-- MySQL dump 10.13  Distrib 5.6.36, for Linux (x86_64)
--
-- Host: localhost    Database: d7_marketplace
-- ------------------------------------------------------
-- Server version	5.6.30

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `actions`
--

DROP TABLE IF EXISTS `actions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `actions` (
  `aid` varchar(255) NOT NULL DEFAULT '0' COMMENT 'Primary Key: Unique actions ID.',
  `type` varchar(32) NOT NULL DEFAULT '' COMMENT 'The object that that action acts on (node, user, comment, system or custom types.)',
  `callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'The callback function that executes when the action runs.',
  `parameters` longblob NOT NULL COMMENT 'Parameters to be passed to the callback function.',
  `label` varchar(255) NOT NULL DEFAULT '0' COMMENT 'Label of the action.',
  PRIMARY KEY (`aid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores action information.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `actions`
--

LOCK TABLES `actions` WRITE;
/*!40000 ALTER TABLE `actions` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `actions` VALUES ('comment_publish_action','comment','comment_publish_action','','Publish comment'),('comment_save_action','comment','comment_save_action','','Save comment'),('comment_unpublish_action','comment','comment_unpublish_action','','Unpublish comment'),('country_disable_action','country','country_disable_action','','Disable country'),('country_enable_action','country','country_enable_action','','Enable country'),('node_make_sticky_action','node','node_make_sticky_action','','Make content sticky'),('node_make_unsticky_action','node','node_make_unsticky_action','','Make content unsticky'),('node_promote_action','node','node_promote_action','','Promote content to front page'),('node_publish_action','node','node_publish_action','','Publish content'),('node_save_action','node','node_save_action','','Save content'),('node_unpromote_action','node','node_unpromote_action','','Remove content from front page'),('node_unpublish_action','node','node_unpublish_action','','Unpublish content'),('pathauto_node_update_action','node','pathauto_node_update_action','','Update node alias'),('pathauto_taxonomy_term_update_action','taxonomy_term','pathauto_taxonomy_term_update_action','','Update taxonomy term alias'),('pathauto_user_update_action','user','pathauto_user_update_action','','Update user alias'),('system_block_ip_action','user','system_block_ip_action','','Ban IP address of current user'),('user_block_user_action','user','user_block_user_action','','Block current user');
/*!40000 ALTER TABLE `actions` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `authmap`
--

DROP TABLE IF EXISTS `authmap`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `authmap` (
  `aid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique authmap ID.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'User’s users.uid.',
  `authname` varchar(128) NOT NULL DEFAULT '' COMMENT 'Unique authentication name.',
  `module` varchar(128) NOT NULL DEFAULT '' COMMENT 'Module which is controlling the authentication.',
  PRIMARY KEY (`aid`),
  UNIQUE KEY `authname` (`authname`),
  KEY `uid_module` (`uid`,`module`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores distributed authentication mapping.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `authmap`
--

LOCK TABLES `authmap` WRITE;
/*!40000 ALTER TABLE `authmap` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `authmap` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `batch`
--

DROP TABLE IF EXISTS `batch`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `batch` (
  `bid` int(10) unsigned NOT NULL COMMENT 'Primary Key: Unique batch ID.',
  `token` varchar(64) NOT NULL COMMENT 'A string token generated against the current user’s session id and the batch id, used to ensure that only the user who submitted the batch can effectively access it.',
  `timestamp` int(11) NOT NULL COMMENT 'A Unix timestamp indicating when this batch was submitted for processing. Stale batches are purged at cron time.',
  `batch` longblob COMMENT 'A serialized array containing the processing data for the batch.',
  PRIMARY KEY (`bid`),
  KEY `token` (`token`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores details about batches (processes that run in...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `batch`
--

LOCK TABLES `batch` WRITE;
/*!40000 ALTER TABLE `batch` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `batch` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `block`
--

DROP TABLE IF EXISTS `block`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `block` (
  `bid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique block ID.',
  `module` varchar(64) NOT NULL DEFAULT '' COMMENT 'The module from which the block originates; for example, ’user’ for the Who’s Online block, and ’block’ for any custom blocks.',
  `delta` varchar(32) NOT NULL DEFAULT '0' COMMENT 'Unique ID for block within a module.',
  `theme` varchar(64) NOT NULL DEFAULT '' COMMENT 'The theme under which the block settings apply.',
  `status` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Block enabled status. (1 = enabled, 0 = disabled)',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Block weight within region.',
  `region` varchar(64) NOT NULL DEFAULT '' COMMENT 'Theme region within which the block is set.',
  `custom` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Flag to indicate how users may control visibility of the block. (0 = Users cannot control, 1 = On by default, but can be hidden, 2 = Hidden by default, but can be shown)',
  `visibility` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Flag to indicate how to show blocks on pages. (0 = Show on all pages except listed pages, 1 = Show only on listed pages, 2 = Use custom PHP code to determine visibility)',
  `pages` text NOT NULL COMMENT 'Contents of the "Pages" block; contains either a list of paths on which to include/exclude the block or PHP code, depending on "visibility" setting.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Custom title for the block. (Empty string will use block default title, <none> will remove the title, text will cause block to use specified title.)',
  `cache` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'Binary flag to indicate block cache mode. (-2: Custom cache, -1: Do not cache, 1: Cache per role, 2: Cache per user, 4: Cache per page, 8: Block cache global) See DRUPAL_CACHE_* constants in ../includes/common.inc for more detailed information.',
  `css_class` varchar(255) NOT NULL DEFAULT '' COMMENT 'String containing the classes for the block.',
  PRIMARY KEY (`bid`),
  UNIQUE KEY `tmd` (`theme`,`module`,`delta`),
  KEY `list` (`theme`,`status`,`region`,`weight`,`module`)
) ENGINE=InnoDB AUTO_INCREMENT=631 DEFAULT CHARSET=utf8 COMMENT='Stores block settings, such as region and visibility...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `block`
--

LOCK TABLES `block` WRITE;
/*!40000 ALTER TABLE `block` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `block` VALUES (1,'system','main','bartik',1,0,'content',0,0,'','',-1,''),(2,'search','form','bartik',1,-1,'sidebar_first',0,0,'','',-1,'search-block block-search-help'),(3,'node','recent','seven',1,10,'dashboard_main',0,0,'','',-1,''),(4,'user','login','bartik',1,0,'sidebar_first',0,0,'','Sign in',-1,'user-login-popup-block'),(5,'system','navigation','bartik',1,0,'sidebar_first',0,0,'','',-1,''),(6,'system','powered-by','bartik',1,10,'footer',0,0,'','',-1,''),(7,'system','help','bartik',1,0,'help',0,0,'','',-1,''),(8,'system','main','seven',1,0,'content',0,0,'','',-1,''),(9,'system','help','seven',1,0,'help',0,0,'','',-1,''),(10,'user','login','seven',1,10,'content',0,0,'','Sign in',-1,'user-login-popup-block'),(11,'user','new','seven',1,0,'dashboard_sidebar',0,0,'','',-1,''),(12,'search','form','seven',1,-10,'dashboard_sidebar',0,0,'','',-1,'search-block block-search-help'),(13,'comment','recent','bartik',0,0,'-1',0,0,'','',1,''),(14,'node','syndicate','bartik',0,0,'-1',0,0,'','',-1,''),(15,'node','recent','bartik',0,0,'-1',0,0,'','',1,''),(16,'shortcut','shortcuts','bartik',0,0,'-1',0,0,'','',-1,''),(17,'system','management','bartik',0,0,'-1',0,0,'','',-1,''),(18,'system','user-menu','bartik',0,0,'-1',0,0,'','<none>',-1,''),(19,'system','main-menu','bartik',0,0,'-1',0,0,'','Categories',-1,'block-main-menu'),(20,'user','new','bartik',0,0,'-1',0,0,'','',1,''),(21,'user','online','bartik',0,0,'-1',0,0,'','',-1,''),(22,'comment','recent','seven',1,0,'dashboard_inactive',0,0,'','',1,''),(23,'node','syndicate','seven',0,0,'-1',0,0,'','',-1,''),(24,'shortcut','shortcuts','seven',0,0,'-1',0,0,'','',-1,''),(25,'system','powered-by','seven',0,10,'-1',0,0,'','',-1,''),(26,'system','navigation','seven',0,0,'-1',0,0,'','',-1,''),(27,'system','management','seven',0,0,'-1',0,0,'','',-1,''),(28,'system','user-menu','seven',0,0,'-1',0,0,'','<none>',-1,''),(29,'system','main-menu','seven',0,0,'-1',0,0,'','Categories',-1,'block-main-menu'),(30,'user','online','seven',1,0,'dashboard_inactive',0,0,'','',-1,''),(31,'comment','recent','azastore',0,0,'-1',0,0,'','',1,''),(32,'node','recent','azastore',0,0,'-1',0,0,'','',1,''),(33,'node','syndicate','azastore',0,0,'-1',0,0,'','',-1,''),(34,'search','form','azastore',1,-1,'header',0,0,'','',-1,'search-block block-search-help'),(35,'shortcut','shortcuts','azastore',0,0,'-1',0,0,'','',-1,''),(36,'system','help','azastore',1,0,'help',0,0,'','',-1,''),(37,'system','main','azastore',1,0,'content',0,0,'','',-1,''),(38,'system','main-menu','azastore',0,0,'-1',0,0,'','Categories',-1,'block-main-menu'),(39,'system','management','azastore',0,0,'-1',0,0,'','',-1,''),(40,'system','navigation','azastore',0,0,'-1',0,0,'','',-1,''),(41,'system','powered-by','azastore',0,-8,'-1',0,0,'','',-1,''),(42,'system','user-menu','azastore',1,0,'headline',0,0,'','<none>',-1,''),(43,'user','login','azastore',0,0,'-1',0,0,'','Sign in',-1,'user-login-popup-block'),(44,'user','new','azastore',0,0,'-1',0,0,'','',1,''),(45,'user','online','azastore',0,0,'-1',0,0,'','',-1,''),(46,'simplenews','0','azastore',0,0,'-1',0,0,'','',1,''),(47,'simplenews','1','azastore',1,0,'panel_footer_first_3',0,0,'','Newsletter',-1,''),(48,'tagclouds','2','azastore',0,0,'-1',0,0,'','',8,''),(49,'tagclouds','1','azastore',0,0,'-1',0,0,'','',8,''),(50,'simplenews','0','bartik',0,0,'-1',0,0,'','',1,''),(51,'simplenews','1','bartik',0,0,'-1',0,0,'','Newsletter',-1,''),(52,'tagclouds','2','bartik',0,0,'-1',0,0,'','',8,''),(53,'tagclouds','1','bartik',0,0,'-1',0,0,'','',8,''),(54,'simplenews','0','seven',0,0,'-1',0,0,'','',1,''),(55,'simplenews','1','seven',0,0,'-1',0,0,'','Newsletter',-1,''),(56,'tagclouds','2','seven',0,0,'-1',0,0,'','',8,''),(57,'tagclouds','1','seven',0,0,'-1',0,0,'','',8,''),(58,'block','1','azastore',1,0,'headline',0,0,'','<none>',-1,'welcome-block'),(59,'block','1','bartik',0,0,'-1',0,0,'','<none>',-1,'welcome-block'),(60,'block','1','seven',0,0,'-1',0,0,'','<none>',-1,'welcome-block'),(61,'commerce_cart','cart','azastore',0,0,'-1',0,0,'checkout*','<none>',-1,''),(62,'commerce_cart','cart','bartik',0,0,'-1',0,0,'checkout*','<none>',-1,''),(63,'commerce_cart','cart','seven',0,0,'-1',0,0,'checkout*','<none>',-1,''),(64,'tagclouds','3','azastore',0,0,'-1',0,0,'','',8,''),(65,'tagclouds','3','bartik',0,0,'-1',0,0,'','',8,''),(66,'tagclouds','3','seven',0,0,'-1',0,0,'','',8,''),(76,'views','frontpage-block_1','azastore',1,0,'content',0,1,'<front>','',-1,'top-sales'),(77,'views','frontpage-block_2','azastore',1,0,'panel_first',0,0,'','',-1,'featured-block'),(78,'views','frontpage-block_1','bartik',0,0,'-1',0,1,'<front>','',-1,'top-sales'),(79,'views','frontpage-block_2','bartik',0,0,'-1',0,0,'','',-1,'featured-block'),(80,'views','frontpage-block_1','seven',0,0,'-1',0,1,'<front>','',-1,'top-sales'),(81,'views','frontpage-block_2','seven',0,0,'-1',0,0,'','',-1,'featured-block'),(82,'tagclouds','4','azastore',0,0,'-1',0,0,'','',8,''),(83,'tagclouds','4','bartik',0,0,'-1',0,0,'','',8,''),(84,'tagclouds','4','seven',0,0,'-1',0,0,'','',8,''),(85,'views','frontpage-block_3','azastore',1,0,'sidebar_first',0,1,'<front>','',-1,''),(88,'views','frontpage-block_3','bartik',0,0,'-1',0,1,'<front>','',-1,''),(90,'views','frontpage-block_3','seven',0,0,'-1',0,1,'<front>','',-1,''),(91,'menu','menu-about-us','azastore',1,0,'panel_footer_first_2',0,0,'','',-1,''),(92,'menu','menu-customer-help','azastore',1,0,'panel_footer_first_1',0,0,'','',-1,''),(93,'menu','menu-about-us','bartik',0,0,'-1',0,0,'','',-1,''),(94,'menu','menu-customer-help','bartik',0,0,'-1',0,0,'','',-1,''),(95,'menu','menu-about-us','seven',0,0,'-1',0,0,'','',-1,''),(96,'menu','menu-customer-help','seven',0,0,'-1',0,0,'','',-1,''),(97,'block','2','azastore',1,0,'panel_footer_first_4',0,0,'','Download apps',-1,'download-apps'),(98,'block','2','bartik',0,0,'-1',0,0,'','Download apps',-1,'download-apps'),(99,'block','2','seven',0,0,'-1',0,0,'','Download apps',-1,'download-apps'),(100,'block','3','azastore',1,0,'panel_footer_first_4',0,0,'','Payment methods',-1,'payment'),(101,'block','3','bartik',0,0,'-1',0,0,'','Payment methods',-1,'payment'),(102,'block','3','seven',0,0,'-1',0,0,'','Payment methods',-1,'payment'),(103,'block','4','azastore',1,0,'footer',0,0,'','<none>',-1,'copyright'),(104,'block','4','bartik',0,0,'-1',0,0,'','<none>',-1,'copyright'),(105,'block','4','seven',0,0,'-1',0,0,'','<none>',-1,'copyright'),(106,'block','5','azastore',1,0,'footer',0,0,'','<none>',-1,'contact-message'),(107,'block','5','bartik',0,0,'-1',0,0,'','<none>',-1,'contact-message'),(108,'block','5','seven',0,0,'-1',0,0,'','<none>',-1,'contact-message'),(109,'views','slideshow-block','azastore',1,0,'panel_highlighted_first_2',0,1,'<front>','<none>',-1,''),(110,'views','slideshow-block','bartik',0,0,'-1',0,1,'<front>','<none>',-1,''),(111,'views','slideshow-block','seven',0,0,'-1',0,1,'<front>','<none>',-1,''),(112,'views','frontpage-block_4','azastore',0,0,'-1',0,0,'','',-1,''),(113,'block','6','azastore',1,0,'sidebar_first',0,1,'<front>','Effortless Shopping',-1,'effortless-shopping'),(114,'block','6','bartik',0,0,'-1',0,1,'<front>','Effortless Shopping',-1,'effortless-shopping'),(115,'block','6','seven',0,0,'-1',0,1,'<front>','Effortless Shopping',-1,'effortless-shopping'),(116,'views','frontpage-block_4','bartik',0,0,'-1',0,0,'','',-1,''),(117,'views','frontpage-block_4','seven',0,0,'-1',0,0,'','',-1,''),(144,'block','1','marketplace',1,-37,'headline',0,0,'','<none>',-1,'welcome-block'),(145,'block','2','marketplace',1,-16,'panel_footer_4',0,0,'','Download apps',-1,'download-apps'),(146,'block','3','marketplace',1,-3,'panel_footer_4',0,0,'','Payment methods',-1,'payment'),(147,'block','4','marketplace',1,0,'footer',0,0,'','<none>',-1,'copyright'),(148,'block','5','marketplace',1,0,'footer',0,0,'','<none>',-1,'contact-message'),(149,'block','6','marketplace',0,-25,'-1',0,1,'<front>','Effortless Shopping',-1,'effortless-shopping'),(150,'comment','recent','marketplace',0,-1,'-1',0,0,'','',1,''),(151,'commerce_cart','cart','marketplace',1,-33,'header',0,0,'checkout*','<none>',-1,''),(158,'menu','menu-about-us','marketplace',1,-24,'panel_footer_2',0,0,'','',-1,''),(159,'menu','menu-customer-help','marketplace',1,-18,'panel_footer_1',0,0,'','',-1,''),(160,'node','recent','marketplace',0,0,'-1',0,0,'','',1,''),(161,'node','syndicate','marketplace',0,5,'-1',0,0,'','',-1,''),(162,'search','form','marketplace',0,-1,'-1',0,0,'','',-1,'search-block block-search-help'),(163,'shortcut','shortcuts','marketplace',0,3,'-1',0,0,'','',-1,''),(164,'simplenews','0','marketplace',0,-4,'-1',0,0,'','',1,''),(165,'simplenews','1','marketplace',1,-5,'panel_footer_3',0,0,'','Newsletter',-1,''),(166,'system','help','marketplace',1,0,'help',0,0,'','',-1,''),(167,'system','main','marketplace',1,0,'content',0,0,'','',-1,''),(168,'system','main-menu','marketplace',1,-14,'panel_mobile_menu',0,0,'','Categories',-1,'block-main-menu'),(169,'system','management','marketplace',0,-13,'-1',0,0,'','',-1,''),(170,'system','navigation','marketplace',0,-6,'-1',0,0,'','',-1,''),(171,'system','powered-by','marketplace',0,-2,'-1',0,0,'','',-1,''),(172,'system','user-menu','marketplace',0,0,'-1',0,0,'','<none>',-1,''),(173,'tagclouds','1','marketplace',0,9,'-1',0,0,'','',8,''),(174,'tagclouds','2','marketplace',0,8,'-1',0,0,'','',8,''),(175,'tagclouds','3','marketplace',0,7,'-1',0,0,'','',8,''),(176,'tagclouds','4','marketplace',0,6,'-1',0,0,'','',8,''),(177,'user','login','marketplace',1,-36,'headline',0,0,'','Sign in',-1,'user-login-popup-block'),(178,'user','new','marketplace',0,11,'-1',0,0,'','',1,''),(179,'user','online','marketplace',0,12,'-1',0,0,'','',-1,''),(180,'views','frontpage-block_1','marketplace',0,0,'-1',0,1,'<front>','',-1,'top-sales'),(181,'views','frontpage-block_2','marketplace',1,0,'panel_first',0,0,'','',-1,'featured-block'),(182,'views','frontpage-block_3','marketplace',0,-24,'-1',0,1,'<front>','',-1,''),(183,'views','frontpage-block_4','marketplace',0,1,'-1',0,0,'','',-1,''),(184,'views','slideshow-block','marketplace',0,7,'-1',0,1,'<front>','<none>',-1,''),(185,'context_ui','editor','bartik',0,0,'-1',0,0,'','',1,''),(186,'context_ui','editor','marketplace',0,-20,'-1',0,0,'','',1,''),(187,'context_ui','editor','seven',0,0,'-1',0,0,'','',1,''),(188,'context_ui','devel','bartik',0,0,'-1',0,0,'','',1,''),(189,'devel','execute_php','bartik',0,0,'-1',0,0,'','',-1,''),(190,'devel','switch_user','bartik',0,0,'-1',0,0,'','',-1,''),(192,'menu','devel','bartik',0,0,'-1',0,0,'','',-1,''),(193,'context_ui','devel','marketplace',0,-19,'-1',0,0,'','',1,''),(194,'devel','execute_php','marketplace',0,-15,'-1',0,0,'','',-1,''),(195,'devel','switch_user','marketplace',0,4,'-1',0,0,'','',-1,''),(197,'menu','devel','marketplace',0,-17,'-1',0,0,'','',-1,''),(198,'context_ui','devel','seven',0,0,'-1',0,0,'','',1,''),(199,'devel','execute_php','seven',0,0,'-1',0,0,'','',-1,''),(200,'devel','switch_user','seven',0,0,'-1',0,0,'','',-1,''),(202,'menu','devel','seven',0,0,'-1',0,0,'','',-1,''),(203,'views','-exp-search_page-page','marketplace',1,-30,'header',0,0,'','<none>',-1,'search-block'),(204,'views','-exp-search_page-page','bartik',0,0,'-1',0,0,'','<none>',-1,'search-block'),(205,'views','-exp-search_page-page','seven',0,0,'-1',0,0,'','<none>',-1,'search-block'),(206,'tagclouds','5','marketplace',0,0,'-1',0,0,'','',8,''),(207,'tagclouds','5','bartik',0,0,'-1',0,0,'','',8,''),(208,'tagclouds','5','seven',0,0,'-1',0,0,'','',8,''),(209,'block','7','bartik',0,0,'-1',0,0,'','<none>',-1,'newsletter-message-block'),(210,'block','7','marketplace',1,0,'panel_footer_3',0,0,'','<none>',-1,'newsletter-message-block'),(211,'block','7','seven',0,0,'-1',0,0,'','<none>',-1,'newsletter-message-block'),(218,'views','banner-block','bartik',0,0,'-1',0,0,'','<none>',-1,''),(219,'views','banner-block','marketplace',0,0,'-1',0,0,'','<none>',-1,''),(220,'views','banner-block','seven',0,0,'-1',0,0,'','<none>',-1,''),(221,'views','banner-block_1','marketplace',0,0,'-1',0,0,'','<none>',-1,''),(222,'views','banner-block_1','bartik',0,0,'-1',0,0,'','',-1,''),(223,'views','banner-block_1','seven',0,0,'-1',0,0,'','',-1,''),(230,'views','recently_read-block','marketplace',0,0,'-1',0,0,'','',-1,''),(231,'views','recently_read-block','bartik',0,0,'-1',0,0,'','',-1,''),(232,'views','recently_read-block','seven',0,0,'-1',0,0,'','',-1,''),(243,'views','product_display-block','bartik',0,0,'-1',0,0,'','',-1,''),(244,'views','product_display-block_1','bartik',0,0,'-1',0,0,'','',-1,''),(246,'views','product_display-block','marketplace',0,0,'-1',0,0,'','',-1,''),(247,'views','product_display-block_1','marketplace',1,0,'panel_second',0,0,'','',-1,''),(249,'views','product_display-block','seven',0,0,'-1',0,0,'','',-1,''),(250,'views','product_display-block_1','seven',0,0,'-1',0,0,'','',-1,''),(260,'views','product_display-block_2','marketplace',1,-38,'panel_third',0,0,'','',-1,''),(261,'views','product_display-block_2','bartik',0,0,'-1',0,0,'','',-1,''),(262,'views','product_display-block_2','seven',0,0,'-1',0,0,'','',-1,''),(263,'views','product_display-block_3','marketplace',0,0,'-1',0,0,'','',-1,''),(264,'views','product_display-block_3','bartik',0,0,'-1',0,0,'','',-1,''),(265,'views','product_display-block_3','seven',0,0,'-1',0,0,'','',-1,''),(266,'views','today_s_deal-block_1','marketplace',0,0,'-1',0,0,'','',-1,'today-deal-block'),(267,'views','brand-block','marketplace',0,0,'-1',0,0,'','<none>',-1,''),(268,'views','brand-block','bartik',0,0,'-1',0,0,'','',-1,''),(269,'views','brand-block','seven',0,0,'-1',0,0,'','',-1,''),(270,'views','today_s_deal-block_1','bartik',0,0,'-1',0,0,'','',-1,'today-deal-block'),(271,'views','today_s_deal-block_1','seven',0,0,'-1',0,0,'','',-1,'today-deal-block'),(278,'menu_descriptions','menu-your-account','marketplace',1,-34,'header',0,0,'','',-1,''),(279,'menu_descriptions','menu-your-account','bartik',0,0,'-1',0,0,'','',-1,''),(280,'menu_descriptions','menu-your-account','seven',0,0,'-1',0,0,'','',-1,''),(281,'menu_descriptions','user-menu','marketplace',1,-32,'header',0,0,'','View Account',-1,''),(282,'menu_descriptions','user-menu','bartik',0,0,'-1',0,0,'','',-1,''),(283,'menu_descriptions','user-menu','seven',0,0,'-1',0,0,'','',-1,''),(284,'views','bestsellers-block_1','marketplace',0,0,'-1',0,0,'','',-1,''),(285,'views','bestsellers-block_1','bartik',0,0,'-1',0,0,'','',-1,''),(286,'views','bestsellers-block_1','seven',0,0,'-1',0,0,'','',-1,''),(287,'search_api_sorts','search-sorts','bartik',0,4,'-1',0,0,'','',-1,''),(288,'search_api_sorts','search-sorts','marketplace',0,4,'-1',0,0,'','',-1,''),(289,'search_api_sorts','search-sorts','seven',0,4,'-1',0,0,'','',-1,''),(290,'facetapi','0','bartik',0,0,'-1',0,0,'','',-1,''),(291,'facetapi','0','marketplace',0,0,'-1',0,0,'','',-1,''),(292,'facetapi','0','seven',0,0,'-1',0,0,'','',-1,''),(293,'facetapi','TFVaQKSORCPdrULxfXDnLQZ40xH0Nper','marketplace',0,0,'-1',0,0,'','Price',-1,'search-price-block'),(294,'facetapi','4MnuqsU9U0F81nBMXnQt67Y06gEKf0TG','marketplace',0,0,'-1',0,0,'','',-1,''),(295,'facetapi','knUu7mF0nojSIDU6VdUGjGkWkQ1WKrDa','marketplace',0,0,'-1',0,0,'','',-1,''),(296,'facetapi','rkiHK9TNltICILmw0IobWpgZeQeEScT1','marketplace',0,0,'-1',0,0,'','',-1,''),(297,'facetapi','ljmT8Ts69OP0ErEpRJXGjkCr6c79Qs0Z','marketplace',0,0,'-1',0,0,'','Brands',-1,''),(298,'facetapi','PkQ0BcHQAoCQ0kNLdvPxh1jd20OztqL3','marketplace',0,0,'-1',0,0,'','Categories',-1,''),(299,'facetapi','TFVaQKSORCPdrULxfXDnLQZ40xH0Nper','bartik',0,0,'-1',0,0,'','Price',-1,'search-price-block'),(300,'facetapi','4MnuqsU9U0F81nBMXnQt67Y06gEKf0TG','bartik',0,0,'-1',0,0,'','',-1,''),(301,'facetapi','knUu7mF0nojSIDU6VdUGjGkWkQ1WKrDa','bartik',0,0,'-1',0,0,'','',-1,''),(302,'facetapi','rkiHK9TNltICILmw0IobWpgZeQeEScT1','bartik',0,0,'-1',0,0,'','',-1,''),(303,'facetapi','ljmT8Ts69OP0ErEpRJXGjkCr6c79Qs0Z','bartik',0,0,'-1',0,0,'','Brands',-1,''),(304,'facetapi','PkQ0BcHQAoCQ0kNLdvPxh1jd20OztqL3','bartik',0,0,'-1',0,0,'','Categories',-1,''),(305,'facetapi','TFVaQKSORCPdrULxfXDnLQZ40xH0Nper','seven',0,0,'-1',0,0,'','Price',-1,'search-price-block'),(306,'facetapi','4MnuqsU9U0F81nBMXnQt67Y06gEKf0TG','seven',0,0,'-1',0,0,'','',-1,''),(307,'facetapi','knUu7mF0nojSIDU6VdUGjGkWkQ1WKrDa','seven',0,0,'-1',0,0,'','',-1,''),(308,'facetapi','rkiHK9TNltICILmw0IobWpgZeQeEScT1','seven',0,0,'-1',0,0,'','',-1,''),(309,'facetapi','ljmT8Ts69OP0ErEpRJXGjkCr6c79Qs0Z','seven',0,0,'-1',0,0,'','Brands',-1,''),(310,'facetapi','PkQ0BcHQAoCQ0kNLdvPxh1jd20OztqL3','seven',0,0,'-1',0,0,'','Categories',-1,''),(311,'views','-exp-search-page','marketplace',1,-34,'header',0,0,'','<none>',-1,'search-block'),(312,'views','-exp-search-page','bartik',0,0,'-1',0,0,'','<none>',-1,'search-block'),(313,'views','-exp-search-page','seven',0,0,'-1',0,0,'','<none>',-1,'search-block'),(314,'views','banner-block_2','marketplace',0,0,'-1',0,0,'','<none>',-1,''),(315,'views','banner-block_2','bartik',0,0,'-1',0,0,'','',-1,''),(316,'views','banner-block_2','seven',0,0,'-1',0,0,'','',-1,''),(317,'block','11','bartik',0,0,'-1',0,1,'contact-us','<none>',-1,'contact-info-block'),(318,'block','11','marketplace',1,0,'content',0,1,'contact-us','<none>',-1,'contact-info-block'),(319,'block','11','seven',0,0,'-1',0,1,'contact-us','<none>',-1,'contact-info-block'),(330,'menu','features','bartik',0,0,'-1',0,0,'','',-1,''),(332,'menu','features','marketplace',0,0,'-1',0,0,'','',-1,''),(334,'menu','features','seven',0,0,'-1',0,0,'','',-1,''),(338,'menu','menu-help-menu','marketplace',0,0,'-1',0,0,'','',-1,'block-help-topics'),(339,'menu','menu-help-menu','bartik',0,0,'-1',0,0,'','',-1,'block-help-topics'),(340,'menu','menu-help-menu','seven',0,0,'-1',0,0,'','',-1,'block-help-topics'),(341,'menu','menu-headline-menu','marketplace',1,-35,'headline',0,0,'','<none>',-1,''),(342,'menu','menu-headline-menu','bartik',0,0,'-1',0,0,'','',-1,''),(343,'menu','menu-headline-menu','seven',0,0,'-1',0,0,'','',-1,''),(348,'facetapi','ZBjCdJ1cexrPNGoMBV2wJ5f6t60m0vxl','marketplace',0,0,'-1',0,0,'','',-1,''),(349,'facetapi','HwnOv01PAgDT2L3Lt2pG4sGndjlWKb5Q','marketplace',0,0,'-1',0,0,'','',-1,''),(350,'facetapi','ZBjCdJ1cexrPNGoMBV2wJ5f6t60m0vxl','bartik',0,0,'-1',0,0,'','',-1,''),(351,'facetapi','HwnOv01PAgDT2L3Lt2pG4sGndjlWKb5Q','bartik',0,0,'-1',0,0,'','',-1,''),(352,'facetapi','ZBjCdJ1cexrPNGoMBV2wJ5f6t60m0vxl','seven',0,0,'-1',0,0,'','',-1,''),(353,'facetapi','HwnOv01PAgDT2L3Lt2pG4sGndjlWKb5Q','seven',0,0,'-1',0,0,'','',-1,''),(354,'views','banner-block_3','marketplace',0,0,'-1',0,0,'','<none>',-1,''),(355,'views','banner-block_3','bartik',0,0,'-1',0,0,'','',-1,''),(356,'views','banner-block_3','seven',0,0,'-1',0,0,'','',-1,''),(357,'views','brand-block_1','marketplace',1,0,'header',0,0,'','Popular searches:',-1,'block-view-search-brand'),(358,'views','brand-block_1','bartik',0,0,'-1',0,0,'','Popular searches:',-1,'block-view-search-brand'),(359,'views','brand-block_1','seven',0,0,'-1',0,0,'','Popular searches:',-1,'block-view-search-brand'),(360,'tagclouds','6','bartik',0,0,'-1',0,0,'','',8,''),(361,'tagclouds','6','marketplace',0,0,'-1',0,0,'','',8,''),(362,'tagclouds','6','seven',0,0,'-1',0,0,'','',8,''),(363,'block','12','bartik',0,0,'-1',0,0,'','',-1,''),(364,'block','12','marketplace',0,0,'-1',0,0,'','',-1,''),(365,'block','12','seven',0,0,'-1',0,0,'','',-1,''),(366,'block','13','bartik',0,0,'-1',0,0,'','',-1,''),(367,'block','13','marketplace',0,0,'-1',0,0,'','',-1,''),(368,'block','13','seven',0,0,'-1',0,0,'','',-1,''),(369,'block','14','bartik',0,0,'-1',0,0,'','',-1,''),(370,'block','14','marketplace',0,0,'-1',0,0,'','',-1,''),(371,'block','14','seven',0,0,'-1',0,0,'','',-1,''),(372,'block','15','bartik',0,0,'-1',0,0,'','',-1,''),(373,'block','15','marketplace',0,0,'-1',0,0,'','',-1,''),(374,'block','15','seven',0,0,'-1',0,0,'','',-1,''),(375,'block','16','bartik',0,0,'-1',0,0,'','',-1,''),(376,'block','16','marketplace',0,0,'-1',0,0,'','',-1,''),(377,'block','16','seven',0,0,'-1',0,0,'','',-1,''),(378,'block','17','bartik',0,0,'-1',0,0,'','',-1,''),(379,'block','17','marketplace',0,0,'-1',0,0,'','',-1,''),(380,'block','17','seven',0,0,'-1',0,0,'','',-1,''),(381,'block','18','bartik',0,0,'-1',0,0,'','',-1,''),(382,'block','18','marketplace',0,0,'-1',0,0,'','',-1,''),(383,'block','18','seven',0,0,'-1',0,0,'','',-1,''),(384,'block','19','bartik',0,0,'-1',0,0,'','',-1,''),(385,'block','19','marketplace',0,0,'-1',0,0,'','',-1,''),(386,'block','19','seven',0,0,'-1',0,0,'','',-1,''),(387,'views','banner-block_4','marketplace',0,0,'-1',0,0,'','<none>',-1,''),(388,'views','banner-block_4','bartik',0,0,'-1',0,0,'','',-1,''),(389,'views','banner-block_4','seven',0,0,'-1',0,0,'','',-1,''),(390,'block','20','bartik',0,0,'-1',0,0,'','Your orders',-1,'block-right user-login-popup-block block-view-orders'),(391,'block','20','marketplace',0,0,'-1',0,0,'','Your orders',-1,'block-right user-login-popup-block block-view-orders'),(392,'block','20','seven',0,0,'-1',0,0,'','Your orders',-1,'block-right user-login-popup-block block-view-orders'),(393,'views','banner-block_5','marketplace',0,0,'-1',0,0,'','',-1,''),(394,'views','banner-block_5','bartik',0,0,'-1',0,0,'','',-1,''),(395,'views','banner-block_5','seven',0,0,'-1',0,0,'','',-1,''),(396,'locale','language','bartik',0,0,'-1',0,0,'','',-1,''),(397,'locale','language','marketplace',0,0,'-1',0,0,'','',-1,''),(398,'locale','language','seven',0,0,'-1',0,0,'','',-1,''),(399,'current_search','standard','bartik',0,0,'-1',0,0,'','<none>',-1,''),(400,'current_search','standard','marketplace',1,0,'content',0,0,'','<none>',-1,''),(401,'current_search','standard','seven',0,0,'-1',0,0,'','<none>',-1,''),(402,'current_search','marketplace','marketplace',0,0,'-1',0,0,'','',-1,''),(403,'current_search','marketplace','bartik',0,0,'-1',0,0,'','',-1,''),(404,'current_search','marketplace','seven',0,0,'-1',0,0,'','',-1,''),(405,'tb_megamenu','devel','bartik',0,0,'-1',0,0,'','',-1,''),(406,'tb_megamenu','features','bartik',0,0,'-1',0,0,'','',-1,''),(407,'tb_megamenu','main-menu','bartik',0,0,'-1',0,0,'<front>','Categories',-1,''),(408,'tb_megamenu','management','bartik',0,0,'-1',0,0,'','',-1,''),(409,'tb_megamenu','menu-about-us','bartik',0,0,'-1',0,0,'','',-1,''),(410,'tb_megamenu','menu-customer-help','bartik',0,0,'-1',0,0,'','',-1,''),(411,'tb_megamenu','menu-headline-menu','bartik',0,0,'-1',0,0,'','',-1,''),(412,'tb_megamenu','menu-help-menu','bartik',0,0,'-1',0,0,'','',-1,''),(413,'tb_megamenu','navigation','bartik',0,0,'-1',0,0,'','',-1,''),(414,'tb_megamenu','user-menu','bartik',0,0,'-1',0,0,'','',-1,''),(415,'tb_megamenu','devel','marketplace',0,0,'-1',0,0,'','',-1,''),(416,'tb_megamenu','features','marketplace',0,0,'-1',0,0,'','',-1,''),(417,'tb_megamenu','main-menu','marketplace',1,0,'panel_menu_top',0,0,'<front>','Categories',-1,''),(418,'tb_megamenu','management','marketplace',0,0,'-1',0,0,'','',-1,''),(419,'tb_megamenu','menu-about-us','marketplace',0,0,'-1',0,0,'','',-1,''),(420,'tb_megamenu','menu-customer-help','marketplace',0,0,'-1',0,0,'','',-1,''),(421,'tb_megamenu','menu-headline-menu','marketplace',0,0,'-1',0,0,'','',-1,''),(422,'tb_megamenu','menu-help-menu','marketplace',0,0,'-1',0,0,'','',-1,''),(423,'tb_megamenu','navigation','marketplace',0,0,'-1',0,0,'','',-1,''),(424,'tb_megamenu','user-menu','marketplace',0,0,'-1',0,0,'','',-1,''),(425,'tb_megamenu','devel','seven',0,0,'-1',0,0,'','',-1,''),(426,'tb_megamenu','features','seven',0,0,'-1',0,0,'','',-1,''),(427,'tb_megamenu','main-menu','seven',0,0,'-1',0,0,'<front>','Categories',-1,''),(428,'tb_megamenu','management','seven',0,0,'-1',0,0,'','',-1,''),(429,'tb_megamenu','menu-about-us','seven',0,0,'-1',0,0,'','',-1,''),(430,'tb_megamenu','menu-customer-help','seven',0,0,'-1',0,0,'','',-1,''),(431,'tb_megamenu','menu-headline-menu','seven',0,0,'-1',0,0,'','',-1,''),(432,'tb_megamenu','menu-help-menu','seven',0,0,'-1',0,0,'','',-1,''),(433,'tb_megamenu','navigation','seven',0,0,'-1',0,0,'','',-1,''),(434,'tb_megamenu','user-menu','seven',0,0,'-1',0,0,'','',-1,''),(435,'block','1','weebpal_backend',1,-37,'header',0,0,'','<none>',-1,'welcome-block'),(436,'block','11','weebpal_backend',1,0,'content',0,1,'contact-us','<none>',-1,'contact-info-block'),(437,'block','12','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(438,'block','13','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(439,'block','14','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(440,'block','15','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(441,'block','16','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(442,'block','17','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(443,'block','18','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(444,'block','19','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(445,'block','2','weebpal_backend',1,-16,'header',0,0,'','Download apps',-1,'download-apps'),(446,'block','20','weebpal_backend',0,0,'-1',0,0,'','Your orders',-1,'block-right user-login-popup-block block-view-orders'),(447,'block','3','weebpal_backend',1,-3,'header',0,0,'','Payment methods',-1,'payment'),(448,'block','4','weebpal_backend',1,0,'footer',0,0,'','<none>',-1,'copyright'),(449,'block','5','weebpal_backend',1,0,'footer',0,0,'','<none>',-1,'contact-message'),(450,'block','6','weebpal_backend',0,-25,'-1',0,1,'<front>','Effortless Shopping',-1,'effortless-shopping'),(451,'block','7','weebpal_backend',1,0,'header',0,0,'','<none>',-1,'newsletter-message-block'),(452,'comment','recent','weebpal_backend',1,-1,'dashboard_inactive',0,0,'','',1,''),(453,'commerce_cart','cart','weebpal_backend',1,-33,'header',0,0,'checkout*','<none>',-1,''),(454,'context_ui','devel','weebpal_backend',0,-19,'-1',0,0,'','',1,''),(455,'context_ui','editor','weebpal_backend',0,-20,'-1',0,0,'','',1,''),(456,'current_search','marketplace','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(457,'current_search','standard','weebpal_backend',1,0,'content',0,0,'','<none>',-1,''),(458,'devel','execute_php','weebpal_backend',0,-15,'-1',0,0,'','',-1,''),(459,'devel','switch_user','weebpal_backend',0,4,'-1',0,0,'','',-1,''),(460,'facetapi','0','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(461,'facetapi','4MnuqsU9U0F81nBMXnQt67Y06gEKf0TG','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(462,'facetapi','HwnOv01PAgDT2L3Lt2pG4sGndjlWKb5Q','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(463,'facetapi','knUu7mF0nojSIDU6VdUGjGkWkQ1WKrDa','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(464,'facetapi','ljmT8Ts69OP0ErEpRJXGjkCr6c79Qs0Z','weebpal_backend',0,0,'-1',0,0,'','Brands',-1,''),(465,'facetapi','PkQ0BcHQAoCQ0kNLdvPxh1jd20OztqL3','weebpal_backend',0,0,'-1',0,0,'','Categories',-1,''),(466,'facetapi','rkiHK9TNltICILmw0IobWpgZeQeEScT1','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(467,'facetapi','TFVaQKSORCPdrULxfXDnLQZ40xH0Nper','weebpal_backend',0,0,'-1',0,0,'','Price',-1,'search-price-block'),(468,'facetapi','ZBjCdJ1cexrPNGoMBV2wJ5f6t60m0vxl','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(469,'locale','language','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(470,'menu','devel','weebpal_backend',0,-17,'-1',0,0,'','',-1,''),(471,'menu','features','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(472,'menu','menu-about-us','weebpal_backend',1,-24,'header',0,0,'','',-1,''),(473,'menu','menu-customer-help','weebpal_backend',1,-18,'header',0,0,'','',-1,''),(474,'menu','menu-headline-menu','weebpal_backend',1,-35,'header',0,0,'','<none>',-1,''),(475,'menu','menu-help-menu','weebpal_backend',0,0,'-1',0,0,'','',-1,'block-help-topics'),(476,'menu_descriptions','menu-your-account','weebpal_backend',1,-34,'header',0,0,'','',-1,''),(477,'menu_descriptions','user-menu','weebpal_backend',1,-32,'header',0,0,'','View Account',-1,''),(478,'node','recent','weebpal_backend',1,0,'dashboard_inactive',0,0,'','',1,''),(479,'node','syndicate','weebpal_backend',0,5,'-1',0,0,'','',-1,''),(480,'search','form','weebpal_backend',1,-1,'dashboard_inactive',0,0,'','',-1,'search-block block-search-help'),(481,'search_api_sorts','search-sorts','weebpal_backend',0,4,'-1',0,0,'','',-1,''),(482,'shortcut','shortcuts','weebpal_backend',0,3,'-1',0,0,'','',-1,''),(483,'simplenews','0','weebpal_backend',0,-4,'-1',0,0,'','',1,''),(484,'simplenews','1','weebpal_backend',1,-5,'header',0,0,'','Newsletter',-1,''),(485,'system','help','weebpal_backend',1,0,'help',0,0,'','',-1,''),(486,'system','main','weebpal_backend',1,0,'content',0,0,'','',-1,''),(487,'system','main-menu','weebpal_backend',1,-14,'header',0,0,'','Categories',-1,'block-main-menu'),(488,'system','management','weebpal_backend',0,-13,'-1',0,0,'','',-1,''),(489,'system','navigation','weebpal_backend',0,-6,'-1',0,0,'','',-1,''),(490,'system','powered-by','weebpal_backend',0,-2,'-1',0,0,'','',-1,''),(491,'system','user-menu','weebpal_backend',0,0,'-1',0,0,'','<none>',-1,''),(492,'tagclouds','1','weebpal_backend',0,9,'-1',0,0,'','',8,''),(493,'tagclouds','2','weebpal_backend',0,8,'-1',0,0,'','',8,''),(494,'tagclouds','3','weebpal_backend',0,7,'-1',0,0,'','',8,''),(495,'tagclouds','4','weebpal_backend',0,6,'-1',0,0,'','',8,''),(496,'tagclouds','5','weebpal_backend',0,0,'-1',0,0,'','',8,''),(497,'tagclouds','6','weebpal_backend',0,0,'-1',0,0,'','',8,''),(498,'tb_megamenu','devel','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(499,'tb_megamenu','features','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(500,'tb_megamenu','main-menu','weebpal_backend',1,0,'header',0,0,'<front>','Categories',-1,''),(501,'tb_megamenu','management','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(502,'tb_megamenu','menu-about-us','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(503,'tb_megamenu','menu-customer-help','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(504,'tb_megamenu','menu-headline-menu','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(505,'tb_megamenu','menu-help-menu','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(506,'tb_megamenu','navigation','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(507,'tb_megamenu','user-menu','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(508,'user','login','weebpal_backend',1,-36,'header',0,0,'','Sign in',-1,'user-login-popup-block'),(509,'user','new','weebpal_backend',1,11,'dashboard_inactive',0,0,'','',1,''),(510,'user','online','weebpal_backend',1,12,'dashboard_inactive',0,0,'','',-1,''),(511,'views','-exp-search-page','weebpal_backend',1,-34,'header',0,0,'','<none>',-1,'search-block'),(512,'views','-exp-search_page-page','weebpal_backend',1,-30,'header',0,0,'','<none>',-1,'search-block'),(513,'views','banner-block','weebpal_backend',0,0,'-1',0,0,'','<none>',-1,''),(514,'views','banner-block_1','weebpal_backend',0,0,'-1',0,0,'','<none>',-1,''),(515,'views','banner-block_2','weebpal_backend',0,0,'-1',0,0,'','<none>',-1,''),(516,'views','banner-block_3','weebpal_backend',0,0,'-1',0,0,'','<none>',-1,''),(517,'views','banner-block_4','weebpal_backend',0,0,'-1',0,0,'','<none>',-1,''),(518,'views','banner-block_5','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(519,'views','bestsellers-block_1','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(520,'views','brand-block','weebpal_backend',0,0,'-1',0,0,'','<none>',-1,''),(521,'views','brand-block_1','weebpal_backend',1,0,'header',0,0,'','Popular searches:',-1,'block-view-search-brand'),(522,'views','frontpage-block_1','weebpal_backend',0,0,'-1',0,1,'<front>','',-1,'top-sales'),(523,'views','frontpage-block_2','weebpal_backend',1,0,'header',0,0,'','',-1,'featured-block'),(524,'views','frontpage-block_3','weebpal_backend',0,-24,'-1',0,1,'<front>','',-1,''),(525,'views','frontpage-block_4','weebpal_backend',0,1,'-1',0,0,'','',-1,''),(526,'views','product_display-block','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(527,'views','product_display-block_1','weebpal_backend',1,0,'header',0,0,'','',-1,''),(528,'views','product_display-block_2','weebpal_backend',1,-38,'header',0,0,'','',-1,''),(529,'views','product_display-block_3','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(530,'views','recently_read-block','weebpal_backend',0,0,'-1',0,0,'','',-1,''),(531,'views','slideshow-block','weebpal_backend',0,7,'-1',0,1,'<front>','<none>',-1,''),(532,'views','today_s_deal-block_1','weebpal_backend',0,0,'-1',0,0,'','',-1,'today-deal-block'),(533,'block','1','we_backend',1,-37,'header',0,0,'','<none>',-1,'welcome-block'),(534,'block','11','we_backend',1,0,'content',0,1,'contact-us','<none>',-1,'contact-info-block'),(535,'block','12','we_backend',0,0,'-1',0,0,'','',-1,''),(536,'block','13','we_backend',0,0,'-1',0,0,'','',-1,''),(537,'block','14','we_backend',0,0,'-1',0,0,'','',-1,''),(538,'block','15','we_backend',0,0,'-1',0,0,'','',-1,''),(539,'block','16','we_backend',0,0,'-1',0,0,'','',-1,''),(540,'block','17','we_backend',0,0,'-1',0,0,'','',-1,''),(541,'block','18','we_backend',0,0,'-1',0,0,'','',-1,''),(542,'block','19','we_backend',0,0,'-1',0,0,'','',-1,''),(543,'block','2','we_backend',1,-16,'header',0,0,'','Download apps',-1,'download-apps'),(544,'block','20','we_backend',0,0,'-1',0,0,'','Your orders',-1,'block-right user-login-popup-block block-view-orders'),(545,'block','3','we_backend',1,-3,'header',0,0,'','Payment methods',-1,'payment'),(546,'block','4','we_backend',1,0,'footer',0,0,'','<none>',-1,'copyright'),(547,'block','5','we_backend',1,0,'footer',0,0,'','<none>',-1,'contact-message'),(548,'block','6','we_backend',0,-25,'-1',0,1,'<front>','Effortless Shopping',-1,'effortless-shopping'),(549,'block','7','we_backend',1,0,'header',0,0,'','<none>',-1,'newsletter-message-block'),(550,'comment','recent','we_backend',1,-1,'dashboard_inactive',0,0,'','',1,''),(551,'commerce_cart','cart','we_backend',1,-33,'header',0,0,'checkout*','<none>',-1,''),(552,'context_ui','devel','we_backend',0,-19,'-1',0,0,'','',1,''),(553,'context_ui','editor','we_backend',0,-20,'-1',0,0,'','',1,''),(554,'current_search','marketplace','we_backend',0,0,'-1',0,0,'','',-1,''),(555,'current_search','standard','we_backend',1,0,'content',0,0,'','<none>',-1,''),(556,'devel','execute_php','we_backend',0,-15,'-1',0,0,'','',-1,''),(557,'devel','switch_user','we_backend',0,4,'-1',0,0,'','',-1,''),(558,'facetapi','0','we_backend',0,0,'-1',0,0,'','',-1,''),(559,'facetapi','4MnuqsU9U0F81nBMXnQt67Y06gEKf0TG','we_backend',0,0,'-1',0,0,'','',-1,''),(560,'facetapi','HwnOv01PAgDT2L3Lt2pG4sGndjlWKb5Q','we_backend',0,0,'-1',0,0,'','',-1,''),(561,'facetapi','knUu7mF0nojSIDU6VdUGjGkWkQ1WKrDa','we_backend',0,0,'-1',0,0,'','',-1,''),(562,'facetapi','ljmT8Ts69OP0ErEpRJXGjkCr6c79Qs0Z','we_backend',0,0,'-1',0,0,'','Brands',-1,''),(563,'facetapi','PkQ0BcHQAoCQ0kNLdvPxh1jd20OztqL3','we_backend',0,0,'-1',0,0,'','Categories',-1,''),(564,'facetapi','rkiHK9TNltICILmw0IobWpgZeQeEScT1','we_backend',0,0,'-1',0,0,'','',-1,''),(565,'facetapi','TFVaQKSORCPdrULxfXDnLQZ40xH0Nper','we_backend',0,0,'-1',0,0,'','Price',-1,'search-price-block'),(566,'facetapi','ZBjCdJ1cexrPNGoMBV2wJ5f6t60m0vxl','we_backend',0,0,'-1',0,0,'','',-1,''),(567,'locale','language','we_backend',0,0,'-1',0,0,'','',-1,''),(568,'menu','devel','we_backend',0,-17,'-1',0,0,'','',-1,''),(569,'menu','features','we_backend',0,0,'-1',0,0,'','',-1,''),(570,'menu','menu-about-us','we_backend',1,-24,'header',0,0,'','',-1,''),(571,'menu','menu-customer-help','we_backend',1,-18,'header',0,0,'','',-1,''),(572,'menu','menu-headline-menu','we_backend',1,-35,'header',0,0,'','<none>',-1,''),(573,'menu','menu-help-menu','we_backend',0,0,'-1',0,0,'','',-1,'block-help-topics'),(574,'menu_descriptions','menu-your-account','we_backend',1,-34,'header',0,0,'','',-1,''),(575,'menu_descriptions','user-menu','we_backend',1,-32,'header',0,0,'','View Account',-1,''),(576,'node','recent','we_backend',1,0,'dashboard_inactive',0,0,'','',1,''),(577,'node','syndicate','we_backend',0,5,'-1',0,0,'','',-1,''),(578,'search','form','we_backend',1,-1,'dashboard_inactive',0,0,'','',-1,'search-block block-search-help'),(579,'search_api_sorts','search-sorts','we_backend',0,4,'-1',0,0,'','',-1,''),(580,'shortcut','shortcuts','we_backend',0,3,'-1',0,0,'','',-1,''),(581,'simplenews','0','we_backend',0,-4,'-1',0,0,'','',1,''),(582,'simplenews','1','we_backend',1,-5,'header',0,0,'','Newsletter',-1,''),(583,'system','help','we_backend',1,0,'help',0,0,'','',-1,''),(584,'system','main','we_backend',1,0,'content',0,0,'','',-1,''),(585,'system','main-menu','we_backend',1,-14,'header',0,0,'','Categories',-1,'block-main-menu'),(586,'system','management','we_backend',0,-13,'-1',0,0,'','',-1,''),(587,'system','navigation','we_backend',0,-6,'-1',0,0,'','',-1,''),(588,'system','powered-by','we_backend',0,-2,'-1',0,0,'','',-1,''),(589,'system','user-menu','we_backend',0,0,'-1',0,0,'','<none>',-1,''),(590,'tagclouds','1','we_backend',0,9,'-1',0,0,'','',8,''),(591,'tagclouds','2','we_backend',0,8,'-1',0,0,'','',8,''),(592,'tagclouds','3','we_backend',0,7,'-1',0,0,'','',8,''),(593,'tagclouds','4','we_backend',0,6,'-1',0,0,'','',8,''),(594,'tagclouds','5','we_backend',0,0,'-1',0,0,'','',8,''),(595,'tagclouds','6','we_backend',0,0,'-1',0,0,'','',8,''),(596,'tb_megamenu','devel','we_backend',0,0,'-1',0,0,'','',-1,''),(597,'tb_megamenu','features','we_backend',0,0,'-1',0,0,'','',-1,''),(598,'tb_megamenu','main-menu','we_backend',1,0,'header',0,0,'<front>','Categories',-1,''),(599,'tb_megamenu','management','we_backend',0,0,'-1',0,0,'','',-1,''),(600,'tb_megamenu','menu-about-us','we_backend',0,0,'-1',0,0,'','',-1,''),(601,'tb_megamenu','menu-customer-help','we_backend',0,0,'-1',0,0,'','',-1,''),(602,'tb_megamenu','menu-headline-menu','we_backend',0,0,'-1',0,0,'','',-1,''),(603,'tb_megamenu','menu-help-menu','we_backend',0,0,'-1',0,0,'','',-1,''),(604,'tb_megamenu','navigation','we_backend',0,0,'-1',0,0,'','',-1,''),(605,'tb_megamenu','user-menu','we_backend',0,0,'-1',0,0,'','',-1,''),(606,'user','login','we_backend',1,-36,'header',0,0,'','Sign in',-1,'user-login-popup-block'),(607,'user','new','we_backend',1,11,'dashboard_inactive',0,0,'','',1,''),(608,'user','online','we_backend',1,12,'dashboard_inactive',0,0,'','',-1,''),(609,'views','-exp-search-page','we_backend',1,-34,'header',0,0,'','<none>',-1,'search-block'),(610,'views','-exp-search_page-page','we_backend',1,-30,'header',0,0,'','<none>',-1,'search-block'),(611,'views','banner-block','we_backend',0,0,'-1',0,0,'','<none>',-1,''),(612,'views','banner-block_1','we_backend',0,0,'-1',0,0,'','<none>',-1,''),(613,'views','banner-block_2','we_backend',0,0,'-1',0,0,'','<none>',-1,''),(614,'views','banner-block_3','we_backend',0,0,'-1',0,0,'','<none>',-1,''),(615,'views','banner-block_4','we_backend',0,0,'-1',0,0,'','<none>',-1,''),(616,'views','banner-block_5','we_backend',0,0,'-1',0,0,'','',-1,''),(617,'views','bestsellers-block_1','we_backend',0,0,'-1',0,0,'','',-1,''),(618,'views','brand-block','we_backend',0,0,'-1',0,0,'','<none>',-1,''),(619,'views','brand-block_1','we_backend',1,0,'header',0,0,'','Popular searches:',-1,'block-view-search-brand'),(620,'views','frontpage-block_1','we_backend',0,0,'-1',0,1,'<front>','',-1,'top-sales'),(621,'views','frontpage-block_2','we_backend',1,0,'header',0,0,'','',-1,'featured-block'),(622,'views','frontpage-block_3','we_backend',0,-24,'-1',0,1,'<front>','',-1,''),(623,'views','frontpage-block_4','we_backend',0,1,'-1',0,0,'','',-1,''),(624,'views','product_display-block','we_backend',0,0,'-1',0,0,'','',-1,''),(625,'views','product_display-block_1','we_backend',1,0,'header',0,0,'','',-1,''),(626,'views','product_display-block_2','we_backend',1,-38,'header',0,0,'','',-1,''),(627,'views','product_display-block_3','we_backend',0,0,'-1',0,0,'','',-1,''),(628,'views','recently_read-block','we_backend',0,0,'-1',0,0,'','',-1,''),(629,'views','slideshow-block','we_backend',0,7,'-1',0,1,'<front>','<none>',-1,''),(630,'views','today_s_deal-block_1','we_backend',0,0,'-1',0,0,'','',-1,'today-deal-block');
/*!40000 ALTER TABLE `block` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `block_current_search`
--

DROP TABLE IF EXISTS `block_current_search`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `block_current_search` (
  `delta` varchar(32) NOT NULL COMMENT 'The block’s unique delta within module, from block.delta.',
  `searcher` varchar(128) NOT NULL COMMENT 'The machine-readable name of the searcher.',
  PRIMARY KEY (`delta`),
  KEY `searcher` (`searcher`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sets up display criteria for blocks based on searcher';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `block_current_search`
--

LOCK TABLES `block_current_search` WRITE;
/*!40000 ALTER TABLE `block_current_search` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `block_current_search` VALUES ('marketplace','search_api@product_display'),('standard','search_api@product_display');
/*!40000 ALTER TABLE `block_current_search` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `block_custom`
--

DROP TABLE IF EXISTS `block_custom`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `block_custom` (
  `bid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The block’s block.bid.',
  `body` longtext COMMENT 'Block contents.',
  `info` varchar(128) NOT NULL DEFAULT '' COMMENT 'Block description.',
  `format` varchar(255) DEFAULT NULL COMMENT 'The filter_format.format of the block body.',
  PRIMARY KEY (`bid`),
  UNIQUE KEY `info` (`info`)
) ENGINE=InnoDB AUTO_INCREMENT=21 DEFAULT CHARSET=utf8 COMMENT='Stores contents of custom-made blocks.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `block_custom`
--

LOCK TABLES `block_custom` WRITE;
/*!40000 ALTER TABLE `block_custom` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `block_custom` VALUES (1,'<p>Welcome to <a href=\"http://demo.weebpal.com/\" target=\"_blank\" title=\"Marketplace\">Marketplace.com</a></p>\r\n','Welcome','full_html'),(2,'<div>\r\n	<ul>\r\n		<li>\r\n			<a href=\"stores.apple.com\" title=\"Apple store\">\r\n				<img src=\"<?php print base_path();?><?php print path_to_theme() . \'/images/apple-store.png\';?>\" alt=\"Apple store\" width=\"130\" height=\"30\"/>\r\n			</a>\r\n		</li>\r\n		<li>\r\n			<a href=\"stores.apple.com\" title=\"Apple store\">\r\n				<img src=\"<?php print base_path();?><?php print path_to_theme() . \'/images/android-store.png\';?>\" alt=\"Apple store\" width=\"130\" height=\"30\"/>\r\n			</a>\r\n		</li>\r\n	</ul>\r\n</div>','Download apps','php_code'),(3,'<ul>\r\n	<li>\r\n		<img class=\"logo-2\" src=\"<?php print base_path();?><?php print path_to_theme() . \'/images/pay1.png\';?>\" alt=\"\"/>\r\n	</li>\r\n	<li>\r\n		<img class=\"logo-2\" src=\"<?php print base_path();?><?php print path_to_theme() . \'/images/pay2.png\';?>\" alt=\"\"/>\r\n	</li>\r\n	<li>\r\n<img class=\"logo-2\" src=\"<?php print base_path();?><?php print path_to_theme() . \'/images/pay3.png\';?>\" alt=\"\"/>\r\n	</li>\r\n	<li>\r\n		<img class=\"logo-2\" src=\"<?php print base_path();?><?php print path_to_theme() . \'/images/pay4.png\';?>\" alt=\"\"/>\r\n	</li>\r\n</ul>','Payment methods','php_code'),(4,'<p>Copyright © 2014 <a href=\"http://weebpal.com\" target=\"_blank\" title=\"WeebPal\">WeebPal.com</a>. All rights reserved.</p>\r\n','Copyright','full_html'),(5,'<p>You can also order from <a href=\"http://weebpal.com\" target=\"_blank\" title=\"WeebPal\">WeebPal</a> by calling 1-800-00-000.</p>\r\n','Contact message','full_html'),(6,'<div>\r\n	<ul>\r\n		<li><i class=\"fa fa-money\"></i>Cash on Delivery</li>\r\n		<li><i class=\"fa fa-car\"></i>Free Delivery</li>\r\n		<li><i class=\"fa fa-refresh\"></i>Free Return</li>\r\n		<li><i class=\"fa fa-headphones\"></i>Customer Service</li>\r\n		<li><i class=\"fa fa-shield\"></i>Trusted Sellers Only</li> \r\n	</ul>\r\n</div>','Effortless Shopping','full_html'),(7,'<p>By subscribing to Matketplace newsletters, you acknowledge that you read & understood the Privacy Policy of Martketplace.</p>\r\n','Newsletter message','filtered_html'),(11,'<p class=\"introduction\">Have a question or want to learn more about how Marketplace can help you build your business? Simply enter your information in the fields below and we will follow up with you shortly. If you are an existing seller on Amazon and have a technical question, contact technical support (Seller Central login required).</p>\r\n\r\n<div class=\"row\">\r\n<div class=\"col-sm-6\">\r\n<h2>Sales &amp; Product Inquiries</h2>\r\n\r\n<p>Nunc elit quam; facilisis et imperdiet sed, dapibus vel magna. Cras neque nulla, tincidunt at lobortis vel, aliquam id elit.</p>\r\n\r\n<p><u><strong>Address:</strong></u>&nbsp; 5651 W. Pine Shade Place, Salt Lake City, UT 84118 USA</p>\r\n\r\n<p><strong><u>Phone:</u></strong>&nbsp;&nbsp; &nbsp; (803) 900-8067</p>\r\n\r\n<p><strong><u>Fax:</u></strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; (803) 900-8067</p>\r\n\r\n<p><u><strong>Email:</strong></u>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; support@gmail.com</p>\r\n</div>\r\n\r\n<div class=\"col-sm-6\">\r\n<h2>Product &amp; Technical Support</h2>\r\n\r\n<p>Nunc elit quam; facilisis et imperdiet sed, dapibus vel magna. Cras neque nulla, tincidunt at lobortis vel, aliquam id elit.</p>\r\n\r\n<p><u><strong>Address:</strong></u>&nbsp; 5651 W. Pine Shade Place, Salt Lake City, UT 84118 USA</p>\r\n\r\n<p><strong><u>Phone:</u></strong>&nbsp;&nbsp; &nbsp; (803) 900-8067</p>\r\n\r\n<p><strong><u>Fax:</u></strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; (803) 900-8067</p>\r\n\r\n<p><u><strong>Email:</strong></u>&nbsp;&nbsp;&nbsp;&nbsp; &nbsp; support@gmail.com</p>\r\n</div>\r\n</div>\r\n','Content on page Contact us','full_html'),(12,'<p><a href=\"<?php print url(\'categories/mens-watches\'); ?>\" title=\"Watches &amp; Accessories\"><img alt=\"Watches &amp; Accessories\" src=\"<?php print base_path() . \'sites/default/files/banner/watches_0.jpg\'; ?>\" /></a></p>\r\n','Watches & Accessories banner','php_code'),(13,'<p><a href=\"<?php print url(\'categories/clothes-shoes-bags\'); ?>\"><img alt=\"Clothes Shoes &amp; Bags\" src=\"<?php print base_path() . \'sites/default/files/banner/clothers.jpg\'; ?>\" /></a></p>\r\n','Clothes Shoes & Bags','php_code'),(14,'<p><a href=\"<?php print url(\'categories/mobiles-tablets\'); ?>\" title=\"Mobiles &amp; Tablets\"><img alt=\"Mobiles &amp; Tablets\" src=\"<?php print base_path() . \'sites/default/files/banner/mobile.jpg\'; ?>\" /></a></p>\r\n','Mobiles & Tablets ','php_code'),(15,'<p><a href=\"<?php print url(\'categories/food-supplements\'); ?>\" title=\"Health &amp; Beauty\"><img alt=\"Health &amp; Beauty\" src=\"<?php print base_path() . \'sites/default/files/banner/health_0.jpg\'; ?>\" /></a></p>\r\n','Health & Beauty ','php_code'),(16,'<p><a href=\"<?php print url(\'categories/desktops\'); ?>\" title=\"Computers &amp; Laptops\"><img alt=\"Computers &amp; Laptops\" src=\"<?php print base_path() . \'sites/default/files/banner/computer.jpg\'; ?>\" /></a></p>\r\n','Computers & Laptops','php_code'),(17,'<p><a href=\"<?php print url(\'categories/toys\'); ?>\" title=\"Toys, Kids &amp; Babies\"><img alt=\"Toys, Kids &amp; Babies\" src=\"<?php print base_path() . \'sites/default/files/banner/toy.jpg\'; ?>\" /></a></p>\r\n','Toys, Kids & Babies ','php_code'),(18,'<p><a href=\"<?php print url(\'/categories/dslrslr-cameras\'); ?>\" title=\"Cameras\"><img alt=\"Cameras\" src=\"<?php print base_path() . \'sites/default/files/banner/camera.jpg\'; ?>\" /></a></p>','Cameras','php_code'),(19,'<p><a href=\"<?php print url(\'categories/televisions\'); ?>\" title=\"Consumer Electronics\"><img alt=\"Consumer Electronics\" src=\"<?php print base_path() . \'sites/default/files/banner/electronics.jpg\'; ?>\" /></a></p>\r\n','Consumer Electronics','php_code'),(20,'<p>Please login to view your cart.</p>\r\n','Login to view your cart','filtered_html');
/*!40000 ALTER TABLE `block_custom` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `block_node_type`
--

DROP TABLE IF EXISTS `block_node_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `block_node_type` (
  `module` varchar(64) NOT NULL COMMENT 'The block’s origin module, from block.module.',
  `delta` varchar(32) NOT NULL COMMENT 'The block’s unique delta within module, from block.delta.',
  `type` varchar(32) NOT NULL COMMENT 'The machine-readable name of this type from node_type.type.',
  PRIMARY KEY (`module`,`delta`,`type`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sets up display criteria for blocks based on content types';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `block_node_type`
--

LOCK TABLES `block_node_type` WRITE;
/*!40000 ALTER TABLE `block_node_type` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `block_node_type` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `block_role`
--

DROP TABLE IF EXISTS `block_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `block_role` (
  `module` varchar(64) NOT NULL COMMENT 'The block’s origin module, from block.module.',
  `delta` varchar(32) NOT NULL COMMENT 'The block’s unique delta within module, from block.delta.',
  `rid` int(10) unsigned NOT NULL COMMENT 'The user’s role ID from users_roles.rid.',
  PRIMARY KEY (`module`,`delta`,`rid`),
  KEY `rid` (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sets up access permissions for blocks based on user roles';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `block_role`
--

LOCK TABLES `block_role` WRITE;
/*!40000 ALTER TABLE `block_role` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `block_role` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `blocked_ips`
--

DROP TABLE IF EXISTS `blocked_ips`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `blocked_ips` (
  `iid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: unique ID for IP addresses.',
  `ip` varchar(40) NOT NULL DEFAULT '' COMMENT 'IP address',
  PRIMARY KEY (`iid`),
  KEY `blocked_ip` (`ip`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores blocked IP addresses.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `blocked_ips`
--

LOCK TABLES `blocked_ips` WRITE;
/*!40000 ALTER TABLE `blocked_ips` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `blocked_ips` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache`
--

DROP TABLE IF EXISTS `cache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Generic cache table for caching things not separated out...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache`
--

LOCK TABLES `cache` WRITE;
/*!40000 ALTER TABLE `cache` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_admin_menu`
--

DROP TABLE IF EXISTS `cache_admin_menu`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_admin_menu` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for Administration menu to store client-side...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_admin_menu`
--

LOCK TABLES `cache_admin_menu` WRITE;
/*!40000 ALTER TABLE `cache_admin_menu` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_admin_menu` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_block`
--

DROP TABLE IF EXISTS `cache_block`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_block` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for the Block module to store already built...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_block`
--

LOCK TABLES `cache_block` WRITE;
/*!40000 ALTER TABLE `cache_block` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_block` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_bootstrap`
--

DROP TABLE IF EXISTS `cache_bootstrap`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_bootstrap` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for data required to bootstrap Drupal, may be...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_bootstrap`
--

LOCK TABLES `cache_bootstrap` WRITE;
/*!40000 ALTER TABLE `cache_bootstrap` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_bootstrap` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_commerce_shipping_rates`
--

DROP TABLE IF EXISTS `cache_commerce_shipping_rates`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_commerce_shipping_rates` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Order ID and shipping method the rates are for.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for the temporary storage of base calculated...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_commerce_shipping_rates`
--

LOCK TABLES `cache_commerce_shipping_rates` WRITE;
/*!40000 ALTER TABLE `cache_commerce_shipping_rates` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_commerce_shipping_rates` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_eck`
--

DROP TABLE IF EXISTS `cache_eck`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_eck` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Generic cache table for caching things not separated out...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_eck`
--

LOCK TABLES `cache_eck` WRITE;
/*!40000 ALTER TABLE `cache_eck` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `cache_eck` VALUES ('bundles','a:1:{s:20:\"commerce_store_store\";O:6:\"Bundle\":7:{s:5:\"isNew\";b:0;s:18:\"\0DBObject\0position\";i:0;s:15:\"\0DBObject\0table\";s:10:\"eck_bundle\";s:14:\"\0DBObject\0vars\";a:6:{i:0;s:2:\"id\";i:1;s:12:\"machine_name\";i:2;s:11:\"entity_type\";i:3;s:4:\"name\";i:4;s:5:\"label\";i:5;s:6:\"config\";}s:14:\"\0DBObject\0data\";a:6:{s:12:\"machine_name\";s:20:\"commerce_store_store\";s:11:\"entity_type\";s:14:\"commerce_store\";s:4:\"name\";s:5:\"store\";s:5:\"label\";s:5:\"Store\";s:6:\"config\";a:0:{}s:2:\"id\";s:1:\"1\";}s:21:\"\0DBObject\0primaryKeys\";a:1:{i:0;s:2:\"id\";}s:19:\"\0DBObject\0serialize\";a:1:{i:0;s:6:\"config\";}}}',0,1500361350,1),('entity_types','a:1:{s:14:\"commerce_store\";O:10:\"EntityType\":8:{s:19:\"\0EntityType\0changes\";a:0:{}s:5:\"isNew\";b:0;s:18:\"\0DBObject\0position\";i:0;s:15:\"\0DBObject\0table\";s:15:\"eck_entity_type\";s:14:\"\0DBObject\0vars\";a:4:{i:0;s:2:\"id\";i:1;s:4:\"name\";i:2;s:5:\"label\";i:3;s:10:\"properties\";}s:14:\"\0DBObject\0data\";a:4:{s:4:\"name\";s:14:\"commerce_store\";s:5:\"label\";s:14:\"Commerce Store\";s:10:\"properties\";a:4:{s:5:\"title\";a:3:{s:5:\"label\";s:5:\"Title\";s:4:\"type\";s:4:\"text\";s:8:\"behavior\";s:5:\"title\";}s:3:\"uid\";a:3:{s:5:\"label\";s:13:\"Owner User ID\";s:4:\"type\";s:16:\"positive_integer\";s:8:\"behavior\";s:6:\"author\";}s:7:\"created\";a:3:{s:5:\"label\";s:7:\"Created\";s:4:\"type\";s:16:\"positive_integer\";s:8:\"behavior\";s:7:\"created\";}s:7:\"changed\";a:3:{s:5:\"label\";s:7:\"Changed\";s:4:\"type\";s:16:\"positive_integer\";s:8:\"behavior\";s:7:\"changed\";}}s:2:\"id\";s:1:\"1\";}s:21:\"\0DBObject\0primaryKeys\";a:1:{i:0;s:2:\"id\";}s:19:\"\0DBObject\0serialize\";a:1:{i:0;s:10:\"properties\";}}}',0,1500361350,1);
/*!40000 ALTER TABLE `cache_eck` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_features`
--

DROP TABLE IF EXISTS `cache_features`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_features` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Generic cache table for caching things not separated out...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_features`
--

LOCK TABLES `cache_features` WRITE;
/*!40000 ALTER TABLE `cache_features` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_features` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_field`
--

DROP TABLE IF EXISTS `cache_field`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_field` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Generic cache table for caching things not separated out...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_field`
--

LOCK TABLES `cache_field` WRITE;
/*!40000 ALTER TABLE `cache_field` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_field` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_filter`
--

DROP TABLE IF EXISTS `cache_filter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_filter` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for the Filter module to store already...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_filter`
--

LOCK TABLES `cache_filter` WRITE;
/*!40000 ALTER TABLE `cache_filter` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_filter` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_form`
--

DROP TABLE IF EXISTS `cache_form`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_form` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for the form system to store recently built...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_form`
--

LOCK TABLES `cache_form` WRITE;
/*!40000 ALTER TABLE `cache_form` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `cache_form` VALUES ('form_form-95OFHX5wO0AUDjqExQgZN4cFDxk0AH22DHuUix-8ar0','a:27:{s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:20:\"commerce-add-to-cart\";i:1;s:42:\"commerce-cart-add-to-cart-form-11-12-13-14\";s:5:\"stock\";s:8:\"in-stock\";}}s:3:\"uid\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:1:\"1\";}s:10:\"attributes\";a:5:{s:19:\"field_product_color\";a:6:{s:5:\"#type\";s:25:\"commerce_fancy_attributes\";s:6:\"#title\";s:6:\"Color:\";s:8:\"#options\";a:4:{i:106;s:4:\"Blue\";i:110;s:5:\"Green\";i:108;s:6:\"Orange\";i:107;s:3:\"Red\";}s:14:\"#default_value\";s:3:\"106\";s:7:\"#weight\";s:1:\"5\";s:5:\"#ajax\";a:1:{s:8:\"callback\";s:49:\"commerce_cart_add_to_cart_form_attributes_refresh\";}}s:5:\"#tree\";s:4:\"TRUE\";s:7:\"#prefix\";s:31:\"<div class=\"attribute-widgets\">\";s:7:\"#suffix\";s:6:\"</div>\";s:7:\"#weight\";i:0;}s:20:\"unchanged_attributes\";a:2:{s:19:\"field_product_color\";a:2:{s:5:\"#type\";s:5:\"value\";s:6:\"#value\";s:3:\"106\";}s:5:\"#tree\";s:4:\"TRUE\";}s:10:\"product_id\";a:2:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:2:\"11\";}s:8:\"quantity\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";s:8:\"Quantity\";s:14:\"#default_value\";s:1:\"1\";s:9:\"#datatype\";s:7:\"integer\";s:5:\"#size\";i:5;s:7:\"#weight\";i:45;}s:16:\"line_item_fields\";a:17:{s:5:\"#type\";s:9:\"container\";s:8:\"#parents\";a:1:{i:0;s:16:\"line_item_fields\";}s:7:\"#weight\";i:10;s:5:\"#tree\";b:1;s:7:\"#entity\";O:8:\"stdClass\":12:{s:4:\"type\";s:7:\"product\";s:8:\"order_id\";i:0;s:8:\"quantity\";s:1:\"1\";s:4:\"data\";a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";s:6:\"entity\";s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/31\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"31\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}s:12:\"line_item_id\";N;s:15:\"line_item_label\";s:23:\"LO024FAAKSJ5ANMY-530660\";s:7:\"created\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:6:\"is_new\";b:1;s:16:\"commerce_product\";a:1:{s:3:\"und\";a:1:{i:0;a:1:{s:10:\"product_id\";s:2:\"11\";}}}s:21:\"commerce_display_path\";a:1:{s:3:\"und\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}}s:19:\"commerce_unit_price\";a:1:{s:3:\"und\";a:1:{i:0;a:3:{s:6:\"amount\";s:4:\"9900\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:4:\"9900\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}}}}}s:19:\"commerce_unit_price\";a:8:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:25:\"field-type-commerce-price\";i:1;s:30:\"field-name-commerce-unit-price\";i:2;s:32:\"field-widget-commerce-price-full\";}}s:7:\"#weight\";i:0;s:5:\"#tree\";b:1;s:9:\"#language\";s:3:\"und\";s:3:\"und\";a:13:{i:0;a:17:{s:12:\"#entity_type\";s:18:\"commerce_line_item\";s:7:\"#entity\";r:48;s:7:\"#bundle\";s:7:\"product\";s:11:\"#field_name\";s:19:\"commerce_unit_price\";s:9:\"#language\";s:3:\"und\";s:14:\"#field_parents\";a:1:{i:0;s:16:\"line_item_fields\";}s:8:\"#columns\";a:3:{i:0;s:6:\"amount\";i:1;s:13:\"currency_code\";i:2;s:4:\"data\";}s:6:\"#title\";s:10:\"Unit price\";s:12:\"#description\";s:0:\"\";s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"#attached\";a:1:{s:3:\"css\";a:1:{i:0;s:71:\"sites/all/modules/commerce/modules/price/theme/commerce_price.theme.css\";}}s:6:\"amount\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";s:10:\"Unit price\";s:14:\"#default_value\";s:5:\"99.00\";s:9:\"#required\";b:1;s:5:\"#size\";i:10;s:13:\"#field_suffix\";s:3:\"USD\";}s:13:\"currency_code\";a:2:{s:5:\"#type\";s:5:\"value\";s:14:\"#default_value\";s:3:\"USD\";}s:4:\"data\";a:2:{s:5:\"#type\";s:5:\"value\";s:14:\"#default_value\";a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:4:\"9900\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}}s:17:\"#element_validate\";a:1:{i:0;s:36:\"commerce_price_field_widget_validate\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:19:\"commerce_unit_price\";s:12:\"#cardinality\";s:1:\"1\";s:6:\"#title\";s:10:\"Unit price\";s:9:\"#required\";b:1;s:12:\"#description\";s:0:\"\";s:7:\"#prefix\";s:64:\"<div id=\"line-item-fields-commerce-unit-price-add-more-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;s:30:\"field_form_element_after_build\";}s:9:\"#language\";s:3:\"und\";s:14:\"#field_parents\";a:1:{i:0;s:16:\"line_item_fields\";}}s:7:\"#access\";b:0;s:23:\"#commerce_cart_settings\";a:1:{s:12:\"field_access\";b:0;}}s:14:\"commerce_total\";a:8:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:25:\"field-type-commerce-price\";i:1;s:25:\"field-name-commerce-total\";i:2;s:32:\"field-widget-commerce-price-full\";}}s:7:\"#weight\";i:1;s:5:\"#tree\";b:1;s:9:\"#language\";s:3:\"und\";s:3:\"und\";a:13:{i:0;a:17:{s:12:\"#entity_type\";s:18:\"commerce_line_item\";s:7:\"#entity\";r:48;s:7:\"#bundle\";s:7:\"product\";s:11:\"#field_name\";s:14:\"commerce_total\";s:9:\"#language\";s:3:\"und\";s:14:\"#field_parents\";a:1:{i:0;s:16:\"line_item_fields\";}s:8:\"#columns\";a:3:{i:0;s:6:\"amount\";i:1;s:13:\"currency_code\";i:2;s:4:\"data\";}s:6:\"#title\";s:5:\"Total\";s:12:\"#description\";s:0:\"\";s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:9:\"#attached\";a:1:{s:3:\"css\";a:1:{i:0;s:71:\"sites/all/modules/commerce/modules/price/theme/commerce_price.theme.css\";}}s:6:\"amount\";a:6:{s:5:\"#type\";s:9:\"textfield\";s:6:\"#title\";s:5:\"Total\";s:14:\"#default_value\";N;s:9:\"#required\";b:1;s:5:\"#size\";i:10;s:13:\"#field_suffix\";s:3:\"USD\";}s:13:\"currency_code\";a:2:{s:5:\"#type\";s:5:\"value\";s:14:\"#default_value\";s:3:\"USD\";}s:4:\"data\";a:2:{s:5:\"#type\";s:5:\"value\";s:14:\"#default_value\";a:1:{s:10:\"components\";a:0:{}}}s:17:\"#element_validate\";a:1:{i:0;s:36:\"commerce_price_field_widget_validate\";}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:14:\"commerce_total\";s:12:\"#cardinality\";s:1:\"1\";s:6:\"#title\";s:5:\"Total\";s:9:\"#required\";b:1;s:12:\"#description\";s:0:\"\";s:7:\"#prefix\";s:59:\"<div id=\"line-item-fields-commerce-total-add-more-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;s:30:\"field_form_element_after_build\";}s:9:\"#language\";s:3:\"und\";s:14:\"#field_parents\";a:1:{i:0;s:16:\"line_item_fields\";}}s:7:\"#access\";b:0;s:23:\"#commerce_cart_settings\";a:1:{s:12:\"field_access\";b:0;}}s:16:\"commerce_product\";a:8:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:37:\"field-type-commerce-product-reference\";i:1;s:27:\"field-name-commerce-product\";i:2;s:52:\"field-widget-commerce-product-reference-autocomplete\";}}s:7:\"#weight\";i:0;s:5:\"#tree\";b:1;s:9:\"#language\";s:3:\"und\";s:3:\"und\";a:18:{s:7:\"#entity\";r:48;s:12:\"#entity_type\";s:18:\"commerce_line_item\";s:7:\"#bundle\";s:7:\"product\";s:11:\"#field_name\";s:16:\"commerce_product\";s:9:\"#language\";s:3:\"und\";s:14:\"#field_parents\";a:1:{i:0;s:16:\"line_item_fields\";}s:8:\"#columns\";a:1:{i:0;s:10:\"product_id\";}s:6:\"#title\";s:7:\"Product\";s:12:\"#description\";s:0:\"\";s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:23:\"LO024FAAKSJ5ANMY-530660\";s:18:\"#autocomplete_path\";s:73:\"commerce_product/autocomplete/commerce_line_item/commerce_product/product\";s:5:\"#size\";i:60;s:10:\"#maxlength\";i:2048;s:17:\"#element_validate\";a:1:{i:0;s:48:\"commerce_product_reference_autocomplete_validate\";}s:12:\"#after_build\";a:1:{i:0;s:30:\"field_form_element_after_build\";}}s:7:\"#access\";b:0;s:23:\"#commerce_cart_settings\";a:1:{s:12:\"field_access\";b:0;}}s:21:\"commerce_display_path\";a:8:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:15:\"field-type-text\";i:1;s:32:\"field-name-commerce-display-path\";i:2;s:27:\"field-widget-text-textfield\";}}s:7:\"#weight\";i:0;s:5:\"#tree\";b:1;s:9:\"#language\";s:3:\"und\";s:3:\"und\";a:13:{i:0;a:13:{s:12:\"#entity_type\";s:18:\"commerce_line_item\";s:7:\"#entity\";r:48;s:7:\"#bundle\";s:7:\"product\";s:11:\"#field_name\";s:21:\"commerce_display_path\";s:9:\"#language\";s:3:\"und\";s:14:\"#field_parents\";a:1:{i:0;s:16:\"line_item_fields\";}s:8:\"#columns\";a:2:{i:0;s:5:\"value\";i:1;s:6:\"format\";}s:6:\"#title\";s:12:\"Display path\";s:12:\"#description\";s:0:\"\";s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"value\";a:17:{s:12:\"#entity_type\";s:18:\"commerce_line_item\";s:7:\"#entity\";r:48;s:7:\"#bundle\";s:7:\"product\";s:11:\"#field_name\";s:21:\"commerce_display_path\";s:9:\"#language\";s:3:\"und\";s:14:\"#field_parents\";a:1:{i:0;s:16:\"line_item_fields\";}s:8:\"#columns\";a:2:{i:0;s:5:\"value\";i:1;s:6:\"format\";}s:6:\"#title\";s:12:\"Display path\";s:12:\"#description\";s:0:\"\";s:9:\"#required\";b:1;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:9:\"textfield\";s:14:\"#default_value\";s:0:\"\";s:5:\"#size\";i:60;s:10:\"#maxlength\";i:255;s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:9:\"text-full\";}}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:21:\"commerce_display_path\";s:12:\"#cardinality\";s:1:\"1\";s:6:\"#title\";s:12:\"Display path\";s:9:\"#required\";b:1;s:12:\"#description\";s:0:\"\";s:7:\"#prefix\";s:66:\"<div id=\"line-item-fields-commerce-display-path-add-more-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;s:30:\"field_form_element_after_build\";}s:9:\"#language\";s:3:\"und\";s:14:\"#field_parents\";a:1:{i:0;s:16:\"line_item_fields\";}}s:7:\"#access\";b:0;s:23:\"#commerce_cart_settings\";a:1:{s:12:\"field_access\";b:0;}}s:13:\"cmp_line_item\";a:8:{s:5:\"#type\";s:9:\"container\";s:11:\"#attributes\";a:1:{s:5:\"class\";a:3:{i:0;s:26:\"field-type-entityreference\";i:1;s:24:\"field-name-cmp-line-item\";i:2;s:41:\"field-widget-entityreference-autocomplete\";}}s:7:\"#weight\";i:2;s:5:\"#tree\";b:1;s:9:\"#language\";s:3:\"und\";s:3:\"und\";a:13:{i:0;a:1:{s:9:\"target_id\";a:18:{s:12:\"#entity_type\";s:18:\"commerce_line_item\";s:7:\"#entity\";r:48;s:7:\"#bundle\";s:7:\"product\";s:11:\"#field_name\";s:13:\"cmp_line_item\";s:9:\"#language\";s:3:\"und\";s:14:\"#field_parents\";a:1:{i:0;s:16:\"line_item_fields\";}s:8:\"#columns\";a:1:{i:0;s:9:\"target_id\";}s:6:\"#title\";s:18:\"Original line item\";s:12:\"#description\";s:0:\"\";s:9:\"#required\";b:0;s:6:\"#delta\";i:0;s:7:\"#weight\";i:0;s:5:\"#type\";s:9:\"textfield\";s:10:\"#maxlength\";i:1024;s:14:\"#default_value\";s:0:\"\";s:18:\"#autocomplete_path\";s:81:\"entityreference/autocomplete/single/cmp_line_item/commerce_line_item/product/NULL\";s:5:\"#size\";i:60;s:17:\"#element_validate\";a:1:{i:0;s:38:\"_entityreference_autocomplete_validate\";}}}s:6:\"#theme\";s:25:\"field_multiple_value_form\";s:11:\"#field_name\";s:13:\"cmp_line_item\";s:12:\"#cardinality\";s:1:\"1\";s:6:\"#title\";s:18:\"Original line item\";s:9:\"#required\";b:0;s:12:\"#description\";s:0:\"\";s:7:\"#prefix\";s:58:\"<div id=\"line-item-fields-cmp-line-item-add-more-wrapper\">\";s:7:\"#suffix\";s:6:\"</div>\";s:10:\"#max_delta\";i:0;s:12:\"#after_build\";a:1:{i:0;s:30:\"field_form_element_after_build\";}s:9:\"#language\";s:3:\"und\";s:14:\"#field_parents\";a:1:{i:0;s:16:\"line_item_fields\";}}s:7:\"#access\";b:0;s:23:\"#commerce_cart_settings\";a:1:{s:12:\"field_access\";b:0;}}s:11:\"#pre_render\";a:2:{i:0;s:30:\"_field_extra_fields_pre_render\";i:1;s:27:\"field_group_form_pre_render\";}s:12:\"#entity_type\";s:18:\"commerce_line_item\";s:7:\"#bundle\";s:7:\"product\";s:9:\"#attached\";a:1:{s:3:\"css\";a:1:{i:0;s:54:\"sites/all/modules/field_group/field_group.field_ui.css\";}}s:7:\"#groups\";a:0:{}s:12:\"#fieldgroups\";a:0:{}s:15:\"#group_children\";a:0:{}}s:6:\"submit\";a:4:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";s:11:\"Add to cart\";s:7:\"#weight\";i:50;s:9:\"#disabled\";b:0;}s:9:\"#validate\";a:2:{i:0;s:39:\"commerce_cart_add_to_cart_form_validate\";i:1;s:35:\"commerce_stock_add_to_cart_validate\";}s:7:\"#submit\";a:1:{i:0;s:37:\"commerce_cart_add_to_cart_form_submit\";}s:12:\"#after_build\";a:2:{i:0;s:42:\"commerce_cart_add_to_cart_form_after_build\";i:1;s:35:\"context_form_alter_node_after_build\";}s:8:\"#form_id\";s:42:\"commerce_cart_add_to_cart_form_11_12_13_14\";s:5:\"#type\";s:4:\"form\";s:9:\"#build_id\";s:48:\"form-95OFHX5wO0AUDjqExQgZN4cFDxk0AH22DHuUix-8ar0\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-95OFHX5wO0AUDjqExQgZN4cFDxk0AH22DHuUix-8ar0\";s:3:\"#id\";s:48:\"form-95OFHX5wO0AUDjqExQgZN4cFDxk0AH22DHuUix-8ar0\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:42:\"commerce_cart_add_to_cart_form_11_12_13_14\";s:10:\"form_token\";a:4:{s:3:\"#id\";s:58:\"edit-commerce-cart-add-to-cart-form-11-12-13-14-form-token\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:43:\"9uIdgnxsS6dwH2bImrIJsx_MIq1CuScmiWtNVqaw380\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:42:\"commerce_cart_add_to_cart_form_11_12_13_14\";s:3:\"#id\";s:47:\"edit-commerce-cart-add-to-cart-form-11-12-13-14\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:42:\"commerce-cart-add-to-cart-form-11-12-13-14\";s:7:\"#method\";s:4:\"post\";s:7:\"#action\";s:90:\"/drupal7/marketplace/en/product/local-lion-water-resistant-hiking-backpack-bag-28l-blue-31\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:5:\"#tree\";b:0;s:8:\"#parents\";a:0:{}s:6:\"#theme\";a:2:{i:0;s:42:\"commerce_cart_add_to_cart_form_11_12_13_14\";i:1;s:30:\"commerce_cart_add_to_cart_form\";}s:9:\"#attached\";a:2:{s:3:\"css\";a:1:{i:0;s:73:\"sites/all/modules/commerce_fancy_attributes/commerce_fancy_attributes.css\";}s:2:\"js\";a:1:{i:0;s:72:\"sites/all/modules/commerce_fancy_attributes/commerce_fancy_attributes.js\";}}s:12:\"#cache_token\";s:43:\"AatW4nrpYwg-TCagGWS9RJChnbKJHWLJ_gk7e3jjtDk\";}',1500382835,1500361235,1),('form_state_form-95OFHX5wO0AUDjqExQgZN4cFDxk0AH22DHuUix-8ar0','a:9:{s:10:\"build_info\";a:3:{s:4:\"args\";a:3:{i:0;O:8:\"stdClass\":12:{s:4:\"type\";s:7:\"product\";s:8:\"order_id\";i:0;s:8:\"quantity\";s:1:\"1\";s:4:\"data\";a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";s:6:\"entity\";s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/31\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"31\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}s:12:\"line_item_id\";N;s:15:\"line_item_label\";s:23:\"LO024FAAKSJ5ANMY-530660\";s:7:\"created\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:6:\"is_new\";b:1;s:16:\"commerce_product\";a:1:{s:3:\"und\";a:1:{i:0;a:1:{s:10:\"product_id\";s:2:\"11\";}}}s:21:\"commerce_display_path\";a:1:{s:3:\"und\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}}s:19:\"commerce_unit_price\";a:1:{s:3:\"und\";a:1:{i:0;a:3:{s:6:\"amount\";s:4:\"9900\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:4:\"9900\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}}}}}i:1;i:1;i:2;a:6:{s:11:\"entity_type\";s:4:\"node\";s:9:\"view_mode\";s:9:\"node_full\";s:7:\"display\";s:4:\"full\";s:8:\"language\";s:2:\"en\";s:9:\"entity_id\";s:2:\"31\";s:12:\"class_prefix\";s:7:\"node-31\";}}s:7:\"form_id\";s:42:\"commerce_cart_add_to_cart_form_11_12_13_14\";s:12:\"base_form_id\";s:30:\"commerce_cart_add_to_cart_form\";}s:10:\"programmed\";b:0;s:30:\"programmed_bypass_access_check\";b:1;s:5:\"cache\";b:1;s:7:\"context\";a:6:{s:11:\"entity_type\";s:4:\"node\";s:9:\"view_mode\";s:9:\"node_full\";s:7:\"display\";s:4:\"full\";s:8:\"language\";s:2:\"en\";s:9:\"entity_id\";s:2:\"31\";s:12:\"class_prefix\";s:7:\"node-31\";}s:9:\"line_item\";r:4;s:5:\"field\";a:1:{s:8:\"#parents\";a:1:{s:16:\"line_item_fields\";a:1:{s:7:\"#fields\";a:5:{s:19:\"commerce_unit_price\";a:1:{s:3:\"und\";a:5:{s:5:\"field\";a:16:{s:12:\"entity_types\";a:1:{i:0;s:18:\"commerce_line_item\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_commerce_unit_price\";a:3:{s:6:\"amount\";s:26:\"commerce_unit_price_amount\";s:13:\"currency_code\";s:33:\"commerce_unit_price_currency_code\";s:4:\"data\";s:24:\"commerce_unit_price_data\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_commerce_unit_price\";a:3:{s:6:\"amount\";s:26:\"commerce_unit_price_amount\";s:13:\"currency_code\";s:33:\"commerce_unit_price_currency_code\";s:4:\"data\";s:24:\"commerce_unit_price_data\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:14:\"currency_price\";a:2:{i:0;s:6:\"amount\";i:1;s:13:\"currency_code\";}}s:2:\"id\";s:2:\"10\";s:10:\"field_name\";s:19:\"commerce_unit_price\";s:4:\"type\";s:14:\"commerce_price\";s:6:\"module\";s:14:\"commerce_price\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"1\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:3:{s:6:\"amount\";a:4:{s:11:\"description\";s:17:\"The price amount.\";s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:13:\"currency_code\";a:4:{s:11:\"description\";s:32:\"The currency code for the price.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}s:4:\"data\";a:5:{s:11:\"description\";s:44:\"A serialized array of additional price data.\";s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;s:9:\"serialize\";b:1;}}s:7:\"bundles\";a:1:{s:18:\"commerce_line_item\";a:2:{i:0;s:7:\"product\";i:1;s:8:\"shipping\";}}}s:8:\"instance\";a:13:{s:5:\"label\";s:10:\"Unit price\";s:8:\"required\";b:1;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:19:\"commerce_price_full\";s:6:\"weight\";i:0;s:8:\"settings\";a:1:{s:13:\"currency_code\";s:7:\"default\";}s:6:\"module\";s:14:\"commerce_price\";}s:7:\"display\";a:3:{s:7:\"display\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:11:\"node_teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}}s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"15\";s:8:\"field_id\";s:2:\"10\";s:10:\"field_name\";s:19:\"commerce_unit_price\";s:11:\"entity_type\";s:18:\"commerce_line_item\";s:6:\"bundle\";s:7:\"product\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:11:\"items_count\";i:1;s:13:\"array_parents\";a:3:{i:0;s:16:\"line_item_fields\";i:1;s:19:\"commerce_unit_price\";i:2;s:3:\"und\";}s:6:\"errors\";a:0:{}}}s:14:\"commerce_total\";a:1:{s:3:\"und\";a:5:{s:5:\"field\";a:16:{s:12:\"entity_types\";a:1:{i:0;s:18:\"commerce_line_item\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_commerce_total\";a:3:{s:6:\"amount\";s:21:\"commerce_total_amount\";s:13:\"currency_code\";s:28:\"commerce_total_currency_code\";s:4:\"data\";s:19:\"commerce_total_data\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_commerce_total\";a:3:{s:6:\"amount\";s:21:\"commerce_total_amount\";s:13:\"currency_code\";s:28:\"commerce_total_currency_code\";s:4:\"data\";s:19:\"commerce_total_data\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:14:\"currency_price\";a:2:{i:0;s:6:\"amount\";i:1;s:13:\"currency_code\";}}s:2:\"id\";s:2:\"11\";s:10:\"field_name\";s:14:\"commerce_total\";s:4:\"type\";s:14:\"commerce_price\";s:6:\"module\";s:14:\"commerce_price\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"1\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:3:{s:6:\"amount\";a:4:{s:11:\"description\";s:17:\"The price amount.\";s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:13:\"currency_code\";a:4:{s:11:\"description\";s:32:\"The currency code for the price.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}s:4:\"data\";a:5:{s:11:\"description\";s:44:\"A serialized array of additional price data.\";s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;s:9:\"serialize\";b:1;}}s:7:\"bundles\";a:1:{s:18:\"commerce_line_item\";a:2:{i:0;s:7:\"product\";i:1;s:8:\"shipping\";}}}s:8:\"instance\";a:13:{s:5:\"label\";s:5:\"Total\";s:8:\"required\";b:1;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:19:\"commerce_price_full\";s:6:\"weight\";i:1;s:8:\"settings\";a:1:{s:13:\"currency_code\";s:7:\"default\";}s:6:\"module\";s:14:\"commerce_price\";}s:7:\"display\";a:3:{s:7:\"display\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:1;s:6:\"module\";s:14:\"commerce_price\";}s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:1;s:6:\"module\";s:14:\"commerce_price\";}s:11:\"node_teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:1;s:6:\"module\";s:14:\"commerce_price\";}}s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"16\";s:8:\"field_id\";s:2:\"11\";s:10:\"field_name\";s:14:\"commerce_total\";s:11:\"entity_type\";s:18:\"commerce_line_item\";s:6:\"bundle\";s:7:\"product\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:11:\"items_count\";i:0;s:13:\"array_parents\";a:3:{i:0;s:16:\"line_item_fields\";i:1;s:14:\"commerce_total\";i:2;s:3:\"und\";}s:6:\"errors\";a:0:{}}}s:16:\"commerce_product\";a:1:{s:3:\"und\";a:5:{s:5:\"field\";a:16:{s:12:\"entity_types\";a:1:{i:0;s:18:\"commerce_line_item\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:1:{s:18:\"options_list_limit\";N;}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_commerce_product\";a:1:{s:10:\"product_id\";s:27:\"commerce_product_product_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_commerce_product\";a:1:{s:10:\"product_id\";s:27:\"commerce_product_product_id\";}}}}}s:12:\"foreign keys\";a:1:{s:10:\"product_id\";a:2:{s:5:\"table\";s:16:\"commerce_product\";s:7:\"columns\";a:1:{s:10:\"product_id\";s:10:\"product_id\";}}}s:7:\"indexes\";a:1:{s:10:\"product_id\";a:1:{i:0;s:10:\"product_id\";}}s:2:\"id\";s:2:\"12\";s:10:\"field_name\";s:16:\"commerce_product\";s:4:\"type\";s:26:\"commerce_product_reference\";s:6:\"module\";s:26:\"commerce_product_reference\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"1\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:10:\"product_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:18:\"commerce_line_item\";a:1:{i:0;s:7:\"product\";}}}s:8:\"instance\";a:13:{s:5:\"label\";s:7:\"Product\";s:8:\"required\";b:1;s:8:\"settings\";a:3:{s:19:\"referenceable_types\";a:0:{}s:15:\"field_injection\";b:1;s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:39:\"commerce_product_reference_autocomplete\";s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:18:\"autocomplete_match\";s:8:\"contains\";s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:29:\"commerce_product/autocomplete\";}s:6:\"module\";s:26:\"commerce_product_reference\";}s:7:\"display\";a:2:{s:7:\"display\";a:5:{s:5:\"label\";s:6:\"hidden\";s:6:\"weight\";i:0;s:4:\"type\";s:30:\"commerce_cart_add_to_cart_form\";s:8:\"settings\";a:6:{s:13:\"show_quantity\";b:0;s:16:\"default_quantity\";i:1;s:7:\"combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:14:\"line_item_type\";s:7:\"product\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:13:\"commerce_cart\";}s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:30:\"commerce_cart_add_to_cart_form\";s:8:\"settings\";a:6:{s:13:\"show_quantity\";b:0;s:16:\"default_quantity\";i:1;s:7:\"combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:14:\"line_item_type\";s:7:\"product\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:13:\"commerce_cart\";s:6:\"weight\";i:2;}}s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"17\";s:8:\"field_id\";s:2:\"12\";s:10:\"field_name\";s:16:\"commerce_product\";s:11:\"entity_type\";s:18:\"commerce_line_item\";s:6:\"bundle\";s:7:\"product\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:11:\"items_count\";i:1;s:13:\"array_parents\";a:3:{i:0;s:16:\"line_item_fields\";i:1;s:16:\"commerce_product\";i:2;s:3:\"und\";}s:6:\"errors\";a:0:{}}}s:21:\"commerce_display_path\";a:1:{s:3:\"und\";a:5:{s:5:\"field\";a:16:{s:12:\"entity_types\";a:1:{i:0;s:18:\"commerce_line_item\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:1:{s:10:\"max_length\";i:255;}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:32:\"field_data_commerce_display_path\";a:2:{s:5:\"value\";s:27:\"commerce_display_path_value\";s:6:\"format\";s:28:\"commerce_display_path_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:36:\"field_revision_commerce_display_path\";a:2:{s:5:\"value\";s:27:\"commerce_display_path_value\";s:6:\"format\";s:28:\"commerce_display_path_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"13\";s:10:\"field_name\";s:21:\"commerce_display_path\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"1\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:18:\"commerce_line_item\";a:1:{i:0;s:7:\"product\";}}}s:8:\"instance\";a:13:{s:5:\"label\";s:12:\"Display path\";s:8:\"required\";b:1;s:8:\"settings\";a:2:{s:15:\"text_processing\";i:0;s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:14:\"text_textfield\";s:6:\"weight\";i:0;s:8:\"settings\";a:1:{s:4:\"size\";i:60;}s:6:\"module\";s:4:\"text\";}s:7:\"display\";a:2:{s:7:\"display\";a:5:{s:5:\"label\";s:6:\"hidden\";s:6:\"weight\";i:0;s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"text\";}s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:3;}}s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"18\";s:8:\"field_id\";s:2:\"13\";s:10:\"field_name\";s:21:\"commerce_display_path\";s:11:\"entity_type\";s:18:\"commerce_line_item\";s:6:\"bundle\";s:7:\"product\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:11:\"items_count\";i:1;s:13:\"array_parents\";a:3:{i:0;s:16:\"line_item_fields\";i:1;s:21:\"commerce_display_path\";i:2;s:3:\"und\";}s:6:\"errors\";a:0:{}}}s:13:\"cmp_line_item\";a:1:{s:3:\"und\";a:5:{s:5:\"field\";a:16:{s:8:\"settings\";a:3:{s:11:\"target_type\";s:18:\"commerce_line_item\";s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:0:{}}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:24:\"field_data_cmp_line_item\";a:1:{s:9:\"target_id\";s:23:\"cmp_line_item_target_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:28:\"field_revision_cmp_line_item\";a:1:{s:9:\"target_id\";s:23:\"cmp_line_item_target_id\";}}}}}s:12:\"foreign keys\";a:1:{s:18:\"commerce_line_item\";a:2:{s:5:\"table\";s:18:\"commerce_line_item\";s:7:\"columns\";a:1:{s:9:\"target_id\";s:12:\"line_item_id\";}}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:2:\"id\";s:2:\"27\";s:10:\"field_name\";s:13:\"cmp_line_item\";s:4:\"type\";s:15:\"entityreference\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:9:\"target_id\";a:4:{s:11:\"description\";s:28:\"The id of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"bundles\";a:1:{s:18:\"commerce_line_item\";a:2:{i:0;s:7:\"product\";i:1;s:8:\"shipping\";}}}s:8:\"instance\";a:13:{s:5:\"label\";s:18:\"Original line item\";s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:21:\"entityreference_label\";s:8:\"settings\";a:2:{s:4:\"link\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:15:\"entityreference\";s:6:\"weight\";i:4;}}s:6:\"widget\";a:4:{s:4:\"type\";s:28:\"entityreference_autocomplete\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:4:\"path\";s:0:\"\";}s:6:\"weight\";i:2;s:6:\"module\";s:15:\"entityreference\";}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"49\";s:8:\"field_id\";s:2:\"27\";s:10:\"field_name\";s:13:\"cmp_line_item\";s:11:\"entity_type\";s:18:\"commerce_line_item\";s:6:\"bundle\";s:7:\"product\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:11:\"items_count\";i:0;s:13:\"array_parents\";a:3:{i:0;s:16:\"line_item_fields\";i:1;s:13:\"cmp_line_item\";i:2;s:3:\"und\";}s:6:\"errors\";a:0:{}}}}}}}s:13:\"process_input\";b:0;s:18:\"default_product_id\";s:2:\"11\";}',1500382835,1500361235,1);
/*!40000 ALTER TABLE `cache_form` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_image`
--

DROP TABLE IF EXISTS `cache_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_image` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table used to store information about image...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_image`
--

LOCK TABLES `cache_image` WRITE;
/*!40000 ALTER TABLE `cache_image` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_image` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_libraries`
--

DROP TABLE IF EXISTS `cache_libraries`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_libraries` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table to store library information.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_libraries`
--

LOCK TABLES `cache_libraries` WRITE;
/*!40000 ALTER TABLE `cache_libraries` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_libraries` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_menu`
--

DROP TABLE IF EXISTS `cache_menu`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_menu` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for the menu system to store router...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_menu`
--

LOCK TABLES `cache_menu` WRITE;
/*!40000 ALTER TABLE `cache_menu` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `cache_menu` VALUES ('menu_custom','a:10:{s:5:\"devel\";a:3:{s:9:\"menu_name\";s:5:\"devel\";s:5:\"title\";s:11:\"Development\";s:11:\"description\";s:16:\"Development link\";}s:8:\"features\";a:3:{s:9:\"menu_name\";s:8:\"features\";s:5:\"title\";s:8:\"Features\";s:11:\"description\";s:36:\"Menu items for any enabled features.\";}s:9:\"main-menu\";a:3:{s:9:\"menu_name\";s:9:\"main-menu\";s:5:\"title\";s:9:\"Main menu\";s:11:\"description\";s:115:\"The <em>Main</em> menu is used on many sites to show the major sections of the site, often in a top navigation bar.\";}s:10:\"management\";a:3:{s:9:\"menu_name\";s:10:\"management\";s:5:\"title\";s:10:\"Management\";s:11:\"description\";s:69:\"The <em>Management</em> menu contains links for administrative tasks.\";}s:13:\"menu-about-us\";a:3:{s:9:\"menu_name\";s:13:\"menu-about-us\";s:5:\"title\";s:8:\"About us\";s:11:\"description\";s:0:\"\";}s:18:\"menu-customer-help\";a:3:{s:9:\"menu_name\";s:18:\"menu-customer-help\";s:5:\"title\";s:13:\"Customer help\";s:11:\"description\";s:0:\"\";}s:18:\"menu-headline-menu\";a:3:{s:9:\"menu_name\";s:18:\"menu-headline-menu\";s:5:\"title\";s:13:\"Headline menu\";s:11:\"description\";s:0:\"\";}s:14:\"menu-help-menu\";a:3:{s:9:\"menu_name\";s:14:\"menu-help-menu\";s:5:\"title\";s:11:\"Help Topics\";s:11:\"description\";s:0:\"\";}s:10:\"navigation\";a:3:{s:9:\"menu_name\";s:10:\"navigation\";s:5:\"title\";s:10:\"Navigation\";s:11:\"description\";s:150:\"The <em>Navigation</em> menu contains links intended for site visitors. Links are added to the <em>Navigation</em> menu automatically by some modules.\";}s:9:\"user-menu\";a:3:{s:9:\"menu_name\";s:9:\"user-menu\";s:5:\"title\";s:9:\"User menu\";s:11:\"description\";s:0:\"\";}}',0,1500361350,1);
/*!40000 ALTER TABLE `cache_menu` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_page`
--

DROP TABLE IF EXISTS `cache_page`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_page` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table used to store compressed pages for anonymous...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_page`
--

LOCK TABLES `cache_page` WRITE;
/*!40000 ALTER TABLE `cache_page` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_page` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_path`
--

DROP TABLE IF EXISTS `cache_path`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_path` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for path alias lookup.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_path`
--

LOCK TABLES `cache_path` WRITE;
/*!40000 ALTER TABLE `cache_path` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_path` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_rules`
--

DROP TABLE IF EXISTS `cache_rules`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_rules` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for the rules engine to store configured items.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_rules`
--

LOCK TABLES `cache_rules` WRITE;
/*!40000 ALTER TABLE `cache_rules` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_rules` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_token`
--

DROP TABLE IF EXISTS `cache_token`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_token` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for token information.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_token`
--

LOCK TABLES `cache_token` WRITE;
/*!40000 ALTER TABLE `cache_token` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_token` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_update`
--

DROP TABLE IF EXISTS `cache_update`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_update` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for the Update module to store information...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_update`
--

LOCK TABLES `cache_update` WRITE;
/*!40000 ALTER TABLE `cache_update` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `cache_update` VALUES ('available_releases::addressfield','a:11:{s:5:\"title\";s:13:\"Address Field\";s:10:\"short_name\";s:12:\"addressfield\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:43:\"https://www.drupal.org/project/addressfield\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:14:{s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:20:\"addressfield 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/addressfield/releases/7.x-1.2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/addressfield-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1444253039\";s:6:\"mdhash\";s:32:\"2c9452731b1b8fffeba8f420c590cc57\";s:8:\"filesize\";s:5:\"77194\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:20:\"addressfield 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/addressfield/releases/7.x-1.1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/addressfield-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1429819381\";s:6:\"mdhash\";s:32:\"c81a7e14dd68dba02c377d8678175b02\";s:8:\"filesize\";s:5:\"76589\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:20:\"addressfield 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/addressfield/releases/7.x-1.0\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/addressfield-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1421426880\";s:6:\"mdhash\";s:32:\"d0dafd2af22b482a5d14d4aa530bbba4\";s:8:\"filesize\";s:5:\"76261\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:24:\"addressfield 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/addressfield/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/addressfield-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1418653681\";s:6:\"mdhash\";s:32:\"b67a4f2f88c958e5bc5dccff84cf7856\";s:8:\"filesize\";s:5:\"74572\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta5\";a:15:{s:4:\"name\";s:26:\"addressfield 7.x-1.0-beta5\";s:7:\"version\";s:13:\"7.x-1.0-beta5\";s:3:\"tag\";s:13:\"7.x-1.0-beta5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/addressfield/releases/7.x-1.0-beta5\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/addressfield-7.x-1.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1386309504\";s:6:\"mdhash\";s:32:\"63d28860718d212d0b68d7c1a199590e\";s:8:\"filesize\";s:5:\"67249\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta4\";a:15:{s:4:\"name\";s:26:\"addressfield 7.x-1.0-beta4\";s:7:\"version\";s:13:\"7.x-1.0-beta4\";s:3:\"tag\";s:13:\"7.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/addressfield/releases/7.x-1.0-beta4\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/addressfield-7.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1367945111\";s:6:\"mdhash\";s:32:\"884414b0ad4afd037b5ba1cec1d107e3\";s:8:\"filesize\";s:5:\"61233\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta3\";a:15:{s:4:\"name\";s:26:\"addressfield 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/addressfield/releases/7.x-1.0-beta3\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/addressfield-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1338304248\";s:6:\"mdhash\";s:32:\"a3df218c4f779a03f4efe4c87d9eaf53\";s:8:\"filesize\";s:5:\"52898\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:26:\"addressfield 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/addressfield/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/addressfield-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1314906115\";s:6:\"mdhash\";s:32:\"8ea36908a8aeca560c273acc75f79d2f\";s:8:\"filesize\";s:5:\"51350\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:26:\"addressfield 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/addressfield/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/addressfield-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1310587614\";s:6:\"mdhash\";s:32:\"b945c657d8a1d05fc3008a0b93d71595\";s:8:\"filesize\";s:5:\"18370\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-1.0-alpha4\";a:15:{s:4:\"name\";s:27:\"addressfield 7.x-1.0-alpha4\";s:7:\"version\";s:14:\"7.x-1.0-alpha4\";s:3:\"tag\";s:14:\"7.x-1.0-alpha4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/addressfield/releases/7.x-1.0-alpha4\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/addressfield-7.x-1.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1307853714\";s:6:\"mdhash\";s:32:\"ae1698ed003872b6f51e53319d41dbc0\";s:8:\"filesize\";s:5:\"15085\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-1.0-alpha3\";a:15:{s:4:\"name\";s:27:\"addressfield 7.x-1.0-alpha3\";s:7:\"version\";s:14:\"7.x-1.0-alpha3\";s:3:\"tag\";s:14:\"7.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/addressfield/releases/7.x-1.0-alpha3\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/addressfield-7.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1307808115\";s:6:\"mdhash\";s:32:\"3d17e265474c269056a8e32123fa7db1\";s:8:\"filesize\";s:5:\"15097\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:27:\"addressfield 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/addressfield/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/addressfield-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1303140714\";s:6:\"mdhash\";s:32:\"8ceff09ca7655dea59d15add3aae1608\";s:8:\"filesize\";s:5:\"13906\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:27:\"addressfield 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/addressfield/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/addressfield-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1286607059\";s:6:\"mdhash\";s:32:\"bd3d8946deeb2d99d559827208112f98\";s:8:\"filesize\";s:5:\"10632\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:24:\"addressfield 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/addressfield/releases/7.x-1.x-dev\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/addressfield-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1451474639\";s:6:\"mdhash\";s:32:\"49f9b3674808adec5528bb421bd3094e\";s:8:\"filesize\";s:5:\"77544\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1500447547,1500361146,1),('available_releases::admin_menu','a:11:{s:5:\"title\";s:19:\"Administration menu\";s:10:\"short_name\";s:10:\"admin_menu\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"3\";s:16:\"supported_majors\";s:1:\"3\";s:13:\"default_major\";s:1:\"3\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:41:\"https://www.drupal.org/project/admin_menu\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:6:{s:11:\"7.x-3.0-rc5\";a:15:{s:4:\"name\";s:22:\"admin_menu 7.x-3.0-rc5\";s:7:\"version\";s:11:\"7.x-3.0-rc5\";s:3:\"tag\";s:11:\"7.x-3.0-rc5\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_menu/releases/7.x-3.0-rc5\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_menu-7.x-3.0-rc5.tar.gz\";s:4:\"date\";s:10:\"1419029280\";s:6:\"mdhash\";s:32:\"4f1a0c14001c880bd7eb170318b91303\";s:8:\"filesize\";s:5:\"53401\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-3.0-rc4\";a:15:{s:4:\"name\";s:22:\"admin_menu 7.x-3.0-rc4\";s:7:\"version\";s:11:\"7.x-3.0-rc4\";s:3:\"tag\";s:11:\"7.x-3.0-rc4\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_menu/releases/7.x-3.0-rc4\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_menu-7.x-3.0-rc4.tar.gz\";s:4:\"date\";s:10:\"1359651687\";s:6:\"mdhash\";s:32:\"3d8359538878723720fca6ddb2f82c7a\";s:8:\"filesize\";s:5:\"55064\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-3.0-rc3\";a:15:{s:4:\"name\";s:22:\"admin_menu 7.x-3.0-rc3\";s:7:\"version\";s:11:\"7.x-3.0-rc3\";s:3:\"tag\";s:11:\"7.x-3.0-rc3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_menu/releases/7.x-3.0-rc3\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_menu-7.x-3.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1337292349\";s:6:\"mdhash\";s:32:\"86b659c35823d541354179eccbfdc2d4\";s:8:\"filesize\";s:5:\"50950\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-3.0-rc2\";a:15:{s:4:\"name\";s:22:\"admin_menu 7.x-3.0-rc2\";s:7:\"version\";s:11:\"7.x-3.0-rc2\";s:3:\"tag\";s:11:\"7.x-3.0-rc2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_menu/releases/7.x-3.0-rc2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_menu-7.x-3.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1335198071\";s:6:\"mdhash\";s:32:\"47761c79c351697f295d933b85441328\";s:8:\"filesize\";s:5:\"49988\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-3.0-rc1\";a:15:{s:4:\"name\";s:22:\"admin_menu 7.x-3.0-rc1\";s:7:\"version\";s:11:\"7.x-3.0-rc1\";s:3:\"tag\";s:11:\"7.x-3.0-rc1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_menu/releases/7.x-3.0-rc1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_menu-7.x-3.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1294378871\";s:6:\"mdhash\";s:32:\"9d0cfb26adda4da7bd309bdf5be305a0\";s:8:\"filesize\";s:5:\"70961\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}s:11:\"7.x-3.x-dev\";a:14:{s:4:\"name\";s:22:\"admin_menu 7.x-3.x-dev\";s:7:\"version\";s:11:\"7.x-3.x-dev\";s:3:\"tag\";s:7:\"7.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_menu/releases/7.x-3.x-dev\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_menu-7.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1426875181\";s:6:\"mdhash\";s:32:\"6d2cdd2a5be2531a7e735847ce329102\";s:8:\"filesize\";s:5:\"53496\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}}}',1500447547,1500361146,1),('available_releases::better_exposed_filters','a:11:{s:5:\"title\";s:22:\"Better Exposed Filters\";s:10:\"short_name\";s:22:\"better_exposed_filters\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"3\";s:16:\"supported_majors\";s:1:\"3\";s:13:\"default_major\";s:1:\"3\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:53:\"https://www.drupal.org/project/better_exposed_filters\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:11:{s:7:\"7.x-3.4\";a:14:{s:4:\"name\";s:30:\"better_exposed_filters 7.x-3.4\";s:7:\"version\";s:7:\"7.x-3.4\";s:3:\"tag\";s:7:\"7.x-3.4\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/better_exposed_filters/releases/7.x-3.4\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/better_exposed_filters-7.x-3.4.tar.gz\";s:4:\"date\";s:10:\"1485926283\";s:6:\"mdhash\";s:32:\"0a149a565aa4885faf6015c1ce6b929b\";s:8:\"filesize\";s:5:\"51110\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-3.3\";a:14:{s:4:\"name\";s:30:\"better_exposed_filters 7.x-3.3\";s:7:\"version\";s:7:\"7.x-3.3\";s:3:\"tag\";s:7:\"7.x-3.3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/better_exposed_filters/releases/7.x-3.3\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/better_exposed_filters-7.x-3.3.tar.gz\";s:4:\"date\";s:10:\"1484287085\";s:6:\"mdhash\";s:32:\"fd788f73765e10d63b29c8552a1565cf\";s:8:\"filesize\";s:5:\"51087\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-3.2\";a:14:{s:4:\"name\";s:30:\"better_exposed_filters 7.x-3.2\";s:7:\"version\";s:7:\"7.x-3.2\";s:3:\"tag\";s:7:\"7.x-3.2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/better_exposed_filters/releases/7.x-3.2\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/better_exposed_filters-7.x-3.2.tar.gz\";s:4:\"date\";s:10:\"1428077881\";s:6:\"mdhash\";s:32:\"3134e2c13500d96fd3c10d0fa07181fa\";s:8:\"filesize\";s:5:\"49437\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-3.1\";a:14:{s:4:\"name\";s:30:\"better_exposed_filters 7.x-3.1\";s:7:\"version\";s:7:\"7.x-3.1\";s:3:\"tag\";s:7:\"7.x-3.1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/better_exposed_filters/releases/7.x-3.1\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/better_exposed_filters-7.x-3.1.tar.gz\";s:4:\"date\";s:10:\"1427969281\";s:6:\"mdhash\";s:32:\"017ab6ca581c48a78ec8f64d03e2e0e4\";s:8:\"filesize\";s:5:\"48222\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-3.0\";a:14:{s:4:\"name\";s:30:\"better_exposed_filters 7.x-3.0\";s:7:\"version\";s:7:\"7.x-3.0\";s:3:\"tag\";s:7:\"7.x-3.0\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/better_exposed_filters/releases/7.x-3.0\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/better_exposed_filters-7.x-3.0.tar.gz\";s:4:\"date\";s:10:\"1418734682\";s:6:\"mdhash\";s:32:\"38a786d3a3b3b771c8c2628a1ce21bd3\";s:8:\"filesize\";s:5:\"46503\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:13:\"7.x-3.0-beta4\";a:15:{s:4:\"name\";s:36:\"better_exposed_filters 7.x-3.0-beta4\";s:7:\"version\";s:13:\"7.x-3.0-beta4\";s:3:\"tag\";s:13:\"7.x-3.0-beta4\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:76:\"https://www.drupal.org/project/better_exposed_filters/releases/7.x-3.0-beta4\";s:13:\"download_link\";s:81:\"https://ftp.drupal.org/files/projects/better_exposed_filters-7.x-3.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1392255205\";s:6:\"mdhash\";s:32:\"f6537a3b09c0e3e9dd257928eae8198e\";s:8:\"filesize\";s:5:\"44243\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta3\";a:15:{s:4:\"name\";s:36:\"better_exposed_filters 7.x-3.0-beta3\";s:7:\"version\";s:13:\"7.x-3.0-beta3\";s:3:\"tag\";s:13:\"7.x-3.0-beta3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:76:\"https://www.drupal.org/project/better_exposed_filters/releases/7.x-3.0-beta3\";s:13:\"download_link\";s:81:\"https://ftp.drupal.org/files/projects/better_exposed_filters-7.x-3.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1349281866\";s:6:\"mdhash\";s:32:\"bf1378218e4cc0db6ecf856813a90d23\";s:8:\"filesize\";s:5:\"29586\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta2\";a:15:{s:4:\"name\";s:36:\"better_exposed_filters 7.x-3.0-beta2\";s:7:\"version\";s:13:\"7.x-3.0-beta2\";s:3:\"tag\";s:13:\"7.x-3.0-beta2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:76:\"https://www.drupal.org/project/better_exposed_filters/releases/7.x-3.0-beta2\";s:13:\"download_link\";s:81:\"https://ftp.drupal.org/files/projects/better_exposed_filters-7.x-3.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1347562608\";s:6:\"mdhash\";s:32:\"0be78b0c7baec31077c41624fbd58087\";s:8:\"filesize\";s:5:\"29237\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta1\";a:15:{s:4:\"name\";s:36:\"better_exposed_filters 7.x-3.0-beta1\";s:7:\"version\";s:13:\"7.x-3.0-beta1\";s:3:\"tag\";s:13:\"7.x-3.0-beta1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:76:\"https://www.drupal.org/project/better_exposed_filters/releases/7.x-3.0-beta1\";s:13:\"download_link\";s:81:\"https://ftp.drupal.org/files/projects/better_exposed_filters-7.x-3.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1312327014\";s:6:\"mdhash\";s:32:\"3ae8db4a8857ef0ba86083b968191feb\";s:8:\"filesize\";s:5:\"22389\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-3.x-dev\";a:14:{s:4:\"name\";s:34:\"better_exposed_filters 7.x-3.x-dev\";s:7:\"version\";s:11:\"7.x-3.x-dev\";s:3:\"tag\";s:7:\"7.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:74:\"https://www.drupal.org/project/better_exposed_filters/releases/7.x-3.x-dev\";s:13:\"download_link\";s:79:\"https://ftp.drupal.org/files/projects/better_exposed_filters-7.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1485926583\";s:6:\"mdhash\";s:32:\"eb328686c9a2c6f536e0f937ae8d701a\";s:8:\"filesize\";s:5:\"51124\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:34:\"better_exposed_filters 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:74:\"https://www.drupal.org/project/better_exposed_filters/releases/7.x-1.x-dev\";s:13:\"download_link\";s:79:\"https://ftp.drupal.org/files/projects/better_exposed_filters-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380555926\";s:6:\"mdhash\";s:32:\"0ffdc1ce5f0cff0254ddbaf787ce930a\";s:8:\"filesize\";s:5:\"22828\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1500447548,1500361146,1),('available_releases::block_class','a:11:{s:5:\"title\";s:11:\"Block Class\";s:10:\"short_name\";s:11:\"block_class\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:42:\"https://www.drupal.org/project/block_class\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:11:{s:7:\"7.x-2.3\";a:14:{s:4:\"name\";s:19:\"block_class 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/block_class/releases/7.x-2.3\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/block_class-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1450415939\";s:6:\"mdhash\";s:32:\"286b7673faa2a067a9e96ee748331db9\";s:8:\"filesize\";s:5:\"12696\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:19:\"block_class 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/block_class/releases/7.x-2.2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/block_class-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1450293839\";s:6:\"mdhash\";s:32:\"9e382ab421c420b01c393be94b401ad9\";s:8:\"filesize\";s:5:\"12684\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:19:\"block_class 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/block_class/releases/7.x-2.1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/block_class-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1377197769\";s:6:\"mdhash\";s:32:\"cb57d269d45aabd8978c0a88b05b9eb3\";s:8:\"filesize\";s:5:\"11499\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:19:\"block_class 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/block_class/releases/7.x-2.0\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/block_class-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1362669357\";s:6:\"mdhash\";s:32:\"4c3afdc9b94f12d4a2fa6ab8eac2bae8\";s:8:\"filesize\";s:4:\"9421\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:19:\"block_class 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/block_class/releases/7.x-1.3\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/block_class-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1377198970\";s:6:\"mdhash\";s:32:\"393dbfad8a142c2ff7d348f30521a63f\";s:8:\"filesize\";s:5:\"11913\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:19:\"block_class 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/block_class/releases/7.x-1.2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/block_class-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1349301967\";s:6:\"mdhash\";s:32:\"30eff4c1392274a53680412e5784330b\";s:8:\"filesize\";s:4:\"8874\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:13:\"7.x-1.2-beta1\";a:15:{s:4:\"name\";s:25:\"block_class 7.x-1.2-beta1\";s:7:\"version\";s:13:\"7.x-1.2-beta1\";s:3:\"tag\";s:13:\"7.x-1.2-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/block_class/releases/7.x-1.2-beta1\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/block_class-7.x-1.2-beta1.tar.gz\";s:4:\"date\";s:10:\"1333059942\";s:6:\"mdhash\";s:32:\"d83eb9270022e9a3d6dc53ad102017d3\";s:8:\"filesize\";s:4:\"8873\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:19:\"block_class 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/block_class/releases/7.x-1.1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/block_class-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1331079937\";s:6:\"mdhash\";s:32:\"b466c130b0fc352d7bd2d434f294e6d6\";s:8:\"filesize\";s:4:\"8694\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:19:\"block_class 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/block_class/releases/7.x-1.0\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/block_class-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1318630894\";s:6:\"mdhash\";s:32:\"7659a7e3cfb4be20692a64b467a40310\";s:8:\"filesize\";s:4:\"8703\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:23:\"block_class 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/block_class/releases/7.x-2.x-dev\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/block_class-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1496362442\";s:6:\"mdhash\";s:32:\"8df84f57a2cf05072280b47904c3dfe4\";s:8:\"filesize\";s:5:\"13550\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:23:\"block_class 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/block_class/releases/7.x-1.x-dev\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/block_class-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380556302\";s:6:\"mdhash\";s:32:\"7419a6f4c1a002401da79a0f3291dd75\";s:8:\"filesize\";s:5:\"11922\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1500447549,1500361146,1),('available_releases::chosen','a:11:{s:5:\"title\";s:6:\"Chosen\";s:10:\"short_name\";s:6:\"chosen\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:37:\"https://www.drupal.org/project/chosen\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:13:{s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:14:\"chosen 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/chosen/releases/7.x-2.1\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/chosen-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1490260383\";s:6:\"mdhash\";s:32:\"ca17f21e5ce6e1697d369301704e70ab\";s:8:\"filesize\";s:5:\"15428\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:14:\"chosen 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/chosen/releases/7.x-2.0\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/chosen-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1476640739\";s:6:\"mdhash\";s:32:\"c0bb1b0a37db807c57cb533a4dbbc17a\";s:8:\"filesize\";s:5:\"15287\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:13:\"7.x-2.0-beta5\";a:15:{s:4:\"name\";s:20:\"chosen 7.x-2.0-beta5\";s:7:\"version\";s:13:\"7.x-2.0-beta5\";s:3:\"tag\";s:13:\"7.x-2.0-beta5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/chosen/releases/7.x-2.0-beta5\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/chosen-7.x-2.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1459939441\";s:6:\"mdhash\";s:32:\"fae42114eaeada4198deeedc35d960bb\";s:8:\"filesize\";s:5:\"14915\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta4\";a:15:{s:4:\"name\";s:20:\"chosen 7.x-2.0-beta4\";s:7:\"version\";s:13:\"7.x-2.0-beta4\";s:3:\"tag\";s:13:\"7.x-2.0-beta4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/chosen/releases/7.x-2.0-beta4\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/chosen-7.x-2.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1394256505\";s:6:\"mdhash\";s:32:\"08b424ba6640ef1ab8f1adff81e90ac6\";s:8:\"filesize\";s:5:\"14294\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta2\";a:15:{s:4:\"name\";s:20:\"chosen 7.x-2.0-beta2\";s:7:\"version\";s:13:\"7.x-2.0-beta2\";s:3:\"tag\";s:13:\"7.x-2.0-beta2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/chosen/releases/7.x-2.0-beta2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/chosen-7.x-2.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1394153305\";s:6:\"mdhash\";s:32:\"dd5a2bd9a4d75a5c1726c1735f432568\";s:8:\"filesize\";s:5:\"13476\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta1\";a:15:{s:4:\"name\";s:20:\"chosen 7.x-2.0-beta1\";s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:3:\"tag\";s:13:\"7.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/chosen/releases/7.x-2.0-beta1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/chosen-7.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1394120905\";s:6:\"mdhash\";s:32:\"1f481e331b6de881d624a9c162fe11a7\";s:8:\"filesize\";s:5:\"13390\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha4\";a:15:{s:4:\"name\";s:21:\"chosen 7.x-2.0-alpha4\";s:7:\"version\";s:14:\"7.x-2.0-alpha4\";s:3:\"tag\";s:14:\"7.x-2.0-alpha4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/chosen/releases/7.x-2.0-alpha4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/chosen-7.x-2.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1379598967\";s:6:\"mdhash\";s:32:\"dbeff0756d01bc335137a4c83455b44f\";s:8:\"filesize\";s:5:\"13421\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha3\";a:15:{s:4:\"name\";s:21:\"chosen 7.x-2.0-alpha3\";s:7:\"version\";s:14:\"7.x-2.0-alpha3\";s:3:\"tag\";s:14:\"7.x-2.0-alpha3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/chosen/releases/7.x-2.0-alpha3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/chosen-7.x-2.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1378478168\";s:6:\"mdhash\";s:32:\"0b927bd495e679dd256d403e1521b54d\";s:8:\"filesize\";s:5:\"13419\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha2\";a:15:{s:4:\"name\";s:21:\"chosen 7.x-2.0-alpha2\";s:7:\"version\";s:14:\"7.x-2.0-alpha2\";s:3:\"tag\";s:14:\"7.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/chosen/releases/7.x-2.0-alpha2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/chosen-7.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1368039911\";s:6:\"mdhash\";s:32:\"9d5dba3e27e93ea920fe5dd4e94fd5d0\";s:8:\"filesize\";s:5:\"10255\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:21:\"chosen 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/chosen/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/chosen-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1358504112\";s:6:\"mdhash\";s:32:\"420ac109b8761bf769c97c69154ff352\";s:8:\"filesize\";s:5:\"10308\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:14:\"chosen 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/chosen/releases/7.x-1.0\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/chosen-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1311684414\";s:6:\"mdhash\";s:32:\"3fbb7ba2bb7e2a8f684df0a7548cb743\";s:8:\"filesize\";s:4:\"7530\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:18:\"chosen 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/chosen/releases/7.x-2.x-dev\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/chosen-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1490607783\";s:6:\"mdhash\";s:32:\"a723666c04945af49f39ec3d6338ce43\";s:8:\"filesize\";s:5:\"16124\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:18:\"chosen 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/chosen/releases/7.x-1.x-dev\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/chosen-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380558355\";s:6:\"mdhash\";s:32:\"413920c0279bc44e65a19ed3cbc62eaa\";s:8:\"filesize\";s:4:\"9895\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1500447550,1500361146,1),('available_releases::ckeditor','a:11:{s:5:\"title\";s:30:\"CKEditor - WYSIWYG HTML editor\";s:10:\"short_name\";s:8:\"ckeditor\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:39:\"https://www.drupal.org/project/ckeditor\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:21:{s:8:\"7.x-1.18\";a:14:{s:4:\"name\";s:17:\"ckeditor 7.x-1.18\";s:7:\"version\";s:8:\"7.x-1.18\";s:3:\"tag\";s:8:\"7.x-1.18\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"18\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.18\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.18.tar.gz\";s:4:\"date\";s:10:\"1498506242\";s:6:\"mdhash\";s:32:\"c85049f6a351e6e72b8890f01325eed2\";s:8:\"filesize\";s:6:\"198098\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:8:\"7.x-1.17\";a:14:{s:4:\"name\";s:17:\"ckeditor 7.x-1.17\";s:7:\"version\";s:8:\"7.x-1.17\";s:3:\"tag\";s:8:\"7.x-1.17\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"17\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.17\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.17.tar.gz\";s:4:\"date\";s:10:\"1450969739\";s:6:\"mdhash\";s:32:\"af5cf266be662fb632034192658f451d\";s:8:\"filesize\";s:6:\"198195\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.16\";a:14:{s:4:\"name\";s:17:\"ckeditor 7.x-1.16\";s:7:\"version\";s:8:\"7.x-1.16\";s:3:\"tag\";s:8:\"7.x-1.16\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"16\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.16\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.16.tar.gz\";s:4:\"date\";s:10:\"1413311928\";s:6:\"mdhash\";s:32:\"b906e538201c88213415cecd6177b3c5\";s:8:\"filesize\";s:6:\"201743\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.15\";a:14:{s:4:\"name\";s:17:\"ckeditor 7.x-1.15\";s:7:\"version\";s:8:\"7.x-1.15\";s:3:\"tag\";s:8:\"7.x-1.15\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"15\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.15\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.15.tar.gz\";s:4:\"date\";s:10:\"1405436628\";s:6:\"mdhash\";s:32:\"7bedcb818fd336144f0b3ac7d056ef85\";s:8:\"filesize\";s:6:\"201891\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.14\";a:14:{s:4:\"name\";s:17:\"ckeditor 7.x-1.14\";s:7:\"version\";s:8:\"7.x-1.14\";s:3:\"tag\";s:8:\"7.x-1.14\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"14\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.14\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.14.tar.gz\";s:4:\"date\";s:10:\"1399546427\";s:6:\"mdhash\";s:32:\"146cc7306386b994fe281781f795c6dc\";s:8:\"filesize\";s:6:\"202031\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.13\";a:14:{s:4:\"name\";s:17:\"ckeditor 7.x-1.13\";s:7:\"version\";s:8:\"7.x-1.13\";s:3:\"tag\";s:8:\"7.x-1.13\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.13\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.13.tar.gz\";s:4:\"date\";s:10:\"1365759619\";s:6:\"mdhash\";s:32:\"e35e43b86694fcb04ea5c590834e9659\";s:8:\"filesize\";s:6:\"242724\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.12\";a:14:{s:4:\"name\";s:17:\"ckeditor 7.x-1.12\";s:7:\"version\";s:8:\"7.x-1.12\";s:3:\"tag\";s:8:\"7.x-1.12\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.12\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.12.tar.gz\";s:4:\"date\";s:10:\"1356180966\";s:6:\"mdhash\";s:32:\"95abc65d68a1bbfe8b87c3a3fa9ff427\";s:8:\"filesize\";s:6:\"241718\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.11\";a:14:{s:4:\"name\";s:17:\"ckeditor 7.x-1.11\";s:7:\"version\";s:8:\"7.x-1.11\";s:3:\"tag\";s:8:\"7.x-1.11\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.11\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.11.tar.gz\";s:4:\"date\";s:10:\"1355320857\";s:6:\"mdhash\";s:32:\"cff447953001b81497c64cd1a4fb9c48\";s:8:\"filesize\";s:6:\"241212\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.10\";a:14:{s:4:\"name\";s:17:\"ckeditor 7.x-1.10\";s:7:\"version\";s:8:\"7.x-1.10\";s:3:\"tag\";s:8:\"7.x-1.10\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.10\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.10.tar.gz\";s:4:\"date\";s:10:\"1355320262\";s:6:\"mdhash\";s:32:\"065fb6dd5309318abcf5249552bdb68a\";s:8:\"filesize\";s:6:\"297619\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.9\";a:14:{s:4:\"name\";s:16:\"ckeditor 7.x-1.9\";s:7:\"version\";s:7:\"7.x-1.9\";s:3:\"tag\";s:7:\"7.x-1.9\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.9\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.9.tar.gz\";s:4:\"date\";s:10:\"1334745697\";s:6:\"mdhash\";s:32:\"9ff722478310ae812d07028fa24998dd\";s:8:\"filesize\";s:6:\"176069\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.8\";a:14:{s:4:\"name\";s:16:\"ckeditor 7.x-1.8\";s:7:\"version\";s:7:\"7.x-1.8\";s:3:\"tag\";s:7:\"7.x-1.8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.8\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.8.tar.gz\";s:4:\"date\";s:10:\"1331818250\";s:6:\"mdhash\";s:32:\"ddf710374b698660dcf5bc8e7a954566\";s:8:\"filesize\";s:6:\"172815\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.7\";a:14:{s:4:\"name\";s:16:\"ckeditor 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.7\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1331747145\";s:6:\"mdhash\";s:32:\"cb2be6da12cb3fde798bbeb3f1a24707\";s:8:\"filesize\";s:6:\"172799\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:16:\"ckeditor 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.6\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1320880530\";s:6:\"mdhash\";s:32:\"e1f9df6492e157d12284f94dae5b9992\";s:8:\"filesize\";s:6:\"210606\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:16:\"ckeditor 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.5\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1320829232\";s:6:\"mdhash\";s:32:\"b04cc3539c6a53f6765aae48b1957644\";s:8:\"filesize\";s:6:\"268084\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:16:\"ckeditor 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.4\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1319630130\";s:6:\"mdhash\";s:32:\"d66cba130acc3ff05da2ef6fa30480f9\";s:8:\"filesize\";s:6:\"210061\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:16:\"ckeditor 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.3\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1314622318\";s:6:\"mdhash\";s:32:\"d94f7cfc922f2020039526bb329936a2\";s:8:\"filesize\";s:5:\"73228\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:16:\"ckeditor 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1306745815\";s:6:\"mdhash\";s:32:\"7df22e6f6d4666895d00d01134f5960a\";s:8:\"filesize\";s:5:\"93621\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:16:\"ckeditor 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1299757267\";s:6:\"mdhash\";s:32:\"b118af2ecd2936efc87bec95dacfbafe\";s:8:\"filesize\";s:5:\"87885\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:16:\"ckeditor 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.0\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1294949192\";s:6:\"mdhash\";s:32:\"f00a0235a70a052226f2db0d6a7c579c\";s:8:\"filesize\";s:6:\"142482\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:20:\"ckeditor 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1292444466\";s:6:\"mdhash\";s:32:\"942b796a636baec84229135cf03c6353\";s:8:\"filesize\";s:6:\"141641\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:20:\"ckeditor 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.x-dev\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1498863242\";s:6:\"mdhash\";s:32:\"ff0ca102a1cfd4aa870779d2a388ef56\";s:8:\"filesize\";s:6:\"198104\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1500447550,1500361146,1),('available_releases::cloud_zoom','a:11:{s:5:\"title\";s:10:\"Cloud Zoom\";s:10:\"short_name\";s:10:\"cloud_zoom\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:41:\"https://www.drupal.org/project/cloud_zoom\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:4:{s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:18:\"cloud_zoom 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/cloud_zoom/releases/7.x-1.1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/cloud_zoom-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1350401767\";s:6:\"mdhash\";s:32:\"ccc7a9024a8730a6b25a92bb2d2c0c8e\";s:8:\"filesize\";s:5:\"13186\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:13:\"7.x-1.1-beta1\";a:15:{s:4:\"name\";s:24:\"cloud_zoom 7.x-1.1-beta1\";s:7:\"version\";s:13:\"7.x-1.1-beta1\";s:3:\"tag\";s:13:\"7.x-1.1-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/cloud_zoom/releases/7.x-1.1-beta1\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/cloud_zoom-7.x-1.1-beta1.tar.gz\";s:4:\"date\";s:10:\"1350399667\";s:6:\"mdhash\";s:32:\"969ea3f7ec718072c00f1d6ab0359fb0\";s:8:\"filesize\";s:5:\"13185\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:18:\"cloud_zoom 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/cloud_zoom/releases/7.x-1.0\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/cloud_zoom-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1275685509\";s:6:\"mdhash\";s:32:\"86a5c69a942dffdb49b88246a1aedd33\";s:8:\"filesize\";s:4:\"7641\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:22:\"cloud_zoom 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/cloud_zoom/releases/7.x-1.x-dev\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/cloud_zoom-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380559093\";s:6:\"mdhash\";s:32:\"54b8262a90a5f37b0536ddb8585d5578\";s:8:\"filesize\";s:5:\"13196\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1500447551,1500361146,1),('available_releases::commerce','a:11:{s:5:\"title\";s:15:\"Drupal Commerce\";s:10:\"short_name\";s:8:\"commerce\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:39:\"https://www.drupal.org/project/commerce\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:27:{s:8:\"7.x-1.13\";a:14:{s:4:\"name\";s:17:\"commerce 7.x-1.13\";s:7:\"version\";s:8:\"7.x-1.13\";s:3:\"tag\";s:8:\"7.x-1.13\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/commerce/releases/7.x-1.13\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.13.tar.gz\";s:4:\"date\";s:10:\"1459956568\";s:6:\"mdhash\";s:32:\"32f60a3f4e7e08d8979be3c8beda49e2\";s:8:\"filesize\";s:6:\"381834\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.12\";a:14:{s:4:\"name\";s:17:\"commerce 7.x-1.12\";s:7:\"version\";s:8:\"7.x-1.12\";s:3:\"tag\";s:8:\"7.x-1.12\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/commerce/releases/7.x-1.12\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.12.tar.gz\";s:4:\"date\";s:10:\"1459831734\";s:6:\"mdhash\";s:32:\"398790375ddc2e1bde90fe38e2cd625a\";s:8:\"filesize\";s:6:\"381908\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.11\";a:14:{s:4:\"name\";s:17:\"commerce 7.x-1.11\";s:7:\"version\";s:8:\"7.x-1.11\";s:3:\"tag\";s:8:\"7.x-1.11\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/commerce/releases/7.x-1.11\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.11.tar.gz\";s:4:\"date\";s:10:\"1421426580\";s:6:\"mdhash\";s:32:\"948ab5d78a0ee7e23c28d3df8f585ab6\";s:8:\"filesize\";s:6:\"382099\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.10\";a:14:{s:4:\"name\";s:17:\"commerce 7.x-1.10\";s:7:\"version\";s:8:\"7.x-1.10\";s:3:\"tag\";s:8:\"7.x-1.10\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/commerce/releases/7.x-1.10\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.10.tar.gz\";s:4:\"date\";s:10:\"1410366832\";s:6:\"mdhash\";s:32:\"aad5b6bbdf089c6f3550b3f04fd8ca1e\";s:8:\"filesize\";s:6:\"381635\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";i:2;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.9\";a:14:{s:4:\"name\";s:16:\"commerce 7.x-1.9\";s:7:\"version\";s:7:\"7.x-1.9\";s:3:\"tag\";s:7:\"7.x-1.9\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/commerce/releases/7.x-1.9\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.9.tar.gz\";s:4:\"date\";s:10:\"1394061805\";s:6:\"mdhash\";s:32:\"1fa0211d155f7e75e3a57c1a6cbd63e9\";s:8:\"filesize\";s:6:\"378943\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.8\";a:14:{s:4:\"name\";s:16:\"commerce 7.x-1.8\";s:7:\"version\";s:7:\"7.x-1.8\";s:3:\"tag\";s:7:\"7.x-1.8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/commerce/releases/7.x-1.8\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.8.tar.gz\";s:4:\"date\";s:10:\"1374609068\";s:6:\"mdhash\";s:32:\"f1f8036c5dc006d641f504d2126ae4e7\";s:8:\"filesize\";s:6:\"369712\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.7\";a:14:{s:4:\"name\";s:16:\"commerce 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/commerce/releases/7.x-1.7\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1367298614\";s:6:\"mdhash\";s:32:\"bedfde3ae336892df9a433990b8fc77a\";s:8:\"filesize\";s:6:\"368250\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:16:\"commerce 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/commerce/releases/7.x-1.6\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1365633618\";s:6:\"mdhash\";s:32:\"951cd47b652aabd411e562c29ce7dbe4\";s:8:\"filesize\";s:6:\"368067\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:16:\"commerce 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/commerce/releases/7.x-1.5\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1360749320\";s:6:\"mdhash\";s:32:\"61f53b99d48441ef3f64a4a7e73981ac\";s:8:\"filesize\";s:6:\"366627\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:16:\"commerce 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/commerce/releases/7.x-1.4\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1350864676\";s:6:\"mdhash\";s:32:\"18bf64b33ecb54e91d38a840f563a879\";s:8:\"filesize\";s:6:\"363286\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:16:\"commerce 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/commerce/releases/7.x-1.3\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1336585865\";s:6:\"mdhash\";s:32:\"827c1fde0fa75a5bcea3bc10f2b2aadf\";s:8:\"filesize\";s:6:\"353698\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:16:\"commerce 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/commerce/releases/7.x-1.2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1327528840\";s:6:\"mdhash\";s:32:\"a7ac902711ce7c3e1722a015f41f2013\";s:8:\"filesize\";s:6:\"349147\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:12:\"New features\";i:2;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:16:\"commerce 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/commerce/releases/7.x-1.1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1322552155\";s:6:\"mdhash\";s:32:\"62942795e7c21e385631659ac241ea1b\";s:8:\"filesize\";s:6:\"328801\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:16:\"commerce 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/commerce/releases/7.x-1.0\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1314124616\";s:6:\"mdhash\";s:32:\"d4eb672998468ec255d8be694a4d3779\";s:8:\"filesize\";s:6:\"315114\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-1.0-rc3\";a:15:{s:4:\"name\";s:20:\"commerce 7.x-1.0-rc3\";s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:3:\"tag\";s:11:\"7.x-1.0-rc3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/commerce/releases/7.x-1.0-rc3\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1313076716\";s:6:\"mdhash\";s:32:\"925dfa96685e2cbed1b549b77a56ebb0\";s:8:\"filesize\";s:6:\"312390\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc2\";a:15:{s:4:\"name\";s:20:\"commerce 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/commerce/releases/7.x-1.0-rc2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1313037416\";s:6:\"mdhash\";s:32:\"6ba485c1fce1535f3b3e2957e616f394\";s:8:\"filesize\";s:6:\"312335\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:20:\"commerce 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/commerce/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1310664115\";s:6:\"mdhash\";s:32:\"c732e70e3e8f4a5e284c26bd4905ec4e\";s:8:\"filesize\";s:6:\"306038\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta4\";a:15:{s:4:\"name\";s:22:\"commerce 7.x-1.0-beta4\";s:7:\"version\";s:13:\"7.x-1.0-beta4\";s:3:\"tag\";s:13:\"7.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/commerce/releases/7.x-1.0-beta4\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1307772351\";s:6:\"mdhash\";s:32:\"afeee457f68ac8165e2d5ad22c5f75e0\";s:8:\"filesize\";s:6:\"289313\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta3\";a:15:{s:4:\"name\";s:22:\"commerce 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/commerce/releases/7.x-1.0-beta3\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1303540316\";s:6:\"mdhash\";s:32:\"e4da46e99b11fb772e386a0db242b5e2\";s:8:\"filesize\";s:6:\"279732\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:22:\"commerce 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/commerce/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1298816467\";s:6:\"mdhash\";s:32:\"f6d3fc0daeb3245edc1d9eddf1e0d457\";s:8:\"filesize\";s:6:\"257520\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:22:\"commerce 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/commerce/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1298529203\";s:6:\"mdhash\";s:32:\"3e435407de0b4f8d8c1d8fd33329e5cb\";s:8:\"filesize\";s:6:\"259881\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha5\";a:15:{s:4:\"name\";s:23:\"commerce 7.x-1.0-alpha5\";s:7:\"version\";s:14:\"7.x-1.0-alpha5\";s:3:\"tag\";s:14:\"7.x-1.0-alpha5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/commerce/releases/7.x-1.0-alpha5\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1296455786\";s:6:\"mdhash\";s:32:\"5dc5d375eedec0ffd7a6fd4d8fcdb102\";s:8:\"filesize\";s:6:\"216068\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha4\";a:15:{s:4:\"name\";s:23:\"commerce 7.x-1.0-alpha4\";s:7:\"version\";s:14:\"7.x-1.0-alpha4\";s:3:\"tag\";s:14:\"7.x-1.0-alpha4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/commerce/releases/7.x-1.0-alpha4\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1293329163\";s:6:\"mdhash\";s:32:\"d62fa017115ecc34b81f3e4fe5e0b3db\";s:8:\"filesize\";s:6:\"191023\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha3\";a:15:{s:4:\"name\";s:23:\"commerce 7.x-1.0-alpha3\";s:7:\"version\";s:14:\"7.x-1.0-alpha3\";s:3:\"tag\";s:14:\"7.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/commerce/releases/7.x-1.0-alpha3\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1289666774\";s:6:\"mdhash\";s:32:\"449fee374e9f9c2f2f350f9a77551222\";s:8:\"filesize\";s:6:\"180135\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:23:\"commerce 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/commerce/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1286608567\";s:6:\"mdhash\";s:32:\"092559792765f635bdd4f30fcc47329d\";s:8:\"filesize\";s:6:\"151878\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:23:\"commerce 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/commerce/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1282612007\";s:6:\"mdhash\";s:32:\"dd5151ef1f8053306be442dd2cf479cd\";s:8:\"filesize\";s:6:\"122724\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:20:\"commerce 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/commerce/releases/7.x-1.x-dev\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1498564442\";s:6:\"mdhash\";s:32:\"11caec0284d1c5089da3c6da02496244\";s:8:\"filesize\";s:6:\"384670\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1500447551,1500361146,1),('available_releases::commerce_cop','a:11:{s:5:\"title\";s:32:\"Commerce Custom Offline Payments\";s:10:\"short_name\";s:12:\"commerce_cop\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:43:\"https://www.drupal.org/project/commerce_cop\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:3:{s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:26:\"commerce_cop 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/commerce_cop/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/commerce_cop-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1409840628\";s:6:\"mdhash\";s:32:\"41dda03ad789f455b1423865ec9a055d\";s:8:\"filesize\";s:5:\"14778\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:26:\"commerce_cop 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/commerce_cop/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/commerce_cop-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1403782727\";s:6:\"mdhash\";s:32:\"d7e5cf28a917c9df23b7749afab1d0db\";s:8:\"filesize\";s:5:\"13594\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:24:\"commerce_cop 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/commerce_cop/releases/7.x-1.x-dev\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/commerce_cop-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1486632185\";s:6:\"mdhash\";s:32:\"1d1995c72d2e2f8ede78fa815c2e6fd5\";s:8:\"filesize\";s:5:\"15509\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}}}',1500447552,1500361146,1),('available_releases::commerce_fancy_attributes','a:11:{s:5:\"title\";s:25:\"Commerce Fancy Attributes\";s:10:\"short_name\";s:25:\"commerce_fancy_attributes\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:56:\"https://www.drupal.org/project/commerce_fancy_attributes\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:3:{s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:33:\"commerce_fancy_attributes 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:73:\"https://www.drupal.org/project/commerce_fancy_attributes/releases/7.x-1.0\";s:13:\"download_link\";s:78:\"https://ftp.drupal.org/files/projects/commerce_fancy_attributes-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1343752308\";s:6:\"mdhash\";s:32:\"80568b9ebde2cda08014713cb8d3fc48\";s:8:\"filesize\";s:5:\"10438\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:39:\"commerce_fancy_attributes 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:79:\"https://www.drupal.org/project/commerce_fancy_attributes/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:84:\"https://ftp.drupal.org/files/projects/commerce_fancy_attributes-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1338395455\";s:6:\"mdhash\";s:32:\"1ba6b34a15d8f489925fc5e3e58ca021\";s:8:\"filesize\";s:5:\"10326\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:37:\"commerce_fancy_attributes 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:77:\"https://www.drupal.org/project/commerce_fancy_attributes/releases/7.x-1.x-dev\";s:13:\"download_link\";s:82:\"https://ftp.drupal.org/files/projects/commerce_fancy_attributes-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1390229304\";s:6:\"mdhash\";s:32:\"a80e40db181dd2a16a29d0cb6d523f44\";s:8:\"filesize\";s:5:\"10436\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447552,1500361146,1),('available_releases::commerce_flat_rate','a:11:{s:5:\"title\";s:18:\"Commerce Flat Rate\";s:10:\"short_name\";s:18:\"commerce_flat_rate\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:49:\"https://www.drupal.org/project/commerce_flat_rate\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:3:{s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:32:\"commerce_flat_rate 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/commerce_flat_rate/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/commerce_flat_rate-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1353122757\";s:6:\"mdhash\";s:32:\"965294aaa0822400ddd41322f9b43cc5\";s:8:\"filesize\";s:5:\"12663\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:32:\"commerce_flat_rate 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/commerce_flat_rate/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/commerce_flat_rate-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1323921939\";s:6:\"mdhash\";s:32:\"1a81a8a678037806fabacbf9f2a45761\";s:8:\"filesize\";s:5:\"12650\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:30:\"commerce_flat_rate 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/commerce_flat_rate/releases/7.x-1.x-dev\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/commerce_flat_rate-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1440899043\";s:6:\"mdhash\";s:32:\"6d6020cc14147b79825b434c511b4b72\";s:8:\"filesize\";s:5:\"14242\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}}}',1500447553,1500361146,1),('available_releases::commerce_marketplace','a:11:{s:5:\"title\";s:20:\"Commerce-Marketplace\";s:10:\"short_name\";s:20:\"commerce_marketplace\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:51:\"https://www.drupal.org/project/commerce_marketplace\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:4:{s:13:\"7.x-1.0-beta3\";a:15:{s:4:\"name\";s:34:\"commerce_marketplace 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:74:\"https://www.drupal.org/project/commerce_marketplace/releases/7.x-1.0-beta3\";s:13:\"download_link\";s:79:\"https://ftp.drupal.org/files/projects/commerce_marketplace-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1408538028\";s:6:\"mdhash\";s:32:\"8a21fbe2566d2e5028830fba6947e392\";s:8:\"filesize\";s:5:\"56122\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:34:\"commerce_marketplace 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:74:\"https://www.drupal.org/project/commerce_marketplace/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:79:\"https://ftp.drupal.org/files/projects/commerce_marketplace-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1387558705\";s:6:\"mdhash\";s:32:\"5452dd6d9430fdff85efef5c90c5f51a\";s:8:\"filesize\";s:5:\"55681\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:34:\"commerce_marketplace 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:74:\"https://www.drupal.org/project/commerce_marketplace/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:79:\"https://ftp.drupal.org/files/projects/commerce_marketplace-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1384946606\";s:6:\"mdhash\";s:32:\"51d3283d18b70749229272f728ebba2b\";s:8:\"filesize\";s:5:\"55438\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:32:\"commerce_marketplace 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/commerce_marketplace/releases/7.x-1.x-dev\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/commerce_marketplace-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1460981939\";s:6:\"mdhash\";s:32:\"e997ec086211a380f1749489c8aac2b7\";s:8:\"filesize\";s:5:\"56761\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}}}',1500447553,1500361146,1),('available_releases::commerce_paypal','a:11:{s:5:\"title\";s:15:\"Commerce PayPal\";s:10:\"short_name\";s:15:\"commerce_paypal\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:46:\"https://www.drupal.org/project/commerce_paypal\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:10:{s:7:\"7.x-2.4\";a:14:{s:4:\"name\";s:23:\"commerce_paypal 7.x-2.4\";s:7:\"version\";s:7:\"7.x-2.4\";s:3:\"tag\";s:7:\"7.x-2.4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/commerce_paypal/releases/7.x-2.4\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/commerce_paypal-7.x-2.4.tar.gz\";s:4:\"date\";s:10:\"1497908942\";s:6:\"mdhash\";s:32:\"4d7129199d1d7efc162ae1eef7003c72\";s:8:\"filesize\";s:5:\"71951\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.3\";a:14:{s:4:\"name\";s:23:\"commerce_paypal 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/commerce_paypal/releases/7.x-2.3\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/commerce_paypal-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1389740905\";s:6:\"mdhash\";s:32:\"2679887b33842c2ab7b7a830cc963ad9\";s:8:\"filesize\";s:5:\"69460\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:23:\"commerce_paypal 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/commerce_paypal/releases/7.x-2.2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/commerce_paypal-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1379410934\";s:6:\"mdhash\";s:32:\"b91dabf9f87041753d85d0f1c2dc91e0\";s:8:\"filesize\";s:5:\"70177\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:23:\"commerce_paypal 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/commerce_paypal/releases/7.x-2.1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/commerce_paypal-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1379295700\";s:6:\"mdhash\";s:32:\"d84284794ac0fe0256bc2f129bdb612f\";s:8:\"filesize\";s:5:\"70303\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:23:\"commerce_paypal 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/commerce_paypal/releases/7.x-2.0\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/commerce_paypal-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1372479352\";s:6:\"mdhash\";s:32:\"46935ff9c2099391421948aeaa18475c\";s:8:\"filesize\";s:5:\"64858\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:13:\"7.x-2.0-beta1\";a:15:{s:4:\"name\";s:29:\"commerce_paypal 7.x-2.0-beta1\";s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:3:\"tag\";s:13:\"7.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/commerce_paypal/releases/7.x-2.0-beta1\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/commerce_paypal-7.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1360753518\";s:6:\"mdhash\";s:32:\"64bd53b26d4fcb2ed43e6a365eafd49f\";s:8:\"filesize\";s:5:\"63814\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:23:\"commerce_paypal 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/commerce_paypal/releases/7.x-1.0\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/commerce_paypal-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1355696805\";s:6:\"mdhash\";s:32:\"58eb5b1ad772a79eb5bfe0fe7dd671e3\";s:8:\"filesize\";s:5:\"29546\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:27:\"commerce_paypal 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/commerce_paypal/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/commerce_paypal-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1347157356\";s:6:\"mdhash\";s:32:\"5efd04e9dace7d2fe112d9061673b91d\";s:8:\"filesize\";s:5:\"29556\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:27:\"commerce_paypal 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/commerce_paypal/releases/7.x-2.x-dev\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/commerce_paypal-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1497908643\";s:6:\"mdhash\";s:32:\"1b6a8bcb14ded436f59294f4a35a1ca6\";s:8:\"filesize\";s:5:\"72053\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:27:\"commerce_paypal 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/commerce_paypal/releases/7.x-1.x-dev\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/commerce_paypal-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380560597\";s:6:\"mdhash\";s:32:\"0daf56e6792f156f4726376570718a3d\";s:8:\"filesize\";s:5:\"29564\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447553,1500361146,1),('available_releases::commerce_search_api','a:11:{s:5:\"title\";s:19:\"Commerce Search API\";s:10:\"short_name\";s:19:\"commerce_search_api\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:50:\"https://www.drupal.org/project/commerce_search_api\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:10:{s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:27:\"commerce_search_api 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/commerce_search_api/releases/7.x-1.6\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/commerce_search_api-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1468517339\";s:6:\"mdhash\";s:32:\"12a8be31646b2ab9cf1aba4551952570\";s:8:\"filesize\";s:5:\"14605\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:27:\"commerce_search_api 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/commerce_search_api/releases/7.x-1.5\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/commerce_search_api-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1468486439\";s:6:\"mdhash\";s:32:\"af7b97feeaf3491436d1a6f30aab415e\";s:8:\"filesize\";s:5:\"14630\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:27:\"commerce_search_api 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/commerce_search_api/releases/7.x-1.4\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/commerce_search_api-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1436974439\";s:6:\"mdhash\";s:32:\"da6cd45c3f56170ced1e805915692096\";s:8:\"filesize\";s:5:\"14604\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:27:\"commerce_search_api 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/commerce_search_api/releases/7.x-1.3\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/commerce_search_api-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1369929362\";s:6:\"mdhash\";s:32:\"82cd7af5509e3622d6f086196f337fdc\";s:8:\"filesize\";s:5:\"14498\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:27:\"commerce_search_api 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/commerce_search_api/releases/7.x-1.2\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/commerce_search_api-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1368798845\";s:6:\"mdhash\";s:32:\"3b5cea4e6e7a55a3a7d9c8d2f13877bd\";s:8:\"filesize\";s:5:\"14426\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:27:\"commerce_search_api 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/commerce_search_api/releases/7.x-1.1\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/commerce_search_api-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1363627216\";s:6:\"mdhash\";s:32:\"3c3e6fdc8225018864dc5f88884c7353\";s:8:\"filesize\";s:5:\"14017\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:27:\"commerce_search_api 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/commerce_search_api/releases/7.x-1.0\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/commerce_search_api-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1359136260\";s:6:\"mdhash\";s:32:\"15e87e0c03c1b6cd1b781ff0873fb696\";s:8:\"filesize\";s:5:\"12447\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-1.0-rc2\";a:15:{s:4:\"name\";s:31:\"commerce_search_api 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/commerce_search_api/releases/7.x-1.0-rc2\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/commerce_search_api-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1355829705\";s:6:\"mdhash\";s:32:\"a99cae3a150fb18382f21f95e433f3e8\";s:8:\"filesize\";s:5:\"12421\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:31:\"commerce_search_api 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/commerce_search_api/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/commerce_search_api-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1352138156\";s:6:\"mdhash\";s:32:\"65efe6071b56e6440db1c5b97a608780\";s:8:\"filesize\";s:5:\"11524\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:31:\"commerce_search_api 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/commerce_search_api/releases/7.x-1.x-dev\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/commerce_search_api-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1469690339\";s:6:\"mdhash\";s:32:\"034f026184bea148b842bf79865f23fe\";s:8:\"filesize\";s:5:\"14939\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447554,1500361146,1),('available_releases::commerce_shipping','a:11:{s:5:\"title\";s:17:\"Commerce Shipping\";s:10:\"short_name\";s:17:\"commerce_shipping\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:48:\"https://www.drupal.org/project/commerce_shipping\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:15:{s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:25:\"commerce_shipping 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/commerce_shipping/releases/7.x-2.2\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/commerce_shipping-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1428479881\";s:6:\"mdhash\";s:32:\"3593bd8d427417887c5ae5f1e0c5946f\";s:8:\"filesize\";s:5:\"32573\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:25:\"commerce_shipping 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/commerce_shipping/releases/7.x-2.1\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/commerce_shipping-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1392818305\";s:6:\"mdhash\";s:32:\"70ed43bdc696135029d3123aaa0de318\";s:8:\"filesize\";s:5:\"30739\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:25:\"commerce_shipping 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/commerce_shipping/releases/7.x-2.0\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/commerce_shipping-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1353011121\";s:6:\"mdhash\";s:32:\"ad99683eef61c418e9191704cf04e611\";s:8:\"filesize\";s:5:\"30908\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:13:\"7.x-2.0-beta1\";a:15:{s:4:\"name\";s:31:\"commerce_shipping 7.x-2.0-beta1\";s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:3:\"tag\";s:13:\"7.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/commerce_shipping/releases/7.x-2.0-beta1\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/commerce_shipping-7.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1323921638\";s:6:\"mdhash\";s:32:\"4cbb53b26a04529c9d3210f4d3c5f2ee\";s:8:\"filesize\";s:5:\"24838\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:25:\"commerce_shipping 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/commerce_shipping/releases/7.x-1.1\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/commerce_shipping-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1353011123\";s:6:\"mdhash\";s:32:\"0e08fdb0a8696c1003237a681a0feb1e\";s:8:\"filesize\";s:5:\"19289\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:25:\"commerce_shipping 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/commerce_shipping/releases/7.x-1.0\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/commerce_shipping-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1325348138\";s:6:\"mdhash\";s:32:\"5147c42fa6f5f2f60517d3d3d745a24d\";s:8:\"filesize\";s:5:\"20801\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-1.0-rc3\";a:15:{s:4:\"name\";s:29:\"commerce_shipping 7.x-1.0-rc3\";s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:3:\"tag\";s:11:\"7.x-1.0-rc3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/commerce_shipping/releases/7.x-1.0-rc3\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/commerce_shipping-7.x-1.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1322755238\";s:6:\"mdhash\";s:32:\"65445579628d7f05592be69b425e2a08\";s:8:\"filesize\";s:5:\"19005\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc2\";a:15:{s:4:\"name\";s:29:\"commerce_shipping 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/commerce_shipping/releases/7.x-1.0-rc2\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/commerce_shipping-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1320351030\";s:6:\"mdhash\";s:32:\"24d22abbb5fc8eb35017f7d371288676\";s:8:\"filesize\";s:5:\"18944\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:29:\"commerce_shipping 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/commerce_shipping/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/commerce_shipping-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1312659715\";s:6:\"mdhash\";s:32:\"659529c2fb52979f81b2e906d3dfff67\";s:8:\"filesize\";s:5:\"18615\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta4\";a:15:{s:4:\"name\";s:31:\"commerce_shipping 7.x-1.0-beta4\";s:7:\"version\";s:13:\"7.x-1.0-beta4\";s:3:\"tag\";s:13:\"7.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/commerce_shipping/releases/7.x-1.0-beta4\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/commerce_shipping-7.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1308175915\";s:6:\"mdhash\";s:32:\"2e97fc76e9f522fc94635defa1965ba6\";s:8:\"filesize\";s:5:\"20771\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta3\";a:15:{s:4:\"name\";s:31:\"commerce_shipping 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/commerce_shipping/releases/7.x-1.0-beta3\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/commerce_shipping-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1307962917\";s:6:\"mdhash\";s:32:\"2f6a98b568b188a4ffa3d225dfccc67c\";s:8:\"filesize\";s:5:\"16909\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:31:\"commerce_shipping 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/commerce_shipping/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/commerce_shipping-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1304181722\";s:6:\"mdhash\";s:32:\"c5e0d73ec9b49b2d7785d165413f049c\";s:8:\"filesize\";s:5:\"16819\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:31:\"commerce_shipping 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/commerce_shipping/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/commerce_shipping-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1298932267\";s:6:\"mdhash\";s:32:\"57616f8148c0998cf2b7bf1a410696e0\";s:8:\"filesize\";s:5:\"16251\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:29:\"commerce_shipping 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/commerce_shipping/releases/7.x-2.x-dev\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/commerce_shipping-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1477172339\";s:6:\"mdhash\";s:32:\"e1dc5c448b06fa9b38cf9cd256364bfd\";s:8:\"filesize\";s:5:\"32615\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:29:\"commerce_shipping 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/commerce_shipping/releases/7.x-1.x-dev\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/commerce_shipping-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380560845\";s:6:\"mdhash\";s:32:\"4537016356671d2a31d44c17c242037f\";s:8:\"filesize\";s:5:\"19296\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447554,1500361146,1),('available_releases::commerce_stock','a:11:{s:5:\"title\";s:14:\"Commerce Stock\";s:10:\"short_name\";s:14:\"commerce_stock\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:3:\"1,2\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:45:\"https://www.drupal.org/project/commerce_stock\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:19:{s:7:\"7.x-2.3\";a:14:{s:4:\"name\";s:22:\"commerce_stock 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/commerce_stock/releases/7.x-2.3\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/commerce_stock-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1459244641\";s:6:\"mdhash\";s:32:\"e386502f6fbdd30724375ef5348f2c6b\";s:8:\"filesize\";s:5:\"25781\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:22:\"commerce_stock 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/commerce_stock/releases/7.x-2.2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/commerce_stock-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1445253539\";s:6:\"mdhash\";s:32:\"6ebe78e212ceebb1709b42ebbd318b99\";s:8:\"filesize\";s:5:\"25048\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:22:\"commerce_stock 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/commerce_stock/releases/7.x-2.1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/commerce_stock-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1418323680\";s:6:\"mdhash\";s:32:\"b944d14f380b82a251b354b3ff678e97\";s:8:\"filesize\";s:5:\"24742\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:22:\"commerce_stock 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/commerce_stock/releases/7.x-2.0\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/commerce_stock-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1400182727\";s:6:\"mdhash\";s:32:\"4676868aad50f326695d28023b77c6f7\";s:8:\"filesize\";s:5:\"24611\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-2.0-rc1\";a:15:{s:4:\"name\";s:26:\"commerce_stock 7.x-2.0-rc1\";s:7:\"version\";s:11:\"7.x-2.0-rc1\";s:3:\"tag\";s:11:\"7.x-2.0-rc1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/commerce_stock/releases/7.x-2.0-rc1\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/commerce_stock-7.x-2.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1375728368\";s:6:\"mdhash\";s:32:\"112396c19181802bca48eadc81da3b1d\";s:8:\"filesize\";s:5:\"23065\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha4\";a:15:{s:4:\"name\";s:29:\"commerce_stock 7.x-2.0-alpha4\";s:7:\"version\";s:14:\"7.x-2.0-alpha4\";s:3:\"tag\";s:14:\"7.x-2.0-alpha4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/commerce_stock/releases/7.x-2.0-alpha4\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/commerce_stock-7.x-2.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1364835311\";s:6:\"mdhash\";s:32:\"12f48def9cee9ad10ba9567b150b3951\";s:8:\"filesize\";s:5:\"20384\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha3\";a:15:{s:4:\"name\";s:29:\"commerce_stock 7.x-2.0-alpha3\";s:7:\"version\";s:14:\"7.x-2.0-alpha3\";s:3:\"tag\";s:14:\"7.x-2.0-alpha3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/commerce_stock/releases/7.x-2.0-alpha3\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/commerce_stock-7.x-2.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1349810167\";s:6:\"mdhash\";s:32:\"dea134ea11e2d7656ab5493bac441716\";s:8:\"filesize\";s:5:\"19562\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha2\";a:15:{s:4:\"name\";s:29:\"commerce_stock 7.x-2.0-alpha2\";s:7:\"version\";s:14:\"7.x-2.0-alpha2\";s:3:\"tag\";s:14:\"7.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/commerce_stock/releases/7.x-2.0-alpha2\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/commerce_stock-7.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1342027883\";s:6:\"mdhash\";s:32:\"e2f8ed25dd136b1293076923c6d65bab\";s:8:\"filesize\";s:5:\"18337\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:29:\"commerce_stock 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/commerce_stock/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/commerce_stock-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1334254247\";s:6:\"mdhash\";s:32:\"1ef334084db5db46ac0d2a73da3adfa5\";s:8:\"filesize\";s:5:\"18318\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:22:\"commerce_stock 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/commerce_stock/releases/7.x-1.2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/commerce_stock-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1368972613\";s:6:\"mdhash\";s:32:\"88eaaaec53555df8b4ab4ff2a8efe899\";s:8:\"filesize\";s:5:\"15648\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:22:\"commerce_stock 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/commerce_stock/releases/7.x-1.1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/commerce_stock-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1342028183\";s:6:\"mdhash\";s:32:\"b13bacc02b9cdffac8ca071477c233b4\";s:8:\"filesize\";s:5:\"15590\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:22:\"commerce_stock 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/commerce_stock/releases/7.x-1.0\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/commerce_stock-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1339940479\";s:6:\"mdhash\";s:32:\"fda865ec3200dbbc2c2572be34e12129\";s:8:\"filesize\";s:5:\"15590\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.0-rc2\";a:15:{s:4:\"name\";s:26:\"commerce_stock 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/commerce_stock/releases/7.x-1.0-rc2\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/commerce_stock-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1330610742\";s:6:\"mdhash\";s:32:\"81e48aa5f52b0b095f88f86d00b285fa\";s:8:\"filesize\";s:5:\"15272\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:26:\"commerce_stock 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/commerce_stock/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/commerce_stock-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1319136930\";s:6:\"mdhash\";s:32:\"c79fff6ff43abf4d93f71a9830d98d98\";s:8:\"filesize\";s:5:\"14736\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha3\";a:15:{s:4:\"name\";s:29:\"commerce_stock 7.x-1.0-alpha3\";s:7:\"version\";s:14:\"7.x-1.0-alpha3\";s:3:\"tag\";s:14:\"7.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/commerce_stock/releases/7.x-1.0-alpha3\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/commerce_stock-7.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1311871015\";s:6:\"mdhash\";s:32:\"1a2110767f56961baeb8c1ee3ba527eb\";s:8:\"filesize\";s:5:\"12497\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:29:\"commerce_stock 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/commerce_stock/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/commerce_stock-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1308694316\";s:6:\"mdhash\";s:32:\"192afb85cf4933154fe61631b961cf9e\";s:8:\"filesize\";s:5:\"11885\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:29:\"commerce_stock 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/commerce_stock/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/commerce_stock-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1303913215\";s:6:\"mdhash\";s:32:\"5d290014e653f2778df24d58a65ab8f2\";s:8:\"filesize\";s:5:\"11658\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:26:\"commerce_stock 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/commerce_stock/releases/7.x-2.x-dev\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/commerce_stock-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1478610239\";s:6:\"mdhash\";s:32:\"7efdd6c7bae55dd48fb663c62b4e44ad\";s:8:\"filesize\";s:5:\"25779\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:26:\"commerce_stock 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/commerce_stock/releases/7.x-1.x-dev\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/commerce_stock-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380560898\";s:6:\"mdhash\";s:32:\"2a5daf2350ddf3f95496d32422b57dbf\";s:8:\"filesize\";s:5:\"15659\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447555,1500361146,1),('available_releases::context','a:11:{s:5:\"title\";s:7:\"Context\";s:10:\"short_name\";s:7:\"context\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"3\";s:16:\"supported_majors\";s:1:\"3\";s:13:\"default_major\";s:1:\"3\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:38:\"https://www.drupal.org/project/context\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:20:{s:7:\"7.x-3.7\";a:14:{s:4:\"name\";s:15:\"context 7.x-3.7\";s:7:\"version\";s:7:\"7.x-3.7\";s:3:\"tag\";s:7:\"7.x-3.7\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/context/releases/7.x-3.7\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/context-7.x-3.7.tar.gz\";s:4:\"date\";s:10:\"1463605439\";s:6:\"mdhash\";s:32:\"7486753eef5a1496a3aa79ce7f168124\";s:8:\"filesize\";s:5:\"74779\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-3.6\";a:14:{s:4:\"name\";s:15:\"context 7.x-3.6\";s:7:\"version\";s:7:\"7.x-3.6\";s:3:\"tag\";s:7:\"7.x-3.6\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/context/releases/7.x-3.6\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/context-7.x-3.6.tar.gz\";s:4:\"date\";s:10:\"1420570680\";s:6:\"mdhash\";s:32:\"74894fd36de656fd00dcd5f0cf4bd7b0\";s:8:\"filesize\";s:5:\"74029\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-3.5\";a:14:{s:4:\"name\";s:15:\"context 7.x-3.5\";s:7:\"version\";s:7:\"7.x-3.5\";s:3:\"tag\";s:7:\"7.x-3.5\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/context/releases/7.x-3.5\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/context-7.x-3.5.tar.gz\";s:4:\"date\";s:10:\"1418341070\";s:6:\"mdhash\";s:32:\"9946cd622ba584de05597d85c2d70903\";s:8:\"filesize\";s:5:\"74008\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-3.4\";a:14:{s:4:\"name\";s:15:\"context 7.x-3.4\";s:7:\"version\";s:7:\"7.x-3.4\";s:3:\"tag\";s:7:\"7.x-3.4\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/context/releases/7.x-3.4\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/context-7.x-3.4.tar.gz\";s:4:\"date\";s:10:\"1418330580\";s:6:\"mdhash\";s:32:\"c253abf7fee5787934c2f2f6fecf3d0c\";s:8:\"filesize\";s:5:\"74019\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-3.3\";a:14:{s:4:\"name\";s:15:\"context 7.x-3.3\";s:7:\"version\";s:7:\"7.x-3.3\";s:3:\"tag\";s:7:\"7.x-3.3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/context/releases/7.x-3.3\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/context-7.x-3.3.tar.gz\";s:4:\"date\";s:10:\"1412114933\";s:6:\"mdhash\";s:32:\"6da85f017a673e57152d0e0b6fe9082f\";s:8:\"filesize\";s:5:\"73996\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-3.2\";a:14:{s:4:\"name\";s:15:\"context 7.x-3.2\";s:7:\"version\";s:7:\"7.x-3.2\";s:3:\"tag\";s:7:\"7.x-3.2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/context/releases/7.x-3.2\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/context-7.x-3.2.tar.gz\";s:4:\"date\";s:10:\"1390931305\";s:6:\"mdhash\";s:32:\"a9ee5d6eb6c1d7980f4834788e5e20f0\";s:8:\"filesize\";s:5:\"72655\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-3.1\";a:14:{s:4:\"name\";s:15:\"context 7.x-3.1\";s:7:\"version\";s:7:\"7.x-3.1\";s:3:\"tag\";s:7:\"7.x-3.1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/context/releases/7.x-3.1\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/context-7.x-3.1.tar.gz\";s:4:\"date\";s:10:\"1381976667\";s:6:\"mdhash\";s:32:\"0211b9782b18364623ac044f1aa39295\";s:8:\"filesize\";s:5:\"71341\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-3.0\";a:14:{s:4:\"name\";s:15:\"context 7.x-3.0\";s:7:\"version\";s:7:\"7.x-3.0\";s:3:\"tag\";s:7:\"7.x-3.0\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/context/releases/7.x-3.0\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/context-7.x-3.0.tar.gz\";s:4:\"date\";s:10:\"1381891268\";s:6:\"mdhash\";s:32:\"4522891bcd393c93f0c00e396fc57d2d\";s:8:\"filesize\";s:5:\"71536\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-3.0-rc1\";a:15:{s:4:\"name\";s:19:\"context 7.x-3.0-rc1\";s:7:\"version\";s:11:\"7.x-3.0-rc1\";s:3:\"tag\";s:11:\"7.x-3.0-rc1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/context/releases/7.x-3.0-rc1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/context-7.x-3.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1380221057\";s:6:\"mdhash\";s:32:\"82c6b89c04b1bf7dc7936da6cb5a68f3\";s:8:\"filesize\";s:5:\"71377\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta7\";a:15:{s:4:\"name\";s:21:\"context 7.x-3.0-beta7\";s:7:\"version\";s:13:\"7.x-3.0-beta7\";s:3:\"tag\";s:13:\"7.x-3.0-beta7\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/context/releases/7.x-3.0-beta7\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/context-7.x-3.0-beta7.tar.gz\";s:4:\"date\";s:10:\"1375065368\";s:6:\"mdhash\";s:32:\"098f672a1a9deff4d02af98c8cfe7314\";s:8:\"filesize\";s:5:\"71132\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta6\";a:15:{s:4:\"name\";s:21:\"context 7.x-3.0-beta6\";s:7:\"version\";s:13:\"7.x-3.0-beta6\";s:3:\"tag\";s:13:\"7.x-3.0-beta6\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/context/releases/7.x-3.0-beta6\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/context-7.x-3.0-beta6.tar.gz\";s:4:\"date\";s:10:\"1355879811\";s:6:\"mdhash\";s:32:\"1fb886ef64dcbf2a1d6baedae3516ccc\";s:8:\"filesize\";s:5:\"70788\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta5\";a:15:{s:4:\"name\";s:21:\"context 7.x-3.0-beta5\";s:7:\"version\";s:13:\"7.x-3.0-beta5\";s:3:\"tag\";s:13:\"7.x-3.0-beta5\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/context/releases/7.x-3.0-beta5\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/context-7.x-3.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1354819308\";s:6:\"mdhash\";s:32:\"7c0e563c681fbf716b7237181dd3b820\";s:8:\"filesize\";s:5:\"70554\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta4\";a:15:{s:4:\"name\";s:21:\"context 7.x-3.0-beta4\";s:7:\"version\";s:13:\"7.x-3.0-beta4\";s:3:\"tag\";s:13:\"7.x-3.0-beta4\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/context/releases/7.x-3.0-beta4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/context-7.x-3.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1344786407\";s:6:\"mdhash\";s:32:\"a8cb1ff2d756fb28c2867efaf02f5a27\";s:8:\"filesize\";s:5:\"64762\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta3\";a:15:{s:4:\"name\";s:21:\"context 7.x-3.0-beta3\";s:7:\"version\";s:13:\"7.x-3.0-beta3\";s:3:\"tag\";s:13:\"7.x-3.0-beta3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/context/releases/7.x-3.0-beta3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/context-7.x-3.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1337490056\";s:6:\"mdhash\";s:32:\"9d3e3844698e647061d43cbab2c1b05a\";s:8:\"filesize\";s:5:\"66729\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta2\";a:15:{s:4:\"name\";s:21:\"context 7.x-3.0-beta2\";s:7:\"version\";s:13:\"7.x-3.0-beta2\";s:3:\"tag\";s:13:\"7.x-3.0-beta2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/context/releases/7.x-3.0-beta2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/context-7.x-3.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1315543301\";s:6:\"mdhash\";s:32:\"c10187dbe386e3c3b12235efb83c4455\";s:8:\"filesize\";s:5:\"65147\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta1\";a:15:{s:4:\"name\";s:21:\"context 7.x-3.0-beta1\";s:7:\"version\";s:13:\"7.x-3.0-beta1\";s:3:\"tag\";s:13:\"7.x-3.0-beta1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/context/releases/7.x-3.0-beta1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/context-7.x-3.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1298925068\";s:6:\"mdhash\";s:32:\"0707f1af392f0bf1cd210a8e638c9de6\";s:8:\"filesize\";s:5:\"63804\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-3.0-alpha3\";a:15:{s:4:\"name\";s:22:\"context 7.x-3.0-alpha3\";s:7:\"version\";s:14:\"7.x-3.0-alpha3\";s:3:\"tag\";s:14:\"7.x-3.0-alpha3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/context/releases/7.x-3.0-alpha3\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/context-7.x-3.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1294089953\";s:6:\"mdhash\";s:32:\"38dd5fc8aef952598f4ef6420addc3b3\";s:8:\"filesize\";s:5:\"63251\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-3.0-alpha2\";a:15:{s:4:\"name\";s:22:\"context 7.x-3.0-alpha2\";s:7:\"version\";s:14:\"7.x-3.0-alpha2\";s:3:\"tag\";s:14:\"7.x-3.0-alpha2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/context/releases/7.x-3.0-alpha2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/context-7.x-3.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1285617662\";s:6:\"mdhash\";s:32:\"e6df800804a2f30da2eb939ef298b033\";s:8:\"filesize\";s:5:\"63205\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-3.0-alpha1\";a:15:{s:4:\"name\";s:22:\"context 7.x-3.0-alpha1\";s:7:\"version\";s:14:\"7.x-3.0-alpha1\";s:3:\"tag\";s:14:\"7.x-3.0-alpha1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/context/releases/7.x-3.0-alpha1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/context-7.x-3.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1284683161\";s:6:\"mdhash\";s:32:\"083993e65701c32d428e2c7e15047b65\";s:8:\"filesize\";s:5:\"62143\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-3.x-dev\";a:14:{s:4:\"name\";s:19:\"context 7.x-3.x-dev\";s:7:\"version\";s:11:\"7.x-3.x-dev\";s:3:\"tag\";s:7:\"7.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/context/releases/7.x-3.x-dev\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/context-7.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1465425842\";s:6:\"mdhash\";s:32:\"6920e8b538b8e529bd0cd8dbe85c0143\";s:8:\"filesize\";s:5:\"74787\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447555,1500361146,1),('available_releases::countries','a:11:{s:5:\"title\";s:9:\"Countries\";s:10:\"short_name\";s:9:\"countries\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:3:\"1,2\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:40:\"https://www.drupal.org/project/countries\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:9:{s:7:\"7.x-2.3\";a:14:{s:4:\"name\";s:17:\"countries 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/countries/releases/7.x-2.3\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/countries-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1409450928\";s:6:\"mdhash\";s:32:\"11fa9b845c3e4e63cb46d6398f54b3cb\";s:8:\"filesize\";s:5:\"56688\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:17:\"countries 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/countries/releases/7.x-2.2\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/countries-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1409235528\";s:6:\"mdhash\";s:32:\"5b86dfbc784fa9dc80e7059919e89d7d\";s:8:\"filesize\";s:5:\"56634\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:17:\"countries 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/countries/releases/7.x-2.1\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/countries-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1352904057\";s:6:\"mdhash\";s:32:\"7282cbafe5b55a32cb8568dc37fde243\";s:8:\"filesize\";s:5:\"53726\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:17:\"countries 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/countries/releases/7.x-2.0\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/countries-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1336135255\";s:6:\"mdhash\";s:32:\"cf0104a6511b2bf14be4fb2a9fc765c5\";s:8:\"filesize\";s:5:\"52398\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:13:\"7.x-2.0-beta2\";a:15:{s:4:\"name\";s:23:\"countries 7.x-2.0-beta2\";s:7:\"version\";s:13:\"7.x-2.0-beta2\";s:3:\"tag\";s:13:\"7.x-2.0-beta2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/countries/releases/7.x-2.0-beta2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/countries-7.x-2.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1316788302\";s:6:\"mdhash\";s:32:\"a8d44cb7a0aedc83670568b14511c50c\";s:8:\"filesize\";s:5:\"33775\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta1\";a:15:{s:4:\"name\";s:23:\"countries 7.x-2.0-beta1\";s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:3:\"tag\";s:13:\"7.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/countries/releases/7.x-2.0-beta1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/countries-7.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1304110315\";s:6:\"mdhash\";s:32:\"927f5176b74518216135d90f59165b0a\";s:8:\"filesize\";s:5:\"29093\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:17:\"countries 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/countries/releases/7.x-1.0\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/countries-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1297289557\";s:6:\"mdhash\";s:32:\"a127c75048c52df2a9f6e27770898c9e\";s:8:\"filesize\";s:5:\"22430\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:21:\"countries 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/countries/releases/7.x-2.x-dev\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/countries-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1434558480\";s:6:\"mdhash\";s:32:\"ae173ce5e7951aadf042089da094d497\";s:8:\"filesize\";s:5:\"56963\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:21:\"countries 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:6:\"master\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/countries/releases/7.x-1.x-dev\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/countries-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380567774\";s:6:\"mdhash\";s:32:\"881200e92dc620f8d47a6d584c9cdd11\";s:8:\"filesize\";s:5:\"27179\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1500447556,1500361146,1),('available_releases::ctools','a:11:{s:5:\"title\";s:25:\"Chaos tool suite (ctools)\";s:10:\"short_name\";s:6:\"ctools\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:37:\"https://www.drupal.org/project/ctools\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:22:{s:8:\"7.x-1.12\";a:14:{s:4:\"name\";s:15:\"ctools 7.x-1.12\";s:7:\"version\";s:8:\"7.x-1.12\";s:3:\"tag\";s:8:\"7.x-1.12\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/ctools/releases/7.x-1.12\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.12.tar.gz\";s:4:\"date\";s:10:\"1479787142\";s:6:\"mdhash\";s:32:\"daae0be22830e34c4d952f91557ae5a5\";s:8:\"filesize\";s:6:\"433707\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.11\";a:14:{s:4:\"name\";s:15:\"ctools 7.x-1.11\";s:7:\"version\";s:8:\"7.x-1.11\";s:3:\"tag\";s:8:\"7.x-1.11\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/ctools/releases/7.x-1.11\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.11.tar.gz\";s:4:\"date\";s:10:\"1476581639\";s:6:\"mdhash\";s:32:\"271d08d18f3c05f51aba1ad77d42f96c\";s:8:\"filesize\";s:6:\"432144\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.10\";a:14:{s:4:\"name\";s:15:\"ctools 7.x-1.10\";s:7:\"version\";s:8:\"7.x-1.10\";s:3:\"tag\";s:8:\"7.x-1.10\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/ctools/releases/7.x-1.10\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.10.tar.gz\";s:4:\"date\";s:10:\"1471454080\";s:6:\"mdhash\";s:32:\"38bb47304f6dcd0bcd6b02ed6ee235fc\";s:8:\"filesize\";s:6:\"430198\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.9\";a:14:{s:4:\"name\";s:14:\"ctools 7.x-1.9\";s:7:\"version\";s:7:\"7.x-1.9\";s:3:\"tag\";s:7:\"7.x-1.9\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/ctools/releases/7.x-1.9\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.9.tar.gz\";s:4:\"date\";s:10:\"1440019139\";s:6:\"mdhash\";s:32:\"bd7b5dac915e8fa3da909379807ef824\";s:8:\"filesize\";s:6:\"429330\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.8\";a:14:{s:4:\"name\";s:14:\"ctools 7.x-1.8\";s:7:\"version\";s:7:\"7.x-1.8\";s:3:\"tag\";s:7:\"7.x-1.8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/ctools/releases/7.x-1.8\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.8.tar.gz\";s:4:\"date\";s:10:\"1440015839\";s:6:\"mdhash\";s:32:\"629f8bc414026864fe4a235b62586e0c\";s:8:\"filesize\";s:6:\"428252\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.7\";a:14:{s:4:\"name\";s:14:\"ctools 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/ctools/releases/7.x-1.7\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1426695781\";s:6:\"mdhash\";s:32:\"81ab507b12875b02b88a0492d1173b99\";s:8:\"filesize\";s:6:\"426463\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:14:\"ctools 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/ctools/releases/7.x-1.6\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1422471481\";s:6:\"mdhash\";s:32:\"e8999d5bd1748ee3dcd4fdc33a24c615\";s:8:\"filesize\";s:6:\"424622\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-1.6-rc1\";a:15:{s:4:\"name\";s:18:\"ctools 7.x-1.6-rc1\";s:7:\"version\";s:11:\"7.x-1.6-rc1\";s:3:\"tag\";s:11:\"7.x-1.6-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/ctools/releases/7.x-1.6-rc1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.6-rc1.tar.gz\";s:4:\"date\";s:10:\"1418961480\";s:6:\"mdhash\";s:32:\"f3dc80ff7f3e29c73870f26a6ad02ff7\";s:8:\"filesize\";s:6:\"422180\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:14:\"ctools 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/ctools/releases/7.x-1.5\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1416423482\";s:6:\"mdhash\";s:32:\"0e90d8baaae78d3c37fe73dbe0d98dac\";s:8:\"filesize\";s:6:\"417508\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:14:\"ctools 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/ctools/releases/7.x-1.4\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1392220719\";s:6:\"mdhash\";s:32:\"df1ce5aeb6a9a5c383d944a2a7494f18\";s:8:\"filesize\";s:6:\"415678\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";i:2;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:14:\"ctools 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/ctools/releases/7.x-1.3\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1365013512\";s:6:\"mdhash\";s:32:\"b27a7230f63a7a81db8cc480ab2dba63\";s:8:\"filesize\";s:6:\"413477\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:14:\"ctools 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/ctools/releases/7.x-1.2\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1345319204\";s:6:\"mdhash\";s:32:\"62fa855ee8aced1e355b09ac6cd54e99\";s:8:\"filesize\";s:6:\"407345\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:14:\"ctools 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/ctools/releases/7.x-1.1\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1344463011\";s:6:\"mdhash\";s:32:\"c36cbb2fd7a6eb8b3245c13972380bd7\";s:8:\"filesize\";s:6:\"405567\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:14:\"ctools 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/ctools/releases/7.x-1.0\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1332962446\";s:6:\"mdhash\";s:32:\"642eca364e64b0074e5ad49f86627ac5\";s:8:\"filesize\";s:6:\"402254\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-1.0-rc2\";a:15:{s:4:\"name\";s:18:\"ctools 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/ctools/releases/7.x-1.0-rc2\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1332017742\";s:6:\"mdhash\";s:32:\"791167a47cea014fad9018c93376aa88\";s:8:\"filesize\";s:6:\"396440\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:18:\"ctools 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/ctools/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1311894415\";s:6:\"mdhash\";s:32:\"39bcea671210505409e3148c8eaefc0e\";s:8:\"filesize\";s:6:\"381078\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:20:\"ctools 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/ctools/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1306885315\";s:6:\"mdhash\";s:32:\"96d8154bfab611eb59cbd3774aa94793\";s:8:\"filesize\";s:6:\"378287\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha4\";a:15:{s:4:\"name\";s:21:\"ctools 7.x-1.0-alpha4\";s:7:\"version\";s:14:\"7.x-1.0-alpha4\";s:3:\"tag\";s:14:\"7.x-1.0-alpha4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/ctools/releases/7.x-1.0-alpha4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1301099792\";s:6:\"mdhash\";s:32:\"774f6654c149f192b11b136a06be5544\";s:8:\"filesize\";s:6:\"370763\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha3\";a:15:{s:4:\"name\";s:21:\"ctools 7.x-1.0-alpha3\";s:7:\"version\";s:14:\"7.x-1.0-alpha3\";s:3:\"tag\";s:14:\"7.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/ctools/releases/7.x-1.0-alpha3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1300395967\";s:6:\"mdhash\";s:32:\"1909846a7bd5775c99331c6564ffefa8\";s:8:\"filesize\";s:6:\"370238\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:21:\"ctools 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/ctools/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1294276865\";s:6:\"mdhash\";s:32:\"30e0f5cb27949d2cd67b80bb36701d3e\";s:8:\"filesize\";s:6:\"521068\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:21:\"ctools 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/ctools/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1286838960\";s:6:\"mdhash\";s:32:\"500a55a33f90b2bab865753a0d8c5439\";s:8:\"filesize\";s:6:\"510384\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:18:\"ctools 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/ctools/releases/7.x-1.x-dev\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1487053684\";s:6:\"mdhash\";s:32:\"149a825138993bde410a2cb823a716c2\";s:8:\"filesize\";s:6:\"440513\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447557,1500361146,1),('available_releases::custom_breadcrumbs','a:11:{s:5:\"title\";s:18:\"Custom Breadcrumbs\";s:10:\"short_name\";s:18:\"custom_breadcrumbs\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:3:\"1,2\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:49:\"https://www.drupal.org/project/custom_breadcrumbs\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:7:{s:13:\"7.x-2.0-beta1\";a:15:{s:4:\"name\";s:32:\"custom_breadcrumbs 7.x-2.0-beta1\";s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:3:\"tag\";s:13:\"7.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/custom_breadcrumbs/releases/7.x-2.0-beta1\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/custom_breadcrumbs-7.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1410287331\";s:6:\"mdhash\";s:32:\"422763aa0261af320ad75d30b9284ca1\";s:8:\"filesize\";s:5:\"56939\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"7.x-2.0-alpha3\";a:15:{s:4:\"name\";s:33:\"custom_breadcrumbs 7.x-2.0-alpha3\";s:7:\"version\";s:14:\"7.x-2.0-alpha3\";s:3:\"tag\";s:14:\"7.x-2.0-alpha3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:73:\"https://www.drupal.org/project/custom_breadcrumbs/releases/7.x-2.0-alpha3\";s:13:\"download_link\";s:78:\"https://ftp.drupal.org/files/projects/custom_breadcrumbs-7.x-2.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1353872502\";s:6:\"mdhash\";s:32:\"fa6f55a3827758727d6005eb9555095c\";s:8:\"filesize\";s:5:\"57499\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"7.x-2.0-alpha2\";a:15:{s:4:\"name\";s:33:\"custom_breadcrumbs 7.x-2.0-alpha2\";s:7:\"version\";s:14:\"7.x-2.0-alpha2\";s:3:\"tag\";s:14:\"7.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:73:\"https://www.drupal.org/project/custom_breadcrumbs/releases/7.x-2.0-alpha2\";s:13:\"download_link\";s:78:\"https://ftp.drupal.org/files/projects/custom_breadcrumbs-7.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1353732105\";s:6:\"mdhash\";s:32:\"70a8d1b66365fc3605b88272af832ccc\";s:8:\"filesize\";s:5:\"57358\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:33:\"custom_breadcrumbs 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:73:\"https://www.drupal.org/project/custom_breadcrumbs/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:78:\"https://ftp.drupal.org/files/projects/custom_breadcrumbs-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1353713204\";s:6:\"mdhash\";s:32:\"f5dd238e0c9e99ddd1488b506185c71e\";s:8:\"filesize\";s:5:\"57178\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:33:\"custom_breadcrumbs 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:73:\"https://www.drupal.org/project/custom_breadcrumbs/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:78:\"https://ftp.drupal.org/files/projects/custom_breadcrumbs-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1294601540\";s:6:\"mdhash\";s:32:\"1e8e3793a8903efe5e0905ad0c04ea3b\";s:8:\"filesize\";s:5:\"10750\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:30:\"custom_breadcrumbs 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/custom_breadcrumbs/releases/7.x-2.x-dev\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/custom_breadcrumbs-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1500043142\";s:6:\"mdhash\";s:32:\"ca4636b14cfb531e00362680b4e425d0\";s:8:\"filesize\";s:5:\"57756\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:30:\"custom_breadcrumbs 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/custom_breadcrumbs/releases/7.x-1.x-dev\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/custom_breadcrumbs-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380568433\";s:6:\"mdhash\";s:32:\"2d9bf4a2f248e53da3dac8f387292946\";s:8:\"filesize\";s:5:\"12896\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}}}',1500447558,1500361146,1),('available_releases::devel','a:11:{s:5:\"title\";s:5:\"Devel\";s:10:\"short_name\";s:5:\"devel\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:36:\"https://www.drupal.org/project/devel\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:11:{s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:13:\"devel 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/devel/releases/7.x-1.5\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/devel-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1398963228\";s:6:\"mdhash\";s:32:\"f06c912eb4edbd48fbcc2867516726a3\";s:8:\"filesize\";s:6:\"193378\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:13:\"devel 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/devel/releases/7.x-1.4\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/devel-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1391635405\";s:6:\"mdhash\";s:32:\"bfdea9f0eee5dea87c8a1828fdd2f092\";s:8:\"filesize\";s:6:\"193388\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:13:\"devel 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/devel/releases/7.x-1.3\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/devel-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1338940281\";s:6:\"mdhash\";s:32:\"c556e6de4b3d3e5451ee772d862bc516\";s:8:\"filesize\";s:6:\"190925\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:13:\"devel 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/devel/releases/7.x-1.2\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/devel-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1311355316\";s:6:\"mdhash\";s:32:\"477e55a4a98b8d00c9eec17aa4093d2a\";s:8:\"filesize\";s:6:\"186138\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:13:\"devel 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/devel/releases/7.x-1.1\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/devel-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1311192116\";s:6:\"mdhash\";s:32:\"7d75493eb42b06ca1649f1bbd1674909\";s:8:\"filesize\";s:6:\"186092\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:12:\"New features\";i:2;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:13:\"devel 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/devel/releases/7.x-1.0\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/devel-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1294172175\";s:6:\"mdhash\";s:32:\"b3de4c4611ccd5e3e6329c775be69613\";s:8:\"filesize\";s:6:\"188724\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:17:\"devel 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/devel/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/devel-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1291608173\";s:6:\"mdhash\";s:32:\"fab96f90db6a569620c3f072a8e58984\";s:8:\"filesize\";s:6:\"210984\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:19:\"devel 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/devel/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/devel-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1271879406\";s:6:\"mdhash\";s:32:\"d7b04a39c0ff4835a467887ac80c0032\";s:8:\"filesize\";s:6:\"154404\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:19:\"devel 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/devel/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/devel-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1268976905\";s:6:\"mdhash\";s:32:\"c9e9d320362f8601752cff87fbfa162f\";s:8:\"filesize\";s:6:\"151951\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:20:\"devel 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/devel/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/devel-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1265080507\";s:6:\"mdhash\";s:32:\"67055f722b47aad39790d3ff346017cf\";s:8:\"filesize\";s:6:\"146771\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:17:\"devel 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/devel/releases/7.x-1.x-dev\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/devel-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1484038083\";s:6:\"mdhash\";s:32:\"4f6427f4ffac8b31b1bb7bcdbe8150c8\";s:8:\"filesize\";s:6:\"190255\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447558,1500361146,1),('available_releases::drupal','a:11:{s:5:\"title\";s:11:\"Drupal core\";s:10:\"short_name\";s:6:\"drupal\";s:4:\"type\";s:12:\"project_core\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"7\";s:16:\"supported_majors\";s:1:\"7\";s:13:\"default_major\";s:1:\"7\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:37:\"https://www.drupal.org/project/drupal\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:67:{s:4:\"7.56\";a:14:{s:4:\"name\";s:11:\"drupal 7.56\";s:7:\"version\";s:4:\"7.56\";s:3:\"tag\";s:4:\"7.56\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"56\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.56\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.56.tar.gz\";s:4:\"date\";s:10:\"1498069782\";s:6:\"mdhash\";s:32:\"5d198f40f0f1cbf9cdf1bf3de842e534\";s:8:\"filesize\";s:7:\"3277833\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.55\";a:14:{s:4:\"name\";s:11:\"drupal 7.55\";s:7:\"version\";s:4:\"7.55\";s:3:\"tag\";s:4:\"7.55\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"55\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.55\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.55.tar.gz\";s:4:\"date\";s:10:\"1496873942\";s:6:\"mdhash\";s:32:\"ad97f8c86cee7be9d6ab13724b55fa1c\";s:8:\"filesize\";s:7:\"3277355\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.54\";a:14:{s:4:\"name\";s:11:\"drupal 7.54\";s:7:\"version\";s:4:\"7.54\";s:3:\"tag\";s:4:\"7.54\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"54\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.54\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.54.tar.gz\";s:4:\"date\";s:10:\"1485986883\";s:6:\"mdhash\";s:32:\"3068cbe488075ae166e23ea6cd29cf0f\";s:8:\"filesize\";s:7:\"3275864\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.53\";a:14:{s:4:\"name\";s:11:\"drupal 7.53\";s:7:\"version\";s:4:\"7.53\";s:3:\"tag\";s:4:\"7.53\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"53\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.53\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.53.tar.gz\";s:4:\"date\";s:10:\"1481152384\";s:6:\"mdhash\";s:32:\"4230279ecca4f0cde652a219e10327e7\";s:8:\"filesize\";s:7:\"3273245\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.52\";a:14:{s:4:\"name\";s:11:\"drupal 7.52\";s:7:\"version\";s:4:\"7.52\";s:3:\"tag\";s:4:\"7.52\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"52\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.52\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.52.tar.gz\";s:4:\"date\";s:10:\"1479322810\";s:6:\"mdhash\";s:32:\"4963e68ca12918d3a3eae56054214191\";s:8:\"filesize\";s:7:\"3289714\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.51\";a:14:{s:4:\"name\";s:11:\"drupal 7.51\";s:7:\"version\";s:4:\"7.51\";s:3:\"tag\";s:4:\"7.51\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"51\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.51\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.51.tar.gz\";s:4:\"date\";s:10:\"1475693339\";s:6:\"mdhash\";s:32:\"49f82c1cac8e4bd4941ca160fcbee93d\";s:8:\"filesize\";s:7:\"3288987\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.50\";a:14:{s:4:\"name\";s:11:\"drupal 7.50\";s:7:\"version\";s:4:\"7.50\";s:3:\"tag\";s:4:\"7.50\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"50\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.50\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.50.tar.gz\";s:4:\"date\";s:10:\"1467918239\";s:6:\"mdhash\";s:32:\"f23905b0248d76f0fc8316692cd64753\";s:8:\"filesize\";s:7:\"3286826\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.44\";a:14:{s:4:\"name\";s:11:\"drupal 7.44\";s:7:\"version\";s:4:\"7.44\";s:3:\"tag\";s:4:\"7.44\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"44\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.44\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.44.tar.gz\";s:4:\"date\";s:10:\"1466021480\";s:6:\"mdhash\";s:32:\"965ab5fe5457625ec8c18e5c1c455008\";s:8:\"filesize\";s:7:\"3265819\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.43\";a:14:{s:4:\"name\";s:11:\"drupal 7.43\";s:7:\"version\";s:4:\"7.43\";s:3:\"tag\";s:4:\"7.43\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"43\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.43\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.43.tar.gz\";s:4:\"date\";s:10:\"1456341749\";s:6:\"mdhash\";s:32:\"c6fb49bc88a6408a985afddac76b9f8b\";s:8:\"filesize\";s:7:\"3265824\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.42\";a:14:{s:4:\"name\";s:11:\"drupal 7.42\";s:7:\"version\";s:4:\"7.42\";s:3:\"tag\";s:4:\"7.42\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"42\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.42-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.42.tar.gz\";s:4:\"date\";s:10:\"1454516939\";s:6:\"mdhash\";s:32:\"9a96f67474e209dd48750ba6fccc77db\";s:8:\"filesize\";s:7:\"3264065\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.41\";a:14:{s:4:\"name\";s:11:\"drupal 7.41\";s:7:\"version\";s:4:\"7.41\";s:3:\"tag\";s:4:\"7.41\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"41\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.41-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.41.tar.gz\";s:4:\"date\";s:10:\"1445457239\";s:6:\"mdhash\";s:32:\"7636e75e8be213455b4ac7911ce5801f\";s:8:\"filesize\";s:7:\"3257325\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.40\";a:14:{s:4:\"name\";s:11:\"drupal 7.40\";s:7:\"version\";s:4:\"7.40\";s:3:\"tag\";s:4:\"7.40\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"40\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.40-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.40.tar.gz\";s:4:\"date\";s:10:\"1444865639\";s:6:\"mdhash\";s:32:\"d4509f13c23999a76e61ec4d5ccfaf26\";s:8:\"filesize\";s:7:\"3257401\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.39\";a:14:{s:4:\"name\";s:11:\"drupal 7.39\";s:7:\"version\";s:4:\"7.39\";s:3:\"tag\";s:4:\"7.39\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"39\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.39-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.39.tar.gz\";s:4:\"date\";s:10:\"1440019139\";s:6:\"mdhash\";s:32:\"6f42a7e9c7a1c2c4c9c2f20c81b8e79a\";s:8:\"filesize\";s:7:\"3249343\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.38\";a:14:{s:4:\"name\";s:11:\"drupal 7.38\";s:7:\"version\";s:4:\"7.38\";s:3:\"tag\";s:4:\"7.38\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"38\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.38-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.38.tar.gz\";s:4:\"date\";s:10:\"1434566280\";s:6:\"mdhash\";s:32:\"c18298c1a5aed32ddbdac605fdef7fce\";s:8:\"filesize\";s:7:\"3247864\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.37\";a:14:{s:4:\"name\";s:11:\"drupal 7.37\";s:7:\"version\";s:4:\"7.37\";s:3:\"tag\";s:4:\"7.37\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"37\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.37-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.37.tar.gz\";s:4:\"date\";s:10:\"1430972281\";s:6:\"mdhash\";s:32:\"3a70696c87b786365f2c6c3aeb895d8a\";s:8:\"filesize\";s:7:\"3244291\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.36\";a:14:{s:4:\"name\";s:11:\"drupal 7.36\";s:7:\"version\";s:4:\"7.36\";s:3:\"tag\";s:4:\"7.36\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"36\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.36-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.36.tar.gz\";s:4:\"date\";s:10:\"1427943181\";s:6:\"mdhash\";s:32:\"98e1f62c11a5dc5f9481935eefc814c5\";s:8:\"filesize\";s:7:\"3244905\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.35\";a:14:{s:4:\"name\";s:11:\"drupal 7.35\";s:7:\"version\";s:4:\"7.35\";s:3:\"tag\";s:4:\"7.35\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"35\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.35-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.35.tar.gz\";s:4:\"date\";s:10:\"1426706281\";s:6:\"mdhash\";s:32:\"fecc55bd0bd476bc35d9ebf68452942d\";s:8:\"filesize\";s:7:\"3234349\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.34\";a:14:{s:4:\"name\";s:11:\"drupal 7.34\";s:7:\"version\";s:4:\"7.34\";s:3:\"tag\";s:4:\"7.34\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"34\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.34-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.34.tar.gz\";s:4:\"date\";s:10:\"1416429264\";s:6:\"mdhash\";s:32:\"bb4d212e1eb1d7375e41613fbefa04f2\";s:8:\"filesize\";s:7:\"3229858\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.33\";a:14:{s:4:\"name\";s:11:\"drupal 7.33\";s:7:\"version\";s:4:\"7.33\";s:3:\"tag\";s:4:\"7.33\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"33\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.33-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.33.tar.gz\";s:4:\"date\";s:10:\"1415374080\";s:6:\"mdhash\";s:32:\"187b076a5753960d5d5cb12d30d93e73\";s:8:\"filesize\";s:7:\"3229397\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.32\";a:14:{s:4:\"name\";s:11:\"drupal 7.32\";s:7:\"version\";s:4:\"7.32\";s:3:\"tag\";s:4:\"7.32\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"32\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.32-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.32.tar.gz\";s:4:\"date\";s:10:\"1413387329\";s:6:\"mdhash\";s:32:\"d5d121a6ce974f2d20604a7e10e1987a\";s:8:\"filesize\";s:7:\"3215563\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.31\";a:14:{s:4:\"name\";s:11:\"drupal 7.31\";s:7:\"version\";s:4:\"7.31\";s:3:\"tag\";s:4:\"7.31\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"31\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.31-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.31.tar.gz\";s:4:\"date\";s:10:\"1407346427\";s:6:\"mdhash\";s:32:\"de256f202930d3ef5ccc6aebc550adaf\";s:8:\"filesize\";s:7:\"3216766\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.30\";a:14:{s:4:\"name\";s:11:\"drupal 7.30\";s:7:\"version\";s:4:\"7.30\";s:3:\"tag\";s:4:\"7.30\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"30\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.30-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.30.tar.gz\";s:4:\"date\";s:10:\"1406239728\";s:6:\"mdhash\";s:32:\"ef7bce65ca6395f1e6bc44c15fdbc3cb\";s:8:\"filesize\";s:7:\"3215744\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.29\";a:14:{s:4:\"name\";s:11:\"drupal 7.29\";s:7:\"version\";s:4:\"7.29\";s:3:\"tag\";s:4:\"7.29\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"29\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.29-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.29.tar.gz\";s:4:\"date\";s:10:\"1405543128\";s:6:\"mdhash\";s:32:\"6ffdfb0ee08fadfb531c7fed1d2c5633\";s:8:\"filesize\";s:7:\"3213499\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.28\";a:14:{s:4:\"name\";s:11:\"drupal 7.28\";s:7:\"version\";s:4:\"7.28\";s:3:\"tag\";s:4:\"7.28\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"28\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.28-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.28.tar.gz\";s:4:\"date\";s:10:\"1399522729\";s:6:\"mdhash\";s:32:\"6255884d7e15c654fc8856805b271551\";s:8:\"filesize\";s:7:\"3212823\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.27\";a:14:{s:4:\"name\";s:11:\"drupal 7.27\";s:7:\"version\";s:4:\"7.27\";s:3:\"tag\";s:4:\"7.27\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"27\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.27-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.27.tar.gz\";s:4:\"date\";s:10:\"1397686464\";s:6:\"mdhash\";s:32:\"e9b05562f1a7f8bbcb5922cd3a0d55cb\";s:8:\"filesize\";s:7:\"3207398\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.26\";a:14:{s:4:\"name\";s:11:\"drupal 7.26\";s:7:\"version\";s:4:\"7.26\";s:3:\"tag\";s:4:\"7.26\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"26\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.26-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.26.tar.gz\";s:4:\"date\";s:10:\"1389815904\";s:6:\"mdhash\";s:32:\"740bd57f524b8ac18a203b663ca1329d\";s:8:\"filesize\";s:7:\"3204587\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.25\";a:14:{s:4:\"name\";s:11:\"drupal 7.25\";s:7:\"version\";s:4:\"7.25\";s:3:\"tag\";s:4:\"7.25\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"25\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.25-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.25.tar.gz\";s:4:\"date\";s:10:\"1388709505\";s:6:\"mdhash\";s:32:\"25906158083d89aa86534df1c683b4ea\";s:8:\"filesize\";s:7:\"3203256\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.24\";a:14:{s:4:\"name\";s:11:\"drupal 7.24\";s:7:\"version\";s:4:\"7.24\";s:3:\"tag\";s:4:\"7.24\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"24\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.24-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.24.tar.gz\";s:4:\"date\";s:10:\"1384982905\";s:6:\"mdhash\";s:32:\"c1ddb37155e4b6160f6508636c06f2a7\";s:8:\"filesize\";s:7:\"3195735\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.23\";a:14:{s:4:\"name\";s:11:\"drupal 7.23\";s:7:\"version\";s:4:\"7.23\";s:3:\"tag\";s:4:\"7.23\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"23\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.23-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.23.tar.gz\";s:4:\"date\";s:10:\"1375928239\";s:6:\"mdhash\";s:32:\"0beca6fec15b8cf8c35a6fdda6675342\";s:8:\"filesize\";s:7:\"3191695\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.22\";a:14:{s:4:\"name\";s:11:\"drupal 7.22\";s:7:\"version\";s:4:\"7.22\";s:3:\"tag\";s:4:\"7.22\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"22\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.22-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.22.tar.gz\";s:4:\"date\";s:10:\"1365027013\";s:6:\"mdhash\";s:32:\"068d7a77958fce6bb002659aa7ccaeb7\";s:8:\"filesize\";s:7:\"3183014\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.21\";a:14:{s:4:\"name\";s:11:\"drupal 7.21\";s:7:\"version\";s:4:\"7.21\";s:3:\"tag\";s:4:\"7.21\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"21\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.21-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.21.tar.gz\";s:4:\"date\";s:10:\"1362616997\";s:6:\"mdhash\";s:32:\"eff054cd53be39ff719f77c81dce1aac\";s:8:\"filesize\";s:7:\"3163798\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.20\";a:14:{s:4:\"name\";s:11:\"drupal 7.20\";s:7:\"version\";s:4:\"7.20\";s:3:\"tag\";s:4:\"7.20\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"20\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.20-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.20.tar.gz\";s:4:\"date\";s:10:\"1361393684\";s:6:\"mdhash\";s:32:\"ee576d63f1fd8a1f1c072a56978da0c5\";s:8:\"filesize\";s:7:\"3163257\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.19\";a:14:{s:4:\"name\";s:11:\"drupal 7.19\";s:7:\"version\";s:4:\"7.19\";s:3:\"tag\";s:4:\"7.19\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"19\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.19-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.19.tar.gz\";s:4:\"date\";s:10:\"1358374871\";s:6:\"mdhash\";s:32:\"c1dd3960f1555df208c80ef612e0c53a\";s:8:\"filesize\";s:7:\"3163130\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.18\";a:14:{s:4:\"name\";s:11:\"drupal 7.18\";s:7:\"version\";s:4:\"7.18\";s:3:\"tag\";s:4:\"7.18\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"18\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.18-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.18.tar.gz\";s:4:\"date\";s:10:\"1355944004\";s:6:\"mdhash\";s:32:\"5c048f60a53acd7cb3c2b6d5fe42f082\";s:8:\"filesize\";s:7:\"3162333\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.17\";a:14:{s:4:\"name\";s:11:\"drupal 7.17\";s:7:\"version\";s:4:\"7.17\";s:3:\"tag\";s:4:\"7.17\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"17\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.17-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.17.tar.gz\";s:4:\"date\";s:10:\"1352325358\";s:6:\"mdhash\";s:32:\"439e8ca7e6a33bb879a4624d8f01bed0\";s:8:\"filesize\";s:7:\"3162429\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.16\";a:14:{s:4:\"name\";s:11:\"drupal 7.16\";s:7:\"version\";s:4:\"7.16\";s:3:\"tag\";s:4:\"7.16\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"16\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.16\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.16.tar.gz\";s:4:\"date\";s:10:\"1350508568\";s:6:\"mdhash\";s:32:\"352497b2df94b5308e31cb8da020b631\";s:8:\"filesize\";s:7:\"3142889\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.15\";a:14:{s:4:\"name\";s:11:\"drupal 7.15\";s:7:\"version\";s:4:\"7.15\";s:3:\"tag\";s:4:\"7.15\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"15\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.15\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.15.tar.gz\";s:4:\"date\";s:10:\"1343839327\";s:6:\"mdhash\";s:32:\"f42c9baccd74e1d035d61ff537ae21b4\";s:8:\"filesize\";s:7:\"3142219\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.14\";a:14:{s:4:\"name\";s:11:\"drupal 7.14\";s:7:\"version\";s:4:\"7.14\";s:3:\"tag\";s:4:\"7.14\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"14\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.14\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.14.tar.gz\";s:4:\"date\";s:10:\"1335997556\";s:6:\"mdhash\";s:32:\"af7abd95c03ecad4e1567ed94a438334\";s:8:\"filesize\";s:7:\"3128473\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.13\";a:14:{s:4:\"name\";s:11:\"drupal 7.13\";s:7:\"version\";s:4:\"7.13\";s:3:\"tag\";s:4:\"7.13\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.13\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.13.tar.gz\";s:4:\"date\";s:10:\"1335997261\";s:6:\"mdhash\";s:32:\"80587b66375c7fc539414a20a2c6f2de\";s:8:\"filesize\";s:7:\"3088448\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.12\";a:14:{s:4:\"name\";s:11:\"drupal 7.12\";s:7:\"version\";s:4:\"7.12\";s:3:\"tag\";s:4:\"7.12\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.12\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.12.tar.gz\";s:4:\"date\";s:10:\"1328134561\";s:6:\"mdhash\";s:32:\"db2284beb97241c9bdca9c638cd8a4f1\";s:8:\"filesize\";s:7:\"3088472\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.11\";a:14:{s:4:\"name\";s:11:\"drupal 7.11\";s:7:\"version\";s:4:\"7.11\";s:3:\"tag\";s:4:\"7.11\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.11\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.11.tar.gz\";s:4:\"date\";s:10:\"1328134275\";s:6:\"mdhash\";s:32:\"e9857e1749762367d7631d74cc6564a7\";s:8:\"filesize\";s:7:\"2789336\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:4:\"7.10\";a:14:{s:4:\"name\";s:11:\"drupal 7.10\";s:7:\"version\";s:4:\"7.10\";s:3:\"tag\";s:4:\"7.10\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.10\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.10.tar.gz\";s:4:\"date\";s:10:\"1323125439\";s:6:\"mdhash\";s:32:\"1caafb849bc756e62dd874b90b95ab31\";s:8:\"filesize\";s:7:\"3067653\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:3:\"7.9\";a:14:{s:4:\"name\";s:10:\"drupal 7.9\";s:7:\"version\";s:3:\"7.9\";s:3:\"tag\";s:3:\"7.9\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:50:\"https://www.drupal.org/project/drupal/releases/7.9\";s:13:\"download_link\";s:55:\"https://ftp.drupal.org/files/projects/drupal-7.9.tar.gz\";s:4:\"date\";s:10:\"1319660731\";s:6:\"mdhash\";s:32:\"7f45f109c413ca69ebb6e3140ed47225\";s:8:\"filesize\";s:7:\"2788086\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:3:\"7.8\";a:14:{s:4:\"name\";s:10:\"drupal 7.8\";s:7:\"version\";s:3:\"7.8\";s:3:\"tag\";s:3:\"7.8\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:50:\"https://www.drupal.org/project/drupal/releases/7.8\";s:13:\"download_link\";s:55:\"https://ftp.drupal.org/files/projects/drupal-7.8.tar.gz\";s:4:\"date\";s:10:\"1314817617\";s:6:\"mdhash\";s:32:\"e0226b56e8d5c57c6b126e8ed5866b1f\";s:8:\"filesize\";s:7:\"2766967\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:3:\"7.7\";a:14:{s:4:\"name\";s:10:\"drupal 7.7\";s:7:\"version\";s:3:\"7.7\";s:3:\"tag\";s:3:\"7.7\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:50:\"https://www.drupal.org/project/drupal/releases/7.7\";s:13:\"download_link\";s:55:\"https://ftp.drupal.org/files/projects/drupal-7.7.tar.gz\";s:4:\"date\";s:10:\"1311813880\";s:6:\"mdhash\";s:32:\"2eeb63fd1ef6b23b0a9f5f6b8aef8850\";s:8:\"filesize\";s:7:\"2754113\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:3:\"7.6\";a:14:{s:4:\"name\";s:10:\"drupal 7.6\";s:7:\"version\";s:3:\"7.6\";s:3:\"tag\";s:3:\"7.6\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:50:\"https://www.drupal.org/project/drupal/releases/7.6\";s:13:\"download_link\";s:55:\"https://ftp.drupal.org/files/projects/drupal-7.6.tar.gz\";s:4:\"date\";s:10:\"1311798716\";s:6:\"mdhash\";s:32:\"e88e63c4da9e5e170f089d050c88c827\";s:8:\"filesize\";s:7:\"2753784\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:3:\"7.5\";a:14:{s:4:\"name\";s:10:\"drupal 7.5\";s:7:\"version\";s:3:\"7.5\";s:3:\"tag\";s:3:\"7.5\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:50:\"https://www.drupal.org/project/drupal/releases/7.5\";s:13:\"download_link\";s:55:\"https://ftp.drupal.org/files/projects/drupal-7.5.tar.gz\";s:4:\"date\";s:10:\"1311798416\";s:6:\"mdhash\";s:32:\"36d65b7a97c58226c64a6abdf481de45\";s:8:\"filesize\";s:7:\"2744690\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:3:\"7.4\";a:14:{s:4:\"name\";s:10:\"drupal 7.4\";s:7:\"version\";s:3:\"7.4\";s:3:\"tag\";s:3:\"7.4\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:50:\"https://www.drupal.org/project/drupal/releases/7.4\";s:13:\"download_link\";s:55:\"https://ftp.drupal.org/files/projects/drupal-7.4.tar.gz\";s:4:\"date\";s:10:\"1309397516\";s:6:\"mdhash\";s:32:\"84704de078e9f5432c9bb5c6ecd841d4\";s:8:\"filesize\";s:7:\"2744808\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:3:\"7.3\";a:14:{s:4:\"name\";s:10:\"drupal 7.3\";s:7:\"version\";s:3:\"7.3\";s:3:\"tag\";s:3:\"7.3\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:50:\"https://www.drupal.org/project/drupal/releases/7.3\";s:13:\"download_link\";s:55:\"https://ftp.drupal.org/files/projects/drupal-7.3.tar.gz\";s:4:\"date\";s:10:\"1309397216\";s:6:\"mdhash\";s:32:\"c290775724bc309647d84d03ddb88e2e\";s:8:\"filesize\";s:7:\"2735461\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:3:\"7.2\";a:14:{s:4:\"name\";s:10:\"drupal 7.2\";s:7:\"version\";s:3:\"7.2\";s:3:\"tag\";s:3:\"7.2\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:50:\"https://www.drupal.org/project/drupal/releases/7.2\";s:13:\"download_link\";s:55:\"https://ftp.drupal.org/files/projects/drupal-7.2.tar.gz\";s:4:\"date\";s:10:\"1306357017\";s:6:\"mdhash\";s:32:\"cf88c87e3694ebd15b62ba6f6a69124f\";s:8:\"filesize\";s:7:\"2731345\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:3:\"7.1\";a:14:{s:4:\"name\";s:10:\"drupal 7.1\";s:7:\"version\";s:3:\"7.1\";s:3:\"tag\";s:3:\"7.1\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:50:\"https://www.drupal.org/project/drupal/releases/7.1\";s:13:\"download_link\";s:55:\"https://ftp.drupal.org/files/projects/drupal-7.1.tar.gz\";s:4:\"date\";s:10:\"1306354916\";s:6:\"mdhash\";s:32:\"27eb45cb894a76f3a9ae6715584a10cc\";s:8:\"filesize\";s:7:\"2713977\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:3:\"7.0\";a:14:{s:4:\"name\";s:10:\"drupal 7.0\";s:7:\"version\";s:3:\"7.0\";s:3:\"tag\";s:3:\"7.0\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:50:\"https://www.drupal.org/project/drupal/releases/7.0\";s:13:\"download_link\";s:55:\"https://ftp.drupal.org/files/projects/drupal-7.0.tar.gz\";s:4:\"date\";s:10:\"1294208759\";s:6:\"mdhash\";s:32:\"e96c0a5e47c5d7706897384069dfb920\";s:8:\"filesize\";s:7:\"2728271\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.0-rc4\";a:15:{s:4:\"name\";s:14:\"drupal 7.0-rc4\";s:7:\"version\";s:7:\"7.0-rc4\";s:3:\"tag\";s:8:\"7.0-rc-4\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/drupal/releases/7.0-rc4\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/drupal-7.0-rc4.tar.gz\";s:4:\"date\";s:10:\"1293684084\";s:6:\"mdhash\";s:32:\"104c08e609c64bb1e45b55a7ad1ad857\";s:8:\"filesize\";s:7:\"2717666\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:7:\"7.0-rc3\";a:15:{s:4:\"name\";s:14:\"drupal 7.0-rc3\";s:7:\"version\";s:7:\"7.0-rc3\";s:3:\"tag\";s:8:\"7.0-rc-3\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/drupal/releases/7.0-rc3\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/drupal-7.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1293099424\";s:6:\"mdhash\";s:32:\"be9a3f190e2648fa03dcb2bf3d8be199\";s:8:\"filesize\";s:7:\"2719115\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:7:\"7.0-rc2\";a:15:{s:4:\"name\";s:14:\"drupal 7.0-rc2\";s:7:\"version\";s:7:\"7.0-rc2\";s:3:\"tag\";s:8:\"7.0-rc-2\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/drupal/releases/7.0-rc2\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/drupal-7.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1292101847\";s:6:\"mdhash\";s:32:\"f31982c73f1707ddccb2927325bc9cb9\";s:8:\"filesize\";s:7:\"2705734\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:7:\"7.0-rc1\";a:15:{s:4:\"name\";s:14:\"drupal 7.0-rc1\";s:7:\"version\";s:7:\"7.0-rc1\";s:3:\"tag\";s:8:\"7.0-rc-1\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/drupal/releases/7.0-rc1\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/drupal-7.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1291190142\";s:6:\"mdhash\";s:32:\"b554e79cf60c02d4dec592151c4b58ee\";s:8:\"filesize\";s:7:\"2694689\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:12:\"New features\";i:2;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:9:\"7.0-beta3\";a:15:{s:4:\"name\";s:16:\"drupal 7.0-beta3\";s:7:\"version\";s:9:\"7.0-beta3\";s:3:\"tag\";s:9:\"7.0-beta3\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/7.0-beta3\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-7.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1289694735\";s:6:\"mdhash\";s:32:\"c942f010a2535586c4578cd7b107c652\";s:8:\"filesize\";s:7:\"2660883\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:12:\"New features\";i:2;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:9:\"7.0-beta2\";a:15:{s:4:\"name\";s:16:\"drupal 7.0-beta2\";s:7:\"version\";s:9:\"7.0-beta2\";s:3:\"tag\";s:9:\"7.0-beta2\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/7.0-beta2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-7.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1287812133\";s:6:\"mdhash\";s:32:\"c2de0bdb657b77af8c8369a355cab8ce\";s:8:\"filesize\";s:7:\"2638949\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:9:\"7.0-beta1\";a:15:{s:4:\"name\";s:16:\"drupal 7.0-beta1\";s:7:\"version\";s:9:\"7.0-beta1\";s:3:\"tag\";s:9:\"7.0-beta1\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/7.0-beta1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-7.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1286422866\";s:6:\"mdhash\";s:32:\"490ce0d95eacc15f2918becd60f6821c\";s:8:\"filesize\";s:7:\"2622225\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:10:\"7.0-alpha7\";a:15:{s:4:\"name\";s:17:\"drupal 7.0-alpha7\";s:7:\"version\";s:10:\"7.0-alpha7\";s:3:\"tag\";s:10:\"7.0-alpha7\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/7.0-alpha7\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-7.0-alpha7.tar.gz\";s:4:\"date\";s:10:\"1284599764\";s:6:\"mdhash\";s:32:\"15183fcf862be97f7e96991e6e56fe2e\";s:8:\"filesize\";s:7:\"2586833\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"7.0-alpha6\";a:15:{s:4:\"name\";s:17:\"drupal 7.0-alpha6\";s:7:\"version\";s:10:\"7.0-alpha6\";s:3:\"tag\";s:10:\"7.0-alpha6\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/7.0-alpha6\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-7.0-alpha6.tar.gz\";s:4:\"date\";s:10:\"1278634809\";s:6:\"mdhash\";s:32:\"eb64647263affc36f76d1e7ffb751d32\";s:8:\"filesize\";s:7:\"2458211\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:12:\"New features\";i:2;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"7.0-alpha5\";a:15:{s:4:\"name\";s:17:\"drupal 7.0-alpha5\";s:7:\"version\";s:10:\"7.0-alpha5\";s:3:\"tag\";s:10:\"7.0-alpha5\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/7.0-alpha5\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-7.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1274628613\";s:6:\"mdhash\";s:32:\"de9c1d51f0ce730f7356bd0a160e8ce1\";s:8:\"filesize\";s:7:\"2424226\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"7.0-alpha4\";a:15:{s:4:\"name\";s:17:\"drupal 7.0-alpha4\";s:7:\"version\";s:10:\"7.0-alpha4\";s:3:\"tag\";s:10:\"7.0-alpha4\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/7.0-alpha4\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-7.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1272318014\";s:6:\"mdhash\";s:32:\"c8f371a388bc65b2211d7d29856fb993\";s:8:\"filesize\";s:7:\"2403384\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"7.0-alpha3\";a:15:{s:4:\"name\";s:17:\"drupal 7.0-alpha3\";s:7:\"version\";s:10:\"7.0-alpha3\";s:3:\"tag\";s:10:\"7.0-alpha3\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/7.0-alpha3\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-7.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1269192317\";s:6:\"mdhash\";s:32:\"9efc083f09d6b523d655bc90a6869945\";s:8:\"filesize\";s:7:\"2357934\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:12:\"New features\";i:2;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"7.0-alpha2\";a:15:{s:4:\"name\";s:17:\"drupal 7.0-alpha2\";s:7:\"version\";s:10:\"7.0-alpha2\";s:3:\"tag\";s:10:\"7.0-alpha2\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/7.0-alpha2\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-7.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1266777910\";s:6:\"mdhash\";s:32:\"cfbfdd2249638a266054f2532348065d\";s:8:\"filesize\";s:7:\"2314834\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"7.0-alpha1\";a:15:{s:4:\"name\";s:17:\"drupal 7.0-alpha1\";s:7:\"version\";s:10:\"7.0-alpha1\";s:3:\"tag\";s:10:\"7.0-alpha1\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/7.0-alpha1\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-7.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1263566711\";s:6:\"mdhash\";s:32:\"508109c6cf0ead868e02d8c3db2a4d1f\";s:8:\"filesize\";s:7:\"2283220\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:7:\"7.x-dev\";a:14:{s:4:\"name\";s:14:\"drupal 7.x-dev\";s:7:\"version\";s:7:\"7.x-dev\";s:3:\"tag\";s:3:\"7.x\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/drupal/releases/7.x-dev\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/drupal-7.x-dev.tar.gz\";s:4:\"date\";s:10:\"1499966043\";s:6:\"mdhash\";s:32:\"f769ca3a41b3e188f3d1b148388939bf\";s:8:\"filesize\";s:7:\"3278048\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1500447548,1500361146,1),('available_releases::eck','a:11:{s:5:\"title\";s:29:\"Entity Construction Kit (ECK)\";s:10:\"short_name\";s:3:\"eck\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:34:\"https://www.drupal.org/project/eck\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:18:{s:11:\"7.x-2.0-rc9\";a:15:{s:4:\"name\";s:15:\"eck 7.x-2.0-rc9\";s:7:\"version\";s:11:\"7.x-2.0-rc9\";s:3:\"tag\";s:11:\"7.x-2.0-rc9\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/eck/releases/7.x-2.0-rc9\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/eck-7.x-2.0-rc9.tar.gz\";s:4:\"date\";s:10:\"1483524242\";s:6:\"mdhash\";s:32:\"2d38ca6229404d870f545f9d6222f539\";s:8:\"filesize\";s:5:\"53044\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-2.0-rc8\";a:15:{s:4:\"name\";s:15:\"eck 7.x-2.0-rc8\";s:7:\"version\";s:11:\"7.x-2.0-rc8\";s:3:\"tag\";s:11:\"7.x-2.0-rc8\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/eck/releases/7.x-2.0-rc8\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/eck-7.x-2.0-rc8.tar.gz\";s:4:\"date\";s:10:\"1448559840\";s:6:\"mdhash\";s:32:\"1b70c7cd1fb591af66d7ad3f518e9f86\";s:8:\"filesize\";s:5:\"52922\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-2.0-rc7\";a:15:{s:4:\"name\";s:15:\"eck 7.x-2.0-rc7\";s:7:\"version\";s:11:\"7.x-2.0-rc7\";s:3:\"tag\";s:11:\"7.x-2.0-rc7\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/eck/releases/7.x-2.0-rc7\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/eck-7.x-2.0-rc7.tar.gz\";s:4:\"date\";s:10:\"1422241380\";s:6:\"mdhash\";s:32:\"59a5f89cbfbc6f2afb8b597aa017dffb\";s:8:\"filesize\";s:5:\"50918\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-2.0-rc6\";a:15:{s:4:\"name\";s:15:\"eck 7.x-2.0-rc6\";s:7:\"version\";s:11:\"7.x-2.0-rc6\";s:3:\"tag\";s:11:\"7.x-2.0-rc6\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/eck/releases/7.x-2.0-rc6\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/eck-7.x-2.0-rc6.tar.gz\";s:4:\"date\";s:10:\"1418843580\";s:6:\"mdhash\";s:32:\"209c01e739a4f57b46b44cbca8d6a76f\";s:8:\"filesize\";s:5:\"50563\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-2.0-rc5\";a:15:{s:4:\"name\";s:15:\"eck 7.x-2.0-rc5\";s:7:\"version\";s:11:\"7.x-2.0-rc5\";s:3:\"tag\";s:11:\"7.x-2.0-rc5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/eck/releases/7.x-2.0-rc5\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/eck-7.x-2.0-rc5.tar.gz\";s:4:\"date\";s:10:\"1417069681\";s:6:\"mdhash\";s:32:\"9921530083c09e89b95f70db308bb341\";s:8:\"filesize\";s:5:\"48763\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-2.0-rc4\";a:15:{s:4:\"name\";s:15:\"eck 7.x-2.0-rc4\";s:7:\"version\";s:11:\"7.x-2.0-rc4\";s:3:\"tag\";s:11:\"7.x-2.0-rc4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/eck/releases/7.x-2.0-rc4\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/eck-7.x-2.0-rc4.tar.gz\";s:4:\"date\";s:10:\"1406213327\";s:6:\"mdhash\";s:32:\"461f35a24bda97f09bf53604037ece9f\";s:8:\"filesize\";s:5:\"47835\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-2.0-rc3\";a:15:{s:4:\"name\";s:15:\"eck 7.x-2.0-rc3\";s:7:\"version\";s:11:\"7.x-2.0-rc3\";s:3:\"tag\";s:11:\"7.x-2.0-rc3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/eck/releases/7.x-2.0-rc3\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/eck-7.x-2.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1398836027\";s:6:\"mdhash\";s:32:\"9e0fa1beba0374fa16f329b8ccbe2ab0\";s:8:\"filesize\";s:5:\"45547\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-2.0-rc2\";a:15:{s:4:\"name\";s:15:\"eck 7.x-2.0-rc2\";s:7:\"version\";s:11:\"7.x-2.0-rc2\";s:3:\"tag\";s:11:\"7.x-2.0-rc2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/eck/releases/7.x-2.0-rc2\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/eck-7.x-2.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1367522714\";s:6:\"mdhash\";s:32:\"c69557e09dd01853cb84ae29b18e34df\";s:8:\"filesize\";s:5:\"45765\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-2.0-rc1\";a:15:{s:4:\"name\";s:15:\"eck 7.x-2.0-rc1\";s:7:\"version\";s:11:\"7.x-2.0-rc1\";s:3:\"tag\";s:11:\"7.x-2.0-rc1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/eck/releases/7.x-2.0-rc1\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/eck-7.x-2.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1347588758\";s:6:\"mdhash\";s:32:\"a96ea4e4f649db7904e408f62c2b17fc\";s:8:\"filesize\";s:5:\"38602\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-2.0-beta1\";a:15:{s:4:\"name\";s:17:\"eck 7.x-2.0-beta1\";s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:3:\"tag\";s:13:\"7.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/eck/releases/7.x-2.0-beta1\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/eck-7.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1336587060\";s:6:\"mdhash\";s:32:\"2261a224fb4a203d1c6e3e9418148ce2\";s:8:\"filesize\";s:5:\"36654\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:18:\"eck 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/eck/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/eck-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1327376742\";s:6:\"mdhash\";s:32:\"1ebd76d4141108ecb67983b7d5d6faea\";s:8:\"filesize\";s:5:\"33665\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"7.x-1.1-alpha3\";a:15:{s:4:\"name\";s:18:\"eck 7.x-1.1-alpha3\";s:7:\"version\";s:14:\"7.x-1.1-alpha3\";s:3:\"tag\";s:14:\"7.x-1.1-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/eck/releases/7.x-1.1-alpha3\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/eck-7.x-1.1-alpha3.tar.gz\";s:4:\"date\";s:10:\"1318820497\";s:6:\"mdhash\";s:32:\"ad89bb1f547daa4b0bb6dcd9890b29a5\";s:8:\"filesize\";s:5:\"23132\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"7.x-1.1-alpha2\";a:15:{s:4:\"name\";s:18:\"eck 7.x-1.1-alpha2\";s:7:\"version\";s:14:\"7.x-1.1-alpha2\";s:3:\"tag\";s:14:\"7.x-1.1-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/eck/releases/7.x-1.1-alpha2\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/eck-7.x-1.1-alpha2.tar.gz\";s:4:\"date\";s:10:\"1318697196\";s:6:\"mdhash\";s:32:\"9d187451efcd0e329a76fd3a90047fdc\";s:8:\"filesize\";s:5:\"23015\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"7.x-1.1-alpha1\";a:15:{s:4:\"name\";s:18:\"eck 7.x-1.1-alpha1\";s:7:\"version\";s:14:\"7.x-1.1-alpha1\";s:3:\"tag\";s:14:\"7.x-1.1-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/eck/releases/7.x-1.1-alpha1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/eck-7.x-1.1-alpha1.tar.gz\";s:4:\"date\";s:10:\"1318625796\";s:6:\"mdhash\";s:32:\"f770d9fef4554499860ea1b47b0c45b3\";s:8:\"filesize\";s:5:\"23001\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:17:\"eck 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/eck/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/eck-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1316051802\";s:6:\"mdhash\";s:32:\"4a65093e0286a60d50cba18f700f42ae\";s:8:\"filesize\";s:5:\"17973\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-3.x-dev\";a:14:{s:4:\"name\";s:15:\"eck 7.x-3.x-dev\";s:7:\"version\";s:11:\"7.x-3.x-dev\";s:3:\"tag\";s:7:\"7.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/eck/releases/7.x-3.x-dev\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/eck-7.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1476171839\";s:6:\"mdhash\";s:32:\"85bfd4922edcf8897d6bfdf5619891da\";s:8:\"filesize\";s:5:\"68931\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:15:\"eck 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/eck/releases/7.x-2.x-dev\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/eck-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1487791083\";s:6:\"mdhash\";s:32:\"30ea19fb6db8de103b3283e67f9caf91\";s:8:\"filesize\";s:5:\"53313\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:15:\"eck 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/eck/releases/7.x-1.x-dev\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/eck-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1468787639\";s:6:\"mdhash\";s:32:\"4579b6f9d6261644aecda0b1cb04ad83\";s:8:\"filesize\";s:5:\"23418\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}}}',1500447559,1500361146,1),('available_releases::entity','a:11:{s:5:\"title\";s:10:\"Entity API\";s:10:\"short_name\";s:6:\"entity\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:37:\"https://www.drupal.org/project/entity\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:30:{s:7:\"7.x-1.8\";a:14:{s:4:\"name\";s:14:\"entity 7.x-1.8\";s:7:\"version\";s:7:\"7.x-1.8\";s:3:\"tag\";s:7:\"7.x-1.8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/entity/releases/7.x-1.8\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/entity-7.x-1.8.tar.gz\";s:4:\"date\";s:10:\"1474545839\";s:6:\"mdhash\";s:32:\"3926d48c86387c3d1d5777538903a752\";s:8:\"filesize\";s:6:\"123957\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.7\";a:14:{s:4:\"name\";s:14:\"entity 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/entity/releases/7.x-1.7\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/entity-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1458222242\";s:6:\"mdhash\";s:32:\"f4787da0230869cc7420b6cea78212e5\";s:8:\"filesize\";s:6:\"121426\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:14:\"entity 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/entity/releases/7.x-1.6\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/entity-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1424876581\";s:6:\"mdhash\";s:32:\"a778a5c82eaddac50e40a3dd0a3ebac6\";s:8:\"filesize\";s:6:\"120850\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:14:\"entity 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/entity/releases/7.x-1.5\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/entity-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1396975451\";s:6:\"mdhash\";s:32:\"04b90c27b2f1627d0a218006291afa9f\";s:8:\"filesize\";s:6:\"121011\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:14:\"entity 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/entity/releases/7.x-1.4\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/entity-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1395335056\";s:6:\"mdhash\";s:32:\"d026208f7b433b9b2dd5fdc705396d0e\";s:8:\"filesize\";s:6:\"120371\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:14:\"entity 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/entity/releases/7.x-1.3\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/entity-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1389210804\";s:6:\"mdhash\";s:32:\"92bb78da6928049c0d9bdea76629416b\";s:8:\"filesize\";s:6:\"119279\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:14:\"entity 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/entity/releases/7.x-1.2\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/entity-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1376493705\";s:6:\"mdhash\";s:32:\"c87e0ce3708a26a3045c36b8ad15f61c\";s:8:\"filesize\";s:6:\"115225\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:14:\"entity 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/entity/releases/7.x-1.1\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/entity-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1367338217\";s:6:\"mdhash\";s:32:\"1f23d1bee48287f1c53f8d3f1391187a\";s:8:\"filesize\";s:6:\"110514\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:14:\"entity 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/entity/releases/7.x-1.0\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1356471145\";s:6:\"mdhash\";s:32:\"f072eda34e284561bb55cfae0dbe30db\";s:8:\"filesize\";s:6:\"110082\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-1.0-rc3\";a:15:{s:4:\"name\";s:18:\"entity 7.x-1.0-rc3\";s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:3:\"tag\";s:11:\"7.x-1.0-rc3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/entity/releases/7.x-1.0-rc3\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1337981155\";s:6:\"mdhash\";s:32:\"267c552757d1fa8bbe17c624a7ec4c3f\";s:8:\"filesize\";s:6:\"106628\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc2\";a:15:{s:4:\"name\";s:18:\"entity 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/entity/releases/7.x-1.0-rc2\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1335099086\";s:6:\"mdhash\";s:32:\"587d7b6a088a195722fe7d11b1c9c8fa\";s:8:\"filesize\";s:6:\"105993\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:18:\"entity 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/entity/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1320914735\";s:6:\"mdhash\";s:32:\"daa6dff009d00756f86b80b31af32c77\";s:8:\"filesize\";s:5:\"95227\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-beta11\";a:15:{s:4:\"name\";s:21:\"entity 7.x-1.0-beta11\";s:7:\"version\";s:14:\"7.x-1.0-beta11\";s:3:\"tag\";s:14:\"7.x-1.0-beta11\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/entity/releases/7.x-1.0-beta11\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-beta11.tar.gz\";s:4:\"date\";s:10:\"1319558131\";s:6:\"mdhash\";s:32:\"0d98c2c361e5936593b8365614fa04e3\";s:8:\"filesize\";s:5:\"83206\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-beta10\";a:15:{s:4:\"name\";s:21:\"entity 7.x-1.0-beta10\";s:7:\"version\";s:14:\"7.x-1.0-beta10\";s:3:\"tag\";s:14:\"7.x-1.0-beta10\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/entity/releases/7.x-1.0-beta10\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-beta10.tar.gz\";s:4:\"date\";s:10:\"1310486817\";s:6:\"mdhash\";s:32:\"016f48d7ecee0da62ae1a8f6cf26a656\";s:8:\"filesize\";s:5:\"77197\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta9\";a:15:{s:4:\"name\";s:20:\"entity 7.x-1.0-beta9\";s:7:\"version\";s:13:\"7.x-1.0-beta9\";s:3:\"tag\";s:13:\"7.x-1.0-beta9\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/7.x-1.0-beta9\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-beta9.tar.gz\";s:4:\"date\";s:10:\"1308239815\";s:6:\"mdhash\";s:32:\"a965dc47b0b8afc2f75b69be31e767d0\";s:8:\"filesize\";s:5:\"75840\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta8\";a:15:{s:4:\"name\";s:20:\"entity 7.x-1.0-beta8\";s:7:\"version\";s:13:\"7.x-1.0-beta8\";s:3:\"tag\";s:13:\"7.x-1.0-beta8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/7.x-1.0-beta8\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-beta8.tar.gz\";s:4:\"date\";s:10:\"1300731067\";s:6:\"mdhash\";s:32:\"317ec15a5f9d90e7613b52f20a7e9a82\";s:8:\"filesize\";s:5:\"71258\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta7\";a:15:{s:4:\"name\";s:20:\"entity 7.x-1.0-beta7\";s:7:\"version\";s:13:\"7.x-1.0-beta7\";s:3:\"tag\";s:13:\"7.x-1.0-beta7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/7.x-1.0-beta7\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-beta7.tar.gz\";s:4:\"date\";s:10:\"1298285230\";s:6:\"mdhash\";s:32:\"9598452892a90a3b098d3152334aeb85\";s:8:\"filesize\";s:5:\"72722\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta6\";a:15:{s:4:\"name\";s:20:\"entity 7.x-1.0-beta6\";s:7:\"version\";s:13:\"7.x-1.0-beta6\";s:3:\"tag\";s:13:\"7.x-1.0-beta6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/7.x-1.0-beta6\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-beta6.tar.gz\";s:4:\"date\";s:10:\"1294170388\";s:6:\"mdhash\";s:32:\"64588b70e6773d146e0bf4267a90a270\";s:8:\"filesize\";s:5:\"68465\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:13:\"7.x-1.0-beta5\";a:15:{s:4:\"name\";s:20:\"entity 7.x-1.0-beta5\";s:7:\"version\";s:13:\"7.x-1.0-beta5\";s:3:\"tag\";s:13:\"7.x-1.0-beta5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/7.x-1.0-beta5\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1293135097\";s:6:\"mdhash\";s:32:\"53325d82ab40c0dc325ccb59d0bca3e6\";s:8:\"filesize\";s:5:\"65300\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta4\";a:15:{s:4:\"name\";s:20:\"entity 7.x-1.0-beta4\";s:7:\"version\";s:13:\"7.x-1.0-beta4\";s:3:\"tag\";s:13:\"7.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/7.x-1.0-beta4\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1292941950\";s:6:\"mdhash\";s:32:\"93210f6c3b3b19258f217a64e6bd56a8\";s:8:\"filesize\";s:5:\"65305\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta3\";a:15:{s:4:\"name\";s:20:\"entity 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/7.x-1.0-beta3\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1291297866\";s:6:\"mdhash\";s:32:\"cb05413449da98da415d40e3520f0f6d\";s:8:\"filesize\";s:5:\"61957\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:20:\"entity 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1290197444\";s:6:\"mdhash\";s:32:\"a1646f5c1933772feb76e2dd31d6324b\";s:8:\"filesize\";s:5:\"60670\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:20:\"entity 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1286786762\";s:6:\"mdhash\";s:32:\"2e53243fdf0fae60217dd7916d982e47\";s:8:\"filesize\";s:5:\"54660\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha6\";a:15:{s:4:\"name\";s:21:\"entity 7.x-1.0-alpha6\";s:7:\"version\";s:14:\"7.x-1.0-alpha6\";s:3:\"tag\";s:14:\"7.x-1.0-alpha6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/entity/releases/7.x-1.0-alpha6\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-alpha6.tar.gz\";s:4:\"date\";s:10:\"1280228111\";s:6:\"mdhash\";s:32:\"5d88abea4508ea3561332f466746ab3d\";s:8:\"filesize\";s:5:\"47315\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha5\";a:15:{s:4:\"name\";s:21:\"entity 7.x-1.0-alpha5\";s:7:\"version\";s:14:\"7.x-1.0-alpha5\";s:3:\"tag\";s:14:\"7.x-1.0-alpha5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/entity/releases/7.x-1.0-alpha5\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1273607706\";s:6:\"mdhash\";s:32:\"13348a08070605b3742d4fad7856d76a\";s:8:\"filesize\";s:5:\"45331\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-1.0-alpha4\";a:15:{s:4:\"name\";s:21:\"entity 7.x-1.0-alpha4\";s:7:\"version\";s:14:\"7.x-1.0-alpha4\";s:3:\"tag\";s:14:\"7.x-1.0-alpha4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/entity/releases/7.x-1.0-alpha4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1268336409\";s:6:\"mdhash\";s:32:\"0e093c0ded92b23a4e628a7953a198dc\";s:8:\"filesize\";s:5:\"41614\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-1.0-alpha3\";a:15:{s:4:\"name\";s:21:\"entity 7.x-1.0-alpha3\";s:7:\"version\";s:14:\"7.x-1.0-alpha3\";s:3:\"tag\";s:14:\"7.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/entity/releases/7.x-1.0-alpha3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1266851413\";s:6:\"mdhash\";s:32:\"d347ca5528b9ed9d132b492cb4b7b2af\";s:8:\"filesize\";s:5:\"40746\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:21:\"entity 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/entity/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1263231309\";s:6:\"mdhash\";s:32:\"be9a91bd68b59480bdca9e8a6d6ad932\";s:8:\"filesize\";s:5:\"31954\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:21:\"entity 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/entity/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1260807922\";s:6:\"mdhash\";s:32:\"858c5a1b255f5316737dbbd3b562d825\";s:8:\"filesize\";s:5:\"29154\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:18:\"entity 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/entity/releases/7.x-1.x-dev\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/entity-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1489006983\";s:6:\"mdhash\";s:32:\"896905b4ea1cfc180d6f03bc5ab44378\";s:8:\"filesize\";s:6:\"124235\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447559,1500361146,1),('available_releases::entityreference','a:11:{s:5:\"title\";s:16:\"Entity reference\";s:10:\"short_name\";s:15:\"entityreference\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:46:\"https://www.drupal.org/project/entityreference\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:18:{s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:23:\"entityreference 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/entityreference/releases/7.x-1.4\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1495557183\";s:6:\"mdhash\";s:32:\"ce8bde18b2b0269f218a1e2dc17579ee\";s:8:\"filesize\";s:5:\"43230\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:23:\"entityreference 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/entityreference/releases/7.x-1.3\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1494450485\";s:6:\"mdhash\";s:32:\"e800309d10d254bd8e80770beb17f4f3\";s:8:\"filesize\";s:5:\"43171\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:23:\"entityreference 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/entityreference/releases/7.x-1.2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1474306739\";s:6:\"mdhash\";s:32:\"ef8f161721709dedcd1babc18b033006\";s:8:\"filesize\";s:5:\"40840\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:23:\"entityreference 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/entityreference/releases/7.x-1.1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1384973004\";s:6:\"mdhash\";s:32:\"604843bda17acbd927f71f8cf8a74a48\";s:8:\"filesize\";s:5:\"40371\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:23:\"entityreference 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1353230808\";s:6:\"mdhash\";s:32:\"81f458c4b41b61f405af905d2fd8a5ec\";s:8:\"filesize\";s:5:\"36787\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-1.0-rc5\";a:15:{s:4:\"name\";s:27:\"entityreference 7.x-1.0-rc5\";s:7:\"version\";s:11:\"7.x-1.0-rc5\";s:3:\"tag\";s:11:\"7.x-1.0-rc5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0-rc5\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0-rc5.tar.gz\";s:4:\"date\";s:10:\"1348565045\";s:6:\"mdhash\";s:32:\"648a462e0bc442533debbd0b1b98e665\";s:8:\"filesize\";s:5:\"32328\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.0-rc4\";a:15:{s:4:\"name\";s:27:\"entityreference 7.x-1.0-rc4\";s:7:\"version\";s:11:\"7.x-1.0-rc4\";s:3:\"tag\";s:11:\"7.x-1.0-rc4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0-rc4\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0-rc4.tar.gz\";s:4:\"date\";s:10:\"1348486666\";s:6:\"mdhash\";s:32:\"b1bdad67159df7cfa1edbc71ca1f15be\";s:8:\"filesize\";s:5:\"31223\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.0-rc3\";a:15:{s:4:\"name\";s:27:\"entityreference 7.x-1.0-rc3\";s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:3:\"tag\";s:11:\"7.x-1.0-rc3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0-rc3\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1338411956\";s:6:\"mdhash\";s:32:\"6f07ffafd42ec5fa9b76d398831c9956\";s:8:\"filesize\";s:5:\"30501\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.0-rc2\";a:15:{s:4:\"name\";s:27:\"entityreference 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0-rc2\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1338371757\";s:6:\"mdhash\";s:32:\"35336e7b27b1755db8464d786167081b\";s:8:\"filesize\";s:5:\"30494\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:27:\"entityreference 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1332279946\";s:6:\"mdhash\";s:32:\"83f006ab5235890efc2b3986f8dcdfe3\";s:8:\"filesize\";s:5:\"24495\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:13:\"7.x-1.0-beta5\";a:15:{s:4:\"name\";s:29:\"entityreference 7.x-1.0-beta5\";s:7:\"version\";s:13:\"7.x-1.0-beta5\";s:3:\"tag\";s:13:\"7.x-1.0-beta5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0-beta5\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1330297849\";s:6:\"mdhash\";s:32:\"1508867497f54a68acb9f92ca4cddcfe\";s:8:\"filesize\";s:5:\"24228\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:13:\"7.x-1.0-beta4\";a:15:{s:4:\"name\";s:29:\"entityreference 7.x-1.0-beta4\";s:7:\"version\";s:13:\"7.x-1.0-beta4\";s:3:\"tag\";s:13:\"7.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0-beta4\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1329149138\";s:6:\"mdhash\";s:32:\"7d5566cd6425d2dca4d0597984726eb8\";s:8:\"filesize\";s:5:\"24005\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:13:\"7.x-1.0-beta3\";a:15:{s:4:\"name\";s:29:\"entityreference 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0-beta3\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1324748139\";s:6:\"mdhash\";s:32:\"397fa7a810501fbb22390c8fb8ac10ef\";s:8:\"filesize\";s:5:\"19799\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:29:\"entityreference 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1322214940\";s:6:\"mdhash\";s:32:\"41b5dd4ed7115763e5b30c41a9a07c3d\";s:8:\"filesize\";s:5:\"19792\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:29:\"entityreference 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1316702804\";s:6:\"mdhash\";s:32:\"a056dc3e075e9b0783cb1addaad5086e\";s:8:\"filesize\";s:5:\"18948\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:30:\"entityreference 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1316171203\";s:6:\"mdhash\";s:32:\"0f5a3e9f3f998ed12d7c6bf1fd864274\";s:8:\"filesize\";s:5:\"17761\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:30:\"entityreference 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1313085717\";s:6:\"mdhash\";s:32:\"d17373159f2c745be04bf3ea2df7632d\";s:8:\"filesize\";s:5:\"10847\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:27:\"entityreference 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/entityreference/releases/7.x-1.x-dev\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1494943085\";s:6:\"mdhash\";s:32:\"3b31310e19437100905b2625d32a5c97\";s:8:\"filesize\";s:5:\"43242\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447560,1500361146,1),('available_releases::exclude_node_title','a:11:{s:5:\"title\";s:18:\"Exclude Node Title\";s:10:\"short_name\";s:18:\"exclude_node_title\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:49:\"https://www.drupal.org/project/exclude_node_title\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:11:{s:7:\"7.x-1.9\";a:14:{s:4:\"name\";s:26:\"exclude_node_title 7.x-1.9\";s:7:\"version\";s:7:\"7.x-1.9\";s:3:\"tag\";s:7:\"7.x-1.9\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/exclude_node_title/releases/7.x-1.9\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/exclude_node_title-7.x-1.9.tar.gz\";s:4:\"date\";s:10:\"1435338180\";s:6:\"mdhash\";s:32:\"341f2a3ff8473cdd37a9e8c689e58524\";s:8:\"filesize\";s:5:\"12171\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.8\";a:14:{s:4:\"name\";s:26:\"exclude_node_title 7.x-1.8\";s:7:\"version\";s:7:\"7.x-1.8\";s:3:\"tag\";s:7:\"7.x-1.8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/exclude_node_title/releases/7.x-1.8\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/exclude_node_title-7.x-1.8.tar.gz\";s:4:\"date\";s:10:\"1435276080\";s:6:\"mdhash\";s:32:\"930611a354bc7e73fd7f996c32571a66\";s:8:\"filesize\";s:5:\"12170\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.7\";a:14:{s:4:\"name\";s:26:\"exclude_node_title 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/exclude_node_title/releases/7.x-1.7\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/exclude_node_title-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1391152706\";s:6:\"mdhash\";s:32:\"92123575d8932a57bcfa0693060dbf27\";s:8:\"filesize\";s:5:\"12123\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:26:\"exclude_node_title 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/exclude_node_title/releases/7.x-1.6\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/exclude_node_title-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1357417950\";s:6:\"mdhash\";s:32:\"10b4719847848c8e4599ebb4c9790ca0\";s:8:\"filesize\";s:5:\"10411\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:26:\"exclude_node_title 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/exclude_node_title/releases/7.x-1.5\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/exclude_node_title-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1329984945\";s:6:\"mdhash\";s:32:\"456a6c50c2dfc3a77182824c359a5dc2\";s:8:\"filesize\";s:4:\"9824\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:26:\"exclude_node_title 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/exclude_node_title/releases/7.x-1.4\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/exclude_node_title-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1329650742\";s:6:\"mdhash\";s:32:\"253a57849ec850d2d47a8d622a1823b1\";s:8:\"filesize\";s:4:\"9600\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:26:\"exclude_node_title 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/exclude_node_title/releases/7.x-1.3\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/exclude_node_title-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1302553615\";s:6:\"mdhash\";s:32:\"043b2dada7ca5cc23985a73377e303ee\";s:8:\"filesize\";s:4:\"8122\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:26:\"exclude_node_title 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/exclude_node_title/releases/7.x-1.2\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/exclude_node_title-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1301381169\";s:6:\"mdhash\";s:32:\"96ce578829c03a20b2078a56bed8e195\";s:8:\"filesize\";s:4:\"8120\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:26:\"exclude_node_title 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/exclude_node_title/releases/7.x-1.1\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/exclude_node_title-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1300439768\";s:6:\"mdhash\";s:32:\"56ea939832aa85929af448750b199ed8\";s:8:\"filesize\";s:4:\"8123\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:26:\"exclude_node_title 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/exclude_node_title/releases/7.x-1.0\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/exclude_node_title-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1298532394\";s:6:\"mdhash\";s:32:\"2f8a0712a9f8fee222714af0b0aad99a\";s:8:\"filesize\";s:4:\"8181\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:30:\"exclude_node_title 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/exclude_node_title/releases/7.x-1.x-dev\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/exclude_node_title-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1447741760\";s:6:\"mdhash\";s:32:\"7fcdaebe749295402f3eb47a8ba1f0a9\";s:8:\"filesize\";s:5:\"12112\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447561,1500361146,1),('available_releases::facetapi','a:11:{s:5:\"title\";s:9:\"Facet API\";s:10:\"short_name\";s:8:\"facetapi\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:39:\"https://www.drupal.org/project/facetapi\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:20:{s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:16:\"facetapi 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/facetapi/releases/7.x-1.5\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/facetapi-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1405685327\";s:6:\"mdhash\";s:32:\"dca53ec6927d7731abddcfa1cd1c5a71\";s:8:\"filesize\";s:5:\"90649\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:16:\"facetapi 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/facetapi/releases/7.x-1.4\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/facetapi-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1404415728\";s:6:\"mdhash\";s:32:\"91d36ea7c583d4aed4c08acf4dbd5fb9\";s:8:\"filesize\";s:5:\"89698\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:16:\"facetapi 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/facetapi/releases/7.x-1.3\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/facetapi-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1364861711\";s:6:\"mdhash\";s:32:\"7492e8550da2d9560f5828bb855dd7cd\";s:8:\"filesize\";s:5:\"89029\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:16:\"facetapi 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/facetapi/releases/7.x-1.2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/facetapi-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1348169693\";s:6:\"mdhash\";s:32:\"eeaf4d05ed91487e41deededca8b93d0\";s:8:\"filesize\";s:5:\"88131\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:16:\"facetapi 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/facetapi/releases/7.x-1.1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/facetapi-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1343771560\";s:6:\"mdhash\";s:32:\"faed38452abd1b576eaa48ad80cc1614\";s:8:\"filesize\";s:5:\"87246\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:16:\"facetapi 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/facetapi/releases/7.x-1.0\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/facetapi-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1340904699\";s:6:\"mdhash\";s:32:\"27c1472487197e41ae6a8b5b68ad8a1f\";s:8:\"filesize\";s:5:\"81363\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-1.0-rc4\";a:15:{s:4:\"name\";s:20:\"facetapi 7.x-1.0-rc4\";s:7:\"version\";s:11:\"7.x-1.0-rc4\";s:3:\"tag\";s:11:\"7.x-1.0-rc4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/facetapi/releases/7.x-1.0-rc4\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/facetapi-7.x-1.0-rc4.tar.gz\";s:4:\"date\";s:10:\"1330124142\";s:6:\"mdhash\";s:32:\"f2cd1ddb8a9222db39ace8bfac560e8d\";s:8:\"filesize\";s:5:\"72506\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc3\";a:15:{s:4:\"name\";s:20:\"facetapi 7.x-1.0-rc3\";s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:3:\"tag\";s:11:\"7.x-1.0-rc3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/facetapi/releases/7.x-1.0-rc3\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/facetapi-7.x-1.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1329949842\";s:6:\"mdhash\";s:32:\"1f778705c5f5e3193e89670e81531371\";s:8:\"filesize\";s:5:\"72468\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc2\";a:15:{s:4:\"name\";s:20:\"facetapi 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/facetapi/releases/7.x-1.0-rc2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/facetapi-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1327885553\";s:6:\"mdhash\";s:32:\"d502b56e035059b22dc319bcf201fac7\";s:8:\"filesize\";s:5:\"72280\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:20:\"facetapi 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/facetapi/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/facetapi-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1325129740\";s:6:\"mdhash\";s:32:\"dcbc46afccce1074cc8620430a5b8738\";s:8:\"filesize\";s:5:\"71154\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta8\";a:15:{s:4:\"name\";s:22:\"facetapi 7.x-1.0-beta8\";s:7:\"version\";s:13:\"7.x-1.0-beta8\";s:3:\"tag\";s:13:\"7.x-1.0-beta8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/facetapi/releases/7.x-1.0-beta8\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/facetapi-7.x-1.0-beta8.tar.gz\";s:4:\"date\";s:10:\"1321386932\";s:6:\"mdhash\";s:32:\"77a920ad8582e38c00647a117dd25885\";s:8:\"filesize\";s:5:\"53347\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta7\";a:15:{s:4:\"name\";s:22:\"facetapi 7.x-1.0-beta7\";s:7:\"version\";s:13:\"7.x-1.0-beta7\";s:3:\"tag\";s:13:\"7.x-1.0-beta7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/facetapi/releases/7.x-1.0-beta7\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/facetapi-7.x-1.0-beta7.tar.gz\";s:4:\"date\";s:10:\"1318164132\";s:6:\"mdhash\";s:32:\"f29e047b363d25223c41eb072be45bc0\";s:8:\"filesize\";s:5:\"52112\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta6\";a:15:{s:4:\"name\";s:22:\"facetapi 7.x-1.0-beta6\";s:7:\"version\";s:13:\"7.x-1.0-beta6\";s:3:\"tag\";s:13:\"7.x-1.0-beta6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/facetapi/releases/7.x-1.0-beta6\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/facetapi-7.x-1.0-beta6.tar.gz\";s:4:\"date\";s:10:\"1313463716\";s:6:\"mdhash\";s:32:\"1c3c04560c0d6fbe3fb1007039e9179c\";s:8:\"filesize\";s:5:\"49073\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta5\";a:15:{s:4:\"name\";s:22:\"facetapi 7.x-1.0-beta5\";s:7:\"version\";s:13:\"7.x-1.0-beta5\";s:3:\"tag\";s:13:\"7.x-1.0-beta5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/facetapi/releases/7.x-1.0-beta5\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/facetapi-7.x-1.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1312127816\";s:6:\"mdhash\";s:32:\"38cf7628f9c03e06098281e3baa4afc7\";s:8:\"filesize\";s:5:\"45337\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta4\";a:15:{s:4:\"name\";s:22:\"facetapi 7.x-1.0-beta4\";s:7:\"version\";s:13:\"7.x-1.0-beta4\";s:3:\"tag\";s:13:\"7.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/facetapi/releases/7.x-1.0-beta4\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/facetapi-7.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1309629416\";s:6:\"mdhash\";s:32:\"4112081a2ac98e9401bbee7bdb8e9e56\";s:8:\"filesize\";s:5:\"36997\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta3\";a:15:{s:4:\"name\";s:22:\"facetapi 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/facetapi/releases/7.x-1.0-beta3\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/facetapi-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1306959115\";s:6:\"mdhash\";s:32:\"87a17770718399b3daa1a54d3827a510\";s:8:\"filesize\";s:5:\"35961\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:12:\"New features\";i:2;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:22:\"facetapi 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/facetapi/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/facetapi-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1306294915\";s:6:\"mdhash\";s:32:\"6224caa25e6b86d5724f271475a5c76a\";s:8:\"filesize\";s:5:\"34521\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:22:\"facetapi 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/facetapi/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/facetapi-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1304656015\";s:6:\"mdhash\";s:32:\"01979695b5810749dafff69ec1397f67\";s:8:\"filesize\";s:5:\"29590\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:20:\"facetapi 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/facetapi/releases/7.x-2.x-dev\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/facetapi-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1432221181\";s:6:\"mdhash\";s:32:\"320e28164514f34b517f0753f9a78f90\";s:8:\"filesize\";s:5:\"90663\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:20:\"facetapi 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/facetapi/releases/7.x-1.x-dev\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/facetapi-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1482179284\";s:6:\"mdhash\";s:32:\"ad810279e53f8f1888d243a4e1b968e4\";s:8:\"filesize\";s:5:\"93257\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447557,1500361146,1),('available_releases::features','a:11:{s:5:\"title\";s:8:\"Features\";s:10:\"short_name\";s:8:\"features\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:39:\"https://www.drupal.org/project/features\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:35:{s:8:\"7.x-2.10\";a:14:{s:4:\"name\";s:17:\"features 7.x-2.10\";s:7:\"version\";s:8:\"7.x-2.10\";s:3:\"tag\";s:8:\"7.x-2.10\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/features/releases/7.x-2.10\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/features-7.x-2.10.tar.gz\";s:4:\"date\";s:10:\"1461011639\";s:6:\"mdhash\";s:32:\"5641e5545020932570aed464fbaebf6a\";s:8:\"filesize\";s:5:\"97102\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.9\";a:14:{s:4:\"name\";s:16:\"features 7.x-2.9\";s:7:\"version\";s:7:\"7.x-2.9\";s:3:\"tag\";s:7:\"7.x-2.9\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/7.x-2.9\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-7.x-2.9.tar.gz\";s:4:\"date\";s:10:\"1460560739\";s:6:\"mdhash\";s:32:\"27fbaf1a31c83f0d18fbe114c2f3fc8a\";s:8:\"filesize\";s:5:\"97030\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.8\";a:14:{s:4:\"name\";s:16:\"features 7.x-2.8\";s:7:\"version\";s:7:\"7.x-2.8\";s:3:\"tag\";s:7:\"7.x-2.8\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/7.x-2.8\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-7.x-2.8.tar.gz\";s:4:\"date\";s:10:\"1458744539\";s:6:\"mdhash\";s:32:\"ad38d9cf2588bdd7821fc662217d6763\";s:8:\"filesize\";s:5:\"96932\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.7\";a:14:{s:4:\"name\";s:16:\"features 7.x-2.7\";s:7:\"version\";s:7:\"7.x-2.7\";s:3:\"tag\";s:7:\"7.x-2.7\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/7.x-2.7\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-7.x-2.7.tar.gz\";s:4:\"date\";s:10:\"1444829339\";s:6:\"mdhash\";s:32:\"dcfcc0cede1d281c23346662029015a5\";s:8:\"filesize\";s:5:\"97292\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:7:\"7.x-2.6\";a:14:{s:4:\"name\";s:16:\"features 7.x-2.6\";s:7:\"version\";s:7:\"7.x-2.6\";s:3:\"tag\";s:7:\"7.x-2.6\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/7.x-2.6\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-7.x-2.6.tar.gz\";s:4:\"date\";s:10:\"1435165980\";s:6:\"mdhash\";s:32:\"3a41eba4ca26f0d3a0e00e97dd8722ba\";s:8:\"filesize\";s:5:\"96581\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-2.6-rc1\";a:15:{s:4:\"name\";s:20:\"features 7.x-2.6-rc1\";s:7:\"version\";s:11:\"7.x-2.6-rc1\";s:3:\"tag\";s:11:\"7.x-2.6-rc1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"6\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/7.x-2.6-rc1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-7.x-2.6-rc1.tar.gz\";s:4:\"date\";s:10:\"1433533080\";s:6:\"mdhash\";s:32:\"ac68a860da89bd8a54f0cb5b7a2668ce\";s:8:\"filesize\";s:5:\"96592\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:7:\"7.x-2.5\";a:14:{s:4:\"name\";s:16:\"features 7.x-2.5\";s:7:\"version\";s:7:\"7.x-2.5\";s:3:\"tag\";s:7:\"7.x-2.5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/7.x-2.5\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-7.x-2.5.tar.gz\";s:4:\"date\";s:10:\"1428943813\";s:6:\"mdhash\";s:32:\"c6fea06d61fe6f4c9d1943a5fcb99f61\";s:8:\"filesize\";s:5:\"92795\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.4\";a:14:{s:4:\"name\";s:16:\"features 7.x-2.4\";s:7:\"version\";s:7:\"7.x-2.4\";s:3:\"tag\";s:7:\"7.x-2.4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/7.x-2.4\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-7.x-2.4.tar.gz\";s:4:\"date\";s:10:\"1425500581\";s:6:\"mdhash\";s:32:\"af6f0fd6117b5c0ff15ef7c1923d116f\";s:8:\"filesize\";s:5:\"92229\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.3\";a:14:{s:4:\"name\";s:16:\"features 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/7.x-2.3\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1420492080\";s:6:\"mdhash\";s:32:\"562c8c81a512e45d5fb04b4ee33858bf\";s:8:\"filesize\";s:5:\"92013\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:16:\"features 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/7.x-2.2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1407338927\";s:6:\"mdhash\";s:32:\"1eaa764a12b7ad846ab3ffa70512c567\";s:8:\"filesize\";s:5:\"92041\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:16:\"features 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/7.x-2.1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1406655227\";s:6:\"mdhash\";s:32:\"4e95d6671dbdaa0e8c8bd1ce9cf04ead\";s:8:\"filesize\";s:5:\"92052\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:16:\"features 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/7.x-2.0\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1382018758\";s:6:\"mdhash\";s:32:\"2ce7c8cb75d3fc57da069721f6a9a052\";s:8:\"filesize\";s:5:\"90313\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:11:\"7.x-2.0-rc5\";a:15:{s:4:\"name\";s:20:\"features 7.x-2.0-rc5\";s:7:\"version\";s:11:\"7.x-2.0-rc5\";s:3:\"tag\";s:11:\"7.x-2.0-rc5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/7.x-2.0-rc5\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-7.x-2.0-rc5.tar.gz\";s:4:\"date\";s:10:\"1381157303\";s:6:\"mdhash\";s:32:\"faf76e87122ff5140a7a8300c96e8389\";s:8:\"filesize\";s:5:\"90231\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.0-rc4\";a:15:{s:4:\"name\";s:20:\"features 7.x-2.0-rc4\";s:7:\"version\";s:11:\"7.x-2.0-rc4\";s:3:\"tag\";s:11:\"7.x-2.0-rc4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/7.x-2.0-rc4\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-7.x-2.0-rc4.tar.gz\";s:4:\"date\";s:10:\"1380815748\";s:6:\"mdhash\";s:32:\"71aa54041d07e2b773efb692c2d13476\";s:8:\"filesize\";s:5:\"90706\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.0-rc3\";a:15:{s:4:\"name\";s:20:\"features 7.x-2.0-rc3\";s:7:\"version\";s:11:\"7.x-2.0-rc3\";s:3:\"tag\";s:11:\"7.x-2.0-rc3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/7.x-2.0-rc3\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-7.x-2.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1377548845\";s:6:\"mdhash\";s:32:\"d92bf152081ba92b2c352b0164198e17\";s:8:\"filesize\";s:5:\"88117\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.0-rc2\";a:15:{s:4:\"name\";s:20:\"features 7.x-2.0-rc2\";s:7:\"version\";s:11:\"7.x-2.0-rc2\";s:3:\"tag\";s:11:\"7.x-2.0-rc2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/7.x-2.0-rc2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-7.x-2.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1375464067\";s:6:\"mdhash\";s:32:\"63db49c3d8285277b787afa237e96454\";s:8:\"filesize\";s:5:\"87769\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.0-rc1\";a:15:{s:4:\"name\";s:20:\"features 7.x-2.0-rc1\";s:7:\"version\";s:11:\"7.x-2.0-rc1\";s:3:\"tag\";s:11:\"7.x-2.0-rc1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/7.x-2.0-rc1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-7.x-2.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1369094412\";s:6:\"mdhash\";s:32:\"303cd7d10ec0a84e500fd1693d2d3fd0\";s:8:\"filesize\";s:5:\"85917\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta2\";a:15:{s:4:\"name\";s:22:\"features 7.x-2.0-beta2\";s:7:\"version\";s:13:\"7.x-2.0-beta2\";s:3:\"tag\";s:13:\"7.x-2.0-beta2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/7.x-2.0-beta2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-7.x-2.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1364589018\";s:6:\"mdhash\";s:32:\"d889b7006668c261294e58a31b40c53e\";s:8:\"filesize\";s:5:\"85069\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta1\";a:15:{s:4:\"name\";s:22:\"features 7.x-2.0-beta1\";s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:3:\"tag\";s:13:\"7.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/7.x-2.0-beta1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-7.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1352395006\";s:6:\"mdhash\";s:32:\"654e54d22922d4cdbdf1b78be19c5cda\";s:8:\"filesize\";s:5:\"83547\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha2\";a:15:{s:4:\"name\";s:23:\"features 7.x-2.0-alpha2\";s:7:\"version\";s:14:\"7.x-2.0-alpha2\";s:3:\"tag\";s:14:\"7.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/features/releases/7.x-2.0-alpha2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/features-7.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1351907522\";s:6:\"mdhash\";s:32:\"f588de7611e09d4460a6cd92bf133200\";s:8:\"filesize\";s:5:\"83533\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:16:\"features 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/7.x-1.0\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1343240292\";s:6:\"mdhash\";s:32:\"00984913badb19fee69d3ee0ac27eee8\";s:8:\"filesize\";s:5:\"72114\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-1.0-rc3\";a:15:{s:4:\"name\";s:20:\"features 7.x-1.0-rc3\";s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:3:\"tag\";s:11:\"7.x-1.0-rc3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/7.x-1.0-rc3\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-7.x-1.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1339680981\";s:6:\"mdhash\";s:32:\"bb8ac718377cd098474e37f202181b03\";s:8:\"filesize\";s:5:\"71806\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc2\";a:15:{s:4:\"name\";s:20:\"features 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/7.x-1.0-rc2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1334345807\";s:6:\"mdhash\";s:32:\"0b559938e0aa604729eb2b2fb4840f1b\";s:8:\"filesize\";s:5:\"69926\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:20:\"features 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1332022247\";s:6:\"mdhash\";s:32:\"a4f24fe0f0ac5e099b18c667253fa8bc\";s:8:\"filesize\";s:5:\"68737\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta6\";a:15:{s:4:\"name\";s:22:\"features 7.x-1.0-beta6\";s:7:\"version\";s:13:\"7.x-1.0-beta6\";s:3:\"tag\";s:13:\"7.x-1.0-beta6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/7.x-1.0-beta6\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-7.x-1.0-beta6.tar.gz\";s:4:\"date\";s:10:\"1325627143\";s:6:\"mdhash\";s:32:\"d65f3131ad8d397bd5437fe4ab7dba0a\";s:8:\"filesize\";s:5:\"68900\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta5\";a:15:{s:4:\"name\";s:22:\"features 7.x-1.0-beta5\";s:7:\"version\";s:13:\"7.x-1.0-beta5\";s:3:\"tag\";s:13:\"7.x-1.0-beta5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/7.x-1.0-beta5\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-7.x-1.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1324573544\";s:6:\"mdhash\";s:32:\"10053380081d77c6e1cc107ea17bd81e\";s:8:\"filesize\";s:5:\"68894\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta4\";a:15:{s:4:\"name\";s:22:\"features 7.x-1.0-beta4\";s:7:\"version\";s:13:\"7.x-1.0-beta4\";s:3:\"tag\";s:13:\"7.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/7.x-1.0-beta4\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-7.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1316565919\";s:6:\"mdhash\";s:32:\"fbce2ff07b59723d6688ceeac97a967a\";s:8:\"filesize\";s:5:\"67007\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta3\";a:15:{s:4:\"name\";s:22:\"features 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/7.x-1.0-beta3\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1308598915\";s:6:\"mdhash\";s:32:\"20db76b147faf56cc2c1c413cf187db3\";s:8:\"filesize\";s:5:\"63951\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:22:\"features 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1302049346\";s:6:\"mdhash\";s:32:\"333424ca64d3278cb51319b842e218b2\";s:8:\"filesize\";s:5:\"63505\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:22:\"features 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1298073121\";s:6:\"mdhash\";s:32:\"a5a58e87c3e18dd77ae0e2fb512531d1\";s:8:\"filesize\";s:5:\"68372\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha3\";a:15:{s:4:\"name\";s:23:\"features 7.x-1.0-alpha3\";s:7:\"version\";s:14:\"7.x-1.0-alpha3\";s:3:\"tag\";s:14:\"7.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/features/releases/7.x-1.0-alpha3\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/features-7.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1285791063\";s:6:\"mdhash\";s:32:\"09651bc4edb61969d1caa23c76c2df00\";s:8:\"filesize\";s:5:\"67846\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:23:\"features 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/features/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/features-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1285602662\";s:6:\"mdhash\";s:32:\"b7bcfb6b3a7ac54cac600153642c7aab\";s:8:\"filesize\";s:5:\"67869\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:23:\"features 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/features/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/features-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1284158807\";s:6:\"mdhash\";s:32:\"829c91a7111886b3f53278fd44346ec7\";s:8:\"filesize\";s:5:\"67845\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:20:\"features 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/7.x-2.x-dev\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1473863339\";s:6:\"mdhash\";s:32:\"5ac1876694e412976d22f572294de436\";s:8:\"filesize\";s:5:\"97121\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:20:\"features 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/7.x-1.x-dev\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380578130\";s:6:\"mdhash\";s:32:\"baaa489bb72393a5168683c4c27f29dc\";s:8:\"filesize\";s:5:\"73847\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447561,1500361146,1),('available_releases::field_collection','a:11:{s:5:\"title\";s:16:\"Field collection\";s:10:\"short_name\";s:16:\"field_collection\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:47:\"https://www.drupal.org/project/field_collection\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:12:{s:14:\"7.x-1.0-beta12\";a:15:{s:4:\"name\";s:31:\"field_collection 7.x-1.0-beta12\";s:7:\"version\";s:14:\"7.x-1.0-beta12\";s:3:\"tag\";s:14:\"7.x-1.0-beta12\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/field_collection/releases/7.x-1.0-beta12\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.0-beta12.tar.gz\";s:4:\"date\";s:10:\"1479402842\";s:6:\"mdhash\";s:32:\"e966ba0c2ad40b9b044ae8bdf993f5ed\";s:8:\"filesize\";s:5:\"51018\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"7.x-1.0-beta11\";a:15:{s:4:\"name\";s:31:\"field_collection 7.x-1.0-beta11\";s:7:\"version\";s:14:\"7.x-1.0-beta11\";s:3:\"tag\";s:14:\"7.x-1.0-beta11\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/field_collection/releases/7.x-1.0-beta11\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.0-beta11.tar.gz\";s:4:\"date\";s:10:\"1454338739\";s:6:\"mdhash\";s:32:\"0f51a97383cd50f72a2ecd950cce5e1a\";s:8:\"filesize\";s:5:\"40461\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"7.x-1.0-beta10\";a:15:{s:4:\"name\";s:31:\"field_collection 7.x-1.0-beta10\";s:7:\"version\";s:14:\"7.x-1.0-beta10\";s:3:\"tag\";s:14:\"7.x-1.0-beta10\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/field_collection/releases/7.x-1.0-beta10\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.0-beta10.tar.gz\";s:4:\"date\";s:10:\"1445529539\";s:6:\"mdhash\";s:32:\"bb00b6d371b096732071ad7999223c5a\";s:8:\"filesize\";s:5:\"40443\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}s:13:\"7.x-1.0-beta9\";a:15:{s:4:\"name\";s:30:\"field_collection 7.x-1.0-beta9\";s:7:\"version\";s:13:\"7.x-1.0-beta9\";s:3:\"tag\";s:13:\"7.x-1.0-beta9\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/field_collection/releases/7.x-1.0-beta9\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.0-beta9.tar.gz\";s:4:\"date\";s:10:\"1445282939\";s:6:\"mdhash\";s:32:\"99910b78ea9fdda42a746089b579152c\";s:8:\"filesize\";s:5:\"40406\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}s:13:\"7.x-1.0-beta8\";a:15:{s:4:\"name\";s:30:\"field_collection 7.x-1.0-beta8\";s:7:\"version\";s:13:\"7.x-1.0-beta8\";s:3:\"tag\";s:13:\"7.x-1.0-beta8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/field_collection/releases/7.x-1.0-beta8\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.0-beta8.tar.gz\";s:4:\"date\";s:10:\"1415122380\";s:6:\"mdhash\";s:32:\"50e687acf3779b987bacde5ad047fb46\";s:8:\"filesize\";s:5:\"38360\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta7\";a:15:{s:4:\"name\";s:30:\"field_collection 7.x-1.0-beta7\";s:7:\"version\";s:13:\"7.x-1.0-beta7\";s:3:\"tag\";s:13:\"7.x-1.0-beta7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/field_collection/releases/7.x-1.0-beta7\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.0-beta7.tar.gz\";s:4:\"date\";s:10:\"1394731105\";s:6:\"mdhash\";s:32:\"8678d50f7248d4830a615f451c623201\";s:8:\"filesize\";s:5:\"36080\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta5\";a:15:{s:4:\"name\";s:30:\"field_collection 7.x-1.0-beta5\";s:7:\"version\";s:13:\"7.x-1.0-beta5\";s:3:\"tag\";s:13:\"7.x-1.0-beta5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/field_collection/releases/7.x-1.0-beta5\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1356475964\";s:6:\"mdhash\";s:32:\"e881931a5e0fea9ff844385c80743a54\";s:8:\"filesize\";s:5:\"33162\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta4\";a:15:{s:4:\"name\";s:30:\"field_collection 7.x-1.0-beta4\";s:7:\"version\";s:13:\"7.x-1.0-beta4\";s:3:\"tag\";s:13:\"7.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/field_collection/releases/7.x-1.0-beta4\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1333382446\";s:6:\"mdhash\";s:32:\"591e8d3bcc5f0af52710680529308d8e\";s:8:\"filesize\";s:5:\"26573\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}s:13:\"7.x-1.0-beta3\";a:15:{s:4:\"name\";s:30:\"field_collection 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/field_collection/releases/7.x-1.0-beta3\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1327376442\";s:6:\"mdhash\";s:32:\"ef0e3a56c77e50a59f0ae965d70b58b3\";s:8:\"filesize\";s:5:\"25613\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:30:\"field_collection 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/field_collection/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1313670125\";s:6:\"mdhash\";s:32:\"b4ee245a67c07332b3b2fa2d83ba7e1a\";s:8:\"filesize\";s:5:\"21012\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:30:\"field_collection 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/field_collection/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1296573488\";s:6:\"mdhash\";s:32:\"7c644203e32cc8c6d2d1bd5400b5c361\";s:8:\"filesize\";s:5:\"17272\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:28:\"field_collection 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/field_collection/releases/7.x-1.x-dev\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1481300583\";s:6:\"mdhash\";s:32:\"cedb190a2c89f6280843a7672094e0bc\";s:8:\"filesize\";s:5:\"51053\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}}}',1500447562,1500361146,1),('available_releases::field_collection_table','a:11:{s:5:\"title\";s:22:\"Field Collection Table\";s:10:\"short_name\";s:22:\"field_collection_table\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:53:\"https://www.drupal.org/project/field_collection_table\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:8:{s:13:\"7.x-1.0-beta5\";a:15:{s:4:\"name\";s:36:\"field_collection_table 7.x-1.0-beta5\";s:7:\"version\";s:13:\"7.x-1.0-beta5\";s:3:\"tag\";s:13:\"7.x-1.0-beta5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:76:\"https://www.drupal.org/project/field_collection_table/releases/7.x-1.0-beta5\";s:13:\"download_link\";s:81:\"https://ftp.drupal.org/files/projects/field_collection_table-7.x-1.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1487676484\";s:6:\"mdhash\";s:32:\"ced1140ecd52939839e89bb664f33c68\";s:8:\"filesize\";s:5:\"12501\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta4\";a:15:{s:4:\"name\";s:36:\"field_collection_table 7.x-1.0-beta4\";s:7:\"version\";s:13:\"7.x-1.0-beta4\";s:3:\"tag\";s:13:\"7.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:76:\"https://www.drupal.org/project/field_collection_table/releases/7.x-1.0-beta4\";s:13:\"download_link\";s:81:\"https://ftp.drupal.org/files/projects/field_collection_table-7.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1485174782\";s:6:\"mdhash\";s:32:\"72ff4f6d9375c5de0ec9d476bc5e2e09\";s:8:\"filesize\";s:5:\"12112\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta3\";a:15:{s:4:\"name\";s:36:\"field_collection_table 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:76:\"https://www.drupal.org/project/field_collection_table/releases/7.x-1.0-beta3\";s:13:\"download_link\";s:81:\"https://ftp.drupal.org/files/projects/field_collection_table-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1446939839\";s:6:\"mdhash\";s:32:\"0f4bd8b2fd100bd0c2943b7f42286048\";s:8:\"filesize\";s:5:\"12869\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:36:\"field_collection_table 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:76:\"https://www.drupal.org/project/field_collection_table/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:81:\"https://ftp.drupal.org/files/projects/field_collection_table-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1426689181\";s:6:\"mdhash\";s:32:\"8387b8d79c4fb6552e48b964054aff02\";s:8:\"filesize\";s:5:\"11616\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:36:\"field_collection_table 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:76:\"https://www.drupal.org/project/field_collection_table/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:81:\"https://ftp.drupal.org/files/projects/field_collection_table-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1323980440\";s:6:\"mdhash\";s:32:\"bb3436cf5b88610fbc23d6ac4201a4f1\";s:8:\"filesize\";s:5:\"10846\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:37:\"field_collection_table 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:77:\"https://www.drupal.org/project/field_collection_table/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:82:\"https://ftp.drupal.org/files/projects/field_collection_table-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1315687302\";s:6:\"mdhash\";s:32:\"e76b08732766f0d1fbfd7b81abeb7af8\";s:8:\"filesize\";s:4:\"9689\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:37:\"field_collection_table 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:77:\"https://www.drupal.org/project/field_collection_table/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:82:\"https://ftp.drupal.org/files/projects/field_collection_table-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1309925224\";s:6:\"mdhash\";s:32:\"1f787a391576e45e6846be1310cae6bf\";s:8:\"filesize\";s:4:\"8531\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:34:\"field_collection_table 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:74:\"https://www.drupal.org/project/field_collection_table/releases/7.x-1.x-dev\";s:13:\"download_link\";s:79:\"https://ftp.drupal.org/files/projects/field_collection_table-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1487676183\";s:6:\"mdhash\";s:32:\"322d5f7c30adfe2e5fb413d4f8e4ac21\";s:8:\"filesize\";s:5:\"12515\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}}}',1500447562,1500361146,1),('available_releases::field_formatter_class','a:11:{s:5:\"title\";s:21:\"Field Formatter Class\";s:10:\"short_name\";s:21:\"field_formatter_class\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:52:\"https://www.drupal.org/project/field_formatter_class\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:4:{s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:29:\"field_formatter_class 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/field_formatter_class/releases/7.x-1.1\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/field_formatter_class-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1361374878\";s:6:\"mdhash\";s:32:\"fcddd9d46e482811643a4340ccda7f13\";s:8:\"filesize\";s:4:\"8470\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:29:\"field_formatter_class 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/field_formatter_class/releases/7.x-1.0\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/field_formatter_class-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1336422355\";s:6:\"mdhash\";s:32:\"404509b98289aee537d744f32c9faebf\";s:8:\"filesize\";s:4:\"8124\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:33:\"field_formatter_class 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:73:\"https://www.drupal.org/project/field_formatter_class/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:78:\"https://ftp.drupal.org/files/projects/field_formatter_class-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1335133878\";s:6:\"mdhash\";s:32:\"e0fae9021ed172082fc4bf1ab573dbb1\";s:8:\"filesize\";s:4:\"8123\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:33:\"field_formatter_class 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:73:\"https://www.drupal.org/project/field_formatter_class/releases/7.x-1.x-dev\";s:13:\"download_link\";s:78:\"https://ftp.drupal.org/files/projects/field_formatter_class-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380578834\";s:6:\"mdhash\";s:32:\"11c5ffa86c4099746ad6a4076b2f67ed\";s:8:\"filesize\";s:4:\"8477\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447563,1500361146,1),('available_releases::field_formatter_settings','a:11:{s:5:\"title\";s:24:\"Field formatter settings\";s:10:\"short_name\";s:24:\"field_formatter_settings\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:55:\"https://www.drupal.org/project/field_formatter_settings\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:4:{s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:32:\"field_formatter_settings 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/field_formatter_settings/releases/7.x-1.1\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/field_formatter_settings-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1378741904\";s:6:\"mdhash\";s:32:\"d7bc7a84011a904f945b4fc54ff6eec0\";s:8:\"filesize\";s:4:\"9545\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:32:\"field_formatter_settings 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/field_formatter_settings/releases/7.x-1.0\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/field_formatter_settings-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1345588632\";s:6:\"mdhash\";s:32:\"9a567846d2b71bd2385b420452218b68\";s:8:\"filesize\";s:4:\"9457\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:38:\"field_formatter_settings 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:78:\"https://www.drupal.org/project/field_formatter_settings/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:83:\"https://ftp.drupal.org/files/projects/field_formatter_settings-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1291403467\";s:6:\"mdhash\";s:32:\"4859595ca1e12604b9a0cb05a66c20ab\";s:8:\"filesize\";s:4:\"7878\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:36:\"field_formatter_settings 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:76:\"https://www.drupal.org/project/field_formatter_settings/releases/7.x-1.x-dev\";s:13:\"download_link\";s:81:\"https://ftp.drupal.org/files/projects/field_formatter_settings-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1437594539\";s:6:\"mdhash\";s:32:\"d5a7bb88068056c117889b1fe58aa536\";s:8:\"filesize\";s:4:\"9622\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447563,1500361146,1),('available_releases::field_group','a:11:{s:5:\"title\";s:11:\"Field Group\";s:10:\"short_name\";s:11:\"field_group\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:42:\"https://www.drupal.org/project/field_group\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:10:{s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:19:\"field_group 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/field_group/releases/7.x-1.5\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/field_group-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1452033539\";s:6:\"mdhash\";s:32:\"8d91e0f3cc8106deefe038d5fc07d3e6\";s:8:\"filesize\";s:5:\"51465\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:19:\"field_group 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/field_group/releases/7.x-1.4\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/field_group-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1401918527\";s:6:\"mdhash\";s:32:\"fa268e0c23b2af31ed560aa03a986cf1\";s:8:\"filesize\";s:5:\"51303\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:19:\"field_group 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/field_group/releases/7.x-1.3\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/field_group-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1380124361\";s:6:\"mdhash\";s:32:\"6ea6a2b8a15c9c68d981f5b0ae6f881c\";s:8:\"filesize\";s:5:\"50593\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:19:\"field_group 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/field_group/releases/7.x-1.2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/field_group-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1377806210\";s:6:\"mdhash\";s:32:\"ea1b1af0b09f7578cffc261c8c5203df\";s:8:\"filesize\";s:5:\"49436\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:19:\"field_group 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/field_group/releases/7.x-1.1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/field_group-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1319051133\";s:6:\"mdhash\";s:32:\"4f02e7b10aff66e3bcdae002d6b80ec6\";s:8:\"filesize\";s:5:\"43065\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:19:\"field_group 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/field_group/releases/7.x-1.0\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/field_group-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1306266416\";s:6:\"mdhash\";s:32:\"5f549fbc7cbfa575a11a9d705a3df597\";s:8:\"filesize\";s:5:\"33471\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-1.0-rc2\";a:15:{s:4:\"name\";s:23:\"field_group 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_group/releases/7.x-1.0-rc2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_group-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1300283167\";s:6:\"mdhash\";s:32:\"959768b52b8d4c04be0e8f8e93f4af1b\";s:8:\"filesize\";s:5:\"32537\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:23:\"field_group 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_group/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_group-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1295392936\";s:6:\"mdhash\";s:32:\"aaa22e6444d2377e9673e5cfd6f21095\";s:8:\"filesize\";s:5:\"30414\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:23:\"field_group 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_group/releases/7.x-2.x-dev\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_group-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380578862\";s:6:\"mdhash\";s:32:\"3ff6c75931a1668be98876378b7c2ebf\";s:8:\"filesize\";s:5:\"41104\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:23:\"field_group 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_group/releases/7.x-1.x-dev\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_group-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1495281183\";s:6:\"mdhash\";s:32:\"fecf1de862c9933f9669961b9b7ad781\";s:8:\"filesize\";s:5:\"51806\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447564,1500361146,1),('available_releases::field_slideshow','a:11:{s:5:\"title\";s:15:\"Field Slideshow\";s:10:\"short_name\";s:15:\"field_slideshow\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:3:\"1,2\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:46:\"https://www.drupal.org/project/field_slideshow\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:19:{s:13:\"7.x-2.0-beta1\";a:15:{s:4:\"name\";s:29:\"field_slideshow 7.x-2.0-beta1\";s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:3:\"tag\";s:13:\"7.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/field_slideshow/releases/7.x-2.0-beta1\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/field_slideshow-7.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1427029981\";s:6:\"mdhash\";s:32:\"f758c524b1b447f74385c7fd24f30234\";s:8:\"filesize\";s:5:\"20135\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:8:\"7.x-1.82\";a:14:{s:4:\"name\";s:24:\"field_slideshow 7.x-1.82\";s:7:\"version\";s:8:\"7.x-1.82\";s:3:\"tag\";s:8:\"7.x-1.82\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"82\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/field_slideshow/releases/7.x-1.82\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/field_slideshow-7.x-1.82.tar.gz\";s:4:\"date\";s:10:\"1363270823\";s:6:\"mdhash\";s:32:\"9f586cf88fa62ead440bd8ad6ec48eaa\";s:8:\"filesize\";s:5:\"19377\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.81\";a:14:{s:4:\"name\";s:24:\"field_slideshow 7.x-1.81\";s:7:\"version\";s:8:\"7.x-1.81\";s:3:\"tag\";s:8:\"7.x-1.81\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"81\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/field_slideshow/releases/7.x-1.81\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/field_slideshow-7.x-1.81.tar.gz\";s:4:\"date\";s:10:\"1359010311\";s:6:\"mdhash\";s:32:\"9d318ebe3b2ca537e297b472f93e60b6\";s:8:\"filesize\";s:5:\"19352\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.8\";a:14:{s:4:\"name\";s:23:\"field_slideshow 7.x-1.8\";s:7:\"version\";s:7:\"7.x-1.8\";s:3:\"tag\";s:7:\"7.x-1.8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_slideshow/releases/7.x-1.8\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_slideshow-7.x-1.8.tar.gz\";s:4:\"date\";s:10:\"1352716302\";s:6:\"mdhash\";s:32:\"34a25cf50d7d3cccf3dc9ac965fb554c\";s:8:\"filesize\";s:5:\"19180\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.7\";a:14:{s:4:\"name\";s:23:\"field_slideshow 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_slideshow/releases/7.x-1.7\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_slideshow-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1349242272\";s:6:\"mdhash\";s:32:\"c504eaecb53ea7d7f7f137f20def73b9\";s:8:\"filesize\";s:5:\"18612\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:23:\"field_slideshow 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_slideshow/releases/7.x-1.6\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_slideshow-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1328169943\";s:6:\"mdhash\";s:32:\"57103ff3118d9e9333b2d1303f485c27\";s:8:\"filesize\";s:5:\"16567\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:23:\"field_slideshow 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_slideshow/releases/7.x-1.5\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_slideshow-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1324645840\";s:6:\"mdhash\";s:32:\"b36861cc5dc7d2fb88fdc91c949f5a9d\";s:8:\"filesize\";s:5:\"16111\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:23:\"field_slideshow 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_slideshow/releases/7.x-1.4\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_slideshow-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1324567840\";s:6:\"mdhash\";s:32:\"15975c7b7693894d605d8ba6c3bd2959\";s:8:\"filesize\";s:5:\"16023\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:23:\"field_slideshow 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_slideshow/releases/7.x-1.3\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_slideshow-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1324469442\";s:6:\"mdhash\";s:32:\"ee3a5cd2ce7d7602f056f667e6300bc0\";s:8:\"filesize\";s:5:\"16029\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:23:\"field_slideshow 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_slideshow/releases/7.x-1.2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_slideshow-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1314689520\";s:6:\"mdhash\";s:32:\"3d7a8a65b5354c83da834ce9f0724935\";s:8:\"filesize\";s:5:\"22573\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:23:\"field_slideshow 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_slideshow/releases/7.x-1.1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_slideshow-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1305725516\";s:6:\"mdhash\";s:32:\"e8f9ece040fc734fdac766d596259893\";s:8:\"filesize\";s:5:\"21537\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:23:\"field_slideshow 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_slideshow/releases/7.x-1.0\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_slideshow-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1300986068\";s:6:\"mdhash\";s:32:\"0bbc3fefe3be61b961786b3b707a6166\";s:8:\"filesize\";s:5:\"18922\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-1.0-rc2\";a:15:{s:4:\"name\";s:27:\"field_slideshow 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/field_slideshow/releases/7.x-1.0-rc2\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/field_slideshow-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1298562419\";s:6:\"mdhash\";s:32:\"908eb7b803a81100368f3adf3bb614fb\";s:8:\"filesize\";s:5:\"18377\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:27:\"field_slideshow 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/field_slideshow/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/field_slideshow-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1297969529\";s:6:\"mdhash\";s:32:\"cd30811763163cbbee4fe41f7ae1865f\";s:8:\"filesize\";s:5:\"17659\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta3\";a:15:{s:4:\"name\";s:29:\"field_slideshow 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/field_slideshow/releases/7.x-1.0-beta3\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/field_slideshow-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1296401595\";s:6:\"mdhash\";s:32:\"8ec7d4c0ad55e77e879486d1d8db4b92\";s:8:\"filesize\";s:5:\"17010\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:29:\"field_slideshow 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/field_slideshow/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/field_slideshow-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1295297810\";s:6:\"mdhash\";s:32:\"6204eb24207ef6f4e144787b75cb4e37\";s:8:\"filesize\";s:5:\"16554\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:29:\"field_slideshow 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/field_slideshow/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/field_slideshow-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1294748510\";s:6:\"mdhash\";s:32:\"90e75b26900092834be207b5129374e7\";s:8:\"filesize\";s:5:\"16061\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:27:\"field_slideshow 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/field_slideshow/releases/7.x-2.x-dev\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/field_slideshow-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1427028481\";s:6:\"mdhash\";s:32:\"a21501069a80cd2446e04ddd1aecff8d\";s:8:\"filesize\";s:5:\"20133\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:27:\"field_slideshow 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/field_slideshow/releases/7.x-1.x-dev\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/field_slideshow-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380578963\";s:6:\"mdhash\";s:32:\"e5874953303cfd31e9c8a6d58e18f709\";s:8:\"filesize\";s:5:\"19406\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447564,1500361146,1),('available_releases::fivestar','a:11:{s:5:\"title\";s:8:\"Fivestar\";s:10:\"short_name\";s:8:\"fivestar\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:39:\"https://www.drupal.org/project/fivestar\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:10:{s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:16:\"fivestar 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/fivestar/releases/7.x-2.2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/fivestar-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1461406441\";s:6:\"mdhash\";s:32:\"ed5cb540db0944a47d7f09657b39d7e4\";s:8:\"filesize\";s:6:\"226248\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:16:\"fivestar 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/fivestar/releases/7.x-2.1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/fivestar-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1395087832\";s:6:\"mdhash\";s:32:\"ab74125c5ff622a55d3c029ad91c82ff\";s:8:\"filesize\";s:6:\"226676\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-2.0-rc3\";a:15:{s:4:\"name\";s:20:\"fivestar 7.x-2.0-rc3\";s:7:\"version\";s:11:\"7.x-2.0-rc3\";s:3:\"tag\";s:11:\"7.x-2.0-rc3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/fivestar/releases/7.x-2.0-rc3\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/fivestar-7.x-2.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1394544996\";s:6:\"mdhash\";s:32:\"7ba894cefa67ccd33d87bfb715f9a0f1\";s:8:\"filesize\";s:6:\"226676\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.0-rc2\";a:15:{s:4:\"name\";s:20:\"fivestar 7.x-2.0-rc2\";s:7:\"version\";s:11:\"7.x-2.0-rc2\";s:3:\"tag\";s:11:\"7.x-2.0-rc2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/fivestar/releases/7.x-2.0-rc2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/fivestar-7.x-2.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1394386705\";s:6:\"mdhash\";s:32:\"ddaac2b3a4c178300ede150b9325e440\";s:8:\"filesize\";s:6:\"227037\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.0-rc1\";a:15:{s:4:\"name\";s:20:\"fivestar 7.x-2.0-rc1\";s:7:\"version\";s:11:\"7.x-2.0-rc1\";s:3:\"tag\";s:11:\"7.x-2.0-rc1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/fivestar/releases/7.x-2.0-rc1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/fivestar-7.x-2.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1393790305\";s:6:\"mdhash\";s:32:\"82689969e410ebf763a7e4a39b6b7631\";s:8:\"filesize\";s:6:\"226649\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta1\";a:15:{s:4:\"name\";s:22:\"fivestar 7.x-2.0-beta1\";s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:3:\"tag\";s:13:\"7.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/fivestar/releases/7.x-2.0-beta1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/fivestar-7.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1392552805\";s:6:\"mdhash\";s:32:\"3ba9ebc0430d4f95564418b584b4c763\";s:8:\"filesize\";s:6:\"225330\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha3\";a:15:{s:4:\"name\";s:23:\"fivestar 7.x-2.0-alpha3\";s:7:\"version\";s:14:\"7.x-2.0-alpha3\";s:3:\"tag\";s:14:\"7.x-2.0-alpha3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/fivestar/releases/7.x-2.0-alpha3\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/fivestar-7.x-2.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1391276005\";s:6:\"mdhash\";s:32:\"1571a761135705581c3f1f33a3bcb293\";s:8:\"filesize\";s:6:\"223936\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha2\";a:15:{s:4:\"name\";s:23:\"fivestar 7.x-2.0-alpha2\";s:7:\"version\";s:14:\"7.x-2.0-alpha2\";s:3:\"tag\";s:14:\"7.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/fivestar/releases/7.x-2.0-alpha2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/fivestar-7.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1332954347\";s:6:\"mdhash\";s:32:\"acebd71efc5234dacbf256d98b68c346\";s:8:\"filesize\";s:6:\"221015\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:23:\"fivestar 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/fivestar/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/fivestar-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1316447804\";s:6:\"mdhash\";s:32:\"e4fddd9e83b1b5ec8c8f7032f52e53e2\";s:8:\"filesize\";s:6:\"193249\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:20:\"fivestar 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/fivestar/releases/7.x-2.x-dev\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/fivestar-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1498452248\";s:6:\"mdhash\";s:32:\"f492061ef8f990fad91471ff53c4ae57\";s:8:\"filesize\";s:6:\"228459\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1500447565,1500361146,1),('available_releases::flexslider','a:11:{s:5:\"title\";s:11:\"Flex Slider\";s:10:\"short_name\";s:10:\"flexslider\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:3:\"1,2\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:41:\"https://www.drupal.org/project/flexslider\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:12:{s:11:\"7.x-2.0-rc2\";a:15:{s:4:\"name\";s:22:\"flexslider 7.x-2.0-rc2\";s:7:\"version\";s:11:\"7.x-2.0-rc2\";s:3:\"tag\";s:11:\"7.x-2.0-rc2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/flexslider/releases/7.x-2.0-rc2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/flexslider-7.x-2.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1487028483\";s:6:\"mdhash\";s:32:\"6bbfff91fc66bef36e8ef42323a33a59\";s:8:\"filesize\";s:7:\"3976547\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-2.0-rc1\";a:15:{s:4:\"name\";s:22:\"flexslider 7.x-2.0-rc1\";s:7:\"version\";s:11:\"7.x-2.0-rc1\";s:3:\"tag\";s:11:\"7.x-2.0-rc1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/flexslider/releases/7.x-2.0-rc1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/flexslider-7.x-2.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1438285139\";s:6:\"mdhash\";s:32:\"c637c53352d34961d6413c8ac04ebf87\";s:8:\"filesize\";s:7:\"3977507\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"7.x-2.0-alpha3\";a:15:{s:4:\"name\";s:25:\"flexslider 7.x-2.0-alpha3\";s:7:\"version\";s:14:\"7.x-2.0-alpha3\";s:3:\"tag\";s:14:\"7.x-2.0-alpha3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/flexslider/releases/7.x-2.0-alpha3\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/flexslider-7.x-2.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1378663044\";s:6:\"mdhash\";s:32:\"a8b4f9b9740ab9d41a9043b1ea7361aa\";s:8:\"filesize\";s:7:\"3977501\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"7.x-2.0-alpha2\";a:15:{s:4:\"name\";s:25:\"flexslider 7.x-2.0-alpha2\";s:7:\"version\";s:14:\"7.x-2.0-alpha2\";s:3:\"tag\";s:14:\"7.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/flexslider/releases/7.x-2.0-alpha2\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/flexslider-7.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1376925141\";s:6:\"mdhash\";s:32:\"8f92257ca4e8baf7a6743a4bcf8738da\";s:8:\"filesize\";s:7:\"3975729\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:25:\"flexslider 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/flexslider/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/flexslider-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1362783811\";s:6:\"mdhash\";s:32:\"cb88bc862e89af0980839962c4f90a78\";s:8:\"filesize\";s:7:\"8366543\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-1.0-rc3\";a:15:{s:4:\"name\";s:22:\"flexslider 7.x-1.0-rc3\";s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:3:\"tag\";s:11:\"7.x-1.0-rc3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/flexslider/releases/7.x-1.0-rc3\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/flexslider-7.x-1.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1337289957\";s:6:\"mdhash\";s:32:\"e10d32bcb407d080319d1c85e93cb3f5\";s:8:\"filesize\";s:5:\"26069\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-1.0-rc2\";a:15:{s:4:\"name\";s:22:\"flexslider 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/flexslider/releases/7.x-1.0-rc2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/flexslider-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1333369556\";s:6:\"mdhash\";s:32:\"e5b228317528e962c633a508a56fcab7\";s:8:\"filesize\";s:5:\"25910\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:22:\"flexslider 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/flexslider/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/flexslider-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1333216546\";s:6:\"mdhash\";s:32:\"cdf482ecf2684c4d63f51242ec815a7c\";s:8:\"filesize\";s:5:\"25930\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:24:\"flexslider 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/flexslider/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/flexslider-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1332764150\";s:6:\"mdhash\";s:32:\"4fe1003a1fcfb8d088cc6e402c2bc5bb\";s:8:\"filesize\";s:5:\"26001\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:24:\"flexslider 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/flexslider/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/flexslider-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1332702357\";s:6:\"mdhash\";s:32:\"058b01b76f42dcf9c075036036c4b62d\";s:8:\"filesize\";s:5:\"25855\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:22:\"flexslider 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/flexslider/releases/7.x-2.x-dev\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/flexslider-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1487024583\";s:6:\"mdhash\";s:32:\"191e55868a7a3a0c9f2f6024b93ae83f\";s:8:\"filesize\";s:7:\"3976557\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:22:\"flexslider 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/flexslider/releases/7.x-1.x-dev\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/flexslider-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1446839939\";s:6:\"mdhash\";s:32:\"ed882b54ea61dc7ad370c2f3ea890e6b\";s:8:\"filesize\";s:5:\"26679\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}}}',1500447565,1500361146,1),('available_releases::icon','a:11:{s:5:\"title\";s:8:\"Icon API\";s:10:\"short_name\";s:4:\"icon\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:35:\"https://www.drupal.org/project/icon\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:9:{s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:12:\"icon 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/icon/releases/7.x-1.0\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/icon-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1490035383\";s:6:\"mdhash\";s:32:\"2bbcce141deca20d1531c9da49d78005\";s:8:\"filesize\";s:5:\"98998\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:16:\"icon 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/icon/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/icon-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1481888884\";s:6:\"mdhash\";s:32:\"f7a0a1b7e9a6fb79c9aff996b97c2f5c\";s:8:\"filesize\";s:5:\"98994\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta6\";a:15:{s:4:\"name\";s:18:\"icon 7.x-1.0-beta6\";s:7:\"version\";s:13:\"7.x-1.0-beta6\";s:3:\"tag\";s:13:\"7.x-1.0-beta6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/icon/releases/7.x-1.0-beta6\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/icon-7.x-1.0-beta6.tar.gz\";s:4:\"date\";s:10:\"1438832039\";s:6:\"mdhash\";s:32:\"422465ab3f9ea49c0024b54394ea59c0\";s:8:\"filesize\";s:6:\"100657\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta5\";a:15:{s:4:\"name\";s:18:\"icon 7.x-1.0-beta5\";s:7:\"version\";s:13:\"7.x-1.0-beta5\";s:3:\"tag\";s:13:\"7.x-1.0-beta5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/icon/releases/7.x-1.0-beta5\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/icon-7.x-1.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1392643705\";s:6:\"mdhash\";s:32:\"b3e14b3b18db785b8f2c98846a0e21ec\";s:8:\"filesize\";s:6:\"102287\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta4\";a:15:{s:4:\"name\";s:18:\"icon 7.x-1.0-beta4\";s:7:\"version\";s:13:\"7.x-1.0-beta4\";s:3:\"tag\";s:13:\"7.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/icon/releases/7.x-1.0-beta4\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/icon-7.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1392515005\";s:6:\"mdhash\";s:32:\"29f02b508b7ce5340863d35d0ca051de\";s:8:\"filesize\";s:6:\"101763\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta3\";a:15:{s:4:\"name\";s:18:\"icon 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/icon/releases/7.x-1.0-beta3\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/icon-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1376583265\";s:6:\"mdhash\";s:32:\"f4a5f9b87c3445d3f1ba510f1a39e5ed\";s:8:\"filesize\";s:5:\"99018\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:18:\"icon 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/icon/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/icon-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1372086351\";s:6:\"mdhash\";s:32:\"12ef3e855be0beca394aa471ef433a93\";s:8:\"filesize\";s:5:\"98148\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:18:\"icon 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/icon/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/icon-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1367221211\";s:6:\"mdhash\";s:32:\"a59197537a875b16cc30f162d3cdfdc3\";s:8:\"filesize\";s:5:\"97276\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:16:\"icon 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/icon/releases/7.x-1.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/icon-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1481888583\";s:6:\"mdhash\";s:32:\"c4b864efe6962f7255a44100e65309ea\";s:8:\"filesize\";s:5:\"99010\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1500447565,1500361146,1),('available_releases::image_link_formatter','a:11:{s:5:\"title\";s:20:\"Image Link Formatter\";s:10:\"short_name\";s:20:\"image_link_formatter\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:51:\"https://www.drupal.org/project/image_link_formatter\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:3:{s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:28:\"image_link_formatter 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/image_link_formatter/releases/7.x-1.1\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/image_link_formatter-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1464230040\";s:6:\"mdhash\";s:32:\"a6f43aeb9d1e55195a5962677b3c47ed\";s:8:\"filesize\";s:5:\"10523\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:28:\"image_link_formatter 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/image_link_formatter/releases/7.x-1.0\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/image_link_formatter-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1355914054\";s:6:\"mdhash\";s:32:\"32c4153149bb72044c3a8e0235cdadc4\";s:8:\"filesize\";s:5:\"10298\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:32:\"image_link_formatter 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/image_link_formatter/releases/7.x-1.x-dev\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/image_link_formatter-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1464671339\";s:6:\"mdhash\";s:32:\"bdbfec895d2da465803a03777f1c3a73\";s:8:\"filesize\";s:5:\"14335\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1500447566,1500361146,1),('available_releases::imce','a:11:{s:5:\"title\";s:4:\"IMCE\";s:10:\"short_name\";s:4:\"imce\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:35:\"https://www.drupal.org/project/imce\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:18:{s:8:\"7.x-1.11\";a:14:{s:4:\"name\";s:13:\"imce 7.x-1.11\";s:7:\"version\";s:8:\"7.x-1.11\";s:3:\"tag\";s:8:\"7.x-1.11\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/imce/releases/7.x-1.11\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/imce-7.x-1.11.tar.gz\";s:4:\"date\";s:10:\"1495890784\";s:6:\"mdhash\";s:32:\"57c956347a4511727b7e03f122b909fc\";s:8:\"filesize\";s:5:\"62452\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.10\";a:14:{s:4:\"name\";s:13:\"imce 7.x-1.10\";s:7:\"version\";s:8:\"7.x-1.10\";s:3:\"tag\";s:8:\"7.x-1.10\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/imce/releases/7.x-1.10\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/imce-7.x-1.10.tar.gz\";s:4:\"date\";s:10:\"1459346866\";s:6:\"mdhash\";s:32:\"62aad4be77c4a9b1c5ca5588c2eb35da\";s:8:\"filesize\";s:5:\"63986\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.9\";a:14:{s:4:\"name\";s:12:\"imce 7.x-1.9\";s:7:\"version\";s:7:\"7.x-1.9\";s:3:\"tag\";s:7:\"7.x-1.9\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/imce/releases/7.x-1.9\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/imce-7.x-1.9.tar.gz\";s:4:\"date\";s:10:\"1400275427\";s:6:\"mdhash\";s:32:\"bcc791ae6fac1c501837e4679f9002b8\";s:8:\"filesize\";s:5:\"63448\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.8\";a:14:{s:4:\"name\";s:12:\"imce 7.x-1.8\";s:7:\"version\";s:7:\"7.x-1.8\";s:3:\"tag\";s:7:\"7.x-1.8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/imce/releases/7.x-1.8\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/imce-7.x-1.8.tar.gz\";s:4:\"date\";s:10:\"1387302358\";s:6:\"mdhash\";s:32:\"edba7f3567eb36ca040f63699b23603e\";s:8:\"filesize\";s:5:\"61452\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.7\";a:14:{s:4:\"name\";s:12:\"imce 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/imce/releases/7.x-1.7\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/imce-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1359476607\";s:6:\"mdhash\";s:32:\"c352bf9da8433628bed0b79c4acdcdb8\";s:8:\"filesize\";s:5:\"61286\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:12:\"imce 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/imce/releases/7.x-1.6\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/imce-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1352537820\";s:6:\"mdhash\";s:32:\"e1300316ea4245063b79bd91f9fd0bcf\";s:8:\"filesize\";s:5:\"61316\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:12:\"imce 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/imce/releases/7.x-1.5\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/imce-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1319104232\";s:6:\"mdhash\";s:32:\"43c36da627ed770bec0e21a442eec712\";s:8:\"filesize\";s:5:\"61276\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:12:\"imce 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/imce/releases/7.x-1.4\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/imce-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1307386616\";s:6:\"mdhash\";s:32:\"6d11af3cd365c143317a0dc37599505c\";s:8:\"filesize\";s:5:\"60190\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:12:\"imce 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/imce/releases/7.x-1.3\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/imce-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1300384567\";s:6:\"mdhash\";s:32:\"9a3b27ca2b5e2aceb3f1ee30841fa8b3\";s:8:\"filesize\";s:5:\"59939\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:12:\"imce 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/imce/releases/7.x-1.2\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/imce-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1296601518\";s:6:\"mdhash\";s:32:\"c6bb7fea90545f71dcf32134b8cf8157\";s:8:\"filesize\";s:5:\"58810\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:12:\"imce 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/imce/releases/7.x-1.1\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/imce-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1293481279\";s:6:\"mdhash\";s:32:\"cef3122364a21b587448b659c34d7b06\";s:8:\"filesize\";s:5:\"58517\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:12:\"imce 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/imce/releases/7.x-1.0\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/imce-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1293289898\";s:6:\"mdhash\";s:32:\"63947e1f2fd23888c014df5bc618b636\";s:8:\"filesize\";s:5:\"58495\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:18:\"imce 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/imce/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/imce-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1286606463\";s:6:\"mdhash\";s:32:\"f0a6cd298c8fd85e96b225d4b0e6a38d\";s:8:\"filesize\";s:5:\"58423\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-1.0-alpha3\";a:15:{s:4:\"name\";s:19:\"imce 7.x-1.0-alpha3\";s:7:\"version\";s:14:\"7.x-1.0-alpha3\";s:3:\"tag\";s:14:\"7.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/imce/releases/7.x-1.0-alpha3\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/imce-7.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1277145015\";s:6:\"mdhash\";s:32:\"161f69f59d6f56a8529446fb147992d3\";s:8:\"filesize\";s:5:\"57825\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:19:\"imce 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/imce/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/imce-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1275125108\";s:6:\"mdhash\";s:32:\"5692e073e353d7451c47c63b381fae9c\";s:8:\"filesize\";s:5:\"57483\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:19:\"imce 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/imce/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/imce-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1268868307\";s:6:\"mdhash\";s:32:\"3aeebc6a28e99abbd5260c28e499d646\";s:8:\"filesize\";s:5:\"55587\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:16:\"imce 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/imce/releases/7.x-1.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/imce-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1499895843\";s:6:\"mdhash\";s:32:\"00ee87de7f12f44c565fcd581ea84f5d\";s:8:\"filesize\";s:5:\"62413\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:6:\"master\";a:13:{s:4:\"name\";s:9:\"imce HEAD\";s:7:\"version\";s:6:\"master\";s:3:\"tag\";s:6:\"master\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/imce/releases/master\";s:13:\"download_link\";s:54:\"https://ftp.drupal.org/files/projects/imce-HEAD.tar.gz\";s:4:\"date\";s:10:\"1286626342\";s:6:\"mdhash\";s:32:\"94c619d7b66e55cd6c810baf0c13211d\";s:8:\"filesize\";s:5:\"58416\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447566,1500361146,1),('available_releases::inline_entity_form','a:11:{s:5:\"title\";s:18:\"Inline Entity Form\";s:10:\"short_name\";s:18:\"inline_entity_form\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:49:\"https://www.drupal.org/project/inline_entity_form\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:15:{s:7:\"7.x-1.8\";a:14:{s:4:\"name\";s:26:\"inline_entity_form 7.x-1.8\";s:7:\"version\";s:7:\"7.x-1.8\";s:3:\"tag\";s:7:\"7.x-1.8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/inline_entity_form/releases/7.x-1.8\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/inline_entity_form-7.x-1.8.tar.gz\";s:4:\"date\";s:10:\"1460849406\";s:6:\"mdhash\";s:32:\"3e9bd90b93c363153a3914804a0dfb91\";s:8:\"filesize\";s:5:\"38827\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:7:\"7.x-1.7\";a:14:{s:4:\"name\";s:26:\"inline_entity_form 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/inline_entity_form/releases/7.x-1.7\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/inline_entity_form-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1460671439\";s:6:\"mdhash\";s:32:\"56477a50f3af5f3b6d26c243a98eee86\";s:8:\"filesize\";s:5:\"38921\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:26:\"inline_entity_form 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/inline_entity_form/releases/7.x-1.6\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/inline_entity_form-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1434553380\";s:6:\"mdhash\";s:32:\"3c55b456227133f0105617cb87489c58\";s:8:\"filesize\";s:5:\"30981\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";i:2;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:26:\"inline_entity_form 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/inline_entity_form/releases/7.x-1.5\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/inline_entity_form-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1389971611\";s:6:\"mdhash\";s:32:\"82ca960cc7c83809723e28941f28b69b\";s:8:\"filesize\";s:5:\"30490\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:26:\"inline_entity_form 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/inline_entity_form/releases/7.x-1.4\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/inline_entity_form-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1388403805\";s:6:\"mdhash\";s:32:\"f9afaa955946b38e581241e7eb6815f8\";s:8:\"filesize\";s:5:\"30414\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:26:\"inline_entity_form 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/inline_entity_form/releases/7.x-1.3\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/inline_entity_form-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1374540993\";s:6:\"mdhash\";s:32:\"006a8635d365d31776877a9a82cff403\";s:8:\"filesize\";s:5:\"28914\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:26:\"inline_entity_form 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/inline_entity_form/releases/7.x-1.2\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/inline_entity_form-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1368798850\";s:6:\"mdhash\";s:32:\"97cb425a20190d3f6ee38bc705081d9b\";s:8:\"filesize\";s:5:\"28322\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:26:\"inline_entity_form 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/inline_entity_form/releases/7.x-1.1\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/inline_entity_form-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1359135111\";s:6:\"mdhash\";s:32:\"50f1b648e4c094e66785eddce85a1062\";s:8:\"filesize\";s:5:\"28262\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:26:\"inline_entity_form 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/inline_entity_form/releases/7.x-1.0\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/inline_entity_form-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1355755076\";s:6:\"mdhash\";s:32:\"3ec652734d75b8a4684c8da46e51647a\";s:8:\"filesize\";s:5:\"28221\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:30:\"inline_entity_form 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/inline_entity_form/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/inline_entity_form-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1347887963\";s:6:\"mdhash\";s:32:\"1f019469ef8c718a177f2eab2e732217\";s:8:\"filesize\";s:5:\"26292\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta4\";a:15:{s:4:\"name\";s:32:\"inline_entity_form 7.x-1.0-beta4\";s:7:\"version\";s:13:\"7.x-1.0-beta4\";s:3:\"tag\";s:13:\"7.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/inline_entity_form/releases/7.x-1.0-beta4\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/inline_entity_form-7.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1345447648\";s:6:\"mdhash\";s:32:\"c4e85dfef7f8bcff698c5ea407c666a6\";s:8:\"filesize\";s:5:\"23161\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta3\";a:15:{s:4:\"name\";s:32:\"inline_entity_form 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/inline_entity_form/releases/7.x-1.0-beta3\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/inline_entity_form-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1340576780\";s:6:\"mdhash\";s:32:\"d4b323ae0c63ff38db6a910fdae416ec\";s:8:\"filesize\";s:5:\"22625\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:32:\"inline_entity_form 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/inline_entity_form/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/inline_entity_form-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1339669279\";s:6:\"mdhash\";s:32:\"8a62a0d558a4195bd3b04aa0f1c3445c\";s:8:\"filesize\";s:5:\"22531\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:32:\"inline_entity_form 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/inline_entity_form/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/inline_entity_form-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1335220280\";s:6:\"mdhash\";s:32:\"5cc10d5cc8b72a1de40252c8fb6226db\";s:8:\"filesize\";s:5:\"20679\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:30:\"inline_entity_form 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/inline_entity_form/releases/7.x-1.x-dev\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/inline_entity_form-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1460848739\";s:6:\"mdhash\";s:32:\"ad773ef9cd539257bf31dcece12fc7fe\";s:8:\"filesize\";s:5:\"38842\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447567,1500361146,1),('available_releases::jcarousel','a:11:{s:5:\"title\";s:9:\"jCarousel\";s:10:\"short_name\";s:9:\"jcarousel\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:40:\"https://www.drupal.org/project/jcarousel\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:11:{s:7:\"7.x-2.7\";a:14:{s:4:\"name\";s:17:\"jcarousel 7.x-2.7\";s:7:\"version\";s:7:\"7.x-2.7\";s:3:\"tag\";s:7:\"7.x-2.7\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/jcarousel/releases/7.x-2.7\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/jcarousel-7.x-2.7.tar.gz\";s:4:\"date\";s:10:\"1420460280\";s:6:\"mdhash\";s:32:\"da7722a86d12f286ce6b05e064b6a6e3\";s:8:\"filesize\";s:5:\"58289\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-2.7-rc1\";a:15:{s:4:\"name\";s:21:\"jcarousel 7.x-2.7-rc1\";s:7:\"version\";s:11:\"7.x-2.7-rc1\";s:3:\"tag\";s:11:\"7.x-2.7-rc1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"7\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/jcarousel/releases/7.x-2.7-rc1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/jcarousel-7.x-2.7-rc1.tar.gz\";s:4:\"date\";s:10:\"1420458180\";s:6:\"mdhash\";s:32:\"cd41f12d87404de09a65778c96f60dc4\";s:8:\"filesize\";s:5:\"58292\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:7:\"7.x-2.6\";a:14:{s:4:\"name\";s:17:\"jcarousel 7.x-2.6\";s:7:\"version\";s:7:\"7.x-2.6\";s:3:\"tag\";s:7:\"7.x-2.6\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/jcarousel/releases/7.x-2.6\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/jcarousel-7.x-2.6.tar.gz\";s:4:\"date\";s:10:\"1322116852\";s:6:\"mdhash\";s:32:\"0cd60b44c05b4d0e1001357f59ecc20c\";s:8:\"filesize\";s:5:\"59462\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.5\";a:14:{s:4:\"name\";s:17:\"jcarousel 7.x-2.5\";s:7:\"version\";s:7:\"7.x-2.5\";s:3:\"tag\";s:7:\"7.x-2.5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/jcarousel/releases/7.x-2.5\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/jcarousel-7.x-2.5.tar.gz\";s:4:\"date\";s:10:\"1319935769\";s:6:\"mdhash\";s:32:\"390b331e84ee07078c15c947b5a49906\";s:8:\"filesize\";s:5:\"58051\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:14:\"7.x-2.4-alpha3\";a:15:{s:4:\"name\";s:24:\"jcarousel 7.x-2.4-alpha3\";s:7:\"version\";s:14:\"7.x-2.4-alpha3\";s:3:\"tag\";s:14:\"7.x-2.4-alpha3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"4\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/jcarousel/releases/7.x-2.4-alpha3\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/jcarousel-7.x-2.4-alpha3.tar.gz\";s:4:\"date\";s:10:\"1302133615\";s:6:\"mdhash\";s:32:\"8a26f61e7c879bf969450cdadfb3bed4\";s:8:\"filesize\";s:5:\"55189\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.3-alpha2\";a:15:{s:4:\"name\";s:24:\"jcarousel 7.x-2.3-alpha2\";s:7:\"version\";s:14:\"7.x-2.3-alpha2\";s:3:\"tag\";s:14:\"7.x-2.3-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/jcarousel/releases/7.x-2.3-alpha2\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/jcarousel-7.x-2.3-alpha2.tar.gz\";s:4:\"date\";s:10:\"1297036300\";s:6:\"mdhash\";s:32:\"0a46305bd164dcb3488b539381fcfd80\";s:8:\"filesize\";s:5:\"55269\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.2-alpha1\";a:15:{s:4:\"name\";s:24:\"jcarousel 7.x-2.2-alpha1\";s:7:\"version\";s:14:\"7.x-2.2-alpha1\";s:3:\"tag\";s:14:\"7.x-2.2-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/jcarousel/releases/7.x-2.2-alpha1\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/jcarousel-7.x-2.2-alpha1.tar.gz\";s:4:\"date\";s:10:\"1292868983\";s:6:\"mdhash\";s:32:\"e67324d105cce787f5a0cb620494bf2a\";s:8:\"filesize\";s:5:\"55026\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.1-alpha1\";a:15:{s:4:\"name\";s:24:\"jcarousel 7.x-2.1-alpha1\";s:7:\"version\";s:14:\"7.x-2.1-alpha1\";s:3:\"tag\";s:14:\"7.x-2.1-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/jcarousel/releases/7.x-2.1-alpha1\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/jcarousel-7.x-2.1-alpha1.tar.gz\";s:4:\"date\";s:10:\"1292184217\";s:6:\"mdhash\";s:32:\"154017caadc52cd00407c499c8dfcfc3\";s:8:\"filesize\";s:5:\"54766\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:24:\"jcarousel 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/jcarousel/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/jcarousel-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1290991275\";s:6:\"mdhash\";s:32:\"e70693d58a9d241bc98a4f602ea305da\";s:8:\"filesize\";s:5:\"54560\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"7.x-3.x-dev\";a:14:{s:4:\"name\";s:21:\"jcarousel 7.x-3.x-dev\";s:7:\"version\";s:11:\"7.x-3.x-dev\";s:3:\"tag\";s:7:\"7.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/jcarousel/releases/7.x-3.x-dev\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/jcarousel-7.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1420043280\";s:6:\"mdhash\";s:32:\"f08221738d43aedaa6e5eda20b56821c\";s:8:\"filesize\";s:5:\"43746\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:21:\"jcarousel 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/jcarousel/releases/7.x-2.x-dev\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/jcarousel-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1420464180\";s:6:\"mdhash\";s:32:\"90787216acc1a3738c47ef8d0b568380\";s:8:\"filesize\";s:5:\"58318\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447568,1500361146,1),('available_releases::jquery_update','a:11:{s:5:\"title\";s:13:\"jQuery Update\";s:10:\"short_name\";s:13:\"jquery_update\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:3:\"2,3\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:44:\"https://www.drupal.org/project/jquery_update\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:18:{s:14:\"7.x-3.0-alpha5\";a:15:{s:4:\"name\";s:28:\"jquery_update 7.x-3.0-alpha5\";s:7:\"version\";s:14:\"7.x-3.0-alpha5\";s:3:\"tag\";s:14:\"7.x-3.0-alpha5\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/jquery_update/releases/7.x-3.0-alpha5\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-3.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1490805183\";s:6:\"mdhash\";s:32:\"48baebd87003519ade8c65dc5598bbe5\";s:8:\"filesize\";s:7:\"1980268\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-3.0-alpha4\";a:15:{s:4:\"name\";s:28:\"jquery_update 7.x-3.0-alpha4\";s:7:\"version\";s:14:\"7.x-3.0-alpha4\";s:3:\"tag\";s:14:\"7.x-3.0-alpha4\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/jquery_update/releases/7.x-3.0-alpha4\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-3.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1489024086\";s:6:\"mdhash\";s:32:\"b9cadf50cf17638df514aad3c188c776\";s:8:\"filesize\";s:7:\"1978968\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-3.0-alpha3\";a:15:{s:4:\"name\";s:28:\"jquery_update 7.x-3.0-alpha3\";s:7:\"version\";s:14:\"7.x-3.0-alpha3\";s:3:\"tag\";s:14:\"7.x-3.0-alpha3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/jquery_update/releases/7.x-3.0-alpha3\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-3.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1445382239\";s:6:\"mdhash\";s:32:\"599739c36c8095b1a268d82a8d5820ac\";s:8:\"filesize\";s:7:\"1463630\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-3.0-alpha2\";a:15:{s:4:\"name\";s:28:\"jquery_update 7.x-3.0-alpha2\";s:7:\"version\";s:14:\"7.x-3.0-alpha2\";s:3:\"tag\";s:14:\"7.x-3.0-alpha2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/jquery_update/releases/7.x-3.0-alpha2\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-3.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1432926481\";s:6:\"mdhash\";s:32:\"99d161a138a599ee9ebd30434479e1ca\";s:8:\"filesize\";s:7:\"1542292\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-3.0-alpha1\";a:15:{s:4:\"name\";s:28:\"jquery_update 7.x-3.0-alpha1\";s:7:\"version\";s:14:\"7.x-3.0-alpha1\";s:3:\"tag\";s:14:\"7.x-3.0-alpha1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/jquery_update/releases/7.x-3.0-alpha1\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-3.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1431975181\";s:6:\"mdhash\";s:32:\"500a98ed3bec0c943994c43913422332\";s:8:\"filesize\";s:7:\"1541898\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:7:\"7.x-2.7\";a:14:{s:4:\"name\";s:21:\"jquery_update 7.x-2.7\";s:7:\"version\";s:7:\"7.x-2.7\";s:3:\"tag\";s:7:\"7.x-2.7\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/jquery_update/releases/7.x-2.7\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-2.7.tar.gz\";s:4:\"date\";s:10:\"1445379839\";s:6:\"mdhash\";s:32:\"85eaf02362c384979bc475df30ae7a3e\";s:8:\"filesize\";s:7:\"1135987\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.6\";a:14:{s:4:\"name\";s:21:\"jquery_update 7.x-2.6\";s:7:\"version\";s:7:\"7.x-2.6\";s:3:\"tag\";s:7:\"7.x-2.6\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/jquery_update/releases/7.x-2.6\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-2.6.tar.gz\";s:4:\"date\";s:10:\"1434549780\";s:6:\"mdhash\";s:32:\"88b81a8defbfdf9a4674f876685543f1\";s:8:\"filesize\";s:7:\"1203578\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.5\";a:14:{s:4:\"name\";s:21:\"jquery_update 7.x-2.5\";s:7:\"version\";s:7:\"7.x-2.5\";s:3:\"tag\";s:7:\"7.x-2.5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/jquery_update/releases/7.x-2.5\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-2.5.tar.gz\";s:4:\"date\";s:10:\"1422221880\";s:6:\"mdhash\";s:32:\"47f430531b0a2a821c791325b2d89388\";s:8:\"filesize\";s:7:\"1201320\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.4\";a:14:{s:4:\"name\";s:21:\"jquery_update 7.x-2.4\";s:7:\"version\";s:7:\"7.x-2.4\";s:3:\"tag\";s:7:\"7.x-2.4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/jquery_update/releases/7.x-2.4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-2.4.tar.gz\";s:4:\"date\";s:10:\"1396482245\";s:6:\"mdhash\";s:32:\"9cc4f8b964202f1d6f005a43a08060c6\";s:8:\"filesize\";s:7:\"1199709\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.3\";a:14:{s:4:\"name\";s:21:\"jquery_update 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/jquery_update/releases/7.x-2.3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1360375905\";s:6:\"mdhash\";s:32:\"2d5a1e594a027fa849ed250f5dfef7c5\";s:8:\"filesize\";s:6:\"709788\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:14:\"7.x-2.3-alpha1\";a:15:{s:4:\"name\";s:28:\"jquery_update 7.x-2.3-alpha1\";s:7:\"version\";s:14:\"7.x-2.3-alpha1\";s:3:\"tag\";s:14:\"7.x-2.3-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/jquery_update/releases/7.x-2.3-alpha1\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-2.3-alpha1.tar.gz\";s:4:\"date\";s:10:\"1348790474\";s:6:\"mdhash\";s:32:\"2fe04a30f74e47c0b1a4ce24023a39fa\";s:8:\"filesize\";s:6:\"709779\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:21:\"jquery_update 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/jquery_update/releases/7.x-2.2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1301920269\";s:6:\"mdhash\";s:32:\"944e097382c08d9a3ba5028ac700162b\";s:8:\"filesize\";s:6:\"482023\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:21:\"jquery_update 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/jquery_update/releases/7.x-2.1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1300647067\";s:6:\"mdhash\";s:32:\"6b6f9064e23aaede7ce9f04ded255a57\";s:8:\"filesize\";s:6:\"479984\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:21:\"jquery_update 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/jquery_update/releases/7.x-2.0\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1297454705\";s:6:\"mdhash\";s:32:\"de6d8095e0bdd4e231922974df3f8fc7\";s:8:\"filesize\";s:6:\"476204\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:21:\"jquery_update 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/jquery_update/releases/7.x-1.0\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1297453316\";s:6:\"mdhash\";s:32:\"4fa3749b8e477b76341d72a5516344d8\";s:8:\"filesize\";s:6:\"476208\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:11:\"7.x-3.x-dev\";a:14:{s:4:\"name\";s:25:\"jquery_update 7.x-3.x-dev\";s:7:\"version\";s:11:\"7.x-3.x-dev\";s:3:\"tag\";s:7:\"7.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/jquery_update/releases/7.x-3.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1490804883\";s:6:\"mdhash\";s:32:\"5786d8734547bdd37d012b365aaa44d9\";s:8:\"filesize\";s:7:\"1980264\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:25:\"jquery_update 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/jquery_update/releases/7.x-2.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1445379839\";s:6:\"mdhash\";s:32:\"b4c28c594a6ecf50ccb9cd9689e778c9\";s:8:\"filesize\";s:7:\"1135988\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:25:\"jquery_update 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/jquery_update/releases/7.x-1.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380584081\";s:6:\"mdhash\";s:32:\"9d1b43a6e55ea389f03cd338ab9c5f35\";s:8:\"filesize\";s:6:\"472169\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447568,1500361146,1),('available_releases::libraries','a:11:{s:5:\"title\";s:13:\"Libraries API\";s:10:\"short_name\";s:9:\"libraries\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:5:\"1,2,3\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:40:\"https://www.drupal.org/project/libraries\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:10:{s:7:\"7.x-2.3\";a:14:{s:4:\"name\";s:17:\"libraries 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/libraries/releases/7.x-2.3\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/libraries-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1463077439\";s:6:\"mdhash\";s:32:\"294d3e4096c513321159b908cfd7c2be\";s:8:\"filesize\";s:5:\"41863\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:17:\"libraries 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/libraries/releases/7.x-2.2\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/libraries-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1391965705\";s:6:\"mdhash\";s:32:\"629663be1ddbbc79531ab98d7d3761dc\";s:8:\"filesize\";s:5:\"33326\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:17:\"libraries 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/libraries/releases/7.x-2.1\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/libraries-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1362848412\";s:6:\"mdhash\";s:32:\"e240bf43e3a4dd2d595bf24ac34d46bd\";s:8:\"filesize\";s:5:\"30501\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:17:\"libraries 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/libraries/releases/7.x-2.0\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/libraries-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1343561873\";s:6:\"mdhash\";s:32:\"bb4707fe9c9c67401c9baa514fbab948\";s:8:\"filesize\";s:5:\"30229\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:14:\"7.x-2.0-alpha2\";a:15:{s:4:\"name\";s:24:\"libraries 7.x-2.0-alpha2\";s:7:\"version\";s:14:\"7.x-2.0-alpha2\";s:3:\"tag\";s:14:\"7.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/libraries/releases/7.x-2.0-alpha2\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/libraries-7.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1323950504\";s:6:\"mdhash\";s:32:\"150a5e24e7f1e849e054ba06921a0311\";s:8:\"filesize\";s:5:\"29501\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:24:\"libraries 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/libraries/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/libraries-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1317479207\";s:6:\"mdhash\";s:32:\"8e3529be946d9ad0a4b387756cb91a5d\";s:8:\"filesize\";s:5:\"28459\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:17:\"libraries 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/libraries/releases/7.x-1.0\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/libraries-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1296096156\";s:6:\"mdhash\";s:32:\"e395a4229adb94f48de0764654e83967\";s:8:\"filesize\";s:4:\"7921\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:11:\"7.x-3.x-dev\";a:14:{s:4:\"name\";s:21:\"libraries 7.x-3.x-dev\";s:7:\"version\";s:11:\"7.x-3.x-dev\";s:3:\"tag\";s:7:\"7.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/libraries/releases/7.x-3.x-dev\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/libraries-7.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1413167628\";s:6:\"mdhash\";s:32:\"7263f590a91de04704820f2b218956f9\";s:8:\"filesize\";s:5:\"33184\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:21:\"libraries 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/libraries/releases/7.x-2.x-dev\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/libraries-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1479046140\";s:6:\"mdhash\";s:32:\"3664fa9b54800164c107a0fbc2e52865\";s:8:\"filesize\";s:5:\"44459\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:21:\"libraries 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/libraries/releases/7.x-1.x-dev\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/libraries-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1406512127\";s:6:\"mdhash\";s:32:\"84247d751f028c55371865aef18fbd11\";s:8:\"filesize\";s:4:\"9041\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447569,1500361146,1),('available_releases::link','a:11:{s:5:\"title\";s:4:\"Link\";s:10:\"short_name\";s:4:\"link\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:35:\"https://www.drupal.org/project/link\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:11:{s:13:\"7.x-1.5-beta1\";a:15:{s:4:\"name\";s:18:\"link 7.x-1.5-beta1\";s:7:\"version\";s:13:\"7.x-1.5-beta1\";s:3:\"tag\";s:13:\"7.x-1.5-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/link/releases/7.x-1.5-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/link-7.x-1.5-beta1.tar.gz\";s:4:\"date\";s:10:\"1499171942\";s:6:\"mdhash\";s:32:\"0589fb97c7b74f82e429a34677eb1fb8\";s:8:\"filesize\";s:5:\"37592\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:12:\"link 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/link/releases/7.x-1.4\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/link-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1452830639\";s:6:\"mdhash\";s:32:\"10cb0a7bb75aaa6cd709c88fd7f79e9f\";s:8:\"filesize\";s:5:\"36913\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:12:\"link 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/link/releases/7.x-1.3\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/link-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1413924828\";s:6:\"mdhash\";s:32:\"cc9ccec6ca028f73cf60f8cab09e5a4d\";s:8:\"filesize\";s:5:\"33988\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:12:\"link 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/link/releases/7.x-1.2\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/link-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1385335704\";s:6:\"mdhash\";s:32:\"100c0b2416d455908a818f0a547e9938\";s:8:\"filesize\";s:5:\"33858\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:12:\"link 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/link/releases/7.x-1.1\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/link-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1360444360\";s:6:\"mdhash\";s:32:\"416691004d5a09681869dcd93188238b\";s:8:\"filesize\";s:5:\"33160\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:12:\"link 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/link/releases/7.x-1.0\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/link-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1319392535\";s:6:\"mdhash\";s:32:\"0b237d7b329c0454f437f5687d607743\";s:8:\"filesize\";s:5:\"31440\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:18:\"link 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/link/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/link-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1317011508\";s:6:\"mdhash\";s:32:\"05802cd5a599cbf0b205a084016779a8\";s:8:\"filesize\";s:5:\"30289\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha3\";a:15:{s:4:\"name\";s:19:\"link 7.x-1.0-alpha3\";s:7:\"version\";s:14:\"7.x-1.0-alpha3\";s:3:\"tag\";s:14:\"7.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/link/releases/7.x-1.0-alpha3\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/link-7.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1297061216\";s:6:\"mdhash\";s:32:\"372ddf2818f9ae6754274b4a8b6b640b\";s:8:\"filesize\";s:5:\"27724\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:19:\"link 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha-2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/link/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/link-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1295189003\";s:6:\"mdhash\";s:32:\"c74d7846f210f1bf4a8f14cc8a2d4dbd\";s:8:\"filesize\";s:5:\"20558\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:62:\"Alpha- releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:19:\"link 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/link/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/link-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1291518680\";s:6:\"mdhash\";s:32:\"e9299a741ec5b8ac631f3ba701df7c14\";s:8:\"filesize\";s:5:\"20843\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:16:\"link 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/link/releases/7.x-1.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/link-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1499889242\";s:6:\"mdhash\";s:32:\"0e45cfac1d902dcd8306ea1d4da60e7c\";s:8:\"filesize\";s:5:\"38002\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447569,1500361146,1),('available_releases::menu_descriptions','a:11:{s:5:\"title\";s:17:\"Menu Descriptions\";s:10:\"short_name\";s:17:\"menu_descriptions\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:48:\"https://www.drupal.org/project/menu_descriptions\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:6:{s:7:\"7.x-1.7\";a:14:{s:4:\"name\";s:25:\"menu_descriptions 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/menu_descriptions/releases/7.x-1.7\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/menu_descriptions-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1478472240\";s:6:\"mdhash\";s:32:\"1f5be675a5c3cc5af50bbf2b6fdff451\";s:8:\"filesize\";s:5:\"11295\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:25:\"menu_descriptions 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/menu_descriptions/releases/7.x-1.6\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/menu_descriptions-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1415818680\";s:6:\"mdhash\";s:32:\"c8503d38fd4771dc2d5e9f34c44106f4\";s:8:\"filesize\";s:5:\"10903\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:25:\"menu_descriptions 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/menu_descriptions/releases/7.x-1.5\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/menu_descriptions-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1409587728\";s:6:\"mdhash\";s:32:\"f293d0ff35f0ce9fb90990eb6a1206a5\";s:8:\"filesize\";s:5:\"10899\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:25:\"menu_descriptions 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/menu_descriptions/releases/7.x-1.4\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/menu_descriptions-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1390573404\";s:6:\"mdhash\";s:32:\"87799219f578fc45a1d63100bf4ea2f7\";s:8:\"filesize\";s:5:\"10881\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:25:\"menu_descriptions 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/menu_descriptions/releases/7.x-1.3\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/menu_descriptions-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1390338804\";s:6:\"mdhash\";s:32:\"89f91721999b372e93bf693cc7ecd69a\";s:8:\"filesize\";s:5:\"10874\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:29:\"menu_descriptions 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/menu_descriptions/releases/7.x-1.x-dev\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/menu_descriptions-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1473208739\";s:6:\"mdhash\";s:32:\"eb110d2bacb6f7fd8dc80d5c8d6adb53\";s:8:\"filesize\";s:5:\"11283\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447569,1500361146,1),('available_releases::menu_token','a:11:{s:5:\"title\";s:10:\"Menu token\";s:10:\"short_name\";s:10:\"menu_token\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:41:\"https://www.drupal.org/project/menu_token\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:11:{s:13:\"7.x-1.0-beta7\";a:15:{s:4:\"name\";s:24:\"menu_token 7.x-1.0-beta7\";s:7:\"version\";s:13:\"7.x-1.0-beta7\";s:3:\"tag\";s:13:\"7.x-1.0-beta7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/menu_token/releases/7.x-1.0-beta7\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/menu_token-7.x-1.0-beta7.tar.gz\";s:4:\"date\";s:10:\"1458066248\";s:6:\"mdhash\";s:32:\"5a5e84dc72d14388b8bad6b552ae73be\";s:8:\"filesize\";s:5:\"14717\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta6\";a:15:{s:4:\"name\";s:24:\"menu_token 7.x-1.0-beta6\";s:7:\"version\";s:13:\"7.x-1.0-beta6\";s:3:\"tag\";s:13:\"7.x-1.0-beta6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/menu_token/releases/7.x-1.0-beta6\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/menu_token-7.x-1.0-beta6.tar.gz\";s:4:\"date\";s:10:\"1448912940\";s:6:\"mdhash\";s:32:\"9b27dd25176dbaca5fb99df6cd7282dc\";s:8:\"filesize\";s:5:\"14565\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta5\";a:15:{s:4:\"name\";s:24:\"menu_token 7.x-1.0-beta5\";s:7:\"version\";s:13:\"7.x-1.0-beta5\";s:3:\"tag\";s:13:\"7.x-1.0-beta5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/menu_token/releases/7.x-1.0-beta5\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/menu_token-7.x-1.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1371232256\";s:6:\"mdhash\";s:32:\"82086784d41f201f922f9f22a7aa9b5c\";s:8:\"filesize\";s:5:\"14366\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta4\";a:15:{s:4:\"name\";s:24:\"menu_token 7.x-1.0-beta4\";s:7:\"version\";s:13:\"7.x-1.0-beta4\";s:3:\"tag\";s:13:\"7.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/menu_token/releases/7.x-1.0-beta4\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/menu_token-7.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1359157010\";s:6:\"mdhash\";s:32:\"f5856c9295f6841f6c73ec4c501f0f51\";s:8:\"filesize\";s:5:\"14200\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta3\";a:15:{s:4:\"name\";s:24:\"menu_token 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/menu_token/releases/7.x-1.0-beta3\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/menu_token-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1353184302\";s:6:\"mdhash\";s:32:\"21ba0d0579cb228719c27d2e25f01427\";s:8:\"filesize\";s:5:\"13924\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:24:\"menu_token 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/menu_token/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/menu_token-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1353166987\";s:6:\"mdhash\";s:32:\"88c585ad14c5bdf41d4a0cbfc7c559c2\";s:8:\"filesize\";s:5:\"13922\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:24:\"menu_token 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/menu_token/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/menu_token-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1332549048\";s:6:\"mdhash\";s:32:\"4549ad75ad56df9ddb63e5729bafdb52\";s:8:\"filesize\";s:5:\"13667\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"7.x-1.0-alpha3\";a:15:{s:4:\"name\";s:25:\"menu_token 7.x-1.0-alpha3\";s:7:\"version\";s:14:\"7.x-1.0-alpha3\";s:3:\"tag\";s:14:\"7.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/menu_token/releases/7.x-1.0-alpha3\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/menu_token-7.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1316444206\";s:6:\"mdhash\";s:32:\"e6fb0c1472662e66913c62b9a33ed179\";s:8:\"filesize\";s:5:\"13626\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:25:\"menu_token 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/menu_token/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/menu_token-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1307952720\";s:6:\"mdhash\";s:32:\"b7ad33d31e3b98992d16f875ee9af9ca\";s:8:\"filesize\";s:4:\"9304\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:25:\"menu_token 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/menu_token/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/menu_token-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1299796269\";s:6:\"mdhash\";s:32:\"c4a9b152cc4142b206a7e24938316535\";s:8:\"filesize\";s:4:\"8402\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:22:\"menu_token 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/menu_token/releases/7.x-1.x-dev\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/menu_token-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1490196783\";s:6:\"mdhash\";s:32:\"c766608c557808d96a5f280ddd1f6d43\";s:8:\"filesize\";s:5:\"16382\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}}}',1500447570,1500361146,1),('available_releases::module_filter','a:11:{s:5:\"title\";s:13:\"Module Filter\";s:10:\"short_name\";s:13:\"module_filter\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:44:\"https://www.drupal.org/project/module_filter\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:15:{s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:21:\"module_filter 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/module_filter/releases/7.x-2.1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/module_filter-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1497029343\";s:6:\"mdhash\";s:32:\"66a4998f63f2cefe77c18713054a42cc\";s:8:\"filesize\";s:5:\"29757\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:21:\"module_filter 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/module_filter/releases/7.x-2.0\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/module_filter-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1424631181\";s:6:\"mdhash\";s:32:\"3e2ebdd2f2ec028252e1cf2a547d7d7e\";s:8:\"filesize\";s:5:\"29130\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:14:\"7.x-2.0-alpha2\";a:15:{s:4:\"name\";s:28:\"module_filter 7.x-2.0-alpha2\";s:7:\"version\";s:14:\"7.x-2.0-alpha2\";s:3:\"tag\";s:14:\"7.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/module_filter/releases/7.x-2.0-alpha2\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/module_filter-7.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1386356904\";s:6:\"mdhash\";s:32:\"342e0e3963e64c39f86061a10bbdaf2e\";s:8:\"filesize\";s:5:\"27898\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:28:\"module_filter 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/module_filter/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/module_filter-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1384832005\";s:6:\"mdhash\";s:32:\"3bfb306828c12830c0ee3678f675f124\";s:8:\"filesize\";s:5:\"27962\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:7:\"7.x-1.8\";a:14:{s:4:\"name\";s:21:\"module_filter 7.x-1.8\";s:7:\"version\";s:7:\"7.x-1.8\";s:3:\"tag\";s:7:\"7.x-1.8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/module_filter/releases/7.x-1.8\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/module_filter-7.x-1.8.tar.gz\";s:4:\"date\";s:10:\"1375995221\";s:6:\"mdhash\";s:32:\"53a1b995dee29e1ab202fa1547dc1266\";s:8:\"filesize\";s:5:\"14605\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.7\";a:14:{s:4:\"name\";s:21:\"module_filter 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/module_filter/releases/7.x-1.7\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/module_filter-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1341518501\";s:6:\"mdhash\";s:32:\"f10e62aa5346d5cd82854d66c359f199\";s:8:\"filesize\";s:5:\"14646\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:21:\"module_filter 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/module_filter/releases/7.x-1.6\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/module_filter-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1316105205\";s:6:\"mdhash\";s:32:\"77ca515021372066e2b19906adddb94e\";s:8:\"filesize\";s:5:\"13177\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:21:\"module_filter 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/module_filter/releases/7.x-1.5\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/module_filter-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1313598120\";s:6:\"mdhash\";s:32:\"f3a6a44ec3e35e91870f8391a9f04ff5\";s:8:\"filesize\";s:5:\"13039\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:21:\"module_filter 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/module_filter/releases/7.x-1.4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/module_filter-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1299525068\";s:6:\"mdhash\";s:32:\"90d9ec10df0b9ee07707f87b96711bca\";s:8:\"filesize\";s:5:\"11570\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:21:\"module_filter 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/module_filter/releases/7.x-1.3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/module_filter-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1299519370\";s:6:\"mdhash\";s:32:\"8a075e4932db8cd4e35371ac276bcb4b\";s:8:\"filesize\";s:5:\"11555\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:21:\"module_filter 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/module_filter/releases/7.x-1.2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/module_filter-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1299516669\";s:6:\"mdhash\";s:32:\"afbb784aeb4029294e5877654385cc8c\";s:8:\"filesize\";s:5:\"11446\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:21:\"module_filter 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/module_filter/releases/7.x-1.1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/module_filter-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1299515169\";s:6:\"mdhash\";s:32:\"45546c1f5bc473389ffc36f0e38a2bc1\";s:8:\"filesize\";s:5:\"13033\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:21:\"module_filter 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/module_filter/releases/7.x-1.0\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/module_filter-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1294104365\";s:6:\"mdhash\";s:32:\"a482aef54751a8fd947bafc2d5ef1ecd\";s:8:\"filesize\";s:5:\"11523\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:25:\"module_filter 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/module_filter/releases/7.x-2.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/module_filter-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1497029343\";s:6:\"mdhash\";s:32:\"bf63bf30b9a6eecb11e527cc12a87312\";s:8:\"filesize\";s:5:\"29762\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:25:\"module_filter 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/module_filter/releases/7.x-1.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/module_filter-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1406917428\";s:6:\"mdhash\";s:32:\"62b7a0ab716b2798d9e60462314d95c5\";s:8:\"filesize\";s:5:\"14743\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447570,1500361146,1),('available_releases::node_class','a:11:{s:5:\"title\";s:10:\"Node Class\";s:10:\"short_name\";s:10:\"node_class\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:41:\"https://www.drupal.org/project/node_class\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:3:{s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:18:\"node_class 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/node_class/releases/7.x-1.3\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/node_class-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1388997805\";s:6:\"mdhash\";s:32:\"76bc0de128d7108d7131c710798c79a8\";s:8:\"filesize\";s:4:\"8698\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:18:\"node_class 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/node_class/releases/7.x-1.1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/node_class-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1353409388\";s:6:\"mdhash\";s:32:\"7132a7c92d76ee2f6d674d96076f40a3\";s:8:\"filesize\";s:4:\"8733\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:18:\"node_class 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/node_class/releases/7.x-1.0\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/node_class-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1327735847\";s:6:\"mdhash\";s:32:\"63906a6d1f0d1dec47561258a8fe4795\";s:8:\"filesize\";s:4:\"8625\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}}}',1500447571,1500361146,1),('available_releases::pathauto','a:11:{s:5:\"title\";s:8:\"Pathauto\";s:10:\"short_name\";s:8:\"pathauto\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:39:\"https://www.drupal.org/project/pathauto\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:10:{s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:16:\"pathauto 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/pathauto/releases/7.x-1.3\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/pathauto-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1444232639\";s:6:\"mdhash\";s:32:\"ff984b2837230a221d53fad5462c0b61\";s:8:\"filesize\";s:5:\"42319\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:16:\"pathauto 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/pathauto/releases/7.x-1.2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/pathauto-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1344525185\";s:6:\"mdhash\";s:32:\"abdb73c49803aefe3c87774a92c42b87\";s:8:\"filesize\";s:5:\"38900\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:16:\"pathauto 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/pathauto/releases/7.x-1.1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/pathauto-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1336950382\";s:6:\"mdhash\";s:32:\"ee42c248db62f384871cb526d72005f2\";s:8:\"filesize\";s:5:\"38652\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:16:\"pathauto 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/pathauto/releases/7.x-1.0\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/pathauto-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1320072936\";s:6:\"mdhash\";s:32:\"6edd617da0cfa31ddde247933d670ef4\";s:8:\"filesize\";s:5:\"37196\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-1.0-rc2\";a:15:{s:4:\"name\";s:20:\"pathauto 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/pathauto/releases/7.x-1.0-rc2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/pathauto-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1308241021\";s:6:\"mdhash\";s:32:\"376c28fa39f3b383ad5134c5a1360be7\";s:8:\"filesize\";s:5:\"35681\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:20:\"pathauto 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/pathauto/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/pathauto-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1308121619\";s:6:\"mdhash\";s:32:\"a53a56cffaaa67c8775c085d542f162c\";s:8:\"filesize\";s:5:\"35350\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:22:\"pathauto 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/pathauto/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/pathauto-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1294891602\";s:6:\"mdhash\";s:32:\"37c8eaa37d69d60303e702c271f99f9e\";s:8:\"filesize\";s:5:\"56885\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:23:\"pathauto 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/pathauto/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/pathauto-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1281556294\";s:6:\"mdhash\";s:32:\"5f4aecc1b5d6a6e4365fafcc7f0efe15\";s:8:\"filesize\";s:6:\"122301\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:12:\"New features\";i:2;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:23:\"pathauto 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/pathauto/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/pathauto-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1267300506\";s:6:\"mdhash\";s:32:\"ec86f7a12f9b4daa02967a3d7ccedef6\";s:8:\"filesize\";s:6:\"121249\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:20:\"pathauto 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/pathauto/releases/7.x-1.x-dev\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/pathauto-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1472576639\";s:6:\"mdhash\";s:32:\"a597c609ed9d356b6ad4faa978b12aa7\";s:8:\"filesize\";s:5:\"42278\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1500447571,1500361146,1),('available_releases::recently_read','a:11:{s:5:\"title\";s:13:\"Recently read\";s:10:\"short_name\";s:13:\"recently_read\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"3\";s:16:\"supported_majors\";s:3:\"2,3\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:44:\"https://www.drupal.org/project/recently_read\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:14:{s:7:\"7.x-3.2\";a:14:{s:4:\"name\";s:21:\"recently_read 7.x-3.2\";s:7:\"version\";s:7:\"7.x-3.2\";s:3:\"tag\";s:7:\"7.x-3.2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/recently_read/releases/7.x-3.2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/recently_read-7.x-3.2.tar.gz\";s:4:\"date\";s:10:\"1473054539\";s:6:\"mdhash\";s:32:\"c557ea870569b051cc9302af3f5fea71\";s:8:\"filesize\";s:5:\"11827\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-3.1\";a:14:{s:4:\"name\";s:21:\"recently_read 7.x-3.1\";s:7:\"version\";s:7:\"7.x-3.1\";s:3:\"tag\";s:7:\"7.x-3.1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/recently_read/releases/7.x-3.1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/recently_read-7.x-3.1.tar.gz\";s:4:\"date\";s:10:\"1409150631\";s:6:\"mdhash\";s:32:\"571a6f27f3a7233e499f1646edd9b3a0\";s:8:\"filesize\";s:5:\"11798\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-3.0\";a:14:{s:4:\"name\";s:21:\"recently_read 7.x-3.0\";s:7:\"version\";s:7:\"7.x-3.0\";s:3:\"tag\";s:7:\"7.x-3.0\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/recently_read/releases/7.x-3.0\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/recently_read-7.x-3.0.tar.gz\";s:4:\"date\";s:10:\"1393752805\";s:6:\"mdhash\";s:32:\"3f6c555692f7204cbff3aaae233472c3\";s:8:\"filesize\";s:5:\"11842\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:14:\"7.x-3.0-alpha2\";a:15:{s:4:\"name\";s:28:\"recently_read 7.x-3.0-alpha2\";s:7:\"version\";s:14:\"7.x-3.0-alpha2\";s:3:\"tag\";s:14:\"7.x-3.0-alpha2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/recently_read/releases/7.x-3.0-alpha2\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/recently_read-7.x-3.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1376841402\";s:6:\"mdhash\";s:32:\"195c22e2b68375a49af7d03baaba58b9\";s:8:\"filesize\";s:5:\"11775\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-3.0-alpha1\";a:15:{s:4:\"name\";s:28:\"recently_read 7.x-3.0-alpha1\";s:7:\"version\";s:14:\"7.x-3.0-alpha1\";s:3:\"tag\";s:14:\"7.x-3.0-alpha1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/recently_read/releases/7.x-3.0-alpha1\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/recently_read-7.x-3.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1365839429\";s:6:\"mdhash\";s:32:\"85b87e214f1c5db93b6a372b2f22e2d7\";s:8:\"filesize\";s:5:\"10716\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha3\";a:15:{s:4:\"name\";s:28:\"recently_read 7.x-2.0-alpha3\";s:7:\"version\";s:14:\"7.x-2.0-alpha3\";s:3:\"tag\";s:14:\"7.x-2.0-alpha3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/recently_read/releases/7.x-2.0-alpha3\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/recently_read-7.x-2.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1360051246\";s:6:\"mdhash\";s:32:\"a7ded8ecb8e1a1a7da29d255b234f8b7\";s:8:\"filesize\";s:5:\"13432\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha2\";a:15:{s:4:\"name\";s:28:\"recently_read 7.x-2.0-alpha2\";s:7:\"version\";s:14:\"7.x-2.0-alpha2\";s:3:\"tag\";s:14:\"7.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/recently_read/releases/7.x-2.0-alpha2\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/recently_read-7.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1359450314\";s:6:\"mdhash\";s:32:\"d9f9e8be5a27ef098bb69a33b205efe8\";s:8:\"filesize\";s:5:\"13067\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:28:\"recently_read 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/recently_read/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/recently_read-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1359016089\";s:6:\"mdhash\";s:32:\"e0cce9b396b487df3ea98bb31b1642ac\";s:8:\"filesize\";s:5:\"12435\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:27:\"recently_read 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/recently_read/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/recently_read-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1330713347\";s:6:\"mdhash\";s:32:\"92e9e6ed7c3d45ec54e3297aad3fb7cd\";s:8:\"filesize\";s:5:\"11800\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-1.0-alpha4\";a:15:{s:4:\"name\";s:28:\"recently_read 7.x-1.0-alpha4\";s:7:\"version\";s:14:\"7.x-1.0-alpha4\";s:3:\"tag\";s:14:\"7.x-1.0-alpha4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/recently_read/releases/7.x-1.0-alpha4\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/recently_read-7.x-1.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1330077045\";s:6:\"mdhash\";s:32:\"5169d481a5de555e02fab8cf6f88b4d8\";s:8:\"filesize\";s:5:\"11291\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:28:\"recently_read 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/recently_read/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/recently_read-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1307104920\";s:6:\"mdhash\";s:32:\"1cfb383883b3aef295f53c566e4f7582\";s:8:\"filesize\";s:4:\"9574\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-3.x-dev\";a:14:{s:4:\"name\";s:25:\"recently_read 7.x-3.x-dev\";s:7:\"version\";s:11:\"7.x-3.x-dev\";s:3:\"tag\";s:7:\"7.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/recently_read/releases/7.x-3.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/recently_read-7.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1473053939\";s:6:\"mdhash\";s:32:\"91b3e5a37be8ca38101d3eafd710f130\";s:8:\"filesize\";s:5:\"11831\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:25:\"recently_read 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/recently_read/releases/7.x-2.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/recently_read-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380624958\";s:6:\"mdhash\";s:32:\"c7debe781be51318405271df9036ca1b\";s:8:\"filesize\";s:5:\"14841\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:25:\"recently_read 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/recently_read/releases/7.x-1.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/recently_read-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380624965\";s:6:\"mdhash\";s:32:\"6e525dfaa250503741dc3e69599934b4\";s:8:\"filesize\";s:5:\"11811\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447572,1500361146,1),('available_releases::rules','a:11:{s:5:\"title\";s:5:\"Rules\";s:10:\"short_name\";s:5:\"rules\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:36:\"https://www.drupal.org/project/rules\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:24:{s:8:\"7.x-2.10\";a:14:{s:4:\"name\";s:14:\"rules 7.x-2.10\";s:7:\"version\";s:8:\"7.x-2.10\";s:3:\"tag\";s:8:\"7.x-2.10\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/rules/releases/7.x-2.10\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/rules-7.x-2.10.tar.gz\";s:4:\"date\";s:10:\"1492697942\";s:6:\"mdhash\";s:32:\"b66045ee97acdec07b4808f649e9dcc8\";s:8:\"filesize\";s:6:\"187783\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.9\";a:14:{s:4:\"name\";s:13:\"rules 7.x-2.9\";s:7:\"version\";s:7:\"7.x-2.9\";s:3:\"tag\";s:7:\"7.x-2.9\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/rules/releases/7.x-2.9\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/rules-7.x-2.9.tar.gz\";s:4:\"date\";s:10:\"1426527181\";s:6:\"mdhash\";s:32:\"ce4e3363c37cb00f4caf0abd3f38f38a\";s:8:\"filesize\";s:6:\"188880\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.8\";a:14:{s:4:\"name\";s:13:\"rules 7.x-2.8\";s:7:\"version\";s:7:\"7.x-2.8\";s:3:\"tag\";s:7:\"7.x-2.8\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/rules/releases/7.x-2.8\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/rules-7.x-2.8.tar.gz\";s:4:\"date\";s:10:\"1420733280\";s:6:\"mdhash\";s:32:\"c84d88caa5ba178efa689a1a71d3a144\";s:8:\"filesize\";s:6:\"187857\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.7\";a:14:{s:4:\"name\";s:13:\"rules 7.x-2.7\";s:7:\"version\";s:7:\"7.x-2.7\";s:3:\"tag\";s:7:\"7.x-2.7\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/rules/releases/7.x-2.7\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/rules-7.x-2.7.tar.gz\";s:4:\"date\";s:10:\"1399041227\";s:6:\"mdhash\";s:32:\"f28b8811918dd16952acca967d09dcc0\";s:8:\"filesize\";s:6:\"186255\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.6\";a:14:{s:4:\"name\";s:13:\"rules 7.x-2.6\";s:7:\"version\";s:7:\"7.x-2.6\";s:3:\"tag\";s:7:\"7.x-2.6\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/rules/releases/7.x-2.6\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/rules-7.x-2.6.tar.gz\";s:4:\"date\";s:10:\"1383063053\";s:6:\"mdhash\";s:32:\"152c1f330f91f83d358b478253a8c042\";s:8:\"filesize\";s:6:\"186022\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.5\";a:14:{s:4:\"name\";s:13:\"rules 7.x-2.5\";s:7:\"version\";s:7:\"7.x-2.5\";s:3:\"tag\";s:7:\"7.x-2.5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/rules/releases/7.x-2.5\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/rules-7.x-2.5.tar.gz\";s:4:\"date\";s:10:\"1379579047\";s:6:\"mdhash\";s:32:\"5387542c8c5cd2de9682d61fafb57314\";s:8:\"filesize\";s:6:\"185061\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.4\";a:14:{s:4:\"name\";s:13:\"rules 7.x-2.4\";s:7:\"version\";s:7:\"7.x-2.4\";s:3:\"tag\";s:7:\"7.x-2.4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/rules/releases/7.x-2.4\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/rules-7.x-2.4.tar.gz\";s:4:\"date\";s:10:\"1379354606\";s:6:\"mdhash\";s:32:\"e19b2c10f96c8a680afe9e4f65db4e5c\";s:8:\"filesize\";s:6:\"184071\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:7:\"7.x-2.3\";a:14:{s:4:\"name\";s:13:\"rules 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/rules/releases/7.x-2.3\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/rules-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1364401819\";s:6:\"mdhash\";s:32:\"9af9fbdc593158638603832c633432b1\";s:8:\"filesize\";s:6:\"170892\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:13:\"rules 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/rules/releases/7.x-2.2\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/rules-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1343980733\";s:6:\"mdhash\";s:32:\"91799bff2cf6690937e056734265458c\";s:8:\"filesize\";s:6:\"168867\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:13:\"rules 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/rules/releases/7.x-2.1\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/rules-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1331918148\";s:6:\"mdhash\";s:32:\"a7f15c72df435554790d5611a8b1732e\";s:8:\"filesize\";s:6:\"167042\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:13:\"rules 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/rules/releases/7.x-2.0\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/rules-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1318336335\";s:6:\"mdhash\";s:32:\"efe3f31a4d21b9fa8757cd692dc8f641\";s:8:\"filesize\";s:6:\"155077\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:11:\"7.x-2.0-rc2\";a:15:{s:4:\"name\";s:17:\"rules 7.x-2.0-rc2\";s:7:\"version\";s:11:\"7.x-2.0-rc2\";s:3:\"tag\";s:11:\"7.x-2.0-rc2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/rules/releases/7.x-2.0-rc2\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/rules-7.x-2.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1316339806\";s:6:\"mdhash\";s:32:\"9a9d7de26f666d5af62fc90612551f64\";s:8:\"filesize\";s:6:\"152243\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.0-rc1\";a:15:{s:4:\"name\";s:17:\"rules 7.x-2.0-rc1\";s:7:\"version\";s:11:\"7.x-2.0-rc1\";s:3:\"tag\";s:11:\"7.x-2.0-rc1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/rules/releases/7.x-2.0-rc1\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/rules-7.x-2.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1313600220\";s:6:\"mdhash\";s:32:\"0c01319958aed5439bd7e22d5f060ab0\";s:8:\"filesize\";s:6:\"150814\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta3\";a:15:{s:4:\"name\";s:19:\"rules 7.x-2.0-beta3\";s:7:\"version\";s:13:\"7.x-2.0-beta3\";s:3:\"tag\";s:13:\"7.x-2.0-beta3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/rules/releases/7.x-2.0-beta3\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/rules-7.x-2.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1312908119\";s:6:\"mdhash\";s:32:\"c0d8f94ec44834355ab2acd02eb01781\";s:8:\"filesize\";s:6:\"146211\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta2\";a:15:{s:4:\"name\";s:19:\"rules 7.x-2.0-beta2\";s:7:\"version\";s:13:\"7.x-2.0-beta2\";s:3:\"tag\";s:13:\"7.x-2.0-beta2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/rules/releases/7.x-2.0-beta2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/rules-7.x-2.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1308241620\";s:6:\"mdhash\";s:32:\"fd1bdc36bc612913dfba91e7bdeda00d\";s:8:\"filesize\";s:6:\"139063\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta1\";a:15:{s:4:\"name\";s:19:\"rules 7.x-2.0-beta1\";s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:3:\"tag\";s:13:\"7.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/rules/releases/7.x-2.0-beta1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/rules-7.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1300896369\";s:6:\"mdhash\";s:32:\"7b9718415365872eca4a2f7b9f50787a\";s:8:\"filesize\";s:6:\"134506\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha5\";a:15:{s:4:\"name\";s:20:\"rules 7.x-2.0-alpha5\";s:7:\"version\";s:14:\"7.x-2.0-alpha5\";s:3:\"tag\";s:14:\"7.x-2.0-alpha5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/rules/releases/7.x-2.0-alpha5\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/rules-7.x-2.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1297877847\";s:6:\"mdhash\";s:32:\"cf14a81dca5d26d4ab392bc14c0c23a6\";s:8:\"filesize\";s:6:\"124733\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-2.0-alpha4\";a:15:{s:4:\"name\";s:20:\"rules 7.x-2.0-alpha4\";s:7:\"version\";s:14:\"7.x-2.0-alpha4\";s:3:\"tag\";s:14:\"7.x-2.0-alpha4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/rules/releases/7.x-2.0-alpha4\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/rules-7.x-2.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1294228281\";s:6:\"mdhash\";s:32:\"3e6905f82d9c9e1ab462ab0c90afe3e9\";s:8:\"filesize\";s:6:\"113547\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha3\";a:15:{s:4:\"name\";s:20:\"rules 7.x-2.0-alpha3\";s:7:\"version\";s:14:\"7.x-2.0-alpha3\";s:3:\"tag\";s:14:\"7.x-2.0-alpha3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/rules/releases/7.x-2.0-alpha3\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/rules-7.x-2.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1291637070\";s:6:\"mdhash\";s:32:\"92f674a49f40ddd9ffb8de5b0e91425f\";s:8:\"filesize\";s:6:\"108782\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha2\";a:15:{s:4:\"name\";s:20:\"rules 7.x-2.0-alpha2\";s:7:\"version\";s:14:\"7.x-2.0-alpha2\";s:3:\"tag\";s:14:\"7.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/rules/releases/7.x-2.0-alpha2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/rules-7.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1286798162\";s:6:\"mdhash\";s:32:\"57e3e8298fff1c6f7cf6af8a0a3c3309\";s:8:\"filesize\";s:6:\"106373\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:20:\"rules 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/rules/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/rules-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1283932308\";s:6:\"mdhash\";s:32:\"103e926a3b79276e6a7ea62b12a7f2a1\";s:8:\"filesize\";s:6:\"104650\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:20:\"rules 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/rules/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/rules-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1286792763\";s:6:\"mdhash\";s:32:\"c49d85d2bb2fb860580a79e3f930b5c1\";s:8:\"filesize\";s:6:\"106374\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:17:\"rules 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/rules/releases/7.x-2.x-dev\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/rules-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1492696442\";s:6:\"mdhash\";s:32:\"68fea23d84ad3632092f9a9ba8d7c636\";s:8:\"filesize\";s:6:\"187827\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:17:\"rules 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/rules/releases/7.x-1.x-dev\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/rules-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380626241\";s:6:\"mdhash\";s:32:\"a1a7d855e52429da95024a30a55a635a\";s:8:\"filesize\";s:4:\"7108\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447572,1500361146,1),('available_releases::search_api','a:11:{s:5:\"title\";s:10:\"Search API\";s:10:\"short_name\";s:10:\"search_api\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:41:\"https://www.drupal.org/project/search_api\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:34:{s:8:\"7.x-1.21\";a:14:{s:4:\"name\";s:19:\"search_api 7.x-1.21\";s:7:\"version\";s:8:\"7.x-1.21\";s:3:\"tag\";s:8:\"7.x-1.21\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"21\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/search_api/releases/7.x-1.21\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.21.tar.gz\";s:4:\"date\";s:10:\"1487844487\";s:6:\"mdhash\";s:32:\"271ef8d9aa8c58787579c90d6f47053f\";s:8:\"filesize\";s:6:\"201027\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.20\";a:14:{s:4:\"name\";s:19:\"search_api 7.x-1.20\";s:7:\"version\";s:8:\"7.x-1.20\";s:3:\"tag\";s:8:\"7.x-1.20\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"20\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/search_api/releases/7.x-1.20\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.20.tar.gz\";s:4:\"date\";s:10:\"1469117339\";s:6:\"mdhash\";s:32:\"beb8c564b0f6833de7edc51ac7967751\";s:8:\"filesize\";s:6:\"200086\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.19\";a:14:{s:4:\"name\";s:19:\"search_api 7.x-1.19\";s:7:\"version\";s:8:\"7.x-1.19\";s:3:\"tag\";s:8:\"7.x-1.19\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"19\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/search_api/releases/7.x-1.19\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.19.tar.gz\";s:4:\"date\";s:10:\"1467708539\";s:6:\"mdhash\";s:32:\"8779a9b9dd664d8118f1ebba6478e807\";s:8:\"filesize\";s:6:\"199603\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.18\";a:14:{s:4:\"name\";s:19:\"search_api 7.x-1.18\";s:7:\"version\";s:8:\"7.x-1.18\";s:3:\"tag\";s:8:\"7.x-1.18\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"18\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/search_api/releases/7.x-1.18\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.18.tar.gz\";s:4:\"date\";s:10:\"1461155340\";s:6:\"mdhash\";s:32:\"c9c3079289ae981daf46e1a6362014aa\";s:8:\"filesize\";s:6:\"198623\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.17\";a:14:{s:4:\"name\";s:19:\"search_api 7.x-1.17\";s:7:\"version\";s:8:\"7.x-1.17\";s:3:\"tag\";s:8:\"7.x-1.17\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"17\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/search_api/releases/7.x-1.17\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.17.tar.gz\";s:4:\"date\";s:10:\"1457970421\";s:6:\"mdhash\";s:32:\"014c8b533e527ea2b06ae74e925c8920\";s:8:\"filesize\";s:6:\"197589\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.16\";a:14:{s:4:\"name\";s:19:\"search_api 7.x-1.16\";s:7:\"version\";s:8:\"7.x-1.16\";s:3:\"tag\";s:8:\"7.x-1.16\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"16\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/search_api/releases/7.x-1.16\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.16.tar.gz\";s:4:\"date\";s:10:\"1440962810\";s:6:\"mdhash\";s:32:\"7e9fadfe45fd01c335ca0f71844b5970\";s:8:\"filesize\";s:6:\"194385\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.15\";a:14:{s:4:\"name\";s:19:\"search_api 7.x-1.15\";s:7:\"version\";s:8:\"7.x-1.15\";s:3:\"tag\";s:8:\"7.x-1.15\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"15\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/search_api/releases/7.x-1.15\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.15.tar.gz\";s:4:\"date\";s:10:\"1433351581\";s:6:\"mdhash\";s:32:\"7d11960c23632ec90a8050d66f8750d8\";s:8:\"filesize\";s:6:\"189122\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.14\";a:14:{s:4:\"name\";s:19:\"search_api 7.x-1.14\";s:7:\"version\";s:8:\"7.x-1.14\";s:3:\"tag\";s:8:\"7.x-1.14\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"14\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/search_api/releases/7.x-1.14\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.14.tar.gz\";s:4:\"date\";s:10:\"1419580680\";s:6:\"mdhash\";s:32:\"906edfaefe325754908cf4bbdff769a6\";s:8:\"filesize\";s:6:\"184006\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.13\";a:14:{s:4:\"name\";s:19:\"search_api 7.x-1.13\";s:7:\"version\";s:8:\"7.x-1.13\";s:3:\"tag\";s:8:\"7.x-1.13\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/search_api/releases/7.x-1.13\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.13.tar.gz\";s:4:\"date\";s:10:\"1406105328\";s:6:\"mdhash\";s:32:\"212edf36d470e41314ebdcf4082c2791\";s:8:\"filesize\";s:6:\"180529\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.12\";a:14:{s:4:\"name\";s:19:\"search_api 7.x-1.12\";s:7:\"version\";s:8:\"7.x-1.12\";s:3:\"tag\";s:8:\"7.x-1.12\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/search_api/releases/7.x-1.12\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.12.tar.gz\";s:4:\"date\";s:10:\"1400837327\";s:6:\"mdhash\";s:32:\"a19a0f98cfecffd9e512eb5749650d5f\";s:8:\"filesize\";s:6:\"179927\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.11\";a:14:{s:4:\"name\";s:19:\"search_api 7.x-1.11\";s:7:\"version\";s:8:\"7.x-1.11\";s:3:\"tag\";s:8:\"7.x-1.11\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/search_api/releases/7.x-1.11\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.11.tar.gz\";s:4:\"date\";s:10:\"1387965505\";s:6:\"mdhash\";s:32:\"d78379c20be4ee295bc4094945b80ce7\";s:8:\"filesize\";s:6:\"175650\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-1.10\";a:14:{s:4:\"name\";s:19:\"search_api 7.x-1.10\";s:7:\"version\";s:8:\"7.x-1.10\";s:3:\"tag\";s:8:\"7.x-1.10\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/search_api/releases/7.x-1.10\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.10.tar.gz\";s:4:\"date\";s:10:\"1386581306\";s:6:\"mdhash\";s:32:\"13c2ff2a5d327ce15afd322fbaa1bdea\";s:8:\"filesize\";s:6:\"175245\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.9\";a:14:{s:4:\"name\";s:18:\"search_api 7.x-1.9\";s:7:\"version\";s:7:\"7.x-1.9\";s:3:\"tag\";s:7:\"7.x-1.9\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/search_api/releases/7.x-1.9\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.9.tar.gz\";s:4:\"date\";s:10:\"1382525727\";s:6:\"mdhash\";s:32:\"ae863e39232d5ab12219e48339ae27b1\";s:8:\"filesize\";s:6:\"161724\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.8\";a:14:{s:4:\"name\";s:18:\"search_api 7.x-1.8\";s:7:\"version\";s:7:\"7.x-1.8\";s:3:\"tag\";s:7:\"7.x-1.8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/search_api/releases/7.x-1.8\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.8.tar.gz\";s:4:\"date\";s:10:\"1378025826\";s:6:\"mdhash\";s:32:\"1354bdb8a27ddd856a09406383d6029b\";s:8:\"filesize\";s:6:\"154912\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.7\";a:14:{s:4:\"name\";s:18:\"search_api 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/search_api/releases/7.x-1.7\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1372668956\";s:6:\"mdhash\";s:32:\"ee32070cf80c89049b428b0c081916da\";s:8:\"filesize\";s:6:\"148297\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:18:\"search_api 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/search_api/releases/7.x-1.6\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1369840267\";s:6:\"mdhash\";s:32:\"1445c08d9efd5ff0a3bd405029e5f7e6\";s:8:\"filesize\";s:6:\"143485\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:18:\"search_api 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/search_api/releases/7.x-1.5\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1367683811\";s:6:\"mdhash\";s:32:\"9cbbf4d2155c18722f35a4587a969936\";s:8:\"filesize\";s:6:\"140475\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:18:\"search_api 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/search_api/releases/7.x-1.4\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1357726719\";s:6:\"mdhash\";s:32:\"42ec65014beb9687e60dd751b9507229\";s:8:\"filesize\";s:6:\"137974\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:12:\"New features\";i:2;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:18:\"search_api 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/search_api/releases/7.x-1.3\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1350461221\";s:6:\"mdhash\";s:32:\"cf8c67a0056fa385eedcdb5d013ae10c\";s:8:\"filesize\";s:6:\"137615\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:12:\"New features\";i:2;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:18:\"search_api 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/search_api/releases/7.x-1.2\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1341612141\";s:6:\"mdhash\";s:32:\"c7ff87666be452eb6fab2b7bea17d7fa\";s:8:\"filesize\";s:6:\"133724\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:18:\"search_api 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/search_api/releases/7.x-1.1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1337778096\";s:6:\"mdhash\";s:32:\"a32a70aa0925aeba38427223ab88f136\";s:8:\"filesize\";s:6:\"132769\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:12:\"New features\";i:2;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:18:\"search_api 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/search_api/releases/7.x-1.0\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1323968143\";s:6:\"mdhash\";s:32:\"10e881f1c4983ca1d62ba896433ae151\";s:8:\"filesize\";s:6:\"151104\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:22:\"search_api 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/search_api/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1320941436\";s:6:\"mdhash\";s:32:\"65536b0e30f5e9bec255d17a047938d3\";s:8:\"filesize\";s:6:\"149658\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-beta10\";a:15:{s:4:\"name\";s:25:\"search_api 7.x-1.0-beta10\";s:7:\"version\";s:14:\"7.x-1.0-beta10\";s:3:\"tag\";s:14:\"7.x-1.0-beta10\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/search_api/releases/7.x-1.0-beta10\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.0-beta10.tar.gz\";s:4:\"date\";s:10:\"1308562320\";s:6:\"mdhash\";s:32:\"0c294f8bd210d09af10b1cf4df315e34\";s:8:\"filesize\";s:6:\"133689\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta9\";a:15:{s:4:\"name\";s:24:\"search_api 7.x-1.0-beta9\";s:7:\"version\";s:13:\"7.x-1.0-beta9\";s:3:\"tag\";s:13:\"7.x-1.0-beta9\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/search_api/releases/7.x-1.0-beta9\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.0-beta9.tar.gz\";s:4:\"date\";s:10:\"1307399219\";s:6:\"mdhash\";s:32:\"a51da006d630bd675b93635cdee9b2c0\";s:8:\"filesize\";s:6:\"131527\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta8\";a:15:{s:4:\"name\";s:24:\"search_api 7.x-1.0-beta8\";s:7:\"version\";s:13:\"7.x-1.0-beta8\";s:3:\"tag\";s:13:\"7.x-1.0-beta8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/search_api/releases/7.x-1.0-beta8\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.0-beta8.tar.gz\";s:4:\"date\";s:10:\"1301749869\";s:6:\"mdhash\";s:32:\"2245e66977cebe2df8b7c21ad289d192\";s:8:\"filesize\";s:6:\"122416\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta7\";a:15:{s:4:\"name\";s:24:\"search_api 7.x-1.0-beta7\";s:7:\"version\";s:13:\"7.x-1.0-beta7\";s:3:\"tag\";s:13:\"7.x-1.0-beta7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/search_api/releases/7.x-1.0-beta7\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.0-beta7.tar.gz\";s:4:\"date\";s:10:\"1299579669\";s:6:\"mdhash\";s:32:\"0a294f232c027260beceed26e28db761\";s:8:\"filesize\";s:6:\"119377\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta6\";a:15:{s:4:\"name\";s:24:\"search_api 7.x-1.0-beta6\";s:7:\"version\";s:13:\"7.x-1.0-beta6\";s:3:\"tag\";s:13:\"7.x-1.0-beta6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/search_api/releases/7.x-1.0-beta6\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.0-beta6.tar.gz\";s:4:\"date\";s:10:\"1299263469\";s:6:\"mdhash\";s:32:\"84a19f33375ee7bb7d3bfc752fb0d4cc\";s:8:\"filesize\";s:6:\"119213\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta5\";a:15:{s:4:\"name\";s:24:\"search_api 7.x-1.0-beta5\";s:7:\"version\";s:13:\"7.x-1.0-beta5\";s:3:\"tag\";s:13:\"7.x-1.0-beta5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/search_api/releases/7.x-1.0-beta5\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1294241542\";s:6:\"mdhash\";s:32:\"2b82abb106e68ad339c6dc9aadf4f343\";s:8:\"filesize\";s:6:\"110378\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta4\";a:15:{s:4:\"name\";s:24:\"search_api 7.x-1.0-beta4\";s:7:\"version\";s:13:\"7.x-1.0-beta4\";s:3:\"tag\";s:13:\"7.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/search_api/releases/7.x-1.0-beta4\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1291033545\";s:6:\"mdhash\";s:32:\"b11824307d4f26dcb0ed40bb94c82d75\";s:8:\"filesize\";s:6:\"106267\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta3\";a:15:{s:4:\"name\";s:24:\"search_api 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/search_api/releases/7.x-1.0-beta3\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1285871472\";s:6:\"mdhash\";s:32:\"b324c2c807cca2b6599c3ceb1f1e4014\";s:8:\"filesize\";s:6:\"124272\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:24:\"search_api 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/search_api/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1282688508\";s:6:\"mdhash\";s:32:\"51aab0439d0db66e24e735c92aaa8dff\";s:8:\"filesize\";s:5:\"71460\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:24:\"search_api 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/search_api/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1282176993\";s:6:\"mdhash\";s:32:\"4737f99778cd705d83264d149ba41389\";s:8:\"filesize\";s:5:\"65467\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:22:\"search_api 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/search_api/releases/7.x-1.x-dev\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1497780542\";s:6:\"mdhash\";s:32:\"a2d44ff0c8cac7d057e4f8e70981f334\";s:8:\"filesize\";s:6:\"202129\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447573,1500361146,1),('available_releases::search_api_db','a:11:{s:5:\"title\";s:26:\"Search API Database Search\";s:10:\"short_name\";s:13:\"search_api_db\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:44:\"https://www.drupal.org/project/search_api_db\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:15:{s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:21:\"search_api_db 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/search_api_db/releases/7.x-1.6\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/search_api_db-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1487844783\";s:6:\"mdhash\";s:32:\"f1d282d1993f7b0586952bb927e8c313\";s:8:\"filesize\";s:5:\"38356\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:21:\"search_api_db 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/search_api_db/releases/7.x-1.5\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/search_api_db-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1440962639\";s:6:\"mdhash\";s:32:\"b41d20e189557bcf11926ea0fc80e74c\";s:8:\"filesize\";s:5:\"36795\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:21:\"search_api_db 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/search_api_db/releases/7.x-1.4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/search_api_db-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1410185628\";s:6:\"mdhash\";s:32:\"ea1c383f27e61d1b4e5266fb4e2ffaf7\";s:8:\"filesize\";s:5:\"35981\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:21:\"search_api_db 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/search_api_db/releases/7.x-1.3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/search_api_db-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1400837927\";s:6:\"mdhash\";s:32:\"b9b34b4e5822c0bde8ccabe5368b2baa\";s:8:\"filesize\";s:5:\"32934\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:21:\"search_api_db 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/search_api_db/releases/7.x-1.2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/search_api_db-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1387968804\";s:6:\"mdhash\";s:32:\"1bf9fd4d6b22e991a6904e3da9d15e19\";s:8:\"filesize\";s:5:\"28351\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:21:\"search_api_db 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/search_api_db/releases/7.x-1.1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/search_api_db-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1386584304\";s:6:\"mdhash\";s:32:\"78160ac36ece6d9235c424a6ef4f0da4\";s:8:\"filesize\";s:5:\"27812\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:21:\"search_api_db 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/search_api_db/releases/7.x-1.0\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/search_api_db-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1382523933\";s:6:\"mdhash\";s:32:\"47e2770bb7021140475b430203fe48ca\";s:8:\"filesize\";s:5:\"26169\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-1.0-rc3\";a:15:{s:4:\"name\";s:25:\"search_api_db 7.x-1.0-rc3\";s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:3:\"tag\";s:11:\"7.x-1.0-rc3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/search_api_db/releases/7.x-1.0-rc3\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/search_api_db-7.x-1.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1380367065\";s:6:\"mdhash\";s:32:\"cac44ff001c787e2beffd9d2fcd977b4\";s:8:\"filesize\";s:5:\"25847\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc2\";a:15:{s:4:\"name\";s:25:\"search_api_db 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/search_api_db/releases/7.x-1.0-rc2\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/search_api_db-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1374443183\";s:6:\"mdhash\";s:32:\"288bf257573c788f1d93ed50b0b6cd9d\";s:8:\"filesize\";s:5:\"24728\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:25:\"search_api_db 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/search_api_db/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/search_api_db-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1368805217\";s:6:\"mdhash\";s:32:\"278528dc46fa4361fe76e4f76145e243\";s:8:\"filesize\";s:5:\"20412\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta4\";a:15:{s:4:\"name\";s:27:\"search_api_db 7.x-1.0-beta4\";s:7:\"version\";s:13:\"7.x-1.0-beta4\";s:3:\"tag\";s:13:\"7.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/search_api_db/releases/7.x-1.0-beta4\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/search_api_db-7.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1351629735\";s:6:\"mdhash\";s:32:\"45b5a4f9219744f9901939fea8559449\";s:8:\"filesize\";s:5:\"19807\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta3\";a:15:{s:4:\"name\";s:27:\"search_api_db 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/search_api_db/releases/7.x-1.0-beta3\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/search_api_db-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1337790720\";s:6:\"mdhash\";s:32:\"8d1a0ab3c61e94860338b40988be8eb8\";s:8:\"filesize\";s:5:\"19583\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:27:\"search_api_db 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/search_api_db/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/search_api_db-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1320944435\";s:6:\"mdhash\";s:32:\"7ca0fa2f9cc7f73ce3b923511539ff5e\";s:8:\"filesize\";s:5:\"19670\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:27:\"search_api_db 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/search_api_db/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/search_api_db-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1315339623\";s:6:\"mdhash\";s:32:\"4abb5dd2d2676c44506114a2cf1f8f82\";s:8:\"filesize\";s:5:\"18426\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:25:\"search_api_db 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/search_api_db/releases/7.x-1.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/search_api_db-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1497778742\";s:6:\"mdhash\";s:32:\"948b49608b6155ffc456e3cb0351499f\";s:8:\"filesize\";s:5:\"38504\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1500447574,1500361146,1),('available_releases::search_api_ranges','a:11:{s:5:\"title\";s:17:\"Search API ranges\";s:10:\"short_name\";s:17:\"search_api_ranges\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:48:\"https://www.drupal.org/project/search_api_ranges\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:7:{s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:25:\"search_api_ranges 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/search_api_ranges/releases/7.x-1.5\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/search_api_ranges-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1392554905\";s:6:\"mdhash\";s:32:\"ecaefedf02924f5f502c4fa44cd60b1d\";s:8:\"filesize\";s:5:\"21717\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:25:\"search_api_ranges 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/search_api_ranges/releases/7.x-1.4\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/search_api_ranges-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1350817329\";s:6:\"mdhash\";s:32:\"4c62d0dc8568ec13203f35f71dde18ca\";s:8:\"filesize\";s:5:\"20191\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:25:\"search_api_ranges 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/search_api_ranges/releases/7.x-1.3\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/search_api_ranges-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1343071658\";s:6:\"mdhash\";s:32:\"9f2ddb3926b6c9f7405c17dfcde566ad\";s:8:\"filesize\";s:5:\"16986\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:25:\"search_api_ranges 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/search_api_ranges/releases/7.x-1.2\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/search_api_ranges-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1312478519\";s:6:\"mdhash\";s:32:\"09f5df9851f3ac3b2e1ece7e21fe6eb1\";s:8:\"filesize\";s:5:\"17931\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:25:\"search_api_ranges 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/search_api_ranges/releases/7.x-1.1\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/search_api_ranges-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1300551668\";s:6:\"mdhash\";s:32:\"b5b4cffbee545d60e599fef4bb8478ce\";s:8:\"filesize\";s:5:\"17323\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:25:\"search_api_ranges 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/search_api_ranges/releases/7.x-1.0\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/search_api_ranges-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1300551068\";s:6:\"mdhash\";s:32:\"f709b5991bbdd136109016a32da56d2b\";s:8:\"filesize\";s:5:\"16765\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:29:\"search_api_ranges 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/search_api_ranges/releases/7.x-1.x-dev\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/search_api_ranges-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1476286439\";s:6:\"mdhash\";s:32:\"61cad662be7f020859d352f47821421c\";s:8:\"filesize\";s:5:\"22871\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447574,1500361146,1),('available_releases::search_api_sorts','a:11:{s:5:\"title\";s:16:\"Search API sorts\";s:10:\"short_name\";s:16:\"search_api_sorts\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:47:\"https://www.drupal.org/project/search_api_sorts\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:9:{s:7:\"7.x-1.7\";a:14:{s:4:\"name\";s:24:\"search_api_sorts 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/search_api_sorts/releases/7.x-1.7\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/search_api_sorts-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1487095383\";s:6:\"mdhash\";s:32:\"b1da23994fc66340e5708d46c15e6288\";s:8:\"filesize\";s:5:\"15750\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:24:\"search_api_sorts 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/search_api_sorts/releases/7.x-1.6\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/search_api_sorts-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1450819139\";s:6:\"mdhash\";s:32:\"5fa9bb8c3a6f6523292dce8933dbbdca\";s:8:\"filesize\";s:5:\"15007\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:24:\"search_api_sorts 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/search_api_sorts/releases/7.x-1.5\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/search_api_sorts-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1392554905\";s:6:\"mdhash\";s:32:\"d072d96802d23653e2bc44476cbdf445\";s:8:\"filesize\";s:5:\"14716\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:24:\"search_api_sorts 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/search_api_sorts/releases/7.x-1.4\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/search_api_sorts-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1358960303\";s:6:\"mdhash\";s:32:\"94b2f6331a362a823841011140602d85\";s:8:\"filesize\";s:5:\"14690\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:24:\"search_api_sorts 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/search_api_sorts/releases/7.x-1.3\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/search_api_sorts-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1350816724\";s:6:\"mdhash\";s:32:\"5a92b065c2145661b2b8e3c15ffdf204\";s:8:\"filesize\";s:5:\"14632\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:24:\"search_api_sorts 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/search_api_sorts/releases/7.x-1.2\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/search_api_sorts-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1343071661\";s:6:\"mdhash\";s:32:\"58ab74fbc3e5315561f3d78ef157f8bf\";s:8:\"filesize\";s:5:\"14282\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:24:\"search_api_sorts 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/search_api_sorts/releases/7.x-1.1\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/search_api_sorts-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1301912768\";s:6:\"mdhash\";s:32:\"0f1f6d29a699dbcb07691cfdb1770399\";s:8:\"filesize\";s:5:\"11790\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:24:\"search_api_sorts 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/search_api_sorts/releases/7.x-1.0\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/search_api_sorts-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1301163668\";s:6:\"mdhash\";s:32:\"b9768350bda08771ceaba3d3b0ad9bad\";s:8:\"filesize\";s:5:\"11724\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:28:\"search_api_sorts 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/search_api_sorts/releases/7.x-1.x-dev\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/search_api_sorts-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1487094782\";s:6:\"mdhash\";s:32:\"43bbdf2b3911e5594389d507640f0dc6\";s:8:\"filesize\";s:5:\"15755\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447575,1500361146,1),('available_releases::select_or_other','a:11:{s:5:\"title\";s:17:\"Select (or other)\";s:10:\"short_name\";s:15:\"select_or_other\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:3:\"2,3\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:46:\"https://www.drupal.org/project/select_or_other\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:26:{s:14:\"7.x-3.0-alpha1\";a:15:{s:4:\"name\";s:30:\"select_or_other 7.x-3.0-alpha1\";s:7:\"version\";s:14:\"7.x-3.0-alpha1\";s:3:\"tag\";s:14:\"7.x-3.0-alpha1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/select_or_other/releases/7.x-3.0-alpha1\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-3.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1445714939\";s:6:\"mdhash\";s:32:\"213b8ff79aebaa8be0895336304aba44\";s:8:\"filesize\";s:5:\"19469\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:8:\"7.x-2.22\";a:14:{s:4:\"name\";s:24:\"select_or_other 7.x-2.22\";s:7:\"version\";s:8:\"7.x-2.22\";s:3:\"tag\";s:8:\"7.x-2.22\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"22\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.22\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.22.tar.gz\";s:4:\"date\";s:10:\"1432142581\";s:6:\"mdhash\";s:32:\"0f8f19915f1cdda1f63bb304a5c257e7\";s:8:\"filesize\";s:5:\"17641\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-2.21\";a:14:{s:4:\"name\";s:24:\"select_or_other 7.x-2.21\";s:7:\"version\";s:8:\"7.x-2.21\";s:3:\"tag\";s:8:\"7.x-2.21\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"21\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.21\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.21.tar.gz\";s:4:\"date\";s:10:\"1428174181\";s:6:\"mdhash\";s:32:\"540c6205e20377dbd2019af63a745e14\";s:8:\"filesize\";s:5:\"17558\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-2.20\";a:14:{s:4:\"name\";s:24:\"select_or_other 7.x-2.20\";s:7:\"version\";s:8:\"7.x-2.20\";s:3:\"tag\";s:8:\"7.x-2.20\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"20\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.20\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.20.tar.gz\";s:4:\"date\";s:10:\"1378331246\";s:6:\"mdhash\";s:32:\"a7f46fc29adf1eef9ce9ed75e58a03ca\";s:8:\"filesize\";s:5:\"15462\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-2.19\";a:14:{s:4:\"name\";s:24:\"select_or_other 7.x-2.19\";s:7:\"version\";s:8:\"7.x-2.19\";s:3:\"tag\";s:8:\"7.x-2.19\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"19\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.19\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.19.tar.gz\";s:4:\"date\";s:10:\"1375892951\";s:6:\"mdhash\";s:32:\"861350113d5156a90617eb574ba377b2\";s:8:\"filesize\";s:5:\"15466\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-2.18\";a:14:{s:4:\"name\";s:24:\"select_or_other 7.x-2.18\";s:7:\"version\";s:8:\"7.x-2.18\";s:3:\"tag\";s:8:\"7.x-2.18\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"18\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.18\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.18.tar.gz\";s:4:\"date\";s:10:\"1372112751\";s:6:\"mdhash\";s:32:\"a41fb5455ada6554b5dfda0c5d8bb87d\";s:8:\"filesize\";s:5:\"15509\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-2.17\";a:14:{s:4:\"name\";s:24:\"select_or_other 7.x-2.17\";s:7:\"version\";s:8:\"7.x-2.17\";s:3:\"tag\";s:8:\"7.x-2.17\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"17\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.17\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.17.tar.gz\";s:4:\"date\";s:10:\"1369722663\";s:6:\"mdhash\";s:32:\"2cc43d0ff1145f2b087785e72ffa999d\";s:8:\"filesize\";s:5:\"15368\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-2.16\";a:14:{s:4:\"name\";s:24:\"select_or_other 7.x-2.16\";s:7:\"version\";s:8:\"7.x-2.16\";s:3:\"tag\";s:8:\"7.x-2.16\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"16\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.16\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.16.tar.gz\";s:4:\"date\";s:10:\"1366136517\";s:6:\"mdhash\";s:32:\"0d59eb969983a603ce8ba4ddbaf2d0ed\";s:8:\"filesize\";s:5:\"15372\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-2.15\";a:14:{s:4:\"name\";s:24:\"select_or_other 7.x-2.15\";s:7:\"version\";s:8:\"7.x-2.15\";s:3:\"tag\";s:8:\"7.x-2.15\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"15\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.15\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.15.tar.gz\";s:4:\"date\";s:10:\"1345436315\";s:6:\"mdhash\";s:32:\"75ac4f1ab7c8f38b372dfa9bde50f61a\";s:8:\"filesize\";s:5:\"14816\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-2.14\";a:14:{s:4:\"name\";s:24:\"select_or_other 7.x-2.14\";s:7:\"version\";s:8:\"7.x-2.14\";s:3:\"tag\";s:8:\"7.x-2.14\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"14\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.14\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.14.tar.gz\";s:4:\"date\";s:10:\"1342146140\";s:6:\"mdhash\";s:32:\"5ce0b27544b47f9ec14eb94c7c2981e4\";s:8:\"filesize\";s:5:\"14805\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-2.13\";a:14:{s:4:\"name\";s:24:\"select_or_other 7.x-2.13\";s:7:\"version\";s:8:\"7.x-2.13\";s:3:\"tag\";s:8:\"7.x-2.13\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.13\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.13.tar.gz\";s:4:\"date\";s:10:\"1341451651\";s:6:\"mdhash\";s:32:\"0089588e5ca4fff91c39bbc9a64355ca\";s:8:\"filesize\";s:5:\"14793\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-2.12\";a:14:{s:4:\"name\";s:24:\"select_or_other 7.x-2.12\";s:7:\"version\";s:8:\"7.x-2.12\";s:3:\"tag\";s:8:\"7.x-2.12\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.12\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.12.tar.gz\";s:4:\"date\";s:10:\"1341378469\";s:6:\"mdhash\";s:32:\"52d74da7f306a7485ad9b3b6cbc92bf7\";s:8:\"filesize\";s:5:\"14797\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-2.11\";a:14:{s:4:\"name\";s:24:\"select_or_other 7.x-2.11\";s:7:\"version\";s:8:\"7.x-2.11\";s:3:\"tag\";s:8:\"7.x-2.11\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.11\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.11.tar.gz\";s:4:\"date\";s:10:\"1339852313\";s:6:\"mdhash\";s:32:\"d2e7e6bfe2e2c2cde3ceec4b2fbb933f\";s:8:\"filesize\";s:5:\"14707\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:8:\"7.x-2.10\";a:14:{s:4:\"name\";s:24:\"select_or_other 7.x-2.10\";s:7:\"version\";s:8:\"7.x-2.10\";s:3:\"tag\";s:8:\"7.x-2.10\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.10\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.10.tar.gz\";s:4:\"date\";s:10:\"1337037989\";s:6:\"mdhash\";s:32:\"6755b12abf593c3c8c9452024006c488\";s:8:\"filesize\";s:5:\"14670\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.9\";a:14:{s:4:\"name\";s:23:\"select_or_other 7.x-2.9\";s:7:\"version\";s:7:\"7.x-2.9\";s:3:\"tag\";s:7:\"7.x-2.9\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.9\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.9.tar.gz\";s:4:\"date\";s:10:\"1332462051\";s:6:\"mdhash\";s:32:\"c242e04c2d8d430a019b48e2546774de\";s:8:\"filesize\";s:5:\"14639\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.8\";a:14:{s:4:\"name\";s:23:\"select_or_other 7.x-2.8\";s:7:\"version\";s:7:\"7.x-2.8\";s:3:\"tag\";s:7:\"7.x-2.8\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.8\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.8.tar.gz\";s:4:\"date\";s:10:\"1327201249\";s:6:\"mdhash\";s:32:\"5a844b316b3bc88713871747b899847a\";s:8:\"filesize\";s:5:\"14775\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.7\";a:14:{s:4:\"name\";s:23:\"select_or_other 7.x-2.7\";s:7:\"version\";s:7:\"7.x-2.7\";s:3:\"tag\";s:7:\"7.x-2.7\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.7\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.7.tar.gz\";s:4:\"date\";s:10:\"1319872535\";s:6:\"mdhash\";s:32:\"1b935921dbcde90b62b152cb14111eef\";s:8:\"filesize\";s:5:\"14375\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.6\";a:14:{s:4:\"name\";s:23:\"select_or_other 7.x-2.6\";s:7:\"version\";s:7:\"7.x-2.6\";s:3:\"tag\";s:7:\"7.x-2.6\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.6\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.6.tar.gz\";s:4:\"date\";s:10:\"1319448336\";s:6:\"mdhash\";s:32:\"dff216b5ed6445aa011053a5b2c17636\";s:8:\"filesize\";s:5:\"14357\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.5\";a:14:{s:4:\"name\";s:23:\"select_or_other 7.x-2.5\";s:7:\"version\";s:7:\"7.x-2.5\";s:3:\"tag\";s:7:\"7.x-2.5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.5\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.5.tar.gz\";s:4:\"date\";s:10:\"1311829919\";s:6:\"mdhash\";s:32:\"7c20e0e4f5b617632f31093ea58af81e\";s:8:\"filesize\";s:5:\"12937\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.4\";a:14:{s:4:\"name\";s:23:\"select_or_other 7.x-2.4\";s:7:\"version\";s:7:\"7.x-2.4\";s:3:\"tag\";s:7:\"7.x-2.4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.4\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.4.tar.gz\";s:4:\"date\";s:10:\"1309740184\";s:6:\"mdhash\";s:32:\"338e70851be371b5ebcf85c0e0ea86b4\";s:8:\"filesize\";s:5:\"12951\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.3\";a:14:{s:4:\"name\";s:23:\"select_or_other 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.3\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1309679521\";s:6:\"mdhash\";s:32:\"6bde2d6b909e2ac36a13ec5b793f6bd1\";s:8:\"filesize\";s:5:\"12956\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:23:\"select_or_other 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1309655238\";s:6:\"mdhash\";s:32:\"667f44bd6e56ba32bb4b48e50d76cf73\";s:8:\"filesize\";s:5:\"12781\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:23:\"select_or_other 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1309587729\";s:6:\"mdhash\";s:32:\"e31576303decbcb515f125ab068ef514\";s:8:\"filesize\";s:5:\"12785\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:23:\"select_or_other 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.0\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1307064717\";s:6:\"mdhash\";s:32:\"41385e26bd8c272b7ef99daf13fefd49\";s:8:\"filesize\";s:5:\"12719\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}s:11:\"7.x-3.x-dev\";a:14:{s:4:\"name\";s:27:\"select_or_other 7.x-3.x-dev\";s:7:\"version\";s:11:\"7.x-3.x-dev\";s:3:\"tag\";s:7:\"7.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/select_or_other/releases/7.x-3.x-dev\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1487792883\";s:6:\"mdhash\";s:32:\"8c35e6b18c39dc193bfb871df0206098\";s:8:\"filesize\";s:5:\"22058\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:27:\"select_or_other 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.x-dev\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1487795884\";s:6:\"mdhash\";s:32:\"b37bc0879e07918e593064559ab943c8\";s:8:\"filesize\";s:5:\"17927\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447575,1500361146,1),('available_releases::views_bulk_operations','a:11:{s:5:\"title\";s:27:\"Views Bulk Operations (VBO)\";s:10:\"short_name\";s:21:\"views_bulk_operations\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"3\";s:16:\"supported_majors\";s:1:\"3\";s:13:\"default_major\";s:1:\"3\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:52:\"https://www.drupal.org/project/views_bulk_operations\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:13:{s:7:\"7.x-3.4\";a:14:{s:4:\"name\";s:29:\"views_bulk_operations 7.x-3.4\";s:7:\"version\";s:7:\"7.x-3.4\";s:3:\"tag\";s:7:\"7.x-3.4\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/views_bulk_operations/releases/7.x-3.4\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/views_bulk_operations-7.x-3.4.tar.gz\";s:4:\"date\";s:10:\"1487698683\";s:6:\"mdhash\";s:32:\"0009517dea9b41bccfdd6ded6881e21a\";s:8:\"filesize\";s:5:\"45529\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-3.3\";a:14:{s:4:\"name\";s:29:\"views_bulk_operations 7.x-3.3\";s:7:\"version\";s:7:\"7.x-3.3\";s:3:\"tag\";s:7:\"7.x-3.3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/views_bulk_operations/releases/7.x-3.3\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/views_bulk_operations-7.x-3.3.tar.gz\";s:4:\"date\";s:10:\"1435764539\";s:6:\"mdhash\";s:32:\"b9583bb0a2e9b89926adc3ecb2bda93b\";s:8:\"filesize\";s:5:\"44411\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-3.2\";a:14:{s:4:\"name\";s:29:\"views_bulk_operations 7.x-3.2\";s:7:\"version\";s:7:\"7.x-3.2\";s:3:\"tag\";s:7:\"7.x-3.2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/views_bulk_operations/releases/7.x-3.2\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/views_bulk_operations-7.x-3.2.tar.gz\";s:4:\"date\";s:10:\"1387798104\";s:6:\"mdhash\";s:32:\"6e504288c3cde5dc71ef536764c14650\";s:8:\"filesize\";s:5:\"44149\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-3.1\";a:14:{s:4:\"name\";s:29:\"views_bulk_operations 7.x-3.1\";s:7:\"version\";s:7:\"7.x-3.1\";s:3:\"tag\";s:7:\"7.x-3.1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/views_bulk_operations/releases/7.x-3.1\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/views_bulk_operations-7.x-3.1.tar.gz\";s:4:\"date\";s:10:\"1354500015\";s:6:\"mdhash\";s:32:\"0650fc653870b5c12b2e7772ceaf6761\";s:8:\"filesize\";s:5:\"41247\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:7:\"7.x-3.0\";a:14:{s:4:\"name\";s:29:\"views_bulk_operations 7.x-3.0\";s:7:\"version\";s:7:\"7.x-3.0\";s:3:\"tag\";s:7:\"7.x-3.0\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/views_bulk_operations/releases/7.x-3.0\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/views_bulk_operations-7.x-3.0.tar.gz\";s:4:\"date\";s:10:\"1347654564\";s:6:\"mdhash\";s:32:\"9c80c378576571607af80f578d0a732d\";s:8:\"filesize\";s:5:\"43783\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-3.0-rc1\";a:15:{s:4:\"name\";s:33:\"views_bulk_operations 7.x-3.0-rc1\";s:7:\"version\";s:11:\"7.x-3.0-rc1\";s:3:\"tag\";s:11:\"7.x-3.0-rc1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:73:\"https://www.drupal.org/project/views_bulk_operations/releases/7.x-3.0-rc1\";s:13:\"download_link\";s:78:\"https://ftp.drupal.org/files/projects/views_bulk_operations-7.x-3.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1328576162\";s:6:\"mdhash\";s:32:\"801679e983d2f7021584b40328e828ee\";s:8:\"filesize\";s:5:\"45073\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta3\";a:15:{s:4:\"name\";s:35:\"views_bulk_operations 7.x-3.0-beta3\";s:7:\"version\";s:13:\"7.x-3.0-beta3\";s:3:\"tag\";s:13:\"7.x-3.0-beta3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:75:\"https://www.drupal.org/project/views_bulk_operations/releases/7.x-3.0-beta3\";s:13:\"download_link\";s:80:\"https://ftp.drupal.org/files/projects/views_bulk_operations-7.x-3.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1318586502\";s:6:\"mdhash\";s:32:\"6533e4877c8fb6cce9b30ef21368155e\";s:8:\"filesize\";s:5:\"37993\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta2\";a:15:{s:4:\"name\";s:35:\"views_bulk_operations 7.x-3.0-beta2\";s:7:\"version\";s:13:\"7.x-3.0-beta2\";s:3:\"tag\";s:13:\"7.x-3.0-beta2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:75:\"https://www.drupal.org/project/views_bulk_operations/releases/7.x-3.0-beta2\";s:13:\"download_link\";s:80:\"https://ftp.drupal.org/files/projects/views_bulk_operations-7.x-3.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1313422921\";s:6:\"mdhash\";s:32:\"1c66f47594adc4a1e902ce248a0b3e44\";s:8:\"filesize\";s:5:\"34077\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta1\";a:15:{s:4:\"name\";s:35:\"views_bulk_operations 7.x-3.0-beta1\";s:7:\"version\";s:13:\"7.x-3.0-beta1\";s:3:\"tag\";s:13:\"7.x-3.0-beta1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:75:\"https://www.drupal.org/project/views_bulk_operations/releases/7.x-3.0-beta1\";s:13:\"download_link\";s:80:\"https://ftp.drupal.org/files/projects/views_bulk_operations-7.x-3.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1310769122\";s:6:\"mdhash\";s:32:\"69852b6f084949ea312a016c0ede58d0\";s:8:\"filesize\";s:5:\"33185\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-3.0-alpha3\";a:15:{s:4:\"name\";s:36:\"views_bulk_operations 7.x-3.0-alpha3\";s:7:\"version\";s:14:\"7.x-3.0-alpha3\";s:3:\"tag\";s:14:\"7.x-3.0-alpha3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:76:\"https://www.drupal.org/project/views_bulk_operations/releases/7.x-3.0-alpha3\";s:13:\"download_link\";s:81:\"https://ftp.drupal.org/files/projects/views_bulk_operations-7.x-3.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1308505319\";s:6:\"mdhash\";s:32:\"53ac21f79173a955ea298250ce5e73e6\";s:8:\"filesize\";s:5:\"30612\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-3.0-alpha2\";a:15:{s:4:\"name\";s:36:\"views_bulk_operations 7.x-3.0-alpha2\";s:7:\"version\";s:14:\"7.x-3.0-alpha2\";s:3:\"tag\";s:14:\"7.x-3.0-alpha2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:76:\"https://www.drupal.org/project/views_bulk_operations/releases/7.x-3.0-alpha2\";s:13:\"download_link\";s:81:\"https://ftp.drupal.org/files/projects/views_bulk_operations-7.x-3.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1306677417\";s:6:\"mdhash\";s:32:\"705895d000a7919df2afcf8773017692\";s:8:\"filesize\";s:5:\"31069\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-3.0-alpha1\";a:15:{s:4:\"name\";s:36:\"views_bulk_operations 7.x-3.0-alpha1\";s:7:\"version\";s:14:\"7.x-3.0-alpha1\";s:3:\"tag\";s:14:\"7.x-3.0-alpha1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:76:\"https://www.drupal.org/project/views_bulk_operations/releases/7.x-3.0-alpha1\";s:13:\"download_link\";s:81:\"https://ftp.drupal.org/files/projects/views_bulk_operations-7.x-3.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1306621617\";s:6:\"mdhash\";s:32:\"c0e74e29388a67d12af24d5db4dcdda8\";s:8:\"filesize\";s:5:\"30918\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-3.x-dev\";a:14:{s:4:\"name\";s:33:\"views_bulk_operations 7.x-3.x-dev\";s:7:\"version\";s:11:\"7.x-3.x-dev\";s:3:\"tag\";s:7:\"7.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:73:\"https://www.drupal.org/project/views_bulk_operations/releases/7.x-3.x-dev\";s:13:\"download_link\";s:78:\"https://ftp.drupal.org/files/projects/views_bulk_operations-7.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1494951783\";s:6:\"mdhash\";s:32:\"082fa5349a7328367a4139a04d7bb51c\";s:8:\"filesize\";s:5:\"45855\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1500447546,1500361146,1),('fetch_failures','a:0:{}',1500361475,1500361146,1),('fetch_task::session_api',NULL,0,1500361137,0),('fetch_task::simplenews',NULL,0,1500361137,0),('fetch_task::tagclouds',NULL,0,1500361137,0),('fetch_task::taxonomy_menu',NULL,0,1500361137,0),('fetch_task::tb_megamenu',NULL,0,1500361137,0),('fetch_task::title',NULL,0,1500361137,0),('fetch_task::token',NULL,0,1500361137,0),('fetch_task::views',NULL,0,1500361137,0),('fetch_task::views_bootstrap',NULL,0,1500361137,0),('fetch_task::views_fieldsets',NULL,0,1500361137,0),('fetch_task::views_field_view',NULL,0,1500361137,0),('fetch_task::views_slideshow',NULL,0,1500361137,0),('fetch_task::votingapi',NULL,0,1500361137,0),('fetch_task::webform',NULL,0,1500361137,0),('fetch_task::weight',NULL,0,1500361137,0),('fetch_task::we_content_migration',NULL,0,1500361137,0),('update_project_data','a:73:{s:21:\"views_bulk_operations\";a:17:{s:4:\"name\";s:21:\"views_bulk_operations\";s:4:\"info\";a:6:{s:4:\"name\";s:25:\"Actions permissions (VBO)\";s:7:\"package\";s:14:\"Administration\";s:7:\"version\";s:7:\"7.x-3.3\";s:7:\"project\";s:21:\"views_bulk_operations\";s:9:\"datestamp\";s:10:\"1435764542\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1435764542\";s:8:\"includes\";a:1:{s:19:\"actions_permissions\";s:25:\"Actions permissions (VBO)\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-3.3\";s:14:\"existing_major\";s:1:\"3\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:27:\"Views Bulk Operations (VBO)\";s:4:\"link\";s:52:\"https://www.drupal.org/project/views_bulk_operations\";s:14:\"latest_version\";s:7:\"7.x-3.4\";s:8:\"releases\";a:1:{s:7:\"7.x-3.4\";a:14:{s:4:\"name\";s:29:\"views_bulk_operations 7.x-3.4\";s:7:\"version\";s:7:\"7.x-3.4\";s:3:\"tag\";s:7:\"7.x-3.4\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/views_bulk_operations/releases/7.x-3.4\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/views_bulk_operations-7.x-3.4.tar.gz\";s:4:\"date\";s:10:\"1487698683\";s:6:\"mdhash\";s:32:\"0009517dea9b41bccfdd6ded6881e21a\";s:8:\"filesize\";s:5:\"45529\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-3.4\";s:6:\"status\";i:4;}s:12:\"addressfield\";a:17:{s:4:\"name\";s:12:\"addressfield\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Address Field\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-1.0\";s:7:\"project\";s:12:\"addressfield\";s:9:\"datestamp\";s:10:\"1421426885\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1421426885\";s:8:\"includes\";a:1:{s:12:\"addressfield\";s:13:\"Address Field\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.0\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:13:\"Address Field\";s:4:\"link\";s:43:\"https://www.drupal.org/project/addressfield\";s:14:\"latest_version\";s:7:\"7.x-1.2\";s:8:\"releases\";a:1:{s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:20:\"addressfield 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/addressfield/releases/7.x-1.2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/addressfield-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1444253039\";s:6:\"mdhash\";s:32:\"2c9452731b1b8fffeba8f420c590cc57\";s:8:\"filesize\";s:5:\"77194\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-1.2\";s:6:\"status\";i:4;}s:10:\"admin_menu\";a:17:{s:4:\"name\";s:10:\"admin_menu\";s:4:\"info\";a:6:{s:4:\"name\";s:32:\"Administration Development tools\";s:7:\"package\";s:14:\"Administration\";s:7:\"version\";s:11:\"7.x-3.0-rc5\";s:7:\"project\";s:10:\"admin_menu\";s:9:\"datestamp\";s:10:\"1419029284\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1419029284\";s:8:\"includes\";a:3:{s:11:\"admin_devel\";s:32:\"Administration Development tools\";s:10:\"admin_menu\";s:19:\"Administration menu\";s:18:\"admin_menu_toolbar\";s:33:\"Administration menu Toolbar style\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:11:\"7.x-3.0-rc5\";s:14:\"existing_major\";s:1:\"3\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:19:\"Administration menu\";s:4:\"link\";s:41:\"https://www.drupal.org/project/admin_menu\";s:14:\"latest_version\";s:11:\"7.x-3.0-rc5\";s:8:\"releases\";a:1:{s:11:\"7.x-3.0-rc5\";a:15:{s:4:\"name\";s:22:\"admin_menu 7.x-3.0-rc5\";s:7:\"version\";s:11:\"7.x-3.0-rc5\";s:3:\"tag\";s:11:\"7.x-3.0-rc5\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_menu/releases/7.x-3.0-rc5\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_menu-7.x-3.0-rc5.tar.gz\";s:4:\"date\";s:10:\"1419029280\";s:6:\"mdhash\";s:32:\"4f1a0c14001c880bd7eb170318b91303\";s:8:\"filesize\";s:5:\"53401\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}}s:11:\"recommended\";s:11:\"7.x-3.0-rc5\";s:6:\"status\";i:5;}s:22:\"better_exposed_filters\";a:17:{s:4:\"name\";s:22:\"better_exposed_filters\";s:4:\"info\";a:6:{s:4:\"name\";s:22:\"Better Exposed Filters\";s:7:\"package\";s:5:\"Views\";s:7:\"version\";s:7:\"7.x-3.4\";s:7:\"project\";s:22:\"better_exposed_filters\";s:9:\"datestamp\";s:10:\"1485926287\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1485926287\";s:8:\"includes\";a:1:{s:22:\"better_exposed_filters\";s:22:\"Better Exposed Filters\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-3.4\";s:14:\"existing_major\";s:1:\"3\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:22:\"Better Exposed Filters\";s:4:\"link\";s:53:\"https://www.drupal.org/project/better_exposed_filters\";s:14:\"latest_version\";s:7:\"7.x-3.4\";s:8:\"releases\";a:1:{s:7:\"7.x-3.4\";a:14:{s:4:\"name\";s:30:\"better_exposed_filters 7.x-3.4\";s:7:\"version\";s:7:\"7.x-3.4\";s:3:\"tag\";s:7:\"7.x-3.4\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/better_exposed_filters/releases/7.x-3.4\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/better_exposed_filters-7.x-3.4.tar.gz\";s:4:\"date\";s:10:\"1485926283\";s:6:\"mdhash\";s:32:\"0a149a565aa4885faf6015c1ce6b929b\";s:8:\"filesize\";s:5:\"51110\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-3.4\";s:6:\"status\";i:5;}s:6:\"drupal\";a:17:{s:4:\"name\";s:6:\"drupal\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Block\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:16:\"_info_file_ctime\";i:1500361104;}s:9:\"datestamp\";s:10:\"1498069849\";s:8:\"includes\";a:31:{s:5:\"block\";s:5:\"Block\";s:5:\"color\";s:5:\"Color\";s:7:\"comment\";s:7:\"Comment\";s:10:\"contextual\";s:16:\"Contextual links\";s:9:\"dashboard\";s:9:\"Dashboard\";s:5:\"dblog\";s:16:\"Database logging\";s:5:\"field\";s:5:\"Field\";s:17:\"field_sql_storage\";s:17:\"Field SQL storage\";s:8:\"field_ui\";s:8:\"Field UI\";s:4:\"file\";s:4:\"File\";s:6:\"filter\";s:6:\"Filter\";s:4:\"help\";s:4:\"Help\";s:5:\"image\";s:5:\"Image\";s:4:\"list\";s:4:\"List\";s:6:\"locale\";s:6:\"Locale\";s:4:\"menu\";s:4:\"Menu\";s:4:\"node\";s:4:\"Node\";s:6:\"number\";s:6:\"Number\";s:7:\"options\";s:7:\"Options\";s:7:\"overlay\";s:7:\"Overlay\";s:4:\"path\";s:4:\"Path\";s:3:\"php\";s:10:\"PHP filter\";s:6:\"search\";s:6:\"Search\";s:8:\"shortcut\";s:8:\"Shortcut\";s:6:\"system\";s:6:\"System\";s:8:\"taxonomy\";s:8:\"Taxonomy\";s:4:\"text\";s:4:\"Text\";s:6:\"update\";s:14:\"Update manager\";s:4:\"user\";s:4:\"User\";s:6:\"bartik\";s:6:\"Bartik\";s:5:\"seven\";s:5:\"Seven\";}s:12:\"project_type\";s:4:\"core\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:4:\"7.56\";s:14:\"existing_major\";s:1:\"7\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:11:\"Drupal core\";s:4:\"link\";s:37:\"https://www.drupal.org/project/drupal\";s:14:\"latest_version\";s:4:\"7.56\";s:8:\"releases\";a:1:{s:4:\"7.56\";a:14:{s:4:\"name\";s:11:\"drupal 7.56\";s:7:\"version\";s:4:\"7.56\";s:3:\"tag\";s:4:\"7.56\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"56\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.56\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.56.tar.gz\";s:4:\"date\";s:10:\"1498069782\";s:6:\"mdhash\";s:32:\"5d198f40f0f1cbf9cdf1bf3de842e534\";s:8:\"filesize\";s:7:\"3277833\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:4:\"7.56\";s:6:\"status\";i:5;}s:11:\"block_class\";a:17:{s:4:\"name\";s:11:\"block_class\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Block Class\";s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:11:\"block_class\";s:9:\"datestamp\";s:10:\"1450415951\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1450415951\";s:8:\"includes\";a:1:{s:11:\"block_class\";s:11:\"Block Class\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.3\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:11:\"Block Class\";s:4:\"link\";s:42:\"https://www.drupal.org/project/block_class\";s:14:\"latest_version\";s:7:\"7.x-2.3\";s:8:\"releases\";a:1:{s:7:\"7.x-2.3\";a:14:{s:4:\"name\";s:19:\"block_class 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/block_class/releases/7.x-2.3\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/block_class-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1450415939\";s:6:\"mdhash\";s:32:\"286b7673faa2a067a9e96ee748331db9\";s:8:\"filesize\";s:5:\"12696\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-2.3\";s:6:\"status\";i:5;}s:6:\"chosen\";a:17:{s:4:\"name\";s:6:\"chosen\";s:4:\"info\";a:6:{s:4:\"name\";s:6:\"Chosen\";s:7:\"package\";s:14:\"User interface\";s:7:\"version\";s:13:\"7.x-2.0-beta4\";s:7:\"project\";s:6:\"chosen\";s:9:\"datestamp\";s:10:\"1394256505\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1394256505\";s:8:\"includes\";a:1:{s:6:\"chosen\";s:6:\"Chosen\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:13:\"7.x-2.0-beta4\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:6:\"Chosen\";s:4:\"link\";s:37:\"https://www.drupal.org/project/chosen\";s:14:\"latest_version\";s:7:\"7.x-2.1\";s:8:\"releases\";a:1:{s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:14:\"chosen 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/chosen/releases/7.x-2.1\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/chosen-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1490260383\";s:6:\"mdhash\";s:32:\"ca17f21e5ce6e1697d369301704e70ab\";s:8:\"filesize\";s:5:\"15428\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-2.1\";s:6:\"status\";i:4;}s:8:\"ckeditor\";a:17:{s:4:\"name\";s:8:\"ckeditor\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"CKEditor\";s:7:\"package\";s:14:\"User interface\";s:7:\"version\";s:8:\"7.x-1.16\";s:7:\"project\";s:8:\"ckeditor\";s:9:\"datestamp\";s:10:\"1413311935\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1413311935\";s:8:\"includes\";a:1:{s:8:\"ckeditor\";s:8:\"CKEditor\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:8:\"7.x-1.16\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:30:\"CKEditor - WYSIWYG HTML editor\";s:4:\"link\";s:39:\"https://www.drupal.org/project/ckeditor\";s:14:\"latest_version\";s:8:\"7.x-1.18\";s:8:\"releases\";a:1:{s:8:\"7.x-1.18\";a:14:{s:4:\"name\";s:17:\"ckeditor 7.x-1.18\";s:7:\"version\";s:8:\"7.x-1.18\";s:3:\"tag\";s:8:\"7.x-1.18\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"18\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.18\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.18.tar.gz\";s:4:\"date\";s:10:\"1498506242\";s:6:\"mdhash\";s:32:\"c85049f6a351e6e72b8890f01325eed2\";s:8:\"filesize\";s:6:\"198098\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}}s:11:\"recommended\";s:8:\"7.x-1.18\";s:6:\"status\";i:4;}s:10:\"cloud_zoom\";a:19:{s:4:\"name\";s:10:\"cloud_zoom\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"Cloud Zoom\";s:7:\"package\";s:10:\"Cloud Zoom\";s:7:\"version\";s:13:\"7.x-1.1+1-dev\";s:7:\"project\";s:10:\"cloud_zoom\";s:9:\"datestamp\";s:10:\"1380559092\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1380559092\";s:8:\"includes\";a:1:{s:10:\"cloud_zoom\";s:10:\"Cloud Zoom\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:13:\"7.x-1.1+1-dev\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:3:\"dev\";s:5:\"title\";s:10:\"Cloud Zoom\";s:4:\"link\";s:41:\"https://www.drupal.org/project/cloud_zoom\";s:14:\"latest_version\";s:7:\"7.x-1.1\";s:8:\"releases\";a:2:{s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:18:\"cloud_zoom 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/cloud_zoom/releases/7.x-1.1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/cloud_zoom-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1350401767\";s:6:\"mdhash\";s:32:\"ccc7a9024a8730a6b25a92bb2d2c0c8e\";s:8:\"filesize\";s:5:\"13186\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:22:\"cloud_zoom 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/cloud_zoom/releases/7.x-1.x-dev\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/cloud_zoom-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380559093\";s:6:\"mdhash\";s:32:\"54b8262a90a5f37b0536ddb8585d5578\";s:8:\"filesize\";s:5:\"13196\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}s:11:\"recommended\";s:7:\"7.x-1.1\";s:11:\"dev_version\";s:11:\"7.x-1.x-dev\";s:10:\"latest_dev\";s:11:\"7.x-1.x-dev\";s:6:\"status\";i:5;}s:8:\"commerce\";a:17:{s:4:\"name\";s:8:\"commerce\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Commerce\";s:7:\"package\";s:8:\"Commerce\";s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1459956613\";s:8:\"includes\";a:18:{s:8:\"commerce\";s:8:\"Commerce\";s:13:\"commerce_cart\";s:4:\"Cart\";s:17:\"commerce_checkout\";s:8:\"Checkout\";s:17:\"commerce_customer\";s:8:\"Customer\";s:20:\"commerce_customer_ui\";s:11:\"Customer UI\";s:18:\"commerce_line_item\";s:9:\"Line Item\";s:21:\"commerce_line_item_ui\";s:12:\"Line Item UI\";s:14:\"commerce_order\";s:5:\"Order\";s:17:\"commerce_order_ui\";s:8:\"Order UI\";s:16:\"commerce_payment\";s:7:\"Payment\";s:19:\"commerce_payment_ui\";s:10:\"Payment UI\";s:14:\"commerce_price\";s:5:\"Price\";s:16:\"commerce_product\";s:7:\"Product\";s:24:\"commerce_product_pricing\";s:15:\"Product Pricing\";s:27:\"commerce_product_pricing_ui\";s:18:\"Product Pricing UI\";s:26:\"commerce_product_reference\";s:17:\"Product Reference\";s:19:\"commerce_product_ui\";s:10:\"Product UI\";s:11:\"commerce_ui\";s:11:\"Commerce UI\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:8:\"7.x-1.13\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:15:\"Drupal Commerce\";s:4:\"link\";s:39:\"https://www.drupal.org/project/commerce\";s:14:\"latest_version\";s:8:\"7.x-1.13\";s:8:\"releases\";a:1:{s:8:\"7.x-1.13\";a:14:{s:4:\"name\";s:17:\"commerce 7.x-1.13\";s:7:\"version\";s:8:\"7.x-1.13\";s:3:\"tag\";s:8:\"7.x-1.13\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/commerce/releases/7.x-1.13\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/commerce-7.x-1.13.tar.gz\";s:4:\"date\";s:10:\"1459956568\";s:6:\"mdhash\";s:32:\"32f60a3f4e7e08d8979be3c8beda49e2\";s:8:\"filesize\";s:6:\"381834\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:8:\"7.x-1.13\";s:6:\"status\";i:5;}s:12:\"commerce_cop\";a:17:{s:4:\"name\";s:12:\"commerce_cop\";s:4:\"info\";a:6:{s:4:\"name\";s:32:\"Commerce Custom Offline Payments\";s:7:\"package\";s:18:\"Commerce (contrib)\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:7:\"project\";s:12:\"commerce_cop\";s:9:\"datestamp\";s:10:\"1409840629\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1409840629\";s:8:\"includes\";a:3:{s:12:\"commerce_cop\";s:32:\"Commerce Custom Offline Payments\";s:26:\"commerce_cop_bank_transfer\";s:21:\"Bank Transfer payment\";s:16:\"commerce_cop_cod\";s:24:\"Cash on Delivery payment\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:13:\"7.x-1.0-beta2\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:32:\"Commerce Custom Offline Payments\";s:4:\"link\";s:43:\"https://www.drupal.org/project/commerce_cop\";s:14:\"latest_version\";s:13:\"7.x-1.0-beta2\";s:8:\"releases\";a:1:{s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:26:\"commerce_cop 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/commerce_cop/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/commerce_cop-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1409840628\";s:6:\"mdhash\";s:32:\"41dda03ad789f455b1423865ec9a055d\";s:8:\"filesize\";s:5:\"14778\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}}s:11:\"recommended\";s:13:\"7.x-1.0-beta2\";s:6:\"status\";i:5;}s:25:\"commerce_fancy_attributes\";a:17:{s:4:\"name\";s:25:\"commerce_fancy_attributes\";s:4:\"info\";a:6:{s:4:\"name\";s:25:\"Commerce fancy attributes\";s:7:\"package\";s:18:\"Commerce (contrib)\";s:7:\"version\";s:7:\"7.x-1.0\";s:7:\"project\";s:25:\"commerce_fancy_attributes\";s:9:\"datestamp\";s:10:\"1343752308\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1343752308\";s:8:\"includes\";a:1:{s:25:\"commerce_fancy_attributes\";s:25:\"Commerce fancy attributes\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.0\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:25:\"Commerce Fancy Attributes\";s:4:\"link\";s:56:\"https://www.drupal.org/project/commerce_fancy_attributes\";s:14:\"latest_version\";s:7:\"7.x-1.0\";s:8:\"releases\";a:1:{s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:33:\"commerce_fancy_attributes 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:73:\"https://www.drupal.org/project/commerce_fancy_attributes/releases/7.x-1.0\";s:13:\"download_link\";s:78:\"https://ftp.drupal.org/files/projects/commerce_fancy_attributes-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1343752308\";s:6:\"mdhash\";s:32:\"80568b9ebde2cda08014713cb8d3fc48\";s:8:\"filesize\";s:5:\"10438\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}}s:11:\"recommended\";s:7:\"7.x-1.0\";s:6:\"status\";i:5;}s:18:\"commerce_flat_rate\";a:17:{s:4:\"name\";s:18:\"commerce_flat_rate\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"Flat Rate\";s:7:\"package\";s:19:\"Commerce (shipping)\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:7:\"project\";s:18:\"commerce_flat_rate\";s:9:\"datestamp\";s:10:\"1353122757\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1353122757\";s:8:\"includes\";a:1:{s:18:\"commerce_flat_rate\";s:9:\"Flat Rate\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:13:\"7.x-1.0-beta2\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:18:\"Commerce Flat Rate\";s:4:\"link\";s:49:\"https://www.drupal.org/project/commerce_flat_rate\";s:14:\"latest_version\";s:13:\"7.x-1.0-beta2\";s:8:\"releases\";a:1:{s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:32:\"commerce_flat_rate 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/commerce_flat_rate/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/commerce_flat_rate-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1353122757\";s:6:\"mdhash\";s:32:\"965294aaa0822400ddd41322f9b43cc5\";s:8:\"filesize\";s:5:\"12663\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}}s:11:\"recommended\";s:13:\"7.x-1.0-beta2\";s:6:\"status\";i:5;}s:20:\"commerce_marketplace\";a:17:{s:4:\"name\";s:20:\"commerce_marketplace\";s:4:\"info\";a:6:{s:4:\"name\";s:20:\"Commerce Marketplace\";s:7:\"package\";s:20:\"Commerce Marketplace\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:7:\"project\";s:20:\"commerce_marketplace\";s:9:\"datestamp\";s:10:\"1408538840\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1408538840\";s:8:\"includes\";a:6:{s:20:\"commerce_marketplace\";s:20:\"Commerce Marketplace\";s:26:\"commerce_marketplace_funds\";s:26:\"Commerce Marketplace Funds\";s:35:\"commerce_marketplace_funds_withdraw\";s:45:\"Commerce Marketplace Funds Withdrawal methods\";s:26:\"commerce_marketplace_order\";s:26:\"Commerce Marketplace Order\";s:14:\"commerce_store\";s:14:\"Commerce Store\";s:21:\"commerce_store_access\";s:26:\"Commerce Store Permissions\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:13:\"7.x-1.0-beta3\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:20:\"Commerce-Marketplace\";s:4:\"link\";s:51:\"https://www.drupal.org/project/commerce_marketplace\";s:14:\"latest_version\";s:13:\"7.x-1.0-beta3\";s:8:\"releases\";a:1:{s:13:\"7.x-1.0-beta3\";a:15:{s:4:\"name\";s:34:\"commerce_marketplace 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:74:\"https://www.drupal.org/project/commerce_marketplace/releases/7.x-1.0-beta3\";s:13:\"download_link\";s:79:\"https://ftp.drupal.org/files/projects/commerce_marketplace-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1408538028\";s:6:\"mdhash\";s:32:\"8a21fbe2566d2e5028830fba6947e392\";s:8:\"filesize\";s:5:\"56122\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}}s:11:\"recommended\";s:13:\"7.x-1.0-beta3\";s:6:\"status\";i:5;}s:15:\"commerce_paypal\";a:17:{s:4:\"name\";s:15:\"commerce_paypal\";s:4:\"info\";a:6:{s:4:\"name\";s:6:\"PayPal\";s:7:\"package\";s:17:\"Commerce (PayPal)\";s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:15:\"commerce_paypal\";s:9:\"datestamp\";s:10:\"1389740908\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1389740908\";s:8:\"includes\";a:2:{s:15:\"commerce_paypal\";s:6:\"PayPal\";s:19:\"commerce_paypal_wps\";s:10:\"PayPal WPS\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.3\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:15:\"Commerce PayPal\";s:4:\"link\";s:46:\"https://www.drupal.org/project/commerce_paypal\";s:14:\"latest_version\";s:7:\"7.x-2.4\";s:8:\"releases\";a:1:{s:7:\"7.x-2.4\";a:14:{s:4:\"name\";s:23:\"commerce_paypal 7.x-2.4\";s:7:\"version\";s:7:\"7.x-2.4\";s:3:\"tag\";s:7:\"7.x-2.4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/commerce_paypal/releases/7.x-2.4\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/commerce_paypal-7.x-2.4.tar.gz\";s:4:\"date\";s:10:\"1497908942\";s:6:\"mdhash\";s:32:\"4d7129199d1d7efc162ae1eef7003c72\";s:8:\"filesize\";s:5:\"71951\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-2.4\";s:6:\"status\";i:4;}s:19:\"commerce_search_api\";a:17:{s:4:\"name\";s:19:\"commerce_search_api\";s:4:\"info\";a:6:{s:4:\"name\";s:19:\"Commerce Search API\";s:7:\"package\";s:18:\"Commerce (contrib)\";s:7:\"version\";s:7:\"7.x-1.4\";s:7:\"project\";s:19:\"commerce_search_api\";s:9:\"datestamp\";s:10:\"1436974444\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1436974444\";s:8:\"includes\";a:1:{s:19:\"commerce_search_api\";s:19:\"Commerce Search API\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.4\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:19:\"Commerce Search API\";s:4:\"link\";s:50:\"https://www.drupal.org/project/commerce_search_api\";s:14:\"latest_version\";s:7:\"7.x-1.6\";s:8:\"releases\";a:1:{s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:27:\"commerce_search_api 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/commerce_search_api/releases/7.x-1.6\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/commerce_search_api-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1468517339\";s:6:\"mdhash\";s:32:\"12a8be31646b2ab9cf1aba4551952570\";s:8:\"filesize\";s:5:\"14605\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-1.6\";s:6:\"status\";i:4;}s:17:\"commerce_shipping\";a:17:{s:4:\"name\";s:17:\"commerce_shipping\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Shipping\";s:7:\"package\";s:19:\"Commerce (shipping)\";s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:17:\"commerce_shipping\";s:9:\"datestamp\";s:10:\"1428479882\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1428479882\";s:8:\"includes\";a:2:{s:17:\"commerce_shipping\";s:8:\"Shipping\";s:20:\"commerce_shipping_ui\";s:11:\"Shipping UI\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.2\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:17:\"Commerce Shipping\";s:4:\"link\";s:48:\"https://www.drupal.org/project/commerce_shipping\";s:14:\"latest_version\";s:7:\"7.x-2.2\";s:8:\"releases\";a:1:{s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:25:\"commerce_shipping 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/commerce_shipping/releases/7.x-2.2\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/commerce_shipping-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1428479881\";s:6:\"mdhash\";s:32:\"3593bd8d427417887c5ae5f1e0c5946f\";s:8:\"filesize\";s:5:\"32573\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-2.2\";s:6:\"status\";i:5;}s:14:\"commerce_stock\";a:17:{s:4:\"name\";s:14:\"commerce_stock\";s:4:\"info\";a:6:{s:4:\"name\";s:21:\"Commerce Simple Stock\";s:7:\"package\";s:16:\"Commerce (stock)\";s:7:\"version\";s:7:\"7.x-2.1\";s:7:\"project\";s:14:\"commerce_stock\";s:9:\"datestamp\";s:10:\"1418323685\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1418323685\";s:8:\"includes\";a:4:{s:11:\"commerce_ss\";s:21:\"Commerce Simple Stock\";s:12:\"commerce_ssr\";s:27:\"Commerce Simple Stock Rules\";s:14:\"commerce_stock\";s:18:\"Commerce Stock API\";s:17:\"commerce_stock_ui\";s:17:\"Commerce stock UI\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.1\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:14:\"Commerce Stock\";s:4:\"link\";s:45:\"https://www.drupal.org/project/commerce_stock\";s:14:\"latest_version\";s:7:\"7.x-2.3\";s:8:\"releases\";a:1:{s:7:\"7.x-2.3\";a:14:{s:4:\"name\";s:22:\"commerce_stock 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/commerce_stock/releases/7.x-2.3\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/commerce_stock-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1459244641\";s:6:\"mdhash\";s:32:\"e386502f6fbdd30724375ef5348f2c6b\";s:8:\"filesize\";s:5:\"25781\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-2.3\";s:6:\"status\";i:4;}s:7:\"context\";a:17:{s:4:\"name\";s:7:\"context\";s:4:\"info\";a:6:{s:4:\"name\";s:7:\"Context\";s:7:\"package\";s:7:\"Context\";s:7:\"version\";s:7:\"7.x-3.6\";s:7:\"project\";s:7:\"context\";s:9:\"datestamp\";s:10:\"1420573188\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1420573188\";s:8:\"includes\";a:2:{s:7:\"context\";s:7:\"Context\";s:10:\"context_ui\";s:10:\"Context UI\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-3.6\";s:14:\"existing_major\";s:1:\"3\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:7:\"Context\";s:4:\"link\";s:38:\"https://www.drupal.org/project/context\";s:14:\"latest_version\";s:7:\"7.x-3.7\";s:8:\"releases\";a:1:{s:7:\"7.x-3.7\";a:14:{s:4:\"name\";s:15:\"context 7.x-3.7\";s:7:\"version\";s:7:\"7.x-3.7\";s:3:\"tag\";s:7:\"7.x-3.7\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/context/releases/7.x-3.7\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/context-7.x-3.7.tar.gz\";s:4:\"date\";s:10:\"1463605439\";s:6:\"mdhash\";s:32:\"7486753eef5a1496a3aa79ce7f168124\";s:8:\"filesize\";s:5:\"74779\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-3.7\";s:6:\"status\";i:4;}s:9:\"countries\";a:17:{s:4:\"name\";s:9:\"countries\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"Countries\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:9:\"countries\";s:9:\"datestamp\";s:10:\"1409450929\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1409450929\";s:8:\"includes\";a:1:{s:9:\"countries\";s:9:\"Countries\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.3\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:9:\"Countries\";s:4:\"link\";s:40:\"https://www.drupal.org/project/countries\";s:14:\"latest_version\";s:7:\"7.x-2.3\";s:8:\"releases\";a:1:{s:7:\"7.x-2.3\";a:14:{s:4:\"name\";s:17:\"countries 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/countries/releases/7.x-2.3\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/countries-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1409450928\";s:6:\"mdhash\";s:32:\"11fa9b845c3e4e63cb46d6398f54b3cb\";s:8:\"filesize\";s:5:\"56688\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-2.3\";s:6:\"status\";i:5;}s:6:\"ctools\";a:17:{s:4:\"name\";s:6:\"ctools\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Chaos tools\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1440020680\";s:8:\"includes\";a:1:{s:6:\"ctools\";s:11:\"Chaos tools\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.9\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:25:\"Chaos tool suite (ctools)\";s:4:\"link\";s:37:\"https://www.drupal.org/project/ctools\";s:14:\"latest_version\";s:8:\"7.x-1.12\";s:8:\"releases\";a:1:{s:8:\"7.x-1.12\";a:14:{s:4:\"name\";s:15:\"ctools 7.x-1.12\";s:7:\"version\";s:8:\"7.x-1.12\";s:3:\"tag\";s:8:\"7.x-1.12\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/ctools/releases/7.x-1.12\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.12.tar.gz\";s:4:\"date\";s:10:\"1479787142\";s:6:\"mdhash\";s:32:\"daae0be22830e34c4d952f91557ae5a5\";s:8:\"filesize\";s:6:\"433707\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:8:\"7.x-1.12\";s:6:\"status\";i:4;}s:8:\"facetapi\";a:17:{s:4:\"name\";s:8:\"facetapi\";s:4:\"info\";a:6:{s:4:\"name\";s:21:\"Current Search Blocks\";s:7:\"package\";s:14:\"Search Toolkit\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:8:\"facetapi\";s:9:\"datestamp\";s:10:\"1405685332\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1405685332\";s:8:\"includes\";a:2:{s:14:\"current_search\";s:21:\"Current Search Blocks\";s:8:\"facetapi\";s:9:\"Facet API\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.5\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:9:\"Facet API\";s:4:\"link\";s:39:\"https://www.drupal.org/project/facetapi\";s:14:\"latest_version\";s:7:\"7.x-1.5\";s:8:\"releases\";a:1:{s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:16:\"facetapi 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/facetapi/releases/7.x-1.5\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/facetapi-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1405685327\";s:6:\"mdhash\";s:32:\"dca53ec6927d7731abddcfa1cd1c5a71\";s:8:\"filesize\";s:5:\"90649\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-1.5\";s:6:\"status\";i:5;}s:18:\"custom_breadcrumbs\";a:17:{s:4:\"name\";s:18:\"custom_breadcrumbs\";s:4:\"info\";a:6:{s:4:\"name\";s:18:\"Custom breadcrumbs\";s:7:\"package\";s:18:\"Custom breadcrumbs\";s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:7:\"project\";s:18:\"custom_breadcrumbs\";s:9:\"datestamp\";s:10:\"1410287363\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1410287363\";s:8:\"includes\";a:5:{s:18:\"custom_breadcrumbs\";s:18:\"Custom breadcrumbs\";s:30:\"custom_breadcrumbs_identifiers\";s:30:\"Custom breadcrumbs identifiers\";s:24:\"custom_breadcrumbs_paths\";s:28:\"Custom breadcrumbs for paths\";s:27:\"custom_breadcrumbs_taxonomy\";s:31:\"Custom breadcrumbs for taxonomy\";s:24:\"custom_breadcrumbs_views\";s:28:\"Custom breadcrumbs for views\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:13:\"7.x-2.0-beta1\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:18:\"Custom Breadcrumbs\";s:4:\"link\";s:49:\"https://www.drupal.org/project/custom_breadcrumbs\";s:14:\"latest_version\";s:13:\"7.x-2.0-beta1\";s:8:\"releases\";a:1:{s:13:\"7.x-2.0-beta1\";a:15:{s:4:\"name\";s:32:\"custom_breadcrumbs 7.x-2.0-beta1\";s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:3:\"tag\";s:13:\"7.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/custom_breadcrumbs/releases/7.x-2.0-beta1\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/custom_breadcrumbs-7.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1410287331\";s:6:\"mdhash\";s:32:\"422763aa0261af320ad75d30b9284ca1\";s:8:\"filesize\";s:5:\"56939\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}}s:11:\"recommended\";s:13:\"7.x-2.0-beta1\";s:6:\"status\";i:5;}s:5:\"devel\";a:17:{s:4:\"name\";s:5:\"devel\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Devel\";s:7:\"package\";s:11:\"Development\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:5:\"devel\";s:9:\"datestamp\";s:10:\"1398963366\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1398963366\";s:8:\"includes\";a:1:{s:5:\"devel\";s:5:\"Devel\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.5\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:5:\"Devel\";s:4:\"link\";s:36:\"https://www.drupal.org/project/devel\";s:14:\"latest_version\";s:7:\"7.x-1.5\";s:8:\"releases\";a:1:{s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:13:\"devel 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/devel/releases/7.x-1.5\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/devel-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1398963228\";s:6:\"mdhash\";s:32:\"f06c912eb4edbd48fbcc2867516726a3\";s:8:\"filesize\";s:6:\"193378\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-1.5\";s:6:\"status\";i:5;}s:3:\"eck\";a:17:{s:4:\"name\";s:3:\"eck\";s:4:\"info\";a:6:{s:4:\"name\";s:23:\"Entity Construction Kit\";s:7:\"package\";s:3:\"ECK\";s:7:\"version\";s:11:\"7.x-2.0-rc7\";s:7:\"project\";s:3:\"eck\";s:9:\"datestamp\";s:10:\"1422241382\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1422241382\";s:8:\"includes\";a:1:{s:3:\"eck\";s:23:\"Entity Construction Kit\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:11:\"7.x-2.0-rc7\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:29:\"Entity Construction Kit (ECK)\";s:4:\"link\";s:34:\"https://www.drupal.org/project/eck\";s:14:\"latest_version\";s:11:\"7.x-2.0-rc9\";s:8:\"releases\";a:1:{s:11:\"7.x-2.0-rc9\";a:15:{s:4:\"name\";s:15:\"eck 7.x-2.0-rc9\";s:7:\"version\";s:11:\"7.x-2.0-rc9\";s:3:\"tag\";s:11:\"7.x-2.0-rc9\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/eck/releases/7.x-2.0-rc9\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/eck-7.x-2.0-rc9.tar.gz\";s:4:\"date\";s:10:\"1483524242\";s:6:\"mdhash\";s:32:\"2d38ca6229404d870f545f9d6222f539\";s:8:\"filesize\";s:5:\"53044\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}}s:11:\"recommended\";s:11:\"7.x-2.0-rc9\";s:6:\"status\";i:4;}s:6:\"entity\";a:17:{s:4:\"name\";s:6:\"entity\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"Entity API\";s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";s:10:\"1424876582\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1424876582\";s:8:\"includes\";a:2:{s:6:\"entity\";s:10:\"Entity API\";s:12:\"entity_token\";s:13:\"Entity tokens\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.6\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:10:\"Entity API\";s:4:\"link\";s:37:\"https://www.drupal.org/project/entity\";s:14:\"latest_version\";s:7:\"7.x-1.8\";s:8:\"releases\";a:1:{s:7:\"7.x-1.8\";a:14:{s:4:\"name\";s:14:\"entity 7.x-1.8\";s:7:\"version\";s:7:\"7.x-1.8\";s:3:\"tag\";s:7:\"7.x-1.8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/entity/releases/7.x-1.8\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/entity-7.x-1.8.tar.gz\";s:4:\"date\";s:10:\"1474545839\";s:6:\"mdhash\";s:32:\"3926d48c86387c3d1d5777538903a752\";s:8:\"filesize\";s:6:\"123957\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-1.8\";s:6:\"status\";i:4;}s:15:\"entityreference\";a:17:{s:4:\"name\";s:15:\"entityreference\";s:4:\"info\";a:6:{s:4:\"name\";s:16:\"Entity Reference\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:15:\"entityreference\";s:9:\"datestamp\";s:10:\"1384973110\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1384973110\";s:8:\"includes\";a:1:{s:15:\"entityreference\";s:16:\"Entity Reference\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.1\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:16:\"Entity reference\";s:4:\"link\";s:46:\"https://www.drupal.org/project/entityreference\";s:14:\"latest_version\";s:7:\"7.x-1.4\";s:8:\"releases\";a:1:{s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:23:\"entityreference 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/entityreference/releases/7.x-1.4\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1495557183\";s:6:\"mdhash\";s:32:\"ce8bde18b2b0269f218a1e2dc17579ee\";s:8:\"filesize\";s:5:\"43230\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-1.4\";s:6:\"status\";i:4;}s:18:\"exclude_node_title\";a:17:{s:4:\"name\";s:18:\"exclude_node_title\";s:4:\"info\";a:6:{s:4:\"name\";s:18:\"Exclude node title\";s:7:\"package\";s:5:\"Other\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:18:\"exclude_node_title\";s:9:\"datestamp\";s:10:\"1435338184\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1435338184\";s:8:\"includes\";a:1:{s:18:\"exclude_node_title\";s:18:\"Exclude node title\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.9\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:18:\"Exclude Node Title\";s:4:\"link\";s:49:\"https://www.drupal.org/project/exclude_node_title\";s:14:\"latest_version\";s:7:\"7.x-1.9\";s:8:\"releases\";a:1:{s:7:\"7.x-1.9\";a:14:{s:4:\"name\";s:26:\"exclude_node_title 7.x-1.9\";s:7:\"version\";s:7:\"7.x-1.9\";s:3:\"tag\";s:7:\"7.x-1.9\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/exclude_node_title/releases/7.x-1.9\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/exclude_node_title-7.x-1.9.tar.gz\";s:4:\"date\";s:10:\"1435338180\";s:6:\"mdhash\";s:32:\"341f2a3ff8473cdd37a9e8c689e58524\";s:8:\"filesize\";s:5:\"12171\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-1.9\";s:6:\"status\";i:5;}s:8:\"features\";a:17:{s:4:\"name\";s:8:\"features\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Features\";s:7:\"package\";s:8:\"Features\";s:7:\"version\";s:8:\"7.x-2.10\";s:7:\"project\";s:8:\"features\";s:9:\"datestamp\";s:10:\"1461011641\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1461011641\";s:8:\"includes\";a:1:{s:8:\"features\";s:8:\"Features\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:8:\"7.x-2.10\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:8:\"Features\";s:4:\"link\";s:39:\"https://www.drupal.org/project/features\";s:14:\"latest_version\";s:8:\"7.x-2.10\";s:8:\"releases\";a:1:{s:8:\"7.x-2.10\";a:14:{s:4:\"name\";s:17:\"features 7.x-2.10\";s:7:\"version\";s:8:\"7.x-2.10\";s:3:\"tag\";s:8:\"7.x-2.10\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/features/releases/7.x-2.10\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/features-7.x-2.10.tar.gz\";s:4:\"date\";s:10:\"1461011639\";s:6:\"mdhash\";s:32:\"5641e5545020932570aed464fbaebf6a\";s:8:\"filesize\";s:5:\"97102\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:8:\"7.x-2.10\";s:6:\"status\";i:5;}s:16:\"field_collection\";a:17:{s:4:\"name\";s:16:\"field_collection\";s:4:\"info\";a:6:{s:4:\"name\";s:16:\"Field collection\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:13:\"7.x-1.0-beta8\";s:7:\"project\";s:16:\"field_collection\";s:9:\"datestamp\";s:10:\"1415122384\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1415122384\";s:8:\"includes\";a:1:{s:16:\"field_collection\";s:16:\"Field collection\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:13:\"7.x-1.0-beta8\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:16:\"Field collection\";s:4:\"link\";s:47:\"https://www.drupal.org/project/field_collection\";s:14:\"latest_version\";s:14:\"7.x-1.0-beta12\";s:8:\"releases\";a:1:{s:14:\"7.x-1.0-beta12\";a:15:{s:4:\"name\";s:31:\"field_collection 7.x-1.0-beta12\";s:7:\"version\";s:14:\"7.x-1.0-beta12\";s:3:\"tag\";s:14:\"7.x-1.0-beta12\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/field_collection/releases/7.x-1.0-beta12\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.0-beta12.tar.gz\";s:4:\"date\";s:10:\"1479402842\";s:6:\"mdhash\";s:32:\"e966ba0c2ad40b9b044ae8bdf993f5ed\";s:8:\"filesize\";s:5:\"51018\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}}s:11:\"recommended\";s:14:\"7.x-1.0-beta12\";s:6:\"status\";i:4;}s:22:\"field_collection_table\";a:17:{s:4:\"name\";s:22:\"field_collection_table\";s:4:\"info\";a:6:{s:4:\"name\";s:22:\"Field Collection Table\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:7:\"project\";s:22:\"field_collection_table\";s:9:\"datestamp\";s:10:\"1426689182\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1426689182\";s:8:\"includes\";a:1:{s:22:\"field_collection_table\";s:22:\"Field Collection Table\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:13:\"7.x-1.0-beta2\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:22:\"Field Collection Table\";s:4:\"link\";s:53:\"https://www.drupal.org/project/field_collection_table\";s:14:\"latest_version\";s:13:\"7.x-1.0-beta5\";s:8:\"releases\";a:1:{s:13:\"7.x-1.0-beta5\";a:15:{s:4:\"name\";s:36:\"field_collection_table 7.x-1.0-beta5\";s:7:\"version\";s:13:\"7.x-1.0-beta5\";s:3:\"tag\";s:13:\"7.x-1.0-beta5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:76:\"https://www.drupal.org/project/field_collection_table/releases/7.x-1.0-beta5\";s:13:\"download_link\";s:81:\"https://ftp.drupal.org/files/projects/field_collection_table-7.x-1.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1487676484\";s:6:\"mdhash\";s:32:\"ced1140ecd52939839e89bb664f33c68\";s:8:\"filesize\";s:5:\"12501\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}}s:11:\"recommended\";s:13:\"7.x-1.0-beta5\";s:6:\"status\";i:4;}s:21:\"field_formatter_class\";a:17:{s:4:\"name\";s:21:\"field_formatter_class\";s:4:\"info\";a:6:{s:4:\"name\";s:21:\"Field Formatter Class\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:21:\"field_formatter_class\";s:9:\"datestamp\";s:10:\"1361374877\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1361374877\";s:8:\"includes\";a:1:{s:21:\"field_formatter_class\";s:21:\"Field Formatter Class\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.1\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:21:\"Field Formatter Class\";s:4:\"link\";s:52:\"https://www.drupal.org/project/field_formatter_class\";s:14:\"latest_version\";s:7:\"7.x-1.1\";s:8:\"releases\";a:1:{s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:29:\"field_formatter_class 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/field_formatter_class/releases/7.x-1.1\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/field_formatter_class-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1361374878\";s:6:\"mdhash\";s:32:\"fcddd9d46e482811643a4340ccda7f13\";s:8:\"filesize\";s:4:\"8470\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-1.1\";s:6:\"status\";i:5;}s:24:\"field_formatter_settings\";a:17:{s:4:\"name\";s:24:\"field_formatter_settings\";s:4:\"info\";a:6:{s:4:\"name\";s:28:\"Field formatter settings API\";s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:24:\"field_formatter_settings\";s:9:\"datestamp\";s:10:\"1378741903\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1378741903\";s:8:\"includes\";a:1:{s:24:\"field_formatter_settings\";s:28:\"Field formatter settings API\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.1\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:24:\"Field formatter settings\";s:4:\"link\";s:55:\"https://www.drupal.org/project/field_formatter_settings\";s:14:\"latest_version\";s:7:\"7.x-1.1\";s:8:\"releases\";a:1:{s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:32:\"field_formatter_settings 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/field_formatter_settings/releases/7.x-1.1\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/field_formatter_settings-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1378741904\";s:6:\"mdhash\";s:32:\"d7bc7a84011a904f945b4fc54ff6eec0\";s:8:\"filesize\";s:4:\"9545\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-1.1\";s:6:\"status\";i:5;}s:11:\"field_group\";a:17:{s:4:\"name\";s:11:\"field_group\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Field Group\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:11:\"field_group\";s:9:\"datestamp\";s:10:\"1452033709\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1452033709\";s:8:\"includes\";a:1:{s:11:\"field_group\";s:11:\"Field Group\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.5\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:11:\"Field Group\";s:4:\"link\";s:42:\"https://www.drupal.org/project/field_group\";s:14:\"latest_version\";s:7:\"7.x-1.5\";s:8:\"releases\";a:1:{s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:19:\"field_group 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/field_group/releases/7.x-1.5\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/field_group-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1452033539\";s:6:\"mdhash\";s:32:\"8d91e0f3cc8106deefe038d5fc07d3e6\";s:8:\"filesize\";s:5:\"51465\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-1.5\";s:6:\"status\";i:5;}s:15:\"field_slideshow\";a:18:{s:4:\"name\";s:15:\"field_slideshow\";s:4:\"info\";a:6:{s:4:\"name\";s:15:\"Field Slideshow\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:8:\"7.x-1.82\";s:7:\"project\";s:15:\"field_slideshow\";s:9:\"datestamp\";s:10:\"1363270823\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1363270823\";s:8:\"includes\";a:1:{s:15:\"field_slideshow\";s:15:\"Field Slideshow\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:8:\"7.x-1.82\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:15:\"Field Slideshow\";s:4:\"link\";s:46:\"https://www.drupal.org/project/field_slideshow\";s:4:\"also\";a:1:{i:2;s:13:\"7.x-2.0-beta1\";}s:8:\"releases\";a:2:{s:13:\"7.x-2.0-beta1\";a:15:{s:4:\"name\";s:29:\"field_slideshow 7.x-2.0-beta1\";s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:3:\"tag\";s:13:\"7.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/field_slideshow/releases/7.x-2.0-beta1\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/field_slideshow-7.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1427029981\";s:6:\"mdhash\";s:32:\"f758c524b1b447f74385c7fd24f30234\";s:8:\"filesize\";s:5:\"20135\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:8:\"7.x-1.82\";a:14:{s:4:\"name\";s:24:\"field_slideshow 7.x-1.82\";s:7:\"version\";s:8:\"7.x-1.82\";s:3:\"tag\";s:8:\"7.x-1.82\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"82\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/field_slideshow/releases/7.x-1.82\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/field_slideshow-7.x-1.82.tar.gz\";s:4:\"date\";s:10:\"1363270823\";s:6:\"mdhash\";s:32:\"9f586cf88fa62ead440bd8ad6ec48eaa\";s:8:\"filesize\";s:5:\"19377\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:14:\"latest_version\";s:8:\"7.x-1.82\";s:11:\"recommended\";s:8:\"7.x-1.82\";s:6:\"status\";i:5;}s:8:\"fivestar\";a:17:{s:4:\"name\";s:8:\"fivestar\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Fivestar\";s:7:\"package\";s:6:\"Voting\";s:7:\"version\";s:7:\"7.x-2.1\";s:7:\"project\";s:8:\"fivestar\";s:9:\"datestamp\";s:10:\"1395087839\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1395087839\";s:8:\"includes\";a:1:{s:8:\"fivestar\";s:8:\"Fivestar\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.1\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:8:\"Fivestar\";s:4:\"link\";s:39:\"https://www.drupal.org/project/fivestar\";s:14:\"latest_version\";s:7:\"7.x-2.2\";s:8:\"releases\";a:1:{s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:16:\"fivestar 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/fivestar/releases/7.x-2.2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/fivestar-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1461406441\";s:6:\"mdhash\";s:32:\"ed5cb540db0944a47d7f09657b39d7e4\";s:8:\"filesize\";s:6:\"226248\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-2.2\";s:6:\"status\";i:4;}s:10:\"flexslider\";a:17:{s:4:\"name\";s:10:\"flexslider\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"FlexSlider\";s:7:\"package\";s:10:\"FlexSlider\";s:7:\"version\";s:11:\"7.x-2.0-rc1\";s:7:\"project\";s:10:\"flexslider\";s:9:\"datestamp\";s:10:\"1438285141\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1438285141\";s:8:\"includes\";a:2:{s:10:\"flexslider\";s:10:\"FlexSlider\";s:17:\"flexslider_fields\";s:17:\"FlexSlider Fields\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:11:\"7.x-2.0-rc1\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:11:\"Flex Slider\";s:4:\"link\";s:41:\"https://www.drupal.org/project/flexslider\";s:14:\"latest_version\";s:11:\"7.x-2.0-rc2\";s:8:\"releases\";a:1:{s:11:\"7.x-2.0-rc2\";a:15:{s:4:\"name\";s:22:\"flexslider 7.x-2.0-rc2\";s:7:\"version\";s:11:\"7.x-2.0-rc2\";s:3:\"tag\";s:11:\"7.x-2.0-rc2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/flexslider/releases/7.x-2.0-rc2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/flexslider-7.x-2.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1487028483\";s:6:\"mdhash\";s:32:\"6bbfff91fc66bef36e8ef42323a33a59\";s:8:\"filesize\";s:7:\"3976547\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}}s:11:\"recommended\";s:11:\"7.x-2.0-rc2\";s:6:\"status\";i:4;}s:4:\"icon\";a:17:{s:4:\"name\";s:4:\"icon\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Icon API\";s:7:\"package\";s:8:\"Icon API\";s:7:\"version\";s:13:\"7.x-1.0-beta6\";s:7:\"project\";s:4:\"icon\";s:9:\"datestamp\";s:10:\"1438832040\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1438832040\";s:8:\"includes\";a:2:{s:4:\"icon\";s:8:\"Icon API\";s:10:\"icon_field\";s:15:\"Icon API: Field\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:13:\"7.x-1.0-beta6\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:8:\"Icon API\";s:4:\"link\";s:35:\"https://www.drupal.org/project/icon\";s:14:\"latest_version\";s:7:\"7.x-1.0\";s:8:\"releases\";a:1:{s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:12:\"icon 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/icon/releases/7.x-1.0\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/icon-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1490035383\";s:6:\"mdhash\";s:32:\"2bbcce141deca20d1531c9da49d78005\";s:8:\"filesize\";s:5:\"98998\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}}s:11:\"recommended\";s:7:\"7.x-1.0\";s:6:\"status\";i:4;}s:20:\"image_link_formatter\";a:17:{s:4:\"name\";s:20:\"image_link_formatter\";s:4:\"info\";a:6:{s:4:\"name\";s:20:\"Image Link Formatter\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-1.0\";s:7:\"project\";s:20:\"image_link_formatter\";s:9:\"datestamp\";s:10:\"1355914053\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1355914053\";s:8:\"includes\";a:1:{s:20:\"image_link_formatter\";s:20:\"Image Link Formatter\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.0\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:20:\"Image Link Formatter\";s:4:\"link\";s:51:\"https://www.drupal.org/project/image_link_formatter\";s:14:\"latest_version\";s:7:\"7.x-1.1\";s:8:\"releases\";a:1:{s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:28:\"image_link_formatter 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/image_link_formatter/releases/7.x-1.1\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/image_link_formatter-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1464230040\";s:6:\"mdhash\";s:32:\"a6f43aeb9d1e55195a5962677b3c47ed\";s:8:\"filesize\";s:5:\"10523\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-1.1\";s:6:\"status\";i:4;}s:4:\"imce\";a:17:{s:4:\"name\";s:4:\"imce\";s:4:\"info\";a:6:{s:4:\"name\";s:4:\"IMCE\";s:7:\"package\";s:5:\"Media\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:4:\"imce\";s:9:\"datestamp\";s:10:\"1400275428\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1400275428\";s:8:\"includes\";a:1:{s:4:\"imce\";s:4:\"IMCE\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.9\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:4:\"IMCE\";s:4:\"link\";s:35:\"https://www.drupal.org/project/imce\";s:14:\"latest_version\";s:8:\"7.x-1.11\";s:8:\"releases\";a:1:{s:8:\"7.x-1.11\";a:14:{s:4:\"name\";s:13:\"imce 7.x-1.11\";s:7:\"version\";s:8:\"7.x-1.11\";s:3:\"tag\";s:8:\"7.x-1.11\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/imce/releases/7.x-1.11\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/imce-7.x-1.11.tar.gz\";s:4:\"date\";s:10:\"1495890784\";s:6:\"mdhash\";s:32:\"57c956347a4511727b7e03f122b909fc\";s:8:\"filesize\";s:5:\"62452\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:8:\"7.x-1.11\";s:6:\"status\";i:4;}s:18:\"inline_entity_form\";a:17:{s:4:\"name\";s:18:\"inline_entity_form\";s:4:\"info\";a:6:{s:4:\"name\";s:18:\"Inline Entity Form\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:18:\"inline_entity_form\";s:9:\"datestamp\";s:10:\"1434553381\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1434553381\";s:8:\"includes\";a:1:{s:18:\"inline_entity_form\";s:18:\"Inline Entity Form\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.6\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:18:\"Inline Entity Form\";s:4:\"link\";s:49:\"https://www.drupal.org/project/inline_entity_form\";s:14:\"latest_version\";s:7:\"7.x-1.8\";s:8:\"releases\";a:1:{s:7:\"7.x-1.8\";a:14:{s:4:\"name\";s:26:\"inline_entity_form 7.x-1.8\";s:7:\"version\";s:7:\"7.x-1.8\";s:3:\"tag\";s:7:\"7.x-1.8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/inline_entity_form/releases/7.x-1.8\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/inline_entity_form-7.x-1.8.tar.gz\";s:4:\"date\";s:10:\"1460849406\";s:6:\"mdhash\";s:32:\"3e9bd90b93c363153a3914804a0dfb91\";s:8:\"filesize\";s:5:\"38827\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:0:\"\";s:5:\"terms\";a:0:{}}}s:11:\"recommended\";s:7:\"7.x-1.8\";s:6:\"status\";i:4;}s:9:\"jcarousel\";a:17:{s:4:\"name\";s:9:\"jcarousel\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"jCarousel\";s:7:\"package\";s:14:\"User interface\";s:7:\"version\";s:7:\"7.x-2.7\";s:7:\"project\";s:9:\"jcarousel\";s:9:\"datestamp\";s:10:\"1420460282\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1420460282\";s:8:\"includes\";a:1:{s:9:\"jcarousel\";s:9:\"jCarousel\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.7\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:9:\"jCarousel\";s:4:\"link\";s:40:\"https://www.drupal.org/project/jcarousel\";s:14:\"latest_version\";s:7:\"7.x-2.7\";s:8:\"releases\";a:1:{s:7:\"7.x-2.7\";a:14:{s:4:\"name\";s:17:\"jcarousel 7.x-2.7\";s:7:\"version\";s:7:\"7.x-2.7\";s:3:\"tag\";s:7:\"7.x-2.7\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/jcarousel/releases/7.x-2.7\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/jcarousel-7.x-2.7.tar.gz\";s:4:\"date\";s:10:\"1420460280\";s:6:\"mdhash\";s:32:\"da7722a86d12f286ce6b05e064b6a6e3\";s:8:\"filesize\";s:5:\"58289\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-2.7\";s:6:\"status\";i:5;}s:13:\"jquery_update\";a:18:{s:4:\"name\";s:13:\"jquery_update\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"jQuery Update\";s:7:\"package\";s:14:\"User interface\";s:7:\"version\";s:7:\"7.x-2.7\";s:7:\"project\";s:13:\"jquery_update\";s:9:\"datestamp\";s:10:\"1445379855\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1445379855\";s:8:\"includes\";a:1:{s:13:\"jquery_update\";s:13:\"jQuery Update\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.7\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:13:\"jQuery Update\";s:4:\"link\";s:44:\"https://www.drupal.org/project/jquery_update\";s:4:\"also\";a:1:{i:3;s:14:\"7.x-3.0-alpha5\";}s:8:\"releases\";a:2:{s:14:\"7.x-3.0-alpha5\";a:15:{s:4:\"name\";s:28:\"jquery_update 7.x-3.0-alpha5\";s:7:\"version\";s:14:\"7.x-3.0-alpha5\";s:3:\"tag\";s:14:\"7.x-3.0-alpha5\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/jquery_update/releases/7.x-3.0-alpha5\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-3.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1490805183\";s:6:\"mdhash\";s:32:\"48baebd87003519ade8c65dc5598bbe5\";s:8:\"filesize\";s:7:\"1980268\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:7:\"7.x-2.7\";a:14:{s:4:\"name\";s:21:\"jquery_update 7.x-2.7\";s:7:\"version\";s:7:\"7.x-2.7\";s:3:\"tag\";s:7:\"7.x-2.7\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/jquery_update/releases/7.x-2.7\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-2.7.tar.gz\";s:4:\"date\";s:10:\"1445379839\";s:6:\"mdhash\";s:32:\"85eaf02362c384979bc475df30ae7a3e\";s:8:\"filesize\";s:7:\"1135987\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}}s:14:\"latest_version\";s:7:\"7.x-2.7\";s:11:\"recommended\";s:7:\"7.x-2.7\";s:6:\"status\";i:5;}s:9:\"libraries\";a:17:{s:4:\"name\";s:9:\"libraries\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"Libraries\";s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:9:\"libraries\";s:9:\"datestamp\";s:10:\"1391965716\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1391965716\";s:8:\"includes\";a:1:{s:9:\"libraries\";s:9:\"Libraries\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.2\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:13:\"Libraries API\";s:4:\"link\";s:40:\"https://www.drupal.org/project/libraries\";s:14:\"latest_version\";s:7:\"7.x-2.3\";s:8:\"releases\";a:1:{s:7:\"7.x-2.3\";a:14:{s:4:\"name\";s:17:\"libraries 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/libraries/releases/7.x-2.3\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/libraries-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1463077439\";s:6:\"mdhash\";s:32:\"294d3e4096c513321159b908cfd7c2be\";s:8:\"filesize\";s:5:\"41863\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-2.3\";s:6:\"status\";i:4;}s:4:\"link\";a:17:{s:4:\"name\";s:4:\"link\";s:4:\"info\";a:6:{s:4:\"name\";s:4:\"Link\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:4:\"link\";s:9:\"datestamp\";s:10:\"1413924830\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1413924830\";s:8:\"includes\";a:1:{s:4:\"link\";s:4:\"Link\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.3\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:4:\"Link\";s:4:\"link\";s:35:\"https://www.drupal.org/project/link\";s:14:\"latest_version\";s:13:\"7.x-1.5-beta1\";s:8:\"releases\";a:2:{s:13:\"7.x-1.5-beta1\";a:15:{s:4:\"name\";s:18:\"link 7.x-1.5-beta1\";s:7:\"version\";s:13:\"7.x-1.5-beta1\";s:3:\"tag\";s:13:\"7.x-1.5-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/link/releases/7.x-1.5-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/link-7.x-1.5-beta1.tar.gz\";s:4:\"date\";s:10:\"1499171942\";s:6:\"mdhash\";s:32:\"0589fb97c7b74f82e429a34677eb1fb8\";s:8:\"filesize\";s:5:\"37592\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:12:\"link 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/link/releases/7.x-1.4\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/link-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1452830639\";s:6:\"mdhash\";s:32:\"10cb0a7bb75aaa6cd709c88fd7f79e9f\";s:8:\"filesize\";s:5:\"36913\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-1.4\";s:6:\"status\";i:4;}s:17:\"menu_descriptions\";a:17:{s:4:\"name\";s:17:\"menu_descriptions\";s:4:\"info\";a:6:{s:4:\"name\";s:17:\"Menu Descriptions\";s:7:\"package\";s:14:\"User interface\";s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:17:\"menu_descriptions\";s:9:\"datestamp\";s:10:\"1415818689\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1415818689\";s:8:\"includes\";a:1:{s:17:\"menu_descriptions\";s:17:\"Menu Descriptions\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.6\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:17:\"Menu Descriptions\";s:4:\"link\";s:48:\"https://www.drupal.org/project/menu_descriptions\";s:14:\"latest_version\";s:7:\"7.x-1.7\";s:8:\"releases\";a:1:{s:7:\"7.x-1.7\";a:14:{s:4:\"name\";s:25:\"menu_descriptions 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/menu_descriptions/releases/7.x-1.7\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/menu_descriptions-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1478472240\";s:6:\"mdhash\";s:32:\"1f5be675a5c3cc5af50bbf2b6fdff451\";s:8:\"filesize\";s:5:\"11295\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-1.7\";s:6:\"status\";i:4;}s:10:\"menu_token\";a:17:{s:4:\"name\";s:10:\"menu_token\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"Menu Token\";s:7:\"version\";s:13:\"7.x-1.0-beta5\";s:7:\"project\";s:10:\"menu_token\";s:9:\"datestamp\";s:10:\"1371232255\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1371232255\";s:8:\"includes\";a:1:{s:10:\"menu_token\";s:10:\"Menu Token\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:13:\"7.x-1.0-beta5\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:10:\"Menu token\";s:4:\"link\";s:41:\"https://www.drupal.org/project/menu_token\";s:14:\"latest_version\";s:13:\"7.x-1.0-beta7\";s:8:\"releases\";a:1:{s:13:\"7.x-1.0-beta7\";a:15:{s:4:\"name\";s:24:\"menu_token 7.x-1.0-beta7\";s:7:\"version\";s:13:\"7.x-1.0-beta7\";s:3:\"tag\";s:13:\"7.x-1.0-beta7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/menu_token/releases/7.x-1.0-beta7\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/menu_token-7.x-1.0-beta7.tar.gz\";s:4:\"date\";s:10:\"1458066248\";s:6:\"mdhash\";s:32:\"5a5e84dc72d14388b8bad6b552ae73be\";s:8:\"filesize\";s:5:\"14717\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}}s:11:\"recommended\";s:13:\"7.x-1.0-beta7\";s:6:\"status\";i:4;}s:13:\"module_filter\";a:17:{s:4:\"name\";s:13:\"module_filter\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Module filter\";s:7:\"package\";s:14:\"Administration\";s:7:\"version\";s:7:\"7.x-2.0\";s:7:\"project\";s:13:\"module_filter\";s:9:\"datestamp\";s:10:\"1424631189\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1424631189\";s:8:\"includes\";a:1:{s:13:\"module_filter\";s:13:\"Module filter\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.0\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:13:\"Module Filter\";s:4:\"link\";s:44:\"https://www.drupal.org/project/module_filter\";s:14:\"latest_version\";s:7:\"7.x-2.1\";s:8:\"releases\";a:1:{s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:21:\"module_filter 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/module_filter/releases/7.x-2.1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/module_filter-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1497029343\";s:6:\"mdhash\";s:32:\"66a4998f63f2cefe77c18713054a42cc\";s:8:\"filesize\";s:5:\"29757\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-2.1\";s:6:\"status\";i:4;}s:10:\"node_class\";a:17:{s:4:\"name\";s:10:\"node_class\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"Node Class\";s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:10:\"node_class\";s:9:\"datestamp\";s:10:\"1388997876\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1388997876\";s:8:\"includes\";a:1:{s:10:\"node_class\";s:10:\"Node Class\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.3\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:10:\"Node Class\";s:4:\"link\";s:41:\"https://www.drupal.org/project/node_class\";s:14:\"latest_version\";s:7:\"7.x-1.3\";s:8:\"releases\";a:1:{s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:18:\"node_class 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/node_class/releases/7.x-1.3\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/node_class-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1388997805\";s:6:\"mdhash\";s:32:\"76bc0de128d7108d7131c710798c79a8\";s:8:\"filesize\";s:4:\"8698\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-1.3\";s:6:\"status\";i:5;}s:8:\"pathauto\";a:17:{s:4:\"name\";s:8:\"pathauto\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Pathauto\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:8:\"pathauto\";s:9:\"datestamp\";s:10:\"1344525185\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1344525185\";s:8:\"includes\";a:1:{s:8:\"pathauto\";s:8:\"Pathauto\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.2\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:8:\"Pathauto\";s:4:\"link\";s:39:\"https://www.drupal.org/project/pathauto\";s:14:\"latest_version\";s:7:\"7.x-1.3\";s:8:\"releases\";a:1:{s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:16:\"pathauto 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/pathauto/releases/7.x-1.3\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/pathauto-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1444232639\";s:6:\"mdhash\";s:32:\"ff984b2837230a221d53fad5462c0b61\";s:8:\"filesize\";s:5:\"42319\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-1.3\";s:6:\"status\";i:4;}s:13:\"recently_read\";a:17:{s:4:\"name\";s:13:\"recently_read\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Recently read\";s:7:\"package\";s:5:\"Other\";s:7:\"version\";s:7:\"7.x-3.1\";s:7:\"project\";s:13:\"recently_read\";s:9:\"datestamp\";s:10:\"1409150634\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1409150634\";s:8:\"includes\";a:1:{s:13:\"recently_read\";s:13:\"Recently read\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-3.1\";s:14:\"existing_major\";s:1:\"3\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:13:\"Recently read\";s:4:\"link\";s:44:\"https://www.drupal.org/project/recently_read\";s:14:\"latest_version\";s:7:\"7.x-3.2\";s:8:\"releases\";a:1:{s:7:\"7.x-3.2\";a:14:{s:4:\"name\";s:21:\"recently_read 7.x-3.2\";s:7:\"version\";s:7:\"7.x-3.2\";s:3:\"tag\";s:7:\"7.x-3.2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/recently_read/releases/7.x-3.2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/recently_read-7.x-3.2.tar.gz\";s:4:\"date\";s:10:\"1473054539\";s:6:\"mdhash\";s:32:\"c557ea870569b051cc9302af3f5fea71\";s:8:\"filesize\";s:5:\"11827\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-3.2\";s:6:\"status\";i:4;}s:5:\"rules\";a:17:{s:4:\"name\";s:5:\"rules\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Rules\";s:7:\"package\";s:5:\"Rules\";s:7:\"version\";s:7:\"7.x-2.9\";s:7:\"project\";s:5:\"rules\";s:9:\"datestamp\";s:10:\"1426527210\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1426527210\";s:8:\"includes\";a:2:{s:5:\"rules\";s:5:\"Rules\";s:11:\"rules_admin\";s:8:\"Rules UI\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.9\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:5:\"Rules\";s:4:\"link\";s:36:\"https://www.drupal.org/project/rules\";s:14:\"latest_version\";s:8:\"7.x-2.10\";s:8:\"releases\";a:1:{s:8:\"7.x-2.10\";a:14:{s:4:\"name\";s:14:\"rules 7.x-2.10\";s:7:\"version\";s:8:\"7.x-2.10\";s:3:\"tag\";s:8:\"7.x-2.10\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/rules/releases/7.x-2.10\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/rules-7.x-2.10.tar.gz\";s:4:\"date\";s:10:\"1492697942\";s:6:\"mdhash\";s:32:\"b66045ee97acdec07b4808f649e9dcc8\";s:8:\"filesize\";s:6:\"187783\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:8:\"7.x-2.10\";s:6:\"status\";i:4;}s:10:\"search_api\";a:17:{s:4:\"name\";s:10:\"search_api\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"Search API\";s:7:\"package\";s:6:\"Search\";s:7:\"version\";s:8:\"7.x-1.21\";s:7:\"project\";s:10:\"search_api\";s:9:\"datestamp\";s:10:\"1487844493\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1487844493\";s:8:\"includes\";a:3:{s:10:\"search_api\";s:10:\"Search API\";s:19:\"search_api_facetapi\";s:13:\"Search facets\";s:16:\"search_api_views\";s:12:\"Search views\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:8:\"7.x-1.21\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:10:\"Search API\";s:4:\"link\";s:41:\"https://www.drupal.org/project/search_api\";s:14:\"latest_version\";s:8:\"7.x-1.21\";s:8:\"releases\";a:1:{s:8:\"7.x-1.21\";a:14:{s:4:\"name\";s:19:\"search_api 7.x-1.21\";s:7:\"version\";s:8:\"7.x-1.21\";s:3:\"tag\";s:8:\"7.x-1.21\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"21\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/search_api/releases/7.x-1.21\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/search_api-7.x-1.21.tar.gz\";s:4:\"date\";s:10:\"1487844487\";s:6:\"mdhash\";s:32:\"271ef8d9aa8c58787579c90d6f47053f\";s:8:\"filesize\";s:6:\"201027\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:8:\"7.x-1.21\";s:6:\"status\";i:5;}s:13:\"search_api_db\";a:17:{s:4:\"name\";s:13:\"search_api_db\";s:4:\"info\";a:6:{s:4:\"name\";s:15:\"Database search\";s:7:\"package\";s:6:\"Search\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:13:\"search_api_db\";s:9:\"datestamp\";s:10:\"1440962643\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1440962643\";s:8:\"includes\";a:1:{s:13:\"search_api_db\";s:15:\"Database search\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.5\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:26:\"Search API Database Search\";s:4:\"link\";s:44:\"https://www.drupal.org/project/search_api_db\";s:14:\"latest_version\";s:7:\"7.x-1.6\";s:8:\"releases\";a:1:{s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:21:\"search_api_db 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/search_api_db/releases/7.x-1.6\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/search_api_db-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1487844783\";s:6:\"mdhash\";s:32:\"f1d282d1993f7b0586952bb927e8c313\";s:8:\"filesize\";s:5:\"38356\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-1.6\";s:6:\"status\";i:4;}s:17:\"search_api_ranges\";a:17:{s:4:\"name\";s:17:\"search_api_ranges\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Search ranges\";s:7:\"package\";s:6:\"Search\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:17:\"search_api_ranges\";s:9:\"datestamp\";s:10:\"1392554914\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1392554914\";s:8:\"includes\";a:1:{s:17:\"search_api_ranges\";s:13:\"Search ranges\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.5\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:17:\"Search API ranges\";s:4:\"link\";s:48:\"https://www.drupal.org/project/search_api_ranges\";s:14:\"latest_version\";s:7:\"7.x-1.5\";s:8:\"releases\";a:1:{s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:25:\"search_api_ranges 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/search_api_ranges/releases/7.x-1.5\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/search_api_ranges-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1392554905\";s:6:\"mdhash\";s:32:\"ecaefedf02924f5f502c4fa44cd60b1d\";s:8:\"filesize\";s:5:\"21717\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-1.5\";s:6:\"status\";i:5;}s:16:\"search_api_sorts\";a:17:{s:4:\"name\";s:16:\"search_api_sorts\";s:4:\"info\";a:6:{s:4:\"name\";s:16:\"Search API sorts\";s:7:\"package\";s:6:\"Search\";s:7:\"version\";s:7:\"7.x-1.7\";s:7:\"project\";s:16:\"search_api_sorts\";s:9:\"datestamp\";s:10:\"1487095386\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1487095386\";s:8:\"includes\";a:1:{s:16:\"search_api_sorts\";s:16:\"Search API sorts\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.7\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:16:\"Search API sorts\";s:4:\"link\";s:47:\"https://www.drupal.org/project/search_api_sorts\";s:14:\"latest_version\";s:7:\"7.x-1.7\";s:8:\"releases\";a:1:{s:7:\"7.x-1.7\";a:14:{s:4:\"name\";s:24:\"search_api_sorts 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/search_api_sorts/releases/7.x-1.7\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/search_api_sorts-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1487095383\";s:6:\"mdhash\";s:32:\"b1da23994fc66340e5708d46c15e6288\";s:8:\"filesize\";s:5:\"15750\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:0:\"\";}}s:11:\"recommended\";s:7:\"7.x-1.7\";s:6:\"status\";i:5;}s:15:\"select_or_other\";a:18:{s:4:\"name\";s:15:\"select_or_other\";s:4:\"info\";a:6:{s:4:\"name\";s:17:\"Select (or other)\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:8:\"7.x-2.22\";s:7:\"project\";s:15:\"select_or_other\";s:9:\"datestamp\";s:10:\"1432142587\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1432142587\";s:8:\"includes\";a:1:{s:15:\"select_or_other\";s:17:\"Select (or other)\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:8:\"7.x-2.22\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:17:\"Select (or other)\";s:4:\"link\";s:46:\"https://www.drupal.org/project/select_or_other\";s:4:\"also\";a:1:{i:3;s:14:\"7.x-3.0-alpha1\";}s:8:\"releases\";a:2:{s:14:\"7.x-3.0-alpha1\";a:15:{s:4:\"name\";s:30:\"select_or_other 7.x-3.0-alpha1\";s:7:\"version\";s:14:\"7.x-3.0-alpha1\";s:3:\"tag\";s:14:\"7.x-3.0-alpha1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/select_or_other/releases/7.x-3.0-alpha1\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-3.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1445714939\";s:6:\"mdhash\";s:32:\"213b8ff79aebaa8be0895336304aba44\";s:8:\"filesize\";s:5:\"19469\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:8:\"7.x-2.22\";a:14:{s:4:\"name\";s:24:\"select_or_other 7.x-2.22\";s:7:\"version\";s:8:\"7.x-2.22\";s:3:\"tag\";s:8:\"7.x-2.22\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"22\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/select_or_other/releases/7.x-2.22\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/select_or_other-7.x-2.22.tar.gz\";s:4:\"date\";s:10:\"1432142581\";s:6:\"mdhash\";s:32:\"0f8f19915f1cdda1f63bb304a5c257e7\";s:8:\"filesize\";s:5:\"17641\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:0:\"\";}}s:14:\"latest_version\";s:8:\"7.x-2.22\";s:11:\"recommended\";s:8:\"7.x-2.22\";s:6:\"status\";i:5;}s:11:\"session_api\";a:13:{s:4:\"name\";s:11:\"session_api\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Session API\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:7:\"project\";s:11:\"session_api\";s:9:\"datestamp\";s:10:\"1354234727\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1354234727\";s:8:\"includes\";a:1:{s:11:\"session_api\";s:11:\"Session API\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:11:\"7.x-1.0-rc1\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:6:\"status\";i:-2;s:6:\"reason\";s:27:\"No available releases found\";}s:10:\"simplenews\";a:13:{s:4:\"name\";s:10:\"simplenews\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"Simplenews\";s:7:\"package\";s:4:\"Mail\";s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:10:\"simplenews\";s:9:\"datestamp\";s:10:\"1381947969\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1381947969\";s:8:\"includes\";a:1:{s:10:\"simplenews\";s:10:\"Simplenews\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.1\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:6:\"status\";i:-2;s:6:\"reason\";s:27:\"No available releases found\";}s:9:\"tagclouds\";a:13:{s:4:\"name\";s:9:\"tagclouds\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"TagClouds\";s:7:\"package\";s:8:\"Taxonomy\";s:7:\"version\";s:8:\"7.x-1.10\";s:7:\"project\";s:9:\"tagclouds\";s:9:\"datestamp\";s:10:\"1404152332\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1404152332\";s:8:\"includes\";a:1:{s:9:\"tagclouds\";s:9:\"TagClouds\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:8:\"7.x-1.10\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:6:\"status\";i:-2;s:6:\"reason\";s:27:\"No available releases found\";}s:13:\"taxonomy_menu\";a:13:{s:4:\"name\";s:13:\"taxonomy_menu\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Taxonomy menu\";s:7:\"package\";s:13:\"Taxonomy menu\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:13:\"taxonomy_menu\";s:9:\"datestamp\";s:10:\"1396359247\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1396359247\";s:8:\"includes\";a:1:{s:13:\"taxonomy_menu\";s:13:\"Taxonomy menu\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.5\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:6:\"status\";i:-2;s:6:\"reason\";s:27:\"No available releases found\";}s:11:\"tb_megamenu\";a:13:{s:4:\"name\";s:11:\"tb_megamenu\";s:4:\"info\";a:6:{s:4:\"name\";s:12:\"TB Mega Menu\";s:7:\"package\";s:4:\"Menu\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:7:\"project\";s:11:\"tb_megamenu\";s:9:\"datestamp\";s:10:\"1440756596\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1440756596\";s:8:\"includes\";a:1:{s:11:\"tb_megamenu\";s:12:\"TB Mega Menu\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:11:\"7.x-1.0-rc2\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:6:\"status\";i:-2;s:6:\"reason\";s:27:\"No available releases found\";}s:5:\"title\";a:13:{s:4:\"name\";s:5:\"title\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Title\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:14:\"7.x-1.0-alpha9\";s:7:\"project\";s:5:\"title\";s:9:\"datestamp\";s:10:\"1484302985\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1484302985\";s:8:\"includes\";a:1:{s:5:\"title\";s:5:\"Title\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:14:\"7.x-1.0-alpha9\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:6:\"status\";i:-2;s:6:\"reason\";s:27:\"No available releases found\";}s:5:\"token\";a:13:{s:4:\"name\";s:5:\"token\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Token\";s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:5:\"token\";s:9:\"datestamp\";s:10:\"1425149060\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1425149060\";s:8:\"includes\";a:1:{s:5:\"token\";s:5:\"Token\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.6\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:6:\"status\";i:-2;s:6:\"reason\";s:27:\"No available releases found\";}s:5:\"views\";a:13:{s:4:\"name\";s:5:\"views\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Views\";s:7:\"package\";s:5:\"Views\";s:7:\"version\";s:8:\"7.x-3.16\";s:7:\"project\";s:5:\"views\";s:9:\"datestamp\";s:10:\"1491158591\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1491158591\";s:8:\"includes\";a:2:{s:5:\"views\";s:5:\"Views\";s:8:\"views_ui\";s:8:\"Views UI\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:8:\"7.x-3.16\";s:14:\"existing_major\";s:1:\"3\";s:12:\"install_type\";s:8:\"official\";s:6:\"status\";i:-2;s:6:\"reason\";s:27:\"No available releases found\";}s:15:\"views_bootstrap\";a:13:{s:4:\"name\";s:15:\"views_bootstrap\";s:4:\"info\";a:6:{s:4:\"name\";s:15:\"Views Bootstrap\";s:7:\"package\";s:5:\"Views\";s:7:\"version\";s:7:\"7.x-3.1\";s:7:\"project\";s:15:\"views_bootstrap\";s:9:\"datestamp\";s:10:\"1398607429\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1398607429\";s:8:\"includes\";a:1:{s:15:\"views_bootstrap\";s:15:\"Views Bootstrap\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-3.1\";s:14:\"existing_major\";s:1:\"3\";s:12:\"install_type\";s:8:\"official\";s:6:\"status\";i:-2;s:6:\"reason\";s:27:\"No available releases found\";}s:16:\"views_field_view\";a:13:{s:4:\"name\";s:16:\"views_field_view\";s:4:\"info\";a:6:{s:4:\"name\";s:16:\"Views Field View\";s:7:\"package\";s:5:\"Views\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:16:\"views_field_view\";s:9:\"datestamp\";s:10:\"1442561052\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1442561052\";s:8:\"includes\";a:1:{s:16:\"views_field_view\";s:16:\"Views Field View\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.2\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:6:\"status\";i:-2;s:6:\"reason\";s:27:\"No available releases found\";}s:15:\"views_fieldsets\";a:13:{s:4:\"name\";s:15:\"views_fieldsets\";s:4:\"info\";a:6:{s:4:\"name\";s:15:\"Views fieldsets\";s:7:\"package\";s:5:\"Views\";s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:15:\"views_fieldsets\";s:9:\"datestamp\";s:10:\"1425515886\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1425515886\";s:8:\"includes\";a:1:{s:15:\"views_fieldsets\";s:15:\"Views fieldsets\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.3\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:6:\"status\";i:-2;s:6:\"reason\";s:27:\"No available releases found\";}s:15:\"views_slideshow\";a:13:{s:4:\"name\";s:15:\"views_slideshow\";s:4:\"info\";a:6:{s:4:\"name\";s:15:\"Views Slideshow\";s:7:\"package\";s:5:\"Views\";s:7:\"version\";s:7:\"7.x-3.1\";s:7:\"project\";s:15:\"views_slideshow\";s:9:\"datestamp\";s:10:\"1382584826\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1382584826\";s:8:\"includes\";a:2:{s:15:\"views_slideshow\";s:15:\"Views Slideshow\";s:21:\"views_slideshow_cycle\";s:22:\"Views Slideshow: Cycle\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-3.1\";s:14:\"existing_major\";s:1:\"3\";s:12:\"install_type\";s:8:\"official\";s:6:\"status\";i:-2;s:6:\"reason\";s:27:\"No available releases found\";}s:9:\"votingapi\";a:13:{s:4:\"name\";s:9:\"votingapi\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"Voting API\";s:7:\"package\";s:6:\"Voting\";s:7:\"version\";s:8:\"7.x-2.12\";s:7:\"project\";s:9:\"votingapi\";s:9:\"datestamp\";s:10:\"1407995929\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1407995929\";s:8:\"includes\";a:1:{s:9:\"votingapi\";s:10:\"Voting API\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:8:\"7.x-2.12\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:6:\"status\";i:-2;s:6:\"reason\";s:27:\"No available releases found\";}s:20:\"we_content_migration\";a:13:{s:4:\"name\";s:20:\"we_content_migration\";s:4:\"info\";a:6:{s:4:\"name\";s:17:\"Content Migration\";s:7:\"package\";s:17:\"Content Migration\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:7:\"project\";s:20:\"we_content_migration\";s:9:\"datestamp\";s:10:\"1499677744\";s:16:\"_info_file_ctime\";i:1499933737;}s:9:\"datestamp\";s:10:\"1499677744\";s:8:\"includes\";a:1:{s:20:\"we_content_migration\";s:17:\"Content Migration\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:11:\"7.x-1.x-dev\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:3:\"dev\";s:6:\"status\";i:-2;s:6:\"reason\";s:27:\"No available releases found\";}s:7:\"webform\";a:13:{s:4:\"name\";s:7:\"webform\";s:4:\"info\";a:6:{s:4:\"name\";s:7:\"Webform\";s:7:\"package\";s:7:\"Webform\";s:7:\"version\";s:8:\"7.x-4.11\";s:7:\"project\";s:7:\"webform\";s:9:\"datestamp\";s:10:\"1442953145\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1442953145\";s:8:\"includes\";a:1:{s:7:\"webform\";s:7:\"Webform\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:8:\"7.x-4.11\";s:14:\"existing_major\";s:1:\"4\";s:12:\"install_type\";s:8:\"official\";s:6:\"status\";i:-2;s:6:\"reason\";s:27:\"No available releases found\";}s:6:\"weight\";a:13:{s:4:\"name\";s:6:\"weight\";s:4:\"info\";a:6:{s:4:\"name\";s:6:\"Weight\";s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:6:\"weight\";s:9:\"datestamp\";s:10:\"1430342647\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1430342647\";s:8:\"includes\";a:1:{s:6:\"weight\";s:6:\"Weight\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.5\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:6:\"status\";i:-2;s:6:\"reason\";s:27:\"No available releases found\";}}',1500364898,1500361298,1),('update_project_projects','a:73:{s:21:\"views_bulk_operations\";a:8:{s:4:\"name\";s:21:\"views_bulk_operations\";s:4:\"info\";a:6:{s:4:\"name\";s:25:\"Actions permissions (VBO)\";s:7:\"package\";s:14:\"Administration\";s:7:\"version\";s:7:\"7.x-3.3\";s:7:\"project\";s:21:\"views_bulk_operations\";s:9:\"datestamp\";s:10:\"1435764542\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1435764542\";s:8:\"includes\";a:1:{s:19:\"actions_permissions\";s:25:\"Actions permissions (VBO)\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:12:\"addressfield\";a:8:{s:4:\"name\";s:12:\"addressfield\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Address Field\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-1.0\";s:7:\"project\";s:12:\"addressfield\";s:9:\"datestamp\";s:10:\"1421426885\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1421426885\";s:8:\"includes\";a:1:{s:12:\"addressfield\";s:13:\"Address Field\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:10:\"admin_menu\";a:8:{s:4:\"name\";s:10:\"admin_menu\";s:4:\"info\";a:6:{s:4:\"name\";s:32:\"Administration Development tools\";s:7:\"package\";s:14:\"Administration\";s:7:\"version\";s:11:\"7.x-3.0-rc5\";s:7:\"project\";s:10:\"admin_menu\";s:9:\"datestamp\";s:10:\"1419029284\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1419029284\";s:8:\"includes\";a:3:{s:11:\"admin_devel\";s:32:\"Administration Development tools\";s:10:\"admin_menu\";s:19:\"Administration menu\";s:18:\"admin_menu_toolbar\";s:33:\"Administration menu Toolbar style\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:22:\"better_exposed_filters\";a:8:{s:4:\"name\";s:22:\"better_exposed_filters\";s:4:\"info\";a:6:{s:4:\"name\";s:22:\"Better Exposed Filters\";s:7:\"package\";s:5:\"Views\";s:7:\"version\";s:7:\"7.x-3.4\";s:7:\"project\";s:22:\"better_exposed_filters\";s:9:\"datestamp\";s:10:\"1485926287\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1485926287\";s:8:\"includes\";a:1:{s:22:\"better_exposed_filters\";s:22:\"Better Exposed Filters\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:6:\"drupal\";a:8:{s:4:\"name\";s:6:\"drupal\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Block\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:16:\"_info_file_ctime\";i:1500361104;}s:9:\"datestamp\";s:10:\"1498069849\";s:8:\"includes\";a:31:{s:5:\"block\";s:5:\"Block\";s:5:\"color\";s:5:\"Color\";s:7:\"comment\";s:7:\"Comment\";s:10:\"contextual\";s:16:\"Contextual links\";s:9:\"dashboard\";s:9:\"Dashboard\";s:5:\"dblog\";s:16:\"Database logging\";s:5:\"field\";s:5:\"Field\";s:17:\"field_sql_storage\";s:17:\"Field SQL storage\";s:8:\"field_ui\";s:8:\"Field UI\";s:4:\"file\";s:4:\"File\";s:6:\"filter\";s:6:\"Filter\";s:4:\"help\";s:4:\"Help\";s:5:\"image\";s:5:\"Image\";s:4:\"list\";s:4:\"List\";s:6:\"locale\";s:6:\"Locale\";s:4:\"menu\";s:4:\"Menu\";s:4:\"node\";s:4:\"Node\";s:6:\"number\";s:6:\"Number\";s:7:\"options\";s:7:\"Options\";s:7:\"overlay\";s:7:\"Overlay\";s:4:\"path\";s:4:\"Path\";s:3:\"php\";s:10:\"PHP filter\";s:6:\"search\";s:6:\"Search\";s:8:\"shortcut\";s:8:\"Shortcut\";s:6:\"system\";s:6:\"System\";s:8:\"taxonomy\";s:8:\"Taxonomy\";s:4:\"text\";s:4:\"Text\";s:6:\"update\";s:14:\"Update manager\";s:4:\"user\";s:4:\"User\";s:6:\"bartik\";s:6:\"Bartik\";s:5:\"seven\";s:5:\"Seven\";}s:12:\"project_type\";s:4:\"core\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:11:\"block_class\";a:8:{s:4:\"name\";s:11:\"block_class\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Block Class\";s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:11:\"block_class\";s:9:\"datestamp\";s:10:\"1450415951\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1450415951\";s:8:\"includes\";a:1:{s:11:\"block_class\";s:11:\"Block Class\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:6:\"chosen\";a:8:{s:4:\"name\";s:6:\"chosen\";s:4:\"info\";a:6:{s:4:\"name\";s:6:\"Chosen\";s:7:\"package\";s:14:\"User interface\";s:7:\"version\";s:13:\"7.x-2.0-beta4\";s:7:\"project\";s:6:\"chosen\";s:9:\"datestamp\";s:10:\"1394256505\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1394256505\";s:8:\"includes\";a:1:{s:6:\"chosen\";s:6:\"Chosen\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:8:\"ckeditor\";a:8:{s:4:\"name\";s:8:\"ckeditor\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"CKEditor\";s:7:\"package\";s:14:\"User interface\";s:7:\"version\";s:8:\"7.x-1.16\";s:7:\"project\";s:8:\"ckeditor\";s:9:\"datestamp\";s:10:\"1413311935\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1413311935\";s:8:\"includes\";a:1:{s:8:\"ckeditor\";s:8:\"CKEditor\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:10:\"cloud_zoom\";a:8:{s:4:\"name\";s:10:\"cloud_zoom\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"Cloud Zoom\";s:7:\"package\";s:10:\"Cloud Zoom\";s:7:\"version\";s:13:\"7.x-1.1+1-dev\";s:7:\"project\";s:10:\"cloud_zoom\";s:9:\"datestamp\";s:10:\"1380559092\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1380559092\";s:8:\"includes\";a:1:{s:10:\"cloud_zoom\";s:10:\"Cloud Zoom\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:8:\"commerce\";a:8:{s:4:\"name\";s:8:\"commerce\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Commerce\";s:7:\"package\";s:8:\"Commerce\";s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1459956613\";s:8:\"includes\";a:18:{s:8:\"commerce\";s:8:\"Commerce\";s:13:\"commerce_cart\";s:4:\"Cart\";s:17:\"commerce_checkout\";s:8:\"Checkout\";s:17:\"commerce_customer\";s:8:\"Customer\";s:20:\"commerce_customer_ui\";s:11:\"Customer UI\";s:18:\"commerce_line_item\";s:9:\"Line Item\";s:21:\"commerce_line_item_ui\";s:12:\"Line Item UI\";s:14:\"commerce_order\";s:5:\"Order\";s:17:\"commerce_order_ui\";s:8:\"Order UI\";s:16:\"commerce_payment\";s:7:\"Payment\";s:19:\"commerce_payment_ui\";s:10:\"Payment UI\";s:14:\"commerce_price\";s:5:\"Price\";s:16:\"commerce_product\";s:7:\"Product\";s:24:\"commerce_product_pricing\";s:15:\"Product Pricing\";s:27:\"commerce_product_pricing_ui\";s:18:\"Product Pricing UI\";s:26:\"commerce_product_reference\";s:17:\"Product Reference\";s:19:\"commerce_product_ui\";s:10:\"Product UI\";s:11:\"commerce_ui\";s:11:\"Commerce UI\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:12:\"commerce_cop\";a:8:{s:4:\"name\";s:12:\"commerce_cop\";s:4:\"info\";a:6:{s:4:\"name\";s:32:\"Commerce Custom Offline Payments\";s:7:\"package\";s:18:\"Commerce (contrib)\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:7:\"project\";s:12:\"commerce_cop\";s:9:\"datestamp\";s:10:\"1409840629\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1409840629\";s:8:\"includes\";a:3:{s:12:\"commerce_cop\";s:32:\"Commerce Custom Offline Payments\";s:26:\"commerce_cop_bank_transfer\";s:21:\"Bank Transfer payment\";s:16:\"commerce_cop_cod\";s:24:\"Cash on Delivery payment\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:25:\"commerce_fancy_attributes\";a:8:{s:4:\"name\";s:25:\"commerce_fancy_attributes\";s:4:\"info\";a:6:{s:4:\"name\";s:25:\"Commerce fancy attributes\";s:7:\"package\";s:18:\"Commerce (contrib)\";s:7:\"version\";s:7:\"7.x-1.0\";s:7:\"project\";s:25:\"commerce_fancy_attributes\";s:9:\"datestamp\";s:10:\"1343752308\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1343752308\";s:8:\"includes\";a:1:{s:25:\"commerce_fancy_attributes\";s:25:\"Commerce fancy attributes\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:18:\"commerce_flat_rate\";a:8:{s:4:\"name\";s:18:\"commerce_flat_rate\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"Flat Rate\";s:7:\"package\";s:19:\"Commerce (shipping)\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:7:\"project\";s:18:\"commerce_flat_rate\";s:9:\"datestamp\";s:10:\"1353122757\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1353122757\";s:8:\"includes\";a:1:{s:18:\"commerce_flat_rate\";s:9:\"Flat Rate\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:20:\"commerce_marketplace\";a:8:{s:4:\"name\";s:20:\"commerce_marketplace\";s:4:\"info\";a:6:{s:4:\"name\";s:20:\"Commerce Marketplace\";s:7:\"package\";s:20:\"Commerce Marketplace\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:7:\"project\";s:20:\"commerce_marketplace\";s:9:\"datestamp\";s:10:\"1408538840\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1408538840\";s:8:\"includes\";a:6:{s:20:\"commerce_marketplace\";s:20:\"Commerce Marketplace\";s:26:\"commerce_marketplace_funds\";s:26:\"Commerce Marketplace Funds\";s:35:\"commerce_marketplace_funds_withdraw\";s:45:\"Commerce Marketplace Funds Withdrawal methods\";s:26:\"commerce_marketplace_order\";s:26:\"Commerce Marketplace Order\";s:14:\"commerce_store\";s:14:\"Commerce Store\";s:21:\"commerce_store_access\";s:26:\"Commerce Store Permissions\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:15:\"commerce_paypal\";a:8:{s:4:\"name\";s:15:\"commerce_paypal\";s:4:\"info\";a:6:{s:4:\"name\";s:6:\"PayPal\";s:7:\"package\";s:17:\"Commerce (PayPal)\";s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:15:\"commerce_paypal\";s:9:\"datestamp\";s:10:\"1389740908\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1389740908\";s:8:\"includes\";a:2:{s:15:\"commerce_paypal\";s:6:\"PayPal\";s:19:\"commerce_paypal_wps\";s:10:\"PayPal WPS\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:19:\"commerce_search_api\";a:8:{s:4:\"name\";s:19:\"commerce_search_api\";s:4:\"info\";a:6:{s:4:\"name\";s:19:\"Commerce Search API\";s:7:\"package\";s:18:\"Commerce (contrib)\";s:7:\"version\";s:7:\"7.x-1.4\";s:7:\"project\";s:19:\"commerce_search_api\";s:9:\"datestamp\";s:10:\"1436974444\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1436974444\";s:8:\"includes\";a:1:{s:19:\"commerce_search_api\";s:19:\"Commerce Search API\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:17:\"commerce_shipping\";a:8:{s:4:\"name\";s:17:\"commerce_shipping\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Shipping\";s:7:\"package\";s:19:\"Commerce (shipping)\";s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:17:\"commerce_shipping\";s:9:\"datestamp\";s:10:\"1428479882\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1428479882\";s:8:\"includes\";a:2:{s:17:\"commerce_shipping\";s:8:\"Shipping\";s:20:\"commerce_shipping_ui\";s:11:\"Shipping UI\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:14:\"commerce_stock\";a:8:{s:4:\"name\";s:14:\"commerce_stock\";s:4:\"info\";a:6:{s:4:\"name\";s:21:\"Commerce Simple Stock\";s:7:\"package\";s:16:\"Commerce (stock)\";s:7:\"version\";s:7:\"7.x-2.1\";s:7:\"project\";s:14:\"commerce_stock\";s:9:\"datestamp\";s:10:\"1418323685\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1418323685\";s:8:\"includes\";a:4:{s:11:\"commerce_ss\";s:21:\"Commerce Simple Stock\";s:12:\"commerce_ssr\";s:27:\"Commerce Simple Stock Rules\";s:14:\"commerce_stock\";s:18:\"Commerce Stock API\";s:17:\"commerce_stock_ui\";s:17:\"Commerce stock UI\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:7:\"context\";a:8:{s:4:\"name\";s:7:\"context\";s:4:\"info\";a:6:{s:4:\"name\";s:7:\"Context\";s:7:\"package\";s:7:\"Context\";s:7:\"version\";s:7:\"7.x-3.6\";s:7:\"project\";s:7:\"context\";s:9:\"datestamp\";s:10:\"1420573188\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1420573188\";s:8:\"includes\";a:2:{s:7:\"context\";s:7:\"Context\";s:10:\"context_ui\";s:10:\"Context UI\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:9:\"countries\";a:8:{s:4:\"name\";s:9:\"countries\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"Countries\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:9:\"countries\";s:9:\"datestamp\";s:10:\"1409450929\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1409450929\";s:8:\"includes\";a:1:{s:9:\"countries\";s:9:\"Countries\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:6:\"ctools\";a:8:{s:4:\"name\";s:6:\"ctools\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Chaos tools\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1440020680\";s:8:\"includes\";a:1:{s:6:\"ctools\";s:11:\"Chaos tools\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:8:\"facetapi\";a:8:{s:4:\"name\";s:8:\"facetapi\";s:4:\"info\";a:6:{s:4:\"name\";s:21:\"Current Search Blocks\";s:7:\"package\";s:14:\"Search Toolkit\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:8:\"facetapi\";s:9:\"datestamp\";s:10:\"1405685332\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1405685332\";s:8:\"includes\";a:2:{s:14:\"current_search\";s:21:\"Current Search Blocks\";s:8:\"facetapi\";s:9:\"Facet API\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:18:\"custom_breadcrumbs\";a:8:{s:4:\"name\";s:18:\"custom_breadcrumbs\";s:4:\"info\";a:6:{s:4:\"name\";s:18:\"Custom breadcrumbs\";s:7:\"package\";s:18:\"Custom breadcrumbs\";s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:7:\"project\";s:18:\"custom_breadcrumbs\";s:9:\"datestamp\";s:10:\"1410287363\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1410287363\";s:8:\"includes\";a:5:{s:18:\"custom_breadcrumbs\";s:18:\"Custom breadcrumbs\";s:30:\"custom_breadcrumbs_identifiers\";s:30:\"Custom breadcrumbs identifiers\";s:24:\"custom_breadcrumbs_paths\";s:28:\"Custom breadcrumbs for paths\";s:27:\"custom_breadcrumbs_taxonomy\";s:31:\"Custom breadcrumbs for taxonomy\";s:24:\"custom_breadcrumbs_views\";s:28:\"Custom breadcrumbs for views\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:5:\"devel\";a:8:{s:4:\"name\";s:5:\"devel\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Devel\";s:7:\"package\";s:11:\"Development\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:5:\"devel\";s:9:\"datestamp\";s:10:\"1398963366\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1398963366\";s:8:\"includes\";a:1:{s:5:\"devel\";s:5:\"Devel\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:3:\"eck\";a:8:{s:4:\"name\";s:3:\"eck\";s:4:\"info\";a:6:{s:4:\"name\";s:23:\"Entity Construction Kit\";s:7:\"package\";s:3:\"ECK\";s:7:\"version\";s:11:\"7.x-2.0-rc7\";s:7:\"project\";s:3:\"eck\";s:9:\"datestamp\";s:10:\"1422241382\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1422241382\";s:8:\"includes\";a:1:{s:3:\"eck\";s:23:\"Entity Construction Kit\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:6:\"entity\";a:8:{s:4:\"name\";s:6:\"entity\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"Entity API\";s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";s:10:\"1424876582\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1424876582\";s:8:\"includes\";a:2:{s:6:\"entity\";s:10:\"Entity API\";s:12:\"entity_token\";s:13:\"Entity tokens\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:15:\"entityreference\";a:8:{s:4:\"name\";s:15:\"entityreference\";s:4:\"info\";a:6:{s:4:\"name\";s:16:\"Entity Reference\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:15:\"entityreference\";s:9:\"datestamp\";s:10:\"1384973110\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1384973110\";s:8:\"includes\";a:1:{s:15:\"entityreference\";s:16:\"Entity Reference\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:18:\"exclude_node_title\";a:8:{s:4:\"name\";s:18:\"exclude_node_title\";s:4:\"info\";a:6:{s:4:\"name\";s:18:\"Exclude node title\";s:7:\"package\";s:5:\"Other\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:18:\"exclude_node_title\";s:9:\"datestamp\";s:10:\"1435338184\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1435338184\";s:8:\"includes\";a:1:{s:18:\"exclude_node_title\";s:18:\"Exclude node title\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:8:\"features\";a:8:{s:4:\"name\";s:8:\"features\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Features\";s:7:\"package\";s:8:\"Features\";s:7:\"version\";s:8:\"7.x-2.10\";s:7:\"project\";s:8:\"features\";s:9:\"datestamp\";s:10:\"1461011641\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1461011641\";s:8:\"includes\";a:1:{s:8:\"features\";s:8:\"Features\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:16:\"field_collection\";a:8:{s:4:\"name\";s:16:\"field_collection\";s:4:\"info\";a:6:{s:4:\"name\";s:16:\"Field collection\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:13:\"7.x-1.0-beta8\";s:7:\"project\";s:16:\"field_collection\";s:9:\"datestamp\";s:10:\"1415122384\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1415122384\";s:8:\"includes\";a:1:{s:16:\"field_collection\";s:16:\"Field collection\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:22:\"field_collection_table\";a:8:{s:4:\"name\";s:22:\"field_collection_table\";s:4:\"info\";a:6:{s:4:\"name\";s:22:\"Field Collection Table\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:7:\"project\";s:22:\"field_collection_table\";s:9:\"datestamp\";s:10:\"1426689182\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1426689182\";s:8:\"includes\";a:1:{s:22:\"field_collection_table\";s:22:\"Field Collection Table\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:21:\"field_formatter_class\";a:8:{s:4:\"name\";s:21:\"field_formatter_class\";s:4:\"info\";a:6:{s:4:\"name\";s:21:\"Field Formatter Class\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:21:\"field_formatter_class\";s:9:\"datestamp\";s:10:\"1361374877\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1361374877\";s:8:\"includes\";a:1:{s:21:\"field_formatter_class\";s:21:\"Field Formatter Class\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:24:\"field_formatter_settings\";a:8:{s:4:\"name\";s:24:\"field_formatter_settings\";s:4:\"info\";a:6:{s:4:\"name\";s:28:\"Field formatter settings API\";s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:24:\"field_formatter_settings\";s:9:\"datestamp\";s:10:\"1378741903\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1378741903\";s:8:\"includes\";a:1:{s:24:\"field_formatter_settings\";s:28:\"Field formatter settings API\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:11:\"field_group\";a:8:{s:4:\"name\";s:11:\"field_group\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Field Group\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:11:\"field_group\";s:9:\"datestamp\";s:10:\"1452033709\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1452033709\";s:8:\"includes\";a:1:{s:11:\"field_group\";s:11:\"Field Group\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:15:\"field_slideshow\";a:8:{s:4:\"name\";s:15:\"field_slideshow\";s:4:\"info\";a:6:{s:4:\"name\";s:15:\"Field Slideshow\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:8:\"7.x-1.82\";s:7:\"project\";s:15:\"field_slideshow\";s:9:\"datestamp\";s:10:\"1363270823\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1363270823\";s:8:\"includes\";a:1:{s:15:\"field_slideshow\";s:15:\"Field Slideshow\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:8:\"fivestar\";a:8:{s:4:\"name\";s:8:\"fivestar\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Fivestar\";s:7:\"package\";s:6:\"Voting\";s:7:\"version\";s:7:\"7.x-2.1\";s:7:\"project\";s:8:\"fivestar\";s:9:\"datestamp\";s:10:\"1395087839\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1395087839\";s:8:\"includes\";a:1:{s:8:\"fivestar\";s:8:\"Fivestar\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:10:\"flexslider\";a:8:{s:4:\"name\";s:10:\"flexslider\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"FlexSlider\";s:7:\"package\";s:10:\"FlexSlider\";s:7:\"version\";s:11:\"7.x-2.0-rc1\";s:7:\"project\";s:10:\"flexslider\";s:9:\"datestamp\";s:10:\"1438285141\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1438285141\";s:8:\"includes\";a:2:{s:10:\"flexslider\";s:10:\"FlexSlider\";s:17:\"flexslider_fields\";s:17:\"FlexSlider Fields\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:4:\"icon\";a:8:{s:4:\"name\";s:4:\"icon\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Icon API\";s:7:\"package\";s:8:\"Icon API\";s:7:\"version\";s:13:\"7.x-1.0-beta6\";s:7:\"project\";s:4:\"icon\";s:9:\"datestamp\";s:10:\"1438832040\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1438832040\";s:8:\"includes\";a:2:{s:4:\"icon\";s:8:\"Icon API\";s:10:\"icon_field\";s:15:\"Icon API: Field\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:20:\"image_link_formatter\";a:8:{s:4:\"name\";s:20:\"image_link_formatter\";s:4:\"info\";a:6:{s:4:\"name\";s:20:\"Image Link Formatter\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-1.0\";s:7:\"project\";s:20:\"image_link_formatter\";s:9:\"datestamp\";s:10:\"1355914053\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1355914053\";s:8:\"includes\";a:1:{s:20:\"image_link_formatter\";s:20:\"Image Link Formatter\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:4:\"imce\";a:8:{s:4:\"name\";s:4:\"imce\";s:4:\"info\";a:6:{s:4:\"name\";s:4:\"IMCE\";s:7:\"package\";s:5:\"Media\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:4:\"imce\";s:9:\"datestamp\";s:10:\"1400275428\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1400275428\";s:8:\"includes\";a:1:{s:4:\"imce\";s:4:\"IMCE\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:18:\"inline_entity_form\";a:8:{s:4:\"name\";s:18:\"inline_entity_form\";s:4:\"info\";a:6:{s:4:\"name\";s:18:\"Inline Entity Form\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:18:\"inline_entity_form\";s:9:\"datestamp\";s:10:\"1434553381\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1434553381\";s:8:\"includes\";a:1:{s:18:\"inline_entity_form\";s:18:\"Inline Entity Form\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:9:\"jcarousel\";a:8:{s:4:\"name\";s:9:\"jcarousel\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"jCarousel\";s:7:\"package\";s:14:\"User interface\";s:7:\"version\";s:7:\"7.x-2.7\";s:7:\"project\";s:9:\"jcarousel\";s:9:\"datestamp\";s:10:\"1420460282\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1420460282\";s:8:\"includes\";a:1:{s:9:\"jcarousel\";s:9:\"jCarousel\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:13:\"jquery_update\";a:8:{s:4:\"name\";s:13:\"jquery_update\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"jQuery Update\";s:7:\"package\";s:14:\"User interface\";s:7:\"version\";s:7:\"7.x-2.7\";s:7:\"project\";s:13:\"jquery_update\";s:9:\"datestamp\";s:10:\"1445379855\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1445379855\";s:8:\"includes\";a:1:{s:13:\"jquery_update\";s:13:\"jQuery Update\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:9:\"libraries\";a:8:{s:4:\"name\";s:9:\"libraries\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"Libraries\";s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:9:\"libraries\";s:9:\"datestamp\";s:10:\"1391965716\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1391965716\";s:8:\"includes\";a:1:{s:9:\"libraries\";s:9:\"Libraries\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:4:\"link\";a:8:{s:4:\"name\";s:4:\"link\";s:4:\"info\";a:6:{s:4:\"name\";s:4:\"Link\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:4:\"link\";s:9:\"datestamp\";s:10:\"1413924830\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1413924830\";s:8:\"includes\";a:1:{s:4:\"link\";s:4:\"Link\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:17:\"menu_descriptions\";a:8:{s:4:\"name\";s:17:\"menu_descriptions\";s:4:\"info\";a:6:{s:4:\"name\";s:17:\"Menu Descriptions\";s:7:\"package\";s:14:\"User interface\";s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:17:\"menu_descriptions\";s:9:\"datestamp\";s:10:\"1415818689\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1415818689\";s:8:\"includes\";a:1:{s:17:\"menu_descriptions\";s:17:\"Menu Descriptions\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:10:\"menu_token\";a:8:{s:4:\"name\";s:10:\"menu_token\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"Menu Token\";s:7:\"version\";s:13:\"7.x-1.0-beta5\";s:7:\"project\";s:10:\"menu_token\";s:9:\"datestamp\";s:10:\"1371232255\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1371232255\";s:8:\"includes\";a:1:{s:10:\"menu_token\";s:10:\"Menu Token\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:13:\"module_filter\";a:8:{s:4:\"name\";s:13:\"module_filter\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Module filter\";s:7:\"package\";s:14:\"Administration\";s:7:\"version\";s:7:\"7.x-2.0\";s:7:\"project\";s:13:\"module_filter\";s:9:\"datestamp\";s:10:\"1424631189\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1424631189\";s:8:\"includes\";a:1:{s:13:\"module_filter\";s:13:\"Module filter\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:10:\"node_class\";a:8:{s:4:\"name\";s:10:\"node_class\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"Node Class\";s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:10:\"node_class\";s:9:\"datestamp\";s:10:\"1388997876\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1388997876\";s:8:\"includes\";a:1:{s:10:\"node_class\";s:10:\"Node Class\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:8:\"pathauto\";a:8:{s:4:\"name\";s:8:\"pathauto\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Pathauto\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:8:\"pathauto\";s:9:\"datestamp\";s:10:\"1344525185\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1344525185\";s:8:\"includes\";a:1:{s:8:\"pathauto\";s:8:\"Pathauto\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:13:\"recently_read\";a:8:{s:4:\"name\";s:13:\"recently_read\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Recently read\";s:7:\"package\";s:5:\"Other\";s:7:\"version\";s:7:\"7.x-3.1\";s:7:\"project\";s:13:\"recently_read\";s:9:\"datestamp\";s:10:\"1409150634\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1409150634\";s:8:\"includes\";a:1:{s:13:\"recently_read\";s:13:\"Recently read\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:5:\"rules\";a:8:{s:4:\"name\";s:5:\"rules\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Rules\";s:7:\"package\";s:5:\"Rules\";s:7:\"version\";s:7:\"7.x-2.9\";s:7:\"project\";s:5:\"rules\";s:9:\"datestamp\";s:10:\"1426527210\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1426527210\";s:8:\"includes\";a:2:{s:5:\"rules\";s:5:\"Rules\";s:11:\"rules_admin\";s:8:\"Rules UI\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:10:\"search_api\";a:8:{s:4:\"name\";s:10:\"search_api\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"Search API\";s:7:\"package\";s:6:\"Search\";s:7:\"version\";s:8:\"7.x-1.21\";s:7:\"project\";s:10:\"search_api\";s:9:\"datestamp\";s:10:\"1487844493\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1487844493\";s:8:\"includes\";a:3:{s:10:\"search_api\";s:10:\"Search API\";s:19:\"search_api_facetapi\";s:13:\"Search facets\";s:16:\"search_api_views\";s:12:\"Search views\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:13:\"search_api_db\";a:8:{s:4:\"name\";s:13:\"search_api_db\";s:4:\"info\";a:6:{s:4:\"name\";s:15:\"Database search\";s:7:\"package\";s:6:\"Search\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:13:\"search_api_db\";s:9:\"datestamp\";s:10:\"1440962643\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1440962643\";s:8:\"includes\";a:1:{s:13:\"search_api_db\";s:15:\"Database search\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:17:\"search_api_ranges\";a:8:{s:4:\"name\";s:17:\"search_api_ranges\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Search ranges\";s:7:\"package\";s:6:\"Search\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:17:\"search_api_ranges\";s:9:\"datestamp\";s:10:\"1392554914\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1392554914\";s:8:\"includes\";a:1:{s:17:\"search_api_ranges\";s:13:\"Search ranges\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:16:\"search_api_sorts\";a:8:{s:4:\"name\";s:16:\"search_api_sorts\";s:4:\"info\";a:6:{s:4:\"name\";s:16:\"Search API sorts\";s:7:\"package\";s:6:\"Search\";s:7:\"version\";s:7:\"7.x-1.7\";s:7:\"project\";s:16:\"search_api_sorts\";s:9:\"datestamp\";s:10:\"1487095386\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1487095386\";s:8:\"includes\";a:1:{s:16:\"search_api_sorts\";s:16:\"Search API sorts\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:15:\"select_or_other\";a:8:{s:4:\"name\";s:15:\"select_or_other\";s:4:\"info\";a:6:{s:4:\"name\";s:17:\"Select (or other)\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:8:\"7.x-2.22\";s:7:\"project\";s:15:\"select_or_other\";s:9:\"datestamp\";s:10:\"1432142587\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1432142587\";s:8:\"includes\";a:1:{s:15:\"select_or_other\";s:17:\"Select (or other)\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:11:\"session_api\";a:8:{s:4:\"name\";s:11:\"session_api\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Session API\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:7:\"project\";s:11:\"session_api\";s:9:\"datestamp\";s:10:\"1354234727\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1354234727\";s:8:\"includes\";a:1:{s:11:\"session_api\";s:11:\"Session API\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:10:\"simplenews\";a:8:{s:4:\"name\";s:10:\"simplenews\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"Simplenews\";s:7:\"package\";s:4:\"Mail\";s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:10:\"simplenews\";s:9:\"datestamp\";s:10:\"1381947969\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1381947969\";s:8:\"includes\";a:1:{s:10:\"simplenews\";s:10:\"Simplenews\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:9:\"tagclouds\";a:8:{s:4:\"name\";s:9:\"tagclouds\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"TagClouds\";s:7:\"package\";s:8:\"Taxonomy\";s:7:\"version\";s:8:\"7.x-1.10\";s:7:\"project\";s:9:\"tagclouds\";s:9:\"datestamp\";s:10:\"1404152332\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1404152332\";s:8:\"includes\";a:1:{s:9:\"tagclouds\";s:9:\"TagClouds\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:13:\"taxonomy_menu\";a:8:{s:4:\"name\";s:13:\"taxonomy_menu\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Taxonomy menu\";s:7:\"package\";s:13:\"Taxonomy menu\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:13:\"taxonomy_menu\";s:9:\"datestamp\";s:10:\"1396359247\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1396359247\";s:8:\"includes\";a:1:{s:13:\"taxonomy_menu\";s:13:\"Taxonomy menu\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:11:\"tb_megamenu\";a:8:{s:4:\"name\";s:11:\"tb_megamenu\";s:4:\"info\";a:6:{s:4:\"name\";s:12:\"TB Mega Menu\";s:7:\"package\";s:4:\"Menu\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:7:\"project\";s:11:\"tb_megamenu\";s:9:\"datestamp\";s:10:\"1440756596\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1440756596\";s:8:\"includes\";a:1:{s:11:\"tb_megamenu\";s:12:\"TB Mega Menu\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:5:\"title\";a:8:{s:4:\"name\";s:5:\"title\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Title\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:14:\"7.x-1.0-alpha9\";s:7:\"project\";s:5:\"title\";s:9:\"datestamp\";s:10:\"1484302985\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1484302985\";s:8:\"includes\";a:1:{s:5:\"title\";s:5:\"Title\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:5:\"token\";a:8:{s:4:\"name\";s:5:\"token\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Token\";s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:5:\"token\";s:9:\"datestamp\";s:10:\"1425149060\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1425149060\";s:8:\"includes\";a:1:{s:5:\"token\";s:5:\"Token\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:5:\"views\";a:8:{s:4:\"name\";s:5:\"views\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Views\";s:7:\"package\";s:5:\"Views\";s:7:\"version\";s:8:\"7.x-3.16\";s:7:\"project\";s:5:\"views\";s:9:\"datestamp\";s:10:\"1491158591\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1491158591\";s:8:\"includes\";a:2:{s:5:\"views\";s:5:\"Views\";s:8:\"views_ui\";s:8:\"Views UI\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:15:\"views_bootstrap\";a:8:{s:4:\"name\";s:15:\"views_bootstrap\";s:4:\"info\";a:6:{s:4:\"name\";s:15:\"Views Bootstrap\";s:7:\"package\";s:5:\"Views\";s:7:\"version\";s:7:\"7.x-3.1\";s:7:\"project\";s:15:\"views_bootstrap\";s:9:\"datestamp\";s:10:\"1398607429\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1398607429\";s:8:\"includes\";a:1:{s:15:\"views_bootstrap\";s:15:\"Views Bootstrap\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:16:\"views_field_view\";a:8:{s:4:\"name\";s:16:\"views_field_view\";s:4:\"info\";a:6:{s:4:\"name\";s:16:\"Views Field View\";s:7:\"package\";s:5:\"Views\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:16:\"views_field_view\";s:9:\"datestamp\";s:10:\"1442561052\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1442561052\";s:8:\"includes\";a:1:{s:16:\"views_field_view\";s:16:\"Views Field View\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:15:\"views_fieldsets\";a:8:{s:4:\"name\";s:15:\"views_fieldsets\";s:4:\"info\";a:6:{s:4:\"name\";s:15:\"Views fieldsets\";s:7:\"package\";s:5:\"Views\";s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:15:\"views_fieldsets\";s:9:\"datestamp\";s:10:\"1425515886\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1425515886\";s:8:\"includes\";a:1:{s:15:\"views_fieldsets\";s:15:\"Views fieldsets\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:15:\"views_slideshow\";a:8:{s:4:\"name\";s:15:\"views_slideshow\";s:4:\"info\";a:6:{s:4:\"name\";s:15:\"Views Slideshow\";s:7:\"package\";s:5:\"Views\";s:7:\"version\";s:7:\"7.x-3.1\";s:7:\"project\";s:15:\"views_slideshow\";s:9:\"datestamp\";s:10:\"1382584826\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1382584826\";s:8:\"includes\";a:2:{s:15:\"views_slideshow\";s:15:\"Views Slideshow\";s:21:\"views_slideshow_cycle\";s:22:\"Views Slideshow: Cycle\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:9:\"votingapi\";a:8:{s:4:\"name\";s:9:\"votingapi\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"Voting API\";s:7:\"package\";s:6:\"Voting\";s:7:\"version\";s:8:\"7.x-2.12\";s:7:\"project\";s:9:\"votingapi\";s:9:\"datestamp\";s:10:\"1407995929\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1407995929\";s:8:\"includes\";a:1:{s:9:\"votingapi\";s:10:\"Voting API\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:20:\"we_content_migration\";a:8:{s:4:\"name\";s:20:\"we_content_migration\";s:4:\"info\";a:6:{s:4:\"name\";s:17:\"Content Migration\";s:7:\"package\";s:17:\"Content Migration\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:7:\"project\";s:20:\"we_content_migration\";s:9:\"datestamp\";s:10:\"1499677744\";s:16:\"_info_file_ctime\";i:1499933737;}s:9:\"datestamp\";s:10:\"1499677744\";s:8:\"includes\";a:1:{s:20:\"we_content_migration\";s:17:\"Content Migration\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:7:\"webform\";a:8:{s:4:\"name\";s:7:\"webform\";s:4:\"info\";a:6:{s:4:\"name\";s:7:\"Webform\";s:7:\"package\";s:7:\"Webform\";s:7:\"version\";s:8:\"7.x-4.11\";s:7:\"project\";s:7:\"webform\";s:9:\"datestamp\";s:10:\"1442953145\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1442953145\";s:8:\"includes\";a:1:{s:7:\"webform\";s:7:\"Webform\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:6:\"weight\";a:8:{s:4:\"name\";s:6:\"weight\";s:4:\"info\";a:6:{s:4:\"name\";s:6:\"Weight\";s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:6:\"weight\";s:9:\"datestamp\";s:10:\"1430342647\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1430342647\";s:8:\"includes\";a:1:{s:6:\"weight\";s:6:\"Weight\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}}',1500364898,1500361298,1);
/*!40000 ALTER TABLE `cache_update` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_views`
--

DROP TABLE IF EXISTS `cache_views`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_views` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Generic cache table for caching things not separated out...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_views`
--

LOCK TABLES `cache_views` WRITE;
/*!40000 ALTER TABLE `cache_views` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_views` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_views_data`
--

DROP TABLE IF EXISTS `cache_views_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_views_data` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '1' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for views to store pre-rendered queries,...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_views_data`
--

LOCK TABLES `cache_views_data` WRITE;
/*!40000 ALTER TABLE `cache_views_data` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_views_data` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `ckeditor_input_format`
--

DROP TABLE IF EXISTS `ckeditor_input_format`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ckeditor_input_format` (
  `name` varchar(128) NOT NULL DEFAULT '' COMMENT 'Name of the CKEditor role',
  `format` varchar(128) NOT NULL DEFAULT '' COMMENT 'Drupal filter format ID',
  PRIMARY KEY (`name`,`format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores CKEditor input format assignments';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ckeditor_input_format`
--

LOCK TABLES `ckeditor_input_format` WRITE;
/*!40000 ALTER TABLE `ckeditor_input_format` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `ckeditor_input_format` VALUES ('Advanced','filtered_html'),('Full','full_html');
/*!40000 ALTER TABLE `ckeditor_input_format` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `ckeditor_settings`
--

DROP TABLE IF EXISTS `ckeditor_settings`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ckeditor_settings` (
  `name` varchar(128) NOT NULL DEFAULT '' COMMENT 'Name of the CKEditor profile',
  `settings` text COMMENT 'Profile settings',
  PRIMARY KEY (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores CKEditor profile settings';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ckeditor_settings`
--

LOCK TABLES `ckeditor_settings` WRITE;
/*!40000 ALTER TABLE `ckeditor_settings` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `ckeditor_settings` VALUES ('Advanced','a:33:{s:2:\"ss\";s:1:\"2\";s:7:\"toolbar\";s:595:\"[\n    [\'Source\'],\n    [\'Cut\',\'Copy\',\'Paste\',\'PasteText\',\'PasteFromWord\',\'-\',\'SpellChecker\', \'Scayt\'],\n    [\'Undo\',\'Redo\',\'Find\',\'Replace\',\'-\',\'SelectAll\'],\n    [\'Image\',\'Media\',\'Flash\',\'Table\',\'HorizontalRule\',\'Smiley\',\'SpecialChar\'],\n    [\'Maximize\', \'ShowBlocks\'],\n    \'/\',\n    [\'Format\'],\n    [\'Bold\',\'Italic\',\'Underline\',\'Strike\',\'-\',\'Subscript\',\'Superscript\',\'-\',\'RemoveFormat\'],\n    [\'NumberedList\',\'BulletedList\',\'-\',\'Outdent\',\'Indent\',\'Blockquote\'],\n    [\'JustifyLeft\',\'JustifyCenter\',\'JustifyRight\',\'JustifyBlock\',\'-\',\'BidiLtr\',\'BidiRtl\'],\n    [\'Link\',\'Unlink\',\'Anchor\',\'Linkit\']\n]\n    \";s:6:\"expand\";s:1:\"t\";s:7:\"default\";s:1:\"t\";s:11:\"show_toggle\";s:1:\"t\";s:7:\"uicolor\";s:7:\"default\";s:12:\"uicolor_user\";s:7:\"default\";s:5:\"width\";s:4:\"100%\";s:4:\"lang\";s:2:\"en\";s:9:\"auto_lang\";s:1:\"t\";s:18:\"language_direction\";s:7:\"default\";s:15:\"allowed_content\";s:1:\"t\";s:19:\"extraAllowedContent\";s:0:\"\";s:10:\"enter_mode\";s:1:\"p\";s:16:\"shift_enter_mode\";s:2:\"br\";s:11:\"font_format\";s:35:\"p;div;pre;address;h1;h2;h3;h4;h5;h6\";s:17:\"custom_formatting\";s:1:\"f\";s:10:\"formatting\";a:1:{s:25:\"custom_formatting_options\";a:6:{s:6:\"indent\";s:6:\"indent\";s:15:\"breakBeforeOpen\";s:15:\"breakBeforeOpen\";s:14:\"breakAfterOpen\";s:14:\"breakAfterOpen\";s:15:\"breakAfterClose\";s:15:\"breakAfterClose\";s:16:\"breakBeforeClose\";i:0;s:10:\"pre_indent\";i:0;}}s:8:\"css_mode\";s:4:\"none\";s:8:\"css_path\";s:0:\"\";s:9:\"css_style\";s:5:\"theme\";s:11:\"styles_path\";s:0:\"\";s:11:\"filebrowser\";s:4:\"imce\";s:17:\"filebrowser_image\";s:4:\"imce\";s:17:\"filebrowser_flash\";s:4:\"imce\";s:13:\"UserFilesPath\";s:5:\"%b%f/\";s:21:\"UserFilesAbsolutePath\";s:7:\"%d%b%f/\";s:21:\"forcePasteAsPlainText\";s:1:\"f\";s:13:\"html_entities\";s:1:\"f\";s:17:\"scayt_autoStartup\";s:1:\"f\";s:15:\"theme_config_js\";s:1:\"f\";s:7:\"js_conf\";s:0:\"\";s:11:\"loadPlugins\";a:2:{s:12:\"drupalbreaks\";a:5:{s:4:\"name\";s:12:\"drupalbreaks\";s:4:\"desc\";s:51:\"Plugin for inserting Drupal teaser and page breaks.\";s:4:\"path\";s:25:\"%plugin_dir%drupalbreaks/\";s:7:\"buttons\";a:1:{s:11:\"DrupalBreak\";a:2:{s:5:\"label\";s:11:\"DrupalBreak\";s:4:\"icon\";s:22:\"images/drupalbreak.png\";}}s:7:\"default\";s:1:\"t\";}s:11:\"tableresize\";a:5:{s:4:\"name\";s:11:\"tableresize\";s:4:\"desc\";s:105:\"Table Resize plugin. See <a href=\"http://ckeditor.com/addon/tableresize\">addon page</a> for more details.\";s:4:\"path\";s:54:\"//cdn.ckeditor.com/4.4.3/full-all/plugins/tableresize/\";s:7:\"buttons\";b:0;s:7:\"default\";s:1:\"t\";}}}'),('CKEditor Global Profile','a:1:{s:13:\"ckeditor_path\";s:33:\"//cdn.ckeditor.com/4.4.3/full-all\";}'),('Full','a:33:{s:2:\"ss\";s:1:\"2\";s:7:\"toolbar\";s:708:\"[\n    [\'Source\'],\n    [\'Cut\',\'Copy\',\'Paste\',\'PasteText\',\'PasteFromWord\',\'-\',\'SpellChecker\', \'Scayt\'],\n    [\'Undo\',\'Redo\',\'Find\',\'Replace\',\'-\',\'SelectAll\'],\n    [\'Image\',\'Media\',\'Flash\',\'Table\',\'HorizontalRule\',\'Smiley\',\'SpecialChar\',\'Iframe\'],\n    \'/\',\n    [\'Bold\',\'Italic\',\'Underline\',\'Strike\',\'-\',\'Subscript\',\'Superscript\',\'-\',\'RemoveFormat\'],\n    [\'NumberedList\',\'BulletedList\',\'-\',\'Outdent\',\'Indent\',\'Blockquote\',\'CreateDiv\'],\n    [\'JustifyLeft\',\'JustifyCenter\',\'JustifyRight\',\'JustifyBlock\',\'-\',\'BidiLtr\',\'BidiRtl\',\'-\',\'Language\'],\n    [\'Link\',\'Unlink\',\'Anchor\',\'Linkit\'],\n    [\'DrupalBreak\'],\n    \'/\',\n    [\'Format\',\'Font\',\'FontSize\'],\n    [\'TextColor\',\'BGColor\'],\n    [\'Maximize\', \'ShowBlocks\']\n]\n    \";s:6:\"expand\";s:1:\"t\";s:7:\"default\";s:1:\"t\";s:11:\"show_toggle\";s:1:\"t\";s:7:\"uicolor\";s:7:\"default\";s:12:\"uicolor_user\";s:7:\"default\";s:5:\"width\";s:4:\"100%\";s:4:\"lang\";s:2:\"en\";s:9:\"auto_lang\";s:1:\"t\";s:18:\"language_direction\";s:7:\"default\";s:15:\"allowed_content\";s:1:\"t\";s:19:\"extraAllowedContent\";s:0:\"\";s:10:\"enter_mode\";s:1:\"p\";s:16:\"shift_enter_mode\";s:2:\"br\";s:11:\"font_format\";s:35:\"p;div;pre;address;h1;h2;h3;h4;h5;h6\";s:17:\"custom_formatting\";s:1:\"f\";s:10:\"formatting\";a:1:{s:25:\"custom_formatting_options\";a:6:{s:6:\"indent\";s:6:\"indent\";s:15:\"breakBeforeOpen\";s:15:\"breakBeforeOpen\";s:14:\"breakAfterOpen\";s:14:\"breakAfterOpen\";s:15:\"breakAfterClose\";s:15:\"breakAfterClose\";s:16:\"breakBeforeClose\";i:0;s:10:\"pre_indent\";i:0;}}s:8:\"css_mode\";s:4:\"none\";s:8:\"css_path\";s:0:\"\";s:9:\"css_style\";s:5:\"theme\";s:11:\"styles_path\";s:0:\"\";s:11:\"filebrowser\";s:4:\"imce\";s:17:\"filebrowser_image\";s:4:\"imce\";s:17:\"filebrowser_flash\";s:4:\"imce\";s:13:\"UserFilesPath\";s:5:\"%b%f/\";s:21:\"UserFilesAbsolutePath\";s:7:\"%d%b%f/\";s:21:\"forcePasteAsPlainText\";s:1:\"f\";s:13:\"html_entities\";s:1:\"f\";s:17:\"scayt_autoStartup\";s:1:\"f\";s:15:\"theme_config_js\";s:1:\"f\";s:7:\"js_conf\";s:29:\"config.allowedContent = true;\";s:11:\"loadPlugins\";a:2:{s:12:\"drupalbreaks\";a:5:{s:4:\"name\";s:12:\"drupalbreaks\";s:4:\"desc\";s:51:\"Plugin for inserting Drupal teaser and page breaks.\";s:4:\"path\";s:25:\"%plugin_dir%drupalbreaks/\";s:7:\"buttons\";a:1:{s:11:\"DrupalBreak\";a:2:{s:5:\"label\";s:11:\"DrupalBreak\";s:4:\"icon\";s:22:\"images/drupalbreak.png\";}}s:7:\"default\";s:1:\"t\";}s:11:\"tableresize\";a:5:{s:4:\"name\";s:11:\"tableresize\";s:4:\"desc\";s:105:\"Table Resize plugin. See <a href=\"http://ckeditor.com/addon/tableresize\">addon page</a> for more details.\";s:4:\"path\";s:54:\"//cdn.ckeditor.com/4.4.3/full-all/plugins/tableresize/\";s:7:\"buttons\";b:0;s:7:\"default\";s:1:\"t\";}}}');
/*!40000 ALTER TABLE `ckeditor_settings` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `comment`
--

DROP TABLE IF EXISTS `comment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `comment` (
  `cid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique comment ID.',
  `pid` int(11) NOT NULL DEFAULT '0' COMMENT 'The comment.cid to which this comment is a reply. If set to 0, this comment is not a reply to an existing comment.',
  `nid` int(11) NOT NULL DEFAULT '0' COMMENT 'The node.nid to which this comment is a reply.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid who authored the comment. If set to 0, this comment was created by an anonymous user.',
  `subject` varchar(64) NOT NULL DEFAULT '' COMMENT 'The comment title.',
  `hostname` varchar(128) NOT NULL DEFAULT '' COMMENT 'The author’s host name.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The time that the comment was created, as a Unix timestamp.',
  `changed` int(11) NOT NULL DEFAULT '0' COMMENT 'The time that the comment was last edited, as a Unix timestamp.',
  `status` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT 'The published status of a comment. (0 = Not Published, 1 = Published)',
  `thread` varchar(255) NOT NULL COMMENT 'The vancode representation of the comment’s place in a thread.',
  `name` varchar(60) DEFAULT NULL COMMENT 'The comment author’s name. Uses users.name if the user is logged in, otherwise uses the value typed into the comment form.',
  `mail` varchar(64) DEFAULT NULL COMMENT 'The comment author’s e-mail address from the comment form, if user is anonymous, and the ’Anonymous users may/must leave their contact information’ setting is turned on.',
  `homepage` varchar(255) DEFAULT NULL COMMENT 'The comment author’s home page address from the comment form, if user is anonymous, and the ’Anonymous users may/must leave their contact information’ setting is turned on.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'The languages.language of this comment.',
  PRIMARY KEY (`cid`),
  KEY `comment_status_pid` (`pid`,`status`),
  KEY `comment_num_new` (`nid`,`status`,`created`,`cid`,`thread`),
  KEY `comment_uid` (`uid`),
  KEY `comment_nid_language` (`nid`,`language`),
  KEY `comment_created` (`created`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COMMENT='Stores comments and associated data.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `comment`
--

LOCK TABLES `comment` WRITE;
/*!40000 ALTER TABLE `comment` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `comment` VALUES (2,0,52,1,'Lorem ipsum dolor sit amet, consectetur adipiscing elit','::1',1418109735,1418109733,1,'01/','admin','','','und');
/*!40000 ALTER TABLE `comment` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `commerce_calculated_price`
--

DROP TABLE IF EXISTS `commerce_calculated_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commerce_calculated_price` (
  `module` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the module performing the calculation.',
  `module_key` mediumtext NOT NULL COMMENT 'A module specific key useful for indicating the context of a particular calculation, e.g. the IDs of Rules evaluated to produce the calculated price.',
  `entity_type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The type of entity this price belongs to.',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The entity ID of the object this price belongs to.',
  `field_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'The name of the field the calculated price relates to.',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The languages.language of the entity.',
  `delta` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The sequence number for this data item, used for multi-value fields',
  `amount` int(11) NOT NULL DEFAULT '0' COMMENT 'The price amount.',
  `currency_code` varchar(32) NOT NULL COMMENT 'The currency code for the price.',
  `data` longtext COMMENT 'A serialized array of additional price data.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the price was calculated.',
  KEY `module` (`module`),
  KEY `entity_type` (`entity_type`),
  KEY `entity_id` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores pre-calculated dynamic prices.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commerce_calculated_price`
--

LOCK TABLES `commerce_calculated_price` WRITE;
/*!40000 ALTER TABLE `commerce_calculated_price` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `commerce_calculated_price` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `commerce_checkout_pane`
--

DROP TABLE IF EXISTS `commerce_checkout_pane`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commerce_checkout_pane` (
  `pane_id` varchar(255) NOT NULL COMMENT 'The machine readable name of the order state.',
  `page` varchar(255) NOT NULL DEFAULT '1' COMMENT 'The ID of the checkout page on which this pane appears.',
  `fieldset` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'Boolean value indicating whether or not the pane should appear in a fieldset.',
  `collapsible` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean value indicating whether or not the pane should appear collapsed.',
  `collapsed` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean value indicating whether or not the pane should appear collapsed.',
  `weight` smallint(6) NOT NULL DEFAULT '0' COMMENT 'The sorting weight of the status for lists of statuses.',
  `enabled` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'Boolean value indicating whether or not the pane is enabled.',
  `review` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'Boolean value indicating whether or not the pane should appear on the checkout review.',
  PRIMARY KEY (`pane_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Checkout pane configuration data.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commerce_checkout_pane`
--

LOCK TABLES `commerce_checkout_pane` WRITE;
/*!40000 ALTER TABLE `commerce_checkout_pane` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `commerce_checkout_pane` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `commerce_custom_offline_payment`
--

DROP TABLE IF EXISTS `commerce_custom_offline_payment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commerce_custom_offline_payment` (
  `id` varchar(32) NOT NULL DEFAULT '' COMMENT 'Machine name of payment',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Payment title',
  `description` text COMMENT 'Description for the payment method.',
  `information` longtext COMMENT 'Default information for the payment method.',
  `format` varchar(255) DEFAULT NULL COMMENT 'The filter_format.format of the payment information.',
  `status` tinyint(4) NOT NULL DEFAULT '0',
  `checkout` tinyint(4) NOT NULL DEFAULT '1',
  `terminal` tinyint(4) NOT NULL DEFAULT '1',
  `fieldable` tinyint(4) NOT NULL DEFAULT '0',
  UNIQUE KEY `machine name` (`id`),
  KEY `permission` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Custom offline payments methods for Drupal Commerce';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commerce_custom_offline_payment`
--

LOCK TABLES `commerce_custom_offline_payment` WRITE;
/*!40000 ALTER TABLE `commerce_custom_offline_payment` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `commerce_custom_offline_payment` VALUES ('bank_transfer','Bank Transfer','Receive direct money transfers initiated by the customer to your bank account.','<p>\n        <strong>Please make payment to:</strong><br />\n        Account owner: <br />\n        Account number: <br />\n        IBAN: <br />\n        Bank code: <br />\n        SWIFT: <br />\n        Banking institution: <br />\n        Branch office: <br />\n        <br />\n        Payment instructions: <br />\n        </p>','filtered_html',1,1,1,1),('commerce_cod','Cash on Delivery','Collect the payment on products delivery.','Pay when you receive order products.','plain_text',1,1,1,1);
/*!40000 ALTER TABLE `commerce_custom_offline_payment` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `commerce_customer_profile`
--

DROP TABLE IF EXISTS `commerce_customer_profile`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commerce_customer_profile` (
  `profile_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a customer profile.',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The current commerce_customer_profile_revision.revision_id version identifier.',
  `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The commerce_customer_profile_type.type of this profile.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that this profile belongs to.',
  `status` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the profile is active or not.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the profile was created.',
  `changed` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the profile was most recently saved.',
  `data` longblob COMMENT 'A serialized array of additional data.',
  PRIMARY KEY (`profile_id`),
  UNIQUE KEY `revision_id` (`revision_id`),
  KEY `uid` (`uid`),
  KEY `customer_profile_type` (`type`),
  KEY `uid_by_type` (`uid`,`type`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8 COMMENT='The base table for customer profiles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commerce_customer_profile`
--

LOCK TABLES `commerce_customer_profile` WRITE;
/*!40000 ALTER TABLE `commerce_customer_profile` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `commerce_customer_profile` VALUES (1,1,'shipping',15,1,1418033754,1418033754,NULL),(2,2,'billing',15,1,1418033754,1418033754,NULL),(3,3,'shipping',15,1,1418093532,1418093532,NULL),(4,4,'billing',15,1,1418093532,1418093532,NULL),(5,5,'shipping',1,1,1419304221,1419304239,NULL),(6,6,'billing',1,1,1419304239,1419304239,NULL);
/*!40000 ALTER TABLE `commerce_customer_profile` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `commerce_customer_profile_revision`
--

DROP TABLE IF EXISTS `commerce_customer_profile_revision`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commerce_customer_profile_revision` (
  `profile_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The commerce_customer_profile.customer_id of the profile this revision belongs to.',
  `revision_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for this revision.',
  `revision_uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that created this profile at this revision.',
  `status` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the profile is active or not.',
  `log` longtext NOT NULL COMMENT 'The log entry explaining the changes in this version.',
  `revision_timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when this revision was created.',
  `data` longblob COMMENT 'A serialized array of additional data.',
  PRIMARY KEY (`revision_id`),
  KEY `profile_id` (`profile_id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8 COMMENT='Saves information about each saved revision of a commerce...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commerce_customer_profile_revision`
--

LOCK TABLES `commerce_customer_profile_revision` WRITE;
/*!40000 ALTER TABLE `commerce_customer_profile_revision` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `commerce_customer_profile_revision` VALUES (1,1,15,1,'',1418033754,NULL),(2,2,15,1,'',1418033754,NULL),(3,3,15,1,'',1418093532,NULL),(4,4,15,1,'',1418093532,NULL),(5,5,1,1,'',1419304239,NULL),(6,6,1,1,'',1419304239,NULL);
/*!40000 ALTER TABLE `commerce_customer_profile_revision` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `commerce_flat_rate_service`
--

DROP TABLE IF EXISTS `commerce_flat_rate_service`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commerce_flat_rate_service` (
  `name` varchar(32) NOT NULL DEFAULT '' COMMENT 'The machine-name of the flat rate service.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The human-readable title of the flat rate service.',
  `display_title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title of the flat rate service displayed to customers.',
  `description` mediumtext NOT NULL COMMENT 'A brief description of the flat rate service.',
  `rules_component` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether or not this service should have a default Rules component for enabling it for orders.',
  `amount` int(11) NOT NULL DEFAULT '0' COMMENT 'The amount of the base rate of the service.',
  `currency_code` varchar(32) NOT NULL COMMENT 'The currency code of the base rate of the service.',
  `data` longtext COMMENT 'A serialized array of additional data.',
  PRIMARY KEY (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores information about shipping services created...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commerce_flat_rate_service`
--

LOCK TABLES `commerce_flat_rate_service` WRITE;
/*!40000 ALTER TABLE `commerce_flat_rate_service` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `commerce_flat_rate_service` VALUES ('free_shipping','Free Shipping','Free Shipping','For order over $50.',1,0,'USD','a:0:{}'),('shipping','Shipping','Normal Shipping','5-8 days',1,1200,'USD','a:0:{}');
/*!40000 ALTER TABLE `commerce_flat_rate_service` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `commerce_line_item`
--

DROP TABLE IF EXISTS `commerce_line_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commerce_line_item` (
  `line_item_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a line item.',
  `order_id` int(11) NOT NULL DEFAULT '0' COMMENT 'The unique ID of the order the line item belongs to.',
  `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The module defined type of this line item.',
  `line_item_label` varchar(255) NOT NULL COMMENT 'The merchant defined label for a line item.',
  `quantity` decimal(10,2) NOT NULL DEFAULT '0.00',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the line item was created.',
  `changed` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the line item was most recently saved.',
  `data` longblob COMMENT 'A serialized array of additional data.',
  PRIMARY KEY (`line_item_id`),
  KEY `order_id` (`order_id`),
  KEY `line_item_type` (`type`)
) ENGINE=InnoDB AUTO_INCREMENT=81 DEFAULT CHARSET=utf8 COMMENT='The base table for line items.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commerce_line_item`
--

LOCK TABLES `commerce_line_item` WRITE;
/*!40000 ALTER TABLE `commerce_line_item` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `commerce_line_item` VALUES (1,4,'product','AP069ELAE8QJVNAMZ-203064',42.00,1416481384,1416563525,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(2,17,'product','AP069ELAE8QJVNAMZ-203064',41.00,1416481384,1416481384,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(3,16,'product','AP069ELAE8QJVNAMZ-203064',1.00,1416481416,1416481416,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(4,18,'product','AP069ELAE8QJVNAMZ-203064',1.00,1416481416,1416481416,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(5,19,'product','product004',1.00,1416551081,1416551081,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:4;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/4\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"4\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(6,21,'product','product004',1.00,1416551081,1416551081,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:4;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/4\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"4\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(7,22,'product','AP069ELAE8QJVNAMZ-203064',1.00,1416559860,1416559860,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(8,23,'product','AP069ELAE8QJVNAMZ-203064',1.00,1416559860,1416559860,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(9,17,'product','AP069ELAE8QJVNAMZ-203064',42.00,1416481384,1416563525,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(10,13,'product','AP069ELAE8QJVNAMZ-203064',1.00,1416563648,1416563648,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(11,24,'product','AP069ELAE8QJVNAMZ-203064',1.00,1416563648,1416563648,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(12,13,'product','AP069ELAE8QJVNAMZ-32423432',1.00,1416797576,1416797576,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:7;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/10\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"10\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(13,24,'product','AP069ELAE8QJVNAMZ-32423432',1.00,1416797576,1416797576,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:7;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/10\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"10\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(14,25,'product','AP069ELAE8QJVNAMZ-203064',2.00,1416798247,1416816593,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(15,26,'product','AP069ELAE8QJVNAMZ-203064',1.00,1416798247,1416798247,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(16,25,'product','AP069ELAE8QJVNAMZ-32423432',1.00,1416798263,1416798263,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:7;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/10\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"10\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(17,26,'product','AP069ELAE8QJVNAMZ-32423432',1.00,1416798263,1416798263,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:7;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/10\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"10\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(18,26,'product','AP069ELAE8QJVNAMZ-203064',2.00,1416798247,1416816593,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(20,29,'product','imac',1.00,1416886760,1416886760,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:8;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/5\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"5\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(21,30,'product','AP069ELAE8QJVNAMZ-203064',1.00,1416887010,1416887010,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(22,31,'product','AP069ELAE8QJVNAMZ-203064',1.00,1416887010,1416887010,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(23,28,'product','AP069ELAE8QJVNAMZ-203064',1.00,1416887094,1416887094,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(24,32,'product','AP069ELAE8QJVNAMZ-203064',1.00,1416887094,1416887094,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(25,34,'product','imac',1.00,1416887793,1416887793,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:8;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/5\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"5\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(26,35,'product','imac',1.00,1416887793,1416887793,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:8;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/5\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"5\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(27,36,'product','imac',2.00,1416887939,1416888026,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:8;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/5\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"5\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(28,37,'product','imac',1.00,1416887939,1416887939,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:8;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/5\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"5\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(29,37,'product','imac',2.00,1416887939,1416888026,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:8;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/5\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"5\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(30,36,'product','AP069ELAE8QJVNAMZ-203064',1.00,1416888097,1416888097,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(31,38,'product','AP069ELAE8QJVNAMZ-203064',1.00,1416888097,1416888097,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(32,39,'product','AP069ELAE8QJVNAMZ-32423432',1.00,1416906023,1416906023,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:7;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/10\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"10\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(33,44,'product','AP069ELAE8QJVNAMZ-32423432',1.00,1416906023,1416906023,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:7;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/10\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"10\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(35,64,'product','AP069ELAE8QJVNAMZ-203064',1.00,1416984754,1416984754,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(36,73,'product','AP069ELAE8QJVNAMZ-203064',1.00,1417155662,1417155662,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(37,74,'product','AP069ELAE8QJVNAMZ-203064',1.00,1417155662,1417155662,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(38,76,'product','AP069ELAE8QJVNAMZ-203064',1.00,1417155865,1417155865,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(39,77,'product','AP069ELAE8QJVNAMZ-203064',1.00,1417155865,1417155865,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(40,83,'product','AP069ELAE8QJVNAMZ-203064',2.00,1417160506,1417171802,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(41,84,'product','AP069ELAE8QJVNAMZ-203064',1.00,1417160506,1417160506,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(42,84,'product','AP069ELAE8QJVNAMZ-203064',2.00,1417160506,1417162502,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(43,84,'product','AP069ELAE8QJVNAMZ-203064',3.00,1417160506,1417164883,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(44,84,'product','AP069ELAE8QJVNAMZ-203064',2.00,1417160506,1417171802,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(45,92,'product','AE217FAAPMF6ANMY-727142',1.00,1417447868,1417447868,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";s:6:\"entity\";s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/30\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"30\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(46,93,'product','AE217FAAPMF6ANMY-727142',1.00,1417447868,1417447868,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";s:6:\"entity\";s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/30\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"30\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(47,109,'product','AP564ELAT12EANMY-913520',1.00,1417592308,1417592308,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:35;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/52\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"52\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(48,111,'product','AP564ELAT12EANMY-913520',1.00,1417592308,1417592308,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:35;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/52\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"52\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(49,115,'product','SA356ELAQRCJANMY-794737',1.00,1417598962,1417598962,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:28;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/45\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"45\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(50,116,'product','SA356ELAQRCJANMY-794737',1.00,1417598962,1417598962,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:28;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/45\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"45\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(52,118,'product','SA356ELAQRCJANMY-794737',1.00,1417663584,1417663584,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:28;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/45\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"45\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(53,121,'product','AP564ELALVSWANMY-592956',1.00,1417667040,1417667040,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:60;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/76\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"76\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(54,122,'product','AP564ELALVSWANMY-592956',1.00,1417667040,1417667040,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:60;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/76\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"76\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(55,120,'product','SA356ELAQRCJANMY-794737',1.00,1417669225,1417669225,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:28;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/45\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"45\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(56,123,'product','SA356ELAQRCJANMY-794737',1.00,1417669225,1417669225,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:28;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/45\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"45\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(57,124,'product','AS575ELAT5HFANMY-920560',1.00,1417676929,1417676929,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:29;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/46\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"46\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(58,125,'product','AS575ELAT5HFANMY-920560',1.00,1417676929,1417676929,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:29;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/46\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"46\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(59,138,'product','AP069ELAE8QJVNAMZ-203064',1.00,1418033542,1418033542,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(60,139,'product','AP069ELAE8QJVNAMZ-203064',1.00,1418033542,1418033542,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:6;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:6:\"node/9\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:1:\"9\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(62,141,'product','AP564ELALVSWANMY-592956',1.00,1418034610,1418034610,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:60;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/76\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"76\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(63,140,'product','AP069ELAE8QJVNAMZ-32423432',2.00,1418036627,1418093449,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:7;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/10\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"10\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(64,142,'product','AP069ELAE8QJVNAMZ-32423432',1.00,1418036627,1418036627,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:7;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/10\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"10\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(65,142,'product','AP069ELAE8QJVNAMZ-32423432',2.00,1418036627,1418093449,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:7;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/10\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"10\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(66,146,'product','AP564ELALVSWANMY-592956',1.00,1418112224,1418112224,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:60;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/76\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"76\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(67,147,'product','AP564ELALVSWANMY-592956',1.00,1418112224,1418112224,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:60;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/76\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"76\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(68,167,'product','SA356ELAQRCJANMY-794737',1.00,1418715353,1418715353,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:28;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/45\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"45\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(69,169,'product','SA356ELAQRCJANMY-794737',1.00,1418715353,1418715353,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:28;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/45\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"45\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(70,189,'product','CH299TBAS06ZANMY-861162',1.00,1418961471,1418961613,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:80;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/97\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"97\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(71,190,'product','CH299TBAS06ZANMY-861162',1.00,1418961471,1418961471,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:80;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/97\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"97\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(72,201,'product','TK512SPALA1FANMY-557274',1.00,1419304163,1419304163,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:82;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:8:\"node/139\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:3:\"139\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(73,202,'product','TK512SPALA1FANMY-557274',1.00,1419304163,1419304163,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:82;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:8:\"node/139\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:3:\"139\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(74,201,'shipping','Normal Shipping',1.00,1419304247,1419304247,'a:2:{s:16:\"shipping_service\";a:14:{s:4:\"name\";s:8:\"shipping\";s:4:\"base\";s:8:\"shipping\";s:13:\"display_title\";s:15:\"Normal Shipping\";s:11:\"description\";s:8:\"5-8 days\";s:15:\"shipping_method\";s:9:\"flat_rate\";s:15:\"rules_component\";b:1;s:15:\"price_component\";s:18:\"flat_rate_shipping\";s:6:\"weight\";i:1;s:9:\"callbacks\";a:4:{s:4:\"rate\";s:37:\"commerce_flat_rate_service_rate_order\";s:12:\"details_form\";s:21:\"shipping_details_form\";s:21:\"details_form_validate\";s:30:\"shipping_details_form_validate\";s:19:\"details_form_submit\";s:28:\"shipping_details_form_submit\";}s:6:\"module\";s:18:\"commerce_flat_rate\";s:5:\"title\";s:8:\"Shipping\";s:9:\"base_rate\";a:3:{s:6:\"amount\";s:4:\"1200\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:4:\"data\";a:0:{}s:10:\"admin_list\";b:1;}s:15:\"service_details\";a:0:{}}'),(75,226,'product','SA356ELAQRCJANMY-794737',1.00,1420434096,1420434096,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:28;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/45\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"45\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(76,230,'product','SA356ELAQRCJANMY-794737',1.00,1420434096,1420434096,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:28;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/45\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"45\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(77,226,'product','CA673ELATEX3ANMY-936277',1.00,1420439764,1420439764,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:73;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/90\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"90\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(78,231,'product','CA673ELATEX3ANMY-936277',1.00,1420439764,1420439764,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:73;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/90\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"90\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(79,250,'product','SA356ELAQRCJANMY-794737',1.00,1440402280,1440402280,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:28;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/45\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"45\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}'),(80,251,'product','SA356ELAQRCJANMY-794737',1.00,1440402280,1440402280,'a:1:{s:7:\"context\";a:5:{s:11:\"product_ids\";a:1:{i:0;i:28;}s:19:\"add_to_cart_combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:12:\"display_path\";s:7:\"node/45\";s:6:\"entity\";a:3:{s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:2:\"45\";s:28:\"product_reference_field_name\";s:13:\"field_product\";}}}');
/*!40000 ALTER TABLE `commerce_line_item` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `commerce_marketplace_funds_account`
--

DROP TABLE IF EXISTS `commerce_marketplace_funds_account`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commerce_marketplace_funds_account` (
  `account_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary key of the funds account.',
  `owner_type` mediumtext NOT NULL COMMENT 'The account owner entity type',
  `owner_id` int(10) unsigned NOT NULL COMMENT 'Account owner ID',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp of the entity creation time.',
  `changed` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp of last entity update time.',
  PRIMARY KEY (`account_id`)
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8 COMMENT='Base table for commerce marketplace funds accounts.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commerce_marketplace_funds_account`
--

LOCK TABLES `commerce_marketplace_funds_account` WRITE;
/*!40000 ALTER TABLE `commerce_marketplace_funds_account` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `commerce_marketplace_funds_account` VALUES (1,'user',1,1417752363,1417752363),(2,'commerce_store',2,1418032332,1418032332),(3,'commerce_store',1,1418033001,1418033001),(4,'user',15,1418036052,1418036052),(5,'user',6,1418281749,1418281749),(6,'user',16,1418356781,1418356781),(7,'commerce_store',3,1418356806,1418356806),(8,'user',0,1418376452,1418376452);
/*!40000 ALTER TABLE `commerce_marketplace_funds_account` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `commerce_marketplace_funds_transaction`
--

DROP TABLE IF EXISTS `commerce_marketplace_funds_transaction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commerce_marketplace_funds_transaction` (
  `transaction_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary key of the transaction.',
  `type` mediumtext NOT NULL COMMENT 'Transaction type',
  `from_account` int(10) unsigned DEFAULT '0' COMMENT 'Actor account',
  `to_account` int(10) unsigned NOT NULL COMMENT 'Target account',
  `order_id` int(10) unsigned DEFAULT NULL COMMENT 'Order ID',
  `status` varchar(255) NOT NULL COMMENT 'Transaction status',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp of the entity creation time.',
  `changed` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp of last entity update time.',
  PRIMARY KEY (`transaction_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Base table for commerce marketplace funds transactions.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commerce_marketplace_funds_transaction`
--

LOCK TABLES `commerce_marketplace_funds_transaction` WRITE;
/*!40000 ALTER TABLE `commerce_marketplace_funds_transaction` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `commerce_marketplace_funds_transaction` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `commerce_marketplace_funds_withdraw_method`
--

DROP TABLE IF EXISTS `commerce_marketplace_funds_withdraw_method`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commerce_marketplace_funds_withdraw_method` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary key of the withdrawal method.',
  `account_id` int(10) unsigned NOT NULL COMMENT 'Owner account',
  `type` varchar(255) NOT NULL COMMENT 'Withdrawal method type',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp of the entity creation time.',
  `changed` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp of last entity update time.',
  PRIMARY KEY (`id`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Commerce Marketplace Funds Withdraw Methods.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commerce_marketplace_funds_withdraw_method`
--

LOCK TABLES `commerce_marketplace_funds_withdraw_method` WRITE;
/*!40000 ALTER TABLE `commerce_marketplace_funds_withdraw_method` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `commerce_marketplace_funds_withdraw_method` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `commerce_marketplace_funds_withdraw_method_type`
--

DROP TABLE IF EXISTS `commerce_marketplace_funds_withdraw_method_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commerce_marketplace_funds_withdraw_method_type` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique withdraw method type identifier.',
  `type` varchar(255) NOT NULL COMMENT 'The machine-readable name of this withdraw method type.',
  `label` varchar(255) NOT NULL DEFAULT '' COMMENT 'The human-readable name of this withdraw method type.',
  `weight` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The weight of this withdraw method type in relation to others.',
  `data` longtext COMMENT 'A serialized array of additional data related to this model type.',
  `status` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'The exportable status of the entity.',
  `module` varchar(255) DEFAULT NULL COMMENT 'The name of the providing module if the entity has been defined in code.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `type` (`type`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COMMENT='Stores information about defined withdraw method types.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commerce_marketplace_funds_withdraw_method_type`
--

LOCK TABLES `commerce_marketplace_funds_withdraw_method_type` WRITE;
/*!40000 ALTER TABLE `commerce_marketplace_funds_withdraw_method_type` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `commerce_marketplace_funds_withdraw_method_type` VALUES (1,'paypal','Paypal',0,'s:0:\"\";',1,NULL);
/*!40000 ALTER TABLE `commerce_marketplace_funds_withdraw_method_type` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `commerce_order`
--

DROP TABLE IF EXISTS `commerce_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commerce_order` (
  `order_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for an order.',
  `order_number` varchar(255) DEFAULT NULL COMMENT 'The order number displayed to the customer.',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The current commerce_order_revision.revision_id version identifier.',
  `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The type of this order.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that owns this order.',
  `mail` varchar(255) NOT NULL DEFAULT '' COMMENT 'The e-mail address associated with the order.',
  `status` varchar(255) NOT NULL COMMENT 'The status name of this order.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the order was created.',
  `changed` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the order was most recently saved.',
  `hostname` varchar(128) NOT NULL DEFAULT '' COMMENT 'The IP address that created this order.',
  `data` longblob COMMENT 'A serialized array of additional data.',
  PRIMARY KEY (`order_id`),
  UNIQUE KEY `order_number` (`order_number`),
  UNIQUE KEY `revision_id` (`revision_id`),
  KEY `uid` (`uid`)
) ENGINE=InnoDB AUTO_INCREMENT=257 DEFAULT CHARSET=utf8 COMMENT='The base table for orders.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commerce_order`
--

LOCK TABLES `commerce_order` WRITE;
/*!40000 ALTER TABLE `commerce_order` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `commerce_order` VALUES (1,'1',1,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1416295727,1416295727,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419230805;}'),(2,'2',2,'commerce_marketplace_order',6,'lazada@shop.com','cart',1416299430,1416299430,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416306266;}'),(3,'3',3,'commerce_marketplace_order',0,'','cart',1416306384,1416306384,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416381342;}'),(4,'4',4,'commerce_marketplace_order',6,'lazada@shop.com','cart',1416385411,1416563628,'::1','a:1:{s:17:\"last_cart_refresh\";i:1416563618;}'),(5,'5',5,'commerce_marketplace_order',0,'','cart',1416385497,1416385497,'::1','a:0:{}'),(6,'6',6,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1416385498,1416385513,'::1','a:1:{s:17:\"last_cart_refresh\";i:1416389784;}'),(7,'7',7,'commerce_marketplace_order',0,'','cart',1416389808,1416389808,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416389811;}'),(8,'8',8,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1416389819,1416390180,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416392120;}'),(9,'9',9,'commerce_marketplace_order',6,'lazada@shop.com','cart',1416392159,1416392159,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416455743;}'),(10,'10',10,'commerce_marketplace_order',0,'','cart',1416392214,1416392214,'127.0.0.1','a:0:{}'),(11,'11',11,'commerce_marketplace_order',0,'','cart',1416393021,1416393021,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416393025;}'),(12,'12',12,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1416450564,1416450564,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416460157;}'),(13,'13',13,'commerce_marketplace_order',6,'lazada@shop.com','cart',1416455760,1416797576,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416797576;}'),(14,'14',14,'commerce_marketplace_order',0,'','cart',1416459583,1416459583,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416459733;}'),(15,'15',15,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1416466139,1416466139,'::1','a:0:{}'),(16,'16',16,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1416476093,1416481416,'::1','a:1:{s:17:\"last_cart_refresh\";i:1416481477;}'),(17,'17',17,'commerce_store_order',6,'lazada@shop.com','cart',1416481384,1416563628,'::1','a:0:{}'),(18,'18',18,'commerce_store_order',1,'you@yourdomain.com','cart',1416481416,1416481416,'::1','a:0:{}'),(19,'19',19,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1416542864,1416551081,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416551384;}'),(20,'20',20,'commerce_marketplace_order',0,'','cart',1416543959,1416543959,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416560591;}'),(21,'21',21,'commerce_store_order',1,'you@yourdomain.com','cart',1416551081,1416551081,'127.0.0.1','a:0:{}'),(22,'22',22,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1416558620,1416559860,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416823984;}'),(23,'23',23,'commerce_store_order',1,'you@yourdomain.com','cart',1416559860,1416559860,'127.0.0.1','a:0:{}'),(24,'24',24,'commerce_store_order',6,'lazada@shop.com','cart',1416563648,1416797576,'::1','a:1:{s:17:\"last_cart_refresh\";i:1416797576;}'),(25,'25',25,'commerce_marketplace_order',6,'lazada@shop.com','cart',1416798149,1416816593,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416825137;}'),(26,'26',26,'commerce_store_order',6,'lazada@shop.com','cart',1416798247,1416816593,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416816593;}'),(27,'27',27,'commerce_marketplace_order',0,'','cart',1416825234,1416825234,'::1','a:1:{s:17:\"last_cart_refresh\";i:1416825560;}'),(28,'28',28,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1416882921,1416887094,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416889057;}'),(29,'29',29,'commerce_store_order',1,'you@yourdomain.com','cart',1416886760,1416887094,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416887094;}'),(30,'30',30,'commerce_marketplace_order',6,'lazada@shop.com','cart',1416887002,1416887656,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416887657;}'),(31,'31',31,'commerce_store_order',6,'lazada@shop.com','cart',1416887010,1416887656,'127.0.0.1','a:0:{}'),(32,'32',32,'commerce_store_order',1,'you@yourdomain.com','cart',1416887094,1416887094,'127.0.0.1','a:0:{}'),(33,'33',33,'commerce_marketplace_order',0,'','cart',1416887670,1416887670,'127.0.0.1','a:0:{}'),(34,'34',34,'commerce_marketplace_order',6,'lazada@shop.com','cart',1416887687,1416887793,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416887780;}'),(35,'35',35,'commerce_store_order',6,'lazada@shop.com','cart',1416887793,1416887793,'127.0.0.1','a:0:{}'),(36,'36',36,'commerce_marketplace_order',6,'lazada@shop.com','cart',1416887813,1416888097,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416888102;}'),(37,'37',37,'commerce_store_order',6,'lazada@shop.com','cart',1416887939,1416888097,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416888087;}'),(38,'38',38,'commerce_store_order',6,'lazada@shop.com','cart',1416888097,1416888097,'127.0.0.1','a:0:{}'),(39,'39',39,'commerce_marketplace_order',6,'lazada@shop.com','cart',1416888317,1416908041,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416908032;}'),(40,'40',40,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1416889123,1416889187,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(41,'41',41,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1416895889,1416895936,'192.168.1.25','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(42,'42',42,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1416900681,1416900735,'192.168.1.5','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(43,'43',43,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1416903023,1416903116,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(44,'44',44,'commerce_store_order',6,'lazada@shop.com','cart',1416906023,1416908041,'127.0.0.1','a:0:{}'),(45,'45',45,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1416908045,1416908875,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(46,'46',46,'commerce_marketplace_order',6,'lazada@shop.com','cart',1416908880,1416909029,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416909020;}'),(47,'47',47,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1416909033,1416909412,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(48,'48',48,'commerce_marketplace_order',6,'lazada@shop.com','cart',1416909415,1416969672,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416969724;}'),(49,'49',49,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1416913253,1416913262,'192.168.1.10','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(50,'50',50,'commerce_marketplace_order',0,'','cart',1416913714,1416913714,'127.0.0.1','a:0:{}'),(51,'51',51,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1416913715,1416913727,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(52,'52',52,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1416968666,1416968717,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(53,'53',53,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1416968705,1416969219,'192.168.1.24','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(54,'54',54,'commerce_marketplace_order',0,'','cart',1416969342,1416969342,'192.168.1.24','a:0:{}'),(55,'55',55,'commerce_marketplace_order',6,'lazada@shop.com','cart',1416969737,1416969792,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416969849;}'),(56,'56',56,'commerce_marketplace_order',0,'','cart',1416969853,1416969853,'127.0.0.1','a:0:{}'),(57,'57',57,'commerce_marketplace_order',6,'lazada@shop.com','cart',1416969883,1416969883,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416970517;}'),(58,'58',58,'commerce_marketplace_order',0,'','cart',1416970277,1416970277,'127.0.0.1','a:0:{}'),(59,'59',59,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1416970277,1416970287,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(60,'60',60,'commerce_marketplace_order',6,'lazada@shop.com','cart',1416970526,1416970546,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416970736;}'),(61,'61',61,'commerce_marketplace_order',6,'lazada@shop.com','cart',1416970743,1416970900,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416970986;}'),(62,'62',62,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1416970989,1417158836,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(63,'63',63,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1416975085,1416984760,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(64,'64',64,'commerce_store_order',1,'you@yourdomain.com','cart',1416984754,1416984760,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(65,'65',65,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417055171,1417055487,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(66,'66',66,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417060029,1417060111,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(67,'67',67,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417062249,1417062423,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(68,'68',68,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417070606,1417070634,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(69,'69',69,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417070685,1417070706,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(70,'70',70,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417081632,1417081650,'192.168.1.24','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(71,'71',71,'commerce_marketplace_order',0,'','cart',1417083103,1417083103,'192.168.1.24','a:0:{}'),(72,'72',72,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417145133,1417145142,'192.168.1.16','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(73,'73',75,'commerce_marketplace_order',1,'you@yourdomain.com','checkout_checkout',1417149807,1417155700,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(74,'74',74,'commerce_store_order',1,'you@yourdomain.com','checkout_checkout',1417155662,1417155700,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(75,'75',76,'commerce_marketplace_order',0,'','cart',1417155801,1417155801,'127.0.0.1','a:0:{}'),(76,'76',79,'commerce_marketplace_order',1,'you@yourdomain.com','checkout_checkout',1417155801,1417155873,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(77,'77',78,'commerce_store_order',1,'you@yourdomain.com','checkout_checkout',1417155865,1417155873,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(78,'78',80,'commerce_marketplace_order',0,'','cart',1417158842,1417158842,'127.0.0.1','a:0:{}'),(79,'79',81,'commerce_marketplace_order',0,'','cart',1417158917,1417158917,'127.0.0.1','a:0:{}'),(80,'80',82,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417158918,1417158933,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(81,'81',83,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417159832,1417159841,'192.168.1.24','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(82,'82',84,'commerce_marketplace_order',0,'','cart',1417160395,1417160395,'127.0.0.1','a:0:{}'),(83,'83',90,'commerce_marketplace_order',1,'you@yourdomain.com','checkout_checkout',1417160395,1417171814,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417403029;}'),(84,'84',86,'commerce_store_order',1,'you@yourdomain.com','checkout_checkout',1417160506,1417171814,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417171814;}'),(85,'85',91,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417403099,1417403724,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417403944;}'),(86,'86',92,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417404280,1417404361,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417404509;}'),(87,'87',93,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417404531,1417404561,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417405065;}'),(88,'88',94,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417405076,1417405221,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417408932;}'),(89,'89',95,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417409024,1417409093,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417409485;}'),(90,'90',96,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417409509,1417409533,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417409537;}'),(91,'91',97,'commerce_marketplace_order',0,'','cart',1417409665,1417409665,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417409811;}'),(92,'92',98,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417416886,1417447868,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417487041;}'),(93,'93',99,'commerce_store_order',1,'you@yourdomain.com','cart',1417447868,1417447868,'::1','a:0:{}'),(94,'94',100,'commerce_marketplace_order',0,'','cart',1417487055,1417487055,'127.0.0.1','a:0:{}'),(95,'95',101,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417487068,1417487068,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417487263;}'),(96,'96',102,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417487367,1417487376,'192.168.1.14','a:1:{s:17:\"last_cart_refresh\";i:1417487412;}'),(97,'97',103,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417487416,1417487513,'192.168.1.14','a:1:{s:17:\"last_cart_refresh\";i:1417489075;}'),(98,'98',104,'commerce_marketplace_order',0,'','cart',1417489179,1417489179,'192.168.1.14','a:0:{}'),(99,'99',105,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417489191,1417489204,'192.168.1.14','a:1:{s:17:\"last_cart_refresh\";i:1417492081;}'),(100,'100',106,'commerce_marketplace_order',0,'','cart',1417492107,1417492107,'127.0.0.1','a:0:{}'),(101,'101',107,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417492107,1417492112,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417502140;}'),(102,'102',108,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417495770,1417502140,'192.168.1.14','a:1:{s:17:\"last_cart_refresh\";i:1417502141;}'),(103,'103',109,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417503078,1417503092,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417509677;}'),(104,'104',110,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417509527,1417509690,'192.168.1.14','a:1:{s:17:\"last_cart_refresh\";i:1417512805;}'),(105,'105',111,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417512832,1417512850,'192.168.1.14','a:1:{s:17:\"last_cart_refresh\";i:1417513908;}'),(106,'106',112,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417514740,1417514776,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417534621;}'),(107,'107',113,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417534675,1417572724,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417574863;}'),(108,'108',114,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417575039,1417575063,'192.168.1.19','a:1:{s:17:\"last_cart_refresh\";i:1417591145;}'),(109,'109',115,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417591142,1417592308,'192.168.1.15','a:1:{s:17:\"last_cart_refresh\";i:1417598033;}'),(110,'110',116,'commerce_marketplace_order',0,'','cart',1417591951,1417591951,'127.0.0.1','a:0:{}'),(111,'111',117,'commerce_store_order',1,'you@yourdomain.com','cart',1417592308,1417592308,'127.0.0.1','a:0:{}'),(112,'112',118,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417598046,1417598059,'192.168.1.15','a:1:{s:17:\"last_cart_refresh\";i:1417598379;}'),(113,'113',119,'commerce_marketplace_order',0,'','cart',1417598377,1417598377,'127.0.0.1','a:0:{}'),(114,'114',120,'commerce_marketplace_order',0,'','cart',1417598377,1417598377,'127.0.0.1','a:0:{}'),(115,'115',121,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417598402,1417598962,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417604427;}'),(116,'116',122,'commerce_store_order',1,'you@yourdomain.com','cart',1417598962,1417598962,'127.0.0.1','a:0:{}'),(117,'117',123,'commerce_marketplace_order',0,'','cart',1417661960,1417663879,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417666278;}'),(118,'118',124,'commerce_store_order',0,'','cart',1417663584,1417663879,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417663879;}'),(119,'119',125,'commerce_marketplace_order',0,'','cart',1417664582,1417664582,'::1','a:0:{}'),(120,'120',126,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417664582,1417669225,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417675205;}'),(121,'121',127,'commerce_marketplace_order',0,'','cart',1417666314,1417667040,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417674989;}'),(122,'122',128,'commerce_store_order',0,'','cart',1417667040,1417667040,'::1','a:0:{}'),(123,'123',129,'commerce_store_order',1,'you@yourdomain.com','cart',1417669225,1417669225,'::1','a:0:{}'),(124,'124',130,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417676263,1417676929,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417677578;}'),(125,'125',131,'commerce_store_order',1,'you@yourdomain.com','cart',1417676929,1417676929,'127.0.0.1','a:0:{}'),(126,'126',132,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417677653,1417677685,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417681413;}'),(127,'127',133,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417681452,1417682379,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417682391;}'),(128,'128',134,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417682425,1417685119,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417691418;}'),(129,'129',135,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417751873,1417752212,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417754704;}'),(130,'130',136,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417773527,1417773659,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417773664;}'),(131,'131',137,'commerce_marketplace_order',0,'','cart',1417774020,1417774020,'::1','a:0:{}'),(132,'132',138,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1417774047,1417774196,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418010094;}'),(133,'133',139,'commerce_marketplace_order',0,'','cart',1417774063,1417774063,'::1','a:0:{}'),(134,'134',140,'commerce_marketplace_order',6,'lazada@shop.com','cart',1418008404,1418031915,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418032659;}'),(135,'135',141,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418010116,1418010131,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418014825;}'),(136,'136',142,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418020578,1418021058,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418098996;}'),(137,'137',143,'commerce_marketplace_order',6,'lazada@shop.com','cart',1418032683,1418032693,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418099429;}'),(138,'138',150,'commerce_marketplace_order',15,'1@abc.com','pending',1418033784,1418033784,'::1','a:3:{s:17:\"last_cart_refresh\";i:1418033781;s:14:\"payment_method\";s:42:\"commerce_cod|commerce_payment_commerce_cod\";s:12:\"commerce_cop\";a:1:{s:11:\"transaction\";s:11:\"dummy_value\";}}'),(139,'139',145,'commerce_store_order',15,'1@abc.com','pending',1418033542,1418033784,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418033781;}'),(140,'140',165,'commerce_marketplace_order',15,'1@abc.com','pending',1418093574,1418093574,'::1','a:3:{s:17:\"last_cart_refresh\";i:1418093572;s:14:\"payment_method\";s:42:\"commerce_cod|commerce_payment_commerce_cod\";s:12:\"commerce_cop\";a:1:{s:11:\"transaction\";s:11:\"dummy_value\";}}'),(141,'141',152,'commerce_store_order',15,'1@abc.com','pending',1418034610,1418093574,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418093572;}'),(142,'142',154,'commerce_store_order',15,'1@abc.com','pending',1418036627,1418093574,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418093572;}'),(143,'143',166,'commerce_marketplace_order',15,'1@abc.com','cart',1418093619,1418093619,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418093668;}'),(144,'144',167,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418099528,1418106846,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418182863;}'),(145,'145',168,'commerce_marketplace_order',0,'','cart',1418105939,1418105939,'::1','a:0:{}'),(146,'146',171,'commerce_marketplace_order',0,'','checkout_checkout',1418111468,1418112493,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418182940;}'),(147,'147',170,'commerce_store_order',0,'','checkout_checkout',1418112224,1418112493,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418112493;}'),(148,'148',172,'commerce_marketplace_order',0,'','cart',1418280530,1418280530,'127.0.0.1','a:0:{}'),(149,'149',173,'commerce_marketplace_order',0,'','cart',1418280530,1418280530,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418281562;}'),(150,'150',174,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418281139,1418352515,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(151,'151',175,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418281574,1418282801,'192.168.1.14','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(152,'152',176,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418281706,1418281719,'192.168.1.17','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(153,'153',177,'commerce_marketplace_order',6,'lazada@shop.com','cart',1418281727,1418281734,'192.168.1.17','a:1:{s:17:\"last_cart_refresh\";i:1418281777;}'),(154,'154',178,'commerce_marketplace_order',0,'','cart',1418281727,1418281727,'192.168.1.14','a:0:{}'),(155,'155',179,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418290927,1418290937,'192.168.1.14','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(156,'156',180,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418350755,1418350783,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(157,'157',181,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418350896,1418351015,'192.168.1.14','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(158,'158',182,'commerce_marketplace_order',16,'weebpal@mail.com','cart',1418356757,1418356767,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418375386;}'),(159,'159',183,'commerce_marketplace_order',17,'test@mail.vn','cart',1418375389,1418375395,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418375396;}'),(160,'160',184,'commerce_marketplace_order',6,'lazada@shop.com','cart',1418376452,1418376464,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418376480;}'),(161,'161',185,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418376486,1418376493,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(162,'162',186,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418377643,1418377657,'192.168.1.21','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(163,'163',187,'commerce_marketplace_order',0,'','cart',1418610068,1418610068,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418613801;}'),(164,'164',188,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418610177,1418610203,'::1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(165,'165',189,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418610527,1418611335,'::1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(166,'166',190,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418615853,1418615876,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(167,'167',194,'commerce_marketplace_order',1,'you@yourdomain.com','checkout_checkout',1418629174,1418715560,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(168,'168',192,'commerce_marketplace_order',0,'','cart',1418713807,1418713807,'192.168.1.21','a:1:{s:17:\"last_cart_refresh\";i:1418713977;}'),(169,'169',193,'commerce_store_order',1,'you@yourdomain.com','checkout_checkout',1418715353,1418715560,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(170,'170',195,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418719352,1418722477,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(171,'171',196,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418786636,1418786885,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(172,'172',197,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418786882,1418786935,'192.168.1.16','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(173,'173',198,'commerce_marketplace_order',0,'','cart',1418802186,1418802186,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418892215;}'),(174,'174',199,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418806236,1418806247,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(175,'175',200,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418872521,1418872909,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(176,'176',201,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418883347,1418883477,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(177,'177',202,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418883495,1418884020,'192.168.1.14','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(178,'178',203,'commerce_marketplace_order',16,'weebpal@mail.com','cart',1418884990,1418885001,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418885020;}'),(179,'179',204,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418885023,1418885030,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(180,'180',205,'commerce_marketplace_order',0,'','cart',1418885548,1418885548,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418885612;}'),(181,'181',206,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418885631,1418885684,'192.168.1.14','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(182,'182',207,'commerce_marketplace_order',0,'','cart',1418891484,1418891484,'127.0.0.1','a:0:{}'),(183,'183',208,'commerce_marketplace_order',0,'','cart',1418898965,1418898965,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418899117;}'),(184,'184',209,'commerce_marketplace_order',0,'','cart',1418958147,1418958147,'127.0.0.1','a:0:{}'),(185,'185',210,'commerce_marketplace_order',0,'','cart',1418958159,1418958159,'127.0.0.1','a:0:{}'),(186,'186',211,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418958173,1418958180,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(187,'187',212,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418958211,1418958219,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(188,'188',213,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418960370,1418960968,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(189,'189',217,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418961202,1418961613,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(190,'190',215,'commerce_store_order',1,'you@yourdomain.com','cart',1418961471,1418961613,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(191,'191',218,'commerce_marketplace_order',0,'','cart',1418973423,1418973423,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418982112;}'),(192,'192',219,'commerce_marketplace_order',0,'','cart',1418975239,1418975239,'127.0.0.1','a:0:{}'),(193,'193',220,'commerce_marketplace_order',0,'','cart',1418975239,1418975239,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418982153;}'),(194,'194',221,'commerce_marketplace_order',0,'','cart',1418982830,1418982830,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418983010;}'),(195,'195',222,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1418983842,1418983882,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419231750;}'),(196,'196',223,'commerce_marketplace_order',0,'','cart',1418984336,1418984336,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418984402;}'),(197,'197',224,'commerce_marketplace_order',0,'','cart',1418984495,1418984495,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418987241;}'),(198,'198',225,'commerce_marketplace_order',0,'','cart',1418985935,1418985935,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418985945;}'),(199,'199',226,'commerce_marketplace_order',0,'','cart',1419220889,1419220889,'127.0.0.1','a:0:{}'),(200,'200',227,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1419231757,1419231821,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419231821;}'),(201,'201',232,'commerce_marketplace_order',1,'you@yourdomain.com','checkout_review',1419231904,1419304247,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419304313;}'),(202,'202',229,'commerce_store_order',1,'you@yourdomain.com','checkout_review',1419304163,1419304247,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419304247;}'),(203,'203',233,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1419304503,1419304556,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419388971;}'),(204,'204',234,'commerce_marketplace_order',0,'','cart',1419315427,1419315427,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419576000;}'),(205,'205',235,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1419475703,1419476196,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419476947;}'),(206,'206',236,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1419476004,1419476962,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419488146;}'),(207,'207',237,'commerce_marketplace_order',0,'','cart',1419481619,1419481619,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419489438;}'),(208,'208',238,'commerce_marketplace_order',0,'','cart',1419488765,1419488765,'127.0.0.1','a:0:{}'),(209,'209',239,'commerce_marketplace_order',0,'','cart',1419500978,1419500978,'127.0.0.1','a:0:{}'),(210,'210',240,'commerce_marketplace_order',0,'','cart',1419500979,1419500979,'127.0.0.1','a:0:{}'),(211,'211',241,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1419500976,1419501055,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419503197;}'),(212,'212',242,'commerce_marketplace_order',0,'','cart',1419501802,1419501802,'192.168.1.24','a:1:{s:17:\"last_cart_refresh\";i:1419501903;}'),(213,'213',243,'commerce_marketplace_order',0,'','cart',1419501971,1419501971,'192.168.1.24','a:1:{s:17:\"last_cart_refresh\";i:1419502822;}'),(214,'214',244,'commerce_marketplace_order',0,'','cart',1419502509,1419502509,'192.168.1.13','a:0:{}'),(215,'215',245,'commerce_marketplace_order',0,'','cart',1419575037,1419575037,'127.0.0.1','a:0:{}'),(216,'216',246,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1419575036,1419575189,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419576982;}'),(217,'217',247,'commerce_marketplace_order',0,'','cart',1419631970,1419631970,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419633902;}'),(218,'218',248,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1419632170,1419632191,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419633908;}'),(219,'219',249,'commerce_marketplace_order',0,'','cart',1419633330,1419633330,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419633345;}'),(220,'220',250,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1419868623,1419868799,'::1','a:1:{s:17:\"last_cart_refresh\";i:1419869609;}'),(221,'221',251,'commerce_marketplace_order',0,'','cart',1419999112,1419999112,'127.0.0.1','a:0:{}'),(222,'222',252,'commerce_marketplace_order',0,'','cart',1419999111,1419999111,'127.0.0.1','a:0:{}'),(223,'223',253,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1419999128,1419999425,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1420000191;}'),(224,'224',254,'commerce_marketplace_order',0,'','cart',1419999252,1419999252,'127.0.0.1','a:0:{}'),(225,'225',255,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1420431886,1420432073,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1420432340;}'),(226,'226',256,'commerce_marketplace_order',16,'weebpal@mail.com','cart',1420432390,1420441457,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1420442286;}'),(227,'227',257,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1420432852,1420432865,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1420432869;}'),(228,'228',258,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1420432898,1420432910,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1420433250;}'),(229,'229',259,'commerce_marketplace_order',0,'','cart',1420433605,1420433605,'127.0.0.1','a:0:{}'),(230,'230',260,'commerce_store_order',16,'weebpal@mail.com','cart',1420434096,1420441457,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1420441457;}'),(231,'231',261,'commerce_store_order',16,'weebpal@mail.com','cart',1420439764,1420441457,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1420441457;}'),(232,'232',262,'commerce_marketplace_order',0,'','cart',1420441334,1420441334,'127.0.0.1','a:0:{}'),(233,'233',263,'commerce_marketplace_order',0,'','cart',1420442299,1420442299,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1420444799;}'),(234,'234',264,'commerce_marketplace_order',0,'','cart',1420693347,1420693347,'192.168.1.29','a:0:{}'),(235,'235',265,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1420693494,1420693534,'192.168.1.29','a:1:{s:17:\"last_cart_refresh\";i:1420698440;}'),(236,'236',266,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1423540274,1423540484,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1423541069;}'),(237,'237',267,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1426155781,1426155982,'::1','a:1:{s:17:\"last_cart_refresh\";i:1426219035;}'),(238,'238',268,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1426652634,1426652810,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1426653492;}'),(239,'239',269,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1429266859,1429266927,'::1','a:1:{s:17:\"last_cart_refresh\";i:1429267311;}'),(240,'240',270,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1438763225,1438763576,'::1','a:1:{s:17:\"last_cart_refresh\";i:1438849879;}'),(241,'241',271,'commerce_marketplace_order',0,'','cart',1438848970,1438848970,'::1','a:0:{}'),(242,'242',272,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1439179301,1439180310,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1439266577;}'),(243,'243',273,'commerce_marketplace_order',0,'','cart',1439201992,1439201992,'127.0.0.1','a:0:{}'),(244,'244',274,'commerce_marketplace_order',0,'','cart',1439202129,1439202129,'127.0.0.1','a:0:{}'),(245,'245',275,'commerce_marketplace_order',0,'','cart',1439202356,1439202356,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1439202755;}'),(246,'246',276,'commerce_marketplace_order',0,'','cart',1439266615,1439266615,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1439266788;}'),(247,'247',277,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1440056499,1440056533,'::1','a:1:{s:17:\"last_cart_refresh\";i:1440056868;}'),(248,'248',279,'commerce_marketplace_order',0,'','cart',1440401932,1440401932,'127.0.0.1','a:0:{}'),(249,'249',278,'commerce_marketplace_order',0,'','cart',1440401943,1440401943,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1440402068;}'),(250,'250',280,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1440401901,1440402280,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1440402591;}'),(251,'251',281,'commerce_store_order',1,'you@yourdomain.com','cart',1440402280,1440402280,'127.0.0.1','a:0:{}'),(252,'252',282,'commerce_marketplace_order',0,'','cart',1443995208,1443995208,'::1','a:1:{s:17:\"last_cart_refresh\";i:1443995882;}'),(253,'253',283,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1446071052,1446071192,'::1','a:1:{s:17:\"last_cart_refresh\";i:1446071493;}'),(254,'254',284,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1455371141,1455371257,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1455374139;}'),(255,'255',285,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1499933570,1499933597,'192.168.1.49','a:1:{s:17:\"last_cart_refresh\";i:1499933862;}'),(256,'256',286,'commerce_marketplace_order',1,'you@yourdomain.com','cart',1500346756,1500347121,'192.168.1.49','a:1:{s:17:\"last_cart_refresh\";i:1500361298;}');
/*!40000 ALTER TABLE `commerce_order` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `commerce_order_revision`
--

DROP TABLE IF EXISTS `commerce_order_revision`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commerce_order_revision` (
  `order_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The commerce_order.order_id of the order this revision belongs to.',
  `order_number` varchar(255) DEFAULT NULL COMMENT 'The order number displayed to the customer for this revision.',
  `revision_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for this revision.',
  `revision_uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that owns the order at this revision.',
  `mail` varchar(255) NOT NULL COMMENT 'The e-mail address associated with the order at this revision.',
  `status` varchar(255) NOT NULL COMMENT 'The status name of this revision.',
  `log` longtext NOT NULL COMMENT 'The log entry explaining the changes in this version.',
  `revision_timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when this revision was created.',
  `revision_hostname` varchar(128) NOT NULL DEFAULT '' COMMENT 'The IP address that created this order.',
  `data` longblob COMMENT 'A serialized array of additional data.',
  PRIMARY KEY (`revision_id`),
  KEY `order_id` (`order_id`)
) ENGINE=InnoDB AUTO_INCREMENT=287 DEFAULT CHARSET=utf8 COMMENT='Saves information about each saved revision of a commerce...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commerce_order_revision`
--

LOCK TABLES `commerce_order_revision` WRITE;
/*!40000 ALTER TABLE `commerce_order_revision` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `commerce_order_revision` VALUES (1,'1',1,1,'you@yourdomain.com','cart','',1416295727,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419230805;}'),(2,'2',2,6,'lazada@shop.com','cart','',1416299430,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416306266;}'),(3,'3',3,0,'','cart','',1416306384,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416381342;}'),(4,'4',4,6,'lazada@shop.com','cart','',1416563628,'::1','a:1:{s:17:\"last_cart_refresh\";i:1416563618;}'),(5,'5',5,0,'','cart','',1416385497,'::1','a:0:{}'),(6,'6',6,1,'you@yourdomain.com','cart','',1416385513,'::1','a:1:{s:17:\"last_cart_refresh\";i:1416389784;}'),(7,'7',7,0,'','cart','',1416389808,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416389811;}'),(8,'8',8,1,'you@yourdomain.com','cart','',1416390180,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416392120;}'),(9,'9',9,6,'lazada@shop.com','cart','',1416392159,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416455743;}'),(10,'10',10,0,'','cart','',1416392214,'127.0.0.1','a:0:{}'),(11,'11',11,0,'','cart','',1416393021,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416393025;}'),(12,'12',12,1,'you@yourdomain.com','cart','',1416450564,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416460157;}'),(13,'13',13,6,'lazada@shop.com','cart','',1416797576,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416797576;}'),(14,'14',14,0,'','cart','',1416459583,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416459733;}'),(15,'15',15,1,'you@yourdomain.com','cart','',1416466139,'::1','a:0:{}'),(16,'16',16,1,'you@yourdomain.com','cart','',1416481416,'::1','a:1:{s:17:\"last_cart_refresh\";i:1416481477;}'),(17,'17',17,6,'lazada@shop.com','cart','',1416563628,'::1','a:0:{}'),(18,'18',18,1,'you@yourdomain.com','cart','',1416481416,'::1','a:0:{}'),(19,'19',19,1,'you@yourdomain.com','cart','',1416551081,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416551384;}'),(20,'20',20,0,'','cart','',1416543959,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416560591;}'),(21,'21',21,1,'you@yourdomain.com','cart','',1416551081,'127.0.0.1','a:0:{}'),(22,'22',22,1,'you@yourdomain.com','cart','',1416559860,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416823984;}'),(23,'23',23,1,'you@yourdomain.com','cart','',1416559860,'127.0.0.1','a:0:{}'),(24,'24',24,6,'lazada@shop.com','cart','',1416797576,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416797576;}'),(25,'25',25,6,'lazada@shop.com','cart','',1416816593,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416825137;}'),(26,'26',26,6,'lazada@shop.com','cart','',1416816593,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416816593;}'),(27,'27',27,0,'','cart','',1416825234,'::1','a:1:{s:17:\"last_cart_refresh\";i:1416825560;}'),(28,'28',28,1,'you@yourdomain.com','cart','',1416887094,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416889057;}'),(29,'29',29,1,'you@yourdomain.com','cart','',1416887094,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416887094;}'),(30,'30',30,6,'lazada@shop.com','cart','',1416887656,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416887657;}'),(31,'31',31,6,'lazada@shop.com','cart','',1416887656,'127.0.0.1','a:0:{}'),(32,'32',32,1,'you@yourdomain.com','cart','',1416887094,'127.0.0.1','a:0:{}'),(33,'33',33,0,'','cart','',1416887670,'127.0.0.1','a:0:{}'),(34,'34',34,6,'lazada@shop.com','cart','',1416887793,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416887780;}'),(35,'35',35,6,'lazada@shop.com','cart','',1416887793,'127.0.0.1','a:0:{}'),(36,'36',36,6,'lazada@shop.com','cart','',1416888097,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416888102;}'),(37,'37',37,6,'lazada@shop.com','cart','',1416888097,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416888087;}'),(38,'38',38,6,'lazada@shop.com','cart','',1416888097,'127.0.0.1','a:0:{}'),(39,'39',39,6,'lazada@shop.com','cart','',1416908041,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416908032;}'),(40,'40',40,1,'you@yourdomain.com','cart','',1416889187,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(41,'41',41,1,'you@yourdomain.com','cart','',1416895936,'192.168.1.25','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(42,'42',42,1,'you@yourdomain.com','cart','',1416900735,'192.168.1.5','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(43,'43',43,1,'you@yourdomain.com','cart','',1416903116,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(44,'44',44,6,'lazada@shop.com','cart','',1416908041,'127.0.0.1','a:0:{}'),(45,'45',45,1,'you@yourdomain.com','cart','',1416908875,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(46,'46',46,6,'lazada@shop.com','cart','',1416909029,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416909020;}'),(47,'47',47,1,'you@yourdomain.com','cart','',1416909412,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(48,'48',48,6,'lazada@shop.com','cart','',1416969672,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416969724;}'),(49,'49',49,1,'you@yourdomain.com','cart','',1416913262,'192.168.1.10','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(50,'50',50,0,'','cart','',1416913714,'127.0.0.1','a:0:{}'),(51,'51',51,1,'you@yourdomain.com','cart','',1416913727,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(52,'52',52,1,'you@yourdomain.com','cart','',1416968717,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(53,'53',53,1,'you@yourdomain.com','cart','',1416969219,'192.168.1.24','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(54,'54',54,0,'','cart','',1416969342,'192.168.1.24','a:0:{}'),(55,'55',55,6,'lazada@shop.com','cart','',1416969792,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416969849;}'),(56,'56',56,0,'','cart','',1416969853,'127.0.0.1','a:0:{}'),(57,'57',57,6,'lazada@shop.com','cart','',1416969883,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416970517;}'),(58,'58',58,0,'','cart','',1416970277,'127.0.0.1','a:0:{}'),(59,'59',59,1,'you@yourdomain.com','cart','',1416970287,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(60,'60',60,6,'lazada@shop.com','cart','',1416970546,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416970736;}'),(61,'61',61,6,'lazada@shop.com','cart','',1416970900,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1416970986;}'),(62,'62',62,1,'you@yourdomain.com','cart','',1417158836,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(63,'63',63,1,'you@yourdomain.com','cart','',1416984760,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(64,'64',64,1,'you@yourdomain.com','cart','',1416984760,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(65,'65',65,1,'you@yourdomain.com','cart','',1417055487,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(66,'66',66,1,'you@yourdomain.com','cart','',1417060111,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(67,'67',67,1,'you@yourdomain.com','cart','',1417062423,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(68,'68',68,1,'you@yourdomain.com','cart','',1417070634,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(69,'69',69,1,'you@yourdomain.com','cart','',1417070706,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(70,'70',70,1,'you@yourdomain.com','cart','',1417081650,'192.168.1.24','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(71,'71',71,0,'','cart','',1417083103,'192.168.1.24','a:0:{}'),(72,'72',72,1,'you@yourdomain.com','cart','',1417145142,'192.168.1.16','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(73,'73',73,1,'you@yourdomain.com','cart','',1417155662,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417155700;}'),(74,'74',74,1,'you@yourdomain.com','checkout_checkout','',1417155700,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(73,'73',75,1,'you@yourdomain.com','checkout_checkout','Customer proceeded to checkout using a submit button.',1417155700,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(75,'75',76,0,'','cart','',1417155801,'127.0.0.1','a:0:{}'),(76,'76',77,1,'you@yourdomain.com','cart','',1417155865,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417155873;}'),(77,'77',78,1,'you@yourdomain.com','checkout_checkout','',1417155873,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(76,'76',79,1,'you@yourdomain.com','checkout_checkout','Customer proceeded to checkout using a submit button.',1417155873,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(78,'78',80,0,'','cart','',1417158842,'127.0.0.1','a:0:{}'),(79,'79',81,0,'','cart','',1417158917,'127.0.0.1','a:0:{}'),(80,'80',82,1,'you@yourdomain.com','cart','',1417158933,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(81,'81',83,1,'you@yourdomain.com','cart','',1417159841,'192.168.1.24','a:1:{s:17:\"last_cart_refresh\";i:1417170195;}'),(82,'82',84,0,'','cart','',1417160395,'127.0.0.1','a:0:{}'),(83,'83',85,1,'you@yourdomain.com','cart','',1417164883,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417167180;}'),(84,'84',86,1,'you@yourdomain.com','checkout_checkout','',1417171814,'192.168.1.5','a:1:{s:17:\"last_cart_refresh\";i:1417171814;}'),(83,'83',87,1,'you@yourdomain.com','cart','Customer updated the order via the shopping cart form.',1417167180,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417171500;}'),(83,'83',88,1,'you@yourdomain.com','checkout_checkout','Customer proceeded to checkout using a submit button.',1417171802,'192.168.1.5','a:1:{s:17:\"last_cart_refresh\";i:1417171797;}'),(83,'83',89,1,'you@yourdomain.com','cart','Order status updated via Rules.',1417171802,'192.168.1.5','a:1:{s:17:\"last_cart_refresh\";i:1417171814;}'),(83,'83',90,1,'you@yourdomain.com','checkout_checkout','Customer proceeded to checkout using a submit button.',1417171814,'192.168.1.5','a:1:{s:17:\"last_cart_refresh\";i:1417403029;}'),(85,'85',91,1,'you@yourdomain.com','cart','',1417403724,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417403944;}'),(86,'86',92,1,'you@yourdomain.com','cart','',1417404361,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417404509;}'),(87,'87',93,1,'you@yourdomain.com','cart','',1417404561,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417405065;}'),(88,'88',94,1,'you@yourdomain.com','cart','',1417405221,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417408932;}'),(89,'89',95,1,'you@yourdomain.com','cart','',1417409093,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417409485;}'),(90,'90',96,1,'you@yourdomain.com','cart','',1417409533,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417409537;}'),(91,'91',97,0,'','cart','',1417409665,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417409811;}'),(92,'92',98,1,'you@yourdomain.com','cart','',1417447868,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417487041;}'),(93,'93',99,1,'you@yourdomain.com','cart','',1417447868,'::1','a:0:{}'),(94,'94',100,0,'','cart','',1417487055,'127.0.0.1','a:0:{}'),(95,'95',101,1,'you@yourdomain.com','cart','',1417487068,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417487263;}'),(96,'96',102,1,'you@yourdomain.com','cart','',1417487376,'192.168.1.14','a:1:{s:17:\"last_cart_refresh\";i:1417487412;}'),(97,'97',103,1,'you@yourdomain.com','cart','',1417487513,'192.168.1.14','a:1:{s:17:\"last_cart_refresh\";i:1417489075;}'),(98,'98',104,0,'','cart','',1417489179,'192.168.1.14','a:0:{}'),(99,'99',105,1,'you@yourdomain.com','cart','',1417489204,'192.168.1.14','a:1:{s:17:\"last_cart_refresh\";i:1417492081;}'),(100,'100',106,0,'','cart','',1417492107,'127.0.0.1','a:0:{}'),(101,'101',107,1,'you@yourdomain.com','cart','',1417492112,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417502140;}'),(102,'102',108,1,'you@yourdomain.com','cart','',1417502140,'192.168.1.14','a:1:{s:17:\"last_cart_refresh\";i:1417502141;}'),(103,'103',109,1,'you@yourdomain.com','cart','',1417503092,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417509677;}'),(104,'104',110,1,'you@yourdomain.com','cart','',1417509690,'192.168.1.14','a:1:{s:17:\"last_cart_refresh\";i:1417512805;}'),(105,'105',111,1,'you@yourdomain.com','cart','',1417512850,'192.168.1.14','a:1:{s:17:\"last_cart_refresh\";i:1417513908;}'),(106,'106',112,1,'you@yourdomain.com','cart','',1417514776,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417534621;}'),(107,'107',113,1,'you@yourdomain.com','cart','',1417572724,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417574863;}'),(108,'108',114,1,'you@yourdomain.com','cart','',1417575063,'192.168.1.19','a:1:{s:17:\"last_cart_refresh\";i:1417591145;}'),(109,'109',115,1,'you@yourdomain.com','cart','',1417592308,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417598033;}'),(110,'110',116,0,'','cart','',1417591951,'127.0.0.1','a:0:{}'),(111,'111',117,1,'you@yourdomain.com','cart','',1417592308,'127.0.0.1','a:0:{}'),(112,'112',118,1,'you@yourdomain.com','cart','',1417598059,'192.168.1.15','a:1:{s:17:\"last_cart_refresh\";i:1417598379;}'),(113,'113',119,0,'','cart','',1417598377,'127.0.0.1','a:0:{}'),(114,'114',120,0,'','cart','',1417598377,'127.0.0.1','a:0:{}'),(115,'115',121,1,'you@yourdomain.com','cart','',1417598962,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417604427;}'),(116,'116',122,1,'you@yourdomain.com','cart','',1417598962,'127.0.0.1','a:0:{}'),(117,'117',123,0,'','cart','',1417663879,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417666278;}'),(118,'118',124,0,'','cart','',1417663879,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417663879;}'),(119,'119',125,0,'','cart','',1417664582,'::1','a:0:{}'),(120,'120',126,1,'you@yourdomain.com','cart','',1417669225,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417675205;}'),(121,'121',127,0,'','cart','',1417667040,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417674989;}'),(122,'122',128,0,'','cart','',1417667040,'::1','a:0:{}'),(123,'123',129,1,'you@yourdomain.com','cart','',1417669225,'::1','a:0:{}'),(124,'124',130,1,'you@yourdomain.com','cart','',1417676929,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417677578;}'),(125,'125',131,1,'you@yourdomain.com','cart','',1417676929,'127.0.0.1','a:0:{}'),(126,'126',132,1,'you@yourdomain.com','cart','',1417677685,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417681413;}'),(127,'127',133,1,'you@yourdomain.com','cart','',1417682379,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417682391;}'),(128,'128',134,1,'you@yourdomain.com','cart','',1417685119,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417691418;}'),(129,'129',135,1,'you@yourdomain.com','cart','',1417752212,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1417754704;}'),(130,'130',136,1,'you@yourdomain.com','cart','',1417773659,'::1','a:1:{s:17:\"last_cart_refresh\";i:1417773664;}'),(131,'131',137,0,'','cart','',1417774020,'::1','a:0:{}'),(132,'132',138,1,'you@yourdomain.com','cart','',1417774196,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418010094;}'),(133,'133',139,0,'','cart','',1417774063,'::1','a:0:{}'),(134,'134',140,6,'lazada@shop.com','cart','',1418031915,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418032659;}'),(135,'135',141,1,'you@yourdomain.com','cart','',1418010131,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418014825;}'),(136,'136',142,1,'you@yourdomain.com','cart','',1418021058,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418098996;}'),(137,'137',143,6,'lazada@shop.com','cart','',1418032693,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418099429;}'),(138,'138',144,15,'1@abc.com','cart','',1418033754,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418033754;}'),(139,'139',145,15,'1@abc.com','pending','',1418033784,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418033781;}'),(138,'138',146,15,'1@abc.com','checkout_shipping','Customer continued to the next checkout page via a submit button.',1418033761,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418033761;}'),(138,'138',147,15,'1@abc.com','checkout_review','Customer continued to the next checkout page via a submit button.',1418033781,'::1','a:3:{s:17:\"last_cart_refresh\";i:1418033781;s:14:\"payment_method\";s:42:\"commerce_cod|commerce_payment_commerce_cod\";s:12:\"commerce_cop\";a:1:{s:11:\"transaction\";s:11:\"dummy_value\";}}'),(138,'138',148,15,'1@abc.com','checkout_payment','Customer continued to the next checkout page via a submit button.',1418033781,'::1','a:3:{s:17:\"last_cart_refresh\";i:1418033781;s:14:\"payment_method\";s:42:\"commerce_cod|commerce_payment_commerce_cod\";s:12:\"commerce_cop\";a:1:{s:11:\"transaction\";s:11:\"dummy_value\";}}'),(138,'138',149,15,'1@abc.com','checkout_complete','Customer skipped the Payment page because payment was already submitted.',1418033784,'::1','a:3:{s:17:\"last_cart_refresh\";i:1418033781;s:14:\"payment_method\";s:42:\"commerce_cod|commerce_payment_commerce_cod\";s:12:\"commerce_cop\";a:1:{s:11:\"transaction\";s:11:\"dummy_value\";}}'),(138,'138',150,15,'1@abc.com','pending','Order state updated via Rules.',1418033784,'::1','a:3:{s:17:\"last_cart_refresh\";i:1418033781;s:14:\"payment_method\";s:42:\"commerce_cod|commerce_payment_commerce_cod\";s:12:\"commerce_cop\";a:1:{s:11:\"transaction\";s:11:\"dummy_value\";}}'),(140,'140',151,15,'1@abc.com','cart','',1418034610,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418035582;}'),(141,'141',152,15,'1@abc.com','pending','',1418093574,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418093572;}'),(140,'140',153,15,'1@abc.com','checkout_checkout','Customer proceeded to checkout using a submit button.',1418036627,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418036622;}'),(142,'142',154,15,'1@abc.com','pending','',1418093574,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418093572;}'),(140,'140',155,15,'1@abc.com','cart','Order status updated via Rules.',1418036709,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418036718;}'),(140,'140',156,15,'1@abc.com','checkout_checkout','Customer proceeded to checkout using a submit button.',1418093449,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418093442;}'),(140,'140',157,15,'1@abc.com','cart','Order status updated via Rules.',1418093449,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418093465;}'),(140,'140',158,15,'1@abc.com','checkout_checkout','Customer proceeded to checkout using a submit button.',1418093465,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418093481;}'),(140,'140',159,15,'1@abc.com','checkout_checkout','Customer proceeded to checkout using a submit button.',1418093481,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418093485;}'),(140,'140',160,15,'1@abc.com','checkout_checkout','Customer proceeded to checkout using a submit button.',1418093532,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418093532;}'),(140,'140',161,15,'1@abc.com','checkout_shipping','Customer continued to the next checkout page via a submit button.',1418093540,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418093540;}'),(140,'140',162,15,'1@abc.com','checkout_review','Customer continued to the next checkout page via a submit button.',1418093572,'::1','a:3:{s:17:\"last_cart_refresh\";i:1418093572;s:14:\"payment_method\";s:42:\"commerce_cod|commerce_payment_commerce_cod\";s:12:\"commerce_cop\";a:1:{s:11:\"transaction\";s:11:\"dummy_value\";}}'),(140,'140',163,15,'1@abc.com','checkout_payment','Customer continued to the next checkout page via a submit button.',1418093572,'::1','a:3:{s:17:\"last_cart_refresh\";i:1418093572;s:14:\"payment_method\";s:42:\"commerce_cod|commerce_payment_commerce_cod\";s:12:\"commerce_cop\";a:1:{s:11:\"transaction\";s:11:\"dummy_value\";}}'),(140,'140',164,15,'1@abc.com','checkout_complete','Customer skipped the Payment page because payment was already submitted.',1418093574,'::1','a:3:{s:17:\"last_cart_refresh\";i:1418093572;s:14:\"payment_method\";s:42:\"commerce_cod|commerce_payment_commerce_cod\";s:12:\"commerce_cop\";a:1:{s:11:\"transaction\";s:11:\"dummy_value\";}}'),(140,'140',165,15,'1@abc.com','pending','Order state updated via Rules.',1418093574,'::1','a:3:{s:17:\"last_cart_refresh\";i:1418093572;s:14:\"payment_method\";s:42:\"commerce_cod|commerce_payment_commerce_cod\";s:12:\"commerce_cop\";a:1:{s:11:\"transaction\";s:11:\"dummy_value\";}}'),(143,'143',166,15,'1@abc.com','cart','',1418093619,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418093668;}'),(144,'144',167,1,'you@yourdomain.com','cart','',1418106846,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418182863;}'),(145,'145',168,0,'','cart','',1418105939,'::1','a:0:{}'),(146,'146',169,0,'','cart','',1418112224,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418112493;}'),(147,'147',170,0,'','checkout_checkout','',1418112493,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418112493;}'),(146,'146',171,0,'','checkout_checkout','Customer proceeded to checkout using a submit button.',1418112493,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418182940;}'),(148,'148',172,0,'','cart','',1418280530,'127.0.0.1','a:0:{}'),(149,'149',173,0,'','cart','',1418280530,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418281562;}'),(150,'150',174,1,'you@yourdomain.com','cart','',1418352515,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(151,'151',175,1,'you@yourdomain.com','cart','',1418282801,'192.168.1.14','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(152,'152',176,1,'you@yourdomain.com','cart','',1418281719,'192.168.1.17','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(153,'153',177,6,'lazada@shop.com','cart','',1418281734,'192.168.1.17','a:1:{s:17:\"last_cart_refresh\";i:1418281777;}'),(154,'154',178,0,'','cart','',1418281727,'192.168.1.14','a:0:{}'),(155,'155',179,1,'you@yourdomain.com','cart','',1418290937,'192.168.1.14','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(156,'156',180,1,'you@yourdomain.com','cart','',1418350783,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(157,'157',181,1,'you@yourdomain.com','cart','',1418351015,'192.168.1.14','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(158,'158',182,16,'weebpal@mail.com','cart','',1418356767,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418375386;}'),(159,'159',183,17,'test@mail.vn','cart','',1418375395,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418375396;}'),(160,'160',184,6,'lazada@shop.com','cart','',1418376464,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418376480;}'),(161,'161',185,1,'you@yourdomain.com','cart','',1418376493,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(162,'162',186,1,'you@yourdomain.com','cart','',1418377657,'192.168.1.21','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(163,'163',187,0,'','cart','',1418610068,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418613801;}'),(164,'164',188,1,'you@yourdomain.com','cart','',1418610203,'::1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(165,'165',189,1,'you@yourdomain.com','cart','',1418611335,'::1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(166,'166',190,1,'you@yourdomain.com','cart','',1418615876,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(167,'167',191,1,'you@yourdomain.com','cart','',1418715353,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418715509;}'),(168,'168',192,0,'','cart','',1418713807,'192.168.1.21','a:1:{s:17:\"last_cart_refresh\";i:1418713977;}'),(169,'169',193,1,'you@yourdomain.com','checkout_checkout','',1418715560,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(167,'167',194,1,'you@yourdomain.com','checkout_checkout','Customer proceeded to checkout using a submit button.',1418715560,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(170,'170',195,1,'you@yourdomain.com','cart','',1418722477,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(171,'171',196,1,'you@yourdomain.com','cart','',1418786885,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(172,'172',197,1,'you@yourdomain.com','cart','',1418786935,'192.168.1.16','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(173,'173',198,0,'','cart','',1418802186,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418892215;}'),(174,'174',199,1,'you@yourdomain.com','cart','',1418806247,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(175,'175',200,1,'you@yourdomain.com','cart','',1418872909,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(176,'176',201,1,'you@yourdomain.com','cart','',1418883477,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(177,'177',202,1,'you@yourdomain.com','cart','',1418884020,'192.168.1.14','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(178,'178',203,16,'weebpal@mail.com','cart','',1418885001,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418885020;}'),(179,'179',204,1,'you@yourdomain.com','cart','',1418885030,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(180,'180',205,0,'','cart','',1418885548,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418885612;}'),(181,'181',206,1,'you@yourdomain.com','cart','',1418885684,'192.168.1.14','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(182,'182',207,0,'','cart','',1418891484,'127.0.0.1','a:0:{}'),(183,'183',208,0,'','cart','',1418898965,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418899117;}'),(184,'184',209,0,'','cart','',1418958147,'127.0.0.1','a:0:{}'),(185,'185',210,0,'','cart','',1418958159,'127.0.0.1','a:0:{}'),(186,'186',211,1,'you@yourdomain.com','cart','',1418958180,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(187,'187',212,1,'you@yourdomain.com','cart','',1418958219,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(188,'188',213,1,'you@yourdomain.com','cart','',1418960968,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(189,'189',214,0,'','cart','',1418961471,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418961488;}'),(190,'190',215,1,'you@yourdomain.com','cart','',1418961613,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(189,'189',216,1,'you@yourdomain.com','cart','Customer updated the order via the shopping cart form.',1418961538,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418961613;}'),(189,'189',217,1,'you@yourdomain.com','cart','Customer updated the order via the shopping cart form.',1418961613,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419222874;}'),(191,'191',218,0,'','cart','',1418973423,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418982112;}'),(192,'192',219,0,'','cart','',1418975239,'127.0.0.1','a:0:{}'),(193,'193',220,0,'','cart','',1418975239,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418982153;}'),(194,'194',221,0,'','cart','',1418982830,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418983010;}'),(195,'195',222,1,'you@yourdomain.com','cart','',1418983882,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419231750;}'),(196,'196',223,0,'','cart','',1418984336,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418984402;}'),(197,'197',224,0,'','cart','',1418984495,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1418987241;}'),(198,'198',225,0,'','cart','',1418985935,'::1','a:1:{s:17:\"last_cart_refresh\";i:1418985945;}'),(199,'199',226,0,'','cart','',1419220889,'127.0.0.1','a:0:{}'),(200,'200',227,1,'you@yourdomain.com','cart','',1419231821,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419231821;}'),(201,'201',228,1,'you@yourdomain.com','cart','',1419304163,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419304171;}'),(202,'202',229,1,'you@yourdomain.com','checkout_review','',1419304247,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419304247;}'),(201,'201',230,1,'you@yourdomain.com','checkout_checkout','Customer proceeded to checkout using a submit button.',1419304239,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419304239;}'),(201,'201',231,1,'you@yourdomain.com','checkout_shipping','Customer continued to the next checkout page via a submit button.',1419304247,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419304247;}'),(201,'201',232,1,'you@yourdomain.com','checkout_review','Customer continued to the next checkout page via a submit button.',1419304247,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419304313;}'),(203,'203',233,1,'you@yourdomain.com','cart','',1419304556,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419388971;}'),(204,'204',234,0,'','cart','',1419315427,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419576000;}'),(205,'205',235,1,'you@yourdomain.com','cart','',1419476196,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419476947;}'),(206,'206',236,1,'you@yourdomain.com','cart','',1419476962,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419488146;}'),(207,'207',237,0,'','cart','',1419481619,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419489438;}'),(208,'208',238,0,'','cart','',1419488765,'127.0.0.1','a:0:{}'),(209,'209',239,0,'','cart','',1419500978,'127.0.0.1','a:0:{}'),(210,'210',240,0,'','cart','',1419500979,'127.0.0.1','a:0:{}'),(211,'211',241,1,'you@yourdomain.com','cart','',1419501055,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419503197;}'),(212,'212',242,0,'','cart','',1419501802,'192.168.1.24','a:1:{s:17:\"last_cart_refresh\";i:1419501903;}'),(213,'213',243,0,'','cart','',1419501971,'192.168.1.24','a:1:{s:17:\"last_cart_refresh\";i:1419502822;}'),(214,'214',244,0,'','cart','',1419502509,'192.168.1.13','a:0:{}'),(215,'215',245,0,'','cart','',1419575037,'127.0.0.1','a:0:{}'),(216,'216',246,1,'you@yourdomain.com','cart','',1419575189,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419576982;}'),(217,'217',247,0,'','cart','',1419631970,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419633902;}'),(218,'218',248,1,'you@yourdomain.com','cart','',1419632191,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419633908;}'),(219,'219',249,0,'','cart','',1419633330,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1419633345;}'),(220,'220',250,1,'you@yourdomain.com','cart','',1419868799,'::1','a:1:{s:17:\"last_cart_refresh\";i:1419869609;}'),(221,'221',251,0,'','cart','',1419999112,'127.0.0.1','a:0:{}'),(222,'222',252,0,'','cart','',1419999111,'127.0.0.1','a:0:{}'),(223,'223',253,1,'you@yourdomain.com','cart','',1419999425,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1420000191;}'),(224,'224',254,0,'','cart','',1419999252,'127.0.0.1','a:0:{}'),(225,'225',255,1,'you@yourdomain.com','cart','',1420432073,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1420432340;}'),(226,'226',256,16,'weebpal@mail.com','cart','',1420441457,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1420442286;}'),(227,'227',257,1,'you@yourdomain.com','cart','',1420432865,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1420432869;}'),(228,'228',258,1,'you@yourdomain.com','cart','',1420432910,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1420433250;}'),(229,'229',259,0,'','cart','',1420433605,'127.0.0.1','a:0:{}'),(230,'230',260,16,'weebpal@mail.com','cart','',1420441457,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1420441457;}'),(231,'231',261,16,'weebpal@mail.com','cart','',1420441457,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1420441457;}'),(232,'232',262,0,'','cart','',1420441334,'127.0.0.1','a:0:{}'),(233,'233',263,0,'','cart','',1420442299,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1420444799;}'),(234,'234',264,0,'','cart','',1420693347,'192.168.1.29','a:0:{}'),(235,'235',265,1,'you@yourdomain.com','cart','',1420693534,'192.168.1.29','a:1:{s:17:\"last_cart_refresh\";i:1420698440;}'),(236,'236',266,1,'you@yourdomain.com','cart','',1423540484,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1423541069;}'),(237,'237',267,1,'you@yourdomain.com','cart','',1426155982,'::1','a:1:{s:17:\"last_cart_refresh\";i:1426219035;}'),(238,'238',268,1,'you@yourdomain.com','cart','',1426652810,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1426653492;}'),(239,'239',269,1,'you@yourdomain.com','cart','',1429266927,'::1','a:1:{s:17:\"last_cart_refresh\";i:1429267311;}'),(240,'240',270,1,'you@yourdomain.com','cart','',1438763576,'::1','a:1:{s:17:\"last_cart_refresh\";i:1438849879;}'),(241,'241',271,0,'','cart','',1438848970,'::1','a:0:{}'),(242,'242',272,1,'you@yourdomain.com','cart','',1439180310,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1439266577;}'),(243,'243',273,0,'','cart','',1439201992,'127.0.0.1','a:0:{}'),(244,'244',274,0,'','cart','',1439202129,'127.0.0.1','a:0:{}'),(245,'245',275,0,'','cart','',1439202356,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1439202755;}'),(246,'246',276,0,'','cart','',1439266615,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1439266788;}'),(247,'247',277,1,'you@yourdomain.com','cart','',1440056533,'::1','a:1:{s:17:\"last_cart_refresh\";i:1440056868;}'),(249,'249',278,0,'','cart','',1440401943,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1440402068;}'),(248,'248',279,0,'','cart','',1440401932,'127.0.0.1','a:0:{}'),(250,'250',280,1,'you@yourdomain.com','cart','',1440402280,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1440402591;}'),(251,'251',281,1,'you@yourdomain.com','cart','',1440402280,'127.0.0.1','a:0:{}'),(252,'252',282,0,'','cart','',1443995208,'::1','a:1:{s:17:\"last_cart_refresh\";i:1443995882;}'),(253,'253',283,1,'you@yourdomain.com','cart','',1446071192,'::1','a:1:{s:17:\"last_cart_refresh\";i:1446071493;}'),(254,'254',284,1,'you@yourdomain.com','cart','',1455371257,'127.0.0.1','a:1:{s:17:\"last_cart_refresh\";i:1455374139;}'),(255,'255',285,1,'you@yourdomain.com','cart','',1499933597,'192.168.1.49','a:1:{s:17:\"last_cart_refresh\";i:1499933862;}'),(256,'256',286,1,'you@yourdomain.com','cart','',1500347121,'192.168.1.49','a:1:{s:17:\"last_cart_refresh\";i:1500361298;}');
/*!40000 ALTER TABLE `commerce_order_revision` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `commerce_payment_transaction`
--

DROP TABLE IF EXISTS `commerce_payment_transaction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commerce_payment_transaction` (
  `transaction_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a transaction.',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The current commerce_payment_transaction_revision.revision_id version identifier.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that created this transaction.',
  `order_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The commerce_order.order_id of the order this payment is for.',
  `payment_method` varchar(128) NOT NULL COMMENT 'The payment method method_id for this transaction.',
  `instance_id` varchar(255) NOT NULL COMMENT 'The payment method instance ID for this transaction.',
  `remote_id` varchar(255) NOT NULL COMMENT 'The remote identifier for this transaction.',
  `message` longtext NOT NULL COMMENT 'The human-readable message associated to this transaction.',
  `message_variables` longblob NOT NULL COMMENT 'The variables associated with the human-readable message.',
  `amount` int(11) NOT NULL DEFAULT '0' COMMENT 'The amount of this transaction.',
  `currency_code` varchar(32) NOT NULL COMMENT 'The currency code for the price.',
  `status` varchar(128) NOT NULL COMMENT 'The status of this transaction (pending, success, or failure).',
  `remote_status` varchar(128) NOT NULL COMMENT 'The status of the transaction at the payment provider.',
  `payload` longblob NOT NULL COMMENT 'The payment-gateway specific payload associated with this transaction.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when this transaction was created.',
  `changed` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when this transaction was last changed.',
  `data` longblob COMMENT 'A serialized array of additional data.',
  PRIMARY KEY (`transaction_id`),
  UNIQUE KEY `revision_id` (`revision_id`),
  KEY `payment_method` (`payment_method`),
  KEY `uid` (`uid`),
  KEY `order_id` (`order_id`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8 COMMENT='Transaction information for every attempted payment.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commerce_payment_transaction`
--

LOCK TABLES `commerce_payment_transaction` WRITE;
/*!40000 ALTER TABLE `commerce_payment_transaction` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `commerce_payment_transaction` VALUES (1,1,15,138,'commerce_cod','commerce_cod|commerce_payment_commerce_cod','','Collect the payment on products delivery.','a:0:{}',120000,'USD','pending','','a:0:{}',1418033781,1418033781,NULL),(2,2,15,139,'commerce_marketplace','','','','a:0:{}',120000,'USD','pending','','a:0:{}',1418033784,1418033784,NULL),(3,3,15,140,'commerce_cod','commerce_cod|commerce_payment_commerce_cod','','Collect the payment on products delivery.','a:0:{}',400000,'USD','pending','','a:0:{}',1418093572,1418093572,NULL),(4,4,15,141,'commerce_marketplace','','','','a:0:{}',0,'USD','pending','','a:0:{}',1418093574,1418093574,NULL),(5,5,15,142,'commerce_marketplace','','','','a:0:{}',600000,'USD','pending','','a:0:{}',1418093574,1418093574,NULL);
/*!40000 ALTER TABLE `commerce_payment_transaction` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `commerce_payment_transaction_revision`
--

DROP TABLE IF EXISTS `commerce_payment_transaction_revision`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commerce_payment_transaction_revision` (
  `transaction_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The primary identifier for a transaction.',
  `revision_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The current commerce_payment_transaction_revision.revision_id version identifier.',
  `revision_uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that created this revision.',
  `remote_id` varchar(255) NOT NULL COMMENT 'The remote identifier for this transaction.',
  `message` longtext NOT NULL COMMENT 'The human-readable message associated to this transaction.',
  `message_variables` longblob NOT NULL COMMENT 'The variables associated with the human-readable message.',
  `amount` int(11) NOT NULL DEFAULT '0' COMMENT 'The amount of this transaction.',
  `currency_code` varchar(32) NOT NULL COMMENT 'The currency code for the price.',
  `status` varchar(128) NOT NULL COMMENT 'The status of this transaction (pending, success, or failure).',
  `remote_status` varchar(128) NOT NULL COMMENT 'The status of the transaction at the payment provider.',
  `log` longtext NOT NULL COMMENT 'The log entry explaining the changes in this version.',
  `revision_timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when this revision was created.',
  `data` longblob COMMENT 'A serialized array of additional data.',
  PRIMARY KEY (`revision_id`),
  KEY `transaction_id` (`transaction_id`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8 COMMENT='Saves information about each saved revision of a commerce...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commerce_payment_transaction_revision`
--

LOCK TABLES `commerce_payment_transaction_revision` WRITE;
/*!40000 ALTER TABLE `commerce_payment_transaction_revision` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `commerce_payment_transaction_revision` VALUES (1,1,15,'','Collect the payment on products delivery.','a:0:{}',120000,'USD','pending','','',1418033781,NULL),(2,2,15,'','','a:0:{}',120000,'USD','pending','','',1418033784,NULL),(3,3,15,'','Collect the payment on products delivery.','a:0:{}',400000,'USD','pending','','',1418093572,NULL),(4,4,15,'','','a:0:{}',0,'USD','pending','','',1418093574,NULL),(5,5,15,'','','a:0:{}',600000,'USD','pending','','',1418093574,NULL);
/*!40000 ALTER TABLE `commerce_payment_transaction_revision` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `commerce_paypal_ipn`
--

DROP TABLE IF EXISTS `commerce_paypal_ipn`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commerce_paypal_ipn` (
  `ipn_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Serial numeric ID of the IPN in the local database.',
  `txn_id` varchar(255) NOT NULL DEFAULT '' COMMENT 'The PayPal transaction ID.',
  `txn_type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The PayPal transaction type.',
  `receiver_email` varchar(255) NOT NULL DEFAULT '' COMMENT 'The e-mail of the payment receiever.',
  `payer_email` varchar(255) NOT NULL DEFAULT '' COMMENT 'The e-mail of the payer.',
  `order_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The order ID the payment belongs to.',
  `transaction_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The payment transaction ID the payment belongs to.',
  `mc_gross` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'The gross payment amount.',
  `mc_currency` varchar(255) NOT NULL DEFAULT '' COMMENT 'The currency code of the payment.',
  `mc_fee` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT 'The amount of fees collected by PayPal for this payment.',
  `payment_status` varchar(255) NOT NULL DEFAULT '' COMMENT 'The status of the payment at PayPal.',
  `payment_type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The type of the payment.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the IPN was received.',
  `changed` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the IPN was last updated.',
  `test_ipn` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether or not this was a test IPN sent by the Sandbox.',
  PRIMARY KEY (`ipn_id`),
  KEY `txn_id` (`txn_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores processed IPNs.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commerce_paypal_ipn`
--

LOCK TABLES `commerce_paypal_ipn` WRITE;
/*!40000 ALTER TABLE `commerce_paypal_ipn` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `commerce_paypal_ipn` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `commerce_product`
--

DROP TABLE IF EXISTS `commerce_product`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commerce_product` (
  `product_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a product, used internally only.',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The current commerce_product_revision.revision_id version identifier.',
  `sku` varchar(255) NOT NULL COMMENT 'The unique, human-readable identifier for a product.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title of this product, always treated as non-markup plain text.',
  `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The commerce_product_type.type of this product.',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The languages.language of this product.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that created this product.',
  `status` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'Boolean indicating whether or not the product appears in lists and may be added to orders.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the product was created.',
  `changed` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the product was most recently saved.',
  `data` longblob COMMENT 'A serialized array of additional data.',
  PRIMARY KEY (`product_id`),
  UNIQUE KEY `sku` (`sku`),
  UNIQUE KEY `revision_id` (`revision_id`),
  KEY `product_type` (`type`),
  KEY `uid` (`uid`)
) ENGINE=InnoDB AUTO_INCREMENT=83 DEFAULT CHARSET=utf8 COMMENT='The base table for products.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commerce_product`
--

LOCK TABLES `commerce_product` WRITE;
/*!40000 ALTER TABLE `commerce_product` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `commerce_product` VALUES (4,15,'product004','BlueAnt PUMP HD Wireless Bluetooth Waterproof Headphones','product','und',1,0,1412915521,1417589418,'b:0;'),(6,83,'AP069ELAE8QJVNAMZ-203064','Apple Macbook Air  MD760B - Core i5 / 13.3\" / 4GB (Silver) ','product','und',6,0,1416303464,1418884773,'b:0;'),(7,10,'AP069ELAE8QJVNAMZ-32423432','Apple Macbook Pro ME864 ZP/A – Core i5 / 13.3” / 4GB (White)','product','und',6,0,1416304113,1418884773,'b:0;'),(8,11,'imac','imac-holiday-hero-xl-2015','product','und',1,0,1416386395,1417591228,'b:0;'),(9,84,'AE217FAAPMF5ANMY-727141','Aeroline Casual Hiking Backpack Dark Blue','product','und',1,1,1417426925,1418359890,'b:0;'),(10,86,'AE217FAAPMF6ANMY-727142','Aeroline Casual Hiking Backpack Dark Orange','product','und',1,1,1417426925,1418359890,'b:0;'),(11,18,'LO024FAAKSJ5ANMY-530660','Local Lion Water Resistant Hiking Backpack Bag 28L Blue','product','und',1,1,1417445005,1418359513,'b:0;'),(12,19,'LO024FAAKSJ5ANMY-530661','Local Lion Water Resistant Hiking Backpack Bag 28L Green','product','und',1,1,1417445005,1418359627,'b:0;'),(13,20,'LO024FAAKSJ6ANMY-530662','Local Lion Water Resistant Hiking Backpack Bag 28L Red','product','und',1,1,1417445005,1418359513,'b:0;'),(14,21,'LO024FAAKSJ3ANMY-530659','Orange','product','und',1,1,1417445005,1418359513,'b:0;'),(15,22,'TE960FAAKJC3ANMY-515575','Black','product','und',1,1,1417446223,1418358737,'b:0;'),(16,23,'TA452FAAL25AANMY-544771','Targus Tsb166Ap 15.6In Revolution Backpack Xl','product','und',1,1,1417447402,1418358891,'b:0;'),(17,24,'TA073FAAQQFQANMY-793372','Tarantula Shoe Bag (BOS04-088SHB-03) - Red ','product','und',1,1,1417478826,1418360139,'b:0;'),(18,25,'DI503FAAP8LHANMY-703741','Diniwell Water-Resistant Travel Shoes Bag Pouch Organizer Bag Ver 2 - Orange','product','und',1,1,1417481146,1418358945,'b:0;'),(19,96,'OE702HBAMQYBANMY-647350','24-Piece Makeup Brush Set','product','und',1,1,1417504200,1418353570,'b:0;'),(20,27,'CA065HBAS3UKANMY-866687','Cameleon MakeUp Kit 396 ','product','und',1,1,1417504583,1417504622,'b:0;'),(21,118,'OE702HBAT78LANMY-922903','4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner','product','und',1,1,1417508779,1418355984,'b:0;'),(22,97,'SK159HBASXK7ANMY-908752','SK-II 5-Piece Skincare Travel Set 5pcs Travel Packs SKII SK2','product','und',1,1,1417509360,1418353687,'b:0;'),(23,98,'SK222HBAQYN8ANMY-807324','Organic Eye Cream 15ml','product','und',1,1,1417510355,1418353847,'b:0;'),(24,99,'ME223HBAT7XUANMY-924008','Mejikaliner Quick Eyelid Essence Stick Glue - Night Use','product','und',1,1,1417511293,1418353898,'b:0;'),(25,100,'HA181HBASX9JANMY-908363','Hairscape 1800W (AUS) 5000 Professional Hair Dryer ','product','und',1,1,1417511809,1418353973,'b:0;'),(26,92,'OE702HBAST9QANMY-901982','Tonific Slimming Massager','product','und',1,1,1417512093,1418352847,'b:0;'),(27,101,'AP564ELAPUHIANMY-741814','Apple iPhone 6 16GB Gold','product','und',1,1,1417513096,1418354150,'b:0;'),(28,35,'SA356ELAQRCJANMY-794737','Samsung N910 Note 4 LTE 32GB White','product','und',1,1,1417513689,1418715439,'b:0;'),(29,36,'AS575ELAT5HFANMY-920560','Asus Transformer P1801-B041K AIO 18.4\" PC Dekstop + Asus RT-N56U Wireless N N600 Dual-Band Gigabit Router','product','und',1,1,1417515301,1426216822,'b:0;'),(30,102,'LE106ELAT4HKANMY-918581','Lenovo A316','product','und',1,1,1417515888,1418354515,'b:0;'),(31,91,'NO225ELAK8TTANMY-497673','Nokia Asha 206 Dual SIM Black','product','und',1,1,1417517324,1418352780,'b:0;'),(32,90,'AP564ELAPEZNANMY-715186','Apple IPAD 3 Wi-Fi+4G MD368 64GB Black','product','und',1,1,1417518185,1418352736,'b:0;'),(33,103,'OE702ELAS5KHANMY-868993','Asus Memopad 7 (Tablet)','product','und',1,1,1417518819,1418354613,'b:0;'),(34,41,'LE106ELASXT7ANMY-909117','Lenovo Tablet Miix 2 59399848 8\" Silver','product','und',1,1,1417528583,1426216927,'b:0;'),(35,42,'AP564ELAT12EANMY-913520','Apple iPad Air 16GB WiFi Space Grey (MD785ZPA)','product','und',1,1,1417530153,1418024974,'b:0;'),(36,104,'SP889ELASU66ANMY-903500','Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold','product','und',1,1,1417530854,1418354735,'b:0;'),(37,44,'SA356ELAT7YMANMY-924036','[GENUINE] SAMSUNG Galaxy Note 4 S View Classic Cover Case - Black','product','und',1,1,1417531758,1417532121,'b:0;'),(38,105,'OE702ELAK0U8ANMY-486129','Samsung Galaxy Tab 7.0 Plus Vehicle Dock With In-Car Charger','product','und',1,1,1417532298,1418354827,'b:0;'),(39,106,'OT343ELAM59DANMY-609257','Angel Universal Mobile Phone In Car Phone Holder 360 degree Item Code: P338','product','und',1,1,1417533303,1418354911,'b:0;'),(40,107,'AP564ELALLJMANMY-575572','Original Apple Earpod Earphone with Remote & Mic for iPhone iPad iPod','product','und',1,1,1417573407,1418354999,'b:0;'),(41,89,'SO406ELAKPRJANMY-525730','Sony Stereo Bluetooth Headset SBH20 Black','product','und',1,1,1417576765,1418352688,'b:0;'),(42,88,'SO406ELAKPRJANMY-525732','Sony Stereo Bluetooth Headset SBH20 Pink','product','und',1,1,1417576765,1418352664,'b:0;'),(43,108,'OE702ELASS8BANMY-900509','TOP Mi 10400mAh Powerbank - Black','product','und',1,1,1417577778,1418355075,'b:0;'),(44,109,'OE702EL51SMMANMY-130613','Universal Dual-Port Power Bank 20000mAh Black','product','und',1,1,1417578198,1418355132,'b:0;'),(45,110,'MU553FAARFDMANMY-830725','MuWo Trendz Swarovski Element White Gold Plated Everlasting Love Set','product','und',1,1,1417578593,1418355191,'b:0;'),(46,53,'LU757FAAT3KBANMY-916954','LUCCACAL Multi Color Tribal Necklace','product','und',1,1,1417578986,1417579731,'b:0;'),(47,111,'DA883FAAL9R7ANMY-556875','Dandelion Women Braided Belt White','product','und',1,1,1417579652,1418355243,'b:0;'),(48,55,'DA883FAAL9QSANMY-556860','Dandelion Cross Stitch Belt Orange','product','und',1,1,1417579912,1417579961,'b:0;'),(49,112,'FU022FAALCH2ANMY-561503','Fur Nyce Big Square Classic Chain Pattern Print Scarf','product','und',1,1,1417580590,1418355310,'b:0;'),(50,113,'FU022FAAL7JTANMY-553296','Fur Nyce Fashion Zebra Pattern Print Scarf White','product','und',1,1,1417580757,1418355550,'b:0;'),(51,114,'IN656FAAS6G7ANMY-870227','Invicta Pro Diver Men Black Stainless Steel Strap Watch 15422','product','und',1,1,1417581463,1418355586,'b:0;'),(52,115,'RO180FAASX6RANMY-908233','Rolex Submariner Black Dial Stainless Steel Automatic Mens Watch 114060','product','und',1,1,1417581629,1418355665,'b:0;'),(53,116,'SU433FAASXLFANMY-908796','SUUNTO VECTOR BLACK SUSS010600610 MOUNTAIN OUTDOOR WATCH ','product','und',1,1,1417582273,1418355713,'b:0;'),(54,117,'OE702FAASHKNANMY-885439','SKMEI 0955 30m Waterproof Analogue Digital Dual Time Men\'s Sports Watch Black + Green','product','und',1,1,1417582520,1418355891,'b:0;'),(55,119,'SA356ELAROW3ANMY-844449','Samsung 4\'\' Full HD LED TV - UA40H5008ARXXM Series 5','product','und',1,1,1417587476,1426216629,'b:0;'),(56,120,'SO406ELAMA8AANMY-618653','Sony 48\" Full HD LED TV - BRAVIA Model KDL-48R470B','product','und',1,1,1417587699,1426216590,'b:0;'),(57,121,'SO406ELAO9YXANMY-651058','Sony BDV-N9200W 9.1 Cinema Studio 3D Blu-Ray Disc home Theatre System','product','und',1,1,1417588138,1418356733,'b:0;'),(58,122,'SA356ELAOL1VANMY-666683','Samsung HT-E350K DVD Home Theater System','product','und',1,1,1417588401,1418356788,'b:0;'),(59,123,'OE702ELAMNJ0ANMY-642088','L12S OLED Smart Watch Bluetooth 3.0 Bracelet Wrist Design for IOS Android iPhone Samsung Smart Phone Blue','product','und',1,1,1417588949,1418356999,'b:0;'),(60,124,'AP564ELALVSWANMY-592956','ORI Apple TV','product','und',1,1,1417589262,1418357047,'b:0;'),(61,68,'DE759ELAT5R5ANMY-920910','Dell Alienware X51-77822G Gaming Desktop','product','und',1,1,1417590261,1418358045,'b:0;'),(62,69,'OE702ELAKQT4ANMY-527371','3 Port HDMI Switch With Remote Control','product','und',1,1,1417591448,1418358116,'b:0;'),(63,70,'DE759ELAP5I7ANMY-696915','Dell PowerConnect 5524P 24 GbE Port Managed L2 Switch with PoE support 10GbE and Stacking Capable','product','und',1,1,1417591728,1418358205,'b:0;'),(64,71,'TP481ELAKVC0ANMY-535125','TP-Link M5250 N900 3G Mobile WiFi Black','product','und',1,1,1417592574,1418358277,'b:0;'),(65,72,'TP481ELAJQBOANMY-468439','TP-LINK N750 Wireless Dual Band Gigabit Router TL-WDR4300 Black','product','und',1,1,1417592796,1418358332,'b:0;'),(66,95,'CA673ELAM9XUANMY-618219','Canon LiDE 210 Scanner','product','und',1,1,1417598912,1418353340,'b:0;'),(67,94,'EP840ELALTF7ANMY-589363','Epson Perfection V33 Scanner','product','und',1,1,1417599162,1418353286,'b:0;'),(68,93,'CA680ELAPVLXANMY-743566','CASIO Exilim EX-ZR1500 Digital Camera Pink','product','und',1,1,1417599720,1418353150,'b:0;'),(69,76,'CA673ELARXO5ANMY-857455','Canon PowerShot SX60 HS 16.1MP Black + 8GB + Case','product','und',1,1,1417600163,1418029308,'b:0;'),(70,77,'CA673ELALORHANMY-581181','Canon EOS 600D 18MP + 18-55mm Lens','product','und',1,1,1417600767,1417600791,'b:0;'),(71,126,'SA356ELAOVYAANMY-683458','Samsung Smart Camera NX Mini 20.5MP Green + 9mm Lens + 16 GB Memory Card','product','und',1,1,1418365242,1418365242,NULL),(72,127,'NI220ELAO90EANMY-649565','Nikon AF-S 50mm Lens f/1.8G','product','und',1,1,1418365650,1418365650,NULL),(73,128,'CA673ELATEX3ANMY-936277','Canon EF-S Lens 18-200mm f/3.5-5.6 IS','product','und',1,1,1418366198,1418366198,NULL),(74,132,'CO716ELAPOWBANMY-731726','Cokin U961A Z Pro Grad Kit - Z Filter Holder + Z121L + Z123L + Z125L','product','und',1,1,1418366731,1418369107,'b:0;'),(75,143,'DL746ELAOZRFANMY-689095','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','product','und',1,1,1418367347,1418371347,'b:0;'),(76,131,'SC910ELAPTXIANMY-740946','CCTV- 850TVL IR DOME CCTV CAMERA','product','und',1,1,1418368416,1418369954,'b:0;'),(77,133,'TR626ELAMPM1ANMY-645445','Trek Ai-Ball Portable Wi-Fi Remote Camera with Cradle & Adaptors (Yellow)','product','und',1,1,1418369205,1418369928,'b:0;'),(78,134,'CT941TBAM1QDANMY-602711','Mini Quran for Kids Yellow','product','und',1,1,1418370240,1418370240,NULL),(79,137,'BO242TBAPSO5ANMY-738496','Boogie Board 10.5 Inch LCD Writing Tablet Pink','product','und',1,1,1418370758,1418370810,'b:0;'),(80,141,'CH299TBAS06ZANMY-861162','Transporter Carry Cot','product','und',1,1,1418371223,1418371223,NULL),(81,144,'KI236HBAP7FZANMY-699829','Kinohimitsu J\'pan BB Drink 50ml x 10','product','und',1,1,1418884808,1418884808,NULL),(82,145,'TK512SPALA1FANMY-557274','TKO Fat Burner Mega','product','und',1,1,1418885579,1419219331,'b:0;');
/*!40000 ALTER TABLE `commerce_product` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `commerce_product_revision`
--

DROP TABLE IF EXISTS `commerce_product_revision`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commerce_product_revision` (
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The commerce_product.product_id of the product this revision belongs to.',
  `revision_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for this revision.',
  `sku` varchar(255) NOT NULL COMMENT 'The unique, human-readable identifier of a product for this revision.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title of this product for this revision',
  `revision_uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that owns the product at this revision.',
  `status` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'The status of this revision.',
  `log` longtext NOT NULL COMMENT 'The log entry explaining the changes in this version.',
  `revision_timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when this revision was created.',
  `data` longblob COMMENT 'A serialized array of additional data for this revision.',
  PRIMARY KEY (`revision_id`),
  KEY `product_id` (`product_id`),
  KEY `revision_uid` (`revision_uid`)
) ENGINE=InnoDB AUTO_INCREMENT=146 DEFAULT CHARSET=utf8 COMMENT='Saves information about each saved revision of a commerce...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commerce_product_revision`
--

LOCK TABLES `commerce_product_revision` WRITE;
/*!40000 ALTER TABLE `commerce_product_revision` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `commerce_product_revision` VALUES (4,4,'product004','BlueAnt PUMP HD Wireless Bluetooth Waterproof Headphones',1,1,'',1417155373,'b:0;'),(6,6,'AP069ELAE8QJVNAMZ-203064','Apple Macbook Air  MD760B - Core i5 / 13.3\" / 4GB (Silver) ',1,1,'',1417155373,'b:0;'),(7,7,'AP069ELAE8QJVNAMZ-32423432','Apple Macbook Pro ME864 ZP/A – Core i5 / 13.3” / 4GB (White)',1,1,'',1417155373,'b:0;'),(8,8,'imac','imac-holiday-hero-xl-2015',1,1,'',1417155373,'b:0;'),(6,9,'AP069ELAE8QJVNAMZ-203064','Apple Macbook Air  MD760B - Core i5 / 13.3\" / 4GB (Silver) ',1,1,'',1417160482,'b:0;'),(7,10,'AP069ELAE8QJVNAMZ-32423432','Apple Macbook Pro ME864 ZP/A – Core i5 / 13.3” / 4GB (White)',1,0,'',1418884773,'b:0;'),(8,11,'imac','imac-holiday-hero-xl-2015',1,0,'',1417591228,'b:0;'),(4,15,'product004','BlueAnt PUMP HD Wireless Bluetooth Waterproof Headphones',1,0,'',1417589418,'b:0;'),(9,16,'AE217FAAPMF5ANMY-727141','Blue',1,1,'',1417489436,'b:0;'),(10,17,'AE217FAAPMF6ANMY-727142','Orange',1,1,'',1417489436,'b:0;'),(11,18,'LO024FAAKSJ5ANMY-530660','Local Lion Water Resistant Hiking Backpack Bag 28L Blue',1,1,'',1418359513,'b:0;'),(12,19,'LO024FAAKSJ5ANMY-530661','Local Lion Water Resistant Hiking Backpack Bag 28L Green',1,1,'',1418359627,'b:0;'),(13,20,'LO024FAAKSJ6ANMY-530662','Local Lion Water Resistant Hiking Backpack Bag 28L Red',1,1,'',1418359513,'b:0;'),(14,21,'LO024FAAKSJ3ANMY-530659','Orange',1,1,'',1418359513,'b:0;'),(15,22,'TE960FAAKJC3ANMY-515575','Black',1,1,'',1418358737,'b:0;'),(16,23,'TA452FAAL25AANMY-544771','Targus Tsb166Ap 15.6In Revolution Backpack Xl',1,1,'',1418358891,'b:0;'),(17,24,'TA073FAAQQFQANMY-793372','Tarantula Shoe Bag (BOS04-088SHB-03) - Red ',1,1,'',1418360139,'b:0;'),(18,25,'DI503FAAP8LHANMY-703741','Diniwell Water-Resistant Travel Shoes Bag Pouch Organizer Bag Ver 2 - Orange',1,1,'',1418358945,'b:0;'),(19,26,'OE702HBAMQYBANMY-647350','24-Piece Makeup Brush Set',1,1,'',1417504200,NULL),(20,27,'CA065HBAS3UKANMY-866687','Cameleon MakeUp Kit 396 ',1,1,'',1417504622,'b:0;'),(21,28,'OE702HBAT78LANMY-922903','4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner',1,1,'',1417508779,NULL),(22,29,'SK159HBASXK7ANMY-908752','SK-II 5-Piece Skincare Travel Set 5pcs Travel Packs SKII SK2',1,1,'',1417509360,NULL),(23,30,'SK222HBAQYN8ANMY-807324','Organic Eye Cream 15ml',1,1,'',1417510355,NULL),(24,31,'ME223HBAT7XUANMY-924008','Mejikaliner Quick Eyelid Essence Stick Glue - Night Use',1,1,'',1417511293,NULL),(25,32,'HA181HBASX9JANMY-908363','Hairscape 1800W (AUS) 5000 Professional Hair Dryer ',1,1,'',1417511809,NULL),(26,33,'OE702HBAST9QANMY-901982','Tonific Slimming Massager',1,1,'',1417775931,'b:0;'),(27,34,'AP564ELAPUHIANMY-741814','Apple iPhone 6 16GB Gold',1,1,'',1417513118,'b:0;'),(28,35,'SA356ELAQRCJANMY-794737','Samsung N910 Note 4 LTE 32GB White',1,1,'',1418715439,'b:0;'),(29,36,'AS575ELAT5HFANMY-920560','Asus Transformer P1801-B041K AIO 18.4\" PC Dekstop + Asus RT-N56U Wireless N N600 Dual-Band Gigabit Router',1,1,'',1426216822,'b:0;'),(30,37,'LE106ELAT4HKANMY-918581','Lenovo A316',1,1,'',1417517463,'b:0;'),(31,38,'NO225ELAK8TTANMY-497673','Nokia Asha 206 Dual SIM Black',1,1,'',1417776103,'b:0;'),(32,39,'AP564ELAPEZNANMY-715186','Apple IPAD 3 Wi-Fi+4G MD368 64GB Black',1,1,'',1417776271,'b:0;'),(33,40,'OE702ELAS5KHANMY-868993','Asus Memopad 7 (Tablet)',1,1,'',1417518819,NULL),(34,41,'LE106ELASXT7ANMY-909117','Lenovo Tablet Miix 2 59399848 8\" Silver',1,1,'',1426216927,'b:0;'),(35,42,'AP564ELAT12EANMY-913520','Apple iPad Air 16GB WiFi Space Grey (MD785ZPA)',1,1,'',1418024974,'b:0;'),(36,43,'SP889ELASU66ANMY-903500','Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold',1,1,'',1417530854,NULL),(37,44,'SA356ELAT7YMANMY-924036','[GENUINE] SAMSUNG Galaxy Note 4 S View Classic Cover Case - Black',1,1,'',1417532121,'b:0;'),(38,45,'OE702ELAK0U8ANMY-486129','Samsung Galaxy Tab 7.0 Plus Vehicle Dock With In-Car Charger',1,1,'',1417532298,NULL),(39,46,'OT343ELAM59DANMY-609257','Angel Universal Mobile Phone In Car Phone Holder 360 degree Item Code: P338',1,1,'',1417533303,NULL),(40,47,'AP564ELALLJMANMY-575572','Original Apple Earpod Earphone with Remote & Mic for iPhone iPad iPod',1,1,'',1417573407,NULL),(41,48,'SO406ELAKPRJANMY-525730','Sony Stereo Bluetooth Headset SBH20 Black',1,1,'',1417776572,'b:0;'),(42,49,'SO406ELAKPRJANMY-525732','Sony Stereo Bluetooth Headset SBH20 Pink',1,1,'',1417777166,'b:0;'),(43,50,'OE702ELASS8BANMY-900509','TOP Mi 10400mAh Powerbank - Black',1,1,'',1417577778,NULL),(44,51,'OE702EL51SMMANMY-130613','Universal Dual-Port Power Bank 20000mAh Black',1,1,'',1417578198,NULL),(45,52,'MU553FAARFDMANMY-830725','MuWo Trendz Swarovski Element White Gold Plated Everlasting Love Set',1,1,'',1417578593,NULL),(46,53,'LU757FAAT3KBANMY-916954','LUCCACAL Multi Color Tribal Necklace',1,1,'',1417579731,'b:0;'),(47,54,'DA883FAAL9R7ANMY-556875','Dandelion Women Braided Belt White',1,1,'',1417579727,'b:0;'),(48,55,'DA883FAAL9QSANMY-556860','Dandelion Cross Stitch Belt Orange',1,1,'',1417579961,'b:0;'),(49,56,'FU022FAALCH2ANMY-561503','Fur Nyce Big Square Classic Chain Pattern Print Scarf',1,1,'',1417580590,NULL),(50,57,'FU022FAAL7JTANMY-553296','Fur Nyce Fashion Zebra Pattern Print Scarf White',1,1,'',1417580757,NULL),(51,58,'IN656FAAS6G7ANMY-870227','Invicta Pro Diver Men Black Stainless Steel Strap Watch 15422',1,1,'',1417581463,NULL),(52,59,'RO180FAASX6RANMY-908233','Rolex Submariner Black Dial Stainless Steel Automatic Mens Watch 114060',1,1,'',1417581629,NULL),(53,60,'SU433FAASXLFANMY-908796','SUUNTO VECTOR BLACK SUSS010600610 MOUNTAIN OUTDOOR WATCH ',1,1,'',1417582273,NULL),(54,61,'OE702FAASHKNANMY-885439','SKMEI 0955 30m Waterproof Analogue Digital Dual Time Men\'s Sports Watch Black + Green',1,1,'',1417582520,NULL),(55,62,'SA356ELAROW3ANMY-844449','Samsung 40\" Full HD LED TV - UA40H5008ARXXM Series 5',1,1,'',1417587476,NULL),(56,63,'SO406ELAMA8AANMY-618653','Sony 48\" Full HD LED TV - BRAVIA Model KDL-48R470B',1,1,'',1417587699,NULL),(57,64,'SO406ELAO9YXANMY-651058','Sony BDV-N9200W 9.1 Cinema Studio 3D Blu-Ray Disc home Theatre System',1,1,'',1417588138,NULL),(58,65,'SA356ELAOL1VANMY-666683','Samsung HT-E350K DVD Home Theater System',1,1,'',1417588401,NULL),(59,66,'OE702ELAMNJ0ANMY-642088','L12S OLED Smart Watch Bluetooth 3.0 Bracelet Wrist Design for IOS Android iPhone Samsung Smart Phone Blue',1,1,'',1417588949,NULL),(60,67,'AP564ELALVSWANMY-592956','ORI Apple TV',1,1,'',1417589262,NULL),(61,68,'DE759ELAT5R5ANMY-920910','Dell Alienware X51-77822G Gaming Desktop',1,1,'',1418358045,'b:0;'),(62,69,'OE702ELAKQT4ANMY-527371','3 Port HDMI Switch With Remote Control',1,1,'',1418358116,'b:0;'),(63,70,'DE759ELAP5I7ANMY-696915','Dell PowerConnect 5524P 24 GbE Port Managed L2 Switch with PoE support 10GbE and Stacking Capable',1,1,'',1418358205,'b:0;'),(64,71,'TP481ELAKVC0ANMY-535125','TP-Link M5250 N900 3G Mobile WiFi Black',1,1,'',1418358277,'b:0;'),(65,72,'TP481ELAJQBOANMY-468439','TP-LINK N750 Wireless Dual Band Gigabit Router TL-WDR4300 Black',1,1,'',1418358332,'b:0;'),(66,73,'CA673ELAM9XUANMY-618219','Canon LiDE 210 Scanner',1,1,'',1417598912,NULL),(67,74,'EP840ELALTF7ANMY-589363','Epson Perfection V33 Scanner',1,1,'',1417599162,NULL),(68,75,'CA680ELAPVLXANMY-743566','CASIO Exilim EX-ZR1500 Digital Camera Pink',1,1,'',1417599720,NULL),(69,76,'CA673ELARXO5ANMY-857455','Canon PowerShot SX60 HS 16.1MP Black + 8GB + Case',1,1,'',1418029308,'b:0;'),(70,77,'CA673ELALORHANMY-581181','Canon EOS 600D 18MP + 18-55mm Lens',1,1,'',1417600791,'b:0;'),(9,78,'AE217FAAPMF5ANMY-727141','Blue',1,1,'',1417603760,'b:0;'),(9,79,'AE217FAAPMF5ANMY-727141','Blue',1,1,'',1417603858,'b:0;'),(10,80,'AE217FAAPMF6ANMY-727142','Orange',1,1,'',1417603893,'b:0;'),(41,81,'SO406ELAKPRJANMY-525730','Sony Stereo Bluetooth Headset SBH20 Black',1,1,'',1417777531,'b:0;'),(42,82,'SO406ELAKPRJANMY-525732','Sony Stereo Bluetooth Headset SBH20 Pink',1,1,'',1417777536,'b:0;'),(6,83,'AP069ELAE8QJVNAMZ-203064','Apple Macbook Air  MD760B - Core i5 / 13.3\" / 4GB (Silver) ',1,0,'',1418884773,'b:0;'),(9,84,'AE217FAAPMF5ANMY-727141','Aeroline Casual Hiking Backpack Dark Blue',1,1,'',1418359890,'b:0;'),(10,85,'AE217FAAPMF6ANMY-727142','Aeroline Casual Hiking Backpack Dark Orange',1,1,'',1418290997,'b:0;'),(10,86,'AE217FAAPMF6ANMY-727142','Aeroline Casual Hiking Backpack Dark Orange',1,1,'',1418359890,'b:0;'),(41,87,'SO406ELAKPRJANMY-525730','Sony Stereo Bluetooth Headset SBH20 Black',1,1,'',1418352605,'b:0;'),(42,88,'SO406ELAKPRJANMY-525732','Sony Stereo Bluetooth Headset SBH20 Pink',1,1,'',1418352664,'b:0;'),(41,89,'SO406ELAKPRJANMY-525730','Sony Stereo Bluetooth Headset SBH20 Black',1,1,'',1418352688,'b:0;'),(32,90,'AP564ELAPEZNANMY-715186','Apple IPAD 3 Wi-Fi+4G MD368 64GB Black',1,1,'',1418352736,'b:0;'),(31,91,'NO225ELAK8TTANMY-497673','Nokia Asha 206 Dual SIM Black',1,1,'',1418352780,'b:0;'),(26,92,'OE702HBAST9QANMY-901982','Tonific Slimming Massager',1,1,'',1418352847,'b:0;'),(68,93,'CA680ELAPVLXANMY-743566','CASIO Exilim EX-ZR1500 Digital Camera Pink',1,1,'',1418353150,'b:0;'),(67,94,'EP840ELALTF7ANMY-589363','Epson Perfection V33 Scanner',1,1,'',1418353286,'b:0;'),(66,95,'CA673ELAM9XUANMY-618219','Canon LiDE 210 Scanner',1,1,'',1418353340,'b:0;'),(19,96,'OE702HBAMQYBANMY-647350','24-Piece Makeup Brush Set',1,1,'',1418353570,'b:0;'),(22,97,'SK159HBASXK7ANMY-908752','SK-II 5-Piece Skincare Travel Set 5pcs Travel Packs SKII SK2',1,1,'',1418353687,'b:0;'),(23,98,'SK222HBAQYN8ANMY-807324','Organic Eye Cream 15ml',1,1,'',1418353847,'b:0;'),(24,99,'ME223HBAT7XUANMY-924008','Mejikaliner Quick Eyelid Essence Stick Glue - Night Use',1,1,'',1418353898,'b:0;'),(25,100,'HA181HBASX9JANMY-908363','Hairscape 1800W (AUS) 5000 Professional Hair Dryer ',1,1,'',1418353973,'b:0;'),(27,101,'AP564ELAPUHIANMY-741814','Apple iPhone 6 16GB Gold',1,1,'',1418354150,'b:0;'),(30,102,'LE106ELAT4HKANMY-918581','Lenovo A316',1,1,'',1418354515,'b:0;'),(33,103,'OE702ELAS5KHANMY-868993','Asus Memopad 7 (Tablet)',1,1,'',1418354613,'b:0;'),(36,104,'SP889ELASU66ANMY-903500','Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold',1,1,'',1418354735,'b:0;'),(38,105,'OE702ELAK0U8ANMY-486129','Samsung Galaxy Tab 7.0 Plus Vehicle Dock With In-Car Charger',1,1,'',1418354827,'b:0;'),(39,106,'OT343ELAM59DANMY-609257','Angel Universal Mobile Phone In Car Phone Holder 360 degree Item Code: P338',1,1,'',1418354911,'b:0;'),(40,107,'AP564ELALLJMANMY-575572','Original Apple Earpod Earphone with Remote & Mic for iPhone iPad iPod',1,1,'',1418354999,'b:0;'),(43,108,'OE702ELASS8BANMY-900509','TOP Mi 10400mAh Powerbank - Black',1,1,'',1418355075,'b:0;'),(44,109,'OE702EL51SMMANMY-130613','Universal Dual-Port Power Bank 20000mAh Black',1,1,'',1418355132,'b:0;'),(45,110,'MU553FAARFDMANMY-830725','MuWo Trendz Swarovski Element White Gold Plated Everlasting Love Set',1,1,'',1418355191,'b:0;'),(47,111,'DA883FAAL9R7ANMY-556875','Dandelion Women Braided Belt White',1,1,'',1418355243,'b:0;'),(49,112,'FU022FAALCH2ANMY-561503','Fur Nyce Big Square Classic Chain Pattern Print Scarf',1,1,'',1418355310,'b:0;'),(50,113,'FU022FAAL7JTANMY-553296','Fur Nyce Fashion Zebra Pattern Print Scarf White',1,1,'',1418355550,'b:0;'),(51,114,'IN656FAAS6G7ANMY-870227','Invicta Pro Diver Men Black Stainless Steel Strap Watch 15422',1,1,'',1418355586,'b:0;'),(52,115,'RO180FAASX6RANMY-908233','Rolex Submariner Black Dial Stainless Steel Automatic Mens Watch 114060',1,1,'',1418355665,'b:0;'),(53,116,'SU433FAASXLFANMY-908796','SUUNTO VECTOR BLACK SUSS010600610 MOUNTAIN OUTDOOR WATCH ',1,1,'',1418355713,'b:0;'),(54,117,'OE702FAASHKNANMY-885439','SKMEI 0955 30m Waterproof Analogue Digital Dual Time Men\'s Sports Watch Black + Green',1,1,'',1418355891,'b:0;'),(21,118,'OE702HBAT78LANMY-922903','4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner',1,1,'',1418355984,'b:0;'),(55,119,'SA356ELAROW3ANMY-844449','Samsung 4\'\' Full HD LED TV - UA40H5008ARXXM Series 5',1,1,'',1426216629,'b:0;'),(56,120,'SO406ELAMA8AANMY-618653','Sony 48\" Full HD LED TV - BRAVIA Model KDL-48R470B',1,1,'',1426216590,'b:0;'),(57,121,'SO406ELAO9YXANMY-651058','Sony BDV-N9200W 9.1 Cinema Studio 3D Blu-Ray Disc home Theatre System',1,1,'',1418356733,'b:0;'),(58,122,'SA356ELAOL1VANMY-666683','Samsung HT-E350K DVD Home Theater System',1,1,'',1418356788,'b:0;'),(59,123,'OE702ELAMNJ0ANMY-642088','L12S OLED Smart Watch Bluetooth 3.0 Bracelet Wrist Design for IOS Android iPhone Samsung Smart Phone Blue',1,1,'',1418356999,'b:0;'),(60,124,'AP564ELALVSWANMY-592956','ORI Apple TV',1,1,'',1418357047,'b:0;'),(11,125,'LO024FAAKSJ4ANMY-530660','Local Lion Water Resistant Hiking Backpack Bag 28L Blue',1,1,'',1418359393,'b:0;'),(71,126,'SA356ELAOVYAANMY-683458','Samsung Smart Camera NX Mini 20.5MP Green + 9mm Lens + 16 GB Memory Card',1,1,'',1418365242,NULL),(72,127,'NI220ELAO90EANMY-649565','Nikon AF-S 50mm Lens f/1.8G',1,1,'',1418365650,NULL),(73,128,'CA673ELATEX3ANMY-936277','Canon EF-S Lens 18-200mm f/3.5-5.6 IS',1,1,'',1418366198,NULL),(74,129,'CO716ELAPOWBANMY-731726','Cokin U961A Z Pro Grad Kit - Z Filter Holder + Z121L + Z123L + Z125L',1,1,'',1418366856,'b:0;'),(75,130,'DL746ELAOZRFANMY-689095','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',1,1,'',1418370702,'b:0;'),(76,131,'SC910ELAPTXIANMY-740946','CCTV- 850TVL IR DOME CCTV CAMERA',1,1,'',1418369954,'b:0;'),(74,132,'CO716ELAPOWBANMY-731726','Cokin U961A Z Pro Grad Kit - Z Filter Holder + Z121L + Z123L + Z125L',1,1,'',1418369107,'b:0;'),(77,133,'TR626ELAMPM1ANMY-645445','Trek Ai-Ball Portable Wi-Fi Remote Camera with Cradle & Adaptors (Yellow)',1,1,'',1418369928,'b:0;'),(78,134,'CT941TBAM1QDANMY-602711','Mini Quran for Kids Yellow',1,1,'',1418370240,NULL),(75,135,'DL746ELAOZRFANMY-689095','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',1,1,'',1418370726,'b:0;'),(75,136,'DL746ELAOZRFANMY-689095','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',1,1,'',1418370734,'b:0;'),(79,137,'BO242TBAPSO5ANMY-738496','Boogie Board 10.5 Inch LCD Writing Tablet Pink',1,1,'',1418370810,'b:0;'),(75,138,'DL746ELAOZRFANMY-689095','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',1,1,'',1418370785,'b:0;'),(75,139,'DL746ELAOZRFANMY-689095','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',1,1,'',1418370793,'b:0;'),(75,140,'DL746ELAOZRFANMY-689095','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',1,1,'',1418370805,'b:0;'),(80,141,'CH299TBAS06ZANMY-861162','Transporter Carry Cot',1,1,'',1418371223,NULL),(75,142,'DL746ELAOZRFANMY-689095','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',1,1,'',1418371339,'b:0;'),(75,143,'DL746ELAOZRFANMY-689095','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',1,1,'',1418371347,'b:0;'),(81,144,'KI236HBAP7FZANMY-699829','Kinohimitsu J\'pan BB Drink 50ml x 10',1,1,'',1418884808,NULL),(82,145,'TK512SPALA1FANMY-557274','TKO Fat Burner Mega',1,1,'',1419219331,'b:0;');
/*!40000 ALTER TABLE `commerce_product_revision` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `commerce_product_type`
--

DROP TABLE IF EXISTS `commerce_product_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commerce_product_type` (
  `type` varchar(32) NOT NULL DEFAULT '' COMMENT 'The machine-readable name of this type.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The human-readable name of this type.',
  `description` mediumtext NOT NULL COMMENT 'A brief description of this type.',
  `help` mediumtext NOT NULL COMMENT 'Help information shown to the user when creating a commerce_product of this type.',
  `revision` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'Determine whether to create a new revision when a product of this type is updated.',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores information about commerce_product types created...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commerce_product_type`
--

LOCK TABLES `commerce_product_type` WRITE;
/*!40000 ALTER TABLE `commerce_product_type` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `commerce_product_type` VALUES ('product','Product','A basic product type.','',1);
/*!40000 ALTER TABLE `commerce_product_type` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `commerce_store_role`
--

DROP TABLE IF EXISTS `commerce_store_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commerce_store_role` (
  `rid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique role ID.',
  `store_id` int(10) unsigned DEFAULT '0' COMMENT 'Promary key: eck_commerce_store.id for commerce_store.',
  `name` varchar(64) NOT NULL DEFAULT '' COMMENT 'Unique role name.',
  PRIMARY KEY (`rid`),
  UNIQUE KEY `name_store_id` (`name`,`store_id`),
  KEY `store_id` (`store_id`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8 COMMENT='Stores user roles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commerce_store_role`
--

LOCK TABLES `commerce_store_role` WRITE;
/*!40000 ALTER TABLE `commerce_store_role` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `commerce_store_role` VALUES (3,1,'administrator'),(5,2,'administrator'),(7,3,'administrator'),(2,1,'member'),(4,2,'member'),(6,3,'member'),(1,0,'non-member');
/*!40000 ALTER TABLE `commerce_store_role` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `commerce_store_role_permission`
--

DROP TABLE IF EXISTS `commerce_store_role_permission`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commerce_store_role_permission` (
  `rid` int(10) unsigned NOT NULL COMMENT 'Foreign Key: role.rid.',
  `permission` varchar(128) NOT NULL DEFAULT '' COMMENT 'A single permission granted to the role identified by rid.',
  `module` varchar(255) NOT NULL DEFAULT '' COMMENT 'The module declaring the permission.',
  PRIMARY KEY (`rid`,`permission`),
  KEY `permission` (`permission`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores the permissions assigned to user roles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commerce_store_role_permission`
--

LOCK TABLES `commerce_store_role_permission` WRITE;
/*!40000 ALTER TABLE `commerce_store_role_permission` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `commerce_store_role_permission` VALUES (0,'view store page','commerce_store_access'),(1,'view store page','commerce_store_access'),(2,'add products to the store','commerce_store_access'),(2,'edit store orders','commerce_store_access'),(2,'view paypal store withdraw method','commerce_marketplace_funds_withdraw'),(2,'view store orders','commerce_store_access'),(2,'view store page','commerce_store_access'),(3,'access store withdraw methods overview page','commerce_marketplace_funds_withdraw'),(3,'add new members to commerce_store','commerce_store_access'),(3,'add new role to commerce_store','commerce_store_access'),(3,'add products to the store','commerce_store_access'),(3,'administer commerce_store members','commerce_store_access'),(3,'change commerce_store role permissions','commerce_store_access'),(3,'create deposit transactions using store funds account','commerce_marketplace_funds'),(3,'create payment transactions using store funds account','commerce_marketplace_funds'),(3,'create transfer transactions using store funds account','commerce_marketplace_funds'),(3,'create withdraw transactions using store funds account','commerce_marketplace_funds'),(3,'delete paypal store withdraw method','commerce_marketplace_funds_withdraw'),(3,'delete store orders','commerce_store_access'),(3,'delete store withdraw methods of any type','commerce_marketplace_funds_withdraw'),(3,'edit commerce_store roles','commerce_store_access'),(3,'edit paypal store withdraw method','commerce_marketplace_funds_withdraw'),(3,'edit store information','commerce_store_access'),(3,'edit store orders','commerce_store_access'),(3,'edit store withdraw methods of any type','commerce_marketplace_funds_withdraw'),(3,'view commerce_store roles overview page','commerce_store_access'),(3,'view paypal store withdraw method','commerce_marketplace_funds_withdraw'),(3,'view store funds account','commerce_marketplace_funds'),(3,'view store funds transactions','commerce_marketplace_funds'),(3,'view store orders','commerce_store_access'),(3,'view store page','commerce_store_access'),(4,'add products to the store','commerce_store_access'),(4,'edit store orders','commerce_store_access'),(4,'view paypal store withdraw method','commerce_marketplace_funds_withdraw'),(4,'view store orders','commerce_store_access'),(4,'view store page','commerce_store_access'),(5,'access store withdraw methods overview page','commerce_marketplace_funds_withdraw'),(5,'add new members to commerce_store','commerce_store_access'),(5,'add new role to commerce_store','commerce_store_access'),(5,'add products to the store','commerce_store_access'),(5,'administer commerce_store members','commerce_store_access'),(5,'change commerce_store role permissions','commerce_store_access'),(5,'create deposit transactions using store funds account','commerce_marketplace_funds'),(5,'create payment transactions using store funds account','commerce_marketplace_funds'),(5,'create transfer transactions using store funds account','commerce_marketplace_funds'),(5,'create withdraw transactions using store funds account','commerce_marketplace_funds'),(5,'delete paypal store withdraw method','commerce_marketplace_funds_withdraw'),(5,'delete store orders','commerce_store_access'),(5,'delete store withdraw methods of any type','commerce_marketplace_funds_withdraw'),(5,'edit commerce_store roles','commerce_store_access'),(5,'edit paypal store withdraw method','commerce_marketplace_funds_withdraw'),(5,'edit store information','commerce_store_access'),(5,'edit store orders','commerce_store_access'),(5,'edit store withdraw methods of any type','commerce_marketplace_funds_withdraw'),(5,'view commerce_store roles overview page','commerce_store_access'),(5,'view paypal store withdraw method','commerce_marketplace_funds_withdraw'),(5,'view store funds account','commerce_marketplace_funds'),(5,'view store funds transactions','commerce_marketplace_funds'),(5,'view store orders','commerce_store_access'),(5,'view store page','commerce_store_access'),(6,'add products to the store','commerce_store_access'),(6,'edit store orders','commerce_store_access'),(6,'view paypal store withdraw method','commerce_marketplace_funds_withdraw'),(6,'view store orders','commerce_store_access'),(6,'view store page','commerce_store_access'),(7,'access store withdraw methods overview page','commerce_marketplace_funds_withdraw'),(7,'add new members to commerce_store','commerce_store_access'),(7,'add new role to commerce_store','commerce_store_access'),(7,'add products to the store','commerce_store_access'),(7,'administer commerce_store members','commerce_store_access'),(7,'change commerce_store role permissions','commerce_store_access'),(7,'create deposit transactions using store funds account','commerce_marketplace_funds'),(7,'create payment transactions using store funds account','commerce_marketplace_funds'),(7,'create transfer transactions using store funds account','commerce_marketplace_funds'),(7,'create withdraw transactions using store funds account','commerce_marketplace_funds'),(7,'delete paypal store withdraw method','commerce_marketplace_funds_withdraw'),(7,'delete store orders','commerce_store_access'),(7,'delete store withdraw methods of any type','commerce_marketplace_funds_withdraw'),(7,'edit commerce_store roles','commerce_store_access'),(7,'edit paypal store withdraw method','commerce_marketplace_funds_withdraw'),(7,'edit store information','commerce_store_access'),(7,'edit store orders','commerce_store_access'),(7,'edit store withdraw methods of any type','commerce_marketplace_funds_withdraw'),(7,'view commerce_store roles overview page','commerce_store_access'),(7,'view paypal store withdraw method','commerce_marketplace_funds_withdraw'),(7,'view store funds account','commerce_marketplace_funds'),(7,'view store funds transactions','commerce_marketplace_funds'),(7,'view store orders','commerce_store_access'),(7,'view store page','commerce_store_access');
/*!40000 ALTER TABLE `commerce_store_role_permission` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `commerce_store_user_role`
--

DROP TABLE IF EXISTS `commerce_store_user_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commerce_store_user_role` (
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: users.uid for user.',
  `rid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: role.rid for role.',
  PRIMARY KEY (`uid`,`rid`),
  KEY `rid` (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Maps users to roles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commerce_store_user_role`
--

LOCK TABLES `commerce_store_user_role` WRITE;
/*!40000 ALTER TABLE `commerce_store_user_role` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `commerce_store_user_role` VALUES (6,2),(6,3),(1,4),(1,5),(16,6),(16,7);
/*!40000 ALTER TABLE `commerce_store_user_role` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `context`
--

DROP TABLE IF EXISTS `context`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `context` (
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The primary identifier for a context.',
  `description` varchar(255) NOT NULL DEFAULT '' COMMENT 'Description for this context.',
  `tag` varchar(255) NOT NULL DEFAULT '' COMMENT 'Tag for this context.',
  `conditions` text COMMENT 'Serialized storage of all context condition settings.',
  `reactions` text COMMENT 'Serialized storage of all context reaction settings.',
  `condition_mode` int(11) DEFAULT '0' COMMENT 'Condition mode for this context.',
  PRIMARY KEY (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Storage for normal (user-defined) contexts.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `context`
--

LOCK TABLES `context` WRITE;
/*!40000 ALTER TABLE `context` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `context` VALUES ('about-us','','block manager','a:1:{s:4:\"path\";a:1:{s:6:\"values\";a:1:{s:8:\"about-us\";s:8:\"about-us\";}}}','a:1:{s:5:\"block\";a:1:{s:6:\"blocks\";a:6:{s:32:\"bean--how-to-shop-at-marketplace\";a:4:{s:6:\"module\";s:4:\"bean\";s:5:\"delta\";s:27:\"-how-to-shop-at-marketplace\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";s:1:\"8\";}s:29:\"bean-safe-and-secure-shopping\";a:4:{s:6:\"module\";s:4:\"bean\";s:5:\"delta\";s:24:\"safe-and-secure-shopping\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";s:1:\"9\";}s:29:\"bean-safe-and-secure-delivery\";a:4:{s:6:\"module\";s:4:\"bean\";s:5:\"delta\";s:24:\"safe-and-secure-delivery\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";s:2:\"10\";}s:12:\"bean-returns\";a:4:{s:6:\"module\";s:4:\"bean\";s:5:\"delta\";s:7:\"returns\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";s:2:\"11\";}s:37:\"bean-comprehensive-and-personal-servi\";a:4:{s:6:\"module\";s:4:\"bean\";s:5:\"delta\";s:32:\"comprehensive-and-personal-servi\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";s:2:\"12\";}s:37:\"bean-marketplace-part-of-online-revol\";a:4:{s:6:\"module\";s:4:\"bean\";s:5:\"delta\";s:32:\"marketplace-part-of-online-revol\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";s:2:\"13\";}}}}',0),('banner','','block manager','a:1:{s:4:\"path\";a:1:{s:6:\"values\";a:1:{s:12:\"categories/*\";s:12:\"categories/*\";}}}','a:1:{s:5:\"block\";a:1:{s:6:\"blocks\";a:2:{s:20:\"views-banner-block_3\";a:4:{s:6:\"module\";s:5:\"views\";s:5:\"delta\";s:14:\"banner-block_3\";s:6:\"region\";s:19:\"panel_highlighted_2\";s:6:\"weight\";s:3:\"-10\";}s:20:\"views-banner-block_2\";a:4:{s:6:\"module\";s:5:\"views\";s:5:\"delta\";s:14:\"banner-block_2\";s:6:\"region\";s:19:\"panel_highlighted_3\";s:6:\"weight\";s:3:\"-10\";}}}}',0),('bannerforbrand','','block manager','a:1:{s:4:\"path\";a:1:{s:6:\"values\";a:1:{s:8:\"brands/*\";s:8:\"brands/*\";}}}','a:1:{s:5:\"block\";a:1:{s:6:\"blocks\";a:2:{s:20:\"views-banner-block_4\";a:4:{s:6:\"module\";s:5:\"views\";s:5:\"delta\";s:14:\"banner-block_4\";s:6:\"region\";s:19:\"panel_highlighted_2\";s:6:\"weight\";s:3:\"-10\";}s:20:\"views-banner-block_2\";a:4:{s:6:\"module\";s:5:\"views\";s:5:\"delta\";s:14:\"banner-block_2\";s:6:\"region\";s:19:\"panel_highlighted_3\";s:6:\"weight\";s:3:\"-10\";}}}}',0),('banner_all_products','','block manager','a:1:{s:4:\"path\";a:1:{s:6:\"values\";a:1:{s:9:\"products*\";s:9:\"products*\";}}}','a:1:{s:5:\"block\";a:1:{s:6:\"blocks\";a:2:{s:20:\"views-banner-block_5\";a:4:{s:6:\"module\";s:5:\"views\";s:5:\"delta\";s:14:\"banner-block_5\";s:6:\"region\";s:19:\"panel_highlighted_2\";s:6:\"weight\";s:3:\"-10\";}s:20:\"views-banner-block_2\";a:4:{s:6:\"module\";s:5:\"views\";s:5:\"delta\";s:14:\"banner-block_2\";s:6:\"region\";s:19:\"panel_highlighted_3\";s:6:\"weight\";s:3:\"-10\";}}}}',0),('help','','block manager','a:1:{s:4:\"path\";a:1:{s:6:\"values\";a:1:{s:15:\"how-can-we-help\";s:15:\"how-can-we-help\";}}}','a:1:{s:5:\"block\";a:1:{s:6:\"blocks\";a:2:{s:11:\"search-form\";a:4:{s:6:\"module\";s:6:\"search\";s:5:\"delta\";s:4:\"form\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";s:1:\"1\";}s:19:\"menu-menu-help-menu\";a:4:{s:6:\"module\";s:4:\"menu\";s:5:\"delta\";s:14:\"menu-help-menu\";s:6:\"region\";s:13:\"sidebar_first\";s:6:\"weight\";s:3:\"-10\";}}}}',0),('home','','block manager','a:1:{s:4:\"path\";a:1:{s:6:\"values\";a:1:{s:7:\"<front>\";s:7:\"<front>\";}}}','a:1:{s:5:\"block\";a:1:{s:6:\"blocks\";a:10:{s:11:\"system-help\";a:4:{s:6:\"module\";s:6:\"system\";s:5:\"delta\";s:4:\"help\";s:6:\"region\";s:4:\"help\";s:6:\"weight\";s:3:\"-10\";}s:11:\"system-main\";a:4:{s:6:\"module\";s:6:\"system\";s:5:\"delta\";s:4:\"main\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";s:2:\"-9\";}s:18:\"views-banner-block\";a:4:{s:6:\"module\";s:5:\"views\";s:5:\"delta\";s:12:\"banner-block\";s:6:\"region\";s:14:\"sidebar_second\";s:6:\"weight\";s:3:\"-10\";}s:7:\"block-6\";a:4:{s:6:\"module\";s:5:\"block\";s:5:\"delta\";s:1:\"6\";s:6:\"region\";s:14:\"sidebar_second\";s:6:\"weight\";s:2:\"-9\";}s:25:\"views-bestsellers-block_1\";a:4:{s:6:\"module\";s:5:\"views\";s:5:\"delta\";s:19:\"bestsellers-block_1\";s:6:\"region\";s:14:\"sidebar_second\";s:6:\"weight\";s:2:\"-8\";}s:20:\"views-banner-block_1\";a:4:{s:6:\"module\";s:5:\"views\";s:5:\"delta\";s:14:\"banner-block_1\";s:6:\"region\";s:14:\"sidebar_second\";s:6:\"weight\";s:2:\"-7\";}s:26:\"views-today_s_deal-block_1\";a:4:{s:6:\"module\";s:5:\"views\";s:5:\"delta\";s:20:\"today_s_deal-block_1\";s:6:\"region\";s:11:\"panel_first\";s:6:\"weight\";s:3:\"-10\";}s:21:\"tb_megamenu-main-menu\";a:4:{s:6:\"module\";s:11:\"tb_megamenu\";s:5:\"delta\";s:9:\"main-menu\";s:6:\"region\";s:19:\"panel_highlighted_1\";s:6:\"weight\";s:2:\"-6\";}s:21:\"views-slideshow-block\";a:4:{s:6:\"module\";s:5:\"views\";s:5:\"delta\";s:15:\"slideshow-block\";s:6:\"region\";s:19:\"panel_highlighted_2\";s:6:\"weight\";s:3:\"-10\";}s:17:\"views-brand-block\";a:4:{s:6:\"module\";s:5:\"views\";s:5:\"delta\";s:11:\"brand-block\";s:6:\"region\";s:19:\"panel_highlighted_2\";s:6:\"weight\";s:2:\"-9\";}}}}',0),('search','','block manager','a:1:{s:4:\"path\";a:1:{s:6:\"values\";a:3:{s:12:\"search-page*\";s:12:\"search-page*\";s:15:\"taxonomy/term/*\";s:15:\"taxonomy/term/*\";s:9:\"products*\";s:9:\"products*\";}}}','a:1:{s:5:\"block\";a:1:{s:6:\"blocks\";a:4:{s:26:\"current_search-marketplace\";a:4:{s:6:\"module\";s:14:\"current_search\";s:5:\"delta\";s:11:\"marketplace\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";s:3:\"-10\";}s:41:\"facetapi-PkQ0BcHQAoCQ0kNLdvPxh1jd20OztqL3\";a:4:{s:6:\"module\";s:8:\"facetapi\";s:5:\"delta\";s:32:\"PkQ0BcHQAoCQ0kNLdvPxh1jd20OztqL3\";s:6:\"region\";s:13:\"sidebar_first\";s:6:\"weight\";s:3:\"-10\";}s:41:\"facetapi-ljmT8Ts69OP0ErEpRJXGjkCr6c79Qs0Z\";a:4:{s:6:\"module\";s:8:\"facetapi\";s:5:\"delta\";s:32:\"ljmT8Ts69OP0ErEpRJXGjkCr6c79Qs0Z\";s:6:\"region\";s:13:\"sidebar_first\";s:6:\"weight\";s:2:\"-9\";}s:41:\"facetapi-TFVaQKSORCPdrULxfXDnLQZ40xH0Nper\";a:4:{s:6:\"module\";s:8:\"facetapi\";s:5:\"delta\";s:32:\"TFVaQKSORCPdrULxfXDnLQZ40xH0Nper\";s:6:\"region\";s:13:\"sidebar_first\";s:6:\"weight\";s:2:\"-8\";}}}}',0),('shipping','','block manager','a:1:{s:4:\"path\";a:1:{s:6:\"values\";a:2:{s:15:\"shipping-pickup\";s:15:\"shipping-pickup\";s:15:\"returns-refunds\";s:15:\"returns-refunds\";}}}','a:1:{s:5:\"block\";a:1:{s:6:\"blocks\";a:1:{s:19:\"menu-menu-help-menu\";a:4:{s:6:\"module\";s:4:\"menu\";s:5:\"delta\";s:14:\"menu-help-menu\";s:6:\"region\";s:13:\"sidebar_first\";s:6:\"weight\";s:3:\"-10\";}}}}',0),('vieworder','','block manager','a:1:{s:4:\"user\";a:1:{s:6:\"values\";a:1:{s:14:\"anonymous user\";s:14:\"anonymous user\";}}}','a:1:{s:5:\"block\";a:1:{s:6:\"blocks\";a:1:{s:8:\"block-20\";a:4:{s:6:\"module\";s:5:\"block\";s:5:\"delta\";s:2:\"20\";s:6:\"region\";s:8:\"headline\";s:6:\"weight\";s:2:\"10\";}}}}',0);
/*!40000 ALTER TABLE `context` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `countries_country`
--

DROP TABLE IF EXISTS `countries_country`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `countries_country` (
  `cid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique country ID. Required for the country bundle.',
  `iso2` char(2) NOT NULL COMMENT 'ISO 3166-1 alpha-2 country code.',
  `iso3` char(3) DEFAULT NULL COMMENT 'ISO 3166-1 alpha-3 country code.',
  `name` varchar(95) NOT NULL COMMENT 'ISO 3166-1 official short name.',
  `official_name` varchar(127) NOT NULL COMMENT 'ISO 3166-1 official long name.',
  `numcode` smallint(6) DEFAULT NULL COMMENT 'ISO 3166-1 numeric-3 country code.',
  `continent` char(2) NOT NULL COMMENT 'Continent code.',
  `enabled` int(11) NOT NULL DEFAULT '1' COMMENT 'Whether the country is enabled.',
  `language` varchar(12) NOT NULL DEFAULT 'und' COMMENT 'The languages.language of this node.',
  PRIMARY KEY (`cid`),
  UNIQUE KEY `iso2` (`iso2`),
  UNIQUE KEY `name` (`name`),
  KEY `enabled` (`enabled`),
  KEY `continent` (`continent`)
) ENGINE=InnoDB AUTO_INCREMENT=251 DEFAULT CHARSET=utf8 COMMENT='Maintains a country database.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `countries_country`
--

LOCK TABLES `countries_country` WRITE;
/*!40000 ALTER TABLE `countries_country` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `countries_country` VALUES (1,'AF','AFG','Afghanistan','Islamic Republic of Afghanistan',4,'AS',1,'und'),(2,'AX','ALA','Aland Islands','Åland Islands',248,'EU',1,'und'),(3,'AL','ALB','Albania','Republic of Albania',8,'EU',1,'und'),(4,'DZ','DZA','Algeria','People\'s Democratic Republic of Algeria',12,'AF',1,'und'),(5,'AS','ASM','American Samoa','American Samoa',16,'OC',1,'und'),(6,'AD','AND','Andorra','Principality of Andorra',20,'EU',1,'und'),(7,'AO','AGO','Angola','Republic of Angola',24,'AF',1,'und'),(8,'AI','AIA','Anguilla','Anguilla',660,'NA',1,'und'),(9,'AQ','ATA','Antarctica','Antarctica',10,'AN',1,'und'),(10,'AG','ATG','Antigua and Barbuda','Antigua and Barbuda',28,'NA',1,'und'),(11,'AR','ARG','Argentina','Argentine Republic',32,'SA',1,'und'),(12,'AM','ARM','Armenia','Republic of Armenia',51,'AS',1,'und'),(13,'AW','ABW','Aruba','Aruba',533,'NA',1,'und'),(14,'AU','AUS','Australia','Commonwealth of Australia',36,'OC',1,'und'),(15,'AT','AUT','Austria','Republic of Austria',40,'EU',1,'und'),(16,'AZ','AZE','Azerbaijan','Republic of Azerbaijan',31,'AS',1,'und'),(17,'BS','BHS','Bahamas','Commonwealth of the Bahamas',44,'NA',1,'und'),(18,'BH','BHR','Bahrain','Kingdom of Bahrain',48,'AS',1,'und'),(19,'BD','BGD','Bangladesh','People\'s Republic of Bangladesh',50,'AS',1,'und'),(20,'BB','BRB','Barbados','Barbados',52,'NA',1,'und'),(21,'BY','BLR','Belarus','Republic of Belarus',112,'EU',1,'und'),(22,'BE','BEL','Belgium','Kingdom of Belgium',56,'EU',1,'und'),(23,'BZ','BLZ','Belize','Belize',84,'NA',1,'und'),(24,'BJ','BEN','Benin','Republic of Benin',204,'AF',1,'und'),(25,'BM','BMU','Bermuda','Bermuda',60,'NA',1,'und'),(26,'BT','BTN','Bhutan','Kingdom of Bhutan',64,'AS',1,'und'),(27,'BO','BOL','Bolivia','Plurinational State of Bolivia',68,'SA',1,'und'),(28,'BA','BIH','Bosnia and Herzegovina','Bosnia and Herzegovina',70,'EU',1,'und'),(29,'BQ','BES','Caribbean Netherlands','Bonaire, Sint Eustatius and Saba',535,'NA',1,'und'),(30,'BW','BWA','Botswana','Republic of Botswana',72,'AF',1,'und'),(31,'BV','BVT','Bouvet Island','Bouvet Island',74,'AN',1,'und'),(32,'BR','BRA','Brazil','Federative Republic of Brazil',76,'SA',1,'und'),(33,'IO','IOT','British Indian Ocean Territory','British Indian Ocean Territory',86,'AS',1,'und'),(34,'BN','BRN','Brunei','Negara Brunei Darussalam',96,'AS',1,'und'),(35,'BG','BGR','Bulgaria','Republic of Bulgaria',100,'EU',1,'und'),(36,'BF','BFA','Burkina Faso','Burkina Faso',854,'AF',1,'und'),(37,'BI','BDI','Burundi','Republic of Burundi',108,'AF',1,'und'),(38,'KH','KHM','Cambodia','Kingdom of Cambodia',116,'AS',1,'und'),(39,'CM','CMR','Cameroon','Republic of Cameroon',120,'AF',1,'und'),(40,'CA','CAN','Canada','Canada',124,'NA',1,'und'),(41,'CV','CPV','Cape Verde','Republic of Cape Verde',132,'AF',1,'und'),(42,'KY','CYM','Cayman Islands','Cayman Islands',136,'NA',1,'und'),(43,'CF','CAF','Central African Republic','Central African Republic',140,'AF',1,'und'),(44,'TD','TCD','Chad','Republic of Chad',148,'AF',1,'und'),(45,'CL','CHL','Chile','Republic of Chile',152,'SA',1,'und'),(46,'CN','CHN','China','People\'s Republic of China',156,'AS',1,'und'),(47,'CX','CXR','Christmas Island','Christmas Island',162,'AS',1,'und'),(48,'CC','CCK','Cocos (Keeling) Islands','Cocos (Keeling) Islands',166,'AS',1,'und'),(49,'CO','COL','Colombia','Republic of Colombia',170,'SA',1,'und'),(50,'KM','COM','Comoros','Union of the Comoros',174,'AF',1,'und'),(51,'CG','COG','Congo (Brazzaville)','Republic of the Congo',178,'AF',1,'und'),(52,'CD','COD','Congo (Kinshasa)','Democratic Republic of the Congo',180,'AF',1,'und'),(53,'CK','COK','Cook Islands','Cook Islands',184,'OC',1,'und'),(54,'CR','CRI','Costa Rica','Republic of Costa Rica',188,'NA',1,'und'),(55,'CI','CIV','Ivory Coast','Republic of Côte d\'Ivoire',384,'AF',1,'und'),(56,'HR','HRV','Croatia','Republic of Croatia',191,'EU',1,'und'),(57,'CU','CUB','Cuba','Republic of Cuba',192,'NA',1,'und'),(58,'CW','CUW','Curaçao','Curaçao',531,'NA',1,'und'),(59,'CY','CYP','Cyprus','Republic of Cyprus',196,'AS',1,'und'),(60,'CZ','CZE','Czech Republic','Czech Republic',203,'EU',1,'und'),(61,'DK','DNK','Denmark','Kingdom of Denmark',208,'EU',1,'und'),(62,'DJ','DJI','Djibouti','Republic of Djibouti',262,'AF',1,'und'),(63,'DM','DMA','Dominica','Commonwealth of Dominica',212,'NA',1,'und'),(64,'DO','DOM','Dominican Republic','Dominican Republic',214,'NA',1,'und'),(65,'EC','ECU','Ecuador','Republic of Ecuador',218,'SA',1,'und'),(66,'EG','EGY','Egypt','Arab Republic of Egypt',818,'AF',1,'und'),(67,'SV','SLV','El Salvador','Republic of El Salvador',222,'NA',1,'und'),(68,'GQ','GNQ','Equatorial Guinea','Republic of Equatorial Guinea',226,'AF',1,'und'),(69,'ER','ERI','Eritrea','State of Eritrea',232,'AF',1,'und'),(70,'EE','EST','Estonia','Republic of Estonia',233,'EU',1,'und'),(71,'ET','ETH','Ethiopia','Federal Democratic Republic of Ethiopia',231,'AF',1,'und'),(72,'FK','FLK','Falkland Islands','Falkland Islands (Malvinas)',238,'SA',1,'und'),(73,'FO','FRO','Faroe Islands','Faroe Islands',234,'EU',1,'und'),(74,'FJ','FJI','Fiji','Republic of Fiji',242,'OC',1,'und'),(75,'FI','FIN','Finland','Republic of Finland',246,'EU',1,'und'),(76,'FR','FRA','France','French Republic',250,'EU',1,'und'),(77,'GF','GUF','French Guiana','French Guiana',254,'SA',1,'und'),(78,'PF','PYF','French Polynesia','French Polynesia',258,'OC',1,'und'),(79,'TF','ATF','French Southern Territories','French Southern Territories',260,'AN',1,'und'),(80,'GA','GAB','Gabon','Gabonese Republic',266,'AF',1,'und'),(81,'GM','GMB','Gambia','Republic of The Gambia',270,'AF',1,'und'),(82,'GE','GEO','Georgia','Georgia',268,'AS',1,'und'),(83,'DE','DEU','Germany','Federal Republic of Germany',276,'EU',1,'und'),(84,'GH','GHA','Ghana','Republic of Ghana',288,'AF',1,'und'),(85,'GI','GIB','Gibraltar','Gibraltar',292,'EU',1,'und'),(86,'GR','GRC','Greece','Hellenic Republic',300,'EU',1,'und'),(87,'GL','GRL','Greenland','Greenland',304,'NA',1,'und'),(88,'GD','GRD','Grenada','Grenada',308,'NA',1,'und'),(89,'GP','GLP','Guadeloupe','Guadeloupe',312,'NA',1,'und'),(90,'GU','GUM','Guam','Guam',316,'OC',1,'und'),(91,'GT','GTM','Guatemala','Republic of Guatemala',320,'NA',1,'und'),(92,'GG','GGY','Guernsey','Guernsey',831,'EU',1,'und'),(93,'GN','GIN','Guinea','Republic of Guinea',324,'AF',1,'und'),(94,'GW','GNB','Guinea-Bissau','Republic of Guinea-Bissau',624,'AF',1,'und'),(95,'GY','GUY','Guyana','Co-operative Republic of Guyana',328,'SA',1,'und'),(96,'HT','HTI','Haiti','Republic of Haiti',332,'NA',1,'und'),(97,'HM','HMD','Heard Island and McDonald Islands','Heard Island and Mcdonald Islands',334,'AN',1,'und'),(98,'VA','VAT','Vatican','Holy See (Vatican City State)',336,'EU',1,'und'),(99,'HN','HND','Honduras','Republic of Honduras',340,'NA',1,'und'),(100,'HK','HKG','Hong Kong S.A.R., China','Hong Kong S.A.R., China',344,'AS',1,'und'),(101,'HU','HUN','Hungary','Hungary',348,'EU',1,'und'),(102,'IS','ISL','Iceland','Republic of Iceland',352,'EU',1,'und'),(103,'IN','IND','India','Republic of India',356,'AS',1,'und'),(104,'ID','IDN','Indonesia','Republic of Indonesia',360,'AS',1,'und'),(105,'IR','IRN','Iran','Islamic Republic of Iran',364,'AS',1,'und'),(106,'IQ','IRQ','Iraq','Republic of Iraq',368,'AS',1,'und'),(107,'IE','IRL','Ireland','Ireland',372,'EU',1,'und'),(108,'IM','IMN','Isle of Man','Isle of Man',833,'EU',1,'und'),(109,'IL','ISR','Israel','State of Israel',376,'AS',1,'und'),(110,'IT','ITA','Italy','Italian Republic',380,'EU',1,'und'),(111,'JM','JAM','Jamaica','Jamaica',388,'NA',1,'und'),(112,'JP','JPN','Japan','Japan',392,'AS',1,'und'),(113,'JE','JEY','Jersey','Jersey',832,'EU',1,'und'),(114,'JO','JOR','Jordan','Hashemite Kingdom of Jordan',400,'AS',1,'und'),(115,'KZ','KAZ','Kazakhstan','Republic of Kazakhstan',398,'AS',1,'und'),(116,'KE','KEN','Kenya','Republic of Kenya',404,'AF',1,'und'),(117,'KI','KIR','Kiribati','Republic of Kiribati',296,'OC',1,'und'),(118,'KP','PRK','North Korea','Democratic People\'s Republic of Korea',408,'AS',1,'und'),(119,'KR','KOR','South Korea','Republic of Korea',410,'AS',1,'und'),(120,'KW','KWT','Kuwait','State of Kuwait',414,'AS',1,'und'),(121,'KG','KGZ','Kyrgyzstan','Kyrgyz Republic',417,'AS',1,'und'),(122,'LA','LAO','Laos','Lao People\'s Democratic Republic',418,'AS',1,'und'),(123,'LV','LVA','Latvia','Republic of Latvia',428,'EU',1,'und'),(124,'LB','LBN','Lebanon','Republic of Lebanon',422,'AS',1,'und'),(125,'LS','LSO','Lesotho','Kingdom of Lesotho',426,'AF',1,'und'),(126,'LR','LBR','Liberia','Republic of Liberia',430,'AF',1,'und'),(127,'LY','LBY','Libya','Libya',434,'AF',1,'und'),(128,'LI','LIE','Liechtenstein','Principality of Liechtenstein',438,'EU',1,'und'),(129,'LT','LTU','Lithuania','Republic of Lithuania',440,'EU',1,'und'),(130,'LU','LUX','Luxembourg','Grand Duchy of Luxembourg',442,'EU',1,'und'),(131,'MO','MAC','Macao S.A.R., China','Macao S.A.R., China',446,'AS',1,'und'),(132,'MK','MKD','Macedonia','The Former Yugoslav Republic of Macedonia',807,'EU',1,'und'),(133,'MG','MDG','Madagascar','Republic of Madagascar',450,'AF',1,'und'),(134,'MW','MWI','Malawi','Republic of Malawi',454,'AF',1,'und'),(135,'MY','MYS','Malaysia','Federation of Malaysia',458,'AS',1,'und'),(136,'MV','MDV','Maldives','Republic of Maldives',462,'AS',1,'und'),(137,'ML','MLI','Mali','Republic of Mali',466,'AF',1,'und'),(138,'MT','MLT','Malta','Republic of Malta',470,'EU',1,'und'),(139,'MH','MHL','Marshall Islands','Republic of the Marshall Islands',584,'OC',1,'und'),(140,'MQ','MTQ','Martinique','Martinique',474,'NA',1,'und'),(141,'MR','MRT','Mauritania','Islamic Republic of Mauritania',478,'AF',1,'und'),(142,'MU','MUS','Mauritius','Republic of Mauritius',480,'AF',1,'und'),(143,'YT','MYT','Mayotte','Mayotte',175,'AF',1,'und'),(144,'MX','MEX','Mexico','United Mexican States',484,'NA',1,'und'),(145,'FM','FSM','Micronesia','Federated States of Micronesia',583,'OC',1,'und'),(146,'MD','MDA','Moldova','Republic of Moldova',498,'EU',1,'und'),(147,'MC','MCO','Monaco','Principality of Monaco',492,'EU',1,'und'),(148,'MN','MNG','Mongolia','Mongolia',496,'AS',1,'und'),(149,'ME','MNE','Montenegro','Montenegro',499,'EU',1,'und'),(150,'MS','MSR','Montserrat','Montserrat',500,'NA',1,'und'),(151,'MA','MAR','Morocco','Kingdom of Morocco',504,'AF',1,'und'),(152,'MZ','MOZ','Mozambique','Republic of Mozambique',508,'AF',1,'und'),(153,'MM','MMR','Myanmar','Republic of the Union of Myanmar',104,'AS',1,'und'),(154,'NA','NAM','Namibia','Republic of Namibia',516,'AF',1,'und'),(155,'NR','NRU','Nauru','Republic of Nauru',520,'OC',1,'und'),(156,'NP','NPL','Nepal','Federal Democratic Republic of Nepal',524,'AS',1,'und'),(157,'NL','NLD','Netherlands','Kingdom of the Netherlands',528,'EU',1,'und'),(158,'AN','ANT','Netherlands Antilles','Netherlands Antilles',530,'NA',1,'und'),(159,'NC','NCL','New Caledonia','New Caledonia',540,'OC',1,'und'),(160,'NZ','NZL','New Zealand','New Zealand',554,'OC',1,'und'),(161,'NI','NIC','Nicaragua','Republic of Nicaragua',558,'NA',1,'und'),(162,'NE','NER','Niger','Republic of Niger',562,'AF',1,'und'),(163,'NG','NGA','Nigeria','Federal Republic of Nigeria',566,'AF',1,'und'),(164,'NU','NIU','Niue','Niue',570,'OC',1,'und'),(165,'NF','NFK','Norfolk Island','Norfolk Island',574,'OC',1,'und'),(166,'MP','MNP','Northern Mariana Islands','Northern Mariana Islands',580,'OC',1,'und'),(167,'NO','NOR','Norway','Kingdom of Norway',578,'EU',1,'und'),(168,'OM','OMN','Oman','Sultanate of Oman',512,'AS',1,'und'),(169,'PK','PAK','Pakistan','Islamic Republic of Pakistan',586,'AS',1,'und'),(170,'PW','PLW','Palau','Republic of Palau',585,'OC',1,'und'),(171,'PS','PSE','Palestinian Territory','State of Palestine',275,'AS',1,'und'),(172,'PA','PAN','Panama','Republic of Panama',591,'NA',1,'und'),(173,'PG','PNG','Papua New Guinea','Independent State of Papua New Guinea',598,'OC',1,'und'),(174,'PY','PRY','Paraguay','Republic of Paraguay',600,'SA',1,'und'),(175,'PE','PER','Peru','Republic of Peru',604,'SA',1,'und'),(176,'PH','PHL','Philippines','Republic of the Philippines',608,'AS',1,'und'),(177,'PN','PCN','Pitcairn','Pitcairn',612,'OC',1,'und'),(178,'PL','POL','Poland','Republic of Poland',616,'EU',1,'und'),(179,'PT','PRT','Portugal','Portuguese Republic',620,'EU',1,'und'),(180,'PR','PRI','Puerto Rico','Puerto Rico',630,'NA',1,'und'),(181,'QA','QAT','Qatar','State of Qatar',634,'AS',1,'und'),(182,'RE','REU','Reunion','Réunion',638,'AF',1,'und'),(183,'RO','ROU','Romania','Romania',642,'EU',1,'und'),(184,'RU','RUS','Russia','Russian Federation',643,'EU',1,'und'),(185,'RW','RWA','Rwanda','Republic of Rwanda',646,'AF',1,'und'),(186,'BL','BLM','Saint Barthélemy','Saint Barthélemy',652,'NA',1,'und'),(187,'SH','SHN','Saint Helena','Saint Helena, Ascension and Tristan da Cunha',654,'AF',1,'und'),(188,'KN','KNA','Saint Kitts and Nevis','Federation of Saint Christopher and Nevis',659,'NA',1,'und'),(189,'LC','LCA','Saint Lucia','Saint Lucia',662,'NA',1,'und'),(190,'MF','MAF','Saint Martin (French part)','Saint Martin (French part)',663,'NA',1,'und'),(191,'PM','SPM','Saint Pierre and Miquelon','Saint Pierre and Miquelon',666,'NA',1,'und'),(192,'VC','VCT','Saint Vincent and the Grenadines','Saint Vincent and the Grenadines',670,'NA',1,'und'),(193,'WS','WSM','Samoa','Independent State of Samoa',882,'OC',1,'und'),(194,'SM','SMR','San Marino','Republic of San Marino',674,'EU',1,'und'),(195,'ST','STP','Sao Tome and Principe','Democratic Republic of São Tomé and Príncipe',678,'AF',1,'und'),(196,'SA','SAU','Saudi Arabia','Kingdom of Saudi Arabia',682,'AS',1,'und'),(197,'SN','SEN','Senegal','Republic of Senegal',686,'AF',1,'und'),(198,'RS','SRB','Serbia','Republic of Serbia',688,'EU',1,'und'),(199,'SC','SYC','Seychelles','Republic of Seychelles',690,'AF',1,'und'),(200,'SL','SLE','Sierra Leone','Republic of Sierra Leone',694,'AF',1,'und'),(201,'SG','SGP','Singapore','Republic of Singapore',702,'AS',1,'und'),(202,'SX','SXM','Sint Maarten','Sint Maarten (Dutch part)',534,'NA',1,'und'),(203,'SK','SVK','Slovakia','Slovak Republic',703,'EU',1,'und'),(204,'SI','SVN','Slovenia','Republic of Slovenia',705,'EU',1,'und'),(205,'SB','SLB','Solomon Islands','Solomon Islands',90,'OC',1,'und'),(206,'SO','SOM','Somalia','Federal Republic of Somalia',706,'AF',1,'und'),(207,'ZA','ZAF','South Africa','Republic of South Africa',710,'AF',1,'und'),(208,'GS','SGS','South Georgia and the South Sandwich Islands','South Georgia and the South Sandwich Islands',239,'AN',1,'und'),(209,'ES','ESP','Spain','Kingdom of Spain',724,'EU',1,'und'),(210,'LK','LKA','Sri Lanka','Democratic Socialist Republic of Sri Lanka',144,'AS',1,'und'),(211,'SS','SSD','South Sudan','Republic of South Sudan',728,'AF',1,'und'),(212,'SD','SDN','Sudan','Republic of the Sudan',729,'AF',1,'und'),(213,'SR','SUR','Suriname','Republic of Suriname',740,'SA',1,'und'),(214,'SJ','SJM','Svalbard and Jan Mayen','Svalbard and Jan Mayen Islands',744,'EU',1,'und'),(215,'SZ','SWZ','Swaziland','Kingdom of Swaziland',748,'AF',1,'und'),(216,'SE','SWE','Sweden','Kingdom of Sweden',752,'EU',1,'und'),(217,'CH','CHE','Switzerland','Switzerland',756,'EU',1,'und'),(218,'SY','SYR','Syria','Syrian Arab Republic',760,'AS',1,'und'),(219,'TW','TWN','Taiwan','Taiwan, Province of China',158,'AS',1,'und'),(220,'TJ','TJK','Tajikistan','Republic of Tajikistan',762,'AS',1,'und'),(221,'TZ','TZA','Tanzania','United Republic of Tanzania',834,'AF',1,'und'),(222,'TH','THA','Thailand','Kingdom of Thailand',764,'AS',1,'und'),(223,'TL','TLS','Timor-Leste','Democratic Republic of Timor-Leste',626,'AS',1,'und'),(224,'TG','TGO','Togo','Togolese Republic',768,'AF',1,'und'),(225,'TK','TKL','Tokelau','Tokelau',772,'OC',1,'und'),(226,'TO','TON','Tonga','Kingdom of Tonga',776,'OC',1,'und'),(227,'TT','TTO','Trinidad and Tobago','Republic of Trinidad and Tobago',780,'NA',1,'und'),(228,'TN','TUN','Tunisia','Republic of Tunisia',788,'AF',1,'und'),(229,'TR','TUR','Turkey','Republic of Turkey',792,'AS',1,'und'),(230,'TM','TKM','Turkmenistan','Turkmenistan',795,'AS',1,'und'),(231,'TC','TCA','Turks and Caicos Islands','Turks and Caicos Islands',796,'NA',1,'und'),(232,'TV','TUV','Tuvalu','Tuvalu',798,'OC',1,'und'),(233,'UG','UGA','Uganda','Republic of Uganda',800,'AF',1,'und'),(234,'UA','UKR','Ukraine','Ukraine',804,'EU',1,'und'),(235,'AE','ARE','United Arab Emirates','United Arab Emirates',784,'AS',1,'und'),(236,'GB','GBR','United Kingdom','United Kingdom of Great Britain and Northern Ireland',826,'EU',1,'und'),(237,'US','USA','United States','United States of America',840,'NA',1,'und'),(238,'UM','UMI','United States Minor Outlying Islands','United States Minor Outlying Islands',581,'OC',1,'und'),(239,'UY','URY','Uruguay','Eastern Republic of Uruguay',858,'SA',1,'und'),(240,'UZ','UZB','Uzbekistan','Republic of Uzbekistan',860,'AS',1,'und'),(241,'VU','VUT','Vanuatu','Republic of Vanuatu',548,'OC',1,'und'),(242,'VE','VEN','Venezuela','Bolivarian Republic of Venezuela',862,'SA',1,'und'),(243,'VN','VNM','Vietnam','Socialist Republic of Viet Nam',704,'AS',1,'und'),(244,'VG','VGB','British Virgin Islands','Virgin Islands, British',92,'NA',1,'und'),(245,'VI','VIR','U.S. Virgin Islands','Virgin Islands, United States',850,'NA',1,'und'),(246,'WF','WLF','Wallis and Futuna','Wallis and Futuna Islands',876,'OC',1,'und'),(247,'EH','ESH','Western Sahara','Western Sahara',732,'AF',1,'und'),(248,'YE','YEM','Yemen','Republic of Yemen',887,'AS',1,'und'),(249,'ZM','ZMB','Zambia','Republic of Zambia',894,'AF',1,'und'),(250,'ZW','ZWE','Zimbabwe','Republic of Zimbabwe',716,'AF',1,'und');
/*!40000 ALTER TABLE `countries_country` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `ctools_css_cache`
--

DROP TABLE IF EXISTS `ctools_css_cache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ctools_css_cache` (
  `cid` varchar(128) NOT NULL COMMENT 'The CSS ID this cache object belongs to.',
  `filename` varchar(255) DEFAULT NULL COMMENT 'The filename this CSS is stored in.',
  `css` longtext COMMENT 'CSS being stored.',
  `filter` tinyint(4) DEFAULT NULL COMMENT 'Whether or not this CSS needs to be filtered.',
  PRIMARY KEY (`cid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='A special cache used to store CSS that must be non-volatile.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ctools_css_cache`
--

LOCK TABLES `ctools_css_cache` WRITE;
/*!40000 ALTER TABLE `ctools_css_cache` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `ctools_css_cache` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `ctools_object_cache`
--

DROP TABLE IF EXISTS `ctools_object_cache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ctools_object_cache` (
  `sid` varchar(64) NOT NULL COMMENT 'The session ID this cache object belongs to.',
  `name` varchar(128) NOT NULL COMMENT 'The name of the object this cache is attached to.',
  `obj` varchar(128) NOT NULL COMMENT 'The type of the object this cache is attached to; this essentially represents the owner so that several sub-systems can use this cache.',
  `updated` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The time this cache was created or updated.',
  `data` longblob COMMENT 'Serialized data being stored.',
  PRIMARY KEY (`sid`,`obj`,`name`),
  KEY `updated` (`updated`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='A special cache used to store objects that are being...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ctools_object_cache`
--

LOCK TABLES `ctools_object_cache` WRITE;
/*!40000 ALTER TABLE `ctools_object_cache` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `ctools_object_cache` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `current_search`
--

DROP TABLE IF EXISTS `current_search`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `current_search` (
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The machine readable name of the configuration.',
  `label` varchar(255) NOT NULL DEFAULT '' COMMENT 'The human readable name of the configuration.',
  `settings` text COMMENT 'Serialized storage of general settings.',
  PRIMARY KEY (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Current search block configurations.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `current_search`
--

LOCK TABLES `current_search` WRITE;
/*!40000 ALTER TABLE `current_search` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `current_search` VALUES ('marketplace','Marketplace','a:2:{s:5:\"items\";a:2:{s:7:\"results\";a:11:{s:2:\"id\";s:4:\"text\";s:5:\"label\";s:7:\"Results\";s:4:\"text\";s:63:\"There is <em>[facetapi_results:result-count]</em> search result\";s:6:\"plural\";i:1;s:11:\"text_plural\";s:64:\"There is <em>[facetapi_results:result-count]</em> search results\";s:16:\"plural_condition\";s:29:\"facetapi_results:result-count\";s:7:\"wrapper\";i:1;s:7:\"element\";s:2:\"h3\";s:3:\"css\";i:1;s:7:\"classes\";s:18:\"text-total-results\";s:6:\"weight\";s:3:\"-50\";}s:12:\"active_items\";a:8:{s:2:\"id\";s:6:\"active\";s:5:\"label\";s:12:\"Active items\";s:7:\"pattern\";s:30:\"[facetapi_active:active-value]\";s:4:\"keys\";i:1;s:3:\"css\";i:1;s:7:\"classes\";s:18:\"item-search-result\";s:8:\"nofollow\";i:1;s:6:\"weight\";s:3:\"-49\";}}s:8:\"advanced\";a:1:{s:14:\"empty_searches\";s:1:\"3\";}}');
/*!40000 ALTER TABLE `current_search` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `custom_breadcrumb`
--

DROP TABLE IF EXISTS `custom_breadcrumb`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `custom_breadcrumb` (
  `bid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Unique identifier for the custom_breadcrumb.',
  `name` varchar(128) DEFAULT NULL COMMENT 'An optional name for the custom breadcrumb.',
  `titles` mediumtext NOT NULL COMMENT 'A return-delimited list of titles for the breadcrumb links.',
  `paths` mediumtext NOT NULL COMMENT 'A return-delimited list of url paths for the breadcrumb links.',
  `visibility_php` mediumtext NOT NULL COMMENT 'An optional PHP snippet to control the custom_breadcrumb visibility.',
  `node_type` varchar(64) DEFAULT 'AND' COMMENT 'Node types the custom_breadcrumb should apply to.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'The language this breadcrumb is for; if blank, the breadcrumb will be used for unknown languages.',
  PRIMARY KEY (`bid`),
  KEY `language` (`language`),
  KEY `node_language` (`node_type`,`language`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COMMENT='Stores custom breadcrumb trail overrides.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `custom_breadcrumb`
--

LOCK TABLES `custom_breadcrumb` WRITE;
/*!40000 ALTER TABLE `custom_breadcrumb` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `custom_breadcrumb` VALUES (1,'Basic Page','[node:title]','','','page','');
/*!40000 ALTER TABLE `custom_breadcrumb` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `custom_breadcrumbs_paths`
--

DROP TABLE IF EXISTS `custom_breadcrumbs_paths`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `custom_breadcrumbs_paths` (
  `bid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Unique identifier for the custom_breadcrumbs_views.',
  `name` varchar(128) DEFAULT NULL COMMENT 'An optional name for the custom breadcrumb.',
  `titles` varchar(255) NOT NULL DEFAULT '' COMMENT 'A return-delimited list of titles for the breadcrumb links.',
  `paths` varchar(255) DEFAULT NULL COMMENT 'A return-delimited list of url paths for the breadcrumb links.',
  `visibility_php` mediumtext NOT NULL COMMENT 'An optional PHP snippet to control the custom_breadcrumbs_views visibility.',
  `specific_path` varchar(255) NOT NULL COMMENT 'Path to the view for this custom breadcrumb.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'The language this breadcrumb is for; if blank, the breadcrumb will be used for unknown languages.',
  PRIMARY KEY (`bid`),
  KEY `language` (`language`),
  KEY `path_language` (`specific_path`,`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores custom breadcrumb trails for specific paths.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `custom_breadcrumbs_paths`
--

LOCK TABLES `custom_breadcrumbs_paths` WRITE;
/*!40000 ALTER TABLE `custom_breadcrumbs_paths` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `custom_breadcrumbs_paths` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `custom_breadcrumbs_taxonomy_term`
--

DROP TABLE IF EXISTS `custom_breadcrumbs_taxonomy_term`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `custom_breadcrumbs_taxonomy_term` (
  `bid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Unique identifier for the custom_breadcrumbs_taxonomy breadcrumbs.',
  `name` varchar(128) DEFAULT NULL COMMENT 'An optional name for the custom breadcrumb.',
  `titles` varchar(255) NOT NULL DEFAULT '' COMMENT 'A title for the breadcrumb link.',
  `paths` varchar(255) DEFAULT NULL COMMENT 'A path for the breadcrumb link.',
  `tid` int(10) unsigned NOT NULL COMMENT 'The taxonomy term id for this breadcrumb.',
  `visibility_php` mediumtext NOT NULL COMMENT 'An optional PHP snippet to control the custom_breadcrumbs_views visibility.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'The language this breadcrumb is for; if blank, the breadcrumb will be used for unknown languages.',
  PRIMARY KEY (`bid`),
  KEY `language` (`language`),
  KEY `tid_language` (`tid`,`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores custom breadcrumbs for taxonomy terms';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `custom_breadcrumbs_taxonomy_term`
--

LOCK TABLES `custom_breadcrumbs_taxonomy_term` WRITE;
/*!40000 ALTER TABLE `custom_breadcrumbs_taxonomy_term` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `custom_breadcrumbs_taxonomy_term` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `custom_breadcrumbs_taxonomy_vocabulary`
--

DROP TABLE IF EXISTS `custom_breadcrumbs_taxonomy_vocabulary`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `custom_breadcrumbs_taxonomy_vocabulary` (
  `bid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Unique identifier for the custom_breadcrumbs_taxonomy breadcrumbs.',
  `name` varchar(128) DEFAULT NULL COMMENT 'An optional name for the custom breadcrumb.',
  `titles` varchar(255) NOT NULL DEFAULT '' COMMENT 'A titles for the breadcrumb link.',
  `paths` varchar(255) DEFAULT NULL COMMENT 'A paths for the breadcrumb link.',
  `vid` int(10) unsigned NOT NULL COMMENT 'The taxonomy vocabulary id for this breadcrumb.',
  `visibility_php` mediumtext NOT NULL COMMENT 'An optional PHP snippet to control the custom_breadcrumbs_views visibility.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'The language this breadcrumb is for; if blank, the breadcrumb will be used for unknown languages.',
  PRIMARY KEY (`bid`),
  KEY `language` (`language`),
  KEY `vid_language` (`vid`,`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores custom breadcrumbs for taxonomy vocabularies';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `custom_breadcrumbs_taxonomy_vocabulary`
--

LOCK TABLES `custom_breadcrumbs_taxonomy_vocabulary` WRITE;
/*!40000 ALTER TABLE `custom_breadcrumbs_taxonomy_vocabulary` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `custom_breadcrumbs_taxonomy_vocabulary` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `custom_breadcrumbs_views`
--

DROP TABLE IF EXISTS `custom_breadcrumbs_views`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `custom_breadcrumbs_views` (
  `bid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Unique identifier for the custom_breadcrumbs_views.',
  `name` varchar(128) DEFAULT NULL COMMENT 'An optional name for the custom breadcrumb.',
  `titles` varchar(255) NOT NULL DEFAULT '' COMMENT 'A return-delimited list of titles for the breadcrumb links.',
  `paths` varchar(255) DEFAULT NULL COMMENT 'A return-delimited list of url paths for the breadcrumb links.',
  `visibility_php` mediumtext NOT NULL COMMENT 'An optional PHP snippet to control the custom_breadcrumbs_views visibility.',
  `views_path` varchar(255) NOT NULL COMMENT 'Path to the view for this custom breadcrumb.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'The language this breadcrumb is for; if blank, the breadcrumb will be used for unknown languages.',
  PRIMARY KEY (`bid`),
  KEY `language` (`language`),
  KEY `vpath_language` (`views_path`,`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores custom breadcrumb trail overrides for views pages.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `custom_breadcrumbs_views`
--

LOCK TABLES `custom_breadcrumbs_views` WRITE;
/*!40000 ALTER TABLE `custom_breadcrumbs_views` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `custom_breadcrumbs_views` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `date_format_locale`
--

DROP TABLE IF EXISTS `date_format_locale`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `date_format_locale` (
  `format` varchar(100) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL COMMENT 'The date format string.',
  `type` varchar(64) NOT NULL COMMENT 'The date format type, e.g. medium.',
  `language` varchar(12) NOT NULL COMMENT 'A languages.language for this format to be used with.',
  PRIMARY KEY (`type`,`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores configured date formats for each locale.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `date_format_locale`
--

LOCK TABLES `date_format_locale` WRITE;
/*!40000 ALTER TABLE `date_format_locale` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `date_format_locale` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `date_format_type`
--

DROP TABLE IF EXISTS `date_format_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `date_format_type` (
  `type` varchar(64) NOT NULL COMMENT 'The date format type, e.g. medium.',
  `title` varchar(255) NOT NULL COMMENT 'The human readable name of the format type.',
  `locked` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Whether or not this is a system provided format.',
  PRIMARY KEY (`type`),
  KEY `title` (`title`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores configured date format types.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `date_format_type`
--

LOCK TABLES `date_format_type` WRITE;
/*!40000 ALTER TABLE `date_format_type` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `date_format_type` VALUES ('long','Long',1),('medium','Medium',1),('search_api_facetapi_DAY','Search facets - Days',1),('search_api_facetapi_HOUR','Search facets - Hours',1),('search_api_facetapi_MINUTE','Search facets - Minutes',1),('search_api_facetapi_MONTH','Search facets - Months',1),('search_api_facetapi_SECOND','Search facets - Seconds',1),('search_api_facetapi_YEAR','Search facets - Years',1),('short','Short',1);
/*!40000 ALTER TABLE `date_format_type` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `date_formats`
--

DROP TABLE IF EXISTS `date_formats`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `date_formats` (
  `dfid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The date format identifier.',
  `format` varchar(100) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL COMMENT 'The date format string.',
  `type` varchar(64) NOT NULL COMMENT 'The date format type, e.g. medium.',
  `locked` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Whether or not this format can be modified.',
  PRIMARY KEY (`dfid`),
  UNIQUE KEY `formats` (`format`,`type`)
) ENGINE=InnoDB AUTO_INCREMENT=42 DEFAULT CHARSET=utf8 COMMENT='Stores configured date formats.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `date_formats`
--

LOCK TABLES `date_formats` WRITE;
/*!40000 ALTER TABLE `date_formats` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `date_formats` VALUES (1,'Y-m-d H:i','short',1),(2,'m/d/Y - H:i','short',1),(3,'d/m/Y - H:i','short',1),(4,'Y/m/d - H:i','short',1),(5,'d.m.Y - H:i','short',1),(6,'m/d/Y - g:ia','short',1),(7,'d/m/Y - g:ia','short',1),(8,'Y/m/d - g:ia','short',1),(9,'M j Y - H:i','short',1),(10,'j M Y - H:i','short',1),(11,'Y M j - H:i','short',1),(12,'M j Y - g:ia','short',1),(13,'j M Y - g:ia','short',1),(14,'Y M j - g:ia','short',1),(15,'D, Y-m-d H:i','medium',1),(16,'D, m/d/Y - H:i','medium',1),(17,'D, d/m/Y - H:i','medium',1),(18,'D, Y/m/d - H:i','medium',1),(19,'F j, Y - H:i','medium',1),(20,'j F, Y - H:i','medium',1),(21,'Y, F j - H:i','medium',1),(22,'D, m/d/Y - g:ia','medium',1),(23,'D, d/m/Y - g:ia','medium',1),(24,'D, Y/m/d - g:ia','medium',1),(25,'F j, Y - g:ia','medium',1),(26,'j F Y - g:ia','medium',1),(27,'Y, F j - g:ia','medium',1),(28,'j. F Y - G:i','medium',1),(29,'l, F j, Y - H:i','long',1),(30,'l, j F, Y - H:i','long',1),(31,'l, Y,  F j - H:i','long',1),(32,'l, F j, Y - g:ia','long',1),(33,'l, j F Y - g:ia','long',1),(34,'l, Y,  F j - g:ia','long',1),(35,'l, j. F Y - G:i','long',1),(36,'Y','search_api_facetapi_YEAR',1),(37,'F Y','search_api_facetapi_MONTH',1),(38,'F j, Y','search_api_facetapi_DAY',1),(39,'H:__','search_api_facetapi_HOUR',1),(40,'H:i','search_api_facetapi_MINUTE',1),(41,'H:i:s','search_api_facetapi_SECOND',1);
/*!40000 ALTER TABLE `date_formats` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `eck_bundle`
--

DROP TABLE IF EXISTS `eck_bundle`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `eck_bundle` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a bundle',
  `machine_name` varchar(128) NOT NULL COMMENT 'A combination of the entity type and the name ofthis bundle, this combination is unique',
  `entity_type` varchar(128) NOT NULL COMMENT 'The entity type this bundle belongs to',
  `name` varchar(128) NOT NULL COMMENT 'The bundle’s name',
  `label` varchar(128) NOT NULL COMMENT 'A human readable name for the bundle (not that the type is not human readable)',
  `config` text NOT NULL COMMENT 'A serialized list of the bundle settings.',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COMMENT='The base table for bundle information';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eck_bundle`
--

LOCK TABLES `eck_bundle` WRITE;
/*!40000 ALTER TABLE `eck_bundle` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `eck_bundle` VALUES (1,'commerce_store_store','commerce_store','store','Store','[]');
/*!40000 ALTER TABLE `eck_bundle` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `eck_commerce_store`
--

DROP TABLE IF EXISTS `eck_commerce_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `eck_commerce_store` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a(n) commerce_store.',
  `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The bundle of the entity',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Text',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Integer',
  `created` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Integer',
  `changed` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Integer',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COMMENT='The base table for a(n) commerce_store.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eck_commerce_store`
--

LOCK TABLES `eck_commerce_store` WRITE;
/*!40000 ALTER TABLE `eck_commerce_store` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `eck_commerce_store` VALUES (2,'store','Marketplace',1,1416300902,1416300902),(3,'store','WeebPal',16,1418356805,1418356805);
/*!40000 ALTER TABLE `eck_commerce_store` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `eck_entity_type`
--

DROP TABLE IF EXISTS `eck_entity_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `eck_entity_type` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a bundle',
  `name` varchar(128) NOT NULL COMMENT 'The machine name of the entity',
  `label` varchar(128) NOT NULL COMMENT 'The entity’s Label',
  `properties` text NOT NULL COMMENT 'A serialized list of properties attached to this entity.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COMMENT='The base table for entity type information';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eck_entity_type`
--

LOCK TABLES `eck_entity_type` WRITE;
/*!40000 ALTER TABLE `eck_entity_type` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `eck_entity_type` VALUES (1,'commerce_store','Commerce Store','{\"title\":{\"label\":\"Title\",\"type\":\"text\",\"behavior\":\"title\"},\"uid\":{\"label\":\"Owner User ID\",\"type\":\"positive_integer\",\"behavior\":\"author\"},\"created\":{\"label\":\"Created\",\"type\":\"positive_integer\",\"behavior\":\"created\"},\"changed\":{\"label\":\"Changed\",\"type\":\"positive_integer\",\"behavior\":\"changed\"}}');
/*!40000 ALTER TABLE `eck_entity_type` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `facetapi`
--

DROP TABLE IF EXISTS `facetapi`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `facetapi` (
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The machine readable name of the configuration.',
  `searcher` varchar(64) NOT NULL DEFAULT '' COMMENT 'The machine readable name of the searcher.',
  `realm` varchar(64) NOT NULL DEFAULT '' COMMENT 'The machine readable name of the realm.',
  `facet` varchar(255) NOT NULL DEFAULT '' COMMENT 'The machine readable name of the facet.',
  `enabled` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Whether the facet is enabled.',
  `settings` blob COMMENT 'Serialized storage of general settings.',
  PRIMARY KEY (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Facet configurations.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `facetapi`
--

LOCK TABLES `facetapi` WRITE;
/*!40000 ALTER TABLE `facetapi` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `facetapi` VALUES ('search_api@product_display::field_brand','search_api@product_display','','field_brand',0,'a:12:{s:8:\"operator\";s:2:\"or\";s:10:\"hard_limit\";s:2:\"50\";s:12:\"dependencies\";a:2:{s:6:\"bundle\";s:4:\"none\";s:15:\"bundle_selected\";a:0:{}}s:14:\"facet_mincount\";s:1:\"1\";s:13:\"facet_missing\";s:1:\"0\";s:7:\"flatten\";s:1:\"0\";s:17:\"individual_parent\";s:1:\"0\";s:10:\"query_type\";s:4:\"term\";s:18:\"limit_active_items\";i:0;s:12:\"default_true\";s:1:\"1\";s:16:\"facet_search_ids\";a:0:{}s:7:\"exclude\";i:0;}'),('search_api@product_display::field_category','search_api@product_display','','field_category',0,'a:12:{s:8:\"operator\";s:2:\"or\";s:10:\"hard_limit\";s:2:\"10\";s:12:\"dependencies\";a:3:{s:6:\"bundle\";s:4:\"none\";s:15:\"bundle_selected\";a:0:{}s:5:\"roles\";a:0:{}}s:14:\"facet_mincount\";s:1:\"1\";s:13:\"facet_missing\";s:1:\"0\";s:7:\"flatten\";s:1:\"0\";s:17:\"individual_parent\";s:1:\"0\";s:10:\"query_type\";s:4:\"term\";s:18:\"limit_active_items\";i:0;s:12:\"default_true\";s:1:\"1\";s:16:\"facet_search_ids\";a:0:{}s:7:\"exclude\";i:0;}'),('search_api@product_display::field_product:commerce_price:amount_decimal','search_api@product_display','','field_product:commerce_price:amount_decimal',0,'a:12:{s:8:\"operator\";s:2:\"or\";s:10:\"hard_limit\";s:2:\"50\";s:12:\"dependencies\";a:2:{s:6:\"bundle\";s:4:\"none\";s:15:\"bundle_selected\";a:0:{}}s:14:\"facet_mincount\";s:1:\"1\";s:13:\"facet_missing\";s:1:\"0\";s:7:\"flatten\";i:0;s:17:\"individual_parent\";i:0;s:10:\"query_type\";s:4:\"term\";s:18:\"limit_active_items\";i:0;s:12:\"default_true\";s:1:\"1\";s:16:\"facet_search_ids\";a:0:{}s:7:\"exclude\";i:0;}'),('search_api@product_display:block:field_availability','search_api@product_display','block','field_availability',1,'a:12:{s:6:\"weight\";i:0;s:6:\"widget\";s:23:\"facetapi_checkbox_links\";s:7:\"filters\";a:4:{s:16:\"useless_searches\";a:2:{s:6:\"status\";i:0;s:6:\"weight\";s:3:\"-50\";}s:17:\"hide_search_start\";a:2:{s:6:\"status\";i:0;s:6:\"weight\";s:3:\"-49\";}s:13:\"current_depth\";a:2:{s:6:\"status\";i:0;s:6:\"weight\";s:3:\"-47\";}s:12:\"active_items\";a:2:{s:6:\"status\";i:0;s:6:\"weight\";s:2:\"-1\";}}s:12:\"active_sorts\";a:3:{s:6:\"active\";s:6:\"active\";s:5:\"count\";s:5:\"count\";s:7:\"display\";s:7:\"display\";}s:11:\"sort_weight\";a:3:{s:6:\"active\";i:-50;s:5:\"count\";i:-49;s:7:\"display\";i:-48;}s:10:\"sort_order\";a:3:{s:6:\"active\";i:3;s:5:\"count\";i:3;s:7:\"display\";i:4;}s:14:\"empty_behavior\";s:4:\"none\";s:15:\"facet_more_text\";s:9:\"Show more\";s:16:\"facet_fewer_text\";s:10:\"Show fewer\";s:10:\"soft_limit\";i:20;s:8:\"nofollow\";i:1;s:13:\"show_expanded\";i:0;}'),('search_api@product_display:block:field_brand','search_api@product_display','block','field_brand',1,'a:20:{s:6:\"weight\";i:0;s:6:\"widget\";s:23:\"facetapi_checkbox_links\";s:7:\"filters\";a:4:{s:16:\"useless_searches\";a:2:{s:6:\"status\";i:0;s:6:\"weight\";s:3:\"-50\";}s:17:\"hide_search_start\";a:2:{s:6:\"status\";i:0;s:6:\"weight\";s:3:\"-49\";}s:13:\"current_depth\";a:2:{s:6:\"status\";i:1;s:6:\"weight\";s:3:\"-47\";}s:12:\"active_items\";a:2:{s:6:\"status\";i:0;s:6:\"weight\";s:2:\"-1\";}}s:12:\"active_sorts\";a:4:{s:6:\"active\";s:6:\"active\";s:5:\"count\";s:5:\"count\";s:7:\"display\";s:7:\"display\";s:7:\"indexed\";i:0;}s:11:\"sort_weight\";a:4:{s:6:\"active\";s:3:\"-50\";s:5:\"count\";s:3:\"-49\";s:7:\"display\";s:3:\"-48\";s:7:\"indexed\";s:1:\"0\";}s:10:\"sort_order\";a:4:{s:6:\"active\";s:1:\"3\";s:5:\"count\";s:1:\"3\";s:7:\"display\";s:1:\"4\";s:7:\"indexed\";s:1:\"4\";}s:14:\"empty_behavior\";s:4:\"none\";s:15:\"facet_more_text\";s:9:\"Show more\";s:16:\"facet_fewer_text\";s:10:\"Show fewer\";s:10:\"soft_limit\";s:2:\"20\";s:8:\"nofollow\";i:1;s:13:\"show_expanded\";i:0;s:4:\"name\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:17:\"auto-submit-delay\";s:4:\"1500\";s:12:\"range_simple\";i:10;s:14:\"range_advanced\";s:0:\"\";s:13:\"display_count\";i:0;s:10:\"empty_text\";a:2:{s:5:\"value\";s:0:\"\";s:6:\"format\";s:13:\"filtered_html\";}}'),('search_api@product_display:block:field_category','search_api@product_display','block','field_category',1,'a:20:{s:6:\"weight\";i:0;s:6:\"widget\";s:23:\"facetapi_checkbox_links\";s:7:\"filters\";a:4:{s:16:\"useless_searches\";a:2:{s:6:\"status\";i:0;s:6:\"weight\";s:3:\"-50\";}s:17:\"hide_search_start\";a:2:{s:6:\"status\";i:0;s:6:\"weight\";s:3:\"-49\";}s:13:\"current_depth\";a:2:{s:6:\"status\";i:1;s:6:\"weight\";s:3:\"-47\";}s:12:\"active_items\";a:2:{s:6:\"status\";i:0;s:6:\"weight\";s:2:\"-1\";}}s:12:\"active_sorts\";a:4:{s:6:\"active\";s:6:\"active\";s:5:\"count\";s:5:\"count\";s:7:\"display\";s:7:\"display\";s:7:\"indexed\";i:0;}s:11:\"sort_weight\";a:4:{s:6:\"active\";s:3:\"-50\";s:5:\"count\";s:3:\"-49\";s:7:\"display\";s:3:\"-48\";s:7:\"indexed\";s:1:\"0\";}s:10:\"sort_order\";a:4:{s:6:\"active\";s:1:\"3\";s:5:\"count\";s:1:\"3\";s:7:\"display\";s:1:\"4\";s:7:\"indexed\";s:1:\"4\";}s:14:\"empty_behavior\";s:4:\"text\";s:15:\"facet_more_text\";s:9:\"Show more\";s:16:\"facet_fewer_text\";s:10:\"Show fewer\";s:10:\"soft_limit\";s:2:\"20\";s:8:\"nofollow\";i:1;s:13:\"show_expanded\";i:0;s:4:\"name\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:17:\"auto-submit-delay\";s:4:\"1500\";s:12:\"range_simple\";i:10;s:14:\"range_advanced\";s:0:\"\";s:13:\"display_count\";i:0;s:10:\"empty_text\";a:2:{s:5:\"value\";s:18:\"<p>Not Found</p>\r\n\";s:6:\"format\";s:13:\"filtered_html\";}}'),('search_api@product_display:block:field_product:commerce_price:amount_decimal','search_api@product_display','block','field_product:commerce_price:amount_decimal',1,'a:20:{s:6:\"weight\";i:0;s:6:\"widget\";s:27:\"search_api_ranges_ui_slider\";s:7:\"filters\";a:3:{s:16:\"useless_searches\";a:2:{s:6:\"status\";i:0;s:6:\"weight\";s:3:\"-50\";}s:17:\"hide_search_start\";a:2:{s:6:\"status\";i:0;s:6:\"weight\";s:3:\"-49\";}s:12:\"active_items\";a:2:{s:6:\"status\";i:0;s:6:\"weight\";s:2:\"-1\";}}s:12:\"active_sorts\";a:4:{s:6:\"active\";s:6:\"active\";s:5:\"count\";s:5:\"count\";s:7:\"display\";s:7:\"display\";s:7:\"indexed\";i:0;}s:11:\"sort_weight\";a:4:{s:6:\"active\";s:3:\"-50\";s:5:\"count\";s:3:\"-49\";s:7:\"display\";s:3:\"-48\";s:7:\"indexed\";s:1:\"0\";}s:10:\"sort_order\";a:4:{s:6:\"active\";s:1:\"3\";s:5:\"count\";s:1:\"3\";s:7:\"display\";s:1:\"4\";s:7:\"indexed\";s:1:\"4\";}s:14:\"empty_behavior\";s:4:\"none\";s:15:\"facet_more_text\";s:9:\"Show more\";s:16:\"facet_fewer_text\";s:10:\"Show fewer\";s:10:\"soft_limit\";s:2:\"20\";s:8:\"nofollow\";i:1;s:13:\"show_expanded\";i:0;s:4:\"name\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:17:\"auto-submit-delay\";s:4:\"1500\";s:12:\"range_simple\";i:10;s:14:\"range_advanced\";s:0:\"\";s:13:\"display_count\";i:0;s:10:\"empty_text\";a:2:{s:5:\"value\";s:0:\"\";s:6:\"format\";s:13:\"filtered_html\";}}');
/*!40000 ALTER TABLE `facetapi` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_collection_item`
--

DROP TABLE IF EXISTS `field_collection_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_collection_item` (
  `item_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique field collection item ID.',
  `revision_id` int(11) NOT NULL COMMENT 'Default revision ID.',
  `field_name` varchar(32) NOT NULL COMMENT 'The name of the field on the host entity embedding this entity.',
  `archived` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the field collection item is archived.',
  PRIMARY KEY (`item_id`)
) ENGINE=InnoDB AUTO_INCREMENT=304 DEFAULT CHARSET=utf8 COMMENT='Stores information about field collection items.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_collection_item`
--

LOCK TABLES `field_collection_item` WRITE;
/*!40000 ALTER TABLE `field_collection_item` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_collection_item` VALUES (1,1,'field_information',0),(2,2,'field_information',0),(7,7,'field_specifications',0),(8,8,'field_specifications',0),(9,9,'field_specifications',0),(14,14,'field_specifications',0),(15,15,'field_specifications',0),(16,16,'field_specifications',0),(17,17,'field_specifications',0),(18,18,'field_specifications',0),(19,19,'field_specifications',0),(20,20,'field_specifications',0),(21,21,'field_specifications',0),(26,26,'field_specifications',0),(27,27,'field_specifications',0),(28,28,'field_specifications',0),(29,29,'field_specifications',0),(30,30,'field_specifications',0),(33,33,'field_specifications',0),(34,34,'field_specifications',0),(35,35,'field_specifications',0),(36,36,'field_specifications',0),(37,37,'field_specifications',0),(38,38,'field_specifications',0),(39,39,'field_specifications',0),(40,40,'field_specifications',0),(41,41,'field_specifications',0),(42,42,'field_specifications',0),(43,43,'field_specifications',0),(44,44,'field_specifications',0),(45,45,'field_specifications',0),(47,47,'field_specifications',0),(48,48,'field_specifications',0),(49,49,'field_specifications',0),(50,50,'field_specifications',0),(54,54,'field_specifications',0),(55,55,'field_specifications',0),(56,56,'field_specifications',0),(57,57,'field_specifications',0),(58,58,'field_specifications',0),(59,59,'field_specifications',0),(60,60,'field_specifications',0),(61,61,'field_specifications',0),(64,64,'field_specifications',0),(66,66,'field_specifications',0),(67,67,'field_specifications',0),(68,68,'field_specifications',0),(69,69,'field_specifications',0),(70,70,'field_specifications',0),(71,71,'field_specifications',0),(72,72,'field_specifications',0),(75,75,'field_specifications',0),(76,76,'field_specifications',0),(77,77,'field_specifications',0),(78,78,'field_specifications',0),(79,79,'field_specifications',0),(80,80,'field_specifications',0),(81,81,'field_specifications',0),(85,85,'field_specifications',0),(86,86,'field_specifications',0),(87,87,'field_specifications',0),(92,92,'field_specifications',0),(93,93,'field_specifications',0),(94,94,'field_specifications',0),(95,95,'field_specifications',0),(101,101,'field_specifications',0),(102,102,'field_specifications',0),(103,103,'field_specifications',0),(110,110,'field_specifications',0),(111,111,'field_specifications',0),(112,112,'field_specifications',0),(113,113,'field_specifications',0),(114,114,'field_specifications',0),(124,124,'field_specifications',0),(125,125,'field_specifications',0),(126,126,'field_specifications',0),(127,127,'field_specifications',0),(128,128,'field_specifications',0),(129,129,'field_specifications',0),(130,130,'field_specifications',0),(143,143,'field_specifications',0),(144,144,'field_specifications',0),(145,145,'field_specifications',0),(150,150,'field_specifications',0),(151,151,'field_specifications',0),(152,152,'field_specifications',0),(153,153,'field_specifications',0),(155,155,'field_specifications',0),(156,156,'field_specifications',0),(157,157,'field_specifications',0),(160,160,'field_specifications',0),(161,161,'field_specifications',0),(162,162,'field_specifications',0),(163,163,'field_specifications',0),(164,164,'field_specifications',0),(165,165,'field_specifications',0),(166,166,'field_specifications',0),(167,167,'field_specifications',0),(168,168,'field_specifications',0),(169,169,'field_specifications',0),(170,170,'field_specifications',0),(171,171,'field_specifications',0),(175,175,'field_specifications',0),(176,176,'field_specifications',0),(177,177,'field_specifications',0),(178,178,'field_specifications',0),(179,179,'field_specifications',0),(180,180,'field_specifications',0),(181,181,'field_specifications',0),(182,182,'field_specifications',0),(183,183,'field_specifications',0),(184,184,'field_specifications',0),(185,185,'field_specifications',0),(186,186,'field_specifications',0),(187,187,'field_specifications',0),(188,188,'field_specifications',0),(189,189,'field_specifications',0),(190,190,'field_specifications',0),(191,191,'field_specifications',0),(192,192,'field_specifications',0),(193,193,'field_specifications',0),(194,194,'field_specifications',0),(195,195,'field_specifications',0),(196,196,'field_specifications',0),(197,197,'field_specifications',0),(198,198,'field_specifications',0),(199,199,'field_specifications',0),(200,200,'field_specifications',0),(201,201,'field_specifications',0),(202,202,'field_specifications',0),(203,203,'field_specifications',0),(204,204,'field_specifications',0),(205,205,'field_specifications',0),(206,206,'field_specifications',0),(207,207,'field_specifications',0),(208,208,'field_specifications',0),(209,209,'field_specifications',0),(210,210,'field_specifications',0),(211,211,'field_specifications',0),(212,212,'field_specifications',0),(213,213,'field_specifications',0),(214,214,'field_specifications',0),(215,215,'field_specifications',0),(216,216,'field_specifications',0),(217,217,'field_specifications',0),(218,218,'field_specifications',0),(219,219,'field_specifications',0),(220,220,'field_specifications',0),(221,221,'field_specifications',0),(222,222,'field_specifications',0),(223,223,'field_specifications',0),(224,224,'field_specifications',0),(225,225,'field_specifications',0),(226,226,'field_specifications',0),(227,227,'field_specifications',0),(228,228,'field_specifications',0),(229,229,'field_specifications',0),(230,230,'field_specifications',0),(234,234,'field_specifications',0),(235,235,'field_specifications',0),(236,236,'field_specifications',0),(237,237,'field_specifications',0),(238,238,'field_specifications',0),(239,239,'field_specifications',0),(240,240,'field_specifications',0),(241,241,'field_specifications',0),(242,242,'field_specifications',0),(243,243,'field_specifications',0),(244,244,'field_specifications',0),(245,245,'field_specifications',0),(246,246,'field_specifications',0),(247,247,'field_specifications',0),(248,248,'field_specifications',0),(249,249,'field_specifications',0),(250,250,'field_specifications',0),(251,251,'field_specifications',0),(252,252,'field_specifications',0),(253,253,'field_specifications',0),(254,254,'field_specifications',0),(255,255,'field_specifications',0),(256,256,'field_specifications',0),(257,257,'field_specifications',0),(258,258,'field_specifications',0),(259,259,'field_specifications',0),(260,260,'field_specifications',0),(261,261,'field_specifications',0),(262,262,'field_specifications',0),(263,263,'field_specifications',0),(267,267,'field_specifications',0),(268,268,'field_specifications',0),(269,269,'field_specifications',0),(270,270,'field_specifications',0),(271,271,'field_specifications',0),(272,272,'field_specifications',0),(273,273,'field_specifications',0),(274,274,'field_specifications',0),(275,275,'field_specifications',0),(276,276,'field_specifications',0),(277,277,'field_specifications',0),(278,278,'field_specifications',0),(279,279,'field_specifications',0),(280,280,'field_specifications',0),(281,281,'field_specifications',0),(282,282,'field_specifications',0),(283,283,'field_specifications',0),(284,284,'field_specifications',0),(285,285,'field_specifications',0),(286,286,'field_specifications',0),(287,287,'field_specifications',0),(288,288,'field_specifications',0),(289,289,'field_specifications',0),(290,290,'field_specifications',0),(291,291,'field_specifications',0),(292,292,'field_specifications',0),(293,293,'field_specifications',0),(294,294,'field_specifications',0),(295,295,'field_specifications',0),(296,296,'field_specifications',0),(297,297,'field_specifications',0),(298,298,'field_specifications',0),(299,299,'field_specifications',0),(300,300,'field_specifications',0),(301,301,'field_specifications',0),(302,302,'field_specifications',0),(303,303,'field_specifications',0);
/*!40000 ALTER TABLE `field_collection_item` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_collection_item_revision`
--

DROP TABLE IF EXISTS `field_collection_item_revision`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_collection_item_revision` (
  `revision_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique revision ID.',
  `item_id` int(11) NOT NULL COMMENT 'Field collection item ID.',
  PRIMARY KEY (`revision_id`),
  KEY `item_id` (`item_id`)
) ENGINE=InnoDB AUTO_INCREMENT=304 DEFAULT CHARSET=utf8 COMMENT='Stores revision information about field collection items.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_collection_item_revision`
--

LOCK TABLES `field_collection_item_revision` WRITE;
/*!40000 ALTER TABLE `field_collection_item_revision` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_collection_item_revision` VALUES (1,1),(2,2),(7,7),(8,8),(9,9),(14,14),(15,15),(16,16),(17,17),(18,18),(19,19),(20,20),(21,21),(26,26),(27,27),(28,28),(29,29),(30,30),(33,33),(34,34),(35,35),(36,36),(37,37),(38,38),(39,39),(40,40),(41,41),(42,42),(43,43),(44,44),(45,45),(47,47),(48,48),(49,49),(50,50),(54,54),(55,55),(56,56),(57,57),(58,58),(59,59),(60,60),(61,61),(64,64),(66,66),(67,67),(68,68),(69,69),(70,70),(71,71),(72,72),(75,75),(76,76),(77,77),(78,78),(79,79),(80,80),(81,81),(85,85),(86,86),(87,87),(92,92),(93,93),(94,94),(95,95),(101,101),(102,102),(103,103),(110,110),(111,111),(112,112),(113,113),(114,114),(124,124),(125,125),(126,126),(127,127),(128,128),(129,129),(130,130),(143,143),(144,144),(145,145),(150,150),(151,151),(152,152),(153,153),(155,155),(156,156),(157,157),(160,160),(161,161),(162,162),(163,163),(164,164),(165,165),(166,166),(167,167),(168,168),(169,169),(170,170),(171,171),(175,175),(176,176),(177,177),(178,178),(179,179),(180,180),(181,181),(182,182),(183,183),(184,184),(185,185),(186,186),(187,187),(188,188),(189,189),(190,190),(191,191),(192,192),(193,193),(194,194),(195,195),(196,196),(197,197),(198,198),(199,199),(200,200),(201,201),(202,202),(203,203),(204,204),(205,205),(206,206),(207,207),(208,208),(209,209),(210,210),(211,211),(212,212),(213,213),(214,214),(215,215),(216,216),(217,217),(218,218),(219,219),(220,220),(221,221),(222,222),(223,223),(224,224),(225,225),(226,226),(227,227),(228,228),(229,229),(230,230),(234,234),(235,235),(236,236),(237,237),(238,238),(239,239),(240,240),(241,241),(242,242),(243,243),(244,244),(245,245),(246,246),(247,247),(248,248),(249,249),(250,250),(251,251),(252,252),(253,253),(254,254),(255,255),(256,256),(257,257),(258,258),(259,259),(260,260),(261,261),(262,262),(263,263),(267,267),(268,268),(269,269),(270,270),(271,271),(272,272),(273,273),(274,274),(275,275),(276,276),(277,277),(278,278),(279,279),(280,280),(281,281),(282,282),(283,283),(284,284),(285,285),(286,286),(287,287),(288,288),(289,289),(290,290),(291,291),(292,292),(293,293),(294,294),(295,295),(296,296),(297,297),(298,298),(299,299),(300,300),(301,301),(302,302),(303,303);
/*!40000 ALTER TABLE `field_collection_item_revision` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_config`
--

DROP TABLE IF EXISTS `field_config`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_config` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a field',
  `field_name` varchar(32) NOT NULL COMMENT 'The name of this field. Non-deleted field names are unique, but multiple deleted fields can have the same name.',
  `type` varchar(128) NOT NULL COMMENT 'The type of this field.',
  `module` varchar(128) NOT NULL DEFAULT '' COMMENT 'The module that implements the field type.',
  `active` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the module that implements the field type is enabled.',
  `storage_type` varchar(128) NOT NULL COMMENT 'The storage backend for the field.',
  `storage_module` varchar(128) NOT NULL DEFAULT '' COMMENT 'The module that implements the storage backend.',
  `storage_active` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the module that implements the storage backend is enabled.',
  `locked` tinyint(4) NOT NULL DEFAULT '0' COMMENT '@TODO',
  `data` longblob NOT NULL COMMENT 'Serialized data containing the field properties that do not warrant a dedicated column.',
  `cardinality` tinyint(4) NOT NULL DEFAULT '0',
  `translatable` tinyint(4) NOT NULL DEFAULT '0',
  `deleted` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `field_name` (`field_name`),
  KEY `active` (`active`),
  KEY `storage_active` (`storage_active`),
  KEY `deleted` (`deleted`),
  KEY `module` (`module`),
  KEY `storage_module` (`storage_module`),
  KEY `type` (`type`),
  KEY `storage_type` (`storage_type`)
) ENGINE=InnoDB AUTO_INCREMENT=60 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_config`
--

LOCK TABLES `field_config` WRITE;
/*!40000 ALTER TABLE `field_config` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_config` VALUES (1,'comment_body','text_long','text',1,'field_sql_storage','field_sql_storage',1,0,'a:6:{s:12:\"entity_types\";a:1:{i:0;s:7:\"comment\";}s:12:\"translatable\";b:0;s:8:\"settings\";a:0:{}s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}}',1,0,0),(2,'body','text_with_summary','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"entity_types\";a:1:{i:0;s:4:\"node\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:15:\"field_data_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:19:\"field_revision_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"2\";}',1,0,0),(3,'field_tags','taxonomy_term_reference','taxonomy',1,'field_sql_storage','field_sql_storage',1,0,'a:6:{s:8:\"settings\";a:1:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:4:\"tags\";s:6:\"parent\";i:0;}}}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";b:0;s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}}',-1,0,0),(4,'field_image','image','image',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:7:\"indexes\";a:1:{s:3:\"fid\";a:1:{i:0;s:3:\"fid\";}}s:8:\"settings\";a:2:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";i:0;}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:22:\"field_data_field_image\";a:5:{s:3:\"fid\";s:15:\"field_image_fid\";s:3:\"alt\";s:15:\"field_image_alt\";s:5:\"title\";s:17:\"field_image_title\";s:5:\"width\";s:17:\"field_image_width\";s:6:\"height\";s:18:\"field_image_height\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:26:\"field_revision_field_image\";a:5:{s:3:\"fid\";s:15:\"field_image_fid\";s:3:\"alt\";s:15:\"field_image_alt\";s:5:\"title\";s:17:\"field_image_title\";s:5:\"width\";s:17:\"field_image_width\";s:6:\"height\";s:18:\"field_image_height\";}}}}}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";s:1:\"0\";s:12:\"foreign keys\";a:1:{s:3:\"fid\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:3:\"fid\";s:3:\"fid\";}}}s:2:\"id\";s:1:\"4\";}',1,0,0),(5,'field_simplenews_term','taxonomy_term_reference','taxonomy',1,'field_sql_storage','field_sql_storage',1,0,'a:6:{s:12:\"translatable\";b:1;s:8:\"settings\";a:1:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:6:\"parent\";i:0;s:10:\"vocabulary\";s:10:\"newsletter\";}}}s:12:\"entity_types\";a:0:{}s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}}',1,1,0),(6,'commerce_customer_address','addressfield','addressfield',1,'field_sql_storage','field_sql_storage',1,0,'a:6:{s:12:\"entity_types\";a:1:{i:0;s:25:\"commerce_customer_profile\";}s:12:\"translatable\";b:0;s:8:\"settings\";a:0:{}s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}}',1,0,0),(7,'commerce_line_items','commerce_line_item_reference','commerce_line_item',1,'field_sql_storage','field_sql_storage',1,1,'a:6:{s:12:\"entity_types\";a:1:{i:0;s:14:\"commerce_order\";}s:12:\"translatable\";b:0;s:8:\"settings\";a:0:{}s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:1:{s:12:\"line_item_id\";a:2:{s:5:\"table\";s:18:\"commerce_line_item\";s:7:\"columns\";a:1:{s:12:\"line_item_id\";s:12:\"line_item_id\";}}}s:7:\"indexes\";a:1:{s:12:\"line_item_id\";a:1:{i:0;s:12:\"line_item_id\";}}}',-1,0,0),(8,'commerce_order_total','commerce_price','commerce_price',1,'field_sql_storage','field_sql_storage',1,1,'a:6:{s:12:\"entity_types\";a:1:{i:0;s:14:\"commerce_order\";}s:12:\"translatable\";b:0;s:8:\"settings\";a:0:{}s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:14:\"currency_price\";a:2:{i:0;s:6:\"amount\";i:1;s:13:\"currency_code\";}}}',1,0,0),(9,'commerce_customer_billing','commerce_customer_profile_reference','commerce_customer',1,'field_sql_storage','field_sql_storage',1,0,'a:6:{s:12:\"entity_types\";a:1:{i:0;s:14:\"commerce_order\";}s:12:\"translatable\";b:0;s:8:\"settings\";a:2:{s:12:\"profile_type\";s:7:\"billing\";s:18:\"options_list_limit\";i:50;}s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:1:{s:10:\"profile_id\";a:2:{s:5:\"table\";s:25:\"commerce_customer_profile\";s:7:\"columns\";a:1:{s:10:\"profile_id\";s:10:\"profile_id\";}}}s:7:\"indexes\";a:1:{s:10:\"profile_id\";a:1:{i:0;s:10:\"profile_id\";}}}',1,0,0),(10,'commerce_unit_price','commerce_price','commerce_price',1,'field_sql_storage','field_sql_storage',1,1,'a:6:{s:12:\"entity_types\";a:1:{i:0;s:18:\"commerce_line_item\";}s:12:\"translatable\";b:0;s:8:\"settings\";a:0:{}s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:14:\"currency_price\";a:2:{i:0;s:6:\"amount\";i:1;s:13:\"currency_code\";}}}',1,0,0),(11,'commerce_total','commerce_price','commerce_price',1,'field_sql_storage','field_sql_storage',1,1,'a:6:{s:12:\"entity_types\";a:1:{i:0;s:18:\"commerce_line_item\";}s:12:\"translatable\";b:0;s:8:\"settings\";a:0:{}s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:14:\"currency_price\";a:2:{i:0;s:6:\"amount\";i:1;s:13:\"currency_code\";}}}',1,0,0),(12,'commerce_product','commerce_product_reference','commerce_product_reference',1,'field_sql_storage','field_sql_storage',1,1,'a:6:{s:12:\"entity_types\";a:1:{i:0;s:18:\"commerce_line_item\";}s:12:\"translatable\";b:0;s:8:\"settings\";a:1:{s:18:\"options_list_limit\";N;}s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:1:{s:10:\"product_id\";a:2:{s:5:\"table\";s:16:\"commerce_product\";s:7:\"columns\";a:1:{s:10:\"product_id\";s:10:\"product_id\";}}}s:7:\"indexes\";a:1:{s:10:\"product_id\";a:1:{i:0;s:10:\"product_id\";}}}',1,0,0),(13,'commerce_display_path','text','text',1,'field_sql_storage','field_sql_storage',1,1,'a:6:{s:12:\"entity_types\";a:1:{i:0;s:18:\"commerce_line_item\";}s:12:\"translatable\";b:0;s:8:\"settings\";a:1:{s:10:\"max_length\";i:255;}s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}}',1,0,0),(14,'commerce_price','commerce_price','commerce_price',1,'field_sql_storage','field_sql_storage',1,1,'a:6:{s:12:\"entity_types\";a:1:{i:0;s:16:\"commerce_product\";}s:12:\"translatable\";b:0;s:8:\"settings\";a:0:{}s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:14:\"currency_price\";a:2:{i:0;s:6:\"amount\";i:1;s:13:\"currency_code\";}}}',1,0,0),(15,'field_link','link_field','link',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:7:{s:10:\"attributes\";a:3:{s:6:\"target\";s:7:\"default\";s:5:\"class\";s:0:\"\";s:3:\"rel\";s:0:\"\";}s:3:\"url\";i:0;s:5:\"title\";s:8:\"optional\";s:11:\"title_value\";s:0:\"\";s:15:\"title_maxlength\";i:128;s:13:\"enable_tokens\";i:1;s:7:\"display\";a:1:{s:10:\"url_cutoff\";i:80;}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_link\";a:3:{s:3:\"url\";s:14:\"field_link_url\";s:5:\"title\";s:16:\"field_link_title\";s:10:\"attributes\";s:21:\"field_link_attributes\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_link\";a:3:{s:3:\"url\";s:14:\"field_link_url\";s:5:\"title\";s:16:\"field_link_title\";s:10:\"attributes\";s:21:\"field_link_attributes\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"15\";}',1,0,0),(17,'field_product','commerce_product_reference','commerce_product_reference',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:18:\"options_list_limit\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:24:\"field_data_field_product\";a:1:{s:10:\"product_id\";s:24:\"field_product_product_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:28:\"field_revision_field_product\";a:1:{s:10:\"product_id\";s:24:\"field_product_product_id\";}}}}}s:12:\"foreign keys\";a:1:{s:10:\"product_id\";a:2:{s:5:\"table\";s:16:\"commerce_product\";s:7:\"columns\";a:1:{s:10:\"product_id\";s:10:\"product_id\";}}}s:7:\"indexes\";a:1:{s:10:\"product_id\";a:1:{i:0;s:10:\"product_id\";}}s:2:\"id\";s:2:\"17\";}',-1,0,0),(18,'field_category','taxonomy_term_reference','taxonomy',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:10:\"categories\";s:6:\"parent\";s:1:\"0\";}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_category\";a:1:{s:3:\"tid\";s:18:\"field_category_tid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_category\";a:1:{s:3:\"tid\";s:18:\"field_category_tid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}s:2:\"id\";s:2:\"18\";}',1,0,0),(21,'field_brand','taxonomy_term_reference','taxonomy',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:6:\"brands\";s:6:\"parent\";s:1:\"0\";}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:22:\"field_data_field_brand\";a:1:{s:3:\"tid\";s:15:\"field_brand_tid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:26:\"field_revision_field_brand\";a:1:{s:3:\"tid\";s:15:\"field_brand_tid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}s:2:\"id\";s:2:\"21\";}',1,0,0),(22,'cmp_store','entityreference','entityreference',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:8:\"settings\";a:3:{s:11:\"target_type\";s:14:\"commerce_store\";s:7:\"handler\";s:30:\"commerce_store_access_behavior\";s:16:\"handler_settings\";a:1:{s:9:\"behaviors\";a:1:{s:17:\"views-select-list\";a:1:{s:6:\"status\";i:0;}}}}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:20:\"field_data_cmp_store\";a:1:{s:9:\"target_id\";s:19:\"cmp_store_target_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:24:\"field_revision_cmp_store\";a:1:{s:9:\"target_id\";s:19:\"cmp_store_target_id\";}}}}}s:12:\"foreign keys\";a:1:{s:18:\"eck_commerce_store\";a:2:{s:5:\"table\";s:18:\"eck_commerce_store\";s:7:\"columns\";a:1:{s:9:\"target_id\";s:2:\"id\";}}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:2:\"id\";s:2:\"22\";}',1,0,0),(23,'cmp_m_store','entityreference','entityreference',1,'field_sql_storage','field_sql_storage',1,0,'a:6:{s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:0:{}}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";b:0;s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:1:{s:5:\"users\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:9:\"target_id\";s:3:\"uid\";}}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}}',-1,0,0),(24,'commerce_customer_shipping','commerce_customer_profile_reference','commerce_customer',1,'field_sql_storage','field_sql_storage',1,0,'a:6:{s:12:\"entity_types\";a:1:{i:0;s:14:\"commerce_order\";}s:12:\"translatable\";b:0;s:8:\"settings\";a:2:{s:12:\"profile_type\";s:8:\"shipping\";s:18:\"options_list_limit\";i:50;}s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:1:{s:10:\"profile_id\";a:2:{s:5:\"table\";s:25:\"commerce_customer_profile\";s:7:\"columns\";a:1:{s:10:\"profile_id\";s:10:\"profile_id\";}}}s:7:\"indexes\";a:1:{s:10:\"profile_id\";a:1:{i:0;s:10:\"profile_id\";}}}',1,0,0),(25,'cmp_o_store','entityreference','entityreference',1,'field_sql_storage','field_sql_storage',1,0,'a:6:{s:8:\"settings\";a:3:{s:11:\"target_type\";s:14:\"commerce_store\";s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:0:{}}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";b:0;s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}}',1,0,0),(26,'cmp_order','entityreference','entityreference',1,'field_sql_storage','field_sql_storage',1,0,'a:6:{s:8:\"settings\";a:3:{s:11:\"target_type\";s:14:\"commerce_order\";s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:0:{}}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";b:0;s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:1:{s:14:\"commerce_order\";a:2:{s:5:\"table\";s:14:\"commerce_order\";s:7:\"columns\";a:1:{s:9:\"target_id\";s:8:\"order_id\";}}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}}',1,0,0),(27,'cmp_line_item','entityreference','entityreference',1,'field_sql_storage','field_sql_storage',1,0,'a:6:{s:8:\"settings\";a:3:{s:11:\"target_type\";s:18:\"commerce_line_item\";s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:0:{}}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";b:0;s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:1:{s:18:\"commerce_line_item\";a:2:{s:5:\"table\";s:18:\"commerce_line_item\";s:7:\"columns\";a:1:{s:9:\"target_id\";s:12:\"line_item_id\";}}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}}',1,0,0),(28,'commerce_shipping_service','list_text','list',1,'field_sql_storage','field_sql_storage',1,1,'a:6:{s:12:\"entity_types\";a:1:{i:0;s:18:\"commerce_line_item\";}s:12:\"translatable\";b:0;s:8:\"settings\";a:2:{s:23:\"allowed_values_function\";s:38:\"commerce_shipping_service_options_list\";s:14:\"allowed_values\";a:0:{}}s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}}',1,0,0),(33,'field_summary','text_long','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:24:\"field_data_field_summary\";a:2:{s:5:\"value\";s:19:\"field_summary_value\";s:6:\"format\";s:20:\"field_summary_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:28:\"field_revision_field_summary\";a:2:{s:5:\"value\";s:19:\"field_summary_value\";s:6:\"format\";s:20:\"field_summary_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"33\";}',1,0,0),(35,'field_specifications','field_collection','field_collection',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:16:\"hide_blank_items\";i:1;s:4:\"path\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:31:\"field_data_field_specifications\";a:2:{s:5:\"value\";s:26:\"field_specifications_value\";s:11:\"revision_id\";s:32:\"field_specifications_revision_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:35:\"field_revision_field_specifications\";a:2:{s:5:\"value\";s:26:\"field_specifications_value\";s:11:\"revision_id\";s:32:\"field_specifications_revision_id\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}s:2:\"id\";s:2:\"35\";}',-1,0,0),(36,'field_colllect_title','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:31:\"field_data_field_colllect_title\";a:2:{s:5:\"value\";s:26:\"field_colllect_title_value\";s:6:\"format\";s:27:\"field_colllect_title_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:35:\"field_revision_field_colllect_title\";a:2:{s:5:\"value\";s:26:\"field_colllect_title_value\";s:6:\"format\";s:27:\"field_colllect_title_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"36\";}',1,0,0),(38,'field_review','fivestar','fivestar',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:4:\"axis\";s:4:\"vote\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:23:\"field_data_field_review\";a:2:{s:6:\"rating\";s:19:\"field_review_rating\";s:6:\"target\";s:19:\"field_review_target\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:27:\"field_revision_field_review\";a:2:{s:6:\"rating\";s:19:\"field_review_rating\";s:6:\"target\";s:19:\"field_review_target\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"38\";}',1,0,0),(39,'field_product_image','image','image',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";i:0;}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_product_image\";a:5:{s:3:\"fid\";s:23:\"field_product_image_fid\";s:3:\"alt\";s:23:\"field_product_image_alt\";s:5:\"title\";s:25:\"field_product_image_title\";s:5:\"width\";s:25:\"field_product_image_width\";s:6:\"height\";s:26:\"field_product_image_height\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_product_image\";a:5:{s:3:\"fid\";s:23:\"field_product_image_fid\";s:3:\"alt\";s:23:\"field_product_image_alt\";s:5:\"title\";s:25:\"field_product_image_title\";s:5:\"width\";s:25:\"field_product_image_width\";s:6:\"height\";s:26:\"field_product_image_height\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"fid\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:3:\"fid\";s:3:\"fid\";}}}s:7:\"indexes\";a:1:{s:3:\"fid\";a:1:{i:0;s:3:\"fid\";}}s:2:\"id\";s:2:\"39\";}',-1,0,0),(41,'field_slide','list_boolean','list',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:2:{i:0;s:9:\"Not Slide\";i:1;s:5:\"Slide\";}s:23:\"allowed_values_function\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:22:\"field_data_field_slide\";a:1:{s:5:\"value\";s:17:\"field_slide_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:26:\"field_revision_field_slide\";a:1:{s:5:\"value\";s:17:\"field_slide_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:2:\"id\";s:2:\"41\";}',1,0,0),(42,'field_bean_icon','icon_field','icon_field',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:6:\"bundle\";N;s:4:\"icon\";N;}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:26:\"field_data_field_bean_icon\";a:2:{s:6:\"bundle\";s:22:\"field_bean_icon_bundle\";s:4:\"icon\";s:20:\"field_bean_icon_icon\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:30:\"field_revision_field_bean_icon\";a:2:{s:6:\"bundle\";s:22:\"field_bean_icon_bundle\";s:4:\"icon\";s:20:\"field_bean_icon_icon\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"42\";}',1,0,0),(43,'field_body','text_with_summary','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_body\";a:3:{s:5:\"value\";s:16:\"field_body_value\";s:7:\"summary\";s:18:\"field_body_summary\";s:6:\"format\";s:17:\"field_body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_body\";a:3:{s:5:\"value\";s:16:\"field_body_value\";s:7:\"summary\";s:18:\"field_body_summary\";s:6:\"format\";s:17:\"field_body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"43\";}',1,0,0),(44,'field_boolean','list_boolean','list',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:2:{i:0;s:8:\"Not Deal\";i:1;s:4:\"Deal\";}s:23:\"allowed_values_function\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:24:\"field_data_field_boolean\";a:1:{s:5:\"value\";s:19:\"field_boolean_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:28:\"field_revision_field_boolean\";a:1:{s:5:\"value\";s:19:\"field_boolean_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:2:\"id\";s:2:\"44\";}',1,0,0),(45,'field_map','text_long','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:20:\"field_data_field_map\";a:2:{s:5:\"value\";s:15:\"field_map_value\";s:6:\"format\";s:16:\"field_map_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:24:\"field_revision_field_map\";a:2:{s:5:\"value\";s:15:\"field_map_value\";s:6:\"format\";s:16:\"field_map_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"45\";}',1,0,0),(46,'commerce_stock','number_decimal','number',1,'field_sql_storage','field_sql_storage',1,0,'a:6:{s:12:\"entity_types\";a:1:{i:0;s:16:\"commerce_product\";}s:12:\"translatable\";b:0;s:8:\"settings\";a:3:{s:9:\"precision\";i:10;s:5:\"scale\";i:2;s:17:\"decimal_separator\";s:1:\".\";}s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}}',1,0,0),(47,'title_field','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:6:{s:12:\"translatable\";b:1;s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";i:255;}s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}}',1,1,0),(48,'field_old_price','commerce_price','commerce_price',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:26:\"field_data_field_old_price\";a:3:{s:6:\"amount\";s:22:\"field_old_price_amount\";s:13:\"currency_code\";s:29:\"field_old_price_currency_code\";s:4:\"data\";s:20:\"field_old_price_data\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:30:\"field_revision_field_old_price\";a:3:{s:6:\"amount\";s:22:\"field_old_price_amount\";s:13:\"currency_code\";s:29:\"field_old_price_currency_code\";s:4:\"data\";s:20:\"field_old_price_data\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:14:\"currency_price\";a:2:{i:0;s:6:\"amount\";i:1;s:13:\"currency_code\";}}s:2:\"id\";s:2:\"48\";}',1,0,0),(49,'field_description','text_long','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_description\";a:2:{s:5:\"value\";s:23:\"field_description_value\";s:6:\"format\";s:24:\"field_description_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_description\";a:2:{s:5:\"value\";s:23:\"field_description_value\";s:6:\"format\";s:24:\"field_description_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"49\";}',1,0,0),(50,'field_color','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:22:\"field_data_field_color\";a:2:{s:5:\"value\";s:17:\"field_color_value\";s:6:\"format\";s:18:\"field_color_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:26:\"field_revision_field_color\";a:2:{s:5:\"value\";s:17:\"field_color_value\";s:6:\"format\";s:18:\"field_color_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"50\";}',1,0,0),(51,'field_product_color','taxonomy_term_reference','taxonomy',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:5:\"color\";s:6:\"parent\";s:1:\"0\";}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_product_color\";a:1:{s:3:\"tid\";s:23:\"field_product_color_tid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_product_color\";a:1:{s:3:\"tid\";s:23:\"field_product_color_tid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}s:2:\"id\";s:2:\"51\";}',1,0,0),(52,'balance','commerce_price','commerce_price',1,'field_sql_storage','field_sql_storage',1,0,'a:6:{s:8:\"settings\";a:0:{}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";b:0;s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:14:\"currency_price\";a:2:{i:0;s:6:\"amount\";i:1;s:13:\"currency_code\";}}}',1,0,0),(53,'amount','commerce_price','commerce_price',1,'field_sql_storage','field_sql_storage',1,0,'a:6:{s:8:\"settings\";a:0:{}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";b:0;s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:14:\"currency_price\";a:2:{i:0;s:6:\"amount\";i:1;s:13:\"currency_code\";}}}',1,0,0),(54,'notes','text_long','text',1,'field_sql_storage','field_sql_storage',1,0,'a:6:{s:8:\"settings\";a:0:{}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";b:0;s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}}',1,0,0),(55,'withdraw_method','entityreference','entityreference',1,'field_sql_storage','field_sql_storage',1,0,'a:6:{s:8:\"settings\";a:3:{s:11:\"target_type\";s:25:\"cmp_funds_withdraw_method\";s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:0:{}}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";b:0;s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}}',1,0,0),(56,'field_withdraw_name','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_withdraw_name\";a:2:{s:5:\"value\";s:25:\"field_withdraw_name_value\";s:6:\"format\";s:26:\"field_withdraw_name_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_withdraw_name\";a:2:{s:5:\"value\";s:25:\"field_withdraw_name_value\";s:6:\"format\";s:26:\"field_withdraw_name_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"56\";}',1,0,0),(57,'field_paypal_email','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:29:\"field_data_field_paypal_email\";a:2:{s:5:\"value\";s:24:\"field_paypal_email_value\";s:6:\"format\";s:25:\"field_paypal_email_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:33:\"field_revision_field_paypal_email\";a:2:{s:5:\"value\";s:24:\"field_paypal_email_value\";s:6:\"format\";s:25:\"field_paypal_email_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"57\";}',1,0,0),(59,'field_discount_percentage','number_decimal','number',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:17:\"decimal_separator\";s:1:\".\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:36:\"field_data_field_discount_percentage\";a:1:{s:5:\"value\";s:31:\"field_discount_percentage_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:40:\"field_revision_field_discount_percentage\";a:1:{s:5:\"value\";s:31:\"field_discount_percentage_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"59\";}',1,0,0);
/*!40000 ALTER TABLE `field_config` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_config_instance`
--

DROP TABLE IF EXISTS `field_config_instance`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_config_instance` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a field instance',
  `field_id` int(11) NOT NULL COMMENT 'The identifier of the field attached by this instance',
  `field_name` varchar(32) NOT NULL DEFAULT '',
  `entity_type` varchar(32) NOT NULL DEFAULT '',
  `bundle` varchar(128) NOT NULL DEFAULT '',
  `data` longblob NOT NULL,
  `deleted` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `field_name_bundle` (`field_name`,`entity_type`,`bundle`),
  KEY `deleted` (`deleted`)
) ENGINE=InnoDB AUTO_INCREMENT=106 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_config_instance`
--

LOCK TABLES `field_config_instance` WRITE;
/*!40000 ALTER TABLE `field_config_instance` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_config_instance` VALUES (1,1,'comment_body','comment','comment_node_page','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(2,2,'body','node','page','a:6:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";i:-4;s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(3,1,'comment_body','comment','comment_node_article','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(4,2,'body','node','article','a:6:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";i:-4;s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(5,3,'field_tags','node','article','a:6:{s:5:\"label\";s:4:\"Tags\";s:11:\"description\";s:63:\"Enter a comma-separated list of words to describe your content.\";s:6:\"widget\";a:4:{s:4:\"type\";s:21:\"taxonomy_autocomplete\";s:6:\"weight\";i:-4;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:21:\"taxonomy/autocomplete\";}s:6:\"module\";s:8:\"taxonomy\";}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:6:\"weight\";i:10;s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}s:6:\"teaser\";a:5:{s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:6:\"weight\";i:10;s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:8:\"required\";b:0;}',0),(6,4,'field_image','node','article','a:6:{s:5:\"label\";s:5:\"Image\";s:11:\"description\";s:40:\"Upload an image to go with this article.\";s:8:\"required\";b:0;s:8:\"settings\";a:9:{s:14:\"file_directory\";s:11:\"field/image\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";b:1;s:11:\"title_field\";s:0:\"\";s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:11:\"image_image\";s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}s:6:\"weight\";i:-1;s:6:\"module\";s:5:\"image\";}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:5:\"large\";s:10:\"image_link\";s:0:\"\";}s:6:\"weight\";i:-1;s:6:\"module\";s:5:\"image\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:6:\"medium\";s:10:\"image_link\";s:7:\"content\";}s:6:\"weight\";i:-1;s:6:\"module\";s:5:\"image\";}}}',0),(7,1,'comment_body','comment','comment_node_simplenews','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(8,2,'body','node','simplenews','a:6:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";i:-4;s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:2:{s:11:\"trim_length\";i:600;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(9,5,'field_simplenews_term','node','simplenews','a:6:{s:5:\"label\";s:19:\"Newsletter category\";s:8:\"required\";b:1;s:6:\"widget\";a:4:{s:4:\"type\";s:15:\"options_buttons\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:-3;s:6:\"module\";s:7:\"options\";}s:7:\"display\";a:5:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:8:\"taxonomy\";s:6:\"weight\";i:1;}s:6:\"teaser\";a:4:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:1;}s:11:\"email_plain\";a:4:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}s:10:\"email_html\";a:4:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}s:13:\"email_textalt\";a:4:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"hidden\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:11:\"description\";s:0:\"\";}',0),(10,1,'comment_body','comment','comment_node_webform','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(11,6,'commerce_customer_address','commerce_customer_profile','billing','a:6:{s:5:\"label\";s:7:\"Address\";s:8:\"required\";b:1;s:6:\"widget\";a:4:{s:4:\"type\";s:21:\"addressfield_standard\";s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:15:\"format_handlers\";a:2:{i:0;s:7:\"address\";i:1;s:12:\"name-oneline\";}s:19:\"available_countries\";a:0:{}s:15:\"default_country\";s:0:\"\";}s:6:\"module\";s:12:\"addressfield\";}s:7:\"display\";a:3:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:20:\"addressfield_default\";s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:19:\"use_widget_handlers\";i:1;s:15:\"format_handlers\";a:1:{i:0;s:7:\"address\";}s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:12:\"addressfield\";}s:8:\"customer\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:20:\"addressfield_default\";s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:19:\"use_widget_handlers\";i:1;s:15:\"format_handlers\";a:1:{i:0;s:7:\"address\";}s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:12:\"addressfield\";}s:13:\"administrator\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:20:\"addressfield_default\";s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:19:\"use_widget_handlers\";i:1;s:15:\"format_handlers\";a:1:{i:0;s:7:\"address\";}s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:12:\"addressfield\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:11:\"description\";s:0:\"\";}',0),(12,7,'commerce_line_items','commerce_order','commerce_order','a:6:{s:5:\"label\";s:10:\"Line items\";s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"commerce_line_item_manager\";s:6:\"weight\";i:-10;s:8:\"settings\";a:0:{}s:6:\"module\";s:18:\"commerce_line_item\";}s:7:\"display\";a:3:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:33:\"commerce_line_item_reference_view\";s:6:\"weight\";i:-10;s:8:\"settings\";a:2:{s:4:\"view\";s:32:\"commerce_line_item_table|default\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:18:\"commerce_line_item\";}s:8:\"customer\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:33:\"commerce_line_item_reference_view\";s:6:\"weight\";i:-10;s:8:\"settings\";a:2:{s:4:\"view\";s:32:\"commerce_line_item_table|default\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:18:\"commerce_line_item\";}s:13:\"administrator\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:33:\"commerce_line_item_reference_view\";s:6:\"weight\";i:-10;s:8:\"settings\";a:2:{s:4:\"view\";s:32:\"commerce_line_item_table|default\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:18:\"commerce_line_item\";}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(13,8,'commerce_order_total','commerce_order','commerce_order','a:6:{s:5:\"label\";s:11:\"Order total\";s:8:\"required\";b:1;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:19:\"commerce_price_full\";s:6:\"weight\";i:-8;s:8:\"settings\";a:1:{s:13:\"currency_code\";s:7:\"default\";}s:6:\"module\";s:14:\"commerce_price\";}s:7:\"display\";a:4:{s:13:\"administrator\";a:5:{s:4:\"type\";s:35:\"commerce_price_formatted_components\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:-8;s:6:\"module\";s:14:\"commerce_price\";}s:8:\"customer\";a:5:{s:4:\"type\";s:35:\"commerce_price_formatted_components\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:-8;s:6:\"module\";s:14:\"commerce_price\";}s:7:\"default\";a:5:{s:4:\"type\";s:35:\"commerce_price_formatted_components\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:-8;s:6:\"module\";s:14:\"commerce_price\";}s:11:\"node_teaser\";a:5:{s:4:\"type\";s:35:\"commerce_price_formatted_components\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:-8;s:6:\"module\";s:14:\"commerce_price\";}}s:11:\"description\";s:0:\"\";}',0),(14,9,'commerce_customer_billing','commerce_order','commerce_order','a:6:{s:5:\"label\";s:19:\"Billing information\";s:6:\"widget\";a:4:{s:4:\"type\";s:33:\"commerce_customer_profile_manager\";s:6:\"weight\";i:-5;s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"commerce_customer\";}s:7:\"display\";a:3:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:43:\"commerce_customer_profile_reference_display\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:17:\"commerce_customer\";}s:8:\"customer\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:43:\"commerce_customer_profile_reference_display\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:17:\"commerce_customer\";}s:13:\"administrator\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:43:\"commerce_customer_profile_reference_display\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:17:\"commerce_customer\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(15,10,'commerce_unit_price','commerce_line_item','product','a:6:{s:5:\"label\";s:10:\"Unit price\";s:8:\"required\";b:1;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:19:\"commerce_price_full\";s:6:\"weight\";i:0;s:8:\"settings\";a:1:{s:13:\"currency_code\";s:7:\"default\";}s:6:\"module\";s:14:\"commerce_price\";}s:7:\"display\";a:3:{s:7:\"display\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:11:\"node_teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}}s:11:\"description\";s:0:\"\";}',0),(16,11,'commerce_total','commerce_line_item','product','a:6:{s:5:\"label\";s:5:\"Total\";s:8:\"required\";b:1;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:19:\"commerce_price_full\";s:6:\"weight\";i:1;s:8:\"settings\";a:1:{s:13:\"currency_code\";s:7:\"default\";}s:6:\"module\";s:14:\"commerce_price\";}s:7:\"display\";a:3:{s:7:\"display\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:1;s:6:\"module\";s:14:\"commerce_price\";}s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:1;s:6:\"module\";s:14:\"commerce_price\";}s:11:\"node_teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:1;s:6:\"module\";s:14:\"commerce_price\";}}s:11:\"description\";s:0:\"\";}',0),(17,12,'commerce_product','commerce_line_item','product','a:6:{s:5:\"label\";s:7:\"Product\";s:8:\"required\";b:1;s:8:\"settings\";a:3:{s:19:\"referenceable_types\";a:0:{}s:15:\"field_injection\";b:1;s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:39:\"commerce_product_reference_autocomplete\";s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:18:\"autocomplete_match\";s:8:\"contains\";s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:29:\"commerce_product/autocomplete\";}s:6:\"module\";s:26:\"commerce_product_reference\";}s:7:\"display\";a:2:{s:7:\"display\";a:5:{s:5:\"label\";s:6:\"hidden\";s:6:\"weight\";i:0;s:4:\"type\";s:30:\"commerce_cart_add_to_cart_form\";s:8:\"settings\";a:6:{s:13:\"show_quantity\";b:0;s:16:\"default_quantity\";i:1;s:7:\"combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:14:\"line_item_type\";s:7:\"product\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:13:\"commerce_cart\";}s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:30:\"commerce_cart_add_to_cart_form\";s:8:\"settings\";a:6:{s:13:\"show_quantity\";b:0;s:16:\"default_quantity\";i:1;s:7:\"combine\";b:1;s:30:\"show_single_product_attributes\";b:0;s:14:\"line_item_type\";s:7:\"product\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:13:\"commerce_cart\";s:6:\"weight\";i:2;}}s:11:\"description\";s:0:\"\";}',0),(18,13,'commerce_display_path','commerce_line_item','product','a:6:{s:5:\"label\";s:12:\"Display path\";s:8:\"required\";b:1;s:8:\"settings\";a:2:{s:15:\"text_processing\";i:0;s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:14:\"text_textfield\";s:6:\"weight\";i:0;s:8:\"settings\";a:1:{s:4:\"size\";i:60;}s:6:\"module\";s:4:\"text\";}s:7:\"display\";a:2:{s:7:\"display\";a:5:{s:5:\"label\";s:6:\"hidden\";s:6:\"weight\";i:0;s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"text\";}s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:3;}}s:11:\"description\";s:0:\"\";}',0),(19,14,'commerce_price','commerce_product','product','a:6:{s:5:\"label\";s:5:\"Price\";s:8:\"required\";b:1;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:19:\"commerce_price_full\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:1:{s:13:\"currency_code\";s:7:\"default\";}s:6:\"module\";s:14:\"commerce_price\";}s:7:\"display\";a:5:{s:4:\"full\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:21:\"calculated_sell_price\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:9:\"line_item\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:21:\"calculated_sell_price\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:26:\"commerce_line_item_display\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:21:\"calculated_sell_price\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:21:\"calculated_sell_price\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:14:\"commerce_price\";}s:11:\"node_teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:21:\"calculated_sell_price\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}}s:11:\"description\";s:0:\"\";}',0),(22,1,'comment_body','comment','comment_node_product','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";s:1:\"3\";s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(23,2,'body','node','product','a:6:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";s:1:\"3\";s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:2:{s:11:\"trim_length\";i:600;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(26,17,'field_product','node','product','a:6:{s:5:\"label\";s:7:\"Product\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"7\";s:4:\"type\";s:18:\"inline_entity_form\";s:6:\"module\";s:18:\"inline_entity_form\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:6:\"fields\";a:0:{}s:13:\"type_settings\";a:7:{s:14:\"allow_existing\";i:0;s:14:\"match_operator\";s:8:\"CONTAINS\";s:17:\"delete_references\";i:1;s:15:\"override_labels\";i:0;s:14:\"label_singular\";s:7:\"product\";s:12:\"label_plural\";s:8:\"products\";s:18:\"autogenerate_title\";i:0;}}}s:8:\"settings\";a:3:{s:15:\"field_injection\";i:1;s:19:\"referenceable_types\";a:1:{s:7:\"product\";s:7:\"product\";}s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:30:\"commerce_cart_add_to_cart_form\";s:6:\"weight\";s:2:\"30\";s:8:\"settings\";a:6:{s:13:\"show_quantity\";i:1;s:16:\"default_quantity\";s:1:\"1\";s:7:\"combine\";i:1;s:30:\"show_single_product_attributes\";i:0;s:14:\"line_item_type\";s:7:\"product\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:13:\"commerce_cart\";}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";}',0),(27,18,'field_category','node','product','a:7:{s:5:\"label\";s:8:\"Category\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"10\";s:4:\"type\";s:14:\"options_select\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:12:\"apply_chosen\";s:0:\"\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:4:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"5\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(30,21,'field_brand','node','product','a:7:{s:5:\"label\";s:5:\"Brand\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"11\";s:4:\"type\";s:14:\"options_select\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:12:\"apply_chosen\";s:0:\"\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:6:\"weight\";s:2:\"25\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:11:\"field-brand\";}s:6:\"module\";s:8:\"taxonomy\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(31,4,'field_image','bean','image_category','a:6:{s:5:\"label\";s:5:\"Image\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"12\";s:4:\"type\";s:11:\"image_image\";s:6:\"module\";s:5:\"image\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}}s:8:\"settings\";a:9:{s:14:\"file_directory\";s:10:\"categories\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";i:0;s:11:\"title_field\";i:0;s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:20:\"image_link_formatter\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:3:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:7:\"content\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:20:\"image_link_formatter\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";}',0),(32,1,'comment_body','comment','comment_node_banner','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(33,2,'body','node','banner','a:7:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:26:\"text_textarea_with_summary\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:4:\"rows\";s:1:\"5\";s:12:\"summary_rows\";i:5;}}s:8:\"settings\";a:3:{s:15:\"text_processing\";s:1:\"1\";s:15:\"display_summary\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:2:{s:11:\"trim_length\";i:600;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(34,4,'field_image','node','banner','a:6:{s:5:\"label\";s:5:\"Image\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"1\";s:4:\"type\";s:11:\"image_image\";s:6:\"module\";s:5:\"image\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}}s:8:\"settings\";a:9:{s:14:\"file_directory\";s:6:\"banner\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";i:1;s:11:\"title_field\";i:1;s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:20:\"image_link_formatter\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:3:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:10:\"field_link\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:20:\"image_link_formatter\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";}',0),(36,22,'cmp_store','commerce_product','product','a:8:{s:5:\"label\";s:5:\"Store\";s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:21:\"entityreference_label\";s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:2:{s:4:\"link\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:15:\"entityreference\";}}s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"6\";s:4:\"type\";s:14:\"options_select\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:12:\"apply_chosen\";s:0:\"\";}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:22:\"commerce_cart_settings\";a:3:{s:15:\"attribute_field\";i:0;s:16:\"attribute_widget\";s:6:\"select\";s:22:\"attribute_widget_title\";s:5:\"Store\";}s:13:\"default_value\";N;}',0),(37,23,'cmp_m_store','commerce_store','store','a:6:{s:5:\"label\";s:7:\"Members\";s:6:\"widget\";a:4:{s:4:\"type\";s:35:\"store_entityreference_hidden_widget\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_store\";}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:21:\"entityreference_label\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:4:\"link\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:15:\"entityreference\";}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(38,7,'commerce_line_items','commerce_order','commerce_store_order','a:6:{s:5:\"label\";s:10:\"Line items\";s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"commerce_line_item_manager\";s:6:\"weight\";i:-10;s:8:\"settings\";a:0:{}s:6:\"module\";s:18:\"commerce_line_item\";}s:7:\"display\";a:3:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:33:\"commerce_line_item_reference_view\";s:6:\"weight\";i:-10;s:8:\"settings\";a:2:{s:4:\"view\";s:32:\"commerce_line_item_table|default\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:18:\"commerce_line_item\";}s:8:\"customer\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:33:\"commerce_line_item_reference_view\";s:6:\"weight\";i:-10;s:8:\"settings\";a:2:{s:4:\"view\";s:32:\"commerce_line_item_table|default\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:18:\"commerce_line_item\";}s:13:\"administrator\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:33:\"commerce_line_item_reference_view\";s:6:\"weight\";i:-10;s:8:\"settings\";a:2:{s:4:\"view\";s:32:\"commerce_line_item_table|default\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:18:\"commerce_line_item\";}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(39,8,'commerce_order_total','commerce_order','commerce_store_order','a:6:{s:5:\"label\";s:11:\"Order total\";s:8:\"required\";b:1;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:19:\"commerce_price_full\";s:6:\"weight\";i:-8;s:8:\"settings\";a:1:{s:13:\"currency_code\";s:7:\"default\";}s:6:\"module\";s:14:\"commerce_price\";}s:7:\"display\";a:5:{s:13:\"administrator\";a:5:{s:4:\"type\";s:35:\"commerce_price_formatted_components\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:-8;s:6:\"module\";s:14:\"commerce_price\";}s:8:\"customer\";a:5:{s:4:\"type\";s:35:\"commerce_price_formatted_components\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:-8;s:6:\"module\";s:14:\"commerce_price\";}s:5:\"token\";a:5:{s:4:\"type\";s:35:\"commerce_price_formatted_components\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:-8;s:6:\"module\";s:14:\"commerce_price\";}s:7:\"default\";a:5:{s:4:\"type\";s:35:\"commerce_price_formatted_components\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:-8;s:6:\"module\";s:14:\"commerce_price\";}s:11:\"node_teaser\";a:5:{s:4:\"type\";s:35:\"commerce_price_formatted_components\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:-8;s:6:\"module\";s:14:\"commerce_price\";}}s:11:\"description\";s:0:\"\";}',0),(40,9,'commerce_customer_billing','commerce_order','commerce_store_order','a:6:{s:5:\"label\";s:19:\"Billing information\";s:6:\"widget\";a:4:{s:4:\"type\";s:33:\"commerce_customer_profile_manager\";s:6:\"weight\";i:-5;s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"commerce_customer\";}s:7:\"display\";a:3:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:43:\"commerce_customer_profile_reference_display\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:17:\"commerce_customer\";}s:8:\"customer\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:43:\"commerce_customer_profile_reference_display\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:17:\"commerce_customer\";}s:13:\"administrator\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:43:\"commerce_customer_profile_reference_display\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:17:\"commerce_customer\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(41,24,'commerce_customer_shipping','commerce_order','commerce_store_order','a:6:{s:5:\"label\";s:20:\"Shipping information\";s:6:\"widget\";a:4:{s:4:\"type\";s:33:\"commerce_customer_profile_manager\";s:6:\"weight\";i:-5;s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"commerce_customer\";}s:7:\"display\";a:3:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:43:\"commerce_customer_profile_reference_display\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:17:\"commerce_customer\";}s:8:\"customer\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:43:\"commerce_customer_profile_reference_display\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:17:\"commerce_customer\";}s:13:\"administrator\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:43:\"commerce_customer_profile_reference_display\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:17:\"commerce_customer\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(42,25,'cmp_o_store','commerce_order','commerce_store_order','a:6:{s:5:\"label\";s:5:\"Store\";s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:21:\"entityreference_label\";s:8:\"settings\";a:2:{s:4:\"link\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:15:\"entityreference\";s:6:\"weight\";i:-4;}}s:6:\"widget\";a:4:{s:4:\"type\";s:28:\"entityreference_autocomplete\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:4:\"path\";s:0:\"\";}s:6:\"weight\";i:-4;s:6:\"module\";s:15:\"entityreference\";}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(43,26,'cmp_order','commerce_order','commerce_store_order','a:6:{s:5:\"label\";s:14:\"Original Order\";s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:21:\"entityreference_label\";s:8:\"settings\";a:2:{s:4:\"link\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:15:\"entityreference\";s:6:\"weight\";i:-3;}}s:6:\"widget\";a:4:{s:4:\"type\";s:28:\"entityreference_autocomplete\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:4:\"path\";s:0:\"\";}s:6:\"weight\";i:-3;s:6:\"module\";s:15:\"entityreference\";}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(44,7,'commerce_line_items','commerce_order','commerce_marketplace_order','a:6:{s:5:\"label\";s:10:\"Line items\";s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"commerce_line_item_manager\";s:6:\"weight\";i:-10;s:8:\"settings\";a:0:{}s:6:\"module\";s:18:\"commerce_line_item\";}s:7:\"display\";a:3:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:33:\"commerce_line_item_reference_view\";s:6:\"weight\";i:-10;s:8:\"settings\";a:2:{s:4:\"view\";s:32:\"commerce_line_item_table|default\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:18:\"commerce_line_item\";}s:8:\"customer\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:33:\"commerce_line_item_reference_view\";s:6:\"weight\";i:-10;s:8:\"settings\";a:2:{s:4:\"view\";s:32:\"commerce_line_item_table|default\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:18:\"commerce_line_item\";}s:13:\"administrator\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:33:\"commerce_line_item_reference_view\";s:6:\"weight\";i:-10;s:8:\"settings\";a:2:{s:4:\"view\";s:32:\"commerce_line_item_table|default\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:18:\"commerce_line_item\";}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(45,8,'commerce_order_total','commerce_order','commerce_marketplace_order','a:6:{s:5:\"label\";s:11:\"Order total\";s:8:\"required\";b:1;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:19:\"commerce_price_full\";s:6:\"weight\";i:-8;s:8:\"settings\";a:1:{s:13:\"currency_code\";s:7:\"default\";}s:6:\"module\";s:14:\"commerce_price\";}s:7:\"display\";a:5:{s:13:\"administrator\";a:5:{s:4:\"type\";s:35:\"commerce_price_formatted_components\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:-8;s:6:\"module\";s:14:\"commerce_price\";}s:8:\"customer\";a:5:{s:4:\"type\";s:35:\"commerce_price_formatted_components\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:-8;s:6:\"module\";s:14:\"commerce_price\";}s:5:\"token\";a:5:{s:4:\"type\";s:35:\"commerce_price_formatted_components\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:-8;s:6:\"module\";s:14:\"commerce_price\";}s:7:\"default\";a:5:{s:4:\"type\";s:35:\"commerce_price_formatted_components\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:-8;s:6:\"module\";s:14:\"commerce_price\";}s:11:\"node_teaser\";a:5:{s:4:\"type\";s:35:\"commerce_price_formatted_components\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:-8;s:6:\"module\";s:14:\"commerce_price\";}}s:11:\"description\";s:0:\"\";}',0),(46,9,'commerce_customer_billing','commerce_order','commerce_marketplace_order','a:6:{s:5:\"label\";s:19:\"Billing information\";s:6:\"widget\";a:4:{s:4:\"type\";s:33:\"commerce_customer_profile_manager\";s:6:\"weight\";i:-5;s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"commerce_customer\";}s:7:\"display\";a:3:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:43:\"commerce_customer_profile_reference_display\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:17:\"commerce_customer\";}s:8:\"customer\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:43:\"commerce_customer_profile_reference_display\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:17:\"commerce_customer\";}s:13:\"administrator\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:43:\"commerce_customer_profile_reference_display\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:17:\"commerce_customer\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(47,24,'commerce_customer_shipping','commerce_order','commerce_marketplace_order','a:6:{s:5:\"label\";s:20:\"Shipping information\";s:6:\"widget\";a:4:{s:4:\"type\";s:33:\"commerce_customer_profile_manager\";s:6:\"weight\";i:-5;s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"commerce_customer\";}s:7:\"display\";a:3:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:43:\"commerce_customer_profile_reference_display\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:17:\"commerce_customer\";}s:8:\"customer\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:43:\"commerce_customer_profile_reference_display\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:17:\"commerce_customer\";}s:13:\"administrator\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:43:\"commerce_customer_profile_reference_display\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:17:\"commerce_customer\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(48,6,'commerce_customer_address','commerce_customer_profile','shipping','a:6:{s:5:\"label\";s:7:\"Address\";s:8:\"required\";b:1;s:6:\"widget\";a:4:{s:4:\"type\";s:21:\"addressfield_standard\";s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:15:\"format_handlers\";a:2:{i:0;s:7:\"address\";i:1;s:12:\"name-oneline\";}s:19:\"available_countries\";a:0:{}s:15:\"default_country\";s:0:\"\";}s:6:\"module\";s:12:\"addressfield\";}s:7:\"display\";a:3:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:20:\"addressfield_default\";s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:19:\"use_widget_handlers\";i:1;s:15:\"format_handlers\";a:1:{i:0;s:7:\"address\";}s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:12:\"addressfield\";}s:8:\"customer\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:20:\"addressfield_default\";s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:19:\"use_widget_handlers\";i:1;s:15:\"format_handlers\";a:1:{i:0;s:7:\"address\";}s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:12:\"addressfield\";}s:13:\"administrator\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:20:\"addressfield_default\";s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:19:\"use_widget_handlers\";i:1;s:15:\"format_handlers\";a:1:{i:0;s:7:\"address\";}s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:12:\"addressfield\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:11:\"description\";s:0:\"\";}',0),(49,27,'cmp_line_item','commerce_line_item','product','a:6:{s:5:\"label\";s:18:\"Original line item\";s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:21:\"entityreference_label\";s:8:\"settings\";a:2:{s:4:\"link\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:15:\"entityreference\";s:6:\"weight\";i:4;}}s:6:\"widget\";a:4:{s:4:\"type\";s:28:\"entityreference_autocomplete\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:4:\"path\";s:0:\"\";}s:6:\"weight\";i:2;s:6:\"module\";s:15:\"entityreference\";}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(50,27,'cmp_line_item','commerce_line_item','shipping','a:6:{s:5:\"label\";s:18:\"Original line item\";s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:21:\"entityreference_label\";s:8:\"settings\";a:2:{s:4:\"link\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:15:\"entityreference\";s:6:\"weight\";i:0;}}s:6:\"widget\";a:4:{s:4:\"type\";s:28:\"entityreference_autocomplete\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:4:\"path\";s:0:\"\";}s:6:\"weight\";i:-4;s:6:\"module\";s:15:\"entityreference\";}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(51,10,'commerce_unit_price','commerce_line_item','shipping','a:6:{s:5:\"label\";s:10:\"Unit price\";s:8:\"required\";b:1;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:19:\"commerce_price_full\";s:6:\"weight\";i:0;s:8:\"settings\";a:1:{s:13:\"currency_code\";s:7:\"default\";}s:6:\"module\";s:14:\"commerce_price\";}s:7:\"display\";a:4:{s:7:\"display\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:5:\"token\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:11:\"node_teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}}s:11:\"description\";s:0:\"\";}',0),(52,11,'commerce_total','commerce_line_item','shipping','a:6:{s:5:\"label\";s:5:\"Total\";s:8:\"required\";b:1;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:19:\"commerce_price_full\";s:6:\"weight\";i:1;s:8:\"settings\";a:1:{s:13:\"currency_code\";s:7:\"default\";}s:6:\"module\";s:14:\"commerce_price\";}s:7:\"display\";a:4:{s:7:\"display\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:1;s:6:\"module\";s:14:\"commerce_price\";}s:5:\"token\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:1;s:6:\"module\";s:14:\"commerce_price\";}s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:1;s:6:\"module\";s:14:\"commerce_price\";}s:11:\"node_teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:1;s:6:\"module\";s:14:\"commerce_price\";}}s:11:\"description\";s:0:\"\";}',0),(53,28,'commerce_shipping_service','commerce_line_item','shipping','a:6:{s:5:\"label\";s:16:\"Shipping service\";s:8:\"required\";b:1;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:14:\"options_select\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:7:\"options\";}s:7:\"display\";a:2:{s:7:\"display\";a:5:{s:5:\"label\";s:6:\"hidden\";s:6:\"weight\";i:0;s:4:\"type\";s:12:\"list_default\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"list\";}s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"list_default\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"list\";s:6:\"weight\";i:2;}}s:11:\"description\";s:0:\"\";}',0),(54,24,'commerce_customer_shipping','commerce_order','commerce_order','a:6:{s:5:\"label\";s:20:\"Shipping information\";s:6:\"widget\";a:4:{s:4:\"type\";s:33:\"commerce_customer_profile_manager\";s:6:\"weight\";i:-5;s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"commerce_customer\";}s:7:\"display\";a:3:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:43:\"commerce_customer_profile_reference_display\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:17:\"commerce_customer\";}s:8:\"customer\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:43:\"commerce_customer_profile_reference_display\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:17:\"commerce_customer\";}s:13:\"administrator\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:43:\"commerce_customer_profile_reference_display\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:17:\"commerce_customer\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(59,33,'field_summary','node','product','a:7:{s:5:\"label\";s:7:\"Summary\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:13:\"text_textarea\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"rows\";s:1:\"5\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"1\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"33\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(61,35,'field_specifications','node','product','a:7:{s:5:\"label\";s:14:\"Specifications\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"8\";s:4:\"type\";s:22:\"field_collection_embed\";s:6:\"module\";s:16:\"field_collection\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:27:\"field_collection_table_view\";s:6:\"weight\";s:2:\"23\";s:8:\"settings\";a:7:{s:4:\"edit\";s:4:\"Edit\";s:6:\"delete\";s:6:\"Delete\";s:3:\"add\";s:3:\"Add\";s:11:\"description\";i:0;s:9:\"view_mode\";s:4:\"full\";s:5:\"empty\";i:1;s:21:\"field_formatter_class\";s:20:\"field-specifications\";}s:6:\"module\";s:22:\"field_collection_table\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(62,36,'field_colllect_title','field_collection_item','field_specifications','a:7:{s:5:\"label\";s:5:\"Title\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"1\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(64,38,'field_review','node','product','a:7:{s:5:\"label\";s:6:\"Review\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"14\";s:4:\"type\";s:7:\"exposed\";s:6:\"module\";s:8:\"fivestar\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:6:\"widget\";a:1:{s:15:\"fivestar_widget\";s:7:\"default\";}}}s:8:\"settings\";a:6:{s:5:\"stars\";s:1:\"5\";s:11:\"allow_clear\";i:0;s:12:\"allow_revote\";i:0;s:13:\"allow_ownvote\";i:0;s:6:\"target\";s:4:\"none\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:26:\"fivestar_formatter_default\";s:6:\"weight\";s:2:\"26\";s:8:\"settings\";a:5:{s:6:\"widget\";a:1:{s:15:\"fivestar_widget\";s:7:\"default\";}s:5:\"style\";s:7:\"average\";s:4:\"text\";s:7:\"average\";s:21:\"field_formatter_class\";s:0:\"\";s:6:\"expose\";b:1;}s:6:\"module\";s:8:\"fivestar\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(65,38,'field_review','comment','comment_node_product','a:7:{s:5:\"label\";s:6:\"Review\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:5:\"stars\";s:6:\"module\";s:8:\"fivestar\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:6:\"widget\";a:1:{s:15:\"fivestar_widget\";s:7:\"default\";}}}s:8:\"settings\";a:6:{s:5:\"stars\";s:1:\"5\";s:11:\"allow_clear\";i:0;s:12:\"allow_revote\";i:0;s:13:\"allow_ownvote\";i:0;s:6:\"target\";s:11:\"parent_node\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:26:\"fivestar_formatter_default\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:5:{s:6:\"widget\";a:1:{s:15:\"fivestar_widget\";s:7:\"default\";}s:5:\"style\";s:4:\"user\";s:4:\"text\";s:4:\"user\";s:21:\"field_formatter_class\";s:0:\"\";s:6:\"expose\";b:1;}s:6:\"module\";s:8:\"fivestar\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(66,39,'field_product_image','commerce_product','product','a:6:{s:5:\"label\";s:5:\"Image\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:11:\"image_image\";s:6:\"module\";s:5:\"image\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}}s:8:\"settings\";a:9:{s:14:\"file_directory\";s:8:\"products\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";i:1;s:11:\"title_field\";i:1;s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:10:\"cloud_zoom\";s:6:\"weight\";s:1:\"5\";s:8:\"settings\";a:6:{s:11:\"slide_style\";s:5:\"large\";s:10:\"zoom_style\";s:1:\"0\";s:16:\"gallery_filedset\";a:2:{s:12:\"gallery_mode\";i:1;s:11:\"thumb_style\";s:9:\"thumbnail\";}s:22:\"zoom_position_fieldset\";a:5:{s:10:\"zoom_width\";s:4:\"auto\";s:11:\"zoom_height\";s:4:\"auto\";s:8:\"position\";s:5:\"right\";s:8:\"adjust_x\";s:1:\"0\";s:8:\"adjust_y\";s:1:\"0\";}s:19:\"zoom_style_fieldset\";a:7:{s:4:\"tint\";s:5:\"false\";s:12:\"tint_opacity\";s:3:\"0.5\";s:12:\"lens_opacity\";s:3:\"0.5\";s:10:\"soft_focus\";i:0;s:11:\"smooth_move\";s:1:\"3\";s:10:\"Show title\";i:0;s:13:\"title_opacity\";s:3:\"0.5\";}s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:10:\"cloud_zoom\";}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";}',0),(68,41,'field_slide','node','banner','a:7:{s:5:\"label\";s:5:\"Slide\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:13:\"options_onoff\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:13:\"display_label\";i:0;}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:4:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:0;s:11:\"description\";s:12:\"Set as slide\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}}',0),(69,15,'field_link','node','banner','a:7:{s:5:\"label\";s:4:\"Link\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"6\";s:4:\"type\";s:10:\"link_field\";s:6:\"module\";s:4:\"link\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:12:{s:12:\"absolute_url\";i:1;s:12:\"validate_url\";i:1;s:3:\"url\";i:0;s:5:\"title\";s:8:\"optional\";s:11:\"title_value\";s:0:\"\";s:27:\"title_label_use_field_label\";i:0;s:15:\"title_maxlength\";s:3:\"128\";s:13:\"enable_tokens\";i:1;s:7:\"display\";a:1:{s:10:\"url_cutoff\";s:2:\"80\";}s:10:\"attributes\";a:6:{s:6:\"target\";s:7:\"default\";s:3:\"rel\";s:0:\"\";s:18:\"configurable_class\";i:0;s:5:\"class\";s:0:\"\";s:18:\"configurable_title\";i:0;s:5:\"title\";s:0:\"\";}s:10:\"rel_remove\";s:7:\"default\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"link_default\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"link\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(70,15,'field_link','bean','image_category','a:7:{s:5:\"label\";s:4:\"Link\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"14\";s:4:\"type\";s:10:\"link_field\";s:6:\"module\";s:4:\"link\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:12:{s:12:\"absolute_url\";i:1;s:12:\"validate_url\";i:1;s:3:\"url\";i:0;s:5:\"title\";s:8:\"optional\";s:11:\"title_value\";s:0:\"\";s:27:\"title_label_use_field_label\";i:0;s:15:\"title_maxlength\";s:3:\"128\";s:13:\"enable_tokens\";i:1;s:7:\"display\";a:1:{s:10:\"url_cutoff\";s:2:\"80\";}s:10:\"attributes\";a:6:{s:6:\"target\";s:7:\"default\";s:3:\"rel\";s:0:\"\";s:18:\"configurable_class\";i:0;s:5:\"class\";s:0:\"\";s:18:\"configurable_title\";i:0;s:5:\"title\";s:0:\"\";}s:10:\"rel_remove\";s:7:\"default\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:4:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(71,42,'field_bean_icon','bean','about','a:7:{s:5:\"label\";s:4:\"Icon\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:10:\"icon_field\";s:6:\"module\";s:10:\"icon_field\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:3:{s:6:\"bundle\";N;s:4:\"icon\";N;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:18:\"icon_field_default\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:2:{s:15:\"link_to_content\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:10:\"icon_field\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(72,43,'field_body','bean','about','a:7:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:26:\"text_textarea_with_summary\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:4:\"rows\";s:2:\"20\";s:12:\"summary_rows\";i:5;}}s:8:\"settings\";a:3:{s:15:\"text_processing\";s:1:\"1\";s:15:\"display_summary\";i:0;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(73,4,'field_image','bean','about','a:6:{s:5:\"label\";s:5:\"Image\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:11:\"image_image\";s:6:\"module\";s:5:\"image\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}}s:8:\"settings\";a:9:{s:14:\"file_directory\";s:10:\"field/bean\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";i:1;s:11:\"title_field\";i:1;s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:3:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:5:\"image\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";}',0),(74,44,'field_boolean','node','product','a:7:{s:5:\"label\";s:4:\"Deal\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"13\";s:4:\"type\";s:13:\"options_onoff\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:13:\"display_label\";i:0;}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}}',0),(75,4,'field_image','taxonomy_term','brands','a:6:{s:5:\"label\";s:5:\"Image\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"1\";s:4:\"type\";s:11:\"image_image\";s:6:\"module\";s:5:\"image\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}}s:8:\"settings\";a:9:{s:14:\"file_directory\";s:11:\"field/brand\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";i:1;s:11:\"title_field\";i:1;s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:3:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:5:\"image\";s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";}',0),(76,2,'body','node','webform','a:7:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"1\";s:4:\"type\";s:26:\"text_textarea_with_summary\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:4:\"rows\";s:2:\"10\";s:12:\"summary_rows\";i:5;}}s:8:\"settings\";a:3:{s:15:\"text_processing\";s:1:\"1\";s:15:\"display_summary\";i:0;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(77,45,'field_map','node','webform','a:7:{s:5:\"label\";s:3:\"Map\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:13:\"text_textarea\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"rows\";s:1:\"5\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"1\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(78,46,'commerce_stock','commerce_product','product','a:7:{s:5:\"label\";s:5:\"Stock\";s:8:\"required\";b:1;s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:25:\"select_or_other_formatter\";s:6:\"weight\";s:1:\"7\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:13:\"product-stock\";}s:6:\"module\";s:15:\"select_or_other\";}}s:11:\"description\";N;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:6:\"number\";s:8:\"settings\";a:0:{}s:6:\"weight\";s:1:\"8\";s:6:\"module\";s:6:\"number\";}}',0),(79,47,'title_field','node','product','a:6:{s:5:\"label\";s:5:\"Title\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:1;s:8:\"settings\";a:3:{s:15:\"text_processing\";i:0;s:10:\"hide_label\";a:2:{s:4:\"page\";b:0;s:6:\"entity\";b:0;}s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:6:\"weight\";i:-5;s:4:\"type\";s:14:\"text_textfield\";s:8:\"settings\";a:1:{s:4:\"size\";i:60;}s:6:\"module\";s:4:\"text\";}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"title_linked\";s:6:\"weight\";s:2:\"24\";s:8:\"settings\";a:4:{s:11:\"title_style\";s:2:\"h1\";s:10:\"title_link\";s:0:\"\";s:11:\"title_class\";s:0:\"\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:5:\"title\";}}}',0),(80,48,'field_old_price','commerce_product','product','a:7:{s:5:\"label\";s:9:\"Old Price\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:19:\"commerce_price_full\";s:6:\"module\";s:14:\"commerce_price\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:13:\"currency_code\";s:7:\"default\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:14:\"commerce_price\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}}}',0),(81,49,'field_description','field_collection_item','field_specifications','a:7:{s:5:\"label\";s:11:\"Description\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:13:\"text_textarea\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"rows\";s:1:\"5\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"1\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:1;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(82,50,'field_color','taxonomy_term','color','a:7:{s:5:\"label\";s:5:\"Color\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"1\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:16:\"add_to_cart_form\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_fancy_attributes_color\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:25:\"commerce_fancy_attributes\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(83,51,'field_product_color','commerce_product','product','a:8:{s:5:\"label\";s:5:\"Color\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"5\";s:4:\"type\";s:14:\"options_select\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:12:\"apply_chosen\";s:0:\"\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:6:\"weight\";s:1:\"8\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:8:\"taxonomy\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:22:\"commerce_cart_settings\";a:3:{s:15:\"attribute_field\";i:1;s:16:\"attribute_widget\";s:25:\"commerce_fancy_attributes\";s:22:\"attribute_widget_title\";s:6:\"Color:\";}s:13:\"default_value\";a:1:{i:0;a:1:{s:3:\"tid\";s:3:\"104\";}}}',0),(84,52,'balance','cmp_funds_account','commerce_store','a:6:{s:5:\"label\";s:7:\"Balance\";s:6:\"widget\";a:4:{s:4:\"type\";s:19:\"commerce_price_full\";s:8:\"settings\";a:1:{s:13:\"currency_code\";s:7:\"default\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:7:\"display\";a:2:{s:4:\"full\";a:5:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:14:\"commerce_price\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:6:\"weight\";i:1;}s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:14:\"commerce_price\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:6:\"weight\";i:1;}}s:8:\"required\";b:1;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:11:\"description\";s:0:\"\";}',0),(85,52,'balance','cmp_funds_account','user','a:6:{s:5:\"label\";s:7:\"Balance\";s:6:\"widget\";a:4:{s:4:\"type\";s:19:\"commerce_price_full\";s:8:\"settings\";a:1:{s:13:\"currency_code\";s:7:\"default\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:7:\"display\";a:2:{s:4:\"full\";a:5:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:14:\"commerce_price\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:6:\"weight\";i:1;}s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:14:\"commerce_price\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:6:\"weight\";i:1;}}s:8:\"required\";b:1;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:11:\"description\";s:0:\"\";}',0),(86,53,'amount','cmp_funds_transaction','deposit','a:6:{s:5:\"label\";s:6:\"Amount\";s:6:\"widget\";a:4:{s:4:\"type\";s:19:\"commerce_price_full\";s:8:\"settings\";a:1:{s:13:\"currency_code\";s:7:\"default\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:7:\"display\";a:2:{s:4:\"full\";a:5:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:1;s:6:\"module\";s:14:\"commerce_price\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";}s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:14:\"commerce_price\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:6:\"weight\";i:1;}}s:8:\"required\";b:1;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:11:\"description\";s:0:\"\";}',0),(87,54,'notes','cmp_funds_transaction','deposit','a:6:{s:7:\"display\";a:2:{s:4:\"full\";a:5:{s:5:\"label\";s:5:\"above\";s:6:\"module\";s:4:\"text\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;}s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:6:\"module\";s:4:\"text\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;}}s:5:\"label\";s:5:\"Notes\";s:8:\"required\";b:0;s:8:\"settings\";a:2:{s:15:\"text_processing\";i:0;s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:4:\"type\";s:13:\"text_textarea\";s:6:\"weight\";i:1;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(88,53,'amount','cmp_funds_transaction','transfer','a:6:{s:5:\"label\";s:6:\"Amount\";s:6:\"widget\";a:4:{s:4:\"type\";s:19:\"commerce_price_full\";s:8:\"settings\";a:1:{s:13:\"currency_code\";s:7:\"default\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:7:\"display\";a:2:{s:4:\"full\";a:5:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:1;s:6:\"module\";s:14:\"commerce_price\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";}s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:14:\"commerce_price\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:6:\"weight\";i:1;}}s:8:\"required\";b:1;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:11:\"description\";s:0:\"\";}',0),(89,54,'notes','cmp_funds_transaction','transfer','a:6:{s:7:\"display\";a:2:{s:4:\"full\";a:5:{s:5:\"label\";s:5:\"above\";s:6:\"module\";s:4:\"text\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;}s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:6:\"module\";s:4:\"text\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;}}s:5:\"label\";s:5:\"Notes\";s:8:\"required\";b:0;s:8:\"settings\";a:2:{s:15:\"text_processing\";i:0;s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:4:\"type\";s:13:\"text_textarea\";s:6:\"weight\";i:1;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(90,53,'amount','cmp_funds_transaction','payment','a:6:{s:5:\"label\";s:6:\"Amount\";s:6:\"widget\";a:4:{s:4:\"type\";s:19:\"commerce_price_full\";s:8:\"settings\";a:1:{s:13:\"currency_code\";s:7:\"default\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:7:\"display\";a:2:{s:4:\"full\";a:5:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:1;s:6:\"module\";s:14:\"commerce_price\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";}s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:14:\"commerce_price\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:6:\"weight\";i:1;}}s:8:\"required\";b:1;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:11:\"description\";s:0:\"\";}',0),(91,54,'notes','cmp_funds_transaction','payment','a:6:{s:7:\"display\";a:2:{s:4:\"full\";a:5:{s:5:\"label\";s:5:\"above\";s:6:\"module\";s:4:\"text\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;}s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:6:\"module\";s:4:\"text\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;}}s:5:\"label\";s:5:\"Notes\";s:8:\"required\";b:0;s:8:\"settings\";a:2:{s:15:\"text_processing\";i:0;s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:4:\"type\";s:13:\"text_textarea\";s:6:\"weight\";i:1;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(92,7,'commerce_line_items','commerce_order','cmp_funds_deposit_order','a:6:{s:5:\"label\";s:10:\"Line items\";s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"commerce_line_item_manager\";s:6:\"weight\";i:-10;s:8:\"settings\";a:0:{}s:6:\"module\";s:18:\"commerce_line_item\";}s:7:\"display\";a:3:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:33:\"commerce_line_item_reference_view\";s:6:\"weight\";i:-10;s:8:\"settings\";a:2:{s:4:\"view\";s:32:\"commerce_line_item_table|default\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:18:\"commerce_line_item\";}s:8:\"customer\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:33:\"commerce_line_item_reference_view\";s:6:\"weight\";i:-10;s:8:\"settings\";a:2:{s:4:\"view\";s:32:\"commerce_line_item_table|default\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:18:\"commerce_line_item\";}s:13:\"administrator\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:33:\"commerce_line_item_reference_view\";s:6:\"weight\";i:-10;s:8:\"settings\";a:2:{s:4:\"view\";s:32:\"commerce_line_item_table|default\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:18:\"commerce_line_item\";}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(93,8,'commerce_order_total','commerce_order','cmp_funds_deposit_order','a:6:{s:5:\"label\";s:11:\"Order total\";s:8:\"required\";b:1;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:19:\"commerce_price_full\";s:6:\"weight\";i:-8;s:8:\"settings\";a:1:{s:13:\"currency_code\";s:7:\"default\";}s:6:\"module\";s:14:\"commerce_price\";}s:7:\"display\";a:5:{s:13:\"administrator\";a:5:{s:4:\"type\";s:35:\"commerce_price_formatted_components\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:-8;s:6:\"module\";s:14:\"commerce_price\";}s:8:\"customer\";a:5:{s:4:\"type\";s:35:\"commerce_price_formatted_components\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:-8;s:6:\"module\";s:14:\"commerce_price\";}s:5:\"token\";a:5:{s:4:\"type\";s:35:\"commerce_price_formatted_components\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:-8;s:6:\"module\";s:14:\"commerce_price\";}s:7:\"default\";a:5:{s:4:\"type\";s:35:\"commerce_price_formatted_components\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:-8;s:6:\"module\";s:14:\"commerce_price\";}s:11:\"node_teaser\";a:5:{s:4:\"type\";s:35:\"commerce_price_formatted_components\";s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:-8;s:6:\"module\";s:14:\"commerce_price\";}}s:11:\"description\";s:0:\"\";}',0),(94,9,'commerce_customer_billing','commerce_order','cmp_funds_deposit_order','a:6:{s:5:\"label\";s:19:\"Billing information\";s:6:\"widget\";a:4:{s:4:\"type\";s:33:\"commerce_customer_profile_manager\";s:6:\"weight\";i:-5;s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"commerce_customer\";}s:7:\"display\";a:3:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:43:\"commerce_customer_profile_reference_display\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:17:\"commerce_customer\";}s:8:\"customer\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:43:\"commerce_customer_profile_reference_display\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:17:\"commerce_customer\";}s:13:\"administrator\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:43:\"commerce_customer_profile_reference_display\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:17:\"commerce_customer\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(95,24,'commerce_customer_shipping','commerce_order','cmp_funds_deposit_order','a:6:{s:5:\"label\";s:20:\"Shipping information\";s:6:\"widget\";a:4:{s:4:\"type\";s:33:\"commerce_customer_profile_manager\";s:6:\"weight\";i:-5;s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"commerce_customer\";}s:7:\"display\";a:3:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:43:\"commerce_customer_profile_reference_display\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:17:\"commerce_customer\";}s:8:\"customer\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:43:\"commerce_customer_profile_reference_display\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:17:\"commerce_customer\";}s:13:\"administrator\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:43:\"commerce_customer_profile_reference_display\";s:6:\"weight\";i:-5;s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:17:\"commerce_customer\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(96,14,'commerce_price','commerce_product','deposit','a:6:{s:5:\"label\";s:5:\"Price\";s:8:\"required\";b:1;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:19:\"commerce_price_full\";s:6:\"weight\";i:0;s:8:\"settings\";a:1:{s:13:\"currency_code\";s:7:\"default\";}s:6:\"module\";s:14:\"commerce_price\";}s:7:\"display\";a:15:{s:4:\"full\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:21:\"calculated_sell_price\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:5:\"token\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:21:\"calculated_sell_price\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:9:\"line_item\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:21:\"calculated_sell_price\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:26:\"commerce_line_item_display\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:21:\"calculated_sell_price\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:24:\"commerce_line_item_token\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:21:\"calculated_sell_price\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:9:\"node_full\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:21:\"calculated_sell_price\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:11:\"node_teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:21:\"calculated_sell_price\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:8:\"node_rss\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:21:\"calculated_sell_price\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:17:\"node_search_index\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:21:\"calculated_sell_price\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:18:\"node_search_result\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:21:\"calculated_sell_price\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:16:\"node_email_plain\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:21:\"calculated_sell_price\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:15:\"node_email_html\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:21:\"calculated_sell_price\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:18:\"node_email_textalt\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:21:\"calculated_sell_price\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:10:\"node_token\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:21:\"calculated_sell_price\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:21:\"calculated_sell_price\";s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}}s:11:\"description\";s:0:\"\";}',0),(97,53,'amount','cmp_funds_transaction','withdraw','a:6:{s:5:\"label\";s:6:\"Amount\";s:6:\"widget\";a:4:{s:4:\"type\";s:19:\"commerce_price_full\";s:8:\"settings\";a:1:{s:13:\"currency_code\";s:7:\"default\";}s:6:\"weight\";i:0;s:6:\"module\";s:14:\"commerce_price\";}s:7:\"display\";a:2:{s:4:\"full\";a:5:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"weight\";i:1;s:6:\"module\";s:14:\"commerce_price\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";}s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:14:\"commerce_price\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:6:\"weight\";i:1;}}s:8:\"required\";b:1;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:11:\"description\";s:0:\"\";}',0),(98,54,'notes','cmp_funds_transaction','withdraw','a:6:{s:7:\"display\";a:2:{s:4:\"full\";a:5:{s:5:\"label\";s:5:\"above\";s:6:\"module\";s:4:\"text\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;}s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:6:\"module\";s:4:\"text\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;}}s:5:\"label\";s:5:\"Notes\";s:8:\"required\";b:0;s:8:\"settings\";a:2:{s:15:\"text_processing\";i:0;s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:4:\"type\";s:13:\"text_textarea\";s:6:\"weight\";i:1;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(99,55,'withdraw_method','cmp_funds_transaction','withdraw','a:6:{s:5:\"label\";s:15:\"Withdraw method\";s:8:\"required\";b:1;s:6:\"widget\";a:4:{s:4:\"type\";s:14:\"options_select\";s:8:\"settings\";a:1:{s:12:\"apply_chosen\";s:0:\"\";}s:6:\"weight\";i:2;s:6:\"module\";s:7:\"options\";}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:21:\"entityreference_label\";s:8:\"settings\";a:2:{s:4:\"link\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:15:\"entityreference\";s:6:\"weight\";i:2;}}s:11:\"description\";s:0:\"\";}',0),(100,56,'field_withdraw_name','cmp_funds_withdraw_method','paypal','a:7:{s:5:\"label\";s:4:\"Name\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"1\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(101,57,'field_paypal_email','cmp_funds_withdraw_method','paypal','a:6:{s:5:\"label\";s:12:\"Paypal Email\";s:6:\"widget\";a:4:{s:4:\"type\";s:14:\"text_textfield\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:1:{s:4:\"size\";i:60;}s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:2:{s:15:\"text_processing\";i:0;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:1;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(103,59,'field_discount_percentage','commerce_product','product','a:7:{s:5:\"label\";s:19:\"Discount Percentage\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"9\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:2:\"- \";s:6:\"suffix\";s:1:\"%\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:14:\"number_decimal\";s:6:\"weight\";s:1:\"9\";s:8:\"settings\";a:5:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\",\";s:5:\"scale\";s:1:\"0\";s:13:\"prefix_suffix\";i:1;s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:6:\"number\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}}',0),(104,18,'field_category','node','banner','a:7:{s:5:\"label\";s:8:\"Category\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:14:\"options_select\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:12:\"apply_chosen\";s:0:\"\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:8:\"taxonomy\";s:6:\"weight\";i:4;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(105,21,'field_brand','node','banner','a:7:{s:5:\"label\";s:5:\"Brand\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"5\";s:4:\"type\";s:14:\"options_select\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:12:\"apply_chosen\";s:0:\"\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:6:\"module\";s:8:\"taxonomy\";s:6:\"weight\";i:5;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0);
/*!40000 ALTER TABLE `field_config_instance` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_amount`
--

DROP TABLE IF EXISTS `field_data_amount`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_amount` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `amount_amount` int(11) NOT NULL DEFAULT '0' COMMENT 'The price amount.',
  `amount_currency_code` varchar(32) NOT NULL COMMENT 'The currency code for the price.',
  `amount_data` longtext COMMENT 'A serialized array of additional price data.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `amount_currency_price` (`amount_amount`,`amount_currency_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 53 (amount)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_amount`
--

LOCK TABLES `field_data_amount` WRITE;
/*!40000 ALTER TABLE `field_data_amount` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `field_data_amount` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_balance`
--

DROP TABLE IF EXISTS `field_data_balance`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_balance` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `balance_amount` int(11) NOT NULL DEFAULT '0' COMMENT 'The price amount.',
  `balance_currency_code` varchar(32) NOT NULL COMMENT 'The currency code for the price.',
  `balance_data` longtext COMMENT 'A serialized array of additional price data.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `balance_currency_price` (`balance_amount`,`balance_currency_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 52 (balance)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_balance`
--

LOCK TABLES `field_data_balance` WRITE;
/*!40000 ALTER TABLE `field_data_balance` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_balance` VALUES ('cmp_funds_account','user',0,1,1,'und',0,0,'USD',NULL),('cmp_funds_account','commerce_store',0,2,2,'und',0,0,'USD',NULL),('cmp_funds_account','commerce_store',0,3,3,'und',0,0,'USD',NULL),('cmp_funds_account','user',0,4,4,'und',0,0,'USD',NULL),('cmp_funds_account','user',0,5,5,'und',0,0,'USD',NULL),('cmp_funds_account','user',0,6,6,'und',0,0,'USD',NULL),('cmp_funds_account','commerce_store',0,7,7,'und',0,0,'USD',NULL),('cmp_funds_account','user',0,8,8,'und',0,0,'USD',NULL);
/*!40000 ALTER TABLE `field_data_balance` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_body`
--

DROP TABLE IF EXISTS `field_data_body`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_body` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `body_value` longtext,
  `body_summary` longtext,
  `body_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `body_format` (`body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 2 (body)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_body`
--

LOCK TABLES `field_data_body` WRITE;
/*!40000 ALTER TABLE `field_data_body` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_body` VALUES ('node','banner',0,7,7,'und',0,'<p>Praesent nonummy mi in odio. Vestibulum dapibus nunc ac augue. Suspendisse enim turpis, dictum sed, iaculis a, condimentum nec, nisi. Sed fringilla mauris sit amet nibh. Aliquam lorem ante, dapibus in, viverra quis, feugiat a, tellus. Aenean viverra rhoncus pede. Pellentesque libero tortor, tincidunt et, tincidunt eget, semper nec, quam. Curabitur suscipit suscipit tellus. Cras id dui. Aenean commodo ligula eget dolor. Curabitur blandit mollis lacus. Quisque malesuada placerat nisl. Fusce vulputate eleifend sapien. Sed hendrerit. Maecenas malesuada. Aliquam lobortis. Phasellus accumsan cursus velit. Sed hendrerit. Suspendisse eu ligula. Donec vitae sapien ut libero venenatis faucibus. Mauris turpis nunc, blandit et, volutpat molestie, porta ut, ligula. Sed fringilla mauris sit amet nibh. Quisque rutrum. Donec vitae sapien ut libero venenatis faucibus. Suspendisse potenti.</p>\r\n','','filtered_html'),('node','banner',0,8,8,'und',0,'<p>Ut id nisl quis enim dignissim sagittis. Cras sagittis. Nam quam nunc, blandit vel, luctus pulvinar, hendrerit id, lorem. Nullam nulla eros, ultricies sit amet, nonummy id, imperdiet feugiat, pede. Phasellus dolor. Nunc egestas, augue at pellentesque laoreet, felis eros vehicula leo, at malesuada velit leo quis pede. Sed a libero. Ut varius tincidunt libero. Suspendisse faucibus, nunc et pellentesque egestas, lacus ante convallis tellus, vitae iaculis lacus elit id tortor. Cras ultricies mi eu turpis hendrerit fringilla. Suspendisse potenti. Phasellus magna. Vestibulum fringilla pede sit amet augue. Nam eget dui. Phasellus dolor. Fusce neque. Nunc interdum lacus sit amet orci. Mauris turpis nunc, blandit et, volutpat molestie, porta ut, ligula. Sed aliquam ultrices mauris. Sed mollis, eros et ultrices tempus, mauris ipsum aliquam libero, non adipiscing dolor urna a orci. Etiam ultricies nisi vel augue. Praesent nec nisl a purus blandit viverra. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Praesent ut ligula non mi varius sagittis. Fusce commodo aliquam arcu.</p>\r\n','','filtered_html'),('node','page',0,16,16,'und',0,'<div class=\"block-payment\">\r\n	<div class=\"row\">\r\n		<div class=\"col-sm-9 field-body-topic\">\r\n			<p>Read about the variety of payment options offered on the Apple Online Store, and how the tax on your order is calculated. Also, get more information about special pricing, offers, promotions, and other great deals with limited time availability.</p>\r\n		</div>\r\n\r\n		<div class=\"col-sm-3 field-choose-topic\">\r\n			<div class=\"title\">Choose a topic</div>\r\n\r\n			<ul>\r\n				<li><a class=\"scroll-to\" href=\"#payment\" title=\"Payment\">Payment</a></li>\r\n				<li><a class=\"scroll-to\" href=\"#tax\" title=\"Tax\">Tax</a></li>\r\n				<li><a class=\"scroll-to\" href=\"#pricing\" title=\"Pricing\">Pricing</a></li>\r\n				<li><a class=\"scroll-to\" href=\"#promotions\" title=\"Promotions, Rebates, and Coupons\">Promotions, Rebates, and Coupons</a></li>\r\n			</ul>\r\n		</div>\r\n	</div>\r\n	<hr>\r\n	<div class=\"row block-content-topic\" id=\"payment\">\r\n		<div class=\"col-sm-3\">\r\n			<h4>Payment</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<div class=\"title\">Payment methods</div>\r\n\r\n			<p>The Apple Online Store accepts a variety of payment methods. Click on a payment method below to find out more:</p>\r\n\r\n			<ol>\r\n				<li><a href=\"#\" title=\"Credit Cards or Debit Cards\">Credit Cards or Debit Cards</a></li>\r\n				<li><a href=\"#\" title=\"Cash\">Cash</a></li>\r\n			</ol>\r\n\r\n			<p>Note: Business lease, wire transfers, cashier\'s checks, and money orders are ineligible payment methods for pickup items.</p>\r\n\r\n			<p>Some payment types are ineligible for orders shipping to multiple addresses. If you are using an ineligible payment type for an order shipping to multiple addresses, you will need to change the payment method, or ship your order to a single address.</p>\r\n\r\n			<p>Some customers may qualify for other forms of payment. Please call an Our Store Specialist at 1-800 for more information.</p>\r\n		</div>\r\n	</div>\r\n	<hr>\r\n	<div class=\"row block-content-topic\" id=\"tax\">\r\n		<div class=\"col-sm-3\">\r\n			<h4>Tax</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<div class=\"title\">Tax rate</div>\r\n\r\n			<p>In accordance with state and local law, your Apple Online Store purchases will be taxed using the applicable sales tax or seller\'s use tax rate for your shipping address, or the Apple Store address where the item is picked up.</p>\r\n\r\n			<p>The tax listed during checkout is only an estimate. In California and Rhode Island, sales tax is collected on the unbundled price of the iPhone.</p>\r\n\r\n			<ul>\r\n				<li>Aliquam erat volutpat</li>\r\n				<li>Phasellus facilisis nulla lacus</li>\r\n			</ul>\r\n\r\n			<p>Your invoice will reflect the final total tax, which includes state and local taxes, as well as any applicable rebates or fees.</p>\r\n		</div>\r\n	</div>\r\n	<hr>\r\n	<div class=\"row block-content-topic\" id=\"pricing\">\r\n		<div class=\"col-sm-3\">\r\n			<h4>Pricing</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<p>In accordance with state and local law, your Apple Online Store purchases will be taxed using the applicable sales tax or seller\'s use tax rate for your shipping address, or the Apple Store address where the item is picked up.</p>\r\n\r\n			<p>The tax listed during checkout is only an estimate. In California and Rhode Island, sales tax is collected on the unbundled price of the iPhone.</p>\r\n\r\n			<p>Your invoice will reflect the final total tax, which includes state and local taxes, as well as any applicable rebates or fees.</p>\r\n		</div>\r\n	</div>\r\n	<hr>\r\n	<div class=\"row block-content-topic\" id=\"promotions\">\r\n		<div class=\"col-sm-3\">\r\n			<h4>Promotions, Rebates, and Coupons</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<p>In accordance with state and local law, your Apple Online Store purchases will be taxed using the applicable sales tax or seller\'s use tax rate for your shipping address, or the Apple Store address where the item is picked up.</p>\r\n		</div>\r\n	</div>\r\n</div>\r\n','','full_html'),('node','page',0,17,17,'und',0,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer varius facilisis eros id posuere. Praesent sed turpis laoreet, aliquam metus a, fringilla libero. Quisque ac porta est. Vestibulum consequat posuere laoreet. Cras tincidunt faucibus velit, euismod egestas est sollicitudin ut. Vestibulum luctus placerat dui eu ullamcorper. Fusce sodales mi et sodales scelerisque. Etiam varius semper est, sed aliquet neque venenatis vel. Etiam non metus nec augue auctor eleifend id in est. Nulla id erat velit. Maecenas quis ex ultricies, dignissim ante et, euismod arcu.</p>\r\n\r\n<p>Cras nulla arcu, ullamcorper at viverra vel, aliquet vel nunc. Pellentesque dapibus auctor nibh, sed rhoncus diam aliquet in. Etiam condimentum metus vitae tortor egestas, id tincidunt purus luctus. Morbi sagittis aliquam dui, nec semper nulla malesuada eu. Donec eleifend molestie justo. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Nullam gravida turpis at ullamcorper porta.</p>\r\n\r\n<p>Aenean ac magna felis. Nulla blandit urna non aliquam tempus. Fusce ultricies laoreet velit, tempus condimentum purus aliquet a. Nullam ut sapien vel neque ornare convallis sit amet ut felis. Donec convallis consectetur lorem, dictum lobortis ex pretium vitae. Proin hendrerit feugiat vulputate. Duis ultricies, erat ut tincidunt feugiat, sapien ipsum pulvinar purus, eu bibendum tellus leo consequat metus. Donec quis dictum nisl. Quisque non lectus tellus. Etiam sit amet tincidunt leo. Morbi pretium rhoncus purus, et rhoncus orci sollicitudin vel. Mauris efficitur nisl eu leo imperdiet elementum. Duis ut consectetur augue. Etiam rutrum placerat volutpat. Suspendisse vitae tempor urna, a hendrerit sapien.</p>\r\n\r\n<p>Sed molestie imperdiet dolor et varius. Aliquam id metus bibendum, pulvinar erat eget, posuere elit. Aenean mattis id orci ac feugiat. Nunc pharetra congue lectus at sollicitudin. Donec ultricies, nunc a varius tincidunt, nulla odio tincidunt justo, nec malesuada augue nulla in purus. Nullam id quam orci. Mauris eu ante at elit malesuada dictum.</p>\r\n\r\n<p>Maecenas bibendum, odio et porta euismod, neque augue tristique velit, sit amet imperdiet felis sapien sed ante. Nullam consequat libero libero, id tempus tortor blandit eget. Nam aliquet nisi orci, sed placerat velit volutpat quis. Donec pulvinar magna et turpis auctor aliquam. Suspendisse et diam dignissim, maximus tellus eget, maximus ligula. Vivamus feugiat pellentesque metus, sit amet accumsan ligula posuere quis. Sed vitae metus sit amet neque iaculis cursus. Fusce luctus at massa sed euismod. Phasellus mollis suscipit purus, quis facilisis leo maximus in. Sed sagittis mi sed diam gravida laoreet. Praesent scelerisque, mi efficitur dictum imperdiet, elit massa volutpat ipsum, non venenatis felis lectus eu est. Aliquam libero justo, lobortis eget felis vel, tincidunt ultricies quam. Nunc et augue lacinia, dignissim augue sit amet, vehicula nisi. Duis varius elit a tellus imperdiet, vel ultricies mi viverra. Suspendisse aliquet eu justo id eleifend. Ut consequat ac lectus nec tincidunt.</p>\r\n','','filtered_html'),('node','page',0,18,18,'und',0,'<div class=\"block-payment\">\r\n	<div class=\"row\">\r\n		<div class=\"col-sm-9 field-body-topic\">\r\n		<p>You can purchase your items online and pick them up at an Apple Store, or ship them directly to your doorstep. Here you\'ll find everything you need to know about pickup, shipping, and much more.</p>\r\n		</div>\r\n\r\n		<div class=\"col-sm-3 field-choose-topic\">\r\n			<div class=\"title\">Choose a topic</div>\r\n\r\n			<ul>\r\n				<li><a class=\"scroll-to\" href=\"#shipping-delivery\" title=\"Shipping & Delivery\">Shipping & Delivery</a></li>\r\n				<li><a class=\"scroll-to\" href=\"#personal-pickup\" title=\"Personal Pickup\">Personal Pickup</a></li>\r\n				<li><a class=\"scroll-to\" href=\"#what-next\" title=\"What\'s Next?\">What\'s Next?</a></li>\r\n				<li><a class=\"scroll-to\" href=\"#text-notifications\" title=\"Text Notifications\">Text Notifications</a></li>\r\n				<li><a class=\"scroll-to\" href=\"#carrier-delivery-options\" title=\"Carrier Delivery Options\">Carrier Delivery Options</a></li>\r\n				<li><a class=\"scroll-to\" href=\"#shipping-policies\" title=\"Shipping Policies\">Shipping Policies</a></li>\r\n			</ul>\r\n		</div>\r\n	</div>\r\n\r\n	<hr />\r\n	<div class=\"row block-content-topic\" id=\"shipping-delivery\">\r\n		<div class=\"col-sm-3 \">\r\n			<h4>Shipping & Delivery</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<div class=\"title\">Standard Return Policy</div>\r\n\r\n			<p>The Apple Online Store accepts a variety of payment methods. Click on a payment method below to find out more:</p>\r\n\r\n			<ol>\r\n				<li><a href=\"#\" title=\"Credit Cards or Debit Cards\">Credit Cards or Debit Cards</a></li>\r\n				<li><a href=\"#\" title=\"Cash\">Cash</a></li>\r\n			</ol>\r\n\r\n			<p>Note: Business lease, wire transfers, cashier\'s checks, and money orders are ineligible payment methods for pickup items.</p>\r\n\r\n			<p>Some payment types are ineligible for orders shipping to multiple addresses. If you are using an ineligible payment type for an order shipping to multiple addresses, you will need to change the payment method, or ship your order to a single address.</p>\r\n\r\n			<p>Some customers may qualify for other forms of payment. Please call an Our Store Specialist at 1-800 for more information.</p>\r\n		</div>\r\n	</div>\r\n\r\n	<hr />\r\n	<div class=\"row block-content-topic\" id=\"personal-pickup\">\r\n		<div class=\"col-sm-3\">\r\n			<h4>Personal Pickup</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<div class=\"title\">Ship your item back to store</div>\r\n\r\n			<p>In accordance with state and local law, your Apple Online Store purchases will be taxed using the applicable sales tax or seller\'s use tax rate for your shipping address, or the Apple Store address where the item is picked up.</p>\r\n\r\n			<p>The tax listed during checkout is only an estimate. In California and Rhode Island, sales tax is collected on the unbundled price of the iPhone.</p>\r\n\r\n			<ul>\r\n				<li>Aliquam erat volutpat</li>\r\n				<li>Phasellus facilisis nulla lacus</li>\r\n			</ul>\r\n\r\n			<p>Your invoice will reflect the final total tax, which includes state and local taxes, as well as any applicable rebates or fees.</p>\r\n		</div>\r\n	</div>\r\n\r\n	<hr />\r\n	<div class=\"row block-content-topic\" id=\"what-next\">\r\n		<div class=\"col-sm-3\">\r\n			<h4>What\'s Next?</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<p>In accordance with state and local law, your Apple Online Store purchases will be taxed using the applicable sales tax or seller\'s use tax rate for your shipping address, or the Apple Store address where the item is picked up.</p>\r\n\r\n			<p>The tax listed during checkout is only an estimate. In California and Rhode Island, sales tax is collected on the unbundled price of the iPhone.</p>\r\n\r\n			<p>Your invoice will reflect the final total tax, which includes state and local taxes, as well as any applicable rebates or fees.</p>\r\n		</div>\r\n	</div>\r\n\r\n	<hr />\r\n	<div class=\"row block-content-topic\" id=\"text-notifications\">\r\n		<div class=\"col-sm-3\">\r\n			<h4>Text Notifications</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<p>In accordance with state and local law, your Apple Online Store purchases will be taxed using the applicable sales tax or seller\'s use tax rate for your shipping address, or the Apple Store address where the item is picked up.</p>\r\n		</div>\r\n	</div>\r\n\r\n	<hr />\r\n	<div class=\"row block-content-topic\" id=\"carrier-delivery-options\">\r\n		<div class=\"col-sm-3\">\r\n			<h4>Carrier Delivery Options</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<p>Proin eget lacus ac eros dapibus mattis. Quisque a dui tellus. Aenean lorem velit, porttitor sed rutrum vitae, faucibus non lacus. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Vivamus imperdiet aliquet justo blandit vestibulum. Nunc et venenatis dolor, et fringilla felis.</p>\r\n		</div>\r\n	</div>\r\n\r\n	<hr />\r\n	<div class=\"row block-content-topic\" id=\"shipping-policies\">\r\n		<div class=\"col-sm-3\">\r\n			<h4>Shipping Policies</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<p>Sed porta, ligula vitae ullamcorper commodo, sapien ipsum convallis quam, ut semper quam sem vitae sem. Nulla congue mauris non dolor egestas gravida. Mauris justo dui, vulputate id tempor at, mollis non massa. Integer sit amet diam id nunc porttitor consequat. Maecenas id erat pretium, efficitur neque a, congue nisi. Donec interdum lacus nec risus ullamcorper auctor.</p>\r\n			<ul>\r\n				<li>Aliquam erat volutpat</li>\r\n				<li>Phasellus facilisis nulla lacus</li>\r\n			</ul>\r\n		</div>\r\n	</div>\r\n</div>\r\n','','full_html'),('node','page',0,19,19,'und',0,'<div class=\"block-payment\">\r\n	<div class=\"row\">\r\n		<div class=\"col-sm-9 field-body-topic\">\r\n			<p>Apple wants you to be thrilled with your new purchase. However, if you need to return an item, we\'re here to help.</p>\r\n		</div>\r\n\r\n		<div class=\"col-sm-3 field-choose-topic\">\r\n			<div class=\"title\">Choose a topic</div>\r\n\r\n			<ul>\r\n				<li><a class=\"scroll-to\" href=\"#returns-policy\" title=\"Returns Policy\">Returns Policy</a></li>\r\n				<li><a class=\"scroll-to\" href=\"#how-to-return\" title=\"How To Return\">How To Return</a></li>\r\n				<li><a class=\"scroll-to\" href=\"#refunds\" title=\"Refunds\">Refunds</a></li>\r\n				<li><a class=\"scroll-to\" href=\"#gift-returns\" title=\"Gift Returns\">Gift Returns</a></li>\r\n			</ul>\r\n		</div>\r\n	</div>\r\n	<hr>\r\n	<div class=\"row block-content-topic\" id=\"returns-policy\">\r\n		<div class=\"col-sm-3 \">\r\n			<h4>Returns &amp; Refunds Policy</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<div class=\"title\">Standard Return Policy</div>\r\n\r\n			<p>The Apple Online Store accepts a variety of payment methods. Click on a payment method below to find out more:</p>\r\n\r\n			<ol>\r\n				<li><a href=\"#\" title=\"Credit Cards or Debit Cards\">Credit Cards or Debit Cards</a></li>\r\n				<li><a href=\"#\" title=\"Cash\">Cash</a></li>\r\n			</ol>\r\n\r\n			<p>Note: Business lease, wire transfers, cashier\'s checks, and money orders are ineligible payment methods for pickup items.</p>\r\n\r\n			<p>Some payment types are ineligible for orders shipping to multiple addresses. If you are using an ineligible payment type for an order shipping to multiple addresses, you will need to change the payment method, or ship your order to a single address.</p>\r\n\r\n			<p>Some customers may qualify for other forms of payment. Please call an Our Store Specialist at 1-800 for more information.</p>\r\n		</div>\r\n	</div>\r\n	<hr>\r\n	<div class=\"row block-content-topic\" id=\"how-to-return\">\r\n		<div class=\"col-sm-3\">\r\n			<h4>How to Return An Item</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<div class=\"title\">Ship your item back to store</div>\r\n\r\n			<p>In accordance with state and local law, your Apple Online Store purchases will be taxed using the applicable sales tax or seller\'s use tax rate for your shipping address, or the Apple Store address where the item is picked up.</p>\r\n\r\n			<p>The tax listed during checkout is only an estimate. In California and Rhode Island, sales tax is collected on the unbundled price of the iPhone.</p>\r\n\r\n			<ul>\r\n				<li>Aliquam erat volutpat</li>\r\n				<li>Phasellus facilisis nulla lacus</li>\r\n			</ul>\r\n\r\n			<p>Your invoice will reflect the final total tax, which includes state and local taxes, as well as any applicable rebates or fees.</p>\r\n		</div>\r\n	</div>\r\n	<hr>\r\n	<div class=\"row block-content-topic\" id=\"refunds\">\r\n		<div class=\"col-sm-3\">\r\n			<h4>Refunds</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<p>In accordance with state and local law, your Apple Online Store purchases will be taxed using the applicable sales tax or seller\'s use tax rate for your shipping address, or the Apple Store address where the item is picked up.</p>\r\n\r\n			<p>The tax listed during checkout is only an estimate. In California and Rhode Island, sales tax is collected on the unbundled price of the iPhone.</p>\r\n\r\n			<p>Your invoice will reflect the final total tax, which includes state and local taxes, as well as any applicable rebates or fees.</p>\r\n		</div>\r\n	</div>\r\n	<hr>\r\n	<div class=\"row block-content-topic\" id=\"gift-returns\">\r\n		<div class=\"col-sm-3\">\r\n			<h4>Gift Returns</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<p>In accordance with state and local law, your Apple Online Store purchases will be taxed using the applicable sales tax or seller\'s use tax rate for your shipping address, or the Apple Store address where the item is picked up.</p>\r\n		</div>\r\n	</div>\r\n</div>\r\n','','full_html'),('node','page',0,20,20,'und',0,'<p>Proin at dui sed elit facilisis vehicula bibendum at ex. Cras a sapien dignissim, consequat diam luctus, condimentum ipsum. Aenean vitae tincidunt elit. Aenean vitae mauris tempor, fermentum est ut, scelerisque odio. Sed quam neque, sagittis quis tempus vitae, accumsan nec orci. Maecenas porttitor quam quis vehicula tempor. Proin purus nisl, dictum id ultricies id, tincidunt eu ligula. Mauris lobortis fringilla dolor non mattis. Donec sit amet commodo mi. Nullam rutrum nisi nulla, sit amet blandit ipsum rutrum eget. Phasellus mattis, ex eleifend pharetra volutpat, eros eros bibendum ligula, at convallis arcu sem eget leo. Cras elementum sodales velit quis efficitur. Praesent non tortor lobortis, varius lectus et, pulvinar nunc. Vestibulum consectetur urna tincidunt tellus malesuada, vel auctor tellus lobortis.</p>\r\n\r\n<p>Mauris tellus neque, maximus quis consequat et, ullamcorper bibendum justo. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi tristique sed nulla in tempor. Etiam sed quam sit amet massa suscipit consequat nec eget ligula. Aenean ac diam tincidunt, condimentum enim eget, ultrices lacus. Maecenas lacinia rutrum metus. Suspendisse viverra nibh pharetra mauris lacinia, ac lobortis dolor suscipit.</p>\r\n\r\n<p>Curabitur ac placerat dui, sit amet luctus ex. Curabitur a tellus lorem. Pellentesque interdum vitae velit nec sodales. Donec nec justo ac eros finibus ultrices. Sed convallis posuere tellus sit amet laoreet. Sed dignissim nisl vel pulvinar tempor. In vestibulum dui convallis, auctor metus et, facilisis nulla. Proin dolor lorem, dignissim et velit nec, dictum vehicula ex. Maecenas ornare et turpis ac laoreet. Ut convallis est sit amet arcu porttitor laoreet. Vivamus ultrices velit in justo hendrerit, eu facilisis dolor efficitur. Integer quis tellus posuere, euismod tortor at, dictum eros. Maecenas ut arcu leo.</p>\r\n','','filtered_html'),('node','page',0,21,21,'und',0,'<p>Phasellus euismod nulla tristique, aliquam eros non, tristique mauris. Etiam rhoncus ipsum vitae nibh accumsan, ut gravida mauris condimentum. Ut ullamcorper velit lobortis nibh tincidunt elementum. Sed suscipit cursus lacinia. Ut efficitur dictum arcu vitae dignissim. Aenean venenatis bibendum augue, scelerisque dictum augue bibendum sit amet. Integer sit amet placerat justo, sed porttitor ante. Cras bibendum magna augue, ut congue urna cursus nec. Suspendisse vitae tortor cursus lectus pretium hendrerit vel sit amet risus. Nulla sed est condimentum, gravida massa sed, bibendum arcu. Integer vestibulum sollicitudin dignissim. Sed placerat nisl mi, nec aliquam lectus ultricies id. Maecenas non ex quam. Integer malesuada nibh quis justo consectetur accumsan. Phasellus consectetur id dolor sed blandit. In vel consequat sem, nec fermentum urna.</p>\r\n\r\n<p>Cras scelerisque nunc semper accumsan mattis. Proin mollis sodales leo, eget lacinia urna posuere nec. Vestibulum vulputate rutrum ex, sit amet tempus lorem commodo et. Vestibulum et tincidunt elit, eget tincidunt nibh. In elementum maximus risus, et ultrices nunc blandit non. Donec viverra ante at ante gravida sodales. Nunc lacinia nulla at commodo ornare. Vestibulum dictum laoreet viverra. Etiam sed neque ac quam tempus venenatis. Vivamus iaculis ipsum condimentum nibh venenatis venenatis. Integer laoreet ultricies nunc. Aenean placerat purus sed lectus scelerisque faucibus. Nulla eu diam eget metus sagittis sollicitudin ac eu lorem. Suspendisse sed odio nulla.</p>\r\n','','filtered_html'),('node','page',0,22,22,'und',0,'<div class=\"carousel slide carousel-affiliate\">\r\n	<div class=\"carousel-inner\">\r\n		<div class=\"item\"><img alt=\"Affiliate Program\" src=\"/sites/default/files/banner/slide-affiliate-1.jpg\" /></div>\r\n\r\n		<div class=\"item active\"><img alt=\"Affiliate Program\" src=\"/sites/default/files/banner/slide-affiliate-2.jpg\" /></div>\r\n	</div>\r\n\r\n	<div class=\"boxwap\"><a class=\"register-now\" href=\"#\" title=\"Register now\">Register now</a>\r\n\r\n		<p>Earn up to 8% commision on sales with Marketplace no.1 online shopping mall</p>\r\n	</div>\r\n</div>\r\n<script type=\"text/javascript\">jQuery(\'.carousel-affiliate\').carousel({interval: 4000, pause: false})</script>\r\n\r\n<div class=\"row block-affiliate\">\r\n<div class=\"col-sm-4\"><i class=\"fa fa-list\"><span>list</span></i>\r\n\r\n		<h3>Advertise</h3>\r\n\r\n		<div class=\"title-note\">Choose from over a million products to advertise to your customers</div>\r\n\r\n		<div class=\"field-body\">\r\n			<p>Whether you are a large network, content site or blogger, we have simple linking tools to meet your advertising needs and help you monetize your web site.</p>\r\n\r\n			<ul>\r\n				<li><a href=\"#\" title=\"Linking Tools\">Linking Tools</a></li>\r\n			</ul>\r\n		</div>\r\n	</div>\r\n\r\n	<div class=\"col-sm-4\"><i class=\"fa fa-usd\"><span>usd</span></i>\r\n\r\n		<h3>Earn</h3>\r\n\r\n		<div class=\"title-note\">Get up to 10% in advertising fees</div>\r\n\r\n		<div class=\"field-body\">\r\n			<p>Earn advertising fees from Qualifying Purchases, not just the products you advertised.</p>\r\n\r\n			<p>Plus, our competitive conversion rates help you maximize your earnings.</p>\r\n\r\n			<ul>\r\n				<li><a href=\"#\" title=\"Advertising Fees\">Advertising Fees</a></li>\r\n				<li><a href=\"#\" title=\"Reporting Tools\">Reporting Tools</a></li>\r\n			</ul>\r\n		</div>\r\n	</div>\r\n\r\n	<div class=\"col-sm-4\"><i class=\"fa fa-hand-o-up\"><span>hand</span></i>\r\n\r\n		<h3>Join</h3>\r\n\r\n		<div class=\"title-note\">It\'s easy and free to join</div>\r\n\r\n		<div class=\"field-body\">\r\n			<p>Get up and running today. Just one approval to join—no third-party advertiser approvals.</p>\r\n\r\n			<ul>\r\n				<li><a href=\"#\" title=\"Learn More\">Learn More</a></li>\r\n				<li><a href=\"#\" title=\"Join Now\">Join Now</a></li>\r\n			</ul>\r\n		</div>\r\n	</div>\r\n</div>\r\n','','full_html'),('node','page',0,23,23,'und',0,'<p>In vel tortor id turpis dignissim porttitor eu ac urna. Aenean in elit vel magna ultricies volutpat. Vestibulum vitae magna auctor, dignissim purus ullamcorper, varius sem. Sed nibh ex, fringilla ac enim at, iaculis maximus elit. Integer vitae gravida dolor. Nullam ultrices, diam at tincidunt feugiat, nunc magna euismod magna, eu euismod odio sapien vel lacus. Etiam malesuada sodales ante eget semper. Phasellus viverra elementum gravida. Maecenas tincidunt posuere lorem, eu tempus augue mollis et. Nam blandit viverra urna, sit amet laoreet dolor auctor ac. Vivamus eu justo erat. Fusce mollis quis nunc a facilisis.</p>\r\n\r\n<p>Curabitur commodo, lorem a tincidunt pellentesque, mauris massa aliquam enim, vel rutrum elit nisl ut mauris. Duis mattis neque arcu, eu pulvinar libero maximus ut. Vestibulum eget facilisis diam. Proin eget ante diam. Donec pulvinar magna id est vestibulum, et facilisis odio pellentesque. Fusce ut felis lorem. Quisque cursus libero non tempor imperdiet. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Donec at nibh nec lacus varius dapibus. Duis a lectus a augue interdum tempor sed ut arcu.</p>\r\n\r\n<p>Aenean fermentum lectus diam, quis fermentum mi cursus ut. Pellentesque turpis nunc, tempor et ullamcorper ac, pellentesque in nibh. Maecenas quis risus et nibh varius iaculis ac vel leo. Nam quis facilisis odio. Vestibulum commodo sed est ut porta. Cras ut porta neque, ac aliquam quam. Proin vel purus facilisis, rhoncus nibh eget, tincidunt nisi. Cras in posuere mi. Vivamus a convallis leo. Quisque in nisl venenatis, rutrum odio vel, gravida lacus. Vivamus id mauris nec ante dictum consectetur. Nullam vulputate nisi sit amet lectus pulvinar, eu pretium ante sodales.</p>\r\n','','filtered_html'),('node','page',0,24,24,'und',0,'<p>We take our customer’s privacy seriously and we will only collect, record, hold, store, disclose, transfer and use your personal information as outlined below. Data protection is a matter of trust and your privacy is important to us. We shall therefore only use your name and other information which relates to you in the manner set out in this Privacy Policy. We will only collect information where it is necessary for us to do so and we will only collect information if it is relevant to our dealings with you.</p>\r\n\r\n<p>We will only keep your information for as long as we are either required to by law or as is relevant for the purposes for which it was collected.</p>\r\n\r\n<p>You can visit the Platform (as defined in the Terms of Use) and browse without having to provide personal details. During your visit to the Platform you remain anonymous and at no time can we identify you unless you have an account on the Platform and log on with your user name and password.</p>\r\n\r\n<p>If you have any comments, suggestions or complaints, you may contact us (and our Data Protection Officer) at <a href=\"#\">customer.services@marketplace.com</a></p>\r\n\r\n<h3>Collection of Personal Information</h3>\r\n\r\n<p>When you create a Marketplace account, or otherwise provide us with your personal information through the Platform, the personal information we collect may include your:</p>\r\n\r\n<ul>\r\n	<li>Name</li>\r\n	<li>Delivery Address</li>\r\n	<li>Email Address</li>\r\n	<li>Contact Number</li>\r\n	<li>Mobile Number</li>\r\n	<li>Date of Birth</li>\r\n	<li>Gender</li>\r\n</ul>\r\n\r\n<p>You must only submit to us, our authorized agent or the Platform, information which is accurate and complete and not misleading and you must keep it up to date and inform us of changes (more information below). We reserve the right to request for documentation to verify the information provided by you.</p>\r\n\r\n<p>We will only be able to collect your personal information if you voluntarily submit the information to us. If you choose not to submit your personal information to us or subsequently withdraw your consent to our use of your personal information, we may not be able to provide you with our Services. You may access and update your personal information submitted to us at any time as described below.</p>\r\n\r\n<p>If you provide personal information of any third party to us, we assume that you have obtained the required consent from the relevant third party to share and transfer his/her personal information to us.</p>\r\n\r\n<p>If you sign up for Marketplace using your social media account or link your Marketplace account to your social media account or use certain other Marketplace social media features, we may access information about you which you have voluntarily provided under your social media account via that social media provider in accordance with the provider\'s policies and we will manage your personal data which we have collected in accordance with Marketplace privacy policy</p>\r\n\r\n<h3>Use and Disclosure of Personal Information</h3>\r\n\r\n<p>The personal information we collect from you will be used, or shared with third parties (including related companies, third party service providers, and third party sellers), for some or all of the following purposes:</p>\r\n\r\n<ul>\r\n	<li>To facilitate your use of the Services (as defined in the Terms of Use) and/or access to the Platform;</li>\r\n	<li>To process orders you submit through the Platform, whether the products are sold by Marketplace or a third party seller. Payments that you make through the Platform for products, whether sold by Marketplace or a third party seller, will be processed by our agent;</li>\r\n	<li>To deliver the products you have purchased through the Platform, whether sold by Marketplace or a third party seller. We may pass your personal information on to a third party in order to make delivery of the product to you (for example to our courier or supplier), whether the product is sold through the Platform by Marketplace or a third party seller;</li>\r\n	<li>To update you on the delivery of the products, whether sold through the Platform by Marketplace or a third party seller, and for customer support purposes;</li>\r\n	<li>To compare information, and verify with third parties in order to ensure that the information is accurate;</li>\r\n	<li>Further, we will use the information you provide to administer your account (if any) with us; verify and carry out financial transactions in relation to payments you make online; audit the downloading of data from the Platform; improve the layout and/or content of the pages of the Platform and customize them for users; identify visitors on the Platform; carry out research on our users’ demographics and behavior; provide you with information we think you may find useful or which you have requested from us, including information about our or third party sellers’ products and services, provided you have indicated that you have not objected to being contacted for these purposes;</li>\r\n	<li>When you register an account with Marketplace or otherwise provide us with your personal information through the Platform, we will also use your personal information to send you marketing and/or promotional materials about our or third party sellers’ products and services from time to time. You can unsubscribe from receiving marketing information at any time by using the unsubscribe function within the electronic marketing material. We may use your contact information to send newsletters from us and from our related companies; and</li>\r\n	<li>In exceptional circumstances Marketplace may be required to disclose personal information, such as when there are grounds to believe that the disclosure is necessary to prevent a threat to life or health, for law enforcement purposes, or for fulfillment of legal and regulatory requirements and requests.</li>\r\n</ul>\r\n\r\n<p>Marketplace may share your personal information with third parties and our affiliates for the abovementioned purposes, specifically, completing a transaction with you, managing your account and our relationship with you, marketing and fulfilling any legal or regulatory requirements and requests as deemed necessary by Marketplace. In sharing your personal information with them, we endeavor to ensure that the third parties and our affiliates keep your personal information secure from unauthorized access, collection, use, disclosure, or similar risks and retain your personal information only for as long as they need your personal information to achieve the abovementioned purposes.</p>\r\n\r\n<p>In disclosing or transferring your personal information to third parties and our affiliates located overseas, Marketplace take steps to ensure that the receiving jurisdiction has in place a standard of protection accorded to personal information that is comparable to the protection under or up to the standard of the Philippine Data Privacy Act.</p>\r\n\r\n<p>Marketplace does not engage into the business of selling customers’ personal information to third parties.</p>\r\n\r\n<h3>Withdrawal of Consent</h3>\r\n\r\n<p>You may communicate your objection to our continual use and/or disclosure of your personal information for any of the purposes and in the manner as stated above at any time by contacting us at our e-mail address below.</p>\r\n\r\n<p>Please note that if you communicate your objection to our use and/or disclosure of your personal information for the purposes and in the manner as stated above, depending on the nature of your objection, we may not be in a position to continue to provide our products or services to you or perform on any contract we have with you. Our legal rights and remedies are expressly reserved in such event.</p>\r\n\r\n<h3>Updating Your Personal Information</h3>\r\n\r\n<p>You can update your personal information anytime by accessing your account on the Marketplace Platform. If you do not have an account with us, you can do so by contacting us at our e-mail address below.</p>\r\n\r\n<p>We take steps to share the updates to your personal information with third parties and our affiliates with whom we have shared your personal information if your personal information is still necessary for the above stated purposes.</p>\r\n\r\n<h3>Accessing Your Personal Information</h3>\r\n\r\n<p>If you would like to view the personal information we have on you or inquire about the ways in which your personal information has been or may have been used or disclosed by Marketplace within the past year, please contact us at our e-mail address below. We reserve the right to charge a reasonable administrative fee for retrieving your personal information records.</p>\r\n\r\n<p>If you have an account with Marketplace, you may access details of your order by logging into your account on the Platform. Here you can view the details of your orders that have been completed, those which are open and those which are shortly to be dispatched and administer your address details, bank details and any newsletter to which you may have subscribed. You undertake to treat your Marketplace username, password and order details confidentially and not make it available to unauthorized third parties. We cannot assume any liability for misuse of your Marketplace username, password or order details, except as stated in the Terms of Use.</p>\r\n\r\n<h3>Security of Your Personal Information</h3>\r\n\r\n<p>Marketplace ensures that all information collected will be safely and securely stored. We protect your personal information by:</p>\r\n\r\n<ul>\r\n	<li>Restricting access to personal information</li>\r\n	<li>Maintaining technology products to prevent unauthorized computer access</li>\r\n	<li>Securely destroying your personal information when it is no longer needed for any legal or business purpose</li>\r\n</ul>\r\n\r\n<p>Marketplace uses 128-bit SSL (secure sockets layer) encryption technology when processing your financial details. 128-bit SSL encryption is approximated to take at least one trillion years to break, and is the industry standard.</p>\r\n\r\n<p>If you believe that your privacy has been breached by Marketplace, please contact us at our e-mail address below.</p>\r\n\r\n<p>Your password is the key to your account. Please use unique numbers, letters and special characters, and do not share your Marketplace password to anyone. If you do share your password with others, you will be responsible for all actions taken in the name of your account and the consequences. If you lose control of your password, you may lose substantial control over your personal information and other information submitted to Marketplace. You could also be subject to legally binding actions taken on your behalf. Therefore, if your password has been compromised for any reason or if you have grounds to believe that your password has been compromised, you should immediately contact us and change your password. You are reminded to log off of your account and close the browser when finished using a shared computer.</p>\r\n\r\n<h3>Minor</h3>\r\n\r\n<p>Marketplace does not sell products for purchase by children. If you are under 18 years old, you may use our website only with the involvement of a parent or guardian.</p>\r\n\r\n<h3>Collection of Computer Data</h3>\r\n\r\n<p>Marketplace or our authorized service providers may use cookies, web beacons, and other similar technologies for storing information to help provide you with a better, faster, safer and personalized experience when you use the Services and/or access the Platform.</p>\r\n\r\n<p>When you visit Marketplace, our company servers will automatically record information that your browser sends whenever you visit a website. This data may include:</p>\r\n\r\n<ul>\r\n	<li>Your computer\'s IP address</li>\r\n	<li>Browser type</li>\r\n	<li>Webpage you were visiting before you came to our Platform</li>\r\n	<li>The pages within the Platform which you visit</li>\r\n	<li>The time spent on those pages, items and information searched for on the Platform, access times and dates, and other statistics.</li>\r\n</ul>\r\n\r\n<p>This information is collected for analysis and evaluation in order to help us improve the Platform and the services and products we provide.</p>\r\n\r\n<p>Cookies are small text files (typically made up of letters and numbers) placed in the memory of your browser or device when you visit a website or view a message. They allow us to recognize a particular device or browser and help us to personalize the content to match your preferred interests more quickly, and to make our Services and Platform more convenient and useful to you.</p>\r\n\r\n<p>Web beacons are small graphic images that may be included on our Service and the Platform. They allow us to count users who have viewed these pages so that we can better understand your preference and interests.</p>\r\n\r\n<h3>No Spam, Spyware, or Virus</h3>\r\n\r\n<p>Spam, spyware or virus is not allowed on Platform. Please set and maintain your communication preferences so that we send communications to you as you prefer. You are not licensed or otherwise allowed to add other users (even a user who has purchased an item from you) to your mailing list (email or physical mail) without their express consent. You should not send any messages which contain spam, spyware or virus via the Platform. If you would like to report any suspicious messages, please contact us at our email address below.</p>\r\n\r\n<h3>Changes to the Privacy Policy</h3>\r\n\r\n<p>Marketplace shall regularly review the sufficiency of this Privacy Policy. We reserve the right to modify and change the Privacy Policy at any time. Any changes to this policy will be published on the Platform.</p>\r\n\r\n<h3>Marketplace\'s Right</h3>\r\n\r\n<p>YOU ACKNOWLEDGE AND AGREE THAT MARKETPLACE HAS THE RIGHT TO DISCLOSE YOUR PERSONAL INFORMATION TO ANY LEGAL, REGULATORY, GOVERNMENTAL, TAX, LAW ENFORCEMENT OR OTHER AUTHORITIES OR THE RELEVANT RIGHT OWNERS, IF MARKETPLACE HAS REASONABLE GROUNDS TO BELIEVE THAT DISCLOSURE OF YOUR PERSONAL INFORMATION IS NECESSARY FOR THE PURPOSE OF MEETING ANY OBLIGATIONS, REQUIREMENTS OR ARRANGEMENTS, WHETHER VOLUNTARY OR MANDATORY, AS A RESULT OF COOPERATING WITH AN ORDER, AN INVESTIGATION AND/OR A REQUEST OF ANY NATURE BY SUCH PARTIES. TO THE EXTENT PERMISSIBLE BY APPLICABLE LAW, YOU AGREE NOT TO TAKE ANY ACTION AND/OR WAIVE YOUR RIGHTS TO TAKE ANY ACTION AGAINST MARKETPLACE FOR THE DISCLOSURE OF YOUR PERSONAL INFORMATION IN THESE CIRCUMSTANCES.</p>\r\n\r\n<h3>Contacting Marketplace</h3>\r\n\r\n<p>If you wish to withdraw your consent to our use of your personal information, request access and/or correction of your personal information, have any queries, comments or concerns, or require any help on technical or cookie-related matters, please feel free to contact us (and our Data Protection Officer) at <a href=\"#\">customer.services@marketplace.com</a></p>','','full_html'),('node','page',0,26,26,'und',0,'<div class=\"block-sell-on\">\r\n<div class=\"row\">\r\n<div class=\"col-sm-6\">\r\n<p>Individuals and businesses can list products on MarketPlace, one of the fastest ways to start selling online.</p>\r\n\r\n<ul>\r\n	<li>More than 20 categories to sell in</li>\r\n	<li>Trusted MarketPlace platform</li>\r\n	<li>No per-item listing fee</li>\r\n</ul>\r\n\r\n<div class=\"note\">\r\n<p>\"Selling on MarketPlace makes it possible for us to reach a global audience with our innovative products.\" <strong>Bernie Thompson, Founder, Plugable Technologies</strong></p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"col-sm-6 text-center\"><iframe allowfullscreen=\"\" height=\"281\" src=\"//player.vimeo.com/video/55806355\" width=\"500\"></iframe></div>\r\n</div>\r\n\r\n<div class=\"block-sell-on-works\">\r\n<h2>How Selling on MarketPlace Works</h2>\r\n\r\n<div class=\"row\">\r\n<div class=\"col-sm-6\">\r\n<div class=\"media\"><i class=\"fa fa-upload pull-left\"><span>upload</span></i>\r\n\r\n<div class=\"media-body\">\r\n<h4 class=\"media-heading\">Upload your listings</h4>\r\n\r\n<p>Add your offers to the MarketPlace catalog using feeds, spreadsheets, and other tools.</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"media\"><i class=\"fa fa-desktop pull-left\"><span>desktop</span></i>\r\n\r\n<div class=\"media-body\">\r\n<h4 class=\"media-heading\">Customers can see your products on marketplace.com</h4>\r\n\r\n<p>With features like 1-Click and a brand millions trust, MarketPlace helps customers make quick, easy, worry-free purchases.</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"media\"><i class=\"fa  fa-truck pull-left\"><span>truck</span></i>\r\n\r\n<div class=\"media-body\">\r\n<h4 class=\"media-heading\">Ship products to customers</h4>\r\n\r\n<p>MarketPlace notifies you when customers place an order. Use Fulfillment by MarketPlace and let MarketPlace do the shipping for you — or handle shipping yourself.</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"media\"><i class=\"fa fa-usd pull-left\"><span>usd</span></i>\r\n\r\n<div class=\"media-body\">\r\n<h4 class=\"media-heading\">MarketPlace transfers payments to you</h4>\r\n\r\n<p>MarketPlace deposits payment into your bank account at regular intervals and notifies you that your payment has been sent.</p>\r\n</div>\r\n</div>\r\n</div>\r\n\r\n<div class=\"col-sm-6 field-image\"><img alt=\"How Selling on MarketPlace Works\" src=\"/sites/default/files/pictures/about-us/sell-on.jpg\" />\r\n<div class=\"note\">\r\n<p>\"Selling on MarketPlace makes it possible for us to reach a global audience with our innovative products.\" <strong>Bernie Thompson, Founder, Plugable Technologies</strong></p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n\r\n<div class=\"note\">\r\n<p>* Offer limited to new Professional Selling on Amazon subscriptions only. Offer is not available to sellers who have previously registered to list on Amazon.com. Offer includes one month of subscription fees only (you will be charged other fees, including referral fees, for items that sell on Amazon.com). A credit of $39.99 will be posted to your seller account to offset one month of subscription fees charged. Other limitations apply. After the trial period, we will automatically charge your credit card the monthly subscription fee at the beginning of every month thereafter.</p>\r\n</div>\r\n</div>\r\n','','full_html'),('node','page',0,27,27,'und',0,'<p><strong>Marketplace</strong> is the number one online shopping site. Marketplace offers a wide array of products and provides convenient online shopping experience with its nationwide shipping, warranties, 30-day returns policy, and easy payment options. Consumers can shop anytime and anywhere for books, electronics, phones &amp; accessories, computers, home &amp; living, hardware, home appliances, toys, kids &amp; babies, travel and luggage, beauty, jewelry &amp; watches, fashion, and sports.</p>\r\n\r\n<div class=\"block-about\">\r\n<div class=\"field-body\">\r\n<h2>How To Shop at Marketplace</h2>\r\n\r\n<p>It’s simple to shop at Marketplace</p>\r\n\r\n<ol>\r\n	<li>Select your products at Marketplace.</li>\r\n	<li>Register with us and pick a payment option.</li>\r\n	<li>Have your products delivered quickly and safely.</li>\r\n</ol>\r\n</div>\r\n</div>\r\n\r\n<div class=\"block-about\">\r\n<div class=\"field-body\">\r\n<h2>Safe and Secure Shoppinge</h2>\r\n\r\n<p>After making your selection, check out and pick a payment method – PayPal, credit card (installments available), and cash on delivery. After a successful transaction, you will get an order status and tracking number that lets you keep track of your order until it is delivered to you.</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"block-about\">\r\n<div class=\"field-body\">\r\n<h2>Safe and Secure Delivery</h2>\r\n\r\n<p>Your orders take utmost priority and will be delivered between 3-5 working days for Metro Manila and 5-10 working days for provincial orders. Should you have any questions on your order, please contact our customer service representatives between 8am to 9pm (Monday to Friday) or between 9am to 6pm (Saturday, Sunday, and holiday) at the <a href=\"http://localhost/marketplace/about-us#\">contact page</a> or (02) 795 8900 and we shall gladly assist you.</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"block-about\">\r\n<div class=\"field-body\">\r\n<h2>Returns</h2>\r\n\r\n<p>If your product is damaged or incomplete upon delivery, please contact MARKETPLACE’S customer service representatives (<a href=\"http://localhost/marketplace/about-us#\">contact page</a> or (02) 795 8900) WITHIN 24 hours of delivery to initiate the return. You have 30 (thirty) days from day of delivery to return your order with a completed <a href=\"http://localhost/marketplace/about-us#\">Return Form</a>. The cost of return will be refunded after your return has been processed.</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"block-about\">\r\n<div class=\"field-body\">\r\n<h2>Comprehensive and Personal Service</h2>\r\n\r\n<p>Our customers can contact us between 8am to 9pm (Monday to Friday) or between 9am to 6pm (Saturday, Sunday, and Holiday) at <a href=\"http://localhost/marketplace/about-us#\">contact page</a> or (02) 795 8900 to check the status of your order, ask any question about Lazada or give feedback on your shopping experience.</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"block-about\">\r\n<div class=\"field-body\">\r\n<h2>Marketplace part of Online Revolution</h2>\r\n\r\n<p>Marketplace is a participant of the <a href=\"https://en.wikipedia.org/wiki/Online_Revolution\">Online Revolution</a> e-commerce event, a Southeast Asian month-long online sale event similar to Black Friday and Cyber Monday, aiming to support the evolution of the Asian online culture thanks to fast-growing ventures and adapting consumers. In the Philippines, our partner ventures include Zalora: The country’s leading online fashion store, Lamido: The online marketplace for buyers to meet sellers, Carmudi: The online car dealership, Lamudi: The online real-estate listing, and Easy Taxi: Your Taxi is 1 Click Away.</p>\r\n</div>\r\n</div>\r\n','','full_html'),('node','webform',0,28,28,'und',0,'<h2>Company &amp; Contact&nbsp;Informattion</h2>\r\n\r\n<p>Fields marked <span class=\"form-required\" title=\"This field is required.\">*</span> are required</p>\r\n','','full_html'),('node','page',0,29,29,'und',0,'<p>We want you to have the simplest, easiest buying experience possible. But we know you might have a few questions. Read on for details about purchasing, shipping, checking order status, returns, and more.</p>\r\n','','filtered_html'),('node','product',0,30,30,'und',0,'<p>Not just any backpack, Aeroline Casual Hiking backpack is ideal when going for that hike, weekend camping rendezvous or traveling. It is a great choice to bring around to help ease the load or lend a helping shoulder in those adventurous moments.</p>\r\n\r\n<p><strong>Ergonomically Designed</strong><br />\r\nAeroline’s backpack is ergonomically designed to accommodate 35 liters worth of essentials such as clothes, food and medicine to prepare you for any situations. This pack provides you with a large compartment with a small interior zippered compartment, a medium compartment and two side pockets. Fret not of downpours or a little sprinkle as it is waterproof and wear resistant to match your toughness.</p>\r\n\r\n<p><strong>Tough on Everything Else Except for You</strong><br />\r\nAs a user friendly pack, it is designed in a way to fit perfectly snugged including a waist strap with buckle to reduce pressure on your spine and shoulder and back support paddings. Thus, making your walks and climbs a more comfortable one. Made out of superior ripstop waterproof nylon cloth, you can pretty much go through any weather suitable for adventurous backpackers, mountain climbers and travellers.</p>\r\n\r\n<p class=\"rtecenter\"><img alt=\"\" src=\"/sites/default/files/products/aeroline-casual-hiking-1.jpg\" /></p>\r\n','','filtered_html'),('node','product',0,31,31,'und',0,'<p>Planning for a weekend getaway from the city jungle? Diving into the lush greenery trail and wide blue ocean for some relaxing time? Then pack all your gears into the Local Lion Water Resistant Hiking Backpack Bag 28L Sky Blue. Its duffle style cavernous space can suck in your travel clothes, smartphone, camera and even laptop! So snap your quickie holiday with this backpack now. This bag is dedicated to keep you connected...even during your wild jungle adventure!</p>\r\n\r\n<p>The Local Lion Water Resistant Hiking Backpack Bag 28L Sky Bluebackpack is designed with your active lifestyle in mind. Made of high quality material, the cool fabric will hurdle any tear or slash on its track without ripping any further damage.</p>\r\n\r\n<p><strong>Put in Everything!</strong><br />\r\nThe main interior of this backpack is big enough to slap in your laptop. Multiple zipped pockets and sleeves are made readily available to store your gadget accompanying accessories. So, stash in your MP3 player, smartphone, power bank, charging cables and camera. Its’ convenient and hard underbelly strips will provide extra protection from your bumpy journey.</p>\r\n\r\n<p><strong>Cushiony Comfort</strong><br />\r\nLong hours of backpacking this bag will be easy as a breeze. Lightweight and compact, the back and shoulder straps are padded with super cushion for your ultimate comfort.</p>\r\n\r\n<p><strong>Looking Pretty Good</strong><br />\r\nCut out with the most trendy pattern pole in town, this backpack is specially design to look fashionable and functional. Plus, this backpack colourfast material can even withstand multiple washing after a rough day in the outdoor. Durable, it will always come out pretty sleek. Just like new!</p>\r\n','','filtered_html'),('node','product',0,32,32,'und',0,'<p>Stay stylish with a laptop bag from Terminus. This Terminus T02-297LAP-01 Laptop Backpack Plus is not only made to appear fashionable, but it is also designed with an ergonomic shape. The Laptop Backpack comes with a front compartment that is ideal for storing paper documents, power adapter, mouse and other laptop accessories. The laptop compartment can fit a 14.5” laptop and there is a padded compartment that could fit an iPad or a tablet. Not only that the bag is lightweight and robust, but it is also elastic to slip over a trolley luggage handle. This bag is great to bring on a travel or even for everyday use, it will never fail to keep your belongings safe, secure and within reach.</p>\r\n\r\n<p><strong>About Terminus</strong><br />\r\nTerminus is a world-class, design oriented brand. A brand that creates many innovations with no boundaries and a home grown brand that draws its inspiration from all over the world. There is no other brand like Terminus, who focuses their designs based on this direction: designs inspired by talented designers from different countries for a truly global style. Every Terminus product is designed to the highest standards of functionality, appearance, fashion and hand feels. Whether it’s for a sophisticated, professional or active lifestyle, you will find innovations and conveniences you didn’t think possible till you see a Terminus bag – bags that wow and work!</p>\r\n','','filtered_html'),('node','product',0,33,33,'und',0,'<p><strong>The Targus 15.6In Revolution Backpack</strong> is a sporty and all purpose backpacks that provide high functionality &amp; rugged protection. Featuring anti-scratch material this backpack can prevent any scratches to the surface of your laptop. The design of this backpack less resembles traditional laptop backpack hence it is the perfect day-to-day backpack even without carrying the laptop around. With special attention to the user experience, the back panel and shoulder straps are designed with the maximum comfort and protection. Featuring a extra- large full zip-down main compartment, users and put and take items to and from this backpack easily without the hassle of digging. With the high grade material and the design of raincover, this backpack can provide superior protection to the items inside. This Revolution backpack is truly designed for the adventurous individuals.</p>\r\n','','filtered_html'),('node','product',0,34,34,'und',0,'<p><img alt=\"Tarantula Shoe Bag (BOS04-088SHB-03) - Red \" src=\"/marketplace/sites/default/files/products/tarantula-shoe-bag-red-des.jpg\" /></p>\r\n','','filtered_html'),('node','product',0,35,35,'und',0,'<p class=\"rtecenter\"><img alt=\"Diniwell Water-Resistant Travel Shoes Bag Pouch Organizer Bag Ver 2 - Orange\" src=\"/marketplace/sites/default/files/products/diniwell-water-resistant-05.jpg\" /><br />\r\n&nbsp;</p>\r\n','','filtered_html'),('node','product',0,36,36,'und',0,'<p>Applying makeup and enhancing looks on the go is made easy thanks to this 24-piece makeup brush set. Featuring&nbsp;natural/synthetic-blend fibres&nbsp;for supreme softness, the premium quality makeup brushes will be delivered to makeup mavens\' doors in a black travel pouch.</p>\r\n\r\n<p><strong>Specification &amp; Features</strong></p>\r\n\r\n<p>Material:</p>\r\n\r\n<ul>\r\n	<li>Brush: Soft synthetic fibres and pony hair</li>\r\n	<li>Handle: Bamboo</li>\r\n	<li>Ferrule: Aluminium</li>\r\n	<li>Pouch: PU leather</li>\r\n</ul>\r\n\r\n<p>Colour: Black and wooden handle</p>\r\n\r\n<p>Individually handcrafted with high quality materials</p>\r\n\r\n<p>Each brush comes with own plastic cover and compartment</p>\r\n\r\n<p>Roll-up pouch for easy travel and storage</p>\r\n\r\n<p>Plastic-lined pouch with waterproof exterior for added protection</p>\r\n','','filtered_html'),('node','product',0,37,37,'und',0,'<p>In vel tortor id turpis dignissim porttitor eu ac urna. Aenean in elit vel magna ultricies volutpat. Vestibulum vitae magna auctor, dignissim purus ullamcorper, varius sem. Sed nibh ex, fringilla ac enim at, iaculis maximus elit. Integer vitae gravida dolor. Nullam ultrices, diam at tincidunt feugiat, nunc magna euismod magna, eu euismod odio sapien vel lacus. Etiam malesuada sodales ante eget semper. Phasellus viverra elementum gravida. Maecenas tincidunt posuere lorem, eu tempus augue mollis et. Nam blandit viverra urna, sit amet laoreet dolor auctor ac. Vivamus eu justo erat. Fusce mollis quis nunc a facilisis.</p>\r\n\r\n<p>Curabitur commodo, lorem a tincidunt pellentesque, mauris massa aliquam enim, vel rutrum elit nisl ut mauris. Duis mattis neque arcu, eu pulvinar libero maximus ut. Vestibulum eget facilisis diam. Proin eget ante diam. Donec pulvinar magna id est vestibulum, et facilisis odio pellentesque. Fusce ut felis lorem. Quisque cursus libero non tempor imperdiet. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Donec at nibh nec lacus varius dapibus. Duis a lectus a augue interdum tempor sed ut arcu.</p>\r\n\r\n<p>&nbsp;</p>\r\n','','filtered_html'),('node','product',0,38,38,'und',0,'<p>Power Perfect Pore with mist function maintains clean, healthy and radiant looking skin without embarrassing blackheads or whiteheads. Its deep penetrating suction cleanses below the surface to effectively help prevent breakouts. No more squeezing, pulling or injuring your skin.</p>\r\n\r\n<p>Power Perfect Pore (Facial Kit) is perfect solution for clean, clear and fair skin. No Blackheads, No Pimples, No Dark Circles, No Wrinkles. Power Perfect Pore is easy to operate. It cleans &amp; clears the skin. Use it with cream or moisturizer for gentle massage and better absorption.</p>\r\n\r\n<p><strong>POWER PORE FACIAL!!!!!</strong><br />\r\nErgonomically designed suction cup. Removes black heads without hurting your skin with hard squeezing. Face Suction Cup Cleans pores and black heads from your skin by its suction technology. Contour Massager tones face muscles, stimulate blood vessels and thus improve blood circulation. Cleaning Sponge helps you to spread facial cream evenly on your face to get maximum benefits of it. Exfoliation Brush with mist function renews skin by removal of dead cells of face and makes your skin glow.</p>\r\n','','filtered_html'),('node','product',0,39,39,'und',0,'<p><strong>SK-II 5-Piece Skincare Travel Set includes: Facial Treatment Gentle Cleanser 20g</strong><br />\r\nSK-II Facial Treatment Gentle Cleanser cares for your skin while it cleanses. It contains Concentrated Pitera and Mild Treatment Essence that leaves your skin hydrated even 30 minutes after cleansing. Work up a fine-textured lather and enjoy its mild rose scent. Facial Treatment Clear Lotion 30ml. For perfectly conditioned and ultra-fresh skin, use the Facial Treatment Clear Lotion morning and evening after cleansing your face and neck. The final part of your cleansing process, this lotion helps remove residual impurities and dead skin cells. Facial Treatment Essence 30ml SK-II Facial Treatment Essence is also known as SK-II Miracle Water. The heart of the SK-II Ritual, the revolutionary Facial Treatment Essence is the second point of your ritual.</p>\r\n\r\n<p><strong>Facial Treatment Mask 1pc</strong><br />\r\nBoosts radiance and moisture levels and can be used by all skin types throughout the year. The mask literally drenches your skin in SK-II Pitera, resulting in a fresher and more hydrated complexion.</p>\r\n\r\n<p class=\"rtecenter\"><img alt=\"\" src=\"/sites/default/files/products/sk-II-5-piece-skincare-travel-01.jpg\" /></p>\r\n','','filtered_html'),('node','product',0,40,40,'und',0,'<p>Revive and restore skin around eyes with this moisturising antioxidant cream containing a special blend of Green Tea, Eyebright and Buckwheat extract. Made with 85% organic ingredients and certified to the strict Soil Association organic skin care standards, also vegan products registered. The gentle formulation of this organic eye cream make it suitable for all skin types, including sensitive skin.</p>\r\n','','filtered_html'),('node','product',0,41,41,'und',0,'<p>Mejikaliner Quick Eyelid Essence Stick Glue is an invisible Clear type double eyelid maker. It creates natural and beautiful double eyelids easily. How to use:1. Remove grease from eyelids.2. Locate your ideal double eyelid-line, usually 3 - 6mm above the eyelash, by slightly twist the end of the glud and apply glue along.3. To remove, wipe with wet cotton bud or facial puff. Volume: 2ml Origin: Japan</p>\r\n','','filtered_html'),('node','product',0,42,42,'und',0,'<p><strong>Hairscape Hair Dryer 5000 </strong><br />\r\nHigh performance professional salon hairdryer. Operating at 1600-1800 watts this turbo force hairdryer offers three speeds and 3 temperature settings Highlights.</p>\r\n','','filtered_html'),('node','product',0,43,43,'und',0,'<p><strong>Tonific - Body Massager</strong> has a unique ergonomic and revolutionary design with advanced technology that penetrates the deepest layers of your skin, helping it burn calories and reduce inches with little to no effort.</p>\r\n\r\n<p><strong>Tonific - Body Massager</strong> is the ideal method to help reduce and tone your entire body without any exercise. The secret is its exclusive design that spins at more than 2700 revolutions per minute.&nbsp;With Tonific you get 3 massagers in 1 with the patent Interchangeable Rotating Acu-Spheres.</p>\r\n','','filtered_html'),('node','product',0,44,44,'und',0,'<p><strong><u>Special Notice</u></strong>: for the iPhone 6, Lazada is not able to&nbsp;accept returns for convenience. In case of a damage or defect you will of&nbsp;course be able to make a return as normal.</p>\r\n<p>Bigger than&nbsp;biggeriPhone 6 isn’t simply bigger — it’s better in every way. Larger, yet dramatically thinner. More powerful, but remarkably power efficient. With a smooth metal surface that seamlessly meets the new Retina HD display. It’s one continuous form where hardware and software function in perfect unison, creating a new generation of iPhone that’s better by any measure.<br />\r\niPhone at its largest. And thinnest.</p>\r\n\r\n<p>iPhone at its largest. And&nbsp;thinnest.Developing an iPhone with a larger, more advanced display meant pushing the edge of design. From the seamless transition of glass and metal to the streamlined profile, every detail was carefully considered to enhance your experience. So while its display is larger, iPhone 6 feels just right.</p>\r\n\r\n<p>Not just a bigger display. A&nbsp;better display.It’s one thing to make a bigger display. It’s something else entirely to make a bigger Multi‑Touch display with brilliant colors and higher contrast at even wider viewing angles. But that’s exactly what we did with the new Retina HD display.</p>\r\n<p>Hugely powerful. Enormously eﬃcient.Built on 64-bit desktop-class architecture, the new A8 chip delivers more power, even while driving a larger display. The M8 motion coprocessor efficiently gathers data from advanced sensors and a new barometer. And with increased battery life, iPhone 6 lets you do more, for longer than ever.</p>\r\n<p>The camera that changed photos now does the same for&nbsp;video.More people take more photos with iPhone than with any other camera. And now the iSight camera has a new sensor with Focus Pixels and new video features, like 1080p HD at 60 fps, slo-mo at 240 fps, and time-lapse video mode. So you’ll have more reasons to capture more moments on video, too.</p>\r\n<p>Faster wireless. Far and wide.iPhone 6 has faster 4G LTE download speeds,* and it supports more LTE bands than any other smartphone to give you better roaming. And when connected to Wi-Fi, you’ll get up to 3x faster speeds.</p>\r\n<p>Security. Right at your fingertip.The breakthrough Touch ID technology lets you securely access your iPhone with the perfect password: your fingerprint. You can also use it to approve purchases or downloads from iTunes, iBooks, and the App Store without having to enter your password.</p>\r\n<p>The biggest iOS release ever.iOS 8 is the world’s most advanced mobile operating system. And with incredible new capabilities and features designed to make the most of a larger display, iOS 8 doesn’t just work seamlessly with iPhone 6. It makes every experience feel bigger and better.</p>\r\n','','filtered_html'),('node','product',0,45,45,'und',0,'<p><strong>Galaxy Note 4 Size &amp; Display</strong><br />\r\nThe phone measures 153.5 x 78.6 x 8.5 mm. The screen size remains the same as its predecessor, the Note 3, at 5.7-inches using the familiar Super AMOLED display with its over-saturated, bright colors. The resolution has been beefed up to “Quad HD” which is a resolution of 1,440 x 2,560 pixels and 515 ppi. For comparison, the Note 3 has a 1080p display of 1,080 x 1,920 pixels and 386 ppi. Because of this, the latest Note 4 is even sharper.</p>\r\n\r\n<p>The thickness of the device is still 0.33-inches, but the weight is 176 grams which makes it a bit more noticeable. This isn’t much of an issue though because unless you have very large hands, holding the Galaxy Note 4 comfortably and safely is usually a two-handed job anyway.</p>\r\n\r\n<p>&nbsp;</p>\r\n\r\n<p><strong>Processor, Memory &amp; Battery</strong><br />\r\nThe speed of the Galaxy Note 4 is impressive with one of the fastest quad-core chip-sets on the market: The Qualcomm Snapdragon 805 Krait 450 processor running at an impressive 2.7 Ghz. A 3200 mAh battery is provided to handle the more demanding QHD display and faster processor. The ability to load many complex apps is also provided for with 3GB of RAM memory which should be sufficient.</p>\r\n\r\n<p><strong>Android &amp; TouchWiz</strong><br />\r\nAndroid 4.4.4 KitKat is supplied. Not quite the Android 4.5 one would have hoped to see but the Samsung TouchWiz skin probably hasn’t been updated for that yet. Hopefully buyers of the Galaxy Note 4 will be able to upgrade the OS post-purchase. The main benefit of Android 4.5 is the remote “kill switch” to turn off the phone if it were stolen or lost.</p>\r\n\r\n<p>The stylus and software for the Note 4 is much the same. For people who love using the stylus, this version of the Note model won’t be much of a departure.</p>\r\n\r\n<p>&nbsp;</p>\r\n\r\n<p><strong>Internal &amp; External Storage</strong><br />\r\nThe internal storage is offered in a single 32GB configuration with a microSD card slot capable of handling up to 64GB cards. This is disappointing given that the Galaxy S5 can accept 128GB microSD cards and one would have expected the flagship Note 4 to offer the same storage capacity especially given the fact that it packs a super HD camera.</p>\r\n','','filtered_html'),('node','product',0,46,46,'und',0,'<p>Meet the world’s first All-in-One PC to feature all the performance of Windows 8 desktop and the flexibility of a tablet. ASUS Transformer AiO is perfect for productivity, but detach its 18.4-inch Full HD display and it instantly transforms into a multi-touch Android tablet.</p>\r\n\r\n<p><strong>ASUS desktops – leading in satisfaction with reliability</strong><br />\r\nASUS computers reflect a tradition of the finest quality, innovation and longevity. Based on the PCWorld USA 2012 reader survey of tech satisfaction, reliability, and service, users ranked ASUS as a leading choice for desktop PCs, citing high satisfaction with their value, connectivity, ease of use and reliability. The survey also found ASUS desktop PCs were one of the most likely to be recommended to others.</p>\r\n\r\n<p><strong>Windows 8 All-in-One PC</strong><br />\r\nWith a 3rd generation Intel Core i7 processor and powerful discrete graphics, ASUS Transformer AiO packs enough desktop PC performance for even the most demanding applications.</p>\r\n\r\n<p><strong>Enjoy Windows 8 anywhere in the home</strong><br />\r\nWith ASUS Transformer AiO, you don’t have to sacrifice powerful desktop performance just for the sake of the portability. Just grab the convenient handle and detach the 18.4-inch display from the PC Station for a fast and fluid Windows 8 experience, anywhere in the home. Wireless Remote Desktop technology gives complete control over Windows 8 on the PC Station with the multi-touch tablet, over any standard Wi-Fi connection.</p>\r\n\r\n<p>Connect the PC Station and Tablet to the same Wi-Fi access point to enjoy seamless data transmission. For faster connections, 5GHz networking is recommended, supported by the dual-band wireless capabilities of the PC station and tablet. It significantly reduces interference from nearby 2.4GHz networks and devices, resulting in better Wi-Fi.</p>\r\n','','filtered_html'),('node','product',0,47,47,'und',0,'<p><p><strong>Lenovo A316</strong> is a dual-core 3G smartphone with fashionable style and cost-effective price. It runs on Android operating system 2.3.6 OS and is operated by MTK6572, dual core, 1.3GHz CPU, Mali-400 GPU and 512MB RAM to make sure switching between applications and functions can be done smoothly.</p>\r\n<p><strong>Double SIM</strong><br />\r\nIt supports double SIM card and completely suitable with globally quad-band GSM and WCDMA 3G systems for making telephone calls. The 4.0 inches display with capacitive touch style lets you make the most out of the entertainment features like watching videos and playing your favourite mobile games.</p>\r\n<p><strong>Air Gesture</strong><br />\r\nWhat’s particularly eye-catching is the mobile phone’s Air-Gesture function, which makes viewing files, skipping tracks and switching pages easier. All you have to do is wave your hand over the screen to browse the previous or next pictures in Gallery, switch to the next song in music player and switch to another page on the Home or menu screen.</p>\r\n<p><strong>Simple Yet Powerful</strong><br />\r\nLenovo A316 is equipped with all the important features that you need in a phone. It supports WiFi and WCDMA 3G systems for browsing internet and data transfer as well as hands-free devices. With a built-in GPS processor for simple and easy routing, you will be able to get direction easily. Besides that, it is also equipped 2MPcamera for capturing great moments of your life. Get yours today!</p>','','filtered_html'),('node','product',0,48,48,'und',0,'<p>Connectivity. Convenience. Class. Imagine all the Cs in the palm of your hands. You want your phone to do everything. You want it to make life easier, but you\'d want it to look good as well. All this is made possible with the Nokia Asha 206 Dual Sim.</p>\r\n\r\n<p><strong>See and Be Seen</strong><br>A big, bright 2.4\'\' screen and tactile, well-spaced keys make the Nokia 206 Dual SIM a joy to use. It looks good too, combining clean, elegant design with a choice of striking colours.</p>\r\n\r\n<p><strong>Big Screen </strong><br>With the Nokia 206 Dual SIM, fun is never far away. Some of the hottest games around are included for free, including Bejeweled, Need for Speed Shift and Medal of Honor. It also comes with Tunewiki Social Player and the Pictelligent camera app.</p>\r\n\r\n<p><strong>Sharing Made Simple</strong><br>Friends are close at hand too, with Facebook, Twitter and eBuddy apps, while Slam makes sharing photos and other content simple. There\'s no complicated pairing process, just touch your Nokia 206 Dual SIM to any Bluetooth phone to transfer content.</p>\r\n\r\n<p><strong>Browsing At Its Best</strong><br>To help you put that large 2.4\'\' screen to good use, the Nokia 206 Dual SIM comes loaded with the Nokia Xpress Browser. More efficient than other browsers, it lets you enjoy an easier, more enjoyable and more affordable internet experience.</p>\r\n','','filtered_html'),('node','product',0,49,49,'und',0,'<p><strong>Retina Display</strong><br />\r\nFour times more pixels than iPad 2. Razor-sharp text. Richer colors. The Retina display transforms the entire iPad experience. So everything looks and feels incredibly lifelike and perfectly detailed</p>\r\n\r\n<p><strong>Performance</strong><br />\r\nThe A5X chip with quad-core graphics drives four times the pixels of iPad 2 yet it delivers the same smoothness and fluidity iPad is known for. Even with all that extra oomph, the new iPad still gets an amazing 10 hours of battery life</p>\r\n\r\n<p><strong>iSight Camera</strong><br />\r\nThe 5-megapixel iSight camera features a backside illumination sensor that captures great-looking pictures whether by sunlight or candlelight. Autofocus, tap to focus, and tap to set exposure functions mean every photo you take instantly becomes a frameworthy gem. And with built-in face detection that automatically balances focus and exposure across up to 10 faces, there’s more room for more grins. So everyone look at iPad and say “Cheese.”</p>\r\n','','filtered_html'),('node','product',0,50,50,'und',0,'<p><strong>The ASUS MeMO Pad 7</strong> was created for those looking for a value tablet. The 7-inch ASUS MeMO Pad 7 punches well above its weight, boasting features and specifications more commonly found on high-end tablets.</p>\r\n\r\n<p>Excellent image quality comes from superb technology. ASUS MeMO Pad 7 includes comes with best technology that combines software and optical design to deliver incredible images. Best of all, it\'s with you all the time to capture every moment.</p>\r\n','','filtered_html'),('node','product',0,51,51,'und',0,'<p>THE MINI-TABLET WITH A QUAD-CORE PROCESSOR.A 8\" Windows 8 tablet with an Intel® Atom™ Processor, the Lenovo Miix 2 is perfect for on-the-go entertainment or productivity.</p>\r\n\r\n<p><strong>Full HD (1280x800) Display With IPS Technology</strong><br />\r\nThe vibrant 8\" wide-view display uses In-Plane Switching (IPS) for vivid colors and nearly 180-degree viewing angles.</p>\r\n\r\n<p><strong>Five-Finger Multitouch Technology</strong><br />\r\nSeamlessly integrate with Windows 8 and enjoy more precise control.</p>\r\n\r\n<p><strong>Optional Detachable Cover With Stylus</strong><br />\r\nProtect your screen when not in use, or use the cover to hold the tablet upright in stand mode. And with included stylus pen, you can take notes, edit documents or simply doodle on-the-go.</p>\r\n\r\n<p><strong>Integrated Webcam</strong><br />\r\nThe 2MP front camera and up-to-8MP rear camera will help you enjoy web conferences or online video chats like you\'re really there.</p>\r\n\r\n<p><strong>Veriface™ Face Recognition Software</strong><br />\r\nYour face is your password. The integrated webcam uses stored images of your face to allow you to login quickly and easily, and the program supports multiple users, allowing you to authorize access for the entire family.</p>\r\n','','filtered_html'),('node','product',0,52,52,'und',0,'<p>Presenting the brand new iPad Air, unbelievably thin and light yet packs so much more power and capabilities than ever before. Featuring the latest A7 chip, advanced wireless, and great apps for your entertainment, productivity and creativity – all beautifully integrated with the iOS 7.</p>\r\n\r\n<p><strong>Amazingly Thin &amp; Light</strong><br>Through a series of vigorous refinements, Apple has managed to drop the iPad Air’s volume close to a quarter of the volume of the previous generation iPad. However, when you hold the iPad Air for the first time in your hands, you will feel how durable and elegantly designed it is. The unibody construction provides amazing strength and simplifies the enclosure which the results is an iPad that not feels amazing to hold but is also easy to take around with you no matter where you go.</p>\r\n\r\n<p><strong>Stunning Display</strong><br>The stunning Retina display is included in the iPad Air and it looks amazing as ever. The iPad Air retains the same 9” display but now has thinner side bezels and a narrower width overall. Although a subtle change, it makes a dramatic difference for your content viewing pleasure and with Retina display, everything seems to just pop out. Using a touch-rejection algorithm, iPad Air recognizes if your thumb is simply resting on the display while you’re holding it or if you’re intentionally interacting with the Multi-Touch screen.</p>\r\n','','filtered_html'),('node','product',0,53,53,'und',0,'<p>Experience the protective new bumper case. The Neo Hybrid™ for the Galaxy Note 4 is a completely reimagined dual layer bumper style case that provides full coverage of your Note 4. It is composed of a UV-coated hard polycarbonate frame and a high-polymer-coated soft TPU cover. The TPU casing has a textured midsection for grip and embedded accent lines for a quality look. The buttons are metallized for a premium look and engaging experience. &nbsp;The inner web-patterned TPU helps absorb and disperse the impact from drops and bumps.</p>\r\n\r\n<ul>\r\n	<li>Advanced Shock Absorption Technology: Web Pattern TPU case</li>\r\n	<li>Matte TPU and Polycarbonate for drop and scratch protection</li>\r\n	<li>Slim and form fitted to show the perfect shape of your device</li>\r\n	<li>Metallic finish to frame &amp; metallized polycarbonate buttons</li>\r\n	<li>Lay on the table design: 0.8mm lip for optimal screen protection</li>\r\n	<li>Compatible with Samsung Galaxy Note 4 Only - 2014</li>\r\n</ul>\r\n','','filtered_html'),('node','product',0,54,54,'und',0,'<p><strong>Samsung S View Cover Case for Galaxy Note 4</strong><br />\r\nThe Samsung S View Cover Case for Galaxy Note 4 protects your screen when it is not in use and is easily flipped open for full access to the screen. When closed, the S View cover offers instant access to critical features, thanks to the Samsung ID chip. View the home screen to check the time, weather and other status items. Accept or reject incoming calls with just a swipe, or reject calls with a preset message. Control your music playback directly on the S View screen. If you miss anything, notifications are shown in the recent activity menu of your S View cover unless phone security settings are activated. Swipe left to quickly access your phone\'s camera without opening the cover to take pictures or video right in the moment.</p>\r\n\r\n<p><strong>The Perfect Combination of Style and Functionality</strong><br />\r\nThe Samsung Galaxy Note 4 S View Cover was developed with your busy lifestyle in mind. This smart case, designed to protect and enhance the Samsung Galaxy Note 4, is the perfect combination of style and functionality. Not only is the S View Cover available in multiple attractive colors, the built-in intelligent color system recognizes the case color and automatically matches the view window background with a complementary color for a personalized look. You can even upload your own image for added customization. And with the innovative S View design, you will never miss important information.</p>\r\n','','filtered_html'),('node','product',0,55,55,'und',0,'<p>The Samsung Galaxy Tab 7.0 Plus Vehicle Dock With In Car Charger lets you take the brilliance of your Samsung smartphone along for the ride! The custom fitted cradle holds the handset securely during long rides. Attach it to a windshield or dashboard and adjust the multi-angle neck for perfect viewing.</p>\r\n\r\n<p>GPS capabilities are optimized with navigation applications but that’s just the beginning with the endless Android apps available. With your hands safely on the steering wheel, experience the convenience of powerful, voice-activated Android applications like S Voice. Your Samsung smartphone and Vehicle Navigation Mount duo is truly brilliance on the go.</p>\r\n','','filtered_html'),('node','product',0,56,56,'und',0,'<p><strong>Mobile yourself with Newly</strong></p>\r\n\r\n<p><strong>Newly iShop</strong><br />\r\nNewly iShop is an online store located in Malaysia. They provide ultimate shopping destination online, providing items of the latest trend, computer accessories, home and living, and Mobile Accessories at affordable price. And since people love Mobile just as much as they do, Newly ALWAYS on the hunt for the newest, drool worthy pieces to bring you. Combining style with quality materials, only the most convenience mobile accessories are sourced from around the globe.</p>\r\n','','filtered_html'),('node','product',0,57,57,'und',0,'<p>Unlike traditional, circular earbuds, the design of the new Apple EarPods is defined by the geometry of the ear. Which makes them more comfortable for more people than any other earbud-style headphone. The speakers inside Apple EarPods have been engineered to minimize sound loss and maximize sound output. So you get high-quality audio that’s just as impressive as what you’d hear from more expensive headphones.</p>\r\n\r\n<p>The Apple EarPods with Remote and Mic also include a built-in remote that lets you adjust the volume, control the playback of music and video, and answer or end calls with a pinch of the cord.</p>\r\n','','filtered_html'),('node','product',0,58,58,'und',0,'<p>Easier than connecting a cable. Touch once to pair your smartphone with your wireless headset*. If the devices have been disconnected, touch once to re-connect. NFC is pure magic.</p>\r\n\r\n<p><strong>Sound clarity</strong><br>An easy-to-use wireless stereo headset from Sony, with straightforward call keys and music controls. Enjoy the rich bass and dynamic sound of this impressive headset. Let HD Voice give the person you are calling an in-the-room experience*. Bluetooth wireless technology lets you move freely and enjoy all the audio in your smartphone. At a distance.</p>\r\n\r\n<p><strong>Design</strong><br>Sony Stereo Bluetooth Headset SBH20 comes in several colours. It has a secure and rotatable clip that lets you wear your mobile phone headset as you want. An ergonomic sliding power key and large tactile music control keys add extreme ease to subtle style.</p>\r\n','','filtered_html'),('node','product',0,59,59,'und',0,'<p>Prepare to experience one of the most advanced powerbanks for all generations of iPad, iPhone, iPod, Samsung devices, HTC, Blackberry and other USB related devices. Introducing the&nbsp;TOP Mi&nbsp;Powerbank 10,400mAh Powerbank. With a capacity of 10,400mAh, this powerful charger will ensure that your smart phones or digital devices be fully charged and ready to use! No need to worry about running out of battery after a long day at work, take efficiency to a whole new level with the&nbsp;TOP Mi&nbsp;PowerBank. So what are you waiting for? Get it now while stocks last!</p>\r\n<p><strong>Useful features for your everyday electronic needs</strong>It is always frustrating when you find yourself in a situation where your smart phone or digital device has run out of battery, especially when you need it the most! With the&nbsp;TOP Mi&nbsp;Powerbank, you never have to get caught in such a predicament ever again! The light indicator is a convenient feature that lets you know when your device has been fully charged and ready to be used to its maximum potential!</p>\r\n','','filtered_html'),('node','product',0,60,60,'und',0,'<p>In this modern digital life today, power bank is just another necessary accessory that most people would need. Imagine having a charging device without the need of carrying the charging cables and connectors that you often forget! Power bank is just super-duper handy especially when you are always out travelling on the road.</p>\r\n\r\n<p><strong>Power Bank</strong><br />\r\nUniversal Power Bank is where power is stored in one compact little tool and can endlessly charge your gadgets on the road conveniently. It’s a mobile power source that enables you to store a huge amount of power and charge your gadgets without you having to look for plugs!</p>\r\n\r\n<p><strong>Incredible Performance</strong><br />\r\nThis power bank is capable of storing up to 20,000mAh power supply which is enough to fully charge your iPhone multiple times! It is built with high quality grade A batteries to ensure an assurance use. Apart from charging your gadgets conveniently, its dual USB jacks are compatible for almost all brands and gadgets!</p>\r\n','','filtered_html'),('node','product',0,61,61,'und',0,'<p>The Symbol of Everlasting Love - is formed from two “bi-skeles”. The bi-skeles, two cornered knots, denote the aspects of two people, mind and spirit. The symbol looks like an “S”, joined together, the everlasting circle of eternity. Thus the figure represents two people, joined in mind and spirit in everlasting love.&nbsp;</p>\r\n\r\n<p><strong>MuWo Trendz Philosophy</strong><br />\r\nJewellery manufacturing process includes most advance technologies and dedicated research. Each product undergoes a series of procedures before we get the net product as a beautiful jewellery. The natural components of jewellery will undergo multiple processes, most jewelleries are executed by casting machines unless those specifically handcrafted ones, which is exceptional in quality.</p>\r\n\r\n<p><strong>MuWo Trendz Jewellery</strong> has two unique grades. Normal grade with a lower price point which is good for most occasion with 2 layer polishing. The premium class undergoes 4 polishing processes and has a finer and smoother finishing for all occasion. No matter what you’re looking for, we have both grades of similar design to choose from. Finally the plating process finishing off the Jewellery to be ready for the big occasion.</p>\r\n','','filtered_html'),('node','product',0,62,62,'und',0,'<p>Power your ensemble with this incredible multi color tribal necklace from Luccacal. Linger this statement necklace over a simple tee or match it to a favorite dress.</p>\r\n','','filtered_html'),('node','product',0,63,63,'und',0,'<p>If you have to share anything in your wardrobe with your girlfriends, then this Dandelion Women Braided Belt would be the perfect calling for it. The interlaced nature of the belt makes it great for anyone – there’s no specific holes on a solid surface, just find one in between the braids to suit your size! This belt is great for a hippie-inspired look for a casual day out with your loved ones.</p>\r\n\r\n<p><strong>For the Child of Spring</strong><br />\r\nWalk through the colours of the wind with Dandelion’s range of fashion accessories, exclusively designed to enhance youthful, peace-loving personalities like yourself. Choose from figure definitive belts, beautiful flowy pastel scarves, eye-opening sunglasses to a wide array of jewelleries to adorn. Bring out the child of spring in you and enjoy the warmth of the sunshine with Dandelion.</p>\r\n','','filtered_html'),('node','product',0,64,64,'und',0,'<p>This beautifully crafted belt can be styled loose or as per usual basis to compliment the outfit of your choice. The Dandelion Cross Stitch Belt is a great addition to the colour blocking trend thanks to its solid colours and unique stitching design. Made to fit all sizes possible, the Dandelion Cross Stitch Belt is suitable for all occasions.</p>\r\n\r\n<p><strong>For the Child of Spring.</strong><br />\r\nWalk through the colours of the wind with Dandelion’s range of fashion accessories, exclusively designed to enhance youthful, peace-loving personalities like yourself. Choose from figure definitive belts, beautiful flowy pastel scarves, eye-opening sunglasses to a wide array of jewelleries to adorn. Bring out the child of spring in you and enjoy the warmth of the sunshine with Dandelion.</p>\r\n','','filtered_html'),('node','product',0,65,65,'und',0,'<p>Accessories are just as important as the clothes you put on and the shoes on your feet. The beauty of accessories is that they are inexpensive and with just several pieces, you could update the look of the clothes you have in your wardrobe without draining your wallet. You could be surprised how a piece of accessory can change an entire look. Whether you have Carrie\'s style of funky and eclectic or Charlotte\'s sophisticated elegance, there\'s always a piece of accessory to suit your signature identity and to flaunt an offbeat style statement. Add up some glam slam to your outfit with Fur Nyce Accessories.</p>\r\n\r\n<p><strong>Features</strong><br />\r\nAdd some wildness to your plain outfit with Fur Nyce Big Square Classic Chain Pattern Print Scarf. The scarf features classic chain pattern print and comes in plain yellow, brown and ivory in colour. The scarf is made of high quality, breathable cotton blends fabric.</p>\r\n\r\n<p><strong>About Fur Nyce Accessories</strong><br />\r\nFUR NYCE Accessories offers sparkling fashion jewelries and accessories in various shapes and styles. You are sure to build a staple collection of accessories that you could go back to time and time again. From classic to the trendiest style, you will definitely find the right piece at FUR NYCE Accessories from its massive style of fashion accessories with excellent value, high quality, and always on trend.</p>\r\n','','filtered_html'),('node','product',0,66,66,'und',0,'<p>Accessories are just as important as the clothes you put on and the shoes on your feet. The beauty of accessories is that they are inexpensive and with just several pieces, you could update the look of the clothes you have in your wardrobe without draining your wallet. You could be surprised how a piece of accessory can change an entire look. Whether you have Carrie\'s style of funky and eclectic or Charlotte\'s sophisticated elegance, thereﾒs always a piece of accessory to suit your signature identity and to flaunt an offbeat style statement. Add up some glam slam to your outfit with Fur Nyce Accessories.</p>\r\n\r\n<p><strong>Features</strong><br />\r\nAdd some wildness to your plain outfit with Fur Nyce Fashion Zebra Pattern Print Scarf. The scarf features zebra pattern print and comes in plain white in colour. The scarf is made of high quality, breathable cotton viscose fabric.</p>\r\n\r\n<p><strong>About Fur Nyce Accessories</strong><br />\r\nFurnyce Accessories offers sparkling fashion jewelries and accessories in various shapes and styles. You are sure to build a staple collection of accessories that you could go back to time and time again. From classic to the trendiest style, you will definitely find the right piece at FUR NYCE Accessories from its massive style of fashion accessories with excellent value, high quality, and always on trend.</p>\r\n','','filtered_html'),('node','product',0,67,67,'und',0,'<p>Once a marker of time, watches now have moved on to being a marker of personality. A watch is no longer just an accessory, it represents your personality and sense of style. Invicta, the watch for modern person, driven, elegant, classy, stylish, tough, invisible.</p>\r\n\r\n<p>A durable timepiece technology packed in a stainless steel strap and a black dial, the Invicta 15422 is intended for the man who appreciates the finer aspects of life. It has a flame fusion crystal glass and is water resistant up t0 10 ATM. Enjoy life in style and elegance with the Invicta 15422.</p>\r\n\r\n<p><strong>About Invicta</strong><br />\r\nIn the little town of Chiasso, Switzerland, was Invicta founded in 1837 and nurtured to where it stands today. Legendary for its consistence in quality and brand personality, Invicta resurfaced in the early 1990’s after a short disappearance during the quartz movement in the 1970’s. Innovative in style and construction, Invicta’s timeless masterpieces exudes an aura of class and elegance from its owner. Invicta, invincible through time, creating an immortal experience.</p>\r\n','','filtered_html'),('node','product',0,68,68,'und',0,'<p><strong>The Rolex Submariner</strong> is the indispensable instrument for every diver. Introduced in 1953, it was the first watch to be water-resistant to 100 meters (330 feet) during the pioneering era for scuba diving. This iconic timepiece exemplifies Rolex’s technical innovations and impeccable craftsmanship.</p>\r\n\r\n<p>Dial Type: Analog. Luminescent hands and markers. Automatic movement. Scratch resistant sapphire crystal. Screw down crown. Solid case back. Case diameter: 40 mm. Round case shape. Oyster clasp. Water resistant at 300 meters/ 1000 feet. Functions: hour, minute, second. Luxury watch style. Watch label: Swiss Made. Rolex Submariner Black Dial Stainless Steel Automatic Mens Watch 114060.</p>\r\n','','filtered_html'),('node','product',0,69,69,'und',0,'<p><strong>SUUNTO VECTOR - THE MOUNTAIN WATCH</strong> after a decade of travels, adventures and courageous expeditions,&nbsp;Suunto Vector is still the most legendary watch with an altimeter,&nbsp;barometer and compass. With the technology and durability that&nbsp;can take on the harshest of environments, it is the choice&nbsp;of professionals.</p>\r\n','','filtered_html'),('node','product',0,70,70,'und',0,'<p><strong>General</strong></p>\r\n\r\n<ul>\r\n	<li>Brand: SKMEI</li>\r\n	<li>Model: 955</li>\r\n	<li>Quantity: 1Piece</li>\r\n	<li>Color: Black + Green</li>\r\n	<li>Casing Material: ABS+PU</li>\r\n	<li>Wristband Material: Rubber</li>\r\n	<li>Suitable for: Adults</li>\r\n	<li>Gender: Men</li>\r\n</ul>\r\n\r\n<p>&nbsp;</p>\r\n\r\n<p><strong>Specification</strong></p>\r\n\r\n<ul>\r\n	<li>Style: Wrist Watch</li>\r\n	<li>Type: Sports watches</li>\r\n	<li>Display: Analog + Digital</li>\r\n	<li>Backlight: Blue</li>\r\n	<li>Movement: Digital + Quartz</li>\r\n	<li>Display Format: 12/24 hour time format</li>\r\n	<li>Water Resistant: 30m Water Resistant</li>\r\n</ul>\r\n\r\n<p>&nbsp;</p>\r\n','','filtered_html'),('node','product',0,71,71,'und',0,'<p>Looking for the best LED TV in town? Well look no further, the Samsung 40\" Full HD LED TV Series 5 is here. It has an outstanding picture with deep black levels, precise color and great bright-room viewing qualities. Its styling is drop-dead gorgeous, and the slim sophisticated design lends a unique, ultramodern look. A great all rounder that fits perfectly on any wall. A thing of a beauty.</p>\r\n\r\n<p><strong>Discover a new reality in Full HD</strong><br />\r\nEnjoy a greater level of home entertainment realism than ever before. Thanks to a resolution twice as high as standard HD TVs, your Samsung FHD TV delivers a breathtaking viewing experience that takes you beyond the screen into a world of total immersion. When you’ve seen the rich and vivid texture of Full HD images, your favourite TV programs and movies will never be the same again. Discover reality with a full high definition experience.</p>\r\n\r\n<p><strong>All the excitement of the big match with Soccer Mode</strong><br />\r\nWith Soccer Mode, it’s like you’re actually at the match. It sharply and vividly brings out the green grass of the pitch and all the other colours of the stadium. A powerful multi-surround sound effect also lets you hear all of the excitement. You can even zoom in to selected areas of the screen for a better view. With just a push of a button you can make the most of your favourite sport with all your friends.</p>\r\n\r\n<p><strong>More vibrant colours for better images</strong><br />\r\nUsing an advanced picture quality improvement algorithm, Samsung’s Wide Colour Enhancer Plus drastically improves the quality of any image and uncovers hidden details. Now see colours as they were meant to be seen with Wide Colour Enhancer Plus.</p>\r\n\r\n<p><strong>Watch movies from your USB</strong><br />\r\nWith ConnectShare Movie, simply plug your USB memory drive or HDD into the TV and instantaneously enjoy movies, photos or music. Now, you can experience a wide variety of content in the comfort of your living room on your TV.</p>\r\n','','filtered_html'),('node','product',0,72,72,'und',0,'<p>For a clearer, sharper, and overall better performing full HD LED TV, the Sony 48\" Full HD LED Smart TV is the one and only choice to which will suit your preference.</p>\r\n\r\n<p><strong>High Resolution Display</strong><br />\r\nThe Sony 48” Full HD LED Smart TV comes with a Clear Resolution Enhancer, which has a superior noise reduction feature while maintaining clear, crisp moving images and natural pictures. With such and in-depth approach to realism and its eye to detail, Sony proves that you can bring lifelike picture quality into the TV.</p>\r\n\r\n<p><strong>New Generation of DVB</strong><br />\r\nThanks to the DVB-T2 (Digital Broadcasting Standard) installed into the Sony 48” Full HD LED Smart TV, you can now experience even better picture and sound quality compared to the standard DVB. It even grants greater flexibility and robustness when accessing HD programmes.</p>\r\n','','filtered_html'),('node','product',0,73,73,'und',0,'<p>Whether you enjoy movies, or sports, or listening to song on a grand scale, this superb home solution by Sony is definitely worth your attention. This Blu-Ray Home Theater system by Sony will take you away from your living room. Its 9.1 channel will stream high definition audio from all angles, including from the top. It will also mute the commentators as you watch your favorites teams play, making you feels as though you’re in the stadium yourself. The Sony BDV-N9200W is here to impress.</p>\r\n\r\n<p><strong>Sony audio&nbsp;</strong><br />\r\nThis Sony BDV-N9200W system will resonate high definition audio that will cater to your listening preference, taking your senses to greater levels.</p>\r\n\r\n<p>Compared to previous CD-quality, this superior solution provides subtle details that were once hidden away. Listen to greater detail and appreciate music in its purest form.&nbsp;</p>\r\n','','filtered_html'),('node','product',0,74,74,'und',0,'<p>Do you feel unsatisfied with the current audio in your house when you’re watching your favourite fighting scene in an action movie? You want to feel like you are in the movie itself, feeling the adrenaline rushing through your body, your heart thumping like mad when you turn on the volume high, ready to indulge in the fighting scene? So here’s the solution! It will be made possible with this home theatre set from Samsung.</p>\r\n\r\n<p><strong>Powerful Audio </strong><br />\r\nMake the most of your home entertainment with this DVD Home Theater System which offers a full range of sound and visual quality. A built-in front-firing subwoofer at the bottom of the speaker delivers rich and deep low-end tones to ensure TV programmes, music and movies are vivid and immersive. Unlike comparable products, you won’t have to buy costly additional equipment for powerful audio.</p>\r\n\r\n<p><strong>Sing Your Heart Out </strong><br />\r\nYour Samsung Home Entertainment System has all you need to enjoy cinematic sound and magnificent music in the comfort of your living room as this model comes with karaoke scoring, mic plus music usb record with cd disc, mic jack, mic volume, fanfare and my karaoke.</p>\r\n','','filtered_html'),('node','product',0,75,75,'und',0,'<p>Many people have their phones in their hand bags and don\'t feel the vibration or even hear their ring tone in busy areas. With this awesome bracelet you can have a wearable fashion accessory and never miss a call again. Caller ID and LED Time Display This beautiful bracelet also displays the caller ID, so you can see the phone number of the person calling, instead of having to struggle opening your bag in a busy area, you can instantly tell if the call is important or not. Another great feature of this bracelet is that it features a time display.Unlike most wireless techniques, bluetooth uses time division duplex to arrange the transmission slots so that it can avoid collision.The top-rated 250mAh battery enables you run into the bracelet for 168 hours constantly.It is also the best gift for your family and friends.</p>\r\n','','filtered_html'),('node','product',0,76,76,'und',0,'<p><strong>Big-time entertainment. One small box.</strong><br />\r\nApple TV gives you access to the best content — blockbuster movies, sports, your music and photos, and more — right on your HDTV.1 You can even play content from your iOS devices on your TV wirelessly using AirPlay.</p>\r\n\r\n<p><strong>Quick and easy setup.</strong><br />\r\nJust plug in the power cord and connect Apple TV to your HDTV with a single HDMI cable (sold separately). If you have an iPhone or iPad, hold it near Apple TV, and Apple TV will learn about your home network and receive your iTunes account settings automatically.</p>\r\n\r\n<p><strong>AirPlay.</strong><br />\r\nAirPlay lets you wirelessly stream what’s on your Mac or iOS device to your HDTV and speakers via Apple TV. Or mirror exactly what’s on your device\'s display to the big screen.</p>\r\n\r\n<p><strong>iCloud.</strong><br />\r\nWith iCloud, you can buy movies on Apple TV and watch them on your iPad, iPhone, iPod touch, Mac, or PC. And vice versa. iCloud also stores your photos and videos, pushing them wirelessly to all your devices — including your HDTV.</p>\r\n\r\n<p><strong>Your photos and videos.</strong><br />\r\nWith My Photo Stream, your most recent photos and videos automatically appear on your Apple TV. And thanks to iMovie Theater, the projects you’ve made in iMovie are ready for viewing on the big screen.</p>\r\n\r\n<p><strong>YouTube, Vimeo, MLB and more.</strong><br />\r\nWatch hit movies, live sports, breaking news, the latest viral videos, and more from some of the biggest names in entertainment.</p>\r\n','','filtered_html'),('node','product',0,77,77,'und',0,'<p><strong>Very compact in size that can fit any places.</strong></p>\r\n\r\n<p><strong>Features &amp; Design</strong><br />\r\nAvailable with Windows 8 - for a smooth, versatile PC experience.Get the Windows 8.1 update:</p>\r\n\r\n<p>Increase productivity with a free update from the Windows Store for great new apps and features.</p>\r\n\r\n<p><strong>Virtual design for virtually any space </strong><br />\r\nEasily bring high performance PC gaming into any room in your house. Whether you’re connected to a monitor or an HDTV, the versatile Alienware X51 lets you experience big-screen gaming wherever you want it.</p>\r\n\r\n<p><strong>Mind-blowing visuals and sound</strong><br />\r\nGaming, movies and other images jump off the screen with the powerful NVIDIA® graphics, Full HD, 3D and Blu-ray capabilities of the Alienware X51. For those seeking a system that can handle high-performance video and audio content creation, look no further than Alienware X51.</p>\r\n','','filtered_html'),('node','product',0,78,78,'und',0,'<p>With a set of correct cables and tools, your devices could work properly and it resulting in very satisfying outcome from your devices. On the other hand, chosing correct cables and tools ensure your devices to last longer. Get it now while the stock last!</p>\r\n\r\n<p><strong>Features</strong></p>\r\n\r\n<ul>\r\n	<li>A device that is used to select a video source for the TV via the HDMI interface.</li>\r\n	<li>For example, a cable box, DVD player and DVR may all have HDMI outputs, but the TV may have only one HDMI input. In this case, a three-port HDMI switch would have three HDMI inputs for the source components and one HDMI output to the TV set. When multiple TVs are used, there are HDMI switches with two or more outputs. The switch may be operated manually, by remote control or automatically by priority.</li>\r\n</ul>\r\n\r\n<p>&nbsp;</p>\r\n','','filtered_html'),('node','product',0,79,79,'und',0,'<p>The Dell 5500 series switches are designed to offer secure, fixed-port Gigabit Ethernet switching solutions to deliver fullwire-speed switching performance. With 24 or 48 built-in copper Gigabit Ethernet ports in a 1U form factor,&nbsp;the 5500 series has a total switching capacity of up to 176 Gbps to support demanding network environments. The switches also offer simple management and scalability via a 40Gbps high-availability stacking architecture that allows you to manage up to eight switches from a single IP address, and share the dual SFP+ across the stack for uplinks to the next layer in your network. The switches are designed for Energy Efficient Ethernet (802.3az), which will reduce per port power consumption up to 50% if the link is idle, and further reduction if ports are inactive.</p>\r\n\r\n<p><strong>Specifications :&nbsp;</strong><br>\r\n\r\n<ul>\r\n	<li>1xPower Cord, 2m, 220V IRE/UK (Malaysia, Singapore, Brunei)</li>\r\n	<li>Lifetime Limited Dell Standard Technical Support</li>\r\n	<li>Lifetime Limited Hardware Warranty</li>\r\n	<li>Layer 2 Managed Gigabit Switches</li>\r\n	<li>Campus-Focused Gigabit Ethernet switch delivering Layer 2</li>\r\n	<li>Available with 24/48 standard Gigabit Ethernet ports or 24/48 Power over Ethernet (PoE) Gigabit Ethernet ports</li>\r\n	<li>Campus stacking capability to simplify deployment and management</li>\r\n	<li>Voice Capability</li>\r\n	<li>MS NAP Certified</li>\r\n</ul>\r\n</p>\r\n','','filtered_html'),('node','product',0,80,80,'und',0,'<p>In this day and age, connection to the Internet is one of the necessities of living in the digital age. With the TP-Link M5250 3G Mobile WiFi, you will always be connected to the Internet no matter where you are – perfect for those always on the move.</p>\r\n\r\n<p><strong>3G Coverage</strong><br />\r\nTP-LINK’s M5250 is at the forefront of wireless 3G sharing, combining the mobility of 3G broadband connections with the flexibility of 802.11n WiFi - No other bulky devices required, simply insert a 3G SIM card to create a 3G Wi-Fi hotspot to share on the move, wherever 3G coverage is available.</p>\r\n\r\n<p><strong>Long Lasting Battery</strong><br />\r\nBattery power is incredibly important especially for a portable mobile device like the M5250. With a 2000mAh battery, the M5250 is capable of operating from 7-10 hours depending on the usage. Even under heavy usage, the device can last up to 6-7 hours tops. Alternatively, you can charge the device via micro USB cable to a laptop or portable charger for endless 3G sharing.</p>\r\n\r\n<p><strong>Lightweight &amp; Portable</strong><br />\r\nThe portable ‘cobblestone’ design of the M5250 makes it very easy to take it along with you to wherever you go. The lightweight yet durable material enables it to withstand light resistance do damage less hassle when travelling.</p>\r\n','','filtered_html'),('node','product',0,81,81,'und',0,'<p><strong>TP-LINK’s TL-WDR4300</strong> is a performance-optimised dual band wireless router that combines the blazing fast speeds of 450Mbps using the crystal clear 5GHz band and 300Mbps using the traditional 2.4GHz band. With five Gigabit ports and 800Mbps+ hardware NAT, your wired devices will have lightning-fast, lag-free connections. Also, 2 USB 2.0 ports capable of sharing flash storage, printers, ftp servers and media players, allowing users to enjoy a robust home media network.</p>\r\n\r\n<p><strong>Concurrent Dual Band Wireless</strong><br />\r\nThe TL-WDR4300 broadcasts and receives both 2.4GHz and 5GHz connections simultaneously at 300Mbps and 450Mbps respective speeds. This allows users to run day-to-day applications, such as e-mail and web browsing over the 2.4GHz band at 300Mbps. At the same time, when running more bandwidth-intensive or latency-sensitive applications, such as streaming HD video or playing online games, users utilise the clearer 5GHz band at 450Mbps.</p>\r\n','','filtered_html'),('node','product',0,82,82,'und',0,'<p>High-Speed, High-Resolution scans from a stylishly slim CIS scanner. The advanced, clip-on scanner stand allows you to operate the scanner in a vertical position, so you need minimal space to scan. But regardless of where you place this sleek, stylish scanner, it looks amazing from any angle.</p>\r\n\r\n<p>Solve all your scanning needs with 5 conveniently located buttons for effortless one-touch operations anyone can use. PDF, copy, scan or email your documents conveniently and directly from the scanning device to your connected PC, streamlining workflow and boosting productivity of daily routine tasks. The last EZ button allows you to create a multi-page PDF file at the touch of a button.&nbsp;<br />\r\nThe scanner is ready to operate the instant they are connected to the PC via USB. Thanks to its energy efficiency that it only takes a single USB connection to power the scanner.</p>\r\n\r\n<p><strong>Upright scanning capability</strong><br />\r\nThe advanced, clip-on scanner stand allows you to operate the scanner in a vertical position, so you need minimal space to scan. But regardless of where you place this sleek, stylish scanner, it looks amazing from any angle.</p>\r\n','','filtered_html'),('node','product',0,83,83,'und',0,'<p><strong>Unsurpassed image quality in high resolution</strong><br />\r\nWith a high resolution of 4800dpi and&nbsp;<a href=\"http://www.epson.com.my/sites/epson_malaysia/explore_epson/innovation/ccd_technology.page\" target=\"_blank\" title=\"Matrix CCD™\">Matrix CCD™</a>, you can be assured that every intricate detail in your images will be captured and preserved. In addition, original colours and details can be accurately reproduced with 48 bit colour depth and embedded ICC profile.</p>\r\n\r\n<p><strong>Customisable one-touch operation for your convenience</strong><br />\r\nFour one-touch buttons on the control panel are pre-defined with Copy, Start, Scan-to-Email and Scan-to-PDF functions. Allocate up to 10 settings effortlessly through Epson Event Manager to suit your personal preferences. Experience customisation at a convenience and versatility like never before.</p>\r\n\r\n<p><strong>Versatility and convenience with a single software Epson Scan v3.9</strong><br />\r\nEpson Scan v3.9 facilitates rotational view of documents and additional language support in searchable PDF. The Auto Area Segmentation function also allows separate scanning of both image and text in a document.</p>\r\n','','filtered_html'),('node','product',0,84,84,'und',0,'<p>With the new EX-ZR1500, taking stunning photos and self-portraits has never been easier. Users can now easily edit their self-portraits according to their preference with the new make-up function that allows adjustment of skin smoothness to 12 levels and enhancement of skin tone according to a scale of six stages from light to tan.</p>\r\n\r\n<p><strong>Easy to see and shoot. LCD tilts to make a snap for self-portraits</strong><br />\r\nThe LCD opens up 180° so you can check your self-portraits as you shoot. It shoots from a variety of angles, letting you get just the right composition. And its built-in camera stand lets you shoot hands-free. Enjoy shooting self-portraits in all kinds of poses.</p>\r\n\r\n<p><strong>The advanced Make-up mode satisfies the pursuit of beauty</strong><br />\r\nAutomatically detects human faces and smoothes and brightens the skin. You can adjust Skin Tone and Smooth Skin to produce the beautiful finish you prefer, whether it is skin with a whitened tone, or lively, healthy skin.&nbsp;</p>\r\n\r\n<p><strong>Art Shot Bracketing lets you encounter the unexpected in one shot</strong><br />\r\nOne click of the shutter creates 5 different styles, lets you try different effects in one go, enhancing the individuality of your photos and changing ordinary shots into artistic ones. It lets you encounter the unexpected in one shot and broaden your photographic expression.&nbsp;</p>\r\n','','filtered_html'),('node','product',0,85,85,'und',0,'<h4><strong>The PowerShot SX60 HS</strong> camera employs a 16.1 Megapixel CMOS sensor. Utilizing a sophisticated light-capturing design, it provides high sensitivity for improved high ISO capture with reduced noise. It is also a high-speed design, capable of rapidly capturing and moving image data to the processor, enabling faster continuous shooting and faster autofocus.</h4>\r\n\r\n<p>The PowerShot SX60 HS camera is equipped with the very latest Canon proprietary processor, the DIGIC 6 Image Processor, which makes several important advancements to image quality both in stills and video. Improved light sensitivity allows for higher resolution with less noise when shooting in dark conditions, and Dynamic IS now detects and compensates for tilt and parallel movement (shift blur) to create video that\'s exceptionally free of distortion. The DIGIC 6 Image Processor also enhances the performance capabilities of the PowerShot SX60 HS, powering full resolution high-speed continuous stills shooting. And video recording is better than ever, as the DIGIC 6 Image Processor enables Full HD at 60p, as well as MP4 recording. Highly compressed MP4 video not only preserves space on your memory card but also improves playback on mobile devices.&nbsp;</p>\r\n','','filtered_html'),('node','product',0,86,86,'und',0,'<p>Dive into the world of photography with the Canon EOS 600D. It is the advanced entry-class DSLR with the cutting edge technology to bring out the inner desire of you. It has 18 megapixels CMOS sensor that able to capture photos with magnificent qualities. The imaging processor is DiG!C 4 for faster and better results in taking shots. The Canon EOS 600D also capable in recording stunning Full HD videos. The 3 inch LCD is adjustable with multiple angles to cope with your shooting skills.<br />\r\n&nbsp;</p>\r\n\r\n<p><strong>18.0-megapixel CMOS sensor</strong><br>\r\nThis camera comes with 18-megapixel CMOS (APS-C-sized) sensor that lets you to capture just about any scenes from vast, breath-taking landscapes to close-up wildlife shots in explicit detail. Photos of 18-megapixel resolution can easily be converted or zoomed in to gallery ready print shots.</p>\r\n\r\n<p><strong>3-inch wide LCD monitor</strong><br>\r\nRecording and playback of images are seamless with the crisp 3-inch wide Vari-Angle Clear View LCD monitor that contains over a million dots. Make full use of the specially designed hinge which can be swivelled in almost any angle to easily frame you subject and find the best angle.</p>\r\n\r\n<p><strong>Scene Intelligent Auto</strong><br>Scene Intelligent Auto is feature that gives better exposure in any picture you took, it will analyse every elements in the photos taken and then it will evaluate and eventually the photo is now seems like auto fixed.</p>\r\n','','filtered_html'),('node','banner',0,87,87,'und',0,'<p>Lorem Ipsum is not simply random text. It has roots in a piece of classical Latin literature from 45 BC, making it over 2000 years old. Richard McClinto</p>\r\n','','filtered_html'),('node','product',0,88,88,'und',0,'<p>It is now easier to capture those fleeting moments of your live wherever you are using just the right lens with Samsung Smart Camera NX Mini. This slim, ultra-portable digital camera measures just 22.5 millimeters wide and can be used with any lens in Samsung\'s NX series. A 3-inch flip-up LCD touch screen is perfect for selfies, while Wi-Fi capability lets you back up photos and videos, post them to social networks, or send them to friends and family.</p>\r\n\r\n<p><strong>Crystal Clear Resolution</strong><br />\r\nSamsung Smart Camera NX Mini comes equipped with 20.5MP BSI CMOS Sensor for high-quality images and life-like colours with crystal clear resolution to perfectly capture your most precious moments. Stylishly slim (22.5mm) and impressively light (158g), this mini camera can perfectly fit your pocket or handbag.</p>\r\n\r\n<p class=\"rtecenter\"><img alt=\"\" src=\"/marketplace/sites/default/files/products/original-samsung-smart-camera-3.png\" /></p>\r\n\r\n<p><strong>Wink Shot</strong><br />\r\nThe NX mini provides a fun and easier way to take your beloved selfies with the wink shot feature. Simply give it a wink, and it will take the shot 2 seconds later. No button necessary. Don\'t forget to smile!</p>\r\n\r\n<p><strong>Get Creative</strong><br />\r\nWhy settle for plain and boring photos when you can work your magic with different special effects available on your Samsung Smart Camera NX Mini? Take your pick from these amazing effects that seamlessly transform each snapshot into a work of art. Display your playful side with Cartoon effect or Oil Paint for days when you feel like creating gallery material masterpiece. Other special effects to choose from are Negative, Vivid, Custom Effect, Fisheye, Soft Focus, Sketch, Landscape, Portrait, Miniature, Calm Classic, Forest, Retro, cross filter, Vignetting, Ink Painting and Zooming Shot.&nbsp;</p>\r\n','','filtered_html'),('node','product',0,89,89,'und',0,'<p>This updated classic with a fast maximum aperture is ideal for everyday shooting, perfect in low lighting situations and great for producing images with beautiful background blur (Bokeh). The AF-S NIKKOR 50mm f/1.8G includes Silent Wave Motor technology (SWM) for fast and precise autofocus, M/A Focus Mode Switch for seamless changes between manual and autofocus operation and an aspherical lens element for outstanding optical performance with high contrast.</p>\r\n\r\n<p><strong>Brilliance in any Light</strong><br />\r\nThis lightweight standard lens is a great travel companion because you never know when a beautiful, sunny day will turn cloudy and rainy. With its fast f/1.8 aperture, the AF-S NIKKOR 50mm f/1.8G will capture even low-light situations with stunning brilliance.</p>\r\n\r\n<p><strong>Beautiful Background Blur</strong><br />\r\nWhether you\'re shooting portraits, food or nature—indoors or outdoors—the AF-S NIKKOR 50mm f/1.8G renders a beautiful, natural background blur (Bokeh) at its wider aperture settings. And its 50mm focal length is perfect for creating natural perspective in your photographs.</p>\r\n\r\n<p><strong>Capture Every Detail</strong><br />\r\nNikon\'s Super Integrated Coating (SIC) enhances light transmission efficiency and offers superior colour consistency and reduced flare, while the AF-S NIKKOR 50mm f/1.8G\'s Aspherical Lens Element (AS) virtually eliminates coma and other types of aberrations, even when shooting at the widest available aperture. Pair that with Nikon\'s Silent Wave Motor (SWM) for fast, accurate and quiet autofocus, and you can be sure all of your portraits will be tack sharp.</p>\r\n','','filtered_html'),('node','product',0,91,91,'und',0,'<p>Kits include a Cokin Z-Pro filter holder and three graduated filters</p>\r\n\r\n<p>GRAD ND/BLUE/ TOBACCO KIT</p>\r\n\r\n<p>filter holder / Grad Grey ND2 (121L), Grad Blue B2 Light (123L)</p>\r\n\r\n<p>Grad Tobacco T2 Light (125L) Code: U961</p>\r\n','','filtered_html'),('node','product',0,92,92,'und',0,'<p>Equipped with a high quality 1.0 lux CMOS sensor, the DCS-5222L delivers exceptional picture quality even in low-light conditions. With built-in Ethernet and Wireless N connectivity options, the DCS-5222L provides easy and flexible installation options. The motorized pan/tilt controls and 10x digital zoom allow you to monitor a large area and zoom to view fine details, and the PIR sensor detects movement in the area and can trigger recordings. The DCS-5222L can record snapshots and video to your computer, a network storage drive, or a microSD card. Camera footage can be viewed remotely through a web browser, or through a mobile device running the mydlinkﾙ app for iOS and Android. Furthermore, the camera provides a Privacy Mode option, which allows you to set a schedule to enter privacy mode, which rotates the lens backwards to protect your privacy.</p>\r\n\r\n<p><strong>Anywhere Access with mydlink</strong><br />\r\nWith the mydlink Lite app for iPhone and Android, you can quickly and easily see your camera feed from anywhere with a Wi-Fi, 3G or 4G connection. No more guessing what\'s going on at your house while you\'re away. Thanks to this app, you can monitor on-the-go... even if you don\'t have access to a computer.</p>\r\n\r\n<p><strong>Sharp Image Monitoring from</strong><br />\r\nDifferent Angles With sharp, responsive pan/tilt movement and digital zoom, the DCS-5222L gives you full control, so you can quickly scan a wide area from a variety of angles, and 10x digital zoom lets you zoom in for more detail.</p>\r\n\r\n<p><strong>HD Video Quality</strong><br />\r\nThe DCS-5222L delivers the confidence of 720P HD video clarity, ensuring rich detail and crisp image quality for your surveillance recordings. And with integrated night-vision and PIR motion-sensing technology, the DCS-5222L remains vigilant 24 hours a day, whether you\'re there or not.</p>\r\n','','filtered_html'),('node','product',0,93,93,'und',0,'<ul>\r\n	<li>1/3\' Super CMOS Dome</li>\r\n	<li>850TVL IR Dome</li>\r\n	<li>24LEDS ,Night View Up to 20M</li>\r\n	<li>High resolution</li>\r\n	<li>Plastic housing black and white</li>\r\n	<li>Lens option: 3.6mm/ 6mm</li>\r\n	<li>Auto Gain Control (AGC)</li>\r\n	<li>Built-in auto gain control (AGC) circuit.</li>\r\n	<li>Gamma Characteristic</li>\r\n	<li>Camera Gamma Characteristic is 0.45</li>\r\n	<li>Scanning Mode</li>\r\n	<li>NTSC or PAL mode</li>\r\n	<li>Night-time Vision</li>\r\n	<li>0 Lux with IR LED ON</li>\r\n</ul>\r\n','','filtered_html'),('node','product',0,94,94,'und',0,'<p><strong>What is an Ai-Ball?</strong><br />\r\nThe Ai-Ball is an ultra-portable, wireless camera module that allows users to view and record audio and video wirelessly on their PC or smartphones.</p>\r\n\r\n<p><strong>Ai-Ball Cradle</strong><br />\r\nPower your Ai-Ball now with the Ai-Ball Cradle, which runs on interchangeable USB, car, and regular AC/DC adapters for round-the-clock Ai-Balling.</p>\r\n\r\n<p><strong>Features:</strong></p>\r\n\r\n<p><strong>Round The Clock Viewing/Recording</strong><br />\r\nChoose from USB, car, or regular AC/DC power to run your Ai-Ball all day long. Just pop your Ai-Ball into the Cradle, adjust its viewing angle and you are all set for Round-the-Clock streaming and recording.</p>\r\n\r\n<p><strong>Wireless</strong><br />\r\nWith its 802.11 b/g Wi-fi interface, the Ai-Ball allows you to stream and record audio video images through your mobile devices such as your smartphones (iPhones or Android devices) and laptops on the go.</p>\r\n','','filtered_html'),('node','product',0,95,95,'und',0,'<p>As a Muslim, it is vital to start educating the children in the arts of Islamic teachings at a very young age. The Mini Quran is a great way for your kids to learn and memorize their Doas, Surahs from the Quran and Prayers.</p>\r\n\r\n<p><strong>Learn and Play</strong><br />\r\nThe Mini Quran for Kids include 16 sections of the Quran, 26 prayers, 8 classic songs, reading when worship, projection at night or dark room.</p>\r\n','','filtered_html'),('node','product',0,96,96,'und',0,'<p><strong><u>Highlights</u></strong></p>\r\n\r\n<ul>\r\n	<li>Writing tablet created to make lists, draw or jot down paperless notes</li>\r\n	<li>“Green” alternative to sticky notes, memo pads, paper and ink</li>\r\n	<li>Less than a 1/4\" thin and is easy to take with you in a purse, scheduler, briefcase or backpack</li>\r\n	<li>Ultra low power consumption; One set of batteries (2 AAAA-included) will last tens of thousands of erases</li>\r\n	<li>Includes LCD Screen cleaning cloth to safely remove smudges</li>\r\n	<li>LCD are made from durable plastic materials</li>\r\n	<li>Safe for school, work or even home use</li>\r\n	<li>Lightweight, portable and durable</li>\r\n</ul>\r\n\r\n<p>&nbsp;<strong>Specifications:</strong></p>\r\n\r\n<ul>\r\n	<li>Measurement: 27cm x 1705cm</li>\r\n	<li>LCD: 10.5 Inch</li>\r\n	<li>Powered: AAAA Battery</li>\r\n	<li>Color: Pink</li>\r\n</ul>\r\n','','filtered_html'),('node','product',0,97,97,'und',0,'<p>Chicco Transporter Carry Cot can be used to change nappies anywhere, anytime. It gives parents and newborns an extra sense of closeness and security. Keeps baby secure and in place comfortably so you can focus on changing their diapers. Convenient for mums night time feeding.</p>\r\n','','filtered_html'),('node','product',0,138,138,'und',0,'<p>The key to a gorgeous complexion is to have healthy, glowing skin. The Kinohimitsu J’pan BB Drink is an amazing, instant drink that helps restore your skin’s natural glow and clarity - not just your face but your entire body, including your back, hands and legs.</p>\r\n\r\n<p><strong>All-Natural Ingredients </strong><br />\r\nInfused with all-natural and beneficial ingredients such as hydrolysed bird’s nest, chicken cartilage (a source of hyaluronic acid) and fermented yeast (a source of co-enzyme Q10, CoQ10), Kinohimitsu J’pan BB Drink is a healthy and effective solution to nourish, hydrate and rejuvenate every single cell in your body by giving rich, healthful nutrients to promote a baby-like rosy complexion.</p>\r\n\r\n<p><strong>Unleash the Radiance Within </strong><br />\r\nFor many individuals, a bright, glowing complexion often means health and happiness but sometimes the rosy sheen on our face is just too difficult to maintain. Over time, skin looks dull and lifeless, perhaps as a result of dehydration, improper face cleansing, lack of essential vitamins, poor blood circulation, build-up of dead skin cells and environmental elements.</p>\r\n','','filtered_html'),('node','product',0,139,139,'und',0,'<p>Get the blast of the delicious&nbsp;FAT BURNER MEGA in a convenient powder format – just mix and drink!&nbsp;</p>\r\n\r\n<p>With its own unique, powerful formula that delivers an amazing experience, The FAT BURNER MEGA is the perfect solution for when you’re trying to get your sweat on in the gym or even when doing light excercise at your very own home. Featuring a potent Acai Berry dose shown to aid weight loss, FAT BURNER MEGA also features, L-carnitine and Lecithin,for an unmatched weight loss experience.</p>\r\n','','filtered_html'),('node','page',0,141,141,'und',0,'<div class=\"page-404\">\r\n<p>Page doesn\'t exist or some other error occured.</p>\r\n<a href=\"/\" title=\"Back to home\">Back to home</a>\r\n</div>\r\n','','full_html'),('node','page',0,143,143,'und',0,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur bibendum sagittis lectus, at interdum diam fermentum nec. Aliquam erat volutpat. In pharetra augue quis leo malesuada feugiat. Nam vestibulum risus quis est consequat, ac efficitur nisl efficitur. Vivamus porta, dui rutrum dictum auctor, tortor dolor aliquet velit, a dapibus sem diam sed massa. Donec id facilisis libero, quis suscipit odio. Nam sed nulla in erat vehicula malesuada volutpat vel ante. Donec sodales eros felis, ut auctor neque vestibulum sit amet. Sed lacinia pellentesque nulla, rhoncus consectetur eros porta quis.</p>\r\n\r\n<p>Maecenas feugiat mi ac urna molestie, vel hendrerit lacus tempus. Morbi egestas sem risus, et bibendum justo mattis eu. Donec sollicitudin ultricies nulla at efficitur. Donec non est vel risus ullamcorper malesuada. Vivamus id volutpat augue, in convallis tortor. Morbi eleifend volutpat ipsum non hendrerit. Vestibulum dignissim magna non justo viverra dapibus. Duis varius molestie dolor, et rhoncus dolor lobortis vel. Cras nec quam at est viverra vestibulum nec et arcu. Sed nec vehicula purus. Etiam nisl risus, scelerisque vitae commodo semper, dignissim vel arcu. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Pellentesque nibh lectus, ornare ac ultrices quis, vulputate at leo. Duis dictum metus eget metus ornare posuere.</p>\r\n\r\n<ul>\r\n	<li>Integer tincidunt hendrerit erat</li>\r\n<li>Phasellus at arcu a augue ultricies eleifend</li>\r\n<li>Sed laoreet laoreet odio vitae pretium</li>\r\n</ul>\r\n\r\n<p>In fringilla commodo elit nec placerat. Sed non placerat nibh. Vestibulum tincidunt mi risus. Proin quis pharetra eros. Cras a libero nibh. Curabitur libero mauris, sodales sit amet diam in, ultrices egestas lectus. Nullam id tortor in lorem dictum tristique. Nulla condimentum facilisis tellus. Mauris urna magna, semper ac gravida quis, volutpat at tellus. Sed vulputate urna ac dui sodales, id eleifend turpis lacinia. Nam accumsan purus et dolor viverra laoreet.</p>\r\n\r\n<p>Proin efficitur congue tortor sit amet iaculis. Nullam porttitor in magna ut venenatis. Donec tristique ante aliquet diam consectetur, in varius eros aliquam. In sed felis a leo hendrerit iaculis. Sed aliquam mollis risus, sed convallis ipsum vulputate sit amet. Cras accumsan sodales efficitur. Praesent egestas vulputate nunc, id lacinia elit commodo nec. Pellentesque convallis viverra nunc eget pharetra. Morbi efficitur tempor vehicula. Nulla scelerisque lorem et sapien dapibus, sit amet feugiat neque dapibus. Praesent id enim mauris. Donec mollis tortor nec placerat eleifend. Suspendisse ac turpis ullamcorper, scelerisque lorem ac, facilisis ante. Phasellus vestibulum diam a nisi mattis mollis. Suspendisse hendrerit dui eu urna vestibulum scelerisque. Nunc vel metus ex.,/p&gt;</p>\r\n','','full_html');
/*!40000 ALTER TABLE `field_data_body` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_cmp_line_item`
--

DROP TABLE IF EXISTS `field_data_cmp_line_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_cmp_line_item` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `cmp_line_item_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `cmp_line_item_target_id` (`cmp_line_item_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 27 (cmp_line_item)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_cmp_line_item`
--

LOCK TABLES `field_data_cmp_line_item` WRITE;
/*!40000 ALTER TABLE `field_data_cmp_line_item` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_cmp_line_item` VALUES ('commerce_line_item','product',0,2,2,'und',0,1),('commerce_line_item','product',0,4,4,'und',0,3),('commerce_line_item','product',0,6,6,'und',0,5),('commerce_line_item','product',0,8,8,'und',0,7),('commerce_line_item','product',0,9,9,'und',0,1),('commerce_line_item','product',0,11,11,'und',0,10),('commerce_line_item','product',0,13,13,'und',0,12),('commerce_line_item','product',0,15,15,'und',0,14),('commerce_line_item','product',0,17,17,'und',0,16),('commerce_line_item','product',0,18,18,'und',0,14),('commerce_line_item','product',0,20,20,'und',0,19),('commerce_line_item','product',0,22,22,'und',0,21),('commerce_line_item','product',0,24,24,'und',0,23),('commerce_line_item','product',0,26,26,'und',0,25),('commerce_line_item','product',0,28,28,'und',0,27),('commerce_line_item','product',0,29,29,'und',0,27),('commerce_line_item','product',0,31,31,'und',0,30),('commerce_line_item','product',0,33,33,'und',0,32),('commerce_line_item','product',0,35,35,'und',0,34),('commerce_line_item','product',0,37,37,'und',0,36),('commerce_line_item','product',0,39,39,'und',0,38),('commerce_line_item','product',0,41,41,'und',0,40),('commerce_line_item','product',0,42,42,'und',0,40),('commerce_line_item','product',0,43,43,'und',0,40),('commerce_line_item','product',0,44,44,'und',0,40),('commerce_line_item','product',0,46,46,'und',0,45),('commerce_line_item','product',0,48,48,'und',0,47),('commerce_line_item','product',0,50,50,'und',0,49),('commerce_line_item','product',0,52,52,'und',0,51),('commerce_line_item','product',0,54,54,'und',0,53),('commerce_line_item','product',0,56,56,'und',0,55),('commerce_line_item','product',0,58,58,'und',0,57),('commerce_line_item','product',0,60,60,'und',0,59),('commerce_line_item','product',0,62,62,'und',0,61),('commerce_line_item','product',0,64,64,'und',0,63),('commerce_line_item','product',0,65,65,'und',0,63),('commerce_line_item','product',0,67,67,'und',0,66),('commerce_line_item','product',0,69,69,'und',0,68),('commerce_line_item','product',0,71,71,'und',0,70),('commerce_line_item','product',0,73,73,'und',0,72),('commerce_line_item','product',0,76,76,'und',0,75),('commerce_line_item','product',0,78,78,'und',0,77),('commerce_line_item','product',0,80,80,'und',0,79);
/*!40000 ALTER TABLE `field_data_cmp_line_item` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_cmp_m_store`
--

DROP TABLE IF EXISTS `field_data_cmp_m_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_cmp_m_store` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `cmp_m_store_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `cmp_m_store_target_id` (`cmp_m_store_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 23 (cmp_m_store)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_cmp_m_store`
--

LOCK TABLES `field_data_cmp_m_store` WRITE;
/*!40000 ALTER TABLE `field_data_cmp_m_store` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_cmp_m_store` VALUES ('commerce_store','store',0,2,2,'und',0,1),('commerce_store','store',0,3,3,'und',0,16);
/*!40000 ALTER TABLE `field_data_cmp_m_store` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_cmp_o_store`
--

DROP TABLE IF EXISTS `field_data_cmp_o_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_cmp_o_store` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `cmp_o_store_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `cmp_o_store_target_id` (`cmp_o_store_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 25 (cmp_o_store)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_cmp_o_store`
--

LOCK TABLES `field_data_cmp_o_store` WRITE;
/*!40000 ALTER TABLE `field_data_cmp_o_store` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_cmp_o_store` VALUES ('commerce_order','commerce_store_order',0,17,17,'und',0,1),('commerce_order','commerce_store_order',0,18,18,'und',0,1),('commerce_order','commerce_store_order',0,21,21,'und',0,2),('commerce_order','commerce_store_order',0,23,23,'und',0,1),('commerce_order','commerce_store_order',0,24,24,'und',0,1),('commerce_order','commerce_store_order',0,26,26,'und',0,1),('commerce_order','commerce_store_order',0,29,29,'und',0,2),('commerce_order','commerce_store_order',0,31,31,'und',0,1),('commerce_order','commerce_store_order',0,32,32,'und',0,1),('commerce_order','commerce_store_order',0,35,35,'und',0,2),('commerce_order','commerce_store_order',0,37,37,'und',0,2),('commerce_order','commerce_store_order',0,38,38,'und',0,1),('commerce_order','commerce_store_order',0,44,44,'und',0,1),('commerce_order','commerce_store_order',0,64,64,'und',0,1),('commerce_order','commerce_store_order',0,74,74,'und',0,1),('commerce_order','commerce_store_order',0,77,78,'und',0,1),('commerce_order','commerce_store_order',0,84,86,'und',0,1),('commerce_order','commerce_store_order',0,93,99,'und',0,2),('commerce_order','commerce_store_order',0,111,117,'und',0,2),('commerce_order','commerce_store_order',0,116,122,'und',0,2),('commerce_order','commerce_store_order',0,118,124,'und',0,2),('commerce_order','commerce_store_order',0,122,128,'und',0,2),('commerce_order','commerce_store_order',0,123,129,'und',0,2),('commerce_order','commerce_store_order',0,125,131,'und',0,2),('commerce_order','commerce_store_order',0,139,145,'und',0,1),('commerce_order','commerce_store_order',0,141,152,'und',0,2),('commerce_order','commerce_store_order',0,142,154,'und',0,1),('commerce_order','commerce_store_order',0,147,170,'und',0,2),('commerce_order','commerce_store_order',0,169,193,'und',0,2),('commerce_order','commerce_store_order',0,190,215,'und',0,3),('commerce_order','commerce_store_order',0,202,229,'und',0,3),('commerce_order','commerce_store_order',0,230,260,'und',0,2),('commerce_order','commerce_store_order',0,231,261,'und',0,3),('commerce_order','commerce_store_order',0,251,281,'und',0,2);
/*!40000 ALTER TABLE `field_data_cmp_o_store` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_cmp_order`
--

DROP TABLE IF EXISTS `field_data_cmp_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_cmp_order` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `cmp_order_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `cmp_order_target_id` (`cmp_order_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 26 (cmp_order)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_cmp_order`
--

LOCK TABLES `field_data_cmp_order` WRITE;
/*!40000 ALTER TABLE `field_data_cmp_order` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_cmp_order` VALUES ('commerce_order','commerce_store_order',0,17,17,'und',0,4),('commerce_order','commerce_store_order',0,18,18,'und',0,16),('commerce_order','commerce_store_order',0,21,21,'und',0,19),('commerce_order','commerce_store_order',0,23,23,'und',0,22),('commerce_order','commerce_store_order',0,24,24,'und',0,13),('commerce_order','commerce_store_order',0,26,26,'und',0,25),('commerce_order','commerce_store_order',0,29,29,'und',0,28),('commerce_order','commerce_store_order',0,31,31,'und',0,30),('commerce_order','commerce_store_order',0,32,32,'und',0,28),('commerce_order','commerce_store_order',0,35,35,'und',0,34),('commerce_order','commerce_store_order',0,37,37,'und',0,36),('commerce_order','commerce_store_order',0,38,38,'und',0,36),('commerce_order','commerce_store_order',0,44,44,'und',0,39),('commerce_order','commerce_store_order',0,64,64,'und',0,63),('commerce_order','commerce_store_order',0,74,74,'und',0,73),('commerce_order','commerce_store_order',0,77,78,'und',0,76),('commerce_order','commerce_store_order',0,84,86,'und',0,83),('commerce_order','commerce_store_order',0,93,99,'und',0,92),('commerce_order','commerce_store_order',0,111,117,'und',0,109),('commerce_order','commerce_store_order',0,116,122,'und',0,115),('commerce_order','commerce_store_order',0,118,124,'und',0,117),('commerce_order','commerce_store_order',0,122,128,'und',0,121),('commerce_order','commerce_store_order',0,123,129,'und',0,120),('commerce_order','commerce_store_order',0,125,131,'und',0,124),('commerce_order','commerce_store_order',0,139,145,'und',0,138),('commerce_order','commerce_store_order',0,141,152,'und',0,140),('commerce_order','commerce_store_order',0,142,154,'und',0,140),('commerce_order','commerce_store_order',0,147,170,'und',0,146),('commerce_order','commerce_store_order',0,169,193,'und',0,167),('commerce_order','commerce_store_order',0,190,215,'und',0,189),('commerce_order','commerce_store_order',0,202,229,'und',0,201),('commerce_order','commerce_store_order',0,230,260,'und',0,226),('commerce_order','commerce_store_order',0,231,261,'und',0,226),('commerce_order','commerce_store_order',0,251,281,'und',0,250);
/*!40000 ALTER TABLE `field_data_cmp_order` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_cmp_store`
--

DROP TABLE IF EXISTS `field_data_cmp_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_cmp_store` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `cmp_store_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `cmp_store_target_id` (`cmp_store_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 22 (cmp_store)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_cmp_store`
--

LOCK TABLES `field_data_cmp_store` WRITE;
/*!40000 ALTER TABLE `field_data_cmp_store` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_cmp_store` VALUES ('commerce_product','product',0,4,15,'und',0,2),('commerce_product','product',0,6,83,'und',0,1),('commerce_product','product',0,7,10,'und',0,3),('commerce_product','product',0,8,11,'und',0,2),('commerce_product','product',0,9,84,'und',0,3),('commerce_product','product',0,10,86,'und',0,3),('commerce_product','product',0,11,18,'und',0,3),('commerce_product','product',0,12,19,'und',0,3),('commerce_product','product',0,13,20,'und',0,2),('commerce_product','product',0,14,21,'und',0,3),('commerce_product','product',0,15,22,'und',0,3),('commerce_product','product',0,16,23,'und',0,3),('commerce_product','product',0,17,24,'und',0,3),('commerce_product','product',0,18,25,'und',0,2),('commerce_product','product',0,19,96,'und',0,2),('commerce_product','product',0,20,27,'und',0,2),('commerce_product','product',0,21,118,'und',0,2),('commerce_product','product',0,22,97,'und',0,2),('commerce_product','product',0,23,98,'und',0,2),('commerce_product','product',0,24,99,'und',0,2),('commerce_product','product',0,25,100,'und',0,2),('commerce_product','product',0,26,92,'und',0,2),('commerce_product','product',0,27,101,'und',0,2),('commerce_product','product',0,28,35,'und',0,2),('commerce_product','product',0,29,36,'und',0,2),('commerce_product','product',0,30,102,'und',0,2),('commerce_product','product',0,31,91,'und',0,2),('commerce_product','product',0,32,90,'und',0,2),('commerce_product','product',0,33,103,'und',0,2),('commerce_product','product',0,34,41,'und',0,2),('commerce_product','product',0,35,42,'und',0,2),('commerce_product','product',0,36,104,'und',0,2),('commerce_product','product',0,37,44,'und',0,2),('commerce_product','product',0,38,105,'und',0,2),('commerce_product','product',0,39,106,'und',0,2),('commerce_product','product',0,40,107,'und',0,2),('commerce_product','product',0,41,89,'und',0,2),('commerce_product','product',0,42,88,'und',0,2),('commerce_product','product',0,43,108,'und',0,2),('commerce_product','product',0,44,109,'und',0,2),('commerce_product','product',0,45,110,'und',0,2),('commerce_product','product',0,46,53,'und',0,2),('commerce_product','product',0,47,111,'und',0,2),('commerce_product','product',0,48,55,'und',0,2),('commerce_product','product',0,49,112,'und',0,2),('commerce_product','product',0,50,113,'und',0,2),('commerce_product','product',0,51,114,'und',0,2),('commerce_product','product',0,52,115,'und',0,2),('commerce_product','product',0,53,116,'und',0,2),('commerce_product','product',0,54,117,'und',0,2),('commerce_product','product',0,55,119,'und',0,2),('commerce_product','product',0,56,120,'und',0,2),('commerce_product','product',0,57,121,'und',0,2),('commerce_product','product',0,58,122,'und',0,2),('commerce_product','product',0,59,123,'und',0,2),('commerce_product','product',0,60,124,'und',0,2),('commerce_product','product',0,61,68,'und',0,3),('commerce_product','product',0,62,69,'und',0,3),('commerce_product','product',0,63,70,'und',0,2),('commerce_product','product',0,64,71,'und',0,2),('commerce_product','product',0,65,72,'und',0,3),('commerce_product','product',0,66,95,'und',0,2),('commerce_product','product',0,67,94,'und',0,2),('commerce_product','product',0,68,93,'und',0,2),('commerce_product','product',0,69,76,'und',0,2),('commerce_product','product',0,70,77,'und',0,2),('commerce_product','product',0,71,126,'und',0,3),('commerce_product','product',0,72,127,'und',0,3),('commerce_product','product',0,73,128,'und',0,3),('commerce_product','product',0,74,132,'und',0,3),('commerce_product','product',0,75,143,'und',0,3),('commerce_product','product',0,76,131,'und',0,3),('commerce_product','product',0,77,133,'und',0,3),('commerce_product','product',0,78,134,'und',0,3),('commerce_product','product',0,79,137,'und',0,3),('commerce_product','product',0,80,141,'und',0,3),('commerce_product','product',0,81,144,'und',0,3),('commerce_product','product',0,82,145,'und',0,3);
/*!40000 ALTER TABLE `field_data_cmp_store` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_comment_body`
--

DROP TABLE IF EXISTS `field_data_comment_body`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_comment_body` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `comment_body_value` longtext,
  `comment_body_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `comment_body_format` (`comment_body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 1 (comment_body)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_comment_body`
--

LOCK TABLES `field_data_comment_body` WRITE;
/*!40000 ALTER TABLE `field_data_comment_body` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_comment_body` VALUES ('comment','comment_node_product',0,2,2,'und',0,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit</p>\r\n','filtered_html');
/*!40000 ALTER TABLE `field_data_comment_body` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_commerce_customer_address`
--

DROP TABLE IF EXISTS `field_data_commerce_customer_address`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_commerce_customer_address` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_customer_address_country` varchar(2) DEFAULT '' COMMENT 'Two letter ISO country code of this address.',
  `commerce_customer_address_administrative_area` varchar(255) DEFAULT '' COMMENT 'The administrative area of this address. (i.e. State/Province)',
  `commerce_customer_address_sub_administrative_area` varchar(255) DEFAULT '' COMMENT 'The sub administrative area of this address.',
  `commerce_customer_address_locality` varchar(255) DEFAULT '' COMMENT 'The locality of this address. (i.e. City)',
  `commerce_customer_address_dependent_locality` varchar(255) DEFAULT '' COMMENT 'The dependent locality of this address.',
  `commerce_customer_address_postal_code` varchar(255) DEFAULT '' COMMENT 'The postal code of this address.',
  `commerce_customer_address_thoroughfare` varchar(255) DEFAULT '' COMMENT 'The thoroughfare of this address. (i.e. Street address)',
  `commerce_customer_address_premise` varchar(255) DEFAULT '' COMMENT 'The premise of this address. (i.e. Apartment / Suite number)',
  `commerce_customer_address_sub_premise` varchar(255) DEFAULT '' COMMENT 'The sub_premise of this address.',
  `commerce_customer_address_organisation_name` varchar(255) DEFAULT '' COMMENT 'Contents of a primary OrganisationName element in the xNL XML.',
  `commerce_customer_address_name_line` varchar(255) DEFAULT '' COMMENT 'Contents of a primary NameLine element in the xNL XML.',
  `commerce_customer_address_first_name` varchar(255) DEFAULT '' COMMENT 'Contents of the FirstName element of a primary PersonName element in the xNL XML.',
  `commerce_customer_address_last_name` varchar(255) DEFAULT '' COMMENT 'Contents of the LastName element of a primary PersonName element in the xNL XML.',
  `commerce_customer_address_data` longtext COMMENT 'Additional data for this address.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 6 (commerce_customer_address)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_commerce_customer_address`
--

LOCK TABLES `field_data_commerce_customer_address` WRITE;
/*!40000 ALTER TABLE `field_data_commerce_customer_address` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_commerce_customer_address` VALUES ('commerce_customer_profile','shipping',0,1,1,'und',0,'VN','good',NULL,'new york',NULL,'70000','us','',NULL,NULL,'jk','jk','',NULL),('commerce_customer_profile','billing',0,2,2,'und',0,'VN','good',NULL,'new york',NULL,'70000','us','',NULL,NULL,'jk','jk','',NULL),('commerce_customer_profile','shipping',0,3,3,'und',0,'VN','waiting',NULL,'nothing',NULL,'7000','nothing','',NULL,NULL,'nothing','nothing','',NULL),('commerce_customer_profile','billing',0,4,4,'und',0,'VN','waiting',NULL,'nothing',NULL,'7000','nothing','',NULL,NULL,'nothing','nothing','',NULL),('commerce_customer_profile','shipping',0,5,5,'und',0,'VN','GO VAP',NULL,'TPHCM',NULL,'70000','44/29/1 Pham Van CHieu','',NULL,NULL,'Le THong','Le','THong',NULL),('commerce_customer_profile','billing',0,6,6,'und',0,'VN','GO VAP',NULL,'TPHCM',NULL,'70000','44/29/1 Pham Van CHieu','',NULL,NULL,'Le THong','Le','THong',NULL);
/*!40000 ALTER TABLE `field_data_commerce_customer_address` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_commerce_customer_billing`
--

DROP TABLE IF EXISTS `field_data_commerce_customer_billing`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_commerce_customer_billing` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_customer_billing_profile_id` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `commerce_customer_billing_profile_id` (`commerce_customer_billing_profile_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 9 (commerce_customer_billing)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_commerce_customer_billing`
--

LOCK TABLES `field_data_commerce_customer_billing` WRITE;
/*!40000 ALTER TABLE `field_data_commerce_customer_billing` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_commerce_customer_billing` VALUES ('commerce_order','commerce_marketplace_order',0,138,150,'und',0,2),('commerce_order','commerce_store_order',0,139,145,'und',0,2),('commerce_order','commerce_marketplace_order',0,140,165,'und',0,4),('commerce_order','commerce_store_order',0,141,152,'und',0,4),('commerce_order','commerce_store_order',0,142,154,'und',0,4),('commerce_order','commerce_marketplace_order',0,201,232,'und',0,6),('commerce_order','commerce_store_order',0,202,229,'und',0,6);
/*!40000 ALTER TABLE `field_data_commerce_customer_billing` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_commerce_customer_shipping`
--

DROP TABLE IF EXISTS `field_data_commerce_customer_shipping`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_commerce_customer_shipping` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_customer_shipping_profile_id` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `commerce_customer_shipping_profile_id` (`commerce_customer_shipping_profile_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 24 (commerce_customer_shipping)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_commerce_customer_shipping`
--

LOCK TABLES `field_data_commerce_customer_shipping` WRITE;
/*!40000 ALTER TABLE `field_data_commerce_customer_shipping` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_commerce_customer_shipping` VALUES ('commerce_order','commerce_marketplace_order',0,138,150,'und',0,1),('commerce_order','commerce_store_order',0,139,145,'und',0,1),('commerce_order','commerce_marketplace_order',0,140,165,'und',0,3),('commerce_order','commerce_store_order',0,141,152,'und',0,3),('commerce_order','commerce_store_order',0,142,154,'und',0,3),('commerce_order','commerce_marketplace_order',0,201,232,'und',0,5),('commerce_order','commerce_store_order',0,202,229,'und',0,5);
/*!40000 ALTER TABLE `field_data_commerce_customer_shipping` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_commerce_display_path`
--

DROP TABLE IF EXISTS `field_data_commerce_display_path`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_commerce_display_path` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_display_path_value` varchar(255) DEFAULT NULL,
  `commerce_display_path_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `commerce_display_path_format` (`commerce_display_path_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 13 (commerce_display_path)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_commerce_display_path`
--

LOCK TABLES `field_data_commerce_display_path` WRITE;
/*!40000 ALTER TABLE `field_data_commerce_display_path` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_commerce_display_path` VALUES ('commerce_line_item','product',0,1,1,'und',0,'node/9',NULL),('commerce_line_item','product',0,2,2,'und',0,'node/9',NULL),('commerce_line_item','product',0,3,3,'und',0,'node/9',NULL),('commerce_line_item','product',0,4,4,'und',0,'node/9',NULL),('commerce_line_item','product',0,5,5,'und',0,'node/4',NULL),('commerce_line_item','product',0,6,6,'und',0,'node/4',NULL),('commerce_line_item','product',0,7,7,'und',0,'node/9',NULL),('commerce_line_item','product',0,8,8,'und',0,'node/9',NULL),('commerce_line_item','product',0,9,9,'und',0,'node/9',NULL),('commerce_line_item','product',0,10,10,'und',0,'node/9',NULL),('commerce_line_item','product',0,11,11,'und',0,'node/9',NULL),('commerce_line_item','product',0,12,12,'und',0,'node/10',NULL),('commerce_line_item','product',0,13,13,'und',0,'node/10',NULL),('commerce_line_item','product',0,14,14,'und',0,'node/9',NULL),('commerce_line_item','product',0,15,15,'und',0,'node/9',NULL),('commerce_line_item','product',0,16,16,'und',0,'node/10',NULL),('commerce_line_item','product',0,17,17,'und',0,'node/10',NULL),('commerce_line_item','product',0,18,18,'und',0,'node/9',NULL),('commerce_line_item','product',0,20,20,'und',0,'node/5',NULL),('commerce_line_item','product',0,21,21,'und',0,'node/9',NULL),('commerce_line_item','product',0,22,22,'und',0,'node/9',NULL),('commerce_line_item','product',0,23,23,'und',0,'node/9',NULL),('commerce_line_item','product',0,24,24,'und',0,'node/9',NULL),('commerce_line_item','product',0,25,25,'und',0,'node/5',NULL),('commerce_line_item','product',0,26,26,'und',0,'node/5',NULL),('commerce_line_item','product',0,27,27,'und',0,'node/5',NULL),('commerce_line_item','product',0,28,28,'und',0,'node/5',NULL),('commerce_line_item','product',0,29,29,'und',0,'node/5',NULL),('commerce_line_item','product',0,30,30,'und',0,'node/9',NULL),('commerce_line_item','product',0,31,31,'und',0,'node/9',NULL),('commerce_line_item','product',0,32,32,'und',0,'node/10',NULL),('commerce_line_item','product',0,33,33,'und',0,'node/10',NULL),('commerce_line_item','product',0,35,35,'und',0,'node/9',NULL),('commerce_line_item','product',0,36,36,'und',0,'node/9',NULL),('commerce_line_item','product',0,37,37,'und',0,'node/9',NULL),('commerce_line_item','product',0,38,38,'und',0,'node/9',NULL),('commerce_line_item','product',0,39,39,'und',0,'node/9',NULL),('commerce_line_item','product',0,40,40,'und',0,'node/9',NULL),('commerce_line_item','product',0,41,41,'und',0,'node/9',NULL),('commerce_line_item','product',0,42,42,'und',0,'node/9',NULL),('commerce_line_item','product',0,43,43,'und',0,'node/9',NULL),('commerce_line_item','product',0,44,44,'und',0,'node/9',NULL),('commerce_line_item','product',0,45,45,'und',0,'node/30',NULL),('commerce_line_item','product',0,46,46,'und',0,'node/30',NULL),('commerce_line_item','product',0,47,47,'und',0,'node/52',NULL),('commerce_line_item','product',0,48,48,'und',0,'node/52',NULL),('commerce_line_item','product',0,49,49,'und',0,'node/45',NULL),('commerce_line_item','product',0,50,50,'und',0,'node/45',NULL),('commerce_line_item','product',0,52,52,'und',0,'node/45',NULL),('commerce_line_item','product',0,53,53,'und',0,'node/76',NULL),('commerce_line_item','product',0,54,54,'und',0,'node/76',NULL),('commerce_line_item','product',0,55,55,'und',0,'node/45',NULL),('commerce_line_item','product',0,56,56,'und',0,'node/45',NULL),('commerce_line_item','product',0,57,57,'und',0,'node/46',NULL),('commerce_line_item','product',0,58,58,'und',0,'node/46',NULL),('commerce_line_item','product',0,59,59,'und',0,'node/9',NULL),('commerce_line_item','product',0,60,60,'und',0,'node/9',NULL),('commerce_line_item','product',0,62,62,'und',0,'node/76',NULL),('commerce_line_item','product',0,63,63,'und',0,'node/10',NULL),('commerce_line_item','product',0,64,64,'und',0,'node/10',NULL),('commerce_line_item','product',0,65,65,'und',0,'node/10',NULL),('commerce_line_item','product',0,66,66,'und',0,'node/76',NULL),('commerce_line_item','product',0,67,67,'und',0,'node/76',NULL),('commerce_line_item','product',0,68,68,'und',0,'node/45',NULL),('commerce_line_item','product',0,69,69,'und',0,'node/45',NULL),('commerce_line_item','product',0,70,70,'und',0,'node/97',NULL),('commerce_line_item','product',0,71,71,'und',0,'node/97',NULL),('commerce_line_item','product',0,72,72,'und',0,'node/139',NULL),('commerce_line_item','product',0,73,73,'und',0,'node/139',NULL),('commerce_line_item','product',0,75,75,'und',0,'node/45',NULL),('commerce_line_item','product',0,76,76,'und',0,'node/45',NULL),('commerce_line_item','product',0,77,77,'und',0,'node/90',NULL),('commerce_line_item','product',0,78,78,'und',0,'node/90',NULL),('commerce_line_item','product',0,79,79,'und',0,'node/45',NULL),('commerce_line_item','product',0,80,80,'und',0,'node/45',NULL);
/*!40000 ALTER TABLE `field_data_commerce_display_path` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_commerce_line_items`
--

DROP TABLE IF EXISTS `field_data_commerce_line_items`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_commerce_line_items` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_line_items_line_item_id` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `commerce_line_items_line_item_id` (`commerce_line_items_line_item_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 7 (commerce_line_items)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_commerce_line_items`
--

LOCK TABLES `field_data_commerce_line_items` WRITE;
/*!40000 ALTER TABLE `field_data_commerce_line_items` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_commerce_line_items` VALUES ('commerce_order','commerce_marketplace_order',0,4,4,'und',0,1),('commerce_order','commerce_marketplace_order',0,13,13,'und',0,10),('commerce_order','commerce_marketplace_order',0,13,13,'und',1,12),('commerce_order','commerce_marketplace_order',0,16,16,'und',0,3),('commerce_order','commerce_store_order',0,17,17,'und',0,2),('commerce_order','commerce_store_order',0,17,17,'und',1,9),('commerce_order','commerce_store_order',0,18,18,'und',0,4),('commerce_order','commerce_marketplace_order',0,19,19,'und',0,5),('commerce_order','commerce_store_order',0,21,21,'und',0,6),('commerce_order','commerce_marketplace_order',0,22,22,'und',0,7),('commerce_order','commerce_store_order',0,23,23,'und',0,8),('commerce_order','commerce_store_order',0,24,24,'und',0,11),('commerce_order','commerce_store_order',0,24,24,'und',1,13),('commerce_order','commerce_marketplace_order',0,25,25,'und',0,14),('commerce_order','commerce_marketplace_order',0,25,25,'und',1,16),('commerce_order','commerce_store_order',0,26,26,'und',0,15),('commerce_order','commerce_store_order',0,26,26,'und',1,17),('commerce_order','commerce_store_order',0,26,26,'und',2,18),('commerce_order','commerce_marketplace_order',0,28,28,'und',0,23),('commerce_order','commerce_marketplace_order',0,30,30,'und',0,21),('commerce_order','commerce_store_order',0,31,31,'und',0,22),('commerce_order','commerce_store_order',0,32,32,'und',0,24),('commerce_order','commerce_marketplace_order',0,34,34,'und',0,25),('commerce_order','commerce_store_order',0,35,35,'und',0,26),('commerce_order','commerce_marketplace_order',0,36,36,'und',0,27),('commerce_order','commerce_marketplace_order',0,36,36,'und',1,30),('commerce_order','commerce_store_order',0,37,37,'und',0,28),('commerce_order','commerce_store_order',0,37,37,'und',1,29),('commerce_order','commerce_store_order',0,38,38,'und',0,31),('commerce_order','commerce_marketplace_order',0,39,39,'und',0,32),('commerce_order','commerce_store_order',0,44,44,'und',0,33),('commerce_order','commerce_marketplace_order',0,73,75,'und',0,36),('commerce_order','commerce_store_order',0,74,74,'und',0,37),('commerce_order','commerce_marketplace_order',0,76,79,'und',0,38),('commerce_order','commerce_store_order',0,77,78,'und',0,39),('commerce_order','commerce_marketplace_order',0,83,90,'und',0,40),('commerce_order','commerce_store_order',0,84,86,'und',0,41),('commerce_order','commerce_store_order',0,84,86,'und',1,42),('commerce_order','commerce_store_order',0,84,86,'und',2,43),('commerce_order','commerce_store_order',0,84,86,'und',3,44),('commerce_order','commerce_marketplace_order',0,92,98,'und',0,45),('commerce_order','commerce_store_order',0,93,99,'und',0,46),('commerce_order','commerce_marketplace_order',0,109,115,'und',0,47),('commerce_order','commerce_store_order',0,111,117,'und',0,48),('commerce_order','commerce_marketplace_order',0,115,121,'und',0,49),('commerce_order','commerce_store_order',0,116,122,'und',0,50),('commerce_order','commerce_marketplace_order',0,120,126,'und',0,55),('commerce_order','commerce_marketplace_order',0,121,127,'und',0,53),('commerce_order','commerce_store_order',0,122,128,'und',0,54),('commerce_order','commerce_store_order',0,123,129,'und',0,56),('commerce_order','commerce_marketplace_order',0,124,130,'und',0,57),('commerce_order','commerce_store_order',0,125,131,'und',0,58),('commerce_order','commerce_marketplace_order',0,138,150,'und',0,59),('commerce_order','commerce_store_order',0,139,145,'und',0,60),('commerce_order','commerce_marketplace_order',0,140,165,'und',0,63),('commerce_order','commerce_store_order',0,142,154,'und',0,64),('commerce_order','commerce_store_order',0,142,154,'und',1,65),('commerce_order','commerce_marketplace_order',0,146,171,'und',0,66),('commerce_order','commerce_store_order',0,147,170,'und',0,67),('commerce_order','commerce_marketplace_order',0,167,194,'und',0,68),('commerce_order','commerce_store_order',0,169,193,'und',0,69),('commerce_order','commerce_marketplace_order',0,189,217,'und',0,70),('commerce_order','commerce_store_order',0,190,215,'und',0,71),('commerce_order','commerce_marketplace_order',0,201,232,'und',0,72),('commerce_order','commerce_marketplace_order',0,201,232,'und',1,74),('commerce_order','commerce_store_order',0,202,229,'und',0,73),('commerce_order','commerce_marketplace_order',0,226,256,'und',0,75),('commerce_order','commerce_marketplace_order',0,226,256,'und',1,77),('commerce_order','commerce_store_order',0,230,260,'und',0,76),('commerce_order','commerce_store_order',0,231,261,'und',0,78),('commerce_order','commerce_marketplace_order',0,250,280,'und',0,79),('commerce_order','commerce_store_order',0,251,281,'und',0,80);
/*!40000 ALTER TABLE `field_data_commerce_line_items` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_commerce_order_total`
--

DROP TABLE IF EXISTS `field_data_commerce_order_total`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_commerce_order_total` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_order_total_amount` int(11) NOT NULL DEFAULT '0' COMMENT 'The price amount.',
  `commerce_order_total_currency_code` varchar(32) NOT NULL COMMENT 'The currency code for the price.',
  `commerce_order_total_data` longtext COMMENT 'A serialized array of additional price data.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `commerce_order_total_currency_price` (`commerce_order_total_amount`,`commerce_order_total_currency_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 8 (commerce_order_total)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_commerce_order_total`
--

LOCK TABLES `field_data_commerce_order_total` WRITE;
/*!40000 ALTER TABLE `field_data_commerce_order_total` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_commerce_order_total` VALUES ('commerce_order','commerce_marketplace_order',0,1,1,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,2,2,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,3,3,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,4,4,'und',0,5040000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:5040000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,5,5,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,6,6,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,7,7,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,8,8,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,9,9,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,10,10,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,11,11,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,12,12,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,13,13,'und',0,320000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:320000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,14,14,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,15,15,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,16,16,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,17,17,'und',0,9960000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:9960000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,18,18,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,19,19,'und',0,11500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:11500;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,20,20,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,21,21,'und',0,11500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:11500;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,22,22,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,23,23,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,24,24,'und',0,320000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:320000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,25,25,'und',0,440000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:440000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,26,26,'und',0,560000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:560000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,27,27,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,28,28,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,29,29,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,30,30,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,31,31,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,32,32,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,33,33,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,34,34,'und',0,300000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:300000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,35,35,'und',0,300000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:300000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,36,36,'und',0,720000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:720000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,37,37,'und',0,900000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:900000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,38,38,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,39,39,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:200000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,40,40,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,41,41,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,42,42,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,43,43,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,44,44,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:200000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,45,45,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,46,46,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,47,47,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,48,48,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,49,49,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,50,50,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,51,51,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,52,52,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,53,53,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,54,54,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,55,55,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,56,56,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,57,57,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,58,58,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,59,59,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,60,60,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,61,61,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,62,62,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,63,63,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,64,64,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,65,65,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,66,66,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,67,67,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,68,68,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,69,69,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,70,70,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,71,71,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,72,72,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,73,75,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,74,74,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,75,76,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,76,79,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,77,78,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,78,80,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,79,81,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,80,82,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,81,83,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,82,84,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,83,90,'und',0,240000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:240000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,84,86,'und',0,960000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:960000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,85,91,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,86,92,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,87,93,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,88,94,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,89,95,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,90,96,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,91,97,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,92,98,'und',0,3800,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:3800;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,93,99,'und',0,3800,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:3800;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,94,100,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,95,101,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,96,102,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,97,103,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,98,104,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,99,105,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,100,106,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,101,107,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,102,108,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,103,109,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,104,110,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,105,111,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,106,112,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,107,113,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,108,114,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,109,115,'und',0,59900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:59900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,110,116,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,111,117,'und',0,59900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:59900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,112,118,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,113,119,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,114,120,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,115,121,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,116,122,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,117,123,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,118,124,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,119,125,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,120,126,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,121,127,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:34900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,122,128,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:34900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,123,129,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,124,130,'und',0,100000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:100000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,125,131,'und',0,100000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:100000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,126,132,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,127,133,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,128,134,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,129,135,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,130,136,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,131,137,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,132,138,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,133,139,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,134,140,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,135,141,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,136,142,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,137,143,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,138,150,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,139,145,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,140,165,'und',0,400000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:400000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,141,152,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,142,154,'und',0,600000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:600000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,143,166,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,144,167,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,145,168,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,146,171,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:34900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,147,170,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:34900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,148,172,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,149,173,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,150,174,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,151,175,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,152,176,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,153,177,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,154,178,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,155,179,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,156,180,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,157,181,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,158,182,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,159,183,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,160,184,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,161,185,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,162,186,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,163,187,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,164,188,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,165,189,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,166,190,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,167,194,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,168,192,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,169,193,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,170,195,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,171,196,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,172,197,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,173,198,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,174,199,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,175,200,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,176,201,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,177,202,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,178,203,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,179,204,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,180,205,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,181,206,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,182,207,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,183,208,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,184,209,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,185,210,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,186,211,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,187,212,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,188,213,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,189,217,'und',0,12500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:12500;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,190,215,'und',0,12500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:12500;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,191,218,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,192,219,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,193,220,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,194,221,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,195,222,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,196,223,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,197,224,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,198,225,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,199,226,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,200,227,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,201,232,'und',0,16200,'USD','a:1:{s:10:\"components\";a:2:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:15000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}i:1;a:3:{s:4:\"name\";s:18:\"flat_rate_shipping\";s:5:\"price\";a:3:{s:6:\"amount\";i:1200;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,202,229,'und',0,15000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:15000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,203,233,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,204,234,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,205,235,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,206,236,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,207,237,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,208,238,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,209,239,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,210,240,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,211,241,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,212,242,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,213,243,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,214,244,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,215,245,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,216,246,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,217,247,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,218,248,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,219,249,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,220,250,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,221,251,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,222,252,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,223,253,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,224,254,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,225,255,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,226,256,'und',0,149900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:149900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,227,257,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,228,258,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,229,259,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,230,260,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,231,261,'und',0,79900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:79900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,232,262,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,233,263,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,234,264,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,235,265,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,236,266,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,237,267,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,238,268,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,239,269,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,240,270,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,241,271,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,242,272,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,243,273,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,244,274,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,245,275,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,246,276,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,247,277,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,248,279,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,249,278,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,250,280,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,251,281,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,252,282,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,253,283,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,254,284,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,255,285,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,256,286,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}');
/*!40000 ALTER TABLE `field_data_commerce_order_total` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_commerce_price`
--

DROP TABLE IF EXISTS `field_data_commerce_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_commerce_price` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_price_amount` int(11) NOT NULL DEFAULT '0' COMMENT 'The price amount.',
  `commerce_price_currency_code` varchar(32) NOT NULL COMMENT 'The currency code for the price.',
  `commerce_price_data` longtext COMMENT 'A serialized array of additional price data.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `commerce_price_currency_price` (`commerce_price_amount`,`commerce_price_currency_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 14 (commerce_price)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_commerce_price`
--

LOCK TABLES `field_data_commerce_price` WRITE;
/*!40000 ALTER TABLE `field_data_commerce_price` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_commerce_price` VALUES ('commerce_product','product',0,4,15,'und',0,11500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,6,83,'und',0,120000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,7,10,'und',0,200000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,8,11,'und',0,300000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,9,84,'und',0,3800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,10,86,'und',0,3800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,11,18,'und',0,9900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,12,19,'und',0,9900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,13,20,'und',0,9900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,14,21,'und',0,9900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,15,22,'und',0,26400,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,16,23,'und',0,31800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,17,24,'und',0,3500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,18,25,'und',0,4100,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,19,96,'und',0,4300,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,20,27,'und',0,5000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,21,118,'und',0,3900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,22,97,'und',0,23800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,23,98,'und',0,10700,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,24,99,'und',0,11500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,25,100,'und',0,5900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,26,92,'und',0,5900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,27,101,'und',0,75000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,28,35,'und',0,70000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,29,36,'und',0,100000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,30,102,'und',0,19900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,31,91,'und',0,4900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,32,90,'und',0,49999,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,33,103,'und',0,34900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,34,41,'und',0,29900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,35,42,'und',0,59900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,36,104,'und',0,6900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,37,44,'und',0,15500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,38,105,'und',0,9400,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,39,106,'und',0,2900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,40,107,'und',0,7500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,41,89,'und',0,13900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,42,88,'und',0,13900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,43,108,'und',0,3900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,44,109,'und',0,4300,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,45,110,'und',0,7900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,46,53,'und',0,2900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,47,111,'und',0,2000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,48,55,'und',0,2400,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,49,112,'und',0,3500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,50,113,'und',0,3000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,51,114,'und',0,39900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,52,115,'und',0,100000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,53,116,'und',0,89900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,54,117,'und',0,8500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,55,119,'und',0,119900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,56,120,'und',0,203500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,57,121,'und',0,129900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,58,122,'und',0,36900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,59,123,'und',0,17900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,60,124,'und',0,34900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,61,68,'und',0,100000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,62,69,'und',0,5500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,63,70,'und',0,129900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,64,71,'und',0,14500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,65,72,'und',0,21900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,66,95,'und',0,49900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,67,94,'und',0,37700,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,68,93,'und',0,59900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,69,76,'und',0,99900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,70,77,'und',0,49900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,71,126,'und',0,68800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,72,127,'und',0,43800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,73,128,'und',0,79900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,74,132,'und',0,54800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,75,143,'und',0,48000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,76,131,'und',0,12800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,77,133,'und',0,15900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,78,134,'und',0,2300,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,79,137,'und',0,19900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,80,141,'und',0,12500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,81,144,'und',0,13000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,82,145,'und',0,15000,'USD','a:1:{s:10:\"components\";a:0:{}}');
/*!40000 ALTER TABLE `field_data_commerce_price` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_commerce_product`
--

DROP TABLE IF EXISTS `field_data_commerce_product`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_commerce_product` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_product_product_id` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `commerce_product_product_id` (`commerce_product_product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 12 (commerce_product)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_commerce_product`
--

LOCK TABLES `field_data_commerce_product` WRITE;
/*!40000 ALTER TABLE `field_data_commerce_product` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_commerce_product` VALUES ('commerce_line_item','product',0,1,1,'und',0,6),('commerce_line_item','product',0,2,2,'und',0,6),('commerce_line_item','product',0,3,3,'und',0,6),('commerce_line_item','product',0,4,4,'und',0,6),('commerce_line_item','product',0,5,5,'und',0,4),('commerce_line_item','product',0,6,6,'und',0,4),('commerce_line_item','product',0,7,7,'und',0,6),('commerce_line_item','product',0,8,8,'und',0,6),('commerce_line_item','product',0,9,9,'und',0,6),('commerce_line_item','product',0,10,10,'und',0,6),('commerce_line_item','product',0,11,11,'und',0,6),('commerce_line_item','product',0,12,12,'und',0,7),('commerce_line_item','product',0,13,13,'und',0,7),('commerce_line_item','product',0,14,14,'und',0,6),('commerce_line_item','product',0,15,15,'und',0,6),('commerce_line_item','product',0,16,16,'und',0,7),('commerce_line_item','product',0,17,17,'und',0,7),('commerce_line_item','product',0,18,18,'und',0,6),('commerce_line_item','product',0,20,20,'und',0,8),('commerce_line_item','product',0,21,21,'und',0,6),('commerce_line_item','product',0,22,22,'und',0,6),('commerce_line_item','product',0,23,23,'und',0,6),('commerce_line_item','product',0,24,24,'und',0,6),('commerce_line_item','product',0,25,25,'und',0,8),('commerce_line_item','product',0,26,26,'und',0,8),('commerce_line_item','product',0,27,27,'und',0,8),('commerce_line_item','product',0,28,28,'und',0,8),('commerce_line_item','product',0,29,29,'und',0,8),('commerce_line_item','product',0,30,30,'und',0,6),('commerce_line_item','product',0,31,31,'und',0,6),('commerce_line_item','product',0,32,32,'und',0,7),('commerce_line_item','product',0,33,33,'und',0,7),('commerce_line_item','product',0,35,35,'und',0,6),('commerce_line_item','product',0,36,36,'und',0,6),('commerce_line_item','product',0,37,37,'und',0,6),('commerce_line_item','product',0,38,38,'und',0,6),('commerce_line_item','product',0,39,39,'und',0,6),('commerce_line_item','product',0,40,40,'und',0,6),('commerce_line_item','product',0,41,41,'und',0,6),('commerce_line_item','product',0,42,42,'und',0,6),('commerce_line_item','product',0,43,43,'und',0,6),('commerce_line_item','product',0,44,44,'und',0,6),('commerce_line_item','product',0,45,45,'und',0,10),('commerce_line_item','product',0,46,46,'und',0,10),('commerce_line_item','product',0,47,47,'und',0,35),('commerce_line_item','product',0,48,48,'und',0,35),('commerce_line_item','product',0,49,49,'und',0,28),('commerce_line_item','product',0,50,50,'und',0,28),('commerce_line_item','product',0,52,52,'und',0,28),('commerce_line_item','product',0,53,53,'und',0,60),('commerce_line_item','product',0,54,54,'und',0,60),('commerce_line_item','product',0,55,55,'und',0,28),('commerce_line_item','product',0,56,56,'und',0,28),('commerce_line_item','product',0,57,57,'und',0,29),('commerce_line_item','product',0,58,58,'und',0,29),('commerce_line_item','product',0,59,59,'und',0,6),('commerce_line_item','product',0,60,60,'und',0,6),('commerce_line_item','product',0,62,62,'und',0,60),('commerce_line_item','product',0,63,63,'und',0,7),('commerce_line_item','product',0,64,64,'und',0,7),('commerce_line_item','product',0,65,65,'und',0,7),('commerce_line_item','product',0,66,66,'und',0,60),('commerce_line_item','product',0,67,67,'und',0,60),('commerce_line_item','product',0,68,68,'und',0,28),('commerce_line_item','product',0,69,69,'und',0,28),('commerce_line_item','product',0,70,70,'und',0,80),('commerce_line_item','product',0,71,71,'und',0,80),('commerce_line_item','product',0,72,72,'und',0,82),('commerce_line_item','product',0,73,73,'und',0,82),('commerce_line_item','product',0,75,75,'und',0,28),('commerce_line_item','product',0,76,76,'und',0,28),('commerce_line_item','product',0,77,77,'und',0,73),('commerce_line_item','product',0,78,78,'und',0,73),('commerce_line_item','product',0,79,79,'und',0,28),('commerce_line_item','product',0,80,80,'und',0,28);
/*!40000 ALTER TABLE `field_data_commerce_product` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_commerce_shipping_service`
--

DROP TABLE IF EXISTS `field_data_commerce_shipping_service`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_commerce_shipping_service` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_shipping_service_value` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `commerce_shipping_service_value` (`commerce_shipping_service_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 28 (commerce_shipping_service)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_commerce_shipping_service`
--

LOCK TABLES `field_data_commerce_shipping_service` WRITE;
/*!40000 ALTER TABLE `field_data_commerce_shipping_service` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_commerce_shipping_service` VALUES ('commerce_line_item','shipping',0,74,74,'und',0,'shipping');
/*!40000 ALTER TABLE `field_data_commerce_shipping_service` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_commerce_stock`
--

DROP TABLE IF EXISTS `field_data_commerce_stock`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_commerce_stock` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_stock_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 46 (commerce_stock)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_commerce_stock`
--

LOCK TABLES `field_data_commerce_stock` WRITE;
/*!40000 ALTER TABLE `field_data_commerce_stock` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_commerce_stock` VALUES ('commerce_product','product',0,4,15,'und',0,0.00),('commerce_product','product',0,6,83,'und',0,9.00),('commerce_product','product',0,7,10,'und',0,8.00),('commerce_product','product',0,8,11,'und',0,10.00),('commerce_product','product',0,9,84,'und',0,3.00),('commerce_product','product',0,10,86,'und',0,5.00),('commerce_product','product',0,11,18,'und',0,1.00),('commerce_product','product',0,12,19,'und',0,1.00),('commerce_product','product',0,13,20,'und',0,1.00),('commerce_product','product',0,14,21,'und',0,1.00),('commerce_product','product',0,15,22,'und',0,1.00),('commerce_product','product',0,16,23,'und',0,5.00),('commerce_product','product',0,17,24,'und',0,4.00),('commerce_product','product',0,18,25,'und',0,10.00),('commerce_product','product',0,19,96,'und',0,5.00),('commerce_product','product',0,20,27,'und',0,2.00),('commerce_product','product',0,21,118,'und',0,10.00),('commerce_product','product',0,22,97,'und',0,6.00),('commerce_product','product',0,23,98,'und',0,5.00),('commerce_product','product',0,24,99,'und',0,7.00),('commerce_product','product',0,25,100,'und',0,1.00),('commerce_product','product',0,26,92,'und',0,5.00),('commerce_product','product',0,27,101,'und',0,5.00),('commerce_product','product',0,28,35,'und',0,5.00),('commerce_product','product',0,29,36,'und',0,1.00),('commerce_product','product',0,30,102,'und',0,3.00),('commerce_product','product',0,31,91,'und',0,10.00),('commerce_product','product',0,32,90,'und',0,4.00),('commerce_product','product',0,33,103,'und',0,5.00),('commerce_product','product',0,34,41,'und',0,6.00),('commerce_product','product',0,35,42,'und',0,4.00),('commerce_product','product',0,36,104,'und',0,20.00),('commerce_product','product',0,37,44,'und',0,5.00),('commerce_product','product',0,38,105,'und',0,2.00),('commerce_product','product',0,39,106,'und',0,4.00),('commerce_product','product',0,40,107,'und',0,5.00),('commerce_product','product',0,41,89,'und',0,5.00),('commerce_product','product',0,42,88,'und',0,5.00),('commerce_product','product',0,43,108,'und',0,5.00),('commerce_product','product',0,44,109,'und',0,5.00),('commerce_product','product',0,45,110,'und',0,3.00),('commerce_product','product',0,46,53,'und',0,100.00),('commerce_product','product',0,47,111,'und',0,5.00),('commerce_product','product',0,48,55,'und',0,4.00),('commerce_product','product',0,49,112,'und',0,4.00),('commerce_product','product',0,50,113,'und',0,6.00),('commerce_product','product',0,51,114,'und',0,5.00),('commerce_product','product',0,52,115,'und',0,6.00),('commerce_product','product',0,53,116,'und',0,4.00),('commerce_product','product',0,54,117,'und',0,8.00),('commerce_product','product',0,55,119,'und',0,5.00),('commerce_product','product',0,56,120,'und',0,6.00),('commerce_product','product',0,57,121,'und',0,1.00),('commerce_product','product',0,58,122,'und',0,2.00),('commerce_product','product',0,59,123,'und',0,5.00),('commerce_product','product',0,60,124,'und',0,5.00),('commerce_product','product',0,61,68,'und',0,1.00),('commerce_product','product',0,62,69,'und',0,5.00),('commerce_product','product',0,63,70,'und',0,4.00),('commerce_product','product',0,64,71,'und',0,5.00),('commerce_product','product',0,65,72,'und',0,6.00),('commerce_product','product',0,66,95,'und',0,5.00),('commerce_product','product',0,67,94,'und',0,5.00),('commerce_product','product',0,68,93,'und',0,5.00),('commerce_product','product',0,69,76,'und',0,3.00),('commerce_product','product',0,70,77,'und',0,5.00),('commerce_product','product',0,71,126,'und',0,5.00),('commerce_product','product',0,72,127,'und',0,5.00),('commerce_product','product',0,73,128,'und',0,4.00),('commerce_product','product',0,74,132,'und',0,4.00),('commerce_product','product',0,75,143,'und',0,6.00),('commerce_product','product',0,76,131,'und',0,7.00),('commerce_product','product',0,77,133,'und',0,7.00),('commerce_product','product',0,78,134,'und',0,1.00),('commerce_product','product',0,79,137,'und',0,5.00),('commerce_product','product',0,80,141,'und',0,5.00),('commerce_product','product',0,81,144,'und',0,5.00),('commerce_product','product',0,82,145,'und',0,5.00);
/*!40000 ALTER TABLE `field_data_commerce_stock` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_commerce_total`
--

DROP TABLE IF EXISTS `field_data_commerce_total`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_commerce_total` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_total_amount` int(11) NOT NULL DEFAULT '0' COMMENT 'The price amount.',
  `commerce_total_currency_code` varchar(32) NOT NULL COMMENT 'The currency code for the price.',
  `commerce_total_data` longtext COMMENT 'A serialized array of additional price data.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `commerce_total_currency_price` (`commerce_total_amount`,`commerce_total_currency_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 11 (commerce_total)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_commerce_total`
--

LOCK TABLES `field_data_commerce_total` WRITE;
/*!40000 ALTER TABLE `field_data_commerce_total` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_commerce_total` VALUES ('commerce_line_item','product',0,1,1,'und',0,5040000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:5040000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,2,2,'und',0,4920000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:4920000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,3,3,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,4,4,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,5,5,'und',0,11500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:11500;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,6,6,'und',0,11500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:11500;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,7,7,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,8,8,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,9,9,'und',0,5040000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:5040000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,10,10,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,11,11,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,12,12,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:200000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,13,13,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:200000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,14,14,'und',0,240000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:240000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,15,15,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,16,16,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:200000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,17,17,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:200000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,18,18,'und',0,240000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:240000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,20,20,'und',0,300000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:300000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,21,21,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,22,22,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,23,23,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,24,24,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,25,25,'und',0,300000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:300000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,26,26,'und',0,300000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:300000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,27,27,'und',0,600000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:600000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,28,28,'und',0,300000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:300000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,29,29,'und',0,600000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:600000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,30,30,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,31,31,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,32,32,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:200000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,33,33,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:200000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,35,35,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,36,36,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,37,37,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,38,38,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,39,39,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,40,40,'und',0,240000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:240000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,41,41,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,42,42,'und',0,240000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:240000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,43,43,'und',0,360000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:360000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,44,44,'und',0,240000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:240000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,45,45,'und',0,3800,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:3800;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,46,46,'und',0,3800,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:3800;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,47,47,'und',0,59900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:59900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,48,48,'und',0,59900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:59900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,49,49,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,50,50,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,52,52,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,53,53,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:34900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,54,54,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:34900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,55,55,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,56,56,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,57,57,'und',0,100000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:100000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,58,58,'und',0,100000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:100000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,59,59,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,60,60,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,62,62,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:34900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,63,63,'und',0,400000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:400000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,64,64,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:200000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,65,65,'und',0,400000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:400000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,66,66,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:34900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,67,67,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:34900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,68,68,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,69,69,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,70,70,'und',0,12500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:12500;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,71,71,'und',0,12500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:12500;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,72,72,'und',0,15000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:15000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,73,73,'und',0,15000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:15000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','shipping',0,74,74,'und',0,1200,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:18:\"flat_rate_shipping\";s:5:\"price\";a:3:{s:6:\"amount\";i:1200;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,75,75,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,76,76,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,77,77,'und',0,79900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:79900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,78,78,'und',0,79900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:79900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,79,79,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,80,80,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}');
/*!40000 ALTER TABLE `field_data_commerce_total` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_commerce_unit_price`
--

DROP TABLE IF EXISTS `field_data_commerce_unit_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_commerce_unit_price` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_unit_price_amount` int(11) NOT NULL DEFAULT '0' COMMENT 'The price amount.',
  `commerce_unit_price_currency_code` varchar(32) NOT NULL COMMENT 'The currency code for the price.',
  `commerce_unit_price_data` longtext COMMENT 'A serialized array of additional price data.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `commerce_unit_price_currency_price` (`commerce_unit_price_amount`,`commerce_unit_price_currency_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 10 (commerce_unit_price)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_commerce_unit_price`
--

LOCK TABLES `field_data_commerce_unit_price` WRITE;
/*!40000 ALTER TABLE `field_data_commerce_unit_price` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_commerce_unit_price` VALUES ('commerce_line_item','product',0,1,1,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,2,2,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,3,3,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,4,4,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,5,5,'und',0,11500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"11500\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,6,6,'und',0,11500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"11500\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,7,7,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,8,8,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,9,9,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,10,10,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,11,11,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,12,12,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"200000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,13,13,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"200000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,14,14,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,15,15,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,16,16,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"200000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,17,17,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"200000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,18,18,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,20,20,'und',0,300000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"300000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,21,21,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,22,22,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,23,23,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,24,24,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,25,25,'und',0,300000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"300000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,26,26,'und',0,300000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"300000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,27,27,'und',0,300000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"300000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,28,28,'und',0,300000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"300000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,29,29,'und',0,300000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"300000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,30,30,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,31,31,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,32,32,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"200000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,33,33,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"200000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,35,35,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,36,36,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,37,37,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,38,38,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,39,39,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,40,40,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,41,41,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,42,42,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,43,43,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,44,44,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,45,45,'und',0,3800,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:4:\"3800\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,46,46,'und',0,3800,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:4:\"3800\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,47,47,'und',0,59900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"59900\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,48,48,'und',0,59900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"59900\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,49,49,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"70000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,50,50,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"70000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,52,52,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"70000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,53,53,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"34900\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,54,54,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"34900\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,55,55,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"70000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,56,56,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"70000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,57,57,'und',0,100000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"100000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,58,58,'und',0,100000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"100000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,59,59,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,60,60,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,62,62,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"34900\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,63,63,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"200000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,64,64,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"200000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,65,65,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"200000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,66,66,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"34900\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,67,67,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"34900\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,68,68,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"70000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,69,69,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"70000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,70,70,'und',0,12500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"12500\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,71,71,'und',0,12500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"12500\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,72,72,'und',0,15000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"15000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,73,73,'und',0,15000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"15000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','shipping',0,74,74,'und',0,1200,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:18:\"flat_rate_shipping\";s:5:\"price\";a:3:{s:6:\"amount\";s:4:\"1200\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,75,75,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"70000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,76,76,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"70000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,77,77,'und',0,79900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"79900\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,78,78,'und',0,79900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"79900\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,79,79,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"70000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,80,80,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"70000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}');
/*!40000 ALTER TABLE `field_data_commerce_unit_price` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_bean_icon`
--

DROP TABLE IF EXISTS `field_data_field_bean_icon`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_bean_icon` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_bean_icon_bundle` varchar(64) DEFAULT NULL,
  `field_bean_icon_icon` varchar(64) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 42 (field_bean_icon)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_bean_icon`
--

LOCK TABLES `field_data_field_bean_icon` WRITE;
/*!40000 ALTER TABLE `field_data_field_bean_icon` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `field_data_field_bean_icon` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_body`
--

DROP TABLE IF EXISTS `field_data_field_body`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_body` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_body_value` longtext,
  `field_body_summary` longtext,
  `field_body_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_body_format` (`field_body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 43 (field_body)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_body`
--

LOCK TABLES `field_data_field_body` WRITE;
/*!40000 ALTER TABLE `field_data_field_body` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `field_data_field_body` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_boolean`
--

DROP TABLE IF EXISTS `field_data_field_boolean`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_boolean` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_boolean_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_boolean_value` (`field_boolean_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 44 (field_boolean)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_boolean`
--

LOCK TABLES `field_data_field_boolean` WRITE;
/*!40000 ALTER TABLE `field_data_field_boolean` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_boolean` VALUES ('node','product',0,30,30,'und',0,0),('node','product',0,31,31,'und',0,0),('node','product',0,32,32,'und',0,0),('node','product',0,33,33,'und',0,0),('node','product',0,34,34,'und',0,0),('node','product',0,35,35,'und',0,0),('node','product',0,36,36,'und',0,0),('node','product',0,37,37,'und',0,0),('node','product',0,38,38,'und',0,0),('node','product',0,39,39,'und',0,0),('node','product',0,40,40,'und',0,0),('node','product',0,41,41,'und',0,0),('node','product',0,42,42,'und',0,0),('node','product',0,43,43,'und',0,0),('node','product',0,44,44,'und',0,1),('node','product',0,45,45,'und',0,1),('node','product',0,46,46,'und',0,1),('node','product',0,47,47,'und',0,0),('node','product',0,48,48,'und',0,0),('node','product',0,49,49,'und',0,0),('node','product',0,50,50,'und',0,0),('node','product',0,51,51,'und',0,0),('node','product',0,52,52,'und',0,1),('node','product',0,53,53,'und',0,0),('node','product',0,54,54,'und',0,0),('node','product',0,55,55,'und',0,0),('node','product',0,56,56,'und',0,0),('node','product',0,57,57,'und',0,0),('node','product',0,58,58,'und',0,0),('node','product',0,59,59,'und',0,0),('node','product',0,60,60,'und',0,0),('node','product',0,61,61,'und',0,0),('node','product',0,62,62,'und',0,0),('node','product',0,63,63,'und',0,0),('node','product',0,64,64,'und',0,0),('node','product',0,65,65,'und',0,0),('node','product',0,66,66,'und',0,0),('node','product',0,67,67,'und',0,0),('node','product',0,68,68,'und',0,0),('node','product',0,69,69,'und',0,0),('node','product',0,70,70,'und',0,0),('node','product',0,71,71,'und',0,1),('node','product',0,72,72,'und',0,0),('node','product',0,73,73,'und',0,0),('node','product',0,74,74,'und',0,0),('node','product',0,75,75,'und',0,0),('node','product',0,76,76,'und',0,0),('node','product',0,77,77,'und',0,0),('node','product',0,78,78,'und',0,0),('node','product',0,79,79,'und',0,0),('node','product',0,80,80,'und',0,0),('node','product',0,81,81,'und',0,0),('node','product',0,82,82,'und',0,0),('node','product',0,83,83,'und',0,0),('node','product',0,84,84,'und',0,0),('node','product',0,85,85,'und',0,0),('node','product',0,86,86,'und',0,0),('node','product',0,88,88,'und',0,0),('node','product',0,89,89,'und',0,0),('node','product',0,90,90,'und',0,0),('node','product',0,91,91,'und',0,0),('node','product',0,92,92,'und',0,0),('node','product',0,93,93,'und',0,0),('node','product',0,94,94,'und',0,0),('node','product',0,95,95,'und',0,0),('node','product',0,96,96,'und',0,0),('node','product',0,97,97,'und',0,0),('node','product',0,138,138,'und',0,0),('node','product',0,139,139,'und',0,0);
/*!40000 ALTER TABLE `field_data_field_boolean` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_brand`
--

DROP TABLE IF EXISTS `field_data_field_brand`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_brand` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_brand_tid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_brand_tid` (`field_brand_tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 21 (field_brand)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_brand`
--

LOCK TABLES `field_data_field_brand` WRITE;
/*!40000 ALTER TABLE `field_data_field_brand` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_brand` VALUES ('node','product',0,30,30,'und',0,74),('node','product',0,31,31,'und',0,75),('node','product',0,32,32,'und',0,76),('node','product',0,33,33,'und',0,78),('node','product',0,34,34,'und',0,79),('node','product',0,35,35,'und',0,81),('node','product',0,36,36,'und',0,82),('node','product',0,37,37,'und',0,83),('node','product',0,38,38,'und',0,82),('node','product',0,39,39,'und',0,84),('node','product',0,40,40,'und',0,85),('node','product',0,41,41,'und',0,86),('node','product',0,42,42,'und',0,87),('node','product',0,43,43,'und',0,82),('node','product',0,44,44,'und',0,10),('node','product',0,45,45,'und',0,11),('node','product',0,46,46,'und',0,13),('node','product',0,47,47,'und',0,88),('node','product',0,48,48,'und',0,14),('node','product',0,49,49,'und',0,10),('node','product',0,50,50,'und',0,13),('node','product',0,51,51,'und',0,88),('node','product',0,52,52,'und',0,10),('node','product',0,53,53,'und',0,89),('node','product',0,54,54,'und',0,11),('node','product',0,55,55,'und',0,82),('node','product',0,56,56,'und',0,90),('node','product',0,57,57,'und',0,10),('node','product',0,58,58,'und',0,91),('node','product',0,59,59,'und',0,82),('node','product',0,60,60,'und',0,82),('node','product',0,61,61,'und',0,92),('node','product',0,62,62,'und',0,93),('node','product',0,63,63,'und',0,94),('node','product',0,64,64,'und',0,94),('node','product',0,65,65,'und',0,95),('node','product',0,66,66,'und',0,95),('node','product',0,67,67,'und',0,97),('node','product',0,68,68,'und',0,96),('node','product',0,69,69,'und',0,99),('node','product',0,70,70,'und',0,82),('node','product',0,71,71,'und',0,11),('node','product',0,72,72,'und',0,11),('node','product',0,73,73,'und',0,91),('node','product',0,74,74,'und',0,11),('node','product',0,75,75,'und',0,82),('node','product',0,76,76,'und',0,10),('node','product',0,77,77,'und',0,12),('node','product',0,78,78,'und',0,82),('node','product',0,79,79,'und',0,12),('node','product',0,80,80,'und',0,100),('node','product',0,81,81,'und',0,100),('node','product',0,82,82,'und',0,102),('node','product',0,83,83,'und',0,101),('node','product',0,84,84,'und',0,98),('node','product',0,85,85,'und',0,102),('node','product',0,86,86,'und',0,102),('node','product',0,88,88,'und',0,11),('node','product',0,89,89,'und',0,103),('node','product',0,90,90,'und',0,102),('node','product',0,91,91,'und',0,111),('node','product',0,92,92,'und',0,112),('node','product',0,93,93,'und',0,113),('node','product',0,94,94,'und',0,114),('node','product',0,95,95,'und',0,115),('node','product',0,96,96,'und',0,116),('node','product',0,97,97,'und',0,117),('node','banner',0,135,135,'und',0,13),('node','banner',0,136,136,'und',0,96),('node','banner',0,137,137,'und',0,102),('node','product',0,138,138,'und',0,118),('node','product',0,139,139,'und',0,119);
/*!40000 ALTER TABLE `field_data_field_brand` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_category`
--

DROP TABLE IF EXISTS `field_data_field_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_category` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_category_tid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_category_tid` (`field_category_tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 18 (field_category)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_category`
--

LOCK TABLES `field_data_field_category` WRITE;
/*!40000 ALTER TABLE `field_data_field_category` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_category` VALUES ('node','product',0,30,30,'und',0,77),('node','product',0,31,31,'und',0,77),('node','product',0,32,32,'und',0,66),('node','product',0,33,33,'und',0,66),('node','product',0,34,34,'und',0,67),('node','product',0,35,35,'und',0,67),('node','product',0,36,36,'und',0,68),('node','product',0,37,37,'und',0,68),('node','product',0,38,38,'und',0,71),('node','product',0,39,39,'und',0,71),('node','product',0,40,40,'und',0,70),('node','product',0,41,41,'und',0,70),('node','product',0,42,42,'und',0,72),('node','product',0,43,43,'und',0,72),('node','product',0,44,44,'und',0,28),('node','product',0,45,45,'und',0,28),('node','product',0,46,46,'und',0,41),('node','product',0,47,47,'und',0,29),('node','product',0,48,48,'und',0,29),('node','product',0,49,49,'und',0,31),('node','product',0,50,50,'und',0,31),('node','product',0,51,51,'und',0,32),('node','product',0,52,52,'und',0,32),('node','product',0,53,53,'und',0,34),('node','product',0,54,54,'und',0,34),('node','product',0,55,55,'und',0,35),('node','product',0,56,56,'und',0,35),('node','product',0,57,57,'und',0,39),('node','product',0,58,58,'und',0,39),('node','product',0,59,59,'und',0,38),('node','product',0,60,60,'und',0,38),('node','product',0,61,61,'und',0,53),('node','product',0,62,62,'und',0,53),('node','product',0,63,63,'und',0,48),('node','product',0,64,64,'und',0,48),('node','product',0,65,65,'und',0,49),('node','product',0,66,66,'und',0,49),('node','product',0,67,67,'und',0,51),('node','product',0,68,68,'und',0,51),('node','product',0,69,69,'und',0,52),('node','product',0,70,70,'und',0,52),('node','product',0,71,71,'und',0,61),('node','product',0,72,72,'und',0,61),('node','product',0,73,73,'und',0,63),('node','product',0,74,74,'und',0,63),('node','product',0,75,75,'und',0,64),('node','product',0,76,76,'und',0,64),('node','product',0,77,77,'und',0,41),('node','product',0,78,78,'und',0,44),('node','product',0,79,79,'und',0,44),('node','product',0,80,80,'und',0,45),('node','product',0,81,81,'und',0,45),('node','product',0,82,82,'und',0,42),('node','product',0,83,83,'und',0,42),('node','product',0,84,84,'und',0,17),('node','product',0,85,85,'und',0,17),('node','product',0,86,86,'und',0,18),('node','banner',0,87,87,'und',0,71),('node','product',0,88,88,'und',0,18),('node','product',0,89,89,'und',0,25),('node','product',0,90,90,'und',0,25),('node','product',0,91,91,'und',0,26),('node','product',0,92,92,'und',0,22),('node','product',0,93,93,'und',0,22),('node','product',0,94,94,'und',0,23),('node','product',0,95,95,'und',0,58),('node','product',0,96,96,'und',0,59),('node','product',0,97,97,'und',0,57),('node','banner',0,98,98,'und',0,58),('node','banner',0,99,99,'und',0,59),('node','banner',0,100,100,'und',0,57),('node','banner',0,101,101,'und',0,77),('node','banner',0,102,102,'und',0,67),('node','banner',0,103,103,'und',0,68),('node','banner',0,104,104,'und',0,70),('node','banner',0,105,105,'und',0,72),('node','banner',0,106,106,'und',0,73),('node','banner',0,107,107,'und',0,29),('node','banner',0,108,108,'und',0,35),('node','banner',0,109,109,'und',0,34),('node','banner',0,110,110,'und',0,28),('node','banner',0,111,111,'und',0,31),('node','banner',0,112,112,'und',0,32),('node','banner',0,113,113,'und',0,39),('node','banner',0,114,114,'und',0,38),('node','banner',0,115,115,'und',0,53),('node','banner',0,116,116,'und',0,48),('node','banner',0,117,117,'und',0,49),('node','banner',0,118,118,'und',0,51),('node','banner',0,119,119,'und',0,52),('node','banner',0,120,120,'und',0,61),('node','banner',0,121,121,'und',0,63),('node','banner',0,122,122,'und',0,64),('node','banner',0,123,123,'und',0,40),('node','banner',0,124,124,'und',0,41),('node','banner',0,125,125,'und',0,44),('node','banner',0,126,126,'und',0,45),('node','banner',0,127,127,'und',0,42),('node','banner',0,128,128,'und',0,17),('node','banner',0,129,129,'und',0,18),('node','banner',0,130,130,'und',0,26),('node','banner',0,131,131,'und',0,25),('node','banner',0,132,132,'und',0,22),('node','banner',0,133,133,'und',0,23),('node','banner',0,134,134,'und',0,66),('node','product',0,138,138,'und',0,73),('node','product',0,139,139,'und',0,73),('node','banner',0,140,140,'und',0,26);
/*!40000 ALTER TABLE `field_data_field_category` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_colllect_title`
--

DROP TABLE IF EXISTS `field_data_field_colllect_title`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_colllect_title` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_colllect_title_value` varchar(255) DEFAULT NULL,
  `field_colllect_title_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_colllect_title_format` (`field_colllect_title_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 36 (field_colllect_title)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_colllect_title`
--

LOCK TABLES `field_data_field_colllect_title` WRITE;
/*!40000 ALTER TABLE `field_data_field_colllect_title` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_colllect_title` VALUES ('field_collection_item','field_specifications',0,7,7,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,8,8,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,9,9,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,14,14,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,15,15,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,16,16,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,17,17,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,18,18,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,19,19,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,20,20,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,21,21,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,26,26,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,27,27,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,28,28,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,29,29,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,30,30,'und',0,'Material',NULL),('field_collection_item','field_specifications',0,33,33,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,34,34,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,35,35,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,36,36,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,37,37,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,38,38,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,39,39,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,40,40,'und',0,'Warranty Period',NULL),('field_collection_item','field_specifications',0,41,41,'und',0,'Warranty Type',NULL),('field_collection_item','field_specifications',0,42,42,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,43,43,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,44,44,'und',0,'Weight ',NULL),('field_collection_item','field_specifications',0,45,45,'und',0,'Warranty Period',NULL),('field_collection_item','field_specifications',0,47,47,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,48,48,'und',0,'Mode',NULL),('field_collection_item','field_specifications',0,49,49,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,50,50,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,54,54,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,55,55,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,56,56,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,57,57,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,58,58,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,59,59,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,60,60,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,61,61,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,64,64,'und',0,'Author',NULL),('field_collection_item','field_specifications',0,66,66,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,67,67,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,68,68,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,69,69,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,70,70,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,71,71,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,72,72,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,75,75,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,76,76,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,77,77,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,78,78,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,79,79,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,80,80,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,81,81,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,85,85,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,86,86,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,87,87,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,92,92,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,93,93,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,94,94,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,95,95,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,101,101,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,102,102,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,103,103,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,110,110,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,111,111,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,112,112,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,113,113,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,114,114,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,124,124,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,125,125,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,126,126,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,127,127,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,128,128,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,129,129,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,130,130,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,143,143,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,144,144,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,145,145,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,150,150,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,151,151,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,152,152,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,153,153,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,155,155,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,156,156,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,157,157,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,160,160,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,161,161,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,162,162,'und',0,'Warranty Period',NULL),('field_collection_item','field_specifications',0,163,163,'und',0,'Warranty Type',NULL),('field_collection_item','field_specifications',0,164,164,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,165,165,'und',0,'Product Line',NULL),('field_collection_item','field_specifications',0,166,166,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,167,167,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,168,168,'und',0,'Color',NULL),('field_collection_item','field_specifications',0,169,169,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,170,170,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,171,171,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,175,175,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,176,176,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,177,177,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,178,178,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,179,179,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,180,180,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,181,181,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,182,182,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,183,183,'und',0,'Compatible Phones',NULL),('field_collection_item','field_specifications',0,184,184,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,185,185,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,186,186,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,187,187,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,188,188,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,189,189,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,190,190,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,191,191,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,192,192,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,193,193,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,194,194,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,195,195,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,196,196,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,197,197,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,198,198,'und',0,'Color',NULL),('field_collection_item','field_specifications',0,199,199,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,200,200,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,201,201,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,202,202,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,203,203,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,204,204,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,205,205,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,206,206,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,207,207,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,208,208,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,209,209,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,210,210,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,211,211,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,212,212,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,213,213,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,214,214,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,215,215,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,216,216,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,217,217,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,218,218,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,219,219,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,220,220,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,221,221,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,222,222,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,223,223,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,224,224,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,225,225,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,226,226,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,227,227,'und',0,'Compatible Phones',NULL),('field_collection_item','field_specifications',0,228,228,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,229,229,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,230,230,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,234,234,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,235,235,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,236,236,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,237,237,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,238,238,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,239,239,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,240,240,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,241,241,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,242,242,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,243,243,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,244,244,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,245,245,'und',0,'Network',NULL),('field_collection_item','field_specifications',0,246,246,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,247,247,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,248,248,'und',0,'Uses & Properties',NULL),('field_collection_item','field_specifications',0,249,249,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,250,250,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,251,251,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,252,252,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,253,253,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,254,254,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,255,255,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,256,256,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,257,257,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,258,258,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,259,259,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,260,260,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,261,261,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,262,262,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,263,263,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,267,267,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,268,268,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,269,269,'und',0,'Display Size (inch)',NULL),('field_collection_item','field_specifications',0,270,270,'und',0,'Megapixels',NULL),('field_collection_item','field_specifications',0,271,271,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,272,272,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,273,273,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,274,274,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,275,275,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,276,276,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,277,277,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,278,278,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,279,279,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,280,280,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,281,281,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,282,282,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,283,283,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,284,284,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,285,285,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,286,286,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,287,287,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,288,288,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,289,289,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,290,290,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,291,291,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,292,292,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,293,293,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,294,294,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,295,295,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,296,296,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,297,297,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,298,298,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,299,299,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,300,300,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,301,301,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,302,302,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,303,303,'und',0,'Weight',NULL);
/*!40000 ALTER TABLE `field_data_field_colllect_title` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_color`
--

DROP TABLE IF EXISTS `field_data_field_color`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_color` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_color_value` varchar(255) DEFAULT NULL,
  `field_color_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_color_format` (`field_color_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 50 (field_color)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_color`
--

LOCK TABLES `field_data_field_color` WRITE;
/*!40000 ALTER TABLE `field_data_field_color` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_color` VALUES ('taxonomy_term','color',0,104,104,'und',0,'#000000',NULL),('taxonomy_term','color',0,105,105,'und',0,'#ffffff',NULL),('taxonomy_term','color',0,106,106,'und',0,'#000099',NULL),('taxonomy_term','color',0,107,107,'und',0,'#cd0000',NULL),('taxonomy_term','color',0,108,108,'und',0,'#ff8d00',NULL),('taxonomy_term','color',0,109,109,'und',0,'#ffc0cb',NULL),('taxonomy_term','color',0,110,110,'und',0,'#00ff00',NULL);
/*!40000 ALTER TABLE `field_data_field_color` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_description`
--

DROP TABLE IF EXISTS `field_data_field_description`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_description` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_description_value` longtext,
  `field_description_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_description_format` (`field_description_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 49 (field_description)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_description`
--

LOCK TABLES `field_data_field_description` WRITE;
/*!40000 ALTER TABLE `field_data_field_description` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_description` VALUES ('field_collection_item','field_specifications',0,7,7,'und',0,'<p>AE217FAAPMF5ANMY-727141</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,8,8,'und',0,'<p>31 x 18 x 51</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,9,9,'und',0,'<table class=\"prd-attributes ui-grid ui-gridFull\">\r\n	<tbody>\r\n		<tr>\r\n			<td>0.8</td>\r\n		</tr>\r\n	</tbody>\r\n</table>\r\n','filtered_html'),('field_collection_item','field_specifications',0,14,14,'und',0,'<p>LO024FAAKSJ4ANMY-530660</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,15,15,'und',0,'<p>B0008 Orange</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,16,16,'und',0,'<p>52x18x33</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,17,17,'und',0,'<p>0.9</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,18,18,'und',0,'<p>TE960FAAKJC3ANMY-515575</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,19,19,'und',0,'<p>T02-297LAP-01</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,20,20,'und',0,'<p>33x15x40</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,21,21,'und',0,'<p>0.50</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,26,26,'und',0,'<p>TA452FAAL25AANMY-544771</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,27,27,'und',0,'<p>Targus-TSB166AP-50-BK</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,28,28,'und',0,'<p>37.46 x 26.03 x 3.88</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,29,29,'und',0,'<p>1.63kg</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,30,30,'und',0,'<p>Polyester</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,33,33,'und',0,'<p>TA073FAAQQFQANMY-793372</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,34,34,'und',0,'<p>9\" x 13.5\" x 4.5\"</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,35,35,'und',0,'<p>0.4</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,36,36,'und',0,'<div>DI503FAAP8LHANMY-703741</div>\r\n','filtered_html'),('field_collection_item','field_specifications',0,37,37,'und',0,'<p>B0077-3</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,38,38,'und',0,'<p>12 x 21.5 x 29</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,39,39,'und',0,'<p>0.26</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,40,40,'und',0,'<p>1 Month</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,41,41,'und',0,'<p>Local Supplier Warranty</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,42,42,'und',0,'<p>OE702HBAMQYBANMY-647350</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,43,43,'und',0,'<p>18 x 10 x 5</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,44,44,'und',0,'<p>3 Months</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,45,45,'und',0,'<p>Local Supplier Warranty</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,47,47,'und',0,'<p>CA065HBAS3UKANMY-866687</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,48,48,'und',0,'<p>MakeUp Kit 396 (48x Eyeshadow, 24x Lip Color, 2x Pressed Powder, 4x Blusher, 5x Applicator)</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,49,49,'und',0,'<p>10x10x10</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,50,50,'und',0,'<p>0.4</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,54,54,'und',0,'<p>OE702HBAT78LANMY-922903</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,55,55,'und',0,'<p>Power Perfect Pore</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,56,56,'und',0,'<p>16 x 13 x 8</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,57,57,'und',0,'<p>0.2</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,58,58,'und',0,'<p>SK159HBASXK7ANMY-908752</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,59,59,'und',0,'<p>SK222HBAQYN8ANMY-807324</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,60,60,'und',0,'<p>12 x 17 x 23</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,61,61,'und',0,'<p>1</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,64,64,'und',0,'<p>www.skinblossom.com.my</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,66,66,'und',0,'<p>ME223HBAT7XUANMY-924008</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,67,67,'und',0,'<p>15x15x15</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,68,68,'und',0,'<p>0.5</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,69,69,'und',0,'<p>HA181HBASX9JANMY-908363</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,70,70,'und',0,'<p>(AUS) 5000</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,71,71,'und',0,'<p>23 x 9 x 23</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,72,72,'und',0,'<p>1</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,75,75,'und',0,'<p>OE702HBAST9QANMY-901982</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,76,76,'und',0,'<p>Tonific Slimming Massager</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,77,77,'und',0,'<p>26 x 11 x 18</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,78,78,'und',0,'<p>1</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,79,79,'und',0,'<p>AP564ELAPUHIANMY-741814</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,80,80,'und',0,'<p>IPHONE6</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,81,81,'und',0,'<p>8x4x3</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,85,85,'und',0,'<p>SA356ELAQRCJANMY-794737</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,86,86,'und',0,'<p>N910</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,87,87,'und',0,'<p>8 x 4 x 1</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,92,92,'und',0,'<p>AS575ELAT5HFANMY-920560</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,93,93,'und',0,'<p>P1801-B041K , F9-ASURTN56U</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,94,94,'und',0,'<p>40x45x30</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,95,95,'und',0,'<p>3</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,101,101,'und',0,'<p>LE106ELAT4HKANMY-918581</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,102,102,'und',0,'<p>A316</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,103,103,'und',0,'<p>7x2x12</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,110,110,'und',0,'<p>NO225ELAK8TTANMY-497673</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,111,111,'und',0,'<p>AP564ELAPEZNANMY-715186</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,112,112,'und',0,'<p>MD368</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,113,113,'und',0,'<p>17 x 22 x 2</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,114,114,'und',0,'<p>0.2</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,124,124,'und',0,'<p>OE702ELAS5KHANMY-868993</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,125,125,'und',0,'<p>12 x 1 x 19.7</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,126,126,'und',0,'<p>0.1</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,127,127,'und',0,'<p>LE106ELASXT7ANMY-909117</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,128,128,'und',0,'<p>Miix 2 59399848</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,129,129,'und',0,'<p>13.2 x 0.7 x 21.6</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,130,130,'und',0,'<p>0.35</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,143,143,'und',0,'<p>AP564ELAT12EANMY-913520</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,144,144,'und',0,'<p>MD785ZPA</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,145,145,'und',0,'<p>24 x 16.95 x 0.75</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,150,150,'und',0,'<p>SP889ELASU66ANMY-903500</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,151,151,'und',0,'<p>Samsung Galaxy Note 4</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,152,152,'und',0,'<p>16 x 8.5 x 1</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,153,153,'und',0,'<p>0.08</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,155,155,'und',0,'<p>SA356ELAT7YMANMY-924036</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,156,156,'und',0,'<p>8.16 x 1.33 x 15.46</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,157,157,'und',0,'<p>63g</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,160,160,'und',0,'<p>OE702ELAK0U8ANMY-486129</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,161,161,'und',0,'<p>Samsung Galaxy Tab 7.0 Plus Vehicle Dock With In-Car Charger</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,162,162,'und',0,'<p>6 Months</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,163,163,'und',0,'<p>Local Supplier Warranty</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,164,164,'und',0,'<p>OT343ELAM59DANMY-609257</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,165,165,'und',0,'<p>Car Accessories</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,166,166,'und',0,'<p>P338</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,167,167,'und',0,'<p>0.1kg</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,168,168,'und',0,'<p>Black</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,169,169,'und',0,'<p>AP564ELALLJMANMY-575572</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,170,170,'und',0,'<p>6x2x6</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,171,171,'und',0,'<p>15g</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,175,175,'und',0,'<p>SO406ELAKPRJANMY-525732</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,176,176,'und',0,'<p>SBH20</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,177,177,'und',0,'<p>13x10x4.5</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,178,178,'und',0,'<p>OE702ELASS8BANMY-900509</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,179,179,'und',0,'<p>5x3.5x2.5</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,180,180,'und',0,'<p>0.5</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,181,181,'und',0,'<p>OE702EL51SMMANMY-130613</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,182,182,'und',0,'<p>13.5 x 7.0 x 2.2cm</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,183,183,'und',0,'<p>Nokia|Apple|LG|Samsung|Blackberry</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,184,184,'und',0,'<p>MU553FAARFDMANMY-830725</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,185,185,'und',0,'<p>Everlasting Love Set</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,186,186,'und',0,'<p>42 x 2 x 1</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,187,187,'und',0,'<p>LU757FAAT3KBANMY-916954</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,188,188,'und',0,'<p>43cm x 7cm extender chain</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,189,189,'und',0,'<p>0.2</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,190,190,'und',0,'<p>DA883FAAL9R7ANMY-556875</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,191,191,'und',0,'<p>2605-0005-99127-17 White</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,192,192,'und',0,'<p>110L x 2W x 0.3H cm</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,193,193,'und',0,'<p>DA883FAAL9QSANMY-556860</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,194,194,'und',0,'<p>2601-0337-99138-5 Orange</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,195,195,'und',0,'<p>110L x 2W x 0.3H cm</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,196,196,'und',0,'<p>FU022FAALCH2ANMY-561503</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,197,197,'und',0,'<p>0.18 kg</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,198,198,'und',0,'<p>Yellow Brown</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,199,199,'und',0,'<p>FU022FAAL7JTANMY-553296</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,200,200,'und',0,'<p>FS0005/white White</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,201,201,'und',0,'<p>90 x 180</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,202,202,'und',0,'<p>IN656FAAS6G7ANMY-870227</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,203,203,'und',0,'<p>15422</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,204,204,'und',0,'<p>12x12x12</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,205,205,'und',0,'<p>RO180FAASX6RANMY-908233</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,206,206,'und',0,'<p>114060</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,207,207,'und',0,'<p>15cm x 17cm x 13cm</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,208,208,'und',0,'<p>SU433FAASXLFANMY-908796</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,209,209,'und',0,'<p>SUSS010600610</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,210,210,'und',0,'<p>5.14 x 4.56 x 1.53</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,211,211,'und',0,'<p>OE702FAASHKNANMY-885439</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,212,212,'und',0,'<p>955</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,213,213,'und',0,'<p>25 cm x 5.2 cm x 1.5 cm</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,214,214,'und',0,'<p>SA356ELAROW3ANMY-844449</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,215,215,'und',0,'<p>UA40H5008ARXXM</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,216,216,'und',0,'<p>9.1x90.5x56.2</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,217,217,'und',0,'<p>SO406ELAMA8AANMY-618653</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,218,218,'und',0,'<p>19.6x108.6x67.4</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,219,219,'und',0,'<p>9.10</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,220,220,'und',0,'<p>SO406ELAO9YXANMY-651058</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,221,221,'und',0,'<p>BDV-N9200W</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,222,222,'und',0,'<p>SA356ELAOL1VANMY-666683</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,223,223,'und',0,'<p>HTE350K</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,224,224,'und',0,'<p>Main 43 x 5.6 x 25</p>\r\n\r\n<p>Front Speaker 7.7 x 10.7 x 6.8</p>\r\n\r\n<p>Center Speaker 22.8 x 7.7 x 7</p>\r\n\r\n<p>Surround Speaker 7.7 x 10.7 x 6.8</p>\r\n\r\n<p>Sub Woofer 15.5 x 30 x 28.5</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,225,225,'und',0,'<p>OE702ELAMNJ0ANMY-642088</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,226,226,'und',0,'<p>L12S</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,227,227,'und',0,'<p>Apple | LG | Samsung | HTC</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,228,228,'und',0,'<p>AP564ELALVSWANMY-592956</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,229,229,'und',0,'<p>23 mm x 98 mm x 98 mm</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,230,230,'und',0,'<p>0.27 kg</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,234,234,'und',0,'<p>DE759ELAT5R5ANMY-920910</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,235,235,'und',0,'<p>X51-77822G</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,236,236,'und',0,'<p>6kg</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,237,237,'und',0,'<p>OE702ELAKQT4ANMY-527371</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,238,238,'und',0,'<p>HDMI/3P</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,239,239,'und',0,'<p>3x14x15</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,240,240,'und',0,'<table class=\"prd-attributes ui-grid ui-gridFull\">\r\n	<tbody>\r\n		<tr>\r\n			<td>\r\n			<div>DE759ELAP5I7ANMY-696915</div>\r\n			</td>\r\n		</tr>\r\n	</tbody>\r\n</table>\r\n','filtered_html'),('field_collection_item','field_specifications',0,241,241,'und',0,'<p>5524P 24</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,242,242,'und',0,'<p>38.1 x 44.0 x 4.32cm</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,243,243,'und',0,'<p>TP481ELAKVC0ANMY-535125</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,244,244,'und',0,'<p>TL-M5250</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,245,245,'und',0,'<p>HSPA+</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,246,246,'und',0,'<p>TP481ELAJQBOANMY-468439</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,247,247,'und',0,'<p>TL-WDR4300</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,248,248,'und',0,'<p>4 x 10/100/1000Mbps LAN Ports<br />\r\n1 x 10/100/1000Mbps WAN Port<br />\r\n2 x USB 2.0 Port<br />\r\nCertification: CE, FCC,IC, RoHS<br />\r\nFrequency: 2.4GHz &amp; 5GHz</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,249,249,'und',0,'<p>CA673ELAM9XUANMY-618219</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,250,250,'und',0,'<p>LiDE 210</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,251,251,'und',0,'<p>36.5 x 25 x 3.9</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,252,252,'und',0,'<p>EP840ELALTF7ANMY-589363</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,253,253,'und',0,'<p>V33</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,254,254,'und',0,'<p>43 x 28 x 3</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,255,255,'und',0,'<div>CA680ELAPVLXANMY-743566</div>\r\n','filtered_html'),('field_collection_item','field_specifications',0,256,256,'und',0,'<p>EX-ZR1500</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,257,257,'und',0,'<p>107.5(W) x 61.5(H) x 36.7(D) mm</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,258,258,'und',0,'<p>CA673ELARXO5ANMY-857455</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,259,259,'und',0,'<p>SX60 HS</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,260,260,'und',0,'<p>12.76 x 9.26 x 11.43</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,261,261,'und',0,'<p>CA673ELALORHANMY-581181</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,262,262,'und',0,'<p>EOS 600D</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,263,263,'und',0,'<p>5x5x5</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,267,267,'und',0,'<p>SA356ELAOVYAANMY-683458</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,268,268,'und',0,'<p>NXF1</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,269,269,'und',0,'<p>3.0</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,270,270,'und',0,'<p>20.5</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,271,271,'und',0,'<p>NI220ELAO90EANMY-649565</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,272,272,'und',0,'<p>7.11 D x 5.33</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,273,273,'und',0,'<p>0.187kg</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,274,274,'und',0,'<div>CA673ELATEX3ANMY-936277</div>\r\n','filtered_html'),('field_collection_item','field_specifications',0,275,275,'und',0,'<p>20 x 30 x 10</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,276,276,'und',0,'<p>5</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,277,277,'und',0,'<p>CO716ELAPOWBANMY-731726</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,278,278,'und',0,'<p>17x15x10</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,279,279,'und',0,'<p>1</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,280,280,'und',0,'<p>DL746ELAOZRFANMY-689095</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,281,281,'und',0,'<p>11.4x11.4x12.5</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,282,282,'und',0,'<p>0.54</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,283,283,'und',0,'<p>SC910ELAPTXIANMY-740946</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,284,284,'und',0,'<p>ST-D403</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,285,285,'und',0,'<p>9 x 10 x 8</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,286,286,'und',0,'<div>TR626ELAMPM1ANMY-645445</div>\r\n','filtered_html'),('field_collection_item','field_specifications',0,287,287,'und',0,'<p>13 x 11.5 x 16.5</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,288,288,'und',0,'<p>0.3</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,289,289,'und',0,'<p>CT941TBAM1QDANMY-602711</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,290,290,'und',0,'<p>25x23x19</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,291,291,'und',0,'<p>0.10</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,292,292,'und',0,'<p>BO242TBAPSO5ANMY-738496</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,293,293,'und',0,'<p>22.3 x 14.2 x 0.3</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,294,294,'und',0,'<p>0.119</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,295,295,'und',0,'<p>CH299TBAS06ZANMY-861162</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,296,296,'und',0,'<p>75 x 31.5 x 10.5</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,297,297,'und',0,'<p>2.6</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,298,298,'und',0,'<p>KI236HBAP7FZANMY-699829</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,299,299,'und',0,'<p>20x20x20</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,300,300,'und',0,'<p>0.1</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,301,301,'und',0,'<p>TK512SPALA1FANMY-557274</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,302,302,'und',0,'<p>9 x 10 x 9</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,303,303,'und',0,'<p>0.38 kg</p>\r\n','filtered_html');
/*!40000 ALTER TABLE `field_data_field_description` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_discount_percentage`
--

DROP TABLE IF EXISTS `field_data_field_discount_percentage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_discount_percentage` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_discount_percentage_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 59 (field_discount_percentage)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_discount_percentage`
--

LOCK TABLES `field_data_field_discount_percentage` WRITE;
/*!40000 ALTER TABLE `field_data_field_discount_percentage` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_discount_percentage` VALUES ('commerce_product','product',0,6,83,'und',0,20.00),('commerce_product','product',0,9,84,'und',0,51.90),('commerce_product','product',0,10,86,'und',0,51.90),('commerce_product','product',0,11,18,'und',0,44.69),('commerce_product','product',0,12,19,'und',0,44.69),('commerce_product','product',0,13,20,'und',0,44.69),('commerce_product','product',0,14,21,'und',0,44.69),('commerce_product','product',0,15,22,'und',0,11.71),('commerce_product','product',0,16,23,'und',0,23.92),('commerce_product','product',0,18,25,'und',0,58.59),('commerce_product','product',0,19,96,'und',0,78.39),('commerce_product','product',0,21,118,'und',0,88.18),('commerce_product','product',0,22,97,'und',0,20.40),('commerce_product','product',0,23,98,'und',0,10.08),('commerce_product','product',0,24,99,'und',0,10.85),('commerce_product','product',0,25,100,'und',0,37.89),('commerce_product','product',0,26,92,'und',0,50.83),('commerce_product','product',0,30,102,'und',0,20.40),('commerce_product','product',0,31,91,'und',0,30.00),('commerce_product','product',0,32,90,'und',0,16.67),('commerce_product','product',0,33,103,'und',0,22.44),('commerce_product','product',0,34,41,'und',0,14.33),('commerce_product','product',0,35,42,'und',0,20.03),('commerce_product','product',0,36,104,'und',0,30.30),('commerce_product','product',0,38,105,'und',0,21.01),('commerce_product','product',0,39,106,'und',0,25.64),('commerce_product','product',0,40,107,'und',0,24.24),('commerce_product','product',0,41,89,'und',0,6.71),('commerce_product','product',0,42,88,'und',0,6.71),('commerce_product','product',0,43,108,'und',0,60.61),('commerce_product','product',0,44,109,'und',0,89.22),('commerce_product','product',0,45,110,'und',0,69.50),('commerce_product','product',0,49,112,'und',0,12.50),('commerce_product','product',0,50,113,'und',0,21.05),('commerce_product','product',0,51,114,'und',0,50.06),('commerce_product','product',0,52,115,'und',0,23.02),('commerce_product','product',0,53,116,'und',0,10.01),('commerce_product','product',0,54,117,'und',0,15.00),('commerce_product','product',0,55,119,'und',0,20.01),('commerce_product','product',0,56,120,'und',0,32.14),('commerce_product','product',0,57,121,'und',0,13.34),('commerce_product','product',0,58,122,'und',0,38.40),('commerce_product','product',0,59,123,'und',0,40.13),('commerce_product','product',0,60,124,'und',0,4.90),('commerce_product','product',0,61,68,'und',0,23.02),('commerce_product','product',0,62,69,'und',0,35.29),('commerce_product','product',0,63,70,'und',0,18.76),('commerce_product','product',0,64,71,'und',0,14.71),('commerce_product','product',0,66,95,'und',0,16.69),('commerce_product','product',0,67,94,'und',0,5.51),('commerce_product','product',0,68,93,'und',0,25.03),('commerce_product','product',0,69,76,'und',0,23.09),('commerce_product','product',0,71,126,'und',0,31.13),('commerce_product','product',0,72,127,'und',0,37.34),('commerce_product','product',0,73,128,'und',0,11.12),('commerce_product','product',0,78,134,'und',0,67.10),('commerce_product','product',0,80,141,'und',0,33.86),('commerce_product','product',0,81,144,'und',0,12.75);
/*!40000 ALTER TABLE `field_data_field_discount_percentage` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_image`
--

DROP TABLE IF EXISTS `field_data_field_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_image` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_image_fid` int(10) unsigned DEFAULT NULL COMMENT 'The file_managed.fid being referenced in this field.',
  `field_image_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image’s ’alt’ attribute.',
  `field_image_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image’s ’title’ attribute.',
  `field_image_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',
  `field_image_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_image_fid` (`field_image_fid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 4 (field_image)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_image`
--

LOCK TABLES `field_data_field_image` WRITE;
/*!40000 ALTER TABLE `field_data_field_image` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_image` VALUES ('node','banner',0,7,7,'und',0,297,'Christmas offers','Christmas offers',570,380),('node','banner',0,8,8,'und',0,202,'Hot pick','Hot pick',570,380),('node','banner',0,11,11,'und',0,63,'Feature FireTv','Feature FireTv',270,150),('node','banner',0,12,12,'und',0,61,'Driver Smarter','Driver Smarter',270,150),('node','banner',0,13,13,'und',0,60,'The Living Room','The Living Room',270,150),('node','banner',0,14,14,'und',0,62,'Get 20% off instantly','Get 20% off instantly',270,120),('node','banner',0,87,87,'und',0,282,'Face Care','Face Care',553,306),('node','banner',0,98,98,'und',0,238,'Educational Toys','Educational Toys',553,306),('node','banner',0,99,99,'und',0,236,'Books & Stationery','Books & Stationery',555,307),('node','banner',0,100,100,'und',0,237,'Health & Safety','Health & Safety',555,307),('node','banner',0,101,101,'und',0,239,'Backpacks','Backpacks',553,306),('node','banner',0,102,102,'und',0,240,'','',553,306),('node','banner',0,103,103,'und',0,241,'Makeup','Makeup',553,306),('node','banner',0,104,104,'und',0,242,'Eye Care','Eye Care',553,306),('node','banner',0,105,105,'und',0,243,'Health & Beauty Tools','Health & Beauty Tools',553,306),('node','banner',0,106,106,'und',0,244,'Food Supplements','Food Supplements',553,306),('node','banner',0,107,107,'und',0,245,'Basic Phones','Basic Phones',553,306),('node','banner',0,108,108,'und',0,246,'Car Accessories','Car Accessories',553,306),('node','banner',0,109,109,'und',0,283,'Cases & Covers','Cases & Covers',553,306),('node','banner',0,110,110,'und',0,250,'Smartphones','Smartphones',553,306),('node','banner',0,111,111,'und',0,251,'With call facility','With call facility',553,306),('node','banner',0,112,112,'und',0,252,'Without call facility','Without call facility',553,306),('node','banner',0,113,113,'und',0,284,'Headphones','Headphones',553,306),('node','banner',0,114,114,'und',0,254,'Batteries & Chargers','Batteries & Chargers',553,306),('node','banner',0,115,115,'und',0,261,'Women\'s Jewellery','Women\'s Jewellery',553,306),('node','banner',0,116,116,'und',0,262,'Belts','Belts',553,306),('node','banner',0,117,117,'und',0,263,'Scarves','Scarves',553,306),('node','banner',0,118,118,'und',0,264,'Business','Business',553,306),('node','banner',0,119,119,'und',0,265,'Sports','Sports',553,306),('node','banner',0,120,120,'und',0,266,'Televisions','Televisions',553,306),('node','banner',0,121,121,'und',0,267,'Home Audio','Home Audio',553,306),('node','banner',0,122,122,'und',0,269,'Gadgets','Gadgets',553,306),('node','banner',0,123,123,'und',0,270,'Laptops','Laptops',553,306),('node','banner',0,124,124,'und',0,271,'Desktop','Desktop',553,306),('node','banner',0,125,125,'und',0,272,'Switches','Switches',553,306),('node','banner',0,126,126,'und',0,273,'Routers','Routers',553,306),('node','banner',0,127,127,'und',0,274,'Scanners','Scanners',553,306),('node','banner',0,128,128,'und',0,275,'Point & Shoot Cameras','Point & Shoot Cameras',553,306),('node','banner',0,129,129,'und',0,276,'DSLR/SLR Cameras','DSLR/SLR Cameras',553,306),('node','banner',0,130,130,'und',0,277,'Filters','Filters',553,306),('node','banner',0,131,131,'und',0,278,'Lenses','Lenses',553,306),('node','banner',0,132,132,'und',0,279,'IP Cameras','IP Cameras',553,306),('node','banner',0,133,133,'und',0,280,'Car Cameras','Car Cameras',553,306),('node','banner',0,134,134,'und',0,281,'Laptop Bags & Cases','Laptop Bags & Cases',553,306),('node','banner',0,135,135,'und',0,285,'Asus','Asus',553,306),('node','banner',0,136,136,'und',0,286,'Rolex','Rolex',553,306),('node','banner',0,137,137,'und',0,295,'Canon','Canon',555,308),('node','banner',0,140,140,'und',0,294,'Filters','Filters',555,308),('node','banner',0,142,142,'und',0,296,'Black Friday','Black Friday',570,380),('taxonomy_term','brands',0,10,10,'und',0,53,'','',180,85),('taxonomy_term','brands',0,12,12,'und',0,55,'','',180,85),('taxonomy_term','brands',0,13,13,'und',0,54,'','',180,85);
/*!40000 ALTER TABLE `field_data_field_image` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_link`
--

DROP TABLE IF EXISTS `field_data_field_link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_link` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_link_url` varchar(2048) DEFAULT NULL,
  `field_link_title` varchar(255) DEFAULT NULL,
  `field_link_attributes` mediumtext,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 15 (field_link)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_link`
--

LOCK TABLES `field_data_field_link` WRITE;
/*!40000 ALTER TABLE `field_data_field_link` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_link` VALUES ('node','banner',0,7,7,'und',0,'product/terminus-t02-297lap-01-laptop-backpack-plus-32','BlueAnt PUMP HD Wireless Bluetooth Waterproof Headphones','a:0:{}'),('node','banner',0,8,8,'und',0,'product/terminus-t02-297lap-01-laptop-backpack-plus-32','Terminus T02-297LAP-01 Laptop Backpack Plus','a:0:{}'),('node','banner',0,11,11,'und',0,'product/targus-tsb166ap-156in-revolution-backpack-xl-33','Feature FireTv','a:0:{}'),('node','banner',0,12,12,'und',0,'product/local-lion-water-resistant-hiking-backpack-bag-28l-31','Driver Smarter','a:0:{}'),('node','banner',0,13,13,'und',0,'product/tarantula-shoe-bag-bos04-088shb-03-red-34','Halloween Shop','a:0:{}'),('node','banner',0,14,14,'und',0,'get-20-instantly-0','Get 20% off instantly','a:0:{}'),('node','banner',0,87,87,'und',0,'product/sk-ii-5-piece-skincare-travel-set-5pcs-travel-packs-skii-sk2-39','SK-II 5-Piece Skincare Travel Set 5pcs Travel Packs SKII SK2','a:0:{}'),('node','banner',0,98,98,'und',0,'product/mini-quran-kids-yellow-95','Mini Quran for Kids Yellow','a:0:{}'),('node','banner',0,99,99,'und',0,'product/boogie-board-105-inch-lcd-writing-tablet-pink-96','Boogie Board 10.5 Inch LCD Writing Tablet Pink','a:0:{}'),('node','banner',0,100,100,'und',0,'product/transporter-carry-cot-97','Transporter Carry Cot','a:0:{}'),('node','banner',0,101,101,'und',0,'product/local-lion-water-resistant-hiking-backpack-bag-28l-blue-31','Local Lion Water Resistant Hiking Backpack Bag 28L Blue Local Lion Water Resistant Hiking Backpack Bag 28L Blue Local Lion Water','a:0:{}'),('node','banner',0,102,102,'und',0,'product/diniwell-water-resistant-travel-shoes-bag-pouch-organizer-bag-ver-2-orange-35','Diniwell Water-Resistant Travel Shoes Bag Pouch Organizer Bag Ver 2 - Orange','a:0:{}'),('node','banner',0,103,103,'und',0,'product/cameleon-makeup-kit-396-37','Cameleon MakeUp Kit 396','a:0:{}'),('node','banner',0,104,104,'und',0,'product/organic-eye-cream-15ml-40','Organic Eye Cream 15ml','a:0:{}'),('node','banner',0,105,105,'und',0,'hairscape-1800w-aus-5000-professional-hair-dryer-42','Hairscape 1800W (AUS) 5000 Professional Hair Dryer','a:0:{}'),('node','banner',0,106,106,'und',0,'mejikaliner-quick-eyelid-essence-stick-glue-night-use-41','Mejikaliner Quick Eyelid Essence Stick Glue - Night Use','a:0:{}'),('node','banner',0,107,107,'und',0,'product/lenovo-a316-47','Lenovo A316','a:0:{}'),('node','banner',0,108,108,'und',0,'product/angel-universal-mobile-phone-car-phone-holder-360-degree-item-code-p338-56','Angel Universal Mobile Phone In Car Phone Holder 360 degree Item Code: P338','a:0:{}'),('node','banner',0,109,109,'und',0,'product/galaxy-note-4-spigen-case-neo-hybrid-metal-gold-53','Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold','a:0:{}'),('node','banner',0,110,110,'und',0,'product/samsung-n910-note-4-lte-32gb-white-45','Samsung N910 Note 4 LTE 32GB White','a:0:{}'),('node','banner',0,111,111,'und',0,'product/asus-memopad-7-tablet-50','Asus Memopad 7 (Tablet)','a:0:{}'),('node','banner',0,112,112,'und',0,'product/lenovo-tablet-miix-2-59399848-8-silver-51','Lenovo Tablet Miix 2 59399848 8\" Silver','a:0:{}'),('node','banner',0,113,113,'und',0,'product/sony-stereo-bluetooth-headset-sbh20-black-58','Sony Stereo Bluetooth Headset SBH20 Black','a:0:{}'),('node','banner',0,114,114,'und',0,'product/top-mi-10400mah-powerbank-black-59','TOP Mi 10400mAh Powerbank - Black','a:0:{}'),('node','banner',0,115,115,'und',0,'product/muwo-trendz-swarovski-element-white-gold-plated-everlasting-love-set-61','MuWo Trendz Swarovski Element White Gold Plated Everlasting Love Set','a:0:{}'),('node','banner',0,116,116,'und',0,'product/dandelion-cross-stitch-belt-orange-64','Dandelion Cross Stitch Belt Orange','a:0:{}'),('node','banner',0,117,117,'und',0,'product/fur-nyce-fashion-zebra-pattern-print-scarf-white-66','Fur Nyce Fashion Zebra Pattern Print Scarf White','a:0:{}'),('node','banner',0,118,118,'und',0,'product/rolex-submariner-black-dial-stainless-steel-automatic-mens-watch-114060-68','Rolex Submariner Black Dial Stainless Steel Automatic Mens Watch 114060','a:0:{}'),('node','banner',0,119,119,'und',0,'product/suunto-vector-black-suss010600610-mountain-outdoor-watch-69','SUUNTO VECTOR BLACK SUSS010600610 MOUNTAIN OUTDOOR WATCH ','a:0:{}'),('node','banner',0,120,120,'und',0,'product/sony-48-full-hd-led-tv-bravia-model-kdl-48r470b-72','Sony 48\" Full HD LED TV - BRAVIA Model KDL-48R470B','a:0:{}'),('node','banner',0,121,121,'und',0,'product/samsung-ht-e350k-dvd-home-theater-system-74','Samsung HT-E350K DVD Home Theater System','a:0:{}'),('node','banner',0,122,122,'und',0,'product/l12s-oled-smart-watch-bluetooth-30-bracelet-wrist-design-ios-android-iphone-samsung-smart','L12S OLED Smart Watch Bluetooth 3.0 Bracelet Wrist Design for IOS Android iPhone Samsung Smart Phone Blue','a:0:{}'),('node','banner',0,123,123,'und',0,'product/apple-macbook-pro-me864-zpa-core-i5-133in-4gb-10','Apple Macbook Pro ME864 ZP/A – Core i5 / 13.3in / 4GB','a:0:{}'),('node','banner',0,124,124,'und',0,'product/asus-transformer-p1801-b041k-aio-184-pc-dekstop-asus-rt-n56u-wireless-n-n600-dual-band','Asus Transformer P1801-B041K AIO 18.4\" PC Dekstop + Asus RT-N56U Wireless N N600 Dual-Band Gigabit Router','a:0:{}'),('node','banner',0,125,125,'und',0,'product/dell-powerconnect-5524p-24-gbe-port-managed-l2-switch-poe-support-10gbe-and-stacking-capable','Dell PowerConnect 5524P 24 GbE Port Managed L2 Switch with PoE support 10GbE and Stacking Capable','a:0:{}'),('node','banner',0,126,126,'und',0,'product/tp-link-n750-wireless-dual-band-gigabit-router-tl-wdr4300-black-81','TP-LINK N750 Wireless Dual Band Gigabit Router TL-WDR4300 Black','a:0:{}'),('node','banner',0,127,127,'und',0,'product/canon-lide-210-scanner-82','Canon LiDE 210 Scanner','a:0:{}'),('node','banner',0,128,128,'und',0,'product/casio-exilim-ex-zr1500-digital-camera-pink-84','CASIO Exilim EX-ZR1500 Digital Camera Pink','a:0:{}'),('node','banner',0,129,129,'und',0,'product/canon-eos-600d-18mp-18-55mm-lens-86','Canon EOS 600D 18MP + 18-55mm Lens','a:0:{}'),('node','banner',0,130,130,'und',0,'product/cokin-u961a-z-pro-grad-kit-z-filter-holder-z121l-z123l-z125l-91','Cokin U961A Z Pro Grad Kit - Z Filter Holder + Z121L + Z123L + Z125L','a:0:{}'),('node','banner',0,131,131,'und',0,'product/canon-ef-s-lens-18-200mm-f35-56-90','Canon EF-S Lens 18-200mm f/3.5-5.6 IS','a:0:{}'),('node','banner',0,132,132,'und',0,'product/d-link-dcs-5222l-cloudcam-hd-wireless-n-pantilt-network-camera-92','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','a:0:{}'),('node','banner',0,133,133,'und',0,'product/trek-ai-ball-portable-wi-fi-remote-camera-cradle-adaptors-yellow-94','Trek Ai-Ball Portable Wi-Fi Remote Camera with Cradle & Adaptors (Yellow)','a:0:{}'),('node','banner',0,134,134,'und',0,'product/terminus-t02-297lap-01-laptop-backpack-plus-32','Terminus T02-297LAP-01 Laptop Backpack Plus','a:0:{}'),('node','banner',0,135,135,'und',0,'product/asus-memopad-7-tablet-50','Asus Memopad 7 (Tablet)','a:0:{}'),('node','banner',0,136,136,'und',0,'product/rolex-submariner-black-dial-stainless-steel-automatic-mens-watch-114060-68','Rolex Submariner Black Dial Stainless Steel Automatic Mens Watch 114060','a:0:{}'),('node','banner',0,137,137,'und',0,'product/canon-powershot-sx60-hs-161mp-black-8gb-case-85','Canon PowerShot SX60 HS 16.1MP Black + 8GB + Case','a:0:{}'),('node','banner',0,140,140,'und',0,'product/cokin-u961a-z-pro-grad-kit-z-filter-holder-z121l-z123l-z125l-91','Cokin U961A Z Pro Grad Kit - Z Filter Holder + Z121L + Z123L + Z125L','a:0:{}'),('node','banner',0,142,142,'und',0,'product/diniwell-water-resistant-travel-shoes-bag-pouch-organizer-bag-ver-2-orange-35','black friday','a:0:{}');
/*!40000 ALTER TABLE `field_data_field_link` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_map`
--

DROP TABLE IF EXISTS `field_data_field_map`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_map` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_map_value` longtext,
  `field_map_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_map_format` (`field_map_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 45 (field_map)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_map`
--

LOCK TABLES `field_data_field_map` WRITE;
/*!40000 ALTER TABLE `field_data_field_map` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_map` VALUES ('node','webform',0,28,28,'und',0,'<p><iframe height=\"403\" src=\"https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d24211.70199537884!2d-73.9482136362959!3d40.66377185214051!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x89c25b6f2cf5c117%3A0x97da648ac6054528!2sWinthrop+St!5e0!3m2!1sen!2s!4v1407399678598\" style=\"border:0; width: 100%\"></iframe></p>\r\n','full_html');
/*!40000 ALTER TABLE `field_data_field_map` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_old_price`
--

DROP TABLE IF EXISTS `field_data_field_old_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_old_price` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_old_price_amount` int(11) NOT NULL DEFAULT '0' COMMENT 'The price amount.',
  `field_old_price_currency_code` varchar(32) NOT NULL COMMENT 'The currency code for the price.',
  `field_old_price_data` longtext COMMENT 'A serialized array of additional price data.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_old_price_currency_price` (`field_old_price_amount`,`field_old_price_currency_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 48 (field_old_price)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_old_price`
--

LOCK TABLES `field_data_field_old_price` WRITE;
/*!40000 ALTER TABLE `field_data_field_old_price` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_old_price` VALUES ('commerce_product','product',0,6,83,'und',0,150000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,9,84,'und',0,7900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,10,86,'und',0,7900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,11,18,'und',0,17900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,12,19,'und',0,17900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,13,20,'und',0,17900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,14,21,'und',0,17900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,15,22,'und',0,29900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,16,23,'und',0,41800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,18,25,'und',0,9900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,19,96,'und',0,19900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,21,118,'und',0,33000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,22,97,'und',0,29900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,23,98,'und',0,11900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,24,99,'und',0,12900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,25,100,'und',0,9500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,26,92,'und',0,12000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,30,102,'und',0,25000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,31,91,'und',0,7000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,32,90,'und',0,60000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,33,103,'und',0,45000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,34,41,'und',0,34900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,35,42,'und',0,74900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,36,104,'und',0,9900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,38,105,'und',0,11900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,39,106,'und',0,3900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,40,107,'und',0,9900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,41,89,'und',0,14900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,42,88,'und',0,14900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,43,108,'und',0,9900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,44,109,'und',0,39900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,45,110,'und',0,25900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,49,112,'und',0,4000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,50,113,'und',0,3800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,51,114,'und',0,79900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,52,115,'und',0,129900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,53,116,'und',0,99900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,54,117,'und',0,10000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,55,119,'und',0,149900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,56,120,'und',0,299900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,57,121,'und',0,149900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,58,122,'und',0,59900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,59,123,'und',0,29900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,60,124,'und',0,36700,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,61,68,'und',0,129900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,62,69,'und',0,8500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,63,70,'und',0,159900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,64,71,'und',0,17000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,66,95,'und',0,59900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,67,94,'und',0,39900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,68,93,'und',0,79900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,69,76,'und',0,129900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,71,126,'und',0,99900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,72,127,'und',0,69900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,73,128,'und',0,89900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,78,134,'und',0,6990,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,80,141,'und',0,18900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,81,144,'und',0,14900,'USD','a:1:{s:10:\"components\";a:0:{}}');
/*!40000 ALTER TABLE `field_data_field_old_price` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_paypal_email`
--

DROP TABLE IF EXISTS `field_data_field_paypal_email`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_paypal_email` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_paypal_email_value` varchar(255) DEFAULT NULL,
  `field_paypal_email_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_paypal_email_format` (`field_paypal_email_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 57 (field_paypal_email)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_paypal_email`
--

LOCK TABLES `field_data_field_paypal_email` WRITE;
/*!40000 ALTER TABLE `field_data_field_paypal_email` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `field_data_field_paypal_email` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_product`
--

DROP TABLE IF EXISTS `field_data_field_product`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_product` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_product_product_id` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_product_product_id` (`field_product_product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 17 (field_product)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_product`
--

LOCK TABLES `field_data_field_product` WRITE;
/*!40000 ALTER TABLE `field_data_field_product` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_product` VALUES ('node','product',0,30,30,'und',0,9),('node','product',0,30,30,'und',1,10),('node','product',0,31,31,'und',0,11),('node','product',0,31,31,'und',1,12),('node','product',0,31,31,'und',2,13),('node','product',0,31,31,'und',3,14),('node','product',0,32,32,'und',0,15),('node','product',0,33,33,'und',0,16),('node','product',0,34,34,'und',0,17),('node','product',0,35,35,'und',0,18),('node','product',0,36,36,'und',0,19),('node','product',0,37,37,'und',0,20),('node','product',0,38,38,'und',0,21),('node','product',0,39,39,'und',0,22),('node','product',0,40,40,'und',0,23),('node','product',0,41,41,'und',0,24),('node','product',0,42,42,'und',0,25),('node','product',0,43,43,'und',0,26),('node','product',0,44,44,'und',0,27),('node','product',0,45,45,'und',0,28),('node','product',0,46,46,'und',0,29),('node','product',0,47,47,'und',0,30),('node','product',0,48,48,'und',0,31),('node','product',0,49,49,'und',0,32),('node','product',0,50,50,'und',0,33),('node','product',0,51,51,'und',0,34),('node','product',0,52,52,'und',0,35),('node','product',0,53,53,'und',0,36),('node','product',0,54,54,'und',0,37),('node','product',0,55,55,'und',0,38),('node','product',0,56,56,'und',0,39),('node','product',0,57,57,'und',0,40),('node','product',0,58,58,'und',0,41),('node','product',0,58,58,'und',1,42),('node','product',0,59,59,'und',0,43),('node','product',0,60,60,'und',0,44),('node','product',0,61,61,'und',0,45),('node','product',0,62,62,'und',0,46),('node','product',0,63,63,'und',0,47),('node','product',0,64,64,'und',0,48),('node','product',0,65,65,'und',0,49),('node','product',0,66,66,'und',0,50),('node','product',0,67,67,'und',0,51),('node','product',0,68,68,'und',0,52),('node','product',0,69,69,'und',0,53),('node','product',0,70,70,'und',0,54),('node','product',0,71,71,'und',0,55),('node','product',0,72,72,'und',0,56),('node','product',0,73,73,'und',0,57),('node','product',0,74,74,'und',0,58),('node','product',0,75,75,'und',0,59),('node','product',0,76,76,'und',0,60),('node','product',0,77,77,'und',0,61),('node','product',0,78,78,'und',0,62),('node','product',0,79,79,'und',0,63),('node','product',0,80,80,'und',0,64),('node','product',0,81,81,'und',0,65),('node','product',0,82,82,'und',0,66),('node','product',0,83,83,'und',0,67),('node','product',0,84,84,'und',0,68),('node','product',0,85,85,'und',0,69),('node','product',0,86,86,'und',0,70),('node','product',0,88,88,'und',0,71),('node','product',0,89,89,'und',0,72),('node','product',0,90,90,'und',0,73),('node','product',0,91,91,'und',0,74),('node','product',0,92,92,'und',0,75),('node','product',0,93,93,'und',0,76),('node','product',0,94,94,'und',0,77),('node','product',0,95,95,'und',0,78),('node','product',0,96,96,'und',0,79),('node','product',0,97,97,'und',0,80),('node','product',0,138,138,'und',0,81),('node','product',0,139,139,'und',0,82);
/*!40000 ALTER TABLE `field_data_field_product` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_product_color`
--

DROP TABLE IF EXISTS `field_data_field_product_color`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_product_color` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_product_color_tid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_product_color_tid` (`field_product_color_tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 51 (field_product_color)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_product_color`
--

LOCK TABLES `field_data_field_product_color` WRITE;
/*!40000 ALTER TABLE `field_data_field_product_color` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_product_color` VALUES ('commerce_product','product',0,9,84,'und',0,106),('commerce_product','product',0,10,86,'und',0,108),('commerce_product','product',0,11,18,'und',0,106),('commerce_product','product',0,12,19,'und',0,110),('commerce_product','product',0,13,20,'und',0,107),('commerce_product','product',0,14,21,'und',0,108),('commerce_product','product',0,41,89,'und',0,104),('commerce_product','product',0,42,88,'und',0,109),('commerce_product','product',0,71,126,'und',0,104),('commerce_product','product',0,72,127,'und',0,104),('commerce_product','product',0,73,128,'und',0,104),('commerce_product','product',0,74,132,'und',0,104),('commerce_product','product',0,75,143,'und',0,104),('commerce_product','product',0,76,131,'und',0,104),('commerce_product','product',0,77,133,'und',0,104),('commerce_product','product',0,78,134,'und',0,104),('commerce_product','product',0,79,137,'und',0,104),('commerce_product','product',0,80,141,'und',0,104),('commerce_product','product',0,81,144,'und',0,104),('commerce_product','product',0,82,145,'und',0,104);
/*!40000 ALTER TABLE `field_data_field_product_color` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_product_image`
--

DROP TABLE IF EXISTS `field_data_field_product_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_product_image` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_product_image_fid` int(10) unsigned DEFAULT NULL COMMENT 'The file_managed.fid being referenced in this field.',
  `field_product_image_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image’s ’alt’ attribute.',
  `field_product_image_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image’s ’title’ attribute.',
  `field_product_image_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',
  `field_product_image_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_product_image_fid` (`field_product_image_fid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 39 (field_product_image)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_product_image`
--

LOCK TABLES `field_data_field_product_image` WRITE;
/*!40000 ALTER TABLE `field_data_field_product_image` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_product_image` VALUES ('commerce_product','product',0,4,15,'und',0,26,'','',400,400),('commerce_product','product',0,6,83,'und',0,19,'','',850,850),('commerce_product','product',0,7,10,'und',0,20,'','',850,850),('commerce_product','product',0,8,11,'und',0,27,'','',466,416),('commerce_product','product',0,9,84,'und',0,76,'Aeroline Casual Hiking Backpack Dark Blue','Aeroline Casual Hiking Backpack Dark Blue',850,850),('commerce_product','product',0,9,84,'und',1,77,'Aeroline Casual Hiking Backpack Dark Blue','Aeroline Casual Hiking Backpack Dark Blue',850,850),('commerce_product','product',0,9,84,'und',2,78,'Aeroline Casual Hiking Backpack Dark Blue','Aeroline Casual Hiking Backpack Dark Blue',850,850),('commerce_product','product',0,10,86,'und',0,79,'Aeroline Casual Hiking Backpack Orange','Aeroline Casual Hiking Backpack Orange',850,850),('commerce_product','product',0,10,86,'und',1,80,'Aeroline Casual Hiking Backpack Orange','Aeroline Casual Hiking Backpack Orange',850,850),('commerce_product','product',0,10,86,'und',2,81,'Aeroline Casual Hiking Backpack Orange','Aeroline Casual Hiking Backpack Orange',850,850),('commerce_product','product',0,11,18,'und',0,82,'Local Lion Water Resistant Hiking Backpack Bag 28L Blue','Local Lion Water Resistant Hiking Backpack Bag 28L Blue',850,850),('commerce_product','product',0,12,19,'und',0,83,'Local Lion Water Resistant Hiking Backpack Bag 28L Green','Local Lion Water Resistant Hiking Backpack Bag 28L Green',850,850),('commerce_product','product',0,13,20,'und',0,84,'Local Lion Water Resistant Hiking Backpack Bag 28L Red','Local Lion Water Resistant Hiking Backpack Bag 28L Red',850,850),('commerce_product','product',0,14,21,'und',0,85,'Local Lion Water Resistant Hiking Backpack Bag 28L Orange','Local Lion Water Resistant Hiking Backpack Bag 28L Orange',850,850),('commerce_product','product',0,15,22,'und',0,86,'Terminus T02-297LAP-01 Laptop Backpack Plus Black','Terminus T02-297LAP-01 Laptop Backpack Plus Black',850,850),('commerce_product','product',0,16,23,'und',0,87,'Targus Tsb166Ap 15.6In Revolution Backpack Xl','Targus Tsb166Ap 15.6In Revolution Backpack Xl',850,850),('commerce_product','product',0,16,23,'und',1,88,'Targus Tsb166Ap 15.6In Revolution Backpack Xl','Targus Tsb166Ap 15.6In Revolution Backpack Xl',850,850),('commerce_product','product',0,16,23,'und',2,89,'Targus Tsb166Ap 15.6In Revolution Backpack Xl','Targus Tsb166Ap 15.6In Revolution Backpack Xl',850,850),('commerce_product','product',0,17,24,'und',0,92,'Tarantula Shoe Bag (BOS04-088SHB-03) - Red ','Tarantula Shoe Bag (BOS04-088SHB-03) - Red ',850,850),('commerce_product','product',0,18,25,'und',0,96,'Diniwell Water-Resistant Travel Shoes Bag Pouch Organizer Bag Ver 2 - Orange','Diniwell Water-Resistant Travel Shoes Bag Pouch Organizer Bag Ver 2 - Orange',850,850),('commerce_product','product',0,18,25,'und',1,97,'Diniwell Water-Resistant Travel Shoes Bag Pouch Organizer Bag Ver 2 - Orange','Diniwell Water-Resistant Travel Shoes Bag Pouch Organizer Bag Ver 2 - Orange',850,850),('commerce_product','product',0,18,25,'und',2,98,'Diniwell Water-Resistant Travel Shoes Bag Pouch Organizer Bag Ver 2 - Orange','Diniwell Water-Resistant Travel Shoes Bag Pouch Organizer Bag Ver 2 - Orange',850,850),('commerce_product','product',0,19,96,'und',0,100,'24-Piece Makeup Brush Set','24-Piece Makeup Brush Set',850,850),('commerce_product','product',0,19,96,'und',1,101,'24-Piece Makeup Brush Set','24-Piece Makeup Brush Set',850,850),('commerce_product','product',0,19,96,'und',2,102,'24-Piece Makeup Brush Set','24-Piece Makeup Brush Set',850,850),('commerce_product','product',0,20,27,'und',0,104,'Cameleon MakeUp Kit 396','Cameleon MakeUp Kit 396',850,850),('commerce_product','product',0,21,118,'und',0,107,'4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner','4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner',850,850),('commerce_product','product',0,21,118,'und',1,108,'4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner','4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner',850,850),('commerce_product','product',0,21,118,'und',2,109,'4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner','4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner',850,850),('commerce_product','product',0,22,97,'und',0,110,'SK-II 5-Piece Skincare Travel Set 5pcs Travel Packs SKII SK2','SK-II 5-Piece Skincare Travel Set 5pcs Travel Packs SKII SK2',850,850),('commerce_product','product',0,23,98,'und',0,112,'Organic Eye Cream 15ml','Organic Eye Cream 15ml',850,850),('commerce_product','product',0,24,99,'und',0,113,'Mejikaliner Quick Eyelid Essence Stick Glue - Night Use','Mejikaliner Quick Eyelid Essence Stick Glue - Night Use',850,850),('commerce_product','product',0,25,100,'und',0,114,'Hairscape 1800W (AUS) 5000 Professional Hair Dryer','Hairscape 1800W (AUS) 5000 Professional Hair Dryer',850,850),('commerce_product','product',0,26,92,'und',0,115,'Tonific Slimming Massager','Tonific Slimming Massager',850,850),('commerce_product','product',0,27,101,'und',0,118,'Apple iPhone 6 16GB Gold','Apple iPhone 6 16GB Gold',850,850),('commerce_product','product',0,27,101,'und',1,119,'Apple iPhone 6 16GB Gold','Apple iPhone 6 16GB Gold',850,850),('commerce_product','product',0,27,101,'und',2,120,'Apple iPhone 6 16GB Gold','Apple iPhone 6 16GB Gold',850,850),('commerce_product','product',0,28,35,'und',0,121,'Samsung N910 Note 4 LTE 32GB White','Samsung N910 Note 4 LTE 32GB White',850,850),('commerce_product','product',0,28,35,'und',1,122,'Samsung N910 Note 4 LTE 32GB White','Samsung N910 Note 4 LTE 32GB White',850,850),('commerce_product','product',0,28,35,'und',2,123,'Samsung N910 Note 4 LTE 32GB White','Samsung N910 Note 4 LTE 32GB White',850,850),('commerce_product','product',0,29,36,'und',0,124,'Asus Transformer P1801-B041K AIO 18.4\'\' PC Dekstop + Asus RT-N56U Wireless N N600 Dual-Band Gigabit Router','Asus Transformer P1801-B041K AIO 18.4\'\' PC Dekstop + Asus RT-N56U Wireless N N600 Dual-Band Gigabit Router',850,850),('commerce_product','product',0,29,36,'und',1,125,'Asus Transformer P1801-B041K AIO 18.4\'\' PC Dekstop + Asus RT-N56U Wireless N N600 Dual-Band Gigabit Router','Asus Transformer P1801-B041K AIO 18.\'\' PC Dekstop + Asus RT-N56U Wireless N N600 Dual-Band Gigabit Router',850,850),('commerce_product','product',0,29,36,'und',2,126,'Asus Transformer P1801-B041K AIO 18.4\'\' PC Dekstop + Asus RT-N56U Wireless N N600 Dual-Band Gigabit Router','Asus Transformer P1801-B041K AIO 18.4\'\' PC Dekstop + Asus RT-N56U Wireless N N600 Dual-Band Gigabit Router',850,850),('commerce_product','product',0,30,102,'und',0,129,'Lenovo A316','Lenovo A316',850,850),('commerce_product','product',0,31,91,'und',0,128,'Nokia Asha 206 Dual SIM Black','Nokia Asha 206 Dual SIM Black',850,850),('commerce_product','product',0,32,90,'und',0,130,'Apple IPAD 3 Wi-Fi+4G MD368 64GB Black','Apple IPAD 3 Wi-Fi+4G MD368 64GB Black',850,850),('commerce_product','product',0,32,90,'und',1,131,'Apple IPAD 3 Wi-Fi+4G MD368 64GB Black','Apple IPAD 3 Wi-Fi+4G MD368 64GB Black',850,850),('commerce_product','product',0,33,103,'und',0,132,'Asus Memopad 7 (Tablet)','Asus Memopad 7 (Tablet)',850,850),('commerce_product','product',0,33,103,'und',1,133,'Asus Memopad 7 (Tablet)','Asus Memopad 7 (Tablet)',850,850),('commerce_product','product',0,34,41,'und',0,137,'Lenovo Tablet Miix 2 59399848 8\'\' Silver','Lenovo Tablet Miix 2 59399848 8\'\' Silver',850,850),('commerce_product','product',0,34,41,'und',1,135,'Lenovo Tablet Miix 2 59399848 8\'\' Silver','Lenovo Tablet Miix 2 59399848 8\'\' Silver',850,850),('commerce_product','product',0,35,42,'und',0,144,'Apple iPad Air 16GB WiFi Space Grey (MD785ZPA)','Apple iPad Air 16GB WiFi Space Grey (MD785ZPA)',850,850),('commerce_product','product',0,35,42,'und',1,145,'Apple iPad Air 16GB WiFi Space Grey (MD785ZPA)','Apple iPad Air 16GB WiFi Space Grey (MD785ZPA)',850,850),('commerce_product','product',0,36,104,'und',0,146,'Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold','Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold',850,850),('commerce_product','product',0,36,104,'und',1,147,'Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold','Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold',850,850),('commerce_product','product',0,36,104,'und',2,148,'Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold','Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold',850,850),('commerce_product','product',0,37,44,'und',0,149,'[GENUINE] SAMSUNG Galaxy Note 4 S View Classic Cover Case - Black','[GENUINE] SAMSUNG Galaxy Note 4 S View Classic Cover Case - Black',850,850),('commerce_product','product',0,37,44,'und',1,150,'[GENUINE] SAMSUNG Galaxy Note 4 S View Classic Cover Case - Black','[GENUINE] SAMSUNG Galaxy Note 4 S View Classic Cover Case - Black',850,850),('commerce_product','product',0,37,44,'und',2,151,'[GENUINE] SAMSUNG Galaxy Note 4 S View Classic Cover Case - Black','[GENUINE] SAMSUNG Galaxy Note 4 S View Classic Cover Case - Black',850,850),('commerce_product','product',0,38,105,'und',0,152,'Samsung Galaxy Tab 7.0 Plus Vehicle Dock With In-Car Charger','Samsung Galaxy Tab 7.0 Plus Vehicle Dock With In-Car Charger',728,728),('commerce_product','product',0,39,106,'und',0,155,'Angel Universal Mobile Phone In Car Phone Holder 360 degree Item Code: P338','Angel Universal Mobile Phone In Car Phone Holder 360 degree Item Code: P338',850,850),('commerce_product','product',0,40,107,'und',0,156,'Original Apple Earpod Earphone with Remote & Mic for iPhone iPad iPod','Original Apple Earpod Earphone with Remote & Mic for iPhone iPad iPod',850,850),('commerce_product','product',0,40,107,'und',1,157,'Original Apple Earpod Earphone with Remote & Mic for iPhone iPad iPod','Original Apple Earpod Earphone with Remote & Mic for iPhone iPad iPod',850,850),('commerce_product','product',0,41,89,'und',0,162,'Sony Stereo Bluetooth Headset SBH20 Black','Sony Stereo Bluetooth Headset SBH20 Black',850,850),('commerce_product','product',0,42,88,'und',0,163,'Sony Stereo Bluetooth Headset SBH20 Pink','Sony Stereo Bluetooth Headset SBH20 Pink',850,850),('commerce_product','product',0,43,108,'und',0,164,'TOP Mi 10400mAh Powerbank - Black','TOP Mi 10400mAh Powerbank - Black',850,850),('commerce_product','product',0,43,108,'und',1,165,'TOP Mi 10400mAh Powerbank - Black','TOP Mi 10400mAh Powerbank - Black',850,850),('commerce_product','product',0,43,108,'und',2,166,'TOP Mi 10400mAh Powerbank - Black','TOP Mi 10400mAh Powerbank - Black',850,850),('commerce_product','product',0,44,109,'und',0,167,'Universal Dual-Port Power Bank 20000mAh Black','Universal Dual-Port Power Bank 20000mAh Black',850,850),('commerce_product','product',0,45,110,'und',0,168,'MuWo Trendz Swarovski Element White Gold Plated Everlasting Love Set','MuWo Trendz Swarovski Element White Gold Plated Everlasting Love Set',850,850),('commerce_product','product',0,46,53,'und',0,169,'LUCCACAL Multi Color Tribal Necklace','LUCCACAL Multi Color Tribal Necklace',850,850),('commerce_product','product',0,47,111,'und',0,170,'Dandelion Women Braided Belt White','Dandelion Women Braided Belt White',850,850),('commerce_product','product',0,48,55,'und',0,171,'Dandelion Cross Stitch Belt Orange','Dandelion Cross Stitch Belt Orange',850,850),('commerce_product','product',0,49,112,'und',0,172,'Fur Nyce Big Square Classic Chain Pattern Print Scarf','Fur Nyce Big Square Classic Chain Pattern Print Scarf',850,850),('commerce_product','product',0,50,113,'und',0,173,'Fur Nyce Fashion Zebra Pattern Print Scarf White','Fur Nyce Fashion Zebra Pattern Print Scarf White',850,850),('commerce_product','product',0,51,114,'und',0,174,'Invicta Pro Diver Men Black Stainless Steel Strap Watch 15422','Invicta Pro Diver Men Black Stainless Steel Strap Watch 15422',850,850),('commerce_product','product',0,52,115,'und',0,175,'Rolex Submariner Black Dial Stainless Steel Automatic Mens Watch 114060','Rolex Submariner Black Dial Stainless Steel Automatic Mens Watch 114060',850,850),('commerce_product','product',0,53,116,'und',0,176,'SUUNTO VECTOR BLACK SUSS010600610 MOUNTAIN OUTDOOR WATCH ','SUUNTO VECTOR BLACK SUSS010600610 MOUNTAIN OUTDOOR WATCH ',850,850),('commerce_product','product',0,54,117,'und',0,177,'SKMEI 0955 30m Waterproof Analogue Digital Dual Time Men\'s Sports Watch Black + Green','SKMEI 0955 30m Waterproof Analogue Digital Dual Time Men\'s Sports Watch Black + Green',850,850),('commerce_product','product',0,55,119,'und',0,178,'Samsung 40\'\' Full HD LED TV - UA40H5008ARXXM Series 5','Samsung 40\'\' Full HD LED TV - UA40H5008ARXXM Series 5',850,850),('commerce_product','product',0,56,120,'und',0,179,'Sony 48\'\' Full HD LED TV - BRAVIA Model KDL-48R470B','Sony 48\'\' Full HD LED TV - BRAVIA Model KDL-48R470B',850,850),('commerce_product','product',0,57,121,'und',0,180,'Sony BDV-N9200W 9.1 Cinema Studio 3D Blu-Ray Disc home Theatre System','Sony BDV-N9200W 9.1 Cinema Studio 3D Blu-Ray Disc home Theatre System',850,850),('commerce_product','product',0,58,122,'und',0,181,'Samsung HT-E350K DVD Home Theater System','Samsung HT-E350K DVD Home Theater System',850,850),('commerce_product','product',0,59,123,'und',0,182,'L12S OLED Smart Watch Bluetooth 3.0 Bracelet Wrist Design for IOS Android iPhone Samsung Smart Phone Blue','L12S OLED Smart Watch Bluetooth 3.0 Bracelet Wrist Design for IOS Android iPhone Samsung Smart Phone Blue',850,850),('commerce_product','product',0,59,123,'und',1,183,'L12S OLED Smart Watch Bluetooth 3.0 Bracelet Wrist Design for IOS Android iPhone Samsung Smart Phone Blue','L12S OLED Smart Watch Bluetooth 3.0 Bracelet Wrist Design for IOS Android iPhone Samsung Smart Phone Blue',850,850),('commerce_product','product',0,60,124,'und',0,184,'ORI Apple TV','ORI Apple TV',850,850),('commerce_product','product',0,61,68,'und',0,185,'Dell Alienware X51-77822G Gaming Desktop','Dell Alienware X51-77822G Gaming Desktop',850,850),('commerce_product','product',0,62,69,'und',0,187,'3 Port HDMI Switch With Remote Control','3 Port HDMI Switch With Remote Control',850,850),('commerce_product','product',0,63,70,'und',0,188,'Dell PowerConnect 5524P 24 GbE Port Managed L2 Switch with PoE support 10GbE and Stacking Capable','Dell PowerConnect 5524P 24 GbE Port Managed L2 Switch with PoE support 10GbE and Stacking Capable',850,850),('commerce_product','product',0,64,71,'und',0,189,'TP-Link M5250 N900 3G Mobile WiFi Black','TP-Link M5250 N900 3G Mobile WiFi Black',850,850),('commerce_product','product',0,64,71,'und',1,190,'TP-Link M5250 N900 3G Mobile WiFi Black','TP-Link M5250 N900 3G Mobile WiFi Black',850,850),('commerce_product','product',0,64,71,'und',2,191,'TP-Link M5250 N900 3G Mobile WiFi Black','TP-Link M5250 N900 3G Mobile WiFi Black',850,850),('commerce_product','product',0,65,72,'und',0,192,'TP-LINK N750 Wireless Dual Band Gigabit Router TL-WDR4300 Black','TP-LINK N750 Wireless Dual Band Gigabit Router TL-WDR4300 Black',728,728),('commerce_product','product',0,66,95,'und',0,193,'Canon LiDE 210 Scanner','Canon LiDE 210 Scanner',850,850),('commerce_product','product',0,67,94,'und',0,194,'Epson Perfection V33 Scanner','Epson Perfection V33 Scanner',850,850),('commerce_product','product',0,68,93,'und',0,195,'CASIO Exilim EX-ZR1500 Digital Camera Pink','CASIO Exilim EX-ZR1500 Digital Camera Pink',850,850),('commerce_product','product',0,68,93,'und',1,196,'CASIO Exilim EX-ZR1500 Digital Camera Pink','CASIO Exilim EX-ZR1500 Digital Camera Pink',850,850),('commerce_product','product',0,68,93,'und',2,197,'CASIO Exilim EX-ZR1500 Digital Camera Pink','CASIO Exilim EX-ZR1500 Digital Camera Pink',850,850),('commerce_product','product',0,69,76,'und',0,198,'Canon PowerShot SX60 HS 16.1MP Black + 8GB + Case','Canon PowerShot SX60 HS 16.1MP Black + 8GB + Case',850,850),('commerce_product','product',0,69,76,'und',1,199,'Canon PowerShot SX60 HS 16.1MP Black + 8GB + Case','Canon PowerShot SX60 HS 16.1MP Black + 8GB + Case',850,850),('commerce_product','product',0,69,76,'und',2,200,'Canon PowerShot SX60 HS 16.1MP Black + 8GB + Case','Canon PowerShot SX60 HS 16.1MP Black + 8GB + Case',850,850),('commerce_product','product',0,70,77,'und',0,201,'Canon EOS 600D 18MP + 18-55mm Lens','Canon EOS 600D 18MP + 18-55mm Lens',850,850),('commerce_product','product',0,71,126,'und',0,211,'Samsung Smart Camera NX Mini 20.5MP Green + 9mm Lens + 16 GB Memory Card','Samsung Smart Camera NX Mini 20.5MP Green + 9mm Lens + 16 GB Memory Card',850,850),('commerce_product','product',0,71,126,'und',1,212,'Samsung Smart Camera NX Mini 20.5MP Green + 9mm Lens + 16 GB Memory Card','Samsung Smart Camera NX Mini 20.5MP Green + 9mm Lens + 16 GB Memory Card',850,850),('commerce_product','product',0,71,126,'und',2,213,'Samsung Smart Camera NX Mini 20.5MP Green + 9mm Lens + 16 GB Memory Card','Samsung Smart Camera NX Mini 20.5MP Green + 9mm Lens + 16 GB Memory Card',850,850),('commerce_product','product',0,72,127,'und',0,214,'Nikon AF-S 50mm Lens f/1.8G','Nikon AF-S 50mm Lens f/1.8G',850,850),('commerce_product','product',0,73,128,'und',0,215,'Canon EF-S Lens 18-200mm f/3.5-5.6 IS','Canon EF-S Lens 18-200mm f/3.5-5.6 IS',850,850),('commerce_product','product',0,73,128,'und',1,216,'Canon EF-S Lens 18-200mm f/3.5-5.6 IS','Canon EF-S Lens 18-200mm f/3.5-5.6 IS',850,850),('commerce_product','product',0,73,128,'und',2,217,'Canon EF-S Lens 18-200mm f/3.5-5.6 IS','Canon EF-S Lens 18-200mm f/3.5-5.6 IS',850,850),('commerce_product','product',0,74,132,'und',0,218,'Cokin U961A Z Pro Grad Kit - Z Filter Holder + Z121L + Z123L + Z125L','Cokin U961A Z Pro Grad Kit - Z Filter Holder + Z121L + Z123L + Z125L',850,850),('commerce_product','product',0,75,143,'und',0,219,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,143,'und',1,220,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,143,'und',2,221,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,76,131,'und',0,222,'CCTV- 850TVL IR DOME CCTV CAMERA','CCTV- 850TVL IR DOME CCTV CAMERA',850,850),('commerce_product','product',0,77,133,'und',0,223,'Trek Ai-Ball Portable Wi-Fi Remote Camera with Cradle & Adaptors (Yellow)','Trek Ai-Ball Portable Wi-Fi Remote Camera with Cradle & Adaptors (Yellow)',850,850),('commerce_product','product',0,77,133,'und',1,224,'Trek Ai-Ball Portable Wi-Fi Remote Camera with Cradle & Adaptors (Yellow)','Trek Ai-Ball Portable Wi-Fi Remote Camera with Cradle & Adaptors (Yellow)',850,850),('commerce_product','product',0,77,133,'und',2,225,'Trek Ai-Ball Portable Wi-Fi Remote Camera with Cradle & Adaptors (Yellow)','Trek Ai-Ball Portable Wi-Fi Remote Camera with Cradle & Adaptors (Yellow)',850,850),('commerce_product','product',0,78,134,'und',0,226,'Mini Quran for Kids Yellow','Mini Quran for Kids Yellow',850,850),('commerce_product','product',0,79,137,'und',0,227,'Boogie Board 10.5 Inch LCD Writing Tablet Pink','Boogie Board 10.5 Inch LCD Writing Tablet Pink',850,850),('commerce_product','product',0,80,141,'und',0,228,'Transporter Carry Cot','Transporter Carry Cot',850,850),('commerce_product','product',0,81,144,'und',0,288,'Kinohimitsu J\'pan BB Drink 50ml x 10','Kinohimitsu J\'pan BB Drink 50ml x 10',850,850),('commerce_product','product',0,82,145,'und',0,289,'TKO Fat Burner Mega','TKO Fat Burner Mega',850,850);
/*!40000 ALTER TABLE `field_data_field_product_image` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_review`
--

DROP TABLE IF EXISTS `field_data_field_review`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_review` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_review_rating` int(10) unsigned DEFAULT NULL,
  `field_review_target` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 38 (field_review)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_review`
--

LOCK TABLES `field_data_field_review` WRITE;
/*!40000 ALTER TABLE `field_data_field_review` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `field_data_field_review` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_simplenews_term`
--

DROP TABLE IF EXISTS `field_data_field_simplenews_term`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_simplenews_term` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_simplenews_term_tid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_simplenews_term_tid` (`field_simplenews_term_tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 5 (field_simplenews_term)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_simplenews_term`
--

LOCK TABLES `field_data_field_simplenews_term` WRITE;
/*!40000 ALTER TABLE `field_data_field_simplenews_term` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `field_data_field_simplenews_term` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_slide`
--

DROP TABLE IF EXISTS `field_data_field_slide`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_slide` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_slide_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_slide_value` (`field_slide_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 41 (field_slide)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_slide`
--

LOCK TABLES `field_data_field_slide` WRITE;
/*!40000 ALTER TABLE `field_data_field_slide` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_slide` VALUES ('node','banner',0,7,7,'und',0,1),('node','banner',0,8,8,'und',0,1),('node','banner',0,11,11,'und',0,0),('node','banner',0,12,12,'und',0,0),('node','banner',0,13,13,'und',0,0),('node','banner',0,14,14,'und',0,0),('node','banner',0,87,87,'und',0,1),('node','banner',0,98,98,'und',0,1),('node','banner',0,99,99,'und',0,1),('node','banner',0,100,100,'und',0,1),('node','banner',0,101,101,'und',0,1),('node','banner',0,102,102,'und',0,1),('node','banner',0,103,103,'und',0,1),('node','banner',0,104,104,'und',0,1),('node','banner',0,105,105,'und',0,1),('node','banner',0,106,106,'und',0,1),('node','banner',0,107,107,'und',0,1),('node','banner',0,108,108,'und',0,1),('node','banner',0,109,109,'und',0,1),('node','banner',0,110,110,'und',0,1),('node','banner',0,111,111,'und',0,1),('node','banner',0,112,112,'und',0,1),('node','banner',0,113,113,'und',0,1),('node','banner',0,114,114,'und',0,1),('node','banner',0,115,115,'und',0,1),('node','banner',0,116,116,'und',0,1),('node','banner',0,117,117,'und',0,1),('node','banner',0,118,118,'und',0,1),('node','banner',0,119,119,'und',0,1),('node','banner',0,120,120,'und',0,1),('node','banner',0,121,121,'und',0,1),('node','banner',0,122,122,'und',0,1),('node','banner',0,123,123,'und',0,1),('node','banner',0,124,124,'und',0,1),('node','banner',0,125,125,'und',0,1),('node','banner',0,126,126,'und',0,1),('node','banner',0,127,127,'und',0,1),('node','banner',0,128,128,'und',0,1),('node','banner',0,129,129,'und',0,1),('node','banner',0,130,130,'und',0,0),('node','banner',0,131,131,'und',0,1),('node','banner',0,132,132,'und',0,1),('node','banner',0,133,133,'und',0,1),('node','banner',0,134,134,'und',0,1),('node','banner',0,135,135,'und',0,1),('node','banner',0,136,136,'und',0,1),('node','banner',0,137,137,'und',0,1),('node','banner',0,140,140,'und',0,1),('node','banner',0,142,142,'und',0,1);
/*!40000 ALTER TABLE `field_data_field_slide` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_specifications`
--

DROP TABLE IF EXISTS `field_data_field_specifications`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_specifications` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_specifications_value` int(11) DEFAULT NULL COMMENT 'The field collection item id.',
  `field_specifications_revision_id` int(11) DEFAULT NULL COMMENT 'The field collection item revision id.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_specifications_revision_id` (`field_specifications_revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 35 (field_specifications)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_specifications`
--

LOCK TABLES `field_data_field_specifications` WRITE;
/*!40000 ALTER TABLE `field_data_field_specifications` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_specifications` VALUES ('node','product',0,30,30,'und',0,7,7),('node','product',0,30,30,'und',1,8,8),('node','product',0,30,30,'und',2,9,9),('node','product',0,31,31,'und',0,14,14),('node','product',0,31,31,'und',1,15,15),('node','product',0,31,31,'und',2,16,16),('node','product',0,31,31,'und',3,17,17),('node','product',0,32,32,'und',0,18,18),('node','product',0,32,32,'und',1,19,19),('node','product',0,32,32,'und',2,20,20),('node','product',0,32,32,'und',3,21,21),('node','product',0,33,33,'und',0,26,26),('node','product',0,33,33,'und',1,27,27),('node','product',0,33,33,'und',2,28,28),('node','product',0,33,33,'und',3,29,29),('node','product',0,33,33,'und',4,30,30),('node','product',0,34,34,'und',0,33,33),('node','product',0,34,34,'und',1,34,34),('node','product',0,34,34,'und',2,35,35),('node','product',0,35,35,'und',0,36,36),('node','product',0,35,35,'und',1,37,37),('node','product',0,35,35,'und',2,38,38),('node','product',0,35,35,'und',3,39,39),('node','product',0,35,35,'und',4,40,40),('node','product',0,35,35,'und',5,41,41),('node','product',0,36,36,'und',0,42,42),('node','product',0,36,36,'und',1,43,43),('node','product',0,36,36,'und',2,44,44),('node','product',0,36,36,'und',3,45,45),('node','product',0,37,37,'und',0,47,47),('node','product',0,37,37,'und',1,48,48),('node','product',0,37,37,'und',2,49,49),('node','product',0,37,37,'und',3,50,50),('node','product',0,38,38,'und',0,54,54),('node','product',0,38,38,'und',1,55,55),('node','product',0,38,38,'und',2,56,56),('node','product',0,38,38,'und',3,57,57),('node','product',0,39,39,'und',0,58,58),('node','product',0,40,40,'und',0,59,59),('node','product',0,40,40,'und',1,60,60),('node','product',0,40,40,'und',2,61,61),('node','product',0,40,40,'und',3,64,64),('node','product',0,41,41,'und',0,66,66),('node','product',0,41,41,'und',1,67,67),('node','product',0,41,41,'und',2,68,68),('node','product',0,42,42,'und',0,69,69),('node','product',0,42,42,'und',1,70,70),('node','product',0,42,42,'und',2,71,71),('node','product',0,42,42,'und',3,72,72),('node','product',0,43,43,'und',0,75,75),('node','product',0,43,43,'und',1,76,76),('node','product',0,43,43,'und',2,77,77),('node','product',0,43,43,'und',3,78,78),('node','product',0,44,44,'und',0,79,79),('node','product',0,44,44,'und',1,80,80),('node','product',0,44,44,'und',2,81,81),('node','product',0,45,45,'und',0,85,85),('node','product',0,45,45,'und',1,86,86),('node','product',0,45,45,'und',2,87,87),('node','product',0,46,46,'und',0,92,92),('node','product',0,46,46,'und',1,93,93),('node','product',0,46,46,'und',2,94,94),('node','product',0,46,46,'und',3,95,95),('node','product',0,47,47,'und',0,101,101),('node','product',0,47,47,'und',1,102,102),('node','product',0,47,47,'und',2,103,103),('node','product',0,48,48,'und',0,110,110),('node','product',0,49,49,'und',0,111,111),('node','product',0,49,49,'und',1,112,112),('node','product',0,49,49,'und',2,113,113),('node','product',0,49,49,'und',3,114,114),('node','product',0,50,50,'und',0,124,124),('node','product',0,50,50,'und',1,125,125),('node','product',0,50,50,'und',2,126,126),('node','product',0,51,51,'und',0,127,127),('node','product',0,51,51,'und',1,128,128),('node','product',0,51,51,'und',2,129,129),('node','product',0,51,51,'und',3,130,130),('node','product',0,52,52,'und',0,143,143),('node','product',0,52,52,'und',1,144,144),('node','product',0,52,52,'und',2,145,145),('node','product',0,53,53,'und',0,150,150),('node','product',0,53,53,'und',1,151,151),('node','product',0,53,53,'und',2,152,152),('node','product',0,53,53,'und',3,153,153),('node','product',0,54,54,'und',0,155,155),('node','product',0,54,54,'und',1,156,156),('node','product',0,54,54,'und',2,157,157),('node','product',0,55,55,'und',0,160,160),('node','product',0,55,55,'und',1,161,161),('node','product',0,55,55,'und',2,162,162),('node','product',0,55,55,'und',3,163,163),('node','product',0,56,56,'und',0,164,164),('node','product',0,56,56,'und',1,165,165),('node','product',0,56,56,'und',2,166,166),('node','product',0,56,56,'und',3,167,167),('node','product',0,56,56,'und',4,168,168),('node','product',0,57,57,'und',0,169,169),('node','product',0,57,57,'und',1,170,170),('node','product',0,57,57,'und',2,171,171),('node','product',0,58,58,'und',0,175,175),('node','product',0,58,58,'und',1,176,176),('node','product',0,58,58,'und',2,177,177),('node','product',0,59,59,'und',0,178,178),('node','product',0,59,59,'und',1,179,179),('node','product',0,59,59,'und',2,180,180),('node','product',0,60,60,'und',0,181,181),('node','product',0,60,60,'und',1,182,182),('node','product',0,60,60,'und',2,183,183),('node','product',0,61,61,'und',0,184,184),('node','product',0,61,61,'und',1,185,185),('node','product',0,61,61,'und',2,186,186),('node','product',0,62,62,'und',0,187,187),('node','product',0,62,62,'und',1,188,188),('node','product',0,62,62,'und',2,189,189),('node','product',0,63,63,'und',0,190,190),('node','product',0,63,63,'und',1,191,191),('node','product',0,63,63,'und',2,192,192),('node','product',0,64,64,'und',0,193,193),('node','product',0,64,64,'und',1,194,194),('node','product',0,64,64,'und',2,195,195),('node','product',0,65,65,'und',0,196,196),('node','product',0,65,65,'und',1,197,197),('node','product',0,65,65,'und',2,198,198),('node','product',0,66,66,'und',0,199,199),('node','product',0,66,66,'und',1,200,200),('node','product',0,66,66,'und',2,201,201),('node','product',0,67,67,'und',0,202,202),('node','product',0,67,67,'und',1,203,203),('node','product',0,67,67,'und',2,204,204),('node','product',0,68,68,'und',0,205,205),('node','product',0,68,68,'und',1,206,206),('node','product',0,68,68,'und',2,207,207),('node','product',0,69,69,'und',0,208,208),('node','product',0,69,69,'und',1,209,209),('node','product',0,69,69,'und',2,210,210),('node','product',0,70,70,'und',0,211,211),('node','product',0,70,70,'und',1,212,212),('node','product',0,70,70,'und',2,213,213),('node','product',0,71,71,'und',0,214,214),('node','product',0,71,71,'und',1,215,215),('node','product',0,71,71,'und',2,216,216),('node','product',0,72,72,'und',0,217,217),('node','product',0,72,72,'und',1,218,218),('node','product',0,72,72,'und',2,219,219),('node','product',0,73,73,'und',0,220,220),('node','product',0,73,73,'und',1,221,221),('node','product',0,74,74,'und',0,222,222),('node','product',0,74,74,'und',1,223,223),('node','product',0,74,74,'und',2,224,224),('node','product',0,75,75,'und',0,225,225),('node','product',0,75,75,'und',1,226,226),('node','product',0,75,75,'und',2,227,227),('node','product',0,76,76,'und',0,228,228),('node','product',0,76,76,'und',1,229,229),('node','product',0,76,76,'und',2,230,230),('node','product',0,77,77,'und',0,234,234),('node','product',0,77,77,'und',1,235,235),('node','product',0,77,77,'und',2,236,236),('node','product',0,78,78,'und',0,237,237),('node','product',0,78,78,'und',1,238,238),('node','product',0,78,78,'und',2,239,239),('node','product',0,79,79,'und',0,240,240),('node','product',0,79,79,'und',1,241,241),('node','product',0,79,79,'und',2,242,242),('node','product',0,80,80,'und',0,243,243),('node','product',0,80,80,'und',1,244,244),('node','product',0,80,80,'und',2,245,245),('node','product',0,81,81,'und',0,246,246),('node','product',0,81,81,'und',1,247,247),('node','product',0,81,81,'und',2,248,248),('node','product',0,82,82,'und',0,249,249),('node','product',0,82,82,'und',1,250,250),('node','product',0,82,82,'und',2,251,251),('node','product',0,83,83,'und',0,252,252),('node','product',0,83,83,'und',1,253,253),('node','product',0,83,83,'und',2,254,254),('node','product',0,84,84,'und',0,255,255),('node','product',0,84,84,'und',1,256,256),('node','product',0,84,84,'und',2,257,257),('node','product',0,85,85,'und',0,258,258),('node','product',0,85,85,'und',1,259,259),('node','product',0,85,85,'und',2,260,260),('node','product',0,86,86,'und',0,261,261),('node','product',0,86,86,'und',1,262,262),('node','product',0,86,86,'und',2,263,263),('node','product',0,88,88,'und',0,267,267),('node','product',0,88,88,'und',1,268,268),('node','product',0,88,88,'und',2,269,269),('node','product',0,88,88,'und',3,270,270),('node','product',0,89,89,'und',0,271,271),('node','product',0,89,89,'und',1,272,272),('node','product',0,89,89,'und',2,273,273),('node','product',0,90,90,'und',0,274,274),('node','product',0,90,90,'und',1,275,275),('node','product',0,90,90,'und',2,276,276),('node','product',0,91,91,'und',0,277,277),('node','product',0,91,91,'und',1,278,278),('node','product',0,91,91,'und',2,279,279),('node','product',0,92,92,'und',0,280,280),('node','product',0,92,92,'und',1,281,281),('node','product',0,92,92,'und',2,282,282),('node','product',0,93,93,'und',0,283,283),('node','product',0,93,93,'und',1,284,284),('node','product',0,93,93,'und',2,285,285),('node','product',0,94,94,'und',0,286,286),('node','product',0,94,94,'und',1,287,287),('node','product',0,94,94,'und',2,288,288),('node','product',0,95,95,'und',0,289,289),('node','product',0,95,95,'und',1,290,290),('node','product',0,95,95,'und',2,291,291),('node','product',0,96,96,'und',0,292,292),('node','product',0,96,96,'und',1,293,293),('node','product',0,96,96,'und',2,294,294),('node','product',0,97,97,'und',0,295,295),('node','product',0,97,97,'und',1,296,296),('node','product',0,97,97,'und',2,297,297),('node','product',0,138,138,'und',0,298,298),('node','product',0,138,138,'und',1,299,299),('node','product',0,138,138,'und',2,300,300),('node','product',0,139,139,'und',0,301,301),('node','product',0,139,139,'und',1,302,302),('node','product',0,139,139,'und',2,303,303);
/*!40000 ALTER TABLE `field_data_field_specifications` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_summary`
--

DROP TABLE IF EXISTS `field_data_field_summary`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_summary` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_summary_value` longtext,
  `field_summary_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_summary_format` (`field_summary_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 33 (field_summary)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_summary`
--

LOCK TABLES `field_data_field_summary` WRITE;
/*!40000 ALTER TABLE `field_data_field_summary` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_summary` VALUES ('node','product',0,31,31,'und',0,'<ul>\r\n	<li>Material: Nylon</li>\r\n	<li>Multiple comparments</li>\r\n	<li>Spacious designDurable</li>\r\n	<li>Fitsyourlaptop</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,33,33,'und',0,'<ul>\r\n	<li>Aliquam erat volutpat</li>\r\n	<li>Phasellus facilisis nulla lacus</li>\r\n	<li>Cras ex dolor, consectetur sit amet auctor iaculis, porttitor sit amet justo</li>\r\n	<li>Sed sed gravida tellus</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,34,34,'und',0,'<ul>\r\n	<li>Zippered main compartment</li>\r\n	<li>Zippered back compartment for towel or slipper</li>\r\n	<li>Neoprene grab handle</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,36,36,'und',0,'<ul>\r\n	<li>Brush: Soft synthetic fibres and pony hair</li>\r\n	<li>Handle: Bamboo</li>\r\n	<li>Ferrule: Aluminium</li>\r\n	<li>Pouch: PU leather</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,37,37,'und',0,'<ul>\r\n	<li>48x Eyeshadow.</li>\r\n	<li>24x Lip Color.</li>\r\n	<li>2x Pressed Powder.</li>\r\n	<li>4x Blusher.</li>\r\n	<li>5x ApplicatorWell coordinated &amp; trendy color.</li>\r\n	<li>Fine texture &amp; glides on smoothly on skin.</li>\r\n	<li>Velvety smooth &amp; stay-true color.</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,39,39,'und',0,'<ul>\r\n	<li>Facial Treatment Gentle Cleanser 20g</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,40,40,'und',0,'<p><strong>Good for:</strong></p>\r\n\r\n<ul>\r\n	<li>All skin types including sensitive skin</li>\r\n	<li>Anti-ageing</li>\r\n	<li>Reducing puffiness, dryness and dark circles</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,42,42,'und',0,'<ul>\r\n	<li>Salon grade, high-powered hair dryer comes with 2 nozzles.</li>\r\n	<li>Italian Design Motor</li>\r\n	<li>Intalian Switch</li>\r\n	<li>Low Noise 1800W.</li>\r\n	<li>3&nbsp;heat (cold&nbsp;&amp;&nbsp;hot) and speed (high, low, off) setting</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,44,44,'und',0,'<p><strong>What\'s in the Box:</strong></p>\r\n\r\n<ul>\r\n	<li>iphone6 &nbsp;x1</li>\r\n	<li>cable x1</li>\r\n	<li>charger x1</li>\r\n	<li>headset x1</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,45,45,'und',0,'<p><strong>Galaxy Note 4 Size &amp; Display</strong><br />\r\nThe phone measures 153.5 x 78.6 x 8.5 mm. The screen size remains the same as its predecessor, the Note 3, at 5.7-inches using the familiar Super AMOLED display with its over-saturated, bright colors</p>\r\n','filtered_html'),('node','product',0,46,46,'und',0,'<ul>\r\n	<li>ASUS desktops – leading in satisfaction with reliability</li>\r\n	<li>Windows 8 All-in-One PC</li>\r\n	<li>Enjoy Windows 8 anywhere in the home</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,47,47,'und',0,'<ul>\r\n	<li>Android 2.3</li>\r\n	<li>2MP camera</li>\r\n	<li>512MB internal / 265MB RAM</li>\r\n	<li>1.3GHz MTK6572 dual-core</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,48,48,'und',0,'<ul>\r\n	<li>Dual SIM</li>\r\n	<li>1.3MP camera</li>\r\n	<li>FM radio / Multimedia player</li>\r\n	<li>Bluetooth 2.1 + EDR</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,49,49,'und',0,'<ul>\r\n	<li>9.7-inch Retina display with Multi-Touch</li>\r\n	<li>Dual-core A5X chip with quad-core graphics</li>\r\n	<li>5MP iSight camera and FaceTime camera</li>\r\n	<li>1080p HD video recording</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,50,50,'und',0,'<ul>\r\n	<li>Affordable</li>\r\n	<li>High Quality</li>\r\n	<li>Long lasting</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,51,51,'und',0,'<ul>\r\n	<li>TABLET 8.0\"1366 x 768 IPS TOUCH</li>\r\n	<li>INTEL ATOM Z3740 (2M UP TO 1.86GHZ)</li>\r\n	<li>2GB RAM</li>\r\n	<li>64GB</li>\r\n	<li>INTEL HD</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,52,52,'und',0,'<ul>\r\n	<li>16GB Capacity</li>\r\n	<li>9.7-inch Retina Display with 264ppi</li>\r\n	<li>A7 chip with 64-bit architecture</li>\r\n	<li>Ultrafast wireless - Wi-Fi (802.11a/b/g/n) with MIMO</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,53,53,'und',0,'<ul>\r\n	<li>Advanced Shock Absorption Technology</li>\r\n	<li>Premium Dia-Cut Edges on PC Frame</li>\r\n	<li>Compatible with Beats by Dre headphones</li>\r\n	<li>Compatible with samsung Galaxy Note4 Only-2014</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,54,54,'und',0,'<ul>\r\n	<li>Flip Cover with smart, interactive window providing quick access to key phone features</li>\r\n	<li>View Weather, Pedometer, Date/Time on Home Screen</li>\r\n	<li>Swipe to preview Messages/Missed Calls</li>\r\n	<li>Swipe to access Quick Camera and Video Recorder</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,55,55,'und',0,'<ul>\r\n	<li>Lightweigh; portable design</li>\r\n	<li>Designed perfectly to fit Samsung Galaxy Tab 7.0 inch</li>\r\n	<li>Holds and charge your device</li>\r\n	<li>Plug and play simplicity</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,56,56,'und',0,'<ul>\r\n	<li>Easy installation: just 1 minute to install on the windshield.</li>\r\n	<li>Easy to rotate the bracket arm at 360 degree.</li>\r\n	<li>The clip width is adjustable to fit most sizes of devices.</li>\r\n	<li>The clip is designed with soft foam, prevent your cellphone from scratching.</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,57,57,'und',0,'<ul>\r\n	<li>Deeper</li>\r\n	<li>Richer bass tones</li>\r\n	<li>Greater protection from sweat and water</li>\r\n	<li>Control music and video playback</li>\r\n	<li>Answer and end calls</li>\r\n	<li>Genuine Apple products</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,58,58,'und',0,'<ul>\r\n	<li>Speaker type: 9.2mm dynamic; 16ohm</li>\r\n	<li>Ear coupling: Insert</li>\r\n	<li>Nominal Impedance: 18±3ohm</li>\r\n	<li>Driver type: Dynamic</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,59,59,'und',0,'<ul>\r\n	<li>10400mAh High Capacity</li>\r\n	<li>Portable and Pocket Size</li>\r\n	<li>2.1A High Power single output</li>\r\n	<li>Fast charging Powerbank</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,60,60,'und',0,'<ul>\r\n	<li>20000mAh</li>\r\n	<li>2 USB ports</li>\r\n	<li>Compatible with many devices</li>\r\n	<li>LED indicators</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,61,61,'und',0,'<ul>\r\n	<li>Necklace length: 40cm – 45cm (adjustable)</li>\r\n	<li>4 layer Pre-polishing 18K White Gold Plated for smoother finish</li>\r\n	<li>Hand-picked Swarovski Elements</li>\r\n	<li>All Occasion Stunner</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,62,62,'und',0,'<ul>\r\n	<li>Mix of faceted black gem, crystal glass, multicolour beads and rhinestones</li>\r\n	<li>Black rope detail</li>\r\n	<li>Antique bronze-tone plating</li>\r\n	<li>Lobster clasp closure</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,63,63,'und',0,'<ul>\r\n	<li>Great for a hippie-inspired look</li>\r\n	<li>One-size-fits-all</li>\r\n	<li>Large buckle</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,64,64,'und',0,'<ul>\r\n	<li>Suitable for formal &amp; casual wear</li>\r\n	<li>With two loops for a customized fit</li>\r\n	<li>Great for colour blocking styles</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,65,65,'und',0,'<ul>\r\n	<li>Material: Cotton Blends</li>\r\n	<li>Size: 130cm x130cm</li>\r\n	<li>Big square comfortable scarf</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,66,66,'und',0,'<ul>\r\n	<li>Material: Viscose</li>\r\n	<li>Size: 90cm x180cm</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,67,67,'und',0,'<ul>\r\n	<li>Analog watch</li>\r\n	<li>Stainless Steel Strap with Round Case and Black Dial</li>\r\n	<li>Japan movement</li>\r\n	<li>Water resistant up to 10 ATM</li>\r\n	<li>Case Dimension: 46 mm</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,68,68,'und',0,'<ul>\r\n	<li>Dial Type: Analog.&nbsp;</li>\r\n	<li>Luminescent hands and markers.&nbsp;</li>\r\n	<li>Automatic movement.&nbsp;</li>\r\n	<li>Scratch resistant sapphire crystal.&nbsp;</li>\r\n	<li>Screw down crown.</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,69,69,'und',0,'<ul>\r\n	<li>Altimeter, barometer, compass</li>\r\n	<li>Weather trend indicator</li>\r\n	<li>Temperature</li>\r\n	<li>Altitude difference measurement</li>\r\n	<li>Altitude log</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,70,70,'und',0,'<ul>\r\n	<li>Casing Material : ABS+PU</li>\r\n	<li>Wristband Material : Rubber</li>\r\n	<li>Display : Analog + Digital</li>\r\n	<li>Display Format : 12/24 hour time format</li>\r\n	<li>Water Resistant : 30m Water Resistant</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,71,71,'und',0,'<ul>\r\n	<li>40\" Display</li>\r\n	<li>1920 x 1080</li>\r\n	<li>4 HDMI</li>\r\n	<li>3 USB</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,72,72,'und',0,'<ul>\r\n	<li>48\" Full HD Screen</li>\r\n	<li>LED TV</li>\r\n	<li>1920 x 1080p Resolution</li>\r\n	<li>Clear Resolution Enhancer</li>\r\n	<li>Bass Reflex Box Speakers</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,73,73,'und',0,'<ul>\r\n	<li>High-resolution Audio Capability&nbsp;</li>\r\n	<li>9.1 channel&nbsp;</li>\r\n	<li>Digital Music Arena Mode&nbsp;</li>\r\n	<li>Virtual Football Mode</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,74,74,'und',0,'<ul>\r\n	<li>CD DA / CD-R / CD-RW</li>\r\n	<li>DVD-Video / DVD±R / DVD±RW/ VCD 1.1</li>\r\n	<li>5.1 Channel</li>\r\n	<li>My Karaoke</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,75,75,'und',0,'<ul>\r\n	<li>Best OLED display module</li>\r\n	<li>High quality of Bluetooth V3.0</li>\r\n	<li>Diverse functions attached: answer calls, listen to music, time display etc.</li>\r\n	<li>Led signal lights design: easy to operate and use.</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,76,76,'und',0,'<ul>\r\n	<li>Processor : Apple single-core A5 chipSystem Requirements : Wi-Fi (802.11a</li>\r\n	<li>Wireless network (wireless video streaming requires 802.11a</li>\r\n	<li>10/100BASE-T Ethernet network.iTunes Store account.MLB.TV</li>\r\n	<li>NHL GameCenter Live: subscription required to watch live and archived games.</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,77,77,'und',0,'<ul>\r\n	<li>Intel Core i7-4770 Processor (Up To 3.9GHz)</li>\r\n	<li>8GB DDR3 Ram</li>\r\n	<li>2TB Harddisk</li>\r\n	<li>2GB GDDR5 NVIDIA GTX 780</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,78,78,'und',0,'<ul>\r\n	<li>High quality HDMI switcher with intelligent function</li>\r\n	<li>3-group input 1-group output</li>\r\n	<li>Supports with HDMI1.3b</li>\r\n	<li>Full HD 1080p</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,79,79,'und',0,'<ul>\r\n	<li>Lifetime Limited Dell Standard Technical Support</li>\r\n	<li>Lifetime Limited Hardware Warranty</li>\r\n	<li>Layer 2 Managed Gigabit Switches</li>\r\n	<li>Voice Capability</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,80,80,'und',0,'<ul>\r\n	<li>Mobile WiFi Hotspot</li>\r\n	<li>2000mAh rechargeable battery</li>\r\n	<li>HSPA+ Support</li>\r\n	<li>21.6Mbps download speed</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,81,81,'und',0,'<ul>\r\n	<li>Wireless router 4-port switch</li>\r\n	<li>2.4GHz &amp; 5GHz</li>\r\n	<li>Up to 450Mbps</li>\r\n	<li>3 external antennas</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,82,82,'und',0,'<ul>\r\n	<li>Flatbed scanner</li>\r\n	<li>Scan speed (A4 300dpi): 10secs</li>\r\n	<li>Scan resolution: 4800 x 4800dpi</li>\r\n	<li>Usb 2.0</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,83,83,'und',0,'<ul>\r\n	<li>4800 X 9600 DPI</li>\r\n	<li>4 CUSTOMISABLE BUTTONS</li>\r\n	<li>ZERO WARM-UP TIME</li>\r\n	<li>BUNDLED SOFTWARE</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,84,84,'und',0,'<ul>\r\n	<li>16.1MP12.5X Optical Zoom4X Digital Zoom1</li>\r\n	<li>2.3-inch high-speed CMOS(back illuminated type)</li>\r\n	<li>3.0-inch TFT color LCD (Super Clear LCD)LCD tilts to make a snap for self-portraits</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,85,85,'und',0,'<ul>\r\n	<li>16.1MP High Sensitivity CMOS Sensor</li>\r\n	<li>DIGIC 6 Image Processor</li>\r\n	<li>65x Optical Zoom Lens</li>\r\n	<li>21-1,365mm (35mm Equivalent)</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,86,86,'und',0,'<ul>\r\n	<li>18.0MP</li>\r\n	<li>3x - 10x zoom</li>\r\n	<li>3.2’ LCD screen</li>\r\n	<li>SD/SDHC/SDXC compatible</li>\r\n	<li>Full HD recording</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,88,88,'und',0,'<ul>\r\n	<li>0.5 Megapixel</li>\r\n	<li>3\" Flip-up LCD display</li>\r\n	<li>2GB built-in memory</li>\r\n	<li>Capture 1080p HD Video</li>\r\n	<li>Li-ion rechargeable battery - 2330 mAh</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,89,89,'und',0,'<ul>\r\n	<li>Autofocus lens</li>\r\n	<li>58mm filter size</li>\r\n	<li>No image stabilisation</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,91,91,'und',0,'<ul>\r\n	<li>Helps Control Depth of Field</li>\r\n	<li>Helps Create Certain Special Effects</li>\r\n	<li>High Quality CR39 Resin</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,92,92,'und',0,'<ul>\r\n	<li>Night Vision</li>\r\n	<li>Sound and Motion Detection</li>\r\n	<li>Remote Viewing</li>\r\n	<li>Local Recording</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,93,93,'und',0,'<ul>\r\n	<li>High resolution</li>\r\n	<li>Plastic housing black and white</li>\r\n	<li>Lens option: 3.6mm/ 6mm</li>\r\n	<li>Auto Gain Control (AGC)</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,94,94,'und',0,'<ul>\r\n	<li>VGA 640x480, QVGA 320x240, QQVGA 160x120, up to 30fps&nbsp;</li>\r\n	<li>F2.8&nbsp;</li>\r\n	<li>View Angle: 60 degree&nbsp;</li>\r\n	<li>Focusing: 20cm to Infinity&nbsp;</li>\r\n	<li>Motion JPEG&nbsp;</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,95,95,'und',0,'<ul>\r\n	<li>On/Off button in the back</li>\r\n	<li>For ages 3 and above</li>\r\n	<li>Requires 3x AAA batteries (not included)</li>\r\n	<li>The Islamic Quran play machine with projection</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,96,96,'und',0,'<ul>\r\n	<li>Writing tablet created to make lists, draw or jot down paperless notes</li>\r\n	<li>“Green” alternative to sticky notes, memo pads, paper and ink</li>\r\n	<li>Less than a 1/4\" thin and is easy to take with you in a purse, scheduler, briefcase or backpack</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,97,97,'und',0,'<ul>\r\n	<li>Practical carry handles.</li>\r\n	<li>Ideal for fitting to the Chicco Ct 0.2 Stroller</li>\r\n	<li>Removable sun canopy.</li>\r\n	<li>Internal lining in breathable fabric.</li>\r\n	<li>The removable and adjustable blanket allows you to use the carrycot in every season.</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,138,138,'und',0,'<ul>\r\n	<li>Beauty drink</li>\r\n	<li>50ml x 10\'s</li>\r\n	<li>100% All-Natural Ingredients</li>\r\n	<li>Promotes healthier &amp; luminous skin</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,139,139,'und',0,'<ul>\r\n	<li>Top Quality Premium Fat Burner</li>\r\n	<li>Increases Energy&nbsp;</li>\r\n	<li>Efficient Carbohydrate Blocker</li>\r\n</ul>\r\n','filtered_html');
/*!40000 ALTER TABLE `field_data_field_summary` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_tags`
--

DROP TABLE IF EXISTS `field_data_field_tags`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_tags` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_tags_tid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_tags_tid` (`field_tags_tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 3 (field_tags)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_tags`
--

LOCK TABLES `field_data_field_tags` WRITE;
/*!40000 ALTER TABLE `field_data_field_tags` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `field_data_field_tags` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_withdraw_name`
--

DROP TABLE IF EXISTS `field_data_field_withdraw_name`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_withdraw_name` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_withdraw_name_value` varchar(255) DEFAULT NULL,
  `field_withdraw_name_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_withdraw_name_format` (`field_withdraw_name_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 56 (field_withdraw_name)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_withdraw_name`
--

LOCK TABLES `field_data_field_withdraw_name` WRITE;
/*!40000 ALTER TABLE `field_data_field_withdraw_name` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `field_data_field_withdraw_name` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_notes`
--

DROP TABLE IF EXISTS `field_data_notes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_notes` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `notes_value` longtext,
  `notes_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `notes_format` (`notes_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 54 (notes)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_notes`
--

LOCK TABLES `field_data_notes` WRITE;
/*!40000 ALTER TABLE `field_data_notes` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `field_data_notes` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_title_field`
--

DROP TABLE IF EXISTS `field_data_title_field`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_title_field` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `title_field_value` varchar(255) DEFAULT NULL,
  `title_field_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `title_field_format` (`title_field_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 47 (title_field)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_title_field`
--

LOCK TABLES `field_data_title_field` WRITE;
/*!40000 ALTER TABLE `field_data_title_field` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_title_field` VALUES ('node','product',0,30,30,'und',0,'Aeroline Casual Hiking Backpack Dark Blue',NULL),('node','product',0,31,31,'und',0,'Local Lion Water Resistant Hiking Backpack Bag 28L Blue',NULL),('node','product',0,32,32,'und',0,'Terminus T02-297LAP-01 Laptop Backpack Plus',NULL),('node','product',0,33,33,'und',0,'Targus Tsb166Ap 15.6In Revolution Backpack Xl',NULL),('node','product',0,34,34,'und',0,'Tarantula Shoe Bag (BOS04-088SHB-03) - Red',NULL),('node','product',0,35,35,'und',0,'Diniwell Water-Resistant Travel Shoes Bag Pouch Organizer Bag Ver 2 - Orange',NULL),('node','product',0,36,36,'und',0,'24-Piece Makeup Brush Set',NULL),('node','product',0,37,37,'und',0,'Cameleon MakeUp Kit 396',NULL),('node','product',0,38,38,'und',0,'4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner',NULL),('node','product',0,39,39,'und',0,'SK-II 5-Piece Skincare Travel Set 5pcs Travel Packs SKII SK2',NULL),('node','product',0,40,40,'und',0,'Organic Eye Cream 15ml',NULL),('node','product',0,41,41,'und',0,'Mejikaliner Quick Eyelid Essence Stick Glue - Night Use',NULL),('node','product',0,42,42,'und',0,'Hairscape 1800W (AUS) 5000 Professional Hair Dryer',NULL),('node','product',0,43,43,'und',0,'Tonific Slimming Massager',NULL),('node','product',0,44,44,'und',0,'Apple iPhone 6 16GB Gold',NULL),('node','product',0,45,45,'und',0,'Samsung N910 Note 4 LTE 32GB White',NULL),('node','product',0,46,46,'und',0,'Asus Transformer P1801-B041K AIO 18.4\" PC Dekstop + Asus RT-N56U Wireless N N600 Dual-Band Gigabit Router',NULL),('node','product',0,47,47,'und',0,'Lenovo A316',NULL),('node','product',0,48,48,'und',0,'Nokia Asha 206 Dual SIM Black',NULL),('node','product',0,49,49,'und',0,'Apple IPAD 3 Wi-Fi+4G MD368 64GB Black',NULL),('node','product',0,50,50,'und',0,'Asus Memopad 7 (Tablet)',NULL),('node','product',0,51,51,'und',0,'Lenovo Tablet Miix 2 59399848 8\" Silver',NULL),('node','product',0,52,52,'und',0,'Apple iPad Air 16GB WiFi Space Grey (MD785ZPA)',NULL),('node','product',0,53,53,'und',0,'Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold',NULL),('node','product',0,54,54,'und',0,'[GENUINE] SAMSUNG Galaxy Note 4 S View Classic Cover Case - Black',NULL),('node','product',0,55,55,'und',0,'Samsung Galaxy Tab 7.0 Plus Vehicle Dock With In-Car Charger',NULL),('node','product',0,56,56,'und',0,'Angel Universal Mobile Phone In Car Phone Holder 360 degree Item Code: P338',NULL),('node','product',0,57,57,'und',0,'Original Apple Earpod Earphone with Remote & Mic for iPhone iPad iPod',NULL),('node','product',0,58,58,'und',0,'Sony Stereo Bluetooth Headset SBH20 Black',NULL),('node','product',0,59,59,'und',0,'TOP Mi 10400mAh Powerbank - Black',NULL),('node','product',0,60,60,'und',0,'Universal Dual-Port Power Bank 20000mAh Black',NULL),('node','product',0,61,61,'und',0,'MuWo Trendz Swarovski Element White Gold Plated Everlasting Love Set',NULL),('node','product',0,62,62,'und',0,'LUCCACAL Multi Color Tribal Necklace',NULL),('node','product',0,63,63,'und',0,'Dandelion Women Braided Belt White',NULL),('node','product',0,64,64,'und',0,'Dandelion Cross Stitch Belt Orange',NULL),('node','product',0,65,65,'und',0,'Fur Nyce Big Square Classic Chain Pattern Print Scarf',NULL),('node','product',0,66,66,'und',0,'Fur Nyce Fashion Zebra Pattern Print Scarf White',NULL),('node','product',0,67,67,'und',0,'Invicta Pro Diver Men Black Stainless Steel Strap Watch 15422',NULL),('node','product',0,68,68,'und',0,'Rolex Submariner Black Dial Stainless Steel Automatic Mens Watch 114060',NULL),('node','product',0,69,69,'und',0,'SUUNTO VECTOR BLACK SUSS010600610 MOUNTAIN OUTDOOR WATCH ',NULL),('node','product',0,70,70,'und',0,'SKMEI 0955 30m Waterproof Analogue Digital Dual Time Men\'s Sports Watch Black + Green',NULL),('node','product',0,71,71,'und',0,'Samsung 4\'\' Full HD LED TV - UA40H5008ARXXM Series 5',NULL),('node','product',0,72,72,'und',0,'Sony 48\" Full HD LED TV - BRAVIA Model KDL-48R470B',NULL),('node','product',0,73,73,'und',0,'Sony BDV-N9200W 9.1 Cinema Studio 3D Blu-Ray Disc home Theatre System',NULL),('node','product',0,74,74,'und',0,'Samsung HT-E350K DVD Home Theater System',NULL),('node','product',0,75,75,'und',0,'L12S OLED Smart Watch Bluetooth 3.0 Bracelet Wrist Design for IOS Android iPhone Samsung Smart Phone Blue',NULL),('node','product',0,76,76,'und',0,'ORI Apple TV',NULL),('node','product',0,77,77,'und',0,'Dell Alienware X51-77822G Gaming Desktop',NULL),('node','product',0,78,78,'und',0,'3 Port HDMI Switch With Remote Control',NULL),('node','product',0,79,79,'und',0,'Dell PowerConnect 5524P 24 GbE Port Managed L2 Switch with PoE support 10GbE and Stacking Capable',NULL),('node','product',0,80,80,'und',0,'TP-Link M5250 N900 3G Mobile WiFi Black',NULL),('node','product',0,81,81,'und',0,'TP-LINK N750 Wireless Dual Band Gigabit Router TL-WDR4300 Black',NULL),('node','product',0,82,82,'und',0,'Canon LiDE 210 Scanner',NULL),('node','product',0,83,83,'und',0,'Epson Perfection V33 Scanner',NULL),('node','product',0,84,84,'und',0,'CASIO Exilim EX-ZR1500 Digital Camera Pink',NULL),('node','product',0,85,85,'und',0,'Canon PowerShot SX60 HS 16.1MP Black + 8GB + Case',NULL),('node','product',0,86,86,'und',0,'Canon EOS 600D 18MP + 18-55mm Lens',NULL),('node','product',0,88,88,'und',0,'Samsung Smart Camera NX Mini 20.5MP Green + 9mm Lens + 16 GB Memory Card',NULL),('node','product',0,89,89,'und',0,'Nikon AF-S 50mm Lens f/1.8G',NULL),('node','product',0,90,90,'und',0,'Canon EF-S Lens 18-200mm f/3.5-5.6 IS',NULL),('node','product',0,91,91,'und',0,'Cokin U961A Z Pro Grad Kit - Z Filter Holder + Z121L + Z123L + Z125L',NULL),('node','product',0,92,92,'und',0,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',NULL),('node','product',0,93,93,'und',0,'CCTV- 850TVL IR DOME CCTV CAMERA ',NULL),('node','product',0,94,94,'und',0,'Trek Ai-Ball Portable Wi-Fi Remote Camera with Cradle & Adaptors (Yellow)',NULL),('node','product',0,95,95,'und',0,'Mini Quran for Kids Yellow',NULL),('node','product',0,96,96,'und',0,'Boogie Board 10.5 Inch LCD Writing Tablet Pink',NULL),('node','product',0,97,97,'und',0,'Transporter Carry Cot',NULL),('node','product',0,138,138,'und',0,'Kinohimitsu J\'pan BB Drink 50ml x 10',NULL),('node','product',0,139,139,'und',0,'TKO Fat Burner Mega',NULL);
/*!40000 ALTER TABLE `field_data_title_field` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_withdraw_method`
--

DROP TABLE IF EXISTS `field_data_withdraw_method`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_withdraw_method` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `withdraw_method_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `withdraw_method_target_id` (`withdraw_method_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 55 (withdraw_method)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_withdraw_method`
--

LOCK TABLES `field_data_withdraw_method` WRITE;
/*!40000 ALTER TABLE `field_data_withdraw_method` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `field_data_withdraw_method` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_group`
--

DROP TABLE IF EXISTS `field_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_group` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a group',
  `identifier` varchar(255) NOT NULL DEFAULT '' COMMENT 'The unique string identifier for a group.',
  `group_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'The name of this group.',
  `entity_type` varchar(32) NOT NULL DEFAULT '',
  `bundle` varchar(128) NOT NULL DEFAULT '',
  `mode` varchar(128) NOT NULL DEFAULT '',
  `parent_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'The parent name for a group',
  `data` longblob NOT NULL COMMENT 'Serialized data containing the group properties that do not warrant a dedicated column.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `identifier` (`identifier`),
  KEY `group_name` (`group_name`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8 COMMENT='Table that contains field group entries and settings.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_group`
--

LOCK TABLES `field_group` WRITE;
/*!40000 ALTER TABLE `field_group` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_group` VALUES (2,'group_info|node|product|form','group_info','node','product','form','','a:5:{s:5:\"label\";s:4:\"Info\";s:6:\"weight\";s:1:\"4\";s:8:\"children\";a:2:{i:0;s:20:\"group_product_detail\";i:1;s:25:\"group_product_information\";}s:11:\"format_type\";s:4:\"tabs\";s:15:\"format_settings\";a:2:{s:9:\"formatter\";s:0:\"\";s:17:\"instance_settings\";a:1:{s:7:\"classes\";s:27:\"group-info field-group-tabs\";}}}'),(3,'group_product_detail|node|product|form','group_product_detail','node','product','form','group_info','a:5:{s:5:\"label\";s:14:\"Product Detail\";s:6:\"weight\";s:2:\"11\";s:8:\"children\";a:2:{i:0;s:13:\"field_product\";i:1;s:20:\"field_specifications\";}s:11:\"format_type\";s:3:\"tab\";s:15:\"format_settings\";a:2:{s:9:\"formatter\";s:6:\"closed\";s:17:\"instance_settings\";a:3:{s:11:\"description\";s:0:\"\";s:7:\"classes\";s:36:\"group-product-detail field-group-tab\";s:15:\"required_fields\";i:1;}}}'),(4,'group_product_information|node|product|form','group_product_information','node','product','form','group_info','a:5:{s:5:\"label\";s:19:\"Product Information\";s:6:\"weight\";s:2:\"12\";s:8:\"children\";a:5:{i:0;s:14:\"field_category\";i:1;s:11:\"field_brand\";i:2;s:18:\"field_availability\";i:3;s:12:\"field_review\";i:4;s:13:\"field_boolean\";}s:11:\"format_type\";s:3:\"tab\";s:15:\"format_settings\";a:2:{s:9:\"formatter\";s:6:\"closed\";s:17:\"instance_settings\";a:3:{s:11:\"description\";s:0:\"\";s:7:\"classes\";s:41:\"group-product-information field-group-tab\";s:15:\"required_fields\";i:1;}}}'),(5,'group_info|node|product|default','group_info','node','product','default','group_summary','a:5:{s:5:\"label\";s:4:\"Info\";s:6:\"weight\";s:1:\"4\";s:8:\"children\";a:8:{i:0;s:13:\"field_product\";i:1;s:11:\"field_brand\";i:2;s:13:\"field_summary\";i:3;s:12:\"field_review\";i:4;s:11:\"title_field\";i:5;s:17:\"product:cmp_store\";i:6;s:22:\"product:commerce_stock\";i:7;s:11:\"group_price\";}s:11:\"format_type\";s:3:\"div\";s:15:\"format_settings\";a:3:{s:5:\"label\";s:4:\"Info\";s:17:\"instance_settings\";a:7:{s:2:\"id\";s:0:\"\";s:7:\"classes\";s:10:\"group-info\";s:11:\"description\";s:0:\"\";s:10:\"show_label\";s:1:\"0\";s:13:\"label_element\";s:2:\"h3\";s:6:\"effect\";s:4:\"none\";s:5:\"speed\";s:4:\"fast\";}s:9:\"formatter\";s:4:\"open\";}}'),(6,'group_more_info|node|product|default','group_more_info','node','product','default','','a:5:{s:5:\"label\";s:9:\"More Info\";s:6:\"weight\";s:1:\"1\";s:8:\"children\";a:2:{i:0;s:20:\"group_product_detail\";i:1;s:17:\"group_information\";}s:11:\"format_type\";s:3:\"div\";s:15:\"format_settings\";a:3:{s:5:\"label\";s:9:\"More Info\";s:17:\"instance_settings\";a:7:{s:2:\"id\";s:17:\"product-more-info\";s:7:\"classes\";s:31:\"group-more-info field-group-div\";s:11:\"description\";s:0:\"\";s:10:\"show_label\";s:1:\"0\";s:13:\"label_element\";s:2:\"h3\";s:6:\"effect\";s:4:\"none\";s:5:\"speed\";s:4:\"fast\";}s:9:\"formatter\";s:4:\"open\";}}'),(7,'group_product_detail|node|product|default','group_product_detail','node','product','default','group_more_info','a:5:{s:5:\"label\";s:14:\"Product Detail\";s:6:\"weight\";s:2:\"13\";s:8:\"children\";a:1:{i:0;s:4:\"body\";}s:11:\"format_type\";s:3:\"div\";s:15:\"format_settings\";a:3:{s:5:\"label\";s:14:\"Product Detail\";s:17:\"instance_settings\";a:7:{s:2:\"id\";s:14:\"product-detail\";s:7:\"classes\";s:20:\"group-product-detail\";s:11:\"description\";s:0:\"\";s:10:\"show_label\";s:1:\"1\";s:13:\"label_element\";s:2:\"h3\";s:6:\"effect\";s:4:\"none\";s:5:\"speed\";s:4:\"fast\";}s:9:\"formatter\";s:4:\"open\";}}'),(8,'group_information|node|product|default','group_information','node','product','default','group_more_info','a:5:{s:5:\"label\";s:14:\"Specifications\";s:6:\"weight\";s:2:\"14\";s:8:\"children\";a:1:{i:0;s:20:\"field_specifications\";}s:11:\"format_type\";s:3:\"div\";s:15:\"format_settings\";a:3:{s:5:\"label\";s:14:\"Specifications\";s:17:\"instance_settings\";a:7:{s:2:\"id\";s:25:\"production-specifications\";s:7:\"classes\";s:29:\" group-product-specifications\";s:11:\"description\";s:0:\"\";s:10:\"show_label\";s:1:\"1\";s:13:\"label_element\";s:2:\"h3\";s:6:\"effect\";s:4:\"none\";s:5:\"speed\";s:4:\"fast\";}s:9:\"formatter\";s:4:\"open\";}}'),(9,'group_summary|node|product|default','group_summary','node','product','default','','a:5:{s:5:\"label\";s:7:\"Summary\";s:6:\"weight\";s:1:\"0\";s:8:\"children\";a:2:{i:0;s:27:\"product:field_product_image\";i:1;s:10:\"group_info\";}s:11:\"format_type\";s:3:\"div\";s:15:\"format_settings\";a:3:{s:5:\"label\";s:7:\"Summary\";s:17:\"instance_settings\";a:7:{s:2:\"id\";s:0:\"\";s:7:\"classes\";s:13:\"group-summary\";s:11:\"description\";s:0:\"\";s:10:\"show_label\";s:1:\"0\";s:13:\"label_element\";s:2:\"h3\";s:6:\"effect\";s:4:\"none\";s:5:\"speed\";s:4:\"fast\";}s:9:\"formatter\";s:4:\"open\";}}'),(10,'group_price|node|product|default','group_price','node','product','default','group_info','a:5:{s:5:\"label\";s:5:\"Price\";s:6:\"weight\";s:2:\"27\";s:8:\"children\";a:3:{i:0;s:22:\"product:commerce_price\";i:1;s:23:\"product:field_old_price\";i:2;s:33:\"product:field_discount_percentage\";}s:11:\"format_type\";s:3:\"div\";s:15:\"format_settings\";a:3:{s:5:\"label\";s:5:\"Price\";s:17:\"instance_settings\";a:7:{s:2:\"id\";s:0:\"\";s:7:\"classes\";s:27:\"group-price field-group-div\";s:11:\"description\";s:0:\"\";s:10:\"show_label\";s:1:\"0\";s:13:\"label_element\";s:2:\"h3\";s:6:\"effect\";s:4:\"none\";s:5:\"speed\";s:4:\"fast\";}s:9:\"formatter\";s:4:\"open\";}}');
/*!40000 ALTER TABLE `field_group` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_amount`
--

DROP TABLE IF EXISTS `field_revision_amount`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_amount` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `amount_amount` int(11) NOT NULL DEFAULT '0' COMMENT 'The price amount.',
  `amount_currency_code` varchar(32) NOT NULL COMMENT 'The currency code for the price.',
  `amount_data` longtext COMMENT 'A serialized array of additional price data.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `amount_currency_price` (`amount_amount`,`amount_currency_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 53 (amount)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_amount`
--

LOCK TABLES `field_revision_amount` WRITE;
/*!40000 ALTER TABLE `field_revision_amount` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `field_revision_amount` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_balance`
--

DROP TABLE IF EXISTS `field_revision_balance`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_balance` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `balance_amount` int(11) NOT NULL DEFAULT '0' COMMENT 'The price amount.',
  `balance_currency_code` varchar(32) NOT NULL COMMENT 'The currency code for the price.',
  `balance_data` longtext COMMENT 'A serialized array of additional price data.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `balance_currency_price` (`balance_amount`,`balance_currency_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 52 (balance)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_balance`
--

LOCK TABLES `field_revision_balance` WRITE;
/*!40000 ALTER TABLE `field_revision_balance` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_balance` VALUES ('cmp_funds_account','user',0,1,1,'und',0,0,'USD',NULL),('cmp_funds_account','commerce_store',0,2,2,'und',0,0,'USD',NULL),('cmp_funds_account','commerce_store',0,3,3,'und',0,0,'USD',NULL),('cmp_funds_account','user',0,4,4,'und',0,0,'USD',NULL),('cmp_funds_account','user',0,5,5,'und',0,0,'USD',NULL),('cmp_funds_account','user',0,6,6,'und',0,0,'USD',NULL),('cmp_funds_account','commerce_store',0,7,7,'und',0,0,'USD',NULL),('cmp_funds_account','user',0,8,8,'und',0,0,'USD',NULL);
/*!40000 ALTER TABLE `field_revision_balance` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_body`
--

DROP TABLE IF EXISTS `field_revision_body`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_body` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `body_value` longtext,
  `body_summary` longtext,
  `body_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `body_format` (`body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 2 (body)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_body`
--

LOCK TABLES `field_revision_body` WRITE;
/*!40000 ALTER TABLE `field_revision_body` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_body` VALUES ('node','banner',0,7,7,'und',0,'<p>Praesent nonummy mi in odio. Vestibulum dapibus nunc ac augue. Suspendisse enim turpis, dictum sed, iaculis a, condimentum nec, nisi. Sed fringilla mauris sit amet nibh. Aliquam lorem ante, dapibus in, viverra quis, feugiat a, tellus. Aenean viverra rhoncus pede. Pellentesque libero tortor, tincidunt et, tincidunt eget, semper nec, quam. Curabitur suscipit suscipit tellus. Cras id dui. Aenean commodo ligula eget dolor. Curabitur blandit mollis lacus. Quisque malesuada placerat nisl. Fusce vulputate eleifend sapien. Sed hendrerit. Maecenas malesuada. Aliquam lobortis. Phasellus accumsan cursus velit. Sed hendrerit. Suspendisse eu ligula. Donec vitae sapien ut libero venenatis faucibus. Mauris turpis nunc, blandit et, volutpat molestie, porta ut, ligula. Sed fringilla mauris sit amet nibh. Quisque rutrum. Donec vitae sapien ut libero venenatis faucibus. Suspendisse potenti.</p>\r\n','','filtered_html'),('node','banner',0,8,8,'und',0,'<p>Ut id nisl quis enim dignissim sagittis. Cras sagittis. Nam quam nunc, blandit vel, luctus pulvinar, hendrerit id, lorem. Nullam nulla eros, ultricies sit amet, nonummy id, imperdiet feugiat, pede. Phasellus dolor. Nunc egestas, augue at pellentesque laoreet, felis eros vehicula leo, at malesuada velit leo quis pede. Sed a libero. Ut varius tincidunt libero. Suspendisse faucibus, nunc et pellentesque egestas, lacus ante convallis tellus, vitae iaculis lacus elit id tortor. Cras ultricies mi eu turpis hendrerit fringilla. Suspendisse potenti. Phasellus magna. Vestibulum fringilla pede sit amet augue. Nam eget dui. Phasellus dolor. Fusce neque. Nunc interdum lacus sit amet orci. Mauris turpis nunc, blandit et, volutpat molestie, porta ut, ligula. Sed aliquam ultrices mauris. Sed mollis, eros et ultrices tempus, mauris ipsum aliquam libero, non adipiscing dolor urna a orci. Etiam ultricies nisi vel augue. Praesent nec nisl a purus blandit viverra. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Praesent ut ligula non mi varius sagittis. Fusce commodo aliquam arcu.</p>\r\n','','filtered_html'),('node','page',0,16,16,'und',0,'<div class=\"block-payment\">\r\n	<div class=\"row\">\r\n		<div class=\"col-sm-9 field-body-topic\">\r\n			<p>Read about the variety of payment options offered on the Apple Online Store, and how the tax on your order is calculated. Also, get more information about special pricing, offers, promotions, and other great deals with limited time availability.</p>\r\n		</div>\r\n\r\n		<div class=\"col-sm-3 field-choose-topic\">\r\n			<div class=\"title\">Choose a topic</div>\r\n\r\n			<ul>\r\n				<li><a class=\"scroll-to\" href=\"#payment\" title=\"Payment\">Payment</a></li>\r\n				<li><a class=\"scroll-to\" href=\"#tax\" title=\"Tax\">Tax</a></li>\r\n				<li><a class=\"scroll-to\" href=\"#pricing\" title=\"Pricing\">Pricing</a></li>\r\n				<li><a class=\"scroll-to\" href=\"#promotions\" title=\"Promotions, Rebates, and Coupons\">Promotions, Rebates, and Coupons</a></li>\r\n			</ul>\r\n		</div>\r\n	</div>\r\n	<hr>\r\n	<div class=\"row block-content-topic\" id=\"payment\">\r\n		<div class=\"col-sm-3\">\r\n			<h4>Payment</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<div class=\"title\">Payment methods</div>\r\n\r\n			<p>The Apple Online Store accepts a variety of payment methods. Click on a payment method below to find out more:</p>\r\n\r\n			<ol>\r\n				<li><a href=\"#\" title=\"Credit Cards or Debit Cards\">Credit Cards or Debit Cards</a></li>\r\n				<li><a href=\"#\" title=\"Cash\">Cash</a></li>\r\n			</ol>\r\n\r\n			<p>Note: Business lease, wire transfers, cashier\'s checks, and money orders are ineligible payment methods for pickup items.</p>\r\n\r\n			<p>Some payment types are ineligible for orders shipping to multiple addresses. If you are using an ineligible payment type for an order shipping to multiple addresses, you will need to change the payment method, or ship your order to a single address.</p>\r\n\r\n			<p>Some customers may qualify for other forms of payment. Please call an Our Store Specialist at 1-800 for more information.</p>\r\n		</div>\r\n	</div>\r\n	<hr>\r\n	<div class=\"row block-content-topic\" id=\"tax\">\r\n		<div class=\"col-sm-3\">\r\n			<h4>Tax</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<div class=\"title\">Tax rate</div>\r\n\r\n			<p>In accordance with state and local law, your Apple Online Store purchases will be taxed using the applicable sales tax or seller\'s use tax rate for your shipping address, or the Apple Store address where the item is picked up.</p>\r\n\r\n			<p>The tax listed during checkout is only an estimate. In California and Rhode Island, sales tax is collected on the unbundled price of the iPhone.</p>\r\n\r\n			<ul>\r\n				<li>Aliquam erat volutpat</li>\r\n				<li>Phasellus facilisis nulla lacus</li>\r\n			</ul>\r\n\r\n			<p>Your invoice will reflect the final total tax, which includes state and local taxes, as well as any applicable rebates or fees.</p>\r\n		</div>\r\n	</div>\r\n	<hr>\r\n	<div class=\"row block-content-topic\" id=\"pricing\">\r\n		<div class=\"col-sm-3\">\r\n			<h4>Pricing</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<p>In accordance with state and local law, your Apple Online Store purchases will be taxed using the applicable sales tax or seller\'s use tax rate for your shipping address, or the Apple Store address where the item is picked up.</p>\r\n\r\n			<p>The tax listed during checkout is only an estimate. In California and Rhode Island, sales tax is collected on the unbundled price of the iPhone.</p>\r\n\r\n			<p>Your invoice will reflect the final total tax, which includes state and local taxes, as well as any applicable rebates or fees.</p>\r\n		</div>\r\n	</div>\r\n	<hr>\r\n	<div class=\"row block-content-topic\" id=\"promotions\">\r\n		<div class=\"col-sm-3\">\r\n			<h4>Promotions, Rebates, and Coupons</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<p>In accordance with state and local law, your Apple Online Store purchases will be taxed using the applicable sales tax or seller\'s use tax rate for your shipping address, or the Apple Store address where the item is picked up.</p>\r\n		</div>\r\n	</div>\r\n</div>\r\n','','full_html'),('node','page',0,17,17,'und',0,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer varius facilisis eros id posuere. Praesent sed turpis laoreet, aliquam metus a, fringilla libero. Quisque ac porta est. Vestibulum consequat posuere laoreet. Cras tincidunt faucibus velit, euismod egestas est sollicitudin ut. Vestibulum luctus placerat dui eu ullamcorper. Fusce sodales mi et sodales scelerisque. Etiam varius semper est, sed aliquet neque venenatis vel. Etiam non metus nec augue auctor eleifend id in est. Nulla id erat velit. Maecenas quis ex ultricies, dignissim ante et, euismod arcu.</p>\r\n\r\n<p>Cras nulla arcu, ullamcorper at viverra vel, aliquet vel nunc. Pellentesque dapibus auctor nibh, sed rhoncus diam aliquet in. Etiam condimentum metus vitae tortor egestas, id tincidunt purus luctus. Morbi sagittis aliquam dui, nec semper nulla malesuada eu. Donec eleifend molestie justo. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Nullam gravida turpis at ullamcorper porta.</p>\r\n\r\n<p>Aenean ac magna felis. Nulla blandit urna non aliquam tempus. Fusce ultricies laoreet velit, tempus condimentum purus aliquet a. Nullam ut sapien vel neque ornare convallis sit amet ut felis. Donec convallis consectetur lorem, dictum lobortis ex pretium vitae. Proin hendrerit feugiat vulputate. Duis ultricies, erat ut tincidunt feugiat, sapien ipsum pulvinar purus, eu bibendum tellus leo consequat metus. Donec quis dictum nisl. Quisque non lectus tellus. Etiam sit amet tincidunt leo. Morbi pretium rhoncus purus, et rhoncus orci sollicitudin vel. Mauris efficitur nisl eu leo imperdiet elementum. Duis ut consectetur augue. Etiam rutrum placerat volutpat. Suspendisse vitae tempor urna, a hendrerit sapien.</p>\r\n\r\n<p>Sed molestie imperdiet dolor et varius. Aliquam id metus bibendum, pulvinar erat eget, posuere elit. Aenean mattis id orci ac feugiat. Nunc pharetra congue lectus at sollicitudin. Donec ultricies, nunc a varius tincidunt, nulla odio tincidunt justo, nec malesuada augue nulla in purus. Nullam id quam orci. Mauris eu ante at elit malesuada dictum.</p>\r\n\r\n<p>Maecenas bibendum, odio et porta euismod, neque augue tristique velit, sit amet imperdiet felis sapien sed ante. Nullam consequat libero libero, id tempus tortor blandit eget. Nam aliquet nisi orci, sed placerat velit volutpat quis. Donec pulvinar magna et turpis auctor aliquam. Suspendisse et diam dignissim, maximus tellus eget, maximus ligula. Vivamus feugiat pellentesque metus, sit amet accumsan ligula posuere quis. Sed vitae metus sit amet neque iaculis cursus. Fusce luctus at massa sed euismod. Phasellus mollis suscipit purus, quis facilisis leo maximus in. Sed sagittis mi sed diam gravida laoreet. Praesent scelerisque, mi efficitur dictum imperdiet, elit massa volutpat ipsum, non venenatis felis lectus eu est. Aliquam libero justo, lobortis eget felis vel, tincidunt ultricies quam. Nunc et augue lacinia, dignissim augue sit amet, vehicula nisi. Duis varius elit a tellus imperdiet, vel ultricies mi viverra. Suspendisse aliquet eu justo id eleifend. Ut consequat ac lectus nec tincidunt.</p>\r\n','','filtered_html'),('node','page',0,18,18,'und',0,'<div class=\"block-payment\">\r\n	<div class=\"row\">\r\n		<div class=\"col-sm-9 field-body-topic\">\r\n		<p>You can purchase your items online and pick them up at an Apple Store, or ship them directly to your doorstep. Here you\'ll find everything you need to know about pickup, shipping, and much more.</p>\r\n		</div>\r\n\r\n		<div class=\"col-sm-3 field-choose-topic\">\r\n			<div class=\"title\">Choose a topic</div>\r\n\r\n			<ul>\r\n				<li><a class=\"scroll-to\" href=\"#shipping-delivery\" title=\"Shipping & Delivery\">Shipping & Delivery</a></li>\r\n				<li><a class=\"scroll-to\" href=\"#personal-pickup\" title=\"Personal Pickup\">Personal Pickup</a></li>\r\n				<li><a class=\"scroll-to\" href=\"#what-next\" title=\"What\'s Next?\">What\'s Next?</a></li>\r\n				<li><a class=\"scroll-to\" href=\"#text-notifications\" title=\"Text Notifications\">Text Notifications</a></li>\r\n				<li><a class=\"scroll-to\" href=\"#carrier-delivery-options\" title=\"Carrier Delivery Options\">Carrier Delivery Options</a></li>\r\n				<li><a class=\"scroll-to\" href=\"#shipping-policies\" title=\"Shipping Policies\">Shipping Policies</a></li>\r\n			</ul>\r\n		</div>\r\n	</div>\r\n\r\n	<hr />\r\n	<div class=\"row block-content-topic\" id=\"shipping-delivery\">\r\n		<div class=\"col-sm-3 \">\r\n			<h4>Shipping & Delivery</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<div class=\"title\">Standard Return Policy</div>\r\n\r\n			<p>The Apple Online Store accepts a variety of payment methods. Click on a payment method below to find out more:</p>\r\n\r\n			<ol>\r\n				<li><a href=\"#\" title=\"Credit Cards or Debit Cards\">Credit Cards or Debit Cards</a></li>\r\n				<li><a href=\"#\" title=\"Cash\">Cash</a></li>\r\n			</ol>\r\n\r\n			<p>Note: Business lease, wire transfers, cashier\'s checks, and money orders are ineligible payment methods for pickup items.</p>\r\n\r\n			<p>Some payment types are ineligible for orders shipping to multiple addresses. If you are using an ineligible payment type for an order shipping to multiple addresses, you will need to change the payment method, or ship your order to a single address.</p>\r\n\r\n			<p>Some customers may qualify for other forms of payment. Please call an Our Store Specialist at 1-800 for more information.</p>\r\n		</div>\r\n	</div>\r\n\r\n	<hr />\r\n	<div class=\"row block-content-topic\" id=\"personal-pickup\">\r\n		<div class=\"col-sm-3\">\r\n			<h4>Personal Pickup</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<div class=\"title\">Ship your item back to store</div>\r\n\r\n			<p>In accordance with state and local law, your Apple Online Store purchases will be taxed using the applicable sales tax or seller\'s use tax rate for your shipping address, or the Apple Store address where the item is picked up.</p>\r\n\r\n			<p>The tax listed during checkout is only an estimate. In California and Rhode Island, sales tax is collected on the unbundled price of the iPhone.</p>\r\n\r\n			<ul>\r\n				<li>Aliquam erat volutpat</li>\r\n				<li>Phasellus facilisis nulla lacus</li>\r\n			</ul>\r\n\r\n			<p>Your invoice will reflect the final total tax, which includes state and local taxes, as well as any applicable rebates or fees.</p>\r\n		</div>\r\n	</div>\r\n\r\n	<hr />\r\n	<div class=\"row block-content-topic\" id=\"what-next\">\r\n		<div class=\"col-sm-3\">\r\n			<h4>What\'s Next?</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<p>In accordance with state and local law, your Apple Online Store purchases will be taxed using the applicable sales tax or seller\'s use tax rate for your shipping address, or the Apple Store address where the item is picked up.</p>\r\n\r\n			<p>The tax listed during checkout is only an estimate. In California and Rhode Island, sales tax is collected on the unbundled price of the iPhone.</p>\r\n\r\n			<p>Your invoice will reflect the final total tax, which includes state and local taxes, as well as any applicable rebates or fees.</p>\r\n		</div>\r\n	</div>\r\n\r\n	<hr />\r\n	<div class=\"row block-content-topic\" id=\"text-notifications\">\r\n		<div class=\"col-sm-3\">\r\n			<h4>Text Notifications</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<p>In accordance with state and local law, your Apple Online Store purchases will be taxed using the applicable sales tax or seller\'s use tax rate for your shipping address, or the Apple Store address where the item is picked up.</p>\r\n		</div>\r\n	</div>\r\n\r\n	<hr />\r\n	<div class=\"row block-content-topic\" id=\"carrier-delivery-options\">\r\n		<div class=\"col-sm-3\">\r\n			<h4>Carrier Delivery Options</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<p>Proin eget lacus ac eros dapibus mattis. Quisque a dui tellus. Aenean lorem velit, porttitor sed rutrum vitae, faucibus non lacus. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Vivamus imperdiet aliquet justo blandit vestibulum. Nunc et venenatis dolor, et fringilla felis.</p>\r\n		</div>\r\n	</div>\r\n\r\n	<hr />\r\n	<div class=\"row block-content-topic\" id=\"shipping-policies\">\r\n		<div class=\"col-sm-3\">\r\n			<h4>Shipping Policies</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<p>Sed porta, ligula vitae ullamcorper commodo, sapien ipsum convallis quam, ut semper quam sem vitae sem. Nulla congue mauris non dolor egestas gravida. Mauris justo dui, vulputate id tempor at, mollis non massa. Integer sit amet diam id nunc porttitor consequat. Maecenas id erat pretium, efficitur neque a, congue nisi. Donec interdum lacus nec risus ullamcorper auctor.</p>\r\n			<ul>\r\n				<li>Aliquam erat volutpat</li>\r\n				<li>Phasellus facilisis nulla lacus</li>\r\n			</ul>\r\n		</div>\r\n	</div>\r\n</div>\r\n','','full_html'),('node','page',0,19,19,'und',0,'<div class=\"block-payment\">\r\n	<div class=\"row\">\r\n		<div class=\"col-sm-9 field-body-topic\">\r\n			<p>Apple wants you to be thrilled with your new purchase. However, if you need to return an item, we\'re here to help.</p>\r\n		</div>\r\n\r\n		<div class=\"col-sm-3 field-choose-topic\">\r\n			<div class=\"title\">Choose a topic</div>\r\n\r\n			<ul>\r\n				<li><a class=\"scroll-to\" href=\"#returns-policy\" title=\"Returns Policy\">Returns Policy</a></li>\r\n				<li><a class=\"scroll-to\" href=\"#how-to-return\" title=\"How To Return\">How To Return</a></li>\r\n				<li><a class=\"scroll-to\" href=\"#refunds\" title=\"Refunds\">Refunds</a></li>\r\n				<li><a class=\"scroll-to\" href=\"#gift-returns\" title=\"Gift Returns\">Gift Returns</a></li>\r\n			</ul>\r\n		</div>\r\n	</div>\r\n	<hr>\r\n	<div class=\"row block-content-topic\" id=\"returns-policy\">\r\n		<div class=\"col-sm-3 \">\r\n			<h4>Returns &amp; Refunds Policy</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<div class=\"title\">Standard Return Policy</div>\r\n\r\n			<p>The Apple Online Store accepts a variety of payment methods. Click on a payment method below to find out more:</p>\r\n\r\n			<ol>\r\n				<li><a href=\"#\" title=\"Credit Cards or Debit Cards\">Credit Cards or Debit Cards</a></li>\r\n				<li><a href=\"#\" title=\"Cash\">Cash</a></li>\r\n			</ol>\r\n\r\n			<p>Note: Business lease, wire transfers, cashier\'s checks, and money orders are ineligible payment methods for pickup items.</p>\r\n\r\n			<p>Some payment types are ineligible for orders shipping to multiple addresses. If you are using an ineligible payment type for an order shipping to multiple addresses, you will need to change the payment method, or ship your order to a single address.</p>\r\n\r\n			<p>Some customers may qualify for other forms of payment. Please call an Our Store Specialist at 1-800 for more information.</p>\r\n		</div>\r\n	</div>\r\n	<hr>\r\n	<div class=\"row block-content-topic\" id=\"how-to-return\">\r\n		<div class=\"col-sm-3\">\r\n			<h4>How to Return An Item</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<div class=\"title\">Ship your item back to store</div>\r\n\r\n			<p>In accordance with state and local law, your Apple Online Store purchases will be taxed using the applicable sales tax or seller\'s use tax rate for your shipping address, or the Apple Store address where the item is picked up.</p>\r\n\r\n			<p>The tax listed during checkout is only an estimate. In California and Rhode Island, sales tax is collected on the unbundled price of the iPhone.</p>\r\n\r\n			<ul>\r\n				<li>Aliquam erat volutpat</li>\r\n				<li>Phasellus facilisis nulla lacus</li>\r\n			</ul>\r\n\r\n			<p>Your invoice will reflect the final total tax, which includes state and local taxes, as well as any applicable rebates or fees.</p>\r\n		</div>\r\n	</div>\r\n	<hr>\r\n	<div class=\"row block-content-topic\" id=\"refunds\">\r\n		<div class=\"col-sm-3\">\r\n			<h4>Refunds</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<p>In accordance with state and local law, your Apple Online Store purchases will be taxed using the applicable sales tax or seller\'s use tax rate for your shipping address, or the Apple Store address where the item is picked up.</p>\r\n\r\n			<p>The tax listed during checkout is only an estimate. In California and Rhode Island, sales tax is collected on the unbundled price of the iPhone.</p>\r\n\r\n			<p>Your invoice will reflect the final total tax, which includes state and local taxes, as well as any applicable rebates or fees.</p>\r\n		</div>\r\n	</div>\r\n	<hr>\r\n	<div class=\"row block-content-topic\" id=\"gift-returns\">\r\n		<div class=\"col-sm-3\">\r\n			<h4>Gift Returns</h4>\r\n		</div>\r\n\r\n		<div class=\"col-sm-9\">\r\n			<p>In accordance with state and local law, your Apple Online Store purchases will be taxed using the applicable sales tax or seller\'s use tax rate for your shipping address, or the Apple Store address where the item is picked up.</p>\r\n		</div>\r\n	</div>\r\n</div>\r\n','','full_html'),('node','page',0,20,20,'und',0,'<p>Proin at dui sed elit facilisis vehicula bibendum at ex. Cras a sapien dignissim, consequat diam luctus, condimentum ipsum. Aenean vitae tincidunt elit. Aenean vitae mauris tempor, fermentum est ut, scelerisque odio. Sed quam neque, sagittis quis tempus vitae, accumsan nec orci. Maecenas porttitor quam quis vehicula tempor. Proin purus nisl, dictum id ultricies id, tincidunt eu ligula. Mauris lobortis fringilla dolor non mattis. Donec sit amet commodo mi. Nullam rutrum nisi nulla, sit amet blandit ipsum rutrum eget. Phasellus mattis, ex eleifend pharetra volutpat, eros eros bibendum ligula, at convallis arcu sem eget leo. Cras elementum sodales velit quis efficitur. Praesent non tortor lobortis, varius lectus et, pulvinar nunc. Vestibulum consectetur urna tincidunt tellus malesuada, vel auctor tellus lobortis.</p>\r\n\r\n<p>Mauris tellus neque, maximus quis consequat et, ullamcorper bibendum justo. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi tristique sed nulla in tempor. Etiam sed quam sit amet massa suscipit consequat nec eget ligula. Aenean ac diam tincidunt, condimentum enim eget, ultrices lacus. Maecenas lacinia rutrum metus. Suspendisse viverra nibh pharetra mauris lacinia, ac lobortis dolor suscipit.</p>\r\n\r\n<p>Curabitur ac placerat dui, sit amet luctus ex. Curabitur a tellus lorem. Pellentesque interdum vitae velit nec sodales. Donec nec justo ac eros finibus ultrices. Sed convallis posuere tellus sit amet laoreet. Sed dignissim nisl vel pulvinar tempor. In vestibulum dui convallis, auctor metus et, facilisis nulla. Proin dolor lorem, dignissim et velit nec, dictum vehicula ex. Maecenas ornare et turpis ac laoreet. Ut convallis est sit amet arcu porttitor laoreet. Vivamus ultrices velit in justo hendrerit, eu facilisis dolor efficitur. Integer quis tellus posuere, euismod tortor at, dictum eros. Maecenas ut arcu leo.</p>\r\n','','filtered_html'),('node','page',0,21,21,'und',0,'<p>Phasellus euismod nulla tristique, aliquam eros non, tristique mauris. Etiam rhoncus ipsum vitae nibh accumsan, ut gravida mauris condimentum. Ut ullamcorper velit lobortis nibh tincidunt elementum. Sed suscipit cursus lacinia. Ut efficitur dictum arcu vitae dignissim. Aenean venenatis bibendum augue, scelerisque dictum augue bibendum sit amet. Integer sit amet placerat justo, sed porttitor ante. Cras bibendum magna augue, ut congue urna cursus nec. Suspendisse vitae tortor cursus lectus pretium hendrerit vel sit amet risus. Nulla sed est condimentum, gravida massa sed, bibendum arcu. Integer vestibulum sollicitudin dignissim. Sed placerat nisl mi, nec aliquam lectus ultricies id. Maecenas non ex quam. Integer malesuada nibh quis justo consectetur accumsan. Phasellus consectetur id dolor sed blandit. In vel consequat sem, nec fermentum urna.</p>\r\n\r\n<p>Cras scelerisque nunc semper accumsan mattis. Proin mollis sodales leo, eget lacinia urna posuere nec. Vestibulum vulputate rutrum ex, sit amet tempus lorem commodo et. Vestibulum et tincidunt elit, eget tincidunt nibh. In elementum maximus risus, et ultrices nunc blandit non. Donec viverra ante at ante gravida sodales. Nunc lacinia nulla at commodo ornare. Vestibulum dictum laoreet viverra. Etiam sed neque ac quam tempus venenatis. Vivamus iaculis ipsum condimentum nibh venenatis venenatis. Integer laoreet ultricies nunc. Aenean placerat purus sed lectus scelerisque faucibus. Nulla eu diam eget metus sagittis sollicitudin ac eu lorem. Suspendisse sed odio nulla.</p>\r\n','','filtered_html'),('node','page',0,22,22,'und',0,'<div class=\"carousel slide carousel-affiliate\">\r\n	<div class=\"carousel-inner\">\r\n		<div class=\"item\"><img alt=\"Affiliate Program\" src=\"/sites/default/files/banner/slide-affiliate-1.jpg\" /></div>\r\n\r\n		<div class=\"item active\"><img alt=\"Affiliate Program\" src=\"/sites/default/files/banner/slide-affiliate-2.jpg\" /></div>\r\n	</div>\r\n\r\n	<div class=\"boxwap\"><a class=\"register-now\" href=\"#\" title=\"Register now\">Register now</a>\r\n\r\n		<p>Earn up to 8% commision on sales with Marketplace no.1 online shopping mall</p>\r\n	</div>\r\n</div>\r\n<script type=\"text/javascript\">jQuery(\'.carousel-affiliate\').carousel({interval: 4000, pause: false})</script>\r\n\r\n<div class=\"row block-affiliate\">\r\n<div class=\"col-sm-4\"><i class=\"fa fa-list\"><span>list</span></i>\r\n\r\n		<h3>Advertise</h3>\r\n\r\n		<div class=\"title-note\">Choose from over a million products to advertise to your customers</div>\r\n\r\n		<div class=\"field-body\">\r\n			<p>Whether you are a large network, content site or blogger, we have simple linking tools to meet your advertising needs and help you monetize your web site.</p>\r\n\r\n			<ul>\r\n				<li><a href=\"#\" title=\"Linking Tools\">Linking Tools</a></li>\r\n			</ul>\r\n		</div>\r\n	</div>\r\n\r\n	<div class=\"col-sm-4\"><i class=\"fa fa-usd\"><span>usd</span></i>\r\n\r\n		<h3>Earn</h3>\r\n\r\n		<div class=\"title-note\">Get up to 10% in advertising fees</div>\r\n\r\n		<div class=\"field-body\">\r\n			<p>Earn advertising fees from Qualifying Purchases, not just the products you advertised.</p>\r\n\r\n			<p>Plus, our competitive conversion rates help you maximize your earnings.</p>\r\n\r\n			<ul>\r\n				<li><a href=\"#\" title=\"Advertising Fees\">Advertising Fees</a></li>\r\n				<li><a href=\"#\" title=\"Reporting Tools\">Reporting Tools</a></li>\r\n			</ul>\r\n		</div>\r\n	</div>\r\n\r\n	<div class=\"col-sm-4\"><i class=\"fa fa-hand-o-up\"><span>hand</span></i>\r\n\r\n		<h3>Join</h3>\r\n\r\n		<div class=\"title-note\">It\'s easy and free to join</div>\r\n\r\n		<div class=\"field-body\">\r\n			<p>Get up and running today. Just one approval to join—no third-party advertiser approvals.</p>\r\n\r\n			<ul>\r\n				<li><a href=\"#\" title=\"Learn More\">Learn More</a></li>\r\n				<li><a href=\"#\" title=\"Join Now\">Join Now</a></li>\r\n			</ul>\r\n		</div>\r\n	</div>\r\n</div>\r\n','','full_html'),('node','page',0,23,23,'und',0,'<p>In vel tortor id turpis dignissim porttitor eu ac urna. Aenean in elit vel magna ultricies volutpat. Vestibulum vitae magna auctor, dignissim purus ullamcorper, varius sem. Sed nibh ex, fringilla ac enim at, iaculis maximus elit. Integer vitae gravida dolor. Nullam ultrices, diam at tincidunt feugiat, nunc magna euismod magna, eu euismod odio sapien vel lacus. Etiam malesuada sodales ante eget semper. Phasellus viverra elementum gravida. Maecenas tincidunt posuere lorem, eu tempus augue mollis et. Nam blandit viverra urna, sit amet laoreet dolor auctor ac. Vivamus eu justo erat. Fusce mollis quis nunc a facilisis.</p>\r\n\r\n<p>Curabitur commodo, lorem a tincidunt pellentesque, mauris massa aliquam enim, vel rutrum elit nisl ut mauris. Duis mattis neque arcu, eu pulvinar libero maximus ut. Vestibulum eget facilisis diam. Proin eget ante diam. Donec pulvinar magna id est vestibulum, et facilisis odio pellentesque. Fusce ut felis lorem. Quisque cursus libero non tempor imperdiet. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Donec at nibh nec lacus varius dapibus. Duis a lectus a augue interdum tempor sed ut arcu.</p>\r\n\r\n<p>Aenean fermentum lectus diam, quis fermentum mi cursus ut. Pellentesque turpis nunc, tempor et ullamcorper ac, pellentesque in nibh. Maecenas quis risus et nibh varius iaculis ac vel leo. Nam quis facilisis odio. Vestibulum commodo sed est ut porta. Cras ut porta neque, ac aliquam quam. Proin vel purus facilisis, rhoncus nibh eget, tincidunt nisi. Cras in posuere mi. Vivamus a convallis leo. Quisque in nisl venenatis, rutrum odio vel, gravida lacus. Vivamus id mauris nec ante dictum consectetur. Nullam vulputate nisi sit amet lectus pulvinar, eu pretium ante sodales.</p>\r\n','','filtered_html'),('node','page',0,24,24,'und',0,'<p>We take our customer’s privacy seriously and we will only collect, record, hold, store, disclose, transfer and use your personal information as outlined below. Data protection is a matter of trust and your privacy is important to us. We shall therefore only use your name and other information which relates to you in the manner set out in this Privacy Policy. We will only collect information where it is necessary for us to do so and we will only collect information if it is relevant to our dealings with you.</p>\r\n\r\n<p>We will only keep your information for as long as we are either required to by law or as is relevant for the purposes for which it was collected.</p>\r\n\r\n<p>You can visit the Platform (as defined in the Terms of Use) and browse without having to provide personal details. During your visit to the Platform you remain anonymous and at no time can we identify you unless you have an account on the Platform and log on with your user name and password.</p>\r\n\r\n<p>If you have any comments, suggestions or complaints, you may contact us (and our Data Protection Officer) at <a href=\"#\">customer.services@marketplace.com</a></p>\r\n\r\n<h3>Collection of Personal Information</h3>\r\n\r\n<p>When you create a Marketplace account, or otherwise provide us with your personal information through the Platform, the personal information we collect may include your:</p>\r\n\r\n<ul>\r\n	<li>Name</li>\r\n	<li>Delivery Address</li>\r\n	<li>Email Address</li>\r\n	<li>Contact Number</li>\r\n	<li>Mobile Number</li>\r\n	<li>Date of Birth</li>\r\n	<li>Gender</li>\r\n</ul>\r\n\r\n<p>You must only submit to us, our authorized agent or the Platform, information which is accurate and complete and not misleading and you must keep it up to date and inform us of changes (more information below). We reserve the right to request for documentation to verify the information provided by you.</p>\r\n\r\n<p>We will only be able to collect your personal information if you voluntarily submit the information to us. If you choose not to submit your personal information to us or subsequently withdraw your consent to our use of your personal information, we may not be able to provide you with our Services. You may access and update your personal information submitted to us at any time as described below.</p>\r\n\r\n<p>If you provide personal information of any third party to us, we assume that you have obtained the required consent from the relevant third party to share and transfer his/her personal information to us.</p>\r\n\r\n<p>If you sign up for Marketplace using your social media account or link your Marketplace account to your social media account or use certain other Marketplace social media features, we may access information about you which you have voluntarily provided under your social media account via that social media provider in accordance with the provider\'s policies and we will manage your personal data which we have collected in accordance with Marketplace privacy policy</p>\r\n\r\n<h3>Use and Disclosure of Personal Information</h3>\r\n\r\n<p>The personal information we collect from you will be used, or shared with third parties (including related companies, third party service providers, and third party sellers), for some or all of the following purposes:</p>\r\n\r\n<ul>\r\n	<li>To facilitate your use of the Services (as defined in the Terms of Use) and/or access to the Platform;</li>\r\n	<li>To process orders you submit through the Platform, whether the products are sold by Marketplace or a third party seller. Payments that you make through the Platform for products, whether sold by Marketplace or a third party seller, will be processed by our agent;</li>\r\n	<li>To deliver the products you have purchased through the Platform, whether sold by Marketplace or a third party seller. We may pass your personal information on to a third party in order to make delivery of the product to you (for example to our courier or supplier), whether the product is sold through the Platform by Marketplace or a third party seller;</li>\r\n	<li>To update you on the delivery of the products, whether sold through the Platform by Marketplace or a third party seller, and for customer support purposes;</li>\r\n	<li>To compare information, and verify with third parties in order to ensure that the information is accurate;</li>\r\n	<li>Further, we will use the information you provide to administer your account (if any) with us; verify and carry out financial transactions in relation to payments you make online; audit the downloading of data from the Platform; improve the layout and/or content of the pages of the Platform and customize them for users; identify visitors on the Platform; carry out research on our users’ demographics and behavior; provide you with information we think you may find useful or which you have requested from us, including information about our or third party sellers’ products and services, provided you have indicated that you have not objected to being contacted for these purposes;</li>\r\n	<li>When you register an account with Marketplace or otherwise provide us with your personal information through the Platform, we will also use your personal information to send you marketing and/or promotional materials about our or third party sellers’ products and services from time to time. You can unsubscribe from receiving marketing information at any time by using the unsubscribe function within the electronic marketing material. We may use your contact information to send newsletters from us and from our related companies; and</li>\r\n	<li>In exceptional circumstances Marketplace may be required to disclose personal information, such as when there are grounds to believe that the disclosure is necessary to prevent a threat to life or health, for law enforcement purposes, or for fulfillment of legal and regulatory requirements and requests.</li>\r\n</ul>\r\n\r\n<p>Marketplace may share your personal information with third parties and our affiliates for the abovementioned purposes, specifically, completing a transaction with you, managing your account and our relationship with you, marketing and fulfilling any legal or regulatory requirements and requests as deemed necessary by Marketplace. In sharing your personal information with them, we endeavor to ensure that the third parties and our affiliates keep your personal information secure from unauthorized access, collection, use, disclosure, or similar risks and retain your personal information only for as long as they need your personal information to achieve the abovementioned purposes.</p>\r\n\r\n<p>In disclosing or transferring your personal information to third parties and our affiliates located overseas, Marketplace take steps to ensure that the receiving jurisdiction has in place a standard of protection accorded to personal information that is comparable to the protection under or up to the standard of the Philippine Data Privacy Act.</p>\r\n\r\n<p>Marketplace does not engage into the business of selling customers’ personal information to third parties.</p>\r\n\r\n<h3>Withdrawal of Consent</h3>\r\n\r\n<p>You may communicate your objection to our continual use and/or disclosure of your personal information for any of the purposes and in the manner as stated above at any time by contacting us at our e-mail address below.</p>\r\n\r\n<p>Please note that if you communicate your objection to our use and/or disclosure of your personal information for the purposes and in the manner as stated above, depending on the nature of your objection, we may not be in a position to continue to provide our products or services to you or perform on any contract we have with you. Our legal rights and remedies are expressly reserved in such event.</p>\r\n\r\n<h3>Updating Your Personal Information</h3>\r\n\r\n<p>You can update your personal information anytime by accessing your account on the Marketplace Platform. If you do not have an account with us, you can do so by contacting us at our e-mail address below.</p>\r\n\r\n<p>We take steps to share the updates to your personal information with third parties and our affiliates with whom we have shared your personal information if your personal information is still necessary for the above stated purposes.</p>\r\n\r\n<h3>Accessing Your Personal Information</h3>\r\n\r\n<p>If you would like to view the personal information we have on you or inquire about the ways in which your personal information has been or may have been used or disclosed by Marketplace within the past year, please contact us at our e-mail address below. We reserve the right to charge a reasonable administrative fee for retrieving your personal information records.</p>\r\n\r\n<p>If you have an account with Marketplace, you may access details of your order by logging into your account on the Platform. Here you can view the details of your orders that have been completed, those which are open and those which are shortly to be dispatched and administer your address details, bank details and any newsletter to which you may have subscribed. You undertake to treat your Marketplace username, password and order details confidentially and not make it available to unauthorized third parties. We cannot assume any liability for misuse of your Marketplace username, password or order details, except as stated in the Terms of Use.</p>\r\n\r\n<h3>Security of Your Personal Information</h3>\r\n\r\n<p>Marketplace ensures that all information collected will be safely and securely stored. We protect your personal information by:</p>\r\n\r\n<ul>\r\n	<li>Restricting access to personal information</li>\r\n	<li>Maintaining technology products to prevent unauthorized computer access</li>\r\n	<li>Securely destroying your personal information when it is no longer needed for any legal or business purpose</li>\r\n</ul>\r\n\r\n<p>Marketplace uses 128-bit SSL (secure sockets layer) encryption technology when processing your financial details. 128-bit SSL encryption is approximated to take at least one trillion years to break, and is the industry standard.</p>\r\n\r\n<p>If you believe that your privacy has been breached by Marketplace, please contact us at our e-mail address below.</p>\r\n\r\n<p>Your password is the key to your account. Please use unique numbers, letters and special characters, and do not share your Marketplace password to anyone. If you do share your password with others, you will be responsible for all actions taken in the name of your account and the consequences. If you lose control of your password, you may lose substantial control over your personal information and other information submitted to Marketplace. You could also be subject to legally binding actions taken on your behalf. Therefore, if your password has been compromised for any reason or if you have grounds to believe that your password has been compromised, you should immediately contact us and change your password. You are reminded to log off of your account and close the browser when finished using a shared computer.</p>\r\n\r\n<h3>Minor</h3>\r\n\r\n<p>Marketplace does not sell products for purchase by children. If you are under 18 years old, you may use our website only with the involvement of a parent or guardian.</p>\r\n\r\n<h3>Collection of Computer Data</h3>\r\n\r\n<p>Marketplace or our authorized service providers may use cookies, web beacons, and other similar technologies for storing information to help provide you with a better, faster, safer and personalized experience when you use the Services and/or access the Platform.</p>\r\n\r\n<p>When you visit Marketplace, our company servers will automatically record information that your browser sends whenever you visit a website. This data may include:</p>\r\n\r\n<ul>\r\n	<li>Your computer\'s IP address</li>\r\n	<li>Browser type</li>\r\n	<li>Webpage you were visiting before you came to our Platform</li>\r\n	<li>The pages within the Platform which you visit</li>\r\n	<li>The time spent on those pages, items and information searched for on the Platform, access times and dates, and other statistics.</li>\r\n</ul>\r\n\r\n<p>This information is collected for analysis and evaluation in order to help us improve the Platform and the services and products we provide.</p>\r\n\r\n<p>Cookies are small text files (typically made up of letters and numbers) placed in the memory of your browser or device when you visit a website or view a message. They allow us to recognize a particular device or browser and help us to personalize the content to match your preferred interests more quickly, and to make our Services and Platform more convenient and useful to you.</p>\r\n\r\n<p>Web beacons are small graphic images that may be included on our Service and the Platform. They allow us to count users who have viewed these pages so that we can better understand your preference and interests.</p>\r\n\r\n<h3>No Spam, Spyware, or Virus</h3>\r\n\r\n<p>Spam, spyware or virus is not allowed on Platform. Please set and maintain your communication preferences so that we send communications to you as you prefer. You are not licensed or otherwise allowed to add other users (even a user who has purchased an item from you) to your mailing list (email or physical mail) without their express consent. You should not send any messages which contain spam, spyware or virus via the Platform. If you would like to report any suspicious messages, please contact us at our email address below.</p>\r\n\r\n<h3>Changes to the Privacy Policy</h3>\r\n\r\n<p>Marketplace shall regularly review the sufficiency of this Privacy Policy. We reserve the right to modify and change the Privacy Policy at any time. Any changes to this policy will be published on the Platform.</p>\r\n\r\n<h3>Marketplace\'s Right</h3>\r\n\r\n<p>YOU ACKNOWLEDGE AND AGREE THAT MARKETPLACE HAS THE RIGHT TO DISCLOSE YOUR PERSONAL INFORMATION TO ANY LEGAL, REGULATORY, GOVERNMENTAL, TAX, LAW ENFORCEMENT OR OTHER AUTHORITIES OR THE RELEVANT RIGHT OWNERS, IF MARKETPLACE HAS REASONABLE GROUNDS TO BELIEVE THAT DISCLOSURE OF YOUR PERSONAL INFORMATION IS NECESSARY FOR THE PURPOSE OF MEETING ANY OBLIGATIONS, REQUIREMENTS OR ARRANGEMENTS, WHETHER VOLUNTARY OR MANDATORY, AS A RESULT OF COOPERATING WITH AN ORDER, AN INVESTIGATION AND/OR A REQUEST OF ANY NATURE BY SUCH PARTIES. TO THE EXTENT PERMISSIBLE BY APPLICABLE LAW, YOU AGREE NOT TO TAKE ANY ACTION AND/OR WAIVE YOUR RIGHTS TO TAKE ANY ACTION AGAINST MARKETPLACE FOR THE DISCLOSURE OF YOUR PERSONAL INFORMATION IN THESE CIRCUMSTANCES.</p>\r\n\r\n<h3>Contacting Marketplace</h3>\r\n\r\n<p>If you wish to withdraw your consent to our use of your personal information, request access and/or correction of your personal information, have any queries, comments or concerns, or require any help on technical or cookie-related matters, please feel free to contact us (and our Data Protection Officer) at <a href=\"#\">customer.services@marketplace.com</a></p>','','full_html'),('node','page',0,26,26,'und',0,'<div class=\"block-sell-on\">\r\n<div class=\"row\">\r\n<div class=\"col-sm-6\">\r\n<p>Individuals and businesses can list products on MarketPlace, one of the fastest ways to start selling online.</p>\r\n\r\n<ul>\r\n	<li>More than 20 categories to sell in</li>\r\n	<li>Trusted MarketPlace platform</li>\r\n	<li>No per-item listing fee</li>\r\n</ul>\r\n\r\n<div class=\"note\">\r\n<p>\"Selling on MarketPlace makes it possible for us to reach a global audience with our innovative products.\" <strong>Bernie Thompson, Founder, Plugable Technologies</strong></p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"col-sm-6 text-center\"><iframe allowfullscreen=\"\" height=\"281\" src=\"//player.vimeo.com/video/55806355\" width=\"500\"></iframe></div>\r\n</div>\r\n\r\n<div class=\"block-sell-on-works\">\r\n<h2>How Selling on MarketPlace Works</h2>\r\n\r\n<div class=\"row\">\r\n<div class=\"col-sm-6\">\r\n<div class=\"media\"><i class=\"fa fa-upload pull-left\"><span>upload</span></i>\r\n\r\n<div class=\"media-body\">\r\n<h4 class=\"media-heading\">Upload your listings</h4>\r\n\r\n<p>Add your offers to the MarketPlace catalog using feeds, spreadsheets, and other tools.</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"media\"><i class=\"fa fa-desktop pull-left\"><span>desktop</span></i>\r\n\r\n<div class=\"media-body\">\r\n<h4 class=\"media-heading\">Customers can see your products on marketplace.com</h4>\r\n\r\n<p>With features like 1-Click and a brand millions trust, MarketPlace helps customers make quick, easy, worry-free purchases.</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"media\"><i class=\"fa  fa-truck pull-left\"><span>truck</span></i>\r\n\r\n<div class=\"media-body\">\r\n<h4 class=\"media-heading\">Ship products to customers</h4>\r\n\r\n<p>MarketPlace notifies you when customers place an order. Use Fulfillment by MarketPlace and let MarketPlace do the shipping for you — or handle shipping yourself.</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"media\"><i class=\"fa fa-usd pull-left\"><span>usd</span></i>\r\n\r\n<div class=\"media-body\">\r\n<h4 class=\"media-heading\">MarketPlace transfers payments to you</h4>\r\n\r\n<p>MarketPlace deposits payment into your bank account at regular intervals and notifies you that your payment has been sent.</p>\r\n</div>\r\n</div>\r\n</div>\r\n\r\n<div class=\"col-sm-6 field-image\"><img alt=\"How Selling on MarketPlace Works\" src=\"/sites/default/files/pictures/about-us/sell-on.jpg\" />\r\n<div class=\"note\">\r\n<p>\"Selling on MarketPlace makes it possible for us to reach a global audience with our innovative products.\" <strong>Bernie Thompson, Founder, Plugable Technologies</strong></p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n\r\n<div class=\"note\">\r\n<p>* Offer limited to new Professional Selling on Amazon subscriptions only. Offer is not available to sellers who have previously registered to list on Amazon.com. Offer includes one month of subscription fees only (you will be charged other fees, including referral fees, for items that sell on Amazon.com). A credit of $39.99 will be posted to your seller account to offset one month of subscription fees charged. Other limitations apply. After the trial period, we will automatically charge your credit card the monthly subscription fee at the beginning of every month thereafter.</p>\r\n</div>\r\n</div>\r\n','','full_html'),('node','page',0,27,27,'und',0,'<p><strong>Marketplace</strong> is the number one online shopping site. Marketplace offers a wide array of products and provides convenient online shopping experience with its nationwide shipping, warranties, 30-day returns policy, and easy payment options. Consumers can shop anytime and anywhere for books, electronics, phones &amp; accessories, computers, home &amp; living, hardware, home appliances, toys, kids &amp; babies, travel and luggage, beauty, jewelry &amp; watches, fashion, and sports.</p>\r\n\r\n<div class=\"block-about\">\r\n<div class=\"field-body\">\r\n<h2>How To Shop at Marketplace</h2>\r\n\r\n<p>It’s simple to shop at Marketplace</p>\r\n\r\n<ol>\r\n	<li>Select your products at Marketplace.</li>\r\n	<li>Register with us and pick a payment option.</li>\r\n	<li>Have your products delivered quickly and safely.</li>\r\n</ol>\r\n</div>\r\n</div>\r\n\r\n<div class=\"block-about\">\r\n<div class=\"field-body\">\r\n<h2>Safe and Secure Shoppinge</h2>\r\n\r\n<p>After making your selection, check out and pick a payment method – PayPal, credit card (installments available), and cash on delivery. After a successful transaction, you will get an order status and tracking number that lets you keep track of your order until it is delivered to you.</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"block-about\">\r\n<div class=\"field-body\">\r\n<h2>Safe and Secure Delivery</h2>\r\n\r\n<p>Your orders take utmost priority and will be delivered between 3-5 working days for Metro Manila and 5-10 working days for provincial orders. Should you have any questions on your order, please contact our customer service representatives between 8am to 9pm (Monday to Friday) or between 9am to 6pm (Saturday, Sunday, and holiday) at the <a href=\"http://localhost/marketplace/about-us#\">contact page</a> or (02) 795 8900 and we shall gladly assist you.</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"block-about\">\r\n<div class=\"field-body\">\r\n<h2>Returns</h2>\r\n\r\n<p>If your product is damaged or incomplete upon delivery, please contact MARKETPLACE’S customer service representatives (<a href=\"http://localhost/marketplace/about-us#\">contact page</a> or (02) 795 8900) WITHIN 24 hours of delivery to initiate the return. You have 30 (thirty) days from day of delivery to return your order with a completed <a href=\"http://localhost/marketplace/about-us#\">Return Form</a>. The cost of return will be refunded after your return has been processed.</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"block-about\">\r\n<div class=\"field-body\">\r\n<h2>Comprehensive and Personal Service</h2>\r\n\r\n<p>Our customers can contact us between 8am to 9pm (Monday to Friday) or between 9am to 6pm (Saturday, Sunday, and Holiday) at <a href=\"http://localhost/marketplace/about-us#\">contact page</a> or (02) 795 8900 to check the status of your order, ask any question about Lazada or give feedback on your shopping experience.</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"block-about\">\r\n<div class=\"field-body\">\r\n<h2>Marketplace part of Online Revolution</h2>\r\n\r\n<p>Marketplace is a participant of the <a href=\"https://en.wikipedia.org/wiki/Online_Revolution\">Online Revolution</a> e-commerce event, a Southeast Asian month-long online sale event similar to Black Friday and Cyber Monday, aiming to support the evolution of the Asian online culture thanks to fast-growing ventures and adapting consumers. In the Philippines, our partner ventures include Zalora: The country’s leading online fashion store, Lamido: The online marketplace for buyers to meet sellers, Carmudi: The online car dealership, Lamudi: The online real-estate listing, and Easy Taxi: Your Taxi is 1 Click Away.</p>\r\n</div>\r\n</div>\r\n','','full_html'),('node','webform',0,28,28,'und',0,'<h2>Company &amp; Contact&nbsp;Informattion</h2>\r\n\r\n<p>Fields marked <span class=\"form-required\" title=\"This field is required.\">*</span> are required</p>\r\n','','full_html'),('node','page',0,29,29,'und',0,'<p>We want you to have the simplest, easiest buying experience possible. But we know you might have a few questions. Read on for details about purchasing, shipping, checking order status, returns, and more.</p>\r\n','','filtered_html'),('node','product',0,30,30,'und',0,'<p>Not just any backpack, Aeroline Casual Hiking backpack is ideal when going for that hike, weekend camping rendezvous or traveling. It is a great choice to bring around to help ease the load or lend a helping shoulder in those adventurous moments.</p>\r\n\r\n<p><strong>Ergonomically Designed</strong><br />\r\nAeroline’s backpack is ergonomically designed to accommodate 35 liters worth of essentials such as clothes, food and medicine to prepare you for any situations. This pack provides you with a large compartment with a small interior zippered compartment, a medium compartment and two side pockets. Fret not of downpours or a little sprinkle as it is waterproof and wear resistant to match your toughness.</p>\r\n\r\n<p><strong>Tough on Everything Else Except for You</strong><br />\r\nAs a user friendly pack, it is designed in a way to fit perfectly snugged including a waist strap with buckle to reduce pressure on your spine and shoulder and back support paddings. Thus, making your walks and climbs a more comfortable one. Made out of superior ripstop waterproof nylon cloth, you can pretty much go through any weather suitable for adventurous backpackers, mountain climbers and travellers.</p>\r\n\r\n<p class=\"rtecenter\"><img alt=\"\" src=\"/sites/default/files/products/aeroline-casual-hiking-1.jpg\" /></p>\r\n','','filtered_html'),('node','product',0,31,31,'und',0,'<p>Planning for a weekend getaway from the city jungle? Diving into the lush greenery trail and wide blue ocean for some relaxing time? Then pack all your gears into the Local Lion Water Resistant Hiking Backpack Bag 28L Sky Blue. Its duffle style cavernous space can suck in your travel clothes, smartphone, camera and even laptop! So snap your quickie holiday with this backpack now. This bag is dedicated to keep you connected...even during your wild jungle adventure!</p>\r\n\r\n<p>The Local Lion Water Resistant Hiking Backpack Bag 28L Sky Bluebackpack is designed with your active lifestyle in mind. Made of high quality material, the cool fabric will hurdle any tear or slash on its track without ripping any further damage.</p>\r\n\r\n<p><strong>Put in Everything!</strong><br />\r\nThe main interior of this backpack is big enough to slap in your laptop. Multiple zipped pockets and sleeves are made readily available to store your gadget accompanying accessories. So, stash in your MP3 player, smartphone, power bank, charging cables and camera. Its’ convenient and hard underbelly strips will provide extra protection from your bumpy journey.</p>\r\n\r\n<p><strong>Cushiony Comfort</strong><br />\r\nLong hours of backpacking this bag will be easy as a breeze. Lightweight and compact, the back and shoulder straps are padded with super cushion for your ultimate comfort.</p>\r\n\r\n<p><strong>Looking Pretty Good</strong><br />\r\nCut out with the most trendy pattern pole in town, this backpack is specially design to look fashionable and functional. Plus, this backpack colourfast material can even withstand multiple washing after a rough day in the outdoor. Durable, it will always come out pretty sleek. Just like new!</p>\r\n','','filtered_html'),('node','product',0,32,32,'und',0,'<p>Stay stylish with a laptop bag from Terminus. This Terminus T02-297LAP-01 Laptop Backpack Plus is not only made to appear fashionable, but it is also designed with an ergonomic shape. The Laptop Backpack comes with a front compartment that is ideal for storing paper documents, power adapter, mouse and other laptop accessories. The laptop compartment can fit a 14.5” laptop and there is a padded compartment that could fit an iPad or a tablet. Not only that the bag is lightweight and robust, but it is also elastic to slip over a trolley luggage handle. This bag is great to bring on a travel or even for everyday use, it will never fail to keep your belongings safe, secure and within reach.</p>\r\n\r\n<p><strong>About Terminus</strong><br />\r\nTerminus is a world-class, design oriented brand. A brand that creates many innovations with no boundaries and a home grown brand that draws its inspiration from all over the world. There is no other brand like Terminus, who focuses their designs based on this direction: designs inspired by talented designers from different countries for a truly global style. Every Terminus product is designed to the highest standards of functionality, appearance, fashion and hand feels. Whether it’s for a sophisticated, professional or active lifestyle, you will find innovations and conveniences you didn’t think possible till you see a Terminus bag – bags that wow and work!</p>\r\n','','filtered_html'),('node','product',0,33,33,'und',0,'<p><strong>The Targus 15.6In Revolution Backpack</strong> is a sporty and all purpose backpacks that provide high functionality &amp; rugged protection. Featuring anti-scratch material this backpack can prevent any scratches to the surface of your laptop. The design of this backpack less resembles traditional laptop backpack hence it is the perfect day-to-day backpack even without carrying the laptop around. With special attention to the user experience, the back panel and shoulder straps are designed with the maximum comfort and protection. Featuring a extra- large full zip-down main compartment, users and put and take items to and from this backpack easily without the hassle of digging. With the high grade material and the design of raincover, this backpack can provide superior protection to the items inside. This Revolution backpack is truly designed for the adventurous individuals.</p>\r\n','','filtered_html'),('node','product',0,34,34,'und',0,'<p><img alt=\"Tarantula Shoe Bag (BOS04-088SHB-03) - Red \" src=\"/marketplace/sites/default/files/products/tarantula-shoe-bag-red-des.jpg\" /></p>\r\n','','filtered_html'),('node','product',0,35,35,'und',0,'<p class=\"rtecenter\"><img alt=\"Diniwell Water-Resistant Travel Shoes Bag Pouch Organizer Bag Ver 2 - Orange\" src=\"/marketplace/sites/default/files/products/diniwell-water-resistant-05.jpg\" /><br />\r\n&nbsp;</p>\r\n','','filtered_html'),('node','product',0,36,36,'und',0,'<p>Applying makeup and enhancing looks on the go is made easy thanks to this 24-piece makeup brush set. Featuring&nbsp;natural/synthetic-blend fibres&nbsp;for supreme softness, the premium quality makeup brushes will be delivered to makeup mavens\' doors in a black travel pouch.</p>\r\n\r\n<p><strong>Specification &amp; Features</strong></p>\r\n\r\n<p>Material:</p>\r\n\r\n<ul>\r\n	<li>Brush: Soft synthetic fibres and pony hair</li>\r\n	<li>Handle: Bamboo</li>\r\n	<li>Ferrule: Aluminium</li>\r\n	<li>Pouch: PU leather</li>\r\n</ul>\r\n\r\n<p>Colour: Black and wooden handle</p>\r\n\r\n<p>Individually handcrafted with high quality materials</p>\r\n\r\n<p>Each brush comes with own plastic cover and compartment</p>\r\n\r\n<p>Roll-up pouch for easy travel and storage</p>\r\n\r\n<p>Plastic-lined pouch with waterproof exterior for added protection</p>\r\n','','filtered_html'),('node','product',0,37,37,'und',0,'<p>In vel tortor id turpis dignissim porttitor eu ac urna. Aenean in elit vel magna ultricies volutpat. Vestibulum vitae magna auctor, dignissim purus ullamcorper, varius sem. Sed nibh ex, fringilla ac enim at, iaculis maximus elit. Integer vitae gravida dolor. Nullam ultrices, diam at tincidunt feugiat, nunc magna euismod magna, eu euismod odio sapien vel lacus. Etiam malesuada sodales ante eget semper. Phasellus viverra elementum gravida. Maecenas tincidunt posuere lorem, eu tempus augue mollis et. Nam blandit viverra urna, sit amet laoreet dolor auctor ac. Vivamus eu justo erat. Fusce mollis quis nunc a facilisis.</p>\r\n\r\n<p>Curabitur commodo, lorem a tincidunt pellentesque, mauris massa aliquam enim, vel rutrum elit nisl ut mauris. Duis mattis neque arcu, eu pulvinar libero maximus ut. Vestibulum eget facilisis diam. Proin eget ante diam. Donec pulvinar magna id est vestibulum, et facilisis odio pellentesque. Fusce ut felis lorem. Quisque cursus libero non tempor imperdiet. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Donec at nibh nec lacus varius dapibus. Duis a lectus a augue interdum tempor sed ut arcu.</p>\r\n\r\n<p>&nbsp;</p>\r\n','','filtered_html'),('node','product',0,38,38,'und',0,'<p>Power Perfect Pore with mist function maintains clean, healthy and radiant looking skin without embarrassing blackheads or whiteheads. Its deep penetrating suction cleanses below the surface to effectively help prevent breakouts. No more squeezing, pulling or injuring your skin.</p>\r\n\r\n<p>Power Perfect Pore (Facial Kit) is perfect solution for clean, clear and fair skin. No Blackheads, No Pimples, No Dark Circles, No Wrinkles. Power Perfect Pore is easy to operate. It cleans &amp; clears the skin. Use it with cream or moisturizer for gentle massage and better absorption.</p>\r\n\r\n<p><strong>POWER PORE FACIAL!!!!!</strong><br />\r\nErgonomically designed suction cup. Removes black heads without hurting your skin with hard squeezing. Face Suction Cup Cleans pores and black heads from your skin by its suction technology. Contour Massager tones face muscles, stimulate blood vessels and thus improve blood circulation. Cleaning Sponge helps you to spread facial cream evenly on your face to get maximum benefits of it. Exfoliation Brush with mist function renews skin by removal of dead cells of face and makes your skin glow.</p>\r\n','','filtered_html'),('node','product',0,39,39,'und',0,'<p><strong>SK-II 5-Piece Skincare Travel Set includes: Facial Treatment Gentle Cleanser 20g</strong><br />\r\nSK-II Facial Treatment Gentle Cleanser cares for your skin while it cleanses. It contains Concentrated Pitera and Mild Treatment Essence that leaves your skin hydrated even 30 minutes after cleansing. Work up a fine-textured lather and enjoy its mild rose scent. Facial Treatment Clear Lotion 30ml. For perfectly conditioned and ultra-fresh skin, use the Facial Treatment Clear Lotion morning and evening after cleansing your face and neck. The final part of your cleansing process, this lotion helps remove residual impurities and dead skin cells. Facial Treatment Essence 30ml SK-II Facial Treatment Essence is also known as SK-II Miracle Water. The heart of the SK-II Ritual, the revolutionary Facial Treatment Essence is the second point of your ritual.</p>\r\n\r\n<p><strong>Facial Treatment Mask 1pc</strong><br />\r\nBoosts radiance and moisture levels and can be used by all skin types throughout the year. The mask literally drenches your skin in SK-II Pitera, resulting in a fresher and more hydrated complexion.</p>\r\n\r\n<p class=\"rtecenter\"><img alt=\"\" src=\"/sites/default/files/products/sk-II-5-piece-skincare-travel-01.jpg\" /></p>\r\n','','filtered_html'),('node','product',0,40,40,'und',0,'<p>Revive and restore skin around eyes with this moisturising antioxidant cream containing a special blend of Green Tea, Eyebright and Buckwheat extract. Made with 85% organic ingredients and certified to the strict Soil Association organic skin care standards, also vegan products registered. The gentle formulation of this organic eye cream make it suitable for all skin types, including sensitive skin.</p>\r\n','','filtered_html'),('node','product',0,41,41,'und',0,'<p>Mejikaliner Quick Eyelid Essence Stick Glue is an invisible Clear type double eyelid maker. It creates natural and beautiful double eyelids easily. How to use:1. Remove grease from eyelids.2. Locate your ideal double eyelid-line, usually 3 - 6mm above the eyelash, by slightly twist the end of the glud and apply glue along.3. To remove, wipe with wet cotton bud or facial puff. Volume: 2ml Origin: Japan</p>\r\n','','filtered_html'),('node','product',0,42,42,'und',0,'<p><strong>Hairscape Hair Dryer 5000 </strong><br />\r\nHigh performance professional salon hairdryer. Operating at 1600-1800 watts this turbo force hairdryer offers three speeds and 3 temperature settings Highlights.</p>\r\n','','filtered_html'),('node','product',0,43,43,'und',0,'<p><strong>Tonific - Body Massager</strong> has a unique ergonomic and revolutionary design with advanced technology that penetrates the deepest layers of your skin, helping it burn calories and reduce inches with little to no effort.</p>\r\n\r\n<p><strong>Tonific - Body Massager</strong> is the ideal method to help reduce and tone your entire body without any exercise. The secret is its exclusive design that spins at more than 2700 revolutions per minute.&nbsp;With Tonific you get 3 massagers in 1 with the patent Interchangeable Rotating Acu-Spheres.</p>\r\n','','filtered_html'),('node','product',0,44,44,'und',0,'<p><strong><u>Special Notice</u></strong>: for the iPhone 6, Lazada is not able to&nbsp;accept returns for convenience. In case of a damage or defect you will of&nbsp;course be able to make a return as normal.</p>\r\n<p>Bigger than&nbsp;biggeriPhone 6 isn’t simply bigger — it’s better in every way. Larger, yet dramatically thinner. More powerful, but remarkably power efficient. With a smooth metal surface that seamlessly meets the new Retina HD display. It’s one continuous form where hardware and software function in perfect unison, creating a new generation of iPhone that’s better by any measure.<br />\r\niPhone at its largest. And thinnest.</p>\r\n\r\n<p>iPhone at its largest. And&nbsp;thinnest.Developing an iPhone with a larger, more advanced display meant pushing the edge of design. From the seamless transition of glass and metal to the streamlined profile, every detail was carefully considered to enhance your experience. So while its display is larger, iPhone 6 feels just right.</p>\r\n\r\n<p>Not just a bigger display. A&nbsp;better display.It’s one thing to make a bigger display. It’s something else entirely to make a bigger Multi‑Touch display with brilliant colors and higher contrast at even wider viewing angles. But that’s exactly what we did with the new Retina HD display.</p>\r\n<p>Hugely powerful. Enormously eﬃcient.Built on 64-bit desktop-class architecture, the new A8 chip delivers more power, even while driving a larger display. The M8 motion coprocessor efficiently gathers data from advanced sensors and a new barometer. And with increased battery life, iPhone 6 lets you do more, for longer than ever.</p>\r\n<p>The camera that changed photos now does the same for&nbsp;video.More people take more photos with iPhone than with any other camera. And now the iSight camera has a new sensor with Focus Pixels and new video features, like 1080p HD at 60 fps, slo-mo at 240 fps, and time-lapse video mode. So you’ll have more reasons to capture more moments on video, too.</p>\r\n<p>Faster wireless. Far and wide.iPhone 6 has faster 4G LTE download speeds,* and it supports more LTE bands than any other smartphone to give you better roaming. And when connected to Wi-Fi, you’ll get up to 3x faster speeds.</p>\r\n<p>Security. Right at your fingertip.The breakthrough Touch ID technology lets you securely access your iPhone with the perfect password: your fingerprint. You can also use it to approve purchases or downloads from iTunes, iBooks, and the App Store without having to enter your password.</p>\r\n<p>The biggest iOS release ever.iOS 8 is the world’s most advanced mobile operating system. And with incredible new capabilities and features designed to make the most of a larger display, iOS 8 doesn’t just work seamlessly with iPhone 6. It makes every experience feel bigger and better.</p>\r\n','','filtered_html'),('node','product',0,45,45,'und',0,'<p><strong>Galaxy Note 4 Size &amp; Display</strong><br />\r\nThe phone measures 153.5 x 78.6 x 8.5 mm. The screen size remains the same as its predecessor, the Note 3, at 5.7-inches using the familiar Super AMOLED display with its over-saturated, bright colors. The resolution has been beefed up to “Quad HD” which is a resolution of 1,440 x 2,560 pixels and 515 ppi. For comparison, the Note 3 has a 1080p display of 1,080 x 1,920 pixels and 386 ppi. Because of this, the latest Note 4 is even sharper.</p>\r\n\r\n<p>The thickness of the device is still 0.33-inches, but the weight is 176 grams which makes it a bit more noticeable. This isn’t much of an issue though because unless you have very large hands, holding the Galaxy Note 4 comfortably and safely is usually a two-handed job anyway.</p>\r\n\r\n<p>&nbsp;</p>\r\n\r\n<p><strong>Processor, Memory &amp; Battery</strong><br />\r\nThe speed of the Galaxy Note 4 is impressive with one of the fastest quad-core chip-sets on the market: The Qualcomm Snapdragon 805 Krait 450 processor running at an impressive 2.7 Ghz. A 3200 mAh battery is provided to handle the more demanding QHD display and faster processor. The ability to load many complex apps is also provided for with 3GB of RAM memory which should be sufficient.</p>\r\n\r\n<p><strong>Android &amp; TouchWiz</strong><br />\r\nAndroid 4.4.4 KitKat is supplied. Not quite the Android 4.5 one would have hoped to see but the Samsung TouchWiz skin probably hasn’t been updated for that yet. Hopefully buyers of the Galaxy Note 4 will be able to upgrade the OS post-purchase. The main benefit of Android 4.5 is the remote “kill switch” to turn off the phone if it were stolen or lost.</p>\r\n\r\n<p>The stylus and software for the Note 4 is much the same. For people who love using the stylus, this version of the Note model won’t be much of a departure.</p>\r\n\r\n<p>&nbsp;</p>\r\n\r\n<p><strong>Internal &amp; External Storage</strong><br />\r\nThe internal storage is offered in a single 32GB configuration with a microSD card slot capable of handling up to 64GB cards. This is disappointing given that the Galaxy S5 can accept 128GB microSD cards and one would have expected the flagship Note 4 to offer the same storage capacity especially given the fact that it packs a super HD camera.</p>\r\n','','filtered_html'),('node','product',0,46,46,'und',0,'<p>Meet the world’s first All-in-One PC to feature all the performance of Windows 8 desktop and the flexibility of a tablet. ASUS Transformer AiO is perfect for productivity, but detach its 18.4-inch Full HD display and it instantly transforms into a multi-touch Android tablet.</p>\r\n\r\n<p><strong>ASUS desktops – leading in satisfaction with reliability</strong><br />\r\nASUS computers reflect a tradition of the finest quality, innovation and longevity. Based on the PCWorld USA 2012 reader survey of tech satisfaction, reliability, and service, users ranked ASUS as a leading choice for desktop PCs, citing high satisfaction with their value, connectivity, ease of use and reliability. The survey also found ASUS desktop PCs were one of the most likely to be recommended to others.</p>\r\n\r\n<p><strong>Windows 8 All-in-One PC</strong><br />\r\nWith a 3rd generation Intel Core i7 processor and powerful discrete graphics, ASUS Transformer AiO packs enough desktop PC performance for even the most demanding applications.</p>\r\n\r\n<p><strong>Enjoy Windows 8 anywhere in the home</strong><br />\r\nWith ASUS Transformer AiO, you don’t have to sacrifice powerful desktop performance just for the sake of the portability. Just grab the convenient handle and detach the 18.4-inch display from the PC Station for a fast and fluid Windows 8 experience, anywhere in the home. Wireless Remote Desktop technology gives complete control over Windows 8 on the PC Station with the multi-touch tablet, over any standard Wi-Fi connection.</p>\r\n\r\n<p>Connect the PC Station and Tablet to the same Wi-Fi access point to enjoy seamless data transmission. For faster connections, 5GHz networking is recommended, supported by the dual-band wireless capabilities of the PC station and tablet. It significantly reduces interference from nearby 2.4GHz networks and devices, resulting in better Wi-Fi.</p>\r\n','','filtered_html'),('node','product',0,47,47,'und',0,'<p><p><strong>Lenovo A316</strong> is a dual-core 3G smartphone with fashionable style and cost-effective price. It runs on Android operating system 2.3.6 OS and is operated by MTK6572, dual core, 1.3GHz CPU, Mali-400 GPU and 512MB RAM to make sure switching between applications and functions can be done smoothly.</p>\r\n<p><strong>Double SIM</strong><br />\r\nIt supports double SIM card and completely suitable with globally quad-band GSM and WCDMA 3G systems for making telephone calls. The 4.0 inches display with capacitive touch style lets you make the most out of the entertainment features like watching videos and playing your favourite mobile games.</p>\r\n<p><strong>Air Gesture</strong><br />\r\nWhat’s particularly eye-catching is the mobile phone’s Air-Gesture function, which makes viewing files, skipping tracks and switching pages easier. All you have to do is wave your hand over the screen to browse the previous or next pictures in Gallery, switch to the next song in music player and switch to another page on the Home or menu screen.</p>\r\n<p><strong>Simple Yet Powerful</strong><br />\r\nLenovo A316 is equipped with all the important features that you need in a phone. It supports WiFi and WCDMA 3G systems for browsing internet and data transfer as well as hands-free devices. With a built-in GPS processor for simple and easy routing, you will be able to get direction easily. Besides that, it is also equipped 2MPcamera for capturing great moments of your life. Get yours today!</p>','','filtered_html'),('node','product',0,48,48,'und',0,'<p>Connectivity. Convenience. Class. Imagine all the Cs in the palm of your hands. You want your phone to do everything. You want it to make life easier, but you\'d want it to look good as well. All this is made possible with the Nokia Asha 206 Dual Sim.</p>\r\n\r\n<p><strong>See and Be Seen</strong><br>A big, bright 2.4\'\' screen and tactile, well-spaced keys make the Nokia 206 Dual SIM a joy to use. It looks good too, combining clean, elegant design with a choice of striking colours.</p>\r\n\r\n<p><strong>Big Screen </strong><br>With the Nokia 206 Dual SIM, fun is never far away. Some of the hottest games around are included for free, including Bejeweled, Need for Speed Shift and Medal of Honor. It also comes with Tunewiki Social Player and the Pictelligent camera app.</p>\r\n\r\n<p><strong>Sharing Made Simple</strong><br>Friends are close at hand too, with Facebook, Twitter and eBuddy apps, while Slam makes sharing photos and other content simple. There\'s no complicated pairing process, just touch your Nokia 206 Dual SIM to any Bluetooth phone to transfer content.</p>\r\n\r\n<p><strong>Browsing At Its Best</strong><br>To help you put that large 2.4\'\' screen to good use, the Nokia 206 Dual SIM comes loaded with the Nokia Xpress Browser. More efficient than other browsers, it lets you enjoy an easier, more enjoyable and more affordable internet experience.</p>\r\n','','filtered_html'),('node','product',0,49,49,'und',0,'<p><strong>Retina Display</strong><br />\r\nFour times more pixels than iPad 2. Razor-sharp text. Richer colors. The Retina display transforms the entire iPad experience. So everything looks and feels incredibly lifelike and perfectly detailed</p>\r\n\r\n<p><strong>Performance</strong><br />\r\nThe A5X chip with quad-core graphics drives four times the pixels of iPad 2 yet it delivers the same smoothness and fluidity iPad is known for. Even with all that extra oomph, the new iPad still gets an amazing 10 hours of battery life</p>\r\n\r\n<p><strong>iSight Camera</strong><br />\r\nThe 5-megapixel iSight camera features a backside illumination sensor that captures great-looking pictures whether by sunlight or candlelight. Autofocus, tap to focus, and tap to set exposure functions mean every photo you take instantly becomes a frameworthy gem. And with built-in face detection that automatically balances focus and exposure across up to 10 faces, there’s more room for more grins. So everyone look at iPad and say “Cheese.”</p>\r\n','','filtered_html'),('node','product',0,50,50,'und',0,'<p><strong>The ASUS MeMO Pad 7</strong> was created for those looking for a value tablet. The 7-inch ASUS MeMO Pad 7 punches well above its weight, boasting features and specifications more commonly found on high-end tablets.</p>\r\n\r\n<p>Excellent image quality comes from superb technology. ASUS MeMO Pad 7 includes comes with best technology that combines software and optical design to deliver incredible images. Best of all, it\'s with you all the time to capture every moment.</p>\r\n','','filtered_html'),('node','product',0,51,51,'und',0,'<p>THE MINI-TABLET WITH A QUAD-CORE PROCESSOR.A 8\" Windows 8 tablet with an Intel® Atom™ Processor, the Lenovo Miix 2 is perfect for on-the-go entertainment or productivity.</p>\r\n\r\n<p><strong>Full HD (1280x800) Display With IPS Technology</strong><br />\r\nThe vibrant 8\" wide-view display uses In-Plane Switching (IPS) for vivid colors and nearly 180-degree viewing angles.</p>\r\n\r\n<p><strong>Five-Finger Multitouch Technology</strong><br />\r\nSeamlessly integrate with Windows 8 and enjoy more precise control.</p>\r\n\r\n<p><strong>Optional Detachable Cover With Stylus</strong><br />\r\nProtect your screen when not in use, or use the cover to hold the tablet upright in stand mode. And with included stylus pen, you can take notes, edit documents or simply doodle on-the-go.</p>\r\n\r\n<p><strong>Integrated Webcam</strong><br />\r\nThe 2MP front camera and up-to-8MP rear camera will help you enjoy web conferences or online video chats like you\'re really there.</p>\r\n\r\n<p><strong>Veriface™ Face Recognition Software</strong><br />\r\nYour face is your password. The integrated webcam uses stored images of your face to allow you to login quickly and easily, and the program supports multiple users, allowing you to authorize access for the entire family.</p>\r\n','','filtered_html'),('node','product',0,52,52,'und',0,'<p>Presenting the brand new iPad Air, unbelievably thin and light yet packs so much more power and capabilities than ever before. Featuring the latest A7 chip, advanced wireless, and great apps for your entertainment, productivity and creativity – all beautifully integrated with the iOS 7.</p>\r\n\r\n<p><strong>Amazingly Thin &amp; Light</strong><br>Through a series of vigorous refinements, Apple has managed to drop the iPad Air’s volume close to a quarter of the volume of the previous generation iPad. However, when you hold the iPad Air for the first time in your hands, you will feel how durable and elegantly designed it is. The unibody construction provides amazing strength and simplifies the enclosure which the results is an iPad that not feels amazing to hold but is also easy to take around with you no matter where you go.</p>\r\n\r\n<p><strong>Stunning Display</strong><br>The stunning Retina display is included in the iPad Air and it looks amazing as ever. The iPad Air retains the same 9” display but now has thinner side bezels and a narrower width overall. Although a subtle change, it makes a dramatic difference for your content viewing pleasure and with Retina display, everything seems to just pop out. Using a touch-rejection algorithm, iPad Air recognizes if your thumb is simply resting on the display while you’re holding it or if you’re intentionally interacting with the Multi-Touch screen.</p>\r\n','','filtered_html'),('node','product',0,53,53,'und',0,'<p>Experience the protective new bumper case. The Neo Hybrid™ for the Galaxy Note 4 is a completely reimagined dual layer bumper style case that provides full coverage of your Note 4. It is composed of a UV-coated hard polycarbonate frame and a high-polymer-coated soft TPU cover. The TPU casing has a textured midsection for grip and embedded accent lines for a quality look. The buttons are metallized for a premium look and engaging experience. &nbsp;The inner web-patterned TPU helps absorb and disperse the impact from drops and bumps.</p>\r\n\r\n<ul>\r\n	<li>Advanced Shock Absorption Technology: Web Pattern TPU case</li>\r\n	<li>Matte TPU and Polycarbonate for drop and scratch protection</li>\r\n	<li>Slim and form fitted to show the perfect shape of your device</li>\r\n	<li>Metallic finish to frame &amp; metallized polycarbonate buttons</li>\r\n	<li>Lay on the table design: 0.8mm lip for optimal screen protection</li>\r\n	<li>Compatible with Samsung Galaxy Note 4 Only - 2014</li>\r\n</ul>\r\n','','filtered_html'),('node','product',0,54,54,'und',0,'<p><strong>Samsung S View Cover Case for Galaxy Note 4</strong><br />\r\nThe Samsung S View Cover Case for Galaxy Note 4 protects your screen when it is not in use and is easily flipped open for full access to the screen. When closed, the S View cover offers instant access to critical features, thanks to the Samsung ID chip. View the home screen to check the time, weather and other status items. Accept or reject incoming calls with just a swipe, or reject calls with a preset message. Control your music playback directly on the S View screen. If you miss anything, notifications are shown in the recent activity menu of your S View cover unless phone security settings are activated. Swipe left to quickly access your phone\'s camera without opening the cover to take pictures or video right in the moment.</p>\r\n\r\n<p><strong>The Perfect Combination of Style and Functionality</strong><br />\r\nThe Samsung Galaxy Note 4 S View Cover was developed with your busy lifestyle in mind. This smart case, designed to protect and enhance the Samsung Galaxy Note 4, is the perfect combination of style and functionality. Not only is the S View Cover available in multiple attractive colors, the built-in intelligent color system recognizes the case color and automatically matches the view window background with a complementary color for a personalized look. You can even upload your own image for added customization. And with the innovative S View design, you will never miss important information.</p>\r\n','','filtered_html'),('node','product',0,55,55,'und',0,'<p>The Samsung Galaxy Tab 7.0 Plus Vehicle Dock With In Car Charger lets you take the brilliance of your Samsung smartphone along for the ride! The custom fitted cradle holds the handset securely during long rides. Attach it to a windshield or dashboard and adjust the multi-angle neck for perfect viewing.</p>\r\n\r\n<p>GPS capabilities are optimized with navigation applications but that’s just the beginning with the endless Android apps available. With your hands safely on the steering wheel, experience the convenience of powerful, voice-activated Android applications like S Voice. Your Samsung smartphone and Vehicle Navigation Mount duo is truly brilliance on the go.</p>\r\n','','filtered_html'),('node','product',0,56,56,'und',0,'<p><strong>Mobile yourself with Newly</strong></p>\r\n\r\n<p><strong>Newly iShop</strong><br />\r\nNewly iShop is an online store located in Malaysia. They provide ultimate shopping destination online, providing items of the latest trend, computer accessories, home and living, and Mobile Accessories at affordable price. And since people love Mobile just as much as they do, Newly ALWAYS on the hunt for the newest, drool worthy pieces to bring you. Combining style with quality materials, only the most convenience mobile accessories are sourced from around the globe.</p>\r\n','','filtered_html'),('node','product',0,57,57,'und',0,'<p>Unlike traditional, circular earbuds, the design of the new Apple EarPods is defined by the geometry of the ear. Which makes them more comfortable for more people than any other earbud-style headphone. The speakers inside Apple EarPods have been engineered to minimize sound loss and maximize sound output. So you get high-quality audio that’s just as impressive as what you’d hear from more expensive headphones.</p>\r\n\r\n<p>The Apple EarPods with Remote and Mic also include a built-in remote that lets you adjust the volume, control the playback of music and video, and answer or end calls with a pinch of the cord.</p>\r\n','','filtered_html'),('node','product',0,58,58,'und',0,'<p>Easier than connecting a cable. Touch once to pair your smartphone with your wireless headset*. If the devices have been disconnected, touch once to re-connect. NFC is pure magic.</p>\r\n\r\n<p><strong>Sound clarity</strong><br>An easy-to-use wireless stereo headset from Sony, with straightforward call keys and music controls. Enjoy the rich bass and dynamic sound of this impressive headset. Let HD Voice give the person you are calling an in-the-room experience*. Bluetooth wireless technology lets you move freely and enjoy all the audio in your smartphone. At a distance.</p>\r\n\r\n<p><strong>Design</strong><br>Sony Stereo Bluetooth Headset SBH20 comes in several colours. It has a secure and rotatable clip that lets you wear your mobile phone headset as you want. An ergonomic sliding power key and large tactile music control keys add extreme ease to subtle style.</p>\r\n','','filtered_html'),('node','product',0,59,59,'und',0,'<p>Prepare to experience one of the most advanced powerbanks for all generations of iPad, iPhone, iPod, Samsung devices, HTC, Blackberry and other USB related devices. Introducing the&nbsp;TOP Mi&nbsp;Powerbank 10,400mAh Powerbank. With a capacity of 10,400mAh, this powerful charger will ensure that your smart phones or digital devices be fully charged and ready to use! No need to worry about running out of battery after a long day at work, take efficiency to a whole new level with the&nbsp;TOP Mi&nbsp;PowerBank. So what are you waiting for? Get it now while stocks last!</p>\r\n<p><strong>Useful features for your everyday electronic needs</strong>It is always frustrating when you find yourself in a situation where your smart phone or digital device has run out of battery, especially when you need it the most! With the&nbsp;TOP Mi&nbsp;Powerbank, you never have to get caught in such a predicament ever again! The light indicator is a convenient feature that lets you know when your device has been fully charged and ready to be used to its maximum potential!</p>\r\n','','filtered_html'),('node','product',0,60,60,'und',0,'<p>In this modern digital life today, power bank is just another necessary accessory that most people would need. Imagine having a charging device without the need of carrying the charging cables and connectors that you often forget! Power bank is just super-duper handy especially when you are always out travelling on the road.</p>\r\n\r\n<p><strong>Power Bank</strong><br />\r\nUniversal Power Bank is where power is stored in one compact little tool and can endlessly charge your gadgets on the road conveniently. It’s a mobile power source that enables you to store a huge amount of power and charge your gadgets without you having to look for plugs!</p>\r\n\r\n<p><strong>Incredible Performance</strong><br />\r\nThis power bank is capable of storing up to 20,000mAh power supply which is enough to fully charge your iPhone multiple times! It is built with high quality grade A batteries to ensure an assurance use. Apart from charging your gadgets conveniently, its dual USB jacks are compatible for almost all brands and gadgets!</p>\r\n','','filtered_html'),('node','product',0,61,61,'und',0,'<p>The Symbol of Everlasting Love - is formed from two “bi-skeles”. The bi-skeles, two cornered knots, denote the aspects of two people, mind and spirit. The symbol looks like an “S”, joined together, the everlasting circle of eternity. Thus the figure represents two people, joined in mind and spirit in everlasting love.&nbsp;</p>\r\n\r\n<p><strong>MuWo Trendz Philosophy</strong><br />\r\nJewellery manufacturing process includes most advance technologies and dedicated research. Each product undergoes a series of procedures before we get the net product as a beautiful jewellery. The natural components of jewellery will undergo multiple processes, most jewelleries are executed by casting machines unless those specifically handcrafted ones, which is exceptional in quality.</p>\r\n\r\n<p><strong>MuWo Trendz Jewellery</strong> has two unique grades. Normal grade with a lower price point which is good for most occasion with 2 layer polishing. The premium class undergoes 4 polishing processes and has a finer and smoother finishing for all occasion. No matter what you’re looking for, we have both grades of similar design to choose from. Finally the plating process finishing off the Jewellery to be ready for the big occasion.</p>\r\n','','filtered_html'),('node','product',0,62,62,'und',0,'<p>Power your ensemble with this incredible multi color tribal necklace from Luccacal. Linger this statement necklace over a simple tee or match it to a favorite dress.</p>\r\n','','filtered_html'),('node','product',0,63,63,'und',0,'<p>If you have to share anything in your wardrobe with your girlfriends, then this Dandelion Women Braided Belt would be the perfect calling for it. The interlaced nature of the belt makes it great for anyone – there’s no specific holes on a solid surface, just find one in between the braids to suit your size! This belt is great for a hippie-inspired look for a casual day out with your loved ones.</p>\r\n\r\n<p><strong>For the Child of Spring</strong><br />\r\nWalk through the colours of the wind with Dandelion’s range of fashion accessories, exclusively designed to enhance youthful, peace-loving personalities like yourself. Choose from figure definitive belts, beautiful flowy pastel scarves, eye-opening sunglasses to a wide array of jewelleries to adorn. Bring out the child of spring in you and enjoy the warmth of the sunshine with Dandelion.</p>\r\n','','filtered_html'),('node','product',0,64,64,'und',0,'<p>This beautifully crafted belt can be styled loose or as per usual basis to compliment the outfit of your choice. The Dandelion Cross Stitch Belt is a great addition to the colour blocking trend thanks to its solid colours and unique stitching design. Made to fit all sizes possible, the Dandelion Cross Stitch Belt is suitable for all occasions.</p>\r\n\r\n<p><strong>For the Child of Spring.</strong><br />\r\nWalk through the colours of the wind with Dandelion’s range of fashion accessories, exclusively designed to enhance youthful, peace-loving personalities like yourself. Choose from figure definitive belts, beautiful flowy pastel scarves, eye-opening sunglasses to a wide array of jewelleries to adorn. Bring out the child of spring in you and enjoy the warmth of the sunshine with Dandelion.</p>\r\n','','filtered_html'),('node','product',0,65,65,'und',0,'<p>Accessories are just as important as the clothes you put on and the shoes on your feet. The beauty of accessories is that they are inexpensive and with just several pieces, you could update the look of the clothes you have in your wardrobe without draining your wallet. You could be surprised how a piece of accessory can change an entire look. Whether you have Carrie\'s style of funky and eclectic or Charlotte\'s sophisticated elegance, there\'s always a piece of accessory to suit your signature identity and to flaunt an offbeat style statement. Add up some glam slam to your outfit with Fur Nyce Accessories.</p>\r\n\r\n<p><strong>Features</strong><br />\r\nAdd some wildness to your plain outfit with Fur Nyce Big Square Classic Chain Pattern Print Scarf. The scarf features classic chain pattern print and comes in plain yellow, brown and ivory in colour. The scarf is made of high quality, breathable cotton blends fabric.</p>\r\n\r\n<p><strong>About Fur Nyce Accessories</strong><br />\r\nFUR NYCE Accessories offers sparkling fashion jewelries and accessories in various shapes and styles. You are sure to build a staple collection of accessories that you could go back to time and time again. From classic to the trendiest style, you will definitely find the right piece at FUR NYCE Accessories from its massive style of fashion accessories with excellent value, high quality, and always on trend.</p>\r\n','','filtered_html'),('node','product',0,66,66,'und',0,'<p>Accessories are just as important as the clothes you put on and the shoes on your feet. The beauty of accessories is that they are inexpensive and with just several pieces, you could update the look of the clothes you have in your wardrobe without draining your wallet. You could be surprised how a piece of accessory can change an entire look. Whether you have Carrie\'s style of funky and eclectic or Charlotte\'s sophisticated elegance, thereﾒs always a piece of accessory to suit your signature identity and to flaunt an offbeat style statement. Add up some glam slam to your outfit with Fur Nyce Accessories.</p>\r\n\r\n<p><strong>Features</strong><br />\r\nAdd some wildness to your plain outfit with Fur Nyce Fashion Zebra Pattern Print Scarf. The scarf features zebra pattern print and comes in plain white in colour. The scarf is made of high quality, breathable cotton viscose fabric.</p>\r\n\r\n<p><strong>About Fur Nyce Accessories</strong><br />\r\nFurnyce Accessories offers sparkling fashion jewelries and accessories in various shapes and styles. You are sure to build a staple collection of accessories that you could go back to time and time again. From classic to the trendiest style, you will definitely find the right piece at FUR NYCE Accessories from its massive style of fashion accessories with excellent value, high quality, and always on trend.</p>\r\n','','filtered_html'),('node','product',0,67,67,'und',0,'<p>Once a marker of time, watches now have moved on to being a marker of personality. A watch is no longer just an accessory, it represents your personality and sense of style. Invicta, the watch for modern person, driven, elegant, classy, stylish, tough, invisible.</p>\r\n\r\n<p>A durable timepiece technology packed in a stainless steel strap and a black dial, the Invicta 15422 is intended for the man who appreciates the finer aspects of life. It has a flame fusion crystal glass and is water resistant up t0 10 ATM. Enjoy life in style and elegance with the Invicta 15422.</p>\r\n\r\n<p><strong>About Invicta</strong><br />\r\nIn the little town of Chiasso, Switzerland, was Invicta founded in 1837 and nurtured to where it stands today. Legendary for its consistence in quality and brand personality, Invicta resurfaced in the early 1990’s after a short disappearance during the quartz movement in the 1970’s. Innovative in style and construction, Invicta’s timeless masterpieces exudes an aura of class and elegance from its owner. Invicta, invincible through time, creating an immortal experience.</p>\r\n','','filtered_html'),('node','product',0,68,68,'und',0,'<p><strong>The Rolex Submariner</strong> is the indispensable instrument for every diver. Introduced in 1953, it was the first watch to be water-resistant to 100 meters (330 feet) during the pioneering era for scuba diving. This iconic timepiece exemplifies Rolex’s technical innovations and impeccable craftsmanship.</p>\r\n\r\n<p>Dial Type: Analog. Luminescent hands and markers. Automatic movement. Scratch resistant sapphire crystal. Screw down crown. Solid case back. Case diameter: 40 mm. Round case shape. Oyster clasp. Water resistant at 300 meters/ 1000 feet. Functions: hour, minute, second. Luxury watch style. Watch label: Swiss Made. Rolex Submariner Black Dial Stainless Steel Automatic Mens Watch 114060.</p>\r\n','','filtered_html'),('node','product',0,69,69,'und',0,'<p><strong>SUUNTO VECTOR - THE MOUNTAIN WATCH</strong> after a decade of travels, adventures and courageous expeditions,&nbsp;Suunto Vector is still the most legendary watch with an altimeter,&nbsp;barometer and compass. With the technology and durability that&nbsp;can take on the harshest of environments, it is the choice&nbsp;of professionals.</p>\r\n','','filtered_html'),('node','product',0,70,70,'und',0,'<p><strong>General</strong></p>\r\n\r\n<ul>\r\n	<li>Brand: SKMEI</li>\r\n	<li>Model: 955</li>\r\n	<li>Quantity: 1Piece</li>\r\n	<li>Color: Black + Green</li>\r\n	<li>Casing Material: ABS+PU</li>\r\n	<li>Wristband Material: Rubber</li>\r\n	<li>Suitable for: Adults</li>\r\n	<li>Gender: Men</li>\r\n</ul>\r\n\r\n<p>&nbsp;</p>\r\n\r\n<p><strong>Specification</strong></p>\r\n\r\n<ul>\r\n	<li>Style: Wrist Watch</li>\r\n	<li>Type: Sports watches</li>\r\n	<li>Display: Analog + Digital</li>\r\n	<li>Backlight: Blue</li>\r\n	<li>Movement: Digital + Quartz</li>\r\n	<li>Display Format: 12/24 hour time format</li>\r\n	<li>Water Resistant: 30m Water Resistant</li>\r\n</ul>\r\n\r\n<p>&nbsp;</p>\r\n','','filtered_html'),('node','product',0,71,71,'und',0,'<p>Looking for the best LED TV in town? Well look no further, the Samsung 40\" Full HD LED TV Series 5 is here. It has an outstanding picture with deep black levels, precise color and great bright-room viewing qualities. Its styling is drop-dead gorgeous, and the slim sophisticated design lends a unique, ultramodern look. A great all rounder that fits perfectly on any wall. A thing of a beauty.</p>\r\n\r\n<p><strong>Discover a new reality in Full HD</strong><br />\r\nEnjoy a greater level of home entertainment realism than ever before. Thanks to a resolution twice as high as standard HD TVs, your Samsung FHD TV delivers a breathtaking viewing experience that takes you beyond the screen into a world of total immersion. When you’ve seen the rich and vivid texture of Full HD images, your favourite TV programs and movies will never be the same again. Discover reality with a full high definition experience.</p>\r\n\r\n<p><strong>All the excitement of the big match with Soccer Mode</strong><br />\r\nWith Soccer Mode, it’s like you’re actually at the match. It sharply and vividly brings out the green grass of the pitch and all the other colours of the stadium. A powerful multi-surround sound effect also lets you hear all of the excitement. You can even zoom in to selected areas of the screen for a better view. With just a push of a button you can make the most of your favourite sport with all your friends.</p>\r\n\r\n<p><strong>More vibrant colours for better images</strong><br />\r\nUsing an advanced picture quality improvement algorithm, Samsung’s Wide Colour Enhancer Plus drastically improves the quality of any image and uncovers hidden details. Now see colours as they were meant to be seen with Wide Colour Enhancer Plus.</p>\r\n\r\n<p><strong>Watch movies from your USB</strong><br />\r\nWith ConnectShare Movie, simply plug your USB memory drive or HDD into the TV and instantaneously enjoy movies, photos or music. Now, you can experience a wide variety of content in the comfort of your living room on your TV.</p>\r\n','','filtered_html'),('node','product',0,72,72,'und',0,'<p>For a clearer, sharper, and overall better performing full HD LED TV, the Sony 48\" Full HD LED Smart TV is the one and only choice to which will suit your preference.</p>\r\n\r\n<p><strong>High Resolution Display</strong><br />\r\nThe Sony 48” Full HD LED Smart TV comes with a Clear Resolution Enhancer, which has a superior noise reduction feature while maintaining clear, crisp moving images and natural pictures. With such and in-depth approach to realism and its eye to detail, Sony proves that you can bring lifelike picture quality into the TV.</p>\r\n\r\n<p><strong>New Generation of DVB</strong><br />\r\nThanks to the DVB-T2 (Digital Broadcasting Standard) installed into the Sony 48” Full HD LED Smart TV, you can now experience even better picture and sound quality compared to the standard DVB. It even grants greater flexibility and robustness when accessing HD programmes.</p>\r\n','','filtered_html'),('node','product',0,73,73,'und',0,'<p>Whether you enjoy movies, or sports, or listening to song on a grand scale, this superb home solution by Sony is definitely worth your attention. This Blu-Ray Home Theater system by Sony will take you away from your living room. Its 9.1 channel will stream high definition audio from all angles, including from the top. It will also mute the commentators as you watch your favorites teams play, making you feels as though you’re in the stadium yourself. The Sony BDV-N9200W is here to impress.</p>\r\n\r\n<p><strong>Sony audio&nbsp;</strong><br />\r\nThis Sony BDV-N9200W system will resonate high definition audio that will cater to your listening preference, taking your senses to greater levels.</p>\r\n\r\n<p>Compared to previous CD-quality, this superior solution provides subtle details that were once hidden away. Listen to greater detail and appreciate music in its purest form.&nbsp;</p>\r\n','','filtered_html'),('node','product',0,74,74,'und',0,'<p>Do you feel unsatisfied with the current audio in your house when you’re watching your favourite fighting scene in an action movie? You want to feel like you are in the movie itself, feeling the adrenaline rushing through your body, your heart thumping like mad when you turn on the volume high, ready to indulge in the fighting scene? So here’s the solution! It will be made possible with this home theatre set from Samsung.</p>\r\n\r\n<p><strong>Powerful Audio </strong><br />\r\nMake the most of your home entertainment with this DVD Home Theater System which offers a full range of sound and visual quality. A built-in front-firing subwoofer at the bottom of the speaker delivers rich and deep low-end tones to ensure TV programmes, music and movies are vivid and immersive. Unlike comparable products, you won’t have to buy costly additional equipment for powerful audio.</p>\r\n\r\n<p><strong>Sing Your Heart Out </strong><br />\r\nYour Samsung Home Entertainment System has all you need to enjoy cinematic sound and magnificent music in the comfort of your living room as this model comes with karaoke scoring, mic plus music usb record with cd disc, mic jack, mic volume, fanfare and my karaoke.</p>\r\n','','filtered_html'),('node','product',0,75,75,'und',0,'<p>Many people have their phones in their hand bags and don\'t feel the vibration or even hear their ring tone in busy areas. With this awesome bracelet you can have a wearable fashion accessory and never miss a call again. Caller ID and LED Time Display This beautiful bracelet also displays the caller ID, so you can see the phone number of the person calling, instead of having to struggle opening your bag in a busy area, you can instantly tell if the call is important or not. Another great feature of this bracelet is that it features a time display.Unlike most wireless techniques, bluetooth uses time division duplex to arrange the transmission slots so that it can avoid collision.The top-rated 250mAh battery enables you run into the bracelet for 168 hours constantly.It is also the best gift for your family and friends.</p>\r\n','','filtered_html'),('node','product',0,76,76,'und',0,'<p><strong>Big-time entertainment. One small box.</strong><br />\r\nApple TV gives you access to the best content — blockbuster movies, sports, your music and photos, and more — right on your HDTV.1 You can even play content from your iOS devices on your TV wirelessly using AirPlay.</p>\r\n\r\n<p><strong>Quick and easy setup.</strong><br />\r\nJust plug in the power cord and connect Apple TV to your HDTV with a single HDMI cable (sold separately). If you have an iPhone or iPad, hold it near Apple TV, and Apple TV will learn about your home network and receive your iTunes account settings automatically.</p>\r\n\r\n<p><strong>AirPlay.</strong><br />\r\nAirPlay lets you wirelessly stream what’s on your Mac or iOS device to your HDTV and speakers via Apple TV. Or mirror exactly what’s on your device\'s display to the big screen.</p>\r\n\r\n<p><strong>iCloud.</strong><br />\r\nWith iCloud, you can buy movies on Apple TV and watch them on your iPad, iPhone, iPod touch, Mac, or PC. And vice versa. iCloud also stores your photos and videos, pushing them wirelessly to all your devices — including your HDTV.</p>\r\n\r\n<p><strong>Your photos and videos.</strong><br />\r\nWith My Photo Stream, your most recent photos and videos automatically appear on your Apple TV. And thanks to iMovie Theater, the projects you’ve made in iMovie are ready for viewing on the big screen.</p>\r\n\r\n<p><strong>YouTube, Vimeo, MLB and more.</strong><br />\r\nWatch hit movies, live sports, breaking news, the latest viral videos, and more from some of the biggest names in entertainment.</p>\r\n','','filtered_html'),('node','product',0,77,77,'und',0,'<p><strong>Very compact in size that can fit any places.</strong></p>\r\n\r\n<p><strong>Features &amp; Design</strong><br />\r\nAvailable with Windows 8 - for a smooth, versatile PC experience.Get the Windows 8.1 update:</p>\r\n\r\n<p>Increase productivity with a free update from the Windows Store for great new apps and features.</p>\r\n\r\n<p><strong>Virtual design for virtually any space </strong><br />\r\nEasily bring high performance PC gaming into any room in your house. Whether you’re connected to a monitor or an HDTV, the versatile Alienware X51 lets you experience big-screen gaming wherever you want it.</p>\r\n\r\n<p><strong>Mind-blowing visuals and sound</strong><br />\r\nGaming, movies and other images jump off the screen with the powerful NVIDIA® graphics, Full HD, 3D and Blu-ray capabilities of the Alienware X51. For those seeking a system that can handle high-performance video and audio content creation, look no further than Alienware X51.</p>\r\n','','filtered_html'),('node','product',0,78,78,'und',0,'<p>With a set of correct cables and tools, your devices could work properly and it resulting in very satisfying outcome from your devices. On the other hand, chosing correct cables and tools ensure your devices to last longer. Get it now while the stock last!</p>\r\n\r\n<p><strong>Features</strong></p>\r\n\r\n<ul>\r\n	<li>A device that is used to select a video source for the TV via the HDMI interface.</li>\r\n	<li>For example, a cable box, DVD player and DVR may all have HDMI outputs, but the TV may have only one HDMI input. In this case, a three-port HDMI switch would have three HDMI inputs for the source components and one HDMI output to the TV set. When multiple TVs are used, there are HDMI switches with two or more outputs. The switch may be operated manually, by remote control or automatically by priority.</li>\r\n</ul>\r\n\r\n<p>&nbsp;</p>\r\n','','filtered_html'),('node','product',0,79,79,'und',0,'<p>The Dell 5500 series switches are designed to offer secure, fixed-port Gigabit Ethernet switching solutions to deliver fullwire-speed switching performance. With 24 or 48 built-in copper Gigabit Ethernet ports in a 1U form factor,&nbsp;the 5500 series has a total switching capacity of up to 176 Gbps to support demanding network environments. The switches also offer simple management and scalability via a 40Gbps high-availability stacking architecture that allows you to manage up to eight switches from a single IP address, and share the dual SFP+ across the stack for uplinks to the next layer in your network. The switches are designed for Energy Efficient Ethernet (802.3az), which will reduce per port power consumption up to 50% if the link is idle, and further reduction if ports are inactive.</p>\r\n\r\n<p><strong>Specifications :&nbsp;</strong><br>\r\n\r\n<ul>\r\n	<li>1xPower Cord, 2m, 220V IRE/UK (Malaysia, Singapore, Brunei)</li>\r\n	<li>Lifetime Limited Dell Standard Technical Support</li>\r\n	<li>Lifetime Limited Hardware Warranty</li>\r\n	<li>Layer 2 Managed Gigabit Switches</li>\r\n	<li>Campus-Focused Gigabit Ethernet switch delivering Layer 2</li>\r\n	<li>Available with 24/48 standard Gigabit Ethernet ports or 24/48 Power over Ethernet (PoE) Gigabit Ethernet ports</li>\r\n	<li>Campus stacking capability to simplify deployment and management</li>\r\n	<li>Voice Capability</li>\r\n	<li>MS NAP Certified</li>\r\n</ul>\r\n</p>\r\n','','filtered_html'),('node','product',0,80,80,'und',0,'<p>In this day and age, connection to the Internet is one of the necessities of living in the digital age. With the TP-Link M5250 3G Mobile WiFi, you will always be connected to the Internet no matter where you are – perfect for those always on the move.</p>\r\n\r\n<p><strong>3G Coverage</strong><br />\r\nTP-LINK’s M5250 is at the forefront of wireless 3G sharing, combining the mobility of 3G broadband connections with the flexibility of 802.11n WiFi - No other bulky devices required, simply insert a 3G SIM card to create a 3G Wi-Fi hotspot to share on the move, wherever 3G coverage is available.</p>\r\n\r\n<p><strong>Long Lasting Battery</strong><br />\r\nBattery power is incredibly important especially for a portable mobile device like the M5250. With a 2000mAh battery, the M5250 is capable of operating from 7-10 hours depending on the usage. Even under heavy usage, the device can last up to 6-7 hours tops. Alternatively, you can charge the device via micro USB cable to a laptop or portable charger for endless 3G sharing.</p>\r\n\r\n<p><strong>Lightweight &amp; Portable</strong><br />\r\nThe portable ‘cobblestone’ design of the M5250 makes it very easy to take it along with you to wherever you go. The lightweight yet durable material enables it to withstand light resistance do damage less hassle when travelling.</p>\r\n','','filtered_html'),('node','product',0,81,81,'und',0,'<p><strong>TP-LINK’s TL-WDR4300</strong> is a performance-optimised dual band wireless router that combines the blazing fast speeds of 450Mbps using the crystal clear 5GHz band and 300Mbps using the traditional 2.4GHz band. With five Gigabit ports and 800Mbps+ hardware NAT, your wired devices will have lightning-fast, lag-free connections. Also, 2 USB 2.0 ports capable of sharing flash storage, printers, ftp servers and media players, allowing users to enjoy a robust home media network.</p>\r\n\r\n<p><strong>Concurrent Dual Band Wireless</strong><br />\r\nThe TL-WDR4300 broadcasts and receives both 2.4GHz and 5GHz connections simultaneously at 300Mbps and 450Mbps respective speeds. This allows users to run day-to-day applications, such as e-mail and web browsing over the 2.4GHz band at 300Mbps. At the same time, when running more bandwidth-intensive or latency-sensitive applications, such as streaming HD video or playing online games, users utilise the clearer 5GHz band at 450Mbps.</p>\r\n','','filtered_html'),('node','product',0,82,82,'und',0,'<p>High-Speed, High-Resolution scans from a stylishly slim CIS scanner. The advanced, clip-on scanner stand allows you to operate the scanner in a vertical position, so you need minimal space to scan. But regardless of where you place this sleek, stylish scanner, it looks amazing from any angle.</p>\r\n\r\n<p>Solve all your scanning needs with 5 conveniently located buttons for effortless one-touch operations anyone can use. PDF, copy, scan or email your documents conveniently and directly from the scanning device to your connected PC, streamlining workflow and boosting productivity of daily routine tasks. The last EZ button allows you to create a multi-page PDF file at the touch of a button.&nbsp;<br />\r\nThe scanner is ready to operate the instant they are connected to the PC via USB. Thanks to its energy efficiency that it only takes a single USB connection to power the scanner.</p>\r\n\r\n<p><strong>Upright scanning capability</strong><br />\r\nThe advanced, clip-on scanner stand allows you to operate the scanner in a vertical position, so you need minimal space to scan. But regardless of where you place this sleek, stylish scanner, it looks amazing from any angle.</p>\r\n','','filtered_html'),('node','product',0,83,83,'und',0,'<p><strong>Unsurpassed image quality in high resolution</strong><br />\r\nWith a high resolution of 4800dpi and&nbsp;<a href=\"http://www.epson.com.my/sites/epson_malaysia/explore_epson/innovation/ccd_technology.page\" target=\"_blank\" title=\"Matrix CCD™\">Matrix CCD™</a>, you can be assured that every intricate detail in your images will be captured and preserved. In addition, original colours and details can be accurately reproduced with 48 bit colour depth and embedded ICC profile.</p>\r\n\r\n<p><strong>Customisable one-touch operation for your convenience</strong><br />\r\nFour one-touch buttons on the control panel are pre-defined with Copy, Start, Scan-to-Email and Scan-to-PDF functions. Allocate up to 10 settings effortlessly through Epson Event Manager to suit your personal preferences. Experience customisation at a convenience and versatility like never before.</p>\r\n\r\n<p><strong>Versatility and convenience with a single software Epson Scan v3.9</strong><br />\r\nEpson Scan v3.9 facilitates rotational view of documents and additional language support in searchable PDF. The Auto Area Segmentation function also allows separate scanning of both image and text in a document.</p>\r\n','','filtered_html'),('node','product',0,84,84,'und',0,'<p>With the new EX-ZR1500, taking stunning photos and self-portraits has never been easier. Users can now easily edit their self-portraits according to their preference with the new make-up function that allows adjustment of skin smoothness to 12 levels and enhancement of skin tone according to a scale of six stages from light to tan.</p>\r\n\r\n<p><strong>Easy to see and shoot. LCD tilts to make a snap for self-portraits</strong><br />\r\nThe LCD opens up 180° so you can check your self-portraits as you shoot. It shoots from a variety of angles, letting you get just the right composition. And its built-in camera stand lets you shoot hands-free. Enjoy shooting self-portraits in all kinds of poses.</p>\r\n\r\n<p><strong>The advanced Make-up mode satisfies the pursuit of beauty</strong><br />\r\nAutomatically detects human faces and smoothes and brightens the skin. You can adjust Skin Tone and Smooth Skin to produce the beautiful finish you prefer, whether it is skin with a whitened tone, or lively, healthy skin.&nbsp;</p>\r\n\r\n<p><strong>Art Shot Bracketing lets you encounter the unexpected in one shot</strong><br />\r\nOne click of the shutter creates 5 different styles, lets you try different effects in one go, enhancing the individuality of your photos and changing ordinary shots into artistic ones. It lets you encounter the unexpected in one shot and broaden your photographic expression.&nbsp;</p>\r\n','','filtered_html'),('node','product',0,85,85,'und',0,'<h4><strong>The PowerShot SX60 HS</strong> camera employs a 16.1 Megapixel CMOS sensor. Utilizing a sophisticated light-capturing design, it provides high sensitivity for improved high ISO capture with reduced noise. It is also a high-speed design, capable of rapidly capturing and moving image data to the processor, enabling faster continuous shooting and faster autofocus.</h4>\r\n\r\n<p>The PowerShot SX60 HS camera is equipped with the very latest Canon proprietary processor, the DIGIC 6 Image Processor, which makes several important advancements to image quality both in stills and video. Improved light sensitivity allows for higher resolution with less noise when shooting in dark conditions, and Dynamic IS now detects and compensates for tilt and parallel movement (shift blur) to create video that\'s exceptionally free of distortion. The DIGIC 6 Image Processor also enhances the performance capabilities of the PowerShot SX60 HS, powering full resolution high-speed continuous stills shooting. And video recording is better than ever, as the DIGIC 6 Image Processor enables Full HD at 60p, as well as MP4 recording. Highly compressed MP4 video not only preserves space on your memory card but also improves playback on mobile devices.&nbsp;</p>\r\n','','filtered_html'),('node','product',0,86,86,'und',0,'<p>Dive into the world of photography with the Canon EOS 600D. It is the advanced entry-class DSLR with the cutting edge technology to bring out the inner desire of you. It has 18 megapixels CMOS sensor that able to capture photos with magnificent qualities. The imaging processor is DiG!C 4 for faster and better results in taking shots. The Canon EOS 600D also capable in recording stunning Full HD videos. The 3 inch LCD is adjustable with multiple angles to cope with your shooting skills.<br />\r\n&nbsp;</p>\r\n\r\n<p><strong>18.0-megapixel CMOS sensor</strong><br>\r\nThis camera comes with 18-megapixel CMOS (APS-C-sized) sensor that lets you to capture just about any scenes from vast, breath-taking landscapes to close-up wildlife shots in explicit detail. Photos of 18-megapixel resolution can easily be converted or zoomed in to gallery ready print shots.</p>\r\n\r\n<p><strong>3-inch wide LCD monitor</strong><br>\r\nRecording and playback of images are seamless with the crisp 3-inch wide Vari-Angle Clear View LCD monitor that contains over a million dots. Make full use of the specially designed hinge which can be swivelled in almost any angle to easily frame you subject and find the best angle.</p>\r\n\r\n<p><strong>Scene Intelligent Auto</strong><br>Scene Intelligent Auto is feature that gives better exposure in any picture you took, it will analyse every elements in the photos taken and then it will evaluate and eventually the photo is now seems like auto fixed.</p>\r\n','','filtered_html'),('node','banner',0,87,87,'und',0,'<p>Lorem Ipsum is not simply random text. It has roots in a piece of classical Latin literature from 45 BC, making it over 2000 years old. Richard McClinto</p>\r\n','','filtered_html'),('node','product',0,88,88,'und',0,'<p>It is now easier to capture those fleeting moments of your live wherever you are using just the right lens with Samsung Smart Camera NX Mini. This slim, ultra-portable digital camera measures just 22.5 millimeters wide and can be used with any lens in Samsung\'s NX series. A 3-inch flip-up LCD touch screen is perfect for selfies, while Wi-Fi capability lets you back up photos and videos, post them to social networks, or send them to friends and family.</p>\r\n\r\n<p><strong>Crystal Clear Resolution</strong><br />\r\nSamsung Smart Camera NX Mini comes equipped with 20.5MP BSI CMOS Sensor for high-quality images and life-like colours with crystal clear resolution to perfectly capture your most precious moments. Stylishly slim (22.5mm) and impressively light (158g), this mini camera can perfectly fit your pocket or handbag.</p>\r\n\r\n<p class=\"rtecenter\"><img alt=\"\" src=\"/marketplace/sites/default/files/products/original-samsung-smart-camera-3.png\" /></p>\r\n\r\n<p><strong>Wink Shot</strong><br />\r\nThe NX mini provides a fun and easier way to take your beloved selfies with the wink shot feature. Simply give it a wink, and it will take the shot 2 seconds later. No button necessary. Don\'t forget to smile!</p>\r\n\r\n<p><strong>Get Creative</strong><br />\r\nWhy settle for plain and boring photos when you can work your magic with different special effects available on your Samsung Smart Camera NX Mini? Take your pick from these amazing effects that seamlessly transform each snapshot into a work of art. Display your playful side with Cartoon effect or Oil Paint for days when you feel like creating gallery material masterpiece. Other special effects to choose from are Negative, Vivid, Custom Effect, Fisheye, Soft Focus, Sketch, Landscape, Portrait, Miniature, Calm Classic, Forest, Retro, cross filter, Vignetting, Ink Painting and Zooming Shot.&nbsp;</p>\r\n','','filtered_html'),('node','product',0,89,89,'und',0,'<p>This updated classic with a fast maximum aperture is ideal for everyday shooting, perfect in low lighting situations and great for producing images with beautiful background blur (Bokeh). The AF-S NIKKOR 50mm f/1.8G includes Silent Wave Motor technology (SWM) for fast and precise autofocus, M/A Focus Mode Switch for seamless changes between manual and autofocus operation and an aspherical lens element for outstanding optical performance with high contrast.</p>\r\n\r\n<p><strong>Brilliance in any Light</strong><br />\r\nThis lightweight standard lens is a great travel companion because you never know when a beautiful, sunny day will turn cloudy and rainy. With its fast f/1.8 aperture, the AF-S NIKKOR 50mm f/1.8G will capture even low-light situations with stunning brilliance.</p>\r\n\r\n<p><strong>Beautiful Background Blur</strong><br />\r\nWhether you\'re shooting portraits, food or nature—indoors or outdoors—the AF-S NIKKOR 50mm f/1.8G renders a beautiful, natural background blur (Bokeh) at its wider aperture settings. And its 50mm focal length is perfect for creating natural perspective in your photographs.</p>\r\n\r\n<p><strong>Capture Every Detail</strong><br />\r\nNikon\'s Super Integrated Coating (SIC) enhances light transmission efficiency and offers superior colour consistency and reduced flare, while the AF-S NIKKOR 50mm f/1.8G\'s Aspherical Lens Element (AS) virtually eliminates coma and other types of aberrations, even when shooting at the widest available aperture. Pair that with Nikon\'s Silent Wave Motor (SWM) for fast, accurate and quiet autofocus, and you can be sure all of your portraits will be tack sharp.</p>\r\n','','filtered_html'),('node','product',0,91,91,'und',0,'<p>Kits include a Cokin Z-Pro filter holder and three graduated filters</p>\r\n\r\n<p>GRAD ND/BLUE/ TOBACCO KIT</p>\r\n\r\n<p>filter holder / Grad Grey ND2 (121L), Grad Blue B2 Light (123L)</p>\r\n\r\n<p>Grad Tobacco T2 Light (125L) Code: U961</p>\r\n','','filtered_html'),('node','product',0,92,92,'und',0,'<p>Equipped with a high quality 1.0 lux CMOS sensor, the DCS-5222L delivers exceptional picture quality even in low-light conditions. With built-in Ethernet and Wireless N connectivity options, the DCS-5222L provides easy and flexible installation options. The motorized pan/tilt controls and 10x digital zoom allow you to monitor a large area and zoom to view fine details, and the PIR sensor detects movement in the area and can trigger recordings. The DCS-5222L can record snapshots and video to your computer, a network storage drive, or a microSD card. Camera footage can be viewed remotely through a web browser, or through a mobile device running the mydlinkﾙ app for iOS and Android. Furthermore, the camera provides a Privacy Mode option, which allows you to set a schedule to enter privacy mode, which rotates the lens backwards to protect your privacy.</p>\r\n\r\n<p><strong>Anywhere Access with mydlink</strong><br />\r\nWith the mydlink Lite app for iPhone and Android, you can quickly and easily see your camera feed from anywhere with a Wi-Fi, 3G or 4G connection. No more guessing what\'s going on at your house while you\'re away. Thanks to this app, you can monitor on-the-go... even if you don\'t have access to a computer.</p>\r\n\r\n<p><strong>Sharp Image Monitoring from</strong><br />\r\nDifferent Angles With sharp, responsive pan/tilt movement and digital zoom, the DCS-5222L gives you full control, so you can quickly scan a wide area from a variety of angles, and 10x digital zoom lets you zoom in for more detail.</p>\r\n\r\n<p><strong>HD Video Quality</strong><br />\r\nThe DCS-5222L delivers the confidence of 720P HD video clarity, ensuring rich detail and crisp image quality for your surveillance recordings. And with integrated night-vision and PIR motion-sensing technology, the DCS-5222L remains vigilant 24 hours a day, whether you\'re there or not.</p>\r\n','','filtered_html'),('node','product',0,93,93,'und',0,'<ul>\r\n	<li>1/3\' Super CMOS Dome</li>\r\n	<li>850TVL IR Dome</li>\r\n	<li>24LEDS ,Night View Up to 20M</li>\r\n	<li>High resolution</li>\r\n	<li>Plastic housing black and white</li>\r\n	<li>Lens option: 3.6mm/ 6mm</li>\r\n	<li>Auto Gain Control (AGC)</li>\r\n	<li>Built-in auto gain control (AGC) circuit.</li>\r\n	<li>Gamma Characteristic</li>\r\n	<li>Camera Gamma Characteristic is 0.45</li>\r\n	<li>Scanning Mode</li>\r\n	<li>NTSC or PAL mode</li>\r\n	<li>Night-time Vision</li>\r\n	<li>0 Lux with IR LED ON</li>\r\n</ul>\r\n','','filtered_html'),('node','product',0,94,94,'und',0,'<p><strong>What is an Ai-Ball?</strong><br />\r\nThe Ai-Ball is an ultra-portable, wireless camera module that allows users to view and record audio and video wirelessly on their PC or smartphones.</p>\r\n\r\n<p><strong>Ai-Ball Cradle</strong><br />\r\nPower your Ai-Ball now with the Ai-Ball Cradle, which runs on interchangeable USB, car, and regular AC/DC adapters for round-the-clock Ai-Balling.</p>\r\n\r\n<p><strong>Features:</strong></p>\r\n\r\n<p><strong>Round The Clock Viewing/Recording</strong><br />\r\nChoose from USB, car, or regular AC/DC power to run your Ai-Ball all day long. Just pop your Ai-Ball into the Cradle, adjust its viewing angle and you are all set for Round-the-Clock streaming and recording.</p>\r\n\r\n<p><strong>Wireless</strong><br />\r\nWith its 802.11 b/g Wi-fi interface, the Ai-Ball allows you to stream and record audio video images through your mobile devices such as your smartphones (iPhones or Android devices) and laptops on the go.</p>\r\n','','filtered_html'),('node','product',0,95,95,'und',0,'<p>As a Muslim, it is vital to start educating the children in the arts of Islamic teachings at a very young age. The Mini Quran is a great way for your kids to learn and memorize their Doas, Surahs from the Quran and Prayers.</p>\r\n\r\n<p><strong>Learn and Play</strong><br />\r\nThe Mini Quran for Kids include 16 sections of the Quran, 26 prayers, 8 classic songs, reading when worship, projection at night or dark room.</p>\r\n','','filtered_html'),('node','product',0,96,96,'und',0,'<p><strong><u>Highlights</u></strong></p>\r\n\r\n<ul>\r\n	<li>Writing tablet created to make lists, draw or jot down paperless notes</li>\r\n	<li>“Green” alternative to sticky notes, memo pads, paper and ink</li>\r\n	<li>Less than a 1/4\" thin and is easy to take with you in a purse, scheduler, briefcase or backpack</li>\r\n	<li>Ultra low power consumption; One set of batteries (2 AAAA-included) will last tens of thousands of erases</li>\r\n	<li>Includes LCD Screen cleaning cloth to safely remove smudges</li>\r\n	<li>LCD are made from durable plastic materials</li>\r\n	<li>Safe for school, work or even home use</li>\r\n	<li>Lightweight, portable and durable</li>\r\n</ul>\r\n\r\n<p>&nbsp;<strong>Specifications:</strong></p>\r\n\r\n<ul>\r\n	<li>Measurement: 27cm x 1705cm</li>\r\n	<li>LCD: 10.5 Inch</li>\r\n	<li>Powered: AAAA Battery</li>\r\n	<li>Color: Pink</li>\r\n</ul>\r\n','','filtered_html'),('node','product',0,97,97,'und',0,'<p>Chicco Transporter Carry Cot can be used to change nappies anywhere, anytime. It gives parents and newborns an extra sense of closeness and security. Keeps baby secure and in place comfortably so you can focus on changing their diapers. Convenient for mums night time feeding.</p>\r\n','','filtered_html'),('node','product',0,138,138,'und',0,'<p>The key to a gorgeous complexion is to have healthy, glowing skin. The Kinohimitsu J’pan BB Drink is an amazing, instant drink that helps restore your skin’s natural glow and clarity - not just your face but your entire body, including your back, hands and legs.</p>\r\n\r\n<p><strong>All-Natural Ingredients </strong><br />\r\nInfused with all-natural and beneficial ingredients such as hydrolysed bird’s nest, chicken cartilage (a source of hyaluronic acid) and fermented yeast (a source of co-enzyme Q10, CoQ10), Kinohimitsu J’pan BB Drink is a healthy and effective solution to nourish, hydrate and rejuvenate every single cell in your body by giving rich, healthful nutrients to promote a baby-like rosy complexion.</p>\r\n\r\n<p><strong>Unleash the Radiance Within </strong><br />\r\nFor many individuals, a bright, glowing complexion often means health and happiness but sometimes the rosy sheen on our face is just too difficult to maintain. Over time, skin looks dull and lifeless, perhaps as a result of dehydration, improper face cleansing, lack of essential vitamins, poor blood circulation, build-up of dead skin cells and environmental elements.</p>\r\n','','filtered_html'),('node','product',0,139,139,'und',0,'<p>Get the blast of the delicious&nbsp;FAT BURNER MEGA in a convenient powder format – just mix and drink!&nbsp;</p>\r\n\r\n<p>With its own unique, powerful formula that delivers an amazing experience, The FAT BURNER MEGA is the perfect solution for when you’re trying to get your sweat on in the gym or even when doing light excercise at your very own home. Featuring a potent Acai Berry dose shown to aid weight loss, FAT BURNER MEGA also features, L-carnitine and Lecithin,for an unmatched weight loss experience.</p>\r\n','','filtered_html'),('node','page',0,141,141,'und',0,'<div class=\"page-404\">\r\n<p>Page doesn\'t exist or some other error occured.</p>\r\n<a href=\"/\" title=\"Back to home\">Back to home</a>\r\n</div>\r\n','','full_html'),('node','page',0,143,143,'und',0,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur bibendum sagittis lectus, at interdum diam fermentum nec. Aliquam erat volutpat. In pharetra augue quis leo malesuada feugiat. Nam vestibulum risus quis est consequat, ac efficitur nisl efficitur. Vivamus porta, dui rutrum dictum auctor, tortor dolor aliquet velit, a dapibus sem diam sed massa. Donec id facilisis libero, quis suscipit odio. Nam sed nulla in erat vehicula malesuada volutpat vel ante. Donec sodales eros felis, ut auctor neque vestibulum sit amet. Sed lacinia pellentesque nulla, rhoncus consectetur eros porta quis.</p>\r\n\r\n<p>Maecenas feugiat mi ac urna molestie, vel hendrerit lacus tempus. Morbi egestas sem risus, et bibendum justo mattis eu. Donec sollicitudin ultricies nulla at efficitur. Donec non est vel risus ullamcorper malesuada. Vivamus id volutpat augue, in convallis tortor. Morbi eleifend volutpat ipsum non hendrerit. Vestibulum dignissim magna non justo viverra dapibus. Duis varius molestie dolor, et rhoncus dolor lobortis vel. Cras nec quam at est viverra vestibulum nec et arcu. Sed nec vehicula purus. Etiam nisl risus, scelerisque vitae commodo semper, dignissim vel arcu. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Pellentesque nibh lectus, ornare ac ultrices quis, vulputate at leo. Duis dictum metus eget metus ornare posuere.</p>\r\n\r\n<ul>\r\n	<li>Integer tincidunt hendrerit erat</li>\r\n<li>Phasellus at arcu a augue ultricies eleifend</li>\r\n<li>Sed laoreet laoreet odio vitae pretium</li>\r\n</ul>\r\n\r\n<p>In fringilla commodo elit nec placerat. Sed non placerat nibh. Vestibulum tincidunt mi risus. Proin quis pharetra eros. Cras a libero nibh. Curabitur libero mauris, sodales sit amet diam in, ultrices egestas lectus. Nullam id tortor in lorem dictum tristique. Nulla condimentum facilisis tellus. Mauris urna magna, semper ac gravida quis, volutpat at tellus. Sed vulputate urna ac dui sodales, id eleifend turpis lacinia. Nam accumsan purus et dolor viverra laoreet.</p>\r\n\r\n<p>Proin efficitur congue tortor sit amet iaculis. Nullam porttitor in magna ut venenatis. Donec tristique ante aliquet diam consectetur, in varius eros aliquam. In sed felis a leo hendrerit iaculis. Sed aliquam mollis risus, sed convallis ipsum vulputate sit amet. Cras accumsan sodales efficitur. Praesent egestas vulputate nunc, id lacinia elit commodo nec. Pellentesque convallis viverra nunc eget pharetra. Morbi efficitur tempor vehicula. Nulla scelerisque lorem et sapien dapibus, sit amet feugiat neque dapibus. Praesent id enim mauris. Donec mollis tortor nec placerat eleifend. Suspendisse ac turpis ullamcorper, scelerisque lorem ac, facilisis ante. Phasellus vestibulum diam a nisi mattis mollis. Suspendisse hendrerit dui eu urna vestibulum scelerisque. Nunc vel metus ex.,/p&gt;</p>\r\n','','full_html');
/*!40000 ALTER TABLE `field_revision_body` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_cmp_line_item`
--

DROP TABLE IF EXISTS `field_revision_cmp_line_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_cmp_line_item` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `cmp_line_item_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `cmp_line_item_target_id` (`cmp_line_item_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 27 (cmp_line_item)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_cmp_line_item`
--

LOCK TABLES `field_revision_cmp_line_item` WRITE;
/*!40000 ALTER TABLE `field_revision_cmp_line_item` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_cmp_line_item` VALUES ('commerce_line_item','product',0,2,2,'und',0,1),('commerce_line_item','product',0,4,4,'und',0,3),('commerce_line_item','product',0,6,6,'und',0,5),('commerce_line_item','product',0,8,8,'und',0,7),('commerce_line_item','product',0,9,9,'und',0,1),('commerce_line_item','product',0,11,11,'und',0,10),('commerce_line_item','product',0,13,13,'und',0,12),('commerce_line_item','product',0,15,15,'und',0,14),('commerce_line_item','product',0,17,17,'und',0,16),('commerce_line_item','product',0,18,18,'und',0,14),('commerce_line_item','product',0,20,20,'und',0,19),('commerce_line_item','product',0,22,22,'und',0,21),('commerce_line_item','product',0,24,24,'und',0,23),('commerce_line_item','product',0,26,26,'und',0,25),('commerce_line_item','product',0,28,28,'und',0,27),('commerce_line_item','product',0,29,29,'und',0,27),('commerce_line_item','product',0,31,31,'und',0,30),('commerce_line_item','product',0,33,33,'und',0,32),('commerce_line_item','product',0,35,35,'und',0,34),('commerce_line_item','product',0,37,37,'und',0,36),('commerce_line_item','product',0,39,39,'und',0,38),('commerce_line_item','product',0,41,41,'und',0,40),('commerce_line_item','product',0,42,42,'und',0,40),('commerce_line_item','product',0,43,43,'und',0,40),('commerce_line_item','product',0,44,44,'und',0,40),('commerce_line_item','product',0,46,46,'und',0,45),('commerce_line_item','product',0,48,48,'und',0,47),('commerce_line_item','product',0,50,50,'und',0,49),('commerce_line_item','product',0,52,52,'und',0,51),('commerce_line_item','product',0,54,54,'und',0,53),('commerce_line_item','product',0,56,56,'und',0,55),('commerce_line_item','product',0,58,58,'und',0,57),('commerce_line_item','product',0,60,60,'und',0,59),('commerce_line_item','product',0,62,62,'und',0,61),('commerce_line_item','product',0,64,64,'und',0,63),('commerce_line_item','product',0,65,65,'und',0,63),('commerce_line_item','product',0,67,67,'und',0,66),('commerce_line_item','product',0,69,69,'und',0,68),('commerce_line_item','product',0,71,71,'und',0,70),('commerce_line_item','product',0,73,73,'und',0,72),('commerce_line_item','product',0,76,76,'und',0,75),('commerce_line_item','product',0,78,78,'und',0,77),('commerce_line_item','product',0,80,80,'und',0,79);
/*!40000 ALTER TABLE `field_revision_cmp_line_item` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_cmp_m_store`
--

DROP TABLE IF EXISTS `field_revision_cmp_m_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_cmp_m_store` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `cmp_m_store_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `cmp_m_store_target_id` (`cmp_m_store_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 23 (cmp_m_store)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_cmp_m_store`
--

LOCK TABLES `field_revision_cmp_m_store` WRITE;
/*!40000 ALTER TABLE `field_revision_cmp_m_store` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_cmp_m_store` VALUES ('commerce_store','store',0,2,2,'und',0,1),('commerce_store','store',0,3,3,'und',0,16);
/*!40000 ALTER TABLE `field_revision_cmp_m_store` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_cmp_o_store`
--

DROP TABLE IF EXISTS `field_revision_cmp_o_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_cmp_o_store` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `cmp_o_store_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `cmp_o_store_target_id` (`cmp_o_store_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 25 (cmp_o_store)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_cmp_o_store`
--

LOCK TABLES `field_revision_cmp_o_store` WRITE;
/*!40000 ALTER TABLE `field_revision_cmp_o_store` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_cmp_o_store` VALUES ('commerce_order','commerce_store_order',0,17,17,'und',0,1),('commerce_order','commerce_store_order',0,18,18,'und',0,1),('commerce_order','commerce_store_order',0,21,21,'und',0,2),('commerce_order','commerce_store_order',0,23,23,'und',0,1),('commerce_order','commerce_store_order',0,24,24,'und',0,1),('commerce_order','commerce_store_order',0,26,26,'und',0,1),('commerce_order','commerce_store_order',0,29,29,'und',0,2),('commerce_order','commerce_store_order',0,31,31,'und',0,1),('commerce_order','commerce_store_order',0,32,32,'und',0,1),('commerce_order','commerce_store_order',0,35,35,'und',0,2),('commerce_order','commerce_store_order',0,37,37,'und',0,2),('commerce_order','commerce_store_order',0,38,38,'und',0,1),('commerce_order','commerce_store_order',0,44,44,'und',0,1),('commerce_order','commerce_store_order',0,64,64,'und',0,1),('commerce_order','commerce_store_order',0,74,74,'und',0,1),('commerce_order','commerce_store_order',0,77,78,'und',0,1),('commerce_order','commerce_store_order',0,84,86,'und',0,1),('commerce_order','commerce_store_order',0,93,99,'und',0,2),('commerce_order','commerce_store_order',0,111,117,'und',0,2),('commerce_order','commerce_store_order',0,116,122,'und',0,2),('commerce_order','commerce_store_order',0,118,124,'und',0,2),('commerce_order','commerce_store_order',0,122,128,'und',0,2),('commerce_order','commerce_store_order',0,123,129,'und',0,2),('commerce_order','commerce_store_order',0,125,131,'und',0,2),('commerce_order','commerce_store_order',0,139,145,'und',0,1),('commerce_order','commerce_store_order',0,141,152,'und',0,2),('commerce_order','commerce_store_order',0,142,154,'und',0,1),('commerce_order','commerce_store_order',0,147,170,'und',0,2),('commerce_order','commerce_store_order',0,169,193,'und',0,2),('commerce_order','commerce_store_order',0,190,215,'und',0,3),('commerce_order','commerce_store_order',0,202,229,'und',0,3),('commerce_order','commerce_store_order',0,230,260,'und',0,2),('commerce_order','commerce_store_order',0,231,261,'und',0,3),('commerce_order','commerce_store_order',0,251,281,'und',0,2);
/*!40000 ALTER TABLE `field_revision_cmp_o_store` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_cmp_order`
--

DROP TABLE IF EXISTS `field_revision_cmp_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_cmp_order` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `cmp_order_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `cmp_order_target_id` (`cmp_order_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 26 (cmp_order)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_cmp_order`
--

LOCK TABLES `field_revision_cmp_order` WRITE;
/*!40000 ALTER TABLE `field_revision_cmp_order` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_cmp_order` VALUES ('commerce_order','commerce_store_order',0,17,17,'und',0,4),('commerce_order','commerce_store_order',0,18,18,'und',0,16),('commerce_order','commerce_store_order',0,21,21,'und',0,19),('commerce_order','commerce_store_order',0,23,23,'und',0,22),('commerce_order','commerce_store_order',0,24,24,'und',0,13),('commerce_order','commerce_store_order',0,26,26,'und',0,25),('commerce_order','commerce_store_order',0,29,29,'und',0,28),('commerce_order','commerce_store_order',0,31,31,'und',0,30),('commerce_order','commerce_store_order',0,32,32,'und',0,28),('commerce_order','commerce_store_order',0,35,35,'und',0,34),('commerce_order','commerce_store_order',0,37,37,'und',0,36),('commerce_order','commerce_store_order',0,38,38,'und',0,36),('commerce_order','commerce_store_order',0,44,44,'und',0,39),('commerce_order','commerce_store_order',0,64,64,'und',0,63),('commerce_order','commerce_store_order',0,74,74,'und',0,73),('commerce_order','commerce_store_order',0,77,78,'und',0,76),('commerce_order','commerce_store_order',0,84,86,'und',0,83),('commerce_order','commerce_store_order',0,93,99,'und',0,92),('commerce_order','commerce_store_order',0,111,117,'und',0,109),('commerce_order','commerce_store_order',0,116,122,'und',0,115),('commerce_order','commerce_store_order',0,118,124,'und',0,117),('commerce_order','commerce_store_order',0,122,128,'und',0,121),('commerce_order','commerce_store_order',0,123,129,'und',0,120),('commerce_order','commerce_store_order',0,125,131,'und',0,124),('commerce_order','commerce_store_order',0,139,145,'und',0,138),('commerce_order','commerce_store_order',0,141,152,'und',0,140),('commerce_order','commerce_store_order',0,142,154,'und',0,140),('commerce_order','commerce_store_order',0,147,170,'und',0,146),('commerce_order','commerce_store_order',0,169,193,'und',0,167),('commerce_order','commerce_store_order',0,190,215,'und',0,189),('commerce_order','commerce_store_order',0,202,229,'und',0,201),('commerce_order','commerce_store_order',0,230,260,'und',0,226),('commerce_order','commerce_store_order',0,231,261,'und',0,226),('commerce_order','commerce_store_order',0,251,281,'und',0,250);
/*!40000 ALTER TABLE `field_revision_cmp_order` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_cmp_store`
--

DROP TABLE IF EXISTS `field_revision_cmp_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_cmp_store` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `cmp_store_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `cmp_store_target_id` (`cmp_store_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 22 (cmp_store)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_cmp_store`
--

LOCK TABLES `field_revision_cmp_store` WRITE;
/*!40000 ALTER TABLE `field_revision_cmp_store` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_cmp_store` VALUES ('commerce_product','product',0,4,4,'und',0,2),('commerce_product','product',0,4,15,'und',0,2),('commerce_product','product',0,6,6,'und',0,1),('commerce_product','product',0,6,9,'und',0,1),('commerce_product','product',0,6,83,'und',0,1),('commerce_product','product',0,7,7,'und',0,1),('commerce_product','product',0,7,10,'und',0,3),('commerce_product','product',0,8,8,'und',0,2),('commerce_product','product',0,8,11,'und',0,2),('commerce_product','product',0,9,16,'und',0,2),('commerce_product','product',0,9,78,'und',0,2),('commerce_product','product',0,9,79,'und',0,2),('commerce_product','product',0,9,84,'und',0,3),('commerce_product','product',0,10,17,'und',0,2),('commerce_product','product',0,10,80,'und',0,2),('commerce_product','product',0,10,85,'und',0,2),('commerce_product','product',0,10,86,'und',0,3),('commerce_product','product',0,11,18,'und',0,3),('commerce_product','product',0,11,125,'und',0,3),('commerce_product','product',0,12,19,'und',0,3),('commerce_product','product',0,13,20,'und',0,2),('commerce_product','product',0,14,21,'und',0,3),('commerce_product','product',0,15,22,'und',0,3),('commerce_product','product',0,16,23,'und',0,3),('commerce_product','product',0,17,24,'und',0,3),('commerce_product','product',0,18,25,'und',0,2),('commerce_product','product',0,19,26,'und',0,2),('commerce_product','product',0,19,96,'und',0,2),('commerce_product','product',0,20,27,'und',0,2),('commerce_product','product',0,21,28,'und',0,2),('commerce_product','product',0,21,118,'und',0,2),('commerce_product','product',0,22,29,'und',0,2),('commerce_product','product',0,22,97,'und',0,2),('commerce_product','product',0,23,30,'und',0,2),('commerce_product','product',0,23,98,'und',0,2),('commerce_product','product',0,24,31,'und',0,2),('commerce_product','product',0,24,99,'und',0,2),('commerce_product','product',0,25,32,'und',0,2),('commerce_product','product',0,25,100,'und',0,2),('commerce_product','product',0,26,33,'und',0,2),('commerce_product','product',0,26,92,'und',0,2),('commerce_product','product',0,27,34,'und',0,2),('commerce_product','product',0,27,101,'und',0,2),('commerce_product','product',0,28,35,'und',0,2),('commerce_product','product',0,29,36,'und',0,2),('commerce_product','product',0,30,37,'und',0,2),('commerce_product','product',0,30,102,'und',0,2),('commerce_product','product',0,31,38,'und',0,2),('commerce_product','product',0,31,91,'und',0,2),('commerce_product','product',0,32,39,'und',0,2),('commerce_product','product',0,32,90,'und',0,2),('commerce_product','product',0,33,40,'und',0,2),('commerce_product','product',0,33,103,'und',0,2),('commerce_product','product',0,34,41,'und',0,2),('commerce_product','product',0,35,42,'und',0,2),('commerce_product','product',0,36,43,'und',0,2),('commerce_product','product',0,36,104,'und',0,2),('commerce_product','product',0,37,44,'und',0,2),('commerce_product','product',0,38,45,'und',0,2),('commerce_product','product',0,38,105,'und',0,2),('commerce_product','product',0,39,46,'und',0,2),('commerce_product','product',0,39,106,'und',0,2),('commerce_product','product',0,40,47,'und',0,2),('commerce_product','product',0,40,107,'und',0,2),('commerce_product','product',0,41,48,'und',0,2),('commerce_product','product',0,41,81,'und',0,2),('commerce_product','product',0,41,87,'und',0,2),('commerce_product','product',0,41,89,'und',0,2),('commerce_product','product',0,42,49,'und',0,2),('commerce_product','product',0,42,82,'und',0,2),('commerce_product','product',0,42,88,'und',0,2),('commerce_product','product',0,43,50,'und',0,2),('commerce_product','product',0,43,108,'und',0,2),('commerce_product','product',0,44,51,'und',0,2),('commerce_product','product',0,44,109,'und',0,2),('commerce_product','product',0,45,52,'und',0,2),('commerce_product','product',0,45,110,'und',0,2),('commerce_product','product',0,46,53,'und',0,2),('commerce_product','product',0,47,54,'und',0,2),('commerce_product','product',0,47,111,'und',0,2),('commerce_product','product',0,48,55,'und',0,2),('commerce_product','product',0,49,56,'und',0,2),('commerce_product','product',0,49,112,'und',0,2),('commerce_product','product',0,50,57,'und',0,2),('commerce_product','product',0,50,113,'und',0,2),('commerce_product','product',0,51,58,'und',0,2),('commerce_product','product',0,51,114,'und',0,2),('commerce_product','product',0,52,59,'und',0,2),('commerce_product','product',0,52,115,'und',0,2),('commerce_product','product',0,53,60,'und',0,2),('commerce_product','product',0,53,116,'und',0,2),('commerce_product','product',0,54,61,'und',0,2),('commerce_product','product',0,54,117,'und',0,2),('commerce_product','product',0,55,62,'und',0,2),('commerce_product','product',0,55,119,'und',0,2),('commerce_product','product',0,56,63,'und',0,2),('commerce_product','product',0,56,120,'und',0,2),('commerce_product','product',0,57,64,'und',0,2),('commerce_product','product',0,57,121,'und',0,2),('commerce_product','product',0,58,65,'und',0,2),('commerce_product','product',0,58,122,'und',0,2),('commerce_product','product',0,59,66,'und',0,2),('commerce_product','product',0,59,123,'und',0,2),('commerce_product','product',0,60,67,'und',0,2),('commerce_product','product',0,60,124,'und',0,2),('commerce_product','product',0,61,68,'und',0,3),('commerce_product','product',0,62,69,'und',0,3),('commerce_product','product',0,63,70,'und',0,2),('commerce_product','product',0,64,71,'und',0,2),('commerce_product','product',0,65,72,'und',0,3),('commerce_product','product',0,66,73,'und',0,2),('commerce_product','product',0,66,95,'und',0,2),('commerce_product','product',0,67,74,'und',0,2),('commerce_product','product',0,67,94,'und',0,2),('commerce_product','product',0,68,75,'und',0,2),('commerce_product','product',0,68,93,'und',0,2),('commerce_product','product',0,69,76,'und',0,2),('commerce_product','product',0,70,77,'und',0,2),('commerce_product','product',0,71,126,'und',0,3),('commerce_product','product',0,72,127,'und',0,3),('commerce_product','product',0,73,128,'und',0,3),('commerce_product','product',0,74,129,'und',0,3),('commerce_product','product',0,74,132,'und',0,3),('commerce_product','product',0,75,130,'und',0,3),('commerce_product','product',0,75,135,'und',0,3),('commerce_product','product',0,75,136,'und',0,3),('commerce_product','product',0,75,138,'und',0,3),('commerce_product','product',0,75,139,'und',0,3),('commerce_product','product',0,75,140,'und',0,3),('commerce_product','product',0,75,142,'und',0,3),('commerce_product','product',0,75,143,'und',0,3),('commerce_product','product',0,76,131,'und',0,3),('commerce_product','product',0,77,133,'und',0,3),('commerce_product','product',0,78,134,'und',0,3),('commerce_product','product',0,79,137,'und',0,3),('commerce_product','product',0,80,141,'und',0,3),('commerce_product','product',0,81,144,'und',0,3),('commerce_product','product',0,82,145,'und',0,3);
/*!40000 ALTER TABLE `field_revision_cmp_store` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_comment_body`
--

DROP TABLE IF EXISTS `field_revision_comment_body`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_comment_body` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `comment_body_value` longtext,
  `comment_body_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `comment_body_format` (`comment_body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 1 (comment_body)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_comment_body`
--

LOCK TABLES `field_revision_comment_body` WRITE;
/*!40000 ALTER TABLE `field_revision_comment_body` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_comment_body` VALUES ('comment','comment_node_product',0,2,2,'und',0,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit</p>\r\n','filtered_html');
/*!40000 ALTER TABLE `field_revision_comment_body` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_commerce_customer_address`
--

DROP TABLE IF EXISTS `field_revision_commerce_customer_address`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_commerce_customer_address` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_customer_address_country` varchar(2) DEFAULT '' COMMENT 'Two letter ISO country code of this address.',
  `commerce_customer_address_administrative_area` varchar(255) DEFAULT '' COMMENT 'The administrative area of this address. (i.e. State/Province)',
  `commerce_customer_address_sub_administrative_area` varchar(255) DEFAULT '' COMMENT 'The sub administrative area of this address.',
  `commerce_customer_address_locality` varchar(255) DEFAULT '' COMMENT 'The locality of this address. (i.e. City)',
  `commerce_customer_address_dependent_locality` varchar(255) DEFAULT '' COMMENT 'The dependent locality of this address.',
  `commerce_customer_address_postal_code` varchar(255) DEFAULT '' COMMENT 'The postal code of this address.',
  `commerce_customer_address_thoroughfare` varchar(255) DEFAULT '' COMMENT 'The thoroughfare of this address. (i.e. Street address)',
  `commerce_customer_address_premise` varchar(255) DEFAULT '' COMMENT 'The premise of this address. (i.e. Apartment / Suite number)',
  `commerce_customer_address_sub_premise` varchar(255) DEFAULT '' COMMENT 'The sub_premise of this address.',
  `commerce_customer_address_organisation_name` varchar(255) DEFAULT '' COMMENT 'Contents of a primary OrganisationName element in the xNL XML.',
  `commerce_customer_address_name_line` varchar(255) DEFAULT '' COMMENT 'Contents of a primary NameLine element in the xNL XML.',
  `commerce_customer_address_first_name` varchar(255) DEFAULT '' COMMENT 'Contents of the FirstName element of a primary PersonName element in the xNL XML.',
  `commerce_customer_address_last_name` varchar(255) DEFAULT '' COMMENT 'Contents of the LastName element of a primary PersonName element in the xNL XML.',
  `commerce_customer_address_data` longtext COMMENT 'Additional data for this address.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 6 (commerce_customer...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_commerce_customer_address`
--

LOCK TABLES `field_revision_commerce_customer_address` WRITE;
/*!40000 ALTER TABLE `field_revision_commerce_customer_address` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_commerce_customer_address` VALUES ('commerce_customer_profile','shipping',0,1,1,'und',0,'VN','good',NULL,'new york',NULL,'70000','us','',NULL,NULL,'jk','jk','',NULL),('commerce_customer_profile','billing',0,2,2,'und',0,'VN','good',NULL,'new york',NULL,'70000','us','',NULL,NULL,'jk','jk','',NULL),('commerce_customer_profile','shipping',0,3,3,'und',0,'VN','waiting',NULL,'nothing',NULL,'7000','nothing','',NULL,NULL,'nothing','nothing','',NULL),('commerce_customer_profile','billing',0,4,4,'und',0,'VN','waiting',NULL,'nothing',NULL,'7000','nothing','',NULL,NULL,'nothing','nothing','',NULL),('commerce_customer_profile','shipping',0,5,5,'und',0,'VN','GO VAP',NULL,'TPHCM',NULL,'70000','44/29/1 Pham Van CHieu','',NULL,NULL,'Le THong','Le','THong',NULL),('commerce_customer_profile','billing',0,6,6,'und',0,'VN','GO VAP',NULL,'TPHCM',NULL,'70000','44/29/1 Pham Van CHieu','',NULL,NULL,'Le THong','Le','THong',NULL);
/*!40000 ALTER TABLE `field_revision_commerce_customer_address` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_commerce_customer_billing`
--

DROP TABLE IF EXISTS `field_revision_commerce_customer_billing`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_commerce_customer_billing` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_customer_billing_profile_id` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `commerce_customer_billing_profile_id` (`commerce_customer_billing_profile_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 9 (commerce_customer...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_commerce_customer_billing`
--

LOCK TABLES `field_revision_commerce_customer_billing` WRITE;
/*!40000 ALTER TABLE `field_revision_commerce_customer_billing` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_commerce_customer_billing` VALUES ('commerce_order','commerce_marketplace_order',0,138,144,'und',0,2),('commerce_order','commerce_marketplace_order',0,138,146,'und',0,2),('commerce_order','commerce_marketplace_order',0,138,147,'und',0,2),('commerce_order','commerce_marketplace_order',0,138,148,'und',0,2),('commerce_order','commerce_marketplace_order',0,138,149,'und',0,2),('commerce_order','commerce_marketplace_order',0,138,150,'und',0,2),('commerce_order','commerce_store_order',0,139,145,'und',0,2),('commerce_order','commerce_marketplace_order',0,140,160,'und',0,4),('commerce_order','commerce_marketplace_order',0,140,161,'und',0,4),('commerce_order','commerce_marketplace_order',0,140,162,'und',0,4),('commerce_order','commerce_marketplace_order',0,140,163,'und',0,4),('commerce_order','commerce_marketplace_order',0,140,164,'und',0,4),('commerce_order','commerce_marketplace_order',0,140,165,'und',0,4),('commerce_order','commerce_store_order',0,141,152,'und',0,4),('commerce_order','commerce_store_order',0,142,154,'und',0,4),('commerce_order','commerce_marketplace_order',0,201,230,'und',0,6),('commerce_order','commerce_marketplace_order',0,201,231,'und',0,6),('commerce_order','commerce_marketplace_order',0,201,232,'und',0,6),('commerce_order','commerce_store_order',0,202,229,'und',0,6);
/*!40000 ALTER TABLE `field_revision_commerce_customer_billing` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_commerce_customer_shipping`
--

DROP TABLE IF EXISTS `field_revision_commerce_customer_shipping`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_commerce_customer_shipping` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_customer_shipping_profile_id` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `commerce_customer_shipping_profile_id` (`commerce_customer_shipping_profile_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 24 (commerce_customer...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_commerce_customer_shipping`
--

LOCK TABLES `field_revision_commerce_customer_shipping` WRITE;
/*!40000 ALTER TABLE `field_revision_commerce_customer_shipping` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_commerce_customer_shipping` VALUES ('commerce_order','commerce_marketplace_order',0,138,144,'und',0,1),('commerce_order','commerce_marketplace_order',0,138,146,'und',0,1),('commerce_order','commerce_marketplace_order',0,138,147,'und',0,1),('commerce_order','commerce_marketplace_order',0,138,148,'und',0,1),('commerce_order','commerce_marketplace_order',0,138,149,'und',0,1),('commerce_order','commerce_marketplace_order',0,138,150,'und',0,1),('commerce_order','commerce_store_order',0,139,145,'und',0,1),('commerce_order','commerce_marketplace_order',0,140,160,'und',0,3),('commerce_order','commerce_marketplace_order',0,140,161,'und',0,3),('commerce_order','commerce_marketplace_order',0,140,162,'und',0,3),('commerce_order','commerce_marketplace_order',0,140,163,'und',0,3),('commerce_order','commerce_marketplace_order',0,140,164,'und',0,3),('commerce_order','commerce_marketplace_order',0,140,165,'und',0,3),('commerce_order','commerce_store_order',0,141,152,'und',0,3),('commerce_order','commerce_store_order',0,142,154,'und',0,3),('commerce_order','commerce_marketplace_order',0,201,230,'und',0,5),('commerce_order','commerce_marketplace_order',0,201,231,'und',0,5),('commerce_order','commerce_marketplace_order',0,201,232,'und',0,5),('commerce_order','commerce_store_order',0,202,229,'und',0,5);
/*!40000 ALTER TABLE `field_revision_commerce_customer_shipping` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_commerce_display_path`
--

DROP TABLE IF EXISTS `field_revision_commerce_display_path`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_commerce_display_path` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_display_path_value` varchar(255) DEFAULT NULL,
  `commerce_display_path_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `commerce_display_path_format` (`commerce_display_path_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 13 (commerce_display...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_commerce_display_path`
--

LOCK TABLES `field_revision_commerce_display_path` WRITE;
/*!40000 ALTER TABLE `field_revision_commerce_display_path` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_commerce_display_path` VALUES ('commerce_line_item','product',0,1,1,'und',0,'node/9',NULL),('commerce_line_item','product',0,2,2,'und',0,'node/9',NULL),('commerce_line_item','product',0,3,3,'und',0,'node/9',NULL),('commerce_line_item','product',0,4,4,'und',0,'node/9',NULL),('commerce_line_item','product',0,5,5,'und',0,'node/4',NULL),('commerce_line_item','product',0,6,6,'und',0,'node/4',NULL),('commerce_line_item','product',0,7,7,'und',0,'node/9',NULL),('commerce_line_item','product',0,8,8,'und',0,'node/9',NULL),('commerce_line_item','product',0,9,9,'und',0,'node/9',NULL),('commerce_line_item','product',0,10,10,'und',0,'node/9',NULL),('commerce_line_item','product',0,11,11,'und',0,'node/9',NULL),('commerce_line_item','product',0,12,12,'und',0,'node/10',NULL),('commerce_line_item','product',0,13,13,'und',0,'node/10',NULL),('commerce_line_item','product',0,14,14,'und',0,'node/9',NULL),('commerce_line_item','product',0,15,15,'und',0,'node/9',NULL),('commerce_line_item','product',0,16,16,'und',0,'node/10',NULL),('commerce_line_item','product',0,17,17,'und',0,'node/10',NULL),('commerce_line_item','product',0,18,18,'und',0,'node/9',NULL),('commerce_line_item','product',0,20,20,'und',0,'node/5',NULL),('commerce_line_item','product',0,21,21,'und',0,'node/9',NULL),('commerce_line_item','product',0,22,22,'und',0,'node/9',NULL),('commerce_line_item','product',0,23,23,'und',0,'node/9',NULL),('commerce_line_item','product',0,24,24,'und',0,'node/9',NULL),('commerce_line_item','product',0,25,25,'und',0,'node/5',NULL),('commerce_line_item','product',0,26,26,'und',0,'node/5',NULL),('commerce_line_item','product',0,27,27,'und',0,'node/5',NULL),('commerce_line_item','product',0,28,28,'und',0,'node/5',NULL),('commerce_line_item','product',0,29,29,'und',0,'node/5',NULL),('commerce_line_item','product',0,30,30,'und',0,'node/9',NULL),('commerce_line_item','product',0,31,31,'und',0,'node/9',NULL),('commerce_line_item','product',0,32,32,'und',0,'node/10',NULL),('commerce_line_item','product',0,33,33,'und',0,'node/10',NULL),('commerce_line_item','product',0,35,35,'und',0,'node/9',NULL),('commerce_line_item','product',0,36,36,'und',0,'node/9',NULL),('commerce_line_item','product',0,37,37,'und',0,'node/9',NULL),('commerce_line_item','product',0,38,38,'und',0,'node/9',NULL),('commerce_line_item','product',0,39,39,'und',0,'node/9',NULL),('commerce_line_item','product',0,40,40,'und',0,'node/9',NULL),('commerce_line_item','product',0,41,41,'und',0,'node/9',NULL),('commerce_line_item','product',0,42,42,'und',0,'node/9',NULL),('commerce_line_item','product',0,43,43,'und',0,'node/9',NULL),('commerce_line_item','product',0,44,44,'und',0,'node/9',NULL),('commerce_line_item','product',0,45,45,'und',0,'node/30',NULL),('commerce_line_item','product',0,46,46,'und',0,'node/30',NULL),('commerce_line_item','product',0,47,47,'und',0,'node/52',NULL),('commerce_line_item','product',0,48,48,'und',0,'node/52',NULL),('commerce_line_item','product',0,49,49,'und',0,'node/45',NULL),('commerce_line_item','product',0,50,50,'und',0,'node/45',NULL),('commerce_line_item','product',0,52,52,'und',0,'node/45',NULL),('commerce_line_item','product',0,53,53,'und',0,'node/76',NULL),('commerce_line_item','product',0,54,54,'und',0,'node/76',NULL),('commerce_line_item','product',0,55,55,'und',0,'node/45',NULL),('commerce_line_item','product',0,56,56,'und',0,'node/45',NULL),('commerce_line_item','product',0,57,57,'und',0,'node/46',NULL),('commerce_line_item','product',0,58,58,'und',0,'node/46',NULL),('commerce_line_item','product',0,59,59,'und',0,'node/9',NULL),('commerce_line_item','product',0,60,60,'und',0,'node/9',NULL),('commerce_line_item','product',0,62,62,'und',0,'node/76',NULL),('commerce_line_item','product',0,63,63,'und',0,'node/10',NULL),('commerce_line_item','product',0,64,64,'und',0,'node/10',NULL),('commerce_line_item','product',0,65,65,'und',0,'node/10',NULL),('commerce_line_item','product',0,66,66,'und',0,'node/76',NULL),('commerce_line_item','product',0,67,67,'und',0,'node/76',NULL),('commerce_line_item','product',0,68,68,'und',0,'node/45',NULL),('commerce_line_item','product',0,69,69,'und',0,'node/45',NULL),('commerce_line_item','product',0,70,70,'und',0,'node/97',NULL),('commerce_line_item','product',0,71,71,'und',0,'node/97',NULL),('commerce_line_item','product',0,72,72,'und',0,'node/139',NULL),('commerce_line_item','product',0,73,73,'und',0,'node/139',NULL),('commerce_line_item','product',0,75,75,'und',0,'node/45',NULL),('commerce_line_item','product',0,76,76,'und',0,'node/45',NULL),('commerce_line_item','product',0,77,77,'und',0,'node/90',NULL),('commerce_line_item','product',0,78,78,'und',0,'node/90',NULL),('commerce_line_item','product',0,79,79,'und',0,'node/45',NULL),('commerce_line_item','product',0,80,80,'und',0,'node/45',NULL);
/*!40000 ALTER TABLE `field_revision_commerce_display_path` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_commerce_line_items`
--

DROP TABLE IF EXISTS `field_revision_commerce_line_items`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_commerce_line_items` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_line_items_line_item_id` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `commerce_line_items_line_item_id` (`commerce_line_items_line_item_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 7 (commerce_line_items)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_commerce_line_items`
--

LOCK TABLES `field_revision_commerce_line_items` WRITE;
/*!40000 ALTER TABLE `field_revision_commerce_line_items` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_commerce_line_items` VALUES ('commerce_order','commerce_marketplace_order',0,4,4,'und',0,1),('commerce_order','commerce_marketplace_order',0,13,13,'und',0,10),('commerce_order','commerce_marketplace_order',0,13,13,'und',1,12),('commerce_order','commerce_marketplace_order',0,16,16,'und',0,3),('commerce_order','commerce_store_order',0,17,17,'und',0,2),('commerce_order','commerce_store_order',0,17,17,'und',1,9),('commerce_order','commerce_store_order',0,18,18,'und',0,4),('commerce_order','commerce_marketplace_order',0,19,19,'und',0,5),('commerce_order','commerce_store_order',0,21,21,'und',0,6),('commerce_order','commerce_marketplace_order',0,22,22,'und',0,7),('commerce_order','commerce_store_order',0,23,23,'und',0,8),('commerce_order','commerce_store_order',0,24,24,'und',0,11),('commerce_order','commerce_store_order',0,24,24,'und',1,13),('commerce_order','commerce_marketplace_order',0,25,25,'und',0,14),('commerce_order','commerce_marketplace_order',0,25,25,'und',1,16),('commerce_order','commerce_store_order',0,26,26,'und',0,15),('commerce_order','commerce_store_order',0,26,26,'und',1,17),('commerce_order','commerce_store_order',0,26,26,'und',2,18),('commerce_order','commerce_marketplace_order',0,28,28,'und',0,23),('commerce_order','commerce_marketplace_order',0,30,30,'und',0,21),('commerce_order','commerce_store_order',0,31,31,'und',0,22),('commerce_order','commerce_store_order',0,32,32,'und',0,24),('commerce_order','commerce_marketplace_order',0,34,34,'und',0,25),('commerce_order','commerce_store_order',0,35,35,'und',0,26),('commerce_order','commerce_marketplace_order',0,36,36,'und',0,27),('commerce_order','commerce_marketplace_order',0,36,36,'und',1,30),('commerce_order','commerce_store_order',0,37,37,'und',0,28),('commerce_order','commerce_store_order',0,37,37,'und',1,29),('commerce_order','commerce_store_order',0,38,38,'und',0,31),('commerce_order','commerce_marketplace_order',0,39,39,'und',0,32),('commerce_order','commerce_store_order',0,44,44,'und',0,33),('commerce_order','commerce_marketplace_order',0,73,73,'und',0,36),('commerce_order','commerce_marketplace_order',0,73,75,'und',0,36),('commerce_order','commerce_store_order',0,74,74,'und',0,37),('commerce_order','commerce_marketplace_order',0,76,77,'und',0,38),('commerce_order','commerce_marketplace_order',0,76,79,'und',0,38),('commerce_order','commerce_store_order',0,77,78,'und',0,39),('commerce_order','commerce_marketplace_order',0,83,85,'und',0,40),('commerce_order','commerce_marketplace_order',0,83,87,'und',0,40),('commerce_order','commerce_marketplace_order',0,83,88,'und',0,40),('commerce_order','commerce_marketplace_order',0,83,89,'und',0,40),('commerce_order','commerce_marketplace_order',0,83,90,'und',0,40),('commerce_order','commerce_store_order',0,84,86,'und',0,41),('commerce_order','commerce_store_order',0,84,86,'und',1,42),('commerce_order','commerce_store_order',0,84,86,'und',2,43),('commerce_order','commerce_store_order',0,84,86,'und',3,44),('commerce_order','commerce_marketplace_order',0,92,98,'und',0,45),('commerce_order','commerce_store_order',0,93,99,'und',0,46),('commerce_order','commerce_marketplace_order',0,109,115,'und',0,47),('commerce_order','commerce_store_order',0,111,117,'und',0,48),('commerce_order','commerce_marketplace_order',0,115,121,'und',0,49),('commerce_order','commerce_store_order',0,116,122,'und',0,50),('commerce_order','commerce_marketplace_order',0,120,126,'und',0,55),('commerce_order','commerce_marketplace_order',0,121,127,'und',0,53),('commerce_order','commerce_store_order',0,122,128,'und',0,54),('commerce_order','commerce_store_order',0,123,129,'und',0,56),('commerce_order','commerce_marketplace_order',0,124,130,'und',0,57),('commerce_order','commerce_store_order',0,125,131,'und',0,58),('commerce_order','commerce_marketplace_order',0,138,144,'und',0,59),('commerce_order','commerce_marketplace_order',0,138,146,'und',0,59),('commerce_order','commerce_marketplace_order',0,138,147,'und',0,59),('commerce_order','commerce_marketplace_order',0,138,148,'und',0,59),('commerce_order','commerce_marketplace_order',0,138,149,'und',0,59),('commerce_order','commerce_marketplace_order',0,138,150,'und',0,59),('commerce_order','commerce_store_order',0,139,145,'und',0,60),('commerce_order','commerce_marketplace_order',0,140,151,'und',0,61),('commerce_order','commerce_marketplace_order',0,140,153,'und',0,61),('commerce_order','commerce_marketplace_order',0,140,153,'und',1,63),('commerce_order','commerce_marketplace_order',0,140,155,'und',0,63),('commerce_order','commerce_marketplace_order',0,140,156,'und',0,63),('commerce_order','commerce_marketplace_order',0,140,157,'und',0,63),('commerce_order','commerce_marketplace_order',0,140,158,'und',0,63),('commerce_order','commerce_marketplace_order',0,140,159,'und',0,63),('commerce_order','commerce_marketplace_order',0,140,160,'und',0,63),('commerce_order','commerce_marketplace_order',0,140,161,'und',0,63),('commerce_order','commerce_marketplace_order',0,140,162,'und',0,63),('commerce_order','commerce_marketplace_order',0,140,163,'und',0,63),('commerce_order','commerce_marketplace_order',0,140,164,'und',0,63),('commerce_order','commerce_marketplace_order',0,140,165,'und',0,63),('commerce_order','commerce_store_order',0,142,154,'und',0,64),('commerce_order','commerce_store_order',0,142,154,'und',1,65),('commerce_order','commerce_marketplace_order',0,146,169,'und',0,66),('commerce_order','commerce_marketplace_order',0,146,171,'und',0,66),('commerce_order','commerce_store_order',0,147,170,'und',0,67),('commerce_order','commerce_marketplace_order',0,167,191,'und',0,68),('commerce_order','commerce_marketplace_order',0,167,194,'und',0,68),('commerce_order','commerce_store_order',0,169,193,'und',0,69),('commerce_order','commerce_marketplace_order',0,189,214,'und',0,70),('commerce_order','commerce_marketplace_order',0,189,216,'und',0,70),('commerce_order','commerce_marketplace_order',0,189,217,'und',0,70),('commerce_order','commerce_store_order',0,190,215,'und',0,71),('commerce_order','commerce_marketplace_order',0,201,228,'und',0,72),('commerce_order','commerce_marketplace_order',0,201,230,'und',0,72),('commerce_order','commerce_marketplace_order',0,201,231,'und',0,72),('commerce_order','commerce_marketplace_order',0,201,231,'und',1,74),('commerce_order','commerce_marketplace_order',0,201,232,'und',0,72),('commerce_order','commerce_marketplace_order',0,201,232,'und',1,74),('commerce_order','commerce_store_order',0,202,229,'und',0,73),('commerce_order','commerce_marketplace_order',0,226,256,'und',0,75),('commerce_order','commerce_marketplace_order',0,226,256,'und',1,77),('commerce_order','commerce_store_order',0,230,260,'und',0,76),('commerce_order','commerce_store_order',0,231,261,'und',0,78),('commerce_order','commerce_marketplace_order',0,250,280,'und',0,79),('commerce_order','commerce_store_order',0,251,281,'und',0,80);
/*!40000 ALTER TABLE `field_revision_commerce_line_items` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_commerce_order_total`
--

DROP TABLE IF EXISTS `field_revision_commerce_order_total`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_commerce_order_total` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_order_total_amount` int(11) NOT NULL DEFAULT '0' COMMENT 'The price amount.',
  `commerce_order_total_currency_code` varchar(32) NOT NULL COMMENT 'The currency code for the price.',
  `commerce_order_total_data` longtext COMMENT 'A serialized array of additional price data.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `commerce_order_total_currency_price` (`commerce_order_total_amount`,`commerce_order_total_currency_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 8 (commerce_order_total)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_commerce_order_total`
--

LOCK TABLES `field_revision_commerce_order_total` WRITE;
/*!40000 ALTER TABLE `field_revision_commerce_order_total` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_commerce_order_total` VALUES ('commerce_order','commerce_marketplace_order',0,1,1,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,2,2,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,3,3,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,4,4,'und',0,5040000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:5040000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,5,5,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,6,6,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,7,7,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,8,8,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,9,9,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,10,10,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,11,11,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,12,12,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,13,13,'und',0,320000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:320000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,14,14,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,15,15,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,16,16,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,17,17,'und',0,9960000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:9960000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,18,18,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,19,19,'und',0,11500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:11500;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,20,20,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,21,21,'und',0,11500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:11500;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,22,22,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,23,23,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,24,24,'und',0,320000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:320000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,25,25,'und',0,440000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:440000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,26,26,'und',0,560000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:560000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,27,27,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,28,28,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,29,29,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,30,30,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,31,31,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,32,32,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,33,33,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,34,34,'und',0,300000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:300000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,35,35,'und',0,300000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:300000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,36,36,'und',0,720000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:720000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,37,37,'und',0,900000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:900000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,38,38,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,39,39,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:200000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,40,40,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,41,41,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,42,42,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,43,43,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,44,44,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:200000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,45,45,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,46,46,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,47,47,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,48,48,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,49,49,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,50,50,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,51,51,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,52,52,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,53,53,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,54,54,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,55,55,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,56,56,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,57,57,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,58,58,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,59,59,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,60,60,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,61,61,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,62,62,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,63,63,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,64,64,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,65,65,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,66,66,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,67,67,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,68,68,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,69,69,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,70,70,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,71,71,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,72,72,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,73,73,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,73,75,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,74,74,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,75,76,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,76,77,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,76,79,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,77,78,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,78,80,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,79,81,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,80,82,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,81,83,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,82,84,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,83,85,'und',0,360000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:360000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,83,87,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,83,88,'und',0,240000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:240000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,83,89,'und',0,240000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:240000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,83,90,'und',0,240000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:240000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,84,86,'und',0,960000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:960000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,85,91,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,86,92,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,87,93,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,88,94,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,89,95,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,90,96,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,91,97,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,92,98,'und',0,3800,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:3800;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,93,99,'und',0,3800,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:3800;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,94,100,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,95,101,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,96,102,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,97,103,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,98,104,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,99,105,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,100,106,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,101,107,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,102,108,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,103,109,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,104,110,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,105,111,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,106,112,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,107,113,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,108,114,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,109,115,'und',0,59900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:59900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,110,116,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,111,117,'und',0,59900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:59900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,112,118,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,113,119,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,114,120,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,115,121,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,116,122,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,117,123,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,118,124,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,119,125,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,120,126,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,121,127,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:34900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,122,128,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:34900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,123,129,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,124,130,'und',0,100000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:100000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,125,131,'und',0,100000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:100000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,126,132,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,127,133,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,128,134,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,129,135,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,130,136,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,131,137,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,132,138,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,133,139,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,134,140,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,135,141,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,136,142,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,137,143,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,138,144,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,138,146,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,138,147,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,138,148,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,138,149,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,138,150,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,139,145,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,140,151,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:34900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,140,153,'und',0,234900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:234900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,140,155,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:200000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,140,156,'und',0,400000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:400000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,140,157,'und',0,400000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:400000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,140,158,'und',0,400000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:400000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,140,159,'und',0,400000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:400000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,140,160,'und',0,400000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:400000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,140,161,'und',0,400000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:400000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,140,162,'und',0,400000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:400000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,140,163,'und',0,400000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:400000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,140,164,'und',0,400000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:400000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,140,165,'und',0,400000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:400000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,141,152,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,142,154,'und',0,600000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:600000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,143,166,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,144,167,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,145,168,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,146,169,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:34900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,146,171,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:34900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,147,170,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:34900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,148,172,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,149,173,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,150,174,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,151,175,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,152,176,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,153,177,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,154,178,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,155,179,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,156,180,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,157,181,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,158,182,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,159,183,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,160,184,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,161,185,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,162,186,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,163,187,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,164,188,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,165,189,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,166,190,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,167,191,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,167,194,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,168,192,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,169,193,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,170,195,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,171,196,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,172,197,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,173,198,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,174,199,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,175,200,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,176,201,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,177,202,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,178,203,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,179,204,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,180,205,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,181,206,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,182,207,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,183,208,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,184,209,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,185,210,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,186,211,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,187,212,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,188,213,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,189,214,'und',0,12500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:12500;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,189,216,'und',0,50000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:50000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,189,217,'und',0,12500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:12500;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,190,215,'und',0,12500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:12500;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,191,218,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,192,219,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,193,220,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,194,221,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,195,222,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,196,223,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,197,224,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,198,225,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,199,226,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,200,227,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,201,228,'und',0,15000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:15000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,201,230,'und',0,15000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:15000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,201,231,'und',0,16200,'USD','a:1:{s:10:\"components\";a:2:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:15000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}i:1;a:3:{s:4:\"name\";s:18:\"flat_rate_shipping\";s:5:\"price\";a:3:{s:6:\"amount\";i:1200;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,201,232,'und',0,16200,'USD','a:1:{s:10:\"components\";a:2:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:15000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}i:1;a:3:{s:4:\"name\";s:18:\"flat_rate_shipping\";s:5:\"price\";a:3:{s:6:\"amount\";i:1200;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,202,229,'und',0,15000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:15000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,203,233,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,204,234,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,205,235,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,206,236,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,207,237,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,208,238,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,209,239,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,210,240,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,211,241,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,212,242,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,213,243,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,214,244,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,215,245,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,216,246,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,217,247,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,218,248,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,219,249,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,220,250,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,221,251,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,222,252,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,223,253,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,224,254,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,225,255,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,226,256,'und',0,149900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:149900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,227,257,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,228,258,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,229,259,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,230,260,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,231,261,'und',0,79900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:79900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,232,262,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,233,263,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,234,264,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,235,265,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,236,266,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,237,267,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,238,268,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,239,269,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,240,270,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,241,271,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,242,272,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,243,273,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,244,274,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,245,275,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,246,276,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,247,277,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,248,279,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,249,278,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,250,280,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_store_order',0,251,281,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,252,282,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,253,283,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,254,284,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,255,285,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_order','commerce_marketplace_order',0,256,286,'und',0,0,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}');
/*!40000 ALTER TABLE `field_revision_commerce_order_total` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_commerce_price`
--

DROP TABLE IF EXISTS `field_revision_commerce_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_commerce_price` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_price_amount` int(11) NOT NULL DEFAULT '0' COMMENT 'The price amount.',
  `commerce_price_currency_code` varchar(32) NOT NULL COMMENT 'The currency code for the price.',
  `commerce_price_data` longtext COMMENT 'A serialized array of additional price data.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `commerce_price_currency_price` (`commerce_price_amount`,`commerce_price_currency_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 14 (commerce_price)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_commerce_price`
--

LOCK TABLES `field_revision_commerce_price` WRITE;
/*!40000 ALTER TABLE `field_revision_commerce_price` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_commerce_price` VALUES ('commerce_product','product',0,4,4,'und',0,11500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,4,15,'und',0,11500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,6,6,'und',0,120000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,6,9,'und',0,120000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,6,83,'und',0,120000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,7,7,'und',0,200000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,7,10,'und',0,200000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,8,8,'und',0,300000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,8,11,'und',0,300000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,9,16,'und',0,3800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,9,78,'und',0,3800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,9,79,'und',0,3800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,9,84,'und',0,3800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,10,17,'und',0,3800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,10,80,'und',0,3800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,10,85,'und',0,3800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,10,86,'und',0,3800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,11,18,'und',0,9900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,11,125,'und',0,9900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,12,19,'und',0,9900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,13,20,'und',0,9900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,14,21,'und',0,9900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,15,22,'und',0,26400,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,16,23,'und',0,31800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,17,24,'und',0,3500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,18,25,'und',0,4100,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,19,26,'und',0,4300,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,19,96,'und',0,4300,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,20,27,'und',0,5000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,21,28,'und',0,3900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,21,118,'und',0,3900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,22,29,'und',0,23800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,22,97,'und',0,23800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,23,30,'und',0,10700,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,23,98,'und',0,10700,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,24,31,'und',0,11500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,24,99,'und',0,11500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,25,32,'und',0,5900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,25,100,'und',0,5900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,26,33,'und',0,5900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,26,92,'und',0,5900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,27,34,'und',0,75000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,27,101,'und',0,75000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,28,35,'und',0,70000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,29,36,'und',0,100000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,30,37,'und',0,19900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,30,102,'und',0,19900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,31,38,'und',0,4900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,31,91,'und',0,4900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,32,39,'und',0,49999,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,32,90,'und',0,49999,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,33,40,'und',0,34900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,33,103,'und',0,34900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,34,41,'und',0,29900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,35,42,'und',0,59900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,36,43,'und',0,6900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,36,104,'und',0,6900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,37,44,'und',0,15500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,38,45,'und',0,9400,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,38,105,'und',0,9400,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,39,46,'und',0,2900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,39,106,'und',0,2900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,40,47,'und',0,7500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,40,107,'und',0,7500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,41,48,'und',0,13900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,41,81,'und',0,13900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,41,87,'und',0,13900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,41,89,'und',0,13900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,42,49,'und',0,13900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,42,82,'und',0,13900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,42,88,'und',0,13900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,43,50,'und',0,3900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,43,108,'und',0,3900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,44,51,'und',0,4300,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,44,109,'und',0,4300,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,45,52,'und',0,7900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,45,110,'und',0,7900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,46,53,'und',0,2900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,47,54,'und',0,2000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,47,111,'und',0,2000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,48,55,'und',0,2400,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,49,56,'und',0,3500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,49,112,'und',0,3500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,50,57,'und',0,3000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,50,113,'und',0,3000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,51,58,'und',0,39900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,51,114,'und',0,39900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,52,59,'und',0,100000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,52,115,'und',0,100000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,53,60,'und',0,89900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,53,116,'und',0,89900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,54,61,'und',0,8500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,54,117,'und',0,8500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,55,62,'und',0,119900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,55,119,'und',0,119900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,56,63,'und',0,203500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,56,120,'und',0,203500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,57,64,'und',0,129900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,57,121,'und',0,129900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,58,65,'und',0,36900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,58,122,'und',0,36900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,59,66,'und',0,17900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,59,123,'und',0,17900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,60,67,'und',0,34900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,60,124,'und',0,34900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,61,68,'und',0,100000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,62,69,'und',0,5500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,63,70,'und',0,129900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,64,71,'und',0,14500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,65,72,'und',0,21900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,66,73,'und',0,49900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,66,95,'und',0,49900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,67,74,'und',0,37700,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,67,94,'und',0,37700,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,68,75,'und',0,59900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,68,93,'und',0,59900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,69,76,'und',0,99900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,70,77,'und',0,49900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,71,126,'und',0,68800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,72,127,'und',0,43800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,73,128,'und',0,79900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,74,129,'und',0,54800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,74,132,'und',0,54800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,75,130,'und',0,48000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,75,135,'und',0,48000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,75,136,'und',0,48000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,75,138,'und',0,48000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,75,139,'und',0,48000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,75,140,'und',0,48000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,75,142,'und',0,48000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,75,143,'und',0,48000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,76,131,'und',0,12800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,77,133,'und',0,15900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,78,134,'und',0,2300,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,79,137,'und',0,19900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,80,141,'und',0,12500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,81,144,'und',0,13000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,82,145,'und',0,15000,'USD','a:1:{s:10:\"components\";a:0:{}}');
/*!40000 ALTER TABLE `field_revision_commerce_price` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_commerce_product`
--

DROP TABLE IF EXISTS `field_revision_commerce_product`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_commerce_product` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_product_product_id` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `commerce_product_product_id` (`commerce_product_product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 12 (commerce_product)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_commerce_product`
--

LOCK TABLES `field_revision_commerce_product` WRITE;
/*!40000 ALTER TABLE `field_revision_commerce_product` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_commerce_product` VALUES ('commerce_line_item','product',0,1,1,'und',0,6),('commerce_line_item','product',0,2,2,'und',0,6),('commerce_line_item','product',0,3,3,'und',0,6),('commerce_line_item','product',0,4,4,'und',0,6),('commerce_line_item','product',0,5,5,'und',0,4),('commerce_line_item','product',0,6,6,'und',0,4),('commerce_line_item','product',0,7,7,'und',0,6),('commerce_line_item','product',0,8,8,'und',0,6),('commerce_line_item','product',0,9,9,'und',0,6),('commerce_line_item','product',0,10,10,'und',0,6),('commerce_line_item','product',0,11,11,'und',0,6),('commerce_line_item','product',0,12,12,'und',0,7),('commerce_line_item','product',0,13,13,'und',0,7),('commerce_line_item','product',0,14,14,'und',0,6),('commerce_line_item','product',0,15,15,'und',0,6),('commerce_line_item','product',0,16,16,'und',0,7),('commerce_line_item','product',0,17,17,'und',0,7),('commerce_line_item','product',0,18,18,'und',0,6),('commerce_line_item','product',0,20,20,'und',0,8),('commerce_line_item','product',0,21,21,'und',0,6),('commerce_line_item','product',0,22,22,'und',0,6),('commerce_line_item','product',0,23,23,'und',0,6),('commerce_line_item','product',0,24,24,'und',0,6),('commerce_line_item','product',0,25,25,'und',0,8),('commerce_line_item','product',0,26,26,'und',0,8),('commerce_line_item','product',0,27,27,'und',0,8),('commerce_line_item','product',0,28,28,'und',0,8),('commerce_line_item','product',0,29,29,'und',0,8),('commerce_line_item','product',0,30,30,'und',0,6),('commerce_line_item','product',0,31,31,'und',0,6),('commerce_line_item','product',0,32,32,'und',0,7),('commerce_line_item','product',0,33,33,'und',0,7),('commerce_line_item','product',0,35,35,'und',0,6),('commerce_line_item','product',0,36,36,'und',0,6),('commerce_line_item','product',0,37,37,'und',0,6),('commerce_line_item','product',0,38,38,'und',0,6),('commerce_line_item','product',0,39,39,'und',0,6),('commerce_line_item','product',0,40,40,'und',0,6),('commerce_line_item','product',0,41,41,'und',0,6),('commerce_line_item','product',0,42,42,'und',0,6),('commerce_line_item','product',0,43,43,'und',0,6),('commerce_line_item','product',0,44,44,'und',0,6),('commerce_line_item','product',0,45,45,'und',0,10),('commerce_line_item','product',0,46,46,'und',0,10),('commerce_line_item','product',0,47,47,'und',0,35),('commerce_line_item','product',0,48,48,'und',0,35),('commerce_line_item','product',0,49,49,'und',0,28),('commerce_line_item','product',0,50,50,'und',0,28),('commerce_line_item','product',0,52,52,'und',0,28),('commerce_line_item','product',0,53,53,'und',0,60),('commerce_line_item','product',0,54,54,'und',0,60),('commerce_line_item','product',0,55,55,'und',0,28),('commerce_line_item','product',0,56,56,'und',0,28),('commerce_line_item','product',0,57,57,'und',0,29),('commerce_line_item','product',0,58,58,'und',0,29),('commerce_line_item','product',0,59,59,'und',0,6),('commerce_line_item','product',0,60,60,'und',0,6),('commerce_line_item','product',0,62,62,'und',0,60),('commerce_line_item','product',0,63,63,'und',0,7),('commerce_line_item','product',0,64,64,'und',0,7),('commerce_line_item','product',0,65,65,'und',0,7),('commerce_line_item','product',0,66,66,'und',0,60),('commerce_line_item','product',0,67,67,'und',0,60),('commerce_line_item','product',0,68,68,'und',0,28),('commerce_line_item','product',0,69,69,'und',0,28),('commerce_line_item','product',0,70,70,'und',0,80),('commerce_line_item','product',0,71,71,'und',0,80),('commerce_line_item','product',0,72,72,'und',0,82),('commerce_line_item','product',0,73,73,'und',0,82),('commerce_line_item','product',0,75,75,'und',0,28),('commerce_line_item','product',0,76,76,'und',0,28),('commerce_line_item','product',0,77,77,'und',0,73),('commerce_line_item','product',0,78,78,'und',0,73),('commerce_line_item','product',0,79,79,'und',0,28),('commerce_line_item','product',0,80,80,'und',0,28);
/*!40000 ALTER TABLE `field_revision_commerce_product` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_commerce_shipping_service`
--

DROP TABLE IF EXISTS `field_revision_commerce_shipping_service`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_commerce_shipping_service` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_shipping_service_value` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `commerce_shipping_service_value` (`commerce_shipping_service_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 28 (commerce_shipping...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_commerce_shipping_service`
--

LOCK TABLES `field_revision_commerce_shipping_service` WRITE;
/*!40000 ALTER TABLE `field_revision_commerce_shipping_service` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_commerce_shipping_service` VALUES ('commerce_line_item','shipping',0,74,74,'und',0,'shipping');
/*!40000 ALTER TABLE `field_revision_commerce_shipping_service` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_commerce_stock`
--

DROP TABLE IF EXISTS `field_revision_commerce_stock`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_commerce_stock` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_stock_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 46 (commerce_stock)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_commerce_stock`
--

LOCK TABLES `field_revision_commerce_stock` WRITE;
/*!40000 ALTER TABLE `field_revision_commerce_stock` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_commerce_stock` VALUES ('commerce_product','product',0,4,4,'und',0,0.00),('commerce_product','product',0,4,15,'und',0,0.00),('commerce_product','product',0,6,6,'und',0,0.00),('commerce_product','product',0,6,9,'und',0,10.00),('commerce_product','product',0,6,83,'und',0,9.00),('commerce_product','product',0,7,7,'und',0,0.00),('commerce_product','product',0,7,10,'und',0,8.00),('commerce_product','product',0,8,8,'und',0,0.00),('commerce_product','product',0,8,11,'und',0,10.00),('commerce_product','product',0,9,16,'und',0,3.00),('commerce_product','product',0,9,78,'und',0,3.00),('commerce_product','product',0,9,79,'und',0,3.00),('commerce_product','product',0,9,84,'und',0,3.00),('commerce_product','product',0,10,17,'und',0,5.00),('commerce_product','product',0,10,80,'und',0,5.00),('commerce_product','product',0,10,85,'und',0,5.00),('commerce_product','product',0,10,86,'und',0,5.00),('commerce_product','product',0,11,18,'und',0,1.00),('commerce_product','product',0,11,125,'und',0,1.00),('commerce_product','product',0,12,19,'und',0,1.00),('commerce_product','product',0,13,20,'und',0,1.00),('commerce_product','product',0,14,21,'und',0,1.00),('commerce_product','product',0,15,22,'und',0,1.00),('commerce_product','product',0,16,23,'und',0,5.00),('commerce_product','product',0,17,24,'und',0,4.00),('commerce_product','product',0,18,25,'und',0,10.00),('commerce_product','product',0,19,26,'und',0,5.00),('commerce_product','product',0,19,96,'und',0,5.00),('commerce_product','product',0,20,27,'und',0,2.00),('commerce_product','product',0,21,28,'und',0,10.00),('commerce_product','product',0,21,118,'und',0,10.00),('commerce_product','product',0,22,29,'und',0,6.00),('commerce_product','product',0,22,97,'und',0,6.00),('commerce_product','product',0,23,30,'und',0,5.00),('commerce_product','product',0,23,98,'und',0,5.00),('commerce_product','product',0,24,31,'und',0,7.00),('commerce_product','product',0,24,99,'und',0,7.00),('commerce_product','product',0,25,32,'und',0,1.00),('commerce_product','product',0,25,100,'und',0,1.00),('commerce_product','product',0,26,33,'und',0,5.00),('commerce_product','product',0,26,92,'und',0,5.00),('commerce_product','product',0,27,34,'und',0,5.00),('commerce_product','product',0,27,101,'und',0,5.00),('commerce_product','product',0,28,35,'und',0,5.00),('commerce_product','product',0,29,36,'und',0,1.00),('commerce_product','product',0,30,37,'und',0,3.00),('commerce_product','product',0,30,102,'und',0,3.00),('commerce_product','product',0,31,38,'und',0,10.00),('commerce_product','product',0,31,91,'und',0,10.00),('commerce_product','product',0,32,39,'und',0,4.00),('commerce_product','product',0,32,90,'und',0,4.00),('commerce_product','product',0,33,40,'und',0,5.00),('commerce_product','product',0,33,103,'und',0,5.00),('commerce_product','product',0,34,41,'und',0,6.00),('commerce_product','product',0,35,42,'und',0,4.00),('commerce_product','product',0,36,43,'und',0,20.00),('commerce_product','product',0,36,104,'und',0,20.00),('commerce_product','product',0,37,44,'und',0,5.00),('commerce_product','product',0,38,45,'und',0,2.00),('commerce_product','product',0,38,105,'und',0,2.00),('commerce_product','product',0,39,46,'und',0,4.00),('commerce_product','product',0,39,106,'und',0,4.00),('commerce_product','product',0,40,47,'und',0,5.00),('commerce_product','product',0,40,107,'und',0,5.00),('commerce_product','product',0,41,48,'und',0,5.00),('commerce_product','product',0,41,81,'und',0,5.00),('commerce_product','product',0,41,87,'und',0,5.00),('commerce_product','product',0,41,89,'und',0,5.00),('commerce_product','product',0,42,49,'und',0,5.00),('commerce_product','product',0,42,82,'und',0,5.00),('commerce_product','product',0,42,88,'und',0,5.00),('commerce_product','product',0,43,50,'und',0,5.00),('commerce_product','product',0,43,108,'und',0,5.00),('commerce_product','product',0,44,51,'und',0,5.00),('commerce_product','product',0,44,109,'und',0,5.00),('commerce_product','product',0,45,52,'und',0,3.00),('commerce_product','product',0,45,110,'und',0,3.00),('commerce_product','product',0,46,53,'und',0,100.00),('commerce_product','product',0,47,54,'und',0,5.00),('commerce_product','product',0,47,111,'und',0,5.00),('commerce_product','product',0,48,55,'und',0,4.00),('commerce_product','product',0,49,56,'und',0,4.00),('commerce_product','product',0,49,112,'und',0,4.00),('commerce_product','product',0,50,57,'und',0,6.00),('commerce_product','product',0,50,113,'und',0,6.00),('commerce_product','product',0,51,58,'und',0,5.00),('commerce_product','product',0,51,114,'und',0,5.00),('commerce_product','product',0,52,59,'und',0,6.00),('commerce_product','product',0,52,115,'und',0,6.00),('commerce_product','product',0,53,60,'und',0,4.00),('commerce_product','product',0,53,116,'und',0,4.00),('commerce_product','product',0,54,61,'und',0,8.00),('commerce_product','product',0,54,117,'und',0,8.00),('commerce_product','product',0,55,62,'und',0,5.00),('commerce_product','product',0,55,119,'und',0,5.00),('commerce_product','product',0,56,63,'und',0,6.00),('commerce_product','product',0,56,120,'und',0,6.00),('commerce_product','product',0,57,64,'und',0,1.00),('commerce_product','product',0,57,121,'und',0,1.00),('commerce_product','product',0,58,65,'und',0,2.00),('commerce_product','product',0,58,122,'und',0,2.00),('commerce_product','product',0,59,66,'und',0,5.00),('commerce_product','product',0,59,123,'und',0,5.00),('commerce_product','product',0,60,67,'und',0,5.00),('commerce_product','product',0,60,124,'und',0,5.00),('commerce_product','product',0,61,68,'und',0,1.00),('commerce_product','product',0,62,69,'und',0,5.00),('commerce_product','product',0,63,70,'und',0,4.00),('commerce_product','product',0,64,71,'und',0,5.00),('commerce_product','product',0,65,72,'und',0,6.00),('commerce_product','product',0,66,73,'und',0,5.00),('commerce_product','product',0,66,95,'und',0,5.00),('commerce_product','product',0,67,74,'und',0,5.00),('commerce_product','product',0,67,94,'und',0,5.00),('commerce_product','product',0,68,75,'und',0,5.00),('commerce_product','product',0,68,93,'und',0,5.00),('commerce_product','product',0,69,76,'und',0,3.00),('commerce_product','product',0,70,77,'und',0,5.00),('commerce_product','product',0,71,126,'und',0,5.00),('commerce_product','product',0,72,127,'und',0,5.00),('commerce_product','product',0,73,128,'und',0,4.00),('commerce_product','product',0,74,129,'und',0,4.00),('commerce_product','product',0,74,132,'und',0,4.00),('commerce_product','product',0,75,130,'und',0,6.00),('commerce_product','product',0,75,135,'und',0,6.00),('commerce_product','product',0,75,136,'und',0,6.00),('commerce_product','product',0,75,138,'und',0,6.00),('commerce_product','product',0,75,139,'und',0,6.00),('commerce_product','product',0,75,140,'und',0,6.00),('commerce_product','product',0,75,142,'und',0,6.00),('commerce_product','product',0,75,143,'und',0,6.00),('commerce_product','product',0,76,131,'und',0,7.00),('commerce_product','product',0,77,133,'und',0,7.00),('commerce_product','product',0,78,134,'und',0,1.00),('commerce_product','product',0,79,137,'und',0,5.00),('commerce_product','product',0,80,141,'und',0,5.00),('commerce_product','product',0,81,144,'und',0,5.00),('commerce_product','product',0,82,145,'und',0,5.00);
/*!40000 ALTER TABLE `field_revision_commerce_stock` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_commerce_total`
--

DROP TABLE IF EXISTS `field_revision_commerce_total`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_commerce_total` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_total_amount` int(11) NOT NULL DEFAULT '0' COMMENT 'The price amount.',
  `commerce_total_currency_code` varchar(32) NOT NULL COMMENT 'The currency code for the price.',
  `commerce_total_data` longtext COMMENT 'A serialized array of additional price data.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `commerce_total_currency_price` (`commerce_total_amount`,`commerce_total_currency_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 11 (commerce_total)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_commerce_total`
--

LOCK TABLES `field_revision_commerce_total` WRITE;
/*!40000 ALTER TABLE `field_revision_commerce_total` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_commerce_total` VALUES ('commerce_line_item','product',0,1,1,'und',0,5040000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:5040000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,2,2,'und',0,4920000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:4920000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,3,3,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,4,4,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,5,5,'und',0,11500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:11500;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,6,6,'und',0,11500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:11500;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,7,7,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,8,8,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,9,9,'und',0,5040000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:5040000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,10,10,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,11,11,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,12,12,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:200000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,13,13,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:200000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,14,14,'und',0,240000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:240000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,15,15,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,16,16,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:200000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,17,17,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:200000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,18,18,'und',0,240000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:240000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,20,20,'und',0,300000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:300000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,21,21,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,22,22,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,23,23,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,24,24,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,25,25,'und',0,300000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:300000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,26,26,'und',0,300000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:300000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,27,27,'und',0,600000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:600000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,28,28,'und',0,300000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:300000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,29,29,'und',0,600000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:600000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,30,30,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,31,31,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,32,32,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:200000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,33,33,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:200000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,35,35,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,36,36,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,37,37,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,38,38,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,39,39,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,40,40,'und',0,240000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:240000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,41,41,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,42,42,'und',0,240000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:240000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,43,43,'und',0,360000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:360000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,44,44,'und',0,240000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:240000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,45,45,'und',0,3800,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:3800;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,46,46,'und',0,3800,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:3800;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,47,47,'und',0,59900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:59900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,48,48,'und',0,59900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:59900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,49,49,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,50,50,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,52,52,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,53,53,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:34900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,54,54,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:34900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,55,55,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,56,56,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,57,57,'und',0,100000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:100000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,58,58,'und',0,100000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:100000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,59,59,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,60,60,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:120000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,62,62,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:34900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,63,63,'und',0,400000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:400000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,64,64,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:200000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,65,65,'und',0,400000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";d:400000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,66,66,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:34900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,67,67,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:34900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,68,68,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,69,69,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,70,70,'und',0,12500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:12500;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,71,71,'und',0,12500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:12500;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,72,72,'und',0,15000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:15000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,73,73,'und',0,15000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:15000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','shipping',0,74,74,'und',0,1200,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:18:\"flat_rate_shipping\";s:5:\"price\";a:3:{s:6:\"amount\";i:1200;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,75,75,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,76,76,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,77,77,'und',0,79900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:79900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,78,78,'und',0,79900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:79900;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,79,79,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,80,80,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";i:70000;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}');
/*!40000 ALTER TABLE `field_revision_commerce_total` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_commerce_unit_price`
--

DROP TABLE IF EXISTS `field_revision_commerce_unit_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_commerce_unit_price` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `commerce_unit_price_amount` int(11) NOT NULL DEFAULT '0' COMMENT 'The price amount.',
  `commerce_unit_price_currency_code` varchar(32) NOT NULL COMMENT 'The currency code for the price.',
  `commerce_unit_price_data` longtext COMMENT 'A serialized array of additional price data.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `commerce_unit_price_currency_price` (`commerce_unit_price_amount`,`commerce_unit_price_currency_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 10 (commerce_unit_price)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_commerce_unit_price`
--

LOCK TABLES `field_revision_commerce_unit_price` WRITE;
/*!40000 ALTER TABLE `field_revision_commerce_unit_price` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_commerce_unit_price` VALUES ('commerce_line_item','product',0,1,1,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,2,2,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,3,3,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,4,4,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,5,5,'und',0,11500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"11500\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,6,6,'und',0,11500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"11500\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,7,7,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,8,8,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,9,9,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,10,10,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,11,11,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,12,12,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"200000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,13,13,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"200000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,14,14,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,15,15,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,16,16,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"200000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,17,17,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"200000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,18,18,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,20,20,'und',0,300000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"300000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,21,21,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,22,22,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,23,23,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,24,24,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,25,25,'und',0,300000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"300000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,26,26,'und',0,300000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"300000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,27,27,'und',0,300000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"300000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,28,28,'und',0,300000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"300000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,29,29,'und',0,300000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"300000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,30,30,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,31,31,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,32,32,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"200000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,33,33,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"200000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,35,35,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,36,36,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,37,37,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,38,38,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,39,39,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,40,40,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,41,41,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,42,42,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,43,43,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,44,44,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,45,45,'und',0,3800,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:4:\"3800\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,46,46,'und',0,3800,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:4:\"3800\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,47,47,'und',0,59900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"59900\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,48,48,'und',0,59900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"59900\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,49,49,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"70000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,50,50,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"70000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,52,52,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"70000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,53,53,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"34900\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,54,54,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"34900\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,55,55,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"70000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,56,56,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"70000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,57,57,'und',0,100000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"100000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,58,58,'und',0,100000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"100000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,59,59,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,60,60,'und',0,120000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"120000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,62,62,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"34900\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,63,63,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"200000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,64,64,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"200000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,65,65,'und',0,200000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:6:\"200000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,66,66,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"34900\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,67,67,'und',0,34900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"34900\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,68,68,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"70000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,69,69,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"70000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,70,70,'und',0,12500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"12500\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,71,71,'und',0,12500,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"12500\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,72,72,'und',0,15000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"15000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,73,73,'und',0,15000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"15000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','shipping',0,74,74,'und',0,1200,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:18:\"flat_rate_shipping\";s:5:\"price\";a:3:{s:6:\"amount\";s:4:\"1200\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,75,75,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"70000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,76,76,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"70000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,77,77,'und',0,79900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"79900\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,78,78,'und',0,79900,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"79900\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,79,79,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"70000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}'),('commerce_line_item','product',0,80,80,'und',0,70000,'USD','a:1:{s:10:\"components\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"base_price\";s:5:\"price\";a:3:{s:6:\"amount\";s:5:\"70000\";s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:1:{s:10:\"components\";a:0:{}}}s:8:\"included\";b:1;}}}');
/*!40000 ALTER TABLE `field_revision_commerce_unit_price` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_bean_icon`
--

DROP TABLE IF EXISTS `field_revision_field_bean_icon`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_bean_icon` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_bean_icon_bundle` varchar(64) DEFAULT NULL,
  `field_bean_icon_icon` varchar(64) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 42 (field_bean_icon)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_bean_icon`
--

LOCK TABLES `field_revision_field_bean_icon` WRITE;
/*!40000 ALTER TABLE `field_revision_field_bean_icon` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `field_revision_field_bean_icon` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_body`
--

DROP TABLE IF EXISTS `field_revision_field_body`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_body` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_body_value` longtext,
  `field_body_summary` longtext,
  `field_body_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_body_format` (`field_body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 43 (field_body)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_body`
--

LOCK TABLES `field_revision_field_body` WRITE;
/*!40000 ALTER TABLE `field_revision_field_body` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `field_revision_field_body` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_boolean`
--

DROP TABLE IF EXISTS `field_revision_field_boolean`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_boolean` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_boolean_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_boolean_value` (`field_boolean_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 44 (field_boolean)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_boolean`
--

LOCK TABLES `field_revision_field_boolean` WRITE;
/*!40000 ALTER TABLE `field_revision_field_boolean` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_boolean` VALUES ('node','product',0,30,30,'und',0,0),('node','product',0,31,31,'und',0,0),('node','product',0,32,32,'und',0,0),('node','product',0,33,33,'und',0,0),('node','product',0,34,34,'und',0,0),('node','product',0,35,35,'und',0,0),('node','product',0,36,36,'und',0,0),('node','product',0,37,37,'und',0,0),('node','product',0,38,38,'und',0,0),('node','product',0,39,39,'und',0,0),('node','product',0,40,40,'und',0,0),('node','product',0,41,41,'und',0,0),('node','product',0,42,42,'und',0,0),('node','product',0,43,43,'und',0,0),('node','product',0,44,44,'und',0,1),('node','product',0,45,45,'und',0,1),('node','product',0,46,46,'und',0,1),('node','product',0,47,47,'und',0,0),('node','product',0,48,48,'und',0,0),('node','product',0,49,49,'und',0,0),('node','product',0,50,50,'und',0,0),('node','product',0,51,51,'und',0,0),('node','product',0,52,52,'und',0,1),('node','product',0,53,53,'und',0,0),('node','product',0,54,54,'und',0,0),('node','product',0,55,55,'und',0,0),('node','product',0,56,56,'und',0,0),('node','product',0,57,57,'und',0,0),('node','product',0,58,58,'und',0,0),('node','product',0,59,59,'und',0,0),('node','product',0,60,60,'und',0,0),('node','product',0,61,61,'und',0,0),('node','product',0,62,62,'und',0,0),('node','product',0,63,63,'und',0,0),('node','product',0,64,64,'und',0,0),('node','product',0,65,65,'und',0,0),('node','product',0,66,66,'und',0,0),('node','product',0,67,67,'und',0,0),('node','product',0,68,68,'und',0,0),('node','product',0,69,69,'und',0,0),('node','product',0,70,70,'und',0,0),('node','product',0,71,71,'und',0,1),('node','product',0,72,72,'und',0,0),('node','product',0,73,73,'und',0,0),('node','product',0,74,74,'und',0,0),('node','product',0,75,75,'und',0,0),('node','product',0,76,76,'und',0,0),('node','product',0,77,77,'und',0,0),('node','product',0,78,78,'und',0,0),('node','product',0,79,79,'und',0,0),('node','product',0,80,80,'und',0,0),('node','product',0,81,81,'und',0,0),('node','product',0,82,82,'und',0,0),('node','product',0,83,83,'und',0,0),('node','product',0,84,84,'und',0,0),('node','product',0,85,85,'und',0,0),('node','product',0,86,86,'und',0,0),('node','product',0,88,88,'und',0,0),('node','product',0,89,89,'und',0,0),('node','product',0,90,90,'und',0,0),('node','product',0,91,91,'und',0,0),('node','product',0,92,92,'und',0,0),('node','product',0,93,93,'und',0,0),('node','product',0,94,94,'und',0,0),('node','product',0,95,95,'und',0,0),('node','product',0,96,96,'und',0,0),('node','product',0,97,97,'und',0,0),('node','product',0,138,138,'und',0,0),('node','product',0,139,139,'und',0,0);
/*!40000 ALTER TABLE `field_revision_field_boolean` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_brand`
--

DROP TABLE IF EXISTS `field_revision_field_brand`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_brand` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_brand_tid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_brand_tid` (`field_brand_tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 21 (field_brand)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_brand`
--

LOCK TABLES `field_revision_field_brand` WRITE;
/*!40000 ALTER TABLE `field_revision_field_brand` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_brand` VALUES ('node','product',0,30,30,'und',0,74),('node','product',0,31,31,'und',0,75),('node','product',0,32,32,'und',0,76),('node','product',0,33,33,'und',0,78),('node','product',0,34,34,'und',0,79),('node','product',0,35,35,'und',0,81),('node','product',0,36,36,'und',0,82),('node','product',0,37,37,'und',0,83),('node','product',0,38,38,'und',0,82),('node','product',0,39,39,'und',0,84),('node','product',0,40,40,'und',0,85),('node','product',0,41,41,'und',0,86),('node','product',0,42,42,'und',0,87),('node','product',0,43,43,'und',0,82),('node','product',0,44,44,'und',0,10),('node','product',0,45,45,'und',0,11),('node','product',0,46,46,'und',0,13),('node','product',0,47,47,'und',0,88),('node','product',0,48,48,'und',0,14),('node','product',0,49,49,'und',0,10),('node','product',0,50,50,'und',0,13),('node','product',0,51,51,'und',0,88),('node','product',0,52,52,'und',0,10),('node','product',0,53,53,'und',0,89),('node','product',0,54,54,'und',0,11),('node','product',0,55,55,'und',0,82),('node','product',0,56,56,'und',0,90),('node','product',0,57,57,'und',0,10),('node','product',0,58,58,'und',0,91),('node','product',0,59,59,'und',0,82),('node','product',0,60,60,'und',0,82),('node','product',0,61,61,'und',0,92),('node','product',0,62,62,'und',0,93),('node','product',0,63,63,'und',0,94),('node','product',0,64,64,'und',0,94),('node','product',0,65,65,'und',0,95),('node','product',0,66,66,'und',0,95),('node','product',0,67,67,'und',0,97),('node','product',0,68,68,'und',0,96),('node','product',0,69,69,'und',0,99),('node','product',0,70,70,'und',0,82),('node','product',0,71,71,'und',0,11),('node','product',0,72,72,'und',0,11),('node','product',0,73,73,'und',0,91),('node','product',0,74,74,'und',0,11),('node','product',0,75,75,'und',0,82),('node','product',0,76,76,'und',0,10),('node','product',0,77,77,'und',0,12),('node','product',0,78,78,'und',0,82),('node','product',0,79,79,'und',0,12),('node','product',0,80,80,'und',0,100),('node','product',0,81,81,'und',0,100),('node','product',0,82,82,'und',0,102),('node','product',0,83,83,'und',0,101),('node','product',0,84,84,'und',0,98),('node','product',0,85,85,'und',0,102),('node','product',0,86,86,'und',0,102),('node','product',0,88,88,'und',0,11),('node','product',0,89,89,'und',0,103),('node','product',0,90,90,'und',0,102),('node','product',0,91,91,'und',0,111),('node','product',0,92,92,'und',0,112),('node','product',0,93,93,'und',0,113),('node','product',0,94,94,'und',0,114),('node','product',0,95,95,'und',0,115),('node','product',0,96,96,'und',0,116),('node','product',0,97,97,'und',0,117),('node','banner',0,135,135,'und',0,13),('node','banner',0,136,136,'und',0,96),('node','banner',0,137,137,'und',0,102),('node','product',0,138,138,'und',0,118),('node','product',0,139,139,'und',0,119);
/*!40000 ALTER TABLE `field_revision_field_brand` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_category`
--

DROP TABLE IF EXISTS `field_revision_field_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_category` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_category_tid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_category_tid` (`field_category_tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 18 (field_category)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_category`
--

LOCK TABLES `field_revision_field_category` WRITE;
/*!40000 ALTER TABLE `field_revision_field_category` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_category` VALUES ('node','product',0,30,30,'und',0,77),('node','product',0,31,31,'und',0,77),('node','product',0,32,32,'und',0,66),('node','product',0,33,33,'und',0,66),('node','product',0,34,34,'und',0,67),('node','product',0,35,35,'und',0,67),('node','product',0,36,36,'und',0,68),('node','product',0,37,37,'und',0,68),('node','product',0,38,38,'und',0,71),('node','product',0,39,39,'und',0,71),('node','product',0,40,40,'und',0,70),('node','product',0,41,41,'und',0,70),('node','product',0,42,42,'und',0,72),('node','product',0,43,43,'und',0,72),('node','product',0,44,44,'und',0,28),('node','product',0,45,45,'und',0,28),('node','product',0,46,46,'und',0,41),('node','product',0,47,47,'und',0,29),('node','product',0,48,48,'und',0,29),('node','product',0,49,49,'und',0,31),('node','product',0,50,50,'und',0,31),('node','product',0,51,51,'und',0,32),('node','product',0,52,52,'und',0,32),('node','product',0,53,53,'und',0,34),('node','product',0,54,54,'und',0,34),('node','product',0,55,55,'und',0,35),('node','product',0,56,56,'und',0,35),('node','product',0,57,57,'und',0,39),('node','product',0,58,58,'und',0,39),('node','product',0,59,59,'und',0,38),('node','product',0,60,60,'und',0,38),('node','product',0,61,61,'und',0,53),('node','product',0,62,62,'und',0,53),('node','product',0,63,63,'und',0,48),('node','product',0,64,64,'und',0,48),('node','product',0,65,65,'und',0,49),('node','product',0,66,66,'und',0,49),('node','product',0,67,67,'und',0,51),('node','product',0,68,68,'und',0,51),('node','product',0,69,69,'und',0,52),('node','product',0,70,70,'und',0,52),('node','product',0,71,71,'und',0,61),('node','product',0,72,72,'und',0,61),('node','product',0,73,73,'und',0,63),('node','product',0,74,74,'und',0,63),('node','product',0,75,75,'und',0,64),('node','product',0,76,76,'und',0,64),('node','product',0,77,77,'und',0,41),('node','product',0,78,78,'und',0,44),('node','product',0,79,79,'und',0,44),('node','product',0,80,80,'und',0,45),('node','product',0,81,81,'und',0,45),('node','product',0,82,82,'und',0,42),('node','product',0,83,83,'und',0,42),('node','product',0,84,84,'und',0,17),('node','product',0,85,85,'und',0,17),('node','product',0,86,86,'und',0,18),('node','banner',0,87,87,'und',0,71),('node','product',0,88,88,'und',0,18),('node','product',0,89,89,'und',0,25),('node','product',0,90,90,'und',0,25),('node','product',0,91,91,'und',0,26),('node','product',0,92,92,'und',0,22),('node','product',0,93,93,'und',0,22),('node','product',0,94,94,'und',0,23),('node','product',0,95,95,'und',0,58),('node','product',0,96,96,'und',0,59),('node','product',0,97,97,'und',0,57),('node','banner',0,98,98,'und',0,58),('node','banner',0,99,99,'und',0,59),('node','banner',0,100,100,'und',0,57),('node','banner',0,101,101,'und',0,77),('node','banner',0,102,102,'und',0,67),('node','banner',0,103,103,'und',0,68),('node','banner',0,104,104,'und',0,70),('node','banner',0,105,105,'und',0,72),('node','banner',0,106,106,'und',0,73),('node','banner',0,107,107,'und',0,29),('node','banner',0,108,108,'und',0,35),('node','banner',0,109,109,'und',0,34),('node','banner',0,110,110,'und',0,28),('node','banner',0,111,111,'und',0,31),('node','banner',0,112,112,'und',0,32),('node','banner',0,113,113,'und',0,39),('node','banner',0,114,114,'und',0,38),('node','banner',0,115,115,'und',0,53),('node','banner',0,116,116,'und',0,48),('node','banner',0,117,117,'und',0,49),('node','banner',0,118,118,'und',0,51),('node','banner',0,119,119,'und',0,52),('node','banner',0,120,120,'und',0,61),('node','banner',0,121,121,'und',0,63),('node','banner',0,122,122,'und',0,64),('node','banner',0,123,123,'und',0,40),('node','banner',0,124,124,'und',0,41),('node','banner',0,125,125,'und',0,44),('node','banner',0,126,126,'und',0,45),('node','banner',0,127,127,'und',0,42),('node','banner',0,128,128,'und',0,17),('node','banner',0,129,129,'und',0,18),('node','banner',0,130,130,'und',0,26),('node','banner',0,131,131,'und',0,25),('node','banner',0,132,132,'und',0,22),('node','banner',0,133,133,'und',0,23),('node','banner',0,134,134,'und',0,66),('node','product',0,138,138,'und',0,73),('node','product',0,139,139,'und',0,73),('node','banner',0,140,140,'und',0,26);
/*!40000 ALTER TABLE `field_revision_field_category` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_colllect_title`
--

DROP TABLE IF EXISTS `field_revision_field_colllect_title`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_colllect_title` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_colllect_title_value` varchar(255) DEFAULT NULL,
  `field_colllect_title_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_colllect_title_format` (`field_colllect_title_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 36 (field_colllect_title)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_colllect_title`
--

LOCK TABLES `field_revision_field_colllect_title` WRITE;
/*!40000 ALTER TABLE `field_revision_field_colllect_title` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_colllect_title` VALUES ('field_collection_item','field_specifications',0,7,7,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,8,8,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,9,9,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,14,14,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,15,15,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,16,16,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,17,17,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,18,18,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,19,19,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,20,20,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,21,21,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,26,26,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,27,27,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,28,28,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,29,29,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,30,30,'und',0,'Material',NULL),('field_collection_item','field_specifications',0,33,33,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,34,34,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,35,35,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,36,36,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,37,37,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,38,38,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,39,39,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,40,40,'und',0,'Warranty Period',NULL),('field_collection_item','field_specifications',0,41,41,'und',0,'Warranty Type',NULL),('field_collection_item','field_specifications',0,42,42,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,43,43,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,44,44,'und',0,'Weight ',NULL),('field_collection_item','field_specifications',0,45,45,'und',0,'Warranty Period',NULL),('field_collection_item','field_specifications',0,47,47,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,48,48,'und',0,'Mode',NULL),('field_collection_item','field_specifications',0,49,49,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,50,50,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,54,54,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,55,55,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,56,56,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,57,57,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,58,58,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,59,59,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,60,60,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,61,61,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,64,64,'und',0,'Author',NULL),('field_collection_item','field_specifications',0,66,66,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,67,67,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,68,68,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,69,69,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,70,70,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,71,71,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,72,72,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,75,75,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,76,76,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,77,77,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,78,78,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,79,79,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,80,80,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,81,81,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,85,85,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,86,86,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,87,87,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,92,92,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,93,93,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,94,94,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,95,95,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,101,101,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,102,102,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,103,103,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,110,110,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,111,111,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,112,112,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,113,113,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,114,114,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,124,124,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,125,125,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,126,126,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,127,127,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,128,128,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,129,129,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,130,130,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,143,143,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,144,144,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,145,145,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,150,150,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,151,151,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,152,152,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,153,153,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,155,155,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,156,156,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,157,157,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,160,160,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,161,161,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,162,162,'und',0,'Warranty Period',NULL),('field_collection_item','field_specifications',0,163,163,'und',0,'Warranty Type',NULL),('field_collection_item','field_specifications',0,164,164,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,165,165,'und',0,'Product Line',NULL),('field_collection_item','field_specifications',0,166,166,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,167,167,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,168,168,'und',0,'Color',NULL),('field_collection_item','field_specifications',0,169,169,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,170,170,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,171,171,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,175,175,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,176,176,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,177,177,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,178,178,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,179,179,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,180,180,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,181,181,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,182,182,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,183,183,'und',0,'Compatible Phones',NULL),('field_collection_item','field_specifications',0,184,184,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,185,185,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,186,186,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,187,187,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,188,188,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,189,189,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,190,190,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,191,191,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,192,192,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,193,193,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,194,194,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,195,195,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,196,196,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,197,197,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,198,198,'und',0,'Color',NULL),('field_collection_item','field_specifications',0,199,199,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,200,200,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,201,201,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,202,202,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,203,203,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,204,204,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,205,205,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,206,206,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,207,207,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,208,208,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,209,209,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,210,210,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,211,211,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,212,212,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,213,213,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,214,214,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,215,215,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,216,216,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,217,217,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,218,218,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,219,219,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,220,220,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,221,221,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,222,222,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,223,223,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,224,224,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,225,225,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,226,226,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,227,227,'und',0,'Compatible Phones',NULL),('field_collection_item','field_specifications',0,228,228,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,229,229,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,230,230,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,234,234,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,235,235,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,236,236,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,237,237,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,238,238,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,239,239,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,240,240,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,241,241,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,242,242,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,243,243,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,244,244,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,245,245,'und',0,'Network',NULL),('field_collection_item','field_specifications',0,246,246,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,247,247,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,248,248,'und',0,'Uses & Properties',NULL),('field_collection_item','field_specifications',0,249,249,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,250,250,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,251,251,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,252,252,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,253,253,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,254,254,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,255,255,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,256,256,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,257,257,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,258,258,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,259,259,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,260,260,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,261,261,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,262,262,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,263,263,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,267,267,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,268,268,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,269,269,'und',0,'Display Size (inch)',NULL),('field_collection_item','field_specifications',0,270,270,'und',0,'Megapixels',NULL),('field_collection_item','field_specifications',0,271,271,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,272,272,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,273,273,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,274,274,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,275,275,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,276,276,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,277,277,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,278,278,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,279,279,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,280,280,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,281,281,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,282,282,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,283,283,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,284,284,'und',0,'Model',NULL),('field_collection_item','field_specifications',0,285,285,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,286,286,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,287,287,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,288,288,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,289,289,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,290,290,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,291,291,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,292,292,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,293,293,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,294,294,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,295,295,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,296,296,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,297,297,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,298,298,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,299,299,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,300,300,'und',0,'Weight',NULL),('field_collection_item','field_specifications',0,301,301,'und',0,'SKU',NULL),('field_collection_item','field_specifications',0,302,302,'und',0,'Size (L x W x H)',NULL),('field_collection_item','field_specifications',0,303,303,'und',0,'Weight',NULL);
/*!40000 ALTER TABLE `field_revision_field_colllect_title` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_color`
--

DROP TABLE IF EXISTS `field_revision_field_color`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_color` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_color_value` varchar(255) DEFAULT NULL,
  `field_color_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_color_format` (`field_color_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 50 (field_color)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_color`
--

LOCK TABLES `field_revision_field_color` WRITE;
/*!40000 ALTER TABLE `field_revision_field_color` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_color` VALUES ('taxonomy_term','color',0,104,104,'und',0,'#000000',NULL),('taxonomy_term','color',0,105,105,'und',0,'#ffffff',NULL),('taxonomy_term','color',0,106,106,'und',0,'#000099',NULL),('taxonomy_term','color',0,107,107,'und',0,'#cd0000',NULL),('taxonomy_term','color',0,108,108,'und',0,'#ff8d00',NULL),('taxonomy_term','color',0,109,109,'und',0,'#ffc0cb',NULL),('taxonomy_term','color',0,110,110,'und',0,'#00ff00',NULL);
/*!40000 ALTER TABLE `field_revision_field_color` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_description`
--

DROP TABLE IF EXISTS `field_revision_field_description`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_description` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_description_value` longtext,
  `field_description_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_description_format` (`field_description_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 49 (field_description)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_description`
--

LOCK TABLES `field_revision_field_description` WRITE;
/*!40000 ALTER TABLE `field_revision_field_description` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_description` VALUES ('field_collection_item','field_specifications',0,7,7,'und',0,'<p>AE217FAAPMF5ANMY-727141</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,8,8,'und',0,'<p>31 x 18 x 51</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,9,9,'und',0,'<table class=\"prd-attributes ui-grid ui-gridFull\">\r\n	<tbody>\r\n		<tr>\r\n			<td>0.8</td>\r\n		</tr>\r\n	</tbody>\r\n</table>\r\n','filtered_html'),('field_collection_item','field_specifications',0,14,14,'und',0,'<p>LO024FAAKSJ4ANMY-530660</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,15,15,'und',0,'<p>B0008 Orange</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,16,16,'und',0,'<p>52x18x33</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,17,17,'und',0,'<p>0.9</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,18,18,'und',0,'<p>TE960FAAKJC3ANMY-515575</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,19,19,'und',0,'<p>T02-297LAP-01</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,20,20,'und',0,'<p>33x15x40</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,21,21,'und',0,'<p>0.50</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,26,26,'und',0,'<p>TA452FAAL25AANMY-544771</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,27,27,'und',0,'<p>Targus-TSB166AP-50-BK</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,28,28,'und',0,'<p>37.46 x 26.03 x 3.88</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,29,29,'und',0,'<p>1.63kg</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,30,30,'und',0,'<p>Polyester</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,33,33,'und',0,'<p>TA073FAAQQFQANMY-793372</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,34,34,'und',0,'<p>9\" x 13.5\" x 4.5\"</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,35,35,'und',0,'<p>0.4</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,36,36,'und',0,'<div>DI503FAAP8LHANMY-703741</div>\r\n','filtered_html'),('field_collection_item','field_specifications',0,37,37,'und',0,'<p>B0077-3</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,38,38,'und',0,'<p>12 x 21.5 x 29</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,39,39,'und',0,'<p>0.26</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,40,40,'und',0,'<p>1 Month</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,41,41,'und',0,'<p>Local Supplier Warranty</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,42,42,'und',0,'<p>OE702HBAMQYBANMY-647350</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,43,43,'und',0,'<p>18 x 10 x 5</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,44,44,'und',0,'<p>3 Months</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,45,45,'und',0,'<p>Local Supplier Warranty</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,47,47,'und',0,'<p>CA065HBAS3UKANMY-866687</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,48,48,'und',0,'<p>MakeUp Kit 396 (48x Eyeshadow, 24x Lip Color, 2x Pressed Powder, 4x Blusher, 5x Applicator)</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,49,49,'und',0,'<p>10x10x10</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,50,50,'und',0,'<p>0.4</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,54,54,'und',0,'<p>OE702HBAT78LANMY-922903</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,55,55,'und',0,'<p>Power Perfect Pore</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,56,56,'und',0,'<p>16 x 13 x 8</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,57,57,'und',0,'<p>0.2</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,58,58,'und',0,'<p>SK159HBASXK7ANMY-908752</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,59,59,'und',0,'<p>SK222HBAQYN8ANMY-807324</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,60,60,'und',0,'<p>12 x 17 x 23</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,61,61,'und',0,'<p>1</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,64,64,'und',0,'<p>www.skinblossom.com.my</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,66,66,'und',0,'<p>ME223HBAT7XUANMY-924008</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,67,67,'und',0,'<p>15x15x15</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,68,68,'und',0,'<p>0.5</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,69,69,'und',0,'<p>HA181HBASX9JANMY-908363</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,70,70,'und',0,'<p>(AUS) 5000</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,71,71,'und',0,'<p>23 x 9 x 23</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,72,72,'und',0,'<p>1</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,75,75,'und',0,'<p>OE702HBAST9QANMY-901982</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,76,76,'und',0,'<p>Tonific Slimming Massager</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,77,77,'und',0,'<p>26 x 11 x 18</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,78,78,'und',0,'<p>1</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,79,79,'und',0,'<p>AP564ELAPUHIANMY-741814</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,80,80,'und',0,'<p>IPHONE6</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,81,81,'und',0,'<p>8x4x3</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,85,85,'und',0,'<p>SA356ELAQRCJANMY-794737</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,86,86,'und',0,'<p>N910</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,87,87,'und',0,'<p>8 x 4 x 1</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,92,92,'und',0,'<p>AS575ELAT5HFANMY-920560</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,93,93,'und',0,'<p>P1801-B041K , F9-ASURTN56U</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,94,94,'und',0,'<p>40x45x30</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,95,95,'und',0,'<p>3</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,101,101,'und',0,'<p>LE106ELAT4HKANMY-918581</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,102,102,'und',0,'<p>A316</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,103,103,'und',0,'<p>7x2x12</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,110,110,'und',0,'<p>NO225ELAK8TTANMY-497673</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,111,111,'und',0,'<p>AP564ELAPEZNANMY-715186</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,112,112,'und',0,'<p>MD368</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,113,113,'und',0,'<p>17 x 22 x 2</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,114,114,'und',0,'<p>0.2</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,124,124,'und',0,'<p>OE702ELAS5KHANMY-868993</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,125,125,'und',0,'<p>12 x 1 x 19.7</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,126,126,'und',0,'<p>0.1</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,127,127,'und',0,'<p>LE106ELASXT7ANMY-909117</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,128,128,'und',0,'<p>Miix 2 59399848</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,129,129,'und',0,'<p>13.2 x 0.7 x 21.6</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,130,130,'und',0,'<p>0.35</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,143,143,'und',0,'<p>AP564ELAT12EANMY-913520</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,144,144,'und',0,'<p>MD785ZPA</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,145,145,'und',0,'<p>24 x 16.95 x 0.75</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,150,150,'und',0,'<p>SP889ELASU66ANMY-903500</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,151,151,'und',0,'<p>Samsung Galaxy Note 4</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,152,152,'und',0,'<p>16 x 8.5 x 1</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,153,153,'und',0,'<p>0.08</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,155,155,'und',0,'<p>SA356ELAT7YMANMY-924036</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,156,156,'und',0,'<p>8.16 x 1.33 x 15.46</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,157,157,'und',0,'<p>63g</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,160,160,'und',0,'<p>OE702ELAK0U8ANMY-486129</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,161,161,'und',0,'<p>Samsung Galaxy Tab 7.0 Plus Vehicle Dock With In-Car Charger</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,162,162,'und',0,'<p>6 Months</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,163,163,'und',0,'<p>Local Supplier Warranty</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,164,164,'und',0,'<p>OT343ELAM59DANMY-609257</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,165,165,'und',0,'<p>Car Accessories</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,166,166,'und',0,'<p>P338</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,167,167,'und',0,'<p>0.1kg</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,168,168,'und',0,'<p>Black</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,169,169,'und',0,'<p>AP564ELALLJMANMY-575572</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,170,170,'und',0,'<p>6x2x6</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,171,171,'und',0,'<p>15g</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,175,175,'und',0,'<p>SO406ELAKPRJANMY-525732</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,176,176,'und',0,'<p>SBH20</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,177,177,'und',0,'<p>13x10x4.5</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,178,178,'und',0,'<p>OE702ELASS8BANMY-900509</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,179,179,'und',0,'<p>5x3.5x2.5</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,180,180,'und',0,'<p>0.5</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,181,181,'und',0,'<p>OE702EL51SMMANMY-130613</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,182,182,'und',0,'<p>13.5 x 7.0 x 2.2cm</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,183,183,'und',0,'<p>Nokia|Apple|LG|Samsung|Blackberry</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,184,184,'und',0,'<p>MU553FAARFDMANMY-830725</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,185,185,'und',0,'<p>Everlasting Love Set</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,186,186,'und',0,'<p>42 x 2 x 1</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,187,187,'und',0,'<p>LU757FAAT3KBANMY-916954</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,188,188,'und',0,'<p>43cm x 7cm extender chain</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,189,189,'und',0,'<p>0.2</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,190,190,'und',0,'<p>DA883FAAL9R7ANMY-556875</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,191,191,'und',0,'<p>2605-0005-99127-17 White</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,192,192,'und',0,'<p>110L x 2W x 0.3H cm</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,193,193,'und',0,'<p>DA883FAAL9QSANMY-556860</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,194,194,'und',0,'<p>2601-0337-99138-5 Orange</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,195,195,'und',0,'<p>110L x 2W x 0.3H cm</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,196,196,'und',0,'<p>FU022FAALCH2ANMY-561503</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,197,197,'und',0,'<p>0.18 kg</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,198,198,'und',0,'<p>Yellow Brown</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,199,199,'und',0,'<p>FU022FAAL7JTANMY-553296</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,200,200,'und',0,'<p>FS0005/white White</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,201,201,'und',0,'<p>90 x 180</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,202,202,'und',0,'<p>IN656FAAS6G7ANMY-870227</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,203,203,'und',0,'<p>15422</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,204,204,'und',0,'<p>12x12x12</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,205,205,'und',0,'<p>RO180FAASX6RANMY-908233</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,206,206,'und',0,'<p>114060</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,207,207,'und',0,'<p>15cm x 17cm x 13cm</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,208,208,'und',0,'<p>SU433FAASXLFANMY-908796</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,209,209,'und',0,'<p>SUSS010600610</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,210,210,'und',0,'<p>5.14 x 4.56 x 1.53</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,211,211,'und',0,'<p>OE702FAASHKNANMY-885439</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,212,212,'und',0,'<p>955</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,213,213,'und',0,'<p>25 cm x 5.2 cm x 1.5 cm</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,214,214,'und',0,'<p>SA356ELAROW3ANMY-844449</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,215,215,'und',0,'<p>UA40H5008ARXXM</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,216,216,'und',0,'<p>9.1x90.5x56.2</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,217,217,'und',0,'<p>SO406ELAMA8AANMY-618653</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,218,218,'und',0,'<p>19.6x108.6x67.4</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,219,219,'und',0,'<p>9.10</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,220,220,'und',0,'<p>SO406ELAO9YXANMY-651058</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,221,221,'und',0,'<p>BDV-N9200W</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,222,222,'und',0,'<p>SA356ELAOL1VANMY-666683</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,223,223,'und',0,'<p>HTE350K</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,224,224,'und',0,'<p>Main 43 x 5.6 x 25</p>\r\n\r\n<p>Front Speaker 7.7 x 10.7 x 6.8</p>\r\n\r\n<p>Center Speaker 22.8 x 7.7 x 7</p>\r\n\r\n<p>Surround Speaker 7.7 x 10.7 x 6.8</p>\r\n\r\n<p>Sub Woofer 15.5 x 30 x 28.5</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,225,225,'und',0,'<p>OE702ELAMNJ0ANMY-642088</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,226,226,'und',0,'<p>L12S</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,227,227,'und',0,'<p>Apple | LG | Samsung | HTC</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,228,228,'und',0,'<p>AP564ELALVSWANMY-592956</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,229,229,'und',0,'<p>23 mm x 98 mm x 98 mm</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,230,230,'und',0,'<p>0.27 kg</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,234,234,'und',0,'<p>DE759ELAT5R5ANMY-920910</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,235,235,'und',0,'<p>X51-77822G</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,236,236,'und',0,'<p>6kg</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,237,237,'und',0,'<p>OE702ELAKQT4ANMY-527371</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,238,238,'und',0,'<p>HDMI/3P</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,239,239,'und',0,'<p>3x14x15</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,240,240,'und',0,'<table class=\"prd-attributes ui-grid ui-gridFull\">\r\n	<tbody>\r\n		<tr>\r\n			<td>\r\n			<div>DE759ELAP5I7ANMY-696915</div>\r\n			</td>\r\n		</tr>\r\n	</tbody>\r\n</table>\r\n','filtered_html'),('field_collection_item','field_specifications',0,241,241,'und',0,'<p>5524P 24</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,242,242,'und',0,'<p>38.1 x 44.0 x 4.32cm</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,243,243,'und',0,'<p>TP481ELAKVC0ANMY-535125</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,244,244,'und',0,'<p>TL-M5250</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,245,245,'und',0,'<p>HSPA+</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,246,246,'und',0,'<p>TP481ELAJQBOANMY-468439</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,247,247,'und',0,'<p>TL-WDR4300</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,248,248,'und',0,'<p>4 x 10/100/1000Mbps LAN Ports<br />\r\n1 x 10/100/1000Mbps WAN Port<br />\r\n2 x USB 2.0 Port<br />\r\nCertification: CE, FCC,IC, RoHS<br />\r\nFrequency: 2.4GHz &amp; 5GHz</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,249,249,'und',0,'<p>CA673ELAM9XUANMY-618219</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,250,250,'und',0,'<p>LiDE 210</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,251,251,'und',0,'<p>36.5 x 25 x 3.9</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,252,252,'und',0,'<p>EP840ELALTF7ANMY-589363</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,253,253,'und',0,'<p>V33</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,254,254,'und',0,'<p>43 x 28 x 3</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,255,255,'und',0,'<div>CA680ELAPVLXANMY-743566</div>\r\n','filtered_html'),('field_collection_item','field_specifications',0,256,256,'und',0,'<p>EX-ZR1500</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,257,257,'und',0,'<p>107.5(W) x 61.5(H) x 36.7(D) mm</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,258,258,'und',0,'<p>CA673ELARXO5ANMY-857455</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,259,259,'und',0,'<p>SX60 HS</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,260,260,'und',0,'<p>12.76 x 9.26 x 11.43</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,261,261,'und',0,'<p>CA673ELALORHANMY-581181</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,262,262,'und',0,'<p>EOS 600D</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,263,263,'und',0,'<p>5x5x5</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,267,267,'und',0,'<p>SA356ELAOVYAANMY-683458</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,268,268,'und',0,'<p>NXF1</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,269,269,'und',0,'<p>3.0</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,270,270,'und',0,'<p>20.5</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,271,271,'und',0,'<p>NI220ELAO90EANMY-649565</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,272,272,'und',0,'<p>7.11 D x 5.33</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,273,273,'und',0,'<p>0.187kg</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,274,274,'und',0,'<div>CA673ELATEX3ANMY-936277</div>\r\n','filtered_html'),('field_collection_item','field_specifications',0,275,275,'und',0,'<p>20 x 30 x 10</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,276,276,'und',0,'<p>5</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,277,277,'und',0,'<p>CO716ELAPOWBANMY-731726</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,278,278,'und',0,'<p>17x15x10</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,279,279,'und',0,'<p>1</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,280,280,'und',0,'<p>DL746ELAOZRFANMY-689095</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,281,281,'und',0,'<p>11.4x11.4x12.5</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,282,282,'und',0,'<p>0.54</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,283,283,'und',0,'<p>SC910ELAPTXIANMY-740946</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,284,284,'und',0,'<p>ST-D403</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,285,285,'und',0,'<p>9 x 10 x 8</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,286,286,'und',0,'<div>TR626ELAMPM1ANMY-645445</div>\r\n','filtered_html'),('field_collection_item','field_specifications',0,287,287,'und',0,'<p>13 x 11.5 x 16.5</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,288,288,'und',0,'<p>0.3</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,289,289,'und',0,'<p>CT941TBAM1QDANMY-602711</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,290,290,'und',0,'<p>25x23x19</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,291,291,'und',0,'<p>0.10</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,292,292,'und',0,'<p>BO242TBAPSO5ANMY-738496</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,293,293,'und',0,'<p>22.3 x 14.2 x 0.3</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,294,294,'und',0,'<p>0.119</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,295,295,'und',0,'<p>CH299TBAS06ZANMY-861162</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,296,296,'und',0,'<p>75 x 31.5 x 10.5</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,297,297,'und',0,'<p>2.6</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,298,298,'und',0,'<p>KI236HBAP7FZANMY-699829</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,299,299,'und',0,'<p>20x20x20</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,300,300,'und',0,'<p>0.1</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,301,301,'und',0,'<p>TK512SPALA1FANMY-557274</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,302,302,'und',0,'<p>9 x 10 x 9</p>\r\n','filtered_html'),('field_collection_item','field_specifications',0,303,303,'und',0,'<p>0.38 kg</p>\r\n','filtered_html');
/*!40000 ALTER TABLE `field_revision_field_description` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_discount_percentage`
--

DROP TABLE IF EXISTS `field_revision_field_discount_percentage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_discount_percentage` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_discount_percentage_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 59 (field_discount...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_discount_percentage`
--

LOCK TABLES `field_revision_field_discount_percentage` WRITE;
/*!40000 ALTER TABLE `field_revision_field_discount_percentage` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_discount_percentage` VALUES ('commerce_product','product',0,6,83,'und',0,20.00),('commerce_product','product',0,9,84,'und',0,51.90),('commerce_product','product',0,10,85,'und',0,51.90),('commerce_product','product',0,10,86,'und',0,51.90),('commerce_product','product',0,11,18,'und',0,44.69),('commerce_product','product',0,11,125,'und',0,44.69),('commerce_product','product',0,12,19,'und',0,44.69),('commerce_product','product',0,13,20,'und',0,44.69),('commerce_product','product',0,14,21,'und',0,44.69),('commerce_product','product',0,15,22,'und',0,11.71),('commerce_product','product',0,16,23,'und',0,23.92),('commerce_product','product',0,18,25,'und',0,58.59),('commerce_product','product',0,19,96,'und',0,78.39),('commerce_product','product',0,21,118,'und',0,88.18),('commerce_product','product',0,22,97,'und',0,20.40),('commerce_product','product',0,23,98,'und',0,10.08),('commerce_product','product',0,24,99,'und',0,10.85),('commerce_product','product',0,25,100,'und',0,37.89),('commerce_product','product',0,26,92,'und',0,50.83),('commerce_product','product',0,30,102,'und',0,20.40),('commerce_product','product',0,31,91,'und',0,30.00),('commerce_product','product',0,32,90,'und',0,16.67),('commerce_product','product',0,33,103,'und',0,22.44),('commerce_product','product',0,34,41,'und',0,14.33),('commerce_product','product',0,35,42,'und',0,20.03),('commerce_product','product',0,36,104,'und',0,30.30),('commerce_product','product',0,38,105,'und',0,21.01),('commerce_product','product',0,39,106,'und',0,25.64),('commerce_product','product',0,40,107,'und',0,24.24),('commerce_product','product',0,41,87,'und',0,6.71),('commerce_product','product',0,41,89,'und',0,6.71),('commerce_product','product',0,42,88,'und',0,6.71),('commerce_product','product',0,43,108,'und',0,60.61),('commerce_product','product',0,44,109,'und',0,89.22),('commerce_product','product',0,45,110,'und',0,69.50),('commerce_product','product',0,49,112,'und',0,12.50),('commerce_product','product',0,50,113,'und',0,21.05),('commerce_product','product',0,51,114,'und',0,50.06),('commerce_product','product',0,52,115,'und',0,23.02),('commerce_product','product',0,53,116,'und',0,10.01),('commerce_product','product',0,54,117,'und',0,15.00),('commerce_product','product',0,55,119,'und',0,20.01),('commerce_product','product',0,56,120,'und',0,32.14),('commerce_product','product',0,57,121,'und',0,13.34),('commerce_product','product',0,58,122,'und',0,38.40),('commerce_product','product',0,59,123,'und',0,40.13),('commerce_product','product',0,60,124,'und',0,4.90),('commerce_product','product',0,61,68,'und',0,23.02),('commerce_product','product',0,62,69,'und',0,35.29),('commerce_product','product',0,63,70,'und',0,18.76),('commerce_product','product',0,64,71,'und',0,14.71),('commerce_product','product',0,66,95,'und',0,16.69),('commerce_product','product',0,67,94,'und',0,5.51),('commerce_product','product',0,68,93,'und',0,25.03),('commerce_product','product',0,69,76,'und',0,23.09),('commerce_product','product',0,71,126,'und',0,31.13),('commerce_product','product',0,72,127,'und',0,37.34),('commerce_product','product',0,73,128,'und',0,11.12),('commerce_product','product',0,74,129,'und',0,0.00),('commerce_product','product',0,75,130,'und',0,45.39),('commerce_product','product',0,75,135,'und',0,45.39),('commerce_product','product',0,75,139,'und',0,45.39),('commerce_product','product',0,75,140,'und',0,45.39),('commerce_product','product',0,75,142,'und',0,45.39),('commerce_product','product',0,78,134,'und',0,67.10),('commerce_product','product',0,80,141,'und',0,33.86),('commerce_product','product',0,81,144,'und',0,12.75);
/*!40000 ALTER TABLE `field_revision_field_discount_percentage` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_image`
--

DROP TABLE IF EXISTS `field_revision_field_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_image` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_image_fid` int(10) unsigned DEFAULT NULL COMMENT 'The file_managed.fid being referenced in this field.',
  `field_image_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image’s ’alt’ attribute.',
  `field_image_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image’s ’title’ attribute.',
  `field_image_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',
  `field_image_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_image_fid` (`field_image_fid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 4 (field_image)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_image`
--

LOCK TABLES `field_revision_field_image` WRITE;
/*!40000 ALTER TABLE `field_revision_field_image` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_image` VALUES ('node','banner',0,7,7,'und',0,297,'Christmas offers','Christmas offers',570,380),('node','banner',0,8,8,'und',0,202,'Hot pick','Hot pick',570,380),('node','banner',0,11,11,'und',0,63,'Feature FireTv','Feature FireTv',270,150),('node','banner',0,12,12,'und',0,61,'Driver Smarter','Driver Smarter',270,150),('node','banner',0,13,13,'und',0,60,'The Living Room','The Living Room',270,150),('node','banner',0,14,14,'und',0,62,'Get 20% off instantly','Get 20% off instantly',270,120),('node','banner',0,87,87,'und',0,282,'Face Care','Face Care',553,306),('node','banner',0,98,98,'und',0,238,'Educational Toys','Educational Toys',553,306),('node','banner',0,99,99,'und',0,236,'Books & Stationery','Books & Stationery',555,307),('node','banner',0,100,100,'und',0,237,'Health & Safety','Health & Safety',555,307),('node','banner',0,101,101,'und',0,239,'Backpacks','Backpacks',553,306),('node','banner',0,102,102,'und',0,240,'','',553,306),('node','banner',0,103,103,'und',0,241,'Makeup','Makeup',553,306),('node','banner',0,104,104,'und',0,242,'Eye Care','Eye Care',553,306),('node','banner',0,105,105,'und',0,243,'Health & Beauty Tools','Health & Beauty Tools',553,306),('node','banner',0,106,106,'und',0,244,'Food Supplements','Food Supplements',553,306),('node','banner',0,107,107,'und',0,245,'Basic Phones','Basic Phones',553,306),('node','banner',0,108,108,'und',0,246,'Car Accessories','Car Accessories',553,306),('node','banner',0,109,109,'und',0,283,'Cases & Covers','Cases & Covers',553,306),('node','banner',0,110,110,'und',0,250,'Smartphones','Smartphones',553,306),('node','banner',0,111,111,'und',0,251,'With call facility','With call facility',553,306),('node','banner',0,112,112,'und',0,252,'Without call facility','Without call facility',553,306),('node','banner',0,113,113,'und',0,284,'Headphones','Headphones',553,306),('node','banner',0,114,114,'und',0,254,'Batteries & Chargers','Batteries & Chargers',553,306),('node','banner',0,115,115,'und',0,261,'Women\'s Jewellery','Women\'s Jewellery',553,306),('node','banner',0,116,116,'und',0,262,'Belts','Belts',553,306),('node','banner',0,117,117,'und',0,263,'Scarves','Scarves',553,306),('node','banner',0,118,118,'und',0,264,'Business','Business',553,306),('node','banner',0,119,119,'und',0,265,'Sports','Sports',553,306),('node','banner',0,120,120,'und',0,266,'Televisions','Televisions',553,306),('node','banner',0,121,121,'und',0,267,'Home Audio','Home Audio',553,306),('node','banner',0,122,122,'und',0,269,'Gadgets','Gadgets',553,306),('node','banner',0,123,123,'und',0,270,'Laptops','Laptops',553,306),('node','banner',0,124,124,'und',0,271,'Desktop','Desktop',553,306),('node','banner',0,125,125,'und',0,272,'Switches','Switches',553,306),('node','banner',0,126,126,'und',0,273,'Routers','Routers',553,306),('node','banner',0,127,127,'und',0,274,'Scanners','Scanners',553,306),('node','banner',0,128,128,'und',0,275,'Point & Shoot Cameras','Point & Shoot Cameras',553,306),('node','banner',0,129,129,'und',0,276,'DSLR/SLR Cameras','DSLR/SLR Cameras',553,306),('node','banner',0,130,130,'und',0,277,'Filters','Filters',553,306),('node','banner',0,131,131,'und',0,278,'Lenses','Lenses',553,306),('node','banner',0,132,132,'und',0,279,'IP Cameras','IP Cameras',553,306),('node','banner',0,133,133,'und',0,280,'Car Cameras','Car Cameras',553,306),('node','banner',0,134,134,'und',0,281,'Laptop Bags & Cases','Laptop Bags & Cases',553,306),('node','banner',0,135,135,'und',0,285,'Asus','Asus',553,306),('node','banner',0,136,136,'und',0,286,'Rolex','Rolex',553,306),('node','banner',0,137,137,'und',0,295,'Canon','Canon',555,308),('node','banner',0,140,140,'und',0,294,'Filters','Filters',555,308),('node','banner',0,142,142,'und',0,296,'Black Friday','Black Friday',570,380),('taxonomy_term','brands',0,10,10,'und',0,53,'','',180,85),('taxonomy_term','brands',0,12,12,'und',0,55,'','',180,85),('taxonomy_term','brands',0,13,13,'und',0,54,'','',180,85);
/*!40000 ALTER TABLE `field_revision_field_image` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_link`
--

DROP TABLE IF EXISTS `field_revision_field_link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_link` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_link_url` varchar(2048) DEFAULT NULL,
  `field_link_title` varchar(255) DEFAULT NULL,
  `field_link_attributes` mediumtext,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 15 (field_link)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_link`
--

LOCK TABLES `field_revision_field_link` WRITE;
/*!40000 ALTER TABLE `field_revision_field_link` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_link` VALUES ('node','banner',0,7,7,'und',0,'product/terminus-t02-297lap-01-laptop-backpack-plus-32','BlueAnt PUMP HD Wireless Bluetooth Waterproof Headphones','a:0:{}'),('node','banner',0,8,8,'und',0,'product/terminus-t02-297lap-01-laptop-backpack-plus-32','Terminus T02-297LAP-01 Laptop Backpack Plus','a:0:{}'),('node','banner',0,11,11,'und',0,'product/targus-tsb166ap-156in-revolution-backpack-xl-33','Feature FireTv','a:0:{}'),('node','banner',0,12,12,'und',0,'product/local-lion-water-resistant-hiking-backpack-bag-28l-31','Driver Smarter','a:0:{}'),('node','banner',0,13,13,'und',0,'product/tarantula-shoe-bag-bos04-088shb-03-red-34','Halloween Shop','a:0:{}'),('node','banner',0,14,14,'und',0,'get-20-instantly-0','Get 20% off instantly','a:0:{}'),('node','banner',0,87,87,'und',0,'product/sk-ii-5-piece-skincare-travel-set-5pcs-travel-packs-skii-sk2-39','SK-II 5-Piece Skincare Travel Set 5pcs Travel Packs SKII SK2','a:0:{}'),('node','banner',0,98,98,'und',0,'product/mini-quran-kids-yellow-95','Mini Quran for Kids Yellow','a:0:{}'),('node','banner',0,99,99,'und',0,'product/boogie-board-105-inch-lcd-writing-tablet-pink-96','Boogie Board 10.5 Inch LCD Writing Tablet Pink','a:0:{}'),('node','banner',0,100,100,'und',0,'product/transporter-carry-cot-97','Transporter Carry Cot','a:0:{}'),('node','banner',0,101,101,'und',0,'product/local-lion-water-resistant-hiking-backpack-bag-28l-blue-31','Local Lion Water Resistant Hiking Backpack Bag 28L Blue Local Lion Water Resistant Hiking Backpack Bag 28L Blue Local Lion Water','a:0:{}'),('node','banner',0,102,102,'und',0,'product/diniwell-water-resistant-travel-shoes-bag-pouch-organizer-bag-ver-2-orange-35','Diniwell Water-Resistant Travel Shoes Bag Pouch Organizer Bag Ver 2 - Orange','a:0:{}'),('node','banner',0,103,103,'und',0,'product/cameleon-makeup-kit-396-37','Cameleon MakeUp Kit 396','a:0:{}'),('node','banner',0,104,104,'und',0,'product/organic-eye-cream-15ml-40','Organic Eye Cream 15ml','a:0:{}'),('node','banner',0,105,105,'und',0,'hairscape-1800w-aus-5000-professional-hair-dryer-42','Hairscape 1800W (AUS) 5000 Professional Hair Dryer','a:0:{}'),('node','banner',0,106,106,'und',0,'mejikaliner-quick-eyelid-essence-stick-glue-night-use-41','Mejikaliner Quick Eyelid Essence Stick Glue - Night Use','a:0:{}'),('node','banner',0,107,107,'und',0,'product/lenovo-a316-47','Lenovo A316','a:0:{}'),('node','banner',0,108,108,'und',0,'product/angel-universal-mobile-phone-car-phone-holder-360-degree-item-code-p338-56','Angel Universal Mobile Phone In Car Phone Holder 360 degree Item Code: P338','a:0:{}'),('node','banner',0,109,109,'und',0,'product/galaxy-note-4-spigen-case-neo-hybrid-metal-gold-53','Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold','a:0:{}'),('node','banner',0,110,110,'und',0,'product/samsung-n910-note-4-lte-32gb-white-45','Samsung N910 Note 4 LTE 32GB White','a:0:{}'),('node','banner',0,111,111,'und',0,'product/asus-memopad-7-tablet-50','Asus Memopad 7 (Tablet)','a:0:{}'),('node','banner',0,112,112,'und',0,'product/lenovo-tablet-miix-2-59399848-8-silver-51','Lenovo Tablet Miix 2 59399848 8\" Silver','a:0:{}'),('node','banner',0,113,113,'und',0,'product/sony-stereo-bluetooth-headset-sbh20-black-58','Sony Stereo Bluetooth Headset SBH20 Black','a:0:{}'),('node','banner',0,114,114,'und',0,'product/top-mi-10400mah-powerbank-black-59','TOP Mi 10400mAh Powerbank - Black','a:0:{}'),('node','banner',0,115,115,'und',0,'product/muwo-trendz-swarovski-element-white-gold-plated-everlasting-love-set-61','MuWo Trendz Swarovski Element White Gold Plated Everlasting Love Set','a:0:{}'),('node','banner',0,116,116,'und',0,'product/dandelion-cross-stitch-belt-orange-64','Dandelion Cross Stitch Belt Orange','a:0:{}'),('node','banner',0,117,117,'und',0,'product/fur-nyce-fashion-zebra-pattern-print-scarf-white-66','Fur Nyce Fashion Zebra Pattern Print Scarf White','a:0:{}'),('node','banner',0,118,118,'und',0,'product/rolex-submariner-black-dial-stainless-steel-automatic-mens-watch-114060-68','Rolex Submariner Black Dial Stainless Steel Automatic Mens Watch 114060','a:0:{}'),('node','banner',0,119,119,'und',0,'product/suunto-vector-black-suss010600610-mountain-outdoor-watch-69','SUUNTO VECTOR BLACK SUSS010600610 MOUNTAIN OUTDOOR WATCH ','a:0:{}'),('node','banner',0,120,120,'und',0,'product/sony-48-full-hd-led-tv-bravia-model-kdl-48r470b-72','Sony 48\" Full HD LED TV - BRAVIA Model KDL-48R470B','a:0:{}'),('node','banner',0,121,121,'und',0,'product/samsung-ht-e350k-dvd-home-theater-system-74','Samsung HT-E350K DVD Home Theater System','a:0:{}'),('node','banner',0,122,122,'und',0,'product/l12s-oled-smart-watch-bluetooth-30-bracelet-wrist-design-ios-android-iphone-samsung-smart','L12S OLED Smart Watch Bluetooth 3.0 Bracelet Wrist Design for IOS Android iPhone Samsung Smart Phone Blue','a:0:{}'),('node','banner',0,123,123,'und',0,'product/apple-macbook-pro-me864-zpa-core-i5-133in-4gb-10','Apple Macbook Pro ME864 ZP/A – Core i5 / 13.3in / 4GB','a:0:{}'),('node','banner',0,124,124,'und',0,'product/asus-transformer-p1801-b041k-aio-184-pc-dekstop-asus-rt-n56u-wireless-n-n600-dual-band','Asus Transformer P1801-B041K AIO 18.4\" PC Dekstop + Asus RT-N56U Wireless N N600 Dual-Band Gigabit Router','a:0:{}'),('node','banner',0,125,125,'und',0,'product/dell-powerconnect-5524p-24-gbe-port-managed-l2-switch-poe-support-10gbe-and-stacking-capable','Dell PowerConnect 5524P 24 GbE Port Managed L2 Switch with PoE support 10GbE and Stacking Capable','a:0:{}'),('node','banner',0,126,126,'und',0,'product/tp-link-n750-wireless-dual-band-gigabit-router-tl-wdr4300-black-81','TP-LINK N750 Wireless Dual Band Gigabit Router TL-WDR4300 Black','a:0:{}'),('node','banner',0,127,127,'und',0,'product/canon-lide-210-scanner-82','Canon LiDE 210 Scanner','a:0:{}'),('node','banner',0,128,128,'und',0,'product/casio-exilim-ex-zr1500-digital-camera-pink-84','CASIO Exilim EX-ZR1500 Digital Camera Pink','a:0:{}'),('node','banner',0,129,129,'und',0,'product/canon-eos-600d-18mp-18-55mm-lens-86','Canon EOS 600D 18MP + 18-55mm Lens','a:0:{}'),('node','banner',0,130,130,'und',0,'product/cokin-u961a-z-pro-grad-kit-z-filter-holder-z121l-z123l-z125l-91','Cokin U961A Z Pro Grad Kit - Z Filter Holder + Z121L + Z123L + Z125L','a:0:{}'),('node','banner',0,131,131,'und',0,'product/canon-ef-s-lens-18-200mm-f35-56-90','Canon EF-S Lens 18-200mm f/3.5-5.6 IS','a:0:{}'),('node','banner',0,132,132,'und',0,'product/d-link-dcs-5222l-cloudcam-hd-wireless-n-pantilt-network-camera-92','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','a:0:{}'),('node','banner',0,133,133,'und',0,'product/trek-ai-ball-portable-wi-fi-remote-camera-cradle-adaptors-yellow-94','Trek Ai-Ball Portable Wi-Fi Remote Camera with Cradle & Adaptors (Yellow)','a:0:{}'),('node','banner',0,134,134,'und',0,'product/terminus-t02-297lap-01-laptop-backpack-plus-32','Terminus T02-297LAP-01 Laptop Backpack Plus','a:0:{}'),('node','banner',0,135,135,'und',0,'product/asus-memopad-7-tablet-50','Asus Memopad 7 (Tablet)','a:0:{}'),('node','banner',0,136,136,'und',0,'product/rolex-submariner-black-dial-stainless-steel-automatic-mens-watch-114060-68','Rolex Submariner Black Dial Stainless Steel Automatic Mens Watch 114060','a:0:{}'),('node','banner',0,137,137,'und',0,'product/canon-powershot-sx60-hs-161mp-black-8gb-case-85','Canon PowerShot SX60 HS 16.1MP Black + 8GB + Case','a:0:{}'),('node','banner',0,140,140,'und',0,'product/cokin-u961a-z-pro-grad-kit-z-filter-holder-z121l-z123l-z125l-91','Cokin U961A Z Pro Grad Kit - Z Filter Holder + Z121L + Z123L + Z125L','a:0:{}'),('node','banner',0,142,142,'und',0,'product/diniwell-water-resistant-travel-shoes-bag-pouch-organizer-bag-ver-2-orange-35','black friday','a:0:{}');
/*!40000 ALTER TABLE `field_revision_field_link` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_map`
--

DROP TABLE IF EXISTS `field_revision_field_map`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_map` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_map_value` longtext,
  `field_map_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_map_format` (`field_map_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 45 (field_map)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_map`
--

LOCK TABLES `field_revision_field_map` WRITE;
/*!40000 ALTER TABLE `field_revision_field_map` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_map` VALUES ('node','webform',0,28,28,'und',0,'<p><iframe height=\"403\" src=\"https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d24211.70199537884!2d-73.9482136362959!3d40.66377185214051!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x89c25b6f2cf5c117%3A0x97da648ac6054528!2sWinthrop+St!5e0!3m2!1sen!2s!4v1407399678598\" style=\"border:0; width: 100%\"></iframe></p>\r\n','full_html');
/*!40000 ALTER TABLE `field_revision_field_map` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_old_price`
--

DROP TABLE IF EXISTS `field_revision_field_old_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_old_price` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_old_price_amount` int(11) NOT NULL DEFAULT '0' COMMENT 'The price amount.',
  `field_old_price_currency_code` varchar(32) NOT NULL COMMENT 'The currency code for the price.',
  `field_old_price_data` longtext COMMENT 'A serialized array of additional price data.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_old_price_currency_price` (`field_old_price_amount`,`field_old_price_currency_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 48 (field_old_price)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_old_price`
--

LOCK TABLES `field_revision_field_old_price` WRITE;
/*!40000 ALTER TABLE `field_revision_field_old_price` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_old_price` VALUES ('commerce_product','product',0,6,9,'und',0,150000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,6,83,'und',0,150000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,9,16,'und',0,7900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,9,78,'und',0,7900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,9,79,'und',0,7900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,9,84,'und',0,7900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,10,17,'und',0,7900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,10,80,'und',0,7900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,10,85,'und',0,7900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,10,86,'und',0,7900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,11,18,'und',0,17900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,11,125,'und',0,17900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,12,19,'und',0,17900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,13,20,'und',0,17900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,14,21,'und',0,17900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,15,22,'und',0,29900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,16,23,'und',0,41800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,18,25,'und',0,9900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,19,26,'und',0,19900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,19,96,'und',0,19900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,21,28,'und',0,33000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,21,118,'und',0,33000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,22,29,'und',0,29900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,22,97,'und',0,29900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,23,30,'und',0,11900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,23,98,'und',0,11900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,24,31,'und',0,12900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,24,99,'und',0,12900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,25,32,'und',0,9500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,25,100,'und',0,9500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,26,33,'und',0,12000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,26,92,'und',0,12000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,30,37,'und',0,25000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,30,102,'und',0,25000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,31,38,'und',0,7000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,31,91,'und',0,7000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,32,39,'und',0,60000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,32,90,'und',0,60000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,33,40,'und',0,45000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,33,103,'und',0,45000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,34,41,'und',0,34900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,35,42,'und',0,74900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,36,43,'und',0,9900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,36,104,'und',0,9900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,38,45,'und',0,11900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,38,105,'und',0,11900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,39,46,'und',0,3900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,39,106,'und',0,3900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,40,47,'und',0,9900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,40,107,'und',0,9900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,41,48,'und',0,14900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,41,81,'und',0,14900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,41,87,'und',0,14900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,41,89,'und',0,14900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,42,49,'und',0,14900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,42,82,'und',0,14900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,42,88,'und',0,14900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,43,50,'und',0,9900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,43,108,'und',0,9900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,44,51,'und',0,39900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,44,109,'und',0,39900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,45,52,'und',0,25900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,45,110,'und',0,25900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,49,56,'und',0,4000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,49,112,'und',0,4000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,50,57,'und',0,3800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,50,113,'und',0,3800,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,51,58,'und',0,79900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,51,114,'und',0,79900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,52,59,'und',0,129900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,52,115,'und',0,129900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,53,60,'und',0,99900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,53,116,'und',0,99900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,54,61,'und',0,10000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,54,117,'und',0,10000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,55,62,'und',0,149900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,55,119,'und',0,149900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,56,63,'und',0,299900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,56,120,'und',0,299900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,57,64,'und',0,149900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,57,121,'und',0,149900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,58,65,'und',0,59900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,58,122,'und',0,59900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,59,66,'und',0,29900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,59,123,'und',0,29900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,60,67,'und',0,36700,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,60,124,'und',0,36700,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,61,68,'und',0,129900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,62,69,'und',0,8500,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,63,70,'und',0,159900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,64,71,'und',0,17000,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,66,73,'und',0,59900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,66,95,'und',0,59900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,67,74,'und',0,39900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,67,94,'und',0,39900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,68,75,'und',0,79900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,68,93,'und',0,79900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,69,76,'und',0,129900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,71,126,'und',0,99900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,72,127,'und',0,69900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,73,128,'und',0,89900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,75,136,'und',0,0,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,75,139,'und',0,87900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,78,134,'und',0,6990,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,80,141,'und',0,18900,'USD','a:1:{s:10:\"components\";a:0:{}}'),('commerce_product','product',0,81,144,'und',0,14900,'USD','a:1:{s:10:\"components\";a:0:{}}');
/*!40000 ALTER TABLE `field_revision_field_old_price` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_paypal_email`
--

DROP TABLE IF EXISTS `field_revision_field_paypal_email`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_paypal_email` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_paypal_email_value` varchar(255) DEFAULT NULL,
  `field_paypal_email_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_paypal_email_format` (`field_paypal_email_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 57 (field_paypal_email)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_paypal_email`
--

LOCK TABLES `field_revision_field_paypal_email` WRITE;
/*!40000 ALTER TABLE `field_revision_field_paypal_email` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `field_revision_field_paypal_email` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_product`
--

DROP TABLE IF EXISTS `field_revision_field_product`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_product` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_product_product_id` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_product_product_id` (`field_product_product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 17 (field_product)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_product`
--

LOCK TABLES `field_revision_field_product` WRITE;
/*!40000 ALTER TABLE `field_revision_field_product` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_product` VALUES ('node','product',0,30,30,'und',0,9),('node','product',0,30,30,'und',1,10),('node','product',0,31,31,'und',0,11),('node','product',0,31,31,'und',1,12),('node','product',0,31,31,'und',2,13),('node','product',0,31,31,'und',3,14),('node','product',0,32,32,'und',0,15),('node','product',0,33,33,'und',0,16),('node','product',0,34,34,'und',0,17),('node','product',0,35,35,'und',0,18),('node','product',0,36,36,'und',0,19),('node','product',0,37,37,'und',0,20),('node','product',0,38,38,'und',0,21),('node','product',0,39,39,'und',0,22),('node','product',0,40,40,'und',0,23),('node','product',0,41,41,'und',0,24),('node','product',0,42,42,'und',0,25),('node','product',0,43,43,'und',0,26),('node','product',0,44,44,'und',0,27),('node','product',0,45,45,'und',0,28),('node','product',0,46,46,'und',0,29),('node','product',0,47,47,'und',0,30),('node','product',0,48,48,'und',0,31),('node','product',0,49,49,'und',0,32),('node','product',0,50,50,'und',0,33),('node','product',0,51,51,'und',0,34),('node','product',0,52,52,'und',0,35),('node','product',0,53,53,'und',0,36),('node','product',0,54,54,'und',0,37),('node','product',0,55,55,'und',0,38),('node','product',0,56,56,'und',0,39),('node','product',0,57,57,'und',0,40),('node','product',0,58,58,'und',0,41),('node','product',0,58,58,'und',1,42),('node','product',0,59,59,'und',0,43),('node','product',0,60,60,'und',0,44),('node','product',0,61,61,'und',0,45),('node','product',0,62,62,'und',0,46),('node','product',0,63,63,'und',0,47),('node','product',0,64,64,'und',0,48),('node','product',0,65,65,'und',0,49),('node','product',0,66,66,'und',0,50),('node','product',0,67,67,'und',0,51),('node','product',0,68,68,'und',0,52),('node','product',0,69,69,'und',0,53),('node','product',0,70,70,'und',0,54),('node','product',0,71,71,'und',0,55),('node','product',0,72,72,'und',0,56),('node','product',0,73,73,'und',0,57),('node','product',0,74,74,'und',0,58),('node','product',0,75,75,'und',0,59),('node','product',0,76,76,'und',0,60),('node','product',0,77,77,'und',0,61),('node','product',0,78,78,'und',0,62),('node','product',0,79,79,'und',0,63),('node','product',0,80,80,'und',0,64),('node','product',0,81,81,'und',0,65),('node','product',0,82,82,'und',0,66),('node','product',0,83,83,'und',0,67),('node','product',0,84,84,'und',0,68),('node','product',0,85,85,'und',0,69),('node','product',0,86,86,'und',0,70),('node','product',0,88,88,'und',0,71),('node','product',0,89,89,'und',0,72),('node','product',0,90,90,'und',0,73),('node','product',0,91,91,'und',0,74),('node','product',0,92,92,'und',0,75),('node','product',0,93,93,'und',0,76),('node','product',0,94,94,'und',0,77),('node','product',0,95,95,'und',0,78),('node','product',0,96,96,'und',0,79),('node','product',0,97,97,'und',0,80),('node','product',0,138,138,'und',0,81),('node','product',0,139,139,'und',0,82);
/*!40000 ALTER TABLE `field_revision_field_product` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_product_color`
--

DROP TABLE IF EXISTS `field_revision_field_product_color`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_product_color` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_product_color_tid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_product_color_tid` (`field_product_color_tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 51 (field_product_color)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_product_color`
--

LOCK TABLES `field_revision_field_product_color` WRITE;
/*!40000 ALTER TABLE `field_revision_field_product_color` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_product_color` VALUES ('commerce_product','product',0,9,78,'und',0,104),('commerce_product','product',0,9,79,'und',0,106),('commerce_product','product',0,9,84,'und',0,106),('commerce_product','product',0,10,80,'und',0,108),('commerce_product','product',0,10,85,'und',0,108),('commerce_product','product',0,10,86,'und',0,108),('commerce_product','product',0,11,18,'und',0,106),('commerce_product','product',0,11,125,'und',0,106),('commerce_product','product',0,12,19,'und',0,110),('commerce_product','product',0,13,20,'und',0,107),('commerce_product','product',0,14,21,'und',0,108),('commerce_product','product',0,41,81,'und',0,104),('commerce_product','product',0,41,87,'und',0,104),('commerce_product','product',0,41,89,'und',0,104),('commerce_product','product',0,42,82,'und',0,109),('commerce_product','product',0,42,88,'und',0,109),('commerce_product','product',0,71,126,'und',0,104),('commerce_product','product',0,72,127,'und',0,104),('commerce_product','product',0,73,128,'und',0,104),('commerce_product','product',0,74,129,'und',0,104),('commerce_product','product',0,74,132,'und',0,104),('commerce_product','product',0,75,130,'und',0,104),('commerce_product','product',0,75,135,'und',0,104),('commerce_product','product',0,75,136,'und',0,104),('commerce_product','product',0,75,138,'und',0,104),('commerce_product','product',0,75,139,'und',0,104),('commerce_product','product',0,75,140,'und',0,104),('commerce_product','product',0,75,142,'und',0,104),('commerce_product','product',0,75,143,'und',0,104),('commerce_product','product',0,76,131,'und',0,104),('commerce_product','product',0,77,133,'und',0,104),('commerce_product','product',0,78,134,'und',0,104),('commerce_product','product',0,79,137,'und',0,104),('commerce_product','product',0,80,141,'und',0,104),('commerce_product','product',0,81,144,'und',0,104),('commerce_product','product',0,82,145,'und',0,104);
/*!40000 ALTER TABLE `field_revision_field_product_color` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_product_image`
--

DROP TABLE IF EXISTS `field_revision_field_product_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_product_image` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_product_image_fid` int(10) unsigned DEFAULT NULL COMMENT 'The file_managed.fid being referenced in this field.',
  `field_product_image_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image’s ’alt’ attribute.',
  `field_product_image_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image’s ’title’ attribute.',
  `field_product_image_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',
  `field_product_image_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_product_image_fid` (`field_product_image_fid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 39 (field_product_image)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_product_image`
--

LOCK TABLES `field_revision_field_product_image` WRITE;
/*!40000 ALTER TABLE `field_revision_field_product_image` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_product_image` VALUES ('commerce_product','product',0,4,4,'und',0,26,'','',400,400),('commerce_product','product',0,4,15,'und',0,26,'','',400,400),('commerce_product','product',0,6,6,'und',0,19,'','',850,850),('commerce_product','product',0,6,9,'und',0,19,'','',850,850),('commerce_product','product',0,6,83,'und',0,19,'','',850,850),('commerce_product','product',0,7,7,'und',0,20,'','',850,850),('commerce_product','product',0,7,10,'und',0,20,'','',850,850),('commerce_product','product',0,8,8,'und',0,27,'','',466,416),('commerce_product','product',0,8,11,'und',0,27,'','',466,416),('commerce_product','product',0,9,16,'und',0,76,'Aeroline Casual Hiking Backpack Dark Blue','Aeroline Casual Hiking Backpack Dark Blue',850,850),('commerce_product','product',0,9,16,'und',1,77,'Aeroline Casual Hiking Backpack Dark Blue','Aeroline Casual Hiking Backpack Dark Blue',850,850),('commerce_product','product',0,9,16,'und',2,78,'Aeroline Casual Hiking Backpack Dark Blue','Aeroline Casual Hiking Backpack Dark Blue',850,850),('commerce_product','product',0,9,78,'und',0,76,'Aeroline Casual Hiking Backpack Dark Blue','Aeroline Casual Hiking Backpack Dark Blue',850,850),('commerce_product','product',0,9,78,'und',1,77,'Aeroline Casual Hiking Backpack Dark Blue','Aeroline Casual Hiking Backpack Dark Blue',850,850),('commerce_product','product',0,9,78,'und',2,78,'Aeroline Casual Hiking Backpack Dark Blue','Aeroline Casual Hiking Backpack Dark Blue',850,850),('commerce_product','product',0,9,79,'und',0,76,'Aeroline Casual Hiking Backpack Dark Blue','Aeroline Casual Hiking Backpack Dark Blue',850,850),('commerce_product','product',0,9,79,'und',1,77,'Aeroline Casual Hiking Backpack Dark Blue','Aeroline Casual Hiking Backpack Dark Blue',850,850),('commerce_product','product',0,9,79,'und',2,78,'Aeroline Casual Hiking Backpack Dark Blue','Aeroline Casual Hiking Backpack Dark Blue',850,850),('commerce_product','product',0,9,84,'und',0,76,'Aeroline Casual Hiking Backpack Dark Blue','Aeroline Casual Hiking Backpack Dark Blue',850,850),('commerce_product','product',0,9,84,'und',1,77,'Aeroline Casual Hiking Backpack Dark Blue','Aeroline Casual Hiking Backpack Dark Blue',850,850),('commerce_product','product',0,9,84,'und',2,78,'Aeroline Casual Hiking Backpack Dark Blue','Aeroline Casual Hiking Backpack Dark Blue',850,850),('commerce_product','product',0,10,17,'und',0,79,'Aeroline Casual Hiking Backpack Orange','Aeroline Casual Hiking Backpack Orange',850,850),('commerce_product','product',0,10,17,'und',1,80,'Aeroline Casual Hiking Backpack Orange','Aeroline Casual Hiking Backpack Orange',850,850),('commerce_product','product',0,10,17,'und',2,81,'Aeroline Casual Hiking Backpack Orange','Aeroline Casual Hiking Backpack Orange',850,850),('commerce_product','product',0,10,80,'und',0,79,'Aeroline Casual Hiking Backpack Orange','Aeroline Casual Hiking Backpack Orange',850,850),('commerce_product','product',0,10,80,'und',1,80,'Aeroline Casual Hiking Backpack Orange','Aeroline Casual Hiking Backpack Orange',850,850),('commerce_product','product',0,10,80,'und',2,81,'Aeroline Casual Hiking Backpack Orange','Aeroline Casual Hiking Backpack Orange',850,850),('commerce_product','product',0,10,85,'und',0,79,'Aeroline Casual Hiking Backpack Orange','Aeroline Casual Hiking Backpack Orange',850,850),('commerce_product','product',0,10,85,'und',1,80,'Aeroline Casual Hiking Backpack Orange','Aeroline Casual Hiking Backpack Orange',850,850),('commerce_product','product',0,10,85,'und',2,81,'Aeroline Casual Hiking Backpack Orange','Aeroline Casual Hiking Backpack Orange',850,850),('commerce_product','product',0,10,86,'und',0,79,'Aeroline Casual Hiking Backpack Orange','Aeroline Casual Hiking Backpack Orange',850,850),('commerce_product','product',0,10,86,'und',1,80,'Aeroline Casual Hiking Backpack Orange','Aeroline Casual Hiking Backpack Orange',850,850),('commerce_product','product',0,10,86,'und',2,81,'Aeroline Casual Hiking Backpack Orange','Aeroline Casual Hiking Backpack Orange',850,850),('commerce_product','product',0,11,18,'und',0,82,'Local Lion Water Resistant Hiking Backpack Bag 28L Blue','Local Lion Water Resistant Hiking Backpack Bag 28L Blue',850,850),('commerce_product','product',0,11,125,'und',0,82,'Local Lion Water Resistant Hiking Backpack Bag 28L Blue','Local Lion Water Resistant Hiking Backpack Bag 28L Blue',850,850),('commerce_product','product',0,12,19,'und',0,83,'Local Lion Water Resistant Hiking Backpack Bag 28L Green','Local Lion Water Resistant Hiking Backpack Bag 28L Green',850,850),('commerce_product','product',0,13,20,'und',0,84,'Local Lion Water Resistant Hiking Backpack Bag 28L Red','Local Lion Water Resistant Hiking Backpack Bag 28L Red',850,850),('commerce_product','product',0,14,21,'und',0,85,'Local Lion Water Resistant Hiking Backpack Bag 28L Orange','Local Lion Water Resistant Hiking Backpack Bag 28L Orange',850,850),('commerce_product','product',0,15,22,'und',0,86,'Terminus T02-297LAP-01 Laptop Backpack Plus Black','Terminus T02-297LAP-01 Laptop Backpack Plus Black',850,850),('commerce_product','product',0,16,23,'und',0,87,'Targus Tsb166Ap 15.6In Revolution Backpack Xl','Targus Tsb166Ap 15.6In Revolution Backpack Xl',850,850),('commerce_product','product',0,16,23,'und',1,88,'Targus Tsb166Ap 15.6In Revolution Backpack Xl','Targus Tsb166Ap 15.6In Revolution Backpack Xl',850,850),('commerce_product','product',0,16,23,'und',2,89,'Targus Tsb166Ap 15.6In Revolution Backpack Xl','Targus Tsb166Ap 15.6In Revolution Backpack Xl',850,850),('commerce_product','product',0,17,24,'und',0,92,'Tarantula Shoe Bag (BOS04-088SHB-03) - Red ','Tarantula Shoe Bag (BOS04-088SHB-03) - Red ',850,850),('commerce_product','product',0,18,25,'und',0,96,'Diniwell Water-Resistant Travel Shoes Bag Pouch Organizer Bag Ver 2 - Orange','Diniwell Water-Resistant Travel Shoes Bag Pouch Organizer Bag Ver 2 - Orange',850,850),('commerce_product','product',0,18,25,'und',1,97,'Diniwell Water-Resistant Travel Shoes Bag Pouch Organizer Bag Ver 2 - Orange','Diniwell Water-Resistant Travel Shoes Bag Pouch Organizer Bag Ver 2 - Orange',850,850),('commerce_product','product',0,18,25,'und',2,98,'Diniwell Water-Resistant Travel Shoes Bag Pouch Organizer Bag Ver 2 - Orange','Diniwell Water-Resistant Travel Shoes Bag Pouch Organizer Bag Ver 2 - Orange',850,850),('commerce_product','product',0,19,26,'und',0,100,'24-Piece Makeup Brush Set','24-Piece Makeup Brush Set',850,850),('commerce_product','product',0,19,26,'und',1,101,'24-Piece Makeup Brush Set','24-Piece Makeup Brush Set',850,850),('commerce_product','product',0,19,26,'und',2,102,'24-Piece Makeup Brush Set','24-Piece Makeup Brush Set',850,850),('commerce_product','product',0,19,96,'und',0,100,'24-Piece Makeup Brush Set','24-Piece Makeup Brush Set',850,850),('commerce_product','product',0,19,96,'und',1,101,'24-Piece Makeup Brush Set','24-Piece Makeup Brush Set',850,850),('commerce_product','product',0,19,96,'und',2,102,'24-Piece Makeup Brush Set','24-Piece Makeup Brush Set',850,850),('commerce_product','product',0,20,27,'und',0,104,'Cameleon MakeUp Kit 396','Cameleon MakeUp Kit 396',850,850),('commerce_product','product',0,21,28,'und',0,107,'4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner','4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner',850,850),('commerce_product','product',0,21,28,'und',1,108,'4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner','4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner',850,850),('commerce_product','product',0,21,28,'und',2,109,'4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner','4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner',850,850),('commerce_product','product',0,21,118,'und',0,107,'4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner','4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner',850,850),('commerce_product','product',0,21,118,'und',1,108,'4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner','4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner',850,850),('commerce_product','product',0,21,118,'und',2,109,'4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner','4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner',850,850),('commerce_product','product',0,22,29,'und',0,110,'SK-II 5-Piece Skincare Travel Set 5pcs Travel Packs SKII SK2','SK-II 5-Piece Skincare Travel Set 5pcs Travel Packs SKII SK2',850,850),('commerce_product','product',0,22,97,'und',0,110,'SK-II 5-Piece Skincare Travel Set 5pcs Travel Packs SKII SK2','SK-II 5-Piece Skincare Travel Set 5pcs Travel Packs SKII SK2',850,850),('commerce_product','product',0,23,30,'und',0,112,'Organic Eye Cream 15ml','Organic Eye Cream 15ml',850,850),('commerce_product','product',0,23,98,'und',0,112,'Organic Eye Cream 15ml','Organic Eye Cream 15ml',850,850),('commerce_product','product',0,24,31,'und',0,113,'Mejikaliner Quick Eyelid Essence Stick Glue - Night Use','Mejikaliner Quick Eyelid Essence Stick Glue - Night Use',850,850),('commerce_product','product',0,24,99,'und',0,113,'Mejikaliner Quick Eyelid Essence Stick Glue - Night Use','Mejikaliner Quick Eyelid Essence Stick Glue - Night Use',850,850),('commerce_product','product',0,25,32,'und',0,114,'Hairscape 1800W (AUS) 5000 Professional Hair Dryer','Hairscape 1800W (AUS) 5000 Professional Hair Dryer',850,850),('commerce_product','product',0,25,100,'und',0,114,'Hairscape 1800W (AUS) 5000 Professional Hair Dryer','Hairscape 1800W (AUS) 5000 Professional Hair Dryer',850,850),('commerce_product','product',0,26,33,'und',0,115,'Tonific Slimming Massager','Tonific Slimming Massager',850,850),('commerce_product','product',0,26,92,'und',0,115,'Tonific Slimming Massager','Tonific Slimming Massager',850,850),('commerce_product','product',0,27,34,'und',0,118,'Apple iPhone 6 16GB Gold','Apple iPhone 6 16GB Gold',850,850),('commerce_product','product',0,27,34,'und',1,119,'Apple iPhone 6 16GB Gold','Apple iPhone 6 16GB Gold',850,850),('commerce_product','product',0,27,34,'und',2,120,'Apple iPhone 6 16GB Gold','Apple iPhone 6 16GB Gold',850,850),('commerce_product','product',0,27,101,'und',0,118,'Apple iPhone 6 16GB Gold','Apple iPhone 6 16GB Gold',850,850),('commerce_product','product',0,27,101,'und',1,119,'Apple iPhone 6 16GB Gold','Apple iPhone 6 16GB Gold',850,850),('commerce_product','product',0,27,101,'und',2,120,'Apple iPhone 6 16GB Gold','Apple iPhone 6 16GB Gold',850,850),('commerce_product','product',0,28,35,'und',0,121,'Samsung N910 Note 4 LTE 32GB White','Samsung N910 Note 4 LTE 32GB White',850,850),('commerce_product','product',0,28,35,'und',1,122,'Samsung N910 Note 4 LTE 32GB White','Samsung N910 Note 4 LTE 32GB White',850,850),('commerce_product','product',0,28,35,'und',2,123,'Samsung N910 Note 4 LTE 32GB White','Samsung N910 Note 4 LTE 32GB White',850,850),('commerce_product','product',0,29,36,'und',0,124,'Asus Transformer P1801-B041K AIO 18.4\'\' PC Dekstop + Asus RT-N56U Wireless N N600 Dual-Band Gigabit Router','Asus Transformer P1801-B041K AIO 18.4\'\' PC Dekstop + Asus RT-N56U Wireless N N600 Dual-Band Gigabit Router',850,850),('commerce_product','product',0,29,36,'und',1,125,'Asus Transformer P1801-B041K AIO 18.4\'\' PC Dekstop + Asus RT-N56U Wireless N N600 Dual-Band Gigabit Router','Asus Transformer P1801-B041K AIO 18.\'\' PC Dekstop + Asus RT-N56U Wireless N N600 Dual-Band Gigabit Router',850,850),('commerce_product','product',0,29,36,'und',2,126,'Asus Transformer P1801-B041K AIO 18.4\'\' PC Dekstop + Asus RT-N56U Wireless N N600 Dual-Band Gigabit Router','Asus Transformer P1801-B041K AIO 18.4\'\' PC Dekstop + Asus RT-N56U Wireless N N600 Dual-Band Gigabit Router',850,850),('commerce_product','product',0,30,37,'und',0,129,'Lenovo A316','Lenovo A316',850,850),('commerce_product','product',0,30,102,'und',0,129,'Lenovo A316','Lenovo A316',850,850),('commerce_product','product',0,31,38,'und',0,128,'Nokia Asha 206 Dual SIM Black','Nokia Asha 206 Dual SIM Black',850,850),('commerce_product','product',0,31,91,'und',0,128,'Nokia Asha 206 Dual SIM Black','Nokia Asha 206 Dual SIM Black',850,850),('commerce_product','product',0,32,39,'und',0,130,'Apple IPAD 3 Wi-Fi+4G MD368 64GB Black','Apple IPAD 3 Wi-Fi+4G MD368 64GB Black',850,850),('commerce_product','product',0,32,39,'und',1,131,'Apple IPAD 3 Wi-Fi+4G MD368 64GB Black','Apple IPAD 3 Wi-Fi+4G MD368 64GB Black',850,850),('commerce_product','product',0,32,90,'und',0,130,'Apple IPAD 3 Wi-Fi+4G MD368 64GB Black','Apple IPAD 3 Wi-Fi+4G MD368 64GB Black',850,850),('commerce_product','product',0,32,90,'und',1,131,'Apple IPAD 3 Wi-Fi+4G MD368 64GB Black','Apple IPAD 3 Wi-Fi+4G MD368 64GB Black',850,850),('commerce_product','product',0,33,40,'und',0,132,'Asus Memopad 7 (Tablet)','Asus Memopad 7 (Tablet)',850,850),('commerce_product','product',0,33,40,'und',1,133,'Asus Memopad 7 (Tablet)','Asus Memopad 7 (Tablet)',850,850),('commerce_product','product',0,33,103,'und',0,132,'Asus Memopad 7 (Tablet)','Asus Memopad 7 (Tablet)',850,850),('commerce_product','product',0,33,103,'und',1,133,'Asus Memopad 7 (Tablet)','Asus Memopad 7 (Tablet)',850,850),('commerce_product','product',0,34,41,'und',0,137,'Lenovo Tablet Miix 2 59399848 8\'\' Silver','Lenovo Tablet Miix 2 59399848 8\'\' Silver',850,850),('commerce_product','product',0,34,41,'und',1,135,'Lenovo Tablet Miix 2 59399848 8\'\' Silver','Lenovo Tablet Miix 2 59399848 8\'\' Silver',850,850),('commerce_product','product',0,35,42,'und',0,144,'Apple iPad Air 16GB WiFi Space Grey (MD785ZPA)','Apple iPad Air 16GB WiFi Space Grey (MD785ZPA)',850,850),('commerce_product','product',0,35,42,'und',1,145,'Apple iPad Air 16GB WiFi Space Grey (MD785ZPA)','Apple iPad Air 16GB WiFi Space Grey (MD785ZPA)',850,850),('commerce_product','product',0,36,43,'und',0,146,'Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold','Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold',850,850),('commerce_product','product',0,36,43,'und',1,147,'Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold','Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold',850,850),('commerce_product','product',0,36,43,'und',2,148,'Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold','Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold',850,850),('commerce_product','product',0,36,104,'und',0,146,'Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold','Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold',850,850),('commerce_product','product',0,36,104,'und',1,147,'Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold','Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold',850,850),('commerce_product','product',0,36,104,'und',2,148,'Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold','Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold',850,850),('commerce_product','product',0,37,44,'und',0,149,'[GENUINE] SAMSUNG Galaxy Note 4 S View Classic Cover Case - Black','[GENUINE] SAMSUNG Galaxy Note 4 S View Classic Cover Case - Black',850,850),('commerce_product','product',0,37,44,'und',1,150,'[GENUINE] SAMSUNG Galaxy Note 4 S View Classic Cover Case - Black','[GENUINE] SAMSUNG Galaxy Note 4 S View Classic Cover Case - Black',850,850),('commerce_product','product',0,37,44,'und',2,151,'[GENUINE] SAMSUNG Galaxy Note 4 S View Classic Cover Case - Black','[GENUINE] SAMSUNG Galaxy Note 4 S View Classic Cover Case - Black',850,850),('commerce_product','product',0,38,45,'und',0,152,'Samsung Galaxy Tab 7.0 Plus Vehicle Dock With In-Car Charger','Samsung Galaxy Tab 7.0 Plus Vehicle Dock With In-Car Charger',728,728),('commerce_product','product',0,38,105,'und',0,152,'Samsung Galaxy Tab 7.0 Plus Vehicle Dock With In-Car Charger','Samsung Galaxy Tab 7.0 Plus Vehicle Dock With In-Car Charger',728,728),('commerce_product','product',0,39,46,'und',0,155,'Angel Universal Mobile Phone In Car Phone Holder 360 degree Item Code: P338','Angel Universal Mobile Phone In Car Phone Holder 360 degree Item Code: P338',850,850),('commerce_product','product',0,39,106,'und',0,155,'Angel Universal Mobile Phone In Car Phone Holder 360 degree Item Code: P338','Angel Universal Mobile Phone In Car Phone Holder 360 degree Item Code: P338',850,850),('commerce_product','product',0,40,47,'und',0,156,'Original Apple Earpod Earphone with Remote & Mic for iPhone iPad iPod','Original Apple Earpod Earphone with Remote & Mic for iPhone iPad iPod',850,850),('commerce_product','product',0,40,47,'und',1,157,'Original Apple Earpod Earphone with Remote & Mic for iPhone iPad iPod','Original Apple Earpod Earphone with Remote & Mic for iPhone iPad iPod',850,850),('commerce_product','product',0,40,107,'und',0,156,'Original Apple Earpod Earphone with Remote & Mic for iPhone iPad iPod','Original Apple Earpod Earphone with Remote & Mic for iPhone iPad iPod',850,850),('commerce_product','product',0,40,107,'und',1,157,'Original Apple Earpod Earphone with Remote & Mic for iPhone iPad iPod','Original Apple Earpod Earphone with Remote & Mic for iPhone iPad iPod',850,850),('commerce_product','product',0,41,48,'und',0,162,'Sony Stereo Bluetooth Headset SBH20 Black','Sony Stereo Bluetooth Headset SBH20 Black',850,850),('commerce_product','product',0,41,81,'und',0,162,'Sony Stereo Bluetooth Headset SBH20 Black','Sony Stereo Bluetooth Headset SBH20 Black',850,850),('commerce_product','product',0,41,87,'und',0,162,'Sony Stereo Bluetooth Headset SBH20 Black','Sony Stereo Bluetooth Headset SBH20 Black',850,850),('commerce_product','product',0,41,89,'und',0,162,'Sony Stereo Bluetooth Headset SBH20 Black','Sony Stereo Bluetooth Headset SBH20 Black',850,850),('commerce_product','product',0,42,49,'und',0,163,'Sony Stereo Bluetooth Headset SBH20 Pink','Sony Stereo Bluetooth Headset SBH20 Pink',850,850),('commerce_product','product',0,42,82,'und',0,163,'Sony Stereo Bluetooth Headset SBH20 Pink','Sony Stereo Bluetooth Headset SBH20 Pink',850,850),('commerce_product','product',0,42,88,'und',0,163,'Sony Stereo Bluetooth Headset SBH20 Pink','Sony Stereo Bluetooth Headset SBH20 Pink',850,850),('commerce_product','product',0,43,50,'und',0,164,'TOP Mi 10400mAh Powerbank - Black','TOP Mi 10400mAh Powerbank - Black',850,850),('commerce_product','product',0,43,50,'und',1,165,'TOP Mi 10400mAh Powerbank - Black','TOP Mi 10400mAh Powerbank - Black',850,850),('commerce_product','product',0,43,50,'und',2,166,'TOP Mi 10400mAh Powerbank - Black','TOP Mi 10400mAh Powerbank - Black',850,850),('commerce_product','product',0,43,108,'und',0,164,'TOP Mi 10400mAh Powerbank - Black','TOP Mi 10400mAh Powerbank - Black',850,850),('commerce_product','product',0,43,108,'und',1,165,'TOP Mi 10400mAh Powerbank - Black','TOP Mi 10400mAh Powerbank - Black',850,850),('commerce_product','product',0,43,108,'und',2,166,'TOP Mi 10400mAh Powerbank - Black','TOP Mi 10400mAh Powerbank - Black',850,850),('commerce_product','product',0,44,51,'und',0,167,'Universal Dual-Port Power Bank 20000mAh Black','Universal Dual-Port Power Bank 20000mAh Black',850,850),('commerce_product','product',0,44,109,'und',0,167,'Universal Dual-Port Power Bank 20000mAh Black','Universal Dual-Port Power Bank 20000mAh Black',850,850),('commerce_product','product',0,45,52,'und',0,168,'MuWo Trendz Swarovski Element White Gold Plated Everlasting Love Set','MuWo Trendz Swarovski Element White Gold Plated Everlasting Love Set',850,850),('commerce_product','product',0,45,110,'und',0,168,'MuWo Trendz Swarovski Element White Gold Plated Everlasting Love Set','MuWo Trendz Swarovski Element White Gold Plated Everlasting Love Set',850,850),('commerce_product','product',0,46,53,'und',0,169,'LUCCACAL Multi Color Tribal Necklace','LUCCACAL Multi Color Tribal Necklace',850,850),('commerce_product','product',0,47,54,'und',0,170,'Dandelion Women Braided Belt White','Dandelion Women Braided Belt White',850,850),('commerce_product','product',0,47,111,'und',0,170,'Dandelion Women Braided Belt White','Dandelion Women Braided Belt White',850,850),('commerce_product','product',0,48,55,'und',0,171,'Dandelion Cross Stitch Belt Orange','Dandelion Cross Stitch Belt Orange',850,850),('commerce_product','product',0,49,56,'und',0,172,'Fur Nyce Big Square Classic Chain Pattern Print Scarf','Fur Nyce Big Square Classic Chain Pattern Print Scarf',850,850),('commerce_product','product',0,49,112,'und',0,172,'Fur Nyce Big Square Classic Chain Pattern Print Scarf','Fur Nyce Big Square Classic Chain Pattern Print Scarf',850,850),('commerce_product','product',0,50,57,'und',0,173,'Fur Nyce Fashion Zebra Pattern Print Scarf White','Fur Nyce Fashion Zebra Pattern Print Scarf White',850,850),('commerce_product','product',0,50,113,'und',0,173,'Fur Nyce Fashion Zebra Pattern Print Scarf White','Fur Nyce Fashion Zebra Pattern Print Scarf White',850,850),('commerce_product','product',0,51,58,'und',0,174,'Invicta Pro Diver Men Black Stainless Steel Strap Watch 15422','Invicta Pro Diver Men Black Stainless Steel Strap Watch 15422',850,850),('commerce_product','product',0,51,114,'und',0,174,'Invicta Pro Diver Men Black Stainless Steel Strap Watch 15422','Invicta Pro Diver Men Black Stainless Steel Strap Watch 15422',850,850),('commerce_product','product',0,52,59,'und',0,175,'Rolex Submariner Black Dial Stainless Steel Automatic Mens Watch 114060','Rolex Submariner Black Dial Stainless Steel Automatic Mens Watch 114060',850,850),('commerce_product','product',0,52,115,'und',0,175,'Rolex Submariner Black Dial Stainless Steel Automatic Mens Watch 114060','Rolex Submariner Black Dial Stainless Steel Automatic Mens Watch 114060',850,850),('commerce_product','product',0,53,60,'und',0,176,'SUUNTO VECTOR BLACK SUSS010600610 MOUNTAIN OUTDOOR WATCH ','SUUNTO VECTOR BLACK SUSS010600610 MOUNTAIN OUTDOOR WATCH ',850,850),('commerce_product','product',0,53,116,'und',0,176,'SUUNTO VECTOR BLACK SUSS010600610 MOUNTAIN OUTDOOR WATCH ','SUUNTO VECTOR BLACK SUSS010600610 MOUNTAIN OUTDOOR WATCH ',850,850),('commerce_product','product',0,54,61,'und',0,177,'SKMEI 0955 30m Waterproof Analogue Digital Dual Time Men\'s Sports Watch Black + Green','SKMEI 0955 30m Waterproof Analogue Digital Dual Time Men\'s Sports Watch Black + Green',850,850),('commerce_product','product',0,54,117,'und',0,177,'SKMEI 0955 30m Waterproof Analogue Digital Dual Time Men\'s Sports Watch Black + Green','SKMEI 0955 30m Waterproof Analogue Digital Dual Time Men\'s Sports Watch Black + Green',850,850),('commerce_product','product',0,55,62,'und',0,178,'Samsung 40\" Full HD LED TV - UA40H5008ARXXM Series 5','Samsung 40\" Full HD LED TV - UA40H5008ARXXM Series 5',850,850),('commerce_product','product',0,55,119,'und',0,178,'Samsung 40\'\' Full HD LED TV - UA40H5008ARXXM Series 5','Samsung 40\'\' Full HD LED TV - UA40H5008ARXXM Series 5',850,850),('commerce_product','product',0,56,63,'und',0,179,'Sony 48\" Full HD LED TV - BRAVIA Model KDL-48R470B','Sony 48\" Full HD LED TV - BRAVIA Model KDL-48R470B',850,850),('commerce_product','product',0,56,120,'und',0,179,'Sony 48\'\' Full HD LED TV - BRAVIA Model KDL-48R470B','Sony 48\'\' Full HD LED TV - BRAVIA Model KDL-48R470B',850,850),('commerce_product','product',0,57,64,'und',0,180,'Sony BDV-N9200W 9.1 Cinema Studio 3D Blu-Ray Disc home Theatre System','Sony BDV-N9200W 9.1 Cinema Studio 3D Blu-Ray Disc home Theatre System',850,850),('commerce_product','product',0,57,121,'und',0,180,'Sony BDV-N9200W 9.1 Cinema Studio 3D Blu-Ray Disc home Theatre System','Sony BDV-N9200W 9.1 Cinema Studio 3D Blu-Ray Disc home Theatre System',850,850),('commerce_product','product',0,58,65,'und',0,181,'Samsung HT-E350K DVD Home Theater System','Samsung HT-E350K DVD Home Theater System',850,850),('commerce_product','product',0,58,122,'und',0,181,'Samsung HT-E350K DVD Home Theater System','Samsung HT-E350K DVD Home Theater System',850,850),('commerce_product','product',0,59,66,'und',0,182,'L12S OLED Smart Watch Bluetooth 3.0 Bracelet Wrist Design for IOS Android iPhone Samsung Smart Phone Blue','L12S OLED Smart Watch Bluetooth 3.0 Bracelet Wrist Design for IOS Android iPhone Samsung Smart Phone Blue',850,850),('commerce_product','product',0,59,66,'und',1,183,'L12S OLED Smart Watch Bluetooth 3.0 Bracelet Wrist Design for IOS Android iPhone Samsung Smart Phone Blue','L12S OLED Smart Watch Bluetooth 3.0 Bracelet Wrist Design for IOS Android iPhone Samsung Smart Phone Blue',850,850),('commerce_product','product',0,59,123,'und',0,182,'L12S OLED Smart Watch Bluetooth 3.0 Bracelet Wrist Design for IOS Android iPhone Samsung Smart Phone Blue','L12S OLED Smart Watch Bluetooth 3.0 Bracelet Wrist Design for IOS Android iPhone Samsung Smart Phone Blue',850,850),('commerce_product','product',0,59,123,'und',1,183,'L12S OLED Smart Watch Bluetooth 3.0 Bracelet Wrist Design for IOS Android iPhone Samsung Smart Phone Blue','L12S OLED Smart Watch Bluetooth 3.0 Bracelet Wrist Design for IOS Android iPhone Samsung Smart Phone Blue',850,850),('commerce_product','product',0,60,67,'und',0,184,'ORI Apple TV','ORI Apple TV',850,850),('commerce_product','product',0,60,124,'und',0,184,'ORI Apple TV','ORI Apple TV',850,850),('commerce_product','product',0,61,68,'und',0,185,'Dell Alienware X51-77822G Gaming Desktop','Dell Alienware X51-77822G Gaming Desktop',850,850),('commerce_product','product',0,62,69,'und',0,187,'3 Port HDMI Switch With Remote Control','3 Port HDMI Switch With Remote Control',850,850),('commerce_product','product',0,63,70,'und',0,188,'Dell PowerConnect 5524P 24 GbE Port Managed L2 Switch with PoE support 10GbE and Stacking Capable','Dell PowerConnect 5524P 24 GbE Port Managed L2 Switch with PoE support 10GbE and Stacking Capable',850,850),('commerce_product','product',0,64,71,'und',0,189,'TP-Link M5250 N900 3G Mobile WiFi Black','TP-Link M5250 N900 3G Mobile WiFi Black',850,850),('commerce_product','product',0,64,71,'und',1,190,'TP-Link M5250 N900 3G Mobile WiFi Black','TP-Link M5250 N900 3G Mobile WiFi Black',850,850),('commerce_product','product',0,64,71,'und',2,191,'TP-Link M5250 N900 3G Mobile WiFi Black','TP-Link M5250 N900 3G Mobile WiFi Black',850,850),('commerce_product','product',0,65,72,'und',0,192,'TP-LINK N750 Wireless Dual Band Gigabit Router TL-WDR4300 Black','TP-LINK N750 Wireless Dual Band Gigabit Router TL-WDR4300 Black',728,728),('commerce_product','product',0,66,73,'und',0,193,'Canon LiDE 210 Scanner','Canon LiDE 210 Scanner',850,850),('commerce_product','product',0,66,95,'und',0,193,'Canon LiDE 210 Scanner','Canon LiDE 210 Scanner',850,850),('commerce_product','product',0,67,74,'und',0,194,'Epson Perfection V33 Scanner','Epson Perfection V33 Scanner',850,850),('commerce_product','product',0,67,94,'und',0,194,'Epson Perfection V33 Scanner','Epson Perfection V33 Scanner',850,850),('commerce_product','product',0,68,75,'und',0,195,'CASIO Exilim EX-ZR1500 Digital Camera Pink','CASIO Exilim EX-ZR1500 Digital Camera Pink',850,850),('commerce_product','product',0,68,75,'und',1,196,'CASIO Exilim EX-ZR1500 Digital Camera Pink','CASIO Exilim EX-ZR1500 Digital Camera Pink',850,850),('commerce_product','product',0,68,75,'und',2,197,'CASIO Exilim EX-ZR1500 Digital Camera Pink','CASIO Exilim EX-ZR1500 Digital Camera Pink',850,850),('commerce_product','product',0,68,93,'und',0,195,'CASIO Exilim EX-ZR1500 Digital Camera Pink','CASIO Exilim EX-ZR1500 Digital Camera Pink',850,850),('commerce_product','product',0,68,93,'und',1,196,'CASIO Exilim EX-ZR1500 Digital Camera Pink','CASIO Exilim EX-ZR1500 Digital Camera Pink',850,850),('commerce_product','product',0,68,93,'und',2,197,'CASIO Exilim EX-ZR1500 Digital Camera Pink','CASIO Exilim EX-ZR1500 Digital Camera Pink',850,850),('commerce_product','product',0,69,76,'und',0,198,'Canon PowerShot SX60 HS 16.1MP Black + 8GB + Case','Canon PowerShot SX60 HS 16.1MP Black + 8GB + Case',850,850),('commerce_product','product',0,69,76,'und',1,199,'Canon PowerShot SX60 HS 16.1MP Black + 8GB + Case','Canon PowerShot SX60 HS 16.1MP Black + 8GB + Case',850,850),('commerce_product','product',0,69,76,'und',2,200,'Canon PowerShot SX60 HS 16.1MP Black + 8GB + Case','Canon PowerShot SX60 HS 16.1MP Black + 8GB + Case',850,850),('commerce_product','product',0,70,77,'und',0,201,'Canon EOS 600D 18MP + 18-55mm Lens','Canon EOS 600D 18MP + 18-55mm Lens',850,850),('commerce_product','product',0,71,126,'und',0,211,'Samsung Smart Camera NX Mini 20.5MP Green + 9mm Lens + 16 GB Memory Card','Samsung Smart Camera NX Mini 20.5MP Green + 9mm Lens + 16 GB Memory Card',850,850),('commerce_product','product',0,71,126,'und',1,212,'Samsung Smart Camera NX Mini 20.5MP Green + 9mm Lens + 16 GB Memory Card','Samsung Smart Camera NX Mini 20.5MP Green + 9mm Lens + 16 GB Memory Card',850,850),('commerce_product','product',0,71,126,'und',2,213,'Samsung Smart Camera NX Mini 20.5MP Green + 9mm Lens + 16 GB Memory Card','Samsung Smart Camera NX Mini 20.5MP Green + 9mm Lens + 16 GB Memory Card',850,850),('commerce_product','product',0,72,127,'und',0,214,'Nikon AF-S 50mm Lens f/1.8G','Nikon AF-S 50mm Lens f/1.8G',850,850),('commerce_product','product',0,73,128,'und',0,215,'Canon EF-S Lens 18-200mm f/3.5-5.6 IS','Canon EF-S Lens 18-200mm f/3.5-5.6 IS',850,850),('commerce_product','product',0,73,128,'und',1,216,'Canon EF-S Lens 18-200mm f/3.5-5.6 IS','Canon EF-S Lens 18-200mm f/3.5-5.6 IS',850,850),('commerce_product','product',0,73,128,'und',2,217,'Canon EF-S Lens 18-200mm f/3.5-5.6 IS','Canon EF-S Lens 18-200mm f/3.5-5.6 IS',850,850),('commerce_product','product',0,74,129,'und',0,218,'Cokin U961A Z Pro Grad Kit - Z Filter Holder + Z121L + Z123L + Z125L','Cokin U961A Z Pro Grad Kit - Z Filter Holder + Z121L + Z123L + Z125L',850,850),('commerce_product','product',0,74,132,'und',0,218,'Cokin U961A Z Pro Grad Kit - Z Filter Holder + Z121L + Z123L + Z125L','Cokin U961A Z Pro Grad Kit - Z Filter Holder + Z121L + Z123L + Z125L',850,850),('commerce_product','product',0,75,130,'und',0,219,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,130,'und',1,220,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,130,'und',2,221,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,135,'und',0,219,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,135,'und',1,220,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,135,'und',2,221,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,136,'und',0,219,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,136,'und',1,220,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,136,'und',2,221,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,138,'und',0,219,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,138,'und',1,220,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,138,'und',2,221,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,139,'und',0,219,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,139,'und',1,220,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,139,'und',2,221,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,140,'und',0,219,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,140,'und',1,220,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,140,'und',2,221,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,142,'und',0,219,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,142,'und',1,220,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,142,'und',2,221,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,143,'und',0,219,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,143,'und',1,220,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,75,143,'und',2,221,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',850,850),('commerce_product','product',0,76,131,'und',0,222,'CCTV- 850TVL IR DOME CCTV CAMERA','CCTV- 850TVL IR DOME CCTV CAMERA',850,850),('commerce_product','product',0,77,133,'und',0,223,'Trek Ai-Ball Portable Wi-Fi Remote Camera with Cradle & Adaptors (Yellow)','Trek Ai-Ball Portable Wi-Fi Remote Camera with Cradle & Adaptors (Yellow)',850,850),('commerce_product','product',0,77,133,'und',1,224,'Trek Ai-Ball Portable Wi-Fi Remote Camera with Cradle & Adaptors (Yellow)','Trek Ai-Ball Portable Wi-Fi Remote Camera with Cradle & Adaptors (Yellow)',850,850),('commerce_product','product',0,77,133,'und',2,225,'Trek Ai-Ball Portable Wi-Fi Remote Camera with Cradle & Adaptors (Yellow)','Trek Ai-Ball Portable Wi-Fi Remote Camera with Cradle & Adaptors (Yellow)',850,850),('commerce_product','product',0,78,134,'und',0,226,'Mini Quran for Kids Yellow','Mini Quran for Kids Yellow',850,850),('commerce_product','product',0,79,137,'und',0,227,'Boogie Board 10.5 Inch LCD Writing Tablet Pink','Boogie Board 10.5 Inch LCD Writing Tablet Pink',850,850),('commerce_product','product',0,80,141,'und',0,228,'Transporter Carry Cot','Transporter Carry Cot',850,850),('commerce_product','product',0,81,144,'und',0,288,'Kinohimitsu J\'pan BB Drink 50ml x 10','Kinohimitsu J\'pan BB Drink 50ml x 10',850,850),('commerce_product','product',0,82,145,'und',0,289,'TKO Fat Burner Mega','TKO Fat Burner Mega',850,850);
/*!40000 ALTER TABLE `field_revision_field_product_image` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_review`
--

DROP TABLE IF EXISTS `field_revision_field_review`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_review` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_review_rating` int(10) unsigned DEFAULT NULL,
  `field_review_target` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 38 (field_review)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_review`
--

LOCK TABLES `field_revision_field_review` WRITE;
/*!40000 ALTER TABLE `field_revision_field_review` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `field_revision_field_review` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_simplenews_term`
--

DROP TABLE IF EXISTS `field_revision_field_simplenews_term`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_simplenews_term` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_simplenews_term_tid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_simplenews_term_tid` (`field_simplenews_term_tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 5 (field_simplenews_term)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_simplenews_term`
--

LOCK TABLES `field_revision_field_simplenews_term` WRITE;
/*!40000 ALTER TABLE `field_revision_field_simplenews_term` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `field_revision_field_simplenews_term` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_slide`
--

DROP TABLE IF EXISTS `field_revision_field_slide`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_slide` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_slide_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_slide_value` (`field_slide_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 41 (field_slide)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_slide`
--

LOCK TABLES `field_revision_field_slide` WRITE;
/*!40000 ALTER TABLE `field_revision_field_slide` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_slide` VALUES ('node','banner',0,7,7,'und',0,1),('node','banner',0,8,8,'und',0,1),('node','banner',0,11,11,'und',0,0),('node','banner',0,12,12,'und',0,0),('node','banner',0,13,13,'und',0,0),('node','banner',0,14,14,'und',0,0),('node','banner',0,87,87,'und',0,1),('node','banner',0,98,98,'und',0,1),('node','banner',0,99,99,'und',0,1),('node','banner',0,100,100,'und',0,1),('node','banner',0,101,101,'und',0,1),('node','banner',0,102,102,'und',0,1),('node','banner',0,103,103,'und',0,1),('node','banner',0,104,104,'und',0,1),('node','banner',0,105,105,'und',0,1),('node','banner',0,106,106,'und',0,1),('node','banner',0,107,107,'und',0,1),('node','banner',0,108,108,'und',0,1),('node','banner',0,109,109,'und',0,1),('node','banner',0,110,110,'und',0,1),('node','banner',0,111,111,'und',0,1),('node','banner',0,112,112,'und',0,1),('node','banner',0,113,113,'und',0,1),('node','banner',0,114,114,'und',0,1),('node','banner',0,115,115,'und',0,1),('node','banner',0,116,116,'und',0,1),('node','banner',0,117,117,'und',0,1),('node','banner',0,118,118,'und',0,1),('node','banner',0,119,119,'und',0,1),('node','banner',0,120,120,'und',0,1),('node','banner',0,121,121,'und',0,1),('node','banner',0,122,122,'und',0,1),('node','banner',0,123,123,'und',0,1),('node','banner',0,124,124,'und',0,1),('node','banner',0,125,125,'und',0,1),('node','banner',0,126,126,'und',0,1),('node','banner',0,127,127,'und',0,1),('node','banner',0,128,128,'und',0,1),('node','banner',0,129,129,'und',0,1),('node','banner',0,130,130,'und',0,0),('node','banner',0,131,131,'und',0,1),('node','banner',0,132,132,'und',0,1),('node','banner',0,133,133,'und',0,1),('node','banner',0,134,134,'und',0,1),('node','banner',0,135,135,'und',0,1),('node','banner',0,136,136,'und',0,1),('node','banner',0,137,137,'und',0,1),('node','banner',0,140,140,'und',0,1),('node','banner',0,142,142,'und',0,1);
/*!40000 ALTER TABLE `field_revision_field_slide` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_specifications`
--

DROP TABLE IF EXISTS `field_revision_field_specifications`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_specifications` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_specifications_value` int(11) DEFAULT NULL COMMENT 'The field collection item id.',
  `field_specifications_revision_id` int(11) DEFAULT NULL COMMENT 'The field collection item revision id.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_specifications_revision_id` (`field_specifications_revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 35 (field_specifications)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_specifications`
--

LOCK TABLES `field_revision_field_specifications` WRITE;
/*!40000 ALTER TABLE `field_revision_field_specifications` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_specifications` VALUES ('node','product',0,30,30,'und',0,7,7),('node','product',0,30,30,'und',1,8,8),('node','product',0,30,30,'und',2,9,9),('node','product',0,31,31,'und',0,14,14),('node','product',0,31,31,'und',1,15,15),('node','product',0,31,31,'und',2,16,16),('node','product',0,31,31,'und',3,17,17),('node','product',0,32,32,'und',0,18,18),('node','product',0,32,32,'und',1,19,19),('node','product',0,32,32,'und',2,20,20),('node','product',0,32,32,'und',3,21,21),('node','product',0,33,33,'und',0,26,26),('node','product',0,33,33,'und',1,27,27),('node','product',0,33,33,'und',2,28,28),('node','product',0,33,33,'und',3,29,29),('node','product',0,33,33,'und',4,30,30),('node','product',0,34,34,'und',0,33,33),('node','product',0,34,34,'und',1,34,34),('node','product',0,34,34,'und',2,35,35),('node','product',0,35,35,'und',0,36,36),('node','product',0,35,35,'und',1,37,37),('node','product',0,35,35,'und',2,38,38),('node','product',0,35,35,'und',3,39,39),('node','product',0,35,35,'und',4,40,40),('node','product',0,35,35,'und',5,41,41),('node','product',0,36,36,'und',0,42,42),('node','product',0,36,36,'und',1,43,43),('node','product',0,36,36,'und',2,44,44),('node','product',0,36,36,'und',3,45,45),('node','product',0,37,37,'und',0,47,47),('node','product',0,37,37,'und',1,48,48),('node','product',0,37,37,'und',2,49,49),('node','product',0,37,37,'und',3,50,50),('node','product',0,38,38,'und',0,54,54),('node','product',0,38,38,'und',1,55,55),('node','product',0,38,38,'und',2,56,56),('node','product',0,38,38,'und',3,57,57),('node','product',0,39,39,'und',0,58,58),('node','product',0,40,40,'und',0,59,59),('node','product',0,40,40,'und',1,60,60),('node','product',0,40,40,'und',2,61,61),('node','product',0,40,40,'und',3,64,64),('node','product',0,41,41,'und',0,66,66),('node','product',0,41,41,'und',1,67,67),('node','product',0,41,41,'und',2,68,68),('node','product',0,42,42,'und',0,69,69),('node','product',0,42,42,'und',1,70,70),('node','product',0,42,42,'und',2,71,71),('node','product',0,42,42,'und',3,72,72),('node','product',0,43,43,'und',0,75,75),('node','product',0,43,43,'und',1,76,76),('node','product',0,43,43,'und',2,77,77),('node','product',0,43,43,'und',3,78,78),('node','product',0,44,44,'und',0,79,79),('node','product',0,44,44,'und',1,80,80),('node','product',0,44,44,'und',2,81,81),('node','product',0,45,45,'und',0,85,85),('node','product',0,45,45,'und',1,86,86),('node','product',0,45,45,'und',2,87,87),('node','product',0,46,46,'und',0,92,92),('node','product',0,46,46,'und',1,93,93),('node','product',0,46,46,'und',2,94,94),('node','product',0,46,46,'und',3,95,95),('node','product',0,47,47,'und',0,101,101),('node','product',0,47,47,'und',1,102,102),('node','product',0,47,47,'und',2,103,103),('node','product',0,48,48,'und',0,110,110),('node','product',0,49,49,'und',0,111,111),('node','product',0,49,49,'und',1,112,112),('node','product',0,49,49,'und',2,113,113),('node','product',0,49,49,'und',3,114,114),('node','product',0,50,50,'und',0,124,124),('node','product',0,50,50,'und',1,125,125),('node','product',0,50,50,'und',2,126,126),('node','product',0,51,51,'und',0,127,127),('node','product',0,51,51,'und',1,128,128),('node','product',0,51,51,'und',2,129,129),('node','product',0,51,51,'und',3,130,130),('node','product',0,52,52,'und',0,143,143),('node','product',0,52,52,'und',1,144,144),('node','product',0,52,52,'und',2,145,145),('node','product',0,53,53,'und',0,150,150),('node','product',0,53,53,'und',1,151,151),('node','product',0,53,53,'und',2,152,152),('node','product',0,53,53,'und',3,153,153),('node','product',0,54,54,'und',0,155,155),('node','product',0,54,54,'und',1,156,156),('node','product',0,54,54,'und',2,157,157),('node','product',0,55,55,'und',0,160,160),('node','product',0,55,55,'und',1,161,161),('node','product',0,55,55,'und',2,162,162),('node','product',0,55,55,'und',3,163,163),('node','product',0,56,56,'und',0,164,164),('node','product',0,56,56,'und',1,165,165),('node','product',0,56,56,'und',2,166,166),('node','product',0,56,56,'und',3,167,167),('node','product',0,56,56,'und',4,168,168),('node','product',0,57,57,'und',0,169,169),('node','product',0,57,57,'und',1,170,170),('node','product',0,57,57,'und',2,171,171),('node','product',0,58,58,'und',0,175,175),('node','product',0,58,58,'und',1,176,176),('node','product',0,58,58,'und',2,177,177),('node','product',0,59,59,'und',0,178,178),('node','product',0,59,59,'und',1,179,179),('node','product',0,59,59,'und',2,180,180),('node','product',0,60,60,'und',0,181,181),('node','product',0,60,60,'und',1,182,182),('node','product',0,60,60,'und',2,183,183),('node','product',0,61,61,'und',0,184,184),('node','product',0,61,61,'und',1,185,185),('node','product',0,61,61,'und',2,186,186),('node','product',0,62,62,'und',0,187,187),('node','product',0,62,62,'und',1,188,188),('node','product',0,62,62,'und',2,189,189),('node','product',0,63,63,'und',0,190,190),('node','product',0,63,63,'und',1,191,191),('node','product',0,63,63,'und',2,192,192),('node','product',0,64,64,'und',0,193,193),('node','product',0,64,64,'und',1,194,194),('node','product',0,64,64,'und',2,195,195),('node','product',0,65,65,'und',0,196,196),('node','product',0,65,65,'und',1,197,197),('node','product',0,65,65,'und',2,198,198),('node','product',0,66,66,'und',0,199,199),('node','product',0,66,66,'und',1,200,200),('node','product',0,66,66,'und',2,201,201),('node','product',0,67,67,'und',0,202,202),('node','product',0,67,67,'und',1,203,203),('node','product',0,67,67,'und',2,204,204),('node','product',0,68,68,'und',0,205,205),('node','product',0,68,68,'und',1,206,206),('node','product',0,68,68,'und',2,207,207),('node','product',0,69,69,'und',0,208,208),('node','product',0,69,69,'und',1,209,209),('node','product',0,69,69,'und',2,210,210),('node','product',0,70,70,'und',0,211,211),('node','product',0,70,70,'und',1,212,212),('node','product',0,70,70,'und',2,213,213),('node','product',0,71,71,'und',0,214,214),('node','product',0,71,71,'und',1,215,215),('node','product',0,71,71,'und',2,216,216),('node','product',0,72,72,'und',0,217,217),('node','product',0,72,72,'und',1,218,218),('node','product',0,72,72,'und',2,219,219),('node','product',0,73,73,'und',0,220,220),('node','product',0,73,73,'und',1,221,221),('node','product',0,74,74,'und',0,222,222),('node','product',0,74,74,'und',1,223,223),('node','product',0,74,74,'und',2,224,224),('node','product',0,75,75,'und',0,225,225),('node','product',0,75,75,'und',1,226,226),('node','product',0,75,75,'und',2,227,227),('node','product',0,76,76,'und',0,228,228),('node','product',0,76,76,'und',1,229,229),('node','product',0,76,76,'und',2,230,230),('node','product',0,77,77,'und',0,234,234),('node','product',0,77,77,'und',1,235,235),('node','product',0,77,77,'und',2,236,236),('node','product',0,78,78,'und',0,237,237),('node','product',0,78,78,'und',1,238,238),('node','product',0,78,78,'und',2,239,239),('node','product',0,79,79,'und',0,240,240),('node','product',0,79,79,'und',1,241,241),('node','product',0,79,79,'und',2,242,242),('node','product',0,80,80,'und',0,243,243),('node','product',0,80,80,'und',1,244,244),('node','product',0,80,80,'und',2,245,245),('node','product',0,81,81,'und',0,246,246),('node','product',0,81,81,'und',1,247,247),('node','product',0,81,81,'und',2,248,248),('node','product',0,82,82,'und',0,249,249),('node','product',0,82,82,'und',1,250,250),('node','product',0,82,82,'und',2,251,251),('node','product',0,83,83,'und',0,252,252),('node','product',0,83,83,'und',1,253,253),('node','product',0,83,83,'und',2,254,254),('node','product',0,84,84,'und',0,255,255),('node','product',0,84,84,'und',1,256,256),('node','product',0,84,84,'und',2,257,257),('node','product',0,85,85,'und',0,258,258),('node','product',0,85,85,'und',1,259,259),('node','product',0,85,85,'und',2,260,260),('node','product',0,86,86,'und',0,261,261),('node','product',0,86,86,'und',1,262,262),('node','product',0,86,86,'und',2,263,263),('node','product',0,88,88,'und',0,267,267),('node','product',0,88,88,'und',1,268,268),('node','product',0,88,88,'und',2,269,269),('node','product',0,88,88,'und',3,270,270),('node','product',0,89,89,'und',0,271,271),('node','product',0,89,89,'und',1,272,272),('node','product',0,89,89,'und',2,273,273),('node','product',0,90,90,'und',0,274,274),('node','product',0,90,90,'und',1,275,275),('node','product',0,90,90,'und',2,276,276),('node','product',0,91,91,'und',0,277,277),('node','product',0,91,91,'und',1,278,278),('node','product',0,91,91,'und',2,279,279),('node','product',0,92,92,'und',0,280,280),('node','product',0,92,92,'und',1,281,281),('node','product',0,92,92,'und',2,282,282),('node','product',0,93,93,'und',0,283,283),('node','product',0,93,93,'und',1,284,284),('node','product',0,93,93,'und',2,285,285),('node','product',0,94,94,'und',0,286,286),('node','product',0,94,94,'und',1,287,287),('node','product',0,94,94,'und',2,288,288),('node','product',0,95,95,'und',0,289,289),('node','product',0,95,95,'und',1,290,290),('node','product',0,95,95,'und',2,291,291),('node','product',0,96,96,'und',0,292,292),('node','product',0,96,96,'und',1,293,293),('node','product',0,96,96,'und',2,294,294),('node','product',0,97,97,'und',0,295,295),('node','product',0,97,97,'und',1,296,296),('node','product',0,97,97,'und',2,297,297),('node','product',0,138,138,'und',0,298,298),('node','product',0,138,138,'und',1,299,299),('node','product',0,138,138,'und',2,300,300),('node','product',0,139,139,'und',0,301,301),('node','product',0,139,139,'und',1,302,302),('node','product',0,139,139,'und',2,303,303);
/*!40000 ALTER TABLE `field_revision_field_specifications` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_summary`
--

DROP TABLE IF EXISTS `field_revision_field_summary`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_summary` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_summary_value` longtext,
  `field_summary_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_summary_format` (`field_summary_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 33 (field_summary)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_summary`
--

LOCK TABLES `field_revision_field_summary` WRITE;
/*!40000 ALTER TABLE `field_revision_field_summary` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_summary` VALUES ('node','product',0,31,31,'und',0,'<ul>\r\n	<li>Material: Nylon</li>\r\n	<li>Multiple comparments</li>\r\n	<li>Spacious designDurable</li>\r\n	<li>Fitsyourlaptop</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,33,33,'und',0,'<ul>\r\n	<li>Aliquam erat volutpat</li>\r\n	<li>Phasellus facilisis nulla lacus</li>\r\n	<li>Cras ex dolor, consectetur sit amet auctor iaculis, porttitor sit amet justo</li>\r\n	<li>Sed sed gravida tellus</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,34,34,'und',0,'<ul>\r\n	<li>Zippered main compartment</li>\r\n	<li>Zippered back compartment for towel or slipper</li>\r\n	<li>Neoprene grab handle</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,36,36,'und',0,'<ul>\r\n	<li>Brush: Soft synthetic fibres and pony hair</li>\r\n	<li>Handle: Bamboo</li>\r\n	<li>Ferrule: Aluminium</li>\r\n	<li>Pouch: PU leather</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,37,37,'und',0,'<ul>\r\n	<li>48x Eyeshadow.</li>\r\n	<li>24x Lip Color.</li>\r\n	<li>2x Pressed Powder.</li>\r\n	<li>4x Blusher.</li>\r\n	<li>5x ApplicatorWell coordinated &amp; trendy color.</li>\r\n	<li>Fine texture &amp; glides on smoothly on skin.</li>\r\n	<li>Velvety smooth &amp; stay-true color.</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,39,39,'und',0,'<ul>\r\n	<li>Facial Treatment Gentle Cleanser 20g</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,40,40,'und',0,'<p><strong>Good for:</strong></p>\r\n\r\n<ul>\r\n	<li>All skin types including sensitive skin</li>\r\n	<li>Anti-ageing</li>\r\n	<li>Reducing puffiness, dryness and dark circles</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,42,42,'und',0,'<ul>\r\n	<li>Salon grade, high-powered hair dryer comes with 2 nozzles.</li>\r\n	<li>Italian Design Motor</li>\r\n	<li>Intalian Switch</li>\r\n	<li>Low Noise 1800W.</li>\r\n	<li>3&nbsp;heat (cold&nbsp;&amp;&nbsp;hot) and speed (high, low, off) setting</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,44,44,'und',0,'<p><strong>What\'s in the Box:</strong></p>\r\n\r\n<ul>\r\n	<li>iphone6 &nbsp;x1</li>\r\n	<li>cable x1</li>\r\n	<li>charger x1</li>\r\n	<li>headset x1</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,45,45,'und',0,'<p><strong>Galaxy Note 4 Size &amp; Display</strong><br />\r\nThe phone measures 153.5 x 78.6 x 8.5 mm. The screen size remains the same as its predecessor, the Note 3, at 5.7-inches using the familiar Super AMOLED display with its over-saturated, bright colors</p>\r\n','filtered_html'),('node','product',0,46,46,'und',0,'<ul>\r\n	<li>ASUS desktops – leading in satisfaction with reliability</li>\r\n	<li>Windows 8 All-in-One PC</li>\r\n	<li>Enjoy Windows 8 anywhere in the home</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,47,47,'und',0,'<ul>\r\n	<li>Android 2.3</li>\r\n	<li>2MP camera</li>\r\n	<li>512MB internal / 265MB RAM</li>\r\n	<li>1.3GHz MTK6572 dual-core</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,48,48,'und',0,'<ul>\r\n	<li>Dual SIM</li>\r\n	<li>1.3MP camera</li>\r\n	<li>FM radio / Multimedia player</li>\r\n	<li>Bluetooth 2.1 + EDR</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,49,49,'und',0,'<ul>\r\n	<li>9.7-inch Retina display with Multi-Touch</li>\r\n	<li>Dual-core A5X chip with quad-core graphics</li>\r\n	<li>5MP iSight camera and FaceTime camera</li>\r\n	<li>1080p HD video recording</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,50,50,'und',0,'<ul>\r\n	<li>Affordable</li>\r\n	<li>High Quality</li>\r\n	<li>Long lasting</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,51,51,'und',0,'<ul>\r\n	<li>TABLET 8.0\"1366 x 768 IPS TOUCH</li>\r\n	<li>INTEL ATOM Z3740 (2M UP TO 1.86GHZ)</li>\r\n	<li>2GB RAM</li>\r\n	<li>64GB</li>\r\n	<li>INTEL HD</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,52,52,'und',0,'<ul>\r\n	<li>16GB Capacity</li>\r\n	<li>9.7-inch Retina Display with 264ppi</li>\r\n	<li>A7 chip with 64-bit architecture</li>\r\n	<li>Ultrafast wireless - Wi-Fi (802.11a/b/g/n) with MIMO</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,53,53,'und',0,'<ul>\r\n	<li>Advanced Shock Absorption Technology</li>\r\n	<li>Premium Dia-Cut Edges on PC Frame</li>\r\n	<li>Compatible with Beats by Dre headphones</li>\r\n	<li>Compatible with samsung Galaxy Note4 Only-2014</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,54,54,'und',0,'<ul>\r\n	<li>Flip Cover with smart, interactive window providing quick access to key phone features</li>\r\n	<li>View Weather, Pedometer, Date/Time on Home Screen</li>\r\n	<li>Swipe to preview Messages/Missed Calls</li>\r\n	<li>Swipe to access Quick Camera and Video Recorder</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,55,55,'und',0,'<ul>\r\n	<li>Lightweigh; portable design</li>\r\n	<li>Designed perfectly to fit Samsung Galaxy Tab 7.0 inch</li>\r\n	<li>Holds and charge your device</li>\r\n	<li>Plug and play simplicity</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,56,56,'und',0,'<ul>\r\n	<li>Easy installation: just 1 minute to install on the windshield.</li>\r\n	<li>Easy to rotate the bracket arm at 360 degree.</li>\r\n	<li>The clip width is adjustable to fit most sizes of devices.</li>\r\n	<li>The clip is designed with soft foam, prevent your cellphone from scratching.</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,57,57,'und',0,'<ul>\r\n	<li>Deeper</li>\r\n	<li>Richer bass tones</li>\r\n	<li>Greater protection from sweat and water</li>\r\n	<li>Control music and video playback</li>\r\n	<li>Answer and end calls</li>\r\n	<li>Genuine Apple products</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,58,58,'und',0,'<ul>\r\n	<li>Speaker type: 9.2mm dynamic; 16ohm</li>\r\n	<li>Ear coupling: Insert</li>\r\n	<li>Nominal Impedance: 18±3ohm</li>\r\n	<li>Driver type: Dynamic</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,59,59,'und',0,'<ul>\r\n	<li>10400mAh High Capacity</li>\r\n	<li>Portable and Pocket Size</li>\r\n	<li>2.1A High Power single output</li>\r\n	<li>Fast charging Powerbank</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,60,60,'und',0,'<ul>\r\n	<li>20000mAh</li>\r\n	<li>2 USB ports</li>\r\n	<li>Compatible with many devices</li>\r\n	<li>LED indicators</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,61,61,'und',0,'<ul>\r\n	<li>Necklace length: 40cm – 45cm (adjustable)</li>\r\n	<li>4 layer Pre-polishing 18K White Gold Plated for smoother finish</li>\r\n	<li>Hand-picked Swarovski Elements</li>\r\n	<li>All Occasion Stunner</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,62,62,'und',0,'<ul>\r\n	<li>Mix of faceted black gem, crystal glass, multicolour beads and rhinestones</li>\r\n	<li>Black rope detail</li>\r\n	<li>Antique bronze-tone plating</li>\r\n	<li>Lobster clasp closure</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,63,63,'und',0,'<ul>\r\n	<li>Great for a hippie-inspired look</li>\r\n	<li>One-size-fits-all</li>\r\n	<li>Large buckle</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,64,64,'und',0,'<ul>\r\n	<li>Suitable for formal &amp; casual wear</li>\r\n	<li>With two loops for a customized fit</li>\r\n	<li>Great for colour blocking styles</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,65,65,'und',0,'<ul>\r\n	<li>Material: Cotton Blends</li>\r\n	<li>Size: 130cm x130cm</li>\r\n	<li>Big square comfortable scarf</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,66,66,'und',0,'<ul>\r\n	<li>Material: Viscose</li>\r\n	<li>Size: 90cm x180cm</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,67,67,'und',0,'<ul>\r\n	<li>Analog watch</li>\r\n	<li>Stainless Steel Strap with Round Case and Black Dial</li>\r\n	<li>Japan movement</li>\r\n	<li>Water resistant up to 10 ATM</li>\r\n	<li>Case Dimension: 46 mm</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,68,68,'und',0,'<ul>\r\n	<li>Dial Type: Analog.&nbsp;</li>\r\n	<li>Luminescent hands and markers.&nbsp;</li>\r\n	<li>Automatic movement.&nbsp;</li>\r\n	<li>Scratch resistant sapphire crystal.&nbsp;</li>\r\n	<li>Screw down crown.</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,69,69,'und',0,'<ul>\r\n	<li>Altimeter, barometer, compass</li>\r\n	<li>Weather trend indicator</li>\r\n	<li>Temperature</li>\r\n	<li>Altitude difference measurement</li>\r\n	<li>Altitude log</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,70,70,'und',0,'<ul>\r\n	<li>Casing Material : ABS+PU</li>\r\n	<li>Wristband Material : Rubber</li>\r\n	<li>Display : Analog + Digital</li>\r\n	<li>Display Format : 12/24 hour time format</li>\r\n	<li>Water Resistant : 30m Water Resistant</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,71,71,'und',0,'<ul>\r\n	<li>40\" Display</li>\r\n	<li>1920 x 1080</li>\r\n	<li>4 HDMI</li>\r\n	<li>3 USB</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,72,72,'und',0,'<ul>\r\n	<li>48\" Full HD Screen</li>\r\n	<li>LED TV</li>\r\n	<li>1920 x 1080p Resolution</li>\r\n	<li>Clear Resolution Enhancer</li>\r\n	<li>Bass Reflex Box Speakers</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,73,73,'und',0,'<ul>\r\n	<li>High-resolution Audio Capability&nbsp;</li>\r\n	<li>9.1 channel&nbsp;</li>\r\n	<li>Digital Music Arena Mode&nbsp;</li>\r\n	<li>Virtual Football Mode</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,74,74,'und',0,'<ul>\r\n	<li>CD DA / CD-R / CD-RW</li>\r\n	<li>DVD-Video / DVD±R / DVD±RW/ VCD 1.1</li>\r\n	<li>5.1 Channel</li>\r\n	<li>My Karaoke</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,75,75,'und',0,'<ul>\r\n	<li>Best OLED display module</li>\r\n	<li>High quality of Bluetooth V3.0</li>\r\n	<li>Diverse functions attached: answer calls, listen to music, time display etc.</li>\r\n	<li>Led signal lights design: easy to operate and use.</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,76,76,'und',0,'<ul>\r\n	<li>Processor : Apple single-core A5 chipSystem Requirements : Wi-Fi (802.11a</li>\r\n	<li>Wireless network (wireless video streaming requires 802.11a</li>\r\n	<li>10/100BASE-T Ethernet network.iTunes Store account.MLB.TV</li>\r\n	<li>NHL GameCenter Live: subscription required to watch live and archived games.</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,77,77,'und',0,'<ul>\r\n	<li>Intel Core i7-4770 Processor (Up To 3.9GHz)</li>\r\n	<li>8GB DDR3 Ram</li>\r\n	<li>2TB Harddisk</li>\r\n	<li>2GB GDDR5 NVIDIA GTX 780</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,78,78,'und',0,'<ul>\r\n	<li>High quality HDMI switcher with intelligent function</li>\r\n	<li>3-group input 1-group output</li>\r\n	<li>Supports with HDMI1.3b</li>\r\n	<li>Full HD 1080p</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,79,79,'und',0,'<ul>\r\n	<li>Lifetime Limited Dell Standard Technical Support</li>\r\n	<li>Lifetime Limited Hardware Warranty</li>\r\n	<li>Layer 2 Managed Gigabit Switches</li>\r\n	<li>Voice Capability</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,80,80,'und',0,'<ul>\r\n	<li>Mobile WiFi Hotspot</li>\r\n	<li>2000mAh rechargeable battery</li>\r\n	<li>HSPA+ Support</li>\r\n	<li>21.6Mbps download speed</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,81,81,'und',0,'<ul>\r\n	<li>Wireless router 4-port switch</li>\r\n	<li>2.4GHz &amp; 5GHz</li>\r\n	<li>Up to 450Mbps</li>\r\n	<li>3 external antennas</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,82,82,'und',0,'<ul>\r\n	<li>Flatbed scanner</li>\r\n	<li>Scan speed (A4 300dpi): 10secs</li>\r\n	<li>Scan resolution: 4800 x 4800dpi</li>\r\n	<li>Usb 2.0</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,83,83,'und',0,'<ul>\r\n	<li>4800 X 9600 DPI</li>\r\n	<li>4 CUSTOMISABLE BUTTONS</li>\r\n	<li>ZERO WARM-UP TIME</li>\r\n	<li>BUNDLED SOFTWARE</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,84,84,'und',0,'<ul>\r\n	<li>16.1MP12.5X Optical Zoom4X Digital Zoom1</li>\r\n	<li>2.3-inch high-speed CMOS(back illuminated type)</li>\r\n	<li>3.0-inch TFT color LCD (Super Clear LCD)LCD tilts to make a snap for self-portraits</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,85,85,'und',0,'<ul>\r\n	<li>16.1MP High Sensitivity CMOS Sensor</li>\r\n	<li>DIGIC 6 Image Processor</li>\r\n	<li>65x Optical Zoom Lens</li>\r\n	<li>21-1,365mm (35mm Equivalent)</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,86,86,'und',0,'<ul>\r\n	<li>18.0MP</li>\r\n	<li>3x - 10x zoom</li>\r\n	<li>3.2’ LCD screen</li>\r\n	<li>SD/SDHC/SDXC compatible</li>\r\n	<li>Full HD recording</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,88,88,'und',0,'<ul>\r\n	<li>0.5 Megapixel</li>\r\n	<li>3\" Flip-up LCD display</li>\r\n	<li>2GB built-in memory</li>\r\n	<li>Capture 1080p HD Video</li>\r\n	<li>Li-ion rechargeable battery - 2330 mAh</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,89,89,'und',0,'<ul>\r\n	<li>Autofocus lens</li>\r\n	<li>58mm filter size</li>\r\n	<li>No image stabilisation</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,91,91,'und',0,'<ul>\r\n	<li>Helps Control Depth of Field</li>\r\n	<li>Helps Create Certain Special Effects</li>\r\n	<li>High Quality CR39 Resin</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,92,92,'und',0,'<ul>\r\n	<li>Night Vision</li>\r\n	<li>Sound and Motion Detection</li>\r\n	<li>Remote Viewing</li>\r\n	<li>Local Recording</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,93,93,'und',0,'<ul>\r\n	<li>High resolution</li>\r\n	<li>Plastic housing black and white</li>\r\n	<li>Lens option: 3.6mm/ 6mm</li>\r\n	<li>Auto Gain Control (AGC)</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,94,94,'und',0,'<ul>\r\n	<li>VGA 640x480, QVGA 320x240, QQVGA 160x120, up to 30fps&nbsp;</li>\r\n	<li>F2.8&nbsp;</li>\r\n	<li>View Angle: 60 degree&nbsp;</li>\r\n	<li>Focusing: 20cm to Infinity&nbsp;</li>\r\n	<li>Motion JPEG&nbsp;</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,95,95,'und',0,'<ul>\r\n	<li>On/Off button in the back</li>\r\n	<li>For ages 3 and above</li>\r\n	<li>Requires 3x AAA batteries (not included)</li>\r\n	<li>The Islamic Quran play machine with projection</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,96,96,'und',0,'<ul>\r\n	<li>Writing tablet created to make lists, draw or jot down paperless notes</li>\r\n	<li>“Green” alternative to sticky notes, memo pads, paper and ink</li>\r\n	<li>Less than a 1/4\" thin and is easy to take with you in a purse, scheduler, briefcase or backpack</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,97,97,'und',0,'<ul>\r\n	<li>Practical carry handles.</li>\r\n	<li>Ideal for fitting to the Chicco Ct 0.2 Stroller</li>\r\n	<li>Removable sun canopy.</li>\r\n	<li>Internal lining in breathable fabric.</li>\r\n	<li>The removable and adjustable blanket allows you to use the carrycot in every season.</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,138,138,'und',0,'<ul>\r\n	<li>Beauty drink</li>\r\n	<li>50ml x 10\'s</li>\r\n	<li>100% All-Natural Ingredients</li>\r\n	<li>Promotes healthier &amp; luminous skin</li>\r\n</ul>\r\n','filtered_html'),('node','product',0,139,139,'und',0,'<ul>\r\n	<li>Top Quality Premium Fat Burner</li>\r\n	<li>Increases Energy&nbsp;</li>\r\n	<li>Efficient Carbohydrate Blocker</li>\r\n</ul>\r\n','filtered_html');
/*!40000 ALTER TABLE `field_revision_field_summary` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_tags`
--

DROP TABLE IF EXISTS `field_revision_field_tags`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_tags` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_tags_tid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_tags_tid` (`field_tags_tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 3 (field_tags)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_tags`
--

LOCK TABLES `field_revision_field_tags` WRITE;
/*!40000 ALTER TABLE `field_revision_field_tags` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `field_revision_field_tags` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_withdraw_name`
--

DROP TABLE IF EXISTS `field_revision_field_withdraw_name`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_withdraw_name` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_withdraw_name_value` varchar(255) DEFAULT NULL,
  `field_withdraw_name_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_withdraw_name_format` (`field_withdraw_name_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 56 (field_withdraw_name)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_withdraw_name`
--

LOCK TABLES `field_revision_field_withdraw_name` WRITE;
/*!40000 ALTER TABLE `field_revision_field_withdraw_name` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `field_revision_field_withdraw_name` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_notes`
--

DROP TABLE IF EXISTS `field_revision_notes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_notes` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `notes_value` longtext,
  `notes_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `notes_format` (`notes_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 54 (notes)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_notes`
--

LOCK TABLES `field_revision_notes` WRITE;
/*!40000 ALTER TABLE `field_revision_notes` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `field_revision_notes` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_title_field`
--

DROP TABLE IF EXISTS `field_revision_title_field`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_title_field` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `title_field_value` varchar(255) DEFAULT NULL,
  `title_field_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `title_field_format` (`title_field_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 47 (title_field)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_title_field`
--

LOCK TABLES `field_revision_title_field` WRITE;
/*!40000 ALTER TABLE `field_revision_title_field` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_title_field` VALUES ('node','product',0,30,30,'und',0,'Aeroline Casual Hiking Backpack Dark Blue',NULL),('node','product',0,31,31,'und',0,'Local Lion Water Resistant Hiking Backpack Bag 28L Blue',NULL),('node','product',0,32,32,'und',0,'Terminus T02-297LAP-01 Laptop Backpack Plus',NULL),('node','product',0,33,33,'und',0,'Targus Tsb166Ap 15.6In Revolution Backpack Xl',NULL),('node','product',0,34,34,'und',0,'Tarantula Shoe Bag (BOS04-088SHB-03) - Red',NULL),('node','product',0,35,35,'und',0,'Diniwell Water-Resistant Travel Shoes Bag Pouch Organizer Bag Ver 2 - Orange',NULL),('node','product',0,36,36,'und',0,'24-Piece Makeup Brush Set',NULL),('node','product',0,37,37,'und',0,'Cameleon MakeUp Kit 396',NULL),('node','product',0,38,38,'und',0,'4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner',NULL),('node','product',0,39,39,'und',0,'SK-II 5-Piece Skincare Travel Set 5pcs Travel Packs SKII SK2',NULL),('node','product',0,40,40,'und',0,'Organic Eye Cream 15ml',NULL),('node','product',0,41,41,'und',0,'Mejikaliner Quick Eyelid Essence Stick Glue - Night Use',NULL),('node','product',0,42,42,'und',0,'Hairscape 1800W (AUS) 5000 Professional Hair Dryer',NULL),('node','product',0,43,43,'und',0,'Tonific Slimming Massager',NULL),('node','product',0,44,44,'und',0,'Apple iPhone 6 16GB Gold',NULL),('node','product',0,45,45,'und',0,'Samsung N910 Note 4 LTE 32GB White',NULL),('node','product',0,46,46,'und',0,'Asus Transformer P1801-B041K AIO 18.4\" PC Dekstop + Asus RT-N56U Wireless N N600 Dual-Band Gigabit Router',NULL),('node','product',0,47,47,'und',0,'Lenovo A316',NULL),('node','product',0,48,48,'und',0,'Nokia Asha 206 Dual SIM Black',NULL),('node','product',0,49,49,'und',0,'Apple IPAD 3 Wi-Fi+4G MD368 64GB Black',NULL),('node','product',0,50,50,'und',0,'Asus Memopad 7 (Tablet)',NULL),('node','product',0,51,51,'und',0,'Lenovo Tablet Miix 2 59399848 8\" Silver',NULL),('node','product',0,52,52,'und',0,'Apple iPad Air 16GB WiFi Space Grey (MD785ZPA)',NULL),('node','product',0,53,53,'und',0,'Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold',NULL),('node','product',0,54,54,'und',0,'[GENUINE] SAMSUNG Galaxy Note 4 S View Classic Cover Case - Black',NULL),('node','product',0,55,55,'und',0,'Samsung Galaxy Tab 7.0 Plus Vehicle Dock With In-Car Charger',NULL),('node','product',0,56,56,'und',0,'Angel Universal Mobile Phone In Car Phone Holder 360 degree Item Code: P338',NULL),('node','product',0,57,57,'und',0,'Original Apple Earpod Earphone with Remote & Mic for iPhone iPad iPod',NULL),('node','product',0,58,58,'und',0,'Sony Stereo Bluetooth Headset SBH20 Black',NULL),('node','product',0,59,59,'und',0,'TOP Mi 10400mAh Powerbank - Black',NULL),('node','product',0,60,60,'und',0,'Universal Dual-Port Power Bank 20000mAh Black',NULL),('node','product',0,61,61,'und',0,'MuWo Trendz Swarovski Element White Gold Plated Everlasting Love Set',NULL),('node','product',0,62,62,'und',0,'LUCCACAL Multi Color Tribal Necklace',NULL),('node','product',0,63,63,'und',0,'Dandelion Women Braided Belt White',NULL),('node','product',0,64,64,'und',0,'Dandelion Cross Stitch Belt Orange',NULL),('node','product',0,65,65,'und',0,'Fur Nyce Big Square Classic Chain Pattern Print Scarf',NULL),('node','product',0,66,66,'und',0,'Fur Nyce Fashion Zebra Pattern Print Scarf White',NULL),('node','product',0,67,67,'und',0,'Invicta Pro Diver Men Black Stainless Steel Strap Watch 15422',NULL),('node','product',0,68,68,'und',0,'Rolex Submariner Black Dial Stainless Steel Automatic Mens Watch 114060',NULL),('node','product',0,69,69,'und',0,'SUUNTO VECTOR BLACK SUSS010600610 MOUNTAIN OUTDOOR WATCH ',NULL),('node','product',0,70,70,'und',0,'SKMEI 0955 30m Waterproof Analogue Digital Dual Time Men\'s Sports Watch Black + Green',NULL),('node','product',0,71,71,'und',0,'Samsung 4\'\' Full HD LED TV - UA40H5008ARXXM Series 5',NULL),('node','product',0,72,72,'und',0,'Sony 48\" Full HD LED TV - BRAVIA Model KDL-48R470B',NULL),('node','product',0,73,73,'und',0,'Sony BDV-N9200W 9.1 Cinema Studio 3D Blu-Ray Disc home Theatre System',NULL),('node','product',0,74,74,'und',0,'Samsung HT-E350K DVD Home Theater System',NULL),('node','product',0,75,75,'und',0,'L12S OLED Smart Watch Bluetooth 3.0 Bracelet Wrist Design for IOS Android iPhone Samsung Smart Phone Blue',NULL),('node','product',0,76,76,'und',0,'ORI Apple TV',NULL),('node','product',0,77,77,'und',0,'Dell Alienware X51-77822G Gaming Desktop',NULL),('node','product',0,78,78,'und',0,'3 Port HDMI Switch With Remote Control',NULL),('node','product',0,79,79,'und',0,'Dell PowerConnect 5524P 24 GbE Port Managed L2 Switch with PoE support 10GbE and Stacking Capable',NULL),('node','product',0,80,80,'und',0,'TP-Link M5250 N900 3G Mobile WiFi Black',NULL),('node','product',0,81,81,'und',0,'TP-LINK N750 Wireless Dual Band Gigabit Router TL-WDR4300 Black',NULL),('node','product',0,82,82,'und',0,'Canon LiDE 210 Scanner',NULL),('node','product',0,83,83,'und',0,'Epson Perfection V33 Scanner',NULL),('node','product',0,84,84,'und',0,'CASIO Exilim EX-ZR1500 Digital Camera Pink',NULL),('node','product',0,85,85,'und',0,'Canon PowerShot SX60 HS 16.1MP Black + 8GB + Case',NULL),('node','product',0,86,86,'und',0,'Canon EOS 600D 18MP + 18-55mm Lens',NULL),('node','product',0,88,88,'und',0,'Samsung Smart Camera NX Mini 20.5MP Green + 9mm Lens + 16 GB Memory Card',NULL),('node','product',0,89,89,'und',0,'Nikon AF-S 50mm Lens f/1.8G',NULL),('node','product',0,90,90,'und',0,'Canon EF-S Lens 18-200mm f/3.5-5.6 IS',NULL),('node','product',0,91,91,'und',0,'Cokin U961A Z Pro Grad Kit - Z Filter Holder + Z121L + Z123L + Z125L',NULL),('node','product',0,92,92,'und',0,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',NULL),('node','product',0,93,93,'und',0,'CCTV- 850TVL IR DOME CCTV CAMERA ',NULL),('node','product',0,94,94,'und',0,'Trek Ai-Ball Portable Wi-Fi Remote Camera with Cradle & Adaptors (Yellow)',NULL),('node','product',0,95,95,'und',0,'Mini Quran for Kids Yellow',NULL),('node','product',0,96,96,'und',0,'Boogie Board 10.5 Inch LCD Writing Tablet Pink',NULL),('node','product',0,97,97,'und',0,'Transporter Carry Cot',NULL),('node','product',0,138,138,'und',0,'Kinohimitsu J\'pan BB Drink 50ml x 10',NULL),('node','product',0,139,139,'und',0,'TKO Fat Burner Mega',NULL);
/*!40000 ALTER TABLE `field_revision_title_field` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_withdraw_method`
--

DROP TABLE IF EXISTS `field_revision_withdraw_method`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_withdraw_method` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `withdraw_method_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `withdraw_method_target_id` (`withdraw_method_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 55 (withdraw_method)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_withdraw_method`
--

LOCK TABLES `field_revision_withdraw_method` WRITE;
/*!40000 ALTER TABLE `field_revision_withdraw_method` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `field_revision_withdraw_method` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `file_managed`
--

DROP TABLE IF EXISTS `file_managed`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `file_managed` (
  `fid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'File ID.',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The users.uid of the user who is associated with the file.',
  `filename` varchar(255) NOT NULL DEFAULT '' COMMENT 'Name of the file with no path components. This may differ from the basename of the URI if the file is renamed to avoid overwriting an existing file.',
  `uri` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '' COMMENT 'The URI to access the file (either local or remote).',
  `filemime` varchar(255) NOT NULL DEFAULT '' COMMENT 'The file’s MIME type.',
  `filesize` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT 'The size of the file in bytes.',
  `status` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A field indicating the status of the file. Two status are defined in core: temporary (0) and permanent (1). Temporary files older than DRUPAL_MAXIMUM_TEMP_FILE_AGE will be removed during a cron run.',
  `timestamp` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'UNIX timestamp for when the file was added.',
  PRIMARY KEY (`fid`),
  UNIQUE KEY `uri` (`uri`),
  KEY `uid` (`uid`),
  KEY `status` (`status`),
  KEY `timestamp` (`timestamp`)
) ENGINE=InnoDB AUTO_INCREMENT=298 DEFAULT CHARSET=utf8 COMMENT='Stores information for uploaded files.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `file_managed`
--

LOCK TABLES `file_managed` WRITE;
/*!40000 ALTER TABLE `file_managed` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `file_managed` VALUES (19,1,'apple-3376-749791-1-zoom.jpg','public://products/apple-3376-749791-1-zoom.jpg','image/jpeg',43315,1,1416382955),(20,1,'apple-9042-269601-1-zoom.jpg','public://products/apple-9042-269601-1-zoom.jpg','image/jpeg',74526,1,1416383403),(26,1,'HC618_0.jpg','public://products/HC618_0.jpg','image/jpeg',15707,1,1416383608),(27,1,'imac-holiday-hero-xl-2015.png','public://products/imac-holiday-hero-xl-2015.png','image/png',205655,1,1416386395),(33,1,'safeshoppingonline21.jpg','public://field/bean/safeshoppingonline21.jpg','image/jpeg',39451,1,1416901656),(34,1,'returns.jpg','public://field/bean/returns.jpg','image/jpeg',9725,1,1416902023),(35,1,'url.jpg','public://field/bean/url.jpg','image/jpeg',924306,1,1416902151),(36,1,'Online_Revolution.jpg','public://field/bean/Online_Revolution.jpg','image/jpeg',85468,1,1416902273),(37,1,'safesecure.jpg','public://field/bean/safesecure.jpg','image/jpeg',125974,1,1416902413),(38,1,'service.jpg','public://field/bean/service.jpg','image/jpeg',79258,1,1416902634),(39,1,'safesecure.jpg','public://field/bean/safesecure_0.jpg','image/jpeg',40458,1,1416902705),(40,1,'safeshoppingonline21.jpg','public://field/bean/safeshoppingonline21_0.jpg','image/jpeg',31536,1,1416906747),(41,1,'safesecure.jpg','public://field/bean/safesecure_1.jpg','image/jpeg',25431,1,1416906799),(42,1,'returns.jpg','public://field/bean/returns_0.jpg','image/jpeg',9559,1,1416906823),(43,1,'online-revolution.jpg','public://field/bean/online-revolution.jpg','image/jpeg',24915,1,1416906872),(44,1,'service.jpg','public://field/bean/service_0.jpg','image/jpeg',56446,1,1416908111),(45,1,'shop-online.jpg','public://field/bean/shop-online.jpg','image/jpeg',28922,1,1416908387),(46,1,'shop-online.jpg','public://field/bean/shop-online_0.jpg','image/jpeg',20445,1,1416908593),(47,1,'service.jpg','public://field/bean/service_1.jpg','image/jpeg',46616,1,1416908608),(49,1,'online-revolution.jpg','public://field/bean/online-revolution_0.jpg','image/jpeg',24915,1,1416908642),(50,1,'returns.jpg','public://field/bean/returns_1.jpg','image/jpeg',10569,1,1416908659),(51,1,'safesecure.jpg','public://field/bean/safesecure_2.jpg','image/jpeg',21903,1,1416908675),(52,1,'safeshoppingonline21.jpg','public://field/bean/safeshoppingonline21_1.jpg','image/jpeg',26636,1,1416908698),(53,1,'brand-1.png','public://field/brand/brand-1.png','image/png',5270,1,1416913442),(54,1,'brand-2.png','public://field/brand/brand-2.png','image/png',4510,1,1416913455),(55,1,'brand-3.png','public://field/brand/brand-3.png','image/png',4956,1,1416913471),(58,1,'slide-affiliate-1.jpg','public://banner/slide-affiliate-1.jpg','image/jpeg',118375,1,1416978001),(59,1,'slide-affiliate-2.jpg','public://banner/slide-affiliate-2.jpg','image/jpeg',186880,1,1416978006),(60,1,'adv-3.png','public://banner/adv-3.png','image/png',26601,1,1417145674),(61,1,'adv-2.png','public://banner/adv-2.png','image/png',22500,1,1417145701),(62,1,'adv-4.png','public://banner/adv-4.png','image/png',15373,1,1417145747),(63,1,'adv-1.png','public://banner/adv-1.png','image/png',18105,1,1417145783),(75,1,'aeroline-casual-hiking-1.jpg','public://products/aeroline-casual-hiking-1.jpg','image/jpeg',61128,1,1417427576),(76,1,'aeroline-casual-hiking-black-blue.jpg','public://products/aeroline-casual-hiking-black-blue_0.jpg','image/jpeg',171534,1,1417429431),(77,1,'aeroline-casual-hiking-black-blue-1.jpg','public://products/aeroline-casual-hiking-black-blue-1_0.jpg','image/jpeg',161150,1,1417429802),(78,1,'aeroline-casual-hiking-black-blue-2.jpg','public://products/aeroline-casual-hiking-black-blue-2_0.jpg','image/jpeg',139655,1,1417429802),(79,1,'aeroline-casual-hiking-orange.jpg','public://products/aeroline-casual-hiking-orange_0.jpg','image/jpeg',101382,1,1417429802),(80,1,'aeroline-casual-hiking-orange-1.jpg','public://products/aeroline-casual-hiking-orange-1_0.jpg','image/jpeg',95088,1,1417429802),(81,1,'aeroline-casual-hiking-orange-2.jpg','public://products/aeroline-casual-hiking-orange-2_0.jpg','image/jpeg',71461,1,1417429802),(82,1,'local-lion-blue.jpg','public://products/local-lion-blue.jpg','image/jpeg',116454,1,1417445005),(83,1,'local-lion-green.jpg','public://products/local-lion-green.jpg','image/jpeg',102511,1,1417445005),(84,1,'local-lion-red.jpg','public://products/local-lion-red.jpg','image/jpeg',109005,1,1417445005),(85,1,'local-lion-orange.jpg','public://products/local-lion-orange.jpg','image/jpeg',118285,1,1417445005),(86,1,'terminus.-t02-297.jpg','public://products/terminus.-t02-297.jpg','image/jpeg',86825,1,1417446223),(87,1,'targus-tsb166ap.jpg','public://products/targus-tsb166ap.jpg','image/jpeg',74618,1,1417447402),(88,1,'targus-tsb166ap-01.jpg','public://products/targus-tsb166ap-01.jpg','image/jpeg',73041,1,1417447402),(89,1,'targus-tsb166ap-02.jpg','public://products/targus-tsb166ap-02.jpg','image/jpeg',69868,1,1417447402),(91,1,'tarantula-shoe-bag-red-des.jpg','public://products/tarantula-shoe-bag-red-des.jpg','image/jpeg',63587,1,1417478720),(92,1,'tarantula-shoe-bag-red.jpg','public://products/tarantula-shoe-bag-red.jpg','image/jpeg',63367,1,1417478826),(96,1,'diniwell-water-resistant.jpg','public://products/diniwell-water-resistant.jpg','image/jpeg',51284,1,1417481146),(97,1,'diniwell-water-resistant-01.jpg','public://products/diniwell-water-resistant-01.jpg','image/jpeg',48680,1,1417481146),(98,1,'diniwell-water-resistant-02.jpg','public://products/diniwell-water-resistant-02.jpg','image/jpeg',80202,1,1417481146),(100,1,'24-piece-makeup.jpg','public://products/24-piece-makeup.jpg','image/jpeg',67997,1,1417504200),(101,1,'24-piece-makeup-01.jpg','public://products/24-piece-makeup-01.jpg','image/jpeg',88729,1,1417504200),(102,1,'24-piece-makeup-02.jpg','public://products/24-piece-makeup-02.jpg','image/jpeg',52641,1,1417504200),(104,1,'cameleon-makeup-kit.jpg','public://products/cameleon-makeup-kit.jpg','image/jpeg',52158,1,1417504583),(107,1,'4-in-1-function-power.jpg','public://products/4-in-1-function-power.jpg','image/jpeg',36169,1,1417508779),(108,1,'4-in-1-function-power-01.jpg','public://products/4-in-1-function-power-01.jpg','image/jpeg',38413,1,1417508779),(109,1,'4-in-1-function-power-02.jpg','public://products/4-in-1-function-power-02.jpg','image/jpeg',46383,1,1417508779),(110,1,'sk-II-5-piece-skincare-travel.jpg','public://products/sk-II-5-piece-skincare-travel.jpg','image/jpeg',61037,1,1417509360),(111,1,'sk-II-5-piece-skincare-travel-01.jpg','public://products/sk-II-5-piece-skincare-travel-01.jpg','image/jpeg',68066,1,1417509335),(112,1,'organic-eye-cream.jpg','public://products/organic-eye-cream.jpg','image/jpeg',45422,1,1417510355),(113,1,'mejikaliner-quick-eyelid.jpg','public://products/mejikaliner-quick-eyelid.jpg','image/jpeg',27136,1,1417511293),(114,1,'hairscape-1800w-aus-5000.jpg','public://products/hairscape-1800w-aus-5000.jpg','image/jpeg',35003,1,1417511809),(115,1,'importtonific-slimming-massager.jpg','public://products/importtonific-slimming-massager.jpg','image/jpeg',67842,1,1417512093),(118,1,'apple-iphone-6-16gb-gold.jpg','public://products/apple-iphone-6-16gb-gold.jpg','image/jpeg',105555,1,1417513096),(119,1,'apple-iphone-6-16gb-gold-01.jpg','public://products/apple-iphone-6-16gb-gold-01.jpg','image/jpeg',41745,1,1417513096),(120,1,'apple-iphone-6-16gb-gold-02.jpg','public://products/apple-iphone-6-16gb-gold-02.jpg','image/jpeg',41874,1,1417513096),(121,1,'samsung-n910-note-4-lte-32gb-white.jpg','public://products/samsung-n910-note-4-lte-32gb-white.jpg','image/jpeg',102003,1,1417513689),(122,1,'samsung-n910-note-4-lte-32gb-white-01.jpg','public://products/samsung-n910-note-4-lte-32gb-white-01.jpg','image/jpeg',133542,1,1417513689),(123,1,'samsung-n910-note-4-lte-32gb-white-02.jpg','public://products/samsung-n910-note-4-lte-32gb-white-02.jpg','image/jpeg',46011,1,1417513689),(124,1,'asus-transformer-p1801-b041k.jpg','public://products/asus-transformer-p1801-b041k.jpg','image/jpeg',57556,1,1417515301),(125,1,'asus-transformer-p1801-b041k-01.jpg','public://products/asus-transformer-p1801-b041k-01.jpg','image/jpeg',72980,1,1417515301),(126,1,'asus-transformer-p1801-b041k-02.jpg','public://products/asus-transformer-p1801-b041k-02.jpg','image/jpeg',68245,1,1417515301),(128,1,'nokia-asha-206-dual-sim-black.jpg','public://products/nokia-asha-206-dual-sim-black.jpg','image/jpeg',63609,1,1417517324),(129,1,'lenovo-a316.jpg','public://products/lenovo-a316_0.jpg','image/jpeg',63374,1,1417517463),(130,1,'apple-ipad-3-wi-fi4g-md368-64gb-black.jpg','public://products/apple-ipad-3-wi-fi4g-md368-64gb-black.jpg','image/jpeg',63228,1,1417518185),(131,1,'apple-ipad-3-wi-fi4g-md368-64gb-black-01.jpg','public://products/apple-ipad-3-wi-fi4g-md368-64gb-black-01.jpg','image/jpeg',33296,1,1417518185),(132,1,'asus-memopad-7-tablet.jpg','public://products/asus-memopad-7-tablet.jpg','image/jpeg',69056,1,1417518819),(133,1,'asus-memopad-7-tablet-01.jpg','public://products/asus-memopad-7-tablet-01.jpg','image/jpeg',123837,1,1417518819),(135,1,'lenovo-tablet-miix-01.jpg','public://products/lenovo-tablet-miix-01.jpg','image/jpeg',88656,1,1417528583),(137,1,'lenovo-tablet-miix.jpg','public://products/lenovo-tablet-miix_0.jpg','image/jpeg',79079,1,1417528869),(144,1,'apple-ipad-air-16gb-wifi-space-grey.jpg','public://products/apple-ipad-air-16gb-wifi-space-grey.jpg','image/jpeg',87184,1,1417530153),(145,1,'apple-ipad-air-16gb-wifi-space-grey-01.jpg','public://products/apple-ipad-air-16gb-wifi-space-grey-01.jpg','image/jpeg',34930,1,1417530153),(146,1,'galaxy-note-4-spigen-case-neo-hybrid-metal-gold.jpg','public://products/galaxy-note-4-spigen-case-neo-hybrid-metal-gold.jpg','image/jpeg',99857,1,1417530854),(147,1,'galaxy-note-4-spigen-case-neo-hybrid-metal-gold-01.jpg','public://products/galaxy-note-4-spigen-case-neo-hybrid-metal-gold-01.jpg','image/jpeg',82829,1,1417530854),(148,1,'galaxy-note-4-spigen-case-neo-hybrid-metal-gold-02.jpg','public://products/galaxy-note-4-spigen-case-neo-hybrid-metal-gold-02.jpg','image/jpeg',52258,1,1417530854),(149,1,'genuine-samsung-galaxy-note-4.jpg','public://products/genuine-samsung-galaxy-note-4.jpg','image/jpeg',86631,1,1417531758),(150,1,'genuine-samsung-galaxy-note-4-01.jpg','public://products/genuine-samsung-galaxy-note-4-01.jpg','image/jpeg',45441,1,1417531758),(151,1,'genuine-samsung-galaxy-note-4-02.jpg','public://products/genuine-samsung-galaxy-note-4-02.jpg','image/jpeg',79371,1,1417531758),(152,1,'samsung-galaxy-tab-70-plus-vehicle-dock.jpg','public://products/samsung-galaxy-tab-70-plus-vehicle-dock.jpg','image/jpeg',26614,1,1417532298),(155,1,'angel-universal-mobile-phone-in-car.jpg','public://products/angel-universal-mobile-phone-in-car.jpg','image/jpeg',69445,1,1417533303),(156,1,'-original-apple-earpod-earphone.jpg','public://products/-original-apple-earpod-earphone.jpg','image/jpeg',15597,1,1417573407),(157,1,'-original-apple-earpod-earphone-01.jpg','public://products/-original-apple-earpod-earphone-01.jpg','image/jpeg',31021,1,1417573407),(162,1,'sony-stereo-bluetooth-headset-01.jpg','public://products/sony-stereo-bluetooth-headset-01_0.jpg','image/jpeg',32108,1,1417576765),(163,1,'sony-stereo-bluetooth-headset-03.jpg','public://products/sony-stereo-bluetooth-headset-03_0.jpg','image/jpeg',26131,1,1417576765),(164,1,'top-mi-10400mah-powerbank.jpg','public://products/top-mi-10400mah-powerbank.jpg','image/jpeg',18336,1,1417577778),(165,1,'top-mi-10400mah-powerbank-01.jpg','public://products/top-mi-10400mah-powerbank-01.jpg','image/jpeg',52499,1,1417577778),(166,1,'top-mi-10400mah-powerbank-02.jpg','public://products/top-mi-10400mah-powerbank-02.jpg','image/jpeg',38290,1,1417577778),(167,1,'universal-dual-port-power-bank.jpg','public://products/universal-dual-port-power-bank.jpg','image/jpeg',32808,1,1417578198),(168,1,'muwo-trendz.jpg','public://products/muwo-trendz.jpg','image/jpeg',51745,1,1417578593),(169,1,'luccacal-multi-color.jpg','public://products/luccacal-multi-color.jpg','image/jpeg',61062,1,1417578986),(170,1,'dandelion-women-braided-belt.jpg','public://products/dandelion-women-braided-belt.jpg','image/jpeg',87308,1,1417579652),(171,1,'dandelion-cross-stitch-belt.jpg','public://products/dandelion-cross-stitch-belt.jpg','image/jpeg',64122,1,1417579912),(172,1,'fur-nyce-big-square-classic.jpg','public://products/fur-nyce-big-square-classic.jpg','image/jpeg',83075,1,1417580590),(173,1,'fur-nyce-fashion-zebra-pattern.jpg','public://products/fur-nyce-fashion-zebra-pattern.jpg','image/jpeg',67387,1,1417580757),(174,1,'invicta-pro-diver-men-black.jpg','public://products/invicta-pro-diver-men-black.jpg','image/jpeg',100598,1,1417581463),(175,1,'rolex-submariner-black-dial-stainless.jpg','public://products/rolex-submariner-black-dial-stainless.jpg','image/jpeg',66894,1,1417581629),(176,1,'suunto-vector-black.jpg','public://products/suunto-vector-black.jpg','image/jpeg',94249,1,1417582273),(177,1,'skmei-0955-30m-waterproof.jpg','public://products/skmei-0955-30m-waterproof.jpg','image/jpeg',84938,1,1417582520),(178,1,'samsung-40-full-hd-led-tv.jpg','public://products/samsung-40-full-hd-led-tv.jpg','image/jpeg',83530,1,1417587476),(179,1,'sony-48-full-hd-led-tv.jpg','public://products/sony-48-full-hd-led-tv.jpg','image/jpeg',60154,1,1417587699),(180,1,'sony-bdv-n9200w.jpg','public://products/sony-bdv-n9200w.jpg','image/jpeg',30841,1,1417588138),(181,1,'samsung-ht-e350k-dvd.jpg','public://products/samsung-ht-e350k-dvd.jpg','image/jpeg',25206,1,1417588401),(182,1,'l12s-oled-smart-watch-bluetooth.jpg','public://products/l12s-oled-smart-watch-bluetooth.jpg','image/jpeg',48439,1,1417588949),(183,1,'l12s-oled-smart-watch-bluetooth-01.jpg','public://products/l12s-oled-smart-watch-bluetooth-01.jpg','image/jpeg',70885,1,1417588949),(184,1,'ori-apple-tv.jpg','public://products/ori-apple-tv.jpg','image/jpeg',38452,1,1417589262),(185,1,'dell-alienware-x51.jpg','public://products/dell-alienware-x51.jpg','image/jpeg',39336,1,1417590261),(187,1,'3-port-hdmi-switch.jpg','public://products/3-port-hdmi-switch.jpg','image/jpeg',40047,1,1417591448),(188,1,'dell-powerconnect-5524p.jpg','public://products/dell-powerconnect-5524p.jpg','image/jpeg',35890,1,1417591728),(189,1,'tp-link-m5250-n900.jpg','public://products/tp-link-m5250-n900.jpg','image/jpeg',74741,1,1417592574),(190,1,'tp-link-m5250-n900-01.jpg','public://products/tp-link-m5250-n900-01.jpg','image/jpeg',78417,1,1417592574),(191,1,'tp-link-m5250-n900-02.jpg','public://products/tp-link-m5250-n900-02.jpg','image/jpeg',76480,1,1417592574),(192,1,'tp-link-n750-wireless.jpg','public://products/tp-link-n750-wireless.jpg','image/jpeg',29853,1,1417592796),(193,1,'canon-lide-210-scanner.jpg','public://products/canon-lide-210-scanner.jpg','image/jpeg',35029,1,1417598912),(194,1,'epson-perfection-v33.jpg','public://products/epson-perfection-v33.jpg','image/jpeg',35655,1,1417599162),(195,1,'casio-exilim-ex-zr1500-digital.jpg','public://products/casio-exilim-ex-zr1500-digital.jpg','image/jpeg',67107,1,1417599720),(196,1,'casio-exilim-ex-zr1500-digital-01.jpg','public://products/casio-exilim-ex-zr1500-digital-01.jpg','image/jpeg',41807,1,1417599720),(197,1,'casio-exilim-ex-zr1500-digital-02.jpg','public://products/casio-exilim-ex-zr1500-digital-02.jpg','image/jpeg',71010,1,1417599720),(198,1,'canon-powershot-sx60.jpg','public://products/canon-powershot-sx60.jpg','image/jpeg',88316,1,1417600163),(199,1,'canon-powershot-sx60-01.jpg','public://products/canon-powershot-sx60-01.jpg','image/jpeg',58810,1,1417600163),(200,1,'canon-powershot-sx60-02.jpg','public://products/canon-powershot-sx60-02.jpg','image/jpeg',73405,1,1417600163),(201,1,'anon-eos-600d.jpg','public://products/anon-eos-600d.jpg','image/jpeg',73561,1,1417600767),(202,1,'slideshow-1.png','public://banner/slideshow-1.png','image/png',240651,1,1417666005),(205,1,'watches.jpg','public://banner/watches.jpg','image/jpeg',146376,1,1418181375),(206,1,'clothers.jpg','public://banner/clothers.jpg','image/jpeg',92679,1,1418182131),(207,1,'mobile.jpg','public://banner/mobile.jpg','image/jpeg',122352,1,1418182550),(208,1,'health.jpg','public://banner/health.jpg','image/jpeg',196536,1,1418182785),(209,6,'picture-6-1418281775.jpg','public://pictures/picture-6-1418281775.jpg','image/jpeg',515514,1,1418281775),(210,1,'original-samsung-smart-camera-3.png','public://products/original-samsung-smart-camera-3.png','image/png',488200,1,1418364902),(211,1,'original-samsung-smart-camera.jpg','public://products/original-samsung-smart-camera.jpg','image/jpeg',77595,1,1418365242),(212,1,'original-samsung-smart-camera-1.jpg','public://products/original-samsung-smart-camera-1.jpg','image/jpeg',107100,1,1418365242),(213,1,'original-samsung-smart-camera-2.jpg','public://products/original-samsung-smart-camera-2.jpg','image/jpeg',110843,1,1418365242),(214,1,'nikon-af-s-50mm-lens-f18g.jpg','public://products/nikon-af-s-50mm-lens-f18g.jpg','image/jpeg',117153,1,1418365650),(215,1,'canon-ef-s-lens-18.jpg','public://products/canon-ef-s-lens-18.jpg','image/jpeg',92621,1,1418366198),(216,1,'canon-ef-s-lens-18-1.jpg','public://products/canon-ef-s-lens-18-1.jpg','image/jpeg',88202,1,1418366198),(217,1,'canon-ef-s-lens-18-2.jpg','public://products/canon-ef-s-lens-18-2.jpg','image/jpeg',109075,1,1418366198),(218,1,'cokin-u961a-z-pro-grad-kit.jpg','public://products/cokin-u961a-z-pro-grad-kit.jpg','image/jpeg',155671,1,1418366731),(219,1,'d-link-dcs-5222l-cloudcam.jpg','public://products/d-link-dcs-5222l-cloudcam.jpg','image/jpeg',58869,1,1418367347),(220,1,'d-link-dcs-5222l-cloudcam-1.jpg','public://products/d-link-dcs-5222l-cloudcam-1.jpg','image/jpeg',44056,1,1418367347),(221,1,'d-link-dcs-5222l-cloudcam-2.jpg','public://products/d-link-dcs-5222l-cloudcam-2.jpg','image/jpeg',50523,1,1418367347),(222,1,'cctv-850tvl-ir-dome-cctv-camera.jpg','public://products/cctv-850tvl-ir-dome-cctv-camera.jpg','image/jpeg',125017,1,1418368416),(223,1,'trek-0043.jpg','public://products/trek-0043.jpg','image/jpeg',61141,1,1418369205),(224,1,'trek-0044.jpg','public://products/trek-0044.jpg','image/jpeg',56738,1,1418369205),(225,1,'trek.jpg','public://products/trek.jpg','image/jpeg',50629,1,1418369205),(226,1,'mini-quran-for-kids-yellow.jpg','public://products/mini-quran-for-kids-yellow.jpg','image/jpeg',104323,1,1418370240),(227,1,'boogie-board-105.jpg','public://products/boogie-board-105.jpg','image/jpeg',94976,1,1418370758),(228,1,'transporter-carry-cot.jpg','public://products/transporter-carry-cot.jpg','image/jpeg',85028,1,1418371223),(236,1,'books-stationery.jpg','public://banner/books-stationery.jpg','image/jpeg',110300,1,1418375179),(237,1,'health-safety.jpg','public://banner/health-safety.jpg','image/jpeg',79715,1,1418375406),(238,1,'educational-toy.jpg','public://banner/educational-toy.jpg','image/jpeg',92201,1,1418375876),(239,1,'backpacks.jpg','public://banner/backpacks.jpg','image/jpeg',58671,1,1418376994),(240,1,'backpacks-1.jpg','public://banner/backpacks-1.jpg','image/jpeg',58671,1,1418377770),(241,1,'makeup.jpg','public://banner/makeup.jpg','image/jpeg',100267,1,1418378499),(242,1,'eye-care.jpg','public://banner/eye-care.jpg','image/jpeg',72162,1,1418378630),(243,1,'health-beauty-tools.jpg','public://banner/health-beauty-tools.jpg','image/jpeg',90685,1,1418378759),(244,1,'food-supplements.jpg','public://banner/food-supplements.jpg','image/jpeg',88817,1,1418379045),(245,1,'mobiles.jpg','public://banner/mobiles.jpg','image/jpeg',67852,1,1418379647),(246,1,'mobile-accessories.jpg','public://banner/mobile-accessories.jpg','image/jpeg',54416,1,1418379782),(250,1,'smartphones.jpg','public://banner/smartphones.jpg','image/jpeg',67690,1,1418380566),(251,1,'tablet.jpg','public://banner/tablet.jpg','image/jpeg',48159,1,1418380893),(252,1,'without-call-facility.jpg','public://banner/without-call-facility.jpg','image/jpeg',57910,1,1418381108),(254,1,'batteries-chargers.jpg','public://banner/batteries-chargers.jpg','image/jpeg',63194,1,1418381604),(255,1,'health_0.jpg','public://banner/health_0.jpg','image/jpeg',169228,1,1418611642),(256,1,'watches_0.jpg','public://banner/watches_0.jpg','image/jpeg',118930,1,1418612446),(257,1,'computer.jpg','public://banner/computer.jpg','image/jpeg',94287,1,1418612527),(258,1,'toy.jpg','public://banner/toy.jpg','image/jpeg',220943,1,1418612629),(259,1,'camera.jpg','public://banner/camera.jpg','image/jpeg',122527,1,1418612846),(260,1,'electronics.jpg','public://banner/electronics.jpg','image/jpeg',204398,1,1418613472),(261,1,'womens-jewellery.jpg','public://banner/womens-jewellery.jpg','image/jpeg',55949,1,1418632088),(262,1,'belts.jpg','public://banner/belts.jpg','image/jpeg',60547,1,1418632181),(263,1,'scarves.jpg','public://banner/scarves.jpg','image/jpeg',109288,1,1418632414),(264,1,'business.jpg','public://banner/business.jpg','image/jpeg',54294,1,1418632547),(265,1,'sport.jpg','public://banner/sport.jpg','image/jpeg',78926,1,1418632627),(266,1,'televisions.jpg','public://banner/televisions.jpg','image/jpeg',101097,1,1418638559),(267,1,'home-audio.jpg','public://banner/home-audio.jpg','image/jpeg',69651,1,1418638692),(269,1,'gadgets.jpg','public://banner/gadgets_0.jpg','image/jpeg',81188,1,1418639070),(270,1,'laptop.jpg','public://banner/laptop.jpg','image/jpeg',91084,1,1418640832),(271,1,'desktop.jpg','public://banner/desktop.jpg','image/jpeg',111382,1,1418641175),(272,1,'switches.jpg','public://banner/switches.jpg','image/jpeg',82439,1,1418641282),(273,1,'routers.jpg','public://banner/routers.jpg','image/jpeg',140518,1,1418641404),(274,1,'scanners.jpg','public://banner/scanners.jpg','image/jpeg',81603,1,1418641523),(275,1,'point-shoot-cameras.jpg','public://banner/point-shoot-cameras.jpg','image/jpeg',103903,1,1418701080),(276,1,'dslrslr-cameras.jpg','public://banner/dslrslr-cameras.jpg','image/jpeg',84886,1,1418701197),(277,1,'filters.jpg','public://banner/filters.jpg','image/jpeg',99269,1,1418701300),(278,1,'lenses.jpg','public://banner/lenses.jpg','image/jpeg',78773,1,1418701389),(279,1,'ip-cameras.jpg','public://banner/ip-cameras.jpg','image/jpeg',73068,1,1418701500),(280,1,'car-cameras.jpg','public://banner/car-cameras.jpg','image/jpeg',72739,1,1418701663),(281,1,'laptop-bags-cases.jpg','public://banner/laptop-bags-cases.jpg','image/jpeg',122124,1,1418704961),(282,1,'face-care.jpg','public://banner/face-care.jpg','image/jpeg',117983,1,1418718447),(283,1,'cases-covers.jpg','public://banner/cases-covers.jpg','image/jpeg',177754,1,1418722570),(284,1,'headphones.jpg','public://banner/headphones_0.jpg','image/jpeg',87322,1,1418723723),(285,1,'asus.jpg','public://banner/asus.jpg','image/jpeg',120202,1,1418789083),(286,1,'rolex.jpg','public://banner/rolex.jpg','image/jpeg',142783,1,1418789989),(288,1,'kinohimitsu-jpan-bb-drink.jpg','public://products/kinohimitsu-jpan-bb-drink.jpg','image/jpeg',157839,1,1418884808),(289,1,'tko-fat-burner-mega.jpg','public://products/tko-fat-burner-mega.jpg','image/jpeg',87651,1,1418885579),(294,1,'filters.jpg','public://banner/filters_1.jpg','image/jpeg',100769,1,1418896269),(295,1,'canon.jpg','public://banner/canon_0.jpg','image/jpeg',126917,1,1418984102),(296,1,'slide1.jpg','public://banner/slide1_0.jpg','image/jpeg',130632,1,1419477032),(297,1,'slide2.jpg','public://banner/slide2.jpg','image/jpeg',236936,1,1419477393);
/*!40000 ALTER TABLE `file_managed` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `file_usage`
--

DROP TABLE IF EXISTS `file_usage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `file_usage` (
  `fid` int(10) unsigned NOT NULL COMMENT 'File ID.',
  `module` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the module that is using the file.',
  `type` varchar(64) NOT NULL DEFAULT '' COMMENT 'The name of the object type in which the file is used.',
  `id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The primary key of the object using the file.',
  `count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The number of times this file is used by this object.',
  PRIMARY KEY (`fid`,`type`,`id`,`module`),
  KEY `type_id` (`type`,`id`),
  KEY `fid_count` (`fid`,`count`),
  KEY `fid_module` (`fid`,`module`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Track where a file is used.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `file_usage`
--

LOCK TABLES `file_usage` WRITE;
/*!40000 ALTER TABLE `file_usage` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `file_usage` VALUES (19,'file','commerce_product',6,3),(20,'file','commerce_product',7,2),(26,'file','commerce_product',4,2),(27,'file','commerce_product',8,2),(33,'file','bean',9,1),(34,'file','bean',10,2),(35,'file','bean',11,1),(36,'file','bean',12,1),(37,'file','bean',13,1),(38,'file','bean',11,1),(39,'file','bean',13,1),(40,'file','bean',9,1),(41,'file','bean',13,1),(42,'file','bean',10,1),(43,'file','bean',12,1),(44,'file','bean',11,1),(45,'file','bean',8,1),(46,'file','bean',8,2),(47,'file','bean',11,3),(49,'file','bean',12,2),(50,'file','bean',10,2),(51,'file','bean',13,2),(52,'file','bean',9,2),(53,'file','taxonomy_term',10,1),(54,'file','taxonomy_term',13,1),(55,'file','taxonomy_term',12,1),(58,'imce','file',58,1),(59,'imce','file',59,1),(60,'file','node',13,1),(61,'file','node',12,1),(62,'file','node',14,1),(63,'file','node',11,1),(75,'imce','file',75,1),(76,'file','commerce_product',9,4),(77,'file','commerce_product',9,4),(78,'file','commerce_product',9,4),(79,'file','commerce_product',10,4),(80,'file','commerce_product',10,4),(81,'file','commerce_product',10,4),(82,'file','commerce_product',11,2),(83,'file','commerce_product',12,1),(84,'file','commerce_product',13,1),(85,'file','commerce_product',14,1),(86,'file','commerce_product',15,1),(87,'file','commerce_product',16,1),(88,'file','commerce_product',16,1),(89,'file','commerce_product',16,1),(91,'imce','file',91,1),(92,'file','commerce_product',17,1),(96,'file','commerce_product',18,1),(97,'file','commerce_product',18,1),(98,'file','commerce_product',18,1),(100,'file','commerce_product',19,2),(101,'file','commerce_product',19,2),(102,'file','commerce_product',19,2),(104,'file','commerce_product',20,1),(107,'file','commerce_product',21,2),(108,'file','commerce_product',21,2),(109,'file','commerce_product',21,2),(110,'file','commerce_product',22,2),(111,'imce','file',111,1),(112,'file','commerce_product',23,2),(113,'file','commerce_product',24,2),(114,'file','commerce_product',25,2),(115,'file','commerce_product',26,2),(118,'file','commerce_product',27,2),(119,'file','commerce_product',27,2),(120,'file','commerce_product',27,2),(121,'file','commerce_product',28,1),(122,'file','commerce_product',28,1),(123,'file','commerce_product',28,1),(124,'file','commerce_product',29,1),(125,'file','commerce_product',29,1),(126,'file','commerce_product',29,1),(128,'file','commerce_product',31,2),(129,'file','commerce_product',30,2),(130,'file','commerce_product',32,2),(131,'file','commerce_product',32,2),(132,'file','commerce_product',33,2),(133,'file','commerce_product',33,2),(135,'file','commerce_product',34,1),(137,'file','commerce_product',34,1),(144,'file','commerce_product',35,1),(145,'file','commerce_product',35,1),(146,'file','commerce_product',36,2),(147,'file','commerce_product',36,2),(148,'file','commerce_product',36,2),(149,'file','commerce_product',37,1),(150,'file','commerce_product',37,1),(151,'file','commerce_product',37,1),(152,'file','commerce_product',38,2),(155,'file','commerce_product',39,2),(156,'file','commerce_product',40,2),(157,'file','commerce_product',40,2),(162,'file','commerce_product',41,4),(163,'file','commerce_product',42,3),(164,'file','commerce_product',43,2),(165,'file','commerce_product',43,2),(166,'file','commerce_product',43,2),(167,'file','commerce_product',44,2),(168,'file','commerce_product',45,2),(169,'file','commerce_product',46,1),(170,'file','commerce_product',47,2),(171,'file','commerce_product',48,1),(172,'file','commerce_product',49,2),(173,'file','commerce_product',50,2),(174,'file','commerce_product',51,2),(175,'file','commerce_product',52,2),(176,'file','commerce_product',53,2),(177,'file','commerce_product',54,2),(178,'file','commerce_product',55,2),(179,'file','commerce_product',56,2),(180,'file','commerce_product',57,2),(181,'file','commerce_product',58,2),(182,'file','commerce_product',59,2),(183,'file','commerce_product',59,2),(184,'file','commerce_product',60,2),(185,'file','commerce_product',61,1),(187,'file','commerce_product',62,1),(188,'file','commerce_product',63,1),(189,'file','commerce_product',64,1),(190,'file','commerce_product',64,1),(191,'file','commerce_product',64,1),(192,'file','commerce_product',65,1),(193,'file','commerce_product',66,2),(194,'file','commerce_product',67,2),(195,'file','commerce_product',68,2),(196,'file','commerce_product',68,2),(197,'file','commerce_product',68,2),(198,'file','commerce_product',69,1),(199,'file','commerce_product',69,1),(200,'file','commerce_product',69,1),(201,'file','commerce_product',70,1),(202,'file','node',8,1),(205,'imce','file',205,1),(206,'imce','file',206,1),(207,'imce','file',207,1),(208,'imce','file',208,1),(209,'user','user',6,1),(210,'imce','file',210,1),(211,'file','commerce_product',71,1),(212,'file','commerce_product',71,1),(213,'file','commerce_product',71,1),(214,'file','commerce_product',72,1),(215,'file','commerce_product',73,1),(216,'file','commerce_product',73,1),(217,'file','commerce_product',73,1),(218,'file','commerce_product',74,2),(219,'file','commerce_product',75,8),(220,'file','commerce_product',75,8),(221,'file','commerce_product',75,8),(222,'file','commerce_product',76,1),(223,'file','commerce_product',77,1),(224,'file','commerce_product',77,1),(225,'file','commerce_product',77,1),(226,'file','commerce_product',78,1),(227,'file','commerce_product',79,1),(228,'file','commerce_product',80,1),(236,'file','node',99,1),(237,'file','node',100,1),(238,'file','node',98,1),(239,'file','node',101,1),(240,'file','node',102,1),(241,'file','node',103,1),(242,'file','node',104,1),(243,'file','node',105,1),(244,'file','node',106,1),(245,'file','node',107,1),(246,'file','node',108,1),(250,'file','node',110,1),(251,'file','node',111,1),(252,'file','node',112,1),(254,'file','node',114,1),(255,'imce','file',255,1),(256,'imce','file',256,1),(257,'imce','file',257,1),(258,'imce','file',258,1),(259,'imce','file',259,1),(260,'imce','file',260,1),(261,'file','node',115,1),(262,'file','node',116,1),(263,'file','node',117,1),(264,'file','node',118,1),(265,'file','node',119,1),(266,'file','node',120,1),(267,'file','node',121,1),(269,'file','node',122,1),(270,'file','node',123,1),(271,'file','node',124,1),(272,'file','node',125,1),(273,'file','node',126,1),(274,'file','node',127,1),(275,'file','node',128,1),(276,'file','node',129,1),(277,'file','node',130,1),(278,'file','node',131,1),(279,'file','node',132,1),(280,'file','node',133,1),(281,'file','node',134,1),(282,'file','node',87,1),(283,'file','node',109,1),(284,'file','node',113,1),(285,'file','node',135,1),(286,'file','node',136,1),(288,'file','commerce_product',81,1),(289,'file','commerce_product',82,1),(294,'file','node',140,1),(295,'file','node',137,1),(296,'file','node',142,1),(297,'file','node',7,1);
/*!40000 ALTER TABLE `file_usage` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `filter`
--

DROP TABLE IF EXISTS `filter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `filter` (
  `format` varchar(255) NOT NULL COMMENT 'Foreign key: The filter_format.format to which this filter is assigned.',
  `module` varchar(64) NOT NULL DEFAULT '' COMMENT 'The origin module of the filter.',
  `name` varchar(32) NOT NULL DEFAULT '' COMMENT 'Name of the filter being referenced.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Weight of filter within format.',
  `status` int(11) NOT NULL DEFAULT '0' COMMENT 'Filter enabled status. (1 = enabled, 0 = disabled)',
  `settings` longblob COMMENT 'A serialized array of name value pairs that store the filter settings for the specific format.',
  PRIMARY KEY (`format`,`name`),
  KEY `list` (`weight`,`module`,`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Table that maps filters (HTML corrector) to text formats ...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `filter`
--

LOCK TABLES `filter` WRITE;
/*!40000 ALTER TABLE `filter` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `filter` VALUES ('filtered_html','filter','filter_autop',2,1,'a:0:{}'),('filtered_html','filter','filter_html',1,1,'a:3:{s:12:\"allowed_html\";s:111:\"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd> <b> <img> <p> <br> <span> <div> <h2>\";s:16:\"filter_html_help\";i:1;s:20:\"filter_html_nofollow\";i:0;}'),('filtered_html','filter','filter_htmlcorrector',10,1,'a:0:{}'),('filtered_html','filter','filter_html_escape',-10,0,'a:0:{}'),('filtered_html','filter','filter_url',0,1,'a:1:{s:17:\"filter_url_length\";s:2:\"72\";}'),('filtered_html','php','php_code',0,0,'a:0:{}'),('full_html','filter','filter_autop',1,1,'a:0:{}'),('full_html','filter','filter_html',-10,0,'a:3:{s:12:\"allowed_html\";s:74:\"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>\";s:16:\"filter_html_help\";i:1;s:20:\"filter_html_nofollow\";i:0;}'),('full_html','filter','filter_htmlcorrector',10,1,'a:0:{}'),('full_html','filter','filter_html_escape',-10,0,'a:0:{}'),('full_html','filter','filter_url',0,1,'a:1:{s:17:\"filter_url_length\";i:72;}'),('php_code','filter','filter_autop',0,0,'a:0:{}'),('php_code','filter','filter_html',-10,0,'a:3:{s:12:\"allowed_html\";s:74:\"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>\";s:16:\"filter_html_help\";i:1;s:20:\"filter_html_nofollow\";i:0;}'),('php_code','filter','filter_htmlcorrector',10,0,'a:0:{}'),('php_code','filter','filter_html_escape',-10,0,'a:0:{}'),('php_code','filter','filter_url',0,0,'a:1:{s:17:\"filter_url_length\";i:72;}'),('php_code','php','php_code',0,1,'a:0:{}'),('plain_text','filter','filter_autop',2,1,'a:0:{}'),('plain_text','filter','filter_html',-10,0,'a:3:{s:12:\"allowed_html\";s:74:\"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>\";s:16:\"filter_html_help\";i:1;s:20:\"filter_html_nofollow\";i:0;}'),('plain_text','filter','filter_htmlcorrector',10,0,'a:0:{}'),('plain_text','filter','filter_html_escape',0,1,'a:0:{}'),('plain_text','filter','filter_url',1,1,'a:1:{s:17:\"filter_url_length\";i:72;}');
/*!40000 ALTER TABLE `filter` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `filter_format`
--

DROP TABLE IF EXISTS `filter_format`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `filter_format` (
  `format` varchar(255) NOT NULL COMMENT 'Primary Key: Unique machine name of the format.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'Name of the text format (Filtered HTML).',
  `cache` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Flag to indicate whether format is cacheable. (1 = cacheable, 0 = not cacheable)',
  `status` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT 'The status of the text format. (1 = enabled, 0 = disabled)',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Weight of text format to use when listing.',
  PRIMARY KEY (`format`),
  UNIQUE KEY `name` (`name`),
  KEY `status_weight` (`status`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores text formats: custom groupings of filters, such as...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `filter_format`
--

LOCK TABLES `filter_format` WRITE;
/*!40000 ALTER TABLE `filter_format` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `filter_format` VALUES ('filtered_html','Filtered HTML',1,1,0),('full_html','Full HTML',1,1,1),('php_code','PHP code',0,1,11),('plain_text','Plain text',1,1,10);
/*!40000 ALTER TABLE `filter_format` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `flexslider_optionset`
--

DROP TABLE IF EXISTS `flexslider_optionset`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `flexslider_optionset` (
  `name` varchar(255) NOT NULL COMMENT 'The machine-readable option set name.',
  `title` varchar(255) NOT NULL COMMENT 'The human-readable title for this option set.',
  `theme` varchar(255) NOT NULL DEFAULT 'classic' COMMENT 'The flexslider theme.',
  `options` longblob COMMENT 'The options array.',
  PRIMARY KEY (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Store option sets for flexslider instances.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `flexslider_optionset`
--

LOCK TABLES `flexslider_optionset` WRITE;
/*!40000 ALTER TABLE `flexslider_optionset` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `flexslider_optionset` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `flood`
--

DROP TABLE IF EXISTS `flood`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `flood` (
  `fid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Unique flood event ID.',
  `event` varchar(64) NOT NULL DEFAULT '' COMMENT 'Name of event (e.g. contact).',
  `identifier` varchar(128) NOT NULL DEFAULT '' COMMENT 'Identifier of the visitor, such as an IP address or hostname.',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp of the event.',
  `expiration` int(11) NOT NULL DEFAULT '0' COMMENT 'Expiration timestamp. Expired events are purged on cron run.',
  PRIMARY KEY (`fid`),
  KEY `allow` (`event`,`identifier`,`timestamp`),
  KEY `purge` (`expiration`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Flood controls the threshold of events, such as the...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `flood`
--

LOCK TABLES `flood` WRITE;
/*!40000 ALTER TABLE `flood` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `flood` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `history`
--

DROP TABLE IF EXISTS `history`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `history` (
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that read the node nid.',
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid that was read.',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp at which the read occurred.',
  PRIMARY KEY (`uid`,`nid`),
  KEY `nid` (`nid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='A record of which users have read which nodes.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `history`
--

LOCK TABLES `history` WRITE;
/*!40000 ALTER TABLE `history` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `history` VALUES (1,19,1500361262),(1,28,1500361251),(1,31,1500361235);
/*!40000 ALTER TABLE `history` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `icon_bundle`
--

DROP TABLE IF EXISTS `icon_bundle`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `icon_bundle` (
  `name` varchar(128) NOT NULL DEFAULT '' COMMENT 'The name of the icon bundle.',
  `bundle` longblob COMMENT 'The array data belonging to the icon bundle.',
  `status` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'The enabled status. (1 = enabled, 0 = disabled) of the icon bundle.',
  PRIMARY KEY (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores the contents of icon bundles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `icon_bundle`
--

LOCK TABLES `icon_bundle` WRITE;
/*!40000 ALTER TABLE `icon_bundle` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `icon_bundle` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `image_effects`
--

DROP TABLE IF EXISTS `image_effects`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `image_effects` (
  `ieid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for an image effect.',
  `isid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The image_styles.isid for an image style.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The weight of the effect in the style.',
  `name` varchar(255) NOT NULL COMMENT 'The unique name of the effect to be executed.',
  `data` longblob NOT NULL COMMENT 'The configuration data for the effect.',
  PRIMARY KEY (`ieid`),
  KEY `isid` (`isid`),
  KEY `weight` (`weight`)
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8 COMMENT='Stores configuration options for image effects.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `image_effects`
--

LOCK TABLES `image_effects` WRITE;
/*!40000 ALTER TABLE `image_effects` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `image_effects` VALUES (1,1,1,'image_scale_and_crop','a:2:{s:5:\"width\";s:3:\"180\";s:6:\"height\";s:3:\"180\";}'),(2,2,1,'image_scale_and_crop','a:2:{s:5:\"width\";s:3:\"570\";s:6:\"height\";s:3:\"380\";}'),(3,3,1,'image_scale_and_crop','a:2:{s:5:\"width\";s:3:\"180\";s:6:\"height\";s:2:\"85\";}'),(4,4,1,'image_scale_and_crop','a:2:{s:5:\"width\";s:2:\"60\";s:6:\"height\";s:2:\"80\";}'),(5,5,1,'image_scale_and_crop','a:2:{s:5:\"width\";s:3:\"625\";s:6:\"height\";s:3:\"625\";}'),(6,6,1,'image_scale_and_crop','a:2:{s:5:\"width\";s:3:\"572\";s:6:\"height\";s:3:\"312\";}'),(8,7,2,'image_scale_and_crop','a:2:{s:5:\"width\";s:3:\"480\";s:6:\"height\";s:3:\"480\";}'),(9,8,1,'image_scale_and_crop','a:2:{s:5:\"width\";s:3:\"555\";s:6:\"height\";s:3:\"308\";}');
/*!40000 ALTER TABLE `image_effects` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `image_styles`
--

DROP TABLE IF EXISTS `image_styles`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `image_styles` (
  `isid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for an image style.',
  `name` varchar(255) NOT NULL COMMENT 'The style machine name.',
  `label` varchar(255) NOT NULL DEFAULT '' COMMENT 'The style administrative name.',
  PRIMARY KEY (`isid`),
  UNIQUE KEY `name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8 COMMENT='Stores configuration options for image styles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `image_styles`
--

LOCK TABLES `image_styles` WRITE;
/*!40000 ALTER TABLE `image_styles` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `image_styles` VALUES (1,'thumbnail_product_grid','Thumbnail (180x180)'),(2,'thumbnail_slideshow','Thumbnail (570x380)'),(3,'thumbnail_180x85','Thumbnail (180x85)'),(4,'thumbnail_60x80','Thumbnail (60x80)'),(5,'thumbnail_626x626','Thumbnail (626x626)'),(6,'thumbnail_572x312','Thumbnail (572x312)'),(7,'large','Large (480x480)'),(8,'thumbnail_555x308','Thumbnail (555x308)');
/*!40000 ALTER TABLE `image_styles` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `languages`
--

DROP TABLE IF EXISTS `languages`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `languages` (
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'Language code, e.g. ’de’ or ’en-US’.',
  `name` varchar(64) NOT NULL DEFAULT '' COMMENT 'Language name in English.',
  `native` varchar(64) NOT NULL DEFAULT '' COMMENT 'Native language name.',
  `direction` int(11) NOT NULL DEFAULT '0' COMMENT 'Direction of language (Left-to-Right = 0, Right-to-Left = 1).',
  `enabled` int(11) NOT NULL DEFAULT '0' COMMENT 'Enabled flag (1 = Enabled, 0 = Disabled).',
  `plurals` int(11) NOT NULL DEFAULT '0' COMMENT 'Number of plural indexes in this language.',
  `formula` varchar(255) NOT NULL DEFAULT '' COMMENT 'Plural formula in PHP code to evaluate to get plural indexes.',
  `domain` varchar(128) NOT NULL DEFAULT '' COMMENT 'Domain to use for this language.',
  `prefix` varchar(128) NOT NULL DEFAULT '' COMMENT 'Path prefix to use for this language.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Weight, used in lists of languages.',
  `javascript` varchar(64) NOT NULL DEFAULT '' COMMENT 'Location of JavaScript translation file.',
  PRIMARY KEY (`language`),
  KEY `list` (`weight`,`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='List of all available languages in the system.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `languages`
--

LOCK TABLES `languages` WRITE;
/*!40000 ALTER TABLE `languages` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `languages` VALUES ('ar','Arabic','العربية',1,1,0,'','','ar',0,''),('en','English','English',0,1,0,'','','en',0,'');
/*!40000 ALTER TABLE `languages` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `locales_source`
--

DROP TABLE IF EXISTS `locales_source`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `locales_source` (
  `lid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Unique identifier of this string.',
  `location` longtext COMMENT 'Drupal path in case of online discovered translations or file path in case of imported strings.',
  `textgroup` varchar(255) NOT NULL DEFAULT 'default' COMMENT 'A module defined group of translations, see hook_locale().',
  `source` blob NOT NULL COMMENT 'The original string in English.',
  `context` varchar(255) NOT NULL DEFAULT '' COMMENT 'The context this string applies to.',
  `version` varchar(20) NOT NULL DEFAULT 'none' COMMENT 'Version of Drupal, where the string was last used (for locales optimization).',
  PRIMARY KEY (`lid`),
  KEY `source_context` (`source`(30),`context`)
) ENGINE=InnoDB AUTO_INCREMENT=4701 DEFAULT CHARSET=utf8 COMMENT='List of English source strings.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `locales_source`
--

LOCK TABLES `locales_source` WRITE;
/*!40000 ALTER TABLE `locales_source` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `locales_source` VALUES (1,'misc/drupal.js','default','An AJAX HTTP error occurred.','','none'),(2,'misc/drupal.js','default','HTTP Result Code: !status','','none'),(3,'misc/drupal.js','default','An AJAX HTTP request terminated abnormally.','','none'),(4,'misc/drupal.js','default','Debugging information follows.','','none'),(5,'misc/drupal.js','default','Path: !uri','','none'),(6,'misc/drupal.js','default','StatusText: !statusText','','none'),(7,'misc/drupal.js','default','ResponseText: !responseText','','none'),(8,'misc/drupal.js','default','ReadyState: !readyState','','none'),(9,'modules/overlay/overlay-child.js','default','Loading','','none'),(10,'modules/overlay/overlay-child.js; misc/vertical-tabs.js','default','(active tab)','','7.34'),(11,'misc/collapse.js','default','Hide','','none'),(12,'misc/collapse.js','default','Show','','none'),(13,'sites/all/modules/jcarousel/js/jcarousel.js','default','Internal server error. Please see server or PHP logs for error information.','','none'),(14,'sites/all/modules/jcarousel/js/jcarousel.js','default','An error occurred at @path.\\n\\nError Description: @error','','none'),(15,'sites/all/modules/module_filter/js/module_filter.js','default','No results','','none'),(16,'sites/all/modules/module_filter/js/module_filter.js','default','clear','','none'),(17,'sites/all/modules/module_filter/js/module_filter_tab.js','default','All','','7.34'),(18,'sites/all/modules/module_filter/js/module_filter_tab.js','default','New','','none'),(19,'sites/all/modules/module_filter/js/module_filter_tab.js','default','Modules installed within the last week.','','none'),(20,'sites/all/modules/module_filter/js/module_filter_tab.js','default','No modules added within the last week.','','none'),(21,'sites/all/modules/module_filter/js/module_filter_tab.js','default','Recent','','none'),(22,'sites/all/modules/module_filter/js/module_filter_tab.js','default','Modules enabled/disabled within the last week.','','none'),(23,'sites/all/modules/module_filter/js/module_filter_tab.js','default','No modules were enabled or disabled within the last week.','','none'),(24,'sites/all/modules/module_filter/js/module_filter_tab.js','default','@enabled of @total','','none'),(25,'misc/tabledrag.js','default','Re-order rows by numerical weight instead of dragging.','','none'),(26,'misc/tabledrag.js','default','Show row weights','','none'),(27,'misc/tabledrag.js','default','Hide row weights','','none'),(28,'misc/tabledrag.js','default','Drag to re-order','','none'),(29,'misc/tabledrag.js','default','Changes made in this table will not be saved until the form is submitted.','','none'),(30,'/admin/config/regional/language?render=overlay','default','Public files','','7.34'),(31,'/admin/config/regional/language?render=overlay','default','Public local files served by the webserver.','','7.34'),(32,'/admin/config/regional/language?render=overlay','default','Temporary files','','7.34'),(33,'/admin/config/regional/language?render=overlay','default','Temporary local files for upload and previews.','','7.34'),(34,'/admin/config/regional/language?render=overlay','default','Languages','','7.34'),(35,'/admin/config/regional/language?render=overlay','default','Configure languages for content and the user interface.','','7.34'),(36,'/admin/config/regional/language?render=overlay','default','Long','','7.34'),(37,'/admin/config/regional/language?render=overlay','default','Medium','','7.34'),(38,'/admin/config/regional/language?render=overlay','default','Short','','7.34'),(39,'/admin/config/regional/language?render=overlay','default','Drupal core update status','','7.34'),(40,'/admin/config/regional/language?render=overlay','default','No update data available','','7.34'),(41,'/admin/config/regional/language?render=overlay','default','No update information available. <a href=\"@run_cron\">Run cron</a> or <a href=\"@check_manually\">check manually</a>.','','7.34'),(42,'/admin/config/regional/language?render=overlay','default','Weight for @title','','7.34'),(43,'/admin/config/regional/language?render=overlay','default','Right to left','','7.34'),(44,'/admin/config/regional/language?render=overlay','default','Left to right','','7.34'),(45,'/admin/config/regional/language?render=overlay','default','Enabled languages','','7.34'),(46,'/admin/config/regional/language?render=overlay','default','Default language','','7.34'),(47,'/admin/config/regional/language?render=overlay','default','Save configuration','','7.34'),(48,'/admin/config/regional/language?render=overlay','default','Icon','','7.34'),(49,'/admin/config/regional/language?render=overlay','default','Other','','7.34'),(50,'/admin/config/regional/language?render=overlay','default','Content','','7.34'),(51,'/admin/config/regional/language?render=overlay','default','Help','','7.34'),(52,'/admin/config/regional/language?render=overlay','default','Page top','','7.34'),(53,'/admin/config/regional/language?render=overlay','default','Page bottom','','7.34'),(54,'/admin/config/regional/language?render=overlay','default','First sidebar','','7.34'),(55,'/admin/config/regional/language?render=overlay','default','Dashboard (main)','','7.34'),(56,'/admin/config/regional/language?render=overlay','default','Dashboard (sidebar)','','7.34'),(57,'/admin/config/regional/language?render=overlay','default','Dashboard (inactive)','','7.34'),(58,'/admin/config/regional/language?render=overlay','default','List','','7.34'),(59,'/admin/config/regional/language?render=overlay','default','Add language','','7.34'),(60,'/admin/config/regional/language?render=overlay','default','Detection and selection','','7.34'),(61,'/admin/config/regional/language?render=overlay','default','With multiple languages enabled, interface text can be translated, registered users may select their preferred language, and authors can assign a specific language to content. <a href=\"@translations\">Download contributed translations</a> from Drupal.org.','','7.34'),(62,'/admin/config/regional/language?render=overlay','default','Billing information','','7.34'),(63,'/admin/config/regional/language?render=overlay','default','The profile used to collect billing information on the checkout and order forms.','','7.34'),(64,'/admin/config/regional/language?render=overlay','default','Shipping information','','7.34'),(65,'/admin/config/regional/language?render=overlay','default','The profile used to collect shipping information on the checkout and order forms.','','7.34'),(66,'/admin/config/regional/language?render=overlay','default','Funds Deposit','','7.34'),(67,'/admin/config/regional/language?render=overlay','default','Stores a Funds Deposit Operation','','7.34'),(68,'/admin/config/regional/language?render=overlay','default','Title','','7.34'),(69,'/admin/config/regional/language?render=overlay','default','Name','','7.34'),(70,'/admin/config/regional/language?render=overlay','default','Description','','7.34'),(71,'/admin/config/regional/language?render=overlay','default','Subject','','7.34'),(72,'/admin/config/regional/language?render=overlay','default','Comment','','7.34'),(73,'/admin/config/regional/language?render=overlay','default','Full comment','','7.34'),(74,'/admin/config/regional/language?render=overlay','default','@node_type comment','','7.34'),(75,'/admin/config/regional/language?render=overlay','default','Commerce Customer profile','','7.34'),(76,'/admin/config/regional/language?render=overlay','default','Administrator','','7.34'),(77,'/admin/config/regional/language?render=overlay','default','Customer','','7.34'),(78,'/admin/config/regional/language?render=overlay','default','customer profile','','7.34'),(79,'/admin/config/regional/language?render=overlay','default','customer profiles','','7.34'),(80,'/admin/config/regional/language?render=overlay','default','Commerce Line item','','7.34'),(81,'/admin/config/regional/language?render=overlay','default','Display','','7.34'),(82,'/admin/config/regional/language?render=overlay','default','line item','','7.34'),(83,'/admin/config/regional/language?render=overlay','default','line items','','7.34'),(84,'/admin/config/regional/language?render=overlay','default','Product','','7.34'),(85,'/admin/config/regional/language?render=overlay','default','References a product and displays it with the SKU as the label.','','7.34'),(86,'/admin/config/regional/language?render=overlay','default','Add product','','7.34'),(87,'/admin/config/regional/language?render=overlay','default','Shipping','','7.34'),(88,'/admin/config/regional/language?render=overlay','default','References a shipping method and displays the rate with the selected service title.','','7.34'),(89,'/admin/config/regional/language?render=overlay','default','Add shipping','','7.34'),(90,'/admin/config/regional/language?render=overlay','default','Postal address','','7.34'),(91,'/admin/config/regional/language?render=overlay','default','A field type used for storing postal addresses according the xNAL standard.','','7.34'),(92,'/admin/config/regional/language?render=overlay','default','Customer profile reference','','7.34'),(93,'/admin/config/regional/language?render=overlay','default','This field stores the ID of a related customer profile as an integer value.','','7.34'),(94,'/admin/config/regional/language?render=overlay','default','Line item reference','','7.34'),(95,'/admin/config/regional/language?render=overlay','default','This field stores the ID of a related line item as an integer value.','','7.34'),(96,'/admin/config/regional/language?render=overlay','default','Price','','7.34'),(97,'/admin/config/regional/language?render=overlay','default','This field stores prices for products consisting of an amount and a currency.','','7.34'),(98,'/admin/config/regional/language?render=overlay','default','Product reference','','7.34'),(99,'/admin/config/regional/language?render=overlay','default','This field stores the ID of a related product as an integer value.','','7.34'),(100,'/admin/config/regional/language?render=overlay','default','Country','','7.34'),(101,'/admin/config/regional/language?render=overlay','default','This field stores a country reference in the database.','','7.34'),(102,'/admin/config/regional/language?render=overlay','default','Entity Reference','','7.34'),(103,'/admin/config/regional/language?render=overlay','default','This field reference another entity.','','7.34'),(104,'/admin/config/regional/language?render=overlay','default','Field collection','','7.34'),(105,'/admin/config/regional/language?render=overlay','default','This field stores references to embedded entities, which itself may contain any number of fields.','','7.34'),(106,'/admin/config/regional/language?render=overlay','default','File','','7.34'),(107,'/admin/config/regional/language?render=overlay','default','This field stores the ID of a file as an integer value.','','7.34'),(108,'/admin/config/regional/language?render=overlay','default','Fivestar Rating','','7.34'),(109,'/admin/config/regional/language?render=overlay','default','Store a rating for this piece of content.','','7.34'),(110,'/admin/config/regional/language?render=overlay','default','Store a bundle and icon in the database to assemble an icon field.','','7.34'),(111,'/admin/config/regional/language?render=overlay','default','Image','','7.34'),(112,'/admin/config/regional/language?render=overlay','default','This field stores the ID of an image file as an integer value.','','7.34'),(113,'/admin/config/regional/language?render=overlay','default','Link','','7.34'),(114,'/admin/config/regional/language?render=overlay','default','Store a title, href, and attributes in the database to assemble a link.','','7.34'),(115,'/admin/config/regional/language?render=overlay','default','List (integer)','','7.34'),(116,'/admin/config/regional/language?render=overlay','default','This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.','','7.34'),(117,'/admin/config/regional/language?render=overlay','default','List (float)','','7.34'),(118,'/admin/config/regional/language?render=overlay','default','This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.','','7.34'),(119,'/admin/config/regional/language?render=overlay','default','List (text)','','7.34'),(120,'/admin/config/regional/language?render=overlay','default','This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.','','7.34'),(121,'/admin/config/regional/language?render=overlay','default','Boolean','','7.34'),(122,'/admin/config/regional/language?render=overlay','default','This field stores simple on/off or yes/no options.','','7.34'),(123,'/admin/config/regional/language?render=overlay','default','Integer','','7.34'),(124,'/admin/config/regional/language?render=overlay','default','This field stores a number in the database as an integer.','','7.34'),(125,'/admin/config/regional/language?render=overlay','default','Decimal','','7.34'),(126,'/admin/config/regional/language?render=overlay','default','This field stores a number in the database in a fixed decimal format.','','7.34'),(127,'/admin/config/regional/language?render=overlay','default','Float','','7.34'),(128,'/admin/config/regional/language?render=overlay','default','This field stores a number in the database in a floating point format.','','7.34'),(129,'/admin/config/regional/language?render=overlay','default','Term reference','','7.34'),(130,'/admin/config/regional/language?render=overlay','default','This field stores a reference to a taxonomy term.','','7.34'),(131,'/admin/config/regional/language?render=overlay','default','Text','','7.34'),(132,'/admin/config/regional/language?render=overlay','default','This field stores varchar text in the database.','','7.34'),(133,'/admin/config/regional/language?render=overlay','default','Long text','','7.34'),(134,'/admin/config/regional/language?render=overlay','default','This field stores long text in the database.','','7.34'),(135,'/admin/config/regional/language?render=overlay','default','Long text and summary','','7.34'),(136,'/admin/config/regional/language?render=overlay','default','This field stores long text in the database along with optional summary text.','','7.34'),(137,'/admin/config/regional/language?render=overlay','default','Dynamic address form','','7.34'),(138,'/admin/config/regional/language?render=overlay','default','Customer profile manager','','7.34'),(139,'/admin/config/regional/language?render=overlay','default','Use a complex widget to edit the profile referenced by this object.','','7.34'),(140,'/admin/config/regional/language?render=overlay','default','Line item manager','','7.34'),(141,'/admin/config/regional/language?render=overlay','default','Use a complex widget to manager the line items referenced by this object.','','7.34'),(142,'/admin/config/regional/language?render=overlay','default','Do not show a widget','','7.34'),(143,'/admin/config/regional/language?render=overlay','default','Will not display the line item reference field on forms. Use only if you maintain line item references some other way.','','7.34'),(144,'/admin/config/regional/language?render=overlay','default','Price textfield','','7.34'),(145,'/admin/config/regional/language?render=overlay','default','Price with currency','','7.34'),(146,'/admin/config/regional/language?render=overlay','default','Autocomplete text field','','7.34'),(147,'/admin/config/regional/language?render=overlay','default','Display the list of referenceable products as a textfield with autocomplete behaviour.','','7.34'),(148,'/admin/config/regional/language?render=overlay','default','Will not display the product reference field on forms. Use only if you maintain product references some other way.','','7.34'),(149,'/admin/config/regional/language?render=overlay','default','Countries by continent','','7.34'),(150,'/admin/config/regional/language?render=overlay','default','Autocomplete','','7.34'),(151,'/admin/config/regional/language?render=overlay','default','An autocomplete text field.','','7.34'),(152,'/admin/config/regional/language?render=overlay','default','Autocomplete (Tags style)','','7.34'),(153,'/admin/config/regional/language?render=overlay','default','Hidden','','7.34'),(154,'/admin/config/regional/language?render=overlay','default','Embedded','','7.34'),(155,'/admin/config/regional/language?render=overlay','default','Table','','7.34'),(156,'/admin/config/regional/language?render=overlay','default','Stars (rated while viewing)','','7.34'),(157,'/admin/config/regional/language?render=overlay','default','Stars (rated while editing)','','7.34'),(158,'/admin/config/regional/language?render=overlay','default','Select list (rated while editing)','','7.34'),(159,'/admin/config/regional/language?render=overlay','default','Inline entity form - Single value','','7.34'),(160,'/admin/config/regional/language?render=overlay','default','Inline entity form - Multiple values','','7.34'),(161,'/admin/config/regional/language?render=overlay','default','Text field','','7.34'),(162,'/admin/config/regional/language?render=overlay','default','Select list','','7.34'),(163,'/admin/config/regional/language?render=overlay','default','Check boxes/radio buttons','','7.34'),(164,'/admin/config/regional/language?render=overlay','default','Single on/off checkbox','','7.34'),(165,'/admin/config/regional/language?render=overlay','default','Autocomplete term widget (tagging)','','7.34'),(166,'/admin/config/regional/language?render=overlay','default','Text area (multiple rows)','','7.34'),(167,'/admin/config/regional/language?render=overlay','default','Text area with a summary','','7.34'),(168,'/admin/config/regional/language?render=overlay','default','&lt;none&gt;','','7.34'),(169,'/admin/config/regional/language?render=overlay','default','Select (or other) list','','7.34'),(170,'/admin/config/regional/language?render=overlay','default','Select (or other) drag and drop lists [deprecated in favor of Field Collection]','','7.34'),(171,'/admin/config/regional/language?render=overlay','default','Select (or other) check boxes/radio buttons','','7.34'),(172,'/admin/config/regional/language?render=overlay','default','Linked and wrapped','','7.34'),(173,'/admin/config/regional/language?render=overlay','default','Default','','7.34'),(174,'/admin/config/regional/language?render=overlay','default','Slide image style','','7.34'),(175,'/admin/config/regional/language?render=overlay','default','Zoom area image style','','7.34'),(176,'/admin/config/regional/language?render=overlay','default','Gallery settings','','7.34'),(177,'/admin/config/regional/language?render=overlay','default','Gallery mode settings','','7.34'),(178,'/admin/config/regional/language?render=overlay','default','Gallery mode','','7.34'),(179,'/admin/config/regional/language?render=overlay','default','Set formatter as gallery mode with thumbs','','7.34'),(180,'/admin/config/regional/language?render=overlay','default','Thumbnails image style','','7.34'),(181,'/admin/config/regional/language?render=overlay','default','Zoom area possition','','7.34'),(182,'/admin/config/regional/language?render=overlay','default','Zoom area location settings','','7.34'),(183,'/admin/config/regional/language?render=overlay','default','Zoom width','','7.34'),(184,'/admin/config/regional/language?render=overlay','default','The width of the zoom window in pixels.</br> If \'auto\' is specified, the width will be the same as the small image.','','7.34'),(185,'/admin/config/regional/language?render=overlay','default','Zoom height','','7.34'),(186,'/admin/config/regional/language?render=overlay','default','The height of the zoom window in pixels.</br> If \'auto\' is specified, the height will be the same as the small image.','','7.34'),(187,'/admin/config/regional/language?render=overlay','default','Position','','7.34'),(188,'/admin/config/regional/language?render=overlay','default','Specifies the position of the zoom window relative to the small image.</br> Allowable values are \'left\', \'right\', \'top\', \'bottom\', \'inside\',</br> or you can specifiy the id of an html element to place the zoom window in e.g. position: \'element1','','7.34'),(189,'/admin/config/regional/language?render=overlay','default','Adjust X','','7.34'),(190,'/admin/config/regional/language?render=overlay','default','Allows you to fine tune the x-position of the zoom window in pixels.','','7.34'),(191,'/admin/config/regional/language?render=overlay','default','Adjust Y','','7.34'),(192,'/admin/config/regional/language?render=overlay','default','Allows you to fine tune the y-position of the zoom window in pixels.','','7.34'),(193,'/admin/config/regional/language?render=overlay','default','Zoom style','','7.34'),(194,'/admin/config/regional/language?render=overlay','default','Zoom area styling and effects settings','','7.34'),(195,'/admin/config/regional/language?render=overlay','default','Tint','','7.34'),(196,'/admin/config/regional/language?render=overlay','default','Specifies a tint colour which will cover the small image.</br> Colours should be specified in hex format,</br> e.g. \'#aa00aa\'. Does not work with softFocus.','','7.34'),(197,'/admin/config/regional/language?render=overlay','default','Tint opacity','','7.34'),(198,'/admin/config/regional/language?render=overlay','default','Opacity of the tint, where 0 is fully transparent, and 1 is fully opaque.','','7.34'),(199,'/admin/config/regional/language?render=overlay','default','Lens opacity','','7.34'),(200,'/admin/config/regional/language?render=overlay','default','Opacity of the lens mouse pointer, where 0 is fully transparent,</br> and 1 is fully opaque. In tint and soft-focus modes, it will always be transparent.','','7.34'),(201,'/admin/config/regional/language?render=overlay','default','Soft focus','','7.34'),(202,'/admin/config/regional/language?render=overlay','default','Applies a subtle blur effect to the small image.</br> Set to true or false. Does not work with tint.','','7.34'),(203,'/admin/config/regional/language?render=overlay','default','Smooth move','','7.34'),(204,'/admin/config/regional/language?render=overlay','default','Amount of smoothness/drift of the zoom image as it moves.</br> The higher the number, the smoother/more drifty the movement will be. 1 = no smoothing.','','7.34'),(205,'/admin/config/regional/language?render=overlay','default','Show title','','7.34'),(206,'/admin/config/regional/language?render=overlay','default','Shows the title tag of the image. True or false.','','7.34'),(207,'/admin/config/regional/language?render=overlay','default','Title opacity','','7.34'),(208,'/admin/config/regional/language?render=overlay','default','Specifies the opacity of the title if displayed,</br> where 0 is fully transparent, and 1 is fully opaque.','','7.34'),(209,'/admin/config/regional/language?render=overlay','default','Cloud zoom','','7.34'),(210,'/admin/config/regional/language?render=overlay','default','Add to Cart form','','7.34'),(211,'/admin/config/regional/language?render=overlay','default','Display an Add to Cart form for the referenced product.','','7.34'),(212,'/admin/config/regional/language?render=overlay','default','Customer profile display','','7.34'),(213,'/admin/config/regional/language?render=overlay','default','Display the customer profile.','','7.34'),(214,'/admin/config/regional/language?render=overlay','default','Line item View','','7.34'),(215,'/admin/config/regional/language?render=overlay','default','Display the line items via a default View.','','7.34'),(216,'/admin/config/regional/language?render=overlay','default','Raw amount','','7.34'),(217,'/admin/config/regional/language?render=overlay','default','Formatted amount','','7.34'),(218,'/admin/config/regional/language?render=overlay','default','Formatted amount with components','','7.34'),(219,'/admin/config/regional/language?render=overlay','default','SKU (link)','','7.34'),(220,'/admin/config/regional/language?render=overlay','default','Display the SKU of the referenced product as a link to the node page.','','7.34'),(221,'/admin/config/regional/language?render=overlay','default','SKU (no link)','','7.34'),(222,'/admin/config/regional/language?render=overlay','default','Display the SKU of the referenced product as plain text.','','7.34'),(223,'/admin/config/regional/language?render=overlay','default','Title (link)','','7.34'),(224,'/admin/config/regional/language?render=overlay','default','Display the title of the referenced product as a link to the node page.','','7.34'),(225,'/admin/config/regional/language?render=overlay','default','Title (no link)','','7.34'),(226,'/admin/config/regional/language?render=overlay','default','Display the title of the referenced product as plain text.','','7.34'),(227,'/admin/config/regional/language?render=overlay','default','Rendered product','','7.34'),(228,'/admin/config/regional/language?render=overlay','default','Display the rendered products in any available view mode.','','7.34'),(229,'/admin/config/regional/language?render=overlay','default','Official name','','7.34'),(230,'/admin/config/regional/language?render=overlay','default','ISO alpha-2 code','','7.34'),(231,'/admin/config/regional/language?render=overlay','default','ISO alpha-3 code','','7.34'),(232,'/admin/config/regional/language?render=overlay','default','ISO numeric-3 code','','7.34'),(233,'/admin/config/regional/language?render=overlay','default','Continent','','7.34'),(234,'/admin/config/regional/language?render=overlay','default','Continent code','','7.34'),(235,'/admin/config/regional/language?render=overlay','default','Label','','7.34'),(236,'/admin/config/regional/language?render=overlay','default','Display the label of the referenced entities.','','7.34'),(237,'/admin/config/regional/language?render=overlay','default','Entity id','','7.34'),(238,'/admin/config/regional/language?render=overlay','default','Display the id of the referenced entities.','','7.34'),(239,'/admin/config/regional/language?render=overlay','default','Rendered entity','','7.34'),(240,'/admin/config/regional/language?render=overlay','default','Display the referenced entities rendered by entity_view().','','7.34'),(241,'/admin/config/regional/language?render=overlay','default','Links to field collection items','','7.34'),(242,'/admin/config/regional/language?render=overlay; misc/machine-name.js','default','Edit','','7.34'),(243,'/admin/config/regional/language?render=overlay','default','Delete','','7.34'),(244,'/admin/config/regional/language?render=overlay; sites/all/modules/views/js/views-admin.js','default','Add','','7.34'),(245,'/admin/config/regional/language?render=overlay','default','Field collection items','','7.34'),(246,'/admin/config/regional/language?render=overlay','default','Fields only','','7.34'),(247,'/admin/config/regional/language?render=overlay','default','Table of field collection items','','7.34'),(248,'/admin/config/regional/language?render=overlay','default','Slideshow','','7.34'),(249,'/admin/config/regional/language?render=overlay','default','Generic file','','7.34'),(250,'/admin/config/regional/language?render=overlay','default','Table of files','','7.34'),(251,'/admin/config/regional/language?render=overlay','default','URL to file','','7.34'),(252,'/admin/config/regional/language?render=overlay','default','As Stars','','7.34'),(253,'/admin/config/regional/language?render=overlay','default','Rating (i.e. 4.2/5)','','7.34'),(254,'/admin/config/regional/language?render=overlay','default','Percentage (i.e. 92)','','7.34'),(255,'/admin/config/regional/language?render=overlay','default','flexslider','','7.34'),(256,'/admin/config/regional/language?render=overlay','default','Image Link Formatter','','7.34'),(257,'/admin/config/regional/language?render=overlay','default','Title, as link (default)','','7.34'),(258,'/admin/config/regional/language?render=overlay','default','Title, as plain text','','7.34'),(259,'/admin/config/regional/language?render=overlay','default','URL, as link','','7.34'),(260,'/admin/config/regional/language?render=overlay','default','URL, as plain text','','7.34'),(261,'/admin/config/regional/language?render=overlay','default','URL, absolute','','7.34'),(262,'/admin/config/regional/language?render=overlay','default','Domain, as link','','7.34'),(263,'/admin/config/regional/language?render=overlay','default','Short, as link with title \"Link\"','','7.34'),(264,'/admin/config/regional/language?render=overlay','default','Label, as link with label as title','','7.34'),(265,'/admin/config/regional/language?render=overlay','default','Separate title and URL','','7.34'),(266,'/admin/config/regional/language?render=overlay','default','Key','','7.34'),(267,'/admin/config/regional/language?render=overlay','default','Unformatted','','7.34'),(268,'/admin/config/regional/language?render=overlay','default','Plain text','','7.34'),(269,'/admin/config/regional/language?render=overlay','default','RSS category','','7.34'),(270,'/admin/config/regional/language?render=overlay','default','Trimmed','','7.34'),(271,'/admin/config/regional/language?render=overlay','default','Summary or trimmed','','7.34'),(272,'/admin/config/regional/language?render=overlay','default','Color','','7.34'),(273,'/admin/config/regional/language?render=overlay','default','Select or other','','7.34'),(274,'/admin/config/regional/language?render=overlay','default','Default SQL storage','','7.34'),(275,'/admin/config/regional/language?render=overlay','default','Stores fields in the local SQL database, using per-field tables.','','7.34'),(276,'/admin/config/regional/language?render=overlay','default','Funds account','','7.34'),(277,'/admin/config/regional/language?render=overlay','default','Funds accounts','','7.34'),(278,'/admin/config/regional/language?render=overlay','default','Store funds account','','7.34'),(279,'/admin/config/regional/language?render=overlay','default','User funds account','','7.34'),(280,'/admin/config/regional/language?render=overlay','default','Full Account','','7.34'),(281,'/admin/config/regional/language?render=overlay','default','Funds transaction','','7.34'),(282,'/admin/config/regional/language?render=overlay','default','Funds transactions','','7.34'),(283,'/admin/config/regional/language?render=overlay','default','Deposit transaction','','7.34'),(284,'/admin/config/regional/language?render=overlay','default','Funds transfer transaction','','7.34'),(285,'/admin/config/regional/language?render=overlay','default','Payment transaction','','7.34'),(286,'/admin/config/regional/language?render=overlay','default','Full Transaction','','7.34'),(287,'/admin/config/regional/language?render=overlay','default','Withdraw Method','','7.34'),(288,'/admin/config/regional/language?render=overlay','default','Withdraw Methods','','7.34'),(289,'/admin/config/regional/language?render=overlay','default','Commerce Marketplace Funds Withdraw Methods.','','7.34'),(290,'/admin/config/regional/language?render=overlay','default','Withdraw method type','','7.34'),(291,'/admin/config/regional/language?render=overlay','default','Withdraw method types','','7.34'),(292,'/admin/config/regional/language?render=overlay','default','Method types of Commerce Marketplace Withdraw Methods.','','7.34'),(293,'/admin/config/regional/language?render=overlay','default','Commerce Order','a drupal commerce order','7.34'),(294,'/admin/config/regional/language?render=overlay','default','Order','a drupal commerce order','7.34'),(295,'/admin/config/regional/language?render=overlay','default','order','','7.34'),(296,'/admin/config/regional/language?render=overlay','default','orders','','7.34'),(297,'/admin/config/regional/language?render=overlay','default','Commerce Payment transaction','','7.34'),(298,'/admin/config/regional/language?render=overlay','default','payment transaction','','7.34'),(299,'/admin/config/regional/language?render=overlay','default','payment transactions','','7.34'),(300,'/admin/config/regional/language?render=overlay','default','PayPal WPS','','7.34'),(301,'/admin/config/regional/language?render=overlay','default','PayPal','','7.34'),(302,'/admin/config/regional/language?render=overlay','default','PayPal Website Payments Standard','','7.34'),(303,'/admin/config/regional/language?render=overlay','default','Commerce Product','','7.34'),(304,'/admin/config/regional/language?render=overlay','default','Admin display','','7.34'),(305,'/admin/config/regional/language?render=overlay','default','product','','7.34'),(306,'/admin/config/regional/language?render=overlay','default','products','','7.34'),(307,'/admin/config/regional/language?render=overlay','default','Commerce Store','','7.34'),(308,'/admin/config/regional/language?render=overlay','default','Teaser','','7.34'),(309,'/admin/config/regional/language?render=overlay','default','Field collection item','','7.34'),(310,'/admin/config/regional/language?render=overlay','default','Full content','','7.34'),(311,'/admin/config/regional/language?render=overlay','default','Field collection @field','','7.34'),(312,'/admin/config/regional/language?render=overlay','default','Node','','7.34'),(313,'/admin/config/regional/language?render=overlay','default','RSS','','7.34'),(314,'/admin/config/regional/language?render=overlay','default','Search index','','7.34'),(315,'/admin/config/regional/language?render=overlay','default','Search result highlighting input','','7.34'),(316,'/admin/config/regional/language?render=overlay','default','Search server','','7.34'),(317,'/admin/config/regional/language?render=overlay','default','Search sort','','7.34'),(318,'/admin/config/regional/language?render=overlay','default','Taxonomy term','','7.34'),(319,'/admin/config/regional/language?render=overlay','default','Taxonomy term page','','7.34'),(320,'/admin/config/regional/language?render=overlay','default','Taxonomy vocabulary','','7.34'),(321,'/admin/config/regional/language?render=overlay','default','User','','7.34'),(322,'/admin/config/regional/language?render=overlay','default','User account','','7.34'),(323,'/admin/config/regional/language?render=overlay','default','Rules configuration','','7.34'),(324,'/admin/config/regional/language?render=overlay','default','Funds deposit order','','7.34'),(325,'/admin/config/regional/language?render=overlay','default','Withdraw transaction','','7.34'),(326,'/admin/config/regional/language?render=overlay','default','Marketplace order','','7.34'),(327,'/admin/config/regional/language?render=overlay','default','Store order','','7.34'),(328,'/admin/config/regional/language?render=overlay','default','Email: Plain','','7.34'),(329,'/admin/config/regional/language?render=overlay','default','Email: HTML','','7.34'),(330,'/admin/config/regional/language?render=overlay','default','Email: HTML text alternative','','7.34'),(331,'/admin/config/regional/language?render=overlay','default','Tokens','','7.34'),(332,'/admin/config/regional/language?render=overlay','default','Add to Cart form - Attribute','','7.34'),(333,'/admin/config/regional/language?render=overlay','default','Line item','','7.34'),(334,'/admin/config/regional/language?render=overlay','default','@entity_type: @view_mode','','7.34'),(335,'/admin/config/regional/language?render=overlay','default','Nodes','','7.34'),(336,'/admin/config/regional/language?render=overlay','default','Users','','7.34'),(337,'/admin/config/regional/language?render=overlay','default','Files','','7.34'),(338,'/admin/config/regional/language?render=overlay','default','Nodes represent the main site content items.','','7.34'),(339,'/admin/config/regional/language?render=overlay','default','Users who have created accounts on your site.','','7.34'),(340,'/admin/config/regional/language?render=overlay','default','Uploaded file.','','7.34'),(341,'/admin/config/regional/language?render=overlay','default','Comments','','7.34'),(342,'/admin/config/regional/language?render=overlay','default','Remark or note that refers to a node.','','7.34'),(343,'/admin/config/regional/language?render=overlay','default','Taxonomy terms','','7.34'),(344,'/admin/config/regional/language?render=overlay','default','Taxonomy terms are used for classifying content.','','7.34'),(345,'/admin/config/regional/language?render=overlay','default','Taxonomy vocabularies','','7.34'),(346,'/admin/config/regional/language?render=overlay','default','Vocabularies contain related taxonomy terms, which are used for classifying content.','','7.34'),(347,'/admin/config/regional/language?render=overlay','default','Development','','7.34'),(348,'/admin/config/regional/language?render=overlay','default','Features','','7.34'),(349,'/admin/config/regional/language?render=overlay','default','Main menu','','7.34'),(350,'/admin/config/regional/language?render=overlay','default','Management','','7.34'),(351,'/admin/config/regional/language?render=overlay','default','About us','','7.34'),(352,'/admin/config/regional/language?render=overlay','default','Customer help','','7.34'),(353,'/admin/config/regional/language?render=overlay','default','Headline menu','','7.34'),(354,'/admin/config/regional/language?render=overlay','default','Help Topics','','7.34'),(355,'/admin/config/regional/language?render=overlay','default','Navigation','','7.34'),(356,'/admin/config/regional/language?render=overlay','default','User menu','','7.34'),(357,'/admin/config/regional/language?render=overlay','default','Normal','','7.34'),(358,'/admin/config/regional/language?render=overlay','default','Overridden','','7.34'),(359,'/admin/config/regional/language?render=overlay','default','Administration','','7.34'),(360,'/admin/config/regional/language?render=overlay','default','Appearance','','7.34'),(361,'/admin/config/regional/language?render=overlay','default','Select and configure your themes.','','7.34'),(362,'/admin/config/regional/language?render=overlay','default','Select and configure your theme','','7.34'),(363,'/admin/config/regional/language?render=overlay','default','Settings','','7.34'),(364,'/admin/config/regional/language?render=overlay','default','Configure default and theme specific settings.','','7.34'),(365,'/admin/config/regional/language?render=overlay','default','Bartik','','7.34'),(366,'/admin/config/regional/language?render=overlay','default','Global settings','','7.34'),(367,'/admin/config/regional/language?render=overlay','default','Seven','','7.34'),(368,'/admin/config/regional/language?render=overlay','default','Market Place','','7.34'),(369,'/admin/config/regional/language?render=overlay','default','Install new theme','','7.34'),(370,'/admin/config/regional/language?render=overlay','default','Update','','7.34'),(371,'/admin/config/regional/language?render=overlay','default','Configuration','','7.34'),(372,'/admin/config/regional/language?render=overlay','default','Administer settings.','','7.34'),(373,'/admin/config/regional/language?render=overlay','default','Content authoring','','7.34'),(374,'/admin/config/regional/language?render=overlay','default','Settings related to formatting and authoring content.','','7.34'),(375,'/admin/config/regional/language?render=overlay','default','Text formats','','7.34'),(376,'/admin/config/regional/language?render=overlay','default','Configure how content input by users is filtered, including allowed HTML tags. Also allows enabling of module-provided filters.','','7.34'),(377,'/admin/config/regional/language?render=overlay','default','Add text format','','7.34'),(378,'/admin/config/regional/language?render=overlay','default','TagClouds configuration','','7.34'),(379,'/admin/config/regional/language?render=overlay','default','Configure the tag clouds. Set the order, the number of tags, and the depth of the clouds.','','7.34'),(380,'/admin/config/regional/language?render=overlay','default','Title settings','','7.34'),(381,'/admin/config/regional/language?render=overlay','default','Settings for the Title module.','','7.34'),(382,'/admin/config/regional/language?render=overlay','default','Webform settings','','7.34'),(383,'/admin/config/regional/language?render=overlay','default','Global configuration of webform functionality.','','7.34'),(384,'/admin/config/regional/language?render=overlay','default','CKEditor','','7.34'),(385,'/admin/config/regional/language?render=overlay','default','Configure the rich text editor.','','7.34'),(386,'/admin/config/regional/language?render=overlay','default','Fivestar','','7.34'),(387,'/admin/config/regional/language?render=overlay','default','Configure site-wide widgets used for Fivestar rating.','','7.34'),(388,'/admin/config/regional/language?render=overlay','default','Exclude Node Title','','7.34'),(389,'/admin/config/regional/language?render=overlay','default','Exclude Node Title from display','','7.34'),(390,'/admin/config/regional/language?render=overlay','default','Development tools.','','7.34'),(391,'/admin/config/regional/language?render=overlay','default','Logging and errors','','7.34'),(392,'/admin/config/regional/language?render=overlay','default','Settings for logging and alerts modules. Various modules can route Drupal\'s system events to different destinations, such as syslog, database, email, etc.','','7.34'),(393,'/admin/config/regional/language?render=overlay','default','Maintenance mode','','7.34'),(394,'/admin/config/regional/language?render=overlay','default','Take the site offline for maintenance or bring it back online.','','7.34'),(395,'/admin/config/regional/language?render=overlay','default','Performance','','7.34'),(396,'/admin/config/regional/language?render=overlay','default','Enable or disable page caching for anonymous users and set CSS and JS bandwidth optimization options.','','7.34'),(397,'/admin/config/regional/language?render=overlay','default','jQuery update','','7.34'),(398,'/admin/config/regional/language?render=overlay','default','Configure settings related to the jQuery upgrade, the library path and compression.','','7.34'),(399,'/admin/config/regional/language?render=overlay','default','Devel settings','','7.34'),(400,'/admin/config/regional/language?render=overlay','default','Helper functions, pages, and blocks to assist Drupal developers. The devel blocks can be managed via the <a href=\"/admin/structure/block\">block administration</a> page.','','7.34'),(401,'/admin/config/regional/language?render=overlay','default','Session API Configuration','','7.34'),(402,'/admin/config/regional/language?render=overlay','default','Configure Session API behavior.','','7.34'),(403,'/admin/config/regional/language?render=overlay','default','Media','','7.34'),(404,'/admin/config/regional/language?render=overlay','default','Media tools.','','7.34'),(405,'/admin/config/regional/language?render=overlay','default','File system','','7.34'),(406,'/admin/config/regional/language?render=overlay','default','Tell Drupal where to store uploaded files and how they are accessed.','','7.34'),(407,'/admin/config/regional/language?render=overlay','default','Image styles','','7.34'),(408,'/admin/config/regional/language?render=overlay','default','Configure styles that can be used for resizing or adjusting images on display.','','7.34'),(409,'/admin/config/regional/language?render=overlay','default','Add style','','7.34'),(410,'/admin/config/regional/language?render=overlay','default','Add a new image style.','','7.34'),(411,'/admin/config/regional/language?render=overlay','default','List the current image styles on the site.','','7.34'),(412,'/admin/config/regional/language?render=overlay','default','Image toolkit','','7.34'),(413,'/admin/config/regional/language?render=overlay','default','Choose which image toolkit to use if you have installed optional toolkits.','','7.34'),(414,'/admin/config/regional/language?render=overlay','default','optionset','','7.34'),(415,'/admin/config/regional/language?render=overlay','default','optionsets','','7.34'),(416,'/admin/config/regional/language?render=overlay','default','FlexSlider optionset','','7.34'),(417,'/admin/config/regional/language?render=overlay','default','FlexSlider optionsets','','7.34'),(418,'/admin/config/regional/language?render=overlay','default','Enable','','7.34'),(419,'/admin/config/regional/language?render=overlay','default','Disable','','7.34'),(420,'/admin/config/regional/language?render=overlay','default','Revert','','7.34'),(421,'/admin/config/regional/language?render=overlay','default','Clone','','7.34'),(422,'/admin/config/regional/language?render=overlay','default','Import','','7.34'),(423,'/admin/config/regional/language?render=overlay','default','Export','','7.34'),(424,'/admin/config/regional/language?render=overlay','default','Add a new @plugin','','7.34'),(425,'/admin/config/regional/language?render=overlay','default','Edit @plugin %title','','7.34'),(426,'/admin/config/regional/language?render=overlay','default','Clone @plugin %title','','7.34'),(427,'/admin/config/regional/language?render=overlay','default','Import @plugin','','7.34'),(428,'/admin/config/regional/language?render=overlay','default','Export @plugin %title','','7.34'),(429,'/admin/config/regional/language?render=overlay','default','Are you sure you want to revert %title?','','7.34'),(430,'/admin/config/regional/language?render=overlay','default','This action will permanently remove any customizations made to this item.','','7.34'),(431,'/admin/config/regional/language?render=overlay','default','The item has been reverted.','','7.34'),(432,'/admin/config/regional/language?render=overlay','default','Are you sure you want to delete %title?','','7.34'),(433,'/admin/config/regional/language?render=overlay','default','This action will permanently remove this item from your database..','','7.34'),(434,'/admin/config/regional/language?render=overlay','default','The item has been deleted.','','7.34'),(435,'/admin/config/regional/language?render=overlay','default','%title has been created.','','7.34'),(436,'/admin/config/regional/language?render=overlay','default','%title could not be created.','','7.34'),(437,'/admin/config/regional/language?render=overlay','default','%title has been updated.','','7.34'),(438,'/admin/config/regional/language?render=overlay','default','%title could not be updated.','','7.34'),(439,'/admin/config/regional/language?render=overlay','default','You can import an exported definition by pasting the exported object code into the field below.','','7.34'),(440,'/admin/config/regional/language?render=overlay','default','@plugin %title was enabled.','','7.34'),(441,'/admin/config/regional/language?render=overlay','default','@plugin %title was disabled.','','7.34'),(442,'/admin/config/regional/language?render=overlay','default','There are no @titles to display.','','7.34'),(443,'/admin/config/regional/language?render=overlay','default','FlexSlider','','7.34'),(444,'/admin/config/regional/language?render=overlay','default','Administer FlexSlider presets.','','7.34'),(445,'/admin/config/regional/language?render=overlay','default','Advanced settings','','7.34'),(446,'/admin/config/regional/language?render=overlay','default','Configure the advanced flexslider module settings.','','7.34'),(447,'/admin/config/regional/language?render=overlay','default','IMCE','','7.34'),(448,'/admin/config/regional/language?render=overlay','default','Control how your image/file browser works.','','7.34'),(449,'/admin/config/regional/language?render=overlay','default','Add new profile','','7.34'),(450,'/admin/config/regional/language?render=overlay','default','Icons','','7.34'),(451,'/admin/config/regional/language?render=overlay','default','Overview of all available icons.','','7.34'),(452,'/admin/config/regional/language?render=overlay','default','Bundles','','7.34'),(453,'/admin/config/regional/language?render=overlay','default','Overview of all available icon bundles.','','7.34'),(454,'/admin/config/regional/language?render=overlay','default','People','','7.34'),(455,'/admin/config/regional/language?render=overlay','default','Configure user accounts.','','7.34'),(456,'/admin/config/regional/language?render=overlay','default','Account settings','','7.34'),(457,'/admin/config/regional/language?render=overlay','default','Configure default behavior of users, including registration requirements, e-mails, fields, and user pictures.','','7.34'),(458,'/admin/config/regional/language?render=overlay','default','Manage display','','7.34'),(459,'/admin/config/regional/language?render=overlay','default','Manage fields','','7.34'),(460,'/admin/config/regional/language?render=overlay','default','IP address blocking','','7.34'),(461,'/admin/config/regional/language?render=overlay','default','Manage blocked IP addresses.','','7.34'),(462,'/admin/config/regional/language?render=overlay','default','Regional and language','','7.34'),(463,'/admin/config/regional/language?render=overlay','default','Regional settings, localization and translation.','','7.34'),(464,'/admin/config/regional/language?render=overlay','default','Date and time','','7.34'),(465,'/admin/config/regional/language?render=overlay','default','Configure display formats for date and time.','','7.34'),(466,'/admin/config/regional/language?render=overlay','default','Formats','','7.34'),(467,'/admin/config/regional/language?render=overlay','default','Configure display format strings for date and time.','','7.34'),(468,'/admin/config/regional/language?render=overlay','default','Add format','','7.34'),(469,'/admin/config/regional/language?render=overlay','default','Allow users to add additional date formats.','','7.34'),(470,'/admin/config/regional/language?render=overlay','default','Types','','7.34'),(471,'/admin/config/regional/language?render=overlay','default','Add date type','','7.34'),(472,'/admin/config/regional/language?render=overlay','default','Add new date type.','','7.34'),(473,'/admin/config/regional/language?render=overlay','default','Localize','','7.34'),(474,'/admin/config/regional/language?render=overlay','default','Configure date formats for each locale','','7.34'),(475,'/admin/config/regional/language?render=overlay','default','Regional settings','','7.34'),(476,'/admin/config/regional/language?render=overlay','default','Settings for the site\'s default time zone and country.','','7.34'),(477,'/admin/config/regional/language?render=overlay','default','Countries','','7.34'),(478,'/admin/config/regional/language?render=overlay','default','List, edit, or add countries.','','7.34'),(479,'/admin/config/regional/language?render=overlay','default','Add country','','7.34'),(480,'/admin/config/regional/language?render=overlay','default','Admin page to add a country.','','7.34'),(481,'/admin/config/regional/language?render=overlay','default','Update countries','','7.34'),(482,'/admin/config/regional/language?render=overlay','default','Bulk import countries from the ISO standard.','','7.34'),(483,'/admin/config/regional/language?render=overlay','default','Session language detection configuration','','7.34'),(484,'/admin/config/regional/language?render=overlay','default','URL language detection configuration','','7.34'),(485,'/admin/config/regional/language?render=overlay','default','Translate interface','','7.34'),(486,'/admin/config/regional/language?render=overlay','default','Translate the built in interface and optionally other text.','','7.34'),(487,'/admin/config/regional/language?render=overlay','default','Overview','','7.34'),(488,'/admin/config/regional/language?render=overlay','default','Translate','','7.34'),(489,'/admin/config/regional/language?render=overlay','default','Search and metadata','','7.34'),(490,'/admin/config/regional/language?render=overlay','default','Local site search, metadata and SEO.','','7.34'),(491,'/admin/config/regional/language?render=overlay','default','Clean URLs','','7.34'),(492,'/admin/config/regional/language?render=overlay','default','Enable or disable clean URLs for your site.','','7.34'),(493,'/admin/config/regional/language?render=overlay','default','Search settings','','7.34'),(494,'/admin/config/regional/language?render=overlay','default','Configure relevance settings for search and other indexing options.','','7.34'),(495,'/admin/config/regional/language?render=overlay','default','Clear index','','7.34'),(496,'/admin/config/regional/language?render=overlay','default','URL aliases','','7.34'),(497,'/admin/config/regional/language?render=overlay','default','Change your site\'s URL paths by aliasing them.','','7.34'),(498,'/admin/config/regional/language?render=overlay','default','Add alias','','7.34'),(499,'/admin/config/regional/language?render=overlay','default','Bulk update','','7.34'),(500,'/admin/config/regional/language?render=overlay','default','Delete aliases','','7.34'),(501,'/admin/config/regional/language?render=overlay','default','Patterns','','7.34'),(502,'/admin/config/regional/language?render=overlay','default','Search API','','7.34'),(503,'/admin/config/regional/language?render=overlay','default','Create and configure search engines.','','7.34'),(504,'/admin/config/regional/language?render=overlay','default','Add index','','7.34'),(505,'/admin/config/regional/language?render=overlay','default','Create a new search index.','','7.34'),(506,'/admin/config/regional/language?render=overlay','default','Add server','','7.34'),(507,'/admin/config/regional/language?render=overlay','default','Create a new search server.','','7.34'),(508,'/admin/config/regional/language?render=overlay','default','Voting API','','7.34'),(509,'/admin/config/regional/language?render=overlay','default','Configure sitewide settings for user-generated ratings and votes.','','7.34'),(510,'/admin/config/regional/language?render=overlay','default','System','','7.34'),(511,'/admin/config/regional/language?render=overlay','default','General system related configuration.','','7.34'),(512,'/admin/config/regional/language?render=overlay','default','Actions','','7.34'),(513,'/admin/config/regional/language?render=overlay','default','Manage the actions defined for your site.','','7.34'),(514,'/admin/config/regional/language?render=overlay','default','Configure an advanced action','','7.34'),(515,'/admin/config/regional/language?render=overlay','default','Manage actions','','7.34'),(516,'/admin/config/regional/language?render=overlay','default','Cron','','7.34'),(517,'/admin/config/regional/language?render=overlay','default','Manage automatic site maintenance tasks.','','7.34'),(518,'/admin/config/regional/language?render=overlay','default','Site information','','7.34'),(519,'/admin/config/regional/language?render=overlay','default','Change site name, e-mail address, slogan, default front page, and number of posts per page, error pages.','','7.34'),(520,'/admin/config/regional/language?render=overlay','default','Recently Read Config','','7.34'),(521,'/admin/config/regional/language?render=overlay','default','Tracks the history of recently read entities by each user.','','7.34'),(522,'/admin/config/regional/language?render=overlay','default','User interface','','7.34'),(523,'/admin/config/regional/language?render=overlay','default','Tools that enhance the user interface.','','7.34'),(524,'/admin/config/regional/language?render=overlay','default','Shortcuts','','7.34'),(525,'/admin/config/regional/language?render=overlay','default','Add and modify shortcut sets.','','7.34'),(526,'/admin/config/regional/language?render=overlay','default','Add shortcut set','','7.34'),(527,'/admin/config/regional/language?render=overlay','default','Module filter','','7.34'),(528,'/admin/config/regional/language?render=overlay','default','Configure how the modules page looks and acts.','','7.34'),(529,'/admin/config/regional/language?render=overlay','default','Chosen','','7.34'),(530,'/admin/config/regional/language?render=overlay','default','Configuration for Chosen plugin','','7.34'),(531,'/admin/config/regional/language?render=overlay','default','Custom breadcrumbs settings','','7.34'),(532,'/admin/config/regional/language?render=overlay','default','Manage sitewide configuration settings to customize the breadcrumb trail.','','7.34'),(533,'/admin/config/regional/language?render=overlay','default','Web services','','7.34'),(534,'/admin/config/regional/language?render=overlay','default','Tools related to web services.','','7.34'),(535,'/admin/config/regional/language?render=overlay','default','RSS publishing','','7.34'),(536,'/admin/config/regional/language?render=overlay','default','Configure the site description, the number of items per feed and whether feeds should be titles/teasers/full-text.','','7.34'),(537,'/admin/config/regional/language?render=overlay','default','Newsletters','','7.34'),(538,'/admin/config/regional/language?render=overlay','default','Configure your sites newsletters.','','7.34'),(539,'/admin/config/regional/language?render=overlay','default','Add newsletter category','','7.34'),(540,'/admin/config/regional/language?render=overlay','default','Simplenews settings.','','7.34'),(541,'/admin/config/regional/language?render=overlay','default','Newsletter','','7.34'),(542,'/admin/config/regional/language?render=overlay','default','Send mail','','7.34'),(543,'/admin/config/regional/language?render=overlay','default','Send mail, cron and debug options.','','7.34'),(544,'/admin/config/regional/language?render=overlay','default','Subscription','','7.34'),(545,'/admin/config/regional/language?render=overlay','default','Subscription settings, opt-in/out confirmation email text.','','7.34'),(546,'/admin/config/regional/language?render=overlay','default','Workflow','','7.34'),(547,'/admin/config/regional/language?render=overlay','default','Content workflow, editorial workflow tools.','','7.34'),(548,'/admin/config/regional/language?render=overlay','default','Rules','','7.34'),(549,'/admin/config/regional/language?render=overlay','default','Manage reaction rules and rule components.','','7.34'),(550,'/admin/config/regional/language?render=overlay','default','Components','','7.34'),(551,'/admin/config/regional/language?render=overlay','default','Add new component','','7.34'),(552,'/admin/config/regional/language?render=overlay','default','Import component','','7.34'),(553,'/admin/config/regional/language?render=overlay','default','Add new rule','','7.34'),(554,'/admin/config/regional/language?render=overlay','default','Import rule','','7.34'),(555,'/admin/config/regional/language?render=overlay','default','Advanced','','7.34'),(556,'/admin/config/regional/language?render=overlay','default','Basic','','7.34'),(557,'/admin/config/regional/language?render=overlay','default','Administration tools.','','7.34'),(558,'/admin/config/regional/language?render=overlay','default','Administration menu','','7.34'),(559,'/admin/config/regional/language?render=overlay','default','Adjust administration menu settings.','','7.34'),(560,'/admin/config/regional/language?render=overlay','default','Menu Token','','7.34'),(561,'/admin/config/regional/language?render=overlay','default','Configure the Menu Token module.','','7.34'),(562,'/admin/config/regional/language?render=overlay','default','Administer content and comments.','','7.34'),(563,'/admin/config/regional/language?render=overlay','default','List and edit site comments and the comment approval queue.','','7.34'),(564,'/admin/config/regional/language?render=overlay','default','Published comments','','7.34'),(565,'/admin/config/regional/language?render=overlay','default','Unapproved comments (@count)','','7.34'),(566,'/admin/config/regional/language?render=overlay','default','List newsletters and newsletter sent status.','','7.34'),(567,'/admin/config/regional/language?render=overlay','default','Webforms','','7.34'),(568,'/admin/config/regional/language?render=overlay','default','View and edit all the available webforms on your site.','','7.34'),(569,'/admin/config/regional/language?render=overlay','default','Dashboard','','7.34'),(570,'/admin/config/regional/language?render=overlay','default','View and customize your dashboard.','','7.34'),(571,'/admin/config/regional/language?render=overlay','default','Configure available dashboard blocks','','7.34'),(572,'/admin/config/regional/language?render=overlay','default','Configure which blocks can be shown on the dashboard.','','7.34'),(573,'/admin/config/regional/language?render=overlay; modules/dashboard/dashboard.js','default','Customize dashboard','','7.34'),(574,'/admin/config/regional/language?render=overlay','default','Customize your dashboard.','','7.34'),(575,'/admin/config/regional/language?render=overlay','default','Reference for usage, configuration, and modules.','','7.34'),(576,'/admin/config/regional/language?render=overlay','default','block','','7.34'),(577,'/admin/config/regional/language?render=overlay','default','color','','7.34'),(578,'/admin/config/regional/language?render=overlay','default','comment','','7.34'),(579,'/admin/config/regional/language?render=overlay','default','contextual','','7.34'),(580,'/admin/config/regional/language?render=overlay','default','dashboard','','7.34'),(581,'/admin/config/regional/language?render=overlay','default','dblog','','7.34'),(582,'/admin/config/regional/language?render=overlay','default','field','','7.34'),(583,'/admin/config/regional/language?render=overlay','default','field_sql_storage','','7.34'),(584,'/admin/config/regional/language?render=overlay','default','field_ui','','7.34'),(585,'/admin/config/regional/language?render=overlay','default','file','','7.34'),(586,'/admin/config/regional/language?render=overlay','default','filter','','7.34'),(587,'/admin/config/regional/language?render=overlay','default','help','','7.34'),(588,'/admin/config/regional/language?render=overlay','default','image','','7.34'),(589,'/admin/config/regional/language?render=overlay','default','list','','7.34'),(590,'/admin/config/regional/language?render=overlay','default','menu','','7.34'),(591,'/admin/config/regional/language?render=overlay','default','node','','7.34'),(592,'/admin/config/regional/language?render=overlay','default','options','','7.34'),(593,'/admin/config/regional/language?render=overlay','default','system','','7.34'),(594,'/admin/config/regional/language?render=overlay','default','taxonomy','','7.34'),(595,'/admin/config/regional/language?render=overlay','default','text','','7.34'),(596,'/admin/config/regional/language?render=overlay','default','user','','7.34'),(597,'/admin/config/regional/language?render=overlay','default','number','','7.34'),(598,'/admin/config/regional/language?render=overlay','default','overlay','','7.34'),(599,'/admin/config/regional/language?render=overlay','default','path','','7.34'),(600,'/admin/config/regional/language?render=overlay','default','rdf','','7.34'),(601,'/admin/config/regional/language?render=overlay','default','search','','7.34'),(602,'/admin/config/regional/language?render=overlay','default','shortcut','','7.34'),(603,'/admin/config/regional/language?render=overlay','default','update','','7.34'),(604,'/admin/config/regional/language?render=overlay','default','admin_menu','','7.34'),(605,'/admin/config/regional/language?render=overlay','default','field_collection','','7.34'),(606,'/admin/config/regional/language?render=overlay','default','jcarousel','','7.34'),(607,'/admin/config/regional/language?render=overlay','default','jquery_update','','7.34'),(608,'/admin/config/regional/language?render=overlay','default','simplenews','','7.34'),(609,'/admin/config/regional/language?render=overlay','default','title','','7.34'),(610,'/admin/config/regional/language?render=overlay','default','views_slideshow','','7.34'),(611,'/admin/config/regional/language?render=overlay','default','views_slideshow_cycle','','7.34'),(612,'/admin/config/regional/language?render=overlay','default','webform','','7.34'),(613,'/admin/config/regional/language?render=overlay','default','commerce_checkout','','7.34'),(614,'/admin/config/regional/language?render=overlay','default','commerce_customer_ui','','7.34'),(615,'/admin/config/regional/language?render=overlay','default','commerce_line_item_ui','','7.34'),(616,'/admin/config/regional/language?render=overlay','default','commerce_order_ui','','7.34'),(617,'/admin/config/regional/language?render=overlay','default','commerce_product_pricing_ui','','7.34'),(618,'/admin/config/regional/language?render=overlay','default','commerce_product_ui','','7.34'),(619,'/admin/config/regional/language?render=overlay','default','rules','','7.34'),(620,'/admin/config/regional/language?render=overlay','default','pathauto','','7.34'),(621,'/admin/config/regional/language?render=overlay','default','token','','7.34'),(622,'/admin/config/regional/language?render=overlay','default','php','','7.34'),(623,'/admin/config/regional/language?render=overlay','default','context','','7.34'),(624,'/admin/config/regional/language?render=overlay','default','context_ui','','7.34'),(625,'/admin/config/regional/language?render=overlay','default','devel','','7.34'),(626,'/admin/config/regional/language?render=overlay','default','ckeditor','','7.34'),(627,'/admin/config/regional/language?render=overlay','default','search_api','','7.34'),(628,'/admin/config/regional/language?render=overlay','default','fivestar','','7.34'),(629,'/admin/config/regional/language?render=overlay','default','fontawesome','','7.34'),(630,'/admin/config/regional/language?render=overlay','default','search_api_sorts','','7.34'),(631,'/admin/config/regional/language?render=overlay','default','commerce_payment_ui','','7.34'),(632,'/admin/config/regional/language?render=overlay','default','features','','7.34'),(633,'/admin/config/regional/language?render=overlay','default','custom_breadcrumbs','','7.34'),(634,'/admin/config/regional/language?render=overlay','default','custom_breadcrumbs_taxonomy','','7.34'),(635,'/admin/config/regional/language?render=overlay','default','commerce_shipping_ui','','7.34'),(636,'/admin/config/regional/language?render=overlay','default','locale','','7.34'),(637,'/admin/config/regional/language?render=overlay','default','Index','','7.34'),(638,'/admin/config/regional/language?render=overlay','default','Modules','','7.34'),(639,'/admin/config/regional/language?render=overlay','default','Extend site functionality.','','7.34'),(640,'/admin/config/regional/language?render=overlay','default','Uninstall','','7.34'),(641,'/admin/config/regional/language?render=overlay','default','Install new module','','7.34'),(642,'/admin/config/regional/language?render=overlay','default','Manage user accounts, roles, and permissions.','','7.34'),(643,'/admin/config/regional/language?render=overlay','default','Add user','','7.34'),(644,'/admin/config/regional/language?render=overlay','default','Find and manage people interacting with your site.','','7.34'),(645,'/admin/config/regional/language?render=overlay','default','Permissions','','7.34'),(646,'/admin/config/regional/language?render=overlay','default','Determine access to features by selecting permissions for roles.','','7.34'),(647,'/admin/config/regional/language?render=overlay','default','Roles','','7.34'),(648,'/admin/config/regional/language?render=overlay','default','List, edit, or add user roles.','','7.34'),(649,'/admin/config/regional/language?render=overlay','default','Newsletter subscriptions','','7.34'),(650,'/admin/config/regional/language?render=overlay','default','Newsletter subscription management.','','7.34'),(651,'/admin/config/regional/language?render=overlay','default','Mass subscribe','','7.34'),(652,'/admin/config/regional/language?render=overlay','default','Mass unsubscribe','','7.34'),(653,'/admin/config/regional/language?render=overlay','default','Reports','','7.34'),(654,'/admin/config/regional/language?render=overlay','default','View reports, updates, and errors.','','7.34'),(655,'/admin/config/regional/language?render=overlay','default','Field list','','7.34'),(656,'/admin/config/regional/language?render=overlay','default','Overview of fields on all entity types.','','7.34'),(657,'/admin/config/regional/language?render=overlay','default','Used in views','','7.34'),(658,'/admin/config/regional/language?render=overlay','default','Overview of fields used in all views.','','7.34'),(659,'/admin/config/regional/language?render=overlay','default','Recent log messages','','7.34'),(660,'/admin/config/regional/language?render=overlay','default','View events that have recently been logged.','','7.34'),(661,'/admin/config/regional/language?render=overlay','default','Status report','','7.34'),(662,'/admin/config/regional/language?render=overlay','default','Get a status report about your site\'s operation and any detected problems.','','7.34'),(663,'/admin/config/regional/language?render=overlay','default','Top \'access denied\' errors','','7.34'),(664,'/admin/config/regional/language?render=overlay','default','View \'access denied\' errors (403s).','','7.34'),(665,'/admin/config/regional/language?render=overlay','default','Top \'page not found\' errors','','7.34'),(666,'/admin/config/regional/language?render=overlay','default','View \'page not found\' errors (404s).','','7.34'),(667,'/admin/config/regional/language?render=overlay','default','Top search phrases','','7.34'),(668,'/admin/config/regional/language?render=overlay','default','View most popular search phrases.','','7.34'),(669,'/admin/config/regional/language?render=overlay','default','Available updates','','7.34'),(670,'/admin/config/regional/language?render=overlay','default','Get a status report about available updates for your installed modules and themes.','','7.34'),(671,'/admin/config/regional/language?render=overlay','default','Install new module or theme','','7.34'),(672,'/admin/config/regional/language?render=overlay','default','Views plugins','','7.34'),(673,'/admin/config/regional/language?render=overlay','default','Overview of plugins used in all views.','','7.34'),(674,'/admin/config/regional/language?render=overlay','default','Structure','','7.34'),(675,'/admin/config/regional/language?render=overlay','default','Administer blocks, content types, menus, etc.','','7.34'),(676,'/admin/config/regional/language?render=overlay','default','Blocks','','7.34'),(677,'/admin/config/regional/language?render=overlay','default','Configure what block content appears in your site\'s sidebars and other regions.','','7.34'),(678,'/admin/config/regional/language?render=overlay','default','Add block','','7.34'),(679,'/admin/config/regional/language?render=overlay','default','Content types','','7.34'),(680,'/admin/config/regional/language?render=overlay','default','Manage content types, including default status, front page promotion, comment settings, etc.','','7.34'),(681,'/admin/config/regional/language?render=overlay','default','Add content type','','7.34'),(682,'/admin/config/regional/language?render=overlay','default','Menus','','7.34'),(683,'/admin/config/regional/language?render=overlay','default','Add new menus to your site, edit existing menus, and rename and reorganize menu links.','','7.34'),(684,'/admin/config/regional/language?render=overlay','default','Add menu','','7.34'),(685,'/admin/config/regional/language?render=overlay','default','List menus','','7.34'),(686,'/admin/config/regional/language?render=overlay','default','Taxonomy','','7.34'),(687,'/admin/config/regional/language?render=overlay','default','Manage tagging, categorization, and classification of your content.','','7.34'),(688,'/admin/config/regional/language?render=overlay','default','Add vocabulary','','7.34'),(689,'/admin/config/regional/language?render=overlay','default','Field collections','','7.34'),(690,'/admin/config/regional/language?render=overlay','default','Manage fields on field collections.','','7.34'),(691,'/admin/config/regional/language?render=overlay','default','view','','7.34'),(692,'/admin/config/regional/language?render=overlay','default','View','','7.34'),(693,'/admin/config/regional/language?render=overlay','default','views','','7.34'),(694,'/admin/config/regional/language?render=overlay','default','Views','','7.34'),(695,'/admin/config/regional/language?render=overlay','default','This action will permanently remove any customizations made to this view.','','7.34'),(696,'/admin/config/regional/language?render=overlay','default','The view has been reverted.','','7.34'),(697,'/admin/config/regional/language?render=overlay','default','This action will permanently remove the view from your database.','','7.34'),(698,'/admin/config/regional/language?render=overlay','default','The view has been deleted.','','7.34'),(699,'/admin/config/regional/language?render=overlay','default','Manage customized lists of content.','','7.34'),(700,'/admin/config/regional/language?render=overlay','default','Add new view','','7.34'),(701,'/admin/config/regional/language?render=overlay','default','Add view from template','','7.34'),(702,'/admin/config/regional/language?render=overlay','default','Mega Menus','','7.34'),(703,'/admin/config/regional/language?render=overlay','default','Request','','7.34'),(704,'/admin/config/regional/language?render=overlay','default','Context','','7.34'),(705,'/admin/config/regional/language?render=overlay','default','contexts','','7.34'),(706,'/admin/config/regional/language?render=overlay','default','Contexts','','7.34'),(707,'/admin/config/regional/language?render=overlay','default','Associate menus, views, blocks, etc. with different contexts to structure your site.','','7.34'),(708,'/admin/config/regional/language?render=overlay','default','Entity types','','7.34'),(709,'/admin/config/regional/language?render=overlay','default','A centralized administrative section for entity types','','7.34'),(710,'/admin/config/regional/language?render=overlay','default','Add entity type','','7.34'),(711,'/admin/config/regional/language?render=overlay','default','Add a new entity type','','7.34'),(712,'/admin/config/regional/language?render=overlay','default','View all the bundles for \'Commerce Store\'','','7.34'),(713,'/admin/config/regional/language?render=overlay','default','Add bundle ','','7.34'),(714,'/admin/config/regional/language?render=overlay','default','Add a(n) new \'Commerce Store Bundle\'','','7.34'),(715,'/admin/config/regional/language?render=overlay','default','Bundle List','','7.34'),(716,'/admin/config/regional/language?render=overlay','default','Delete the \'Commerce Store\' Entity Type','','7.34'),(717,'/admin/config/regional/language?render=overlay','default','Edit the \'Commerce Store\' entity type','','7.34'),(718,'/admin/config/regional/language?render=overlay','default','Manage properties','','7.34'),(719,'/admin/config/regional/language?render=overlay','default','Manage the properties of the Commerce Store entity type','','7.34'),(720,'/admin/config/regional/language?render=overlay','default','Store','','7.34'),(721,'/admin/config/regional/language?render=overlay','default','View all entites of type Commerce Store with bundle Store','','7.34'),(722,'/admin/config/regional/language?render=overlay','default','Entity List','','7.34'),(723,'/admin/config/regional/language?render=overlay','default','Add Store','','7.34'),(724,'/admin/config/regional/language?render=overlay','default','Add an entity of type Commerce Store with bundle Store','','7.34'),(725,'/admin/config/regional/language?render=overlay','default','Manage features.','','7.34'),(726,'/admin/config/regional/language?render=overlay','default','Create feature','','7.34'),(727,'/admin/config/regional/language?render=overlay','default','Create a new feature.','','7.34'),(728,'/admin/config/regional/language?render=overlay','default','Manage','','7.34'),(729,'/admin/config/regional/language?render=overlay','default','Enable and disable features.','','7.34'),(730,'/admin/config/regional/language?render=overlay','default','Adjust settings for using features module.','','7.34'),(731,'/admin/config/regional/language?render=overlay','default','Custom breadcrumbs','','7.34'),(732,'/admin/config/regional/language?render=overlay','default','Customize the breadcrumb trail for pages on your site.','','7.34'),(733,'/admin/config/regional/language?render=overlay','default','Path','','7.34'),(734,'/admin/config/regional/language?render=overlay','default','Term','','7.34'),(735,'/admin/config/regional/language?render=overlay','default','Vocabulary','','7.34'),(736,'/admin/config/regional/language?render=overlay','default','Tasks','','7.34'),(737,'/admin/config/regional/language?render=overlay','default','Administer your store.','','7.34'),(738,'/admin/config/regional/language?render=overlay','default','Configure settings and business rules for your store.','','7.34'),(739,'/admin/config/regional/language?render=overlay','default','Checkout settings','','7.34'),(740,'/admin/config/regional/language?render=overlay','default','Customize the checkout form and configure checkout rules.','','7.34'),(741,'/admin/config/regional/language?render=overlay','default','Checkout form','','7.34'),(742,'/admin/config/regional/language?render=overlay','default','Build your checkout pages using module defined checkout form elements.','','7.34'),(743,'/admin/config/regional/language?render=overlay','default','Checkout rules','','7.34'),(744,'/admin/config/regional/language?render=overlay','default','Enable and configure checkout completion rules.','','7.34'),(745,'/admin/config/regional/language?render=overlay','default','Add a checkout rule','','7.34'),(746,'/admin/config/regional/language?render=overlay','default','Adds an additional checkout completion rule configuration.','','7.34'),(747,'/admin/config/regional/language?render=overlay','default','Currency settings','','7.34'),(748,'/admin/config/regional/language?render=overlay','default','Configure the default currency and display settings.','','7.34'),(749,'/admin/config/regional/language?render=overlay','default','Line item types','','7.34'),(750,'/admin/config/regional/language?render=overlay','default','Manage line item types for your store.','','7.34'),(751,'/admin/config/regional/language?render=overlay','default','Order settings','','7.34'),(752,'/admin/config/regional/language?render=overlay','default','Configure general order settings, fields, and displays.','','7.34'),(753,'/admin/config/regional/language?render=overlay','default','Product pricing rules','','7.34'),(754,'/admin/config/regional/language?render=overlay','default','Enable and configure product pricing rules and pre-calculation.','','7.34'),(755,'/admin/config/regional/language?render=overlay','default','Administer the rules used for calculating product sell prices.','','7.34'),(756,'/admin/config/regional/language?render=overlay','default','Add a pricing rule','','7.34'),(757,'/admin/config/regional/language?render=overlay','default','Adds an additional sell price calculation rule configuration.','','7.34'),(758,'/admin/config/regional/language?render=overlay','default','Pre-calculation','','7.34'),(759,'/admin/config/regional/language?render=overlay','default','Configure the price pre-calculation settings.','','7.34'),(760,'/admin/config/regional/language?render=overlay','default','Commerce Store Order settings','','7.34'),(761,'/admin/config/regional/language?render=overlay','default','Configure general store order settings, fields, and displays.','','7.34'),(762,'/admin/config/regional/language?render=overlay','default','Commerce Search API','','7.34'),(763,'/admin/config/regional/language?render=overlay','default','Configure the generated product display index.','','7.34'),(764,'/admin/config/regional/language?render=overlay','default','Custom Offline Payments','','7.34'),(765,'/admin/config/regional/language?render=overlay','default','Manage custom offline payment methods','','7.34'),(766,'/admin/config/regional/language?render=overlay','default','Add payment method','','7.34'),(767,'/admin/config/regional/language?render=overlay','default','Payment methods','','7.34'),(768,'/admin/config/regional/language?render=overlay','default','Enable and configure payment method rule configurations.','','7.34'),(769,'/admin/config/regional/language?render=overlay','default','Add a payment method rule','','7.34'),(770,'/admin/config/regional/language?render=overlay','default','Adds an additional payment method rule configuration.','','7.34'),(771,'/admin/config/regional/language?render=overlay','default','Stock management','','7.34'),(772,'/admin/config/regional/language?render=overlay','default','Configure stock management.','','7.34'),(773,'/admin/config/regional/language?render=overlay','default','Simple Stock management','','7.34'),(774,'/admin/config/regional/language?render=overlay','default','Configure Simple stock.','','7.34'),(775,'/admin/config/regional/language?render=overlay','default','Stock control','','7.34'),(776,'/admin/config/regional/language?render=overlay','default','Manage and configure stock control rules.','','7.34'),(777,'/admin/config/regional/language?render=overlay','default','Create a stock control rule','','7.34'),(778,'/admin/config/regional/language?render=overlay','default','Add a new stock control rule','','7.34'),(779,'/admin/config/regional/language?render=overlay','default','Stock management API','','7.34'),(780,'/admin/config/regional/language?render=overlay','default','Configure stock management API.','','7.34'),(781,'/admin/config/regional/language?render=overlay','default','Stock validation','','7.34'),(782,'/admin/config/regional/language?render=overlay','default','Manage and configure stock validation events.','','7.34'),(783,'/admin/config/regional/language?render=overlay','default','Add a Cart action rule','','7.34'),(784,'/admin/config/regional/language?render=overlay','default','Act on the add to cart action.','','7.34'),(785,'/admin/config/regional/language?render=overlay','default','Add a Cart state rule','','7.34'),(786,'/admin/config/regional/language?render=overlay','default','Disable or modify the add to cart form.','','7.34'),(787,'/admin/config/regional/language?render=overlay','default','Add a Validate cart / checkout rule','','7.34'),(788,'/admin/config/regional/language?render=overlay','default','Validate products in the the cart before checkout.','','7.34'),(789,'/admin/config/regional/language?render=overlay','default','Manage shipping methods and services.','','7.34'),(790,'/admin/config/regional/language?render=overlay','default','Calculation rules','','7.34'),(791,'/admin/config/regional/language?render=overlay','default','Add and configure your shipping rate calculation rules.','','7.34'),(792,'/admin/config/regional/language?render=overlay','default','Add a calculation rule','','7.34'),(793,'/admin/config/regional/language?render=overlay','default','Adds an additional shipping rate calculation rule configuration.','','7.34'),(794,'/admin/config/regional/language?render=overlay','default','Shipping methods','','7.34'),(795,'/admin/config/regional/language?render=overlay','default','Manage shipping methods.','','7.34'),(796,'/admin/config/regional/language?render=overlay','default','Flat rate','','7.34'),(797,'/admin/config/regional/language?render=overlay','default','Lets you create flat rate services, specifying their base rates and using Rules to apply additional rate calculation logic.','','7.34'),(798,'/admin/config/regional/language?render=overlay','default','Redirect to the shipping method list.','','7.34'),(799,'/admin/config/regional/language?render=overlay','default','Add a flat rate service','','7.34'),(800,'/admin/config/regional/language?render=overlay','default','Create a new flat rate shipping service, including a title and base shipping rate.','','7.34'),(801,'/admin/config/regional/language?render=overlay','default','Configure rule','','7.34'),(802,'/admin/config/regional/language?render=overlay','default','Add conditions to the rule used to collect rates for this shipping method.','','7.34'),(803,'/admin/config/regional/language?render=overlay','default','View services','','7.34'),(804,'/admin/config/regional/language?render=overlay','default','View the table of services defined for this shipping method.','','7.34'),(805,'/admin/config/regional/language?render=overlay','default','Shipping services','','7.34'),(806,'/admin/config/regional/language?render=overlay','default','Manage shipping services.','','7.34'),(807,'/admin/config/regional/language?render=overlay','default','Manage shipping services for this shipping method.','','7.34'),(808,'/admin/config/regional/language?render=overlay','default','Redirect to the shipping service list.','','7.34'),(809,'/admin/config/regional/language?render=overlay','default','Configure component','','7.34'),(810,'/admin/config/regional/language?render=overlay','default','Add conditions to the Rules component used to rate orders for this service.','','7.34'),(811,'/admin/config/regional/language?render=overlay','default','Delete the flat rate service.','','7.34'),(812,'/admin/config/regional/language?render=overlay','default','Edit the flat rate service.','','7.34'),(813,'/admin/config/regional/language?render=overlay','default','Customer profiles','','7.34'),(814,'/admin/config/regional/language?render=overlay','default','Manage customer profiles and profile types in the store.','','7.34'),(815,'/admin/config/regional/language?render=overlay','default','Add a customer profile','','7.34'),(816,'/admin/config/regional/language?render=overlay','default','Add a new customer profile.','','7.34'),(817,'/admin/config/regional/language?render=overlay','default','Create @name','','7.34'),(818,'/admin/config/regional/language?render=overlay','default','Profile types','','7.34'),(819,'/admin/config/regional/language?render=overlay','default','Manage customer profile types for your store.','','7.34'),(820,'/admin/config/regional/language?render=overlay','default','Orders','','7.34'),(821,'/admin/config/regional/language?render=overlay','default','Manage orders in the store.','','7.34'),(822,'/admin/config/regional/language?render=overlay','default','Create an order','','7.34'),(823,'/admin/config/regional/language?render=overlay','default','Create a new order.','','7.34'),(824,'/admin/config/regional/language?render=overlay','default','Shopping carts','','7.34'),(825,'/admin/config/regional/language?render=overlay','default','Products','','7.34'),(826,'/admin/config/regional/language?render=overlay','default','Manage products and product types in the store.','','7.34'),(827,'/admin/config/regional/language?render=overlay','default','Add a product','','7.34'),(828,'/admin/config/regional/language?render=overlay','default','Add a new product for sale.','','7.34'),(829,'/admin/config/regional/language?render=overlay','default','Create !name','','7.34'),(830,'/admin/config/regional/language?render=overlay','default','A basic product type.','','7.34'),(831,'/admin/config/regional/language?render=overlay','default','Product types','','7.34'),(832,'/admin/config/regional/language?render=overlay','default','Manage products types for your store.','','7.34'),(833,'/admin/config/regional/language?render=overlay','default','Add product type','','7.34'),(834,'/admin/config/regional/language?render=overlay','default','Node: Teaser','','7.34'),(835,'/admin/config/regional/language?render=overlay','default','Commerce Marketplace Funds','','7.34'),(836,'/admin/config/regional/language?render=overlay','default','Change Commerce Marketplace Funds settings.','','7.34'),(837,'/admin/config/regional/language?render=overlay','default','Administer Marketplace funds account entity types','','7.34'),(838,'/admin/config/regional/language?render=overlay','default','Change funds accounts settings.','','7.34'),(839,'/admin/config/regional/language?render=overlay','default','Administer Marketplace Store Funds Account entity type','','7.34'),(840,'/admin/config/regional/language?render=overlay','default','Configure Store funds accounts.','','7.34'),(841,'/admin/config/regional/language?render=overlay','default','Administer Marketplace User Funds Account entity type','','7.34'),(842,'/admin/config/regional/language?render=overlay','default','Configure User funds accounts.','','7.34'),(843,'/admin/config/regional/language?render=overlay','default','Administer Marketplace funds transaction entity types','','7.34'),(844,'/admin/config/regional/language?render=overlay','default','Change funds transactions settings.','','7.34'),(845,'/admin/config/regional/language?render=overlay','default','Administer marketplace funds Deposit transaction entity type','','7.34'),(846,'/admin/config/regional/language?render=overlay','default','Configure Deposit transaction transactions.','','7.34'),(847,'/admin/config/regional/language?render=overlay','default','Administer marketplace funds Funds transfer transaction entity type','','7.34'),(848,'/admin/config/regional/language?render=overlay','default','Configure Funds transfer transaction transactions.','','7.34'),(849,'/admin/config/regional/language?render=overlay','default','Administer marketplace funds Payment transaction entity type','','7.34'),(850,'/admin/config/regional/language?render=overlay','default','Configure Payment transaction transactions.','','7.34'),(851,'/admin/config/regional/language?render=overlay','default','Administer marketplace funds Withdraw transaction entity type','','7.34'),(852,'/admin/config/regional/language?render=overlay','default','Configure Withdraw transaction transactions.','','7.34'),(853,'/admin/config/regional/language?render=overlay','default','Commerce Marketplace Funds Processor','','7.34'),(854,'/admin/config/regional/language?render=overlay','default','Change Commerce Marketplace Funds Processor.','','7.34'),(855,'/admin/config/regional/language?render=overlay','default','Manage withdraw method entity types, including adding\r\n      and removing fields and the display of fields.','','7.34'),(856,'/admin/config/regional/language?render=overlay','default','Add @entity_type','','7.34'),(857,'/admin/config/regional/language?render=overlay','default','Import @entity_type','','7.34'),(858,'/admin/config/regional/language?render=overlay','default','Field settings','','7.34'),(859,'/admin/config/regional/language?render=overlay','default','Widget type','','7.34'),(860,'/admin/config/regional/language?render=overlay','default','Add link','','7.34'),(861,'/admin/config/regional/language?render=overlay','default','Delete menu','','7.34'),(862,'/admin/config/regional/language?render=overlay','default','Edit menu','','7.34'),(863,'/admin/config/regional/language?render=overlay','default','List links','','7.34'),(864,'/admin/config/regional/language?render=overlay','default','Add term','','7.34'),(865,'/admin/config/regional/language?render=overlay','default','Webform','','7.34'),(866,'/admin/config/regional/language?render=overlay','default','Status','','7.34'),(867,'/admin/config/regional/language?render=overlay','default','The open or closed status of a webform.','','7.34'),(868,'/admin/config/regional/language?render=overlay','default','Webform submissions','','7.34'),(869,'/admin/config/regional/language?render=overlay','default','Submissions generated from Webform forms.','','7.34'),(870,'/admin/config/regional/language?render=overlay','default','Serial number','','7.34'),(871,'/admin/config/regional/language?render=overlay','default','The serial number of the submission.','','7.34'),(872,'/admin/config/regional/language?render=overlay','default','Sid','','7.34'),(873,'/admin/config/regional/language?render=overlay','default','The submission ID of the submission.','','7.34'),(874,'/admin/config/regional/language?render=overlay','default','Value','','7.34'),(875,'/admin/config/regional/language?render=overlay','default','The value of a component as submitted by a user.','','7.34'),(876,'/admin/config/regional/language?render=overlay','default','Webform submission data','','7.34'),(877,'/admin/config/regional/language?render=overlay','default','The webform node this submission was generated from.','','7.34'),(878,'/admin/config/regional/language?render=overlay','default','Webform Node','','7.34'),(879,'/admin/config/regional/language?render=overlay','default','The user who sent the webform submission.','','7.34'),(880,'/admin/config/regional/language?render=overlay','default','Webform Submission User','','7.34'),(881,'/admin/config/regional/language?render=overlay','default','Draft','','7.34'),(882,'/admin/config/regional/language?render=overlay','default','Whether or not the submission is a draft.','','7.34'),(883,'/admin/config/regional/language?render=overlay','default','Submitted','','7.34'),(884,'/admin/config/regional/language?render=overlay','default','The date this submission was submitted.','','7.34'),(885,'/admin/config/regional/language?render=overlay','default','Remote address','','7.34'),(886,'/admin/config/regional/language?render=overlay','default','The remote IP address of the user that submitted this submission.','','7.34'),(887,'/admin/config/regional/language?render=overlay','default','View link','','7.34'),(888,'/admin/config/regional/language?render=overlay','default','Provide a simple link to view the submission.','','7.34'),(889,'/admin/config/regional/language?render=overlay','default','Edit link','','7.34'),(890,'/admin/config/regional/language?render=overlay','default','Provide a simple link to edit the submission.','','7.34'),(891,'/admin/config/regional/language?render=overlay','default','Delete link','','7.34'),(892,'/admin/config/regional/language?render=overlay','default','Provide a simple link to delete the submission.','','7.34'),(893,'/admin/config/regional/language?render=overlay','default','Data','','7.34'),(894,'/admin/config/regional/language?render=overlay','default','Relates to a webform submission data','','7.34'),(895,'/admin/config/regional/language?render=overlay','default','Submission Data','','7.34'),(896,'/admin/config/regional/language?render=overlay','default','Data field','','7.34'),(897,'/admin/config/regional/language?render=overlay','default','Value (raw)','','7.34'),(898,'/admin/config/regional/language?render=overlay','default','The raw value from the database as submitted by a user. Use only when needing to sort on a field value.','','7.34'),(899,'/admin/config/regional/language?render=overlay','default','Value delta','','7.34'),(900,'/admin/config/regional/language?render=overlay','default','The delta value of the submitted data in a multi value component (such as checkboxes).','','7.34'),(901,'/admin/config/regional/language?render=overlay','default','Comments are responses to node content.','','7.34'),(902,'/admin/config/regional/language?render=overlay','default','The title of the comment.','','7.34'),(903,'/admin/config/regional/language?render=overlay','default','ID','','7.34'),(904,'/admin/config/regional/language?render=overlay','default','The comment ID of the field','','7.34'),(905,'/admin/config/regional/language?render=overlay','default','Author','','7.34'),(906,'/admin/config/regional/language?render=overlay','default','The name of the comment\'s author. Can be rendered as a link to the author\'s homepage.','','7.34'),(907,'/admin/config/regional/language?render=overlay','default','Author\'s website','','7.34'),(908,'/admin/config/regional/language?render=overlay','default','The website address of the comment\'s author. Can be rendered as a link. Will be empty if the author is a registered user.','','7.34'),(909,'/admin/config/regional/language?render=overlay','default','Hostname','','7.34'),(910,'/admin/config/regional/language?render=overlay','default','Hostname of user that posted the comment.','','7.34'),(911,'/admin/config/regional/language?render=overlay','default','Mail','','7.34'),(912,'/admin/config/regional/language?render=overlay','default','Email of user that posted the comment. Will be empty if the author is a registered user.','','7.34'),(913,'/admin/config/regional/language?render=overlay','default','Post date','','7.34'),(914,'/admin/config/regional/language?render=overlay','default','Date and time of when the comment was created.','','7.34'),(915,'/admin/config/regional/language?render=overlay','default','Language','','7.34'),(916,'/admin/config/regional/language?render=overlay','default','The language the comment is in.','','7.34'),(917,'/admin/config/regional/language?render=overlay','default','Updated date','','7.34'),(918,'/admin/config/regional/language?render=overlay','default','Date and time of when the comment was last updated.','','7.34'),(919,'/admin/config/regional/language?render=overlay','default','Created date','','7.34'),(920,'/admin/config/regional/language?render=overlay','default','Date in the form of CCYYMMDD.','','7.34'),(921,'/admin/config/regional/language?render=overlay','default','Created year + month','','7.34'),(922,'/admin/config/regional/language?render=overlay','default','Date in the form of YYYYMM.','','7.34'),(923,'/admin/config/regional/language?render=overlay','default','Created year','','7.34'),(924,'/admin/config/regional/language?render=overlay','default','Date in the form of YYYY.','','7.34'),(925,'/admin/config/regional/language?render=overlay','default','Created month','','7.34'),(926,'/admin/config/regional/language?render=overlay','default','Date in the form of MM (01 - 12).','','7.34'),(927,'/admin/config/regional/language?render=overlay','default','Created day','','7.34'),(928,'/admin/config/regional/language?render=overlay','default','Date in the form of DD (01 - 31).','','7.34'),(929,'/admin/config/regional/language?render=overlay','default','Created week','','7.34'),(930,'/admin/config/regional/language?render=overlay','default','Date in the form of WW (01 - 53).','','7.34'),(931,'/admin/config/regional/language?render=overlay','default','Approved','','7.34'),(932,'/admin/config/regional/language?render=overlay','default','Whether the comment is approved (or still in the moderation queue).','','7.34'),(933,'/admin/config/regional/language?render=overlay','default','Not Approved','','7.34'),(934,'/admin/config/regional/language?render=overlay','default','Approved comment','','7.34'),(935,'/admin/config/regional/language?render=overlay','default','Provide a simple link to view the comment.','','7.34'),(936,'/admin/config/regional/language?render=overlay','default','Provide a simple link to edit the comment.','','7.34'),(937,'/admin/config/regional/language?render=overlay','default','Provide a simple link to delete the comment.','','7.34'),(938,'/admin/config/regional/language?render=overlay','default','Approve link','','7.34'),(939,'/admin/config/regional/language?render=overlay','default','Provide a simple link to approve the comment.','','7.34'),(940,'/admin/config/regional/language?render=overlay','default','Reply-to link','','7.34'),(941,'/admin/config/regional/language?render=overlay','default','Provide a simple link to reply to the comment.','','7.34'),(942,'/admin/config/regional/language?render=overlay','default','Depth','','7.34'),(943,'/admin/config/regional/language?render=overlay','default','Display the depth of the comment if it is threaded.','','7.34'),(944,'/admin/config/regional/language?render=overlay','default','Thread','','7.34'),(945,'/admin/config/regional/language?render=overlay','default','Sort by the threaded order. This will keep child comments together with their parents.','','7.34'),(946,'/admin/config/regional/language?render=overlay','default','Nid','','7.34'),(947,'/admin/config/regional/language?render=overlay','default','The node ID to which the comment is a reply to.','','7.34'),(948,'/admin/config/regional/language?render=overlay','default','The content to which the comment is a reply to.','','7.34'),(949,'/admin/config/regional/language?render=overlay','default','Author uid','','7.34'),(950,'/admin/config/regional/language?render=overlay','default','If you need more fields than the uid add the comment: author relationship','','7.34'),(951,'/admin/config/regional/language?render=overlay','default','The User ID of the comment\'s author.','','7.34'),(952,'/admin/config/regional/language?render=overlay','default','author','','7.34'),(953,'/admin/config/regional/language?render=overlay','default','Parent CID','','7.34'),(954,'/admin/config/regional/language?render=overlay','default','The Comment ID of the parent comment.','','7.34'),(955,'/admin/config/regional/language?render=overlay','default','Parent comment','','7.34'),(956,'/admin/config/regional/language?render=overlay','default','The parent comment.','','7.34'),(957,'/admin/config/regional/language?render=overlay','default','Last comment time','','7.34'),(958,'/admin/config/regional/language?render=overlay','default','Date and time of when the last comment was posted.','','7.34'),(959,'/admin/config/regional/language?render=overlay','default','Last comment author','','7.34'),(960,'/admin/config/regional/language?render=overlay','default','The name of the author of the last posted comment.','','7.34'),(961,'/admin/config/regional/language?render=overlay','default','Comment count','','7.34'),(962,'/admin/config/regional/language?render=overlay','default','The number of comments a node has.','','7.34'),(963,'/admin/config/regional/language?render=overlay','default','Updated/commented date','','7.34'),(964,'/admin/config/regional/language?render=overlay','default','The most recent of last comment posted or node updated time.','','7.34'),(965,'/admin/config/regional/language?render=overlay','default','Last comment CID','','7.34'),(966,'/admin/config/regional/language?render=overlay','default','Display the last comment of a node','','7.34'),(967,'/admin/config/regional/language?render=overlay','default','Last Comment','','7.34'),(968,'/admin/config/regional/language?render=overlay','default','The last comment of a node.','','7.34'),(969,'/admin/config/regional/language?render=overlay','default','Last comment uid','','7.34'),(970,'/admin/config/regional/language?render=overlay','default','The User ID of the author of the last comment of a node.','','7.34'),(971,'/admin/config/regional/language?render=overlay','default','Commerce Customer Profile','','7.34'),(972,'/admin/config/regional/language?render=overlay','default','Customer profiles containing addresses and other customer information.','','7.34'),(973,'/admin/config/regional/language?render=overlay','default','Profile ID','','7.34'),(974,'/admin/config/regional/language?render=overlay','default','The unique internal identifier of the profile.','','7.34'),(975,'/admin/config/regional/language?render=overlay','default','Type','','7.34'),(976,'/admin/config/regional/language?render=overlay','default','The human-readable name of the type of the customer profile.','','7.34'),(977,'/admin/config/regional/language?render=overlay','default','Owner','','7.34'),(978,'/admin/config/regional/language?render=overlay','default','Relate a profile to the user it belongs to.','','7.34'),(979,'/admin/config/regional/language?render=overlay','default','Profile owner','','7.34'),(980,'/admin/config/regional/language?render=overlay','default','Whether or not the profile is active.','','7.34'),(981,'/admin/config/regional/language?render=overlay; sites/all/modules/commerce/modules/customer/commerce_customer.js','default','Active','','7.34'),(982,'/admin/config/regional/language?render=overlay; sites/all/modules/weight/weight.js; sites/all/modules/commerce/modules/customer/commerce_customer.js; sites/all/modules/search_api/search_api.admin.js','default','Disabled','','7.34'),(983,'/admin/config/regional/language?render=overlay','default','The date the profile was created.','','7.34'),(984,'/admin/config/regional/language?render=overlay','default','In the form of CCYYMMDD.','','7.34'),(985,'/admin/config/regional/language?render=overlay','default','In the form of YYYYMM.','','7.34'),(986,'/admin/config/regional/language?render=overlay','default','In the form of YYYY.','','7.34'),(987,'/admin/config/regional/language?render=overlay','default','In the form of MM (01 - 12).','','7.34'),(988,'/admin/config/regional/language?render=overlay','default','In the form of DD (01 - 31).','','7.34'),(989,'/admin/config/regional/language?render=overlay','default','In the form of WW (01 - 53).','','7.34'),(990,'/admin/config/regional/language?render=overlay','default','The date the profile was last updated.','','7.34'),(991,'/admin/config/regional/language?render=overlay','default','Updated year + month','','7.34'),(992,'/admin/config/regional/language?render=overlay','default','Updated year','','7.34'),(993,'/admin/config/regional/language?render=overlay','default','Updated month','','7.34'),(994,'/admin/config/regional/language?render=overlay','default','Updated day','','7.34'),(995,'/admin/config/regional/language?render=overlay','default','Updated week','','7.34'),(996,'/admin/config/regional/language?render=overlay','default','Provide a simple link to the administrator view of the profile.','','7.34'),(997,'/admin/config/regional/language?render=overlay','default','Provide a simple link to edit the profile.','','7.34'),(998,'/admin/config/regional/language?render=overlay','default','Provide a simple link to delete the profile.','','7.34'),(999,'/admin/config/regional/language?render=overlay','default','Empty text','','7.34'),(1000,'/admin/config/regional/language?render=overlay','default','Displays an appropriate empty text message for customer profile lists.','','7.34'),(1001,'/admin/config/regional/language?render=overlay','default','Commerce Line Item','','7.34'),(1002,'/admin/config/regional/language?render=overlay','default','A line item referenced by another entity.','','7.34'),(1003,'/admin/config/regional/language?render=overlay','default','Line item ID','','7.34'),(1004,'/admin/config/regional/language?render=overlay','default','The unique internal identifier of the line item.','','7.34'),(1005,'/admin/config/regional/language?render=overlay','default','The human-readable name of the type of the line item.','','7.34'),(1006,'/admin/config/regional/language?render=overlay','default','The title of the line item determined by its type.','','7.34'),(1007,'/admin/config/regional/language?render=overlay','default','The label of the line item.','','7.34'),(1008,'/admin/config/regional/language?render=overlay','default','Quantity','','7.34'),(1009,'/admin/config/regional/language?render=overlay','default','The quantity of the line item.','','7.34'),(1010,'/admin/config/regional/language?render=overlay','default','Quantity text field','','7.34'),(1011,'/admin/config/regional/language?render=overlay','default','Adds a text field to edit the line item quantity in the View.','','7.34'),(1012,'/admin/config/regional/language?render=overlay','default','Delete button','','7.34'),(1013,'/admin/config/regional/language?render=overlay','default','Adds a button to delete a line item.','','7.34'),(1014,'/admin/config/regional/language?render=overlay','default','Order ID','a drupal commerce order','7.34'),(1015,'/admin/config/regional/language?render=overlay','default','The unique internal identifier of the associated order.','','7.34'),(1016,'/admin/config/regional/language?render=overlay','default','The date the line item was created.','','7.34'),(1017,'/admin/config/regional/language?render=overlay','default','The date the line item was last updated.','','7.34'),(1018,'/admin/config/regional/language?render=overlay','default','Line item summary','','7.34'),(1019,'/admin/config/regional/language?render=overlay','default','Summarize the line items in a View with an optional link to checkout.','','7.34'),(1020,'/admin/config/regional/language?render=overlay','default','Commerce Order','','7.34'),(1021,'/admin/config/regional/language?render=overlay','default','Order placed in the store.','','7.34'),(1022,'/admin/config/regional/language?render=overlay','default','The unique internal identifier of the order.','','7.34'),(1023,'/admin/config/regional/language?render=overlay','default','Order number','a drupal commerce order','7.34'),(1024,'/admin/config/regional/language?render=overlay','default','The unique customer facing number of the order.','','7.34'),(1025,'/admin/config/regional/language?render=overlay','default','Order type','a drupal commerce order','7.34'),(1026,'/admin/config/regional/language?render=overlay','default','The type of the order.','','7.34'),(1027,'/admin/config/regional/language?render=overlay','default','Uid','','7.34'),(1028,'/admin/config/regional/language?render=overlay','default','The owner\'s user ID.','','7.34'),(1029,'/admin/config/regional/language?render=overlay','default','Relate this order to its owner\'s user account','','7.34'),(1030,'/admin/config/regional/language?render=overlay','default','Order owner','','7.34'),(1031,'/admin/config/regional/language?render=overlay','default','Order status','','7.34'),(1032,'/admin/config/regional/language?render=overlay','default','The workflow status of the order.','','7.34'),(1033,'/admin/config/regional/language?render=overlay','default','Order state','','7.34'),(1034,'/admin/config/regional/language?render=overlay','default','The workflow state of the order.','','7.34'),(1035,'/admin/config/regional/language?render=overlay','default','E-mail','','7.34'),(1036,'/admin/config/regional/language?render=overlay','default','The e-mail address used for correspondence about this order.','','7.34'),(1037,'/admin/config/regional/language?render=overlay','default','The date the order was created.','','7.34'),(1038,'/admin/config/regional/language?render=overlay','default','The date the order was last updated.','','7.34'),(1039,'/admin/config/regional/language?render=overlay','default','Provide a simple link to the administrator view of the order.','','7.34'),(1040,'/admin/config/regional/language?render=overlay','default','Provide a simple link to edit the order.','','7.34'),(1041,'/admin/config/regional/language?render=overlay','default','Provide a simple link to delete the order.','','7.34'),(1042,'/admin/config/regional/language?render=overlay','default','Operations links','','7.34'),(1043,'/admin/config/regional/language?render=overlay','default','Display all the available operations links for the order.','','7.34'),(1044,'/admin/config/regional/language?render=overlay','default','Displays an appropriate empty text message for order lists.','','7.34'),(1045,'/admin/config/regional/language?render=overlay','default','Order total','','7.34'),(1046,'/admin/config/regional/language?render=overlay','default','Displays the order total field formatted with its components list; requires an Order ID argument.','','7.34'),(1047,'/admin/config/regional/language?render=overlay','default','Commerce Order revision','','7.34'),(1048,'/admin/config/regional/language?render=overlay','default','Commerce Order revision is a history of changes to an order.','','7.34'),(1049,'/admin/config/regional/language?render=overlay','default','The customer facing number of the order.','','7.34'),(1050,'/admin/config/regional/language?render=overlay','default','Revision ID','','7.34'),(1051,'/admin/config/regional/language?render=overlay','default','The revision ID of the order revision.','','7.34'),(1052,'/admin/config/regional/language?render=overlay','default','Order','','7.34'),(1053,'/admin/config/regional/language?render=overlay','default','Latest order revision','','7.34'),(1054,'/admin/config/regional/language?render=overlay','default','Relate an order revision to the user who created the revision.','','7.34'),(1055,'/admin/config/regional/language?render=overlay','default','Revision user','','7.34'),(1056,'/admin/config/regional/language?render=overlay','default','The e-mail address used for correspondence about this order revision.','','7.34'),(1057,'/admin/config/regional/language?render=overlay','default','The workflow status of the order revision.','','7.34'),(1058,'/admin/config/regional/language?render=overlay','default','Log message','','7.34'),(1059,'/admin/config/regional/language?render=overlay','default','The log message entered when the revision was created.','','7.34'),(1060,'/admin/config/regional/language?render=overlay','default','Revision date','','7.34'),(1061,'/admin/config/regional/language?render=overlay','default','The date the order revision was created.','','7.34'),(1062,'/admin/config/regional/language?render=overlay','default','View order form','','7.34'),(1063,'/admin/config/regional/language?render=overlay','default','Display a form that redirects to the view page for an order.','','7.34'),(1064,'/admin/config/regional/language?render=overlay','default','Commerce Payment Transaction','','7.34'),(1065,'/admin/config/regional/language?render=overlay','default','The receipt of a payment transaction.','','7.34'),(1066,'/admin/config/regional/language?render=overlay','default','Transaction ID','','7.34'),(1067,'/admin/config/regional/language?render=overlay','default','The unique internal identifier of the transaction.','','7.34'),(1068,'/admin/config/regional/language?render=overlay','default','The creator\'s user ID.','','7.34'),(1069,'/admin/config/regional/language?render=overlay','default','Creator','','7.34'),(1070,'/admin/config/regional/language?render=overlay','default','Relate this payment transaction to its creator\'s user account','','7.34'),(1071,'/admin/config/regional/language?render=overlay','default','Payment transaction creator','','7.34'),(1072,'/admin/config/regional/language?render=overlay','default','Payment method','','7.34'),(1073,'/admin/config/regional/language?render=overlay','default','The payment method of the transaction.','','7.34'),(1074,'/admin/config/regional/language?render=overlay','default','Remote ID','','7.34'),(1075,'/admin/config/regional/language?render=overlay','default','The remote identifier of this transaction at the payment provider.','','7.34'),(1076,'/admin/config/regional/language?render=overlay','default','Amount','','7.34'),(1077,'/admin/config/regional/language?render=overlay','default','The amount of the transaction.','','7.34'),(1078,'/admin/config/regional/language?render=overlay','default','Currency','','7.34'),(1079,'/admin/config/regional/language?render=overlay','default','The currency of the transaction.','','7.34'),(1080,'/admin/config/regional/language?render=overlay','default','Message','','7.34'),(1081,'/admin/config/regional/language?render=overlay','default','The message associated with the transaction.','','7.34'),(1082,'/admin/config/regional/language?render=overlay','default','The status of this transaction.','','7.34'),(1083,'/admin/config/regional/language?render=overlay','default','Remote status','','7.34'),(1084,'/admin/config/regional/language?render=overlay','default','The status of this transaction at the payment provider.','','7.34'),(1085,'/admin/config/regional/language?render=overlay','default','The date the transaction was created.','','7.34'),(1086,'/admin/config/regional/language?render=overlay','default','Changed date','','7.34'),(1087,'/admin/config/regional/language?render=overlay','default','The date the transaction was last changed.','','7.34'),(1088,'/admin/config/regional/language?render=overlay','default','Provide a simple link to delete the payment transaction.','','7.34'),(1089,'/admin/config/regional/language?render=overlay','default','Display all the available operations links for the transaction.','','7.34'),(1090,'/admin/config/regional/language?render=overlay','default','Totals','','7.34'),(1091,'/admin/config/regional/language?render=overlay','default','Display transaction total and order balance information for all transactions in the View.','','7.34'),(1092,'/admin/config/regional/language?render=overlay','default','Products from the store.','','7.34'),(1093,'/admin/config/regional/language?render=overlay','default','Product ID','','7.34'),(1094,'/admin/config/regional/language?render=overlay','default','The unique internal identifier of the product.','','7.34'),(1095,'/admin/config/regional/language?render=overlay','default','SKU','','7.34'),(1096,'/admin/config/regional/language?render=overlay','default','The unique human-readable identifier of the product.','','7.34'),(1097,'/admin/config/regional/language?render=overlay','default','The human-readable name of the type of the product.','','7.34'),(1098,'/admin/config/regional/language?render=overlay','default','The title of the product used for administrative display.','','7.34'),(1099,'/admin/config/regional/language?render=overlay','default','The language the product is in.','','7.34'),(1100,'/admin/config/regional/language?render=overlay','default','Relate a product to the user who created it.','','7.34'),(1101,'/admin/config/regional/language?render=overlay','default','Product creator','','7.34'),(1102,'/admin/config/regional/language?render=overlay','default','Whether or not the product is active.','','7.34'),(1103,'/admin/config/regional/language?render=overlay','default','The date the product was created.','','7.34'),(1104,'/admin/config/regional/language?render=overlay','default','The date the product was last updated.','','7.34'),(1105,'/admin/config/regional/language?render=overlay','default','Provide a simple link to the administrator view of the product.','','7.34'),(1106,'/admin/config/regional/language?render=overlay','default','Provide a simple link to edit the product.','','7.34'),(1107,'/admin/config/regional/language?render=overlay','default','Provide a simple link to delete the product.','','7.34'),(1108,'/admin/config/regional/language?render=overlay','default','Display all the available operations links for the product.','','7.34'),(1109,'/admin/config/regional/language?render=overlay','default','Displays an appropriate empty text message for product lists.','','7.34'),(1110,'/admin/config/regional/language?render=overlay','default','Commerce Product revision','','7.34'),(1111,'/admin/config/regional/language?render=overlay','default','Commerce Product revision is a history of changes to a product.','','7.34'),(1112,'/admin/config/regional/language?render=overlay','default','The revision ID of the product revision.','','7.34'),(1113,'/admin/config/regional/language?render=overlay','default','Latest product revision','','7.34'),(1114,'/admin/config/regional/language?render=overlay','default','The unique human-readable identifier of the product revision.','','7.34'),(1115,'/admin/config/regional/language?render=overlay','default','The title of the product revision used for administrative display.','','7.34'),(1116,'/admin/config/regional/language?render=overlay','default','Relate a product revision to the user who created the revision.','','7.34'),(1117,'/admin/config/regional/language?render=overlay','default','Whether or not the product was active at the time of the revision.','','7.34'),(1118,'/admin/config/regional/language?render=overlay','default','The date the product revision was created.','','7.34'),(1119,'/admin/config/regional/language?render=overlay','default','Country ID','','7.34'),(1120,'/admin/config/regional/language?render=overlay','default','The country ID of the country.','','7.34'),(1121,'/admin/config/regional/language?render=overlay','default','ISO2','','7.34'),(1122,'/admin/config/regional/language?render=overlay','default','The ISO2 country code of the country.','','7.34'),(1123,'/admin/config/regional/language?render=overlay','default','ISO2 - list','','7.34'),(1124,'/admin/config/regional/language?render=overlay','default','ISO3','','7.34'),(1125,'/admin/config/regional/language?render=overlay','default','The ISO3 country code of the country.','','7.34'),(1126,'/admin/config/regional/language?render=overlay','default','ISO3 - list','','7.34'),(1127,'/admin/config/regional/language?render=overlay','default','The name of the country.','','7.34'),(1128,'/admin/config/regional/language?render=overlay','default','Name - list','','7.34'),(1129,'/admin/config/regional/language?render=overlay','default','The official name of the country.','','7.34'),(1130,'/admin/config/regional/language?render=overlay','default','Official name - list','','7.34'),(1131,'/admin/config/regional/language?render=overlay','default','The continent of this country.','','7.34'),(1132,'/admin/config/regional/language?render=overlay','default','Continent - list','','7.34'),(1133,'/admin/config/regional/language?render=overlay; sites/all/modules/weight/weight.js; sites/all/modules/search_api/search_api.admin.js','default','Enabled','','7.34'),(1134,'/admin/config/regional/language?render=overlay','default','Whether or not the country is enabled.','','7.34'),(1135,'/admin/config/regional/language?render=overlay','default','The internal numeric ID of the customer profile.','','7.34'),(1136,'/admin/config/regional/language?render=overlay','default','The type of the customer profile.','','7.34'),(1137,'/admin/config/regional/language?render=overlay','default','User ID','','7.34'),(1138,'/admin/config/regional/language?render=overlay','default','The unique ID of the user the customer profile belongs to.','','7.34'),(1139,'/admin/config/regional/language?render=overlay','default','The user the customer profile belongs to.','','7.34'),(1140,'/admin/config/regional/language?render=overlay','default','Whether or not the customer profile is active.','','7.34'),(1141,'/admin/config/regional/language?render=overlay','default','Date created','','7.34'),(1142,'/admin/config/regional/language?render=overlay','default','The date the customer profile was created.','','7.34'),(1143,'/admin/config/regional/language?render=overlay','default','Date updated','','7.34'),(1144,'/admin/config/regional/language?render=overlay','default','The date the customer profile was last updated.','','7.34'),(1145,'/admin/config/regional/language?render=overlay','default','The internal numeric ID of the line item.','','7.34'),(1146,'/admin/config/regional/language?render=overlay','default','The unique ID of the order the line item belongs to.','','7.34'),(1147,'/admin/config/regional/language?render=overlay','default','The order the line item belongs to.','','7.34'),(1148,'/admin/config/regional/language?render=overlay','default','The human readable name of the line item type.','','7.34'),(1149,'/admin/config/regional/language?render=overlay','default','Line item label','','7.34'),(1150,'/admin/config/regional/language?render=overlay','default','The label displayed with the line item.','','7.34'),(1151,'/admin/config/regional/language?render=overlay','default','Quantity associated with this line item','','7.34'),(1152,'/admin/config/regional/language?render=overlay','default','Date changed','','7.34'),(1153,'/admin/config/regional/language?render=overlay','default','The date the line item was most recently updated.','','7.34'),(1154,'/admin/config/regional/language?render=overlay','default','The internal numeric ID of the order.','','7.34'),(1155,'/admin/config/regional/language?render=overlay','default','The order number displayed to the customer.','','7.34'),(1156,'/admin/config/regional/language?render=overlay','default','The current status of the order.','','7.34'),(1157,'/admin/config/regional/language?render=overlay','default','State','','7.34'),(1158,'/admin/config/regional/language?render=overlay','default','The state of the order derived from its status.','','7.34'),(1159,'/admin/config/regional/language?render=overlay','default','The date the order was most recently updated.','','7.34'),(1160,'/admin/config/regional/language?render=overlay','default','Host name','','7.34'),(1161,'/admin/config/regional/language?render=overlay','default','The IP address that created this order.','','7.34'),(1162,'/admin/config/regional/language?render=overlay','default','The human readable name of the order type.','','7.34'),(1163,'/admin/config/regional/language?render=overlay','default','Owner ID','','7.34'),(1164,'/admin/config/regional/language?render=overlay','default','The unique ID of the order owner.','','7.34'),(1165,'/admin/config/regional/language?render=overlay','default','The owner of the order.','','7.34'),(1166,'/admin/config/regional/language?render=overlay','default','Order e-mail','','7.34'),(1167,'/admin/config/regional/language?render=overlay','default','The e-mail address associated with this order.','','7.34'),(1168,'/admin/config/regional/language?render=overlay','default','Order e-mail prepared for username usage','','7.34'),(1169,'/admin/config/regional/language?render=overlay','default','The e-mail address associated with this order with illegal characters for usernames replaced.','','7.34'),(1170,'/admin/config/regional/language?render=overlay','default','The internal numeric ID of the transaction.','','7.34'),(1171,'/admin/config/regional/language?render=overlay','default','The unique ID of the user who created the transaction.','','7.34'),(1172,'/admin/config/regional/language?render=overlay','default','The user who created the transaction.','','7.34'),(1173,'/admin/config/regional/language?render=overlay','default','The unique ID of the order the transaction belongs to.','','7.34'),(1174,'/admin/config/regional/language?render=overlay','default','The order the transaction belongs to.','','7.34'),(1175,'/admin/config/regional/language?render=overlay','default','The date the payment was created.','','7.34'),(1176,'/admin/config/regional/language?render=overlay','default','The date the payment was last updated.','','7.34'),(1177,'/admin/config/regional/language?render=overlay','default','Remote id','','7.34'),(1178,'/admin/config/regional/language?render=overlay','default','The remote identifier for this transaction.','','7.34'),(1179,'/admin/config/regional/language?render=overlay','default','The amount for this transaction.','','7.34'),(1180,'/admin/config/regional/language?render=overlay','default','Currency Code','','7.34'),(1181,'/admin/config/regional/language?render=overlay','default','The currency code for this transaction.','','7.34'),(1182,'/admin/config/regional/language?render=overlay','default','Message for this transaction.','','7.34'),(1183,'/admin/config/regional/language?render=overlay','default','Status of the payment transaction.','','7.34'),(1184,'/admin/config/regional/language?render=overlay','default','Remote status of the payment transaction.','','7.34'),(1185,'/admin/config/regional/language?render=overlay','default','The internal numeric ID of the product.','','7.34'),(1186,'/admin/config/regional/language?render=overlay','default','The human readable product SKU.','','7.34'),(1187,'/admin/config/regional/language?render=overlay','default','The type of the product.','','7.34'),(1188,'/admin/config/regional/language?render=overlay','default','The title of the product.','','7.34'),(1189,'/admin/config/regional/language?render=overlay','default','The language the product was created in.','','7.34'),(1190,'/admin/config/regional/language?render=overlay','default','Boolean indicating whether the product is active or disabled.','','7.34'),(1191,'/admin/config/regional/language?render=overlay','default','The date the product was most recently updated.','','7.34'),(1192,'/admin/config/regional/language?render=overlay','default','Creator ID','','7.34'),(1193,'/admin/config/regional/language?render=overlay','default','The unique ID of the product creator.','','7.34'),(1194,'/admin/config/regional/language?render=overlay','default','The creator of the product.','','7.34'),(1195,'/admin/config/regional/language?render=overlay','default','!entity_type type','','7.34'),(1196,'/admin/config/regional/language?render=overlay','default','The type of this :entity_type entity.','','7.34'),(1197,'/admin/config/regional/language?render=overlay','default','@entity \"@property\" property.','','7.34'),(1198,'/admin/config/regional/language?render=overlay','default','@entity ID','','7.34'),(1199,'/admin/config/regional/language?render=overlay','default','The unique ID of the @entity.','','7.34'),(1200,'/admin/config/regional/language?render=overlay','default','URL','','7.34'),(1201,'/admin/config/regional/language?render=overlay','default','The URL of the entity.','','7.34'),(1202,'/admin/config/regional/language?render=overlay','default','Funds account ID','','7.34'),(1203,'/admin/config/regional/language?render=overlay','default','The unique ID of the funds account.','','7.34'),(1204,'/admin/config/regional/language?render=overlay','default','Owner type','','7.34'),(1205,'/admin/config/regional/language?render=overlay','default','Entity type of the funds account owner.','','7.34'),(1206,'/admin/config/regional/language?render=overlay','default','Funds account owner','','7.34'),(1207,'/admin/config/regional/language?render=overlay','default','The owner of the funds account.','','7.34'),(1208,'/admin/config/regional/language?render=overlay','default','Field: The funds account balance','','7.34'),(1209,'/admin/config/regional/language?render=overlay','default','Amount value of field %name','','7.34'),(1210,'/admin/config/regional/language?render=overlay','default','Amount (decimal)','','7.34'),(1211,'/admin/config/regional/language?render=overlay','default','Amount value of field %name (as a decimal)','','7.34'),(1212,'/admin/config/regional/language?render=overlay','default','Currency code of field %name','','7.34'),(1213,'/admin/config/regional/language?render=overlay','default','Data array of field %name','','7.34'),(1214,'/admin/config/regional/language?render=overlay','default','The date the funds account was created.','','7.34'),(1215,'/admin/config/regional/language?render=overlay','default','The date the funds account was most recently updated.','','7.34'),(1216,'/admin/config/regional/language?render=overlay','default','Funds transaction ID','','7.34'),(1217,'/admin/config/regional/language?render=overlay','default','The unique ID of the funds transaction.','','7.34'),(1218,'/admin/config/regional/language?render=overlay','default','Transaction type','','7.34'),(1219,'/admin/config/regional/language?render=overlay','default','The type of the funds transaction.','','7.34'),(1220,'/admin/config/regional/language?render=overlay','default','Originator account','','7.34'),(1221,'/admin/config/regional/language?render=overlay','default','The transaction originator account.','','7.34'),(1222,'/admin/config/regional/language?render=overlay','default','Destination account','','7.34'),(1223,'/admin/config/regional/language?render=overlay','default','The transaction destination account.','','7.34'),(1224,'/admin/config/regional/language?render=overlay','default','Order ID','','7.34'),(1225,'/admin/config/regional/language?render=overlay','default','The Commerce Order of the transaction.','','7.34'),(1226,'/admin/config/regional/language?render=overlay','default','The transaction status.','','7.34'),(1227,'/admin/config/regional/language?render=overlay','default','Field: The transaction amount','','7.34'),(1228,'/admin/config/regional/language?render=overlay','default','The date the funds transaction was created.','','7.34'),(1229,'/admin/config/regional/language?render=overlay','default','The date the funds transaction was most recently updated.','','7.34'),(1230,'/admin/config/regional/language?render=overlay','default','Withdraw Method ID','','7.34'),(1231,'/admin/config/regional/language?render=overlay','default','The unique ID of the Withdraw method.','','7.34'),(1232,'/admin/config/regional/language?render=overlay','default','Associated funds account','','7.34'),(1233,'/admin/config/regional/language?render=overlay','default','The funds account associated with this withdraw method.','','7.34'),(1234,'/admin/config/regional/language?render=overlay','default','The type of the withdraw method.','','7.34'),(1235,'/admin/config/regional/language?render=overlay','default','Machine-readable name','','7.34'),(1236,'/admin/config/regional/language?render=overlay','default','The machine-readable name identifying this @entity.','','7.34'),(1237,'/admin/config/regional/language?render=overlay','default','Internal, numeric @entity ID','','7.34'),(1238,'/admin/config/regional/language?render=overlay','default','The ID used to identify this @entity internally.','','7.34'),(1239,'/admin/config/regional/language?render=overlay','default','The human readable label.','','7.34'),(1240,'/admin/config/regional/language?render=overlay','default','Field name','','7.34'),(1241,'/admin/config/regional/language?render=overlay','default','The machine-readable name of the field collection field containing this item.','','7.34'),(1242,'/admin/config/regional/language?render=overlay','default','Host entity','','7.34'),(1243,'/admin/config/regional/language?render=overlay','default','The entity containing the field collection field.','','7.34'),(1244,'/admin/config/regional/language?render=overlay','default','Comment ID','','7.34'),(1245,'/admin/config/regional/language?render=overlay','default','The unique ID of the comment.','','7.34'),(1246,'/admin/config/regional/language?render=overlay','default','IP Address','','7.34'),(1247,'/admin/config/regional/language?render=overlay','default','The IP address of the computer the comment was posted from.','','7.34'),(1248,'/admin/config/regional/language?render=overlay','default','The name left by the comment author.','','7.34'),(1249,'/admin/config/regional/language?render=overlay','default','Email address','','7.34'),(1250,'/admin/config/regional/language?render=overlay','default','The email address left by the comment author.','','7.34'),(1251,'/admin/config/regional/language?render=overlay','default','Home page','','7.34'),(1252,'/admin/config/regional/language?render=overlay','default','The home page URL left by the comment author.','','7.34'),(1253,'/admin/config/regional/language?render=overlay','default','The subject of the comment.','','7.34'),(1254,'/admin/config/regional/language?render=overlay','default','The URL of the comment.','','7.34'),(1255,'/admin/config/regional/language?render=overlay','default','Edit URL','','7.34'),(1256,'/admin/config/regional/language?render=overlay','default','The URL of the comment\'s edit page.','','7.34'),(1257,'/admin/config/regional/language?render=overlay','default','The date the comment was posted.','','7.34'),(1258,'/admin/config/regional/language?render=overlay','default','Parent','','7.34'),(1259,'/admin/config/regional/language?render=overlay','default','The comment\'s parent, if comment threading is active.','','7.34'),(1260,'/admin/config/regional/language?render=overlay','default','The node the comment was posted to.','','7.34'),(1261,'/admin/config/regional/language?render=overlay','default','The author of the comment.','','7.34'),(1262,'/admin/config/regional/language?render=overlay','default','Whether the comment is published or unpublished.','','7.34'),(1263,'/admin/config/regional/language?render=overlay','default','Field \"@name\".','','7.34'),(1264,'/admin/config/regional/language?render=overlay','default','Summary','','7.34'),(1265,'/admin/config/regional/language?render=overlay','default','Text format','','7.34'),(1266,'/admin/config/regional/language?render=overlay','default','The file.','','7.34'),(1267,'/admin/config/regional/language?render=overlay','default','The file description','','7.34'),(1268,'/admin/config/regional/language?render=overlay','default','Whether the file is being displayed.','','7.34'),(1269,'/admin/config/regional/language?render=overlay','default','The image file.','','7.34'),(1270,'/admin/config/regional/language?render=overlay','default','The \"Alt\" attribute text','','7.34'),(1271,'/admin/config/regional/language?render=overlay','default','The \"Title\" attribute text','','7.34'),(1272,'/admin/config/regional/language?render=overlay','default','The title of the link.','','7.34'),(1273,'/admin/config/regional/language?render=overlay','default','The URL of the link.','','7.34'),(1274,'/admin/config/regional/language?render=overlay','default','The attributes of the link.','','7.34'),(1275,'/admin/config/regional/language?render=overlay','default','Average Rating','','7.34'),(1276,'/admin/config/regional/language?render=overlay','default','User\'s Rating','','7.34'),(1277,'/admin/config/regional/language?render=overlay','default','Rating count','','7.34'),(1278,'/admin/config/regional/language?render=overlay','default','Full name','','7.34'),(1279,'/admin/config/regional/language?render=overlay','default','First name','','7.34'),(1280,'/admin/config/regional/language?render=overlay','default','Last name','','7.34'),(1281,'/admin/config/regional/language?render=overlay','default','Company','','7.34'),(1282,'/admin/config/regional/language?render=overlay','default','Administrative area (i.e. State / Province)','','7.34'),(1283,'/admin/config/regional/language?render=overlay','default','Sub administrative area','','7.34'),(1284,'/admin/config/regional/language?render=overlay','default','Locality (i.e. City)','','7.34'),(1285,'/admin/config/regional/language?render=overlay','default','Dependent locality','','7.34'),(1286,'/admin/config/regional/language?render=overlay','default','Postal code','','7.34'),(1287,'/admin/config/regional/language?render=overlay','default','Thoroughfare (i.e. Street address)','','7.34'),(1288,'/admin/config/regional/language?render=overlay','default','Premise (i.e. Apartment / Suite number)','','7.34'),(1289,'/admin/config/regional/language?render=overlay','default','Node ID','','7.34'),(1290,'/admin/config/regional/language?render=overlay','default','The unique ID of the node.','','7.34'),(1291,'/admin/config/regional/language?render=overlay','default','The unique ID of the node\'s revision.','','7.34'),(1292,'/admin/config/regional/language?render=overlay','default','Is new','','7.34'),(1293,'/admin/config/regional/language?render=overlay','default','Whether the node is new and not saved to the database yet.','','7.34'),(1294,'/admin/config/regional/language?render=overlay','default','Content type','','7.34'),(1295,'/admin/config/regional/language?render=overlay','default','The type of the node.','','7.34'),(1296,'/admin/config/regional/language?render=overlay','default','The title of the node.','','7.34'),(1297,'/admin/config/regional/language?render=overlay','default','The language the node is written in.','','7.34'),(1298,'/admin/config/regional/language?render=overlay','default','The URL of the node.','','7.34'),(1299,'/admin/config/regional/language?render=overlay','default','The URL of the node\'s edit page.','','7.34'),(1300,'/admin/config/regional/language?render=overlay','default','Whether the node is published or unpublished.','','7.34'),(1301,'/admin/config/regional/language?render=overlay','default','Promoted to frontpage','','7.34'),(1302,'/admin/config/regional/language?render=overlay','default','Whether the node is promoted to the frontpage.','','7.34'),(1303,'/admin/config/regional/language?render=overlay','default','Sticky in lists','','7.34'),(1304,'/admin/config/regional/language?render=overlay','default','Whether the node is displayed at the top of lists in which it appears.','','7.34'),(1305,'/admin/config/regional/language?render=overlay','default','The date the node was posted.','','7.34'),(1306,'/admin/config/regional/language?render=overlay','default','The date the node was most recently updated.','','7.34'),(1307,'/admin/config/regional/language?render=overlay','default','The author of the node.','','7.34'),(1308,'/admin/config/regional/language?render=overlay','default','Translation source node','','7.34'),(1309,'/admin/config/regional/language?render=overlay','default','The original-language version of this node, if one exists.','','7.34'),(1310,'/admin/config/regional/language?render=overlay','default','Revision log message','','7.34'),(1311,'/admin/config/regional/language?render=overlay','default','In case a new revision is to be saved, the log entry explaining the changes for this version.','','7.34'),(1312,'/admin/config/regional/language?render=overlay','default','Creates revision','','7.34'),(1313,'/admin/config/regional/language?render=overlay','default','Whether saving this node creates a new revision.','','7.34'),(1314,'/admin/config/regional/language?render=overlay','default','Term ID','','7.34'),(1315,'/admin/config/regional/language?render=overlay','default','The unique ID of the taxonomy term.','','7.34'),(1316,'/admin/config/regional/language?render=overlay','default','The name of the taxonomy term.','','7.34'),(1317,'/admin/config/regional/language?render=overlay','default','The optional description of the taxonomy term.','','7.34'),(1318,'/admin/config/regional/language?render=overlay','default','Weight','','7.34'),(1319,'/admin/config/regional/language?render=overlay','default','The weight of the term, which is used for ordering terms during display.','','7.34'),(1320,'/admin/config/regional/language?render=overlay','default','Node count','','7.34'),(1321,'/admin/config/regional/language?render=overlay','default','The number of nodes tagged with the taxonomy term.','','7.34'),(1322,'/admin/config/regional/language?render=overlay','default','The URL of the taxonomy term.','','7.34'),(1323,'/admin/config/regional/language?render=overlay','default','The vocabulary the taxonomy term belongs to.','','7.34'),(1324,'/admin/config/regional/language?render=overlay','default','Parent terms','','7.34'),(1325,'/admin/config/regional/language?render=overlay','default','The parent terms of the taxonomy term.','','7.34'),(1326,'/admin/config/regional/language?render=overlay','default','All parent terms','','7.34'),(1327,'/admin/config/regional/language?render=overlay','default','Ancestors of the term, i.e. parent of all above hierarchy levels.','','7.34'),(1328,'/admin/config/regional/language?render=overlay','default','Vocabulary ID','','7.34'),(1329,'/admin/config/regional/language?render=overlay','default','The unique ID of the taxonomy vocabulary.','','7.34'),(1330,'/admin/config/regional/language?render=overlay','default','The name of the taxonomy vocabulary.','','7.34'),(1331,'/admin/config/regional/language?render=overlay','default','Machine name','','7.34'),(1332,'/admin/config/regional/language?render=overlay','default','The machine name of the taxonomy vocabulary.','','7.34'),(1333,'/admin/config/regional/language?render=overlay','default','The optional description of the taxonomy vocabulary.','','7.34'),(1334,'/admin/config/regional/language?render=overlay','default','Term count','','7.34'),(1335,'/admin/config/regional/language?render=overlay','default','The number of terms belonging to the taxonomy vocabulary.','','7.34'),(1336,'/admin/config/regional/language?render=overlay','default','The unique ID of the user account.','','7.34'),(1337,'/admin/config/regional/language?render=overlay','default','The login name of the user account.','','7.34'),(1338,'/admin/config/regional/language?render=overlay','default','Email','','7.34'),(1339,'/admin/config/regional/language?render=overlay','default','The email address of the user account.','','7.34'),(1340,'/admin/config/regional/language?render=overlay','default','The URL of the account profile page.','','7.34'),(1341,'/admin/config/regional/language?render=overlay','default','The url of the account edit page.','','7.34'),(1342,'/admin/config/regional/language?render=overlay','default','Last access','','7.34'),(1343,'/admin/config/regional/language?render=overlay','default','The date the user last accessed the site.','','7.34'),(1344,'/admin/config/regional/language?render=overlay','default','Last login','','7.34'),(1345,'/admin/config/regional/language?render=overlay','default','The date the user last logged in to the site.','','7.34'),(1346,'/admin/config/regional/language?render=overlay','default','Created','','7.34'),(1347,'/admin/config/regional/language?render=overlay','default','The date the user account was created.','','7.34'),(1348,'/admin/config/regional/language?render=overlay','default','User roles','','7.34'),(1349,'/admin/config/regional/language?render=overlay','default','The roles of the user.','','7.34'),(1350,'/admin/config/regional/language?render=overlay','default','Whether the user is active or blocked.','','7.34'),(1351,'/admin/config/regional/language?render=overlay','default','Default theme','','7.34'),(1352,'/admin/config/regional/language?render=overlay','default','The user\'s default theme.','','7.34'),(1353,'/admin/config/regional/language?render=overlay','default','The name of the site.','','7.34'),(1354,'/admin/config/regional/language?render=overlay','default','Slogan','','7.34'),(1355,'/admin/config/regional/language?render=overlay','default','The slogan of the site.','','7.34'),(1356,'/admin/config/regional/language?render=overlay','default','The administrative email address for the site.','','7.34'),(1357,'/admin/config/regional/language?render=overlay','default','The URL of the site\'s front page.','','7.34'),(1358,'/admin/config/regional/language?render=overlay','default','Login page','','7.34'),(1359,'/admin/config/regional/language?render=overlay','default','The URL of the site\'s login page.','','7.34'),(1360,'/admin/config/regional/language?render=overlay','default','Logged in user','','7.34'),(1361,'/admin/config/regional/language?render=overlay','default','The currently logged in user.','','7.34'),(1362,'/admin/config/regional/language?render=overlay','default','Current date','','7.34'),(1363,'/admin/config/regional/language?render=overlay','default','The current date and time.','','7.34'),(1364,'/admin/config/regional/language?render=overlay','default','Current page','','7.34'),(1365,'/admin/config/regional/language?render=overlay','default','Information related to the current page request.','','7.34'),(1366,'/admin/config/regional/language?render=overlay','default','The internal Drupal path of the current page request.','','7.34'),(1367,'/admin/config/regional/language?render=overlay','default','The full URL of the current page request.','','7.34'),(1368,'/admin/config/regional/language?render=overlay','default','File ID','','7.34'),(1369,'/admin/config/regional/language?render=overlay','default','The unique ID of the uploaded file.','','7.34'),(1370,'/admin/config/regional/language?render=overlay','default','File name','','7.34'),(1371,'/admin/config/regional/language?render=overlay','default','The name of the file on disk.','','7.34'),(1372,'/admin/config/regional/language?render=overlay','default','MIME type','','7.34'),(1373,'/admin/config/regional/language?render=overlay','default','The MIME type of the file.','','7.34'),(1374,'/admin/config/regional/language?render=overlay','default','File size','','7.34'),(1375,'/admin/config/regional/language?render=overlay','default','The size of the file, in kilobytes.','','7.34'),(1376,'/admin/config/regional/language?render=overlay','default','The web-accessible URL for the file.','','7.34'),(1377,'/admin/config/regional/language?render=overlay','default','Timestamp','','7.34'),(1378,'/admin/config/regional/language?render=overlay','default','The date the file was most recently changed.','','7.34'),(1379,'/admin/config/regional/language?render=overlay','default','The user who originally uploaded the file.','','7.34'),(1380,'/admin/config/regional/language?render=overlay','default','The primary identifier for a server.','','7.34'),(1381,'/admin/config/regional/language?render=overlay','default','The displayed name for a server.','','7.34'),(1382,'/admin/config/regional/language?render=overlay','default','The internally used machine name for a server.','','7.34'),(1383,'/admin/config/regional/language?render=overlay','default','The displayed description for a server.','','7.34'),(1384,'/admin/config/regional/language?render=overlay','default','Service class','','7.34'),(1385,'/admin/config/regional/language?render=overlay','default','The ID of the service class to use for this server.','','7.34'),(1386,'/admin/config/regional/language?render=overlay','default','A flag indicating whether the server is enabled.','','7.34'),(1387,'/admin/config/regional/language?render=overlay','default','Search API server status property','','7.34'),(1388,'/admin/config/regional/language?render=overlay','default','Module','','7.34'),(1389,'/admin/config/regional/language?render=overlay','default','The name of the module from which this server originates.','','7.34'),(1390,'/admin/config/regional/language?render=overlay','default','An integer identifying the index.','','7.34'),(1391,'/admin/config/regional/language?render=overlay','default','A name to be displayed for the index.','','7.34'),(1392,'/admin/config/regional/language?render=overlay','default','The internally used machine name for an index.','','7.34'),(1393,'/admin/config/regional/language?render=overlay','default','A string describing the index\' use to users.','','7.34'),(1394,'/admin/config/regional/language?render=overlay','default','Server ID','','7.34'),(1395,'/admin/config/regional/language?render=overlay','default','The machine name of the search_api_server with which data should be indexed.','','7.34'),(1396,'/admin/config/regional/language?render=overlay','default','Server','','7.34'),(1397,'/admin/config/regional/language?render=overlay','default','The search_api_server with which data should be indexed.','','7.34'),(1398,'/admin/config/regional/language?render=overlay','default','Item type','','7.34'),(1399,'/admin/config/regional/language?render=overlay','default','The type of items stored in this index.','','7.34'),(1400,'/admin/config/regional/language?render=overlay','default','A flag indicating whether the index is enabled.','','7.34'),(1401,'/admin/config/regional/language?render=overlay','default','Read only','','7.34'),(1402,'/admin/config/regional/language?render=overlay','default','A flag indicating whether the index is read-only.','','7.34'),(1403,'/admin/config/regional/language?render=overlay','default','Search API index status property','','7.34'),(1404,'/admin/config/regional/language?render=overlay','default','The name of the module from which this index originates.','','7.34'),(1405,'/admin/config/regional/language?render=overlay','default','User\'s shopping cart order','','7.34'),(1406,'/admin/config/regional/language?render=overlay','default','The shopping cart order belonging to the current user.','','7.34'),(1407,'/admin/config/regional/language?render=overlay','default','View URL','','7.34'),(1408,'/admin/config/regional/language?render=overlay','default','The URL a customer can visit to view the order.','','7.34'),(1409,'/admin/config/regional/language?render=overlay','default','Admin URL','','7.34'),(1410,'/admin/config/regional/language?render=overlay','default','The URL of the order\'s administrative view page.','','7.34'),(1411,'/admin/config/regional/language?render=overlay','default','The URL of the order\'s edit page.','','7.34'),(1412,'/admin/config/regional/language?render=overlay','default','The URL of the product\'s edit page.','','7.34'),(1413,'/admin/config/regional/language?render=overlay','default','A bridge to @entity_type referenced by @field_name','','7.34'),(1414,'/admin/config/regional/language?render=overlay','default','Continent name','','7.34'),(1415,'/admin/config/regional/language?render=overlay','default','The date the entity was created.','','7.34'),(1416,'/admin/config/regional/language?render=overlay','default','The last time this entity was updated.','','7.34'),(1417,'/admin/config/regional/language?render=overlay','default','Comments allowed','','7.34'),(1418,'/admin/config/regional/language?render=overlay','default','Whether comments are allowed on this node: 0 = no, 1 = closed (read only), 2 = open (read/write).','','7.34'),(1419,'/admin/config/regional/language?render=overlay','default','The node comments.','','7.34'),(1420,'/admin/config/regional/language?render=overlay','default','The number of comments posted on a node.','','7.34'),(1421,'/admin/config/regional/language?render=overlay','default','New comment count','','7.34'),(1422,'/admin/config/regional/language?render=overlay','default','The number of comments posted on a node since the reader last viewed it.','','7.34'),(1423,'/admin/config/regional/language?render=overlay','default','The main body text','','7.34'),(1424,'/admin/config/regional/language?render=overlay','default','This account\'s default language for e-mails, and preferred language for site presentation.','','7.34'),(1425,'/admin/config/regional/language?render=overlay','default','Interface language','','7.34'),(1426,'/admin/config/regional/language?render=overlay','default','The language code of the current user interface language.','','7.34'),(1427,'/admin/config/regional/language?render=overlay','default','Content language','','7.34'),(1428,'/admin/config/regional/language?render=overlay','default','The language code of the current content language.','','7.34'),(1429,'/admin/config/regional/language?render=overlay','default','Associated @label via the @label\'s @property.','','7.34'),(1430,'/admin/config/regional/language?render=overlay','default','Revisions','','7.34'),(1431,'/admin/config/regional/language?render=overlay','default','(No information available)','','7.34'),(1432,'/admin/config/regional/language?render=overlay','default','Rendered @entity-type','','7.34'),(1433,'/admin/config/regional/language?render=overlay','default','The @entity-type of the current relationship rendered using a view mode.','','7.34'),(1434,'/admin/config/regional/language?render=overlay','default','Entity','','7.34'),(1435,'/admin/config/regional/language?render=overlay','default','Displays a single chosen entity.','','7.34'),(1436,'/admin/config/regional/language?render=overlay','default','@entity:@bundle','','7.34'),(1437,'/admin/config/regional/language?render=overlay','default','Appears in: @bundles.','','7.34'),(1438,'/admin/config/regional/language?render=overlay','default','@group: @field','','7.34'),(1439,'/admin/config/regional/language?render=overlay','default','@label (!name)','','7.34'),(1440,'/admin/config/regional/language?render=overlay','default','- No value -','','7.34'),(1441,'/admin/config/regional/language?render=overlay','default','@entity entity referenced from !field_name','','7.34'),(1442,'/admin/config/regional/language?render=overlay','default','Referenced Entity','','7.34'),(1443,'/admin/config/regional/language?render=overlay','default','A bridge to the @entity entity that is referenced via !field_name','','7.34'),(1444,'/admin/config/regional/language?render=overlay','default','@label (!name:!column)','','7.34'),(1445,'/admin/config/regional/language?render=overlay','default','@label:!column','','7.34'),(1446,'/admin/config/regional/language?render=overlay','default','Referenced products','','7.34'),(1447,'/admin/config/regional/language?render=overlay','default','Products referenced by !field_name','','7.34'),(1448,'/admin/config/regional/language?render=overlay','default','Relate this entity to products referenced by its !field_name value.','','7.34'),(1449,'/admin/config/regional/language?render=overlay','default','@group (historical data)','','7.34'),(1450,'/admin/config/regional/language?render=overlay','default','@group (historical data): @field','','7.34'),(1451,'/admin/config/regional/language?render=overlay','default','@label (!name:delta)','','7.34'),(1452,'/admin/config/regional/language?render=overlay','default','@label:delta','','7.34'),(1453,'/admin/config/regional/language?render=overlay','default','Delta - Appears in: @bundles.','','7.34'),(1454,'/admin/config/regional/language?render=overlay','default','term from !field_name','','7.34'),(1455,'/admin/config/regional/language?render=overlay','default','Field','','7.34'),(1456,'/admin/config/regional/language?render=overlay','default','This is an alias of @group: @field.','','7.34'),(1457,'/admin/config/regional/language?render=overlay','default','Also known as: !also.','','7.34'),(1458,'/admin/config/regional/language?render=overlay','default','image from !field_name','','7.34'),(1459,'/admin/config/regional/language?render=overlay','default','field collection item from !field_name','','7.34'),(1460,'/admin/config/regional/language?render=overlay','default','field collection item revision from !field_name','','7.34'),(1461,'/admin/config/regional/language?render=overlay','default','Entity with the @field (@field_name)','','7.34'),(1462,'/admin/config/regional/language?render=overlay','default','Relate each @entity using @field.','','7.34'),(1463,'/admin/config/regional/language?render=overlay','default','!field_name','','7.34'),(1464,'/admin/config/regional/language?render=overlay','default','@label (!name:language)','','7.34'),(1465,'/admin/config/regional/language?render=overlay','default','@label:language','','7.34'),(1466,'/admin/config/regional/language?render=overlay','default','Language - Appears in: @bundles.','','7.34'),(1467,'/admin/config/regional/language?render=overlay','default','<No value>','','7.34'),(1468,'/admin/config/regional/language?render=overlay','default','@field-label - @property-label','','7.34'),(1469,'/admin/config/regional/language?render=overlay','default','Referenced line items','','7.34'),(1470,'/admin/config/regional/language?render=overlay','default','Line items referenced by !field_name','','7.34'),(1471,'/admin/config/regional/language?render=overlay','default','Relate this entity to line items referenced by its !field_name value.','','7.34'),(1472,'/admin/config/regional/language?render=overlay','default','Referenced customer profile','','7.34'),(1473,'/admin/config/regional/language?render=overlay','default','Customer profile referenced by !field_name','','7.34'),(1474,'/admin/config/regional/language?render=overlay','default','Relate this entity to the customer profile referenced by its !field_name value.','','7.34'),(1475,'/admin/config/regional/language?render=overlay','default','Locale source','','7.34'),(1476,'/admin/config/regional/language?render=overlay','default','A source string for translation, in English or the default site language.','','7.34'),(1477,'/admin/config/regional/language?render=overlay','default','LID','','7.34'),(1478,'/admin/config/regional/language?render=overlay','default','The ID of the source string.','','7.34'),(1479,'/admin/config/regional/language?render=overlay','default','Location','','7.34'),(1480,'/admin/config/regional/language?render=overlay','default','A description of the location or context of the string.','','7.34'),(1481,'/admin/config/regional/language?render=overlay','default','Group','','7.34'),(1482,'/admin/config/regional/language?render=overlay','default','The group the translation is in.','','7.34'),(1483,'/admin/config/regional/language?render=overlay','default','Source','','7.34'),(1484,'/admin/config/regional/language?render=overlay','default','The full original string.','','7.34'),(1485,'/admin/config/regional/language?render=overlay','default','Version','','7.34'),(1486,'/admin/config/regional/language?render=overlay','default','The version of Drupal core that this string is for.','','7.34'),(1487,'/admin/config/regional/language?render=overlay','default','Provide a simple link to edit the translations.','','7.34'),(1488,'/admin/config/regional/language?render=overlay','default','Locale target','','7.34'),(1489,'/admin/config/regional/language?render=overlay','default','Translation','','7.34'),(1490,'/admin/config/regional/language?render=overlay','default','The full translation string.','','7.34'),(1491,'/admin/config/regional/language?render=overlay','default','The language this translation is in.','','7.34'),(1492,'/admin/config/regional/language?render=overlay','default','Singular LID','','7.34'),(1493,'/admin/config/regional/language?render=overlay','default','The ID of the parent translation.','','7.34'),(1494,'/admin/config/regional/language?render=overlay','default','Plural','','7.34'),(1495,'/admin/config/regional/language?render=overlay','default','Whether or not the translation is plural.','','7.34'),(1496,'/admin/config/regional/language?render=overlay','default','The node ID.','','7.34'),(1497,'/admin/config/regional/language?render=overlay','default','The content title.','','7.34'),(1498,'/admin/config/regional/language?render=overlay','default','The date the content was posted.','','7.34'),(1499,'/admin/config/regional/language?render=overlay','default','The date the content was last updated.','','7.34'),(1500,'/admin/config/regional/language?render=overlay','default','The content type (for example, \"blog entry\", \"forum post\", \"story\", etc).','','7.34'),(1501,'/admin/config/regional/language?render=overlay','default','Published','','7.34'),(1502,'/admin/config/regional/language?render=overlay','default','Whether or not the content is published.','','7.34'),(1503,'/admin/config/regional/language?render=overlay; modules/node/node.js; modules/node/content_types.js','default','Not published','','7.34'),(1504,'/admin/config/regional/language?render=overlay','default','Published or admin','','7.34'),(1505,'/admin/config/regional/language?render=overlay','default','Filters out unpublished content if the current user cannot view it.','','7.34'),(1506,'/admin/config/regional/language?render=overlay','default','Promoted to front page','','7.34'),(1507,'/admin/config/regional/language?render=overlay','default','Whether or not the content is promoted to the front page.','','7.34'),(1508,'/admin/config/regional/language?render=overlay','default','Promoted','','7.34'),(1509,'/admin/config/regional/language?render=overlay','default','Not promoted','','7.34'),(1510,'/admin/config/regional/language?render=overlay','default','Sticky','','7.34'),(1511,'/admin/config/regional/language?render=overlay','default','Whether or not the content is sticky.','','7.34'),(1512,'/admin/config/regional/language?render=overlay','default','Not sticky','','7.34'),(1513,'/admin/config/regional/language?render=overlay','default','Whether or not the content is sticky. To list sticky content first, set this to descending.','','7.34'),(1514,'/admin/config/regional/language?render=overlay','default','Provide a simple link to the content.','','7.34'),(1515,'/admin/config/regional/language?render=overlay','default','Provide a simple link to edit the content.','','7.34'),(1516,'/admin/config/regional/language?render=overlay','default','Provide a simple link to delete the content.','','7.34'),(1517,'/admin/config/regional/language?render=overlay','default','The aliased path to this content.','','7.34'),(1518,'/admin/config/regional/language?render=overlay','default','The user authoring the content. If you need more fields than the uid add the content: author relationship','','7.34'),(1519,'/admin/config/regional/language?render=overlay','default','Relate content to the user who created it.','','7.34'),(1520,'/admin/config/regional/language?render=overlay','default','User has a revision','','7.34'),(1521,'/admin/config/regional/language?render=overlay','default','All nodes where a certain user has a revision','','7.34'),(1522,'/admin/config/regional/language?render=overlay','default','Content revision','','7.34'),(1523,'/admin/config/regional/language?render=overlay','default','Content revision is a history of changes to content.','','7.34'),(1524,'/admin/config/regional/language?render=overlay','default','Relate a content revision to the user who created the revision.','','7.34'),(1525,'/admin/config/regional/language?render=overlay','default','revision user','','7.34'),(1526,'/admin/config/regional/language?render=overlay','default','The revision NID of the content revision.','','7.34'),(1527,'/admin/config/regional/language?render=overlay','default','Get the actual content from a content revision.','','7.34'),(1528,'/admin/config/regional/language?render=overlay','default','Vid','','7.34'),(1529,'/admin/config/regional/language?render=overlay','default','The revision ID of the content revision.','','7.34'),(1530,'/admin/config/regional/language?render=overlay','default','The date the node was last updated.','','7.34'),(1531,'/admin/config/regional/language?render=overlay','default','Provide a simple link to the revision.','','7.34'),(1532,'/admin/config/regional/language?render=overlay','default','Revert link','','7.34'),(1533,'/admin/config/regional/language?render=overlay','default','Provide a simple link to revert to the revision.','','7.34'),(1534,'/admin/config/regional/language?render=overlay','default','Provide a simple link to delete the content revision.','','7.34'),(1535,'/admin/config/regional/language?render=overlay','default','Content access','','7.34'),(1536,'/admin/config/regional/language?render=overlay','default','Access','','7.34'),(1537,'/admin/config/regional/language?render=overlay','default','Filter by access.','','7.34'),(1538,'/admin/config/regional/language?render=overlay','default','Filter for content by view access. <strong>Not necessary if you are using node as your base table.</strong>','','7.34'),(1539,'/admin/config/regional/language?render=overlay','default','Has new content','','7.34'),(1540,'/admin/config/regional/language?render=overlay','default','Show a marker if the content is new or updated.','','7.34'),(1541,'/admin/config/regional/language?render=overlay','default','Show only content that is new or updated.','','7.34'),(1542,'/admin/config/regional/language?render=overlay','default','Recently Read','','7.34'),(1543,'/admin/config/regional/language?render=overlay','default','Recently read Session api sid','','7.34'),(1544,'/admin/config/regional/language?render=overlay','default','Label for sid','','7.34'),(1545,'/admin/config/regional/language?render=overlay','default','Session api','','7.34'),(1546,'/admin/config/regional/language?render=overlay','default','Relationship to session api','','7.34'),(1547,'/admin/config/regional/language?render=overlay','default','entity type','','7.34'),(1548,'/admin/config/regional/language?render=overlay','default','Entity Type','','7.34'),(1549,'/admin/config/regional/language?render=overlay','default','Recently Read Entity Id','','7.34'),(1550,'/admin/config/regional/language?render=overlay','default','Current','','7.34'),(1551,'/admin/config/regional/language?render=overlay','default','Filter the view to the current user.','','7.34'),(1552,'/admin/config/regional/language?render=overlay','default','Recently Read Date','','7.34'),(1553,'/admin/config/regional/language?render=overlay','default','Recently Read Time','','7.34'),(1554,'/admin/config/regional/language?render=overlay','default','Search','','7.34'),(1555,'/admin/config/regional/language?render=overlay','default','Score','','7.34'),(1556,'/admin/config/regional/language?render=overlay','default','The score of the search item. This will not be used if the search filter is not also present.','','7.34'),(1557,'/admin/config/regional/language?render=overlay','default','Links from','','7.34'),(1558,'/admin/config/regional/language?render=overlay','default','Other nodes that are linked from the node.','','7.34'),(1559,'/admin/config/regional/language?render=overlay','default','Links to','','7.34'),(1560,'/admin/config/regional/language?render=overlay','default','Other nodes that link to the node.','','7.34'),(1561,'/admin/config/regional/language?render=overlay','default','Search Terms','','7.34'),(1562,'/admin/config/regional/language?render=overlay','default','The terms to search for.','','7.34'),(1563,'/admin/config/regional/language?render=overlay','default','Indexed @entity_type','','7.34'),(1564,'/admin/config/regional/language?render=overlay','default','Use the %name search index for filtering and retrieving data.','','7.34'),(1565,'/admin/config/regional/language?render=overlay','default','Item language','','7.34'),(1566,'/admin/config/regional/language?render=overlay','default','A field added by the search framework to let components determine an item\'s language. Is always indexed.','','7.34'),(1567,'/admin/config/regional/language?render=overlay','default','Product Display filter','','7.34'),(1568,'/admin/config/regional/language?render=overlay','default','Exclude nodes that aren\'t product displays.','','7.34'),(1569,'/admin/config/regional/language?render=overlay','default','Exclude unpublished products','','7.34'),(1570,'/admin/config/regional/language?render=overlay','default','Exclude unpublished products.','','7.34'),(1571,'/admin/config/regional/language?render=overlay','default','Bundle filter','','7.34'),(1572,'/admin/config/regional/language?render=overlay','default','Exclude items from indexing based on their bundle (content type, vocabulary, …).','','7.34'),(1573,'/admin/config/regional/language?render=overlay','default','Role filter','','7.34'),(1574,'/admin/config/regional/language?render=overlay','default','Exclude users from indexing based on their role.','','7.34'),(1575,'/admin/config/regional/language?render=overlay','default','URL field','','7.34'),(1576,'/admin/config/regional/language?render=overlay','default','Adds the item\'s URL to the indexed data.','','7.34'),(1577,'/admin/config/regional/language?render=overlay','default','Aggregated fields','','7.34'),(1578,'/admin/config/regional/language?render=overlay','default','Gives you the ability to define additional fields, containing data from one or more other fields.','','7.34'),(1579,'/admin/config/regional/language?render=overlay','default','Complete entity view','','7.34'),(1580,'/admin/config/regional/language?render=overlay','default','Adds an additional field containing the whole HTML content of the entity when viewed.','','7.34'),(1581,'/admin/config/regional/language?render=overlay','default','Index hierarchy','','7.34'),(1582,'/admin/config/regional/language?render=overlay','default','Allows to index hierarchical fields along with all their ancestors.','','7.34'),(1583,'/admin/config/regional/language?render=overlay','default','Language control','','7.34'),(1584,'/admin/config/regional/language?render=overlay','default','Lets you determine the language of items in the index.','','7.34'),(1585,'/admin/config/regional/language?render=overlay','default','Node access','','7.34'),(1586,'/admin/config/regional/language?render=overlay','default','Add node access information to the index. <strong>Caution:</strong> This only affects the indexed nodes themselves, not any node reference fields that are indexed with them, or displayed in search results.','','7.34'),(1587,'/admin/config/regional/language?render=overlay','default','Access check','','7.34'),(1588,'/admin/config/regional/language?render=overlay','default','Exclude unpublished nodes','','7.34'),(1589,'/admin/config/regional/language?render=overlay','default','Exclude unpublished nodes from the index. <strong>Caution:</strong> This only affects the indexed nodes themselves. If an enabled node has references to disabled nodes, those will still be indexed (or displayed) normally.','','7.34'),(1590,'/admin/config/regional/language?render=overlay','default','Search API ranges','','7.34'),(1591,'/admin/config/regional/language?render=overlay','default','Adds the minimum and maximum values of selected numeric fields.','','7.34'),(1592,'/admin/config/regional/language?render=overlay','default','!field (indexed)','','7.34'),(1593,'/admin/config/regional/language?render=overlay','default','Entity ID','','7.34'),(1594,'/admin/config/regional/language?render=overlay','default','The entity\'s ID.','','7.34'),(1595,'/admin/config/regional/language?render=overlay','default','Relevance','','7.34'),(1596,'/admin/config/regional/language?render=overlay','default','The relevance of this search result with respect to the query.','','7.34'),(1597,'/admin/config/regional/language?render=overlay','default','Excerpt','','7.34'),(1598,'/admin/config/regional/language?render=overlay','default','The search result excerpted to show found search terms.','','7.34'),(1599,'/admin/config/regional/language?render=overlay','default','Fulltext search','','7.34'),(1600,'/admin/config/regional/language?render=overlay','default','Search several or all fulltext fields at once.','','7.34'),(1601,'/admin/config/regional/language?render=overlay','default','More like this','','7.34'),(1602,'/admin/config/regional/language?render=overlay','default','Find similar content.','','7.34'),(1603,'/admin/config/regional/language?render=overlay','default','Indexed taxonomy term fields','','7.34'),(1604,'/admin/config/regional/language?render=overlay','default','Search in all indexed taxonomy term fields.','','7.34'),(1605,'/admin/config/regional/language?render=overlay','default','Node access information','','7.34'),(1606,'/admin/config/regional/language?render=overlay','default','Data needed to apply node access.','','7.34'),(1607,'/admin/config/regional/language?render=overlay','default','Simplenews mailspool','','7.34'),(1608,'/admin/config/regional/language?render=overlay','default','Spool for temporary storage of newsletter emails.','','7.34'),(1609,'/admin/config/regional/language?render=overlay','default','Simplenews spool','','7.34'),(1610,'/admin/config/regional/language?render=overlay','default','Ms ID','','7.34'),(1611,'/admin/config/regional/language?render=overlay','default','The primary identifier for a mail spool record.','','7.34'),(1612,'/admin/config/regional/language?render=overlay','default','Subscriber','','7.34'),(1613,'/admin/config/regional/language?render=overlay','default','The formatted email address of mail message receipient.','','7.34'),(1614,'/admin/config/regional/language?render=overlay','default','The {node}.nid of this newsletter.','','7.34'),(1615,'/admin/config/regional/language?render=overlay','default','The {term_data}.tid this newsletter issue belongs to.','','7.34'),(1616,'/admin/config/regional/language?render=overlay','default','Issue','','7.34'),(1617,'/admin/config/regional/language?render=overlay','default','Subscriber ID','','7.34'),(1618,'/admin/config/regional/language?render=overlay','default','The {simplenews_subscriber}.snid foreign key for this spool','','7.34'),(1619,'/admin/config/regional/language?render=overlay','default','Sent status','','7.34'),(1620,'/admin/config/regional/language?render=overlay','default','The sent status of the email (0 = hold, 1 = pending, 2 = done).','','7.34'),(1621,'/admin/config/regional/language?render=overlay','default','Error','','7.34'),(1622,'/admin/config/regional/language?render=overlay','default','A boolean indicating whether an error occured while sending the email.','','7.34'),(1623,'/admin/config/regional/language?render=overlay','default','The time status was set or changed.','','7.34'),(1624,'/admin/config/regional/language?render=overlay','default','A serialized array of name value pairs that are related to the email address.','','7.34'),(1625,'/admin/config/regional/language?render=overlay','default','Simplenews issue','','7.34'),(1626,'/admin/config/regional/language?render=overlay','default','The {term_data}.tid (= newsletter series) this issue belongs to.','','7.34'),(1627,'/admin/config/regional/language?render=overlay','default','Newsletter sent status: 0: Not sent, 1: Pending (being sent or waiting for cron to run), 2: Sent.','','7.34'),(1628,'/admin/config/regional/language?render=overlay','default','Subscriber count','','7.34'),(1629,'/admin/config/regional/language?render=overlay','default','The count of subscribers of the newsletter at the time it was sent.','','7.34'),(1630,'/admin/config/regional/language?render=overlay','default','Send newsletter','','7.34'),(1631,'/admin/config/regional/language?render=overlay','default','Provides a link to send the simplenews newsletter if not sent yet.','','7.34'),(1632,'/admin/config/regional/language?render=overlay','default','Simplenews subscriber','','7.34'),(1633,'/admin/config/regional/language?render=overlay','default','Contains subscribers of Simplenews Newsletters.','','7.34'),(1634,'/admin/config/regional/language?render=overlay','default','Primary key: Unique subsciber ID.','','7.34'),(1635,'/admin/config/regional/language?render=overlay','default','Activated','','7.34'),(1636,'/admin/config/regional/language?render=overlay','default','Boolean indicating the status of the subscription.','','7.34'),(1637,'/admin/config/regional/language?render=overlay','default','The subscription email address.','','7.34'),(1638,'/admin/config/regional/language?render=overlay','default','The {users}.uid that has the same email address.','','7.34'),(1639,'/admin/config/regional/language?render=overlay','default','Anonymous subscriber preferred language. Empty for authenticated users.','','7.34'),(1640,'/admin/config/regional/language?render=overlay','default','UNIX timestamp of when the user first subscribed to a newsletter.','','7.34'),(1641,'/admin/config/regional/language?render=overlay','default','Simplenews subscription','','7.34'),(1642,'/admin/config/regional/language?render=overlay','default','Contains all Subscriptions of every Simplenews Newsletters.','','7.34'),(1643,'/admin/config/regional/language?render=overlay','default','The {simplenews_subscriptions}.snid who is subscribed.','','7.34'),(1644,'/admin/config/regional/language?render=overlay','default','The newsletter series ({term_data}.tid) the subscriber is subscribed to.','','7.34'),(1645,'/admin/config/regional/language?render=overlay','default','Term (Newsletter series)','','7.34'),(1646,'/admin/config/regional/language?render=overlay','default','A flag indicating whether the user is subscribed (1) or unsubscribed (0).','','7.34'),(1647,'/admin/config/regional/language?render=overlay','default','UNIX timestamp of when the user is (un)subscribed.','','7.34'),(1648,'/admin/config/regional/language?render=overlay','default','The source via which the user is (un)subscribed.','','7.34'),(1649,'/admin/config/regional/language?render=overlay','default','Simplenews category','','7.34'),(1650,'/admin/config/regional/language?render=overlay','default','Format','','7.34'),(1651,'/admin/config/regional/language?render=overlay','default','Format of the newsletter (plain or html).','','7.34'),(1652,'/admin/config/regional/language?render=overlay','default','Priority','','7.34'),(1653,'/admin/config/regional/language?render=overlay','default','Email priority according to RFC 2156 and RFC 5231 (0 = none; 1 = highest; 2 = high; 3 = normal; 4 = low; 5 = lowest).','','7.34'),(1654,'/admin/config/regional/language?render=overlay','default','Receipt','','7.34'),(1655,'/admin/config/regional/language?render=overlay','default','Boolean indicating request for email receipt confirmation according to RFC 2822.','','7.34'),(1656,'/admin/config/regional/language?render=overlay','default','From name','','7.34'),(1657,'/admin/config/regional/language?render=overlay','default','Sender name for newsletter emails.','','7.34'),(1658,'/admin/config/regional/language?render=overlay','default','Email Subject','','7.34'),(1659,'/admin/config/regional/language?render=overlay','default','Subject of newsletter email. May contain tokens.','','7.34'),(1660,'/admin/config/regional/language?render=overlay','default','From address','','7.34'),(1661,'/admin/config/regional/language?render=overlay','default','Sender address for newsletter emails','','7.34'),(1662,'/admin/config/regional/language?render=overlay','default','Hyperlinks displaymode','','7.34'),(1663,'/admin/config/regional/language?render=overlay','default','Flag indicating type of hyperlink conversion (1 = hyperlinks are in-line; 0 = hyperlinks are placed at email bottom).','','7.34'),(1664,'/admin/config/regional/language?render=overlay','default','New account','','7.34'),(1665,'/admin/config/regional/language?render=overlay','default','How to treat subscription at account creation (none = None; on = Default on; off = Default off; silent = Invisible subscription).','','7.34'),(1666,'/admin/config/regional/language?render=overlay','default','Confirmation displaymode','','7.34'),(1667,'/admin/config/regional/language?render=overlay','default','How to treat subscription confirmation (hidden = Newsletter is hidden from the user; single = Single opt-in; double = Double opt-in).','','7.34'),(1668,'/admin/config/regional/language?render=overlay','default','Block','','7.34'),(1669,'/admin/config/regional/language?render=overlay','default','Indicates wether a subscription block is available for this category','','7.34'),(1670,'/admin/config/regional/language?render=overlay','default','Files maintained by Drupal and various modules.','','7.34'),(1671,'/admin/config/regional/language?render=overlay','default','The ID of the file.','','7.34'),(1672,'/admin/config/regional/language?render=overlay','default','The name of the file.','','7.34'),(1673,'/admin/config/regional/language?render=overlay','default','The path of the file.','','7.34'),(1674,'/admin/config/regional/language?render=overlay','default','Mime type','','7.34'),(1675,'/admin/config/regional/language?render=overlay','default','The mime type of the file.','','7.34'),(1676,'/admin/config/regional/language?render=overlay','default','Extension','','7.34'),(1677,'/admin/config/regional/language?render=overlay','default','The extension of the file.','','7.34'),(1678,'/admin/config/regional/language?render=overlay','default','Size','','7.34'),(1679,'/admin/config/regional/language?render=overlay','default','The size of the file.','','7.34'),(1680,'/admin/config/regional/language?render=overlay','default','The status of the file.','','7.34'),(1681,'/admin/config/regional/language?render=overlay','default','Upload date','','7.34'),(1682,'/admin/config/regional/language?render=overlay','default','The date the file was uploaded.','','7.34'),(1683,'/admin/config/regional/language?render=overlay','default','User who uploaded','','7.34'),(1684,'/admin/config/regional/language?render=overlay','default','The user that uploaded the file.','','7.34'),(1685,'/admin/config/regional/language?render=overlay','default','File Usage','','7.34'),(1686,'/admin/config/regional/language?render=overlay','default','Content that is associated with this file, usually because this file is in a field on the content.','','7.34'),(1687,'/admin/config/regional/language?render=overlay','default','A file that is associated with this node, usually because it is in a field on the node.','','7.34'),(1688,'/admin/config/regional/language?render=overlay','default','A user that is associated with this file, usually because this file is in a field on the user.','','7.34'),(1689,'/admin/config/regional/language?render=overlay','default','A file that is associated with this user, usually because it is in a field on the user.','','7.34'),(1690,'/admin/config/regional/language?render=overlay','default','A comment that is associated with this file, usually because this file is in a field on the comment.','','7.34'),(1691,'/admin/config/regional/language?render=overlay','default','A file that is associated with this comment, usually because it is in a field on the comment.','','7.34'),(1692,'/admin/config/regional/language?render=overlay','default','Taxonomy Term','','7.34'),(1693,'/admin/config/regional/language?render=overlay','default','A taxonomy term that is associated with this file, usually because this file is in a field on the taxonomy term.','','7.34'),(1694,'/admin/config/regional/language?render=overlay','default','A file that is associated with this taxonomy term, usually because it is in a field on the taxonomy term.','','7.34'),(1695,'/admin/config/regional/language?render=overlay','default','Taxonomy Vocabulary','','7.34'),(1696,'/admin/config/regional/language?render=overlay','default','A taxonomy vocabulary that is associated with this file, usually because this file is in a field on the taxonomy vocabulary.','','7.34'),(1697,'/admin/config/regional/language?render=overlay','default','A file that is associated with this taxonomy vocabulary, usually because it is in a field on the taxonomy vocabulary.','','7.34'),(1698,'/admin/config/regional/language?render=overlay','default','The module managing this file relationship.','','7.34'),(1699,'/admin/config/regional/language?render=overlay','default','Entity type','','7.34'),(1700,'/admin/config/regional/language?render=overlay','default','The type of entity that is related to the file.','','7.34'),(1701,'/admin/config/regional/language?render=overlay','default','The ID of the entity that is related to the file.','','7.34'),(1702,'/admin/config/regional/language?render=overlay','default','Use count','','7.34'),(1703,'/admin/config/regional/language?render=overlay','default','The number of times the file is used by this entity.','','7.34'),(1704,'/admin/config/regional/language?render=overlay','default','Module/Theme/Theme engine','','7.34'),(1705,'/admin/config/regional/language?render=overlay','default','Modules/Themes/Theme engines in your codebase.','','7.34'),(1706,'/admin/config/regional/language?render=overlay','default','Module/Theme/Theme engine filename','','7.34'),(1707,'/admin/config/regional/language?render=overlay','default','The path of the primary file for this item, relative to the Drupal root; e.g. modules/node/node.module.','','7.34'),(1708,'/admin/config/regional/language?render=overlay','default','Module/Theme/Theme engine name','','7.34'),(1709,'/admin/config/regional/language?render=overlay','default','The name of the item; e.g. node.','','7.34'),(1710,'/admin/config/regional/language?render=overlay','default','The type of the item, either module, theme, or theme_engine.','','7.34'),(1711,'/admin/config/regional/language?render=overlay','default','Boolean indicating whether or not this item is enabled.','','7.34'),(1712,'/admin/config/regional/language?render=overlay','default','Schema version','','7.34'),(1713,'/admin/config/regional/language?render=overlay','default','The module\'s database schema version number. -1 if the module is not installed (its tables do not exist); 0 or the largest N of the module\'s hook_update_N() function that has either been run or existed when the module was first installed.','','7.34'),(1714,'/admin/config/regional/language?render=overlay','default','Name of the vocabulary a term is a member of. This will be the vocabulary that whichever term the \"Taxonomy: Term\" field is; and can similarly cause duplicates.','','7.34'),(1715,'/admin/config/regional/language?render=overlay','default','The taxonomy vocabulary name','','7.34'),(1716,'/admin/config/regional/language?render=overlay','default','Machine-Name of the vocabulary a term is a member of. This will be the vocabulary that whichever term the \"Taxonomy: Term\" field is; and can similarly cause duplicates.','','7.34'),(1717,'/admin/config/regional/language?render=overlay','default','Filter the results of \"Taxonomy: Term\" to a particular vocabulary.','','7.34'),(1718,'/admin/config/regional/language?render=overlay','default','The taxonomy vocabulary ID','','7.34'),(1719,'/admin/config/regional/language?render=overlay','default','The taxonomy vocabulary description','','7.34'),(1720,'/admin/config/regional/language?render=overlay','default','The taxonomy vocabulary weight','','7.34'),(1721,'/admin/config/regional/language?render=overlay','default','Taxonomy terms are attached to nodes.','','7.34'),(1722,'/admin/config/regional/language?render=overlay','default','The tid of a taxonomy term.','','7.34'),(1723,'/admin/config/regional/language?render=overlay','default','Taxonomy term chosen from autocomplete or select widget.','','7.34'),(1724,'/admin/config/regional/language?render=overlay','default','Representative node','','7.34'),(1725,'/admin/config/regional/language?render=overlay','default','Obtains a single representative node for each term, according to a chosen sort criterion.','','7.34'),(1726,'/admin/config/regional/language?render=overlay','default','The taxonomy term name.','','7.34'),(1727,'/admin/config/regional/language?render=overlay','default','Taxonomy term name.','','7.34'),(1728,'/admin/config/regional/language?render=overlay','default','Uncategorized','','7.34'),(1729,'/admin/config/regional/language?render=overlay','default','The term weight field','','7.34'),(1730,'/admin/config/regional/language?render=overlay','default','Term description','','7.34'),(1731,'/admin/config/regional/language?render=overlay','default','The description associated with a taxonomy term.','','7.34'),(1732,'/admin/config/regional/language?render=overlay','default','Term edit link','','7.34'),(1733,'/admin/config/regional/language?render=overlay','default','Provide a simple link to edit the term.','','7.34'),(1734,'/admin/config/regional/language?render=overlay','default','Content with term','','7.34'),(1735,'/admin/config/regional/language?render=overlay','default','Relate all content tagged with a term.','','7.34'),(1736,'/admin/config/regional/language?render=overlay','default','Has taxonomy term ID','','7.34'),(1737,'/admin/config/regional/language?render=overlay','default','Display content if it has the selected taxonomy terms.','','7.34'),(1738,'/admin/config/regional/language?render=overlay','default','Has taxonomy term','','7.34'),(1739,'/admin/config/regional/language?render=overlay','default','Parent term','','7.34'),(1740,'/admin/config/regional/language?render=overlay','default','The parent term of the term. This can produce duplicate entries if you are using a vocabulary that allows multiple parents.','','7.34'),(1741,'/admin/config/regional/language?render=overlay','default','Filter the results of \"Taxonomy: Term\" by the parent pid.','','7.34'),(1742,'/admin/config/regional/language?render=overlay','default','The parent term of the term.','','7.34'),(1743,'/admin/config/regional/language?render=overlay','default','The user ID','','7.34'),(1744,'/admin/config/regional/language?render=overlay','default','Content authored','','7.34'),(1745,'/admin/config/regional/language?render=overlay','default','Relate content to the user who created it. This relationship will create one record for each content item created by the user.','','7.34'),(1746,'/admin/config/regional/language?render=overlay','default','nodes','','7.34'),(1747,'/admin/config/regional/language?render=overlay','default','The raw numeric user ID.','','7.34'),(1748,'/admin/config/regional/language?render=overlay','default','Obtains a single representative node for each user, according to a chosen sort criterion.','','7.34'),(1749,'/admin/config/regional/language?render=overlay','default','Filter the view to the currently logged in user.','','7.34'),(1750,'/admin/config/regional/language?render=overlay','default','The user or author name.','','7.34'),(1751,'/admin/config/regional/language?render=overlay','default','Name (raw)','','7.34'),(1752,'/admin/config/regional/language?render=overlay','default','The user or author name. This filter does not check if the user exists and allows partial matching. Does not utilize autocomplete.','','7.34'),(1753,'/admin/config/regional/language?render=overlay','default','Email address for a given user. This field is normally not shown to users, so be cautious when using it.','','7.34'),(1754,'/admin/config/regional/language?render=overlay','default','Language of the user','','7.34'),(1755,'/admin/config/regional/language?render=overlay','default','Picture','','7.34'),(1756,'/admin/config/regional/language?render=overlay','default','The user\'s picture, if allowed.','','7.34'),(1757,'/admin/config/regional/language?render=overlay','default','Has Avatar','','7.34'),(1758,'/admin/config/regional/language?render=overlay','default','Provide a simple link to the user.','','7.34'),(1759,'/admin/config/regional/language?render=overlay','default','The date the user was created.','','7.34'),(1760,'/admin/config/regional/language?render=overlay','default','The user\'s last access date.','','7.34'),(1761,'/admin/config/regional/language?render=overlay','default','The user\'s last login date.','','7.34'),(1762,'/admin/config/regional/language?render=overlay','default','Whether a user is active or blocked.','','7.34'),(1763,'/admin/config/regional/language?render=overlay','default','Blocked','','7.34'),(1764,'/admin/config/regional/language?render=overlay','default','Signature','','7.34'),(1765,'/admin/config/regional/language?render=overlay','default','The user\'s signature.','','7.34'),(1766,'/admin/config/regional/language?render=overlay','default','Provide a simple link to edit the user.','','7.34'),(1767,'/admin/config/regional/language?render=overlay','default','Cancel link','','7.34'),(1768,'/admin/config/regional/language?render=overlay','default','Provide a simple link to cancel the user.','','7.34'),(1769,'/admin/config/regional/language?render=overlay','default','Provide serialized data of the user','','7.34'),(1770,'/admin/config/regional/language?render=overlay','default','Roles that a user belongs to.','','7.34'),(1771,'/admin/config/regional/language?render=overlay','default','No role','','7.34'),(1772,'/admin/config/regional/language?render=overlay','default','Permission','','7.34'),(1773,'/admin/config/regional/language?render=overlay','default','The user permissions.','','7.34'),(1774,'/admin/config/regional/language?render=overlay','default','Authmap ID','','7.34'),(1775,'/admin/config/regional/language?render=overlay','default','The Authmap ID.','','7.34'),(1776,'/admin/config/regional/language?render=overlay','default','Authentication name','','7.34'),(1777,'/admin/config/regional/language?render=overlay','default','The unique authentication name.','','7.34'),(1778,'/admin/config/regional/language?render=overlay','default','Authentication module','','7.34'),(1779,'/admin/config/regional/language?render=overlay','default','The name of the module managing the authentication entry.','','7.34'),(1780,'/admin/config/regional/language?render=overlay','default','Fieldset','','7.34'),(1781,'/admin/config/regional/language?render=overlay','default','Adds a fieldset to put fields and other fieldsets in.','','7.34'),(1782,'/admin/config/regional/language?render=overlay','default','Votes','','7.34'),(1783,'/admin/config/regional/language?render=overlay','default','Vote results','','7.34'),(1784,'/admin/config/regional/language?render=overlay','default','The value of an individual cast vote.','','7.34'),(1785,'/admin/config/regional/language?render=overlay','default','Value type','','7.34'),(1786,'/admin/config/regional/language?render=overlay','default','The nature of the vote being cast (points, percentage, etc).','','7.34'),(1787,'/admin/config/regional/language?render=overlay','default','Tag','','7.34'),(1788,'/admin/config/regional/language?render=overlay','default','An optional tag to group multi-criteria votes.','','7.34'),(1789,'/admin/config/regional/language?render=overlay','default','The user who cast the vote.','','7.34'),(1790,'/admin/config/regional/language?render=overlay','default','Individual voter','','7.34'),(1791,'/admin/config/regional/language?render=overlay','default','Current user','','7.34'),(1792,'/admin/config/regional/language?render=overlay','default','Restrict votes to those cast by the current user.','','7.34'),(1793,'/admin/config/regional/language?render=overlay','default','The IP address of the user who cast the vote.','','7.34'),(1794,'/admin/config/regional/language?render=overlay','default','The time the vote was cast.','','7.34'),(1795,'/admin/config/regional/language?render=overlay','default','The nature of the results in question (points, percentage, etc).','','7.34'),(1796,'/admin/config/regional/language?render=overlay','default','An optional tag to group multi-criteria results.','','7.34'),(1797,'/admin/config/regional/language?render=overlay','default','Function','','7.34'),(1798,'/admin/config/regional/language?render=overlay','default','The aggregate function used to calculate the result.','','7.34'),(1799,'/admin/config/regional/language?render=overlay','default','The time the results were calculated.','','7.34'),(1800,'/admin/config/regional/language?render=overlay','default','The weight of the node, formatted as a form element.','','7.34'),(1801,'/admin/config/regional/language?render=overlay','default','Weight value','','7.34'),(1802,'/admin/config/regional/language?render=overlay','default','The weight of the node.','','7.34'),(1803,'/admin/config/regional/language?render=overlay','default','Displays nodes that are Weight enabled','','7.34'),(1804,'/admin/config/regional/language?render=overlay','default','Global','','7.34'),(1805,'/admin/config/regional/language?render=overlay','default','Random','','7.34'),(1806,'/admin/config/regional/language?render=overlay','default','Randomize the display order.','','7.34'),(1807,'/admin/config/regional/language?render=overlay','default','Null','','7.34'),(1808,'/admin/config/regional/language?render=overlay','default','Allow a contextual filter value to be ignored. The query will not be altered by this contextual filter value. Can be used when contextual filter values come from the URL, and a part of the URL needs to be ignored.','','7.34'),(1809,'/admin/config/regional/language?render=overlay','default','Custom text','','7.34'),(1810,'/admin/config/regional/language?render=overlay','default','Provide custom text or link.','','7.34'),(1811,'/admin/config/regional/language?render=overlay','default','View result counter','','7.34'),(1812,'/admin/config/regional/language?render=overlay','default','Displays the actual position of the view result','','7.34'),(1813,'/admin/config/regional/language?render=overlay','default','Text area','','7.34'),(1814,'/admin/config/regional/language?render=overlay','default','Provide markup text for the area.','','7.34'),(1815,'/admin/config/regional/language?render=overlay','default','Unfiltered text','','7.34'),(1816,'/admin/config/regional/language?render=overlay','default','Add unrestricted, custom text or markup. This is similar to the custom text field.','','7.34'),(1817,'/admin/config/regional/language?render=overlay','default','View area','','7.34'),(1818,'/admin/config/regional/language?render=overlay','default','Insert a view inside an area.','','7.34'),(1819,'/admin/config/regional/language?render=overlay','default','Result summary','','7.34'),(1820,'/admin/config/regional/language?render=overlay','default','Shows result summary, for example the items per page.','','7.34'),(1821,'/admin/config/regional/language?render=overlay','default','Messages','','7.34'),(1822,'/admin/config/regional/language?render=overlay','default','Displays messages in the area.','','7.34'),(1823,'/admin/config/regional/language?render=overlay','default','Contextual Links','','7.34'),(1824,'/admin/config/regional/language?render=overlay','default','Display fields in a contextual links menu.','','7.34'),(1825,'/admin/config/regional/language?render=overlay','default','Combine fields filter','','7.34'),(1826,'/admin/config/regional/language?render=overlay','default','Combine two fields together and search by them.','','7.34'),(1827,'/admin/config/regional/language?render=overlay','default','Math expression','','7.34'),(1828,'/admin/config/regional/language?render=overlay','default','Evaluates a mathematical expression and displays it.','','7.34'),(1829,'/admin/config/regional/language?render=overlay','default','Fields comparison','','7.34'),(1830,'/admin/config/regional/language?render=overlay','default','Compare database fields against eachother.','','7.34'),(1831,'/admin/config/regional/language?render=overlay','default','Use fields comparison to filter the result of the view.','','7.34'),(1832,'/admin/config/regional/language?render=overlay','default','Webform submission','','7.34'),(1833,'/admin/config/regional/language?render=overlay','default','Webform submissions of the given Webform node.','','7.34'),(1834,'/admin/config/regional/language?render=overlay','default','Webform Submission','','7.34'),(1835,'/admin/config/regional/language?render=overlay','default','Webform submission count','','7.34'),(1836,'/admin/config/regional/language?render=overlay','default','The number of webform submissions on this node.','','7.34'),(1837,'/admin/config/regional/language?render=overlay','default','Webform submissions of the given user.','','7.34'),(1838,'/admin/config/regional/language?render=overlay','default','The number of webform submissions for this user.','','7.34'),(1839,'/admin/config/regional/language?render=overlay','default','Webform edit link','','7.34'),(1840,'/admin/config/regional/language?render=overlay','default','Provide a simple link to edit the webform components and configuration.','','7.34'),(1841,'/admin/config/regional/language?render=overlay','default','Webform results link','','7.34'),(1842,'/admin/config/regional/language?render=overlay','default','Provide a simple link to view the results of a webform.','','7.34'),(1843,'/admin/config/regional/language?render=overlay','default','Webform form body','','7.34'),(1844,'/admin/config/regional/language?render=overlay','default','The Webform form body display for this node.','','7.34'),(1845,'/admin/config/regional/language?render=overlay','default','New comments','','7.34'),(1846,'/admin/config/regional/language?render=overlay','default','The number of new comments on the node.','','7.34'),(1847,'/admin/config/regional/language?render=overlay','default','Add comment link','','7.34'),(1848,'/admin/config/regional/language?render=overlay','default','Display the standard add comment link used on regular nodes, which will only display if the viewing user has access to add a comment.','','7.34'),(1849,'/admin/config/regional/language?render=overlay','default','Comment status','','7.34'),(1850,'/admin/config/regional/language?render=overlay','default','Whether comments are enabled or disabled on the node.','','7.34'),(1851,'/admin/config/regional/language?render=overlay','default','User posted or commented','','7.34'),(1852,'/admin/config/regional/language?render=overlay','default','Display nodes only if a user posted the node or commented on the node.','','7.34'),(1853,'/admin/config/regional/language?render=overlay','default','Comments of the node','','7.34'),(1854,'/admin/config/regional/language?render=overlay','default','Relate all comments on the node. This will create 1 duplicate record for every comment. Usually if you need this it is better to create a comment view.','','7.34'),(1855,'/admin/config/regional/language?render=overlay','default','Display an Add to Cart form for the product.','','7.34'),(1856,'/admin/config/regional/language?render=overlay','default','Empty Shopping Cart','','7.34'),(1857,'/admin/config/regional/language?render=overlay','default','Displays an appropriate empty text message for shopping carts.','','7.34'),(1858,'/admin/config/regional/language?render=overlay','default','Order Balance','','7.34'),(1859,'/admin/config/regional/language?render=overlay','default','Total transaction payment balance for the order.','','7.34'),(1860,'/admin/config/regional/language?render=overlay','default','Payment Transaction','','7.34'),(1861,'/admin/config/regional/language?render=overlay','default','Relate this order to its payment transactions. This relationship will cause duplicated records if there are multiple transactions per order.','','7.34'),(1862,'/admin/config/regional/language?render=overlay','default','Transaction','a drupal commerce transaction','7.34'),(1863,'/admin/config/regional/language?render=overlay','default','Representative payment transaction','','7.34'),(1864,'/admin/config/regional/language?render=overlay','default','Obtains a single representative payment transaction for each order, according to a chosen sort criterion.','','7.34'),(1865,'/admin/config/regional/language?render=overlay','default','Product display','','7.34'),(1866,'/admin/config/regional/language?render=overlay','default','Whether or not the content functions as a product display.','','7.34'),(1867,'/admin/config/regional/language?render=overlay','default','Is a product display','','7.34'),(1868,'/admin/config/regional/language?render=overlay','default','Product display content type','','7.34'),(1869,'/admin/config/regional/language?render=overlay','default','Filters by the content type but only shows product display content types as options.','','7.34'),(1870,'/admin/config/regional/language?render=overlay','default','Line item is of a product line item type','','7.34'),(1871,'/admin/config/regional/language?render=overlay','default','Filter line items to those of a product line item type (including but not limited to the default Product line item type).','','7.34'),(1872,'/admin/config/regional/language?render=overlay','default','@entity_type referencing products from !field_name','','7.34'),(1873,'/admin/config/regional/language?render=overlay','default','Referencing @entity_type','','7.34'),(1874,'/admin/config/regional/language?render=overlay','default','Relate a product to the @entity_type referencing it through !field_name.','','7.34'),(1875,'/admin/config/regional/language?render=overlay','default','Provide a simple link to the %entity_label content.','','7.34'),(1876,'/admin/config/regional/language?render=overlay','default','Provide a simple link to edit the %entity_label content.','','7.34'),(1877,'/admin/config/regional/language?render=overlay','default','Provide a simple link to delete the %entity_label content.','','7.34'),(1878,'/admin/config/regional/language?render=overlay','default','@entity referencing @target_entity from !field_name','','7.34'),(1879,'/admin/config/regional/language?render=overlay','default','Referencing entity','','7.34'),(1880,'/admin/config/regional/language?render=overlay','default','A bridge to the @entity entity that is referencing @target_entity via !field_name','','7.34'),(1881,'/admin/config/regional/language?render=overlay','default','@entity using @field','','7.34'),(1882,'/admin/config/regional/language?render=overlay','default','Relate each @entity with a @field set to the term.','','7.34'),(1883,'/admin/config/regional/language?render=overlay','default','Relate each @entity with a @field set to the image.','','7.34'),(1884,'/admin/config/regional/language?render=overlay','default','The language the content is in.','','7.34'),(1885,'/admin/config/regional/language?render=overlay','default','Recently Read Relationship','','7.34'),(1886,'/admin/config/regional/language?render=overlay','default','Taxonomy terms on node','','7.34'),(1887,'/admin/config/regional/language?render=overlay','default','Relate nodes to taxonomy terms, specifiying which vocabulary or vocabularies to use. This relationship will cause duplicated records if there are multiple terms.','','7.34'),(1888,'/admin/config/regional/language?render=overlay','default','term','','7.34'),(1889,'/admin/config/regional/language?render=overlay','default','All taxonomy terms','','7.34'),(1890,'/admin/config/regional/language?render=overlay','default','Display all taxonomy terms associated with a node from specified vocabularies.','','7.34'),(1891,'/admin/config/regional/language?render=overlay','default','Display content if it has the selected taxonomy terms, or children of the selected terms. Due to additional complexity, this has fewer options than the versions without depth.','','7.34'),(1892,'/admin/config/regional/language?render=overlay','default','Has taxonomy term ID (with depth)','','7.34'),(1893,'/admin/config/regional/language?render=overlay','default','Has taxonomy terms (with depth)','','7.34'),(1894,'/admin/config/regional/language?render=overlay','default','Has taxonomy term ID depth modifier','','7.34'),(1895,'/admin/config/regional/language?render=overlay','default','Allows the \"depth\" for Taxonomy: Term ID (with depth) to be modified via an additional contextual filter value.','','7.34'),(1896,'/admin/config/regional/language?render=overlay','default','Embed a view as a field. This can cause slow performance, so enable some caching.','','7.34'),(1897,'/admin/config/regional/language?render=overlay','default','View (Views field view)','','7.34'),(1898,'/admin/config/regional/language?render=overlay','default','Embed a view in an area. This can cause slow performance, so enable some caching.','','7.34'),(1899,'/admin/config/regional/language?render=overlay','default','Embed a views_field_view field in an area. This can also accept argument tokens.','','7.34'),(1900,'/admin/config/regional/language?render=overlay','default','Break lock','','7.34'),(1901,'/admin/config/regional/language?render=overlay','default','Edit view','','7.34'),(1902,'/admin/config/regional/language?render=overlay','default','Disable text format','','7.34'),(1903,'/admin/config/regional/language?render=overlay','default','Home','','7.34'),(1904,'/admin/config/regional/language?render=overlay','default','Run cron','','7.34'),(1905,'/admin/config/regional/language?render=overlay','default','Run updates','','7.34'),(1906,'/admin/config/regional/language?render=overlay','default','@project issue queue','','7.34'),(1907,'/admin/config/regional/language?render=overlay','default','Flush all caches','','7.34'),(1908,'/admin/config/regional/language?render=overlay','default','CSS and JavaScript','','7.34'),(1909,'/admin/config/regional/language?render=overlay','default','Page and else','','7.34'),(1910,'/admin/config/regional/language?render=overlay','default','Menu','','7.34'),(1911,'/admin/config/regional/language?render=overlay','default','Class registry','','7.34'),(1912,'/admin/config/regional/language?render=overlay','default','Theme registry','','7.34'),(1913,'/admin/config/regional/language?render=overlay','default','Update data','','7.34'),(1914,'/admin/config/regional/language?render=overlay','default','Disable developer modules','','7.34'),(1915,'/admin/config/regional/language?render=overlay','default','Execute PHP Code','','7.34'),(1916,'/admin/config/regional/language?render=overlay','default','Execute some PHP code','','7.34'),(1917,'/admin/config/regional/language?render=overlay','default','Function reference','','7.34'),(1918,'/admin/config/regional/language?render=overlay','default','View a list of currently defined user functions with documentation links.','','7.34'),(1919,'/admin/config/regional/language?render=overlay','default','Hook_elements()','','7.34'),(1920,'/admin/config/regional/language?render=overlay','default','View the active form/render elements for this site.','','7.34'),(1921,'/admin/config/regional/language?render=overlay','default','PHPinfo()','','7.34'),(1922,'/admin/config/regional/language?render=overlay','default','View your server\'s PHP configuration','','7.34'),(1923,'/admin/config/regional/language?render=overlay','default','Reinstall modules','','7.34'),(1924,'/admin/config/regional/language?render=overlay','default','Run hook_uninstall() and then hook_install() for a given module.','','7.34'),(1925,'/admin/config/regional/language?render=overlay','default','Session viewer','','7.34'),(1926,'/admin/config/regional/language?render=overlay','default','List the contents of $_SESSION.','','7.34'),(1927,'/admin/config/regional/language?render=overlay','default','Variable editor','','7.34'),(1928,'/admin/config/regional/language?render=overlay','default','Edit and delete site variables.','','7.34'),(1929,'/admin/config/regional/language?render=overlay','default','Clear cache','','7.34'),(1930,'/admin/config/regional/language?render=overlay','default','Clear the CSS cache and all database cache tables which store page, node, theme and variable caches.','','7.34'),(1931,'/admin/config/regional/language?render=overlay','default','Entity info','','7.34'),(1932,'/admin/config/regional/language?render=overlay','default','View entity information across the whole site.','','7.34'),(1933,'/admin/config/regional/language?render=overlay','default','Field info','','7.34'),(1934,'/admin/config/regional/language?render=overlay','default','View fields information across the whole site.','','7.34'),(1935,'/admin/config/regional/language?render=overlay','default','Menu item','','7.34'),(1936,'/admin/config/regional/language?render=overlay','default','Details about a given menu item.','','7.34'),(1937,'/admin/config/regional/language?render=overlay','default','Rebuild menus','','7.34'),(1938,'/admin/config/regional/language?render=overlay','default','Rebuild menu based on hook_menu() and revert any custom changes. All menu items return to their default settings.','','7.34'),(1939,'/admin/config/regional/language?render=overlay','default','View a list of available theme functions across the whole site.','','7.34'),(1940,'/admin/config/regional/language?render=overlay','default','Log out','','7.34'),(1941,'/admin/config/regional/language?render=overlay','default','This user can switch back.','','7.34'),(1942,'/admin/config/regional/language?render=overlay','default','Caution: this user will be unable to switch back.','','7.34'),(1943,'/admin/config/regional/language?render=overlay','default','Add content','','7.34'),(1944,'/admin/config/regional/language?render=overlay','default','Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.','','7.34'),(1945,'/admin/config/regional/language?render=overlay','default','Use <em>basic pages</em> for your static content, such as an \'About us\' page.','','7.34'),(1946,'/admin/config/regional/language?render=overlay','default','A newsletter issue to be sent to subscribed email addresses.','','7.34'),(1947,'/admin/config/regional/language?render=overlay','default','Create a new form or questionnaire accessible to users. Submission results and statistics are recorded and accessible to privileged users.','','7.34'),(1948,'/admin/config/regional/language?render=overlay','default','Token registry','','7.34'),(1949,'/admin/config/regional/language?render=overlay','default','Hello <strong>@username</strong>','','7.34'),(1950,'/admin/config/regional/language?render=overlay','default','The source node for this current node\'s translation set.','','7.34'),(1951,'/admin/config/regional/language?render=overlay','default','The explanation of the most recent changes made to the node.','','7.34'),(1952,'/admin/config/regional/language?render=overlay','default','The content type of the node.','','7.34'),(1953,'/admin/config/regional/language?render=overlay','default','Tokens related to content types.','','7.34'),(1954,'/admin/config/regional/language?render=overlay','default','The name of the content type.','','7.34'),(1955,'/admin/config/regional/language?render=overlay','default','The unique machine-readable name of the content type.','','7.34'),(1956,'/admin/config/regional/language?render=overlay','default','The optional description of the content type.','','7.34'),(1957,'/admin/config/regional/language?render=overlay','default','The number of nodes belonging to the content type.','','7.34'),(1958,'/admin/config/regional/language?render=overlay','default','The URL of the content type\'s edit page.','','7.34'),(1959,'/admin/config/regional/language?render=overlay','default','The URL of the taxonomy term\'s edit page.','','7.34'),(1960,'/admin/config/regional/language?render=overlay','default','Parents','','7.34'),(1961,'/admin/config/regional/language?render=overlay','default','An array of all the term\'s parents, starting with the root.','','7.34'),(1962,'/admin/config/regional/language?render=overlay','default','Root term','','7.34'),(1963,'/admin/config/regional/language?render=overlay','default','The root term of the taxonomy term.','','7.34'),(1964,'/admin/config/regional/language?render=overlay','default','The unique machine-readable name of the vocabulary.','','7.34'),(1965,'/admin/config/regional/language?render=overlay','default','The URL of the vocabulary\'s edit page.','','7.34'),(1966,'/admin/config/regional/language?render=overlay','default','Base name','','7.34'),(1967,'/admin/config/regional/language?render=overlay','default','The base name of the file.','','7.34'),(1968,'/admin/config/regional/language?render=overlay','default','File byte size','','7.34'),(1969,'/admin/config/regional/language?render=overlay','default','The size of the file, in bytes.','','7.34'),(1970,'/admin/config/regional/language?render=overlay','default','Account cancellation URL','','7.34'),(1971,'/admin/config/regional/language?render=overlay','default','The URL of the confirm delete page for the user account.','','7.34'),(1972,'/admin/config/regional/language?render=overlay','default','One-time login URL','','7.34'),(1973,'/admin/config/regional/language?render=overlay','default','The URL of the one-time login page for the user account.','','7.34'),(1974,'/admin/config/regional/language?render=overlay','default','The picture of the user.','','7.34'),(1975,'/admin/config/regional/language?render=overlay','default','The user roles associated with the user account.','','7.34'),(1976,'/admin/config/regional/language?render=overlay','default','IP address','','7.34'),(1977,'/admin/config/regional/language?render=overlay','default','Menu links','','7.34'),(1978,'/admin/config/regional/language?render=overlay','default','Tokens related to menu links.','','7.34'),(1979,'/admin/config/regional/language?render=overlay','default','Link ID','','7.34'),(1980,'/admin/config/regional/language?render=overlay','default','The unique ID of the menu link.','','7.34'),(1981,'/admin/config/regional/language?render=overlay','default','The title of the menu link.','','7.34'),(1982,'/admin/config/regional/language?render=overlay','default','The URL of the menu link.','','7.34'),(1983,'/admin/config/regional/language?render=overlay','default','The menu link\'s parent.','','7.34'),(1984,'/admin/config/regional/language?render=overlay','default','An array of all the menu link\'s parents, starting with the root.','','7.34'),(1985,'/admin/config/regional/language?render=overlay','default','Root','','7.34'),(1986,'/admin/config/regional/language?render=overlay','default','The menu link\'s root.','','7.34'),(1987,'/admin/config/regional/language?render=overlay','default','Tokens related to the current page request.','','7.34'),(1988,'/admin/config/regional/language?render=overlay','default','The title of the current page.','','7.34'),(1989,'/admin/config/regional/language?render=overlay','default','The URL of the current page.','','7.34'),(1990,'/admin/config/regional/language?render=overlay','default','Page number','','7.34'),(1991,'/admin/config/regional/language?render=overlay','default','The page number of the current page when viewing paged lists.','','7.34'),(1992,'/admin/config/regional/language?render=overlay','default','Query string value','','7.34'),(1993,'/admin/config/regional/language?render=overlay','default','The value of a specific query string field of the current page.','','7.34'),(1994,'/admin/config/regional/language?render=overlay','default','Tokens related to URLs.','','7.34'),(1995,'/admin/config/regional/language?render=overlay','default','The path component of the URL.','','7.34'),(1996,'/admin/config/regional/language?render=overlay','default','Relative URL','','7.34'),(1997,'/admin/config/regional/language?render=overlay','default','The relative URL.','','7.34'),(1998,'/admin/config/regional/language?render=overlay','default','Absolute URL','','7.34'),(1999,'/admin/config/regional/language?render=overlay','default','The absolute URL.','','7.34'),(2000,'/admin/config/regional/language?render=overlay','default','Brief URL','','7.34'),(2001,'/admin/config/regional/language?render=overlay','default','The URL without the protocol and trailing backslash.','','7.34'),(2002,'/admin/config/regional/language?render=overlay','default','Unaliased URL','','7.34'),(2003,'/admin/config/regional/language?render=overlay','default','The unaliased URL.','','7.34'),(2004,'/admin/config/regional/language?render=overlay','default','Arguments','','7.34'),(2005,'/admin/config/regional/language?render=overlay','default','The specific argument of the current page (e.g. \'arg:1\' on the page \'node/1\' returns \'1\').','','7.34'),(2006,'/admin/config/regional/language?render=overlay','default','Array','','7.34'),(2007,'/admin/config/regional/language?render=overlay','default','Tokens related to arrays of strings.','','7.34'),(2008,'/admin/config/regional/language?render=overlay','default','First','','7.34'),(2009,'/admin/config/regional/language?render=overlay','default','The first element of the array.','','7.34'),(2010,'/admin/config/regional/language?render=overlay','default','Last','','7.34'),(2011,'/admin/config/regional/language?render=overlay','default','The last element of the array.','','7.34'),(2012,'/admin/config/regional/language?render=overlay','default','Count','','7.34'),(2013,'/admin/config/regional/language?render=overlay','default','The number of elements in the array.','','7.34'),(2014,'/admin/config/regional/language?render=overlay','default','Reversed','','7.34'),(2015,'/admin/config/regional/language?render=overlay','default','The array reversed.','','7.34'),(2016,'/admin/config/regional/language?render=overlay','default','Keys','','7.34'),(2017,'/admin/config/regional/language?render=overlay','default','The array of keys of the array.','','7.34'),(2018,'/admin/config/regional/language?render=overlay','default','Imploded','','7.34'),(2019,'/admin/config/regional/language?render=overlay','default','The values of the array joined together with a custom string in-between each value.','','7.34'),(2020,'/admin/config/regional/language?render=overlay','default','The specific value of the array.','','7.34'),(2021,'/admin/config/regional/language?render=overlay','default','Number','','7.34'),(2022,'/admin/config/regional/language?render=overlay','default','A random number from 0 to @max.','','7.34'),(2023,'/admin/config/regional/language?render=overlay','default','Hash','','7.34'),(2024,'/admin/config/regional/language?render=overlay','default','A random hash. The possible hashing algorithms are: @hash-algos.','','7.34'),(2025,'/admin/config/regional/language?render=overlay','default','Submission','','7.34'),(2026,'/admin/config/regional/language?render=overlay','default','Tokens related to webform submissions.','','7.34'),(2027,'/admin/config/regional/language?render=overlay','default','The serial number of this webform submission.','','7.34'),(2028,'/admin/config/regional/language?render=overlay','default','Submission ID','','7.34'),(2029,'/admin/config/regional/language?render=overlay','default','The unique indentifier for the webform submission.','','7.34'),(2030,'/admin/config/regional/language?render=overlay','default','Date submitted','','7.34'),(2031,'/admin/config/regional/language?render=overlay','default','The date the webform was submitted.','','7.34'),(2032,'/admin/config/regional/language?render=overlay','default','The IP address that was used when submitting the webform.','','7.34'),(2033,'/admin/config/regional/language?render=overlay','default','Submitter','','7.34'),(2034,'/admin/config/regional/language?render=overlay','default','The user that submitted the webform result.','','7.34'),(2035,'/admin/config/regional/language?render=overlay','default','Webform tokens related to URLs.','','7.34'),(2036,'/admin/config/regional/language?render=overlay','default','Webform submission values','','7.34'),(2037,'/admin/config/regional/language?render=overlay','default','Webform tokens from submitted data. Replace the \"?\" with the \"field key\", including any parent field keys separated by colons. You may append \":label\" for just the label or \":withlabel\" for both the label and value together. Append \":key\" for just the key in a key|label pair.','','7.34'),(2038,'/admin/config/regional/language?render=overlay','default','Address field','','7.34'),(2039,'/admin/config/regional/language?render=overlay','default','Tokens related to address field values and their components.','','7.34'),(2040,'/admin/config/regional/language?render=overlay','default','Country name','','7.34'),(2041,'/admin/config/regional/language?render=overlay','default','The full name of the country.','','7.34'),(2042,'/admin/config/regional/language?render=overlay','default','Country code','','7.34'),(2043,'/admin/config/regional/language?render=overlay','default','The two letter ISO country code.','','7.34'),(2044,'/admin/config/regional/language?render=overlay','default','Administrative area (i.e. State/Province)','','7.34'),(2045,'/admin/config/regional/language?render=overlay','default','The administrative area value, expanded to the full name if applicable.','','7.34'),(2046,'/admin/config/regional/language?render=overlay','default','Administrative area (raw value)','','7.34'),(2047,'/admin/config/regional/language?render=overlay','default','The raw administrative area value.','','7.34'),(2048,'/admin/config/regional/language?render=overlay','default','The locality value.','','7.34'),(2049,'/admin/config/regional/language?render=overlay','default','The postal code value.','','7.34'),(2050,'/admin/config/regional/language?render=overlay','default','The thoroughfare value.','','7.34'),(2051,'/admin/config/regional/language?render=overlay','default','Premise (i.e. Street address)','','7.34'),(2052,'/admin/config/regional/language?render=overlay','default','Organisation','','7.34'),(2053,'/admin/config/regional/language?render=overlay','default','The organisation name value.','','7.34'),(2054,'/admin/config/regional/language?render=overlay','default','The name line value of the address.','','7.34'),(2055,'/admin/config/regional/language?render=overlay','default','The first name value.','','7.34'),(2056,'/admin/config/regional/language?render=overlay','default','The last name value.','','7.34'),(2057,'/admin/config/regional/language?render=overlay','default','Address formatted for MailChimp','','7.34'),(2058,'/admin/config/regional/language?render=overlay','default','The full address formatted for import into MailChimp.','','7.34'),(2059,'/admin/config/regional/language?render=overlay','default','Tokens for comments posted on the site.','','7.34'),(2060,'/admin/config/regional/language?render=overlay','default','The formatted content of the comment itself.','','7.34'),(2061,'/admin/config/regional/language?render=overlay','default','The date the comment was most recently updated.','','7.34'),(2062,'/admin/config/regional/language?render=overlay','default','The author of the comment, if they were logged in.','','7.34'),(2063,'/admin/config/regional/language?render=overlay','default','Tokens related to customer profiles.','','7.34'),(2064,'/admin/config/regional/language?render=overlay','default','Customer profile ID','','7.34'),(2065,'/admin/config/regional/language?render=overlay','default','The unique numeric ID of the customer profile.','','7.34'),(2066,'/admin/config/regional/language?render=overlay','default','The unique ID of the customer profile\'s latest revision.','','7.34'),(2067,'/admin/config/regional/language?render=overlay','default','Customer profile type','','7.34'),(2068,'/admin/config/regional/language?render=overlay','default','Customer profile type name','','7.34'),(2069,'/admin/config/regional/language?render=overlay','default','The type name of the customer profile.','','7.34'),(2070,'/admin/config/regional/language?render=overlay','default','Customer profile owner','','7.34'),(2071,'/admin/config/regional/language?render=overlay','default','Line items','','7.34'),(2072,'/admin/config/regional/language?render=overlay','default','Tokens related to individual line items.','','7.34'),(2073,'/admin/config/regional/language?render=overlay','default','The unique numeric ID of the line item.','','7.34'),(2074,'/admin/config/regional/language?render=overlay','default','Line item type','','7.34'),(2075,'/admin/config/regional/language?render=overlay','default','The type of the line item.','','7.34'),(2076,'/admin/config/regional/language?render=overlay','default','Line item type name','','7.34'),(2077,'/admin/config/regional/language?render=overlay','default','The human-readable name of the line item type.','','7.34'),(2078,'/admin/config/regional/language?render=overlay','default','Order associated with the line item','','7.34'),(2079,'/admin/config/regional/language?render=overlay','default','Orders','a drupal commerce order','7.34'),(2080,'/admin/config/regional/language?render=overlay','default','Tokens related to individual orders.','','7.34'),(2081,'/admin/config/regional/language?render=overlay','default','The unique numeric ID of the order.','','7.34'),(2082,'/admin/config/regional/language?render=overlay','default','The unique ID of the order\'s latest revision.','','7.34'),(2083,'/admin/config/regional/language?render=overlay','default','Order type','','7.34'),(2084,'/admin/config/regional/language?render=overlay','default','Order type name','','7.34'),(2085,'/admin/config/regional/language?render=overlay','default','The human-readable name of the order type.','','7.34'),(2086,'/admin/config/regional/language?render=overlay','default','The e-mail address associated with the order.','','7.34'),(2087,'/admin/config/regional/language?render=overlay','default','Order status title','','7.34'),(2088,'/admin/config/regional/language?render=overlay','default','The human-readable title of the order status.','','7.34'),(2089,'/admin/config/regional/language?render=overlay','default','The current state of the order.','','7.34'),(2090,'/admin/config/regional/language?render=overlay','default','Order state title','','7.34'),(2091,'/admin/config/regional/language?render=overlay','default','The human-readable title of the order state.','','7.34'),(2092,'/admin/config/regional/language?render=overlay','default','The URL of the order.','','7.34'),(2093,'/admin/config/regional/language?render=overlay','default','The URL for customers to view the order.','','7.34'),(2094,'/admin/config/regional/language?render=overlay','default','The URL for administrators to view the order.','','7.34'),(2095,'/admin/config/regional/language?render=overlay','default','Payment transactions','a drupal commerce payment transaction','7.34'),(2096,'/admin/config/regional/language?render=overlay','default','Tokens related to payment transactions.','','7.34'),(2097,'/admin/config/regional/language?render=overlay','default','The primary identifier for a payment transaction.','','7.34'),(2098,'/admin/config/regional/language?render=overlay','default','The unique ID for the latest revision of a payment transaction.','','7.34'),(2099,'/admin/config/regional/language?render=overlay','default','The payment method method_id for the payment transaction.','','7.34'),(2100,'/admin/config/regional/language?render=overlay','default','Payment method title','','7.34'),(2101,'/admin/config/regional/language?render=overlay','default','The administrative title of the payment method for the payment transaction.','','7.34'),(2102,'/admin/config/regional/language?render=overlay','default','Payment method short title','','7.34'),(2103,'/admin/config/regional/language?render=overlay','default','The customer oriented short title of the payment method for the payment transaction.','','7.34'),(2104,'/admin/config/regional/language?render=overlay','default','The remote identifier for the payment transaction.','','7.34'),(2105,'/admin/config/regional/language?render=overlay','default','The human-readable message associated to the payment transaction.','','7.34'),(2106,'/admin/config/regional/language?render=overlay','default','The raw amount of the payment transaction.','','7.34'),(2107,'/admin/config/regional/language?render=overlay','default','The formatted amount of the payment transaction.','','7.34'),(2108,'/admin/config/regional/language?render=overlay','default','Currency code','','7.34'),(2109,'/admin/config/regional/language?render=overlay','default','The currency code for the payment.','','7.34'),(2110,'/admin/config/regional/language?render=overlay','default','Currency symbol','','7.34'),(2111,'/admin/config/regional/language?render=overlay','default','The currency symbol for the payment.','','7.34'),(2112,'/admin/config/regional/language?render=overlay','default','The status of this transaction (pending, success, or failure).','','7.34'),(2113,'/admin/config/regional/language?render=overlay','default','The status of the transaction at the payment provider.','','7.34'),(2114,'/admin/config/regional/language?render=overlay','default','The order related to the payment transaction.','','7.34'),(2115,'/admin/config/regional/language?render=overlay','default','The creator of the payment transaction.','','7.34'),(2116,'/admin/config/regional/language?render=overlay','default','The date the payment transaction was created.','','7.34'),(2117,'/admin/config/regional/language?render=overlay','default','The date the payment transaction was last updated.','','7.34'),(2118,'/admin/config/regional/language?render=overlay','default','Tokens related to individual products.','','7.34'),(2119,'/admin/config/regional/language?render=overlay','default','The machine name of the product type.','','7.34'),(2120,'/admin/config/regional/language?render=overlay','default','Type name','','7.34'),(2121,'/admin/config/regional/language?render=overlay','default','The human readable name of the product type.','','7.34'),(2122,'/admin/config/regional/language?render=overlay','default','Stock level (int)','','7.34'),(2123,'/admin/config/regional/language?render=overlay','default','The stock level as an integer','','7.34'),(2124,'/admin/config/regional/language?render=overlay','default','Stock level available for the user','','7.34'),(2125,'/admin/config/regional/language?render=overlay','default','The available stock level for the current user','','7.34'),(2126,'/admin/config/regional/language?render=overlay','default','Quantity already ordered','','7.34'),(2127,'/admin/config/regional/language?render=overlay','default','The quantity already ordered (in the basket) for the user','','7.34'),(2128,'/admin/config/regional/language?render=overlay','default','Tokens related to individual countries.','','7.34'),(2129,'/admin/config/regional/language?render=overlay','default','Default country','','7.34'),(2130,'/admin/config/regional/language?render=overlay','default','Tokens related to the sites default country.','','7.34'),(2131,'/admin/config/regional/language?render=overlay','default','The unique internal database ID of the country.','','7.34'),(2132,'/admin/config/regional/language?render=overlay','default','The @property of the country.','','7.34'),(2133,'/admin/config/regional/language?render=overlay','default','The Continent code of the country.','','7.34'),(2134,'/admin/config/regional/language?render=overlay','default','Search results','','7.34'),(2135,'/admin/config/regional/language?render=overlay','default','Tokens related to the search query and response.','','7.34'),(2136,'/admin/config/regional/language?render=overlay','default','Active facet items','','7.34'),(2137,'/admin/config/regional/language?render=overlay','default','Tokens related to active facet items.','','7.34'),(2138,'/admin/config/regional/language?render=overlay','default','Facet field','','7.34'),(2139,'/admin/config/regional/language?render=overlay','default','Tokens related to a facet field.','','7.34'),(2140,'/admin/config/regional/language?render=overlay','default','Search keywords','','7.34'),(2141,'/admin/config/regional/language?render=overlay','default','The search keywords entered by the user.','','7.34'),(2142,'/admin/config/regional/language?render=overlay','default','The page number of the result set.','','7.34'),(2143,'/admin/config/regional/language?render=overlay','default','Page limit','','7.34'),(2144,'/admin/config/regional/language?render=overlay','default','The number of results displayed per page.','','7.34'),(2145,'/admin/config/regional/language?render=overlay','default','Page total','','7.34'),(2146,'/admin/config/regional/language?render=overlay','default','The total number of pages in the result set.','','7.34'),(2147,'/admin/config/regional/language?render=overlay','default','Offset','','7.34'),(2148,'/admin/config/regional/language?render=overlay','default','The zero-based offset of the first element on the search page.','','7.34'),(2149,'/admin/config/regional/language?render=overlay','default','Start count','','7.34'),(2150,'/admin/config/regional/language?render=overlay','default','The number of the first item on the page.','','7.34'),(2151,'/admin/config/regional/language?render=overlay','default','End count','','7.34'),(2152,'/admin/config/regional/language?render=overlay','default','The number of the last item on the page.','','7.34'),(2153,'/admin/config/regional/language?render=overlay','default','Result count','','7.34'),(2154,'/admin/config/regional/language?render=overlay','default','The total number of results matched by the search query.','','7.34'),(2155,'/admin/config/regional/language?render=overlay','default','Search path','','7.34'),(2156,'/admin/config/regional/language?render=overlay','default','Path to the current page without any filter','','7.34'),(2157,'/admin/config/regional/language?render=overlay','default','Mapped value','','7.34'),(2158,'/admin/config/regional/language?render=overlay','default','The mapped value of the active item.','','7.34'),(2159,'/admin/config/regional/language?render=overlay','default','Raw value','','7.34'),(2160,'/admin/config/regional/language?render=overlay','default','The raw value of the active item as stored in the index.','','7.34'),(2161,'/admin/config/regional/language?render=overlay','default','The zero-based position of the active item.','','7.34'),(2162,'/admin/config/regional/language?render=overlay','default','Facet label','','7.34'),(2163,'/admin/config/regional/language?render=overlay','default','The human readable label of the active item\'s facet.','','7.34'),(2164,'/admin/config/regional/language?render=overlay','default','Facet name','','7.34'),(2165,'/admin/config/regional/language?render=overlay','default','The machine readable name of the active item\'s facet.','','7.34'),(2166,'/admin/config/regional/language?render=overlay','default','Tokens related to menus.','','7.34'),(2167,'/admin/config/regional/language?render=overlay','default','The name of the menu.','','7.34'),(2168,'/admin/config/regional/language?render=overlay','default','The unique machine-readable name of the menu.','','7.34'),(2169,'/admin/config/regional/language?render=overlay','default','The optional description of the menu.','','7.34'),(2170,'/admin/config/regional/language?render=overlay','default','Menu link count','','7.34'),(2171,'/admin/config/regional/language?render=overlay','default','The number of menu links belonging to the menu.','','7.34'),(2172,'/admin/config/regional/language?render=overlay','default','The URL of the menu\'s edit page.','','7.34'),(2173,'/admin/config/regional/language?render=overlay','default','The menu of the menu link.','','7.34'),(2174,'/admin/config/regional/language?render=overlay','default','The URL of the menu link\'s edit page.','','7.34'),(2175,'/admin/config/regional/language?render=overlay','default','Menu link','','7.34'),(2176,'/admin/config/regional/language?render=overlay','default','The menu link for this node.','','7.34'),(2177,'/admin/config/regional/language?render=overlay','default','Tokens related to individual content items, or \"nodes\".','','7.34'),(2178,'/admin/config/regional/language?render=overlay','default','Content ID','','7.34'),(2179,'/admin/config/regional/language?render=overlay','default','The unique ID of the content item, or \"node\".','','7.34'),(2180,'/admin/config/regional/language?render=overlay','default','The unique ID of the node\'s latest revision.','','7.34'),(2181,'/admin/config/regional/language?render=overlay','default','Translation set ID','','7.34'),(2182,'/admin/config/regional/language?render=overlay','default','The unique ID of the original-language version of this node, if one exists.','','7.34'),(2183,'/admin/config/regional/language?render=overlay','default','Content type name','','7.34'),(2184,'/admin/config/regional/language?render=overlay','default','The human-readable name of the node type.','','7.34'),(2185,'/admin/config/regional/language?render=overlay','default','Body','','7.34'),(2186,'/admin/config/regional/language?render=overlay','default','The main body text of the node.','','7.34'),(2187,'/admin/config/regional/language?render=overlay','default','The summary of the node\'s main body text.','','7.34'),(2188,'/admin/config/regional/language?render=overlay','default','Tokens related to the newsletter recipient','','7.34'),(2189,'/admin/config/regional/language?render=overlay','default','Simplenews newsletter category','','7.34'),(2190,'/admin/config/regional/language?render=overlay','default','Tokens related to the newsletter category','','7.34'),(2191,'/admin/config/regional/language?render=overlay','default','Subscription URL','','7.34'),(2192,'/admin/config/regional/language?render=overlay','default','The URL of the page where the subscription is confirmed.','','7.34'),(2193,'/admin/config/regional/language?render=overlay','default','Unsubscribe URL','','7.34'),(2194,'/admin/config/regional/language?render=overlay','default','The URL of the page where the cancellation of the subscription is confirmed.','','7.34'),(2195,'/admin/config/regional/language?render=overlay','default','Manage URL','','7.34'),(2196,'/admin/config/regional/language?render=overlay','default','The URL of the page where the subscribers can manage their newsletter subscriptions.','','7.34'),(2197,'/admin/config/regional/language?render=overlay','default','Combined confirmation URL','','7.34'),(2198,'/admin/config/regional/language?render=overlay','default','The URL of the page where subscribers can confirm their subscription changes.','','7.34'),(2199,'/admin/config/regional/language?render=overlay','default','Subscriber email','','7.34'),(2200,'/admin/config/regional/language?render=overlay','default','The email address of the newsletter receiver.','','7.34'),(2201,'/admin/config/regional/language?render=overlay','default','Corresponding user','','7.34'),(2202,'/admin/config/regional/language?render=overlay','default','The user object that corresponds to this subscriber. This is not set for anonymous subscribers.','','7.34'),(2203,'/admin/config/regional/language?render=overlay','default','Newsletter category','','7.34'),(2204,'/admin/config/regional/language?render=overlay','default','The name of the newsletter category.','','7.34'),(2205,'/admin/config/regional/language?render=overlay','default','Newsletter category URL','','7.34'),(2206,'/admin/config/regional/language?render=overlay','default','The URL of the page listing the issues of this newsletter category.','','7.34'),(2207,'/admin/config/regional/language?render=overlay','default','Corresponding term','','7.34'),(2208,'/admin/config/regional/language?render=overlay','default','The taxonomy term of this newsletter category','','7.34'),(2209,'/admin/config/regional/language?render=overlay','default','Tokens for site-wide settings and other global information.','','7.34'),(2210,'/admin/config/regional/language?render=overlay','default','Dates','','7.34'),(2211,'/admin/config/regional/language?render=overlay','default','Tokens related to times and dates.','','7.34'),(2212,'/admin/config/regional/language?render=overlay','default','Tokens related to uploaded files.','','7.34'),(2213,'/admin/config/regional/language?render=overlay','default','URL (brief)','','7.34'),(2214,'/admin/config/regional/language?render=overlay','default','The URL of the site\'s front page without the protocol.','','7.34'),(2215,'/admin/config/regional/language?render=overlay','default','Short format','','7.34'),(2216,'/admin/config/regional/language?render=overlay','default','A date in \'short\' format. (%date)','','7.34'),(2217,'/admin/config/regional/language?render=overlay','default','Medium format','','7.34'),(2218,'/admin/config/regional/language?render=overlay','default','Thu','','7.34'),(2219,'/admin/config/regional/language?render=overlay','default','A date in \'medium\' format. (%date)','','7.34'),(2220,'/admin/config/regional/language?render=overlay','default','Long format','','7.34'),(2221,'/admin/config/regional/language?render=overlay','default','Thursday','','7.34'),(2222,'/admin/config/regional/language?render=overlay','default','December','Long month name','7.34'),(2223,'/admin/config/regional/language?render=overlay','default','A date in \'long\' format. (%date)','','7.34'),(2224,'/admin/config/regional/language?render=overlay','default','Custom format','','7.34'),(2225,'/admin/config/regional/language?render=overlay','default','the PHP documentation','','7.34'),(2226,'/admin/config/regional/language?render=overlay','default','A date in a custom format. See !php-date for details.','','7.34'),(2227,'/admin/config/regional/language?render=overlay','default','Time-since','','7.34'),(2228,'/admin/config/regional/language?render=overlay','default','@count years','','7.34'),(2229,'/admin/config/regional/language?render=overlay','default','@count days','','7.34'),(2230,'/admin/config/regional/language?render=overlay','default','A date in \'time-since\' format. (%date)','','7.34'),(2231,'/admin/config/regional/language?render=overlay','default','Raw timestamp','','7.34'),(2232,'/admin/config/regional/language?render=overlay','default','A date in UNIX timestamp format (%date)','','7.34'),(2233,'/admin/config/regional/language?render=overlay','default','The location of the file relative to Drupal root.','','7.34'),(2234,'/admin/config/regional/language?render=overlay','default','Tokens related to taxonomy terms.','','7.34'),(2235,'/admin/config/regional/language?render=overlay','default','Vocabularies','','7.34'),(2236,'/admin/config/regional/language?render=overlay','default','Tokens related to taxonomy vocabularies.','','7.34'),(2237,'/admin/config/regional/language?render=overlay','default','The number of nodes tagged with terms belonging to the taxonomy vocabulary.','','7.34'),(2238,'/admin/config/regional/language?render=overlay','default','The parent term of the taxonomy term, if one exists.','','7.34'),(2239,'/admin/config/regional/language?render=overlay','default','Tokens related to individual user accounts.','','7.34'),(2240,'/admin/config/regional/language?render=overlay','default','Tokens related to the currently logged in user.','','7.34'),(2241,'/admin/config/regional/language?render=overlay','default','The URL of the account edit page.','','7.34'),(2242,'/admin/config/regional/language?render=overlay','default','Joined path','','7.34'),(2243,'/admin/config/regional/language?render=overlay','default','The array values each cleaned by Pathauto and then joined with the slash into a string that resembles an URL.','','7.34'),(2244,'/admin/config/regional/language?render=overlay','default','Tokens related to views.','','7.34'),(2245,'/admin/config/regional/language?render=overlay','default','The human-readable name of the view.','','7.34'),(2246,'/admin/config/regional/language?render=overlay','default','The description of the view.','','7.34'),(2247,'/admin/config/regional/language?render=overlay','default','The machine-readable name of the view.','','7.34'),(2248,'/admin/config/regional/language?render=overlay','default','The title of current display of the view.','','7.34'),(2249,'/admin/config/regional/language?render=overlay','default','The URL of the view.','','7.34'),(2250,'/admin/config/regional/language?render=overlay','default','Payment settings','','7.34'),(2251,'/admin/config/regional/language?render=overlay','default','price','','7.34'),(2252,'/admin/config/regional/language?render=overlay','default','watchdog log entry','','7.34'),(2253,'/admin/config/regional/language?render=overlay','default','The category to which this message belongs','','7.34'),(2254,'/admin/config/regional/language?render=overlay','default','Severity','','7.34'),(2255,'/admin/config/regional/language?render=overlay','default','Request uri','','7.34'),(2256,'/admin/config/regional/language?render=overlay','default','An associated, HTML formatted link','','7.34'),(2257,'/admin/config/regional/language?render=overlay','default','text token','','7.34'),(2258,'/admin/config/regional/language?render=overlay','default','formatted text','','7.34'),(2259,'/admin/config/regional/language?render=overlay','default','decimal number','','7.34'),(2260,'/admin/config/regional/language?render=overlay','default','integer','','7.34'),(2261,'/admin/config/regional/language?render=overlay','default','date','','7.34'),(2262,'/admin/config/regional/language?render=overlay','default','duration','','7.34'),(2263,'/admin/config/regional/language?render=overlay','default','truth value','','7.34'),(2264,'/admin/config/regional/language?render=overlay','default','URI','','7.34'),(2265,'/admin/config/regional/language?render=overlay','default','list','data_types','7.34'),(2266,'/admin/config/regional/language?render=overlay','default','List','data_types','7.34'),(2267,'/admin/config/regional/language?render=overlay','default','list of text','','7.34'),(2268,'/admin/config/regional/language?render=overlay','default','list of integer','','7.34'),(2269,'/admin/config/regional/language?render=overlay','default','list of text tokens','','7.34'),(2270,'/admin/config/regional/language?render=overlay','default','any entity','','7.34'),(2271,'/admin/config/regional/language?render=overlay','default','list of @type_label items','','7.34'),(2272,'/admin/config/regional/language?render=overlay','default','Condition set (OR)','','7.34'),(2273,'/admin/config/regional/language?render=overlay','default','Condition set (AND)','','7.34'),(2274,'/admin/config/regional/language?render=overlay','default','Action set','','7.34'),(2275,'/admin/config/regional/language?render=overlay','default','Rule','','7.34'),(2276,'/admin/config/regional/language?render=overlay','default','Rule set','','7.34'),(2277,'/admin/config/regional/language?render=overlay','default','Order is a shopping cart','','7.34'),(2278,'/admin/config/regional/language?render=overlay','default','Commerce Cart','','7.34'),(2279,'/admin/config/regional/language?render=overlay','default','Order address component comparison','','7.34'),(2280,'/admin/config/regional/language?render=overlay','default','The order containing the profile reference with the address in question.','','7.34'),(2281,'/admin/config/regional/language?render=overlay','default','Address','','7.34'),(2282,'/admin/config/regional/language?render=overlay','default','The address associated with this order whose component you want to compare.','','7.34'),(2283,'/admin/config/regional/language?render=overlay','default','Address component','','7.34'),(2284,'/admin/config/regional/language?render=overlay','default','The actual address component you want to compare. Common names of address components are given in parentheses.','','7.34'),(2285,'/admin/config/regional/language?render=overlay','default','Operator','','7.34'),(2286,'/admin/config/regional/language?render=overlay','default','The comparison operator.','','7.34'),(2287,'/admin/config/regional/language?render=overlay','default','The value to compare against the address component. Bear in mind that addresses using select lists for various components may use a value different from the option you select. For example, countries are selected by name, but the value is the two letter abbreviation. For comparisons with multiple possible values, place separate values on new lines.','','7.34'),(2288,'/admin/config/regional/language?render=overlay','default','Order contains a particular product','','7.34'),(2289,'/admin/config/regional/language?render=overlay','default','The order whose line items should be checked for the specified product. If the specified order does not exist, the comparison will act as if it is against a quantity of 0.','','7.34'),(2290,'/admin/config/regional/language?render=overlay','default','Product SKU','','7.34'),(2291,'/admin/config/regional/language?render=overlay','default','The SKU of the product to look for on the order.','','7.34'),(2292,'/admin/config/regional/language?render=overlay','default','The operator used with the quantity value below to compare the quantity of the specified product on the order.','','7.34'),(2293,'/admin/config/regional/language?render=overlay','default','The value to compare against the quantity of the specified product on the order.','','7.34'),(2294,'/admin/config/regional/language?render=overlay','default','Order contains products of particular product types','','7.34'),(2295,'/admin/config/regional/language?render=overlay','default','The order whose line items should be checked for the specified product type. If the specified order does not exist, the comparison will act as if it is against a quantity of 0.','','7.34'),(2296,'/admin/config/regional/language?render=overlay','default','Product type(s)','','7.34'),(2297,'/admin/config/regional/language?render=overlay','default','The product type(s) to look for in the order.','','7.34'),(2298,'/admin/config/regional/language?render=overlay','default','The operator used with the quantity value below to compare against the quantity of products matching the specified product type(s) on the order.','','7.34'),(2299,'/admin/config/regional/language?render=overlay','default','The value to compare against the quantity of products of the specified product type(s) on the order.','','7.34'),(2300,'/admin/config/regional/language?render=overlay','default','Total product quantity comparison','','7.34'),(2301,'/admin/config/regional/language?render=overlay','default','The order whose product line item quantities should be totalled. If the specified order does not exist, the comparison will act as if it is against a quantity of 0.','','7.34'),(2302,'/admin/config/regional/language?render=overlay','default','The comparison operator to use against the total number of products on the order.','','7.34'),(2303,'/admin/config/regional/language?render=overlay','default','The value to compare against the total quantity of products on the order.','','7.34'),(2304,'/admin/config/regional/language?render=overlay','default','Order balance comparison','','7.34'),(2305,'/admin/config/regional/language?render=overlay','default','The order whose balance should be compared (calculated as the order total minus completed payment amounts).','','7.34'),(2306,'/admin/config/regional/language?render=overlay','default','Integer representing a value in minor currency units to compare against, such as 1000 for $10. A balance of 0 or less indicates the order has been paid in full.','','7.34'),(2307,'/admin/config/regional/language?render=overlay','default','Commerce Payment','','7.34'),(2308,'/admin/config/regional/language?render=overlay','default','Selected payment method comparison','','7.34'),(2309,'/admin/config/regional/language?render=overlay','default','The order whose selected payment method (if any) should be compared against the method specified below.','','7.34'),(2310,'/admin/config/regional/language?render=overlay','default','This condition will perform a simple equivalency check to see if the payment method you specify matches what a customer selected on the checkout form.','','7.34'),(2311,'/admin/config/regional/language?render=overlay','default','Price comparison','','7.34'),(2312,'/admin/config/regional/language?render=overlay','default','First Price','','7.34'),(2313,'/admin/config/regional/language?render=overlay','default','The price value that should be compared.','','7.34'),(2314,'/admin/config/regional/language?render=overlay','default','Second Price','','7.34'),(2315,'/admin/config/regional/language?render=overlay','default','The corresponding price value that should be compared against.','','7.34'),(2316,'/admin/config/regional/language?render=overlay','default','Commerce Price','','7.34'),(2317,'/admin/config/regional/language?render=overlay','default','Shipping line item exists','','7.34'),(2318,'/admin/config/regional/language?render=overlay','default','The order whose line items should be checked for an existing shipping line item.','','7.34'),(2319,'/admin/config/regional/language?render=overlay','default','Shipping service','','7.34'),(2320,'/admin/config/regional/language?render=overlay','default','Limit the search amongst the shipping line items to a particular shipping service.','','7.34'),(2321,'/admin/config/regional/language?render=overlay','default','Commerce Shipping','','7.34'),(2322,'/admin/config/regional/language?render=overlay','default','Product has simple stock enabled for its type','','7.34'),(2323,'/admin/config/regional/language?render=overlay','default','Commerce Stock (ss)','','7.34'),(2324,'/admin/config/regional/language?render=overlay','default','Product simple stock is not disabled by an override','','7.34'),(2325,'/admin/config/regional/language?render=overlay','default','Order has products that are out of stock','','7.34'),(2326,'/admin/config/regional/language?render=overlay','default','Commerce Stock','','7.34'),(2327,'/admin/config/regional/language?render=overlay','default','Data comparison','','7.34'),(2328,'/admin/config/regional/language?render=overlay','default','Data to compare','','7.34'),(2329,'/admin/config/regional/language?render=overlay','default','The data to be compared, specified by using a data selector, e.g. \"node:author:name\".','','7.34'),(2330,'/admin/config/regional/language?render=overlay','default','Data value','','7.34'),(2331,'/admin/config/regional/language?render=overlay','default','The value to compare the data with.','','7.34'),(2332,'/admin/config/regional/language?render=overlay','default','Data value is empty','','7.34'),(2333,'/admin/config/regional/language?render=overlay','default','Data to check','','7.34'),(2334,'/admin/config/regional/language?render=overlay','default','The data to be checked to be empty, specified by using a data selector, e.g. \"node:author:name\".','','7.34'),(2335,'/admin/config/regional/language?render=overlay','default','List contains item','','7.34'),(2336,'/admin/config/regional/language?render=overlay','default','Item','','7.34'),(2337,'/admin/config/regional/language?render=overlay','default','The item to check for.','','7.34'),(2338,'/admin/config/regional/language?render=overlay','default','List count comparison','','7.34'),(2339,'/admin/config/regional/language?render=overlay','default','List to check','','7.34'),(2340,'/admin/config/regional/language?render=overlay','default','A multi value data element to have its count compared, specified by using a data selector, eg node:author:roles.','','7.34'),(2341,'/admin/config/regional/language?render=overlay','default','The count to compare the data count with.','','7.34'),(2342,'/admin/config/regional/language?render=overlay','default','Text comparison','','7.34'),(2343,'/admin/config/regional/language?render=overlay','default','Matching text','','7.34'),(2344,'/admin/config/regional/language?render=overlay','default','Comparison operation','','7.34'),(2345,'/admin/config/regional/language?render=overlay','default','regular expression','','7.34'),(2346,'/admin/config/regional/language?render=overlay','default','In case the comparison operation @regex is selected, the matching pattern will be interpreted as a <a href=\"@regex-wikipedia\">regular expression</a>.  Tip: <a href=\"@RegExr\">RegExr: Online Regular Expression Testing Tool</a> is helpful for learning, writing, and testing Regular Expressions.','','7.34'),(2347,'/admin/config/regional/language?render=overlay','default','Entity is new','','7.34'),(2348,'/admin/config/regional/language?render=overlay','default','Specifies the entity for which to evaluate the condition.','','7.34'),(2349,'/admin/config/regional/language?render=overlay','default','Entities','','7.34'),(2350,'/admin/config/regional/language?render=overlay','default','Entity has field','','7.34'),(2351,'/admin/config/regional/language?render=overlay','default','The name of the field to check for.','','7.34'),(2352,'/admin/config/regional/language?render=overlay','default','Entity is of type','','7.34'),(2353,'/admin/config/regional/language?render=overlay','default','The entity type to check for.','','7.34'),(2354,'/admin/config/regional/language?render=overlay','default','Entity is of bundle','','7.34'),(2355,'/admin/config/regional/language?render=overlay','default','The type of the checked entity.','','7.34'),(2356,'/admin/config/regional/language?render=overlay','default','Entity bundle','','7.34'),(2357,'/admin/config/regional/language?render=overlay','default','The condition is met if the entity is of one of the selected bundles.','','7.34'),(2358,'/admin/config/regional/language?render=overlay','default','User has field access','','7.34'),(2359,'/admin/config/regional/language?render=overlay','default','Access operation','','7.34'),(2360,'/admin/config/regional/language?render=overlay','default','Specifies the user account for which to check access. If left empty, the currently logged in user will be used.','','7.34'),(2361,'/admin/config/regional/language?render=overlay','default','User has role(s)','','7.34'),(2362,'/admin/config/regional/language?render=overlay','default','Match roles','','7.34'),(2363,'/admin/config/regional/language?render=overlay','default','If matching against all selected roles, the user must have <em>all</em> the roles selected.','','7.34'),(2364,'/admin/config/regional/language?render=overlay','default','User is blocked','','7.34'),(2365,'/admin/config/regional/language?render=overlay','default','Execute custom PHP code','','7.34'),(2366,'/admin/config/regional/language?render=overlay','default','PHP','','7.34'),(2367,'/admin/config/regional/language?render=overlay','default','PHP code','','7.34'),(2368,'/admin/config/regional/language?render=overlay','default','Enter PHP code without &lt;?php ?&gt; delimiters that returns a boolean value; e.g. <code>@code</code>.','','7.34'),(2369,'/admin/config/regional/language?render=overlay','default','Path has URL alias','','7.34'),(2370,'/admin/config/regional/language?render=overlay','default','Existing system path','','7.34'),(2371,'/admin/config/regional/language?render=overlay','default','Specifies the existing path you wish to check for. For example: node/28, forum/1, taxonomy/term/1+2.','','7.34'),(2372,'/admin/config/regional/language?render=overlay','default','If specified, the language for which the URL alias applies.','','7.34'),(2373,'/admin/config/regional/language?render=overlay','default','URL alias exists','','7.34'),(2374,'/admin/config/regional/language?render=overlay','default','URL alias','','7.34'),(2375,'/admin/config/regional/language?render=overlay','default','Specify the URL alias to check for. For example, \"about\" for an about page.','','7.34'),(2376,'/admin/config/regional/language?render=overlay','default','Content is of type','','7.34'),(2377,'/admin/config/regional/language?render=overlay','default','Evaluates to TRUE if the given content is of one of the selected content types.','','7.34'),(2378,'/admin/config/regional/language?render=overlay','default','The content type(s) to check for.','','7.34'),(2379,'/admin/config/regional/language?render=overlay','default','Content is published','','7.34'),(2380,'/admin/config/regional/language?render=overlay','default','Content is sticky','','7.34'),(2381,'/admin/config/regional/language?render=overlay','default','Content is promoted to frontpage','','7.34'),(2382,'/admin/config/regional/language?render=overlay','default','Entity exists by property','','7.34'),(2383,'/admin/config/regional/language?render=overlay','default','Specifies the type of the entity that should be fetched.','','7.34'),(2384,'/admin/config/regional/language?render=overlay','default','Property','','7.34'),(2385,'/admin/config/regional/language?render=overlay','default','The property by which the entity is to be selected.','','7.34'),(2386,'/admin/config/regional/language?render=overlay','default','The property value of the entity to be fetched.','','7.34'),(2387,'/admin/config/regional/language?render=overlay','default','Remove all products from an order','','7.34'),(2388,'/admin/config/regional/language?render=overlay','default','Order to empty','','7.34'),(2389,'/admin/config/regional/language?render=overlay','default','Display a translatable Add to Cart message','','7.34'),(2390,'/admin/config/regional/language?render=overlay','default','Product added to the cart','','7.34'),(2391,'/admin/config/regional/language?render=overlay','default','Add a product to the cart','','7.34'),(2392,'/admin/config/regional/language?render=overlay','default','Specify the user whose shopping cart order the product will be added to, typically <em>site:current-user</em>.','','7.34'),(2393,'/admin/config/regional/language?render=overlay','default','The SKU of the product to add to the cart.','','7.34'),(2394,'/admin/config/regional/language?render=overlay','default','Combine similar items in the cart','','7.34'),(2395,'/admin/config/regional/language?render=overlay','default','If checked, the product will be combined added to an existing similar product line item in the cart by incrementing its quantity.','','7.34'),(2396,'/admin/config/regional/language?render=overlay','default','Added product line item','','7.34'),(2397,'/admin/config/regional/language?render=overlay','default','Send account e-mail','','7.34'),(2398,'/admin/config/regional/language?render=overlay','default','Account','','7.34'),(2399,'/admin/config/regional/language?render=overlay','default','E-mail type','','7.34'),(2400,'/admin/config/regional/language?render=overlay','default','Select the e-mail based on your site\'s account settings to send to the user.','','7.34'),(2401,'/admin/config/regional/language?render=overlay','default','Complete checkout for an order','','7.34'),(2402,'/admin/config/regional/language?render=overlay','default','Order in checkout','','7.34'),(2403,'/admin/config/regional/language?render=overlay','default','Commerce Checkout','','7.34'),(2404,'/admin/config/regional/language?render=overlay','default','Add an amount to the unit price','','7.34'),(2405,'/admin/config/regional/language?render=overlay','default','Specify a numeric amount to add to the unit price.','','7.34'),(2406,'/admin/config/regional/language?render=overlay','default','Subtract an amount from the unit price','','7.34'),(2407,'/admin/config/regional/language?render=overlay','default','Specify a numeric amount to subtract from the price.','','7.34'),(2408,'/admin/config/regional/language?render=overlay','default','Multiply the unit price by some amount','','7.34'),(2409,'/admin/config/regional/language?render=overlay','default','Specify the numeric amount by which to multiply the price.','','7.34'),(2410,'/admin/config/regional/language?render=overlay','default','Divide the unit price by some amount','','7.34'),(2411,'/admin/config/regional/language?render=overlay','default','Specify a numeric amount by which to divide the price.','','7.34'),(2412,'/admin/config/regional/language?render=overlay','default','Set the unit price to a specific amount','','7.34'),(2413,'/admin/config/regional/language?render=overlay','default','Specify the numeric amount to set the price to.','','7.34'),(2414,'/admin/config/regional/language?render=overlay','default','Price component type','','7.34'),(2415,'/admin/config/regional/language?render=overlay','default','Price components track changes to prices made during the price calculation process, and they are carried over from the unit price to the total price of a line item. When an order total is calculated, it combines all the components of every line item on the order. When the unit price is altered by this action, the selected type of price component will be added to its data array and reflected in the order total display when it is formatted with components showing. Defaults to base price, which displays as the order Subtotal.','','7.34'),(2416,'/admin/config/regional/language?render=overlay','default','Price rounding mode','','7.34'),(2417,'/admin/config/regional/language?render=overlay','default','Round the resulting price amount after performing this operation.','','7.34'),(2418,'/admin/config/regional/language?render=overlay','default','Set the unit price\'s currency code','','7.34'),(2419,'/admin/config/regional/language?render=overlay','default','Convert the unit price to a different currency','','7.34'),(2420,'/admin/config/regional/language?render=overlay','default','Create a new Funds Transaction','','7.34'),(2421,'/admin/config/regional/language?render=overlay','default','Transaction Type','','7.34'),(2422,'/admin/config/regional/language?render=overlay','default','Transaction amount','','7.34'),(2423,'/admin/config/regional/language?render=overlay','default','Transaction status','','7.34'),(2424,'/admin/config/regional/language?render=overlay','default','Notes','','7.34'),(2425,'/admin/config/regional/language?render=overlay','default','Transaction','','7.34'),(2426,'/admin/config/regional/language?render=overlay','default','Apply fees to funds transaction','','7.34'),(2427,'/admin/config/regional/language?render=overlay','default','Fee type','','7.34'),(2428,'/admin/config/regional/language?render=overlay','default','Fee value','','7.34'),(2429,'/admin/config/regional/language?render=overlay','default','If fee type is Percentage, enter a decimal number between 0 and 1, so 0.05 means 5%. If it\'s Flat rate, enter a positive decimal value. It\'s your responsibility to make sure that the flat rate is less than the transaction amount.','','7.34'),(2430,'/admin/config/regional/language?render=overlay','default','Apply transaction to related accounts balance','','7.34'),(2431,'/admin/config/regional/language?render=overlay','default','Load funds account using owner information','','7.34'),(2432,'/admin/config/regional/language?render=overlay','default','Owner Type','','7.34'),(2433,'/admin/config/regional/language?render=overlay','default','Funds Account','','7.34'),(2434,'/admin/config/regional/language?render=overlay','default','Load Deposit transaction from order','','7.34'),(2435,'/admin/config/regional/language?render=overlay','default','Load related Store orders from Marketplace order','','7.34'),(2436,'/admin/config/regional/language?render=overlay','default','Commerce Marketplace','','7.34'),(2437,'/admin/config/regional/language?render=overlay','default','Marketplace Order','','7.34'),(2438,'/admin/config/regional/language?render=overlay','default','Store orders','','7.34'),(2439,'/admin/config/regional/language?render=overlay','default','Update the order state','','7.34'),(2440,'/admin/config/regional/language?render=overlay','default','Order to update','','7.34'),(2441,'/admin/config/regional/language?render=overlay','default','Select the order state whose default status the order will be updated to.','','7.34'),(2442,'/admin/config/regional/language?render=overlay','default','Update the order status','','7.34'),(2443,'/admin/config/regional/language?render=overlay','default','Enable payment method: @method','','7.34'),(2444,'/admin/config/regional/language?render=overlay','default','Add a rate for a shipping service to an order','','7.34'),(2445,'/admin/config/regional/language?render=overlay','default','Collect rates for a shipping method','','7.34'),(2446,'/admin/config/regional/language?render=overlay','default','Shipping method','','7.34'),(2447,'/admin/config/regional/language?render=overlay','default','Apply shipping rate to an order','','7.34'),(2448,'/admin/config/regional/language?render=overlay','default','If left empty, the first available shipping service will be applied.','','7.34'),(2449,'/admin/config/regional/language?render=overlay','default','Delete all shipping line items from an order','','7.34'),(2450,'/admin/config/regional/language?render=overlay','default','Decrease the product stock level, given a line item','','7.34'),(2451,'/admin/config/regional/language?render=overlay','default','Increase the product stock level, given a line item','','7.34'),(2452,'/admin/config/regional/language?render=overlay','default','Set the result of an add to cart stock check','','7.34'),(2453,'/admin/config/regional/language?render=overlay','default','Stock Action','','7.34'),(2454,'/admin/config/regional/language?render=overlay','default','the action to take .','','7.34'),(2455,'/admin/config/regional/language?render=overlay','default','User message','','7.34'),(2456,'/admin/config/regional/language?render=overlay','default','Approved Quantity','','7.34'),(2457,'/admin/config/regional/language?render=overlay','default','Set the state of the add to cart form','','7.34'),(2458,'/admin/config/regional/language?render=overlay','default','Disable the add to cart?','','7.34'),(2459,'/admin/config/regional/language?render=overlay','default','The text to set the action to','','7.34'),(2460,'/admin/config/regional/language?render=overlay','default','add a class to the add to cart form','','7.34'),(2461,'/admin/config/regional/language?render=overlay','default','Advanced configuration of the add to cart form','','7.34'),(2462,'/admin/config/regional/language?render=overlay','default','Hide the Quantity field if it is visible','','7.34'),(2463,'/admin/config/regional/language?render=overlay','default','Add a class to the add to cart form','','7.34'),(2464,'/admin/config/regional/language?render=overlay','default','Prefix','','7.34'),(2465,'/admin/config/regional/language?render=overlay','default','Suffix','','7.34'),(2466,'/admin/config/regional/language?render=overlay','default','The action to take.','','7.34'),(2467,'/admin/config/regional/language?render=overlay','default','Only aplicable if Normal Submit was chosen as the Stock Action','','7.34'),(2468,'/admin/config/regional/language?render=overlay','default','A new custom submit function','','7.34'),(2469,'/admin/config/regional/language?render=overlay','default','Only aplicable if Custom Submit was chosen as the Stock Action','','7.34'),(2470,'/admin/config/regional/language?render=overlay','default','Clear the submit array first','','7.34'),(2471,'/admin/config/regional/language?render=overlay','default','a new of a custom validation function','','7.34'),(2472,'/admin/config/regional/language?render=overlay','default','Clear the validation array first','','7.34'),(2473,'/admin/config/regional/language?render=overlay','default','Custom URL','','7.34'),(2474,'/admin/config/regional/language?render=overlay','default','Only aplicable if URL Action was chosen as the Stock Action  (all submit and validation will be ignored). You can use the [product_id] token and [url] for a return path','','7.34'),(2475,'/admin/config/regional/language?render=overlay','default','Custom HTML','','7.34'),(2476,'/admin/config/regional/language?render=overlay','default','Only aplicable if Custom HTML was chosen as the Stock Action  (all submit and validation will be ignored). You can use the [product_id] token and [url] for a return path','','7.34'),(2477,'/admin/config/regional/language?render=overlay','default','Set the state of the checkout process (called one per an item)','','7.34'),(2478,'/admin/config/regional/language?render=overlay','default','The item to index.','','7.34'),(2479,'/admin/config/regional/language?render=overlay','default','The index on which the item should be indexed. Leave blank to index on all indexes for this item type.','','7.34'),(2480,'/admin/config/regional/language?render=overlay','default','Index immediately','','7.34'),(2481,'/admin/config/regional/language?render=overlay','default','Activate for indexing the item right away, otherwise it will only be marked as dirty and indexed during the next cron run.','','7.34'),(2482,'/admin/config/regional/language?render=overlay','default','Index an entity','','7.34'),(2483,'/admin/config/regional/language?render=overlay','default','Set a data value','','7.34'),(2484,'/admin/config/regional/language?render=overlay','default','Specifies the data to be modified using a data selector, e.g. \"node:author:name\".','','7.34'),(2485,'/admin/config/regional/language?render=overlay','default','The new value to set for the specified data.','','7.34'),(2486,'/admin/config/regional/language?render=overlay','default','Calculate a value','','7.34'),(2487,'/admin/config/regional/language?render=overlay','default','Input value 1','','7.34'),(2488,'/admin/config/regional/language?render=overlay','default','The first input value for the calculation.','','7.34'),(2489,'/admin/config/regional/language?render=overlay','default','The calculation operator.','','7.34'),(2490,'/admin/config/regional/language?render=overlay','default','Input value 2','','7.34'),(2491,'/admin/config/regional/language?render=overlay','default','The second input value.','','7.34'),(2492,'/admin/config/regional/language?render=overlay','default','Calculation result','','7.34'),(2493,'/admin/config/regional/language?render=overlay','default','Add an item to a list','','7.34'),(2494,'/admin/config/regional/language?render=overlay','default','The data list, to which an item is to be added.','','7.34'),(2495,'/admin/config/regional/language?render=overlay','default','Item to add','','7.34'),(2496,'/admin/config/regional/language?render=overlay','default','Enforce uniqueness','','7.34'),(2497,'/admin/config/regional/language?render=overlay','default','Only add the item to the list if it is not yet contained.','','7.34'),(2498,'/admin/config/regional/language?render=overlay','default','Insert position','','7.34'),(2499,'/admin/config/regional/language?render=overlay','default','Remove an item from a list','','7.34'),(2500,'/admin/config/regional/language?render=overlay','default','The data list for which an item is to be removed.','','7.34'),(2501,'/admin/config/regional/language?render=overlay','default','Item to remove','','7.34'),(2502,'/admin/config/regional/language?render=overlay','default','Add a variable','','7.34'),(2503,'/admin/config/regional/language?render=overlay','default','Specifies the type of the variable that should be added.','','7.34'),(2504,'/admin/config/regional/language?render=overlay','default','Optionally, specify the initial value of the variable.','','7.34'),(2505,'/admin/config/regional/language?render=overlay','default','Added variable','','7.34'),(2506,'/admin/config/regional/language?render=overlay','default','Convert data type','','7.34'),(2507,'/admin/config/regional/language?render=overlay','default','Target type','','7.34'),(2508,'/admin/config/regional/language?render=overlay','default','The data type to convert a value to.','','7.34'),(2509,'/admin/config/regional/language?render=overlay','default','Value to convert','','7.34'),(2510,'/admin/config/regional/language?render=overlay','default','Rounding behavior','','7.34'),(2511,'/admin/config/regional/language?render=overlay','default','The rounding behavior the conversion should use.','','7.34'),(2512,'/admin/config/regional/language?render=overlay','default','Conversion result','','7.34'),(2513,'/admin/config/regional/language?render=overlay','default','Fetch entity by id','','7.34'),(2514,'/admin/config/regional/language?render=overlay','default','Specifies the type of entity that should be fetched.','','7.34'),(2515,'/admin/config/regional/language?render=overlay','default','Identifier','','7.34'),(2516,'/admin/config/regional/language?render=overlay','default','Fetched entity','','7.34'),(2517,'/admin/config/regional/language?render=overlay','default','Fetch entity by property','','7.34'),(2518,'/admin/config/regional/language?render=overlay','default','Limit result count','','7.34'),(2519,'/admin/config/regional/language?render=overlay','default','Limit the maximum number of fetched entities.','','7.34'),(2520,'/admin/config/regional/language?render=overlay','default','Create a new entity','','7.34'),(2521,'/admin/config/regional/language?render=overlay','default','Specifies the type of the entity that should be created.','','7.34'),(2522,'/admin/config/regional/language?render=overlay','default','Created entity','','7.34'),(2523,'/admin/config/regional/language?render=overlay','default','Save entity','','7.34'),(2524,'/admin/config/regional/language?render=overlay','default','Specifies the entity, which should be saved permanently.','','7.34'),(2525,'/admin/config/regional/language?render=overlay','default','Force saving immediately','','7.34'),(2526,'/admin/config/regional/language?render=overlay','default','Usually saving is postponed till the end of the evaluation, so that multiple saves can be fold into one. If this set, saving is forced to happen immediately.','','7.34'),(2527,'/admin/config/regional/language?render=overlay','default','Delete entity','','7.34'),(2528,'/admin/config/regional/language?render=overlay','default','Specifies the entity, which should be deleted permanently.','','7.34'),(2529,'/admin/config/regional/language?render=overlay','default','Publish content','','7.34'),(2530,'/admin/config/regional/language?render=overlay','default','Unpublish content','','7.34'),(2531,'/admin/config/regional/language?render=overlay','default','Make content sticky','','7.34'),(2532,'/admin/config/regional/language?render=overlay','default','Make content unsticky','','7.34'),(2533,'/admin/config/regional/language?render=overlay','default','Promote content to front page','','7.34'),(2534,'/admin/config/regional/language?render=overlay','default','Remove content from front page','','7.34'),(2535,'/admin/config/regional/language?render=overlay','default','Change the author of content','','7.34'),(2536,'/admin/config/regional/language?render=overlay','default','Save content','','7.34'),(2537,'/admin/config/regional/language?render=overlay','default','Unpublish content containing keyword(s)','','7.34'),(2538,'/admin/config/regional/language?render=overlay','default','Show a message on the site','','7.34'),(2539,'/admin/config/regional/language?render=overlay','default','Message type','','7.34'),(2540,'/admin/config/regional/language?render=overlay','default','Repeat message','','7.34'),(2541,'/admin/config/regional/language?render=overlay','default','If disabled and the message has been already shown, then the message won\'t be repeated.','','7.34'),(2542,'/admin/config/regional/language?render=overlay','default','Page redirect','','7.34'),(2543,'/admin/config/regional/language?render=overlay','default','A Drupal path, path alias, or external URL to redirect to. Enter (optional) queries after \"?\" and (optional) anchor after \"#\".','','7.34'),(2544,'/admin/config/regional/language?render=overlay','default','Force redirect','','7.34'),(2545,'/admin/config/regional/language?render=overlay','default','Force the redirect even if another destination parameter is present. Per default Drupal would redirect to the path given as destination parameter, in case it is set. Usually the destination parameter is set by appending it to the URL, e.g. !example_url','','7.34'),(2546,'/admin/config/regional/language?render=overlay','default','Append destination parameter','','7.34'),(2547,'/admin/config/regional/language?render=overlay','default','Whether to append a destination parameter to the URL, so another redirect issued later on would lead back to the origin page.','','7.34'),(2548,'/admin/config/regional/language?render=overlay','default','Set breadcrumb','','7.34'),(2549,'/admin/config/regional/language?render=overlay','default','Titles','','7.34'),(2550,'/admin/config/regional/language?render=overlay','default','A list of titles for the breadcrumb links.','','7.34'),(2551,'/admin/config/regional/language?render=overlay','default','Paths','','7.34'),(2552,'/admin/config/regional/language?render=overlay','default','A list of Drupal paths for the breadcrumb links, matching the order of the titles.','','7.34'),(2553,'/admin/config/regional/language?render=overlay','default','To','','7.34'),(2554,'/admin/config/regional/language?render=overlay','default','The e-mail address or addresses where the message will be sent to. The formatting of this string must comply with RFC 2822.','','7.34'),(2555,'/admin/config/regional/language?render=overlay','default','The mail\'s subject.','','7.34'),(2556,'/admin/config/regional/language?render=overlay','default','The mail\'s message body.','','7.34'),(2557,'/admin/config/regional/language?render=overlay','default','From','','7.34'),(2558,'/admin/config/regional/language?render=overlay','default','The mail\'s from address. Leave it empty to use the site-wide configured address.','','7.34'),(2559,'/admin/config/regional/language?render=overlay','default','If specified, the language used for getting the mail message and subject.','','7.34'),(2560,'/admin/config/regional/language?render=overlay','default','Send mail to all users of a role','','7.34'),(2561,'/admin/config/regional/language?render=overlay','default','Select the roles whose users should receive the mail.','','7.34'),(2562,'/admin/config/regional/language?render=overlay','default','Block IP address','','7.34'),(2563,'/admin/config/regional/language?render=overlay','default','If not provided, the IP address of the current user will be used.','','7.34'),(2564,'/admin/config/regional/language?render=overlay','default','The user whose roles should be changed.','','7.34'),(2565,'/admin/config/regional/language?render=overlay','default','Add user role','','7.34'),(2566,'/admin/config/regional/language?render=overlay','default','Remove user role','','7.34'),(2567,'/admin/config/regional/language?render=overlay','default','Block a user','','7.34'),(2568,'/admin/config/regional/language?render=overlay','default','Unblock a user','','7.34'),(2569,'/admin/config/regional/language?render=overlay','default','unlabeled','','7.34'),(2570,'/admin/config/regional/language?render=overlay','default','Enter PHP code without &lt;?php ?&gt; delimiters.','','7.34'),(2571,'/admin/config/regional/language?render=overlay','default','Create or delete any URL alias','','7.34'),(2572,'/admin/config/regional/language?render=overlay','default','Specifies the existing path you wish to alias. For example: node/28, forum/1, taxonomy/term/1+2.','','7.34'),(2573,'/admin/config/regional/language?render=overlay','default','Leave it empty to delete URL aliases pointing to the given path alias.','','7.34'),(2574,'/admin/config/regional/language?render=overlay','default','Specify an alternative path by which this data can be accessed. For example, \"about\" for an about page. Use a relative path and do not add a trailing slash.','','7.34'),(2575,'/admin/config/regional/language?render=overlay','default','Leave it empty to delete URL aliases pointing to the given system path.','','7.34'),(2576,'/admin/config/regional/language?render=overlay','default','Create or delete a content\'s URL alias','','7.34'),(2577,'/admin/config/regional/language?render=overlay','default','Specify an alternative path by which the content can be accessed. For example, \"about\" for an about page. Use a relative path and do not add a trailing slash.','','7.34'),(2578,'/admin/config/regional/language?render=overlay','default','Leave it empty to delete the URL alias.','','7.34'),(2579,'/admin/config/regional/language?render=overlay','default','Create or delete a taxonomy term\'s URL alias','','7.34'),(2580,'/admin/config/regional/language?render=overlay','default','Specify an alternative path by which the term can be accessed. For example, \"content/drupal\" for a Drupal term. Use a relative path and do not add a trailing slash.','','7.34'),(2581,'/admin/config/regional/language?render=overlay','default','Debug value','','7.34'),(2582,'/admin/config/regional/language?render=overlay','default','Devel','','7.34'),(2583,'/admin/config/regional/language?render=overlay','default','Value to debug','','7.34'),(2584,'/admin/config/regional/language?render=overlay','default','Current list item','','7.34'),(2585,'/admin/config/regional/language?render=overlay','default','Tokens related to %label Rules variables.','','7.34'),(2586,'/admin/config/regional/language?render=overlay','default','The value of the variable.','','7.34'),(2587,'/admin/config/regional/language?render=overlay','default','Tokens related to the current date and time.','','7.34'),(2588,'/admin/config/regional/language?render=overlay','default','Original @entity','','7.34'),(2589,'/admin/config/regional/language?render=overlay','default','The original @entity data if the @entity is being updated or saved.','','7.34'),(2590,'/admin/config/regional/language?render=overlay','default','The URL of the @entity.','','7.34'),(2591,'/admin/config/regional/language?render=overlay','default','The method_id of the payment method selected by the customer during checkout.','','7.34'),(2592,'/admin/config/regional/language?render=overlay','default','The administrative title of the payment method selected by the customer during checkout.','','7.34'),(2593,'/admin/config/regional/language?render=overlay','default','The customer oriented short title of the payment method selected by the customer during checkout.','','7.34'),(2594,'/admin/config/regional/language?render=overlay','default','The following properties may be appended to the token: @keys','','7.34'),(2595,'/admin/config/regional/language?render=overlay','default','List of @entities','','7.34'),(2596,'/admin/config/regional/language?render=overlay','default','Tokens related to the \"@name\" entities.','','7.34'),(2597,'/admin/config/regional/language?render=overlay','default','@type with delta @delta','','7.34'),(2598,'/admin/config/regional/language?render=overlay','default','The list item with delta @delta. Delta values start from 0 and are incremented by one per list item.','','7.34'),(2599,'/admin/config/regional/language?render=overlay','default','List of @type values','','7.34'),(2600,'/admin/config/regional/language?render=overlay','default','Tokens for lists of @type values.','','7.34'),(2601,'/admin/config/regional/language?render=overlay','default','Rendered submissions','','7.34'),(2602,'/admin/config/regional/language?render=overlay','default','Display the rendered submission','','7.34'),(2603,'/admin/config/regional/language?render=overlay','default','Better Exposed Filters','','7.34'),(2604,'/admin/config/regional/language?render=overlay','default','Allow use of checkboxes/radio buttons for exposed filters','','7.34'),(2605,'/admin/config/regional/language?render=overlay','default','Display the comment with standard comment view.','','7.34'),(2606,'/admin/config/regional/language?render=overlay','default','Display the comment as RSS.','','7.34'),(2607,'/admin/config/regional/language?render=overlay','default','Current user\'s cart order ID','','7.34'),(2608,'/admin/config/regional/language?render=overlay','default','Current user or role','','7.34'),(2609,'/admin/config/regional/language?render=overlay','default','Renders a single entity in a specific view mode (e.g. teaser).','','7.34'),(2610,'/admin/config/regional/language?render=overlay','default','Entity Reference Source','','7.34'),(2611,'/admin/config/regional/language?render=overlay','default','Entity Reference list','','7.34'),(2612,'/admin/config/regional/language?render=overlay','default','Inline fields','','7.34'),(2613,'/admin/config/regional/language?render=overlay','default','Displays the fields with an optional template.','','7.34'),(2614,'/admin/config/regional/language?render=overlay','default','jCarousel','','7.34'),(2615,'/admin/config/regional/language?render=overlay','default','Display rows in a carousel via jCarousel.','','7.34'),(2616,'/admin/config/regional/language?render=overlay','default','Display the content with standard node view.','','7.34'),(2617,'/admin/config/regional/language?render=overlay','default','Content ID from URL','','7.34'),(2618,'/admin/config/regional/language?render=overlay','default','Search API Query','','7.34'),(2619,'/admin/config/regional/language?render=overlay','default','Query will be generated and run using the Search API.','','7.34'),(2620,'/admin/config/regional/language?render=overlay','default','Search-specific','','7.34'),(2621,'/admin/config/regional/language?render=overlay','default','Cache Search API views. (Other methods probably won\'t work with search views.)','','7.34'),(2622,'/admin/config/regional/language?render=overlay','default','Facets block','','7.34'),(2623,'/admin/config/regional/language?render=overlay','default','Display facets for this search as a block anywhere on the site.','','7.34'),(2624,'/admin/config/regional/language?render=overlay','default','Taxonomy term ID from URL','','7.34'),(2625,'/admin/config/regional/language?render=overlay','default','Display the user with standard user view.','','7.34'),(2626,'/admin/config/regional/language?render=overlay','default','User ID from URL','','7.34'),(2627,'/admin/config/regional/language?render=overlay','default','User ID from logged in user','','7.34'),(2628,'/admin/config/regional/language?render=overlay','default','Bootstrap Carousel','','7.34'),(2629,'/admin/config/regional/language?render=overlay','default','Bootstrap Carousel Style','','7.34'),(2630,'/admin/config/regional/language?render=overlay','default','Bootstrap Thumbnails','','7.34'),(2631,'/admin/config/regional/language?render=overlay','default','Bootstrap Thumbnails Style','','7.34'),(2632,'/admin/config/regional/language?render=overlay','default','Bootstrap Grid','','7.34'),(2633,'/admin/config/regional/language?render=overlay','default','Bootstrap Grid Style','','7.34'),(2634,'/admin/config/regional/language?render=overlay','default','Bootstrap Accordion','','7.34'),(2635,'/admin/config/regional/language?render=overlay','default','Bootstrap Accordion Style','','7.34'),(2636,'/admin/config/regional/language?render=overlay','default','Bootstrap Tab','','7.34'),(2637,'/admin/config/regional/language?render=overlay','default','Bootstrap Tab Style','','7.34'),(2638,'/admin/config/regional/language?render=overlay','default','Bootstrap Media Object','','7.34'),(2639,'/admin/config/regional/language?render=overlay','default','Bootstrap Media Object Style','','7.34'),(2640,'/admin/config/regional/language?render=overlay','default','Bootstrap Table','','7.34'),(2641,'/admin/config/regional/language?render=overlay','default','Displays rows in Bootstrap Table Style','','7.34'),(2642,'/admin/config/regional/language?render=overlay','default','Choose the fields to display in Bootstrap Carousel Style.','','7.34'),(2643,'/admin/config/regional/language?render=overlay','default','Bootstrap Thumbnail','','7.34'),(2644,'/admin/config/regional/language?render=overlay','default','Choose the fields to display in Bootstrap Thumbnail Style.','','7.34'),(2645,'/admin/config/regional/language?render=overlay','default','Views fieldsets options','','7.34'),(2646,'/admin/config/regional/language?render=overlay','default','A way to export Views Fieldsets.','','7.34'),(2647,'/admin/config/regional/language?render=overlay','default','Display the results as a slideshow.','','7.34'),(2648,'/admin/config/regional/language?render=overlay','default','Master','','7.34'),(2649,'/admin/config/regional/language?render=overlay','default','Default settings for this view.','','7.34'),(2650,'/admin/config/regional/language?render=overlay','default','Page','','7.34'),(2651,'/admin/config/regional/language?render=overlay','default','Display the view as a page, with a URL and menu links.','','7.34'),(2652,'/admin/config/regional/language?render=overlay','default','Display the view as a block.','','7.34'),(2653,'/admin/config/regional/language?render=overlay','default','Attachment','','7.34'),(2654,'/admin/config/regional/language?render=overlay','default','Attachments added to other displays to achieve multiple views in the same view.','','7.34'),(2655,'/admin/config/regional/language?render=overlay','default','Feed','','7.34'),(2656,'/admin/config/regional/language?render=overlay','default','Display the view as a feed, such as an RSS feed.','','7.34'),(2657,'/admin/config/regional/language?render=overlay','default','Embed','','7.34'),(2658,'/admin/config/regional/language?render=overlay','default','Provide a display which can be embedded using the views api.','','7.34'),(2659,'/admin/config/regional/language?render=overlay','default','Empty display extender','','7.34'),(2660,'/admin/config/regional/language?render=overlay','default','Unformatted list','','7.34'),(2661,'/admin/config/regional/language?render=overlay','default','Displays rows one after another.','','7.34'),(2662,'/admin/config/regional/language?render=overlay','default','HTML list','','7.34'),(2663,'/admin/config/regional/language?render=overlay','default','Displays rows as an HTML list.','','7.34'),(2664,'/admin/config/regional/language?render=overlay','default','Grid','','7.34'),(2665,'/admin/config/regional/language?render=overlay','default','Displays rows in a grid.','','7.34'),(2666,'/admin/config/regional/language?render=overlay','default','Displays rows in a table.','','7.34'),(2667,'/admin/config/regional/language?render=overlay','default','Displays the default summary as a list.','','7.34'),(2668,'/admin/config/regional/language?render=overlay','default','Displays the summary unformatted, with option for one after another or inline.','','7.34'),(2669,'/admin/config/regional/language?render=overlay','default','RSS Feed','','7.34'),(2670,'/admin/config/regional/language?render=overlay','default','Generates an RSS feed from a view.','','7.34'),(2671,'/admin/config/regional/language?render=overlay','default','Fields','','7.34'),(2672,'/admin/config/regional/language?render=overlay','default','Display fields as RSS items.','','7.34'),(2673,'/admin/config/regional/language?render=overlay','default','Fixed value','','7.34'),(2674,'/admin/config/regional/language?render=overlay','default','PHP Code','','7.34'),(2675,'/admin/config/regional/language?render=overlay','default','Raw value from URL','','7.34'),(2676,'/admin/config/regional/language?render=overlay','default','Numeric','','7.34'),(2677,'/admin/config/regional/language?render=overlay','default','None','','7.34'),(2678,'/admin/config/regional/language?render=overlay','default','Will be available to all users.','','7.34'),(2679,'/admin/config/regional/language?render=overlay','default','Role','','7.34'),(2680,'/admin/config/regional/language?render=overlay','default','Access will be granted to users with any of the specified roles.','','7.34'),(2681,'/admin/config/regional/language?render=overlay','default','Access will be granted to users with the specified permission string.','','7.34'),(2682,'/admin/config/regional/language?render=overlay','default','SQL Query','','7.34'),(2683,'/admin/config/regional/language?render=overlay','default','Query will be generated and run using the Drupal database API.','','7.34'),(2684,'/admin/config/regional/language?render=overlay','default','No caching of Views data.','','7.34'),(2685,'/admin/config/regional/language?render=overlay','default','Time-based','','7.34'),(2686,'/admin/config/regional/language?render=overlay','default','Simple time-based caching of data.','','7.34'),(2687,'/admin/config/regional/language?render=overlay','default','Basic exposed form','','7.34'),(2688,'/admin/config/regional/language?render=overlay','default','Input required','','7.34'),(2689,'/admin/config/regional/language?render=overlay','default','An exposed form that only renders a view if the form contains user input.','','7.34'),(2690,'/admin/config/regional/language?render=overlay','default','Display all items','','7.34'),(2691,'/admin/config/regional/language?render=overlay','default','Display all items that this view might find','','7.34'),(2692,'/admin/config/regional/language?render=overlay','default','Display a specified number of items','','7.34'),(2693,'/admin/config/regional/language?render=overlay','default','Display a limited number items that this view might find.','','7.34'),(2694,'/admin/config/regional/language?render=overlay','default','Paged output, full pager','','7.34'),(2695,'/admin/config/regional/language?render=overlay','default','Full','','7.34'),(2696,'/admin/config/regional/language?render=overlay','default','Paged output, full Drupal style','','7.34'),(2697,'/admin/config/regional/language?render=overlay','default','Paged output, mini pager','','7.34'),(2698,'/admin/config/regional/language?render=overlay','default','Mini','','7.34'),(2699,'/admin/config/regional/language?render=overlay','default','Use the mini pager output.','','7.34'),(2700,'/admin/config/regional/language?render=overlay','default','Do not pass admin strings for translation.','','7.34'),(2701,'/admin/config/regional/language?render=overlay','default','Core','','7.34'),(2702,'/admin/config/regional/language?render=overlay','default','Use Drupal core t() function. Not recommended, as it doesn\'t support updates to existing strings.','','7.34'),(2703,'/admin/config/regional/language?render=overlay','default','If you need to translate Views labels into other languages, consider installing the <a href=\"!path\">Internationalization</a> package\'s Views translation module.','','7.34'),(2704,'/admin/config/regional/language?render=overlay','default','Jump menu','','7.34'),(2705,'/admin/config/regional/language?render=overlay','default','Puts all of the results into a select box and allows the user to go to a different page based upon the results.','','7.34'),(2706,'/admin/config/regional/language?render=overlay','default','more','','7.34'),(2707,'/admin/config/regional/language?render=overlay','default','fields','','7.34'),(2708,'/admin/config/regional/language?render=overlay','default','Contextual filters','','7.34'),(2709,'/admin/config/regional/language?render=overlay','default','contextual filters','','7.34'),(2710,'/admin/config/regional/language?render=overlay','default','Contextual filter','','7.34'),(2711,'/admin/config/regional/language?render=overlay','default','contextual filter','','7.34'),(2712,'/admin/config/regional/language?render=overlay','default','Sort criteria','','7.34'),(2713,'/admin/config/regional/language?render=overlay','default','sort criteria','','7.34'),(2714,'/admin/config/regional/language?render=overlay','default','Sort criterion','','7.34'),(2715,'/admin/config/regional/language?render=overlay','default','sort criterion','','7.34'),(2716,'/admin/config/regional/language?render=overlay','default','Filter criteria','','7.34'),(2717,'/admin/config/regional/language?render=overlay','default','filter criteria','','7.34'),(2718,'/admin/config/regional/language?render=overlay','default','Filter criterion','','7.34'),(2719,'/admin/config/regional/language?render=overlay','default','filter criterion','','7.34'),(2720,'/admin/config/regional/language?render=overlay','default','Relationships','','7.34'),(2721,'/admin/config/regional/language?render=overlay','default','relationships','','7.34'),(2722,'/admin/config/regional/language?render=overlay','default','Relationship','','7.34'),(2723,'/admin/config/regional/language?render=overlay','default','Header','','7.34'),(2724,'/admin/config/regional/language?render=overlay','default','header','','7.34'),(2725,'/admin/config/regional/language?render=overlay','default','Footer','','7.34'),(2726,'/admin/config/regional/language?render=overlay','default','footer','','7.34'),(2727,'/admin/config/regional/language?render=overlay','default','No results behavior','','7.34'),(2728,'/admin/config/regional/language?render=overlay','default','no results behavior','','7.34'),(2729,'/admin/config/regional/language?render=overlay','default','Order number','','7.34'),(2730,'/admin/config/regional/language?render=overlay','default','Total','','7.34'),(2731,'/admin/config/regional/language?render=overlay','default','Options','','7.34'),(2732,'/admin/config/regional/language?render=overlay','default','You have not placed any orders with us yet.','','7.34'),(2733,'/admin/config/regional/language?render=overlay','default','Display all results for the specified field','','7.34'),(2734,'/admin/config/regional/language?render=overlay','default','Provide default value','','7.34'),(2735,'/admin/config/regional/language?render=overlay','default','Hide view','','7.34'),(2736,'/admin/config/regional/language?render=overlay','default','Display a summary','','7.34'),(2737,'/admin/config/regional/language?render=overlay','default','Display contents of \"No results found\"','','7.34'),(2738,'/admin/config/regional/language?render=overlay','default','Display \"Access Denied\"','','7.34'),(2739,'/admin/config/regional/language?render=overlay','default','Show \"Page not found\"','','7.34'),(2740,'/admin/config/regional/language?render=overlay','default','Stores','','7.34'),(2741,'/admin/config/regional/language?render=overlay','default','@name\'s funds account','','7.34'),(2742,'/admin/config/regional/language?render=overlay','default','Add to %shortcut_set shortcuts','','7.34'),(2743,'/admin/config/regional/language?render=overlay','default','You are here','','7.34'),(2744,'/admin/config/regional/language?render=overlay','default','Status message','','7.34'),(2745,'/admin/config/regional/language?render=overlay','default','Error message','','7.34'),(2746,'/admin/config/regional/language?render=overlay','default','Warning message','','7.34'),(2747,'/admin/config/regional/language?render=overlay','default','Enable !title','','7.34'),(2748,'/admin/config/regional/language?render=overlay','default','Set !title as default','','7.34'),(2749,'/admin/config/regional/language?render=overlay','default','!title !required','','7.34'),(2750,'/admin/config/regional/language?render=overlay','default','Choose some options','','7.34'),(2751,'/admin/config/regional/language?render=overlay','default','Choose an option','','7.34'),(2752,'/admin/config/regional/language?render=overlay','default','No results match','','7.34'),(2753,'/admin/config/regional/language?render=overlay','default','edit','','7.34'),(2754,'/admin/config/regional/language?render=overlay','default','English name','','7.34'),(2755,'/admin/config/regional/language?render=overlay','default','Native name','','7.34'),(2756,'/admin/config/regional/language?render=overlay','default','Code','','7.34'),(2757,'/admin/config/regional/language?render=overlay','default','Direction','','7.34'),(2758,'/admin/config/regional/language?render=overlay','default','Operations','','7.34'),(2759,'/admin/config/regional/language?render=overlay','default','If you have problems accessing administrative pages on this site, disable the overlay on your profile page.','','7.34'),(2760,'/admin/config/regional/language?render=overlay','default','Dismiss this message.','','7.34'),(2761,'/admin/config/regional/language?render=overlay','default','Options for the administrative overlay','','7.34'),(2762,'/admin/config/regional/language?render=overlay','default','Close overlay','','7.34'),(2763,'/admin/config/regional/language?render=overlay','default','Primary tabs','','7.34'),(2764,'/admin/config/regional/language?render=overlay','default','!local-task-title!active','','7.34'),(2765,'/admin/config/regional/language?render=overlay','default','Skip to main content','','7.34'),(2766,'/','default','','','7.34'),(2767,'/','default','Related Products','','7.34'),(2768,'/','default','Front page feed','','7.34'),(2769,'/','default','Group results together','','7.34'),(2770,'/','default','Count DISTINCT','','7.34'),(2771,'/','default','Sum','','7.34'),(2772,'/','default','Average','','7.34'),(2773,'/','default','Minimum','','7.34'),(2774,'/','default','Maximum','','7.34'),(2775,'/','default','Standard deviation','','7.34'),(2776,'/','default','True','','7.34'),(2777,'/','default','Products referenced by field_product','','7.34'),(2778,'/','default','Is one of','','7.34'),(2779,'/','default','in','','7.34'),(2780,'/','default','=','','7.34'),(2781,'/','default','Is not one of','','7.34'),(2782,'/','default','not in','','7.34'),(2783,'/','default','<>','','7.34'),(2784,'/','default','Is empty (NULL)','','7.34'),(2785,'/','default','empty','','7.34'),(2786,'/','default','Is not empty (NOT NULL)','','7.34'),(2787,'/','default','not empty','','7.34'),(2788,'/','default','<a href=\"[path]\" title=\"[field_product_image-title]\">[field_product_image]</a>','','7.34'),(2789,'/','default','Review','','7.34'),(2790,'/','default','Subscribe to !feed-title','','7.34'),(2791,'/','default','Limit allowed HTML tags','','7.34'),(2792,'/','default','Convert line breaks into HTML (i.e. <code>&lt;br&gt;</code> and <code>&lt;p&gt;</code>)','','7.34'),(2793,'/','default','Convert URLs into links','','7.34'),(2794,'/','default','Correct faulty and chopped off HTML','','7.34'),(2795,'/','default','Display any HTML as plain text','','7.34'),(2796,'/','default','PHP evaluator','','7.34'),(2797,'/','default','Executes a piece of PHP code. The usage of this filter should be restricted to administrators only!','','7.34'),(2798,'/','default','Apply','','7.34'),(2799,'/','default','Reset','','7.34'),(2800,'/','default','Sort by','','7.34'),(2801,'/','default','Asc','','7.34'),(2802,'/','default','Desc','','7.34'),(2803,'/','default','Product Teaser','','7.34'),(2804,'/','default','Your Recently Viewed Items','','7.34'),(2805,'/','default','Best sellers','','7.34'),(2806,'/','default','Recommended for you','','7.34'),(2807,'/','default','Brand','','7.34'),(2808,'/','default','<span>by </span>[field_brand]','','7.34'),(2809,'/','default','Old Price','','7.34'),(2810,'/','default','Discount Percentage','','7.34'),(2811,'/','default','Average: !stars','','7.34'),(2812,'/','default','No votes yet','','7.34'),(2813,'/','default','United Arab Emirates Dirham','','7.34'),(2814,'/','default','Fils','','7.34'),(2815,'/','default','Dirham','','7.34'),(2816,'/','default','Afghan Afghani','','7.34'),(2817,'/','default','Pul','','7.34'),(2818,'/','default','Afghani','','7.34'),(2819,'/','default','Netherlands Antillean Guilder','','7.34'),(2820,'/','default','Cent','','7.34'),(2821,'/','default','Guilder','','7.34'),(2822,'/','default','Angolan Kwanza','','7.34'),(2823,'/','default','Cêntimo','','7.34'),(2824,'/','default','Kwanza','','7.34'),(2825,'/','default','Argentine Peso Moneda Nacional','','7.34'),(2826,'/','default','Centavos','','7.34'),(2827,'/','default','Peso','','7.34'),(2828,'/','default','Argentine Peso','','7.34'),(2829,'/','default','Centavo','','7.34'),(2830,'/','default','Australian Dollar','','7.34'),(2831,'/','default','Dollar','','7.34'),(2832,'/','default','Aruban Florin','','7.34'),(2833,'/','default','Azerbaijanian Manat','','7.34'),(2834,'/','default','Qəpik','','7.34'),(2835,'/','default','New Manat','','7.34'),(2836,'/','default','Bosnia-Herzegovina Convertible Mark','','7.34'),(2837,'/','default','Fening','','7.34'),(2838,'/','default','Convertible Marka','','7.34'),(2839,'/','default','Barbadian Dollar','','7.34'),(2840,'/','default','Bangladeshi Taka','','7.34'),(2841,'/','default','Paisa','','7.34'),(2842,'/','default','Taka','','7.34'),(2843,'/','default','Bulgarian lev','','7.34'),(2844,'/','default','Stotinka','','7.34'),(2845,'/','default','Lev','','7.34'),(2846,'/','default','Bahraini Dinar','','7.34'),(2847,'/','default','Dinar','','7.34'),(2848,'/','default','Burundian Franc','','7.34'),(2849,'/','default','Centime','','7.34'),(2850,'/','default','Franc','','7.34'),(2851,'/','default','Bermudan Dollar','','7.34'),(2852,'/','default','Brunei Dollar','','7.34'),(2853,'/','default','Sen','','7.34'),(2854,'/','default','Bolivian Boliviano','','7.34'),(2855,'/','default','Bolivianos','','7.34'),(2856,'/','default','Brazilian Real','','7.34'),(2857,'/','default','Reais','','7.34'),(2858,'/','default','Bahamian Dollar','','7.34'),(2859,'/','default','Bhutanese Ngultrum','','7.34'),(2860,'/','default','Chetrum','','7.34'),(2861,'/','default','Ngultrum','','7.34'),(2862,'/','default','Botswanan Pula','','7.34'),(2863,'/','default','Thebe','','7.34'),(2864,'/','default','Pulas','','7.34'),(2865,'/','default','Belarusian ruble','','7.34'),(2866,'/','default','Ruble','','7.34'),(2867,'/','default','Belize Dollar','','7.34'),(2868,'/','default','Canadian Dollar','','7.34'),(2869,'/','default','Congolese Franc','','7.34'),(2870,'/','default','Swiss Franc','','7.34'),(2871,'/','default','Rappen','','7.34'),(2872,'/','default','Chilean Peso','','7.34'),(2873,'/','default','Chinese Yuan Renminbi','','7.34'),(2874,'/','default','Fen','','7.34'),(2875,'/','default','Yuan','','7.34'),(2876,'/','default','Colombian Peso','','7.34'),(2877,'/','default','Costa Rican Colón','','7.34'),(2878,'/','default','Céntimo','','7.34'),(2879,'/','default','Colón','','7.34'),(2880,'/','default','Cuban Convertible Peso','','7.34'),(2881,'/','default','Cuban Peso','','7.34'),(2882,'/','default','Cape Verdean Escudo','','7.34'),(2883,'/','default','Escudo','','7.34'),(2884,'/','default','Czech Republic Koruna','','7.34'),(2885,'/','default','Haléř','','7.34'),(2886,'/','default','Koruna','','7.34'),(2887,'/','default','Djiboutian Franc','','7.34'),(2888,'/','default','Danish Krone','','7.34'),(2889,'/','default','Øre','','7.34'),(2890,'/','default','Kroner','','7.34'),(2891,'/','default','Dominican Peso','','7.34'),(2892,'/','default','Algerian Dinar','','7.34'),(2893,'/','default','Santeem','','7.34'),(2894,'/','default','Estonian Kroon','','7.34'),(2895,'/','default','Sent','','7.34'),(2896,'/','default','Krooni','','7.34'),(2897,'/','default','Egyptian Pound','','7.34'),(2898,'/','default','Piastr','','7.34'),(2899,'/','default','Pound','','7.34'),(2900,'/','default','Eritrean Nakfa','','7.34'),(2901,'/','default','Nakfa','','7.34'),(2902,'/','default','Ethiopian Birr','','7.34'),(2903,'/','default','Santim','','7.34'),(2904,'/','default','Birr','','7.34'),(2905,'/','default','Euro','','7.34'),(2906,'/','default','Fijian Dollar','','7.34'),(2907,'/','default','Falkland Islands Pound','','7.34'),(2908,'/','default','Penny','','7.34'),(2909,'/','default','British Pound Sterling','','7.34'),(2910,'/','default','Ghanaian Cedi','','7.34'),(2911,'/','default','Pesewa','','7.34'),(2912,'/','default','Cedi','','7.34'),(2913,'/','default','Gibraltar Pound','','7.34'),(2914,'/','default','Gambian Dalasi','','7.34'),(2915,'/','default','Butut','','7.34'),(2916,'/','default','Dalasis','','7.34'),(2917,'/','default','Guinean Franc','','7.34'),(2918,'/','default','Guatemalan Quetzal','','7.34'),(2919,'/','default','Quetzales','','7.34'),(2920,'/','default','Guyanaese Dollar','','7.34'),(2921,'/','default','Hong Kong Dollar','','7.34'),(2922,'/','default','Honduran Lempira','','7.34'),(2923,'/','default','Lempiras','','7.34'),(2924,'/','default','Croatian Kuna','','7.34'),(2925,'/','default','Lipa','','7.34'),(2926,'/','default','Kuna','','7.34'),(2927,'/','default','Haitian Gourde','','7.34'),(2928,'/','default','Gourde','','7.34'),(2929,'/','default','Hungarian Forint','','7.34'),(2930,'/','default','Forint','','7.34'),(2931,'/','default','Indonesian Rupiah','','7.34'),(2932,'/','default','Rupiahs','','7.34'),(2933,'/','default','Israeli New Shekel','','7.34'),(2934,'/','default','Agora','','7.34'),(2935,'/','default','New Shekels','','7.34'),(2936,'/','default','Indian Rupee','','7.34'),(2937,'/','default','Rupee','','7.34'),(2938,'/','default','Iranian Rial','','7.34'),(2939,'/','default','Rial','','7.34'),(2940,'/','default','Toman','','7.34'),(2941,'/','default','Icelandic Króna','','7.34'),(2942,'/','default','Eyrir','','7.34'),(2943,'/','default','Kronur','','7.34'),(2944,'/','default','Jamaican Dollar','','7.34'),(2945,'/','default','Jordanian Dinar','','7.34'),(2946,'/','default','Japanese Yen','','7.34'),(2947,'/','default','Yen','','7.34'),(2948,'/','default','Kenyan Shilling','','7.34'),(2949,'/','default','Shilling','','7.34'),(2950,'/','default','Kyrgyzstani Som','','7.34'),(2951,'/','default','Som','','7.34'),(2952,'/','default','Tyiyn','','7.34'),(2953,'/','default','Comorian Franc','','7.34'),(2954,'/','default','South Korean Won','','7.34'),(2955,'/','default','Jeon','','7.34'),(2956,'/','default','Won','','7.34'),(2957,'/','default','Kuwaiti Dinar','','7.34'),(2958,'/','default','Cayman Islands Dollar','','7.34'),(2959,'/','default','Kazakhstani tenge','','7.34'),(2960,'/','default','Tiyn','','7.34'),(2961,'/','default','Tenge','','7.34'),(2962,'/','default','Laotian Kip','','7.34'),(2963,'/','default','Att','','7.34'),(2964,'/','default','Kips','','7.34'),(2965,'/','default','Lebanese Pound','','7.34'),(2966,'/','default','Piastre','','7.34'),(2967,'/','default','Sri Lanka Rupee','','7.34'),(2968,'/','default','Liberian Dollar','','7.34'),(2969,'/','default','Lesotho Loti','','7.34'),(2970,'/','default','Sente','','7.34'),(2971,'/','default','Loti','','7.34'),(2972,'/','default','Lithuanian Litas','','7.34'),(2973,'/','default','Centas','','7.34'),(2974,'/','default','Litai','','7.34'),(2975,'/','default','Latvian Lats','','7.34'),(2976,'/','default','Santims','','7.34'),(2977,'/','default','Lati','','7.34'),(2978,'/','default','Libyan Dinar','','7.34'),(2979,'/','default','Moroccan Dirham','','7.34'),(2980,'/','default','Santimat','','7.34'),(2981,'/','default','Dirhams','','7.34'),(2982,'/','default','Moldovan leu','','7.34'),(2983,'/','default','bani','','7.34'),(2984,'/','default','Lei','','7.34'),(2985,'/','default','Macedonian denar','','7.34'),(2986,'/','default','Deni','','7.34'),(2987,'/','default','Denari','','7.34'),(2988,'/','default','Myanma Kyat','','7.34'),(2989,'/','default','Pya','','7.34'),(2990,'/','default','Kyat','','7.34'),(2991,'/','default','Mongolian Tugrik','','7.34'),(2992,'/','default','Möngö','','7.34'),(2993,'/','default','Tugriks','','7.34'),(2994,'/','default','Macanese Pataca','','7.34'),(2995,'/','default','Avo','','7.34'),(2996,'/','default','Pataca','','7.34'),(2997,'/','default','Mauritanian Ouguiya','','7.34'),(2998,'/','default','Khoums','','7.34'),(2999,'/','default','Ouguiya','','7.34'),(3000,'/','default','Maltese Pound','','7.34'),(3001,'/','default','Mauritian Rupee','','7.34'),(3002,'/','default','Mexican Peso','','7.34'),(3003,'/','default','Malaysian Ringgit','','7.34'),(3004,'/','default','Ringgits','','7.34'),(3005,'/','default','Mozambican Metical','','7.34'),(3006,'/','default','Metical','','7.34'),(3007,'/','default','Namibian Dollar','','7.34'),(3008,'/','default','Nigerian Naira','','7.34'),(3009,'/','default','Kobo','','7.34'),(3010,'/','default','Naira','','7.34'),(3011,'/','default','Nicaraguan Cordoba Oro','','7.34'),(3012,'/','default','Cordoba','','7.34'),(3013,'/','default','Norwegian Krone','','7.34'),(3014,'/','default','Krone','','7.34'),(3015,'/','default','Nepalese Rupee','','7.34'),(3016,'/','default','New Zealand Dollar','','7.34'),(3017,'/','default','Panamanian Balboa','','7.34'),(3018,'/','default','Centésimo','','7.34'),(3019,'/','default','Balboa','','7.34'),(3020,'/','default','Peruvian Nuevo Sol','','7.34'),(3021,'/','default','Nuevos Sole','','7.34'),(3022,'/','default','Papua New Guinean Kina','','7.34'),(3023,'/','default','Toea','','7.34'),(3024,'/','default','Kina ','','7.34'),(3025,'/','default','Philippine Peso','','7.34'),(3026,'/','default','Pakistani Rupee','','7.34'),(3027,'/','default','Polish Złoty','','7.34'),(3028,'/','default','Grosz','','7.34'),(3029,'/','default','Złotych','','7.34'),(3030,'/','default','Paraguayan Guarani','','7.34'),(3031,'/','default','Guarani','','7.34'),(3032,'/','default','Qatari Rial','','7.34'),(3033,'/','default','Rhodesian Dollar','','7.34'),(3034,'/','default','Romanian Leu','','7.34'),(3035,'/','default','Ban','','7.34'),(3036,'/','default','Leu','','7.34'),(3037,'/','default','Serbian Dinar','','7.34'),(3038,'/','default','Para','','7.34'),(3039,'/','default','Dinars','','7.34'),(3040,'/','default','Russian Ruble','','7.34'),(3041,'/','default','Kopek','','7.34'),(3042,'/','default','Saudi Riyal','','7.34'),(3043,'/','default','Hallallah','','7.34'),(3044,'/','default','Riyals','','7.34'),(3045,'/','default','Solomon Islands Dollar','','7.34'),(3046,'/','default','Seychellois Rupee','','7.34'),(3047,'/','default','Old Sudanese Dinar','','7.34'),(3048,'/','default','Swedish Krona','','7.34'),(3049,'/','default','Öre','','7.34'),(3050,'/','default','Kronor','','7.34'),(3051,'/','default','Singapore Dollar','','7.34'),(3052,'/','default','Saint Helena Pound','','7.34'),(3053,'/','default','Sierra Leonean Leone','','7.34'),(3054,'/','default','Leone','','7.34'),(3055,'/','default','Somali Shilling','','7.34'),(3056,'/','default','Surinamese Dollar','','7.34'),(3057,'/','default','Suriname Guilder','','7.34'),(3058,'/','default','São Tomé and Príncipe Dobra','','7.34'),(3059,'/','default','Dobra','','7.34'),(3060,'/','default','Syrian Pound','','7.34'),(3061,'/','default','Swazi Lilangeni','','7.34'),(3062,'/','default','Lilangeni','','7.34'),(3063,'/','default','Thai Baht','','7.34'),(3064,'/','default','Satang','','7.34'),(3065,'/','default','Baht','','7.34'),(3066,'/','default','Tunisian Dinar','','7.34'),(3067,'/','default','Millime','','7.34'),(3068,'/','default','Tongan Paʻanga','','7.34'),(3069,'/','default','Senit','','7.34'),(3070,'/','default','Paʻanga','','7.34'),(3071,'/','default','Turkish Lira','','7.34'),(3072,'/','default','Kurus','','7.34'),(3073,'/','default','Lira','','7.34'),(3074,'/','default','Trinidad and Tobago Dollar','','7.34'),(3075,'/','default','New Taiwan Dollar','','7.34'),(3076,'/','default','New Dollar','','7.34'),(3077,'/','default','Tanzanian Shilling','','7.34'),(3078,'/','default','Senti','','7.34'),(3079,'/','default','Ukrainian Hryvnia','','7.34'),(3080,'/','default','Kopiyka','','7.34'),(3081,'/','default','Hryvnia','','7.34'),(3082,'/','default','Ugandan Shilling','','7.34'),(3083,'/','default','United States Dollar','','7.34'),(3084,'/','default','Uruguayan Peso','','7.34'),(3085,'/','default','Venezuelan Bolívar Fuerte','','7.34'),(3086,'/','default','Bolivares Fuerte','','7.34'),(3087,'/','default','Vietnamese Dong','','7.34'),(3088,'/','default','Hà','','7.34'),(3089,'/','default','Dong','','7.34'),(3090,'/','default','Vanuatu Vatu','','7.34'),(3091,'/','default','Vatu','','7.34'),(3092,'/','default','Samoan Tala','','7.34'),(3093,'/','default','Sene','','7.34'),(3094,'/','default','Tala','','7.34'),(3095,'/','default','CFA Franc BEAC','','7.34'),(3096,'/','default','East Caribbean Dollar','','7.34'),(3097,'/','default','CFA Franc BCEAO','','7.34'),(3098,'/','default','CFP Franc','','7.34'),(3099,'/','default','Yemeni Rial','','7.34'),(3100,'/','default','South African Rand','','7.34'),(3101,'/','default','Rand','','7.34'),(3102,'/','default','Zambian Kwacha','','7.34'),(3103,'/','default','Ngwee','','7.34'),(3104,'/','default','Kwacha','','7.34'),(3105,'/','default','@code_before@code_spacer@negative@symbol_before@price@symbol_spacer@symbol_after@code_spacer@code_after','','7.34'),(3106,'/','default','Resize','','7.34'),(3107,'/','default','Resizing will make images an exact set of dimensions. This may cause images to be stretched or shrunk disproportionately.','','7.34'),(3108,'/','default','Scale','','7.34'),(3109,'/','default','Scaling will maintain the aspect-ratio of the original image. If only a single dimension is specified, the other dimension will be calculated.','','7.34'),(3110,'/','default','Scale and crop','','7.34'),(3111,'/','default','Scale and crop will maintain the aspect-ratio of the original image, then crop the larger dimension. This is most useful for creating perfectly square thumbnails without stretching the image.','','7.34'),(3112,'/','default','Crop','','7.34'),(3113,'/','default','Cropping will remove portions of an image to make it the specified dimensions.','','7.34'),(3114,'/','default','Desaturate','','7.34'),(3115,'/','default','Desaturate converts an image to grayscale.','','7.34'),(3116,'/','default','Rotate','','7.34'),(3117,'/','default','Rotating an image may cause the dimensions of an image to increase to fit the diagonal.','','7.34'),(3118,'/','default','Fieldset','views_fieldsets','7.34'),(3119,'/','default','...','','7.34'),(3120,'/','default','Headline','','7.34'),(3121,'/','default','Main Menu','','7.34'),(3122,'/','default','Sidebar first','','7.34'),(3123,'/','default','Sidebar second','','7.34'),(3124,'/','default','Menu Top','','7.34'),(3125,'/','default','Panel Mobile Menu','','7.34'),(3126,'/','default','Panel First','','7.34'),(3127,'/','default','Panel Second','','7.34'),(3128,'/','default','Panel Third','','7.34'),(3129,'/','default','Highlighted Left','','7.34'),(3130,'/','default','Highlighted','','7.34'),(3131,'/','default','Highlighted Right','','7.34'),(3132,'/','default','Panel Footer 1','','7.34'),(3133,'/','default','Panel Footer 2','','7.34'),(3134,'/','default','Panel Footer 3','','7.34'),(3135,'/','default','Panel Footer 4','','7.34'),(3136,'/','default','.','','7.34'),(3137,'/','default',',','','7.34'),(3138,'/','default','Select any filter and click on Apply to see results','','7.34'),(3139,'/','default','Go','','7.34'),(3140,'/','default','Select terms from vocabulary @voc','','7.34'),(3141,'/','default','- Any -','','7.34'),(3142,'/','default','Items per page','','7.34'),(3143,'/','default','- All -','','7.34'),(3144,'/','default','« first','','7.34'),(3145,'/','default','‹ previous','','7.34'),(3146,'/','default','next ›','','7.34'),(3147,'/','default','last »','','7.34'),(3148,'/','default','Advanced options','','7.34'),(3149,'/','default','Your shopping cart is empty.','','7.34'),(3150,'/','default','Shopping cart','','7.34'),(3151,'/','default','Checkout','','7.34'),(3152,'/','default','Review order','','7.34'),(3153,'/','default','Review your order before continuing.','','7.34'),(3154,'/','default','Complete','','7.34'),(3155,'/','default','Checkout complete','','7.34'),(3156,'/','default','Payment','','7.34'),(3157,'/','default','Use the button below to proceed to the payment server.','','7.34'),(3158,'/','default','Go back','','7.34'),(3159,'/','default','Continue to next step','','7.34'),(3160,'/','default','Shopping cart contents','','7.34'),(3161,'/','default','Completion message','','7.34'),(3162,'/','default','Account information','','7.34'),(3163,'/','default','Off-site payment redirect','','7.34'),(3164,'/','default','check if all items are in stock at checkout','','7.34'),(3165,'/','default','Checkout: @page','','7.34'),(3166,'/','default','Canceled','','7.34'),(3167,'/','default','Pending','','7.34'),(3168,'/','default','Processing','','7.34'),(3169,'/','default','Completed','','7.34'),(3170,'/','default','Popular Searches','','7.34'),(3171,'/','default','Tango','','7.34'),(3172,'/','default','Is the current session?','','7.34'),(3173,'/','default','Stay informed on our latest news!','','7.34'),(3174,'/','default','Subscribe','','7.34'),(3175,'/','default','Unsubscribe','','7.34'),(3176,'/','default','Manage my subscriptions','','7.34'),(3177,'/','default','Previous issues','','7.34'),(3178,'/','default','@newsletter feed','','7.34'),(3179,'/','default','Banner block 1','','7.34'),(3180,'/','default','Banner block with 3 item','','7.34'),(3181,'/','default','Banner block with 2 item','','7.34'),(3182,'/','default','Banner block with slideshow','','7.34'),(3183,'/','default','[field_image]','','7.34'),(3184,'/','default','or','','7.34'),(3185,'/','default','Is all of','','7.34'),(3186,'/','default','and','','7.34'),(3187,'/','default','Is none of','','7.34'),(3188,'/','default','not','','7.34'),(3189,'/','default','Line items referenced by commerce_line_items','','7.34'),(3190,'/','default','Products referenced by commerce_product','','7.34'),(3191,'/','default','Node referencing products from field_product','','7.34'),(3192,'/','default','Today\'s Deal','','7.34'),(3193,'/','default','View more','','7.34'),(3194,'/','default','Backpacks','','7.34'),(3195,'/','default','Laptop Bags & Cases','','7.34'),(3196,'/','default','Bags & Backpacks','','7.34'),(3197,'/','default','Shoe Bags','','7.34'),(3198,'/','default','Clothes Shoes & Bags','','7.34'),(3199,'/','default','Makeup','','7.34'),(3200,'/','default','Face Care','','7.34'),(3201,'/','default','Eye Care','','7.34'),(3202,'/','default','Face','','7.34'),(3203,'/','default','Health & Beauty Tools','','7.34'),(3204,'/','default','Food Supplements','','7.34'),(3205,'/','default','Health & Beauty','','7.34'),(3206,'/','default','Smartphones','','7.34'),(3207,'/','default','Basic Phones','','7.34'),(3208,'/','default','Mobiles','','7.34'),(3209,'/','default','With call facility','','7.34'),(3210,'/','default','Without call facility','','7.34'),(3211,'/','default','Tablets','','7.34'),(3212,'/','default','Cases & Covers','','7.34'),(3213,'/','default','Car Accessories','','7.34'),(3214,'/','default','Mobile Accessories','','7.34'),(3215,'/','default','Headphones','','7.34'),(3216,'/','default','Batteries & Chargers','','7.34'),(3217,'/','default','Tablet Accessories','','7.34'),(3218,'/','default','Mobiles & Tablets','','7.34'),(3219,'/','default','Women\'s Jewellery','','7.34'),(3220,'/','default','Belts','','7.34'),(3221,'/','default','Scarves','','7.34'),(3222,'/','default','Women\'s Accessories','','7.34'),(3223,'/','default','Business','','7.34'),(3224,'/','default','Sports','','7.34'),(3225,'/','default','Men\'s Watches','','7.34'),(3226,'/','default','Watches & Accessories','','7.34'),(3227,'/','default','Televisions','','7.34'),(3228,'/','default','TV & Video','','7.34'),(3229,'/','default','Home Audio','','7.34'),(3230,'/','default','Audio','','7.34'),(3231,'/','default','Gadgets','','7.34'),(3232,'/','default','Consumer Electronics','','7.34'),(3233,'/','default','Laptops','','7.34'),(3234,'/','default','Desktops','','7.34'),(3235,'/','default','Switches','','7.34'),(3236,'/','default','Routers','','7.34'),(3237,'/','default','Network Components','','7.34'),(3238,'/','default','Scanners','','7.34'),(3239,'/','default','Computers & Laptops','','7.34'),(3240,'/','default','Point & Shoot Cameras','','7.34'),(3241,'/','default','DSLR/SLR Cameras','','7.34'),(3242,'/','default','Filters','','7.34'),(3243,'/','default','Lenses','','7.34'),(3244,'/','default','Camera Accessories','','7.34'),(3245,'/','default','IP Cameras','','7.34'),(3246,'/','default','Car Cameras','','7.34'),(3247,'/','default','Other Cameras','','7.34'),(3248,'/','default','Cameras','','7.34'),(3249,'/','default','Educational Toys','','7.34'),(3250,'/','default','Toys','','7.34'),(3251,'/','default','Books & Stationery','','7.34'),(3252,'/','default','Kids','','7.34'),(3253,'/','default','Health & Safety','','7.34'),(3254,'/','default','Babies','','7.34'),(3255,'/','default','Toys, Kids & Babies','','7.34'),(3256,'/','default','All categories','','7.34'),(3257,'/','default','Is less than','','7.34'),(3258,'/','default','<','','7.34'),(3259,'/','default','Is less than or equal to','','7.34'),(3260,'/','default','<=','','7.34'),(3261,'/','default','Is equal to','','7.34'),(3262,'/','default','Is not equal to','','7.34'),(3263,'/','default','!=','','7.34'),(3264,'/','default','Is greater than or equal to','','7.34'),(3265,'/','default','>=','','7.34'),(3266,'/','default','Is greater than','','7.34'),(3267,'/','default','>','','7.34'),(3268,'/','default','Is between','','7.34'),(3269,'/','default','between','','7.34'),(3270,'/','default','Is not between','','7.34'),(3271,'/','default','not between','','7.34'),(3272,'/','default','Regular expression','','7.34'),(3273,'/','default','regex','','7.34'),(3274,'/','default','Configure block','','7.34'),(3275,'/','default','Config Mega Menus','','7.34'),(3276,'/','default','Default Style','','7.34'),(3277,'/','default','Default Layout','','7.34'),(3278,'/','default','Back to Home','','7.34'),(3279,'/','default','Back to Top','','7.34'),(3280,'sites/all/themes/marketplace/js/weebpal.js','default','Are you sure you want to reset your theme settings to default theme settings?','','none'),(3281,'modules/overlay/overlay-parent.js','default','@title dialog','','none'),(3282,'sites/all/modules/better_exposed_filters/better_exposed_filters.js','default','Select All','','none'),(3283,'sites/all/modules/better_exposed_filters/better_exposed_filters.js','default','Select None','','none'),(3284,'modules/contextual/contextual.js','default','Configure','','none'),(3285,'/admin/config/regional/settings?render=overlay','default','Andorra','','7.34'),(3286,'/admin/config/regional/settings?render=overlay','default','United Arab Emirates','','7.34'),(3287,'/admin/config/regional/settings?render=overlay','default','Afghanistan','','7.34'),(3288,'/admin/config/regional/settings?render=overlay','default','Antigua and Barbuda','','7.34'),(3289,'/admin/config/regional/settings?render=overlay','default','Anguilla','','7.34'),(3290,'/admin/config/regional/settings?render=overlay','default','Albania','','7.34'),(3291,'/admin/config/regional/settings?render=overlay','default','Armenia','','7.34'),(3292,'/admin/config/regional/settings?render=overlay','default','Netherlands Antilles','','7.34'),(3293,'/admin/config/regional/settings?render=overlay','default','Angola','','7.34'),(3294,'/admin/config/regional/settings?render=overlay','default','Antarctica','','7.34'),(3295,'/admin/config/regional/settings?render=overlay','default','Argentina','','7.34'),(3296,'/admin/config/regional/settings?render=overlay','default','American Samoa','','7.34'),(3297,'/admin/config/regional/settings?render=overlay','default','Austria','','7.34'),(3298,'/admin/config/regional/settings?render=overlay','default','Australia','','7.34'),(3299,'/admin/config/regional/settings?render=overlay','default','Aruba','','7.34'),(3300,'/admin/config/regional/settings?render=overlay','default','Aland Islands','','7.34'),(3301,'/admin/config/regional/settings?render=overlay','default','Azerbaijan','','7.34'),(3302,'/admin/config/regional/settings?render=overlay','default','Bosnia and Herzegovina','','7.34'),(3303,'/admin/config/regional/settings?render=overlay','default','Barbados','','7.34'),(3304,'/admin/config/regional/settings?render=overlay','default','Bangladesh','','7.34'),(3305,'/admin/config/regional/settings?render=overlay','default','Belgium','','7.34'),(3306,'/admin/config/regional/settings?render=overlay','default','Burkina Faso','','7.34'),(3307,'/admin/config/regional/settings?render=overlay','default','Bulgaria','','7.34'),(3308,'/admin/config/regional/settings?render=overlay','default','Bahrain','','7.34'),(3309,'/admin/config/regional/settings?render=overlay','default','Burundi','','7.34'),(3310,'/admin/config/regional/settings?render=overlay','default','Benin','','7.34'),(3311,'/admin/config/regional/settings?render=overlay','default','Saint Barthélemy','','7.34'),(3312,'/admin/config/regional/settings?render=overlay','default','Bermuda','','7.34'),(3313,'/admin/config/regional/settings?render=overlay','default','Brunei','','7.34'),(3314,'/admin/config/regional/settings?render=overlay','default','Bolivia','','7.34'),(3315,'/admin/config/regional/settings?render=overlay','default','Caribbean Netherlands','','7.34'),(3316,'/admin/config/regional/settings?render=overlay','default','Brazil','','7.34'),(3317,'/admin/config/regional/settings?render=overlay','default','Bahamas','','7.34'),(3318,'/admin/config/regional/settings?render=overlay','default','Bhutan','','7.34'),(3319,'/admin/config/regional/settings?render=overlay','default','Bouvet Island','','7.34'),(3320,'/admin/config/regional/settings?render=overlay','default','Botswana','','7.34'),(3321,'/admin/config/regional/settings?render=overlay','default','Belarus','','7.34'),(3322,'/admin/config/regional/settings?render=overlay','default','Belize','','7.34'),(3323,'/admin/config/regional/settings?render=overlay','default','Canada','','7.34'),(3324,'/admin/config/regional/settings?render=overlay','default','Cocos (Keeling) Islands','','7.34'),(3325,'/admin/config/regional/settings?render=overlay','default','Congo (Kinshasa)','','7.34'),(3326,'/admin/config/regional/settings?render=overlay','default','Central African Republic','','7.34'),(3327,'/admin/config/regional/settings?render=overlay','default','Congo (Brazzaville)','','7.34'),(3328,'/admin/config/regional/settings?render=overlay','default','Switzerland','','7.34'),(3329,'/admin/config/regional/settings?render=overlay','default','Ivory Coast','','7.34'),(3330,'/admin/config/regional/settings?render=overlay','default','Cook Islands','','7.34'),(3331,'/admin/config/regional/settings?render=overlay','default','Chile','','7.34'),(3332,'/admin/config/regional/settings?render=overlay','default','Cameroon','','7.34'),(3333,'/admin/config/regional/settings?render=overlay','default','China','','7.34'),(3334,'/admin/config/regional/settings?render=overlay','default','Colombia','','7.34'),(3335,'/admin/config/regional/settings?render=overlay','default','Costa Rica','','7.34'),(3336,'/admin/config/regional/settings?render=overlay','default','Cuba','','7.34'),(3337,'/admin/config/regional/settings?render=overlay','default','Cape Verde','','7.34'),(3338,'/admin/config/regional/settings?render=overlay','default','Curaçao','','7.34'),(3339,'/admin/config/regional/settings?render=overlay','default','Christmas Island','','7.34'),(3340,'/admin/config/regional/settings?render=overlay','default','Cyprus','','7.34'),(3341,'/admin/config/regional/settings?render=overlay','default','Czech Republic','','7.34'),(3342,'/admin/config/regional/settings?render=overlay','default','Germany','','7.34'),(3343,'/admin/config/regional/settings?render=overlay','default','Djibouti','','7.34'),(3344,'/admin/config/regional/settings?render=overlay','default','Denmark','','7.34'),(3345,'/admin/config/regional/settings?render=overlay','default','Dominica','','7.34'),(3346,'/admin/config/regional/settings?render=overlay','default','Dominican Republic','','7.34'),(3347,'/admin/config/regional/settings?render=overlay','default','Algeria','','7.34'),(3348,'/admin/config/regional/settings?render=overlay','default','Ecuador','','7.34'),(3349,'/admin/config/regional/settings?render=overlay','default','Estonia','','7.34'),(3350,'/admin/config/regional/settings?render=overlay','default','Egypt','','7.34'),(3351,'/admin/config/regional/settings?render=overlay','default','Western Sahara','','7.34'),(3352,'/admin/config/regional/settings?render=overlay','default','Eritrea','','7.34'),(3353,'/admin/config/regional/settings?render=overlay','default','Spain','','7.34'),(3354,'/admin/config/regional/settings?render=overlay','default','Ethiopia','','7.34'),(3355,'/admin/config/regional/settings?render=overlay','default','Finland','','7.34'),(3356,'/admin/config/regional/settings?render=overlay','default','Fiji','','7.34'),(3357,'/admin/config/regional/settings?render=overlay','default','Falkland Islands','','7.34'),(3358,'/admin/config/regional/settings?render=overlay','default','Micronesia','','7.34'),(3359,'/admin/config/regional/settings?render=overlay','default','Faroe Islands','','7.34'),(3360,'/admin/config/regional/settings?render=overlay','default','France','','7.34'),(3361,'/admin/config/regional/settings?render=overlay','default','Gabon','','7.34'),(3362,'/admin/config/regional/settings?render=overlay','default','United Kingdom','','7.34'),(3363,'/admin/config/regional/settings?render=overlay','default','Grenada','','7.34'),(3364,'/admin/config/regional/settings?render=overlay','default','Georgia','','7.34'),(3365,'/admin/config/regional/settings?render=overlay','default','French Guiana','','7.34'),(3366,'/admin/config/regional/settings?render=overlay','default','Guernsey','','7.34'),(3367,'/admin/config/regional/settings?render=overlay','default','Ghana','','7.34'),(3368,'/admin/config/regional/settings?render=overlay','default','Gibraltar','','7.34'),(3369,'/admin/config/regional/settings?render=overlay','default','Greenland','','7.34'),(3370,'/admin/config/regional/settings?render=overlay','default','Gambia','','7.34'),(3371,'/admin/config/regional/settings?render=overlay','default','Guinea','','7.34'),(3372,'/admin/config/regional/settings?render=overlay','default','Guadeloupe','','7.34'),(3373,'/admin/config/regional/settings?render=overlay','default','Equatorial Guinea','','7.34'),(3374,'/admin/config/regional/settings?render=overlay','default','Greece','','7.34'),(3375,'/admin/config/regional/settings?render=overlay','default','South Georgia and the South Sandwich Islands','','7.34'),(3376,'/admin/config/regional/settings?render=overlay','default','Guatemala','','7.34'),(3377,'/admin/config/regional/settings?render=overlay','default','Guam','','7.34'),(3378,'/admin/config/regional/settings?render=overlay','default','Guinea-Bissau','','7.34'),(3379,'/admin/config/regional/settings?render=overlay','default','Guyana','','7.34'),(3380,'/admin/config/regional/settings?render=overlay','default','Hong Kong S.A.R., China','','7.34'),(3381,'/admin/config/regional/settings?render=overlay','default','Heard Island and McDonald Islands','','7.34'),(3382,'/admin/config/regional/settings?render=overlay','default','Honduras','','7.34'),(3383,'/admin/config/regional/settings?render=overlay','default','Croatia','','7.34'),(3384,'/admin/config/regional/settings?render=overlay','default','Haiti','','7.34'),(3385,'/admin/config/regional/settings?render=overlay','default','Hungary','','7.34'),(3386,'/admin/config/regional/settings?render=overlay','default','Indonesia','','7.34'),(3387,'/admin/config/regional/settings?render=overlay','default','Ireland','','7.34'),(3388,'/admin/config/regional/settings?render=overlay','default','Israel','','7.34'),(3389,'/admin/config/regional/settings?render=overlay','default','Isle of Man','','7.34'),(3390,'/admin/config/regional/settings?render=overlay','default','India','','7.34'),(3391,'/admin/config/regional/settings?render=overlay','default','British Indian Ocean Territory','','7.34'),(3392,'/admin/config/regional/settings?render=overlay','default','Iraq','','7.34'),(3393,'/admin/config/regional/settings?render=overlay','default','Iran','','7.34'),(3394,'/admin/config/regional/settings?render=overlay','default','Iceland','','7.34'),(3395,'/admin/config/regional/settings?render=overlay','default','Italy','','7.34'),(3396,'/admin/config/regional/settings?render=overlay','default','Jersey','','7.34'),(3397,'/admin/config/regional/settings?render=overlay','default','Jamaica','','7.34'),(3398,'/admin/config/regional/settings?render=overlay','default','Jordan','','7.34'),(3399,'/admin/config/regional/settings?render=overlay','default','Japan','','7.34'),(3400,'/admin/config/regional/settings?render=overlay','default','Kenya','','7.34'),(3401,'/admin/config/regional/settings?render=overlay','default','Kyrgyzstan','','7.34'),(3402,'/admin/config/regional/settings?render=overlay','default','Cambodia','','7.34'),(3403,'/admin/config/regional/settings?render=overlay','default','Kiribati','','7.34'),(3404,'/admin/config/regional/settings?render=overlay','default','Comoros','','7.34'),(3405,'/admin/config/regional/settings?render=overlay','default','Saint Kitts and Nevis','','7.34'),(3406,'/admin/config/regional/settings?render=overlay','default','North Korea','','7.34'),(3407,'/admin/config/regional/settings?render=overlay','default','South Korea','','7.34'),(3408,'/admin/config/regional/settings?render=overlay','default','Kuwait','','7.34'),(3409,'/admin/config/regional/settings?render=overlay','default','Cayman Islands','','7.34'),(3410,'/admin/config/regional/settings?render=overlay','default','Kazakhstan','','7.34'),(3411,'/admin/config/regional/settings?render=overlay','default','Laos','','7.34'),(3412,'/admin/config/regional/settings?render=overlay','default','Lebanon','','7.34'),(3413,'/admin/config/regional/settings?render=overlay','default','Saint Lucia','','7.34'),(3414,'/admin/config/regional/settings?render=overlay','default','Liechtenstein','','7.34'),(3415,'/admin/config/regional/settings?render=overlay','default','Sri Lanka','','7.34'),(3416,'/admin/config/regional/settings?render=overlay','default','Liberia','','7.34'),(3417,'/admin/config/regional/settings?render=overlay','default','Lesotho','','7.34'),(3418,'/admin/config/regional/settings?render=overlay','default','Lithuania','','7.34'),(3419,'/admin/config/regional/settings?render=overlay','default','Luxembourg','','7.34'),(3420,'/admin/config/regional/settings?render=overlay','default','Latvia','','7.34'),(3421,'/admin/config/regional/settings?render=overlay','default','Libya','','7.34'),(3422,'/admin/config/regional/settings?render=overlay','default','Morocco','','7.34'),(3423,'/admin/config/regional/settings?render=overlay','default','Monaco','','7.34'),(3424,'/admin/config/regional/settings?render=overlay','default','Moldova','','7.34'),(3425,'/admin/config/regional/settings?render=overlay','default','Montenegro','','7.34'),(3426,'/admin/config/regional/settings?render=overlay','default','Saint Martin (French part)','','7.34'),(3427,'/admin/config/regional/settings?render=overlay','default','Madagascar','','7.34'),(3428,'/admin/config/regional/settings?render=overlay','default','Marshall Islands','','7.34'),(3429,'/admin/config/regional/settings?render=overlay','default','Macedonia','','7.34'),(3430,'/admin/config/regional/settings?render=overlay','default','Mali','','7.34'),(3431,'/admin/config/regional/settings?render=overlay','default','Myanmar','','7.34'),(3432,'/admin/config/regional/settings?render=overlay','default','Mongolia','','7.34'),(3433,'/admin/config/regional/settings?render=overlay','default','Macao S.A.R., China','','7.34'),(3434,'/admin/config/regional/settings?render=overlay','default','Northern Mariana Islands','','7.34'),(3435,'/admin/config/regional/settings?render=overlay','default','Martinique','','7.34'),(3436,'/admin/config/regional/settings?render=overlay','default','Mauritania','','7.34'),(3437,'/admin/config/regional/settings?render=overlay','default','Montserrat','','7.34'),(3438,'/admin/config/regional/settings?render=overlay','default','Malta','','7.34'),(3439,'/admin/config/regional/settings?render=overlay','default','Mauritius','','7.34'),(3440,'/admin/config/regional/settings?render=overlay','default','Maldives','','7.34'),(3441,'/admin/config/regional/settings?render=overlay','default','Malawi','','7.34'),(3442,'/admin/config/regional/settings?render=overlay','default','Mexico','','7.34'),(3443,'/admin/config/regional/settings?render=overlay','default','Malaysia','','7.34'),(3444,'/admin/config/regional/settings?render=overlay','default','Mozambique','','7.34'),(3445,'/admin/config/regional/settings?render=overlay','default','Namibia','','7.34'),(3446,'/admin/config/regional/settings?render=overlay','default','New Caledonia','','7.34'),(3447,'/admin/config/regional/settings?render=overlay','default','Niger','','7.34'),(3448,'/admin/config/regional/settings?render=overlay','default','Norfolk Island','','7.34'),(3449,'/admin/config/regional/settings?render=overlay','default','Nigeria','','7.34'),(3450,'/admin/config/regional/settings?render=overlay','default','Nicaragua','','7.34'),(3451,'/admin/config/regional/settings?render=overlay','default','Netherlands','','7.34'),(3452,'/admin/config/regional/settings?render=overlay','default','Norway','','7.34'),(3453,'/admin/config/regional/settings?render=overlay','default','Nepal','','7.34'),(3454,'/admin/config/regional/settings?render=overlay','default','Nauru','','7.34'),(3455,'/admin/config/regional/settings?render=overlay','default','Niue','','7.34'),(3456,'/admin/config/regional/settings?render=overlay','default','New Zealand','','7.34'),(3457,'/admin/config/regional/settings?render=overlay','default','Oman','','7.34'),(3458,'/admin/config/regional/settings?render=overlay','default','Panama','','7.34'),(3459,'/admin/config/regional/settings?render=overlay','default','Peru','','7.34'),(3460,'/admin/config/regional/settings?render=overlay','default','French Polynesia','','7.34'),(3461,'/admin/config/regional/settings?render=overlay','default','Papua New Guinea','','7.34'),(3462,'/admin/config/regional/settings?render=overlay','default','Philippines','','7.34'),(3463,'/admin/config/regional/settings?render=overlay','default','Pakistan','','7.34'),(3464,'/admin/config/regional/settings?render=overlay','default','Poland','','7.34'),(3465,'/admin/config/regional/settings?render=overlay','default','Saint Pierre and Miquelon','','7.34'),(3466,'/admin/config/regional/settings?render=overlay','default','Pitcairn','','7.34'),(3467,'/admin/config/regional/settings?render=overlay','default','Puerto Rico','','7.34'),(3468,'/admin/config/regional/settings?render=overlay','default','Palestinian Territory','','7.34'),(3469,'/admin/config/regional/settings?render=overlay','default','Portugal','','7.34'),(3470,'/admin/config/regional/settings?render=overlay','default','Palau','','7.34'),(3471,'/admin/config/regional/settings?render=overlay','default','Paraguay','','7.34'),(3472,'/admin/config/regional/settings?render=overlay','default','Qatar','','7.34'),(3473,'/admin/config/regional/settings?render=overlay','default','Reunion','','7.34'),(3474,'/admin/config/regional/settings?render=overlay','default','Romania','','7.34'),(3475,'/admin/config/regional/settings?render=overlay','default','Serbia','','7.34'),(3476,'/admin/config/regional/settings?render=overlay','default','Russia','','7.34'),(3477,'/admin/config/regional/settings?render=overlay','default','Rwanda','','7.34'),(3478,'/admin/config/regional/settings?render=overlay','default','Saudi Arabia','','7.34'),(3479,'/admin/config/regional/settings?render=overlay','default','Solomon Islands','','7.34'),(3480,'/admin/config/regional/settings?render=overlay','default','Seychelles','','7.34'),(3481,'/admin/config/regional/settings?render=overlay','default','Sudan','','7.34'),(3482,'/admin/config/regional/settings?render=overlay','default','Sweden','','7.34'),(3483,'/admin/config/regional/settings?render=overlay','default','Singapore','','7.34'),(3484,'/admin/config/regional/settings?render=overlay','default','Saint Helena','','7.34'),(3485,'/admin/config/regional/settings?render=overlay','default','Slovenia','','7.34'),(3486,'/admin/config/regional/settings?render=overlay','default','Svalbard and Jan Mayen','','7.34'),(3487,'/admin/config/regional/settings?render=overlay','default','Slovakia','','7.34'),(3488,'/admin/config/regional/settings?render=overlay','default','Sierra Leone','','7.34'),(3489,'/admin/config/regional/settings?render=overlay','default','San Marino','','7.34'),(3490,'/admin/config/regional/settings?render=overlay','default','Senegal','','7.34'),(3491,'/admin/config/regional/settings?render=overlay','default','Somalia','','7.34'),(3492,'/admin/config/regional/settings?render=overlay','default','Suriname','','7.34'),(3493,'/admin/config/regional/settings?render=overlay','default','South Sudan','','7.34'),(3494,'/admin/config/regional/settings?render=overlay','default','Sao Tome and Principe','','7.34'),(3495,'/admin/config/regional/settings?render=overlay','default','El Salvador','','7.34'),(3496,'/admin/config/regional/settings?render=overlay','default','Sint Maarten','','7.34'),(3497,'/admin/config/regional/settings?render=overlay','default','Syria','','7.34'),(3498,'/admin/config/regional/settings?render=overlay','default','Swaziland','','7.34'),(3499,'/admin/config/regional/settings?render=overlay','default','Turks and Caicos Islands','','7.34'),(3500,'/admin/config/regional/settings?render=overlay','default','Chad','','7.34'),(3501,'/admin/config/regional/settings?render=overlay','default','French Southern Territories','','7.34'),(3502,'/admin/config/regional/settings?render=overlay','default','Togo','','7.34'),(3503,'/admin/config/regional/settings?render=overlay','default','Thailand','','7.34'),(3504,'/admin/config/regional/settings?render=overlay','default','Tajikistan','','7.34'),(3505,'/admin/config/regional/settings?render=overlay','default','Tokelau','','7.34'),(3506,'/admin/config/regional/settings?render=overlay','default','Timor-Leste','','7.34'),(3507,'/admin/config/regional/settings?render=overlay','default','Turkmenistan','','7.34'),(3508,'/admin/config/regional/settings?render=overlay','default','Tunisia','','7.34'),(3509,'/admin/config/regional/settings?render=overlay','default','Tonga','','7.34'),(3510,'/admin/config/regional/settings?render=overlay','default','Turkey','','7.34'),(3511,'/admin/config/regional/settings?render=overlay','default','Trinidad and Tobago','','7.34'),(3512,'/admin/config/regional/settings?render=overlay','default','Tuvalu','','7.34'),(3513,'/admin/config/regional/settings?render=overlay','default','Taiwan','','7.34'),(3514,'/admin/config/regional/settings?render=overlay','default','Tanzania','','7.34'),(3515,'/admin/config/regional/settings?render=overlay','default','Ukraine','','7.34'),(3516,'/admin/config/regional/settings?render=overlay','default','Uganda','','7.34'),(3517,'/admin/config/regional/settings?render=overlay','default','United States Minor Outlying Islands','','7.34'),(3518,'/admin/config/regional/settings?render=overlay','default','United States','','7.34'),(3519,'/admin/config/regional/settings?render=overlay','default','Uruguay','','7.34'),(3520,'/admin/config/regional/settings?render=overlay','default','Uzbekistan','','7.34'),(3521,'/admin/config/regional/settings?render=overlay','default','Vatican','','7.34'),(3522,'/admin/config/regional/settings?render=overlay','default','Saint Vincent and the Grenadines','','7.34'),(3523,'/admin/config/regional/settings?render=overlay','default','Venezuela','','7.34'),(3524,'/admin/config/regional/settings?render=overlay','default','British Virgin Islands','','7.34'),(3525,'/admin/config/regional/settings?render=overlay','default','U.S. Virgin Islands','','7.34'),(3526,'/admin/config/regional/settings?render=overlay','default','Vietnam','','7.34'),(3527,'/admin/config/regional/settings?render=overlay','default','Vanuatu','','7.34'),(3528,'/admin/config/regional/settings?render=overlay','default','Wallis and Futuna','','7.34'),(3529,'/admin/config/regional/settings?render=overlay','default','Samoa','','7.34'),(3530,'/admin/config/regional/settings?render=overlay','default','Yemen','','7.34'),(3531,'/admin/config/regional/settings?render=overlay','default','Mayotte','','7.34'),(3532,'/admin/config/regional/settings?render=overlay','default','South Africa','','7.34'),(3533,'/admin/config/regional/settings?render=overlay','default','Zambia','','7.34'),(3534,'/admin/config/regional/settings?render=overlay','default','Zimbabwe','','7.34'),(3535,'/admin/config/regional/settings?render=overlay','default','Africa/Abidjan','','7.34'),(3536,'/admin/config/regional/settings?render=overlay','default','@zone: @date','','7.34'),(3537,'/admin/config/regional/settings?render=overlay','default','Africa/Accra','','7.34'),(3538,'/admin/config/regional/settings?render=overlay','default','Africa/Addis Ababa','','7.34'),(3539,'/admin/config/regional/settings?render=overlay','default','Africa/Algiers','','7.34'),(3540,'/admin/config/regional/settings?render=overlay','default','Africa/Asmara','','7.34'),(3541,'/admin/config/regional/settings?render=overlay','default','Africa/Bamako','','7.34'),(3542,'/admin/config/regional/settings?render=overlay','default','Africa/Bangui','','7.34'),(3543,'/admin/config/regional/settings?render=overlay','default','Africa/Banjul','','7.34'),(3544,'/admin/config/regional/settings?render=overlay','default','Africa/Bissau','','7.34'),(3545,'/admin/config/regional/settings?render=overlay','default','Africa/Blantyre','','7.34'),(3546,'/admin/config/regional/settings?render=overlay','default','Africa/Brazzaville','','7.34'),(3547,'/admin/config/regional/settings?render=overlay','default','Africa/Bujumbura','','7.34'),(3548,'/admin/config/regional/settings?render=overlay','default','Africa/Cairo','','7.34'),(3549,'/admin/config/regional/settings?render=overlay','default','Africa/Casablanca','','7.34'),(3550,'/admin/config/regional/settings?render=overlay','default','Africa/Ceuta','','7.34'),(3551,'/admin/config/regional/settings?render=overlay','default','Africa/Conakry','','7.34'),(3552,'/admin/config/regional/settings?render=overlay','default','Africa/Dakar','','7.34'),(3553,'/admin/config/regional/settings?render=overlay','default','Africa/Dar es Salaam','','7.34'),(3554,'/admin/config/regional/settings?render=overlay','default','Africa/Djibouti','','7.34'),(3555,'/admin/config/regional/settings?render=overlay','default','Africa/Douala','','7.34'),(3556,'/admin/config/regional/settings?render=overlay','default','Africa/El Aaiun','','7.34'),(3557,'/admin/config/regional/settings?render=overlay','default','Africa/Freetown','','7.34'),(3558,'/admin/config/regional/settings?render=overlay','default','Africa/Gaborone','','7.34'),(3559,'/admin/config/regional/settings?render=overlay','default','Africa/Harare','','7.34'),(3560,'/admin/config/regional/settings?render=overlay','default','Africa/Johannesburg','','7.34'),(3561,'/admin/config/regional/settings?render=overlay','default','Africa/Juba','','7.34'),(3562,'/admin/config/regional/settings?render=overlay','default','Africa/Kampala','','7.34'),(3563,'/admin/config/regional/settings?render=overlay','default','Africa/Khartoum','','7.34'),(3564,'/admin/config/regional/settings?render=overlay','default','Africa/Kigali','','7.34'),(3565,'/admin/config/regional/settings?render=overlay','default','Africa/Kinshasa','','7.34'),(3566,'/admin/config/regional/settings?render=overlay','default','Africa/Lagos','','7.34'),(3567,'/admin/config/regional/settings?render=overlay','default','Africa/Libreville','','7.34'),(3568,'/admin/config/regional/settings?render=overlay','default','Africa/Lome','','7.34'),(3569,'/admin/config/regional/settings?render=overlay','default','Africa/Luanda','','7.34'),(3570,'/admin/config/regional/settings?render=overlay','default','Africa/Lubumbashi','','7.34'),(3571,'/admin/config/regional/settings?render=overlay','default','Africa/Lusaka','','7.34'),(3572,'/admin/config/regional/settings?render=overlay','default','Africa/Malabo','','7.34'),(3573,'/admin/config/regional/settings?render=overlay','default','Africa/Maputo','','7.34'),(3574,'/admin/config/regional/settings?render=overlay','default','Africa/Maseru','','7.34'),(3575,'/admin/config/regional/settings?render=overlay','default','Africa/Mbabane','','7.34'),(3576,'/admin/config/regional/settings?render=overlay','default','Africa/Mogadishu','','7.34'),(3577,'/admin/config/regional/settings?render=overlay','default','Africa/Monrovia','','7.34'),(3578,'/admin/config/regional/settings?render=overlay','default','Africa/Nairobi','','7.34'),(3579,'/admin/config/regional/settings?render=overlay','default','Africa/Ndjamena','','7.34'),(3580,'/admin/config/regional/settings?render=overlay','default','Africa/Niamey','','7.34'),(3581,'/admin/config/regional/settings?render=overlay','default','Africa/Nouakchott','','7.34'),(3582,'/admin/config/regional/settings?render=overlay','default','Africa/Ouagadougou','','7.34'),(3583,'/admin/config/regional/settings?render=overlay','default','Africa/Porto-Novo','','7.34'),(3584,'/admin/config/regional/settings?render=overlay','default','Africa/Sao Tome','','7.34'),(3585,'/admin/config/regional/settings?render=overlay','default','Africa/Tripoli','','7.34'),(3586,'/admin/config/regional/settings?render=overlay','default','Africa/Tunis','','7.34'),(3587,'/admin/config/regional/settings?render=overlay','default','Africa/Windhoek','','7.34'),(3588,'/admin/config/regional/settings?render=overlay','default','America/Adak','','7.34'),(3589,'/admin/config/regional/settings?render=overlay','default','Wednesday','','7.34'),(3590,'/admin/config/regional/settings?render=overlay','default','America/Anchorage','','7.34'),(3591,'/admin/config/regional/settings?render=overlay','default','America/Anguilla','','7.34'),(3592,'/admin/config/regional/settings?render=overlay','default','America/Antigua','','7.34'),(3593,'/admin/config/regional/settings?render=overlay','default','America/Araguaina','','7.34'),(3594,'/admin/config/regional/settings?render=overlay','default','America/Argentina/Buenos Aires','','7.34'),(3595,'/admin/config/regional/settings?render=overlay','default','America/Argentina/Catamarca','','7.34'),(3596,'/admin/config/regional/settings?render=overlay','default','America/Argentina/Cordoba','','7.34'),(3597,'/admin/config/regional/settings?render=overlay','default','America/Argentina/Jujuy','','7.34'),(3598,'/admin/config/regional/settings?render=overlay','default','America/Argentina/La Rioja','','7.34'),(3599,'/admin/config/regional/settings?render=overlay','default','America/Argentina/Mendoza','','7.34'),(3600,'/admin/config/regional/settings?render=overlay','default','America/Argentina/Rio Gallegos','','7.34'),(3601,'/admin/config/regional/settings?render=overlay','default','America/Argentina/Salta','','7.34'),(3602,'/admin/config/regional/settings?render=overlay','default','America/Argentina/San Juan','','7.34'),(3603,'/admin/config/regional/settings?render=overlay','default','America/Argentina/San Luis','','7.34'),(3604,'/admin/config/regional/settings?render=overlay','default','America/Argentina/Tucuman','','7.34'),(3605,'/admin/config/regional/settings?render=overlay','default','America/Argentina/Ushuaia','','7.34'),(3606,'/admin/config/regional/settings?render=overlay','default','America/Aruba','','7.34'),(3607,'/admin/config/regional/settings?render=overlay','default','America/Asuncion','','7.34'),(3608,'/admin/config/regional/settings?render=overlay','default','America/Atikokan','','7.34'),(3609,'/admin/config/regional/settings?render=overlay','default','America/Bahia','','7.34'),(3610,'/admin/config/regional/settings?render=overlay','default','America/Bahia Banderas','','7.34'),(3611,'/admin/config/regional/settings?render=overlay','default','America/Barbados','','7.34'),(3612,'/admin/config/regional/settings?render=overlay','default','America/Belem','','7.34'),(3613,'/admin/config/regional/settings?render=overlay','default','America/Belize','','7.34'),(3614,'/admin/config/regional/settings?render=overlay','default','America/Blanc-Sablon','','7.34'),(3615,'/admin/config/regional/settings?render=overlay','default','America/Boa Vista','','7.34'),(3616,'/admin/config/regional/settings?render=overlay','default','America/Bogota','','7.34'),(3617,'/admin/config/regional/settings?render=overlay','default','America/Boise','','7.34'),(3618,'/admin/config/regional/settings?render=overlay','default','America/Cambridge Bay','','7.34'),(3619,'/admin/config/regional/settings?render=overlay','default','America/Campo Grande','','7.34'),(3620,'/admin/config/regional/settings?render=overlay','default','America/Cancun','','7.34'),(3621,'/admin/config/regional/settings?render=overlay','default','America/Caracas','','7.34'),(3622,'/admin/config/regional/settings?render=overlay','default','America/Cayenne','','7.34'),(3623,'/admin/config/regional/settings?render=overlay','default','America/Cayman','','7.34'),(3624,'/admin/config/regional/settings?render=overlay','default','America/Chicago','','7.34'),(3625,'/admin/config/regional/settings?render=overlay','default','America/Chihuahua','','7.34'),(3626,'/admin/config/regional/settings?render=overlay','default','America/Costa Rica','','7.34'),(3627,'/admin/config/regional/settings?render=overlay','default','America/Creston','','7.34'),(3628,'/admin/config/regional/settings?render=overlay','default','America/Cuiaba','','7.34'),(3629,'/admin/config/regional/settings?render=overlay','default','America/Curacao','','7.34'),(3630,'/admin/config/regional/settings?render=overlay','default','America/Danmarkshavn','','7.34'),(3631,'/admin/config/regional/settings?render=overlay','default','America/Dawson','','7.34'),(3632,'/admin/config/regional/settings?render=overlay','default','America/Dawson Creek','','7.34'),(3633,'/admin/config/regional/settings?render=overlay','default','America/Denver','','7.34'),(3634,'/admin/config/regional/settings?render=overlay','default','America/Detroit','','7.34'),(3635,'/admin/config/regional/settings?render=overlay','default','America/Dominica','','7.34'),(3636,'/admin/config/regional/settings?render=overlay','default','America/Edmonton','','7.34'),(3637,'/admin/config/regional/settings?render=overlay','default','America/Eirunepe','','7.34'),(3638,'/admin/config/regional/settings?render=overlay','default','America/El Salvador','','7.34'),(3639,'/admin/config/regional/settings?render=overlay','default','America/Fortaleza','','7.34'),(3640,'/admin/config/regional/settings?render=overlay','default','America/Glace Bay','','7.34'),(3641,'/admin/config/regional/settings?render=overlay','default','America/Godthab','','7.34'),(3642,'/admin/config/regional/settings?render=overlay','default','America/Goose Bay','','7.34'),(3643,'/admin/config/regional/settings?render=overlay','default','America/Grand Turk','','7.34'),(3644,'/admin/config/regional/settings?render=overlay','default','America/Grenada','','7.34'),(3645,'/admin/config/regional/settings?render=overlay','default','America/Guadeloupe','','7.34'),(3646,'/admin/config/regional/settings?render=overlay','default','America/Guatemala','','7.34'),(3647,'/admin/config/regional/settings?render=overlay','default','America/Guayaquil','','7.34'),(3648,'/admin/config/regional/settings?render=overlay','default','America/Guyana','','7.34'),(3649,'/admin/config/regional/settings?render=overlay','default','America/Halifax','','7.34'),(3650,'/admin/config/regional/settings?render=overlay','default','America/Havana','','7.34'),(3651,'/admin/config/regional/settings?render=overlay','default','America/Hermosillo','','7.34'),(3652,'/admin/config/regional/settings?render=overlay','default','America/Indiana/Indianapolis','','7.34'),(3653,'/admin/config/regional/settings?render=overlay','default','America/Indiana/Knox','','7.34'),(3654,'/admin/config/regional/settings?render=overlay','default','America/Indiana/Marengo','','7.34'),(3655,'/admin/config/regional/settings?render=overlay','default','America/Indiana/Petersburg','','7.34'),(3656,'/admin/config/regional/settings?render=overlay','default','America/Indiana/Tell City','','7.34'),(3657,'/admin/config/regional/settings?render=overlay','default','America/Indiana/Vevay','','7.34'),(3658,'/admin/config/regional/settings?render=overlay','default','America/Indiana/Vincennes','','7.34'),(3659,'/admin/config/regional/settings?render=overlay','default','America/Indiana/Winamac','','7.34'),(3660,'/admin/config/regional/settings?render=overlay','default','America/Inuvik','','7.34'),(3661,'/admin/config/regional/settings?render=overlay','default','America/Iqaluit','','7.34'),(3662,'/admin/config/regional/settings?render=overlay','default','America/Jamaica','','7.34'),(3663,'/admin/config/regional/settings?render=overlay','default','America/Juneau','','7.34'),(3664,'/admin/config/regional/settings?render=overlay','default','America/Kentucky/Louisville','','7.34'),(3665,'/admin/config/regional/settings?render=overlay','default','America/Kentucky/Monticello','','7.34'),(3666,'/admin/config/regional/settings?render=overlay','default','America/Kralendijk','','7.34'),(3667,'/admin/config/regional/settings?render=overlay','default','America/La Paz','','7.34'),(3668,'/admin/config/regional/settings?render=overlay','default','America/Lima','','7.34'),(3669,'/admin/config/regional/settings?render=overlay','default','America/Los Angeles','','7.34'),(3670,'/admin/config/regional/settings?render=overlay','default','America/Lower Princes','','7.34'),(3671,'/admin/config/regional/settings?render=overlay','default','America/Maceio','','7.34'),(3672,'/admin/config/regional/settings?render=overlay','default','America/Managua','','7.34'),(3673,'/admin/config/regional/settings?render=overlay','default','America/Manaus','','7.34'),(3674,'/admin/config/regional/settings?render=overlay','default','America/Marigot','','7.34'),(3675,'/admin/config/regional/settings?render=overlay','default','America/Martinique','','7.34'),(3676,'/admin/config/regional/settings?render=overlay','default','America/Matamoros','','7.34'),(3677,'/admin/config/regional/settings?render=overlay','default','America/Mazatlan','','7.34'),(3678,'/admin/config/regional/settings?render=overlay','default','America/Menominee','','7.34'),(3679,'/admin/config/regional/settings?render=overlay','default','America/Merida','','7.34'),(3680,'/admin/config/regional/settings?render=overlay','default','America/Metlakatla','','7.34'),(3681,'/admin/config/regional/settings?render=overlay','default','America/Mexico City','','7.34'),(3682,'/admin/config/regional/settings?render=overlay','default','America/Miquelon','','7.34'),(3683,'/admin/config/regional/settings?render=overlay','default','America/Moncton','','7.34'),(3684,'/admin/config/regional/settings?render=overlay','default','America/Monterrey','','7.34'),(3685,'/admin/config/regional/settings?render=overlay','default','America/Montevideo','','7.34'),(3686,'/admin/config/regional/settings?render=overlay','default','America/Montserrat','','7.34'),(3687,'/admin/config/regional/settings?render=overlay','default','America/Nassau','','7.34'),(3688,'/admin/config/regional/settings?render=overlay','default','America/New York','','7.34'),(3689,'/admin/config/regional/settings?render=overlay','default','America/Nipigon','','7.34'),(3690,'/admin/config/regional/settings?render=overlay','default','America/Nome','','7.34'),(3691,'/admin/config/regional/settings?render=overlay','default','America/Noronha','','7.34'),(3692,'/admin/config/regional/settings?render=overlay','default','America/North Dakota/Beulah','','7.34'),(3693,'/admin/config/regional/settings?render=overlay','default','America/North Dakota/Center','','7.34'),(3694,'/admin/config/regional/settings?render=overlay','default','America/North Dakota/New Salem','','7.34'),(3695,'/admin/config/regional/settings?render=overlay','default','America/Ojinaga','','7.34'),(3696,'/admin/config/regional/settings?render=overlay','default','America/Panama','','7.34'),(3697,'/admin/config/regional/settings?render=overlay','default','America/Pangnirtung','','7.34'),(3698,'/admin/config/regional/settings?render=overlay','default','America/Paramaribo','','7.34'),(3699,'/admin/config/regional/settings?render=overlay','default','America/Phoenix','','7.34'),(3700,'/admin/config/regional/settings?render=overlay','default','America/Port-au-Prince','','7.34'),(3701,'/admin/config/regional/settings?render=overlay','default','America/Port of Spain','','7.34'),(3702,'/admin/config/regional/settings?render=overlay','default','America/Porto Velho','','7.34'),(3703,'/admin/config/regional/settings?render=overlay','default','America/Puerto Rico','','7.34'),(3704,'/admin/config/regional/settings?render=overlay','default','America/Rainy River','','7.34'),(3705,'/admin/config/regional/settings?render=overlay','default','America/Rankin Inlet','','7.34'),(3706,'/admin/config/regional/settings?render=overlay','default','America/Recife','','7.34'),(3707,'/admin/config/regional/settings?render=overlay','default','America/Regina','','7.34'),(3708,'/admin/config/regional/settings?render=overlay','default','America/Resolute','','7.34'),(3709,'/admin/config/regional/settings?render=overlay','default','America/Rio Branco','','7.34'),(3710,'/admin/config/regional/settings?render=overlay','default','America/Santa Isabel','','7.34'),(3711,'/admin/config/regional/settings?render=overlay','default','America/Santarem','','7.34'),(3712,'/admin/config/regional/settings?render=overlay','default','America/Santiago','','7.34'),(3713,'/admin/config/regional/settings?render=overlay','default','America/Santo Domingo','','7.34'),(3714,'/admin/config/regional/settings?render=overlay','default','America/Sao Paulo','','7.34'),(3715,'/admin/config/regional/settings?render=overlay','default','America/Scoresbysund','','7.34'),(3716,'/admin/config/regional/settings?render=overlay','default','America/Sitka','','7.34'),(3717,'/admin/config/regional/settings?render=overlay','default','America/St Barthelemy','','7.34'),(3718,'/admin/config/regional/settings?render=overlay','default','America/St Johns','','7.34'),(3719,'/admin/config/regional/settings?render=overlay','default','America/St Kitts','','7.34'),(3720,'/admin/config/regional/settings?render=overlay','default','America/St Lucia','','7.34'),(3721,'/admin/config/regional/settings?render=overlay','default','America/St Thomas','','7.34'),(3722,'/admin/config/regional/settings?render=overlay','default','America/St Vincent','','7.34'),(3723,'/admin/config/regional/settings?render=overlay','default','America/Swift Current','','7.34'),(3724,'/admin/config/regional/settings?render=overlay','default','America/Tegucigalpa','','7.34'),(3725,'/admin/config/regional/settings?render=overlay','default','America/Thule','','7.34'),(3726,'/admin/config/regional/settings?render=overlay','default','America/Thunder Bay','','7.34'),(3727,'/admin/config/regional/settings?render=overlay','default','America/Tijuana','','7.34'),(3728,'/admin/config/regional/settings?render=overlay','default','America/Toronto','','7.34'),(3729,'/admin/config/regional/settings?render=overlay','default','America/Tortola','','7.34'),(3730,'/admin/config/regional/settings?render=overlay','default','America/Vancouver','','7.34'),(3731,'/admin/config/regional/settings?render=overlay','default','America/Whitehorse','','7.34'),(3732,'/admin/config/regional/settings?render=overlay','default','America/Winnipeg','','7.34'),(3733,'/admin/config/regional/settings?render=overlay','default','America/Yakutat','','7.34'),(3734,'/admin/config/regional/settings?render=overlay','default','America/Yellowknife','','7.34'),(3735,'/admin/config/regional/settings?render=overlay','default','Antarctica/Casey','','7.34'),(3736,'/admin/config/regional/settings?render=overlay','default','Antarctica/Davis','','7.34'),(3737,'/admin/config/regional/settings?render=overlay','default','Antarctica/DumontDUrville','','7.34'),(3738,'/admin/config/regional/settings?render=overlay','default','Antarctica/Macquarie','','7.34'),(3739,'/admin/config/regional/settings?render=overlay','default','Antarctica/Mawson','','7.34'),(3740,'/admin/config/regional/settings?render=overlay','default','Antarctica/McMurdo','','7.34'),(3741,'/admin/config/regional/settings?render=overlay','default','Antarctica/Palmer','','7.34'),(3742,'/admin/config/regional/settings?render=overlay','default','Antarctica/Rothera','','7.34'),(3743,'/admin/config/regional/settings?render=overlay','default','Antarctica/Syowa','','7.34'),(3744,'/admin/config/regional/settings?render=overlay','default','Antarctica/Troll','','7.34'),(3745,'/admin/config/regional/settings?render=overlay','default','Antarctica/Vostok','','7.34'),(3746,'/admin/config/regional/settings?render=overlay','default','Arctic/Longyearbyen','','7.34'),(3747,'/admin/config/regional/settings?render=overlay','default','Asia/Aden','','7.34'),(3748,'/admin/config/regional/settings?render=overlay','default','Asia/Almaty','','7.34'),(3749,'/admin/config/regional/settings?render=overlay','default','Asia/Amman','','7.34'),(3750,'/admin/config/regional/settings?render=overlay','default','Asia/Anadyr','','7.34'),(3751,'/admin/config/regional/settings?render=overlay','default','Asia/Aqtau','','7.34'),(3752,'/admin/config/regional/settings?render=overlay','default','Asia/Aqtobe','','7.34'),(3753,'/admin/config/regional/settings?render=overlay','default','Asia/Ashgabat','','7.34'),(3754,'/admin/config/regional/settings?render=overlay','default','Asia/Baghdad','','7.34'),(3755,'/admin/config/regional/settings?render=overlay','default','Asia/Bahrain','','7.34'),(3756,'/admin/config/regional/settings?render=overlay','default','Asia/Baku','','7.34'),(3757,'/admin/config/regional/settings?render=overlay','default','Asia/Bangkok','','7.34'),(3758,'/admin/config/regional/settings?render=overlay','default','Asia/Beirut','','7.34'),(3759,'/admin/config/regional/settings?render=overlay','default','Asia/Bishkek','','7.34'),(3760,'/admin/config/regional/settings?render=overlay','default','Asia/Brunei','','7.34'),(3761,'/admin/config/regional/settings?render=overlay','default','Asia/Choibalsan','','7.34'),(3762,'/admin/config/regional/settings?render=overlay','default','Asia/Chongqing','','7.34'),(3763,'/admin/config/regional/settings?render=overlay','default','Asia/Colombo','','7.34'),(3764,'/admin/config/regional/settings?render=overlay','default','Asia/Damascus','','7.34'),(3765,'/admin/config/regional/settings?render=overlay','default','Asia/Dhaka','','7.34'),(3766,'/admin/config/regional/settings?render=overlay','default','Asia/Dili','','7.34'),(3767,'/admin/config/regional/settings?render=overlay','default','Asia/Dubai','','7.34'),(3768,'/admin/config/regional/settings?render=overlay','default','Asia/Dushanbe','','7.34'),(3769,'/admin/config/regional/settings?render=overlay','default','Asia/Gaza','','7.34'),(3770,'/admin/config/regional/settings?render=overlay','default','Asia/Harbin','','7.34'),(3771,'/admin/config/regional/settings?render=overlay','default','Asia/Hebron','','7.34'),(3772,'/admin/config/regional/settings?render=overlay','default','Asia/Ho Chi Minh','','7.34'),(3773,'/admin/config/regional/settings?render=overlay','default','Asia/Hong Kong','','7.34'),(3774,'/admin/config/regional/settings?render=overlay','default','Asia/Hovd','','7.34'),(3775,'/admin/config/regional/settings?render=overlay','default','Asia/Irkutsk','','7.34'),(3776,'/admin/config/regional/settings?render=overlay','default','Asia/Jakarta','','7.34'),(3777,'/admin/config/regional/settings?render=overlay','default','Asia/Jayapura','','7.34'),(3778,'/admin/config/regional/settings?render=overlay','default','Asia/Jerusalem','','7.34'),(3779,'/admin/config/regional/settings?render=overlay','default','Asia/Kabul','','7.34'),(3780,'/admin/config/regional/settings?render=overlay','default','Asia/Kamchatka','','7.34'),(3781,'/admin/config/regional/settings?render=overlay','default','Asia/Karachi','','7.34'),(3782,'/admin/config/regional/settings?render=overlay','default','Asia/Kashgar','','7.34'),(3783,'/admin/config/regional/settings?render=overlay','default','Asia/Kathmandu','','7.34'),(3784,'/admin/config/regional/settings?render=overlay','default','Asia/Khandyga','','7.34'),(3785,'/admin/config/regional/settings?render=overlay','default','Asia/Kolkata','','7.34'),(3786,'/admin/config/regional/settings?render=overlay','default','Asia/Krasnoyarsk','','7.34'),(3787,'/admin/config/regional/settings?render=overlay','default','Asia/Kuala Lumpur','','7.34'),(3788,'/admin/config/regional/settings?render=overlay','default','Asia/Kuching','','7.34'),(3789,'/admin/config/regional/settings?render=overlay','default','Asia/Kuwait','','7.34'),(3790,'/admin/config/regional/settings?render=overlay','default','Asia/Macau','','7.34'),(3791,'/admin/config/regional/settings?render=overlay','default','Asia/Magadan','','7.34'),(3792,'/admin/config/regional/settings?render=overlay','default','Asia/Makassar','','7.34'),(3793,'/admin/config/regional/settings?render=overlay','default','Asia/Manila','','7.34'),(3794,'/admin/config/regional/settings?render=overlay','default','Asia/Muscat','','7.34'),(3795,'/admin/config/regional/settings?render=overlay','default','Asia/Nicosia','','7.34'),(3796,'/admin/config/regional/settings?render=overlay','default','Asia/Novokuznetsk','','7.34'),(3797,'/admin/config/regional/settings?render=overlay','default','Asia/Novosibirsk','','7.34'),(3798,'/admin/config/regional/settings?render=overlay','default','Asia/Omsk','','7.34'),(3799,'/admin/config/regional/settings?render=overlay','default','Asia/Oral','','7.34'),(3800,'/admin/config/regional/settings?render=overlay','default','Asia/Phnom Penh','','7.34'),(3801,'/admin/config/regional/settings?render=overlay','default','Asia/Pontianak','','7.34'),(3802,'/admin/config/regional/settings?render=overlay','default','Asia/Pyongyang','','7.34'),(3803,'/admin/config/regional/settings?render=overlay','default','Asia/Qatar','','7.34'),(3804,'/admin/config/regional/settings?render=overlay','default','Asia/Qyzylorda','','7.34'),(3805,'/admin/config/regional/settings?render=overlay','default','Asia/Rangoon','','7.34'),(3806,'/admin/config/regional/settings?render=overlay','default','Asia/Riyadh','','7.34'),(3807,'/admin/config/regional/settings?render=overlay','default','Asia/Sakhalin','','7.34'),(3808,'/admin/config/regional/settings?render=overlay','default','Asia/Samarkand','','7.34'),(3809,'/admin/config/regional/settings?render=overlay','default','Asia/Seoul','','7.34'),(3810,'/admin/config/regional/settings?render=overlay','default','Asia/Shanghai','','7.34'),(3811,'/admin/config/regional/settings?render=overlay','default','Asia/Singapore','','7.34'),(3812,'/admin/config/regional/settings?render=overlay','default','Asia/Taipei','','7.34'),(3813,'/admin/config/regional/settings?render=overlay','default','Asia/Tashkent','','7.34'),(3814,'/admin/config/regional/settings?render=overlay','default','Asia/Tbilisi','','7.34'),(3815,'/admin/config/regional/settings?render=overlay','default','Asia/Tehran','','7.34'),(3816,'/admin/config/regional/settings?render=overlay','default','Asia/Thimphu','','7.34'),(3817,'/admin/config/regional/settings?render=overlay','default','Asia/Tokyo','','7.34'),(3818,'/admin/config/regional/settings?render=overlay','default','Asia/Ulaanbaatar','','7.34'),(3819,'/admin/config/regional/settings?render=overlay','default','Asia/Urumqi','','7.34'),(3820,'/admin/config/regional/settings?render=overlay','default','Asia/Ust-Nera','','7.34'),(3821,'/admin/config/regional/settings?render=overlay','default','Asia/Vientiane','','7.34'),(3822,'/admin/config/regional/settings?render=overlay','default','Asia/Vladivostok','','7.34'),(3823,'/admin/config/regional/settings?render=overlay','default','Asia/Yakutsk','','7.34'),(3824,'/admin/config/regional/settings?render=overlay','default','Asia/Yekaterinburg','','7.34'),(3825,'/admin/config/regional/settings?render=overlay','default','Asia/Yerevan','','7.34'),(3826,'/admin/config/regional/settings?render=overlay','default','Atlantic/Azores','','7.34'),(3827,'/admin/config/regional/settings?render=overlay','default','Atlantic/Bermuda','','7.34'),(3828,'/admin/config/regional/settings?render=overlay','default','Atlantic/Canary','','7.34'),(3829,'/admin/config/regional/settings?render=overlay','default','Atlantic/Cape Verde','','7.34'),(3830,'/admin/config/regional/settings?render=overlay','default','Atlantic/Faroe','','7.34'),(3831,'/admin/config/regional/settings?render=overlay','default','Atlantic/Madeira','','7.34'),(3832,'/admin/config/regional/settings?render=overlay','default','Atlantic/Reykjavik','','7.34'),(3833,'/admin/config/regional/settings?render=overlay','default','Atlantic/South Georgia','','7.34'),(3834,'/admin/config/regional/settings?render=overlay','default','Atlantic/St Helena','','7.34'),(3835,'/admin/config/regional/settings?render=overlay','default','Atlantic/Stanley','','7.34'),(3836,'/admin/config/regional/settings?render=overlay','default','Australia/Adelaide','','7.34'),(3837,'/admin/config/regional/settings?render=overlay','default','Australia/Brisbane','','7.34'),(3838,'/admin/config/regional/settings?render=overlay','default','Australia/Broken Hill','','7.34'),(3839,'/admin/config/regional/settings?render=overlay','default','Australia/Currie','','7.34'),(3840,'/admin/config/regional/settings?render=overlay','default','Australia/Darwin','','7.34'),(3841,'/admin/config/regional/settings?render=overlay','default','Australia/Eucla','','7.34'),(3842,'/admin/config/regional/settings?render=overlay','default','Australia/Hobart','','7.34'),(3843,'/admin/config/regional/settings?render=overlay','default','Australia/Lindeman','','7.34'),(3844,'/admin/config/regional/settings?render=overlay','default','Australia/Lord Howe','','7.34'),(3845,'/admin/config/regional/settings?render=overlay','default','Australia/Melbourne','','7.34'),(3846,'/admin/config/regional/settings?render=overlay','default','Australia/Perth','','7.34'),(3847,'/admin/config/regional/settings?render=overlay','default','Australia/Sydney','','7.34'),(3848,'/admin/config/regional/settings?render=overlay','default','Europe/Amsterdam','','7.34'),(3849,'/admin/config/regional/settings?render=overlay','default','Europe/Andorra','','7.34'),(3850,'/admin/config/regional/settings?render=overlay','default','Europe/Athens','','7.34'),(3851,'/admin/config/regional/settings?render=overlay','default','Europe/Belgrade','','7.34'),(3852,'/admin/config/regional/settings?render=overlay','default','Europe/Berlin','','7.34'),(3853,'/admin/config/regional/settings?render=overlay','default','Europe/Bratislava','','7.34'),(3854,'/admin/config/regional/settings?render=overlay','default','Europe/Brussels','','7.34'),(3855,'/admin/config/regional/settings?render=overlay','default','Europe/Bucharest','','7.34'),(3856,'/admin/config/regional/settings?render=overlay','default','Europe/Budapest','','7.34'),(3857,'/admin/config/regional/settings?render=overlay','default','Europe/Busingen','','7.34'),(3858,'/admin/config/regional/settings?render=overlay','default','Europe/Chisinau','','7.34'),(3859,'/admin/config/regional/settings?render=overlay','default','Europe/Copenhagen','','7.34'),(3860,'/admin/config/regional/settings?render=overlay','default','Europe/Dublin','','7.34'),(3861,'/admin/config/regional/settings?render=overlay','default','Europe/Gibraltar','','7.34'),(3862,'/admin/config/regional/settings?render=overlay','default','Europe/Guernsey','','7.34'),(3863,'/admin/config/regional/settings?render=overlay','default','Europe/Helsinki','','7.34'),(3864,'/admin/config/regional/settings?render=overlay','default','Europe/Isle of Man','','7.34'),(3865,'/admin/config/regional/settings?render=overlay','default','Europe/Istanbul','','7.34'),(3866,'/admin/config/regional/settings?render=overlay','default','Europe/Jersey','','7.34'),(3867,'/admin/config/regional/settings?render=overlay','default','Europe/Kaliningrad','','7.34'),(3868,'/admin/config/regional/settings?render=overlay','default','Europe/Kiev','','7.34'),(3869,'/admin/config/regional/settings?render=overlay','default','Europe/Lisbon','','7.34'),(3870,'/admin/config/regional/settings?render=overlay','default','Europe/Ljubljana','','7.34'),(3871,'/admin/config/regional/settings?render=overlay','default','Europe/London','','7.34'),(3872,'/admin/config/regional/settings?render=overlay','default','Europe/Luxembourg','','7.34'),(3873,'/admin/config/regional/settings?render=overlay','default','Europe/Madrid','','7.34'),(3874,'/admin/config/regional/settings?render=overlay','default','Europe/Malta','','7.34'),(3875,'/admin/config/regional/settings?render=overlay','default','Europe/Mariehamn','','7.34'),(3876,'/admin/config/regional/settings?render=overlay','default','Europe/Minsk','','7.34'),(3877,'/admin/config/regional/settings?render=overlay','default','Europe/Monaco','','7.34'),(3878,'/admin/config/regional/settings?render=overlay','default','Europe/Moscow','','7.34'),(3879,'/admin/config/regional/settings?render=overlay','default','Europe/Oslo','','7.34'),(3880,'/admin/config/regional/settings?render=overlay','default','Europe/Paris','','7.34'),(3881,'/admin/config/regional/settings?render=overlay','default','Europe/Podgorica','','7.34'),(3882,'/admin/config/regional/settings?render=overlay','default','Europe/Prague','','7.34'),(3883,'/admin/config/regional/settings?render=overlay','default','Europe/Riga','','7.34'),(3884,'/admin/config/regional/settings?render=overlay','default','Europe/Rome','','7.34'),(3885,'/admin/config/regional/settings?render=overlay','default','Europe/Samara','','7.34'),(3886,'/admin/config/regional/settings?render=overlay','default','Europe/San Marino','','7.34'),(3887,'/admin/config/regional/settings?render=overlay','default','Europe/Sarajevo','','7.34'),(3888,'/admin/config/regional/settings?render=overlay','default','Europe/Simferopol','','7.34'),(3889,'/admin/config/regional/settings?render=overlay','default','Europe/Skopje','','7.34'),(3890,'/admin/config/regional/settings?render=overlay','default','Europe/Sofia','','7.34'),(3891,'/admin/config/regional/settings?render=overlay','default','Europe/Stockholm','','7.34'),(3892,'/admin/config/regional/settings?render=overlay','default','Europe/Tallinn','','7.34'),(3893,'/admin/config/regional/settings?render=overlay','default','Europe/Tirane','','7.34'),(3894,'/admin/config/regional/settings?render=overlay','default','Europe/Uzhgorod','','7.34'),(3895,'/admin/config/regional/settings?render=overlay','default','Europe/Vaduz','','7.34'),(3896,'/admin/config/regional/settings?render=overlay','default','Europe/Vatican','','7.34'),(3897,'/admin/config/regional/settings?render=overlay','default','Europe/Vienna','','7.34'),(3898,'/admin/config/regional/settings?render=overlay','default','Europe/Vilnius','','7.34'),(3899,'/admin/config/regional/settings?render=overlay','default','Europe/Volgograd','','7.34'),(3900,'/admin/config/regional/settings?render=overlay','default','Europe/Warsaw','','7.34'),(3901,'/admin/config/regional/settings?render=overlay','default','Europe/Zagreb','','7.34'),(3902,'/admin/config/regional/settings?render=overlay','default','Europe/Zaporozhye','','7.34'),(3903,'/admin/config/regional/settings?render=overlay','default','Europe/Zurich','','7.34'),(3904,'/admin/config/regional/settings?render=overlay','default','Indian/Antananarivo','','7.34'),(3905,'/admin/config/regional/settings?render=overlay','default','Indian/Chagos','','7.34'),(3906,'/admin/config/regional/settings?render=overlay','default','Indian/Christmas','','7.34'),(3907,'/admin/config/regional/settings?render=overlay','default','Indian/Cocos','','7.34'),(3908,'/admin/config/regional/settings?render=overlay','default','Indian/Comoro','','7.34'),(3909,'/admin/config/regional/settings?render=overlay','default','Indian/Kerguelen','','7.34'),(3910,'/admin/config/regional/settings?render=overlay','default','Indian/Mahe','','7.34'),(3911,'/admin/config/regional/settings?render=overlay','default','Indian/Maldives','','7.34'),(3912,'/admin/config/regional/settings?render=overlay','default','Indian/Mauritius','','7.34'),(3913,'/admin/config/regional/settings?render=overlay','default','Indian/Mayotte','','7.34'),(3914,'/admin/config/regional/settings?render=overlay','default','Indian/Reunion','','7.34'),(3915,'/admin/config/regional/settings?render=overlay','default','Pacific/Apia','','7.34'),(3916,'/admin/config/regional/settings?render=overlay','default','Pacific/Auckland','','7.34'),(3917,'/admin/config/regional/settings?render=overlay','default','Pacific/Chatham','','7.34'),(3918,'/admin/config/regional/settings?render=overlay','default','Pacific/Chuuk','','7.34'),(3919,'/admin/config/regional/settings?render=overlay','default','Pacific/Easter','','7.34'),(3920,'/admin/config/regional/settings?render=overlay','default','Pacific/Efate','','7.34'),(3921,'/admin/config/regional/settings?render=overlay','default','Pacific/Enderbury','','7.34'),(3922,'/admin/config/regional/settings?render=overlay','default','Pacific/Fakaofo','','7.34'),(3923,'/admin/config/regional/settings?render=overlay','default','Pacific/Fiji','','7.34'),(3924,'/admin/config/regional/settings?render=overlay','default','Pacific/Funafuti','','7.34'),(3925,'/admin/config/regional/settings?render=overlay','default','Pacific/Galapagos','','7.34'),(3926,'/admin/config/regional/settings?render=overlay','default','Pacific/Gambier','','7.34'),(3927,'/admin/config/regional/settings?render=overlay','default','Pacific/Guadalcanal','','7.34'),(3928,'/admin/config/regional/settings?render=overlay','default','Pacific/Guam','','7.34'),(3929,'/admin/config/regional/settings?render=overlay','default','Pacific/Honolulu','','7.34'),(3930,'/admin/config/regional/settings?render=overlay','default','Pacific/Johnston','','7.34'),(3931,'/admin/config/regional/settings?render=overlay','default','Pacific/Kiritimati','','7.34'),(3932,'/admin/config/regional/settings?render=overlay','default','Pacific/Kosrae','','7.34'),(3933,'/admin/config/regional/settings?render=overlay','default','Pacific/Kwajalein','','7.34'),(3934,'/admin/config/regional/settings?render=overlay','default','Pacific/Majuro','','7.34'),(3935,'/admin/config/regional/settings?render=overlay','default','Pacific/Marquesas','','7.34'),(3936,'/admin/config/regional/settings?render=overlay','default','Pacific/Midway','','7.34'),(3937,'/admin/config/regional/settings?render=overlay','default','Pacific/Nauru','','7.34'),(3938,'/admin/config/regional/settings?render=overlay','default','Pacific/Niue','','7.34'),(3939,'/admin/config/regional/settings?render=overlay','default','Pacific/Norfolk','','7.34'),(3940,'/admin/config/regional/settings?render=overlay','default','Pacific/Noumea','','7.34'),(3941,'/admin/config/regional/settings?render=overlay','default','Pacific/Pago Pago','','7.34'),(3942,'/admin/config/regional/settings?render=overlay','default','Pacific/Palau','','7.34'),(3943,'/admin/config/regional/settings?render=overlay','default','Pacific/Pitcairn','','7.34'),(3944,'/admin/config/regional/settings?render=overlay','default','Pacific/Pohnpei','','7.34'),(3945,'/admin/config/regional/settings?render=overlay','default','Pacific/Port Moresby','','7.34'),(3946,'/admin/config/regional/settings?render=overlay','default','Pacific/Rarotonga','','7.34'),(3947,'/admin/config/regional/settings?render=overlay','default','Pacific/Saipan','','7.34'),(3948,'/admin/config/regional/settings?render=overlay','default','Pacific/Tahiti','','7.34'),(3949,'/admin/config/regional/settings?render=overlay','default','Pacific/Tarawa','','7.34'),(3950,'/admin/config/regional/settings?render=overlay','default','Pacific/Tongatapu','','7.34'),(3951,'/admin/config/regional/settings?render=overlay','default','Pacific/Wake','','7.34'),(3952,'/admin/config/regional/settings?render=overlay','default','Pacific/Wallis','','7.34'),(3953,'/admin/config/regional/settings?render=overlay','default','UTC','','7.34'),(3954,'/admin/config/regional/settings?render=overlay','default','Locale','','7.34'),(3955,'/admin/config/regional/settings?render=overlay','default','First day of week','','7.34'),(3956,'/admin/config/regional/settings?render=overlay','default','Sunday','','7.34'),(3957,'/admin/config/regional/settings?render=overlay','default','Monday','','7.34'),(3958,'/admin/config/regional/settings?render=overlay','default','Tuesday','','7.34'),(3959,'/admin/config/regional/settings?render=overlay','default','Friday','','7.34'),(3960,'/admin/config/regional/settings?render=overlay','default','Saturday','','7.34'),(3961,'/admin/config/regional/settings?render=overlay','default','Time zones','','7.34'),(3962,'/admin/config/regional/settings?render=overlay','default','Default time zone','','7.34'),(3963,'/admin/config/regional/settings?render=overlay','default','Users may set their own time zone.','','7.34'),(3964,'/admin/config/regional/settings?render=overlay','default','Remind users at login if their time zone is not set.','','7.34'),(3965,'/admin/config/regional/settings?render=overlay','default','Only applied if users may set their own time zone.','','7.34'),(3966,'/admin/config/regional/settings?render=overlay','default','Time zone for new users','','7.34'),(3967,'/admin/config/regional/settings?render=overlay','default','Default time zone.','','7.34'),(3968,'/admin/config/regional/settings?render=overlay','default','Empty time zone.','','7.34'),(3969,'/admin/config/regional/settings?render=overlay','default','Users may set their own time zone at registration.','','7.34'),(3970,'/admin/config/regional/settings?render=overlay','default','- None -','','7.34'),(3971,'/admin/config?render=overlay','default','Chosen JavaScript file','','7.34'),(3972,'/admin/config?render=overlay','default','Installed','','7.34'),(3973,'/admin/config?render=overlay','default','Unknown','','7.34'),(3974,'/admin/config?render=overlay','default','Cloud Zoom','','7.34'),(3975,'/admin/config?render=overlay','default','Source files found in %path.','','7.34'),(3976,'/admin/config?render=overlay','default','GD library PNG support','','7.34'),(3977,'/admin/config?render=overlay','default','CTools CSS Cache','','7.34'),(3978,'/admin/config?render=overlay','default','Exists','','7.34'),(3979,'/admin/config?render=overlay','default','JQuery Cycle plugin','','7.34'),(3980,'/admin/config?render=overlay','default','JQuery ImagesLoaded plugin','','7.34'),(3981,'/admin/config?render=overlay','default','Not found','','7.34'),(3982,'/admin/config?render=overlay','default','For best results, you should download the !name and move the downloaded js file(s) into the %path folder of your server.','','7.34'),(3983,'/admin/config?render=overlay','default','Not enabled','','7.34'),(3984,'/admin/config?render=overlay','default','Your server is capable of displaying file upload progress, but does not have the required libraries. It is recommended to install the <a href=\"http://pecl.php.net/package/uploadprogress\">PECL uploadprogress library</a> (preferred) or to install <a href=\"http://us2.php.net/apc\">APC</a>.','','7.34'),(3985,'/admin/config?render=overlay','default','Upload progress','','7.34'),(3986,'/admin/config?render=overlay','default','Version 2.0 installed','','7.34'),(3987,'/admin/config?render=overlay','default','Version %version installed','','7.34'),(3988,'/admin/config?render=overlay','default','FlexSlider library installed.','','7.34'),(3989,'/admin/config?render=overlay','default','GD library rotate and desaturate effects','','7.34'),(3990,'/admin/config?render=overlay','default','jQuery Update','','7.34'),(3991,'/admin/config?render=overlay','default','jQuery %jquery and jQuery UI %ui','','7.34'),(3992,'/admin/config?render=overlay','default','If the site is experiencing problems with permissions to content, you may have to rebuild the permissions cache. Rebuilding will remove all privileges to content and replace them with permissions based on the current modules and settings. Rebuilding may take some time if there is a lot of content or complex permission settings. After rebuilding has completed, content will automatically use the new permissions.','','7.34'),(3993,'/admin/config?render=overlay','default','Node Access Permissions','','7.34'),(3994,'/admin/config?render=overlay','default','Rebuild permissions','','7.34'),(3995,'/admin/config?render=overlay','default','Drupal','','7.34'),(3996,'/admin/config?render=overlay','default','Web server','','7.34'),(3997,'/admin/config?render=overlay','default','more information','','7.34'),(3998,'/admin/config?render=overlay','default','PHP register globals','','7.34'),(3999,'/admin/config?render=overlay','default','PHP extensions','','7.34'),(4000,'/admin/config?render=overlay','default','Database system','','7.34'),(4001,'/admin/config?render=overlay','default','Database system version','','7.34'),(4002,'/admin/config?render=overlay','default','PHP memory limit','','7.34'),(4003,'/admin/config?render=overlay','default','Protected','','7.34'),(4004,'/admin/config?render=overlay','default','Configuration file','','7.34'),(4005,'/admin/config?render=overlay','default','Public files directory','','7.34'),(4006,'/admin/config?render=overlay','default','Temporary files directory','','7.34'),(4007,'/admin/config?render=overlay','default','For more information, see the online handbook entry for <a href=\"@cron-handbook\">configuring cron jobs</a>.','','7.34'),(4008,'/admin/config?render=overlay','default','@count min','','7.34'),(4009,'/admin/config?render=overlay','default','@count sec','','7.34'),(4010,'/admin/config?render=overlay','default','Last run !time ago','','7.34'),(4011,'/admin/config?render=overlay','default','You can <a href=\"@cron\">run cron manually</a>.','','7.34'),(4012,'/admin/config?render=overlay','default','To run cron from outside the site, go to <a href=\"!cron\">!cron</a>','','7.34'),(4013,'/admin/config?render=overlay','default','Cron maintenance tasks','','7.34'),(4014,'/admin/config?render=overlay','default','Writable (<em>public</em> download method)','','7.34'),(4015,'/admin/config?render=overlay','default','Database updates','','7.34'),(4016,'/admin/config?render=overlay','default','Up to date','','7.34'),(4017,'/admin/config?render=overlay','default','Access to update.php','','7.34'),(4018,'/admin/config?render=overlay','default','Standard PHP','','7.34'),(4019,'/admin/config?render=overlay','default','PHP Mbstring Extension','','7.34'),(4020,'/admin/config?render=overlay','default','Unicode library','','7.34'),(4021,'/admin/config?render=overlay','default','Update notifications','','7.34'),(4022,'/admin/config?render=overlay','default','The following tokens or token types are not defined as arrays:','','7.34'),(4023,'/admin/config?render=overlay','default','The following tokens or token types are missing required name and/or description information:','','7.34'),(4024,'/admin/config?render=overlay','default','The following token types do not have any tokens defined:','','7.34'),(4025,'/admin/config?render=overlay','default','The following token types are not defined but have tokens:','','7.34'),(4026,'/admin/config?render=overlay','default','The following token or token types are defined by multiple modules:','','7.34'),(4027,'/admin/config?render=overlay','default','jQuery Cycle Library','','7.34'),(4028,'/admin/config?render=overlay','default','Hide descriptions','','7.34'),(4029,'/admin/config?render=overlay','default','Compress layout by hiding descriptions.','','7.34'),(4030,'/admin/config/regional/language?render=overlay&render=overlay','default','Configuration saved.','','7.34'),(4031,'sites/all/modules/ckeditor/includes/ckeditor.utils.js','default','Content can only be inserted into CKEditor in the WYSIWYG mode.','','none'),(4032,'/admin/config/development/performance?render=overlay','default','Clear all caches','','7.34'),(4033,'/admin/config/development/performance?render=overlay','default','Caching','','7.34'),(4034,'/admin/config/development/performance?render=overlay','default','Cache pages for anonymous users','','7.34'),(4035,'/admin/config/development/performance?render=overlay','default','0 sec','','7.34'),(4036,'/admin/config/development/performance?render=overlay','default','1 min','','7.34'),(4037,'/admin/config/development/performance?render=overlay','default','1 hour','','7.34'),(4038,'/admin/config/development/performance?render=overlay','default','@count hours','','7.34'),(4039,'/admin/config/development/performance?render=overlay','default','1 day','','7.34'),(4040,'/admin/config/development/performance?render=overlay','default','none','','7.34'),(4041,'/admin/config/development/performance?render=overlay','default','Minimum cache lifetime','','7.34'),(4042,'/admin/config/development/performance?render=overlay','default','Cached pages will not be re-created until at least this much time has elapsed.','','7.34'),(4043,'/admin/config/development/performance?render=overlay','default','Expiration of cached pages','','7.34'),(4044,'/admin/config/development/performance?render=overlay','default','The maximum time an external cache can use an old version of a page.','','7.34'),(4045,'/admin/config/development/performance?render=overlay','default','Bandwidth optimization','','7.34'),(4046,'/admin/config/development/performance?render=overlay','default','External resources can be optimized automatically, which can reduce both the size and number of requests made to your website.','','7.34'),(4047,'/admin/config/development/performance?render=overlay','default','Compress cached pages.','','7.34'),(4048,'/admin/config/development/performance?render=overlay','default','Aggregate and compress CSS files.','','7.34'),(4049,'/admin/config/development/performance?render=overlay','default','Aggregate JavaScript files.','','7.34'),(4050,'/admin/config/development/performance?render=overlay','default','Cache blocks','','7.34'),(4051,'/admin/config/development/performance?render=overlay&render=overlay','default','Field type(s) in use - see <a href=\"@fields-page\">Field list</a>','','7.34'),(4052,'/admin/config/development/performance?render=overlay&render=overlay','default','Database service','','7.34'),(4053,'/admin/config/development/performance?render=overlay&render=overlay','default','<p>Index items using multiple database tables, for simple searches.</p><ul><li>All field types are supported and indexed in a special way, with URI/String and Integer/Duration being equivalent.</li><li>The \"direct\" parse mode results in the keys being normally split around white-space, only preprocessing might differ.</li><li>Currently, phrase queries are not supported.</li></ul>','','7.34'),(4054,'/admin/config/development/performance?render=overlay&render=overlay','default','Service class in use by the following server: !servers.','','7.34'),(4055,'/admin/config/development/performance?render=overlay&render=overlay','default','Simple (with optional filter by bundle)','','7.34'),(4056,'/admin/config/development/performance?render=overlay&render=overlay','default','Views: Filter by an entity reference view','','7.34'),(4057,'/admin/config/development/performance?render=overlay&render=overlay','default','Taxonomy index','','7.34'),(4058,'/admin/config/development/performance?render=overlay&render=overlay','default','Include the term references created by instances of this field carried by node entities in the core {taxonomy_index} table. This will allow various modules to handle them like core term_reference fields.','','7.34'),(4059,'/admin/config/development/performance?render=overlay&render=overlay','default','Render Views filters as select list','','7.34'),(4060,'/admin/config/development/performance?render=overlay&render=overlay','default','Provides a select list for Views filters on this field. This should not be used when there are over 100 entities, as it might cause an out of memory error.','','7.34'),(4061,'/admin/config/development/performance?render=overlay&render=overlay','default','@entity_label from context','','7.34'),(4062,'/admin/config/development/performance?render=overlay&render=overlay','default','Picks a @entity_label from the current context.','','7.34'),(4063,'/admin/config/development/performance?render=overlay&render=overlay','default','Random @entity_label','','7.34'),(4064,'/admin/config/development/performance?render=overlay&render=overlay','default','Picks a random @entity_label from the database.','','7.34'),(4065,'/admin/config/development/performance?render=overlay&render=overlay','default','User-defined @entity_label','','7.34'),(4066,'/admin/config/development/performance?render=overlay&render=overlay','default','Uses a user-defined @entity_label.','','7.34'),(4067,'/admin/config/development/performance?render=overlay&render=overlay','default','Content revisions','','7.34'),(4068,'/admin/config/development/performance?render=overlay&render=overlay','default','Orders in this state have not been completed by the customer yet.','','7.34'),(4069,'/admin/config/development/performance?render=overlay&render=overlay','default','Orders in this state have begun but not completed the checkout process.','','7.34'),(4070,'/admin/config/development/performance?render=overlay&render=overlay','default','Orders in this state have been canceled through some user action.','','7.34'),(4071,'/admin/config/development/performance?render=overlay&render=overlay','default','Orders in this state have been created and are awaiting further action.','','7.34'),(4072,'/admin/config/development/performance?render=overlay&render=overlay','default','Orders in this state have been completed as far as the customer is concerned.','','7.34'),(4073,'/admin/config/development/performance?render=overlay&render=overlay','default','Search service: @name','','7.34'),(4074,'/admin/config/development/performance?render=overlay&render=overlay','default','Lullabot','','7.34'),(4075,'/admin/config/development/performance?render=overlay&render=overlay','default','Convert config TB MegaMenu to MegaMenu-VX','','7.34'),(4076,'/admin/config/development/performance?render=overlay&render=overlay','default','The <em>Blocks</em> realm displays each facet in a separate <a href=\"@block-page\">block</a>. Users are able to refine their searches in a drill-down fashion.','','7.34'),(4077,'/admin/config/development/performance?render=overlay&render=overlay','default','Defaults','','7.34'),(4078,'/admin/config/development/performance?render=overlay&render=overlay','default','Image gallery','','7.34'),(4079,'/admin/config/development/performance?render=overlay&render=overlay','default','Gallery page','','7.34'),(4080,'/admin/config/development/performance?render=overlay&render=overlay','default','%1','','7.34'),(4081,'/admin/config/development/performance?render=overlay&render=overlay','default','<a href=\"#\" class=\"product-display-type active\" data-type=\"products-grid\" ><i class=\"fa fa-th\"></i></a>\n<a href=\"#\" class=\"product-display-type\" data-type=\"products-list\" ><i class=\"fa fa-list\"></i></a>','','7.34'),(4082,'/admin/config/development/performance?render=overlay&render=overlay','default','Sorry! No results found','','7.34'),(4083,'/admin/config/development/performance?render=overlay&render=overlay','default','Yes','','7.34'),(4084,'/admin/config/development/performance?render=overlay&render=overlay','default','No','','7.34'),(4085,'/admin/config/development/performance?render=overlay&render=overlay','default','False','','7.34'),(4086,'/admin/config/development/performance?render=overlay&render=overlay','default','On','','7.34'),(4087,'/admin/config/development/performance?render=overlay&render=overlay','default','Off','','7.34'),(4088,'/admin/config/development/performance?render=overlay&render=overlay','default','Custom','','7.34'),(4089,'/admin/config/development/performance?render=overlay&render=overlay','default','Filter by names containing','','7.34'),(4090,'/admin/config/development/performance?render=overlay&render=overlay','default','Updated','','7.34'),(4091,'/admin/config/development/performance?render=overlay&render=overlay','default','-','','7.34'),(4092,'/admin/config/development/performance?render=overlay&render=overlay','default','Customer profile referenced by commerce_customer_billing','','7.34'),(4093,'/admin/config/development/performance?render=overlay&render=overlay','default','There are currently no shopping cart orders.','','7.34'),(4094,'/admin/config/development/performance?render=overlay&render=overlay','default','Revision','','7.34'),(4095,'/admin/config/development/performance?render=overlay&render=overlay','default','Created on','','7.34'),(4096,'/admin/config/development/performance?render=overlay&render=overlay','default','Created by','','7.34'),(4097,'/admin/config/development/performance?render=overlay&render=overlay','default','Filter by SKUs containing','','7.34'),(4098,'/admin/config/development/performance?render=overlay&render=overlay','default','Publish comment','','7.34'),(4099,'/admin/config/development/performance?render=overlay&render=overlay','default','Unpublish comment','','7.34'),(4100,'/admin/config/development/performance?render=overlay&render=overlay','default','Unpublish comment containing keyword(s)','','7.34'),(4101,'/admin/config/development/performance?render=overlay&render=overlay','default','Save comment','','7.34'),(4102,'/admin/config/development/performance?render=overlay&render=overlay','default','Enable country','','7.34'),(4103,'/admin/config/development/performance?render=overlay&render=overlay','default','Disable country','','7.34'),(4104,'/admin/config/development/performance?render=overlay&render=overlay','default','Display a message to the user','','7.34'),(4105,'/admin/config/development/performance?render=overlay&render=overlay','default','Send e-mail','','7.34'),(4106,'/admin/config/development/performance?render=overlay&render=overlay','default','Ban IP address of current user','','7.34'),(4107,'/admin/config/development/performance?render=overlay&render=overlay','default','Redirect to URL','','7.34'),(4108,'/admin/config/development/performance?render=overlay&render=overlay','default','Block current user','','7.34'),(4109,'/admin/config/development/performance?render=overlay&render=overlay','default','Update node alias','','7.34'),(4110,'/admin/config/development/performance?render=overlay&render=overlay','default','Update taxonomy term alias','','7.34'),(4111,'/admin/config/development/performance?render=overlay&render=overlay','default','Update user alias','','7.34'),(4112,'/admin/config/development/performance?render=overlay&render=overlay','default','Featured','','7.34'),(4113,'/admin/config/development/performance?render=overlay&render=overlay','default','Triptych first','','7.34'),(4114,'/admin/config/development/performance?render=overlay&render=overlay','default','Triptych middle','','7.34'),(4115,'/admin/config/development/performance?render=overlay&render=overlay','default','Triptych last','','7.34'),(4116,'/admin/config/development/performance?render=overlay&render=overlay','default','Footer first column','','7.34'),(4117,'/admin/config/development/performance?render=overlay&render=overlay','default','Footer second column','','7.34'),(4118,'/admin/config/development/performance?render=overlay&render=overlay','default','Footer third column','','7.34'),(4119,'/admin/config/development/performance?render=overlay&render=overlay','default','Footer fourth column','','7.34'),(4120,'/admin/config/development/performance?render=overlay&render=overlay','default','Recent comments','','7.34'),(4121,'/admin/config/development/performance?render=overlay&render=overlay','default','Context editor','','7.34'),(4122,'/admin/config/development/performance?render=overlay&render=overlay','default','Context inspector','','7.34'),(4123,'/admin/config/development/performance?render=overlay&render=overlay','default','Standard URL processors','','7.34'),(4124,'/admin/config/development/performance?render=overlay&render=overlay','default','Filter by @type.','','7.34'),(4125,'/admin/config/development/performance?render=overlay&render=overlay','default','(Caution: This may perform very poorly for large result sets.)','','7.34'),(4126,'/admin/config/development/performance?render=overlay&render=overlay','default','Local','','7.34'),(4127,'/admin/config/development/performance?render=overlay&render=overlay','default','Fancy attributes','','7.34'),(4128,'/admin/config/development/performance?render=overlay&render=overlay','default','Links','','7.34'),(4129,'/admin/config/development/performance?render=overlay&render=overlay','default','Links with checkboxes','','7.34'),(4130,'/admin/config/development/performance?render=overlay&render=overlay','default','Ranges: Min/Max UI Slider','','7.34'),(4131,'/admin/config/development/performance?render=overlay&render=overlay','default','Ranges: Text links','','7.34'),(4132,'/admin/config/development/performance?render=overlay&render=overlay','default','Ranges: Text links with checkboxes','','7.34'),(4133,'/admin/config/development/performance?render=overlay&render=overlay','default','Ranges: Drop down list','','7.34'),(4134,'/admin/config/development/performance?render=overlay&render=overlay','default','User interface text','','7.34'),(4135,'/admin/config/development/performance?render=overlay&render=overlay','default','Order of language detection methods for user interface text. If a translation of user interface text is available in the detected language, it will be displayed.','','7.34'),(4136,'/admin/config/development/performance?render=overlay&render=overlay','default','Order of language detection methods for content. If a version of content is available in the detected language, it will be displayed.','','7.34'),(4137,'/admin/config/development/performance?render=overlay&render=overlay','default','Language switcher (@type)','','7.34'),(4138,'/admin/config/development/performance?render=overlay&render=overlay','default','Syndicate','','7.34'),(4139,'/admin/config/development/performance?render=overlay&render=overlay','default','Recent content','','7.34'),(4140,'/admin/config/development/performance?render=overlay&render=overlay','default','Search form','','7.34'),(4141,'/admin/config/development/performance?render=overlay&render=overlay','default','Search sorts','','7.34'),(4142,'/admin/config/development/performance?render=overlay&render=overlay','default','Newsletter: Multi Subscription','','7.34'),(4143,'/admin/config/development/performance?render=overlay&render=overlay','default','Newsletter: @title','','7.34'),(4144,'/admin/config/development/performance?render=overlay&render=overlay','default','Main page content','','7.34'),(4145,'/admin/config/development/performance?render=overlay&render=overlay','default','Powered by Drupal','','7.34'),(4146,'/admin/config/development/performance?render=overlay&render=overlay','default','System help','','7.34'),(4147,'/admin/config/development/performance?render=overlay&render=overlay','default','Tags in @voc','','7.34'),(4148,'/admin/config/development/performance?render=overlay&render=overlay','default','User login','','7.34'),(4149,'/admin/config/development/performance?render=overlay&render=overlay','default','Who\'s new','','7.34'),(4150,'/admin/config/development/performance?render=overlay&render=overlay','default','Who\'s online','','7.34'),(4151,'/admin/config/development/performance?render=overlay&render=overlay','default','View: !view','','7.34'),(4152,'/admin/config/development/performance?render=overlay&render=overlay','default','View: !view: !display','','7.34'),(4153,'/admin/config/development/performance?render=overlay&render=overlay','default','Exposed form: @view-@display_id','','7.34'),(4154,'/admin/config/development/performance?render=overlay&render=overlay','default','Sales','','7.34'),(4155,'/admin/config/development/performance?render=overlay&render=overlay','default','Execute PHP','','7.34'),(4156,'/admin/config/development/performance?render=overlay&render=overlay','default','Switch user','','7.34'),(4157,'/admin/config/development/performance?render=overlay&render=overlay','default','View store funds account','','7.34'),(4158,'/admin/config/development/performance?render=overlay&render=overlay','default','View store funds transactions','','7.34'),(4159,'/admin/config/development/performance?render=overlay&render=overlay','default','Create new %bundle transaction using store\'s funds account','','7.34'),(4160,'/admin/config/development/performance?render=overlay&render=overlay','default','Edit store withdraw methods of any type','','7.34'),(4161,'/admin/config/development/performance?render=overlay&render=overlay','default','Delete store withdraw methods of any type','','7.34'),(4162,'/admin/config/development/performance?render=overlay&render=overlay','default','Access store\'s withdraw methods overview page','','7.34'),(4163,'/admin/config/development/performance?render=overlay&render=overlay','default','View store\'s %bundle withdraw method','','7.34'),(4164,'/admin/config/development/performance?render=overlay&render=overlay','default','Edit store\'s %bundle withdraw method','','7.34'),(4165,'/admin/config/development/performance?render=overlay&render=overlay','default','Administer store members','','7.34'),(4166,'/admin/config/development/performance?render=overlay&render=overlay','default','Edit store','','7.34'),(4167,'/admin/config/development/performance?render=overlay&render=overlay','default','View store page','','7.34'),(4168,'/admin/config/development/performance?render=overlay&render=overlay','default','Add new members to the store','','7.34'),(4169,'/admin/config/development/performance?render=overlay&render=overlay','default','Change permissions for store roles','','7.34'),(4170,'/admin/config/development/performance?render=overlay&render=overlay','default','View store roles list','','7.34'),(4171,'/admin/config/development/performance?render=overlay&render=overlay','default','Create new store roles','','7.34'),(4172,'/admin/config/development/performance?render=overlay&render=overlay','default','Edit store roles','','7.34'),(4173,'/admin/config/development/performance?render=overlay&render=overlay','default','Create products for the store','','7.34'),(4174,'/admin/config/development/performance?render=overlay&render=overlay','default','View store orders','','7.34'),(4175,'/admin/config/development/performance?render=overlay&render=overlay','default','Edit store orders','','7.34'),(4176,'/admin/config/development/performance?render=overlay&render=overlay','default','Delete store orders','','7.34'),(4177,'/admin/config/development/performance?render=overlay&render=overlay','default','Title (Fulltext)','','7.34'),(4178,'/admin/config/development/performance?render=overlay&render=overlay','default','A Fulltext aggregation of the title field.','','7.34'),(4179,'/admin/config/development/performance?render=overlay&render=overlay','default','Fulltext','','7.34'),(4180,'/admin/config/development/performance?render=overlay&render=overlay','default','String','','7.34'),(4181,'/admin/config/development/performance?render=overlay&render=overlay','default','Date','','7.34'),(4182,'/admin/config/development/performance?render=overlay&render=overlay','default','Duration','','7.34'),(4183,'/admin/config/development/performance?render=overlay&render=overlay','default','@field name (Fulltext)','','7.34'),(4184,'/admin/config/development/performance?render=overlay&render=overlay','default','Name property of @field as fulltext','','7.34'),(4185,'/admin/config/development/performance?render=overlay&render=overlay','default','Delete shipping line items on shopping cart updates','','7.34'),(4186,'/admin/config/development/performance?render=overlay&render=overlay','default','Site-wide settings and other global information.','','7.34'),(4187,'/admin/config/development/performance?render=overlay&render=overlay','default','Rate @title','','7.34'),(4188,'/admin/config/development/performance?render=overlay&render=overlay','default','Collect rates: @title','','7.34'),(4189,'/admin/config/development/performance?render=overlay&render=overlay','default','Display an Add to Cart message','','7.34'),(4190,'/admin/config/development/performance?render=overlay&render=overlay','default','Reset the cart order status on product add or remove','','7.34'),(4191,'/admin/config/development/performance?render=overlay&render=overlay','default','Unset the price of disabled products in the cart','','7.34'),(4192,'/admin/config/development/performance?render=overlay&render=overlay','default','Set the order created date to the checkout completion date','','7.34'),(4193,'/admin/config/development/performance?render=overlay&render=overlay','default','Update the order status on checkout completion','','7.34'),(4194,'/admin/config/development/performance?render=overlay&render=overlay','default','Assign an anonymous order to a pre-existing user','','7.34'),(4195,'/admin/config/development/performance?render=overlay&render=overlay','default','Fetched account','','7.34'),(4196,'/admin/config/development/performance?render=overlay&render=overlay','default','Create a new account for an anonymous order','','7.34'),(4197,'/admin/config/development/performance?render=overlay&render=overlay','default','Created account','','7.34'),(4198,'/admin/config/development/performance?render=overlay&render=overlay','default','Send an order notification e-mail','','7.34'),(4199,'/admin/config/development/performance?render=overlay&render=overlay','default','Order [commerce-order:order-number] at [site:name]','','7.34'),(4200,'/admin/config/development/performance?render=overlay&render=overlay','default','Thanks for your order [commerce-order:order-number] at [site:name].\n\nIf this is your first order with us, you will receive a separate e-mail with login instructions. You can view your order history with us at any time by logging into our website at:\n\n[site:login-url]\n\nYou can find the status of your current order at:\n\n[commerce-order:customer-url]\n\nPlease contact us if you have any questions about your order.','','7.34'),(4201,'/admin/config/development/performance?render=overlay&render=overlay','default','Before adding a product to the cart','','7.34'),(4202,'/admin/config/development/performance?render=overlay&render=overlay','default','Shopping cart order','','7.34'),(4203,'/admin/config/development/performance?render=overlay&render=overlay','default','After adding a product to the cart','','7.34'),(4204,'/admin/config/development/performance?render=overlay&render=overlay','default','Product line item','','7.34'),(4205,'/admin/config/development/performance?render=overlay&render=overlay','default','Unchanged product line item','','7.34'),(4206,'/admin/config/development/performance?render=overlay&render=overlay','default','After removing a product from the cart','','7.34'),(4207,'/admin/config/development/performance?render=overlay&render=overlay','default','Completing the checkout process','','7.34'),(4208,'/admin/config/development/performance?render=overlay&render=overlay','default','Completed order','a drupal commerce order','7.34'),(4209,'/admin/config/development/performance?render=overlay&render=overlay','default','Select available payment methods for an order','','7.34'),(4210,'/admin/config/development/performance?render=overlay&render=overlay','default','unchanged entity','','7.34'),(4211,'/admin/config/development/performance?render=overlay&render=overlay','default','Last completed transaction','','7.34'),(4212,'/admin/config/development/performance?render=overlay&render=overlay','default','When an order is first paid in full','','7.34'),(4213,'/admin/config/development/performance?render=overlay&render=overlay','default','Calculating the sell price of a product','','7.34'),(4214,'/admin/config/development/performance?render=overlay&render=overlay','default','Collecting shipping rates for an order','','7.34'),(4215,'/admin/config/development/performance?render=overlay&render=overlay','default','Calculating a shipping rate','','7.34'),(4216,'/admin/config/development/performance?render=overlay&render=overlay','default','Shipping line item','','7.34'),(4217,'/admin/config/development/performance?render=overlay&render=overlay','default','Check if a product is in stock when adding to cart','','7.34'),(4218,'/admin/config/development/performance?render=overlay&render=overlay','default','Requested Quantity','','7.34'),(4219,'/admin/config/development/performance?render=overlay&render=overlay','default','Quantity already ordered (in the cart)','','7.34'),(4220,'/admin/config/development/performance?render=overlay&render=overlay','default','Quantity requested + already ordered','','7.34'),(4221,'/admin/config/development/performance?render=overlay&render=overlay','default','Check if a product add to cart form should be enabled (is in stock)','','7.34'),(4222,'/admin/config/development/performance?render=overlay&render=overlay','default','Check if a product is in stock before continuing to checkout','','7.34'),(4223,'/admin/config/development/performance?render=overlay&render=overlay','default','After saving a new @entity','','7.34'),(4224,'/admin/config/development/performance?render=overlay&render=overlay','default','created @entity','','7.34'),(4225,'/admin/config/development/performance?render=overlay&render=overlay','default','After updating an existing @entity','','7.34'),(4226,'/admin/config/development/performance?render=overlay&render=overlay','default','updated @entity','','7.34'),(4227,'/admin/config/development/performance?render=overlay&render=overlay','default','Before saving a @entity','','7.34'),(4228,'/admin/config/development/performance?render=overlay&render=overlay','default','saved @entity','','7.34'),(4229,'/admin/config/development/performance?render=overlay&render=overlay','default','After deleting a @entity','','7.34'),(4230,'/admin/config/development/performance?render=overlay&render=overlay','default','deleted @entity','','7.34'),(4231,'/admin/config/development/performance?render=overlay&render=overlay','default','@entity is viewed','','7.34'),(4232,'/admin/config/development/performance?render=overlay&render=overlay','default','viewed @entity','','7.34'),(4233,'/admin/config/development/performance?render=overlay&render=overlay','default','view mode','','7.34'),(4234,'/admin/config/development/performance?render=overlay&render=overlay','default','After saving new content','','7.34'),(4235,'/admin/config/development/performance?render=overlay&render=overlay','default','created content','','7.34'),(4236,'/admin/config/development/performance?render=overlay&render=overlay','default','After updating existing content','','7.34'),(4237,'/admin/config/development/performance?render=overlay&render=overlay','default','updated content','','7.34'),(4238,'/admin/config/development/performance?render=overlay&render=overlay','default','unchanged content','','7.34'),(4239,'/admin/config/development/performance?render=overlay&render=overlay','default','Before saving content','','7.34'),(4240,'/admin/config/development/performance?render=overlay&render=overlay','default','saved content','','7.34'),(4241,'/admin/config/development/performance?render=overlay&render=overlay','default','Content is viewed','','7.34'),(4242,'/admin/config/development/performance?render=overlay&render=overlay','default','Note that if drupal\'s page cache is enabled, this event won\'t be generated for pages served from cache.','','7.34'),(4243,'/admin/config/development/performance?render=overlay&render=overlay','default','viewed content','','7.34'),(4244,'/admin/config/development/performance?render=overlay&render=overlay','default','After deleting content','','7.34'),(4245,'/admin/config/development/performance?render=overlay&render=overlay','default','deleted content','','7.34'),(4246,'/admin/config/development/performance?render=overlay&render=overlay','default','Drupal is initializing','','7.34'),(4247,'/admin/config/development/performance?render=overlay&render=overlay','default','Be aware that some actions might initialize the theme system. After that, it\'s impossible for any module to change the used theme.','','7.34'),(4248,'/admin/config/development/performance?render=overlay&render=overlay','default','Cron maintenance tasks are performed','','7.34'),(4249,'/admin/config/development/performance?render=overlay&render=overlay','default','System log entry is created','','7.34'),(4250,'/admin/config/development/performance?render=overlay&render=overlay','default','Log entry','','7.34'),(4251,'/admin/config/development/performance?render=overlay&render=overlay','default','After saving a new user account','','7.34'),(4252,'/admin/config/development/performance?render=overlay&render=overlay','default','registered user','','7.34'),(4253,'/admin/config/development/performance?render=overlay&render=overlay','default','After updating an existing user account','','7.34'),(4254,'/admin/config/development/performance?render=overlay&render=overlay','default','updated user','','7.34'),(4255,'/admin/config/development/performance?render=overlay&render=overlay','default','unchanged user','','7.34'),(4256,'/admin/config/development/performance?render=overlay&render=overlay','default','Before saving a user account','','7.34'),(4257,'/admin/config/development/performance?render=overlay&render=overlay','default','saved user','','7.34'),(4258,'/admin/config/development/performance?render=overlay&render=overlay','default','User account page is viewed','','7.34'),(4259,'/admin/config/development/performance?render=overlay&render=overlay','default','viewed user','','7.34'),(4260,'/admin/config/development/performance?render=overlay&render=overlay','default','After a user account has been deleted','','7.34'),(4261,'/admin/config/development/performance?render=overlay&render=overlay','default','deleted user','','7.34'),(4262,'/admin/config/development/performance?render=overlay&render=overlay','default','User has logged in','','7.34'),(4263,'/admin/config/development/performance?render=overlay&render=overlay','default','logged in user','','7.34'),(4264,'/admin/config/development/performance?render=overlay&render=overlay','default','User has logged out','','7.34'),(4265,'/admin/config/development/performance?render=overlay&render=overlay','default','logged out user','','7.34'),(4266,'/admin/config/development/performance?render=overlay&render=overlay','default','After saving a new comment','','7.34'),(4267,'/admin/config/development/performance?render=overlay&render=overlay','default','created comment','','7.34'),(4268,'/admin/config/development/performance?render=overlay&render=overlay','default','After updating an existing comment','','7.34'),(4269,'/admin/config/development/performance?render=overlay&render=overlay','default','updated comment','','7.34'),(4270,'/admin/config/development/performance?render=overlay&render=overlay','default','unchanged comment','','7.34'),(4271,'/admin/config/development/performance?render=overlay&render=overlay','default','Before saving a comment','','7.34'),(4272,'/admin/config/development/performance?render=overlay&render=overlay','default','saved comment','','7.34'),(4273,'/admin/config/development/performance?render=overlay&render=overlay','default','A comment is viewed','','7.34'),(4274,'/admin/config/development/performance?render=overlay&render=overlay','default','viewed comment','','7.34'),(4275,'/admin/config/development/performance?render=overlay&render=overlay','default','After deleting a comment','','7.34'),(4276,'/admin/config/development/performance?render=overlay&render=overlay','default','deleted comment','','7.34'),(4277,'/admin/config/development/performance?render=overlay&render=overlay','default','After saving a new term','','7.34'),(4278,'/admin/config/development/performance?render=overlay&render=overlay','default','created term','','7.34'),(4279,'/admin/config/development/performance?render=overlay&render=overlay','default','After updating an existing term','','7.34'),(4280,'/admin/config/development/performance?render=overlay&render=overlay','default','updated term','','7.34'),(4281,'/admin/config/development/performance?render=overlay&render=overlay','default','unchanged term','','7.34'),(4282,'/admin/config/development/performance?render=overlay&render=overlay','default','Before saving a taxonomy term','','7.34'),(4283,'/admin/config/development/performance?render=overlay&render=overlay','default','saved term','','7.34'),(4284,'/admin/config/development/performance?render=overlay&render=overlay','default','After deleting a term','','7.34'),(4285,'/admin/config/development/performance?render=overlay&render=overlay','default','deleted term','','7.34'),(4286,'/admin/config/development/performance?render=overlay&render=overlay','default','After saving a new vocabulary','','7.34'),(4287,'/admin/config/development/performance?render=overlay&render=overlay','default','created vocabulary','','7.34'),(4288,'/admin/config/development/performance?render=overlay&render=overlay','default','After updating an existing vocabulary','','7.34'),(4289,'/admin/config/development/performance?render=overlay&render=overlay','default','updated vocabulary','','7.34'),(4290,'/admin/config/development/performance?render=overlay&render=overlay','default','unchanged vocabulary','','7.34'),(4291,'/admin/config/development/performance?render=overlay&render=overlay','default','Before saving a vocabulary','','7.34'),(4292,'/admin/config/development/performance?render=overlay&render=overlay','default','saved vocabulary','','7.34'),(4293,'/admin/config/development/performance?render=overlay&render=overlay','default','After deleting a vocabulary','','7.34'),(4294,'/admin/config/development/performance?render=overlay&render=overlay','default','deleted vocabulary','','7.34'),(4295,'/admin/config/development/performance?render=overlay&render=overlay','default','Create funds payment transaction for store order','','7.34'),(4296,'/admin/config/development/performance?render=overlay&render=overlay','default','The list to loop over. The loop will step through each item in the list, allowing further actions on them. See <a href=\"@url\"> the online handbook</a> for more information on how to use loops.','','7.34'),(4297,'/admin/config/development/performance?render=overlay&render=overlay','default','FontAwsome: Icons','','7.34'),(4298,'/admin/config/development/performance?render=overlay&render=overlay','default','Lullacons: Pack 1','','7.34'),(4299,'/admin/config/development/performance?render=overlay&render=overlay','default','Caches cleared.','','7.34'),(4300,'/admin/config/development/performance?render=overlay&render=overlay','default','Presents month, day, and year fields.','','7.34'),(4301,'/admin/config/development/performance?render=overlay&render=overlay','default','A special textfield that accepts e-mail addresses.','','7.34'),(4302,'/admin/config/development/performance?render=overlay&render=overlay','default','Fieldsets allow you to organize multiple fields into groups.','','7.34'),(4303,'/admin/config/development/performance?render=overlay&render=overlay','default','Allows creation of grid questions, denoted by radio buttons.','','7.34'),(4304,'/admin/config/development/performance?render=overlay&render=overlay','default','A field which is not visible to the user, but is recorded with the submission.','','7.34'),(4305,'/admin/config/development/performance?render=overlay&render=overlay','default','Markup','','7.34'),(4306,'/admin/config/development/performance?render=overlay&render=overlay','default','Displays text as HTML in the form; does not render a field.','','7.34'),(4307,'/admin/config/development/performance?render=overlay&render=overlay','default','A numeric input field (either as textfield or select list).','','7.34'),(4308,'/admin/config/development/performance?render=overlay&render=overlay','default','Page break','','7.34'),(4309,'/admin/config/development/performance?render=overlay&render=overlay','default','Organize forms into multiple pages.','','7.34'),(4310,'/admin/config/development/performance?render=overlay&render=overlay','default','Select options','','7.34'),(4311,'/admin/config/development/performance?render=overlay&render=overlay','default','Allows creation of checkboxes, radio buttons, or select menus.','','7.34'),(4312,'/admin/config/development/performance?render=overlay&render=overlay','default','Textarea','','7.34'),(4313,'/admin/config/development/performance?render=overlay&render=overlay','default','A large text area that allows for multiple lines of input.','','7.34'),(4314,'/admin/config/development/performance?render=overlay&render=overlay','default','Textfield','','7.34'),(4315,'/admin/config/development/performance?render=overlay&render=overlay','default','Basic textfield type.','','7.34'),(4316,'/admin/config/development/performance?render=overlay&render=overlay','default','Time','','7.34'),(4317,'/admin/config/development/performance?render=overlay&render=overlay','default','Presents the user with hour and minute fields. Optional am/pm fields.','','7.34'),(4318,'/admin/config/development/performance?render=overlay&render=overlay','default','Allow users to upload files of configurable types.','','7.34'),(4319,'/admin/config/development/performance?render=overlay&render=overlay','default','Vocabulary terms','','7.34'),(4320,'/admin/config/development/performance?render=overlay&render=overlay','default','All the terms in a vocabulary.','','7.34'),(4321,'/admin/config/development/performance?render=overlay&render=overlay','default','User picture','','7.34'),(4322,'/admin/config/development/performance?render=overlay&render=overlay','default','The picture of a user.','','7.34'),(4323,'/admin/config/development/performance?render=overlay&render=overlay','default','User profile','','7.34'),(4324,'/admin/config/development/performance?render=overlay&render=overlay','default','The profile of a user.','','7.34'),(4325,'/admin/config/development/performance?render=overlay&render=overlay','default','User signature','','7.34'),(4326,'/admin/config/development/performance?render=overlay&render=overlay','default','The signature of a user.','','7.34'),(4327,'/admin/config/development/performance?render=overlay&render=overlay','default','Term description.','','7.34'),(4328,'/admin/config/development/performance?render=overlay&render=overlay','default','List of related terms','','7.34'),(4329,'/admin/config/development/performance?render=overlay&render=overlay','default','Terms related to an existing term; may be child, siblings or top level.','','7.34'),(4330,'/admin/config/development/performance?render=overlay&render=overlay','default','Advanced search form','','7.34'),(4331,'/admin/config/development/performance?render=overlay&render=overlay','default','A search form with advanced options.','','7.34'),(4332,'/admin/config/development/performance?render=overlay&render=overlay','default','Keywords','','7.34'),(4333,'/admin/config/development/performance?render=overlay&render=overlay','default','Widgets','','7.34'),(4334,'/admin/config/development/performance?render=overlay&render=overlay','default','The results of a search using keywords.','','7.34'),(4335,'/admin/config/development/performance?render=overlay&render=overlay','default','Add the action links (local tasks) as content.','','7.34'),(4336,'/admin/config/development/performance?render=overlay&render=overlay','default','Page elements','','7.34'),(4337,'/admin/config/development/performance?render=overlay&render=overlay','default','Breadcrumb','','7.34'),(4338,'/admin/config/development/performance?render=overlay&render=overlay','default','Add the breadcrumb trail as content.','','7.34'),(4339,'/admin/config/development/performance?render=overlay&render=overlay','default','Feed icons','','7.34'),(4340,'/admin/config/development/performance?render=overlay&render=overlay','default','Add the site feed_icons statement as content.','','7.34'),(4341,'/admin/config/development/performance?render=overlay&render=overlay','default','Add the help text of the current page as content.','','7.34'),(4342,'/admin/config/development/performance?render=overlay&render=overlay','default','Site logo','','7.34'),(4343,'/admin/config/development/performance?render=overlay&render=overlay','default','Add the logo trail as content.','','7.34'),(4344,'/admin/config/development/performance?render=overlay&render=overlay','default','Status messages','','7.34'),(4345,'/admin/config/development/performance?render=overlay&render=overlay','default','Add the status messages of the current page as content.','','7.34'),(4346,'/admin/config/development/performance?render=overlay&render=overlay','default','Primary navigation links','','7.34'),(4347,'/admin/config/development/performance?render=overlay&render=overlay','default','Add the primary_links (local tasks) as content.','','7.34'),(4348,'/admin/config/development/performance?render=overlay&render=overlay','default','Secondary navigation links','','7.34'),(4349,'/admin/config/development/performance?render=overlay&render=overlay','default','Add the secondary_links (local tasks) as content.','','7.34'),(4350,'/admin/config/development/performance?render=overlay&render=overlay','default','Site name','','7.34'),(4351,'/admin/config/development/performance?render=overlay&render=overlay','default','Site slogan','','7.34'),(4352,'/admin/config/development/performance?render=overlay&render=overlay','default','Add the site\'s slogan as content.','','7.34'),(4353,'/admin/config/development/performance?render=overlay&render=overlay','default','Tabs','','7.34'),(4354,'/admin/config/development/performance?render=overlay&render=overlay','default','Add the tabs (local tasks) as content.','','7.34'),(4355,'/admin/config/development/performance?render=overlay&render=overlay','default','Page title','','7.34'),(4356,'/admin/config/development/performance?render=overlay&render=overlay','default','Add the page title as content.','','7.34'),(4357,'/admin/config/development/performance?render=overlay&render=overlay','default','Node form author information','','7.34'),(4358,'/admin/config/development/performance?render=overlay&render=overlay','default','Author information on the Node form.','','7.34'),(4359,'/admin/config/development/performance?render=overlay&render=overlay','default','Form','','7.34'),(4360,'/admin/config/development/performance?render=overlay&render=overlay','default','Node form submit buttons','','7.34'),(4361,'/admin/config/development/performance?render=overlay&render=overlay','default','Submit buttons for the node form.','','7.34'),(4362,'/admin/config/development/performance?render=overlay&render=overlay','default','Node form comment settings','','7.34'),(4363,'/admin/config/development/performance?render=overlay&render=overlay','default','Comment settings on the Node form.','','7.34'),(4364,'/admin/config/development/performance?render=overlay&render=overlay','default','Node form languages','','7.34'),(4365,'/admin/config/development/performance?render=overlay&render=overlay','default','The language selection form.','','7.34'),(4366,'/admin/config/development/performance?render=overlay&render=overlay','default','Node form revision log message','','7.34'),(4367,'/admin/config/development/performance?render=overlay&render=overlay','default','Revision log message for the node.','','7.34'),(4368,'/admin/config/development/performance?render=overlay&render=overlay','default','Node form menu settings','','7.34'),(4369,'/admin/config/development/performance?render=overlay&render=overlay','default','Menu settings on the Node form.','','7.34'),(4370,'/admin/config/development/performance?render=overlay&render=overlay','default','Node form url path settings','','7.34'),(4371,'/admin/config/development/performance?render=overlay&render=overlay','default','Publishing options on the Node form.','','7.34'),(4372,'/admin/config/development/performance?render=overlay&render=overlay','default','Node form publishing options','','7.34'),(4373,'/admin/config/development/performance?render=overlay&render=overlay','default','Node form title field','','7.34'),(4374,'/admin/config/development/performance?render=overlay&render=overlay','default','The node title form.','','7.34'),(4375,'/admin/config/development/performance?render=overlay&render=overlay','default','Attached files','','7.34'),(4376,'/admin/config/development/performance?render=overlay&render=overlay','default','A list of files attached to the node.','','7.34'),(4377,'/admin/config/development/performance?render=overlay&render=overlay','default','Node author','','7.34'),(4378,'/admin/config/development/performance?render=overlay&render=overlay','default','The author of the referenced node.','','7.34'),(4379,'/admin/config/development/performance?render=overlay&render=overlay','default','Node body','','7.34'),(4380,'/admin/config/development/performance?render=overlay&render=overlay','default','The body of the referenced node.','','7.34'),(4381,'/admin/config/development/performance?render=overlay&render=overlay','default','Node comments','','7.34'),(4382,'/admin/config/development/performance?render=overlay&render=overlay','default','The comments of the referenced node.','','7.34'),(4383,'/admin/config/development/performance?render=overlay&render=overlay','default','Comment form','','7.34'),(4384,'/admin/config/development/performance?render=overlay&render=overlay','default','A form to add a new comment.','','7.34'),(4385,'/admin/config/development/performance?render=overlay&render=overlay','default','Node content','','7.34'),(4386,'/admin/config/development/performance?render=overlay&render=overlay','default','The content of the referenced node.','','7.34'),(4387,'/admin/config/development/performance?render=overlay&render=overlay','default','Node created date','','7.34'),(4388,'/admin/config/development/performance?render=overlay&render=overlay','default','The date the referenced node was created.','','7.34'),(4389,'/admin/config/development/performance?render=overlay&render=overlay','default','Node links','','7.34'),(4390,'/admin/config/development/performance?render=overlay&render=overlay','default','Node links of the referenced node.','','7.34'),(4391,'/admin/config/development/performance?render=overlay&render=overlay','default','Node terms','','7.34'),(4392,'/admin/config/development/performance?render=overlay&render=overlay','default','Taxonomy terms of the referenced node.','','7.34'),(4393,'/admin/config/development/performance?render=overlay&render=overlay','default','Node title','','7.34'),(4394,'/admin/config/development/performance?render=overlay&render=overlay','default','The title of the referenced node.','','7.34'),(4395,'/admin/config/development/performance?render=overlay&render=overlay','default','Node type description','','7.34'),(4396,'/admin/config/development/performance?render=overlay&render=overlay','default','Node type description.','','7.34'),(4397,'/admin/config/development/performance?render=overlay&render=overlay','default','Node last updated date','','7.34'),(4398,'/admin/config/development/performance?render=overlay&render=overlay','default','The date the referenced node was last updated.','','7.34'),(4399,'/admin/config/development/performance?render=overlay&render=overlay','default','Existing node','','7.34'),(4400,'/admin/config/development/performance?render=overlay&render=overlay','default','Add a node from your site as content.','','7.34'),(4401,'/admin/config/development/performance?render=overlay&render=overlay','default','Entity field','','7.34'),(4402,'/admin/config/development/performance?render=overlay&render=overlay','default','General form','','7.34'),(4403,'/admin/config/development/performance?render=overlay&render=overlay','default','Everything in the form that is not displayed by other content.','','7.34'),(4404,'/admin/config/development/performance?render=overlay&render=overlay','default','Entity extra field','','7.34'),(4405,'/admin/config/development/performance?render=overlay&render=overlay','default','Custom content','','7.34'),(4406,'/admin/config/development/performance?render=overlay&render=overlay','default','Comment Reply Form','','7.34'),(4407,'/admin/config/development/performance?render=overlay&render=overlay','default','A form to add a new comment reply.','','7.34'),(4408,'/admin/config/development/performance?render=overlay','default','Context (any)','','7.34'),(4409,'/admin/config/development/performance?render=overlay','default','Set this context on the basis of other active contexts. Put each context on a separate line. The condition will pass if <em>any</em> of the contexts are active. You can use the <code>*</code> character (asterisk) as a wildcard and the <code>~</code> character (tilde) to prevent this context from activating if the listed context is active. Other contexts which use context conditions can not be used to exclude this context from activating.','','7.34'),(4410,'/admin/config/development/performance?render=overlay','default','Context (all)','','7.34'),(4411,'/admin/config/development/performance?render=overlay','default','Set this context on the basis of other active contexts. Put each context on a separate line. The condition will pass only if <em>all</em> of the contexts are active. You can use the <code>*</code> character (asterisk) as a wildcard and the <code>~</code> character (tilde) to prevent this context from activating if the listed context is active. Other contexts which use context conditions can not be used to exclude this context from activating.','','7.34'),(4412,'/admin/config/development/performance?render=overlay','default','Node type','','7.34'),(4413,'/admin/config/development/performance?render=overlay','default','Set this context when viewing a node page or using the add/edit form of one of these content types.','','7.34'),(4414,'/admin/config/development/performance?render=overlay','default','Sitewide context','','7.34'),(4415,'/admin/config/development/performance?render=overlay','default','Should this context always be set? If <strong>true</strong>, this context will be active across your entire site.','','7.34'),(4416,'/admin/config/development/performance?render=overlay','default','Default context','','7.34'),(4417,'/admin/config/development/performance?render=overlay','default','This context will be set if no other context is active except sitewide contexts.','','7.34'),(4418,'/admin/config/development/performance?render=overlay','default','Set this context when any of the paths above match the page path. Put each path on a separate line. You can use the <code>*</code> character (asterisk) as a wildcard and the <code>~</code> character (tilde) to exclude one or more paths. Use &lt;front&gt; for the site front page.','','7.34'),(4419,'/admin/config/development/performance?render=overlay','default','Query String','','7.34'),(4420,'/admin/config/development/performance?render=overlay','default','Set this context when any of the query strings above match the page query string. Put each query string on a separate line. You can use the \"*\" character as a wildcard and <code>~</code> to exclude one or more query strings.','','7.34'),(4421,'/admin/config/development/performance?render=overlay','default','User role','','7.34'),(4422,'/admin/config/development/performance?render=overlay','default','Set this context when the current user has one of the selected role(s).','','7.34'),(4423,'/admin/config/development/performance?render=overlay','default','User page','','7.34'),(4424,'/admin/config/development/performance?render=overlay','default','Set this context when viewing a user page.','','7.34'),(4425,'/admin/config/development/performance?render=overlay','default','Set this context when any of the selected menu items belong to the current active menu trail.','','7.34'),(4426,'/admin/config/development/performance?render=overlay','default','Set this context when displaying the page of one of these views.','','7.34'),(4427,'/admin/config/development/performance?render=overlay','default','Set this context when viewing the site in the selected language.','','7.34'),(4428,'/admin/config/development/performance?render=overlay','default','Set this context when viewing a node with the selected taxonomy terms.','','7.34'),(4429,'/admin/config/development/performance?render=overlay','default','Set this context when viewing a taxonomy term page.','','7.34'),(4430,'/admin/config/development/performance?render=overlay','default','Control block visibility using context.','','7.34'),(4431,'/admin/config/development/performance?render=overlay','default','Regions','','7.34'),(4432,'/admin/config/development/performance?render=overlay','default','Control Region visiblity using context.','','7.34'),(4433,'/admin/config/development/performance?render=overlay','default','Set the breadcrumb trail to the selected menu item.','','7.34'),(4434,'/admin/config/development/performance?render=overlay','default','Template suggestions','','7.34'),(4435,'/admin/config/development/performance?render=overlay','default','Add template suggestions using context.','','7.34'),(4436,'/admin/config/development/performance?render=overlay','default','Theme Page','','7.34'),(4437,'/admin/config/development/performance?render=overlay','default','Control page theme variables using context.','','7.34'),(4438,'/admin/config/development/performance?render=overlay','default','Theme HTML','','7.34'),(4439,'/admin/config/development/performance?render=overlay','default','Control HTML theme variables using context.','','7.34'),(4440,'/admin/config/development/performance?render=overlay','default','Debug','','7.34'),(4441,'/admin/config/development/performance?render=overlay','default','Debug output reaction for SimpleTest.','','7.34'),(4442,'/admin/config/development/performance?render=overlay','default','Control menu active class using context.','','7.34'),(4443,'/admin/config/development/performance?render=overlay','default','A special cache used to store objects that are being edited; it serves to save state in an ordinarily stateless environment.','','7.34'),(4444,'/admin/config/development/performance?render=overlay','default','Menu token properties','','7.34'),(4445,'/admin/config/development/performance?render=overlay','default','The menu link {menu_links}.mlid','','7.34'),(4446,'/admin/config/development/performance?render=overlay','default','The actual path with tokens','','7.34'),(4447,'/admin/config/development/performance?render=overlay','default','Map Session API IDs to the {sessions} sid field.','','7.34'),(4448,'/admin/config/development/performance?render=overlay','default','Table that contains field group entries and settings.','','7.34'),(4449,'/admin/config/development/performance?render=overlay','default','Reply to','','7.34'),(4450,'/admin/config/development/performance?render=overlay','default','Recent posts','','7.34'),(4451,'/admin/config/development/performance?render=overlay','default','Replies','','7.34'),(4452,'/admin/config/development/performance?render=overlay','default','Last Post','','7.34'),(4453,'/admin/config/development/performance?render=overlay','default',' new','','7.34'),(4454,'/admin/config/development/performance?render=overlay','default','Recent posts for %1','','7.34'),(4455,'/admin/config/development/performance?render=overlay','default','Cart summary','','7.34'),(4456,'/admin/config/development/performance?render=overlay','default','Line Item','','7.34'),(4457,'/admin/config/development/performance?render=overlay','default','Remove','','7.34'),(4458,'/admin/config/development/performance?render=overlay','default',' × ','','7.34'),(4459,'/admin/config/development/performance?render=overlay','default','Admin page','','7.34'),(4460,'/admin/config/development/performance?render=overlay','default','Empty line item text.','','7.34'),(4461,'/admin/config/development/performance?render=overlay','default','No line items found.','','7.34'),(4462,'/admin/config/development/performance?render=overlay','default','([line_item_label])','','7.34'),(4463,'/admin/config/development/performance?render=overlay','default','Unit price','','7.34'),(4464,'/admin/config/development/performance?render=overlay','default','Customer profile','','7.34'),(4465,'/admin/config/development/performance?render=overlay','default','User Orders','','7.34'),(4466,'/admin/config/development/performance?render=overlay','default','Order Revisions','','7.34'),(4467,'/admin/config/development/performance?render=overlay','default','Method','','7.34'),(4468,'/admin/config/development/performance?render=overlay','default','Result message','','7.34'),(4469,'/admin/config/development/performance?render=overlay','default','Product Revisions','','7.34'),(4470,'/admin/config/development/performance?render=overlay','default','Monthly archive','','7.34'),(4471,'/admin/config/development/performance?render=overlay','default','Last update','','7.34'),(4472,'/admin/config/development/performance?render=overlay','default','recently read','','7.34'),(4473,'/admin/config/development/performance?render=overlay','default','No backlinks found.','','7.34'),(4474,'/admin/config/development/performance?render=overlay','default','Pages that link to %1','','7.34'),(4475,'/admin/config/development/performance?render=overlay','default','What links here','','7.34'),(4476,'/admin/config/development/performance?render=overlay','default','@type field.','','7.34'),(4477,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Rate','','7.34'),(4478,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Select rating','','7.34'),(4479,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Give it @star/@count','','7.34'),(4480,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Add to cart','','7.34'),(4481,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Your name','','7.34'),(4482,'/product/samsung-n910-note-4-lte-32gb-white-45','default','View user profile.','','7.34'),(4483,'/product/samsung-n910-note-4-lte-32gb-white-45','default','The content of this field is kept private and will not be shown publicly.','','7.34'),(4484,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Homepage','','7.34'),(4485,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Authored on','','7.34'),(4486,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Save','','7.34'),(4487,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Preview','','7.34'),(4488,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Compose tips','','7.34'),(4489,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Tags','','7.34'),(4490,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Webform client form.','','7.34'),(4491,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Rich text editor settings','','7.34'),(4492,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Author textfield','','7.34'),(4493,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Subject textfield','','7.34'),(4494,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Line item module label form element','','7.34'),(4495,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Line item module quantity form element','','7.34'),(4496,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Short descriptive label for the line item','','7.34'),(4497,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Product module SKU form element','','7.34'),(4498,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Product module title form element','','7.34'),(4499,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Product module status form element','','7.34'),(4500,'/product/samsung-n910-note-4-lte-32gb-white-45','default','The human readable identifier of the product','','7.34'),(4501,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Full product title','','7.34'),(4502,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Whether the product is active or disabled','','7.34'),(4503,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Product: @label','','7.34'),(4504,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Field from a referenced product.','','7.34'),(4505,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Node module element','','7.34'),(4506,'/product/samsung-n910-note-4-lte-32gb-white-45','default','URL path settings','','7.34'),(4507,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Path module form elements','','7.34'),(4508,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Newsletter subscriptions of the user','','7.34'),(4509,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Term name textfield','','7.34'),(4510,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Term description textarea','','7.34'),(4511,'/product/samsung-n910-note-4-lte-32gb-white-45','default','User name and password','','7.34'),(4512,'/product/samsung-n910-note-4-lte-32gb-white-45','default','User module account form elements.','','7.34'),(4513,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Timezone','','7.34'),(4514,'/product/samsung-n910-note-4-lte-32gb-white-45','default','User module timezone form element.','','7.34'),(4515,'/product/samsung-n910-note-4-lte-32gb-white-45','default','History','','7.34'),(4516,'/product/samsung-n910-note-4-lte-32gb-white-45','default','User module history view element.','','7.34'),(4517,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Administrative overlay','','7.34'),(4518,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Language settings','','7.34'),(4519,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Language settings for the user account.','','7.34'),(4520,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Load','','7.34'),(4521,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Render','','7.34'),(4522,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Tue','','7.34'),(4523,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Product Detail','','7.34'),(4524,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Specifications','','7.34'),(4525,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Add new comment','','7.34'),(4526,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Switch to plain text editor','','7.34'),(4527,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Switch to rich text editor','','7.34'),(4528,'/product/samsung-n910-note-4-lte-32gb-white-45; sites/all/modules/webform/js/webform.js','default','This field is required.','','7.34'),(4529,'/product/samsung-n910-note-4-lte-32gb-white-45','default','More information about text formats','','7.34'),(4530,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Web page addresses and e-mail addresses turn into links automatically.','','7.34'),(4531,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Allowed HTML tags: @tags','','7.34'),(4532,'/product/samsung-n910-note-4-lte-32gb-white-45','default','Lines and paragraphs break automatically.','','7.34'),(4533,'/product/samsung-n910-note-4-lte-32gb-white-45','default','No HTML tags allowed.','','7.34'),(4534,'/product/samsung-n910-note-4-lte-32gb-white-45','default','You may post PHP code. You should include &lt;?php ?&gt; tags.','','7.34'),(4535,'/admin/config/development/performance?render=overlay&render=overlay','default','CKEditor profiles','','7.34'),(4536,'/admin/config/development/performance?render=overlay&render=overlay','default','Commerce Custom Offline Payments','','7.34'),(4537,'/admin/config/development/performance?render=overlay&render=overlay','default','Entity Types','','7.34'),(4538,'/admin/config/development/performance?render=overlay&render=overlay','default','Field Bases','','7.34'),(4539,'/admin/config/development/performance?render=overlay&render=overlay','default','Field Instances','','7.34'),(4540,'/admin/config/development/performance?render=overlay&render=overlay','default','Menu items','','7.34'),(4541,'/','default','Username','','7.34'),(4542,'/','default','Password','','7.34'),(4543,'/','default','Log in','','7.34'),(4544,'/','default','Create new account','','7.34'),(4545,'/','default','Create a new user account.','','7.34'),(4546,'/','default','Request new password','','7.34'),(4547,'/','default','Request new password via e-mail.','','7.34'),(4548,'/','default','not yet assigned','','7.34'),(4549,'/sites/default/files/styles/large/public/products/sk-II-5-piece-skincare-travel.jpg?itok=O2OWzmn9','default','Generate image style','','7.34'),(4550,'/sites/default/files/styles/large/public/products/sk-II-5-piece-skincare-travel.jpg?itok=O2OWzmn9','default','GD2 image manipulation toolkit','','7.34'),(4551,'/product/sk-ii-5-piece-skincare-travel-set-5pcs-travel-packs-skii-sk2-39','default','Module and theme update status','','7.34'),(4552,'/product/sk-ii-5-piece-skincare-travel-set-5pcs-travel-packs-skii-sk2-39','default','There are updates available for one or more of your modules or themes. To ensure the proper functioning of your site, you should update as soon as possible.','','7.34'),(4553,'/product/sk-ii-5-piece-skincare-travel-set-5pcs-travel-packs-skii-sk2-39','default','See the <a href=\"@available_updates\">available updates</a> page for more information.','','7.34'),(4554,'/product/sk-ii-5-piece-skincare-travel-set-5pcs-travel-packs-skii-sk2-39','default','Out of date','','7.34'),(4555,'/product/sk-ii-5-piece-skincare-travel-set-5pcs-travel-packs-skii-sk2-39','default','New release(s) available for !site_name','','7.34'),(4556,'/product/sk-ii-5-piece-skincare-travel-set-5pcs-travel-packs-skii-sk2-39','default','See the available updates page for more information:','','7.34'),(4557,'/product/sk-ii-5-piece-skincare-travel-set-5pcs-travel-packs-skii-sk2-39','default','Your site is currently configured to send these emails when any updates are available. To get notified only for security updates, !url.','','7.34'),(4558,'/product/sk-ii-5-piece-skincare-travel-set-5pcs-travel-packs-skii-sk2-39','default','Unable to send e-mail. Contact the site administrator if the problem persists.','','7.34'),(4559,'/admin/config?render=overlay','default','See the <a href=\"@available_updates\">available updates</a> page for more information and to install your missing updates.','','7.34'),(4560,'modules/field/modules/text/text.js','default','Hide summary','','none'),(4561,'modules/field/modules/text/text.js','default','Edit summary','','none'),(4562,'misc/ajax.js','default','Please wait...','','none'),(4563,'modules/file/file.js','default','The selected file %filename cannot be uploaded. Only files with the following extensions are allowed: %extensions.','','none'),(4564,'modules/menu/menu.js','default','Not in menu','','none'),(4565,'sites/all/modules/pathauto/pathauto.js','default','Automatic alias','','none'),(4566,'sites/all/modules/pathauto/pathauto.js','default','Alias: @alias','','none'),(4567,'sites/all/modules/pathauto/pathauto.js','default','No alias','','none'),(4568,'modules/node/node.js','default','New revision','','none'),(4569,'modules/node/node.js','default','No revision','','none'),(4570,'modules/node/node.js','default','By @name on @date','','none'),(4571,'modules/node/node.js','default','By @name','','none'),(4572,'modules/comment/comment-node-form.js','default','@number comments per page','','none'),(4573,'misc/autocomplete.js','default','Autocomplete popup','','none'),(4574,'misc/autocomplete.js','default','Searching for matches...','','none'),(4575,'sites/all/modules/imce/js/imce.js','default','File browsing is disabled in directory %dir.','','none'),(4576,'sites/all/modules/imce/js/imce.js','default','Upload','','none'),(4577,'sites/all/modules/imce/js/imce.js','default','You can not perform this operation.','','none'),(4578,'sites/all/modules/imce/js/imce.js','default','Do you want to refresh the current directory?','','none'),(4579,'sites/all/modules/imce/js/imce.js','default','Only files with the following extensions are allowed: %files-allowed.','','none'),(4580,'sites/all/modules/imce/js/imce.js','default','Delete selected files?','','none'),(4581,'sites/all/modules/imce/js/imce.js','default','Please select a thumbnail.','','none'),(4582,'sites/all/modules/imce/js/imce.js','default','Please specify dimensions within the allowed range that is from 1x1 to @dimensions.','','none'),(4583,'sites/all/modules/imce/js/imce.js','default','Please select a file.','','none'),(4584,'sites/all/modules/imce/js/imce.js','default','Log messages','','none'),(4585,'sites/all/modules/imce/js/imce.js','default','%filename is not an image.','','none'),(4586,'sites/all/modules/imce/js/imce.js','default','You must select at least %num files.','','none'),(4587,'sites/all/modules/imce/js/imce.js','default','You are not allowed to operate on more than %num files.','','none'),(4588,'sites/all/modules/imce/js/imce.js','default','Close','','none'),(4589,'sites/all/modules/imce/js/imce_extras.js','default','Change view','','none'),(4590,'sites/all/modules/imce/js/imce_set_app.js','default','Insert file','','none'),(4591,'sites/all/modules/views/js/views-admin.js','default','Remove group','','none'),(4592,'sites/all/modules/views/js/views-admin.js','default','Apply (all displays)','','none'),(4593,'sites/all/modules/views/js/views-admin.js','default','Revert to default','','none'),(4594,'sites/all/modules/views/js/views-admin.js','default','Apply (this display)','','none'),(4595,'misc/tableselect.js','default','Select all rows in this table','','none'),(4596,'misc/tableselect.js','default','Deselect all rows in this table','','none'),(4597,'sites/all/modules/weight/weight.js','default','Range: !range','','none'),(4598,'sites/all/modules/weight/weight.js','default','Default: !default','','none'),(4599,'sites/all/modules/weight/weight.js','default','Weight: !weight','','none'),(4600,'modules/block/block.js','default','Not restricted','','none'),(4601,'modules/block/block.js','default','Restricted to certain pages','','none'),(4602,'modules/block/block.js','default','Not customizable','','none'),(4603,'modules/block/block.js','default','The changes to these blocks will not be saved until the <em>Save blocks</em> button is clicked.','','none'),(4604,'modules/block/block.js','default','The block cannot be placed in this region.','','none'),(4605,'modules/node/content_types.js','default','Requires a title','','none'),(4606,'modules/node/content_types.js','default','Don\'t display post information','','none'),(4607,'sites/all/modules/token/token.js','default','Loading token browser...','','none'),(4608,'sites/all/modules/token/token.js','default','Available tokens','','none'),(4609,'sites/all/modules/token/token.js','default','Insert this token into your form','','none'),(4610,'sites/all/modules/token/token.js','default','First click a text field to insert your tokens into.','','none'),(4611,'sites/all/modules/commerce/modules/customer/commerce_customer.js','default','Owned by @name','','none'),(4612,'/ar','default','Mon','','7.34'),(4613,'/ar','default','January','Long month name','7.34'),(4614,'/ar','default','@count weeks','','7.34'),(4615,'/ar/product/samsung-n910-note-4-lte-32gb-white-45','default','authenticated user','','7.34'),(4616,'/ar/product/samsung-n910-note-4-lte-32gb-white-45','default','<a href=\"@login\">Log in</a> or <a href=\"@register\">register</a> to post comments','','7.34'),(4617,'/ar/product/samsung-n910-note-4-lte-32gb-white-45','default','@sku: @title','','7.34'),(4618,'/ar/product/samsung-n910-note-4-lte-32gb-white-45','default','%title added to <a href=\"!cart-url\">your cart</a>.','','7.34'),(4619,'/ar/product/samsung-n910-note-4-lte-32gb-white-45','default','Order status updated via Rules.','','7.34'),(4620,'/ar/product/samsung-n910-note-4-lte-32gb-white-45','default','Display path','','7.34'),(4621,'/ar/product/samsung-n910-note-4-lte-32gb-white-45','default','View cart','','7.34'),(4622,'/ar/product/samsung-n910-note-4-lte-32gb-white-45','default','item','product count on a Commerce order','7.34'),(4623,'/ar/product/samsung-n910-note-4-lte-32gb-white-45','default','1 item','product count on a Commerce order','7.34'),(4624,'/ar/checkout/226','default','Commerce Marketplace Funds fee','','7.34'),(4625,'/ar/checkout/226','default','Base price','','7.34'),(4626,'/ar/checkout/226','default','Subtotal','','7.34'),(4627,'/ar/checkout/226','default','Discount','','7.34'),(4628,'/ar/checkout/226','default','Fee','','7.34'),(4629,'/ar/checkout/226','default','E-mail address','','7.34'),(4630,'/ar/checkout/226','default','Address form (country-specific)','','7.34'),(4631,'/ar/checkout/226','default','Address 1','','7.34'),(4632,'/ar/checkout/226','default','Address 2','','7.34'),(4633,'/ar/checkout/226','default','City','','7.34'),(4634,'/ar/checkout/226','default','State','Territory of a country','7.34'),(4635,'/ar/checkout/226','default','Name (single line)','','7.34'),(4636,'/ar/checkout/226','default','Cancel','','7.34'),(4637,'/ar/product/canon-ef-s-lens-18-200mm-f35-56-90','default','Fri','','7.34'),(4638,'/ar/product/canon-ef-s-lens-18-200mm-f35-56-90','default','items','product count on a Commerce order','7.34'),(4639,'/ar/product/canon-ef-s-lens-18-200mm-f35-56-90','default','@count items','product count on a Commerce order','7.34'),(4640,'/ar/checkout/226?destination=checkout/226','default','Sorry, unrecognized username or password. <a href=\"@password\">Have you forgotten your password?</a>','','7.34'),(4641,'/ar/user','default','My account','','7.34'),(4642,'/ar/user','default','Subscribed to','','7.34'),(4643,'/ar/user','default','Manage <a href=\"!url\">subscriptions</a>','','7.34'),(4644,'/ar/user','default','Member for','','7.34'),(4645,'/ar/user','default','Configure withdraw methods','','7.34'),(4646,'/ar/user','default','Make a Deposit transaction','','7.34'),(4647,'/ar/user','default','Make a Funds transfer transaction','','7.34'),(4648,'/ar/user/16/edit','default','Spaces are allowed; punctuation is not allowed except for periods, hyphens, apostrophes, and underscores.','','7.34'),(4649,'/ar/user/16/edit','default','A valid e-mail address. All e-mails from the system will be sent to this address. The e-mail address is not made public and will only be used if you wish to receive a new password or wish to receive certain news or notifications by e-mail.','','7.34'),(4650,'/ar/user/16/edit','default','To change the current user password, enter the new password in both fields.','','7.34'),(4651,'/ar/user/16/edit','default','Enter your current password to change the %mail or %pass. !request_new.','','7.34'),(4652,'/ar/user/16/edit','default','Current password','','7.34'),(4653,'/ar/user/16/edit','default','Notify user of new account','','7.34'),(4654,'/ar/user/16/edit','default','Signature settings','','7.34'),(4655,'/ar/user/16/edit','default','Your signature will be publicly displayed at the end of your comments.','','7.34'),(4656,'/ar/user/16/edit','default','Delete picture','','7.34'),(4657,'/ar/user/16/edit','default','Check this box to delete your current picture.','','7.34'),(4658,'/ar/user/16/edit','default','Upload picture','','7.34'),(4659,'/ar/user/16/edit','default','Your virtual face or picture. Pictures larger than @dimensions pixels will be scaled down.','','7.34'),(4660,'/ar/user/16/edit','default','Cancel account','','7.34'),(4661,'/ar/user/16/edit','default','Arabic','','7.34'),(4662,'/ar/user/16/edit','default','English','','7.34'),(4663,'/ar/user/16/edit','default','Locale settings','','7.34'),(4664,'/ar/user/16/edit','default','Time zone','','7.34'),(4665,'/ar/user/16/edit','default','Select the desired local time and time zone. Dates and times throughout this site will be displayed using this time zone.','','7.34'),(4666,'/ar/user/16/edit','default','Confirm password','','7.34'),(4667,'/ar/user/16/edit','default','Password strength:','','7.34'),(4668,'/ar/user/16/edit','default','To make your password stronger:','','7.34'),(4669,'/ar/user/16/edit','default','Make it at least 6 characters','','7.34'),(4670,'/ar/user/16/edit','default','Add lowercase letters','','7.34'),(4671,'/ar/user/16/edit','default','Add uppercase letters','','7.34'),(4672,'/ar/user/16/edit','default','Add numbers','','7.34'),(4673,'/ar/user/16/edit','default','Add punctuation','','7.34'),(4674,'/ar/user/16/edit','default','Make it different from your username','','7.34'),(4675,'/ar/user/16/edit','default','yes','','7.34'),(4676,'/ar/user/16/edit','default','no','','7.34'),(4677,'/ar/user/16/edit','default','Weak','','7.34'),(4678,'/ar/user/16/edit','default','Fair','','7.34'),(4679,'/ar/user/16/edit','default','Good','','7.34'),(4680,'/ar/user/16/edit','default','Strong','','7.34'),(4681,'/ar/user/16/edit','default','Passwords match:','','7.34'),(4682,'/ar/user/16/edit','default','Secondary tabs','','7.34'),(4683,'/ar/user','default','Enter your @s username.','','7.34'),(4684,'/ar/user','default','Enter the password that accompanies your username.','','7.34'),(4685,'/ar/user/password','default','Username or e-mail address','','7.34'),(4686,'/ar/user/password','default','E-mail new password','','7.34'),(4687,'/ar/user/password','default','No available releases found','','7.34'),(4688,'/ar/user/password','default','There was a problem checking <a href=\"@update-report\">available updates</a> for Drupal.','','7.34'),(4689,'sites/all/modules/context/plugins/context_reaction_block.js','default','Desired block weight exceeds available weight options, please check weights for blocks before saving','','none'),(4690,'sites/all/modules/context/plugins/context_reaction_block.js','default','Now Editing: ','','none'),(4691,'/marketplace/en/admin/structure/views/view/product_display/edit/block_1?destination=frontpage&render=overlay&render=overlay','default','Recently Viewed','','7.34'),(4692,'sites/all/themes/marketplace/js/marketplace.js','default','Cart','','none'),(4693,'sites/all/modules/megamenus/js/megamenus.js; sites/all/modules/tb_megamenu/js/tb-megamenu-object.js','default','Remove this block','','none'),(4694,'sites/all/modules/megamenus/js/megamenus.js; sites/all/modules/tb_megamenu/js/tb-megamenu-object.js','default','Saved config sucessfully!','','none'),(4695,'sites/all/modules/tb_megamenu/js/tb-megamenu-object.js','default','All unsaved changed has been reseted!','','none'),(4696,'misc/drupal.js','default','CustomMessage: !customMessage','','none'),(4697,'misc/ajax.js','default','The response failed verification so will not be processed.','','none'),(4698,'misc/ajax.js','default','The callback URL is not local and not trusted: !url','','none'),(4699,'sites/all/modules/search_api/search_api.admin.js','default','List additional actions','','none'),(4700,'modules/dashboard/dashboard.js','default','Done','','none');
/*!40000 ALTER TABLE `locales_source` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `locales_target`
--

DROP TABLE IF EXISTS `locales_target`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `locales_target` (
  `lid` int(11) NOT NULL DEFAULT '0' COMMENT 'Source string ID. References locales_source.lid.',
  `translation` blob NOT NULL COMMENT 'Translation string value in this language.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'Language code. References languages.language.',
  `plid` int(11) NOT NULL DEFAULT '0' COMMENT 'Parent lid (lid of the previous string in the plural chain) in case of plural strings. References locales_source.lid.',
  `plural` int(11) NOT NULL DEFAULT '0' COMMENT 'Plural index number in case of plural strings.',
  PRIMARY KEY (`language`,`lid`,`plural`),
  KEY `lid` (`lid`),
  KEY `plid` (`plid`),
  KEY `plural` (`plural`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores translated versions of strings.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `locales_target`
--

LOCK TABLES `locales_target` WRITE;
/*!40000 ALTER TABLE `locales_target` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `locales_target` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `menu_custom`
--

DROP TABLE IF EXISTS `menu_custom`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menu_custom` (
  `menu_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique key for menu. This is used as a block delta so length is 32.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Menu title; displayed at top of block.',
  `description` text COMMENT 'Menu description.',
  PRIMARY KEY (`menu_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Holds definitions for top-level custom menus (for example...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menu_custom`
--

LOCK TABLES `menu_custom` WRITE;
/*!40000 ALTER TABLE `menu_custom` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `menu_custom` VALUES ('devel','Development','Development link'),('features','Features','Menu items for any enabled features.'),('main-menu','Main menu','The <em>Main</em> menu is used on many sites to show the major sections of the site, often in a top navigation bar.'),('management','Management','The <em>Management</em> menu contains links for administrative tasks.'),('menu-about-us','About us',''),('menu-customer-help','Customer help',''),('menu-headline-menu','Headline menu',''),('menu-help-menu','Help Topics',''),('navigation','Navigation','The <em>Navigation</em> menu contains links intended for site visitors. Links are added to the <em>Navigation</em> menu automatically by some modules.'),('user-menu','User menu','');
/*!40000 ALTER TABLE `menu_custom` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `menu_descriptions`
--

DROP TABLE IF EXISTS `menu_descriptions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menu_descriptions` (
  `mlid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The primary identifier for a menu link.',
  `description` text COMMENT 'The menu item description.',
  `format` varchar(255) NOT NULL DEFAULT '' COMMENT 'The description format.',
  PRIMARY KEY (`mlid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='The base table for menu descriptions.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menu_descriptions`
--

LOCK TABLES `menu_descriptions` WRITE;
/*!40000 ALTER TABLE `menu_descriptions` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `menu_descriptions` VALUES (2,'<p>Manage your settings, payment and order info</p>\r\n','filtered_html'),(644,'','filtered_html'),(962,'<p>Find out estimated delivery dates for your orders</p>\r\n','filtered_html'),(963,'<p>Manage account settings, payments and order info</p>\r\n','filtered_html'),(964,'<p>Find out estimated delivery dates for your orders.</p>\r\n','filtered_html'),(976,'','filtered_html'),(1054,'','filtered_html'),(1056,'','filtered_html'),(1057,'','filtered_html'),(1058,'','filtered_html'),(1059,'','filtered_html'),(1060,'','filtered_html'),(1061,'','filtered_html'),(1063,'','filtered_html'),(1271,'','filtered_html'),(1272,'','filtered_html'),(1273,'','filtered_html');
/*!40000 ALTER TABLE `menu_descriptions` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `menu_links`
--

DROP TABLE IF EXISTS `menu_links`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menu_links` (
  `menu_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'The menu name. All links with the same menu name (such as ’navigation’) are part of the same menu.',
  `mlid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The menu link ID (mlid) is the integer primary key.',
  `plid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The parent link ID (plid) is the mlid of the link above in the hierarchy, or zero if the link is at the top level in its menu.',
  `link_path` varchar(255) NOT NULL DEFAULT '' COMMENT 'The Drupal path or external path this link points to.',
  `router_path` varchar(255) NOT NULL DEFAULT '' COMMENT 'For links corresponding to a Drupal path (external = 0), this connects the link to a menu_router.path for joins.',
  `link_title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The text displayed for the link, which may be modified by a title callback stored in menu_router.',
  `options` blob COMMENT 'A serialized array of options to be passed to the url() or l() function, such as a query string or HTML attributes.',
  `module` varchar(255) NOT NULL DEFAULT 'system' COMMENT 'The name of the module that generated this link.',
  `hidden` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag for whether the link should be rendered in menus. (1 = a disabled menu item that may be shown on admin screens, -1 = a menu callback, 0 = a normal, visible link)',
  `external` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate if the link points to a full URL starting with a protocol, like http:// (1 = external, 0 = internal).',
  `has_children` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Flag indicating whether any links have this link as a parent (1 = children exist, 0 = no children).',
  `expanded` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Flag for whether this link should be rendered as expanded in menus - expanded links always have their child links displayed, instead of only when the link is in the active trail (1 = expanded, 0 = not expanded)',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Link weight among links in the same menu at the same depth.',
  `depth` smallint(6) NOT NULL DEFAULT '0' COMMENT 'The depth relative to the top level. A link with plid == 0 will have depth == 1.',
  `customized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate that the user has manually created or edited the link (1 = customized, 0 = not customized).',
  `p1` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The first mlid in the materialized path. If N = depth, then pN must equal the mlid. If depth > 1 then p(N-1) must equal the plid. All pX where X > depth must equal zero. The columns p1 .. p9 are also called the parents.',
  `p2` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The second mlid in the materialized path. See p1.',
  `p3` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The third mlid in the materialized path. See p1.',
  `p4` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The fourth mlid in the materialized path. See p1.',
  `p5` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The fifth mlid in the materialized path. See p1.',
  `p6` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The sixth mlid in the materialized path. See p1.',
  `p7` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The seventh mlid in the materialized path. See p1.',
  `p8` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The eighth mlid in the materialized path. See p1.',
  `p9` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The ninth mlid in the materialized path. See p1.',
  `updated` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Flag that indicates that this link was generated during the update from Drupal 5.',
  PRIMARY KEY (`mlid`),
  KEY `path_menu` (`link_path`(128),`menu_name`),
  KEY `menu_plid_expand_child` (`menu_name`,`plid`,`expanded`,`has_children`),
  KEY `menu_parents` (`menu_name`,`p1`,`p2`,`p3`,`p4`,`p5`,`p6`,`p7`,`p8`,`p9`),
  KEY `router_path` (`router_path`(128))
) ENGINE=InnoDB AUTO_INCREMENT=2319 DEFAULT CHARSET=utf8 COMMENT='Contains the individual links within a menu.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menu_links`
--

LOCK TABLES `menu_links` WRITE;
/*!40000 ALTER TABLE `menu_links` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `menu_links` VALUES ('management',1,0,'admin','admin','Administration','a:0:{}','system',0,0,1,0,9,1,0,1,0,0,0,0,0,0,0,0,0),('user-menu',2,0,'user','user','View Account','a:2:{s:5:\"alter\";b:1;s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','system',0,0,0,0,-46,1,1,2,0,0,0,0,0,0,0,0,0),('navigation',3,0,'comment/%','comment/%','Comment permalink','a:0:{}','system',0,0,1,0,0,1,0,3,0,0,0,0,0,0,0,0,0),('navigation',4,0,'filter/tips','filter/tips','Compose tips','a:0:{}','system',1,0,1,0,0,1,0,4,0,0,0,0,0,0,0,0,0),('navigation',5,0,'node/%','node/%','','a:0:{}','system',0,0,0,0,0,1,0,5,0,0,0,0,0,0,0,0,0),('navigation',6,0,'node/add','node/add','Add content','a:0:{}','system',0,0,1,0,0,1,0,6,0,0,0,0,0,0,0,0,0),('management',7,1,'admin/appearance','admin/appearance','Appearance','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"Select and configure your themes.\";}}','system',0,0,0,0,-6,2,0,1,7,0,0,0,0,0,0,0,0),('management',8,1,'admin/config','admin/config','Configuration','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:20:\"Administer settings.\";}}','system',0,0,1,0,0,2,0,1,8,0,0,0,0,0,0,0,0),('management',9,1,'admin/content','admin/content','Content','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:32:\"Administer content and comments.\";}}','system',0,0,1,0,-10,2,0,1,9,0,0,0,0,0,0,0,0),('user-menu',10,2,'user/register','user/register','Create new account','a:0:{}','system',-1,0,0,0,0,2,0,2,10,0,0,0,0,0,0,0,0),('management',11,1,'admin/dashboard','admin/dashboard','Dashboard','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"View and customize your dashboard.\";}}','system',0,0,0,0,-15,2,0,1,11,0,0,0,0,0,0,0,0),('management',12,1,'admin/help','admin/help','Help','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:48:\"Reference for usage, configuration, and modules.\";}}','system',0,0,0,0,9,2,0,1,12,0,0,0,0,0,0,0,0),('management',13,1,'admin/index','admin/index','Index','a:0:{}','system',-1,0,0,0,-18,2,0,1,13,0,0,0,0,0,0,0,0),('user-menu',14,2,'user/login','user/login','Log in','a:0:{}','system',-1,0,0,0,0,2,0,2,14,0,0,0,0,0,0,0,0),('user-menu',15,0,'user/logout','user/logout','Log out','a:0:{}','system',0,0,0,0,-45,1,1,15,0,0,0,0,0,0,0,0,0),('management',16,1,'admin/modules','admin/modules','Modules','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:26:\"Extend site functionality.\";}}','system',0,0,0,0,-2,2,0,1,16,0,0,0,0,0,0,0,0),('navigation',17,0,'user/%','user/%','My account','a:0:{}','system',0,0,1,0,0,1,0,17,0,0,0,0,0,0,0,0,0),('management',18,1,'admin/people','admin/people','People','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Manage user accounts, roles, and permissions.\";}}','system',0,0,0,0,-4,2,0,1,18,0,0,0,0,0,0,0,0),('management',19,1,'admin/reports','admin/reports','Reports','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"View reports, updates, and errors.\";}}','system',0,0,1,0,5,2,0,1,19,0,0,0,0,0,0,0,0),('user-menu',20,2,'user/password','user/password','Request new password','a:0:{}','system',-1,0,0,0,0,2,0,2,20,0,0,0,0,0,0,0,0),('management',21,1,'admin/structure','admin/structure','Structure','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Administer blocks, content types, menus, etc.\";}}','system',0,0,1,0,-8,2,0,1,21,0,0,0,0,0,0,0,0),('management',22,1,'admin/tasks','admin/tasks','Tasks','a:0:{}','system',-1,0,0,0,-20,2,0,1,22,0,0,0,0,0,0,0,0),('navigation',23,0,'comment/reply/%','comment/reply/%','Add new comment','a:0:{}','system',0,0,0,0,0,1,0,23,0,0,0,0,0,0,0,0,0),('navigation',24,3,'comment/%/approve','comment/%/approve','Approve','a:0:{}','system',0,0,0,0,1,2,0,3,24,0,0,0,0,0,0,0,0),('navigation',25,3,'comment/%/delete','comment/%/delete','Delete','a:0:{}','system',-1,0,0,0,2,2,0,3,25,0,0,0,0,0,0,0,0),('navigation',26,3,'comment/%/edit','comment/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,2,0,3,26,0,0,0,0,0,0,0,0),('navigation',27,0,'taxonomy/term/%','taxonomy/term/%','Taxonomy term','a:0:{}','system',0,0,0,0,0,1,0,27,0,0,0,0,0,0,0,0,0),('navigation',28,3,'comment/%/view','comment/%/view','View comment','a:0:{}','system',-1,0,0,0,-10,2,0,3,28,0,0,0,0,0,0,0,0),('management',29,18,'admin/people/create','admin/people/create','Add user','a:0:{}','system',-1,0,0,0,0,3,0,1,18,29,0,0,0,0,0,0,0),('management',30,21,'admin/structure/block','admin/structure/block','Blocks','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:79:\"Configure what block content appears in your site\'s sidebars and other regions.\";}}','system',0,0,1,0,0,3,0,1,21,30,0,0,0,0,0,0,0),('navigation',31,17,'user/%/cancel','user/%/cancel','Cancel account','a:0:{}','system',0,0,1,0,0,2,0,17,31,0,0,0,0,0,0,0,0),('management',32,9,'admin/content/comment','admin/content/comment','Comments','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:59:\"List and edit site comments and the comment approval queue.\";}}','system',0,0,0,0,0,3,0,1,9,32,0,0,0,0,0,0,0),('management',33,11,'admin/dashboard/configure','admin/dashboard/configure','Configure available dashboard blocks','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:53:\"Configure which blocks can be shown on the dashboard.\";}}','system',-1,0,0,0,0,3,0,1,11,33,0,0,0,0,0,0,0),('management',34,9,'admin/content/node','admin/content/node','Content','a:0:{}','system',-1,0,0,0,-10,3,0,1,9,34,0,0,0,0,0,0,0),('management',35,8,'admin/config/content','admin/config/content','Content authoring','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:53:\"Settings related to formatting and authoring content.\";}}','system',0,0,1,0,-15,3,0,1,8,35,0,0,0,0,0,0,0),('management',36,21,'admin/structure/types','admin/structure/types','Content types','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:92:\"Manage content types, including default status, front page promotion, comment settings, etc.\";}}','system',0,0,1,0,0,3,0,1,21,36,0,0,0,0,0,0,0),('management',37,11,'admin/dashboard/customize','admin/dashboard/customize','Customize dashboard','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:25:\"Customize your dashboard.\";}}','system',-1,0,0,0,0,3,0,1,11,37,0,0,0,0,0,0,0),('navigation',38,5,'node/%/delete','node/%/delete','Delete','a:0:{}','system',-1,0,0,0,1,2,0,5,38,0,0,0,0,0,0,0,0),('management',39,8,'admin/config/development','admin/config/development','Development','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:18:\"Development tools.\";}}','system',0,0,1,0,-10,3,0,1,8,39,0,0,0,0,0,0,0),('navigation',40,17,'user/%/edit','user/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,2,0,17,40,0,0,0,0,0,0,0,0),('navigation',41,5,'node/%/edit','node/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,2,0,5,41,0,0,0,0,0,0,0,0),('management',42,19,'admin/reports/fields','admin/reports/fields','Field list','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:39:\"Overview of fields on all entity types.\";}}','system',0,0,0,0,0,3,0,1,19,42,0,0,0,0,0,0,0),('management',43,16,'admin/modules/list','admin/modules/list','List','a:0:{}','system',-1,0,0,0,0,3,0,1,16,43,0,0,0,0,0,0,0),('management',44,18,'admin/people/people','admin/people/people','List','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:50:\"Find and manage people interacting with your site.\";}}','system',-1,0,0,0,-10,3,0,1,18,44,0,0,0,0,0,0,0),('management',45,7,'admin/appearance/list','admin/appearance/list','List','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:31:\"Select and configure your theme\";}}','system',-1,0,0,0,-1,3,0,1,7,45,0,0,0,0,0,0,0),('management',46,8,'admin/config/media','admin/config/media','Media','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:12:\"Media tools.\";}}','system',0,0,1,0,-10,3,0,1,8,46,0,0,0,0,0,0,0),('management',47,21,'admin/structure/menu','admin/structure/menu','Menus','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:86:\"Add new menus to your site, edit existing menus, and rename and reorganize menu links.\";}}','system',0,0,1,0,0,3,0,1,21,47,0,0,0,0,0,0,0),('management',48,8,'admin/config/people','admin/config/people','People','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:24:\"Configure user accounts.\";}}','system',0,0,1,0,-20,3,0,1,8,48,0,0,0,0,0,0,0),('management',49,18,'admin/people/permissions','admin/people/permissions','Permissions','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:64:\"Determine access to features by selecting permissions for roles.\";}}','system',-1,0,0,0,0,3,0,1,18,49,0,0,0,0,0,0,0),('management',50,19,'admin/reports/dblog','admin/reports/dblog','Recent log messages','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"View events that have recently been logged.\";}}','system',0,0,0,0,-1,3,0,1,19,50,0,0,0,0,0,0,0),('management',51,8,'admin/config/regional','admin/config/regional','Regional and language','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:48:\"Regional settings, localization and translation.\";}}','system',0,0,1,0,-5,3,0,1,8,51,0,0,0,0,0,0,0),('navigation',52,5,'node/%/revisions','node/%/revisions','Revisions','a:0:{}','system',-1,0,1,0,2,2,0,5,52,0,0,0,0,0,0,0,0),('management',53,8,'admin/config/search','admin/config/search','Search and metadata','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:36:\"Local site search, metadata and SEO.\";}}','system',0,0,1,0,-10,3,0,1,8,53,0,0,0,0,0,0,0),('management',54,7,'admin/appearance/settings','admin/appearance/settings','Settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:46:\"Configure default and theme specific settings.\";}}','system',-1,0,0,0,20,3,0,1,7,54,0,0,0,0,0,0,0),('management',55,19,'admin/reports/status','admin/reports/status','Status report','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:74:\"Get a status report about your site\'s operation and any detected problems.\";}}','system',0,0,0,0,-60,3,0,1,19,55,0,0,0,0,0,0,0),('management',56,8,'admin/config/system','admin/config/system','System','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"General system related configuration.\";}}','system',0,0,1,0,-20,3,0,1,8,56,0,0,0,0,0,0,0),('management',57,21,'admin/structure/taxonomy','admin/structure/taxonomy','Taxonomy','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:67:\"Manage tagging, categorization, and classification of your content.\";}}','system',0,0,1,0,0,3,0,1,21,57,0,0,0,0,0,0,0),('management',58,19,'admin/reports/access-denied','admin/reports/access-denied','Top \'access denied\' errors','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:35:\"View \'access denied\' errors (403s).\";}}','system',0,0,0,0,0,3,0,1,19,58,0,0,0,0,0,0,0),('management',59,19,'admin/reports/page-not-found','admin/reports/page-not-found','Top \'page not found\' errors','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:36:\"View \'page not found\' errors (404s).\";}}','system',0,0,0,0,0,3,0,1,19,59,0,0,0,0,0,0,0),('management',60,16,'admin/modules/uninstall','admin/modules/uninstall','Uninstall','a:0:{}','system',-1,0,0,0,20,3,0,1,16,60,0,0,0,0,0,0,0),('management',61,8,'admin/config/user-interface','admin/config/user-interface','User interface','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Tools that enhance the user interface.\";}}','system',0,0,1,0,-15,3,0,1,8,61,0,0,0,0,0,0,0),('navigation',62,5,'node/%/view','node/%/view','View','a:0:{}','system',-1,0,0,0,-10,2,0,5,62,0,0,0,0,0,0,0,0),('navigation',63,17,'user/%/view','user/%/view','View','a:0:{}','system',-1,0,0,0,-10,2,0,17,63,0,0,0,0,0,0,0,0),('management',64,8,'admin/config/services','admin/config/services','Web services','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:30:\"Tools related to web services.\";}}','system',0,0,1,0,0,3,0,1,8,64,0,0,0,0,0,0,0),('management',65,8,'admin/config/workflow','admin/config/workflow','Workflow','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Content workflow, editorial workflow tools.\";}}','system',0,0,1,0,5,3,0,1,8,65,0,0,0,0,0,0,0),('management',66,12,'admin/help/block','admin/help/block','block','a:0:{}','system',-1,0,0,0,0,3,0,1,12,66,0,0,0,0,0,0,0),('management',67,12,'admin/help/color','admin/help/color','color','a:0:{}','system',-1,0,0,0,0,3,0,1,12,67,0,0,0,0,0,0,0),('management',68,12,'admin/help/comment','admin/help/comment','comment','a:0:{}','system',-1,0,0,0,0,3,0,1,12,68,0,0,0,0,0,0,0),('management',69,12,'admin/help/contextual','admin/help/contextual','contextual','a:0:{}','system',-1,0,0,0,0,3,0,1,12,69,0,0,0,0,0,0,0),('management',70,12,'admin/help/dashboard','admin/help/dashboard','dashboard','a:0:{}','system',-1,0,0,0,0,3,0,1,12,70,0,0,0,0,0,0,0),('management',71,12,'admin/help/dblog','admin/help/dblog','dblog','a:0:{}','system',-1,0,0,0,0,3,0,1,12,71,0,0,0,0,0,0,0),('management',72,12,'admin/help/field','admin/help/field','field','a:0:{}','system',-1,0,0,0,0,3,0,1,12,72,0,0,0,0,0,0,0),('management',73,12,'admin/help/field_sql_storage','admin/help/field_sql_storage','field_sql_storage','a:0:{}','system',-1,0,0,0,0,3,0,1,12,73,0,0,0,0,0,0,0),('management',74,12,'admin/help/field_ui','admin/help/field_ui','field_ui','a:0:{}','system',-1,0,0,0,0,3,0,1,12,74,0,0,0,0,0,0,0),('management',75,12,'admin/help/file','admin/help/file','file','a:0:{}','system',-1,0,0,0,0,3,0,1,12,75,0,0,0,0,0,0,0),('management',76,12,'admin/help/filter','admin/help/filter','filter','a:0:{}','system',-1,0,0,0,0,3,0,1,12,76,0,0,0,0,0,0,0),('management',77,12,'admin/help/help','admin/help/help','help','a:0:{}','system',-1,0,0,0,0,3,0,1,12,77,0,0,0,0,0,0,0),('management',78,12,'admin/help/image','admin/help/image','image','a:0:{}','system',-1,0,0,0,0,3,0,1,12,78,0,0,0,0,0,0,0),('management',79,12,'admin/help/list','admin/help/list','list','a:0:{}','system',-1,0,0,0,0,3,0,1,12,79,0,0,0,0,0,0,0),('management',80,12,'admin/help/menu','admin/help/menu','menu','a:0:{}','system',-1,0,0,0,0,3,0,1,12,80,0,0,0,0,0,0,0),('management',81,12,'admin/help/node','admin/help/node','node','a:0:{}','system',-1,0,0,0,0,3,0,1,12,81,0,0,0,0,0,0,0),('management',82,12,'admin/help/options','admin/help/options','options','a:0:{}','system',-1,0,0,0,0,3,0,1,12,82,0,0,0,0,0,0,0),('management',83,12,'admin/help/system','admin/help/system','system','a:0:{}','system',-1,0,0,0,0,3,0,1,12,83,0,0,0,0,0,0,0),('management',84,12,'admin/help/taxonomy','admin/help/taxonomy','taxonomy','a:0:{}','system',-1,0,0,0,0,3,0,1,12,84,0,0,0,0,0,0,0),('management',85,12,'admin/help/text','admin/help/text','text','a:0:{}','system',-1,0,0,0,0,3,0,1,12,85,0,0,0,0,0,0,0),('management',86,12,'admin/help/user','admin/help/user','user','a:0:{}','system',-1,0,0,0,0,3,0,1,12,86,0,0,0,0,0,0,0),('navigation',87,27,'taxonomy/term/%/edit','taxonomy/term/%/edit','Edit','a:0:{}','system',-1,0,0,0,10,2,0,27,87,0,0,0,0,0,0,0,0),('navigation',88,27,'taxonomy/term/%/view','taxonomy/term/%/view','View','a:0:{}','system',-1,0,0,0,0,2,0,27,88,0,0,0,0,0,0,0,0),('management',89,57,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','','a:0:{}','system',0,0,1,0,0,4,0,1,21,57,89,0,0,0,0,0,0),('management',90,48,'admin/config/people/accounts','admin/config/people/accounts','Account settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:109:\"Configure default behavior of users, including registration requirements, e-mails, fields, and user pictures.\";}}','system',0,0,0,0,-10,4,0,1,8,48,90,0,0,0,0,0,0),('management',91,56,'admin/config/system/actions','admin/config/system/actions','Actions','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:41:\"Manage the actions defined for your site.\";}}','system',0,0,1,0,0,4,0,1,8,56,91,0,0,0,0,0,0),('management',92,30,'admin/structure/block/add','admin/structure/block/add','Add block','a:0:{}','system',-1,0,0,0,0,4,0,1,21,30,92,0,0,0,0,0,0),('management',93,36,'admin/structure/types/add','admin/structure/types/add','Add content type','a:0:{}','system',-1,0,0,0,0,4,0,1,21,36,93,0,0,0,0,0,0),('management',94,47,'admin/structure/menu/add','admin/structure/menu/add','Add menu','a:0:{}','system',-1,0,0,0,0,4,0,1,21,47,94,0,0,0,0,0,0),('management',95,57,'admin/structure/taxonomy/add','admin/structure/taxonomy/add','Add vocabulary','a:0:{}','system',-1,0,0,0,0,4,0,1,21,57,95,0,0,0,0,0,0),('management',97,54,'admin/appearance/settings/bartik','admin/appearance/settings/bartik','Bartik','a:0:{}','system',-1,0,0,0,0,4,0,1,7,54,97,0,0,0,0,0,0),('management',98,53,'admin/config/search/clean-urls','admin/config/search/clean-urls','Clean URLs','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Enable or disable clean URLs for your site.\";}}','system',0,0,0,0,5,4,0,1,8,53,98,0,0,0,0,0,0),('management',99,56,'admin/config/system/cron','admin/config/system/cron','Cron','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:40:\"Manage automatic site maintenance tasks.\";}}','system',0,0,0,0,20,4,0,1,8,56,99,0,0,0,0,0,0),('management',100,51,'admin/config/regional/date-time','admin/config/regional/date-time','Date and time','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:44:\"Configure display formats for date and time.\";}}','system',0,0,0,0,-15,4,0,1,8,51,100,0,0,0,0,0,0),('management',101,19,'admin/reports/event/%','admin/reports/event/%','Details','a:0:{}','system',0,0,0,0,0,3,0,1,19,101,0,0,0,0,0,0,0),('management',102,46,'admin/config/media/file-system','admin/config/media/file-system','File system','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:68:\"Tell Drupal where to store uploaded files and how they are accessed.\";}}','system',0,0,0,0,-10,4,0,1,8,46,102,0,0,0,0,0,0),('management',103,54,'admin/appearance/settings/garland','admin/appearance/settings/garland','Garland','a:0:{}','system',-1,0,0,0,0,4,0,1,7,54,103,0,0,0,0,0,0),('management',104,54,'admin/appearance/settings/global','admin/appearance/settings/global','Global settings','a:0:{}','system',-1,0,0,0,-1,4,0,1,7,54,104,0,0,0,0,0,0),('management',105,48,'admin/config/people/ip-blocking','admin/config/people/ip-blocking','IP address blocking','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:28:\"Manage blocked IP addresses.\";}}','system',0,0,1,0,10,4,0,1,8,48,105,0,0,0,0,0,0),('management',106,46,'admin/config/media/image-styles','admin/config/media/image-styles','Image styles','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:78:\"Configure styles that can be used for resizing or adjusting images on display.\";}}','system',0,0,1,0,0,4,0,1,8,46,106,0,0,0,0,0,0),('management',107,46,'admin/config/media/image-toolkit','admin/config/media/image-toolkit','Image toolkit','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:74:\"Choose which image toolkit to use if you have installed optional toolkits.\";}}','system',0,0,0,0,20,4,0,1,8,46,107,0,0,0,0,0,0),('management',108,43,'admin/modules/list/confirm','admin/modules/list/confirm','List','a:0:{}','system',-1,0,0,0,0,4,0,1,16,43,108,0,0,0,0,0,0),('management',109,36,'admin/structure/types/list','admin/structure/types/list','List','a:0:{}','system',-1,0,0,0,-10,4,0,1,21,36,109,0,0,0,0,0,0),('management',110,57,'admin/structure/taxonomy/list','admin/structure/taxonomy/list','List','a:0:{}','system',-1,0,0,0,-10,4,0,1,21,57,110,0,0,0,0,0,0),('management',111,47,'admin/structure/menu/list','admin/structure/menu/list','List menus','a:0:{}','system',-1,0,0,0,-10,4,0,1,21,47,111,0,0,0,0,0,0),('management',112,39,'admin/config/development/logging','admin/config/development/logging','Logging and errors','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:154:\"Settings for logging and alerts modules. Various modules can route Drupal\'s system events to different destinations, such as syslog, database, email, etc.\";}}','system',0,0,0,0,-15,4,0,1,8,39,112,0,0,0,0,0,0),('management',113,39,'admin/config/development/maintenance','admin/config/development/maintenance','Maintenance mode','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:62:\"Take the site offline for maintenance or bring it back online.\";}}','system',0,0,0,0,-10,4,0,1,8,39,113,0,0,0,0,0,0),('management',114,39,'admin/config/development/performance','admin/config/development/performance','Performance','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:101:\"Enable or disable page caching for anonymous users and set CSS and JS bandwidth optimization options.\";}}','system',0,0,0,0,-20,4,0,1,8,39,114,0,0,0,0,0,0),('management',115,49,'admin/people/permissions/list','admin/people/permissions/list','Permissions','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:64:\"Determine access to features by selecting permissions for roles.\";}}','system',-1,0,0,0,-8,4,0,1,18,49,115,0,0,0,0,0,0),('management',116,32,'admin/content/comment/new','admin/content/comment/new','Published comments','a:0:{}','system',-1,0,0,0,-10,4,0,1,9,32,116,0,0,0,0,0,0),('management',117,64,'admin/config/services/rss-publishing','admin/config/services/rss-publishing','RSS publishing','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:114:\"Configure the site description, the number of items per feed and whether feeds should be titles/teasers/full-text.\";}}','system',0,0,0,0,0,4,0,1,8,64,117,0,0,0,0,0,0),('management',118,51,'admin/config/regional/settings','admin/config/regional/settings','Regional settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:54:\"Settings for the site\'s default time zone and country.\";}}','system',0,0,0,0,-20,4,0,1,8,51,118,0,0,0,0,0,0),('management',119,49,'admin/people/permissions/roles','admin/people/permissions/roles','Roles','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:30:\"List, edit, or add user roles.\";}}','system',-1,0,1,0,-5,4,0,1,18,49,119,0,0,0,0,0,0),('management',120,47,'admin/structure/menu/settings','admin/structure/menu/settings','Settings','a:0:{}','system',-1,0,0,0,5,4,0,1,21,47,120,0,0,0,0,0,0),('management',121,54,'admin/appearance/settings/seven','admin/appearance/settings/seven','Seven','a:0:{}','system',-1,0,0,0,0,4,0,1,7,54,121,0,0,0,0,0,0),('management',122,56,'admin/config/system/site-information','admin/config/system/site-information','Site information','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:104:\"Change site name, e-mail address, slogan, default front page, and number of posts per page, error pages.\";}}','system',0,0,0,0,-20,4,0,1,8,56,122,0,0,0,0,0,0),('management',123,54,'admin/appearance/settings/stark','admin/appearance/settings/stark','Stark','a:0:{}','system',-1,0,0,0,0,4,0,1,7,54,123,0,0,0,0,0,0),('management',124,35,'admin/config/content/formats','admin/config/content/formats','Text formats','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:127:\"Configure how content input by users is filtered, including allowed HTML tags. Also allows enabling of module-provided filters.\";}}','system',0,0,1,0,0,4,0,1,8,35,124,0,0,0,0,0,0),('management',125,32,'admin/content/comment/approval','admin/content/comment/approval','Unapproved comments','a:0:{}','system',-1,0,0,0,0,4,0,1,9,32,125,0,0,0,0,0,0),('management',126,60,'admin/modules/uninstall/confirm','admin/modules/uninstall/confirm','Uninstall','a:0:{}','system',-1,0,0,0,0,4,0,1,16,60,126,0,0,0,0,0,0),('navigation',127,40,'user/%/edit/account','user/%/edit/account','Account','a:0:{}','system',-1,0,0,0,0,3,0,17,40,127,0,0,0,0,0,0,0),('management',128,124,'admin/config/content/formats/%','admin/config/content/formats/%','','a:0:{}','system',0,0,1,0,0,5,0,1,8,35,124,128,0,0,0,0,0),('management',129,106,'admin/config/media/image-styles/add','admin/config/media/image-styles/add','Add style','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:22:\"Add a new image style.\";}}','system',-1,0,0,0,2,5,0,1,8,46,106,129,0,0,0,0,0),('management',130,89,'admin/structure/taxonomy/%/add','admin/structure/taxonomy/%/add','Add term','a:0:{}','system',-1,0,0,0,0,5,0,1,21,57,89,130,0,0,0,0,0),('management',131,124,'admin/config/content/formats/add','admin/config/content/formats/add','Add text format','a:0:{}','system',-1,0,0,0,1,5,0,1,8,35,124,131,0,0,0,0,0),('management',133,30,'admin/structure/block/list/bartik','admin/structure/block/list/bartik','Bartik','a:0:{}','system',-1,0,0,0,0,4,0,1,21,30,133,0,0,0,0,0,0),('management',134,91,'admin/config/system/actions/configure','admin/config/system/actions/configure','Configure an advanced action','a:0:{}','system',-1,0,0,0,0,5,0,1,8,56,91,134,0,0,0,0,0),('management',135,47,'admin/structure/menu/manage/%','admin/structure/menu/manage/%','Customize menu','a:0:{}','system',0,0,1,0,0,4,0,1,21,47,135,0,0,0,0,0,0),('management',136,89,'admin/structure/taxonomy/%/edit','admin/structure/taxonomy/%/edit','Edit','a:0:{}','system',-1,0,0,0,-10,5,0,1,21,57,89,136,0,0,0,0,0),('management',137,36,'admin/structure/types/manage/%','admin/structure/types/manage/%','Edit content type','a:0:{}','system',0,0,1,0,0,4,0,1,21,36,137,0,0,0,0,0,0),('management',138,100,'admin/config/regional/date-time/formats','admin/config/regional/date-time/formats','Formats','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:51:\"Configure display format strings for date and time.\";}}','system',-1,0,1,0,-9,5,0,1,8,51,100,138,0,0,0,0,0),('management',139,30,'admin/structure/block/list/garland','admin/structure/block/list/garland','Garland','a:0:{}','system',-1,0,0,0,0,4,0,1,21,30,139,0,0,0,0,0,0),('management',140,124,'admin/config/content/formats/list','admin/config/content/formats/list','List','a:0:{}','system',-1,0,0,0,0,5,0,1,8,35,124,140,0,0,0,0,0),('management',141,89,'admin/structure/taxonomy/%/list','admin/structure/taxonomy/%/list','List','a:0:{}','system',-1,0,0,0,-20,5,0,1,21,57,89,141,0,0,0,0,0),('management',142,106,'admin/config/media/image-styles/list','admin/config/media/image-styles/list','List','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:42:\"List the current image styles on the site.\";}}','system',-1,0,0,0,1,5,0,1,8,46,106,142,0,0,0,0,0),('management',143,91,'admin/config/system/actions/manage','admin/config/system/actions/manage','Manage actions','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:41:\"Manage the actions defined for your site.\";}}','system',-1,0,0,0,-2,5,0,1,8,56,91,143,0,0,0,0,0),('management',144,90,'admin/config/people/accounts/settings','admin/config/people/accounts/settings','Settings','a:0:{}','system',-1,0,0,0,-10,5,0,1,8,48,90,144,0,0,0,0,0),('management',145,30,'admin/structure/block/list/seven','admin/structure/block/list/seven','Seven','a:0:{}','system',-1,0,0,0,0,4,0,1,21,30,145,0,0,0,0,0,0),('management',146,30,'admin/structure/block/list/stark','admin/structure/block/list/stark','Stark','a:0:{}','system',-1,0,0,0,0,4,0,1,21,30,146,0,0,0,0,0,0),('management',147,100,'admin/config/regional/date-time/types','admin/config/regional/date-time/types','Types','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:44:\"Configure display formats for date and time.\";}}','system',-1,0,1,0,-10,5,0,1,8,51,100,147,0,0,0,0,0),('navigation',148,52,'node/%/revisions/%/delete','node/%/revisions/%/delete','Delete earlier revision','a:0:{}','system',0,0,0,0,0,3,0,5,52,148,0,0,0,0,0,0,0),('navigation',149,52,'node/%/revisions/%/revert','node/%/revisions/%/revert','Revert to earlier revision','a:0:{}','system',0,0,0,0,0,3,0,5,52,149,0,0,0,0,0,0,0),('navigation',150,52,'node/%/revisions/%/view','node/%/revisions/%/view','Revisions','a:0:{}','system',0,0,0,0,0,3,0,5,52,150,0,0,0,0,0,0,0),('management',152,139,'admin/structure/block/list/garland/add','admin/structure/block/list/garland/add','Add block','a:0:{}','system',-1,0,0,0,0,5,0,1,21,30,139,152,0,0,0,0,0),('management',153,145,'admin/structure/block/list/seven/add','admin/structure/block/list/seven/add','Add block','a:0:{}','system',-1,0,0,0,0,5,0,1,21,30,145,153,0,0,0,0,0),('management',154,146,'admin/structure/block/list/stark/add','admin/structure/block/list/stark/add','Add block','a:0:{}','system',-1,0,0,0,0,5,0,1,21,30,146,154,0,0,0,0,0),('management',155,147,'admin/config/regional/date-time/types/add','admin/config/regional/date-time/types/add','Add date type','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:18:\"Add new date type.\";}}','system',-1,0,0,0,-10,6,0,1,8,51,100,147,155,0,0,0,0),('management',156,138,'admin/config/regional/date-time/formats/add','admin/config/regional/date-time/formats/add','Add format','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Allow users to add additional date formats.\";}}','system',-1,0,0,0,-10,6,0,1,8,51,100,138,156,0,0,0,0),('management',157,135,'admin/structure/menu/manage/%/add','admin/structure/menu/manage/%/add','Add link','a:0:{}','system',-1,0,0,0,0,5,0,1,21,47,135,157,0,0,0,0,0),('management',158,30,'admin/structure/block/manage/%/%','admin/structure/block/manage/%/%','Configure block','a:0:{}','system',0,0,0,0,0,4,0,1,21,30,158,0,0,0,0,0,0),('navigation',159,31,'user/%/cancel/confirm/%/%','user/%/cancel/confirm/%/%','Confirm account cancellation','a:0:{}','system',0,0,0,0,0,3,0,17,31,159,0,0,0,0,0,0,0),('management',160,137,'admin/structure/types/manage/%/delete','admin/structure/types/manage/%/delete','Delete','a:0:{}','system',0,0,0,0,0,5,0,1,21,36,137,160,0,0,0,0,0),('management',161,105,'admin/config/people/ip-blocking/delete/%','admin/config/people/ip-blocking/delete/%','Delete IP address','a:0:{}','system',0,0,0,0,0,5,0,1,8,48,105,161,0,0,0,0,0),('management',162,91,'admin/config/system/actions/delete/%','admin/config/system/actions/delete/%','Delete action','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:17:\"Delete an action.\";}}','system',0,0,0,0,0,5,0,1,8,56,91,162,0,0,0,0,0),('management',163,135,'admin/structure/menu/manage/%/delete','admin/structure/menu/manage/%/delete','Delete menu','a:0:{}','system',0,0,0,0,0,5,0,1,21,47,135,163,0,0,0,0,0),('management',164,47,'admin/structure/menu/item/%/delete','admin/structure/menu/item/%/delete','Delete menu link','a:0:{}','system',0,0,0,0,0,4,0,1,21,47,164,0,0,0,0,0,0),('management',165,119,'admin/people/permissions/roles/delete/%','admin/people/permissions/roles/delete/%','Delete role','a:0:{}','system',0,0,0,0,0,5,0,1,18,49,119,165,0,0,0,0,0),('management',166,128,'admin/config/content/formats/%/disable','admin/config/content/formats/%/disable','Disable text format','a:0:{}','system',0,0,0,0,0,6,0,1,8,35,124,128,166,0,0,0,0),('management',167,137,'admin/structure/types/manage/%/edit','admin/structure/types/manage/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,5,0,1,21,36,137,167,0,0,0,0,0),('management',168,135,'admin/structure/menu/manage/%/edit','admin/structure/menu/manage/%/edit','Edit menu','a:0:{}','system',-1,0,0,0,0,5,0,1,21,47,135,168,0,0,0,0,0),('management',169,47,'admin/structure/menu/item/%/edit','admin/structure/menu/item/%/edit','Edit menu link','a:0:{}','system',0,0,0,0,0,4,0,1,21,47,169,0,0,0,0,0,0),('management',170,119,'admin/people/permissions/roles/edit/%','admin/people/permissions/roles/edit/%','Edit role','a:0:{}','system',0,0,0,0,0,5,0,1,18,49,119,170,0,0,0,0,0),('management',171,106,'admin/config/media/image-styles/edit/%','admin/config/media/image-styles/edit/%','Edit style','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:25:\"Configure an image style.\";}}','system',0,0,1,0,0,5,0,1,8,46,106,171,0,0,0,0,0),('management',172,135,'admin/structure/menu/manage/%/list','admin/structure/menu/manage/%/list','List links','a:0:{}','system',-1,0,0,0,-10,5,0,1,21,47,135,172,0,0,0,0,0),('management',173,47,'admin/structure/menu/item/%/reset','admin/structure/menu/item/%/reset','Reset menu link','a:0:{}','system',0,0,0,0,0,4,0,1,21,47,173,0,0,0,0,0,0),('management',174,106,'admin/config/media/image-styles/delete/%','admin/config/media/image-styles/delete/%','Delete style','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:22:\"Delete an image style.\";}}','system',0,0,0,0,0,5,0,1,8,46,106,174,0,0,0,0,0),('management',175,106,'admin/config/media/image-styles/revert/%','admin/config/media/image-styles/revert/%','Revert style','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:22:\"Revert an image style.\";}}','system',0,0,0,0,0,5,0,1,8,46,106,175,0,0,0,0,0),('management',176,137,'admin/structure/types/manage/%/comment/display','admin/structure/types/manage/%/comment/display','Comment display','a:0:{}','system',-1,0,0,0,4,5,0,1,21,36,137,176,0,0,0,0,0),('management',177,137,'admin/structure/types/manage/%/comment/fields','admin/structure/types/manage/%/comment/fields','Comment fields','a:0:{}','system',-1,0,1,0,3,5,0,1,21,36,137,177,0,0,0,0,0),('management',178,158,'admin/structure/block/manage/%/%/configure','admin/structure/block/manage/%/%/configure','Configure block','a:0:{}','system',-1,0,0,0,0,5,0,1,21,30,158,178,0,0,0,0,0),('management',179,158,'admin/structure/block/manage/%/%/delete','admin/structure/block/manage/%/%/delete','Delete block','a:0:{}','system',-1,0,0,0,0,5,0,1,21,30,158,179,0,0,0,0,0),('management',180,138,'admin/config/regional/date-time/formats/%/delete','admin/config/regional/date-time/formats/%/delete','Delete date format','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:47:\"Allow users to delete a configured date format.\";}}','system',0,0,0,0,0,6,0,1,8,51,100,138,180,0,0,0,0),('management',181,147,'admin/config/regional/date-time/types/%/delete','admin/config/regional/date-time/types/%/delete','Delete date type','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Allow users to delete a configured date type.\";}}','system',0,0,0,0,0,6,0,1,8,51,100,147,181,0,0,0,0),('management',182,138,'admin/config/regional/date-time/formats/%/edit','admin/config/regional/date-time/formats/%/edit','Edit date format','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Allow users to edit a configured date format.\";}}','system',0,0,0,0,0,6,0,1,8,51,100,138,182,0,0,0,0),('management',183,171,'admin/config/media/image-styles/edit/%/add/%','admin/config/media/image-styles/edit/%/add/%','Add image effect','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:28:\"Add a new effect to a style.\";}}','system',0,0,0,0,0,6,0,1,8,46,106,171,183,0,0,0,0),('management',184,171,'admin/config/media/image-styles/edit/%/effects/%','admin/config/media/image-styles/edit/%/effects/%','Edit image effect','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:39:\"Edit an existing effect within a style.\";}}','system',0,0,1,0,0,6,0,1,8,46,106,171,184,0,0,0,0),('management',185,184,'admin/config/media/image-styles/edit/%/effects/%/delete','admin/config/media/image-styles/edit/%/effects/%/delete','Delete image effect','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:39:\"Delete an existing effect from a style.\";}}','system',0,0,0,0,0,7,0,1,8,46,106,171,184,185,0,0,0),('management',186,47,'admin/structure/menu/manage/main-menu','admin/structure/menu/manage/%','Main menu','a:0:{}','menu',0,0,0,0,0,4,0,1,21,47,186,0,0,0,0,0,0),('management',187,47,'admin/structure/menu/manage/management','admin/structure/menu/manage/%','Management','a:0:{}','menu',0,0,0,0,0,4,0,1,21,47,187,0,0,0,0,0,0),('management',188,47,'admin/structure/menu/manage/navigation','admin/structure/menu/manage/%','Navigation','a:0:{}','menu',0,0,0,0,0,4,0,1,21,47,188,0,0,0,0,0,0),('management',189,47,'admin/structure/menu/manage/user-menu','admin/structure/menu/manage/%','User menu','a:0:{}','menu',0,0,0,0,0,4,0,1,21,47,189,0,0,0,0,0,0),('navigation',190,0,'search','search','Search','a:0:{}','system',1,0,0,0,0,1,0,190,0,0,0,0,0,0,0,0,0),('navigation',191,190,'search/node','search/node','Content','a:0:{}','system',-1,0,0,0,-10,2,0,190,191,0,0,0,0,0,0,0,0),('navigation',192,190,'search/user','search/user','Users','a:0:{}','system',-1,0,0,0,0,2,0,190,192,0,0,0,0,0,0,0,0),('navigation',193,191,'search/node/%','search/node/%','Content','a:0:{}','system',-1,0,0,0,0,3,0,190,191,193,0,0,0,0,0,0,0),('navigation',194,17,'user/%/shortcuts','user/%/shortcuts','Shortcuts','a:0:{}','system',-1,0,0,0,0,2,0,17,194,0,0,0,0,0,0,0,0),('management',195,19,'admin/reports/search','admin/reports/search','Top search phrases','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"View most popular search phrases.\";}}','system',0,0,0,0,0,3,0,1,19,195,0,0,0,0,0,0,0),('navigation',196,192,'search/user/%','search/user/%','Users','a:0:{}','system',-1,0,0,0,0,3,0,190,192,196,0,0,0,0,0,0,0),('management',197,12,'admin/help/number','admin/help/number','number','a:0:{}','system',-1,0,0,0,0,3,0,1,12,197,0,0,0,0,0,0,0),('management',198,12,'admin/help/overlay','admin/help/overlay','overlay','a:0:{}','system',-1,0,0,0,0,3,0,1,12,198,0,0,0,0,0,0,0),('management',199,12,'admin/help/path','admin/help/path','path','a:0:{}','system',-1,0,0,0,0,3,0,1,12,199,0,0,0,0,0,0,0),('management',201,12,'admin/help/search','admin/help/search','search','a:0:{}','system',-1,0,0,0,0,3,0,1,12,201,0,0,0,0,0,0,0),('management',202,12,'admin/help/shortcut','admin/help/shortcut','shortcut','a:0:{}','system',-1,0,0,0,0,3,0,1,12,202,0,0,0,0,0,0,0),('management',203,53,'admin/config/search/settings','admin/config/search/settings','Search settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:67:\"Configure relevance settings for search and other indexing options.\";}}','system',0,0,0,0,-10,4,0,1,8,53,203,0,0,0,0,0,0),('management',204,61,'admin/config/user-interface/shortcut','admin/config/user-interface/shortcut','Shortcuts','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:29:\"Add and modify shortcut sets.\";}}','system',0,0,1,0,0,4,0,1,8,61,204,0,0,0,0,0,0),('management',205,53,'admin/config/search/path','admin/config/search/path','URL aliases','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:46:\"Change your site\'s URL paths by aliasing them.\";}}','system',0,0,1,0,-5,4,0,1,8,53,205,0,0,0,0,0,0),('management',206,205,'admin/config/search/path/add','admin/config/search/path/add','Add alias','a:0:{}','system',-1,0,0,0,0,5,0,1,8,53,205,206,0,0,0,0,0),('management',207,204,'admin/config/user-interface/shortcut/add-set','admin/config/user-interface/shortcut/add-set','Add shortcut set','a:0:{}','system',-1,0,0,0,0,5,0,1,8,61,204,207,0,0,0,0,0),('management',208,203,'admin/config/search/settings/reindex','admin/config/search/settings/reindex','Clear index','a:0:{}','system',-1,0,0,0,0,5,0,1,8,53,203,208,0,0,0,0,0),('management',209,204,'admin/config/user-interface/shortcut/%','admin/config/user-interface/shortcut/%','Edit shortcuts','a:0:{}','system',0,0,1,0,0,5,0,1,8,61,204,209,0,0,0,0,0),('management',210,205,'admin/config/search/path/list','admin/config/search/path/list','List','a:0:{}','system',-1,0,0,0,-10,5,0,1,8,53,205,210,0,0,0,0,0),('management',211,209,'admin/config/user-interface/shortcut/%/add-link','admin/config/user-interface/shortcut/%/add-link','Add shortcut','a:0:{}','system',-1,0,0,0,0,6,0,1,8,61,204,209,211,0,0,0,0),('management',212,205,'admin/config/search/path/delete/%','admin/config/search/path/delete/%','Delete alias','a:0:{}','system',0,0,0,0,0,5,0,1,8,53,205,212,0,0,0,0,0),('management',213,209,'admin/config/user-interface/shortcut/%/delete','admin/config/user-interface/shortcut/%/delete','Delete shortcut set','a:0:{}','system',0,0,0,0,0,6,0,1,8,61,204,209,213,0,0,0,0),('management',214,205,'admin/config/search/path/edit/%','admin/config/search/path/edit/%','Edit alias','a:0:{}','system',0,0,0,0,0,5,0,1,8,53,205,214,0,0,0,0,0),('management',215,209,'admin/config/user-interface/shortcut/%/edit','admin/config/user-interface/shortcut/%/edit','Edit set name','a:0:{}','system',-1,0,0,0,10,6,0,1,8,61,204,209,215,0,0,0,0),('management',216,204,'admin/config/user-interface/shortcut/link/%','admin/config/user-interface/shortcut/link/%','Edit shortcut','a:0:{}','system',0,0,1,0,0,5,0,1,8,61,204,216,0,0,0,0,0),('management',217,209,'admin/config/user-interface/shortcut/%/links','admin/config/user-interface/shortcut/%/links','List links','a:0:{}','system',-1,0,0,0,0,6,0,1,8,61,204,209,217,0,0,0,0),('management',218,216,'admin/config/user-interface/shortcut/link/%/delete','admin/config/user-interface/shortcut/link/%/delete','Delete shortcut','a:0:{}','system',0,0,0,0,0,6,0,1,8,61,204,216,218,0,0,0,0),('shortcut-set-1',219,0,'node/add','node/add','Add content','a:0:{}','menu',0,0,0,0,-20,1,0,219,0,0,0,0,0,0,0,0,0),('shortcut-set-1',220,0,'admin/content','admin/content','Find content','a:0:{}','menu',0,0,0,0,-19,1,0,220,0,0,0,0,0,0,0,0,0),('main-menu',221,0,'<front>','','Home','a:0:{}','menu',1,1,0,0,-50,1,1,221,0,0,0,0,0,0,0,0,0),('navigation',222,6,'node/add/article','node/add/article','Article','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:89:\"Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.\";}}','system',0,0,0,0,0,2,0,6,222,0,0,0,0,0,0,0,0),('navigation',223,6,'node/add/page','node/add/page','Basic page','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:77:\"Use <em>basic pages</em> for your static content, such as an \'About us\' page.\";}}','system',0,0,0,0,0,2,0,6,223,0,0,0,0,0,0,0,0),('management',263,16,'admin/modules/install','admin/modules/install','Install new module','a:0:{}','system',-1,0,0,0,25,3,0,1,16,263,0,0,0,0,0,0,0),('management',264,7,'admin/appearance/install','admin/appearance/install','Install new theme','a:0:{}','system',-1,0,0,0,25,3,0,1,7,264,0,0,0,0,0,0,0),('management',265,16,'admin/modules/update','admin/modules/update','Update','a:0:{}','system',-1,0,0,0,10,3,0,1,16,265,0,0,0,0,0,0,0),('management',266,19,'admin/reports/updates','admin/reports/updates','Available updates','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:82:\"Get a status report about available updates for your installed modules and themes.\";}}','system',0,0,0,0,-50,3,0,1,19,266,0,0,0,0,0,0,0),('management',267,7,'admin/appearance/update','admin/appearance/update','Update','a:0:{}','system',-1,0,0,0,10,3,0,1,7,267,0,0,0,0,0,0,0),('management',268,12,'admin/help/update','admin/help/update','update','a:0:{}','system',-1,0,0,0,0,3,0,1,12,268,0,0,0,0,0,0,0),('management',269,266,'admin/reports/updates/install','admin/reports/updates/install','Install new module or theme','a:0:{}','system',-1,0,0,0,25,4,0,1,19,266,269,0,0,0,0,0,0),('management',270,266,'admin/reports/updates/list','admin/reports/updates/list','List','a:0:{}','system',-1,0,0,0,0,4,0,1,19,266,270,0,0,0,0,0,0),('management',271,266,'admin/reports/updates/settings','admin/reports/updates/settings','Settings','a:0:{}','system',-1,0,0,0,50,4,0,1,19,266,271,0,0,0,0,0,0),('management',272,266,'admin/reports/updates/update','admin/reports/updates/update','Update','a:0:{}','system',-1,0,0,0,10,4,0,1,19,266,272,0,0,0,0,0,0),('management',311,133,'admin/structure/block/list/bartik/add','admin/structure/block/list/bartik/add','Add block','a:0:{}','system',-1,0,0,0,0,5,0,1,21,30,133,311,0,0,0,0,0),('navigation',312,0,'tagclouds','tagclouds','Tags','a:0:{}','system',1,0,0,0,0,1,0,312,0,0,0,0,0,0,0,0,0),('navigation',313,312,'tagclouds/chunk/%','tagclouds/chunk/%','Tags','a:0:{}','system',1,0,0,0,0,2,0,312,313,0,0,0,0,0,0,0,0),('management',314,8,'admin/config/administration','admin/config/administration','Administration','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:21:\"Administration tools.\";}}','system',0,0,1,0,0,3,0,1,8,314,0,0,0,0,0,0,0),('management',315,21,'admin/structure/field-collections','admin/structure/field-collections','Field collections','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:35:\"Manage fields on field collections.\";}}','system',0,0,1,0,0,3,0,1,21,315,0,0,0,0,0,0,0),('navigation',316,5,'node/%/simplenews','node/%/simplenews','Newsletter','a:0:{}','system',-1,0,0,0,2,2,0,5,316,0,0,0,0,0,0,0,0),('management',317,18,'admin/people/simplenews','admin/people/simplenews','Newsletter subscriptions','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:35:\"Newsletter subscription management.\";}}','system',-1,0,1,0,0,3,0,1,18,317,0,0,0,0,0,0,0),('management',318,9,'admin/content/simplenews','admin/content/simplenews','Newsletters','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:44:\"List newsletters and newsletter sent status.\";}}','system',-1,0,0,0,0,3,0,1,9,318,0,0,0,0,0,0,0),('navigation',319,5,'node/%/webform-results','node/%/webform-results','Results','a:0:{}','system',-1,0,0,0,2,2,0,5,319,0,0,0,0,0,0,0,0),('navigation',320,6,'node/add/simplenews','node/add/simplenews','Simplenews newsletter','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:60:\"A newsletter issue to be sent to subscribed email addresses.\";}}','system',0,0,0,0,0,2,0,6,320,0,0,0,0,0,0,0,0),('management',321,21,'admin/structure/views','admin/structure/views','Views','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:35:\"Manage customized lists of content.\";}}','system',0,0,1,0,0,3,0,1,21,321,0,0,0,0,0,0,0),('management',322,19,'admin/reports/views-plugins','admin/reports/views-plugins','Views plugins','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Overview of plugins used in all views.\";}}','system',0,0,0,0,0,3,0,1,19,322,0,0,0,0,0,0,0),('navigation',323,6,'node/add/webform','node/add/webform','Webform','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:138:\"Create a new form or questionnaire accessible to users. Submission results and statistics are recorded and accessible to privileged users.\";}}','system',0,0,0,0,0,2,0,6,323,0,0,0,0,0,0,0,0),('navigation',324,5,'node/%/webform','node/%/webform','Webform','a:0:{}','system',-1,0,0,0,1,2,0,5,324,0,0,0,0,0,0,0,0),('management',325,9,'admin/content/webform','admin/content/webform','Webforms','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:54:\"View and edit all the available webforms on your site.\";}}','system',-1,0,0,0,0,3,0,1,9,325,0,0,0,0,0,0,0),('management',326,12,'admin/help/admin_menu','admin/help/admin_menu','admin_menu','a:0:{}','system',-1,0,0,0,0,3,0,1,12,326,0,0,0,0,0,0,0),('management',327,12,'admin/help/field_collection','admin/help/field_collection','field_collection','a:0:{}','system',-1,0,0,0,0,3,0,1,12,327,0,0,0,0,0,0,0),('management',328,12,'admin/help/flexslider','admin/help/flexslider','flexslider','a:0:{}','system',-1,0,0,0,0,3,0,1,12,328,0,0,0,0,0,0,0),('management',329,12,'admin/help/jcarousel','admin/help/jcarousel','jcarousel','a:0:{}','system',-1,0,0,0,0,3,0,1,12,329,0,0,0,0,0,0,0),('management',330,12,'admin/help/jquery_update','admin/help/jquery_update','jquery_update','a:0:{}','system',-1,0,0,0,0,3,0,1,12,330,0,0,0,0,0,0,0),('management',331,12,'admin/help/simplenews','admin/help/simplenews','simplenews','a:0:{}','system',-1,0,0,0,0,3,0,1,12,331,0,0,0,0,0,0,0),('management',332,12,'admin/help/title','admin/help/title','title','a:0:{}','system',-1,0,0,0,0,3,0,1,12,332,0,0,0,0,0,0,0),('management',333,12,'admin/help/views_slideshow','admin/help/views_slideshow','views_slideshow','a:0:{}','system',-1,0,0,0,0,3,0,1,12,333,0,0,0,0,0,0,0),('management',334,12,'admin/help/views_slideshow_cycle','admin/help/views_slideshow_cycle','views_slideshow_cycle','a:0:{}','system',-1,0,0,0,0,3,0,1,12,334,0,0,0,0,0,0,0),('management',335,12,'admin/help/webform','admin/help/webform','webform','a:0:{}','system',-1,0,0,0,0,3,0,1,12,335,0,0,0,0,0,0,0),('management',336,321,'admin/structure/views/add','admin/structure/views/add','Add new view','a:0:{}','system',-1,0,0,0,0,4,0,1,21,321,336,0,0,0,0,0,0),('management',337,321,'admin/structure/views/add-template','admin/structure/views/add-template','Add view from template','a:0:{}','system',-1,0,0,0,0,4,0,1,21,321,337,0,0,0,0,0,0),('management',338,314,'admin/config/administration/admin_menu','admin/config/administration/admin_menu','Administration menu','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:36:\"Adjust administration menu settings.\";}}','system',0,0,0,0,0,4,0,1,8,314,338,0,0,0,0,0,0),('navigation',339,319,'node/%/webform-results/analysis','node/%/webform-results/analysis','Analysis','a:0:{}','system',-1,0,0,0,5,3,0,5,319,339,0,0,0,0,0,0,0),('navigation',340,319,'node/%/webform-results/clear','node/%/webform-results/clear','Clear','a:0:{}','system',-1,0,0,0,8,3,0,5,319,340,0,0,0,0,0,0,0),('navigation',341,324,'node/%/webform/conditionals','node/%/webform/conditionals','Conditionals','a:0:{}','system',-1,0,0,0,1,3,0,5,324,341,0,0,0,0,0,0,0),('navigation',342,319,'node/%/webform-results/download','node/%/webform-results/download','Download','a:0:{}','system',-1,0,0,0,7,3,0,5,319,342,0,0,0,0,0,0,0),('navigation',343,324,'node/%/webform/emails','node/%/webform/emails','E-mails','a:0:{}','system',-1,0,0,0,4,3,0,5,324,343,0,0,0,0,0,0,0),('management',344,317,'admin/people/simplenews/export','admin/people/simplenews/export','Export','a:0:{}','system',-1,0,0,0,10,4,0,1,18,317,344,0,0,0,0,0,0),('management',345,46,'admin/config/media/flexslider','admin/config/media/flexslider','FlexSlider','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:30:\"Administer FlexSlider presets.\";}}','system',0,0,0,0,0,4,0,1,8,46,345,0,0,0,0,0,0),('navigation',346,324,'node/%/webform/components','node/%/webform/components','Form components','a:0:{}','system',-1,0,0,0,0,3,0,5,324,346,0,0,0,0,0,0,0),('navigation',347,324,'node/%/webform/configure','node/%/webform/configure','Form settings','a:0:{}','system',-1,0,0,0,5,3,0,5,324,347,0,0,0,0,0,0,0),('management',348,321,'admin/structure/views/import','admin/structure/views/import','Import','a:0:{}','system',-1,0,0,0,0,4,0,1,21,321,348,0,0,0,0,0,0),('management',349,321,'admin/structure/views/list','admin/structure/views/list','List','a:0:{}','system',-1,0,0,0,-10,4,0,1,21,321,349,0,0,0,0,0,0),('management',350,42,'admin/reports/fields/list','admin/reports/fields/list','List','a:0:{}','system',-1,0,0,0,-10,4,0,1,19,42,350,0,0,0,0,0,0),('management',351,317,'admin/people/simplenews/import','admin/people/simplenews/import','Mass subscribe','a:0:{}','system',-1,0,0,0,8,4,0,1,18,317,351,0,0,0,0,0,0),('management',352,317,'admin/people/simplenews/unsubscribe','admin/people/simplenews/unsubscribe','Mass unsubscribe','a:0:{}','system',-1,0,0,0,9,4,0,1,18,317,352,0,0,0,0,0,0),('management',353,61,'admin/config/user-interface/modulefilter','admin/config/user-interface/modulefilter','Module filter','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:46:\"Configure how the modules page looks and acts.\";}}','system',0,0,0,0,0,4,0,1,8,61,353,0,0,0,0,0,0),('management',354,64,'admin/config/services/simplenews','admin/config/services/simplenews','Newsletters','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"Configure your sites newsletters.\";}}','system',0,0,0,0,0,4,0,1,8,64,354,0,0,0,0,0,0),('management',355,321,'admin/structure/views/settings','admin/structure/views/settings','Settings','a:0:{}','system',-1,0,0,0,0,4,0,1,21,321,355,0,0,0,0,0,0),('navigation',356,319,'node/%/webform-results/submissions','node/%/webform-results/submissions','Submissions','a:0:{}','system',-1,0,0,0,4,3,0,5,319,356,0,0,0,0,0,0,0),('navigation',357,319,'node/%/webform-results/table','node/%/webform-results/table','Table','a:0:{}','system',-1,0,0,0,6,3,0,5,319,357,0,0,0,0,0,0,0),('management',358,35,'admin/config/content/tagclouds','admin/config/content/tagclouds','TagClouds configuration','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:89:\"Configure the tag clouds. Set the order, the number of tags, and the depth of the clouds.\";}}','system',0,0,0,0,0,4,0,1,8,35,358,0,0,0,0,0,0),('management',359,35,'admin/config/content/title','admin/config/content/title','Title settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:30:\"Settings for the Title module.\";}}','system',0,0,0,0,0,4,0,1,8,35,359,0,0,0,0,0,0),('management',360,42,'admin/reports/fields/views-fields','admin/reports/fields/views-fields','Used in views','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"Overview of fields used in all views.\";}}','system',-1,0,0,0,0,4,0,1,19,42,360,0,0,0,0,0,0),('management',361,35,'admin/config/content/webform','admin/config/content/webform','Webform settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:46:\"Global configuration of webform functionality.\";}}','system',0,0,0,0,0,4,0,1,8,35,361,0,0,0,0,0,0),('management',362,39,'admin/config/development/jquery_update','admin/config/development/jquery_update','jQuery update','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:83:\"Configure settings related to the jQuery upgrade, the library path and compression.\";}}','system',0,0,0,0,0,4,0,1,8,39,362,0,0,0,0,0,0),('navigation',363,40,'user/%/edit/simplenews','user/%/edit/simplenews','','a:0:{}','system',-1,0,0,0,10,3,0,17,40,363,0,0,0,0,0,0,0),('management',364,345,'admin/config/media/flexslider/add','admin/config/media/flexslider/add','Add','a:0:{}','system',-1,0,0,0,0,5,0,1,8,46,345,364,0,0,0,0,0),('management',365,354,'admin/config/services/simplenews/add','admin/config/services/simplenews/add','Add newsletter category','a:0:{}','system',-1,0,0,0,-9,5,0,1,8,64,354,365,0,0,0,0,0),('management',366,355,'admin/structure/views/settings/advanced','admin/structure/views/settings/advanced','Advanced','a:0:{}','system',-1,0,0,0,1,5,0,1,21,321,355,366,0,0,0,0,0),('management',367,345,'admin/config/media/flexslider/advanced','admin/config/media/flexslider/advanced','Advanced settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:50:\"Configure the advanced flexslider module settings.\";}}','system',-1,0,0,0,2,5,0,1,8,46,345,367,0,0,0,0,0),('management',368,355,'admin/structure/views/settings/basic','admin/structure/views/settings/basic','Basic','a:0:{}','system',-1,0,0,0,0,5,0,1,21,321,355,368,0,0,0,0,0),('management',369,345,'admin/config/media/flexslider/import','admin/config/media/flexslider/import','Import','a:0:{}','system',-1,0,0,0,0,5,0,1,8,46,345,369,0,0,0,0,0),('management',370,345,'admin/config/media/flexslider/list','admin/config/media/flexslider/list','List','a:0:{}','system',-1,0,0,0,-10,5,0,1,8,46,345,370,0,0,0,0,0),('management',371,354,'admin/config/services/simplenews/categories','admin/config/services/simplenews/categories','Newsletters','a:0:{}','system',-1,0,1,0,0,5,0,1,8,64,354,371,0,0,0,0,0),('management',372,354,'admin/config/services/simplenews/settings','admin/config/services/simplenews/settings','Settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:20:\"Simplenews settings.\";}}','system',-1,0,0,0,20,5,0,1,8,64,354,372,0,0,0,0,0),('management',373,321,'admin/structure/views/view/%','admin/structure/views/view/%','','a:0:{}','system',0,0,0,0,0,4,0,1,21,321,373,0,0,0,0,0,0),('navigation',374,339,'node/%/webform-results/analysis/%','node/%/webform-results/analysis/%','Analysis','a:0:{}','system',-1,0,0,0,0,4,0,5,319,339,374,0,0,0,0,0,0),('navigation',375,5,'node/%/submission/%/delete','node/%/submission/%/delete','Delete','a:0:{}','system',-1,0,0,0,2,2,0,5,375,0,0,0,0,0,0,0,0),('navigation',376,5,'node/%/submission/%/edit','node/%/submission/%/edit','Edit','a:0:{}','system',-1,0,0,0,1,2,0,5,376,0,0,0,0,0,0,0,0),('navigation',377,346,'node/%/webform/components/%','node/%/webform/components/%','','a:0:{}','system',-1,0,0,0,0,4,0,5,324,346,377,0,0,0,0,0,0),('navigation',378,5,'node/%/submission/%/view','node/%/submission/%/view','View','a:0:{}','system',-1,0,0,0,0,2,0,5,378,0,0,0,0,0,0,0,0),('management',379,373,'admin/structure/views/view/%/break-lock','admin/structure/views/view/%/break-lock','Break lock','a:0:{}','system',-1,0,0,0,0,5,0,1,21,321,373,379,0,0,0,0,0),('management',380,373,'admin/structure/views/view/%/edit','admin/structure/views/view/%/edit','Edit view','a:0:{}','system',-1,0,0,0,-10,5,0,1,21,321,373,380,0,0,0,0,0),('navigation',381,374,'node/%/webform-results/analysis/%/more','node/%/webform-results/analysis/%/more','In-depth analysis','a:0:{}','system',-1,0,0,0,0,5,0,5,319,339,374,381,0,0,0,0,0),('management',382,372,'admin/config/services/simplenews/settings/newsletter','admin/config/services/simplenews/settings/newsletter','Newsletter','a:0:{}','system',-1,0,0,0,-15,6,0,1,8,64,354,372,382,0,0,0,0),('management',383,372,'admin/config/services/simplenews/settings/mail','admin/config/services/simplenews/settings/mail','Send mail','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"Send mail, cron and debug options.\";}}','system',-1,0,0,0,-5,6,0,1,8,64,354,372,383,0,0,0,0),('management',384,372,'admin/config/services/simplenews/settings/subscription','admin/config/services/simplenews/settings/subscription','Subscription','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:58:\"Subscription settings, opt-in/out confirmation email text.\";}}','system',-1,0,0,0,-10,6,0,1,8,64,354,372,384,0,0,0,0),('management',385,317,'admin/people/simplenews/users/edit/%','admin/people/simplenews/users/edit/%','Subscriptions','a:0:{}','system',0,0,0,0,0,4,0,1,18,317,385,0,0,0,0,0,0),('navigation',386,377,'node/%/webform/components/%/delete','node/%/webform/components/%/delete','','a:0:{}','system',-1,0,0,0,0,5,0,5,324,346,377,386,0,0,0,0,0),('navigation',387,377,'node/%/webform/components/%/clone','node/%/webform/components/%/clone','','a:0:{}','system',-1,0,0,0,0,5,0,5,324,346,377,387,0,0,0,0,0),('management',388,373,'admin/structure/views/view/%/clone','admin/structure/views/view/%/clone','Clone','a:0:{}','system',-1,0,0,0,0,5,0,1,21,321,373,388,0,0,0,0,0),('management',389,373,'admin/structure/views/view/%/delete','admin/structure/views/view/%/delete','Delete','a:0:{}','system',-1,0,0,0,0,5,0,1,21,321,373,389,0,0,0,0,0),('management',390,373,'admin/structure/views/view/%/export','admin/structure/views/view/%/export','Export','a:0:{}','system',-1,0,0,0,0,5,0,1,21,321,373,390,0,0,0,0,0),('management',391,373,'admin/structure/views/view/%/revert','admin/structure/views/view/%/revert','Revert','a:0:{}','system',-1,0,0,0,0,5,0,1,21,321,373,391,0,0,0,0,0),('management',395,371,'admin/config/services/simplenews/categories/%/delete','admin/config/services/simplenews/categories/%/delete','Newsletters','a:0:{}','system',0,0,0,0,0,6,0,1,8,64,354,371,395,0,0,0,0),('management',396,373,'admin/structure/views/view/%/preview/%','admin/structure/views/view/%/preview/%','','a:0:{}','system',-1,0,0,0,0,5,0,1,21,321,373,396,0,0,0,0,0),('management',397,371,'admin/config/services/simplenews/categories/%/edit','admin/config/services/simplenews/categories/%/edit','Newsletters','a:0:{}','system',0,0,0,0,0,6,0,1,8,64,354,371,397,0,0,0,0),('management',398,321,'admin/structure/views/ajax/preview/%/%','admin/structure/views/ajax/preview/%/%','','a:0:{}','system',0,0,0,0,0,4,0,1,21,321,398,0,0,0,0,0,0),('management',399,321,'admin/structure/views/nojs/preview/%/%','admin/structure/views/nojs/preview/%/%','','a:0:{}','system',0,0,0,0,0,4,0,1,21,321,399,0,0,0,0,0,0),('management',400,89,'admin/structure/taxonomy/%/fields/replace/%','admin/structure/taxonomy/%/fields/replace/%','Replace fields','a:0:{}','system',0,0,0,0,0,5,0,1,21,57,89,400,0,0,0,0,0),('management',401,370,'admin/config/media/flexslider/list/%/edit','admin/config/media/flexslider/list/%/edit','Edit','a:0:{}','system',-1,0,0,0,-10,6,0,1,8,46,345,370,401,0,0,0,0),('management',402,370,'admin/config/media/flexslider/list/%/export','admin/config/media/flexslider/list/%/export','Export','a:0:{}','system',-1,0,0,0,0,6,0,1,8,46,345,370,402,0,0,0,0),('management',403,137,'admin/structure/types/manage/%/fields/replace/%','admin/structure/types/manage/%/fields/replace/%','Replace fields','a:0:{}','system',0,0,0,0,0,5,0,1,21,36,137,403,0,0,0,0,0),('management',404,177,'admin/structure/types/manage/%/comment/fields/replace/%','admin/structure/types/manage/%/comment/fields/replace/%','Replace fields','a:0:{}','system',0,0,0,0,0,6,0,1,21,36,137,177,404,0,0,0,0),('user-menu',405,0,'user/login','user/login','Sign in','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',1,0,0,0,-50,1,1,405,0,0,0,0,0,0,0,0,0),('navigation',410,0,'cart','cart','Shopping cart','a:0:{}','system',0,0,0,0,0,1,0,410,0,0,0,0,0,0,0,0,0),('navigation',411,410,'cart/my','cart/my','Shopping cart (# items)','a:0:{}','system',1,0,0,0,0,2,0,410,411,0,0,0,0,0,0,0,0),('management',412,1,'admin/commerce','admin/commerce','Store','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:22:\"Administer your store.\";}}','system',0,0,1,0,-7,2,0,1,412,0,0,0,0,0,0,0,0),('management',413,412,'admin/commerce/config','admin/commerce/config','Configuration','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:53:\"Configure settings and business rules for your store.\";}}','system',0,0,1,0,50,3,0,1,412,413,0,0,0,0,0,0,0),('management',414,12,'admin/help/commerce_checkout','admin/help/commerce_checkout','commerce_checkout','a:0:{}','system',-1,0,0,0,0,3,0,1,12,414,0,0,0,0,0,0,0),('management',415,12,'admin/help/commerce_customer_ui','admin/help/commerce_customer_ui','commerce_customer_ui','a:0:{}','system',-1,0,0,0,0,3,0,1,12,415,0,0,0,0,0,0,0),('management',416,12,'admin/help/commerce_line_item_ui','admin/help/commerce_line_item_ui','commerce_line_item_ui','a:0:{}','system',-1,0,0,0,0,3,0,1,12,416,0,0,0,0,0,0,0),('management',417,12,'admin/help/commerce_order_ui','admin/help/commerce_order_ui','commerce_order_ui','a:0:{}','system',-1,0,0,0,0,3,0,1,12,417,0,0,0,0,0,0,0),('management',418,12,'admin/help/commerce_product_pricing_ui','admin/help/commerce_product_pricing_ui','commerce_product_pricing_ui','a:0:{}','system',-1,0,0,0,0,3,0,1,12,418,0,0,0,0,0,0,0),('management',419,12,'admin/help/commerce_product_ui','admin/help/commerce_product_ui','commerce_product_ui','a:0:{}','system',-1,0,0,0,0,3,0,1,12,419,0,0,0,0,0,0,0),('management',420,12,'admin/help/rules','admin/help/rules','rules','a:0:{}','system',-1,0,0,0,0,3,0,1,12,420,0,0,0,0,0,0,0),('management',421,412,'admin/commerce/customer-profiles','admin/commerce/customer-profiles','Customer profiles','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:56:\"Manage customer profiles and profile types in the store.\";}}','system',0,0,1,0,0,3,0,1,412,421,0,0,0,0,0,0,0),('management',422,412,'admin/commerce/orders','admin/commerce/orders','Orders','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:27:\"Manage orders in the store.\";}}','system',0,0,1,0,0,3,0,1,412,422,0,0,0,0,0,0,0),('management',423,412,'admin/commerce/products','admin/commerce/products','Products','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:47:\"Manage products and product types in the store.\";}}','system',0,0,1,0,0,3,0,1,412,423,0,0,0,0,0,0,0),('navigation',424,17,'user/%/orders','user/%/orders','Orders','a:0:{}','system',-1,0,1,0,15,2,0,17,424,0,0,0,0,0,0,0,0),('management',425,421,'admin/commerce/customer-profiles/%','admin/commerce/customer-profiles/%','','a:0:{}','system',0,0,0,0,0,4,0,1,412,421,425,0,0,0,0,0,0),('management',426,422,'admin/commerce/orders/%','admin/commerce/orders/%','','a:0:{}','system',0,0,0,0,0,4,0,1,412,422,426,0,0,0,0,0,0),('navigation',427,424,'user/%/orders/%','user/%/orders/%','','a:0:{}','system',0,0,0,0,0,3,0,17,424,427,0,0,0,0,0,0,0),('management',428,423,'admin/commerce/products/%','admin/commerce/products/%','','a:0:{}','system',0,0,0,0,0,4,0,1,412,423,428,0,0,0,0,0,0),('management',429,421,'admin/commerce/customer-profiles/add','admin/commerce/customer-profiles/add','Add a customer profile','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:27:\"Add a new customer profile.\";}}','system',0,0,1,0,10,4,0,1,412,421,429,0,0,0,0,0,0),('management',430,423,'admin/commerce/products/add','admin/commerce/products/add','Add a product','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:27:\"Add a new product for sale.\";}}','system',0,0,1,0,10,4,0,1,412,423,430,0,0,0,0,0,0),('management',431,413,'admin/commerce/config/checkout','admin/commerce/config/checkout','Checkout settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:57:\"Customize the checkout form and configure checkout rules.\";}}','system',0,0,0,0,0,4,0,1,412,413,431,0,0,0,0,0,0),('management',432,422,'admin/commerce/orders/add','admin/commerce/orders/add','Create an order','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:19:\"Create a new order.\";}}','system',0,0,1,0,10,4,0,1,412,422,432,0,0,0,0,0,0),('management',433,413,'admin/commerce/config/currency','admin/commerce/config/currency','Currency settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:52:\"Configure the default currency and display settings.\";}}','system',0,0,0,0,0,4,0,1,412,413,433,0,0,0,0,0,0),('management',434,413,'admin/commerce/config/line-items','admin/commerce/config/line-items','Line item types','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Manage line item types for your store.\";}}','system',0,0,1,0,0,4,0,1,412,413,434,0,0,0,0,0,0),('management',435,65,'admin/config/workflow/rules','admin/config/workflow/rules','Rules','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:42:\"Manage reaction rules and rule components.\";}}','system',0,0,0,0,0,4,0,1,8,65,435,0,0,0,0,0,0),('management',436,413,'admin/commerce/config/order','admin/commerce/config/order','Order settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:55:\"Configure general order settings, fields, and displays.\";}}','system',0,0,0,0,0,4,0,1,412,413,436,0,0,0,0,0,0),('management',437,413,'admin/commerce/config/product-pricing','admin/commerce/config/product-pricing','Product pricing rules','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:63:\"Enable and configure product pricing rules and pre-calculation.\";}}','system',0,0,0,0,0,4,0,1,412,413,437,0,0,0,0,0,0),('management',438,423,'admin/commerce/products/types','admin/commerce/products/types','Product types','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"Manage products types for your store.\";}}','system',-1,0,1,0,0,4,0,1,412,423,438,0,0,0,0,0,0),('management',439,421,'admin/commerce/customer-profiles/types','admin/commerce/customer-profiles/types','Profile types','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Manage customer profile types for your store.\";}}','system',-1,0,1,0,0,4,0,1,412,421,439,0,0,0,0,0,0),('management',440,421,'admin/commerce/customer-profiles/list','admin/commerce/customer-profiles/list','List','a:0:{}','system',-1,0,0,0,-10,4,0,1,412,421,440,0,0,0,0,0,0),('management',441,422,'admin/commerce/orders/list','admin/commerce/orders/list','Orders','a:0:{}','system',-1,0,0,0,-10,4,0,1,412,422,441,0,0,0,0,0,0),('management',442,422,'admin/commerce/orders/carts','admin/commerce/orders/carts','Shopping carts','a:0:{}','system',-1,0,0,0,0,4,0,1,412,422,442,0,0,0,0,0,0),('management',443,423,'admin/commerce/products/list','admin/commerce/products/list','List','a:0:{}','system',-1,0,0,0,-10,4,0,1,412,423,443,0,0,0,0,0,0),('management',444,438,'admin/commerce/products/types/add','admin/commerce/products/types/add','Add product type','a:0:{}','system',-1,0,0,0,0,5,0,1,412,423,438,444,0,0,0,0,0),('management',445,439,'admin/commerce/customer-profiles/types/billing','admin/commerce/customer-profiles/types/billing','Billing information','a:0:{}','system',0,0,0,0,0,5,0,1,412,421,439,445,0,0,0,0,0),('management',446,431,'admin/commerce/config/checkout/form','admin/commerce/config/checkout/form','Checkout form','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:70:\"Build your checkout pages using module defined checkout form elements.\";}}','system',-1,0,1,0,0,5,0,1,412,413,431,446,0,0,0,0,0),('management',447,431,'admin/commerce/config/checkout/rules','admin/commerce/config/checkout/rules','Checkout rules','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:47:\"Enable and configure checkout completion rules.\";}}','system',-1,0,0,0,5,5,0,1,412,413,431,447,0,0,0,0,0),('management',448,435,'admin/config/workflow/rules/components','admin/config/workflow/rules/components','Components','a:0:{}','system',-1,0,0,0,0,5,0,1,8,65,435,448,0,0,0,0,0),('management',449,430,'admin/commerce/products/add/product','admin/commerce/products/add/product','Create !name','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:21:\"A basic product type.\";}}','system',0,0,0,0,0,5,0,1,412,423,430,449,0,0,0,0,0),('management',450,429,'admin/commerce/customer-profiles/add/billing','admin/commerce/customer-profiles/add/billing','Create @name','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:80:\"The profile used to collect billing information on the checkout and order forms.\";}}','system',0,0,0,0,0,5,0,1,412,421,429,450,0,0,0,0,0),('management',451,432,'admin/commerce/orders/add/%','admin/commerce/orders/add/%','Create an order','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:42:\"Create a new order for the specified user.\";}}','system',0,0,0,0,0,5,0,1,412,422,432,451,0,0,0,0,0),('management',452,426,'admin/commerce/orders/%/delete','admin/commerce/orders/%/delete','Delete','a:0:{}','system',-1,0,0,0,20,5,0,1,412,422,426,452,0,0,0,0,0),('management',453,428,'admin/commerce/products/%/delete','admin/commerce/products/%/delete','Delete','a:0:{}','system',-1,0,0,0,20,5,0,1,412,423,428,453,0,0,0,0,0),('management',454,425,'admin/commerce/customer-profiles/%/delete','admin/commerce/customer-profiles/%/delete','Delete a customer profile','a:0:{}','system',-1,0,0,0,10,5,0,1,412,421,425,454,0,0,0,0,0),('management',455,425,'admin/commerce/customer-profiles/%/edit','admin/commerce/customer-profiles/%/edit','Edit','a:0:{}','system',-1,0,0,0,-10,5,0,1,412,421,425,455,0,0,0,0,0),('management',456,426,'admin/commerce/orders/%/edit','admin/commerce/orders/%/edit','Edit','a:0:{}','system',-1,0,0,0,-5,5,0,1,412,422,426,456,0,0,0,0,0),('management',457,428,'admin/commerce/products/%/edit','admin/commerce/products/%/edit','Edit','a:0:{}','system',-1,0,0,0,-10,5,0,1,412,423,428,457,0,0,0,0,0),('management',458,437,'admin/commerce/config/product-pricing/rules','admin/commerce/config/product-pricing/rules','List','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:62:\"Administer the rules used for calculating product sell prices.\";}}','system',-1,0,1,0,0,5,0,1,412,413,437,458,0,0,0,0,0),('management',461,437,'admin/commerce/config/product-pricing/pre-calculation','admin/commerce/config/product-pricing/pre-calculation','Pre-calculation','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Configure the price pre-calculation settings.\";}}','system',-1,0,0,0,5,5,0,1,412,413,437,461,0,0,0,0,0),('management',462,434,'admin/commerce/config/line-items/product','admin/commerce/config/line-items/product','Product','a:0:{}','system',0,0,0,0,0,5,0,1,412,413,434,462,0,0,0,0,0),('management',463,438,'admin/commerce/products/types/product','admin/commerce/products/types/product','Product','a:0:{}','system',0,0,0,0,0,5,0,1,412,423,438,463,0,0,0,0,0),('management',464,435,'admin/config/workflow/rules/reaction','admin/config/workflow/rules/reaction','Rules','a:0:{}','system',-1,0,0,0,-1,5,0,1,8,65,435,464,0,0,0,0,0),('management',465,436,'admin/commerce/config/order/settings','admin/commerce/config/order/settings','Settings','a:0:{}','system',-1,0,0,0,-10,5,0,1,412,413,436,465,0,0,0,0,0),('management',466,435,'admin/config/workflow/rules/settings','admin/config/workflow/rules/settings','Settings','a:0:{}','system',-1,0,0,0,1,5,0,1,8,65,435,466,0,0,0,0,0),('management',467,426,'admin/commerce/orders/%/view','admin/commerce/orders/%/view','View','a:0:{}','system',-1,0,0,0,-10,5,0,1,412,422,426,467,0,0,0,0,0),('management',468,426,'admin/commerce/orders/%/revisions','admin/commerce/orders/%/revisions','Revisions','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:29:\"View revisions of this order.\";}}','system',-1,0,0,0,20,5,0,1,412,422,426,468,0,0,0,0,0),('management',469,428,'admin/commerce/products/%/revisions','admin/commerce/products/%/revisions','Revisions','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:31:\"View revisions of this product.\";}}','system',-1,0,0,0,0,5,0,1,412,423,428,469,0,0,0,0,0),('management',470,447,'admin/commerce/config/checkout/rules/add','admin/commerce/config/checkout/rules/add','Add a checkout rule','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:58:\"Adds an additional checkout completion rule configuration.\";}}','system',-1,0,0,0,0,6,0,1,412,413,431,447,470,0,0,0,0),('management',471,458,'admin/commerce/config/product-pricing/rules/add','admin/commerce/config/product-pricing/rules/add','Add a pricing rule','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:61:\"Adds an additional sell price calculation rule configuration.\";}}','system',0,0,0,0,0,6,0,1,412,413,437,458,471,0,0,0,0),('management',472,448,'admin/config/workflow/rules/components/add','admin/config/workflow/rules/components/add','Add new component','a:0:{}','system',-1,0,0,0,0,6,0,1,8,65,435,448,472,0,0,0,0),('management',473,464,'admin/config/workflow/rules/reaction/add','admin/config/workflow/rules/reaction/add','Add new rule','a:0:{}','system',-1,0,0,0,0,6,0,1,8,65,435,464,473,0,0,0,0),('management',475,466,'admin/config/workflow/rules/settings/advanced','admin/config/workflow/rules/settings/advanced','Advanced','a:0:{}','system',-1,0,0,0,0,6,0,1,8,65,435,466,475,0,0,0,0),('management',476,456,'admin/commerce/orders/%/edit/refresh','admin/commerce/orders/%/edit/refresh','Apply pricing rules','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:89:\"Executes the cart order refresh used to apply all current pricing rules on the front end.\";}}','system',-1,0,0,0,0,6,0,1,412,422,426,456,476,0,0,0,0),('management',477,466,'admin/config/workflow/rules/settings/basic','admin/config/workflow/rules/settings/basic','Basic','a:0:{}','system',-1,0,0,0,-10,6,0,1,8,65,435,466,477,0,0,0,0),('management',480,463,'admin/commerce/products/types/product/delete','admin/commerce/products/types/product/delete','Delete','a:0:{}','system',-1,0,0,0,10,6,0,1,412,423,438,463,480,0,0,0,0),('management',481,463,'admin/commerce/products/types/product/edit','admin/commerce/products/types/product/edit','Edit','a:0:{}','system',-1,0,0,0,0,6,0,1,412,423,438,463,481,0,0,0,0),('management',482,448,'admin/config/workflow/rules/components/import','admin/config/workflow/rules/components/import','Import component','a:0:{}','system',-1,0,0,0,0,6,0,1,8,65,435,448,482,0,0,0,0),('management',483,464,'admin/config/workflow/rules/reaction/import','admin/config/workflow/rules/reaction/import','Import rule','a:0:{}','system',-1,0,0,0,0,6,0,1,8,65,435,464,483,0,0,0,0),('management',484,445,'admin/commerce/customer-profiles/types/billing/display','admin/commerce/customer-profiles/types/billing/display','Manage display','a:0:{}','system',-1,0,0,0,2,6,0,1,412,421,439,445,484,0,0,0,0),('management',485,462,'admin/commerce/config/line-items/product/display','admin/commerce/config/line-items/product/display','Manage display','a:0:{}','system',-1,0,0,0,2,6,0,1,412,413,434,462,485,0,0,0,0),('management',486,463,'admin/commerce/products/types/product/display','admin/commerce/products/types/product/display','Manage display','a:0:{}','system',-1,0,0,0,2,6,0,1,412,423,438,463,486,0,0,0,0),('management',487,445,'admin/commerce/customer-profiles/types/billing/fields','admin/commerce/customer-profiles/types/billing/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,6,0,1,412,421,439,445,487,0,0,0,0),('management',488,462,'admin/commerce/config/line-items/product/fields','admin/commerce/config/line-items/product/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,6,0,1,412,413,434,462,488,0,0,0,0),('management',489,463,'admin/commerce/products/types/product/fields','admin/commerce/products/types/product/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,6,0,1,412,423,438,463,489,0,0,0,0),('management',490,456,'admin/commerce/orders/%/edit/checkout','admin/commerce/orders/%/edit/checkout','Simulate checkout completion','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:60:\"Directly invokes the checkout completion rules on the order.\";}}','system',-1,0,0,0,0,6,0,1,412,422,426,456,490,0,0,0,0),('management',492,446,'admin/commerce/config/checkout/form/pane/%','admin/commerce/config/checkout/form/pane/%','','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Configure the settings for a checkout pane.\";}}','system',0,0,0,0,0,6,0,1,412,413,431,446,492,0,0,0,0),('management',493,447,'admin/commerce/config/checkout/rules/manage/%','admin/commerce/config/checkout/rules/manage/%','','a:0:{}','system',-1,0,1,0,0,6,0,1,412,413,431,447,493,0,0,0,0),('management',494,458,'admin/commerce/config/product-pricing/rules/manage/%','admin/commerce/config/product-pricing/rules/manage/%','','a:0:{}','system',-1,0,1,0,0,6,0,1,412,413,437,458,494,0,0,0,0),('management',495,448,'admin/config/workflow/rules/components/manage/%','admin/config/workflow/rules/components/manage/%','','a:0:{}','system',-1,0,1,0,0,6,0,1,8,65,435,448,495,0,0,0,0),('management',496,464,'admin/config/workflow/rules/reaction/manage/%','admin/config/workflow/rules/reaction/manage/%','','a:0:{}','system',-1,0,1,0,0,6,0,1,8,65,435,464,496,0,0,0,0),('management',513,493,'admin/commerce/config/checkout/rules/manage/%/clone','admin/commerce/config/checkout/rules/manage/%/clone','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,431,447,493,513,0,0,0),('management',514,494,'admin/commerce/config/product-pricing/rules/manage/%/clone','admin/commerce/config/product-pricing/rules/manage/%/clone','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,437,458,494,514,0,0,0),('management',515,495,'admin/config/workflow/rules/components/manage/%/clone','admin/config/workflow/rules/components/manage/%/clone','','a:0:{}','system',0,0,0,0,0,7,0,1,8,65,435,448,495,515,0,0,0),('management',516,496,'admin/config/workflow/rules/reaction/manage/%/clone','admin/config/workflow/rules/reaction/manage/%/clone','','a:0:{}','system',0,0,0,0,0,7,0,1,8,65,435,464,496,516,0,0,0),('management',517,493,'admin/commerce/config/checkout/rules/manage/%/execute','admin/commerce/config/checkout/rules/manage/%/execute','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,431,447,493,517,0,0,0),('management',518,494,'admin/commerce/config/product-pricing/rules/manage/%/execute','admin/commerce/config/product-pricing/rules/manage/%/execute','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,437,458,494,518,0,0,0),('management',519,495,'admin/config/workflow/rules/components/manage/%/execute','admin/config/workflow/rules/components/manage/%/execute','','a:0:{}','system',0,0,0,0,0,7,0,1,8,65,435,448,495,519,0,0,0),('management',520,496,'admin/config/workflow/rules/reaction/manage/%/execute','admin/config/workflow/rules/reaction/manage/%/execute','','a:0:{}','system',0,0,0,0,0,7,0,1,8,65,435,464,496,520,0,0,0),('management',521,493,'admin/commerce/config/checkout/rules/manage/%/export','admin/commerce/config/checkout/rules/manage/%/export','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,431,447,493,521,0,0,0),('management',522,494,'admin/commerce/config/product-pricing/rules/manage/%/export','admin/commerce/config/product-pricing/rules/manage/%/export','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,437,458,494,522,0,0,0),('management',523,495,'admin/config/workflow/rules/components/manage/%/export','admin/config/workflow/rules/components/manage/%/export','','a:0:{}','system',0,0,0,0,0,7,0,1,8,65,435,448,495,523,0,0,0),('management',524,496,'admin/config/workflow/rules/reaction/manage/%/export','admin/config/workflow/rules/reaction/manage/%/export','','a:0:{}','system',0,0,0,0,0,7,0,1,8,65,435,464,496,524,0,0,0),('management',525,493,'admin/commerce/config/checkout/rules/manage/%/%','admin/commerce/config/checkout/rules/manage/%/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,431,447,493,525,0,0,0),('management',526,494,'admin/commerce/config/product-pricing/rules/manage/%/%','admin/commerce/config/product-pricing/rules/manage/%/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,437,458,494,526,0,0,0),('management',527,495,'admin/config/workflow/rules/components/manage/%/%','admin/config/workflow/rules/components/manage/%/%','','a:0:{}','system',0,0,0,0,0,7,0,1,8,65,435,448,495,527,0,0,0),('management',528,496,'admin/config/workflow/rules/reaction/manage/%/%','admin/config/workflow/rules/reaction/manage/%/%','','a:0:{}','system',0,0,0,0,0,7,0,1,8,65,435,464,496,528,0,0,0),('management',529,489,'admin/commerce/products/types/product/fields/replace/%','admin/commerce/products/types/product/fields/replace/%','Replace fields','a:0:{}','system',0,0,0,0,0,7,0,1,412,423,438,463,489,529,0,0,0),('management',542,493,'admin/commerce/config/checkout/rules/manage/%/delete/event','admin/commerce/config/checkout/rules/manage/%/delete/event','Remove event','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"Remove an event from a reaction rule.\";}}','system',0,0,0,0,0,7,0,1,412,413,431,447,493,542,0,0,0),('management',543,494,'admin/commerce/config/product-pricing/rules/manage/%/delete/event','admin/commerce/config/product-pricing/rules/manage/%/delete/event','Remove event','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"Remove an event from a reaction rule.\";}}','system',0,0,0,0,0,7,0,1,412,413,437,458,494,543,0,0,0),('management',544,495,'admin/config/workflow/rules/components/manage/%/delete/event','admin/config/workflow/rules/components/manage/%/delete/event','Remove event','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"Remove an event from a reaction rule.\";}}','system',0,0,0,0,0,7,0,1,8,65,435,448,495,544,0,0,0),('management',545,496,'admin/config/workflow/rules/reaction/manage/%/delete/event','admin/config/workflow/rules/reaction/manage/%/delete/event','Remove event','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"Remove an event from a reaction rule.\";}}','system',0,0,0,0,0,7,0,1,8,65,435,464,496,545,0,0,0),('management',546,493,'admin/commerce/config/checkout/rules/manage/%/add/event','admin/commerce/config/checkout/rules/manage/%/add/event','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,431,447,493,546,0,0,0),('management',547,494,'admin/commerce/config/product-pricing/rules/manage/%/add/event','admin/commerce/config/product-pricing/rules/manage/%/add/event','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,437,458,494,547,0,0,0),('management',548,495,'admin/config/workflow/rules/components/manage/%/add/event','admin/config/workflow/rules/components/manage/%/add/event','','a:0:{}','system',0,0,0,0,0,7,0,1,8,65,435,448,495,548,0,0,0),('management',549,496,'admin/config/workflow/rules/reaction/manage/%/add/event','admin/config/workflow/rules/reaction/manage/%/add/event','','a:0:{}','system',0,0,0,0,0,7,0,1,8,65,435,464,496,549,0,0,0),('management',550,493,'admin/commerce/config/checkout/rules/manage/%/delete/%','admin/commerce/config/checkout/rules/manage/%/delete/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,431,447,493,550,0,0,0),('management',551,494,'admin/commerce/config/product-pricing/rules/manage/%/delete/%','admin/commerce/config/product-pricing/rules/manage/%/delete/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,437,458,494,551,0,0,0),('management',552,495,'admin/config/workflow/rules/components/manage/%/delete/%','admin/config/workflow/rules/components/manage/%/delete/%','','a:0:{}','system',0,0,0,0,0,7,0,1,8,65,435,448,495,552,0,0,0),('management',553,496,'admin/config/workflow/rules/reaction/manage/%/delete/%','admin/config/workflow/rules/reaction/manage/%/delete/%','','a:0:{}','system',0,0,0,0,0,7,0,1,8,65,435,464,496,553,0,0,0),('management',554,493,'admin/commerce/config/checkout/rules/manage/%/edit/%','admin/commerce/config/checkout/rules/manage/%/edit/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,431,447,493,554,0,0,0),('management',555,494,'admin/commerce/config/product-pricing/rules/manage/%/edit/%','admin/commerce/config/product-pricing/rules/manage/%/edit/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,437,458,494,555,0,0,0),('management',556,495,'admin/config/workflow/rules/components/manage/%/edit/%','admin/config/workflow/rules/components/manage/%/edit/%','','a:0:{}','system',0,0,0,0,0,7,0,1,8,65,435,448,495,556,0,0,0),('management',557,496,'admin/config/workflow/rules/reaction/manage/%/edit/%','admin/config/workflow/rules/reaction/manage/%/edit/%','','a:0:{}','system',0,0,0,0,0,7,0,1,8,65,435,464,496,557,0,0,0),('management',558,493,'admin/commerce/config/checkout/rules/manage/%/add/%','admin/commerce/config/checkout/rules/manage/%/add/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,431,447,493,558,0,0,0),('management',559,494,'admin/commerce/config/product-pricing/rules/manage/%/add/%','admin/commerce/config/product-pricing/rules/manage/%/add/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,437,458,494,559,0,0,0),('management',560,495,'admin/config/workflow/rules/components/manage/%/add/%','admin/config/workflow/rules/components/manage/%/add/%','','a:0:{}','system',0,0,0,0,0,7,0,1,8,65,435,448,495,560,0,0,0),('management',561,496,'admin/config/workflow/rules/reaction/manage/%/add/%','admin/config/workflow/rules/reaction/manage/%/add/%','','a:0:{}','system',0,0,0,0,0,7,0,1,8,65,435,464,496,561,0,0,0),('navigation',594,6,'node/add/product','node/add/product','Product','a:0:{}','system',0,0,0,0,0,2,0,6,594,0,0,0,0,0,0,0,0),('management',595,12,'admin/help/pathauto','admin/help/pathauto','pathauto','a:0:{}','system',-1,0,0,0,0,3,0,1,12,595,0,0,0,0,0,0,0),('management',596,12,'admin/help/token','admin/help/token','token','a:0:{}','system',-1,0,0,0,0,3,0,1,12,596,0,0,0,0,0,0,0),('management',597,205,'admin/config/search/path/update_bulk','admin/config/search/path/update_bulk','Bulk update','a:0:{}','system',-1,0,0,0,30,5,0,1,8,53,205,597,0,0,0,0,0),('management',598,205,'admin/config/search/path/delete_bulk','admin/config/search/path/delete_bulk','Delete aliases','a:0:{}','system',-1,0,0,0,40,5,0,1,8,53,205,598,0,0,0,0,0),('management',599,205,'admin/config/search/path/patterns','admin/config/search/path/patterns','Patterns','a:0:{}','system',-1,0,0,0,10,5,0,1,8,53,205,599,0,0,0,0,0),('management',600,205,'admin/config/search/path/settings','admin/config/search/path/settings','Settings','a:0:{}','system',-1,0,0,0,20,5,0,1,8,53,205,600,0,0,0,0,0),('main-menu',611,0,'taxonomy/term/8','taxonomy/term/%','Cameras','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:7:\"Cameras\";}}','taxonomy_menu',0,0,1,1,-43,1,1,611,0,0,0,0,0,0,0,0,0),('main-menu',612,0,'taxonomy/term/2','taxonomy/term/%','Clothes Shoes & Bags','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:20:\"Clothes Shoes & Bags\";}}','taxonomy_menu',0,0,1,1,-49,1,1,612,0,0,0,0,0,0,0,0,0),('main-menu',613,0,'taxonomy/term/7','taxonomy/term/%','Computers & Laptops','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:19:\"Computers & Laptops\";}}','taxonomy_menu',0,0,1,1,-44,1,1,613,0,0,0,0,0,0,0,0,0),('main-menu',614,0,'taxonomy/term/6','taxonomy/term/%','Consumer Electronics','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:20:\"Consumer Electronics\";}}','taxonomy_menu',0,0,1,1,-45,1,1,614,0,0,0,0,0,0,0,0,0),('main-menu',615,0,'taxonomy/term/3','taxonomy/term/%','Health & Beauty','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:15:\"Health & Beauty\";}}','taxonomy_menu',0,0,1,1,-48,1,1,615,0,0,0,0,0,0,0,0,0),('main-menu',616,0,'taxonomy/term/4','taxonomy/term/%','Mobiles & Tablets','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:17:\"Mobiles & Tablets\";}}','taxonomy_menu',0,0,1,1,-47,1,1,616,0,0,0,0,0,0,0,0,0),('main-menu',617,0,'taxonomy/term/9','taxonomy/term/%','Toys, Kids & Babies','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:19:\"Toys, Kids & Babies\";}}','taxonomy_menu',0,0,1,1,-42,1,1,617,0,0,0,0,0,0,0,0,0),('main-menu',618,0,'taxonomy/term/5','taxonomy/term/%','Watches & Accessories','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:21:\"Watches & Accessories\";}}','taxonomy_menu',0,0,1,1,-46,1,1,618,0,0,0,0,0,0,0,0,0),('management',628,47,'admin/structure/menu/manage/menu-customer-help','admin/structure/menu/manage/%','Customer help','a:0:{}','menu',0,0,0,0,0,4,0,1,21,47,628,0,0,0,0,0,0),('menu-customer-help',630,0,'node/16','node/%','Payment & Pricing ','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,0,1,1,630,0,0,0,0,0,0,0,0,0),('menu-customer-help',631,0,'node/17','node/%','How to buy','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,0,1,1,631,0,0,0,0,0,0,0,0,0),('menu-customer-help',632,0,'node/18','node/%','Shipping & Pickup','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,0,1,1,632,0,0,0,0,0,0,0,0,0),('menu-customer-help',633,0,'node/19','node/%','Returns & Refunds ','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,0,1,1,633,0,0,0,0,0,0,0,0,0),('menu-customer-help',634,0,'node/20','node/%','Order Status','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,0,1,1,634,0,0,0,0,0,0,0,0,0),('management',635,47,'admin/structure/menu/manage/menu-about-us','admin/structure/menu/manage/%','About us','a:0:{}','menu',0,0,0,0,0,4,0,1,21,47,635,0,0,0,0,0,0),('menu-about-us',636,0,'node/27','node/%','About Marketplace','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,0,1,1,636,0,0,0,0,0,0,0,0,0),('menu-about-us',637,0,'node/22','node/%','Afﬁliate Program','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,0,1,1,637,0,0,0,0,0,0,0,0,0),('menu-about-us',638,0,'node/23','node/%','Terms & Conditions','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,0,1,1,638,0,0,0,0,0,0,0,0,0),('menu-about-us',639,0,'node/24','node/%','Privacy Policy','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,0,1,1,639,0,0,0,0,0,0,0,0,0),('menu-about-us',641,0,'node/26','node/%','Sell on Marketplace','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,0,1,1,641,0,0,0,0,0,0,0,0,0),('management',642,12,'admin/help/php','admin/help/php','php','a:0:{}','system',-1,0,0,0,0,3,0,1,12,642,0,0,0,0,0,0,0),('main-menu',644,0,'products','products','All categories','a:2:{s:10:\"attributes\";a:2:{s:5:\"class\";a:1:{i:0;s:14:\"all-categories\";}s:5:\"title\";s:0:\"\";}s:15:\"item_attributes\";a:3:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:5:\"style\";s:0:\"\";}}','menu',0,0,0,0,-41,1,1,644,0,0,0,0,0,0,0,0,0),('management',651,54,'admin/appearance/settings/marketplace','admin/appearance/settings/marketplace','Market Place','a:0:{}','system',-1,0,0,0,0,4,0,1,7,54,651,0,0,0,0,0,0),('management',652,30,'admin/structure/block/list/marketplace','admin/structure/block/list/marketplace','Market Place','a:0:{}','system',-1,0,0,0,-10,4,0,1,21,30,652,0,0,0,0,0,0),('management',655,21,'admin/structure/context','admin/structure/context','Context','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:84:\"Associate menus, views, blocks, etc. with different contexts to structure your site.\";}}','system',0,0,0,0,0,3,0,1,21,655,0,0,0,0,0,0,0),('management',656,12,'admin/help/context','admin/help/context','context','a:0:{}','system',-1,0,0,0,0,3,0,1,12,656,0,0,0,0,0,0,0),('management',657,12,'admin/help/context_ui','admin/help/context_ui','context_ui','a:0:{}','system',-1,0,0,0,0,3,0,1,12,657,0,0,0,0,0,0,0),('management',658,655,'admin/structure/context/add','admin/structure/context/add','Add','a:0:{}','system',-1,0,0,0,0,4,0,1,21,655,658,0,0,0,0,0,0),('management',659,655,'admin/structure/context/import','admin/structure/context/import','Import','a:0:{}','system',-1,0,0,0,0,4,0,1,21,655,659,0,0,0,0,0,0),('management',660,655,'admin/structure/context/list','admin/structure/context/list','List','a:0:{}','system',-1,0,0,0,-10,4,0,1,21,655,660,0,0,0,0,0,0),('management',661,655,'admin/structure/context/settings','admin/structure/context/settings','Settings','a:0:{}','system',-1,0,0,0,3,4,0,1,21,655,661,0,0,0,0,0,0),('management',662,660,'admin/structure/context/list/%/edit','admin/structure/context/list/%/edit','Edit','a:0:{}','system',-1,0,0,0,-10,5,0,1,21,655,660,662,0,0,0,0,0),('management',663,660,'admin/structure/context/list/%/export','admin/structure/context/list/%/export','Export','a:0:{}','system',-1,0,0,0,0,5,0,1,21,655,660,663,0,0,0,0,0),('devel',664,0,'devel/settings','devel/settings','Devel settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:171:\"Helper functions, pages, and blocks to assist Drupal developers. The devel blocks can be managed via the <a href=\"/en/admin/structure/block\">block administration</a> page.\";}}','system',0,0,0,0,0,1,0,664,0,0,0,0,0,0,0,0,0),('devel',665,0,'devel/php','devel/php','Execute PHP Code','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:21:\"Execute some PHP code\";}}','system',0,0,0,0,0,1,0,665,0,0,0,0,0,0,0,0,0),('devel',666,0,'devel/reference','devel/reference','Function reference','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:73:\"View a list of currently defined user functions with documentation links.\";}}','system',0,0,0,0,0,1,0,666,0,0,0,0,0,0,0,0,0),('devel',667,0,'devel/elements','devel/elements','Hook_elements()','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:51:\"View the active form/render elements for this site.\";}}','system',0,0,0,0,0,1,0,667,0,0,0,0,0,0,0,0,0),('devel',668,0,'devel/phpinfo','devel/phpinfo','PHPinfo()','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:36:\"View your server\'s PHP configuration\";}}','system',0,0,0,0,0,1,0,668,0,0,0,0,0,0,0,0,0),('devel',669,0,'devel/reinstall','devel/reinstall','Reinstall modules','a:2:{s:10:\"attributes\";a:1:{s:5:\"title\";s:64:\"Run hook_uninstall() and then hook_install() for a given module.\";}s:5:\"alter\";b:1;}','system',0,0,0,0,0,1,0,669,0,0,0,0,0,0,0,0,0),('devel',670,0,'devel/run-cron','devel/run-cron','Run cron','a:0:{}','system',0,0,0,0,0,1,0,670,0,0,0,0,0,0,0,0,0),('devel',671,0,'devel/session','devel/session','Session viewer','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:31:\"List the contents of $_SESSION.\";}}','system',0,0,0,0,0,1,0,671,0,0,0,0,0,0,0,0,0),('devel',672,0,'devel/variable','devel/variable','Variable editor','a:2:{s:10:\"attributes\";a:1:{s:5:\"title\";s:31:\"Edit and delete site variables.\";}s:5:\"alter\";b:1;}','system',0,0,0,0,0,1,0,672,0,0,0,0,0,0,0,0,0),('devel',673,0,'devel/cache/clear','devel/cache/clear','Clear cache','a:2:{s:10:\"attributes\";a:1:{s:5:\"title\";s:100:\"Clear the CSS cache and all database cache tables which store page, node, theme and variable caches.\";}s:5:\"alter\";b:1;}','system',0,0,0,0,0,1,0,673,0,0,0,0,0,0,0,0,0),('navigation',675,3,'comment/%/devel','comment/%/devel','Devel','a:0:{}','system',-1,0,0,0,100,2,0,3,675,0,0,0,0,0,0,0,0),('navigation',676,5,'node/%/devel','node/%/devel','Devel','a:0:{}','system',-1,0,0,0,100,2,0,5,676,0,0,0,0,0,0,0,0),('navigation',677,17,'user/%/devel','user/%/devel','Devel','a:0:{}','system',-1,0,0,0,100,2,0,17,677,0,0,0,0,0,0,0,0),('devel',678,0,'devel/entity/info','devel/entity/info','Entity info','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:46:\"View entity information across the whole site.\";}}','system',0,0,0,0,0,1,0,678,0,0,0,0,0,0,0,0,0),('devel',679,0,'devel/field/info','devel/field/info','Field info','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:46:\"View fields information across the whole site.\";}}','system',0,0,0,0,0,1,0,679,0,0,0,0,0,0,0,0,0),('devel',680,0,'devel/menu/item','devel/menu/item','Menu item','a:2:{s:10:\"attributes\";a:1:{s:5:\"title\";s:32:\"Details about a given menu item.\";}s:5:\"alter\";b:1;}','system',0,0,0,0,0,1,0,680,0,0,0,0,0,0,0,0,0),('devel',681,0,'devel/menu/reset','devel/menu/reset','Rebuild menus','a:2:{s:10:\"attributes\";a:1:{s:5:\"title\";s:113:\"Rebuild menu based on hook_menu() and revert any custom changes. All menu items return to their default settings.\";}s:5:\"alter\";b:1;}','system',0,0,0,0,0,1,0,681,0,0,0,0,0,0,0,0,0),('devel',682,0,'devel/theme/registry','devel/theme/registry','Theme registry','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:63:\"View a list of available theme functions across the whole site.\";}}','system',0,0,0,0,0,1,0,682,0,0,0,0,0,0,0,0,0),('management',683,12,'admin/help/devel','admin/help/devel','devel','a:0:{}','system',-1,0,0,0,0,3,0,1,12,683,0,0,0,0,0,0,0),('navigation',684,27,'taxonomy/term/%/devel','taxonomy/term/%/devel','Devel','a:0:{}','system',-1,0,0,0,100,2,0,27,684,0,0,0,0,0,0,0,0),('management',685,39,'admin/config/development/devel','admin/config/development/devel','Devel settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:171:\"Helper functions, pages, and blocks to assist Drupal developers. The devel blocks can be managed via the <a href=\"/en/admin/structure/block\">block administration</a> page.\";}}','system',0,0,0,0,0,4,0,1,8,39,685,0,0,0,0,0,0),('navigation',687,675,'comment/%/devel/load','comment/%/devel/load','Load','a:0:{}','system',-1,0,0,0,0,3,0,3,675,687,0,0,0,0,0,0,0),('navigation',688,676,'node/%/devel/load','node/%/devel/load','Load','a:0:{}','system',-1,0,0,0,0,3,0,5,676,688,0,0,0,0,0,0,0),('navigation',689,677,'user/%/devel/load','user/%/devel/load','Load','a:0:{}','system',-1,0,0,0,0,3,0,17,677,689,0,0,0,0,0,0,0),('navigation',691,675,'comment/%/devel/render','comment/%/devel/render','Render','a:0:{}','system',-1,0,0,0,100,3,0,3,675,691,0,0,0,0,0,0,0),('navigation',692,676,'node/%/devel/render','node/%/devel/render','Render','a:0:{}','system',-1,0,0,0,100,3,0,5,676,692,0,0,0,0,0,0,0),('navigation',693,677,'user/%/devel/render','user/%/devel/render','Render','a:0:{}','system',-1,0,0,0,100,3,0,17,677,693,0,0,0,0,0,0,0),('navigation',694,676,'node/%/devel/token','node/%/devel/token','Tokens','a:0:{}','system',-1,0,0,0,5,3,0,5,676,694,0,0,0,0,0,0,0),('navigation',695,677,'user/%/devel/token','user/%/devel/token','Tokens','a:0:{}','system',-1,0,0,0,5,3,0,17,677,695,0,0,0,0,0,0,0),('navigation',696,675,'comment/%/devel/token','comment/%/devel/token','Tokens','a:0:{}','system',-1,0,0,0,5,3,0,3,675,696,0,0,0,0,0,0,0),('navigation',697,684,'taxonomy/term/%/devel/load','taxonomy/term/%/devel/load','Load','a:0:{}','system',-1,0,0,0,0,3,0,27,684,697,0,0,0,0,0,0,0),('navigation',698,684,'taxonomy/term/%/devel/render','taxonomy/term/%/devel/render','Render','a:0:{}','system',-1,0,0,0,100,3,0,27,684,698,0,0,0,0,0,0,0),('navigation',699,684,'taxonomy/term/%/devel/token','taxonomy/term/%/devel/token','Tokens','a:0:{}','system',-1,0,0,0,5,3,0,27,684,699,0,0,0,0,0,0,0),('navigation',700,5,'node/%/submission/%/devel','node/%/submission/%/devel','Devel','a:0:{}','system',-1,0,0,0,100,2,0,5,700,0,0,0,0,0,0,0,0),('navigation',701,700,'node/%/submission/%/devel/load','node/%/submission/%/devel/load','Load','a:0:{}','system',-1,0,0,0,0,3,0,5,700,701,0,0,0,0,0,0,0),('navigation',702,700,'node/%/submission/%/devel/token','node/%/submission/%/devel/token','Tokens','a:0:{}','system',-1,0,0,0,5,3,0,5,700,702,0,0,0,0,0,0,0),('navigation',805,6,'node/add/banner','node/add/banner','Banner','a:0:{}','system',0,0,0,0,0,2,0,6,805,0,0,0,0,0,0,0,0),('management',806,21,'admin/structure/entity-type','admin/structure/entity-type','Entity types','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:53:\"A centralized administrative section for entity types\";}}','system',0,0,1,0,0,3,0,1,21,806,0,0,0,0,0,0,0),('navigation',807,17,'user/%/imce','user/%/imce','File browser','a:0:{}','system',-1,0,0,0,10,2,0,17,807,0,0,0,0,0,0,0,0),('navigation',808,17,'user/%/stores','user/%/stores','Stores','a:0:{}','system',-1,0,0,0,0,2,0,17,808,0,0,0,0,0,0,0,0),('navigation',809,0,'commerce_store/store/%','commerce_store/store/%','View Store','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:55:\"View an entity of type Commerce Store with bundle Store\";}}','system',0,0,0,0,0,1,0,809,0,0,0,0,0,0,0,0,0),('management',810,12,'admin/help/ckeditor','admin/help/ckeditor','ckeditor','a:0:{}','system',-1,0,0,0,0,3,0,1,12,810,0,0,0,0,0,0,0),('navigation',811,809,'commerce_store/store/%/products','commerce_store/store/%/products','','a:0:{}','system',-1,0,0,0,4,2,0,809,811,0,0,0,0,0,0,0,0),('navigation',812,809,'commerce_store/store/%/delete','commerce_store/store/%/delete','Delete','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:55:\"View an entity of type Commerce Store with bundle Store\";}}','system',-1,0,0,0,2,2,0,809,812,0,0,0,0,0,0,0,0),('navigation',813,809,'commerce_store/store/%/edit','commerce_store/store/%/edit','Edit','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:55:\"View an entity of type Commerce Store with bundle Store\";}}','system',-1,0,0,0,1,2,0,809,813,0,0,0,0,0,0,0,0),('navigation',814,809,'commerce_store/store/%/people','commerce_store/store/%/people','Members','a:0:{}','system',-1,0,0,0,5,2,0,809,814,0,0,0,0,0,0,0,0),('navigation',815,809,'commerce_store/store/%/sales','commerce_store/store/%/sales','Sales','a:0:{}','system',-1,0,1,0,5,2,0,809,815,0,0,0,0,0,0,0,0),('navigation',816,809,'commerce_store/store/%/view','commerce_store/store/%/view','View','a:0:{}','system',-1,0,0,0,0,2,0,809,816,0,0,0,0,0,0,0,0),('management',817,806,'admin/structure/entity-type/add','admin/structure/entity-type/add','Add entity type','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:21:\"Add a new entity type\";}}','system',-1,0,0,0,-1,4,0,1,21,806,817,0,0,0,0,0,0),('management',818,35,'admin/config/content/ckeditor','admin/config/content/ckeditor','CKEditor','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:31:\"Configure the rich text editor.\";}}','system',0,0,0,0,0,4,0,1,8,35,818,0,0,0,0,0,0),('management',819,806,'admin/structure/entity-type/commerce_store','admin/structure/entity-type/commerce_store','Commerce Store','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:41:\"View all the bundles for \'Commerce Store\'\";}}','system',0,0,1,0,0,4,0,1,21,806,819,0,0,0,0,0,0),('management',820,413,'admin/commerce/config/commerce_store_order','admin/commerce/config/commerce_store_order','Commerce Store Order settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:61:\"Configure general store order settings, fields, and displays.\";}}','system',0,0,0,0,0,4,0,1,412,413,820,0,0,0,0,0,0),('management',821,46,'admin/config/media/imce','admin/config/media/imce','IMCE','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:42:\"Control how your image/file browser works.\";}}','system',0,0,0,0,0,4,0,1,8,46,821,0,0,0,0,0,0),('navigation',822,815,'commerce_store/store/%/sales/%','commerce_store/store/%/sales/%','','a:0:{}','system',0,0,1,0,0,3,0,809,815,822,0,0,0,0,0,0,0),('navigation',823,814,'commerce_store/store/%/people/add','commerce_store/store/%/people/add','Add','a:0:{}','system',-1,0,0,0,0,3,0,809,814,823,0,0,0,0,0,0,0),('navigation',824,814,'commerce_store/store/%/people/list','commerce_store/store/%/people/list','List','a:0:{}','system',-1,0,0,0,0,3,0,809,814,824,0,0,0,0,0,0,0),('navigation',825,814,'commerce_store/store/%/people/permissions','commerce_store/store/%/people/permissions','Permissions','a:0:{}','system',-1,0,0,0,0,3,0,809,814,825,0,0,0,0,0,0,0),('navigation',826,814,'commerce_store/store/%/people/roles','commerce_store/store/%/people/roles','Roles','a:0:{}','system',-1,0,1,0,0,3,0,809,814,826,0,0,0,0,0,0,0),('management',827,819,'admin/structure/entity-type/commerce_store/add','admin/structure/entity-type/commerce_store/add','Add bundle ','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:36:\"Add a(n) new \'Commerce Store Bundle\'\";}}','system',-1,0,0,0,0,5,0,1,21,806,819,827,0,0,0,0,0),('management',828,821,'admin/config/media/imce/profile','admin/config/media/imce/profile','Add new profile','a:0:{}','system',-1,0,0,0,0,5,0,1,8,46,821,828,0,0,0,0,0),('management',829,819,'admin/structure/entity-type/commerce_store/list','admin/structure/entity-type/commerce_store/list','Bundle List','a:0:{}','system',-1,0,0,0,100,5,0,1,21,806,819,829,0,0,0,0,0),('management',830,429,'admin/commerce/customer-profiles/add/shipping','admin/commerce/customer-profiles/add/shipping','Create @name','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:81:\"The profile used to collect shipping information on the checkout and order forms.\";}}','system',0,0,0,0,0,5,0,1,412,421,429,830,0,0,0,0,0),('management',831,819,'admin/structure/entity-type/commerce_store/delete','admin/structure/entity-type/commerce_store/delete','Delete','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:39:\"Delete the \'Commerce Store\' Entity Type\";}}','system',-1,0,0,0,3,5,0,1,21,806,819,831,0,0,0,0,0),('management',832,820,'admin/commerce/config/commerce_store_order/edit','admin/commerce/config/commerce_store_order/edit','Edit','a:0:{}','system',-1,0,0,0,0,5,0,1,412,413,820,832,0,0,0,0,0),('navigation',833,427,'user/%/orders/%/edit','user/%/orders/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,4,0,17,424,427,833,0,0,0,0,0,0),('management',834,819,'admin/structure/entity-type/commerce_store/edit','admin/structure/entity-type/commerce_store/edit','Edit','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"Edit the \'Commerce Store\' entity type\";}}','system',-1,0,0,0,2,5,0,1,21,806,819,834,0,0,0,0,0),('management',837,819,'admin/structure/entity-type/commerce_store/properties','admin/structure/entity-type/commerce_store/properties','Manage properties','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:55:\"Manage the properties of the Commerce Store entity type\";}}','system',-1,0,0,0,4,5,0,1,21,806,819,837,0,0,0,0,0),('management',838,434,'admin/commerce/config/line-items/shipping','admin/commerce/config/line-items/shipping','Shipping','a:0:{}','system',0,0,0,0,0,5,0,1,412,413,434,838,0,0,0,0,0),('management',839,439,'admin/commerce/customer-profiles/types/shipping','admin/commerce/customer-profiles/types/shipping','Shipping information','a:0:{}','system',0,0,0,0,0,5,0,1,412,421,439,839,0,0,0,0,0),('management',840,819,'admin/structure/entity-type/commerce_store/store','admin/structure/entity-type/commerce_store/store','Store','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:57:\"View all entites of type Commerce Store with bundle Store\";}}','system',0,0,1,0,0,5,0,1,21,806,819,840,0,0,0,0,0),('navigation',841,822,'commerce_store/store/%/sales/%/edit','commerce_store/store/%/sales/%/edit','','a:0:{}','system',0,0,0,0,0,4,0,809,815,822,841,0,0,0,0,0,0),('navigation',842,826,'commerce_store/store/%/people/roles/add','commerce_store/store/%/people/roles/add','Add new role','a:0:{}','system',-1,0,0,0,0,4,0,809,814,826,842,0,0,0,0,0,0),('management',846,840,'admin/structure/entity-type/commerce_store/store/delete','admin/structure/entity-type/commerce_store/store/delete','Delete','a:0:{}','system',-1,0,0,0,0,6,0,1,21,806,819,840,846,0,0,0,0),('management',847,840,'admin/structure/entity-type/commerce_store/store/edit','admin/structure/entity-type/commerce_store/store/edit','Edit','a:0:{}','system',-1,0,0,0,0,6,0,1,21,806,819,840,847,0,0,0,0),('management',848,840,'admin/structure/entity-type/commerce_store/store/list','admin/structure/entity-type/commerce_store/store/list','Entity List','a:0:{}','system',-1,0,0,0,100,6,0,1,21,806,819,840,848,0,0,0,0),('management',849,839,'admin/commerce/customer-profiles/types/shipping/display','admin/commerce/customer-profiles/types/shipping/display','Manage display','a:0:{}','system',-1,0,0,0,2,6,0,1,412,421,439,839,849,0,0,0,0),('management',850,838,'admin/commerce/config/line-items/shipping/display','admin/commerce/config/line-items/shipping/display','Manage display','a:0:{}','system',-1,0,0,0,2,6,0,1,412,413,434,838,850,0,0,0,0),('management',852,839,'admin/commerce/customer-profiles/types/shipping/fields','admin/commerce/customer-profiles/types/shipping/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,6,0,1,412,421,439,839,852,0,0,0,0),('management',853,838,'admin/commerce/config/line-items/shipping/fields','admin/commerce/config/line-items/shipping/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,6,0,1,412,413,434,838,853,0,0,0,0),('management',856,840,'admin/structure/entity-type/commerce_store/store/add','admin/structure/entity-type/commerce_store/store/add','Add Store','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:54:\"Add an entity of type Commerce Store with bundle Store\";}}','system',0,0,0,0,0,6,0,1,21,806,819,840,856,0,0,0,0),('navigation',858,826,'commerce_store/store/%/people/roles/%/edit','commerce_store/store/%/people/roles/%/edit','Edit role','a:0:{}','system',0,0,0,0,0,4,0,809,814,826,858,0,0,0,0,0,0),('management',871,840,'admin/structure/entity-type/commerce_store/store/%/delete','admin/structure/entity-type/commerce_store/store/%/delete','Delete Store','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:57:\"Delete an entity of type Commerce Store with bundle Store\";}}','system',0,0,0,0,0,6,0,1,21,806,819,840,871,0,0,0,0),('management',872,840,'admin/structure/entity-type/commerce_store/store/%/edit','admin/structure/entity-type/commerce_store/store/%/edit','Edit Store','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:55:\"Edit an entity of type Commerce Store with bundle Store\";}}','system',0,0,0,0,0,6,0,1,21,806,819,840,872,0,0,0,0),('management',890,12,'admin/help/search_api','admin/help/search_api','search_api','a:0:{}','system',-1,0,0,0,0,3,0,1,12,890,0,0,0,0,0,0,0),('management',891,53,'admin/config/search/search_api','admin/config/search/search_api','Search API','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:36:\"Create and configure search engines.\";}}','system',0,0,1,0,0,4,0,1,8,53,891,0,0,0,0,0,0),('management',892,891,'admin/config/search/search_api/add_index','admin/config/search/search_api/add_index','Add index','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:26:\"Create a new search index.\";}}','system',-1,0,0,0,0,5,0,1,8,53,891,892,0,0,0,0,0),('management',893,891,'admin/config/search/search_api/add_server','admin/config/search/search_api/add_server','Add server','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:27:\"Create a new search server.\";}}','system',-1,0,0,0,-1,5,0,1,8,53,891,893,0,0,0,0,0),('management',894,891,'admin/config/search/search_api/overview','admin/config/search/search_api/overview','Overview','a:0:{}','system',-1,0,0,0,-10,5,0,1,8,53,891,894,0,0,0,0,0),('management',895,891,'admin/config/search/search_api/index/%','admin/config/search/search_api/index/%','View index','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:19:\"View index details.\";}}','system',0,0,0,0,0,5,0,1,8,53,891,895,0,0,0,0,0),('management',896,891,'admin/config/search/search_api/server/%','admin/config/search/search_api/server/%','View server','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:20:\"View server details.\";}}','system',0,0,0,0,0,5,0,1,8,53,891,896,0,0,0,0,0),('management',897,895,'admin/config/search/search_api/index/%/delete','admin/config/search/search_api/index/%/delete','Delete','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:13:\"Delete index.\";}}','system',-1,0,0,0,10,6,0,1,8,53,891,895,897,0,0,0,0),('management',898,896,'admin/config/search/search_api/server/%/delete','admin/config/search/search_api/server/%/delete','Delete','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:14:\"Delete server.\";}}','system',-1,0,0,0,10,6,0,1,8,53,891,896,898,0,0,0,0),('management',899,895,'admin/config/search/search_api/index/%/disable','admin/config/search/search_api/index/%/disable','Disable','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:14:\"Disable index.\";}}','system',-1,0,0,0,8,6,0,1,8,53,891,895,899,0,0,0,0),('management',900,896,'admin/config/search/search_api/server/%/disable','admin/config/search/search_api/server/%/disable','Disable','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:14:\"Disable index.\";}}','system',-1,0,0,0,8,6,0,1,8,53,891,896,900,0,0,0,0),('management',901,895,'admin/config/search/search_api/index/%/edit','admin/config/search/search_api/index/%/edit','Edit','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:20:\"Edit index settings.\";}}','system',-1,0,0,0,-6,6,0,1,8,53,891,895,901,0,0,0,0),('management',902,896,'admin/config/search/search_api/server/%/edit','admin/config/search/search_api/server/%/edit','Edit','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:20:\"Edit server details.\";}}','system',-1,0,0,0,-1,6,0,1,8,53,891,896,902,0,0,0,0),('management',903,895,'admin/config/search/search_api/index/%/fields','admin/config/search/search_api/index/%/fields','Fields','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:22:\"Select indexed fields.\";}}','system',-1,0,0,0,-4,6,0,1,8,53,891,895,903,0,0,0,0),('management',904,895,'admin/config/search/search_api/index/%/workflow','admin/config/search/search_api/index/%/workflow','Filters','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:23:\"Edit indexing workflow.\";}}','system',-1,0,0,0,-2,6,0,1,8,53,891,895,904,0,0,0,0),('management',905,895,'admin/config/search/search_api/index/%/view','admin/config/search/search_api/index/%/view','View','a:0:{}','system',-1,0,0,0,-10,6,0,1,8,53,891,895,905,0,0,0,0),('management',906,896,'admin/config/search/search_api/server/%/view','admin/config/search/search_api/server/%/view','View','a:0:{}','system',-1,0,0,0,-10,6,0,1,8,53,891,896,906,0,0,0,0),('management',924,12,'admin/help/fivestar','admin/help/fivestar','fivestar','a:0:{}','system',-1,0,0,0,0,3,0,1,12,924,0,0,0,0,0,0,0),('management',925,35,'admin/config/content/fivestar','admin/config/content/fivestar','Fivestar','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:53:\"Configure site-wide widgets used for Fivestar rating.\";}}','system',0,0,0,0,0,4,0,1,8,35,925,0,0,0,0,0,0),('management',926,53,'admin/config/search/votingapi','admin/config/search/votingapi','Voting API','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:65:\"Configure sitewide settings for user-generated ratings and votes.\";}}','system',0,0,0,0,0,4,0,1,8,53,926,0,0,0,0,0,0),('navigation',927,0,'field-collection/field-specifications/%','field-collection/field-specifications/%','','a:0:{}','system',0,0,1,0,0,1,0,927,0,0,0,0,0,0,0,0,0),('navigation',928,927,'field-collection/field-specifications/%/delete','field-collection/field-specifications/%/delete','Delete','a:0:{}','system',-1,0,0,0,0,2,0,927,928,0,0,0,0,0,0,0,0),('navigation',929,927,'field-collection/field-specifications/%/edit','field-collection/field-specifications/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,2,0,927,929,0,0,0,0,0,0,0,0),('navigation',930,927,'field-collection/field-specifications/%/view','field-collection/field-specifications/%/view','View','a:0:{}','system',-1,0,0,0,-10,2,0,927,930,0,0,0,0,0,0,0,0),('navigation',932,0,'field-collection/field-specifications/add/%/%','field-collection/field-specifications/add/%/%','','a:0:{}','system',0,0,0,0,0,1,0,932,0,0,0,0,0,0,0,0,0),('navigation',933,927,'field-collection/field-specifications/%/revisions/%','field-collection/field-specifications/%/revisions/%','','a:0:{}','system',0,0,0,0,0,2,0,927,933,0,0,0,0,0,0,0,0),('management',944,35,'admin/config/content/exclude_node_title','admin/config/content/exclude_node_title','Exclude Node Title','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:31:\"Exclude Node Title from display\";}}','system',0,0,0,0,0,4,0,1,8,35,944,0,0,0,0,0,0),('management',947,61,'admin/config/user-interface/chosen','admin/config/user-interface/chosen','Chosen','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:31:\"Configuration for Chosen plugin\";}}','system',0,0,0,0,0,4,0,1,8,61,947,0,0,0,0,0,0),('management',948,56,'admin/config/system/recently-read','admin/config/system/recently-read','Recently Read Config','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:58:\"Tracks the history of recently read entities by each user.\";}}','system',0,0,0,0,0,4,0,1,8,56,948,0,0,0,0,0,0),('management',949,39,'admin/config/development/session-api','admin/config/development/session-api','Session API Configuration','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:31:\"Configure Session API behavior.\";}}','system',0,0,0,0,0,4,0,1,8,39,949,0,0,0,0,0,0),('navigation',952,0,'icons','icons','Icons','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:32:\"Overview of all available icons.\";}}','system',0,0,1,0,0,1,0,952,0,0,0,0,0,0,0,0,0),('navigation',953,952,'icons/%','icons/%','','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:15:\"An icon bundle.\";}}','system',0,0,0,0,0,2,0,952,953,0,0,0,0,0,0,0,0),('management',954,46,'admin/config/media/icon','admin/config/media/icon','Icons','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:32:\"Overview of all available icons.\";}}','system',0,0,1,0,0,4,0,1,8,46,954,0,0,0,0,0,0),('management',955,954,'admin/config/media/icon/overview','admin/config/media/icon/overview','Bundles','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:39:\"Overview of all available icon bundles.\";}}','system',-1,0,0,0,-10,5,0,1,8,46,954,955,0,0,0,0,0),('management',956,954,'admin/config/media/icon/bundle/%','admin/config/media/icon/bundle/%','','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:15:\"An icon bundle.\";}}','system',0,0,0,0,0,5,0,1,8,46,954,956,0,0,0,0,0),('management',957,956,'admin/config/media/icon/bundle/%/configure','admin/config/media/icon/bundle/%/configure','Configure','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Form callback for configuring an icon bundle.\";}}','system',-1,0,0,0,0,6,0,1,8,46,954,956,957,0,0,0,0),('management',958,956,'admin/config/media/icon/bundle/%/icons','admin/config/media/icon/bundle/%/icons','Icons','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:50:\"Provide an overview of all available icon bundles.\";}}','system',-1,0,0,0,-10,6,0,1,8,46,954,956,958,0,0,0,0),('navigation',960,0,'menutoken/%','menutoken/%','Dummy Menu Token item','a:0:{}','system',0,0,0,0,0,1,0,960,0,0,0,0,0,0,0,0,0),('management',961,8,'admin/config/menu_token','admin/config/menu_token','Menu Token','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:32:\"Configure the Menu Token module.\";}}','system',0,0,0,0,0,3,0,1,8,961,0,0,0,0,0,0,0),('user-menu',964,0,'menutoken/5475427e3dd3f','menutoken/%','Check orders status','a:5:{s:20:\"menu_token_link_path\";s:30:\"user/[current-user:uid]/orders\";s:15:\"menu_token_data\";a:0:{}s:18:\"menu_token_options\";a:1:{s:5:\"clear\";i:0;}s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}s:5:\"alter\";b:1;}','menu',0,0,0,0,-49,1,1,964,0,0,0,0,0,0,0,0,0),('management',965,12,'admin/help/search_api_sorts','admin/help/search_api_sorts','search_api_sorts','a:0:{}','system',-1,0,0,0,0,3,0,1,12,965,0,0,0,0,0,0,0),('management',967,895,'admin/config/search/search_api/index/%/facets','admin/config/search/search_api/index/%/facets','Facets','a:0:{}','system',-1,0,0,0,-1,6,0,1,8,53,891,895,967,0,0,0,0),('management',968,895,'admin/config/search/search_api/index/%/sorts','admin/config/search/search_api/index/%/sorts','Sorts','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"Select the sort fields to display.\";}}','system',-1,0,0,0,-1,6,0,1,8,53,891,895,968,0,0,0,0),('management',969,967,'admin/config/search/search_api/index/%/facets/block','admin/config/search/search_api/index/%/facets/block','Blocks','a:0:{}','system',-1,0,0,0,-10,7,0,1,8,53,891,895,967,969,0,0,0),('management',970,53,'admin/config/search/facetapi/%/%/%/dependencies','admin/config/search/facetapi/%/%/%/dependencies','Configure facet dependencies','a:0:{}','system',-1,0,0,0,-10,4,0,1,8,53,970,0,0,0,0,0,0),('management',971,53,'admin/config/search/facetapi/%/%/%/edit','admin/config/search/facetapi/%/%/%/edit','Configure facet display','a:0:{}','system',-1,0,0,0,-15,4,0,1,8,53,971,0,0,0,0,0,0),('management',972,53,'admin/config/search/facetapi/%/%/%/filters','admin/config/search/facetapi/%/%/%/filters','Configure facet filters','a:0:{}','system',-1,0,0,0,-5,4,0,1,8,53,972,0,0,0,0,0,0),('management',973,53,'admin/config/search/facetapi/%/%/%/export','admin/config/search/facetapi/%/%/%/export','Export facet configuration','a:0:{}','system',0,0,0,0,0,4,0,1,8,53,973,0,0,0,0,0,0),('management',974,53,'admin/config/search/facetapi/%/%/%/revert','admin/config/search/facetapi/%/%/%/revert','Revert facet configuration','a:0:{}','system',0,0,0,0,0,4,0,1,8,53,974,0,0,0,0,0,0),('management',975,413,'admin/commerce/config/commerce_search_api','admin/commerce/config/commerce_search_api','Commerce Search API','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:46:\"Configure the generated product display index.\";}}','system',0,0,0,0,0,4,0,1,412,413,975,0,0,0,0,0,0),('menu-customer-help',976,0,'node/28','node/%','Contact us','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,0,1,1,976,0,0,0,0,0,0,0,0,0),('management',977,51,'admin/config/regional/countries','admin/config/regional/countries','Countries','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:29:\"List, edit, or add countries.\";}}','system',0,0,0,0,0,4,0,1,8,51,977,0,0,0,0,0,0),('management',978,977,'admin/config/regional/countries/%','admin/config/regional/countries/%','','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:15:\"Edit a country.\";}}','system',-1,0,0,0,0,5,0,1,8,51,977,978,0,0,0,0,0),('management',979,977,'admin/config/regional/countries/add','admin/config/regional/countries/add','Add country','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:28:\"Admin page to add a country.\";}}','system',-1,0,0,0,1,5,0,1,8,51,977,979,0,0,0,0,0),('management',980,977,'admin/config/regional/countries/list','admin/config/regional/countries/list','List','a:0:{}','system',-1,0,0,0,0,5,0,1,8,51,977,980,0,0,0,0,0),('management',983,977,'admin/config/regional/countries/import','admin/config/regional/countries/import','Update countries','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:44:\"Bulk import countries from the ISO standard.\";}}','system',-1,0,0,0,2,5,0,1,8,51,977,983,0,0,0,0,0),('management',986,978,'admin/config/regional/countries/%/delete','admin/config/regional/countries/%/delete','Delete country','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"Country delete confirmation form.\";}}','system',-1,0,0,0,0,6,0,1,8,51,977,978,986,0,0,0,0),('management',987,978,'admin/config/regional/countries/%/edit','admin/config/regional/countries/%/edit','Edit','a:0:{}','system',-1,0,0,0,-10,6,0,1,8,51,977,978,987,0,0,0,0),('management',994,21,'admin/structure/features','admin/structure/features','Features','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:16:\"Manage features.\";}}','system',0,0,0,0,0,3,0,1,21,994,0,0,0,0,0,0,0),('management',995,12,'admin/help/commerce_payment_ui','admin/help/commerce_payment_ui','commerce_payment_ui','a:0:{}','system',-1,0,0,0,0,3,0,1,12,995,0,0,0,0,0,0,0),('management',996,12,'admin/help/features','admin/help/features','features','a:0:{}','system',-1,0,0,0,0,3,0,1,12,996,0,0,0,0,0,0,0),('management',997,994,'admin/structure/features/create','admin/structure/features/create','Create feature','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:21:\"Create a new feature.\";}}','system',-1,0,0,0,10,4,0,1,21,994,997,0,0,0,0,0,0),('management',998,413,'admin/commerce/config/custom-offline-payments','admin/commerce/config/custom-offline-payments','Custom Offline Payments','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"Manage custom offline payment methods\";}}','system',0,0,1,0,3,4,0,1,412,413,998,0,0,0,0,0,0),('management',999,994,'admin/structure/features/manage','admin/structure/features/manage','Manage','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:28:\"Enable and disable features.\";}}','system',-1,0,0,0,0,4,0,1,21,994,999,0,0,0,0,0,0),('management',1000,413,'admin/commerce/config/payment-methods','admin/commerce/config/payment-methods','Payment methods','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:56:\"Enable and configure payment method rule configurations.\";}}','system',0,0,1,0,0,4,0,1,412,413,1000,0,0,0,0,0,0),('management',1001,994,'admin/structure/features/settings','admin/structure/features/settings','Settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:42:\"Adjust settings for using features module.\";}}','system',-1,0,0,0,11,4,0,1,21,994,1001,0,0,0,0,0,0),('management',1002,1000,'admin/commerce/config/payment-methods/add','admin/commerce/config/payment-methods/add','Add a payment method rule','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:53:\"Adds an additional payment method rule configuration.\";}}','system',0,0,0,0,0,5,0,1,412,413,1000,1002,0,0,0,0,0),('management',1003,998,'admin/commerce/config/custom-offline-payments/add','admin/commerce/config/custom-offline-payments/add','Add payment method','a:0:{}','system',-1,0,0,0,0,5,0,1,412,413,998,1003,0,0,0,0,0),('management',1004,998,'admin/commerce/config/custom-offline-payments/%','admin/commerce/config/custom-offline-payments/%','Edit payment method','a:0:{}','system',0,0,0,0,0,5,0,1,412,413,998,1004,0,0,0,0,0),('management',1005,426,'admin/commerce/orders/%/payment','admin/commerce/orders/%/payment','Payment','a:0:{}','system',-1,0,1,0,10,5,0,1,412,422,426,1005,0,0,0,0,0),('management',1006,994,'admin/structure/features/%/view','admin/structure/features/%/view','View','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:32:\"Display components of a feature.\";}}','system',-1,0,0,0,-10,4,0,1,21,994,1006,0,0,0,0,0,0),('management',1007,994,'admin/structure/features/%/recreate','admin/structure/features/%/recreate','Recreate','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:29:\"Recreate an existing feature.\";}}','system',-1,0,0,0,11,4,0,1,21,994,1007,0,0,0,0,0,0),('management',1008,1005,'admin/commerce/orders/%/payment/%','admin/commerce/orders/%/payment/%','','a:0:{}','system',0,0,0,0,0,6,0,1,412,422,426,1005,1008,0,0,0,0),('management',1009,1000,'admin/commerce/config/payment-methods/manage/%','admin/commerce/config/payment-methods/manage/%','','a:0:{}','system',-1,0,1,0,0,5,0,1,412,413,1000,1009,0,0,0,0,0),('management',1010,1004,'admin/commerce/config/custom-offline-payments/%/delete','admin/commerce/config/custom-offline-payments/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,6,0,1,412,413,998,1004,1010,0,0,0,0),('management',1011,1004,'admin/commerce/config/custom-offline-payments/%/edit','admin/commerce/config/custom-offline-payments/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,6,0,1,412,413,998,1004,1011,0,0,0,0),('management',1012,1009,'admin/commerce/config/payment-methods/manage/%/clone','admin/commerce/config/payment-methods/manage/%/clone','','a:0:{}','system',0,0,0,0,0,6,0,1,412,413,1000,1009,1012,0,0,0,0),('management',1013,1009,'admin/commerce/config/payment-methods/manage/%/execute','admin/commerce/config/payment-methods/manage/%/execute','','a:0:{}','system',0,0,0,0,0,6,0,1,412,413,1000,1009,1013,0,0,0,0),('management',1014,1009,'admin/commerce/config/payment-methods/manage/%/export','admin/commerce/config/payment-methods/manage/%/export','','a:0:{}','system',0,0,0,0,0,6,0,1,412,413,1000,1009,1014,0,0,0,0),('management',1015,1008,'admin/commerce/orders/%/payment/%/offline-payment-confirm','admin/commerce/orders/%/payment/%/offline-payment-confirm','Confirm payment','a:0:{}','system',-1,0,0,0,2,7,0,1,412,422,426,1005,1008,1015,0,0,0),('management',1016,1008,'admin/commerce/orders/%/payment/%/delete','admin/commerce/orders/%/payment/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,7,0,1,412,422,426,1005,1008,1016,0,0,0),('management',1017,1009,'admin/commerce/config/payment-methods/manage/%/%','admin/commerce/config/payment-methods/manage/%/%','','a:0:{}','system',0,0,0,0,0,6,0,1,412,413,1000,1009,1017,0,0,0,0),('management',1018,1008,'admin/commerce/orders/%/payment/%/view','admin/commerce/orders/%/payment/%/view','View','a:0:{}','system',-1,0,0,0,0,7,0,1,412,422,426,1005,1008,1018,0,0,0),('management',1019,1009,'admin/commerce/config/payment-methods/manage/%/delete/event','admin/commerce/config/payment-methods/manage/%/delete/event','Remove event','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"Remove an event from a reaction rule.\";}}','system',0,0,0,0,0,6,0,1,412,413,1000,1009,1019,0,0,0,0),('management',1020,1009,'admin/commerce/config/payment-methods/manage/%/add/event','admin/commerce/config/payment-methods/manage/%/add/event','','a:0:{}','system',0,0,0,0,0,6,0,1,412,413,1000,1009,1020,0,0,0,0),('management',1021,1009,'admin/commerce/config/payment-methods/manage/%/delete/%','admin/commerce/config/payment-methods/manage/%/delete/%','','a:0:{}','system',0,0,0,0,0,6,0,1,412,413,1000,1009,1021,0,0,0,0),('management',1022,1009,'admin/commerce/config/payment-methods/manage/%/edit/%','admin/commerce/config/payment-methods/manage/%/edit/%','','a:0:{}','system',0,0,0,0,0,6,0,1,412,413,1000,1009,1022,0,0,0,0),('management',1023,1009,'admin/commerce/config/payment-methods/manage/%/add/%','admin/commerce/config/payment-methods/manage/%/add/%','','a:0:{}','system',0,0,0,0,0,6,0,1,412,413,1000,1009,1023,0,0,0,0),('management',1024,413,'admin/commerce/config/stock','admin/commerce/config/stock','Stock management','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:27:\"Configure stock management.\";}}','system',0,0,0,0,0,4,0,1,412,413,1024,0,0,0,0,0,0),('management',1025,1024,'admin/commerce/config/stock/ss','admin/commerce/config/stock/ss','Simple Stock management','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:23:\"Configure Simple stock.\";}}','system',-1,0,0,0,0,5,0,1,412,413,1024,1025,0,0,0,0,0),('management',1026,1024,'admin/commerce/config/stock/control','admin/commerce/config/stock/control','Stock control','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:41:\"Manage and configure stock control rules.\";}}','system',-1,0,1,0,6,5,0,1,412,413,1024,1026,0,0,0,0,0),('management',1027,1024,'admin/commerce/config/stock/api','admin/commerce/config/stock/api','Stock management API','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:31:\"Configure stock management API.\";}}','system',-1,0,0,0,-10,5,0,1,412,413,1024,1027,0,0,0,0,0),('management',1028,1024,'admin/commerce/config/stock/validation','admin/commerce/config/stock/validation','Stock validation','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Manage and configure stock validation events.\";}}','system',-1,0,1,0,5,5,0,1,412,413,1024,1028,0,0,0,0,0),('management',1029,1028,'admin/commerce/config/stock/validation/add_cart_action','admin/commerce/config/stock/validation/add_cart_action','Add a Cart action rule','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:30:\"Act on the add to cart action.\";}}','system',0,0,0,0,0,6,0,1,412,413,1024,1028,1029,0,0,0,0),('management',1030,1028,'admin/commerce/config/stock/validation/add_cart_state','admin/commerce/config/stock/validation/add_cart_state','Add a Cart state rule','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:39:\"Disable or modify the add to cart form.\";}}','system',0,0,0,0,0,6,0,1,412,413,1024,1028,1030,0,0,0,0),('management',1031,1028,'admin/commerce/config/stock/validation/add_checkout','admin/commerce/config/stock/validation/add_checkout','Add a Validate cart / checkout rule','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:50:\"Validate products in the the cart before checkout.\";}}','system',0,0,0,0,0,6,0,1,412,413,1024,1028,1031,0,0,0,0),('management',1032,1026,'admin/commerce/config/stock/control/add','admin/commerce/config/stock/control/add','Create a stock control rule','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:28:\"Add a new stock control rule\";}}','system',0,0,0,0,0,6,0,1,412,413,1024,1026,1032,0,0,0,0),('management',1033,1026,'admin/commerce/config/stock/control/manage/%','admin/commerce/config/stock/control/manage/%','','a:0:{}','system',-1,0,1,0,0,6,0,1,412,413,1024,1026,1033,0,0,0,0),('management',1034,1028,'admin/commerce/config/stock/validation/manage/%','admin/commerce/config/stock/validation/manage/%','','a:0:{}','system',-1,0,1,0,0,6,0,1,412,413,1024,1028,1034,0,0,0,0),('management',1035,1033,'admin/commerce/config/stock/control/manage/%/clone','admin/commerce/config/stock/control/manage/%/clone','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,1024,1026,1033,1035,0,0,0),('management',1036,1034,'admin/commerce/config/stock/validation/manage/%/clone','admin/commerce/config/stock/validation/manage/%/clone','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,1024,1028,1034,1036,0,0,0),('management',1037,1033,'admin/commerce/config/stock/control/manage/%/execute','admin/commerce/config/stock/control/manage/%/execute','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,1024,1026,1033,1037,0,0,0),('management',1038,1034,'admin/commerce/config/stock/validation/manage/%/execute','admin/commerce/config/stock/validation/manage/%/execute','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,1024,1028,1034,1038,0,0,0),('management',1039,1033,'admin/commerce/config/stock/control/manage/%/export','admin/commerce/config/stock/control/manage/%/export','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,1024,1026,1033,1039,0,0,0),('management',1040,1034,'admin/commerce/config/stock/validation/manage/%/export','admin/commerce/config/stock/validation/manage/%/export','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,1024,1028,1034,1040,0,0,0),('management',1041,1033,'admin/commerce/config/stock/control/manage/%/%','admin/commerce/config/stock/control/manage/%/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,1024,1026,1033,1041,0,0,0),('management',1042,1034,'admin/commerce/config/stock/validation/manage/%/%','admin/commerce/config/stock/validation/manage/%/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,1024,1028,1034,1042,0,0,0),('management',1043,1033,'admin/commerce/config/stock/control/manage/%/delete/event','admin/commerce/config/stock/control/manage/%/delete/event','Remove event','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"Remove an event from a reaction rule.\";}}','system',0,0,0,0,0,7,0,1,412,413,1024,1026,1033,1043,0,0,0),('management',1044,1034,'admin/commerce/config/stock/validation/manage/%/delete/event','admin/commerce/config/stock/validation/manage/%/delete/event','Remove event','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"Remove an event from a reaction rule.\";}}','system',0,0,0,0,0,7,0,1,412,413,1024,1028,1034,1044,0,0,0),('management',1045,1033,'admin/commerce/config/stock/control/manage/%/add/event','admin/commerce/config/stock/control/manage/%/add/event','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,1024,1026,1033,1045,0,0,0),('management',1046,1034,'admin/commerce/config/stock/validation/manage/%/add/event','admin/commerce/config/stock/validation/manage/%/add/event','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,1024,1028,1034,1046,0,0,0),('management',1047,1033,'admin/commerce/config/stock/control/manage/%/delete/%','admin/commerce/config/stock/control/manage/%/delete/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,1024,1026,1033,1047,0,0,0),('management',1048,1034,'admin/commerce/config/stock/validation/manage/%/delete/%','admin/commerce/config/stock/validation/manage/%/delete/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,1024,1028,1034,1048,0,0,0),('management',1049,1033,'admin/commerce/config/stock/control/manage/%/edit/%','admin/commerce/config/stock/control/manage/%/edit/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,1024,1026,1033,1049,0,0,0),('management',1050,1034,'admin/commerce/config/stock/validation/manage/%/edit/%','admin/commerce/config/stock/validation/manage/%/edit/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,1024,1028,1034,1050,0,0,0),('management',1051,1033,'admin/commerce/config/stock/control/manage/%/add/%','admin/commerce/config/stock/control/manage/%/add/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,1024,1026,1033,1051,0,0,0),('management',1052,1034,'admin/commerce/config/stock/validation/manage/%/add/%','admin/commerce/config/stock/validation/manage/%/add/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,1024,1028,1034,1052,0,0,0),('management',1055,47,'admin/structure/menu/manage/menu-help-menu','admin/structure/menu/manage/%','Help Topics','a:0:{}','menu',0,0,0,0,0,4,0,1,21,47,1055,0,0,0,0,0,0),('menu-help-menu',1056,0,'user','user','View Account','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,-50,1,1,1056,0,0,0,0,0,0,0,0,0),('menu-help-menu',1057,0,'node/16','node/%','Payment & Pricing','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,-47,1,1,1057,0,0,0,0,0,0,0,0,0),('menu-help-menu',1058,0,'node/17','node/%','How to buy','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,-49,1,1,1058,0,0,0,0,0,0,0,0,0),('menu-help-menu',1059,0,'node/18','node/%','Shipping & Pickup','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,-45,1,1,1059,0,0,0,0,0,0,0,0,0),('menu-help-menu',1060,0,'node/19','node/%','Returns & Refunds','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,-46,1,1,1060,0,0,0,0,0,0,0,0,0),('menu-help-menu',1061,0,'node/20','node/%','Order Status','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,-48,1,1,1061,0,0,0,0,0,0,0,0,0),('management',1062,47,'admin/structure/menu/manage/menu-headline-menu','admin/structure/menu/manage/%','Headline menu','a:0:{}','menu',0,0,0,0,0,4,0,1,21,47,1062,0,0,0,0,0,0),('menu-headline-menu',1063,0,'node/29','node/%','Get Help','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,-49,1,1,1063,0,0,0,0,0,0,0,0,0),('main-menu',1064,611,'taxonomy/term/17','taxonomy/term/%','Point & Shoot Cameras','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:21:\"Point & Shoot Cameras\";}}','taxonomy_menu',0,0,0,1,0,2,0,611,1064,0,0,0,0,0,0,0,0),('main-menu',1065,611,'taxonomy/term/18','taxonomy/term/%','DSLR/SLR Cameras','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:16:\"DSLR/SLR Cameras\";}}','taxonomy_menu',0,0,0,1,1,2,0,611,1065,0,0,0,0,0,0,0,0),('main-menu',1068,611,'taxonomy/term/21','taxonomy/term/%','Other Cameras','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:13:\"Other Cameras\";}}','taxonomy_menu',0,0,1,1,5,2,0,611,1068,0,0,0,0,0,0,0,0),('main-menu',1069,1068,'taxonomy/term/22','taxonomy/term/%','IP Cameras','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:10:\"IP Cameras\";}}','taxonomy_menu',0,0,0,1,0,3,0,611,1068,1069,0,0,0,0,0,0,0),('main-menu',1070,1068,'taxonomy/term/23','taxonomy/term/%','Car Cameras','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:11:\"Car Cameras\";}}','taxonomy_menu',0,0,0,1,1,3,0,611,1068,1070,0,0,0,0,0,0,0),('main-menu',1071,611,'taxonomy/term/24','taxonomy/term/%','Camera Accessories','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:18:\"Camera Accessories\";}}','taxonomy_menu',0,0,1,1,4,2,0,611,1071,0,0,0,0,0,0,0,0),('main-menu',1072,1071,'taxonomy/term/25','taxonomy/term/%','Lenses','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:6:\"Lenses\";}}','taxonomy_menu',0,0,0,1,1,3,0,611,1071,1072,0,0,0,0,0,0,0),('main-menu',1073,1071,'taxonomy/term/26','taxonomy/term/%','Filters','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:7:\"Filters\";}}','taxonomy_menu',0,0,0,1,0,3,0,611,1071,1073,0,0,0,0,0,0,0),('main-menu',1074,616,'taxonomy/term/27','taxonomy/term/%','Mobiles','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:7:\"Mobiles\";}}','taxonomy_menu',0,0,1,1,0,2,0,616,1074,0,0,0,0,0,0,0,0),('main-menu',1075,1074,'taxonomy/term/28','taxonomy/term/%','Smartphones','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:11:\"Smartphones\";}}','taxonomy_menu',0,0,0,1,0,3,0,616,1074,1075,0,0,0,0,0,0,0),('main-menu',1076,1074,'taxonomy/term/29','taxonomy/term/%','Basic Phones','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:12:\"Basic Phones\";}}','taxonomy_menu',0,0,0,1,1,3,0,616,1074,1076,0,0,0,0,0,0,0),('main-menu',1077,616,'taxonomy/term/30','taxonomy/term/%','Tablets','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:7:\"Tablets\";}}','taxonomy_menu',0,0,1,1,1,2,0,616,1077,0,0,0,0,0,0,0,0),('main-menu',1078,1077,'taxonomy/term/31','taxonomy/term/%','With call facility','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:18:\"With call facility\";}}','taxonomy_menu',0,0,0,1,0,3,0,616,1077,1078,0,0,0,0,0,0,0),('main-menu',1079,1077,'taxonomy/term/32','taxonomy/term/%','Without call facility','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:21:\"Without call facility\";}}','taxonomy_menu',0,0,0,1,1,3,0,616,1077,1079,0,0,0,0,0,0,0),('main-menu',1080,616,'taxonomy/term/33','taxonomy/term/%','Mobile Accessories','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:18:\"Mobile Accessories\";}}','taxonomy_menu',0,0,1,1,2,2,0,616,1080,0,0,0,0,0,0,0,0),('main-menu',1081,1080,'taxonomy/term/34','taxonomy/term/%','Cases & Covers','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:14:\"Cases & Covers\";}}','taxonomy_menu',0,0,0,1,0,3,0,616,1080,1081,0,0,0,0,0,0,0),('main-menu',1082,1080,'taxonomy/term/35','taxonomy/term/%','Car Accessories','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:15:\"Car Accessories\";}}','taxonomy_menu',0,0,0,1,1,3,0,616,1080,1082,0,0,0,0,0,0,0),('main-menu',1083,616,'taxonomy/term/36','taxonomy/term/%','Tablet Accessories','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:18:\"Tablet Accessories\";}}','taxonomy_menu',0,0,1,1,3,2,0,616,1083,0,0,0,0,0,0,0,0),('main-menu',1085,1083,'taxonomy/term/38','taxonomy/term/%','Batteries & Chargers','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:20:\"Batteries & Chargers\";}}','taxonomy_menu',0,0,0,1,1,3,0,616,1083,1085,0,0,0,0,0,0,0),('main-menu',1086,1083,'taxonomy/term/39','taxonomy/term/%','Headphones','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:10:\"Headphones\";}}','taxonomy_menu',0,0,0,1,0,3,0,616,1083,1086,0,0,0,0,0,0,0),('main-menu',1087,613,'taxonomy/term/40','taxonomy/term/%','Laptops','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:7:\"Laptops\";}}','taxonomy_menu',0,0,0,1,0,2,0,613,1087,0,0,0,0,0,0,0,0),('main-menu',1088,613,'taxonomy/term/41','taxonomy/term/%','Desktops','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:8:\"Desktops\";}}','taxonomy_menu',0,0,0,1,1,2,0,613,1088,0,0,0,0,0,0,0,0),('main-menu',1089,613,'taxonomy/term/42','taxonomy/term/%','Scanners','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:8:\"Scanners\";}}','taxonomy_menu',0,0,0,1,3,2,0,613,1089,0,0,0,0,0,0,0,0),('main-menu',1090,613,'taxonomy/term/43','taxonomy/term/%','Network Components','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:18:\"Network Components\";}}','taxonomy_menu',0,0,1,1,2,2,0,613,1090,0,0,0,0,0,0,0,0),('main-menu',1091,1090,'taxonomy/term/44','taxonomy/term/%','Switches','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:8:\"Switches\";}}','taxonomy_menu',0,0,0,1,0,3,0,613,1090,1091,0,0,0,0,0,0,0),('main-menu',1092,1090,'taxonomy/term/45','taxonomy/term/%','Routers','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:7:\"Routers\";}}','taxonomy_menu',0,0,0,1,1,3,0,613,1090,1092,0,0,0,0,0,0,0),('main-menu',1094,618,'taxonomy/term/47','taxonomy/term/%','Women\'s Accessories','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:19:\"Women\'s Accessories\";}}','taxonomy_menu',0,0,1,1,1,2,0,618,1094,0,0,0,0,0,0,0,0),('main-menu',1095,1094,'taxonomy/term/48','taxonomy/term/%','Belts','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:5:\"Belts\";}}','taxonomy_menu',0,0,0,1,0,3,0,618,1094,1095,0,0,0,0,0,0,0),('main-menu',1096,1094,'taxonomy/term/49','taxonomy/term/%','Scarves','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:7:\"Scarves\";}}','taxonomy_menu',0,0,0,1,1,3,0,618,1094,1096,0,0,0,0,0,0,0),('main-menu',1097,618,'taxonomy/term/50','taxonomy/term/%','Men\'s Watches','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:13:\"Men\'s Watches\";}}','taxonomy_menu',0,0,1,1,2,2,0,618,1097,0,0,0,0,0,0,0,0),('main-menu',1098,1097,'taxonomy/term/51','taxonomy/term/%','Business','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:8:\"Business\";}}','taxonomy_menu',0,0,0,1,0,3,0,618,1097,1098,0,0,0,0,0,0,0),('main-menu',1099,1097,'taxonomy/term/52','taxonomy/term/%','Sports','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:6:\"Sports\";}}','taxonomy_menu',0,0,0,1,1,3,0,618,1097,1099,0,0,0,0,0,0,0),('main-menu',1100,618,'taxonomy/term/53','taxonomy/term/%','Women\'s Jewellery','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:17:\"Women\'s Jewellery\";}}','taxonomy_menu',0,0,0,1,0,2,0,618,1100,0,0,0,0,0,0,0,0),('main-menu',1101,617,'taxonomy/term/54','taxonomy/term/%','Babies','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:6:\"Babies\";}}','taxonomy_menu',0,0,1,1,2,2,0,617,1101,0,0,0,0,0,0,0,0),('main-menu',1102,617,'taxonomy/term/55','taxonomy/term/%','Toys','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:4:\"Toys\";}}','taxonomy_menu',0,0,1,1,0,2,0,617,1102,0,0,0,0,0,0,0,0),('main-menu',1103,617,'taxonomy/term/56','taxonomy/term/%','Kids','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:4:\"Kids\";}}','taxonomy_menu',0,0,1,1,1,2,0,617,1103,0,0,0,0,0,0,0,0),('main-menu',1104,1101,'taxonomy/term/57','taxonomy/term/%','Health & Safety','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:15:\"Health & Safety\";}}','taxonomy_menu',0,0,0,1,0,3,0,617,1101,1104,0,0,0,0,0,0,0),('main-menu',1105,1102,'taxonomy/term/58','taxonomy/term/%','Educational Toys','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:16:\"Educational Toys\";}}','taxonomy_menu',0,0,0,1,0,3,0,617,1102,1105,0,0,0,0,0,0,0),('main-menu',1106,1103,'taxonomy/term/59','taxonomy/term/%','Books & Stationery','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:18:\"Books & Stationery\";}}','taxonomy_menu',0,0,0,1,0,3,0,617,1103,1106,0,0,0,0,0,0,0),('main-menu',1107,614,'taxonomy/term/60','taxonomy/term/%','TV & Video','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:10:\"TV & Video\";}}','taxonomy_menu',0,0,1,1,0,2,0,614,1107,0,0,0,0,0,0,0,0),('main-menu',1108,1107,'taxonomy/term/61','taxonomy/term/%','Televisions','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:11:\"Televisions\";}}','taxonomy_menu',0,0,0,1,0,3,0,614,1107,1108,0,0,0,0,0,0,0),('main-menu',1109,614,'taxonomy/term/62','taxonomy/term/%','Audio','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:5:\"Audio\";}}','taxonomy_menu',0,0,1,1,1,2,0,614,1109,0,0,0,0,0,0,0,0),('main-menu',1110,1109,'taxonomy/term/63','taxonomy/term/%','Home Audio','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:10:\"Home Audio\";}}','taxonomy_menu',0,0,0,1,0,3,0,614,1109,1110,0,0,0,0,0,0,0),('main-menu',1111,614,'taxonomy/term/64','taxonomy/term/%','Gadgets','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:7:\"Gadgets\";}}','taxonomy_menu',0,0,0,1,2,2,0,614,1111,0,0,0,0,0,0,0,0),('main-menu',1112,612,'taxonomy/term/65','taxonomy/term/%','Bags & Backpacks','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:16:\"Bags & Backpacks\";}}','taxonomy_menu',0,0,1,1,0,2,0,612,1112,0,0,0,0,0,0,0,0),('main-menu',1113,1112,'taxonomy/term/66','taxonomy/term/%','Laptop Bags & Cases','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:19:\"Laptop Bags & Cases\";}}','taxonomy_menu',0,0,0,1,1,3,0,612,1112,1113,0,0,0,0,0,0,0),('main-menu',1114,612,'taxonomy/term/67','taxonomy/term/%','Shoe Bags','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:9:\"Shoe Bags\";}}','taxonomy_menu',0,0,0,1,1,2,0,612,1114,0,0,0,0,0,0,0,0),('main-menu',1115,615,'taxonomy/term/68','taxonomy/term/%','Makeup','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:6:\"Makeup\";}}','taxonomy_menu',0,0,0,1,0,2,0,615,1115,0,0,0,0,0,0,0,0),('main-menu',1116,615,'taxonomy/term/69','taxonomy/term/%','Face','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:4:\"Face\";}}','taxonomy_menu',0,0,1,1,1,2,0,615,1116,0,0,0,0,0,0,0,0),('main-menu',1117,1116,'taxonomy/term/70','taxonomy/term/%','Eye Care','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:8:\"Eye Care\";}}','taxonomy_menu',0,0,0,1,1,3,0,615,1116,1117,0,0,0,0,0,0,0),('main-menu',1118,1116,'taxonomy/term/71','taxonomy/term/%','Face Care','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:9:\"Face Care\";}}','taxonomy_menu',0,0,0,1,0,3,0,615,1116,1118,0,0,0,0,0,0,0),('main-menu',1119,615,'taxonomy/term/72','taxonomy/term/%','Health & Beauty Tools','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:21:\"Health & Beauty Tools\";}}','taxonomy_menu',0,0,0,1,2,2,0,615,1119,0,0,0,0,0,0,0,0),('main-menu',1120,615,'taxonomy/term/73','taxonomy/term/%','Food Supplements','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:16:\"Food Supplements\";}}','taxonomy_menu',0,0,0,1,3,2,0,615,1120,0,0,0,0,0,0,0,0),('main-menu',1121,1112,'taxonomy/term/77','taxonomy/term/%','Backpacks','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:9:\"Backpacks\";}}','taxonomy_menu',0,0,0,1,0,3,0,612,1112,1121,0,0,0,0,0,0,0),('management',1122,21,'admin/structure/custom_breadcrumbs','admin/structure/custom_breadcrumbs','Custom breadcrumbs','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:54:\"Customize the breadcrumb trail for pages on your site.\";}}','system',0,0,0,0,0,3,0,1,21,1122,0,0,0,0,0,0,0),('management',1123,12,'admin/help/custom_breadcrumbs','admin/help/custom_breadcrumbs','custom_breadcrumbs','a:0:{}','system',-1,0,0,0,0,3,0,1,12,1123,0,0,0,0,0,0,0),('management',1124,61,'admin/config/user-interface/custom-breadcrumbs','admin/config/user-interface/custom-breadcrumbs','Custom breadcrumbs settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:73:\"Manage sitewide configuration settings to customize the breadcrumb trail.\";}}','system',0,0,0,0,0,4,0,1,8,61,1124,0,0,0,0,0,0),('management',1125,1122,'admin/structure/custom_breadcrumbs/list','admin/structure/custom_breadcrumbs/list','List','a:0:{}','system',-1,0,0,0,0,4,0,1,21,1122,1125,0,0,0,0,0,0),('management',1126,1122,'admin/structure/custom_breadcrumbs/node/add','admin/structure/custom_breadcrumbs/node/add','Node','a:0:{}','system',-1,0,0,0,1,4,0,1,21,1122,1126,0,0,0,0,0,0),('management',1127,1122,'admin/structure/custom_breadcrumbs/path/add','admin/structure/custom_breadcrumbs/path/add','Path','a:0:{}','system',-1,0,0,0,5,4,0,1,21,1122,1127,0,0,0,0,0,0),('management',1130,12,'admin/help/custom_breadcrumbs_taxonomy','admin/help/custom_breadcrumbs_taxonomy','custom_breadcrumbs_taxonomy','a:0:{}','system',-1,0,0,0,0,3,0,1,12,1130,0,0,0,0,0,0,0),('management',1131,1122,'admin/structure/custom_breadcrumbs/taxonomy_term/add','admin/structure/custom_breadcrumbs/taxonomy_term/add','Term','a:0:{}','system',-1,0,0,0,5,4,0,1,21,1122,1131,0,0,0,0,0,0),('management',1132,1122,'admin/structure/custom_breadcrumbs/taxonomy_vocabulary/add','admin/structure/custom_breadcrumbs/taxonomy_vocabulary/add','Vocabulary','a:0:{}','system',-1,0,0,0,5,4,0,1,21,1122,1132,0,0,0,0,0,0),('management',1133,1122,'admin/structure/custom_breadcrumbs/views/add','admin/structure/custom_breadcrumbs/views/add','Views','a:0:{}','system',-1,0,0,0,5,4,0,1,21,1122,1133,0,0,0,0,0,0),('navigation',1135,0,'funds/transaction/%','funds/transaction/%','','a:0:{}','system',0,0,0,0,0,1,0,1135,0,0,0,0,0,0,0,0,0),('navigation',1136,17,'user/%/account','user/%/account','','a:0:{}','system',-1,0,0,0,2,2,0,17,1136,0,0,0,0,0,0,0,0),('management',1137,412,'admin/commerce/marketplace_funds','admin/commerce/marketplace_funds','Commerce Marketplace Funds','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Change Commerce Marketplace Funds settings.\";}}','system',0,0,1,0,0,3,0,1,412,1137,0,0,0,0,0,0,0),('navigation',1138,1135,'funds/transaction/%/edit','funds/transaction/%/edit','Edit','a:0:{}','system',-1,0,0,0,10,2,0,1135,1138,0,0,0,0,0,0,0,0),('navigation',1139,1135,'funds/transaction/%/view','funds/transaction/%/view','View','a:0:{}','system',-1,0,0,0,0,2,0,1135,1139,0,0,0,0,0,0,0,0),('navigation',1140,809,'commerce_store/store/%/account','commerce_store/store/%/account','','a:0:{}','system',-1,0,0,0,2,2,0,809,1140,0,0,0,0,0,0,0,0),('navigation',1141,1136,'user/%/account/view','user/%/account/view','Account','a:0:{}','system',-1,0,0,0,-1,3,0,17,1136,1141,0,0,0,0,0,0,0),('navigation',1142,1136,'user/%/account/transaction','user/%/account/transaction','Account Transactions','a:0:{}','system',-1,0,0,0,1,3,0,17,1136,1142,0,0,0,0,0,0,0),('management',1143,1137,'admin/commerce/marketplace_funds/account','admin/commerce/marketplace_funds/account','Administer Marketplace funds account entity types','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:31:\"Change funds accounts settings.\";}}','system',0,0,1,0,0,4,0,1,412,1137,1143,0,0,0,0,0,0),('management',1144,1137,'admin/commerce/marketplace_funds/transaction','admin/commerce/marketplace_funds/transaction','Administer Marketplace funds transaction entity types','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:35:\"Change funds transactions settings.\";}}','system',0,0,1,0,0,4,0,1,412,1137,1144,0,0,0,0,0,0),('management',1145,1137,'admin/commerce/marketplace_funds/processor','admin/commerce/marketplace_funds/processor','Commerce Marketplace Funds Processor','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:44:\"Change Commerce Marketplace Funds Processor.\";}}','system',0,0,0,0,0,4,0,1,412,1137,1145,0,0,0,0,0,0),('navigation',1146,1136,'user/%/account/withdraw','user/%/account/withdraw','Configure withdraw methods','a:0:{}','system',-1,0,1,0,0,3,0,17,1136,1146,0,0,0,0,0,0,0),('management',1147,1137,'admin/commerce/marketplace_funds/withdraw','admin/commerce/marketplace_funds/withdraw','Withdraw method types','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:106:\"Manage withdraw method entity types, including adding\n      and removing fields and the display of fields.\";}}','system',0,0,1,0,0,4,0,1,412,1137,1147,0,0,0,0,0,0),('navigation',1148,1146,'user/%/account/withdraw/%','user/%/account/withdraw/%','','a:0:{}','system',0,0,0,0,0,4,0,17,1136,1146,1148,0,0,0,0,0,0),('management',1149,1147,'admin/commerce/marketplace_funds/withdraw/add','admin/commerce/marketplace_funds/withdraw/add','','a:0:{}','system',-1,0,0,0,0,5,0,1,412,1137,1147,1149,0,0,0,0,0),('management',1150,1147,'admin/commerce/marketplace_funds/withdraw/import','admin/commerce/marketplace_funds/withdraw/import','','a:0:{}','system',-1,0,0,0,0,5,0,1,412,1137,1147,1150,0,0,0,0,0),('navigation',1151,1140,'commerce_store/store/%/account/view','commerce_store/store/%/account/view','Account','a:0:{}','system',-1,0,0,0,-1,3,0,809,1140,1151,0,0,0,0,0,0,0),('navigation',1152,1140,'commerce_store/store/%/account/transaction','commerce_store/store/%/account/transaction','Account Transactions','a:0:{}','system',-1,0,0,0,1,3,0,809,1140,1152,0,0,0,0,0,0,0),('navigation',1153,1140,'commerce_store/store/%/account/withdraw','commerce_store/store/%/account/withdraw','Configure withdraw methods','a:0:{}','system',-1,0,1,0,0,3,0,809,1140,1153,0,0,0,0,0,0,0),('management',1154,430,'admin/commerce/products/add/deposit','admin/commerce/products/add/deposit','Create !name','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:32:\"Stores a Funds Deposit Operation\";}}','system',0,0,0,0,0,5,0,1,412,423,430,1154,0,0,0,0,0),('management',1155,438,'admin/commerce/products/types/deposit','admin/commerce/products/types/deposit','Funds Deposit','a:0:{}','system',0,0,0,0,0,5,0,1,412,423,438,1155,0,0,0,0,0),('management',1156,1147,'admin/commerce/marketplace_funds/withdraw/list','admin/commerce/marketplace_funds/withdraw/list','List','a:0:{}','system',-1,0,0,0,-10,5,0,1,412,1137,1147,1156,0,0,0,0,0),('navigation',1157,1153,'commerce_store/store/%/account/withdraw/%','commerce_store/store/%/account/withdraw/%','','a:0:{}','system',0,0,0,0,0,4,0,809,1140,1153,1157,0,0,0,0,0,0),('management',1158,1143,'admin/commerce/marketplace_funds/account/commerce_store/manage','admin/commerce/marketplace_funds/account/commerce_store/manage','Administer Marketplace Store Funds Account entity type','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:31:\"Configure Store funds accounts.\";}}','system',0,0,0,0,0,5,0,1,412,1137,1143,1158,0,0,0,0,0),('management',1159,1143,'admin/commerce/marketplace_funds/account/user/manage','admin/commerce/marketplace_funds/account/user/manage','Administer Marketplace User Funds Account entity type','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:30:\"Configure User funds accounts.\";}}','system',0,0,0,0,0,5,0,1,412,1137,1143,1159,0,0,0,0,0),('management',1160,1144,'admin/commerce/marketplace_funds/transaction/deposit/manage','admin/commerce/marketplace_funds/transaction/deposit/manage','Administer marketplace funds Deposit transaction entity type','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Configure Deposit transaction transactions.\";}}','system',0,0,0,0,0,5,0,1,412,1137,1144,1160,0,0,0,0,0),('management',1161,1144,'admin/commerce/marketplace_funds/transaction/transfer/manage','admin/commerce/marketplace_funds/transaction/transfer/manage','Administer marketplace funds Funds transfer transaction entity type','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:50:\"Configure Funds transfer transaction transactions.\";}}','system',0,0,0,0,0,5,0,1,412,1137,1144,1161,0,0,0,0,0),('management',1162,1144,'admin/commerce/marketplace_funds/transaction/payment/manage','admin/commerce/marketplace_funds/transaction/payment/manage','Administer marketplace funds Payment transaction entity type','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Configure Payment transaction transactions.\";}}','system',0,0,0,0,0,5,0,1,412,1137,1144,1162,0,0,0,0,0),('management',1163,1144,'admin/commerce/marketplace_funds/transaction/withdraw/manage','admin/commerce/marketplace_funds/transaction/withdraw/manage','Administer marketplace funds Withdraw transaction entity type','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:44:\"Configure Withdraw transaction transactions.\";}}','system',0,0,0,0,0,5,0,1,412,1137,1144,1163,0,0,0,0,0),('navigation',1164,1142,'user/%/account/transaction/new/withdraw','user/%/account/transaction/new/withdraw','Create withdraw request','a:0:{}','system',-1,0,0,0,1,4,0,17,1136,1142,1164,0,0,0,0,0,0),('navigation',1165,1142,'user/%/account/transaction/new/deposit','user/%/account/transaction/new/deposit','Make a Deposit transaction','a:0:{}','system',-1,0,0,0,0,4,0,17,1136,1142,1165,0,0,0,0,0,0),('navigation',1166,1142,'user/%/account/transaction/new/transfer','user/%/account/transaction/new/transfer','Make a Funds transfer transaction','a:0:{}','system',-1,0,0,0,0,4,0,17,1136,1142,1166,0,0,0,0,0,0),('management',1167,1155,'admin/commerce/products/types/deposit/display','admin/commerce/products/types/deposit/display','Manage display','a:0:{}','system',-1,0,0,0,2,6,0,1,412,423,438,1155,1167,0,0,0,0),('management',1168,1155,'admin/commerce/products/types/deposit/fields','admin/commerce/products/types/deposit/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,6,0,1,412,423,438,1155,1168,0,0,0,0),('management',1169,1147,'admin/commerce/marketplace_funds/withdraw/manage/%','admin/commerce/marketplace_funds/withdraw/manage/%','Edit','a:0:{}','system',0,0,1,0,0,5,0,1,412,1137,1147,1169,0,0,0,0,0),('navigation',1173,1152,'commerce_store/store/%/account/transaction/new/withdraw','commerce_store/store/%/account/transaction/new/withdraw','Create withdraw request','a:0:{}','system',-1,0,0,0,1,4,0,809,1140,1152,1173,0,0,0,0,0,0),('management',1176,1158,'admin/commerce/marketplace_funds/account/commerce_store/manage/list','admin/commerce/marketplace_funds/account/commerce_store/manage/list','List','a:0:{}','system',-1,0,0,0,0,6,0,1,412,1137,1143,1158,1176,0,0,0,0),('management',1177,1159,'admin/commerce/marketplace_funds/account/user/manage/list','admin/commerce/marketplace_funds/account/user/manage/list','List','a:0:{}','system',-1,0,0,0,0,6,0,1,412,1137,1143,1159,1177,0,0,0,0),('management',1178,1160,'admin/commerce/marketplace_funds/transaction/deposit/manage/list','admin/commerce/marketplace_funds/transaction/deposit/manage/list','List','a:0:{}','system',-1,0,0,0,0,6,0,1,412,1137,1144,1160,1178,0,0,0,0),('management',1179,1162,'admin/commerce/marketplace_funds/transaction/payment/manage/list','admin/commerce/marketplace_funds/transaction/payment/manage/list','List','a:0:{}','system',-1,0,0,0,0,6,0,1,412,1137,1144,1162,1179,0,0,0,0),('management',1180,1161,'admin/commerce/marketplace_funds/transaction/transfer/manage/list','admin/commerce/marketplace_funds/transaction/transfer/manage/list','List','a:0:{}','system',-1,0,0,0,0,6,0,1,412,1137,1144,1161,1180,0,0,0,0),('management',1181,1163,'admin/commerce/marketplace_funds/transaction/withdraw/manage/list','admin/commerce/marketplace_funds/transaction/withdraw/manage/list','List','a:0:{}','system',-1,0,0,0,0,6,0,1,412,1137,1144,1163,1181,0,0,0,0),('navigation',1182,1152,'commerce_store/store/%/account/transaction/new/deposit','commerce_store/store/%/account/transaction/new/deposit','Make a Deposit transaction','a:0:{}','system',-1,0,0,0,0,4,0,809,1140,1152,1182,0,0,0,0,0,0),('navigation',1183,1152,'commerce_store/store/%/account/transaction/new/transfer','commerce_store/store/%/account/transaction/new/transfer','Make a Funds transfer transaction','a:0:{}','system',-1,0,0,0,0,4,0,809,1140,1152,1183,0,0,0,0,0,0),('management',1206,1169,'admin/commerce/marketplace_funds/withdraw/manage/%/%','admin/commerce/marketplace_funds/withdraw/manage/%/%','','a:0:{}','system',0,0,0,0,0,6,0,1,412,1137,1147,1169,1206,0,0,0,0),('management',1207,1169,'admin/commerce/marketplace_funds/withdraw/manage/%/edit','admin/commerce/marketplace_funds/withdraw/manage/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,6,0,1,412,1137,1147,1169,1207,0,0,0,0),('management',1208,1169,'admin/commerce/marketplace_funds/withdraw/manage/%/clone','admin/commerce/marketplace_funds/withdraw/manage/%/clone','Clone','a:0:{}','system',0,0,0,0,0,6,0,1,412,1137,1147,1169,1208,0,0,0,0),('management',1228,1168,'admin/commerce/products/types/deposit/fields/replace/%','admin/commerce/products/types/deposit/fields/replace/%','Replace fields','a:0:{}','system',0,0,0,0,0,7,0,1,412,423,438,1155,1168,1228,0,0,0),('user-menu',1271,0,'menutoken/548ab0a68133f','menutoken/%','Your Store','a:5:{s:20:\"menu_token_link_path\";s:30:\"user/[current-user:uid]/stores\";s:15:\"menu_token_data\";a:0:{}s:18:\"menu_token_options\";a:1:{s:5:\"clear\";i:0;}s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}s:5:\"alter\";b:1;}','menu',0,0,0,0,-48,1,1,1271,0,0,0,0,0,0,0,0,0),('user-menu',1272,0,'menutoken/548ab2889cfde','menutoken/%','Your Balance','a:5:{s:20:\"menu_token_link_path\";s:31:\"user/[current-user:uid]/account\";s:15:\"menu_token_data\";a:0:{}s:18:\"menu_token_options\";a:1:{s:5:\"clear\";i:0;}s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}s:5:\"alter\";b:1;}','menu',0,0,0,0,-47,1,1,1272,0,0,0,0,0,0,0,0,0),('menu-headline-menu',1273,0,'menutoken/548ab5610c2fb','menutoken/%','Your Orders','a:5:{s:20:\"menu_token_link_path\";s:30:\"user/[current-user:uid]/orders\";s:15:\"menu_token_data\";a:0:{}s:18:\"menu_token_options\";a:1:{s:5:\"clear\";i:0;}s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}s:5:\"alter\";b:1;}','menu',0,0,0,0,-50,1,1,1273,0,0,0,0,0,0,0,0,0),('management',1274,12,'admin/help/commerce_shipping_ui','admin/help/commerce_shipping_ui','commerce_shipping_ui','a:0:{}','system',-1,0,0,0,0,3,0,1,12,1274,0,0,0,0,0,0,0),('management',1275,413,'admin/commerce/config/shipping','admin/commerce/config/shipping','Shipping','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"Manage shipping methods and services.\";}}','system',0,0,0,0,0,4,0,1,412,413,1275,0,0,0,0,0,0),('management',1276,1275,'admin/commerce/config/shipping/calculation-rules','admin/commerce/config/shipping/calculation-rules','Calculation rules','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:55:\"Add and configure your shipping rate calculation rules.\";}}','system',-1,0,1,0,10,5,0,1,412,413,1275,1276,0,0,0,0,0),('management',1277,1275,'admin/commerce/config/shipping/methods','admin/commerce/config/shipping/methods','Shipping methods','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:24:\"Manage shipping methods.\";}}','system',-1,0,1,0,5,5,0,1,412,413,1275,1277,0,0,0,0,0),('management',1278,1275,'admin/commerce/config/shipping/services','admin/commerce/config/shipping/services','Shipping services','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:25:\"Manage shipping services.\";}}','system',-1,0,1,0,0,5,0,1,412,413,1275,1278,0,0,0,0,0),('management',1279,1276,'admin/commerce/config/shipping/calculation-rules/add','admin/commerce/config/shipping/calculation-rules/add','Add a calculation rule','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:64:\"Adds an additional shipping rate calculation rule configuration.\";}}','system',0,0,0,0,0,6,0,1,412,413,1275,1276,1279,0,0,0,0),('management',1280,1276,'admin/commerce/config/shipping/calculation-rules/manage/%','admin/commerce/config/shipping/calculation-rules/manage/%','','a:0:{}','system',-1,0,1,0,0,6,0,1,412,413,1275,1276,1280,0,0,0,0),('management',1281,1280,'admin/commerce/config/shipping/calculation-rules/manage/%/clone','admin/commerce/config/shipping/calculation-rules/manage/%/clone','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,1275,1276,1280,1281,0,0,0),('management',1282,1280,'admin/commerce/config/shipping/calculation-rules/manage/%/execute','admin/commerce/config/shipping/calculation-rules/manage/%/execute','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,1275,1276,1280,1282,0,0,0),('management',1283,1280,'admin/commerce/config/shipping/calculation-rules/manage/%/export','admin/commerce/config/shipping/calculation-rules/manage/%/export','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,1275,1276,1280,1283,0,0,0),('management',1284,1280,'admin/commerce/config/shipping/calculation-rules/manage/%/%','admin/commerce/config/shipping/calculation-rules/manage/%/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,1275,1276,1280,1284,0,0,0),('management',1285,1280,'admin/commerce/config/shipping/calculation-rules/manage/%/delete/event','admin/commerce/config/shipping/calculation-rules/manage/%/delete/event','Remove event','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"Remove an event from a reaction rule.\";}}','system',0,0,0,0,0,7,0,1,412,413,1275,1276,1280,1285,0,0,0),('management',1286,1280,'admin/commerce/config/shipping/calculation-rules/manage/%/add/event','admin/commerce/config/shipping/calculation-rules/manage/%/add/event','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,1275,1276,1280,1286,0,0,0),('management',1287,1280,'admin/commerce/config/shipping/calculation-rules/manage/%/delete/%','admin/commerce/config/shipping/calculation-rules/manage/%/delete/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,1275,1276,1280,1287,0,0,0),('management',1288,1280,'admin/commerce/config/shipping/calculation-rules/manage/%/edit/%','admin/commerce/config/shipping/calculation-rules/manage/%/edit/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,1275,1276,1280,1288,0,0,0),('management',1289,1280,'admin/commerce/config/shipping/calculation-rules/manage/%/add/%','admin/commerce/config/shipping/calculation-rules/manage/%/add/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,1275,1276,1280,1289,0,0,0),('management',1290,1277,'admin/commerce/config/shipping/methods/flat-rate','admin/commerce/config/shipping/methods/flat-rate','','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"Redirect to the shipping method list.\";}}','system',0,0,0,0,0,6,0,1,412,413,1275,1277,1290,0,0,0,0),('management',1291,1278,'admin/commerce/config/shipping/services/flat-rate','admin/commerce/config/shipping/services/flat-rate','Flat rate','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:50:\"Manage shipping services for this shipping method.\";}}','system',-1,0,0,0,0,6,0,1,412,413,1275,1278,1291,0,0,0,0),('management',1292,1291,'admin/commerce/config/shipping/services/flat-rate/add','admin/commerce/config/shipping/services/flat-rate/add','Add a flat rate service','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:82:\"Create a new flat rate shipping service, including a title and base shipping rate.\";}}','system',-1,0,0,0,0,7,0,1,412,413,1275,1278,1291,1292,0,0,0),('management',1293,1290,'admin/commerce/config/shipping/methods/flat-rate/add','admin/commerce/config/shipping/methods/flat-rate/add','Add a flat rate service','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:82:\"Create a new flat rate shipping service, including a title and base shipping rate.\";}}','system',-1,0,0,0,8,7,0,1,412,413,1275,1277,1290,1293,0,0,0),('management',1294,1290,'admin/commerce/config/shipping/methods/flat-rate/rule','admin/commerce/config/shipping/methods/flat-rate/rule','Configure rule','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:74:\"Add conditions to the rule used to collect rates for this shipping method.\";}}','system',-1,0,0,0,5,7,0,1,412,413,1275,1277,1290,1294,0,0,0),('management',1295,1290,'admin/commerce/config/shipping/methods/flat-rate/services','admin/commerce/config/shipping/methods/flat-rate/services','View services','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:60:\"View the table of services defined for this shipping method.\";}}','system',-1,0,0,0,10,7,0,1,412,413,1275,1277,1290,1295,0,0,0),('management',1296,1278,'admin/commerce/config/shipping/services/flat-rate-free-shipping','admin/commerce/config/shipping/services/flat-rate-free-shipping','','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Redirect to the shipping service list.\";}}','system',0,0,0,0,0,6,0,1,412,413,1275,1278,1296,0,0,0,0),('management',1297,1296,'admin/commerce/config/shipping/services/flat-rate-free-shipping/component','admin/commerce/config/shipping/services/flat-rate-free-shipping/component','Configure component','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:75:\"Add conditions to the Rules component used to rate orders for this service.\";}}','system',-1,0,0,0,5,7,0,1,412,413,1275,1278,1296,1297,0,0,0),('management',1298,1296,'admin/commerce/config/shipping/services/flat-rate-free-shipping/delete','admin/commerce/config/shipping/services/flat-rate-free-shipping/delete','Delete','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:29:\"Delete the flat rate service.\";}}','system',-1,0,0,0,10,7,0,1,412,413,1275,1278,1296,1298,0,0,0),('management',1299,1296,'admin/commerce/config/shipping/services/flat-rate-free-shipping/edit','admin/commerce/config/shipping/services/flat-rate-free-shipping/edit','Edit','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:27:\"Edit the flat rate service.\";}}','system',-1,0,0,0,0,7,0,1,412,413,1275,1278,1296,1299,0,0,0),('management',1300,1278,'admin/commerce/config/shipping/services/flat-rate-shipping','admin/commerce/config/shipping/services/flat-rate-shipping','','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Redirect to the shipping service list.\";}}','system',0,0,0,0,0,6,0,1,412,413,1275,1278,1300,0,0,0,0),('management',1301,1300,'admin/commerce/config/shipping/services/flat-rate-shipping/component','admin/commerce/config/shipping/services/flat-rate-shipping/component','Configure component','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:75:\"Add conditions to the Rules component used to rate orders for this service.\";}}','system',-1,0,0,0,5,7,0,1,412,413,1275,1278,1300,1301,0,0,0),('management',1302,1300,'admin/commerce/config/shipping/services/flat-rate-shipping/delete','admin/commerce/config/shipping/services/flat-rate-shipping/delete','Delete','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:29:\"Delete the flat rate service.\";}}','system',-1,0,0,0,10,7,0,1,412,413,1275,1278,1300,1302,0,0,0),('management',1303,1300,'admin/commerce/config/shipping/services/flat-rate-shipping/edit','admin/commerce/config/shipping/services/flat-rate-shipping/edit','Edit','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:27:\"Edit the flat rate service.\";}}','system',-1,0,0,0,0,7,0,1,412,413,1275,1278,1300,1303,0,0,0),('management',1304,12,'admin/help/locale','admin/help/locale','locale','a:0:{}','system',-1,0,0,0,0,3,0,1,12,1304,0,0,0,0,0,0,0),('management',1305,51,'admin/config/regional/language','admin/config/regional/language','Languages','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:55:\"Configure languages for content and the user interface.\";}}','system',0,0,1,0,-10,4,0,1,8,51,1305,0,0,0,0,0,0),('management',1306,51,'admin/config/regional/translate','admin/config/regional/translate','Translate interface','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:59:\"Translate the built in interface and optionally other text.\";}}','system',0,0,1,0,-5,4,0,1,8,51,1306,0,0,0,0,0,0),('management',1307,1305,'admin/config/regional/language/add','admin/config/regional/language/add','Add language','a:0:{}','system',-1,0,0,0,5,5,0,1,8,51,1305,1307,0,0,0,0,0),('management',1308,1305,'admin/config/regional/language/configure','admin/config/regional/language/configure','Detection and selection','a:0:{}','system',-1,0,0,0,10,5,0,1,8,51,1305,1308,0,0,0,0,0),('management',1309,1306,'admin/config/regional/translate/export','admin/config/regional/translate/export','Export','a:0:{}','system',-1,0,0,0,30,5,0,1,8,51,1306,1309,0,0,0,0,0),('management',1310,1306,'admin/config/regional/translate/import','admin/config/regional/translate/import','Import','a:0:{}','system',-1,0,0,0,20,5,0,1,8,51,1306,1310,0,0,0,0,0),('management',1311,1305,'admin/config/regional/language/overview','admin/config/regional/language/overview','List','a:0:{}','system',-1,0,0,0,0,5,0,1,8,51,1305,1311,0,0,0,0,0),('management',1312,100,'admin/config/regional/date-time/locale','admin/config/regional/date-time/locale','Localize','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Configure date formats for each locale\";}}','system',-1,0,1,0,-8,5,0,1,8,51,100,1312,0,0,0,0,0),('management',1313,1306,'admin/config/regional/translate/overview','admin/config/regional/translate/overview','Overview','a:0:{}','system',-1,0,0,0,0,5,0,1,8,51,1306,1313,0,0,0,0,0),('management',1314,1306,'admin/config/regional/translate/translate','admin/config/regional/translate/translate','Translate','a:0:{}','system',-1,0,0,0,10,5,0,1,8,51,1306,1314,0,0,0,0,0),('management',1315,1305,'admin/config/regional/language/delete/%','admin/config/regional/language/delete/%','Confirm','a:0:{}','system',0,0,0,0,0,5,0,1,8,51,1305,1315,0,0,0,0,0),('management',1316,1306,'admin/config/regional/translate/delete/%','admin/config/regional/translate/delete/%','Delete string','a:0:{}','system',0,0,0,0,0,5,0,1,8,51,1306,1316,0,0,0,0,0),('management',1317,1305,'admin/config/regional/language/edit/%','admin/config/regional/language/edit/%','Edit language','a:0:{}','system',0,0,0,0,0,5,0,1,8,51,1305,1317,0,0,0,0,0),('management',1318,1306,'admin/config/regional/translate/edit/%','admin/config/regional/translate/edit/%','Edit string','a:0:{}','system',0,0,0,0,0,5,0,1,8,51,1306,1318,0,0,0,0,0),('management',1319,1308,'admin/config/regional/language/configure/session','admin/config/regional/language/configure/session','Session language detection configuration','a:0:{}','system',-1,0,0,0,0,6,0,1,8,51,1305,1308,1319,0,0,0,0),('management',1320,1308,'admin/config/regional/language/configure/url','admin/config/regional/language/configure/url','URL language detection configuration','a:0:{}','system',-1,0,0,0,0,6,0,1,8,51,1305,1308,1320,0,0,0,0),('management',1321,1312,'admin/config/regional/date-time/locale/%/edit','admin/config/regional/date-time/locale/%/edit','Localize date formats','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Configure date formats for each locale\";}}','system',0,0,0,0,0,6,0,1,8,51,100,1312,1321,0,0,0,0),('management',1322,1312,'admin/config/regional/date-time/locale/%/reset','admin/config/regional/date-time/locale/%/reset','Reset date formats','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:47:\"Reset localized date formats to global defaults\";}}','system',0,0,0,0,0,6,0,1,8,51,100,1312,1322,0,0,0,0),('management',1323,53,'admin/config/search/current_search','admin/config/search/current_search','Current search blocks','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:32:\"Configure current search blocks.\";}}','system',0,0,1,0,0,4,0,1,8,53,1323,0,0,0,0,0,0),('management',1324,1323,'admin/config/search/current_search/add','admin/config/search/current_search/add','Add','a:0:{}','system',-1,0,0,0,0,5,0,1,8,53,1323,1324,0,0,0,0,0),('management',1325,1323,'admin/config/search/current_search/import','admin/config/search/current_search/import','Import','a:0:{}','system',-1,0,0,0,0,5,0,1,8,53,1323,1325,0,0,0,0,0),('management',1326,1323,'admin/config/search/current_search/list','admin/config/search/current_search/list','List','a:0:{}','system',-1,0,0,0,-10,5,0,1,8,53,1323,1326,0,0,0,0,0),('management',1327,1326,'admin/config/search/current_search/list/%/edit','admin/config/search/current_search/list/%/edit','Configure current search items','a:0:{}','system',-1,0,0,0,-10,6,0,1,8,53,1323,1326,1327,0,0,0,0),('management',1328,1326,'admin/config/search/current_search/list/%/export','admin/config/search/current_search/list/%/export','Export','a:0:{}','system',-1,0,0,0,0,6,0,1,8,53,1323,1326,1328,0,0,0,0),('management',1329,1323,'admin/config/search/current_search/item/%/delete/%','admin/config/search/current_search/item/%/delete/%','Revert current search block configuration','a:0:{}','system',0,0,0,0,0,5,0,1,8,53,1323,1329,0,0,0,0,0),('management',1815,21,'admin/structure/tb-megamenu','admin/structure/tb-megamenu','TB Mega Menu','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:12:\"TB Mega Menu\";}}','system',0,0,0,0,0,3,0,1,21,1815,0,0,0,0,0,0,0),('management',1816,1815,'admin/structure/tb-megamenu/request','admin/structure/tb-megamenu/request','Request','a:0:{}','system',1,0,0,0,0,4,0,1,21,1815,1816,0,0,0,0,0,0),('management',1817,1815,'admin/structure/tb-megamenu/%/config','admin/structure/tb-megamenu/%/config','Config TB Mega Menu','a:0:{}','system',-1,0,0,0,-10,4,0,1,21,1815,1817,0,0,0,0,0,0),('navigation',1818,343,'node/%/webform/emails/%','node/%/webform/emails/%','','a:0:{}','system',-1,0,0,0,0,4,0,5,324,343,1818,0,0,0,0,0,0),('navigation',1819,1818,'node/%/webform/emails/%/delete','node/%/webform/emails/%/delete','','a:0:{}','system',-1,0,0,0,0,5,0,5,324,343,1818,1819,0,0,0,0,0),('navigation',1820,1818,'node/%/webform/emails/%/clone','node/%/webform/emails/%/clone','','a:0:{}','system',-1,0,0,0,0,5,0,5,324,343,1818,1820,0,0,0,0,0),('navigation',2067,4,'filter/tips/%','filter/tips/%','Compose tips','a:0:{}','system',0,0,0,0,0,2,0,4,2067,0,0,0,0,0,0,0,0),('management',2068,54,'admin/appearance/settings/we_backend','admin/appearance/settings/we_backend','WeebPal Backend theme','a:0:{}','system',-1,0,0,0,0,4,0,1,7,54,2068,0,0,0,0,0,0),('management',2069,30,'admin/structure/block/list/we_backend','admin/structure/block/list/we_backend','WeebPal Backend theme','a:0:{}','system',-1,0,0,0,0,4,0,1,21,30,2069,0,0,0,0,0,0),('management',2070,2069,'admin/structure/block/list/we_backend/add','admin/structure/block/list/we_backend/add','Add block','a:0:{}','system',-1,0,0,0,0,5,0,1,21,30,2069,2070,0,0,0,0,0),('management',2071,21,'admin/structure/migrate_content','admin/structure/migrate_content','Migrate Content','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:23:\"Manage Migrate Content.\";}}','system',0,0,0,0,0,3,0,1,21,2071,0,0,0,0,0,0,0),('management',2072,2071,'admin/structure/migrate_content/create','admin/structure/migrate_content/create','Create','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:23:\"Migrate Content Create.\";}}','system',-1,0,0,0,10,4,0,1,21,2071,2072,0,0,0,0,0,0),('management',2073,2071,'admin/structure/migrate_content/import-from-upload','admin/structure/migrate_content/import-from-upload','Import','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:26:\"Upload zip file to import.\";}}','system',-1,0,0,0,11,4,0,1,21,2071,2073,0,0,0,0,0,0),('management',2074,2071,'admin/structure/migrate_content/manage','admin/structure/migrate_content/manage','Manage','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"Enable and disable entity bundle.\";}}','system',-1,0,0,0,0,4,0,1,21,2071,2074,0,0,0,0,0,0),('management',2075,2071,'admin/structure/migrate_content/settings','admin/structure/migrate_content/settings','Settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:49:\"Adjust settings for using migrate content module.\";}}','system',-1,0,0,0,11,4,0,1,21,2071,2075,0,0,0,0,0,0),('management',2076,315,'admin/structure/field-collections/%','admin/structure/field-collections/%','Manage fields','a:0:{}','system',0,0,0,0,1,4,0,1,21,315,2076,0,0,0,0,0,0),('management',2077,436,'admin/commerce/config/order/display','admin/commerce/config/order/display','Manage display','a:0:{}','system',-1,0,0,0,2,5,0,1,412,413,436,2077,0,0,0,0,0),('management',2078,820,'admin/commerce/config/commerce_store_order/display','admin/commerce/config/commerce_store_order/display','Manage display','a:0:{}','system',-1,0,0,0,2,5,0,1,412,413,820,2078,0,0,0,0,0),('management',2079,977,'admin/config/regional/countries/display','admin/config/regional/countries/display','Manage display','a:0:{}','system',-1,0,0,0,2,5,0,1,8,51,977,2079,0,0,0,0,0),('management',2080,2076,'admin/structure/field-collections/%/display','admin/structure/field-collections/%/display','Manage display','a:0:{}','system',-1,0,0,0,2,5,0,1,21,315,2076,2080,0,0,0,0,0),('management',2081,89,'admin/structure/taxonomy/%/display','admin/structure/taxonomy/%/display','Manage display','a:0:{}','system',-1,0,0,0,2,5,0,1,21,57,89,2081,0,0,0,0,0),('management',2082,90,'admin/config/people/accounts/display','admin/config/people/accounts/display','Manage display','a:0:{}','system',-1,0,0,0,2,5,0,1,8,48,90,2082,0,0,0,0,0),('management',2083,436,'admin/commerce/config/order/fields','admin/commerce/config/order/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,5,0,1,412,413,436,2083,0,0,0,0,0),('management',2084,820,'admin/commerce/config/commerce_store_order/fields','admin/commerce/config/commerce_store_order/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,5,0,1,412,413,820,2084,0,0,0,0,0),('management',2085,977,'admin/config/regional/countries/fields','admin/config/regional/countries/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,5,0,1,8,51,977,2085,0,0,0,0,0),('management',2086,2076,'admin/structure/field-collections/%/fields','admin/structure/field-collections/%/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,5,0,1,21,315,2076,2086,0,0,0,0,0),('management',2087,89,'admin/structure/taxonomy/%/fields','admin/structure/taxonomy/%/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,5,0,1,21,57,89,2087,0,0,0,0,0),('management',2088,90,'admin/config/people/accounts/fields','admin/config/people/accounts/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,5,0,1,8,48,90,2088,0,0,0,0,0),('management',2089,2081,'admin/structure/taxonomy/%/display/add_to_cart_form','admin/structure/taxonomy/%/display/add_to_cart_form','Add to Cart form - Attribute','a:0:{}','system',-1,0,0,0,2,6,0,1,21,57,89,2081,2089,0,0,0,0),('management',2090,2077,'admin/commerce/config/order/display/administrator','admin/commerce/config/order/display/administrator','Administrator','a:0:{}','system',-1,0,0,0,0,6,0,1,412,413,436,2077,2090,0,0,0,0),('management',2091,2078,'admin/commerce/config/commerce_store_order/display/administrator','admin/commerce/config/commerce_store_order/display/administrator','Administrator','a:0:{}','system',-1,0,0,0,0,6,0,1,412,413,820,2078,2091,0,0,0,0),('management',2092,2079,'admin/config/regional/countries/display/full','admin/config/regional/countries/display/full','Country','a:0:{}','system',-1,0,0,0,0,6,0,1,8,51,977,2079,2092,0,0,0,0),('management',2093,2077,'admin/commerce/config/order/display/customer','admin/commerce/config/order/display/customer','Customer','a:0:{}','system',-1,0,0,0,1,6,0,1,412,413,436,2077,2093,0,0,0,0),('management',2094,2078,'admin/commerce/config/commerce_store_order/display/customer','admin/commerce/config/commerce_store_order/display/customer','Customer','a:0:{}','system',-1,0,0,0,1,6,0,1,412,413,820,2078,2094,0,0,0,0),('management',2095,2077,'admin/commerce/config/order/display/default','admin/commerce/config/order/display/default','Default','a:0:{}','system',-1,0,0,0,-10,6,0,1,412,413,436,2077,2095,0,0,0,0),('management',2096,2078,'admin/commerce/config/commerce_store_order/display/default','admin/commerce/config/commerce_store_order/display/default','Default','a:0:{}','system',-1,0,0,0,-10,6,0,1,412,413,820,2078,2096,0,0,0,0),('management',2097,2079,'admin/config/regional/countries/display/default','admin/config/regional/countries/display/default','Default','a:0:{}','system',-1,0,0,0,-10,6,0,1,8,51,977,2079,2097,0,0,0,0),('management',2098,2080,'admin/structure/field-collections/%/display/default','admin/structure/field-collections/%/display/default','Default','a:0:{}','system',-1,0,0,0,-10,6,0,1,21,315,2076,2080,2098,0,0,0,0),('management',2099,2081,'admin/structure/taxonomy/%/display/default','admin/structure/taxonomy/%/display/default','Default','a:0:{}','system',-1,0,0,0,-10,6,0,1,21,57,89,2081,2099,0,0,0,0),('management',2100,2082,'admin/config/people/accounts/display/default','admin/config/people/accounts/display/default','Default','a:0:{}','system',-1,0,0,0,-10,6,0,1,8,48,90,2082,2100,0,0,0,0),('management',2101,2080,'admin/structure/field-collections/%/display/full','admin/structure/field-collections/%/display/full','Full content','a:0:{}','system',-1,0,0,0,0,6,0,1,21,315,2076,2080,2101,0,0,0,0),('management',2102,840,'admin/structure/entity-type/commerce_store/store/display','admin/structure/entity-type/commerce_store/store/display','Manage display','a:0:{}','system',-1,0,0,0,2,6,0,1,21,806,819,840,2102,0,0,0,0),('management',2103,137,'admin/structure/types/manage/%/display','admin/structure/types/manage/%/display','Manage display','a:0:{}','system',-1,0,0,0,2,5,0,1,21,36,137,2103,0,0,0,0,0),('management',2104,840,'admin/structure/entity-type/commerce_store/store/fields','admin/structure/entity-type/commerce_store/store/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,6,0,1,21,806,819,840,2104,0,0,0,0),('management',2105,137,'admin/structure/types/manage/%/fields','admin/structure/types/manage/%/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,5,0,1,21,36,137,2105,0,0,0,0,0),('management',2106,2081,'admin/structure/taxonomy/%/display/full','admin/structure/taxonomy/%/display/full','Taxonomy term page','a:0:{}','system',-1,0,0,0,0,6,0,1,21,57,89,2081,2106,0,0,0,0),('management',2107,2077,'admin/commerce/config/order/display/token','admin/commerce/config/order/display/token','Tokens','a:0:{}','system',-1,0,0,0,2,6,0,1,412,413,436,2077,2107,0,0,0,0),('management',2108,2078,'admin/commerce/config/commerce_store_order/display/token','admin/commerce/config/commerce_store_order/display/token','Tokens','a:0:{}','system',-1,0,0,0,2,6,0,1,412,413,820,2078,2108,0,0,0,0),('management',2109,2079,'admin/config/regional/countries/display/token','admin/config/regional/countries/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,6,0,1,8,51,977,2079,2109,0,0,0,0),('management',2110,2080,'admin/structure/field-collections/%/display/token','admin/structure/field-collections/%/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,6,0,1,21,315,2076,2080,2110,0,0,0,0),('management',2111,2081,'admin/structure/taxonomy/%/display/token','admin/structure/taxonomy/%/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,6,0,1,21,57,89,2081,2111,0,0,0,0),('management',2112,2082,'admin/config/people/accounts/display/token','admin/config/people/accounts/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,6,0,1,8,48,90,2082,2112,0,0,0,0),('management',2113,2082,'admin/config/people/accounts/display/full','admin/config/people/accounts/display/full','User account','a:0:{}','system',-1,0,0,0,0,6,0,1,8,48,90,2082,2113,0,0,0,0),('management',2114,2083,'admin/commerce/config/order/fields/%','admin/commerce/config/order/fields/%','','a:0:{}','system',0,0,0,0,0,6,0,1,412,413,436,2083,2114,0,0,0,0),('management',2115,2084,'admin/commerce/config/commerce_store_order/fields/%','admin/commerce/config/commerce_store_order/fields/%','','a:0:{}','system',0,0,0,0,0,6,0,1,412,413,820,2084,2115,0,0,0,0),('management',2116,2085,'admin/config/regional/countries/fields/%','admin/config/regional/countries/fields/%','','a:0:{}','system',0,0,0,0,0,6,0,1,8,51,977,2085,2116,0,0,0,0),('management',2117,2086,'admin/structure/field-collections/%/fields/%','admin/structure/field-collections/%/fields/%','','a:0:{}','system',0,0,0,0,0,6,0,1,21,315,2076,2086,2117,0,0,0,0),('management',2118,2087,'admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','','a:0:{}','system',0,0,0,0,0,6,0,1,21,57,89,2087,2118,0,0,0,0),('management',2119,2088,'admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','','a:0:{}','system',0,0,0,0,0,6,0,1,8,48,90,2088,2119,0,0,0,0),('management',2120,1167,'admin/commerce/products/types/deposit/display/full','admin/commerce/products/types/deposit/display/full','Admin display','a:0:{}','system',-1,0,0,0,0,7,0,1,412,423,438,1155,1167,2120,0,0,0),('management',2121,486,'admin/commerce/products/types/product/display/full','admin/commerce/products/types/product/display/full','Admin display','a:0:{}','system',-1,0,0,0,0,7,0,1,412,423,438,463,486,2121,0,0,0),('management',2122,484,'admin/commerce/customer-profiles/types/billing/display/administrator','admin/commerce/customer-profiles/types/billing/display/administrator','Administrator','a:0:{}','system',-1,0,0,0,0,7,0,1,412,421,439,445,484,2122,0,0,0),('management',2123,849,'admin/commerce/customer-profiles/types/shipping/display/administrator','admin/commerce/customer-profiles/types/shipping/display/administrator','Administrator','a:0:{}','system',-1,0,0,0,0,7,0,1,412,421,439,839,849,2123,0,0,0),('management',2124,1167,'admin/commerce/products/types/deposit/display/commerce_line_item_display','admin/commerce/products/types/deposit/display/commerce_line_item_display','Commerce Line item: Display','a:0:{}','system',-1,0,0,0,3,7,0,1,412,423,438,1155,1167,2124,0,0,0),('management',2125,486,'admin/commerce/products/types/product/display/commerce_line_item_display','admin/commerce/products/types/product/display/commerce_line_item_display','Commerce Line item: Display','a:0:{}','system',-1,0,0,0,3,7,0,1,412,423,438,463,486,2125,0,0,0),('management',2126,1167,'admin/commerce/products/types/deposit/display/commerce_line_item_token','admin/commerce/products/types/deposit/display/commerce_line_item_token','Commerce Line item: Tokens','a:0:{}','system',-1,0,0,0,4,7,0,1,412,423,438,1155,1167,2126,0,0,0),('management',2127,486,'admin/commerce/products/types/product/display/commerce_line_item_token','admin/commerce/products/types/product/display/commerce_line_item_token','Commerce Line item: Tokens','a:0:{}','system',-1,0,0,0,4,7,0,1,412,423,438,463,486,2127,0,0,0),('management',2128,484,'admin/commerce/customer-profiles/types/billing/display/customer','admin/commerce/customer-profiles/types/billing/display/customer','Customer','a:0:{}','system',-1,0,0,0,1,7,0,1,412,421,439,445,484,2128,0,0,0),('management',2129,849,'admin/commerce/customer-profiles/types/shipping/display/customer','admin/commerce/customer-profiles/types/shipping/display/customer','Customer','a:0:{}','system',-1,0,0,0,1,7,0,1,412,421,439,839,849,2129,0,0,0),('management',2130,484,'admin/commerce/customer-profiles/types/billing/display/default','admin/commerce/customer-profiles/types/billing/display/default','Default','a:0:{}','system',-1,0,0,0,-10,7,0,1,412,421,439,445,484,2130,0,0,0),('management',2131,849,'admin/commerce/customer-profiles/types/shipping/display/default','admin/commerce/customer-profiles/types/shipping/display/default','Default','a:0:{}','system',-1,0,0,0,-10,7,0,1,412,421,439,839,849,2131,0,0,0),('management',2132,485,'admin/commerce/config/line-items/product/display/default','admin/commerce/config/line-items/product/display/default','Default','a:0:{}','system',-1,0,0,0,-10,7,0,1,412,413,434,462,485,2132,0,0,0),('management',2133,850,'admin/commerce/config/line-items/shipping/display/default','admin/commerce/config/line-items/shipping/display/default','Default','a:0:{}','system',-1,0,0,0,-10,7,0,1,412,413,434,838,850,2133,0,0,0),('management',2134,1167,'admin/commerce/products/types/deposit/display/default','admin/commerce/products/types/deposit/display/default','Default','a:0:{}','system',-1,0,0,0,-10,7,0,1,412,423,438,1155,1167,2134,0,0,0),('management',2135,486,'admin/commerce/products/types/product/display/default','admin/commerce/products/types/product/display/default','Default','a:0:{}','system',-1,0,0,0,-10,7,0,1,412,423,438,463,486,2135,0,0,0),('management',2136,2102,'admin/structure/entity-type/commerce_store/store/display/default','admin/structure/entity-type/commerce_store/store/display/default','Default','a:0:{}','system',-1,0,0,0,-10,7,0,1,21,806,819,840,2102,2136,0,0,0),('management',2137,2103,'admin/structure/types/manage/%/display/default','admin/structure/types/manage/%/display/default','Default','a:0:{}','system',-1,0,0,0,-10,6,0,1,21,36,137,2103,2137,0,0,0,0),('management',2138,485,'admin/commerce/config/line-items/product/display/display','admin/commerce/config/line-items/product/display/display','Display','a:0:{}','system',-1,0,0,0,0,7,0,1,412,413,434,462,485,2138,0,0,0),('management',2139,850,'admin/commerce/config/line-items/shipping/display/display','admin/commerce/config/line-items/shipping/display/display','Display','a:0:{}','system',-1,0,0,0,0,7,0,1,412,413,434,838,850,2139,0,0,0),('management',2140,2103,'admin/structure/types/manage/%/display/email_html','admin/structure/types/manage/%/display/email_html','Email: HTML','a:0:{}','system',-1,0,0,0,6,6,0,1,21,36,137,2103,2140,0,0,0,0),('management',2141,2103,'admin/structure/types/manage/%/display/email_textalt','admin/structure/types/manage/%/display/email_textalt','Email: HTML text alternative','a:0:{}','system',-1,0,0,0,7,6,0,1,21,36,137,2103,2141,0,0,0,0),('management',2142,2103,'admin/structure/types/manage/%/display/email_plain','admin/structure/types/manage/%/display/email_plain','Email: Plain','a:0:{}','system',-1,0,0,0,5,6,0,1,21,36,137,2103,2142,0,0,0,0),('management',2143,2102,'admin/structure/entity-type/commerce_store/store/display/full','admin/structure/entity-type/commerce_store/store/display/full','Full','a:0:{}','system',-1,0,0,0,0,7,0,1,21,806,819,840,2102,2143,0,0,0),('management',2144,2103,'admin/structure/types/manage/%/display/full','admin/structure/types/manage/%/display/full','Full content','a:0:{}','system',-1,0,0,0,0,6,0,1,21,36,137,2103,2144,0,0,0,0),('management',2145,1167,'admin/commerce/products/types/deposit/display/line_item','admin/commerce/products/types/deposit/display/line_item','Line item','a:0:{}','system',-1,0,0,0,2,7,0,1,412,423,438,1155,1167,2145,0,0,0),('management',2146,486,'admin/commerce/products/types/product/display/line_item','admin/commerce/products/types/product/display/line_item','Line item','a:0:{}','system',-1,0,0,0,2,7,0,1,412,423,438,463,486,2146,0,0,0),('management',2147,1158,'admin/commerce/marketplace_funds/account/commerce_store/manage/display','admin/commerce/marketplace_funds/account/commerce_store/manage/display','Manage display','a:0:{}','system',-1,0,0,0,2,6,0,1,412,1137,1143,1158,2147,0,0,0,0),('management',2148,1159,'admin/commerce/marketplace_funds/account/user/manage/display','admin/commerce/marketplace_funds/account/user/manage/display','Manage display','a:0:{}','system',-1,0,0,0,2,6,0,1,412,1137,1143,1159,2148,0,0,0,0),('management',2149,1160,'admin/commerce/marketplace_funds/transaction/deposit/manage/display','admin/commerce/marketplace_funds/transaction/deposit/manage/display','Manage display','a:0:{}','system',-1,0,0,0,2,6,0,1,412,1137,1144,1160,2149,0,0,0,0),('management',2150,1162,'admin/commerce/marketplace_funds/transaction/payment/manage/display','admin/commerce/marketplace_funds/transaction/payment/manage/display','Manage display','a:0:{}','system',-1,0,0,0,2,6,0,1,412,1137,1144,1162,2150,0,0,0,0),('management',2151,1161,'admin/commerce/marketplace_funds/transaction/transfer/manage/display','admin/commerce/marketplace_funds/transaction/transfer/manage/display','Manage display','a:0:{}','system',-1,0,0,0,2,6,0,1,412,1137,1144,1161,2151,0,0,0,0),('management',2152,1163,'admin/commerce/marketplace_funds/transaction/withdraw/manage/display','admin/commerce/marketplace_funds/transaction/withdraw/manage/display','Manage display','a:0:{}','system',-1,0,0,0,2,6,0,1,412,1137,1144,1163,2152,0,0,0,0),('management',2153,1169,'admin/commerce/marketplace_funds/withdraw/manage/%/display','admin/commerce/marketplace_funds/withdraw/manage/%/display','Manage display','a:0:{}','system',-1,0,0,0,2,6,0,1,412,1137,1147,1169,2153,0,0,0,0),('management',2154,1158,'admin/commerce/marketplace_funds/account/commerce_store/manage/fields','admin/commerce/marketplace_funds/account/commerce_store/manage/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,6,0,1,412,1137,1143,1158,2154,0,0,0,0),('management',2155,1159,'admin/commerce/marketplace_funds/account/user/manage/fields','admin/commerce/marketplace_funds/account/user/manage/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,6,0,1,412,1137,1143,1159,2155,0,0,0,0),('management',2156,1160,'admin/commerce/marketplace_funds/transaction/deposit/manage/fields','admin/commerce/marketplace_funds/transaction/deposit/manage/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,6,0,1,412,1137,1144,1160,2156,0,0,0,0),('management',2157,1162,'admin/commerce/marketplace_funds/transaction/payment/manage/fields','admin/commerce/marketplace_funds/transaction/payment/manage/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,6,0,1,412,1137,1144,1162,2157,0,0,0,0),('management',2158,1161,'admin/commerce/marketplace_funds/transaction/transfer/manage/fields','admin/commerce/marketplace_funds/transaction/transfer/manage/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,6,0,1,412,1137,1144,1161,2158,0,0,0,0),('management',2159,1163,'admin/commerce/marketplace_funds/transaction/withdraw/manage/fields','admin/commerce/marketplace_funds/transaction/withdraw/manage/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,6,0,1,412,1137,1144,1163,2159,0,0,0,0),('management',2160,1169,'admin/commerce/marketplace_funds/withdraw/manage/%/fields','admin/commerce/marketplace_funds/withdraw/manage/%/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,6,0,1,412,1137,1147,1169,2160,0,0,0,0),('management',2161,1167,'admin/commerce/products/types/deposit/display/node_email_html','admin/commerce/products/types/deposit/display/node_email_html','Node: Email: HTML','a:0:{}','system',-1,0,0,0,11,7,0,1,412,423,438,1155,1167,2161,0,0,0),('management',2162,486,'admin/commerce/products/types/product/display/node_email_html','admin/commerce/products/types/product/display/node_email_html','Node: Email: HTML','a:0:{}','system',-1,0,0,0,11,7,0,1,412,423,438,463,486,2162,0,0,0),('management',2163,1167,'admin/commerce/products/types/deposit/display/node_email_textalt','admin/commerce/products/types/deposit/display/node_email_textalt','Node: Email: HTML text alternative','a:0:{}','system',-1,0,0,0,12,7,0,1,412,423,438,1155,1167,2163,0,0,0),('management',2164,486,'admin/commerce/products/types/product/display/node_email_textalt','admin/commerce/products/types/product/display/node_email_textalt','Node: Email: HTML text alternative','a:0:{}','system',-1,0,0,0,12,7,0,1,412,423,438,463,486,2164,0,0,0),('management',2165,1167,'admin/commerce/products/types/deposit/display/node_email_plain','admin/commerce/products/types/deposit/display/node_email_plain','Node: Email: Plain','a:0:{}','system',-1,0,0,0,10,7,0,1,412,423,438,1155,1167,2165,0,0,0),('management',2166,486,'admin/commerce/products/types/product/display/node_email_plain','admin/commerce/products/types/product/display/node_email_plain','Node: Email: Plain','a:0:{}','system',-1,0,0,0,10,7,0,1,412,423,438,463,486,2166,0,0,0),('management',2167,1167,'admin/commerce/products/types/deposit/display/node_full','admin/commerce/products/types/deposit/display/node_full','Node: Full content','a:0:{}','system',-1,0,0,0,5,7,0,1,412,423,438,1155,1167,2167,0,0,0),('management',2168,486,'admin/commerce/products/types/product/display/node_full','admin/commerce/products/types/product/display/node_full','Node: Full content','a:0:{}','system',-1,0,0,0,5,7,0,1,412,423,438,463,486,2168,0,0,0),('management',2169,1167,'admin/commerce/products/types/deposit/display/node_teaser','admin/commerce/products/types/deposit/display/node_teaser','Node: Teaser','a:0:{}','system',-1,0,0,0,6,7,0,1,412,423,438,1155,1167,2169,0,0,0),('management',2170,486,'admin/commerce/products/types/product/display/node_teaser','admin/commerce/products/types/product/display/node_teaser','Node: Teaser','a:0:{}','system',-1,0,0,0,6,7,0,1,412,423,438,463,486,2170,0,0,0),('management',2171,2103,'admin/structure/types/manage/%/display/search_result','admin/structure/types/manage/%/display/search_result','Search result highlighting input','a:0:{}','system',-1,0,0,0,4,6,0,1,21,36,137,2103,2171,0,0,0,0),('management',2172,484,'admin/commerce/customer-profiles/types/billing/display/token','admin/commerce/customer-profiles/types/billing/display/token','Tokens','a:0:{}','system',-1,0,0,0,2,7,0,1,412,421,439,445,484,2172,0,0,0),('management',2173,849,'admin/commerce/customer-profiles/types/shipping/display/token','admin/commerce/customer-profiles/types/shipping/display/token','Tokens','a:0:{}','system',-1,0,0,0,2,7,0,1,412,421,439,839,849,2173,0,0,0),('management',2174,485,'admin/commerce/config/line-items/product/display/token','admin/commerce/config/line-items/product/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,7,0,1,412,413,434,462,485,2174,0,0,0),('management',2175,850,'admin/commerce/config/line-items/shipping/display/token','admin/commerce/config/line-items/shipping/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,7,0,1,412,413,434,838,850,2175,0,0,0),('management',2176,1167,'admin/commerce/products/types/deposit/display/token','admin/commerce/products/types/deposit/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,7,0,1,412,423,438,1155,1167,2176,0,0,0),('management',2177,486,'admin/commerce/products/types/product/display/token','admin/commerce/products/types/product/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,7,0,1,412,423,438,463,486,2177,0,0,0),('management',2178,2102,'admin/structure/entity-type/commerce_store/store/display/token','admin/structure/entity-type/commerce_store/store/display/token','Tokens','a:0:{}','system',-1,0,0,0,2,7,0,1,21,806,819,840,2102,2178,0,0,0),('management',2179,2103,'admin/structure/types/manage/%/display/token','admin/structure/types/manage/%/display/token','Tokens','a:0:{}','system',-1,0,0,0,8,6,0,1,21,36,137,2103,2179,0,0,0,0),('management',2180,1167,'admin/commerce/products/types/deposit/display/node_rss','admin/commerce/products/types/deposit/display/node_rss','Node: RSS','a:0:{}','system',-1,0,0,0,7,7,0,1,412,423,438,1155,1167,2180,0,0,0),('management',2181,486,'admin/commerce/products/types/product/display/node_rss','admin/commerce/products/types/product/display/node_rss','Node: RSS','a:0:{}','system',-1,0,0,0,7,7,0,1,412,423,438,463,486,2181,0,0,0),('management',2182,1167,'admin/commerce/products/types/deposit/display/node_search_index','admin/commerce/products/types/deposit/display/node_search_index','Node: Search index','a:0:{}','system',-1,0,0,0,8,7,0,1,412,423,438,1155,1167,2182,0,0,0),('management',2183,486,'admin/commerce/products/types/product/display/node_search_index','admin/commerce/products/types/product/display/node_search_index','Node: Search index','a:0:{}','system',-1,0,0,0,8,7,0,1,412,423,438,463,486,2183,0,0,0),('management',2184,1167,'admin/commerce/products/types/deposit/display/node_search_result','admin/commerce/products/types/deposit/display/node_search_result','Node: Search result highlighting input','a:0:{}','system',-1,0,0,0,9,7,0,1,412,423,438,1155,1167,2184,0,0,0),('management',2185,486,'admin/commerce/products/types/product/display/node_search_result','admin/commerce/products/types/product/display/node_search_result','Node: Search result highlighting input','a:0:{}','system',-1,0,0,0,9,7,0,1,412,423,438,463,486,2185,0,0,0),('management',2186,1167,'admin/commerce/products/types/deposit/display/node_token','admin/commerce/products/types/deposit/display/node_token','Node: Tokens','a:0:{}','system',-1,0,0,0,13,7,0,1,412,423,438,1155,1167,2186,0,0,0),('management',2187,486,'admin/commerce/products/types/product/display/node_token','admin/commerce/products/types/product/display/node_token','Node: Tokens','a:0:{}','system',-1,0,0,0,13,7,0,1,412,423,438,463,486,2187,0,0,0),('management',2188,2103,'admin/structure/types/manage/%/display/rss','admin/structure/types/manage/%/display/rss','RSS','a:0:{}','system',-1,0,0,0,2,6,0,1,21,36,137,2103,2188,0,0,0,0),('management',2189,2103,'admin/structure/types/manage/%/display/search_index','admin/structure/types/manage/%/display/search_index','Search index','a:0:{}','system',-1,0,0,0,3,6,0,1,21,36,137,2103,2189,0,0,0,0),('management',2190,2102,'admin/structure/entity-type/commerce_store/store/display/teaser','admin/structure/entity-type/commerce_store/store/display/teaser','Teaser','a:0:{}','system',-1,0,0,0,1,7,0,1,21,806,819,840,2102,2190,0,0,0),('management',2191,2103,'admin/structure/types/manage/%/display/teaser','admin/structure/types/manage/%/display/teaser','Teaser','a:0:{}','system',-1,0,0,0,1,6,0,1,21,36,137,2103,2191,0,0,0,0),('management',2192,2114,'admin/commerce/config/order/fields/%/delete','admin/commerce/config/order/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,7,0,1,412,413,436,2083,2114,2192,0,0,0),('management',2193,2114,'admin/commerce/config/order/fields/%/edit','admin/commerce/config/order/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,7,0,1,412,413,436,2083,2114,2193,0,0,0),('management',2194,2115,'admin/commerce/config/commerce_store_order/fields/%/delete','admin/commerce/config/commerce_store_order/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,7,0,1,412,413,820,2084,2115,2194,0,0,0),('management',2195,2115,'admin/commerce/config/commerce_store_order/fields/%/edit','admin/commerce/config/commerce_store_order/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,7,0,1,412,413,820,2084,2115,2195,0,0,0),('management',2196,2116,'admin/config/regional/countries/fields/%/delete','admin/config/regional/countries/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,7,0,1,8,51,977,2085,2116,2196,0,0,0),('management',2197,2116,'admin/config/regional/countries/fields/%/edit','admin/config/regional/countries/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,7,0,1,8,51,977,2085,2116,2197,0,0,0),('management',2198,2117,'admin/structure/field-collections/%/fields/%/delete','admin/structure/field-collections/%/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,7,0,1,21,315,2076,2086,2117,2198,0,0,0),('management',2199,2118,'admin/structure/taxonomy/%/fields/%/delete','admin/structure/taxonomy/%/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,7,0,1,21,57,89,2087,2118,2199,0,0,0),('management',2200,2117,'admin/structure/field-collections/%/fields/%/edit','admin/structure/field-collections/%/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,7,0,1,21,315,2076,2086,2117,2200,0,0,0),('management',2201,2118,'admin/structure/taxonomy/%/fields/%/edit','admin/structure/taxonomy/%/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,7,0,1,21,57,89,2087,2118,2201,0,0,0),('management',2202,2119,'admin/config/people/accounts/fields/%/delete','admin/config/people/accounts/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,7,0,1,8,48,90,2088,2119,2202,0,0,0),('management',2203,2119,'admin/config/people/accounts/fields/%/edit','admin/config/people/accounts/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,7,0,1,8,48,90,2088,2119,2203,0,0,0),('management',2204,487,'admin/commerce/customer-profiles/types/billing/fields/%','admin/commerce/customer-profiles/types/billing/fields/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,421,439,445,487,2204,0,0,0),('management',2205,852,'admin/commerce/customer-profiles/types/shipping/fields/%','admin/commerce/customer-profiles/types/shipping/fields/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,421,439,839,852,2205,0,0,0),('management',2206,488,'admin/commerce/config/line-items/product/fields/%','admin/commerce/config/line-items/product/fields/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,434,462,488,2206,0,0,0),('management',2207,853,'admin/commerce/config/line-items/shipping/fields/%','admin/commerce/config/line-items/shipping/fields/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,413,434,838,853,2207,0,0,0),('management',2208,2114,'admin/commerce/config/order/fields/%/field-settings','admin/commerce/config/order/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,7,0,1,412,413,436,2083,2114,2208,0,0,0),('management',2209,2114,'admin/commerce/config/order/fields/%/widget-type','admin/commerce/config/order/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,7,0,1,412,413,436,2083,2114,2209,0,0,0),('management',2210,2115,'admin/commerce/config/commerce_store_order/fields/%/field-settings','admin/commerce/config/commerce_store_order/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,7,0,1,412,413,820,2084,2115,2210,0,0,0),('management',2211,2115,'admin/commerce/config/commerce_store_order/fields/%/widget-type','admin/commerce/config/commerce_store_order/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,7,0,1,412,413,820,2084,2115,2211,0,0,0),('management',2212,1168,'admin/commerce/products/types/deposit/fields/%','admin/commerce/products/types/deposit/fields/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,423,438,1155,1168,2212,0,0,0),('management',2213,489,'admin/commerce/products/types/product/fields/%','admin/commerce/products/types/product/fields/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,423,438,463,489,2213,0,0,0),('management',2214,2104,'admin/structure/entity-type/commerce_store/store/fields/%','admin/structure/entity-type/commerce_store/store/fields/%','','a:0:{}','system',0,0,0,0,0,7,0,1,21,806,819,840,2104,2214,0,0,0),('management',2215,2116,'admin/config/regional/countries/fields/%/field-settings','admin/config/regional/countries/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,7,0,1,8,51,977,2085,2116,2215,0,0,0),('management',2216,2116,'admin/config/regional/countries/fields/%/widget-type','admin/config/regional/countries/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,7,0,1,8,51,977,2085,2116,2216,0,0,0),('management',2217,2117,'admin/structure/field-collections/%/fields/%/field-settings','admin/structure/field-collections/%/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,7,0,1,21,315,2076,2086,2117,2217,0,0,0),('management',2218,2117,'admin/structure/field-collections/%/fields/%/widget-type','admin/structure/field-collections/%/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,7,0,1,21,315,2076,2086,2117,2218,0,0,0),('management',2219,2105,'admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','','a:0:{}','system',0,0,0,0,0,6,0,1,21,36,137,2105,2219,0,0,0,0),('management',2220,2118,'admin/structure/taxonomy/%/fields/%/field-settings','admin/structure/taxonomy/%/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,7,0,1,21,57,89,2087,2118,2220,0,0,0),('management',2221,2118,'admin/structure/taxonomy/%/fields/%/widget-type','admin/structure/taxonomy/%/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,7,0,1,21,57,89,2087,2118,2221,0,0,0),('management',2222,2119,'admin/config/people/accounts/fields/%/field-settings','admin/config/people/accounts/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,7,0,1,8,48,90,2088,2119,2222,0,0,0),('management',2223,2119,'admin/config/people/accounts/fields/%/widget-type','admin/config/people/accounts/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,7,0,1,8,48,90,2088,2119,2223,0,0,0),('management',2224,2147,'admin/commerce/marketplace_funds/account/commerce_store/manage/display/default','admin/commerce/marketplace_funds/account/commerce_store/manage/display/default','Default','a:0:{}','system',-1,0,0,0,-10,7,0,1,412,1137,1143,1158,2147,2224,0,0,0),('management',2225,2148,'admin/commerce/marketplace_funds/account/user/manage/display/default','admin/commerce/marketplace_funds/account/user/manage/display/default','Default','a:0:{}','system',-1,0,0,0,-10,7,0,1,412,1137,1143,1159,2148,2225,0,0,0),('management',2226,2149,'admin/commerce/marketplace_funds/transaction/deposit/manage/display/default','admin/commerce/marketplace_funds/transaction/deposit/manage/display/default','Default','a:0:{}','system',-1,0,0,0,-10,7,0,1,412,1137,1144,1160,2149,2226,0,0,0),('management',2227,2150,'admin/commerce/marketplace_funds/transaction/payment/manage/display/default','admin/commerce/marketplace_funds/transaction/payment/manage/display/default','Default','a:0:{}','system',-1,0,0,0,-10,7,0,1,412,1137,1144,1162,2150,2227,0,0,0),('management',2228,2151,'admin/commerce/marketplace_funds/transaction/transfer/manage/display/default','admin/commerce/marketplace_funds/transaction/transfer/manage/display/default','Default','a:0:{}','system',-1,0,0,0,-10,7,0,1,412,1137,1144,1161,2151,2228,0,0,0),('management',2229,2152,'admin/commerce/marketplace_funds/transaction/withdraw/manage/display/default','admin/commerce/marketplace_funds/transaction/withdraw/manage/display/default','Default','a:0:{}','system',-1,0,0,0,-10,7,0,1,412,1137,1144,1163,2152,2229,0,0,0),('management',2230,2153,'admin/commerce/marketplace_funds/withdraw/manage/%/display/default','admin/commerce/marketplace_funds/withdraw/manage/%/display/default','Default','a:0:{}','system',-1,0,0,0,-10,7,0,1,412,1137,1147,1169,2153,2230,0,0,0),('management',2231,176,'admin/structure/types/manage/%/comment/display/default','admin/structure/types/manage/%/comment/display/default','Default','a:0:{}','system',-1,0,0,0,-10,6,0,1,21,36,137,176,2231,0,0,0,0),('management',2232,2147,'admin/commerce/marketplace_funds/account/commerce_store/manage/display/full','admin/commerce/marketplace_funds/account/commerce_store/manage/display/full','Full Account','a:0:{}','system',-1,0,0,0,0,7,0,1,412,1137,1143,1158,2147,2232,0,0,0),('management',2233,2148,'admin/commerce/marketplace_funds/account/user/manage/display/full','admin/commerce/marketplace_funds/account/user/manage/display/full','Full Account','a:0:{}','system',-1,0,0,0,0,7,0,1,412,1137,1143,1159,2148,2233,0,0,0),('management',2234,2149,'admin/commerce/marketplace_funds/transaction/deposit/manage/display/full','admin/commerce/marketplace_funds/transaction/deposit/manage/display/full','Full Transaction','a:0:{}','system',-1,0,0,0,0,7,0,1,412,1137,1144,1160,2149,2234,0,0,0),('management',2235,2150,'admin/commerce/marketplace_funds/transaction/payment/manage/display/full','admin/commerce/marketplace_funds/transaction/payment/manage/display/full','Full Transaction','a:0:{}','system',-1,0,0,0,0,7,0,1,412,1137,1144,1162,2150,2235,0,0,0),('management',2236,2151,'admin/commerce/marketplace_funds/transaction/transfer/manage/display/full','admin/commerce/marketplace_funds/transaction/transfer/manage/display/full','Full Transaction','a:0:{}','system',-1,0,0,0,0,7,0,1,412,1137,1144,1161,2151,2236,0,0,0),('management',2237,2152,'admin/commerce/marketplace_funds/transaction/withdraw/manage/display/full','admin/commerce/marketplace_funds/transaction/withdraw/manage/display/full','Full Transaction','a:0:{}','system',-1,0,0,0,0,7,0,1,412,1137,1144,1163,2152,2237,0,0,0),('management',2238,176,'admin/structure/types/manage/%/comment/display/full','admin/structure/types/manage/%/comment/display/full','Full comment','a:0:{}','system',-1,0,0,0,0,6,0,1,21,36,137,176,2238,0,0,0,0),('management',2239,2147,'admin/commerce/marketplace_funds/account/commerce_store/manage/display/token','admin/commerce/marketplace_funds/account/commerce_store/manage/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,7,0,1,412,1137,1143,1158,2147,2239,0,0,0),('management',2240,2148,'admin/commerce/marketplace_funds/account/user/manage/display/token','admin/commerce/marketplace_funds/account/user/manage/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,7,0,1,412,1137,1143,1159,2148,2240,0,0,0),('management',2241,2149,'admin/commerce/marketplace_funds/transaction/deposit/manage/display/token','admin/commerce/marketplace_funds/transaction/deposit/manage/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,7,0,1,412,1137,1144,1160,2149,2241,0,0,0),('management',2242,2150,'admin/commerce/marketplace_funds/transaction/payment/manage/display/token','admin/commerce/marketplace_funds/transaction/payment/manage/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,7,0,1,412,1137,1144,1162,2150,2242,0,0,0),('management',2243,2151,'admin/commerce/marketplace_funds/transaction/transfer/manage/display/token','admin/commerce/marketplace_funds/transaction/transfer/manage/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,7,0,1,412,1137,1144,1161,2151,2243,0,0,0),('management',2244,2152,'admin/commerce/marketplace_funds/transaction/withdraw/manage/display/token','admin/commerce/marketplace_funds/transaction/withdraw/manage/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,7,0,1,412,1137,1144,1163,2152,2244,0,0,0),('management',2245,2153,'admin/commerce/marketplace_funds/withdraw/manage/%/display/token','admin/commerce/marketplace_funds/withdraw/manage/%/display/token','Tokens','a:0:{}','system',-1,0,0,0,0,7,0,1,412,1137,1147,1169,2153,2245,0,0,0),('management',2246,176,'admin/structure/types/manage/%/comment/display/token','admin/structure/types/manage/%/comment/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,6,0,1,21,36,137,176,2246,0,0,0,0),('management',2247,2158,'admin/commerce/marketplace_funds/transaction/transfer/manage/fields/%','admin/commerce/marketplace_funds/transaction/transfer/manage/fields/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,1137,1144,1161,2158,2247,0,0,0),('management',2248,2159,'admin/commerce/marketplace_funds/transaction/withdraw/manage/fields/%','admin/commerce/marketplace_funds/transaction/withdraw/manage/fields/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,1137,1144,1163,2159,2248,0,0,0),('management',2249,2160,'admin/commerce/marketplace_funds/withdraw/manage/%/fields/%','admin/commerce/marketplace_funds/withdraw/manage/%/fields/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,1137,1147,1169,2160,2249,0,0,0),('management',2250,2155,'admin/commerce/marketplace_funds/account/user/manage/fields/%','admin/commerce/marketplace_funds/account/user/manage/fields/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,1137,1143,1159,2155,2250,0,0,0),('management',2251,2157,'admin/commerce/marketplace_funds/transaction/payment/manage/fields/%','admin/commerce/marketplace_funds/transaction/payment/manage/fields/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,1137,1144,1162,2157,2251,0,0,0),('management',2252,177,'admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','','a:0:{}','system',0,0,0,0,0,6,0,1,21,36,137,177,2252,0,0,0,0),('management',2253,2204,'admin/commerce/customer-profiles/types/billing/fields/%/delete','admin/commerce/customer-profiles/types/billing/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,8,0,1,412,421,439,445,487,2204,2253,0,0),('management',2254,2204,'admin/commerce/customer-profiles/types/billing/fields/%/edit','admin/commerce/customer-profiles/types/billing/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,8,0,1,412,421,439,445,487,2204,2254,0,0),('management',2255,2154,'admin/commerce/marketplace_funds/account/commerce_store/manage/fields/%','admin/commerce/marketplace_funds/account/commerce_store/manage/fields/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,1137,1143,1158,2154,2255,0,0,0),('management',2256,2156,'admin/commerce/marketplace_funds/transaction/deposit/manage/fields/%','admin/commerce/marketplace_funds/transaction/deposit/manage/fields/%','','a:0:{}','system',0,0,0,0,0,7,0,1,412,1137,1144,1160,2156,2256,0,0,0),('management',2257,2204,'admin/commerce/customer-profiles/types/billing/fields/%/field-settings','admin/commerce/customer-profiles/types/billing/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,8,0,1,412,421,439,445,487,2204,2257,0,0),('management',2258,2204,'admin/commerce/customer-profiles/types/billing/fields/%/widget-type','admin/commerce/customer-profiles/types/billing/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,8,0,1,412,421,439,445,487,2204,2258,0,0),('management',2259,2205,'admin/commerce/customer-profiles/types/shipping/fields/%/delete','admin/commerce/customer-profiles/types/shipping/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,8,0,1,412,421,439,839,852,2205,2259,0,0),('management',2260,2205,'admin/commerce/customer-profiles/types/shipping/fields/%/edit','admin/commerce/customer-profiles/types/shipping/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,8,0,1,412,421,439,839,852,2205,2260,0,0),('management',2261,2205,'admin/commerce/customer-profiles/types/shipping/fields/%/field-settings','admin/commerce/customer-profiles/types/shipping/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,8,0,1,412,421,439,839,852,2205,2261,0,0),('management',2262,2205,'admin/commerce/customer-profiles/types/shipping/fields/%/widget-type','admin/commerce/customer-profiles/types/shipping/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,8,0,1,412,421,439,839,852,2205,2262,0,0),('management',2263,2206,'admin/commerce/config/line-items/product/fields/%/delete','admin/commerce/config/line-items/product/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,8,0,1,412,413,434,462,488,2206,2263,0,0),('management',2264,2206,'admin/commerce/config/line-items/product/fields/%/edit','admin/commerce/config/line-items/product/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,8,0,1,412,413,434,462,488,2206,2264,0,0),('management',2265,2206,'admin/commerce/config/line-items/product/fields/%/field-settings','admin/commerce/config/line-items/product/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,8,0,1,412,413,434,462,488,2206,2265,0,0),('management',2266,2206,'admin/commerce/config/line-items/product/fields/%/widget-type','admin/commerce/config/line-items/product/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,8,0,1,412,413,434,462,488,2206,2266,0,0),('management',2267,2207,'admin/commerce/config/line-items/shipping/fields/%/delete','admin/commerce/config/line-items/shipping/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,8,0,1,412,413,434,838,853,2207,2267,0,0),('management',2268,2207,'admin/commerce/config/line-items/shipping/fields/%/edit','admin/commerce/config/line-items/shipping/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,8,0,1,412,413,434,838,853,2207,2268,0,0),('management',2269,2207,'admin/commerce/config/line-items/shipping/fields/%/field-settings','admin/commerce/config/line-items/shipping/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,8,0,1,412,413,434,838,853,2207,2269,0,0),('management',2270,2207,'admin/commerce/config/line-items/shipping/fields/%/widget-type','admin/commerce/config/line-items/shipping/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,8,0,1,412,413,434,838,853,2207,2270,0,0),('management',2271,2212,'admin/commerce/products/types/deposit/fields/%/delete','admin/commerce/products/types/deposit/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,8,0,1,412,423,438,1155,1168,2212,2271,0,0),('management',2272,2212,'admin/commerce/products/types/deposit/fields/%/edit','admin/commerce/products/types/deposit/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,8,0,1,412,423,438,1155,1168,2212,2272,0,0),('management',2273,2212,'admin/commerce/products/types/deposit/fields/%/field-settings','admin/commerce/products/types/deposit/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,8,0,1,412,423,438,1155,1168,2212,2273,0,0),('management',2274,2212,'admin/commerce/products/types/deposit/fields/%/widget-type','admin/commerce/products/types/deposit/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,8,0,1,412,423,438,1155,1168,2212,2274,0,0),('management',2275,2213,'admin/commerce/products/types/product/fields/%/delete','admin/commerce/products/types/product/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,8,0,1,412,423,438,463,489,2213,2275,0,0),('management',2276,2213,'admin/commerce/products/types/product/fields/%/edit','admin/commerce/products/types/product/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,8,0,1,412,423,438,463,489,2213,2276,0,0),('management',2277,2213,'admin/commerce/products/types/product/fields/%/field-settings','admin/commerce/products/types/product/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,8,0,1,412,423,438,463,489,2213,2277,0,0),('management',2278,2213,'admin/commerce/products/types/product/fields/%/widget-type','admin/commerce/products/types/product/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,8,0,1,412,423,438,463,489,2213,2278,0,0),('management',2279,2214,'admin/structure/entity-type/commerce_store/store/fields/%/delete','admin/structure/entity-type/commerce_store/store/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,8,0,1,21,806,819,840,2104,2214,2279,0,0),('management',2280,2214,'admin/structure/entity-type/commerce_store/store/fields/%/edit','admin/structure/entity-type/commerce_store/store/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,8,0,1,21,806,819,840,2104,2214,2280,0,0),('management',2281,2214,'admin/structure/entity-type/commerce_store/store/fields/%/field-settings','admin/structure/entity-type/commerce_store/store/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,8,0,1,21,806,819,840,2104,2214,2281,0,0),('management',2282,2214,'admin/structure/entity-type/commerce_store/store/fields/%/widget-type','admin/structure/entity-type/commerce_store/store/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,8,0,1,21,806,819,840,2104,2214,2282,0,0),('management',2283,2219,'admin/structure/types/manage/%/fields/%/delete','admin/structure/types/manage/%/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,7,0,1,21,36,137,2105,2219,2283,0,0,0),('management',2284,2219,'admin/structure/types/manage/%/fields/%/edit','admin/structure/types/manage/%/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,7,0,1,21,36,137,2105,2219,2284,0,0,0),('management',2285,2219,'admin/structure/types/manage/%/fields/%/field-settings','admin/structure/types/manage/%/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,7,0,1,21,36,137,2105,2219,2285,0,0,0),('management',2286,2219,'admin/structure/types/manage/%/fields/%/widget-type','admin/structure/types/manage/%/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,7,0,1,21,36,137,2105,2219,2286,0,0,0),('management',2287,2255,'admin/commerce/marketplace_funds/account/commerce_store/manage/fields/%/delete','admin/commerce/marketplace_funds/account/commerce_store/manage/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,8,0,1,412,1137,1143,1158,2154,2255,2287,0,0),('management',2288,2255,'admin/commerce/marketplace_funds/account/commerce_store/manage/fields/%/edit','admin/commerce/marketplace_funds/account/commerce_store/manage/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,8,0,1,412,1137,1143,1158,2154,2255,2288,0,0),('management',2289,2255,'admin/commerce/marketplace_funds/account/commerce_store/manage/fields/%/field-settings','admin/commerce/marketplace_funds/account/commerce_store/manage/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,8,0,1,412,1137,1143,1158,2154,2255,2289,0,0),('management',2290,2255,'admin/commerce/marketplace_funds/account/commerce_store/manage/fields/%/widget-type','admin/commerce/marketplace_funds/account/commerce_store/manage/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,8,0,1,412,1137,1143,1158,2154,2255,2290,0,0),('management',2291,2250,'admin/commerce/marketplace_funds/account/user/manage/fields/%/delete','admin/commerce/marketplace_funds/account/user/manage/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,8,0,1,412,1137,1143,1159,2155,2250,2291,0,0),('management',2292,2250,'admin/commerce/marketplace_funds/account/user/manage/fields/%/edit','admin/commerce/marketplace_funds/account/user/manage/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,8,0,1,412,1137,1143,1159,2155,2250,2292,0,0),('management',2293,2250,'admin/commerce/marketplace_funds/account/user/manage/fields/%/field-settings','admin/commerce/marketplace_funds/account/user/manage/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,8,0,1,412,1137,1143,1159,2155,2250,2293,0,0),('management',2294,2250,'admin/commerce/marketplace_funds/account/user/manage/fields/%/widget-type','admin/commerce/marketplace_funds/account/user/manage/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,8,0,1,412,1137,1143,1159,2155,2250,2294,0,0),('management',2295,2256,'admin/commerce/marketplace_funds/transaction/deposit/manage/fields/%/delete','admin/commerce/marketplace_funds/transaction/deposit/manage/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,8,0,1,412,1137,1144,1160,2156,2256,2295,0,0),('management',2296,2256,'admin/commerce/marketplace_funds/transaction/deposit/manage/fields/%/edit','admin/commerce/marketplace_funds/transaction/deposit/manage/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,8,0,1,412,1137,1144,1160,2156,2256,2296,0,0),('management',2297,2256,'admin/commerce/marketplace_funds/transaction/deposit/manage/fields/%/field-settings','admin/commerce/marketplace_funds/transaction/deposit/manage/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,8,0,1,412,1137,1144,1160,2156,2256,2297,0,0),('management',2298,2256,'admin/commerce/marketplace_funds/transaction/deposit/manage/fields/%/widget-type','admin/commerce/marketplace_funds/transaction/deposit/manage/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,8,0,1,412,1137,1144,1160,2156,2256,2298,0,0),('management',2299,2251,'admin/commerce/marketplace_funds/transaction/payment/manage/fields/%/delete','admin/commerce/marketplace_funds/transaction/payment/manage/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,8,0,1,412,1137,1144,1162,2157,2251,2299,0,0),('management',2300,2251,'admin/commerce/marketplace_funds/transaction/payment/manage/fields/%/edit','admin/commerce/marketplace_funds/transaction/payment/manage/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,8,0,1,412,1137,1144,1162,2157,2251,2300,0,0),('management',2301,2251,'admin/commerce/marketplace_funds/transaction/payment/manage/fields/%/field-settings','admin/commerce/marketplace_funds/transaction/payment/manage/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,8,0,1,412,1137,1144,1162,2157,2251,2301,0,0),('management',2302,2251,'admin/commerce/marketplace_funds/transaction/payment/manage/fields/%/widget-type','admin/commerce/marketplace_funds/transaction/payment/manage/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,8,0,1,412,1137,1144,1162,2157,2251,2302,0,0),('management',2303,2247,'admin/commerce/marketplace_funds/transaction/transfer/manage/fields/%/delete','admin/commerce/marketplace_funds/transaction/transfer/manage/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,8,0,1,412,1137,1144,1161,2158,2247,2303,0,0),('management',2304,2247,'admin/commerce/marketplace_funds/transaction/transfer/manage/fields/%/edit','admin/commerce/marketplace_funds/transaction/transfer/manage/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,8,0,1,412,1137,1144,1161,2158,2247,2304,0,0),('management',2305,2247,'admin/commerce/marketplace_funds/transaction/transfer/manage/fields/%/field-settings','admin/commerce/marketplace_funds/transaction/transfer/manage/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,8,0,1,412,1137,1144,1161,2158,2247,2305,0,0),('management',2306,2247,'admin/commerce/marketplace_funds/transaction/transfer/manage/fields/%/widget-type','admin/commerce/marketplace_funds/transaction/transfer/manage/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,8,0,1,412,1137,1144,1161,2158,2247,2306,0,0),('management',2307,2248,'admin/commerce/marketplace_funds/transaction/withdraw/manage/fields/%/delete','admin/commerce/marketplace_funds/transaction/withdraw/manage/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,8,0,1,412,1137,1144,1163,2159,2248,2307,0,0),('management',2308,2248,'admin/commerce/marketplace_funds/transaction/withdraw/manage/fields/%/edit','admin/commerce/marketplace_funds/transaction/withdraw/manage/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,8,0,1,412,1137,1144,1163,2159,2248,2308,0,0),('management',2309,2248,'admin/commerce/marketplace_funds/transaction/withdraw/manage/fields/%/field-settings','admin/commerce/marketplace_funds/transaction/withdraw/manage/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,8,0,1,412,1137,1144,1163,2159,2248,2309,0,0),('management',2310,2248,'admin/commerce/marketplace_funds/transaction/withdraw/manage/fields/%/widget-type','admin/commerce/marketplace_funds/transaction/withdraw/manage/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,8,0,1,412,1137,1144,1163,2159,2248,2310,0,0),('management',2311,2249,'admin/commerce/marketplace_funds/withdraw/manage/%/fields/%/delete','admin/commerce/marketplace_funds/withdraw/manage/%/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,8,0,1,412,1137,1147,1169,2160,2249,2311,0,0),('management',2312,2249,'admin/commerce/marketplace_funds/withdraw/manage/%/fields/%/edit','admin/commerce/marketplace_funds/withdraw/manage/%/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,8,0,1,412,1137,1147,1169,2160,2249,2312,0,0),('management',2313,2249,'admin/commerce/marketplace_funds/withdraw/manage/%/fields/%/field-settings','admin/commerce/marketplace_funds/withdraw/manage/%/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,8,0,1,412,1137,1147,1169,2160,2249,2313,0,0),('management',2314,2249,'admin/commerce/marketplace_funds/withdraw/manage/%/fields/%/widget-type','admin/commerce/marketplace_funds/withdraw/manage/%/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,8,0,1,412,1137,1147,1169,2160,2249,2314,0,0),('management',2315,2252,'admin/structure/types/manage/%/comment/fields/%/delete','admin/structure/types/manage/%/comment/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,7,0,1,21,36,137,177,2252,2315,0,0,0),('management',2316,2252,'admin/structure/types/manage/%/comment/fields/%/edit','admin/structure/types/manage/%/comment/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,7,0,1,21,36,137,177,2252,2316,0,0,0),('management',2317,2252,'admin/structure/types/manage/%/comment/fields/%/field-settings','admin/structure/types/manage/%/comment/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,7,0,1,21,36,137,177,2252,2317,0,0,0),('management',2318,2252,'admin/structure/types/manage/%/comment/fields/%/widget-type','admin/structure/types/manage/%/comment/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,7,0,1,21,36,137,177,2252,2318,0,0,0);
/*!40000 ALTER TABLE `menu_links` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `menu_router`
--

DROP TABLE IF EXISTS `menu_router`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menu_router` (
  `path` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: the Drupal path this entry describes',
  `load_functions` blob NOT NULL COMMENT 'A serialized array of function names (like node_load) to be called to load an object corresponding to a part of the current path.',
  `to_arg_functions` blob NOT NULL COMMENT 'A serialized array of function names (like user_uid_optional_to_arg) to be called to replace a part of the router path with another string.',
  `access_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'The callback which determines the access to this router path. Defaults to user_access.',
  `access_arguments` blob COMMENT 'A serialized array of arguments for the access callback.',
  `page_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the function that renders the page.',
  `page_arguments` blob COMMENT 'A serialized array of arguments for the page callback.',
  `delivery_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the function that sends the result of the page_callback function to the browser.',
  `fit` int(11) NOT NULL DEFAULT '0' COMMENT 'A numeric representation of how specific the path is.',
  `number_parts` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Number of parts in this router path.',
  `context` int(11) NOT NULL DEFAULT '0' COMMENT 'Only for local tasks (tabs) - the context of a local task to control its placement.',
  `tab_parent` varchar(255) NOT NULL DEFAULT '' COMMENT 'Only for local tasks (tabs) - the router path of the parent page (which may also be a local task).',
  `tab_root` varchar(255) NOT NULL DEFAULT '' COMMENT 'Router path of the closest non-tab parent page. For pages that are not local tasks, this will be the same as the path.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title for the current page, or the title for the tab if this is a local task.',
  `title_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'A function which will alter the title. Defaults to t()',
  `title_arguments` varchar(255) NOT NULL DEFAULT '' COMMENT 'A serialized array of arguments for the title callback. If empty, the title will be used as the sole argument for the title callback.',
  `theme_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'A function which returns the name of the theme that will be used to render this page. If left empty, the default theme will be used.',
  `theme_arguments` varchar(255) NOT NULL DEFAULT '' COMMENT 'A serialized array of arguments for the theme callback.',
  `type` int(11) NOT NULL DEFAULT '0' COMMENT 'Numeric representation of the type of the menu item, like MENU_LOCAL_TASK.',
  `description` text NOT NULL COMMENT 'A description of this item.',
  `position` varchar(255) NOT NULL DEFAULT '' COMMENT 'The position of the block (left or right) on the system administration page for this item.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Weight of the element. Lighter weights are higher up, heavier weights go down.',
  `include_file` mediumtext COMMENT 'The file to include for this element, usually the page callback function lives in this file.',
  PRIMARY KEY (`path`),
  KEY `fit` (`fit`),
  KEY `tab_parent` (`tab_parent`(64),`weight`,`title`),
  KEY `tab_root_weight_title` (`tab_root`(64),`weight`,`title`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Maps paths to various callbacks (access, page and title)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menu_router`
--

LOCK TABLES `menu_router` WRITE;
/*!40000 ALTER TABLE `menu_router` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `menu_router` VALUES ('admin','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',1,1,0,'','admin','Administration','t','','','a:0:{}',6,'','',9,'modules/system/system.admin.inc'),('admin/appearance','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','system_themes_page','a:0:{}','',3,2,0,'','admin/appearance','Appearance','t','','','a:0:{}',6,'Select and configure your themes.','left',-6,'modules/system/system.admin.inc'),('admin/appearance/default','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','system_theme_default','a:0:{}','',7,3,0,'','admin/appearance/default','Set default theme','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/appearance/disable','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','system_theme_disable','a:0:{}','',7,3,0,'','admin/appearance/disable','Disable theme','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/appearance/enable','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','system_theme_enable','a:0:{}','',7,3,0,'','admin/appearance/enable','Enable theme','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/appearance/install','','','update_manager_access','a:0:{}','drupal_get_form','a:2:{i:0;s:27:\"update_manager_install_form\";i:1;s:5:\"theme\";}','',7,3,1,'admin/appearance','admin/appearance','Install new theme','t','','','a:0:{}',388,'','',25,'modules/update/update.manager.inc'),('admin/appearance/list','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','system_themes_page','a:0:{}','',7,3,1,'admin/appearance','admin/appearance','List','t','','','a:0:{}',140,'Select and configure your theme','',-1,'modules/system/system.admin.inc'),('admin/appearance/settings','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','drupal_get_form','a:1:{i:0;s:21:\"system_theme_settings\";}','',7,3,1,'admin/appearance','admin/appearance','Settings','t','','','a:0:{}',132,'Configure default and theme specific settings.','',20,'modules/system/system.admin.inc'),('admin/appearance/settings/bartik','','','_system_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:25:\"themes/bartik/bartik.info\";s:4:\"name\";s:6:\"bartik\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:6:\"Bartik\";s:11:\"description\";s:48:\"A flexible, recolorable theme with many regions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:7:\"regions\";a:20:{s:6:\"header\";s:6:\"Header\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"triptych_first\";s:14:\"Triptych first\";s:15:\"triptych_middle\";s:15:\"Triptych middle\";s:13:\"triptych_last\";s:13:\"Triptych last\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"0\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:28:\"themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','drupal_get_form','a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:6:\"bartik\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Bartik','t','','','a:0:{}',132,'','',0,'modules/system/system.admin.inc'),('admin/appearance/settings/garland','','','_system_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:27:\"themes/garland/garland.info\";s:4:\"name\";s:7:\"garland\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:7:\"Garland\";s:11:\"description\";s:111:\"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:8:\"settings\";a:1:{s:13:\"garland_width\";s:5:\"fluid\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:29:\"themes/garland/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','drupal_get_form','a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:7:\"garland\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Garland','t','','','a:0:{}',132,'','',0,'modules/system/system.admin.inc'),('admin/appearance/settings/global','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','drupal_get_form','a:1:{i:0;s:21:\"system_theme_settings\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Global settings','t','','','a:0:{}',140,'','',-1,'modules/system/system.admin.inc'),('admin/appearance/settings/marketplace','','','_system_themes_access','a:1:{i:0;O:8:\"stdClass\":13:{s:8:\"filename\";s:45:\"sites/all/themes/marketplace/marketplace.info\";s:4:\"name\";s:11:\"marketplace\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:12:\"Market Place\";s:11:\"description\";s:23:\"Theme for Market Place.\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"engine\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:5:{s:3:\"all\";a:11:{s:34:\"vendor/bootstrap/css/bootstrap.css\";s:63:\"sites/all/themes/marketplace/vendor/bootstrap/css/bootstrap.css\";s:40:\"vendor/bootstrap/css/bootstrap-theme.css\";s:69:\"sites/all/themes/marketplace/vendor/bootstrap/css/bootstrap-theme.css\";s:20:\"fonts/stylesheet.css\";s:49:\"sites/all/themes/marketplace/fonts/stylesheet.css\";s:15:\"css/animate.css\";s:44:\"sites/all/themes/marketplace/css/animate.css\";s:12:\"css/html.css\";s:41:\"sites/all/themes/marketplace/css/html.css\";s:12:\"css/base.css\";s:41:\"sites/all/themes/marketplace/css/base.css\";s:12:\"css/page.css\";s:41:\"sites/all/themes/marketplace/css/page.css\";s:13:\"css/block.css\";s:42:\"sites/all/themes/marketplace/css/block.css\";s:12:\"css/view.css\";s:41:\"sites/all/themes/marketplace/css/view.css\";s:12:\"css/menu.css\";s:41:\"sites/all/themes/marketplace/css/menu.css\";s:14:\"css/screen.css\";s:43:\"sites/all/themes/marketplace/css/screen.css\";}s:56:\"only screen and (min-width:992px) and (max-width:1199px)\";a:1:{s:22:\"css/screens/tablet.css\";s:51:\"sites/all/themes/marketplace/css/screens/tablet.css\";}s:55:\"only screen and (min-width:768px) and (max-width:991px)\";a:1:{s:31:\"css/screens/vertical_tablet.css\";s:60:\"sites/all/themes/marketplace/css/screens/vertical_tablet.css\";}s:33:\"only screen and (max-width:991px)\";a:1:{s:22:\"css/screens/common.css\";s:51:\"sites/all/themes/marketplace/css/screens/common.css\";}s:33:\"only screen and (max-width:767px)\";a:1:{s:22:\"css/screens/mobile.css\";s:51:\"sites/all/themes/marketplace/css/screens/mobile.css\";}}s:7:\"scripts\";a:6:{s:36:\"vendor/bootstrap/js/bootstrap.min.js\";s:65:\"sites/all/themes/marketplace/vendor/bootstrap/js/bootstrap.min.js\";s:23:\"vendor/jquery.cookie.js\";s:52:\"sites/all/themes/marketplace/vendor/jquery.cookie.js\";s:30:\"vendor/jquery.smooth-scroll.js\";s:59:\"sites/all/themes/marketplace/vendor/jquery.smooth-scroll.js\";s:28:\"vendor/uikit/js/uikit.min.js\";s:57:\"sites/all/themes/marketplace/vendor/uikit/js/uikit.min.js\";s:13:\"js/weebpal.js\";s:42:\"sites/all/themes/marketplace/js/weebpal.js\";s:17:\"js/marketplace.js\";s:46:\"sites/all/themes/marketplace/js/marketplace.js\";}s:8:\"features\";a:7:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:25:\"comment_user_verification\";i:6;s:7:\"favicon\";}s:7:\"regions\";a:25:{s:8:\"headline\";s:8:\"Headline\";s:6:\"header\";s:6:\"Header\";s:9:\"main_menu\";s:9:\"Main Menu\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"panel_menu_top\";s:8:\"Menu Top\";s:17:\"panel_mobile_menu\";s:17:\"Panel Mobile Menu\";s:11:\"panel_first\";s:11:\"Panel First\";s:12:\"panel_second\";s:12:\"Panel Second\";s:11:\"panel_third\";s:11:\"Panel Third\";s:19:\"panel_highlighted_1\";s:16:\"Highlighted Left\";s:19:\"panel_highlighted_2\";s:11:\"Highlighted\";s:19:\"panel_highlighted_3\";s:17:\"Highlighted Right\";s:14:\"panel_footer_1\";s:14:\"Panel Footer 1\";s:14:\"panel_footer_2\";s:14:\"Panel Footer 2\";s:14:\"panel_footer_3\";s:14:\"Panel Footer 3\";s:14:\"panel_footer_4\";s:14:\"Panel Footer 4\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:9:{s:19:\"sidebar_first_width\";s:1:\"3\";s:20:\"sidebar_second_width\";s:1:\"3\";s:20:\"panel_footer_1_width\";s:1:\"3\";s:20:\"panel_footer_2_width\";s:1:\"3\";s:20:\"panel_footer_3_width\";s:1:\"3\";s:20:\"panel_footer_4_width\";s:1:\"3\";s:25:\"panel_highlighted_1_width\";s:1:\"4\";s:25:\"panel_highlighted_3_width\";s:1:\"4\";s:20:\"layout_width_default\";s:4:\"1200\";}s:5:\"skins\";a:5:{s:3:\"red\";s:3:\"Red\";s:9:\"dark_blue\";s:9:\"Dark Blue\";s:6:\"yellow\";s:6:\"Yellow\";s:5:\"green\";s:5:\"Green\";s:4:\"cyan\";s:4:\"Cyan\";}s:11:\"backgrounds\";a:7:{s:4:\"bg-1\";s:12:\"Background 1\";s:4:\"bg-2\";s:12:\"Background 2\";s:4:\"bg-3\";s:12:\"Background 3\";s:4:\"bg-4\";s:12:\"Background 4\";s:4:\"bg-5\";s:12:\"Background 5\";s:4:\"bg-6\";s:12:\"Background 6\";s:4:\"bg-7\";s:12:\"Background 7\";}s:6:\"layout\";a:1:{s:12:\"layout-boxed\";s:12:\"Boxed Layout\";}s:10:\"screenshot\";s:43:\"sites/all/themes/marketplace/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"mtime\";i:1499933463;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:5:{s:3:\"all\";a:11:{s:34:\"vendor/bootstrap/css/bootstrap.css\";s:63:\"sites/all/themes/marketplace/vendor/bootstrap/css/bootstrap.css\";s:40:\"vendor/bootstrap/css/bootstrap-theme.css\";s:69:\"sites/all/themes/marketplace/vendor/bootstrap/css/bootstrap-theme.css\";s:20:\"fonts/stylesheet.css\";s:49:\"sites/all/themes/marketplace/fonts/stylesheet.css\";s:15:\"css/animate.css\";s:44:\"sites/all/themes/marketplace/css/animate.css\";s:12:\"css/html.css\";s:41:\"sites/all/themes/marketplace/css/html.css\";s:12:\"css/base.css\";s:41:\"sites/all/themes/marketplace/css/base.css\";s:12:\"css/page.css\";s:41:\"sites/all/themes/marketplace/css/page.css\";s:13:\"css/block.css\";s:42:\"sites/all/themes/marketplace/css/block.css\";s:12:\"css/view.css\";s:41:\"sites/all/themes/marketplace/css/view.css\";s:12:\"css/menu.css\";s:41:\"sites/all/themes/marketplace/css/menu.css\";s:14:\"css/screen.css\";s:43:\"sites/all/themes/marketplace/css/screen.css\";}s:56:\"only screen and (min-width:992px) and (max-width:1199px)\";a:1:{s:22:\"css/screens/tablet.css\";s:51:\"sites/all/themes/marketplace/css/screens/tablet.css\";}s:55:\"only screen and (min-width:768px) and (max-width:991px)\";a:1:{s:31:\"css/screens/vertical_tablet.css\";s:60:\"sites/all/themes/marketplace/css/screens/vertical_tablet.css\";}s:33:\"only screen and (max-width:991px)\";a:1:{s:22:\"css/screens/common.css\";s:51:\"sites/all/themes/marketplace/css/screens/common.css\";}s:33:\"only screen and (max-width:767px)\";a:1:{s:22:\"css/screens/mobile.css\";s:51:\"sites/all/themes/marketplace/css/screens/mobile.css\";}}s:7:\"scripts\";a:6:{s:36:\"vendor/bootstrap/js/bootstrap.min.js\";s:65:\"sites/all/themes/marketplace/vendor/bootstrap/js/bootstrap.min.js\";s:23:\"vendor/jquery.cookie.js\";s:52:\"sites/all/themes/marketplace/vendor/jquery.cookie.js\";s:30:\"vendor/jquery.smooth-scroll.js\";s:59:\"sites/all/themes/marketplace/vendor/jquery.smooth-scroll.js\";s:28:\"vendor/uikit/js/uikit.min.js\";s:57:\"sites/all/themes/marketplace/vendor/uikit/js/uikit.min.js\";s:13:\"js/weebpal.js\";s:42:\"sites/all/themes/marketplace/js/weebpal.js\";s:17:\"js/marketplace.js\";s:46:\"sites/all/themes/marketplace/js/marketplace.js\";}s:6:\"engine\";s:11:\"phptemplate\";}}','drupal_get_form','a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:11:\"marketplace\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Market Place','t','','','a:0:{}',132,'','',0,'modules/system/system.admin.inc'),('admin/appearance/settings/seven','','','_system_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/seven/seven.info\";s:4:\"name\";s:5:\"seven\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:5:\"Seven\";s:11:\"description\";s:65:\"A simple one-column, tableless, fluid width administration theme.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"1\";}s:7:\"regions\";a:8:{s:7:\"content\";s:7:\"Content\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','drupal_get_form','a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:5:\"seven\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Seven','t','','','a:0:{}',132,'','',0,'modules/system/system.admin.inc'),('admin/appearance/settings/stark','','','_system_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/stark/stark.info\";s:4:\"name\";s:5:\"stark\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:5:\"Stark\";s:11:\"description\";s:208:\"This theme demonstrates Drupal\'s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal\'s default code, see the <a href=\"http://drupal.org/theme-guide\">Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/stark/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','drupal_get_form','a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:5:\"stark\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Stark','t','','','a:0:{}',132,'','',0,'modules/system/system.admin.inc'),('admin/appearance/settings/we_backend','','','_system_themes_access','a:1:{i:0;O:8:\"stdClass\":13:{s:8:\"filename\";s:43:\"sites/all/themes/we_backend/we_backend.info\";s:4:\"name\";s:10:\"we_backend\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:15:{s:4:\"name\";s:21:\"WeebPal Backend theme\";s:11:\"description\";s:26:\"Backend theme from WeebPal\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"engine\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:20:\"assets/css/style.css\";s:48:\"sites/all/themes/we_backend/assets/css/style.css\";}}s:7:\"scripts\";a:1:{s:20:\"assets/js/scripts.js\";s:48:\"sites/all/themes/we_backend/assets/js/scripts.js\";}s:8:\"features\";a:7:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:25:\"comment_user_verification\";i:6;s:7:\"favicon\";}s:7:\"regions\";a:10:{s:6:\"header\";s:6:\"Header\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:10:\"screenshot\";s:42:\"sites/all/themes/we_backend/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"mtime\";i:1499933463;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:20:\"assets/css/style.css\";s:48:\"sites/all/themes/we_backend/assets/css/style.css\";}}s:7:\"scripts\";a:1:{s:20:\"assets/js/scripts.js\";s:48:\"sites/all/themes/we_backend/assets/js/scripts.js\";}s:6:\"engine\";s:11:\"phptemplate\";}}','drupal_get_form','a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:10:\"we_backend\";}','',15,4,1,'admin/appearance/settings','admin/appearance','WeebPal Backend theme','t','','','a:0:{}',132,'','',0,'modules/system/system.admin.inc'),('admin/appearance/update','','','update_manager_access','a:0:{}','drupal_get_form','a:2:{i:0;s:26:\"update_manager_update_form\";i:1;s:5:\"theme\";}','',7,3,1,'admin/appearance','admin/appearance','Update','t','','','a:0:{}',132,'','',10,'modules/update/update.manager.inc'),('admin/commerce','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',3,2,0,'','admin/commerce','Store','t','','','a:0:{}',6,'Administer your store.','',-7,'modules/system/system.admin.inc'),('admin/commerce/config','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/commerce/config','Configuration','t','','','a:0:{}',6,'Configure settings and business rules for your store.','',50,'modules/system/system.admin.inc'),('admin/commerce/config/checkout','','','user_access','a:1:{i:0;s:19:\"administer checkout\";}','drupal_get_form','a:1:{i:0;s:30:\"commerce_checkout_builder_form\";}','',15,4,0,'','admin/commerce/config/checkout','Checkout settings','t','','','a:0:{}',6,'Customize the checkout form and configure checkout rules.','',0,'sites/all/modules/commerce/modules/checkout/includes/commerce_checkout.admin.inc'),('admin/commerce/config/checkout/form','','','user_access','a:1:{i:0;s:19:\"administer checkout\";}','drupal_get_form','a:1:{i:0;s:30:\"commerce_checkout_builder_form\";}','',31,5,1,'admin/commerce/config/checkout','admin/commerce/config/checkout','Checkout form','t','','','a:0:{}',140,'Build your checkout pages using module defined checkout form elements.','',0,'sites/all/modules/commerce/modules/checkout/includes/commerce_checkout.admin.inc'),('admin/commerce/config/checkout/form/pane/%','a:1:{i:6;s:27:\"commerce_checkout_pane_load\";}','','user_access','a:1:{i:0;s:19:\"administer checkout\";}','drupal_get_form','a:2:{i:0;s:36:\"commerce_checkout_pane_settings_form\";i:1;i:6;}','',126,7,0,'','admin/commerce/config/checkout/form/pane/%','','commerce_checkout_pane_settings_title','a:1:{i:0;i:6;}','','a:0:{}',6,'Configure the settings for a checkout pane.','',0,'sites/all/modules/commerce/modules/checkout/includes/commerce_checkout.admin.inc'),('admin/commerce/config/checkout/rules','','','user_access','a:1:{i:0;s:19:\"administer checkout\";}','commerce_checkout_complete_rules','a:0:{}','',31,5,1,'admin/commerce/config/checkout','admin/commerce/config/checkout','Checkout rules','t','','','a:0:{}',132,'Enable and configure checkout completion rules.','',5,'sites/all/modules/commerce/modules/checkout/includes/commerce_checkout.admin.inc'),('admin/commerce/config/checkout/rules/add','','','user_access','a:1:{i:0;s:19:\"administer checkout\";}','drupal_get_form','a:2:{i:0;s:40:\"commerce_checkout_add_complete_rule_form\";i:1;s:36:\"admin/commerce/config/checkout/rules\";}','',63,6,1,'admin/commerce/config/checkout/rules','admin/commerce/config/checkout','Add a checkout rule','t','','','a:0:{}',388,'Adds an additional checkout completion rule configuration.','',0,'sites/all/modules/rules/rules_admin/rules_admin.inc'),('admin/commerce/config/checkout/rules/manage/%','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:31:\"rules_ui_form_edit_rules_config\";i:1;i:6;i:2;s:36:\"admin/commerce/config/checkout/rules\";}','',126,7,0,'','admin/commerce/config/checkout/rules/manage/%','','rules_get_title','a:2:{i:0;s:24:\"Editing !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',4,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/checkout/rules/manage/%/%','a:2:{i:6;s:17:\"rules_config_load\";i:7;N;}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:37:\"rules_ui_form_rules_config_confirm_op\";i:1;i:6;i:2;i:7;i:3;s:36:\"admin/commerce/config/checkout/rules\";}','',252,8,0,'','admin/commerce/config/checkout/rules/manage/%/%','','t','','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/checkout/rules/manage/%/add/%','a:2:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}i:8;a:1:{s:18:\"rules_element_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:5:{i:0;s:20:\"rules_ui_add_element\";i:1;i:6;i:2;i:9;i:3;i:8;i:4;s:36:\"admin/commerce/config/checkout/rules\";}','',506,9,0,'','admin/commerce/config/checkout/rules/manage/%/add/%','','rules_menu_add_element_title','a:1:{i:0;a:1:{i:0;i:9;}}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/checkout/rules/manage/%/add/event','a:1:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:23:\"rules_ui_add_event_page\";i:1;i:6;i:2;s:36:\"admin/commerce/config/checkout/rules\";}','',507,9,0,'','admin/commerce/config/checkout/rules/manage/%/add/event','','rules_get_title','a:2:{i:0;s:32:\"Adding event to !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/checkout/rules/manage/%/autocomplete','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','rules_ui_form_data_selection_auto_completion','a:3:{i:0;i:8;i:1;i:9;i:2;i:10;}','',253,8,0,'','admin/commerce/config/checkout/rules/manage/%/autocomplete','','t','','','a:0:{}',0,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/checkout/rules/manage/%/clone','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:32:\"rules_ui_form_clone_rules_config\";i:1;i:6;i:2;s:36:\"admin/commerce/config/checkout/rules\";}','',253,8,0,'','admin/commerce/config/checkout/rules/manage/%/clone','','rules_get_title','a:2:{i:0;s:24:\"Cloning !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/checkout/rules/manage/%/delete/%','a:2:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}i:8;a:1:{s:18:\"rules_element_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:23:\"rules_ui_delete_element\";i:1;i:6;i:2;i:8;i:3;s:36:\"admin/commerce/config/checkout/rules\";}','',506,9,0,'','admin/commerce/config/checkout/rules/manage/%/delete/%','','rules_get_title','a:2:{i:0;s:24:\"Editing !plugin \"!label\"\";i:1;i:8;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/checkout/rules/manage/%/delete/event','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:21:\"rules_ui_remove_event\";i:1;i:6;i:2;i:9;i:3;s:36:\"admin/commerce/config/checkout/rules\";}','',507,9,0,'','admin/commerce/config/checkout/rules/manage/%/delete/event','Remove event','t','','','a:0:{}',6,'Remove an event from a reaction rule.','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/checkout/rules/manage/%/edit/%','a:2:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}i:8;a:1:{s:18:\"rules_element_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:21:\"rules_ui_edit_element\";i:1;i:6;i:2;i:8;i:3;s:36:\"admin/commerce/config/checkout/rules\";}','',506,9,0,'','admin/commerce/config/checkout/rules/manage/%/edit/%','','rules_get_title','a:2:{i:0;s:24:\"Editing !plugin \"!label\"\";i:1;i:8;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/checkout/rules/manage/%/execute','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:34:\"rules_ui_form_execute_rules_config\";i:1;i:6;i:2;s:36:\"admin/commerce/config/checkout/rules\";}','',253,8,0,'','admin/commerce/config/checkout/rules/manage/%/execute','','rules_get_title','a:2:{i:0;s:26:\"Executing !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/checkout/rules/manage/%/export','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:4:\"view\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:33:\"rules_ui_form_export_rules_config\";i:1;i:6;i:2;s:36:\"admin/commerce/config/checkout/rules\";}','',253,8,0,'','admin/commerce/config/checkout/rules/manage/%/export','','rules_get_title','a:2:{i:0;s:26:\"Export of !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/commerce_search_api','','','commerce_search_api_admin_settings_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:39:\"commerce_search_api_admin_settings_form\";}','',15,4,0,'','admin/commerce/config/commerce_search_api','Commerce Search API','t','','','a:0:{}',6,'Configure the generated product display index.','',0,'sites/all/modules/commerce_search_api/includes/commerce_search_api.admin.inc'),('admin/commerce/config/commerce_store_order','','','user_access','a:1:{i:0;s:39:\"configure commerce store order settings\";}','drupal_get_form','a:1:{i:0;s:28:\"commerce_order_settings_form\";}','',15,4,0,'','admin/commerce/config/commerce_store_order','Commerce Store Order settings','t','','','a:0:{}',6,'Configure general store order settings, fields, and displays.','',0,'sites/all/modules/commerce/modules/order/includes/commerce_order_ui.orders.inc'),('admin/commerce/config/commerce_store_order/display','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:39:\"configure commerce store order settings\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:14:\"commerce_order\";i:2;s:20:\"commerce_store_order\";i:3;s:7:\"default\";}','',31,5,1,'admin/commerce/config/commerce_store_order','admin/commerce/config/commerce_store_order','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/commerce_store_order/display/administrator','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:14:\"commerce_order\";i:1;s:20:\"commerce_store_order\";i:2;s:13:\"administrator\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:39:\"configure commerce store order settings\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:14:\"commerce_order\";i:2;s:20:\"commerce_store_order\";i:3;s:13:\"administrator\";}','',63,6,1,'admin/commerce/config/commerce_store_order/display','admin/commerce/config/commerce_store_order','Administrator','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/commerce_store_order/display/customer','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:14:\"commerce_order\";i:1;s:20:\"commerce_store_order\";i:2;s:8:\"customer\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:39:\"configure commerce store order settings\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:14:\"commerce_order\";i:2;s:20:\"commerce_store_order\";i:3;s:8:\"customer\";}','',63,6,1,'admin/commerce/config/commerce_store_order/display','admin/commerce/config/commerce_store_order','Customer','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/commerce_store_order/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:14:\"commerce_order\";i:1;s:20:\"commerce_store_order\";i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:39:\"configure commerce store order settings\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:14:\"commerce_order\";i:2;s:20:\"commerce_store_order\";i:3;s:7:\"default\";}','',63,6,1,'admin/commerce/config/commerce_store_order/display','admin/commerce/config/commerce_store_order','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/commerce_store_order/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:14:\"commerce_order\";i:1;s:20:\"commerce_store_order\";i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:39:\"configure commerce store order settings\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:14:\"commerce_order\";i:2;s:20:\"commerce_store_order\";i:3;s:5:\"token\";}','',63,6,1,'admin/commerce/config/commerce_store_order/display','admin/commerce/config/commerce_store_order','Tokens','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/commerce_store_order/edit','','','user_access','a:1:{i:0;s:39:\"configure commerce store order settings\";}','drupal_get_form','a:1:{i:0;s:28:\"commerce_order_settings_form\";}','',31,5,1,'admin/commerce/config/commerce_store_order','admin/commerce/config/commerce_store_order','Edit','t','','','a:0:{}',140,'','',0,'sites/all/modules/commerce/modules/order/includes/commerce_order_ui.orders.inc'),('admin/commerce/config/commerce_store_order/fields','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:39:\"configure commerce store order settings\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:14:\"commerce_order\";i:2;s:20:\"commerce_store_order\";}','',31,5,1,'admin/commerce/config/commerce_store_order','admin/commerce/config/commerce_store_order','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/commerce_store_order/fields/%','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:14:\"commerce_order\";i:1;s:20:\"commerce_store_order\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:39:\"configure commerce store order settings\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',62,6,0,'','admin/commerce/config/commerce_store_order/fields/%','','field_ui_menu_title','a:1:{i:0;i:5;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/commerce_store_order/fields/%/delete','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:14:\"commerce_order\";i:1;s:20:\"commerce_store_order\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:39:\"configure commerce store order settings\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:5;}','',125,7,1,'admin/commerce/config/commerce_store_order/fields/%','admin/commerce/config/commerce_store_order/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/commerce_store_order/fields/%/edit','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:14:\"commerce_order\";i:1;s:20:\"commerce_store_order\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:39:\"configure commerce store order settings\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',125,7,1,'admin/commerce/config/commerce_store_order/fields/%','admin/commerce/config/commerce_store_order/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/commerce_store_order/fields/%/field-settings','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:14:\"commerce_order\";i:1;s:20:\"commerce_store_order\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:39:\"configure commerce store order settings\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:5;}','',125,7,1,'admin/commerce/config/commerce_store_order/fields/%','admin/commerce/config/commerce_store_order/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/commerce_store_order/fields/%/widget-type','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:14:\"commerce_order\";i:1;s:20:\"commerce_store_order\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:39:\"configure commerce store order settings\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:5;}','',125,7,1,'admin/commerce/config/commerce_store_order/fields/%','admin/commerce/config/commerce_store_order/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/commerce_store_order/groups/%/delete','a:1:{i:5;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:14:\"commerce_order\";i:1;s:20:\"commerce_store_order\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:39:\"configure commerce store order settings\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:5;}','',125,7,0,'','admin/commerce/config/commerce_store_order/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/config/commerce_store_order/groups/%/enable','a:1:{i:5;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:14:\"commerce_order\";i:1;s:20:\"commerce_store_order\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:39:\"configure commerce store order settings\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:5;}','',125,7,0,'','admin/commerce/config/commerce_store_order/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/config/currency','','','user_access','a:1:{i:0;s:15:\"configure store\";}','drupal_get_form','a:1:{i:0;s:31:\"commerce_currency_settings_form\";}','',15,4,0,'','admin/commerce/config/currency','Currency settings','t','','','a:0:{}',6,'Configure the default currency and display settings.','',0,'sites/all/modules/commerce/includes/commerce_ui.admin.inc'),('admin/commerce/config/custom-offline-payments','','','user_access','a:1:{i:0;s:34:\"administer custom offline payments\";}','commerce_cop_admin_overview','a:0:{}','',15,4,0,'','admin/commerce/config/custom-offline-payments','Custom Offline Payments','t','','','a:0:{}',6,'Manage custom offline payment methods','',3,'sites/all/modules/commerce_cop/commerce_cop.admin.inc'),('admin/commerce/config/custom-offline-payments/%','a:1:{i:4;s:27:\"custom_offline_payment_load\";}','','user_access','a:1:{i:0;s:34:\"administer custom offline payments\";}','drupal_get_form','a:2:{i:0;s:30:\"commerce_cop_edit_payment_form\";i:1;i:4;}','',30,5,0,'','admin/commerce/config/custom-offline-payments/%','Edit payment method','t','','','a:0:{}',6,'','',0,'sites/all/modules/commerce_cop/commerce_cop.admin.inc'),('admin/commerce/config/custom-offline-payments/%/delete','a:1:{i:4;s:27:\"custom_offline_payment_load\";}','','user_access','a:1:{i:0;s:34:\"administer custom offline payments\";}','drupal_get_form','a:2:{i:0;s:32:\"commerce_cop_delete_payment_form\";i:1;i:4;}','',61,6,2,'admin/commerce/config/custom-offline-payments/%','admin/commerce/config/custom-offline-payments/%','Delete','t','','','a:0:{}',132,'','',10,'sites/all/modules/commerce_cop/commerce_cop.admin.inc'),('admin/commerce/config/custom-offline-payments/%/edit','a:1:{i:4;s:27:\"custom_offline_payment_load\";}','','user_access','a:1:{i:0;s:34:\"administer custom offline payments\";}','drupal_get_form','a:2:{i:0;s:30:\"commerce_cop_edit_payment_form\";i:1;i:4;}','',61,6,3,'admin/commerce/config/custom-offline-payments/%','admin/commerce/config/custom-offline-payments/%','Edit','t','','','a:0:{}',140,'','',0,'sites/all/modules/commerce_cop/commerce_cop.admin.inc'),('admin/commerce/config/custom-offline-payments/add','','','user_access','a:1:{i:0;s:34:\"administer custom offline payments\";}','drupal_get_form','a:1:{i:0;s:30:\"commerce_cop_edit_payment_form\";}','',31,5,1,'admin/commerce/config/custom-offline-payments','admin/commerce/config/custom-offline-payments','Add payment method','t','','','a:0:{}',388,'','',0,'sites/all/modules/commerce_cop/commerce_cop.admin.inc'),('admin/commerce/config/line-items','','','user_access','a:1:{i:0;s:26:\"administer line item types\";}','commerce_line_item_ui_types_overview','a:0:{}','',15,4,0,'','admin/commerce/config/line-items','Line item types','t','','','a:0:{}',6,'Manage line item types for your store.','',0,'sites/all/modules/commerce/modules/line_item/includes/commerce_line_item_ui.types.inc'),('admin/commerce/config/line-items/product','','','user_access','a:1:{i:0;s:26:\"administer line item types\";}','commerce_line_item_ui_line_item_type_redirect','a:1:{i:0;s:7:\"product\";}','',31,5,0,'','admin/commerce/config/line-items/product','Product','t','','','a:0:{}',6,'','',0,''),('admin/commerce/config/line-items/product/display','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:26:\"administer line item types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:18:\"commerce_line_item\";i:2;s:7:\"product\";i:3;s:7:\"default\";}','',63,6,3,'admin/commerce/config/line-items/product','admin/commerce/config/line-items/product','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/line-items/product/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:18:\"commerce_line_item\";i:1;s:7:\"product\";i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:26:\"administer line item types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:18:\"commerce_line_item\";i:2;s:7:\"product\";i:3;s:7:\"default\";}','',127,7,1,'admin/commerce/config/line-items/product/display','admin/commerce/config/line-items/product','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/line-items/product/display/display','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:18:\"commerce_line_item\";i:1;s:7:\"product\";i:2;s:7:\"display\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:26:\"administer line item types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:18:\"commerce_line_item\";i:2;s:7:\"product\";i:3;s:7:\"display\";}','',127,7,1,'admin/commerce/config/line-items/product/display','admin/commerce/config/line-items/product','Display','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/line-items/product/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:18:\"commerce_line_item\";i:1;s:7:\"product\";i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:26:\"administer line item types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:18:\"commerce_line_item\";i:2;s:7:\"product\";i:3;s:5:\"token\";}','',127,7,1,'admin/commerce/config/line-items/product/display','admin/commerce/config/line-items/product','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/line-items/product/fields','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:26:\"administer line item types\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:18:\"commerce_line_item\";i:2;s:7:\"product\";}','',63,6,3,'admin/commerce/config/line-items/product','admin/commerce/config/line-items/product','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/line-items/product/fields/%','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:18:\"commerce_line_item\";i:1;s:7:\"product\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:26:\"administer line item types\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}','',126,7,0,'','admin/commerce/config/line-items/product/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/line-items/product/fields/%/delete','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:18:\"commerce_line_item\";i:1;s:7:\"product\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:26:\"administer line item types\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:6;}','',253,8,1,'admin/commerce/config/line-items/product/fields/%','admin/commerce/config/line-items/product/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/line-items/product/fields/%/edit','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:18:\"commerce_line_item\";i:1;s:7:\"product\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:26:\"administer line item types\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}','',253,8,1,'admin/commerce/config/line-items/product/fields/%','admin/commerce/config/line-items/product/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/line-items/product/fields/%/field-settings','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:18:\"commerce_line_item\";i:1;s:7:\"product\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:26:\"administer line item types\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:6;}','',253,8,1,'admin/commerce/config/line-items/product/fields/%','admin/commerce/config/line-items/product/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/line-items/product/fields/%/widget-type','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:18:\"commerce_line_item\";i:1;s:7:\"product\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:26:\"administer line item types\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:6;}','',253,8,1,'admin/commerce/config/line-items/product/fields/%','admin/commerce/config/line-items/product/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/line-items/product/groups/%/delete','a:1:{i:6;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:18:\"commerce_line_item\";i:1;s:7:\"product\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:26:\"administer line item types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:6;}','',253,8,0,'','admin/commerce/config/line-items/product/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/config/line-items/product/groups/%/enable','a:1:{i:6;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:18:\"commerce_line_item\";i:1;s:7:\"product\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:26:\"administer line item types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:6;}','',253,8,0,'','admin/commerce/config/line-items/product/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/config/line-items/shipping','','','user_access','a:1:{i:0;s:26:\"administer line item types\";}','commerce_line_item_ui_line_item_type_redirect','a:1:{i:0;s:8:\"shipping\";}','',31,5,0,'','admin/commerce/config/line-items/shipping','Shipping','t','','','a:0:{}',6,'','',0,''),('admin/commerce/config/line-items/shipping/display','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:26:\"administer line item types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:18:\"commerce_line_item\";i:2;s:8:\"shipping\";i:3;s:7:\"default\";}','',63,6,3,'admin/commerce/config/line-items/shipping','admin/commerce/config/line-items/shipping','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/line-items/shipping/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:18:\"commerce_line_item\";i:1;s:8:\"shipping\";i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:26:\"administer line item types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:18:\"commerce_line_item\";i:2;s:8:\"shipping\";i:3;s:7:\"default\";}','',127,7,1,'admin/commerce/config/line-items/shipping/display','admin/commerce/config/line-items/shipping','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/line-items/shipping/display/display','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:18:\"commerce_line_item\";i:1;s:8:\"shipping\";i:2;s:7:\"display\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:26:\"administer line item types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:18:\"commerce_line_item\";i:2;s:8:\"shipping\";i:3;s:7:\"display\";}','',127,7,1,'admin/commerce/config/line-items/shipping/display','admin/commerce/config/line-items/shipping','Display','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/line-items/shipping/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:18:\"commerce_line_item\";i:1;s:8:\"shipping\";i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:26:\"administer line item types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:18:\"commerce_line_item\";i:2;s:8:\"shipping\";i:3;s:5:\"token\";}','',127,7,1,'admin/commerce/config/line-items/shipping/display','admin/commerce/config/line-items/shipping','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/line-items/shipping/fields','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:26:\"administer line item types\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:18:\"commerce_line_item\";i:2;s:8:\"shipping\";}','',63,6,3,'admin/commerce/config/line-items/shipping','admin/commerce/config/line-items/shipping','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/line-items/shipping/fields/%','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:18:\"commerce_line_item\";i:1;s:8:\"shipping\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:26:\"administer line item types\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}','',126,7,0,'','admin/commerce/config/line-items/shipping/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/line-items/shipping/fields/%/delete','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:18:\"commerce_line_item\";i:1;s:8:\"shipping\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:26:\"administer line item types\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:6;}','',253,8,1,'admin/commerce/config/line-items/shipping/fields/%','admin/commerce/config/line-items/shipping/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/line-items/shipping/fields/%/edit','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:18:\"commerce_line_item\";i:1;s:8:\"shipping\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:26:\"administer line item types\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}','',253,8,1,'admin/commerce/config/line-items/shipping/fields/%','admin/commerce/config/line-items/shipping/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/line-items/shipping/fields/%/field-settings','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:18:\"commerce_line_item\";i:1;s:8:\"shipping\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:26:\"administer line item types\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:6;}','',253,8,1,'admin/commerce/config/line-items/shipping/fields/%','admin/commerce/config/line-items/shipping/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/line-items/shipping/fields/%/widget-type','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:18:\"commerce_line_item\";i:1;s:8:\"shipping\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:26:\"administer line item types\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:6;}','',253,8,1,'admin/commerce/config/line-items/shipping/fields/%','admin/commerce/config/line-items/shipping/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/line-items/shipping/groups/%/delete','a:1:{i:6;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:18:\"commerce_line_item\";i:1;s:8:\"shipping\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:26:\"administer line item types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:6;}','',253,8,0,'','admin/commerce/config/line-items/shipping/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/config/line-items/shipping/groups/%/enable','a:1:{i:6;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:18:\"commerce_line_item\";i:1;s:8:\"shipping\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:26:\"administer line item types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:6;}','',253,8,0,'','admin/commerce/config/line-items/shipping/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/config/order','','','user_access','a:1:{i:0;s:24:\"configure order settings\";}','drupal_get_form','a:1:{i:0;s:28:\"commerce_order_settings_form\";}','',15,4,0,'','admin/commerce/config/order','Order settings','t','','','a:0:{}',6,'Configure general order settings, fields, and displays.','',0,'sites/all/modules/commerce/modules/order/includes/commerce_order_ui.orders.inc'),('admin/commerce/config/order/display','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"configure order settings\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:14:\"commerce_order\";i:2;s:14:\"commerce_order\";i:3;s:7:\"default\";}','',31,5,1,'admin/commerce/config/order','admin/commerce/config/order','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/order/display/administrator','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:14:\"commerce_order\";i:1;s:14:\"commerce_order\";i:2;s:13:\"administrator\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"configure order settings\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:14:\"commerce_order\";i:2;s:14:\"commerce_order\";i:3;s:13:\"administrator\";}','',63,6,1,'admin/commerce/config/order/display','admin/commerce/config/order','Administrator','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/order/display/customer','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:14:\"commerce_order\";i:1;s:14:\"commerce_order\";i:2;s:8:\"customer\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"configure order settings\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:14:\"commerce_order\";i:2;s:14:\"commerce_order\";i:3;s:8:\"customer\";}','',63,6,1,'admin/commerce/config/order/display','admin/commerce/config/order','Customer','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/order/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:14:\"commerce_order\";i:1;s:14:\"commerce_order\";i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"configure order settings\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:14:\"commerce_order\";i:2;s:14:\"commerce_order\";i:3;s:7:\"default\";}','',63,6,1,'admin/commerce/config/order/display','admin/commerce/config/order','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/order/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:14:\"commerce_order\";i:1;s:14:\"commerce_order\";i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"configure order settings\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:14:\"commerce_order\";i:2;s:14:\"commerce_order\";i:3;s:5:\"token\";}','',63,6,1,'admin/commerce/config/order/display','admin/commerce/config/order','Tokens','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/order/fields','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"configure order settings\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:14:\"commerce_order\";i:2;s:14:\"commerce_order\";}','',31,5,1,'admin/commerce/config/order','admin/commerce/config/order','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/order/fields/%','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:14:\"commerce_order\";i:1;s:14:\"commerce_order\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"configure order settings\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',62,6,0,'','admin/commerce/config/order/fields/%','','field_ui_menu_title','a:1:{i:0;i:5;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/order/fields/%/delete','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:14:\"commerce_order\";i:1;s:14:\"commerce_order\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"configure order settings\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:5;}','',125,7,1,'admin/commerce/config/order/fields/%','admin/commerce/config/order/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/order/fields/%/edit','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:14:\"commerce_order\";i:1;s:14:\"commerce_order\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"configure order settings\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',125,7,1,'admin/commerce/config/order/fields/%','admin/commerce/config/order/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/order/fields/%/field-settings','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:14:\"commerce_order\";i:1;s:14:\"commerce_order\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"configure order settings\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:5;}','',125,7,1,'admin/commerce/config/order/fields/%','admin/commerce/config/order/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/order/fields/%/widget-type','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:14:\"commerce_order\";i:1;s:14:\"commerce_order\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"configure order settings\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:5;}','',125,7,1,'admin/commerce/config/order/fields/%','admin/commerce/config/order/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/config/order/groups/%/delete','a:1:{i:5;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:14:\"commerce_order\";i:1;s:14:\"commerce_order\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"configure order settings\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:5;}','',125,7,0,'','admin/commerce/config/order/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/config/order/groups/%/enable','a:1:{i:5;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:14:\"commerce_order\";i:1;s:14:\"commerce_order\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"configure order settings\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:5;}','',125,7,0,'','admin/commerce/config/order/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/config/order/settings','','','user_access','a:1:{i:0;s:24:\"configure order settings\";}','drupal_get_form','a:1:{i:0;s:28:\"commerce_order_settings_form\";}','',31,5,1,'admin/commerce/config/order','admin/commerce/config/order','Settings','t','','','a:0:{}',140,'','',-10,'sites/all/modules/commerce/modules/order/includes/commerce_order_ui.orders.inc'),('admin/commerce/config/payment-methods','','','user_access','a:1:{i:0;s:26:\"administer payment methods\";}','commerce_payment_ui_admin_page','a:0:{}','',15,4,0,'','admin/commerce/config/payment-methods','Payment methods','t','','','a:0:{}',6,'Enable and configure payment method rule configurations.','',0,'sites/all/modules/commerce/modules/payment/includes/commerce_payment_ui.admin.inc'),('admin/commerce/config/payment-methods/add','','','user_access','a:1:{i:0;s:26:\"administer payment methods\";}','drupal_get_form','a:2:{i:0;s:41:\"commerce_payment_ui_add_payment_rule_form\";i:1;s:37:\"admin/commerce/config/payment-methods\";}','',31,5,0,'','admin/commerce/config/payment-methods/add','Add a payment method rule','t','','','a:0:{}',6,'Adds an additional payment method rule configuration.','',0,'sites/all/modules/rules/rules_admin/rules_admin.inc'),('admin/commerce/config/payment-methods/manage/%','a:1:{i:5;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:5;}','drupal_get_form','a:3:{i:0;s:31:\"rules_ui_form_edit_rules_config\";i:1;i:5;i:2;s:37:\"admin/commerce/config/payment-methods\";}','',62,6,0,'','admin/commerce/config/payment-methods/manage/%','','rules_get_title','a:2:{i:0;s:24:\"Editing !plugin \"!label\"\";i:1;i:5;}','','a:0:{}',4,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/payment-methods/manage/%/%','a:2:{i:5;s:17:\"rules_config_load\";i:6;N;}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:5;}','drupal_get_form','a:4:{i:0;s:37:\"rules_ui_form_rules_config_confirm_op\";i:1;i:5;i:2;i:6;i:3;s:37:\"admin/commerce/config/payment-methods\";}','',124,7,0,'','admin/commerce/config/payment-methods/manage/%/%','','t','','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/payment-methods/manage/%/add/%','a:2:{i:5;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:5;}}i:7;a:1:{s:18:\"rules_element_load\";a:1:{i:0;i:5;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:5;}','drupal_get_form','a:5:{i:0;s:20:\"rules_ui_add_element\";i:1;i:5;i:2;i:8;i:3;i:7;i:4;s:37:\"admin/commerce/config/payment-methods\";}','',250,8,0,'','admin/commerce/config/payment-methods/manage/%/add/%','','rules_menu_add_element_title','a:1:{i:0;a:1:{i:0;i:8;}}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/payment-methods/manage/%/add/event','a:1:{i:5;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:5;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:5;}','drupal_get_form','a:3:{i:0;s:23:\"rules_ui_add_event_page\";i:1;i:5;i:2;s:37:\"admin/commerce/config/payment-methods\";}','',251,8,0,'','admin/commerce/config/payment-methods/manage/%/add/event','','rules_get_title','a:2:{i:0;s:32:\"Adding event to !plugin \"!label\"\";i:1;i:5;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/payment-methods/manage/%/autocomplete','a:1:{i:5;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:5;}','rules_ui_form_data_selection_auto_completion','a:3:{i:0;i:7;i:1;i:8;i:2;i:9;}','',125,7,0,'','admin/commerce/config/payment-methods/manage/%/autocomplete','','t','','','a:0:{}',0,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/payment-methods/manage/%/clone','a:1:{i:5;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:5;}','drupal_get_form','a:3:{i:0;s:32:\"rules_ui_form_clone_rules_config\";i:1;i:5;i:2;s:37:\"admin/commerce/config/payment-methods\";}','',125,7,0,'','admin/commerce/config/payment-methods/manage/%/clone','','rules_get_title','a:2:{i:0;s:24:\"Cloning !plugin \"!label\"\";i:1;i:5;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/payment-methods/manage/%/delete/%','a:2:{i:5;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:5;}}i:7;a:1:{s:18:\"rules_element_load\";a:1:{i:0;i:5;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:5;}','drupal_get_form','a:4:{i:0;s:23:\"rules_ui_delete_element\";i:1;i:5;i:2;i:7;i:3;s:37:\"admin/commerce/config/payment-methods\";}','',250,8,0,'','admin/commerce/config/payment-methods/manage/%/delete/%','','rules_get_title','a:2:{i:0;s:24:\"Editing !plugin \"!label\"\";i:1;i:7;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/payment-methods/manage/%/delete/event','a:1:{i:5;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:5;}','drupal_get_form','a:4:{i:0;s:21:\"rules_ui_remove_event\";i:1;i:5;i:2;i:8;i:3;s:37:\"admin/commerce/config/payment-methods\";}','',251,8,0,'','admin/commerce/config/payment-methods/manage/%/delete/event','Remove event','t','','','a:0:{}',6,'Remove an event from a reaction rule.','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/payment-methods/manage/%/edit/%','a:2:{i:5;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:5;}}i:7;a:1:{s:18:\"rules_element_load\";a:1:{i:0;i:5;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:5;}','drupal_get_form','a:4:{i:0;s:21:\"rules_ui_edit_element\";i:1;i:5;i:2;i:7;i:3;s:37:\"admin/commerce/config/payment-methods\";}','',250,8,0,'','admin/commerce/config/payment-methods/manage/%/edit/%','','rules_get_title','a:2:{i:0;s:24:\"Editing !plugin \"!label\"\";i:1;i:7;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/payment-methods/manage/%/execute','a:1:{i:5;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:5;}','drupal_get_form','a:3:{i:0;s:34:\"rules_ui_form_execute_rules_config\";i:1;i:5;i:2;s:37:\"admin/commerce/config/payment-methods\";}','',125,7,0,'','admin/commerce/config/payment-methods/manage/%/execute','','rules_get_title','a:2:{i:0;s:26:\"Executing !plugin \"!label\"\";i:1;i:5;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/payment-methods/manage/%/export','a:1:{i:5;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:4:\"view\";i:1;i:5;}','drupal_get_form','a:3:{i:0;s:33:\"rules_ui_form_export_rules_config\";i:1;i:5;i:2;s:37:\"admin/commerce/config/payment-methods\";}','',125,7,0,'','admin/commerce/config/payment-methods/manage/%/export','','rules_get_title','a:2:{i:0;s:26:\"Export of !plugin \"!label\"\";i:1;i:5;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/product-pricing','','','user_access','a:1:{i:0;s:26:\"administer product pricing\";}','commerce_product_pricing_ui_sell_price_rules','a:0:{}','',15,4,0,'','admin/commerce/config/product-pricing','Product pricing rules','t','','','a:0:{}',6,'Enable and configure product pricing rules and pre-calculation.','',0,'sites/all/modules/commerce/modules/product_pricing/includes/commerce_product_pricing_ui.admin.inc'),('admin/commerce/config/product-pricing/pre-calculation','','','user_access','a:1:{i:0;s:26:\"administer product pricing\";}','drupal_get_form','a:1:{i:0;s:46:\"commerce_product_pre_calculation_settings_form\";}','',31,5,1,'admin/commerce/config/product-pricing','admin/commerce/config/product-pricing','Pre-calculation','t','','','a:0:{}',132,'Configure the price pre-calculation settings.','',5,'sites/all/modules/commerce/modules/product_pricing/includes/commerce_product_pricing_ui.admin.inc'),('admin/commerce/config/product-pricing/rules','','','user_access','a:1:{i:0;s:26:\"administer product pricing\";}','commerce_product_pricing_ui_sell_price_rules','a:0:{}','',31,5,1,'admin/commerce/config/product-pricing','admin/commerce/config/product-pricing','List','t','','','a:0:{}',140,'Administer the rules used for calculating product sell prices.','',0,'sites/all/modules/commerce/modules/product_pricing/includes/commerce_product_pricing_ui.admin.inc'),('admin/commerce/config/product-pricing/rules/add','','','user_access','a:1:{i:0;s:26:\"administer product pricing\";}','drupal_get_form','a:2:{i:0;s:49:\"commerce_product_pricing_ui_add_pricing_rule_form\";i:1;s:43:\"admin/commerce/config/product-pricing/rules\";}','',63,6,0,'','admin/commerce/config/product-pricing/rules/add','Add a pricing rule','t','','','a:0:{}',6,'Adds an additional sell price calculation rule configuration.','',0,'sites/all/modules/rules/rules_admin/rules_admin.inc'),('admin/commerce/config/product-pricing/rules/manage/%','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:31:\"rules_ui_form_edit_rules_config\";i:1;i:6;i:2;s:43:\"admin/commerce/config/product-pricing/rules\";}','',126,7,0,'','admin/commerce/config/product-pricing/rules/manage/%','','rules_get_title','a:2:{i:0;s:24:\"Editing !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',4,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/product-pricing/rules/manage/%/%','a:2:{i:6;s:17:\"rules_config_load\";i:7;N;}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:37:\"rules_ui_form_rules_config_confirm_op\";i:1;i:6;i:2;i:7;i:3;s:43:\"admin/commerce/config/product-pricing/rules\";}','',252,8,0,'','admin/commerce/config/product-pricing/rules/manage/%/%','','t','','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/product-pricing/rules/manage/%/add/%','a:2:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}i:8;a:1:{s:18:\"rules_element_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:5:{i:0;s:20:\"rules_ui_add_element\";i:1;i:6;i:2;i:9;i:3;i:8;i:4;s:43:\"admin/commerce/config/product-pricing/rules\";}','',506,9,0,'','admin/commerce/config/product-pricing/rules/manage/%/add/%','','rules_menu_add_element_title','a:1:{i:0;a:1:{i:0;i:9;}}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/product-pricing/rules/manage/%/add/event','a:1:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:23:\"rules_ui_add_event_page\";i:1;i:6;i:2;s:43:\"admin/commerce/config/product-pricing/rules\";}','',507,9,0,'','admin/commerce/config/product-pricing/rules/manage/%/add/event','','rules_get_title','a:2:{i:0;s:32:\"Adding event to !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/product-pricing/rules/manage/%/autocomplete','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','rules_ui_form_data_selection_auto_completion','a:3:{i:0;i:8;i:1;i:9;i:2;i:10;}','',253,8,0,'','admin/commerce/config/product-pricing/rules/manage/%/autocomplete','','t','','','a:0:{}',0,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/product-pricing/rules/manage/%/clone','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:32:\"rules_ui_form_clone_rules_config\";i:1;i:6;i:2;s:43:\"admin/commerce/config/product-pricing/rules\";}','',253,8,0,'','admin/commerce/config/product-pricing/rules/manage/%/clone','','rules_get_title','a:2:{i:0;s:24:\"Cloning !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/product-pricing/rules/manage/%/delete/%','a:2:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}i:8;a:1:{s:18:\"rules_element_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:23:\"rules_ui_delete_element\";i:1;i:6;i:2;i:8;i:3;s:43:\"admin/commerce/config/product-pricing/rules\";}','',506,9,0,'','admin/commerce/config/product-pricing/rules/manage/%/delete/%','','rules_get_title','a:2:{i:0;s:24:\"Editing !plugin \"!label\"\";i:1;i:8;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/product-pricing/rules/manage/%/delete/event','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:21:\"rules_ui_remove_event\";i:1;i:6;i:2;i:9;i:3;s:43:\"admin/commerce/config/product-pricing/rules\";}','',507,9,0,'','admin/commerce/config/product-pricing/rules/manage/%/delete/event','Remove event','t','','','a:0:{}',6,'Remove an event from a reaction rule.','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/product-pricing/rules/manage/%/edit/%','a:2:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}i:8;a:1:{s:18:\"rules_element_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:21:\"rules_ui_edit_element\";i:1;i:6;i:2;i:8;i:3;s:43:\"admin/commerce/config/product-pricing/rules\";}','',506,9,0,'','admin/commerce/config/product-pricing/rules/manage/%/edit/%','','rules_get_title','a:2:{i:0;s:24:\"Editing !plugin \"!label\"\";i:1;i:8;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/product-pricing/rules/manage/%/execute','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:34:\"rules_ui_form_execute_rules_config\";i:1;i:6;i:2;s:43:\"admin/commerce/config/product-pricing/rules\";}','',253,8,0,'','admin/commerce/config/product-pricing/rules/manage/%/execute','','rules_get_title','a:2:{i:0;s:26:\"Executing !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/product-pricing/rules/manage/%/export','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:4:\"view\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:33:\"rules_ui_form_export_rules_config\";i:1;i:6;i:2;s:43:\"admin/commerce/config/product-pricing/rules\";}','',253,8,0,'','admin/commerce/config/product-pricing/rules/manage/%/export','','rules_get_title','a:2:{i:0;s:26:\"Export of !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/shipping','','','user_access','a:1:{i:0;s:19:\"administer shipping\";}','commerce_shipping_ui_overview','a:2:{i:0;s:8:\"services\";i:1;s:9:\"flat_rate\";}','',15,4,0,'','admin/commerce/config/shipping','Shipping','t','','','a:0:{}',6,'Manage shipping methods and services.','',0,'sites/all/modules/commerce_shipping/includes/commerce_shipping_ui.admin.inc'),('admin/commerce/config/shipping/calculation-rules','','','user_access','a:1:{i:0;s:19:\"administer shipping\";}','commerce_shipping_ui_rate_calculation_rules','a:0:{}','',31,5,1,'admin/commerce/config/shipping','admin/commerce/config/shipping','Calculation rules','t','','','a:0:{}',132,'Add and configure your shipping rate calculation rules.','',10,'sites/all/modules/commerce_shipping/includes/commerce_shipping_ui.admin.inc'),('admin/commerce/config/shipping/calculation-rules/add','','','user_access','a:1:{i:0;s:19:\"administer shipping\";}','drupal_get_form','a:2:{i:0;s:46:\"commerce_shipping_ui_add_calculation_rule_form\";i:1;s:48:\"admin/commerce/config/shipping/calculation-rules\";}','',63,6,0,'','admin/commerce/config/shipping/calculation-rules/add','Add a calculation rule','t','','','a:0:{}',6,'Adds an additional shipping rate calculation rule configuration.','',0,'sites/all/modules/rules/rules_admin/rules_admin.inc'),('admin/commerce/config/shipping/calculation-rules/manage/%','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:31:\"rules_ui_form_edit_rules_config\";i:1;i:6;i:2;s:48:\"admin/commerce/config/shipping/calculation-rules\";}','',126,7,0,'','admin/commerce/config/shipping/calculation-rules/manage/%','','rules_get_title','a:2:{i:0;s:24:\"Editing !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',4,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/shipping/calculation-rules/manage/%/%','a:2:{i:6;s:17:\"rules_config_load\";i:7;N;}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:37:\"rules_ui_form_rules_config_confirm_op\";i:1;i:6;i:2;i:7;i:3;s:48:\"admin/commerce/config/shipping/calculation-rules\";}','',252,8,0,'','admin/commerce/config/shipping/calculation-rules/manage/%/%','','t','','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/shipping/calculation-rules/manage/%/add/%','a:2:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}i:8;a:1:{s:18:\"rules_element_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:5:{i:0;s:20:\"rules_ui_add_element\";i:1;i:6;i:2;i:9;i:3;i:8;i:4;s:48:\"admin/commerce/config/shipping/calculation-rules\";}','',506,9,0,'','admin/commerce/config/shipping/calculation-rules/manage/%/add/%','','rules_menu_add_element_title','a:1:{i:0;a:1:{i:0;i:9;}}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/shipping/calculation-rules/manage/%/add/event','a:1:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:23:\"rules_ui_add_event_page\";i:1;i:6;i:2;s:48:\"admin/commerce/config/shipping/calculation-rules\";}','',507,9,0,'','admin/commerce/config/shipping/calculation-rules/manage/%/add/event','','rules_get_title','a:2:{i:0;s:32:\"Adding event to !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/shipping/calculation-rules/manage/%/autocomplete','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','rules_ui_form_data_selection_auto_completion','a:3:{i:0;i:8;i:1;i:9;i:2;i:10;}','',253,8,0,'','admin/commerce/config/shipping/calculation-rules/manage/%/autocomplete','','t','','','a:0:{}',0,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/shipping/calculation-rules/manage/%/clone','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:32:\"rules_ui_form_clone_rules_config\";i:1;i:6;i:2;s:48:\"admin/commerce/config/shipping/calculation-rules\";}','',253,8,0,'','admin/commerce/config/shipping/calculation-rules/manage/%/clone','','rules_get_title','a:2:{i:0;s:24:\"Cloning !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/shipping/calculation-rules/manage/%/delete/%','a:2:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}i:8;a:1:{s:18:\"rules_element_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:23:\"rules_ui_delete_element\";i:1;i:6;i:2;i:8;i:3;s:48:\"admin/commerce/config/shipping/calculation-rules\";}','',506,9,0,'','admin/commerce/config/shipping/calculation-rules/manage/%/delete/%','','rules_get_title','a:2:{i:0;s:24:\"Editing !plugin \"!label\"\";i:1;i:8;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/shipping/calculation-rules/manage/%/delete/event','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:21:\"rules_ui_remove_event\";i:1;i:6;i:2;i:9;i:3;s:48:\"admin/commerce/config/shipping/calculation-rules\";}','',507,9,0,'','admin/commerce/config/shipping/calculation-rules/manage/%/delete/event','Remove event','t','','','a:0:{}',6,'Remove an event from a reaction rule.','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/shipping/calculation-rules/manage/%/edit/%','a:2:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}i:8;a:1:{s:18:\"rules_element_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:21:\"rules_ui_edit_element\";i:1;i:6;i:2;i:8;i:3;s:48:\"admin/commerce/config/shipping/calculation-rules\";}','',506,9,0,'','admin/commerce/config/shipping/calculation-rules/manage/%/edit/%','','rules_get_title','a:2:{i:0;s:24:\"Editing !plugin \"!label\"\";i:1;i:8;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/shipping/calculation-rules/manage/%/execute','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:34:\"rules_ui_form_execute_rules_config\";i:1;i:6;i:2;s:48:\"admin/commerce/config/shipping/calculation-rules\";}','',253,8,0,'','admin/commerce/config/shipping/calculation-rules/manage/%/execute','','rules_get_title','a:2:{i:0;s:26:\"Executing !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/shipping/calculation-rules/manage/%/export','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:4:\"view\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:33:\"rules_ui_form_export_rules_config\";i:1;i:6;i:2;s:48:\"admin/commerce/config/shipping/calculation-rules\";}','',253,8,0,'','admin/commerce/config/shipping/calculation-rules/manage/%/export','','rules_get_title','a:2:{i:0;s:26:\"Export of !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/shipping/methods','','','user_access','a:1:{i:0;s:19:\"administer shipping\";}','commerce_shipping_ui_overview','a:1:{i:0;s:7:\"methods\";}','',31,5,1,'admin/commerce/config/shipping','admin/commerce/config/shipping','Shipping methods','t','','','a:0:{}',132,'Manage shipping methods.','',5,'sites/all/modules/commerce_shipping/includes/commerce_shipping_ui.admin.inc'),('admin/commerce/config/shipping/methods/flat-rate','','','user_access','a:1:{i:0;s:19:\"administer shipping\";}','drupal_goto','a:1:{i:0;s:38:\"admin/commerce/config/shipping/methods\";}','',63,6,0,'','admin/commerce/config/shipping/methods/flat-rate','','commerce_shipping_method_get_title','a:1:{i:0;s:9:\"flat_rate\";}','','a:0:{}',6,'Redirect to the shipping method list.','',0,''),('admin/commerce/config/shipping/methods/flat-rate/add','','','commerce_flat_rate_service_access','a:1:{i:0;s:6:\"create\";}','drupal_goto','a:1:{i:0;s:53:\"admin/commerce/config/shipping/services/flat-rate/add\";}','',127,7,2,'admin/commerce/config/shipping/methods/flat-rate','admin/commerce/config/shipping/methods/flat-rate','Add a flat rate service','t','','','a:0:{}',132,'Create a new flat rate shipping service, including a title and base shipping rate.','',8,''),('admin/commerce/config/shipping/methods/flat-rate/rule','','','user_access','a:1:{i:0;s:16:\"administer rules\";}','drupal_goto','a:1:{i:0;s:78:\"admin/config/workflow/rules/reaction/manage/commerce_shipping_method_flat_rate\";}','',127,7,2,'admin/commerce/config/shipping/methods/flat-rate','admin/commerce/config/shipping/methods/flat-rate','Configure rule','t','','','a:0:{}',132,'Add conditions to the rule used to collect rates for this shipping method.','',5,''),('admin/commerce/config/shipping/methods/flat-rate/services','','','user_access','a:1:{i:0;s:19:\"administer shipping\";}','drupal_goto','a:1:{i:0;s:49:\"admin/commerce/config/shipping/services/flat-rate\";}','',127,7,2,'admin/commerce/config/shipping/methods/flat-rate','admin/commerce/config/shipping/methods/flat-rate','View services','t','','','a:0:{}',132,'View the table of services defined for this shipping method.','',10,''),('admin/commerce/config/shipping/services','','','user_access','a:1:{i:0;s:19:\"administer shipping\";}','commerce_shipping_ui_overview','a:2:{i:0;s:8:\"services\";i:1;s:9:\"flat_rate\";}','',31,5,1,'admin/commerce/config/shipping','admin/commerce/config/shipping','Shipping services','t','','','a:0:{}',140,'Manage shipping services.','',0,'sites/all/modules/commerce_shipping/includes/commerce_shipping_ui.admin.inc'),('admin/commerce/config/shipping/services/flat-rate','','','user_access','a:1:{i:0;s:19:\"administer shipping\";}','commerce_shipping_ui_overview','a:2:{i:0;s:8:\"services\";i:1;s:9:\"flat_rate\";}','',63,6,1,'admin/commerce/config/shipping/services','admin/commerce/config/shipping','Flat rate','t','','','a:0:{}',140,'Manage shipping services for this shipping method.','',0,'sites/all/modules/commerce_shipping/includes/commerce_shipping_ui.admin.inc'),('admin/commerce/config/shipping/services/flat-rate-free-shipping','','','user_access','a:1:{i:0;s:19:\"administer shipping\";}','drupal_goto','a:1:{i:0;s:49:\"admin/commerce/config/shipping/services/flat-rate\";}','',63,6,0,'','admin/commerce/config/shipping/services/flat-rate-free-shipping','','commerce_shipping_service_get_title','a:1:{i:0;s:13:\"free_shipping\";}','','a:0:{}',6,'Redirect to the shipping service list.','',0,''),('admin/commerce/config/shipping/services/flat-rate-free-shipping/component','','','user_access','a:1:{i:0;s:16:\"administer rules\";}','drupal_goto','a:1:{i:0;s:85:\"admin/config/workflow/rules/components/manage/commerce_shipping_service_free_shipping\";}','',127,7,2,'admin/commerce/config/shipping/services/flat-rate-free-shipping','admin/commerce/config/shipping/services/flat-rate-free-shipping','Configure component','t','','','a:0:{}',132,'Add conditions to the Rules component used to rate orders for this service.','',5,''),('admin/commerce/config/shipping/services/flat-rate-free-shipping/delete','','','commerce_flat_rate_service_access','a:1:{i:0;s:6:\"delete\";}','commerce_flat_rate_service_delete_page','a:1:{i:0;s:13:\"free_shipping\";}','',127,7,2,'admin/commerce/config/shipping/services/flat-rate-free-shipping','admin/commerce/config/shipping/services/flat-rate-free-shipping','Delete','t','','','a:0:{}',132,'Delete the flat rate service.','',10,'sites/all/modules/commerce_flat_rate/includes/commerce_flat_rate.admin.inc'),('admin/commerce/config/shipping/services/flat-rate-free-shipping/edit','','','commerce_flat_rate_service_access','a:1:{i:0;s:6:\"update\";}','commerce_flat_rate_service_edit_page','a:1:{i:0;s:13:\"free_shipping\";}','',127,7,2,'admin/commerce/config/shipping/services/flat-rate-free-shipping','admin/commerce/config/shipping/services/flat-rate-free-shipping','Edit','t','','','a:0:{}',132,'Edit the flat rate service.','',0,'sites/all/modules/commerce_flat_rate/includes/commerce_flat_rate.admin.inc'),('admin/commerce/config/shipping/services/flat-rate-shipping','','','user_access','a:1:{i:0;s:19:\"administer shipping\";}','drupal_goto','a:1:{i:0;s:49:\"admin/commerce/config/shipping/services/flat-rate\";}','',63,6,0,'','admin/commerce/config/shipping/services/flat-rate-shipping','','commerce_shipping_service_get_title','a:1:{i:0;s:8:\"shipping\";}','','a:0:{}',6,'Redirect to the shipping service list.','',0,''),('admin/commerce/config/shipping/services/flat-rate-shipping/component','','','user_access','a:1:{i:0;s:16:\"administer rules\";}','drupal_goto','a:1:{i:0;s:80:\"admin/config/workflow/rules/components/manage/commerce_shipping_service_shipping\";}','',127,7,2,'admin/commerce/config/shipping/services/flat-rate-shipping','admin/commerce/config/shipping/services/flat-rate-shipping','Configure component','t','','','a:0:{}',132,'Add conditions to the Rules component used to rate orders for this service.','',5,''),('admin/commerce/config/shipping/services/flat-rate-shipping/delete','','','commerce_flat_rate_service_access','a:1:{i:0;s:6:\"delete\";}','commerce_flat_rate_service_delete_page','a:1:{i:0;s:8:\"shipping\";}','',127,7,2,'admin/commerce/config/shipping/services/flat-rate-shipping','admin/commerce/config/shipping/services/flat-rate-shipping','Delete','t','','','a:0:{}',132,'Delete the flat rate service.','',10,'sites/all/modules/commerce_flat_rate/includes/commerce_flat_rate.admin.inc'),('admin/commerce/config/shipping/services/flat-rate-shipping/edit','','','commerce_flat_rate_service_access','a:1:{i:0;s:6:\"update\";}','commerce_flat_rate_service_edit_page','a:1:{i:0;s:8:\"shipping\";}','',127,7,2,'admin/commerce/config/shipping/services/flat-rate-shipping','admin/commerce/config/shipping/services/flat-rate-shipping','Edit','t','','','a:0:{}',132,'Edit the flat rate service.','',0,'sites/all/modules/commerce_flat_rate/includes/commerce_flat_rate.admin.inc'),('admin/commerce/config/shipping/services/flat-rate/add','','','commerce_flat_rate_service_access','a:1:{i:0;s:6:\"create\";}','drupal_get_form','a:2:{i:0;s:31:\"commerce_flat_rate_service_form\";i:1;a:8:{s:4:\"name\";s:0:\"\";s:5:\"title\";s:0:\"\";s:13:\"display_title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:15:\"rules_component\";b:1;s:9:\"base_rate\";a:3:{s:6:\"amount\";i:0;s:13:\"currency_code\";s:3:\"USD\";s:4:\"data\";a:0:{}}s:4:\"data\";a:0:{}s:6:\"is_new\";b:1;}}','',127,7,1,'admin/commerce/config/shipping/services/flat-rate','admin/commerce/config/shipping','Add a flat rate service','t','','','a:0:{}',388,'Create a new flat rate shipping service, including a title and base shipping rate.','',0,'sites/all/modules/commerce_flat_rate/includes/commerce_flat_rate.admin.inc'),('admin/commerce/config/stock','','','user_access','a:1:{i:0;s:34:\"administer commerce_stock settings\";}','drupal_get_form','a:1:{i:0;s:25:\"commerce_stock_admin_form\";}','',15,4,0,'','admin/commerce/config/stock','Stock management','t','','','a:0:{}',6,'Configure stock management.','',0,'sites/all/modules/commerce_stock/includes/commerce_stock.admin.inc'),('admin/commerce/config/stock/api','','','user_access','a:1:{i:0;s:34:\"administer commerce_stock settings\";}','drupal_get_form','a:1:{i:0;s:25:\"commerce_stock_admin_form\";}','',31,5,1,'admin/commerce/config/stock','admin/commerce/config/stock','Stock management API','t','','','a:0:{}',140,'Configure stock management API.','',-10,'sites/all/modules/commerce_stock/includes/commerce_stock.admin.inc'),('admin/commerce/config/stock/control','','','user_access','a:1:{i:0;s:16:\"administer rules\";}','commerce_stock_admin_stock_control_ruless','a:0:{}','',31,5,1,'admin/commerce/config/stock','admin/commerce/config/stock','Stock control','t','','','a:0:{}',132,'Manage and configure stock control rules.','',6,'sites/all/modules/commerce_stock/includes/commerce_stock.admin.inc'),('admin/commerce/config/stock/control/add','','','user_access','a:1:{i:0;s:16:\"administer rules\";}','drupal_get_form','a:2:{i:0;s:41:\"commerce_stock_ui_stock_control_rule_form\";i:1;s:35:\"admin/commerce/config/stock/control\";}','',63,6,0,'','admin/commerce/config/stock/control/add','Create a stock control rule','t','','','a:0:{}',6,'Add a new stock control rule','',0,'sites/all/modules/rules/rules_admin/rules_admin.inc'),('admin/commerce/config/stock/control/manage/%','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:31:\"rules_ui_form_edit_rules_config\";i:1;i:6;i:2;s:35:\"admin/commerce/config/stock/control\";}','',126,7,0,'','admin/commerce/config/stock/control/manage/%','','rules_get_title','a:2:{i:0;s:24:\"Editing !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',4,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/stock/control/manage/%/%','a:2:{i:6;s:17:\"rules_config_load\";i:7;N;}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:37:\"rules_ui_form_rules_config_confirm_op\";i:1;i:6;i:2;i:7;i:3;s:35:\"admin/commerce/config/stock/control\";}','',252,8,0,'','admin/commerce/config/stock/control/manage/%/%','','t','','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/stock/control/manage/%/add/%','a:2:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}i:8;a:1:{s:18:\"rules_element_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:5:{i:0;s:20:\"rules_ui_add_element\";i:1;i:6;i:2;i:9;i:3;i:8;i:4;s:35:\"admin/commerce/config/stock/control\";}','',506,9,0,'','admin/commerce/config/stock/control/manage/%/add/%','','rules_menu_add_element_title','a:1:{i:0;a:1:{i:0;i:9;}}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/stock/control/manage/%/add/event','a:1:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:23:\"rules_ui_add_event_page\";i:1;i:6;i:2;s:35:\"admin/commerce/config/stock/control\";}','',507,9,0,'','admin/commerce/config/stock/control/manage/%/add/event','','rules_get_title','a:2:{i:0;s:32:\"Adding event to !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/stock/control/manage/%/autocomplete','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','rules_ui_form_data_selection_auto_completion','a:3:{i:0;i:8;i:1;i:9;i:2;i:10;}','',253,8,0,'','admin/commerce/config/stock/control/manage/%/autocomplete','','t','','','a:0:{}',0,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/stock/control/manage/%/clone','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:32:\"rules_ui_form_clone_rules_config\";i:1;i:6;i:2;s:35:\"admin/commerce/config/stock/control\";}','',253,8,0,'','admin/commerce/config/stock/control/manage/%/clone','','rules_get_title','a:2:{i:0;s:24:\"Cloning !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/stock/control/manage/%/delete/%','a:2:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}i:8;a:1:{s:18:\"rules_element_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:23:\"rules_ui_delete_element\";i:1;i:6;i:2;i:8;i:3;s:35:\"admin/commerce/config/stock/control\";}','',506,9,0,'','admin/commerce/config/stock/control/manage/%/delete/%','','rules_get_title','a:2:{i:0;s:24:\"Editing !plugin \"!label\"\";i:1;i:8;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/stock/control/manage/%/delete/event','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:21:\"rules_ui_remove_event\";i:1;i:6;i:2;i:9;i:3;s:35:\"admin/commerce/config/stock/control\";}','',507,9,0,'','admin/commerce/config/stock/control/manage/%/delete/event','Remove event','t','','','a:0:{}',6,'Remove an event from a reaction rule.','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/stock/control/manage/%/edit/%','a:2:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}i:8;a:1:{s:18:\"rules_element_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:21:\"rules_ui_edit_element\";i:1;i:6;i:2;i:8;i:3;s:35:\"admin/commerce/config/stock/control\";}','',506,9,0,'','admin/commerce/config/stock/control/manage/%/edit/%','','rules_get_title','a:2:{i:0;s:24:\"Editing !plugin \"!label\"\";i:1;i:8;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/stock/control/manage/%/execute','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:34:\"rules_ui_form_execute_rules_config\";i:1;i:6;i:2;s:35:\"admin/commerce/config/stock/control\";}','',253,8,0,'','admin/commerce/config/stock/control/manage/%/execute','','rules_get_title','a:2:{i:0;s:26:\"Executing !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/stock/control/manage/%/export','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:4:\"view\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:33:\"rules_ui_form_export_rules_config\";i:1;i:6;i:2;s:35:\"admin/commerce/config/stock/control\";}','',253,8,0,'','admin/commerce/config/stock/control/manage/%/export','','rules_get_title','a:2:{i:0;s:26:\"Export of !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/stock/ss','','','user_access','a:1:{i:0;s:34:\"administer commerce_stock settings\";}','drupal_get_form','a:1:{i:0;s:22:\"commerce_ss_admin_form\";}','',31,5,1,'admin/commerce/config/stock','admin/commerce/config/stock','Simple Stock management','t','','','a:0:{}',132,'Configure Simple stock.','',0,'sites/all/modules/commerce_stock/modules/commerce_ss/includes/commerce_ss.admin.inc'),('admin/commerce/config/stock/validation','','','user_access','a:1:{i:0;s:16:\"administer rules\";}','commerce_stock_admin_event_ruless','a:0:{}','',31,5,1,'admin/commerce/config/stock','admin/commerce/config/stock','Stock validation','t','','','a:0:{}',132,'Manage and configure stock validation events.','',5,'sites/all/modules/commerce_stock/includes/commerce_stock.admin.inc'),('admin/commerce/config/stock/validation/add_cart_action','','','user_access','a:1:{i:0;s:16:\"administer rules\";}','drupal_get_form','a:2:{i:0;s:43:\"commerce_stock_ui_add_cart_action_rule_form\";i:1;s:38:\"admin/commerce/config/stock/validation\";}','',63,6,0,'','admin/commerce/config/stock/validation/add_cart_action','Add a Cart action rule','t','','','a:0:{}',6,'Act on the add to cart action.','',0,'sites/all/modules/rules/rules_admin/rules_admin.inc'),('admin/commerce/config/stock/validation/add_cart_state','','','user_access','a:1:{i:0;s:16:\"administer rules\";}','drupal_get_form','a:2:{i:0;s:42:\"commerce_stock_ui_add_cart_state_rule_form\";i:1;s:38:\"admin/commerce/config/stock/validation\";}','',63,6,0,'','admin/commerce/config/stock/validation/add_cart_state','Add a Cart state rule','t','','','a:0:{}',6,'Disable or modify the add to cart form.','',0,'sites/all/modules/rules/rules_admin/rules_admin.inc'),('admin/commerce/config/stock/validation/add_checkout','','','user_access','a:1:{i:0;s:16:\"administer rules\";}','drupal_get_form','a:2:{i:0;s:40:\"commerce_stock_ui_add_checkout_rule_form\";i:1;s:38:\"admin/commerce/config/stock/validation\";}','',63,6,0,'','admin/commerce/config/stock/validation/add_checkout','Add a Validate cart / checkout rule','t','','','a:0:{}',6,'Validate products in the the cart before checkout.','',0,'sites/all/modules/rules/rules_admin/rules_admin.inc'),('admin/commerce/config/stock/validation/manage/%','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:31:\"rules_ui_form_edit_rules_config\";i:1;i:6;i:2;s:38:\"admin/commerce/config/stock/validation\";}','',126,7,0,'','admin/commerce/config/stock/validation/manage/%','','rules_get_title','a:2:{i:0;s:24:\"Editing !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',4,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/stock/validation/manage/%/%','a:2:{i:6;s:17:\"rules_config_load\";i:7;N;}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:37:\"rules_ui_form_rules_config_confirm_op\";i:1;i:6;i:2;i:7;i:3;s:38:\"admin/commerce/config/stock/validation\";}','',252,8,0,'','admin/commerce/config/stock/validation/manage/%/%','','t','','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/stock/validation/manage/%/add/%','a:2:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}i:8;a:1:{s:18:\"rules_element_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:5:{i:0;s:20:\"rules_ui_add_element\";i:1;i:6;i:2;i:9;i:3;i:8;i:4;s:38:\"admin/commerce/config/stock/validation\";}','',506,9,0,'','admin/commerce/config/stock/validation/manage/%/add/%','','rules_menu_add_element_title','a:1:{i:0;a:1:{i:0;i:9;}}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/stock/validation/manage/%/add/event','a:1:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:23:\"rules_ui_add_event_page\";i:1;i:6;i:2;s:38:\"admin/commerce/config/stock/validation\";}','',507,9,0,'','admin/commerce/config/stock/validation/manage/%/add/event','','rules_get_title','a:2:{i:0;s:32:\"Adding event to !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/stock/validation/manage/%/autocomplete','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','rules_ui_form_data_selection_auto_completion','a:3:{i:0;i:8;i:1;i:9;i:2;i:10;}','',253,8,0,'','admin/commerce/config/stock/validation/manage/%/autocomplete','','t','','','a:0:{}',0,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/stock/validation/manage/%/clone','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:32:\"rules_ui_form_clone_rules_config\";i:1;i:6;i:2;s:38:\"admin/commerce/config/stock/validation\";}','',253,8,0,'','admin/commerce/config/stock/validation/manage/%/clone','','rules_get_title','a:2:{i:0;s:24:\"Cloning !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/stock/validation/manage/%/delete/%','a:2:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}i:8;a:1:{s:18:\"rules_element_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:23:\"rules_ui_delete_element\";i:1;i:6;i:2;i:8;i:3;s:38:\"admin/commerce/config/stock/validation\";}','',506,9,0,'','admin/commerce/config/stock/validation/manage/%/delete/%','','rules_get_title','a:2:{i:0;s:24:\"Editing !plugin \"!label\"\";i:1;i:8;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/stock/validation/manage/%/delete/event','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:21:\"rules_ui_remove_event\";i:1;i:6;i:2;i:9;i:3;s:38:\"admin/commerce/config/stock/validation\";}','',507,9,0,'','admin/commerce/config/stock/validation/manage/%/delete/event','Remove event','t','','','a:0:{}',6,'Remove an event from a reaction rule.','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/stock/validation/manage/%/edit/%','a:2:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}i:8;a:1:{s:18:\"rules_element_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:21:\"rules_ui_edit_element\";i:1;i:6;i:2;i:8;i:3;s:38:\"admin/commerce/config/stock/validation\";}','',506,9,0,'','admin/commerce/config/stock/validation/manage/%/edit/%','','rules_get_title','a:2:{i:0;s:24:\"Editing !plugin \"!label\"\";i:1;i:8;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/stock/validation/manage/%/execute','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:34:\"rules_ui_form_execute_rules_config\";i:1;i:6;i:2;s:38:\"admin/commerce/config/stock/validation\";}','',253,8,0,'','admin/commerce/config/stock/validation/manage/%/execute','','rules_get_title','a:2:{i:0;s:26:\"Executing !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/config/stock/validation/manage/%/export','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:4:\"view\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:33:\"rules_ui_form_export_rules_config\";i:1;i:6;i:2;s:38:\"admin/commerce/config/stock/validation\";}','',253,8,0,'','admin/commerce/config/stock/validation/manage/%/export','','rules_get_title','a:2:{i:0;s:26:\"Export of !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/commerce/customer-profiles','','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:45:\"administer commerce_customer_profile entities\";}}}','views_page','a:2:{i:0;s:26:\"commerce_customer_profiles\";i:1;s:6:\"page_1\";}','',7,3,0,'','admin/commerce/customer-profiles','Customer profiles','t','','','a:0:{}',6,'Manage customer profiles and profile types in the store.','',0,''),('admin/commerce/customer-profiles/%','a:1:{i:3;s:30:\"commerce_customer_profile_load\";}','','commerce_customer_profile_access','a:2:{i:0;s:6:\"update\";i:1;i:3;}','commerce_customer_ui_customer_profile_form_wrapper','a:1:{i:0;i:3;}','',14,4,3,'','admin/commerce/customer-profiles/%','','commerce_customer_ui_customer_profile_title','a:1:{i:0;i:3;}','','a:0:{}',6,'','',0,'sites/all/modules/commerce/modules/customer/includes/commerce_customer_ui.profiles.inc'),('admin/commerce/customer-profiles/%/delete','a:1:{i:3;s:30:\"commerce_customer_profile_load\";}','','commerce_customer_profile_access','a:2:{i:0;s:6:\"delete\";i:1;i:3;}','commerce_customer_ui_customer_profile_delete_form_wrapper','a:1:{i:0;i:3;}','',29,5,2,'admin/commerce/customer-profiles/%','admin/commerce/customer-profiles/%','Delete a customer profile','t','','','a:0:{}',132,'','',10,'sites/all/modules/commerce/modules/customer/includes/commerce_customer_ui.profiles.inc'),('admin/commerce/customer-profiles/%/edit','a:1:{i:3;s:30:\"commerce_customer_profile_load\";}','','commerce_customer_profile_access','a:2:{i:0;s:6:\"update\";i:1;i:3;}','commerce_customer_ui_customer_profile_form_wrapper','a:1:{i:0;i:3;}','',29,5,3,'admin/commerce/customer-profiles/%','admin/commerce/customer-profiles/%','Edit','t','','','a:0:{}',140,'','',-10,'sites/all/modules/commerce/modules/customer/includes/commerce_customer_ui.profiles.inc'),('admin/commerce/customer-profiles/add','','','commerce_customer_ui_customer_profile_add_any_access','a:0:{}','commerce_customer_ui_customer_profile_add_page','a:0:{}','',15,4,0,'','admin/commerce/customer-profiles/add','Add a customer profile','t','','','a:0:{}',6,'Add a new customer profile.','',10,'sites/all/modules/commerce/modules/customer/includes/commerce_customer_ui.profiles.inc'),('admin/commerce/customer-profiles/add/billing','','','commerce_customer_profile_access','a:2:{i:0;s:6:\"create\";i:1;O:8:\"stdClass\":8:{s:4:\"type\";s:7:\"billing\";s:3:\"uid\";i:0;s:10:\"profile_id\";N;s:11:\"revision_id\";N;s:6:\"status\";i:1;s:7:\"created\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:6:\"is_new\";b:1;}}','commerce_customer_ui_customer_profile_form_wrapper','a:1:{i:0;O:8:\"stdClass\":8:{s:4:\"type\";s:7:\"billing\";s:3:\"uid\";i:0;s:10:\"profile_id\";N;s:11:\"revision_id\";N;s:6:\"status\";i:1;s:7:\"created\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:6:\"is_new\";b:1;}}','',31,5,0,'','admin/commerce/customer-profiles/add/billing','Create @name','t','a:1:{s:5:\"@name\";s:19:\"Billing information\";}','','a:0:{}',6,'The profile used to collect billing information on the checkout and order forms.','',0,'sites/all/modules/commerce/modules/customer/includes/commerce_customer_ui.profiles.inc'),('admin/commerce/customer-profiles/add/shipping','','','commerce_customer_profile_access','a:2:{i:0;s:6:\"create\";i:1;O:8:\"stdClass\":8:{s:4:\"type\";s:8:\"shipping\";s:3:\"uid\";i:0;s:10:\"profile_id\";N;s:11:\"revision_id\";N;s:6:\"status\";i:1;s:7:\"created\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:6:\"is_new\";b:1;}}','commerce_customer_ui_customer_profile_form_wrapper','a:1:{i:0;O:8:\"stdClass\":8:{s:4:\"type\";s:8:\"shipping\";s:3:\"uid\";i:0;s:10:\"profile_id\";N;s:11:\"revision_id\";N;s:6:\"status\";i:1;s:7:\"created\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:6:\"is_new\";b:1;}}','',31,5,0,'','admin/commerce/customer-profiles/add/shipping','Create @name','t','a:1:{s:5:\"@name\";s:20:\"Shipping information\";}','','a:0:{}',6,'The profile used to collect shipping information on the checkout and order forms.','',0,'sites/all/modules/commerce/modules/customer/includes/commerce_customer_ui.profiles.inc'),('admin/commerce/customer-profiles/list','','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:45:\"administer commerce_customer_profile entities\";}}}','views_page','a:2:{i:0;s:26:\"commerce_customer_profiles\";i:1;s:6:\"page_1\";}','',15,4,1,'admin/commerce/customer-profiles','admin/commerce/customer-profiles','List','t','','','a:0:{}',140,'','',-10,''),('admin/commerce/customer-profiles/types','','','user_access','a:1:{i:0;s:33:\"administer customer profile types\";}','commerce_customer_ui_customer_profile_types_overview','a:0:{}','',15,4,1,'admin/commerce/customer-profiles','admin/commerce/customer-profiles','Profile types','t','','','a:0:{}',132,'Manage customer profile types for your store.','',0,'sites/all/modules/commerce/modules/customer/includes/commerce_customer_ui.profile_types.inc'),('admin/commerce/customer-profiles/types/billing','','','user_access','a:1:{i:0;s:33:\"administer customer profile types\";}','commerce_customer_ui_profile_type_redirect','a:1:{i:0;s:7:\"billing\";}','',31,5,0,'','admin/commerce/customer-profiles/types/billing','Billing information','t','','','a:0:{}',6,'','',0,''),('admin/commerce/customer-profiles/types/billing/display','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:33:\"administer customer profile types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:25:\"commerce_customer_profile\";i:2;s:7:\"billing\";i:3;s:7:\"default\";}','',63,6,3,'admin/commerce/customer-profiles/types/billing','admin/commerce/customer-profiles/types/billing','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/customer-profiles/types/billing/display/administrator','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:25:\"commerce_customer_profile\";i:1;s:7:\"billing\";i:2;s:13:\"administrator\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:33:\"administer customer profile types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:25:\"commerce_customer_profile\";i:2;s:7:\"billing\";i:3;s:13:\"administrator\";}','',127,7,1,'admin/commerce/customer-profiles/types/billing/display','admin/commerce/customer-profiles/types/billing','Administrator','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/customer-profiles/types/billing/display/customer','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:25:\"commerce_customer_profile\";i:1;s:7:\"billing\";i:2;s:8:\"customer\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:33:\"administer customer profile types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:25:\"commerce_customer_profile\";i:2;s:7:\"billing\";i:3;s:8:\"customer\";}','',127,7,1,'admin/commerce/customer-profiles/types/billing/display','admin/commerce/customer-profiles/types/billing','Customer','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/customer-profiles/types/billing/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:25:\"commerce_customer_profile\";i:1;s:7:\"billing\";i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:33:\"administer customer profile types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:25:\"commerce_customer_profile\";i:2;s:7:\"billing\";i:3;s:7:\"default\";}','',127,7,1,'admin/commerce/customer-profiles/types/billing/display','admin/commerce/customer-profiles/types/billing','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/customer-profiles/types/billing/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:25:\"commerce_customer_profile\";i:1;s:7:\"billing\";i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:33:\"administer customer profile types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:25:\"commerce_customer_profile\";i:2;s:7:\"billing\";i:3;s:5:\"token\";}','',127,7,1,'admin/commerce/customer-profiles/types/billing/display','admin/commerce/customer-profiles/types/billing','Tokens','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/customer-profiles/types/billing/fields','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:33:\"administer customer profile types\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:25:\"commerce_customer_profile\";i:2;s:7:\"billing\";}','',63,6,3,'admin/commerce/customer-profiles/types/billing','admin/commerce/customer-profiles/types/billing','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/customer-profiles/types/billing/fields/%','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:25:\"commerce_customer_profile\";i:1;s:7:\"billing\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:33:\"administer customer profile types\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}','',126,7,0,'','admin/commerce/customer-profiles/types/billing/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/customer-profiles/types/billing/fields/%/delete','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:25:\"commerce_customer_profile\";i:1;s:7:\"billing\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:33:\"administer customer profile types\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:6;}','',253,8,1,'admin/commerce/customer-profiles/types/billing/fields/%','admin/commerce/customer-profiles/types/billing/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/customer-profiles/types/billing/fields/%/edit','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:25:\"commerce_customer_profile\";i:1;s:7:\"billing\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:33:\"administer customer profile types\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}','',253,8,1,'admin/commerce/customer-profiles/types/billing/fields/%','admin/commerce/customer-profiles/types/billing/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/customer-profiles/types/billing/fields/%/field-settings','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:25:\"commerce_customer_profile\";i:1;s:7:\"billing\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:33:\"administer customer profile types\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:6;}','',253,8,1,'admin/commerce/customer-profiles/types/billing/fields/%','admin/commerce/customer-profiles/types/billing/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/customer-profiles/types/billing/fields/%/widget-type','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:25:\"commerce_customer_profile\";i:1;s:7:\"billing\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:33:\"administer customer profile types\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:6;}','',253,8,1,'admin/commerce/customer-profiles/types/billing/fields/%','admin/commerce/customer-profiles/types/billing/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/customer-profiles/types/billing/groups/%/delete','a:1:{i:6;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:25:\"commerce_customer_profile\";i:1;s:7:\"billing\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:33:\"administer customer profile types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:6;}','',253,8,0,'','admin/commerce/customer-profiles/types/billing/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/customer-profiles/types/billing/groups/%/enable','a:1:{i:6;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:25:\"commerce_customer_profile\";i:1;s:7:\"billing\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:33:\"administer customer profile types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:6;}','',253,8,0,'','admin/commerce/customer-profiles/types/billing/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/customer-profiles/types/shipping','','','user_access','a:1:{i:0;s:33:\"administer customer profile types\";}','commerce_customer_ui_profile_type_redirect','a:1:{i:0;s:8:\"shipping\";}','',31,5,0,'','admin/commerce/customer-profiles/types/shipping','Shipping information','t','','','a:0:{}',6,'','',0,''),('admin/commerce/customer-profiles/types/shipping/display','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:33:\"administer customer profile types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:25:\"commerce_customer_profile\";i:2;s:8:\"shipping\";i:3;s:7:\"default\";}','',63,6,3,'admin/commerce/customer-profiles/types/shipping','admin/commerce/customer-profiles/types/shipping','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/customer-profiles/types/shipping/display/administrator','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:25:\"commerce_customer_profile\";i:1;s:8:\"shipping\";i:2;s:13:\"administrator\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:33:\"administer customer profile types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:25:\"commerce_customer_profile\";i:2;s:8:\"shipping\";i:3;s:13:\"administrator\";}','',127,7,1,'admin/commerce/customer-profiles/types/shipping/display','admin/commerce/customer-profiles/types/shipping','Administrator','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/customer-profiles/types/shipping/display/customer','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:25:\"commerce_customer_profile\";i:1;s:8:\"shipping\";i:2;s:8:\"customer\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:33:\"administer customer profile types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:25:\"commerce_customer_profile\";i:2;s:8:\"shipping\";i:3;s:8:\"customer\";}','',127,7,1,'admin/commerce/customer-profiles/types/shipping/display','admin/commerce/customer-profiles/types/shipping','Customer','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/customer-profiles/types/shipping/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:25:\"commerce_customer_profile\";i:1;s:8:\"shipping\";i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:33:\"administer customer profile types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:25:\"commerce_customer_profile\";i:2;s:8:\"shipping\";i:3;s:7:\"default\";}','',127,7,1,'admin/commerce/customer-profiles/types/shipping/display','admin/commerce/customer-profiles/types/shipping','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/customer-profiles/types/shipping/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:25:\"commerce_customer_profile\";i:1;s:8:\"shipping\";i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:33:\"administer customer profile types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:25:\"commerce_customer_profile\";i:2;s:8:\"shipping\";i:3;s:5:\"token\";}','',127,7,1,'admin/commerce/customer-profiles/types/shipping/display','admin/commerce/customer-profiles/types/shipping','Tokens','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/customer-profiles/types/shipping/fields','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:33:\"administer customer profile types\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:25:\"commerce_customer_profile\";i:2;s:8:\"shipping\";}','',63,6,3,'admin/commerce/customer-profiles/types/shipping','admin/commerce/customer-profiles/types/shipping','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/customer-profiles/types/shipping/fields/%','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:25:\"commerce_customer_profile\";i:1;s:8:\"shipping\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:33:\"administer customer profile types\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}','',126,7,0,'','admin/commerce/customer-profiles/types/shipping/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/customer-profiles/types/shipping/fields/%/delete','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:25:\"commerce_customer_profile\";i:1;s:8:\"shipping\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:33:\"administer customer profile types\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:6;}','',253,8,1,'admin/commerce/customer-profiles/types/shipping/fields/%','admin/commerce/customer-profiles/types/shipping/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/customer-profiles/types/shipping/fields/%/edit','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:25:\"commerce_customer_profile\";i:1;s:8:\"shipping\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:33:\"administer customer profile types\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}','',253,8,1,'admin/commerce/customer-profiles/types/shipping/fields/%','admin/commerce/customer-profiles/types/shipping/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/customer-profiles/types/shipping/fields/%/field-settings','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:25:\"commerce_customer_profile\";i:1;s:8:\"shipping\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:33:\"administer customer profile types\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:6;}','',253,8,1,'admin/commerce/customer-profiles/types/shipping/fields/%','admin/commerce/customer-profiles/types/shipping/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/customer-profiles/types/shipping/fields/%/widget-type','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:25:\"commerce_customer_profile\";i:1;s:8:\"shipping\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:33:\"administer customer profile types\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:6;}','',253,8,1,'admin/commerce/customer-profiles/types/shipping/fields/%','admin/commerce/customer-profiles/types/shipping/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/customer-profiles/types/shipping/groups/%/delete','a:1:{i:6;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:25:\"commerce_customer_profile\";i:1;s:8:\"shipping\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:33:\"administer customer profile types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:6;}','',253,8,0,'','admin/commerce/customer-profiles/types/shipping/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/customer-profiles/types/shipping/groups/%/enable','a:1:{i:6;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:25:\"commerce_customer_profile\";i:1;s:8:\"shipping\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:33:\"administer customer profile types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:6;}','',253,8,0,'','admin/commerce/customer-profiles/types/shipping/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/marketplace_funds','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/commerce/marketplace_funds','Commerce Marketplace Funds','t','','','a:0:{}',6,'Change Commerce Marketplace Funds settings.','',0,'modules/system/system.admin.inc'),('admin/commerce/marketplace_funds/account','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',15,4,0,'','admin/commerce/marketplace_funds/account','Administer Marketplace funds account entity types','t','','','a:0:{}',6,'Change funds accounts settings.','',0,'modules/system/system.admin.inc'),('admin/commerce/marketplace_funds/account/commerce_store/manage','','','user_access','a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}','commerce_marketplace_funds_list_accounts','a:1:{i:0;i:4;}','',63,6,0,'','admin/commerce/marketplace_funds/account/commerce_store/manage','Administer Marketplace Store Funds Account entity type','t','','','a:0:{}',6,'Configure Store funds accounts.','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.admin.inc'),('admin/commerce/marketplace_funds/account/commerce_store/manage/display','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:17:\"cmp_funds_account\";i:2;s:14:\"commerce_store\";i:3;s:7:\"default\";}','',127,7,1,'admin/commerce/marketplace_funds/account/commerce_store/manage','admin/commerce/marketplace_funds/account/commerce_store/manage','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/account/commerce_store/manage/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:17:\"cmp_funds_account\";i:1;s:14:\"commerce_store\";i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:17:\"cmp_funds_account\";i:2;s:14:\"commerce_store\";i:3;s:7:\"default\";}','',255,8,1,'admin/commerce/marketplace_funds/account/commerce_store/manage/display','admin/commerce/marketplace_funds/account/commerce_store/manage','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/account/commerce_store/manage/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:17:\"cmp_funds_account\";i:1;s:14:\"commerce_store\";i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:17:\"cmp_funds_account\";i:2;s:14:\"commerce_store\";i:3;s:4:\"full\";}','',255,8,1,'admin/commerce/marketplace_funds/account/commerce_store/manage/display','admin/commerce/marketplace_funds/account/commerce_store/manage','Full Account','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/account/commerce_store/manage/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:17:\"cmp_funds_account\";i:1;s:14:\"commerce_store\";i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:17:\"cmp_funds_account\";i:2;s:14:\"commerce_store\";i:3;s:5:\"token\";}','',255,8,1,'admin/commerce/marketplace_funds/account/commerce_store/manage/display','admin/commerce/marketplace_funds/account/commerce_store/manage','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/account/commerce_store/manage/fields','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:17:\"cmp_funds_account\";i:2;s:14:\"commerce_store\";}','',127,7,1,'admin/commerce/marketplace_funds/account/commerce_store/manage','admin/commerce/marketplace_funds/account/commerce_store/manage','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/account/commerce_store/manage/fields/%','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:17:\"cmp_funds_account\";i:1;s:14:\"commerce_store\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}','',254,8,0,'','admin/commerce/marketplace_funds/account/commerce_store/manage/fields/%','','field_ui_menu_title','a:1:{i:0;i:7;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/account/commerce_store/manage/fields/%/delete','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:17:\"cmp_funds_account\";i:1;s:14:\"commerce_store\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:7;}','',509,9,1,'admin/commerce/marketplace_funds/account/commerce_store/manage/fields/%','admin/commerce/marketplace_funds/account/commerce_store/manage/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/account/commerce_store/manage/fields/%/edit','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:17:\"cmp_funds_account\";i:1;s:14:\"commerce_store\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}','',509,9,1,'admin/commerce/marketplace_funds/account/commerce_store/manage/fields/%','admin/commerce/marketplace_funds/account/commerce_store/manage/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/account/commerce_store/manage/fields/%/field-settings','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:17:\"cmp_funds_account\";i:1;s:14:\"commerce_store\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:7;}','',509,9,1,'admin/commerce/marketplace_funds/account/commerce_store/manage/fields/%','admin/commerce/marketplace_funds/account/commerce_store/manage/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/account/commerce_store/manage/fields/%/widget-type','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:17:\"cmp_funds_account\";i:1;s:14:\"commerce_store\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:7;}','',509,9,1,'admin/commerce/marketplace_funds/account/commerce_store/manage/fields/%','admin/commerce/marketplace_funds/account/commerce_store/manage/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/account/commerce_store/manage/groups/%/delete','a:1:{i:7;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:17:\"cmp_funds_account\";i:1;s:14:\"commerce_store\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:7;}','',509,9,0,'','admin/commerce/marketplace_funds/account/commerce_store/manage/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/marketplace_funds/account/commerce_store/manage/groups/%/enable','a:1:{i:7;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:17:\"cmp_funds_account\";i:1;s:14:\"commerce_store\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:7;}','',509,9,0,'','admin/commerce/marketplace_funds/account/commerce_store/manage/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/marketplace_funds/account/commerce_store/manage/list','','','user_access','a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}','commerce_marketplace_funds_list_accounts','a:1:{i:0;i:4;}','',127,7,1,'admin/commerce/marketplace_funds/account/commerce_store/manage','admin/commerce/marketplace_funds/account/commerce_store/manage','List','t','','','a:0:{}',140,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.admin.inc'),('admin/commerce/marketplace_funds/account/user/manage','','','user_access','a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}','commerce_marketplace_funds_list_accounts','a:1:{i:0;i:4;}','',63,6,0,'','admin/commerce/marketplace_funds/account/user/manage','Administer Marketplace User Funds Account entity type','t','','','a:0:{}',6,'Configure User funds accounts.','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.admin.inc'),('admin/commerce/marketplace_funds/account/user/manage/display','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:17:\"cmp_funds_account\";i:2;s:4:\"user\";i:3;s:7:\"default\";}','',127,7,1,'admin/commerce/marketplace_funds/account/user/manage','admin/commerce/marketplace_funds/account/user/manage','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/account/user/manage/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:17:\"cmp_funds_account\";i:1;s:4:\"user\";i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:17:\"cmp_funds_account\";i:2;s:4:\"user\";i:3;s:7:\"default\";}','',255,8,1,'admin/commerce/marketplace_funds/account/user/manage/display','admin/commerce/marketplace_funds/account/user/manage','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/account/user/manage/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:17:\"cmp_funds_account\";i:1;s:4:\"user\";i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:17:\"cmp_funds_account\";i:2;s:4:\"user\";i:3;s:4:\"full\";}','',255,8,1,'admin/commerce/marketplace_funds/account/user/manage/display','admin/commerce/marketplace_funds/account/user/manage','Full Account','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/account/user/manage/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:17:\"cmp_funds_account\";i:1;s:4:\"user\";i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:17:\"cmp_funds_account\";i:2;s:4:\"user\";i:3;s:5:\"token\";}','',255,8,1,'admin/commerce/marketplace_funds/account/user/manage/display','admin/commerce/marketplace_funds/account/user/manage','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/account/user/manage/fields','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:17:\"cmp_funds_account\";i:2;s:4:\"user\";}','',127,7,1,'admin/commerce/marketplace_funds/account/user/manage','admin/commerce/marketplace_funds/account/user/manage','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/account/user/manage/fields/%','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:17:\"cmp_funds_account\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}','',254,8,0,'','admin/commerce/marketplace_funds/account/user/manage/fields/%','','field_ui_menu_title','a:1:{i:0;i:7;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/account/user/manage/fields/%/delete','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:17:\"cmp_funds_account\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:7;}','',509,9,1,'admin/commerce/marketplace_funds/account/user/manage/fields/%','admin/commerce/marketplace_funds/account/user/manage/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/account/user/manage/fields/%/edit','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:17:\"cmp_funds_account\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}','',509,9,1,'admin/commerce/marketplace_funds/account/user/manage/fields/%','admin/commerce/marketplace_funds/account/user/manage/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/account/user/manage/fields/%/field-settings','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:17:\"cmp_funds_account\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:7;}','',509,9,1,'admin/commerce/marketplace_funds/account/user/manage/fields/%','admin/commerce/marketplace_funds/account/user/manage/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/account/user/manage/fields/%/widget-type','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:17:\"cmp_funds_account\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:7;}','',509,9,1,'admin/commerce/marketplace_funds/account/user/manage/fields/%','admin/commerce/marketplace_funds/account/user/manage/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/account/user/manage/groups/%/delete','a:1:{i:7;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:17:\"cmp_funds_account\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:7;}','',509,9,0,'','admin/commerce/marketplace_funds/account/user/manage/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/marketplace_funds/account/user/manage/groups/%/enable','a:1:{i:7;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:17:\"cmp_funds_account\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:7;}','',509,9,0,'','admin/commerce/marketplace_funds/account/user/manage/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/marketplace_funds/account/user/manage/list','','','user_access','a:1:{i:0;s:37:\"administer cmp_funds_account entities\";}','commerce_marketplace_funds_list_accounts','a:1:{i:0;i:4;}','',127,7,1,'admin/commerce/marketplace_funds/account/user/manage','admin/commerce/marketplace_funds/account/user/manage','List','t','','','a:0:{}',140,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.admin.inc'),('admin/commerce/marketplace_funds/processor','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','drupal_get_form','a:1:{i:0;s:48:\"commerce_marketplace_funds_processor_config_form\";}','',15,4,0,'','admin/commerce/marketplace_funds/processor','Commerce Marketplace Funds Processor','t','','','a:0:{}',6,'Change Commerce Marketplace Funds Processor.','',0,''),('admin/commerce/marketplace_funds/transaction','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',15,4,0,'','admin/commerce/marketplace_funds/transaction','Administer Marketplace funds transaction entity types','t','','','a:0:{}',6,'Change funds transactions settings.','',0,'modules/system/system.admin.inc'),('admin/commerce/marketplace_funds/transaction/deposit/manage','','','user_access','a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}','commerce_marketplace_funds_list_transactions','a:1:{i:0;i:4;}','',63,6,0,'','admin/commerce/marketplace_funds/transaction/deposit/manage','Administer marketplace funds Deposit transaction entity type','t','','','a:0:{}',6,'Configure Deposit transaction transactions.','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.admin.inc'),('admin/commerce/marketplace_funds/transaction/deposit/manage/display','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"cmp_funds_transaction\";i:2;s:7:\"deposit\";i:3;s:7:\"default\";}','',127,7,1,'admin/commerce/marketplace_funds/transaction/deposit/manage','admin/commerce/marketplace_funds/transaction/deposit/manage','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/deposit/manage/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:7:\"deposit\";i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"cmp_funds_transaction\";i:2;s:7:\"deposit\";i:3;s:7:\"default\";}','',255,8,1,'admin/commerce/marketplace_funds/transaction/deposit/manage/display','admin/commerce/marketplace_funds/transaction/deposit/manage','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/deposit/manage/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:7:\"deposit\";i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"cmp_funds_transaction\";i:2;s:7:\"deposit\";i:3;s:4:\"full\";}','',255,8,1,'admin/commerce/marketplace_funds/transaction/deposit/manage/display','admin/commerce/marketplace_funds/transaction/deposit/manage','Full Transaction','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/deposit/manage/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:7:\"deposit\";i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"cmp_funds_transaction\";i:2;s:7:\"deposit\";i:3;s:5:\"token\";}','',255,8,1,'admin/commerce/marketplace_funds/transaction/deposit/manage/display','admin/commerce/marketplace_funds/transaction/deposit/manage','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/deposit/manage/fields','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:21:\"cmp_funds_transaction\";i:2;s:7:\"deposit\";}','',127,7,1,'admin/commerce/marketplace_funds/transaction/deposit/manage','admin/commerce/marketplace_funds/transaction/deposit/manage','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/deposit/manage/fields/%','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:7:\"deposit\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}','',254,8,0,'','admin/commerce/marketplace_funds/transaction/deposit/manage/fields/%','','field_ui_menu_title','a:1:{i:0;i:7;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/deposit/manage/fields/%/delete','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:7:\"deposit\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:7;}','',509,9,1,'admin/commerce/marketplace_funds/transaction/deposit/manage/fields/%','admin/commerce/marketplace_funds/transaction/deposit/manage/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/deposit/manage/fields/%/edit','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:7:\"deposit\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}','',509,9,1,'admin/commerce/marketplace_funds/transaction/deposit/manage/fields/%','admin/commerce/marketplace_funds/transaction/deposit/manage/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/deposit/manage/fields/%/field-settings','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:7:\"deposit\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:7;}','',509,9,1,'admin/commerce/marketplace_funds/transaction/deposit/manage/fields/%','admin/commerce/marketplace_funds/transaction/deposit/manage/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/deposit/manage/fields/%/widget-type','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:7:\"deposit\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:7;}','',509,9,1,'admin/commerce/marketplace_funds/transaction/deposit/manage/fields/%','admin/commerce/marketplace_funds/transaction/deposit/manage/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/deposit/manage/groups/%/delete','a:1:{i:7;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:7:\"deposit\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:7;}','',509,9,0,'','admin/commerce/marketplace_funds/transaction/deposit/manage/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/marketplace_funds/transaction/deposit/manage/groups/%/enable','a:1:{i:7;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:7:\"deposit\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:7;}','',509,9,0,'','admin/commerce/marketplace_funds/transaction/deposit/manage/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/marketplace_funds/transaction/deposit/manage/list','','','user_access','a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}','commerce_marketplace_funds_list_transactions','a:1:{i:0;i:4;}','',127,7,1,'admin/commerce/marketplace_funds/transaction/deposit/manage','admin/commerce/marketplace_funds/transaction/deposit/manage','List','t','','','a:0:{}',140,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.admin.inc'),('admin/commerce/marketplace_funds/transaction/payment/manage','','','user_access','a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}','commerce_marketplace_funds_list_transactions','a:1:{i:0;i:4;}','',63,6,0,'','admin/commerce/marketplace_funds/transaction/payment/manage','Administer marketplace funds Payment transaction entity type','t','','','a:0:{}',6,'Configure Payment transaction transactions.','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.admin.inc'),('admin/commerce/marketplace_funds/transaction/payment/manage/display','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"cmp_funds_transaction\";i:2;s:7:\"payment\";i:3;s:7:\"default\";}','',127,7,1,'admin/commerce/marketplace_funds/transaction/payment/manage','admin/commerce/marketplace_funds/transaction/payment/manage','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/payment/manage/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:7:\"payment\";i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"cmp_funds_transaction\";i:2;s:7:\"payment\";i:3;s:7:\"default\";}','',255,8,1,'admin/commerce/marketplace_funds/transaction/payment/manage/display','admin/commerce/marketplace_funds/transaction/payment/manage','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/payment/manage/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:7:\"payment\";i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"cmp_funds_transaction\";i:2;s:7:\"payment\";i:3;s:4:\"full\";}','',255,8,1,'admin/commerce/marketplace_funds/transaction/payment/manage/display','admin/commerce/marketplace_funds/transaction/payment/manage','Full Transaction','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/payment/manage/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:7:\"payment\";i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"cmp_funds_transaction\";i:2;s:7:\"payment\";i:3;s:5:\"token\";}','',255,8,1,'admin/commerce/marketplace_funds/transaction/payment/manage/display','admin/commerce/marketplace_funds/transaction/payment/manage','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/payment/manage/fields','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:21:\"cmp_funds_transaction\";i:2;s:7:\"payment\";}','',127,7,1,'admin/commerce/marketplace_funds/transaction/payment/manage','admin/commerce/marketplace_funds/transaction/payment/manage','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/payment/manage/fields/%','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:7:\"payment\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}','',254,8,0,'','admin/commerce/marketplace_funds/transaction/payment/manage/fields/%','','field_ui_menu_title','a:1:{i:0;i:7;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/payment/manage/fields/%/delete','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:7:\"payment\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:7;}','',509,9,1,'admin/commerce/marketplace_funds/transaction/payment/manage/fields/%','admin/commerce/marketplace_funds/transaction/payment/manage/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/payment/manage/fields/%/edit','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:7:\"payment\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}','',509,9,1,'admin/commerce/marketplace_funds/transaction/payment/manage/fields/%','admin/commerce/marketplace_funds/transaction/payment/manage/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/payment/manage/fields/%/field-settings','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:7:\"payment\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:7;}','',509,9,1,'admin/commerce/marketplace_funds/transaction/payment/manage/fields/%','admin/commerce/marketplace_funds/transaction/payment/manage/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/payment/manage/fields/%/widget-type','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:7:\"payment\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:7;}','',509,9,1,'admin/commerce/marketplace_funds/transaction/payment/manage/fields/%','admin/commerce/marketplace_funds/transaction/payment/manage/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/payment/manage/groups/%/delete','a:1:{i:7;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:7:\"payment\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:7;}','',509,9,0,'','admin/commerce/marketplace_funds/transaction/payment/manage/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/marketplace_funds/transaction/payment/manage/groups/%/enable','a:1:{i:7;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:7:\"payment\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:7;}','',509,9,0,'','admin/commerce/marketplace_funds/transaction/payment/manage/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/marketplace_funds/transaction/payment/manage/list','','','user_access','a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}','commerce_marketplace_funds_list_transactions','a:1:{i:0;i:4;}','',127,7,1,'admin/commerce/marketplace_funds/transaction/payment/manage','admin/commerce/marketplace_funds/transaction/payment/manage','List','t','','','a:0:{}',140,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.admin.inc'),('admin/commerce/marketplace_funds/transaction/transfer/manage','','','user_access','a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}','commerce_marketplace_funds_list_transactions','a:1:{i:0;i:4;}','',63,6,0,'','admin/commerce/marketplace_funds/transaction/transfer/manage','Administer marketplace funds Funds transfer transaction entity type','t','','','a:0:{}',6,'Configure Funds transfer transaction transactions.','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.admin.inc'),('admin/commerce/marketplace_funds/transaction/transfer/manage/display','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"cmp_funds_transaction\";i:2;s:8:\"transfer\";i:3;s:7:\"default\";}','',127,7,1,'admin/commerce/marketplace_funds/transaction/transfer/manage','admin/commerce/marketplace_funds/transaction/transfer/manage','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/transfer/manage/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:8:\"transfer\";i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"cmp_funds_transaction\";i:2;s:8:\"transfer\";i:3;s:7:\"default\";}','',255,8,1,'admin/commerce/marketplace_funds/transaction/transfer/manage/display','admin/commerce/marketplace_funds/transaction/transfer/manage','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/transfer/manage/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:8:\"transfer\";i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"cmp_funds_transaction\";i:2;s:8:\"transfer\";i:3;s:4:\"full\";}','',255,8,1,'admin/commerce/marketplace_funds/transaction/transfer/manage/display','admin/commerce/marketplace_funds/transaction/transfer/manage','Full Transaction','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/transfer/manage/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:8:\"transfer\";i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"cmp_funds_transaction\";i:2;s:8:\"transfer\";i:3;s:5:\"token\";}','',255,8,1,'admin/commerce/marketplace_funds/transaction/transfer/manage/display','admin/commerce/marketplace_funds/transaction/transfer/manage','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/transfer/manage/fields','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:21:\"cmp_funds_transaction\";i:2;s:8:\"transfer\";}','',127,7,1,'admin/commerce/marketplace_funds/transaction/transfer/manage','admin/commerce/marketplace_funds/transaction/transfer/manage','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/transfer/manage/fields/%','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:8:\"transfer\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}','',254,8,0,'','admin/commerce/marketplace_funds/transaction/transfer/manage/fields/%','','field_ui_menu_title','a:1:{i:0;i:7;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/transfer/manage/fields/%/delete','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:8:\"transfer\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:7;}','',509,9,1,'admin/commerce/marketplace_funds/transaction/transfer/manage/fields/%','admin/commerce/marketplace_funds/transaction/transfer/manage/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/transfer/manage/fields/%/edit','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:8:\"transfer\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}','',509,9,1,'admin/commerce/marketplace_funds/transaction/transfer/manage/fields/%','admin/commerce/marketplace_funds/transaction/transfer/manage/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/transfer/manage/fields/%/field-settings','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:8:\"transfer\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:7;}','',509,9,1,'admin/commerce/marketplace_funds/transaction/transfer/manage/fields/%','admin/commerce/marketplace_funds/transaction/transfer/manage/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/transfer/manage/fields/%/widget-type','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:8:\"transfer\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:7;}','',509,9,1,'admin/commerce/marketplace_funds/transaction/transfer/manage/fields/%','admin/commerce/marketplace_funds/transaction/transfer/manage/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/transfer/manage/groups/%/delete','a:1:{i:7;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:8:\"transfer\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:7;}','',509,9,0,'','admin/commerce/marketplace_funds/transaction/transfer/manage/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/marketplace_funds/transaction/transfer/manage/groups/%/enable','a:1:{i:7;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:8:\"transfer\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:7;}','',509,9,0,'','admin/commerce/marketplace_funds/transaction/transfer/manage/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/marketplace_funds/transaction/transfer/manage/list','','','user_access','a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}','commerce_marketplace_funds_list_transactions','a:1:{i:0;i:4;}','',127,7,1,'admin/commerce/marketplace_funds/transaction/transfer/manage','admin/commerce/marketplace_funds/transaction/transfer/manage','List','t','','','a:0:{}',140,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.admin.inc'),('admin/commerce/marketplace_funds/transaction/withdraw/manage','','','user_access','a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}','commerce_marketplace_funds_list_transactions','a:1:{i:0;i:4;}','',63,6,0,'','admin/commerce/marketplace_funds/transaction/withdraw/manage','Administer marketplace funds Withdraw transaction entity type','t','','','a:0:{}',6,'Configure Withdraw transaction transactions.','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.admin.inc'),('admin/commerce/marketplace_funds/transaction/withdraw/manage/display','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"cmp_funds_transaction\";i:2;s:8:\"withdraw\";i:3;s:7:\"default\";}','',127,7,1,'admin/commerce/marketplace_funds/transaction/withdraw/manage','admin/commerce/marketplace_funds/transaction/withdraw/manage','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/withdraw/manage/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:8:\"withdraw\";i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"cmp_funds_transaction\";i:2;s:8:\"withdraw\";i:3;s:7:\"default\";}','',255,8,1,'admin/commerce/marketplace_funds/transaction/withdraw/manage/display','admin/commerce/marketplace_funds/transaction/withdraw/manage','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/withdraw/manage/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:8:\"withdraw\";i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"cmp_funds_transaction\";i:2;s:8:\"withdraw\";i:3;s:4:\"full\";}','',255,8,1,'admin/commerce/marketplace_funds/transaction/withdraw/manage/display','admin/commerce/marketplace_funds/transaction/withdraw/manage','Full Transaction','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/withdraw/manage/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:8:\"withdraw\";i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"cmp_funds_transaction\";i:2;s:8:\"withdraw\";i:3;s:5:\"token\";}','',255,8,1,'admin/commerce/marketplace_funds/transaction/withdraw/manage/display','admin/commerce/marketplace_funds/transaction/withdraw/manage','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/withdraw/manage/fields','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:21:\"cmp_funds_transaction\";i:2;s:8:\"withdraw\";}','',127,7,1,'admin/commerce/marketplace_funds/transaction/withdraw/manage','admin/commerce/marketplace_funds/transaction/withdraw/manage','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/withdraw/manage/fields/%','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:8:\"withdraw\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}','',254,8,0,'','admin/commerce/marketplace_funds/transaction/withdraw/manage/fields/%','','field_ui_menu_title','a:1:{i:0;i:7;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/withdraw/manage/fields/%/delete','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:8:\"withdraw\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:7;}','',509,9,1,'admin/commerce/marketplace_funds/transaction/withdraw/manage/fields/%','admin/commerce/marketplace_funds/transaction/withdraw/manage/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/withdraw/manage/fields/%/edit','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:8:\"withdraw\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}','',509,9,1,'admin/commerce/marketplace_funds/transaction/withdraw/manage/fields/%','admin/commerce/marketplace_funds/transaction/withdraw/manage/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/withdraw/manage/fields/%/field-settings','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:8:\"withdraw\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:7;}','',509,9,1,'admin/commerce/marketplace_funds/transaction/withdraw/manage/fields/%','admin/commerce/marketplace_funds/transaction/withdraw/manage/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/withdraw/manage/fields/%/widget-type','a:1:{i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:8:\"withdraw\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:7;}','',509,9,1,'admin/commerce/marketplace_funds/transaction/withdraw/manage/fields/%','admin/commerce/marketplace_funds/transaction/withdraw/manage/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/transaction/withdraw/manage/groups/%/delete','a:1:{i:7;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:8:\"withdraw\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:7;}','',509,9,0,'','admin/commerce/marketplace_funds/transaction/withdraw/manage/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/marketplace_funds/transaction/withdraw/manage/groups/%/enable','a:1:{i:7;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:21:\"cmp_funds_transaction\";i:1;s:8:\"withdraw\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:7;}','',509,9,0,'','admin/commerce/marketplace_funds/transaction/withdraw/manage/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/marketplace_funds/transaction/withdraw/manage/list','','','user_access','a:1:{i:0;s:41:\"administer cmp_funds_transaction entities\";}','commerce_marketplace_funds_list_transactions','a:1:{i:0;i:4;}','',127,7,1,'admin/commerce/marketplace_funds/transaction/withdraw/manage','admin/commerce/marketplace_funds/transaction/withdraw/manage','List','t','','','a:0:{}',140,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.admin.inc'),('admin/commerce/marketplace_funds/withdraw','','','entity_access','a:2:{i:0;s:4:\"view\";i:1;s:30:\"cmp_funds_withdraw_method_type\";}','drupal_get_form','a:2:{i:0;s:44:\"cmp_funds_withdraw_method_type_overview_form\";i:1;s:30:\"cmp_funds_withdraw_method_type\";}','',15,4,0,'','admin/commerce/marketplace_funds/withdraw','Withdraw method types','t','','','a:0:{}',6,'Manage withdraw method entity types, including adding\n      and removing fields and the display of fields.','',0,'sites/all/modules/entity/includes/entity.ui.inc'),('admin/commerce/marketplace_funds/withdraw/add','','','entity_access','a:2:{i:0;s:6:\"create\";i:1;s:30:\"cmp_funds_withdraw_method_type\";}','entity_ui_get_form','a:3:{i:0;s:30:\"cmp_funds_withdraw_method_type\";i:1;N;i:2;s:3:\"add\";}','',31,5,1,'admin/commerce/marketplace_funds/withdraw','admin/commerce/marketplace_funds/withdraw','','entity_ui_get_action_title','a:2:{i:0;s:3:\"add\";i:1;s:30:\"cmp_funds_withdraw_method_type\";}','','a:0:{}',388,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/modules/withdraw/includes/commerce_marketplace_funds_withdraw.method_type.admin.inc'),('admin/commerce/marketplace_funds/withdraw/import','','','entity_access','a:2:{i:0;s:6:\"create\";i:1;s:30:\"cmp_funds_withdraw_method_type\";}','drupal_get_form','a:4:{i:0;s:45:\"cmp_funds_withdraw_method_type_operation_form\";i:1;s:30:\"cmp_funds_withdraw_method_type\";i:2;N;i:3;s:6:\"import\";}','',31,5,1,'admin/commerce/marketplace_funds/withdraw','admin/commerce/marketplace_funds/withdraw','','entity_ui_get_action_title','a:2:{i:0;s:6:\"import\";i:1;s:30:\"cmp_funds_withdraw_method_type\";}','','a:0:{}',388,'','',0,'sites/all/modules/entity/includes/entity.ui.inc'),('admin/commerce/marketplace_funds/withdraw/list','','','entity_access','a:2:{i:0;s:4:\"view\";i:1;s:30:\"cmp_funds_withdraw_method_type\";}','drupal_get_form','a:2:{i:0;s:44:\"cmp_funds_withdraw_method_type_overview_form\";i:1;s:30:\"cmp_funds_withdraw_method_type\";}','',31,5,1,'admin/commerce/marketplace_funds/withdraw','admin/commerce/marketplace_funds/withdraw','List','t','','','a:0:{}',140,'','',-10,'sites/all/modules/entity/includes/entity.ui.inc'),('admin/commerce/marketplace_funds/withdraw/manage/%','a:1:{i:5;a:1:{s:18:\"entity_object_load\";a:1:{i:0;s:30:\"cmp_funds_withdraw_method_type\";}}}','','entity_access','a:3:{i:0;s:6:\"update\";i:1;s:30:\"cmp_funds_withdraw_method_type\";i:2;i:5;}','entity_ui_get_form','a:2:{i:0;s:30:\"cmp_funds_withdraw_method_type\";i:1;i:5;}','',62,6,0,'','admin/commerce/marketplace_funds/withdraw/manage/%','Edit','entity_label','a:2:{i:0;s:30:\"cmp_funds_withdraw_method_type\";i:1;i:5;}','','a:0:{}',6,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/modules/withdraw/includes/commerce_marketplace_funds_withdraw.method_type.admin.inc'),('admin/commerce/marketplace_funds/withdraw/manage/%/%','a:2:{i:5;a:1:{s:18:\"entity_object_load\";a:1:{i:0;s:30:\"cmp_funds_withdraw_method_type\";}}i:6;N;}','','entity_access','a:3:{i:0;s:6:\"delete\";i:1;s:30:\"cmp_funds_withdraw_method_type\";i:2;i:5;}','drupal_get_form','a:4:{i:0;s:45:\"cmp_funds_withdraw_method_type_operation_form\";i:1;s:30:\"cmp_funds_withdraw_method_type\";i:2;i:5;i:3;i:6;}','',124,7,0,'','admin/commerce/marketplace_funds/withdraw/manage/%/%','','t','','','a:0:{}',6,'','',0,'sites/all/modules/entity/includes/entity.ui.inc'),('admin/commerce/marketplace_funds/withdraw/manage/%/clone','a:1:{i:5;a:1:{s:18:\"entity_object_load\";a:1:{i:0;s:30:\"cmp_funds_withdraw_method_type\";}}}','','entity_access','a:2:{i:0;s:6:\"create\";i:1;s:30:\"cmp_funds_withdraw_method_type\";}','entity_ui_get_form','a:3:{i:0;s:30:\"cmp_funds_withdraw_method_type\";i:1;i:5;i:2;s:5:\"clone\";}','',125,7,0,'','admin/commerce/marketplace_funds/withdraw/manage/%/clone','Clone','t','','','a:0:{}',6,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/modules/withdraw/includes/commerce_marketplace_funds_withdraw.method_type.admin.inc'),('admin/commerce/marketplace_funds/withdraw/manage/%/display','a:1:{i:5;s:35:\"cmp_funds_withdraw_method_type_load\";}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:42:\"administer cmp_funds_withdraw_method types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:25:\"cmp_funds_withdraw_method\";i:2;i:5;i:3;s:7:\"default\";}','',125,7,1,'admin/commerce/marketplace_funds/withdraw/manage/%','admin/commerce/marketplace_funds/withdraw/manage/%','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/withdraw/manage/%/display/default','a:1:{i:5;s:35:\"cmp_funds_withdraw_method_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:25:\"cmp_funds_withdraw_method\";i:1;i:5;i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:42:\"administer cmp_funds_withdraw_method types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:25:\"cmp_funds_withdraw_method\";i:2;i:5;i:3;s:7:\"default\";}','',251,8,1,'admin/commerce/marketplace_funds/withdraw/manage/%/display','admin/commerce/marketplace_funds/withdraw/manage/%','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/withdraw/manage/%/display/token','a:1:{i:5;s:35:\"cmp_funds_withdraw_method_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:25:\"cmp_funds_withdraw_method\";i:1;i:5;i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:42:\"administer cmp_funds_withdraw_method types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:25:\"cmp_funds_withdraw_method\";i:2;i:5;i:3;s:5:\"token\";}','',251,8,1,'admin/commerce/marketplace_funds/withdraw/manage/%/display','admin/commerce/marketplace_funds/withdraw/manage/%','Tokens','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/withdraw/manage/%/edit','a:1:{i:5;a:1:{s:18:\"entity_object_load\";a:1:{i:0;s:30:\"cmp_funds_withdraw_method_type\";}}}','','entity_access','a:3:{i:0;s:6:\"update\";i:1;s:30:\"cmp_funds_withdraw_method_type\";i:2;i:5;}','entity_ui_get_form','a:2:{i:0;s:30:\"cmp_funds_withdraw_method_type\";i:1;i:5;}','',125,7,1,'admin/commerce/marketplace_funds/withdraw/manage/%','admin/commerce/marketplace_funds/withdraw/manage/%','Edit','t','','','a:0:{}',140,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/modules/withdraw/includes/commerce_marketplace_funds_withdraw.method_type.admin.inc'),('admin/commerce/marketplace_funds/withdraw/manage/%/fields','a:1:{i:5;s:35:\"cmp_funds_withdraw_method_type_load\";}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:42:\"administer cmp_funds_withdraw_method types\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:25:\"cmp_funds_withdraw_method\";i:2;i:5;}','',125,7,1,'admin/commerce/marketplace_funds/withdraw/manage/%','admin/commerce/marketplace_funds/withdraw/manage/%','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/withdraw/manage/%/fields/%','a:2:{i:5;a:1:{s:35:\"cmp_funds_withdraw_method_type_load\";a:4:{i:0;s:25:\"cmp_funds_withdraw_method\";i:1;i:5;i:2;s:1:\"5\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:25:\"cmp_funds_withdraw_method\";i:1;i:5;i:2;s:1:\"5\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:42:\"administer cmp_funds_withdraw_method types\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}','',250,8,0,'','admin/commerce/marketplace_funds/withdraw/manage/%/fields/%','','field_ui_menu_title','a:1:{i:0;i:7;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/withdraw/manage/%/fields/%/delete','a:2:{i:5;a:1:{s:35:\"cmp_funds_withdraw_method_type_load\";a:4:{i:0;s:25:\"cmp_funds_withdraw_method\";i:1;i:5;i:2;s:1:\"5\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:25:\"cmp_funds_withdraw_method\";i:1;i:5;i:2;s:1:\"5\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:42:\"administer cmp_funds_withdraw_method types\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:7;}','',501,9,1,'admin/commerce/marketplace_funds/withdraw/manage/%/fields/%','admin/commerce/marketplace_funds/withdraw/manage/%/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/withdraw/manage/%/fields/%/edit','a:2:{i:5;a:1:{s:35:\"cmp_funds_withdraw_method_type_load\";a:4:{i:0;s:25:\"cmp_funds_withdraw_method\";i:1;i:5;i:2;s:1:\"5\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:25:\"cmp_funds_withdraw_method\";i:1;i:5;i:2;s:1:\"5\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:42:\"administer cmp_funds_withdraw_method types\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}','',501,9,1,'admin/commerce/marketplace_funds/withdraw/manage/%/fields/%','admin/commerce/marketplace_funds/withdraw/manage/%/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/withdraw/manage/%/fields/%/field-settings','a:2:{i:5;a:1:{s:35:\"cmp_funds_withdraw_method_type_load\";a:4:{i:0;s:25:\"cmp_funds_withdraw_method\";i:1;i:5;i:2;s:1:\"5\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:25:\"cmp_funds_withdraw_method\";i:1;i:5;i:2;s:1:\"5\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:42:\"administer cmp_funds_withdraw_method types\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:7;}','',501,9,1,'admin/commerce/marketplace_funds/withdraw/manage/%/fields/%','admin/commerce/marketplace_funds/withdraw/manage/%/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/withdraw/manage/%/fields/%/widget-type','a:2:{i:5;a:1:{s:35:\"cmp_funds_withdraw_method_type_load\";a:4:{i:0;s:25:\"cmp_funds_withdraw_method\";i:1;i:5;i:2;s:1:\"5\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:25:\"cmp_funds_withdraw_method\";i:1;i:5;i:2;s:1:\"5\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:42:\"administer cmp_funds_withdraw_method types\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:7;}','',501,9,1,'admin/commerce/marketplace_funds/withdraw/manage/%/fields/%','admin/commerce/marketplace_funds/withdraw/manage/%/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/marketplace_funds/withdraw/manage/%/groups/%/delete','a:2:{i:5;a:1:{s:35:\"cmp_funds_withdraw_method_type_load\";a:4:{i:0;s:25:\"cmp_funds_withdraw_method\";i:1;i:5;i:2;s:1:\"5\";i:3;s:4:\"%map\";}}i:7;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:25:\"cmp_funds_withdraw_method\";i:1;i:5;i:2;s:1:\"5\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:42:\"administer cmp_funds_withdraw_method types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:7;}','',501,9,0,'','admin/commerce/marketplace_funds/withdraw/manage/%/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/marketplace_funds/withdraw/manage/%/groups/%/enable','a:2:{i:5;a:1:{s:35:\"cmp_funds_withdraw_method_type_load\";a:4:{i:0;s:25:\"cmp_funds_withdraw_method\";i:1;i:5;i:2;s:1:\"5\";i:3;s:4:\"%map\";}}i:7;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:25:\"cmp_funds_withdraw_method\";i:1;i:5;i:2;s:1:\"5\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:42:\"administer cmp_funds_withdraw_method types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:7;}','',501,9,0,'','admin/commerce/marketplace_funds/withdraw/manage/%/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/orders','','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:30:\"view any commerce_order entity\";}}}','views_page','a:2:{i:0;s:15:\"commerce_orders\";i:1;s:10:\"admin_page\";}','',7,3,0,'','admin/commerce/orders','Orders','t','','','a:0:{}',6,'Manage orders in the store.','',0,''),('admin/commerce/orders/%','a:1:{i:3;s:19:\"commerce_order_load\";}','','commerce_order_admin_order_view_access','a:1:{i:0;i:3;}','commerce_order_ui_order_view','a:1:{i:0;i:3;}','',14,4,0,'','admin/commerce/orders/%','','commerce_order_ui_order_title','a:1:{i:0;i:3;}','','a:0:{}',6,'','',0,''),('admin/commerce/orders/%/delete','a:1:{i:3;s:19:\"commerce_order_load\";}','','commerce_order_access','a:2:{i:0;s:6:\"delete\";i:1;i:3;}','commerce_order_ui_order_delete_form_wrapper','a:1:{i:0;i:3;}','',29,5,2,'admin/commerce/orders/%','admin/commerce/orders/%','Delete','t','','','a:0:{}',132,'','',20,'sites/all/modules/commerce/modules/order/includes/commerce_order_ui.orders.inc'),('admin/commerce/orders/%/edit','a:1:{i:3;s:19:\"commerce_order_load\";}','','commerce_order_access','a:2:{i:0;s:6:\"update\";i:1;i:3;}','commerce_order_ui_order_form_wrapper','a:1:{i:0;i:3;}','',29,5,3,'admin/commerce/orders/%','admin/commerce/orders/%','Edit','t','','','a:0:{}',132,'','',-5,'sites/all/modules/commerce/modules/order/includes/commerce_order_ui.orders.inc'),('admin/commerce/orders/%/edit/checkout','a:1:{i:3;s:19:\"commerce_order_load\";}','','commerce_checkout_complete_form_access','a:1:{i:0;i:3;}','drupal_get_form','a:2:{i:0;s:31:\"commerce_checkout_complete_form\";i:1;i:3;}','',59,6,1,'admin/commerce/orders/%/edit','admin/commerce/orders/%','Simulate checkout completion','t','','','a:0:{}',388,'Directly invokes the checkout completion rules on the order.','',0,'sites/all/modules/commerce/modules/checkout/includes/commerce_checkout.admin.inc'),('admin/commerce/orders/%/edit/refresh','a:1:{i:3;s:19:\"commerce_order_load\";}','','commerce_cart_order_refresh_form_access','a:1:{i:0;i:3;}','drupal_get_form','a:2:{i:0;s:32:\"commerce_cart_order_refresh_form\";i:1;i:3;}','',59,6,1,'admin/commerce/orders/%/edit','admin/commerce/orders/%','Apply pricing rules','t','','','a:0:{}',388,'Executes the cart order refresh used to apply all current pricing rules on the front end.','',0,'sites/all/modules/commerce/modules/cart/includes/commerce_cart.admin.inc'),('admin/commerce/orders/%/payment','a:1:{i:3;s:19:\"commerce_order_load\";}','','commerce_payment_transaction_order_access','a:2:{i:0;s:4:\"view\";i:1;i:3;}','commerce_payment_ui_order_tab','a:1:{i:0;i:3;}','',29,5,3,'admin/commerce/orders/%','admin/commerce/orders/%','Payment','t','','','a:0:{}',132,'','',10,'sites/all/modules/commerce/modules/payment/includes/commerce_payment_ui.admin.inc'),('admin/commerce/orders/%/payment/%','a:2:{i:3;s:19:\"commerce_order_load\";i:5;s:33:\"commerce_payment_transaction_load\";}','','commerce_payment_transaction_access','a:2:{i:0;s:4:\"view\";i:1;i:5;}','commerce_payment_ui_payment_transaction_view','a:3:{i:0;i:3;i:1;i:5;i:2;s:13:\"administrator\";}','',58,6,0,'','admin/commerce/orders/%/payment/%','','commerce_payment_ui_payment_transaction_title','a:1:{i:0;i:5;}','','a:0:{}',6,'','',0,'sites/all/modules/commerce/modules/payment/includes/commerce_payment_ui.admin.inc'),('admin/commerce/orders/%/payment/%/delete','a:2:{i:3;s:19:\"commerce_order_load\";i:5;s:33:\"commerce_payment_transaction_load\";}','','commerce_payment_transaction_access','a:2:{i:0;s:6:\"delete\";i:1;i:5;}','commerce_payment_ui_payment_transaction_delete_form_wrapper','a:2:{i:0;i:3;i:1;i:5;}','',117,7,2,'admin/commerce/orders/%/payment/%','admin/commerce/orders/%/payment/%','Delete','t','','','a:0:{}',132,'','',10,'sites/all/modules/commerce/modules/payment/includes/commerce_payment_ui.admin.inc'),('admin/commerce/orders/%/payment/%/offline-payment-confirm','a:2:{i:3;s:19:\"commerce_order_load\";i:5;s:33:\"commerce_payment_transaction_load\";}','','commerce_cop_payment_access','a:2:{i:0;i:3;i:1;i:5;}','drupal_get_form','a:3:{i:0;s:33:\"commerce_cop_confirm_payment_form\";i:1;i:3;i:2;i:5;}','',117,7,2,'admin/commerce/orders/%/payment/%','admin/commerce/orders/%/payment/%','Confirm payment','t','','','a:0:{}',132,'','',2,''),('admin/commerce/orders/%/payment/%/view','a:2:{i:3;s:19:\"commerce_order_load\";i:5;s:33:\"commerce_payment_transaction_load\";}','','commerce_payment_transaction_access','a:2:{i:0;s:4:\"view\";i:1;i:5;}','commerce_payment_ui_payment_transaction_view','a:3:{i:0;i:3;i:1;i:5;i:2;s:13:\"administrator\";}','',117,7,3,'admin/commerce/orders/%/payment/%','admin/commerce/orders/%/payment/%','View','t','','','a:0:{}',140,'','',0,'sites/all/modules/commerce/modules/payment/includes/commerce_payment_ui.admin.inc'),('admin/commerce/orders/%/revisions','a:1:{i:3;N;}','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:34:\"administer commerce_order entities\";}}}','views_page','a:3:{i:0;s:24:\"commerce_order_revisions\";i:1;s:20:\"order_revisions_page\";i:2;i:3;}','',29,5,1,'admin/commerce/orders/%','admin/commerce/orders/%','Revisions','t','','','a:0:{}',132,'View revisions of this order.','',20,''),('admin/commerce/orders/%/view','a:1:{i:3;s:19:\"commerce_order_load\";}','','commerce_order_admin_order_view_access','a:1:{i:0;i:3;}','commerce_order_ui_order_view','a:1:{i:0;i:3;}','',29,5,3,'admin/commerce/orders/%','admin/commerce/orders/%','View','t','','','a:0:{}',140,'','',-10,''),('admin/commerce/orders/add','','','commerce_order_access','a:1:{i:0;s:6:\"create\";}','commerce_order_ui_order_form_wrapper','a:0:{}','',15,4,0,'','admin/commerce/orders/add','Create an order','t','','','a:0:{}',6,'Create a new order.','',10,'sites/all/modules/commerce/modules/order/includes/commerce_order_ui.orders.inc'),('admin/commerce/orders/add/%','a:1:{i:4;s:9:\"user_load\";}','','commerce_order_access','a:1:{i:0;s:6:\"create\";}','commerce_order_ui_order_form_wrapper','a:2:{i:0;N;i:1;i:4;}','',30,5,0,'','admin/commerce/orders/add/%','Create an order','t','','','a:0:{}',6,'Create a new order for the specified user.','',0,'sites/all/modules/commerce/modules/order/includes/commerce_order_ui.orders.inc'),('admin/commerce/orders/carts','','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:30:\"view any commerce_order entity\";}}}','views_page','a:2:{i:0;s:15:\"commerce_orders\";i:1;s:14:\"shopping_carts\";}','',15,4,1,'admin/commerce/orders','admin/commerce/orders','Shopping carts','t','','','a:0:{}',132,'','',0,''),('admin/commerce/orders/list','','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:30:\"view any commerce_order entity\";}}}','views_page','a:2:{i:0;s:15:\"commerce_orders\";i:1;s:10:\"admin_page\";}','',15,4,1,'admin/commerce/orders','admin/commerce/orders','Orders','t','','','a:0:{}',140,'','',-10,''),('admin/commerce/products','','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:36:\"administer commerce_product entities\";}}}','views_page','a:2:{i:0;s:17:\"commerce_products\";i:1;s:10:\"admin_page\";}','',7,3,0,'','admin/commerce/products','Products','t','','','a:0:{}',6,'Manage products and product types in the store.','',0,''),('admin/commerce/products/%','a:1:{i:3;s:21:\"commerce_product_load\";}','','commerce_product_access','a:2:{i:0;s:6:\"update\";i:1;i:3;}','commerce_product_ui_product_form_wrapper','a:1:{i:0;i:3;}','',14,4,3,'','admin/commerce/products/%','','commerce_product_ui_product_title','a:1:{i:0;i:3;}','','a:0:{}',6,'','',0,'sites/all/modules/commerce/modules/product/includes/commerce_product_ui.products.inc'),('admin/commerce/products/%/delete','a:1:{i:3;s:21:\"commerce_product_load\";}','','commerce_product_access','a:2:{i:0;s:6:\"delete\";i:1;i:3;}','commerce_product_ui_product_delete_form_wrapper','a:1:{i:0;i:3;}','',29,5,2,'admin/commerce/products/%','admin/commerce/products/%','Delete','t','','','a:0:{}',132,'','',20,'sites/all/modules/commerce/modules/product/includes/commerce_product_ui.products.inc'),('admin/commerce/products/%/edit','a:1:{i:3;s:21:\"commerce_product_load\";}','','commerce_product_access','a:2:{i:0;s:6:\"update\";i:1;i:3;}','commerce_product_ui_product_form_wrapper','a:1:{i:0;i:3;}','',29,5,3,'admin/commerce/products/%','admin/commerce/products/%','Edit','t','','','a:0:{}',140,'','',-10,'sites/all/modules/commerce/modules/product/includes/commerce_product_ui.products.inc'),('admin/commerce/products/%/revisions','a:1:{i:3;N;}','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:36:\"administer commerce_product entities\";}}}','views_page','a:3:{i:0;s:26:\"commerce_product_revisions\";i:1;s:22:\"product_revisions_page\";i:2;i:3;}','',29,5,1,'admin/commerce/products/%','admin/commerce/products/%','Revisions','t','','','a:0:{}',132,'View revisions of this product.','',0,''),('admin/commerce/products/add','','','commerce_product_ui_product_add_any_access','a:0:{}','commerce_product_ui_add_page','a:0:{}','',15,4,0,'','admin/commerce/products/add','Add a product','t','','','a:0:{}',6,'Add a new product for sale.','',10,'sites/all/modules/commerce/modules/product/includes/commerce_product_ui.products.inc'),('admin/commerce/products/add/deposit','','','commerce_product_access','a:2:{i:0;s:6:\"create\";i:1;O:8:\"stdClass\":10:{s:4:\"type\";s:7:\"deposit\";s:10:\"product_id\";N;s:6:\"is_new\";b:1;s:3:\"sku\";s:0:\"\";s:11:\"revision_id\";N;s:5:\"title\";s:0:\"\";s:3:\"uid\";s:0:\"\";s:6:\"status\";i:1;s:7:\"created\";s:0:\"\";s:7:\"changed\";s:0:\"\";}}','commerce_product_ui_product_form_wrapper','a:1:{i:0;O:8:\"stdClass\":10:{s:4:\"type\";s:7:\"deposit\";s:10:\"product_id\";N;s:6:\"is_new\";b:1;s:3:\"sku\";s:0:\"\";s:11:\"revision_id\";N;s:5:\"title\";s:0:\"\";s:3:\"uid\";s:0:\"\";s:6:\"status\";i:1;s:7:\"created\";s:0:\"\";s:7:\"changed\";s:0:\"\";}}','',31,5,0,'','admin/commerce/products/add/deposit','Create !name','t','a:1:{s:5:\"!name\";s:13:\"Funds Deposit\";}','','a:0:{}',6,'Stores a Funds Deposit Operation','',0,'sites/all/modules/commerce/modules/product/includes/commerce_product_ui.products.inc'),('admin/commerce/products/add/product','','','commerce_product_access','a:2:{i:0;s:6:\"create\";i:1;O:8:\"stdClass\":10:{s:4:\"type\";s:7:\"product\";s:10:\"product_id\";N;s:6:\"is_new\";b:1;s:3:\"sku\";s:0:\"\";s:11:\"revision_id\";N;s:5:\"title\";s:0:\"\";s:3:\"uid\";s:0:\"\";s:6:\"status\";i:1;s:7:\"created\";s:0:\"\";s:7:\"changed\";s:0:\"\";}}','commerce_product_ui_product_form_wrapper','a:1:{i:0;O:8:\"stdClass\":10:{s:4:\"type\";s:7:\"product\";s:10:\"product_id\";N;s:6:\"is_new\";b:1;s:3:\"sku\";s:0:\"\";s:11:\"revision_id\";N;s:5:\"title\";s:0:\"\";s:3:\"uid\";s:0:\"\";s:6:\"status\";i:1;s:7:\"created\";s:0:\"\";s:7:\"changed\";s:0:\"\";}}','',31,5,0,'','admin/commerce/products/add/product','Create !name','t','a:1:{s:5:\"!name\";s:7:\"Product\";}','','a:0:{}',6,'A basic product type.','',0,'sites/all/modules/commerce/modules/product/includes/commerce_product_ui.products.inc'),('admin/commerce/products/list','','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:36:\"administer commerce_product entities\";}}}','views_page','a:2:{i:0;s:17:\"commerce_products\";i:1;s:10:\"admin_page\";}','',15,4,1,'admin/commerce/products','admin/commerce/products','List','t','','','a:0:{}',140,'','',-10,''),('admin/commerce/products/types','','','user_access','a:1:{i:0;s:24:\"administer product types\";}','commerce_product_ui_types_overview','a:0:{}','',15,4,1,'admin/commerce/products','admin/commerce/products','Product types','t','','','a:0:{}',132,'Manage products types for your store.','',0,'sites/all/modules/commerce/modules/product/includes/commerce_product_ui.types.inc'),('admin/commerce/products/types/add','','','user_access','a:1:{i:0;s:24:\"administer product types\";}','commerce_product_ui_product_type_form_wrapper','a:1:{i:0;a:5:{s:4:\"type\";s:0:\"\";s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:4:\"help\";s:0:\"\";s:8:\"revision\";i:1;}}','',31,5,1,'admin/commerce/products/types','admin/commerce/products','Add product type','t','','','a:0:{}',388,'','',0,'sites/all/modules/commerce/modules/product/includes/commerce_product_ui.types.inc'),('admin/commerce/products/types/deposit','','','user_access','a:1:{i:0;s:24:\"administer product types\";}','commerce_product_ui_product_type_form_wrapper','a:1:{i:0;s:7:\"deposit\";}','',31,5,0,'','admin/commerce/products/types/deposit','Funds Deposit','t','','','a:0:{}',6,'','',0,'sites/all/modules/commerce/modules/product/includes/commerce_product_ui.types.inc'),('admin/commerce/products/types/deposit/display','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"deposit\";i:3;s:7:\"default\";}','',63,6,3,'admin/commerce/products/types/deposit','admin/commerce/products/types/deposit','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/deposit/display/commerce_line_item_display','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"deposit\";i:2;s:26:\"commerce_line_item_display\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"deposit\";i:3;s:26:\"commerce_line_item_display\";}','',127,7,1,'admin/commerce/products/types/deposit/display','admin/commerce/products/types/deposit','Commerce Line item: Display','t','','','a:0:{}',132,'','',3,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/deposit/display/commerce_line_item_token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"deposit\";i:2;s:24:\"commerce_line_item_token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"deposit\";i:3;s:24:\"commerce_line_item_token\";}','',127,7,1,'admin/commerce/products/types/deposit/display','admin/commerce/products/types/deposit','Commerce Line item: Tokens','t','','','a:0:{}',132,'','',4,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/deposit/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"deposit\";i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"deposit\";i:3;s:7:\"default\";}','',127,7,1,'admin/commerce/products/types/deposit/display','admin/commerce/products/types/deposit','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/deposit/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"deposit\";i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"deposit\";i:3;s:4:\"full\";}','',127,7,1,'admin/commerce/products/types/deposit/display','admin/commerce/products/types/deposit','Admin display','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/deposit/display/line_item','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"deposit\";i:2;s:9:\"line_item\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"deposit\";i:3;s:9:\"line_item\";}','',127,7,1,'admin/commerce/products/types/deposit/display','admin/commerce/products/types/deposit','Line item','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/deposit/display/node_email_html','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"deposit\";i:2;s:15:\"node_email_html\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"deposit\";i:3;s:15:\"node_email_html\";}','',127,7,1,'admin/commerce/products/types/deposit/display','admin/commerce/products/types/deposit','Node: Email: HTML','t','','','a:0:{}',132,'','',11,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/deposit/display/node_email_plain','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"deposit\";i:2;s:16:\"node_email_plain\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"deposit\";i:3;s:16:\"node_email_plain\";}','',127,7,1,'admin/commerce/products/types/deposit/display','admin/commerce/products/types/deposit','Node: Email: Plain','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/deposit/display/node_email_textalt','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"deposit\";i:2;s:18:\"node_email_textalt\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"deposit\";i:3;s:18:\"node_email_textalt\";}','',127,7,1,'admin/commerce/products/types/deposit/display','admin/commerce/products/types/deposit','Node: Email: HTML text alternative','t','','','a:0:{}',132,'','',12,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/deposit/display/node_full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"deposit\";i:2;s:9:\"node_full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"deposit\";i:3;s:9:\"node_full\";}','',127,7,1,'admin/commerce/products/types/deposit/display','admin/commerce/products/types/deposit','Node: Full content','t','','','a:0:{}',132,'','',5,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/deposit/display/node_rss','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"deposit\";i:2;s:8:\"node_rss\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"deposit\";i:3;s:8:\"node_rss\";}','',127,7,1,'admin/commerce/products/types/deposit/display','admin/commerce/products/types/deposit','Node: RSS','t','','','a:0:{}',132,'','',7,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/deposit/display/node_search_index','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"deposit\";i:2;s:17:\"node_search_index\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"deposit\";i:3;s:17:\"node_search_index\";}','',127,7,1,'admin/commerce/products/types/deposit/display','admin/commerce/products/types/deposit','Node: Search index','t','','','a:0:{}',132,'','',8,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/deposit/display/node_search_result','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"deposit\";i:2;s:18:\"node_search_result\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"deposit\";i:3;s:18:\"node_search_result\";}','',127,7,1,'admin/commerce/products/types/deposit/display','admin/commerce/products/types/deposit','Node: Search result highlighting input','t','','','a:0:{}',132,'','',9,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/deposit/display/node_teaser','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"deposit\";i:2;s:11:\"node_teaser\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"deposit\";i:3;s:11:\"node_teaser\";}','',127,7,1,'admin/commerce/products/types/deposit/display','admin/commerce/products/types/deposit','Node: Teaser','t','','','a:0:{}',132,'','',6,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/deposit/display/node_token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"deposit\";i:2;s:10:\"node_token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"deposit\";i:3;s:10:\"node_token\";}','',127,7,1,'admin/commerce/products/types/deposit/display','admin/commerce/products/types/deposit','Node: Tokens','t','','','a:0:{}',132,'','',13,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/deposit/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"deposit\";i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"deposit\";i:3;s:5:\"token\";}','',127,7,1,'admin/commerce/products/types/deposit/display','admin/commerce/products/types/deposit','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/deposit/fields','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"deposit\";}','',63,6,3,'admin/commerce/products/types/deposit','admin/commerce/products/types/deposit','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/deposit/fields/%','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:16:\"commerce_product\";i:1;s:7:\"deposit\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}','',126,7,0,'','admin/commerce/products/types/deposit/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/deposit/fields/%/delete','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:16:\"commerce_product\";i:1;s:7:\"deposit\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:6;}','',253,8,1,'admin/commerce/products/types/deposit/fields/%','admin/commerce/products/types/deposit/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/deposit/fields/%/edit','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:16:\"commerce_product\";i:1;s:7:\"deposit\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}','',253,8,1,'admin/commerce/products/types/deposit/fields/%','admin/commerce/products/types/deposit/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/deposit/fields/%/field-settings','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:16:\"commerce_product\";i:1;s:7:\"deposit\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:6;}','',253,8,1,'admin/commerce/products/types/deposit/fields/%','admin/commerce/products/types/deposit/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/deposit/fields/%/widget-type','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:16:\"commerce_product\";i:1;s:7:\"deposit\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:6;}','',253,8,1,'admin/commerce/products/types/deposit/fields/%','admin/commerce/products/types/deposit/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/deposit/fields/replace/%','a:1:{i:7;N;}','','user_access','a:1:{i:0;s:24:\"administer product types\";}','drupal_get_form','a:4:{i:0;s:28:\"title_field_replacement_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"deposit\";i:3;i:7;}','',254,8,0,'','admin/commerce/products/types/deposit/fields/replace/%','Replace fields','t','','','a:0:{}',6,'','',0,'sites/all/modules/title/title.admin.inc'),('admin/commerce/products/types/deposit/groups/%/delete','a:1:{i:6;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:16:\"commerce_product\";i:1;s:7:\"deposit\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer product types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:6;}','',253,8,0,'','admin/commerce/products/types/deposit/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/products/types/deposit/groups/%/enable','a:1:{i:6;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:16:\"commerce_product\";i:1;s:7:\"deposit\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer product types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:6;}','',253,8,0,'','admin/commerce/products/types/deposit/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/products/types/product','','','user_access','a:1:{i:0;s:24:\"administer product types\";}','commerce_product_ui_product_type_form_wrapper','a:1:{i:0;s:7:\"product\";}','',31,5,0,'','admin/commerce/products/types/product','Product','t','','','a:0:{}',6,'','',0,'sites/all/modules/commerce/modules/product/includes/commerce_product_ui.types.inc'),('admin/commerce/products/types/product/delete','','','commerce_product_ui_product_type_update_access','a:1:{i:0;s:7:\"product\";}','commerce_product_ui_product_type_delete_form_wrapper','a:1:{i:0;s:7:\"product\";}','',63,6,2,'admin/commerce/products/types/product','admin/commerce/products/types/product','Delete','t','','','a:0:{}',132,'','',10,'sites/all/modules/commerce/modules/product/includes/commerce_product_ui.types.inc'),('admin/commerce/products/types/product/display','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"product\";i:3;s:7:\"default\";}','',63,6,3,'admin/commerce/products/types/product','admin/commerce/products/types/product','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/product/display/commerce_line_item_display','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"product\";i:2;s:26:\"commerce_line_item_display\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"product\";i:3;s:26:\"commerce_line_item_display\";}','',127,7,1,'admin/commerce/products/types/product/display','admin/commerce/products/types/product','Commerce Line item: Display','t','','','a:0:{}',132,'','',3,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/product/display/commerce_line_item_token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"product\";i:2;s:24:\"commerce_line_item_token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"product\";i:3;s:24:\"commerce_line_item_token\";}','',127,7,1,'admin/commerce/products/types/product/display','admin/commerce/products/types/product','Commerce Line item: Tokens','t','','','a:0:{}',132,'','',4,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/product/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"product\";i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"product\";i:3;s:7:\"default\";}','',127,7,1,'admin/commerce/products/types/product/display','admin/commerce/products/types/product','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/product/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"product\";i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"product\";i:3;s:4:\"full\";}','',127,7,1,'admin/commerce/products/types/product/display','admin/commerce/products/types/product','Admin display','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/product/display/line_item','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"product\";i:2;s:9:\"line_item\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"product\";i:3;s:9:\"line_item\";}','',127,7,1,'admin/commerce/products/types/product/display','admin/commerce/products/types/product','Line item','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/product/display/node_email_html','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"product\";i:2;s:15:\"node_email_html\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"product\";i:3;s:15:\"node_email_html\";}','',127,7,1,'admin/commerce/products/types/product/display','admin/commerce/products/types/product','Node: Email: HTML','t','','','a:0:{}',132,'','',11,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/product/display/node_email_plain','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"product\";i:2;s:16:\"node_email_plain\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"product\";i:3;s:16:\"node_email_plain\";}','',127,7,1,'admin/commerce/products/types/product/display','admin/commerce/products/types/product','Node: Email: Plain','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/product/display/node_email_textalt','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"product\";i:2;s:18:\"node_email_textalt\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"product\";i:3;s:18:\"node_email_textalt\";}','',127,7,1,'admin/commerce/products/types/product/display','admin/commerce/products/types/product','Node: Email: HTML text alternative','t','','','a:0:{}',132,'','',12,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/product/display/node_full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"product\";i:2;s:9:\"node_full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"product\";i:3;s:9:\"node_full\";}','',127,7,1,'admin/commerce/products/types/product/display','admin/commerce/products/types/product','Node: Full content','t','','','a:0:{}',132,'','',5,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/product/display/node_rss','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"product\";i:2;s:8:\"node_rss\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"product\";i:3;s:8:\"node_rss\";}','',127,7,1,'admin/commerce/products/types/product/display','admin/commerce/products/types/product','Node: RSS','t','','','a:0:{}',132,'','',7,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/product/display/node_search_index','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"product\";i:2;s:17:\"node_search_index\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"product\";i:3;s:17:\"node_search_index\";}','',127,7,1,'admin/commerce/products/types/product/display','admin/commerce/products/types/product','Node: Search index','t','','','a:0:{}',132,'','',8,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/product/display/node_search_result','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"product\";i:2;s:18:\"node_search_result\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"product\";i:3;s:18:\"node_search_result\";}','',127,7,1,'admin/commerce/products/types/product/display','admin/commerce/products/types/product','Node: Search result highlighting input','t','','','a:0:{}',132,'','',9,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/product/display/node_teaser','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"product\";i:2;s:11:\"node_teaser\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"product\";i:3;s:11:\"node_teaser\";}','',127,7,1,'admin/commerce/products/types/product/display','admin/commerce/products/types/product','Node: Teaser','t','','','a:0:{}',132,'','',6,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/product/display/node_token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"product\";i:2;s:10:\"node_token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"product\";i:3;s:10:\"node_token\";}','',127,7,1,'admin/commerce/products/types/product/display','admin/commerce/products/types/product','Node: Tokens','t','','','a:0:{}',132,'','',13,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/product/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:16:\"commerce_product\";i:1;s:7:\"product\";i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"product\";i:3;s:5:\"token\";}','',127,7,1,'admin/commerce/products/types/product/display','admin/commerce/products/types/product','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/product/edit','','','commerce_product_ui_product_type_update_access','a:1:{i:0;s:7:\"product\";}','commerce_product_ui_product_type_form_wrapper','a:1:{i:0;s:7:\"product\";}','',63,6,3,'admin/commerce/products/types/product','admin/commerce/products/types/product','Edit','t','','','a:0:{}',140,'','',0,'sites/all/modules/commerce/modules/product/includes/commerce_product_ui.types.inc'),('admin/commerce/products/types/product/fields','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"product\";}','',63,6,3,'admin/commerce/products/types/product','admin/commerce/products/types/product','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/product/fields/%','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:16:\"commerce_product\";i:1;s:7:\"product\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}','',126,7,0,'','admin/commerce/products/types/product/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/product/fields/%/delete','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:16:\"commerce_product\";i:1;s:7:\"product\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:6;}','',253,8,1,'admin/commerce/products/types/product/fields/%','admin/commerce/products/types/product/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/product/fields/%/edit','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:16:\"commerce_product\";i:1;s:7:\"product\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}','',253,8,1,'admin/commerce/products/types/product/fields/%','admin/commerce/products/types/product/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/product/fields/%/field-settings','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:16:\"commerce_product\";i:1;s:7:\"product\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:6;}','',253,8,1,'admin/commerce/products/types/product/fields/%','admin/commerce/products/types/product/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/product/fields/%/widget-type','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:16:\"commerce_product\";i:1;s:7:\"product\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer product types\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:6;}','',253,8,1,'admin/commerce/products/types/product/fields/%','admin/commerce/products/types/product/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/commerce/products/types/product/fields/replace/%','a:1:{i:7;N;}','','user_access','a:1:{i:0;s:24:\"administer product types\";}','drupal_get_form','a:4:{i:0;s:28:\"title_field_replacement_form\";i:1;s:16:\"commerce_product\";i:2;s:7:\"product\";i:3;i:7;}','',254,8,0,'','admin/commerce/products/types/product/fields/replace/%','Replace fields','t','','','a:0:{}',6,'','',0,'sites/all/modules/title/title.admin.inc'),('admin/commerce/products/types/product/groups/%/delete','a:1:{i:6;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:16:\"commerce_product\";i:1;s:7:\"product\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer product types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:6;}','',253,8,0,'','admin/commerce/products/types/product/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/commerce/products/types/product/groups/%/enable','a:1:{i:6;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:16:\"commerce_product\";i:1;s:7:\"product\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer product types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:6;}','',253,8,0,'','admin/commerce/products/types/product/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/compact','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_compact_page','a:0:{}','',3,2,0,'','admin/compact','Compact mode','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/config','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_config_page','a:0:{}','',3,2,0,'','admin/config','Configuration','t','','','a:0:{}',6,'Administer settings.','',0,'modules/system/system.admin.inc'),('admin/config/administration','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/administration','Administration','t','','','a:0:{}',6,'Administration tools.','',0,'modules/system/system.admin.inc'),('admin/config/administration/admin_menu','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:25:\"admin_menu_theme_settings\";}','',15,4,0,'','admin/config/administration/admin_menu','Administration menu','t','','','a:0:{}',6,'Adjust administration menu settings.','',0,'sites/all/modules/admin_menu/admin_menu.inc'),('admin/config/content','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/content','Content authoring','t','','','a:0:{}',6,'Settings related to formatting and authoring content.','left',-15,'modules/system/system.admin.inc'),('admin/config/content/ckeditor','','','user_access','a:1:{i:0;s:19:\"administer ckeditor\";}','ckeditor_admin_main','a:0:{}','',15,4,0,'','admin/config/content/ckeditor','CKEditor','t','','','a:0:{}',6,'Configure the rich text editor.','',0,'sites/all/modules/ckeditor/includes/ckeditor.admin.inc'),('admin/config/content/ckeditor/add','','','user_access','a:1:{i:0;s:19:\"administer ckeditor\";}','drupal_get_form','a:2:{i:0;s:27:\"ckeditor_admin_profile_form\";i:1;s:3:\"add\";}','',31,5,0,'','admin/config/content/ckeditor/add','Add a new CKEditor profile','t','','','a:0:{}',0,'Configure the rich text editor.','',0,'sites/all/modules/ckeditor/includes/ckeditor.admin.inc'),('admin/config/content/ckeditor/addg','','','user_access','a:1:{i:0;s:19:\"administer ckeditor\";}','drupal_get_form','a:2:{i:0;s:34:\"ckeditor_admin_global_profile_form\";i:1;s:3:\"add\";}','',31,5,0,'','admin/config/content/ckeditor/addg','Add the CKEditor Global profile','t','','','a:0:{}',0,'Configure the rich text editor.','',0,'sites/all/modules/ckeditor/includes/ckeditor.admin.inc'),('admin/config/content/ckeditor/clone/%','a:1:{i:5;s:21:\"ckeditor_profile_load\";}','','user_access','a:1:{i:0;s:19:\"administer ckeditor\";}','drupal_get_form','a:3:{i:0;s:33:\"ckeditor_admin_profile_clone_form\";i:1;s:5:\"clone\";i:2;i:5;}','',62,6,0,'','admin/config/content/ckeditor/clone/%','Clone the CKEditor profile','t','','','a:0:{}',0,'Configure the rich text editor.','',0,'sites/all/modules/ckeditor/includes/ckeditor.admin.inc'),('admin/config/content/ckeditor/delete/%','a:1:{i:5;s:21:\"ckeditor_profile_load\";}','','user_access','a:1:{i:0;s:19:\"administer ckeditor\";}','drupal_get_form','a:2:{i:0;s:34:\"ckeditor_admin_profile_delete_form\";i:1;i:5;}','',62,6,0,'','admin/config/content/ckeditor/delete/%','Delete the CKEditor profile','t','','','a:0:{}',0,'Configure the rich text editor.','',0,'sites/all/modules/ckeditor/includes/ckeditor.admin.inc'),('admin/config/content/ckeditor/edit/%','a:1:{i:5;s:21:\"ckeditor_profile_load\";}','','user_access','a:1:{i:0;s:19:\"administer ckeditor\";}','drupal_get_form','a:3:{i:0;s:27:\"ckeditor_admin_profile_form\";i:1;s:4:\"edit\";i:2;i:5;}','',62,6,0,'','admin/config/content/ckeditor/edit/%','Edit the CKEditor profile','t','','','a:0:{}',0,'Configure the rich text editor.','',0,'sites/all/modules/ckeditor/includes/ckeditor.admin.inc'),('admin/config/content/ckeditor/editg','','','user_access','a:1:{i:0;s:19:\"administer ckeditor\";}','drupal_get_form','a:2:{i:0;s:34:\"ckeditor_admin_global_profile_form\";i:1;s:4:\"edit\";}','',31,5,0,'','admin/config/content/ckeditor/editg','Edit the CKEditor Global profile','t','','','a:0:{}',0,'Configure the rich text editor.','',0,'sites/all/modules/ckeditor/includes/ckeditor.admin.inc'),('admin/config/content/ckeditor/skinframe','','','user_access','a:1:{i:0;s:19:\"administer ckeditor\";}','ckeditor_skinframe','a:0:{}','',31,5,0,'','admin/config/content/ckeditor/skinframe','Change skin of CKEditor','t','','','a:0:{}',0,'Configure skin for CKEditor.','',0,'sites/all/modules/ckeditor/includes/ckeditor.admin.inc'),('admin/config/content/exclude_node_title','','','user_access','a:1:{i:0;s:29:\"administer exclude node title\";}','drupal_get_form','a:1:{i:0;s:33:\"exclude_node_title_admin_settings\";}','',15,4,0,'','admin/config/content/exclude_node_title','Exclude Node Title','t','','','a:0:{}',6,'Exclude Node Title from display','',0,'sites/all/modules/exclude_node_title/exclude_node_title.admin.inc'),('admin/config/content/fivestar','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:17:\"fivestar_settings\";}','',15,4,0,'','admin/config/content/fivestar','Fivestar','t','','','a:0:{}',6,'Configure site-wide widgets used for Fivestar rating.','',0,'sites/all/modules/fivestar/includes/fivestar.admin.inc'),('admin/config/content/formats','','','user_access','a:1:{i:0;s:18:\"administer filters\";}','drupal_get_form','a:1:{i:0;s:21:\"filter_admin_overview\";}','',15,4,0,'','admin/config/content/formats','Text formats','t','','','a:0:{}',6,'Configure how content input by users is filtered, including allowed HTML tags. Also allows enabling of module-provided filters.','',0,'modules/filter/filter.admin.inc'),('admin/config/content/formats/%','a:1:{i:4;s:18:\"filter_format_load\";}','','user_access','a:1:{i:0;s:18:\"administer filters\";}','filter_admin_format_page','a:1:{i:0;i:4;}','',30,5,0,'','admin/config/content/formats/%','','filter_admin_format_title','a:1:{i:0;i:4;}','','a:0:{}',6,'','',0,'modules/filter/filter.admin.inc'),('admin/config/content/formats/%/disable','a:1:{i:4;s:18:\"filter_format_load\";}','','_filter_disable_format_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:20:\"filter_admin_disable\";i:1;i:4;}','',61,6,0,'','admin/config/content/formats/%/disable','Disable text format','t','','','a:0:{}',6,'','',0,'modules/filter/filter.admin.inc'),('admin/config/content/formats/add','','','user_access','a:1:{i:0;s:18:\"administer filters\";}','filter_admin_format_page','a:0:{}','',31,5,1,'admin/config/content/formats','admin/config/content/formats','Add text format','t','','','a:0:{}',388,'','',1,'modules/filter/filter.admin.inc'),('admin/config/content/formats/list','','','user_access','a:1:{i:0;s:18:\"administer filters\";}','drupal_get_form','a:1:{i:0;s:21:\"filter_admin_overview\";}','',31,5,1,'admin/config/content/formats','admin/config/content/formats','List','t','','','a:0:{}',140,'','',0,'modules/filter/filter.admin.inc'),('admin/config/content/tagclouds','','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:1:{i:0;s:18:\"tagclouds_settings\";}','',15,4,0,'','admin/config/content/tagclouds','TagClouds configuration','t','','','a:0:{}',6,'Configure the tag clouds. Set the order, the number of tags, and the depth of the clouds.','',0,''),('admin/config/content/title','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:25:\"title_admin_settings_form\";}','',15,4,0,'','admin/config/content/title','Title settings','t','','','a:0:{}',6,'Settings for the Title module.','',0,'sites/all/modules/title/title.admin.inc'),('admin/config/content/webform','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:22:\"webform_admin_settings\";}','',15,4,0,'','admin/config/content/webform','Webform settings','t','','','a:0:{}',6,'Global configuration of webform functionality.','',0,'sites/all/modules/webform/includes/webform.admin.inc'),('admin/config/development','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/development','Development','t','','','a:0:{}',6,'Development tools.','right',-10,'modules/system/system.admin.inc'),('admin/config/development/devel','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:20:\"devel_admin_settings\";}','',15,4,0,'','admin/config/development/devel','Devel settings','t','','','a:0:{}',6,'Helper functions, pages, and blocks to assist Drupal developers. The devel blocks can be managed via the <a href=\"/en/admin/structure/block\">block administration</a> page.','',0,'sites/all/modules/devel/devel.admin.inc'),('admin/config/development/jquery_update','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:27:\"jquery_update_settings_form\";}','',15,4,0,'','admin/config/development/jquery_update','jQuery update','t','','','a:0:{}',6,'Configure settings related to the jQuery upgrade, the library path and compression.','',0,''),('admin/config/development/logging','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:23:\"system_logging_settings\";}','',15,4,0,'','admin/config/development/logging','Logging and errors','t','','','a:0:{}',6,'Settings for logging and alerts modules. Various modules can route Drupal\'s system events to different destinations, such as syslog, database, email, etc.','',-15,'modules/system/system.admin.inc'),('admin/config/development/maintenance','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:28:\"system_site_maintenance_mode\";}','',15,4,0,'','admin/config/development/maintenance','Maintenance mode','t','','','a:0:{}',6,'Take the site offline for maintenance or bring it back online.','',-10,'modules/system/system.admin.inc'),('admin/config/development/performance','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:27:\"system_performance_settings\";}','',15,4,0,'','admin/config/development/performance','Performance','t','','','a:0:{}',6,'Enable or disable page caching for anonymous users and set CSS and JS bandwidth optimization options.','',-20,'modules/system/system.admin.inc'),('admin/config/development/session-api','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:25:\"session_api_settings_form\";}','',15,4,0,'','admin/config/development/session-api','Session API Configuration','t','','','a:0:{}',6,'Configure Session API behavior.','',0,'sites/all/modules/session_api/session_api.admin.inc'),('admin/config/media','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/media','Media','t','','','a:0:{}',6,'Media tools.','left',-10,'modules/system/system.admin.inc'),('admin/config/media/file-system','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:27:\"system_file_system_settings\";}','',15,4,0,'','admin/config/media/file-system','File system','t','','','a:0:{}',6,'Tell Drupal where to store uploaded files and how they are accessed.','',-10,'modules/system/system.admin.inc'),('admin/config/media/flexslider','','','ctools_export_ui_task_access','a:2:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:4:\"list\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:4:\"list\";}','',15,4,0,'','admin/config/media/flexslider','FlexSlider','t','','','a:0:{}',6,'Administer FlexSlider presets.','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/flexslider/add','','','ctools_export_ui_task_access','a:2:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:3:\"add\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:3:\"add\";}','',31,5,1,'admin/config/media/flexslider','admin/config/media/flexslider','Add','t','','','a:0:{}',388,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/flexslider/advanced','','','user_access','a:1:{i:0;s:21:\"administer flexslider\";}','drupal_get_form','a:1:{i:0;s:24:\"flexslider_form_settings\";}','',31,5,1,'admin/config/media/flexslider','admin/config/media/flexslider','Advanced settings','t','','','a:0:{}',132,'Configure the advanced flexslider module settings.','',2,'sites/all/modules/flexslider/flexslider.admin.inc'),('admin/config/media/flexslider/import','','','ctools_export_ui_task_access','a:2:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:6:\"import\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:6:\"import\";}','',31,5,1,'admin/config/media/flexslider','admin/config/media/flexslider','Import','t','','','a:0:{}',388,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/flexslider/list','','','ctools_export_ui_task_access','a:2:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:4:\"list\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:4:\"list\";}','',31,5,1,'admin/config/media/flexslider','admin/config/media/flexslider','List','t','','','a:0:{}',140,'','',-10,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/flexslider/list/%','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"flexslider_ctools_export_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:4:\"edit\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:4:\"edit\";i:2;i:5;}','',62,6,0,'','admin/config/media/flexslider/list/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/flexslider/list/%/clone','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"flexslider_ctools_export_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:5:\"clone\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:5:\"clone\";i:2;i:5;}','',125,7,0,'','admin/config/media/flexslider/list/%/clone','Clone','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/flexslider/list/%/delete','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"flexslider_ctools_export_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:6:\"delete\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:6:\"delete\";i:2;i:5;}','',125,7,0,'','admin/config/media/flexslider/list/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/flexslider/list/%/disable','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"flexslider_ctools_export_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:7:\"disable\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:7:\"disable\";i:2;i:5;}','',125,7,0,'','admin/config/media/flexslider/list/%/disable','Disable','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/flexslider/list/%/edit','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"flexslider_ctools_export_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:4:\"edit\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:4:\"edit\";i:2;i:5;}','',125,7,1,'admin/config/media/flexslider/list/%','admin/config/media/flexslider/list/%','Edit','t','','','a:0:{}',140,'','',-10,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/flexslider/list/%/enable','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"flexslider_ctools_export_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:6:\"enable\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:6:\"enable\";i:2;i:5;}','',125,7,0,'','admin/config/media/flexslider/list/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/flexslider/list/%/export','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"flexslider_ctools_export_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:6:\"export\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:6:\"export\";i:2;i:5;}','',125,7,1,'admin/config/media/flexslider/list/%','admin/config/media/flexslider/list/%','Export','t','','','a:0:{}',132,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/flexslider/list/%/revert','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"flexslider_ctools_export_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:6:\"revert\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:6:\"delete\";i:2;i:5;}','',125,7,0,'','admin/config/media/flexslider/list/%/revert','Revert','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/icon','','','user_access','a:1:{i:0;s:16:\"administer icons\";}','drupal_get_form','a:1:{i:0;s:25:\"icon_bundle_overview_form\";}','',15,4,0,'','admin/config/media/icon','Icons','t','','','a:0:{}',6,'Overview of all available icons.','',0,'sites/all/modules/icon/includes/admin.inc'),('admin/config/media/icon/bundle/%','a:1:{i:5;s:16:\"icon_bundle_load\";}','','user_access','a:1:{i:0;s:16:\"administer icons\";}','icon_bundle_list','a:1:{i:0;i:5;}','',62,6,0,'','admin/config/media/icon/bundle/%','','icon_bundle_get_title','a:1:{i:0;i:5;}','icon_bundle_get_theme','a:1:{i:0;i:5;}',6,'An icon bundle.','',0,'sites/all/modules/icon/includes/admin.inc'),('admin/config/media/icon/bundle/%/configure','a:1:{i:5;s:16:\"icon_bundle_load\";}','','user_access','a:1:{i:0;s:16:\"administer icons\";}','drupal_get_form','a:2:{i:0;s:26:\"icon_bundle_configure_form\";i:1;i:5;}','',125,7,1,'admin/config/media/icon/bundle/%','admin/config/media/icon/bundle/%','Configure','t','','icon_bundle_get_theme','a:1:{i:0;i:5;}',132,'Form callback for configuring an icon bundle.','',0,'sites/all/modules/icon/includes/admin.inc'),('admin/config/media/icon/bundle/%/delete','a:1:{i:5;s:16:\"icon_bundle_load\";}','','user_access','a:1:{i:0;s:16:\"administer icons\";}','drupal_get_form','a:2:{i:0;s:23:\"icon_bundle_delete_form\";i:1;i:5;}','',125,7,0,'','admin/config/media/icon/bundle/%/delete','Delete','t','','icon_bundle_get_theme','a:1:{i:0;i:5;}',0,'Confirmation page for deleting an icon bundle from the database.','',0,'sites/all/modules/icon/includes/admin.inc'),('admin/config/media/icon/bundle/%/icons','a:1:{i:5;s:16:\"icon_bundle_load\";}','','user_access','a:1:{i:0;s:16:\"administer icons\";}','icon_bundle_list','a:1:{i:0;i:5;}','',125,7,1,'admin/config/media/icon/bundle/%','admin/config/media/icon/bundle/%','Icons','t','','icon_bundle_get_theme','a:1:{i:0;i:5;}',140,'Provide an overview of all available icon bundles.','',-10,'sites/all/modules/icon/includes/admin.inc'),('admin/config/media/icon/bundle/%/reset','a:1:{i:5;s:16:\"icon_bundle_load\";}','','user_access','a:1:{i:0;s:16:\"administer icons\";}','drupal_get_form','a:2:{i:0;s:22:\"icon_bundle_reset_form\";i:1;i:5;}','',125,7,0,'','admin/config/media/icon/bundle/%/reset','Reset','t','','icon_bundle_get_theme','a:1:{i:0;i:5;}',0,'Confirmation page for resetting a module or theme provided bundle that has been overridden in the database.','',0,'sites/all/modules/icon/includes/admin.inc'),('admin/config/media/icon/overview','','','user_access','a:1:{i:0;s:16:\"administer icons\";}','drupal_get_form','a:1:{i:0;s:25:\"icon_bundle_overview_form\";}','',31,5,1,'admin/config/media/icon','admin/config/media/icon','Bundles','t','','','a:0:{}',140,'Overview of all available icon bundles.','',-10,'sites/all/modules/icon/includes/admin.inc'),('admin/config/media/image-styles','','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','image_style_list','a:0:{}','',15,4,0,'','admin/config/media/image-styles','Image styles','t','','','a:0:{}',6,'Configure styles that can be used for resizing or adjusting images on display.','',0,'modules/image/image.admin.inc'),('admin/config/media/image-styles/add','','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','drupal_get_form','a:1:{i:0;s:20:\"image_style_add_form\";}','',31,5,1,'admin/config/media/image-styles','admin/config/media/image-styles','Add style','t','','','a:0:{}',388,'Add a new image style.','',2,'modules/image/image.admin.inc'),('admin/config/media/image-styles/delete/%','a:1:{i:5;a:1:{s:16:\"image_style_load\";a:2:{i:0;N;i:1;s:1:\"1\";}}}','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','drupal_get_form','a:2:{i:0;s:23:\"image_style_delete_form\";i:1;i:5;}','',62,6,0,'','admin/config/media/image-styles/delete/%','Delete style','t','','','a:0:{}',6,'Delete an image style.','',0,'modules/image/image.admin.inc'),('admin/config/media/image-styles/edit/%','a:1:{i:5;s:16:\"image_style_load\";}','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','drupal_get_form','a:2:{i:0;s:16:\"image_style_form\";i:1;i:5;}','',62,6,0,'','admin/config/media/image-styles/edit/%','Edit style','t','','','a:0:{}',6,'Configure an image style.','',0,'modules/image/image.admin.inc'),('admin/config/media/image-styles/edit/%/add/%','a:2:{i:5;a:1:{s:16:\"image_style_load\";a:1:{i:0;i:5;}}i:7;a:1:{s:28:\"image_effect_definition_load\";a:1:{i:0;i:5;}}}','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','drupal_get_form','a:3:{i:0;s:17:\"image_effect_form\";i:1;i:5;i:2;i:7;}','',250,8,0,'','admin/config/media/image-styles/edit/%/add/%','Add image effect','t','','','a:0:{}',6,'Add a new effect to a style.','',0,'modules/image/image.admin.inc'),('admin/config/media/image-styles/edit/%/effects/%','a:2:{i:5;a:1:{s:16:\"image_style_load\";a:2:{i:0;i:5;i:1;s:1:\"3\";}}i:7;a:1:{s:17:\"image_effect_load\";a:2:{i:0;i:5;i:1;s:1:\"3\";}}}','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','drupal_get_form','a:3:{i:0;s:17:\"image_effect_form\";i:1;i:5;i:2;i:7;}','',250,8,0,'','admin/config/media/image-styles/edit/%/effects/%','Edit image effect','t','','','a:0:{}',6,'Edit an existing effect within a style.','',0,'modules/image/image.admin.inc'),('admin/config/media/image-styles/edit/%/effects/%/delete','a:2:{i:5;a:1:{s:16:\"image_style_load\";a:2:{i:0;i:5;i:1;s:1:\"3\";}}i:7;a:1:{s:17:\"image_effect_load\";a:2:{i:0;i:5;i:1;s:1:\"3\";}}}','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','drupal_get_form','a:3:{i:0;s:24:\"image_effect_delete_form\";i:1;i:5;i:2;i:7;}','',501,9,0,'','admin/config/media/image-styles/edit/%/effects/%/delete','Delete image effect','t','','','a:0:{}',6,'Delete an existing effect from a style.','',0,'modules/image/image.admin.inc'),('admin/config/media/image-styles/list','','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','image_style_list','a:0:{}','',31,5,1,'admin/config/media/image-styles','admin/config/media/image-styles','List','t','','','a:0:{}',140,'List the current image styles on the site.','',1,'modules/image/image.admin.inc'),('admin/config/media/image-styles/revert/%','a:1:{i:5;a:1:{s:16:\"image_style_load\";a:2:{i:0;N;i:1;s:1:\"2\";}}}','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','drupal_get_form','a:2:{i:0;s:23:\"image_style_revert_form\";i:1;i:5;}','',62,6,0,'','admin/config/media/image-styles/revert/%','Revert style','t','','','a:0:{}',6,'Revert an image style.','',0,'modules/image/image.admin.inc'),('admin/config/media/image-toolkit','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:29:\"system_image_toolkit_settings\";}','',15,4,0,'','admin/config/media/image-toolkit','Image toolkit','t','','','a:0:{}',6,'Choose which image toolkit to use if you have installed optional toolkits.','',20,'modules/system/system.admin.inc'),('admin/config/media/imce','','','user_access','a:1:{i:0;s:15:\"administer imce\";}','imce_admin','a:0:{}','',15,4,0,'','admin/config/media/imce','IMCE','t','','','a:0:{}',6,'Control how your image/file browser works.','',0,'sites/all/modules/imce/inc/imce.admin.inc'),('admin/config/media/imce/profile','','','user_access','a:1:{i:0;s:15:\"administer imce\";}','imce_profile_operations','a:0:{}','',31,5,0,'','admin/config/media/imce/profile','Add new profile','t','','','a:0:{}',4,'','',0,'sites/all/modules/imce/inc/imce.admin.inc'),('admin/config/menu_token','','','user_access','a:1:{i:0;s:21:\"administer menu_token\";}','drupal_get_form','a:1:{i:0;s:24:\"menu_token_settings_form\";}','',7,3,0,'','admin/config/menu_token','Menu Token','t','','','a:0:{}',6,'Configure the Menu Token module.','',0,'sites/all/modules/menu_token/menu_token.admin.inc'),('admin/config/people','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/people','People','t','','','a:0:{}',6,'Configure user accounts.','left',-20,'modules/system/system.admin.inc'),('admin/config/people/accounts','','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:1:{i:0;s:19:\"user_admin_settings\";}','',15,4,0,'','admin/config/people/accounts','Account settings','t','','','a:0:{}',6,'Configure default behavior of users, including registration requirements, e-mails, fields, and user pictures.','',-10,'modules/user/user.admin.inc'),('admin/config/people/accounts/display','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:16:\"administer users\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";i:3;s:7:\"default\";}','',31,5,1,'admin/config/people/accounts','admin/config/people/accounts','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:16:\"administer users\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";i:3;s:7:\"default\";}','',63,6,1,'admin/config/people/accounts/display','admin/config/people/accounts','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:16:\"administer users\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";i:3;s:4:\"full\";}','',63,6,1,'admin/config/people/accounts/display','admin/config/people/accounts','User account','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:16:\"administer users\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";i:3;s:5:\"token\";}','',63,6,1,'admin/config/people/accounts/display','admin/config/people/accounts','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:16:\"administer users\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";}','',31,5,1,'admin/config/people/accounts','admin/config/people/accounts','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields/%','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:16:\"administer users\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',62,6,0,'','admin/config/people/accounts/fields/%','','field_ui_menu_title','a:1:{i:0;i:5;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields/%/delete','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:16:\"administer users\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:5;}','',125,7,1,'admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields/%/edit','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:16:\"administer users\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',125,7,1,'admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields/%/field-settings','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:16:\"administer users\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:5;}','',125,7,1,'admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields/%/widget-type','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:16:\"administer users\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:5;}','',125,7,1,'admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/groups/%/delete','a:1:{i:5;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:5;}','',125,7,0,'','admin/config/people/accounts/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/config/people/accounts/groups/%/enable','a:1:{i:5;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:5;}','',125,7,0,'','admin/config/people/accounts/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/config/people/accounts/settings','','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:1:{i:0;s:19:\"user_admin_settings\";}','',31,5,1,'admin/config/people/accounts','admin/config/people/accounts','Settings','t','','','a:0:{}',140,'','',-10,'modules/user/user.admin.inc'),('admin/config/people/ip-blocking','','','user_access','a:1:{i:0;s:18:\"block IP addresses\";}','system_ip_blocking','a:0:{}','',15,4,0,'','admin/config/people/ip-blocking','IP address blocking','t','','','a:0:{}',6,'Manage blocked IP addresses.','',10,'modules/system/system.admin.inc'),('admin/config/people/ip-blocking/delete/%','a:1:{i:5;s:15:\"blocked_ip_load\";}','','user_access','a:1:{i:0;s:18:\"block IP addresses\";}','drupal_get_form','a:2:{i:0;s:25:\"system_ip_blocking_delete\";i:1;i:5;}','',62,6,0,'','admin/config/people/ip-blocking/delete/%','Delete IP address','t','','','a:0:{}',6,'','',0,'modules/system/system.admin.inc'),('admin/config/regional','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/regional','Regional and language','t','','','a:0:{}',6,'Regional settings, localization and translation.','left',-5,'modules/system/system.admin.inc'),('admin/config/regional/countries','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','countries_admin_overview','a:0:{}','',15,4,0,'','admin/config/regional/countries','Countries','t','','','a:0:{}',6,'List, edit, or add countries.','',0,'sites/all/modules/countries/countries.admin.inc'),('admin/config/regional/countries/%','a:1:{i:4;s:12:\"country_load\";}','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','countries_admin_page','a:1:{i:0;i:4;}','',30,5,0,'','admin/config/regional/countries/%','','countries_page_title','a:1:{i:0;i:4;}','','a:0:{}',4,'Edit a country.','',0,'sites/all/modules/countries/countries.admin.inc'),('admin/config/regional/countries/%/delete','a:1:{i:4;s:12:\"country_load\";}','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:2:{i:0;s:22:\"countries_admin_delete\";i:1;i:4;}','',61,6,0,'','admin/config/regional/countries/%/delete','Delete country','t','','','a:0:{}',4,'Country delete confirmation form.','',0,'sites/all/modules/countries/countries.admin.inc'),('admin/config/regional/countries/%/edit','a:1:{i:4;s:12:\"country_load\";}','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','countries_admin_page','a:1:{i:0;i:4;}','',61,6,1,'admin/config/regional/countries/%','admin/config/regional/countries/%','Edit','t','','','a:0:{}',140,'','',-10,'sites/all/modules/countries/countries.admin.inc'),('admin/config/regional/countries/add','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','countries_admin_page','a:0:{}','',31,5,1,'admin/config/regional/countries','admin/config/regional/countries','Add country','t','','','a:0:{}',388,'Admin page to add a country.','',1,'sites/all/modules/countries/countries.admin.inc'),('admin/config/regional/countries/display','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:29:\"administer site configuration\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"country\";i:2;s:7:\"country\";i:3;s:7:\"default\";}','',31,5,1,'admin/config/regional/countries','admin/config/regional/countries','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/config/regional/countries/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:7:\"country\";i:1;s:7:\"country\";i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:29:\"administer site configuration\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"country\";i:2;s:7:\"country\";i:3;s:7:\"default\";}','',63,6,1,'admin/config/regional/countries/display','admin/config/regional/countries','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/config/regional/countries/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:7:\"country\";i:1;s:7:\"country\";i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:29:\"administer site configuration\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"country\";i:2;s:7:\"country\";i:3;s:4:\"full\";}','',63,6,1,'admin/config/regional/countries/display','admin/config/regional/countries','Country','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/regional/countries/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:7:\"country\";i:1;s:7:\"country\";i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:29:\"administer site configuration\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"country\";i:2;s:7:\"country\";i:3;s:5:\"token\";}','',63,6,1,'admin/config/regional/countries/display','admin/config/regional/countries','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/config/regional/countries/fields','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:29:\"administer site configuration\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:7:\"country\";i:2;s:7:\"country\";}','',31,5,1,'admin/config/regional/countries','admin/config/regional/countries','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/config/regional/countries/fields/%','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"country\";i:1;s:7:\"country\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:29:\"administer site configuration\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',62,6,0,'','admin/config/regional/countries/fields/%','','field_ui_menu_title','a:1:{i:0;i:5;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/regional/countries/fields/%/delete','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"country\";i:1;s:7:\"country\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:29:\"administer site configuration\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:5;}','',125,7,1,'admin/config/regional/countries/fields/%','admin/config/regional/countries/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/config/regional/countries/fields/%/edit','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"country\";i:1;s:7:\"country\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:29:\"administer site configuration\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',125,7,1,'admin/config/regional/countries/fields/%','admin/config/regional/countries/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/regional/countries/fields/%/field-settings','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"country\";i:1;s:7:\"country\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:29:\"administer site configuration\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:5;}','',125,7,1,'admin/config/regional/countries/fields/%','admin/config/regional/countries/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/regional/countries/fields/%/widget-type','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"country\";i:1;s:7:\"country\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:29:\"administer site configuration\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:5;}','',125,7,1,'admin/config/regional/countries/fields/%','admin/config/regional/countries/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/regional/countries/groups/%/delete','a:1:{i:5;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:7:\"country\";i:1;s:7:\"country\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:5;}','',125,7,0,'','admin/config/regional/countries/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/config/regional/countries/groups/%/enable','a:1:{i:5;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:7:\"country\";i:1;s:7:\"country\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:5;}','',125,7,0,'','admin/config/regional/countries/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/config/regional/countries/import','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:27:\"countries_admin_import_form\";}','',31,5,1,'admin/config/regional/countries','admin/config/regional/countries','Update countries','t','','','a:0:{}',388,'Bulk import countries from the ISO standard.','',2,'sites/all/modules/countries/countries.admin.inc'),('admin/config/regional/countries/list','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','countries_admin_overview','a:0:{}','',31,5,1,'admin/config/regional/countries','admin/config/regional/countries','List','t','','','a:0:{}',140,'','',0,'sites/all/modules/countries/countries.admin.inc'),('admin/config/regional/date-time','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:25:\"system_date_time_settings\";}','',15,4,0,'','admin/config/regional/date-time','Date and time','t','','','a:0:{}',6,'Configure display formats for date and time.','',-15,'modules/system/system.admin.inc'),('admin/config/regional/date-time/formats','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','system_date_time_formats','a:0:{}','',31,5,1,'admin/config/regional/date-time','admin/config/regional/date-time','Formats','t','','','a:0:{}',132,'Configure display format strings for date and time.','',-9,'modules/system/system.admin.inc'),('admin/config/regional/date-time/formats/%/delete','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:2:{i:0;s:30:\"system_date_delete_format_form\";i:1;i:5;}','',125,7,0,'','admin/config/regional/date-time/formats/%/delete','Delete date format','t','','','a:0:{}',6,'Allow users to delete a configured date format.','',0,'modules/system/system.admin.inc'),('admin/config/regional/date-time/formats/%/edit','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:2:{i:0;s:34:\"system_configure_date_formats_form\";i:1;i:5;}','',125,7,0,'','admin/config/regional/date-time/formats/%/edit','Edit date format','t','','','a:0:{}',6,'Allow users to edit a configured date format.','',0,'modules/system/system.admin.inc'),('admin/config/regional/date-time/formats/add','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:34:\"system_configure_date_formats_form\";}','',63,6,1,'admin/config/regional/date-time/formats','admin/config/regional/date-time','Add format','t','','','a:0:{}',388,'Allow users to add additional date formats.','',-10,'modules/system/system.admin.inc'),('admin/config/regional/date-time/formats/lookup','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','system_date_time_lookup','a:0:{}','',63,6,0,'','admin/config/regional/date-time/formats/lookup','Date and time lookup','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/config/regional/date-time/locale','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','locale_date_format_language_overview_page','a:0:{}','',31,5,1,'admin/config/regional/date-time','admin/config/regional/date-time','Localize','t','','','a:0:{}',132,'Configure date formats for each locale','',-8,'modules/locale/locale.admin.inc'),('admin/config/regional/date-time/locale/%/edit','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:2:{i:0;s:23:\"locale_date_format_form\";i:1;i:5;}','',125,7,0,'','admin/config/regional/date-time/locale/%/edit','Localize date formats','t','','','a:0:{}',6,'Configure date formats for each locale','',0,'modules/locale/locale.admin.inc'),('admin/config/regional/date-time/locale/%/reset','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:2:{i:0;s:29:\"locale_date_format_reset_form\";i:1;i:5;}','',125,7,0,'','admin/config/regional/date-time/locale/%/reset','Reset date formats','t','','','a:0:{}',6,'Reset localized date formats to global defaults','',0,'modules/locale/locale.admin.inc'),('admin/config/regional/date-time/types','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:25:\"system_date_time_settings\";}','',31,5,1,'admin/config/regional/date-time','admin/config/regional/date-time','Types','t','','','a:0:{}',140,'Configure display formats for date and time.','',-10,'modules/system/system.admin.inc'),('admin/config/regional/date-time/types/%/delete','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:2:{i:0;s:35:\"system_delete_date_format_type_form\";i:1;i:5;}','',125,7,0,'','admin/config/regional/date-time/types/%/delete','Delete date type','t','','','a:0:{}',6,'Allow users to delete a configured date type.','',0,'modules/system/system.admin.inc'),('admin/config/regional/date-time/types/add','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:32:\"system_add_date_format_type_form\";}','',63,6,1,'admin/config/regional/date-time/types','admin/config/regional/date-time','Add date type','t','','','a:0:{}',388,'Add new date type.','',-10,'modules/system/system.admin.inc'),('admin/config/regional/language','','','user_access','a:1:{i:0;s:20:\"administer languages\";}','drupal_get_form','a:1:{i:0;s:30:\"locale_languages_overview_form\";}','',15,4,0,'','admin/config/regional/language','Languages','t','','','a:0:{}',6,'Configure languages for content and the user interface.','',-10,'modules/locale/locale.admin.inc'),('admin/config/regional/language/add','','','user_access','a:1:{i:0;s:20:\"administer languages\";}','locale_languages_add_screen','a:0:{}','',31,5,1,'admin/config/regional/language','admin/config/regional/language','Add language','t','','','a:0:{}',388,'','',5,'modules/locale/locale.admin.inc'),('admin/config/regional/language/configure','','','user_access','a:1:{i:0;s:20:\"administer languages\";}','drupal_get_form','a:1:{i:0;s:31:\"locale_languages_configure_form\";}','',31,5,1,'admin/config/regional/language','admin/config/regional/language','Detection and selection','t','','','a:0:{}',132,'','',10,'modules/locale/locale.admin.inc'),('admin/config/regional/language/configure/session','','','user_access','a:1:{i:0;s:20:\"administer languages\";}','drupal_get_form','a:1:{i:0;s:38:\"locale_language_providers_session_form\";}','',63,6,0,'','admin/config/regional/language/configure/session','Session language detection configuration','t','','','a:0:{}',4,'','',0,'modules/locale/locale.admin.inc'),('admin/config/regional/language/configure/url','','','user_access','a:1:{i:0;s:20:\"administer languages\";}','drupal_get_form','a:1:{i:0;s:34:\"locale_language_providers_url_form\";}','',63,6,0,'','admin/config/regional/language/configure/url','URL language detection configuration','t','','','a:0:{}',4,'','',0,'modules/locale/locale.admin.inc'),('admin/config/regional/language/delete/%','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:20:\"administer languages\";}','drupal_get_form','a:2:{i:0;s:28:\"locale_languages_delete_form\";i:1;i:5;}','',62,6,0,'','admin/config/regional/language/delete/%','Confirm','t','','','a:0:{}',6,'','',0,'modules/locale/locale.admin.inc'),('admin/config/regional/language/edit/%','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:20:\"administer languages\";}','drupal_get_form','a:2:{i:0;s:26:\"locale_languages_edit_form\";i:1;i:5;}','',62,6,0,'','admin/config/regional/language/edit/%','Edit language','t','','','a:0:{}',6,'','',0,'modules/locale/locale.admin.inc'),('admin/config/regional/language/overview','','','user_access','a:1:{i:0;s:20:\"administer languages\";}','drupal_get_form','a:1:{i:0;s:30:\"locale_languages_overview_form\";}','',31,5,1,'admin/config/regional/language','admin/config/regional/language','List','t','','','a:0:{}',140,'','',0,'modules/locale/locale.admin.inc'),('admin/config/regional/settings','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:24:\"system_regional_settings\";}','',15,4,0,'','admin/config/regional/settings','Regional settings','t','','','a:0:{}',6,'Settings for the site\'s default time zone and country.','',-20,'modules/system/system.admin.inc'),('admin/config/regional/translate','','','user_access','a:1:{i:0;s:19:\"translate interface\";}','locale_translate_overview_screen','a:0:{}','',15,4,0,'','admin/config/regional/translate','Translate interface','t','','','a:0:{}',6,'Translate the built in interface and optionally other text.','',-5,'modules/locale/locale.admin.inc'),('admin/config/regional/translate/delete/%','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:19:\"translate interface\";}','locale_translate_delete_page','a:1:{i:0;i:5;}','',62,6,0,'','admin/config/regional/translate/delete/%','Delete string','t','','','a:0:{}',6,'','',0,'modules/locale/locale.admin.inc'),('admin/config/regional/translate/edit/%','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:19:\"translate interface\";}','drupal_get_form','a:2:{i:0;s:26:\"locale_translate_edit_form\";i:1;i:5;}','',62,6,0,'','admin/config/regional/translate/edit/%','Edit string','t','','','a:0:{}',6,'','',0,'modules/locale/locale.admin.inc'),('admin/config/regional/translate/export','','','user_access','a:1:{i:0;s:19:\"translate interface\";}','locale_translate_export_screen','a:0:{}','',31,5,1,'admin/config/regional/translate','admin/config/regional/translate','Export','t','','','a:0:{}',132,'','',30,'modules/locale/locale.admin.inc'),('admin/config/regional/translate/import','','','user_access','a:1:{i:0;s:19:\"translate interface\";}','drupal_get_form','a:1:{i:0;s:28:\"locale_translate_import_form\";}','',31,5,1,'admin/config/regional/translate','admin/config/regional/translate','Import','t','','','a:0:{}',132,'','',20,'modules/locale/locale.admin.inc'),('admin/config/regional/translate/overview','','','user_access','a:1:{i:0;s:19:\"translate interface\";}','locale_translate_overview_screen','a:0:{}','',31,5,1,'admin/config/regional/translate','admin/config/regional/translate','Overview','t','','','a:0:{}',140,'','',0,'modules/locale/locale.admin.inc'),('admin/config/regional/translate/translate','','','user_access','a:1:{i:0;s:19:\"translate interface\";}','locale_translate_seek_screen','a:0:{}','',31,5,1,'admin/config/regional/translate','admin/config/regional/translate','Translate','t','','','a:0:{}',132,'','',10,'modules/locale/locale.admin.inc'),('admin/config/search','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/search','Search and metadata','t','','','a:0:{}',6,'Local site search, metadata and SEO.','left',-10,'modules/system/system.admin.inc'),('admin/config/search/clean-urls','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:25:\"system_clean_url_settings\";}','',15,4,0,'','admin/config/search/clean-urls','Clean URLs','t','','','a:0:{}',6,'Enable or disable clean URLs for your site.','',5,'modules/system/system.admin.inc'),('admin/config/search/clean-urls/check','','','1','a:0:{}','drupal_json_output','a:1:{i:0;a:1:{s:6:\"status\";b:1;}}','',31,5,0,'','admin/config/search/clean-urls/check','Clean URL check','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/config/search/current_search','','','facetapi_access_callback','a:0:{}','ctools_export_ui_switcher_page','a:2:{i:0;s:31:\"current_search_ctools_export_ui\";i:1;s:4:\"list\";}','',15,4,0,'','admin/config/search/current_search','Current search blocks','t','','','a:0:{}',6,'Configure current search blocks.','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/search/current_search/add','','','facetapi_access_callback','a:0:{}','ctools_export_ui_switcher_page','a:2:{i:0;s:31:\"current_search_ctools_export_ui\";i:1;s:3:\"add\";}','',31,5,1,'admin/config/search/current_search','admin/config/search/current_search','Add','t','','','a:0:{}',388,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/search/current_search/import','','','facetapi_access_callback','a:0:{}','ctools_export_ui_switcher_page','a:2:{i:0;s:31:\"current_search_ctools_export_ui\";i:1;s:6:\"import\";}','',31,5,1,'admin/config/search/current_search','admin/config/search/current_search','Import','t','','','a:0:{}',388,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/search/current_search/item/%/delete/%','a:2:{i:5;s:24:\"current_search_item_load\";i:7;N;}','','facetapi_access_callback','a:0:{}','drupal_get_form','a:3:{i:0;s:31:\"current_search_delete_item_form\";i:1;i:5;i:2;i:7;}','',250,8,0,'','admin/config/search/current_search/item/%/delete/%','Revert current search block configuration','t','','','a:0:{}',6,'','',0,'sites/all/modules/facetapi/contrib/current_search/plugins/export_ui/current_search_export_ui.class.php'),('admin/config/search/current_search/list','','','facetapi_access_callback','a:0:{}','ctools_export_ui_switcher_page','a:2:{i:0;s:31:\"current_search_ctools_export_ui\";i:1;s:4:\"list\";}','',31,5,1,'admin/config/search/current_search','admin/config/search/current_search','List','t','','','a:0:{}',140,'','',-10,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/search/current_search/list/%','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:31:\"current_search_ctools_export_ui\";}}}','','facetapi_access_callback','a:0:{}','ctools_export_ui_switcher_page','a:3:{i:0;s:31:\"current_search_ctools_export_ui\";i:1;s:4:\"edit\";i:2;i:5;}','',62,6,0,'','admin/config/search/current_search/list/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/search/current_search/list/%/clone','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:31:\"current_search_ctools_export_ui\";}}}','','facetapi_access_callback','a:0:{}','ctools_export_ui_switcher_page','a:3:{i:0;s:31:\"current_search_ctools_export_ui\";i:1;s:5:\"clone\";i:2;i:5;}','',125,7,0,'','admin/config/search/current_search/list/%/clone','Clone','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/search/current_search/list/%/delete','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:31:\"current_search_ctools_export_ui\";}}}','','facetapi_access_callback','a:0:{}','ctools_export_ui_switcher_page','a:3:{i:0;s:31:\"current_search_ctools_export_ui\";i:1;s:6:\"delete\";i:2;i:5;}','',125,7,0,'','admin/config/search/current_search/list/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/search/current_search/list/%/disable','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:31:\"current_search_ctools_export_ui\";}}}','','facetapi_access_callback','a:0:{}','ctools_export_ui_switcher_page','a:3:{i:0;s:31:\"current_search_ctools_export_ui\";i:1;s:7:\"disable\";i:2;i:5;}','',125,7,0,'','admin/config/search/current_search/list/%/disable','Disable','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/search/current_search/list/%/edit','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:31:\"current_search_ctools_export_ui\";}}}','','facetapi_access_callback','a:0:{}','ctools_export_ui_switcher_page','a:3:{i:0;s:31:\"current_search_ctools_export_ui\";i:1;s:4:\"edit\";i:2;i:5;}','',125,7,2,'admin/config/search/current_search/list/%','admin/config/search/current_search/list/%','Configure current search items','t','','','a:0:{}',388,'','',-10,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/search/current_search/list/%/enable','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:31:\"current_search_ctools_export_ui\";}}}','','facetapi_access_callback','a:0:{}','ctools_export_ui_switcher_page','a:3:{i:0;s:31:\"current_search_ctools_export_ui\";i:1;s:6:\"enable\";i:2;i:5;}','',125,7,0,'','admin/config/search/current_search/list/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/search/current_search/list/%/export','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:31:\"current_search_ctools_export_ui\";}}}','','facetapi_access_callback','a:0:{}','ctools_export_ui_switcher_page','a:3:{i:0;s:31:\"current_search_ctools_export_ui\";i:1;s:6:\"export\";i:2;i:5;}','',125,7,1,'admin/config/search/current_search/list/%','admin/config/search/current_search/list/%','Export','t','','','a:0:{}',132,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/search/current_search/list/%/revert','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:31:\"current_search_ctools_export_ui\";}}}','','facetapi_access_callback','a:0:{}','ctools_export_ui_switcher_page','a:3:{i:0;s:31:\"current_search_ctools_export_ui\";i:1;s:6:\"delete\";i:2;i:5;}','',125,7,0,'','admin/config/search/current_search/list/%/revert','Revert','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/search/facetapi/%/%/%/dependencies','a:3:{i:4;a:1:{s:21:\"facetapi_adapter_load\";a:1:{i:0;i:4;}}i:5;a:1:{s:19:\"facetapi_realm_load\";a:1:{i:0;i:4;}}i:6;a:1:{s:26:\"facetapi_dependencies_load\";a:1:{i:0;i:4;}}}','','facetapi_access_callback','a:0:{}','drupal_get_form','a:4:{i:0;s:32:\"facetapi_facet_dependencies_form\";i:1;i:4;i:2;i:5;i:3;i:6;}','',241,8,2,'admin/config/search','admin/config/search','Configure facet dependencies','t','','','a:0:{}',388,'','',-10,'sites/all/modules/facetapi/facetapi.admin.inc'),('admin/config/search/facetapi/%/%/%/edit','a:3:{i:4;a:1:{s:21:\"facetapi_adapter_load\";a:1:{i:0;i:4;}}i:5;a:1:{s:19:\"facetapi_realm_load\";a:1:{i:0;i:4;}}i:6;a:1:{s:19:\"facetapi_facet_load\";a:1:{i:0;i:4;}}}','','facetapi_access_callback','a:0:{}','drupal_get_form','a:4:{i:0;s:27:\"facetapi_facet_display_form\";i:1;i:4;i:2;i:5;i:3;i:6;}','',241,8,2,'admin/config/search','admin/config/search','Configure facet display','t','','','a:0:{}',388,'','',-15,'sites/all/modules/facetapi/facetapi.admin.inc'),('admin/config/search/facetapi/%/%/%/export','a:3:{i:4;a:1:{s:21:\"facetapi_adapter_load\";a:1:{i:0;i:4;}}i:5;a:1:{s:19:\"facetapi_realm_load\";a:1:{i:0;i:4;}}i:6;a:1:{s:19:\"facetapi_facet_load\";a:1:{i:0;i:4;}}}','','facetapi_access_callback','a:0:{}','drupal_get_form','a:4:{i:0;s:20:\"facetapi_export_form\";i:1;i:4;i:2;i:5;i:3;i:6;}','',241,8,0,'','admin/config/search/facetapi/%/%/%/export','Export facet configuration','t','','','a:0:{}',6,'','',0,'sites/all/modules/facetapi/facetapi.admin.inc'),('admin/config/search/facetapi/%/%/%/filters','a:3:{i:4;a:1:{s:21:\"facetapi_adapter_load\";a:1:{i:0;i:4;}}i:5;a:1:{s:19:\"facetapi_realm_load\";a:1:{i:0;i:4;}}i:6;a:1:{s:21:\"facetapi_filters_load\";a:1:{i:0;i:4;}}}','','facetapi_access_callback','a:0:{}','drupal_get_form','a:4:{i:0;s:27:\"facetapi_facet_filters_form\";i:1;i:4;i:2;i:5;i:3;i:6;}','',241,8,2,'admin/config/search','admin/config/search','Configure facet filters','t','','','a:0:{}',388,'','',-5,'sites/all/modules/facetapi/facetapi.admin.inc'),('admin/config/search/facetapi/%/%/%/revert','a:3:{i:4;a:1:{s:21:\"facetapi_adapter_load\";a:1:{i:0;i:4;}}i:5;a:1:{s:19:\"facetapi_realm_load\";a:1:{i:0;i:4;}}i:6;a:1:{s:19:\"facetapi_facet_load\";a:1:{i:0;i:4;}}}','','facetapi_access_callback','a:0:{}','drupal_get_form','a:4:{i:0;s:20:\"facetapi_revert_form\";i:1;i:4;i:2;i:5;i:3;i:6;}','',241,8,0,'','admin/config/search/facetapi/%/%/%/revert','Revert facet configuration','t','','','a:0:{}',6,'','',0,'sites/all/modules/facetapi/facetapi.admin.inc'),('admin/config/search/path','','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','path_admin_overview','a:0:{}','',15,4,0,'','admin/config/search/path','URL aliases','t','','','a:0:{}',6,'Change your site\'s URL paths by aliasing them.','',-5,'modules/path/path.admin.inc'),('admin/config/search/path/add','','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','path_admin_edit','a:0:{}','',31,5,1,'admin/config/search/path','admin/config/search/path','Add alias','t','','','a:0:{}',388,'','',0,'modules/path/path.admin.inc'),('admin/config/search/path/delete/%','a:1:{i:5;s:9:\"path_load\";}','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','drupal_get_form','a:2:{i:0;s:25:\"path_admin_delete_confirm\";i:1;i:5;}','',62,6,0,'','admin/config/search/path/delete/%','Delete alias','t','','','a:0:{}',6,'','',0,'modules/path/path.admin.inc'),('admin/config/search/path/delete_bulk','','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','drupal_get_form','a:1:{i:0;s:21:\"pathauto_admin_delete\";}','',31,5,1,'admin/config/search/path','admin/config/search/path','Delete aliases','t','','','a:0:{}',132,'','',40,'sites/all/modules/pathauto/pathauto.admin.inc'),('admin/config/search/path/edit/%','a:1:{i:5;s:9:\"path_load\";}','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','path_admin_edit','a:1:{i:0;i:5;}','',62,6,0,'','admin/config/search/path/edit/%','Edit alias','t','','','a:0:{}',6,'','',0,'modules/path/path.admin.inc'),('admin/config/search/path/list','','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','path_admin_overview','a:0:{}','',31,5,1,'admin/config/search/path','admin/config/search/path','List','t','','','a:0:{}',140,'','',-10,'modules/path/path.admin.inc'),('admin/config/search/path/patterns','','','user_access','a:1:{i:0;s:19:\"administer pathauto\";}','drupal_get_form','a:1:{i:0;s:22:\"pathauto_patterns_form\";}','',31,5,1,'admin/config/search/path','admin/config/search/path','Patterns','t','','','a:0:{}',132,'','',10,'sites/all/modules/pathauto/pathauto.admin.inc'),('admin/config/search/path/settings','','','user_access','a:1:{i:0;s:19:\"administer pathauto\";}','drupal_get_form','a:1:{i:0;s:22:\"pathauto_settings_form\";}','',31,5,1,'admin/config/search/path','admin/config/search/path','Settings','t','','','a:0:{}',132,'','',20,'sites/all/modules/pathauto/pathauto.admin.inc'),('admin/config/search/path/update_bulk','','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','drupal_get_form','a:1:{i:0;s:25:\"pathauto_bulk_update_form\";}','',31,5,1,'admin/config/search/path','admin/config/search/path','Bulk update','t','','','a:0:{}',132,'','',30,'sites/all/modules/pathauto/pathauto.admin.inc'),('admin/config/search/search_api','','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','search_api_admin_overview','a:0:{}','',15,4,0,'','admin/config/search/search_api','Search API','t','','','a:0:{}',6,'Create and configure search engines.','',0,'sites/all/modules/search_api/search_api.admin.inc'),('admin/config/search/search_api/add_index','','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','drupal_get_form','a:1:{i:0;s:26:\"search_api_admin_add_index\";}','',31,5,1,'admin/config/search/search_api','admin/config/search/search_api','Add index','t','','','a:0:{}',388,'Create a new search index.','',0,'sites/all/modules/search_api/search_api.admin.inc'),('admin/config/search/search_api/add_server','','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','drupal_get_form','a:1:{i:0;s:27:\"search_api_admin_add_server\";}','',31,5,1,'admin/config/search/search_api','admin/config/search/search_api','Add server','t','','','a:0:{}',388,'Create a new search server.','',-1,'sites/all/modules/search_api/search_api.admin.inc'),('admin/config/search/search_api/index/%','a:1:{i:5;s:21:\"search_api_index_load\";}','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','search_api_admin_index_view','a:1:{i:0;i:5;}','',62,6,0,'','admin/config/search/search_api/index/%','View index','search_api_admin_item_title','a:1:{i:0;i:5;}','','a:0:{}',6,'View index details.','',0,'sites/all/modules/search_api/search_api.admin.inc'),('admin/config/search/search_api/index/%/delete','a:1:{i:5;s:21:\"search_api_index_load\";}','','search_api_access_delete_page','a:1:{i:0;i:5;}','drupal_get_form','a:4:{i:0;s:24:\"search_api_admin_confirm\";i:1;s:5:\"index\";i:2;s:6:\"delete\";i:3;i:5;}','',125,7,2,'admin/config/search/search_api/index/%','admin/config/search/search_api/index/%','Delete','search_api_title_delete_page','a:1:{i:0;i:5;}','','a:0:{}',132,'Delete index.','',10,'sites/all/modules/search_api/search_api.admin.inc'),('admin/config/search/search_api/index/%/disable','a:1:{i:5;s:21:\"search_api_index_load\";}','','search_api_access_disable_page','a:1:{i:0;i:5;}','search_api_admin_index_view','a:2:{i:0;i:5;i:1;i:6;}','',125,7,2,'admin/config/search/search_api/index/%','admin/config/search/search_api/index/%','Disable','t','','','a:0:{}',132,'Disable index.','',8,'sites/all/modules/search_api/search_api.admin.inc'),('admin/config/search/search_api/index/%/edit','a:1:{i:5;s:21:\"search_api_index_load\";}','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','drupal_get_form','a:2:{i:0;s:27:\"search_api_admin_index_edit\";i:1;i:5;}','',125,7,3,'admin/config/search/search_api/index/%','admin/config/search/search_api/index/%','Edit','t','','','a:0:{}',132,'Edit index settings.','',-6,'sites/all/modules/search_api/search_api.admin.inc'),('admin/config/search/search_api/index/%/facets','a:1:{i:5;s:21:\"search_api_index_load\";}','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','search_api_facetapi_settings','a:2:{i:0;s:5:\"block\";i:1;i:5;}','',125,7,3,'admin/config/search/search_api/index/%','admin/config/search/search_api/index/%','Facets','t','','','a:0:{}',132,'','',-1,''),('admin/config/search/search_api/index/%/facets/block','a:1:{i:5;s:21:\"search_api_index_load\";}','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','search_api_facetapi_settings','a:2:{i:0;s:5:\"block\";i:1;i:5;}','',251,8,1,'admin/config/search/search_api/index/%/facets','admin/config/search/search_api/index/%','Blocks','t','','','a:0:{}',140,'','',-10,''),('admin/config/search/search_api/index/%/fields','a:1:{i:5;s:21:\"search_api_index_load\";}','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','drupal_get_form','a:2:{i:0;s:29:\"search_api_admin_index_fields\";i:1;i:5;}','',125,7,3,'admin/config/search/search_api/index/%','admin/config/search/search_api/index/%','Fields','t','','','a:0:{}',132,'Select indexed fields.','',-4,'sites/all/modules/search_api/search_api.admin.inc'),('admin/config/search/search_api/index/%/sorts','a:1:{i:5;s:21:\"search_api_index_load\";}','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','drupal_get_form','a:2:{i:0;s:29:\"search_api_sorts_index_select\";i:1;i:5;}','',125,7,3,'admin/config/search/search_api/index/%','admin/config/search/search_api/index/%','Sorts','t','','','a:0:{}',132,'Select the sort fields to display.','',-1,'sites/all/modules/search_api_sorts/search_api_sorts.admin.inc'),('admin/config/search/search_api/index/%/view','a:1:{i:5;s:21:\"search_api_index_load\";}','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','search_api_admin_index_view','a:1:{i:0;i:5;}','',125,7,1,'admin/config/search/search_api/index/%','admin/config/search/search_api/index/%','View','t','','','a:0:{}',140,'','',-10,'sites/all/modules/search_api/search_api.admin.inc'),('admin/config/search/search_api/index/%/workflow','a:1:{i:5;s:21:\"search_api_index_load\";}','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','drupal_get_form','a:2:{i:0;s:31:\"search_api_admin_index_workflow\";i:1;i:5;}','',125,7,3,'admin/config/search/search_api/index/%','admin/config/search/search_api/index/%','Filters','t','','','a:0:{}',132,'Edit indexing workflow.','',-2,'sites/all/modules/search_api/search_api.admin.inc'),('admin/config/search/search_api/overview','','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','search_api_admin_overview','a:0:{}','',31,5,1,'admin/config/search/search_api','admin/config/search/search_api','Overview','t','','','a:0:{}',140,'','',-10,'sites/all/modules/search_api/search_api.admin.inc'),('admin/config/search/search_api/server/%','a:1:{i:5;s:22:\"search_api_server_load\";}','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','search_api_admin_server_view','a:1:{i:0;i:5;}','',62,6,0,'','admin/config/search/search_api/server/%','View server','search_api_admin_item_title','a:1:{i:0;i:5;}','','a:0:{}',6,'View server details.','',0,'sites/all/modules/search_api/search_api.admin.inc'),('admin/config/search/search_api/server/%/delete','a:1:{i:5;s:22:\"search_api_server_load\";}','','search_api_access_delete_page','a:1:{i:0;i:5;}','drupal_get_form','a:4:{i:0;s:24:\"search_api_admin_confirm\";i:1;s:6:\"server\";i:2;s:6:\"delete\";i:3;i:5;}','',125,7,2,'admin/config/search/search_api/server/%','admin/config/search/search_api/server/%','Delete','search_api_title_delete_page','a:1:{i:0;i:5;}','','a:0:{}',132,'Delete server.','',10,'sites/all/modules/search_api/search_api.admin.inc'),('admin/config/search/search_api/server/%/disable','a:1:{i:5;s:22:\"search_api_server_load\";}','','search_api_access_disable_page','a:1:{i:0;i:5;}','search_api_admin_server_view','a:2:{i:0;i:5;i:1;i:6;}','',125,7,2,'admin/config/search/search_api/server/%','admin/config/search/search_api/server/%','Disable','t','','','a:0:{}',132,'Disable index.','',8,'sites/all/modules/search_api/search_api.admin.inc'),('admin/config/search/search_api/server/%/edit','a:1:{i:5;s:22:\"search_api_server_load\";}','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','drupal_get_form','a:2:{i:0;s:28:\"search_api_admin_server_edit\";i:1;i:5;}','',125,7,3,'admin/config/search/search_api/server/%','admin/config/search/search_api/server/%','Edit','t','','','a:0:{}',132,'Edit server details.','',-1,'sites/all/modules/search_api/search_api.admin.inc'),('admin/config/search/search_api/server/%/view','a:1:{i:5;s:22:\"search_api_server_load\";}','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','search_api_admin_server_view','a:1:{i:0;i:5;}','',125,7,1,'admin/config/search/search_api/server/%','admin/config/search/search_api/server/%','View','t','','','a:0:{}',140,'','',-10,'sites/all/modules/search_api/search_api.admin.inc'),('admin/config/search/settings','','','user_access','a:1:{i:0;s:17:\"administer search\";}','drupal_get_form','a:1:{i:0;s:21:\"search_admin_settings\";}','',15,4,0,'','admin/config/search/settings','Search settings','t','','','a:0:{}',6,'Configure relevance settings for search and other indexing options.','',-10,'modules/search/search.admin.inc'),('admin/config/search/settings/reindex','','','user_access','a:1:{i:0;s:17:\"administer search\";}','drupal_get_form','a:1:{i:0;s:22:\"search_reindex_confirm\";}','',31,5,0,'','admin/config/search/settings/reindex','Clear index','t','','','a:0:{}',4,'','',0,'modules/search/search.admin.inc'),('admin/config/search/votingapi','','','user_access','a:1:{i:0;s:21:\"administer voting api\";}','drupal_get_form','a:1:{i:0;s:23:\"votingapi_settings_form\";}','',15,4,0,'','admin/config/search/votingapi','Voting API','t','','','a:0:{}',6,'Configure sitewide settings for user-generated ratings and votes.','',0,'sites/all/modules/votingapi/votingapi.admin.inc'),('admin/config/services','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/services','Web services','t','','','a:0:{}',6,'Tools related to web services.','right',0,'modules/system/system.admin.inc'),('admin/config/services/rss-publishing','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:25:\"system_rss_feeds_settings\";}','',15,4,0,'','admin/config/services/rss-publishing','RSS publishing','t','','','a:0:{}',6,'Configure the site description, the number of items per feed and whether feeds should be titles/teasers/full-text.','',0,'modules/system/system.admin.inc'),('admin/config/services/simplenews','','','user_access','a:1:{i:0;s:22:\"administer newsletters\";}','drupal_get_form','a:1:{i:0;s:27:\"simplenews_admin_categories\";}','',15,4,0,'','admin/config/services/simplenews','Newsletters','t','','','a:0:{}',6,'Configure your sites newsletters.','',0,'sites/all/modules/simplenews/includes/simplenews.admin.inc'),('admin/config/services/simplenews/add','','','user_access','a:1:{i:0;s:22:\"administer newsletters\";}','drupal_get_form','a:1:{i:0;s:30:\"simplenews_admin_category_form\";}','',31,5,1,'admin/config/services/simplenews','admin/config/services/simplenews','Add newsletter category','t','','','a:0:{}',388,'','',-9,'sites/all/modules/simplenews/includes/simplenews.admin.inc'),('admin/config/services/simplenews/categories','','','user_access','a:1:{i:0;s:22:\"administer newsletters\";}','drupal_get_form','a:1:{i:0;s:27:\"simplenews_admin_categories\";}','',31,5,1,'admin/config/services/simplenews','admin/config/services/simplenews','Newsletters','t','','','a:0:{}',140,'','',0,'sites/all/modules/simplenews/includes/simplenews.admin.inc'),('admin/config/services/simplenews/categories/%/delete','a:1:{i:5;s:24:\"simplenews_category_load\";}','','user_access','a:1:{i:0;s:22:\"administer newsletters\";}','drupal_get_form','a:2:{i:0;s:32:\"simplenews_admin_category_delete\";i:1;i:5;}','',125,7,0,'','admin/config/services/simplenews/categories/%/delete','Newsletters','t','','','a:0:{}',6,'','',0,'sites/all/modules/simplenews/includes/simplenews.admin.inc'),('admin/config/services/simplenews/categories/%/edit','a:1:{i:5;s:24:\"simplenews_category_load\";}','','user_access','a:1:{i:0;s:22:\"administer newsletters\";}','drupal_get_form','a:2:{i:0;s:30:\"simplenews_admin_category_form\";i:1;i:5;}','',125,7,0,'','admin/config/services/simplenews/categories/%/edit','Newsletters','t','','','a:0:{}',6,'','',0,'sites/all/modules/simplenews/includes/simplenews.admin.inc'),('admin/config/services/simplenews/settings','','','user_access','a:1:{i:0;s:30:\"administer simplenews settings\";}','drupal_get_form','a:1:{i:0;s:36:\"simplenews_admin_settings_newsletter\";}','',31,5,1,'admin/config/services/simplenews','admin/config/services/simplenews','Settings','t','','','a:0:{}',132,'Simplenews settings.','',20,'sites/all/modules/simplenews/includes/simplenews.admin.inc'),('admin/config/services/simplenews/settings/mail','','','user_access','a:1:{i:0;s:30:\"administer simplenews settings\";}','drupal_get_form','a:1:{i:0;s:30:\"simplenews_admin_settings_mail\";}','',63,6,1,'admin/config/services/simplenews/settings','admin/config/services/simplenews','Send mail','t','','','a:0:{}',132,'Send mail, cron and debug options.','',-5,'sites/all/modules/simplenews/includes/simplenews.admin.inc'),('admin/config/services/simplenews/settings/newsletter','','','user_access','a:1:{i:0;s:30:\"administer simplenews settings\";}','drupal_get_form','a:1:{i:0;s:36:\"simplenews_admin_settings_newsletter\";}','',63,6,1,'admin/config/services/simplenews/settings','admin/config/services/simplenews','Newsletter','t','','','a:0:{}',140,'','',-15,'sites/all/modules/simplenews/includes/simplenews.admin.inc'),('admin/config/services/simplenews/settings/subscription','','','user_access','a:1:{i:0;s:30:\"administer simplenews settings\";}','drupal_get_form','a:1:{i:0;s:38:\"simplenews_admin_settings_subscription\";}','',63,6,1,'admin/config/services/simplenews/settings','admin/config/services/simplenews','Subscription','t','','','a:0:{}',132,'Subscription settings, opt-in/out confirmation email text.','',-10,'sites/all/modules/simplenews/includes/simplenews.admin.inc'),('admin/config/system','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/system','System','t','','','a:0:{}',6,'General system related configuration.','right',-20,'modules/system/system.admin.inc'),('admin/config/system/actions','','','user_access','a:1:{i:0;s:18:\"administer actions\";}','system_actions_manage','a:0:{}','',15,4,0,'','admin/config/system/actions','Actions','t','','','a:0:{}',6,'Manage the actions defined for your site.','',0,'modules/system/system.admin.inc'),('admin/config/system/actions/configure','','','user_access','a:1:{i:0;s:18:\"administer actions\";}','drupal_get_form','a:1:{i:0;s:24:\"system_actions_configure\";}','',31,5,0,'','admin/config/system/actions/configure','Configure an advanced action','t','','','a:0:{}',4,'','',0,'modules/system/system.admin.inc'),('admin/config/system/actions/delete/%','a:1:{i:5;s:12:\"actions_load\";}','','user_access','a:1:{i:0;s:18:\"administer actions\";}','drupal_get_form','a:2:{i:0;s:26:\"system_actions_delete_form\";i:1;i:5;}','',62,6,0,'','admin/config/system/actions/delete/%','Delete action','t','','','a:0:{}',6,'Delete an action.','',0,'modules/system/system.admin.inc'),('admin/config/system/actions/manage','','','user_access','a:1:{i:0;s:18:\"administer actions\";}','system_actions_manage','a:0:{}','',31,5,1,'admin/config/system/actions','admin/config/system/actions','Manage actions','t','','','a:0:{}',140,'Manage the actions defined for your site.','',-2,'modules/system/system.admin.inc'),('admin/config/system/actions/orphan','','','user_access','a:1:{i:0;s:18:\"administer actions\";}','system_actions_remove_orphans','a:0:{}','',31,5,0,'','admin/config/system/actions/orphan','Remove orphans','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/config/system/cron','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:20:\"system_cron_settings\";}','',15,4,0,'','admin/config/system/cron','Cron','t','','','a:0:{}',6,'Manage automatic site maintenance tasks.','',20,'modules/system/system.admin.inc'),('admin/config/system/recently-read','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:22:\"recently_read_settings\";}','',15,4,0,'','admin/config/system/recently-read','Recently Read Config','t','','','a:0:{}',6,'Tracks the history of recently read entities by each user.','',0,''),('admin/config/system/site-information','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:32:\"system_site_information_settings\";}','',15,4,0,'','admin/config/system/site-information','Site information','t','','','a:0:{}',6,'Change site name, e-mail address, slogan, default front page, and number of posts per page, error pages.','',-20,'modules/system/system.admin.inc'),('admin/config/user-interface','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/user-interface','User interface','t','','','a:0:{}',6,'Tools that enhance the user interface.','right',-15,'modules/system/system.admin.inc'),('admin/config/user-interface/chosen','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:21:\"chosen_admin_settings\";}','',15,4,0,'','admin/config/user-interface/chosen','Chosen','t','','','a:0:{}',6,'Configuration for Chosen plugin','',0,'sites/all/modules/chosen/chosen.admin.inc'),('admin/config/user-interface/custom-breadcrumbs','','','user_access','a:1:{i:0;s:29:\"administer custom breadcrumbs\";}','drupal_get_form','a:1:{i:0;s:33:\"custom_breadcrumbs_admin_settings\";}','',15,4,0,'','admin/config/user-interface/custom-breadcrumbs','Custom breadcrumbs settings','t','','','a:0:{}',6,'Manage sitewide configuration settings to customize the breadcrumb trail.','',0,'sites/all/modules/custom_breadcrumbs/custom_breadcrumbs.admin.inc'),('admin/config/user-interface/modulefilter','','','user_access','a:1:{i:0;s:24:\"administer module filter\";}','drupal_get_form','a:1:{i:0;s:22:\"module_filter_settings\";}','',15,4,0,'','admin/config/user-interface/modulefilter','Module filter','t','','','a:0:{}',6,'Configure how the modules page looks and acts.','',0,'sites/all/modules/module_filter/module_filter.admin.inc'),('admin/config/user-interface/shortcut','','','user_access','a:1:{i:0;s:20:\"administer shortcuts\";}','shortcut_set_admin','a:0:{}','',15,4,0,'','admin/config/user-interface/shortcut','Shortcuts','t','','','a:0:{}',6,'Add and modify shortcut sets.','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/%','a:1:{i:4;s:17:\"shortcut_set_load\";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:22:\"shortcut_set_customize\";i:1;i:4;}','',30,5,0,'','admin/config/user-interface/shortcut/%','Edit shortcuts','shortcut_set_title_callback','a:1:{i:0;i:4;}','','a:0:{}',6,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/%/add-link','a:1:{i:4;s:17:\"shortcut_set_load\";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:17:\"shortcut_link_add\";i:1;i:4;}','',61,6,1,'admin/config/user-interface/shortcut/%','admin/config/user-interface/shortcut/%','Add shortcut','t','','','a:0:{}',388,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/%/add-link-inline','a:1:{i:4;s:17:\"shortcut_set_load\";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','shortcut_link_add_inline','a:1:{i:0;i:4;}','',61,6,0,'','admin/config/user-interface/shortcut/%/add-link-inline','Add shortcut','t','','','a:0:{}',0,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/%/delete','a:1:{i:4;s:17:\"shortcut_set_load\";}','','shortcut_set_delete_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:24:\"shortcut_set_delete_form\";i:1;i:4;}','',61,6,0,'','admin/config/user-interface/shortcut/%/delete','Delete shortcut set','t','','','a:0:{}',6,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/%/edit','a:1:{i:4;s:17:\"shortcut_set_load\";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:22:\"shortcut_set_edit_form\";i:1;i:4;}','',61,6,1,'admin/config/user-interface/shortcut/%','admin/config/user-interface/shortcut/%','Edit set name','t','','','a:0:{}',132,'','',10,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/%/links','a:1:{i:4;s:17:\"shortcut_set_load\";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:22:\"shortcut_set_customize\";i:1;i:4;}','',61,6,1,'admin/config/user-interface/shortcut/%','admin/config/user-interface/shortcut/%','List links','t','','','a:0:{}',140,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/add-set','','','user_access','a:1:{i:0;s:20:\"administer shortcuts\";}','drupal_get_form','a:1:{i:0;s:21:\"shortcut_set_add_form\";}','',31,5,1,'admin/config/user-interface/shortcut','admin/config/user-interface/shortcut','Add shortcut set','t','','','a:0:{}',388,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/link/%','a:1:{i:5;s:14:\"menu_link_load\";}','','shortcut_link_access','a:1:{i:0;i:5;}','drupal_get_form','a:2:{i:0;s:18:\"shortcut_link_edit\";i:1;i:5;}','',62,6,0,'','admin/config/user-interface/shortcut/link/%','Edit shortcut','t','','','a:0:{}',6,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/link/%/delete','a:1:{i:5;s:14:\"menu_link_load\";}','','shortcut_link_access','a:1:{i:0;i:5;}','drupal_get_form','a:2:{i:0;s:20:\"shortcut_link_delete\";i:1;i:5;}','',125,7,0,'','admin/config/user-interface/shortcut/link/%/delete','Delete shortcut','t','','','a:0:{}',6,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/workflow','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/workflow','Workflow','t','','','a:0:{}',6,'Content workflow, editorial workflow tools.','right',5,'modules/system/system.admin.inc'),('admin/config/workflow/rules','','','user_access','a:1:{i:0;s:16:\"administer rules\";}','drupal_get_form','a:2:{i:0;s:29:\"rules_admin_reaction_overview\";i:1;s:36:\"admin/config/workflow/rules/reaction\";}','',15,4,0,'','admin/config/workflow/rules','Rules','t','','','a:0:{}',6,'Manage reaction rules and rule components.','right',0,'sites/all/modules/rules/rules_admin/rules_admin.inc'),('admin/config/workflow/rules/autocomplete_tags','','','user_access','a:1:{i:0;s:16:\"administer rules\";}','rules_autocomplete_tags','a:1:{i:0;i:5;}','',31,5,0,'','admin/config/workflow/rules/autocomplete_tags','Rules tags autocomplete','t','','','a:0:{}',0,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/components','','','user_access','a:1:{i:0;s:16:\"administer rules\";}','drupal_get_form','a:2:{i:0;s:31:\"rules_admin_components_overview\";i:1;s:38:\"admin/config/workflow/rules/components\";}','',31,5,1,'admin/config/workflow/rules','admin/config/workflow/rules','Components','t','','','a:0:{}',132,'','',0,'sites/all/modules/rules/rules_admin/rules_admin.inc'),('admin/config/workflow/rules/components/add','','','user_access','a:1:{i:0;s:16:\"administer rules\";}','drupal_get_form','a:2:{i:0;s:25:\"rules_admin_add_component\";i:1;s:38:\"admin/config/workflow/rules/components\";}','',63,6,1,'admin/config/workflow/rules/components','admin/config/workflow/rules','Add new component','t','','','a:0:{}',388,'','',0,'sites/all/modules/rules/rules_admin/rules_admin.inc'),('admin/config/workflow/rules/components/import','','','user_access','a:1:{i:0;s:16:\"administer rules\";}','drupal_get_form','a:2:{i:0;s:20:\"rules_ui_import_form\";i:1;s:38:\"admin/config/workflow/rules/components\";}','',63,6,1,'admin/config/workflow/rules/components','admin/config/workflow/rules','Import component','t','','','a:0:{}',388,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/components/manage/%','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:31:\"rules_ui_form_edit_rules_config\";i:1;i:6;i:2;s:38:\"admin/config/workflow/rules/components\";}','',126,7,0,'','admin/config/workflow/rules/components/manage/%','','rules_get_title','a:2:{i:0;s:24:\"Editing !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',4,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/components/manage/%/%','a:2:{i:6;s:17:\"rules_config_load\";i:7;N;}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:37:\"rules_ui_form_rules_config_confirm_op\";i:1;i:6;i:2;i:7;i:3;s:38:\"admin/config/workflow/rules/components\";}','',252,8,0,'','admin/config/workflow/rules/components/manage/%/%','','t','','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/components/manage/%/add/%','a:2:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}i:8;a:1:{s:18:\"rules_element_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:5:{i:0;s:20:\"rules_ui_add_element\";i:1;i:6;i:2;i:9;i:3;i:8;i:4;s:38:\"admin/config/workflow/rules/components\";}','',506,9,0,'','admin/config/workflow/rules/components/manage/%/add/%','','rules_menu_add_element_title','a:1:{i:0;a:1:{i:0;i:9;}}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/components/manage/%/add/event','a:1:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:23:\"rules_ui_add_event_page\";i:1;i:6;i:2;s:38:\"admin/config/workflow/rules/components\";}','',507,9,0,'','admin/config/workflow/rules/components/manage/%/add/event','','rules_get_title','a:2:{i:0;s:32:\"Adding event to !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/components/manage/%/autocomplete','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','rules_ui_form_data_selection_auto_completion','a:3:{i:0;i:8;i:1;i:9;i:2;i:10;}','',253,8,0,'','admin/config/workflow/rules/components/manage/%/autocomplete','','t','','','a:0:{}',0,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/components/manage/%/clone','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:32:\"rules_ui_form_clone_rules_config\";i:1;i:6;i:2;s:38:\"admin/config/workflow/rules/components\";}','',253,8,0,'','admin/config/workflow/rules/components/manage/%/clone','','rules_get_title','a:2:{i:0;s:24:\"Cloning !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/components/manage/%/delete/%','a:2:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}i:8;a:1:{s:18:\"rules_element_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:23:\"rules_ui_delete_element\";i:1;i:6;i:2;i:8;i:3;s:38:\"admin/config/workflow/rules/components\";}','',506,9,0,'','admin/config/workflow/rules/components/manage/%/delete/%','','rules_get_title','a:2:{i:0;s:24:\"Editing !plugin \"!label\"\";i:1;i:8;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/components/manage/%/delete/event','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:21:\"rules_ui_remove_event\";i:1;i:6;i:2;i:9;i:3;s:38:\"admin/config/workflow/rules/components\";}','',507,9,0,'','admin/config/workflow/rules/components/manage/%/delete/event','Remove event','t','','','a:0:{}',6,'Remove an event from a reaction rule.','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/components/manage/%/edit/%','a:2:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}i:8;a:1:{s:18:\"rules_element_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:21:\"rules_ui_edit_element\";i:1;i:6;i:2;i:8;i:3;s:38:\"admin/config/workflow/rules/components\";}','',506,9,0,'','admin/config/workflow/rules/components/manage/%/edit/%','','rules_get_title','a:2:{i:0;s:24:\"Editing !plugin \"!label\"\";i:1;i:8;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/components/manage/%/execute','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:34:\"rules_ui_form_execute_rules_config\";i:1;i:6;i:2;s:38:\"admin/config/workflow/rules/components\";}','',253,8,0,'','admin/config/workflow/rules/components/manage/%/execute','','rules_get_title','a:2:{i:0;s:26:\"Executing !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/components/manage/%/export','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:4:\"view\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:33:\"rules_ui_form_export_rules_config\";i:1;i:6;i:2;s:38:\"admin/config/workflow/rules/components\";}','',253,8,0,'','admin/config/workflow/rules/components/manage/%/export','','rules_get_title','a:2:{i:0;s:26:\"Export of !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/reaction','','','user_access','a:1:{i:0;s:16:\"administer rules\";}','drupal_get_form','a:2:{i:0;s:29:\"rules_admin_reaction_overview\";i:1;s:36:\"admin/config/workflow/rules/reaction\";}','',31,5,1,'admin/config/workflow/rules','admin/config/workflow/rules','Rules','t','','','a:0:{}',140,'','',-1,'sites/all/modules/rules/rules_admin/rules_admin.inc'),('admin/config/workflow/rules/reaction/add','','','user_access','a:1:{i:0;s:16:\"administer rules\";}','drupal_get_form','a:2:{i:0;s:29:\"rules_admin_add_reaction_rule\";i:1;s:36:\"admin/config/workflow/rules/reaction\";}','',63,6,1,'admin/config/workflow/rules/reaction','admin/config/workflow/rules','Add new rule','t','','','a:0:{}',388,'','',0,'sites/all/modules/rules/rules_admin/rules_admin.inc'),('admin/config/workflow/rules/reaction/import','','','user_access','a:1:{i:0;s:16:\"administer rules\";}','drupal_get_form','a:2:{i:0;s:20:\"rules_ui_import_form\";i:1;s:36:\"admin/config/workflow/rules/reaction\";}','',63,6,1,'admin/config/workflow/rules/reaction','admin/config/workflow/rules','Import rule','t','','','a:0:{}',388,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/reaction/manage/%','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:31:\"rules_ui_form_edit_rules_config\";i:1;i:6;i:2;s:36:\"admin/config/workflow/rules/reaction\";}','',126,7,0,'','admin/config/workflow/rules/reaction/manage/%','','rules_get_title','a:2:{i:0;s:24:\"Editing !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',4,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/reaction/manage/%/%','a:2:{i:6;s:17:\"rules_config_load\";i:7;N;}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:37:\"rules_ui_form_rules_config_confirm_op\";i:1;i:6;i:2;i:7;i:3;s:36:\"admin/config/workflow/rules/reaction\";}','',252,8,0,'','admin/config/workflow/rules/reaction/manage/%/%','','t','','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/reaction/manage/%/add/%','a:2:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}i:8;a:1:{s:18:\"rules_element_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:5:{i:0;s:20:\"rules_ui_add_element\";i:1;i:6;i:2;i:9;i:3;i:8;i:4;s:36:\"admin/config/workflow/rules/reaction\";}','',506,9,0,'','admin/config/workflow/rules/reaction/manage/%/add/%','','rules_menu_add_element_title','a:1:{i:0;a:1:{i:0;i:9;}}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/reaction/manage/%/add/event','a:1:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:23:\"rules_ui_add_event_page\";i:1;i:6;i:2;s:36:\"admin/config/workflow/rules/reaction\";}','',507,9,0,'','admin/config/workflow/rules/reaction/manage/%/add/event','','rules_get_title','a:2:{i:0;s:32:\"Adding event to !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/reaction/manage/%/autocomplete','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','rules_ui_form_data_selection_auto_completion','a:3:{i:0;i:8;i:1;i:9;i:2;i:10;}','',253,8,0,'','admin/config/workflow/rules/reaction/manage/%/autocomplete','','t','','','a:0:{}',0,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/reaction/manage/%/clone','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:32:\"rules_ui_form_clone_rules_config\";i:1;i:6;i:2;s:36:\"admin/config/workflow/rules/reaction\";}','',253,8,0,'','admin/config/workflow/rules/reaction/manage/%/clone','','rules_get_title','a:2:{i:0;s:24:\"Cloning !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/reaction/manage/%/delete/%','a:2:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}i:8;a:1:{s:18:\"rules_element_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:23:\"rules_ui_delete_element\";i:1;i:6;i:2;i:8;i:3;s:36:\"admin/config/workflow/rules/reaction\";}','',506,9,0,'','admin/config/workflow/rules/reaction/manage/%/delete/%','','rules_get_title','a:2:{i:0;s:24:\"Editing !plugin \"!label\"\";i:1;i:8;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/reaction/manage/%/delete/event','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:21:\"rules_ui_remove_event\";i:1;i:6;i:2;i:9;i:3;s:36:\"admin/config/workflow/rules/reaction\";}','',507,9,0,'','admin/config/workflow/rules/reaction/manage/%/delete/event','Remove event','t','','','a:0:{}',6,'Remove an event from a reaction rule.','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/reaction/manage/%/edit/%','a:2:{i:6;a:1:{s:17:\"rules_config_load\";a:1:{i:0;i:6;}}i:8;a:1:{s:18:\"rules_element_load\";a:1:{i:0;i:6;}}}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:4:{i:0;s:21:\"rules_ui_edit_element\";i:1;i:6;i:2;i:8;i:3;s:36:\"admin/config/workflow/rules/reaction\";}','',506,9,0,'','admin/config/workflow/rules/reaction/manage/%/edit/%','','rules_get_title','a:2:{i:0;s:24:\"Editing !plugin \"!label\"\";i:1;i:8;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/reaction/manage/%/execute','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:6:\"update\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:34:\"rules_ui_form_execute_rules_config\";i:1;i:6;i:2;s:36:\"admin/config/workflow/rules/reaction\";}','',253,8,0,'','admin/config/workflow/rules/reaction/manage/%/execute','','rules_get_title','a:2:{i:0;s:26:\"Executing !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/reaction/manage/%/export','a:1:{i:6;s:17:\"rules_config_load\";}','','rules_config_access','a:2:{i:0;s:4:\"view\";i:1;i:6;}','drupal_get_form','a:3:{i:0;s:33:\"rules_ui_form_export_rules_config\";i:1;i:6;i:2;s:36:\"admin/config/workflow/rules/reaction\";}','',253,8,0,'','admin/config/workflow/rules/reaction/manage/%/export','','rules_get_title','a:2:{i:0;s:26:\"Export of !plugin \"!label\"\";i:1;i:6;}','','a:0:{}',6,'','',0,'sites/all/modules/rules/ui/ui.forms.inc'),('admin/config/workflow/rules/settings','','','user_access','a:1:{i:0;s:16:\"administer rules\";}','drupal_get_form','a:1:{i:0;s:20:\"rules_admin_settings\";}','',31,5,1,'admin/config/workflow/rules','admin/config/workflow/rules','Settings','t','','','a:0:{}',132,'','',1,'sites/all/modules/rules/rules_admin/rules_admin.inc'),('admin/config/workflow/rules/settings/advanced','','','user_access','a:1:{i:0;s:16:\"administer rules\";}','drupal_get_form','a:1:{i:0;s:29:\"rules_admin_settings_advanced\";}','',63,6,1,'admin/config/workflow/rules/settings','admin/config/workflow/rules','Advanced','t','','','a:0:{}',132,'','',0,'sites/all/modules/rules/rules_admin/rules_admin.inc'),('admin/config/workflow/rules/settings/basic','','','user_access','a:1:{i:0;s:16:\"administer rules\";}','drupal_get_form','a:1:{i:0;s:20:\"rules_admin_settings\";}','',63,6,1,'admin/config/workflow/rules/settings','admin/config/workflow/rules','Basic','t','','','a:0:{}',140,'','',-10,'sites/all/modules/rules/rules_admin/rules_admin.inc'),('admin/config/workflow/rules/upgrade','','','user_access','a:1:{i:0;s:16:\"administer rules\";}','drupal_get_form','a:1:{i:0;s:18:\"rules_upgrade_form\";}','',31,5,0,'','admin/config/workflow/rules/upgrade','Upgrade','t','','','a:0:{}',0,'','',0,'sites/all/modules/rules/includes/rules.upgrade.inc'),('admin/config/workflow/rules/upgrade/clear','','','user_access','a:1:{i:0;s:16:\"administer rules\";}','drupal_get_form','a:1:{i:0;s:32:\"rules_upgrade_confirm_clear_form\";}','',63,6,0,'','admin/config/workflow/rules/upgrade/clear','Clear','t','','','a:0:{}',0,'','',0,'sites/all/modules/rules/includes/rules.upgrade.inc'),('admin/content','','','user_access','a:1:{i:0;s:23:\"access content overview\";}','drupal_get_form','a:1:{i:0;s:18:\"node_admin_content\";}','',3,2,0,'','admin/content','Content','t','','','a:0:{}',6,'Administer content and comments.','',-10,'modules/node/node.admin.inc'),('admin/content/comment','','','user_access','a:1:{i:0;s:19:\"administer comments\";}','comment_admin','a:0:{}','',7,3,1,'admin/content','admin/content','Comments','t','','','a:0:{}',134,'List and edit site comments and the comment approval queue.','',0,'modules/comment/comment.admin.inc'),('admin/content/comment/approval','','','user_access','a:1:{i:0;s:19:\"administer comments\";}','comment_admin','a:1:{i:0;s:8:\"approval\";}','',15,4,1,'admin/content/comment','admin/content','Unapproved comments','comment_count_unpublished','','','a:0:{}',132,'','',0,'modules/comment/comment.admin.inc'),('admin/content/comment/new','','','user_access','a:1:{i:0;s:19:\"administer comments\";}','comment_admin','a:0:{}','',15,4,1,'admin/content/comment','admin/content','Published comments','t','','','a:0:{}',140,'','',-10,'modules/comment/comment.admin.inc'),('admin/content/node','','','user_access','a:1:{i:0;s:23:\"access content overview\";}','drupal_get_form','a:1:{i:0;s:18:\"node_admin_content\";}','',7,3,1,'admin/content','admin/content','Content','t','','','a:0:{}',140,'','',-10,'modules/node/node.admin.inc'),('admin/content/simplenews','','','user_access','a:1:{i:0;s:22:\"administer newsletters\";}','drupal_get_form','a:1:{i:0;s:34:\"simplenews_admin_newsletter_issues\";}','',7,3,1,'admin/content','admin/content','Newsletters','t','','','a:0:{}',132,'List newsletters and newsletter sent status.','',0,'sites/all/modules/simplenews/includes/simplenews.admin.inc'),('admin/content/simplenews/subscriptions/delete','','','user_access','a:1:{i:0;s:35:\"administer simplenews subscriptions\";}','drupal_get_form','a:1:{i:0;s:47:\"simplenews_subscription_multiple_delete_confirm\";}','',31,5,0,'','admin/content/simplenews/subscriptions/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/simplenews/includes/simplenews.admin.inc'),('admin/content/webform','','','user_access','a:1:{i:0;s:26:\"access all webform results\";}','webform_admin_content','a:0:{}','',7,3,1,'admin/content','admin/content','Webforms','t','','','a:0:{}',132,'View and edit all the available webforms on your site.','',0,'sites/all/modules/webform/includes/webform.admin.inc'),('admin/dashboard','','','user_access','a:1:{i:0;s:16:\"access dashboard\";}','dashboard_admin','a:0:{}','',3,2,0,'','admin/dashboard','Dashboard','t','','','a:0:{}',6,'View and customize your dashboard.','',-15,''),('admin/dashboard/block-content/%/%','a:2:{i:3;N;i:4;N;}','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','dashboard_show_block_content','a:2:{i:0;i:3;i:1;i:4;}','',28,5,0,'','admin/dashboard/block-content/%/%','','t','','','a:0:{}',0,'','',0,''),('admin/dashboard/configure','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','dashboard_admin_blocks','a:0:{}','',7,3,0,'','admin/dashboard/configure','Configure available dashboard blocks','t','','','a:0:{}',4,'Configure which blocks can be shown on the dashboard.','',0,''),('admin/dashboard/customize','','','user_access','a:1:{i:0;s:16:\"access dashboard\";}','dashboard_admin','a:1:{i:0;b:1;}','',7,3,0,'','admin/dashboard/customize','Customize dashboard','t','','','a:0:{}',4,'Customize your dashboard.','',0,''),('admin/dashboard/drawer','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','dashboard_show_disabled','a:0:{}','',7,3,0,'','admin/dashboard/drawer','','t','','','a:0:{}',0,'','',0,''),('admin/dashboard/update','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','dashboard_update','a:0:{}','',7,3,0,'','admin/dashboard/update','','t','','','a:0:{}',0,'','',0,''),('admin/help','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_main','a:0:{}','',3,2,0,'','admin/help','Help','t','','','a:0:{}',6,'Reference for usage, configuration, and modules.','',9,'modules/help/help.admin.inc'),('admin/help/admin_menu','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/admin_menu','admin_menu','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/block','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/block','block','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/ckeditor','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/ckeditor','ckeditor','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/color','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/color','color','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/comment','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/comment','comment','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/commerce_checkout','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/commerce_checkout','commerce_checkout','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/commerce_customer_ui','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/commerce_customer_ui','commerce_customer_ui','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/commerce_line_item_ui','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/commerce_line_item_ui','commerce_line_item_ui','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/commerce_order_ui','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/commerce_order_ui','commerce_order_ui','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/commerce_payment_ui','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/commerce_payment_ui','commerce_payment_ui','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/commerce_product_pricing_ui','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/commerce_product_pricing_ui','commerce_product_pricing_ui','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/commerce_product_ui','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/commerce_product_ui','commerce_product_ui','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/commerce_shipping_ui','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/commerce_shipping_ui','commerce_shipping_ui','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/context','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/context','context','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/contextual','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/contextual','contextual','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/context_ui','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/context_ui','context_ui','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/custom_breadcrumbs','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/custom_breadcrumbs','custom_breadcrumbs','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/custom_breadcrumbs_taxonomy','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/custom_breadcrumbs_taxonomy','custom_breadcrumbs_taxonomy','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/dashboard','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/dashboard','dashboard','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/dblog','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/dblog','dblog','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/devel','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/devel','devel','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/features','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/features','features','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/field','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/field','field','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/field_collection','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/field_collection','field_collection','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/field_sql_storage','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/field_sql_storage','field_sql_storage','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/field_ui','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/field_ui','field_ui','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/file','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/file','file','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/filter','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/filter','filter','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/fivestar','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/fivestar','fivestar','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/flexslider','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/flexslider','flexslider','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/help','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/help','help','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/image','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/image','image','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/jcarousel','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/jcarousel','jcarousel','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/jquery_update','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/jquery_update','jquery_update','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/list','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/list','list','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/locale','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/locale','locale','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/menu','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/menu','menu','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/node','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/node','node','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/number','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/number','number','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/options','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/options','options','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/overlay','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/overlay','overlay','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/path','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/path','path','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/pathauto','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/pathauto','pathauto','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/php','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/php','php','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/rules','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/rules','rules','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/search','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/search','search','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/search_api','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/search_api','search_api','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/search_api_sorts','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/search_api_sorts','search_api_sorts','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/shortcut','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/shortcut','shortcut','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/simplenews','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/simplenews','simplenews','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/system','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/system','system','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/taxonomy','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/taxonomy','taxonomy','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/text','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/text','text','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/title','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/title','title','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/token','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/token','token','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/update','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/update','update','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/user','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/user','user','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/views_slideshow','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/views_slideshow','views_slideshow','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/views_slideshow_cycle','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/views_slideshow_cycle','views_slideshow_cycle','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/webform','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/webform','webform','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/index','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_index','a:0:{}','',3,2,1,'admin','admin','Index','t','','','a:0:{}',132,'','',-18,'modules/system/system.admin.inc'),('admin/modules','','','user_access','a:1:{i:0;s:18:\"administer modules\";}','drupal_get_form','a:1:{i:0;s:14:\"system_modules\";}','',3,2,0,'','admin/modules','Modules','t','','','a:0:{}',6,'Extend site functionality.','',-2,'modules/system/system.admin.inc'),('admin/modules/install','','','update_manager_access','a:0:{}','drupal_get_form','a:2:{i:0;s:27:\"update_manager_install_form\";i:1;s:6:\"module\";}','',7,3,1,'admin/modules','admin/modules','Install new module','t','','','a:0:{}',388,'','',25,'modules/update/update.manager.inc'),('admin/modules/list','','','user_access','a:1:{i:0;s:18:\"administer modules\";}','drupal_get_form','a:1:{i:0;s:14:\"system_modules\";}','',7,3,1,'admin/modules','admin/modules','List','t','','','a:0:{}',140,'','',0,'modules/system/system.admin.inc'),('admin/modules/list/confirm','','','user_access','a:1:{i:0;s:18:\"administer modules\";}','drupal_get_form','a:1:{i:0;s:14:\"system_modules\";}','',15,4,0,'','admin/modules/list/confirm','List','t','','','a:0:{}',4,'','',0,'modules/system/system.admin.inc'),('admin/modules/uninstall','','','user_access','a:1:{i:0;s:18:\"administer modules\";}','drupal_get_form','a:1:{i:0;s:24:\"system_modules_uninstall\";}','',7,3,1,'admin/modules','admin/modules','Uninstall','t','','','a:0:{}',132,'','',20,'modules/system/system.admin.inc'),('admin/modules/uninstall/confirm','','','user_access','a:1:{i:0;s:18:\"administer modules\";}','drupal_get_form','a:1:{i:0;s:24:\"system_modules_uninstall\";}','',15,4,0,'','admin/modules/uninstall/confirm','Uninstall','t','','','a:0:{}',4,'','',0,'modules/system/system.admin.inc'),('admin/modules/update','','','update_manager_access','a:0:{}','drupal_get_form','a:2:{i:0;s:26:\"update_manager_update_form\";i:1;s:6:\"module\";}','',7,3,1,'admin/modules','admin/modules','Update','t','','','a:0:{}',132,'','',10,'modules/update/update.manager.inc'),('admin/people','','','user_access','a:1:{i:0;s:16:\"administer users\";}','user_admin','a:1:{i:0;s:4:\"list\";}','',3,2,0,'','admin/people','People','t','','','a:0:{}',6,'Manage user accounts, roles, and permissions.','left',-4,'modules/user/user.admin.inc'),('admin/people/create','','','user_access','a:1:{i:0;s:16:\"administer users\";}','user_admin','a:1:{i:0;s:6:\"create\";}','',7,3,1,'admin/people','admin/people','Add user','t','','','a:0:{}',388,'','',0,'modules/user/user.admin.inc'),('admin/people/people','','','user_access','a:1:{i:0;s:16:\"administer users\";}','user_admin','a:1:{i:0;s:4:\"list\";}','',7,3,1,'admin/people','admin/people','List','t','','','a:0:{}',140,'Find and manage people interacting with your site.','',-10,'modules/user/user.admin.inc'),('admin/people/permissions','','','user_access','a:1:{i:0;s:22:\"administer permissions\";}','drupal_get_form','a:1:{i:0;s:22:\"user_admin_permissions\";}','',7,3,1,'admin/people','admin/people','Permissions','t','','','a:0:{}',132,'Determine access to features by selecting permissions for roles.','',0,'modules/user/user.admin.inc'),('admin/people/permissions/list','','','user_access','a:1:{i:0;s:22:\"administer permissions\";}','drupal_get_form','a:1:{i:0;s:22:\"user_admin_permissions\";}','',15,4,1,'admin/people/permissions','admin/people','Permissions','t','','','a:0:{}',140,'Determine access to features by selecting permissions for roles.','',-8,'modules/user/user.admin.inc'),('admin/people/permissions/roles','','','user_access','a:1:{i:0;s:22:\"administer permissions\";}','drupal_get_form','a:1:{i:0;s:16:\"user_admin_roles\";}','',15,4,1,'admin/people/permissions','admin/people','Roles','t','','','a:0:{}',132,'List, edit, or add user roles.','',-5,'modules/user/user.admin.inc'),('admin/people/permissions/roles/delete/%','a:1:{i:5;s:14:\"user_role_load\";}','','user_role_edit_access','a:1:{i:0;i:5;}','drupal_get_form','a:2:{i:0;s:30:\"user_admin_role_delete_confirm\";i:1;i:5;}','',62,6,0,'','admin/people/permissions/roles/delete/%','Delete role','t','','','a:0:{}',6,'','',0,'modules/user/user.admin.inc'),('admin/people/permissions/roles/edit/%','a:1:{i:5;s:14:\"user_role_load\";}','','user_role_edit_access','a:1:{i:0;i:5;}','drupal_get_form','a:2:{i:0;s:15:\"user_admin_role\";i:1;i:5;}','',62,6,0,'','admin/people/permissions/roles/edit/%','Edit role','t','','','a:0:{}',6,'','',0,'modules/user/user.admin.inc'),('admin/people/simplenews','','','user_access','a:1:{i:0;s:35:\"administer simplenews subscriptions\";}','drupal_get_form','a:1:{i:0;s:29:\"simplenews_admin_subscription\";}','',7,3,1,'admin/people','admin/people','Newsletter subscriptions','t','','','a:0:{}',132,'Newsletter subscription management.','',0,'sites/all/modules/simplenews/includes/simplenews.admin.inc'),('admin/people/simplenews/export','','','user_access','a:1:{i:0;s:35:\"administer simplenews subscriptions\";}','drupal_get_form','a:1:{i:0;s:35:\"simplenews_subscription_list_export\";}','',15,4,1,'admin/people/simplenews','admin/people','Export','t','','','a:0:{}',388,'','',10,'sites/all/modules/simplenews/includes/simplenews.admin.inc'),('admin/people/simplenews/import','','','user_access','a:1:{i:0;s:35:\"administer simplenews subscriptions\";}','drupal_get_form','a:1:{i:0;s:32:\"simplenews_subscription_list_add\";}','',15,4,1,'admin/people/simplenews','admin/people','Mass subscribe','t','','','a:0:{}',388,'','',8,'sites/all/modules/simplenews/includes/simplenews.admin.inc'),('admin/people/simplenews/unsubscribe','','','user_access','a:1:{i:0;s:35:\"administer simplenews subscriptions\";}','drupal_get_form','a:1:{i:0;s:35:\"simplenews_subscription_list_remove\";}','',15,4,1,'admin/people/simplenews','admin/people','Mass unsubscribe','t','','','a:0:{}',388,'','',9,'sites/all/modules/simplenews/includes/simplenews.admin.inc'),('admin/people/simplenews/users/edit/%','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:35:\"administer simplenews subscriptions\";}','drupal_get_form','a:2:{i:0;s:35:\"simplenews_subscriptions_admin_form\";i:1;i:5;}','',62,6,0,'','admin/people/simplenews/users/edit/%','Subscriptions','t','','','a:0:{}',6,'','',0,'sites/all/modules/simplenews/includes/simplenews.subscription.inc'),('admin/reports','','','user_access','a:1:{i:0;s:19:\"access site reports\";}','system_admin_menu_block_page','a:0:{}','',3,2,0,'','admin/reports','Reports','t','','','a:0:{}',6,'View reports, updates, and errors.','left',5,'modules/system/system.admin.inc'),('admin/reports/access-denied','','','user_access','a:1:{i:0;s:19:\"access site reports\";}','dblog_top','a:1:{i:0;s:13:\"access denied\";}','',7,3,0,'','admin/reports/access-denied','Top \'access denied\' errors','t','','','a:0:{}',6,'View \'access denied\' errors (403s).','',0,'modules/dblog/dblog.admin.inc'),('admin/reports/dblog','','','user_access','a:1:{i:0;s:19:\"access site reports\";}','dblog_overview','a:0:{}','',7,3,0,'','admin/reports/dblog','Recent log messages','t','','','a:0:{}',6,'View events that have recently been logged.','',-1,'modules/dblog/dblog.admin.inc'),('admin/reports/event/%','a:1:{i:3;N;}','','user_access','a:1:{i:0;s:19:\"access site reports\";}','dblog_event','a:1:{i:0;i:3;}','',14,4,0,'','admin/reports/event/%','Details','t','','','a:0:{}',6,'','',0,'modules/dblog/dblog.admin.inc'),('admin/reports/fields','','','user_access','a:1:{i:0;s:24:\"administer content types\";}','field_ui_fields_list','a:0:{}','',7,3,0,'','admin/reports/fields','Field list','t','','','a:0:{}',6,'Overview of fields on all entity types.','',0,'modules/field_ui/field_ui.admin.inc'),('admin/reports/fields/list','','','user_access','a:1:{i:0;s:24:\"administer content types\";}','field_ui_fields_list','a:0:{}','',15,4,1,'admin/reports/fields','admin/reports/fields','List','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/reports/fields/views-fields','','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_field_list','a:0:{}','',15,4,1,'admin/reports/fields','admin/reports/fields','Used in views','t','','','a:0:{}',132,'Overview of fields used in all views.','',0,'sites/all/modules/views/includes/admin.inc'),('admin/reports/page-not-found','','','user_access','a:1:{i:0;s:19:\"access site reports\";}','dblog_top','a:1:{i:0;s:14:\"page not found\";}','',7,3,0,'','admin/reports/page-not-found','Top \'page not found\' errors','t','','','a:0:{}',6,'View \'page not found\' errors (404s).','',0,'modules/dblog/dblog.admin.inc'),('admin/reports/search','','','user_access','a:1:{i:0;s:19:\"access site reports\";}','dblog_top','a:1:{i:0;s:6:\"search\";}','',7,3,0,'','admin/reports/search','Top search phrases','t','','','a:0:{}',6,'View most popular search phrases.','',0,'modules/dblog/dblog.admin.inc'),('admin/reports/status','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','system_status','a:0:{}','',7,3,0,'','admin/reports/status','Status report','t','','','a:0:{}',6,'Get a status report about your site\'s operation and any detected problems.','',-60,'modules/system/system.admin.inc'),('admin/reports/status/php','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','system_php','a:0:{}','',15,4,0,'','admin/reports/status/php','PHP','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/reports/status/rebuild','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','drupal_get_form','a:1:{i:0;s:30:\"node_configure_rebuild_confirm\";}','',15,4,0,'','admin/reports/status/rebuild','Rebuild permissions','t','','','a:0:{}',0,'','',0,'modules/node/node.admin.inc'),('admin/reports/status/run-cron','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','system_run_cron','a:0:{}','',15,4,0,'','admin/reports/status/run-cron','Run cron','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/reports/updates','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','module_filter_update_status','a:0:{}','',7,3,0,'','admin/reports/updates','Available updates','t','','','a:0:{}',6,'Get a status report about available updates for your installed modules and themes.','',-50,'sites/all/modules/module_filter/module_filter.pages.inc'),('admin/reports/updates/check','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','update_manual_status','a:0:{}','',15,4,0,'','admin/reports/updates/check','Manual update check','t','','','a:0:{}',0,'','',0,'modules/update/update.fetch.inc'),('admin/reports/updates/install','','','update_manager_access','a:0:{}','drupal_get_form','a:2:{i:0;s:27:\"update_manager_install_form\";i:1;s:6:\"report\";}','',15,4,1,'admin/reports/updates','admin/reports/updates','Install new module or theme','t','','','a:0:{}',388,'','',25,'modules/update/update.manager.inc'),('admin/reports/updates/list','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','module_filter_update_status','a:0:{}','',15,4,1,'admin/reports/updates','admin/reports/updates','List','t','','','a:0:{}',140,'','',0,'sites/all/modules/module_filter/module_filter.pages.inc'),('admin/reports/updates/settings','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:15:\"update_settings\";}','',15,4,1,'admin/reports/updates','admin/reports/updates','Settings','t','','','a:0:{}',132,'','',50,'modules/update/update.settings.inc'),('admin/reports/updates/update','','','update_manager_access','a:0:{}','drupal_get_form','a:2:{i:0;s:26:\"update_manager_update_form\";i:1;s:6:\"report\";}','',15,4,1,'admin/reports/updates','admin/reports/updates','Update','t','','','a:0:{}',132,'','',10,'modules/update/update.manager.inc'),('admin/reports/views-plugins','','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_plugin_list','a:0:{}','',7,3,0,'','admin/reports/views-plugins','Views plugins','t','','','a:0:{}',6,'Overview of plugins used in all views.','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',3,2,0,'','admin/structure','Structure','t','','','a:0:{}',6,'Administer blocks, content types, menus, etc.','right',-8,'modules/system/system.admin.inc'),('admin/structure/block','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','block_admin_display','a:1:{i:0;s:11:\"marketplace\";}','',7,3,0,'','admin/structure/block','Blocks','t','','','a:0:{}',6,'Configure what block content appears in your site\'s sidebars and other regions.','',0,'modules/block/block.admin.inc'),('admin/structure/block/add','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:1:{i:0;s:20:\"block_add_block_form\";}','',15,4,1,'admin/structure/block','admin/structure/block','Add block','t','','','a:0:{}',388,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/demo/bartik','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:25:\"themes/bartik/bartik.info\";s:4:\"name\";s:6:\"bartik\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:6:\"Bartik\";s:11:\"description\";s:48:\"A flexible, recolorable theme with many regions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:7:\"regions\";a:20:{s:6:\"header\";s:6:\"Header\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"triptych_first\";s:14:\"Triptych first\";s:15:\"triptych_middle\";s:15:\"Triptych middle\";s:13:\"triptych_last\";s:13:\"Triptych last\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"0\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:28:\"themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_demo','a:1:{i:0;s:6:\"bartik\";}','',31,5,0,'','admin/structure/block/demo/bartik','Bartik','t','','_block_custom_theme','a:1:{i:0;s:6:\"bartik\";}',0,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/demo/garland','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:27:\"themes/garland/garland.info\";s:4:\"name\";s:7:\"garland\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:7:\"Garland\";s:11:\"description\";s:111:\"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:8:\"settings\";a:1:{s:13:\"garland_width\";s:5:\"fluid\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:29:\"themes/garland/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_demo','a:1:{i:0;s:7:\"garland\";}','',31,5,0,'','admin/structure/block/demo/garland','Garland','t','','_block_custom_theme','a:1:{i:0;s:7:\"garland\";}',0,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/demo/marketplace','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":13:{s:8:\"filename\";s:45:\"sites/all/themes/marketplace/marketplace.info\";s:4:\"name\";s:11:\"marketplace\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:12:\"Market Place\";s:11:\"description\";s:23:\"Theme for Market Place.\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"engine\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:5:{s:3:\"all\";a:11:{s:34:\"vendor/bootstrap/css/bootstrap.css\";s:63:\"sites/all/themes/marketplace/vendor/bootstrap/css/bootstrap.css\";s:40:\"vendor/bootstrap/css/bootstrap-theme.css\";s:69:\"sites/all/themes/marketplace/vendor/bootstrap/css/bootstrap-theme.css\";s:20:\"fonts/stylesheet.css\";s:49:\"sites/all/themes/marketplace/fonts/stylesheet.css\";s:15:\"css/animate.css\";s:44:\"sites/all/themes/marketplace/css/animate.css\";s:12:\"css/html.css\";s:41:\"sites/all/themes/marketplace/css/html.css\";s:12:\"css/base.css\";s:41:\"sites/all/themes/marketplace/css/base.css\";s:12:\"css/page.css\";s:41:\"sites/all/themes/marketplace/css/page.css\";s:13:\"css/block.css\";s:42:\"sites/all/themes/marketplace/css/block.css\";s:12:\"css/view.css\";s:41:\"sites/all/themes/marketplace/css/view.css\";s:12:\"css/menu.css\";s:41:\"sites/all/themes/marketplace/css/menu.css\";s:14:\"css/screen.css\";s:43:\"sites/all/themes/marketplace/css/screen.css\";}s:56:\"only screen and (min-width:992px) and (max-width:1199px)\";a:1:{s:22:\"css/screens/tablet.css\";s:51:\"sites/all/themes/marketplace/css/screens/tablet.css\";}s:55:\"only screen and (min-width:768px) and (max-width:991px)\";a:1:{s:31:\"css/screens/vertical_tablet.css\";s:60:\"sites/all/themes/marketplace/css/screens/vertical_tablet.css\";}s:33:\"only screen and (max-width:991px)\";a:1:{s:22:\"css/screens/common.css\";s:51:\"sites/all/themes/marketplace/css/screens/common.css\";}s:33:\"only screen and (max-width:767px)\";a:1:{s:22:\"css/screens/mobile.css\";s:51:\"sites/all/themes/marketplace/css/screens/mobile.css\";}}s:7:\"scripts\";a:6:{s:36:\"vendor/bootstrap/js/bootstrap.min.js\";s:65:\"sites/all/themes/marketplace/vendor/bootstrap/js/bootstrap.min.js\";s:23:\"vendor/jquery.cookie.js\";s:52:\"sites/all/themes/marketplace/vendor/jquery.cookie.js\";s:30:\"vendor/jquery.smooth-scroll.js\";s:59:\"sites/all/themes/marketplace/vendor/jquery.smooth-scroll.js\";s:28:\"vendor/uikit/js/uikit.min.js\";s:57:\"sites/all/themes/marketplace/vendor/uikit/js/uikit.min.js\";s:13:\"js/weebpal.js\";s:42:\"sites/all/themes/marketplace/js/weebpal.js\";s:17:\"js/marketplace.js\";s:46:\"sites/all/themes/marketplace/js/marketplace.js\";}s:8:\"features\";a:7:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:25:\"comment_user_verification\";i:6;s:7:\"favicon\";}s:7:\"regions\";a:25:{s:8:\"headline\";s:8:\"Headline\";s:6:\"header\";s:6:\"Header\";s:9:\"main_menu\";s:9:\"Main Menu\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"panel_menu_top\";s:8:\"Menu Top\";s:17:\"panel_mobile_menu\";s:17:\"Panel Mobile Menu\";s:11:\"panel_first\";s:11:\"Panel First\";s:12:\"panel_second\";s:12:\"Panel Second\";s:11:\"panel_third\";s:11:\"Panel Third\";s:19:\"panel_highlighted_1\";s:16:\"Highlighted Left\";s:19:\"panel_highlighted_2\";s:11:\"Highlighted\";s:19:\"panel_highlighted_3\";s:17:\"Highlighted Right\";s:14:\"panel_footer_1\";s:14:\"Panel Footer 1\";s:14:\"panel_footer_2\";s:14:\"Panel Footer 2\";s:14:\"panel_footer_3\";s:14:\"Panel Footer 3\";s:14:\"panel_footer_4\";s:14:\"Panel Footer 4\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:9:{s:19:\"sidebar_first_width\";s:1:\"3\";s:20:\"sidebar_second_width\";s:1:\"3\";s:20:\"panel_footer_1_width\";s:1:\"3\";s:20:\"panel_footer_2_width\";s:1:\"3\";s:20:\"panel_footer_3_width\";s:1:\"3\";s:20:\"panel_footer_4_width\";s:1:\"3\";s:25:\"panel_highlighted_1_width\";s:1:\"4\";s:25:\"panel_highlighted_3_width\";s:1:\"4\";s:20:\"layout_width_default\";s:4:\"1200\";}s:5:\"skins\";a:5:{s:3:\"red\";s:3:\"Red\";s:9:\"dark_blue\";s:9:\"Dark Blue\";s:6:\"yellow\";s:6:\"Yellow\";s:5:\"green\";s:5:\"Green\";s:4:\"cyan\";s:4:\"Cyan\";}s:11:\"backgrounds\";a:7:{s:4:\"bg-1\";s:12:\"Background 1\";s:4:\"bg-2\";s:12:\"Background 2\";s:4:\"bg-3\";s:12:\"Background 3\";s:4:\"bg-4\";s:12:\"Background 4\";s:4:\"bg-5\";s:12:\"Background 5\";s:4:\"bg-6\";s:12:\"Background 6\";s:4:\"bg-7\";s:12:\"Background 7\";}s:6:\"layout\";a:1:{s:12:\"layout-boxed\";s:12:\"Boxed Layout\";}s:10:\"screenshot\";s:43:\"sites/all/themes/marketplace/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"mtime\";i:1499933463;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:5:{s:3:\"all\";a:11:{s:34:\"vendor/bootstrap/css/bootstrap.css\";s:63:\"sites/all/themes/marketplace/vendor/bootstrap/css/bootstrap.css\";s:40:\"vendor/bootstrap/css/bootstrap-theme.css\";s:69:\"sites/all/themes/marketplace/vendor/bootstrap/css/bootstrap-theme.css\";s:20:\"fonts/stylesheet.css\";s:49:\"sites/all/themes/marketplace/fonts/stylesheet.css\";s:15:\"css/animate.css\";s:44:\"sites/all/themes/marketplace/css/animate.css\";s:12:\"css/html.css\";s:41:\"sites/all/themes/marketplace/css/html.css\";s:12:\"css/base.css\";s:41:\"sites/all/themes/marketplace/css/base.css\";s:12:\"css/page.css\";s:41:\"sites/all/themes/marketplace/css/page.css\";s:13:\"css/block.css\";s:42:\"sites/all/themes/marketplace/css/block.css\";s:12:\"css/view.css\";s:41:\"sites/all/themes/marketplace/css/view.css\";s:12:\"css/menu.css\";s:41:\"sites/all/themes/marketplace/css/menu.css\";s:14:\"css/screen.css\";s:43:\"sites/all/themes/marketplace/css/screen.css\";}s:56:\"only screen and (min-width:992px) and (max-width:1199px)\";a:1:{s:22:\"css/screens/tablet.css\";s:51:\"sites/all/themes/marketplace/css/screens/tablet.css\";}s:55:\"only screen and (min-width:768px) and (max-width:991px)\";a:1:{s:31:\"css/screens/vertical_tablet.css\";s:60:\"sites/all/themes/marketplace/css/screens/vertical_tablet.css\";}s:33:\"only screen and (max-width:991px)\";a:1:{s:22:\"css/screens/common.css\";s:51:\"sites/all/themes/marketplace/css/screens/common.css\";}s:33:\"only screen and (max-width:767px)\";a:1:{s:22:\"css/screens/mobile.css\";s:51:\"sites/all/themes/marketplace/css/screens/mobile.css\";}}s:7:\"scripts\";a:6:{s:36:\"vendor/bootstrap/js/bootstrap.min.js\";s:65:\"sites/all/themes/marketplace/vendor/bootstrap/js/bootstrap.min.js\";s:23:\"vendor/jquery.cookie.js\";s:52:\"sites/all/themes/marketplace/vendor/jquery.cookie.js\";s:30:\"vendor/jquery.smooth-scroll.js\";s:59:\"sites/all/themes/marketplace/vendor/jquery.smooth-scroll.js\";s:28:\"vendor/uikit/js/uikit.min.js\";s:57:\"sites/all/themes/marketplace/vendor/uikit/js/uikit.min.js\";s:13:\"js/weebpal.js\";s:42:\"sites/all/themes/marketplace/js/weebpal.js\";s:17:\"js/marketplace.js\";s:46:\"sites/all/themes/marketplace/js/marketplace.js\";}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_demo','a:1:{i:0;s:11:\"marketplace\";}','',31,5,0,'','admin/structure/block/demo/marketplace','Market Place','t','','_block_custom_theme','a:1:{i:0;s:11:\"marketplace\";}',0,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/demo/seven','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/seven/seven.info\";s:4:\"name\";s:5:\"seven\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:5:\"Seven\";s:11:\"description\";s:65:\"A simple one-column, tableless, fluid width administration theme.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"1\";}s:7:\"regions\";a:8:{s:7:\"content\";s:7:\"Content\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_demo','a:1:{i:0;s:5:\"seven\";}','',31,5,0,'','admin/structure/block/demo/seven','Seven','t','','_block_custom_theme','a:1:{i:0;s:5:\"seven\";}',0,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/demo/stark','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/stark/stark.info\";s:4:\"name\";s:5:\"stark\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:5:\"Stark\";s:11:\"description\";s:208:\"This theme demonstrates Drupal\'s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal\'s default code, see the <a href=\"http://drupal.org/theme-guide\">Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/stark/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_demo','a:1:{i:0;s:5:\"stark\";}','',31,5,0,'','admin/structure/block/demo/stark','Stark','t','','_block_custom_theme','a:1:{i:0;s:5:\"stark\";}',0,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/demo/we_backend','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":13:{s:8:\"filename\";s:43:\"sites/all/themes/we_backend/we_backend.info\";s:4:\"name\";s:10:\"we_backend\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:15:{s:4:\"name\";s:21:\"WeebPal Backend theme\";s:11:\"description\";s:26:\"Backend theme from WeebPal\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"engine\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:20:\"assets/css/style.css\";s:48:\"sites/all/themes/we_backend/assets/css/style.css\";}}s:7:\"scripts\";a:1:{s:20:\"assets/js/scripts.js\";s:48:\"sites/all/themes/we_backend/assets/js/scripts.js\";}s:8:\"features\";a:7:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:25:\"comment_user_verification\";i:6;s:7:\"favicon\";}s:7:\"regions\";a:10:{s:6:\"header\";s:6:\"Header\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:10:\"screenshot\";s:42:\"sites/all/themes/we_backend/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"mtime\";i:1499933463;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:20:\"assets/css/style.css\";s:48:\"sites/all/themes/we_backend/assets/css/style.css\";}}s:7:\"scripts\";a:1:{s:20:\"assets/js/scripts.js\";s:48:\"sites/all/themes/we_backend/assets/js/scripts.js\";}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_demo','a:1:{i:0;s:10:\"we_backend\";}','',31,5,0,'','admin/structure/block/demo/we_backend','WeebPal Backend theme','t','','_block_custom_theme','a:1:{i:0;s:10:\"we_backend\";}',0,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/bartik','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:25:\"themes/bartik/bartik.info\";s:4:\"name\";s:6:\"bartik\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:6:\"Bartik\";s:11:\"description\";s:48:\"A flexible, recolorable theme with many regions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:7:\"regions\";a:20:{s:6:\"header\";s:6:\"Header\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"triptych_first\";s:14:\"Triptych first\";s:15:\"triptych_middle\";s:15:\"Triptych middle\";s:13:\"triptych_last\";s:13:\"Triptych last\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"0\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:28:\"themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_display','a:1:{i:0;s:6:\"bartik\";}','',31,5,1,'admin/structure/block','admin/structure/block','Bartik','t','','','a:0:{}',132,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/bartik/add','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:1:{i:0;s:20:\"block_add_block_form\";}','',63,6,1,'admin/structure/block/list/bartik','admin/structure/block','Add block','t','','','a:0:{}',388,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/garland','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:27:\"themes/garland/garland.info\";s:4:\"name\";s:7:\"garland\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:7:\"Garland\";s:11:\"description\";s:111:\"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:8:\"settings\";a:1:{s:13:\"garland_width\";s:5:\"fluid\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:29:\"themes/garland/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_display','a:1:{i:0;s:7:\"garland\";}','',31,5,1,'admin/structure/block','admin/structure/block','Garland','t','','','a:0:{}',132,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/garland/add','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:1:{i:0;s:20:\"block_add_block_form\";}','',63,6,1,'admin/structure/block/list/garland','admin/structure/block','Add block','t','','','a:0:{}',388,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/marketplace','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":13:{s:8:\"filename\";s:45:\"sites/all/themes/marketplace/marketplace.info\";s:4:\"name\";s:11:\"marketplace\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:12:\"Market Place\";s:11:\"description\";s:23:\"Theme for Market Place.\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"engine\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:5:{s:3:\"all\";a:11:{s:34:\"vendor/bootstrap/css/bootstrap.css\";s:63:\"sites/all/themes/marketplace/vendor/bootstrap/css/bootstrap.css\";s:40:\"vendor/bootstrap/css/bootstrap-theme.css\";s:69:\"sites/all/themes/marketplace/vendor/bootstrap/css/bootstrap-theme.css\";s:20:\"fonts/stylesheet.css\";s:49:\"sites/all/themes/marketplace/fonts/stylesheet.css\";s:15:\"css/animate.css\";s:44:\"sites/all/themes/marketplace/css/animate.css\";s:12:\"css/html.css\";s:41:\"sites/all/themes/marketplace/css/html.css\";s:12:\"css/base.css\";s:41:\"sites/all/themes/marketplace/css/base.css\";s:12:\"css/page.css\";s:41:\"sites/all/themes/marketplace/css/page.css\";s:13:\"css/block.css\";s:42:\"sites/all/themes/marketplace/css/block.css\";s:12:\"css/view.css\";s:41:\"sites/all/themes/marketplace/css/view.css\";s:12:\"css/menu.css\";s:41:\"sites/all/themes/marketplace/css/menu.css\";s:14:\"css/screen.css\";s:43:\"sites/all/themes/marketplace/css/screen.css\";}s:56:\"only screen and (min-width:992px) and (max-width:1199px)\";a:1:{s:22:\"css/screens/tablet.css\";s:51:\"sites/all/themes/marketplace/css/screens/tablet.css\";}s:55:\"only screen and (min-width:768px) and (max-width:991px)\";a:1:{s:31:\"css/screens/vertical_tablet.css\";s:60:\"sites/all/themes/marketplace/css/screens/vertical_tablet.css\";}s:33:\"only screen and (max-width:991px)\";a:1:{s:22:\"css/screens/common.css\";s:51:\"sites/all/themes/marketplace/css/screens/common.css\";}s:33:\"only screen and (max-width:767px)\";a:1:{s:22:\"css/screens/mobile.css\";s:51:\"sites/all/themes/marketplace/css/screens/mobile.css\";}}s:7:\"scripts\";a:6:{s:36:\"vendor/bootstrap/js/bootstrap.min.js\";s:65:\"sites/all/themes/marketplace/vendor/bootstrap/js/bootstrap.min.js\";s:23:\"vendor/jquery.cookie.js\";s:52:\"sites/all/themes/marketplace/vendor/jquery.cookie.js\";s:30:\"vendor/jquery.smooth-scroll.js\";s:59:\"sites/all/themes/marketplace/vendor/jquery.smooth-scroll.js\";s:28:\"vendor/uikit/js/uikit.min.js\";s:57:\"sites/all/themes/marketplace/vendor/uikit/js/uikit.min.js\";s:13:\"js/weebpal.js\";s:42:\"sites/all/themes/marketplace/js/weebpal.js\";s:17:\"js/marketplace.js\";s:46:\"sites/all/themes/marketplace/js/marketplace.js\";}s:8:\"features\";a:7:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:25:\"comment_user_verification\";i:6;s:7:\"favicon\";}s:7:\"regions\";a:25:{s:8:\"headline\";s:8:\"Headline\";s:6:\"header\";s:6:\"Header\";s:9:\"main_menu\";s:9:\"Main Menu\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"panel_menu_top\";s:8:\"Menu Top\";s:17:\"panel_mobile_menu\";s:17:\"Panel Mobile Menu\";s:11:\"panel_first\";s:11:\"Panel First\";s:12:\"panel_second\";s:12:\"Panel Second\";s:11:\"panel_third\";s:11:\"Panel Third\";s:19:\"panel_highlighted_1\";s:16:\"Highlighted Left\";s:19:\"panel_highlighted_2\";s:11:\"Highlighted\";s:19:\"panel_highlighted_3\";s:17:\"Highlighted Right\";s:14:\"panel_footer_1\";s:14:\"Panel Footer 1\";s:14:\"panel_footer_2\";s:14:\"Panel Footer 2\";s:14:\"panel_footer_3\";s:14:\"Panel Footer 3\";s:14:\"panel_footer_4\";s:14:\"Panel Footer 4\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:9:{s:19:\"sidebar_first_width\";s:1:\"3\";s:20:\"sidebar_second_width\";s:1:\"3\";s:20:\"panel_footer_1_width\";s:1:\"3\";s:20:\"panel_footer_2_width\";s:1:\"3\";s:20:\"panel_footer_3_width\";s:1:\"3\";s:20:\"panel_footer_4_width\";s:1:\"3\";s:25:\"panel_highlighted_1_width\";s:1:\"4\";s:25:\"panel_highlighted_3_width\";s:1:\"4\";s:20:\"layout_width_default\";s:4:\"1200\";}s:5:\"skins\";a:5:{s:3:\"red\";s:3:\"Red\";s:9:\"dark_blue\";s:9:\"Dark Blue\";s:6:\"yellow\";s:6:\"Yellow\";s:5:\"green\";s:5:\"Green\";s:4:\"cyan\";s:4:\"Cyan\";}s:11:\"backgrounds\";a:7:{s:4:\"bg-1\";s:12:\"Background 1\";s:4:\"bg-2\";s:12:\"Background 2\";s:4:\"bg-3\";s:12:\"Background 3\";s:4:\"bg-4\";s:12:\"Background 4\";s:4:\"bg-5\";s:12:\"Background 5\";s:4:\"bg-6\";s:12:\"Background 6\";s:4:\"bg-7\";s:12:\"Background 7\";}s:6:\"layout\";a:1:{s:12:\"layout-boxed\";s:12:\"Boxed Layout\";}s:10:\"screenshot\";s:43:\"sites/all/themes/marketplace/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"mtime\";i:1499933463;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:5:{s:3:\"all\";a:11:{s:34:\"vendor/bootstrap/css/bootstrap.css\";s:63:\"sites/all/themes/marketplace/vendor/bootstrap/css/bootstrap.css\";s:40:\"vendor/bootstrap/css/bootstrap-theme.css\";s:69:\"sites/all/themes/marketplace/vendor/bootstrap/css/bootstrap-theme.css\";s:20:\"fonts/stylesheet.css\";s:49:\"sites/all/themes/marketplace/fonts/stylesheet.css\";s:15:\"css/animate.css\";s:44:\"sites/all/themes/marketplace/css/animate.css\";s:12:\"css/html.css\";s:41:\"sites/all/themes/marketplace/css/html.css\";s:12:\"css/base.css\";s:41:\"sites/all/themes/marketplace/css/base.css\";s:12:\"css/page.css\";s:41:\"sites/all/themes/marketplace/css/page.css\";s:13:\"css/block.css\";s:42:\"sites/all/themes/marketplace/css/block.css\";s:12:\"css/view.css\";s:41:\"sites/all/themes/marketplace/css/view.css\";s:12:\"css/menu.css\";s:41:\"sites/all/themes/marketplace/css/menu.css\";s:14:\"css/screen.css\";s:43:\"sites/all/themes/marketplace/css/screen.css\";}s:56:\"only screen and (min-width:992px) and (max-width:1199px)\";a:1:{s:22:\"css/screens/tablet.css\";s:51:\"sites/all/themes/marketplace/css/screens/tablet.css\";}s:55:\"only screen and (min-width:768px) and (max-width:991px)\";a:1:{s:31:\"css/screens/vertical_tablet.css\";s:60:\"sites/all/themes/marketplace/css/screens/vertical_tablet.css\";}s:33:\"only screen and (max-width:991px)\";a:1:{s:22:\"css/screens/common.css\";s:51:\"sites/all/themes/marketplace/css/screens/common.css\";}s:33:\"only screen and (max-width:767px)\";a:1:{s:22:\"css/screens/mobile.css\";s:51:\"sites/all/themes/marketplace/css/screens/mobile.css\";}}s:7:\"scripts\";a:6:{s:36:\"vendor/bootstrap/js/bootstrap.min.js\";s:65:\"sites/all/themes/marketplace/vendor/bootstrap/js/bootstrap.min.js\";s:23:\"vendor/jquery.cookie.js\";s:52:\"sites/all/themes/marketplace/vendor/jquery.cookie.js\";s:30:\"vendor/jquery.smooth-scroll.js\";s:59:\"sites/all/themes/marketplace/vendor/jquery.smooth-scroll.js\";s:28:\"vendor/uikit/js/uikit.min.js\";s:57:\"sites/all/themes/marketplace/vendor/uikit/js/uikit.min.js\";s:13:\"js/weebpal.js\";s:42:\"sites/all/themes/marketplace/js/weebpal.js\";s:17:\"js/marketplace.js\";s:46:\"sites/all/themes/marketplace/js/marketplace.js\";}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_display','a:1:{i:0;s:11:\"marketplace\";}','',31,5,1,'admin/structure/block','admin/structure/block','Market Place','t','','','a:0:{}',140,'','',-10,'modules/block/block.admin.inc'),('admin/structure/block/list/seven','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/seven/seven.info\";s:4:\"name\";s:5:\"seven\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:5:\"Seven\";s:11:\"description\";s:65:\"A simple one-column, tableless, fluid width administration theme.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"1\";}s:7:\"regions\";a:8:{s:7:\"content\";s:7:\"Content\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_display','a:1:{i:0;s:5:\"seven\";}','',31,5,1,'admin/structure/block','admin/structure/block','Seven','t','','','a:0:{}',132,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/seven/add','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:1:{i:0;s:20:\"block_add_block_form\";}','',63,6,1,'admin/structure/block/list/seven','admin/structure/block','Add block','t','','','a:0:{}',388,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/stark','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/stark/stark.info\";s:4:\"name\";s:5:\"stark\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:5:\"Stark\";s:11:\"description\";s:208:\"This theme demonstrates Drupal\'s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal\'s default code, see the <a href=\"http://drupal.org/theme-guide\">Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/stark/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_display','a:1:{i:0;s:5:\"stark\";}','',31,5,1,'admin/structure/block','admin/structure/block','Stark','t','','','a:0:{}',132,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/stark/add','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:1:{i:0;s:20:\"block_add_block_form\";}','',63,6,1,'admin/structure/block/list/stark','admin/structure/block','Add block','t','','','a:0:{}',388,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/we_backend','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":13:{s:8:\"filename\";s:43:\"sites/all/themes/we_backend/we_backend.info\";s:4:\"name\";s:10:\"we_backend\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:15:{s:4:\"name\";s:21:\"WeebPal Backend theme\";s:11:\"description\";s:26:\"Backend theme from WeebPal\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"engine\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:20:\"assets/css/style.css\";s:48:\"sites/all/themes/we_backend/assets/css/style.css\";}}s:7:\"scripts\";a:1:{s:20:\"assets/js/scripts.js\";s:48:\"sites/all/themes/we_backend/assets/js/scripts.js\";}s:8:\"features\";a:7:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:25:\"comment_user_verification\";i:6;s:7:\"favicon\";}s:7:\"regions\";a:10:{s:6:\"header\";s:6:\"Header\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:10:\"screenshot\";s:42:\"sites/all/themes/we_backend/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"mtime\";i:1499933463;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:20:\"assets/css/style.css\";s:48:\"sites/all/themes/we_backend/assets/css/style.css\";}}s:7:\"scripts\";a:1:{s:20:\"assets/js/scripts.js\";s:48:\"sites/all/themes/we_backend/assets/js/scripts.js\";}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_display','a:1:{i:0;s:10:\"we_backend\";}','',31,5,1,'admin/structure/block','admin/structure/block','WeebPal Backend theme','t','','','a:0:{}',132,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/we_backend/add','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:1:{i:0;s:20:\"block_add_block_form\";}','',63,6,1,'admin/structure/block/list/we_backend','admin/structure/block','Add block','t','','','a:0:{}',388,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/manage/%/%','a:2:{i:4;N;i:5;N;}','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:3:{i:0;s:21:\"block_admin_configure\";i:1;i:4;i:2;i:5;}','',60,6,0,'','admin/structure/block/manage/%/%','Configure block','t','','','a:0:{}',6,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/manage/%/%/configure','a:2:{i:4;N;i:5;N;}','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:3:{i:0;s:21:\"block_admin_configure\";i:1;i:4;i:2;i:5;}','',121,7,2,'admin/structure/block/manage/%/%','admin/structure/block/manage/%/%','Configure block','t','','','a:0:{}',140,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/manage/%/%/delete','a:2:{i:4;N;i:5;N;}','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:3:{i:0;s:25:\"block_custom_block_delete\";i:1;i:4;i:2;i:5;}','',121,7,0,'admin/structure/block/manage/%/%','admin/structure/block/manage/%/%','Delete block','t','','','a:0:{}',132,'','',0,'modules/block/block.admin.inc'),('admin/structure/context','','','ctools_export_ui_task_access','a:2:{i:0;s:7:\"context\";i:1;s:4:\"list\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:7:\"context\";i:1;s:4:\"list\";}','',7,3,0,'','admin/structure/context','Context','t','','','a:0:{}',6,'Associate menus, views, blocks, etc. with different contexts to structure your site.','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/context/add','','','ctools_export_ui_task_access','a:2:{i:0;s:7:\"context\";i:1;s:3:\"add\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:7:\"context\";i:1;s:3:\"add\";}','',15,4,1,'admin/structure/context','admin/structure/context','Add','t','','','a:0:{}',388,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/context/import','','','ctools_export_ui_task_access','a:2:{i:0;s:7:\"context\";i:1;s:6:\"import\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:7:\"context\";i:1;s:6:\"import\";}','',15,4,1,'admin/structure/context','admin/structure/context','Import','t','','','a:0:{}',388,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/context/list','','','ctools_export_ui_task_access','a:2:{i:0;s:7:\"context\";i:1;s:4:\"list\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:7:\"context\";i:1;s:4:\"list\";}','',15,4,1,'admin/structure/context','admin/structure/context','List','t','','','a:0:{}',140,'','',-10,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/context/list/%','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:7:\"context\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:7:\"context\";i:1;s:4:\"edit\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:7:\"context\";i:1;s:4:\"edit\";i:2;i:4;}','',30,5,0,'','admin/structure/context/list/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/context/list/%/clone','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:7:\"context\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:7:\"context\";i:1;s:5:\"clone\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:7:\"context\";i:1;s:5:\"clone\";i:2;i:4;}','',61,6,0,'','admin/structure/context/list/%/clone','Clone','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/context/list/%/delete','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:7:\"context\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:7:\"context\";i:1;s:6:\"delete\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:7:\"context\";i:1;s:6:\"delete\";i:2;i:4;}','',61,6,0,'','admin/structure/context/list/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/context/list/%/disable','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:7:\"context\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:7:\"context\";i:1;s:7:\"disable\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:7:\"context\";i:1;s:7:\"disable\";i:2;i:4;}','',61,6,0,'','admin/structure/context/list/%/disable','Disable','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/context/list/%/edit','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:7:\"context\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:7:\"context\";i:1;s:4:\"edit\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:7:\"context\";i:1;s:4:\"edit\";i:2;i:4;}','',61,6,1,'admin/structure/context/list/%','admin/structure/context/list/%','Edit','t','','','a:0:{}',140,'','',-10,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/context/list/%/enable','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:7:\"context\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:7:\"context\";i:1;s:6:\"enable\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:7:\"context\";i:1;s:6:\"enable\";i:2;i:4;}','',61,6,0,'','admin/structure/context/list/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/context/list/%/export','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:7:\"context\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:7:\"context\";i:1;s:6:\"export\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:7:\"context\";i:1;s:6:\"export\";i:2;i:4;}','',61,6,1,'admin/structure/context/list/%','admin/structure/context/list/%','Export','t','','','a:0:{}',132,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/context/list/%/revert','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:7:\"context\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:7:\"context\";i:1;s:6:\"revert\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:7:\"context\";i:1;s:6:\"delete\";i:2;i:4;}','',61,6,0,'','admin/structure/context/list/%/revert','Revert','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/context/settings','','','user_access','a:1:{i:0;s:19:\"administer contexts\";}','drupal_get_form','a:1:{i:0;s:19:\"context_ui_settings\";}','',15,4,1,'admin/structure/context','admin/structure/context','Settings','t','','','a:0:{}',132,'','',3,''),('admin/structure/custom_breadcrumbs','','','user_access','a:1:{i:0;s:29:\"administer custom breadcrumbs\";}','custom_breadcrumbs_page','a:0:{}','',7,3,0,'','admin/structure/custom_breadcrumbs','Custom breadcrumbs','t','','','a:0:{}',6,'Customize the breadcrumb trail for pages on your site.','',0,'sites/all/modules/custom_breadcrumbs/custom_breadcrumbs.admin.inc'),('admin/structure/custom_breadcrumbs/list','','','user_access','a:1:{i:0;s:29:\"administer custom breadcrumbs\";}','custom_breadcrumbs_page','a:0:{}','',15,4,1,'admin/structure/custom_breadcrumbs','admin/structure/custom_breadcrumbs','List','t','','','a:0:{}',140,'','',0,'sites/all/modules/custom_breadcrumbs/custom_breadcrumbs.admin.inc'),('admin/structure/custom_breadcrumbs/node/add','','','user_access','a:1:{i:0;s:29:\"administer custom breadcrumbs\";}','drupal_get_form','a:2:{i:0;s:23:\"custom_breadcrumbs_form\";i:1;s:4:\"node\";}','',31,5,1,'admin/structure/custom_breadcrumbs','admin/structure/custom_breadcrumbs','Node','t','','','a:0:{}',132,'','',1,'sites/all/modules/custom_breadcrumbs/custom_breadcrumbs.admin.inc'),('admin/structure/custom_breadcrumbs/node/edit','','','user_access','a:1:{i:0;s:29:\"administer custom breadcrumbs\";}','drupal_get_form','a:2:{i:0;s:23:\"custom_breadcrumbs_form\";i:1;s:4:\"node\";}','',31,5,0,'','admin/structure/custom_breadcrumbs/node/edit','Edit custom breadcrumb for nodes','t','','','a:0:{}',0,'','',0,'sites/all/modules/custom_breadcrumbs/custom_breadcrumbs.admin.inc'),('admin/structure/custom_breadcrumbs/path/add','','','user_access','a:1:{i:0;s:29:\"administer custom breadcrumbs\";}','drupal_get_form','a:2:{i:0;s:29:\"custom_breadcrumbs_paths_form\";i:1;s:4:\"path\";}','',31,5,1,'admin/structure/custom_breadcrumbs','admin/structure/custom_breadcrumbs','Path','t','','','a:0:{}',132,'','',5,''),('admin/structure/custom_breadcrumbs/path/edit','','','user_access','a:1:{i:0;s:29:\"administer custom breadcrumbs\";}','drupal_get_form','a:2:{i:0;s:29:\"custom_breadcrumbs_paths_form\";i:1;s:4:\"path\";}','',31,5,0,'','admin/structure/custom_breadcrumbs/path/edit','Edit custom breadcrumb for path','t','','','a:0:{}',0,'','',0,''),('admin/structure/custom_breadcrumbs/taxonomy_term/add','','','user_access','a:1:{i:0;s:29:\"administer custom breadcrumbs\";}','drupal_get_form','a:2:{i:0;s:37:\"custom_breadcrumbs_taxonomy_term_form\";i:1;s:13:\"taxonomy_term\";}','',31,5,1,'admin/structure/custom_breadcrumbs','admin/structure/custom_breadcrumbs','Term','t','','','a:0:{}',132,'','',5,'sites/all/modules/custom_breadcrumbs/custom_breadcrumbs_taxonomy/custom_breadcrumbs_taxonomy.admin.inc'),('admin/structure/custom_breadcrumbs/taxonomy_term/edit','','','user_access','a:1:{i:0;s:29:\"administer custom breadcrumbs\";}','drupal_get_form','a:2:{i:0;s:37:\"custom_breadcrumbs_taxonomy_term_form\";i:1;s:13:\"taxonomy_term\";}','',31,5,0,'','admin/structure/custom_breadcrumbs/taxonomy_term/edit','Edit custom breadcrumb for taxonomy term','t','','','a:0:{}',0,'','',0,'sites/all/modules/custom_breadcrumbs/custom_breadcrumbs_taxonomy/custom_breadcrumbs_taxonomy.admin.inc'),('admin/structure/custom_breadcrumbs/taxonomy_vocabulary/add','','','user_access','a:1:{i:0;s:29:\"administer custom breadcrumbs\";}','drupal_get_form','a:2:{i:0;s:43:\"custom_breadcrumbs_taxonomy_vocabulary_form\";i:1;s:19:\"taxonomy_vocabulary\";}','',31,5,1,'admin/structure/custom_breadcrumbs','admin/structure/custom_breadcrumbs','Vocabulary','t','','','a:0:{}',132,'','',5,'sites/all/modules/custom_breadcrumbs/custom_breadcrumbs_taxonomy/custom_breadcrumbs_taxonomy.admin.inc'),('admin/structure/custom_breadcrumbs/taxonomy_vocabulary/edit','','','user_access','a:1:{i:0;s:29:\"administer custom breadcrumbs\";}','drupal_get_form','a:2:{i:0;s:43:\"custom_breadcrumbs_taxonomy_vocabulary_form\";i:1;s:19:\"taxonomy_vocabulary\";}','',31,5,0,'','admin/structure/custom_breadcrumbs/taxonomy_vocabulary/edit','Edit custom breadcrumb for taxonomy vobaculary','t','','','a:0:{}',0,'','',0,'sites/all/modules/custom_breadcrumbs/custom_breadcrumbs_taxonomy/custom_breadcrumbs_taxonomy.admin.inc'),('admin/structure/custom_breadcrumbs/views/add','','','user_access','a:1:{i:0;s:29:\"administer custom breadcrumbs\";}','drupal_get_form','a:2:{i:0;s:29:\"custom_breadcrumbs_views_form\";i:1;s:5:\"views\";}','',31,5,1,'admin/structure/custom_breadcrumbs','admin/structure/custom_breadcrumbs','Views','t','','','a:0:{}',132,'','',5,''),('admin/structure/custom_breadcrumbs/views/edit','','','user_access','a:1:{i:0;s:29:\"administer custom breadcrumbs\";}','drupal_get_form','a:2:{i:0;s:29:\"custom_breadcrumbs_views_form\";i:1;s:5:\"views\";}','',31,5,0,'','admin/structure/custom_breadcrumbs/views/edit','Edit custom breadcrumb for views','t','','','a:0:{}',0,'','',0,''),('admin/structure/entity-type','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:\"eck administer entity types\";i:1;s:21:\"eck list entity types\";}}','eck__entity_type__list','a:0:{}','',7,3,0,'','admin/structure/entity-type','Entity types','t','','','a:0:{}',6,'A centralized administrative section for entity types','',0,'sites/all/modules/eck/eck.entity_type.inc'),('admin/structure/entity-type/add','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:\"eck administer entity types\";i:1;s:20:\"eck add entity types\";}}','drupal_get_form','a:1:{i:0;s:22:\"eck__entity_type__form\";}','',15,4,1,'admin/structure/entity-type','admin/structure/entity-type','Add entity type','t','','','a:0:{}',388,'Add a new entity type','',-1,'sites/all/modules/eck/eck.entity_type.inc'),('admin/structure/entity-type/commerce_store','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:\"eck administer bundles\";i:1;s:16:\"eck list bundles\";i:2;s:37:\"eck administer commerce_store bundles\";i:3;s:31:\"eck list commerce_store bundles\";}}','eck__bundle__list','a:1:{i:0;i:3;}','',15,4,0,'','admin/structure/entity-type/commerce_store','Commerce Store','t','','','a:0:{}',6,'View all the bundles for \'Commerce Store\'','',0,'sites/all/modules/eck/eck.bundle.inc'),('admin/structure/entity-type/commerce_store/add','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:\"eck administer bundles\";i:1;s:15:\"eck add bundles\";i:2;s:37:\"eck administer commerce_store bundles\";i:3;s:30:\"eck add commerce_store bundles\";}}','drupal_get_form','a:2:{i:0;s:16:\"eck__bundle__add\";i:1;i:3;}','',31,5,1,'admin/structure/entity-type/commerce_store','admin/structure/entity-type/commerce_store','Add bundle ','t','','','a:0:{}',388,'Add a(n) new \'Commerce Store Bundle\'','',0,'sites/all/modules/eck/eck.bundle.inc'),('admin/structure/entity-type/commerce_store/delete','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:\"eck administer entity types\";i:1;s:23:\"eck delete entity types\";}}','drupal_get_form','a:2:{i:0;s:29:\"eck__entity_type__delete_form\";i:1;s:14:\"commerce_store\";}','',31,5,1,'admin/structure/entity-type/commerce_store','admin/structure/entity-type/commerce_store','Delete','t','','','a:0:{}',132,'Delete the \'Commerce Store\' Entity Type','',3,'sites/all/modules/eck/eck.entity_type.inc'),('admin/structure/entity-type/commerce_store/edit','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:\"eck administer entity types\";i:1;s:21:\"eck edit entity types\";}}','drupal_get_form','a:2:{i:0;s:22:\"eck__entity_type__form\";i:1;s:14:\"commerce_store\";}','',31,5,1,'admin/structure/entity-type/commerce_store','admin/structure/entity-type/commerce_store','Edit','t','','','a:0:{}',132,'Edit the \'Commerce Store\' entity type','',2,'sites/all/modules/eck/eck.entity_type.inc'),('admin/structure/entity-type/commerce_store/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:\"eck administer bundles\";i:1;s:16:\"eck list bundles\";i:2;s:37:\"eck administer commerce_store bundles\";i:3;s:31:\"eck list commerce_store bundles\";}}','eck__bundle__list','a:1:{i:0;i:3;}','',31,5,1,'admin/structure/entity-type/commerce_store','admin/structure/entity-type/commerce_store','Bundle List','t','','','a:0:{}',140,'','',100,'sites/all/modules/eck/eck.bundle.inc'),('admin/structure/entity-type/commerce_store/properties','','','eck__multiple_access_check','a:1:{i:0;a:2:{i:0;s:27:\"eck administer entity types\";i:1;s:32:\"manage commerce_store properties\";}}','drupal_get_form','a:2:{i:0;s:21:\"eck__properties__form\";i:1;s:14:\"commerce_store\";}','',31,5,1,'admin/structure/entity-type/commerce_store','admin/structure/entity-type/commerce_store','Manage properties','t','','','a:0:{}',132,'Manage the properties of the Commerce Store entity type','',4,'sites/all/modules/eck/eck.properties.inc'),('admin/structure/entity-type/commerce_store/store','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:\"eck administer entities\";i:1;s:17:\"eck list entities\";i:2;s:44:\"eck administer commerce_store store entities\";i:3;s:38:\"eck list commerce_store store entities\";}}','eck__entity__list','a:2:{i:0;s:14:\"commerce_store\";i:1;s:5:\"store\";}','',31,5,0,'','admin/structure/entity-type/commerce_store/store','Store','t','','','a:0:{}',6,'View all entites of type Commerce Store with bundle Store','',0,'sites/all/modules/eck/eck.entity.inc'),('admin/structure/entity-type/commerce_store/store/%/delete','a:1:{i:5;a:1:{s:14:\"eckentity_load\";a:1:{i:0;s:14:\"commerce_store\";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:\"delete\";i:1;s:14:\"commerce_store\";i:2;s:5:\"store\";i:3;i:5;}','eck__entity__delete','a:3:{i:0;s:14:\"commerce_store\";i:1;s:5:\"store\";i:2;i:5;}','',125,7,0,'','admin/structure/entity-type/commerce_store/store/%/delete','Delete Store','t','','','a:0:{}',6,'Delete an entity of type Commerce Store with bundle Store','',0,'sites/all/modules/eck/eck.entity.inc'),('admin/structure/entity-type/commerce_store/store/%/edit','a:1:{i:5;a:1:{s:14:\"eckentity_load\";a:1:{i:0;s:14:\"commerce_store\";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:\"edit\";i:1;s:14:\"commerce_store\";i:2;s:5:\"store\";i:3;i:5;}','eck__entity__edit','a:3:{i:0;s:14:\"commerce_store\";i:1;s:5:\"store\";i:2;i:5;}','',125,7,0,'','admin/structure/entity-type/commerce_store/store/%/edit','Edit Store','t','','','a:0:{}',6,'Edit an entity of type Commerce Store with bundle Store','',0,'sites/all/modules/eck/eck.entity.inc'),('admin/structure/entity-type/commerce_store/store/add','','','eck__entity_menu_access','a:3:{i:0;s:3:\"add\";i:1;s:14:\"commerce_store\";i:2;s:5:\"store\";}','eck__entity__add','a:2:{i:0;s:14:\"commerce_store\";i:1;s:5:\"store\";}','',63,6,0,'','admin/structure/entity-type/commerce_store/store/add','Add Store','t','','','a:0:{}',6,'Add an entity of type Commerce Store with bundle Store','',0,'sites/all/modules/eck/eck.entity.inc'),('admin/structure/entity-type/commerce_store/store/delete','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:\"eck administer bundles\";i:1;s:18:\"eck delete bundles\";i:2;s:37:\"eck administer commerce_store bundles\";i:3;s:33:\"eck delete commerce_store bundles\";}}','drupal_get_form','a:3:{i:0;s:24:\"eck__bundle__delete_form\";i:1;i:3;i:2;i:4;}','',63,6,1,'admin/structure/entity-type/commerce_store/store','admin/structure/entity-type/commerce_store/store','Delete','t','','','a:0:{}',132,'','',0,'sites/all/modules/eck/eck.bundle.inc'),('admin/structure/entity-type/commerce_store/store/display','','','field_ui_admin_access','a:2:{i:0;s:26:\"eck__multiple_access_check\";i:1;a:1:{i:0;a:4:{i:0;s:22:\"eck administer bundles\";i:1;s:16:\"eck edit bundles\";i:2;s:37:\"eck administer commerce_store bundles\";i:3;s:31:\"eck edit commerce_store bundles\";}}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:14:\"commerce_store\";i:2;s:5:\"store\";i:3;s:7:\"default\";}','',63,6,1,'admin/structure/entity-type/commerce_store/store','admin/structure/entity-type/commerce_store/store','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/commerce_store/store/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:14:\"commerce_store\";i:1;s:5:\"store\";i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:26:\"eck__multiple_access_check\";i:5;a:1:{i:0;a:4:{i:0;s:22:\"eck administer bundles\";i:1;s:16:\"eck edit bundles\";i:2;s:37:\"eck administer commerce_store bundles\";i:3;s:31:\"eck edit commerce_store bundles\";}}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:14:\"commerce_store\";i:2;s:5:\"store\";i:3;s:7:\"default\";}','',127,7,1,'admin/structure/entity-type/commerce_store/store/display','admin/structure/entity-type/commerce_store/store','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/commerce_store/store/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:14:\"commerce_store\";i:1;s:5:\"store\";i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:26:\"eck__multiple_access_check\";i:5;a:1:{i:0;a:4:{i:0;s:22:\"eck administer bundles\";i:1;s:16:\"eck edit bundles\";i:2;s:37:\"eck administer commerce_store bundles\";i:3;s:31:\"eck edit commerce_store bundles\";}}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:14:\"commerce_store\";i:2;s:5:\"store\";i:3;s:4:\"full\";}','',127,7,1,'admin/structure/entity-type/commerce_store/store/display','admin/structure/entity-type/commerce_store/store','Full','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/commerce_store/store/display/teaser','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:14:\"commerce_store\";i:1;s:5:\"store\";i:2;s:6:\"teaser\";i:3;s:21:\"field_ui_admin_access\";i:4;s:26:\"eck__multiple_access_check\";i:5;a:1:{i:0;a:4:{i:0;s:22:\"eck administer bundles\";i:1;s:16:\"eck edit bundles\";i:2;s:37:\"eck administer commerce_store bundles\";i:3;s:31:\"eck edit commerce_store bundles\";}}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:14:\"commerce_store\";i:2;s:5:\"store\";i:3;s:6:\"teaser\";}','',127,7,1,'admin/structure/entity-type/commerce_store/store/display','admin/structure/entity-type/commerce_store/store','Teaser','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/commerce_store/store/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:14:\"commerce_store\";i:1;s:5:\"store\";i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:26:\"eck__multiple_access_check\";i:5;a:1:{i:0;a:4:{i:0;s:22:\"eck administer bundles\";i:1;s:16:\"eck edit bundles\";i:2;s:37:\"eck administer commerce_store bundles\";i:3;s:31:\"eck edit commerce_store bundles\";}}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:14:\"commerce_store\";i:2;s:5:\"store\";i:3;s:5:\"token\";}','',127,7,1,'admin/structure/entity-type/commerce_store/store/display','admin/structure/entity-type/commerce_store/store','Tokens','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/commerce_store/store/edit','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:\"eck administer bundles\";i:1;s:16:\"eck edit bundles\";i:2;s:37:\"eck administer commerce_store bundles\";i:3;s:31:\"eck edit commerce_store bundles\";}}','drupal_get_form','a:3:{i:0;s:22:\"eck__bundle__edit_form\";i:1;s:14:\"commerce_store\";i:2;s:5:\"store\";}','',63,6,1,'admin/structure/entity-type/commerce_store/store','admin/structure/entity-type/commerce_store/store','Edit','t','','','a:0:{}',132,'','',0,'sites/all/modules/eck/eck.bundle.inc'),('admin/structure/entity-type/commerce_store/store/fields','','','field_ui_admin_access','a:2:{i:0;s:26:\"eck__multiple_access_check\";i:1;a:1:{i:0;a:4:{i:0;s:22:\"eck administer bundles\";i:1;s:16:\"eck edit bundles\";i:2;s:37:\"eck administer commerce_store bundles\";i:3;s:31:\"eck edit commerce_store bundles\";}}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:14:\"commerce_store\";i:2;s:5:\"store\";}','',63,6,1,'admin/structure/entity-type/commerce_store/store','admin/structure/entity-type/commerce_store/store','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/commerce_store/store/fields/%','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:14:\"commerce_store\";i:1;s:5:\"store\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:26:\"eck__multiple_access_check\";i:1;a:1:{i:0;a:4:{i:0;s:22:\"eck administer bundles\";i:1;s:16:\"eck edit bundles\";i:2;s:37:\"eck administer commerce_store bundles\";i:3;s:31:\"eck edit commerce_store bundles\";}}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}','',126,7,0,'','admin/structure/entity-type/commerce_store/store/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/commerce_store/store/fields/%/delete','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:14:\"commerce_store\";i:1;s:5:\"store\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:26:\"eck__multiple_access_check\";i:1;a:1:{i:0;a:4:{i:0;s:22:\"eck administer bundles\";i:1;s:16:\"eck edit bundles\";i:2;s:37:\"eck administer commerce_store bundles\";i:3;s:31:\"eck edit commerce_store bundles\";}}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:6;}','',253,8,1,'admin/structure/entity-type/commerce_store/store/fields/%','admin/structure/entity-type/commerce_store/store/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/commerce_store/store/fields/%/edit','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:14:\"commerce_store\";i:1;s:5:\"store\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:26:\"eck__multiple_access_check\";i:1;a:1:{i:0;a:4:{i:0;s:22:\"eck administer bundles\";i:1;s:16:\"eck edit bundles\";i:2;s:37:\"eck administer commerce_store bundles\";i:3;s:31:\"eck edit commerce_store bundles\";}}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}','',253,8,1,'admin/structure/entity-type/commerce_store/store/fields/%','admin/structure/entity-type/commerce_store/store/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/commerce_store/store/fields/%/field-settings','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:14:\"commerce_store\";i:1;s:5:\"store\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:26:\"eck__multiple_access_check\";i:1;a:1:{i:0;a:4:{i:0;s:22:\"eck administer bundles\";i:1;s:16:\"eck edit bundles\";i:2;s:37:\"eck administer commerce_store bundles\";i:3;s:31:\"eck edit commerce_store bundles\";}}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:6;}','',253,8,1,'admin/structure/entity-type/commerce_store/store/fields/%','admin/structure/entity-type/commerce_store/store/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/commerce_store/store/fields/%/widget-type','a:1:{i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:14:\"commerce_store\";i:1;s:5:\"store\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:26:\"eck__multiple_access_check\";i:1;a:1:{i:0;a:4:{i:0;s:22:\"eck administer bundles\";i:1;s:16:\"eck edit bundles\";i:2;s:37:\"eck administer commerce_store bundles\";i:3;s:31:\"eck edit commerce_store bundles\";}}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:6;}','',253,8,1,'admin/structure/entity-type/commerce_store/store/fields/%','admin/structure/entity-type/commerce_store/store/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/entity-type/commerce_store/store/groups/%/delete','a:1:{i:6;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:14:\"commerce_store\";i:1;s:5:\"store\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:\"eck administer bundles\";i:1;s:16:\"eck edit bundles\";i:2;s:37:\"eck administer commerce_store bundles\";i:3;s:31:\"eck edit commerce_store bundles\";}}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:6;}','',253,8,0,'','admin/structure/entity-type/commerce_store/store/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/commerce_store/store/groups/%/enable','a:1:{i:6;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:14:\"commerce_store\";i:1;s:5:\"store\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:22:\"eck administer bundles\";i:1;s:16:\"eck edit bundles\";i:2;s:37:\"eck administer commerce_store bundles\";i:3;s:31:\"eck edit commerce_store bundles\";}}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:6;}','',253,8,0,'','admin/structure/entity-type/commerce_store/store/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/structure/entity-type/commerce_store/store/list','','','eck__multiple_access_check','a:1:{i:0;a:4:{i:0;s:23:\"eck administer entities\";i:1;s:17:\"eck list entities\";i:2;s:44:\"eck administer commerce_store store entities\";i:3;s:38:\"eck list commerce_store store entities\";}}','eck__entity__list','a:2:{i:0;s:14:\"commerce_store\";i:1;s:5:\"store\";}','',63,6,1,'admin/structure/entity-type/commerce_store/store','admin/structure/entity-type/commerce_store/store','Entity List','t','','','a:0:{}',140,'','',100,'sites/all/modules/eck/eck.entity.inc'),('admin/structure/features','','','user_access','a:1:{i:0;s:15:\"manage features\";}','drupal_get_form','a:1:{i:0;s:19:\"features_admin_form\";}','',7,3,0,'','admin/structure/features','Features','t','','','a:0:{}',6,'Manage features.','',0,'sites/all/modules/features/features.admin.inc'),('admin/structure/features/%','a:1:{i:3;a:1:{s:12:\"feature_load\";a:1:{i:0;b:1;}}}','','user_access','a:1:{i:0;s:19:\"administer features\";}','drupal_get_form','a:2:{i:0;s:25:\"features_admin_components\";i:1;i:3;}','',14,4,0,'','admin/structure/features/%','','features_get_feature_title','a:1:{i:0;i:3;}','','a:0:{}',0,'Display components of a feature.','',0,'sites/all/modules/features/features.admin.inc'),('admin/structure/features/%/lock','a:1:{i:3;a:1:{s:12:\"feature_load\";a:1:{i:0;b:1;}}}','','user_access','a:1:{i:0;s:15:\"manage features\";}','features_admin_lock','a:3:{i:0;i:3;i:1;i:5;i:2;i:6;}','',29,5,0,'','admin/structure/features/%/lock','Lock','t','','','a:0:{}',0,'Lock a feature or components.','',0,'sites/all/modules/features/features.admin.inc'),('admin/structure/features/%/recreate','a:1:{i:3;a:1:{s:12:\"feature_load\";a:1:{i:0;b:1;}}}','','user_access','a:1:{i:0;s:19:\"administer features\";}','drupal_get_form','a:2:{i:0;s:20:\"features_export_form\";i:1;i:3;}','',29,5,1,'admin/structure/features/%','admin/structure/features/%','Recreate','t','','','a:0:{}',132,'Recreate an existing feature.','',11,'sites/all/modules/features/features.admin.inc'),('admin/structure/features/%/status','a:1:{i:3;a:1:{s:12:\"feature_load\";a:1:{i:0;b:1;}}}','','user_access','a:1:{i:0;s:19:\"administer features\";}','features_feature_status','a:1:{i:0;i:3;}','',29,5,0,'','admin/structure/features/%/status','Status','t','','','a:0:{}',0,'Javascript status call back.','',0,'sites/all/modules/features/features.admin.inc'),('admin/structure/features/%/view','a:1:{i:3;a:1:{s:12:\"feature_load\";a:1:{i:0;b:1;}}}','','user_access','a:1:{i:0;s:19:\"administer features\";}','drupal_get_form','a:2:{i:0;s:25:\"features_admin_components\";i:1;i:3;}','',29,5,1,'admin/structure/features/%','admin/structure/features/%','View','t','','','a:0:{}',140,'Display components of a feature.','',-10,'sites/all/modules/features/features.admin.inc'),('admin/structure/features/cleanup','','','user_access','a:1:{i:0;s:15:\"manage features\";}','features_cleanup','a:0:{}','',15,4,0,'','admin/structure/features/cleanup','Cleanup','t','','','a:0:{}',0,'Clear cache after enabling/disabling a feature.','',1,'sites/all/modules/features/features.admin.inc'),('admin/structure/features/create','','','user_access','a:1:{i:0;s:19:\"administer features\";}','drupal_get_form','a:1:{i:0;s:20:\"features_export_form\";}','',15,4,1,'admin/structure/features','admin/structure/features','Create feature','t','','','a:0:{}',132,'Create a new feature.','',10,'sites/all/modules/features/features.admin.inc'),('admin/structure/features/manage','','','user_access','a:1:{i:0;s:15:\"manage features\";}','drupal_get_form','a:1:{i:0;s:19:\"features_admin_form\";}','',15,4,1,'admin/structure/features','admin/structure/features','Manage','t','','','a:0:{}',140,'Enable and disable features.','',0,'sites/all/modules/features/features.admin.inc'),('admin/structure/features/settings','','','user_access','a:1:{i:0;s:19:\"administer features\";}','drupal_get_form','a:1:{i:0;s:22:\"features_settings_form\";}','',15,4,1,'admin/structure/features','admin/structure/features','Settings','t','','','a:0:{}',132,'Adjust settings for using features module.','',11,'sites/all/modules/features/features.admin.inc'),('admin/structure/field-collections','','','user_access','a:1:{i:0;s:28:\"administer field collections\";}','field_collections_overview','a:0:{}','',7,3,0,'','admin/structure/field-collections','Field collections','t','','','a:0:{}',6,'Manage fields on field collections.','',0,'sites/all/modules/field_collection/field_collection.admin.inc'),('admin/structure/field-collections/%','a:1:{i:3;s:32:\"field_collection_field_name_load\";}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:28:\"administer field collections\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:21:\"field_collection_item\";i:2;i:3;}','',14,4,0,'','admin/structure/field-collections/%','Manage fields','field_collection_admin_page_title','a:1:{i:0;i:3;}','','a:0:{}',6,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/display','a:1:{i:3;s:32:\"field_collection_field_name_load\";}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:28:\"administer field collections\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"field_collection_item\";i:2;i:3;i:3;s:7:\"default\";}','',29,5,1,'admin/structure/field-collections/%','admin/structure/field-collections/%','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/display/default','a:1:{i:3;s:32:\"field_collection_field_name_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:28:\"administer field collections\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"field_collection_item\";i:2;i:3;i:3;s:7:\"default\";}','',59,6,1,'admin/structure/field-collections/%/display','admin/structure/field-collections/%','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/display/full','a:1:{i:3;s:32:\"field_collection_field_name_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:28:\"administer field collections\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"field_collection_item\";i:2;i:3;i:3;s:4:\"full\";}','',59,6,1,'admin/structure/field-collections/%/display','admin/structure/field-collections/%','Full content','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/display/token','a:1:{i:3;s:32:\"field_collection_field_name_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:28:\"administer field collections\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"field_collection_item\";i:2;i:3;i:3;s:5:\"token\";}','',59,6,1,'admin/structure/field-collections/%/display','admin/structure/field-collections/%','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/fields','a:1:{i:3;s:32:\"field_collection_field_name_load\";}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:28:\"administer field collections\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:21:\"field_collection_item\";i:2;i:3;}','',29,5,1,'admin/structure/field-collections/%','admin/structure/field-collections/%','Manage fields','t','','','a:0:{}',140,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/fields/%','a:2:{i:3;a:1:{s:32:\"field_collection_field_name_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:28:\"administer field collections\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',58,6,0,'','admin/structure/field-collections/%/fields/%','','field_ui_menu_title','a:1:{i:0;i:5;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/fields/%/delete','a:2:{i:3;a:1:{s:32:\"field_collection_field_name_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:28:\"administer field collections\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:5;}','',117,7,1,'admin/structure/field-collections/%/fields/%','admin/structure/field-collections/%/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/fields/%/edit','a:2:{i:3;a:1:{s:32:\"field_collection_field_name_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:28:\"administer field collections\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',117,7,1,'admin/structure/field-collections/%/fields/%','admin/structure/field-collections/%/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/fields/%/field-settings','a:2:{i:3;a:1:{s:32:\"field_collection_field_name_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:28:\"administer field collections\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:5;}','',117,7,1,'admin/structure/field-collections/%/fields/%','admin/structure/field-collections/%/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/fields/%/widget-type','a:2:{i:3;a:1:{s:32:\"field_collection_field_name_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:28:\"administer field collections\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:5;}','',117,7,1,'admin/structure/field-collections/%/fields/%','admin/structure/field-collections/%/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/groups/%/delete','a:2:{i:3;a:1:{s:32:\"field_collection_field_name_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:28:\"administer field collections\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:5;}','',117,7,0,'','admin/structure/field-collections/%/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/structure/field-collections/%/groups/%/enable','a:2:{i:3;a:1:{s:32:\"field_collection_field_name_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:28:\"administer field collections\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:5;}','',117,7,0,'','admin/structure/field-collections/%/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/structure/menu','','','user_access','a:1:{i:0;s:15:\"administer menu\";}','menu_overview_page','a:0:{}','',7,3,0,'','admin/structure/menu','Menus','t','','','a:0:{}',6,'Add new menus to your site, edit existing menus, and rename and reorganize menu links.','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/add','','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:2:{i:0;s:14:\"menu_edit_menu\";i:1;s:3:\"add\";}','',15,4,1,'admin/structure/menu','admin/structure/menu','Add menu','t','','','a:0:{}',388,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/item/%/delete','a:1:{i:4;s:14:\"menu_link_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','menu_item_delete_page','a:1:{i:0;i:4;}','',61,6,0,'','admin/structure/menu/item/%/delete','Delete menu link','t','','','a:0:{}',6,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/item/%/edit','a:1:{i:4;s:14:\"menu_link_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:4:{i:0;s:14:\"menu_edit_item\";i:1;s:4:\"edit\";i:2;i:4;i:3;N;}','',61,6,0,'','admin/structure/menu/item/%/edit','Edit menu link','t','','','a:0:{}',6,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/item/%/reset','a:1:{i:4;s:14:\"menu_link_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:2:{i:0;s:23:\"menu_reset_item_confirm\";i:1;i:4;}','',61,6,0,'','admin/structure/menu/item/%/reset','Reset menu link','t','','','a:0:{}',6,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/list','','','user_access','a:1:{i:0;s:15:\"administer menu\";}','menu_overview_page','a:0:{}','',15,4,1,'admin/structure/menu','admin/structure/menu','List menus','t','','','a:0:{}',140,'','',-10,'modules/menu/menu.admin.inc'),('admin/structure/menu/manage/%','a:1:{i:4;s:9:\"menu_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}','',30,5,0,'','admin/structure/menu/manage/%','Customize menu','menu_overview_title','a:1:{i:0;i:4;}','','a:0:{}',6,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/manage/%/add','a:1:{i:4;s:9:\"menu_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:4:{i:0;s:14:\"menu_edit_item\";i:1;s:3:\"add\";i:2;N;i:3;i:4;}','',61,6,1,'admin/structure/menu/manage/%','admin/structure/menu/manage/%','Add link','t','','','a:0:{}',388,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/manage/%/delete','a:1:{i:4;s:9:\"menu_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','menu_delete_menu_page','a:1:{i:0;i:4;}','',61,6,0,'','admin/structure/menu/manage/%/delete','Delete menu','t','','','a:0:{}',6,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/manage/%/edit','a:1:{i:4;s:9:\"menu_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:3:{i:0;s:14:\"menu_edit_menu\";i:1;s:4:\"edit\";i:2;i:4;}','',61,6,3,'admin/structure/menu/manage/%','admin/structure/menu/manage/%','Edit menu','t','','','a:0:{}',132,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/manage/%/list','a:1:{i:4;s:9:\"menu_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}','',61,6,3,'admin/structure/menu/manage/%','admin/structure/menu/manage/%','List links','t','','','a:0:{}',140,'','',-10,'modules/menu/menu.admin.inc'),('admin/structure/menu/parents','','','user_access','a:1:{i:0;s:15:\"administer menu\";}','menu_parent_options_js','a:0:{}','',15,4,0,'','admin/structure/menu/parents','Parent menu items','t','','','a:0:{}',0,'','',0,''),('admin/structure/menu/settings','','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:1:{i:0;s:14:\"menu_configure\";}','',15,4,1,'admin/structure/menu','admin/structure/menu','Settings','t','','','a:0:{}',132,'','',5,'modules/menu/menu.admin.inc'),('admin/structure/migrate_content','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:31:\"we_content_migration_admin_form\";}','',7,3,0,'','admin/structure/migrate_content','Migrate Content','t','','','a:0:{}',6,'Manage Migrate Content.','',0,'sites/all/modules/we_content_migration/we_content_migration.admin.inc'),('admin/structure/migrate_content/create','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:32:\"we_content_migration_export_form\";}','',15,4,1,'admin/structure/migrate_content','admin/structure/migrate_content','Create','t','','','a:0:{}',132,'Migrate Content Create.','',10,'sites/all/modules/we_content_migration/we_content_migration.admin.inc'),('admin/structure/migrate_content/import-from-upload','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:44:\"we_content_migration_import_from_upload_form\";}','',15,4,1,'admin/structure/migrate_content','admin/structure/migrate_content','Import','t','','','a:0:{}',132,'Upload zip file to import.','',11,'sites/all/modules/we_content_migration/we_content_migration.admin.inc'),('admin/structure/migrate_content/manage','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:31:\"we_content_migration_admin_form\";}','',15,4,1,'admin/structure/migrate_content','admin/structure/migrate_content','Manage','t','','','a:0:{}',140,'Enable and disable entity bundle.','',0,'sites/all/modules/we_content_migration/we_content_migration.admin.inc'),('admin/structure/migrate_content/settings','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:34:\"we_content_migration_settings_form\";}','',15,4,1,'admin/structure/migrate_content','admin/structure/migrate_content','Settings','t','','','a:0:{}',132,'Adjust settings for using migrate content module.','',11,'sites/all/modules/we_content_migration/we_content_migration.admin.inc'),('admin/structure/taxonomy','','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:1:{i:0;s:30:\"taxonomy_overview_vocabularies\";}','',7,3,0,'','admin/structure/taxonomy','Taxonomy','t','','','a:0:{}',6,'Manage tagging, categorization, and classification of your content.','',0,'modules/taxonomy/taxonomy.admin.inc'),('admin/structure/taxonomy/%','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:23:\"taxonomy_overview_terms\";i:1;i:3;}','',14,4,0,'','admin/structure/taxonomy/%','','entity_label','a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;i:3;}','','a:0:{}',6,'','',0,'modules/taxonomy/taxonomy.admin.inc'),('admin/structure/taxonomy/%/add','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:3:{i:0;s:18:\"taxonomy_form_term\";i:1;a:0:{}i:2;i:3;}','',29,5,1,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','Add term','t','','','a:0:{}',388,'','',0,'modules/taxonomy/taxonomy.admin.inc'),('admin/structure/taxonomy/%/display','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:19:\"administer taxonomy\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:7:\"default\";}','',29,5,1,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/display/add_to_cart_form','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:16:\"add_to_cart_form\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:19:\"administer taxonomy\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:16:\"add_to_cart_form\";}','',59,6,1,'admin/structure/taxonomy/%/display','admin/structure/taxonomy/%','Add to Cart form - Attribute','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/display/default','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:19:\"administer taxonomy\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:7:\"default\";}','',59,6,1,'admin/structure/taxonomy/%/display','admin/structure/taxonomy/%','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/display/full','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:19:\"administer taxonomy\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:4:\"full\";}','',59,6,1,'admin/structure/taxonomy/%/display','admin/structure/taxonomy/%','Taxonomy term page','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/display/token','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:19:\"administer taxonomy\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:5:\"token\";}','',59,6,1,'admin/structure/taxonomy/%/display','admin/structure/taxonomy/%','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/edit','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:24:\"taxonomy_form_vocabulary\";i:1;i:3;}','',29,5,1,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','Edit','t','','','a:0:{}',132,'','',-10,'modules/taxonomy/taxonomy.admin.inc'),('admin/structure/taxonomy/%/fields','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:19:\"administer taxonomy\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;}','',29,5,1,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/fields/%','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:19:\"administer taxonomy\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',58,6,0,'','admin/structure/taxonomy/%/fields/%','','field_ui_menu_title','a:1:{i:0;i:5;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/fields/%/delete','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:19:\"administer taxonomy\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:5;}','',117,7,1,'admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/fields/%/edit','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:19:\"administer taxonomy\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',117,7,1,'admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/fields/%/field-settings','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:19:\"administer taxonomy\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:5;}','',117,7,1,'admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/fields/%/widget-type','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:19:\"administer taxonomy\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:5;}','',117,7,1,'admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/fields/replace/%','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:0:{}}i:6;N;}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:4:{i:0;s:28:\"title_field_replacement_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;i:6;}','',118,7,0,'','admin/structure/taxonomy/%/fields/replace/%','Replace fields','t','','','a:0:{}',6,'','',0,'sites/all/modules/title/title.admin.inc'),('admin/structure/taxonomy/%/groups/%/delete','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:5;}','',117,7,0,'','admin/structure/taxonomy/%/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/structure/taxonomy/%/groups/%/enable','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:5;}','',117,7,0,'','admin/structure/taxonomy/%/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/structure/taxonomy/%/list','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:23:\"taxonomy_overview_terms\";i:1;i:3;}','',29,5,1,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','List','t','','','a:0:{}',140,'','',-20,'modules/taxonomy/taxonomy.admin.inc'),('admin/structure/taxonomy/add','','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:1:{i:0;s:24:\"taxonomy_form_vocabulary\";}','',15,4,1,'admin/structure/taxonomy','admin/structure/taxonomy','Add vocabulary','t','','','a:0:{}',388,'','',0,'modules/taxonomy/taxonomy.admin.inc'),('admin/structure/taxonomy/list','','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:1:{i:0;s:30:\"taxonomy_overview_vocabularies\";}','',15,4,1,'admin/structure/taxonomy','admin/structure/taxonomy','List','t','','','a:0:{}',140,'','',-10,'modules/taxonomy/taxonomy.admin.inc'),('admin/structure/tb-megamenu','','','user_access','a:1:{i:0;s:22:\"administer tb_megamenu\";}','drupal_get_form','a:1:{i:0;s:26:\"tb_megamenu_admin_settings\";}','',7,3,0,'','admin/structure/tb-megamenu','TB Mega Menu','t','','','a:0:{}',6,'TB Mega Menu','',0,'sites/all/modules/tb_megamenu/tb_megamenu.admin.inc'),('admin/structure/tb-megamenu/%','a:1:{i:3;s:26:\"tb_megamenu_menu_name_load\";}','','user_access','a:1:{i:0;s:22:\"administer tb_megamenu\";}','drupal_get_form','a:2:{i:0;s:26:\"tb_megamenu_configure_form\";i:1;i:3;}','',14,4,0,'','admin/structure/tb-megamenu/%','Config TB Mega Menu','t','','','a:0:{}',0,'Config TB Mega Menu','',0,'sites/all/modules/tb_megamenu/tb_megamenu.admin.inc'),('admin/structure/tb-megamenu/%/config','a:1:{i:3;s:26:\"tb_megamenu_menu_name_load\";}','','user_access','a:1:{i:0;s:22:\"administer tb_megamenu\";}','drupal_get_form','a:2:{i:0;s:26:\"tb_megamenu_configure_form\";i:1;i:3;}','',29,5,3,'admin/structure/tb-megamenu/%','admin/structure/tb-megamenu/%','Config TB Mega Menu','t','','','a:0:{}',140,'','',-10,'sites/all/modules/tb_megamenu/tb_megamenu.admin.inc'),('admin/structure/tb-megamenu/request','','','user_access','a:1:{i:0;s:22:\"administer tb_megamenu\";}','tb_megamenu_request','a:0:{}','',15,4,0,'','admin/structure/tb-megamenu/request','Request','t','','','a:0:{}',20,'','',0,'sites/all/modules/tb_megamenu/tb_megamenu.ajax.inc'),('admin/structure/types','','','user_access','a:1:{i:0;s:24:\"administer content types\";}','node_overview_types','a:0:{}','',7,3,0,'','admin/structure/types','Content types','t','','','a:0:{}',6,'Manage content types, including default status, front page promotion, comment settings, etc.','',0,'modules/node/content_types.inc'),('admin/structure/types/add','','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:1:{i:0;s:14:\"node_type_form\";}','',15,4,1,'admin/structure/types','admin/structure/types','Add content type','t','','','a:0:{}',388,'','',0,'modules/node/content_types.inc'),('admin/structure/types/list','','','user_access','a:1:{i:0;s:24:\"administer content types\";}','node_overview_types','a:0:{}','',15,4,1,'admin/structure/types','admin/structure/types','List','t','','','a:0:{}',140,'','',-10,'modules/node/content_types.inc'),('admin/structure/types/manage/%','a:1:{i:4;s:14:\"node_type_load\";}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:14:\"node_type_form\";i:1;i:4;}','',30,5,0,'','admin/structure/types/manage/%','Edit content type','node_type_page_title','a:1:{i:0;i:4;}','','a:0:{}',6,'','',0,'modules/node/content_types.inc'),('admin/structure/types/manage/%/comment/display','a:1:{i:4;s:22:\"comment_node_type_load\";}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;s:7:\"default\";}','',123,7,1,'admin/structure/types/manage/%','admin/structure/types/manage/%','Comment display','t','','','a:0:{}',132,'','',4,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/display/default','a:1:{i:4;s:22:\"comment_node_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;s:7:\"default\";}','',247,8,1,'admin/structure/types/manage/%/comment/display','admin/structure/types/manage/%','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/display/full','a:1:{i:4;s:22:\"comment_node_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;s:4:\"full\";}','',247,8,1,'admin/structure/types/manage/%/comment/display','admin/structure/types/manage/%','Full comment','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/display/token','a:1:{i:4;s:22:\"comment_node_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;s:5:\"token\";}','',247,8,1,'admin/structure/types/manage/%/comment/display','admin/structure/types/manage/%','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields','a:1:{i:4;s:22:\"comment_node_type_load\";}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:7:\"comment\";i:2;i:4;}','',123,7,1,'admin/structure/types/manage/%','admin/structure/types/manage/%','Comment fields','t','','','a:0:{}',132,'','',3,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields/%','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}','',246,8,0,'','admin/structure/types/manage/%/comment/fields/%','','field_ui_menu_title','a:1:{i:0;i:7;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields/%/delete','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:7;}','',493,9,1,'admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields/%/edit','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}','',493,9,1,'admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields/%/field-settings','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:7;}','',493,9,1,'admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields/%/widget-type','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:7;}','',493,9,1,'admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields/replace/%','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:0:{}}i:8;N;}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:28:\"title_field_replacement_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;i:8;}','',494,9,0,'','admin/structure/types/manage/%/comment/fields/replace/%','Replace fields','t','','','a:0:{}',6,'','',0,'sites/all/modules/title/title.admin.inc'),('admin/structure/types/manage/%/comment/groups/%/delete','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:7;}','',493,9,0,'','admin/structure/types/manage/%/comment/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/structure/types/manage/%/comment/groups/%/enable','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:7;}','',493,9,0,'','admin/structure/types/manage/%/comment/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/structure/types/manage/%/delete','a:1:{i:4;s:14:\"node_type_load\";}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:24:\"node_type_delete_confirm\";i:1;i:4;}','',61,6,0,'','admin/structure/types/manage/%/delete','Delete','t','','','a:0:{}',6,'','',0,'modules/node/content_types.inc'),('admin/structure/types/manage/%/display','a:1:{i:4;s:14:\"node_type_load\";}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:7:\"default\";}','',61,6,1,'admin/structure/types/manage/%','admin/structure/types/manage/%','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/default','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:7:\"default\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/email_html','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:10:\"email_html\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:10:\"email_html\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Email: HTML','t','','','a:0:{}',132,'','',6,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/email_plain','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:11:\"email_plain\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:11:\"email_plain\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Email: Plain','t','','','a:0:{}',132,'','',5,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/email_textalt','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:13:\"email_textalt\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:13:\"email_textalt\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Email: HTML text alternative','t','','','a:0:{}',132,'','',7,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/full','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:4:\"full\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Full content','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/rss','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:3:\"rss\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:3:\"rss\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','RSS','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/search_index','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:12:\"search_index\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:12:\"search_index\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Search index','t','','','a:0:{}',132,'','',3,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/search_result','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:13:\"search_result\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:13:\"search_result\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Search result highlighting input','t','','','a:0:{}',132,'','',4,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/teaser','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:6:\"teaser\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:6:\"teaser\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Teaser','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/token','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:5:\"token\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Tokens','t','','','a:0:{}',132,'','',8,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/edit','a:1:{i:4;s:14:\"node_type_load\";}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:14:\"node_type_form\";i:1;i:4;}','',61,6,1,'admin/structure/types/manage/%','admin/structure/types/manage/%','Edit','t','','','a:0:{}',140,'','',0,'modules/node/content_types.inc'),('admin/structure/types/manage/%/fields','a:1:{i:4;s:14:\"node_type_load\";}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:4:\"node\";i:2;i:4;}','',61,6,1,'admin/structure/types/manage/%','admin/structure/types/manage/%','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/fields/%','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}','',122,7,0,'','admin/structure/types/manage/%/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/fields/%/delete','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:6;}','',245,8,1,'admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/fields/%/edit','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}','',245,8,1,'admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/fields/%/field-settings','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:6;}','',245,8,1,'admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/fields/%/widget-type','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:6;}','',245,8,1,'admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/fields/replace/%','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:0:{}}i:7;N;}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:28:\"title_field_replacement_form\";i:1;s:4:\"node\";i:2;i:4;i:3;i:7;}','',246,8,0,'','admin/structure/types/manage/%/fields/replace/%','Replace fields','t','','','a:0:{}',6,'','',0,'sites/all/modules/title/title.admin.inc'),('admin/structure/types/manage/%/groups/%/delete','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:6;}','',245,8,0,'','admin/structure/types/manage/%/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/structure/types/manage/%/groups/%/enable','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:6;}','',245,8,0,'','admin/structure/types/manage/%/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/structure/views','','','ctools_export_ui_task_access','a:2:{i:0;s:8:\"views_ui\";i:1;s:4:\"list\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:8:\"views_ui\";i:1;s:4:\"list\";}','',7,3,0,'','admin/structure/views','Views','t','','','a:0:{}',6,'Manage customized lists of content.','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/views/add','','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_add_page','a:0:{}','',15,4,1,'admin/structure/views','admin/structure/views','Add new view','t','','','a:0:{}',388,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/add-template','','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_add_template_page','a:0:{}','',15,4,1,'admin/structure/views','admin/structure/views','Add view from template','t','','','a:0:{}',388,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/ajax/%/%','a:2:{i:4;N;i:5;s:19:\"views_ui_cache_load\";}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_ajax_form','a:3:{i:0;b:1;i:1;i:4;i:2;i:5;}','ajax_deliver',60,6,0,'','admin/structure/views/ajax/%/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/ajax/preview/%/%','a:2:{i:5;s:19:\"views_ui_cache_load\";i:6;N;}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_preview','a:2:{i:0;i:5;i:1;i:6;}','ajax_deliver',124,7,0,'','admin/structure/views/ajax/preview/%/%','','t','','','a:0:{}',6,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/import','','','views_import_access','a:1:{i:0;s:16:\"administer views\";}','drupal_get_form','a:1:{i:0;s:20:\"views_ui_import_page\";}','',15,4,1,'admin/structure/views','admin/structure/views','Import','t','','','a:0:{}',388,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/list','','','ctools_export_ui_task_access','a:2:{i:0;s:8:\"views_ui\";i:1;s:4:\"list\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:8:\"views_ui\";i:1;s:4:\"list\";}','',15,4,1,'admin/structure/views','admin/structure/views','List','t','','','a:0:{}',140,'','',-10,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/views/nojs/%/%','a:2:{i:4;N;i:5;s:19:\"views_ui_cache_load\";}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_ajax_form','a:3:{i:0;b:0;i:1;i:4;i:2;i:5;}','',60,6,0,'','admin/structure/views/nojs/%/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/nojs/preview/%/%','a:2:{i:5;s:19:\"views_ui_cache_load\";i:6;N;}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_preview','a:2:{i:0;i:5;i:1;i:6;}','',124,7,0,'','admin/structure/views/nojs/preview/%/%','','t','','','a:0:{}',6,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/settings','','','user_access','a:1:{i:0;s:16:\"administer views\";}','drupal_get_form','a:1:{i:0;s:29:\"views_ui_admin_settings_basic\";}','',15,4,1,'admin/structure/views','admin/structure/views','Settings','t','','','a:0:{}',132,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/settings/advanced','','','user_access','a:1:{i:0;s:16:\"administer views\";}','drupal_get_form','a:1:{i:0;s:32:\"views_ui_admin_settings_advanced\";}','',31,5,1,'admin/structure/views/settings','admin/structure/views','Advanced','t','','','a:0:{}',132,'','',1,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/settings/basic','','','user_access','a:1:{i:0;s:16:\"administer views\";}','drupal_get_form','a:1:{i:0;s:29:\"views_ui_admin_settings_basic\";}','',31,5,1,'admin/structure/views/settings','admin/structure/views','Basic','t','','','a:0:{}',140,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/template/%/add','a:1:{i:4;N;}','','ctools_export_ui_task_access','a:3:{i:0;s:8:\"views_ui\";i:1;s:12:\"add_template\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:\"views_ui\";i:1;s:12:\"add_template\";i:2;i:4;}','',61,6,0,'','admin/structure/views/template/%/add','Add from template','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/views/view/%','a:1:{i:4;s:19:\"views_ui_cache_load\";}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_edit_page','a:1:{i:0;i:4;}','',30,5,0,'','admin/structure/views/view/%','','views_ui_edit_page_title','a:1:{i:0;i:4;}','','a:0:{}',6,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/view/%/break-lock','a:1:{i:4;s:19:\"views_ui_cache_load\";}','','user_access','a:1:{i:0;s:16:\"administer views\";}','drupal_get_form','a:2:{i:0;s:27:\"views_ui_break_lock_confirm\";i:1;i:4;}','',61,6,0,'','admin/structure/views/view/%/break-lock','Break lock','t','','','a:0:{}',4,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/view/%/clone','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:8:\"views_ui\";i:1;s:5:\"clone\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:\"views_ui\";i:1;s:5:\"clone\";i:2;i:4;}','',61,6,0,'','admin/structure/views/view/%/clone','Clone','t','','','a:0:{}',4,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/views/view/%/delete','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"delete\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"delete\";i:2;i:4;}','',61,6,0,'','admin/structure/views/view/%/delete','Delete','t','','','a:0:{}',4,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/views/view/%/disable','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:8:\"views_ui\";i:1;s:7:\"disable\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:\"views_ui\";i:1;s:7:\"disable\";i:2;i:4;}','',61,6,0,'','admin/structure/views/view/%/disable','Disable','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/views/view/%/edit','a:1:{i:4;s:19:\"views_ui_cache_load\";}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_edit_page','a:1:{i:0;i:4;}','',61,6,3,'admin/structure/views/view/%','admin/structure/views/view/%','Edit view','t','','ajax_base_page_theme','a:0:{}',140,'','',-10,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/view/%/edit/%/ajax','a:2:{i:4;s:19:\"views_ui_cache_load\";i:6;N;}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_ajax_get_form','a:3:{i:0;s:18:\"views_ui_edit_form\";i:1;i:4;i:2;i:6;}','ajax_deliver',245,8,0,'','admin/structure/views/view/%/edit/%/ajax','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/view/%/enable','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"enable\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"enable\";i:2;i:4;}','',61,6,0,'','admin/structure/views/view/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/views/view/%/export','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"export\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"export\";i:2;i:4;}','',61,6,0,'','admin/structure/views/view/%/export','Export','t','','','a:0:{}',4,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/views/view/%/preview/%','a:2:{i:4;s:19:\"views_ui_cache_load\";i:6;N;}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_build_preview','a:2:{i:0;i:4;i:1;i:6;}','',122,7,3,'','admin/structure/views/view/%/preview/%','','t','','','a:0:{}',4,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/view/%/preview/%/ajax','a:2:{i:4;s:19:\"views_ui_cache_load\";i:6;N;}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_build_preview','a:2:{i:0;i:4;i:1;i:6;}','ajax_deliver',245,8,0,'','admin/structure/views/view/%/preview/%/ajax','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/view/%/revert','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"revert\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"delete\";i:2;i:4;}','',61,6,0,'','admin/structure/views/view/%/revert','Revert','t','','','a:0:{}',4,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/tasks','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',3,2,1,'admin','admin','Tasks','t','','','a:0:{}',140,'','',-20,'modules/system/system.admin.inc'),('admin/update/ready','','','update_manager_access','a:0:{}','drupal_get_form','a:1:{i:0;s:32:\"update_manager_update_ready_form\";}','',7,3,0,'','admin/update/ready','Ready to update','t','','','a:0:{}',0,'','',0,'modules/update/update.manager.inc'),('admin/views/ajax/autocomplete/tag','','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_autocomplete_tag','a:0:{}','',31,5,0,'','admin/views/ajax/autocomplete/tag','','t','','','a:0:{}',0,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/views/ajax/autocomplete/taxonomy','','','user_access','a:1:{i:0;s:14:\"access content\";}','views_ajax_autocomplete_taxonomy','a:0:{}','',31,5,0,'','admin/views/ajax/autocomplete/taxonomy','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/views/includes/ajax.inc'),('admin/views/ajax/autocomplete/user','','','user_access','a:1:{i:0;s:20:\"access user profiles\";}','views_ajax_autocomplete_user','a:0:{}','',31,5,0,'','admin/views/ajax/autocomplete/user','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/views/includes/ajax.inc'),('admin_menu/flush-cache','','','user_access','a:1:{i:0;s:12:\"flush caches\";}','admin_menu_flush_cache','a:0:{}','',3,2,0,'','admin_menu/flush-cache','','t','','','a:0:{}',0,'','',0,'sites/all/modules/admin_menu/admin_menu.inc'),('batch','','','1','a:0:{}','system_batch_page','a:0:{}','',1,1,0,'','batch','','t','','_system_batch_theme','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('cart','','','user_access','a:1:{i:0;s:14:\"access content\";}','commerce_cart_view','a:0:{}','',1,1,0,'','cart','Shopping cart','t','','','a:0:{}',6,'','',0,'sites/all/modules/commerce/modules/cart/includes/commerce_cart.pages.inc'),('cart/my','','','user_access','a:1:{i:0;s:14:\"access content\";}','commerce_cart_menu_item_redirect','a:0:{}','',3,2,0,'','cart/my','Shopping cart (# items)','commerce_cart_menu_item_title','a:1:{i:0;b:1;}','','a:0:{}',20,'','',0,''),('checkout','','','user_access','a:1:{i:0;s:15:\"access checkout\";}','commerce_cart_checkout_router','a:0:{}','',1,1,0,'','checkout','Checkout','t','','','a:0:{}',0,'','',0,'sites/all/modules/commerce/modules/cart/includes/commerce_cart.pages.inc'),('checkout/%','a:1:{i:1;s:19:\"commerce_order_load\";}','','user_access','a:1:{i:0;s:15:\"access checkout\";}','commerce_checkout_router','a:1:{i:0;i:1;}','',2,2,0,'','checkout/%','Checkout','t','','','a:0:{}',0,'','',0,'sites/all/modules/commerce/modules/checkout/includes/commerce_checkout.pages.inc'),('checkout/%/%','a:2:{i:1;s:19:\"commerce_order_load\";i:2;s:27:\"commerce_checkout_page_load\";}','','user_access','a:1:{i:0;s:15:\"access checkout\";}','commerce_checkout_router','a:2:{i:0;i:1;i:1;i:2;}','',4,3,0,'','checkout/%/%','Checkout','t','','','a:0:{}',0,'','',0,'sites/all/modules/commerce/modules/checkout/includes/commerce_checkout.pages.inc'),('ckeditor/disable/wysiwyg/%','a:1:{i:3;N;}','','1','a:1:{i:0;s:19:\"administer ckeditor\";}','ckeditor_disable_wysiwyg','a:1:{i:0;i:3;}','',14,4,0,'','ckeditor/disable/wysiwyg/%','Disable the WYSIWYG module','t','','','a:0:{}',0,'Disable WYSIWYG module.','',0,'sites/all/modules/ckeditor/includes/ckeditor.admin.inc'),('ckeditor/xss','','','1','a:0:{}','ckeditor_filter_xss','a:0:{}','',3,2,0,'','ckeditor/xss','XSS Filter','t','','','a:0:{}',0,'XSS Filter.','',0,'sites/all/modules/ckeditor/includes/ckeditor.page.inc'),('comment/%','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:15:\"access comments\";}','comment_permalink','a:1:{i:0;i:1;}','',2,2,0,'','comment/%','Comment permalink','t','','','a:0:{}',6,'','',0,''),('comment/%/approve','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:19:\"administer comments\";}','comment_approve','a:1:{i:0;i:1;}','',5,3,0,'','comment/%/approve','Approve','t','','','a:0:{}',6,'','',1,'modules/comment/comment.pages.inc'),('comment/%/delete','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:19:\"administer comments\";}','comment_confirm_delete_page','a:1:{i:0;i:1;}','',5,3,1,'comment/%','comment/%','Delete','t','','','a:0:{}',132,'','',2,'modules/comment/comment.admin.inc'),('comment/%/devel','a:1:{i:1;s:12:\"comment_load\";}','','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_load_object','a:2:{i:0;s:7:\"comment\";i:1;i:1;}','',5,3,1,'comment/%','comment/%','Devel','t','','','a:0:{}',132,'','',100,'sites/all/modules/devel/devel.pages.inc'),('comment/%/devel/load','a:1:{i:1;s:12:\"comment_load\";}','','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_load_object','a:2:{i:0;s:7:\"comment\";i:1;i:1;}','',11,4,1,'comment/%/devel','comment/%','Load','t','','','a:0:{}',140,'','',0,'sites/all/modules/devel/devel.pages.inc'),('comment/%/devel/render','a:1:{i:1;s:12:\"comment_load\";}','','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_render_object','a:2:{i:0;s:7:\"comment\";i:1;i:1;}','',11,4,1,'comment/%/devel','comment/%','Render','t','','','a:0:{}',132,'','',100,'sites/all/modules/devel/devel.pages.inc'),('comment/%/devel/token','a:1:{i:1;s:12:\"comment_load\";}','','user_access','a:1:{i:0;s:24:\"access devel information\";}','token_devel_token_object','a:2:{i:0;s:7:\"comment\";i:1;i:1;}','',11,4,1,'comment/%/devel','comment/%','Tokens','t','','','a:0:{}',132,'','',5,'sites/all/modules/token/token.pages.inc'),('comment/%/edit','a:1:{i:1;s:12:\"comment_load\";}','','comment_access','a:2:{i:0;s:4:\"edit\";i:1;i:1;}','comment_edit_page','a:1:{i:0;i:1;}','',5,3,1,'comment/%','comment/%','Edit','t','','','a:0:{}',132,'','',0,''),('comment/%/view','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:15:\"access comments\";}','comment_permalink','a:1:{i:0;i:1;}','',5,3,1,'comment/%','comment/%','View comment','t','','','a:0:{}',140,'','',-10,''),('comment/reply/%','a:1:{i:2;s:9:\"node_load\";}','','node_access','a:2:{i:0;s:4:\"view\";i:1;i:2;}','comment_reply','a:1:{i:0;i:2;}','',6,3,0,'','comment/reply/%','Add new comment','t','','','a:0:{}',6,'','',0,'modules/comment/comment.pages.inc'),('commerce_paypal/ipn','','','1','a:0:{}','commerce_paypal_process_ipn','a:0:{}','',3,2,0,'','commerce_paypal/ipn','','t','','','a:0:{}',0,'','',0,''),('commerce_paypal/ipn/%','a:1:{i:2;s:37:\"commerce_payment_method_instance_load\";}','','1','a:0:{}','commerce_paypal_process_ipn','a:1:{i:0;i:2;}','',6,3,0,'','commerce_paypal/ipn/%','','t','','','a:0:{}',0,'','',0,''),('commerce_product/autocomplete','','','1','a:0:{}','commerce_product_autocomplete','a:0:{}','',3,2,0,'','commerce_product/autocomplete','commerce_product autocomplete','t','','','a:0:{}',0,'','',0,''),('commerce_store/store/%','a:1:{i:2;a:1:{s:14:\"eckentity_load\";a:1:{i:0;s:14:\"commerce_store\";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:\"view\";i:1;s:14:\"commerce_store\";i:2;s:5:\"store\";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:14:\"commerce_store\";i:1;s:5:\"store\";i:2;i:2;}','',6,3,0,'','commerce_store/store/%','View Store','t','','','a:0:{}',6,'View an entity of type Commerce Store with bundle Store','',0,'sites/all/modules/eck/eck.entity.inc'),('commerce_store/store/%/account','a:1:{i:2;s:19:\"commerce_store_load\";}','','commerce_marketplace_funds_account_page_access','a:2:{i:0;s:14:\"commerce_store\";i:1;i:2;}','commerce_marketplace_funds_account_view','a:2:{i:0;s:14:\"commerce_store\";i:1;i:2;}','',13,4,1,'commerce_store/store/%','commerce_store/store/%','','commerce_marketplace_funds_account_title','a:2:{i:0;s:14:\"commerce_store\";i:1;i:2;}','','a:0:{}',132,'','',2,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.pages.inc'),('commerce_store/store/%/account/transaction','a:1:{i:2;s:19:\"commerce_store_load\";}','','commerce_marketplace_funds_account_transactions_page_access','a:2:{i:0;s:14:\"commerce_store\";i:1;i:2;}','commerce_marketplace_funds_account_transactions_list','a:2:{i:0;s:14:\"commerce_store\";i:1;i:2;}','',27,5,1,'commerce_store/store/%/account','commerce_store/store/%','Account Transactions','t','','','a:0:{}',132,'','',1,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.pages.inc'),('commerce_store/store/%/account/transaction/new/deposit','a:1:{i:2;s:19:\"commerce_store_load\";}','','commerce_marketplace_funds_new_transaction_page_access','a:3:{i:0;s:14:\"commerce_store\";i:1;i:2;i:2;s:7:\"deposit\";}','commerce_marketplace_funds_new_deposit_transaction_page','a:3:{i:0;s:14:\"commerce_store\";i:1;i:2;i:2;s:7:\"deposit\";}','',111,7,1,'commerce_store/store/%/account/transaction','commerce_store/store/%','Make a Deposit transaction','t','','','a:0:{}',388,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.admin.inc'),('commerce_store/store/%/account/transaction/new/transfer','a:1:{i:2;s:19:\"commerce_store_load\";}','','commerce_marketplace_funds_new_transaction_page_access','a:3:{i:0;s:14:\"commerce_store\";i:1;i:2;i:2;s:8:\"transfer\";}','commerce_marketplace_funds_new_transfer_transaction_page','a:3:{i:0;s:14:\"commerce_store\";i:1;i:2;i:2;s:8:\"transfer\";}','',111,7,1,'commerce_store/store/%/account/transaction','commerce_store/store/%','Make a Funds transfer transaction','t','','','a:0:{}',388,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.admin.inc'),('commerce_store/store/%/account/transaction/new/withdraw','a:1:{i:2;s:19:\"commerce_store_load\";}','','commerce_marketplace_funds_new_transaction_page_access','a:3:{i:0;s:14:\"commerce_store\";i:1;i:2;i:2;s:8:\"withdraw\";}','drupal_get_form','a:3:{i:0;s:56:\"commerce_marketplace_funds_new_withdraw_transaction_form\";i:1;s:14:\"commerce_store\";i:2;i:2;}','',111,7,1,'commerce_store/store/%/account/transaction','commerce_store/store/%','Create withdraw request','t','','','a:0:{}',388,'','',1,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/modules/withdraw/includes/commerce_marketplace_funds_withdraw.transaction.admin.inc'),('commerce_store/store/%/account/view','a:1:{i:2;s:19:\"commerce_store_load\";}','','commerce_marketplace_funds_account_page_access','a:2:{i:0;s:14:\"commerce_store\";i:1;i:2;}','commerce_marketplace_funds_account_view','a:2:{i:0;s:14:\"commerce_store\";i:1;i:2;}','',27,5,1,'commerce_store/store/%/account','commerce_store/store/%','Account','t','','','a:0:{}',140,'','',-1,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.pages.inc'),('commerce_store/store/%/account/withdraw','a:1:{i:2;s:19:\"commerce_store_load\";}','','commerce_marketplace_funds_account_withdraw_overview_access','a:2:{i:0;s:14:\"commerce_store\";i:1;i:2;}','commerce_marketplace_funds_withdraw_methods_overview_page','a:2:{i:0;s:14:\"commerce_store\";i:1;i:2;}','',27,5,1,'commerce_store/store/%/account','commerce_store/store/%','Configure withdraw methods','t','','','a:0:{}',132,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/modules/withdraw/includes/commerce_marketplace_funds_withdraw.method.admin.inc'),('commerce_store/store/%/account/withdraw/%','a:2:{i:2;s:19:\"commerce_store_load\";i:5;N;}','','commerce_marketplace_funds_withdraw_method_access','a:5:{i:0;s:4:\"edit\";i:1;i:5;i:2;N;i:3;s:14:\"commerce_store\";i:4;i:2;}','commerce_marketplace_funds_withdraw_method_form_wrapper','a:3:{i:0;i:5;i:1;s:14:\"commerce_store\";i:2;i:2;}','',54,6,0,'','commerce_store/store/%/account/withdraw/%','','commerce_marketplace_funds_withdraw_method_add_page_title','a:1:{i:0;i:5;}','','a:0:{}',6,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/modules/withdraw/includes/commerce_marketplace_funds_withdraw.method.admin.inc'),('commerce_store/store/%/delete','a:1:{i:2;a:1:{s:14:\"eckentity_load\";a:1:{i:0;s:14:\"commerce_store\";}}}','','eck__entity_menu_access','a:4:{i:0;s:6:\"delete\";i:1;s:14:\"commerce_store\";i:2;s:5:\"store\";i:3;i:2;}','eck__entity__delete','a:3:{i:0;s:14:\"commerce_store\";i:1;s:5:\"store\";i:2;i:2;}','',13,4,3,'commerce_store/store/%','commerce_store/store/%','Delete','t','','','a:0:{}',132,'View an entity of type Commerce Store with bundle Store','',2,'sites/all/modules/eck/eck.entity.inc'),('commerce_store/store/%/edit','a:1:{i:2;a:1:{s:14:\"eckentity_load\";a:1:{i:0;s:14:\"commerce_store\";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:\"edit\";i:1;s:14:\"commerce_store\";i:2;s:5:\"store\";i:3;i:2;}','eck__entity__edit','a:3:{i:0;s:14:\"commerce_store\";i:1;s:5:\"store\";i:2;i:2;}','',13,4,3,'commerce_store/store/%','commerce_store/store/%','Edit','t','','','a:0:{}',132,'View an entity of type Commerce Store with bundle Store','',1,'sites/all/modules/eck/eck.entity.inc'),('commerce_store/store/%/people','a:1:{i:2;a:1:{s:14:\"eckentity_load\";a:1:{i:0;s:14:\"commerce_store\";}}}','','commerce_store_access_people_page_access','a:1:{i:0;i:2;}','drupal_get_form','a:2:{i:0;s:33:\"commerce_store_access_people_page\";i:1;i:2;}','',13,4,1,'commerce_store/store/%','commerce_store/store/%','Members','t','','','a:0:{}',132,'','',5,'sites/all/modules/commerce_marketplace/modules/commerce_store_access/includes/commerce_store_access.pages.inc'),('commerce_store/store/%/people/add','a:1:{i:2;a:1:{s:14:\"eckentity_load\";a:1:{i:0;s:14:\"commerce_store\";}}}','','commerce_store_access_add_people_page_access','a:1:{i:0;i:2;}','drupal_get_form','a:2:{i:0;s:37:\"commerce_store_access_add_people_page\";i:1;i:2;}','',27,5,1,'commerce_store/store/%/people','commerce_store/store/%','Add','t','','','a:0:{}',388,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_store_access/includes/commerce_store_access.pages.inc'),('commerce_store/store/%/people/list','a:1:{i:2;a:1:{s:14:\"eckentity_load\";a:1:{i:0;s:14:\"commerce_store\";}}}','','commerce_store_access_people_page_access','a:1:{i:0;i:2;}','drupal_get_form','a:2:{i:0;s:33:\"commerce_store_access_people_page\";i:1;i:2;}','',27,5,1,'commerce_store/store/%/people','commerce_store/store/%','List','t','','','a:0:{}',140,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_store_access/includes/commerce_store_access.pages.inc'),('commerce_store/store/%/people/permissions','a:1:{i:2;a:1:{s:14:\"eckentity_load\";a:1:{i:0;s:14:\"commerce_store\";}}}','','commerce_store_access_perms_page_access','a:1:{i:0;i:2;}','drupal_get_form','a:2:{i:0;s:32:\"commerce_store_access_perms_page\";i:1;i:2;}','',27,5,1,'commerce_store/store/%/people','commerce_store/store/%','Permissions','t','','','a:0:{}',132,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_store_access/includes/commerce_store_access.pages.inc'),('commerce_store/store/%/people/roles','a:1:{i:2;a:1:{s:14:\"eckentity_load\";a:1:{i:0;s:14:\"commerce_store\";}}}','','commerce_store_access_roles_page_access','a:1:{i:0;i:2;}','commerce_store_access_roles_page','a:1:{i:0;i:2;}','',27,5,1,'commerce_store/store/%/people','commerce_store/store/%','Roles','t','','','a:0:{}',132,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_store_access/includes/commerce_store_access.pages.inc'),('commerce_store/store/%/people/roles/%/edit','a:2:{i:2;a:1:{s:14:\"eckentity_load\";a:1:{i:0;s:14:\"commerce_store\";}}i:5;N;}','','commerce_store_access_edit_role_page_access','a:2:{i:0;i:2;i:1;i:5;}','drupal_get_form','a:3:{i:0;s:35:\"commerce_store_access_add_role_page\";i:1;i:2;i:2;i:5;}','',109,7,0,'','commerce_store/store/%/people/roles/%/edit','Edit role','t','','','a:0:{}',6,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_store_access/includes/commerce_store_access.pages.inc'),('commerce_store/store/%/people/roles/add','a:1:{i:2;a:1:{s:14:\"eckentity_load\";a:1:{i:0;s:14:\"commerce_store\";}}}','','commerce_store_access_add_role_page_access','a:1:{i:0;i:2;}','drupal_get_form','a:2:{i:0;s:35:\"commerce_store_access_add_role_page\";i:1;i:2;}','',55,6,1,'commerce_store/store/%/people/roles','commerce_store/store/%','Add new role','t','','','a:0:{}',388,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_store_access/includes/commerce_store_access.pages.inc'),('commerce_store/store/%/products','a:1:{i:2;s:19:\"commerce_store_load\";}','','commerce_store_access_user_access','a:2:{i:0;s:15:\"view store page\";i:1;i:2;}','commerce_marketplace_store_products','a:1:{i:0;i:2;}','',13,4,1,'commerce_store/store/%','commerce_store/store/%','','commerce_marketplace_store_products_page_title','a:1:{i:0;i:2;}','','a:0:{}',132,'','',4,''),('commerce_store/store/%/sales','a:1:{i:2;s:19:\"commerce_store_load\";}','','commerce_store_access_user_access','a:2:{i:0;s:17:\"view store orders\";i:1;i:2;}','commerce_marketplace_sales','a:1:{i:0;i:2;}','',13,4,1,'commerce_store/store/%','commerce_store/store/%','Sales','t','','','a:0:{}',132,'','',5,''),('commerce_store/store/%/sales/%','a:2:{i:2;s:19:\"commerce_store_load\";i:4;s:19:\"commerce_order_load\";}','','commerce_marketplace_order_access','a:3:{i:0;i:2;i:1;i:4;i:2;s:17:\"view store orders\";}','commerce_marketplace_view_order','a:1:{i:0;i:4;}','',26,5,0,'','commerce_store/store/%/sales/%','','commerce_marketplace_order_title','a:1:{i:0;i:4;}','','a:0:{}',6,'','',0,''),('commerce_store/store/%/sales/%/edit','a:2:{i:2;s:19:\"commerce_store_load\";i:4;s:19:\"commerce_order_load\";}','','commerce_marketplace_order_access','a:3:{i:0;i:2;i:1;i:4;i:2;s:17:\"edit store orders\";}','drupal_get_form','a:2:{i:0;s:25:\"commerce_order_order_form\";i:1;i:4;}','',53,6,0,'','commerce_store/store/%/sales/%/edit','','commerce_marketplace_order_title','a:1:{i:0;i:4;}','','a:0:{}',6,'','',0,'sites/all/modules/commerce/modules/order//includes/commerce_order.forms.inc'),('commerce_store/store/%/view','a:1:{i:2;a:1:{s:14:\"eckentity_load\";a:1:{i:0;s:14:\"commerce_store\";}}}','','eck__entity_menu_access','a:4:{i:0;s:4:\"view\";i:1;s:14:\"commerce_store\";i:2;s:5:\"store\";i:3;i:2;}','eck__entity__view','a:3:{i:0;s:14:\"commerce_store\";i:1;s:5:\"store\";i:2;i:2;}','',13,4,1,'commerce_store/store/%','commerce_store/store/%','View','t','','','a:0:{}',140,'','',0,'sites/all/modules/eck/eck.entity.inc'),('context-ui/activate','','','user_access','a:1:{i:0;s:19:\"administer contexts\";}','context_ui_activate','a:0:{}','',3,2,0,'','context-ui/activate','Activate Context UI','t','','','a:0:{}',0,'','',0,''),('context-ui/deactivate','','','user_access','a:1:{i:0;s:19:\"administer contexts\";}','context_ui_deactivate','a:0:{}','',3,2,0,'','context-ui/deactivate','Deactivate Context UI','t','','','a:0:{}',0,'','',0,''),('ctools/autocomplete/%','a:1:{i:2;N;}','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_content_autocomplete_entity','a:1:{i:0;i:2;}','',6,3,0,'','ctools/autocomplete/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/content.menu.inc'),('ctools/context/ajax/access/add','','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_access_ajax_add','a:0:{}','',31,5,0,'','ctools/context/ajax/access/add','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/context-access-admin.inc'),('ctools/context/ajax/access/configure','','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_access_ajax_edit','a:0:{}','',31,5,0,'','ctools/context/ajax/access/configure','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/context-access-admin.inc'),('ctools/context/ajax/access/delete','','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_access_ajax_delete','a:0:{}','',31,5,0,'','ctools/context/ajax/access/delete','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/context-access-admin.inc'),('ctools/context/ajax/add','','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_context_ajax_item_add','a:0:{}','',15,4,0,'','ctools/context/ajax/add','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/context-admin.inc'),('ctools/context/ajax/configure','','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_context_ajax_item_edit','a:0:{}','',15,4,0,'','ctools/context/ajax/configure','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/context-admin.inc'),('ctools/context/ajax/delete','','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_context_ajax_item_delete','a:0:{}','',15,4,0,'','ctools/context/ajax/delete','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/context-admin.inc'),('devel/arguments','','','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_querylog_arguments','a:0:{}','',3,2,0,'','devel/arguments','Arguments query','t','','','a:0:{}',0,'Return a given query, with arguments instead of placeholders. Used by query log','',0,'sites/all/modules/devel/devel.pages.inc'),('devel/cache/clear','','','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_cache_clear','a:0:{}','',7,3,0,'','devel/cache/clear','Clear cache','t','','','a:0:{}',6,'Clear the CSS cache and all database cache tables which store page, node, theme and variable caches.','',0,'sites/all/modules/devel/devel.pages.inc'),('devel/elements','','','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_elements_page','a:0:{}','',3,2,0,'','devel/elements','Hook_elements()','t','','','a:0:{}',6,'View the active form/render elements for this site.','',0,'sites/all/modules/devel/devel.pages.inc'),('devel/entity/info','','','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_entity_info_page','a:0:{}','',7,3,0,'','devel/entity/info','Entity info','t','','','a:0:{}',6,'View entity information across the whole site.','',0,'sites/all/modules/devel/devel.pages.inc'),('devel/explain','','','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_querylog_explain','a:0:{}','',3,2,0,'','devel/explain','Explain query','t','','','a:0:{}',0,'Run an EXPLAIN on a given query. Used by query log','',0,'sites/all/modules/devel/devel.pages.inc'),('devel/field/info','','','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_field_info_page','a:0:{}','',7,3,0,'','devel/field/info','Field info','t','','','a:0:{}',6,'View fields information across the whole site.','',0,'sites/all/modules/devel/devel.pages.inc'),('devel/menu/item','','','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_menu_item','a:0:{}','',7,3,0,'','devel/menu/item','Menu item','t','','','a:0:{}',6,'Details about a given menu item.','',0,'sites/all/modules/devel/devel.pages.inc'),('devel/menu/reset','','','user_access','a:1:{i:0;s:24:\"access devel information\";}','drupal_get_form','a:1:{i:0;s:18:\"devel_menu_rebuild\";}','',7,3,0,'','devel/menu/reset','Rebuild menus','t','','','a:0:{}',6,'Rebuild menu based on hook_menu() and revert any custom changes. All menu items return to their default settings.','',0,'sites/all/modules/devel/devel.pages.inc'),('devel/php','','','user_access','a:1:{i:0;s:16:\"execute php code\";}','drupal_get_form','a:1:{i:0;s:18:\"devel_execute_form\";}','',3,2,0,'','devel/php','Execute PHP Code','t','','','a:0:{}',6,'Execute some PHP code','',0,'sites/all/modules/devel/devel.pages.inc'),('devel/phpinfo','','','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_phpinfo','a:0:{}','',3,2,0,'','devel/phpinfo','PHPinfo()','t','','','a:0:{}',6,'View your server\'s PHP configuration','',0,'sites/all/modules/devel/devel.pages.inc'),('devel/reference','','','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_function_reference','a:0:{}','',3,2,0,'','devel/reference','Function reference','t','','','a:0:{}',6,'View a list of currently defined user functions with documentation links.','',0,'sites/all/modules/devel/devel.pages.inc'),('devel/reinstall','','','user_access','a:1:{i:0;s:24:\"access devel information\";}','drupal_get_form','a:1:{i:0;s:15:\"devel_reinstall\";}','',3,2,0,'','devel/reinstall','Reinstall modules','t','','','a:0:{}',6,'Run hook_uninstall() and then hook_install() for a given module.','',0,'sites/all/modules/devel/devel.pages.inc'),('devel/run-cron','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','system_run_cron','a:0:{}','',3,2,0,'','devel/run-cron','Run cron','t','','','a:0:{}',6,'','',0,'modules/system/system.admin.inc'),('devel/session','','','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_session','a:0:{}','',3,2,0,'','devel/session','Session viewer','t','','','a:0:{}',6,'List the contents of $_SESSION.','',0,'sites/all/modules/devel/devel.pages.inc'),('devel/settings','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:20:\"devel_admin_settings\";}','',3,2,0,'','devel/settings','Devel settings','t','','','a:0:{}',6,'Helper functions, pages, and blocks to assist Drupal developers. The devel blocks can be managed via the <a href=\"/en/admin/structure/block\">block administration</a> page.','',0,'sites/all/modules/devel/devel.admin.inc'),('devel/switch','','','_devel_switch_user_access','a:1:{i:0;i:2;}','devel_switch_user','a:0:{}','',3,2,0,'','devel/switch','Switch user','t','','','a:0:{}',0,'','',0,'sites/all/modules/devel/devel.pages.inc'),('devel/theme/registry','','','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_theme_registry','a:0:{}','',7,3,0,'','devel/theme/registry','Theme registry','t','','','a:0:{}',6,'View a list of available theme functions across the whole site.','',0,'sites/all/modules/devel/devel.pages.inc'),('devel/variable','','','user_access','a:1:{i:0;s:24:\"access devel information\";}','drupal_get_form','a:1:{i:0;s:19:\"devel_variable_form\";}','',3,2,0,'','devel/variable','Variable editor','t','','','a:0:{}',6,'Edit and delete site variables.','',0,'sites/all/modules/devel/devel.pages.inc'),('devel/variable/edit/%','a:1:{i:3;N;}','','user_access','a:1:{i:0;s:24:\"access devel information\";}','drupal_get_form','a:2:{i:0;s:19:\"devel_variable_edit\";i:1;i:3;}','',14,4,0,'','devel/variable/edit/%','Variable editor','t','','','a:0:{}',0,'','',0,'sites/all/modules/devel/devel.pages.inc'),('entityreference/autocomplete/single/%/%/%','a:3:{i:3;N;i:4;N;i:5;N;}','','entityreference_autocomplete_access_callback','a:4:{i:0;i:2;i:1;i:3;i:2;i:4;i:3;i:5;}','entityreference_autocomplete_callback','a:4:{i:0;i:2;i:1;i:3;i:2;i:4;i:3;i:5;}','',56,6,0,'','entityreference/autocomplete/single/%/%/%','Entity Reference Autocomplete','t','','','a:0:{}',0,'','',0,''),('entityreference/autocomplete/tags/%/%/%','a:3:{i:3;N;i:4;N;i:5;N;}','','entityreference_autocomplete_access_callback','a:4:{i:0;i:2;i:1;i:3;i:2;i:4;i:3;i:5;}','entityreference_autocomplete_callback','a:4:{i:0;i:2;i:1;i:3;i:2;i:4;i:3;i:5;}','',56,6,0,'','entityreference/autocomplete/tags/%/%/%','Entity Reference Autocomplete','t','','','a:0:{}',0,'','',0,''),('features/ajaxcallback/%','a:1:{i:2;N;}','','user_access','a:1:{i:0;s:19:\"administer features\";}','features_export_components_json','a:1:{i:0;i:2;}','',6,3,0,'','features/ajaxcallback/%','','features_get_feature_components','','','a:0:{}',0,'Return components of a feature.','',0,'sites/all/modules/features/features.admin.inc'),('features/autocomplete/packages','','','user_access','a:1:{i:0;s:15:\"manage features\";}','features_autocomplete_packages','a:0:{}','',7,3,0,'','features/autocomplete/packages','','t','','','a:0:{}',0,'','',0,'sites/all/modules/features/features.admin.inc'),('field-collection/field-specifications/%','a:1:{i:2;s:26:\"field_collection_item_load\";}','','field_collection_item_access','a:2:{i:0;s:4:\"view\";i:1;i:2;}','field_collection_item_page_view','a:1:{i:0;i:2;}','',6,3,0,'','field-collection/field-specifications/%','','t','','','a:0:{}',6,'','',0,'sites/all/modules/field_collection/field_collection.pages.inc'),('field-collection/field-specifications/%/delete','a:1:{i:2;s:26:\"field_collection_item_load\";}','','field_collection_item_access','a:2:{i:0;s:6:\"delete\";i:1;i:2;}','drupal_get_form','a:2:{i:0;s:36:\"field_collection_item_delete_confirm\";i:1;i:2;}','',13,4,2,'field-collection/field-specifications/%','field-collection/field-specifications/%','Delete','t','','','a:0:{}',132,'','',0,'sites/all/modules/field_collection/field_collection.pages.inc'),('field-collection/field-specifications/%/edit','a:1:{i:2;s:26:\"field_collection_item_load\";}','','field_collection_item_access','a:2:{i:0;s:6:\"update\";i:1;i:2;}','drupal_get_form','a:2:{i:0;s:26:\"field_collection_item_form\";i:1;i:2;}','',13,4,3,'field-collection/field-specifications/%','field-collection/field-specifications/%','Edit','t','','','a:0:{}',132,'','',0,'sites/all/modules/field_collection/field_collection.pages.inc'),('field-collection/field-specifications/%/revisions/%','a:2:{i:2;s:26:\"field_collection_item_load\";i:4;s:35:\"field_collection_item_revision_load\";}','','field_collection_item_access','a:2:{i:0;s:4:\"view\";i:1;i:4;}','field_collection_item_page_view','a:1:{i:0;i:4;}','',26,5,0,'','field-collection/field-specifications/%/revisions/%','','t','','','a:0:{}',6,'','',0,'sites/all/modules/field_collection/field_collection.pages.inc'),('field-collection/field-specifications/%/view','a:1:{i:2;s:26:\"field_collection_item_load\";}','','field_collection_item_access','a:2:{i:0;s:4:\"view\";i:1;i:2;}','field_collection_item_page_view','a:1:{i:0;i:2;}','',13,4,1,'field-collection/field-specifications/%','field-collection/field-specifications/%','View','t','','','a:0:{}',140,'','',-10,'sites/all/modules/field_collection/field_collection.pages.inc'),('field-collection/field-specifications/add/%/%','a:2:{i:3;N;i:4;N;}','','1','a:0:{}','field_collection_item_add','a:3:{i:0;s:20:\"field_specifications\";i:1;i:3;i:2;i:4;}','',28,5,0,'','field-collection/field-specifications/add/%/%','','t','','','a:0:{}',6,'','',0,'sites/all/modules/field_collection/field_collection.pages.inc'),('field_collection/ajax','','','1','a:0:{}','field_collection_remove_js','a:0:{}','ajax_deliver',3,2,0,'','field_collection/ajax','Remove item callback','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'includes/form.inc'),('file/ajax','','','user_access','a:1:{i:0;s:14:\"access content\";}','file_ajax_upload','a:0:{}','ajax_deliver',3,2,0,'','file/ajax','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,''),('file/progress','','','user_access','a:1:{i:0;s:14:\"access content\";}','file_ajax_progress','a:0:{}','',3,2,0,'','file/progress','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,''),('filter/tips','','','1','a:0:{}','filter_tips_long','a:0:{}','',3,2,0,'','filter/tips','Compose tips','t','','','a:0:{}',20,'','',0,'modules/filter/filter.pages.inc'),('filter/tips/%','a:1:{i:2;s:18:\"filter_format_load\";}','','filter_access','a:1:{i:0;i:2;}','filter_tips_long','a:1:{i:0;i:2;}','',6,3,0,'','filter/tips/%','Compose tips','t','','','a:0:{}',6,'','',0,'modules/filter/filter.pages.inc'),('frontpage','','','views_access','a:1:{i:0;b:1;}','views_page','a:2:{i:0;s:9:\"frontpage\";i:1;s:4:\"page\";}','',1,1,0,'','frontpage','','t','','','a:0:{}',0,'','',0,''),('funds/account/autocomplete','','','1','a:0:{}','commerce_marketplace_funds_account_autocomplete_callback','a:0:{}','',7,3,0,'','funds/account/autocomplete','','t','','','a:0:{}',0,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.pages.inc'),('funds/transaction/%','a:1:{i:2;s:43:\"commerce_marketplace_funds_transaction_load\";}','','commerce_marketplace_funds_transaction_page_access','a:1:{i:0;i:2;}','commerce_marketplace_funds_transaction_view','a:1:{i:0;i:2;}','',6,3,0,'','funds/transaction/%','','commerce_marketplace_funds_transaction_title','a:1:{i:0;i:2;}','','a:0:{}',6,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.pages.inc'),('funds/transaction/%/edit','a:1:{i:2;s:43:\"commerce_marketplace_funds_transaction_load\";}','','commerce_marketplace_funds_transaction_access','a:2:{i:0;s:6:\"update\";i:1;i:2;}','commerce_marketplace_funds_transaction_edit','a:1:{i:0;i:2;}','',13,4,1,'funds/transaction/%','funds/transaction/%','Edit','t','','','a:0:{}',132,'','',10,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.admin.inc'),('funds/transaction/%/view','a:1:{i:2;s:43:\"commerce_marketplace_funds_transaction_load\";}','','commerce_marketplace_funds_transaction_page_access','a:1:{i:0;i:2;}','commerce_marketplace_funds_transaction_view','a:1:{i:0;i:2;}','',13,4,1,'funds/transaction/%','funds/transaction/%','View','t','','','a:0:{}',140,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.pages.inc'),('icons','','','user_access','a:1:{i:0;s:10:\"view icons\";}','drupal_get_form','a:1:{i:0;s:25:\"icon_bundle_overview_form\";}','',1,1,0,'','icons','Icons','t','','','a:0:{}',6,'Overview of all available icons.','',0,'sites/all/modules/icon/includes/admin.inc'),('icons/%','a:1:{i:1;s:16:\"icon_bundle_load\";}','','user_access','a:1:{i:0;s:10:\"view icons\";}','icon_bundle_list','a:1:{i:0;i:1;}','',2,2,0,'','icons/%','','icon_bundle_get_title','a:1:{i:0;i:1;}','icon_bundle_get_theme','a:1:{i:0;i:1;}',6,'An icon bundle.','',0,'sites/all/modules/icon/includes/admin.inc'),('imce','','','imce_access','a:2:{i:0;b:0;i:1;i:1;}','imce','a:0:{}','',1,1,0,'','imce','File browser','t','','','a:0:{}',0,'','',0,'sites/all/modules/imce/inc/imce.page.inc'),('inline_entity_form/autocomplete','','','1','a:0:{}','inline_entity_form_autocomplete','a:0:{}','',3,2,0,'','inline_entity_form/autocomplete','Inline Entity Form Autocomplete','t','','','a:0:{}',0,'','',0,''),('jcarousel/ajax/views','','','1','a:0:{}','jcarousel_views_ajax','a:0:{}','',7,3,0,'','jcarousel/ajax/views','','t','','','a:0:{}',0,'','',0,'sites/all/modules/jcarousel/includes/jcarousel.views.inc'),('js/admin_menu/cache','','','user_access','a:1:{i:0;s:26:\"access administration menu\";}','admin_menu_js_cache','a:0:{}','admin_menu_deliver',7,3,0,'','js/admin_menu/cache','','t','','','a:0:{}',0,'','',0,''),('menutoken/%','a:1:{i:1;N;}','','1','a:0:{}','theme_menu_token_uses_tokens','a:0:{}','',2,2,0,'','menutoken/%','Dummy Menu Token item','t','','','a:0:{}',6,'','',0,''),('migrate_content/ajaxcallback/%','a:1:{i:2;N;}','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','we_content_migration_export_components_json','a:1:{i:0;i:2;}','',6,3,0,'','migrate_content/ajaxcallback/%','','Check require bundles','','','a:0:{}',0,'Check require bundles.','',0,'sites/all/modules/we_content_migration/we_content_migration.admin.inc'),('newsletter/confirm','','','user_access','a:1:{i:0;s:24:\"subscribe to newsletters\";}','simplenews_confirm_subscription','a:0:{}','',3,2,0,'','newsletter/confirm','Confirm newsletter subscriptions','t','','','a:0:{}',0,'','',0,'sites/all/modules/simplenews/includes/simplenews.subscription.inc'),('newsletter/subscriptions','','','user_access','a:1:{i:0;s:24:\"subscribe to newsletters\";}','drupal_get_form','a:1:{i:0;s:34:\"simplenews_subscriptions_page_form\";}','',3,2,0,'','newsletter/subscriptions','Your newsletter subscriptions','t','','','a:0:{}',0,'','',0,'sites/all/modules/simplenews/includes/simplenews.subscription.inc'),('node','','','user_access','a:1:{i:0;s:14:\"access content\";}','weight_page_default','a:0:{}','',1,1,0,'','node','','t','','','a:0:{}',0,'','',0,''),('node/%','a:1:{i:1;s:9:\"node_load\";}','','node_access','a:2:{i:0;s:4:\"view\";i:1;i:1;}','node_page_view','a:1:{i:0;i:1;}','',2,2,0,'','node/%','','node_page_title','a:1:{i:0;i:1;}','','a:0:{}',6,'','',0,''),('node/%/delete','a:1:{i:1;s:9:\"node_load\";}','','node_access','a:2:{i:0;s:6:\"delete\";i:1;i:1;}','drupal_get_form','a:2:{i:0;s:19:\"node_delete_confirm\";i:1;i:1;}','',5,3,2,'node/%','node/%','Delete','t','','','a:0:{}',132,'','',1,'modules/node/node.pages.inc'),('node/%/devel','a:1:{i:1;s:9:\"node_load\";}','','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_load_object','a:2:{i:0;s:4:\"node\";i:1;i:1;}','',5,3,1,'node/%','node/%','Devel','t','','','a:0:{}',132,'','',100,'sites/all/modules/devel/devel.pages.inc'),('node/%/devel/load','a:1:{i:1;s:9:\"node_load\";}','','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_load_object','a:2:{i:0;s:4:\"node\";i:1;i:1;}','',11,4,1,'node/%/devel','node/%','Load','t','','','a:0:{}',140,'','',0,'sites/all/modules/devel/devel.pages.inc'),('node/%/devel/render','a:1:{i:1;s:9:\"node_load\";}','','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_render_object','a:2:{i:0;s:4:\"node\";i:1;i:1;}','',11,4,1,'node/%/devel','node/%','Render','t','','','a:0:{}',132,'','',100,'sites/all/modules/devel/devel.pages.inc'),('node/%/devel/token','a:1:{i:1;s:9:\"node_load\";}','','user_access','a:1:{i:0;s:24:\"access devel information\";}','token_devel_token_object','a:2:{i:0;s:4:\"node\";i:1;i:1;}','',11,4,1,'node/%/devel','node/%','Tokens','t','','','a:0:{}',132,'','',5,'sites/all/modules/token/token.pages.inc'),('node/%/done','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_confirmation_page_access','a:1:{i:0;i:1;}','_webform_confirmation','a:1:{i:0;i:1;}','',5,3,0,'','node/%/done','Webform confirmation','t','','','a:0:{}',0,'','',0,''),('node/%/edit','a:1:{i:1;s:9:\"node_load\";}','','node_access','a:2:{i:0;s:6:\"update\";i:1;i:1;}','node_page_edit','a:1:{i:0;i:1;}','',5,3,3,'node/%','node/%','Edit','t','','','a:0:{}',132,'','',0,'modules/node/node.pages.inc'),('node/%/revisions','a:1:{i:1;s:9:\"node_load\";}','','_node_revision_access','a:1:{i:0;i:1;}','node_revision_overview','a:1:{i:0;i:1;}','',5,3,1,'node/%','node/%','Revisions','t','','','a:0:{}',132,'','',2,'modules/node/node.pages.inc'),('node/%/revisions/%/delete','a:2:{i:1;a:1:{s:9:\"node_load\";a:1:{i:0;i:3;}}i:3;N;}','','_node_revision_access','a:2:{i:0;i:1;i:1;s:6:\"delete\";}','drupal_get_form','a:2:{i:0;s:28:\"node_revision_delete_confirm\";i:1;i:1;}','',21,5,0,'','node/%/revisions/%/delete','Delete earlier revision','t','','','a:0:{}',6,'','',0,'modules/node/node.pages.inc'),('node/%/revisions/%/revert','a:2:{i:1;a:1:{s:9:\"node_load\";a:1:{i:0;i:3;}}i:3;N;}','','_node_revision_access','a:2:{i:0;i:1;i:1;s:6:\"update\";}','drupal_get_form','a:2:{i:0;s:28:\"node_revision_revert_confirm\";i:1;i:1;}','',21,5,0,'','node/%/revisions/%/revert','Revert to earlier revision','t','','','a:0:{}',6,'','',0,'modules/node/node.pages.inc'),('node/%/revisions/%/view','a:2:{i:1;a:1:{s:9:\"node_load\";a:1:{i:0;i:3;}}i:3;N;}','','_node_revision_access','a:1:{i:0;i:1;}','node_show','a:2:{i:0;i:1;i:1;b:1;}','',21,5,0,'','node/%/revisions/%/view','Revisions','t','','','a:0:{}',6,'','',0,''),('node/%/simplenews','a:1:{i:1;s:9:\"node_load\";}','','simplenews_node_tab_access','a:1:{i:0;i:1;}','simplenews_node_tab_page','a:1:{i:0;i:1;}','',5,3,132,'node/%','node/%','Newsletter','t','','','a:0:{}',132,'','',2,'sites/all/modules/simplenews/includes/simplenews.admin.inc'),('node/%/submission/%','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:1:{i:0;i:1;}}i:3;a:1:{s:28:\"webform_menu_submission_load\";a:1:{i:0;i:1;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_submission_access','a:3:{i:0;i:1;i:1;i:3;i:2;s:4:\"view\";}','webform_submission_page','a:3:{i:0;i:1;i:1;i:3;i:2;s:4:\"html\";}','',10,4,0,'','node/%/submission/%','Webform submission','webform_submission_title','a:2:{i:0;i:1;i:1;i:3;}','','a:0:{}',0,'','',0,'sites/all/modules/webform/includes/webform.submissions.inc'),('node/%/submission/%/delete','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:1:{i:0;i:1;}}i:3;a:1:{s:28:\"webform_menu_submission_load\";a:1:{i:0;i:1;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_submission_access','a:3:{i:0;i:1;i:1;i:3;i:2;s:6:\"delete\";}','drupal_get_form','a:3:{i:0;s:30:\"webform_submission_delete_form\";i:1;i:1;i:2;i:3;}','',21,5,1,'node/%/submission/%','node/%/submission/%','Delete','t','','','a:0:{}',132,'','',2,'sites/all/modules/webform/includes/webform.submissions.inc'),('node/%/submission/%/devel','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:1:{i:0;i:1;}}i:3;a:1:{s:28:\"webform_menu_submission_load\";a:1:{i:0;i:1;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_load_object','a:2:{i:0;s:10:\"submission\";i:1;i:3;}','',21,5,1,'node/%/submission/%','node/%/submission/%','Devel','t','','','a:0:{}',132,'','',100,'sites/all/modules/devel/devel.pages.inc'),('node/%/submission/%/devel/load','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:1:{i:0;i:1;}}i:3;a:1:{s:28:\"webform_menu_submission_load\";a:1:{i:0;i:1;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_load_object','a:2:{i:0;s:10:\"submission\";i:1;i:3;}','',43,6,1,'node/%/submission/%/devel','node/%/submission/%','Load','t','','','a:0:{}',140,'','',0,'sites/all/modules/devel/devel.pages.inc'),('node/%/submission/%/devel/token','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:1:{i:0;i:1;}}i:3;a:1:{s:28:\"webform_menu_submission_load\";a:1:{i:0;i:1;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','user_access','a:1:{i:0;s:24:\"access devel information\";}','token_devel_token_object','a:3:{i:0;s:18:\"webform-submission\";i:1;i:3;i:2;s:10:\"submission\";}','',43,6,1,'node/%/submission/%/devel','node/%/submission/%','Tokens','t','','','a:0:{}',132,'','',5,'sites/all/modules/token/token.pages.inc'),('node/%/submission/%/edit','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:1:{i:0;i:1;}}i:3;a:1:{s:28:\"webform_menu_submission_load\";a:1:{i:0;i:1;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_submission_access','a:3:{i:0;i:1;i:1;i:3;i:2;s:4:\"edit\";}','webform_submission_page','a:3:{i:0;i:1;i:1;i:3;i:2;s:4:\"form\";}','',21,5,1,'node/%/submission/%','node/%/submission/%','Edit','t','','','a:0:{}',132,'','',1,'sites/all/modules/webform/includes/webform.submissions.inc'),('node/%/submission/%/resend','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:1:{i:0;i:1;}}i:3;a:1:{s:28:\"webform_menu_submission_load\";a:1:{i:0;i:1;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_results_access','a:1:{i:0;i:1;}','drupal_get_form','a:3:{i:0;s:25:\"webform_submission_resend\";i:1;i:1;i:2;i:3;}','',21,5,0,'','node/%/submission/%/resend','Resend e-mails','t','','','a:0:{}',0,'','',0,'sites/all/modules/webform/includes/webform.submissions.inc'),('node/%/submission/%/view','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:1:{i:0;i:1;}}i:3;a:1:{s:28:\"webform_menu_submission_load\";a:1:{i:0;i:1;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_submission_access','a:3:{i:0;i:1;i:1;i:3;i:2;s:4:\"view\";}','webform_submission_page','a:3:{i:0;i:1;i:1;i:3;i:2;s:4:\"html\";}','',21,5,1,'node/%/submission/%','node/%/submission/%','View','t','','','a:0:{}',140,'','',0,'sites/all/modules/webform/includes/webform.submissions.inc'),('node/%/submissions','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_submission_access','a:3:{i:0;i:1;i:1;N;i:2;s:4:\"list\";}','webform_results_submissions','a:3:{i:0;i:1;i:1;b:1;i:2;s:2:\"50\";}','',5,3,0,'','node/%/submissions','Submissions','t','','','a:0:{}',0,'','',0,'sites/all/modules/webform/includes/webform.report.inc'),('node/%/view','a:1:{i:1;s:9:\"node_load\";}','','node_access','a:2:{i:0;s:4:\"view\";i:1;i:1;}','node_page_view','a:1:{i:0;i:1;}','',5,3,1,'node/%','node/%','View','t','','','a:0:{}',140,'','',-10,''),('node/%/webform','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_node_update_access','a:1:{i:0;i:1;}','webform_components_page','a:1:{i:0;i:1;}','',5,3,3,'node/%','node/%','Webform','t','','','a:0:{}',132,'','',1,'sites/all/modules/webform/includes/webform.components.inc'),('node/%/webform-results','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_results_access','a:1:{i:0;i:1;}','webform_results_submissions','a:3:{i:0;i:1;i:1;b:0;i:2;s:2:\"50\";}','',5,3,3,'node/%','node/%','Results','t','','','a:0:{}',132,'','',2,'sites/all/modules/webform/includes/webform.report.inc'),('node/%/webform-results/analysis','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_results_access','a:1:{i:0;i:1;}','webform_results_analysis','a:1:{i:0;i:1;}','',11,4,1,'node/%/webform-results','node/%','Analysis','t','','','a:0:{}',132,'','',5,'sites/all/modules/webform/includes/webform.report.inc'),('node/%/webform-results/analysis/%','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:2:{i:0;i:1;i:1;i:4;}}i:4;a:1:{s:27:\"webform_menu_component_load\";a:2:{i:0;i:1;i:1;i:4;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_results_access','a:1:{i:0;i:1;}','webform_results_analysis','a:3:{i:0;i:1;i:1;a:0:{}i:2;i:4;}','',22,5,1,'node/%/webform-results/analysis','node/%','Analysis','t','','','a:0:{}',132,'','',0,'sites/all/modules/webform/includes/webform.report.inc'),('node/%/webform-results/analysis/%/more','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:2:{i:0;i:1;i:1;i:4;}}i:4;a:1:{s:27:\"webform_menu_component_load\";a:2:{i:0;i:1;i:1;i:4;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_results_access','a:1:{i:0;i:1;}','webform_results_analysis','a:3:{i:0;i:1;i:1;a:0:{}i:2;i:4;}','',45,6,1,'node/%/webform-results/analysis/%','node/%','In-depth analysis','t','','','a:0:{}',140,'','',0,'sites/all/modules/webform/includes/webform.report.inc'),('node/%/webform-results/clear','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_results_clear_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:26:\"webform_results_clear_form\";i:1;i:1;}','',11,4,1,'node/%/webform-results','node/%','Clear','t','','','a:0:{}',132,'','',8,'sites/all/modules/webform/includes/webform.report.inc'),('node/%/webform-results/download','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_results_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:29:\"webform_results_download_form\";i:1;i:1;}','',11,4,1,'node/%/webform-results','node/%','Download','t','','','a:0:{}',132,'','',7,'sites/all/modules/webform/includes/webform.report.inc'),('node/%/webform-results/download-file','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_results_access','a:1:{i:0;i:1;}','webform_results_download_callback','a:1:{i:0;i:1;}','',11,4,0,'','node/%/webform-results/download-file','Download','t','','','a:0:{}',0,'','',0,'sites/all/modules/webform/includes/webform.report.inc'),('node/%/webform-results/submissions','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_results_access','a:1:{i:0;i:1;}','webform_results_submissions','a:3:{i:0;i:1;i:1;b:0;i:2;s:2:\"50\";}','',11,4,1,'node/%/webform-results','node/%','Submissions','t','','','a:0:{}',140,'','',4,'sites/all/modules/webform/includes/webform.report.inc'),('node/%/webform-results/table','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_results_access','a:1:{i:0;i:1;}','webform_results_table','a:2:{i:0;i:1;i:1;s:2:\"50\";}','',11,4,1,'node/%/webform-results','node/%','Table','t','','','a:0:{}',132,'','',6,'sites/all/modules/webform/includes/webform.report.inc'),('node/%/webform/components','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_node_update_access','a:1:{i:0;i:1;}','webform_components_page','a:1:{i:0;i:1;}','',11,4,1,'node/%/webform','node/%','Form components','t','','','a:0:{}',140,'','',0,'sites/all/modules/webform/includes/webform.components.inc'),('node/%/webform/components/%','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:2:{i:0;i:1;i:1;i:5;}}i:4;a:1:{s:27:\"webform_menu_component_load\";a:2:{i:0;i:1;i:1;i:5;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_node_update_access','a:1:{i:0;i:1;}','drupal_get_form','a:4:{i:0;s:27:\"webform_component_edit_form\";i:1;i:1;i:2;i:4;i:3;b:0;}','',22,5,1,'node/%/webform/components','node/%','','t','','','a:0:{}',132,'','',0,'sites/all/modules/webform/includes/webform.components.inc'),('node/%/webform/components/%/clone','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:2:{i:0;i:1;i:1;i:5;}}i:4;a:1:{s:27:\"webform_menu_component_load\";a:2:{i:0;i:1;i:1;i:5;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_node_update_access','a:1:{i:0;i:1;}','drupal_get_form','a:4:{i:0;s:27:\"webform_component_edit_form\";i:1;i:1;i:2;i:4;i:3;b:1;}','',45,6,1,'node/%/webform/components/%','node/%','','t','','','a:0:{}',132,'','',0,'sites/all/modules/webform/includes/webform.components.inc'),('node/%/webform/components/%/delete','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:2:{i:0;i:1;i:1;i:5;}}i:4;a:1:{s:27:\"webform_menu_component_load\";a:2:{i:0;i:1;i:1;i:5;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_node_update_access','a:1:{i:0;i:1;}','drupal_get_form','a:3:{i:0;s:29:\"webform_component_delete_form\";i:1;i:1;i:2;i:4;}','',45,6,1,'node/%/webform/components/%','node/%','','t','','','a:0:{}',132,'','',0,'sites/all/modules/webform/includes/webform.components.inc'),('node/%/webform/conditionals','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_node_update_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:25:\"webform_conditionals_form\";i:1;i:1;}','',11,4,1,'node/%/webform','node/%','Conditionals','t','','','a:0:{}',132,'','',1,'sites/all/modules/webform/includes/webform.conditionals.inc'),('node/%/webform/configure','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_node_update_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:22:\"webform_configure_form\";i:1;i:1;}','',11,4,1,'node/%/webform','node/%','Form settings','t','','','a:0:{}',132,'','',5,'sites/all/modules/webform/includes/webform.pages.inc'),('node/%/webform/emails','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_node_update_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:19:\"webform_emails_form\";i:1;i:1;}','',11,4,1,'node/%/webform','node/%','E-mails','t','','','a:0:{}',132,'','',4,'sites/all/modules/webform/includes/webform.emails.inc'),('node/%/webform/emails/%','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:1:{i:0;i:1;}}i:4;a:1:{s:23:\"webform_menu_email_load\";a:1:{i:0;i:1;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_node_update_access','a:1:{i:0;i:1;}','drupal_get_form','a:3:{i:0;s:23:\"webform_email_edit_form\";i:1;i:1;i:2;i:4;}','',22,5,1,'node/%/webform/emails','node/%','','t','','','a:0:{}',132,'','',0,'sites/all/modules/webform/includes/webform.emails.inc'),('node/%/webform/emails/%/clone','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:1:{i:0;i:1;}}i:4;a:1:{s:23:\"webform_menu_email_load\";a:1:{i:0;i:1;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_node_update_access','a:1:{i:0;i:1;}','drupal_get_form','a:4:{i:0;s:23:\"webform_email_edit_form\";i:1;i:1;i:2;i:4;i:3;b:1;}','',45,6,1,'node/%/webform/emails/%','node/%','','t','','','a:0:{}',132,'','',0,'sites/all/modules/webform/includes/webform.emails.inc'),('node/%/webform/emails/%/delete','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:1:{i:0;i:1;}}i:4;a:1:{s:23:\"webform_menu_email_load\";a:1:{i:0;i:1;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_node_update_access','a:1:{i:0;i:1;}','drupal_get_form','a:3:{i:0;s:25:\"webform_email_delete_form\";i:1;i:1;i:2;i:4;}','',45,6,1,'node/%/webform/emails/%','node/%','','t','','','a:0:{}',132,'','',0,'sites/all/modules/webform/includes/webform.emails.inc'),('node/add','','','_node_add_access','a:0:{}','node_add_page','a:0:{}','',3,2,0,'','node/add','Add content','t','','','a:0:{}',6,'','',0,'modules/node/node.pages.inc'),('node/add/article','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:7:\"article\";}','node_add','a:1:{i:0;s:7:\"article\";}','',7,3,0,'','node/add/article','Article','check_plain','','','a:0:{}',6,'Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.','',0,'modules/node/node.pages.inc'),('node/add/banner','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:6:\"banner\";}','node_add','a:1:{i:0;s:6:\"banner\";}','',7,3,0,'','node/add/banner','Banner','check_plain','','','a:0:{}',6,'','',0,'modules/node/node.pages.inc'),('node/add/page','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:4:\"page\";}','node_add','a:1:{i:0;s:4:\"page\";}','',7,3,0,'','node/add/page','Basic page','check_plain','','','a:0:{}',6,'Use <em>basic pages</em> for your static content, such as an \'About us\' page.','',0,'modules/node/node.pages.inc'),('node/add/product','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:7:\"product\";}','node_add','a:1:{i:0;s:7:\"product\";}','',7,3,0,'','node/add/product','Product','check_plain','','','a:0:{}',6,'','',0,'modules/node/node.pages.inc'),('node/add/simplenews','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:10:\"simplenews\";}','node_add','a:1:{i:0;s:10:\"simplenews\";}','',7,3,0,'','node/add/simplenews','Simplenews newsletter','check_plain','','','a:0:{}',6,'A newsletter issue to be sent to subscribed email addresses.','',0,'modules/node/node.pages.inc'),('node/add/webform','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:7:\"webform\";}','node_add','a:1:{i:0;s:7:\"webform\";}','',7,3,0,'','node/add/webform','Webform','check_plain','','','a:0:{}',6,'Create a new form or questionnaire accessible to users. Submission results and statistics are recorded and accessible to privileged users.','',0,'modules/node/node.pages.inc'),('overlay-ajax/%','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:14:\"access overlay\";}','overlay_ajax_render_region','a:1:{i:0;i:1;}','',2,2,0,'','overlay-ajax/%','','t','','','a:0:{}',0,'','',0,''),('overlay/dismiss-message','','','user_access','a:1:{i:0;s:14:\"access overlay\";}','overlay_user_dismiss_message','a:0:{}','',3,2,0,'','overlay/dismiss-message','','t','','','a:0:{}',0,'','',0,''),('products','','','views_access','a:1:{i:0;b:1;}','views_page','a:2:{i:0;s:8:\"category\";i:1;s:6:\"page_1\";}','',1,1,0,'','products','','t','','','a:0:{}',0,'','',0,''),('rss.xml','','','views_access','a:1:{i:0;b:1;}','views_page','a:2:{i:0;s:9:\"frontpage\";i:1;s:4:\"feed\";}','',1,1,0,'','rss.xml','','t','','','a:0:{}',0,'','',0,''),('search','','','search_is_active','a:0:{}','search_view','a:0:{}','',1,1,0,'','search','Search','t','','','a:0:{}',20,'','',0,'modules/search/search.pages.inc'),('search-page','','','views_access','a:1:{i:0;b:1;}','views_page','a:2:{i:0;s:6:\"search\";i:1;s:4:\"page\";}','',1,1,0,'','search-page','','t','','','a:0:{}',0,'','',0,''),('search/node','','','_search_menu_access','a:1:{i:0;s:4:\"node\";}','search_view','a:2:{i:0;s:4:\"node\";i:1;s:0:\"\";}','',3,2,1,'search','search','Content','t','','','a:0:{}',132,'','',-10,'modules/search/search.pages.inc'),('search/node/%','a:1:{i:2;a:1:{s:14:\"menu_tail_load\";a:2:{i:0;s:4:\"%map\";i:1;s:6:\"%index\";}}}','a:1:{i:2;s:16:\"menu_tail_to_arg\";}','_search_menu_access','a:1:{i:0;s:4:\"node\";}','search_view','a:2:{i:0;s:4:\"node\";i:1;i:2;}','',6,3,1,'search/node','search/node/%','Content','t','','','a:0:{}',132,'','',0,'modules/search/search.pages.inc'),('search/user','','','_search_menu_access','a:1:{i:0;s:4:\"user\";}','search_view','a:2:{i:0;s:4:\"user\";i:1;s:0:\"\";}','',3,2,1,'search','search','Users','t','','','a:0:{}',132,'','',0,'modules/search/search.pages.inc'),('search/user/%','a:1:{i:2;a:1:{s:14:\"menu_tail_load\";a:2:{i:0;s:4:\"%map\";i:1;s:6:\"%index\";}}}','a:1:{i:2;s:16:\"menu_tail_to_arg\";}','_search_menu_access','a:1:{i:0;s:4:\"user\";}','search_view','a:2:{i:0;s:4:\"user\";i:1;i:2;}','',6,3,1,'search/node','search/node/%','Users','t','','','a:0:{}',132,'','',0,'modules/search/search.pages.inc'),('select-or-other-test-form','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','drupal_get_form','a:1:{i:0;s:25:\"select_or_other_test_form\";}','',1,1,0,'','select-or-other-test-form','select_or_other test','t','','','a:0:{}',0,'','',0,''),('sites/default/files/styles/%','a:1:{i:4;s:16:\"image_style_load\";}','','1','a:0:{}','image_style_deliver','a:1:{i:0;i:4;}','',30,5,0,'','sites/default/files/styles/%','Generate image style','t','','','a:0:{}',0,'','',0,''),('system/ajax','','','1','a:0:{}','ajax_form_callback','a:0:{}','ajax_deliver',3,2,0,'','system/ajax','AHAH callback','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'includes/form.inc'),('system/files','','','1','a:0:{}','file_download','a:1:{i:0;s:7:\"private\";}','',3,2,0,'','system/files','File download','t','','','a:0:{}',0,'','',0,''),('system/files/styles/%','a:1:{i:3;s:16:\"image_style_load\";}','','1','a:0:{}','image_style_deliver','a:1:{i:0;i:3;}','',14,4,0,'','system/files/styles/%','Generate image style','t','','','a:0:{}',0,'','',0,''),('system/temporary','','','1','a:0:{}','file_download','a:1:{i:0;s:9:\"temporary\";}','',3,2,0,'','system/temporary','Temporary files','t','','','a:0:{}',0,'','',0,''),('system/timezone','','','1','a:0:{}','system_timezone','a:0:{}','',3,2,0,'','system/timezone','Time zone','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('tagclouds','','','user_access','a:1:{i:0;s:14:\"access content\";}','tagclouds_page_chunk','a:1:{i:0;N;}','',1,1,0,'','tagclouds','Tags','t','','','a:0:{}',20,'','',0,''),('tagclouds/chunk/%','a:1:{i:2;s:19:\"tagclouds_vocs_load\";}','','user_access','a:1:{i:0;s:14:\"access content\";}','tagclouds_page_chunk','a:1:{i:0;i:2;}','',6,3,0,'','tagclouds/chunk/%','Tags','t','','','a:0:{}',20,'','',0,''),('tagclouds/list/%','a:1:{i:2;s:19:\"tagclouds_vocs_load\";}','','user_access','a:1:{i:0;s:14:\"access content\";}','tagclouds_page_list','a:1:{i:0;i:2;}','',6,3,0,'','tagclouds/list/%','Tags','t','','','a:0:{}',0,'','',0,''),('taxonomy/autocomplete','','','user_access','a:1:{i:0;s:14:\"access content\";}','taxonomy_autocomplete','a:0:{}','',3,2,0,'','taxonomy/autocomplete','Autocomplete taxonomy','t','','','a:0:{}',0,'','',0,'modules/taxonomy/taxonomy.pages.inc'),('taxonomy/term/%','a:1:{i:2;N;}','','views_access','a:1:{i:0;b:1;}','views_page','a:3:{i:0;s:8:\"category\";i:1;s:4:\"page\";i:2;i:2;}','',6,3,0,'','taxonomy/term/%','','t','','','a:0:{}',0,'','',0,''),('taxonomy/term/%/devel','a:1:{i:2;s:18:\"taxonomy_term_load\";}','','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_load_object','a:3:{i:0;s:13:\"taxonomy_term\";i:1;i:2;i:2;s:4:\"term\";}','',13,4,1,'taxonomy/term/%','taxonomy/term/%','Devel','t','','','a:0:{}',132,'','',100,'sites/all/modules/devel/devel.pages.inc'),('taxonomy/term/%/devel/load','a:1:{i:2;s:18:\"taxonomy_term_load\";}','','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_load_object','a:3:{i:0;s:13:\"taxonomy_term\";i:1;i:2;i:2;s:4:\"term\";}','',27,5,1,'taxonomy/term/%/devel','taxonomy/term/%','Load','t','','','a:0:{}',140,'','',0,'sites/all/modules/devel/devel.pages.inc'),('taxonomy/term/%/devel/render','a:1:{i:2;s:18:\"taxonomy_term_load\";}','','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_render_object','a:3:{i:0;s:13:\"taxonomy_term\";i:1;i:2;i:2;s:4:\"term\";}','',27,5,1,'taxonomy/term/%/devel','taxonomy/term/%','Render','t','','','a:0:{}',132,'','',100,'sites/all/modules/devel/devel.pages.inc'),('taxonomy/term/%/devel/token','a:1:{i:2;s:18:\"taxonomy_term_load\";}','','user_access','a:1:{i:0;s:24:\"access devel information\";}','token_devel_token_object','a:2:{i:0;s:13:\"taxonomy_term\";i:1;i:2;}','',27,5,1,'taxonomy/term/%/devel','taxonomy/term/%','Tokens','t','','','a:0:{}',132,'','',5,'sites/all/modules/token/token.pages.inc'),('taxonomy/term/%/edit','a:1:{i:2;s:18:\"taxonomy_term_load\";}','','taxonomy_term_edit_access','a:1:{i:0;i:2;}','drupal_get_form','a:3:{i:0;s:18:\"taxonomy_form_term\";i:1;i:2;i:2;N;}','',13,4,1,'taxonomy/term/%','taxonomy/term/%','Edit','t','','','a:0:{}',132,'','',10,'modules/taxonomy/taxonomy.admin.inc'),('taxonomy/term/%/feed','a:1:{i:2;s:18:\"taxonomy_term_load\";}','','user_access','a:1:{i:0;s:14:\"access content\";}','taxonomy_term_feed','a:1:{i:0;i:2;}','',13,4,0,'','taxonomy/term/%/feed','Taxonomy term','taxonomy_term_title','a:1:{i:0;i:2;}','','a:0:{}',0,'','',0,'modules/taxonomy/taxonomy.pages.inc'),('taxonomy/term/%/view','a:1:{i:2;s:18:\"taxonomy_term_load\";}','','views_access','a:1:{i:0;b:1;}','views_page','a:3:{i:0;s:8:\"category\";i:1;s:4:\"page\";i:2;i:2;}','',13,4,1,'taxonomy/term/%','taxonomy/term/%','View','t','','','a:0:{}',140,'','',0,''),('today-deal','','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}','views_page','a:2:{i:0;s:12:\"today_s_deal\";i:1;s:4:\"page\";}','',1,1,0,'','today-deal','','t','','','a:0:{}',0,'','',0,''),('token/autocomplete/%','a:1:{i:2;s:15:\"token_type_load\";}','','1','a:0:{}','token_autocomplete_token','a:1:{i:0;i:2;}','',6,3,0,'','token/autocomplete/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/token/token.pages.inc'),('token/flush-cache','','','user_access','a:1:{i:0;s:12:\"flush caches\";}','token_flush_cache_callback','a:0:{}','',3,2,0,'','token/flush-cache','','t','','','a:0:{}',0,'','',0,'sites/all/modules/token/token.pages.inc'),('token/tree','','','1','a:0:{}','token_page_output_tree','a:0:{}','',3,2,0,'','token/tree','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/token/token.pages.inc'),('user','','','1','a:0:{}','user_page','a:0:{}','',1,1,0,'','user','User account','user_menu_title','','','a:0:{}',6,'','',-10,'modules/user/user.pages.inc'),('user/%','a:1:{i:1;s:9:\"user_load\";}','','user_view_access','a:1:{i:0;i:1;}','user_view_page','a:1:{i:0;i:1;}','',2,2,0,'','user/%','My account','user_page_title','a:1:{i:0;i:1;}','','a:0:{}',6,'','',0,''),('user/%/account','a:1:{i:1;s:9:\"user_load\";}','','commerce_marketplace_funds_account_page_access','a:2:{i:0;s:4:\"user\";i:1;i:1;}','commerce_marketplace_funds_account_view','a:2:{i:0;s:4:\"user\";i:1;i:1;}','',5,3,1,'user/%','user/%','','commerce_marketplace_funds_account_title','a:2:{i:0;s:4:\"user\";i:1;i:1;}','','a:0:{}',132,'','',2,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.pages.inc'),('user/%/account/transaction','a:1:{i:1;s:9:\"user_load\";}','','commerce_marketplace_funds_account_transactions_page_access','a:2:{i:0;s:4:\"user\";i:1;i:1;}','commerce_marketplace_funds_account_transactions_list','a:2:{i:0;s:4:\"user\";i:1;i:1;}','',11,4,1,'user/%/account','user/%','Account Transactions','t','','','a:0:{}',132,'','',1,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.pages.inc'),('user/%/account/transaction/new/deposit','a:1:{i:1;s:9:\"user_load\";}','','commerce_marketplace_funds_new_transaction_page_access','a:3:{i:0;s:4:\"user\";i:1;i:1;i:2;s:7:\"deposit\";}','commerce_marketplace_funds_new_deposit_transaction_page','a:3:{i:0;s:4:\"user\";i:1;i:1;i:2;s:7:\"deposit\";}','',47,6,1,'user/%/account/transaction','user/%','Make a Deposit transaction','t','','','a:0:{}',388,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.admin.inc'),('user/%/account/transaction/new/transfer','a:1:{i:1;s:9:\"user_load\";}','','commerce_marketplace_funds_new_transaction_page_access','a:3:{i:0;s:4:\"user\";i:1;i:1;i:2;s:8:\"transfer\";}','commerce_marketplace_funds_new_transfer_transaction_page','a:3:{i:0;s:4:\"user\";i:1;i:1;i:2;s:8:\"transfer\";}','',47,6,1,'user/%/account/transaction','user/%','Make a Funds transfer transaction','t','','','a:0:{}',388,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.admin.inc'),('user/%/account/transaction/new/withdraw','a:1:{i:1;s:9:\"user_load\";}','','commerce_marketplace_funds_new_transaction_page_access','a:3:{i:0;s:4:\"user\";i:1;i:1;i:2;s:8:\"withdraw\";}','drupal_get_form','a:3:{i:0;s:56:\"commerce_marketplace_funds_new_withdraw_transaction_form\";i:1;s:4:\"user\";i:2;i:1;}','',47,6,1,'user/%/account/transaction','user/%','Create withdraw request','t','','','a:0:{}',388,'','',1,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/modules/withdraw/includes/commerce_marketplace_funds_withdraw.transaction.admin.inc'),('user/%/account/view','a:1:{i:1;s:9:\"user_load\";}','','commerce_marketplace_funds_account_page_access','a:2:{i:0;s:4:\"user\";i:1;i:1;}','commerce_marketplace_funds_account_view','a:2:{i:0;s:4:\"user\";i:1;i:1;}','',11,4,1,'user/%/account','user/%','Account','t','','','a:0:{}',140,'','',-1,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/includes/commerce_marketplace_funds.pages.inc'),('user/%/account/withdraw','a:1:{i:1;s:9:\"user_load\";}','','commerce_marketplace_funds_account_withdraw_overview_access','a:2:{i:0;s:4:\"user\";i:1;i:1;}','commerce_marketplace_funds_withdraw_methods_overview_page','a:2:{i:0;s:4:\"user\";i:1;i:1;}','',11,4,1,'user/%/account','user/%','Configure withdraw methods','t','','','a:0:{}',132,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/modules/withdraw/includes/commerce_marketplace_funds_withdraw.method.admin.inc'),('user/%/account/withdraw/%','a:2:{i:1;s:9:\"user_load\";i:4;N;}','','commerce_marketplace_funds_withdraw_method_access','a:5:{i:0;s:4:\"edit\";i:1;i:4;i:2;N;i:3;s:4:\"user\";i:4;i:1;}','commerce_marketplace_funds_withdraw_method_form_wrapper','a:3:{i:0;i:4;i:1;s:4:\"user\";i:2;i:1;}','',22,5,0,'','user/%/account/withdraw/%','','commerce_marketplace_funds_withdraw_method_add_page_title','a:1:{i:0;i:4;}','','a:0:{}',6,'','',0,'sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/modules/withdraw/includes/commerce_marketplace_funds_withdraw.method.admin.inc'),('user/%/cancel','a:1:{i:1;s:9:\"user_load\";}','','user_cancel_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:24:\"user_cancel_confirm_form\";i:1;i:1;}','',5,3,0,'','user/%/cancel','Cancel account','t','','','a:0:{}',6,'','',0,'modules/user/user.pages.inc'),('user/%/cancel/confirm/%/%','a:3:{i:1;s:9:\"user_load\";i:4;N;i:5;N;}','','user_cancel_access','a:1:{i:0;i:1;}','user_cancel_confirm','a:3:{i:0;i:1;i:1;i:4;i:2;i:5;}','',44,6,0,'','user/%/cancel/confirm/%/%','Confirm account cancellation','t','','','a:0:{}',6,'','',0,'modules/user/user.pages.inc'),('user/%/devel','a:1:{i:1;s:9:\"user_load\";}','','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_load_object','a:2:{i:0;s:4:\"user\";i:1;i:1;}','',5,3,1,'user/%','user/%','Devel','t','','','a:0:{}',132,'','',100,'sites/all/modules/devel/devel.pages.inc'),('user/%/devel/load','a:1:{i:1;s:9:\"user_load\";}','','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_load_object','a:2:{i:0;s:4:\"user\";i:1;i:1;}','',11,4,1,'user/%/devel','user/%','Load','t','','','a:0:{}',140,'','',0,'sites/all/modules/devel/devel.pages.inc'),('user/%/devel/render','a:1:{i:1;s:9:\"user_load\";}','','user_access','a:1:{i:0;s:24:\"access devel information\";}','devel_render_object','a:2:{i:0;s:4:\"user\";i:1;i:1;}','',11,4,1,'user/%/devel','user/%','Render','t','','','a:0:{}',132,'','',100,'sites/all/modules/devel/devel.pages.inc'),('user/%/devel/token','a:1:{i:1;s:9:\"user_load\";}','','user_access','a:1:{i:0;s:24:\"access devel information\";}','token_devel_token_object','a:2:{i:0;s:4:\"user\";i:1;i:1;}','',11,4,1,'user/%/devel','user/%','Tokens','t','','','a:0:{}',132,'','',5,'sites/all/modules/token/token.pages.inc'),('user/%/edit','a:1:{i:1;s:9:\"user_load\";}','','user_edit_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:17:\"user_profile_form\";i:1;i:1;}','',5,3,1,'user/%','user/%','Edit','t','','','a:0:{}',132,'','',0,'modules/user/user.pages.inc'),('user/%/edit/account','a:1:{i:1;a:1:{s:18:\"user_category_load\";a:2:{i:0;s:4:\"%map\";i:1;s:6:\"%index\";}}}','','user_edit_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:17:\"user_profile_form\";i:1;i:1;}','',11,4,1,'user/%/edit','user/%','Account','t','','','a:0:{}',140,'','',0,'modules/user/user.pages.inc'),('user/%/edit/simplenews','a:1:{i:1;a:1:{s:18:\"user_category_load\";a:2:{i:0;s:4:\"%map\";i:1;s:6:\"%index\";}}}','','simplenews_subscription_edit_access','a:1:{i:0;i:1;}','drupal_get_form','a:3:{i:0;s:17:\"user_profile_form\";i:1;i:1;i:2;i:3;}','',11,4,1,'user/%/edit','user/%','','check_plain','a:1:{i:0;s:11:\"Newsletters\";}','','a:0:{}',132,'','',10,'modules/user/user.pages.inc'),('user/%/imce','a:1:{i:1;s:9:\"user_load\";}','','imce_user_page_access','a:1:{i:0;i:1;}','imce_user_page','a:1:{i:0;i:1;}','',5,3,1,'user/%','user/%','File browser','t','','','a:0:{}',132,'','',10,'sites/all/modules/imce/inc/imce.page.inc'),('user/%/orders','a:1:{i:1;a:1:{s:14:\"views_arg_load\";a:3:{i:0;s:20:\"commerce_user_orders\";i:1;s:10:\"order_page\";i:2;s:6:\"%index\";}}}','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:32:\"view own commerce_order entities\";}}}','views_page','a:3:{i:0;s:20:\"commerce_user_orders\";i:1;s:10:\"order_page\";i:2;i:1;}','',5,3,1,'user/%','user/%','Orders','t','','','a:0:{}',132,'','',15,''),('user/%/orders/%','a:2:{i:1;s:9:\"user_load\";i:3;s:19:\"commerce_order_load\";}','','commerce_order_customer_order_view_access','a:1:{i:0;i:3;}','commerce_order_ui_order_view','a:2:{i:0;i:3;i:1;s:8:\"customer\";}','',10,4,0,'','user/%/orders/%','','commerce_order_ui_order_title','a:1:{i:0;i:3;}','','a:0:{}',6,'','',0,''),('user/%/orders/%/edit','a:2:{i:1;s:9:\"user_load\";i:3;s:19:\"commerce_order_load\";}','','1','a:0:{}','drupal_get_form','a:2:{i:0;s:25:\"commerce_order_order_form\";i:1;i:3;}','',21,5,1,'user/%/orders/%','user/%/orders/%','Edit','t','','','a:0:{}',388,'','',0,'sites/all/modules/commerce/modules/order//includes/commerce_order.forms.inc'),('user/%/shortcuts','a:1:{i:1;s:9:\"user_load\";}','','shortcut_set_switch_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:19:\"shortcut_set_switch\";i:1;i:1;}','',5,3,1,'user/%','user/%','Shortcuts','t','','','a:0:{}',132,'','',0,'modules/shortcut/shortcut.admin.inc'),('user/%/stores','a:1:{i:1;s:9:\"user_load\";}','','commerce_marketplace_user_stores_access','a:1:{i:0;i:1;}','commerce_marketplace_user_stores','a:1:{i:0;i:1;}','',5,3,1,'user/%','user/%','Stores','t','','','a:0:{}',132,'','',0,''),('user/%/view','a:1:{i:1;s:9:\"user_load\";}','','user_view_access','a:1:{i:0;i:1;}','user_view_page','a:1:{i:0;i:1;}','',5,3,1,'user/%','user/%','View','t','','','a:0:{}',140,'','',-10,''),('user/autocomplete','','','user_access','a:1:{i:0;s:20:\"access user profiles\";}','user_autocomplete','a:0:{}','',3,2,0,'','user/autocomplete','User autocomplete','t','','','a:0:{}',0,'','',0,'modules/user/user.pages.inc'),('user/login','','','user_is_anonymous','a:0:{}','user_page','a:0:{}','',3,2,1,'user','user','Log in','t','','','a:0:{}',140,'','',0,'modules/user/user.pages.inc'),('user/logout','','','user_is_logged_in','a:0:{}','user_logout','a:0:{}','',3,2,0,'','user/logout','Log out','t','','','a:0:{}',6,'','',10,'modules/user/user.pages.inc'),('user/password','','','1','a:0:{}','drupal_get_form','a:1:{i:0;s:9:\"user_pass\";}','',3,2,1,'user','user','Request new password','t','','','a:0:{}',132,'','',0,'modules/user/user.pages.inc'),('user/register','','','user_register_access','a:0:{}','drupal_get_form','a:1:{i:0;s:18:\"user_register_form\";}','',3,2,1,'user','user','Create new account','t','','','a:0:{}',132,'','',0,''),('user/reset/%/%/%','a:3:{i:2;N;i:3;N;i:4;N;}','','1','a:0:{}','drupal_get_form','a:4:{i:0;s:15:\"user_pass_reset\";i:1;i:2;i:2;i:3;i:3;i:4;}','',24,5,0,'','user/reset/%/%/%','Reset password','t','','','a:0:{}',0,'','',0,'modules/user/user.pages.inc'),('views/ajax','','','1','a:0:{}','views_ajax','a:0:{}','ajax_deliver',3,2,0,'','views/ajax','Views','t','','ajax_base_page_theme','a:0:{}',0,'Ajax callback for view loading.','',0,'sites/all/modules/views/includes/ajax.inc'),('webform/ajax/options/%','a:1:{i:3;a:1:{s:17:\"webform_menu_load\";a:1:{i:0;i:3;}}}','a:1:{i:3;s:19:\"webform_menu_to_arg\";}','webform_node_update_access','a:1:{i:0;i:3;}','webform_select_options_ajax','a:0:{}','',14,4,0,'','webform/ajax/options/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/webform/components/select.inc'),('webform/autocomplete','','','user_access','a:1:{i:0;s:16:\"administer views\";}','webform_views_autocomplete','a:0:{}','',3,2,0,'','webform/autocomplete','Webforms','t','','','a:0:{}',0,'','',0,'sites/all/modules/webform/views/webform.views.inc'),('weight','','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:18:\"assign node weight\";}}}','views_page','a:2:{i:0;s:6:\"weight\";i:1;s:4:\"page\";}','',1,1,0,'','weight','','t','','','a:0:{}',0,'','',0,''),('withdraw_method/%cmp_funds_withdraw_method','','','commerce_marketplace_funds_withdraw_method_access','a:2:{i:0;s:4:\"view\";i:1;i:1;}','commerce_marketplace_funds_withdraw_method_page_view','a:1:{i:0;i:1;}','',3,2,0,'','withdraw_method/%cmp_funds_withdraw_method','','commerce_marketplace_funds_withdraw_method_page_title','a:1:{i:0;i:1;}','','a:0:{}',0,'','',0,'');
/*!40000 ALTER TABLE `menu_router` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `menu_token`
--

DROP TABLE IF EXISTS `menu_token`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menu_token` (
  `mlid` int(10) unsigned NOT NULL COMMENT 'The menu link menu_links.mlid',
  `link_path` varchar(255) NOT NULL DEFAULT '' COMMENT 'The actual path with tokens',
  PRIMARY KEY (`mlid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Menu token properties';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menu_token`
--

LOCK TABLES `menu_token` WRITE;
/*!40000 ALTER TABLE `menu_token` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `menu_token` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node`
--

DROP TABLE IF EXISTS `node`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node` (
  `nid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a node.',
  `vid` int(10) unsigned DEFAULT NULL COMMENT 'The current node_revision.vid version identifier.',
  `type` varchar(32) NOT NULL DEFAULT '' COMMENT 'The node_type.type of this node.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'The languages.language of this node.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title of this node, always treated as non-markup plain text.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that owns this node; initially, this is the user that created it.',
  `status` int(11) NOT NULL DEFAULT '1' COMMENT 'Boolean indicating whether the node is published (visible to non-administrators).',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the node was created.',
  `changed` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the node was most recently saved.',
  `comment` int(11) NOT NULL DEFAULT '0' COMMENT 'Whether comments are allowed on this node: 0 = no, 1 = closed (read only), 2 = open (read/write).',
  `promote` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the node should be displayed on the front page.',
  `sticky` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the node should be displayed at the top of lists in which it appears.',
  `tnid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The translation set id for this node, which equals the node id of the source post in each set.',
  `translate` int(11) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this translation page needs to be updated.',
  PRIMARY KEY (`nid`),
  UNIQUE KEY `vid` (`vid`),
  KEY `node_changed` (`changed`),
  KEY `node_created` (`created`),
  KEY `node_frontpage` (`promote`,`status`,`sticky`,`created`),
  KEY `node_status_type` (`status`,`type`,`nid`),
  KEY `node_title_type` (`title`,`type`(4)),
  KEY `node_type` (`type`(4)),
  KEY `uid` (`uid`),
  KEY `tnid` (`tnid`),
  KEY `translate` (`translate`),
  KEY `language` (`language`)
) ENGINE=InnoDB AUTO_INCREMENT=144 DEFAULT CHARSET=utf8 COMMENT='The base table for nodes.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node`
--

LOCK TABLES `node` WRITE;
/*!40000 ALTER TABLE `node` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `node` VALUES (7,7,'banner','und','BlueAnt PUMP HD Wireless Bluetooth Waterproof Headphones',1,1,1416296517,1420433246,1,1,0,0,0),(8,8,'banner','und','Banner 2',1,1,1416297259,1420433163,1,1,0,0,0),(11,11,'banner','und','Feature FireTv',1,1,1416545441,1417492603,1,1,1,0,0),(12,12,'banner','und','Driver Smarter',1,1,1416545494,1417492689,1,1,1,0,0),(13,13,'banner','und','The Living Room',1,1,1416545527,1418973719,1,1,1,0,0),(14,14,'banner','und','Get 20% off instantly',1,1,1416545629,1419633551,1,1,0,0,0),(16,16,'page','und','Payment & Pricing ',1,1,1416822894,1417171117,1,0,0,0,0),(17,17,'page','und','How to buy',1,1,1416822941,1418113435,1,0,0,0,0),(18,18,'page','und','Shipping & Pickup',1,1,1416823034,1417404441,1,0,0,0,0),(19,19,'page','und','Returns & Refunds ',1,1,1416823188,1417171213,1,0,0,0,0),(20,20,'page','und','Order Status',1,1,1416823305,1416823305,1,0,0,0,0),(21,21,'page','und','About Marketplace',1,1,1416823399,1416823399,1,0,0,0,0),(22,22,'page','und','Afﬁliate Program',1,1,1416823711,1418986477,1,0,0,0,0),(23,23,'page','und','Terms & Conditions',1,1,1416823770,1416823770,1,0,0,0,0),(24,24,'page','und','Privacy Policy',1,1,1416823830,1416989379,1,0,0,0,0),(26,26,'page','und','Sell on Marketplace',1,1,1416823940,1418986672,1,0,0,0,0),(27,27,'page','und','About Us',1,1,1416899475,1416987088,1,0,0,0,0),(28,28,'webform','und','Contact Us',1,1,1417071223,1426653260,1,0,0,0,0),(29,29,'page','und','How can we help?',1,1,1417403784,1417406756,1,0,0,0,0),(30,30,'product','und','Aeroline Casual Hiking Backpack Dark Blue',1,1,1417426925,1419501346,2,1,0,0,0),(31,31,'product','und','Local Lion Water Resistant Hiking Backpack Bag 28L Blue',1,1,1417445005,1418359627,2,1,0,0,0),(32,32,'product','und','Terminus T02-297LAP-01 Laptop Backpack Plus',1,1,1417446223,1418358737,2,0,0,0,0),(33,33,'product','und','Targus Tsb166Ap 15.6In Revolution Backpack Xl',1,1,1417447402,1418358891,2,1,0,0,0),(34,34,'product','und','Tarantula Shoe Bag (BOS04-088SHB-03) - Red',1,1,1417478826,1418360139,2,0,0,0,0),(35,35,'product','und','Diniwell Water-Resistant Travel Shoes Bag Pouch Organizer Bag Ver 2 - Orange',1,1,1417481146,1418359064,2,0,0,0,0),(36,36,'product','und','24-Piece Makeup Brush Set',1,1,1417504200,1418353548,2,0,0,0,0),(37,37,'product','und','Cameleon MakeUp Kit 396',1,1,1417504583,1418353776,2,1,0,0,0),(38,38,'product','und','4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner',1,1,1417508779,1417594591,2,0,0,0,0),(39,39,'product','und','SK-II 5-Piece Skincare Travel Set 5pcs Travel Packs SKII SK2',1,1,1417509360,1419501285,2,0,0,0,0),(40,40,'product','und','Organic Eye Cream 15ml',1,1,1417510355,1418353842,2,0,0,0,0),(41,41,'product','und','Mejikaliner Quick Eyelid Essence Stick Glue - Night Use',1,1,1417511293,1417597485,2,0,0,0,0),(42,42,'product','und','Hairscape 1800W (AUS) 5000 Professional Hair Dryer',1,1,1417511809,1418353962,2,0,0,0,0),(43,43,'product','und','Tonific Slimming Massager',1,1,1417512093,1418352829,2,0,0,0,0),(44,44,'product','und','Apple iPhone 6 16GB Gold',1,1,1417513096,1418354130,2,1,0,0,0),(45,45,'product','und','Samsung N910 Note 4 LTE 32GB White',1,1,1417513689,1418715439,2,1,0,0,0),(46,46,'product','und','Asus Transformer P1801-B041K AIO 18.4\" PC Dekstop + Asus RT-N56U Wireless N N600 Dual-Band Gigabit Router',1,1,1417515301,1426216822,2,1,0,0,0),(47,47,'product','und','Lenovo A316',1,1,1417515888,1418354497,2,0,0,0,0),(48,48,'product','und','Nokia Asha 206 Dual SIM Black',1,1,1417517324,1418352185,2,0,0,0,0),(49,49,'product','und','Apple IPAD 3 Wi-Fi+4G MD368 64GB Black',1,1,1417518185,1418351813,2,0,0,0,0),(50,50,'product','und','Asus Memopad 7 (Tablet)',1,1,1417518819,1418354598,2,0,0,0,0),(51,51,'product','und','Lenovo Tablet Miix 2 59399848 8\" Silver',1,1,1417528583,1426216927,2,1,0,0,0),(52,52,'product','und','Apple iPad Air 16GB WiFi Space Grey (MD785ZPA)',1,1,1417530153,1418352025,2,1,0,0,0),(53,53,'product','und','Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold',1,1,1417530854,1418354720,2,0,0,0,0),(54,54,'product','und','[GENUINE] SAMSUNG Galaxy Note 4 S View Classic Cover Case - Black',1,1,1417531758,1418354776,2,0,0,0,0),(55,55,'product','und','Samsung Galaxy Tab 7.0 Plus Vehicle Dock With In-Car Charger',1,1,1417532298,1418354819,2,0,0,0,0),(56,56,'product','und','Angel Universal Mobile Phone In Car Phone Holder 360 degree Item Code: P338',1,1,1417533303,1418354894,2,0,0,0,0),(57,57,'product','und','Original Apple Earpod Earphone with Remote & Mic for iPhone iPad iPod',1,1,1417573407,1418354984,2,0,0,0,0),(58,58,'product','und','Sony Stereo Bluetooth Headset SBH20 Black',1,1,1417576765,1418352069,2,0,0,0,0),(59,59,'product','und','TOP Mi 10400mAh Powerbank - Black',1,1,1417577778,1418355051,2,0,0,0,0),(60,60,'product','und','Universal Dual-Port Power Bank 20000mAh Black',1,1,1417578198,1418355115,2,0,0,0,0),(61,61,'product','und','MuWo Trendz Swarovski Element White Gold Plated Everlasting Love Set',1,1,1417578593,1418355175,2,0,0,0,0),(62,62,'product','und','LUCCACAL Multi Color Tribal Necklace',1,1,1417578986,1417594948,2,0,0,0,0),(63,63,'product','und','Dandelion Women Braided Belt White',1,1,1417579652,1418355239,2,0,0,0,0),(64,64,'product','und','Dandelion Cross Stitch Belt Orange',1,1,1417579912,1417594868,2,0,0,0,0),(65,65,'product','und','Fur Nyce Big Square Classic Chain Pattern Print Scarf',1,1,1417580590,1418355292,2,0,0,0,0),(66,66,'product','und','Fur Nyce Fashion Zebra Pattern Print Scarf White',1,1,1417580757,1418355487,2,0,0,0,0),(67,67,'product','und','Invicta Pro Diver Men Black Stainless Steel Strap Watch 15422',1,1,1417581463,1417594778,2,0,0,0,0),(68,68,'product','und','Rolex Submariner Black Dial Stainless Steel Automatic Mens Watch 114060',1,1,1417581629,1418355650,2,1,0,0,0),(69,69,'product','und','SUUNTO VECTOR BLACK SUSS010600610 MOUNTAIN OUTDOOR WATCH ',1,1,1417582273,1418355696,2,0,0,0,0),(70,70,'product','und','SKMEI 0955 30m Waterproof Analogue Digital Dual Time Men\'s Sports Watch Black + Green',1,1,1417582520,1418355936,2,0,0,0,0),(71,71,'product','und','Samsung 4\'\' Full HD LED TV - UA40H5008ARXXM Series 5',1,1,1417587476,1426216629,2,1,0,0,0),(72,72,'product','und','Sony 48\" Full HD LED TV - BRAVIA Model KDL-48R470B',1,1,1417587699,1426216590,2,1,0,0,0),(73,73,'product','und','Sony BDV-N9200W 9.1 Cinema Studio 3D Blu-Ray Disc home Theatre System',1,1,1417588138,1418356710,2,0,0,0,0),(74,74,'product','und','Samsung HT-E350K DVD Home Theater System',1,1,1417588401,1417594395,2,0,0,0,0),(75,75,'product','und','L12S OLED Smart Watch Bluetooth 3.0 Bracelet Wrist Design for IOS Android iPhone Samsung Smart Phone Blue',1,1,1417588949,1417594269,2,0,0,0,0),(76,76,'product','und','ORI Apple TV',1,1,1417589262,1417594234,2,0,0,0,0),(77,77,'product','und','Dell Alienware X51-77822G Gaming Desktop',1,1,1417590261,1418358045,2,1,0,0,0),(78,78,'product','und','3 Port HDMI Switch With Remote Control',1,1,1417591448,1418358116,2,0,0,0,0),(79,79,'product','und','Dell PowerConnect 5524P 24 GbE Port Managed L2 Switch with PoE support 10GbE and Stacking Capable',1,1,1417591728,1418358205,2,0,0,0,0),(80,80,'product','und','TP-Link M5250 N900 3G Mobile WiFi Black',1,1,1417592574,1418358277,2,0,0,0,0),(81,81,'product','und','TP-LINK N750 Wireless Dual Band Gigabit Router TL-WDR4300 Black',1,1,1417592796,1418358332,2,0,0,0,0),(82,82,'product','und','Canon LiDE 210 Scanner',1,1,1417598912,1418353325,2,0,0,0,0),(83,83,'product','und','Epson Perfection V33 Scanner',1,1,1417599162,1418353195,2,0,0,0,0),(84,84,'product','und','CASIO Exilim EX-ZR1500 Digital Camera Pink',1,1,1417599720,1418353115,2,0,0,0,0),(85,85,'product','und','Canon PowerShot SX60 HS 16.1MP Black + 8GB + Case',1,1,1417600163,1418029308,2,0,0,0,0),(86,86,'product','und','Canon EOS 600D 18MP + 18-55mm Lens',1,1,1417600767,1418352963,2,0,0,0,0),(87,87,'banner','und','Face Care',1,1,1417666125,1418718447,1,0,0,0,0),(88,88,'product','und','Samsung Smart Camera NX Mini 20.5MP Green + 9mm Lens + 16 GB Memory Card',1,1,1418365242,1418365269,2,0,0,0,0),(89,89,'product','und','Nikon AF-S 50mm Lens f/1.8G',1,1,1418365650,1418365650,2,0,0,0,0),(90,90,'product','und','Canon EF-S Lens 18-200mm f/3.5-5.6 IS',1,1,1418366198,1418366198,2,1,0,0,0),(91,91,'product','und','Cokin U961A Z Pro Grad Kit - Z Filter Holder + Z121L + Z123L + Z125L',1,1,1418366731,1418366856,2,0,0,0,0),(92,92,'product','und','D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera',1,1,1418367347,1418370702,2,0,0,0,0),(93,93,'product','und','CCTV- 850TVL IR DOME CCTV CAMERA ',1,1,1418368416,1418369954,2,0,0,0,0),(94,94,'product','und','Trek Ai-Ball Portable Wi-Fi Remote Camera with Cradle & Adaptors (Yellow)',1,1,1418369205,1418369928,2,0,0,0,0),(95,95,'product','und','Mini Quran for Kids Yellow',1,1,1418370240,1418370240,2,0,0,0,0),(96,96,'product','und','Boogie Board 10.5 Inch LCD Writing Tablet Pink',1,1,1418370758,1418370810,2,0,0,0,0),(97,97,'product','und','Transporter Carry Cot',1,1,1418371223,1418371252,2,0,0,0,0),(98,98,'banner','und','Educational Toys',1,1,1418374047,1418375876,1,0,0,0,0),(99,99,'banner','und','Books & Stationery',1,1,1418375179,1418375218,1,0,0,0,0),(100,100,'banner','und','Health & Safety',1,1,1418375406,1418375406,1,0,0,0,0),(101,101,'banner','und','Backpacks',1,1,1418376994,1418376994,1,0,0,0,0),(102,102,'banner','und','Shoe Bags',1,1,1418377770,1418377770,1,0,0,0,0),(103,103,'banner','und','Makeup',1,1,1418378499,1418378499,1,0,0,0,0),(104,104,'banner','und','Eye Care',1,1,1418378630,1418378630,1,0,0,0,0),(105,105,'banner','und','Health & Beauty Tools',1,1,1418378759,1418378767,1,0,0,0,0),(106,106,'banner','und','Food Supplements',1,1,1418379045,1418379130,1,0,0,0,0),(107,107,'banner','und','Basic Phones',1,1,1418379647,1418380438,1,0,0,0,0),(108,108,'banner','und','Car Accessories',1,1,1418379782,1418380250,1,0,0,0,0),(109,109,'banner','und','Cases & Covers',1,1,1418379877,1418722570,1,0,0,0,0),(110,110,'banner','und','Smartphones',1,1,1418380566,1418789320,1,0,0,0,0),(111,111,'banner','und','With call facility',1,1,1418380893,1418380893,1,0,0,0,0),(112,112,'banner','und','Without call facility',1,1,1418381108,1418381108,1,0,0,0,0),(113,113,'banner','und','Headphones',1,1,1418381515,1418723723,1,0,0,0,0),(114,114,'banner','und','Batteries & Chargers',1,1,1418381604,1418381604,1,0,0,0,0),(115,115,'banner','und','Women\'s Jewellery',1,1,1418632088,1418632318,1,0,0,0,0),(116,116,'banner','und','Belts',1,1,1418632181,1418632296,1,0,0,0,0),(117,117,'banner','und','Scarves',1,1,1418632414,1418632414,1,0,0,0,0),(118,118,'banner','und','Business',1,1,1418632547,1418632547,1,0,0,0,0),(119,119,'banner','und','Sports',1,1,1418632627,1418632627,1,0,0,0,0),(120,120,'banner','und','Televisions',1,1,1418638559,1418638559,1,0,0,0,0),(121,121,'banner','und','Home Audio',1,1,1418638692,1418638692,1,0,0,0,0),(122,122,'banner','und','Gadgets',1,1,1418639070,1418639070,1,0,0,0,0),(123,123,'banner','und','Laptops',1,1,1418640832,1418641090,1,0,0,0,0),(124,124,'banner','und','Desktop',1,1,1418641175,1418641175,1,0,0,0,0),(125,125,'banner','und','Switches',1,1,1418641282,1418641282,1,0,0,0,0),(126,126,'banner','und','Routers',1,1,1418641404,1418641404,1,0,0,0,0),(127,127,'banner','und','Scanners',1,1,1418641523,1418641523,1,0,0,0,0),(128,128,'banner','und','Point & Shoot Cameras',1,1,1418701080,1418701080,1,0,0,0,0),(129,129,'banner','und','DSLR/SLR Cameras',1,1,1418701197,1418701197,1,0,0,0,0),(130,130,'banner','und','Filters',1,1,1418701300,1418701300,1,0,0,0,0),(131,131,'banner','und','Lenses',1,1,1418701389,1418701389,1,0,0,0,0),(132,132,'banner','und','IP Cameras',1,1,1418701500,1418701500,1,0,0,0,0),(133,133,'banner','und','Car Cameras',1,1,1418701663,1418701663,1,0,0,0,0),(134,134,'banner','und','Laptop Bags & Cases',1,1,1418704961,1418704961,1,0,0,0,0),(135,135,'banner','und','Asus',1,1,1418789083,1418789357,1,0,0,0,0),(136,136,'banner','und','Rolex',1,1,1418789989,1418789989,1,0,0,0,0),(137,137,'banner','und','Canon',1,1,1418790897,1418984102,1,0,0,0,0),(138,138,'product','und','Kinohimitsu J\'pan BB Drink 50ml x 10',1,1,1418884808,1418884808,2,0,0,0,0),(139,139,'product','und','TKO Fat Burner Mega',1,1,1418885579,1419219331,2,0,0,0,0),(140,140,'banner','und','Filters',1,1,1418895744,1418896269,1,0,0,0,0),(141,141,'page','und','404-page',1,1,1418971049,1418974786,1,0,0,0,0),(142,142,'banner','und','Black Friday',1,1,1419477032,1420432986,1,1,0,0,0),(143,143,'page','en','Get 20% off instantly',1,1,1419633533,1419633533,1,0,0,0,0);
/*!40000 ALTER TABLE `node` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_access`
--

DROP TABLE IF EXISTS `node_access`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_access` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid this record affects.',
  `gid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The grant ID a user must possess in the specified realm to gain this row’s privileges on the node.',
  `realm` varchar(255) NOT NULL DEFAULT '' COMMENT 'The realm in which the user must possess the grant ID. Each node access node can define one or more realms.',
  `grant_view` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether a user with the realm/grant pair can view this node.',
  `grant_update` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether a user with the realm/grant pair can edit this node.',
  `grant_delete` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether a user with the realm/grant pair can delete this node.',
  PRIMARY KEY (`nid`,`gid`,`realm`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Identifies which realm/grant pairs a user must possess in...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_access`
--

LOCK TABLES `node_access` WRITE;
/*!40000 ALTER TABLE `node_access` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `node_access` VALUES (0,0,'all',1,0,0);
/*!40000 ALTER TABLE `node_access` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_class`
--

DROP TABLE IF EXISTS `node_class`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_class` (
  `nid` varchar(32) NOT NULL,
  `css_class` varchar(255) NOT NULL DEFAULT '' COMMENT 'String containing the classes for the block.',
  PRIMARY KEY (`nid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_class`
--

LOCK TABLES `node_class` WRITE;
/*!40000 ALTER TABLE `node_class` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `node_class` VALUES ('100',''),('101',''),('102',''),('103',''),('104',''),('105',''),('106',''),('107',''),('108',''),('109',''),('11',''),('110',''),('111',''),('112',''),('113',''),('114',''),('115',''),('116',''),('117',''),('118',''),('119',''),('12',''),('120',''),('121',''),('122',''),('123',''),('124',''),('125',''),('126',''),('127',''),('128',''),('129',''),('13',''),('130',''),('131',''),('132',''),('133',''),('134',''),('135',''),('136',''),('137',''),('138',''),('139',''),('14',''),('140',''),('141',''),('142',''),('143',''),('16',''),('17',''),('18',''),('19',''),('22',''),('26',''),('28','contact-us'),('29',''),('30',''),('31',''),('32',''),('33',''),('34',''),('35',''),('36',''),('37',''),('38',''),('39',''),('40',''),('41',''),('42',''),('43',''),('44',''),('45',''),('46',''),('47',''),('48',''),('49',''),('50',''),('51',''),('52',''),('53',''),('54',''),('55',''),('56',''),('57',''),('58',''),('59',''),('60',''),('61',''),('62',''),('63',''),('64',''),('65',''),('66',''),('67',''),('68',''),('69',''),('7',''),('70',''),('71',''),('72',''),('73',''),('74',''),('75',''),('76',''),('77',''),('78',''),('79',''),('8',''),('80',''),('81',''),('82',''),('83',''),('84',''),('85',''),('86',''),('87',''),('88',''),('89',''),('90',''),('91',''),('92',''),('93',''),('94',''),('95',''),('96',''),('97',''),('98',''),('99','');
/*!40000 ALTER TABLE `node_class` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_comment_statistics`
--

DROP TABLE IF EXISTS `node_comment_statistics`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_comment_statistics` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid for which the statistics are compiled.',
  `cid` int(11) NOT NULL DEFAULT '0' COMMENT 'The comment.cid of the last comment.',
  `last_comment_timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp of the last comment that was posted within this node, from comment.changed.',
  `last_comment_name` varchar(60) DEFAULT NULL COMMENT 'The name of the latest author to post a comment on this node, from comment.name.',
  `last_comment_uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The user ID of the latest author to post a comment on this node, from comment.uid.',
  `comment_count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The total number of comments on this node.',
  PRIMARY KEY (`nid`),
  KEY `node_comment_timestamp` (`last_comment_timestamp`),
  KEY `comment_count` (`comment_count`),
  KEY `last_comment_uid` (`last_comment_uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Maintains statistics of node and comments posts to show ...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_comment_statistics`
--

LOCK TABLES `node_comment_statistics` WRITE;
/*!40000 ALTER TABLE `node_comment_statistics` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `node_comment_statistics` VALUES (7,0,1416296517,NULL,1,0),(8,0,1416297259,NULL,1,0),(11,0,1416545441,NULL,1,0),(12,0,1416545494,NULL,1,0),(13,0,1416545527,NULL,1,0),(14,0,1416545629,NULL,1,0),(16,0,1416822894,NULL,1,0),(17,0,1416822941,NULL,1,0),(18,0,1416823034,NULL,1,0),(19,0,1416823188,NULL,1,0),(20,0,1416823305,NULL,1,0),(21,0,1416823399,NULL,1,0),(22,0,1416823711,NULL,1,0),(23,0,1416823770,NULL,1,0),(24,0,1416823830,NULL,1,0),(26,0,1416823940,NULL,1,0),(27,0,1416899475,NULL,1,0),(28,0,1417071223,NULL,1,0),(29,0,1417403784,NULL,1,0),(30,0,1417426925,NULL,1,0),(31,0,1417445005,NULL,1,0),(32,0,1417446223,NULL,1,0),(33,0,1417447402,NULL,1,0),(34,0,1417478826,NULL,1,0),(35,0,1417481146,NULL,1,0),(36,0,1417504200,NULL,1,0),(37,0,1417504583,NULL,1,0),(38,0,1417508779,NULL,1,0),(39,0,1417509360,NULL,1,0),(40,0,1417510355,NULL,1,0),(41,0,1417511293,NULL,1,0),(42,0,1417511809,NULL,1,0),(43,0,1417512093,NULL,1,0),(44,0,1417513096,NULL,1,0),(45,0,1417513689,NULL,1,0),(46,0,1417515301,NULL,1,0),(47,0,1417515888,NULL,1,0),(48,0,1417517324,NULL,1,0),(49,0,1417518185,NULL,1,0),(50,0,1417518819,NULL,1,0),(51,0,1417528583,NULL,1,0),(52,2,1418109733,'',1,1),(53,0,1417530854,NULL,1,0),(54,0,1417531758,NULL,1,0),(55,0,1417532298,NULL,1,0),(56,0,1417533303,NULL,1,0),(57,0,1417573407,NULL,1,0),(58,0,1417576765,NULL,1,0),(59,0,1417577778,NULL,1,0),(60,0,1417578198,NULL,1,0),(61,0,1417578593,NULL,1,0),(62,0,1417578986,NULL,1,0),(63,0,1417579652,NULL,1,0),(64,0,1417579912,NULL,1,0),(65,0,1417580590,NULL,1,0),(66,0,1417580757,NULL,1,0),(67,0,1417581463,NULL,1,0),(68,0,1417581629,NULL,1,0),(69,0,1417582273,NULL,1,0),(70,0,1417582520,NULL,1,0),(71,0,1417587476,NULL,1,0),(72,0,1417587699,NULL,1,0),(73,0,1417588138,NULL,1,0),(74,0,1417588401,NULL,1,0),(75,0,1417588949,NULL,1,0),(76,0,1417589262,NULL,1,0),(77,0,1417590261,NULL,1,0),(78,0,1417591448,NULL,1,0),(79,0,1417591728,NULL,1,0),(80,0,1417592574,NULL,1,0),(81,0,1417592796,NULL,1,0),(82,0,1417598912,NULL,1,0),(83,0,1417599162,NULL,1,0),(84,0,1417599720,NULL,1,0),(85,0,1417600163,NULL,1,0),(86,0,1417600767,NULL,1,0),(87,0,1417666125,NULL,1,0),(88,0,1418365242,NULL,1,0),(89,0,1418365650,NULL,1,0),(90,0,1418366198,NULL,1,0),(91,0,1418366731,NULL,1,0),(92,0,1418367347,NULL,1,0),(93,0,1418368416,NULL,1,0),(94,0,1418369205,NULL,1,0),(95,0,1418370240,NULL,1,0),(96,0,1418370758,NULL,1,0),(97,0,1418371223,NULL,1,0),(98,0,1418374047,NULL,1,0),(99,0,1418375179,NULL,1,0),(100,0,1418375406,NULL,1,0),(101,0,1418376994,NULL,1,0),(102,0,1418377770,NULL,1,0),(103,0,1418378499,NULL,1,0),(104,0,1418378630,NULL,1,0),(105,0,1418378759,NULL,1,0),(106,0,1418379045,NULL,1,0),(107,0,1418379647,NULL,1,0),(108,0,1418379782,NULL,1,0),(109,0,1418379877,NULL,1,0),(110,0,1418380566,NULL,1,0),(111,0,1418380893,NULL,1,0),(112,0,1418381108,NULL,1,0),(113,0,1418381515,NULL,1,0),(114,0,1418381604,NULL,1,0),(115,0,1418632088,NULL,1,0),(116,0,1418632181,NULL,1,0),(117,0,1418632414,NULL,1,0),(118,0,1418632547,NULL,1,0),(119,0,1418632627,NULL,1,0),(120,0,1418638559,NULL,1,0),(121,0,1418638692,NULL,1,0),(122,0,1418639070,NULL,1,0),(123,0,1418640832,NULL,1,0),(124,0,1418641175,NULL,1,0),(125,0,1418641282,NULL,1,0),(126,0,1418641404,NULL,1,0),(127,0,1418641523,NULL,1,0),(128,0,1418701080,NULL,1,0),(129,0,1418701197,NULL,1,0),(130,0,1418701300,NULL,1,0),(131,0,1418701389,NULL,1,0),(132,0,1418701500,NULL,1,0),(133,0,1418701663,NULL,1,0),(134,0,1418704961,NULL,1,0),(135,0,1418789083,NULL,1,0),(136,0,1418789989,NULL,1,0),(137,0,1418790897,NULL,1,0),(138,0,1418884808,NULL,1,0),(139,0,1418885579,NULL,1,0),(140,0,1418895744,NULL,1,0),(141,0,1418971049,NULL,1,0),(142,0,1419477032,NULL,1,0),(143,0,1419633533,NULL,1,0);
/*!40000 ALTER TABLE `node_comment_statistics` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_revision`
--

DROP TABLE IF EXISTS `node_revision`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_revision` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node this version belongs to.',
  `vid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for this version.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that created this version.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title of this version.',
  `log` longtext NOT NULL COMMENT 'The log entry explaining the changes in this version.',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when this version was created.',
  `status` int(11) NOT NULL DEFAULT '1' COMMENT 'Boolean indicating whether the node (at the time of this revision) is published (visible to non-administrators).',
  `comment` int(11) NOT NULL DEFAULT '0' COMMENT 'Whether comments are allowed on this node (at the time of this revision): 0 = no, 1 = closed (read only), 2 = open (read/write).',
  `promote` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the node (at the time of this revision) should be displayed on the front page.',
  `sticky` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the node (at the time of this revision) should be displayed at the top of lists in which it appears.',
  PRIMARY KEY (`vid`),
  KEY `nid` (`nid`),
  KEY `uid` (`uid`)
) ENGINE=InnoDB AUTO_INCREMENT=144 DEFAULT CHARSET=utf8 COMMENT='Stores information about each saved version of a node.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_revision`
--

LOCK TABLES `node_revision` WRITE;
/*!40000 ALTER TABLE `node_revision` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `node_revision` VALUES (7,7,1,'BlueAnt PUMP HD Wireless Bluetooth Waterproof Headphones','',1420433246,1,1,1,0),(8,8,1,'Banner 2','',1420433163,1,1,1,0),(11,11,1,'Feature FireTv','',1417492603,1,1,1,1),(12,12,1,'Driver Smarter','',1417492689,1,1,1,1),(13,13,1,'The Living Room','',1418973719,1,1,1,1),(14,14,1,'Get 20% off instantly','',1419633551,1,1,1,0),(16,16,1,'Payment & Pricing ','',1417171117,1,1,0,0),(17,17,1,'How to buy','',1418113435,1,1,0,0),(18,18,1,'Shipping & Pickup','',1417404441,1,1,0,0),(19,19,1,'Returns & Refunds ','',1417171213,1,1,0,0),(20,20,1,'Order Status','',1416823305,1,1,0,0),(21,21,1,'About Marketplace','',1416823399,1,1,0,0),(22,22,1,'Afﬁliate Program','',1418986477,1,1,0,0),(23,23,1,'Terms & Conditions','',1416823770,1,1,0,0),(24,24,1,'Privacy Policy','',1416989379,1,1,0,0),(26,26,1,'Sell on Marketplace','',1418986672,1,1,0,0),(27,27,1,'About Us','',1416987088,1,1,0,0),(28,28,1,'Contact Us','',1426653260,1,1,0,0),(29,29,1,'How can we help?','',1417406756,1,1,0,0),(30,30,1,'Aeroline Casual Hiking Backpack Dark Blue','',1419501346,1,2,1,0),(31,31,1,'Local Lion Water Resistant Hiking Backpack Bag 28L Blue','',1418359627,1,2,1,0),(32,32,1,'Terminus T02-297LAP-01 Laptop Backpack Plus','',1418358737,1,2,0,0),(33,33,1,'Targus Tsb166Ap 15.6In Revolution Backpack Xl','',1418358891,1,2,1,0),(34,34,1,'Tarantula Shoe Bag (BOS04-088SHB-03) - Red','',1418360139,1,2,0,0),(35,35,1,'Diniwell Water-Resistant Travel Shoes Bag Pouch Organizer Bag Ver 2 - Orange','',1418359064,1,2,0,0),(36,36,1,'24-Piece Makeup Brush Set','',1418353548,1,2,0,0),(37,37,1,'Cameleon MakeUp Kit 396','',1418353776,1,2,1,0),(38,38,1,'4 in 1 Function Power Perfect Pore Facial Face Care Blackhead Cleaner','',1417594591,1,2,0,0),(39,39,1,'SK-II 5-Piece Skincare Travel Set 5pcs Travel Packs SKII SK2','',1419501285,1,2,0,0),(40,40,1,'Organic Eye Cream 15ml','',1418353842,1,2,0,0),(41,41,1,'Mejikaliner Quick Eyelid Essence Stick Glue - Night Use','',1417597485,1,2,0,0),(42,42,1,'Hairscape 1800W (AUS) 5000 Professional Hair Dryer','',1418353962,1,2,0,0),(43,43,1,'Tonific Slimming Massager','',1418352829,1,2,0,0),(44,44,1,'Apple iPhone 6 16GB Gold','',1418354130,1,2,1,0),(45,45,1,'Samsung N910 Note 4 LTE 32GB White','',1418715439,1,2,1,0),(46,46,1,'Asus Transformer P1801-B041K AIO 18.4\" PC Dekstop + Asus RT-N56U Wireless N N600 Dual-Band Gigabit Router','',1426216822,1,2,1,0),(47,47,1,'Lenovo A316','',1418354497,1,2,0,0),(48,48,1,'Nokia Asha 206 Dual SIM Black','',1418352185,1,2,0,0),(49,49,1,'Apple IPAD 3 Wi-Fi+4G MD368 64GB Black','',1418351813,1,2,0,0),(50,50,1,'Asus Memopad 7 (Tablet)','',1418354598,1,2,0,0),(51,51,1,'Lenovo Tablet Miix 2 59399848 8\" Silver','',1426216927,1,2,1,0),(52,52,1,'Apple iPad Air 16GB WiFi Space Grey (MD785ZPA)','',1418352025,1,2,1,0),(53,53,1,'Galaxy Note 4 Spigen Case Neo Hybrid Metal Gold','',1418354720,1,2,0,0),(54,54,1,'[GENUINE] SAMSUNG Galaxy Note 4 S View Classic Cover Case - Black','',1418354776,1,2,0,0),(55,55,1,'Samsung Galaxy Tab 7.0 Plus Vehicle Dock With In-Car Charger','',1418354819,1,2,0,0),(56,56,1,'Angel Universal Mobile Phone In Car Phone Holder 360 degree Item Code: P338','',1418354894,1,2,0,0),(57,57,1,'Original Apple Earpod Earphone with Remote & Mic for iPhone iPad iPod','',1418354984,1,2,0,0),(58,58,1,'Sony Stereo Bluetooth Headset SBH20 Black','',1418352069,1,2,0,0),(59,59,1,'TOP Mi 10400mAh Powerbank - Black','',1418355051,1,2,0,0),(60,60,1,'Universal Dual-Port Power Bank 20000mAh Black','',1418355115,1,2,0,0),(61,61,1,'MuWo Trendz Swarovski Element White Gold Plated Everlasting Love Set','',1418355175,1,2,0,0),(62,62,1,'LUCCACAL Multi Color Tribal Necklace','',1417594948,1,2,0,0),(63,63,1,'Dandelion Women Braided Belt White','',1418355239,1,2,0,0),(64,64,1,'Dandelion Cross Stitch Belt Orange','',1417594868,1,2,0,0),(65,65,1,'Fur Nyce Big Square Classic Chain Pattern Print Scarf','',1418355292,1,2,0,0),(66,66,1,'Fur Nyce Fashion Zebra Pattern Print Scarf White','',1418355487,1,2,0,0),(67,67,1,'Invicta Pro Diver Men Black Stainless Steel Strap Watch 15422','',1417594778,1,2,0,0),(68,68,1,'Rolex Submariner Black Dial Stainless Steel Automatic Mens Watch 114060','',1418355650,1,2,1,0),(69,69,1,'SUUNTO VECTOR BLACK SUSS010600610 MOUNTAIN OUTDOOR WATCH ','',1418355696,1,2,0,0),(70,70,1,'SKMEI 0955 30m Waterproof Analogue Digital Dual Time Men\'s Sports Watch Black + Green','',1418355936,1,2,0,0),(71,71,1,'Samsung 4\'\' Full HD LED TV - UA40H5008ARXXM Series 5','',1426216629,1,2,1,0),(72,72,1,'Sony 48\" Full HD LED TV - BRAVIA Model KDL-48R470B','',1426216590,1,2,1,0),(73,73,1,'Sony BDV-N9200W 9.1 Cinema Studio 3D Blu-Ray Disc home Theatre System','',1418356710,1,2,0,0),(74,74,1,'Samsung HT-E350K DVD Home Theater System','',1417594395,1,2,0,0),(75,75,1,'L12S OLED Smart Watch Bluetooth 3.0 Bracelet Wrist Design for IOS Android iPhone Samsung Smart Phone Blue','',1417594269,1,2,0,0),(76,76,1,'ORI Apple TV','',1417594234,1,2,0,0),(77,77,1,'Dell Alienware X51-77822G Gaming Desktop','',1418358045,1,2,1,0),(78,78,1,'3 Port HDMI Switch With Remote Control','',1418358116,1,2,0,0),(79,79,1,'Dell PowerConnect 5524P 24 GbE Port Managed L2 Switch with PoE support 10GbE and Stacking Capable','',1418358205,1,2,0,0),(80,80,1,'TP-Link M5250 N900 3G Mobile WiFi Black','',1418358277,1,2,0,0),(81,81,1,'TP-LINK N750 Wireless Dual Band Gigabit Router TL-WDR4300 Black','',1418358332,1,2,0,0),(82,82,1,'Canon LiDE 210 Scanner','',1418353325,1,2,0,0),(83,83,1,'Epson Perfection V33 Scanner','',1418353195,1,2,0,0),(84,84,1,'CASIO Exilim EX-ZR1500 Digital Camera Pink','',1418353115,1,2,0,0),(85,85,1,'Canon PowerShot SX60 HS 16.1MP Black + 8GB + Case','',1418029308,1,2,0,0),(86,86,1,'Canon EOS 600D 18MP + 18-55mm Lens','',1418352963,1,2,0,0),(87,87,1,'Face Care','',1418718447,1,1,0,0),(88,88,1,'Samsung Smart Camera NX Mini 20.5MP Green + 9mm Lens + 16 GB Memory Card','',1418365269,1,2,0,0),(89,89,1,'Nikon AF-S 50mm Lens f/1.8G','',1418365650,1,2,0,0),(90,90,1,'Canon EF-S Lens 18-200mm f/3.5-5.6 IS','',1418366198,1,2,1,0),(91,91,1,'Cokin U961A Z Pro Grad Kit - Z Filter Holder + Z121L + Z123L + Z125L','',1418366856,1,2,0,0),(92,92,1,'D-Link DCS-5222L Cloudcam Hd Wireless N Pan/Tilt Network Camera','',1418370702,1,2,0,0),(93,93,1,'CCTV- 850TVL IR DOME CCTV CAMERA ','',1418369954,1,2,0,0),(94,94,1,'Trek Ai-Ball Portable Wi-Fi Remote Camera with Cradle & Adaptors (Yellow)','',1418369928,1,2,0,0),(95,95,1,'Mini Quran for Kids Yellow','',1418370240,1,2,0,0),(96,96,1,'Boogie Board 10.5 Inch LCD Writing Tablet Pink','',1418370810,1,2,0,0),(97,97,1,'Transporter Carry Cot','',1418371252,1,2,0,0),(98,98,1,'Educational Toys','',1418375876,1,1,0,0),(99,99,1,'Books & Stationery','',1418375218,1,1,0,0),(100,100,1,'Health & Safety','',1418375406,1,1,0,0),(101,101,1,'Backpacks','',1418376994,1,1,0,0),(102,102,1,'Shoe Bags','',1418377770,1,1,0,0),(103,103,1,'Makeup','',1418378499,1,1,0,0),(104,104,1,'Eye Care','',1418378630,1,1,0,0),(105,105,1,'Health & Beauty Tools','',1418378767,1,1,0,0),(106,106,1,'Food Supplements','',1418379130,1,1,0,0),(107,107,1,'Basic Phones','',1418380438,1,1,0,0),(108,108,1,'Car Accessories','',1418380250,1,1,0,0),(109,109,1,'Cases & Covers','',1418722570,1,1,0,0),(110,110,1,'Smartphones','',1418789320,1,1,0,0),(111,111,1,'With call facility','',1418380893,1,1,0,0),(112,112,1,'Without call facility','',1418381108,1,1,0,0),(113,113,1,'Headphones','',1418723723,1,1,0,0),(114,114,1,'Batteries & Chargers','',1418381604,1,1,0,0),(115,115,1,'Women\'s Jewellery','',1418632318,1,1,0,0),(116,116,1,'Belts','',1418632296,1,1,0,0),(117,117,1,'Scarves','',1418632414,1,1,0,0),(118,118,1,'Business','',1418632547,1,1,0,0),(119,119,1,'Sports','',1418632627,1,1,0,0),(120,120,1,'Televisions','',1418638559,1,1,0,0),(121,121,1,'Home Audio','',1418638692,1,1,0,0),(122,122,1,'Gadgets','',1418639070,1,1,0,0),(123,123,1,'Laptops','',1418641090,1,1,0,0),(124,124,1,'Desktop','',1418641175,1,1,0,0),(125,125,1,'Switches','',1418641282,1,1,0,0),(126,126,1,'Routers','',1418641404,1,1,0,0),(127,127,1,'Scanners','',1418641523,1,1,0,0),(128,128,1,'Point & Shoot Cameras','',1418701080,1,1,0,0),(129,129,1,'DSLR/SLR Cameras','',1418701197,1,1,0,0),(130,130,1,'Filters','',1418701300,1,1,0,0),(131,131,1,'Lenses','',1418701389,1,1,0,0),(132,132,1,'IP Cameras','',1418701500,1,1,0,0),(133,133,1,'Car Cameras','',1418701663,1,1,0,0),(134,134,1,'Laptop Bags & Cases','',1418704961,1,1,0,0),(135,135,1,'Asus','',1418789357,1,1,0,0),(136,136,1,'Rolex','',1418789989,1,1,0,0),(137,137,1,'Canon','',1418984102,1,1,0,0),(138,138,1,'Kinohimitsu J\'pan BB Drink 50ml x 10','',1418884808,1,2,0,0),(139,139,1,'TKO Fat Burner Mega','',1419219331,1,2,0,0),(140,140,1,'Filters','',1418896269,1,1,0,0),(141,141,1,'404-page','',1418974786,1,1,0,0),(142,142,1,'Black Friday','',1420432986,1,1,1,0),(143,143,1,'Get 20% off instantly','',1419633533,1,1,0,0);
/*!40000 ALTER TABLE `node_revision` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_type`
--

DROP TABLE IF EXISTS `node_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_type` (
  `type` varchar(32) NOT NULL COMMENT 'The machine-readable name of this type.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The human-readable name of this type.',
  `base` varchar(255) NOT NULL COMMENT 'The base string used to construct callbacks corresponding to this node type.',
  `module` varchar(255) NOT NULL COMMENT 'The module defining this node type.',
  `description` mediumtext NOT NULL COMMENT 'A brief description of this type.',
  `help` mediumtext NOT NULL COMMENT 'Help information shown to the user when creating a node of this type.',
  `has_title` tinyint(3) unsigned NOT NULL COMMENT 'Boolean indicating whether this type uses the node.title field.',
  `title_label` varchar(255) NOT NULL DEFAULT '' COMMENT 'The label displayed for the title field on the edit form.',
  `custom` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this type is defined by a module (FALSE) or by a user via Add content type (TRUE).',
  `modified` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this type has been modified by an administrator; currently not used in any way.',
  `locked` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether the administrator can change the machine name of this type.',
  `disabled` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether the node type is disabled.',
  `orig_type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The original machine-readable name of this node type. This may be different from the current type name if the locked field is 0.',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores information about all defined node types.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_type`
--

LOCK TABLES `node_type` WRITE;
/*!40000 ALTER TABLE `node_type` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `node_type` VALUES ('article','Article','node_content','node','Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.','',1,'Title',1,1,0,0,'article'),('banner','Banner','node_content','node','','',1,'Title',1,1,0,0,'banner'),('page','Basic page','node_content','node','Use <em>basic pages</em> for your static content, such as an \'About us\' page.','',1,'Title',1,1,0,0,'page'),('product','Product','node_content','node','','',1,'Title',1,1,0,0,'products'),('simplenews','Simplenews newsletter','node_content','node','A newsletter issue to be sent to subscribed email addresses.','',1,'Title',1,1,0,0,'simplenews'),('webform','Webform','node_content','node','Create a new form or questionnaire accessible to users. Submission results and statistics are recorded and accessible to privileged users.','',1,'Title',1,1,0,0,'webform');
/*!40000 ALTER TABLE `node_type` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `queue`
--

DROP TABLE IF EXISTS `queue`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `queue` (
  `item_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique item ID.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The queue name.',
  `data` longblob COMMENT 'The arbitrary data for the item.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp when the claim lease expires on the item.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp when the item was created.',
  PRIMARY KEY (`item_id`),
  KEY `name_created` (`name`,`created`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB AUTO_INCREMENT=2046 DEFAULT CHARSET=utf8 COMMENT='Stores items in queues.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `queue`
--

LOCK TABLES `queue` WRITE;
/*!40000 ALTER TABLE `queue` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `queue` VALUES (2030,'update_fetch_tasks','a:8:{s:4:\"name\";s:11:\"session_api\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Session API\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:7:\"project\";s:11:\"session_api\";s:9:\"datestamp\";s:10:\"1354234727\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1354234727\";s:8:\"includes\";a:1:{s:11:\"session_api\";s:11:\"Session API\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}',0,1500361138),(2031,'update_fetch_tasks','a:8:{s:4:\"name\";s:10:\"simplenews\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"Simplenews\";s:7:\"package\";s:4:\"Mail\";s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:10:\"simplenews\";s:9:\"datestamp\";s:10:\"1381947969\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1381947969\";s:8:\"includes\";a:1:{s:10:\"simplenews\";s:10:\"Simplenews\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}',0,1500361138),(2032,'update_fetch_tasks','a:8:{s:4:\"name\";s:9:\"tagclouds\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"TagClouds\";s:7:\"package\";s:8:\"Taxonomy\";s:7:\"version\";s:8:\"7.x-1.10\";s:7:\"project\";s:9:\"tagclouds\";s:9:\"datestamp\";s:10:\"1404152332\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1404152332\";s:8:\"includes\";a:1:{s:9:\"tagclouds\";s:9:\"TagClouds\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}',0,1500361138),(2033,'update_fetch_tasks','a:8:{s:4:\"name\";s:13:\"taxonomy_menu\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Taxonomy menu\";s:7:\"package\";s:13:\"Taxonomy menu\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:13:\"taxonomy_menu\";s:9:\"datestamp\";s:10:\"1396359247\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1396359247\";s:8:\"includes\";a:1:{s:13:\"taxonomy_menu\";s:13:\"Taxonomy menu\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}',0,1500361138),(2034,'update_fetch_tasks','a:8:{s:4:\"name\";s:11:\"tb_megamenu\";s:4:\"info\";a:6:{s:4:\"name\";s:12:\"TB Mega Menu\";s:7:\"package\";s:4:\"Menu\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:7:\"project\";s:11:\"tb_megamenu\";s:9:\"datestamp\";s:10:\"1440756596\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1440756596\";s:8:\"includes\";a:1:{s:11:\"tb_megamenu\";s:12:\"TB Mega Menu\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}',0,1500361138),(2035,'update_fetch_tasks','a:8:{s:4:\"name\";s:5:\"title\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Title\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:14:\"7.x-1.0-alpha9\";s:7:\"project\";s:5:\"title\";s:9:\"datestamp\";s:10:\"1484302985\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1484302985\";s:8:\"includes\";a:1:{s:5:\"title\";s:5:\"Title\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}',0,1500361138),(2036,'update_fetch_tasks','a:8:{s:4:\"name\";s:5:\"token\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Token\";s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:5:\"token\";s:9:\"datestamp\";s:10:\"1425149060\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1425149060\";s:8:\"includes\";a:1:{s:5:\"token\";s:5:\"Token\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}',0,1500361138),(2037,'update_fetch_tasks','a:8:{s:4:\"name\";s:5:\"views\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Views\";s:7:\"package\";s:5:\"Views\";s:7:\"version\";s:8:\"7.x-3.16\";s:7:\"project\";s:5:\"views\";s:9:\"datestamp\";s:10:\"1491158591\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1491158591\";s:8:\"includes\";a:2:{s:5:\"views\";s:5:\"Views\";s:8:\"views_ui\";s:8:\"Views UI\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}',0,1500361138),(2038,'update_fetch_tasks','a:8:{s:4:\"name\";s:15:\"views_bootstrap\";s:4:\"info\";a:6:{s:4:\"name\";s:15:\"Views Bootstrap\";s:7:\"package\";s:5:\"Views\";s:7:\"version\";s:7:\"7.x-3.1\";s:7:\"project\";s:15:\"views_bootstrap\";s:9:\"datestamp\";s:10:\"1398607429\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1398607429\";s:8:\"includes\";a:1:{s:15:\"views_bootstrap\";s:15:\"Views Bootstrap\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}',0,1500361138),(2039,'update_fetch_tasks','a:8:{s:4:\"name\";s:16:\"views_field_view\";s:4:\"info\";a:6:{s:4:\"name\";s:16:\"Views Field View\";s:7:\"package\";s:5:\"Views\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:16:\"views_field_view\";s:9:\"datestamp\";s:10:\"1442561052\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1442561052\";s:8:\"includes\";a:1:{s:16:\"views_field_view\";s:16:\"Views Field View\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}',0,1500361138),(2040,'update_fetch_tasks','a:8:{s:4:\"name\";s:15:\"views_fieldsets\";s:4:\"info\";a:6:{s:4:\"name\";s:15:\"Views fieldsets\";s:7:\"package\";s:5:\"Views\";s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:15:\"views_fieldsets\";s:9:\"datestamp\";s:10:\"1425515886\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1425515886\";s:8:\"includes\";a:1:{s:15:\"views_fieldsets\";s:15:\"Views fieldsets\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}',0,1500361138),(2041,'update_fetch_tasks','a:8:{s:4:\"name\";s:15:\"views_slideshow\";s:4:\"info\";a:6:{s:4:\"name\";s:15:\"Views Slideshow\";s:7:\"package\";s:5:\"Views\";s:7:\"version\";s:7:\"7.x-3.1\";s:7:\"project\";s:15:\"views_slideshow\";s:9:\"datestamp\";s:10:\"1382584826\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1382584826\";s:8:\"includes\";a:2:{s:15:\"views_slideshow\";s:15:\"Views Slideshow\";s:21:\"views_slideshow_cycle\";s:22:\"Views Slideshow: Cycle\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}',0,1500361138),(2042,'update_fetch_tasks','a:8:{s:4:\"name\";s:9:\"votingapi\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"Voting API\";s:7:\"package\";s:6:\"Voting\";s:7:\"version\";s:8:\"7.x-2.12\";s:7:\"project\";s:9:\"votingapi\";s:9:\"datestamp\";s:10:\"1407995929\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1407995929\";s:8:\"includes\";a:1:{s:9:\"votingapi\";s:10:\"Voting API\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}',0,1500361138),(2043,'update_fetch_tasks','a:8:{s:4:\"name\";s:20:\"we_content_migration\";s:4:\"info\";a:6:{s:4:\"name\";s:17:\"Content Migration\";s:7:\"package\";s:17:\"Content Migration\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:7:\"project\";s:20:\"we_content_migration\";s:9:\"datestamp\";s:10:\"1499677744\";s:16:\"_info_file_ctime\";i:1499933737;}s:9:\"datestamp\";s:10:\"1499677744\";s:8:\"includes\";a:1:{s:20:\"we_content_migration\";s:17:\"Content Migration\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}',0,1500361138),(2044,'update_fetch_tasks','a:8:{s:4:\"name\";s:7:\"webform\";s:4:\"info\";a:6:{s:4:\"name\";s:7:\"Webform\";s:7:\"package\";s:7:\"Webform\";s:7:\"version\";s:8:\"7.x-4.11\";s:7:\"project\";s:7:\"webform\";s:9:\"datestamp\";s:10:\"1442953145\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1442953145\";s:8:\"includes\";a:1:{s:7:\"webform\";s:7:\"Webform\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}',0,1500361138),(2045,'update_fetch_tasks','a:8:{s:4:\"name\";s:6:\"weight\";s:4:\"info\";a:6:{s:4:\"name\";s:6:\"Weight\";s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:6:\"weight\";s:9:\"datestamp\";s:10:\"1430342647\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499933463;}s:9:\"datestamp\";s:10:\"1430342647\";s:8:\"includes\";a:1:{s:6:\"weight\";s:6:\"Weight\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}',0,1500361138);
/*!40000 ALTER TABLE `queue` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `recently_read`
--

DROP TABLE IF EXISTS `recently_read`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `recently_read` (
  `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The sid from session_api',
  `type` varchar(32) NOT NULL DEFAULT '' COMMENT 'The type of the read entity.',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The entity id.',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language of the read entity.',
  `timestamp` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The time the node has been read.',
  PRIMARY KEY (`sid`,`type`,`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Table for history of read entities';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `recently_read`
--

LOCK TABLES `recently_read` WRITE;
/*!40000 ALTER TABLE `recently_read` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `recently_read` VALUES (123,'node',19,'en',1500361262),(123,'node',28,'en',1500361251),(123,'node',31,'en',1500361235);
/*!40000 ALTER TABLE `recently_read` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `registry`
--

DROP TABLE IF EXISTS `registry`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `registry` (
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the function, class, or interface.',
  `type` varchar(9) NOT NULL DEFAULT '' COMMENT 'Either function or class or interface.',
  `filename` varchar(255) NOT NULL COMMENT 'Name of the file.',
  `module` varchar(255) NOT NULL DEFAULT '' COMMENT 'Name of the module the file belongs to.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The order in which this module’s hooks should be invoked relative to other modules. Equal-weighted modules are ordered by name.',
  PRIMARY KEY (`name`,`type`),
  KEY `hook` (`type`,`weight`,`module`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Each record is a function, class, or interface name and...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `registry`
--

LOCK TABLES `registry` WRITE;
/*!40000 ALTER TABLE `registry` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `registry` VALUES ('AccessDeniedTestCase','class','modules/system/system.test','system',0),('addressfield_views_handler_field_country','class','sites/all/modules/addressfield/views/addressfield_views_handler_field_country.inc','addressfield',0),('addressfield_views_handler_filter_country','class','sites/all/modules/addressfield/views/addressfield_views_handler_filter_country.inc','addressfield',0),('AdminMenuCustomizedTestCase','class','sites/all/modules/admin_menu/tests/admin_menu.test','admin_menu',100),('AdminMenuDynamicLinksTestCase','class','sites/all/modules/admin_menu/tests/admin_menu.test','admin_menu',100),('AdminMenuLinkTypesTestCase','class','sites/all/modules/admin_menu/tests/admin_menu.test','admin_menu',100),('AdminMenuPermissionsTestCase','class','sites/all/modules/admin_menu/tests/admin_menu.test','admin_menu',100),('AdminMenuWebTestCase','class','sites/all/modules/admin_menu/tests/admin_menu.test','admin_menu',100),('AdminMetaTagTestCase','class','modules/system/system.test','system',0),('ArchiverInterface','interface','includes/archiver.inc','',0),('ArchiverTar','class','modules/system/system.archiver.inc','system',0),('ArchiverZip','class','modules/system/system.archiver.inc','system',0),('Archive_Tar','class','modules/system/system.tar.inc','system',0),('BatchMemoryQueue','class','includes/batch.queue.inc','',0),('BatchQueue','class','includes/batch.queue.inc','',0),('BEF_TestCheckboxes','class','sites/all/modules/better_exposed_filters/tests/better_exposed_filters.test','better_exposed_filters',0),('BEF_TestDatepicker','class','sites/all/modules/better_exposed_filters/tests/better_exposed_filters.test','better_exposed_filters',0),('BEF_TestHidden','class','sites/all/modules/better_exposed_filters/tests/better_exposed_filters.test','better_exposed_filters',0),('BEF_TestLinks','class','sites/all/modules/better_exposed_filters/tests/better_exposed_filters.test','better_exposed_filters',0),('BEF_TestMisc','class','sites/all/modules/better_exposed_filters/tests/better_exposed_filters.test','better_exposed_filters',0),('BEF_TestOptions','class','sites/all/modules/better_exposed_filters/tests/better_exposed_filters.test','better_exposed_filters',0),('BEF_TestRadios','class','sites/all/modules/better_exposed_filters/tests/better_exposed_filters.test','better_exposed_filters',0),('BEF_TestRewrite','class','sites/all/modules/better_exposed_filters/tests/better_exposed_filters.test','better_exposed_filters',0),('BEF_TestSecondaryFilters','class','sites/all/modules/better_exposed_filters/tests/better_exposed_filters.test','better_exposed_filters',0),('BEF_TestSliders','class','sites/all/modules/better_exposed_filters/tests/better_exposed_filters.test','better_exposed_filters',0),('BEF_TestSort','class','sites/all/modules/better_exposed_filters/tests/better_exposed_filters.test','better_exposed_filters',0),('BEF_TestTaxonomyFilters','class','sites/all/modules/better_exposed_filters/tests/better_exposed_filters.test','better_exposed_filters',0),('better_exposed_filters_exposed_form_plugin','class','sites/all/modules/better_exposed_filters/better_exposed_filters_exposed_form_plugin.inc','better_exposed_filters',0),('BlockAdminThemeTestCase','class','modules/block/block.test','block',-5),('BlockCacheTestCase','class','modules/block/block.test','block',-5),('BlockClassContextTestCase','class','sites/all/modules/block_class/block_class.test','block_class',0),('BlockClassFeaturesTestCase','class','sites/all/modules/block_class/block_class.test','block_class',0),('BlockClassPermissionTestCase','class','sites/all/modules/block_class/block_class.test','block_class',0),('BlockClassTestCase','class','sites/all/modules/block_class/block_class.test','block_class',0),('BlockClassUpdateDisplayTestCase','class','sites/all/modules/block_class/block_class.test','block_class',0),('BlockHashTestCase','class','modules/block/block.test','block',-5),('BlockHiddenRegionTestCase','class','modules/block/block.test','block',-5),('BlockHTMLIdTestCase','class','modules/block/block.test','block',-5),('BlockInvalidRegionTestCase','class','modules/block/block.test','block',-5),('BlockTemplateSuggestionsUnitTest','class','modules/block/block.test','block',-5),('BlockTestCase','class','modules/block/block.test','block',-5),('BlockViewModuleDeltaAlterWebTest','class','modules/block/block.test','block',-5),('ColorTestCase','class','modules/color/color.test','color',0),('CommentActionsTestCase','class','modules/comment/comment.test','comment',0),('CommentAnonymous','class','modules/comment/comment.test','comment',0),('CommentApprovalTest','class','modules/comment/comment.test','comment',0),('CommentBlockFunctionalTest','class','modules/comment/comment.test','comment',0),('CommentContentRebuild','class','modules/comment/comment.test','comment',0),('CommentController','class','modules/comment/comment.module','comment',0),('CommentFieldsTest','class','modules/comment/comment.test','comment',0),('CommentHelperCase','class','modules/comment/comment.test','comment',0),('CommentInterfaceTest','class','modules/comment/comment.test','comment',0),('CommentNodeAccessTest','class','modules/comment/comment.test','comment',0),('CommentNodeChangesTestCase','class','modules/comment/comment.test','comment',0),('CommentPagerTest','class','modules/comment/comment.test','comment',0),('CommentPreviewTest','class','modules/comment/comment.test','comment',0),('CommentRSSUnitTest','class','modules/comment/comment.test','comment',0),('CommentThreadingTestCase','class','modules/comment/comment.test','comment',0),('CommentTokenReplaceTestCase','class','modules/comment/comment.test','comment',0),('CommerceBaseTestCase','class','sites/all/modules/commerce/tests/commerce_base.test','commerce',1),('CommerceBaseTesterTestCase','class','sites/all/modules/commerce/tests/commerce_base.test','commerce',1),('CommerceCartTestCase','class','sites/all/modules/commerce/modules/cart/tests/commerce_cart.test','commerce_cart',0),('CommerceCartTestCaseAnonymousToAuthenticated','class','sites/all/modules/commerce/modules/cart/tests/commerce_cart.test','commerce_cart',0),('CommerceCartTestCaseAttributes','class','sites/all/modules/commerce/modules/cart/tests/commerce_cart.test','commerce_cart',0),('CommerceCartTestCaseMultiProducts','class','sites/all/modules/commerce/modules/cart/tests/commerce_cart.test','commerce_cart',0),('CommerceCartTestCaseSimpleProduct','class','sites/all/modules/commerce/modules/cart/tests/commerce_cart.test','commerce_cart',0),('CommerceCheckoutTestProcess','class','sites/all/modules/commerce/modules/checkout/tests/commerce_checkout.test','commerce_checkout',0),('CommerceCustomerProfileEntityController','class','sites/all/modules/commerce/modules/customer/includes/commerce_customer_profile.controller.inc','commerce_customer',0),('CommerceCustomerUITest','class','sites/all/modules/commerce/modules/customer/tests/commerce_customer_ui.test','commerce_customer_ui',0),('CommerceLineItemEntityController','class','sites/all/modules/commerce/modules/line_item/includes/commerce_line_item.controller.inc','commerce_line_item',0),('CommerceLineItemInlineEntityFormController','class','sites/all/modules/inline_entity_form/includes/commerce_line_item.inline_entity_form.inc','inline_entity_form',0),('CommerceMarketplaceFundsAccount','class','sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/lib/commerce_marketplace_funds.account.entity.inc','commerce_marketplace_funds',0),('CommerceMarketplaceFundsAccountController','class','sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/lib/commerce_marketplace_funds.account.controller.inc','commerce_marketplace_funds',0),('CommerceMarketplaceFundsAccountMetadataController','class','sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/lib/commerce_marketplace_funds.account.metadata.inc','commerce_marketplace_funds',0),('CommerceMarketplaceFundsProcessorInterface','interface','sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/lib/commerce_marketplace_funds.processor.interface.inc','commerce_marketplace_funds',0),('CommerceMarketplaceFundsTransaction','class','sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/lib/commerce_marketplace_funds.transaction.entity.inc','commerce_marketplace_funds',0),('CommerceMarketplaceFundsTransactionController','class','sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/lib/commerce_marketplace_funds.transaction.controller.inc','commerce_marketplace_funds',0),('CommerceMarketplaceFundsTransactionMetadataController','class','sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/lib/commerce_marketplace_funds.transaction.metadata.inc','commerce_marketplace_funds',0),('CommerceMarketplaceFundsWithdrawMethod','class','sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/modules/withdraw/lib/commerce_marketplace_funds_withdraw.method.entity.inc','commerce_marketplace_funds_withdraw',0),('CommerceMarketplaceFundsWithdrawMethodController','class','sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/modules/withdraw/lib/commerce_marketplace_funds_withdraw.method.controller.inc','commerce_marketplace_funds_withdraw',0),('CommerceMarketplaceFundsWithdrawMethodMetadataController','class','sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/modules/withdraw/lib/commerce_marketplace_funds_withdraw.method.metadata.inc','commerce_marketplace_funds_withdraw',0),('CommerceMarketplaceFundsWithdrawMethodType','class','sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/modules/withdraw/lib/commerce_marketplace_funds_withdraw.method_type.entity.inc','commerce_marketplace_funds_withdraw',0),('CommerceMarketplaceFundsWithdrawMethodTypeController','class','sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/modules/withdraw/lib/commerce_marketplace_funds_withdraw.method_type.controller.inc','commerce_marketplace_funds_withdraw',0),('CommerceMarketplaceFundsWithdrawMethodTypeUIController','class','sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/modules/withdraw/includes/commerce_marketplace_funds_withdraw.method_type.admin.inc','commerce_marketplace_funds_withdraw',0),('CommerceOrderCRUDTestCase','class','sites/all/modules/commerce/modules/order/tests/commerce_order.test','commerce_order',0),('CommerceOrderEntityController','class','sites/all/modules/commerce/modules/order/includes/commerce_order.controller.inc','commerce_order',0),('CommerceOrderRulesTest','class','sites/all/modules/commerce/modules/order/tests/commerce_order.rules.test','commerce_order',0),('CommerceOrderUIAdminTest','class','sites/all/modules/commerce/modules/order/tests/commerce_order_ui.test','commerce_order_ui',0),('CommercePaymentOffsiteTest','class','sites/all/modules/commerce/modules/payment/tests/commerce_payment_ui.test','commerce_payment_ui',0),('CommercePaymentRulesTest','class','sites/all/modules/commerce/modules/payment/tests/commerce_payment.rules.test','commerce_payment',0),('CommercePaymentTransactionEntityController','class','sites/all/modules/commerce/modules/payment/includes/commerce_payment_transaction.controller.inc','commerce_payment',0),('CommercePaymentUITest','class','sites/all/modules/commerce/modules/payment/tests/commerce_payment_ui.test','commerce_payment_ui',0),('CommerceProductCRUDTestCase','class','sites/all/modules/commerce/modules/product/tests/commerce_product.test','commerce_product',0),('CommerceProductEntityController','class','sites/all/modules/commerce/modules/product/includes/commerce_product.controller.inc','commerce_product',0),('CommerceProductInlineEntityFormController','class','sites/all/modules/inline_entity_form/includes/commerce_product.inline_entity_form.inc','inline_entity_form',0),('CommerceProductReferenceAdminTest','class','sites/all/modules/commerce/modules/product_reference/tests/commerce_product_reference.test','commerce_product_reference',0),('CommerceProductRulesTestCase','class','sites/all/modules/commerce/modules/product/tests/commerce_product.test','commerce_product',0),('CommerceProductUIAdminTest','class','sites/all/modules/commerce/modules/product/tests/commerce_product_ui.test','commerce_product_ui',0),('CommerceSearchApiAlterProductStatus','class','sites/all/modules/commerce_search_api/includes/callback_product_status.inc','commerce_search_api',0),('CommerceSearchApiFancy','class','sites/all/modules/commerce_search_api/includes/facetapi/widget_fancy_attributes.inc','commerce_search_api',0),('CommerceSearchApiProductDisplayFilter','class','sites/all/modules/commerce_search_api/includes/commerce_search_api_product_display_filter.inc','commerce_search_api',0),('CommerceSearchApiSameSearch','class','sites/all/modules/commerce_search_api/includes/facetapi/filter_same_search.inc','commerce_search_api',0),('CommerceSearchApiSearchStart','class','sites/all/modules/commerce_search_api/includes/facetapi/filter_search_start.inc','commerce_search_api',0),('commerce_cart_handler_area_empty_text','class','sites/all/modules/commerce/modules/cart/includes/views/handlers/commerce_cart_handler_area_empty_text.inc','commerce_cart',0),('commerce_cart_handler_field_add_to_cart_form','class','sites/all/modules/commerce/modules/cart/includes/views/handlers/commerce_cart_handler_field_add_to_cart_form.inc','commerce_cart',0),('commerce_cart_handler_field_edit_attributes','class','sites/all/modules/commerce/modules/cart/includes/views/handlers/commerce_cart_handler_field_edit_attributes.inc','commerce_cart',0),('commerce_cart_plugin_argument_default_current_cart_order_id','class','sites/all/modules/commerce/modules/cart/includes/views/handlers/commerce_cart_plugin_argument_default_current_cart_order_id.inc','commerce_cart',0),('commerce_customer_handler_area_empty_text','class','sites/all/modules/commerce/modules/customer/includes/views/handlers/commerce_customer_handler_area_empty_text.inc','commerce_customer',0),('commerce_customer_handler_field_customer_profile','class','sites/all/modules/commerce/modules/customer/includes/views/handlers/commerce_customer_handler_field_customer_profile.inc','commerce_customer',0),('commerce_customer_handler_field_customer_profile_link','class','sites/all/modules/commerce/modules/customer/includes/views/handlers/commerce_customer_handler_field_customer_profile_link.inc','commerce_customer',0),('commerce_customer_handler_field_customer_profile_link_delete','class','sites/all/modules/commerce/modules/customer/includes/views/handlers/commerce_customer_handler_field_customer_profile_link_delete.inc','commerce_customer',0),('commerce_customer_handler_field_customer_profile_link_edit','class','sites/all/modules/commerce/modules/customer/includes/views/handlers/commerce_customer_handler_field_customer_profile_link_edit.inc','commerce_customer',0),('commerce_customer_handler_field_customer_profile_type','class','sites/all/modules/commerce/modules/customer/includes/views/handlers/commerce_customer_handler_field_customer_profile_type.inc','commerce_customer',0),('commerce_customer_handler_filter_customer_profile_type','class','sites/all/modules/commerce/modules/customer/includes/views/handlers/commerce_customer_handler_filter_customer_profile_type.inc','commerce_customer',0),('commerce_line_item_handler_area_line_item_summary','class','sites/all/modules/commerce/modules/line_item/includes/views/handlers/commerce_line_item_handler_area_line_item_summary.inc','commerce_line_item',0),('commerce_line_item_handler_argument_line_item_line_item_id','class','sites/all/modules/commerce/modules/line_item/includes/views/handlers/commerce_line_item_handler_argument_line_item_line_item_id.inc','commerce_line_item',0),('commerce_line_item_handler_field_edit_delete','class','sites/all/modules/commerce/modules/line_item/includes/views/handlers/commerce_line_item_handler_field_edit_delete.inc','commerce_line_item',0),('commerce_line_item_handler_field_edit_quantity','class','sites/all/modules/commerce/modules/line_item/includes/views/handlers/commerce_line_item_handler_field_edit_quantity.inc','commerce_line_item',0),('commerce_line_item_handler_field_line_item_title','class','sites/all/modules/commerce/modules/line_item/includes/views/handlers/commerce_line_item_handler_field_line_item_title.inc','commerce_line_item',0),('commerce_line_item_handler_field_line_item_type','class','sites/all/modules/commerce/modules/line_item/includes/views/handlers/commerce_line_item_handler_field_line_item_type.inc','commerce_line_item',0),('commerce_line_item_handler_filter_line_item_is_referenced','class','sites/all/modules/commerce/modules/line_item/includes/views/handlers/commerce_line_item_handler_filter_line_item_is_referenced.inc','commerce_line_item',0),('commerce_line_item_handler_filter_line_item_type','class','sites/all/modules/commerce/modules/line_item/includes/views/handlers/commerce_line_item_handler_filter_line_item_type.inc','commerce_line_item',0),('commerce_order_handler_area_empty_text','class','sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_area_empty_text.inc','commerce_order',0),('commerce_order_handler_area_order_total','class','sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_area_order_total.inc','commerce_order',0),('commerce_order_handler_argument_order_order_id','class','sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_argument_order_order_id.inc','commerce_order',0),('commerce_order_handler_field_order','class','sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_field_order.inc','commerce_order',0),('commerce_order_handler_field_order_link','class','sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_field_order_link.inc','commerce_order',0),('commerce_order_handler_field_order_link_delete','class','sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_field_order_link_delete.inc','commerce_order',0),('commerce_order_handler_field_order_link_edit','class','sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_field_order_link_edit.inc','commerce_order',0),('commerce_order_handler_field_order_mail','class','sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_field_order_mail.inc','commerce_order',0),('commerce_order_handler_field_order_operations','class','sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_field_order_operations.inc','commerce_order',0),('commerce_order_handler_field_order_state','class','sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_field_order_state.inc','commerce_order',0),('commerce_order_handler_field_order_status','class','sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_field_order_status.inc','commerce_order',0),('commerce_order_handler_field_order_type','class','sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_field_order_type.inc','commerce_order',0),('commerce_order_handler_filter_order_state','class','sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_filter_order_state.inc','commerce_order',0),('commerce_order_handler_filter_order_status','class','sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_filter_order_status.inc','commerce_order',0),('commerce_order_handler_filter_order_type','class','sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_filter_order_type.inc','commerce_order',0),('commerce_order_plugin_argument_validate_user','class','sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_plugin_argument_validate_user.inc','commerce_order',0),('commerce_order_ui_handler_area_view_order_form','class','sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_ui_handler_area_view_order_form.inc','commerce_order_ui',0),('commerce_payment_handler_area_totals','class','sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_area_totals.inc','commerce_payment',0),('commerce_payment_handler_field_amount','class','sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_field_amount.inc','commerce_payment',0),('commerce_payment_handler_field_balance','class','sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_field_balance.inc','commerce_payment',0),('commerce_payment_handler_field_currency_code','class','sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_field_currency_code.inc','commerce_payment',0),('commerce_payment_handler_field_message','class','sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_field_message.inc','commerce_payment',0),('commerce_payment_handler_field_payment_method','class','sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_field_payment_method.inc','commerce_payment',0),('commerce_payment_handler_field_payment_transaction_link','class','sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_field_payment_transaction_link.inc','commerce_payment',0),('commerce_payment_handler_field_payment_transaction_link_delete','class','sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_field_payment_transaction_link_delete.inc','commerce_payment',0),('commerce_payment_handler_field_payment_transaction_operations','class','sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_field_payment_transaction_operations.inc','commerce_payment',0),('commerce_payment_handler_field_status','class','sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_field_status.inc','commerce_payment',0),('commerce_payment_handler_filter_currency_code','class','sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_filter_currency_code.inc','commerce_payment',0),('commerce_payment_handler_filter_payment_method','class','sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_filter_payment_method.inc','commerce_payment',0),('commerce_payment_handler_filter_payment_transaction_status','class','sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_filter_payment_transaction_status.inc','commerce_payment',0),('commerce_price_handler_field_commerce_price','class','sites/all/modules/commerce/modules/price/includes/views/handlers/commerce_price_handler_field_commerce_price.inc','commerce_price',0),('commerce_price_handler_filter_commerce_price_amount','class','sites/all/modules/commerce/modules/price/includes/views/handlers/commerce_price_handler_filter_commerce_price_amount.inc','commerce_price',0),('commerce_product_handler_area_empty_text','class','sites/all/modules/commerce/modules/product/includes/views/handlers/commerce_product_handler_area_empty_text.inc','commerce_product',0),('commerce_product_handler_argument_product_id','class','sites/all/modules/commerce/modules/product/includes/views/handlers/commerce_product_handler_argument_product_id.inc','commerce_product',0),('commerce_product_handler_field_product','class','sites/all/modules/commerce/modules/product/includes/views/handlers/commerce_product_handler_field_product.inc','commerce_product',0),('commerce_product_handler_field_product_link','class','sites/all/modules/commerce/modules/product/includes/views/handlers/commerce_product_handler_field_product_link.inc','commerce_product',0),('commerce_product_handler_field_product_link_delete','class','sites/all/modules/commerce/modules/product/includes/views/handlers/commerce_product_handler_field_product_link_delete.inc','commerce_product',0),('commerce_product_handler_field_product_link_edit','class','sites/all/modules/commerce/modules/product/includes/views/handlers/commerce_product_handler_field_product_link_edit.inc','commerce_product',0),('commerce_product_handler_field_product_operations','class','sites/all/modules/commerce/modules/product/includes/views/handlers/commerce_product_handler_field_product_operations.inc','commerce_product',0),('commerce_product_handler_field_product_type','class','sites/all/modules/commerce/modules/product/includes/views/handlers/commerce_product_handler_field_product_type.inc','commerce_product',0),('commerce_product_handler_filter_product_type','class','sites/all/modules/commerce/modules/product/includes/views/handlers/commerce_product_handler_filter_product_type.inc','commerce_product',0),('commerce_product_reference_handler_filter_node_is_product_display','class','sites/all/modules/commerce/modules/product_reference/includes/views/handlers/commerce_product_reference_handler_filter_node_is_product_display.inc','commerce_product_reference',0),('commerce_product_reference_handler_filter_node_type','class','sites/all/modules/commerce/modules/product_reference/includes/views/handlers/commerce_product_reference_handler_filter_node_type.inc','commerce_product_reference',0),('commerce_product_reference_handler_filter_product_line_item_type','class','sites/all/modules/commerce/modules/product_reference/includes/views/handlers/commerce_product_reference_handler_filter_product_line_item_type.inc','commerce_product_reference',0),('commerce_shipping_handler_relationship_shipping_line_item_representative','class','sites/all/modules/commerce_shipping/includes/views/handlers/commerce_shipping_handler_relationship_shipping_line_item_representative.inc','commerce_shipping',0),('ConfirmFormTest','class','modules/system/system.test','system',0),('ContextConditionBookroot','class','sites/all/modules/context/tests/context.conditions.test','context',0),('ContextConditionBookTest','class','sites/all/modules/context/tests/context.conditions.test','context',0),('ContextConditionContextTest','class','sites/all/modules/context/tests/context.conditions.test','context',0),('ContextConditionLanguageTest','class','sites/all/modules/context/tests/context.conditions.test','context',0),('ContextConditionMenuTest','class','sites/all/modules/context/tests/context.conditions.test','context',0),('ContextConditionNodeTaxonomyTest','class','sites/all/modules/context/tests/context.conditions.test','context',0),('ContextConditionNodeTest','class','sites/all/modules/context/tests/context.conditions.test','context',0),('ContextConditionPathTest','class','sites/all/modules/context/tests/context.conditions.test','context',0),('ContextConditionSitewideTest','class','sites/all/modules/context/tests/context.conditions.test','context',0),('ContextConditionUserPageTest','class','sites/all/modules/context/tests/context.conditions.test','context',0),('ContextConditionUserTest','class','sites/all/modules/context/tests/context.conditions.test','context',0),('ContextReactionBlockAjaxAccessTest','class','sites/all/modules/context/tests/context.reactions.test','context',0),('ContextReactionBlockAjaxTest','class','sites/all/modules/context/tests/context.reactions.test','context',0),('ContextReactionBlockTest','class','sites/all/modules/context/tests/context.reactions.test','context',0),('ContextReactionBreadcrumbTest','class','sites/all/modules/context/tests/context.reactions.test','context',0),('ContextReactionMenuTest','class','sites/all/modules/context/tests/context.reactions.test','context',0),('ContextReactionRegionTest','class','sites/all/modules/context/tests/context.reactions.test','context',0),('ContextReactionThemeHtmlTest','class','sites/all/modules/context/tests/context.reactions.test','context',0),('ContextualDynamicContextTestCase','class','modules/contextual/contextual.test','contextual',0),('ContextUiTestCase','class','sites/all/modules/context/context_ui/tests/context_ui.test','context_ui',0),('ContextUnitTest','class','sites/all/modules/context/tests/context.test','context',0),('context_condition','class','sites/all/modules/context/plugins/context_condition.inc','context',0),('context_condition_context','class','sites/all/modules/context/plugins/context_condition_context.inc','context',0),('context_condition_context_all','class','sites/all/modules/context/plugins/context_condition_context_all.inc','context',0),('context_condition_default','class','sites/all/modules/context/plugins/context_condition_default.inc','context',0),('context_condition_language','class','sites/all/modules/context/plugins/context_condition_language.inc','context',0),('context_condition_menu','class','sites/all/modules/context/plugins/context_condition_menu.inc','context',0),('context_condition_node','class','sites/all/modules/context/plugins/context_condition_node.inc','context',0),('context_condition_node_taxonomy','class','sites/all/modules/context/plugins/context_condition_node_taxonomy.inc','context',0),('context_condition_path','class','sites/all/modules/context/plugins/context_condition_path.inc','context',0),('context_condition_query_string','class','sites/all/modules/context/plugins/context_condition_query_string.inc','context',0),('context_condition_sitewide','class','sites/all/modules/context/plugins/context_condition_sitewide.inc','context',0),('context_condition_taxonomy_term','class','sites/all/modules/context/plugins/context_condition_taxonomy_term.inc','context',0),('context_condition_user','class','sites/all/modules/context/plugins/context_condition_user.inc','context',0),('context_condition_user_page','class','sites/all/modules/context/plugins/context_condition_user_page.inc','context',0),('context_condition_views','class','sites/all/modules/context/plugins/context_condition_views.inc','context',0),('context_export_ui','class','sites/all/modules/context/context_ui/export_ui/context_export_ui.class.php','context_ui',0),('context_reaction','class','sites/all/modules/context/plugins/context_reaction.inc','context',0),('context_reaction_block','class','sites/all/modules/context/plugins/context_reaction_block.inc','context',0),('context_reaction_breadcrumb','class','sites/all/modules/context/plugins/context_reaction_breadcrumb.inc','context',0),('context_reaction_debug','class','sites/all/modules/context/plugins/context_reaction_debug.inc','context',0),('context_reaction_menu','class','sites/all/modules/context/plugins/context_reaction_menu.inc','context',0),('context_reaction_region','class','sites/all/modules/context/plugins/context_reaction_region.inc','context',0),('context_reaction_template_suggestions','class','sites/all/modules/context/plugins/context_reaction_template_suggestions.inc','context',0),('context_reaction_theme','class','sites/all/modules/context/plugins/context_reaction_theme.inc','context',0),('context_reaction_theme_html','class','sites/all/modules/context/plugins/context_reaction_theme_html.inc','context',0),('CountriesBaseImportUnitTest','class','sites/all/modules/countries/tests/countries.test','countries',0),('CountriesBaseInstallUnitTest','class','sites/all/modules/countries/tests/countries.test','countries',0),('CountriesBaseSetupTest','class','sites/all/modules/countries/tests/countries.test','countries',0),('CountriesCacheUnitTest','class','sites/all/modules/countries/tests/countries.test','countries',0),('CountriesCRUDUIUnitTest','class','sites/all/modules/countries/tests/countries.test','countries',0),('CountriesCRUDUnitTest','class','sites/all/modules/countries/tests/countries.test','countries',0),('CountriesElementUnitTest','class','sites/all/modules/countries/tests/countries.test','countries',0),('CountriesFieldUnitTest','class','sites/all/modules/countries/tests/countries.test','countries',0),('CountriesFunctionsUnitTest','class','sites/all/modules/countries/tests/countries.test','countries',0),('CronQueueTestCase','class','modules/system/system.test','system',0),('CronRunTestCase','class','modules/system/system.test','system',0),('CToolsCssCache','class','sites/all/modules/ctools/includes/css-cache.inc','ctools',0),('CtoolsObjectCache','class','sites/all/modules/ctools/tests/css_cache.test','ctools',0),('ctools_context','class','sites/all/modules/ctools/includes/context.inc','ctools',0),('ctools_context_optional','class','sites/all/modules/ctools/includes/context.inc','ctools',0),('ctools_context_required','class','sites/all/modules/ctools/includes/context.inc','ctools',0),('ctools_export_ui','class','sites/all/modules/ctools/plugins/export_ui/ctools_export_ui.class.php','ctools',0),('ctools_math_expr','class','sites/all/modules/ctools/includes/math-expr.inc','ctools',0),('ctools_math_expr_stack','class','sites/all/modules/ctools/includes/math-expr.inc','ctools',0),('ctools_stylizer_image_processor','class','sites/all/modules/ctools/includes/stylizer.inc','ctools',0),('CurrentSearchBugFixTestCase','class','sites/all/modules/facetapi/contrib/current_search/tests/current_search.test','current_search',0),('CurrentSearchGroup','class','sites/all/modules/facetapi/contrib/current_search/plugins/current_search/item_group.inc','current_search',0),('CurrentSearchInterfaceTestCase','class','sites/all/modules/facetapi/contrib/current_search/tests/current_search.test','current_search',0),('CurrentSearchItem','class','sites/all/modules/facetapi/contrib/current_search/plugins/current_search/item.inc','current_search',0),('CurrentSearchItemActive','class','sites/all/modules/facetapi/contrib/current_search/plugins/current_search/item_active.inc','current_search',0),('CurrentSearchItemText','class','sites/all/modules/facetapi/contrib/current_search/plugins/current_search/item_text.inc','current_search',0),('CurrentSearchTestCase','class','sites/all/modules/facetapi/contrib/current_search/tests/current_search.test','current_search',0),('current_search_export_ui','class','sites/all/modules/facetapi/contrib/current_search/plugins/export_ui/current_search_export_ui.class.php','current_search',0),('DashboardBlocksTestCase','class','modules/dashboard/dashboard.test','dashboard',0),('Database','class','includes/database/database.inc','',0),('DatabaseCondition','class','includes/database/query.inc','',0),('DatabaseConnection','class','includes/database/database.inc','',0),('DatabaseConnectionNotDefinedException','class','includes/database/database.inc','',0),('DatabaseConnection_mysql','class','includes/database/mysql/database.inc','',0),('DatabaseConnection_pgsql','class','includes/database/pgsql/database.inc','',0),('DatabaseConnection_sqlite','class','includes/database/sqlite/database.inc','',0),('DatabaseDriverNotSpecifiedException','class','includes/database/database.inc','',0),('DatabaseLog','class','includes/database/log.inc','',0),('DatabaseSchema','class','includes/database/schema.inc','',0),('DatabaseSchemaObjectDoesNotExistException','class','includes/database/schema.inc','',0),('DatabaseSchemaObjectExistsException','class','includes/database/schema.inc','',0),('DatabaseSchema_mysql','class','includes/database/mysql/schema.inc','',0),('DatabaseSchema_pgsql','class','includes/database/pgsql/schema.inc','',0),('DatabaseSchema_sqlite','class','includes/database/sqlite/schema.inc','',0),('DatabaseStatementBase','class','includes/database/database.inc','',0),('DatabaseStatementEmpty','class','includes/database/database.inc','',0),('DatabaseStatementInterface','interface','includes/database/database.inc','',0),('DatabaseStatementPrefetch','class','includes/database/prefetch.inc','',0),('DatabaseStatement_sqlite','class','includes/database/sqlite/database.inc','',0),('DatabaseTaskException','class','includes/install.inc','',0),('DatabaseTasks','class','includes/install.inc','',0),('DatabaseTasks_mysql','class','includes/database/mysql/install.inc','',0),('DatabaseTasks_pgsql','class','includes/database/pgsql/install.inc','',0),('DatabaseTasks_sqlite','class','includes/database/sqlite/install.inc','',0),('DatabaseTransaction','class','includes/database/database.inc','',0),('DatabaseTransactionCommitFailedException','class','includes/database/database.inc','',0),('DatabaseTransactionExplicitCommitNotAllowedException','class','includes/database/database.inc','',0),('DatabaseTransactionNameNonUniqueException','class','includes/database/database.inc','',0),('DatabaseTransactionNoActiveException','class','includes/database/database.inc','',0),('DatabaseTransactionOutOfOrderException','class','includes/database/database.inc','',0),('DateFormatTestCase','class','modules/system/system.test','system',0),('DateTimeFunctionalTest','class','modules/system/system.test','system',0),('DBLogTestCase','class','modules/dblog/dblog.test','dblog',0),('DefaultMailSystem','class','modules/system/system.mail.inc','system',0),('DeleteQuery','class','includes/database/query.inc','',0),('DeleteQuery_sqlite','class','includes/database/sqlite/query.inc','',0),('DevelMailLog','class','sites/all/modules/devel/devel.mail.inc','devel',88),('DevelMailTest','class','sites/all/modules/devel/devel.test','devel',88),('DrupalCacheArray','class','includes/bootstrap.inc','',0),('DrupalCacheInterface','interface','includes/cache.inc','',0),('DrupalCommerceEntityController','class','sites/all/modules/commerce/includes/commerce.controller.inc','commerce',1),('DrupalDatabaseCache','class','includes/cache.inc','',0),('DrupalDefaultEntityController','class','includes/entity.inc','',0),('DrupalEntityControllerInterface','interface','includes/entity.inc','',0),('DrupalFakeCache','class','includes/cache-install.inc','',0),('DrupalLocalStreamWrapper','class','includes/stream_wrappers.inc','',0),('DrupalPrivateStreamWrapper','class','includes/stream_wrappers.inc','',0),('DrupalPublicStreamWrapper','class','includes/stream_wrappers.inc','',0),('DrupalQueue','class','modules/system/system.queue.inc','system',0),('DrupalQueueInterface','interface','modules/system/system.queue.inc','system',0),('DrupalReliableQueueInterface','interface','modules/system/system.queue.inc','system',0),('DrupalSetMessageTest','class','modules/system/system.test','system',0),('DrupalStreamWrapperInterface','interface','includes/stream_wrappers.inc','',0),('DrupalTemporaryStreamWrapper','class','includes/stream_wrappers.inc','',0),('DrupalUpdateException','class','includes/update.inc','',0),('DrupalUpdaterInterface','interface','includes/updater.inc','',0),('EckInlineEntityFormController','class','sites/all/modules/eck/includes/eck.inline_entity_form.inc','eck',0),('eck_views_handler_field_link','class','sites/all/modules/eck/views/handlers/eck_views_handler_field_link.inc','eck',0),('eck_views_handler_field_link_delete','class','sites/all/modules/eck/views/handlers/eck_views_handler_field_link_delete.inc','eck',0),('eck_views_handler_field_link_edit','class','sites/all/modules/eck/views/handlers/eck_views_handler_field_link_edit.inc','eck',0),('EnableDisableTestCase','class','modules/system/system.test','system',0),('Entity','class','sites/all/modules/entity/includes/entity.inc','entity',0),('EntityAPICommentNodeAccessTestCase','class','sites/all/modules/entity/entity.test','entity',0),('EntityAPIController','class','sites/all/modules/entity/includes/entity.controller.inc','entity',0),('EntityAPIControllerExportable','class','sites/all/modules/entity/includes/entity.controller.inc','entity',0),('EntityAPIControllerInterface','interface','sites/all/modules/entity/includes/entity.controller.inc','entity',0),('EntityAPIControllerRevisionableInterface','interface','sites/all/modules/entity/includes/entity.controller.inc','entity',0),('EntityAPIi18nItegrationTestCase','class','sites/all/modules/entity/entity.test','entity',0),('EntityAPIRulesIntegrationTestCase','class','sites/all/modules/entity/entity.test','entity',0),('EntityAPITestCase','class','sites/all/modules/entity/entity.test','entity',0),('EntityBundleableUIController','class','sites/all/modules/entity/includes/entity.ui.inc','entity',0),('EntityContentUIController','class','sites/all/modules/entity/includes/entity.ui.inc','entity',0),('EntityDB','class','sites/all/modules/entity/includes/entity.inc','entity',0),('EntityDBExtendable','class','sites/all/modules/entity/includes/entity.inc','entity',0),('EntityDefaultExtraFieldsController','class','sites/all/modules/entity/entity.info.inc','entity',0),('EntityDefaultFeaturesController','class','sites/all/modules/entity/entity.features.inc','entity',0),('EntityDefaultI18nStringController','class','sites/all/modules/entity/entity.i18n.inc','entity',0),('EntityDefaultMetadataController','class','sites/all/modules/entity/entity.info.inc','entity',0),('EntityDefaultRulesController','class','sites/all/modules/entity/entity.rules.inc','entity',0),('EntityDefaultUIController','class','sites/all/modules/entity/includes/entity.ui.inc','entity',0),('EntityDefaultViewsController','class','sites/all/modules/entity/views/entity.views.inc','entity',0),('EntityDrupalWrapper','class','sites/all/modules/entity/includes/entity.wrapper.inc','entity',0),('EntityExtendable','class','sites/all/modules/entity/includes/entity.inc','entity',0),('EntityExtraFieldsControllerInterface','interface','sites/all/modules/entity/entity.info.inc','entity',0),('EntityFieldHandlerHelper','class','sites/all/modules/entity/views/handlers/entity_views_field_handler_helper.inc','entity',0),('EntityFieldQuery','class','includes/entity.inc','',0),('EntityFieldQueryException','class','includes/entity.inc','',0),('EntityInlineEntityFormController','class','sites/all/modules/inline_entity_form/includes/entity.inline_entity_form.inc','inline_entity_form',0),('EntityListWrapper','class','sites/all/modules/entity/includes/entity.wrapper.inc','entity',0),('EntityMalformedException','class','includes/entity.inc','',0),('EntityMetadataArrayObject','class','sites/all/modules/entity/includes/entity.wrapper.inc','entity',0),('EntityMetadataIntegrationTestCase','class','sites/all/modules/entity/entity.test','entity',0),('EntityMetadataNodeAccessTestCase','class','sites/all/modules/entity/entity.test','entity',0),('EntityMetadataNodeCreateAccessTestCase','class','sites/all/modules/entity/entity.test','entity',0),('EntityMetadataNodeRevisionAccessTestCase','class','sites/all/modules/entity/entity.test','entity',0),('EntityMetadataTestCase','class','sites/all/modules/entity/entity.test','entity',0),('EntityMetadataWrapper','class','sites/all/modules/entity/includes/entity.wrapper.inc','entity',0),('EntityMetadataWrapperException','class','sites/all/modules/entity/includes/entity.wrapper.inc','entity',0),('EntityMetadataWrapperIterator','class','sites/all/modules/entity/includes/entity.wrapper.inc','entity',0),('EntityPropertiesTestCase','class','modules/field/tests/field.test','field',0),('EntityReferenceAdminTestCase','class','sites/all/modules/entityreference/tests/entityreference.admin.test','entityreference',0),('EntityReferenceBehavior_TaxonomyIndex','class','sites/all/modules/entityreference/plugins/behavior/EntityReferenceBehavior_TaxonomyIndex.class.php','entityreference',0),('EntityReferenceBehavior_ViewsFilterSelect','class','sites/all/modules/entityreference/plugins/behavior/EntityReferenceBehavior_ViewsFilterSelect.class.php','entityreference',0),('EntityReferenceHandlersTestCase','class','sites/all/modules/entityreference/tests/entityreference.handlers.test','entityreference',0),('EntityReferenceTaxonomyTestCase','class','sites/all/modules/entityreference/tests/entityreference.taxonomy.test','entityreference',0),('EntityReference_BehaviorHandler','interface','sites/all/modules/entityreference/plugins/behavior/abstract.inc','entityreference',0),('EntityReference_BehaviorHandler_Abstract','class','sites/all/modules/entityreference/plugins/behavior/abstract.inc','entityreference',0),('EntityReference_BehaviorHandler_Broken','class','sites/all/modules/entityreference/plugins/behavior/abstract.inc','entityreference',0),('entityreference_plugin_display','class','sites/all/modules/entityreference/views/entityreference_plugin_display.inc','entityreference',0),('entityreference_plugin_row_fields','class','sites/all/modules/entityreference/views/entityreference_plugin_row_fields.inc','entityreference',0),('entityreference_plugin_style','class','sites/all/modules/entityreference/views/entityreference_plugin_style.inc','entityreference',0),('EntityReference_SelectionHandler','interface','sites/all/modules/entityreference/plugins/selection/abstract.inc','entityreference',0),('EntityReference_SelectionHandler_Broken','class','sites/all/modules/entityreference/plugins/selection/abstract.inc','entityreference',0),('EntityReference_SelectionHandler_Commerce_Store','class','sites/all/modules/commerce_marketplace/modules/commerce_store_access/plugins/selection/EntityReference_SelectionHandler_Commerce_Store.class.php','commerce_store_access',0),('EntityReference_SelectionHandler_Generic','class','sites/all/modules/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','entityreference',0),('EntityReference_SelectionHandler_Generic_comment','class','sites/all/modules/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','entityreference',0),('EntityReference_SelectionHandler_Generic_file','class','sites/all/modules/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','entityreference',0),('EntityReference_SelectionHandler_Generic_node','class','sites/all/modules/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','entityreference',0),('EntityReference_SelectionHandler_Generic_taxonomy_term','class','sites/all/modules/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','entityreference',0),('EntityReference_SelectionHandler_Generic_user','class','sites/all/modules/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','entityreference',0),('EntityReference_SelectionHandler_Views','class','sites/all/modules/entityreference/plugins/selection/EntityReference_SelectionHandler_Views.class.php','entityreference',0),('EntityStructureWrapper','class','sites/all/modules/entity/includes/entity.wrapper.inc','entity',0),('EntityTokenTestCase','class','sites/all/modules/entity/entity.test','entity',0),('EntityTranslationCommerceProductHandler','class','sites/all/modules/commerce/modules/product/includes/commerce_product.translation_handler.inc','commerce_product',0),('EntityValueWrapper','class','sites/all/modules/entity/includes/entity.wrapper.inc','entity',0),('EntityWebTestCase','class','sites/all/modules/entity/entity.test','entity',0),('entity_views_handler_area_entity','class','sites/all/modules/entity/views/handlers/entity_views_handler_area_entity.inc','entity',0),('entity_views_handler_field_boolean','class','sites/all/modules/entity/views/handlers/entity_views_handler_field_boolean.inc','entity',0),('entity_views_handler_field_date','class','sites/all/modules/entity/views/handlers/entity_views_handler_field_date.inc','entity',0),('entity_views_handler_field_duration','class','sites/all/modules/entity/views/handlers/entity_views_handler_field_duration.inc','entity',0),('entity_views_handler_field_entity','class','sites/all/modules/entity/views/handlers/entity_views_handler_field_entity.inc','entity',0),('entity_views_handler_field_field','class','sites/all/modules/entity/views/handlers/entity_views_handler_field_field.inc','entity',0),('entity_views_handler_field_numeric','class','sites/all/modules/entity/views/handlers/entity_views_handler_field_numeric.inc','entity',0),('entity_views_handler_field_options','class','sites/all/modules/entity/views/handlers/entity_views_handler_field_options.inc','entity',0),('entity_views_handler_field_text','class','sites/all/modules/entity/views/handlers/entity_views_handler_field_text.inc','entity',0),('entity_views_handler_field_uri','class','sites/all/modules/entity/views/handlers/entity_views_handler_field_uri.inc','entity',0),('entity_views_handler_relationship','class','sites/all/modules/entity/views/handlers/entity_views_handler_relationship.inc','entity',0),('entity_views_handler_relationship_by_bundle','class','sites/all/modules/entity/views/handlers/entity_views_handler_relationship_by_bundle.inc','entity',0),('entity_views_plugin_row_entity_view','class','sites/all/modules/entity/views/plugins/entity_views_plugin_row_entity_view.inc','entity',0),('FacesExtendable','class','sites/all/modules/rules/includes/faces.inc','rules',20),('FacesExtendableException','class','sites/all/modules/rules/includes/faces.inc','rules',20),('FacesExtender','class','sites/all/modules/rules/includes/faces.inc','rules',20),('FacesExtenderInterface','interface','sites/all/modules/rules/includes/faces.inc','rules',20),('FacetapiAdapter','class','sites/all/modules/facetapi/plugins/facetapi/adapter.inc','facetapi',0),('FacetapiAdminInterfaceTestCase','class','sites/all/modules/facetapi/tests/facetapi.test','facetapi',0),('FacetapiApiFunctions','class','sites/all/modules/facetapi/tests/facetapi.test','facetapi',0),('FacetapiBugFixTestCase','class','sites/all/modules/facetapi/tests/facetapi.test','facetapi',0),('FacetapiDependency','class','sites/all/modules/facetapi/plugins/facetapi/dependency.inc','facetapi',0),('FacetapiDependencyBundle','class','sites/all/modules/facetapi/plugins/facetapi/dependency_bundle.inc','facetapi',0),('FacetapiDependencyRole','class','sites/all/modules/facetapi/plugins/facetapi/dependency_role.inc','facetapi',0),('FacetapiEmptyBehavior','class','sites/all/modules/facetapi/plugins/facetapi/empty_behavior.inc','facetapi',0),('FacetapiEmptyBehaviorNone','class','sites/all/modules/facetapi/plugins/facetapi/empty_behavior.inc','facetapi',0),('FacetapiEmptyBehaviorText','class','sites/all/modules/facetapi/plugins/facetapi/empty_behavior_text.inc','facetapi',0),('FacetapiFacet','class','sites/all/modules/facetapi/plugins/facetapi/adapter.inc','facetapi',0),('FacetapiFacetProcessor','class','sites/all/modules/facetapi/plugins/facetapi/adapter.inc','facetapi',0),('FacetapiFilter','class','sites/all/modules/facetapi/plugins/facetapi/filter.inc','facetapi',0),('FacetapiFilterActiveItems','class','sites/all/modules/facetapi/plugins/facetapi/filter.inc','facetapi',0),('FacetapiFilterCurrentDepth','class','sites/all/modules/facetapi/plugins/facetapi/filter.inc','facetapi',0),('FacetapiQueryType','class','sites/all/modules/facetapi/plugins/facetapi/query_type.inc','facetapi',0),('FacetapiQueryTypeDate','class','sites/all/modules/facetapi/plugins/facetapi/query_type.inc','facetapi',0),('FacetapiQueryTypeInterface','interface','sites/all/modules/facetapi/plugins/facetapi/query_type.inc','facetapi',0),('FacetapiQueryTypeRange','class','sites/all/modules/facetapi/plugins/facetapi/query_type.inc','facetapi',0),('FacetapiSearchPageInterfaceTestCase','class','sites/all/modules/facetapi/tests/facetapi.test','facetapi',0),('FacetapiTestAdapter','class','sites/all/modules/facetapi/tests/facetapi_test.plugins.inc','facetapi',0),('FacetapiTestCase','class','sites/all/modules/facetapi/tests/facetapi.test','facetapi',0),('FacetapiTestNonterm','class','sites/all/modules/facetapi/tests/facetapi_test.plugins.inc','facetapi',0),('FacetapiTestTerm','class','sites/all/modules/facetapi/tests/facetapi_test.plugins.inc','facetapi',0),('FacetapiTestWidgetNonterm','class','sites/all/modules/facetapi/tests/facetapi_test.plugins.inc','facetapi',0),('FacetapiUrlProcessor','class','sites/all/modules/facetapi/plugins/facetapi/url_processor.inc','facetapi',0),('FacetapiUrlProcessorStandard','class','sites/all/modules/facetapi/plugins/facetapi/url_processor_standard.inc','facetapi',0),('FacetapiWidget','class','sites/all/modules/facetapi/plugins/facetapi/widget.inc','facetapi',0),('FacetapiWidgetCheckboxLinks','class','sites/all/modules/facetapi/plugins/facetapi/widget_links.inc','facetapi',0),('FacetapiWidgetLinks','class','sites/all/modules/facetapi/plugins/facetapi/widget_links.inc','facetapi',0),('FeaturesCtoolsIntegrationTest','class','sites/all/modules/features/tests/features.test','features',20),('FeaturesDetectionTestCase','class','sites/all/modules/features/tests/features.test','features',20),('FeaturesEnableTestCase','class','sites/all/modules/features/tests/features.test','features',20),('FeaturesUserTestCase','class','sites/all/modules/features/tests/features.test','features',20),('FeedsMapperFieldTestCase','class','sites/all/modules/entityreference/tests/entityreference.feeds.test','entityreference',0),('FieldAttachOtherTestCase','class','modules/field/tests/field.test','field',0),('FieldAttachStorageTestCase','class','modules/field/tests/field.test','field',0),('FieldAttachTestCase','class','modules/field/tests/field.test','field',0),('FieldBulkDeleteTestCase','class','modules/field/tests/field.test','field',0),('FieldCollectionBasicTestCase','class','sites/all/modules/field_collection/field_collection.test','field_collection',0),('FieldCollectionContentTranslationTestCase','class','sites/all/modules/field_collection/field_collection.test','field_collection',0),('FieldCollectionItemMetadataController','class','sites/all/modules/field_collection/field_collection.info.inc','field_collection',0),('FieldCollectionRulesIntegrationTestCase','class','sites/all/modules/field_collection/field_collection.test','field_collection',0),('FieldCrudTestCase','class','modules/field/tests/field.test','field',0),('FieldDisplayAPITestCase','class','modules/field/tests/field.test','field',0),('FieldException','class','modules/field/field.module','field',0),('FieldFormTestCase','class','modules/field/tests/field.test','field',0),('FieldInfo','class','modules/field/field.info.class.inc','field',0),('FieldInfoTestCase','class','modules/field/tests/field.test','field',0),('FieldInstanceCrudTestCase','class','modules/field/tests/field.test','field',0),('FieldsOverlapException','class','includes/database/database.inc','',0),('FieldSqlStorageTestCase','class','modules/field/modules/field_sql_storage/field_sql_storage.test','field_sql_storage',0),('FieldTestCase','class','modules/field/tests/field.test','field',0),('FieldTranslationsTestCase','class','modules/field/tests/field.test','field',0),('FieldUIAlterTestCase','class','modules/field_ui/field_ui.test','field_ui',0),('FieldUIManageDisplayTestCase','class','modules/field_ui/field_ui.test','field_ui',0),('FieldUIManageFieldsTestCase','class','modules/field_ui/field_ui.test','field_ui',0),('FieldUITestCase','class','modules/field_ui/field_ui.test','field_ui',0),('FieldUpdateForbiddenException','class','modules/field/field.module','field',0),('FieldValidationException','class','modules/field/field.attach.inc','field',0),('field_collection_handler_relationship','class','sites/all/modules/field_collection/views/field_collection_handler_relationship.inc','field_collection',0),('FileFieldAnonymousSubmission','class','modules/file/tests/file.test','file',0),('FileFieldDisplayTestCase','class','modules/file/tests/file.test','file',0),('FileFieldPathTestCase','class','modules/file/tests/file.test','file',0),('FileFieldRevisionTestCase','class','modules/file/tests/file.test','file',0),('FileFieldTestCase','class','modules/file/tests/file.test','file',0),('FileFieldValidateTestCase','class','modules/file/tests/file.test','file',0),('FileFieldWidgetTestCase','class','modules/file/tests/file.test','file',0),('FileManagedFileElementTestCase','class','modules/file/tests/file.test','file',0),('FilePrivateTestCase','class','modules/file/tests/file.test','file',0),('FileTaxonomyTermTestCase','class','modules/file/tests/file.test','file',0),('FileTokenReplaceTestCase','class','modules/file/tests/file.test','file',0),('FileTransfer','class','includes/filetransfer/filetransfer.inc','',0),('FileTransferChmodInterface','interface','includes/filetransfer/filetransfer.inc','',0),('FileTransferException','class','includes/filetransfer/filetransfer.inc','',0),('FileTransferFTP','class','includes/filetransfer/ftp.inc','',0),('FileTransferFTPExtension','class','includes/filetransfer/ftp.inc','',0),('FileTransferLocal','class','includes/filetransfer/local.inc','',0),('FileTransferSSH','class','includes/filetransfer/ssh.inc','',0),('FilterAdminTestCase','class','modules/filter/filter.test','filter',0),('FilterCRUDTestCase','class','modules/filter/filter.test','filter',0),('FilterDefaultFormatTestCase','class','modules/filter/filter.test','filter',0),('FilterDOMSerializeTestCase','class','modules/filter/filter.test','filter',0),('FilterFormatAccessTestCase','class','modules/filter/filter.test','filter',0),('FilterHooksTestCase','class','modules/filter/filter.test','filter',0),('FilterNoFormatTestCase','class','modules/filter/filter.test','filter',0),('FilterSecurityTestCase','class','modules/filter/filter.test','filter',0),('FilterSettingsTestCase','class','modules/filter/filter.test','filter',0),('FilterUnitTestCase','class','modules/filter/filter.test','filter',0),('FivestarBaseTestCase','class','sites/all/modules/fivestar/test/fivestar.base.test','fivestar',0),('FivestarTestCase','class','sites/all/modules/fivestar/test/fivestar.field.test','fivestar',0),('FlexsliderTestCase','class','sites/all/modules/flexslider/flexslider.test','flexslider',0),('FloodFunctionalTest','class','modules/system/system.test','system',0),('FrontPageTestCase','class','modules/system/system.test','system',0),('GroupDisplayTestCase','class','sites/all/modules/field_group/tests/field_group.display.test','field_group',1),('GroupUITestCase','class','sites/all/modules/field_group/tests/field_group.ui.test','field_group',1),('HelpTestCase','class','modules/help/help.test','help',0),('HookRequirementsTestCase','class','modules/system/system.test','system',0),('ImageAdminStylesUnitTest','class','modules/image/image.test','image',0),('ImageAdminUiTestCase','class','modules/image/image.test','image',0),('ImageDimensionsScaleTestCase','class','modules/image/image.test','image',0),('ImageDimensionsTestCase','class','modules/image/image.test','image',0),('ImageEffectsUnitTest','class','modules/image/image.test','image',0),('ImageFieldDefaultImagesTestCase','class','modules/image/image.test','image',0),('ImageFieldDisplayTestCase','class','modules/image/image.test','image',0),('ImageFieldTestCase','class','modules/image/image.test','image',0),('ImageFieldValidateTestCase','class','modules/image/image.test','image',0),('ImageStyleFlushTest','class','modules/image/image.test','image',0),('ImageStylesPathAndUrlTestCase','class','modules/image/image.test','image',0),('ImageThemeFunctionWebTestCase','class','modules/image/image.test','image',0),('InfoFileParserTestCase','class','modules/system/system.test','system',0),('InsertQuery','class','includes/database/query.inc','',0),('InsertQuery_mysql','class','includes/database/mysql/query.inc','',0),('InsertQuery_pgsql','class','includes/database/pgsql/query.inc','',0),('InsertQuery_sqlite','class','includes/database/sqlite/query.inc','',0),('InvalidMergeQueryException','class','includes/database/database.inc','',0),('IPAddressBlockingTestCase','class','modules/system/system.test','system',0),('jcarousel_style_plugin','class','sites/all/modules/jcarousel/includes/jcarousel_style_plugin.inc','jcarousel',0),('LibrariesTestCase','class','sites/all/modules/libraries/tests/libraries.test','libraries',0),('LibrariesUnitTestCase','class','sites/all/modules/libraries/tests/libraries.test','libraries',0),('LinkAttributeCrudTest','class','sites/all/modules/link/tests/link.attribute.test','link',0),('LinkBaseTestClass','class','sites/all/modules/link/tests/link.test','link',0),('LinkContentCrudTest','class','sites/all/modules/link/tests/link.crud.test','link',0),('LinkTokenTest','class','sites/all/modules/link/tests/link.token.test','link',0),('LinkUITest','class','sites/all/modules/link/tests/link.crud_browser.test','link',0),('LinkValidateSpecificURL','class','sites/all/modules/link/tests/link.validate.test','link',0),('LinkValidateTest','class','sites/all/modules/link/tests/link.validate.test','link',0),('LinkValidateTestCase','class','sites/all/modules/link/tests/link.validate.test','link',0),('LinkValidateTestNews','class','sites/all/modules/link/tests/link.validate.test','link',0),('LinkValidateUrlLight','class','sites/all/modules/link/tests/link.validate.test','link',0),('link_views_handler_argument_target','class','sites/all/modules/link/views/link_views_handler_argument_target.inc','link',0),('link_views_handler_filter_protocol','class','sites/all/modules/link/views/link_views_handler_filter_protocol.inc','link',0),('ListDynamicValuesTestCase','class','modules/field/modules/list/tests/list.test','list',0),('ListDynamicValuesValidationTestCase','class','modules/field/modules/list/tests/list.test','list',0),('ListFieldTestCase','class','modules/field/modules/list/tests/list.test','list',0),('ListFieldUITestCase','class','modules/field/modules/list/tests/list.test','list',0),('LocaleBrowserDetectionTest','class','modules/locale/locale.test','locale',0),('LocaleCommentLanguageFunctionalTest','class','modules/locale/locale.test','locale',0),('LocaleConfigurationTest','class','modules/locale/locale.test','locale',0),('LocaleContentFunctionalTest','class','modules/locale/locale.test','locale',0),('LocaleCSSAlterTest','class','modules/locale/locale.test','locale',0),('LocaleDateFormatsFunctionalTest','class','modules/locale/locale.test','locale',0),('LocaleExportFunctionalTest','class','modules/locale/locale.test','locale',0),('LocaleImportFunctionalTest','class','modules/locale/locale.test','locale',0),('LocaleInstallTest','class','modules/locale/locale.test','locale',0),('LocaleJavascriptTranslationTest','class','modules/locale/locale.test','locale',0),('LocaleLanguageNegotiationInfoFunctionalTest','class','modules/locale/locale.test','locale',0),('LocaleLanguageSwitchingFunctionalTest','class','modules/locale/locale.test','locale',0),('LocaleLibraryInfoAlterTest','class','modules/locale/locale.test','locale',0),('LocaleMultilingualFieldsFunctionalTest','class','modules/locale/locale.test','locale',0),('LocalePathFunctionalTest','class','modules/locale/locale.test','locale',0),('LocalePluralFormatTest','class','modules/locale/locale.test','locale',0),('LocaleStringIsSafeTest','class','modules/locale/locale.test','locale',0),('LocaleTranslationFunctionalTest','class','modules/locale/locale.test','locale',0),('LocaleUILanguageNegotiationTest','class','modules/locale/locale.test','locale',0),('LocaleUninstallFrenchFunctionalTest','class','modules/locale/locale.test','locale',0),('LocaleUninstallFunctionalTest','class','modules/locale/locale.test','locale',0),('LocaleUrlRewritingTest','class','modules/locale/locale.test','locale',0),('LocaleUserCreationTest','class','modules/locale/locale.test','locale',0),('LocaleUserLanguageFunctionalTest','class','modules/locale/locale.test','locale',0),('MailSystemInterface','interface','includes/mail.inc','',0),('MemoryQueue','class','modules/system/system.queue.inc','system',0),('MenuNodeTestCase','class','modules/menu/menu.test','menu',0),('MenuTestCase','class','modules/menu/menu.test','menu',0),('MenuTokenTestCase','class','sites/all/modules/menu_token/menu_token.test','menu_token',0),('menu_token_entity_context','class','sites/all/modules/menu_token/plugins/menu_token_entity_context.inc','menu_token',0),('menu_token_entity_random','class','sites/all/modules/menu_token/plugins/menu_token_entity_random.inc','menu_token',0),('menu_token_entity_user_defined','class','sites/all/modules/menu_token/plugins/menu_token_entity_user_defined.inc','menu_token',0),('MergeQuery','class','includes/database/query.inc','',0),('MigrateAddressFieldHandler','class','sites/all/modules/addressfield/addressfield.migrate.inc','addressfield',0),('MigrateCountryFieldHandler','class','sites/all/modules/countries/countries.migrate.inc','countries',0),('MigrateDestinationFieldCollection','class','sites/all/modules/field_collection/field_collection.migrate.inc','field_collection',0),('MigrateEntityReferenceFieldHandler','class','sites/all/modules/entityreference/entityreference.migrate.inc','entityreference',0),('MigrateLinkFieldHandler','class','sites/all/modules/link/link.migrate.inc','link',0),('ModuleDependencyTestCase','class','modules/system/system.test','system',0),('ModuleRequiredTestCase','class','modules/system/system.test','system',0),('ModuleTestCase','class','modules/system/system.test','system',0),('ModuleUpdater','class','modules/system/system.updater.inc','system',0),('ModuleVersionTestCase','class','modules/system/system.test','system',0),('MultiStepNodeFormBasicOptionsTest','class','modules/node/node.test','node',0),('NewDefaultThemeBlocks','class','modules/block/block.test','block',-5),('NodeAccessBaseTableTestCase','class','modules/node/node.test','node',0),('NodeAccessFieldTestCase','class','modules/node/node.test','node',0),('NodeAccessPagerTestCase','class','modules/node/node.test','node',0),('NodeAccessRebuildTestCase','class','modules/node/node.test','node',0),('NodeAccessRecordsTestCase','class','modules/node/node.test','node',0),('NodeAccessTestCase','class','modules/node/node.test','node',0),('NodeAdminTestCase','class','modules/node/node.test','node',0),('NodeBlockFunctionalTest','class','modules/node/node.test','node',0),('NodeBlockTestCase','class','modules/node/node.test','node',0),('NodeBuildContent','class','modules/node/node.test','node',0),('NodeController','class','modules/node/node.module','node',0),('NodeCreationTestCase','class','modules/node/node.test','node',0),('NodeEntityFieldQueryAlter','class','modules/node/node.test','node',0),('NodeEntityViewModeAlterTest','class','modules/node/node.test','node',0),('NodeFeedTestCase','class','modules/node/node.test','node',0),('NodeInlineEntityFormController','class','sites/all/modules/inline_entity_form/includes/node.inline_entity_form.inc','inline_entity_form',0),('NodeLoadHooksTestCase','class','modules/node/node.test','node',0),('NodeLoadMultipleTestCase','class','modules/node/node.test','node',0),('NodeMultiByteUtf8Test','class','modules/node/node.test','node',0),('NodePageCacheTest','class','modules/node/node.test','node',0),('NodePostSettingsTestCase','class','modules/node/node.test','node',0),('NodeQueryAlter','class','modules/node/node.test','node',0),('NodeRevisionPermissionsTestCase','class','modules/node/node.test','node',0),('NodeRevisionsTestCase','class','modules/node/node.test','node',0),('NodeRSSContentTestCase','class','modules/node/node.test','node',0),('NodeSaveTestCase','class','modules/node/node.test','node',0),('NodeTitleTestCase','class','modules/node/node.test','node',0),('NodeTitleXSSTestCase','class','modules/node/node.test','node',0),('NodeTokenReplaceTestCase','class','modules/node/node.test','node',0),('NodeTypePersistenceTestCase','class','modules/node/node.test','node',0),('NodeTypeTestCase','class','modules/node/node.test','node',0),('NodeWebTestCase','class','modules/node/node.test','node',0),('NoFieldsException','class','includes/database/database.inc','',0),('NoHelpTestCase','class','modules/help/help.test','help',0),('NonDefaultBlockAdmin','class','modules/block/block.test','block',-5),('NumberFieldTestCase','class','modules/field/modules/number/number.test','number',0),('OptionsSelectDynamicValuesTestCase','class','modules/field/modules/options/options.test','options',0),('OptionsWidgetsTestCase','class','modules/field/modules/options/options.test','options',0),('PageEditTestCase','class','modules/node/node.test','node',0),('PageNotFoundTestCase','class','modules/system/system.test','system',0),('PagePreviewTestCase','class','modules/node/node.test','node',0),('PagerDefault','class','includes/pager.inc','',0),('PageTitleFiltering','class','modules/system/system.test','system',0),('PageViewTestCase','class','modules/node/node.test','node',0),('PathautoBulkUpdateTestCase','class','sites/all/modules/pathauto/pathauto.test','pathauto',1),('PathautoFunctionalTestCase','class','sites/all/modules/pathauto/pathauto.test','pathauto',1),('PathautoFunctionalTestHelper','class','sites/all/modules/pathauto/pathauto.test','pathauto',1),('PathautoLocaleTestCase','class','sites/all/modules/pathauto/pathauto.test','pathauto',1),('PathautoTestHelper','class','sites/all/modules/pathauto/pathauto.test','pathauto',1),('PathautoTokenTestCase','class','sites/all/modules/pathauto/pathauto.test','pathauto',1),('PathautoUnitTestCase','class','sites/all/modules/pathauto/pathauto.test','pathauto',1),('PathLanguageTestCase','class','modules/path/path.test','path',0),('PathLanguageUITestCase','class','modules/path/path.test','path',0),('PathMonolingualTestCase','class','modules/path/path.test','path',0),('PathTaxonomyTermTestCase','class','modules/path/path.test','path',0),('PathTestCase','class','modules/path/path.test','path',0),('PHPAccessTestCase','class','modules/php/php.test','php',0),('PHPFilterTestCase','class','modules/php/php.test','php',0),('PHPTestCase','class','modules/php/php.test','php',0),('Query','class','includes/database/query.inc','',0),('QueryAlterableInterface','interface','includes/database/query.inc','',0),('QueryConditionInterface','interface','includes/database/query.inc','',0),('QueryExtendableInterface','interface','includes/database/select.inc','',0),('QueryPlaceholderInterface','interface','includes/database/query.inc','',0),('QueueTestCase','class','modules/system/system.test','system',0),('recently_read_handler_filter_current','class','sites/all/modules/recently_read/includes/recently_read_handler_filter_current.inc','recently_read',0),('recently_read_handler_filter_entity_type','class','sites/all/modules/recently_read/includes/recently_read_handler_filter_entity_type.inc','recently_read',0),('RetrieveFileTestCase','class','modules/system/system.test','system',0),('Rule','class','sites/all/modules/rules/includes/rules.plugins.inc','rules',20),('RulesAbstractPlugin','class','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesAbstractPluginDefaults','class','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesAbstractPluginUI','class','sites/all/modules/rules/ui/ui.core.inc','rules',20),('RulesAction','class','sites/all/modules/rules/includes/rules.plugins.inc','rules',20),('RulesActionContainer','class','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesActionContainerUI','class','sites/all/modules/rules/ui/ui.core.inc','rules',20),('RulesActionHandlerBase','class','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesActionHandlerInterface','interface','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesActionInterface','interface','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesActionSet','class','sites/all/modules/rules/includes/rules.plugins.inc','rules',20),('RulesAnd','class','sites/all/modules/rules/includes/rules.plugins.inc','rules',20),('RulesCondition','class','sites/all/modules/rules/includes/rules.plugins.inc','rules',20),('RulesConditionContainer','class','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesConditionContainerUI','class','sites/all/modules/rules/ui/ui.core.inc','rules',20),('RulesConditionHandlerBase','class','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesConditionHandlerInterface','interface','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesConditionInterface','interface','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesContainerPlugin','class','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesContainerPluginUI','class','sites/all/modules/rules/ui/ui.core.inc','rules',20),('RulesData','class','sites/all/modules/rules/includes/rules.state.inc','rules',20),('RulesDataDirectInputFormInterface','interface','sites/all/modules/rules/ui/ui.data.inc','rules',20),('RulesDataInputEvaluator','class','sites/all/modules/rules/includes/rules.processor.inc','rules',20),('RulesDataInputOptionsListInterface','interface','sites/all/modules/rules/ui/ui.data.inc','rules',20),('RulesDataProcessor','class','sites/all/modules/rules/includes/rules.processor.inc','rules',20),('RulesDataUI','class','sites/all/modules/rules/ui/ui.data.inc','rules',20),('RulesDataUIBoolean','class','sites/all/modules/rules/ui/ui.data.inc','rules',20),('RulesDataUIBundleEntity','class','sites/all/modules/rules/ui/ui.data.inc','rules',20),('RulesDataUICommercePrice','class','sites/all/modules/commerce/modules/price/commerce_price.rules.inc','commerce_price',0),('RulesDataUIDate','class','sites/all/modules/rules/ui/ui.data.inc','rules',20),('RulesDataUIDecimal','class','sites/all/modules/rules/ui/ui.data.inc','rules',20),('RulesDataUIDuration','class','sites/all/modules/rules/ui/ui.data.inc','rules',20),('RulesDataUIEntity','class','sites/all/modules/rules/ui/ui.data.inc','rules',20),('RulesDataUIEntityExportable','class','sites/all/modules/rules/ui/ui.data.inc','rules',20),('RulesDataUIInteger','class','sites/all/modules/rules/ui/ui.data.inc','rules',20),('RulesDataUIIPAddress','class','sites/all/modules/rules/ui/ui.data.inc','rules',20),('RulesDataUIListEntity','class','sites/all/modules/rules/ui/ui.data.inc','rules',20),('RulesDataUIListInteger','class','sites/all/modules/rules/ui/ui.data.inc','rules',20),('RulesDataUIListText','class','sites/all/modules/rules/ui/ui.data.inc','rules',20),('RulesDataUIListToken','class','sites/all/modules/rules/ui/ui.data.inc','rules',20),('RulesDataUIPaymentSettings','class','sites/all/modules/commerce/modules/payment/commerce_payment.rules.inc','commerce_payment',0),('RulesDataUITaxonomyVocabulary','class','sites/all/modules/rules/ui/ui.data.inc','rules',20),('RulesDataUIText','class','sites/all/modules/rules/ui/ui.data.inc','rules',20),('RulesDataUITextFormatted','class','sites/all/modules/rules/ui/ui.data.inc','rules',20),('RulesDataUITextToken','class','sites/all/modules/rules/ui/ui.data.inc','rules',20),('RulesDataUIURI','class','sites/all/modules/rules/ui/ui.data.inc','rules',20),('RulesDataWrapperSavableInterface','interface','sites/all/modules/rules/includes/rules.state.inc','rules',20),('RulesDateInputEvaluator','class','sites/all/modules/rules/modules/rules_core.eval.inc','rules',20),('RulesDateOffsetProcessor','class','sites/all/modules/rules/modules/rules_core.eval.inc','rules',20),('RulesDependencyException','class','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesElementMap','class','sites/all/modules/rules/ui/ui.core.inc','rules',20),('RulesEntityController','class','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesEvaluationException','class','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesEventDefaultHandler','class','sites/all/modules/rules/includes/rules.event.inc','rules',20),('RulesEventDispatcherInterface','interface','sites/all/modules/rules/includes/rules.event.inc','rules',20),('RulesEventDispatcherTestCase','class','sites/all/modules/rules/tests/rules.test','rules',20),('RulesEventHandlerBase','class','sites/all/modules/rules/includes/rules.event.inc','rules',20),('RulesEventHandlerEntityBundle','class','sites/all/modules/rules/includes/rules.event.inc','rules',20),('RulesEventHandlerInterface','interface','sites/all/modules/rules/includes/rules.event.inc','rules',20),('RulesEventSet','class','sites/all/modules/rules/includes/rules.plugins.inc','rules',20),('RulesException','class','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesExtendable','class','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesFeaturesController','class','sites/all/modules/rules/rules.features.inc','rules',20),('RulesIdentifiableDataWrapper','class','sites/all/modules/rules/includes/rules.state.inc','rules',20),('RulesIntegrationTestCase','class','sites/all/modules/rules/tests/rules.test','rules',20),('RulesIntegrityException','class','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesInvocationEnabledTestCase','class','sites/all/modules/rules/tests/rules.test','rules',20),('RulesLog','class','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesLoop','class','sites/all/modules/rules/includes/rules.plugins.inc','rules',20),('RulesLoopUI','class','sites/all/modules/rules/ui/ui.plugins.inc','rules',20),('RulesNodeConditionBase','class','sites/all/modules/rules/modules/node.eval.inc','rules',20),('RulesNodeConditionPromoted','class','sites/all/modules/rules/modules/node.eval.inc','rules',20),('RulesNodeConditionPublished','class','sites/all/modules/rules/modules/node.eval.inc','rules',20),('RulesNodeConditionSticky','class','sites/all/modules/rules/modules/node.eval.inc','rules',20),('RulesNodeConditionType','class','sites/all/modules/rules/modules/node.eval.inc','rules',20),('RulesNumericOffsetProcessor','class','sites/all/modules/rules/modules/rules_core.eval.inc','rules',20),('RulesOptimizationInterface','interface','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesOr','class','sites/all/modules/rules/includes/rules.plugins.inc','rules',20),('RulesPHPDataProcessor','class','sites/all/modules/rules/modules/php.eval.inc','rules',20),('RulesPHPEvaluator','class','sites/all/modules/rules/modules/php.eval.inc','rules',20),('RulesPlugin','class','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesPluginFeaturesIntegrationInterace','interface','sites/all/modules/rules/rules.features.inc','rules',20),('RulesPluginHandlerBase','class','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesPluginHandlerInterface','interface','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesPluginImplInterface','interface','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesPluginUI','class','sites/all/modules/rules/ui/ui.core.inc','rules',20),('RulesPluginUIInterface','interface','sites/all/modules/rules/ui/ui.core.inc','rules',20),('RulesReactionRule','class','sites/all/modules/rules/includes/rules.plugins.inc','rules',20),('RulesReactionRuleUI','class','sites/all/modules/rules/ui/ui.plugins.inc','rules',20),('RulesRecursiveElementIterator','class','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesRuleSet','class','sites/all/modules/rules/includes/rules.plugins.inc','rules',20),('RulesRuleSetUI','class','sites/all/modules/rules/ui/ui.plugins.inc','rules',20),('RulesRuleUI','class','sites/all/modules/rules/ui/ui.plugins.inc','rules',20),('RulesState','class','sites/all/modules/rules/includes/rules.state.inc','rules',20),('RulesTaxonomyVocabularyWrapper','class','sites/all/modules/rules/modules/rules_core.eval.inc','rules',20),('RulesTestCase','class','sites/all/modules/rules/tests/rules.test','rules',20),('RulesTestDataCase','class','sites/all/modules/rules/tests/rules.test','rules',20),('RulesTokenEvaluator','class','sites/all/modules/rules/modules/system.eval.inc','rules',20),('RulesTriggerableInterface','interface','sites/all/modules/rules/includes/rules.core.inc','rules',20),('RulesTriggerTestCase','class','sites/all/modules/rules/tests/rules.test','rules',20),('RulesUICategory','class','sites/all/modules/rules/ui/ui.core.inc','rules',20),('RulesUIController','class','sites/all/modules/rules/ui/ui.controller.inc','rules',20),('RulesURIInputEvaluator','class','sites/all/modules/rules/modules/rules_core.eval.inc','rules',20),('SchemaCache','class','includes/bootstrap.inc','',0),('SearchAdvancedSearchForm','class','modules/search/search.test','search',0),('SearchApiAbstractAlterCallback','class','sites/all/modules/search_api/includes/callback.inc','search_api',0),('SearchApiAbstractDataSourceController','class','sites/all/modules/search_api/includes/datasource.inc','search_api',0),('SearchApiAbstractProcessor','class','sites/all/modules/search_api/includes/processor.inc','search_api',0),('SearchApiAbstractService','class','sites/all/modules/search_api/includes/service.inc','search_api',0),('SearchApiAlterAddAggregation','class','sites/all/modules/search_api/includes/callback_add_aggregation.inc','search_api',0),('SearchApiAlterAddHierarchy','class','sites/all/modules/search_api/includes/callback_add_hierarchy.inc','search_api',0),('SearchApiAlterAddUrl','class','sites/all/modules/search_api/includes/callback_add_url.inc','search_api',0),('SearchApiAlterAddViewedEntity','class','sites/all/modules/search_api/includes/callback_add_viewed_entity.inc','search_api',0),('SearchApiAlterBundleFilter','class','sites/all/modules/search_api/includes/callback_bundle_filter.inc','search_api',0),('SearchApiAlterCallbackInterface','interface','sites/all/modules/search_api/includes/callback.inc','search_api',0),('SearchApiAlterCommentAccess','class','sites/all/modules/search_api/includes/callback_comment_access.inc','search_api',0),('SearchApiAlterLanguageControl','class','sites/all/modules/search_api/includes/callback_language_control.inc','search_api',0),('SearchApiAlterNodeAccess','class','sites/all/modules/search_api/includes/callback_node_access.inc','search_api',0),('SearchApiAlterNodeStatus','class','sites/all/modules/search_api/includes/callback_node_status.inc','search_api',0),('SearchApiAlterRoleFilter','class','sites/all/modules/search_api/includes/callback_role_filter.inc','search_api',0),('SearchApiAlterUserStatus','class','sites/all/modules/search_api/includes/callback_user_status.inc','search_api',0),('SearchApiCombinedEntityDataSourceController','class','sites/all/modules/search_api/includes/datasource_multiple.inc','search_api',0),('SearchApiDataSourceControllerInterface','interface','sites/all/modules/search_api/includes/datasource.inc','search_api',0),('SearchApiDataSourceException','class','sites/all/modules/search_api/includes/exception.inc','search_api',0),('SearchApiDbService','class','sites/all/modules/search_api_db/service.inc','search_api_db',0),('SearchApiDbTest','class','sites/all/modules/search_api_db/search_api_db.test','search_api_db',0),('SearchApiEntityDataSourceController','class','sites/all/modules/search_api/includes/datasource_entity.inc','search_api',0),('SearchApiException','class','sites/all/modules/search_api/includes/exception.inc','search_api',0),('SearchApiExternalDataSourceController','class','sites/all/modules/search_api/includes/datasource_external.inc','search_api',0),('SearchApiFacetapiAdapter','class','sites/all/modules/search_api/contrib/search_api_facetapi/plugins/facetapi/adapter.inc','search_api_facetapi',0),('SearchApiFacetapiDate','class','sites/all/modules/search_api/contrib/search_api_facetapi/plugins/facetapi/query_type_date.inc','search_api_facetapi',0),('SearchApiFacetapiTerm','class','sites/all/modules/search_api/contrib/search_api_facetapi/plugins/facetapi/query_type_term.inc','search_api_facetapi',0),('SearchApiHighlight','class','sites/all/modules/search_api/includes/processor_highlight.inc','search_api',0),('SearchApiHtmlFilter','class','sites/all/modules/search_api/includes/processor_html_filter.inc','search_api',0),('SearchApiIgnoreCase','class','sites/all/modules/search_api/includes/processor_ignore_case.inc','search_api',0),('SearchApiIndex','class','sites/all/modules/search_api/includes/index_entity.inc','search_api',0),('SearchApiPorter2','class','sites/all/modules/search_api/includes/processor_stemmer.inc','search_api',0),('SearchApiPorterStemmer','class','sites/all/modules/search_api/includes/processor_stemmer.inc','search_api',0),('SearchApiProcessorInterface','interface','sites/all/modules/search_api/includes/processor.inc','search_api',0),('SearchApiQuery','class','sites/all/modules/search_api/includes/query.inc','search_api',0),('SearchApiQueryFilter','class','sites/all/modules/search_api/includes/query.inc','search_api',0),('SearchApiQueryFilterInterface','interface','sites/all/modules/search_api/includes/query.inc','search_api',0),('SearchApiQueryInterface','interface','sites/all/modules/search_api/includes/query.inc','search_api',0),('SearchApiRangesAlter','class','sites/all/modules/search_api_ranges/includes/callback_search_api_ranges.inc','search_api_ranges',0),('SearchApiRangesWidgetCheckboxLinks','class','sites/all/modules/search_api_ranges/plugins/facetapi/widget_links.inc','search_api_ranges',0),('SearchApiRangesWidgetLinks','class','sites/all/modules/search_api_ranges/plugins/facetapi/widget_links.inc','search_api_ranges',0),('SearchApiRangesWidgetSelect','class','sites/all/modules/search_api_ranges/plugins/facetapi/widget_select.inc','search_api_ranges',0),('SearchApiRangesWidgetUISlider','class','sites/all/modules/search_api_ranges/plugins/facetapi/widget_slider.inc','search_api_ranges',0),('SearchApiServer','class','sites/all/modules/search_api/includes/server_entity.inc','search_api',0),('SearchApiServiceInterface','interface','sites/all/modules/search_api/includes/service.inc','search_api',0),('SearchApiSort','class','sites/all/modules/search_api_sorts/search_api_sorts.entity.inc','search_api_sorts',0),('SearchApiSortsTest','class','sites/all/modules/search_api_sorts/search_api_sorts.test','search_api_sorts',0),('SearchApiStopWords','class','sites/all/modules/search_api/includes/processor_stopwords.inc','search_api',0),('SearchApiTokenizer','class','sites/all/modules/search_api/includes/processor_tokenizer.inc','search_api',0),('SearchApiTransliteration','class','sites/all/modules/search_api/includes/processor_transliteration.inc','search_api',0),('SearchApiUnitTest','class','sites/all/modules/search_api/search_api.test','search_api',0),('SearchApiViewsCache','class','sites/all/modules/search_api/contrib/search_api_views/includes/plugin_cache.inc','search_api_views',0),('SearchApiViewsFacetsBlockDisplay','class','sites/all/modules/search_api/contrib/search_api_views/includes/display_facet_block.inc','search_api_views',0),('SearchApiViewsHandlerArgument','class','sites/all/modules/search_api/contrib/search_api_views/includes/handler_argument.inc','search_api_views',0),('SearchApiViewsHandlerArgumentDate','class','sites/all/modules/search_api/contrib/search_api_views/includes/handler_argument_date.inc','search_api_views',0),('SearchApiViewsHandlerArgumentFulltext','class','sites/all/modules/search_api/contrib/search_api_views/includes/handler_argument_fulltext.inc','search_api_views',0),('SearchApiViewsHandlerArgumentMoreLikeThis','class','sites/all/modules/search_api/contrib/search_api_views/includes/handler_argument_more_like_this.inc','search_api_views',0),('SearchApiViewsHandlerArgumentString','class','sites/all/modules/search_api/contrib/search_api_views/includes/handler_argument_string.inc','search_api_views',0),('SearchApiViewsHandlerArgumentTaxonomyTerm','class','sites/all/modules/search_api/contrib/search_api_views/includes/handler_argument_taxonomy_term.inc','search_api_views',0),('SearchApiViewsHandlerFilter','class','sites/all/modules/search_api/contrib/search_api_views/includes/handler_filter.inc','search_api_views',0),('SearchApiViewsHandlerFilterBoolean','class','sites/all/modules/search_api/contrib/search_api_views/includes/handler_filter_boolean.inc','search_api_views',0),('SearchApiViewsHandlerFilterDate','class','sites/all/modules/search_api/contrib/search_api_views/includes/handler_filter_date.inc','search_api_views',0),('SearchApiViewsHandlerFilterEntity','class','sites/all/modules/search_api/contrib/search_api_views/includes/handler_filter_entity.inc','search_api_views',0),('SearchApiViewsHandlerFilterFulltext','class','sites/all/modules/search_api/contrib/search_api_views/includes/handler_filter_fulltext.inc','search_api_views',0),('SearchApiViewsHandlerFilterLanguage','class','sites/all/modules/search_api/contrib/search_api_views/includes/handler_filter_language.inc','search_api_views',0),('SearchApiViewsHandlerFilterOptions','class','sites/all/modules/search_api/contrib/search_api_views/includes/handler_filter_options.inc','search_api_views',0),('SearchApiViewsHandlerFilterTaxonomyTerm','class','sites/all/modules/search_api/contrib/search_api_views/includes/handler_filter_taxonomy_term.inc','search_api_views',0),('SearchApiViewsHandlerFilterText','class','sites/all/modules/search_api/contrib/search_api_views/includes/handler_filter_text.inc','search_api_views',0),('SearchApiViewsHandlerFilterUser','class','sites/all/modules/search_api/contrib/search_api_views/includes/handler_filter_user.inc','search_api_views',0),('SearchApiViewsHandlerSort','class','sites/all/modules/search_api/contrib/search_api_views/includes/handler_sort.inc','search_api_views',0),('SearchApiViewsQuery','class','sites/all/modules/search_api/contrib/search_api_views/includes/query.inc','search_api_views',0),('SearchApiWebTest','class','sites/all/modules/search_api/search_api.test','search_api',0),('SearchBlockTestCase','class','modules/search/search.test','search',0),('SearchCommentCountToggleTestCase','class','modules/search/search.test','search',0),('SearchCommentTestCase','class','modules/search/search.test','search',0),('SearchConfigSettingsForm','class','modules/search/search.test','search',0),('SearchEmbedForm','class','modules/search/search.test','search',0),('SearchExactTestCase','class','modules/search/search.test','search',0),('SearchExcerptTestCase','class','modules/search/search.test','search',0),('SearchExpressionInsertExtractTestCase','class','modules/search/search.test','search',0),('SearchKeywordsConditions','class','modules/search/search.test','search',0),('SearchLanguageTestCase','class','modules/search/search.test','search',0),('SearchMatchTestCase','class','modules/search/search.test','search',0),('SearchNodeAccessTest','class','modules/search/search.test','search',0),('SearchNodeTagTest','class','modules/search/search.test','search',0),('SearchNumberMatchingTestCase','class','modules/search/search.test','search',0),('SearchNumbersTestCase','class','modules/search/search.test','search',0),('SearchPageOverride','class','modules/search/search.test','search',0),('SearchPageText','class','modules/search/search.test','search',0),('SearchQuery','class','modules/search/search.extender.inc','search',0),('SearchRankingTestCase','class','modules/search/search.test','search',0),('SearchSetLocaleTest','class','modules/search/search.test','search',0),('SearchSimplifyTestCase','class','modules/search/search.test','search',0),('SearchTokenizerTestCase','class','modules/search/search.test','search',0),('SelectOrOtherNumberTestCase','class','sites/all/modules/select_or_other/tests/select_or_other_number.test','select_or_other',1),('SelectOrOtherTextTestCase','class','sites/all/modules/select_or_other/tests/select_or_other_text.test','select_or_other',1),('SelectQuery','class','includes/database/select.inc','',0),('SelectQueryExtender','class','includes/database/select.inc','',0),('SelectQueryInterface','interface','includes/database/select.inc','',0),('SelectQuery_pgsql','class','includes/database/pgsql/select.inc','',0),('SelectQuery_sqlite','class','includes/database/sqlite/select.inc','',0),('SessionApiTestCase','class','sites/all/modules/session_api/session_api.test','session_api',0),('ShortcutLinksTestCase','class','modules/shortcut/shortcut.test','shortcut',0),('ShortcutSetsTestCase','class','modules/shortcut/shortcut.test','shortcut',0),('ShortcutTestCase','class','modules/shortcut/shortcut.test','shortcut',0),('ShutdownFunctionsTest','class','modules/system/system.test','system',0),('SimpleNewsAdministrationTestCase','class','sites/all/modules/simplenews/tests/simplenews.test','simplenews',0),('SimpleNewsI18nTestCase','class','sites/all/modules/simplenews/tests/simplenews.test','simplenews',0),('SimplenewsSendTestCase','class','sites/all/modules/simplenews/tests/simplenews.test','simplenews',0),('SimplenewsSourceCacheBuild','class','sites/all/modules/simplenews/includes/simplenews.source.inc','simplenews',0),('SimplenewsSourceCacheInterface','interface','sites/all/modules/simplenews/includes/simplenews.source.inc','simplenews',0),('SimplenewsSourceCacheNone','class','sites/all/modules/simplenews/includes/simplenews.source.inc','simplenews',0),('SimplenewsSourceCacheStatic','class','sites/all/modules/simplenews/includes/simplenews.source.inc','simplenews',0),('SimplenewsSourceInterface','interface','sites/all/modules/simplenews/includes/simplenews.source.inc','simplenews',0),('SimplenewsSourceNode','class','sites/all/modules/simplenews/includes/simplenews.source.inc','simplenews',0),('SimplenewsSourceNodeInterface','interface','sites/all/modules/simplenews/includes/simplenews.source.inc','simplenews',0),('SimplenewsSourceTest','class','sites/all/modules/simplenews/includes/simplenews.source.inc','simplenews',0),('SimplenewsSourceTestCase','class','sites/all/modules/simplenews/tests/simplenews.test','simplenews',0),('SimplenewsSpool','class','sites/all/modules/simplenews/includes/simplenews.source.inc','simplenews',0),('SimplenewsSpoolInterface','interface','sites/all/modules/simplenews/includes/simplenews.source.inc','simplenews',0),('SimplenewsSubscribeTestCase','class','sites/all/modules/simplenews/tests/simplenews.test','simplenews',0),('SimplenewsTestCase','class','sites/all/modules/simplenews/tests/simplenews.test','simplenews',0),('SimplenewsUnitTest','class','sites/all/modules/simplenews/tests/simplenews.test','simplenews',0),('SimpleNewsUpgradePath61TestCase','class','sites/all/modules/simplenews/tests/simplenews.test','simplenews',0),('SimpleNewsUpgradePath62TestCase','class','sites/all/modules/simplenews/tests/simplenews.test','simplenews',0),('SimpleNewsUpgradePathTestCase','class','sites/all/modules/simplenews/tests/simplenews.test','simplenews',0),('simplenews_handler_field_category_hyperlinks','class','sites/all/modules/simplenews/includes/views/handlers/simplenews_handler_field_category_hyperlinks.inc','simplenews',0),('simplenews_handler_field_category_new_account','class','sites/all/modules/simplenews/includes/views/handlers/simplenews_handler_field_category_new_account.inc','simplenews',0),('simplenews_handler_field_category_opt_inout','class','sites/all/modules/simplenews/includes/views/handlers/simplenews_handler_field_category_opt_inout.inc','simplenews',0),('simplenews_handler_field_newsletter_priority','class','sites/all/modules/simplenews/includes/views/handlers/simplenews_handler_field_newsletter_priority.inc','simplenews',0),('simplenews_handler_field_newsletter_send','class','sites/all/modules/simplenews/includes/views/handlers/simplenews_handler_field_newsletter_send.inc','simplenews',0),('simplenews_handler_field_newsletter_status','class','sites/all/modules/simplenews/includes/views/handlers/simplenews_handler_field_newsletter_status.inc','simplenews',0),('simplenews_handler_filter_category_hyperlinks','class','sites/all/modules/simplenews/includes/views/handlers/simplenews_handler_filter_category_hyperlinks.inc','simplenews',0),('simplenews_handler_filter_category_new_account','class','sites/all/modules/simplenews/includes/views/handlers/simplenews_handler_filter_category_new_account.inc','simplenews',0),('simplenews_handler_filter_category_opt_inout','class','sites/all/modules/simplenews/includes/views/handlers/simplenews_handler_filter_category_opt_inout.inc','simplenews',0),('simplenews_handler_filter_newsletter_priority','class','sites/all/modules/simplenews/includes/views/handlers/simplenews_handler_filter_newsletter_priority.inc','simplenews',0),('simplenews_handler_filter_newsletter_status','class','sites/all/modules/simplenews/includes/views/handlers/simplenews_handler_filter_newsletter_status.inc','simplenews',0),('SiteMaintenanceTestCase','class','modules/system/system.test','system',0),('SkipDotsRecursiveDirectoryIterator','class','includes/filetransfer/filetransfer.inc','',0),('StreamWrapperInterface','interface','includes/stream_wrappers.inc','',0),('SummaryLengthTestCase','class','modules/node/node.test','node',0),('SystemAdminTestCase','class','modules/system/system.test','system',0),('SystemAuthorizeCase','class','modules/system/system.test','system',0),('SystemBlockTestCase','class','modules/system/system.test','system',0),('SystemIndexPhpTest','class','modules/system/system.test','system',0),('SystemInfoAlterTestCase','class','modules/system/system.test','system',0),('SystemMainContentFallback','class','modules/system/system.test','system',0),('SystemQueue','class','modules/system/system.queue.inc','system',0),('SystemThemeFunctionalTest','class','modules/system/system.test','system',0),('SystemValidTokenTest','class','modules/system/system.test','system',0),('TableSort','class','includes/tablesort.inc','',0),('TaxonomyEFQTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyHooksTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyLegacyTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyLoadMultipleTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyMenuHierarchyTest','class','sites/all/modules/taxonomy_menu/taxonomy_menu.test','taxonomy_menu',0),('TaxonomyMenuTreeNode','class','sites/all/modules/taxonomy_menu/taxonomy_menu.test','taxonomy_menu',0),('TaxonomyMenuUnitTest','class','sites/all/modules/taxonomy_menu/taxonomy_menu.test','taxonomy_menu',0),('TaxonomyMenuWebTestCase','class','sites/all/modules/taxonomy_menu/taxonomy_menu.test','taxonomy_menu',0),('TaxonomyQueryAlterTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyRSSTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyTermController','class','modules/taxonomy/taxonomy.module','taxonomy',0),('TaxonomyTermFieldMultipleVocabularyTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyTermFieldTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyTermFunctionTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyTermIndexTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyTermInlineEntityFormController','class','sites/all/modules/inline_entity_form/includes/taxonomy_term.inline_entity_form.inc','inline_entity_form',0),('TaxonomyTermTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyThemeTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyTokenReplaceTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyVocabularyController','class','modules/taxonomy/taxonomy.module','taxonomy',0),('TaxonomyVocabularyFunctionalTest','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyVocabularyTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyWebTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TestingMailSystem','class','modules/system/system.mail.inc','system',0),('TextFieldTestCase','class','modules/field/modules/text/text.test','text',0),('TextSummaryTestCase','class','modules/field/modules/text/text.test','text',0),('TextTranslationTestCase','class','modules/field/modules/text/text.test','text',0),('ThemeRegistry','class','includes/theme.inc','',0),('ThemeUpdater','class','modules/system/system.updater.inc','system',0),('TitleAdminSettingsTestCase','class','sites/all/modules/title/tests/title.test','title',100),('TitleFieldReplacementTestCase','class','sites/all/modules/title/tests/title.test','title',100),('TitleTranslationTestCase','class','sites/all/modules/title/tests/title.test','title',100),('TokenArrayTestCase','class','sites/all/modules/token/token.test','token',0),('TokenBlockTestCase','class','sites/all/modules/token/token.test','token',0),('TokenCommentTestCase','class','sites/all/modules/token/token.test','token',0),('TokenCurrentPageTestCase','class','sites/all/modules/token/token.test','token',0),('TokenDateTestCase','class','sites/all/modules/token/token.test','token',0),('TokenEntityTestCase','class','sites/all/modules/token/token.test','token',0),('TokenFileTestCase','class','sites/all/modules/token/token.test','token',0),('TokenMenuTestCase','class','sites/all/modules/token/token.test','token',0),('TokenNodeTestCase','class','sites/all/modules/token/token.test','token',0),('TokenProfileTestCase','class','sites/all/modules/token/token.test','token',0),('TokenRandomTestCase','class','sites/all/modules/token/token.test','token',0),('TokenReplaceTestCase','class','modules/system/system.test','system',0),('TokenScanTest','class','modules/system/system.test','system',0),('TokenTaxonomyTestCase','class','sites/all/modules/token/token.test','token',0),('TokenTestHelper','class','sites/all/modules/token/token.test','token',0),('TokenUnitTestCase','class','sites/all/modules/token/token.test','token',0),('TokenURLTestCase','class','sites/all/modules/token/token.test','token',0),('TokenUserTestCase','class','sites/all/modules/token/token.test','token',0),('TruncateQuery','class','includes/database/query.inc','',0),('TruncateQuery_mysql','class','includes/database/mysql/query.inc','',0),('TruncateQuery_sqlite','class','includes/database/sqlite/query.inc','',0),('UpdateCoreTestCase','class','modules/update/update.test','update',0),('UpdateCoreUnitTestCase','class','modules/update/update.test','update',0),('UpdateQuery','class','includes/database/query.inc','',0),('UpdateQuery_pgsql','class','includes/database/pgsql/query.inc','',0),('UpdateQuery_sqlite','class','includes/database/sqlite/query.inc','',0),('Updater','class','includes/updater.inc','',0),('UpdaterException','class','includes/updater.inc','',0),('UpdaterFileTransferException','class','includes/updater.inc','',0),('UpdateScriptFunctionalTest','class','modules/system/system.test','system',0),('UpdateTestContribCase','class','modules/update/update.test','update',0),('UpdateTestHelper','class','modules/update/update.test','update',0),('UpdateTestUploadCase','class','modules/update/update.test','update',0),('UserAccountLinksUnitTests','class','modules/user/user.test','user',0),('UserAdminTestCase','class','modules/user/user.test','user',0),('UserAuthmapAssignmentTestCase','class','modules/user/user.test','user',0),('UserAutocompleteTestCase','class','modules/user/user.test','user',0),('UserBlocksUnitTests','class','modules/user/user.test','user',0),('UserCancelTestCase','class','modules/user/user.test','user',0),('UserController','class','modules/user/user.module','user',0),('UserCreateTestCase','class','modules/user/user.test','user',0),('UserEditedOwnAccountTestCase','class','modules/user/user.test','user',0),('UserEditRebuildTestCase','class','modules/user/user.test','user',0),('UserEditTestCase','class','modules/user/user.test','user',0),('UserLoginTestCase','class','modules/user/user.test','user',0),('UserPasswordResetTestCase','class','modules/user/user.test','user',0),('UserPermissionsTestCase','class','modules/user/user.test','user',0),('UserPictureTestCase','class','modules/user/user.test','user',0),('UserRegistrationTestCase','class','modules/user/user.test','user',0),('UserRoleAdminTestCase','class','modules/user/user.test','user',0),('UserRolesAssignmentTestCase','class','modules/user/user.test','user',0),('UserSaveTestCase','class','modules/user/user.test','user',0),('UserSignatureTestCase','class','modules/user/user.test','user',0),('UserTimeZoneFunctionalTest','class','modules/user/user.test','user',0),('UserTokenReplaceTestCase','class','modules/user/user.test','user',0),('UserUserSearchTestCase','class','modules/user/user.test','user',0),('UserValidateCurrentPassCustomForm','class','modules/user/user.test','user',0),('UserValidationTestCase','class','modules/user/user.test','user',0),('view','class','sites/all/modules/views/includes/view.inc','views',10),('ViewsAccessTest','class','sites/all/modules/views/tests/views_access.test','views',10),('ViewsAnalyzeTest','class','sites/all/modules/views/tests/views_analyze.test','views',10),('ViewsArgumentDefaultTest','class','sites/all/modules/views/tests/views_argument_default.test','views',10),('ViewsArgumentValidatorTest','class','sites/all/modules/views/tests/views_argument_validator.test','views',10),('ViewsBasicTest','class','sites/all/modules/views/tests/views_basic.test','views',10),('ViewsBootstrapAccordionPluginStyle','class','sites/all/modules/views_bootstrap/plugins/accordion/views_bootstrap_accordion_plugin_style.inc','views_bootstrap',0),('ViewsBootstrapCarouselPluginRows','class','sites/all/modules/views_bootstrap/plugins/carousel/views_bootstrap_carousel_plugin_rows.inc','views_bootstrap',0),('ViewsBootstrapCarouselPluginStyle','class','sites/all/modules/views_bootstrap/plugins/carousel/views_bootstrap_carousel_plugin_style.inc','views_bootstrap',0),('ViewsBootstrapGridPluginStyle','class','sites/all/modules/views_bootstrap/plugins/grid/views_bootstrap_grid_plugin_style.inc','views_bootstrap',0),('ViewsBootstrapMediaPluginStyle','class','sites/all/modules/views_bootstrap/plugins/media/views_bootstrap_media_plugin_style.inc','views_bootstrap',0),('ViewsBootstrapTablePluginStyle','class','sites/all/modules/views_bootstrap/plugins/table/views_bootstrap_table_plugin_style.inc','views_bootstrap',0),('ViewsBootstrapTabPluginStyle','class','sites/all/modules/views_bootstrap/plugins/tab/views_bootstrap_tab_plugin_style.inc','views_bootstrap',0),('ViewsBootstrapThumbnailPluginRows','class','sites/all/modules/views_bootstrap/plugins/thumbnail/views_bootstrap_thumbnail_plugin_rows.inc','views_bootstrap',0),('ViewsBootstrapThumbnailPluginStyle','class','sites/all/modules/views_bootstrap/plugins/thumbnail/views_bootstrap_thumbnail_plugin_style.inc','views_bootstrap',0),('ViewsCacheTest','class','sites/all/modules/views/tests/views_cache.test','views',10),('ViewsExposedFormTest','class','sites/all/modules/views/tests/views_exposed_form.test','views',10),('viewsFieldApiDataTest','class','sites/all/modules/views/tests/field/views_fieldapi.test','views',10),('ViewsFieldApiTestHelper','class','sites/all/modules/views/tests/field/views_fieldapi.test','views',10),('viewsFieldViewTestCase','class','sites/all/modules/views_field_view/tests/views_field_view.test','views_field_view',0),('ViewsGlossaryTestCase','class','sites/all/modules/views/tests/views_glossary.test','views',10),('ViewsHandlerAreaTextTest','class','sites/all/modules/views/tests/handlers/views_handler_area_text.test','views',10),('viewsHandlerArgumentCommentUserUidTest','class','sites/all/modules/views/tests/comment/views_handler_argument_comment_user_uid.test','views',10),('ViewsHandlerArgumentNullTest','class','sites/all/modules/views/tests/handlers/views_handler_argument_null.test','views',10),('ViewsHandlerArgumentStringTest','class','sites/all/modules/views/tests/handlers/views_handler_argument_string.test','views',10),('ViewsHandlerFieldBooleanTest','class','sites/all/modules/views/tests/handlers/views_handler_field_boolean.test','views',10),('ViewsHandlerFieldCustomTest','class','sites/all/modules/views/tests/handlers/views_handler_field_custom.test','views',10),('ViewsHandlerFieldDateTest','class','sites/all/modules/views/tests/handlers/views_handler_field_date.test','views',10),('viewsHandlerFieldFieldTest','class','sites/all/modules/views/tests/field/views_fieldapi.test','views',10),('ViewsHandlerFieldMath','class','sites/all/modules/views/tests/handlers/views_handler_field_math.test','views',10),('ViewsHandlerFieldTest','class','sites/all/modules/views/tests/handlers/views_handler_field.test','views',10),('ViewsHandlerFieldUrlTest','class','sites/all/modules/views/tests/handlers/views_handler_field_url.test','views',10),('viewsHandlerFieldUserNameTest','class','sites/all/modules/views/tests/user/views_handler_field_user_name.test','views',10),('ViewsHandlerFileExtensionTest','class','sites/all/modules/views/tests/handlers/views_handler_field_file_extension.test','views',10),('ViewsHandlerFilterCombineTest','class','sites/all/modules/views/tests/handlers/views_handler_filter_combine.test','views',10),('viewsHandlerFilterCommentUserUidTest','class','sites/all/modules/views/tests/comment/views_handler_filter_comment_user_uid.test','views',10),('ViewsHandlerFilterCounterTest','class','sites/all/modules/views/tests/handlers/views_handler_field_counter.test','views',10),('ViewsHandlerFilterDateTest','class','sites/all/modules/views/tests/handlers/views_handler_filter_date.test','views',10),('ViewsHandlerFilterEqualityTest','class','sites/all/modules/views/tests/handlers/views_handler_filter_equality.test','views',10),('ViewsHandlerFilterInOperator','class','sites/all/modules/views/tests/handlers/views_handler_filter_in_operator.test','views',10),('ViewsHandlerFilterNumericTest','class','sites/all/modules/views/tests/handlers/views_handler_filter_numeric.test','views',10),('ViewsHandlerFilterStringTest','class','sites/all/modules/views/tests/handlers/views_handler_filter_string.test','views',10),('ViewsHandlerRelationshipNodeTermDataTest','class','sites/all/modules/views/tests/taxonomy/views_handler_relationship_node_term_data.test','views',10),('ViewsHandlerSortDateTest','class','sites/all/modules/views/tests/handlers/views_handler_sort_date.test','views',10),('ViewsHandlerSortRandomTest','class','sites/all/modules/views/tests/handlers/views_handler_sort_random.test','views',10),('ViewsHandlerSortTest','class','sites/all/modules/views/tests/handlers/views_handler_sort.test','views',10),('ViewsHandlersTest','class','sites/all/modules/views/tests/views_handlers.test','views',10),('ViewsHandlerTest','class','sites/all/modules/views/tests/handlers/views_handlers.test','views',10),('ViewsHandlerTestFileSize','class','sites/all/modules/views/tests/handlers/views_handler_field_file_size.test','views',10),('ViewsHandlerTestXss','class','sites/all/modules/views/tests/handlers/views_handler_field_xss.test','views',10),('ViewsModuleTest','class','sites/all/modules/views/tests/views_module.test','views',10),('ViewsNodeRevisionRelationsTestCase','class','sites/all/modules/views/tests/node/views_node_revision_relations.test','views',10),('ViewsPagerTest','class','sites/all/modules/views/tests/views_pager.test','views',10),('ViewsPluginDisplayTestCase','class','sites/all/modules/views/tests/plugins/views_plugin_display.test','views',10),('viewsPluginStyleJumpMenuTest','class','sites/all/modules/views/tests/styles/views_plugin_style_jump_menu.test','views',10),('ViewsPluginStyleMappingTest','class','sites/all/modules/views/tests/styles/views_plugin_style_mapping.test','views',10),('ViewsPluginStyleTestBase','class','sites/all/modules/views/tests/styles/views_plugin_style_base.test','views',10),('ViewsPluginStyleTestCase','class','sites/all/modules/views/tests/styles/views_plugin_style.test','views',10),('ViewsPluginStyleUnformattedTestCase','class','sites/all/modules/views/tests/styles/views_plugin_style_unformatted.test','views',10),('ViewsQueryGroupByTest','class','sites/all/modules/views/tests/views_groupby.test','views',10),('viewsSearchQuery','class','sites/all/modules/views/modules/search/views_handler_filter_search.inc','views',10),('ViewsSqlTest','class','sites/all/modules/views/tests/views_query.test','views',10),('ViewsTestCase','class','sites/all/modules/views/tests/views_query.test','views',10),('ViewsTranslatableTest','class','sites/all/modules/views/tests/views_translatable.test','views',10),('ViewsUiBaseViewsWizard','class','sites/all/modules/views/plugins/views_wizard/views_ui_base_views_wizard.class.php','views_ui',0),('ViewsUiCommentViewsWizard','class','sites/all/modules/views/plugins/views_wizard/views_ui_comment_views_wizard.class.php','views_ui',0),('ViewsUiFileManagedViewsWizard','class','sites/all/modules/views/plugins/views_wizard/views_ui_file_managed_views_wizard.class.php','views_ui',0),('viewsUiGroupbyTestCase','class','sites/all/modules/views/tests/views_groupby.test','views',10),('ViewsUiNodeRevisionViewsWizard','class','sites/all/modules/views/plugins/views_wizard/views_ui_node_revision_views_wizard.class.php','views_ui',0),('ViewsUiNodeViewsWizard','class','sites/all/modules/views/plugins/views_wizard/views_ui_node_views_wizard.class.php','views_ui',0),('ViewsUiTaxonomyTermViewsWizard','class','sites/all/modules/views/plugins/views_wizard/views_ui_taxonomy_term_views_wizard.class.php','views_ui',0),('ViewsUiUsersViewsWizard','class','sites/all/modules/views/plugins/views_wizard/views_ui_users_views_wizard.class.php','views_ui',0),('ViewsUIWizardBasicTestCase','class','sites/all/modules/views/tests/views_ui.test','views',10),('ViewsUIWizardDefaultViewsTestCase','class','sites/all/modules/views/tests/views_ui.test','views',10),('ViewsUIWizardHelper','class','sites/all/modules/views/tests/views_ui.test','views',10),('ViewsUIWizardItemsPerPageTestCase','class','sites/all/modules/views/tests/views_ui.test','views',10),('ViewsUIWizardJumpMenuTestCase','class','sites/all/modules/views/tests/views_ui.test','views',10),('ViewsUIWizardMenuTestCase','class','sites/all/modules/views/tests/views_ui.test','views',10),('ViewsUIWizardOverrideDisplaysTestCase','class','sites/all/modules/views/tests/views_ui.test','views',10),('ViewsUIWizardSortingTestCase','class','sites/all/modules/views/tests/views_ui.test','views',10),('ViewsUIWizardTaggedWithTestCase','class','sites/all/modules/views/tests/views_ui.test','views',10),('ViewsUpgradeTestCase','class','sites/all/modules/views/tests/views_upgrade.test','views',10),('ViewsUserArgumentDefault','class','sites/all/modules/views/tests/user/views_user_argument_default.test','views',10),('ViewsUserArgumentValidate','class','sites/all/modules/views/tests/user/views_user_argument_validate.test','views',10),('ViewsUserTestCase','class','sites/all/modules/views/tests/user/views_user.test','views',10),('ViewsViewTest','class','sites/all/modules/views/tests/views_view.test','views',10),('ViewsWizardException','class','sites/all/modules/views/plugins/views_wizard/views_ui_base_views_wizard.class.php','views_ui',0),('ViewsWizardInterface','interface','sites/all/modules/views/plugins/views_wizard/views_ui_base_views_wizard.class.php','views_ui',0),('views_db_object','class','sites/all/modules/views/includes/view.inc','views',10),('views_display','class','sites/all/modules/views/includes/view.inc','views',10),('views_fieldsets_fieldset_field_handler','class','sites/all/modules/views_fieldsets/views/views_fieldsets_fieldset_field_handler.inc','views_fieldsets',0),('views_field_view_handler_field_view','class','sites/all/modules/views_field_view/views_field_view_handler_field_view.inc','views_field_view',0),('views_handler','class','sites/all/modules/views/includes/handlers.inc','views',10),('views_handler_area','class','sites/all/modules/views/handlers/views_handler_area.inc','views',10),('views_handler_area_broken','class','sites/all/modules/views/handlers/views_handler_area.inc','views',10),('views_handler_area_messages','class','sites/all/modules/views/handlers/views_handler_area_messages.inc','views',10),('views_handler_area_result','class','sites/all/modules/views/handlers/views_handler_area_result.inc','views',10),('views_handler_area_text','class','sites/all/modules/views/handlers/views_handler_area_text.inc','views',10),('views_handler_area_text_custom','class','sites/all/modules/views/handlers/views_handler_area_text_custom.inc','views',10),('views_handler_area_view','class','sites/all/modules/views/handlers/views_handler_area_view.inc','views',10),('views_handler_argument','class','sites/all/modules/views/handlers/views_handler_argument.inc','views',10),('views_handler_argument_aggregator_category_cid','class','sites/all/modules/views/modules/aggregator/views_handler_argument_aggregator_category_cid.inc','views',10),('views_handler_argument_aggregator_fid','class','sites/all/modules/views/modules/aggregator/views_handler_argument_aggregator_fid.inc','views',10),('views_handler_argument_aggregator_iid','class','sites/all/modules/views/modules/aggregator/views_handler_argument_aggregator_iid.inc','views',10),('views_handler_argument_broken','class','sites/all/modules/views/handlers/views_handler_argument.inc','views',10),('views_handler_argument_comment_user_uid','class','sites/all/modules/views/modules/comment/views_handler_argument_comment_user_uid.inc','views',10),('views_handler_argument_countries_country','class','sites/all/modules/countries/views/views_handler_argument_countries_country.inc','countries',0),('views_handler_argument_date','class','sites/all/modules/views/handlers/views_handler_argument_date.inc','views',10),('views_handler_argument_field_list','class','sites/all/modules/views/modules/field/views_handler_argument_field_list.inc','views',10),('views_handler_argument_field_list_string','class','sites/all/modules/views/modules/field/views_handler_argument_field_list_string.inc','views',10),('views_handler_argument_file_fid','class','sites/all/modules/views/modules/system/views_handler_argument_file_fid.inc','views',10),('views_handler_argument_formula','class','sites/all/modules/views/handlers/views_handler_argument_formula.inc','views',10),('views_handler_argument_group_by_numeric','class','sites/all/modules/views/handlers/views_handler_argument_group_by_numeric.inc','views',10),('views_handler_argument_locale_group','class','sites/all/modules/views/modules/locale/views_handler_argument_locale_group.inc','views',10),('views_handler_argument_locale_language','class','sites/all/modules/views/modules/locale/views_handler_argument_locale_language.inc','views',10),('views_handler_argument_many_to_one','class','sites/all/modules/views/handlers/views_handler_argument_many_to_one.inc','views',10),('views_handler_argument_node_created_day','class','sites/all/modules/views/modules/node/views_handler_argument_dates_various.inc','views',10),('views_handler_argument_node_created_fulldate','class','sites/all/modules/views/modules/node/views_handler_argument_dates_various.inc','views',10),('views_handler_argument_node_created_month','class','sites/all/modules/views/modules/node/views_handler_argument_dates_various.inc','views',10),('views_handler_argument_node_created_week','class','sites/all/modules/views/modules/node/views_handler_argument_dates_various.inc','views',10),('views_handler_argument_node_created_year','class','sites/all/modules/views/modules/node/views_handler_argument_dates_various.inc','views',10),('views_handler_argument_node_created_year_month','class','sites/all/modules/views/modules/node/views_handler_argument_dates_various.inc','views',10),('views_handler_argument_node_language','class','sites/all/modules/views/modules/node/views_handler_argument_node_language.inc','views',10),('views_handler_argument_node_nid','class','sites/all/modules/views/modules/node/views_handler_argument_node_nid.inc','views',10),('views_handler_argument_node_tnid','class','sites/all/modules/views/modules/translation/views_handler_argument_node_tnid.inc','views',10),('views_handler_argument_node_type','class','sites/all/modules/views/modules/node/views_handler_argument_node_type.inc','views',10),('views_handler_argument_node_uid_revision','class','sites/all/modules/views/modules/node/views_handler_argument_node_uid_revision.inc','views',10),('views_handler_argument_node_vid','class','sites/all/modules/views/modules/node/views_handler_argument_node_vid.inc','views',10),('views_handler_argument_null','class','sites/all/modules/views/handlers/views_handler_argument_null.inc','views',10),('views_handler_argument_numeric','class','sites/all/modules/views/handlers/views_handler_argument_numeric.inc','views',10),('views_handler_argument_search','class','sites/all/modules/views/modules/search/views_handler_argument_search.inc','views',10),('views_handler_argument_string','class','sites/all/modules/views/handlers/views_handler_argument_string.inc','views',10),('views_handler_argument_taxonomy','class','sites/all/modules/views/modules/taxonomy/views_handler_argument_taxonomy.inc','views',10),('views_handler_argument_term_node_tid','class','sites/all/modules/views/modules/taxonomy/views_handler_argument_term_node_tid.inc','views',10),('views_handler_argument_term_node_tid_depth','class','sites/all/modules/views/modules/taxonomy/views_handler_argument_term_node_tid_depth.inc','views',10),('views_handler_argument_term_node_tid_depth_join','class','sites/all/modules/views/modules/taxonomy/views_handler_argument_term_node_tid_depth_join.inc','views',10),('views_handler_argument_term_node_tid_depth_modifier','class','sites/all/modules/views/modules/taxonomy/views_handler_argument_term_node_tid_depth_modifier.inc','views',10),('views_handler_argument_tracker_comment_user_uid','class','sites/all/modules/views/modules/tracker/views_handler_argument_tracker_comment_user_uid.inc','views',10),('views_handler_argument_users_roles_rid','class','sites/all/modules/views/modules/user/views_handler_argument_users_roles_rid.inc','views',10),('views_handler_argument_user_uid','class','sites/all/modules/views/modules/user/views_handler_argument_user_uid.inc','views',10),('views_handler_argument_vocabulary_machine_name','class','sites/all/modules/views/modules/taxonomy/views_handler_argument_vocabulary_machine_name.inc','views',10),('views_handler_argument_vocabulary_vid','class','sites/all/modules/views/modules/taxonomy/views_handler_argument_vocabulary_vid.inc','views',10),('views_handler_field','class','sites/all/modules/views/handlers/views_handler_field.inc','views',10),('views_handler_field_accesslog_path','class','sites/all/modules/views/modules/statistics/views_handler_field_accesslog_path.inc','views',10),('views_handler_field_aggregator_category','class','sites/all/modules/views/modules/aggregator/views_handler_field_aggregator_category.inc','views',10),('views_handler_field_aggregator_title_link','class','sites/all/modules/views/modules/aggregator/views_handler_field_aggregator_title_link.inc','views',10),('views_handler_field_aggregator_xss','class','sites/all/modules/views/modules/aggregator/views_handler_field_aggregator_xss.inc','views',10),('views_handler_field_boolean','class','sites/all/modules/views/handlers/views_handler_field_boolean.inc','views',10),('views_handler_field_broken','class','sites/all/modules/views/handlers/views_handler_field.inc','views',10),('views_handler_field_comment','class','sites/all/modules/views/modules/comment/views_handler_field_comment.inc','views',10),('views_handler_field_comment_depth','class','sites/all/modules/views/modules/comment/views_handler_field_comment_depth.inc','views',10),('views_handler_field_comment_link','class','sites/all/modules/views/modules/comment/views_handler_field_comment_link.inc','views',10),('views_handler_field_comment_link_approve','class','sites/all/modules/views/modules/comment/views_handler_field_comment_link_approve.inc','views',10),('views_handler_field_comment_link_delete','class','sites/all/modules/views/modules/comment/views_handler_field_comment_link_delete.inc','views',10),('views_handler_field_comment_link_edit','class','sites/all/modules/views/modules/comment/views_handler_field_comment_link_edit.inc','views',10),('views_handler_field_comment_link_reply','class','sites/all/modules/views/modules/comment/views_handler_field_comment_link_reply.inc','views',10),('views_handler_field_comment_node_link','class','sites/all/modules/views/modules/comment/views_handler_field_comment_node_link.inc','views',10),('views_handler_field_comment_username','class','sites/all/modules/views/modules/comment/views_handler_field_comment_username.inc','views',10),('views_handler_field_contact_link','class','sites/all/modules/views/modules/contact/views_handler_field_contact_link.inc','views',10),('views_handler_field_contextual_links','class','sites/all/modules/views/handlers/views_handler_field_contextual_links.inc','views',10),('views_handler_field_counter','class','sites/all/modules/views/handlers/views_handler_field_counter.inc','views',10),('views_handler_field_countries_continent','class','sites/all/modules/countries/views/views_handler_field_countries_continent.inc','countries',0),('views_handler_field_ctools_dropdown','class','sites/all/modules/views/handlers/views_handler_field_ctools_dropdown.inc','views',10),('views_handler_field_custom','class','sites/all/modules/views/handlers/views_handler_field_custom.inc','views',10),('views_handler_field_date','class','sites/all/modules/views/handlers/views_handler_field_date.inc','views',10),('views_handler_field_entity','class','sites/all/modules/views/handlers/views_handler_field_entity.inc','views',10),('views_handler_field_field','class','sites/all/modules/views/modules/field/views_handler_field_field.inc','views',10),('views_handler_field_file','class','sites/all/modules/views/modules/system/views_handler_field_file.inc','views',10),('views_handler_field_file_extension','class','sites/all/modules/views/modules/system/views_handler_field_file_extension.inc','views',10),('views_handler_field_file_filemime','class','sites/all/modules/views/modules/system/views_handler_field_file_filemime.inc','views',10),('views_handler_field_file_size','class','sites/all/modules/views/handlers/views_handler_field.inc','views',10),('views_handler_field_file_status','class','sites/all/modules/views/modules/system/views_handler_field_file_status.inc','views',10),('views_handler_field_file_uri','class','sites/all/modules/views/modules/system/views_handler_field_file_uri.inc','views',10),('views_handler_field_filter_format_name','class','sites/all/modules/views/modules/filter/views_handler_field_filter_format_name.inc','views',10),('views_handler_field_history_user_timestamp','class','sites/all/modules/views/modules/node/views_handler_field_history_user_timestamp.inc','views',10),('views_handler_field_last_comment_timestamp','class','sites/all/modules/views/modules/comment/views_handler_field_last_comment_timestamp.inc','views',10),('views_handler_field_links','class','sites/all/modules/views/handlers/views_handler_field_links.inc','views',10),('views_handler_field_locale_group','class','sites/all/modules/views/modules/locale/views_handler_field_locale_group.inc','views',10),('views_handler_field_locale_language','class','sites/all/modules/views/modules/locale/views_handler_field_locale_language.inc','views',10),('views_handler_field_locale_link_edit','class','sites/all/modules/views/modules/locale/views_handler_field_locale_link_edit.inc','views',10),('views_handler_field_machine_name','class','sites/all/modules/views/handlers/views_handler_field_machine_name.inc','views',10),('views_handler_field_markup','class','sites/all/modules/views/handlers/views_handler_field_markup.inc','views',10),('views_handler_field_math','class','sites/all/modules/views/handlers/views_handler_field_math.inc','views',10),('views_handler_field_ncs_last_comment_name','class','sites/all/modules/views/modules/comment/views_handler_field_ncs_last_comment_name.inc','views',10),('views_handler_field_ncs_last_updated','class','sites/all/modules/views/modules/comment/views_handler_field_ncs_last_updated.inc','views',10),('views_handler_field_node','class','sites/all/modules/views/modules/node/views_handler_field_node.inc','views',10),('views_handler_field_node_comment','class','sites/all/modules/views/modules/comment/views_handler_field_node_comment.inc','views',10),('views_handler_field_node_counter_timestamp','class','sites/all/modules/views/modules/statistics/views_handler_field_node_counter_timestamp.inc','views',10),('views_handler_field_node_language','class','sites/all/modules/views/modules/locale/views_handler_field_node_language.inc','views',10),('views_handler_field_node_link','class','sites/all/modules/views/modules/node/views_handler_field_node_link.inc','views',10),('views_handler_field_node_link_delete','class','sites/all/modules/views/modules/node/views_handler_field_node_link_delete.inc','views',10),('views_handler_field_node_link_edit','class','sites/all/modules/views/modules/node/views_handler_field_node_link_edit.inc','views',10),('views_handler_field_node_link_translate','class','sites/all/modules/views/modules/translation/views_handler_field_node_link_translate.inc','views',10),('views_handler_field_node_new_comments','class','sites/all/modules/views/modules/comment/views_handler_field_node_new_comments.inc','views',10),('views_handler_field_node_path','class','sites/all/modules/views/modules/node/views_handler_field_node_path.inc','views',10),('views_handler_field_node_revision','class','sites/all/modules/views/modules/node/views_handler_field_node_revision.inc','views',10),('views_handler_field_node_revision_link','class','sites/all/modules/views/modules/node/views_handler_field_node_revision_link.inc','views',10),('views_handler_field_node_revision_link_delete','class','sites/all/modules/views/modules/node/views_handler_field_node_revision_link_delete.inc','views',10),('views_handler_field_node_revision_link_revert','class','sites/all/modules/views/modules/node/views_handler_field_node_revision_link_revert.inc','views',10),('views_handler_field_node_translation_link','class','sites/all/modules/views/modules/translation/views_handler_field_node_translation_link.inc','views',10),('views_handler_field_node_type','class','sites/all/modules/views/modules/node/views_handler_field_node_type.inc','views',10),('views_handler_field_node_version_count','class','sites/all/modules/views/modules/node/views_handler_field_node_version_count.inc','views',10),('views_handler_field_numeric','class','sites/all/modules/views/handlers/views_handler_field_numeric.inc','views',10),('views_handler_field_prerender_list','class','sites/all/modules/views/handlers/views_handler_field_prerender_list.inc','views',10),('views_handler_field_profile_date','class','sites/all/modules/views/modules/profile/views_handler_field_profile_date.inc','views',10),('views_handler_field_profile_list','class','sites/all/modules/views/modules/profile/views_handler_field_profile_list.inc','views',10),('views_handler_field_search_score','class','sites/all/modules/views/modules/search/views_handler_field_search_score.inc','views',10),('views_handler_field_serialized','class','sites/all/modules/views/handlers/views_handler_field_serialized.inc','views',10),('views_handler_field_statistics_numeric','class','sites/all/modules/views/modules/statistics/views_handler_field_statistics_numeric.inc','views',10),('views_handler_field_taxonomy','class','sites/all/modules/views/modules/taxonomy/views_handler_field_taxonomy.inc','views',10),('views_handler_field_term_link_edit','class','sites/all/modules/views/modules/taxonomy/views_handler_field_term_link_edit.inc','views',10),('views_handler_field_term_node_tid','class','sites/all/modules/views/modules/taxonomy/views_handler_field_term_node_tid.inc','views',10),('views_handler_field_time_interval','class','sites/all/modules/views/handlers/views_handler_field_time_interval.inc','views',10),('views_handler_field_url','class','sites/all/modules/views/handlers/views_handler_field_url.inc','views',10),('views_handler_field_user','class','sites/all/modules/views/modules/user/views_handler_field_user.inc','views',10),('views_handler_field_user_language','class','sites/all/modules/views/modules/user/views_handler_field_user_language.inc','views',10),('views_handler_field_user_link','class','sites/all/modules/views/modules/user/views_handler_field_user_link.inc','views',10),('views_handler_field_user_link_cancel','class','sites/all/modules/views/modules/user/views_handler_field_user_link_cancel.inc','views',10),('views_handler_field_user_link_edit','class','sites/all/modules/views/modules/user/views_handler_field_user_link_edit.inc','views',10),('views_handler_field_user_mail','class','sites/all/modules/views/modules/user/views_handler_field_user_mail.inc','views',10),('views_handler_field_user_name','class','sites/all/modules/views/modules/user/views_handler_field_user_name.inc','views',10),('views_handler_field_user_permissions','class','sites/all/modules/views/modules/user/views_handler_field_user_permissions.inc','views',10),('views_handler_field_user_picture','class','sites/all/modules/views/modules/user/views_handler_field_user_picture.inc','views',10),('views_handler_field_user_roles','class','sites/all/modules/views/modules/user/views_handler_field_user_roles.inc','views',10),('views_handler_field_xss','class','sites/all/modules/views/handlers/views_handler_field.inc','views',10),('views_handler_filter','class','sites/all/modules/views/handlers/views_handler_filter.inc','views',10),('views_handler_filter_aggregator_category_cid','class','sites/all/modules/views/modules/aggregator/views_handler_filter_aggregator_category_cid.inc','views',10),('views_handler_filter_boolean_operator','class','sites/all/modules/views/handlers/views_handler_filter_boolean_operator.inc','views',10),('views_handler_filter_boolean_operator_string','class','sites/all/modules/views/handlers/views_handler_filter_boolean_operator_string.inc','views',10),('views_handler_filter_broken','class','sites/all/modules/views/handlers/views_handler_filter.inc','views',10),('views_handler_filter_combine','class','sites/all/modules/views/handlers/views_handler_filter_combine.inc','views',10),('views_handler_filter_comment_user_uid','class','sites/all/modules/views/modules/comment/views_handler_filter_comment_user_uid.inc','views',10),('views_handler_filter_countries_continents_list','class','sites/all/modules/countries/views/views_handler_filter_countries_continents_list.inc','countries',0),('views_handler_filter_countries_list','class','sites/all/modules/countries/views/views_handler_filter_countries_list.inc','countries',0),('views_handler_filter_date','class','sites/all/modules/views/handlers/views_handler_filter_date.inc','views',10),('views_handler_filter_entity_bundle','class','sites/all/modules/views/handlers/views_handler_filter_entity_bundle.inc','views',10),('views_handler_filter_equality','class','sites/all/modules/views/handlers/views_handler_filter_equality.inc','views',10),('views_handler_filter_fields_compare','class','sites/all/modules/views/handlers/views_handler_filter_fields_compare.inc','views',10),('views_handler_filter_field_list','class','sites/all/modules/views/modules/field/views_handler_filter_field_list.inc','views',10),('views_handler_filter_field_list_boolean','class','sites/all/modules/views/modules/field/views_handler_filter_field_list_boolean.inc','views',10),('views_handler_filter_file_status','class','sites/all/modules/views/modules/system/views_handler_filter_file_status.inc','views',10),('views_handler_filter_group_by_numeric','class','sites/all/modules/views/handlers/views_handler_filter_group_by_numeric.inc','views',10),('views_handler_filter_history_user_timestamp','class','sites/all/modules/views/modules/node/views_handler_filter_history_user_timestamp.inc','views',10),('views_handler_filter_in_operator','class','sites/all/modules/views/handlers/views_handler_filter_in_operator.inc','views',10),('views_handler_filter_locale_group','class','sites/all/modules/views/modules/locale/views_handler_filter_locale_group.inc','views',10),('views_handler_filter_locale_language','class','sites/all/modules/views/modules/locale/views_handler_filter_locale_language.inc','views',10),('views_handler_filter_locale_version','class','sites/all/modules/views/modules/locale/views_handler_filter_locale_version.inc','views',10),('views_handler_filter_many_to_one','class','sites/all/modules/views/handlers/views_handler_filter_many_to_one.inc','views',10),('views_handler_filter_ncs_last_updated','class','sites/all/modules/views/modules/comment/views_handler_filter_ncs_last_updated.inc','views',10),('views_handler_filter_node_access','class','sites/all/modules/views/modules/node/views_handler_filter_node_access.inc','views',10),('views_handler_filter_node_comment','class','sites/all/modules/views/modules/comment/views_handler_filter_node_comment.inc','views',10),('views_handler_filter_node_language','class','sites/all/modules/views/modules/locale/views_handler_filter_node_language.inc','views',10),('views_handler_filter_node_status','class','sites/all/modules/views/modules/node/views_handler_filter_node_status.inc','views',10),('views_handler_filter_node_tnid','class','sites/all/modules/views/modules/translation/views_handler_filter_node_tnid.inc','views',10),('views_handler_filter_node_tnid_child','class','sites/all/modules/views/modules/translation/views_handler_filter_node_tnid_child.inc','views',10),('views_handler_filter_node_type','class','sites/all/modules/views/modules/node/views_handler_filter_node_type.inc','views',10),('views_handler_filter_node_uid_revision','class','sites/all/modules/views/modules/node/views_handler_filter_node_uid_revision.inc','views',10),('views_handler_filter_node_version_count','class','sites/all/modules/views/modules/node/views_handler_filter_node_version_count.inc','views',10),('views_handler_filter_numeric','class','sites/all/modules/views/handlers/views_handler_filter_numeric.inc','views',10),('views_handler_filter_profile_selection','class','sites/all/modules/views/modules/profile/views_handler_filter_profile_selection.inc','views',10),('views_handler_filter_search','class','sites/all/modules/views/modules/search/views_handler_filter_search.inc','views',10),('views_handler_filter_string','class','sites/all/modules/views/handlers/views_handler_filter_string.inc','views',10),('views_handler_filter_system_type','class','sites/all/modules/views/modules/system/views_handler_filter_system_type.inc','views',10),('views_handler_filter_term_node_tid','class','sites/all/modules/views/modules/taxonomy/views_handler_filter_term_node_tid.inc','views',10),('views_handler_filter_term_node_tid_depth','class','sites/all/modules/views/modules/taxonomy/views_handler_filter_term_node_tid_depth.inc','views',10),('views_handler_filter_term_node_tid_depth_join','class','sites/all/modules/views/modules/taxonomy/views_handler_filter_term_node_tid_depth_join.inc','views',10),('views_handler_filter_tracker_boolean_operator','class','sites/all/modules/views/modules/tracker/views_handler_filter_tracker_boolean_operator.inc','views',10),('views_handler_filter_tracker_comment_user_uid','class','sites/all/modules/views/modules/tracker/views_handler_filter_tracker_comment_user_uid.inc','views',10),('views_handler_filter_user_current','class','sites/all/modules/views/modules/user/views_handler_filter_user_current.inc','views',10),('views_handler_filter_user_name','class','sites/all/modules/views/modules/user/views_handler_filter_user_name.inc','views',10),('views_handler_filter_user_permissions','class','sites/all/modules/views/modules/user/views_handler_filter_user_permissions.inc','views',10),('views_handler_filter_user_roles','class','sites/all/modules/views/modules/user/views_handler_filter_user_roles.inc','views',10),('views_handler_filter_vocabulary_machine_name','class','sites/all/modules/views/modules/taxonomy/views_handler_filter_vocabulary_machine_name.inc','views',10),('views_handler_filter_vocabulary_vid','class','sites/all/modules/views/modules/taxonomy/views_handler_filter_vocabulary_vid.inc','views',10),('views_handler_relationship','class','sites/all/modules/views/handlers/views_handler_relationship.inc','views',10),('views_handler_relationship_broken','class','sites/all/modules/views/handlers/views_handler_relationship.inc','views',10),('views_handler_relationship_entity_reverse','class','sites/all/modules/views/modules/field/views_handler_relationship_entity_reverse.inc','views',10),('views_handler_relationship_groupwise_max','class','sites/all/modules/views/handlers/views_handler_relationship_groupwise_max.inc','views',10),('views_handler_relationship_node_term_data','class','sites/all/modules/views/modules/taxonomy/views_handler_relationship_node_term_data.inc','views',10),('views_handler_relationship_translation','class','sites/all/modules/views/modules/translation/views_handler_relationship_translation.inc','views',10),('views_handler_sort','class','sites/all/modules/views/handlers/views_handler_sort.inc','views',10),('views_handler_sort_broken','class','sites/all/modules/views/handlers/views_handler_sort.inc','views',10),('views_handler_sort_comment_thread','class','sites/all/modules/views/modules/comment/views_handler_sort_comment_thread.inc','views',10),('views_handler_sort_date','class','sites/all/modules/views/handlers/views_handler_sort_date.inc','views',10),('views_handler_sort_group_by_numeric','class','sites/all/modules/views/handlers/views_handler_sort_group_by_numeric.inc','views',10),('views_handler_sort_menu_hierarchy','class','sites/all/modules/views/handlers/views_handler_sort_menu_hierarchy.inc','views',10),('views_handler_sort_ncs_last_comment_name','class','sites/all/modules/views/modules/comment/views_handler_sort_ncs_last_comment_name.inc','views',10),('views_handler_sort_ncs_last_updated','class','sites/all/modules/views/modules/comment/views_handler_sort_ncs_last_updated.inc','views',10),('views_handler_sort_node_language','class','sites/all/modules/views/modules/locale/views_handler_sort_node_language.inc','views',10),('views_handler_sort_node_version_count','class','sites/all/modules/views/modules/node/views_handler_sort_node_version_count.inc','views',10),('views_handler_sort_random','class','sites/all/modules/views/handlers/views_handler_sort_random.inc','views',10),('views_handler_sort_search_score','class','sites/all/modules/views/modules/search/views_handler_sort_search_score.inc','views',10),('views_handler_title_field','class','sites/all/modules/title/views/views_handler_title_field.inc','title',100),('views_join','class','sites/all/modules/views/includes/handlers.inc','views',10),('views_join_subquery','class','sites/all/modules/views/includes/handlers.inc','views',10),('views_many_to_one_helper','class','sites/all/modules/views/includes/handlers.inc','views',10),('views_object','class','sites/all/modules/views/includes/base.inc','views',10),('views_plugin','class','sites/all/modules/views/includes/plugins.inc','views',10),('views_plugin_access','class','sites/all/modules/views/plugins/views_plugin_access.inc','views',10),('views_plugin_access_none','class','sites/all/modules/views/plugins/views_plugin_access_none.inc','views',10),('views_plugin_access_perm','class','sites/all/modules/views/plugins/views_plugin_access_perm.inc','views',10),('views_plugin_access_role','class','sites/all/modules/views/plugins/views_plugin_access_role.inc','views',10),('views_plugin_argument_default','class','sites/all/modules/views/plugins/views_plugin_argument_default.inc','views',10),('views_plugin_argument_default_book_root','class','sites/all/modules/views/modules/book/views_plugin_argument_default_book_root.inc','views',10),('views_plugin_argument_default_current_user','class','sites/all/modules/views/modules/user/views_plugin_argument_default_current_user.inc','views',10),('views_plugin_argument_default_fixed','class','sites/all/modules/views/plugins/views_plugin_argument_default_fixed.inc','views',10),('views_plugin_argument_default_node','class','sites/all/modules/views/modules/node/views_plugin_argument_default_node.inc','views',10),('views_plugin_argument_default_php','class','sites/all/modules/views/plugins/views_plugin_argument_default_php.inc','views',10),('views_plugin_argument_default_raw','class','sites/all/modules/views/plugins/views_plugin_argument_default_raw.inc','views',10),('views_plugin_argument_default_taxonomy_tid','class','sites/all/modules/views/modules/taxonomy/views_plugin_argument_default_taxonomy_tid.inc','views',10),('views_plugin_argument_default_user','class','sites/all/modules/views/modules/user/views_plugin_argument_default_user.inc','views',10),('views_plugin_argument_validate','class','sites/all/modules/views/plugins/views_plugin_argument_validate.inc','views',10),('views_plugin_argument_validate_node','class','sites/all/modules/views/modules/node/views_plugin_argument_validate_node.inc','views',10),('views_plugin_argument_validate_numeric','class','sites/all/modules/views/plugins/views_plugin_argument_validate_numeric.inc','views',10),('views_plugin_argument_validate_php','class','sites/all/modules/views/plugins/views_plugin_argument_validate_php.inc','views',10),('views_plugin_argument_validate_taxonomy_term','class','sites/all/modules/views/modules/taxonomy/views_plugin_argument_validate_taxonomy_term.inc','views',10),('views_plugin_argument_validate_user','class','sites/all/modules/views/modules/user/views_plugin_argument_validate_user.inc','views',10),('views_plugin_cache','class','sites/all/modules/views/plugins/views_plugin_cache.inc','views',10),('views_plugin_cache_none','class','sites/all/modules/views/plugins/views_plugin_cache_none.inc','views',10),('views_plugin_cache_time','class','sites/all/modules/views/plugins/views_plugin_cache_time.inc','views',10),('views_plugin_display','class','sites/all/modules/views/plugins/views_plugin_display.inc','views',10),('views_plugin_display_attachment','class','sites/all/modules/views/plugins/views_plugin_display_attachment.inc','views',10),('views_plugin_display_block','class','sites/all/modules/views/plugins/views_plugin_display_block.inc','views',10),('views_plugin_display_default','class','sites/all/modules/views/plugins/views_plugin_display_default.inc','views',10),('views_plugin_display_embed','class','sites/all/modules/views/plugins/views_plugin_display_embed.inc','views',10),('views_plugin_display_extender','class','sites/all/modules/views/plugins/views_plugin_display_extender.inc','views',10),('views_plugin_display_feed','class','sites/all/modules/views/plugins/views_plugin_display_feed.inc','views',10),('views_plugin_display_page','class','sites/all/modules/views/plugins/views_plugin_display_page.inc','views',10),('views_plugin_exposed_form','class','sites/all/modules/views/plugins/views_plugin_exposed_form.inc','views',10),('views_plugin_exposed_form_basic','class','sites/all/modules/views/plugins/views_plugin_exposed_form_basic.inc','views',10),('views_plugin_exposed_form_input_required','class','sites/all/modules/views/plugins/views_plugin_exposed_form_input_required.inc','views',10),('views_plugin_localization','class','sites/all/modules/views/plugins/views_plugin_localization.inc','views',10),('views_plugin_localization_core','class','sites/all/modules/views/plugins/views_plugin_localization_core.inc','views',10),('views_plugin_localization_none','class','sites/all/modules/views/plugins/views_plugin_localization_none.inc','views',10),('views_plugin_localization_test','class','sites/all/modules/views/tests/views_plugin_localization_test.inc','views',10),('views_plugin_pager','class','sites/all/modules/views/plugins/views_plugin_pager.inc','views',10),('views_plugin_pager_full','class','sites/all/modules/views/plugins/views_plugin_pager_full.inc','views',10),('views_plugin_pager_mini','class','sites/all/modules/views/plugins/views_plugin_pager_mini.inc','views',10),('views_plugin_pager_none','class','sites/all/modules/views/plugins/views_plugin_pager_none.inc','views',10),('views_plugin_pager_some','class','sites/all/modules/views/plugins/views_plugin_pager_some.inc','views',10),('views_plugin_query','class','sites/all/modules/views/plugins/views_plugin_query.inc','views',10),('views_plugin_query_default','class','sites/all/modules/views/plugins/views_plugin_query_default.inc','views',10),('views_plugin_row','class','sites/all/modules/views/plugins/views_plugin_row.inc','views',10),('views_plugin_row_aggregator_rss','class','sites/all/modules/views/modules/aggregator/views_plugin_row_aggregator_rss.inc','views',10),('views_plugin_row_comment_rss','class','sites/all/modules/views/modules/comment/views_plugin_row_comment_rss.inc','views',10),('views_plugin_row_comment_view','class','sites/all/modules/views/modules/comment/views_plugin_row_comment_view.inc','views',10),('views_plugin_row_fields','class','sites/all/modules/views/plugins/views_plugin_row_fields.inc','views',10),('views_plugin_row_node_rss','class','sites/all/modules/views/modules/node/views_plugin_row_node_rss.inc','views',10),('views_plugin_row_node_view','class','sites/all/modules/views/modules/node/views_plugin_row_node_view.inc','views',10),('views_plugin_row_rss_fields','class','sites/all/modules/views/plugins/views_plugin_row_rss_fields.inc','views',10),('views_plugin_row_search_view','class','sites/all/modules/views/modules/search/views_plugin_row_search_view.inc','views',10),('views_plugin_row_user_view','class','sites/all/modules/views/modules/user/views_plugin_row_user_view.inc','views',10),('views_plugin_style','class','sites/all/modules/views/plugins/views_plugin_style.inc','views',10),('views_plugin_style_default','class','sites/all/modules/views/plugins/views_plugin_style_default.inc','views',10),('views_plugin_style_grid','class','sites/all/modules/views/plugins/views_plugin_style_grid.inc','views',10),('views_plugin_style_jump_menu','class','sites/all/modules/views/plugins/views_plugin_style_jump_menu.inc','views',10),('views_plugin_style_list','class','sites/all/modules/views/plugins/views_plugin_style_list.inc','views',10),('views_plugin_style_mapping','class','sites/all/modules/views/plugins/views_plugin_style_mapping.inc','views',10),('views_plugin_style_rss','class','sites/all/modules/views/plugins/views_plugin_style_rss.inc','views',10),('views_plugin_style_summary','class','sites/all/modules/views/plugins/views_plugin_style_summary.inc','views',10),('views_plugin_style_summary_jump_menu','class','sites/all/modules/views/plugins/views_plugin_style_summary_jump_menu.inc','views',10),('views_plugin_style_summary_unformatted','class','sites/all/modules/views/plugins/views_plugin_style_summary_unformatted.inc','views',10),('views_plugin_style_table','class','sites/all/modules/views/plugins/views_plugin_style_table.inc','views',10),('views_slideshow_plugin_style_slideshow','class','sites/all/modules/views_slideshow/views_slideshow_plugin_style_slideshow.inc','views_slideshow',0),('views_test_area_access','class','sites/all/modules/views/tests/test_handlers/views_test_area_access.inc','views',10),('views_test_plugin_access_test_dynamic','class','sites/all/modules/views/tests/test_plugins/views_test_plugin_access_test_dynamic.inc','views',10),('views_test_plugin_access_test_static','class','sites/all/modules/views/tests/test_plugins/views_test_plugin_access_test_static.inc','views',10),('views_test_plugin_style_test_mapping','class','sites/all/modules/views/tests/test_plugins/views_test_plugin_style_test_mapping.inc','views',10),('views_ui','class','sites/all/modules/views/plugins/export_ui/views_ui.class.php','views_ui',0),('VotingAPITestCase','class','sites/all/modules/votingapi/tests/votingapi.test','votingapi',0),('votingapi_views_handler_field_value','class','sites/all/modules/votingapi/views/votingapi_views_handler_field_value.inc','votingapi',0),('votingapi_views_handler_relationship','class','sites/all/modules/votingapi/views/votingapi_views_handler_relationship.inc','votingapi',0),('votingapi_views_handler_sort_nullable','class','sites/all/modules/votingapi/views/votingapi_views_handler_sort_nullable.inc','votingapi',0),('WebformComponentsTestCase','class','sites/all/modules/webform/tests/components.test','webform',-1),('WebformConditionals','class','sites/all/modules/webform/includes/webform.webformconditionals.inc','webform',-1),('WebformConditionalsTestCase','class','sites/all/modules/webform/tests/conditionals.test','webform',-1),('WebformGeneralTestCase','class','sites/all/modules/webform/tests/webform.test','webform',-1),('WebformPermissionsTestCase','class','sites/all/modules/webform/tests/permissions.test','webform',-1),('WebformSubmissionTestCase','class','sites/all/modules/webform/tests/submission.test','webform',-1),('WebformTestCase','class','sites/all/modules/webform/tests/webform.test','webform',-1),('webform_exporter','class','sites/all/modules/webform/includes/exporters/webform_exporter.inc','webform',-1),('webform_exporter_delimited','class','sites/all/modules/webform/includes/exporters/webform_exporter_delimited.inc','webform',-1),('webform_exporter_excel_delimited','class','sites/all/modules/webform/includes/exporters/webform_exporter_excel_delimited.inc','webform',-1),('webform_exporter_excel_xlsx','class','sites/all/modules/webform/includes/exporters/webform_exporter_excel_xlsx.inc','webform',-1),('webform_handler_area_result_pager','class','sites/all/modules/webform/views/webform_handler_area_result_pager.inc','webform',-1),('webform_handler_field_form_body','class','sites/all/modules/webform/views/webform_handler_field_form_body.inc','webform',-1),('webform_handler_field_is_draft','class','sites/all/modules/webform/views/webform_handler_field_is_draft.inc','webform',-1),('webform_handler_field_node_link_edit','class','sites/all/modules/webform/views/webform_handler_field_node_link_edit.inc','webform',-1),('webform_handler_field_node_link_results','class','sites/all/modules/webform/views/webform_handler_field_node_link_results.inc','webform',-1),('webform_handler_field_numeric_data','class','sites/all/modules/webform/views/webform_handler_numeric_data.inc','webform',-1),('webform_handler_field_submission_count','class','sites/all/modules/webform/views/webform_handler_field_submission_count.inc','webform',-1),('webform_handler_field_submission_data','class','sites/all/modules/webform/views/webform_handler_field_submission_data.inc','webform',-1),('webform_handler_field_submission_link','class','sites/all/modules/webform/views/webform_handler_field_submission_link.inc','webform',-1),('webform_handler_field_webform_status','class','sites/all/modules/webform/views/webform_handler_field_webform_status.inc','webform',-1),('webform_handler_filter_is_draft','class','sites/all/modules/webform/views/webform_handler_filter_is_draft.inc','webform',-1),('webform_handler_filter_numeric_data','class','sites/all/modules/webform/views/webform_handler_numeric_data.inc','webform',-1),('webform_handler_filter_submission_data','class','sites/all/modules/webform/views/webform_handler_filter_submission_data.inc','webform',-1),('webform_handler_filter_webform_status','class','sites/all/modules/webform/views/webform_handler_filter_webform_status.inc','webform',-1),('webform_handler_relationship_submission_data','class','sites/all/modules/webform/views/webform_handler_relationship_submission_data.inc','webform',-1),('webform_handler_sort_numeric_data','class','sites/all/modules/webform/views/webform_handler_numeric_data.inc','webform',-1),('webform_views_plugin_row_submission_view','class','sites/all/modules/webform/views/webform_plugin_row_submission_view.inc','webform',-1),('WeightNodeHandler','class','sites/all/modules/weight/weight.migrate.inc','weight',0),('weight_handler_field_weight','class','sites/all/modules/weight/views/weight_handler_field_weight.inc','weight',0),('weight_handler_filter_weight_enabled','class','sites/all/modules/weight/views/weight_handler_filter_weight_enabled.inc','weight',0);
/*!40000 ALTER TABLE `registry` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `registry_file`
--

DROP TABLE IF EXISTS `registry_file`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `registry_file` (
  `filename` varchar(255) NOT NULL COMMENT 'Path to the file.',
  `hash` varchar(64) NOT NULL COMMENT 'sha-256 hash of the file’s contents when last parsed.',
  PRIMARY KEY (`filename`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Files parsed to build the registry.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `registry_file`
--

LOCK TABLES `registry_file` WRITE;
/*!40000 ALTER TABLE `registry_file` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `registry_file` VALUES ('includes/actions.inc','f36b066681463c7dfe189e0430cb1a89bf66f7e228cbb53cdfcd93987193f759'),('includes/ajax.inc','3d1c0d2efcdab327224122df1156a665f9bbf60873907dde2f189b018d4e9be3'),('includes/archiver.inc','bdbb21b712a62f6b913590b609fd17cd9f3c3b77c0d21f68e71a78427ed2e3e9'),('includes/authorize.inc','6d64d8c21aa01eb12fc29918732e4df6b871ed06e5d41373cb95c197ed661d13'),('includes/batch.inc','1fe00f9a25481cd43e19fbd6bd37b7ff9dca79f8405ec3e55ffb011be12ec2c3'),('includes/batch.queue.inc','554b2e92e1dad0f7fd5a19cb8dff7e109f10fbe2441a5692d076338ec908de0f'),('includes/bootstrap.inc','fdd02ea25268751b8024237b82792c9c05e596f744bb1c2cda4d36da839c902c'),('includes/cache-install.inc','e7ed123c5805703c84ad2cce9c1ca46b3ce8caeeea0d8ef39a3024a4ab95fa0e'),('includes/cache.inc','033c9bf2555dba29382b077f78cc00c82fd7f42a959ba31b710adddf6fdf24fe'),('includes/common.inc','04e8ed1c7f366c1012909481c118ec0203e3c998782564bfdbc5620c82def903'),('includes/database/database.inc','2ef46543fb9cf61ed9fa9aed4e44dd31630c22604ea6b8e48b57ebd7ad11a111'),('includes/database/log.inc','9feb5a17ae2fabcf26a96d2a634ba73da501f7bcfc3599a693d916a6971d00d1'),('includes/database/mysql/database.inc','32a577354dba6030043500873f8a2a7359c80c179a213284b026c1a9b0452b70'),('includes/database/mysql/install.inc','6ae316941f771732fbbabed7e1d6b4cbb41b1f429dd097d04b3345aa15e461a0'),('includes/database/mysql/query.inc','0212a871646c223bf77aa26b945c77a8974855373967b5fb9fdc09f8a1de88a6'),('includes/database/mysql/schema.inc','2ef729f8d6466d5cd87ba233152d88590bce629d8366040b2509b4e24258d780'),('includes/database/pgsql/database.inc','651bec324e2204aa35a28fdbd876aa8e4f7a9e909e75cc8db811e9c156b0df88'),('includes/database/pgsql/install.inc','39587f26a9e054afaab2064d996af910f1b201ef1c6b82938ef130e4ff8c6aab'),('includes/database/pgsql/query.inc','0df57377686c921e722a10b49d5e433b131176c8059a4ace4680964206fc14b4'),('includes/database/pgsql/schema.inc','1588daadfa53506aa1f5d94572162a45a46dc3ceabdd0e2f224532ded6508403'),('includes/database/pgsql/select.inc','1e509bc97c58223750e8ea735145b316827e36f43c07b946003e41f5bca23659'),('includes/database/prefetch.inc','b5b207a66a69ecb52ee4f4459af16a7b5eabedc87254245f37cc33bebb61c0fb'),('includes/database/query.inc','982d44a294eea1c9619687c14df2987257e3776fcabeba05f01432e934cf61c6'),('includes/database/schema.inc','6ea8e4063eb72d8f6b1a9f8b8908489d9f89b4a158ef37002d21209fb500358c'),('includes/database/select.inc','02a2d4345287df62b163ca2524e99b7370c9ec167bc937245328683d4e3e3d56'),('includes/database/sqlite/database.inc','62f6669c4610557c4b34ada9f0a0f61d6cb7b377e0a9032d2efca7b5f39b0965'),('includes/database/sqlite/install.inc','6620f354aa175a116ba3a0562c980d86cc3b8b481042fc3cc5ed6a4d1a7a6d74'),('includes/database/sqlite/query.inc','0eb02ad036ef61c490fb3f189a4cdc8fc1ae0d442737806346fd63aea8f30db3'),('includes/database/sqlite/schema.inc','3a7d22ec1f0ee09bfa267309b90e30edbe39e453b3025b30cbe3ae7412a4df2d'),('includes/database/sqlite/select.inc','8d1c426dbd337733c206cce9f59a172546c6ed856d8ef3f1c7bef05a16f7bf68'),('includes/date.inc','1de2c25e3b67a9919fc6c8061594442b6fb2cdd3a48ddf1591ee3aa98484b737'),('includes/entity.inc','f06b508f93e72ba70f979d8391be57662c018a03a32fac0a6d3baa752740133d'),('includes/errors.inc','d731bbe3a60508e164cfa90b8edc06400c7f15844f9f9bc3935dd87e44c460db'),('includes/file.inc','f112194214d483ce867165922ad7996c64174bd932369f89f8335af026bbb493'),('includes/file.mimetypes.inc','33266e837f4ce076378e7e8cef6c5af46446226ca4259f83e13f605856a7f147'),('includes/filetransfer/filetransfer.inc','fdea8ae48345ec91885ac48a9bc53daf87616271472bb7c29b7e3ce219b22034'),('includes/filetransfer/ftp.inc','51eb119b8e1221d598ffa6cc46c8a322aa77b49a3d8879f7fb38b7221cf7e06d'),('includes/filetransfer/local.inc','7cbfdb46abbdf539640db27e66fb30e5265128f31002bd0dfc3af16ae01a9492'),('includes/filetransfer/ssh.inc','92f1232158cb32ab04cbc93ae38ad3af04796e18f66910a9bc5ca8e437f06891'),('includes/form.inc','a0e219d53d641f08d6f1d609e53f06f3f8b1c591d20113d0992557c815b44a72'),('includes/graph.inc','8e0e313a8bb33488f371df11fc1b58d7cf80099b886cd1003871e2c896d1b536'),('includes/image.inc','bcdc7e1599c02227502b9d0fe36eeb2b529b130a392bc709eb737647bd361826'),('includes/install.core.inc','189653e4bb7d4828bd6e1b61015fabcc7182e23d9dd8858170f98114d99400c8'),('includes/install.inc','fbb23627b06abb070b4531da786c1e06bf1dbd6f923bb2b404f4808c2340b0f9'),('includes/iso.inc','0ce4c225edcfa9f037703bc7dd09d4e268a69bcc90e55da0a3f04c502bd2f349'),('includes/json-encode.inc','02a822a652d00151f79db9aa9e171c310b69b93a12f549bc2ce00533a8efa14e'),('includes/language.inc','4e08f30843a7ccaeea5c041083e9f77d33d57ff002f1ab4f66168e2c683ce128'),('includes/locale.inc','ca50acc0780cbffeca17f99a0997f91b8b9402f0eec1898c3122e1d73664d01d'),('includes/lock.inc','a181c8bd4f88d292a0a73b9f1fbd727e3314f66ec3631f288e6b9a54ba2b70fa'),('includes/mail.inc','41d0e657119a05f8d7e85ebf32e74b12a1c3107d717a348158414b113e208b9c'),('includes/menu.inc','8e7a8a1a4666a8ca66d1b19cc97be4cf82c3bb0e835e652ee366bec9b74a8c23'),('includes/module.inc','8dab73e50e6bcd680a26f55597d2d103ba68a29089f888e2a2c206fc38eaa669'),('includes/pager.inc','6f9494b85c07a2cc3be4e54aff2d2757485238c476a7da084d25bde1d88be6d8'),('includes/password.inc','fd9a1c94fe5a0fa7c7049a2435c7280b1d666b2074595010e3c492dd15712775'),('includes/path.inc','2dca08d14a46e5ac6a665b7a5dde78045d8de2b35aaa78c6fb811e1125ce4953'),('includes/registry.inc','f47b20859f0fc80bf4bb2849a1282d6c54006957b69da0e5f4691de585ca4cdf'),('includes/session.inc','5851ff6941aba2744dd0c247f077fc02fbbe24e9786e04ea0a3c372d68ca6d16'),('includes/stream_wrappers.inc','b8a5a53f3d3ef26ea868037547f76af8049ce0c55b464810c627310a84f24924'),('includes/tablesort.inc','2d88768a544829595dd6cda2a5eb008bedb730f36bba6dfe005d9ddd999d5c0f'),('includes/theme.inc','5d8b96db9760367eb86821085a17a144a58cb355e6f547e321321ee34535da7b'),('includes/theme.maintenance.inc','39f068b3eee4d10a90d6aa3c86db587b6d25844c2919d418d34d133cfe330f5a'),('includes/token.inc','5e7898cd78689e2c291ed3cd8f41c032075656896f1db57e49217aac19ae0428'),('includes/unicode.entities.inc','2b858138596d961fbaa4c6e3986e409921df7f76b6ee1b109c4af5970f1e0f54'),('includes/unicode.inc','e18772dafe0f80eb139fcfc582fef1704ba9f730647057d4f4841d6a6e4066ca'),('includes/update.inc','25c30f1e61ef9c91a7bdeb37791c2215d9dc2ae07dba124722d783ca31bb01e7'),('includes/updater.inc','d2da0e74ed86e93c209f16069f3d32e1a134ceb6c06a0044f78e841a1b54e380'),('includes/utility.inc','3458fd2b55ab004dd0cc529b8e58af12916e8bd36653b072bdd820b26b907ed5'),('includes/xmlrpc.inc','ea24176ec445c440ba0c825fc7b04a31b440288df8ef02081560dc418e34e659'),('includes/xmlrpcs.inc','925c4d5bf429ad9650f059a8862a100bd394dce887933f5b3e7e32309a51fd8e'),('modules/block/block.test','40d9de00589211770a85c47d38c8ad61c598ec65d9332128a882eb8750e65a16'),('modules/color/color.test','610ba154f42b6af5871fb09cdb0bc7badc29b03845c08d86e0e524840dd27568'),('modules/comment/comment.module','db858137ff6ce06d87cb3b8f5275bed90c33a6d9aa7d46e7a74524cc2f052309'),('modules/comment/comment.test','332d14e197b4ebe85b1b70a15602981d99d332e2293576c0e44cf18a808c7aac'),('modules/contextual/contextual.test','023dafa199bd325ecc55a17b2a3db46ac0a31e23059f701f789f3bc42427ba0b'),('modules/dashboard/dashboard.test','125df00fc6deb985dc554aa7807a48e60a68dbbddbad9ec2c4718da724f0e683'),('modules/dblog/dblog.test','79ba7991c3f40f9241e9a03ffa43faf945c82658ca9b52ec62bd13bd80f41269'),('modules/field/field.attach.inc','2df4687b5ec078c4893dc1fea514f67524fd5293de717b9e05caf977e5ae2327'),('modules/field/field.info.class.inc','cf18178e119d43897d3abd882ba3acc0cf59d1ad747663437c57b1ec4d0a4322'),('modules/field/field.module','48b5b83f214a8d19e446f46c5d7a1cd35faa656ccb7b540f9f02462a440cacdd'),('modules/field/modules/field_sql_storage/field_sql_storage.test','315eedaf2022afc884c35efd3b7c400eddab6ea30bec91924bc82ab5cd3e79f2'),('modules/field/modules/list/tests/list.test','c1a214d7efd3247dd947d742a8514ec9649da62593608dfdccee6913d48e5709'),('modules/field/modules/number/number.test','fc8f193904f1c5f87dcf51a279975214b34aa1349fe9c38b09c4e6740b059b49'),('modules/field/modules/options/options.test','1b30956b6f46840ccb41b99bda08f328172f008f1fb4164c65fe9e4047fffa5f'),('modules/field/modules/text/text.test','5c28b9da26417d2ed8a169850989c0b59f2b188a0161eb58e2b87c67994d602d'),('modules/field/tests/field.test','5eaad7a933ef8ea05b958056492ce17858cd542111f0fe81dd1a5949ad8f966e'),('modules/field_ui/field_ui.test','f535e5627c969e9083a63aaf72d4ac645e30709d7b87af15c6c3b870481f283a'),('modules/file/tests/file.test','f2328df0915f0d7235cb147515ed64cb1c510a744646fb680da98c8d9f2523c5'),('modules/filter/filter.test','b8aa5e6b832422c6ad5fe963898ec9526c814614f27ecccb67107ce194997d6a'),('modules/help/help.test','bc934de8c71bd9874a05ccb5e8f927f4c227b3b2397d739e8504c8fd6ae5a83c'),('modules/image/image.test','6e7a0cbcb58f6210127b0ac7c1d118d488abd0925fe8db10a3405af87f1d9fe1'),('modules/locale/locale.test','08793bfbabe6147248a3cbbecaec2c3179baf15bd3289b43f3b0dad3bc8280ae'),('modules/menu/menu.test','71efd7117a882fdcdd50971b4a68f7f2895b532e09acf094d747f27a15742c5b'),('modules/node/node.module','70f969229d03819dba439546ae7aef30283b93e410af1b45f5a25b90d3cb8edd'),('modules/node/node.test','35bf40fde62f3a1de95bab9f037b84f20c2f93a1c579d7d19e4a87afe75dc330'),('modules/path/path.test','2004183b2c7c86028bf78c519c6a7afc4397a8267874462b0c2b49b0f8c20322'),('modules/php/php.test','d234f9c1ab18a05834a3cb6dc532fb4c259aa25612551f953ba6e3bb714657b8'),('modules/search/search.extender.inc','013a6a841cc48a6dc991153fb692b8d1546e56b78d9c95e97e0d7e92296d3481'),('modules/search/search.test','e43c21510d510885dfad6484afa931382083b75b7e67286bda56a6aafe265f28'),('modules/shortcut/shortcut.test','0d78280d4d0a05aa772218e45911552e39611ca9c258b9dd436307914ac3f254'),('modules/system/system.archiver.inc','faa849f3e646a910ab82fd6c8bbf0a4e6b8c60725d7ba81ec0556bd716616cd1'),('modules/system/system.mail.inc','d31e1769f5defbe5f27dc68f641ab80fb8d3de92f6e895f4c654ec05fc7e5f0f'),('modules/system/system.queue.inc','a77a5913d84368092805ac551ca63737c1d829455504fcccb95baa2932f28009'),('modules/system/system.tar.inc','d0d2f191d79b3227852e7436908386bdd7a25f78c73f3c8bf9ef5903892ae993'),('modules/system/system.test','7a94d94c13eb60684678e62f25cec44d46714a1ca4987f62d86d358e8978902a'),('modules/system/system.updater.inc','9433fa8d39500b8c59ab05f41c0aac83b2586a43be4aa949821380e36c4d3c48'),('modules/taxonomy/taxonomy.module','19992c2e810a7b7a1c228d178b0b6c5f358082d515b8a6e77b0415a430e23997'),('modules/taxonomy/taxonomy.test','ce91ff8a2879d65fdb3477d3f437cad8ef50b8963dadb75ae203854987b2c23a'),('modules/update/update.test','994b66b737f16eb98ee18c9e9ecd62e86de2792159e70b36982e95b48f2746a3'),('modules/user/user.module','b773a1b0f7448546393e6f7b2436d0d91b7965889afdf4a863bba4c0bc0dba69'),('modules/user/user.test','0b55048c0de2dee5ab1c25a38c01b3bd13f476b43e4172bb0c06cb6188d2edc9'),('sites/all/modules/addressfield/addressfield.migrate.inc','e380fa7331f04e098224ea0fad8bcd2572bd6680c86f60206f926bb25ce2bc5d'),('sites/all/modules/addressfield/views/addressfield_views_handler_field_country.inc','e87fd32bd4ba5229040ab7020206774fec2717236d4a39c729362b5c7a55f03c'),('sites/all/modules/addressfield/views/addressfield_views_handler_filter_country.inc','51956e153daca9f27e4c8bbecfa2398a4ef50391d2f5bcac258586a6d1dd1fb2'),('sites/all/modules/admin_menu/tests/admin_menu.test','185f8244f7a086cda1bd9435ec529e8632598e9b09d1e0d7363b75cf87c04afb'),('sites/all/modules/better_exposed_filters/better_exposed_filters_exposed_form_plugin.inc','64b7e6ba646b8e34d12ab61f6635d3b56acffe4f8220cff22eec0b790a37d5a5'),('sites/all/modules/better_exposed_filters/tests/better_exposed_filters.test','6ca4aeb4b38d2efe8df587435dd073b8e1a218faa48f155d27ec2c44b5f88c35'),('sites/all/modules/block_class/block_class.test','ad3e6238a7a0c025d2cac75cfa089c90ce721a94241925db4484ceb6a04ec8a4'),('sites/all/modules/cloud_zoom/cloud_zoom.module','e2d897e80021f49120eab4db3e2b0154c03ee3ae83714c3a6feb6490a71007ed'),('sites/all/modules/commerce/includes/commerce.controller.inc','248037a84c99cddc817e8c1bb5a6b219b5a52ebad9194caee9e81228cbb756bc'),('sites/all/modules/commerce/modules/cart/includes/views/handlers/commerce_cart_handler_area_empty_text.inc','0e6492974d7c4456f0fad1b8e5222aa24a55a12f35bb6c8069827450bb2da939'),('sites/all/modules/commerce/modules/cart/includes/views/handlers/commerce_cart_handler_field_add_to_cart_form.inc','7f535730f3c0b47b95349a70f99704f0620eea7d839ad3501b0c469c113f8b67'),('sites/all/modules/commerce/modules/cart/includes/views/handlers/commerce_cart_handler_field_edit_attributes.inc','688e8399990d3e5853ba59d193047c03df2f4e76bdf3e1b6d7aaa28caf025cd5'),('sites/all/modules/commerce/modules/cart/includes/views/handlers/commerce_cart_plugin_argument_default_current_cart_order_id.inc','b84cad387beb045be35f171f5e85a856644b9ac2bb7941191f3e9be77f88a710'),('sites/all/modules/commerce/modules/cart/tests/commerce_cart.test','258debbb7f1251924658b3d27d0f3a60dd9e6a18f114400b0186cf00475429a3'),('sites/all/modules/commerce/modules/checkout/tests/commerce_checkout.test','337b9fbf1afbe746e5e967c1531d3cab994bb0eeadd54e0cba4da0ff00aed1a3'),('sites/all/modules/commerce/modules/customer/includes/commerce_customer_profile.controller.inc','85bf83dabd007703d86c55e8d1f1a8fbee5d5b158a2864f622544d64ee69edcb'),('sites/all/modules/commerce/modules/customer/includes/views/handlers/commerce_customer_handler_area_empty_text.inc','fed903be8479497e5a1310d94bb211af51c20274a3e285e2bb1817bfc11fbc3c'),('sites/all/modules/commerce/modules/customer/includes/views/handlers/commerce_customer_handler_field_customer_profile.inc','ebe35f7320b8dd6bd46c1aba843111af38c0aa9263c02b768daa66d720bd6070'),('sites/all/modules/commerce/modules/customer/includes/views/handlers/commerce_customer_handler_field_customer_profile_link.inc','532d0b95202ac3f91dc501f87683dadb25e20d6461f3862582d5884b89484156'),('sites/all/modules/commerce/modules/customer/includes/views/handlers/commerce_customer_handler_field_customer_profile_link_delete.inc','e16edf474e1f85f04104595847b96cc1ad9a9f639f71a7d5dc9888b8cdb67628'),('sites/all/modules/commerce/modules/customer/includes/views/handlers/commerce_customer_handler_field_customer_profile_link_edit.inc','ccc7610e3c39af5c89525875efe48321144f9a1cb592f59be9adbf54b2b84166'),('sites/all/modules/commerce/modules/customer/includes/views/handlers/commerce_customer_handler_field_customer_profile_type.inc','29e0cd35a8bc418c386909733f5fd15a04bb21b74e75e497a1d54b06243ccf6b'),('sites/all/modules/commerce/modules/customer/includes/views/handlers/commerce_customer_handler_filter_customer_profile_type.inc','8f8c4cb4051b7fedb749329396c543fc7202f3cad391eda98cde6a41223812f7'),('sites/all/modules/commerce/modules/customer/tests/commerce_customer_ui.test','48750f3fbd5a6eab95801f7da1be67bcead71e26e8b3ba88d421edf775bbf5f7'),('sites/all/modules/commerce/modules/line_item/includes/commerce_line_item.controller.inc','86c6f46c78e400e3032cd404f7839a912f214de64b2ce71f6ec3116bcdd86ca2'),('sites/all/modules/commerce/modules/line_item/includes/views/handlers/commerce_line_item_handler_area_line_item_summary.inc','d18bbd5a19ab3a259876ec5b8d0da8d2045e7b82e170ccb9ec201b5da7c58967'),('sites/all/modules/commerce/modules/line_item/includes/views/handlers/commerce_line_item_handler_argument_line_item_line_item_id.inc','81480b49818b241ce78cfb6c077cce289494c237c021664f190f1d8c9ba7800e'),('sites/all/modules/commerce/modules/line_item/includes/views/handlers/commerce_line_item_handler_field_edit_delete.inc','68ef6e754dbaaae8229c744c100aafcaa9bf57f049d95a473530e6fabf73d8b9'),('sites/all/modules/commerce/modules/line_item/includes/views/handlers/commerce_line_item_handler_field_edit_quantity.inc','f490ea63c696d411cbad657301f61763486618a3037748a2820e0504c4ec08de'),('sites/all/modules/commerce/modules/line_item/includes/views/handlers/commerce_line_item_handler_field_line_item_title.inc','3822e632c5ea542f71227060d76debdb9097ad369e74fa3a2e89d077f3a22e02'),('sites/all/modules/commerce/modules/line_item/includes/views/handlers/commerce_line_item_handler_field_line_item_type.inc','cb2db3c3349cb740f5c77272a56cd6be31d54e36f3482af8ebc1278aa375141b'),('sites/all/modules/commerce/modules/line_item/includes/views/handlers/commerce_line_item_handler_filter_line_item_is_referenced.inc','ea396f7eb8991b6cd243ea9fc60c07e17e1eab6537595c68b1b3dbc8ced7293e'),('sites/all/modules/commerce/modules/line_item/includes/views/handlers/commerce_line_item_handler_filter_line_item_type.inc','659256427a611b407a22c9a2c2f3e8c78b467303ec95841a82c8afcc8c8a727a'),('sites/all/modules/commerce/modules/order/includes/commerce_order.controller.inc','e7f2d8386171d1aa525838e6e2274df2adc155beca2fdab4841e8d32bef3679e'),('sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_area_empty_text.inc','c9d0a4c48f04d2ab7e87d46f9dfb59bc92c618f8b39204dcce054091b52364c1'),('sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_area_order_total.inc','aee446ec85e60d9270d957859295e72247a34c363cd9e21a70de0042bdf70f0d'),('sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_argument_order_order_id.inc','cb6ac659e98422f86972b44565128fe6f0d365601443e7e36828a520222cf688'),('sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_field_order.inc','a977f8e47c334e07d31a4c0a18cd04e1e0f56f6821709f5e8e71eec995c38f02'),('sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_field_order_link.inc','0d8b298a1b45541f0a7553ff5c7309046200b071a6f7f5596693541c7a719db3'),('sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_field_order_link_delete.inc','caec98e1d1fe9bc1d9119991151f42f2fd673c0181779c80034cf15dc5faed6e'),('sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_field_order_link_edit.inc','691ffbd21c9519cb642a9e366b1a4bb1ebdace5f666559d833fb07ab5f079e21'),('sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_field_order_mail.inc','f2be853810ce4f954043407ddc1be88aa001101ed9a5fa66aa42ad2c0c1dfff5'),('sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_field_order_operations.inc','f2d6ec4603fda04b7fc05ec6ef4e53a3850fc7721664365b3b5e6cdc6b1e2d04'),('sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_field_order_state.inc','bcbec60e2fb92fb75dae0bbbbe819e801840cbb3de63ef2a1f9535c725bc1623'),('sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_field_order_status.inc','4a25a59b07cfe43385f985cd616411f6c2ad29fa38527d9880f54a8fd559e016'),('sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_field_order_type.inc','71e9aa4c5dfcb42eff64f7b8a3232527fc006305e91b72756bb6e439d452153e'),('sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_filter_order_state.inc','a719a0fd34c099b3eec20c1e5a5ed72acc7119dc9162d3ab6ae90af39de0de9d'),('sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_filter_order_status.inc','42504b8d7b5f17d02179d70079814c2fee3e40f747d0ff35de4c20186e0c3043'),('sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_handler_filter_order_type.inc','d8436f1591e9fd62bb0aa1fcc3129fd01268fe0a3c7af3cd0a2342e4d3408636'),('sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_plugin_argument_validate_user.inc','743a72f40e414f7b1928142eb1a8042d4d2fa5281ec750922f2d9e6862882824'),('sites/all/modules/commerce/modules/order/includes/views/handlers/commerce_order_ui_handler_area_view_order_form.inc','4483d114736578f480359578047b526762a5c571c982ffdcfd6458c6acf8f662'),('sites/all/modules/commerce/modules/order/tests/commerce_order.rules.test','04ec760068e39ad13ab72a37cf3dc002c6328825a55f822aa7efa3218f2d60e4'),('sites/all/modules/commerce/modules/order/tests/commerce_order.test','904d356edfa8542d083c996e4c06ba7b6f55c62fc0daca26778056d8af1edf22'),('sites/all/modules/commerce/modules/order/tests/commerce_order_ui.test','b185458945355a95cf3a057160cdc690aa80fa03821ed31f2ea9c11628c052c9'),('sites/all/modules/commerce/modules/payment/commerce_payment.rules.inc','0153ad66ca4781078f3ede987c5532f1a472fbe3dd2b6aa72410e888eeb95ee9'),('sites/all/modules/commerce/modules/payment/includes/commerce_payment_transaction.controller.inc','b12a4a18fbc642b0e4081179fccde644d89d7679bf9dde7646e388f4bc8befe2'),('sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_area_totals.inc','f0991a1b4083b5f702fca3f62a597022e49185dec9ad2b4d098af00d78c3c0ec'),('sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_field_amount.inc','569c5d4c24fe590e2e866d9b9a79645043396c3b431960ac993c1836dfd25ecf'),('sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_field_balance.inc','de9aeb8e12a4659231ff676095ae819fc88aee4b238f54f3926999be7a539ef1'),('sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_field_currency_code.inc','6154926f646d9fe3172340d41a62672a0e26611da0872d42b4a82b6cb1486879'),('sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_field_message.inc','9855e47621475e512cd54baea47a376e5eb4e4b4e42c279f395c2c2f1aab2903'),('sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_field_payment_method.inc','f3601781c3f0ddc077f58668f405de3639e99315977fde4753e1f8996c6faf16'),('sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_field_payment_transaction_link.inc','ef3c32f9836535e18a674bbbad030685a4b81ea08d34547a2055c04dba888090'),('sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_field_payment_transaction_link_delete.inc','eaaec1a608b819c4c9e42f3f3ac558a800347b1b732068f89513df5ed407d35e'),('sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_field_payment_transaction_operations.inc','b8bde7f508f298e45800ab7b2b9c8e9cd9c52fdc61961ff7535bf7f997d3c120'),('sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_field_status.inc','b746d6dbf127ff715b0e47b3d0c167745f1baad8057b878d4969ea24a016c171'),('sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_filter_currency_code.inc','f0bc3d1da8a2396aa06c01ebfb1d620066a173ffc3bb8565655201d0a1d3ba25'),('sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_filter_payment_method.inc','ca86dba0891054cc2c172ee862341dbd92577187df28c6634c547f9114037199'),('sites/all/modules/commerce/modules/payment/includes/views/handlers/commerce_payment_handler_filter_payment_transaction_status.inc','1d7b8959c12c22c909930bff6e90ad5f55db95ed04b258d08f7ebc9d157760e9'),('sites/all/modules/commerce/modules/payment/tests/commerce_payment.rules.test','2fa338eca91d1e212657dd29f505a4fda3b1cb81663e278936befc243a3c18c1'),('sites/all/modules/commerce/modules/payment/tests/commerce_payment_ui.test','917aea18ebe2def8f90884ce07e63d06216a0687f2ef7e9de457080375366261'),('sites/all/modules/commerce/modules/price/commerce_price.rules.inc','16541b1d9da4f98443003289c228222d33754dfbc8dc07d719ae01c4f8c549ac'),('sites/all/modules/commerce/modules/price/includes/views/handlers/commerce_price_handler_field_commerce_price.inc','e84d432bb7a02f22344a6a84527aa2d1ca70589a706aae84991a71df7c8b2a27'),('sites/all/modules/commerce/modules/price/includes/views/handlers/commerce_price_handler_filter_commerce_price_amount.inc','205b6df491c7c82e22c3f8cd29306994ab2115c7d99f2f24b4a76e4316be3f5f'),('sites/all/modules/commerce/modules/product/includes/commerce_product.controller.inc','ebbd8db4485553c2b3ff3121082de7287156c2263b0a3e9f4d863ecadfa54168'),('sites/all/modules/commerce/modules/product/includes/commerce_product.translation_handler.inc','d88c0e171b4ba03e024d975c4a4410305aa2675795782f37df5d7171a06a30f8'),('sites/all/modules/commerce/modules/product/includes/views/handlers/commerce_product_handler_area_empty_text.inc','3fc65f87f59bba6c1d5ef7c7969bb1d3a8c91d9d18cda8bb01cbcfd62bc20bdc'),('sites/all/modules/commerce/modules/product/includes/views/handlers/commerce_product_handler_argument_product_id.inc','651774675d1cb476411fc0bc44949d40bb4fca2760089de187363a5171ae4445'),('sites/all/modules/commerce/modules/product/includes/views/handlers/commerce_product_handler_field_product.inc','24d037ac9a5ceb9170646770c62f030f5e55ca8b7c1272ad8c6b55539618a526'),('sites/all/modules/commerce/modules/product/includes/views/handlers/commerce_product_handler_field_product_link.inc','ee3a40bc879eebfba39543bf62cf34b8d408168b9399dd087bcd628f1d5f31ed'),('sites/all/modules/commerce/modules/product/includes/views/handlers/commerce_product_handler_field_product_link_delete.inc','4d4877469c84cdeb775b06ad09977efd91d745d6c161753d72bd155dda851529'),('sites/all/modules/commerce/modules/product/includes/views/handlers/commerce_product_handler_field_product_link_edit.inc','00c8d31f31ce028dbd1a527c7f4c13daae48d0636d30b741842c4dc3829f90e9'),('sites/all/modules/commerce/modules/product/includes/views/handlers/commerce_product_handler_field_product_operations.inc','a58db505803442eec0efc59a4375fcc60314108aa0dc4b934bdfa11d7a9dd86b'),('sites/all/modules/commerce/modules/product/includes/views/handlers/commerce_product_handler_field_product_type.inc','8106f66874127a7c180a97478c5e63d92667543983010be0ce7d71c2c1f3c7ed'),('sites/all/modules/commerce/modules/product/includes/views/handlers/commerce_product_handler_filter_product_type.inc','1ea0f4a8efe1def76619e3d2e576e176330ee61b9eea86775150c646842bb754'),('sites/all/modules/commerce/modules/product/tests/commerce_product.test','0233a8db5a8ec35e8b5bcda18273cb8da152dcfbcb04ad8d88a3459d99e8c9cd'),('sites/all/modules/commerce/modules/product/tests/commerce_product_ui.test','dbddff7a5281eeb93c89d1b89a484fcc05fac0dad7f9524942138638af52f645'),('sites/all/modules/commerce/modules/product_reference/includes/views/handlers/commerce_product_reference_handler_filter_node_is_product_display.inc','4aa262c1b96313b4e1e2c53bc99f443e44c259f150cd7ba2e3687e0946d26ea1'),('sites/all/modules/commerce/modules/product_reference/includes/views/handlers/commerce_product_reference_handler_filter_node_type.inc','8f247d3c2b181f650dbb4b76e44be33248b814c14e3cbf8ff36eab5cbd677d18'),('sites/all/modules/commerce/modules/product_reference/includes/views/handlers/commerce_product_reference_handler_filter_product_line_item_type.inc','6cde0d9ddbc01fdc70e69182417160e11a79ccb16e8718c1db95fffa9c5978d5'),('sites/all/modules/commerce/modules/product_reference/tests/commerce_product_reference.test','a38ef2ec0c83ad4bd505dd9a9cec7d6395d22635720854ea30a4974bbe6ed78c'),('sites/all/modules/commerce/tests/commerce_base.test','01746a2e204743e170423af3e597e139ab7054fc40a3fd889ad3e3eed489990e'),('sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/lib/commerce_marketplace_funds.account.controller.inc','3f1816ad76e90f9421d1dbf538a012dbd55fd06e7f487df3e27f4c9029fbc2b1'),('sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/lib/commerce_marketplace_funds.account.entity.inc','4cef69e1560c1ea50dff167ffdc8a8aba9079813fa0b44bf254869cade9a747c'),('sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/lib/commerce_marketplace_funds.account.metadata.inc','952e1a2188cc1f3736a20295e1afec269b236b5f33a6fa12b22e262d56f6d985'),('sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/lib/commerce_marketplace_funds.processor.interface.inc','be4a41bf0afee87814a1efdedd60377136d3059a2a4de45063f6cb43c2ac9317'),('sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/lib/commerce_marketplace_funds.transaction.controller.inc','2b167734a703202554881925650aaf986db217e3ec44cdd5cadb45279e6e5a73'),('sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/lib/commerce_marketplace_funds.transaction.entity.inc','78257e0bf0e0089cb9248f297518afb5a89321670cb5ffb013a5fbf8b571b3c9'),('sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/lib/commerce_marketplace_funds.transaction.metadata.inc','b6b2947394b6ff7a746a521c51c42c22bfd88714c1b6ee593b64eced4a387cf5'),('sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/modules/withdraw/includes/commerce_marketplace_funds_withdraw.method.admin.inc','98bf288fac37d44dbb3e4604aa491185a660b9252686a0fac1261959d4814158'),('sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/modules/withdraw/includes/commerce_marketplace_funds_withdraw.method_type.admin.inc','64783ab79863769dfebe12cac117be1034bf41a0f2fec46a3dc4b90856e49669'),('sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/modules/withdraw/lib/commerce_marketplace_funds_withdraw.method.controller.inc','e0b32d90c01eee98cf9f444c2be1b1c5ab25f7ae678c0887920d9de0931e70d3'),('sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/modules/withdraw/lib/commerce_marketplace_funds_withdraw.method.entity.inc','586721c7c38bfe5d2977ef6b3fa40ee9e7214ba62a2090518b5390bb0603787a'),('sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/modules/withdraw/lib/commerce_marketplace_funds_withdraw.method.metadata.inc','118180d5bcc93d694ee9849e12cc92582b53d01dde13adca16d136e7dccd4ef2'),('sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/modules/withdraw/lib/commerce_marketplace_funds_withdraw.method_type.controller.inc','f7f6ecdb0a44bb9120c91b5ae01f905a981e66520abfa54c495a5fcd846c642e'),('sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/modules/withdraw/lib/commerce_marketplace_funds_withdraw.method_type.entity.inc','91ce8ed120300e8ce920cc62126077c27e44e209e8d22c472c5f55d509d31b88'),('sites/all/modules/commerce_marketplace/modules/commerce_store_access/plugins/selection/EntityReference_SelectionHandler_Commerce_Store.class.php','4ec87ff1f89b90405fd715333975fb6ad89e5c5845128fe0a337d91bf022c50c'),('sites/all/modules/commerce_search_api/includes/callback_product_status.inc','fdecbf2671945b8df595040ff0ec6bbb4dc07fbeba16ac461b0c61587198af87'),('sites/all/modules/commerce_search_api/includes/commerce_search_api_product_display_filter.inc','94006e0cefafdbc65041d3848af1dd9b5e5cdf900482f7919e59fd21e9834b51'),('sites/all/modules/commerce_search_api/includes/facetapi/filter_same_search.inc','f05b8ac916f6b3d98f54213c976b5b2403e03684d07ad4c1a0cbc72d032b1e55'),('sites/all/modules/commerce_search_api/includes/facetapi/filter_search_start.inc','14e37a4c7aabae66d8e9078386e8de2e9fef5a52492c93a96894a435be18012e'),('sites/all/modules/commerce_search_api/includes/facetapi/widget_fancy_attributes.inc','014d2eebcdba7257d5054c231e08331b601926e65ff4c58405557462a839b095'),('sites/all/modules/commerce_shipping/includes/views/handlers/commerce_shipping_handler_relationship_shipping_line_item_representative.inc','6e0b4f444e3405293fef80d3288009eec79c2a913b1e6f74de992d4113eaa1fa'),('sites/all/modules/context/context_ui/export_ui/context_export_ui.class.php','ee6ee0bb2d30fade0e982d1db437a802e654ac438b15362fa7d33770d9f11f60'),('sites/all/modules/context/context_ui/tests/context_ui.test','7350a5984e3d4799621809f5d9134cf117411c9049b49f78b4d35293591f3dd5'),('sites/all/modules/context/plugins/context_condition.inc','2701acb0f8667cf922052a9265bb84c936a3b716afaf3a8eff2ad04e332b5a2f'),('sites/all/modules/context/plugins/context_condition_context.inc','cc3630470442db0c92d2def23cc03eeb9de30fb1c00dd2e00660646e292a705c'),('sites/all/modules/context/plugins/context_condition_context_all.inc','80b00ab0cd49aa4cfe4493a2cd08dde594d73ba3f3563d34c15ae2b46fc5983e'),('sites/all/modules/context/plugins/context_condition_default.inc','5764948ea3f0c7b55e14b0cd3690ab279f2237eb45043fac102a82b5d392c4a2'),('sites/all/modules/context/plugins/context_condition_language.inc','edbd457b68a4dd1e213792dce89d89ae17127d21ec3aa7e64eb6e636f11b2034'),('sites/all/modules/context/plugins/context_condition_menu.inc','6f3c05bc11b8e9e4257add5045ff00f7aa554624e47424affe00170f7bd8a8c8'),('sites/all/modules/context/plugins/context_condition_node.inc','8d54a13f2ed57cd1a36d1dbcba62e32f256ed6e71554643599fca50a3dddbbd0'),('sites/all/modules/context/plugins/context_condition_node_taxonomy.inc','f7f766547b3e1767ff69adfd25f756cc519a1e845e134f945c1e40865e5bf243'),('sites/all/modules/context/plugins/context_condition_path.inc','c9ad2e426c75c8ba6bc4c94181aadadf3f474272cd0dc0bc67bd7c6cd810fea7'),('sites/all/modules/context/plugins/context_condition_query_string.inc','3902793c371098e42e0d3336fb8a0c26a0f18685ac03c6ac9a04f755a8ebd0cc'),('sites/all/modules/context/plugins/context_condition_sitewide.inc','cb5061fe6757287744f3db7296380120089c4e56af3298395aeaa3da16aedc3b'),('sites/all/modules/context/plugins/context_condition_taxonomy_term.inc','94eb955d5705e75936cc440417893e341905fa7fb3df3b6d3e7d838fa33e313c'),('sites/all/modules/context/plugins/context_condition_user.inc','a6fd04ce6574d5391427a038da1f158f47b062cde7655811fa5a41271e75d20c'),('sites/all/modules/context/plugins/context_condition_user_page.inc','c5c48146a183e6d2cdfa07222e7f614bd9ba3ff4b745131c9910aeb79bbf4bcd'),('sites/all/modules/context/plugins/context_condition_views.inc','5cd3e84b22977af2d1a72ecc9dffb9b1beb1ac42f2ad2741de5a015a45734473'),('sites/all/modules/context/plugins/context_reaction.inc','497ce814344a5789eebd05e77f9a84625d20f8bf38cf77bf794ac85fdd1c1c0a'),('sites/all/modules/context/plugins/context_reaction_block.inc','e387623a2916d3ecd34eb455a8b62d621edd2f84ba6a2a925bdd835338120fbb'),('sites/all/modules/context/plugins/context_reaction_breadcrumb.inc','2231768e9595ef916c50c41bbe32d2b5a7812bfc50d359da85c8fa31cc883bec'),('sites/all/modules/context/plugins/context_reaction_debug.inc','c57b92ccf0b1278dce108089989eb32fb532e786f9bc01d2cb694819b468f322'),('sites/all/modules/context/plugins/context_reaction_menu.inc','eb9d92f4a0549728a3110ca13ed70de4cb67d02ad321b9c13fbde4bf58c53911'),('sites/all/modules/context/plugins/context_reaction_region.inc','fc61c32bcdd8da4db6441424a4b5af8c7ccfd388386b0a0f3e497fe694006241'),('sites/all/modules/context/plugins/context_reaction_template_suggestions.inc','a56462376d34c9304297425695c29aecad3d8fd9e98f82b111153c1335803f8d'),('sites/all/modules/context/plugins/context_reaction_theme.inc','eae05dc2e34947aacc18bdfb4925df9a7946d64d9b23e7cde92ee23610cadffd'),('sites/all/modules/context/plugins/context_reaction_theme_html.inc','b0b4f355aebce29dbaa3e2bf26c35443d134f73649f1e197170e73d5ab93e0a2'),('sites/all/modules/context/tests/context.conditions.test','28e69f66bb56433c584474beb75e83a87b74bc5927baf646a8cea7c26b8b47b9'),('sites/all/modules/context/tests/context.reactions.test','4d1d8d1497fc32e685446e52e387e537a6ec183ed598d224e356ad1461676efa'),('sites/all/modules/context/tests/context.test','05e97800946a534d2a4f3f017f6ac3ee682c7ef8a430cef5bb769574701d9419'),('sites/all/modules/countries/countries.migrate.inc','e3f771150e30e4ed2036fe6f9220f7cba778329689a3a20299cb7ac8f35f7372'),('sites/all/modules/countries/tests/countries.test','f3cc28f8c2f6682bf7ab8eea1a6fd0838b5722161f9fb062458feb5c589cb135'),('sites/all/modules/countries/views/views_handler_argument_countries_country.inc','a0c03b35ae2dccc8377e4c3614892ac4ed20c55fa7cfcd18a3015d116a377ecc'),('sites/all/modules/countries/views/views_handler_field_countries_continent.inc','7f3bd40b6f34a7b596eae46fa7a9e659b9d3890aa041d5907b7373e68953b6a2'),('sites/all/modules/countries/views/views_handler_filter_countries_continents_list.inc','476ce117d28bfddece1fd8464f76cd19d1c61cd660976ae92bc2b76672b593f8'),('sites/all/modules/countries/views/views_handler_filter_countries_list.inc','b17e7c4d5eb7cad5cf548dde7108e2b764a8454c133fe1236f95e16b0e1ad4fd'),('sites/all/modules/ctools/includes/context.inc','4cec11a71872eb916c4315c9f727a184d46758aa64bb950d86877a60b9007157'),('sites/all/modules/ctools/includes/css-cache.inc','db90ff67669d9fa445e91074ac67fb97cdb191a19e68d42744f0fd4158649cfa'),('sites/all/modules/ctools/includes/math-expr.inc','601db581743dd22d67f7aaf228bd8d26298d72033fc675d02385a1fd6d31888f'),('sites/all/modules/ctools/includes/stylizer.inc','3f91f5ed42fb6ee1b65ddef7ac22577b07a5d75ca1eb2df60041243ced5c7079'),('sites/all/modules/ctools/plugins/export_ui/ctools_export_ui.class.php','2fd87a7d80689e4d44673b31c07b762144eb8ac57324fd0b9cd9ede5f4ea34b5'),('sites/all/modules/ctools/tests/css_cache.test','0dbc038efedb1fa06d2617b7c72b3a45d6ee5b5b791dcb1134876f174a2a7733'),('sites/all/modules/custom_breadcrumbs/custom_breadcrumbs.admin.inc','2dfcdeb791af87788759628257e7a4fd7371687c7c500a37dca87a6d1495d974'),('sites/all/modules/custom_breadcrumbs/custom_breadcrumbs.install','c3912f2bd2d3a1bf42795548377b9574476e92f37ebbc16b9a98a7c9d929cc25'),('sites/all/modules/custom_breadcrumbs/custom_breadcrumbs.module','5021699bea0e3d06fd06fd2efa1172f30931c281d5bf5ee3b80cffaa440f6d30'),('sites/all/modules/custom_breadcrumbs/custom_breadcrumbs_common.inc','f85a5072788d160cd4b0986f6e384b064b4d8be1c1137191eb9e77a9a1f58b81'),('sites/all/modules/custom_breadcrumbs/custom_breadcrumbs_identifiers/custom_breadcrumbs_identifiers.module','decadffd6d3f6c17b611be68eb0c644515d7855ffed20d83c9892fddc7d2a9c7'),('sites/all/modules/custom_breadcrumbs/custom_breadcrumbs_paths/custom_breadcrumbs_paths.install','7a7b71c3c00d43cc91693ac77d7a22d82580bc5ffed9f812b68dcfd12b097662'),('sites/all/modules/custom_breadcrumbs/custom_breadcrumbs_paths/custom_breadcrumbs_paths.module','3cc446b1992142ed2484fd283a04bd1c442d6d841b8af0654fda3de9f40556d6'),('sites/all/modules/custom_breadcrumbs/custom_breadcrumbs_taxonomy/custom_breadcrumbs_taxonomy.admin.inc','b74bcd37a6af875e72cc6429014857a22bb96509b9db272acc901a0432c8536b'),('sites/all/modules/custom_breadcrumbs/custom_breadcrumbs_taxonomy/custom_breadcrumbs_taxonomy.inc','629822c86e21c75d785b30a4cdceb8764d0fa4169aad229203cb09911f7de047'),('sites/all/modules/custom_breadcrumbs/custom_breadcrumbs_taxonomy/custom_breadcrumbs_taxonomy.install','692455edca73eaca1dafc55e9dc6f8083428469a72f045bc06a0e3e71415f672'),('sites/all/modules/custom_breadcrumbs/custom_breadcrumbs_taxonomy/custom_breadcrumbs_taxonomy.module','3f1fb5279b92243e0cf06de6d9cccc8d9042f02eaacb62fb163fb969d76b7dcf'),('sites/all/modules/custom_breadcrumbs/custom_breadcrumbs_views/custom_breadcrumbs_views.install','983b01cfa1901ce8ab6c348987c050abd15ec6a760857214d0781c65ba19046c'),('sites/all/modules/custom_breadcrumbs/custom_breadcrumbs_views/custom_breadcrumbs_views.module','31e3ec28a50cf0a0a85b89734443733dea88b6220bd10cb71678e983f94a388b'),('sites/all/modules/devel/devel.mail.inc','49da9730e719dd57db1eb0c416874a5bc0b5a0af50d06f0e3e3832514b653e15'),('sites/all/modules/devel/devel.test','6d18fc4c80d6c92d827f967baa36a11a0efc82b02bb79c1ebb53da515322f084'),('sites/all/modules/eck/includes/eck.inline_entity_form.inc','583803912c459b0a9304d3b674188377c9495b0ca931984e332d75b24f6e747a'),('sites/all/modules/eck/views/handlers/eck_views_handler_field_link.inc','39eab956a6428b31be35656f45afe7e1700ddbd36a7c7ae90a6102c4f7c26495'),('sites/all/modules/eck/views/handlers/eck_views_handler_field_link_delete.inc','384d146cd9f2db1b34b71e14474d4adf0d9e60d0a3628e638632573bb8d9e049'),('sites/all/modules/eck/views/handlers/eck_views_handler_field_link_edit.inc','6a4db2c030fbdd1f01448c06bff109119cf6a4c7b0bb34bfa41a21233663ec9b'),('sites/all/modules/entity/entity.features.inc','47261e1f4f39ac3707a16fdea8a8147c09df1281bcb4b9e46b0c8120603137e8'),('sites/all/modules/entity/entity.i18n.inc','41e0e62af7e2774f62b162d597bb3244551c280296b692b29d039a2c243d7059'),('sites/all/modules/entity/entity.info.inc','8799080b9393c9560e64feae1276fb7d26fef4d92bb0edacc863ee3e7b67bf04'),('sites/all/modules/entity/entity.rules.inc','774199059d1b3ebe6d3fe7a49dbb1550df489055a3d066b5de54edda8dd7ba84'),('sites/all/modules/entity/entity.test','df253128e41f152b45ef30b5674009c51cf4112450e5dad8e815f39ced280db5'),('sites/all/modules/entity/entity_token.module','0c1ad6fb6f8c430e47a81be6d08180883c5a1ee728ce8b5dd0775713b34fb862'),('sites/all/modules/entity/entity_token.tokens.inc','084edf8f860f3c9843e23cc2e06a9084dcb644ee6d99c21cdd7bd924138d518f'),('sites/all/modules/entity/includes/entity.controller.inc','342db185e6170b63c59a9b360a196eb322edb9a5b8c7819f66b0eae48ed13ebd'),('sites/all/modules/entity/includes/entity.inc','57411fa3d7b5cd2afe8b84f20c1741f48c32673a9da07bd2c35d4a11c50c640e'),('sites/all/modules/entity/includes/entity.ui.inc','65739b31af0e6b422919c17805799dc99143fd89cacfb56b9186e26ece2d0df2'),('sites/all/modules/entity/includes/entity.wrapper.inc','0db08cbb6b730035e3e9a483e6e5c06a744a73f19e4ca83936446b44f0c3d158'),('sites/all/modules/entity/views/entity.views.inc','de657f42389ed6832df787e4b618d8d7117b60d145d34ce5dcf3a5b65db29df9'),('sites/all/modules/entity/views/handlers/entity_views_field_handler_helper.inc','4ec395881109a71327ab8d7c5b5702bef30288ca66557e44e8539cc15a2135bb'),('sites/all/modules/entity/views/handlers/entity_views_handler_area_entity.inc','7b7bb88e53861739b7279f705f0492fc83ce95f5b20d89339480f546422ebf25'),('sites/all/modules/entity/views/handlers/entity_views_handler_field_boolean.inc','b28b8eee8761ba7a6af35d97ab7aaee28406e6c227271f9769818560626c5791'),('sites/all/modules/entity/views/handlers/entity_views_handler_field_date.inc','b0f5be5b399de94934b24e84c8cf6053a043f6b00c60dcffa752daeafdd38778'),('sites/all/modules/entity/views/handlers/entity_views_handler_field_duration.inc','ed7bb64cb63b94a20c8cde98cfb053b5ea252804396cf61ac562faf1d850266b'),('sites/all/modules/entity/views/handlers/entity_views_handler_field_entity.inc','4f255918a22fefebe9c7734f200751457a7ca4d3648e32a98511bb51968d7521'),('sites/all/modules/entity/views/handlers/entity_views_handler_field_field.inc','893121efbce2a7181e31147bade260c9cc657cbd33b0d254cb28b2650e57566d'),('sites/all/modules/entity/views/handlers/entity_views_handler_field_numeric.inc','f14e2b063930e8820af381b4f5e83c7278440e7804ab88cfde865b6c94e7c0f6'),('sites/all/modules/entity/views/handlers/entity_views_handler_field_options.inc','27ef31b8ee7b9999930380d6a5fdb477772329c4ddbd5c70cc34bcdc7543ce56'),('sites/all/modules/entity/views/handlers/entity_views_handler_field_text.inc','5fb0a85d35d29944c699ceaf6efed5eda2df757009e44caba8ff2be397568b60'),('sites/all/modules/entity/views/handlers/entity_views_handler_field_uri.inc','79ecaa3eb17dfdd0ca077351b75a2c0adf411ebc04720e7cc0e2397674225f24'),('sites/all/modules/entity/views/handlers/entity_views_handler_relationship.inc','b69bc538d1e1e0f91f8485ca54c3b6e2be025caa47619734c467377cf89041b9'),('sites/all/modules/entity/views/handlers/entity_views_handler_relationship_by_bundle.inc','65300c793c4591d60ad908dc02cf3148fe4e899fa6ad218e875fd92d411374dc'),('sites/all/modules/entity/views/plugins/entity_views_plugin_row_entity_view.inc','ba557790215f2658146424d933e0d17787a0b15180c5815f23428448ccf056a0'),('sites/all/modules/entityreference/entityreference.migrate.inc','617c6c49e6e0fa4d106cfb49b61a6994b5520934ac3b64a8400a9d969eab7c59'),('sites/all/modules/entityreference/plugins/behavior/abstract.inc','a7959ddece2ce3490f92d916162e07aed313e28ca299ca0375bad633b42d93e3'),('sites/all/modules/entityreference/plugins/behavior/EntityReferenceBehavior_TaxonomyIndex.class.php','92fa0cf46ecdf6200659646e6666c562ea506c40efa41a8edd4758dc0c551b92'),('sites/all/modules/entityreference/plugins/behavior/EntityReferenceBehavior_ViewsFilterSelect.class.php','f6805f62bbd376d98676706602aeb1c4d16e645acb429d31032bc3fb37d850d3'),('sites/all/modules/entityreference/plugins/selection/abstract.inc','7ecf94f5dc3456e4a5c87117d19deb98c368617fb07d610505b1dfa351f14a0b'),('sites/all/modules/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','e9a8a3c693ed24218d00c10c445cdb21daed10a26e6b55e5c9d6a8c616cfd871'),('sites/all/modules/entityreference/plugins/selection/EntityReference_SelectionHandler_Views.class.php','b1878655779d07b8210ab81c3dd9aae931250f328b044114045a4780a84a0ed7'),('sites/all/modules/entityreference/plugins/selection/views.inc','7bbe8900b6b71c2d41e370deaccca869884d0fe9ca81772d7d5bca5f58ec1cd8'),('sites/all/modules/entityreference/tests/entityreference.admin.test','bcd6516be3099ae87a4c3d41add08edd17eafb4244db8442c5dc15f19ebde7ae'),('sites/all/modules/entityreference/tests/entityreference.feeds.test','320c7480b1758e4d80e91c0a6ea3d43b6b35d1adfe00b6155b61ef786510bb7c'),('sites/all/modules/entityreference/tests/entityreference.handlers.test','2fa170925ac5303c519378f1763e918cc2f111205220d90998b547a08db90d8c'),('sites/all/modules/entityreference/tests/entityreference.taxonomy.test','8e4f7d9ae621df0f587b6fcbf139adea2a35c69305ef018ced88447a41164c5f'),('sites/all/modules/entityreference/views/entityreference_plugin_display.inc','9216a065ea4fdb2daacb1280e5c9549e3400b8553b5293534cf65a0d703ab189'),('sites/all/modules/entityreference/views/entityreference_plugin_row_fields.inc','7f5a58c099c2df6fd1c3ae285197a4648841d44fa107bcb2064bc1edf435ea8b'),('sites/all/modules/entityreference/views/entityreference_plugin_style.inc','ad9a7ea5a37c2d9658c2b1d19ade3011c27ed5d9959423ebf7a390372507e6b0'),('sites/all/modules/exclude_node_title/exclude_node_title.admin.inc','17336fde56eca0021cd93b9cdd7a0e27059d5cb27e6d5f9d0a09704c84710719'),('sites/all/modules/exclude_node_title/exclude_node_title.info','bda33eeb9630085aac53467850671c740ec8717427aeb36df431ea72513aab0c'),('sites/all/modules/exclude_node_title/exclude_node_title.module','1ce6d7d038fb4c0e02222c34e5b2555c7653c4a5301c874521b3c79f174a11d1'),('sites/all/modules/facetapi/contrib/current_search/plugins/current_search/item.inc','0d378e4914899ae89d2217153d9c03451253ccefbbafd4350888f43383a4238f'),('sites/all/modules/facetapi/contrib/current_search/plugins/current_search/item_active.inc','4ce5714cc1d6d5e025ab8941da87d578e258d652d891ab3d35ba5352f5041727'),('sites/all/modules/facetapi/contrib/current_search/plugins/current_search/item_group.inc','732e45b7dab0c1ce16e8c5bd77be6fe2fd2cfb0a461f9dd1bfa0397606dc0abb'),('sites/all/modules/facetapi/contrib/current_search/plugins/current_search/item_text.inc','f76400b54404b155ee620cf14d1de142040c794e8b349127f73e77deeece66d4'),('sites/all/modules/facetapi/contrib/current_search/plugins/export_ui/current_search_export_ui.class.php','60fed09bc36f857b89781c2acde3c4988a53180cf1051b6fbbf8b49e11591d15'),('sites/all/modules/facetapi/contrib/current_search/tests/current_search.test','a3ce7c8f48329e7e42cd61cfbc42c7b44ecfca25283085e540a03263fe216daa'),('sites/all/modules/facetapi/plugins/facetapi/adapter.inc','3d6721eaf55c8038b9091bd156849ebdf0217e6ddd0711df9f12ec2e23650741'),('sites/all/modules/facetapi/plugins/facetapi/dependency.inc','81154314a88d75e6fc6dcc92eafca7724f16a54d6cdcda0daef619e004b971d3'),('sites/all/modules/facetapi/plugins/facetapi/dependency_bundle.inc','3bedb18ff855cc5398a61dd9208389124e4a47c7f7e0ff65018b24b13c3dfd02'),('sites/all/modules/facetapi/plugins/facetapi/dependency_role.inc','7a47b57d47a8787760b8ab56d168ca91b6831521d7389f2e7c166c099a68701c'),('sites/all/modules/facetapi/plugins/facetapi/empty_behavior.inc','57910048dc778148391488afeed3d6207557b9e9f50b6b4abd3729fad0f173bc'),('sites/all/modules/facetapi/plugins/facetapi/empty_behavior_text.inc','cde7359e18718cca997f07a9a76b98854f8afece8375afa39e4a849c72e6d848'),('sites/all/modules/facetapi/plugins/facetapi/filter.inc','9b27d5d2c854be0f34e6447af2136e5324ba25b4e5dadaeca7cdc5670b37c15e'),('sites/all/modules/facetapi/plugins/facetapi/query_type.inc','a4907dcbfd98ab9aaff874848c983333cbd0d3c4579ddc01c8fc571ce8914053'),('sites/all/modules/facetapi/plugins/facetapi/url_processor.inc','11df874f65ba7718f9820d13bfaa995422e80053390aa2d1d211d9731649929c'),('sites/all/modules/facetapi/plugins/facetapi/url_processor_standard.inc','ab91c765b7d19f0cc3ff16ae1316fce1e4da53ac15da562b092a4f55d9a91e26'),('sites/all/modules/facetapi/plugins/facetapi/widget.inc','36f64aa7a52eaa94f3e2966713ccd7155906ad65c6aaf8c33c95a2a34352c3a1'),('sites/all/modules/facetapi/plugins/facetapi/widget_links.inc','cb7562f3f04f6c973c48d96af4287eef51db58c4b20cd3e0926130ed2d96a253'),('sites/all/modules/facetapi/tests/facetapi.test','0fc24a7b3fc8e73e423706a44288893ee4abf2c9388350da0834b0a9c28cb72e'),('sites/all/modules/facetapi/tests/facetapi_test.plugins.inc','9e20990742e15a532c1b483396c6e3ca3a917dcda944a0f030ca7f4813182e10'),('sites/all/modules/features/tests/features.test','5fc1c5733eb4c76c32f1a79736c064f1f89001f7987eb7bf183c8d438c8f8baf'),('sites/all/modules/field_collection/field_collection.info.inc','e11b810756dabe6eb24b70a3a84390480a2de7c5d65ea5a1f0d6045802f8405e'),('sites/all/modules/field_collection/field_collection.migrate.inc','2a24762712659caf3d93429d973763e6f0ae4c36d42841893a501f070629aafb'),('sites/all/modules/field_collection/field_collection.test','9d30f2ab55492a10e7d381e5af1985160b798fcc57c14b5516e6d4c7cd997dc8'),('sites/all/modules/field_collection/views/field_collection_handler_relationship.inc','6e8c13805c1ff233410bb408d524786df4ca64fc10ee4bd874a16277243efba1'),('sites/all/modules/field_group/tests/field_group.display.test','68b48634e0311fb4a804d39d8c03acc3de868719df0f4cca495c81e9de4e2035'),('sites/all/modules/field_group/tests/field_group.ui.test','17486a055b85febf5cc55cdb638bf104ef3acab75b76735763650217dd5ab9d4'),('sites/all/modules/field_slideshow/field_slideshow.module','659d5f7908ca6530df427b4074b1020c2b7b189b0e23d5844ef69242f5afeb3a'),('sites/all/modules/fivestar/test/fivestar.base.test','673858a7652d27ab2ba950e4448716c667187cd33186a51f02e200aad5528af2'),('sites/all/modules/fivestar/test/fivestar.field.test','0c15a08ee59b4a74d86491c10c3924adbad0f391fc4e81715f7ff79f3115e4ff'),('sites/all/modules/flexslider/flexslider.test','377205ce1adf7f8235881d5e3a9e465fc9157e1d1dd2cc83da924da82b93086a'),('sites/all/modules/flexslider/theme/flexslider.theme.inc','d8045c74c4d3e7daa9b0864e14a571d6aa36883f5ba80e065078b80cfb807a95'),('sites/all/modules/icon/icon.install','3abd29f18d20c4fc3ea68d5e8548444012bbaed23fea2275558028e1ba0a69f9'),('sites/all/modules/icon/icon.module','8173bbe63ea07f832fed446762cc733a2f7dcae55c0b3a28cc33457fb7fe7248'),('sites/all/modules/inline_entity_form/includes/commerce_line_item.inline_entity_form.inc','a53470b7433c702c57e60e88affd22789e81ad1ca06a4bf431abba762d778c92'),('sites/all/modules/inline_entity_form/includes/commerce_product.inline_entity_form.inc','3a7563cad090c2663acf7b59487e077e4d1cf655648d719f67764892d72ef7f1'),('sites/all/modules/inline_entity_form/includes/entity.inline_entity_form.inc','3ab59ca2e9a051fe0dc60d03400574f2f3d82ac925f530e92acaa46be62f9c1d'),('sites/all/modules/inline_entity_form/includes/node.inline_entity_form.inc','ba4a82ca3d31c88830dd41a7c482b136732e5afeabe0cea9aa90e612e080804c'),('sites/all/modules/inline_entity_form/includes/taxonomy_term.inline_entity_form.inc','232b818cbbdc4cd2231c4e1d4334137ff047e9a5a49273a8fee14e52010c71c7'),('sites/all/modules/jcarousel/includes/jcarousel.views.inc','690f67684bd4f7dfa0e2e9573fa2db6cb0ea932ad7eebbbcac3868fd721bfe05'),('sites/all/modules/jcarousel/includes/jcarousel_style_plugin.inc','07c54b3d8b4d0dfc8c02e102d36f30089e673010a3e4dd88cbb24814ab66f18d'),('sites/all/modules/jcarousel/jcarousel.module','2fc24478d406def8c9b14be739f446a344bda59a9bfaad6f8990a713ce59c1af'),('sites/all/modules/jquery_update/jquery_update.install','d377a4e1df5c9606b4d603fbf14296f6d4df921bb3e188341a0c602651498388'),('sites/all/modules/jquery_update/jquery_update.module','5550809cea16a9f09ebcd6e70fc36a19a2aa3fd6180039d2e2382b86d659a8c3'),('sites/all/modules/libraries/tests/libraries.test','b566140ed33211b04cda3d8773b5bc25f8986065463864a0703fa89979daa817'),('sites/all/modules/link/link.migrate.inc','0a17ff0daa79813174fff92e9db787e75e710fe757b6924eec193c66fe13f3df'),('sites/all/modules/link/link.module','3fdf23f9f409b80df5eee57207a5045c566422cef14128306835f7b1b03a5e66'),('sites/all/modules/link/tests/link.attribute.test','8c21045dbcf346edf8dc70c157d02074dd87372d4f60e7f5a4ae11683cd79399'),('sites/all/modules/link/tests/link.crud.test','de19e2c5e8c6cb02f25d7051bdd1db77852379ac59ce8185c25b4bf927478f22'),('sites/all/modules/link/tests/link.crud_browser.test','07794771164033e14a635625ad08fdbcdc4dafa154db2ec0bd9a95ca30202eb5'),('sites/all/modules/link/tests/link.test','fe5d8cd577fbfc07929e7216e115530a28777ace9b7135fbc853a3a78d550456'),('sites/all/modules/link/tests/link.token.test','930af3b64ccabd58a14c8f596ee4b908596b4bee64174bfa34d55fbab7173da4'),('sites/all/modules/link/tests/link.validate.test','4fb3d9124767f43332f2e40bcca3aba98575dd1f6a286adfc8831607823986c5'),('sites/all/modules/link/views/link_views_handler_argument_target.inc','d77c23c6b085382c63e7dbce3d95afc9756517edcdc4cd455892d8333520d4c9'),('sites/all/modules/link/views/link_views_handler_filter_protocol.inc','e10a0d2de73bfa9a56fadbac023c6ac16022ced40c0444ab6ffed1b5d7ea7358'),('sites/all/modules/menu_token/menu_token.test','9776d35918617c6db188535d4fe7cd6c11d74c4a205ec94e57b8f82783982b5a'),('sites/all/modules/menu_token/plugins/menu_token_entity_context.inc','7e290b9af0a2cc4728ec3b84507ddc21efcc70de39604204e8d1928d7fb92294'),('sites/all/modules/menu_token/plugins/menu_token_entity_random.inc','49aa3d777f3c6ec6c4017856ce3d09869a1068197c7b4d5807afaadb611f3288'),('sites/all/modules/menu_token/plugins/menu_token_entity_user_defined.inc','e0e29128fb89e40697a62af3734359f40a990198ea9584fc38de7a7777d58668'),('sites/all/modules/module_filter/css/module_filter.css','2813d8a7a9cca73ac2e7a5e3979d6e913f78cc36dbfe5e21c412eeb9a8fe97fc'),('sites/all/modules/module_filter/css/module_filter_tab.css','4e505f0aa9e9ba6306f0c1fe900ec5efcdd6de983748e4eee9491ebb03d85c63'),('sites/all/modules/module_filter/js/module_filter.js','4bb9003d81e4ad063abb22e6820fd35072bb1bcb6a340c7d8034bbc6c5e81b95'),('sites/all/modules/module_filter/js/module_filter_tab.js','bb0ce3b3bddc0255175b2e3d0700206b1c10b645c7382d22ff7b897fedc9e750'),('sites/all/modules/module_filter/module_filter.admin.inc','15784b28ac9e77ba6e299b1a60b5d3176dc6fa3ecaba50dc60a1e0c56f925192'),('sites/all/modules/module_filter/module_filter.install','46a1159d2f88bb2db41a8c4c1378c6385d02d0aa689cc2940ecd4924d508c9f5'),('sites/all/modules/module_filter/module_filter.module','31d1273dbf8896a75abaf22a851b20f3653defacac9432ef5d430dc520998560'),('sites/all/modules/module_filter/module_filter.theme.inc','2f052942faf0585ee84dc90cf88152450a7a0cc09b958dd59526970d363ffe3a'),('sites/all/modules/pathauto/pathauto.test','9204240a755119e02eae68c77e7b9ab816747423ccaaf51742231fbaef1f604f'),('sites/all/modules/recently_read/includes/recently_read.views.inc','b18cd74399b70d73e5026428988d66d3cc86f5fa9edb4f9c3b18d49d9a08c2bf'),('sites/all/modules/recently_read/includes/recently_read_handler_filter_current.inc','af923cada4559fee7aa24053acc9d18980d94bb40f3c7a1d6eb3498fe61087a2'),('sites/all/modules/recently_read/includes/recently_read_handler_filter_entity_type.inc','db89eca2a8ecf319d8ab73b6dcb392f668b982a661786a04012b399f876ec3c4'),('sites/all/modules/rules/includes/faces.inc','72352c57a12e740b80e235ee5fe245b91c5bca9938f4751670acc8e719626bcb'),('sites/all/modules/rules/includes/rules.core.inc','e7d13cae20c6610a6236b1cedd891efdaf97490e1924e3c26c73994ca421d199'),('sites/all/modules/rules/includes/rules.event.inc','286bb8005acf30a6f4fdb23ff75843f70a82a99ac3e225c31290aad10e2a50ae'),('sites/all/modules/rules/includes/rules.plugins.inc','d760fa99514c4acdc6e7abf6d820a979615304ed677eb291955356115dcbe44c'),('sites/all/modules/rules/includes/rules.processor.inc','902d554987e019cfe9c8818a83a96db7e02c556efb4c63961ee9d091ee98c988'),('sites/all/modules/rules/includes/rules.state.inc','26cb9d0792e6313e0582816527eef3e1310a07c5e3065b2b26e3408dca500bf0'),('sites/all/modules/rules/modules/node.eval.inc','7873fe5eaa00b0f6b189bb6e4d43efe63d587009e05ae502c15076c63b931a6c'),('sites/all/modules/rules/modules/php.eval.inc','4d579f9d83912a1ff4e3e35b20a7792fb7e282d8d07c706e944ffbb6b20c42f6'),('sites/all/modules/rules/modules/rules_core.eval.inc','edf268c4e9a24d700ef08ca5cf8addc93a437d30cb0129aeb7aa93e76f8f855e'),('sites/all/modules/rules/modules/system.eval.inc','1076decc24a4779c7a582b446b9147d65ddd03cec530ee62809c86e49c62f736'),('sites/all/modules/rules/rules.features.inc','dc219fc6df253743cfe775503edffd6ba8b76fe9d8b549294242b0691cad0302'),('sites/all/modules/rules/rules_admin/rules_admin.inc','5bcd9e3059d4ee4dbcec6dd959bbc518a8c2d0dcadd506cd1c5c31aab2cda463'),('sites/all/modules/rules/rules_admin/rules_admin.module','38cd2e74c2d951d4a4d6025191cf4aa87be9ece9b2bf5b248ce0bfdfc62aa9cb'),('sites/all/modules/rules/tests/rules.test','61d6f9cfb2ff09eb595639a31dbd651de0606288d7b85d29089f564bc91ca516'),('sites/all/modules/rules/ui/ui.controller.inc','c0d16bd7340a766225865d942dcdad23aead4275e3f18b326e23f42f2313f30b'),('sites/all/modules/rules/ui/ui.core.inc','ba58ed06bf4c3471c5958c2072315e016ab563a74291b89666b868214b8b0725'),('sites/all/modules/rules/ui/ui.data.inc','4646714b3c18f527193308316313944a410f95c3cc849c8605d6dcf63ef035c1'),('sites/all/modules/rules/ui/ui.plugins.inc','d290f1ab6933f0a9189c5197c471d422d04d315b137079863ef746ed4ef673c4'),('sites/all/modules/search_api/contrib/search_api_facetapi/plugins/facetapi/adapter.inc','70f326a0620d826d8e27eaeba77f5e7134cb988525708fcd5ab663b4923066e7'),('sites/all/modules/search_api/contrib/search_api_facetapi/plugins/facetapi/query_type_date.inc','e91d1317bcef14b7a4ab7f80902cbda2c525ba7dfb9166cbd54adb4fdc733647'),('sites/all/modules/search_api/contrib/search_api_facetapi/plugins/facetapi/query_type_term.inc','fdf300c9bd520ae8c73de81f2ac029861089167597ddba9d5019a3997151d1e2'),('sites/all/modules/search_api/contrib/search_api_views/includes/display_facet_block.inc','906d48d08c20215d8dafa6e0c24f7e36f9e97bf15c1d39fcc597cb948dea828a'),('sites/all/modules/search_api/contrib/search_api_views/includes/handler_argument.inc','1d77154b07b8dbdbd5156eadfa66f47dde177dac7a93974ae340dba9249fce60'),('sites/all/modules/search_api/contrib/search_api_views/includes/handler_argument_date.inc','4ec2d15d6bfdc6159ad46fa280deae2b4ecaf63980675d69659bc6381b5d5f51'),('sites/all/modules/search_api/contrib/search_api_views/includes/handler_argument_fulltext.inc','c00399b8a5fc3fa0a017b8d5fa3d373daab8be062d07842f2c41e0f5afbce881'),('sites/all/modules/search_api/contrib/search_api_views/includes/handler_argument_more_like_this.inc','992c8917143a0578d9bc4200640a8409c66aebcabe97d23b8e2486831e656774'),('sites/all/modules/search_api/contrib/search_api_views/includes/handler_argument_string.inc','68ad2702458c1133ec263d4eab77a953c096ff0e40451e8f04a2ab10dc48f495'),('sites/all/modules/search_api/contrib/search_api_views/includes/handler_argument_taxonomy_term.inc','563527f281b96e7b2c4feb986def8f8215cedbbf7a3b2927db01c55fef4a7632'),('sites/all/modules/search_api/contrib/search_api_views/includes/handler_filter.inc','256d97d69e2f69238b2f7ce9a3679216ccb3a6d524e4672f114d3a00c908cf67'),('sites/all/modules/search_api/contrib/search_api_views/includes/handler_filter_boolean.inc','11af85669c26e90797cc15a634400c611b62ea597be46143338d2e10aaa4440c'),('sites/all/modules/search_api/contrib/search_api_views/includes/handler_filter_date.inc','d49de5d26d4cc9ecd670178f80785edff898b836440fd63fb114a8fab587c0f6'),('sites/all/modules/search_api/contrib/search_api_views/includes/handler_filter_entity.inc','82c8d4b09be9c5bb31bf0dcd846146868102635f4ba546f3274d5a67f097bf22'),('sites/all/modules/search_api/contrib/search_api_views/includes/handler_filter_fulltext.inc','9fc4b8843b7195b2f3839286401adcb701b41e4653588199d664e11c6d1cbc36'),('sites/all/modules/search_api/contrib/search_api_views/includes/handler_filter_language.inc','4c851c882c9af931e618ff1d0aa14814a78aabc81fd9fb306f22e4d049ea99a7'),('sites/all/modules/search_api/contrib/search_api_views/includes/handler_filter_options.inc','d4b5950d9f3300f4031df049aee95454ed06fc3748718ea8411db12b171aa7df'),('sites/all/modules/search_api/contrib/search_api_views/includes/handler_filter_taxonomy_term.inc','469695c5d5fa24eb2da0d5c3b7b40452478f4bca7b94fe171682a2bfd72f7ec4'),('sites/all/modules/search_api/contrib/search_api_views/includes/handler_filter_text.inc','c6d809573fafd0f7916b9a97b9bb45627fb188864b11202079de059413ea60b2'),('sites/all/modules/search_api/contrib/search_api_views/includes/handler_filter_user.inc','0d552445449bff309a7083c75b6cf6c1a43c05449095b034cd30a5f4eafe4d7f'),('sites/all/modules/search_api/contrib/search_api_views/includes/handler_sort.inc','2046233f698eb1b8f9f938179fc19c6cda9b5a55833454c8f989f268f963c491'),('sites/all/modules/search_api/contrib/search_api_views/includes/plugin_cache.inc','e267e41ab58f67eca6fa90ba6eb851c2c9fef4f76a11476db2f40d8d1a8fe2e2'),('sites/all/modules/search_api/contrib/search_api_views/includes/query.inc','1d157b08b4e81d1ccdb95895dcc334c52c896b7a6738b09c9172a2a6c9eafa1b'),('sites/all/modules/search_api/includes/callback.inc','58607e8dcb692a7c8463beadd2a09f5002316af2e959d56a505d26e43df36be3'),('sites/all/modules/search_api/includes/callback_add_aggregation.inc','a500c39f3265d5264999a00499b8f04eca7f4a07565e9b2e7857b438147a3f0a'),('sites/all/modules/search_api/includes/callback_add_hierarchy.inc','619eea2c13652b00046ad3db30c911064a22a026ce032bde3ab20da67d7207e5'),('sites/all/modules/search_api/includes/callback_add_url.inc','66080f835b71b1d294a931d4f003d0a438e4f08d22f7174cc5d9c716fc4e497a'),('sites/all/modules/search_api/includes/callback_add_viewed_entity.inc','e534e6fedd7b1c3188220aff139c2e0852593d6b44a54c520744fc5dd226fc0e'),('sites/all/modules/search_api/includes/callback_bundle_filter.inc','100cfd70474e96a911abbffa5fc30f693966b0f21f5054493bd136b3cbc5dcaf'),('sites/all/modules/search_api/includes/callback_comment_access.inc','1f488864cb696fb5543c3045184dc09c62c5422541b3bc420cb3dc077fdb1a00'),('sites/all/modules/search_api/includes/callback_language_control.inc','ad391daecbf5f7762840af59bee964be8eb5d958bc3a1c9de82e7f84a651d511'),('sites/all/modules/search_api/includes/callback_node_access.inc','a9e0e6b64ed66cc2d949614f1aea06b132e5e2c6aa108c1e83833a57ae482e96'),('sites/all/modules/search_api/includes/callback_node_status.inc','9626bd5d17f5de72151f6fe9b3c4b74f0d462ba0c7d15a8d5d780722127f76c2'),('sites/all/modules/search_api/includes/callback_role_filter.inc','76165fcd0a15b4b7dd72940e4e79b8ec2772c26eb835d0ebae57bd9ba59abc81'),('sites/all/modules/search_api/includes/callback_user_status.inc','8a2e3356fc898c2c5302e0cd0ac8e54044856ccb15dc857c84b47e20d7dca56e'),('sites/all/modules/search_api/includes/datasource.inc','62b60ed73c37b12062776f8289d238e5c9a514ddfee76d8b2a179736601a0c0a'),('sites/all/modules/search_api/includes/datasource_entity.inc','ba11e4a73125c70690ef22e9a5dd8064383a92d9d8a53f7b0e73cf1325aef639'),('sites/all/modules/search_api/includes/datasource_external.inc','711f01f1a06c73eb22ce26ffb16faa3f6ba376e22a314eb7e0c1ff2e8600ce5a'),('sites/all/modules/search_api/includes/datasource_multiple.inc','af004659506d3d6db7dc07b51731048e5b3a46ca19291558196429f10b79594d'),('sites/all/modules/search_api/includes/exception.inc','7bd8e58bb99e2f7d3cf9e7363982d95bc3312a04d8ac5040e49c442573398838'),('sites/all/modules/search_api/includes/index_entity.inc','a3a1e84ba76d35c9dfe9152e21e061ca4008ad9d3a03bb05396446fd57d6ff38'),('sites/all/modules/search_api/includes/processor.inc','c89c69f4053c3fb5cc66ab342afb0657b8c44a14c32eac28bda5d0424b6b7465'),('sites/all/modules/search_api/includes/processor_highlight.inc','0b49ea2d8a340198ab48088d0034eb0a1647c0f02d3934b1ab8260fd7e731070'),('sites/all/modules/search_api/includes/processor_html_filter.inc','43c80246a16ea0fcea36337cc211d1a382d8381f439526b2949eaeda67e2bab4'),('sites/all/modules/search_api/includes/processor_ignore_case.inc','945c8562fc4ee860a7467310995adeda20a84807cb1a896a2c356a4f42c5a8b0'),('sites/all/modules/search_api/includes/processor_stemmer.inc','35cbe9c8d30a661cdb14a43c79daed5e20786976256698ef442692964018cffd'),('sites/all/modules/search_api/includes/processor_stopwords.inc','a67f7b830d1bad82dd7208a0be896db4b8554c942210d5b3ca73eec2874c64c5'),('sites/all/modules/search_api/includes/processor_tokenizer.inc','c6cc4460ad2b5229cc3bb937884cdfc82537fda56a50d596dee7c7d4111a18bb'),('sites/all/modules/search_api/includes/processor_transliteration.inc','8f4092031b1fc9d660d97242b82c362bcf0d077458fa9195eba3289fa556cee1'),('sites/all/modules/search_api/includes/query.inc','8070033cb27c17acabffba376d23468daea485b9efa9cd4592dbdcd278832726'),('sites/all/modules/search_api/includes/server_entity.inc','e8558b19499efe5f92e6616d39c6032ffb57cd919726927e65a97e3d60da6417'),('sites/all/modules/search_api/includes/service.inc','8eab59601f99536844191b1107c8695192b868dcab6da522a00bb34d04dcc65e'),('sites/all/modules/search_api/search_api.test','5cae26bc8557b0396117e88fe0bb6609b3fd1a4c9a6faadb9ad7602780a8db41'),('sites/all/modules/search_api_db/search_api_db.test','e627a8dc649dfa58ae61585b402e3b8eb99a4a9560389906fc54eded360f6808'),('sites/all/modules/search_api_db/service.inc','e39a1cb8a55280369e0fdbabed57961a577968a4e0c406256240754870ad0119'),('sites/all/modules/search_api_ranges/includes/callback_search_api_ranges.inc','9190cd7c4bcedf27a77123d73d65211da29aa3578c86bed1bda5aa7f4d078147'),('sites/all/modules/search_api_ranges/plugins/facetapi/widget_links.inc','f4402bcff8e0a01884717bdbba54208f72fdab886db4288f0a8bde8660354ac2'),('sites/all/modules/search_api_ranges/plugins/facetapi/widget_select.inc','2afe2ad3e546a09b19cd56c5787eb050e23432e4b7908a165de4eb30ac5e3a2a'),('sites/all/modules/search_api_ranges/plugins/facetapi/widget_slider.inc','0454d1abfbc18634a15f95472d78df50b898ee1d2bc8f164f7767ca087c9cb75'),('sites/all/modules/search_api_sorts/search_api_sorts.entity.inc','35fb4ceee3646fadb3c78ea9611d3eeb57acb36481922c48cb6e3bf48b0b4abd'),('sites/all/modules/search_api_sorts/search_api_sorts.test','6de62d7f449e61e43461c943a13da7243f88a73fd3ec13cb8cd7f9467b636d7b'),('sites/all/modules/select_or_other/tests/select_or_other_number.test','e6d939d177b746a364b0e4bfc1fb17a0a2511ae0df026102b6a41be525cb2df4'),('sites/all/modules/select_or_other/tests/select_or_other_text.test','4ecc7b7df42fdb5ee5157bcfc4a7cca118414d22ecf5b0297ccd3825fb5c4827'),('sites/all/modules/session_api/session_api.admin.inc','d54e8b2cc7e07acd2ade58a56046c046053e76b53de793f69acda4b737fcfc09'),('sites/all/modules/session_api/session_api.install','95cceed55bee0101a98a60b43243ad9bd0b2672b2948fe5e6775855392708dda'),('sites/all/modules/session_api/session_api.module','b961ae45eb6422c7436ac2c0fbbe9016855bbb343ad60b6a611602152c201514'),('sites/all/modules/session_api/session_api.test','7d3e993652bb465cb3ff3a7c71746d43f98f21282aefce3f2f35fe862ddc8d11'),('sites/all/modules/simplenews/includes/simplenews.source.inc','3affac6085f0577baeb11e398f20fd2757ff1eaaf78a64b4dea532bc270c85ea'),('sites/all/modules/simplenews/includes/views/handlers/simplenews_handler_field_category_hyperlinks.inc','e2de96b32926704be822451228646de12086858dc79b785a13eccef2cd4c227e'),('sites/all/modules/simplenews/includes/views/handlers/simplenews_handler_field_category_new_account.inc','303a46a2615d5b403d2b5195dcf7368590dccfb8aefeb0cb4def7f5744c12b02'),('sites/all/modules/simplenews/includes/views/handlers/simplenews_handler_field_category_opt_inout.inc','bd630326309a757ec4c84c551a94af75a45b260695ac1e78470e5deae5aedff7'),('sites/all/modules/simplenews/includes/views/handlers/simplenews_handler_field_newsletter_priority.inc','5c2e3aca9eec1066a9d8753f0fecbf5240dccc78c43feabc71ae38d41c8b7444'),('sites/all/modules/simplenews/includes/views/handlers/simplenews_handler_field_newsletter_send.inc','5a197d8f083151c3fdf295a826bab995309bc2a7e81add3427177978ee1a9124'),('sites/all/modules/simplenews/includes/views/handlers/simplenews_handler_field_newsletter_status.inc','50ee35017d09d35a6a95ade6ef6962b44065ae50a50937cd988792a6d238fbea'),('sites/all/modules/simplenews/includes/views/handlers/simplenews_handler_filter_category_hyperlinks.inc','ca03538f8aaa4d4aeb144f1ca7981d96bae6e7877911761d89da3e1890167e75'),('sites/all/modules/simplenews/includes/views/handlers/simplenews_handler_filter_category_new_account.inc','3ec702aba8edee78bd88082edb409e650cc529c6bbf261acdc2696985676f4f8'),('sites/all/modules/simplenews/includes/views/handlers/simplenews_handler_filter_category_opt_inout.inc','4022d7c90e8f136fc4123360bf63d9780d0c4c007ed2dfb5f6bb92d62a23221b'),('sites/all/modules/simplenews/includes/views/handlers/simplenews_handler_filter_newsletter_priority.inc','c2fad9628acb69a2aae20a54446bbee81e57c5ea98bc7a164769111e72fce5f4'),('sites/all/modules/simplenews/includes/views/handlers/simplenews_handler_filter_newsletter_status.inc','1060bed3a6b5af84214adab7e2158ee36951d2f2d109ee5829ce836380cdc3a0'),('sites/all/modules/simplenews/tests/simplenews.test','6c3df929bde1bafd77ce0af559d741c6d1534cdca2606813334568d7ddce7087'),('sites/all/modules/taxonomy_menu/taxonomy_menu.batch.inc','e7cf6aa0476da11b29910a108faca5d636e4582340d789ebe9049f3e1f944a5d'),('sites/all/modules/taxonomy_menu/taxonomy_menu.database.inc','ecb8a8713bcb2ec2aec7062137e2bc51dc819bb695da608b03be7be5472902c2'),('sites/all/modules/taxonomy_menu/taxonomy_menu.install','b1b3b627fbc2c55f2dc004d62f2192c51884b4f2667cce63b37da53bb1c9c781'),('sites/all/modules/taxonomy_menu/taxonomy_menu.module','0ee1bc326987ffa350b04287e8e9a20821ad8d8ad2129bdb147a9392c7599705'),('sites/all/modules/taxonomy_menu/taxonomy_menu.test','3a99877ef3d1fb93e110e268ea52771054425ce075e3ad11511ab93bd5728fb6'),('sites/all/modules/title/tests/title.test','d8d4884c1f6269a3d3c4a413efe7eb356b6595583e424f85ecb161516da62125'),('sites/all/modules/title/title.module','ad172436fe4a35461650f63cdb1a250e77d658f47df3a964a95f0967e9f6c09c'),('sites/all/modules/title/views/views_handler_title_field.inc','0d3887f86cac0993973710229695f755694e334928355b7fd0b0f98a096be3c6'),('sites/all/modules/token/token.test','79c44cc6bb46caa41eaf371df9c77d7ef98bbee7d96c04ca1039375dc6674961'),('sites/all/modules/views/handlers/views_handler_area.inc','95d4374c805c057c9855304ded14ce316cdee8aca0744120a74400e2a8173fae'),('sites/all/modules/views/handlers/views_handler_area_messages.inc','de94f83a65b47d55bbb4949fcf93dd4ad628a4a105cea2b47cdc22593f3e5925'),('sites/all/modules/views/handlers/views_handler_area_result.inc','f406d7e4409545ffea2e56c9a10f87f20adef2276c6d6bbc8003885cccc8ca3b'),('sites/all/modules/views/handlers/views_handler_area_text.inc','531d0ac3b64206970593762df0abac60524f607253c3af876dd66ba747786dce'),('sites/all/modules/views/handlers/views_handler_area_text_custom.inc','35b702060c192b0adf6601ed437d0a02effd3accb71c07d6156013c8be9d5a15'),('sites/all/modules/views/handlers/views_handler_area_view.inc','e604b5716d9ea202ab0b8e51d2bd0a4a8eeab461db0a74bf37745d6cbba25c41'),('sites/all/modules/views/handlers/views_handler_argument.inc','1f0498d1878e331f59b9f0cc87b67df330437c736e565a05fe1a14ab65ec3f26'),('sites/all/modules/views/handlers/views_handler_argument_date.inc','1b423d5a437bbd8ed97d0bfb69c635d36f15114699a7bc0056568cc87937477d'),('sites/all/modules/views/handlers/views_handler_argument_formula.inc','5a29748494a7e1c37606224de0c3cac45566efe057e4748b6676a898ac224a61'),('sites/all/modules/views/handlers/views_handler_argument_group_by_numeric.inc','b8d29f27592448b63f15138510128203d726590daef56cf153a09407c90ec481'),('sites/all/modules/views/handlers/views_handler_argument_many_to_one.inc','b2de259c2d00fe7ed04eb5d45eb5107ce60535dd0275823883cc29b04d1a3974'),('sites/all/modules/views/handlers/views_handler_argument_null.inc','26699660fd0915ec078d7eb35a93ef39fd53e3a2a4841c0ac5dbf0bb02207bee'),('sites/all/modules/views/handlers/views_handler_argument_numeric.inc','ae23d847fa0f1e92baec32665a8894e26660999e338bebffb49ee42daac5a063'),('sites/all/modules/views/handlers/views_handler_argument_string.inc','f8fe4daf0a636cc93d520a0d5ff212840d8bdaa704ddc3c59a24667f341ed3a1'),('sites/all/modules/views/handlers/views_handler_field.inc','3d059d737e738436a15651f9ac8374f460a71eb569619ba0a8a14a55a3efc87e'),('sites/all/modules/views/handlers/views_handler_field_boolean.inc','dc00b916a223935e05f51d94a2dffbaf430b162517072f7c2122332af41e8fc2'),('sites/all/modules/views/handlers/views_handler_field_contextual_links.inc','2f54701c9f71a4a525e724a6787b5e0089a3c38e426d1925bf8344d017d571bf'),('sites/all/modules/views/handlers/views_handler_field_counter.inc','865a5ad7df830dae9e167709446e66cebf3e32e91ec05b5c2b887c96d0d6b0d8'),('sites/all/modules/views/handlers/views_handler_field_ctools_dropdown.inc','a78c424ef884ae9878c0b140d532bdf3b116fdc0e8a7cd519848c675d5b1a5a6'),('sites/all/modules/views/handlers/views_handler_field_custom.inc','a3d25fc20401ae0a1af4b7d6e83376a5b7dc18ab0aed17a3c6d81e2314cf19f8'),('sites/all/modules/views/handlers/views_handler_field_date.inc','79cb6583981104d70d20393fe62281c749680f375cb67355635ef00688258934'),('sites/all/modules/views/handlers/views_handler_field_entity.inc','909ab36aff896ad8fa4306d95a052172ec27e471ab385a035fcadef8d019e0f9'),('sites/all/modules/views/handlers/views_handler_field_links.inc','331a7c8e68a9a94a41a0d7e3e2b6a5c8436792cf244b409ffd732f9cbbab3642'),('sites/all/modules/views/handlers/views_handler_field_machine_name.inc','df2fe47cf9c6d2e7de8627c08da809fb60883c38697340966f303c223e22aee4'),('sites/all/modules/views/handlers/views_handler_field_markup.inc','a0c652fdf47f7efe35bbf2371f00e230409fe90ea0038eb101bf0c93ae0718e9'),('sites/all/modules/views/handlers/views_handler_field_math.inc','08c9fb88b20ca346ee3dc29773b2341ea294ba85b659dbd8c1cc92a9ddf900e8'),('sites/all/modules/views/handlers/views_handler_field_numeric.inc','1e36f9d55b4cfeb268068e5c9bd6f326999c04191485d3db4610e94e6f57fad9'),('sites/all/modules/views/handlers/views_handler_field_prerender_list.inc','0fe605bf457886fbca5f041a422fc51c6a1927654dcd06cbfc619496fe57de0e'),('sites/all/modules/views/handlers/views_handler_field_serialized.inc','ad3d82a9f37ae4c71a875526c353839da2ff529351efc7861f8b7c9d4b5a47db'),('sites/all/modules/views/handlers/views_handler_field_time_interval.inc','280d569784312d19dabfb7aeb94639442ae37e16cba02659a8251de08a4f1de2'),('sites/all/modules/views/handlers/views_handler_field_url.inc','7ca57a8dcc42a3d1e7e7ec5defa64a689cb678073e15153ff6a7cafe54c90249'),('sites/all/modules/views/handlers/views_handler_filter.inc','4c8937c5b6399c42bb6659169f5c8563ca415fd7effab1ddeeebf2bb6b9a8011'),('sites/all/modules/views/handlers/views_handler_filter_boolean_operator.inc','f4ca59e4e1f91f219a1b33690a4ad412269946804fe7cacf24f2574b2c6d8599'),('sites/all/modules/views/handlers/views_handler_filter_boolean_operator_string.inc','0ddd32cda535112c187de1c062797849ff90d9b312a8659056e76d2d209f694a'),('sites/all/modules/views/handlers/views_handler_filter_combine.inc','802f033bba6a9965896b02e3c3e0ea4493e4be282f2c5444ebbeec7e8a478072'),('sites/all/modules/views/handlers/views_handler_filter_date.inc','fb63877ecfa64f2be8557a21dcf34e28b59c4a9c5f561f55738162d2301c4aa1'),('sites/all/modules/views/handlers/views_handler_filter_entity_bundle.inc','02db977a67a09f70bdc8e2bbc46a05fff8a6d8bd6423308c95418476e84714a3'),('sites/all/modules/views/handlers/views_handler_filter_equality.inc','2100cdd7f5232348adae494c5122ba41ff051eee0a8cc14aeaf6a66202cb7ed1'),('sites/all/modules/views/handlers/views_handler_filter_fields_compare.inc','e116c3796f1bd409b150f5ab896b9bab956d6e71a82e5770ed6fde44605751b2'),('sites/all/modules/views/handlers/views_handler_filter_group_by_numeric.inc','9401c4c0fe0d678898e5288ef8152784a12e0743df21dec15457353eb2cdb01d'),('sites/all/modules/views/handlers/views_handler_filter_in_operator.inc','8fd7f075468bddde5c4208b1c3a6105f8fea0ac0c214452a37c00fc2f3453a7d'),('sites/all/modules/views/handlers/views_handler_filter_many_to_one.inc','b4a415c2824195d3d7d0e37ada9d69ebec0b9cd833ebcac2439efc20aac15595'),('sites/all/modules/views/handlers/views_handler_filter_numeric.inc','8a999227d17674a70381ab8b45fbdc91269a83a45e5f7514607ed8b4a5bf6a9f'),('sites/all/modules/views/handlers/views_handler_filter_string.inc','140006335ac5b19b6253b431afde624db70385b9d22390b8c275296ae469cc7b'),('sites/all/modules/views/handlers/views_handler_relationship.inc','4fefdb6c9c48b72dcfe86484123b97eb5f5b90b6a440d8026d71f74dccbd1cd6'),('sites/all/modules/views/handlers/views_handler_relationship_groupwise_max.inc','47dcfe351159b10153697c17b3a92607edb34a258ba3b44087c947b9cc88e86f'),('sites/all/modules/views/handlers/views_handler_sort.inc','06aab8d75f3dce81eb032128b8f755bfff752dcefc2e5d494b137bca161fdefa'),('sites/all/modules/views/handlers/views_handler_sort_date.inc','d7e771abf74585bd09cc8e666747a093f40848b451de8ba67c8158317946f1b2'),('sites/all/modules/views/handlers/views_handler_sort_group_by_numeric.inc','4ba1c38c9af32789a951b8f9377e13631ae26bf1dac3371b31a37ead25b32eb8'),('sites/all/modules/views/handlers/views_handler_sort_menu_hierarchy.inc','ccd65ea3b3270366b7175e2cd7cc9167a09c27e1486949e4a05495ff5c7be5c1'),('sites/all/modules/views/handlers/views_handler_sort_random.inc','05a00c3bf76c3278ae0ce39a206a6224089faf5ac4a00dd5b8a558f06fab8e46'),('sites/all/modules/views/includes/base.inc','5ad8155dbc31cc4460b65747d99b70a64a83f6fefa00231c8d965293a7a183ee'),('sites/all/modules/views/includes/handlers.inc','5cab753c012d357ce2a10b645eca4254b3647fdfe2452510eee37c8a12639a14'),('sites/all/modules/views/includes/plugins.inc','11c03b1c69be7e9969ec0665b07ddfe170c9505f8d4e862cb27f1232a2a4240e'),('sites/all/modules/views/includes/view.inc','99e60c217d6dc781ec48ae8fc841e636eee31d977936e1980a34eca28734ad2e'),('sites/all/modules/views/modules/aggregator/views_handler_argument_aggregator_category_cid.inc','97acf41d6694fd4451909c18b118f482db9f39aa4b8c5cfa75d044d410c46012'),('sites/all/modules/views/modules/aggregator/views_handler_argument_aggregator_fid.inc','c37def91d635b01db36809141d147d263cc910895e11c05e73d703e86b39fd43'),('sites/all/modules/views/modules/aggregator/views_handler_argument_aggregator_iid.inc','344f2806344d9c6356f2e19d297522f53bab7a4cebdf23c76d04c85c9e0a0d8e'),('sites/all/modules/views/modules/aggregator/views_handler_field_aggregator_category.inc','252b30b832d8c0097d6878f5d56beecfc8cc1fc7cc8b5a4670d8d95a80b4f17d'),('sites/all/modules/views/modules/aggregator/views_handler_field_aggregator_title_link.inc','1bb18967b11f2f4de62075d27e483f175b5e3431622c2e5e8292afcd000beadf'),('sites/all/modules/views/modules/aggregator/views_handler_field_aggregator_xss.inc','2db2e1f0500e0a252c7367e6a92906870b3247f9d424f999c381368ee2c76597'),('sites/all/modules/views/modules/aggregator/views_handler_filter_aggregator_category_cid.inc','7c7c0690c836ac1b75bca3433aca587b79aec3e7d072ce97dc9b33a35780ad4f'),('sites/all/modules/views/modules/aggregator/views_plugin_row_aggregator_rss.inc','591e5bb7272e389fe5fc2b563f8887dbc3674811ffbb41333d36a7a9a1859e56'),('sites/all/modules/views/modules/book/views_plugin_argument_default_book_root.inc','bd3bd9496bf519b1688cf39396f3afa495a29c8190a3e173c0740f4d20606a53'),('sites/all/modules/views/modules/comment/views_handler_argument_comment_user_uid.inc','5e29f7523010a074bda7c619b24c5d31e0c060cdbe47136b8b16b2f198ed4b4a'),('sites/all/modules/views/modules/comment/views_handler_field_comment.inc','a126d690cc5bf8491cb4bee4cc8237b90e86768bebbbecb8a9409a3c1e00fa9e'),('sites/all/modules/views/modules/comment/views_handler_field_comment_depth.inc','1dc353a31d3c71c67d0b3e6854d9e767e421010fbbf6a8b04a14035e5f7c097f'),('sites/all/modules/views/modules/comment/views_handler_field_comment_link.inc','1f7382f7cb05c65a7cba44e4cd58022bbc6ce5597b96228d1891d7720510bf0e'),('sites/all/modules/views/modules/comment/views_handler_field_comment_link_approve.inc','f6db8a0b4dd9fffba9d8ecb7b7363ba99d3b2dc7176436a0a6dd7a93195a5789'),('sites/all/modules/views/modules/comment/views_handler_field_comment_link_delete.inc','905a4cb1f91a4b40ee1ca1d1ded9958ae18e82286589fec100adb676769b1fe9'),('sites/all/modules/views/modules/comment/views_handler_field_comment_link_edit.inc','8139c932cde20f366a3019111c054b1ed00dbc0c40634b91239b400243b7723a'),('sites/all/modules/views/modules/comment/views_handler_field_comment_link_reply.inc','8807884efb840407696c909b9d5d07f60bde9d7f385a59eca214178ce5369558'),('sites/all/modules/views/modules/comment/views_handler_field_comment_node_link.inc','64746ff2b80a5f8e83b996a325c3d5c8393934c331510b93d5815ea11c1db162'),('sites/all/modules/views/modules/comment/views_handler_field_comment_username.inc','1ce3fa61b3933a3e15466760e4c5d4a85407ba4c8753422b766fc04395fa4d02'),('sites/all/modules/views/modules/comment/views_handler_field_last_comment_timestamp.inc','30c55ec6d55bf4928b757f2a236aab56d34a8e6955944a1471e9d7b7aed057c0'),('sites/all/modules/views/modules/comment/views_handler_field_ncs_last_comment_name.inc','82025f3ad22b63abc57172d358b3f975006109802f4a5ecac93ce3785c505cae'),('sites/all/modules/views/modules/comment/views_handler_field_ncs_last_updated.inc','facfbc5defd843f4dfb60e645f09a784234d87876628c8de98d2dfa6bb98a895'),('sites/all/modules/views/modules/comment/views_handler_field_node_comment.inc','0cf9e8fb416dca35c3b9df3125eb3a8585f798c6a8f8d0e1034b1fccb5cec38b'),('sites/all/modules/views/modules/comment/views_handler_field_node_new_comments.inc','e0830d1f70dea473e46ab2b86e380ef741b2907f033777889f812f46989f2ff7'),('sites/all/modules/views/modules/comment/views_handler_filter_comment_user_uid.inc','f526c2c4153b28d7b144054828261ba7b26566169350477cd4fb3f5b5f280719'),('sites/all/modules/views/modules/comment/views_handler_filter_ncs_last_updated.inc','9369675dfee24891fe19bddf85a847c275b8127949c55112ae5cb4d422977d24'),('sites/all/modules/views/modules/comment/views_handler_filter_node_comment.inc','70706c47bad9180c2426005da6c178ed8d27b75b28cb797ca2a1925a96dcef09'),('sites/all/modules/views/modules/comment/views_handler_sort_comment_thread.inc','a64bc780cba372bd408f08a5ea9289cdf3d40562bdf2f7320657be9a9f6c7882'),('sites/all/modules/views/modules/comment/views_handler_sort_ncs_last_comment_name.inc','9f039e8b8a046c058fda620804e3503be7b3e7e3e4119f0b015ccbae0922635b'),('sites/all/modules/views/modules/comment/views_handler_sort_ncs_last_updated.inc','fa8b9c3614ad5838aa40194940d9dc6935175a16e141ac919f40e74a7428c4e3'),('sites/all/modules/views/modules/comment/views_plugin_row_comment_rss.inc','96f651234e30a3aff805ae9a524c99813a286bf75b5a9fd8da2d7d4fbec50810'),('sites/all/modules/views/modules/comment/views_plugin_row_comment_view.inc','82d7296fa3109ca170f66f6f3b5e1209af98a9519bb5e4a2c42d9fc0e95d7078'),('sites/all/modules/views/modules/contact/views_handler_field_contact_link.inc','ec783b215a06c89c0933107a580c144051118305dd0129ac28a7fea5f95a8fd5'),('sites/all/modules/views/modules/field/views_handler_argument_field_list.inc','eff5152a2c120425a2a75fe7dbcb49ed86e5d48392b0f45b49c2e7abee9fa72b'),('sites/all/modules/views/modules/field/views_handler_argument_field_list_string.inc','534af91d92da7a622580ab8b262f9ef76241671a5185f30ba81898806c7b7f15'),('sites/all/modules/views/modules/field/views_handler_field_field.inc','94ff7382dba773fc637c777e20b810ae7d4aa4936fb0bc067e6a3824ba929d2d'),('sites/all/modules/views/modules/field/views_handler_filter_field_list.inc','3b55cd0a14453c95ebd534507ab842a8505496d0b7e4c7fcd61c186034c7322d'),('sites/all/modules/views/modules/field/views_handler_filter_field_list_boolean.inc','d33035e141ca686b3f18da1e97adaa1ff8e5d1db266340d3030e873a744685e2'),('sites/all/modules/views/modules/field/views_handler_relationship_entity_reverse.inc','060035c5430c81671e4541bcf7de833c8a1eb3fa3f3a9db94dd3cebfa4299ef1'),('sites/all/modules/views/modules/filter/views_handler_field_filter_format_name.inc','fc3f074ffb39822182783a8d5cf2b89ffcc097ccbb2ed15818a72a99e3a18468'),('sites/all/modules/views/modules/locale/views_handler_argument_locale_group.inc','c8545411096da40f48eef8ec59391f4729c884079482e3e5b3cdd5578a1f9ad7'),('sites/all/modules/views/modules/locale/views_handler_argument_locale_language.inc','a1b6505bb26e4b3abce543b9097cd0a7b8cddf00bf1e49fbba86febebb0f4486'),('sites/all/modules/views/modules/locale/views_handler_field_locale_group.inc','5b62afe18f92ee4a5fb49eb0995e65b4744bbe3b9c24ffe8f6c21f3191c04afc'),('sites/all/modules/views/modules/locale/views_handler_field_locale_language.inc','0cc08bd2d42e07f26e7acc92642b36f0ac62bf23ee9ba3fd21e6cab9a80e9f72'),('sites/all/modules/views/modules/locale/views_handler_field_locale_link_edit.inc','3883d3f37030d6d8e397e79ccb99ec3cb715ba7a789510f4b79b7515e314e7ae'),('sites/all/modules/views/modules/locale/views_handler_field_node_language.inc','a6ccdb6c1c4df3b4fd31b714f5aa4ac99771ffce63439d6c5de6c0ae2f09a2c1'),('sites/all/modules/views/modules/locale/views_handler_filter_locale_group.inc','40fbc041bab64f336f59d1e0593f184b879b2a0c9e2a6050709bdc54cceb2716'),('sites/all/modules/views/modules/locale/views_handler_filter_locale_language.inc','3433893d988aad36b918dd6214f5258b701506bc9c0c6a72fd854a036b635e20'),('sites/all/modules/views/modules/locale/views_handler_filter_locale_version.inc','9337ea5216784ffc67a0aa45c946e65ad11fc40849189cc70911a81366b78620'),('sites/all/modules/views/modules/locale/views_handler_filter_node_language.inc','d7edea3f35891cc76aa3bb185b9c1404378623ea7fd214c2a1f0d824df12779a'),('sites/all/modules/views/modules/locale/views_handler_sort_node_language.inc','b7b70efcf7de1f4dee4722ac8aa16031f17d62e60b1b5772f9985cadf91e4415'),('sites/all/modules/views/modules/node/views_handler_argument_dates_various.inc','80ee0e32fd48de1fa9d91645f27f7f26e8700acd3b1120a6d414bb1a794f6d0e'),('sites/all/modules/views/modules/node/views_handler_argument_node_language.inc','7ee3ba02bddaa6aeef9961cdf6af7bb386fc2b12529f095b28520bb98af51775'),('sites/all/modules/views/modules/node/views_handler_argument_node_nid.inc','11c5b62413ffd1b2c66d4b60a2fe21cf6eb839ae40d4ef81c7a938c5be3e30de'),('sites/all/modules/views/modules/node/views_handler_argument_node_type.inc','9e21b4cc4ae861f58c804ea7e2c17fbc5dd2a7938b9abfeb54437b531fc95e6e'),('sites/all/modules/views/modules/node/views_handler_argument_node_uid_revision.inc','675c99f8da9748ac507e202f546914bee3ed4065f6ce83a23a2aaafdaefd084e'),('sites/all/modules/views/modules/node/views_handler_argument_node_vid.inc','7e5da5594a336c1d0f4cf080ab3fcd690e0de1ee6b5e1830b5fb76a46bced19c'),('sites/all/modules/views/modules/node/views_handler_field_history_user_timestamp.inc','7d6d9c8273d317ab908d4873a32086dbd5f78a2b2d07b7ed79975841a2cadea6'),('sites/all/modules/views/modules/node/views_handler_field_node.inc','99a0ef52b68e8913eb3563d5c47097c09e46c6493fcb006f383c6f6798edb7fc'),('sites/all/modules/views/modules/node/views_handler_field_node_link.inc','26d8309a3a9140682d7d90e4d16ff664a3d7ce662af6ccbf75dc4c493515d7d9'),('sites/all/modules/views/modules/node/views_handler_field_node_link_delete.inc','3eeed8c9ffc088ee28b8ffaa5e2b084db24284acc4d1b2e69f90c96cc889016d'),('sites/all/modules/views/modules/node/views_handler_field_node_link_edit.inc','28f8c3b7d3d60c31fec3cdf81c84cfbb20f492220457694a0e150c3ddee030c0'),('sites/all/modules/views/modules/node/views_handler_field_node_path.inc','f392fde21e434fd40fc672546ef684780179d91827350ba9c348bb1cc5924727'),('sites/all/modules/views/modules/node/views_handler_field_node_revision.inc','3f510d58acaa8f844292b86c388cb1e78eac8c732bb5e7c9e92439c425710240'),('sites/all/modules/views/modules/node/views_handler_field_node_revision_link.inc','ace72f296cf4a4da4b7dd7b303532aebf93b6b1c18a5d30b51b65738475e3889'),('sites/all/modules/views/modules/node/views_handler_field_node_revision_link_delete.inc','0a36602f080c4ef2bb5cb7dbddc5533deab7743c2fbf3bd88b9e478432cac7fb'),('sites/all/modules/views/modules/node/views_handler_field_node_revision_link_revert.inc','80ddc7f0c001fde9af491bb22d6044b85324fe90bea611fc3822408fd60008fa'),('sites/all/modules/views/modules/node/views_handler_field_node_type.inc','f8f39c6f238f837270d1b2e42e67bf9ab400a37fe24246c8b86dfcfacc1c4fd9'),('sites/all/modules/views/modules/node/views_handler_field_node_version_count.inc','1298f7f7ee4b6e6e2957b266fbb7c63e102b9d7e9ccca8d5a86592736bce9493'),('sites/all/modules/views/modules/node/views_handler_filter_history_user_timestamp.inc','2970f270e071cad079880e9598d9f7b71d4dd2a2a42a31cd4489029a3cafe158'),('sites/all/modules/views/modules/node/views_handler_filter_node_access.inc','ca625167c8928f1c5b354c27c120ed9b19c1df665dc3b02ed6d96b58194d6243'),('sites/all/modules/views/modules/node/views_handler_filter_node_status.inc','f7099a59d3f237f2870ecb6b0b5e49dd9d785b1085e94baf55687251e7f3231b'),('sites/all/modules/views/modules/node/views_handler_filter_node_type.inc','6842082e7b6e131d6e002e627e6b4490b93ca6ffe7fc0b158d31843217c8c929'),('sites/all/modules/views/modules/node/views_handler_filter_node_uid_revision.inc','2cfe9ba95e5ea8c240a57cfa1bed58385cbfed0c7f35e3d8c4da6d873b5a61fa'),('sites/all/modules/views/modules/node/views_handler_filter_node_version_count.inc','de61f3547604e5905486cdae5f5e94d1a45bdac4d3c43157193dd6fe0dd6473c'),('sites/all/modules/views/modules/node/views_handler_sort_node_version_count.inc','ce2a392319ebed3dbb2b660f3d6f4c6690b1cd46cf6b1c01802f12158114c4c4'),('sites/all/modules/views/modules/node/views_plugin_argument_default_node.inc','7fb79c8f4adb9bcef7c7da4bf4046fe3490e16c244f6ab96fdca97a8567315ff'),('sites/all/modules/views/modules/node/views_plugin_argument_validate_node.inc','f10d3f4081eed5ca32c41b67e9a0e6f35b2f8ba2cd7897230cb5a680b410a6de'),('sites/all/modules/views/modules/node/views_plugin_row_node_rss.inc','1e55454684102fad08c947695c370a890a22ea22c3c9aca3207f2299aa3daf7e'),('sites/all/modules/views/modules/node/views_plugin_row_node_view.inc','6b7dfe1a3b16eae682b2664a48bb6af16f040b4ca2c8e71f8b771a0577a66bae'),('sites/all/modules/views/modules/profile/views_handler_field_profile_date.inc','e206509ef8b592e602e005f6e3fa5ba8ef7222bdb5bacd0aaeea898c4001e9b0'),('sites/all/modules/views/modules/profile/views_handler_field_profile_list.inc','da5fa527ab4bb6a1ff44cc2f9cec91cf3b094670f9e6e3884e1fedce714afe6f'),('sites/all/modules/views/modules/profile/views_handler_filter_profile_selection.inc','758dea53760a1b655986c33d21345ac396ad41d10ddf39dd16bc7d8c68e72da7'),('sites/all/modules/views/modules/search/views_handler_argument_search.inc','9de18defd5d9320b6333dc496627657be1dd8ccb145dfc136a80f1bcee6e1f55'),('sites/all/modules/views/modules/search/views_handler_field_search_score.inc','711af637c864b775672d9f6203fc2da0902ed17404181d1117b400012aac366f'),('sites/all/modules/views/modules/search/views_handler_filter_search.inc','aa2ae23905b84b77ee6042f8f26542eedd7422bdd7518255a289db7da0f6400b'),('sites/all/modules/views/modules/search/views_handler_sort_search_score.inc','9d23dd6c464d486266749106caec1d10cec2da1cc3ae5f907f39056c46badbdf'),('sites/all/modules/views/modules/search/views_plugin_row_search_view.inc','bc25864154d4df0a58bc1ac1148581c76df36267a1d18f8caee2e3e1233c8286'),('sites/all/modules/views/modules/statistics/views_handler_field_accesslog_path.inc','7843e5f4b35f4322d673b5646e840c274f7d747f2c60c4d4e9c47e282e6db37d'),('sites/all/modules/views/modules/statistics/views_handler_field_node_counter_timestamp.inc','a1de51345d268dc0f080104ff9ae4c9ca1f7a2dd45560a59630b2bb03bdc54c9'),('sites/all/modules/views/modules/statistics/views_handler_field_statistics_numeric.inc','b46b6b14e14631941ac2dc9baf0b1290c148f42801f05cb419f84a2091d03e40'),('sites/all/modules/views/modules/system/views_handler_argument_file_fid.inc','e9bf1fdf12f210f0a77774381b670c77ee88e7789971ce732b254f6be5a0e451'),('sites/all/modules/views/modules/system/views_handler_field_file.inc','0fff4adb471c0c164a78f507b035a68d41f404ab10535f06f6c11206f39a7681'),('sites/all/modules/views/modules/system/views_handler_field_file_extension.inc','768aa56198c7e82327391084f5dd27d7efdb8179ff6b8c941f892fe30469a0da'),('sites/all/modules/views/modules/system/views_handler_field_file_filemime.inc','bdd7f1255f3000f7f2900341d4c4ca378244b96390ef52a30db2962d017b61a4'),('sites/all/modules/views/modules/system/views_handler_field_file_status.inc','bfb0b9d796a4dbf95c4bb7a3deef7724bcda9e0d9067939b74ec787da934f2b0'),('sites/all/modules/views/modules/system/views_handler_field_file_uri.inc','350d7dde27ee97cb4279360374eb8633ce7fee115a109346bea85c2c4e3a68c2'),('sites/all/modules/views/modules/system/views_handler_filter_file_status.inc','9210a34795f9db36974525e718c91c03c28554da1199932791925d7c4a2f3b11'),('sites/all/modules/views/modules/system/views_handler_filter_system_type.inc','d27513703a75c4d8af79b489266cf4102a36e350c3d90404dab24403ab637205'),('sites/all/modules/views/modules/taxonomy/views_handler_argument_taxonomy.inc','8962fa76f1e03316932468b0fd805817af94726beb82bf9f4786e0c709264662'),('sites/all/modules/views/modules/taxonomy/views_handler_argument_term_node_tid.inc','e50f47ac64a93c2a43b6bd940119dee46b9f25f79f5d25a93fd0df7d707c93ab'),('sites/all/modules/views/modules/taxonomy/views_handler_argument_term_node_tid_depth.inc','5b2806fbad4a6cc104e733a3a0faf6eb1c19975930c67c4149fb3267976e0b7d'),('sites/all/modules/views/modules/taxonomy/views_handler_argument_term_node_tid_depth_join.inc','ca667646f99645c00e6dfb7eb52e2f54faf848be41c99af5caf2201dcd56926b'),('sites/all/modules/views/modules/taxonomy/views_handler_argument_term_node_tid_depth_modifier.inc','d85ebe68290239b25fc240451655b825325854e9707cf742fbd75de81e0f1aa7'),('sites/all/modules/views/modules/taxonomy/views_handler_argument_vocabulary_machine_name.inc','888647527bec3444b2d0a571a77900396d7c5e884bca04a2a3667a61f6377b5e'),('sites/all/modules/views/modules/taxonomy/views_handler_argument_vocabulary_vid.inc','bf4be783ef6899f004f4dbd06c1bf2cd6dbc322678c825eec36bee81d667e81f'),('sites/all/modules/views/modules/taxonomy/views_handler_field_taxonomy.inc','fcafbbf79b79829eff211aa69580aa746b6d21a29416758bd43e25b5433f9a02'),('sites/all/modules/views/modules/taxonomy/views_handler_field_term_link_edit.inc','3da63f6feb1fa3312853b54585d761d037dac8841b4c06e01e35463c9098064a'),('sites/all/modules/views/modules/taxonomy/views_handler_field_term_node_tid.inc','d7bb6f685b85de9f9cc87500b3e5a07493832f032d826e20700bbd1baa020a61'),('sites/all/modules/views/modules/taxonomy/views_handler_filter_term_node_tid.inc','6ecc68ee0efaaedd1ae8b290e587955a7d6c3ea361f671921167df55d353922e'),('sites/all/modules/views/modules/taxonomy/views_handler_filter_term_node_tid_depth.inc','0b05ec052dcc03081e20338808dda17beb0bdf869b0cfc1375ca96cfb758c22a'),('sites/all/modules/views/modules/taxonomy/views_handler_filter_term_node_tid_depth_join.inc','76d59ca83bdcb40493055829a9132646ed89478d7eb6e468db2d879e66e3794c'),('sites/all/modules/views/modules/taxonomy/views_handler_filter_vocabulary_machine_name.inc','f1787b436b914cfe5ca6f2575d4c0595f4f496795711d6e8a116a39986728b0a'),('sites/all/modules/views/modules/taxonomy/views_handler_filter_vocabulary_vid.inc','2a4d7dfbb6b795d217e2617595238f552bbea04b80217c933f1ee9978ceb7a0e'),('sites/all/modules/views/modules/taxonomy/views_handler_relationship_node_term_data.inc','0bfd4c7882054565fb4ff52cf5697fe8cffca69d24717ebc37e6eacc14fe2312'),('sites/all/modules/views/modules/taxonomy/views_plugin_argument_default_taxonomy_tid.inc','fc4c3ace525162fc922de581af0710c7d92dc355e9630040a29a5c3a6ab7f9af'),('sites/all/modules/views/modules/taxonomy/views_plugin_argument_validate_taxonomy_term.inc','8a9d828e5e4387d831172a5c658fac8ef584d843be6c95e9b4e357af6c8f97de'),('sites/all/modules/views/modules/tracker/views_handler_argument_tracker_comment_user_uid.inc','91f5b7e9537942eee7a1798906f772cb9806eebfdc201c54fcdecf027cd71d0f'),('sites/all/modules/views/modules/tracker/views_handler_filter_tracker_boolean_operator.inc','5efea908902052d68141017b6f29f17381e7bb8ebb6d88245471926f0a552207'),('sites/all/modules/views/modules/tracker/views_handler_filter_tracker_comment_user_uid.inc','05e07f74d1e3978afd4c80a9b4bd72444872b84a44949a512f1d3040ce28421c'),('sites/all/modules/views/modules/translation/views_handler_argument_node_tnid.inc','b0e3c87d3790cfa2e265f3d9700f2b3c2857932aa4b6e003e5d0114fc1b4d499'),('sites/all/modules/views/modules/translation/views_handler_field_node_link_translate.inc','27a1ac81b50d4807d9a1eff4c5dc8929e4472f9d363f70f5391a794db73424a2'),('sites/all/modules/views/modules/translation/views_handler_field_node_translation_link.inc','641ff25cd317bb803de2ace4bd23e8c5f5af5ba4ac38aab7be2fdc58fbb9e86a'),('sites/all/modules/views/modules/translation/views_handler_filter_node_tnid.inc','0942fd793740e3aec032a1abb7132f53788a9cdeaeb3d931cac908ac30b73950'),('sites/all/modules/views/modules/translation/views_handler_filter_node_tnid_child.inc','2a7a96d6caa4a99996549be0457bf40fa619731543a636d4573e55c190c64c7a'),('sites/all/modules/views/modules/translation/views_handler_relationship_translation.inc','9137c85f5ca309d4ee0d3243c470563a5853f5926b8cbd3e843438d4308c9516'),('sites/all/modules/views/modules/user/views_handler_argument_users_roles_rid.inc','72da80e7f3c6980da024d86f37ba3721021cc1ead2cfcc1ab9b27897b7b5077a'),('sites/all/modules/views/modules/user/views_handler_argument_user_uid.inc','a4af1bdc1ec5e40587c22c14e839980050baaa346c9d5934ef3f01794932cdc5'),('sites/all/modules/views/modules/user/views_handler_field_user.inc','1a2141524e43d86b52c7828fe6df61dd603ad433743c1139cfc5cc28ccb5ce74'),('sites/all/modules/views/modules/user/views_handler_field_user_language.inc','5a3da9e08ebeebbcb5abc6a9b16e0d380c5bb5c57b608afb540a3ca6dc1b2959'),('sites/all/modules/views/modules/user/views_handler_field_user_link.inc','5a0f35d5305a29816658385ecbd804bf43c92d4b3629fbe4bd9b8d0e9574b6ff'),('sites/all/modules/views/modules/user/views_handler_field_user_link_cancel.inc','b865881b15ce86b5a00f2892d3fc62f40131417527211275ff9a3d09d485750b'),('sites/all/modules/views/modules/user/views_handler_field_user_link_edit.inc','5d7c1155d9eccbd6b07c7446fe2b6a8848d6a500f508ac3779f16df56816f92b'),('sites/all/modules/views/modules/user/views_handler_field_user_mail.inc','b7355b704f19322afb4876cea27744367e20098d4ed973e480bf2baf1ddd111c'),('sites/all/modules/views/modules/user/views_handler_field_user_name.inc','3be11e273d7a0e8d1e1406b94ba651a6f545f9d48d94758495449b68487f4426'),('sites/all/modules/views/modules/user/views_handler_field_user_permissions.inc','ec37373524bf23ae107adda6b825570c550e6654c0f0956409fc58df2c860903'),('sites/all/modules/views/modules/user/views_handler_field_user_picture.inc','0103d136a91fb219fd981801301b7df00adf90617900ded08efbf6d7df04959b'),('sites/all/modules/views/modules/user/views_handler_field_user_roles.inc','ab5068c4f01a05c6511f7d4b973a77650d5b5c481d4a73f63b7a9b1ef9c0d138'),('sites/all/modules/views/modules/user/views_handler_filter_user_current.inc','7f70b7e3b3c10e75d95f54afc9c2fe2f1af9b7a9eab2308d2961b2588dc05845'),('sites/all/modules/views/modules/user/views_handler_filter_user_name.inc','5225e5d89051313e0e49ea833709bb4dc44369afeee970b0cfaf1818ababa22c'),('sites/all/modules/views/modules/user/views_handler_filter_user_permissions.inc','a72e8d02c1075cebfee33e5b046460eef9193b2a7c1d47ff130457e4485b6fe5'),('sites/all/modules/views/modules/user/views_handler_filter_user_roles.inc','3bb69fbc4e352ce8e4840ec78bdd0f1f29e8709097ce6b29cc2fedd2c74c023e'),('sites/all/modules/views/modules/user/views_plugin_argument_default_current_user.inc','11e729115350deffe46ebfe3a55281fa169a90e38a76c3a9d98f26c87900a22b'),('sites/all/modules/views/modules/user/views_plugin_argument_default_user.inc','fe567f009a8e20f402f104b157fd44c04d6bd886a39b2f3355104f644f905419'),('sites/all/modules/views/modules/user/views_plugin_argument_validate_user.inc','40d623b0a678fa7c292da92582f06449d0396341ab161069f0fe8d1086ab95da'),('sites/all/modules/views/modules/user/views_plugin_row_user_view.inc','6a6c1bfac677eb9ffd25870cd72939c903f2c92d6d18e3abc6c634ac153e5c2b'),('sites/all/modules/views/plugins/export_ui/views_ui.class.php','8cd921da4fc00f0441808c6d521fa9fdfc753976244518a001a6354975eb6fe8'),('sites/all/modules/views/plugins/views_plugin_access.inc','cc16bf7dc4c10eab382e948cfd91902ac1055514b627e3c50932376d3e3f1b91'),('sites/all/modules/views/plugins/views_plugin_access_none.inc','8e0a6b706c60abf63ab84d8624567ca12a5b80ad293e4334790065fbe6fa14d4'),('sites/all/modules/views/plugins/views_plugin_access_perm.inc','1807a9c91485a5abd3fb2f6590ed4bc185fdabe308db37b169be8abdfc30cab2'),('sites/all/modules/views/plugins/views_plugin_access_role.inc','8784836ea87ec6b0974125ed95ed6bbf6fdf91624f496f22c28e9229c695068d'),('sites/all/modules/views/plugins/views_plugin_argument_default.inc','43e593760f0e8f031f2e7b861385caa5e39f37de400fe4595925288c78f52f23'),('sites/all/modules/views/plugins/views_plugin_argument_default_fixed.inc','daaa3b59b54cbb11e411e010303f67a51348bb97a4e06997b475f4c41e91c4e0'),('sites/all/modules/views/plugins/views_plugin_argument_default_php.inc','7a133b603294bfe498bfdeb50fade0b6e3cf8862270376067d86f69e7dc50eb8'),('sites/all/modules/views/plugins/views_plugin_argument_default_raw.inc','4318e0dfa56f167183453cf8cd913f3b7ee539b77a096507905e36db12ded97e'),('sites/all/modules/views/plugins/views_plugin_argument_validate.inc','2ada4fdc59b366f33209c0cfc515b06e765b487091760cfa22e94ca1c028c9cb'),('sites/all/modules/views/plugins/views_plugin_argument_validate_numeric.inc','c050d3b5723dbfdca9ad312c7fa198e509c626057b95eed326820ce733dd9730'),('sites/all/modules/views/plugins/views_plugin_argument_validate_php.inc','56a09922081a5e368d5796907727e35cbf43b0d634e53f947990c8a42d5b5f3e'),('sites/all/modules/views/plugins/views_plugin_cache.inc','870ceb5dd920212f4297849046e696b50dbe35a9ad4ac28b7021a7dd03aa64d9'),('sites/all/modules/views/plugins/views_plugin_cache_none.inc','a0d0ba252e1e2b65350c7ce648b97364726fa8ded5a366bfcce30c62daee4450'),('sites/all/modules/views/plugins/views_plugin_cache_time.inc','fb55f3236b30f00f3ca5228c40115444a0e2f164a4f54e6fe07dee514e183569'),('sites/all/modules/views/plugins/views_plugin_display.inc','dd190a0984bfd20a876e6437898ec691b4f46bc7a8d2e9ef17e054d03294536f'),('sites/all/modules/views/plugins/views_plugin_display_attachment.inc','6124e2ec51eadd7500fb878c25d9c5044b4ae9b6323dbbaa40b4806b69dd4cc0'),('sites/all/modules/views/plugins/views_plugin_display_block.inc','7ad6a90efa396f68276e93e19a6273c88782d514c1f1cea6ed0b046287e16a10'),('sites/all/modules/views/plugins/views_plugin_display_default.inc','91c6554d8f41f848bf30093d44d076051c54e998f6b50bdc2a922bfeeef9c54d'),('sites/all/modules/views/plugins/views_plugin_display_embed.inc','5424f2ea9e031faade7a562b8013aea193db5b0bc1be92b97bd7967de0d7bfff'),('sites/all/modules/views/plugins/views_plugin_display_extender.inc','75fb9f80e7f153715b911690c7140f251df588e6a541fab5881fbfafc0bbf778'),('sites/all/modules/views/plugins/views_plugin_display_feed.inc','f2fb6152e12da300b9bb8e1b45621dfe921c3ce0e769970ee1532e32a3657c53'),('sites/all/modules/views/plugins/views_plugin_display_page.inc','ece0ae5d5d730ef646178b09bc41a59e091c96a6ac3b3db5bdb9e61d194787bb'),('sites/all/modules/views/plugins/views_plugin_exposed_form.inc','0632ce61b4e39f8c0f39866987e4908657020298520fcf7c2712c0135e77d95b'),('sites/all/modules/views/plugins/views_plugin_exposed_form_basic.inc','c736e1862b393e15ecc80deb58663405a1d68c2db07eb620d8e640406876cd17'),('sites/all/modules/views/plugins/views_plugin_exposed_form_input_required.inc','98b81e3b78f7242dd30a3754830bdde2fb1dfe8f002ae0daa06976f1bb64fa75'),('sites/all/modules/views/plugins/views_plugin_localization.inc','d7239cc693994dcd069c1f1e7847a7902c5bd29b8d64a93cdf37c602576661fb'),('sites/all/modules/views/plugins/views_plugin_localization_core.inc','f0900c0640e7c779e9b876223ea395f613c8fe8449f6c8eb5d060e2d54a6afcc'),('sites/all/modules/views/plugins/views_plugin_localization_none.inc','4930c3a13ddc0df3065f4920a836ffdc933b037e1337764e6687d7311f49dd8a'),('sites/all/modules/views/plugins/views_plugin_pager.inc','d7c32e38f149e9009e175395dff2b00ec429867653c7535301b705a7cc69d9ed'),('sites/all/modules/views/plugins/views_plugin_pager_full.inc','60e4dec532de00bf7e785e5fa29a0be43c7b550efa85df0346a1712a3c39f7cd'),('sites/all/modules/views/plugins/views_plugin_pager_mini.inc','0a9d101d5a4217fb888c643bfddd7bf7f2f9c0937faa2753a31452a5ee68190b'),('sites/all/modules/views/plugins/views_plugin_pager_none.inc','822cab1ada25f4902a0505f13db86886061d2ced655438b33b197d031ccceddd'),('sites/all/modules/views/plugins/views_plugin_pager_some.inc','bc6aa7cbf1bc09374eced33334195c8897e4078336b8306d02d71c7aaaa22c99'),('sites/all/modules/views/plugins/views_plugin_query.inc','475a7ff0d4c7c7e27d7971ebd909a87bdb8322c47d6023b68f50f6fe6a1ec059'),('sites/all/modules/views/plugins/views_plugin_query_default.inc','d5f89543721a3cd24f6a18114c630f741d11029d933f1b01d59f349219b747d6'),('sites/all/modules/views/plugins/views_plugin_row.inc','3ca81529526b930cfb0dda202757f203649236b90441e3c035bb79cd419ee2a6'),('sites/all/modules/views/plugins/views_plugin_row_fields.inc','875fb2868cdbcc5f7af03098cbe55b9bb91ef512e5e52ccde89f7a02a0c5fbe2'),('sites/all/modules/views/plugins/views_plugin_row_rss_fields.inc','62f4a0ceef14aec9958ee8b98d352303f10818ddc66031814cc8b9d21752ade9'),('sites/all/modules/views/plugins/views_plugin_style.inc','1ac358d216da612e1731d6b1c730d2ee57ccb8cdd31ad768ae97af542325244f'),('sites/all/modules/views/plugins/views_plugin_style_default.inc','bf411e635d2fd9e09eb245b43581a0a7b670359180ccb042d42a5e579bbe9c30'),('sites/all/modules/views/plugins/views_plugin_style_grid.inc','35094b7f644b7e0692c9026b6b6b4c4c864c37fcdedef04b359dd2bdba496a47'),('sites/all/modules/views/plugins/views_plugin_style_jump_menu.inc','53a438d8a5398877eacdbff97f3b0c418ebc2fa16e69efd5e4a31b0b986e03a3'),('sites/all/modules/views/plugins/views_plugin_style_list.inc','407b928d2c74a91903b681088bccce926d2268d0a9a6a34c185a4849dc0d7e31'),('sites/all/modules/views/plugins/views_plugin_style_mapping.inc','a6b430a148dda1b07ecee314b897c1da41ce375566adf50ee23ae1da822fddf3'),('sites/all/modules/views/plugins/views_plugin_style_rss.inc','ac72d530faffee78a1695a0b3893528ceb8451f18be0521c580485904a5ba57b'),('sites/all/modules/views/plugins/views_plugin_style_summary.inc','872df59f8f389eaf9b019e82d859dd198d31166e26a9102132e3932c7f1f2916'),('sites/all/modules/views/plugins/views_plugin_style_summary_jump_menu.inc','2ec0d225824ee65b6bb61317979e1dabe2be524a66ab19da924c6949dd31af3b'),('sites/all/modules/views/plugins/views_plugin_style_summary_unformatted.inc','c1e6f9dd1d75e29fee271171440d2182e633a1dbbc996cb186f637ff7ad93ed9'),('sites/all/modules/views/plugins/views_plugin_style_table.inc','0cbcc5d256a13953fbd3e5966a33d2426d5c3bd8c228ef370daebf2f428e693c'),('sites/all/modules/views/plugins/views_wizard/views_ui_base_views_wizard.class.php','d8325414c8ddde5c955a5cfb053b77478bb4d73cb2f7d75b857b082bc5a1e12d'),('sites/all/modules/views/plugins/views_wizard/views_ui_comment_views_wizard.class.php','585a8e885a18d4d2dee260859492eb332d70166abf2d201777ebf0d2083d2ebe'),('sites/all/modules/views/plugins/views_wizard/views_ui_file_managed_views_wizard.class.php','5734fb564ba9e2485cfa5d4a49f0c76f65a9be357b78e769ee4af92c4ef9e22a'),('sites/all/modules/views/plugins/views_wizard/views_ui_node_revision_views_wizard.class.php','6faf9ef92501a4f1aeaf86bcff9edaeb47bd7526ba50d06b841c9366149e7725'),('sites/all/modules/views/plugins/views_wizard/views_ui_node_views_wizard.class.php','f10e588fcfe2dc37d0df1c520c3cd797b85d6f729335606b1aa11fcb5884e6eb'),('sites/all/modules/views/plugins/views_wizard/views_ui_taxonomy_term_views_wizard.class.php','87d72dba2aef587994307cb287b638a409d148911e4b90109798ecacf5a721e7'),('sites/all/modules/views/plugins/views_wizard/views_ui_users_views_wizard.class.php','f9fe2fb1ee87a1871e6ad32bad61b2457313f24da1bd5423977ced12de542919'),('sites/all/modules/views/tests/comment/views_handler_argument_comment_user_uid.test','b8b417ef0e05806a88bd7d5e2f7dcb41339fbf5b66f39311defc9fb65476d561'),('sites/all/modules/views/tests/comment/views_handler_filter_comment_user_uid.test','347c6ffd4383706dbde844235aaf31cff44a22e95d2e6d8ef4da34a41b70edd1'),('sites/all/modules/views/tests/field/views_fieldapi.test','53e6d57c2d1d6cd0cd92e15ca4077ba532214daf41e9c7c0f940c7c8dbd86a66'),('sites/all/modules/views/tests/handlers/views_handlers.test','f94dd3c4ba0bb1ffbf42704f600b94a808c1202a9ca26e7bdef8e7921c2724e9'),('sites/all/modules/views/tests/handlers/views_handler_area_text.test','af74a74a3357567b844606add76d7ca1271317778dd7bd245a216cf963c738b4'),('sites/all/modules/views/tests/handlers/views_handler_argument_null.test','1d174e1f467b905d67217bd755100d78ffeca4aa4ada5c4be40270cd6d30b721'),('sites/all/modules/views/tests/handlers/views_handler_argument_string.test','3d0213af0041146abb61dcdc750869ed773d0ac80cfa74ffbadfdd03b1f11c52'),('sites/all/modules/views/tests/handlers/views_handler_field.test','af552bf825ab77486b3d0d156779b7c4806ce5a983c6116ad68b633daf9bb927'),('sites/all/modules/views/tests/handlers/views_handler_field_boolean.test','d334b12a850f36b41fe89ab30a9d758fd3ce434286bd136404344b7b288460ae'),('sites/all/modules/views/tests/handlers/views_handler_field_counter.test','75b31942adf06b107f5ffd3c97545fde8cd1040b1d00f682e3c7c1320026e26c'),('sites/all/modules/views/tests/handlers/views_handler_field_custom.test','1446bc3d5a6b1180a79edfa46a5268dbf7f089836aa3bc45df00ddaff9dd0ce1'),('sites/all/modules/views/tests/handlers/views_handler_field_date.test','02df76a93a42d6131957748b1e69254835f9e44a47dafca1e833914e6b7f88a0'),('sites/all/modules/views/tests/handlers/views_handler_field_file_extension.test','606ca091ad7e5709f7653324aaa021484d1f0e07e8639b3f0f7c26d3cfdee53c'),('sites/all/modules/views/tests/handlers/views_handler_field_file_size.test','49184db68af398a54e81c8a76261acd861da8fd7846b9d51dcf476d61396bfb9'),('sites/all/modules/views/tests/handlers/views_handler_field_math.test','6e39e4f782e6b36151ceafb41a5509f7c661be79b393b24f6f5496d724535887'),('sites/all/modules/views/tests/handlers/views_handler_field_url.test','b41f762a71594b438a2e60a79c8260ba54e6305635725b0747e29f0d3ffe08c9'),('sites/all/modules/views/tests/handlers/views_handler_field_xss.test','f129ee16c03f84673e33990cbb2da5aa88c362f46e9ba1620b2a842ffd1c9cd2'),('sites/all/modules/views/tests/handlers/views_handler_filter_combine.test','05842d83a11822afe7d566835f5db9f0f94fdb27ddfc388d38138767bdf36f8b'),('sites/all/modules/views/tests/handlers/views_handler_filter_date.test','ad2ca901c6a4ac3a82fc349a33826f043c6c80f773f40374be2e95acb39491e3'),('sites/all/modules/views/tests/handlers/views_handler_filter_equality.test','c88f21c9cbf1aae83393b26616908f8020c18fe378d76256c7ba192df2ec17af'),('sites/all/modules/views/tests/handlers/views_handler_filter_in_operator.test','89420a4071677232e0eb82b184b37b818a82bdb2ff90a8b21293f9ecb21808bf'),('sites/all/modules/views/tests/handlers/views_handler_filter_numeric.test','35ac7a34e696b979e86ef7209b6697098d9abe218e30a02cc4fe39fb11f2a852'),('sites/all/modules/views/tests/handlers/views_handler_filter_string.test','b7d090780748faad478e619fd55673d746d4a0cf343d9e40ea96881324c34cbd'),('sites/all/modules/views/tests/handlers/views_handler_sort.test','f4ff79e6bc54e83c4eb2777811f33702b7e9fe7416ef70ae00d100fa54d44fec'),('sites/all/modules/views/tests/handlers/views_handler_sort_date.test','f548584d7c6a71cabd3ce07e04053a38df3f3e1685210ce8114238fd05344c10'),('sites/all/modules/views/tests/handlers/views_handler_sort_random.test','4fdba9bf05a26720ffa97e7a37da65ddc9044bd2832f8c89007b82feb062f182'),('sites/all/modules/views/tests/node/views_node_revision_relations.test','9467497a6d693615b48c8f57611a850002317bcb091b926d2efbbe56a4e61480'),('sites/all/modules/views/tests/plugins/views_plugin_display.test','4a6b136543a60999604c54125fa9d4f5aa61a5dcc71e2133d89325d81bc0fc2d'),('sites/all/modules/views/tests/styles/views_plugin_style.test','92d9a02f87f07d091999b961045b1dd654165059d8d1931b5c2ea1d88d0b439f'),('sites/all/modules/views/tests/styles/views_plugin_style_base.test','54fb7816d18416d8b0db67e9f55aa2aa50ac204eb9311be14b6700b7d7a95ae7'),('sites/all/modules/views/tests/styles/views_plugin_style_jump_menu.test','b88baa8aebe183943a6e4cf2df314fef13ac41b5844cd5fa4aa91557dd624895'),('sites/all/modules/views/tests/styles/views_plugin_style_mapping.test','a4e68bc8cfbeff4a1d9b8085fd115bfe7a8c4b84c049573fa0409b0dc8c2f053'),('sites/all/modules/views/tests/styles/views_plugin_style_unformatted.test','033ca29d41af47cd7bd12d50fea6c956dde247202ebda9df7f637111481bb51d'),('sites/all/modules/views/tests/taxonomy/views_handler_relationship_node_term_data.test','6074f5c7ae63225ea0cd26626ace6c017740e226f4d3c234e39869c31308223d'),('sites/all/modules/views/tests/test_handlers/views_test_area_access.inc','619e39bc4535976865b96751535d0d5aac4a7a87c1d47cb6d4c4bb9c9fa74716'),('sites/all/modules/views/tests/test_plugins/views_test_plugin_access_test_dynamic.inc','6a3ce8c256b84734b6b67a893ab24465a5f62d7bdf9ab5d22082a31849346b7d'),('sites/all/modules/views/tests/test_plugins/views_test_plugin_access_test_static.inc','e345e42d443cfa73db0ed2be61291117ebd57b86196cdb77c6f440e93443def3'),('sites/all/modules/views/tests/test_plugins/views_test_plugin_style_test_mapping.inc','0b2c68626105bd5f6b9074022a37c3d09d3a6bd70b811bb26d5eacad6d74546f'),('sites/all/modules/views/tests/user/views_handler_field_user_name.test','69641b6da26d8daee9a2ceb2d0df56668bf09b86db1d4071c275b6e8d0885f9e'),('sites/all/modules/views/tests/user/views_user.test','fbb63b42a0b7051bd4d33cf36841f39d7cc13a63b0554eca431b2a08c19facae'),('sites/all/modules/views/tests/user/views_user_argument_default.test','6423f2db7673763991b1fd0c452a7d84413c7dd888ca6c95545fadc531cfaaf4'),('sites/all/modules/views/tests/user/views_user_argument_validate.test','c88c9e5d162958f8924849758486a0d83822ada06088f5cf71bfbe76932d8d84'),('sites/all/modules/views/tests/views_access.test','f8b9d04b43c09a67ec722290a30408c1df8c163cf6e5863b41468bb4e381ee6f'),('sites/all/modules/views/tests/views_analyze.test','5548e36c99bb626209d63e5cddbc31f49ad83865c983d2662c6826b328d24ffb'),('sites/all/modules/views/tests/views_argument_default.test','5950937aae4608bba5b86f366ef3a56cc6518bbccfeaeacda79fa13246d220e4'),('sites/all/modules/views/tests/views_argument_validator.test','31f8f49946c8aa3b03d6d9a2281bdfb11c54071b28e83fb3e827ca6ff5e38c88'),('sites/all/modules/views/tests/views_basic.test','655bd33983f84bbea68a3f24bfab545d2c02f36a478566edf35a98a58ff0c6cf'),('sites/all/modules/views/tests/views_cache.test','4e9b8ae1d9e72a9eaee95f5083004316d2199617f7d6c8f4bea40e99d17efcd8'),('sites/all/modules/views/tests/views_exposed_form.test','6962c7ed8a38030ec1cfa94485de07ceb1f9393216985bd8bfecac768f6c0950'),('sites/all/modules/views/tests/views_glossary.test','118d50177a68a6f88e3727e10f8bcc6f95176282cc42fbd604458eeb932a36e8'),('sites/all/modules/views/tests/views_groupby.test','f26ad6857dc4821a4a0780642bda05fcb69ed506968e521f759bb28be4080143'),('sites/all/modules/views/tests/views_handlers.test','a696e3d6b1748da03a04ac532f403700d07c920b9c405c628a6c94ea6764f501'),('sites/all/modules/views/tests/views_module.test','5137e27449639d3e02f1b27206ef3ff96957546333b517318dfe8f58239dc860'),('sites/all/modules/views/tests/views_pager.test','6f448c8c13c5177afb35103119d6281958a2d6dbdfb96ae5f4ee77cb3b44adc5'),('sites/all/modules/views/tests/views_plugin_localization_test.inc','baedcf6c7381f9c5d3a5062f7d256f96808d06e04b6e73eff8e791e5f5293f45'),('sites/all/modules/views/tests/views_query.test','f8cb1649e43c8a2b036fec742e86b8eb9c2c4c095a4c4e7a7c3ca13c6ce8e6e6'),('sites/all/modules/views/tests/views_test.views_default.inc','4c65cc385b3e3c2e17fe054eb7a1ec70f4dd4b0394bdb108de2ddc0a7b435635'),('sites/all/modules/views/tests/views_translatable.test','6899c7b09ab72c262480cf78d200ecddfb683e8f2495438a55b35ae0e103a1b3'),('sites/all/modules/views/tests/views_ui.test','f9687a363d7cc2828739583e3eedeb68c99acd505ff4e3036c806a42b93a2688'),('sites/all/modules/views/tests/views_upgrade.test','c48bd74b85809dd78d963e525e38f3b6dd7e12aa249f73bd6a20247a40d6713a'),('sites/all/modules/views/tests/views_view.test','a52e010d27cc2eb29804a3acd30f574adf11fad1f5860e431178b61cddbdbb69'),('sites/all/modules/views/views_ui.module','418d555f71e72cb771a01ad7bfe7410c4d8191738271fa4e7cbb063940afb2a0'),('sites/all/modules/views_bootstrap/plugins/accordion/views_bootstrap_accordion_plugin_style.inc','cd1d10d86d6478f2e09627e584bed61c2b56fbe04ab145f21fff1db57517141f'),('sites/all/modules/views_bootstrap/plugins/carousel/views_bootstrap_carousel_plugin_rows.inc','29dc7c5efbed6cce2a1febdca54bf32b68bc86ea44b1aaca20d317afb0c56071'),('sites/all/modules/views_bootstrap/plugins/carousel/views_bootstrap_carousel_plugin_style.inc','1f0914b41bbe43d4aed077ac921aab48c0ed1ebd47842bcb54e830435d6f9933'),('sites/all/modules/views_bootstrap/plugins/grid/views_bootstrap_grid_plugin_style.inc','91729a36053b19b9b0dc19e15283145aa52e2ef256dca6fbc137f4373d5a5d21'),('sites/all/modules/views_bootstrap/plugins/media/views_bootstrap_media_plugin_style.inc','2fb49eab8d79cee51c0f21bd94b4c933b8ca2b0adbd3e5895811f22bfb90a99e'),('sites/all/modules/views_bootstrap/plugins/tab/views_bootstrap_tab_plugin_style.inc','9c760e3b195d4a41b3bb60c51a19ad776283ca93b71e6b06e450295b9574308c'),('sites/all/modules/views_bootstrap/plugins/table/views_bootstrap_table_plugin_style.inc','2e2e63ca485eb5bee8a7e84105a67862d2c6837f51c139d5c8022b25bb779ca5'),('sites/all/modules/views_bootstrap/plugins/thumbnail/views_bootstrap_thumbnail_plugin_rows.inc','e7865515d7fdfa8ebcda036fe002cd8081ce7042962b6952869227a57a74e8cb'),('sites/all/modules/views_bootstrap/plugins/thumbnail/views_bootstrap_thumbnail_plugin_style.inc','5fcf10588197e194f205589755001d3c7ff96e8139ea8f1adc084fd3e8a7cb7c'),('sites/all/modules/views_fieldsets/views/views_fieldsets_fieldset_field_handler.inc','2870256bc954a75a21a134dbb32d02cdc77ab8aadf43539ee3e9ab48ba2c9696'),('sites/all/modules/views_field_view/tests/views_field_view.test','cbc84f9b875e681a61f6401abf0e97b95bbeb55fd6def4800cdca3f62617ac91'),('sites/all/modules/views_field_view/views_field_view_handler_field_view.inc','31d1f7bf2d427a5d04161816a995efb72816d1583f8d69af3a244fa68a6ae0b9'),('sites/all/modules/views_slideshow/contrib/views_slideshow_cycle/theme/views_slideshow_cycle.theme.inc','6a074c958bf41f9067a640ca8a40480bee29e64ab9f352fee5f3bb95d7480cdb'),('sites/all/modules/views_slideshow/contrib/views_slideshow_cycle/views_slideshow_cycle.module','4a5cf6b3a8747cd8a8d874c796ffab08c7d3b1921cfd6779ed87526ec446914e'),('sites/all/modules/views_slideshow/contrib/views_slideshow_cycle/views_slideshow_cycle.views_slideshow.inc','fc525602109c8db6173814b73c8f04921331f3373f1fa8666111e252eb3cf9b6'),('sites/all/modules/views_slideshow/theme/views_slideshow.theme.inc','3cbed9cfdc7994fccb3f9882246e6faf282518b84a7248c8d93a55f97585e8f4'),('sites/all/modules/views_slideshow/views_slideshow.module','106f6cd97700ae75adabe1a2ba1ae1e1f4bda1d60e1e56406392cb7358605667'),('sites/all/modules/views_slideshow/views_slideshow.views.inc','95958d4aba955044f00330dd59f35b6759e7057ced744429bfb45732e4ce094c'),('sites/all/modules/views_slideshow/views_slideshow_plugin_style_slideshow.inc','3df328b32c9d209cca54e3d8136e5c0f37b1619d0bcb600ca5568a85bd7da20b'),('sites/all/modules/votingapi/tests/votingapi.test','dd54282d34cff2a3a01f9ffbde51b367e5136e4d97d67b7255fb2fbccfe9933a'),('sites/all/modules/votingapi/views/votingapi_views_handler_field_value.inc','878d014877b0fb86302c7557a598ef1a49923b6ee55557685b6deddf6336bb16'),('sites/all/modules/votingapi/views/votingapi_views_handler_relationship.inc','effdeaa71d58295cac16a56aa4276c0a8b0aa95d2ab438deb26e30e4b3a0fba8'),('sites/all/modules/votingapi/views/votingapi_views_handler_sort_nullable.inc','892d69754cf1945b31c5429f9676efbcfc1dabbdadfef68dd7780339c505f565'),('sites/all/modules/webform/includes/exporters/webform_exporter.inc','5b681b19fc29764749622e59ed5c8093f6e16156cca7f537973be888e87a8e19'),('sites/all/modules/webform/includes/exporters/webform_exporter_delimited.inc','aaa051b7c984e26ae39a08bdfb9e1bc27a1f60d30bb83315bb2dc74fc5b03b87'),('sites/all/modules/webform/includes/exporters/webform_exporter_excel_delimited.inc','fe301ec8cba10b2e5ecdfed30c386fef1dbb1a33db21a19fa686533775b72223'),('sites/all/modules/webform/includes/exporters/webform_exporter_excel_xlsx.inc','b3407ce58fb72c05d723ab699440f687db6344d4a8756eca7333deaa9c6f2df3'),('sites/all/modules/webform/includes/webform.webformconditionals.inc','570b6547d286fdd91aa431cd524711a5fdec600ae379e508b0bc453a218b5720'),('sites/all/modules/webform/tests/components.test','3c3933763024a02ecf00197e48792a4cb3d7d38ee433a687d862403d1b33597b'),('sites/all/modules/webform/tests/conditionals.test','cd6c0093d349a9b5e9e2c88b67f61ca037fab12f9d6baaf556d2592d460484b4'),('sites/all/modules/webform/tests/permissions.test','a3a44e69e38d99f100bc8e38ecac9c732e7f6559d08760f17d090f83b3661b6b'),('sites/all/modules/webform/tests/submission.test','29b2d613653a21a3644e6401e4156827eaeb344e79b5c2140ed8e1751f6a00fa'),('sites/all/modules/webform/tests/webform.test','a1f5ca21126eaefbd33bea6bbebd231798428fccf430f20f263d9f0aedcf0fd0'),('sites/all/modules/webform/views/webform.views.inc','10d205b4c10a77b1da972554898c2e452226973f57affee3f26dcf1620102161'),('sites/all/modules/webform/views/webform_handler_area_result_pager.inc','23b6f7013773cfed06c540748f7e2f0dc40602289bc97d73fe603ca9c87f0deb'),('sites/all/modules/webform/views/webform_handler_field_form_body.inc','60d708d683c67b553ecee37c7d74b00ee4b06253799e31befef9cb3ff703abb2'),('sites/all/modules/webform/views/webform_handler_field_is_draft.inc','1f1411981bc3e96ae4dccfb4c52a059b2e6488818ad4649fe8074f7de2d324f6'),('sites/all/modules/webform/views/webform_handler_field_node_link_edit.inc','15c6c4755b2ec87f71699399851a831176d515071ef356de4a64b75b76989e89'),('sites/all/modules/webform/views/webform_handler_field_node_link_results.inc','5320f9c4ffa4842d2efc31c6d563c083e0432c682f1eff706ade34fb8e54d630'),('sites/all/modules/webform/views/webform_handler_field_submission_count.inc','1ed985c65786a215a39ecb119ad26c7e78108ecb8f969ed902cc4618c5378232'),('sites/all/modules/webform/views/webform_handler_field_submission_data.inc','20d43042081563855ef07ae91283d387664f00d4ba700b1b062b5cfdc43d9dd6'),('sites/all/modules/webform/views/webform_handler_field_submission_link.inc','faaf698125ac99f18bdb8c4a7b9961e5ad06bdd157c7bbeaf8a8ad7d5be6aa60'),('sites/all/modules/webform/views/webform_handler_field_webform_status.inc','1545900e2423f6869995b1a82072d25e0d0f66c51df5dbe691698d8e15020d73'),('sites/all/modules/webform/views/webform_handler_filter_is_draft.inc','dfb94fba66085fd0c07b8012f6846228fabc46809b00028bb896d6a304cdfec8'),('sites/all/modules/webform/views/webform_handler_filter_submission_data.inc','74d41b7fc50055de6279fd1d4757752841018374116ca844466b72a6085f9792'),('sites/all/modules/webform/views/webform_handler_filter_webform_status.inc','4a6e3f21703f750b31e868e64fd1fc4b760c01b9a3ca98b250f34c29614fbc69'),('sites/all/modules/webform/views/webform_handler_numeric_data.inc','ce2d03c6fd25c5022ca1441f3f6b69e7d6643d67c06e853c2968500e7a8bf215'),('sites/all/modules/webform/views/webform_handler_relationship_submission_data.inc','10ba625ac9813ee2b7cb3b66b557ea8d60d32ae5bf4300b8bd6ee41be0303fbd'),('sites/all/modules/webform/views/webform_plugin_row_submission_view.inc','728907aaf814b5dc10a6d2c2c60880b160031536e81cff7071ffe04c570a7f60'),('sites/all/modules/weight/views/weight_handler_field_weight.inc','1c466bab88ab15dc0684cb4833154c9ced0fd3c289c5f6c768c178d4421d2f27'),('sites/all/modules/weight/views/weight_handler_filter_weight_enabled.inc','49985e0837b7437246595bfc479f33932cf2a9b8b33a811796f26c451b970727'),('sites/all/modules/weight/weight.migrate.inc','7cad96b61af2c907fc0bef9513f07b59c461bb1ddf27501e521b58b95a90eb3c');
/*!40000 ALTER TABLE `registry_file` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `role`
--

DROP TABLE IF EXISTS `role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role` (
  `rid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique role ID.',
  `name` varchar(64) NOT NULL DEFAULT '' COMMENT 'Unique role name.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The weight of this role in listings and the user interface.',
  PRIMARY KEY (`rid`),
  UNIQUE KEY `name` (`name`),
  KEY `name_weight` (`name`,`weight`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8 COMMENT='Stores user roles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role`
--

LOCK TABLES `role` WRITE;
/*!40000 ALTER TABLE `role` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `role` VALUES (3,'administrator',3),(1,'anonymous user',0),(2,'authenticated user',1),(4,'Seller',2);
/*!40000 ALTER TABLE `role` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `role_permission`
--

DROP TABLE IF EXISTS `role_permission`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role_permission` (
  `rid` int(10) unsigned NOT NULL COMMENT 'Foreign Key: role.rid.',
  `permission` varchar(128) NOT NULL DEFAULT '' COMMENT 'A single permission granted to the role identified by rid.',
  `module` varchar(255) NOT NULL DEFAULT '' COMMENT 'The module declaring the permission.',
  PRIMARY KEY (`rid`,`permission`),
  KEY `permission` (`permission`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores the permissions assigned to user roles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role_permission`
--

LOCK TABLES `role_permission` WRITE;
/*!40000 ALTER TABLE `role_permission` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `role_permission` VALUES (1,'access checkout','commerce_checkout'),(1,'access comments','comment'),(1,'access content','node'),(1,'access user profiles','user'),(1,'search content','search'),(1,'send newsletter','simplenews'),(1,'subscribe to newsletters','simplenews'),(1,'use advanced search','search'),(1,'use exclude node title','exclude_node_title'),(1,'use text format filtered_html','filter'),(1,'view any commerce_product entity','commerce_product'),(1,'view any store','commerce_store_access'),(2,'access checkout','commerce_checkout'),(2,'access comments','comment'),(2,'access content','node'),(2,'access user profiles','user'),(2,'edit webform components','webform'),(2,'post comments','comment'),(2,'search content','search'),(2,'send newsletter','simplenews'),(2,'skip comment approval','comment'),(2,'subscribe to newsletters','simplenews'),(2,'use advanced search','search'),(2,'use exclude node title','exclude_node_title'),(2,'use text format filtered_html','filter'),(2,'view any commerce_product entity','commerce_product'),(2,'view any store','commerce_store_access'),(3,'access administration menu','admin_menu'),(3,'access administration pages','system'),(3,'access all views','views'),(3,'access all webform results','webform'),(3,'access checkout','commerce_checkout'),(3,'access comments','comment'),(3,'access content','node'),(3,'access content overview','node'),(3,'access contextual links','contextual'),(3,'access dashboard','dashboard'),(3,'access devel information','devel'),(3,'access new transaction overview page','commerce_marketplace_funds'),(3,'access overlay','overlay'),(3,'access own webform results','webform'),(3,'access own webform submissions','webform'),(3,'access rules debug','rules'),(3,'access site in maintenance mode','system'),(3,'access site reports','system'),(3,'access user profiles','user'),(3,'add products to any store','commerce_store_access'),(3,'administer actions','system'),(3,'administer block classes','block_class'),(3,'administer blocks','block'),(3,'administer checkout','commerce_checkout'),(3,'administer ckeditor','ckeditor'),(3,'administer cmp_funds_account entities','commerce_marketplace_funds'),(3,'administer cmp_funds_transaction entities','commerce_marketplace_funds'),(3,'administer cmp_funds_withdraw_method types','commerce_marketplace_funds_withdraw'),(3,'administer comments','comment'),(3,'administer commerce_customer_profile entities','commerce_customer'),(3,'administer commerce_order entities','commerce_order'),(3,'administer commerce_product entities','commerce_product'),(3,'administer commerce_stock settings','commerce_stock'),(3,'administer content types','node'),(3,'administer contexts','context_ui'),(3,'administer custom breadcrumbs','custom_breadcrumbs'),(3,'administer custom offline payments','commerce_cop'),(3,'administer customer profile types','commerce_customer'),(3,'administer exclude node title','exclude_node_title'),(3,'administer facets','facetapi'),(3,'administer features','features'),(3,'administer field collections','field_collection'),(3,'administer fieldgroups','field_group'),(3,'administer fields','field'),(3,'administer filters','filter'),(3,'administer flat rate services','commerce_flat_rate'),(3,'administer flexslider','flexslider'),(3,'administer icons','icon'),(3,'administer image styles','image'),(3,'administer imce','imce'),(3,'administer languages','locale'),(3,'administer line item types','commerce_line_item'),(3,'administer line items','commerce_line_item'),(3,'administer menu','menu'),(3,'administer menu_token','menu_token'),(3,'administer module filter','module_filter'),(3,'administer modules','system'),(3,'administer newsletters','simplenews'),(3,'administer nodes','node'),(3,'administer pathauto','pathauto'),(3,'administer payment methods','commerce_payment'),(3,'administer payments','commerce_payment'),(3,'administer permissions','user'),(3,'administer product pricing','commerce_product_pricing_ui'),(3,'administer product types','commerce_product'),(3,'administer rules','rules'),(3,'administer search','search'),(3,'administer search_api','search_api'),(3,'administer shipping','commerce_shipping'),(3,'administer shortcuts','shortcut'),(3,'administer simplenews settings','simplenews'),(3,'administer simplenews subscriptions','simplenews'),(3,'administer site configuration','system'),(3,'administer software updates','system'),(3,'administer taxonomy','taxonomy'),(3,'administer tb_megamenu','tb_megamenu'),(3,'administer themes','system'),(3,'administer url aliases','path'),(3,'administer users','user'),(3,'administer views','views'),(3,'administer voting api','votingapi'),(3,'assign node weight','weight'),(3,'block IP addresses','system'),(3,'bypass node access','node'),(3,'bypass rules access','rules'),(3,'cancel account','user'),(3,'change own username','user'),(3,'configure commerce store order settings','commerce_store'),(3,'configure order settings','commerce_order'),(3,'configure store','commerce'),(3,'context ajax block access','context_ui'),(3,'create article content','node'),(3,'create commerce_customer_profile entities','commerce_customer'),(3,'create commerce_customer_profile entities of bundle billing','commerce_customer'),(3,'create commerce_order entities','commerce_order'),(3,'create commerce_order entities of bundle commerce_order','commerce_order'),(3,'create commerce_product entities','commerce_product'),(3,'create commerce_product entities of bundle product','commerce_product'),(3,'create new deposit transaction from any account of any type','commerce_marketplace_funds'),(3,'create new deposit transaction from any commerce_store funds account','commerce_marketplace_funds'),(3,'create new deposit transaction from any user funds account','commerce_marketplace_funds'),(3,'create new deposit transaction from own commerce_store funds account','commerce_marketplace_funds'),(3,'create new deposit transaction from own user funds account','commerce_marketplace_funds'),(3,'create new stores','commerce_store_access'),(3,'create new transfer transaction from any account of any type','commerce_marketplace_funds'),(3,'create new transfer transaction from any commerce_store funds account','commerce_marketplace_funds'),(3,'create new transfer transaction from any user funds account','commerce_marketplace_funds'),(3,'create new transfer transaction from own commerce_store funds account','commerce_marketplace_funds'),(3,'create new transfer transaction from own user funds account','commerce_marketplace_funds'),(3,'create new withdraw methods of any type','commerce_marketplace_funds_withdraw'),(3,'create page content','node'),(3,'create payments','commerce_payment'),(3,'create url aliases','path'),(3,'customize ckeditor','ckeditor'),(3,'customize shortcut links','shortcut'),(3,'delete all webform submissions','webform'),(3,'delete any article content','node'),(3,'delete any page content','node'),(3,'delete any store','commerce_store_access'),(3,'delete own article content','node'),(3,'delete own page content','node'),(3,'delete own stores','commerce_store_access'),(3,'delete own webform submissions','webform'),(3,'delete payments','commerce_payment'),(3,'delete revisions','node'),(3,'delete terms in 1','taxonomy'),(3,'delete withdraw methods of any type','commerce_marketplace_funds_withdraw'),(3,'display drupal links','admin_menu'),(3,'eck add bundles','eck'),(3,'eck add commerce_store bundles','eck'),(3,'eck add commerce_store store entities','eck'),(3,'eck add entities','eck'),(3,'eck add entity types','eck'),(3,'eck administer bundles','eck'),(3,'eck administer commerce_store bundles','eck'),(3,'eck administer commerce_store store entities','eck'),(3,'eck administer entities','eck'),(3,'eck administer entity types','eck'),(3,'eck delete bundles','eck'),(3,'eck delete commerce_store bundles','eck'),(3,'eck delete commerce_store store entities','eck'),(3,'eck delete entities','eck'),(3,'eck delete entity types','eck'),(3,'eck edit bundles','eck'),(3,'eck edit commerce_store bundles','eck'),(3,'eck edit commerce_store store entities','eck'),(3,'eck edit entities','eck'),(3,'eck edit entity types','eck'),(3,'eck list bundles','eck'),(3,'eck list commerce_store bundles','eck'),(3,'eck list commerce_store store entities','eck'),(3,'eck list entities','eck'),(3,'eck list entity types','eck'),(3,'eck view commerce_store bundles','eck'),(3,'eck view commerce_store store entities','eck'),(3,'eck view entities','eck'),(3,'edit all webform submissions','webform'),(3,'edit any article content','node'),(3,'edit any commerce_customer_profile entity','commerce_customer'),(3,'edit any commerce_customer_profile entity of bundle billing','commerce_customer'),(3,'edit any commerce_order entity','commerce_order'),(3,'edit any commerce_order entity of bundle commerce_order','commerce_order'),(3,'edit any commerce_product entity','commerce_product'),(3,'edit any commerce_product entity of bundle product','commerce_product'),(3,'edit any deposit transactions','commerce_marketplace_funds'),(3,'edit any page content','node'),(3,'edit any transactions of any type','commerce_marketplace_funds'),(3,'edit any transfer transactions','commerce_marketplace_funds'),(3,'edit own article content','node'),(3,'edit own comments','comment'),(3,'edit own commerce_customer_profile entities','commerce_customer'),(3,'edit own commerce_customer_profile entities of bundle billing','commerce_customer'),(3,'edit own commerce_order entities','commerce_order'),(3,'edit own commerce_order entities of bundle commerce_order','commerce_order'),(3,'edit own commerce_product entities','commerce_product'),(3,'edit own commerce_product entities of bundle product','commerce_product'),(3,'edit own page content','node'),(3,'edit own webform submissions','webform'),(3,'edit terms in 1','taxonomy'),(3,'edit withdraw methods of any type','commerce_marketplace_funds_withdraw'),(3,'exclude any node title','exclude_node_title'),(3,'exclude own node title','exclude_node_title'),(3,'execute comment_publish_action','actions_permissions'),(3,'execute comment_save_action','actions_permissions'),(3,'execute comment_unpublish_action','actions_permissions'),(3,'execute comment_unpublish_by_keyword_action','actions_permissions'),(3,'execute node_assign_owner_action','actions_permissions'),(3,'execute node_make_sticky_action','actions_permissions'),(3,'execute node_make_unsticky_action','actions_permissions'),(3,'execute node_promote_action','actions_permissions'),(3,'execute node_publish_action','actions_permissions'),(3,'execute node_save_action','actions_permissions'),(3,'execute node_unpromote_action','actions_permissions'),(3,'execute node_unpublish_action','actions_permissions'),(3,'execute node_unpublish_by_keyword_action','actions_permissions'),(3,'execute php code','devel'),(3,'execute system_block_ip_action','actions_permissions'),(3,'execute system_goto_action','actions_permissions'),(3,'execute system_message_action','actions_permissions'),(3,'execute system_send_email_action','actions_permissions'),(3,'execute user_block_user_action','actions_permissions'),(3,'flush caches','admin_menu'),(3,'generate features','features'),(3,'make rule based changes to commerce_stock','commerce_stock'),(3,'manage commerce_store properties','eck'),(3,'manage features','features'),(3,'notify of path changes','pathauto'),(3,'post comments','comment'),(3,'rate content','fivestar'),(3,'rename features','features'),(3,'revert revisions','node'),(3,'search content','search'),(3,'select account cancellation method','user'),(3,'send newsletter','simplenews'),(3,'skip comment approval','comment'),(3,'subscribe to newsletters','simplenews'),(3,'switch shortcut sets','shortcut'),(3,'switch users','devel'),(3,'translate interface','locale'),(3,'update payments','commerce_payment'),(3,'use advanced search','search'),(3,'use exclude node title','exclude_node_title'),(3,'use PHP for settings','php'),(3,'use php in custom breadcrumbs','custom_breadcrumbs'),(3,'use search_api_sorts','search_api_sorts'),(3,'use text format filtered_html','filter'),(3,'use text format full_html','filter'),(3,'view any account withdraw methods overview page','commerce_marketplace_funds_withdraw'),(3,'view any cmp_funds_account of any type','commerce_marketplace_funds'),(3,'view any cmp_funds_transaction of any type','commerce_marketplace_funds'),(3,'view any commerce_customer_profile entity','commerce_customer'),(3,'view any commerce_customer_profile entity of bundle billing','commerce_customer'),(3,'view any commerce_order entity','commerce_order'),(3,'view any commerce_order entity of bundle commerce_order','commerce_order'),(3,'view any commerce_product entity','commerce_product'),(3,'view any commerce_product entity of bundle product','commerce_product'),(3,'view any commerce_store funds account','commerce_marketplace_funds'),(3,'view any commerce_store funds account transactions','commerce_marketplace_funds'),(3,'view any store','commerce_store_access'),(3,'view any user funds account','commerce_marketplace_funds'),(3,'view any user funds account transactions','commerce_marketplace_funds'),(3,'view icons','icon'),(3,'view own account withdraw methods overview page','commerce_marketplace_funds_withdraw'),(3,'view own commerce_customer_profile entities','commerce_customer'),(3,'view own commerce_customer_profile entities of bundle billing','commerce_customer'),(3,'view own commerce_order entities','commerce_order'),(3,'view own commerce_order entities of bundle commerce_order','commerce_order'),(3,'view own commerce_product entities','commerce_product'),(3,'view own commerce_product entities of bundle product','commerce_product'),(3,'view own commerce_store funds account','commerce_marketplace_funds'),(3,'view own commerce_store funds account transactions','commerce_marketplace_funds'),(3,'view own stores','commerce_marketplace'),(3,'view own unpublished content','node'),(3,'view own user funds account','commerce_marketplace_funds'),(3,'view own user funds account transactions','commerce_marketplace_funds'),(3,'view payments','commerce_payment'),(3,'view revisions','node'),(3,'view the administration theme','system'),(3,'view withdraw methods of any type','commerce_marketplace_funds_withdraw'),(4,'access administration menu','admin_menu'),(4,'access administration pages','system'),(4,'access checkout','commerce_checkout'),(4,'create commerce_order entities of bundle commerce_marketplace_order','commerce_order'),(4,'create commerce_order entities of bundle commerce_store_order','commerce_order'),(4,'create commerce_product entities','commerce_product'),(4,'create commerce_product entities of bundle product','commerce_product'),(4,'create new deposit transaction from any commerce_store funds account','commerce_marketplace_funds'),(4,'create new deposit transaction from any user funds account','commerce_marketplace_funds'),(4,'create new deposit transaction from own commerce_store funds account','commerce_marketplace_funds'),(4,'create new deposit transaction from own user funds account','commerce_marketplace_funds'),(4,'create new stores','commerce_store_access'),(4,'create new transfer transaction from own commerce_store funds account','commerce_marketplace_funds'),(4,'create new transfer transaction from own user funds account','commerce_marketplace_funds'),(4,'create product content','node'),(4,'delete own product content','node'),(4,'delete own stores','commerce_store_access'),(4,'eck list bundles','eck'),(4,'eck list commerce_store bundles','eck'),(4,'eck list commerce_store store entities','eck'),(4,'eck list entities','eck'),(4,'eck list entity types','eck'),(4,'eck view commerce_store bundles','eck'),(4,'eck view commerce_store store entities','eck'),(4,'eck view entities','eck'),(4,'edit any commerce_product entity of bundle product','commerce_product'),(4,'edit any transactions of any type','commerce_marketplace_funds'),(4,'edit own commerce_order entities of bundle commerce_marketplace_order','commerce_order'),(4,'edit own commerce_order entities of bundle commerce_store_order','commerce_order'),(4,'edit own commerce_product entities','commerce_product'),(4,'edit own commerce_product entities of bundle product','commerce_product'),(4,'edit own product content','node'),(4,'edit withdraw methods of any type','commerce_marketplace_funds_withdraw'),(4,'use exclude node title','exclude_node_title'),(4,'view any commerce_order entity','commerce_order'),(4,'view own account withdraw methods overview page','commerce_marketplace_funds_withdraw'),(4,'view own commerce_order entities','commerce_order'),(4,'view own commerce_order entities of bundle cmp_funds_deposit_order','commerce_order'),(4,'view own commerce_order entities of bundle commerce_marketplace_order','commerce_order'),(4,'view own commerce_order entities of bundle commerce_order','commerce_order'),(4,'view own commerce_order entities of bundle commerce_store_order','commerce_order'),(4,'view own commerce_product entities','commerce_product'),(4,'view own commerce_product entities of bundle product','commerce_product'),(4,'view own commerce_store funds account','commerce_marketplace_funds'),(4,'view own commerce_store funds account transactions','commerce_marketplace_funds'),(4,'view own stores','commerce_marketplace'),(4,'view own user funds account','commerce_marketplace_funds'),(4,'view own user funds account transactions','commerce_marketplace_funds'),(4,'view withdraw methods of any type','commerce_marketplace_funds_withdraw');
/*!40000 ALTER TABLE `role_permission` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `rules_config`
--

DROP TABLE IF EXISTS `rules_config`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rules_config` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The internal identifier for any configuration.',
  `name` varchar(64) NOT NULL COMMENT 'The name of the configuration.',
  `label` varchar(255) NOT NULL DEFAULT 'unlabeled' COMMENT 'The label of the configuration.',
  `plugin` varchar(127) NOT NULL COMMENT 'The name of the plugin of this configuration.',
  `active` int(11) NOT NULL DEFAULT '1' COMMENT 'Boolean indicating whether the configuration is active. Usage depends on how the using module makes use of it.',
  `weight` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Weight of the configuration. Usage depends on how the using module makes use of it.',
  `status` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'The exportable status of the entity.',
  `dirty` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Dirty configurations fail the integrity check, e.g. due to missing dependencies.',
  `module` varchar(255) DEFAULT NULL COMMENT 'The name of the providing module if the entity has been defined in code.',
  `owner` varchar(255) NOT NULL DEFAULT 'rules' COMMENT 'The name of the module via which the rule has been configured.',
  `access_exposed` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Whether to use a permission to control access for using components.',
  `data` longblob COMMENT 'Everything else, serialized.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`),
  KEY `plugin` (`plugin`)
) ENGINE=InnoDB AUTO_INCREMENT=29 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rules_config`
--

LOCK TABLES `rules_config` WRITE;
/*!40000 ALTER TABLE `rules_config` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `rules_config` VALUES (1,'commerce_cart_add_to_cart_message','Display an Add to Cart message','reaction rule',1,0,2,0,'commerce_cart','rules',0,'O:17:\"RulesReactionRule\":19:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:1:\"1\";s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:4:\"name\";s:33:\"commerce_cart_add_to_cart_message\";s:5:\"label\";s:30:\"Display an Add to Cart message\";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"active\";b:1;s:6:\"status\";i:2;s:6:\"module\";s:13:\"commerce_cart\";s:5:\"owner\";s:5:\"rules\";s:4:\"data\";r:1;s:4:\"tags\";a:1:{i:0;s:13:\"Commerce Cart\";}s:11:\"\0*\0children\";a:1:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:23:\"commerce_product:select\";s:16:\"commerce-product\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:33:\"commerce_cart_add_to_cart_message\";}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:0:{}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:1:{i:0;s:25:\"commerce_cart_product_add\";}s:16:\"\0*\0eventSettings\";a:0:{}}'),(2,'commerce_cart_order_status_reset','Reset the cart order status on product add or remove','reaction rule',1,0,2,0,'commerce_cart','rules',0,'O:17:\"RulesReactionRule\":19:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:1:\"2\";s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:4:\"name\";s:32:\"commerce_cart_order_status_reset\";s:5:\"label\";s:52:\"Reset the cart order status on product add or remove\";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"active\";b:1;s:6:\"status\";i:2;s:6:\"module\";s:13:\"commerce_cart\";s:5:\"owner\";s:5:\"rules\";s:4:\"data\";r:1;s:4:\"tags\";a:1:{i:0;s:13:\"Commerce Cart\";}s:11:\"\0*\0children\";a:1:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:21:\"commerce_order:select\";s:14:\"commerce-order\";s:12:\"order_status\";s:4:\"cart\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:28:\"commerce_order_update_status\";}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:0:{}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:2:{i:0;s:25:\"commerce_cart_product_add\";i:1;s:28:\"commerce_cart_product_remove\";}s:16:\"\0*\0eventSettings\";a:0:{}}'),(3,'commerce_cart_unset_disabled_products','Unset the price of disabled products in the cart','reaction rule',1,10,2,0,'commerce_cart','rules',0,'O:17:\"RulesReactionRule\":19:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:1:\"3\";s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:10;s:8:\"settings\";a:0:{}s:4:\"name\";s:37:\"commerce_cart_unset_disabled_products\";s:5:\"label\";s:48:\"Unset the price of disabled products in the cart\";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"active\";b:1;s:6:\"status\";i:2;s:6:\"module\";s:13:\"commerce_cart\";s:5:\"owner\";s:5:\"rules\";s:4:\"data\";r:1;s:4:\"tags\";a:1:{i:0;s:13:\"Commerce Cart\";}s:11:\"\0*\0children\";a:1:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:11:\"data:select\";s:45:\"commerce-line-item:commerce-unit-price:amount\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:8:\"data_set\";}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:3:{i:0;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:28;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:11:\"data:select\";s:31:\"commerce-line-item:line-item-id\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:13:\"data_is_empty\";s:9:\"\0*\0negate\";b:1;}i:1;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:28;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:13:\"entity:select\";s:18:\"commerce-line-item\";s:5:\"field\";s:16:\"commerce_product\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:16:\"entity_has_field\";s:9:\"\0*\0negate\";b:0;}i:2;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:28;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:11:\"data:select\";s:42:\"commerce-line-item:commerce-product:status\";s:2:\"op\";s:2:\"==\";s:5:\"value\";s:1:\"0\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:7:\"data_is\";s:9:\"\0*\0negate\";b:0;}}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:1:{i:0;s:37:\"commerce_product_calculate_sell_price\";}s:16:\"\0*\0eventSettings\";a:0:{}}'),(4,'commerce_checkout_order_created_date_update','Set the order created date to the checkout completion date','reaction rule',1,-10,2,0,'commerce_checkout','rules',0,'O:17:\"RulesReactionRule\":19:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:1:\"4\";s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:-10;s:8:\"settings\";a:0:{}s:4:\"name\";s:43:\"commerce_checkout_order_created_date_update\";s:5:\"label\";s:58:\"Set the order created date to the checkout completion date\";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"active\";b:1;s:6:\"status\";i:2;s:6:\"module\";s:17:\"commerce_checkout\";s:5:\"owner\";s:5:\"rules\";s:4:\"data\";r:1;s:4:\"tags\";a:1:{i:0;s:17:\"Commerce Checkout\";}s:11:\"\0*\0children\";a:1:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:11:\"data:select\";s:22:\"commerce-order:created\";s:12:\"value:select\";s:17:\"site:current-date\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:8:\"data_set\";}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:0:{}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:1:{i:0;s:26:\"commerce_checkout_complete\";}s:16:\"\0*\0eventSettings\";a:0:{}}'),(5,'commerce_checkout_order_status_update','Update the order status on checkout completion','reaction rule',1,0,2,0,'commerce_checkout','rules',0,'O:17:\"RulesReactionRule\":19:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:1:\"5\";s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:4:\"name\";s:37:\"commerce_checkout_order_status_update\";s:5:\"label\";s:46:\"Update the order status on checkout completion\";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"active\";b:1;s:6:\"status\";i:2;s:6:\"module\";s:17:\"commerce_checkout\";s:5:\"owner\";s:5:\"rules\";s:4:\"data\";r:1;s:4:\"tags\";a:1:{i:0;s:17:\"Commerce Checkout\";}s:11:\"\0*\0children\";a:1:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:21:\"commerce_order:select\";s:14:\"commerce-order\";s:11:\"order_state\";s:7:\"pending\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:27:\"commerce_order_update_state\";}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:0:{}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:1:{i:0;s:26:\"commerce_checkout_complete\";}s:16:\"\0*\0eventSettings\";a:0:{}}'),(6,'commerce_checkout_order_convert','Assign an anonymous order to a pre-existing user','reaction rule',1,1,2,0,'commerce_checkout','rules',0,'O:17:\"RulesReactionRule\":19:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:1:\"6\";s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:1;s:8:\"settings\";a:0:{}s:4:\"name\";s:31:\"commerce_checkout_order_convert\";s:5:\"label\";s:48:\"Assign an anonymous order to a pre-existing user\";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"active\";b:1;s:6:\"status\";i:2;s:6:\"module\";s:17:\"commerce_checkout\";s:5:\"owner\";s:5:\"rules\";s:4:\"data\";r:1;s:4:\"tags\";a:1:{i:0;s:17:\"Commerce Checkout\";}s:11:\"\0*\0children\";a:2:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:7:{s:4:\"type\";s:4:\"user\";s:8:\"property\";s:4:\"mail\";s:12:\"value:select\";s:19:\"commerce-order:mail\";s:5:\"limit\";i:1;s:20:\"entity_fetched:label\";s:15:\"Fetched account\";s:18:\"entity_fetched:var\";s:15:\"account_fetched\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:12:\"entity_query\";}i:1;O:9:\"RulesLoop\":7:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:11:\"list:select\";s:15:\"account-fetched\";s:8:\"item:var\";s:9:\"list_item\";s:10:\"item:label\";s:17:\"Current list item\";s:9:\"item:type\";s:4:\"user\";}s:11:\"\0*\0children\";a:3:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:32;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:11:\"data:select\";s:18:\"commerce-order:uid\";s:12:\"value:select\";s:13:\"list-item:uid\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:8:\"data_set\";}i:1;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:32;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:11:\"data:select\";s:44:\"commerce-order:commerce-customer-billing:uid\";s:12:\"value:select\";s:13:\"list-item:uid\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:8:\"data_set\";}i:2;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:32;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:11:\"data:select\";s:45:\"commerce-order:commerce-customer-shipping:uid\";s:12:\"value:select\";s:13:\"list-item:uid\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:8:\"data_set\";}}s:7:\"\0*\0info\";a:0:{}}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:3:{i:0;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:75;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:11:\"data:select\";s:18:\"commerce-order:uid\";s:2:\"op\";s:2:\"==\";s:5:\"value\";s:1:\"0\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:7:\"data_is\";s:9:\"\0*\0negate\";b:0;}i:1;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:75;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:4:\"type\";s:4:\"user\";s:8:\"property\";s:4:\"mail\";s:12:\"value:select\";s:19:\"commerce-order:mail\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:13:\"entity_exists\";s:9:\"\0*\0negate\";b:0;}i:2;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:75;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:11:\"data:select\";s:19:\"commerce-order:type\";s:2:\"op\";s:2:\"==\";s:5:\"value\";s:14:\"commerce_order\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:7:\"data_is\";s:9:\"\0*\0negate\";b:0;}}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:1:{i:0;s:26:\"commerce_checkout_complete\";}s:16:\"\0*\0eventSettings\";a:0:{}}'),(7,'commerce_checkout_new_account','Create a new account for an anonymous order','reaction rule',1,2,2,0,'commerce_checkout','rules',0,'O:17:\"RulesReactionRule\":19:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:1:\"7\";s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:2;s:8:\"settings\";a:0:{}s:4:\"name\";s:29:\"commerce_checkout_new_account\";s:5:\"label\";s:43:\"Create a new account for an anonymous order\";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"active\";b:1;s:6:\"status\";i:2;s:6:\"module\";s:17:\"commerce_checkout\";s:5:\"owner\";s:5:\"rules\";s:4:\"data\";r:1;s:4:\"tags\";a:1:{i:0;s:17:\"Commerce Checkout\";}s:11:\"\0*\0children\";a:5:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:6:{s:4:\"type\";s:4:\"user\";s:17:\"param_name:select\";s:28:\"commerce-order:mail-username\";s:17:\"param_mail:select\";s:19:\"commerce-order:mail\";s:20:\"entity_created:label\";s:15:\"Created account\";s:18:\"entity_created:var\";s:15:\"account_created\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:13:\"entity_create\";}i:1;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:11:\"data:select\";s:22:\"account-created:status\";s:5:\"value\";i:1;s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:8:\"data_set\";}i:2;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:11:\"data:select\";s:15:\"account-created\";s:9:\"immediate\";i:1;s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:11:\"entity_save\";}i:3;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:7:{s:4:\"type\";s:4:\"user\";s:8:\"property\";s:4:\"mail\";s:12:\"value:select\";s:19:\"commerce-order:mail\";s:5:\"limit\";i:1;s:20:\"entity_fetched:label\";s:15:\"Fetched account\";s:18:\"entity_fetched:var\";s:15:\"account_fetched\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:12:\"entity_query\";}i:4;O:9:\"RulesLoop\":7:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:11:\"list:select\";s:15:\"account-fetched\";s:8:\"item:var\";s:9:\"list_item\";s:10:\"item:label\";s:17:\"Current list item\";s:9:\"item:type\";s:4:\"user\";}s:11:\"\0*\0children\";a:4:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:65;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:14:\"account:select\";s:9:\"list-item\";s:10:\"email_type\";s:22:\"register_admin_created\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:18:\"send_account_email\";}i:1;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:65;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:11:\"data:select\";s:18:\"commerce-order:uid\";s:12:\"value:select\";s:13:\"list-item:uid\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:8:\"data_set\";}i:2;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:65;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:11:\"data:select\";s:44:\"commerce-order:commerce-customer-billing:uid\";s:12:\"value:select\";s:13:\"list-item:uid\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:8:\"data_set\";}i:3;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:65;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:11:\"data:select\";s:45:\"commerce-order:commerce-customer-shipping:uid\";s:12:\"value:select\";s:13:\"list-item:uid\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:8:\"data_set\";}}s:7:\"\0*\0info\";a:0:{}}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:3:{i:0;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:118;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:11:\"data:select\";s:18:\"commerce-order:uid\";s:2:\"op\";s:2:\"==\";s:5:\"value\";s:1:\"0\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:7:\"data_is\";s:9:\"\0*\0negate\";b:0;}i:1;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:118;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:4:\"type\";s:4:\"user\";s:8:\"property\";s:4:\"mail\";s:12:\"value:select\";s:19:\"commerce-order:mail\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:13:\"entity_exists\";s:9:\"\0*\0negate\";b:1;}i:2;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:118;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:11:\"data:select\";s:19:\"commerce-order:type\";s:2:\"op\";s:2:\"==\";s:5:\"value\";s:14:\"commerce_order\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:7:\"data_is\";s:9:\"\0*\0negate\";b:0;}}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:1:{i:0;s:26:\"commerce_checkout_complete\";}s:16:\"\0*\0eventSettings\";a:0:{}}'),(8,'commerce_checkout_order_email','Send an order notification e-mail','reaction rule',1,4,2,0,'commerce_checkout','rules',0,'O:17:\"RulesReactionRule\":19:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:1:\"8\";s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:4;s:8:\"settings\";a:0:{}s:4:\"name\";s:29:\"commerce_checkout_order_email\";s:5:\"label\";s:33:\"Send an order notification e-mail\";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"active\";b:1;s:6:\"status\";i:2;s:6:\"module\";s:17:\"commerce_checkout\";s:5:\"owner\";s:5:\"rules\";s:4:\"data\";r:1;s:4:\"tags\";a:1:{i:0;s:17:\"Commerce Checkout\";}s:11:\"\0*\0children\";a:1:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:5:{s:9:\"to:select\";s:19:\"commerce-order:mail\";s:7:\"subject\";s:50:\"Order [commerce-order:order-number] at [site:name]\";s:7:\"message\";s:412:\"Thanks for your order [commerce-order:order-number] at [site:name].\n\nIf this is your first order with us, you will receive a separate e-mail with login instructions. You can view your order history with us at any time by logging into our website at:\n\n[site:login-url]\n\nYou can find the status of your current order at:\n\n[commerce-order:customer-url]\n\nPlease contact us if you have any questions about your order.\";s:4:\"from\";s:0:\"\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:4:\"mail\";}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:0:{}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:1:{i:0;s:26:\"commerce_checkout_complete\";}s:16:\"\0*\0eventSettings\";a:0:{}}'),(9,'commerce_shipping_cart_update_delete','Delete shipping line items on shopping cart updates','reaction rule',1,0,2,0,'commerce_shipping','rules',0,'O:17:\"RulesReactionRule\":18:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:1:\"9\";s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:4:\"name\";s:36:\"commerce_shipping_cart_update_delete\";s:5:\"label\";s:51:\"Delete shipping line items on shopping cart updates\";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"active\";b:1;s:6:\"status\";i:2;s:6:\"module\";s:17:\"commerce_shipping\";s:5:\"owner\";s:5:\"rules\";s:4:\"data\";r:1;s:11:\"\0*\0children\";a:1:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:21:\"commerce_order:select\";s:14:\"commerce-order\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:44:\"commerce_shipping_delete_shipping_line_items\";}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:2:{i:0;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:26;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:11:\"data:select\";s:21:\"commerce-order:status\";s:2:\"op\";s:2:\"==\";s:5:\"value\";s:4:\"cart\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:7:\"data_is\";s:9:\"\0*\0negate\";b:0;}i:1;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:26;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:11:\"data:select\";s:31:\"commerce-order-unchanged:status\";s:2:\"op\";s:2:\"==\";s:5:\"value\";s:4:\"cart\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:7:\"data_is\";s:9:\"\0*\0negate\";b:1;}}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:1:{i:0;s:21:\"commerce_order_update\";}s:16:\"\0*\0eventSettings\";a:0:{}}'),(10,'commerce_payment_paypal_wps','PayPal WPS','reaction rule',1,0,3,0,'commerce_payment','rules',0,'O:17:\"RulesReactionRule\":21:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:2:\"10\";s:12:\"\0*\0elementId\";i:1;s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:0:{}s:4:\"name\";s:27:\"commerce_payment_paypal_wps\";s:5:\"label\";s:10:\"PayPal WPS\";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"active\";s:1:\"1\";s:6:\"status\";i:3;s:5:\"dirty\";b:0;s:6:\"module\";s:16:\"commerce_payment\";s:5:\"owner\";s:5:\"rules\";s:14:\"access_exposed\";s:1:\"0\";s:4:\"data\";r:1;s:4:\"tags\";a:1:{i:0;s:16:\"Commerce Payment\";}s:11:\"\0*\0children\";a:1:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:3;s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:21:\"commerce_order:select\";s:14:\"commerce-order\";s:14:\"payment_method\";a:2:{s:9:\"method_id\";s:10:\"paypal_wps\";s:8:\"settings\";a:10:{s:8:\"business\";s:34:\"lpmthong.dev-facilitator@gmail.com\";s:13:\"currency_code\";s:3:\"USD\";s:26:\"allow_supported_currencies\";i:0;s:8:\"language\";s:2:\"US\";s:6:\"server\";s:7:\"sandbox\";s:14:\"payment_action\";s:4:\"sale\";s:11:\"ipn_logging\";s:12:\"notification\";s:15:\"receiver_emails\";s:0:\"\";s:26:\"ipn_create_billing_profile\";i:0;s:25:\"show_payment_instructions\";i:0;}}}s:14:\"\0*\0elementName\";s:34:\"commerce_payment_enable_paypal_wps\";}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:2;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:0:{}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:1:{i:0;s:24:\"commerce_payment_methods\";}s:16:\"\0*\0eventSettings\";a:0:{}}'),(11,'commerce_payment_bank_transfer','Bank Transfer','reaction rule',1,0,3,0,'commerce_payment','rules',0,'O:17:\"RulesReactionRule\":21:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:2:\"11\";s:12:\"\0*\0elementId\";i:1;s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:0:{}s:4:\"name\";s:30:\"commerce_payment_bank_transfer\";s:5:\"label\";s:13:\"Bank Transfer\";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"active\";s:1:\"1\";s:6:\"status\";i:3;s:5:\"dirty\";b:0;s:6:\"module\";s:16:\"commerce_payment\";s:5:\"owner\";s:5:\"rules\";s:14:\"access_exposed\";s:1:\"0\";s:4:\"data\";r:1;s:4:\"tags\";a:1:{i:0;s:16:\"Commerce Payment\";}s:11:\"\0*\0children\";a:1:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:3;s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:21:\"commerce_order:select\";s:14:\"commerce-order\";s:14:\"payment_method\";a:2:{s:9:\"method_id\";s:13:\"bank_transfer\";s:8:\"settings\";a:1:{s:11:\"information\";a:2:{s:5:\"value\";s:153:\"<p>\r\n        <strong>Please make payment to:</strong><br />\r\n        Account owner:Weebpal<br />\r\n        Account number: 31101100011<br />\r\n        </p>\";s:6:\"format\";s:13:\"filtered_html\";}}}}s:14:\"\0*\0elementName\";s:37:\"commerce_payment_enable_bank_transfer\";}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:2;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:0:{}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:1:{i:0;s:24:\"commerce_payment_methods\";}s:16:\"\0*\0eventSettings\";a:0:{}}'),(12,'commerce_payment_commerce_cod','Cash on Delivery','reaction rule',1,0,2,0,'commerce_payment','rules',0,'O:17:\"RulesReactionRule\":19:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:2:\"12\";s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:4:\"name\";s:29:\"commerce_payment_commerce_cod\";s:5:\"label\";s:16:\"Cash on Delivery\";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"active\";s:1:\"1\";s:6:\"status\";i:2;s:6:\"module\";s:16:\"commerce_payment\";s:5:\"owner\";s:5:\"rules\";s:4:\"data\";r:1;s:4:\"tags\";a:1:{i:0;s:16:\"Commerce Payment\";}s:11:\"\0*\0children\";a:1:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:21:\"commerce_order:select\";s:14:\"commerce-order\";s:14:\"payment_method\";s:12:\"commerce_cod\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:36:\"commerce_payment_enable_commerce_cod\";}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:0:{}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:1:{i:0;s:24:\"commerce_payment_methods\";}s:16:\"\0*\0eventSettings\";a:0:{}}'),(13,'rules_decrement_stock_completing_order','Stock: Decrease when completing the order process','reaction rule',1,0,2,0,'commerce_ss','rules',0,'O:17:\"RulesReactionRule\":18:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:2:\"13\";s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:4:\"name\";s:38:\"rules_decrement_stock_completing_order\";s:5:\"label\";s:49:\"Stock: Decrease when completing the order process\";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"status\";i:2;s:6:\"module\";s:11:\"commerce_ss\";s:5:\"owner\";s:5:\"rules\";s:4:\"data\";r:1;s:4:\"tags\";a:1:{i:0;s:13:\"stock_control\";}s:11:\"\0*\0children\";a:1:{i:0;O:9:\"RulesLoop\":7:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:8:\"item:var\";s:9:\"list_item\";s:10:\"item:label\";s:17:\"Current list item\";s:11:\"list:select\";s:34:\"commerce-order:commerce-line-items\";}s:11:\"\0*\0children\";a:1:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:17;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:18:\"#_needs_processing\";b:1;s:25:\"commerce_line_item:select\";s:9:\"list-item\";}s:14:\"\0*\0elementName\";s:33:\"commerce_ss_decrease_by_line_item\";}}s:7:\"\0*\0info\";a:0:{}}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:0:{}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:1:{i:0;s:26:\"commerce_checkout_complete\";}s:16:\"\0*\0eventSettings\";a:0:{}}'),(14,'rules_stock_disable_add_to_cart','Stock: disable add to cart ','reaction rule',1,0,2,0,'commerce_ssr','rules',0,'O:17:\"RulesReactionRule\":17:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:2:\"14\";s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:4:\"name\";s:31:\"rules_stock_disable_add_to_cart\";s:5:\"label\";s:27:\"Stock: disable add to cart \";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"status\";i:2;s:6:\"module\";s:12:\"commerce_ssr\";s:5:\"owner\";s:5:\"rules\";s:4:\"data\";r:1;s:11:\"\0*\0children\";a:1:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:18:\"#_needs_processing\";b:1;s:8:\"disabled\";i:1;s:4:\"text\";s:12:\"Out of stock\";s:10:\"class_name\";s:12:\"out-of-stock\";}s:14:\"\0*\0elementName\";s:41:\"commerce_stock_set_add_to_cart_form_state\";}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:3:{i:0;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:27;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:18:\"#_needs_processing\";b:1;s:23:\"commerce_product:select\";s:16:\"commerce_product\";}s:14:\"\0*\0elementName\";s:36:\"commerce_ss_stock_enabled_on_product\";s:9:\"\0*\0negate\";b:0;}i:1;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:27;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:18:\"#_needs_processing\";b:1;s:23:\"commerce_product:select\";s:16:\"commerce_product\";}s:14:\"\0*\0elementName\";s:30:\"commerce_ss_stock_not_disabled\";s:9:\"\0*\0negate\";b:0;}i:2;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:27;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:18:\"#_needs_processing\";b:1;s:11:\"data:select\";s:31:\"commerce-product:commerce-stock\";s:2:\"op\";s:1:\">\";s:5:\"value\";s:1:\"0\";}s:14:\"\0*\0elementName\";s:7:\"data_is\";s:9:\"\0*\0negate\";b:1;}}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:1:{i:0;s:43:\"commerce_stock_check_add_to_cart_form_state\";}s:16:\"\0*\0eventSettings\";a:0:{}}'),(15,'rules_stock_validate_add_to_cart','Stock: validate add to cart','reaction rule',1,0,2,0,'commerce_ssr','rules',0,'O:17:\"RulesReactionRule\":17:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:2:\"15\";s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:4:\"name\";s:32:\"rules_stock_validate_add_to_cart\";s:5:\"label\";s:27:\"Stock: validate add to cart\";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"status\";i:2;s:6:\"module\";s:12:\"commerce_ssr\";s:5:\"owner\";s:5:\"rules\";s:4:\"data\";r:1;s:11:\"\0*\0children\";a:2:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:6:{s:18:\"#_needs_processing\";b:1;s:14:\"input_1:select\";s:31:\"commerce-product:commerce-stock\";s:2:\"op\";s:1:\"-\";s:14:\"input_2:select\";s:21:\"stock-already-ordered\";s:10:\"result:var\";s:17:\"approved_quantity\";s:12:\"result:label\";s:17:\"approved quantity\";}s:14:\"\0*\0elementName\";s:9:\"data_calc\";}i:1;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:18:\"#_needs_processing\";b:1;s:12:\"stock_action\";s:1:\"1\";s:7:\"message\";s:113:\"The maximum quantity for [commerce-product:title] that can be ordered is [commerce-product:commerce-stock-int].\r\n\";s:24:\"approved_quantity:select\";s:17:\"approved-quantity\";}s:14:\"\0*\0elementName\";s:36:\"commerce_stock_add_to_cart_set_state\";}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:3:{i:0;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:40;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:18:\"#_needs_processing\";b:1;s:23:\"commerce_product:select\";s:16:\"commerce_product\";}s:14:\"\0*\0elementName\";s:36:\"commerce_ss_stock_enabled_on_product\";s:9:\"\0*\0negate\";b:0;}i:1;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:40;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:18:\"#_needs_processing\";b:1;s:23:\"commerce_product:select\";s:16:\"commerce_product\";}s:14:\"\0*\0elementName\";s:30:\"commerce_ss_stock_not_disabled\";s:9:\"\0*\0negate\";b:0;}i:2;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:40;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:18:\"#_needs_processing\";b:1;s:11:\"data:select\";s:21:\"stock-requested-total\";s:2:\"op\";s:1:\">\";s:12:\"value:select\";s:31:\"commerce-product:commerce-stock\";}s:14:\"\0*\0elementName\";s:7:\"data_is\";s:9:\"\0*\0negate\";b:0;}}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:1:{i:0;s:40:\"commerce_stock_add_to_cart_check_product\";}s:16:\"\0*\0eventSettings\";a:0:{}}'),(16,'rules_stock_validate_checkout','Stock: validate checkout','reaction rule',1,0,2,0,'commerce_ssr','rules',0,'O:17:\"RulesReactionRule\":17:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:2:\"16\";s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:4:\"name\";s:29:\"rules_stock_validate_checkout\";s:5:\"label\";s:24:\"Stock: validate checkout\";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"status\";i:2;s:6:\"module\";s:12:\"commerce_ssr\";s:5:\"owner\";s:5:\"rules\";s:4:\"data\";r:1;s:11:\"\0*\0children\";a:1:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:18:\"#_needs_processing\";b:1;s:12:\"stock_action\";s:1:\"1\";s:7:\"message\";s:111:\"The maximum quantity for [commerce-product:title] that can be ordered is [commerce-product:commerce-stock-int].\";s:24:\"approved_quantity:select\";s:31:\"commerce-product:commerce-stock\";}s:14:\"\0*\0elementName\";s:29:\"commerce_stock_checkout_state\";}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:3:{i:0;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:27;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:18:\"#_needs_processing\";b:1;s:23:\"commerce_product:select\";s:16:\"commerce_product\";}s:14:\"\0*\0elementName\";s:36:\"commerce_ss_stock_enabled_on_product\";s:9:\"\0*\0negate\";b:0;}i:1;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:27;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:18:\"#_needs_processing\";b:1;s:23:\"commerce_product:select\";s:16:\"commerce_product\";}s:14:\"\0*\0elementName\";s:30:\"commerce_ss_stock_not_disabled\";s:9:\"\0*\0negate\";b:0;}i:2;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:27;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:18:\"#_needs_processing\";b:1;s:11:\"data:select\";s:21:\"stock-already-ordered\";s:2:\"op\";s:1:\">\";s:12:\"value:select\";s:31:\"commerce-product:commerce-stock\";}s:14:\"\0*\0elementName\";s:7:\"data_is\";s:9:\"\0*\0negate\";b:0;}}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:1:{i:0;s:37:\"commerce_stock_check_product_checkout\";}s:16:\"\0*\0eventSettings\";a:0:{}}'),(17,'rules_create_funds_payment_transaction_for_store_order','Create funds payment transaction for store order','rule',1,0,2,0,'commerce_marketplace_funds','rules',0,'O:4:\"Rule\":15:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:2:\"17\";s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:4:\"name\";s:54:\"rules_create_funds_payment_transaction_for_store_order\";s:5:\"label\";s:48:\"Create funds payment transaction for store order\";s:6:\"plugin\";s:4:\"rule\";s:6:\"status\";i:2;s:6:\"module\";s:26:\"commerce_marketplace_funds\";s:5:\"owner\";s:5:\"rules\";s:4:\"data\";r:1;s:11:\"\0*\0children\";a:6:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:5:{s:10:\"owner_type\";s:14:\"commerce_store\";s:15:\"owner_id:select\";s:20:\"order:cmp-o-store:id\";s:19:\"funds_account:label\";s:13:\"Funds account\";s:17:\"funds_account:var\";s:13:\"funds_account\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:54:\"commerce_marketplace_funds_rules_account_load_by_owner\";}i:1;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:10:{s:16:\"transaction_type\";s:7:\"payment\";s:13:\"amount:select\";s:33:\"order:commerce-order-total:amount\";s:10:\"originator\";N;s:18:\"destination:select\";s:13:\"funds-account\";s:12:\"order:select\";s:5:\"order\";s:5:\"notes\";s:94:\"Created for original order #[order:cmp_order:order_id] placed by [order:cmp_order:owner:name].\";s:6:\"status\";s:7:\"success\";s:17:\"transaction:label\";s:11:\"Transaction\";s:15:\"transaction:var\";s:11:\"transaction\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:51:\"commerce_marketplace_funds_rules_create_transaction\";}i:2;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:18:\"transaction:select\";s:11:\"transaction\";s:8:\"fee_type\";s:7:\"percent\";s:3:\"fee\";d:0.050000000000000003;s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:55:\"commerce_marketplace_funds_rules_apply_transaction_fees\";}i:3;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:11:\"data:select\";s:11:\"transaction\";s:9:\"immediate\";i:1;s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:11:\"entity_save\";}i:4;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:18:\"transaction:select\";s:11:\"transaction\";s:18:\"destination:select\";s:13:\"funds-account\";s:10:\"originator\";N;s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:62:\"commerce_marketplace_funds_rules_apply_transaction_to_accounts\";}i:5;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:11:\"data:select\";s:13:\"funds-account\";s:9:\"immediate\";i:1;s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:11:\"entity_save\";}}s:7:\"\0*\0info\";a:1:{s:9:\"variables\";a:1:{s:5:\"order\";a:2:{s:4:\"type\";s:14:\"commerce_order\";s:5:\"label\";s:5:\"Order\";}}}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:1:{i:0;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:91;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:11:\"data:select\";s:10:\"order:type\";s:2:\"op\";s:2:\"==\";s:5:\"value\";s:20:\"commerce_store_order\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:7:\"data_is\";s:9:\"\0*\0negate\";b:0;}}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}}'),(18,'rules_make_payments_to_stores','Make payments to stores','reaction rule',1,0,2,0,'commerce_marketplace_funds','rules',0,'O:17:\"RulesReactionRule\":18:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:2:\"18\";s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:4:\"name\";s:29:\"rules_make_payments_to_stores\";s:5:\"label\";s:23:\"Make payments to stores\";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"active\";b:1;s:6:\"status\";i:2;s:6:\"module\";s:26:\"commerce_marketplace_funds\";s:5:\"owner\";s:5:\"rules\";s:4:\"data\";r:1;s:11:\"\0*\0children\";a:2:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:24:\"marketplace_order:select\";s:14:\"commerce-order\";s:18:\"store_orders:label\";s:12:\"Store orders\";s:16:\"store_orders:var\";s:12:\"store_orders\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:67:\"commerce_marketplace_order_load_store_orders_from_marketplace_order\";}i:1;O:9:\"RulesLoop\":7:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:11:\"list:select\";s:12:\"store-orders\";s:8:\"item:var\";s:11:\"store_order\";s:10:\"item:label\";s:11:\"Store order\";s:9:\"item:type\";s:14:\"commerce_order\";}s:11:\"\0*\0children\";a:1:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:27;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:12:\"order:select\";s:11:\"store-order\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:64:\"component_rules_create_funds_payment_transaction_for_store_order\";}}s:7:\"\0*\0info\";a:0:{}}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:1:{i:0;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:49;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:11:\"data:select\";s:19:\"commerce-order:type\";s:2:\"op\";s:2:\"==\";s:5:\"value\";s:26:\"commerce_marketplace_order\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:7:\"data_is\";s:9:\"\0*\0negate\";b:0;}}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:1:{i:0;s:35:\"commerce_payment_order_paid_in_full\";}s:16:\"\0*\0eventSettings\";a:0:{}}'),(19,'rules_complete_deposit_process','Complete deposit process','reaction rule',1,0,2,0,'commerce_marketplace_funds','rules',0,'O:17:\"RulesReactionRule\":18:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:2:\"19\";s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:4:\"name\";s:30:\"rules_complete_deposit_process\";s:5:\"label\";s:24:\"Complete deposit process\";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"active\";b:1;s:6:\"status\";i:2;s:6:\"module\";s:26:\"commerce_marketplace_funds\";s:5:\"owner\";s:5:\"rules\";s:4:\"data\";r:1;s:11:\"\0*\0children\";a:6:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:12:\"order:select\";s:14:\"commerce-order\";s:23:\"funds_transaction:label\";s:17:\"Funds transaction\";s:21:\"funds_transaction:var\";s:17:\"funds_transaction\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:62:\"commerce_marketplace_funds_load_deposit_transaction_from_order\";}i:1;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:11:\"data:select\";s:24:\"funds-transaction:status\";s:5:\"value\";s:7:\"success\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:8:\"data_set\";}i:2;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:11:\"data:select\";s:17:\"funds-transaction\";s:9:\"immediate\";i:1;s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:11:\"entity_save\";}i:3;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:5:{s:4:\"type\";s:17:\"cmp_funds_account\";s:12:\"value:select\";s:37:\"funds-transaction:destination-account\";s:20:\"variable_added:label\";s:19:\"Destination account\";s:18:\"variable_added:var\";s:19:\"destination_account\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:12:\"variable_add\";}i:4;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:18:\"transaction:select\";s:17:\"funds-transaction\";s:18:\"destination:select\";s:19:\"destination-account\";s:10:\"originator\";N;s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:62:\"commerce_marketplace_funds_rules_apply_transaction_to_accounts\";}i:5;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:11:\"data:select\";s:19:\"destination-account\";s:9:\"immediate\";i:1;s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:11:\"entity_save\";}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:1:{i:0;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:81;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:11:\"data:select\";s:19:\"commerce-order:type\";s:2:\"op\";s:2:\"==\";s:5:\"value\";s:23:\"cmp_funds_deposit_order\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:7:\"data_is\";s:9:\"\0*\0negate\";b:0;}}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:1:{i:0;s:26:\"commerce_checkout_complete\";}s:16:\"\0*\0eventSettings\";a:0:{}}'),(20,'rules_apply_fees_on_deposit','Apply Fees on deposit','reaction rule',1,0,2,0,'commerce_marketplace_funds','rules',0,'O:17:\"RulesReactionRule\":18:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:2:\"20\";s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:4:\"name\";s:27:\"rules_apply_fees_on_deposit\";s:5:\"label\";s:21:\"Apply Fees on deposit\";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"active\";b:1;s:6:\"status\";i:2;s:6:\"module\";s:26:\"commerce_marketplace_funds\";s:5:\"owner\";s:5:\"rules\";s:4:\"data\";r:1;s:11:\"\0*\0children\";a:2:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:18:\"transaction:select\";s:21:\"cmp-funds-transaction\";s:8:\"fee_type\";s:7:\"percent\";s:3:\"fee\";s:4:\"0.05\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:55:\"commerce_marketplace_funds_rules_apply_transaction_fees\";}i:1;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:11:\"data:select\";s:21:\"cmp-funds-transaction\";s:9:\"immediate\";i:1;s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:11:\"entity_save\";}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:1:{i:0;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:38;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:13:\"entity:select\";s:21:\"cmp-funds-transaction\";s:4:\"type\";s:21:\"cmp_funds_transaction\";s:6:\"bundle\";s:7:\"deposit\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:19:\"entity_is_of_bundle\";s:9:\"\0*\0negate\";b:0;}}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:1:{i:0;s:28:\"cmp_funds_transaction_insert\";}s:16:\"\0*\0eventSettings\";a:0:{}}'),(21,'rules_calculate_discount_percentage','Calculate Discount Percentage','reaction rule',1,0,1,0,'rules','rules',0,'O:17:\"RulesReactionRule\":21:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:2:\"21\";s:12:\"\0*\0elementId\";i:1;s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:0:{}s:4:\"name\";s:35:\"rules_calculate_discount_percentage\";s:5:\"label\";s:29:\"Calculate Discount Percentage\";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"active\";s:1:\"1\";s:6:\"status\";s:1:\"1\";s:5:\"dirty\";b:0;s:6:\"module\";s:5:\"rules\";s:5:\"owner\";s:5:\"rules\";s:14:\"access_exposed\";s:1:\"0\";s:4:\"data\";r:1;s:4:\"tags\";a:0:{}s:11:\"\0*\0children\";a:4:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:4;s:6:\"weight\";i:0;s:8:\"settings\";a:5:{s:14:\"input_1:select\";s:47:\"commerce-product:field-old-price:amount-decimal\";s:2:\"op\";s:1:\"-\";s:14:\"input_2:select\";s:46:\"commerce-product:commerce-price:amount-decimal\";s:12:\"result:label\";s:18:\"Calculation result\";s:10:\"result:var\";s:9:\"subresult\";}s:14:\"\0*\0elementName\";s:9:\"data_calc\";}i:1;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:5;s:6:\"weight\";i:1;s:8:\"settings\";a:5:{s:14:\"input_1:select\";s:9:\"subresult\";s:2:\"op\";s:1:\"/\";s:14:\"input_2:select\";s:47:\"commerce-product:field-old-price:amount-decimal\";s:12:\"result:label\";s:18:\"Calculation result\";s:10:\"result:var\";s:9:\"divresult\";}s:14:\"\0*\0elementName\";s:9:\"data_calc\";}i:2;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:7;s:6:\"weight\";i:2;s:8:\"settings\";a:5:{s:14:\"input_1:select\";s:9:\"divresult\";s:2:\"op\";s:1:\"*\";s:7:\"input_2\";s:3:\"100\";s:12:\"result:label\";s:18:\"Calculation result\";s:10:\"result:var\";s:7:\"percent\";}s:14:\"\0*\0elementName\";s:9:\"data_calc\";}i:3;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:8;s:6:\"weight\";i:3;s:8:\"settings\";a:2:{s:11:\"data:select\";s:42:\"commerce-product:field-discount-percentage\";s:12:\"value:select\";s:7:\"percent\";}s:14:\"\0*\0elementName\";s:8:\"data_set\";}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:2;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:2:{i:0;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:65;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:3;s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:13:\"entity:select\";s:16:\"commerce-product\";s:5:\"field\";s:15:\"field_old_price\";}s:14:\"\0*\0elementName\";s:16:\"entity_has_field\";s:9:\"\0*\0negate\";b:0;}i:1;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:65;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:6;s:6:\"weight\";i:1;s:8:\"settings\";a:2:{s:13:\"entity:select\";s:16:\"commerce-product\";s:5:\"field\";s:25:\"field_discount_percentage\";}s:14:\"\0*\0elementName\";s:16:\"entity_has_field\";s:9:\"\0*\0negate\";b:0;}}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:1:{i:0;s:24:\"commerce_product_presave\";}s:16:\"\0*\0eventSettings\";a:0:{}}'),(22,'rules_calculate_discount_percentage_null','Calculate Discount Percentage (Null)','reaction rule',1,1,1,0,'rules','rules',0,'O:17:\"RulesReactionRule\":21:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:2:\"22\";s:12:\"\0*\0elementId\";i:1;s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}s:4:\"name\";s:40:\"rules_calculate_discount_percentage_null\";s:5:\"label\";s:36:\"Calculate Discount Percentage (Null)\";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"active\";s:1:\"1\";s:6:\"status\";s:1:\"1\";s:5:\"dirty\";b:0;s:6:\"module\";s:5:\"rules\";s:5:\"owner\";s:5:\"rules\";s:14:\"access_exposed\";s:1:\"0\";s:4:\"data\";r:1;s:4:\"tags\";a:0:{}s:11:\"\0*\0children\";a:1:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:5;s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:11:\"data:select\";s:42:\"commerce-product:field-discount-percentage\";s:5:\"value\";N;}s:14:\"\0*\0elementName\";s:8:\"data_set\";}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:2;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:5:{i:0;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:29;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:3;s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:13:\"entity:select\";s:16:\"commerce-product\";s:5:\"field\";s:25:\"field_discount_percentage\";}s:14:\"\0*\0elementName\";s:16:\"entity_has_field\";s:9:\"\0*\0negate\";b:0;}i:1;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:29;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:4;s:6:\"weight\";i:1;s:8:\"settings\";a:1:{s:11:\"data:select\";s:42:\"commerce-product:field-discount-percentage\";}s:14:\"\0*\0elementName\";s:13:\"data_is_empty\";s:9:\"\0*\0negate\";b:0;}i:2;O:7:\"RulesOr\":8:{s:9:\"\0*\0parent\";r:29;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:6;s:6:\"weight\";i:2;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:0:{}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}i:3;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:29;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:7;s:6:\"weight\";i:3;s:8:\"settings\";a:2:{s:13:\"entity:select\";s:16:\"commerce-product\";s:5:\"field\";s:15:\"field_old_price\";}s:14:\"\0*\0elementName\";s:16:\"entity_has_field\";s:9:\"\0*\0negate\";b:0;}i:4;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:29;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:8;s:6:\"weight\";i:4;s:8:\"settings\";a:1:{s:11:\"data:select\";s:39:\"commerce-product:field-old-price:amount\";}s:14:\"\0*\0elementName\";s:13:\"data_is_empty\";s:9:\"\0*\0negate\";b:0;}}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:1:{i:0;s:24:\"commerce_product_presave\";}s:16:\"\0*\0eventSettings\";a:0:{}}'),(23,'rules_update_the_order_status_on_checkout_completion_if_payment','Update the order status on checkout completion (if payment complete)','reaction rule',1,1,1,0,'rules','rules',0,'O:17:\"RulesReactionRule\":21:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:2:\"23\";s:12:\"\0*\0elementId\";i:1;s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}s:4:\"name\";s:63:\"rules_update_the_order_status_on_checkout_completion_if_payment\";s:5:\"label\";s:68:\"Update the order status on checkout completion (if payment complete)\";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"active\";s:1:\"1\";s:6:\"status\";s:1:\"1\";s:5:\"dirty\";b:0;s:6:\"module\";s:5:\"rules\";s:5:\"owner\";s:5:\"rules\";s:14:\"access_exposed\";s:1:\"0\";s:4:\"data\";r:1;s:4:\"tags\";a:1:{i:0;s:17:\"Commerce Checkout\";}s:11:\"\0*\0children\";a:1:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:4;s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:21:\"commerce_order:select\";s:14:\"commerce_order\";s:12:\"order_status\";s:9:\"completed\";}s:14:\"\0*\0elementName\";s:28:\"commerce_order_update_status\";}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:2;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:1:{i:0;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:30;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:3;s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:21:\"commerce_order:select\";s:14:\"commerce_order\";s:5:\"value\";s:1:\"0\";}s:14:\"\0*\0elementName\";s:41:\"commerce_payment_order_balance_comparison\";s:9:\"\0*\0negate\";b:0;}}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:1:{i:0;s:26:\"commerce_checkout_complete\";}s:16:\"\0*\0eventSettings\";a:0:{}}'),(24,'rules_order_paid_in_full_order_state_to_processing','Order paid in full: Order state to processing','reaction rule',1,1,1,0,'rules','rules',0,'O:17:\"RulesReactionRule\":21:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:2:\"24\";s:12:\"\0*\0elementId\";i:1;s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}s:4:\"name\";s:50:\"rules_order_paid_in_full_order_state_to_processing\";s:5:\"label\";s:45:\"Order paid in full: Order state to processing\";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"active\";s:1:\"1\";s:6:\"status\";s:1:\"1\";s:5:\"dirty\";b:0;s:6:\"module\";s:5:\"rules\";s:5:\"owner\";s:5:\"rules\";s:14:\"access_exposed\";s:1:\"0\";s:4:\"data\";r:1;s:4:\"tags\";a:0:{}s:11:\"\0*\0children\";a:1:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:4;s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:21:\"commerce_order:select\";s:14:\"commerce_order\";s:12:\"order_status\";s:9:\"completed\";}s:14:\"\0*\0elementName\";s:28:\"commerce_order_update_status\";}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:2;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:1:{i:0;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:29;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:3;s:6:\"weight\";i:0;s:8:\"settings\";a:1:{s:21:\"commerce_order:select\";s:14:\"commerce_order\";}s:14:\"\0*\0elementName\";s:22:\"commerce_order_is_cart\";s:9:\"\0*\0negate\";b:1;}}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:1:{i:0;s:35:\"commerce_payment_order_paid_in_full\";}s:16:\"\0*\0eventSettings\";a:0:{}}'),(25,'commerce_shipping_method_flat_rate','Collect rates: Flat rate','reaction rule',1,0,2,0,'commerce_shipping','rules',0,'O:17:\"RulesReactionRule\":18:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:2:\"25\";s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:4:\"name\";s:34:\"commerce_shipping_method_flat_rate\";s:5:\"label\";s:24:\"Collect rates: Flat rate\";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"active\";b:1;s:6:\"status\";i:2;s:6:\"module\";s:17:\"commerce_shipping\";s:5:\"owner\";s:5:\"rules\";s:4:\"data\";r:1;s:11:\"\0*\0children\";a:1:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:20:\"shipping_method_name\";s:9:\"flat_rate\";s:21:\"commerce_order:select\";s:14:\"commerce-order\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:38:\"commerce_shipping_method_collect_rates\";}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:1:{i:0;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:27;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:11:\"data:select\";s:19:\"commerce-order:type\";s:2:\"op\";s:2:\"==\";s:5:\"value\";s:23:\"cmp_funds_deposit_order\";s:18:\"#_needs_processing\";b:1;}s:14:\"\0*\0elementName\";s:7:\"data_is\";s:9:\"\0*\0negate\";b:1;}}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:1:{i:0;s:31:\"commerce_shipping_collect_rates\";}s:16:\"\0*\0eventSettings\";a:0:{}}'),(26,'commerce_shipping_service_free_shipping','Rate Free Shipping','rule',1,0,3,0,'commerce_shipping','rules',0,'O:4:\"Rule\":19:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:2:\"26\";s:12:\"\0*\0elementId\";i:1;s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:0:{}s:4:\"name\";s:39:\"commerce_shipping_service_free_shipping\";s:5:\"label\";s:18:\"Rate Free Shipping\";s:6:\"plugin\";s:4:\"rule\";s:6:\"active\";s:1:\"1\";s:6:\"status\";i:3;s:5:\"dirty\";b:0;s:6:\"module\";s:17:\"commerce_shipping\";s:5:\"owner\";s:5:\"rules\";s:14:\"access_exposed\";s:1:\"0\";s:4:\"data\";r:1;s:4:\"tags\";a:0:{}s:11:\"\0*\0children\";a:1:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:3;s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:21:\"shipping_service_name\";s:13:\"free_shipping\";s:21:\"commerce_order:select\";s:14:\"commerce-order\";}s:14:\"\0*\0elementName\";s:36:\"commerce_shipping_service_rate_order\";}}s:7:\"\0*\0info\";a:1:{s:9:\"variables\";a:1:{s:14:\"commerce_order\";a:2:{s:4:\"type\";s:14:\"commerce_order\";s:5:\"label\";s:5:\"Order\";}}}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:2;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:1:{i:0;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:33;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:11:\"data:select\";s:42:\"commerce-order:commerce-order-total:amount\";s:2:\"op\";s:1:\">\";s:5:\"value\";s:2:\"50\";}s:14:\"\0*\0elementName\";s:7:\"data_is\";s:9:\"\0*\0negate\";b:0;}}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}}'),(27,'commerce_shipping_service_shipping','Rate Shipping','rule',1,0,3,0,'commerce_shipping','rules',0,'O:4:\"Rule\":19:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:2:\"27\";s:12:\"\0*\0elementId\";i:1;s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:0:{}s:4:\"name\";s:34:\"commerce_shipping_service_shipping\";s:5:\"label\";s:13:\"Rate Shipping\";s:6:\"plugin\";s:4:\"rule\";s:6:\"active\";s:1:\"1\";s:6:\"status\";i:3;s:5:\"dirty\";b:0;s:6:\"module\";s:17:\"commerce_shipping\";s:5:\"owner\";s:5:\"rules\";s:14:\"access_exposed\";s:1:\"0\";s:4:\"data\";r:1;s:4:\"tags\";a:0:{}s:11:\"\0*\0children\";a:1:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:3;s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:21:\"shipping_service_name\";s:8:\"shipping\";s:21:\"commerce_order:select\";s:14:\"commerce-order\";}s:14:\"\0*\0elementName\";s:36:\"commerce_shipping_service_rate_order\";}}s:7:\"\0*\0info\";a:1:{s:9:\"variables\";a:1:{s:14:\"commerce_order\";a:2:{s:4:\"type\";s:14:\"commerce_order\";s:5:\"label\";s:5:\"Order\";}}}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";i:2;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:1:{i:0;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:33;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:11:\"data:select\";s:42:\"commerce-order:commerce-order-total:amount\";s:2:\"op\";s:1:\">\";s:5:\"value\";s:1:\"0\";}s:14:\"\0*\0elementName\";s:7:\"data_is\";s:9:\"\0*\0negate\";b:0;}}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}}'),(28,'rules_increment_stock_canceling_order','Stock: Increase when canceling the order process','reaction rule',0,0,2,0,'commerce_ss','rules',0,'O:17:\"RulesReactionRule\":19:{s:9:\"\0*\0parent\";N;s:2:\"id\";s:2:\"28\";s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:4:\"name\";s:37:\"rules_increment_stock_canceling_order\";s:5:\"label\";s:48:\"Stock: Increase when canceling the order process\";s:6:\"plugin\";s:13:\"reaction rule\";s:6:\"active\";b:0;s:6:\"status\";i:2;s:6:\"module\";s:11:\"commerce_ss\";s:5:\"owner\";s:5:\"rules\";s:4:\"data\";r:1;s:4:\"tags\";a:1:{i:0;s:13:\"stock_control\";}s:11:\"\0*\0children\";a:1:{i:0;O:9:\"RulesLoop\":7:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:3:{s:8:\"item:var\";s:9:\"list_item\";s:10:\"item:label\";s:17:\"Current list item\";s:11:\"list:select\";s:34:\"commerce-order:commerce-line-items\";}s:11:\"\0*\0children\";a:1:{i:0;O:11:\"RulesAction\":6:{s:9:\"\0*\0parent\";r:18;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:18:\"#_needs_processing\";b:1;s:25:\"commerce_line_item:select\";s:9:\"list-item\";}s:14:\"\0*\0elementName\";s:33:\"commerce_ss_increase_by_line_item\";}}s:7:\"\0*\0info\";a:0:{}}}s:7:\"\0*\0info\";a:0:{}s:13:\"\0*\0conditions\";O:8:\"RulesAnd\":8:{s:9:\"\0*\0parent\";r:1;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:11:\"\0*\0children\";a:2:{i:0;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:39;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:18:\"#_needs_processing\";b:1;s:11:\"data:select\";s:21:\"commerce-order:status\";s:2:\"op\";s:2:\"==\";s:5:\"value\";s:8:\"canceled\";}s:14:\"\0*\0elementName\";s:7:\"data_is\";s:9:\"\0*\0negate\";b:0;}i:1;O:14:\"RulesCondition\":7:{s:9:\"\0*\0parent\";r:39;s:2:\"id\";N;s:12:\"\0*\0elementId\";N;s:6:\"weight\";i:0;s:8:\"settings\";a:4:{s:18:\"#_needs_processing\";b:1;s:11:\"data:select\";s:31:\"commerce-order-unchanged:status\";s:2:\"op\";s:2:\"IN\";s:5:\"value\";a:3:{s:7:\"pending\";s:7:\"pending\";s:10:\"processing\";s:10:\"processing\";s:9:\"completed\";s:9:\"completed\";}}s:14:\"\0*\0elementName\";s:7:\"data_is\";s:9:\"\0*\0negate\";b:0;}}s:7:\"\0*\0info\";a:0:{}s:9:\"\0*\0negate\";b:0;}s:9:\"\0*\0events\";a:1:{i:0;s:21:\"commerce_order_update\";}s:16:\"\0*\0eventSettings\";a:0:{}}');
/*!40000 ALTER TABLE `rules_config` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `rules_dependencies`
--

DROP TABLE IF EXISTS `rules_dependencies`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rules_dependencies` (
  `id` int(10) unsigned NOT NULL COMMENT 'The primary identifier of the configuration.',
  `module` varchar(255) NOT NULL COMMENT 'The name of the module that is required for the configuration.',
  PRIMARY KEY (`id`,`module`),
  KEY `module` (`module`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rules_dependencies`
--

LOCK TABLES `rules_dependencies` WRITE;
/*!40000 ALTER TABLE `rules_dependencies` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `rules_dependencies` VALUES (24,'commerce_cart'),(13,'commerce_checkout'),(23,'commerce_checkout'),(23,'commerce_order'),(24,'commerce_order'),(10,'commerce_payment'),(11,'commerce_payment'),(23,'commerce_payment'),(24,'commerce_payment'),(26,'commerce_shipping'),(27,'commerce_shipping'),(13,'commerce_ss'),(14,'commerce_ss'),(15,'commerce_ss'),(16,'commerce_ss'),(28,'commerce_ss'),(14,'commerce_stock'),(15,'commerce_stock'),(16,'commerce_stock'),(21,'entity'),(22,'entity'),(28,'entity'),(14,'rules'),(15,'rules'),(16,'rules'),(21,'rules'),(22,'rules'),(26,'rules'),(27,'rules'),(28,'rules');
/*!40000 ALTER TABLE `rules_dependencies` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `rules_tags`
--

DROP TABLE IF EXISTS `rules_tags`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rules_tags` (
  `id` int(10) unsigned NOT NULL COMMENT 'The primary identifier of the configuration.',
  `tag` varchar(255) NOT NULL COMMENT 'The tag string associated with this configuration',
  PRIMARY KEY (`id`,`tag`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rules_tags`
--

LOCK TABLES `rules_tags` WRITE;
/*!40000 ALTER TABLE `rules_tags` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `rules_tags` VALUES (1,'Commerce Cart'),(2,'Commerce Cart'),(3,'Commerce Cart'),(4,'Commerce Checkout'),(5,'Commerce Checkout'),(6,'Commerce Checkout'),(7,'Commerce Checkout'),(8,'Commerce Checkout'),(10,'Commerce Payment'),(11,'Commerce Payment'),(12,'Commerce Payment'),(13,'stock_control'),(23,'Commerce Checkout'),(28,'stock_control');
/*!40000 ALTER TABLE `rules_tags` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `rules_trigger`
--

DROP TABLE IF EXISTS `rules_trigger`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rules_trigger` (
  `id` int(10) unsigned NOT NULL COMMENT 'The primary identifier of the configuration.',
  `event` varchar(127) NOT NULL DEFAULT '' COMMENT 'The name of the event on which the configuration should be triggered.',
  PRIMARY KEY (`id`,`event`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rules_trigger`
--

LOCK TABLES `rules_trigger` WRITE;
/*!40000 ALTER TABLE `rules_trigger` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `rules_trigger` VALUES (1,'commerce_cart_product_add'),(2,'commerce_cart_product_add'),(2,'commerce_cart_product_remove'),(3,'commerce_product_calculate_sell_price'),(4,'commerce_checkout_complete'),(5,'commerce_checkout_complete'),(6,'commerce_checkout_complete'),(7,'commerce_checkout_complete'),(8,'commerce_checkout_complete'),(9,'commerce_order_update'),(10,'commerce_payment_methods'),(11,'commerce_payment_methods'),(12,'commerce_payment_methods'),(13,'commerce_checkout_complete'),(14,'commerce_stock_check_add_to_cart_form_state'),(15,'commerce_stock_add_to_cart_check_product'),(16,'commerce_stock_check_product_checkout'),(18,'commerce_payment_order_paid_in_full'),(19,'commerce_checkout_complete'),(20,'cmp_funds_transaction_insert'),(21,'commerce_product_presave'),(22,'commerce_product_presave'),(23,'commerce_checkout_complete'),(24,'commerce_payment_order_paid_in_full'),(25,'commerce_shipping_collect_rates'),(28,'commerce_order_update');
/*!40000 ALTER TABLE `rules_trigger` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_api_db_product_display`
--

DROP TABLE IF EXISTS `search_api_db_product_display`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_api_db_product_display` (
  `item_id` bigint(20) NOT NULL COMMENT 'The primary identifier of the item.',
  `nid` bigint(20) DEFAULT NULL COMMENT 'The field’s value for this item.',
  `type` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The field’s value for this item.',
  `status` bigint(20) DEFAULT NULL COMMENT 'The field’s value for this item.',
  `created` bigint(20) DEFAULT NULL COMMENT 'The field’s value for this item.',
  `changed` bigint(20) DEFAULT NULL COMMENT 'The field’s value for this item.',
  `field_simplenews_term` bigint(20) DEFAULT NULL COMMENT 'The field’s value for this item.',
  `field_category` bigint(20) DEFAULT NULL COMMENT 'The field’s value for this item.',
  `field_brand` bigint(20) DEFAULT NULL COMMENT 'The field’s value for this item.',
  `search_api_language` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The field’s value for this item.',
  `field_product_commerce_price_amount_decimal_asc` float DEFAULT NULL COMMENT 'The field’s value for this item.',
  `field_product_commerce_price_amount_decimal_desc` float DEFAULT NULL COMMENT 'The field’s value for this item.',
  `field_simplenews_term_name` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The field’s value for this item.',
  `field_category_name` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The field’s value for this item.',
  `field_brand_name` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The field’s value for this item.',
  `field_category_vocabulary` bigint(20) DEFAULT NULL COMMENT 'The field’s value for this item.',
  PRIMARY KEY (`item_id`),
  KEY `nid` (`nid`),
  KEY `type` (`type`(10)),
  KEY `status` (`status`),
  KEY `created` (`created`),
  KEY `changed` (`changed`),
  KEY `field_simplenews_term` (`field_simplenews_term`),
  KEY `field_category` (`field_category`),
  KEY `field_brand` (`field_brand`),
  KEY `search_api_language` (`search_api_language`(10)),
  KEY `field_product_commerce_price_amount_decimal_asc` (`field_product_commerce_price_amount_decimal_asc`),
  KEY `field_product_commerce_price_amount_decimal_desc` (`field_product_commerce_price_amount_decimal_desc`),
  KEY `field_simplenews_term_name` (`field_simplenews_term_name`(10)),
  KEY `field_category_name` (`field_category_name`(10)),
  KEY `field_brand_name` (`field_brand_name`(10)),
  KEY `field_category_vocabulary` (`field_category_vocabulary`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_api_db_product_display`
--

LOCK TABLES `search_api_db_product_display` WRITE;
/*!40000 ALTER TABLE `search_api_db_product_display` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `search_api_db_product_display` VALUES (30,30,'product',1,1417426925,1419501346,NULL,77,74,'und',38,38,NULL,'Backpacks','Aeroline',3),(31,31,'product',1,1417445005,1418359627,NULL,77,75,'und',99,99,NULL,'Backpacks','Local Lion',3),(32,32,'product',1,1417446223,1418358737,NULL,66,76,'und',264,264,NULL,'Laptop Bags & Cases','Terminus',3),(33,33,'product',1,1417447402,1418358891,NULL,66,78,'und',318,318,NULL,'Laptop Bags & Cases','Targus',3),(34,34,'product',1,1417478826,1418360139,NULL,67,79,'und',35,35,NULL,'Shoe Bags','Tarantula',3),(35,35,'product',1,1417481146,1418359064,NULL,67,81,'und',41,41,NULL,'Shoe Bags','Diniwell',3),(36,36,'product',1,1417504200,1418353548,NULL,68,82,'und',43,43,NULL,'Makeup','OEM',3),(37,37,'product',1,1417504583,1418353776,NULL,68,83,'und',50,50,NULL,'Makeup','Cameleon',3),(38,38,'product',1,1417508779,1417594591,NULL,71,82,'und',39,39,NULL,'Face Care','OEM',3),(39,39,'product',1,1417509360,1419501285,NULL,71,84,'und',238,238,NULL,'Face Care','SK II',3),(40,40,'product',1,1417510355,1418353842,NULL,70,85,'und',107,107,NULL,'Eye Care','Skin Blossom',3),(41,41,'product',1,1417511293,1417597485,NULL,70,86,'und',115,115,NULL,'Eye Care','Mejikaliner',3),(42,42,'product',1,1417511809,1418353962,NULL,72,87,'und',59,59,NULL,'Health & Beauty Tools','Hairscape',3),(43,43,'product',1,1417512093,1418352829,NULL,72,82,'und',59,59,NULL,'Health & Beauty Tools','OEM',3),(44,44,'product',1,1417513096,1418354130,NULL,28,10,'und',750,750,NULL,'Smartphones','Apple',3),(45,45,'product',1,1417513689,1418715439,NULL,28,11,'und',700,700,NULL,'Smartphones','Samsung',3),(46,46,'product',1,1417515301,1426216822,NULL,41,13,'und',1000,1000,NULL,'Desktops','Asus',3),(47,47,'product',1,1417515888,1418354497,NULL,29,88,'und',199,199,NULL,'Basic Phones','Lenovo',3),(48,48,'product',1,1417517324,1418352185,NULL,29,14,'und',49,49,NULL,'Basic Phones','Nokia',3),(49,49,'product',1,1417518185,1418351813,NULL,31,10,'und',499.99,499.99,NULL,'With call facility','Apple',3),(50,50,'product',1,1417518819,1418354598,NULL,31,13,'und',349,349,NULL,'With call facility','Asus',3),(51,51,'product',1,1417528583,1426216927,NULL,32,88,'und',299,299,NULL,'Without call facility','Lenovo',3),(52,52,'product',1,1417530153,1418352025,NULL,32,10,'und',599,599,NULL,'Without call facility','Apple',3),(53,53,'product',1,1417530854,1418354720,NULL,34,89,'und',69,69,NULL,'Cases & Covers','Spigen',3),(54,54,'product',1,1417531758,1418354776,NULL,34,11,'und',155,155,NULL,'Cases & Covers','Samsung',3),(55,55,'product',1,1417532298,1418354819,NULL,35,82,'und',94,94,NULL,'Car Accessories','OEM',3),(56,56,'product',1,1417533303,1418354894,NULL,35,90,'und',29,29,NULL,'Car Accessories','Others',3),(57,57,'product',1,1417573407,1418354984,NULL,39,10,'und',75,75,NULL,'Headphones','Apple',3),(58,58,'product',1,1417576765,1418352069,NULL,39,91,'und',139,139,NULL,'Headphones','Sony',3),(59,59,'product',1,1417577778,1418355051,NULL,38,82,'und',39,39,NULL,'Batteries & Chargers','OEM',3),(60,60,'product',1,1417578198,1418355115,NULL,38,82,'und',43,43,NULL,'Batteries & Chargers','OEM',3),(61,61,'product',1,1417578593,1418355175,NULL,53,92,'und',79,79,NULL,'Women\'s Jewellery','MuWo Trendz',3),(62,62,'product',1,1417578986,1417594948,NULL,53,93,'und',29,29,NULL,'Women\'s Jewellery','Luccacal',3),(63,63,'product',1,1417579652,1418355239,NULL,48,94,'und',20,20,NULL,'Belts','Dandelion',3),(64,64,'product',1,1417579912,1417594868,NULL,48,94,'und',24,24,NULL,'Belts','Dandelion',3),(65,65,'product',1,1417580590,1418355292,NULL,49,95,'und',35,35,NULL,'Scarves','Fur Nyce',3),(66,66,'product',1,1417580757,1418355487,NULL,49,95,'und',30,30,NULL,'Scarves','Fur Nyce',3),(67,67,'product',1,1417581463,1417594778,NULL,51,97,'und',399,399,NULL,'Business','Invicta',3),(68,68,'product',1,1417581629,1418355650,NULL,51,96,'und',1000,1000,NULL,'Business','Rolex',3),(69,69,'product',1,1417582273,1418355696,NULL,52,99,'und',899,899,NULL,'Sports','Suunto',3),(70,70,'product',1,1417582520,1418355936,NULL,52,82,'und',85,85,NULL,'Sports','OEM',3),(71,71,'product',1,1417587476,1426216629,NULL,61,11,'und',1199,1199,NULL,'Televisions','Samsung',3),(72,72,'product',1,1417587699,1426216590,NULL,61,11,'und',2035,2035,NULL,'Televisions','Samsung',3),(73,73,'product',1,1417588138,1418356710,NULL,63,91,'und',1299,1299,NULL,'Home Audio','Sony',3),(74,74,'product',1,1417588401,1417594395,NULL,63,11,'und',369,369,NULL,'Home Audio','Samsung',3),(75,75,'product',1,1417588949,1417594269,NULL,64,82,'und',179,179,NULL,'Gadgets','OEM',3),(76,76,'product',1,1417589262,1417594234,NULL,64,10,'und',349,349,NULL,'Gadgets','Apple',3),(77,77,'product',1,1417590261,1418358045,NULL,41,12,'und',1000,1000,NULL,'Desktops','Dell',3),(78,78,'product',1,1417591448,1418358116,NULL,44,82,'und',55,55,NULL,'Switches','OEM',3),(79,79,'product',1,1417591728,1418358205,NULL,44,12,'und',1299,1299,NULL,'Switches','Dell',3),(80,80,'product',1,1417592574,1418358277,NULL,45,100,'und',145,145,NULL,'Routers','TP Link',3),(81,81,'product',1,1417592796,1418358332,NULL,45,100,'und',219,219,NULL,'Routers','TP Link',3),(82,82,'product',1,1417598912,1418353325,NULL,42,102,'und',499,499,NULL,'Scanners','Canon',3),(83,83,'product',1,1417599162,1418353195,NULL,42,101,'und',377,377,NULL,'Scanners','Epson',3),(84,84,'product',1,1417599720,1418353115,NULL,17,98,'und',599,599,NULL,'Point & Shoot Cameras','Casio',3),(85,85,'product',1,1417600163,1418029308,NULL,17,102,'und',999,999,NULL,'Point & Shoot Cameras','Canon',3),(86,86,'product',1,1417600767,1418352963,NULL,18,102,'und',499,499,NULL,'DSLR/SLR Cameras','Canon',3),(88,88,'product',1,1418365242,1418365269,NULL,18,11,'und',688,688,NULL,'DSLR/SLR Cameras','Samsung',3),(89,89,'product',1,1418365650,1418365650,NULL,25,103,'und',438,438,NULL,'Lenses','Nikon',3),(90,90,'product',1,1418366198,1418366198,NULL,25,102,'und',799,799,NULL,'Lenses','Canon',3),(91,91,'product',1,1418366731,1418366856,NULL,26,111,'und',548,548,NULL,'Filters','Cokin',3),(92,92,'product',1,1418367347,1418370702,NULL,22,112,'und',480,480,NULL,'IP Cameras','D-Link',3),(93,93,'product',1,1418368416,1418369954,NULL,22,113,'und',128,128,NULL,'IP Cameras','ScanTrack',3),(94,94,'product',1,1418369205,1418369928,NULL,23,114,'und',159,159,NULL,'Car Cameras','Trek',3),(95,95,'product',1,1418370240,1418370240,NULL,58,115,'und',23,23,NULL,'Educational Toys','CT Toys',3),(96,96,'product',1,1418370758,1418370810,NULL,59,116,'und',199,199,NULL,'Books & Stationery','Boogie',3),(97,97,'product',1,1418371223,1418371252,NULL,57,117,'und',125,125,NULL,'Health & Safety','Chicco',3),(138,138,'product',1,1418884808,1418884808,NULL,73,118,'und',130,130,NULL,'Food Supplements','Kinohimitsu',3),(139,139,'product',1,1418885579,1419219331,NULL,73,119,'und',150,150,NULL,'Food Supplements','TKO Nutrition',3);
/*!40000 ALTER TABLE `search_api_db_product_display` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_api_db_product_display_field_category_parent`
--

DROP TABLE IF EXISTS `search_api_db_product_display_field_category_parent`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_api_db_product_display_field_category_parent` (
  `item_id` bigint(20) NOT NULL COMMENT 'The primary identifier of the item.',
  `value` bigint(20) NOT NULL COMMENT 'The field’s value for this item.',
  PRIMARY KEY (`item_id`,`value`),
  KEY `value` (`value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_api_db_product_display_field_category_parent`
--

LOCK TABLES `search_api_db_product_display_field_category_parent` WRITE;
/*!40000 ALTER TABLE `search_api_db_product_display_field_category_parent` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `search_api_db_product_display_field_category_parent` VALUES (34,2),(35,2),(36,3),(37,3),(42,3),(43,3),(138,3),(139,3),(61,5),(62,5),(75,6),(76,6),(46,7),(77,7),(82,7),(83,7),(84,8),(85,8),(86,8),(88,8),(92,21),(93,21),(94,21),(89,24),(90,24),(91,24),(44,27),(45,27),(47,27),(48,27),(49,30),(50,30),(51,30),(52,30),(53,33),(54,33),(55,33),(56,33),(57,36),(58,36),(59,36),(60,36),(78,43),(79,43),(80,43),(81,43),(63,47),(64,47),(65,47),(66,47),(67,50),(68,50),(69,50),(70,50),(97,54),(95,56),(96,56),(71,60),(72,60),(73,62),(74,62),(30,65),(31,65),(32,65),(33,65),(38,69),(39,69),(40,69),(41,69);
/*!40000 ALTER TABLE `search_api_db_product_display_field_category_parent` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_api_db_product_display_field_category_parents_all`
--

DROP TABLE IF EXISTS `search_api_db_product_display_field_category_parents_all`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_api_db_product_display_field_category_parents_all` (
  `item_id` bigint(20) NOT NULL COMMENT 'The primary identifier of the item.',
  `value` bigint(20) NOT NULL COMMENT 'The field’s value for this item.',
  PRIMARY KEY (`item_id`,`value`),
  KEY `value` (`value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_api_db_product_display_field_category_parents_all`
--

LOCK TABLES `search_api_db_product_display_field_category_parents_all` WRITE;
/*!40000 ALTER TABLE `search_api_db_product_display_field_category_parents_all` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `search_api_db_product_display_field_category_parents_all` VALUES (30,2),(31,2),(32,2),(33,2),(34,2),(35,2),(36,3),(37,3),(38,3),(39,3),(40,3),(41,3),(42,3),(43,3),(138,3),(139,3),(44,4),(45,4),(47,4),(48,4),(49,4),(50,4),(51,4),(52,4),(53,4),(54,4),(55,4),(56,4),(57,4),(58,4),(59,4),(60,4),(61,5),(62,5),(63,5),(64,5),(65,5),(66,5),(67,5),(68,5),(69,5),(70,5),(71,6),(72,6),(73,6),(74,6),(75,6),(76,6),(46,7),(77,7),(78,7),(79,7),(80,7),(81,7),(82,7),(83,7),(84,8),(85,8),(86,8),(88,8),(89,8),(90,8),(91,8),(92,8),(93,8),(94,8),(95,9),(96,9),(97,9),(84,17),(85,17),(86,18),(88,18),(92,21),(93,21),(94,21),(92,22),(93,22),(94,23),(89,24),(90,24),(91,24),(89,25),(90,25),(91,26),(44,27),(45,27),(47,27),(48,27),(44,28),(45,28),(47,29),(48,29),(49,30),(50,30),(51,30),(52,30),(49,31),(50,31),(51,32),(52,32),(53,33),(54,33),(55,33),(56,33),(53,34),(54,34),(55,35),(56,35),(57,36),(58,36),(59,36),(60,36),(59,38),(60,38),(57,39),(58,39),(46,41),(77,41),(82,42),(83,42),(78,43),(79,43),(80,43),(81,43),(78,44),(79,44),(80,45),(81,45),(63,47),(64,47),(65,47),(66,47),(63,48),(64,48),(65,49),(66,49),(67,50),(68,50),(69,50),(70,50),(67,51),(68,51),(69,52),(70,52),(61,53),(62,53),(97,54),(95,56),(96,56),(97,57),(95,58),(96,59),(71,60),(72,60),(71,61),(72,61),(73,62),(74,62),(73,63),(74,63),(75,64),(76,64),(30,65),(31,65),(32,65),(33,65),(32,66),(33,66),(34,67),(35,67),(36,68),(37,68),(38,69),(39,69),(40,69),(41,69),(40,70),(41,70),(38,71),(39,71),(42,72),(43,72),(138,73),(139,73),(30,77),(31,77);
/*!40000 ALTER TABLE `search_api_db_product_display_field_category_parents_all` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_api_db_product_display_field_product`
--

DROP TABLE IF EXISTS `search_api_db_product_display_field_product`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_api_db_product_display_field_product` (
  `item_id` bigint(20) NOT NULL COMMENT 'The primary identifier of the item.',
  `value` bigint(20) NOT NULL COMMENT 'The field’s value for this item.',
  PRIMARY KEY (`item_id`,`value`),
  KEY `value` (`value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_api_db_product_display_field_product`
--

LOCK TABLES `search_api_db_product_display_field_product` WRITE;
/*!40000 ALTER TABLE `search_api_db_product_display_field_product` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `search_api_db_product_display_field_product` VALUES (30,9),(30,10),(31,11),(31,12),(31,13),(31,14),(32,15),(33,16),(34,17),(35,18),(36,19),(37,20),(38,21),(39,22),(40,23),(41,24),(42,25),(43,26),(44,27),(45,28),(46,29),(47,30),(48,31),(49,32),(50,33),(51,34),(52,35),(53,36),(54,37),(55,38),(56,39),(57,40),(58,41),(58,42),(59,43),(60,44),(61,45),(62,46),(63,47),(64,48),(65,49),(66,50),(67,51),(68,52),(69,53),(70,54),(71,55),(72,56),(73,57),(74,58),(75,59),(76,60),(77,61),(78,62),(79,63),(80,64),(81,65),(82,66),(83,67),(84,68),(85,69),(86,70),(88,71),(89,72),(90,73),(91,74),(92,75),(93,76),(94,77),(95,78),(96,79),(97,80),(138,81),(139,82);
/*!40000 ALTER TABLE `search_api_db_product_display_field_product` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_api_db_product_display_field_product_commerce_price_amo`
--

DROP TABLE IF EXISTS `search_api_db_product_display_field_product_commerce_price_amo`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_api_db_product_display_field_product_commerce_price_amo` (
  `item_id` bigint(20) NOT NULL COMMENT 'The primary identifier of the item.',
  `value` float NOT NULL COMMENT 'The field’s value for this item.',
  PRIMARY KEY (`item_id`,`value`),
  KEY `value` (`value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_api_db_product_display_field_product_commerce_price_amo`
--

LOCK TABLES `search_api_db_product_display_field_product_commerce_price_amo` WRITE;
/*!40000 ALTER TABLE `search_api_db_product_display_field_product_commerce_price_amo` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `search_api_db_product_display_field_product_commerce_price_amo` VALUES (63,20),(95,23),(64,24),(56,29),(62,29),(66,30),(34,35),(65,35),(30,38),(38,39),(59,39),(35,41),(36,43),(60,43),(48,49),(37,50),(78,55),(42,59),(43,59),(53,69),(57,75),(61,79),(70,85),(55,94),(31,99),(40,107),(41,115),(97,125),(93,128),(138,130),(58,139),(80,145),(139,150),(54,155),(94,159),(75,179),(47,199),(96,199),(81,219),(39,238),(32,264),(51,299),(33,318),(50,349),(76,349),(74,369),(83,377),(67,399),(89,438),(92,480),(82,499),(86,499),(49,499.99),(91,548),(52,599),(84,599),(88,688),(45,700),(44,750),(90,799),(69,899),(85,999),(46,1000),(68,1000),(77,1000),(71,1199),(73,1299),(79,1299),(72,2035);
/*!40000 ALTER TABLE `search_api_db_product_display_field_product_commerce_price_amo` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_api_db_product_display_field_tags`
--

DROP TABLE IF EXISTS `search_api_db_product_display_field_tags`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_api_db_product_display_field_tags` (
  `item_id` bigint(20) NOT NULL COMMENT 'The primary identifier of the item.',
  `value` bigint(20) NOT NULL COMMENT 'The field’s value for this item.',
  PRIMARY KEY (`item_id`,`value`),
  KEY `value` (`value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_api_db_product_display_field_tags`
--

LOCK TABLES `search_api_db_product_display_field_tags` WRITE;
/*!40000 ALTER TABLE `search_api_db_product_display_field_tags` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `search_api_db_product_display_field_tags` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_api_db_product_display_field_tags_name`
--

DROP TABLE IF EXISTS `search_api_db_product_display_field_tags_name`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_api_db_product_display_field_tags_name` (
  `item_id` bigint(20) NOT NULL COMMENT 'The primary identifier of the item.',
  `value` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'The field’s value for this item.',
  PRIMARY KEY (`item_id`,`value`),
  KEY `value` (`value`(10))
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_api_db_product_display_field_tags_name`
--

LOCK TABLES `search_api_db_product_display_field_tags_name` WRITE;
/*!40000 ALTER TABLE `search_api_db_product_display_field_tags_name` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `search_api_db_product_display_field_tags_name` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_api_db_product_display_text`
--

DROP TABLE IF EXISTS `search_api_db_product_display_text`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_api_db_product_display_text` (
  `item_id` bigint(20) NOT NULL COMMENT 'The primary identifier of the item.',
  `field_name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'The name of the field in which the token appears, or an MD5 hash of the field.',
  `word` varchar(50) COLLATE utf8_bin NOT NULL COMMENT 'The text of the indexed token.',
  `score` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The score associated with this token.',
  PRIMARY KEY (`item_id`,`field_name`,`word`),
  KEY `word_field` (`word`(20),`field_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_api_db_product_display_text`
--

LOCK TABLES `search_api_db_product_display_text` WRITE;
/*!40000 ALTER TABLE `search_api_db_product_display_text` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `search_api_db_product_display_text` VALUES (30,'search_api_aggregation_1','aeroline',1000),(30,'search_api_aggregation_1','backpack',1000),(30,'search_api_aggregation_1','blue',1000),(30,'search_api_aggregation_1','casual',1000),(30,'search_api_aggregation_1','dark',1000),(30,'search_api_aggregation_1','hiking',1000),(30,'search_api_aggregation_4','backpacks',1000),(30,'search_api_aggregation_5','aeroline',1000),(31,'search_api_aggregation_1','28l',1000),(31,'search_api_aggregation_1','backpack',1000),(31,'search_api_aggregation_1','bag',1000),(31,'search_api_aggregation_1','blue',1000),(31,'search_api_aggregation_1','hiking',1000),(31,'search_api_aggregation_1','lion',1000),(31,'search_api_aggregation_1','local',1000),(31,'search_api_aggregation_1','resistant',1000),(31,'search_api_aggregation_1','water',1000),(31,'search_api_aggregation_4','backpacks',1000),(31,'search_api_aggregation_5','lion',1000),(31,'search_api_aggregation_5','local',1000),(32,'search_api_aggregation_1','1',1000),(32,'search_api_aggregation_1','297lap',1000),(32,'search_api_aggregation_1','backpack',1000),(32,'search_api_aggregation_1','laptop',1000),(32,'search_api_aggregation_1','plus',1000),(32,'search_api_aggregation_1','t02',1000),(32,'search_api_aggregation_1','terminus',1000),(32,'search_api_aggregation_4','bags',1000),(32,'search_api_aggregation_4','cases',1000),(32,'search_api_aggregation_4','laptop',1000),(32,'search_api_aggregation_5','terminus',1000),(33,'search_api_aggregation_1','15',1000),(33,'search_api_aggregation_1','6in',1000),(33,'search_api_aggregation_1','backpack',1000),(33,'search_api_aggregation_1','revolution',1000),(33,'search_api_aggregation_1','targus',1000),(33,'search_api_aggregation_1','tsb166ap',1000),(33,'search_api_aggregation_4','bags',1000),(33,'search_api_aggregation_4','cases',1000),(33,'search_api_aggregation_4','laptop',1000),(33,'search_api_aggregation_5','targus',1000),(34,'search_api_aggregation_1','088shb',1000),(34,'search_api_aggregation_1','3',1000),(34,'search_api_aggregation_1','bag',1000),(34,'search_api_aggregation_1','bos04',1000),(34,'search_api_aggregation_1','red',1000),(34,'search_api_aggregation_1','shoe',1000),(34,'search_api_aggregation_1','tarantula',1000),(34,'search_api_aggregation_4','bags',1000),(34,'search_api_aggregation_4','shoe',1000),(34,'search_api_aggregation_5','tarantula',1000),(35,'search_api_aggregation_1','2',1000),(35,'search_api_aggregation_1','bag',2000),(35,'search_api_aggregation_1','diniwell',1000),(35,'search_api_aggregation_1','orange',1000),(35,'search_api_aggregation_1','organizer',1000),(35,'search_api_aggregation_1','pouch',1000),(35,'search_api_aggregation_1','resistant',1000),(35,'search_api_aggregation_1','shoes',1000),(35,'search_api_aggregation_1','travel',1000),(35,'search_api_aggregation_1','ver',1000),(35,'search_api_aggregation_1','water',1000),(35,'search_api_aggregation_4','bags',1000),(35,'search_api_aggregation_4','shoe',1000),(35,'search_api_aggregation_5','diniwell',1000),(36,'search_api_aggregation_1','24',1000),(36,'search_api_aggregation_1','brush',1000),(36,'search_api_aggregation_1','makeup',1000),(36,'search_api_aggregation_1','piece',1000),(36,'search_api_aggregation_1','set',1000),(36,'search_api_aggregation_4','makeup',1000),(36,'search_api_aggregation_5','oem',1000),(37,'search_api_aggregation_1','396',1000),(37,'search_api_aggregation_1','cameleon',1000),(37,'search_api_aggregation_1','kit',1000),(37,'search_api_aggregation_1','makeup',1000),(37,'search_api_aggregation_4','makeup',1000),(37,'search_api_aggregation_5','cameleon',1000),(38,'search_api_aggregation_1','1',1000),(38,'search_api_aggregation_1','4',1000),(38,'search_api_aggregation_1','blackhead',1000),(38,'search_api_aggregation_1','care',1000),(38,'search_api_aggregation_1','cleaner',1000),(38,'search_api_aggregation_1','face',1000),(38,'search_api_aggregation_1','facial',1000),(38,'search_api_aggregation_1','function',1000),(38,'search_api_aggregation_1','perfect',1000),(38,'search_api_aggregation_1','pore',1000),(38,'search_api_aggregation_1','power',1000),(38,'search_api_aggregation_4','care',1000),(38,'search_api_aggregation_4','face',1000),(38,'search_api_aggregation_5','oem',1000),(39,'search_api_aggregation_1','5',1000),(39,'search_api_aggregation_1','5pcs',1000),(39,'search_api_aggregation_1','packs',1000),(39,'search_api_aggregation_1','piece',1000),(39,'search_api_aggregation_1','set',1000),(39,'search_api_aggregation_1','sk2',1000),(39,'search_api_aggregation_1','skii',1000),(39,'search_api_aggregation_1','skincare',1000),(39,'search_api_aggregation_1','travel',2000),(39,'search_api_aggregation_4','care',1000),(39,'search_api_aggregation_4','face',1000),(40,'search_api_aggregation_1','15ml',1000),(40,'search_api_aggregation_1','cream',1000),(40,'search_api_aggregation_1','eye',1000),(40,'search_api_aggregation_1','organic',1000),(40,'search_api_aggregation_4','care',1000),(40,'search_api_aggregation_4','eye',1000),(40,'search_api_aggregation_5','blossom',1000),(40,'search_api_aggregation_5','skin',1000),(41,'search_api_aggregation_1','essence',1000),(41,'search_api_aggregation_1','eyelid',1000),(41,'search_api_aggregation_1','glue',1000),(41,'search_api_aggregation_1','mejikaliner',1000),(41,'search_api_aggregation_1','night',1000),(41,'search_api_aggregation_1','quick',1000),(41,'search_api_aggregation_1','stick',1000),(41,'search_api_aggregation_1','use',1000),(41,'search_api_aggregation_4','care',1000),(41,'search_api_aggregation_4','eye',1000),(41,'search_api_aggregation_5','mejikaliner',1000),(42,'search_api_aggregation_1','1800w',1000),(42,'search_api_aggregation_1','5000',1000),(42,'search_api_aggregation_1','aus',1000),(42,'search_api_aggregation_1','dryer',1000),(42,'search_api_aggregation_1','hair',1000),(42,'search_api_aggregation_1','hairscape',1000),(42,'search_api_aggregation_1','professional',1000),(42,'search_api_aggregation_4','beauty',1000),(42,'search_api_aggregation_4','health',1000),(42,'search_api_aggregation_4','tools',1000),(42,'search_api_aggregation_5','hairscape',1000),(43,'search_api_aggregation_1','massager',1000),(43,'search_api_aggregation_1','slimming',1000),(43,'search_api_aggregation_1','tonific',1000),(43,'search_api_aggregation_4','beauty',1000),(43,'search_api_aggregation_4','health',1000),(43,'search_api_aggregation_4','tools',1000),(43,'search_api_aggregation_5','oem',1000),(44,'search_api_aggregation_1','16gb',1000),(44,'search_api_aggregation_1','6',1000),(44,'search_api_aggregation_1','apple',1000),(44,'search_api_aggregation_1','gold',1000),(44,'search_api_aggregation_1','iphone',1000),(44,'search_api_aggregation_4','smartphones',1000),(44,'search_api_aggregation_5','apple',1000),(45,'search_api_aggregation_1','32gb',1000),(45,'search_api_aggregation_1','4',1000),(45,'search_api_aggregation_1','lte',1000),(45,'search_api_aggregation_1','n910',1000),(45,'search_api_aggregation_1','note',1000),(45,'search_api_aggregation_1','samsung',1000),(45,'search_api_aggregation_1','white',1000),(45,'search_api_aggregation_4','smartphones',1000),(45,'search_api_aggregation_5','samsung',1000),(46,'search_api_aggregation_1','18',1000),(46,'search_api_aggregation_1','4',1000),(46,'search_api_aggregation_1','aio',1000),(46,'search_api_aggregation_1','asus',2000),(46,'search_api_aggregation_1','b041k',1000),(46,'search_api_aggregation_1','band',1000),(46,'search_api_aggregation_1','dekstop',1000),(46,'search_api_aggregation_1','dual',1000),(46,'search_api_aggregation_1','gigabit',1000),(46,'search_api_aggregation_1','n56u',1000),(46,'search_api_aggregation_1','n600',1000),(46,'search_api_aggregation_1','p1801',1000),(46,'search_api_aggregation_1','router',1000),(46,'search_api_aggregation_1','transformer',1000),(46,'search_api_aggregation_1','wireless',1000),(46,'search_api_aggregation_4','desktops',1000),(46,'search_api_aggregation_5','asus',1000),(47,'search_api_aggregation_1','a316',1000),(47,'search_api_aggregation_1','lenovo',1000),(47,'search_api_aggregation_4','basic',1000),(47,'search_api_aggregation_4','phones',1000),(47,'search_api_aggregation_5','lenovo',1000),(48,'search_api_aggregation_1','206',1000),(48,'search_api_aggregation_1','asha',1000),(48,'search_api_aggregation_1','black',1000),(48,'search_api_aggregation_1','dual',1000),(48,'search_api_aggregation_1','nokia',1000),(48,'search_api_aggregation_1','sim',1000),(48,'search_api_aggregation_4','basic',1000),(48,'search_api_aggregation_4','phones',1000),(48,'search_api_aggregation_5','nokia',1000),(49,'search_api_aggregation_1','3',1000),(49,'search_api_aggregation_1','64gb',1000),(49,'search_api_aggregation_1','apple',1000),(49,'search_api_aggregation_1','black',1000),(49,'search_api_aggregation_1','ipad',1000),(49,'search_api_aggregation_1','md368',1000),(49,'search_api_aggregation_4','call',1000),(49,'search_api_aggregation_4','facility',1000),(49,'search_api_aggregation_4','with',1000),(49,'search_api_aggregation_5','apple',1000),(50,'search_api_aggregation_1','7',1000),(50,'search_api_aggregation_1','asus',1000),(50,'search_api_aggregation_1','memopad',1000),(50,'search_api_aggregation_1','tablet',1000),(50,'search_api_aggregation_4','call',1000),(50,'search_api_aggregation_4','facility',1000),(50,'search_api_aggregation_4','with',1000),(50,'search_api_aggregation_5','asus',1000),(51,'search_api_aggregation_1','2',1000),(51,'search_api_aggregation_1','59399848',1000),(51,'search_api_aggregation_1','8',1000),(51,'search_api_aggregation_1','lenovo',1000),(51,'search_api_aggregation_1','miix',1000),(51,'search_api_aggregation_1','silver',1000),(51,'search_api_aggregation_1','tablet',1000),(51,'search_api_aggregation_4','call',1000),(51,'search_api_aggregation_4','facility',1000),(51,'search_api_aggregation_4','without',1000),(51,'search_api_aggregation_5','lenovo',1000),(52,'search_api_aggregation_1','16gb',1000),(52,'search_api_aggregation_1','air',1000),(52,'search_api_aggregation_1','apple',1000),(52,'search_api_aggregation_1','grey',1000),(52,'search_api_aggregation_1','ipad',1000),(52,'search_api_aggregation_1','md785zpa',1000),(52,'search_api_aggregation_1','space',1000),(52,'search_api_aggregation_1','wifi',1000),(52,'search_api_aggregation_4','call',1000),(52,'search_api_aggregation_4','facility',1000),(52,'search_api_aggregation_4','without',1000),(52,'search_api_aggregation_5','apple',1000),(53,'search_api_aggregation_1','4',1000),(53,'search_api_aggregation_1','case',1000),(53,'search_api_aggregation_1','galaxy',1000),(53,'search_api_aggregation_1','gold',1000),(53,'search_api_aggregation_1','hybrid',1000),(53,'search_api_aggregation_1','metal',1000),(53,'search_api_aggregation_1','neo',1000),(53,'search_api_aggregation_1','note',1000),(53,'search_api_aggregation_1','spigen',1000),(53,'search_api_aggregation_4','cases',1000),(53,'search_api_aggregation_4','covers',1000),(53,'search_api_aggregation_5','spigen',1000),(54,'search_api_aggregation_1','4',1000),(54,'search_api_aggregation_1','black',1000),(54,'search_api_aggregation_1','case',1000),(54,'search_api_aggregation_1','classic',1000),(54,'search_api_aggregation_1','cover',1000),(54,'search_api_aggregation_1','galaxy',1000),(54,'search_api_aggregation_1','genuine',1000),(54,'search_api_aggregation_1','note',1000),(54,'search_api_aggregation_1','samsung',1000),(54,'search_api_aggregation_1','view',1000),(54,'search_api_aggregation_4','cases',1000),(54,'search_api_aggregation_4','covers',1000),(54,'search_api_aggregation_5','samsung',1000),(55,'search_api_aggregation_1','7',1000),(55,'search_api_aggregation_1','car',1000),(55,'search_api_aggregation_1','charger',1000),(55,'search_api_aggregation_1','dock',1000),(55,'search_api_aggregation_1','galaxy',1000),(55,'search_api_aggregation_1','plus',1000),(55,'search_api_aggregation_1','samsung',1000),(55,'search_api_aggregation_1','tab',1000),(55,'search_api_aggregation_1','vehicle',1000),(55,'search_api_aggregation_1','with',1000),(55,'search_api_aggregation_4','accessories',1000),(55,'search_api_aggregation_4','car',1000),(55,'search_api_aggregation_5','oem',1000),(56,'search_api_aggregation_1','360',1000),(56,'search_api_aggregation_1','angel',1000),(56,'search_api_aggregation_1','car',1000),(56,'search_api_aggregation_1','code',1000),(56,'search_api_aggregation_1','degree',1000),(56,'search_api_aggregation_1','holder',1000),(56,'search_api_aggregation_1','item',1000),(56,'search_api_aggregation_1','mobile',1000),(56,'search_api_aggregation_1','p338',1000),(56,'search_api_aggregation_1','phone',2000),(56,'search_api_aggregation_1','universal',1000),(56,'search_api_aggregation_4','accessories',1000),(56,'search_api_aggregation_4','car',1000),(56,'search_api_aggregation_5','others',1000),(57,'search_api_aggregation_1','apple',1000),(57,'search_api_aggregation_1','earphone',1000),(57,'search_api_aggregation_1','earpod',1000),(57,'search_api_aggregation_1','for',1000),(57,'search_api_aggregation_1','ipad',1000),(57,'search_api_aggregation_1','iphone',1000),(57,'search_api_aggregation_1','ipod',1000),(57,'search_api_aggregation_1','mic',1000),(57,'search_api_aggregation_1','original',1000),(57,'search_api_aggregation_1','remote',1000),(57,'search_api_aggregation_1','with',1000),(57,'search_api_aggregation_4','headphones',1000),(57,'search_api_aggregation_5','apple',1000),(58,'search_api_aggregation_1','black',1000),(58,'search_api_aggregation_1','bluetooth',1000),(58,'search_api_aggregation_1','headset',1000),(58,'search_api_aggregation_1','sbh20',1000),(58,'search_api_aggregation_1','sony',1000),(58,'search_api_aggregation_1','stereo',1000),(58,'search_api_aggregation_4','headphones',1000),(58,'search_api_aggregation_5','sony',1000),(59,'search_api_aggregation_1','10400mah',1000),(59,'search_api_aggregation_1','black',1000),(59,'search_api_aggregation_1','powerbank',1000),(59,'search_api_aggregation_1','top',1000),(59,'search_api_aggregation_4','batteries',1000),(59,'search_api_aggregation_4','chargers',1000),(59,'search_api_aggregation_5','oem',1000),(60,'search_api_aggregation_1','20000mah',1000),(60,'search_api_aggregation_1','bank',1000),(60,'search_api_aggregation_1','black',1000),(60,'search_api_aggregation_1','dual',1000),(60,'search_api_aggregation_1','port',1000),(60,'search_api_aggregation_1','power',1000),(60,'search_api_aggregation_1','universal',1000),(60,'search_api_aggregation_4','batteries',1000),(60,'search_api_aggregation_4','chargers',1000),(60,'search_api_aggregation_5','oem',1000),(61,'search_api_aggregation_1','element',1000),(61,'search_api_aggregation_1','everlasting',1000),(61,'search_api_aggregation_1','gold',1000),(61,'search_api_aggregation_1','love',1000),(61,'search_api_aggregation_1','muwo',1000),(61,'search_api_aggregation_1','plated',1000),(61,'search_api_aggregation_1','set',1000),(61,'search_api_aggregation_1','swarovski',1000),(61,'search_api_aggregation_1','trendz',1000),(61,'search_api_aggregation_1','white',1000),(61,'search_api_aggregation_4','jewellery',1000),(61,'search_api_aggregation_4','women',1000),(61,'search_api_aggregation_5','muwo',1000),(61,'search_api_aggregation_5','trendz',1000),(62,'search_api_aggregation_1','color',1000),(62,'search_api_aggregation_1','luccacal',1000),(62,'search_api_aggregation_1','multi',1000),(62,'search_api_aggregation_1','necklace',1000),(62,'search_api_aggregation_1','tribal',1000),(62,'search_api_aggregation_4','jewellery',1000),(62,'search_api_aggregation_4','women',1000),(62,'search_api_aggregation_5','luccacal',1000),(63,'search_api_aggregation_1','belt',1000),(63,'search_api_aggregation_1','braided',1000),(63,'search_api_aggregation_1','dandelion',1000),(63,'search_api_aggregation_1','white',1000),(63,'search_api_aggregation_1','women',1000),(63,'search_api_aggregation_4','belts',1000),(63,'search_api_aggregation_5','dandelion',1000),(64,'search_api_aggregation_1','belt',1000),(64,'search_api_aggregation_1','cross',1000),(64,'search_api_aggregation_1','dandelion',1000),(64,'search_api_aggregation_1','orange',1000),(64,'search_api_aggregation_1','stitch',1000),(64,'search_api_aggregation_4','belts',1000),(64,'search_api_aggregation_5','dandelion',1000),(65,'search_api_aggregation_1','big',1000),(65,'search_api_aggregation_1','chain',1000),(65,'search_api_aggregation_1','classic',1000),(65,'search_api_aggregation_1','fur',1000),(65,'search_api_aggregation_1','nyce',1000),(65,'search_api_aggregation_1','pattern',1000),(65,'search_api_aggregation_1','print',1000),(65,'search_api_aggregation_1','scarf',1000),(65,'search_api_aggregation_1','square',1000),(65,'search_api_aggregation_4','scarves',1000),(65,'search_api_aggregation_5','fur',1000),(65,'search_api_aggregation_5','nyce',1000),(66,'search_api_aggregation_1','fashion',1000),(66,'search_api_aggregation_1','fur',1000),(66,'search_api_aggregation_1','nyce',1000),(66,'search_api_aggregation_1','pattern',1000),(66,'search_api_aggregation_1','print',1000),(66,'search_api_aggregation_1','scarf',1000),(66,'search_api_aggregation_1','white',1000),(66,'search_api_aggregation_1','zebra',1000),(66,'search_api_aggregation_4','scarves',1000),(66,'search_api_aggregation_5','fur',1000),(66,'search_api_aggregation_5','nyce',1000),(67,'search_api_aggregation_1','15422',1000),(67,'search_api_aggregation_1','black',1000),(67,'search_api_aggregation_1','diver',1000),(67,'search_api_aggregation_1','invicta',1000),(67,'search_api_aggregation_1','men',1000),(67,'search_api_aggregation_1','pro',1000),(67,'search_api_aggregation_1','stainless',1000),(67,'search_api_aggregation_1','steel',1000),(67,'search_api_aggregation_1','strap',1000),(67,'search_api_aggregation_1','watch',1000),(67,'search_api_aggregation_4','business',1000),(67,'search_api_aggregation_5','invicta',1000),(68,'search_api_aggregation_1','114060',1000),(68,'search_api_aggregation_1','automatic',1000),(68,'search_api_aggregation_1','black',1000),(68,'search_api_aggregation_1','dial',1000),(68,'search_api_aggregation_1','mens',1000),(68,'search_api_aggregation_1','rolex',1000),(68,'search_api_aggregation_1','stainless',1000),(68,'search_api_aggregation_1','steel',1000),(68,'search_api_aggregation_1','submariner',1000),(68,'search_api_aggregation_1','watch',1000),(68,'search_api_aggregation_4','business',1000),(68,'search_api_aggregation_5','rolex',1000),(69,'search_api_aggregation_1','black',1000),(69,'search_api_aggregation_1','mountain',1000),(69,'search_api_aggregation_1','outdoor',1000),(69,'search_api_aggregation_1','suss010600610',1000),(69,'search_api_aggregation_1','suunto',1000),(69,'search_api_aggregation_1','vector',1000),(69,'search_api_aggregation_1','watch',1000),(69,'search_api_aggregation_4','sports',1000),(69,'search_api_aggregation_5','suunto',1000),(70,'search_api_aggregation_1','30m',1000),(70,'search_api_aggregation_1','955',1000),(70,'search_api_aggregation_1','analogue',1000),(70,'search_api_aggregation_1','black',1000),(70,'search_api_aggregation_1','digital',1000),(70,'search_api_aggregation_1','dual',1000),(70,'search_api_aggregation_1','green',1000),(70,'search_api_aggregation_1','men',1000),(70,'search_api_aggregation_1','skmei',1000),(70,'search_api_aggregation_1','sports',1000),(70,'search_api_aggregation_1','time',1000),(70,'search_api_aggregation_1','watch',1000),(70,'search_api_aggregation_1','waterproof',1000),(70,'search_api_aggregation_4','sports',1000),(70,'search_api_aggregation_5','oem',1000),(71,'search_api_aggregation_1','4',1000),(71,'search_api_aggregation_1','5',1000),(71,'search_api_aggregation_1','full',1000),(71,'search_api_aggregation_1','led',1000),(71,'search_api_aggregation_1','samsung',1000),(71,'search_api_aggregation_1','series',1000),(71,'search_api_aggregation_1','ua40h5008arxxm',1000),(71,'search_api_aggregation_4','televisions',1000),(71,'search_api_aggregation_5','samsung',1000),(72,'search_api_aggregation_1','48',1000),(72,'search_api_aggregation_1','48r470b',1000),(72,'search_api_aggregation_1','bravia',1000),(72,'search_api_aggregation_1','full',1000),(72,'search_api_aggregation_1','kdl',1000),(72,'search_api_aggregation_1','led',1000),(72,'search_api_aggregation_1','model',1000),(72,'search_api_aggregation_1','sony',1000),(72,'search_api_aggregation_4','televisions',1000),(72,'search_api_aggregation_5','samsung',1000),(73,'search_api_aggregation_1','1',1000),(73,'search_api_aggregation_1','9',1000),(73,'search_api_aggregation_1','bdv',1000),(73,'search_api_aggregation_1','blu',1000),(73,'search_api_aggregation_1','cinema',1000),(73,'search_api_aggregation_1','disc',1000),(73,'search_api_aggregation_1','home',1000),(73,'search_api_aggregation_1','n9200w',1000),(73,'search_api_aggregation_1','ray',1000),(73,'search_api_aggregation_1','sony',1000),(73,'search_api_aggregation_1','studio',1000),(73,'search_api_aggregation_1','system',1000),(73,'search_api_aggregation_1','theatre',1000),(73,'search_api_aggregation_4','audio',1000),(73,'search_api_aggregation_4','home',1000),(73,'search_api_aggregation_5','sony',1000),(74,'search_api_aggregation_1','dvd',1000),(74,'search_api_aggregation_1','e350k',1000),(74,'search_api_aggregation_1','home',1000),(74,'search_api_aggregation_1','samsung',1000),(74,'search_api_aggregation_1','system',1000),(74,'search_api_aggregation_1','theater',1000),(74,'search_api_aggregation_4','audio',1000),(74,'search_api_aggregation_4','home',1000),(74,'search_api_aggregation_5','samsung',1000),(75,'search_api_aggregation_1','3',1000),(75,'search_api_aggregation_1','android',1000),(75,'search_api_aggregation_1','blue',1000),(75,'search_api_aggregation_1','bluetooth',1000),(75,'search_api_aggregation_1','bracelet',1000),(75,'search_api_aggregation_1','design',1000),(75,'search_api_aggregation_1','for',1000),(75,'search_api_aggregation_1','ios',1000),(75,'search_api_aggregation_1','iphone',1000),(75,'search_api_aggregation_1','l12s',1000),(75,'search_api_aggregation_1','oled',1000),(75,'search_api_aggregation_1','phone',1000),(75,'search_api_aggregation_1','samsung',1000),(75,'search_api_aggregation_1','smart',2000),(75,'search_api_aggregation_1','watch',1000),(75,'search_api_aggregation_1','wrist',1000),(75,'search_api_aggregation_4','gadgets',1000),(75,'search_api_aggregation_5','oem',1000),(76,'search_api_aggregation_1','apple',1000),(76,'search_api_aggregation_1','ori',1000),(76,'search_api_aggregation_4','gadgets',1000),(76,'search_api_aggregation_5','apple',1000),(77,'search_api_aggregation_1','77822g',1000),(77,'search_api_aggregation_1','alienware',1000),(77,'search_api_aggregation_1','dell',1000),(77,'search_api_aggregation_1','desktop',1000),(77,'search_api_aggregation_1','gaming',1000),(77,'search_api_aggregation_1','x51',1000),(77,'search_api_aggregation_4','desktops',1000),(77,'search_api_aggregation_5','dell',1000),(78,'search_api_aggregation_1','3',1000),(78,'search_api_aggregation_1','control',1000),(78,'search_api_aggregation_1','hdmi',1000),(78,'search_api_aggregation_1','port',1000),(78,'search_api_aggregation_1','remote',1000),(78,'search_api_aggregation_1','switch',1000),(78,'search_api_aggregation_1','with',1000),(78,'search_api_aggregation_4','switches',1000),(78,'search_api_aggregation_5','oem',1000),(79,'search_api_aggregation_1','10gbe',1000),(79,'search_api_aggregation_1','24',1000),(79,'search_api_aggregation_1','5524p',1000),(79,'search_api_aggregation_1','and',1000),(79,'search_api_aggregation_1','capable',1000),(79,'search_api_aggregation_1','dell',1000),(79,'search_api_aggregation_1','gbe',1000),(79,'search_api_aggregation_1','managed',1000),(79,'search_api_aggregation_1','poe',1000),(79,'search_api_aggregation_1','port',1000),(79,'search_api_aggregation_1','powerconnect',1000),(79,'search_api_aggregation_1','stacking',1000),(79,'search_api_aggregation_1','support',1000),(79,'search_api_aggregation_1','switch',1000),(79,'search_api_aggregation_1','with',1000),(79,'search_api_aggregation_4','switches',1000),(79,'search_api_aggregation_5','dell',1000),(80,'search_api_aggregation_1','black',1000),(80,'search_api_aggregation_1','link',1000),(80,'search_api_aggregation_1','m5250',1000),(80,'search_api_aggregation_1','mobile',1000),(80,'search_api_aggregation_1','n900',1000),(80,'search_api_aggregation_1','wifi',1000),(80,'search_api_aggregation_4','routers',1000),(80,'search_api_aggregation_5','link',1000),(81,'search_api_aggregation_1','band',1000),(81,'search_api_aggregation_1','black',1000),(81,'search_api_aggregation_1','dual',1000),(81,'search_api_aggregation_1','gigabit',1000),(81,'search_api_aggregation_1','link',1000),(81,'search_api_aggregation_1','n750',1000),(81,'search_api_aggregation_1','router',1000),(81,'search_api_aggregation_1','wdr4300',1000),(81,'search_api_aggregation_1','wireless',1000),(81,'search_api_aggregation_4','routers',1000),(81,'search_api_aggregation_5','link',1000),(82,'search_api_aggregation_1','210',1000),(82,'search_api_aggregation_1','canon',1000),(82,'search_api_aggregation_1','lide',1000),(82,'search_api_aggregation_1','scanner',1000),(82,'search_api_aggregation_4','scanners',1000),(82,'search_api_aggregation_5','canon',1000),(83,'search_api_aggregation_1','epson',1000),(83,'search_api_aggregation_1','perfection',1000),(83,'search_api_aggregation_1','scanner',1000),(83,'search_api_aggregation_1','v33',1000),(83,'search_api_aggregation_4','scanners',1000),(83,'search_api_aggregation_5','epson',1000),(84,'search_api_aggregation_1','camera',1000),(84,'search_api_aggregation_1','casio',1000),(84,'search_api_aggregation_1','digital',1000),(84,'search_api_aggregation_1','exilim',1000),(84,'search_api_aggregation_1','pink',1000),(84,'search_api_aggregation_1','zr1500',1000),(84,'search_api_aggregation_4','cameras',1000),(84,'search_api_aggregation_4','point',1000),(84,'search_api_aggregation_4','shoot',1000),(84,'search_api_aggregation_5','casio',1000),(85,'search_api_aggregation_1','16',1000),(85,'search_api_aggregation_1','1mp',1000),(85,'search_api_aggregation_1','8gb',1000),(85,'search_api_aggregation_1','black',1000),(85,'search_api_aggregation_1','canon',1000),(85,'search_api_aggregation_1','case',1000),(85,'search_api_aggregation_1','powershot',1000),(85,'search_api_aggregation_1','sx60',1000),(85,'search_api_aggregation_4','cameras',1000),(85,'search_api_aggregation_4','point',1000),(85,'search_api_aggregation_4','shoot',1000),(85,'search_api_aggregation_5','canon',1000),(86,'search_api_aggregation_1','18',1000),(86,'search_api_aggregation_1','18mp',1000),(86,'search_api_aggregation_1','55mm',1000),(86,'search_api_aggregation_1','600d',1000),(86,'search_api_aggregation_1','canon',1000),(86,'search_api_aggregation_1','eos',1000),(86,'search_api_aggregation_1','lens',1000),(86,'search_api_aggregation_4','cameras',1000),(86,'search_api_aggregation_4','dslr',1000),(86,'search_api_aggregation_4','slr',1000),(86,'search_api_aggregation_5','canon',1000),(88,'search_api_aggregation_1','16',1000),(88,'search_api_aggregation_1','20',1000),(88,'search_api_aggregation_1','5mp',1000),(88,'search_api_aggregation_1','9mm',1000),(88,'search_api_aggregation_1','camera',1000),(88,'search_api_aggregation_1','card',1000),(88,'search_api_aggregation_1','green',1000),(88,'search_api_aggregation_1','lens',1000),(88,'search_api_aggregation_1','memory',1000),(88,'search_api_aggregation_1','mini',1000),(88,'search_api_aggregation_1','samsung',1000),(88,'search_api_aggregation_1','smart',1000),(88,'search_api_aggregation_4','cameras',1000),(88,'search_api_aggregation_4','dslr',1000),(88,'search_api_aggregation_4','slr',1000),(88,'search_api_aggregation_5','samsung',1000),(89,'search_api_aggregation_1','1',1000),(89,'search_api_aggregation_1','50mm',1000),(89,'search_api_aggregation_1','lens',1000),(89,'search_api_aggregation_1','nikon',1000),(89,'search_api_aggregation_4','lenses',1000),(89,'search_api_aggregation_5','nikon',1000),(90,'search_api_aggregation_1','18',1000),(90,'search_api_aggregation_1','200mm',1000),(90,'search_api_aggregation_1','3',1000),(90,'search_api_aggregation_1','5',2000),(90,'search_api_aggregation_1','6',1000),(90,'search_api_aggregation_1','canon',1000),(90,'search_api_aggregation_1','lens',1000),(90,'search_api_aggregation_4','lenses',1000),(90,'search_api_aggregation_5','canon',1000),(91,'search_api_aggregation_1','cokin',1000),(91,'search_api_aggregation_1','filter',1000),(91,'search_api_aggregation_1','grad',1000),(91,'search_api_aggregation_1','holder',1000),(91,'search_api_aggregation_1','kit',1000),(91,'search_api_aggregation_1','pro',1000),(91,'search_api_aggregation_1','u961a',1000),(91,'search_api_aggregation_1','z121l',1000),(91,'search_api_aggregation_1','z123l',1000),(91,'search_api_aggregation_1','z125l',1000),(91,'search_api_aggregation_4','filters',1000),(91,'search_api_aggregation_5','cokin',1000),(92,'search_api_aggregation_1','5222l',1000),(92,'search_api_aggregation_1','camera',1000),(92,'search_api_aggregation_1','cloudcam',1000),(92,'search_api_aggregation_1','dcs',1000),(92,'search_api_aggregation_1','link',1000),(92,'search_api_aggregation_1','network',1000),(92,'search_api_aggregation_1','pan',1000),(92,'search_api_aggregation_1','tilt',1000),(92,'search_api_aggregation_1','wireless',1000),(92,'search_api_aggregation_4','cameras',1000),(92,'search_api_aggregation_5','link',1000),(93,'search_api_aggregation_1','850tvl',1000),(93,'search_api_aggregation_1','camera',1000),(93,'search_api_aggregation_1','cctv',2000),(93,'search_api_aggregation_1','dome',1000),(93,'search_api_aggregation_4','cameras',1000),(93,'search_api_aggregation_5','scantrack',1000),(94,'search_api_aggregation_1','adaptors',1000),(94,'search_api_aggregation_1','ball',1000),(94,'search_api_aggregation_1','camera',1000),(94,'search_api_aggregation_1','cradle',1000),(94,'search_api_aggregation_1','portable',1000),(94,'search_api_aggregation_1','remote',1000),(94,'search_api_aggregation_1','trek',1000),(94,'search_api_aggregation_1','with',1000),(94,'search_api_aggregation_1','yellow',1000),(94,'search_api_aggregation_4','cameras',1000),(94,'search_api_aggregation_4','car',1000),(94,'search_api_aggregation_5','trek',1000),(95,'search_api_aggregation_1','for',1000),(95,'search_api_aggregation_1','kids',1000),(95,'search_api_aggregation_1','mini',1000),(95,'search_api_aggregation_1','quran',1000),(95,'search_api_aggregation_1','yellow',1000),(95,'search_api_aggregation_4','educational',1000),(95,'search_api_aggregation_4','toys',1000),(95,'search_api_aggregation_5','toys',1000),(96,'search_api_aggregation_1','10',1000),(96,'search_api_aggregation_1','5',1000),(96,'search_api_aggregation_1','board',1000),(96,'search_api_aggregation_1','boogie',1000),(96,'search_api_aggregation_1','inch',1000),(96,'search_api_aggregation_1','lcd',1000),(96,'search_api_aggregation_1','pink',1000),(96,'search_api_aggregation_1','tablet',1000),(96,'search_api_aggregation_1','writing',1000),(96,'search_api_aggregation_4','books',1000),(96,'search_api_aggregation_4','stationery',1000),(96,'search_api_aggregation_5','boogie',1000),(97,'search_api_aggregation_1','carry',1000),(97,'search_api_aggregation_1','cot',1000),(97,'search_api_aggregation_1','transporter',1000),(97,'search_api_aggregation_4','health',1000),(97,'search_api_aggregation_4','safety',1000),(97,'search_api_aggregation_5','chicco',1000),(138,'search_api_aggregation_1','10',1000),(138,'search_api_aggregation_1','50ml',1000),(138,'search_api_aggregation_1','drink',1000),(138,'search_api_aggregation_1','kinohimitsu',1000),(138,'search_api_aggregation_1','pan',1000),(138,'search_api_aggregation_4','food',1000),(138,'search_api_aggregation_4','supplements',1000),(138,'search_api_aggregation_5','kinohimitsu',1000),(139,'search_api_aggregation_1','burner',1000),(139,'search_api_aggregation_1','fat',1000),(139,'search_api_aggregation_1','mega',1000),(139,'search_api_aggregation_1','tko',1000),(139,'search_api_aggregation_4','food',1000),(139,'search_api_aggregation_4','supplements',1000),(139,'search_api_aggregation_5','nutrition',1000),(139,'search_api_aggregation_5','tko',1000);
/*!40000 ALTER TABLE `search_api_db_product_display_text` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_api_index`
--

DROP TABLE IF EXISTS `search_api_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_api_index` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'An integer identifying the index.',
  `name` varchar(50) NOT NULL COMMENT 'A name to be displayed for the index.',
  `machine_name` varchar(50) NOT NULL COMMENT 'The machine name of the index.',
  `description` text COMMENT 'A string describing the index’ use to users.',
  `server` varchar(50) DEFAULT NULL COMMENT 'The search_api_server.machine_name with which data should be indexed.',
  `item_type` varchar(50) NOT NULL COMMENT 'The type of items stored in this index.',
  `options` mediumtext NOT NULL COMMENT 'An array of additional arguments configuring this index.',
  `enabled` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'A flag indicating whether this index is enabled.',
  `read_only` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A flag indicating whether to write to this index.',
  `status` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'The exportable status of the entity.',
  `module` varchar(255) DEFAULT NULL COMMENT 'The name of the providing module if the entity has been defined in code.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `machine_name` (`machine_name`),
  KEY `item_type` (`item_type`),
  KEY `server` (`server`),
  KEY `enabled` (`enabled`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COMMENT='Stores all search indexes on a search_api_server.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_api_index`
--

LOCK TABLES `search_api_index` WRITE;
/*!40000 ALTER TABLE `search_api_index` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `search_api_index` VALUES (1,'Default node index','default_node_index','An automatically created search index for indexing node data. Might be configured to specific needs.',NULL,'node','a:5:{s:14:\"index_directly\";i:1;s:10:\"cron_limit\";s:2:\"50\";s:20:\"data_alter_callbacks\";a:1:{s:28:\"search_api_alter_node_access\";a:3:{s:6:\"status\";i:1;s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:0:{}}}s:10:\"processors\";a:3:{s:22:\"search_api_case_ignore\";a:3:{s:6:\"status\";i:1;s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:1:{s:7:\"strings\";i:0;}}s:22:\"search_api_html_filter\";a:3:{s:6:\"status\";i:1;s:6:\"weight\";s:2:\"10\";s:8:\"settings\";a:3:{s:5:\"title\";i:0;s:3:\"alt\";i:1;s:4:\"tags\";s:54:\"h1 = 5\nh2 = 3\nh3 = 2\nstrong = 2\nb = 2\nem = 1.5\nu = 1.5\";}}s:20:\"search_api_tokenizer\";a:3:{s:6:\"status\";i:1;s:6:\"weight\";s:2:\"20\";s:8:\"settings\";a:2:{s:6:\"spaces\";s:13:\"[^\\p{L}\\p{N}]\";s:9:\"ignorable\";s:3:\"[-]\";}}}s:6:\"fields\";a:10:{s:6:\"author\";a:2:{s:4:\"type\";s:7:\"integer\";s:11:\"entity_type\";s:4:\"user\";}s:10:\"body:value\";a:1:{s:4:\"type\";s:4:\"text\";}s:7:\"changed\";a:1:{s:4:\"type\";s:4:\"date\";}s:13:\"comment_count\";a:1:{s:4:\"type\";s:7:\"integer\";}s:7:\"created\";a:1:{s:4:\"type\";s:4:\"date\";}s:7:\"promote\";a:1:{s:4:\"type\";s:7:\"boolean\";}s:19:\"search_api_language\";a:1:{s:4:\"type\";s:6:\"string\";}s:6:\"sticky\";a:1:{s:4:\"type\";s:7:\"boolean\";}s:5:\"title\";a:2:{s:4:\"type\";s:4:\"text\";s:5:\"boost\";s:3:\"5.0\";}s:4:\"type\";a:1:{s:4:\"type\";s:6:\"string\";}}}',0,0,1,NULL),(2,'Product display','product_display',NULL,'frontend','node','a:4:{s:14:\"index_directly\";i:1;s:10:\"cron_limit\";i:50;s:6:\"fields\";a:27:{s:7:\"changed\";a:1:{s:4:\"type\";s:4:\"date\";}s:7:\"created\";a:1:{s:4:\"type\";s:4:\"date\";}s:11:\"field_brand\";a:2:{s:4:\"type\";s:7:\"integer\";s:11:\"entity_type\";s:13:\"taxonomy_term\";}s:16:\"field_brand:name\";a:1:{s:4:\"type\";s:6:\"string\";}s:14:\"field_category\";a:2:{s:4:\"type\";s:7:\"integer\";s:11:\"entity_type\";s:13:\"taxonomy_term\";}s:19:\"field_category:name\";a:1:{s:4:\"type\";s:6:\"string\";}s:21:\"field_category:parent\";a:2:{s:4:\"type\";s:13:\"list<integer>\";s:11:\"entity_type\";s:13:\"taxonomy_term\";}s:26:\"field_category:parents_all\";a:2:{s:4:\"type\";s:13:\"list<integer>\";s:11:\"entity_type\";s:13:\"taxonomy_term\";}s:25:\"field_category:vocabulary\";a:2:{s:4:\"type\";s:7:\"integer\";s:11:\"entity_type\";s:19:\"taxonomy_vocabulary\";}s:13:\"field_product\";a:2:{s:4:\"type\";s:13:\"list<integer>\";s:11:\"entity_type\";s:16:\"commerce_product\";}s:43:\"field_product:commerce_price:amount_decimal\";a:1:{s:4:\"type\";s:13:\"list<decimal>\";}s:47:\"field_product_commerce_price_amount_decimal_asc\";a:1:{s:4:\"type\";s:7:\"decimal\";}s:48:\"field_product_commerce_price_amount_decimal_desc\";a:1:{s:4:\"type\";s:7:\"decimal\";}s:21:\"field_simplenews_term\";a:2:{s:4:\"type\";s:7:\"integer\";s:11:\"entity_type\";s:13:\"taxonomy_term\";}s:26:\"field_simplenews_term:name\";a:1:{s:4:\"type\";s:6:\"string\";}s:10:\"field_tags\";a:2:{s:4:\"type\";s:13:\"list<integer>\";s:11:\"entity_type\";s:13:\"taxonomy_term\";}s:15:\"field_tags:name\";a:1:{s:4:\"type\";s:12:\"list<string>\";}s:3:\"nid\";a:1:{s:4:\"type\";s:7:\"integer\";}s:24:\"search_api_aggregation_1\";a:1:{s:4:\"type\";s:4:\"text\";}s:24:\"search_api_aggregation_2\";a:1:{s:4:\"type\";s:4:\"text\";}s:24:\"search_api_aggregation_3\";a:1:{s:4:\"type\";s:4:\"text\";}s:24:\"search_api_aggregation_4\";a:1:{s:4:\"type\";s:4:\"text\";}s:24:\"search_api_aggregation_5\";a:1:{s:4:\"type\";s:4:\"text\";}s:24:\"search_api_aggregation_6\";a:1:{s:4:\"type\";s:4:\"text\";}s:19:\"search_api_language\";a:1:{s:4:\"type\";s:6:\"string\";}s:6:\"status\";a:1:{s:4:\"type\";s:7:\"integer\";}s:4:\"type\";a:1:{s:4:\"type\";s:6:\"string\";}}s:20:\"data_alter_callbacks\";a:4:{s:42:\"commerce_search_api_product_display_filter\";a:2:{s:6:\"status\";i:1;s:6:\"weight\";i:-10;}s:40:\"commerce_search_api_alter_product_status\";a:2:{s:6:\"status\";i:1;s:6:\"weight\";i:-9;}s:32:\"search_api_alter_add_aggregation\";a:3:{s:6:\"status\";i:1;s:6:\"weight\";i:0;s:8:\"settings\";a:1:{s:6:\"fields\";a:6:{s:24:\"search_api_aggregation_1\";a:4:{s:4:\"name\";s:16:\"Title (Fulltext)\";s:4:\"type\";s:8:\"fulltext\";s:6:\"fields\";a:1:{i:0;s:11:\"title_field\";}s:11:\"description\";s:42:\"A Fulltext aggregation of the title field.\";}s:24:\"search_api_aggregation_2\";a:4:{s:4:\"name\";s:20:\"Tags name (Fulltext)\";s:4:\"type\";s:8:\"fulltext\";s:6:\"fields\";a:1:{i:0;s:15:\"field_tags:name\";}s:11:\"description\";s:33:\"Name property of Tags as fulltext\";}s:24:\"search_api_aggregation_3\";a:4:{s:4:\"name\";s:35:\"Newsletter category name (Fulltext)\";s:4:\"type\";s:8:\"fulltext\";s:6:\"fields\";a:1:{i:0;s:26:\"field_simplenews_term:name\";}s:11:\"description\";s:48:\"Name property of Newsletter category as fulltext\";}s:24:\"search_api_aggregation_4\";a:4:{s:4:\"name\";s:24:\"Category name (Fulltext)\";s:4:\"type\";s:8:\"fulltext\";s:6:\"fields\";a:1:{i:0;s:19:\"field_category:name\";}s:11:\"description\";s:37:\"Name property of Category as fulltext\";}s:24:\"search_api_aggregation_5\";a:4:{s:4:\"name\";s:21:\"Brand name (Fulltext)\";s:4:\"type\";s:8:\"fulltext\";s:6:\"fields\";a:1:{i:0;s:16:\"field_brand:name\";}s:11:\"description\";s:34:\"Name property of Brand as fulltext\";}s:24:\"search_api_aggregation_6\";a:4:{s:4:\"name\";s:28:\"Availability name (Fulltext)\";s:4:\"type\";s:8:\"fulltext\";s:6:\"fields\";a:1:{i:0;s:23:\"field_availability:name\";}s:11:\"description\";s:41:\"Name property of Availability as fulltext\";}}}}s:23:\"search_api_ranges_alter\";a:3:{s:6:\"status\";i:1;s:6:\"weight\";i:1;s:8:\"settings\";a:1:{s:6:\"fields\";a:1:{s:43:\"field_product:commerce_price:amount_decimal\";s:43:\"field_product:commerce_price:amount_decimal\";}}}}}',1,0,3,'commerce_search_api');
/*!40000 ALTER TABLE `search_api_index` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_api_item`
--

DROP TABLE IF EXISTS `search_api_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_api_item` (
  `item_id` int(10) unsigned NOT NULL COMMENT 'The item’s entity id (e.g. node.nid for nodes).',
  `index_id` int(10) unsigned NOT NULL COMMENT 'The search_api_index.id this item belongs to.',
  `changed` bigint(20) NOT NULL DEFAULT '1' COMMENT 'Either a flag or a timestamp to indicate if or when the item was changed since it was last indexed.',
  PRIMARY KEY (`item_id`,`index_id`),
  KEY `indexing` (`index_id`,`changed`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores the items which should be indexed for each index,...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_api_item`
--

LOCK TABLES `search_api_item` WRITE;
/*!40000 ALTER TABLE `search_api_item` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `search_api_item` VALUES (7,2,0),(8,2,0),(11,2,0),(12,2,0),(13,2,0),(14,2,0),(16,2,0),(17,2,0),(18,2,0),(19,2,0),(20,2,0),(21,2,0),(22,2,0),(23,2,0),(24,2,0),(26,2,0),(27,2,0),(28,2,0),(29,2,0),(30,2,0),(31,2,0),(32,2,0),(33,2,0),(34,2,0),(35,2,0),(36,2,0),(37,2,0),(38,2,0),(39,2,0),(40,2,0),(41,2,0),(42,2,0),(43,2,0),(44,2,0),(45,2,0),(46,2,0),(47,2,0),(48,2,0),(49,2,0),(50,2,0),(51,2,0),(52,2,0),(53,2,0),(54,2,0),(55,2,0),(56,2,0),(57,2,0),(58,2,0),(59,2,0),(60,2,0),(61,2,0),(62,2,0),(63,2,0),(64,2,0),(65,2,0),(66,2,0),(67,2,0),(68,2,0),(69,2,0),(70,2,0),(71,2,0),(72,2,0),(73,2,0),(74,2,0),(75,2,0),(76,2,0),(77,2,0),(78,2,0),(79,2,0),(80,2,0),(81,2,0),(82,2,0),(83,2,0),(84,2,0),(85,2,0),(86,2,0),(87,2,0),(88,2,0),(89,2,0),(90,2,0),(91,2,0),(92,2,0),(93,2,0),(94,2,0),(95,2,0),(96,2,0),(97,2,0),(98,2,0),(99,2,0),(100,2,0),(101,2,0),(102,2,0),(103,2,0),(104,2,0),(105,2,0),(106,2,0),(107,2,0),(108,2,0),(109,2,0),(110,2,0),(111,2,0),(112,2,0),(113,2,0),(114,2,0),(115,2,0),(116,2,0),(117,2,0),(118,2,0),(119,2,0),(120,2,0),(121,2,0),(122,2,0),(123,2,0),(124,2,0),(125,2,0),(126,2,0),(127,2,0),(128,2,0),(129,2,0),(130,2,0),(131,2,0),(132,2,0),(133,2,0),(134,2,0),(135,2,0),(136,2,0),(137,2,0),(138,2,0),(139,2,0),(140,2,0),(141,2,0),(142,2,0),(143,2,0);
/*!40000 ALTER TABLE `search_api_item` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_api_item_string_id`
--

DROP TABLE IF EXISTS `search_api_item_string_id`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_api_item_string_id` (
  `item_id` varchar(64) NOT NULL COMMENT 'The item’s ID.',
  `index_id` int(10) unsigned NOT NULL COMMENT 'The search_api_index.id this item belongs to.',
  `changed` bigint(20) NOT NULL DEFAULT '1' COMMENT 'Either a flag or a timestamp to indicate if or when the item was changed since it was last indexed.',
  PRIMARY KEY (`item_id`,`index_id`),
  KEY `indexing` (`index_id`,`changed`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores the items which should be indexed for each index,...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_api_item_string_id`
--

LOCK TABLES `search_api_item_string_id` WRITE;
/*!40000 ALTER TABLE `search_api_item_string_id` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `search_api_item_string_id` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_api_server`
--

DROP TABLE IF EXISTS `search_api_server`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_api_server` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a server.',
  `name` varchar(50) NOT NULL COMMENT 'The displayed name for a server.',
  `machine_name` varchar(50) NOT NULL COMMENT 'The machine name for a server.',
  `description` text COMMENT 'The displayed description for a server.',
  `class` varchar(50) NOT NULL COMMENT 'The id of the service class to use for this server.',
  `options` mediumtext NOT NULL COMMENT 'The options used to configure the service object.',
  `enabled` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'A flag indicating whether the server is enabled.',
  `status` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'The exportable status of the entity.',
  `module` varchar(255) DEFAULT NULL COMMENT 'The name of the providing module if the entity has been defined in code.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `machine_name` (`machine_name`),
  KEY `enabled` (`enabled`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COMMENT='Stores all search servers created through the Search API.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_api_server`
--

LOCK TABLES `search_api_server` WRITE;
/*!40000 ALTER TABLE `search_api_server` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `search_api_server` VALUES (1,'Db server','frontend','','search_api_db_service','a:3:{s:8:\"database\";s:15:\"default:default\";s:9:\"min_chars\";i:3;s:7:\"indexes\";a:1:{s:15:\"product_display\";a:27:{s:3:\"nid\";a:4:{s:5:\"table\";s:29:\"search_api_db_product_display\";s:6:\"column\";s:3:\"nid\";s:4:\"type\";s:7:\"integer\";s:5:\"boost\";s:3:\"1.0\";}s:4:\"type\";a:4:{s:5:\"table\";s:29:\"search_api_db_product_display\";s:6:\"column\";s:4:\"type\";s:4:\"type\";s:6:\"string\";s:5:\"boost\";s:3:\"1.0\";}s:6:\"status\";a:4:{s:5:\"table\";s:29:\"search_api_db_product_display\";s:6:\"column\";s:6:\"status\";s:4:\"type\";s:7:\"integer\";s:5:\"boost\";s:3:\"1.0\";}s:7:\"created\";a:4:{s:5:\"table\";s:29:\"search_api_db_product_display\";s:6:\"column\";s:7:\"created\";s:4:\"type\";s:4:\"date\";s:5:\"boost\";s:3:\"1.0\";}s:7:\"changed\";a:4:{s:5:\"table\";s:29:\"search_api_db_product_display\";s:6:\"column\";s:7:\"changed\";s:4:\"type\";s:4:\"date\";s:5:\"boost\";s:3:\"1.0\";}s:10:\"field_tags\";a:4:{s:5:\"table\";s:40:\"search_api_db_product_display_field_tags\";s:6:\"column\";s:5:\"value\";s:4:\"type\";s:13:\"list<integer>\";s:5:\"boost\";s:3:\"1.0\";}s:21:\"field_simplenews_term\";a:4:{s:5:\"table\";s:29:\"search_api_db_product_display\";s:6:\"column\";s:21:\"field_simplenews_term\";s:4:\"type\";s:7:\"integer\";s:5:\"boost\";s:3:\"1.0\";}s:13:\"field_product\";a:4:{s:5:\"table\";s:43:\"search_api_db_product_display_field_product\";s:6:\"column\";s:5:\"value\";s:4:\"type\";s:13:\"list<integer>\";s:5:\"boost\";s:3:\"1.0\";}s:14:\"field_category\";a:4:{s:5:\"table\";s:29:\"search_api_db_product_display\";s:6:\"column\";s:14:\"field_category\";s:4:\"type\";s:7:\"integer\";s:5:\"boost\";s:3:\"1.0\";}s:11:\"field_brand\";a:4:{s:5:\"table\";s:29:\"search_api_db_product_display\";s:6:\"column\";s:11:\"field_brand\";s:4:\"type\";s:7:\"integer\";s:5:\"boost\";s:3:\"1.0\";}s:19:\"search_api_language\";a:4:{s:5:\"table\";s:29:\"search_api_db_product_display\";s:6:\"column\";s:19:\"search_api_language\";s:4:\"type\";s:6:\"string\";s:5:\"boost\";s:3:\"1.0\";}s:47:\"field_product_commerce_price_amount_decimal_asc\";a:4:{s:5:\"table\";s:29:\"search_api_db_product_display\";s:6:\"column\";s:47:\"field_product_commerce_price_amount_decimal_asc\";s:4:\"type\";s:7:\"decimal\";s:5:\"boost\";s:3:\"1.0\";}s:48:\"field_product_commerce_price_amount_decimal_desc\";a:4:{s:5:\"table\";s:29:\"search_api_db_product_display\";s:6:\"column\";s:48:\"field_product_commerce_price_amount_decimal_desc\";s:4:\"type\";s:7:\"decimal\";s:5:\"boost\";s:3:\"1.0\";}s:24:\"search_api_aggregation_1\";a:3:{s:5:\"table\";s:34:\"search_api_db_product_display_text\";s:4:\"type\";s:4:\"text\";s:5:\"boost\";s:3:\"1.0\";}s:24:\"search_api_aggregation_2\";a:3:{s:5:\"table\";s:34:\"search_api_db_product_display_text\";s:4:\"type\";s:4:\"text\";s:5:\"boost\";s:3:\"1.0\";}s:24:\"search_api_aggregation_3\";a:3:{s:5:\"table\";s:34:\"search_api_db_product_display_text\";s:4:\"type\";s:4:\"text\";s:5:\"boost\";s:3:\"1.0\";}s:24:\"search_api_aggregation_4\";a:3:{s:5:\"table\";s:34:\"search_api_db_product_display_text\";s:4:\"type\";s:4:\"text\";s:5:\"boost\";s:3:\"1.0\";}s:24:\"search_api_aggregation_5\";a:3:{s:5:\"table\";s:34:\"search_api_db_product_display_text\";s:4:\"type\";s:4:\"text\";s:5:\"boost\";s:3:\"1.0\";}s:24:\"search_api_aggregation_6\";a:3:{s:5:\"table\";s:34:\"search_api_db_product_display_text\";s:4:\"type\";s:4:\"text\";s:5:\"boost\";s:3:\"1.0\";}s:15:\"field_tags:name\";a:4:{s:5:\"table\";s:45:\"search_api_db_product_display_field_tags_name\";s:6:\"column\";s:5:\"value\";s:4:\"type\";s:12:\"list<string>\";s:5:\"boost\";s:3:\"1.0\";}s:26:\"field_simplenews_term:name\";a:4:{s:5:\"table\";s:29:\"search_api_db_product_display\";s:6:\"column\";s:26:\"field_simplenews_term_name\";s:4:\"type\";s:6:\"string\";s:5:\"boost\";s:3:\"1.0\";}s:19:\"field_category:name\";a:4:{s:5:\"table\";s:29:\"search_api_db_product_display\";s:6:\"column\";s:19:\"field_category_name\";s:4:\"type\";s:6:\"string\";s:5:\"boost\";s:3:\"1.0\";}s:16:\"field_brand:name\";a:4:{s:5:\"table\";s:29:\"search_api_db_product_display\";s:6:\"column\";s:16:\"field_brand_name\";s:4:\"type\";s:6:\"string\";s:5:\"boost\";s:3:\"1.0\";}s:43:\"field_product:commerce_price:amount_decimal\";a:4:{s:5:\"table\";s:62:\"search_api_db_product_display_field_product_commerce_price_amo\";s:6:\"column\";s:5:\"value\";s:4:\"type\";s:13:\"list<decimal>\";s:5:\"boost\";s:3:\"1.0\";}s:25:\"field_category:vocabulary\";a:4:{s:5:\"table\";s:29:\"search_api_db_product_display\";s:6:\"column\";s:25:\"field_category_vocabulary\";s:4:\"type\";s:7:\"integer\";s:5:\"boost\";s:3:\"1.0\";}s:21:\"field_category:parent\";a:4:{s:5:\"table\";s:51:\"search_api_db_product_display_field_category_parent\";s:6:\"column\";s:5:\"value\";s:4:\"type\";s:13:\"list<integer>\";s:5:\"boost\";s:3:\"1.0\";}s:26:\"field_category:parents_all\";a:4:{s:5:\"table\";s:56:\"search_api_db_product_display_field_category_parents_all\";s:6:\"column\";s:5:\"value\";s:4:\"type\";s:13:\"list<integer>\";s:5:\"boost\";s:3:\"1.0\";}}}}',1,1,NULL);
/*!40000 ALTER TABLE `search_api_server` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_api_sort`
--

DROP TABLE IF EXISTS `search_api_sort`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_api_sort` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a sort.',
  `identifier` varchar(255) NOT NULL COMMENT 'The identifier for this sort.',
  `index_id` varchar(50) NOT NULL COMMENT 'The search_api_index.machine_name this sort belongs to.',
  `field` varchar(255) NOT NULL COMMENT 'The index field this sort belongs to.',
  `name` varchar(80) NOT NULL COMMENT 'The human-readable name to be displayed for this sort.',
  `enabled` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'A flag indicating whether the sort is enabled.',
  `default_sort` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A flag indicating whether the sort is the default sort for the index.',
  `default_sort_no_terms` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A flag indicating whether the sort is the default sort for the index when there are no search terms present.',
  `default_order` varchar(4) NOT NULL DEFAULT 'desc' COMMENT 'The default order for this field.',
  `weight` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A weight field determining the sort order of the sorts in the block.',
  `status` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'The exportable status of the entity.',
  `module` varchar(255) DEFAULT NULL COMMENT 'The name of the providing module if the entity has been defined in code.',
  PRIMARY KEY (`id`),
  KEY `field` (`index_id`,`field`(50)),
  KEY `enabled` (`enabled`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores all activated or configured sorts of a site.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_api_sort`
--

LOCK TABLES `search_api_sort` WRITE;
/*!40000 ALTER TABLE `search_api_sort` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `search_api_sort` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_api_task`
--

DROP TABLE IF EXISTS `search_api_task`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_api_task` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'An integer identifying this task.',
  `server_id` varchar(50) NOT NULL COMMENT 'The search_api_server.machine_name for which this task should be executed.',
  `type` varchar(50) NOT NULL COMMENT 'A keyword identifying the type of task that should be executed.',
  `index_id` varchar(50) DEFAULT NULL COMMENT 'The search_api_index.machine_name to which this task pertains, if applicable for this type.',
  `data` mediumtext COMMENT 'Some data needed for the task, might be optional depending on the type.',
  PRIMARY KEY (`id`),
  KEY `server` (`server_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores pending tasks for servers.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_api_task`
--

LOCK TABLES `search_api_task` WRITE;
/*!40000 ALTER TABLE `search_api_task` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `search_api_task` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_dataset`
--

DROP TABLE IF EXISTS `search_dataset`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_dataset` (
  `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Search item ID, e.g. node ID for nodes.',
  `type` varchar(16) NOT NULL COMMENT 'Type of item, e.g. node.',
  `data` longtext NOT NULL COMMENT 'List of space-separated words from the item.',
  `reindex` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Set to force node reindexing.',
  PRIMARY KEY (`sid`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores items that will be searched.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_dataset`
--

LOCK TABLES `search_dataset` WRITE;
/*!40000 ALTER TABLE `search_dataset` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `search_dataset` VALUES (7,'node',' blueant pump hd wireless bluetooth waterproof headphones blueant pump hd wireless bluetooth waterproof headphones ',0),(8,'node',' banner 2 terminus t02297lap01 laptop backpack plus ',0),(11,'node',' feature firetv feature firetv ',0),(12,'node',' driver smarter driver smarter ',0),(13,'node',' the living room halloween shop ',0),(14,'node',' get 20 off instantly get 20 off instantly ',0),(16,'node',' payment pricing read about the variety of payment options offered on the apple online store and how the tax on your order is calculated also get more information about special pricing offers promotions and other great deals with limited time availability choose a topic payment tax pricing promotions rebates and coupons payment payment methods the apple online store accepts a variety of payment methods click on a payment method below to find out more  credit cards or debit cards cash note business lease wire transfers cashier s checks and money orders are ineligible payment methods for pickup items some payment types are ineligible for orders shipping to multiple addresses if you are using an ineligible payment type for an order shipping to multiple addresses you will need to change the payment method or ship your order to a single address some customers may qualify for other forms of payment please call an our store specialist at 1800 for more information tax tax rate in accordance with state and local law your apple online store purchases will be taxed using the applicable sales tax or seller s use tax rate for your shipping address or the apple store address where the item is picked up the tax listed during checkout is only an estimate in california and rhode island sales tax is collected on the unbundled price of the iphone aliquam erat volutpat phasellus facilisis nulla lacus your invoice will reflect the final total tax which includes state and local taxes as well as any applicable rebates or fees pricing in accordance with state and local law your apple online store purchases will be taxed using the applicable sales tax or seller s use tax rate for your shipping address or the apple store address where the item is picked up the tax listed during checkout is only an estimate in california and rhode island sales tax is collected on the unbundled price of the iphone your invoice will reflect the final total tax which includes state and local taxes as well as any applicable rebates or fees promotions rebates and coupons in accordance with state and local law your apple online store purchases will be taxed using the applicable sales tax or seller s use tax rate for your shipping address or the apple store address where the item is picked up  ',0),(17,'node',' how to buy lorem ipsum dolor sit amet consectetur adipiscing elit integer varius facilisis eros id posuere praesent sed turpis laoreet aliquam metus a fringilla libero quisque ac porta est vestibulum consequat posuere laoreet cras tincidunt faucibus velit euismod egestas est sollicitudin ut vestibulum luctus placerat dui eu ullamcorper fusce sodales mi et sodales scelerisque etiam varius semper est sed aliquet neque venenatis vel etiam non metus nec augue auctor eleifend id in est nulla id erat velit maecenas quis ex ultricies dignissim ante et euismod arcu cras nulla arcu ullamcorper at viverra vel aliquet vel nunc pellentesque dapibus auctor nibh sed rhoncus diam aliquet in etiam condimentum metus vitae tortor egestas id tincidunt purus luctus morbi sagittis aliquam dui nec semper nulla malesuada eu donec eleifend molestie justo pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas nullam gravida turpis at ullamcorper porta aenean ac magna felis nulla blandit urna non aliquam tempus fusce ultricies laoreet velit tempus condimentum purus aliquet a nullam ut sapien vel neque ornare convallis sit amet ut felis donec convallis consectetur lorem dictum lobortis ex pretium vitae proin hendrerit feugiat vulputate duis ultricies erat ut tincidunt feugiat sapien ipsum pulvinar purus eu bibendum tellus leo consequat metus donec quis dictum nisl quisque non lectus tellus etiam sit amet tincidunt leo morbi pretium rhoncus purus et rhoncus orci sollicitudin vel mauris efficitur nisl eu leo imperdiet elementum duis ut consectetur augue etiam rutrum placerat volutpat suspendisse vitae tempor urna a hendrerit sapien sed molestie imperdiet dolor et varius aliquam id metus bibendum pulvinar erat eget posuere elit aenean mattis id orci ac feugiat nunc pharetra congue lectus at sollicitudin donec ultricies nunc a varius tincidunt nulla odio tincidunt justo nec malesuada augue nulla in purus nullam id quam orci mauris eu ante at elit malesuada dictum maecenas bibendum odio et porta euismod neque augue tristique velit sit amet imperdiet felis sapien sed ante nullam consequat libero libero id tempus tortor blandit eget nam aliquet nisi orci sed placerat velit volutpat quis donec pulvinar magna et turpis auctor aliquam suspendisse et diam dignissim maximus tellus eget maximus ligula vivamus feugiat pellentesque metus sit amet accumsan ligula posuere quis sed vitae metus sit amet neque iaculis cursus fusce luctus at massa sed euismod phasellus mollis suscipit purus quis facilisis leo maximus in sed sagittis mi sed diam gravida laoreet praesent scelerisque mi efficitur dictum imperdiet elit massa volutpat ipsum non venenatis felis lectus eu est aliquam libero justo lobortis eget felis vel tincidunt ultricies quam nunc et augue lacinia dignissim augue sit amet vehicula nisi duis varius elit a tellus imperdiet vel ultricies mi viverra suspendisse aliquet eu justo id eleifend ut consequat ac lectus nec tincidunt  ',0),(18,'node',' shipping pickup you can purchase your items online and pick them up at an apple store or ship them directly to your doorstep here you ll find everything you need to know about pickup shipping and much more choose a topic shipping delivery personal pickup what s next  text notifications carrier delivery options shipping policies shipping delivery standard return policy the apple online store accepts a variety of payment methods click on a payment method below to find out more  credit cards or debit cards cash note business lease wire transfers cashier s checks and money orders are ineligible payment methods for pickup items some payment types are ineligible for orders shipping to multiple addresses if you are using an ineligible payment type for an order shipping to multiple addresses you will need to change the payment method or ship your order to a single address some customers may qualify for other forms of payment please call an our store specialist at 1800 for more information personal pickup ship your item back to store in accordance with state and local law your apple online store purchases will be taxed using the applicable sales tax or seller s use tax rate for your shipping address or the apple store address where the item is picked up the tax listed during checkout is only an estimate in california and rhode island sales tax is collected on the unbundled price of the iphone aliquam erat volutpat phasellus facilisis nulla lacus your invoice will reflect the final total tax which includes state and local taxes as well as any applicable rebates or fees what s next  in accordance with state and local law your apple online store purchases will be taxed using the applicable sales tax or seller s use tax rate for your shipping address or the apple store address where the item is picked up the tax listed during checkout is only an estimate in california and rhode island sales tax is collected on the unbundled price of the iphone your invoice will reflect the final total tax which includes state and local taxes as well as any applicable rebates or fees text notifications in accordance with state and local law your apple online store purchases will be taxed using the applicable sales tax or seller s use tax rate for your shipping address or the apple store address where the item is picked up carrier delivery options proin eget lacus ac eros dapibus mattis quisque a dui tellus aenean lorem velit porttitor sed rutrum vitae faucibus non lacus cum sociis natoque penatibus et magnis dis parturient montes nascetur ridiculus mus vivamus imperdiet aliquet justo blandit vestibulum nunc et venenatis dolor et fringilla felis shipping policies sed porta ligula vitae ullamcorper commodo sapien ipsum convallis quam ut semper quam sem vitae sem nulla congue mauris non dolor egestas gravida mauris justo dui vulputate id tempor at mollis non massa integer sit amet diam id nunc porttitor consequat maecenas id erat pretium efficitur neque a congue nisi donec interdum lacus nec risus ullamcorper auctor aliquam erat volutpat phasellus facilisis nulla lacus  ',0),(19,'node',' returns refunds apple wants you to be thrilled with your new purchase however if you need to return an item we re here to help choose a topic returns policy how to return refunds gift returns returns refunds policy standard return policy the apple online store accepts a variety of payment methods click on a payment method below to find out more  credit cards or debit cards cash note business lease wire transfers cashier s checks and money orders are ineligible payment methods for pickup items some payment types are ineligible for orders shipping to multiple addresses if you are using an ineligible payment type for an order shipping to multiple addresses you will need to change the payment method or ship your order to a single address some customers may qualify for other forms of payment please call an our store specialist at 1800 for more information how to return an item ship your item back to store in accordance with state and local law your apple online store purchases will be taxed using the applicable sales tax or seller s use tax rate for your shipping address or the apple store address where the item is picked up the tax listed during checkout is only an estimate in california and rhode island sales tax is collected on the unbundled price of the iphone aliquam erat volutpat phasellus facilisis nulla lacus your invoice will reflect the final total tax which includes state and local taxes as well as any applicable rebates or fees refunds in accordance with state and local law your apple online store purchases will be taxed using the applicable sales tax or seller s use tax rate for your shipping address or the apple store address where the item is picked up the tax listed during checkout is only an estimate in california and rhode island sales tax is collected on the unbundled price of the iphone your invoice will reflect the final total tax which includes state and local taxes as well as any applicable rebates or fees gift returns in accordance with state and local law your apple online store purchases will be taxed using the applicable sales tax or seller s use tax rate for your shipping address or the apple store address where the item is picked up  ',0),(20,'node',' order status proin at dui sed elit facilisis vehicula bibendum at ex cras a sapien dignissim consequat diam luctus condimentum ipsum aenean vitae tincidunt elit aenean vitae mauris tempor fermentum est ut scelerisque odio sed quam neque sagittis quis tempus vitae accumsan nec orci maecenas porttitor quam quis vehicula tempor proin purus nisl dictum id ultricies id tincidunt eu ligula mauris lobortis fringilla dolor non mattis donec sit amet commodo mi nullam rutrum nisi nulla sit amet blandit ipsum rutrum eget phasellus mattis ex eleifend pharetra volutpat eros eros bibendum ligula at convallis arcu sem eget leo cras elementum sodales velit quis efficitur praesent non tortor lobortis varius lectus et pulvinar nunc vestibulum consectetur urna tincidunt tellus malesuada vel auctor tellus lobortis mauris tellus neque maximus quis consequat et ullamcorper bibendum justo lorem ipsum dolor sit amet consectetur adipiscing elit morbi tristique sed nulla in tempor etiam sed quam sit amet massa suscipit consequat nec eget ligula aenean ac diam tincidunt condimentum enim eget ultrices lacus maecenas lacinia rutrum metus suspendisse viverra nibh pharetra mauris lacinia ac lobortis dolor suscipit curabitur ac placerat dui sit amet luctus ex curabitur a tellus lorem pellentesque interdum vitae velit nec sodales donec nec justo ac eros finibus ultrices sed convallis posuere tellus sit amet laoreet sed dignissim nisl vel pulvinar tempor in vestibulum dui convallis auctor metus et facilisis nulla proin dolor lorem dignissim et velit nec dictum vehicula ex maecenas ornare et turpis ac laoreet ut convallis est sit amet arcu porttitor laoreet vivamus ultrices velit in justo hendrerit eu facilisis dolor efficitur integer quis tellus posuere euismod tortor at dictum eros maecenas ut arcu leo  ',0),(21,'node',' about marketplace phasellus euismod nulla tristique aliquam eros non tristique mauris etiam rhoncus ipsum vitae nibh accumsan ut gravida mauris condimentum ut ullamcorper velit lobortis nibh tincidunt elementum sed suscipit cursus lacinia ut efficitur dictum arcu vitae dignissim aenean venenatis bibendum augue scelerisque dictum augue bibendum sit amet integer sit amet placerat justo sed porttitor ante cras bibendum magna augue ut congue urna cursus nec suspendisse vitae tortor cursus lectus pretium hendrerit vel sit amet risus nulla sed est condimentum gravida massa sed bibendum arcu integer vestibulum sollicitudin dignissim sed placerat nisl mi nec aliquam lectus ultricies id maecenas non ex quam integer malesuada nibh quis justo consectetur accumsan phasellus consectetur id dolor sed blandit in vel consequat sem nec fermentum urna cras scelerisque nunc semper accumsan mattis proin mollis sodales leo eget lacinia urna posuere nec vestibulum vulputate rutrum ex sit amet tempus lorem commodo et vestibulum et tincidunt elit eget tincidunt nibh in elementum maximus risus et ultrices nunc blandit non donec viverra ante at ante gravida sodales nunc lacinia nulla at commodo ornare vestibulum dictum laoreet viverra etiam sed neque ac quam tempus venenatis vivamus iaculis ipsum condimentum nibh venenatis venenatis integer laoreet ultricies nunc aenean placerat purus sed lectus scelerisque faucibus nulla eu diam eget metus sagittis sollicitudin ac eu lorem suspendisse sed odio nulla  ',0),(22,'node',' afﬁliate program register now earn up to 8 commision on sales with marketplace no1 online shopping mall list advertise choose from over a million products to advertise to your customers whether you are a large network content site or blogger we have simple linking tools to meet your advertising needs and help you monetize your web site linking tools usd earn get up to 10 in advertising fees earn advertising fees from qualifying purchases not just the products you advertised plus our competitive conversion rates help you maximize your earnings advertising fees reporting tools hand join it s easy and free to join get up and running today just one approval to join no thirdparty advertiser approvals learn more join now ',0),(23,'node',' terms conditions in vel tortor id turpis dignissim porttitor eu ac urna aenean in elit vel magna ultricies volutpat vestibulum vitae magna auctor dignissim purus ullamcorper varius sem sed nibh ex fringilla ac enim at iaculis maximus elit integer vitae gravida dolor nullam ultrices diam at tincidunt feugiat nunc magna euismod magna eu euismod odio sapien vel lacus etiam malesuada sodales ante eget semper phasellus viverra elementum gravida maecenas tincidunt posuere lorem eu tempus augue mollis et nam blandit viverra urna sit amet laoreet dolor auctor ac vivamus eu justo erat fusce mollis quis nunc a facilisis curabitur commodo lorem a tincidunt pellentesque mauris massa aliquam enim vel rutrum elit nisl ut mauris duis mattis neque arcu eu pulvinar libero maximus ut vestibulum eget facilisis diam proin eget ante diam donec pulvinar magna id est vestibulum et facilisis odio pellentesque fusce ut felis lorem quisque cursus libero non tempor imperdiet pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas donec at nibh nec lacus varius dapibus duis a lectus a augue interdum tempor sed ut arcu aenean fermentum lectus diam quis fermentum mi cursus ut pellentesque turpis nunc tempor et ullamcorper ac pellentesque in nibh maecenas quis risus et nibh varius iaculis ac vel leo nam quis facilisis odio vestibulum commodo sed est ut porta cras ut porta neque ac aliquam quam proin vel purus facilisis rhoncus nibh eget tincidunt nisi cras in posuere mi vivamus a convallis leo quisque in nisl venenatis rutrum odio vel gravida lacus vivamus id mauris nec ante dictum consectetur nullam vulputate nisi sit amet lectus pulvinar eu pretium ante sodales  ',0),(24,'node',' privacy policy we take our customer s privacy seriously and we will only collect record hold store disclose transfer and use your personal information as outlined below data protection is a matter of trust and your privacy is important to us we shall therefore only use your name and other information which relates to you in the manner set out in this privacy policy we will only collect information where it is necessary for us to do so and we will only collect information if it is relevant to our dealings with you we will only keep your information for as long as we are either required to by law or as is relevant for the purposes for which it was collected you can visit the platform as defined in the terms of use and browse without having to provide personal details during your visit to the platform you remain anonymous and at no time can we identify you unless you have an account on the platform and log on with your user name and password if you have any comments suggestions or complaints you may contact us and our data protection officer at customerservices marketplacecom collection of personal information when you create a marketplace account or otherwise provide us with your personal information through the platform the personal information we collect may include your name delivery address email address contact number mobile number date of birth gender you must only submit to us our authorized agent or the platform information which is accurate and complete and not misleading and you must keep it up to date and inform us of changes more information below we reserve the right to request for documentation to verify the information provided by you we will only be able to collect your personal information if you voluntarily submit the information to us if you choose not to submit your personal information to us or subsequently withdraw your consent to our use of your personal information we may not be able to provide you with our services you may access and update your personal information submitted to us at any time as described below if you provide personal information of any third party to us we assume that you have obtained the required consent from the relevant third party to share and transfer his her personal information to us if you sign up for marketplace using your social media account or link your marketplace account to your social media account or use certain other marketplace social media features we may access information about you which you have voluntarily provided under your social media account via that social media provider in accordance with the provider s policies and we will manage your personal data which we have collected in accordance with marketplace privacy policy use and disclosure of personal information the personal information we collect from you will be used or shared with third parties including related companies third party service providers and third party sellers for some or all of the following purposes to facilitate your use of the services as defined in the terms of use and or access to the platform to process orders you submit through the platform whether the products are sold by marketplace or a third party seller payments that you make through the platform for products whether sold by marketplace or a third party seller will be processed by our agent to deliver the products you have purchased through the platform whether sold by marketplace or a third party seller we may pass your personal information on to a third party in order to make delivery of the product to you for example to our courier or supplier whether the product is sold through the platform by marketplace or a third party seller to update you on the delivery of the products whether sold through the platform by marketplace or a third party seller and for customer support purposes to compare information and verify with third parties in order to ensure that the information is accurate further we will use the information you provide to administer your account if any with us verify and carry out financial transactions in relation to payments you make online audit the downloading of data from the platform improve the layout and or content of the pages of the platform and customize them for users identify visitors on the platform carry out research on our users demographics and behavior provide you with information we think you may find useful or which you have requested from us including information about our or third party sellers products and services provided you have indicated that you have not objected to being contacted for these purposes when you register an account with marketplace or otherwise provide us with your personal information through the platform we will also use your personal information to send you marketing and or promotional materials about our or third party sellers products and services from time to time you can unsubscribe from receiving marketing information at any time by using the unsubscribe function within the electronic marketing material we may use your contact information to send newsletters from us and from our related companies and in exceptional circumstances marketplace may be required to disclose personal information such as when there are grounds to believe that the disclosure is necessary to prevent a threat to life or health for law enforcement purposes or for fulfillment of legal and regulatory requirements and requests marketplace may share your personal information with third parties and our affiliates for the abovementioned purposes specifically completing a transaction with you managing your account and our relationship with you marketing and fulfilling any legal or regulatory requirements and requests as deemed necessary by marketplace in sharing your personal information with them we endeavor to ensure that the third parties and our affiliates keep your personal information secure from unauthorized access collection use disclosure or similar risks and retain your personal information only for as long as they need your personal information to achieve the abovementioned purposes in disclosing or transferring your personal information to third parties and our affiliates located overseas marketplace take steps to ensure that the receiving jurisdiction has in place a standard of protection accorded to personal information that is comparable to the protection under or up to the standard of the philippine data privacy act marketplace does not engage into the business of selling customers personal information to third parties withdrawal of consent you may communicate your objection to our continual use and or disclosure of your personal information for any of the purposes and in the manner as stated above at any time by contacting us at our email address below please note that if you communicate your objection to our use and or disclosure of your personal information for the purposes and in the manner as stated above depending on the nature of your objection we may not be in a position to continue to provide our products or services to you or perform on any contract we have with you our legal rights and remedies are expressly reserved in such event updating your personal information you can update your personal information anytime by accessing your account on the marketplace platform if you do not have an account with us you can do so by contacting us at our email address below we take steps to share the updates to your personal information with third parties and our affiliates with whom we have shared your personal information if your personal information is still necessary for the above stated purposes accessing your personal information if you would like to view the personal information we have on you or inquire about the ways in which your personal information has been or may have been used or disclosed by marketplace within the past year please contact us at our email address below we reserve the right to charge a reasonable administrative fee for retrieving your personal information records if you have an account with marketplace you may access details of your order by logging into your account on the platform here you can view the details of your orders that have been completed those which are open and those which are shortly to be dispatched and administer your address details bank details and any newsletter to which you may have subscribed you undertake to treat your marketplace username password and order details confidentially and not make it available to unauthorized third parties we cannot assume any liability for misuse of your marketplace username password or order details except as stated in the terms of use security of your personal information marketplace ensures that all information collected will be safely and securely stored we protect your personal information by restricting access to personal information maintaining technology products to prevent unauthorized computer access securely destroying your personal information when it is no longer needed for any legal or business purpose marketplace uses 128bit ssl secure sockets layer encryption technology when processing your financial details 128bit ssl encryption is approximated to take at least one trillion years to break and is the industry standard if you believe that your privacy has been breached by marketplace please contact us at our email address below your password is the key to your account please use unique numbers letters and special characters and do not share your marketplace password to anyone if you do share your password with others you will be responsible for all actions taken in the name of your account and the consequences if you lose control of your password you may lose substantial control over your personal information and other information submitted to marketplace you could also be subject to legally binding actions taken on your behalf therefore if your password has been compromised for any reason or if you have grounds to believe that your password has been compromised you should immediately contact us and change your password you are reminded to log off of your account and close the browser when finished using a shared computer minor marketplace does not sell products for purchase by children if you are under 18 years old you may use our website only with the involvement of a parent or guardian collection of computer data marketplace or our authorized service providers may use cookies web beacons and other similar technologies for storing information to help provide you with a better faster safer and personalized experience when you use the services and or access the platform when you visit marketplace our company servers will automatically record information that your browser sends whenever you visit a website this data may include your computer s ip address browser type webpage you were visiting before you came to our platform the pages within the platform which you visit the time spent on those pages items and information searched for on the platform access times and dates and other statistics this information is collected for analysis and evaluation in order to help us improve the platform and the services and products we provide cookies are small text files typically made up of letters and numbers placed in the memory of your browser or device when you visit a website or view a message they allow us to recognize a particular device or browser and help us to personalize the content to match your preferred interests more quickly and to make our services and platform more convenient and useful to you web beacons are small graphic images that may be included on our service and the platform they allow us to count users who have viewed these pages so that we can better understand your preference and interests no spam spyware or virus spam spyware or virus is not allowed on platform please set and maintain your communication preferences so that we send communications to you as you prefer you are not licensed or otherwise allowed to add other users even a user who has purchased an item from you to your mailing list email or physical mail without their express consent you should not send any messages which contain spam spyware or virus via the platform if you would like to report any suspicious messages please contact us at our email address below changes to the privacy policy marketplace shall regularly review the sufficiency of this privacy policy we reserve the right to modify and change the privacy policy at any time any changes to this policy will be published on the platform marketplace s right you acknowledge and agree that marketplace has the right to disclose your personal information to any legal regulatory governmental tax law enforcement or other authorities or the relevant right owners if marketplace has reasonable grounds to believe that disclosure of your personal information is necessary for the purpose of meeting any obligations requirements or arrangements whether voluntary or mandatory as a result of cooperating with an order an investigation and or a request of any nature by such parties to the extent permissible by applicable law you agree not to take any action and or waive your rights to take any action against marketplace for the disclosure of your personal information in these circumstances contacting marketplace if you wish to withdraw your consent to our use of your personal information request access and or correction of your personal information have any queries comments or concerns or require any help on technical or cookierelated matters please feel free to contact us and our data protection officer at customerservices marketplacecom ',0),(26,'node',' sell on marketplace individuals and businesses can list products on marketplace one of the fastest ways to start selling online more than 20 categories to sell in trusted marketplace platform no peritem listing fee selling on marketplace makes it possible for us to reach a global audience with our innovative products  bernie thompson founder plugable technologies how selling on marketplace works upload upload your listings add your offers to the marketplace catalog using feeds spreadsheets and other tools desktop customers can see your products on marketplacecom with features like 1click and a brand millions trust marketplace helps customers make quick easy worryfree purchases truck ship products to customers marketplace notifies you when customers place an order use fulfillment by marketplace and let marketplace do the shipping for you or handle shipping yourself usd marketplace transfers payments to you marketplace deposits payment into your bank account at regular intervals and notifies you that your payment has been sent selling on marketplace makes it possible for us to reach a global audience with our innovative products  bernie thompson founder plugable technologies  offer limited to new professional selling on amazon subscriptions only offer is not available to sellers who have previously registered to list on amazoncom offer includes one month of subscription fees only you will be charged other fees including referral fees for items that sell on amazoncom a credit of 3999 will be posted to your seller account to offset one month of subscription fees charged other limitations apply after the trial period we will automatically charge your credit card the monthly subscription fee at the beginning of every month thereafter  ',0),(27,'node',' about us marketplace is the number one online shopping site marketplace offers a wide array of products and provides convenient online shopping experience with its nationwide shipping warranties 30day returns policy and easy payment options consumers can shop anytime and anywhere for books electronics phones accessories computers home living hardware home appliances toys kids babies travel and luggage beauty jewelry watches fashion and sports how to shop at marketplace it s simple to shop at marketplace select your products at marketplace register with us and pick a payment option have your products delivered quickly and safely safe and secure shoppinge after making your selection check out and pick a payment method paypal credit card installments available and cash on delivery after a successful transaction you will get an order status and tracking number that lets you keep track of your order until it is delivered to you safe and secure delivery your orders take utmost priority and will be delivered between 35 working days for metro manila and 510 working days for provincial orders should you have any questions on your order please contact our customer service representatives between 8am to 9pm monday to friday or between 9am to 6pm saturday sunday and holiday at the contact page or 2 795 8900 and we shall gladly assist you returns if your product is damaged or incomplete upon delivery please contact marketplace s customer service representatives  contact page or 2 795 8900 within 24 hours of delivery to initiate the return you have 30 thirty days from day of delivery to return your order with a completed return form  the cost of return will be refunded after your return has been processed comprehensive and personal service our customers can contact us between 8am to 9pm monday to friday or between 9am to 6pm saturday sunday and holiday at contact page or 2 795 8900 to check the status of your order ask any question about lazada or give feedback on your shopping experience marketplace part of online revolution marketplace is a participant of the online revolution ecommerce event a southeast asian monthlong online sale event similar to black friday and cyber monday aiming to support the evolution of the asian online culture thanks to fastgrowing ventures and adapting consumers in the philippines our partner ventures include zalora the country s leading online fashion store lamido the online marketplace for buyers to meet sellers carmudi the online car dealership lamudi the online realestate listing and easy taxi your taxi is 1 click away  ',0),(28,'node',' contact us company contact informattion fields marked are required first name last name company name country none afghanistan aland islands albania algeria american samoa andorra angola anguilla antarctica antigua and barbuda argentina armenia aruba australia austria azerbaijan bahamas bahrain bangladesh barbados belarus belgium belize benin bermuda bhutan bolivia bosnia and herzegovina botswana bouvet island brazil british indian ocean territory british virgin islands brunei bulgaria burkina faso burundi cambodia cameroon canada cape verde caribbean netherlands cayman islands central african republic chad chile china christmas island cocos keeling islands colombia comoros congo brazzaville congo kinshasa cook islands costa rica croatia cuba curaçao cyprus czech republic denmark djibouti dominica dominican republic ecuador egypt el salvador equatorial guinea eritrea estonia ethiopia falkland islands faroe islands fiji finland france french guiana french polynesia french southern territories gabon gambia georgia germany ghana gibraltar greece greenland grenada guadeloupe guam guatemala guernsey guinea guineabissau guyana haiti heard island and mcdonald islands honduras hong kong sar china hungary iceland india indonesia iran iraq ireland isle of man israel italy ivory coast jamaica japan jersey jordan kazakhstan kenya kiribati kuwait kyrgyzstan laos latvia lebanon lesotho liberia libya liechtenstein lithuania luxembourg macao sar china macedonia madagascar malawi malaysia maldives mali malta marshall islands martinique mauritania mauritius mayotte mexico micronesia moldova monaco mongolia montenegro montserrat morocco mozambique myanmar namibia nauru nepal netherlands netherlands antilles new caledonia new zealand nicaragua niger nigeria niue norfolk island northern mariana islands north korea norway oman pakistan palau palestinian territory panama papua new guinea paraguay peru philippines pitcairn poland portugal puerto rico qatar reunion romania russia rwanda saint barthélemy saint helena saint kitts and nevis saint lucia saint martin french part saint pierre and miquelon saint vincent and the grenadines samoa san marino sao tome and principe saudi arabia senegal serbia seychelles sierra leone singapore sint maarten slovakia slovenia solomon islands somalia south africa south georgia and the south sandwich islands south korea south sudan spain sri lanka sudan suriname svalbard and jan mayen swaziland sweden switzerland syria taiwan tajikistan tanzania thailand timorleste togo tokelau tonga trinidad and tobago tunisia turkey turkmenistan turks and caicos islands tuvalu us virgin islands uganda ukraine united arab emirates united kingdom united states united states minor outlying islands uruguay uzbekistan vanuatu vatican venezuela vietnam wallis and futuna western sahara yemen zambia zimbabwe telephone email comments and or details  ',0),(29,'node',' how can we help  we want you to have the simplest easiest buying experience possible but we know you might have a few questions read on for details about purchasing shipping checking order status returns and more  ',0),(30,'node',' aeroline casual hiking backpack dark blue not just any backpack aeroline casual hiking backpack is ideal when going for that hike weekend camping rendezvous or traveling it is a great choice to bring around to help ease the load or lend a helping shoulder in those adventurous moments ergonomically designed aeroline s backpack is ergonomically designed to accommodate 35 liters worth of essentials such as clothes food and medicine to prepare you for any situations this pack provides you with a large compartment with a small interior zippered compartment a medium compartment and two side pockets fret not of downpours or a little sprinkle as it is waterproof and wear resistant to match your toughness tough on everything else except for you as a user friendly pack it is designed in a way to fit perfectly snugged including a waist strap with buckle to reduce pressure on your spine and shoulder and back support paddings thus making your walks and climbs a more comfortable one made out of superior ripstop waterproof nylon cloth you can pretty much go through any weather suitable for adventurous backpackers mountain climbers and travellers description sku ae217faapmf5anmy727141 size l x w x h 31 x 18 x 51 weight 8 aeroline casual hiking backpack dark blue aeroline  no votes yet 7900 52 3800 color blue orange quantity 300 store weebpal  ',0),(31,'node',' local lion water resistant hiking backpack bag 28l blue planning for a weekend getaway from the city jungle diving into the lush greenery trail and wide blue ocean for some relaxing time then pack all your gears into the local lion water resistant hiking backpack bag 28l sky blue its duffle style cavernous space can suck in your travel clothes smartphone camera and even laptop so snap your quickie holiday with this backpack now this bag is dedicated to keep you connected even during your wild jungle adventure the local lion water resistant hiking backpack bag 28l sky bluebackpack is designed with your active lifestyle in mind made of high quality material the cool fabric will hurdle any tear or slash on its track without ripping any further damage put in everything  the main interior of this backpack is big enough to slap in your laptop multiple zipped pockets and sleeves are made readily available to store your gadget accompanying accessories so stash in your mp3 player smartphone power bank charging cables and camera its convenient and hard underbelly strips will provide extra protection from your bumpy journey cushiony comfort long hours of backpacking this bag will be easy as a breeze lightweight and compact the back and shoulder straps are padded with super cushion for your ultimate comfort looking pretty good cut out with the most trendy pattern pole in town this backpack is specially design to look fashionable and functional plus this backpack colourfast material can even withstand multiple washing after a rough day in the outdoor durable it will always come out pretty sleek just like new  description sku lo024faaksj4anmy530660 model b0008 orange size l x w x h 52x18x33 weight 9 local lion water resistant hiking backpack bag 28l blue local lion  no votes yet 17900 45 9900 color blue green orange red quantity 100 store weebpal material nylon multiple comparments spacious designdurable fitsyourlaptop  ',0),(32,'node',' terminus t02297lap01 laptop backpack plus stay stylish with a laptop bag from terminus this terminus t02297lap01 laptop backpack plus is not only made to appear fashionable but it is also designed with an ergonomic shape the laptop backpack comes with a front compartment that is ideal for storing paper documents power adapter mouse and other laptop accessories the laptop compartment can fit a 145 laptop and there is a padded compartment that could fit an ipad or a tablet not only that the bag is lightweight and robust but it is also elastic to slip over a trolley luggage handle this bag is great to bring on a travel or even for everyday use it will never fail to keep your belongings safe secure and within reach about terminus terminus is a worldclass design oriented brand a brand that creates many innovations with no boundaries and a home grown brand that draws its inspiration from all over the world there is no other brand like terminus who focuses their designs based on this direction designs inspired by talented designers from different countries for a truly global style every terminus product is designed to the highest standards of functionality appearance fashion and hand feels whether it s for a sophisticated professional or active lifestyle you will find innovations and conveniences you didn t think possible till you see a terminus bag bags that wow and work  description sku te960faakjc3anmy515575 model t02297lap01 size l x w x h 33x15x40 weight 50 terminus t02297lap01 laptop backpack plus terminus  no votes yet 29900 12 26400 quantity 100 store weebpal  ',0),(33,'node',' targus tsb166ap 156in revolution backpack xl the targus 156in revolution backpack is a sporty and all purpose backpacks that provide high functionality rugged protection featuring antiscratch material this backpack can prevent any scratches to the surface of your laptop the design of this backpack less resembles traditional laptop backpack hence it is the perfect daytoday backpack even without carrying the laptop around with special attention to the user experience the back panel and shoulder straps are designed with the maximum comfort and protection featuring a extra large full zipdown main compartment users and put and take items to and from this backpack easily without the hassle of digging with the high grade material and the design of raincover this backpack can provide superior protection to the items inside this revolution backpack is truly designed for the adventurous individuals description sku ta452faal25aanmy544771 model targustsb166ap50bk size l x w x h 3746 x 2603 x 388 weight 163kg material polyester targus tsb166ap 156in revolution backpack xl targus  no votes yet 41800 24 31800 quantity 500 store weebpal aliquam erat volutpat phasellus facilisis nulla lacus cras ex dolor consectetur sit amet auctor iaculis porttitor sit amet justo sed sed gravida tellus  ',0),(34,'node',' tarantula shoe bag bos04088shb03 red description sku ta073faaqqfqanmy793372 size l x w x h 9 x 135 x 45 weight 4 tarantula shoe bag bos04088shb03 red tarantula  no votes yet 3500 quantity 400 store weebpal zippered main compartment zippered back compartment for towel or slipper neoprene grab handle  ',0),(35,'node',' diniwell waterresistant travel shoes bag pouch organizer bag ver 2 orange   description sku di503faap8lhanmy703741 model b00773 size l x w x h 12 x 215 x 29 weight 26 warranty period 1 month warranty type local supplier warranty diniwell waterresistant travel shoes bag pouch organizer bag ver 2 orange diniwell  no votes yet 9900 59 4100 quantity 1000 store marketplace  ',0),(36,'node',' 24piece makeup brush set applying makeup and enhancing looks on the go is made easy thanks to this 24piece makeup brush set featuring natural syntheticblend fibres for supreme softness the premium quality makeup brushes will be delivered to makeup mavens doors in a black travel pouch specification features material brush soft synthetic fibres and pony hair handle bamboo ferrule aluminium pouch pu leather colour black and wooden handle individually handcrafted with high quality materials each brush comes with own plastic cover and compartment rollup pouch for easy travel and storage plasticlined pouch with waterproof exterior for added protection description sku oe702hbamqybanmy647350 size l x w x h 18 x 10 x 5 weight 3 months warranty period local supplier warranty 24piece makeup brush set oem  no votes yet 19900 78 4300 quantity 500 store marketplace brush soft synthetic fibres and pony hair handle bamboo ferrule aluminium pouch pu leather  ',0),(37,'node',' cameleon makeup kit 396 in vel tortor id turpis dignissim porttitor eu ac urna aenean in elit vel magna ultricies volutpat vestibulum vitae magna auctor dignissim purus ullamcorper varius sem sed nibh ex fringilla ac enim at iaculis maximus elit integer vitae gravida dolor nullam ultrices diam at tincidunt feugiat nunc magna euismod magna eu euismod odio sapien vel lacus etiam malesuada sodales ante eget semper phasellus viverra elementum gravida maecenas tincidunt posuere lorem eu tempus augue mollis et nam blandit viverra urna sit amet laoreet dolor auctor ac vivamus eu justo erat fusce mollis quis nunc a facilisis curabitur commodo lorem a tincidunt pellentesque mauris massa aliquam enim vel rutrum elit nisl ut mauris duis mattis neque arcu eu pulvinar libero maximus ut vestibulum eget facilisis diam proin eget ante diam donec pulvinar magna id est vestibulum et facilisis odio pellentesque fusce ut felis lorem quisque cursus libero non tempor imperdiet pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas donec at nibh nec lacus varius dapibus duis a lectus a augue interdum tempor sed ut arcu  description sku ca065hbas3ukanmy866687 mode makeup kit 396 48x eyeshadow 24x lip color 2x pressed powder 4x blusher 5x applicator size l x w x h 10x10x10 weight 4 cameleon makeup kit 396 cameleon  no votes yet 5000 quantity 200 store marketplace 48x eyeshadow 24x lip color 2x pressed powder 4x blusher 5x applicatorwell coordinated trendy color fine texture glides on smoothly on skin velvety smooth staytrue color  ',0),(38,'node',' 4 in 1 function power perfect pore facial face care blackhead cleaner power perfect pore with mist function maintains clean healthy and radiant looking skin without embarrassing blackheads or whiteheads its deep penetrating suction cleanses below the surface to effectively help prevent breakouts no more squeezing pulling or injuring your skin power perfect pore facial kit is perfect solution for clean clear and fair skin no blackheads no pimples no dark circles no wrinkles power perfect pore is easy to operate it cleans clears the skin use it with cream or moisturizer for gentle massage and better absorption power pore facial  ergonomically designed suction cup removes black heads without hurting your skin with hard squeezing face suction cup cleans pores and black heads from your skin by its suction technology contour massager tones face muscles stimulate blood vessels and thus improve blood circulation cleaning sponge helps you to spread facial cream evenly on your face to get maximum benefits of it exfoliation brush with mist function renews skin by removal of dead cells of face and makes your skin glow description sku oe702hbat78lanmy922903 model power perfect pore size l x w x h 16 x 13 x 8 weight 2 4 in 1 function power perfect pore facial face care blackhead cleaner oem  no votes yet 33000 88 3900 quantity 1000 store marketplace  ',0),(39,'node',' skii 5piece skincare travel set 5pcs travel packs skii sk2 skii 5piece skincare travel set includes facial treatment gentle cleanser 20g skii facial treatment gentle cleanser cares for your skin while it cleanses it contains concentrated pitera and mild treatment essence that leaves your skin hydrated even 30 minutes after cleansing work up a finetextured lather and enjoy its mild rose scent facial treatment clear lotion 30ml for perfectly conditioned and ultrafresh skin use the facial treatment clear lotion morning and evening after cleansing your face and neck the final part of your cleansing process this lotion helps remove residual impurities and dead skin cells facial treatment essence 30ml skii facial treatment essence is also known as skii miracle water the heart of the skii ritual the revolutionary facial treatment essence is the second point of your ritual facial treatment mask 1pc boosts radiance and moisture levels and can be used by all skin types throughout the year the mask literally drenches your skin in skii pitera resulting in a fresher and more hydrated complexion description sku sk159hbasxk7anmy908752 skii 5piece skincare travel set 5pcs travel packs skii sk2 sk ii  no votes yet 29900 20 23800 quantity 600 store marketplace facial treatment gentle cleanser 20g  ',0),(40,'node',' organic eye cream 15ml revive and restore skin around eyes with this moisturising antioxidant cream containing a special blend of green tea eyebright and buckwheat extract made with 85 organic ingredients and certified to the strict soil association organic skin care standards also vegan products registered the gentle formulation of this organic eye cream make it suitable for all skin types including sensitive skin description sku sk222hbaqyn8anmy807324 size l x w x h 12 x 17 x 23 weight 1 author wwwskinblossomcommy organic eye cream 15ml skin blossom  no votes yet 11900 10 10700 quantity 500 store marketplace good for  all skin types including sensitive skin antiageing reducing puffiness dryness and dark circles  ',0),(41,'node',' mejikaliner quick eyelid essence stick glue night use mejikaliner quick eyelid essence stick glue is an invisible clear type double eyelid maker it creates natural and beautiful double eyelids easily how to use 1 remove grease from eyelids2 locate your ideal double eyelidline usually 3 6mm above the eyelash by slightly twist the end of the glud and apply glue along3 to remove wipe with wet cotton bud or facial puff volume 2ml origin japan description sku me223hbat7xuanmy924008 size l x w x h 15x15x15 weight 5 mejikaliner quick eyelid essence stick glue night use mejikaliner  no votes yet 12900 11 11500 quantity 700 store marketplace  ',0),(42,'node',' hairscape 1800w aus 5000 professional hair dryer hairscape hair dryer 5000 high performance professional salon hairdryer operating at 16001800 watts this turbo force hairdryer offers three speeds and 3 temperature settings highlights description sku ha181hbasx9janmy908363 model aus 5000 size l x w x h 23 x 9 x 23 weight 1 hairscape 1800w aus 5000 professional hair dryer hairscape  no votes yet 9500 38 5900 quantity 100 store marketplace salon grade highpowered hair dryer comes with 2 nozzles italian design motor intalian switch low noise 1800w 3 heat cold hot and speed high low off setting  ',0),(43,'node',' tonific slimming massager tonific body massager has a unique ergonomic and revolutionary design with advanced technology that penetrates the deepest layers of your skin helping it burn calories and reduce inches with little to no effort tonific body massager is the ideal method to help reduce and tone your entire body without any exercise the secret is its exclusive design that spins at more than 2700 revolutions per minute with tonific you get 3 massagers in 1 with the patent interchangeable rotating acuspheres description sku oe702hbast9qanmy901982 model tonific slimming massager size l x w x h 26 x 11 x 18 weight 1 tonific slimming massager oem  no votes yet 12000 51 5900 quantity 500 store marketplace  ',0),(44,'node',' apple iphone 6 16gb gold special notice  for the iphone 6 lazada is not able to accept returns for convenience in case of a damage or defect you will of course be able to make a return as normal bigger than biggeriphone 6 isn t simply bigger it s better in every way larger yet dramatically thinner more powerful but remarkably power efficient with a smooth metal surface that seamlessly meets the new retina hd display it s one continuous form where hardware and software function in perfect unison creating a new generation of iphone that s better by any measure iphone at its largest and thinnest iphone at its largest and thinnestdeveloping an iphone with a larger more advanced display meant pushing the edge of design from the seamless transition of glass and metal to the streamlined profile every detail was carefully considered to enhance your experience so while its display is larger iphone 6 feels just right not just a bigger display a better displayit s one thing to make a bigger display it s something else entirely to make a bigger multi touch display with brilliant colors and higher contrast at even wider viewing angles but that s exactly what we did with the new retina hd display hugely powerful enormously eﬃcientbuilt on 64bit desktopclass architecture the new a8 chip delivers more power even while driving a larger display the m8 motion coprocessor efficiently gathers data from advanced sensors and a new barometer and with increased battery life iphone 6 lets you do more for longer than ever the camera that changed photos now does the same for videomore people take more photos with iphone than with any other camera and now the isight camera has a new sensor with focus pixels and new video features like 1080p hd at 60 fps slomo at 240 fps and timelapse video mode so you ll have more reasons to capture more moments on video too faster wireless far and wideiphone 6 has faster 4g lte download speeds and it supports more lte bands than any other smartphone to give you better roaming and when connected to wifi you ll get up to 3x faster speeds security right at your fingertipthe breakthrough touch id technology lets you securely access your iphone with the perfect password your fingerprint you can also use it to approve purchases or downloads from itunes ibooks and the app store without having to enter your password the biggest ios release everios 8 is the world s most advanced mobile operating system and with incredible new capabilities and features designed to make the most of a larger display ios 8 doesn t just work seamlessly with iphone 6 it makes every experience feel bigger and better description sku ap564elapuhianmy741814 model iphone6 size l x w x h 8x4x3 apple iphone 6 16gb gold apple  no votes yet 75000 quantity 500 store marketplace what s in the box  iphone6 x1 cable x1 charger x1 headset x1  ',0),(45,'node',' samsung n910 note 4 lte 32gb white galaxy note 4 size display the phone measures 1535 x 786 x 85 mm the screen size remains the same as its predecessor the note 3 at 57inches using the familiar super amoled display with its oversaturated bright colors the resolution has been beefed up to quad hd which is a resolution of 1440 x 2560 pixels and 515 ppi for comparison the note 3 has a 1080p display of 1080 x 1920 pixels and 386 ppi because of this the latest note 4 is even sharper the thickness of the device is still 033inches but the weight is 176 grams which makes it a bit more noticeable this isn t much of an issue though because unless you have very large hands holding the galaxy note 4 comfortably and safely is usually a twohanded job anyway  processor memory battery the speed of the galaxy note 4 is impressive with one of the fastest quadcore chipsets on the market the qualcomm snapdragon 805 krait 450 processor running at an impressive 27 ghz a 3200 mah battery is provided to handle the more demanding qhd display and faster processor the ability to load many complex apps is also provided for with 3gb of ram memory which should be sufficient android touchwiz android 444 kitkat is supplied not quite the android 45 one would have hoped to see but the samsung touchwiz skin probably hasn t been updated for that yet hopefully buyers of the galaxy note 4 will be able to upgrade the os postpurchase the main benefit of android 45 is the remote kill switch to turn off the phone if it were stolen or lost the stylus and software for the note 4 is much the same for people who love using the stylus this version of the note model won t be much of a departure  internal external storage the internal storage is offered in a single 32gb configuration with a microsd card slot capable of handling up to 64gb cards this is disappointing given that the galaxy s5 can accept 128gb microsd cards and one would have expected the flagship note 4 to offer the same storage capacity especially given the fact that it packs a super hd camera description sku sa356elaqrcjanmy794737 model n910 size l x w x h 8 x 4 x 1 samsung n910 note 4 lte 32gb white samsung  no votes yet 70000 quantity 500 store marketplace galaxy note 4 size display the phone measures 1535 x 786 x 85 mm the screen size remains the same as its predecessor the note 3 at 57inches using the familiar super amoled display with its oversaturated bright colors  ',0),(46,'node',' asus transformer p1801b041k aio 184 pc dekstop asus rtn56u wireless n n600 dualband gigabit router meet the world s first allinone pc to feature all the performance of windows 8 desktop and the flexibility of a tablet asus transformer aio is perfect for productivity but detach its 184inch full hd display and it instantly transforms into a multitouch android tablet asus desktops leading in satisfaction with reliability asus computers reflect a tradition of the finest quality innovation and longevity based on the pcworld usa 2012 reader survey of tech satisfaction reliability and service users ranked asus as a leading choice for desktop pcs citing high satisfaction with their value connectivity ease of use and reliability the survey also found asus desktop pcs were one of the most likely to be recommended to others windows 8 allinone pc with a 3rd generation intel core i7 processor and powerful discrete graphics asus transformer aio packs enough desktop pc performance for even the most demanding applications enjoy windows 8 anywhere in the home with asus transformer aio you don t have to sacrifice powerful desktop performance just for the sake of the portability just grab the convenient handle and detach the 184inch display from the pc station for a fast and fluid windows 8 experience anywhere in the home wireless remote desktop technology gives complete control over windows 8 on the pc station with the multitouch tablet over any standard wifi connection connect the pc station and tablet to the same wifi access point to enjoy seamless data transmission for faster connections 5ghz networking is recommended supported by the dualband wireless capabilities of the pc station and tablet it significantly reduces interference from nearby 24ghz networks and devices resulting in better wifi description sku as575elat5hfanmy920560 model p1801b041k f9asurtn56u size l x w x h 40x45x30 weight 3 asus transformer p1801b041k aio 184 pc dekstop asus rtn56u wireless n n600 dualband gigabit router asus  no votes yet 100000 quantity 100 store marketplace asus desktops leading in satisfaction with reliability windows 8 allinone pc enjoy windows 8 anywhere in the home  ',0),(47,'node',' lenovo a316 lenovo a316 is a dualcore 3g smartphone with fashionable style and costeffective price it runs on android operating system 236 os and is operated by mtk6572 dual core 13ghz cpu mali400 gpu and 512mb ram to make sure switching between applications and functions can be done smoothly double sim it supports double sim card and completely suitable with globally quadband gsm and wcdma 3g systems for making telephone calls the 40 inches display with capacitive touch style lets you make the most out of the entertainment features like watching videos and playing your favourite mobile games air gesture what s particularly eyecatching is the mobile phone s airgesture function which makes viewing files skipping tracks and switching pages easier all you have to do is wave your hand over the screen to browse the previous or next pictures in gallery switch to the next song in music player and switch to another page on the home or menu screen simple yet powerful lenovo a316 is equipped with all the important features that you need in a phone it supports wifi and wcdma 3g systems for browsing internet and data transfer as well as handsfree devices with a builtin gps processor for simple and easy routing you will be able to get direction easily besides that it is also equipped 2mpcamera for capturing great moments of your life get yours today  description sku le106elat4hkanmy918581 model a316 size l x w x h 7x2x12 lenovo a316 lenovo  no votes yet 25000 20 19900 quantity 300 store marketplace android 23 2mp camera 512mb internal 265mb ram 13ghz mtk6572 dualcore  ',0),(48,'node',' nokia asha 206 dual sim black connectivity convenience class imagine all the cs in the palm of your hands you want your phone to do everything you want it to make life easier but you d want it to look good as well all this is made possible with the nokia asha 206 dual sim see and be seen a big bright 24 screen and tactile wellspaced keys make the nokia 206 dual sim a joy to use it looks good too combining clean elegant design with a choice of striking colours big screen with the nokia 206 dual sim fun is never far away some of the hottest games around are included for free including bejeweled need for speed shift and medal of honor it also comes with tunewiki social player and the pictelligent camera app sharing made simple friends are close at hand too with facebook twitter and ebuddy apps while slam makes sharing photos and other content simple there s no complicated pairing process just touch your nokia 206 dual sim to any bluetooth phone to transfer content browsing at its best to help you put that large 24 screen to good use the nokia 206 dual sim comes loaded with the nokia xpress browser more efficient than other browsers it lets you enjoy an easier more enjoyable and more affordable internet experience description sku no225elak8ttanmy497673 nokia asha 206 dual sim black nokia  no votes yet 7000 30 4900 quantity 1000 store marketplace dual sim 13mp camera fm radio multimedia player bluetooth 21 edr  ',0),(49,'node',' apple ipad 3 wifi 4g md368 64gb black retina display four times more pixels than ipad 2 razorsharp text richer colors the retina display transforms the entire ipad experience so everything looks and feels incredibly lifelike and perfectly detailed performance the a5x chip with quadcore graphics drives four times the pixels of ipad 2 yet it delivers the same smoothness and fluidity ipad is known for even with all that extra oomph the new ipad still gets an amazing 10 hours of battery life isight camera the 5megapixel isight camera features a backside illumination sensor that captures greatlooking pictures whether by sunlight or candlelight autofocus tap to focus and tap to set exposure functions mean every photo you take instantly becomes a frameworthy gem and with builtin face detection that automatically balances focus and exposure across up to 10 faces there s more room for more grins so everyone look at ipad and say cheese  description sku ap564elapeznanmy715186 model md368 size l x w x h 17 x 22 x 2 weight 2 apple ipad 3 wifi 4g md368 64gb black apple  no votes yet 60000 17 49999 quantity 400 store marketplace 97inch retina display with multitouch dualcore a5x chip with quadcore graphics 5mp isight camera and facetime camera 1080p hd video recording  ',0),(50,'node',' asus memopad 7 tablet  the asus memo pad 7 was created for those looking for a value tablet the 7inch asus memo pad 7 punches well above its weight boasting features and specifications more commonly found on highend tablets excellent image quality comes from superb technology asus memo pad 7 includes comes with best technology that combines software and optical design to deliver incredible images best of all it s with you all the time to capture every moment description sku oe702elas5khanmy868993 size l x w x h 12 x 1 x 197 weight 1 asus memopad 7 tablet  asus  no votes yet 45000 22 34900 quantity 500 store marketplace affordable high quality long lasting  ',0),(51,'node',' lenovo tablet miix 2 59399848 8 silver the minitablet with a quadcore processora 8 windows 8 tablet with an intel atom processor the lenovo miix 2 is perfect for onthego entertainment or productivity full hd 1280x800 display with ips technology the vibrant 8 wideview display uses inplane switching ips for vivid colors and nearly 180degree viewing angles fivefinger multitouch technology seamlessly integrate with windows 8 and enjoy more precise control optional detachable cover with stylus protect your screen when not in use or use the cover to hold the tablet upright in stand mode and with included stylus pen you can take notes edit documents or simply doodle onthego integrated webcam the 2mp front camera and upto8mp rear camera will help you enjoy web conferences or online video chats like you re really there veriface face recognition software your face is your password the integrated webcam uses stored images of your face to allow you to login quickly and easily and the program supports multiple users allowing you to authorize access for the entire family description sku le106elasxt7anmy909117 model miix 2 59399848 size l x w x h 132 x 7 x 216 weight 35 lenovo tablet miix 2 59399848 8 silver lenovo  no votes yet 34900 14 29900 quantity 600 store marketplace tablet 801366 x 768 ips touch intel atom z3740 2m up to 186ghz 2gb ram 64gb intel hd  ',0),(52,'node',' apple ipad air 16gb wifi space grey md785zpa  presenting the brand new ipad air unbelievably thin and light yet packs so much more power and capabilities than ever before featuring the latest a7 chip advanced wireless and great apps for your entertainment productivity and creativity all beautifully integrated with the ios 7 amazingly thin light through a series of vigorous refinements apple has managed to drop the ipad air s volume close to a quarter of the volume of the previous generation ipad however when you hold the ipad air for the first time in your hands you will feel how durable and elegantly designed it is the unibody construction provides amazing strength and simplifies the enclosure which the results is an ipad that not feels amazing to hold but is also easy to take around with you no matter where you go stunning display the stunning retina display is included in the ipad air and it looks amazing as ever the ipad air retains the same 9 display but now has thinner side bezels and a narrower width overall although a subtle change it makes a dramatic difference for your content viewing pleasure and with retina display everything seems to just pop out using a touchrejection algorithm ipad air recognizes if your thumb is simply resting on the display while you re holding it or if you re intentionally interacting with the multitouch screen description sku ap564elat12eanmy913520 model md785zpa size l x w x h 24 x 1695 x 75 apple ipad air 16gb wifi space grey md785zpa  apple  no votes yet 74900 20 59900 quantity 400 store marketplace 16gb capacity 97inch retina display with 264ppi a7 chip with 64bit architecture ultrafast wireless wifi 80211a b g n with mimo lorem ipsum dolor sit amet consectetur adipiscing elit permalink submitted by admin on tue 12092014 1422 lorem ipsum dolor sit amet consectetur adipiscing elit  your rating none log in or register to post comments  ',0),(53,'node',' galaxy note 4 spigen case neo hybrid metal gold experience the protective new bumper case the neo hybrid for the galaxy note 4 is a completely reimagined dual layer bumper style case that provides full coverage of your note 4 it is composed of a uvcoated hard polycarbonate frame and a highpolymercoated soft tpu cover the tpu casing has a textured midsection for grip and embedded accent lines for a quality look the buttons are metallized for a premium look and engaging experience the inner webpatterned tpu helps absorb and disperse the impact from drops and bumps advanced shock absorption technology web pattern tpu case matte tpu and polycarbonate for drop and scratch protection slim and form fitted to show the perfect shape of your device metallic finish to frame metallized polycarbonate buttons lay on the table design 08mm lip for optimal screen protection compatible with samsung galaxy note 4 only 2014 description sku sp889elasu66anmy903500 model samsung galaxy note 4 size l x w x h 16 x 85 x 1 weight 8 galaxy note 4 spigen case neo hybrid metal gold spigen  no votes yet 9900 30 6900 quantity 2000 store marketplace advanced shock absorption technology premium diacut edges on pc frame compatible with beats by dre headphones compatible with samsung galaxy note4 only2014  ',0),(54,'node','  genuine samsung galaxy note 4 s view classic cover case black samsung s view cover case for galaxy note 4 the samsung s view cover case for galaxy note 4 protects your screen when it is not in use and is easily flipped open for full access to the screen when closed the s view cover offers instant access to critical features thanks to the samsung id chip view the home screen to check the time weather and other status items accept or reject incoming calls with just a swipe or reject calls with a preset message control your music playback directly on the s view screen if you miss anything notifications are shown in the recent activity menu of your s view cover unless phone security settings are activated swipe left to quickly access your phone s camera without opening the cover to take pictures or video right in the moment the perfect combination of style and functionality the samsung galaxy note 4 s view cover was developed with your busy lifestyle in mind this smart case designed to protect and enhance the samsung galaxy note 4 is the perfect combination of style and functionality not only is the s view cover available in multiple attractive colors the builtin intelligent color system recognizes the case color and automatically matches the view window background with a complementary color for a personalized look you can even upload your own image for added customization and with the innovative s view design you will never miss important information description sku sa356elat7ymanmy924036 size l x w x h 816 x 133 x 1546 weight 63g  genuine samsung galaxy note 4 s view classic cover case black samsung  no votes yet 15500 quantity 500 store marketplace flip cover with smart interactive window providing quick access to key phone features view weather pedometer date time on home screen swipe to preview messages missed calls swipe to access quick camera and video recorder  ',0),(55,'node',' samsung galaxy tab 70 plus vehicle dock with incar charger the samsung galaxy tab 70 plus vehicle dock with in car charger lets you take the brilliance of your samsung smartphone along for the ride the custom fitted cradle holds the handset securely during long rides attach it to a windshield or dashboard and adjust the multiangle neck for perfect viewing gps capabilities are optimized with navigation applications but that s just the beginning with the endless android apps available with your hands safely on the steering wheel experience the convenience of powerful voiceactivated android applications like s voice your samsung smartphone and vehicle navigation mount duo is truly brilliance on the go description sku oe702elak0u8anmy486129 model samsung galaxy tab 70 plus vehicle dock with incar charger warranty period 6 months warranty type local supplier warranty samsung galaxy tab 70 plus vehicle dock with incar charger oem  no votes yet 11900 21 9400 quantity 200 store marketplace lightweigh portable design designed perfectly to fit samsung galaxy tab 70 inch holds and charge your device plug and play simplicity  ',0),(56,'node',' angel universal mobile phone in car phone holder 360 degree item code p338 mobile yourself with newly newly ishop newly ishop is an online store located in malaysia they provide ultimate shopping destination online providing items of the latest trend computer accessories home and living and mobile accessories at affordable price and since people love mobile just as much as they do newly always on the hunt for the newest drool worthy pieces to bring you combining style with quality materials only the most convenience mobile accessories are sourced from around the globe description sku ot343elam59danmy609257 product line car accessories model p338 weight 01kg color black angel universal mobile phone in car phone holder 360 degree item code p338 others  no votes yet 3900 26 2900 quantity 400 store marketplace easy installation just 1 minute to install on the windshield easy to rotate the bracket arm at 360 degree the clip width is adjustable to fit most sizes of devices the clip is designed with soft foam prevent your cellphone from scratching  ',0),(57,'node',' original apple earpod earphone with remote mic for iphone ipad ipod unlike traditional circular earbuds the design of the new apple earpods is defined by the geometry of the ear which makes them more comfortable for more people than any other earbudstyle headphone the speakers inside apple earpods have been engineered to minimize sound loss and maximize sound output so you get highquality audio that s just as impressive as what you d hear from more expensive headphones the apple earpods with remote and mic also include a builtin remote that lets you adjust the volume control the playback of music and video and answer or end calls with a pinch of the cord description sku ap564elalljmanmy575572 size l x w x h 6x2x6 weight 15g original apple earpod earphone with remote mic for iphone ipad ipod apple  no votes yet 9900 24 7500 quantity 500 store marketplace deeper richer bass tones greater protection from sweat and water control music and video playback answer and end calls genuine apple products  ',0),(58,'node',' sony stereo bluetooth headset sbh20 black easier than connecting a cable touch once to pair your smartphone with your wireless headset if the devices have been disconnected touch once to reconnect nfc is pure magic sound clarity an easytouse wireless stereo headset from sony with straightforward call keys and music controls enjoy the rich bass and dynamic sound of this impressive headset let hd voice give the person you are calling an intheroom experience bluetooth wireless technology lets you move freely and enjoy all the audio in your smartphone at a distance design sony stereo bluetooth headset sbh20 comes in several colours it has a secure and rotatable clip that lets you wear your mobile phone headset as you want an ergonomic sliding power key and large tactile music control keys add extreme ease to subtle style description sku so406elakprjanmy525732 model sbh20 size l x w x h 13x10x45 sony stereo bluetooth headset sbh20 black sony  no votes yet 14900 7 13900 color black pink quantity 500 store marketplace speaker type 92mm dynamic 16ohm ear coupling insert nominal impedance 18 3ohm driver type dynamic  ',0),(59,'node',' top mi 10400mah powerbank black prepare to experience one of the most advanced powerbanks for all generations of ipad iphone ipod samsung devices htc blackberry and other usb related devices introducing the top mi powerbank 10400mah powerbank with a capacity of 10400mah this powerful charger will ensure that your smart phones or digital devices be fully charged and ready to use no need to worry about running out of battery after a long day at work take efficiency to a whole new level with the top mi powerbank so what are you waiting for get it now while stocks last  useful features for your everyday electronic needs it is always frustrating when you find yourself in a situation where your smart phone or digital device has run out of battery especially when you need it the most with the top mi powerbank you never have to get caught in such a predicament ever again the light indicator is a convenient feature that lets you know when your device has been fully charged and ready to be used to its maximum potential  description sku oe702elass8banmy900509 size l x w x h 5x35x25 weight 5 top mi 10400mah powerbank black oem  no votes yet 9900 61 3900 quantity 500 store marketplace 10400mah high capacity portable and pocket size 21a high power single output fast charging powerbank  ',0),(60,'node',' universal dualport power bank 20000mah black in this modern digital life today power bank is just another necessary accessory that most people would need imagine having a charging device without the need of carrying the charging cables and connectors that you often forget power bank is just superduper handy especially when you are always out travelling on the road power bank universal power bank is where power is stored in one compact little tool and can endlessly charge your gadgets on the road conveniently it s a mobile power source that enables you to store a huge amount of power and charge your gadgets without you having to look for plugs  incredible performance this power bank is capable of storing up to 20000mah power supply which is enough to fully charge your iphone multiple times it is built with high quality grade a batteries to ensure an assurance use apart from charging your gadgets conveniently its dual usb jacks are compatible for almost all brands and gadgets  description sku oe702el51smmanmy130613 size l x w x h 135 x 70 x 22cm compatible phones nokia apple lg samsung blackberry universal dualport power bank 20000mah black oem  no votes yet 39900 89 4300 quantity 500 store marketplace 20000mah 2 usb ports compatible with many devices led indicators  ',0),(61,'node',' muwo trendz swarovski element white gold plated everlasting love set the symbol of everlasting love is formed from two biskeles the biskeles two cornered knots denote the aspects of two people mind and spirit the symbol looks like an s joined together the everlasting circle of eternity thus the figure represents two people joined in mind and spirit in everlasting love  muwo trendz philosophy jewellery manufacturing process includes most advance technologies and dedicated research each product undergoes a series of procedures before we get the net product as a beautiful jewellery the natural components of jewellery will undergo multiple processes most jewelleries are executed by casting machines unless those specifically handcrafted ones which is exceptional in quality muwo trendz jewellery has two unique grades normal grade with a lower price point which is good for most occasion with 2 layer polishing the premium class undergoes 4 polishing processes and has a finer and smoother finishing for all occasion no matter what you re looking for we have both grades of similar design to choose from finally the plating process finishing off the jewellery to be ready for the big occasion description sku mu553faarfdmanmy830725 model everlasting love set size l x w x h 42 x 2 x 1 muwo trendz swarovski element white gold plated everlasting love set muwo trendz  no votes yet 25900 70 7900 quantity 300 store marketplace necklace length 40cm 45cm adjustable 4 layer prepolishing 18k white gold plated for smoother finish handpicked swarovski elements all occasion stunner  ',0),(62,'node',' luccacal multi color tribal necklace power your ensemble with this incredible multi color tribal necklace from luccacal linger this statement necklace over a simple tee or match it to a favorite dress description sku lu757faat3kbanmy916954 size l x w x h 43cm x 7cm extender chain weight 2 luccacal multi color tribal necklace luccacal  no votes yet 2900 quantity 10000 store marketplace mix of faceted black gem crystal glass multicolour beads and rhinestones black rope detail antique bronzetone plating lobster clasp closure  ',0),(63,'node',' dandelion women braided belt white if you have to share anything in your wardrobe with your girlfriends then this dandelion women braided belt would be the perfect calling for it the interlaced nature of the belt makes it great for anyone there s no specific holes on a solid surface just find one in between the braids to suit your size this belt is great for a hippieinspired look for a casual day out with your loved ones for the child of spring walk through the colours of the wind with dandelion s range of fashion accessories exclusively designed to enhance youthful peaceloving personalities like yourself choose from figure definitive belts beautiful flowy pastel scarves eyeopening sunglasses to a wide array of jewelleries to adorn bring out the child of spring in you and enjoy the warmth of the sunshine with dandelion description sku da883faal9r7anmy556875 model 260500059912717 white size l x w x h 110l x 2w x 03h cm dandelion women braided belt white dandelion  no votes yet 2000 quantity 500 store marketplace great for a hippieinspired look onesizefitsall large buckle  ',0),(64,'node',' dandelion cross stitch belt orange this beautifully crafted belt can be styled loose or as per usual basis to compliment the outfit of your choice the dandelion cross stitch belt is a great addition to the colour blocking trend thanks to its solid colours and unique stitching design made to fit all sizes possible the dandelion cross stitch belt is suitable for all occasions for the child of spring walk through the colours of the wind with dandelion s range of fashion accessories exclusively designed to enhance youthful peaceloving personalities like yourself choose from figure definitive belts beautiful flowy pastel scarves eyeopening sunglasses to a wide array of jewelleries to adorn bring out the child of spring in you and enjoy the warmth of the sunshine with dandelion description sku da883faal9qsanmy556860 model 26010337991385 orange size l x w x h 110l x 2w x 03h cm dandelion cross stitch belt orange dandelion  no votes yet 2400 quantity 400 store marketplace suitable for formal casual wear with two loops for a customized fit great for colour blocking styles  ',0),(65,'node',' fur nyce big square classic chain pattern print scarf accessories are just as important as the clothes you put on and the shoes on your feet the beauty of accessories is that they are inexpensive and with just several pieces you could update the look of the clothes you have in your wardrobe without draining your wallet you could be surprised how a piece of accessory can change an entire look whether you have carrie s style of funky and eclectic or charlotte s sophisticated elegance there s always a piece of accessory to suit your signature identity and to flaunt an offbeat style statement add up some glam slam to your outfit with fur nyce accessories features add some wildness to your plain outfit with fur nyce big square classic chain pattern print scarf the scarf features classic chain pattern print and comes in plain yellow brown and ivory in colour the scarf is made of high quality breathable cotton blends fabric about fur nyce accessories fur nyce accessories offers sparkling fashion jewelries and accessories in various shapes and styles you are sure to build a staple collection of accessories that you could go back to time and time again from classic to the trendiest style you will definitely find the right piece at fur nyce accessories from its massive style of fashion accessories with excellent value high quality and always on trend description sku fu022faalch2anmy561503 weight 18 kg color yellow brown fur nyce big square classic chain pattern print scarf fur nyce  no votes yet 4000 13 3500 quantity 400 store marketplace material cotton blends size 130cm x130cm big square comfortable scarf  ',0),(66,'node',' fur nyce fashion zebra pattern print scarf white accessories are just as important as the clothes you put on and the shoes on your feet the beauty of accessories is that they are inexpensive and with just several pieces you could update the look of the clothes you have in your wardrobe without draining your wallet you could be surprised how a piece of accessory can change an entire look whether you have carrie s style of funky and eclectic or charlotte s sophisticated elegance there ﾒ s always a piece of accessory to suit your signature identity and to flaunt an offbeat style statement add up some glam slam to your outfit with fur nyce accessories features add some wildness to your plain outfit with fur nyce fashion zebra pattern print scarf the scarf features zebra pattern print and comes in plain white in colour the scarf is made of high quality breathable cotton viscose fabric about fur nyce accessories furnyce accessories offers sparkling fashion jewelries and accessories in various shapes and styles you are sure to build a staple collection of accessories that you could go back to time and time again from classic to the trendiest style you will definitely find the right piece at fur nyce accessories from its massive style of fashion accessories with excellent value high quality and always on trend description sku fu022faal7jtanmy553296 model fs0005 white white size l x w x h 90 x 180 fur nyce fashion zebra pattern print scarf white fur nyce  no votes yet 3800 21 3000 quantity 600 store marketplace material viscose size 90cm x180cm  ',0),(67,'node',' invicta pro diver men black stainless steel strap watch 15422 once a marker of time watches now have moved on to being a marker of personality a watch is no longer just an accessory it represents your personality and sense of style invicta the watch for modern person driven elegant classy stylish tough invisible a durable timepiece technology packed in a stainless steel strap and a black dial the invicta 15422 is intended for the man who appreciates the finer aspects of life it has a flame fusion crystal glass and is water resistant up t0 10 atm enjoy life in style and elegance with the invicta 15422 about invicta in the little town of chiasso switzerland was invicta founded in 1837 and nurtured to where it stands today legendary for its consistence in quality and brand personality invicta resurfaced in the early 1990 s after a short disappearance during the quartz movement in the 1970 s innovative in style and construction invicta s timeless masterpieces exudes an aura of class and elegance from its owner invicta invincible through time creating an immortal experience description sku in656faas6g7anmy870227 model 15422 size l x w x h 12x12x12 invicta pro diver men black stainless steel strap watch 15422 invicta  no votes yet 79900 50 39900 quantity 500 store marketplace analog watch stainless steel strap with round case and black dial japan movement water resistant up to 10 atm case dimension 46 mm  ',0),(68,'node',' rolex submariner black dial stainless steel automatic mens watch 114060 the rolex submariner is the indispensable instrument for every diver introduced in 1953 it was the first watch to be waterresistant to 100 meters 330 feet during the pioneering era for scuba diving this iconic timepiece exemplifies rolex s technical innovations and impeccable craftsmanship dial type analog luminescent hands and markers automatic movement scratch resistant sapphire crystal screw down crown solid case back case diameter 40 mm round case shape oyster clasp water resistant at 300 meters 1000 feet functions hour minute second luxury watch style watch label swiss made rolex submariner black dial stainless steel automatic mens watch 114060 description sku ro180faasx6ranmy908233 model 114060 size l x w x h 15cm x 17cm x 13cm rolex submariner black dial stainless steel automatic mens watch 114060 rolex  no votes yet 129900 23 100000 quantity 600 store marketplace dial type analog luminescent hands and markers automatic movement scratch resistant sapphire crystal screw down crown  ',0),(69,'node',' suunto vector black suss010600610 mountain outdoor watch suunto vector the mountain watch after a decade of travels adventures and courageous expeditions suunto vector is still the most legendary watch with an altimeter barometer and compass with the technology and durability that can take on the harshest of environments it is the choice of professionals description sku su433faasxlfanmy908796 model suss010600610 size l x w x h 514 x 456 x 153 suunto vector black suss010600610 mountain outdoor watch suunto  no votes yet 99900 10 89900 quantity 400 store marketplace altimeter barometer compass weather trend indicator temperature altitude difference measurement altitude log  ',0),(70,'node',' skmei 955 30m waterproof analogue digital dual time men s sports watch black green general brand skmei model 955 quantity 1piece color black green casing material abs pu wristband material rubber suitable for adults gender men  specification style wrist watch type sports watches display analog digital backlight blue movement digital quartz display format 1224 hour time format water resistant 30m water resistant  description sku oe702faashknanmy885439 model 955 size l x w x h 25 cm x 52 cm x 15 cm skmei 955 30m waterproof analogue digital dual time men s sports watch black green oem  no votes yet 10000 15 8500 quantity 800 store marketplace casing material abs pu wristband material rubber display analog digital display format 1224 hour time format water resistant 30m water resistant  ',0),(71,'node',' samsung 4 full hd led tv ua40h5008arxxm series 5 looking for the best led tv in town well look no further the samsung 40 full hd led tv series 5 is here it has an outstanding picture with deep black levels precise color and great brightroom viewing qualities its styling is dropdead gorgeous and the slim sophisticated design lends a unique ultramodern look a great all rounder that fits perfectly on any wall a thing of a beauty discover a new reality in full hd enjoy a greater level of home entertainment realism than ever before thanks to a resolution twice as high as standard hd tvs your samsung fhd tv delivers a breathtaking viewing experience that takes you beyond the screen into a world of total immersion when you ve seen the rich and vivid texture of full hd images your favourite tv programs and movies will never be the same again discover reality with a full high definition experience all the excitement of the big match with soccer mode with soccer mode it s like you re actually at the match it sharply and vividly brings out the green grass of the pitch and all the other colours of the stadium a powerful multisurround sound effect also lets you hear all of the excitement you can even zoom in to selected areas of the screen for a better view with just a push of a button you can make the most of your favourite sport with all your friends more vibrant colours for better images using an advanced picture quality improvement algorithm samsung s wide colour enhancer plus drastically improves the quality of any image and uncovers hidden details now see colours as they were meant to be seen with wide colour enhancer plus watch movies from your usb with connectshare movie simply plug your usb memory drive or hdd into the tv and instantaneously enjoy movies photos or music now you can experience a wide variety of content in the comfort of your living room on your tv description sku sa356elarow3anmy844449 model ua40h5008arxxm size l x w x h 91x905x562 samsung 4 full hd led tv ua40h5008arxxm series 5 samsung  no votes yet 149900 20 119900 quantity 500 store marketplace 40 display 1920 x 1080 4 hdmi 3 usb  ',0),(72,'node',' sony 48 full hd led tv bravia model kdl48r470b for a clearer sharper and overall better performing full hd led tv the sony 48 full hd led smart tv is the one and only choice to which will suit your preference high resolution display the sony 48 full hd led smart tv comes with a clear resolution enhancer which has a superior noise reduction feature while maintaining clear crisp moving images and natural pictures with such and indepth approach to realism and its eye to detail sony proves that you can bring lifelike picture quality into the tv new generation of dvb thanks to the dvbt2 digital broadcasting standard installed into the sony 48 full hd led smart tv you can now experience even better picture and sound quality compared to the standard dvb it even grants greater flexibility and robustness when accessing hd programmes description sku so406elama8aanmy618653 size l x w x h 196x1086x674 weight 910 sony 48 full hd led tv bravia model kdl48r470b samsung  no votes yet 299900 32 203500 quantity 600 store marketplace 48 full hd screen led tv 1920 x 1080p resolution clear resolution enhancer bass reflex box speakers  ',0),(73,'node',' sony bdvn9200w 91 cinema studio 3d bluray disc home theatre system whether you enjoy movies or sports or listening to song on a grand scale this superb home solution by sony is definitely worth your attention this bluray home theater system by sony will take you away from your living room its 91 channel will stream high definition audio from all angles including from the top it will also mute the commentators as you watch your favorites teams play making you feels as though you re in the stadium yourself the sony bdvn9200w is here to impress sony audio  this sony bdvn9200w system will resonate high definition audio that will cater to your listening preference taking your senses to greater levels compared to previous cdquality this superior solution provides subtle details that were once hidden away listen to greater detail and appreciate music in its purest form  description sku so406elao9yxanmy651058 model bdvn9200w sony bdvn9200w 91 cinema studio 3d bluray disc home theatre system sony  no votes yet 149900 13 129900 quantity 100 store marketplace highresolution audio capability 91 channel digital music arena mode virtual football mode  ',0),(74,'node',' samsung hte350k dvd home theater system do you feel unsatisfied with the current audio in your house when you re watching your favourite fighting scene in an action movie you want to feel like you are in the movie itself feeling the adrenaline rushing through your body your heart thumping like mad when you turn on the volume high ready to indulge in the fighting scene so here s the solution it will be made possible with this home theatre set from samsung powerful audio make the most of your home entertainment with this dvd home theater system which offers a full range of sound and visual quality a builtin frontfiring subwoofer at the bottom of the speaker delivers rich and deep lowend tones to ensure tv programmes music and movies are vivid and immersive unlike comparable products you won t have to buy costly additional equipment for powerful audio sing your heart out your samsung home entertainment system has all you need to enjoy cinematic sound and magnificent music in the comfort of your living room as this model comes with karaoke scoring mic plus music usb record with cd disc mic jack mic volume fanfare and my karaoke description sku sa356elaol1vanmy666683 model hte350k size l x w x h main 43 x 56 x 25 front speaker 77 x 107 x 68 center speaker 228 x 77 x 7 surround speaker 77 x 107 x 68 sub woofer 155 x 30 x 285 samsung hte350k dvd home theater system samsung  no votes yet 59900 38 36900 quantity 200 store marketplace cd da cdr cdrw dvdvideo dvd r dvd rw vcd 11 51 channel my karaoke  ',0),(75,'node',' l12s oled smart watch bluetooth 30 bracelet wrist design for ios android iphone samsung smart phone blue many people have their phones in their hand bags and don t feel the vibration or even hear their ring tone in busy areas with this awesome bracelet you can have a wearable fashion accessory and never miss a call again caller id and led time display this beautiful bracelet also displays the caller id so you can see the phone number of the person calling instead of having to struggle opening your bag in a busy area you can instantly tell if the call is important or not another great feature of this bracelet is that it features a time displayunlike most wireless techniques bluetooth uses time division duplex to arrange the transmission slots so that it can avoid collisionthe toprated 250mah battery enables you run into the bracelet for 168 hours constantlyit is also the best gift for your family and friends description sku oe702elamnj0anmy642088 model l12s compatible phones apple lg samsung htc l12s oled smart watch bluetooth 30 bracelet wrist design for ios android iphone samsung smart phone blue oem  no votes yet 29900 40 17900 quantity 500 store marketplace best oled display module high quality of bluetooth v30 diverse functions attached answer calls listen to music time display etc led signal lights design easy to operate and use  ',0),(76,'node',' ori apple tv bigtime entertainment one small box apple tv gives you access to the best content blockbuster movies sports your music and photos and more right on your hdtv1 you can even play content from your ios devices on your tv wirelessly using airplay quick and easy setup just plug in the power cord and connect apple tv to your hdtv with a single hdmi cable sold separately if you have an iphone or ipad hold it near apple tv and apple tv will learn about your home network and receive your itunes account settings automatically airplay airplay lets you wirelessly stream what s on your mac or ios device to your hdtv and speakers via apple tv or mirror exactly what s on your device s display to the big screen icloud with icloud you can buy movies on apple tv and watch them on your ipad iphone ipod touch mac or pc and vice versa icloud also stores your photos and videos pushing them wirelessly to all your devices including your hdtv your photos and videos with my photo stream your most recent photos and videos automatically appear on your apple tv and thanks to imovie theater the projects you ve made in imovie are ready for viewing on the big screen youtube vimeo mlb and more watch hit movies live sports breaking news the latest viral videos and more from some of the biggest names in entertainment description sku ap564elalvswanmy592956 size l x w x h 23 mm x 98 mm x 98 mm weight 27 kg ori apple tv apple  no votes yet 36700 5 34900 quantity 500 store marketplace processor apple singlecore a5 chipsystem requirements wifi 80211a wireless network wireless video streaming requires 80211a 10100baset ethernet networkitunes store accountmlbtv nhl gamecenter live subscription required to watch live and archived games  ',0),(77,'node',' dell alienware x5177822g gaming desktop very compact in size that can fit any places features design available with windows 8 for a smooth versatile pc experienceget the windows 81 update increase productivity with a free update from the windows store for great new apps and features virtual design for virtually any space easily bring high performance pc gaming into any room in your house whether you re connected to a monitor or an hdtv the versatile alienware x51 lets you experience bigscreen gaming wherever you want it mindblowing visuals and sound gaming movies and other images jump off the screen with the powerful nvidia graphics full hd 3d and bluray capabilities of the alienware x51 for those seeking a system that can handle highperformance video and audio content creation look no further than alienware x51 description sku de759elat5r5anmy920910 model x5177822g weight 6kg dell alienware x5177822g gaming desktop dell  no votes yet 129900 23 100000 quantity 100 store weebpal intel core i74770 processor up to 39ghz 8gb ddr3 ram 2tb harddisk 2gb gddr5 nvidia gtx 780  ',0),(78,'node',' 3 port hdmi switch with remote control with a set of correct cables and tools your devices could work properly and it resulting in very satisfying outcome from your devices on the other hand chosing correct cables and tools ensure your devices to last longer get it now while the stock last  features a device that is used to select a video source for the tv via the hdmi interface for example a cable box dvd player and dvr may all have hdmi outputs but the tv may have only one hdmi input in this case a threeport hdmi switch would have three hdmi inputs for the source components and one hdmi output to the tv set when multiple tvs are used there are hdmi switches with two or more outputs the switch may be operated manually by remote control or automatically by priority  description sku oe702elakqt4anmy527371 model hdmi 3p size l x w x h 3x14x15 3 port hdmi switch with remote control oem  no votes yet 8500 35 5500 quantity 500 store weebpal high quality hdmi switcher with intelligent function 3group input 1group output supports with hdmi13b full hd 1080p  ',0),(79,'node',' dell powerconnect 5524p 24 gbe port managed l2 switch with poe support 10gbe and stacking capable the dell 5500 series switches are designed to offer secure fixedport gigabit ethernet switching solutions to deliver fullwirespeed switching performance with 24 or 48 builtin copper gigabit ethernet ports in a 1u form factor the 5500 series has a total switching capacity of up to 176 gbps to support demanding network environments the switches also offer simple management and scalability via a 40gbps highavailability stacking architecture that allows you to manage up to eight switches from a single ip address and share the dual sfp across the stack for uplinks to the next layer in your network the switches are designed for energy efficient ethernet 8023az which will reduce per port power consumption up to 50 if the link is idle and further reduction if ports are inactive specifications  1xpower cord 2m 220v ire uk malaysia singapore brunei lifetime limited dell standard technical support lifetime limited hardware warranty layer 2 managed gigabit switches campusfocused gigabit ethernet switch delivering layer 2 available with 2448 standard gigabit ethernet ports or 2448 power over ethernet poe gigabit ethernet ports campus stacking capability to simplify deployment and management voice capability ms nap certified description sku de759elap5i7anmy696915 model 5524p 24 size l x w x h 381 x 440 x 432cm dell powerconnect 5524p 24 gbe port managed l2 switch with poe support 10gbe and stacking capable dell  no votes yet 159900 19 129900 quantity 400 store marketplace lifetime limited dell standard technical support lifetime limited hardware warranty layer 2 managed gigabit switches voice capability  ',0),(80,'node',' tplink m5250 n900 3g mobile wifi black in this day and age connection to the internet is one of the necessities of living in the digital age with the tplink m5250 3g mobile wifi you will always be connected to the internet no matter where you are perfect for those always on the move 3g coverage tplink s m5250 is at the forefront of wireless 3g sharing combining the mobility of 3g broadband connections with the flexibility of 80211n wifi no other bulky devices required simply insert a 3g sim card to create a 3g wifi hotspot to share on the move wherever 3g coverage is available long lasting battery battery power is incredibly important especially for a portable mobile device like the m5250 with a 2000mah battery the m5250 is capable of operating from 710 hours depending on the usage even under heavy usage the device can last up to 67 hours tops alternatively you can charge the device via micro usb cable to a laptop or portable charger for endless 3g sharing lightweight portable the portable cobblestone design of the m5250 makes it very easy to take it along with you to wherever you go the lightweight yet durable material enables it to withstand light resistance do damage less hassle when travelling description sku tp481elakvc0anmy535125 model tlm5250 network hspa  tplink m5250 n900 3g mobile wifi black tp link  no votes yet 17000 15 14500 quantity 500 store marketplace mobile wifi hotspot 2000mah rechargeable battery hspa support 216mbps download speed  ',0),(81,'node',' tplink n750 wireless dual band gigabit router tlwdr4300 black tplink s tlwdr4300 is a performanceoptimised dual band wireless router that combines the blazing fast speeds of 450mbps using the crystal clear 5ghz band and 300mbps using the traditional 24ghz band with five gigabit ports and 800mbps hardware nat your wired devices will have lightningfast lagfree connections also 2 usb 20 ports capable of sharing flash storage printers ftp servers and media players allowing users to enjoy a robust home media network concurrent dual band wireless the tlwdr4300 broadcasts and receives both 24ghz and 5ghz connections simultaneously at 300mbps and 450mbps respective speeds this allows users to run daytoday applications such as email and web browsing over the 24ghz band at 300mbps at the same time when running more bandwidthintensive or latencysensitive applications such as streaming hd video or playing online games users utilise the clearer 5ghz band at 450mbps description sku tp481elajqboanmy468439 model tlwdr4300 uses properties 4 x 101001000mbps lan ports 1 x 101001000mbps wan port 2 x usb 20 port certification ce fcc ic rohs frequency 24ghz 5ghz tplink n750 wireless dual band gigabit router tlwdr4300 black tp link  no votes yet 21900 quantity 600 store weebpal wireless router 4port switch 24ghz 5ghz up to 450mbps 3 external antennas  ',0),(82,'node',' canon lide 210 scanner highspeed highresolution scans from a stylishly slim cis scanner the advanced clipon scanner stand allows you to operate the scanner in a vertical position so you need minimal space to scan but regardless of where you place this sleek stylish scanner it looks amazing from any angle solve all your scanning needs with 5 conveniently located buttons for effortless onetouch operations anyone can use pdf copy scan or email your documents conveniently and directly from the scanning device to your connected pc streamlining workflow and boosting productivity of daily routine tasks the last ez button allows you to create a multipage pdf file at the touch of a button the scanner is ready to operate the instant they are connected to the pc via usb thanks to its energy efficiency that it only takes a single usb connection to power the scanner upright scanning capability the advanced clipon scanner stand allows you to operate the scanner in a vertical position so you need minimal space to scan but regardless of where you place this sleek stylish scanner it looks amazing from any angle description sku ca673elam9xuanmy618219 model lide 210 size l x w x h 365 x 25 x 39 canon lide 210 scanner canon  no votes yet 59900 17 49900 quantity 500 store marketplace flatbed scanner scan speed a4 300dpi 10secs scan resolution 4800 x 4800dpi usb 20  ',0),(83,'node',' epson perfection v33 scanner unsurpassed image quality in high resolution with a high resolution of 4800dpi and  matrix ccd   you can be assured that every intricate detail in your images will be captured and preserved in addition original colours and details can be accurately reproduced with 48 bit colour depth and embedded icc profile customisable onetouch operation for your convenience four onetouch buttons on the control panel are predefined with copy start scantoemail and scantopdf functions allocate up to 10 settings effortlessly through epson event manager to suit your personal preferences experience customisation at a convenience and versatility like never before versatility and convenience with a single software epson scan v39 epson scan v39 facilitates rotational view of documents and additional language support in searchable pdf the auto area segmentation function also allows separate scanning of both image and text in a document description sku ep840elaltf7anmy589363 model v33 size l x w x h 43 x 28 x 3 epson perfection v33 scanner epson  no votes yet 39900 6 37700 quantity 500 store marketplace 4800 x 9600 dpi 4 customisable buttons zero warmup time bundled software  ',0),(84,'node',' casio exilim exzr1500 digital camera pink with the new exzr1500 taking stunning photos and selfportraits has never been easier users can now easily edit their selfportraits according to their preference with the new makeup function that allows adjustment of skin smoothness to 12 levels and enhancement of skin tone according to a scale of six stages from light to tan easy to see and shoot lcd tilts to make a snap for selfportraits the lcd opens up 180 so you can check your selfportraits as you shoot it shoots from a variety of angles letting you get just the right composition and its builtin camera stand lets you shoot handsfree enjoy shooting selfportraits in all kinds of poses the advanced makeup mode satisfies the pursuit of beauty automatically detects human faces and smoothes and brightens the skin you can adjust skin tone and smooth skin to produce the beautiful finish you prefer whether it is skin with a whitened tone or lively healthy skin  art shot bracketing lets you encounter the unexpected in one shot one click of the shutter creates 5 different styles lets you try different effects in one go enhancing the individuality of your photos and changing ordinary shots into artistic ones it lets you encounter the unexpected in one shot and broaden your photographic expression  description sku ca680elapvlxanmy743566 model exzr1500 size l x w x h 1075 w x 615 h x 367 d mm casio exilim exzr1500 digital camera pink casio  no votes yet 79900 25 59900 quantity 500 store marketplace 161mp125x optical zoom4x digital zoom1 23inch highspeed cmos back illuminated type 30inch tft color lcd super clear lcd lcd tilts to make a snap for selfportraits  ',0),(85,'node',' canon powershot sx60 hs 161mp black 8gb case the powershot sx60 hs camera employs a 161 megapixel cmos sensor utilizing a sophisticated lightcapturing design it provides high sensitivity for improved high iso capture with reduced noise it is also a highspeed design capable of rapidly capturing and moving image data to the processor enabling faster continuous shooting and faster autofocus the powershot sx60 hs camera is equipped with the very latest canon proprietary processor the digic 6 image processor which makes several important advancements to image quality both in stills and video improved light sensitivity allows for higher resolution with less noise when shooting in dark conditions and dynamic is now detects and compensates for tilt and parallel movement shift blur to create video that s exceptionally free of distortion the digic 6 image processor also enhances the performance capabilities of the powershot sx60 hs powering full resolution highspeed continuous stills shooting and video recording is better than ever as the digic 6 image processor enables full hd at 60p as well as mp4 recording highly compressed mp4 video not only preserves space on your memory card but also improves playback on mobile devices  description sku ca673elarxo5anmy857455 model sx60 hs size l x w x h 1276 x 926 x 1143 canon powershot sx60 hs 161mp black 8gb case canon  no votes yet 129900 23 99900 quantity 300 store marketplace 161mp high sensitivity cmos sensor digic 6 image processor 65x optical zoom lens 211365mm 35mm equivalent  ',0),(86,'node',' canon eos 600d 18mp 1855mm lens dive into the world of photography with the canon eos 600d it is the advanced entryclass dslr with the cutting edge technology to bring out the inner desire of you it has 18 megapixels cmos sensor that able to capture photos with magnificent qualities the imaging processor is dig c 4 for faster and better results in taking shots the canon eos 600d also capable in recording stunning full hd videos the 3 inch lcd is adjustable with multiple angles to cope with your shooting skills  180megapixel cmos sensor this camera comes with 18megapixel cmos apscsized sensor that lets you to capture just about any scenes from vast breathtaking landscapes to closeup wildlife shots in explicit detail photos of 18megapixel resolution can easily be converted or zoomed in to gallery ready print shots 3inch wide lcd monitor recording and playback of images are seamless with the crisp 3inch wide variangle clear view lcd monitor that contains over a million dots make full use of the specially designed hinge which can be swivelled in almost any angle to easily frame you subject and find the best angle scene intelligent auto scene intelligent auto is feature that gives better exposure in any picture you took it will analyse every elements in the photos taken and then it will evaluate and eventually the photo is now seems like auto fixed description sku ca673elalorhanmy581181 model eos 600d size l x w x h 5x5x5 canon eos 600d 18mp 1855mm lens canon  no votes yet 49900 quantity 500 store marketplace 180mp 3x 10x zoom 32 lcd screen sd sdhc sdxc compatible full hd recording  ',0),(87,'node',' face care skii 5piece skincare travel set 5pcs travel packs skii sk2 face care ',0),(88,'node',' samsung smart camera nx mini 205mp green 9mm lens 16 gb memory card it is now easier to capture those fleeting moments of your live wherever you are using just the right lens with samsung smart camera nx mini this slim ultraportable digital camera measures just 225 millimeters wide and can be used with any lens in samsung s nx series a 3inch flipup lcd touch screen is perfect for selfies while wifi capability lets you back up photos and videos post them to social networks or send them to friends and family crystal clear resolution samsung smart camera nx mini comes equipped with 205mp bsi cmos sensor for highquality images and lifelike colours with crystal clear resolution to perfectly capture your most precious moments stylishly slim 225mm and impressively light 158g this mini camera can perfectly fit your pocket or handbag wink shot the nx mini provides a fun and easier way to take your beloved selfies with the wink shot feature simply give it a wink and it will take the shot 2 seconds later no button necessary don t forget to smile  get creative why settle for plain and boring photos when you can work your magic with different special effects available on your samsung smart camera nx mini take your pick from these amazing effects that seamlessly transform each snapshot into a work of art display your playful side with cartoon effect or oil paint for days when you feel like creating gallery material masterpiece other special effects to choose from are negative vivid custom effect fisheye soft focus sketch landscape portrait miniature calm classic forest retro cross filter vignetting ink painting and zooming shot  description sku sa356elaovyaanmy683458 model nxf1 display size inch 30 megapixels 205 samsung smart camera nx mini 205mp green 9mm lens 16 gb memory card samsung  no votes yet 99900 31 68800 quantity 500 store weebpal 5 megapixel 3 flipup lcd display 2gb builtin memory capture 1080p hd video liion rechargeable battery 2330 mah  ',0),(89,'node',' nikon afs 50mm lens f 18g this updated classic with a fast maximum aperture is ideal for everyday shooting perfect in low lighting situations and great for producing images with beautiful background blur bokeh the afs nikkor 50mm f 18g includes silent wave motor technology swm for fast and precise autofocus m a focus mode switch for seamless changes between manual and autofocus operation and an aspherical lens element for outstanding optical performance with high contrast brilliance in any light this lightweight standard lens is a great travel companion because you never know when a beautiful sunny day will turn cloudy and rainy with its fast f 18 aperture the afs nikkor 50mm f 18g will capture even lowlight situations with stunning brilliance beautiful background blur whether you re shooting portraits food or nature indoors or outdoors the afs nikkor 50mm f 18g renders a beautiful natural background blur bokeh at its wider aperture settings and its 50mm focal length is perfect for creating natural perspective in your photographs capture every detail nikon s super integrated coating sic enhances light transmission efficiency and offers superior colour consistency and reduced flare while the afs nikkor 50mm f 18g s aspherical lens element as virtually eliminates coma and other types of aberrations even when shooting at the widest available aperture pair that with nikon s silent wave motor swm for fast accurate and quiet autofocus and you can be sure all of your portraits will be tack sharp description sku ni220elao90eanmy649565 size l x w x h 711 d x 533 weight 0187kg nikon afs 50mm lens f 18g nikon  no votes yet 69900 37 43800 quantity 500 store weebpal autofocus lens 58mm filter size no image stabilisation  ',0),(90,'node',' canon efs lens 18200mm f 3556 is description sku ca673elatex3anmy936277 size l x w x h 20 x 30 x 10 weight 5 canon efs lens 18200mm f 3556 is canon  no votes yet 89900 11 quantity 79900 400 store weebpal  ',0),(91,'node',' cokin u961a z pro grad kit z filter holder z121l z123l z125l kits include a cokin zpro filter holder and three graduated filters grad nd blue tobacco kit filter holder grad grey nd2 121l grad blue b2 light 123l grad tobacco t2 light 125l code u961 description sku co716elapowbanmy731726 size l x w x h 17x15x10 weight 1 cokin u961a z pro grad kit z filter holder z121l z123l z125l cokin  no votes yet 54800 quantity 400 store weebpal helps control depth of field helps create certain special effects high quality cr39 resin  ',0),(92,'node',' dlink dcs5222l cloudcam hd wireless n pan tilt network camera equipped with a high quality 10 lux cmos sensor the dcs5222l delivers exceptional picture quality even in lowlight conditions with builtin ethernet and wireless n connectivity options the dcs5222l provides easy and flexible installation options the motorized pan tilt controls and 10x digital zoom allow you to monitor a large area and zoom to view fine details and the pir sensor detects movement in the area and can trigger recordings the dcs5222l can record snapshots and video to your computer a network storage drive or a microsd card camera footage can be viewed remotely through a web browser or through a mobile device running the mydlink ﾙ app for ios and android furthermore the camera provides a privacy mode option which allows you to set a schedule to enter privacy mode which rotates the lens backwards to protect your privacy anywhere access with mydlink with the mydlink lite app for iphone and android you can quickly and easily see your camera feed from anywhere with a wifi 3g or 4g connection no more guessing what s going on at your house while you re away thanks to this app you can monitor onthego even if you don t have access to a computer sharp image monitoring from different angles with sharp responsive pan tilt movement and digital zoom the dcs5222l gives you full control so you can quickly scan a wide area from a variety of angles and 10x digital zoom lets you zoom in for more detail hd video quality the dcs5222l delivers the confidence of 720p hd video clarity ensuring rich detail and crisp image quality for your surveillance recordings and with integrated nightvision and pir motionsensing technology the dcs5222l remains vigilant 24 hours a day whether you re there or not description sku dl746elaozrfanmy689095 size l x w x h 114x114x125 weight 54 dlink dcs5222l cloudcam hd wireless n pan tilt network camera dlink  no votes yet 48000 quantity 600 store weebpal night vision sound and motion detection remote viewing local recording  ',0),(93,'node',' cctv 850tvl ir dome cctv camera 13 super cmos dome 850tvl ir dome 24leds night view up to 20m high resolution plastic housing black and white lens option 36mm 6mm auto gain control agc builtin auto gain control agc circuit gamma characteristic camera gamma characteristic is 45 scanning mode ntsc or pal mode nighttime vision  lux with ir led on description sku sc910elaptxianmy740946 model std403 size l x w x h 9 x 10 x 8 cctv 850tvl ir dome cctv camera scantrack  no votes yet 12800 quantity 700 store weebpal high resolution plastic housing black and white lens option 36mm 6mm auto gain control agc  ',0),(94,'node',' trek aiball portable wifi remote camera with cradle adaptors yellow  what is an aiball  the aiball is an ultraportable wireless camera module that allows users to view and record audio and video wirelessly on their pc or smartphones aiball cradle power your aiball now with the aiball cradle which runs on interchangeable usb car and regular ac dc adapters for roundtheclock aiballing features  round the clock viewing recording choose from usb car or regular ac dc power to run your aiball all day long just pop your aiball into the cradle adjust its viewing angle and you are all set for roundtheclock streaming and recording wireless with its 80211 b g wifi interface the aiball allows you to stream and record audio video images through your mobile devices such as your smartphones iphones or android devices and laptops on the go description sku tr626elampm1anmy645445 size l x w x h 13 x 115 x 165 weight 3 trek aiball portable wifi remote camera with cradle adaptors yellow  trek  no votes yet 15900 quantity 700 store weebpal vga 640x480 qvga 320x240 qqvga 160x120 up to 30fps f28 view angle 60 degree focusing 20cm to infinity motion jpeg  ',0),(95,'node',' mini quran for kids yellow as a muslim it is vital to start educating the children in the arts of islamic teachings at a very young age the mini quran is a great way for your kids to learn and memorize their doas surahs from the quran and prayers learn and play the mini quran for kids include 16 sections of the quran 26 prayers 8 classic songs reading when worship projection at night or dark room description sku ct941tbam1qdanmy602711 size l x w x h 25x23x19 weight 10 mini quran for kids yellow ct toys  no votes yet 6990 67 2300 quantity 100 store weebpal on off button in the back for ages 3 and above requires 3x aaa batteries not included the islamic quran play machine with projection  ',0),(96,'node',' boogie board 105 inch lcd writing tablet pink highlights writing tablet created to make lists draw or jot down paperless notes green alternative to sticky notes memo pads paper and ink less than a 14 thin and is easy to take with you in a purse scheduler briefcase or backpack ultra low power consumption one set of batteries 2 aaaaincluded will last tens of thousands of erases includes lcd screen cleaning cloth to safely remove smudges lcd are made from durable plastic materials safe for school work or even home use lightweight portable and durable  specifications  measurement 27cm x 1705cm lcd 105 inch powered aaaa battery color pink description sku bo242tbapso5anmy738496 size l x w x h 223 x 142 x 3 weight 119 boogie board 105 inch lcd writing tablet pink boogie  no votes yet 19900 quantity 500 store weebpal writing tablet created to make lists draw or jot down paperless notes green alternative to sticky notes memo pads paper and ink less than a 14 thin and is easy to take with you in a purse scheduler briefcase or backpack  ',0),(97,'node',' transporter carry cot chicco transporter carry cot can be used to change nappies anywhere anytime it gives parents and newborns an extra sense of closeness and security keeps baby secure and in place comfortably so you can focus on changing their diapers convenient for mums night time feeding description sku ch299tbas06zanmy861162 size l x w x h 75 x 315 x 105 weight 26 transporter carry cot chicco  no votes yet 18900 34 12500 quantity 500 store weebpal practical carry handles ideal for fitting to the chicco ct 2 stroller removable sun canopy internal lining in breathable fabric the removable and adjustable blanket allows you to use the carrycot in every season  ',0),(98,'node',' educational toys mini quran for kids yellow educational toys ',0),(99,'node',' books stationery boogie board 105 inch lcd writing tablet pink books stationery ',0),(100,'node',' health safety transporter carry cot health safety ',0),(101,'node',' backpacks local lion water resistant hiking backpack bag 28l blue local lion water resistant hiking backpack bag 28l blue local lion water backpacks ',0),(102,'node',' shoe bags diniwell waterresistant travel shoes bag pouch organizer bag ver 2 orange shoe bags ',0),(103,'node',' makeup cameleon makeup kit 396 makeup ',0),(104,'node',' eye care organic eye cream 15ml eye care ',0),(105,'node',' health beauty tools hairscape 1800w aus 5000 professional hair dryer health beauty tools ',0),(106,'node',' food supplements mejikaliner quick eyelid essence stick glue night use food supplements ',0),(107,'node',' basic phones lenovo a316 basic phones ',0),(108,'node',' car accessories angel universal mobile phone in car phone holder 360 degree item code p338 car accessories ',0),(109,'node',' cases covers galaxy note 4 spigen case neo hybrid metal gold cases covers ',0),(110,'node',' smartphones samsung n910 note 4 lte 32gb white smartphones ',0),(111,'node',' with call facility asus memopad 7 tablet  with call facility ',0),(112,'node',' without call facility lenovo tablet miix 2 59399848 8 silver without call facility ',0),(113,'node',' headphones sony stereo bluetooth headset sbh20 black headphones ',0),(114,'node',' batteries chargers top mi 10400mah powerbank black batteries chargers ',0),(115,'node',' women s jewellery muwo trendz swarovski element white gold plated everlasting love set women s jewellery ',0),(116,'node',' belts dandelion cross stitch belt orange belts ',0),(117,'node',' scarves fur nyce fashion zebra pattern print scarf white scarves ',0),(118,'node',' business rolex submariner black dial stainless steel automatic mens watch 114060 business ',0),(119,'node',' sports suunto vector black suss010600610 mountain outdoor watch sports ',0),(120,'node',' televisions sony 48 full hd led tv bravia model kdl48r470b televisions ',0),(121,'node',' home audio samsung hte350k dvd home theater system home audio ',0),(122,'node',' gadgets l12s oled smart watch bluetooth 30 bracelet wrist design for ios android iphone samsung smart phone blue gadgets ',0),(123,'node',' laptops apple macbook pro me864 zp a core i5 133in 4gb laptops ',0),(124,'node',' desktop asus transformer p1801b041k aio 184 pc dekstop asus rtn56u wireless n n600 dualband gigabit router desktops ',0),(125,'node',' switches dell powerconnect 5524p 24 gbe port managed l2 switch with poe support 10gbe and stacking capable switches ',0),(126,'node',' routers tplink n750 wireless dual band gigabit router tlwdr4300 black routers ',0),(127,'node',' scanners canon lide 210 scanner scanners ',0),(128,'node',' point shoot cameras casio exilim exzr1500 digital camera pink point shoot cameras ',0),(129,'node',' dslr slr cameras canon eos 600d 18mp 1855mm lens dslr slr cameras ',0),(130,'node',' filters cokin u961a z pro grad kit z filter holder z121l z123l z125l filters ',0),(131,'node',' lenses canon efs lens 18200mm f 3556 is lenses ',0),(132,'node',' ip cameras dlink dcs5222l cloudcam hd wireless n pan tilt network camera ip cameras ',0),(133,'node',' car cameras trek aiball portable wifi remote camera with cradle adaptors yellow  car cameras ',0),(134,'node',' laptop bags cases terminus t02297lap01 laptop backpack plus laptop bags cases ',0),(135,'node',' asus asus memopad 7 tablet  asus ',0),(136,'node',' rolex rolex submariner black dial stainless steel automatic mens watch 114060 rolex ',0),(137,'node',' canon canon powershot sx60 hs 161mp black 8gb case canon ',0),(138,'node',' kinohimitsu j pan bb drink 50ml x 10 the key to a gorgeous complexion is to have healthy glowing skin the kinohimitsu j pan bb drink is an amazing instant drink that helps restore your skin s natural glow and clarity not just your face but your entire body including your back hands and legs allnatural ingredients infused with allnatural and beneficial ingredients such as hydrolysed bird s nest chicken cartilage a source of hyaluronic acid and fermented yeast a source of coenzyme q10 coq10 kinohimitsu j pan bb drink is a healthy and effective solution to nourish hydrate and rejuvenate every single cell in your body by giving rich healthful nutrients to promote a babylike rosy complexion unleash the radiance within for many individuals a bright glowing complexion often means health and happiness but sometimes the rosy sheen on our face is just too difficult to maintain over time skin looks dull and lifeless perhaps as a result of dehydration improper face cleansing lack of essential vitamins poor blood circulation buildup of dead skin cells and environmental elements description sku ki236hbap7fzanmy699829 size l x w x h 20x20x20 weight 1 kinohimitsu j pan bb drink 50ml x 10 kinohimitsu  no votes yet 14900 13 13000 quantity 500 store weebpal beauty drink 50ml x 10 s 100 allnatural ingredients promotes healthier luminous skin  ',0),(139,'node',' tko fat burner mega get the blast of the delicious fat burner mega in a convenient powder format just mix and drink with its own unique powerful formula that delivers an amazing experience the fat burner mega is the perfect solution for when you re trying to get your sweat on in the gym or even when doing light excercise at your very own home featuring a potent acai berry dose shown to aid weight loss fat burner mega also features lcarnitine and lecithin for an unmatched weight loss experience description sku tk512spala1fanmy557274 size l x w x h 9 x 10 x 9 weight 38 kg tko fat burner mega tko nutrition  no votes yet 15000 quantity 500 store weebpal top quality premium fat burner increases energy efficient carbohydrate blocker  ',0),(140,'node',' filters cokin u961a z pro grad kit z filter holder z121l z123l z125l filters ',0),(141,'node',' 404page page doesn t exist or some other error occured back to home ',0),(142,'node',' black friday black friday ',0),(143,'node',' get 20 off instantly lorem ipsum dolor sit amet consectetur adipiscing elit curabitur bibendum sagittis lectus at interdum diam fermentum nec aliquam erat volutpat in pharetra augue quis leo malesuada feugiat nam vestibulum risus quis est consequat ac efficitur nisl efficitur vivamus porta dui rutrum dictum auctor tortor dolor aliquet velit a dapibus sem diam sed massa donec id facilisis libero quis suscipit odio nam sed nulla in erat vehicula malesuada volutpat vel ante donec sodales eros felis ut auctor neque vestibulum sit amet sed lacinia pellentesque nulla rhoncus consectetur eros porta quis maecenas feugiat mi ac urna molestie vel hendrerit lacus tempus morbi egestas sem risus et bibendum justo mattis eu donec sollicitudin ultricies nulla at efficitur donec non est vel risus ullamcorper malesuada vivamus id volutpat augue in convallis tortor morbi eleifend volutpat ipsum non hendrerit vestibulum dignissim magna non justo viverra dapibus duis varius molestie dolor et rhoncus dolor lobortis vel cras nec quam at est viverra vestibulum nec et arcu sed nec vehicula purus etiam nisl risus scelerisque vitae commodo semper dignissim vel arcu pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas pellentesque nibh lectus ornare ac ultrices quis vulputate at leo duis dictum metus eget metus ornare posuere integer tincidunt hendrerit erat phasellus at arcu a augue ultricies eleifend sed laoreet laoreet odio vitae pretium in fringilla commodo elit nec placerat sed non placerat nibh vestibulum tincidunt mi risus proin quis pharetra eros cras a libero nibh curabitur libero mauris sodales sit amet diam in ultrices egestas lectus nullam id tortor in lorem dictum tristique nulla condimentum facilisis tellus mauris urna magna semper ac gravida quis volutpat at tellus sed vulputate urna ac dui sodales id eleifend turpis lacinia nam accumsan purus et dolor viverra laoreet proin efficitur congue tortor sit amet iaculis nullam porttitor in magna ut venenatis donec tristique ante aliquet diam consectetur in varius eros aliquam in sed felis a leo hendrerit iaculis sed aliquam mollis risus sed convallis ipsum vulputate sit amet cras accumsan sodales efficitur praesent egestas vulputate nunc id lacinia elit commodo nec pellentesque convallis viverra nunc eget pharetra morbi efficitur tempor vehicula nulla scelerisque lorem et sapien dapibus sit amet feugiat neque dapibus praesent id enim mauris donec mollis tortor nec placerat eleifend suspendisse ac turpis ullamcorper scelerisque lorem ac facilisis ante phasellus vestibulum diam a nisi mattis mollis suspendisse hendrerit dui eu urna vestibulum scelerisque nunc vel metus ex p  ',0);
/*!40000 ALTER TABLE `search_dataset` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_index`
--

DROP TABLE IF EXISTS `search_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_index` (
  `word` varchar(50) NOT NULL DEFAULT '' COMMENT 'The search_total.word that is associated with the search item.',
  `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The search_dataset.sid of the searchable item to which the word belongs.',
  `type` varchar(16) NOT NULL COMMENT 'The search_dataset.type of the searchable item to which the word belongs.',
  `score` float DEFAULT NULL COMMENT 'The numeric score of the word, higher being more important.',
  PRIMARY KEY (`word`,`sid`,`type`),
  KEY `sid_type` (`sid`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores the search index, associating words, items and...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_index`
--

LOCK TABLES `search_index` WRITE;
/*!40000 ALTER TABLE `search_index` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `search_index` VALUES ('0187kg',89,'node',0.886095),('01kg',56,'node',1),('033inches',45,'node',1),('03h',63,'node',1),('03h',64,'node',1),('08mm',53,'node',1),('1',27,'node',0.72066),('1',35,'node',1),('1',38,'node',51.2944),('1',40,'node',1),('1',41,'node',1),('1',42,'node',1),('1',43,'node',2),('1',45,'node',0.731649),('1',50,'node',2),('1',53,'node',1),('1',56,'node',1),('1',61,'node',0.957226),('1',81,'node',1),('1',91,'node',1),('1',138,'node',0.96498),('10',22,'node',1),('10',36,'node',1),('10',40,'node',1),('10',49,'node',2),('10',67,'node',1.92743),('10',69,'node',1),('10',83,'node',1),('10',90,'node',1),('10',92,'node',1),('10',93,'node',1),('10',95,'node',1),('10',138,'node',51.9121),('10',139,'node',1),('100',31,'node',0.754681),('100',32,'node',0.866793),('100',42,'node',1),('100',46,'node',0.819249),('100',68,'node',1),('100',73,'node',1),('100',77,'node',1),('100',95,'node',1),('100',138,'node',0.923838),('1000',35,'node',1),('1000',38,'node',0.945829),('1000',48,'node',0.892724),('1000',68,'node',1),('10000',62,'node',1),('10000',70,'node',1),('100000',46,'node',0.824901),('100000',68,'node',1),('100000',77,'node',1),('101001000mbps',81,'node',2),('10100baset',76,'node',0.863659),('10400mah',59,'node',54.3365),('10400mah',114,'node',11),('105',96,'node',53),('105',97,'node',1),('105',99,'node',11),('107',74,'node',1.85512),('10700',40,'node',1),('1075',84,'node',0.913226),('1080',45,'node',1),('1080',71,'node',0.731649),('1080p',44,'node',0.833529),('1080p',45,'node',1),('1080p',49,'node',0.931053),('1080p',72,'node',1),('1080p',78,'node',0.997306),('1080p',88,'node',0.736141),('10gbe',79,'node',50.1132),('10gbe',125,'node',11),('10secs',82,'node',0.96498),('10x',86,'node',0.830633),('10x',92,'node',1.92384),('10x10x10',37,'node',0.949597),('11',41,'node',1),('11',43,'node',1),('11',74,'node',0.857458),('11',90,'node',1),('110l',63,'node',1),('110l',64,'node',1),('114060',68,'node',54),('114060',118,'node',11),('114060',136,'node',11),('1143',85,'node',0.953396),('114x114x125',92,'node',0.842342),('115',94,'node',1),('11500',41,'node',1),('119',96,'node',1),('11900',40,'node',1),('11900',55,'node',1),('119900',71,'node',0.747619),('12',32,'node',0.876337),('12',35,'node',1),('12',40,'node',1),('12',50,'node',1),('12',84,'node',1),('12000',43,'node',1),('12092014',52,'node',0.78951),('121l',91,'node',1),('1224',70,'node',2),('123l',91,'node',1),('12500',97,'node',1),('125l',91,'node',1),('1276',85,'node',0.961087),('12800',93,'node',1),('1280x800',51,'node',4),('128bit',24,'node',0.971769),('128gb',45,'node',0.76188),('12900',41,'node',1),('129900',68,'node',1),('129900',73,'node',1),('129900',77,'node',1),('129900',79,'node',0.913226),('129900',85,'node',0.942091),('12x12x12',67,'node',0.980874),('13',38,'node',0.989021),('13',65,'node',0.953396),('13',73,'node',1),('13',93,'node',1),('13',94,'node',1),('13',138,'node',0.949597),('13000',138,'node',0.945829),('130cm',65,'node',0.923838),('132',51,'node',0.961087),('133',54,'node',0.916736),('133in',123,'node',11),('135',34,'node',1),('135',60,'node',1),('13900',58,'node',1),('13cm',68,'node',1),('13ghz',47,'node',1.81367),('13mp',48,'node',0.882818),('13x10x45',58,'node',1),('14',51,'node',0.931053),('14',96,'node',2),('142',96,'node',1),('1422',52,'node',0.786915),('1440',45,'node',1),('145',32,'node',1),('14500',80,'node',0.942091),('14900',58,'node',1),('14900',138,'node',0.953396),('149900',71,'node',0.752312),('149900',73,'node',1),('15',70,'node',2),('15',80,'node',0.945829),('15000',139,'node',1),('153',69,'node',1),('1535',45,'node',1.71636),('15422',67,'node',54.3831),('1546',54,'node',0.913226),('155',74,'node',0.909743),('15500',54,'node',0.896076),('156in',33,'node',56),('158g',88,'node',1),('15900',94,'node',1),('159900',79,'node',0.920273),('15cm',68,'node',1),('15g',57,'node',1),('15ml',40,'node',52),('15ml',104,'node',11),('15x15x15',41,'node',1),('16',38,'node',0.993146),('16',53,'node',1),('16',88,'node',45.9997),('16',95,'node',1),('16001800',42,'node',1),('160x120',94,'node',1),('161',85,'node',1),('161mp',85,'node',51.6063),('161mp',137,'node',11),('161mp125x',84,'node',0.873132),('163kg',33,'node',1),('165',94,'node',1),('168',75,'node',1),('1695',52,'node',0.876337),('16gb',44,'node',43.2853),('16gb',52,'node',49.464),('16ohm',58,'node',0.997306),('17',40,'node',1),('17',49,'node',1.95793),('17',82,'node',1),('17000',80,'node',0.949597),('1705cm',96,'node',1),('176',45,'node',1),('176',79,'node',1),('17900',31,'node',0.771698),('17900',75,'node',0.968904),('17cm',68,'node',1),('17x15x10',91,'node',1),('18',24,'node',0.445053),('18',30,'node',0.934703),('18',36,'node',1),('18',43,'node',1),('18',58,'node',0.972861),('18',65,'node',0.972861),('18',86,'node',1),('18',89,'node',1),('180',66,'node',0.972861),('180',84,'node',1),('1800',16,'node',1),('1800',18,'node',1),('1800',19,'node',1),('1800w',42,'node',53),('1800w',105,'node',11),('180degree',51,'node',1),('180megapixel',86,'node',4),('180mp',86,'node',0.833529),('18200mm',90,'node',52),('18200mm',131,'node',11),('1837',67,'node',1),('184',46,'node',47.5965),('184',124,'node',11),('184inch',46,'node',1.98902),('1855mm',86,'node',48.2142),('1855mm',129,'node',11),('186ghz',51,'node',0.896076),('18900',97,'node',1),('18g',89,'node',52.9261),('18k',61,'node',0.899454),('18megapixel',86,'node',2),('18mp',86,'node',48.2142),('18mp',129,'node',11),('19',79,'node',0.916736),('1920',45,'node',1),('1920',71,'node',0.733888),('1920',72,'node',1),('1953',68,'node',1),('196x1086x674',72,'node',1),('197',50,'node',1),('1970',67,'node',1),('1990',67,'node',1),('19900',36,'node',1),('19900',47,'node',0.842342),('19900',96,'node',1),('1click',26,'node',1),('1group',78,'node',1),('1pc',39,'node',4),('1piece',70,'node',1),('1xpower',79,'node',1),('2',8,'node',26),('2',27,'node',2.63413),('2',35,'node',52),('2',38,'node',0.976851),('2',42,'node',1),('2',49,'node',3.95772),('2',51,'node',52.4593),('2',60,'node',0.953396),('2',61,'node',1.95723),('2',62,'node',1),('2',79,'node',2.89338),('2',81,'node',2),('2',88,'node',1),('2',96,'node',1),('2',97,'node',1),('2',102,'node',11),('2',112,'node',11),('20',14,'node',37),('20',26,'node',1),('20',39,'node',1),('20',47,'node',0.845322),('20',52,'node',0.863659),('20',71,'node',0.749958),('20',81,'node',2),('20',82,'node',0.949597),('20',90,'node',1),('20',143,'node',26),('200',37,'node',0.923838),('200',55,'node',1),('200',74,'node',0.879565),('2000',53,'node',0.98493),('2000',63,'node',1),('20000mah',60,'node',53.6679),('2000mah',80,'node',1.92384),('2012',46,'node',1),('2014',53,'node',1),('203500',72,'node',1),('205',88,'node',0.771698),('205mp',88,'node',46.9997),('206',48,'node',54.7167),('20cm',94,'node',1),('20g',39,'node',5),('20m',93,'node',1),('20x20x20',138,'node',0.972861),('21',48,'node',0.873132),('21',55,'node',1),('21',66,'node',0.957226),('210',82,'node',53),('210',127,'node',11),('211365mm',85,'node',0.902857),('215',35,'node',1),('216',51,'node',0.953396),('216mbps',80,'node',0.916736),('21900',81,'node',0.980874),('21a',59,'node',0.927431),('22',49,'node',0.98493),('22',50,'node',1),('220v',79,'node',1),('223',96,'node',1),('225',88,'node',1),('225mm',88,'node',1),('228',74,'node',0.927431),('22cm',60,'node',1),('23',40,'node',1),('23',42,'node',2),('23',47,'node',0.827757),('23',68,'node',1),('23',76,'node',0.942091),('23',77,'node',1),('23',85,'node',0.938382),('2300',95,'node',1),('2330',88,'node',0.725015),('236',47,'node',1),('23800',39,'node',1),('23inch',84,'node',0.860547),('24',27,'node',0.882818),('24',33,'node',1),('24',48,'node',1.97286),('24',52,'node',0.879565),('24',57,'node',1),('24',79,'node',52.0553),('24',92,'node',0.873132),('24',125,'node',11),('240',44,'node',0.822065),('2400',64,'node',1),('2448',79,'node',1.98217),('24ghz',46,'node',0.873132),('24ghz',81,'node',4.94654),('24leds',93,'node',1),('24piece',36,'node',53),('24x',37,'node',1.8941),('25',70,'node',1),('25',74,'node',0.949597),('25',82,'node',1),('25',84,'node',0.892724),('25000',47,'node',0.848323),('250mah',75,'node',1),('2560',45,'node',1),('25900',61,'node',0.945829),('25x23x19',95,'node',1),('26',35,'node',1),('26',43,'node',1),('26',56,'node',1),('26',95,'node',1),('26',97,'node',1),('26010337991385',64,'node',1),('2603',33,'node',1),('260500059912717',63,'node',1),('26400',32,'node',0.873132),('264ppi',52,'node',0.839384),('265mb',47,'node',0.816452),('27',45,'node',1),('27',76,'node',0.931053),('2700',43,'node',1),('27cm',96,'node',1),('28',83,'node',1),('285',74,'node',0.902857),('28l',31,'node',48.1943),('28l',101,'node',12),('29',35,'node',1),('2900',56,'node',1),('2900',62,'node',1),('29900',32,'node',0.879565),('29900',39,'node',1),('29900',51,'node',0.927431),('29900',75,'node',0.976851),('299900',72,'node',1),('2gb',51,'node',0.892724),('2gb',77,'node',0.976851),('2gb',88,'node',0.740689),('2ml',41,'node',1),('2mp',47,'node',0.824901),('2mp',51,'node',1),('2mpcamera',47,'node',0.892724),('2tb',77,'node',0.98493),('3',36,'node',1),('3',41,'node',1),('3',42,'node',2),('3',43,'node',1),('3',45,'node',2.71636),('3',46,'node',0.833529),('3',49,'node',51.3981),('3',71,'node',0.727213),('3',78,'node',52),('3',81,'node',0.953396),('3',83,'node',0.997306),('3',86,'node',1),('3',88,'node',0.742984),('3',94,'node',1),('3',95,'node',1),('3',96,'node',1),('30',27,'node',0.869951),('30',39,'node',1),('30',48,'node',0.902857),('30',53,'node',0.997306),('30',74,'node',0.906287),('30',75,'node',51.7145),('30',88,'node',0.776703),('30',90,'node',1),('30',122,'node',11),('300',30,'node',0.892724),('300',47,'node',0.836446),('300',61,'node',0.931053),('300',68,'node',1),('300',85,'node',0.927431),('3000',66,'node',0.953396),('300dpi',82,'node',0.968904),('300mbps',81,'node',3),('30day',27,'node',1),('30fps',94,'node',1),('30inch',84,'node',0.842342),('30m',70,'node',54),('30ml',39,'node',2),('31',30,'node',0.938382),('31',88,'node',0.76188),('315',97,'node',1),('31800',33,'node',1),('32',72,'node',1),('32',86,'node',0.824901),('3200',45,'node',1),('320x240',94,'node',1),('32gb',45,'node',45.7572),('32gb',110,'node',11),('330',68,'node',1),('33000',38,'node',0.961087),('33x15x40',32,'node',0.896076),('34',97,'node',1),('34900',50,'node',1),('34900',51,'node',0.934703),('34900',76,'node',0.913226),('35',27,'node',1),('35',30,'node',1),('35',51,'node',0.945829),('35',78,'node',1),('3500',34,'node',1),('3500',65,'node',0.949597),('3556',90,'node',52),('3556',131,'node',11),('35mm',85,'node',0.899454),('360',56,'node',53),('360',108,'node',11),('365',82,'node',1),('367',84,'node',0.906287),('36700',76,'node',0.920273),('36900',74,'node',0.886095),('36mm',93,'node',2),('37',89,'node',0.873132),('3746',33,'node',1),('37700',83,'node',0.976851),('38',42,'node',1),('38',74,'node',0.889397),('38',139,'node',1),('3800',30,'node',0.906287),('3800',66,'node',0.961087),('381',79,'node',0.938382),('386',45,'node',1),('388',33,'node',1),('39',82,'node',1),('3900',38,'node',0.953396),('3900',56,'node',1),('3900',59,'node',0.957226),('396',37,'node',51.387),('396',103,'node',11),('39900',60,'node',0.976851),('39900',67,'node',0.961087),('39900',83,'node',0.98493),('3999',26,'node',0.934703),('39ghz',77,'node',1),('3gb',45,'node',0.953396),('3group',78,'node',1),('3inch',86,'node',5),('3inch',88,'node',1),('3ohm',58,'node',0.968904),('3rd',46,'node',1),('3x14x15',78,'node',1),('4',34,'node',1),('4',37,'node',0.942091),('4',38,'node',51.2944),('4',45,'node',58.0148),('4',53,'node',56),('4',54,'node',56.4743),('4',61,'node',1.90286),('4',71,'node',46.4131),('4',81,'node',1),('4',83,'node',0.945829),('4',86,'node',1),('4',109,'node',11),('4',110,'node',11),('40',47,'node',1),('40',68,'node',1),('40',71,'node',1.73614),('40',75,'node',0.972861),('400',34,'node',1),('400',49,'node',0.961087),('400',52,'node',0.854391),('400',56,'node',1),('400',64,'node',1),('400',65,'node',0.942091),('400',69,'node',1),('400',79,'node',0.906287),('400',90,'node',1),('400',91,'node',1),('4000',65,'node',0.957226),('404page',141,'node',26),('40cm',61,'node',0.913226),('40gbps',79,'node',1),('40x45x30',46,'node',0.839384),('4100',35,'node',1),('41800',33,'node',1),('42',61,'node',0.961087),('43',74,'node',0.957226),('43',83,'node',1),('4300',36,'node',1),('4300',60,'node',0.968904),('432cm',79,'node',0.931053),('43800',89,'node',0.869951),('43cm',62,'node',1),('440',79,'node',0.934703),('444',45,'node',0.931053),('45',31,'node',0.769219),('45',34,'node',1),('45',45,'node',1.76762),('45',93,'node',1),('450',45,'node',1),('45000',50,'node',1),('450mbps',81,'node',3.9534),('456',69,'node',1),('45cm',61,'node',0.909743),('46',67,'node',0.923838),('48',72,'node',56),('48',79,'node',1),('48',83,'node',1),('48',120,'node',11),('4800',82,'node',0.957226),('4800',83,'node',0.957226),('48000',92,'node',0.827757),('4800dpi',82,'node',0.953396),('4800dpi',83,'node',1),('48x',37,'node',1.90225),('4900',48,'node',0.899454),('49900',82,'node',0.997306),('49900',86,'node',0.848323),('49999',49,'node',0.968904),('4gb',123,'node',11),('4port',81,'node',0.961087),('5',36,'node',1),('5',41,'node',1),('5',59,'node',0.980874),('5',71,'node',46.6837),('5',76,'node',0.916736),('5',82,'node',1),('5',84,'node',0.993146),('5',88,'node',0.747619),('5',90,'node',1),('50',32,'node',0.889397),('50',67,'node',0.96498),('50',79,'node',1),('500',33,'node',1),('500',36,'node',1),('500',40,'node',1),('500',43,'node',1),('500',44,'node',0.659351),('500',45,'node',0.722831),('500',50,'node',1),('500',54,'node',0.889397),('500',57,'node',1),('500',58,'node',1),('500',59,'node',0.949597),('500',60,'node',0.961087),('500',63,'node',1),('500',67,'node',0.953396),('500',71,'node',0.742984),('500',75,'node',0.961087),('500',76,'node',0.906287),('500',78,'node',1),('500',80,'node',0.934703),('500',82,'node',0.989021),('500',83,'node',0.968904),('500',84,'node',0.882818),('500',86,'node',0.842342),('500',88,'node',0.754681),('500',89,'node',0.863659),('500',96,'node',1),('500',97,'node',1),('500',138,'node',0.938382),('500',139,'node',1),('5000',37,'node',0.931053),('5000',42,'node',57),('5000',105,'node',11),('50ml',138,'node',51.9121),('50mm',89,'node',53.9261),('51',30,'node',0.931053),('51',43,'node',1),('51',74,'node',0.854391),('510',27,'node',1),('512mb',47,'node',1.81925),('514',69,'node',1),('515',45,'node',1),('52',30,'node',0.909743),('52',70,'node',1),('52x18x33',31,'node',0.784336),('533',89,'node',0.892724),('54',92,'node',0.836446),('54800',91,'node',1),('5500',78,'node',1),('5500',79,'node',2),('5524p',79,'node',51.0553),('5524p',125,'node',11),('56',74,'node',0.953396),('57inches',45,'node',1.71636),('58mm',89,'node',0.854391),('59',35,'node',1),('5900',42,'node',1),('5900',43,'node',1),('59399848',51,'node',51.4593),('59399848',112,'node',11),('59900',52,'node',0.860547),('59900',74,'node',0.892724),('59900',82,'node',1),('59900',84,'node',0.889397),('5ghz',46,'node',0.899454),('5ghz',81,'node',4.94654),('5megapixel',49,'node',1),('5mp',49,'node',0.938382),('5pcs',39,'node',52),('5pcs',87,'node',11),('5piece',39,'node',56),('5piece',87,'node',11),('5x35x25',59,'node',0.989021),('5x5x5',86,'node',0.857458),('6',44,'node',48.656),('6',55,'node',1),('6',83,'node',0.980874),('6',85,'node',3.91674),('60',44,'node',0.830633),('60',94,'node',1),('600',39,'node',1),('600',51,'node',0.920273),('600',66,'node',0.945829),('600',68,'node',1),('600',72,'node',1),('600',81,'node',0.972861),('600',92,'node',0.822065),('60000',49,'node',0.972861),('600d',86,'node',51.0747),('600d',129,'node',11),('60p',85,'node',1),('61',59,'node',0.961087),('615',84,'node',0.909743),('63g',54,'node',0.906287),('640x480',94,'node',1),('64bit',44,'node',0.957226),('64bit',52,'node',0.836446),('64gb',45,'node',0.776703),('64gb',49,'node',51.3981),('64gb',51,'node',0.886095),('65x',85,'node',0.916736),('67',80,'node',1),('67',95,'node',1),('68',74,'node',1.85144),('68800',88,'node',0.759465),('6900',53,'node',0.993146),('6990',95,'node',1),('69900',89,'node',0.876337),('6kg',77,'node',1),('6mm',41,'node',1),('6mm',93,'node',2),('6pm',27,'node',1.76614),('6x2x6',57,'node',1),('7',50,'node',58),('7',51,'node',0.957226),('7',52,'node',1),('7',58,'node',1),('7',74,'node',0.923838),('7',111,'node',11),('7',135,'node',11),('70',55,'node',55),('70',60,'node',1),('70',61,'node',0.942091),('700',41,'node',1),('700',93,'node',1),('700',94,'node',1),('7000',48,'node',0.906287),('70000',45,'node',0.727213),('710',80,'node',1),('711',89,'node',0.896076),('720p',92,'node',0.913226),('74900',52,'node',0.866793),('75',52,'node',0.873132),('75',97,'node',1),('7500',57,'node',1),('75000',44,'node',0.662985),('768',51,'node',0.906287),('77',74,'node',2.78266),('78',36,'node',1),('780',77,'node',0.96498),('786',45,'node',1.71636),('7900',30,'node',0.913226),('7900',61,'node',0.938382),('795',27,'node',2.63059),('79900',67,'node',0.968904),('79900',84,'node',0.896076),('79900',90,'node',1),('7cm',62,'node',1),('7inch',50,'node',1),('7x2x12',47,'node',0.854391),('8',22,'node',1),('8',30,'node',0.923838),('8',38,'node',0.98493),('8',44,'node',1.38943),('8',45,'node',0.733888),('8',46,'node',12.5405),('8',51,'node',54.4944),('8',53,'node',1),('8',77,'node',1),('8',93,'node',1),('8',95,'node',1),('8',112,'node',11),('800',70,'node',1),('800mbps',81,'node',1),('801366',51,'node',0.909743),('80211',94,'node',1),('80211a',52,'node',0.827757),('80211a',76,'node',1.74322),('80211n',80,'node',1),('8023az',79,'node',1),('805',45,'node',1),('81',77,'node',1),('816',54,'node',0.920273),('85',40,'node',1),('85',45,'node',1.71636),('85',53,'node',1),('8500',70,'node',1),('8500',78,'node',1),('850tvl',93,'node',53),('88',38,'node',0.957226),('89',60,'node',0.972861),('8900',27,'node',2.62708),('89900',69,'node',1),('89900',90,'node',1),('8am',27,'node',1.78498),('8gb',77,'node',0.997306),('8gb',85,'node',50.6895),('8gb',137,'node',11),('8x4x3',44,'node',0.66666),('9',31,'node',0.779231),('9',34,'node',1),('9',42,'node',1),('9',52,'node',1),('9',93,'node',1),('9',139,'node',2),('90',66,'node',0.976851),('90cm',66,'node',0.931053),('91',73,'node',54),('910',72,'node',1),('91x905x562',71,'node',0.759465),('926',85,'node',0.957226),('92mm',58,'node',1),('9400',55,'node',1),('9500',42,'node',1),('955',70,'node',54),('9600',83,'node',0.953396),('97inch',49,'node',0.949597),('97inch',52,'node',0.842342),('98',76,'node',1.87308),('9900',31,'node',0.766757),('9900',35,'node',1),('9900',53,'node',1),('9900',57,'node',1),('9900',59,'node',0.96498),('99900',69,'node',1),('99900',85,'node',0.934703),('99900',88,'node',0.76431),('9am',27,'node',1.76985),('9mm',88,'node',45.9997),('9pm',27,'node',1.78115),('a316',47,'node',53.9733),('a316',107,'node',11),('a5x',49,'node',1.93838),('aaa',95,'node',1),('aaaa',96,'node',1),('aaaaincluded',96,'node',1),('aberrations',89,'node',0.953396),('ability',45,'node',0.976851),('able',24,'node',1.87703),('able',44,'node',2),('able',45,'node',0.869951),('able',47,'node',0.913226),('able',86,'node',1),('about',16,'node',2),('about',18,'node',1),('about',21,'node',26),('about',24,'node',2.7647),('about',27,'node',26.8221),('about',29,'node',1),('about',32,'node',4),('about',59,'node',1),('about',65,'node',4),('about',66,'node',4),('about',67,'node',4),('about',76,'node',1),('about',86,'node',1),('above',24,'node',1.67522),('above',41,'node',1),('above',50,'node',1),('above',95,'node',1),('abovementioned',24,'node',1.23489),('abs',70,'node',2),('absorb',53,'node',1),('absorption',38,'node',1),('absorption',53,'node',1.97286),('acai',139,'node',1),('accent',53,'node',1),('accept',44,'node',1),('accept',45,'node',0.76431),('accept',54,'node',1),('accepts',16,'node',1),('accepts',18,'node',1),('accepts',19,'node',1),('access',24,'node',5.92978),('access',44,'node',0.747619),('access',46,'node',0.923838),('access',51,'node',0.993146),('access',54,'node',4.71512),('access',76,'node',1),('access',92,'node',4.9689),('accessing',24,'node',9.22433),('accessing',72,'node',1),('accessories',27,'node',1),('accessories',31,'node',1),('accessories',32,'node',1),('accessories',56,'node',4),('accessories',63,'node',1),('accessories',64,'node',1),('accessories',65,'node',12),('accessories',66,'node',12),('accessories',108,'node',37),('accessory',60,'node',1),('accessory',65,'node',2),('accessory',66,'node',2),('accessory',67,'node',1),('accessory',75,'node',1),('accommodate',30,'node',1),('accompanying',31,'node',1),('accordance',16,'node',2.81949),('accordance',18,'node',2.77879),('accordance',19,'node',2.84055),('accordance',24,'node',1.68177),('accorded',24,'node',0.58995),('according',84,'node',2),('account',24,'node',11.0267),('account',26,'node',1.92384),('account',76,'node',1),('accountmlbtv',76,'node',0.854391),('accumsan',17,'node',0.902857),('accumsan',20,'node',1),('accumsan',21,'node',3),('accumsan',143,'node',1.8267),('accurate',24,'node',1.74762),('accurate',89,'node',0.934703),('accurately',83,'node',1),('achieve',24,'node',0.604732),('acid',138,'node',1),('acknowledge',24,'node',0.382539),('across',49,'node',1),('across',79,'node',1),('act',24,'node',0.585658),('action',24,'node',0.744265),('action',74,'node',1),('actions',24,'node',0.924788),('activated',54,'node',1),('active',31,'node',1),('active',32,'node',0.961087),('activity',54,'node',1),('actually',71,'node',1),('acuspheres',43,'node',1),('adapter',32,'node',1),('adapters',94,'node',1),('adapting',27,'node',0.76431),('adaptors',94,'node',52),('adaptors',133,'node',11),('add',24,'node',0.393562),('add',26,'node',1),('add',58,'node',1),('add',65,'node',2),('add',66,'node',2),('added',36,'node',1),('added',54,'node',0.96498),('addition',64,'node',1),('addition',83,'node',1),('additional',74,'node',1),('additional',83,'node',1),('address',16,'node',6.63897),('address',18,'node',6.55759),('address',19,'node',6.68109),('address',24,'node',5.44979),('address',79,'node',1),('addresses',16,'node',2),('addresses',18,'node',2),('addresses',19,'node',2),('adipiscing',17,'node',1),('adipiscing',20,'node',1),('adipiscing',52,'node',21.7262),('adipiscing',143,'node',1),('adjust',55,'node',1),('adjust',57,'node',1),('adjust',84,'node',1),('adjust',94,'node',1),('adjustable',56,'node',1),('adjustable',61,'node',0.906287),('adjustable',86,'node',1),('adjustable',97,'node',1),('adjustment',84,'node',1),('admin',52,'node',8.74229),('administer',24,'node',1.26217),('administrative',24,'node',0.529288),('adorn',63,'node',1),('adorn',64,'node',1),('adrenaline',74,'node',1),('adults',70,'node',1),('advance',61,'node',1),('advanced',43,'node',1),('advanced',44,'node',2.61436),('advanced',52,'node',1),('advanced',53,'node',1.97286),('advanced',59,'node',1),('advanced',71,'node',0.876337),('advanced',82,'node',2),('advanced',84,'node',4),('advanced',86,'node',1),('advancements',85,'node',1),('adventure',31,'node',1),('adventures',69,'node',1),('adventurous',30,'node',1.9689),('adventurous',33,'node',1),('advertise',22,'node',17),('advertised',22,'node',1),('advertiser',22,'node',1),('advertising',22,'node',14),('ae217faapmf5anmy727141',30,'node',0.945829),('aenean',17,'node',1.93838),('aenean',18,'node',0.863659),('aenean',20,'node',3),('aenean',21,'node',2),('aenean',23,'node',2),('aenean',37,'node',1),('aeroline',30,'node',62.0501),('affiliates',24,'node',2.39385),('affordable',48,'node',0.934703),('affordable',50,'node',1),('affordable',56,'node',1),('afghanistan',28,'node',1),('africa',28,'node',0.609315),('african',28,'node',1),('afs',89,'node',52.9261),('after',26,'node',0.913226),('after',27,'node',2.84532),('after',31,'node',0.833529),('after',39,'node',2),('after',59,'node',1),('after',67,'node',1),('after',69,'node',1),('afﬁliate',22,'node',26),('again',59,'node',1),('again',65,'node',1),('again',66,'node',1),('again',71,'node',1),('again',75,'node',1),('against',24,'node',0.37157),('agc',93,'node',3),('age',80,'node',2),('age',95,'node',1),('agent',24,'node',1.77419),('ages',95,'node',1),('agree',24,'node',0.754639),('aiball',94,'node',66),('aiball',133,'node',11),('aiballing',94,'node',1),('aid',139,'node',1),('aiming',27,'node',0.781775),('aio',46,'node',50.5965),('aio',124,'node',11),('air',47,'node',4),('air',52,'node',54.5498),('airgesture',47,'node',1),('airplay',76,'node',6),('aland',28,'node',1),('albania',28,'node',1),('algeria',28,'node',1),('algorithm',52,'node',0.934703),('algorithm',71,'node',0.866793),('alienware',77,'node',55),('aliquam',16,'node',0.972861),('aliquam',17,'node',5.73488),('aliquam',18,'node',1.6551),('aliquam',19,'node',0.989021),('aliquam',21,'node',2),('aliquam',23,'node',1.99315),('aliquam',33,'node',1),('aliquam',37,'node',1),('aliquam',143,'node',2.81257),('aliquet',17,'node',5.78987),('aliquet',18,'node',0.800068),('aliquet',143,'node',1.90629),('all',24,'node',1.77459),('all',31,'node',1),('all',32,'node',1),('all',33,'node',1),('all',39,'node',1),('all',40,'node',2),('all',46,'node',1),('all',47,'node',1.97685),('all',48,'node',2),('all',49,'node',1),('all',50,'node',2),('all',52,'node',1),('all',58,'node',1),('all',59,'node',1),('all',60,'node',1),('all',61,'node',1.8861),('all',64,'node',2),('all',71,'node',7.79696),('all',73,'node',1),('all',74,'node',1),('all',76,'node',1),('all',78,'node',1),('all',82,'node',1),('all',84,'node',1),('all',89,'node',0.920273),('all',94,'node',2),('allinone',46,'node',5.81092),('allnatural',138,'node',5.92027),('allocate',83,'node',1),('allow',24,'node',0.814635),('allow',51,'node',1),('allow',92,'node',1),('allowed',24,'node',0.791588),('allowing',51,'node',1),('allowing',81,'node',1),('allows',79,'node',1),('allows',81,'node',1),('allows',82,'node',3),('allows',83,'node',1),('allows',84,'node',1),('allows',85,'node',1),('allows',92,'node',1),('allows',94,'node',2),('allows',97,'node',1),('almost',60,'node',1),('almost',86,'node',0.968904),('along',55,'node',1),('along',80,'node',1),('along3',41,'node',1),('also',16,'node',1),('also',24,'node',1.14389),('also',32,'node',2),('also',39,'node',1),('also',40,'node',1),('also',44,'node',0.738408),('also',45,'node',0.957226),('also',46,'node',1),('also',47,'node',0.896076),('also',48,'node',1),('also',52,'node',1),('also',57,'node',1),('also',71,'node',0.945829),('also',73,'node',1),('also',75,'node',2),('also',76,'node',1),('also',79,'node',1),('also',81,'node',1),('also',83,'node',1),('also',85,'node',2.99731),('also',86,'node',1),('also',139,'node',1),('alternative',96,'node',2),('alternatively',80,'node',1),('although',52,'node',0.997306),('altimeter',69,'node',2),('altitude',69,'node',2),('aluminium',36,'node',2),('always',31,'node',0.819249),('always',56,'node',1),('always',59,'node',1),('always',60,'node',1),('always',65,'node',1.99315),('always',66,'node',2),('always',80,'node',2),('amazing',49,'node',1),('amazing',52,'node',3),('amazing',82,'node',2),('amazing',88,'node',0.931053),('amazing',138,'node',1),('amazing',139,'node',1),('amazingly',52,'node',4),('amazon',26,'node',1),('amazoncom',26,'node',1.91523),('american',28,'node',1),('amet',17,'node',6.57577),('amet',18,'node',0.729424),('amet',20,'node',6.95779),('amet',21,'node',4),('amet',23,'node',1.96109),('amet',33,'node',1.95383),('amet',37,'node',1),('amet',52,'node',21.8681),('amet',143,'node',5.64737),('amoled',45,'node',1.71636),('amount',60,'node',1),('analog',67,'node',0.942091),('analog',68,'node',2),('analog',70,'node',2),('analogue',70,'node',52),('analyse',86,'node',0.913226),('analysis',24,'node',0.419117),('and',16,'node',32.3868),('and',18,'node',9.44073),('and',19,'node',7.61947),('and',22,'node',3),('and',24,'node',63.9573),('and',26,'node',5),('and',27,'node',70.7735),('and',28,'node',8.92044),('and',29,'node',1),('and',30,'node',6.95723),('and',31,'node',7.64763),('and',32,'node',7.84344),('and',33,'node',7),('and',36,'node',6),('and',38,'node',6),('and',39,'node',9),('and',40,'node',4),('and',41,'node',2),('and',42,'node',2),('and',43,'node',3),('and',44,'node',14.4651),('and',45,'node',5.5681),('and',46,'node',10.6462),('and',47,'node',11.8383),('and',48,'node',9.9347),('and',49,'node',7.9347),('and',50,'node',2),('and',51,'node',6),('and',52,'node',8.96109),('and',53,'node',8),('and',54,'node',10.8055),('and',55,'node',4),('and',56,'node',3),('and',57,'node',7),('and',58,'node',5),('and',59,'node',3.93105),('and',60,'node',4),('and',61,'node',5),('and',62,'node',1),('and',63,'node',1),('and',64,'node',2),('and',65,'node',9.99315),('and',66,'node',9),('and',67,'node',8.93105),('and',68,'node',3),('and',69,'node',3),('and',71,'node',7.60463),('and',72,'node',7),('and',73,'node',1),('and',74,'node',5.97685),('and',75,'node',4.89272),('and',76,'node',24.7809),('and',77,'node',8),('and',78,'node',5),('and',79,'node',54.0821),('and',80,'node',1),('and',81,'node',7),('and',82,'node',2),('and',83,'node',12),('and',84,'node',11.9071),('and',85,'node',7),('and',86,'node',4.74557),('and',88,'node',8.77026),('and',89,'node',10.8045),('and',91,'node',1),('and',92,'node',15.3534),('and',93,'node',2),('and',94,'node',7),('and',95,'node',7),('and',96,'node',5),('and',97,'node',4),('and',125,'node',11),('and',138,'node',8.99731),('and',139,'node',2),('andorra',28,'node',1),('android',45,'node',6.4522),('android',46,'node',1),('android',47,'node',1.82776),('android',55,'node',2),('android',75,'node',51.7145),('android',92,'node',2),('android',94,'node',1),('android',122,'node',11),('angel',56,'node',52),('angel',108,'node',11),('angle',82,'node',2),('angle',86,'node',1.91081),('angle',94,'node',2),('angles',44,'node',0.98493),('angles',51,'node',1),('angles',73,'node',1),('angles',84,'node',1),('angles',86,'node',1),('angles',92,'node',1.87723),('angola',28,'node',1),('anguilla',28,'node',1),('anonymous',24,'node',1),('another',47,'node',1),('another',60,'node',1),('another',75,'node',1),('answer',57,'node',2),('answer',75,'node',0.923838),('antarctica',28,'node',1),('ante',17,'node',2.84055),('ante',21,'node',3),('ante',23,'node',3.93009),('ante',37,'node',2),('ante',143,'node',2.7891),('antennas',81,'node',0.945829),('antiageing',40,'node',1),('antigua',28,'node',1),('antilles',28,'node',0.731649),('antioxidant',40,'node',1),('antique',62,'node',1),('antiscratch',33,'node',1),('any',16,'node',1.82648),('any',18,'node',1.78885),('any',19,'node',1.85133),('any',24,'node',12.6787),('any',27,'node',1.81392),('any',30,'node',2.97685),('any',31,'node',2),('any',33,'node',1),('any',43,'node',1),('any',44,'node',2.63725),('any',46,'node',0.945829),('any',48,'node',1),('any',57,'node',1),('any',71,'node',1.84532),('any',77,'node',9),('any',82,'node',2),('any',86,'node',2.88882),('any',88,'node',1),('any',89,'node',4),('anyone',24,'node',0.469921),('anyone',63,'node',1),('anyone',82,'node',1),('anything',54,'node',1),('anything',63,'node',1),('anytime',24,'node',0.548462),('anytime',27,'node',1),('anytime',97,'node',1),('anyway',45,'node',1),('anywhere',27,'node',1),('anywhere',46,'node',5.77982),('anywhere',92,'node',5),('anywhere',97,'node',1),('ap564elalljmanmy575572',57,'node',1),('ap564elalvswanmy592956',76,'node',0.949597),('ap564elapeznanmy715186',49,'node',1),('ap564elapuhianmy741814',44,'node',0.674137),('ap564elat12eanmy913520',52,'node',0.889397),('apart',60,'node',1),('aperture',89,'node',3.94209),('app',44,'node',0.722831),('app',48,'node',1),('app',92,'node',2.98087),('appear',32,'node',1),('appear',76,'node',1),('appearance',32,'node',0.989021),('apple',16,'node',7.63897),('apple',18,'node',7.55759),('apple',19,'node',7.68109),('apple',44,'node',50.5983),('apple',49,'node',62.1435),('apple',52,'node',59.1882),('apple',57,'node',67),('apple',60,'node',1),('apple',75,'node',0.997306),('apple',76,'node',68.2077),('apple',123,'node',11),('appliances',27,'node',1),('applicable',16,'node',4.64245),('applicable',18,'node',4.56427),('applicable',19,'node',4.68825),('applicable',24,'node',0.373259),('applications',46,'node',1),('applications',47,'node',1),('applications',55,'node',2),('applications',81,'node',2),('applicator',37,'node',0.957226),('applicatorwell',37,'node',0.913226),('apply',26,'node',0.916736),('apply',41,'node',1),('applying',36,'node',1),('appreciate',73,'node',1),('appreciates',67,'node',1),('approach',72,'node',1),('approval',22,'node',1),('approvals',22,'node',1),('approve',44,'node',0.733888),('approximated',24,'node',0.482973),('apps',45,'node',0.961087),('apps',48,'node',1),('apps',52,'node',1),('apps',55,'node',1),('apps',77,'node',1),('apscsized',86,'node',1),('arab',28,'node',0.562486),('arabia',28,'node',0.63167),('architecture',44,'node',0.949597),('architecture',52,'node',0.833529),('architecture',79,'node',1),('archived',76,'node',0.839384),('arcu',17,'node',2),('arcu',20,'node',2.93009),('arcu',21,'node',2),('arcu',23,'node',2),('arcu',37,'node',2),('arcu',143,'node',2.96109),('are',16,'node',3),('are',18,'node',3),('are',19,'node',3),('are',22,'node',1),('are',24,'node',6.14833),('are',28,'node',1),('are',31,'node',1.90629),('are',33,'node',1),('are',48,'node',2),('are',53,'node',1),('are',54,'node',2),('are',55,'node',1),('are',56,'node',1),('are',58,'node',1),('are',59,'node',1),('are',60,'node',2),('are',61,'node',1),('are',65,'node',3),('are',66,'node',3),('are',74,'node',2),('are',76,'node',1),('are',78,'node',2),('are',79,'node',3),('are',80,'node',1),('are',82,'node',1),('are',83,'node',1),('are',86,'node',1),('are',88,'node',1.85135),('are',94,'node',1),('are',96,'node',1),('area',75,'node',1),('area',83,'node',1),('area',92,'node',2.92743),('areas',71,'node',0.920273),('areas',75,'node',1),('arena',73,'node',1),('argentina',28,'node',1),('arm',56,'node',1),('armenia',28,'node',1),('around',30,'node',1),('around',33,'node',1),('around',40,'node',1),('around',48,'node',1),('around',52,'node',1),('around',56,'node',1),('arrange',75,'node',1),('arrangements',24,'node',0.37784),('array',27,'node',1),('array',63,'node',1),('array',64,'node',1),('art',84,'node',4),('art',88,'node',0.906287),('artistic',84,'node',0.949597),('arts',95,'node',1),('aruba',28,'node',1),('as575elat5hfanmy920560',46,'node',0.851346),('asha',48,'node',50.7439),('asian',27,'node',1.57159),('ask',27,'node',0.827757),('aspects',61,'node',1),('aspects',67,'node',1),('aspherical',89,'node',1.97286),('assist',27,'node',0.902857),('association',40,'node',1),('assume',24,'node',1.41002),('assurance',60,'node',1),('assured',83,'node',1),('asus',46,'node',115.141),('asus',50,'node',69),('asus',111,'node',11),('asus',124,'node',22),('asus',135,'node',48),('atm',67,'node',1.92743),('atom',51,'node',1.89945),('attach',55,'node',1),('attached',75,'node',0.927431),('attention',33,'node',1),('attention',73,'node',1),('attractive',54,'node',1),('auctor',17,'node',2.91323),('auctor',18,'node',0.703756),('auctor',20,'node',1.98087),('auctor',23,'node',2),('auctor',33,'node',0.980874),('auctor',37,'node',2),('auctor',143,'node',2),('audience',26,'node',2),('audio',57,'node',1),('audio',58,'node',1),('audio',73,'node',7),('audio',74,'node',6),('audio',77,'node',1),('audio',94,'node',2),('audio',121,'node',37),('audit',24,'node',0.731649),('augue',17,'node',5.55724),('augue',21,'node',3),('augue',23,'node',2),('augue',37,'node',2),('augue',143,'node',2.96109),('aura',67,'node',1),('aus',42,'node',53),('aus',105,'node',11),('australia',28,'node',1),('austria',28,'node',1),('author',40,'node',1),('authorities',24,'node',0.380175),('authorize',51,'node',0.997306),('authorized',24,'node',1.44024),('auto',83,'node',1),('auto',86,'node',5.56457),('auto',93,'node',3),('autofocus',49,'node',1),('autofocus',85,'node',1),('autofocus',89,'node',3.78182),('automatic',68,'node',55),('automatic',118,'node',11),('automatic',136,'node',11),('automatically',24,'node',0.430168),('automatically',26,'node',0.902857),('automatically',49,'node',1),('automatically',54,'node',1),('automatically',76,'node',2),('automatically',78,'node',1),('automatically',84,'node',1),('availability',16,'node',1),('available',24,'node',0.509287),('available',26,'node',1),('available',27,'node',1),('available',31,'node',1),('available',54,'node',1),('available',55,'node',1),('available',77,'node',1),('available',79,'node',0.997306),('available',80,'node',1),('available',88,'node',0.945829),('available',89,'node',0.945829),('avoid',75,'node',1),('away',27,'node',0.716357),('away',48,'node',1),('away',73,'node',2),('away',92,'node',0.993146),('awesome',75,'node',1),('azerbaijan',28,'node',1),('b0008',31,'node',0.792123),('b00773',35,'node',1),('babies',27,'node',1),('baby',97,'node',1),('babylike',138,'node',1),('back',18,'node',1),('back',19,'node',1),('back',30,'node',1),('back',31,'node',0.916736),('back',33,'node',1),('back',34,'node',1),('back',65,'node',1),('back',66,'node',1),('back',68,'node',1),('back',84,'node',0.851346),('back',88,'node',1),('back',95,'node',1),('back',138,'node',1),('back',141,'node',11),('background',54,'node',1),('background',89,'node',6),('backlight',70,'node',1),('backpack',8,'node',11),('backpack',30,'node',52.9271),('backpack',31,'node',51.8972),('backpack',32,'node',51.0385),('backpack',33,'node',63),('backpack',96,'node',2),('backpack',101,'node',22),('backpack',134,'node',11),('backpackers',30,'node',0.968904),('backpacking',31,'node',0.934703),('backpacks',33,'node',1),('backpacks',101,'node',37),('backside',49,'node',1),('backwards',92,'node',1),('bag',31,'node',50.1253),('bag',32,'node',3.92384),('bag',34,'node',52),('bag',35,'node',104),('bag',75,'node',1),('bag',101,'node',12),('bag',102,'node',22),('bags',32,'node',0.923838),('bags',75,'node',1),('bags',102,'node',37),('bags',134,'node',37),('bahamas',28,'node',1),('bahrain',28,'node',1),('balances',49,'node',1),('bamboo',36,'node',2),('band',81,'node',60.8218),('band',126,'node',11),('bands',44,'node',0.779231),('bandwidthintensive',81,'node',1),('bangladesh',28,'node',1),('bank',24,'node',0.516879),('bank',26,'node',1),('bank',31,'node',0.997306),('bank',60,'node',59.7145),('banner',8,'node',26),('barbados',28,'node',1),('barbuda',28,'node',1),('barometer',44,'node',0.913226),('barometer',69,'node',2),('barthélemy',28,'node',0.662985),('based',32,'node',1),('based',46,'node',1),('basic',107,'node',37),('basis',64,'node',1),('bass',57,'node',1),('bass',58,'node',1),('bass',72,'node',1),('batteries',60,'node',1),('batteries',95,'node',1),('batteries',96,'node',1),('batteries',114,'node',37),('battery',44,'node',0.906287),('battery',45,'node',4.99731),('battery',49,'node',1),('battery',59,'node',2),('battery',75,'node',1),('battery',80,'node',6.92027),('battery',88,'node',0.727213),('battery',96,'node',1),('bdvn9200w',73,'node',55),('beacons',24,'node',0.843916),('beads',62,'node',1),('beats',53,'node',0.96498),('beautiful',41,'node',1),('beautiful',61,'node',1),('beautiful',63,'node',1),('beautiful',64,'node',1),('beautiful',75,'node',1),('beautiful',84,'node',1),('beautiful',89,'node',7),('beautifully',52,'node',1),('beautifully',64,'node',1),('beauty',27,'node',1),('beauty',65,'node',1),('beauty',66,'node',1),('beauty',71,'node',1),('beauty',84,'node',4),('beauty',105,'node',37),('beauty',138,'node',0.927431),('because',45,'node',2),('because',89,'node',1),('becomes',49,'node',1),('beefed',45,'node',1),('been',24,'node',2.98197),('been',26,'node',1),('been',27,'node',0.842342),('been',45,'node',1.8894),('been',57,'node',1),('been',58,'node',1),('been',59,'node',1),('been',84,'node',1),('before',24,'node',0.424938),('before',52,'node',1),('before',61,'node',1),('before',71,'node',1),('before',83,'node',1),('beginning',26,'node',0.889397),('beginning',55,'node',1),('behalf',24,'node',0.45757),('behavior',24,'node',0.705825),('being',24,'node',0.691597),('being',67,'node',1),('bejeweled',48,'node',1),('belarus',28,'node',1),('belgium',28,'node',1),('believe',24,'node',1.96257),('belize',28,'node',1),('belongings',32,'node',1),('beloved',88,'node',1),('below',16,'node',1),('below',18,'node',1),('below',19,'node',1),('below',24,'node',5.3876),('below',38,'node',1),('belt',63,'node',55),('belt',64,'node',55),('belt',116,'node',11),('belts',63,'node',1),('belts',64,'node',1),('belts',116,'node',37),('beneficial',138,'node',1),('benefit',45,'node',0.857458),('benefits',38,'node',1),('benin',28,'node',1),('bermuda',28,'node',1),('bernie',26,'node',8),('berry',139,'node',1),('besides',47,'node',0.899454),('best',48,'node',3.97258),('best',50,'node',2),('best',71,'node',1),('best',75,'node',1.9496),('best',76,'node',1),('best',86,'node',0.949597),('better',24,'node',0.836812),('better',38,'node',1),('better',44,'node',4.44964),('better',46,'node',0.860547),('better',71,'node',4.435),('better',72,'node',2),('better',85,'node',1),('better',86,'node',1.92743),('between',27,'node',4.55483),('between',47,'node',1),('between',63,'node',1),('between',89,'node',1),('beyond',71,'node',1),('bezels',52,'node',1),('bhutan',28,'node',1),('bibendum',17,'node',2.85967),('bibendum',20,'node',3),('bibendum',21,'node',4),('bibendum',143,'node',2),('big',31,'node',1),('big',48,'node',5),('big',61,'node',0.98493),('big',65,'node',53.0062),('big',71,'node',4),('big',76,'node',2),('bigger',44,'node',5.67794),('biggeriphone',44,'node',1),('biggest',44,'node',0.712106),('biggest',76,'node',0.96498),('bigscreen',77,'node',1),('bigtime',76,'node',4),('binding',24,'node',0.45843),('bird',138,'node',1),('birth',24,'node',1),('biskeles',61,'node',2),('bit',45,'node',1),('bit',83,'node',1),('black',27,'node',0.786915),('black',36,'node',2),('black',38,'node',2),('black',48,'node',49.7439),('black',49,'node',51.3981),('black',54,'node',49.4743),('black',56,'node',1),('black',58,'node',53),('black',59,'node',51.3981),('black',60,'node',51.7145),('black',62,'node',2),('black',67,'node',53.3292),('black',68,'node',53),('black',69,'node',52),('black',70,'node',53),('black',71,'node',1),('black',80,'node',50.8879),('black',81,'node',51.8218),('black',85,'node',50.6895),('black',93,'node',2),('black',113,'node',11),('black',114,'node',11),('black',118,'node',11),('black',119,'node',11),('black',126,'node',11),('black',136,'node',11),('black',137,'node',11),('black',142,'node',37),('blackberry',59,'node',1),('blackberry',60,'node',0.993146),('blackhead',38,'node',51.2944),('blackheads',38,'node',2),('blandit',17,'node',1.92027),('blandit',18,'node',0.794753),('blandit',20,'node',1),('blandit',21,'node',2),('blandit',23,'node',1),('blandit',37,'node',1),('blanket',97,'node',1),('blast',139,'node',1),('blazing',81,'node',1),('blend',40,'node',1),('blends',65,'node',1.92743),('blockbuster',76,'node',1),('blocker',139,'node',1),('blocking',64,'node',2),('blogger',22,'node',1),('blood',38,'node',2),('blood',138,'node',1),('blossom',40,'node',11),('blue',30,'node',50.8266),('blue',31,'node',48.9562),('blue',70,'node',1),('blue',75,'node',1.98902),('blue',91,'node',2),('blue',101,'node',12),('blue',122,'node',1),('blueant',7,'node',37),('bluebackpack',31,'node',1),('bluetooth',7,'node',37),('bluetooth',48,'node',1.87313),('bluetooth',58,'node',54),('bluetooth',75,'node',53.6529),('bluetooth',113,'node',11),('bluetooth',122,'node',11),('blur',85,'node',1),('blur',89,'node',6),('bluray',73,'node',53),('bluray',77,'node',1),('blusher',37,'node',1.87431),('bo242tbapso5anmy738496',96,'node',1),('board',96,'node',52),('board',99,'node',11),('boasting',50,'node',1),('body',43,'node',9),('body',74,'node',1),('body',138,'node',2),('bokeh',89,'node',2),('bolivia',28,'node',1),('boogie',96,'node',63),('boogie',99,'node',11),('books',27,'node',1),('books',99,'node',37),('boosting',82,'node',1),('boosts',39,'node',1),('boring',88,'node',0.972861),('bos04088shb03',34,'node',52),('bosnia',28,'node',1),('both',61,'node',1),('both',81,'node',1),('both',83,'node',1),('both',85,'node',1),('botswana',28,'node',1),('bottom',74,'node',1),('boundaries',32,'node',1),('bouvet',28,'node',1),('box',44,'node',2.62303),('box',72,'node',1),('box',76,'node',4),('box',78,'node',1),('bracelet',75,'node',55.7145),('bracelet',122,'node',11),('bracket',56,'node',1),('bracketing',84,'node',4),('braided',63,'node',53),('braids',63,'node',1),('brand',26,'node',1),('brand',32,'node',4),('brand',52,'node',1),('brand',67,'node',1),('brand',70,'node',1),('brands',60,'node',1),('bravia',72,'node',52),('bravia',120,'node',11),('brazil',28,'node',1),('brazzaville',28,'node',1),('breached',24,'node',0.476356),('break',24,'node',0.478227),('breaking',76,'node',0.98493),('breakouts',38,'node',1),('breakthrough',44,'node',0.754681),('breathable',65,'node',1),('breathable',66,'node',1),('breathable',97,'node',1),('breathtaking',71,'node',1),('breathtaking',86,'node',1),('breeze',31,'node',0.927431),('briefcase',96,'node',2),('bright',45,'node',1.71636),('bright',48,'node',1),('bright',138,'node',1),('brightens',84,'node',1),('brightroom',71,'node',1),('brilliance',55,'node',2),('brilliance',89,'node',5),('brilliant',44,'node',1),('bring',30,'node',1),('bring',32,'node',1),('bring',56,'node',1),('bring',63,'node',1),('bring',64,'node',1),('bring',72,'node',1),('bring',77,'node',1),('bring',86,'node',1),('brings',71,'node',0.993146),('british',28,'node',2),('broadband',80,'node',1),('broadcasting',72,'node',1),('broadcasts',81,'node',1),('broaden',84,'node',0.942091),('bronzetone',62,'node',1),('brown',65,'node',1.96498),('browse',24,'node',1),('browse',47,'node',1),('browser',24,'node',2.12938),('browser',48,'node',0.96498),('browser',92,'node',1),('browsers',48,'node',0.949597),('browsing',47,'node',0.961087),('browsing',48,'node',4),('browsing',81,'node',1),('brunei',28,'node',1),('brunei',79,'node',1),('brush',36,'node',56),('brush',38,'node',1),('brushes',36,'node',1),('bsi',88,'node',1),('buckle',30,'node',1),('buckle',63,'node',1),('buckwheat',40,'node',1),('bud',41,'node',1),('build',65,'node',1),('build',66,'node',1),('buildup',138,'node',1),('built',60,'node',1),('builtin',47,'node',0.934703),('builtin',49,'node',1),('builtin',54,'node',1),('builtin',57,'node',1),('builtin',74,'node',1),('builtin',79,'node',1),('builtin',84,'node',1),('builtin',88,'node',0.738408),('builtin',92,'node',1),('builtin',93,'node',1),('bulgaria',28,'node',1),('bulky',80,'node',1),('bumper',53,'node',2),('bumps',53,'node',1),('bumpy',31,'node',0.957226),('bundled',83,'node',0.931053),('burkina',28,'node',1),('burn',43,'node',1),('burner',139,'node',56),('burundi',28,'node',1),('business',16,'node',1),('business',18,'node',1),('business',19,'node',1),('business',24,'node',1.0708),('business',118,'node',37),('businesses',26,'node',1),('busy',54,'node',1),('busy',75,'node',2),('but',29,'node',1),('but',32,'node',2),('but',44,'node',1.98087),('but',45,'node',1.89945),('but',46,'node',1),('but',48,'node',1),('but',52,'node',2),('but',55,'node',1),('but',78,'node',1),('but',82,'node',2),('but',85,'node',1),('but',138,'node',2),('button',71,'node',0.902857),('button',82,'node',2),('button',88,'node',1),('button',95,'node',1),('buttons',53,'node',2),('buttons',82,'node',1),('buttons',83,'node',1.94209),('buy',17,'node',26),('buy',74,'node',1),('buy',76,'node',1),('buyers',27,'node',0.742984),('buyers',45,'node',0.876337),('buying',29,'node',1),('ca065hbas3ukanmy866687',37,'node',0.997306),('ca673elalorhanmy581181',86,'node',0.866793),('ca673elam9xuanmy618219',82,'node',1),('ca673elarxo5anmy857455',85,'node',0.972861),('ca673elatex3anmy936277',90,'node',1),('ca680elapvlxanmy743566',84,'node',0.923838),('cable',44,'node',0.653974),('cable',58,'node',1),('cable',76,'node',1),('cable',78,'node',1),('cable',80,'node',1),('cables',31,'node',0.989021),('cables',60,'node',1),('cables',78,'node',2),('caicos',28,'node',0.569105),('calculated',16,'node',1),('caledonia',28,'node',0.727213),('california',16,'node',1.90974),('california',18,'node',1.87027),('california',19,'node',1.92027),('call',16,'node',1),('call',18,'node',1),('call',19,'node',1),('call',58,'node',1),('call',75,'node',2),('call',111,'node',37),('call',112,'node',37),('caller',75,'node',2),('calling',58,'node',1),('calling',63,'node',1),('calling',75,'node',1),('calls',47,'node',1),('calls',54,'node',2.84832),('calls',57,'node',2),('calls',75,'node',0.920273),('calm',88,'node',0.822065),('calories',43,'node',1),('cambodia',28,'node',1),('came',24,'node',0.424201),('cameleon',37,'node',60.7201),('cameleon',103,'node',11),('camera',31,'node',1.98493),('camera',44,'node',2.60125),('camera',45,'node',0.742984),('camera',47,'node',0.822065),('camera',48,'node',1.87957),('camera',49,'node',6.86576),('camera',51,'node',2),('camera',54,'node',1.84832),('camera',84,'node',50.4743),('camera',85,'node',2),('camera',86,'node',1),('camera',88,'node',50.9418),('camera',92,'node',50.6718),('camera',93,'node',53),('camera',94,'node',53),('camera',128,'node',11),('camera',132,'node',11),('camera',133,'node',11),('cameras',128,'node',37),('cameras',129,'node',37),('cameras',132,'node',37),('cameras',133,'node',37),('cameroon',28,'node',1),('camping',30,'node',1),('campus',79,'node',0.98493),('campusfocused',79,'node',1),('can',18,'node',1),('can',24,'node',4.69231),('can',26,'node',14),('can',27,'node',1.82776),('can',29,'node',26),('can',30,'node',0.993146),('can',31,'node',1.83938),('can',32,'node',1),('can',33,'node',2),('can',39,'node',1),('can',44,'node',0.740689),('can',45,'node',0.766757),('can',47,'node',1),('can',51,'node',1),('can',54,'node',0.98493),('can',60,'node',1),('can',64,'node',1),('can',65,'node',1),('can',66,'node',1),('can',69,'node',1),('can',71,'node',2.61849),('can',72,'node',2),('can',75,'node',4),('can',76,'node',2),('can',77,'node',5),('can',80,'node',2),('can',82,'node',1),('can',83,'node',2),('can',84,'node',3),('can',86,'node',1.97286),('can',88,'node',2.96498),('can',89,'node',0.927431),('can',92,'node',5.91558),('can',97,'node',2),('canada',28,'node',1),('candlelight',49,'node',1),('cannot',24,'node',0.508221),('canon',82,'node',63),('canon',85,'node',62.1351),('canon',86,'node',59.6125),('canon',90,'node',63),('canon',127,'node',11),('canon',129,'node',11),('canon',131,'node',11),('canon',137,'node',48),('canopy',97,'node',1),('capabilities',44,'node',0.689612),('capabilities',46,'node',0.889397),('capabilities',52,'node',1),('capabilities',55,'node',1),('capabilities',77,'node',1),('capabilities',85,'node',1),('capability',73,'node',1),('capability',79,'node',2.84193),('capability',82,'node',4),('capability',88,'node',1),('capable',45,'node',0.781775),('capable',60,'node',1),('capable',79,'node',1.92743),('capable',80,'node',1),('capable',81,'node',1),('capable',85,'node',1),('capable',86,'node',1),('capable',125,'node',1),('capacitive',47,'node',1),('capacity',45,'node',0.752312),('capacity',52,'node',0.845322),('capacity',59,'node',1.9347),('capacity',79,'node',1),('cape',28,'node',1),('capture',44,'node',0.808176),('capture',50,'node',1),('capture',85,'node',1),('capture',86,'node',2),('capture',88,'node',2.73614),('capture',89,'node',5),('captured',83,'node',1),('captures',49,'node',1),('capturing',47,'node',0.889397),('capturing',85,'node',1),('car',27,'node',0.733888),('car',55,'node',1),('car',56,'node',53),('car',94,'node',2),('car',108,'node',48),('car',133,'node',37),('carbohydrate',139,'node',1),('card',26,'node',0.896076),('card',27,'node',1),('card',45,'node',0.786915),('card',47,'node',1),('card',80,'node',1),('card',85,'node',1),('card',88,'node',45.9997),('card',92,'node',1),('cards',16,'node',22),('cards',18,'node',22),('cards',19,'node',22),('cards',45,'node',1.53366),('care',38,'node',51.2944),('care',40,'node',1),('care',87,'node',37),('care',104,'node',37),('carefully',44,'node',1),('cares',39,'node',1),('caribbean',28,'node',1),('carmudi',27,'node',0.736141),('carrie',65,'node',1),('carrie',66,'node',1),('carrier',18,'node',22.5622),('carry',24,'node',1.45298),('carry',97,'node',54),('carry',100,'node',11),('carrycot',97,'node',1),('carrying',33,'node',1),('carrying',60,'node',1),('cartilage',138,'node',1),('cartoon',88,'node',0.892724),('case',44,'node',1),('case',53,'node',55),('case',54,'node',56.4743),('case',67,'node',1.86213),('case',68,'node',3),('case',78,'node',1),('case',85,'node',50.6895),('case',109,'node',11),('case',137,'node',11),('cases',109,'node',37),('cases',134,'node',37),('cash',16,'node',11),('cash',18,'node',11),('cash',19,'node',11),('cash',27,'node',1),('cashier',16,'node',1),('cashier',18,'node',1),('cashier',19,'node',1),('casing',53,'node',1),('casing',70,'node',2),('casio',84,'node',59.4057),('casio',128,'node',11),('casting',61,'node',1),('casual',30,'node',50.9271),('casual',63,'node',1),('casual',64,'node',1),('catalog',26,'node',1),('categories',26,'node',1),('cater',73,'node',1),('caught',59,'node',1),('cavernous',31,'node',1),('cayman',28,'node',1),('ccd',83,'node',11),('cctv',93,'node',104),('cdquality',73,'node',1),('cdr',74,'node',0.869951),('cdrw',74,'node',0.866793),('cell',138,'node',1),('cellphone',56,'node',1),('cells',38,'node',1),('cells',39,'node',1),('cells',138,'node',1),('center',74,'node',0.931053),('central',28,'node',1),('certain',24,'node',0.863659),('certain',91,'node',1),('certification',81,'node',1),('certified',40,'node',1),('certified',79,'node',0.961087),('ch299tbas06zanmy861162',97,'node',1),('chad',28,'node',1),('chain',62,'node',1),('chain',65,'node',53.0895),('change',16,'node',1),('change',18,'node',1),('change',19,'node',1),('change',24,'node',0.836453),('change',52,'node',0.989021),('change',65,'node',1),('change',66,'node',1),('change',97,'node',1),('changed',44,'node',0.886095),('changes',24,'node',7.53259),('changes',89,'node',1),('changing',84,'node',0.96498),('changing',97,'node',1),('channel',73,'node',2),('channel',74,'node',0.851346),('characteristic',93,'node',2),('characters',24,'node',0.470829),('charge',24,'node',0.53161),('charge',26,'node',0.899454),('charge',55,'node',1),('charge',60,'node',3),('charge',80,'node',1),('charged',26,'node',1.87367),('charged',59,'node',2),('charger',44,'node',0.652202),('charger',55,'node',54),('charger',59,'node',1),('charger',80,'node',1),('chargers',114,'node',37),('charging',31,'node',0.993146),('charging',59,'node',0.909743),('charging',60,'node',3),('charlotte',65,'node',1),('charlotte',66,'node',1),('chats',51,'node',1),('check',27,'node',1.82776),('check',54,'node',1),('check',84,'node',1),('checking',29,'node',1),('checkout',16,'node',1.90974),('checkout',18,'node',1.88254),('checkout',19,'node',1.92027),('checks',16,'node',1),('checks',18,'node',1),('checks',19,'node',1),('cheese',49,'node',1),('chiasso',67,'node',1),('chicco',97,'node',13),('chicken',138,'node',1),('child',63,'node',5),('child',64,'node',5),('children',24,'node',0.445866),('children',95,'node',1),('chile',28,'node',1),('china',28,'node',2.67822),('chip',44,'node',0.945829),('chip',49,'node',1.93838),('chip',52,'node',1.83645),('chip',54,'node',1),('chipsets',45,'node',1),('chipsystem',76,'node',0.889397),('choice',30,'node',1),('choice',46,'node',1),('choice',48,'node',1),('choice',64,'node',1),('choice',69,'node',1),('choice',72,'node',1),('choose',16,'node',1),('choose',18,'node',1),('choose',19,'node',1),('choose',22,'node',1),('choose',24,'node',0.942091),('choose',61,'node',1),('choose',63,'node',1),('choose',64,'node',1),('choose',88,'node',0.854391),('choose',94,'node',1),('chosing',78,'node',1),('christmas',28,'node',1),('cinema',73,'node',52),('cinematic',74,'node',1),('circle',61,'node',1),('circles',38,'node',1),('circles',40,'node',1),('circuit',93,'node',1),('circular',57,'node',1),('circulation',38,'node',1),('circulation',138,'node',1),('circumstances',24,'node',1.03036),('cis',82,'node',1),('citing',46,'node',1),('city',31,'node',1),('clarity',58,'node',4),('clarity',92,'node',0.909743),('clarity',138,'node',1),('clasp',62,'node',1),('clasp',68,'node',1),('class',48,'node',1),('class',61,'node',1),('class',67,'node',1),('classic',54,'node',49.4743),('classic',65,'node',54.0895),('classic',66,'node',1),('classic',88,'node',0.819249),('classic',89,'node',1),('classic',95,'node',1),('classy',67,'node',1),('clean',38,'node',2),('clean',48,'node',1),('cleaner',38,'node',51.2944),('cleaning',38,'node',1),('cleaning',96,'node',1),('cleans',38,'node',2),('cleanser',39,'node',6),('cleanses',38,'node',1),('cleanses',39,'node',1),('cleansing',39,'node',3),('cleansing',138,'node',1),('clear',38,'node',1),('clear',39,'node',2),('clear',41,'node',1),('clear',72,'node',3),('clear',81,'node',1),('clear',84,'node',0.830633),('clear',86,'node',1),('clear',88,'node',5),('clearer',72,'node',1),('clearer',81,'node',1),('clears',38,'node',1),('click',16,'node',1),('click',18,'node',1),('click',19,'node',1),('click',27,'node',0.718502),('click',84,'node',1),('climbers',30,'node',0.961087),('climbs',30,'node',1),('clip',56,'node',2),('clip',58,'node',1),('clipon',82,'node',2),('clock',94,'node',4),('close',24,'node',0.450806),('close',48,'node',1),('close',52,'node',1),('closed',54,'node',1),('closeness',97,'node',1),('closeup',86,'node',1),('closure',62,'node',1),('cloth',30,'node',0.997306),('cloth',96,'node',1),('clothes',30,'node',1),('clothes',31,'node',1),('clothes',65,'node',2),('clothes',66,'node',2),('cloudcam',92,'node',47.6718),('cloudcam',132,'node',11),('cloudy',89,'node',1),('cmos',84,'node',0.854391),('cmos',85,'node',1.91674),('cmos',86,'node',6),('cmos',88,'node',1),('cmos',92,'node',1),('cmos',93,'node',1),('co716elapowbanmy731726',91,'node',1),('coast',28,'node',0.848323),('coating',89,'node',1),('cobblestone',80,'node',1),('cocos',28,'node',1),('code',56,'node',52),('code',91,'node',1),('code',108,'node',11),('coenzyme',138,'node',1),('cokin',91,'node',64),('cokin',130,'node',11),('cokin',140,'node',11),('cold',42,'node',1),('collect',24,'node',5.77936),('collected',16,'node',1.89876),('collected',18,'node',1.8583),('collected',19,'node',1.92027),('collected',24,'node',2.75748),('collection',24,'node',23.6562),('collection',65,'node',1),('collection',66,'node',1),('collisionthe',75,'node',1),('colombia',28,'node',1),('color',30,'node',0.902857),('color',31,'node',0.76431),('color',37,'node',3.66528),('color',54,'node',2.99315),('color',56,'node',1),('color',58,'node',1),('color',62,'node',53),('color',65,'node',0.968904),('color',70,'node',1),('color',71,'node',1),('color',84,'node',0.836446),('color',96,'node',1),('colors',44,'node',1),('colors',45,'node',1.71636),('colors',49,'node',1),('colors',51,'node',1),('colors',54,'node',1),('colour',36,'node',1),('colour',64,'node',2),('colour',65,'node',1),('colour',66,'node',1),('colour',71,'node',1.6798),('colour',83,'node',1),('colour',89,'node',0.993146),('colourfast',31,'node',0.842342),('colours',48,'node',1),('colours',58,'node',1),('colours',63,'node',1),('colours',64,'node',2),('colours',71,'node',5.31492),('colours',83,'node',1),('colours',88,'node',1),('coma',89,'node',0.96498),('combination',54,'node',5),('combines',50,'node',1),('combines',81,'node',1),('combining',48,'node',1),('combining',56,'node',1),('combining',80,'node',1),('come',31,'node',0.816452),('comes',32,'node',1),('comes',36,'node',1),('comes',42,'node',1),('comes',48,'node',1.97286),('comes',50,'node',2),('comes',58,'node',1),('comes',65,'node',1),('comes',66,'node',1),('comes',72,'node',1),('comes',74,'node',1),('comes',86,'node',1),('comes',88,'node',1),('comfort',31,'node',4.67604),('comfort',33,'node',1),('comfort',71,'node',0.779231),('comfort',74,'node',1),('comfortable',30,'node',1),('comfortable',57,'node',1),('comfortable',65,'node',0.916736),('comfortably',45,'node',1),('comfortably',97,'node',1),('commentators',73,'node',1),('comments',24,'node',1.36934),('comments',28,'node',0.536316),('comments',52,'node',0.771698),('commision',22,'node',1),('commodo',18,'node',0.769219),('commodo',20,'node',1),('commodo',21,'node',2),('commodo',23,'node',2),('commodo',37,'node',1),('commodo',143,'node',2.84567),('commonly',50,'node',1),('communicate',24,'node',1.13831),('communication',24,'node',0.39674),('communications',24,'node',0.395463),('comoros',28,'node',1),('compact',31,'node',0.920273),('compact',60,'node',1),('compact',77,'node',4),('companies',24,'node',1.48041),('companion',89,'node',1),('company',24,'node',0.431687),('company',28,'node',20),('comparable',24,'node',0.588512),('comparable',74,'node',1),('compare',24,'node',0.752312),('compared',72,'node',1),('compared',73,'node',1),('comparison',45,'node',1),('comparments',31,'node',0.747619),('compartment',30,'node',3),('compartment',32,'node',3),('compartment',33,'node',1),('compartment',34,'node',2),('compartment',36,'node',1),('compass',69,'node',2),('compatible',53,'node',2.91838),('compatible',60,'node',2.94583),('compatible',75,'node',1),('compatible',86,'node',0.813674),('compensates',85,'node',1),('competitive',22,'node',1),('complaints',24,'node',1),('complementary',54,'node',0.997306),('complete',24,'node',0.997306),('complete',46,'node',0.957226),('completed',24,'node',0.522445),('completed',27,'node',0.857458),('completely',47,'node',1),('completely',53,'node',1),('completing',24,'node',0.628375),('complex',45,'node',0.96498),('complexion',39,'node',1),('complexion',138,'node',3),('complicated',48,'node',1),('compliment',64,'node',1),('components',61,'node',1),('components',78,'node',1),('composed',53,'node',1),('composition',84,'node',1),('comprehensive',27,'node',15.8925),('compressed',85,'node',1),('compromised',24,'node',0.911723),('computer',24,'node',8.41483),('computer',56,'node',1),('computer',92,'node',1.9689),('computers',27,'node',1),('computers',46,'node',1),('concentrated',39,'node',1),('concerns',24,'node',0.369343),('concurrent',81,'node',4),('condimentum',17,'node',2),('condimentum',20,'node',2),('condimentum',21,'node',3),('condimentum',143,'node',0.934703),('conditioned',39,'node',1),('conditions',23,'node',26),('conditions',85,'node',1),('conditions',92,'node',1),('conferences',51,'node',1),('confidence',92,'node',0.916736),('confidentially',24,'node',0.510357),('configuration',45,'node',0.792123),('congo',28,'node',2),('congue',17,'node',0.931053),('congue',18,'node',1.46654),('congue',21,'node',1),('congue',143,'node',0.920273),('connect',46,'node',0.931053),('connect',76,'node',1),('connected',31,'node',1),('connected',44,'node',0.766757),('connected',77,'node',1),('connected',80,'node',1),('connected',82,'node',2),('connecting',58,'node',1),('connection',46,'node',0.934703),('connection',80,'node',1),('connection',82,'node',1),('connection',92,'node',1),('connections',46,'node',0.902857),('connections',80,'node',1),('connections',81,'node',2),('connectivity',46,'node',1),('connectivity',48,'node',1),('connectivity',92,'node',1),('connectors',60,'node',1),('connectshare',71,'node',0.810915),('consectetur',17,'node',2.95723),('consectetur',20,'node',2),('consectetur',21,'node',2),('consectetur',23,'node',0.968904),('consectetur',33,'node',0.993146),('consectetur',52,'node',21.7969),('consectetur',143,'node',2.90629),('consent',24,'node',11.7745),('consequat',17,'node',3.77834),('consequat',18,'node',0.725015),('consequat',20,'node',3),('consequat',21,'node',1),('consequat',143,'node',1),('consequences',24,'node',0.465433),('considered',44,'node',1),('consistence',67,'node',1),('consistency',89,'node',0.989021),('constantlyit',75,'node',1),('construction',52,'node',1),('construction',67,'node',1),('consumers',27,'node',1.76188),('consumption',79,'node',1),('consumption',96,'node',1),('contact',24,'node',4.87439),('contact',27,'node',31.7053),('contact',28,'node',45),('contacted',24,'node',0.689612),('contacting',24,'node',7.04993),('contain',24,'node',0.387358),('containing',40,'node',1),('contains',39,'node',1),('contains',86,'node',1),('content',22,'node',1),('content',24,'node',1.13146),('content',48,'node',2),('content',52,'node',0.972861),('content',71,'node',0.781775),('content',76,'node',2),('content',77,'node',1),('continual',24,'node',0.571798),('continue',24,'node',0.559882),('continuous',44,'node',1),('continuous',85,'node',2),('contour',38,'node',1),('contract',24,'node',0.557303),('contrast',44,'node',1),('contrast',89,'node',1),('control',24,'node',0.925566),('control',46,'node',0.953396),('control',51,'node',1),('control',54,'node',1),('control',57,'node',2),('control',58,'node',1),('control',78,'node',53),('control',83,'node',1),('control',91,'node',1),('control',92,'node',0.938382),('control',93,'node',3),('controls',58,'node',1),('controls',92,'node',1),('convallis',17,'node',2),('convallis',18,'node',0.76188),('convallis',20,'node',3.94276),('convallis',23,'node',0.980874),('convallis',143,'node',2.79893),('convenience',44,'node',1),('convenience',48,'node',1),('convenience',55,'node',1),('convenience',56,'node',1),('convenience',83,'node',9),('conveniences',32,'node',0.945829),('convenient',24,'node',0.405928),('convenient',27,'node',1),('convenient',31,'node',0.98493),('convenient',46,'node',0.997306),('convenient',59,'node',1),('convenient',97,'node',1),('convenient',139,'node',1),('conveniently',60,'node',2),('conveniently',82,'node',2),('conversion',22,'node',1),('converted',86,'node',1),('cook',28,'node',1),('cookierelated',24,'node',0.36769),('cookies',24,'node',0.857928),('cool',31,'node',1),('cooperating',24,'node',0.375535),('coordinated',37,'node',0.909743),('cope',86,'node',1),('copper',79,'node',1),('coprocessor',44,'node',0.931053),('copy',82,'node',1),('copy',83,'node',1),('coq10',138,'node',1),('cord',57,'node',1),('cord',76,'node',1),('cord',79,'node',1),('core',46,'node',1),('core',47,'node',1),('core',77,'node',1),('core',123,'node',11),('cornered',61,'node',1),('correct',78,'node',2),('correction',24,'node',0.370453),('cost',27,'node',0.851346),('costa',28,'node',1),('costeffective',47,'node',1),('costly',74,'node',1),('cot',97,'node',53),('cot',100,'node',11),('cotton',41,'node',1),('cotton',65,'node',1.92743),('cotton',66,'node',1),('could',24,'node',0.461031),('could',32,'node',1),('could',65,'node',3),('could',66,'node',3),('could',78,'node',1),('count',24,'node',0.403258),('countries',32,'node',1),('country',27,'node',0.752312),('country',28,'node',1),('coupling',58,'node',0.989021),('coupons',16,'node',22.8267),('courageous',69,'node',1),('courier',24,'node',0.759465),('course',44,'node',1),('cover',36,'node',1),('cover',51,'node',5),('cover',53,'node',1),('cover',54,'node',60.3506),('coverage',53,'node',1),('coverage',80,'node',5),('covers',109,'node',37),('cpu',47,'node',1),('cr39',91,'node',1),('cradle',55,'node',1),('cradle',94,'node',58),('cradle',133,'node',11),('crafted',64,'node',1),('craftsmanship',68,'node',1),('cras',17,'node',2),('cras',20,'node',2),('cras',21,'node',2),('cras',23,'node',1.97818),('cras',33,'node',1),('cras',143,'node',2.84495),('cream',38,'node',2),('cream',40,'node',54),('cream',104,'node',11),('create',24,'node',1),('create',80,'node',1),('create',82,'node',1),('create',85,'node',1),('create',91,'node',1),('created',50,'node',1),('created',96,'node',2),('creates',32,'node',1),('creates',41,'node',1),('creates',84,'node',0.997306),('creating',44,'node',1),('creating',67,'node',1),('creating',88,'node',0.869951),('creating',89,'node',1),('creation',77,'node',1),('creative',88,'node',3.95608),('creativity',52,'node',1),('credit',16,'node',11),('credit',18,'node',11),('credit',19,'node',11),('credit',26,'node',1.83446),('credit',27,'node',1),('crisp',72,'node',1),('crisp',86,'node',1),('crisp',92,'node',0.899454),('critical',54,'node',1),('croatia',28,'node',1),('cross',64,'node',54),('cross',88,'node',0.810915),('cross',116,'node',11),('crown',68,'node',2),('crystal',62,'node',1),('crystal',67,'node',1),('crystal',68,'node',2),('crystal',81,'node',1),('crystal',88,'node',5),('ct941tbam1qdanmy602711',95,'node',1),('cuba',28,'node',1),('culture',27,'node',0.774192),('cum',18,'node',0.836446),('cup',38,'node',2),('curabitur',20,'node',2),('curabitur',23,'node',1),('curabitur',37,'node',1),('curabitur',143,'node',1.94209),('curaçao',28,'node',1),('current',74,'node',1),('cursus',17,'node',0.896076),('cursus',21,'node',3),('cursus',23,'node',2),('cursus',37,'node',1),('cushion',31,'node',0.899454),('cushiony',31,'node',3.79839),('custom',55,'node',1),('custom',88,'node',0.845322),('customer',24,'node',1.75468),('customer',27,'node',1.855),('customers',16,'node',1),('customers',18,'node',1),('customers',19,'node',1),('customers',22,'node',1),('customers',24,'node',0.577261),('customers',26,'node',28),('customers',27,'node',0.830633),('customerservices',24,'node',15.0206),('customisable',83,'node',4.94209),('customisation',83,'node',1),('customization',54,'node',0.961087),('customize',24,'node',0.718502),('customized',64,'node',1),('cut',31,'node',0.882818),('cutting',86,'node',1),('cyber',27,'node',0.784336),('cyprus',28,'node',1),('czech',28,'node',1),('da883faal9qsanmy556860',64,'node',1),('da883faal9r7anmy556875',63,'node',1),('daily',82,'node',1),('damage',31,'node',1),('damage',44,'node',1),('damage',80,'node',1),('damaged',27,'node',0.896076),('dandelion',63,'node',66),('dandelion',64,'node',67),('dandelion',116,'node',11),('dapibus',17,'node',1),('dapibus',18,'node',0.879565),('dapibus',23,'node',1),('dapibus',37,'node',1),('dapibus',143,'node',3.77879),('dark',30,'node',49.9271),('dark',38,'node',1),('dark',40,'node',1),('dark',85,'node',1),('dark',95,'node',1),('dashboard',55,'node',1),('data',24,'node',11.9866),('data',44,'node',0.920273),('data',46,'node',0.913226),('data',47,'node',0.953396),('data',85,'node',1),('date',24,'node',1.98493),('date',54,'node',0.860547),('dates',24,'node',0.420557),('day',27,'node',0.860547),('day',31,'node',0.827757),('day',59,'node',1),('day',63,'node',1),('day',80,'node',1),('day',89,'node',1),('day',92,'node',0.866793),('day',94,'node',1),('days',27,'node',2.86096),('days',88,'node',0.879565),('daytoday',33,'node',1),('daytoday',81,'node',1),('dcs5222l',92,'node',53.4139),('dcs5222l',132,'node',11),('ddr3',77,'node',0.993146),('de759elap5i7anmy696915',79,'node',0.949597),('de759elat5r5anmy920910',77,'node',1),('dead',38,'node',1),('dead',39,'node',1),('dead',138,'node',1),('dealership',27,'node',0.731649),('dealings',24,'node',1),('deals',16,'node',1),('debit',16,'node',11),('debit',18,'node',11),('debit',19,'node',11),('decade',69,'node',1),('dedicated',31,'node',1),('dedicated',61,'node',1),('deemed',24,'node',0.620288),('deep',38,'node',1),('deep',71,'node',1),('deep',74,'node',1),('deeper',57,'node',1),('deepest',43,'node',1),('defect',44,'node',1),('defined',24,'node',1.7974),('defined',57,'node',1),('definitely',65,'node',1),('definitely',66,'node',1),('definitely',73,'node',1),('definition',71,'node',1),('definition',73,'node',2),('definitive',63,'node',1),('definitive',64,'node',1),('degree',56,'node',53),('degree',94,'node',1),('degree',108,'node',11),('dehydration',138,'node',1),('dekstop',46,'node',47.5965),('dekstop',124,'node',11),('delicious',139,'node',1),('deliver',24,'node',0.774192),('deliver',50,'node',1),('deliver',79,'node',1),('delivered',27,'node',3),('delivered',36,'node',1),('delivering',79,'node',1),('delivers',44,'node',0.942091),('delivers',49,'node',1),('delivers',71,'node',1),('delivers',74,'node',1),('delivers',92,'node',1.91674),('delivers',139,'node',1),('delivery',18,'node',46.5622),('delivery',24,'node',2.51899),('delivery',27,'node',22.6199),('dell',77,'node',63),('dell',79,'node',63.211),('dell',125,'node',11),('demanding',45,'node',0.989021),('demanding',46,'node',1),('demanding',79,'node',1),('demographics',24,'node',0.707906),('denmark',28,'node',1),('denote',61,'node',1),('departure',45,'node',0.808176),('depending',24,'node',0.563797),('depending',80,'node',1),('deployment',79,'node',0.972861),('deposits',26,'node',1),('depth',83,'node',1),('depth',91,'node',1),('described',24,'node',0.913226),('description',30,'node',0.953396),('description',31,'node',0.802752),('description',32,'node',0.913226),('description',33,'node',1),('description',34,'node',1),('description',35,'node',1),('description',36,'node',1),('description',37,'node',1),('description',38,'node',1),('description',39,'node',1),('description',40,'node',1),('description',41,'node',1),('description',42,'node',1),('description',43,'node',1),('description',44,'node',0.677939),('description',45,'node',0.740689),('description',46,'node',0.857458),('description',47,'node',0.869951),('description',48,'node',0.923838),('description',49,'node',1),('description',50,'node',1),('description',51,'node',0.980874),('description',52,'node',0.896076),('description',53,'node',1),('description',54,'node',0.934703),('description',55,'node',1),('description',56,'node',1),('description',57,'node',1),('description',58,'node',1),('description',59,'node',1),('description',60,'node',1),('description',61,'node',0.980874),('description',62,'node',1),('description',63,'node',1),('description',64,'node',1),('description',65,'node',0.989021),('description',66,'node',1),('description',67,'node',1),('description',68,'node',1),('description',69,'node',1),('description',70,'node',1),('description',71,'node',0.771698),('description',72,'node',1),('description',73,'node',1),('description',74,'node',0.976851),('description',75,'node',1),('description',76,'node',0.957226),('description',77,'node',1),('description',78,'node',1),('description',79,'node',0.957226),('description',80,'node',0.98493),('description',81,'node',1),('description',82,'node',1),('description',83,'node',1),('description',84,'node',0.931053),('description',85,'node',0.980874),('description',86,'node',0.873132),('description',88,'node',0.794753),('description',89,'node',0.909743),('description',90,'node',1),('description',91,'node',1),('description',92,'node',0.854391),('description',93,'node',1),('description',94,'node',1),('description',95,'node',1),('description',96,'node',1),('description',97,'node',1),('description',138,'node',0.989021),('description',139,'node',1),('design',31,'node',0.857458),('design',32,'node',1),('design',33,'node',2),('design',42,'node',1),('design',43,'node',2),('design',44,'node',1),('design',48,'node',1),('design',50,'node',1),('design',53,'node',1),('design',54,'node',0.953396),('design',55,'node',1),('design',57,'node',1),('design',58,'node',4),('design',61,'node',1),('design',64,'node',1),('design',71,'node',1),('design',75,'node',52.614),('design',77,'node',8),('design',80,'node',1),('design',85,'node',2),('design',122,'node',11),('designdurable',31,'node',0.742984),('designed',30,'node',6),('designed',31,'node',1),('designed',32,'node',2),('designed',33,'node',2),('designed',38,'node',1),('designed',44,'node',0.687638),('designed',52,'node',1),('designed',54,'node',1),('designed',55,'node',1),('designed',56,'node',1),('designed',63,'node',1),('designed',64,'node',1),('designed',79,'node',2),('designed',86,'node',0.98493),('designers',32,'node',1),('designs',32,'node',2),('desire',86,'node',1),('desktop',26,'node',4),('desktop',46,'node',5.96498),('desktop',77,'node',52),('desktop',124,'node',26),('desktopclass',44,'node',0.953396),('desktops',46,'node',4.81092),('desktops',124,'node',11),('destination',56,'node',1),('destroying',24,'node',0.49376),('detach',46,'node',1.98902),('detachable',51,'node',4),('detail',44,'node',1),('detail',62,'node',1),('detail',72,'node',1),('detail',73,'node',1),('detail',83,'node',1),('detail',86,'node',1),('detail',89,'node',4),('detail',92,'node',1.81973),('detailed',49,'node',1),('details',24,'node',4.57819),('details',28,'node',0.535131),('details',29,'node',1),('details',71,'node',0.836446),('details',73,'node',1),('details',83,'node',1),('details',92,'node',1),('detection',49,'node',1),('detection',92,'node',0.802752),('detects',84,'node',1),('detects',85,'node',1),('detects',92,'node',1),('developed',54,'node',1),('device',24,'node',0.822077),('device',45,'node',1),('device',53,'node',1),('device',55,'node',1),('device',59,'node',2),('device',60,'node',1),('device',76,'node',2),('device',78,'node',1),('device',80,'node',3),('device',82,'node',1),('device',92,'node',1),('devices',46,'node',0.866793),('devices',47,'node',0.938382),('devices',56,'node',1),('devices',58,'node',1),('devices',59,'node',3),('devices',60,'node',0.942091),('devices',76,'node',2),('devices',78,'node',3),('devices',80,'node',1),('devices',81,'node',1),('devices',85,'node',0.98493),('devices',94,'node',2),('di503faap8lhanmy703741',35,'node',1),('diacut',53,'node',0.972861),('dial',67,'node',1.93105),('dial',68,'node',55),('dial',118,'node',11),('dial',136,'node',11),('diam',17,'node',2.79279),('diam',18,'node',0.727213),('diam',20,'node',2),('diam',21,'node',1),('diam',23,'node',4),('diam',37,'node',3),('diam',143,'node',4.72749),('diameter',68,'node',1),('diapers',97,'node',1),('dictum',17,'node',3.78477),('dictum',20,'node',2.9381),('dictum',21,'node',3),('dictum',23,'node',0.972861),('dictum',143,'node',2.91963),('did',44,'node',0.972861),('didn',32,'node',0.942091),('difference',52,'node',0.976851),('difference',69,'node',1),('different',32,'node',1),('different',84,'node',1.96587),('different',88,'node',0.957226),('different',92,'node',0.957226),('difficult',138,'node',1),('dig',86,'node',1),('digging',33,'node',1),('digic',85,'node',3.91674),('digital',59,'node',2),('digital',60,'node',1),('digital',70,'node',55),('digital',72,'node',1),('digital',73,'node',1),('digital',80,'node',1),('digital',84,'node',50.3379),('digital',88,'node',1),('digital',92,'node',2.86967),('digital',128,'node',11),('dignissim',17,'node',2.78956),('dignissim',20,'node',2.96175),('dignissim',21,'node',2),('dignissim',23,'node',2),('dignissim',37,'node',2),('dignissim',143,'node',2),('dimension',67,'node',0.927431),('diniwell',35,'node',63),('diniwell',102,'node',11),('direction',32,'node',1),('direction',47,'node',0.906287),('directly',18,'node',1),('directly',54,'node',1),('directly',82,'node',1),('dis',18,'node',0.822065),('disappearance',67,'node',1),('disappointing',45,'node',0.771698),('disc',73,'node',52),('disc',74,'node',0.989021),('disclose',24,'node',2.0389),('disclosed',24,'node',0.535131),('disclosing',24,'node',0.60322),('disclosure',24,'node',16.5303),('disconnected',58,'node',1),('discover',71,'node',5),('discrete',46,'node',1),('dispatched',24,'node',0.517983),('disperse',53,'node',1),('display',44,'node',8.58928),('display',45,'node',10.5627),('display',46,'node',1.98902),('display',47,'node',1),('display',49,'node',5.94583),('display',51,'node',5),('display',52,'node',8.71721),('display',70,'node',4),('display',71,'node',0.736141),('display',72,'node',4),('display',75,'node',2.85934),('display',76,'node',1),('display',88,'node',2.42532),('displayit',44,'node',1),('displays',75,'node',1),('displayunlike',75,'node',1),('distance',58,'node',1),('distortion',85,'node',1),('dive',86,'node',1),('diver',67,'node',51.3981),('diver',68,'node',1),('diverse',75,'node',0.934703),('diving',31,'node',1),('diving',68,'node',1),('division',75,'node',1),('djibouti',28,'node',1),('dl746elaozrfanmy689095',92,'node',0.848323),('dlink',92,'node',56.8406),('dlink',132,'node',11),('doas',95,'node',1),('dock',55,'node',54),('document',83,'node',1),('documentation',24,'node',0.961087),('documents',32,'node',1),('documents',51,'node',1),('documents',82,'node',1),('documents',83,'node',1),('does',24,'node',1.03174),('does',44,'node',0.876337),('doesn',44,'node',0.685676),('doesn',141,'node',1),('doing',139,'node',1),('dolor',17,'node',1.94209),('dolor',18,'node',1.53195),('dolor',20,'node',4.94585),('dolor',21,'node',1),('dolor',23,'node',2),('dolor',33,'node',0.997306),('dolor',37,'node',2),('dolor',52,'node',22.0121),('dolor',143,'node',4.92027),('dome',93,'node',54),('dominica',28,'node',1),('dominican',28,'node',1),('don',46,'node',1),('don',75,'node',1),('don',88,'node',1),('don',92,'node',0.976851),('done',47,'node',1),('donec',17,'node',4.82559),('donec',18,'node',0.712106),('donec',20,'node',1.99315),('donec',21,'node',1),('donec',23,'node',2),('donec',37,'node',2),('donec',143,'node',5.79238),('doodle',51,'node',1),('doors',36,'node',1),('doorstep',18,'node',1),('dose',139,'node',1),('dots',86,'node',1),('double',41,'node',3),('double',47,'node',5),('down',68,'node',2),('down',96,'node',2),('download',44,'node',0.786915),('download',80,'node',0.913226),('downloading',24,'node',0.729424),('downloads',44,'node',0.729424),('downpours',30,'node',1),('dpi',83,'node',0.949597),('draining',65,'node',1),('draining',66,'node',1),('dramatic',52,'node',0.980874),('dramatically',44,'node',1),('drastically',71,'node',0.851346),('draw',96,'node',2),('draws',32,'node',1),('dre',53,'node',0.961087),('drenches',39,'node',1),('dress',62,'node',1),('drink',138,'node',54.9121),('drink',139,'node',1),('drive',71,'node',0.797402),('drive',92,'node',1),('driven',67,'node',1),('driver',12,'node',37),('driver',58,'node',0.96498),('drives',49,'node',1),('driving',44,'node',0.938382),('drool',56,'node',1),('drop',52,'node',1),('drop',53,'node',1),('dropdead',71,'node',1),('drops',53,'node',1),('dryer',42,'node',57),('dryer',105,'node',11),('dryness',40,'node',1),('dslr',86,'node',1),('dslr',129,'node',37),('dual',47,'node',1),('dual',48,'node',55.5995),('dual',53,'node',1),('dual',60,'node',1),('dual',70,'node',52),('dual',79,'node',1),('dual',81,'node',56.8218),('dual',126,'node',11),('dualband',46,'node',48.4859),('dualband',124,'node',11),('dualcore',47,'node',1.81367),('dualcore',49,'node',0.942091),('dualport',60,'node',51.7145),('duffle',31,'node',1),('dui',17,'node',2),('dui',18,'node',1.61294),('dui',20,'node',2.98087),('dui',143,'node',2.8034),('duis',17,'node',2.83036),('duis',23,'node',2),('duis',37,'node',2),('duis',143,'node',1.98493),('dull',138,'node',1),('duo',55,'node',1),('duplex',75,'node',1),('durability',69,'node',1),('durable',31,'node',0.822065),('durable',52,'node',1),('durable',67,'node',1),('durable',80,'node',1),('durable',96,'node',2),('during',16,'node',1.90974),('during',18,'node',1.8867),('during',19,'node',1.92027),('during',24,'node',1),('during',31,'node',1),('during',55,'node',1),('during',67,'node',1),('during',68,'node',1),('dvb',72,'node',5),('dvbt2',72,'node',1),('dvd',74,'node',52.1069),('dvd',78,'node',1),('dvd',121,'node',11),('dvdvideo',74,'node',0.863659),('dvr',78,'node',1),('dynamic',58,'node',2.95839),('dynamic',85,'node',1),('each',36,'node',1),('each',61,'node',1),('each',88,'node',0.916736),('ear',57,'node',1),('ear',58,'node',0.993146),('earbuds',57,'node',1),('earbudstyle',57,'node',1),('early',67,'node',1),('earn',22,'node',18),('earnings',22,'node',1),('earphone',57,'node',52),('earpod',57,'node',52),('earpods',57,'node',3),('ease',30,'node',1),('ease',46,'node',1),('ease',58,'node',1),('easier',47,'node',1),('easier',48,'node',1.93838),('easier',58,'node',1),('easier',84,'node',1),('easier',88,'node',2),('easiest',29,'node',1),('easily',33,'node',1),('easily',41,'node',1),('easily',47,'node',0.902857),('easily',51,'node',1),('easily',54,'node',1),('easily',77,'node',1),('easily',84,'node',1),('easily',86,'node',1.96109),('easily',92,'node',1),('easy',22,'node',1),('easy',26,'node',1),('easy',27,'node',1.72283),('easy',31,'node',0.931053),('easy',36,'node',2),('easy',38,'node',1),('easy',47,'node',0.923838),('easy',52,'node',1),('easy',56,'node',2),('easy',75,'node',0.899454),('easy',76,'node',4),('easy',80,'node',1),('easy',84,'node',4),('easy',92,'node',1),('easy',96,'node',2),('easytouse',58,'node',1),('ebuddy',48,'node',1),('eclectic',65,'node',1),('eclectic',66,'node',1),('ecommerce',27,'node',0.805455),('ecuador',28,'node',1),('edge',44,'node',1),('edge',86,'node',1),('edges',53,'node',0.968904),('edit',51,'node',1),('edit',84,'node',1),('edr',48,'node',0.869951),('educating',95,'node',1),('educational',98,'node',37),('effect',71,'node',0.949597),('effect',88,'node',1.73174),('effective',138,'node',1),('effectively',38,'node',1),('effects',84,'node',0.976851),('effects',88,'node',2.73142),('effects',91,'node',1),('efficiency',59,'node',1),('efficiency',82,'node',1),('efficiency',89,'node',1),('efficient',44,'node',1),('efficient',48,'node',0.957226),('efficient',79,'node',1),('efficient',139,'node',1),('efficiently',44,'node',0.927431),('efficitur',17,'node',1.84847),('efficitur',18,'node',0.718502),('efficitur',20,'node',1.96498),('efficitur',21,'node',1),('efficitur',143,'node',5.71921),('effort',43,'node',1),('effortless',82,'node',1),('effortlessly',83,'node',1),('efs',90,'node',52),('efs',131,'node',11),('egestas',17,'node',3),('egestas',18,'node',0.747619),('egestas',23,'node',1),('egestas',37,'node',1),('egestas',143,'node',3.83784),('eget',17,'node',3.65167),('eget',18,'node',0.886095),('eget',20,'node',4),('eget',21,'node',3),('eget',23,'node',3.98493),('eget',37,'node',3),('eget',143,'node',1.87695),('egypt',28,'node',1),('eight',79,'node',1),('either',24,'node',1),('elastic',32,'node',1),('electronic',24,'node',0.66666),('electronic',59,'node',4),('electronics',27,'node',1),('elegance',65,'node',1),('elegance',66,'node',1),('elegance',67,'node',2),('elegant',48,'node',1),('elegant',67,'node',1),('elegantly',52,'node',1),('eleifend',17,'node',2.87313),('eleifend',20,'node',1),('eleifend',143,'node',3.77102),('element',61,'node',50.7883),('element',89,'node',1.97286),('element',115,'node',11),('elements',61,'node',0.889397),('elements',86,'node',0.906287),('elements',138,'node',0.993146),('elementum',17,'node',0.961087),('elementum',20,'node',1),('elementum',21,'node',2),('elementum',23,'node',1),('elementum',37,'node',1),('eliminates',89,'node',0.968904),('elit',17,'node',4.61135),('elit',20,'node',3),('elit',21,'node',1),('elit',23,'node',3),('elit',37,'node',3),('elit',52,'node',21.6559),('elit',143,'node',2.84567),('else',30,'node',4),('else',44,'node',1),('email',24,'node',3.89543),('email',28,'node',0.537506),('email',81,'node',1),('email',82,'node',1),('embarrassing',38,'node',1),('embedded',53,'node',1),('embedded',83,'node',1),('emirates',28,'node',0.561181),('employs',85,'node',1),('enables',60,'node',1),('enables',75,'node',1),('enables',80,'node',1),('enables',85,'node',1),('enabling',85,'node',1),('enclosure',52,'node',1),('encounter',84,'node',4.94209),('encryption',24,'node',0.967871),('end',41,'node',1),('end',57,'node',2),('endeavor',24,'node',0.617112),('endless',55,'node',1),('endless',80,'node',1),('endlessly',60,'node',1),('energy',79,'node',1),('energy',82,'node',1),('energy',139,'node',1),('enforcement',24,'node',1.02366),('engage',24,'node',0.582831),('engaging',53,'node',1),('engineered',57,'node',1),('enhance',44,'node',1),('enhance',54,'node',1),('enhance',63,'node',1),('enhance',64,'node',1),('enhancement',84,'node',1),('enhancer',71,'node',1.67671),('enhancer',72,'node',2),('enhances',85,'node',1),('enhances',89,'node',1),('enhancing',36,'node',1),('enhancing',84,'node',0.972861),('enim',20,'node',1),('enim',23,'node',2),('enim',37,'node',2),('enim',143,'node',0.889397),('enjoy',39,'node',1),('enjoy',46,'node',5.72765),('enjoy',48,'node',0.942091),('enjoy',51,'node',2),('enjoy',58,'node',2),('enjoy',63,'node',1),('enjoy',64,'node',1),('enjoy',67,'node',1),('enjoy',71,'node',1.78951),('enjoy',73,'node',1),('enjoy',74,'node',1),('enjoy',81,'node',1),('enjoy',84,'node',1),('enjoyable',48,'node',0.938382),('enormously',44,'node',0.96498),('enough',31,'node',1),('enough',46,'node',1),('enough',60,'node',1),('ensemble',62,'node',1),('ensure',24,'node',1.96127),('ensure',59,'node',1),('ensure',60,'node',1),('ensure',74,'node',1),('ensure',78,'node',1),('ensures',24,'node',0.502958),('ensuring',92,'node',0.906287),('enter',44,'node',0.714225),('enter',92,'node',1),('entertainment',47,'node',1),('entertainment',51,'node',1),('entertainment',52,'node',1),('entertainment',71,'node',1),('entertainment',74,'node',2),('entertainment',76,'node',4.95723),('entire',43,'node',1),('entire',49,'node',1),('entire',51,'node',0.989021),('entire',65,'node',1),('entire',66,'node',1),('entire',138,'node',1),('entirely',44,'node',1),('entryclass',86,'node',1),('environmental',138,'node',0.997306),('environments',69,'node',1),('environments',79,'node',1),('eos',86,'node',51.0747),('eos',129,'node',11),('ep840elaltf7anmy589363',83,'node',1),('epson',83,'node',68.7464),('equatorial',28,'node',1),('equipment',74,'node',1),('equipped',47,'node',1.8736),('equipped',85,'node',1),('equipped',88,'node',1),('equipped',92,'node',1),('equivalent',85,'node',0.896076),('era',68,'node',1),('erases',96,'node',1),('erat',16,'node',0.968904),('erat',17,'node',2.94209),('erat',18,'node',2.37196),('erat',19,'node',0.98493),('erat',23,'node',1),('erat',33,'node',1),('erat',37,'node',1),('erat',143,'node',2.96498),('ergonomic',32,'node',1),('ergonomic',43,'node',1),('ergonomic',58,'node',1),('ergonomically',30,'node',5),('ergonomically',38,'node',1),('eritrea',28,'node',1),('eros',17,'node',1),('eros',18,'node',0.882818),('eros',20,'node',3.95037),('eros',21,'node',1),('eros',143,'node',3.84838),('error',141,'node',1),('especially',45,'node',0.749958),('especially',59,'node',1),('especially',60,'node',1),('especially',80,'node',1),('essence',39,'node',4),('essence',41,'node',53),('essence',106,'node',11),('essential',138,'node',1),('essentials',30,'node',1),('est',17,'node',4.87957),('est',20,'node',1.97286),('est',21,'node',1),('est',23,'node',2),('est',37,'node',1),('est',143,'node',3),('estimate',16,'node',1.90974),('estimate',18,'node',1.87433),('estimate',19,'node',1.92027),('estonia',28,'node',1),('etc',75,'node',0.909743),('eternity',61,'node',1),('ethernet',76,'node',0.860547),('ethernet',79,'node',6.95888),('ethernet',92,'node',1),('ethiopia',28,'node',1),('etiam',17,'node',4.93408),('etiam',20,'node',1),('etiam',21,'node',2),('etiam',23,'node',1),('etiam',37,'node',1),('etiam',143,'node',1),('euismod',17,'node',3.80967),('euismod',20,'node',0.961087),('euismod',21,'node',1),('euismod',23,'node',2),('euismod',37,'node',2),('evaluate',86,'node',0.896076),('evaluation',24,'node',0.418401),('even',24,'node',0.392932),('even',31,'node',2.83938),('even',32,'node',1),('even',33,'node',1),('even',39,'node',1),('even',44,'node',1.93569),('even',45,'node',1),('even',46,'node',1),('even',49,'node',1),('even',54,'node',0.980874),('even',71,'node',0.931053),('even',72,'node',2),('even',75,'node',1),('even',76,'node',1),('even',80,'node',1),('even',89,'node',1.9496),('even',92,'node',1.97685),('even',96,'node',1),('even',139,'node',1),('evening',39,'node',1),('evenly',38,'node',1),('event',24,'node',0.550958),('event',27,'node',1.59226),('event',83,'node',1),('eventually',86,'node',0.892724),('ever',44,'node',0.892724),('ever',52,'node',2),('ever',59,'node',1),('ever',71,'node',1),('ever',85,'node',1),('everios',44,'node',0.705825),('everlasting',61,'node',54.7533),('everlasting',115,'node',11),('every',26,'node',0.886095),('every',32,'node',1),('every',44,'node',2.67986),('every',49,'node',1),('every',50,'node',1),('every',68,'node',1),('every',83,'node',1),('every',86,'node',0.909743),('every',89,'node',4),('every',97,'node',1),('every',138,'node',1),('everyday',32,'node',1),('everyday',59,'node',4),('everyday',89,'node',1),('everyone',49,'node',1),('everything',18,'node',1),('everything',30,'node',4),('everything',31,'node',4),('everything',48,'node',1),('everything',49,'node',1),('everything',52,'node',0.961087),('evolution',27,'node',0.776703),('exactly',44,'node',0.980874),('exactly',76,'node',1),('example',24,'node',0.76188),('example',78,'node',1),('excellent',50,'node',1),('excellent',65,'node',1),('excellent',66,'node',1),('except',24,'node',0.50505),('except',30,'node',4),('exceptional',24,'node',0.661163),('exceptional',61,'node',1),('exceptional',92,'node',1),('exceptionally',85,'node',1),('excercise',139,'node',1),('excitement',71,'node',4.9347),('exclusive',43,'node',1),('exclusively',63,'node',1),('exclusively',64,'node',1),('executed',61,'node',1),('exemplifies',68,'node',1),('exercise',43,'node',1),('exfoliation',38,'node',1),('exilim',84,'node',49.4743),('exilim',128,'node',11),('exist',141,'node',1),('expected',45,'node',0.759465),('expeditions',69,'node',1),('expensive',57,'node',1),('experience',24,'node',0.43245),('experience',27,'node',1.81367),('experience',29,'node',1),('experience',33,'node',1),('experience',44,'node',1.67986),('experience',46,'node',0.972861),('experience',48,'node',0.927431),('experience',49,'node',1),('experience',53,'node',2),('experience',55,'node',1),('experience',58,'node',1),('experience',59,'node',1),('experience',67,'node',1),('experience',71,'node',2.78434),('experience',72,'node',1),('experience',77,'node',1),('experience',83,'node',1),('experience',139,'node',2),('experienceget',77,'node',1),('explicit',86,'node',1),('exposure',49,'node',2),('exposure',86,'node',0.927431),('express',24,'node',0.388583),('expression',84,'node',0.934703),('expressly',24,'node',0.553478),('extender',62,'node',1),('extent',24,'node',0.374394),('exterior',36,'node',1),('external',45,'node',3.21101),('external',81,'node',0.949597),('extra',31,'node',0.96498),('extra',33,'node',1),('extra',49,'node',1),('extra',97,'node',1),('extract',40,'node',1),('extreme',58,'node',1),('exudes',67,'node',1),('exzr1500',84,'node',51.391),('exzr1500',128,'node',11),('eye',40,'node',53),('eye',72,'node',1),('eye',104,'node',48),('eyebright',40,'node',1),('eyecatching',47,'node',1),('eyelash',41,'node',1),('eyelid',41,'node',54),('eyelid',106,'node',11),('eyelidline',41,'node',1),('eyelids',41,'node',1),('eyelids2',41,'node',1),('eyeopening',63,'node',1),('eyeopening',64,'node',1),('eyes',40,'node',1),('eyeshadow',37,'node',1.89816),('eﬃcientbuilt',44,'node',0.961087),('f28',94,'node',1),('f9asurtn56u',46,'node',0.845322),('fabric',31,'node',1),('fabric',65,'node',1),('fabric',66,'node',1),('fabric',97,'node',1),('face',38,'node',55.2944),('face',39,'node',1),('face',49,'node',1),('face',51,'node',6),('face',87,'node',37),('face',138,'node',3),('facebook',48,'node',1),('faces',49,'node',1),('faces',84,'node',1),('faceted',62,'node',1),('facetime',49,'node',0.934703),('facial',38,'node',57.2944),('facial',39,'node',15),('facial',41,'node',1),('facilisis',16,'node',0.957226),('facilisis',17,'node',1.87957),('facilisis',18,'node',1.64008),('facilisis',19,'node',0.972861),('facilisis',20,'node',2.94585),('facilisis',23,'node',4.98902),('facilisis',33,'node',1),('facilisis',37,'node',3),('facilisis',143,'node',2.81387),('facilitate',24,'node',0.800068),('facilitates',83,'node',1),('facility',111,'node',37),('facility',112,'node',37),('fact',45,'node',0.747619),('factor',79,'node',1),('fail',32,'node',1),('fair',38,'node',1),('falkland',28,'node',1),('fames',17,'node',1),('fames',23,'node',1),('fames',37,'node',1),('fames',143,'node',1),('familiar',45,'node',1.71636),('family',51,'node',0.98493),('family',75,'node',1),('family',88,'node',1),('fanfare',74,'node',0.980874),('far',44,'node',0.794753),('far',48,'node',1),('faroe',28,'node',1),('fashion',27,'node',1.74762),('fashion',32,'node',0.98493),('fashion',63,'node',1),('fashion',64,'node',1),('fashion',65,'node',2),('fashion',66,'node',54.1915),('fashion',75,'node',1),('fashion',117,'node',11),('fashionable',31,'node',0.851346),('fashionable',32,'node',1),('fashionable',47,'node',1),('faso',28,'node',1),('fast',46,'node',0.980874),('fast',59,'node',0.913226),('fast',81,'node',1),('fast',89,'node',3.9347),('faster',24,'node',0.434757),('faster',44,'node',2.34904),('faster',45,'node',0.980874),('faster',46,'node',0.906287),('faster',85,'node',2),('faster',86,'node',1),('fastest',26,'node',1),('fastest',45,'node',1),('fastgrowing',27,'node',0.769219),('fat',139,'node',56),('faucibus',17,'node',1),('faucibus',18,'node',0.842342),('faucibus',21,'node',1),('favorite',62,'node',1),('favorites',73,'node',1),('favourite',47,'node',1),('favourite',71,'node',1.89272),('favourite',74,'node',1),('fcc',81,'node',1),('feature',11,'node',37),('feature',46,'node',1),('feature',59,'node',1),('feature',72,'node',1),('feature',75,'node',1),('feature',86,'node',0.934703),('feature',88,'node',1),('features',24,'node',0.860547),('features',26,'node',1),('features',36,'node',4),('features',44,'node',1.52702),('features',47,'node',1.97286),('features',49,'node',1),('features',50,'node',1),('features',54,'node',1.86366),('features',59,'node',4),('features',65,'node',5),('features',66,'node',5),('features',75,'node',1),('features',77,'node',5),('features',78,'node',4),('features',94,'node',4),('features',139,'node',1),('featuring',33,'node',2),('featuring',36,'node',1),('featuring',52,'node',1),('featuring',139,'node',1),('fee',24,'node',0.528135),('fee',26,'node',1.8894),('feed',92,'node',1),('feedback',27,'node',0.816452),('feeding',97,'node',1),('feeds',26,'node',1),('feel',24,'node',0.366597),('feel',44,'node',0.679856),('feel',52,'node',1),('feel',74,'node',2),('feel',75,'node',1),('feel',88,'node',0.876337),('feeling',74,'node',1),('feels',32,'node',0.976851),('feels',44,'node',1),('feels',49,'node',1),('feels',52,'node',1),('feels',73,'node',1),('fees',16,'node',1.82297),('fees',18,'node',1.78212),('fees',19,'node',1.84411),('fees',22,'node',13),('fees',26,'node',3.77305),('feet',65,'node',1),('feet',66,'node',1),('feet',68,'node',2),('felis',17,'node',4.6794),('felis',18,'node',0.779231),('felis',23,'node',1),('felis',37,'node',1),('felis',143,'node',1.90629),('fermented',138,'node',1),('fermentum',20,'node',1),('fermentum',21,'node',1),('fermentum',23,'node',2),('fermentum',143,'node',1),('ferrule',36,'node',2),('feugiat',17,'node',3.83756),('feugiat',23,'node',1),('feugiat',37,'node',1),('feugiat',143,'node',2.8894),('few',29,'node',1),('fhd',71,'node',1),('fibres',36,'node',3),('field',91,'node',1),('fields',28,'node',1),('fighting',74,'node',2),('figure',61,'node',1),('figure',63,'node',1),('figure',64,'node',1),('fiji',28,'node',0.997306),('file',82,'node',1),('files',24,'node',0.416268),('files',47,'node',1),('filter',88,'node',0.808176),('filter',89,'node',0.851346),('filter',91,'node',54),('filter',130,'node',11),('filter',140,'node',11),('filters',91,'node',1),('filters',130,'node',37),('filters',140,'node',37),('final',16,'node',1.84812),('final',18,'node',1.80967),('final',19,'node',1.87367),('final',39,'node',1),('finally',61,'node',1),('financial',24,'node',1.22366),('find',16,'node',1),('find',18,'node',2),('find',19,'node',1),('find',24,'node',0.7017),('find',32,'node',0.949597),('find',59,'node',1),('find',63,'node',1),('find',65,'node',1),('find',66,'node',1),('find',86,'node',0.953396),('fine',37,'node',0.902857),('fine',92,'node',1),('finer',61,'node',1),('finer',67,'node',1),('finest',46,'node',1),('finetextured',39,'node',1),('fingerprint',44,'node',0.742984),('fingertipthe',44,'node',0.757065),('finibus',20,'node',0.993146),('finish',53,'node',1),('finish',61,'node',0.896076),('finish',84,'node',1),('finished',24,'node',0.449147),('finishing',61,'node',1.99315),('finland',28,'node',0.993146),('firetv',11,'node',37),('first',28,'node',1),('first',46,'node',1),('first',52,'node',1),('first',68,'node',1),('fisheye',88,'node',0.842342),('fit',30,'node',1),('fit',32,'node',2),('fit',55,'node',1),('fit',56,'node',1),('fit',64,'node',2),('fit',77,'node',4),('fit',88,'node',1),('fits',71,'node',1),('fitsyourlaptop',31,'node',0.740689),('fitted',53,'node',1),('fitted',55,'node',1),('fitting',97,'node',1),('five',81,'node',1),('fivefinger',51,'node',4),('fixed',86,'node',0.876337),('fixedport',79,'node',1),('flagship',45,'node',0.757065),('flame',67,'node',1),('flare',89,'node',0.980874),('flash',81,'node',1),('flatbed',82,'node',0.976851),('flaunt',65,'node',1),('flaunt',66,'node',1),('fleeting',88,'node',1),('flexibility',46,'node',1),('flexibility',72,'node',1),('flexibility',80,'node',1),('flexible',92,'node',1),('flip',54,'node',0.879565),('flipped',54,'node',1),('flipup',88,'node',1.74069),('flowy',63,'node',1),('flowy',64,'node',1),('fluid',46,'node',0.976851),('fluidity',49,'node',1),('foam',56,'node',1),('focal',89,'node',1),('focus',44,'node',0.848323),('focus',49,'node',2),('focus',88,'node',0.836446),('focus',89,'node',1),('focus',97,'node',1),('focuses',32,'node',1),('focusing',94,'node',1),('following',24,'node',0.802752),('food',30,'node',1),('food',89,'node',1),('food',106,'node',37),('footage',92,'node',1),('football',73,'node',1),('for',16,'node',7.81949),('for',18,'node',7.77879),('for',19,'node',7.84055),('for',24,'node',19.4631),('for',26,'node',3.94209),('for',27,'node',3.74029),('for',29,'node',1),('for',30,'node',6.9689),('for',31,'node',2.89608),('for',32,'node',3.9689),('for',33,'node',1),('for',34,'node',1),('for',36,'node',3),('for',38,'node',2),('for',39,'node',2),('for',40,'node',5),('for',44,'node',3.76603),('for',45,'node',4.48929),('for',46,'node',5.88716),('for',47,'node',3.77432),('for',48,'node',2),('for',49,'node',2),('for',50,'node',2),('for',51,'node',2.98902),('for',52,'node',2.97286),('for',53,'node',6),('for',54,'node',7.95813),('for',55,'node',2),('for',56,'node',1),('for',57,'node',53),('for',59,'node',6),('for',60,'node',2),('for',61,'node',4.88101),('for',63,'node',9),('for',64,'node',8),('for',67,'node',3),('for',68,'node',2),('for',70,'node',1),('for',71,'node',5.435),('for',72,'node',1),('for',74,'node',1),('for',75,'node',53.7145),('for',76,'node',1),('for',77,'node',7),('for',78,'node',3),('for',79,'node',2),('for',80,'node',3),('for',82,'node',1),('for',83,'node',4),('for',84,'node',4.82776),('for',85,'node',3),('for',86,'node',1),('for',88,'node',3.85642),('for',89,'node',6.9347),('for',92,'node',3.81635),('for',94,'node',2),('for',95,'node',55),('for',96,'node',1),('for',97,'node',2),('for',98,'node',11),('for',122,'node',11),('for',138,'node',1),('for',139,'node',2),('force',42,'node',1),('forefront',80,'node',1),('forest',88,'node',0.816452),('forget',60,'node',1),('forget',88,'node',1),('form',27,'node',9.3983),('form',44,'node',1),('form',53,'node',1),('form',73,'node',1),('form',79,'node',1),('formal',64,'node',1),('format',70,'node',4),('format',139,'node',1),('formed',61,'node',1),('forms',16,'node',1),('forms',18,'node',1),('forms',19,'node',1),('formula',139,'node',1),('formulation',40,'node',1),('found',46,'node',1),('found',50,'node',1),('founded',67,'node',1),('founder',26,'node',8),('four',49,'node',2),('four',83,'node',1),('fps',44,'node',1.64701),('frame',53,'node',2.96498),('frame',86,'node',0.961087),('frameworthy',49,'node',1),('france',28,'node',0.989021),('free',22,'node',1),('free',24,'node',0.366053),('free',48,'node',1),('free',77,'node',1),('free',85,'node',1),('freely',58,'node',1),('french',28,'node',3.58684),('frequency',81,'node',0.997306),('fresher',39,'node',1),('fret',30,'node',1),('friday',27,'node',2.55792),('friday',142,'node',37),('friendly',30,'node',1),('friends',48,'node',1),('friends',71,'node',0.889397),('friends',75,'node',1),('friends',88,'node',1),('fringilla',17,'node',1),('fringilla',18,'node',0.781775),('fringilla',20,'node',1),('fringilla',23,'node',1),('fringilla',37,'node',1),('fringilla',143,'node',0.953396),('from',22,'node',2),('from',24,'node',6.82343),('from',27,'node',0.863659),('from',31,'node',1.95723),('from',32,'node',3),('from',33,'node',1),('from',38,'node',1),('from',41,'node',1),('from',44,'node',2.64395),('from',46,'node',1.86536),('from',50,'node',1),('from',53,'node',1),('from',56,'node',2),('from',57,'node',2),('from',58,'node',1),('from',60,'node',1),('from',61,'node',2),('from',62,'node',1),('from',63,'node',1),('from',64,'node',1),('from',65,'node',2),('from',66,'node',2),('from',67,'node',1),('from',71,'node',3.26581),('from',73,'node',3),('from',74,'node',1),('from',76,'node',1.9689),('from',77,'node',1),('from',78,'node',1),('from',79,'node',1),('from',80,'node',1),('from',82,'node',4),('from',84,'node',2),('from',86,'node',1),('from',88,'node',1.78973),('from',92,'node',5.75634),('from',94,'node',1),('from',95,'node',1),('from',96,'node',1),('front',32,'node',1),('front',51,'node',1),('front',74,'node',0.945829),('frontfiring',74,'node',1),('frustrating',59,'node',1),('fs0005',66,'node',0.98493),('ftp',81,'node',1),('fu022faal7jtanmy553296',66,'node',0.993146),('fu022faalch2anmy561503',65,'node',0.980874),('fulfilling',24,'node',0.621888),('fulfillment',24,'node',0.641769),('fulfillment',26,'node',1),('full',33,'node',1),('full',46,'node',1),('full',51,'node',4),('full',53,'node',1),('full',54,'node',1),('full',71,'node',52.6837),('full',72,'node',57),('full',74,'node',1),('full',77,'node',1),('full',78,'node',1),('full',85,'node',2),('full',86,'node',2.80406),('full',92,'node',0.942091),('full',120,'node',11),('fullwirespeed',79,'node',1),('fully',59,'node',2),('fully',60,'node',1),('fun',48,'node',1),('fun',88,'node',1),('function',24,'node',0.670377),('function',38,'node',53.2944),('function',44,'node',1),('function',47,'node',1),('function',78,'node',1),('function',83,'node',1),('function',84,'node',1),('functional',31,'node',0.848323),('functionality',32,'node',0.993146),('functionality',33,'node',1),('functionality',54,'node',5),('functions',47,'node',1),('functions',49,'node',1),('functions',68,'node',1),('functions',75,'node',0.931053),('functions',83,'node',1),('funky',65,'node',1),('funky',66,'node',1),('fur',65,'node',69.7042),('fur',66,'node',68.8494),('fur',117,'node',11),('furnyce',66,'node',1),('further',24,'node',0.747619),('further',31,'node',1),('further',71,'node',1),('further',77,'node',1),('further',79,'node',1),('furthermore',92,'node',1),('fusce',17,'node',2.89272),('fusce',23,'node',2),('fusce',37,'node',2),('fusion',67,'node',1),('futuna',28,'node',0.545988),('gabon',28,'node',0.96498),('gadget',31,'node',1),('gadgets',60,'node',4),('gadgets',122,'node',37),('gain',93,'node',3),('galaxy',45,'node',10.5053),('galaxy',53,'node',55.9534),('galaxy',54,'node',56.4743),('galaxy',55,'node',55),('galaxy',109,'node',11),('gallery',47,'node',1),('gallery',86,'node',1),('gallery',88,'node',0.866793),('gambia',28,'node',0.961087),('gamecenter',76,'node',0.848323),('games',47,'node',1),('games',48,'node',1),('games',76,'node',0.836446),('games',81,'node',1),('gaming',77,'node',55),('gamma',93,'node',2),('gathers',44,'node',0.923838),('gbe',79,'node',50.1132),('gbe',125,'node',11),('gbps',79,'node',1),('gddr5',77,'node',0.972861),('gears',31,'node',1),('gem',49,'node',1),('gem',62,'node',1),('gender',24,'node',1),('gender',70,'node',1),('general',70,'node',4),('generation',44,'node',1),('generation',46,'node',1),('generation',52,'node',1),('generation',72,'node',4),('generations',59,'node',1),('gentle',38,'node',1),('gentle',39,'node',6),('gentle',40,'node',1),('genuine',54,'node',49.4743),('genuine',57,'node',1),('geometry',57,'node',1),('georgia',28,'node',1.56501),('germany',28,'node',0.953396),('gesture',47,'node',4),('get',14,'node',37),('get',16,'node',1),('get',22,'node',2),('get',27,'node',1),('get',38,'node',1),('get',43,'node',1),('get',44,'node',0.76188),('get',47,'node',1.78608),('get',57,'node',1),('get',59,'node',2),('get',61,'node',1),('get',78,'node',1),('get',84,'node',1),('get',88,'node',3.97258),('get',139,'node',2),('get',143,'node',26),('getaway',31,'node',1),('gets',49,'node',1),('ghana',28,'node',0.949597),('ghz',45,'node',1),('gibraltar',28,'node',0.945829),('gift',19,'node',22.9636),('gift',75,'node',1),('gigabit',46,'node',47.5965),('gigabit',79,'node',6.87003),('gigabit',81,'node',52.8218),('gigabit',124,'node',11),('gigabit',126,'node',11),('girlfriends',63,'node',1),('give',27,'node',0.819249),('give',44,'node',0.774192),('give',58,'node',1),('give',88,'node',1),('given',45,'node',1.51684),('gives',46,'node',0.961087),('gives',76,'node',1),('gives',86,'node',0.931053),('gives',92,'node',0.945829),('gives',97,'node',1),('giving',138,'node',1),('gladly',27,'node',0.906287),('glam',65,'node',1),('glam',66,'node',1),('glass',44,'node',1),('glass',62,'node',1),('glass',67,'node',1),('glides',37,'node',0.896076),('global',26,'node',2),('global',32,'node',1),('globally',47,'node',1),('globe',56,'node',1),('glow',38,'node',1),('glow',138,'node',1),('glowing',138,'node',2),('glud',41,'node',1),('glue',41,'node',54),('glue',106,'node',11),('going',30,'node',1),('going',92,'node',1),('gold',44,'node',43.2853),('gold',53,'node',52),('gold',61,'node',51.6844),('gold',109,'node',11),('gold',115,'node',11),('good',31,'node',3.54438),('good',40,'node',4),('good',48,'node',2.97286),('good',61,'node',1),('gorgeous',71,'node',1),('gorgeous',138,'node',1),('governmental',24,'node',0.381353),('gps',47,'node',0.931053),('gps',55,'node',1),('gpu',47,'node',1),('grab',34,'node',1),('grab',46,'node',1),('grad',91,'node',56),('grad',130,'node',11),('grad',140,'node',11),('grade',33,'node',1),('grade',42,'node',1),('grade',60,'node',1),('grade',61,'node',1),('grades',61,'node',2),('graduated',91,'node',1),('grams',45,'node',1),('grand',73,'node',1),('grants',72,'node',1),('graphic',24,'node',0.405257),('graphics',46,'node',1),('graphics',49,'node',1.93838),('graphics',77,'node',1),('grass',71,'node',0.980874),('gravida',17,'node',1.87957),('gravida',18,'node',0.745294),('gravida',21,'node',3),('gravida',23,'node',2.97286),('gravida',33,'node',0.961087),('gravida',37,'node',2),('gravida',143,'node',0.927431),('grease',41,'node',1),('great',16,'node',1),('great',30,'node',1),('great',32,'node',1),('great',47,'node',0.886095),('great',52,'node',1),('great',63,'node',3),('great',64,'node',2),('great',71,'node',2),('great',75,'node',1),('great',77,'node',1),('great',89,'node',2),('great',95,'node',1),('greater',57,'node',1),('greater',71,'node',1),('greater',72,'node',1),('greater',73,'node',2),('greatlooking',49,'node',1),('greece',28,'node',0.942091),('green',31,'node',0.76188),('green',40,'node',1),('green',70,'node',53),('green',71,'node',0.98493),('green',88,'node',45.9997),('green',96,'node',2),('greenery',31,'node',1),('greenland',28,'node',0.938382),('grenada',28,'node',0.934703),('grenadines',28,'node',0.643484),('grey',52,'node',48.6187),('grey',91,'node',1),('grins',49,'node',1),('grip',53,'node',1),('grounds',24,'node',1.48799),('grown',32,'node',1),('gsm',47,'node',1),('gtx',77,'node',0.968904),('guadeloupe',28,'node',0.931053),('guam',28,'node',0.927431),('guardian',24,'node',0.441034),('guatemala',28,'node',0.923838),('guernsey',28,'node',0.920273),('guessing',92,'node',1),('guiana',28,'node',0.980874),('guinea',28,'node',2.60635),('guineabissau',28,'node',0.916736),('guyana',28,'node',0.913226),('gym',139,'node',1),('ha181hbasx9janmy908363',42,'node',1),('habitant',17,'node',1),('habitant',23,'node',1),('habitant',37,'node',1),('habitant',143,'node',1),('hair',36,'node',2),('hair',42,'node',57),('hair',105,'node',11),('hairdryer',42,'node',2),('hairscape',42,'node',67),('hairscape',105,'node',11),('haiti',28,'node',0.909743),('halloween',13,'node',11),('hand',22,'node',4),('hand',32,'node',0.980874),('hand',47,'node',1),('hand',48,'node',1),('hand',75,'node',1),('hand',78,'node',1),('handbag',88,'node',1),('handcrafted',36,'node',1),('handcrafted',61,'node',1),('handle',26,'node',1),('handle',32,'node',1),('handle',34,'node',1),('handle',36,'node',3),('handle',45,'node',0.993146),('handle',46,'node',0.993146),('handle',77,'node',1),('handles',97,'node',1),('handling',45,'node',0.779231),('handpicked',61,'node',0.892724),('hands',45,'node',1),('hands',48,'node',1),('hands',52,'node',1),('hands',55,'node',1),('hands',68,'node',2),('hands',138,'node',1),('handset',55,'node',1),('handsfree',47,'node',0.942091),('handsfree',84,'node',1),('handy',60,'node',1),('happiness',138,'node',1),('hard',31,'node',0.980874),('hard',38,'node',1),('hard',53,'node',1),('harddisk',77,'node',0.980874),('hardware',27,'node',1),('hardware',44,'node',1),('hardware',79,'node',1.89608),('hardware',81,'node',1),('harshest',69,'node',1),('has',24,'node',3.67136),('has',26,'node',1),('has',27,'node',0.845322),('has',43,'node',1),('has',44,'node',1.6439),('has',45,'node',2),('has',52,'node',2),('has',53,'node',1),('has',58,'node',1),('has',59,'node',2),('has',61,'node',2),('has',67,'node',1),('has',71,'node',1),('has',72,'node',1),('has',74,'node',1),('has',79,'node',1),('has',84,'node',1),('has',86,'node',1),('hasn',45,'node',0.892724),('hassle',33,'node',1),('hassle',80,'node',0.997306),('have',22,'node',1),('have',24,'node',12.9535),('have',26,'node',0.989021),('have',27,'node',2.85897),('have',29,'node',2),('have',44,'node',0.813674),('have',45,'node',2.66575),('have',46,'node',1),('have',47,'node',1),('have',57,'node',1),('have',58,'node',1),('have',59,'node',1),('have',61,'node',1),('have',63,'node',1),('have',65,'node',2),('have',66,'node',2),('have',67,'node',1),('have',74,'node',1),('have',75,'node',2),('have',76,'node',1),('have',78,'node',3),('have',81,'node',1),('have',92,'node',0.972861),('have',138,'node',1),('having',24,'node',1),('having',44,'node',0.716357),('having',60,'node',2),('having',75,'node',1),('hdd',71,'node',0.794753),('hdmi',71,'node',0.729424),('hdmi',76,'node',1),('hdmi',78,'node',61),('hdmi13b',78,'node',1),('hdtv',76,'node',3),('hdtv',77,'node',1),('hdtv1',76,'node',1),('headphone',57,'node',1),('headphones',7,'node',37),('headphones',53,'node',0.957226),('headphones',57,'node',1),('headphones',113,'node',37),('heads',38,'node',2),('headset',44,'node',0.650439),('headset',58,'node',57),('headset',113,'node',11),('health',24,'node',0.645209),('health',100,'node',37),('health',105,'node',37),('health',138,'node',1),('healthful',138,'node',1),('healthier',138,'node',0.916736),('healthy',38,'node',1),('healthy',84,'node',1),('healthy',138,'node',2),('hear',57,'node',1),('hear',71,'node',0.938382),('hear',75,'node',1),('heard',28,'node',0.906287),('heart',39,'node',1),('heart',74,'node',5),('heat',42,'node',1),('heavy',80,'node',1),('helena',28,'node',0.661163),('help',19,'node',1),('help',22,'node',2),('help',24,'node',1.63155),('help',29,'node',26),('help',30,'node',1),('help',38,'node',1),('help',43,'node',1),('help',48,'node',0.989021),('help',51,'node',1),('helping',30,'node',1),('helping',43,'node',1),('helps',26,'node',1),('helps',38,'node',1),('helps',39,'node',1),('helps',53,'node',1),('helps',91,'node',2),('helps',138,'node',1),('hence',33,'node',1),('hendrerit',17,'node',1.94209),('hendrerit',20,'node',0.968904),('hendrerit',21,'node',1),('hendrerit',143,'node',4.75083),('her',24,'node',0.882818),('here',18,'node',1),('here',19,'node',1),('here',24,'node',0.523573),('here',71,'node',1),('here',73,'node',1),('here',74,'node',1),('herzegovina',28,'node',1),('hidden',71,'node',0.839384),('hidden',73,'node',1),('high',31,'node',1),('high',33,'node',2),('high',36,'node',1),('high',42,'node',2),('high',46,'node',1),('high',50,'node',1),('high',59,'node',1.86222),('high',60,'node',1),('high',65,'node',1.99315),('high',66,'node',2),('high',71,'node',2),('high',72,'node',4),('high',73,'node',2),('high',74,'node',1),('high',75,'node',0.945829),('high',77,'node',1),('high',78,'node',1),('high',83,'node',5),('high',85,'node',2.91674),('high',89,'node',1),('high',91,'node',1),('high',92,'node',1),('high',93,'node',2),('highavailability',79,'node',1),('highend',50,'node',1),('higher',44,'node',1),('higher',85,'node',1),('highest',32,'node',1),('highlights',42,'node',1),('highlights',96,'node',4),('highly',85,'node',1),('highperformance',77,'node',1),('highpolymercoated',53,'node',1),('highpowered',42,'node',1),('highquality',57,'node',1),('highquality',88,'node',1),('highresolution',73,'node',1),('highresolution',82,'node',1),('highspeed',82,'node',1),('highspeed',84,'node',0.857458),('highspeed',85,'node',2),('hike',30,'node',1),('hiking',30,'node',50.9271),('hiking',31,'node',48.1943),('hiking',101,'node',22),('hinge',86,'node',0.980874),('hippieinspired',63,'node',2),('his',24,'node',0.886095),('hit',76,'node',0.993146),('hold',24,'node',1),('hold',51,'node',1),('hold',52,'node',2),('hold',76,'node',1),('holder',56,'node',52),('holder',91,'node',54),('holder',108,'node',11),('holder',130,'node',11),('holder',140,'node',11),('holding',45,'node',1),('holding',52,'node',0.913226),('holds',55,'node',2),('holes',63,'node',1),('holiday',27,'node',1.75519),('holiday',31,'node',1),('home',27,'node',2),('home',32,'node',1),('home',46,'node',5.77982),('home',47,'node',1),('home',54,'node',1.85746),('home',56,'node',1),('home',71,'node',1),('home',73,'node',54),('home',74,'node',53.3858),('home',76,'node',1),('home',81,'node',1),('home',96,'node',1),('home',121,'node',48),('home',139,'node',1),('home',141,'node',11),('honduras',28,'node',0.899454),('hong',28,'node',0.896076),('honor',48,'node',1),('hoped',45,'node',0.906287),('hopefully',45,'node',0.879565),('hot',42,'node',1),('hotspot',80,'node',1.92384),('hottest',48,'node',1),('hour',68,'node',1),('hour',70,'node',2),('hours',27,'node',0.879565),('hours',31,'node',0.938382),('hours',49,'node',1),('hours',75,'node',1),('hours',80,'node',2),('hours',92,'node',0.869951),('house',74,'node',1),('house',77,'node',1),('house',92,'node',1),('housing',93,'node',2),('how',16,'node',1),('how',17,'node',26),('how',19,'node',24),('how',26,'node',19),('how',27,'node',19),('how',29,'node',26),('how',41,'node',1),('how',52,'node',1),('how',65,'node',1),('how',66,'node',1),('however',19,'node',1),('however',52,'node',1),('hspa',80,'node',1.88136),('htc',59,'node',1),('htc',75,'node',0.993146),('hte350k',74,'node',50.3508),('hte350k',121,'node',11),('huge',60,'node',1),('hugely',44,'node',0.968904),('human',84,'node',1),('hungary',28,'node',0.886095),('hunt',56,'node',1),('hurdle',31,'node',1),('hurting',38,'node',1),('hyaluronic',138,'node',1),('hybrid',53,'node',53),('hybrid',109,'node',11),('hydrate',138,'node',1),('hydrated',39,'node',2),('hydrolysed',138,'node',1),('i74770',77,'node',1),('iaculis',17,'node',0.899454),('iaculis',21,'node',1),('iaculis',23,'node',2),('iaculis',33,'node',0.976851),('iaculis',37,'node',1),('iaculis',143,'node',1.82302),('ibooks',44,'node',0.725015),('icc',83,'node',1),('iceland',28,'node',0.882818),('icloud',76,'node',6),('iconic',68,'node',1),('ideal',30,'node',1),('ideal',32,'node',1),('ideal',41,'node',1),('ideal',43,'node',1),('ideal',89,'node',1),('ideal',97,'node',1),('identify',24,'node',1.71211),('identity',65,'node',1),('identity',66,'node',1),('idle',79,'node',1),('illuminated',84,'node',0.848323),('illumination',49,'node',1),('image',50,'node',1),('image',54,'node',0.968904),('image',71,'node',0.845322),('image',83,'node',5),('image',85,'node',5.91674),('image',89,'node',0.848323),('image',92,'node',4.75599),('images',24,'node',0.404588),('images',50,'node',1),('images',51,'node',1),('images',71,'node',4.51826),('images',72,'node',1),('images',77,'node',1),('images',83,'node',1),('images',86,'node',1),('images',88,'node',1),('images',89,'node',1),('images',94,'node',1),('imagine',48,'node',1),('imagine',60,'node',1),('imaging',86,'node',1),('immediately',24,'node',0.454162),('immersion',71,'node',1),('immersive',74,'node',1),('immortal',67,'node',1),('imovie',76,'node',2),('impact',53,'node',1),('impeccable',68,'node',1),('impedance',58,'node',0.976851),('imperdiet',17,'node',4.58004),('imperdiet',18,'node',0.802752),('imperdiet',23,'node',1),('imperdiet',37,'node',1),('important',24,'node',1),('important',47,'node',0.976851),('important',54,'node',0.942091),('important',65,'node',1),('important',66,'node',1),('important',75,'node',1),('important',80,'node',1),('important',85,'node',1),('impress',73,'node',1),('impressive',45,'node',2),('impressive',57,'node',1),('impressive',58,'node',1),('impressively',88,'node',1),('improper',138,'node',1),('improve',24,'node',1.1449),('improve',38,'node',1),('improved',85,'node',2),('improvement',71,'node',0.869951),('improves',71,'node',0.848323),('improves',85,'node',0.997306),('impurities',39,'node',1),('in656faas6g7anmy870227',67,'node',0.993146),('inactive',79,'node',1),('incar',55,'node',53),('inch',55,'node',1),('inch',86,'node',1),('inch',88,'node',0.779231),('inch',96,'node',53),('inch',99,'node',11),('inches',43,'node',1),('inches',47,'node',1),('include',24,'node',1.42791),('include',27,'node',0.757065),('include',57,'node',1),('include',91,'node',1),('include',95,'node',1),('included',24,'node',0.403922),('included',48,'node',1),('included',51,'node',1),('included',52,'node',1),('included',95,'node',1),('includes',16,'node',1.83717),('includes',18,'node',1.79914),('includes',19,'node',1.86236),('includes',26,'node',0.972861),('includes',39,'node',4),('includes',50,'node',1),('includes',61,'node',1),('includes',89,'node',1),('includes',96,'node',1),('including',24,'node',1.5205),('including',26,'node',0.949597),('including',30,'node',1),('including',40,'node',2),('including',48,'node',1),('including',73,'node',1),('including',76,'node',1),('including',138,'node',1),('incoming',54,'node',1),('incomplete',27,'node',0.892724),('increase',77,'node',1),('increased',44,'node',0.909743),('increases',139,'node',1),('incredible',44,'node',0.691597),('incredible',50,'node',1),('incredible',60,'node',4),('incredible',62,'node',1),('incredibly',49,'node',1),('incredibly',80,'node',1),('indepth',72,'node',1),('india',28,'node',0.879565),('indian',28,'node',1),('indicated',24,'node',0.695602),('indicator',59,'node',1),('indicator',69,'node',1),('indicators',60,'node',0.934703),('indispensable',68,'node',1),('individuality',84,'node',0.968904),('individually',36,'node',1),('individuals',26,'node',1),('individuals',33,'node',1),('individuals',138,'node',1),('indonesia',28,'node',0.876337),('indoors',89,'node',1),('indulge',74,'node',1),('industry',24,'node',0.47729),('ineligible',16,'node',3),('ineligible',18,'node',3),('ineligible',19,'node',3),('inexpensive',65,'node',1),('inexpensive',66,'node',1),('infinity',94,'node',1),('inform',24,'node',0.98493),('information',16,'node',2),('information',18,'node',1),('information',19,'node',1),('information',24,'node',96.9271),('information',54,'node',0.938382),('informattion',28,'node',19),('infused',138,'node',1),('ingredients',40,'node',1),('ingredients',138,'node',5.92027),('initiate',27,'node',0.876337),('injuring',38,'node',1),('ink',88,'node',0.802752),('ink',96,'node',2),('inner',53,'node',1),('inner',86,'node',1),('innovation',46,'node',1),('innovations',32,'node',1.94583),('innovations',68,'node',1),('innovative',26,'node',2),('innovative',54,'node',0.957226),('innovative',67,'node',1),('inplane',51,'node',1),('input',78,'node',2),('inputs',78,'node',1),('inquire',24,'node',0.538701),('insert',58,'node',0.98493),('insert',80,'node',1),('inside',33,'node',1),('inside',57,'node',1),('inspiration',32,'node',1),('inspired',32,'node',1),('install',56,'node',1),('installation',56,'node',1),('installation',92,'node',1),('installed',72,'node',1),('installments',27,'node',1),('instant',54,'node',1),('instant',82,'node',1),('instant',138,'node',1),('instantaneously',71,'node',0.792123),('instantly',14,'node',37),('instantly',46,'node',1),('instantly',49,'node',1),('instantly',75,'node',1),('instantly',143,'node',26),('instead',75,'node',1),('instrument',68,'node',1),('intalian',42,'node',1),('integer',17,'node',1),('integer',18,'node',0.733888),('integer',20,'node',0.96498),('integer',21,'node',4),('integer',23,'node',1),('integer',37,'node',1),('integer',143,'node',0.972861),('integrate',51,'node',1),('integrated',51,'node',5),('integrated',52,'node',1),('integrated',89,'node',1),('integrated',92,'node',0.892724),('intel',46,'node',1),('intel',51,'node',2.78227),('intel',77,'node',1),('intelligent',54,'node',1),('intelligent',78,'node',1),('intelligent',86,'node',4.70306),('intended',67,'node',1),('intentionally',52,'node',0.909743),('interacting',52,'node',0.906287),('interactive',54,'node',0.876337),('interchangeable',43,'node',1),('interchangeable',94,'node',1),('interdum',18,'node',0.71),('interdum',20,'node',0.997306),('interdum',23,'node',1),('interdum',37,'node',1),('interdum',143,'node',1),('interests',24,'node',0.807248),('interface',78,'node',1),('interface',94,'node',1),('interference',46,'node',0.879565),('interior',30,'node',1),('interior',31,'node',1),('interlaced',63,'node',1),('internal',45,'node',4.01922),('internal',47,'node',0.819249),('internal',97,'node',1),('internet',47,'node',0.957226),('internet',48,'node',0.931053),('internet',80,'node',2),('intervals',26,'node',1),('intheroom',58,'node',1),('into',24,'node',1.105),('into',26,'node',1),('into',31,'node',2),('into',46,'node',1),('into',71,'node',1.79212),('into',72,'node',2),('into',75,'node',1),('into',77,'node',1),('into',84,'node',0.953396),('into',86,'node',1),('into',88,'node',0.909743),('into',94,'node',1),('intricate',83,'node',1),('introduced',68,'node',1),('introducing',59,'node',1),('investigation',24,'node',0.374963),('invicta',67,'node',73.1435),('invincible',67,'node',1),('invisible',41,'node',1),('invisible',67,'node',1),('invoice',16,'node',1.85557),('invoice',18,'node',1.81683),('invoice',19,'node',1.88136),('involvement',24,'node',0.442633),('ios',44,'node',1.39568),('ios',52,'node',1),('ios',75,'node',51.7145),('ios',76,'node',2),('ios',92,'node',1),('ios',122,'node',11),('ipad',32,'node',1),('ipad',49,'node',57.3981),('ipad',52,'node',56.5498),('ipad',57,'node',52),('ipad',59,'node',1),('ipad',76,'node',2),('iphone',16,'node',1.88659),('iphone',18,'node',1.84662),('iphone',19,'node',1.91342),('iphone',44,'node',52.4723),('iphone',57,'node',52),('iphone',59,'node',1),('iphone',60,'node',1),('iphone',75,'node',51.7145),('iphone',76,'node',2),('iphone',92,'node',1),('iphone',122,'node',11),('iphone6',44,'node',1.32435),('iphones',94,'node',1),('ipod',57,'node',52),('ipod',59,'node',1),('ipod',76,'node',1),('ips',51,'node',5.90286),('ipsum',17,'node',2.87957),('ipsum',18,'node',0.76431),('ipsum',20,'node',3),('ipsum',21,'node',2),('ipsum',52,'node',22.0848),('ipsum',143,'node',2.90286),('iran',28,'node',0.873132),('iraq',28,'node',0.869951),('ire',79,'node',1),('ireland',28,'node',0.866793),('ishop',56,'node',5),('isight',44,'node',0.857458),('isight',49,'node',5.9347),('islamic',95,'node',2),('island',16,'node',1.90289),('island',18,'node',1.86226),('island',19,'node',1.92027),('island',28,'node',3.61496),('islands',28,'node',12.284),('isle',28,'node',0.863659),('isn',44,'node',1),('isn',45,'node',1),('iso',85,'node',1),('israel',28,'node',0.857458),('issue',45,'node',1),('italian',42,'node',1),('italy',28,'node',0.854391),('item',16,'node',2.81949),('item',18,'node',3.77879),('item',19,'node',17.8405),('item',24,'node',0.392305),('item',56,'node',52),('item',108,'node',11),('items',16,'node',1),('items',18,'node',2),('items',19,'node',1),('items',24,'node',0.422736),('items',26,'node',0.942091),('items',33,'node',2),('items',54,'node',1),('items',56,'node',1),('its',27,'node',1),('its',31,'node',2.98493),('its',32,'node',1),('its',38,'node',2),('its',39,'node',1),('its',43,'node',1),('its',44,'node',3),('its',45,'node',3.43271),('its',46,'node',1),('its',48,'node',3.98922),('its',50,'node',1),('its',59,'node',1),('its',60,'node',1),('its',64,'node',1),('its',65,'node',1),('its',66,'node',1),('its',67,'node',2),('its',71,'node',1),('its',72,'node',1),('its',73,'node',2),('its',82,'node',1),('its',84,'node',1),('its',89,'node',3),('its',94,'node',2),('its',139,'node',1),('itself',74,'node',1),('itunes',44,'node',0.727213),('itunes',76,'node',1),('ivory',28,'node',0.851346),('ivory',65,'node',1),('jack',74,'node',0.98493),('jacks',60,'node',1),('jamaica',28,'node',0.845322),('jan',28,'node',0.597248),('japan',28,'node',0.842342),('japan',41,'node',1),('japan',67,'node',0.931053),('jersey',28,'node',0.839384),('jewelleries',61,'node',1),('jewelleries',63,'node',1),('jewelleries',64,'node',1),('jewellery',61,'node',7.98902),('jewellery',115,'node',37),('jewelries',65,'node',1),('jewelries',66,'node',1),('jewelry',27,'node',1),('job',45,'node',1),('join',22,'node',29),('joined',61,'node',2),('jordan',28,'node',0.836446),('jot',96,'node',2),('journey',31,'node',0.953396),('joy',48,'node',1),('jpeg',94,'node',1),('jump',77,'node',1),('jungle',31,'node',2),('jurisdiction',24,'node',0.595774),('just',22,'node',2),('just',30,'node',1),('just',31,'node',0.810915),('just',44,'node',2.68372),('just',46,'node',2),('just',48,'node',1),('just',52,'node',0.953396),('just',54,'node',1),('just',55,'node',1),('just',56,'node',2),('just',57,'node',1),('just',60,'node',2),('just',63,'node',1),('just',65,'node',2),('just',66,'node',2),('just',67,'node',1),('just',71,'node',0.909743),('just',76,'node',1),('just',84,'node',1),('just',86,'node',1),('just',88,'node',2),('just',94,'node',1),('just',138,'node',2),('just',139,'node',1),('justo',17,'node',3.67654),('justo',18,'node',1.54039),('justo',20,'node',2.96205),('justo',21,'node',2),('justo',23,'node',1),('justo',33,'node',0.968904),('justo',37,'node',1),('justo',143,'node',2),('karaoke',74,'node',2.82517),('kazakhstan',28,'node',0.833529),('kdl48r470b',72,'node',52),('kdl48r470b',120,'node',11),('keeling',28,'node',1),('keep',24,'node',2.60047),('keep',27,'node',1),('keep',31,'node',1),('keep',32,'node',1),('keeps',97,'node',1),('kenya',28,'node',0.830633),('key',24,'node',0.475426),('key',54,'node',0.866793),('key',58,'node',1),('key',138,'node',1),('keys',48,'node',1),('keys',58,'node',2),('ki236hbap7fzanmy699829',138,'node',0.980874),('kids',27,'node',1),('kids',95,'node',54),('kids',98,'node',11),('kill',45,'node',0.851346),('kinds',84,'node',1),('kingdom',28,'node',0.559882),('kinohimitsu',138,'node',63.5602),('kinshasa',28,'node',1),('kiribati',28,'node',0.827757),('kit',37,'node',51.387),('kit',38,'node',1),('kit',91,'node',53),('kit',103,'node',11),('kit',130,'node',11),('kit',140,'node',11),('kitkat',45,'node',0.927431),('kits',91,'node',1),('kitts',28,'node',0.659351),('knots',61,'node',1),('know',18,'node',1),('know',29,'node',1),('know',59,'node',1),('know',89,'node',1),('known',39,'node',1),('known',49,'node',1),('kong',28,'node',0.892724),('korea',28,'node',1.31208),('krait',45,'node',1),('kuwait',28,'node',0.824901),('kyrgyzstan',28,'node',0.822065),('l12s',75,'node',52.7145),('l12s',122,'node',11),('label',68,'node',1),('lacinia',17,'node',0.879565),('lacinia',20,'node',2),('lacinia',21,'node',3),('lacinia',143,'node',2.81991),('lack',138,'node',1),('lacus',16,'node',0.949597),('lacus',18,'node',4.05992),('lacus',19,'node',0.96498),('lacus',20,'node',1),('lacus',23,'node',2.97286),('lacus',33,'node',1),('lacus',37,'node',2),('lacus',143,'node',1),('lagfree',81,'node',1),('lamido',27,'node',0.745294),('lamudi',27,'node',0.729424),('lan',81,'node',1),('landscape',88,'node',0.830633),('landscapes',86,'node',1),('language',83,'node',1),('lanka',28,'node',0.601716),('laoreet',17,'node',3.87957),('laoreet',20,'node',2.93065),('laoreet',21,'node',2),('laoreet',23,'node',1),('laoreet',37,'node',1),('laoreet',143,'node',2.83859),('laos',28,'node',0.819249),('laptop',8,'node',11),('laptop',31,'node',2),('laptop',32,'node',55.0385),('laptop',33,'node',3),('laptop',80,'node',1),('laptop',134,'node',48),('laptops',94,'node',1),('laptops',123,'node',37),('large',22,'node',1),('large',30,'node',1),('large',33,'node',1),('large',45,'node',1),('large',48,'node',0.976851),('large',58,'node',1),('large',63,'node',1),('large',92,'node',1),('larger',44,'node',4.62038),('largest',44,'node',2),('last',28,'node',1),('last',59,'node',1),('last',78,'node',2),('last',80,'node',1),('last',82,'node',1),('last',96,'node',1),('lasting',50,'node',1),('lasting',80,'node',4),('latencysensitive',81,'node',1),('later',88,'node',1),('latest',45,'node',1),('latest',52,'node',1),('latest',56,'node',1),('latest',76,'node',0.976851),('latest',85,'node',1),('lather',39,'node',1),('latvia',28,'node',0.816452),('law',16,'node',2.81949),('law',18,'node',2.77879),('law',19,'node',2.84055),('law',24,'node',2.39635),('lay',53,'node',1),('layer',24,'node',0.485867),('layer',53,'node',1),('layer',61,'node',1.90286),('layer',79,'node',3.89338),('layers',43,'node',1),('layout',24,'node',0.725015),('lazada',27,'node',0.822065),('lazada',44,'node',1),('lcarnitine',139,'node',1),('lcd',84,'node',7.48904),('lcd',86,'node',6.82206),('lcd',88,'node',1.74069),('lcd',96,'node',55),('lcd',99,'node',11),('le106elasxt7anmy909117',51,'node',0.972861),('le106elat4hkanmy918581',47,'node',0.863659),('leading',27,'node',0.749958),('leading',46,'node',5.81092),('learn',22,'node',11),('learn',76,'node',1),('learn',95,'node',5),('lease',16,'node',1),('lease',18,'node',1),('lease',19,'node',1),('least',24,'node',0.482016),('leather',36,'node',2),('leaves',39,'node',1),('lebanon',28,'node',0.813674),('lecithin',139,'node',1),('lectus',17,'node',3.661),('lectus',20,'node',1),('lectus',21,'node',3),('lectus',23,'node',2.96109),('lectus',37,'node',1),('lectus',143,'node',2.93569),('led',60,'node',0.938382),('led',71,'node',47.6837),('led',72,'node',57),('led',75,'node',1.90629),('led',93,'node',1),('led',120,'node',11),('left',54,'node',1),('legal',24,'node',2.68849),('legally',24,'node',0.459294),('legendary',67,'node',1),('legendary',69,'node',1),('legs',138,'node',1),('lend',30,'node',1),('lends',71,'node',1),('length',61,'node',0.916736),('length',89,'node',1),('lenovo',47,'node',62.4807),('lenovo',51,'node',61.8573),('lenovo',107,'node',11),('lenovo',112,'node',11),('lens',85,'node',0.906287),('lens',86,'node',48.2142),('lens',88,'node',47.9997),('lens',89,'node',52.7805),('lens',90,'node',52),('lens',92,'node',1),('lens',93,'node',2),('lens',129,'node',11),('lens',131,'node',11),('lenses',131,'node',37),('leo',17,'node',3.81042),('leo',20,'node',1.95723),('leo',21,'node',1),('leo',23,'node',1.97685),('leo',143,'node',2.89122),('leone',28,'node',0.623497),('lesotho',28,'node',0.810915),('less',33,'node',1),('less',80,'node',1),('less',85,'node',1),('less',96,'node',2),('let',26,'node',1),('let',58,'node',1),('lets',27,'node',1),('lets',44,'node',1.64941),('lets',47,'node',1),('lets',48,'node',0.945829),('lets',55,'node',1),('lets',57,'node',1),('lets',58,'node',2),('lets',59,'node',1),('lets',71,'node',0.942091),('lets',76,'node',1),('lets',77,'node',1),('lets',84,'node',6.92296),('lets',86,'node',1),('lets',88,'node',1),('lets',92,'node',0.923838),('letters',24,'node',0.886814),('letting',84,'node',1),('level',59,'node',1),('level',71,'node',1),('levels',39,'node',1),('levels',71,'node',1),('levels',73,'node',1),('levels',84,'node',1),('liability',24,'node',0.507159),('liberia',28,'node',0.808176),('libero',17,'node',3.72011),('libero',23,'node',2),('libero',37,'node',2),('libero',143,'node',2.88418),('libya',28,'node',0.805455),('licensed',24,'node',0.394193),('lide',82,'node',53),('lide',127,'node',11),('liechtenstein',28,'node',0.802752),('life',24,'node',0.646943),('life',44,'node',0.902857),('life',47,'node',0.879565),('life',48,'node',1),('life',49,'node',1),('life',60,'node',1),('life',67,'node',2),('lifeless',138,'node',1),('lifelike',49,'node',1),('lifelike',72,'node',1),('lifelike',88,'node',1),('lifestyle',31,'node',1),('lifestyle',32,'node',0.957226),('lifestyle',54,'node',1),('lifetime',79,'node',3.79215),('light',52,'node',5),('light',59,'node',1),('light',80,'node',1),('light',84,'node',1),('light',85,'node',1),('light',88,'node',1),('light',89,'node',5),('light',91,'node',2),('light',139,'node',1),('lightcapturing',85,'node',1),('lighting',89,'node',1),('lightningfast',81,'node',1),('lights',75,'node',0.902857),('lightweigh',55,'node',1),('lightweight',31,'node',0.923838),('lightweight',32,'node',1),('lightweight',80,'node',5),('lightweight',89,'node',1),('lightweight',96,'node',1),('ligula',17,'node',1.8092),('ligula',18,'node',0.774192),('ligula',20,'node',3),('liion',88,'node',0.731649),('like',24,'node',0.927857),('like',26,'node',1),('like',31,'node',0.808176),('like',32,'node',1),('like',44,'node',0.836446),('like',47,'node',1),('like',51,'node',1),('like',55,'node',1),('like',61,'node',1),('like',63,'node',1),('like',64,'node',1),('like',71,'node',1),('like',74,'node',2),('like',80,'node',1),('like',83,'node',1),('like',86,'node',0.879565),('like',88,'node',0.873132),('likely',46,'node',1),('limitations',26,'node',0.920273),('limited',16,'node',1),('limited',26,'node',1),('limited',79,'node',3.79215),('line',56,'node',1),('lines',53,'node',1),('linger',62,'node',1),('lining',97,'node',1),('link',24,'node',0.866793),('link',79,'node',1),('link',80,'node',10.5295),('link',81,'node',10.9246),('linking',22,'node',12),('lion',31,'node',56.738),('lion',101,'node',23),('lip',37,'node',1.89008),('lip',53,'node',1),('list',22,'node',4),('list',24,'node',0.391056),('list',26,'node',1.97685),('listed',16,'node',1.90974),('listed',18,'node',1.8894),('listed',19,'node',1.92027),('listen',73,'node',1),('listen',75,'node',0.916736),('listening',73,'node',2),('listing',26,'node',1),('listing',27,'node',0.725015),('listings',26,'node',13),('lists',96,'node',2),('lite',92,'node',1),('literally',39,'node',1),('liters',30,'node',1),('lithuania',28,'node',0.800068),('little',30,'node',1),('little',43,'node',1),('little',60,'node',1),('little',67,'node',1),('live',76,'node',2.67373),('live',88,'node',1),('lively',84,'node',1),('living',13,'node',26),('living',27,'node',1),('living',56,'node',1),('living',71,'node',0.776703),('living',73,'node',1),('living',74,'node',1),('living',80,'node',1),('lo024faaksj4anmy530660',31,'node',0.797402),('load',30,'node',1),('load',45,'node',0.972861),('loaded',48,'node',0.972861),('lobortis',17,'node',1.87957),('lobortis',20,'node',4),('lobortis',21,'node',1),('lobortis',143,'node',1),('lobster',62,'node',1),('local',16,'node',4.65307),('local',18,'node',4.57448),('local',19,'node',4.6992),('local',31,'node',56.738),('local',35,'node',1),('local',36,'node',1),('local',55,'node',1),('local',92,'node',0.794753),('local',101,'node',23),('locate',41,'node',1),('located',24,'node',0.600219),('located',56,'node',1),('located',82,'node',1),('log',24,'node',1.45164),('log',52,'node',1.71431),('log',69,'node',1),('logging',24,'node',0.524706),('login',51,'node',1),('long',24,'node',1.60778),('long',31,'node',0.942091),('long',50,'node',1),('long',55,'node',1),('long',59,'node',1),('long',80,'node',4),('long',94,'node',1),('longer',24,'node',0.492759),('longer',44,'node',0.896076),('longer',67,'node',1),('longer',78,'node',1),('longevity',46,'node',1),('look',31,'node',0.854391),('look',48,'node',1),('look',49,'node',1),('look',53,'node',2),('look',54,'node',0.989021),('look',60,'node',1),('look',63,'node',2),('look',65,'node',2),('look',66,'node',2),('look',71,'node',2),('look',77,'node',1),('looking',31,'node',3.5709),('looking',38,'node',1),('looking',50,'node',1),('looking',61,'node',1),('looking',71,'node',1),('looks',36,'node',1),('looks',48,'node',1),('looks',49,'node',1),('looks',52,'node',1),('looks',61,'node',1),('looks',82,'node',2),('looks',138,'node',1),('loops',64,'node',1),('loose',64,'node',1),('lorem',17,'node',2),('lorem',18,'node',0.860547),('lorem',20,'node',2.98087),('lorem',21,'node',2),('lorem',23,'node',3),('lorem',37,'node',3),('lorem',52,'node',22.158),('lorem',143,'node',3.71024),('lose',24,'node',0.927327),('loss',57,'node',1),('loss',139,'node',2),('lost',45,'node',0.833529),('lotion',39,'node',3),('love',45,'node',0.819249),('love',56,'node',1),('love',61,'node',53.7533),('love',115,'node',11),('loved',63,'node',1),('low',42,'node',2),('low',89,'node',1),('low',96,'node',1),('lowend',74,'node',1),('lower',61,'node',1),('lowlight',89,'node',1),('lowlight',92,'node',1),('lte',44,'node',1.56874),('lte',45,'node',44.965),('lte',110,'node',11),('lu757faat3kbanmy916954',62,'node',1),('luccacal',62,'node',64),('lucia',28,'node',0.655756),('luctus',17,'node',2.89272),('luctus',20,'node',2),('luggage',27,'node',1),('luggage',32,'node',1),('luminescent',68,'node',2),('luminous',138,'node',0.913226),('lush',31,'node',1),('lux',92,'node',1),('lux',93,'node',1),('luxembourg',28,'node',0.797402),('luxury',68,'node',1),('m5250',80,'node',55.8879),('maarten',28,'node',0.618696),('mac',76,'node',2),('macao',28,'node',0.794753),('macbook',123,'node',11),('macedonia',28,'node',0.792123),('machine',95,'node',1),('machines',61,'node',1),('mad',74,'node',1),('madagascar',28,'node',0.78951),('made',24,'node',0.414858),('made',30,'node',1),('made',31,'node',2),('made',32,'node',1),('made',36,'node',1),('made',40,'node',1),('made',48,'node',5),('made',64,'node',1),('made',65,'node',1),('made',66,'node',1),('made',68,'node',1),('made',74,'node',1),('made',76,'node',1),('made',96,'node',1),('maecenas',17,'node',1.92027),('maecenas',18,'node',0.722831),('maecenas',20,'node',3.9381),('maecenas',21,'node',1),('maecenas',23,'node',2),('maecenas',37,'node',1),('maecenas',143,'node',1),('magic',58,'node',1),('magic',88,'node',0.961087),('magna',17,'node',1.91323),('magna',21,'node',1),('magna',23,'node',5),('magna',37,'node',5),('magna',143,'node',2.83717),('magnificent',74,'node',1),('magnificent',86,'node',1),('magnis',18,'node',0.824901),('mah',45,'node',1),('mah',88,'node',0.722831),('mail',24,'node',0.389816),('mailing',24,'node',0.391679),('main',31,'node',1),('main',33,'node',1),('main',34,'node',1),('main',45,'node',0.860547),('main',74,'node',0.961087),('maintain',24,'node',0.397382),('maintain',138,'node',1),('maintaining',24,'node',0.496787),('maintaining',72,'node',1),('maintains',38,'node',1),('make',24,'node',3.19264),('make',26,'node',1),('make',40,'node',1),('make',44,'node',3.68568),('make',47,'node',2),('make',48,'node',2),('make',71,'node',0.899454),('make',74,'node',1),('make',84,'node',4.82776),('make',86,'node',0.997306),('make',96,'node',2),('maker',41,'node',1),('makes',26,'node',2),('makes',38,'node',1),('makes',44,'node',0.681785),('makes',45,'node',1),('makes',47,'node',1),('makes',48,'node',1),('makes',52,'node',0.98493),('makes',57,'node',1),('makes',63,'node',1),('makes',80,'node',1),('makes',85,'node',1),('makeup',36,'node',56),('makeup',37,'node',51.387),('makeup',84,'node',5),('makeup',103,'node',48),('making',27,'node',1),('making',30,'node',1),('making',47,'node',1),('making',73,'node',1),('malawi',28,'node',0.786915),('malaysia',28,'node',0.784336),('malaysia',56,'node',1),('malaysia',79,'node',1),('maldives',28,'node',0.781775),('malesuada',17,'node',3.84411),('malesuada',20,'node',1),('malesuada',21,'node',1),('malesuada',23,'node',2),('malesuada',37,'node',2),('malesuada',143,'node',4),('mali',28,'node',0.779231),('mali400',47,'node',1),('mall',22,'node',1),('malta',28,'node',0.776703),('man',28,'node',0.860547),('man',67,'node',1),('manage',24,'node',0.839384),('manage',79,'node',1),('managed',52,'node',1),('managed',79,'node',52.0093),('managed',125,'node',11),('management',79,'node',1.9689),('manager',83,'node',1),('managing',24,'node',0.625114),('mandatory',24,'node',0.376684),('manila',27,'node',1),('manner',24,'node',2.13425),('manual',89,'node',1),('manually',78,'node',1),('manufacturing',61,'node',1),('many',32,'node',1),('many',45,'node',0.968904),('many',60,'node',0.945829),('many',75,'node',1),('many',138,'node',1),('mariana',28,'node',0.71),('marino',28,'node',0.640063),('marked',28,'node',1),('marker',67,'node',2),('markers',68,'node',2),('market',45,'node',1),('marketing',24,'node',2.63694),('marketplace',21,'node',26),('marketplace',22,'node',1),('marketplace',24,'node',31.9648),('marketplace',26,'node',68),('marketplace',27,'node',43.8971),('marketplace',35,'node',1),('marketplace',36,'node',1),('marketplace',37,'node',0.916736),('marketplace',38,'node',0.938382),('marketplace',39,'node',1),('marketplace',40,'node',1),('marketplace',41,'node',1),('marketplace',42,'node',1),('marketplace',43,'node',1),('marketplace',44,'node',0.657549),('marketplace',45,'node',0.718502),('marketplace',46,'node',0.813674),('marketplace',47,'node',0.830633),('marketplace',48,'node',0.886095),('marketplace',49,'node',0.953396),('marketplace',50,'node',1),('marketplace',51,'node',0.913226),('marketplace',52,'node',0.848323),('marketplace',53,'node',0.976851),('marketplace',54,'node',0.882818),('marketplace',55,'node',1),('marketplace',56,'node',1),('marketplace',57,'node',1),('marketplace',58,'node',1),('marketplace',59,'node',0.942091),('marketplace',60,'node',0.957226),('marketplace',61,'node',0.923838),('marketplace',62,'node',1),('marketplace',63,'node',1),('marketplace',64,'node',1),('marketplace',65,'node',0.934703),('marketplace',66,'node',0.938382),('marketplace',67,'node',0.945829),('marketplace',68,'node',1),('marketplace',69,'node',1),('marketplace',70,'node',1),('marketplace',71,'node',0.738408),('marketplace',72,'node',1),('marketplace',73,'node',1),('marketplace',74,'node',0.873132),('marketplace',75,'node',0.953396),('marketplace',76,'node',0.899454),('marketplace',79,'node',0.899454),('marketplace',80,'node',0.927431),('marketplace',82,'node',0.980874),('marketplace',83,'node',0.961087),('marketplace',84,'node',0.876337),('marketplace',85,'node',0.920273),('marketplace',86,'node',0.836446),('marketplacecom',24,'node',15.0206),('marketplacecom',26,'node',13),('marshall',28,'node',0.774192),('martin',28,'node',0.653974),('martinique',28,'node',0.771698),('mask',39,'node',5),('massa',17,'node',1.77229),('massa',18,'node',0.736141),('massa',20,'node',1),('massa',21,'node',1),('massa',23,'node',1),('massa',37,'node',1),('massa',143,'node',1),('massage',38,'node',1),('massager',38,'node',1),('massager',43,'node',61),('massagers',43,'node',1),('massive',65,'node',1),('massive',66,'node',1),('masterpiece',88,'node',0.860547),('masterpieces',67,'node',1),('match',24,'node',0.408633),('match',30,'node',1),('match',62,'node',1),('match',71,'node',5),('matches',54,'node',1),('material',24,'node',0.664818),('material',31,'node',2.58934),('material',33,'node',3),('material',36,'node',1),('material',65,'node',0.931053),('material',66,'node',0.934703),('material',70,'node',4),('material',80,'node',1),('material',88,'node',0.863659),('materials',24,'node',0.676032),('materials',36,'node',1),('materials',56,'node',1),('materials',96,'node',1),('matrix',83,'node',11),('matte',53,'node',1),('matter',24,'node',1),('matter',52,'node',1),('matter',61,'node',1),('matter',80,'node',1),('matters',24,'node',0.367143),('mattis',17,'node',0.938382),('mattis',18,'node',0.876337),('mattis',20,'node',2),('mattis',21,'node',1),('mattis',23,'node',1),('mattis',37,'node',1),('mattis',143,'node',1.87957),('mauris',17,'node',1.89313),('mauris',18,'node',1.49294),('mauris',20,'node',4),('mauris',21,'node',2),('mauris',23,'node',2.97286),('mauris',37,'node',2),('mauris',143,'node',2.75562),('mauritania',28,'node',0.769219),('mauritius',28,'node',0.766757),('mavens',36,'node',1),('maximize',22,'node',1),('maximize',57,'node',1),('maximum',33,'node',1),('maximum',38,'node',1),('maximum',59,'node',1),('maximum',89,'node',1),('maximus',17,'node',2.70253),('maximus',20,'node',1),('maximus',21,'node',1),('maximus',23,'node',2),('maximus',37,'node',2),('may',16,'node',1),('may',18,'node',1),('may',19,'node',1),('may',24,'node',13.022),('may',78,'node',3),('mayen',28,'node',0.595774),('mayotte',28,'node',0.76431),('mcdonald',28,'node',0.902857),('md368',49,'node',52.3913),('md785zpa',52,'node',49.5015),('me223hbat7xuanmy924008',41,'node',1),('me864',123,'node',11),('mean',49,'node',1),('means',138,'node',1),('meant',44,'node',1),('meant',71,'node',0.822065),('measure',44,'node',1),('measurement',69,'node',1),('measurement',96,'node',1),('measures',45,'node',1.71636),('measures',88,'node',1),('medal',48,'node',1),('media',24,'node',4.29383),('media',81,'node',2),('medicine',30,'node',1),('medium',30,'node',1),('meet',22,'node',1),('meet',27,'node',0.740689),('meet',46,'node',1),('meeting',24,'node',0.379004),('meets',44,'node',1),('mega',139,'node',55),('megapixel',85,'node',1),('megapixel',88,'node',0.745294),('megapixels',86,'node',1),('megapixels',88,'node',0.774192),('mejikaliner',41,'node',64),('mejikaliner',106,'node',11),('memo',50,'node',6),('memo',96,'node',2),('memopad',50,'node',52),('memopad',111,'node',11),('memopad',135,'node',11),('memorize',95,'node',1),('memory',24,'node',0.413458),('memory',45,'node',4.94583),('memory',71,'node',0.800068),('memory',85,'node',1),('memory',88,'node',46.7358),('men',67,'node',51.3981),('men',70,'node',53),('mens',68,'node',53),('mens',118,'node',11),('mens',136,'node',11),('menu',47,'node',0.997306),('menu',54,'node',1),('message',24,'node',0.412068),('message',54,'node',1),('messages',24,'node',0.773506),('messages',54,'node',0.854391),('metal',44,'node',2),('metal',53,'node',52),('metal',109,'node',11),('metallic',53,'node',1),('metallized',53,'node',2),('meters',68,'node',2),('method',16,'node',2),('method',18,'node',2),('method',19,'node',2),('method',27,'node',1),('method',43,'node',1),('methods',16,'node',3),('methods',18,'node',2),('methods',19,'node',2),('metro',27,'node',1),('metus',17,'node',6.72933),('metus',20,'node',1.98087),('metus',21,'node',1),('metus',143,'node',2.84135),('mexico',28,'node',0.76188),('mic',57,'node',53),('mic',74,'node',2.9658),('micro',80,'node',1),('micronesia',28,'node',0.759465),('microsd',45,'node',1.54897),('microsd',92,'node',1),('midsection',53,'node',1),('might',29,'node',1),('miix',51,'node',52.4593),('miix',112,'node',11),('mild',39,'node',2),('millimeters',88,'node',1),('million',22,'node',1),('million',86,'node',1),('millions',26,'node',1),('mimo',52,'node',0.824901),('mind',31,'node',1),('mind',54,'node',1),('mind',61,'node',2),('mindblowing',77,'node',4),('mini',88,'node',50.9418),('mini',95,'node',54),('mini',98,'node',11),('miniature',88,'node',0.824901),('minimal',82,'node',2),('minimize',57,'node',1),('minitablet',51,'node',1),('minor',24,'node',7.17315),('minor',28,'node',0.557303),('minute',43,'node',1),('minute',56,'node',1),('minute',68,'node',1),('minutes',39,'node',1),('miquelon',28,'node',0.648686),('miracle',39,'node',1),('mirror',76,'node',1),('misleading',24,'node',0.989021),('miss',54,'node',1.94209),('miss',75,'node',1),('missed',54,'node',0.851346),('mist',38,'node',2),('misuse',24,'node',0.506102),('mix',62,'node',1),('mix',139,'node',1),('mlb',76,'node',3.98922),('mobile',24,'node',1),('mobile',44,'node',0.697623),('mobile',47,'node',2),('mobile',56,'node',59),('mobile',58,'node',1),('mobile',60,'node',1),('mobile',80,'node',53.8117),('mobile',85,'node',0.989021),('mobile',92,'node',1),('mobile',94,'node',1),('mobile',108,'node',11),('mobility',80,'node',1),('mode',37,'node',0.993146),('mode',44,'node',0.816452),('mode',51,'node',1),('mode',71,'node',5),('mode',73,'node',1.99731),('mode',84,'node',4),('mode',89,'node',1),('mode',92,'node',2),('mode',93,'node',2),('model',31,'node',0.794753),('model',32,'node',0.902857),('model',33,'node',1),('model',35,'node',1),('model',38,'node',1),('model',42,'node',1),('model',43,'node',1),('model',44,'node',0.672252),('model',45,'node',1.54756),('model',46,'node',0.848323),('model',47,'node',0.860547),('model',49,'node',0.997306),('model',51,'node',0.968904),('model',52,'node',0.886095),('model',53,'node',1),('model',55,'node',1),('model',56,'node',1),('model',58,'node',1),('model',61,'node',0.968904),('model',63,'node',1),('model',64,'node',1),('model',66,'node',0.989021),('model',67,'node',0.989021),('model',68,'node',1),('model',69,'node',1),('model',70,'node',2),('model',71,'node',0.76431),('model',72,'node',52),('model',73,'node',1),('model',74,'node',1.96498),('model',75,'node',1),('model',77,'node',1),('model',78,'node',1),('model',79,'node',0.945829),('model',80,'node',0.972861),('model',81,'node',1),('model',82,'node',1),('model',83,'node',1),('model',84,'node',0.920273),('model',85,'node',0.968904),('model',86,'node',0.863659),('model',88,'node',0.786915),('model',93,'node',1),('model',120,'node',11),('modern',60,'node',1),('modern',67,'node',1),('modify',24,'node',0.383732),('module',75,'node',0.949597),('module',94,'node',1),('moisture',39,'node',1),('moisturising',40,'node',1),('moisturizer',38,'node',1),('moldova',28,'node',0.757065),('molestie',17,'node',1.94209),('molestie',143,'node',2),('mollis',17,'node',0.886095),('mollis',18,'node',0.738408),('mollis',21,'node',1),('mollis',23,'node',2),('mollis',37,'node',2),('mollis',143,'node',2.67195),('moment',50,'node',1),('moment',54,'node',1),('moments',30,'node',1),('moments',44,'node',0.805455),('moments',47,'node',0.882818),('moments',88,'node',2),('monaco',28,'node',0.754681),('monday',27,'node',2.55913),('monetize',22,'node',1),('money',16,'node',1),('money',18,'node',1),('money',19,'node',1),('mongolia',28,'node',0.752312),('monitor',77,'node',1),('monitor',86,'node',5),('monitor',92,'node',1.98087),('monitoring',92,'node',3.84435),('montenegro',28,'node',0.749958),('montes',18,'node',0.816452),('month',26,'node',2.772),('month',35,'node',1),('monthlong',27,'node',0.794753),('monthly',26,'node',0.892724),('months',36,'node',1),('months',55,'node',1),('montserrat',28,'node',0.747619),('morbi',17,'node',2.97685),('morbi',20,'node',1),('morbi',23,'node',1),('morbi',37,'node',1),('morbi',143,'node',3.89608),('more',16,'node',3),('more',18,'node',3),('more',19,'node',2),('more',22,'node',11),('more',24,'node',1.78938),('more',26,'node',1),('more',29,'node',1),('more',30,'node',1),('more',38,'node',1),('more',39,'node',1),('more',43,'node',1),('more',44,'node',7.09061),('more',45,'node',1.98902),('more',48,'node',2.83417),('more',49,'node',3),('more',50,'node',1),('more',51,'node',1),('more',52,'node',1),('more',57,'node',3),('more',71,'node',3.54438),('more',76,'node',5.94149),('more',78,'node',1),('more',81,'node',1),('more',92,'node',1.92027),('morning',39,'node',1),('morocco',28,'node',0.745294),('most',31,'node',0.876337),('most',44,'node',1.38533),('most',46,'node',2),('most',47,'node',1),('most',56,'node',2),('most',59,'node',2),('most',60,'node',1),('most',61,'node',3),('most',69,'node',1),('most',71,'node',0.896076),('most',74,'node',1),('most',75,'node',1),('most',76,'node',1),('most',88,'node',1),('motion',44,'node',0.934703),('motion',92,'node',0.805455),('motion',94,'node',1),('motionsensing',92,'node',0.886095),('motor',42,'node',1),('motor',89,'node',1.9347),('motorized',92,'node',1),('mount',55,'node',1),('mountain',30,'node',0.96498),('mountain',69,'node',56),('mountain',119,'node',11),('mouse',32,'node',1),('move',58,'node',1),('move',80,'node',2),('moved',67,'node',1),('movement',67,'node',1.92743),('movement',68,'node',2),('movement',70,'node',1),('movement',85,'node',1),('movement',92,'node',1.94583),('movie',71,'node',0.808176),('movie',74,'node',2),('movies',71,'node',5.05532),('movies',73,'node',1),('movies',74,'node',1),('movies',76,'node',2.98902),('movies',77,'node',1),('moving',72,'node',1),('moving',85,'node',1),('mozambique',28,'node',0.742984),('mp3',31,'node',1),('mp4',85,'node',2),('mtk6572',47,'node',1.81367),('mu553faarfdmanmy830725',61,'node',0.972861),('much',18,'node',1),('much',30,'node',0.98493),('much',45,'node',2.63308),('much',52,'node',1),('much',56,'node',1),('multi',44,'node',1),('multi',62,'node',53),('multiangle',55,'node',1),('multicolour',62,'node',1),('multimedia',48,'node',0.876337),('multipage',82,'node',1),('multiple',16,'node',2),('multiple',18,'node',2),('multiple',19,'node',2),('multiple',31,'node',2.58406),('multiple',51,'node',1),('multiple',54,'node',1),('multiple',60,'node',1),('multiple',61,'node',1),('multiple',78,'node',1),('multiple',86,'node',1),('multisurround',71,'node',0.957226),('multitouch',46,'node',1.94583),('multitouch',49,'node',0.945829),('multitouch',51,'node',4),('multitouch',52,'node',0.902857),('mums',97,'node',1),('mus',18,'node',0.808176),('muscles',38,'node',1),('music',47,'node',1),('music',54,'node',1),('music',57,'node',2),('music',58,'node',2),('music',71,'node',0.786915),('music',73,'node',2),('music',74,'node',2.99731),('music',75,'node',0.913226),('music',76,'node',1),('muslim',95,'node',1),('must',24,'node',1.98493),('mute',73,'node',1),('muwo',61,'node',69.2757),('muwo',115,'node',11),('myanmar',28,'node',0.740689),('mydlink',92,'node',6),('n600',46,'node',47.5965),('n600',124,'node',11),('n750',81,'node',51.8218),('n750',126,'node',11),('n900',80,'node',50.8879),('n910',45,'node',45.6989),('n910',110,'node',11),('nam',17,'node',0.920273),('nam',23,'node',2),('nam',37,'node',1),('nam',143,'node',2.92384),('name',24,'node',3.46543),('name',28,'node',3),('names',76,'node',0.961087),('namibia',28,'node',0.738408),('nap',79,'node',0.96498),('nappies',97,'node',1),('narrower',52,'node',1),('nascetur',18,'node',0.813674),('nat',81,'node',1),('nationwide',27,'node',1),('natoque',18,'node',0.830633),('natural',36,'node',1),('natural',41,'node',1),('natural',61,'node',1),('natural',72,'node',1),('natural',89,'node',2),('natural',138,'node',1),('nature',24,'node',0.93688),('nature',63,'node',1),('nature',89,'node',1),('nauru',28,'node',0.736141),('navigation',55,'node',2),('nd2',91,'node',1),('near',76,'node',1),('nearby',46,'node',0.876337),('nearly',51,'node',1),('nec',17,'node',3.79697),('nec',18,'node',0.707906),('nec',20,'node',4.96717),('nec',21,'node',4),('nec',23,'node',1.97286),('nec',37,'node',1),('nec',143,'node',6.73177),('necessary',24,'node',3.19046),('necessary',60,'node',1),('necessary',88,'node',1),('necessities',80,'node',1),('neck',39,'node',1),('neck',55,'node',1),('necklace',61,'node',0.920273),('necklace',62,'node',54),('need',16,'node',1),('need',18,'node',2),('need',19,'node',2),('need',24,'node',0.606252),('need',47,'node',0.968904),('need',48,'node',1),('need',59,'node',2),('need',60,'node',2),('need',74,'node',1),('need',82,'node',2),('needed',24,'node',0.491762),('needs',22,'node',1),('needs',59,'node',4),('needs',82,'node',1),('negative',88,'node',0.851346),('neo',53,'node',53),('neo',109,'node',11),('neoprene',34,'node',1),('nepal',28,'node',0.733888),('neque',17,'node',3.81973),('neque',18,'node',0.716357),('neque',20,'node',2),('neque',21,'node',1),('neque',23,'node',1.99315),('neque',37,'node',1),('neque',143,'node',1.8894),('nest',138,'node',1),('net',61,'node',1),('netherlands',28,'node',2.4633),('netus',17,'node',1),('netus',23,'node',1),('netus',37,'node',1),('netus',143,'node',1),('network',22,'node',1),('network',76,'node',1.87313),('network',79,'node',2),('network',80,'node',0.96498),('network',81,'node',1),('network',92,'node',48.6718),('network',132,'node',11),('networking',46,'node',0.896076),('networkitunes',76,'node',0.857458),('networks',46,'node',0.869951),('networks',88,'node',1),('never',32,'node',1),('never',48,'node',1),('never',54,'node',0.945829),('never',59,'node',1),('never',71,'node',1),('never',75,'node',1),('never',83,'node',1),('never',84,'node',1),('never',89,'node',1),('nevis',28,'node',0.657549),('new',19,'node',1),('new',26,'node',1),('new',28,'node',2.14405),('new',31,'node',0.805455),('new',44,'node',7.21126),('new',49,'node',1),('new',52,'node',1),('new',53,'node',1),('new',57,'node',1),('new',59,'node',1),('new',71,'node',4),('new',72,'node',4),('new',77,'node',1),('new',84,'node',2),('newborns',97,'node',1),('newest',56,'node',1),('newly',56,'node',10),('news',76,'node',0.980874),('newsletter',24,'node',0.51578),('newsletters',24,'node',0.662985),('next',18,'node',22.5622),('next',47,'node',2),('next',79,'node',1),('nfc',58,'node',1),('nhl',76,'node',0.851346),('ni220elao90eanmy649565',89,'node',0.902857),('nibh',17,'node',1),('nibh',20,'node',1),('nibh',21,'node',5),('nibh',23,'node',4.98493),('nibh',37,'node',2),('nibh',143,'node',2.88792),('nicaragua',28,'node',0.722831),('niger',28,'node',0.72066),('nigeria',28,'node',0.718502),('night',41,'node',52),('night',92,'node',0.813674),('night',93,'node',1),('night',95,'node',1),('night',97,'node',1),('night',106,'node',11),('nighttime',93,'node',1),('nightvision',92,'node',0.889397),('nikkor',89,'node',3.97286),('nikon',89,'node',60.599),('nisi',17,'node',1.78987),('nisi',18,'node',0.714225),('nisi',20,'node',1),('nisi',23,'node',1.94602),('nisi',143,'node',0.882818),('nisl',17,'node',1.94991),('nisl',20,'node',1.98087),('nisl',21,'node',1),('nisl',23,'node',1.97685),('nisl',37,'node',1),('nisl',143,'node',2),('niue',28,'node',0.716357),('no1',22,'node',1),('no225elak8ttanmy497673',48,'node',0.916736),('noise',42,'node',1),('noise',72,'node',1),('noise',85,'node',2),('nokia',48,'node',65.7311),('nokia',60,'node',1),('nominal',58,'node',0.980874),('non',17,'node',3.86044),('non',18,'node',2.32314),('non',20,'node',2),('non',21,'node',3),('non',23,'node',1),('non',37,'node',1),('non',143,'node',3.94583),('none',28,'node',1),('none',52,'node',0.781775),('norfolk',28,'node',0.714225),('normal',44,'node',1),('normal',61,'node',1),('north',28,'node',0.707906),('northern',28,'node',0.712106),('norway',28,'node',0.703756),('not',22,'node',1),('not',24,'node',8.22215),('not',26,'node',1),('not',30,'node',2),('not',32,'node',2),('not',44,'node',2),('not',45,'node',0.920273),('not',51,'node',1),('not',52,'node',1),('not',54,'node',2),('not',75,'node',1),('not',85,'node',1),('not',92,'node',0.857458),('not',95,'node',1),('not',138,'node',1),('note',16,'node',1),('note',18,'node',1),('note',19,'node',1),('note',24,'node',0.565115),('note',45,'node',60.8132),('note',53,'node',56),('note',54,'node',56.4743),('note',109,'node',11),('note',110,'node',11),('note4',53,'node',0.953396),('notes',51,'node',1),('notes',96,'node',4),('notice',44,'node',4),('noticeable',45,'node',1),('notifications',18,'node',22.5622),('notifications',54,'node',1),('notifies',26,'node',2),('nourish',138,'node',1),('now',22,'node',22),('now',31,'node',1),('now',44,'node',1.73702),('now',52,'node',1),('now',59,'node',1),('now',67,'node',1),('now',71,'node',1.61787),('now',72,'node',1),('now',78,'node',1),('now',84,'node',1),('now',85,'node',1),('now',86,'node',0.886095),('now',88,'node',1),('now',94,'node',1),('nozzles',42,'node',1),('ntsc',93,'node',1),('nulla',16,'node',0.953396),('nulla',17,'node',5.85127),('nulla',18,'node',2.38871),('nulla',19,'node',0.968904),('nulla',20,'node',2.98087),('nulla',21,'node',5),('nulla',33,'node',1),('nulla',143,'node',4.82743),('nullam',17,'node',3.84411),('nullam',20,'node',1),('nullam',23,'node',1.96498),('nullam',37,'node',1),('nullam',143,'node',1.85161),('number',24,'node',2),('number',27,'node',2),('number',75,'node',1),('numbers',24,'node',0.887733),('nunc',17,'node',3.7417),('nunc',18,'node',1.51453),('nunc',20,'node',1),('nunc',21,'node',4),('nunc',23,'node',3),('nunc',37,'node',2),('nunc',143,'node',2.67509),('nurtured',67,'node',1),('nutrients',138,'node',1),('nutrition',139,'node',11),('nvidia',77,'node',1.9689),('nxf1',88,'node',0.784336),('nyce',65,'node',69.7042),('nyce',66,'node',68.8494),('nyce',117,'node',11),('nylon',30,'node',1),('nylon',31,'node',0.749958),('objected',24,'node',0.693594),('objection',24,'node',1.69813),('obligations',24,'node',0.378421),('obtained',24,'node',0.896076),('occasion',61,'node',3.86697),('occasions',64,'node',1),('occured',141,'node',1),('ocean',28,'node',1),('ocean',31,'node',1),('odio',17,'node',1.8477),('odio',20,'node',1),('odio',21,'node',1),('odio',23,'node',3.97286),('odio',37,'node',2),('odio',143,'node',1.95723),('oe702el51smmanmy130613',60,'node',1),('oe702elak0u8anmy486129',55,'node',1),('oe702elakqt4anmy527371',78,'node',1),('oe702elamnj0anmy642088',75,'node',1),('oe702elas5khanmy868993',50,'node',1),('oe702elass8banmy900509',59,'node',0.997306),('oe702faashknanmy885439',70,'node',1),('oe702hbamqybanmy647350',36,'node',1),('oe702hbast9qanmy901982',43,'node',1),('oe702hbat78lanmy922903',38,'node',1),('oem',36,'node',11),('oem',38,'node',10.7015),('oem',43,'node',11),('oem',55,'node',11),('oem',59,'node',10.7454),('oem',60,'node',10.8792),('oem',70,'node',11),('oem',75,'node',10.8792),('oem',78,'node',11),('off',14,'node',37),('off',24,'node',0.45164),('off',42,'node',1),('off',45,'node',0.842342),('off',61,'node',0.993146),('off',77,'node',1),('off',95,'node',1),('off',143,'node',26),('offbeat',65,'node',1),('offbeat',66,'node',1),('offer',26,'node',2.97286),('offer',45,'node',0.754681),('offer',79,'node',2),('offered',16,'node',1),('offered',45,'node',0.797402),('offers',16,'node',1),('offers',26,'node',1),('offers',27,'node',1),('offers',42,'node',1),('offers',54,'node',1),('offers',65,'node',1),('offers',66,'node',1),('offers',74,'node',1),('offers',89,'node',1),('officer',24,'node',1.36551),('offset',26,'node',0.923838),('often',60,'node',1),('often',138,'node',1),('oil',88,'node',0.886095),('old',24,'node',0.444243),('oled',75,'node',52.6641),('oled',122,'node',11),('oman',28,'node',0.7017),('once',58,'node',2),('once',67,'node',1),('once',73,'node',1),('one',22,'node',1),('one',24,'node',0.481063),('one',26,'node',2.88918),('one',27,'node',1),('one',30,'node',1),('one',44,'node',2),('one',45,'node',2.66921),('one',46,'node',1),('one',59,'node',1),('one',60,'node',1),('one',63,'node',1),('one',72,'node',1),('one',76,'node',4),('one',78,'node',2),('one',80,'node',1),('one',84,'node',6.91495),('one',96,'node',1),('ones',61,'node',1),('ones',63,'node',1),('ones',84,'node',0.945829),('onesizefitsall',63,'node',1),('onetouch',82,'node',1),('onetouch',83,'node',5),('online',16,'node',4.81949),('online',18,'node',4.77879),('online',19,'node',3.84055),('online',22,'node',1),('online',24,'node',0.733888),('online',26,'node',1),('online',27,'node',30.7854),('online',51,'node',1),('online',56,'node',2),('online',81,'node',1),('only',16,'node',1.90974),('only',18,'node',1.87842),('only',19,'node',1.92027),('only',24,'node',8.00001),('only',26,'node',1.95723),('only',32,'node',2),('only',53,'node',1),('only',54,'node',1),('only',56,'node',1),('only',72,'node',1),('only',78,'node',1),('only',82,'node',1),('only',85,'node',1),('only2014',53,'node',0.949597),('onthego',51,'node',2),('onthego',92,'node',0.980874),('oomph',49,'node',1),('open',24,'node',0.520204),('open',54,'node',1),('opening',54,'node',1),('opening',75,'node',1),('opens',84,'node',1),('operate',38,'node',1),('operate',75,'node',0.896076),('operate',82,'node',3),('operated',47,'node',1),('operated',78,'node',1),('operating',42,'node',1),('operating',44,'node',0.695602),('operating',47,'node',1),('operating',80,'node',1),('operation',83,'node',4),('operation',89,'node',1),('operations',82,'node',1),('optical',50,'node',1),('optical',84,'node',0.869951),('optical',85,'node',0.913226),('optical',89,'node',1),('optimal',53,'node',1),('optimized',55,'node',1),('option',27,'node',1),('option',92,'node',1),('option',93,'node',2),('optional',51,'node',4),('options',16,'node',1),('options',18,'node',22.5622),('options',27,'node',1),('options',92,'node',2),('orange',30,'node',0.899454),('orange',31,'node',1.54897),('orange',35,'node',52),('orange',64,'node',53),('orange',102,'node',11),('orange',116,'node',11),('orci',17,'node',3.74505),('orci',20,'node',1),('order',16,'node',3),('order',18,'node',2),('order',19,'node',2),('order',20,'node',26),('order',24,'node',3.84948),('order',26,'node',1),('order',27,'node',4.66609),('order',29,'node',1),('orders',16,'node',2),('orders',18,'node',2),('orders',19,'node',2),('orders',24,'node',1.3172),('orders',27,'node',1.99315),('ordinary',84,'node',0.961087),('organic',40,'node',55),('organic',104,'node',11),('organizer',35,'node',52),('organizer',102,'node',11),('ori',76,'node',50.1132),('oriented',32,'node',1),('origin',41,'node',1),('original',57,'node',52),('original',83,'node',1),('ornare',17,'node',1),('ornare',20,'node',0.980874),('ornare',21,'node',1),('ornare',143,'node',1.97416),('ot343elam59danmy609257',56,'node',1),('other',16,'node',2),('other',18,'node',1),('other',19,'node',1),('other',24,'node',3.95239),('other',26,'node',2.86987),('other',32,'node',2),('other',44,'node',1.63725),('other',48,'node',1.9496),('other',54,'node',1),('other',57,'node',1),('other',59,'node',1),('other',71,'node',0.972861),('other',77,'node',1),('other',78,'node',1),('other',80,'node',1),('other',88,'node',0.857458),('other',89,'node',0.961087),('other',141,'node',1),('others',24,'node',0.469016),('others',46,'node',1),('others',56,'node',11),('otherwise',24,'node',2.07729),('our',16,'node',1),('our',18,'node',1),('our',19,'node',1),('our',22,'node',1),('our',24,'node',21.1839),('our',26,'node',2),('our',27,'node',2.56296),('our',138,'node',1),('out',16,'node',1),('out',18,'node',1),('out',19,'node',1),('out',24,'node',2.45069),('out',27,'node',1),('out',30,'node',1),('out',31,'node',1.69324),('out',47,'node',1),('out',52,'node',0.945829),('out',59,'node',2),('out',60,'node',1),('out',63,'node',2),('out',64,'node',1),('out',71,'node',0.989021),('out',74,'node',4),('out',86,'node',1),('outcome',78,'node',1),('outdoor',31,'node',0.824901),('outdoor',69,'node',52),('outdoor',119,'node',11),('outdoors',89,'node',1),('outfit',64,'node',1),('outfit',65,'node',2),('outfit',66,'node',2),('outlined',24,'node',1),('outlying',28,'node',0.556022),('output',57,'node',1),('output',59,'node',0.916736),('output',78,'node',2),('outputs',78,'node',2),('outstanding',71,'node',1),('outstanding',89,'node',1),('over',22,'node',1),('over',24,'node',0.461904),('over',32,'node',2),('over',46,'node',1.89543),('over',47,'node',1),('over',62,'node',1),('over',79,'node',0.989021),('over',81,'node',1),('over',86,'node',1),('over',138,'node',1),('overall',52,'node',1),('overall',72,'node',1),('oversaturated',45,'node',1.71636),('overseas',24,'node',0.59873),('own',36,'node',1),('own',54,'node',0.972861),('own',139,'node',2),('owner',67,'node',1),('owners',24,'node',0.379588),('oyster',68,'node',1),('p1801b041k',46,'node',48.4418),('p1801b041k',124,'node',11),('p338',56,'node',53),('p338',108,'node',11),('pack',30,'node',2),('pack',31,'node',1),('packed',67,'node',1),('packs',39,'node',52),('packs',45,'node',0.745294),('packs',46,'node',1),('packs',52,'node',1),('packs',87,'node',11),('pad',50,'node',6),('padded',31,'node',0.906287),('padded',32,'node',1),('paddings',30,'node',1),('pads',96,'node',2),('page',27,'node',29.0146),('page',47,'node',1),('page',141,'node',1),('pages',24,'node',1.96814),('pages',47,'node',1),('paint',88,'node',0.882818),('painting',88,'node',0.800068),('pair',58,'node',1),('pair',89,'node',0.942091),('pairing',48,'node',1),('pakistan',28,'node',0.699655),('pal',93,'node',1),('palau',28,'node',0.697623),('palestinian',28,'node',0.695602),('palm',48,'node',1),('pan',92,'node',49.6176),('pan',132,'node',11),('pan',138,'node',52.9883),('panama',28,'node',0.693594),('panel',33,'node',1),('panel',83,'node',1),('paper',32,'node',1),('paper',96,'node',2),('paperless',96,'node',2),('papua',28,'node',0.691597),('paraguay',28,'node',0.689612),('parallel',85,'node',1),('parent',24,'node',0.441832),('parents',97,'node',1),('part',27,'node',15.4598),('part',28,'node',0.652202),('part',39,'node',1),('participant',27,'node',0.808176),('particular',24,'node',0.41),('particularly',47,'node',1),('parties',24,'node',5.43006),('partner',27,'node',0.759465),('parturient',18,'node',0.819249),('party',24,'node',9.39917),('pass',24,'node',0.769219),('password',24,'node',5.25675),('password',44,'node',1.4574),('password',51,'node',1),('past',24,'node',0.533952),('pastel',63,'node',1),('pastel',64,'node',1),('patent',43,'node',1),('pattern',31,'node',0.869951),('pattern',53,'node',1),('pattern',65,'node',53.0895),('pattern',66,'node',53.1915),('pattern',117,'node',11),('payment',16,'node',59),('payment',18,'node',7),('payment',19,'node',7),('payment',26,'node',2),('payment',27,'node',3),('payments',24,'node',1.51566),('payments',26,'node',13),('paypal',27,'node',1),('pcs',46,'node',2),('pcworld',46,'node',1),('pdf',82,'node',2),('pdf',83,'node',1),('peaceloving',63,'node',1),('peaceloving',64,'node',1),('pedometer',54,'node',0.863659),('pellentesque',17,'node',2.90286),('pellentesque',20,'node',1),('pellentesque',23,'node',5),('pellentesque',37,'node',3),('pellentesque',143,'node',3.89608),('pen',51,'node',1),('penatibus',18,'node',0.827757),('penetrates',43,'node',1),('penetrating',38,'node',1),('people',44,'node',0.866793),('people',45,'node',0.824901),('people',56,'node',1),('people',57,'node',1),('people',60,'node',1),('people',61,'node',2),('people',75,'node',1),('per',43,'node',1),('per',64,'node',1),('per',79,'node',1),('perfect',33,'node',1),('perfect',38,'node',56.2917),('perfect',44,'node',1.74529),('perfect',46,'node',1),('perfect',51,'node',1),('perfect',53,'node',1),('perfect',54,'node',5),('perfect',55,'node',1),('perfect',63,'node',1),('perfect',80,'node',1),('perfect',88,'node',1),('perfect',89,'node',2),('perfect',139,'node',1),('perfection',83,'node',51.8218),('perfectly',30,'node',1),('perfectly',39,'node',1),('perfectly',49,'node',1),('perfectly',55,'node',1),('perfectly',71,'node',1),('perfectly',88,'node',2),('perform',24,'node',0.558589),('performance',42,'node',1),('performance',46,'node',3),('performance',49,'node',4),('performance',60,'node',4),('performance',77,'node',1),('performance',79,'node',1),('performance',85,'node',1),('performance',89,'node',1),('performanceoptimised',81,'node',1),('performing',72,'node',1),('perhaps',138,'node',1),('period',26,'node',0.906287),('period',35,'node',1),('period',36,'node',1),('period',55,'node',1),('peritem',26,'node',1),('permalink',52,'node',8.80075),('permissible',24,'node',0.373825),('person',58,'node',1),('person',67,'node',1),('person',75,'node',1),('personal',18,'node',24),('personal',24,'node',82.3924),('personal',27,'node',15.8371),('personal',83,'node',1),('personalities',63,'node',1),('personalities',64,'node',1),('personality',67,'node',3),('personalize',24,'node',0.409315),('personalized',24,'node',0.433216),('personalized',54,'node',0.993146),('perspective',89,'node',1),('peru',28,'node',0.687638),('pharetra',17,'node',0.934703),('pharetra',20,'node',2),('pharetra',143,'node',2.83817),('phasellus',16,'node',0.961087),('phasellus',17,'node',0.889397),('phasellus',18,'node',1.64379),('phasellus',19,'node',0.976851),('phasellus',20,'node',1),('phasellus',21,'node',2),('phasellus',23,'node',1),('phasellus',33,'node',1),('phasellus',37,'node',1),('phasellus',143,'node',1.8478),('philippine',24,'node',0.587082),('philippines',27,'node',0.76188),('philippines',28,'node',0.685676),('philosophy',61,'node',4),('phone',45,'node',2.55574),('phone',47,'node',1.96498),('phone',48,'node',2),('phone',54,'node',2.86366),('phone',56,'node',104),('phone',58,'node',1),('phone',59,'node',1),('phone',75,'node',2.98902),('phone',108,'node',22),('phone',122,'node',1),('phones',27,'node',1),('phones',59,'node',1),('phones',60,'node',1),('phones',75,'node',1.99731),('phones',107,'node',37),('photo',49,'node',1),('photo',76,'node',1),('photo',86,'node',0.889397),('photographic',84,'node',0.938382),('photographs',89,'node',1),('photography',86,'node',1),('photos',44,'node',1.74336),('photos',48,'node',1),('photos',71,'node',0.78951),('photos',76,'node',7),('photos',84,'node',1.96498),('photos',86,'node',2.90286),('photos',88,'node',1.9689),('physical',24,'node',0.390435),('pick',18,'node',1),('pick',27,'node',2),('pick',88,'node',0.942091),('picked',16,'node',2.81949),('picked',18,'node',2.77879),('picked',19,'node',2.84055),('pickup',16,'node',1),('pickup',18,'node',52),('pickup',19,'node',1),('pictelligent',48,'node',1),('picture',71,'node',1.87313),('picture',72,'node',2),('picture',86,'node',0.923838),('picture',92,'node',1),('pictures',47,'node',1),('pictures',49,'node',1),('pictures',54,'node',1),('pictures',72,'node',1),('piece',65,'node',3),('piece',66,'node',3),('pieces',56,'node',1),('pieces',65,'node',1),('pieces',66,'node',1),('pierre',28,'node',0.650439),('pimples',38,'node',1),('pinch',57,'node',1),('pink',58,'node',1),('pink',84,'node',49.4743),('pink',96,'node',53),('pink',99,'node',11),('pink',128,'node',11),('pioneering',68,'node',1),('pir',92,'node',1.8861),('pitcairn',28,'node',0.683725),('pitch',71,'node',0.976851),('pitera',39,'node',2),('pixels',44,'node',0.845322),('pixels',45,'node',2),('pixels',49,'node',2),('place',24,'node',0.592848),('place',26,'node',1),('place',82,'node',2),('place',97,'node',1),('placed',24,'node',0.414157),('placerat',17,'node',2.86662),('placerat',20,'node',1),('placerat',21,'node',3),('placerat',143,'node',2.78152),('places',77,'node',4),('plain',65,'node',2),('plain',66,'node',2),('plain',88,'node',0.976851),('planning',31,'node',1),('plastic',36,'node',1),('plastic',93,'node',2),('plastic',96,'node',1),('plasticlined',36,'node',1),('plated',61,'node',51.6844),('plated',115,'node',11),('platform',24,'node',17.6473),('platform',26,'node',1),('plating',61,'node',0.997306),('plating',62,'node',1),('play',55,'node',1),('play',73,'node',1),('play',76,'node',1),('play',95,'node',5),('playback',54,'node',1),('playback',57,'node',2),('playback',85,'node',0.993146),('playback',86,'node',1),('player',31,'node',1),('player',47,'node',1),('player',48,'node',1.87313),('player',78,'node',1),('players',81,'node',1),('playful',88,'node',0.899454),('playing',47,'node',1),('playing',81,'node',1),('please',16,'node',1),('please',18,'node',1),('please',19,'node',1),('please',24,'node',3.19749),('please',27,'node',1.86697),('pleasure',52,'node',0.96498),('plug',55,'node',1),('plug',71,'node',0.802752),('plug',76,'node',1),('plugable',26,'node',8),('plugs',60,'node',1),('plus',8,'node',11),('plus',22,'node',1),('plus',31,'node',0.845322),('plus',32,'node',50.0385),('plus',55,'node',54),('plus',71,'node',1.67364),('plus',74,'node',1),('plus',134,'node',11),('pocket',59,'node',0.931053),('pocket',88,'node',1),('pockets',30,'node',1),('pockets',31,'node',1),('poe',79,'node',51.0981),('poe',125,'node',11),('point',39,'node',1),('point',46,'node',0.920273),('point',61,'node',1),('point',128,'node',37),('poland',28,'node',0.681785),('pole',31,'node',0.866793),('policies',18,'node',21.0971),('policies',24,'node',0.842342),('policy',18,'node',1),('policy',19,'node',25),('policy',24,'node',35.155),('policy',27,'node',1),('polishing',61,'node',2),('polycarbonate',53,'node',3),('polyester',33,'node',1),('polynesia',28,'node',0.976851),('pony',36,'node',2),('poor',138,'node',1),('pop',52,'node',0.949597),('pop',94,'node',1),('pore',38,'node',59.2917),('pores',38,'node',1),('port',78,'node',52),('port',79,'node',51.1132),('port',81,'node',2),('port',125,'node',11),('porta',17,'node',2.92027),('porta',18,'node',0.776703),('porta',23,'node',1.99315),('porta',143,'node',2),('portability',46,'node',1),('portable',55,'node',1),('portable',59,'node',0.934703),('portable',80,'node',7),('portable',94,'node',52),('portable',96,'node',1),('portable',133,'node',11),('portrait',88,'node',0.827757),('portraits',89,'node',1.91674),('ports',60,'node',0.949597),('ports',79,'node',3.97395),('ports',81,'node',3),('porttitor',18,'node',1.57941),('porttitor',20,'node',1.97286),('porttitor',21,'node',1),('porttitor',23,'node',1),('porttitor',33,'node',0.972861),('porttitor',37,'node',1),('porttitor',143,'node',0.913226),('portugal',28,'node',0.679856),('poses',84,'node',1),('position',24,'node',0.561181),('position',82,'node',2),('possible',26,'node',2),('possible',29,'node',1),('possible',32,'node',0.934703),('possible',48,'node',1),('possible',64,'node',1),('possible',74,'node',1),('post',52,'node',0.774192),('post',88,'node',1),('posted',26,'node',0.931053),('postpurchase',45,'node',0.863659),('posuere',17,'node',3.83784),('posuere',20,'node',1.95011),('posuere',21,'node',1),('posuere',23,'node',1.98087),('posuere',37,'node',1),('posuere',143,'node',0.976851),('potent',139,'node',1),('potential',59,'node',1),('pouch',35,'node',52),('pouch',36,'node',5),('pouch',102,'node',11),('powder',37,'node',1.87821),('powder',139,'node',1),('power',31,'node',1),('power',32,'node',1),('power',38,'node',59.2917),('power',44,'node',1.93838),('power',52,'node',1),('power',58,'node',1),('power',59,'node',0.923838),('power',60,'node',63.7145),('power',62,'node',1),('power',76,'node',1),('power',79,'node',1.98902),('power',80,'node',1),('power',82,'node',1),('power',94,'node',2),('power',96,'node',1),('powerbank',59,'node',56.3044),('powerbank',114,'node',11),('powerbanks',59,'node',1),('powerconnect',79,'node',50.1132),('powerconnect',125,'node',11),('powered',96,'node',1),('powerful',44,'node',1.96498),('powerful',46,'node',2),('powerful',47,'node',3.93972),('powerful',55,'node',1),('powerful',59,'node',1),('powerful',71,'node',0.961087),('powerful',74,'node',5),('powerful',77,'node',1),('powerful',139,'node',1),('powering',85,'node',1),('powershot',85,'node',56.6895),('powershot',137,'node',11),('ppi',45,'node',2),('practical',97,'node',1),('praesent',17,'node',1.87957),('praesent',20,'node',1),('praesent',143,'node',1.79225),('prayers',95,'node',2),('precious',88,'node',1),('precise',51,'node',1),('precise',71,'node',1),('precise',89,'node',1),('predecessor',45,'node',1.71636),('predefined',83,'node',1),('predicament',59,'node',1),('prefer',24,'node',0.394827),('prefer',84,'node',1),('preference',24,'node',0.400625),('preference',72,'node',1),('preference',73,'node',1),('preference',84,'node',1),('preferences',24,'node',0.3961),('preferences',83,'node',1),('preferred',24,'node',0.407953),('premium',36,'node',1),('premium',53,'node',1.97286),('premium',61,'node',1),('premium',139,'node',1),('prepare',30,'node',1),('prepare',59,'node',1),('prepolishing',61,'node',0.902857),('presenting',52,'node',1),('preserved',83,'node',1),('preserves',85,'node',1),('preset',54,'node',1),('pressed',37,'node',1.88213),('pressure',30,'node',1),('pretium',17,'node',1.97685),('pretium',18,'node',0.72066),('pretium',21,'node',1),('pretium',23,'node',0.961087),('pretium',143,'node',0.957226),('pretty',30,'node',0.989021),('pretty',31,'node',4.37126),('prevent',24,'node',1.1452),('prevent',33,'node',1),('prevent',38,'node',1),('prevent',56,'node',1),('preview',54,'node',0.857458),('previous',47,'node',1),('previous',52,'node',1),('previous',73,'node',1),('previously',26,'node',0.98493),('price',16,'node',1.89062),('price',18,'node',1.85048),('price',19,'node',1.91758),('price',47,'node',1),('price',56,'node',1),('price',61,'node',1),('pricing',16,'node',49.8267),('principe',28,'node',0.635),('print',65,'node',53.0895),('print',66,'node',53.1915),('print',86,'node',1),('print',117,'node',11),('printers',81,'node',1),('priority',27,'node',1),('priority',78,'node',1),('privacy',24,'node',37.8339),('privacy',92,'node',3),('pro',67,'node',51.3981),('pro',91,'node',52),('pro',123,'node',11),('pro',130,'node',11),('pro',140,'node',11),('probably',45,'node',0.896076),('procedures',61,'node',1),('process',24,'node',0.797402),('process',39,'node',1),('process',48,'node',1),('process',61,'node',1.99315),('processed',24,'node',0.776703),('processed',27,'node',0.839384),('processes',61,'node',2),('processing',24,'node',0.483934),('processor',45,'node',5.97685),('processor',46,'node',1),('processor',47,'node',0.927431),('processor',51,'node',1),('processor',76,'node',0.896076),('processor',77,'node',1),('processor',85,'node',5.91674),('processor',86,'node',1),('processora',51,'node',1),('produce',84,'node',1),('producing',89,'node',1),('product',24,'node',1.51899),('product',27,'node',0.899454),('product',32,'node',1),('product',56,'node',1),('product',61,'node',2),('productivity',46,'node',1),('productivity',51,'node',1),('productivity',52,'node',1),('productivity',77,'node',1),('productivity',82,'node',1),('products',22,'node',2),('products',24,'node',6.38005),('products',26,'node',29),('products',27,'node',3),('products',40,'node',1),('products',57,'node',1),('products',74,'node',1),('professional',26,'node',1),('professional',32,'node',0.96498),('professional',42,'node',53),('professional',105,'node',11),('professionals',69,'node',1),('profile',44,'node',1),('profile',83,'node',1),('program',22,'node',26),('program',51,'node',1),('programmes',72,'node',1),('programmes',74,'node',1),('programs',71,'node',1),('proin',17,'node',1),('proin',18,'node',0.889397),('proin',20,'node',2.98087),('proin',21,'node',1),('proin',23,'node',1.98902),('proin',37,'node',1),('proin',143,'node',1.8661),('projection',95,'node',2),('projects',76,'node',1),('promote',138,'node',1),('promotes',138,'node',0.920273),('promotional',24,'node',0.677939),('promotions',16,'node',23.8267),('properly',78,'node',1),('properties',81,'node',1),('proprietary',85,'node',1),('protect',24,'node',0.498827),('protect',51,'node',1),('protect',54,'node',1),('protect',92,'node',1),('protection',24,'node',3.54254),('protection',31,'node',0.961087),('protection',33,'node',3),('protection',36,'node',1),('protection',53,'node',2),('protection',57,'node',1),('protective',53,'node',1),('protects',54,'node',1),('proves',72,'node',1),('provide',24,'node',7.38176),('provide',31,'node',0.968904),('provide',33,'node',2),('provide',56,'node',1),('provided',24,'node',2.50339),('provided',45,'node',1.9507),('provider',24,'node',1.69067),('providers',24,'node',1.25391),('provides',27,'node',1),('provides',30,'node',1),('provides',52,'node',1),('provides',53,'node',1),('provides',73,'node',1),('provides',85,'node',1),('provides',88,'node',1),('provides',92,'node',2),('providing',54,'node',0.873132),('providing',56,'node',1),('provincial',27,'node',0.997306),('published',24,'node',0.383134),('puerto',28,'node',0.677939),('puff',41,'node',1),('puffiness',40,'node',1),('pulling',38,'node',1),('pulvinar',17,'node',2.85532),('pulvinar',20,'node',1.98087),('pulvinar',23,'node',2.96109),('pulvinar',37,'node',2),('pump',7,'node',37),('punches',50,'node',1),('purchase',18,'node',1),('purchase',19,'node',1),('purchase',24,'node',0.446681),('purchased',24,'node',1.164),('purchases',16,'node',2.81949),('purchases',18,'node',2.77879),('purchases',19,'node',2.84055),('purchases',22,'node',1),('purchases',26,'node',1),('purchases',44,'node',0.731649),('purchasing',29,'node',1),('pure',58,'node',1),('purest',73,'node',1),('purpose',24,'node',0.869773),('purpose',33,'node',1),('purposes',24,'node',6.78963),('purse',96,'node',2),('pursuit',84,'node',4),('purus',17,'node',5.77756),('purus',20,'node',1),('purus',21,'node',1),('purus',23,'node',1.98902),('purus',37,'node',1),('purus',143,'node',1.92027),('push',71,'node',0.906287),('pushing',44,'node',1),('pushing',76,'node',1),('put',31,'node',4),('put',33,'node',1),('put',48,'node',0.98493),('put',65,'node',1),('put',66,'node',1),('q10',138,'node',1),('qatar',28,'node',0.674137),('qhd',45,'node',0.98493),('qqvga',94,'node',1),('quad',45,'node',1),('quadband',47,'node',1),('quadcore',45,'node',1),('quadcore',49,'node',1.93838),('quadcore',51,'node',1),('qualcomm',45,'node',1),('qualify',16,'node',1),('qualify',18,'node',1),('qualify',19,'node',1),('qualifying',22,'node',1),('qualities',71,'node',1),('qualities',86,'node',1),('quality',31,'node',1),('quality',36,'node',2),('quality',46,'node',1),('quality',50,'node',2),('quality',53,'node',1),('quality',56,'node',1),('quality',60,'node',1),('quality',61,'node',1),('quality',65,'node',1.99315),('quality',66,'node',2),('quality',67,'node',1),('quality',71,'node',1.71845),('quality',72,'node',2),('quality',74,'node',1),('quality',75,'node',0.942091),('quality',78,'node',1),('quality',83,'node',4),('quality',85,'node',1),('quality',91,'node',1),('quality',92,'node',6.56302),('quality',139,'node',1),('quam',17,'node',1.8034),('quam',18,'node',1.51415),('quam',20,'node',3),('quam',21,'node',2),('quam',23,'node',0.993146),('quam',143,'node',1),('quantity',30,'node',0.896076),('quantity',31,'node',0.757065),('quantity',32,'node',0.869951),('quantity',33,'node',1),('quantity',34,'node',1),('quantity',35,'node',1),('quantity',36,'node',1),('quantity',37,'node',0.927431),('quantity',38,'node',0.949597),('quantity',39,'node',1),('quantity',40,'node',1),('quantity',41,'node',1),('quantity',42,'node',1),('quantity',43,'node',1),('quantity',44,'node',0.661163),('quantity',45,'node',0.725015),('quantity',46,'node',0.822065),('quantity',47,'node',0.839384),('quantity',48,'node',0.896076),('quantity',49,'node',0.96498),('quantity',50,'node',1),('quantity',51,'node',0.923838),('quantity',52,'node',0.857458),('quantity',53,'node',0.989021),('quantity',54,'node',0.892724),('quantity',55,'node',1),('quantity',56,'node',1),('quantity',57,'node',1),('quantity',58,'node',1),('quantity',59,'node',0.953396),('quantity',60,'node',0.96498),('quantity',61,'node',0.934703),('quantity',62,'node',1),('quantity',63,'node',1),('quantity',64,'node',1),('quantity',65,'node',0.945829),('quantity',66,'node',0.949597),('quantity',67,'node',0.957226),('quantity',68,'node',1),('quantity',69,'node',1),('quantity',70,'node',2),('quantity',71,'node',0.745294),('quantity',72,'node',1),('quantity',73,'node',1),('quantity',74,'node',0.882818),('quantity',75,'node',0.96498),('quantity',76,'node',0.909743),('quantity',77,'node',1),('quantity',78,'node',1),('quantity',79,'node',0.909743),('quantity',80,'node',0.938382),('quantity',81,'node',0.976851),('quantity',82,'node',0.993146),('quantity',83,'node',0.972861),('quantity',84,'node',0.886095),('quantity',85,'node',0.931053),('quantity',86,'node',0.845322),('quantity',88,'node',0.757065),('quantity',89,'node',0.866793),('quantity',90,'node',1),('quantity',91,'node',1),('quantity',92,'node',0.824901),('quantity',93,'node',1),('quantity',94,'node',1),('quantity',95,'node',1),('quantity',96,'node',1),('quantity',97,'node',1),('quantity',138,'node',0.942091),('quantity',139,'node',1),('quarter',52,'node',1),('quartz',67,'node',1),('quartz',70,'node',1),('queries',24,'node',0.369897),('question',27,'node',0.824901),('questions',27,'node',0.98493),('questions',29,'node',1),('quick',26,'node',1),('quick',41,'node',53),('quick',54,'node',1.71827),('quick',76,'node',4),('quick',106,'node',11),('quickie',31,'node',1),('quickly',24,'node',0.406601),('quickly',27,'node',1),('quickly',51,'node',1),('quickly',54,'node',1),('quickly',92,'node',1.9347),('quiet',89,'node',0.931053),('quis',17,'node',4.67718),('quis',20,'node',4.96109),('quis',21,'node',1),('quis',23,'node',4),('quis',37,'node',1),('quis',143,'node',6.85495),('quisque',17,'node',1.98087),('quisque',18,'node',0.873132),('quisque',23,'node',1.97685),('quisque',37,'node',1),('quite',45,'node',0.916736),('quran',95,'node',57),('quran',98,'node',11),('qvga',94,'node',1),('radiance',39,'node',1),('radiance',138,'node',4),('radiant',38,'node',1),('radio',48,'node',0.879565),('raincover',33,'node',1),('rainy',89,'node',1),('ram',45,'node',0.949597),('ram',47,'node',1.81367),('ram',51,'node',0.889397),('ram',77,'node',0.989021),('range',63,'node',1),('range',64,'node',1),('range',74,'node',1),('ranked',46,'node',1),('rapidly',85,'node',1),('rate',16,'node',3.81949),('rate',18,'node',2.77879),('rate',19,'node',2.84055),('rates',22,'node',1),('rating',52,'node',0.784336),('razorsharp',49,'node',1),('reach',26,'node',2),('reach',32,'node',1),('read',16,'node',1),('read',29,'node',1),('reader',46,'node',1),('readily',31,'node',1),('reading',95,'node',1),('ready',59,'node',2),('ready',61,'node',0.989021),('ready',74,'node',1),('ready',76,'node',1),('ready',82,'node',1),('ready',86,'node',1),('realestate',27,'node',0.727213),('realism',71,'node',1),('realism',72,'node',1),('reality',71,'node',5),('really',51,'node',1),('rear',51,'node',1),('reason',24,'node',0.45586),('reasonable',24,'node',0.90945),('reasons',44,'node',0.810915),('rebates',16,'node',24.6496),('rebates',18,'node',1.78547),('rebates',19,'node',1.8477),('receive',76,'node',1),('receives',81,'node',1),('receiving',24,'node',1.26803),('recent',54,'node',1),('recent',76,'node',1),('rechargeable',80,'node',0.923838),('rechargeable',88,'node',0.729424),('recognition',51,'node',4),('recognize',24,'node',0.410687),('recognizes',52,'node',0.931053),('recognizes',54,'node',1),('recommended',46,'node',1.89272),('reconnect',58,'node',1),('record',24,'node',1.42941),('record',74,'node',0.993146),('record',92,'node',1),('record',94,'node',2),('recorder',54,'node',0.848323),('recording',49,'node',0.923838),('recording',85,'node',2),('recording',86,'node',2.81092),('recording',92,'node',0.792123),('recording',94,'node',5),('recordings',92,'node',1.89272),('records',24,'node',0.525844),('red',31,'node',0.759465),('red',34,'node',52),('reduce',30,'node',1),('reduce',43,'node',2),('reduce',79,'node',1),('reduced',85,'node',1),('reduced',89,'node',0.98493),('reduces',46,'node',0.882818),('reducing',40,'node',1),('reduction',72,'node',1),('reduction',79,'node',1),('referral',26,'node',0.945829),('refinements',52,'node',1),('reflect',16,'node',1.85183),('reflect',18,'node',1.81324),('reflect',19,'node',1.8775),('reflect',46,'node',1),('reflex',72,'node',1),('refunded',27,'node',0.848323),('refunds',19,'node',61.9636),('regardless',82,'node',2),('register',22,'node',11),('register',24,'node',0.685676),('register',27,'node',1),('register',52,'node',1.70875),('registered',26,'node',0.980874),('registered',40,'node',1),('regular',26,'node',1),('regular',94,'node',2),('regularly',24,'node',0.385536),('regulatory',24,'node',1.64001),('reimagined',53,'node',1),('reject',54,'node',2),('rejuvenate',138,'node',1),('related',24,'node',1.48323),('related',59,'node',1),('relates',24,'node',1),('relation',24,'node',0.736141),('relationship',24,'node',0.623497),('relaxing',31,'node',1),('release',44,'node',0.707906),('relevant',24,'node',3.26899),('reliability',46,'node',6.81092),('remain',24,'node',1),('remains',45,'node',1.71636),('remains',92,'node',0.879565),('remarkably',44,'node',1),('remedies',24,'node',0.554747),('reminded',24,'node',0.452478),('remote',45,'node',0.854391),('remote',46,'node',0.968904),('remote',57,'node',54),('remote',78,'node',53),('remote',92,'node',0.800068),('remote',94,'node',52),('remote',133,'node',11),('remotely',92,'node',1),('removable',97,'node',2),('removal',38,'node',1),('remove',39,'node',1),('remove',41,'node',2),('remove',96,'node',1),('removes',38,'node',1),('renders',89,'node',1),('rendezvous',30,'node',1),('renews',38,'node',1),('report',24,'node',0.386749),('reporting',22,'node',11),('representatives',27,'node',1.84718),('represents',61,'node',1),('represents',67,'node',1),('reproduced',83,'node',1),('republic',28,'node',3),('request',24,'node',1.70983),('requested',24,'node',0.697623),('requests',24,'node',1.25529),('require',24,'node',0.36879),('required',24,'node',2.55027),('required',28,'node',1),('required',76,'node',0.842342),('required',80,'node',1),('requirements',24,'node',1.63481),('requirements',76,'node',0.886095),('requires',76,'node',0.866793),('requires',95,'node',1),('research',24,'node',0.71),('research',61,'node',1),('resembles',33,'node',1),('reserve',24,'node',1.8882),('reserved',24,'node',0.552215),('residual',39,'node',1),('resin',91,'node',1),('resistance',80,'node',1),('resistant',30,'node',1),('resistant',31,'node',48.1943),('resistant',67,'node',1.92743),('resistant',68,'node',3),('resistant',70,'node',4),('resistant',101,'node',22),('resolution',45,'node',2),('resolution',71,'node',1),('resolution',72,'node',7),('resolution',82,'node',0.961087),('resolution',83,'node',5),('resolution',85,'node',2),('resolution',86,'node',1),('resolution',88,'node',5),('resolution',93,'node',2),('resonate',73,'node',1),('respective',81,'node',1),('responsible',24,'node',0.468115),('responsive',92,'node',0.949597),('resting',52,'node',0.920273),('restore',40,'node',1),('restore',138,'node',1),('restricting',24,'node',0.497805),('result',24,'node',0.376109),('result',138,'node',1),('resulting',39,'node',1),('resulting',46,'node',0.863659),('resulting',78,'node',1),('results',52,'node',1),('results',86,'node',1),('resurfaced',67,'node',1),('retain',24,'node',0.609315),('retains',52,'node',1),('retina',44,'node',1.9689),('retina',49,'node',5.94583),('retina',52,'node',2.80047),('retrieving',24,'node',0.526987),('retro',88,'node',0.813674),('return',18,'node',1),('return',19,'node',26),('return',27,'node',12.8225),('return',44,'node',1),('returns',19,'node',72.9635),('returns',27,'node',18.0896),('returns',29,'node',1),('returns',44,'node',1),('reunion',28,'node',0.672252),('review',24,'node',0.384933),('revive',40,'node',1),('revolution',27,'node',24.2674),('revolution',33,'node',57),('revolutionary',39,'node',1),('revolutionary',43,'node',1),('revolutions',43,'node',1),('rhinestones',62,'node',1),('rhode',16,'node',1.90705),('rhode',18,'node',1.86625),('rhode',19,'node',1.92027),('rhoncus',17,'node',2.9537),('rhoncus',21,'node',1),('rhoncus',23,'node',0.989021),('rhoncus',143,'node',2),('rica',28,'node',1),('rich',58,'node',1),('rich',71,'node',1),('rich',74,'node',1),('rich',92,'node',0.902857),('rich',138,'node',1),('richer',49,'node',1),('richer',57,'node',1),('rico',28,'node',0.676032),('ride',55,'node',1),('rides',55,'node',1),('ridiculus',18,'node',0.810915),('right',24,'node',8.7658),('right',44,'node',1.75707),('right',54,'node',1),('right',65,'node',1),('right',66,'node',1),('right',76,'node',1),('right',84,'node',1),('right',88,'node',1),('rights',24,'node',0.927592),('ring',75,'node',1),('ripping',31,'node',1),('ripstop',30,'node',1),('risks',24,'node',0.610858),('risus',18,'node',0.705825),('risus',21,'node',2),('risus',23,'node',1),('risus',143,'node',5.84869),('ritual',39,'node',2),('ro180faasx6ranmy908233',68,'node',1),('road',60,'node',2),('roaming',44,'node',0.771698),('robust',32,'node',1),('robust',81,'node',1),('robustness',72,'node',1),('rohs',81,'node',1),('rolex',68,'node',69),('rolex',118,'node',11),('rolex',136,'node',48),('rollup',36,'node',1),('romania',28,'node',0.670377),('room',13,'node',26),('room',49,'node',1),('room',71,'node',0.774192),('room',73,'node',1),('room',74,'node',1),('room',77,'node',1),('room',95,'node',1),('rope',62,'node',1),('rose',39,'node',1),('rosy',138,'node',2),('rotatable',58,'node',1),('rotate',56,'node',1),('rotates',92,'node',1),('rotating',43,'node',1),('rotational',83,'node',1),('rough',31,'node',0.830633),('round',67,'node',0.938382),('round',68,'node',1),('round',94,'node',4),('rounder',71,'node',1),('roundtheclock',94,'node',2),('router',46,'node',47.5965),('router',81,'node',53.7829),('router',124,'node',11),('router',126,'node',11),('routers',126,'node',37),('routine',82,'node',1),('routing',47,'node',0.920273),('rtn56u',46,'node',47.5965),('rtn56u',124,'node',11),('rubber',70,'node',2),('rugged',33,'node',1),('run',59,'node',1),('run',75,'node',1),('run',81,'node',1),('run',94,'node',1),('running',22,'node',1),('running',45,'node',1),('running',59,'node',1),('running',81,'node',1),('running',92,'node',1),('runs',47,'node',1),('runs',94,'node',1),('rushing',74,'node',1),('russia',28,'node',0.668514),('rutrum',17,'node',0.957226),('rutrum',18,'node',0.848323),('rutrum',20,'node',3),('rutrum',21,'node',1),('rutrum',23,'node',1.97286),('rutrum',37,'node',1),('rutrum',143,'node',1),('rwanda',28,'node',0.66666),('sa356elaol1vanmy666683',74,'node',0.968904),('sa356elaovyaanmy683458',88,'node',0.78951),('sa356elaqrcjanmy794737',45,'node',0.736141),('sa356elarow3anmy844449',71,'node',0.766757),('sa356elat7ymanmy924036',54,'node',0.927431),('sacrifice',46,'node',1),('safe',27,'node',38),('safe',32,'node',1),('safe',96,'node',1),('safely',24,'node',0.501918),('safely',27,'node',1),('safely',45,'node',1),('safely',55,'node',1),('safely',96,'node',1),('safer',24,'node',0.433985),('safety',100,'node',37),('sagittis',17,'node',1.87957),('sagittis',20,'node',1),('sagittis',21,'node',1),('sagittis',143,'node',1),('sahara',28,'node',0.543537),('saint',28,'node',4.59244),('sake',46,'node',1),('sale',27,'node',0.792123),('sales',16,'node',4.71825),('sales',18,'node',4.63709),('sales',19,'node',4.76082),('sales',22,'node',1),('salon',42,'node',2),('salvador',28,'node',1),('same',44,'node',0.873132),('same',45,'node',3.29357),('same',46,'node',0.927431),('same',49,'node',1),('same',52,'node',1),('same',71,'node',1),('same',81,'node',1),('samoa',28,'node',1.64177),('samsung',45,'node',53.8882),('samsung',53,'node',2.9534),('samsung',54,'node',67.4057),('samsung',55,'node',57),('samsung',59,'node',1),('samsung',60,'node',0.997306),('samsung',71,'node',56.8751),('samsung',72,'node',11),('samsung',74,'node',61.2798),('samsung',75,'node',52.7077),('samsung',88,'node',58.4032),('samsung',110,'node',11),('samsung',121,'node',11),('samsung',122,'node',11),('san',28,'node',0.641769),('sandwich',28,'node',0.60778),('sao',28,'node',0.638366),('sapien',17,'node',3.86236),('sapien',18,'node',0.766757),('sapien',20,'node',1),('sapien',23,'node',1),('sapien',37,'node',1),('sapien',143,'node',0.892724),('sapphire',68,'node',2),('sar',28,'node',1.68152),('satisfaction',46,'node',6.81092),('satisfies',84,'node',4),('satisfying',78,'node',1),('saturday',27,'node',1.76246),('saudi',28,'node',0.63333),('say',49,'node',1),('sbh20',58,'node',54),('sbh20',113,'node',11),('sc910elaptxianmy740946',93,'node',1),('scalability',79,'node',1),('scale',73,'node',1),('scale',84,'node',1),('scan',82,'node',4.93395),('scan',83,'node',5),('scan',92,'node',0.934703),('scanner',82,'node',61.9729),('scanner',83,'node',51.8218),('scanner',127,'node',11),('scanners',127,'node',37),('scanning',82,'node',6),('scanning',83,'node',1),('scanning',93,'node',1),('scans',82,'node',1),('scantoemail',83,'node',1),('scantopdf',83,'node',1),('scantrack',93,'node',11),('scarf',65,'node',55.0027),('scarf',66,'node',54.1915),('scarf',117,'node',11),('scarves',63,'node',1),('scarves',64,'node',1),('scarves',117,'node',37),('scelerisque',17,'node',1.87957),('scelerisque',20,'node',1),('scelerisque',21,'node',3),('scelerisque',143,'node',3.65511),('scene',74,'node',2),('scene',86,'node',4.71802),('scenes',86,'node',1),('scent',39,'node',1),('schedule',92,'node',1),('scheduler',96,'node',2),('school',96,'node',1),('scoring',74,'node',1),('scratch',53,'node',1),('scratch',68,'node',2),('scratches',33,'node',1),('scratching',56,'node',1),('screen',45,'node',1.71636),('screen',47,'node',1.99315),('screen',48,'node',5.97286),('screen',51,'node',1),('screen',52,'node',0.899454),('screen',53,'node',1),('screen',54,'node',4.85746),('screen',71,'node',1.91674),('screen',72,'node',1),('screen',76,'node',2),('screen',77,'node',1),('screen',86,'node',0.822065),('screen',88,'node',1),('screen',96,'node',1),('screw',68,'node',2),('scuba',68,'node',1),('sdhc',86,'node',0.819249),('sdxc',86,'node',0.816452),('seamless',44,'node',1),('seamless',46,'node',0.916736),('seamless',86,'node',1),('seamless',89,'node',1),('seamlessly',44,'node',1.68178),('seamlessly',51,'node',1),('seamlessly',88,'node',0.923838),('searchable',83,'node',1),('searched',24,'node',0.422007),('season',97,'node',1),('second',39,'node',1),('second',68,'node',1),('seconds',88,'node',1),('secret',43,'node',1),('sections',95,'node',1),('secure',24,'node',1.10238),('secure',27,'node',38),('secure',32,'node',1),('secure',58,'node',1),('secure',79,'node',1),('secure',97,'node',1),('securely',24,'node',0.994643),('securely',44,'node',0.749958),('securely',55,'node',1),('security',24,'node',8.06402),('security',44,'node',0.759465),('security',54,'node',1),('security',97,'node',1),('sed',17,'node',9.32357),('sed',18,'node',1.62805),('sed',20,'node',5.96989),('sed',21,'node',9),('sed',23,'node',3),('sed',33,'node',1.92607),('sed',37,'node',2),('sed',143,'node',9.54618),('see',26,'node',13),('see',32,'node',0.927431),('see',45,'node',0.902857),('see',48,'node',4),('see',71,'node',0.830633),('see',75,'node',1),('see',84,'node',4),('see',92,'node',1),('seeking',77,'node',1),('seems',52,'node',0.957226),('seems',86,'node',0.882818),('seen',48,'node',4),('seen',71,'node',1.81925),('segmentation',83,'node',1),('select',27,'node',1),('select',78,'node',1),('selected',71,'node',0.923838),('selection',27,'node',1),('selfies',88,'node',2),('selfportraits',84,'node',8.82776),('sell',24,'node',0.4475),('sell',26,'node',27.9384),('seller',16,'node',2.81949),('seller',18,'node',2.77879),('seller',19,'node',2.84055),('seller',24,'node',3.83962),('seller',26,'node',0.927431),('sellers',24,'node',2.18065),('sellers',26,'node',0.997306),('sellers',27,'node',0.738408),('selling',24,'node',0.578643),('selling',26,'node',23),('sem',18,'node',1.50699),('sem',20,'node',1),('sem',21,'node',1),('sem',23,'node',1),('sem',37,'node',1),('sem',143,'node',2),('semper',17,'node',2),('semper',18,'node',0.757065),('semper',21,'node',1),('semper',23,'node',1),('semper',37,'node',1),('semper',143,'node',1.92743),('send',24,'node',2.1282),('send',88,'node',1),('sends',24,'node',0.429413),('senectus',17,'node',1),('senectus',23,'node',1),('senectus',37,'node',1),('senectus',143,'node',1),('senegal',28,'node',0.630018),('sense',67,'node',1),('sense',97,'node',1),('senses',73,'node',1),('sensitive',40,'node',2),('sensitivity',85,'node',2.91674),('sensor',44,'node',0.851346),('sensor',49,'node',1),('sensor',85,'node',1.91674),('sensor',86,'node',6),('sensor',88,'node',1),('sensor',92,'node',2),('sensors',44,'node',0.916736),('sent',26,'node',1),('separate',83,'node',1),('separately',76,'node',1),('serbia',28,'node',0.628375),('series',52,'node',1),('series',61,'node',1),('series',71,'node',46.6837),('series',79,'node',2),('series',88,'node',1),('seriously',24,'node',1),('servers',24,'node',0.430926),('servers',81,'node',1),('service',24,'node',1.65995),('service',27,'node',17.6331),('service',46,'node',1),('services',24,'node',4.90846),('set',24,'node',1.39738),('set',36,'node',53),('set',39,'node',56),('set',49,'node',1),('set',61,'node',51.7533),('set',74,'node',1),('set',78,'node',2),('set',87,'node',11),('set',92,'node',1),('set',94,'node',1),('set',96,'node',1),('set',115,'node',11),('setting',42,'node',1),('settings',42,'node',1),('settings',54,'node',1),('settings',76,'node',1),('settings',83,'node',1),('settings',89,'node',1),('settle',88,'node',0.980874),('setup',76,'node',4),('several',58,'node',1),('several',65,'node',1),('several',66,'node',1),('several',85,'node',1),('seychelles',28,'node',0.62674),('sfp',79,'node',1),('shall',24,'node',1.38554),('shall',27,'node',0.909743),('shape',32,'node',1),('shape',53,'node',1),('shape',68,'node',1),('shapes',65,'node',1),('shapes',66,'node',1),('share',24,'node',3.00765),('share',63,'node',1),('share',79,'node',1),('share',80,'node',1),('shared',24,'node',1.82249),('sharing',24,'node',0.618696),('sharing',48,'node',5),('sharing',80,'node',2),('sharing',81,'node',1),('sharp',89,'node',0.913226),('sharp',92,'node',4.82521),('sharper',45,'node',1),('sharper',72,'node',1),('sharply',71,'node',1),('sheen',138,'node',1),('shift',48,'node',1),('shift',85,'node',1),('ship',16,'node',1),('ship',18,'node',3),('ship',19,'node',2),('ship',26,'node',13),('shipping',16,'node',4.81949),('shipping',18,'node',76.8759),('shipping',19,'node',4.84055),('shipping',26,'node',2),('shipping',27,'node',1),('shipping',29,'node',1),('shock',53,'node',1.97286),('shoe',34,'node',52),('shoe',102,'node',37),('shoes',35,'node',52),('shoes',65,'node',1),('shoes',66,'node',1),('shoes',102,'node',11),('shoot',84,'node',6),('shoot',128,'node',37),('shooting',84,'node',1),('shooting',85,'node',3),('shooting',86,'node',1),('shooting',89,'node',2.9496),('shoots',84,'node',1),('shop',13,'node',11),('shop',27,'node',21),('shopping',22,'node',1),('shopping',27,'node',2.81367),('shopping',56,'node',1),('shoppinge',27,'node',19),('short',67,'node',1),('shortly',24,'node',0.519091),('shot',84,'node',8.94209),('shot',88,'node',6.79475),('shots',84,'node',0.957226),('shots',86,'node',3),('should',24,'node',0.842979),('should',27,'node',0.993146),('should',45,'node',0.945829),('shoulder',30,'node',2),('shoulder',31,'node',0.913226),('shoulder',33,'node',1),('show',53,'node',1),('shown',54,'node',1),('shown',139,'node',1),('shutter',84,'node',1),('sic',89,'node',1),('side',30,'node',1),('side',52,'node',1),('side',88,'node',0.896076),('sierra',28,'node',0.625114),('sign',24,'node',0.879565),('signal',75,'node',0.906287),('signature',65,'node',1),('signature',66,'node',1),('significantly',46,'node',0.886095),('silent',89,'node',1.9347),('silver',51,'node',50.4944),('silver',112,'node',11),('sim',47,'node',5),('sim',48,'node',55.5995),('sim',80,'node',1),('similar',24,'node',1.05028),('similar',27,'node',0.78951),('similar',61,'node',1),('simple',22,'node',1),('simple',27,'node',1),('simple',47,'node',4.89642),('simple',48,'node',5),('simple',62,'node',1),('simple',79,'node',1),('simplest',29,'node',1),('simplicity',55,'node',1),('simplifies',52,'node',1),('simplify',79,'node',0.976851),('simply',44,'node',1),('simply',51,'node',1),('simply',52,'node',0.923838),('simply',71,'node',0.805455),('simply',80,'node',1),('simply',88,'node',1),('simultaneously',81,'node',1),('since',56,'node',1),('sing',74,'node',4),('singapore',28,'node',0.621888),('singapore',79,'node',1),('single',16,'node',1),('single',18,'node',1),('single',19,'node',1),('single',45,'node',0.794753),('single',59,'node',0.920273),('single',76,'node',1),('single',79,'node',1),('single',82,'node',1),('single',83,'node',4),('single',138,'node',1),('singlecore',76,'node',0.892724),('sint',28,'node',0.620288),('sit',17,'node',6.57577),('sit',18,'node',0.731649),('sit',20,'node',6.95779),('sit',21,'node',4),('sit',23,'node',1.96109),('sit',33,'node',1.95793),('sit',37,'node',1),('sit',52,'node',21.9399),('sit',143,'node',5.64737),('site',22,'node',2),('site',27,'node',1),('situation',59,'node',1),('situations',30,'node',1),('situations',89,'node',2),('six',84,'node',1),('size',30,'node',0.942091),('size',31,'node',0.786915),('size',32,'node',0.899454),('size',33,'node',1),('size',34,'node',1),('size',35,'node',1),('size',36,'node',1),('size',37,'node',0.953396),('size',38,'node',0.997306),('size',40,'node',1),('size',41,'node',1),('size',42,'node',1),('size',43,'node',1),('size',44,'node',0.668514),('size',45,'node',9.31567),('size',46,'node',0.842342),('size',47,'node',0.857458),('size',49,'node',0.993146),('size',50,'node',1),('size',51,'node',0.96498),('size',52,'node',0.882818),('size',53,'node',1),('size',54,'node',0.923838),('size',57,'node',1),('size',58,'node',1),('size',59,'node',1.92058),('size',60,'node',1),('size',61,'node',0.96498),('size',62,'node',1),('size',63,'node',2),('size',64,'node',1),('size',65,'node',0.927431),('size',66,'node',1.91193),('size',67,'node',0.98493),('size',68,'node',1),('size',69,'node',1),('size',70,'node',1),('size',71,'node',0.76188),('size',72,'node',1),('size',74,'node',0.96498),('size',76,'node',0.945829),('size',77,'node',4),('size',78,'node',1),('size',79,'node',0.942091),('size',82,'node',1),('size',83,'node',1),('size',84,'node',0.916736),('size',85,'node',0.96498),('size',86,'node',0.860547),('size',88,'node',0.781775),('size',89,'node',1.74778),('size',90,'node',1),('size',91,'node',1),('size',92,'node',0.845322),('size',93,'node',1),('size',94,'node',1),('size',95,'node',1),('size',96,'node',1),('size',97,'node',1),('size',138,'node',0.976851),('size',139,'node',1),('sizes',56,'node',1),('sizes',64,'node',1),('sk159hbasxk7anmy908752',39,'node',1),('sk2',39,'node',52),('sk2',87,'node',11),('sk222hbaqyn8anmy807324',40,'node',1),('sketch',88,'node',0.833529),('skii',39,'node',113),('skii',87,'node',22),('skills',86,'node',1),('skin',37,'node',0.889397),('skin',38,'node',8),('skin',39,'node',6),('skin',40,'node',17),('skin',43,'node',1),('skin',45,'node',0.899454),('skin',84,'node',7),('skin',138,'node',4.90974),('skincare',39,'node',56),('skincare',87,'node',11),('skipping',47,'node',1),('skmei',70,'node',53),('sku',30,'node',0.949597),('sku',31,'node',0.800068),('sku',32,'node',0.909743),('sku',33,'node',1),('sku',34,'node',1),('sku',35,'node',1),('sku',36,'node',1),('sku',37,'node',1),('sku',38,'node',1),('sku',39,'node',1),('sku',40,'node',1),('sku',41,'node',1),('sku',42,'node',1),('sku',43,'node',1),('sku',44,'node',0.676032),('sku',45,'node',0.738408),('sku',46,'node',0.854391),('sku',47,'node',0.866793),('sku',48,'node',0.920273),('sku',49,'node',1),('sku',50,'node',1),('sku',51,'node',0.976851),('sku',52,'node',0.892724),('sku',53,'node',1),('sku',54,'node',0.931053),('sku',55,'node',1),('sku',56,'node',1),('sku',57,'node',1),('sku',58,'node',1),('sku',59,'node',1),('sku',60,'node',1),('sku',61,'node',0.976851),('sku',62,'node',1),('sku',63,'node',1),('sku',64,'node',1),('sku',65,'node',0.98493),('sku',66,'node',0.997306),('sku',67,'node',0.997306),('sku',68,'node',1),('sku',69,'node',1),('sku',70,'node',1),('sku',71,'node',0.769219),('sku',72,'node',1),('sku',73,'node',1),('sku',74,'node',0.972861),('sku',75,'node',1),('sku',76,'node',0.953396),('sku',77,'node',1),('sku',78,'node',1),('sku',79,'node',0.953396),('sku',80,'node',0.980874),('sku',81,'node',1),('sku',82,'node',1),('sku',83,'node',1),('sku',84,'node',0.927431),('sku',85,'node',0.976851),('sku',86,'node',0.869951),('sku',88,'node',0.792123),('sku',89,'node',0.906287),('sku',90,'node',1),('sku',91,'node',1),('sku',92,'node',0.851346),('sku',93,'node',1),('sku',94,'node',1),('sku',95,'node',1),('sku',96,'node',1),('sku',97,'node',1),('sku',138,'node',0.98493),('sku',139,'node',1),('sky',31,'node',2),('slam',48,'node',1),('slam',65,'node',1),('slam',66,'node',1),('slap',31,'node',1),('slash',31,'node',1),('sleek',31,'node',0.813674),('sleek',82,'node',2),('sleeves',31,'node',1),('sliding',58,'node',1),('slightly',41,'node',1),('slim',53,'node',1),('slim',71,'node',1),('slim',82,'node',1),('slim',88,'node',2),('slimming',43,'node',53),('slip',32,'node',1),('slipper',34,'node',1),('slomo',44,'node',0.824901),('slot',45,'node',0.784336),('slots',75,'node',1),('slovakia',28,'node',0.617112),('slovenia',28,'node',0.615536),('slr',129,'node',37),('small',24,'node',0.822945),('small',30,'node',1),('small',76,'node',4),('smart',54,'node',1.87634),('smart',59,'node',2),('smart',72,'node',3),('smart',75,'node',103.429),('smart',88,'node',48.9418),('smart',122,'node',22),('smarter',12,'node',37),('smartphone',31,'node',2),('smartphone',44,'node',0.776703),('smartphone',47,'node',1),('smartphone',55,'node',2),('smartphone',58,'node',2),('smartphones',94,'node',2),('smartphones',110,'node',37),('smile',88,'node',0.997306),('smooth',37,'node',0.882818),('smooth',44,'node',1),('smooth',77,'node',1),('smooth',84,'node',1),('smoother',61,'node',1.89608),('smoothes',84,'node',1),('smoothly',37,'node',0.892724),('smoothly',47,'node',1),('smoothness',49,'node',1),('smoothness',84,'node',1),('smudges',96,'node',1),('snap',31,'node',1),('snap',84,'node',4.82776),('snapdragon',45,'node',1),('snapshot',88,'node',0.913226),('snapshots',92,'node',1),('snugged',30,'node',1),('so406elakprjanmy525732',58,'node',1),('so406elama8aanmy618653',72,'node',1),('so406elao9yxanmy651058',73,'node',1),('soccer',71,'node',5),('social',24,'node',4.29701),('social',48,'node',1),('social',88,'node',1),('sociis',18,'node',0.833529),('sockets',24,'node',0.486839),('sodales',17,'node',2),('sodales',20,'node',1.99315),('sodales',21,'node',2),('sodales',23,'node',1.95723),('sodales',37,'node',1),('sodales',143,'node',3.76508),('soft',36,'node',2),('soft',53,'node',1),('soft',56,'node',1),('soft',88,'node',0.839384),('softness',36,'node',1),('software',44,'node',1),('software',45,'node',0.827757),('software',50,'node',1),('software',51,'node',4),('software',83,'node',4.92743),('soil',40,'node',1),('sold',24,'node',3.8422),('sold',76,'node',1),('solid',63,'node',1),('solid',64,'node',1),('solid',68,'node',1),('sollicitudin',17,'node',2.90029),('sollicitudin',21,'node',2),('sollicitudin',143,'node',1),('solomon',28,'node',0.613969),('solution',38,'node',1),('solution',73,'node',2),('solution',74,'node',1),('solution',138,'node',1),('solution',139,'node',1),('solutions',79,'node',1),('solve',82,'node',1),('somalia',28,'node',0.61241),('some',16,'node',2),('some',18,'node',2),('some',19,'node',2),('some',24,'node',0.808176),('some',31,'node',1),('some',48,'node',1),('some',65,'node',2),('some',66,'node',2),('some',76,'node',0.968904),('some',141,'node',1),('something',44,'node',1),('sometimes',138,'node',1),('song',47,'node',1),('song',73,'node',1),('songs',95,'node',1),('sony',58,'node',65),('sony',72,'node',56),('sony',73,'node',71),('sony',113,'node',11),('sony',120,'node',11),('sophisticated',32,'node',0.968904),('sophisticated',65,'node',1),('sophisticated',66,'node',1),('sophisticated',71,'node',1),('sophisticated',85,'node',1),('sound',57,'node',2),('sound',58,'node',5),('sound',71,'node',0.953396),('sound',72,'node',1),('sound',74,'node',2),('sound',77,'node',4),('sound',92,'node',0.808176),('source',60,'node',1),('source',78,'node',2),('source',138,'node',2),('sourced',56,'node',1),('south',28,'node',3.03892),('southeast',27,'node',0.800068),('southern',28,'node',0.972861),('sp889elasu66anmy903500',53,'node',1),('space',31,'node',1),('space',52,'node',48.6187),('space',77,'node',4),('space',82,'node',2),('space',85,'node',1),('spacious',31,'node',0.745294),('spain',28,'node',0.604732),('spam',24,'node',7.18433),('sparkling',65,'node',1),('sparkling',66,'node',1),('speaker',58,'node',1),('speaker',74,'node',3.78626),('speakers',57,'node',1),('speakers',72,'node',0.997306),('speakers',76,'node',1),('special',16,'node',1),('special',24,'node',0.471741),('special',33,'node',1),('special',40,'node',1),('special',44,'node',4),('special',88,'node',1.80779),('special',91,'node',1),('specialist',16,'node',1),('specialist',18,'node',1),('specialist',19,'node',1),('specially',31,'node',0.860547),('specially',86,'node',0.989021),('specific',63,'node',1),('specifically',24,'node',0.630018),('specifically',61,'node',1),('specification',36,'node',4),('specification',70,'node',4),('specifications',50,'node',1),('specifications',79,'node',4),('specifications',96,'node',4),('speed',42,'node',1),('speed',45,'node',1),('speed',48,'node',1),('speed',80,'node',0.909743),('speed',82,'node',0.972861),('speeds',42,'node',1),('speeds',44,'node',1.5438),('speeds',81,'node',2),('spent',24,'node',0.423467),('spigen',53,'node',63),('spigen',109,'node',11),('spine',30,'node',1),('spins',43,'node',1),('spirit',61,'node',2),('sponge',38,'node',1),('sport',71,'node',0.892724),('sports',27,'node',1),('sports',70,'node',53),('sports',73,'node',1),('sports',76,'node',1.98493),('sports',119,'node',37),('sporty',33,'node',1),('spread',38,'node',1),('spreadsheets',26,'node',1),('spring',63,'node',5),('spring',64,'node',5),('sprinkle',30,'node',1),('spyware',24,'node',7.17392),('square',65,'node',53.0062),('squeezing',38,'node',2),('sri',28,'node',0.60322),('ssl',24,'node',0.970789),('stabilisation',89,'node',0.845322),('stack',79,'node',1),('stacking',79,'node',52.0941),('stacking',125,'node',11),('stadium',71,'node',0.96498),('stadium',73,'node',1),('stages',84,'node',1),('stainless',67,'node',53.3365),('stainless',68,'node',53),('stainless',118,'node',11),('stainless',136,'node',11),('stand',51,'node',1),('stand',82,'node',2),('stand',84,'node',1),('standard',18,'node',1),('standard',19,'node',1),('standard',24,'node',1.65483),('standard',46,'node',0.942091),('standard',71,'node',1),('standard',72,'node',2),('standard',79,'node',2.8851),('standard',89,'node',1),('standards',32,'node',0.997306),('standards',40,'node',1),('stands',67,'node',1),('staple',65,'node',1),('staple',66,'node',1),('start',26,'node',1),('start',83,'node',1),('start',95,'node',1),('stash',31,'node',1),('state',16,'node',4.65307),('state',18,'node',4.57448),('state',19,'node',4.6992),('stated',24,'node',2.18057),('statement',62,'node',1),('statement',65,'node',1),('statement',66,'node',1),('states',28,'node',1.11589),('station',46,'node',3.74429),('stationery',99,'node',37),('statistics',24,'node',0.419836),('status',20,'node',26),('status',27,'node',1.82776),('status',29,'node',1),('status',54,'node',1),('stay',32,'node',1),('staytrue',37,'node',0.879565),('std403',93,'node',1),('steel',67,'node',53.3365),('steel',68,'node',53),('steel',118,'node',11),('steel',136,'node',11),('steering',55,'node',1),('steps',24,'node',1.14324),('stereo',58,'node',54),('stereo',113,'node',11),('stick',41,'node',53),('stick',106,'node',11),('sticky',96,'node',2),('still',24,'node',0.543537),('still',45,'node',1),('still',49,'node',1),('still',69,'node',1),('stills',85,'node',2),('stimulate',38,'node',1),('stitch',64,'node',54),('stitch',116,'node',11),('stitching',64,'node',1),('stock',78,'node',1),('stocks',59,'node',1),('stolen',45,'node',0.836446),('storage',36,'node',1),('storage',45,'node',4.74998),('storage',81,'node',1),('storage',92,'node',1),('store',16,'node',8.63897),('store',18,'node',9.55759),('store',19,'node',8.68109),('store',24,'node',1),('store',27,'node',0.747619),('store',30,'node',0.889397),('store',31,'node',1.75231),('store',32,'node',0.863659),('store',33,'node',1),('store',34,'node',1),('store',35,'node',1),('store',36,'node',1),('store',37,'node',0.920273),('store',38,'node',0.942091),('store',39,'node',1),('store',40,'node',1),('store',41,'node',1),('store',42,'node',1),('store',43,'node',1),('store',44,'node',1.37821),('store',45,'node',0.72066),('store',46,'node',0.816452),('store',47,'node',0.833529),('store',48,'node',0.889397),('store',49,'node',0.957226),('store',50,'node',1),('store',51,'node',0.916736),('store',52,'node',0.851346),('store',53,'node',0.980874),('store',54,'node',0.886095),('store',55,'node',1),('store',56,'node',2),('store',57,'node',1),('store',58,'node',1),('store',59,'node',0.945829),('store',60,'node',1.95723),('store',61,'node',0.927431),('store',62,'node',1),('store',63,'node',1),('store',64,'node',1),('store',65,'node',0.938382),('store',66,'node',0.942091),('store',67,'node',0.949597),('store',68,'node',1),('store',69,'node',1),('store',70,'node',1),('store',71,'node',0.740689),('store',72,'node',1),('store',73,'node',1),('store',74,'node',0.876337),('store',75,'node',0.957226),('store',76,'node',1.75725),('store',77,'node',2),('store',78,'node',1),('store',79,'node',0.902857),('store',80,'node',0.931053),('store',81,'node',0.968904),('store',82,'node',0.98493),('store',83,'node',0.96498),('store',84,'node',0.879565),('store',85,'node',0.923838),('store',86,'node',0.839384),('store',88,'node',0.752312),('store',89,'node',0.860547),('store',90,'node',1),('store',91,'node',1),('store',92,'node',0.819249),('store',93,'node',1),('store',94,'node',1),('store',95,'node',1),('store',96,'node',1),('store',97,'node',1),('store',138,'node',0.934703),('store',139,'node',1),('stored',24,'node',0.499853),('stored',51,'node',1),('stored',60,'node',1),('stores',76,'node',1),('storing',24,'node',0.43709),('storing',32,'node',1),('storing',60,'node',1),('straightforward',58,'node',1),('strap',30,'node',1),('strap',67,'node',53.3365),('straps',31,'node',0.909743),('straps',33,'node',1),('stream',73,'node',1),('stream',76,'node',2),('stream',94,'node',1),('streaming',76,'node',0.869951),('streaming',81,'node',1),('streaming',94,'node',1),('streamlined',44,'node',1),('streamlining',82,'node',1),('strength',52,'node',1),('strict',40,'node',1),('striking',48,'node',1),('strips',31,'node',0.972861),('stroller',97,'node',1),('struggle',75,'node',1),('studio',73,'node',52),('stunner',61,'node',0.886095),('stunning',52,'node',5),('stunning',84,'node',1),('stunning',86,'node',1),('stunning',89,'node',1),('style',31,'node',1),('style',32,'node',1),('style',47,'node',2),('style',53,'node',1),('style',54,'node',5),('style',56,'node',1),('style',58,'node',1),('style',65,'node',4),('style',66,'node',4),('style',67,'node',3),('style',68,'node',1),('style',70,'node',1),('styled',64,'node',1),('styles',64,'node',1),('styles',65,'node',1),('styles',66,'node',1),('styles',84,'node',0.98493),('styling',71,'node',1),('stylish',32,'node',1),('stylish',67,'node',1),('stylish',82,'node',2),('stylishly',82,'node',1),('stylishly',88,'node',1),('stylus',45,'node',1.64708),('stylus',51,'node',5),('su433faasxlfanmy908796',69,'node',1),('sub',74,'node',0.916736),('subject',24,'node',0.460161),('subject',86,'node',0.957226),('submariner',68,'node',57),('submariner',118,'node',11),('submariner',136,'node',11),('submit',24,'node',3.6726),('submitted',24,'node',1.37777),('submitted',52,'node',0.797402),('subscribed',24,'node',0.514686),('subscription',26,'node',2.77465),('subscription',76,'node',0.845322),('subscriptions',26,'node',1),('subsequently',24,'node',0.938382),('substantial',24,'node',0.462781),('subtle',52,'node',0.993146),('subtle',58,'node',1),('subtle',73,'node',1),('subwoofer',74,'node',1),('successful',27,'node',1),('such',24,'node',1.5829),('such',30,'node',1),('such',59,'node',1),('such',72,'node',1),('such',81,'node',2),('such',94,'node',1),('such',138,'node',1),('suck',31,'node',1),('suction',38,'node',4),('sudan',28,'node',1.20647),('sufficiency',24,'node',0.384332),('sufficient',45,'node',0.942091),('suggestions',24,'node',1),('suit',63,'node',1),('suit',65,'node',1),('suit',66,'node',1),('suit',72,'node',1),('suit',83,'node',1),('suitable',30,'node',0.972861),('suitable',40,'node',1),('suitable',47,'node',1),('suitable',64,'node',2),('suitable',70,'node',1),('sun',97,'node',1),('sunday',27,'node',1.75881),('sunglasses',63,'node',1),('sunglasses',64,'node',1),('sunlight',49,'node',1),('sunny',89,'node',1),('sunshine',63,'node',1),('sunshine',64,'node',1),('super',31,'node',0.902857),('super',45,'node',2.45934),('super',84,'node',0.833529),('super',89,'node',1),('super',93,'node',1),('superb',50,'node',1),('superb',73,'node',1),('superduper',60,'node',1),('superior',30,'node',1),('superior',33,'node',1),('superior',72,'node',1),('superior',73,'node',1),('superior',89,'node',0.997306),('supplements',106,'node',37),('supplied',45,'node',0.923838),('supplier',24,'node',0.757065),('supplier',35,'node',1),('supplier',36,'node',1),('supplier',55,'node',1),('supply',60,'node',1),('support',24,'node',0.754681),('support',27,'node',0.779231),('support',30,'node',1),('support',79,'node',53.0093),('support',80,'node',0.920273),('support',83,'node',1),('support',125,'node',11),('supported',46,'node',0.892724),('supports',44,'node',0.781775),('supports',47,'node',1.96498),('supports',51,'node',1),('supports',78,'node',1),('supreme',36,'node',1),('surahs',95,'node',1),('sure',47,'node',1),('sure',65,'node',1),('sure',66,'node',1),('sure',89,'node',0.923838),('surface',33,'node',1),('surface',38,'node',1),('surface',44,'node',1),('surface',63,'node',1),('suriname',28,'node',0.600219),('surprised',65,'node',1),('surprised',66,'node',1),('surround',74,'node',0.920273),('surveillance',92,'node',0.896076),('survey',46,'node',2),('suscipit',17,'node',0.882818),('suscipit',20,'node',2),('suscipit',21,'node',1),('suscipit',143,'node',1),('suspendisse',17,'node',2.73595),('suspendisse',20,'node',1),('suspendisse',21,'node',2),('suspendisse',143,'node',1.76566),('suspicious',24,'node',0.386142),('suss010600610',69,'node',53),('suss010600610',119,'node',11),('suunto',69,'node',68),('suunto',119,'node',11),('svalbard',28,'node',0.59873),('swarovski',61,'node',51.6777),('swarovski',115,'node',11),('swaziland',28,'node',0.594307),('sweat',57,'node',1),('sweat',139,'node',1),('sweden',28,'node',0.592848),('swipe',54,'node',3.70578),('swiss',68,'node',1),('switch',42,'node',1),('switch',45,'node',0.848323),('switch',47,'node',2),('switch',78,'node',54),('switch',79,'node',51.1132),('switch',81,'node',0.957226),('switch',89,'node',1),('switch',125,'node',11),('switcher',78,'node',1),('switches',78,'node',1),('switches',79,'node',5.89608),('switches',125,'node',37),('switching',47,'node',2),('switching',51,'node',1),('switching',79,'node',3),('switzerland',28,'node',0.591395),('switzerland',67,'node',1),('swivelled',86,'node',0.972861),('swm',89,'node',1.9347),('sx60',85,'node',57.6545),('sx60',137,'node',11),('symbol',61,'node',2),('synthetic',36,'node',2),('syntheticblend',36,'node',1),('syria',28,'node',0.58995),('system',44,'node',0.693594),('system',47,'node',1),('system',54,'node',1),('system',73,'node',54),('system',74,'node',51.3858),('system',77,'node',1),('system',121,'node',11),('systems',47,'node',1.96109),('t02297lap01',8,'node',11),('t02297lap01',32,'node',50.9379),('t02297lap01',134,'node',11),('ta073faaqqfqanmy793372',34,'node',1),('ta452faal25aanmy544771',33,'node',1),('tab',55,'node',55),('table',53,'node',1),('tablet',32,'node',1),('tablet',46,'node',4.75936),('tablet',50,'node',53),('tablet',51,'node',53.4041),('tablet',96,'node',54),('tablet',99,'node',11),('tablet',111,'node',11),('tablet',112,'node',11),('tablet',135,'node',11),('tablets',50,'node',1),('tack',89,'node',0.916736),('tactile',48,'node',1),('tactile',58,'node',1),('taiwan',28,'node',0.588512),('tajikistan',28,'node',0.587082),('take',24,'node',3.36952),('take',27,'node',1),('take',33,'node',1),('take',44,'node',0.863659),('take',49,'node',1),('take',51,'node',1),('take',52,'node',1),('take',54,'node',1),('take',55,'node',1),('take',59,'node',1),('take',69,'node',1),('take',73,'node',1),('take',80,'node',1),('take',88,'node',2.94209),('take',96,'node',2),('taken',24,'node',0.923894),('taken',86,'node',0.902857),('takes',71,'node',1),('takes',82,'node',1),('taking',73,'node',1),('taking',84,'node',1),('taking',86,'node',1),('talented',32,'node',1),('tan',84,'node',1),('tanzania',28,'node',0.585658),('tap',49,'node',2),('tarantula',34,'node',63),('targus',33,'node',67),('targustsb166ap50bk',33,'node',1),('tasks',82,'node',1),('tax',16,'node',37.2883),('tax',18,'node',11.1079),('tax',19,'node',11.3877),('tax',24,'node',0.380763),('taxed',16,'node',2.81949),('taxed',18,'node',2.77879),('taxed',19,'node',2.84055),('taxes',16,'node',1.83358),('taxes',18,'node',1.79568),('taxes',19,'node',1.85866),('taxi',27,'node',1.44349),('te960faakjc3anmy515575',32,'node',0.906287),('tea',40,'node',1),('teachings',95,'node',1),('teams',73,'node',1),('tear',31,'node',1),('tech',46,'node',1),('technical',24,'node',0.36824),('technical',68,'node',1),('technical',79,'node',1.89608),('techniques',75,'node',1),('technologies',24,'node',0.437873),('technologies',26,'node',8),('technologies',61,'node',1),('technology',24,'node',0.979707),('technology',38,'node',1),('technology',43,'node',1),('technology',44,'node',0.752312),('technology',46,'node',0.96498),('technology',50,'node',2),('technology',51,'node',8),('technology',53,'node',1.97286),('technology',58,'node',1),('technology',67,'node',1),('technology',69,'node',1),('technology',86,'node',1),('technology',89,'node',1),('technology',92,'node',0.882818),('tee',62,'node',1),('telephone',28,'node',0.538701),('telephone',47,'node',1),('televisions',120,'node',37),('tell',75,'node',1),('tellus',17,'node',3.75287),('tellus',18,'node',0.866793),('tellus',20,'node',5.94602),('tellus',33,'node',0.957226),('tellus',143,'node',1.85489),('temperature',42,'node',1),('temperature',69,'node',1),('tempor',17,'node',0.945829),('tempor',18,'node',0.740689),('tempor',20,'node',3.98087),('tempor',23,'node',3),('tempor',37,'node',2),('tempor',143,'node',0.896076),('tempus',17,'node',2.92027),('tempus',20,'node',1),('tempus',21,'node',2),('tempus',23,'node',1),('tempus',37,'node',1),('tempus',143,'node',1),('tens',96,'node',1),('terminus',8,'node',11),('terminus',32,'node',68.7094),('terminus',134,'node',11),('terms',23,'node',26),('terms',24,'node',2.3014),('territories',28,'node',0.968904),('territory',28,'node',1.69359),('text',18,'node',22.5622),('text',24,'node',0.416977),('text',49,'node',1),('text',83,'node',1),('texture',37,'node',0.899454),('texture',71,'node',1),('textured',53,'node',1),('tft',84,'node',0.839384),('thailand',28,'node',0.584241),('than',26,'node',1),('than',43,'node',1),('than',44,'node',3.52997),('than',48,'node',0.953396),('than',49,'node',1),('than',52,'node',1),('than',57,'node',1),('than',58,'node',1),('than',71,'node',1),('than',77,'node',1),('than',85,'node',1),('than',96,'node',2),('thanks',27,'node',0.771698),('thanks',36,'node',1),('thanks',54,'node',1),('thanks',64,'node',1),('thanks',71,'node',1),('thanks',72,'node',1),('thanks',76,'node',1),('thanks',82,'node',1),('thanks',92,'node',0.989021),('that',24,'node',11.3284),('that',26,'node',1.93838),('that',27,'node',1),('that',30,'node',1),('that',32,'node',5.92027),('that',33,'node',1),('that',39,'node',1),('that',43,'node',2),('that',44,'node',3.86697),('that',45,'node',2.39815),('that',47,'node',1.86894),('that',48,'node',0.980874),('that',49,'node',3),('that',50,'node',1),('that',52,'node',1),('that',53,'node',1),('that',55,'node',1),('that',57,'node',2),('that',58,'node',1),('that',59,'node',2),('that',60,'node',3),('that',65,'node',2),('that',66,'node',2),('that',69,'node',1),('that',71,'node',2),('that',72,'node',1),('that',73,'node',2),('that',75,'node',2),('that',77,'node',5),('that',78,'node',1),('that',79,'node',1),('that',81,'node',1),('that',82,'node',1),('that',83,'node',1),('that',84,'node',1),('that',85,'node',1),('that',86,'node',3.93105),('that',88,'node',0.927431),('that',89,'node',0.938382),('that',94,'node',1),('that',138,'node',1),('that',139,'node',1),('the',13,'node',26),('the',16,'node',20.9976),('the',18,'node',17.7364),('the',19,'node',18.1493),('the',22,'node',1),('the',24,'node',65.7602),('the',26,'node',5.69186),('the',27,'node',10.5507),('the',28,'node',1.25299),('the',29,'node',1),('the',30,'node',1),('the',31,'node',8.61797),('the',32,'node',5),('the',33,'node',16),('the',36,'node',2),('the',38,'node',2),('the',39,'node',8),('the',40,'node',2),('the',41,'node',3),('the',43,'node',4),('the',44,'node',16.6601),('the',45,'node',36.5832),('the',46,'node',24.2731),('the',47,'node',8.97685),('the',48,'node',8.94176),('the',49,'node',7),('the',50,'node',6),('the',51,'node',8.98902),('the',52,'node',16.8196),('the',53,'node',9),('the',54,'node',21.9572),('the',55,'node',11),('the',56,'node',9),('the',57,'node',9),('the',58,'node',4),('the',59,'node',6),('the',60,'node',4),('the',61,'node',11.9713),('the',63,'node',13),('the',64,'node',13),('the',65,'node',9),('the',66,'node',9),('the',67,'node',9),('the',68,'node',7),('the',69,'node',8),('the',71,'node',24.0638),('the',72,'node',7),('the',73,'node',4),('the',74,'node',10),('the',75,'node',8),('the',76,'node',6.94183),('the',77,'node',6),('the',78,'node',8),('the',79,'node',8),('the',80,'node',18),('the',81,'node',7),('the',82,'node',11),('the',83,'node',2),('the',84,'node',20.911),('the',85,'node',12),('the',86,'node',12.7309),('the',88,'node',4),('the',89,'node',4.92246),('the',92,'node',13.6589),('the',94,'node',9),('the',95,'node',8),('the',97,'node',3),('the',138,'node',7),('the',139,'node',5),('theater',73,'node',1),('theater',74,'node',50.3858),('theater',76,'node',1),('theater',121,'node',11),('theatre',73,'node',52),('theatre',74,'node',1),('their',24,'node',0.389198),('their',32,'node',1),('their',46,'node',1),('their',75,'node',3),('their',84,'node',2),('their',94,'node',1),('their',95,'node',1),('their',97,'node',1),('them',18,'node',2),('them',24,'node',1.33347),('them',57,'node',1),('them',76,'node',2),('them',88,'node',2),('then',31,'node',1),('then',63,'node',1),('then',86,'node',0.899454),('there',24,'node',0.655756),('there',32,'node',2),('there',48,'node',1),('there',49,'node',1),('there',51,'node',1),('there',63,'node',1),('there',65,'node',1),('there',66,'node',1),('there',78,'node',1),('there',92,'node',0.860547),('thereafter',26,'node',0.882818),('therefore',24,'node',1.45671),('these',24,'node',1.45993),('these',88,'node',0.934703),('they',24,'node',1.42241),('they',56,'node',2),('they',65,'node',1),('they',66,'node',1),('they',71,'node',0.827757),('they',82,'node',1),('thickness',45,'node',1),('thin',52,'node',5),('thin',96,'node',2),('thing',44,'node',1),('thing',71,'node',1),('think',24,'node',0.703756),('think',32,'node',0.938382),('thinner',44,'node',1),('thinner',52,'node',1),('thinnest',44,'node',1),('thinnestdeveloping',44,'node',1),('third',24,'node',14.4583),('thirdparty',22,'node',1),('thirty',27,'node',0.866793),('this',24,'node',2.61389),('this',30,'node',1),('this',31,'node',5.63394),('this',32,'node',3),('this',33,'node',5),('this',36,'node',1),('this',39,'node',1),('this',40,'node',2),('this',42,'node',1),('this',45,'node',3.58815),('this',48,'node',1),('this',54,'node',1),('this',58,'node',1),('this',59,'node',1),('this',60,'node',2),('this',62,'node',2),('this',63,'node',2),('this',64,'node',1),('this',68,'node',1),('this',73,'node',4),('this',74,'node',3),('this',75,'node',3),('this',78,'node',1),('this',80,'node',1),('this',81,'node',1),('this',82,'node',2),('this',86,'node',1),('this',88,'node',2),('this',89,'node',2),('this',92,'node',0.98493),('thompson',26,'node',8),('those',24,'node',1.46315),('those',30,'node',1),('those',50,'node',1),('those',61,'node',1),('those',77,'node',1),('those',80,'node',1),('those',88,'node',1),('though',45,'node',1),('though',73,'node',1),('thousands',96,'node',1),('threat',24,'node',0.648686),('three',42,'node',1),('three',78,'node',1),('three',91,'node',1),('threeport',78,'node',1),('thrilled',19,'node',1),('through',24,'node',5.53113),('through',30,'node',0.980874),('through',52,'node',1),('through',63,'node',1),('through',64,'node',1),('through',67,'node',1),('through',74,'node',1),('through',83,'node',1),('through',92,'node',2),('through',94,'node',1),('throughout',39,'node',1),('thumb',52,'node',0.927431),('thumping',74,'node',1),('thus',30,'node',1),('thus',38,'node',1),('thus',61,'node',1),('till',32,'node',0.931053),('tilt',85,'node',1),('tilt',92,'node',49.6176),('tilt',132,'node',11),('tilts',84,'node',4.82776),('time',16,'node',1),('time',24,'node',5.30625),('time',31,'node',1),('time',50,'node',1),('time',52,'node',1),('time',54,'node',1.85746),('time',65,'node',2),('time',66,'node',2),('time',67,'node',2),('time',70,'node',54),('time',75,'node',3.90974),('time',81,'node',1),('time',83,'node',0.934703),('time',97,'node',1),('time',138,'node',1),('timelapse',44,'node',0.819249),('timeless',67,'node',1),('timepiece',67,'node',1),('timepiece',68,'node',1),('times',24,'node',0.421281),('times',49,'node',2),('times',60,'node',1),('timorleste',28,'node',0.582831),('tincidunt',17,'node',7.58082),('tincidunt',20,'node',4),('tincidunt',21,'node',3),('tincidunt',23,'node',3.98493),('tincidunt',37,'node',3),('tincidunt',143,'node',1.91473),('tk512spala1fanmy557274',139,'node',1),('tko',139,'node',63),('tlm5250',80,'node',0.968904),('tlwdr4300',81,'node',57.8218),('tlwdr4300',126,'node',11),('tobacco',91,'node',2),('tobago',28,'node',0.575885),('today',22,'node',1),('today',47,'node',0.873132),('today',60,'node',1),('today',67,'node',1),('together',61,'node',1),('togo',28,'node',0.581429),('tokelau',28,'node',0.580033),('tome',28,'node',0.636679),('tone',43,'node',1),('tone',75,'node',1),('tone',84,'node',3),('tones',38,'node',1),('tones',57,'node',1),('tones',74,'node',1),('tonga',28,'node',0.578643),('tonific',43,'node',62),('too',44,'node',0.802752),('too',48,'node',2),('too',138,'node',1),('took',86,'node',0.920273),('tool',60,'node',1),('tools',22,'node',23),('tools',26,'node',1),('tools',78,'node',2),('tools',105,'node',37),('top',59,'node',54.3981),('top',73,'node',1),('top',114,'node',11),('top',139,'node',1),('topic',16,'node',1),('topic',18,'node',1),('topic',19,'node',1),('toprated',75,'node',1),('tops',80,'node',1),('tortor',17,'node',1.92027),('tortor',20,'node',1.95723),('tortor',21,'node',1),('tortor',23,'node',1),('tortor',37,'node',1),('tortor',143,'node',4.73753),('total',16,'node',1.84445),('total',18,'node',1.80613),('total',19,'node',1.86987),('total',71,'node',1),('total',79,'node',1),('touch',44,'node',1.75231),('touch',47,'node',1),('touch',48,'node',1),('touch',51,'node',0.902857),('touch',58,'node',2),('touch',76,'node',1),('touch',82,'node',1),('touch',88,'node',1),('touchrejection',52,'node',0.938382),('touchwiz',45,'node',4.63826),('tough',30,'node',4),('tough',67,'node',1),('toughness',30,'node',1),('towel',34,'node',1),('town',31,'node',0.863659),('town',67,'node',1),('town',71,'node',1),('toys',27,'node',1),('toys',95,'node',11),('toys',98,'node',37),('tp481elajqboanmy468439',81,'node',1),('tp481elakvc0anmy535125',80,'node',0.976851),('tplink',80,'node',52.8879),('tplink',81,'node',55.8218),('tplink',126,'node',11),('tpu',53,'node',5),('tr626elampm1anmy645445',94,'node',1),('track',27,'node',1),('track',31,'node',1),('tracking',27,'node',1),('tracks',47,'node',1),('tradition',46,'node',1),('traditional',33,'node',1),('traditional',57,'node',1),('traditional',81,'node',1),('trail',31,'node',1),('transaction',24,'node',0.62674),('transaction',27,'node',1),('transactions',24,'node',0.738408),('transfer',24,'node',1.8861),('transfer',47,'node',0.949597),('transfer',48,'node',1),('transferring',24,'node',0.601716),('transfers',16,'node',1),('transfers',18,'node',1),('transfers',19,'node',1),('transfers',26,'node',13),('transform',88,'node',0.920273),('transformer',46,'node',50.5965),('transformer',124,'node',11),('transforms',46,'node',1),('transforms',49,'node',1),('transition',44,'node',1),('transmission',46,'node',0.909743),('transmission',75,'node',1),('transmission',89,'node',1),('transporter',97,'node',53),('transporter',100,'node',11),('travel',27,'node',1),('travel',31,'node',1),('travel',32,'node',1),('travel',35,'node',52),('travel',36,'node',2),('travel',39,'node',108),('travel',87,'node',22),('travel',89,'node',1),('travel',102,'node',11),('traveling',30,'node',1),('travellers',30,'node',0.957226),('travelling',60,'node',1),('travelling',80,'node',0.989021),('travels',69,'node',1),('treat',24,'node',0.512513),('treatment',39,'node',16),('trek',94,'node',63),('trek',133,'node',11),('trend',56,'node',1),('trend',64,'node',1),('trend',65,'node',0.993146),('trend',66,'node',1),('trend',69,'node',1),('trendiest',65,'node',1),('trendiest',66,'node',1),('trendy',31,'node',0.873132),('trendy',37,'node',0.906287),('trendz',61,'node',69.2757),('trendz',115,'node',11),('trial',26,'node',0.909743),('tribal',62,'node',53),('trigger',92,'node',1),('trillion',24,'node',0.480114),('trinidad',28,'node',0.577261),('tristique',17,'node',1.92027),('tristique',20,'node',1),('tristique',21,'node',2),('tristique',23,'node',1),('tristique',37,'node',1),('tristique',143,'node',2.84099),('trolley',32,'node',1),('truck',26,'node',4),('truly',32,'node',1),('truly',33,'node',1),('truly',55,'node',1),('trust',24,'node',1),('trust',26,'node',1),('trusted',26,'node',1),('try',84,'node',0.980874),('trying',139,'node',1),('tsb166ap',33,'node',52),('tue',52,'node',0.792123),('tunewiki',48,'node',1),('tunisia',28,'node',0.574516),('turbo',42,'node',1),('turkey',28,'node',0.573154),('turkmenistan',28,'node',0.571798),('turks',28,'node',0.570448),('turn',45,'node',0.845322),('turn',74,'node',1),('turn',89,'node',1),('turpis',17,'node',3.91323),('turpis',20,'node',0.976851),('turpis',23,'node',3),('turpis',37,'node',2),('turpis',143,'node',2.80666),('tuvalu',28,'node',0.567769),('tvs',71,'node',1),('tvs',78,'node',1),('twice',71,'node',1),('twist',41,'node',1),('twitter',48,'node',1),('two',30,'node',1),('two',61,'node',5),('two',64,'node',1),('two',78,'node',1),('twohanded',45,'node',1),('type',16,'node',1),('type',18,'node',1),('type',19,'node',1),('type',24,'node',0.42791),('type',35,'node',1),('type',41,'node',1),('type',55,'node',1),('type',58,'node',1.96109),('type',68,'node',2),('type',70,'node',1),('type',84,'node',0.845322),('types',16,'node',1),('types',18,'node',1),('types',19,'node',1),('types',39,'node',1),('types',40,'node',2),('types',89,'node',0.957226),('typically',24,'node',0.415562),('u961',91,'node',1),('u961a',91,'node',52),('u961a',130,'node',11),('u961a',140,'node',11),('ua40h5008arxxm',71,'node',46.4456),('uganda',28,'node',0.566439),('ukraine',28,'node',0.565115),('ullamcorper',17,'node',3),('ullamcorper',18,'node',1.47545),('ullamcorper',20,'node',1),('ullamcorper',21,'node',1),('ullamcorper',23,'node',2),('ullamcorper',37,'node',1),('ullamcorper',143,'node',1.88282),('ultimate',31,'node',0.896076),('ultimate',56,'node',1),('ultra',96,'node',1),('ultrafast',52,'node',0.830633),('ultrafresh',39,'node',1),('ultramodern',71,'node',1),('ultraportable',88,'node',1),('ultraportable',94,'node',1),('ultrices',20,'node',2.95793),('ultrices',21,'node',1),('ultrices',23,'node',1),('ultrices',37,'node',1),('ultrices',143,'node',1.93153),('ultricies',17,'node',5.68013),('ultricies',20,'node',1),('ultricies',21,'node',2),('ultricies',23,'node',1),('ultricies',37,'node',1),('ultricies',143,'node',1.96109),('unauthorized',24,'node',1.61695),('unbelievably',52,'node',1),('unbundled',16,'node',1.89467),('unbundled',18,'node',1.85438),('unbundled',19,'node',1.92027),('uncovers',71,'node',0.842342),('under',24,'node',1.88653),('under',80,'node',1),('underbelly',31,'node',0.976851),('undergo',61,'node',1),('undergoes',61,'node',2),('understand',24,'node',0.40128),('undertake',24,'node',0.513597),('unexpected',84,'node',4.94209),('unibody',52,'node',1),('unique',24,'node',0.474499),('unique',43,'node',1),('unique',61,'node',1),('unique',64,'node',1),('unique',71,'node',1),('unique',139,'node',1),('unison',44,'node',1),('united',28,'node',2.23957),('universal',56,'node',52),('universal',60,'node',52.7145),('universal',108,'node',11),('unleash',138,'node',4),('unless',24,'node',1),('unless',45,'node',1),('unless',54,'node',1),('unless',61,'node',1),('unlike',57,'node',1),('unlike',74,'node',1),('unmatched',139,'node',1),('unsatisfied',74,'node',1),('unsubscribe',24,'node',1.34451),('unsurpassed',83,'node',4),('until',27,'node',1),('update',24,'node',2.22342),('update',65,'node',1),('update',66,'node',1),('update',77,'node',2),('updated',45,'node',0.889397),('updated',89,'node',1),('updates',24,'node',0.545988),('updating',24,'node',8.79531),('upgrade',45,'node',0.866793),('uplinks',79,'node',1),('upload',26,'node',17),('upload',54,'node',0.976851),('upon',27,'node',0.889397),('upright',51,'node',1),('upright',82,'node',4),('upto8mp',51,'node',1),('urna',17,'node',1.94209),('urna',20,'node',1),('urna',21,'node',3),('urna',23,'node',2),('urna',37,'node',2),('urna',143,'node',3.73083),('uruguay',28,'node',0.554747),('usa',46,'node',1),('usage',80,'node',2),('usb',59,'node',1),('usb',60,'node',1.9496),('usb',71,'node',4.77978),('usb',74,'node',0.997306),('usb',80,'node',1),('usb',81,'node',2),('usb',82,'node',2.9496),('usb',94,'node',2),('usd',22,'node',4),('usd',26,'node',4),('use',16,'node',2.81949),('use',18,'node',2.77879),('use',19,'node',2.84055),('use',24,'node',26.2701),('use',26,'node',1),('use',32,'node',1),('use',38,'node',1),('use',39,'node',1),('use',41,'node',53),('use',44,'node',0.736141),('use',46,'node',1),('use',48,'node',1.97286),('use',51,'node',2),('use',54,'node',1),('use',59,'node',1),('use',60,'node',1),('use',75,'node',0.892724),('use',82,'node',1),('use',86,'node',0.993146),('use',96,'node',1),('use',97,'node',1),('use',106,'node',11),('used',24,'node',1.36866),('used',39,'node',1),('used',59,'node',1),('used',78,'node',2),('used',88,'node',1),('used',97,'node',1),('useful',24,'node',1.10491),('useful',59,'node',4),('user',24,'node',1.3923),('user',30,'node',1),('user',33,'node',1),('username',24,'node',1.01648),('users',24,'node',2.21766),('users',33,'node',1),('users',46,'node',1),('users',51,'node',1),('users',81,'node',3),('users',84,'node',1),('users',94,'node',1),('uses',24,'node',0.489781),('uses',51,'node',2),('uses',75,'node',1),('uses',81,'node',1),('using',16,'node',3.81949),('using',18,'node',3.77879),('using',19,'node',3.84055),('using',24,'node',1.99504),('using',26,'node',1),('using',45,'node',2.53281),('using',52,'node',0.942091),('using',71,'node',0.879565),('using',76,'node',1),('using',81,'node',2),('using',88,'node',1),('usual',64,'node',1),('usually',41,'node',1),('usually',45,'node',1),('utilise',81,'node',1),('utilizing',85,'node',1),('utmost',27,'node',1),('uvcoated',53,'node',1),('uzbekistan',28,'node',0.553478),('v30',75,'node',0.938382),('v33',83,'node',52.8218),('v39',83,'node',5),('value',46,'node',1),('value',50,'node',1),('value',65,'node',0.997306),('value',66,'node',1),('vanuatu',28,'node',0.552215),('variangle',86,'node',1),('variety',16,'node',2),('variety',18,'node',1),('variety',19,'node',1),('variety',71,'node',0.784336),('variety',84,'node',1),('variety',92,'node',0.927431),('various',65,'node',1),('various',66,'node',1),('varius',17,'node',4.74265),('varius',20,'node',1),('varius',23,'node',3),('varius',37,'node',2),('varius',143,'node',1.90629),('vast',86,'node',1),('vatican',28,'node',0.550958),('vcd',74,'node',0.860547),('vector',69,'node',57),('vector',119,'node',11),('vegan',40,'node',1),('vehicle',55,'node',55),('vehicula',17,'node',0.876337),('vehicula',20,'node',2.98087),('vehicula',143,'node',2.89272),('vel',17,'node',6.72556),('vel',20,'node',1.98087),('vel',21,'node',2),('vel',23,'node',6.96188),('vel',37,'node',4),('vel',143,'node',5.87957),('velit',17,'node',4.8335),('velit',18,'node',0.857458),('velit',20,'node',3.94292),('velit',21,'node',1),('velit',143,'node',1),('velvety',37,'node',0.886095),('venenatis',17,'node',1.87957),('venenatis',18,'node',0.786915),('venenatis',21,'node',4),('venenatis',23,'node',0.976851),('venenatis',143,'node',0.909743),('venezuela',28,'node',0.549707),('ventures',27,'node',1.52382),('ver',35,'node',52),('ver',102,'node',11),('verde',28,'node',1),('veriface',51,'node',4),('verify',24,'node',2.45017),('versa',76,'node',1),('versatile',77,'node',2),('versatility',83,'node',5),('version',45,'node',0.816452),('vertical',82,'node',2),('very',45,'node',1),('very',77,'node',4),('very',78,'node',1),('very',80,'node',1),('very',85,'node',1),('very',95,'node',1),('very',139,'node',1),('vessels',38,'node',1),('vestibulum',17,'node',2),('vestibulum',18,'node',0.792123),('vestibulum',20,'node',1.98087),('vestibulum',21,'node',4),('vestibulum',23,'node',4),('vestibulum',37,'node',3),('vestibulum',143,'node',6.70821),('vga',94,'node',1),('via',24,'node',1.2381),('via',76,'node',1),('via',78,'node',1),('via',79,'node',1),('via',80,'node',1),('via',82,'node',1),('vibrant',51,'node',1),('vibrant',71,'node',3.53127),('vibration',75,'node',1),('vice',76,'node',1),('video',44,'node',2.46155),('video',49,'node',0.927431),('video',51,'node',1),('video',54,'node',1.84832),('video',57,'node',2),('video',76,'node',0.873132),('video',77,'node',1),('video',78,'node',1),('video',81,'node',1),('video',85,'node',4),('video',88,'node',0.733888),('video',92,'node',5.57669),('video',94,'node',2),('videomore',44,'node',0.869951),('videos',47,'node',1),('videos',76,'node',6.9689),('videos',86,'node',1),('videos',88,'node',1),('vietnam',28,'node',0.548462),('view',24,'node',1.47441),('view',54,'node',63.2913),('view',71,'node',0.913226),('view',83,'node',1),('view',86,'node',1),('view',92,'node',1),('view',93,'node',1),('view',94,'node',2),('viewed',24,'node',0.401937),('viewed',92,'node',1),('viewing',44,'node',0.989021),('viewing',47,'node',1),('viewing',51,'node',1),('viewing',52,'node',0.968904),('viewing',55,'node',1),('viewing',71,'node',2),('viewing',76,'node',1),('viewing',92,'node',0.797402),('viewing',94,'node',5),('vigilant',92,'node',0.876337),('vignetting',88,'node',0.805455),('vigorous',52,'node',1),('vimeo',76,'node',4),('vincent',28,'node',0.646943),('viral',76,'node',0.972861),('virgin',28,'node',1.56644),('virtual',73,'node',1),('virtual',77,'node',4),('virtually',77,'node',4),('virtually',89,'node',0.972861),('virus',24,'node',7.16354),('viscose',66,'node',1.93105),('vision',92,'node',0.810915),('vision',93,'node',1),('visit',24,'node',3.69513),('visiting',24,'node',0.425677),('visitors',24,'node',0.712106),('visual',74,'node',1),('visuals',77,'node',4),('vitae',17,'node',3.84528),('vitae',18,'node',2.36933),('vitae',20,'node',3.99315),('vitae',21,'node',3),('vitae',23,'node',2),('vitae',37,'node',2),('vitae',143,'node',1.95723),('vital',95,'node',1),('vitamins',138,'node',1),('vivamus',17,'node',0.906287),('vivamus',18,'node',0.805455),('vivamus',20,'node',0.972861),('vivamus',21,'node',1),('vivamus',23,'node',2.95373),('vivamus',37,'node',1),('vivamus',143,'node',2),('viverra',17,'node',1.87313),('viverra',20,'node',1),('viverra',21,'node',2),('viverra',23,'node',2),('viverra',37,'node',2),('viverra',143,'node',3.81635),('vivid',51,'node',1),('vivid',71,'node',1),('vivid',74,'node',1),('vivid',88,'node',0.848323),('vividly',71,'node',0.997306),('voice',55,'node',1),('voice',58,'node',1),('voice',79,'node',1.86498),('voiceactivated',55,'node',1),('volume',41,'node',1),('volume',52,'node',2),('volume',57,'node',1),('volume',74,'node',1.98087),('voluntarily',24,'node',1.80022),('voluntary',24,'node',0.377261),('volutpat',16,'node',0.96498),('volutpat',17,'node',2.74619),('volutpat',18,'node',1.64753),('volutpat',19,'node',0.980874),('volutpat',20,'node',1),('volutpat',23,'node',1),('volutpat',33,'node',1),('volutpat',37,'node',1),('volutpat',143,'node',4.92384),('votes',30,'node',0.920273),('votes',31,'node',0.776703),('votes',32,'node',0.886095),('votes',33,'node',1),('votes',34,'node',1),('votes',35,'node',1),('votes',36,'node',1),('votes',37,'node',0.938382),('votes',38,'node',0.968904),('votes',39,'node',1),('votes',40,'node',1),('votes',41,'node',1),('votes',42,'node',1),('votes',43,'node',1),('votes',44,'node',0.664818),('votes',45,'node',0.729424),('votes',46,'node',0.830633),('votes',47,'node',0.851346),('votes',48,'node',0.913226),('votes',49,'node',0.976851),('votes',50,'node',1),('votes',51,'node',0.942091),('votes',52,'node',0.869951),('votes',53,'node',1),('votes',54,'node',0.902857),('votes',55,'node',1),('votes',56,'node',1),('votes',57,'node',1),('votes',58,'node',1),('votes',59,'node',0.972861),('votes',60,'node',0.98493),('votes',61,'node',0.953396),('votes',62,'node',1),('votes',63,'node',1),('votes',64,'node',1),('votes',65,'node',0.96498),('votes',66,'node',0.968904),('votes',67,'node',0.976851),('votes',68,'node',1),('votes',69,'node',1),('votes',70,'node',1),('votes',71,'node',0.757065),('votes',72,'node',1),('votes',73,'node',1),('votes',74,'node',0.899454),('votes',75,'node',0.98493),('votes',76,'node',0.927431),('votes',77,'node',1),('votes',78,'node',1),('votes',79,'node',0.927431),('votes',80,'node',0.953396),('votes',81,'node',0.989021),('votes',82,'node',1),('votes',83,'node',0.993146),('votes',84,'node',0.902857),('votes',85,'node',0.949597),('votes',86,'node',0.854391),('votes',88,'node',0.769219),('votes',89,'node',0.882818),('votes',90,'node',1),('votes',91,'node',1),('votes',92,'node',0.833529),('votes',93,'node',1),('votes',94,'node',1),('votes',95,'node',1),('votes',96,'node',1),('votes',97,'node',1),('votes',138,'node',0.961087),('votes',139,'node',1),('vulputate',17,'node',1),('vulputate',18,'node',0.742984),('vulputate',21,'node',1),('vulputate',23,'node',0.96498),('vulputate',143,'node',3.71517),('waist',30,'node',1),('waiting',59,'node',1),('waive',24,'node',0.372131),('walk',63,'node',1),('walk',64,'node',1),('walks',30,'node',1),('wall',71,'node',1),('wallet',65,'node',1),('wallet',66,'node',1),('wallis',28,'node',0.547222),('wan',81,'node',1),('want',29,'node',1),('want',48,'node',3),('want',58,'node',1),('want',74,'node',1),('want',77,'node',1),('wants',19,'node',1),('wardrobe',63,'node',1),('wardrobe',65,'node',1),('wardrobe',66,'node',1),('warmth',63,'node',1),('warmth',64,'node',1),('warmup',83,'node',0.938382),('warranties',27,'node',1),('warranty',35,'node',3),('warranty',36,'node',2),('warranty',55,'node',3),('warranty',79,'node',1.89608),('was',24,'node',1),('was',44,'node',1),('was',50,'node',1),('was',54,'node',1),('was',67,'node',1),('was',68,'node',1),('washing',31,'node',0.836446),('watch',67,'node',54.3365),('watch',68,'node',56),('watch',69,'node',57),('watch',70,'node',53),('watch',71,'node',3.27699),('watch',73,'node',1),('watch',75,'node',51.7145),('watch',76,'node',2.83253),('watch',118,'node',11),('watch',119,'node',11),('watch',122,'node',11),('watch',136,'node',11),('watches',27,'node',1),('watches',67,'node',1),('watches',70,'node',1),('watching',47,'node',1),('watching',74,'node',1),('water',31,'node',48.1943),('water',39,'node',1),('water',57,'node',1),('water',67,'node',1.92743),('water',68,'node',1),('water',70,'node',4),('water',101,'node',23),('waterproof',7,'node',37),('waterproof',30,'node',2),('waterproof',36,'node',1),('waterproof',70,'node',52),('waterresistant',35,'node',52),('waterresistant',68,'node',1),('waterresistant',102,'node',11),('watts',42,'node',1),('wave',47,'node',1),('wave',89,'node',1.9347),('way',30,'node',1),('way',44,'node',1),('way',88,'node',1),('way',95,'node',1),('ways',24,'node',0.537506),('ways',26,'node',1),('wcdma',47,'node',1.96109),('wear',30,'node',1),('wear',58,'node',1),('wear',64,'node',1),('wearable',75,'node',1),('weather',30,'node',0.976851),('weather',54,'node',1.86366),('weather',69,'node',1),('web',22,'node',1),('web',24,'node',0.844705),('web',51,'node',1),('web',53,'node',1),('web',81,'node',1),('web',92,'node',1),('webcam',51,'node',5),('webpage',24,'node',0.427163),('webpatterned',53,'node',1),('website',24,'node',1.28341),('weebpal',30,'node',0.886095),('weebpal',31,'node',0.752312),('weebpal',32,'node',0.860547),('weebpal',33,'node',1),('weebpal',34,'node',1),('weebpal',77,'node',1),('weebpal',78,'node',1),('weebpal',81,'node',0.96498),('weebpal',88,'node',0.749958),('weebpal',89,'node',0.857458),('weebpal',90,'node',1),('weebpal',91,'node',1),('weebpal',92,'node',0.816452),('weebpal',93,'node',1),('weebpal',94,'node',1),('weebpal',95,'node',1),('weebpal',96,'node',1),('weebpal',97,'node',1),('weebpal',138,'node',0.931053),('weebpal',139,'node',1),('weekend',30,'node',1),('weekend',31,'node',1),('weight',30,'node',0.927431),('weight',31,'node',0.781775),('weight',32,'node',0.892724),('weight',33,'node',1),('weight',34,'node',1),('weight',35,'node',1),('weight',36,'node',1),('weight',37,'node',0.945829),('weight',38,'node',0.980874),('weight',40,'node',1),('weight',41,'node',1),('weight',42,'node',1),('weight',43,'node',1),('weight',45,'node',1),('weight',46,'node',0.836446),('weight',49,'node',0.980874),('weight',50,'node',2),('weight',51,'node',0.949597),('weight',53,'node',1),('weight',54,'node',0.909743),('weight',56,'node',1),('weight',57,'node',1),('weight',59,'node',0.98493),('weight',62,'node',1),('weight',65,'node',0.976851),('weight',72,'node',1),('weight',76,'node',0.934703),('weight',77,'node',1),('weight',89,'node',0.889397),('weight',90,'node',1),('weight',91,'node',1),('weight',92,'node',0.839384),('weight',94,'node',1),('weight',95,'node',1),('weight',96,'node',1),('weight',97,'node',1),('weight',138,'node',0.968904),('weight',139,'node',3),('well',16,'node',1.83002),('well',18,'node',1.79225),('well',19,'node',1.85498),('well',47,'node',0.945829),('well',48,'node',1),('well',50,'node',1),('well',71,'node',1),('well',85,'node',1),('wellspaced',48,'node',1),('were',24,'node',0.426419),('were',45,'node',0.839384),('were',46,'node',1),('were',71,'node',0.824901),('were',73,'node',1),('western',28,'node',0.544759),('wet',41,'node',1),('what',18,'node',22.5622),('what',44,'node',3.59988),('what',47,'node',1),('what',57,'node',1),('what',59,'node',1),('what',61,'node',1),('what',76,'node',2),('what',92,'node',1),('what',94,'node',4),('wheel',55,'node',1),('when',24,'node',5.04271),('when',26,'node',1),('when',30,'node',1),('when',44,'node',0.769219),('when',51,'node',1),('when',52,'node',1),('when',54,'node',2),('when',59,'node',3),('when',60,'node',1),('when',71,'node',1),('when',72,'node',1),('when',74,'node',2),('when',78,'node',1),('when',80,'node',0.993146),('when',81,'node',1),('when',85,'node',1),('when',88,'node',1.84524),('when',89,'node',1.9496),('when',95,'node',1),('when',139,'node',2),('whenever',24,'node',0.42866),('where',16,'node',2.81949),('where',18,'node',2.77879),('where',19,'node',2.84055),('where',24,'node',1),('where',44,'node',1),('where',52,'node',1),('where',59,'node',1),('where',60,'node',1),('where',67,'node',1),('where',80,'node',1),('where',82,'node',2),('wherever',77,'node',1),('wherever',80,'node',2),('wherever',88,'node',1),('whether',22,'node',1),('whether',24,'node',4.22467),('whether',32,'node',0.972861),('whether',49,'node',1),('whether',65,'node',1),('whether',66,'node',1),('whether',73,'node',1),('whether',77,'node',1),('whether',84,'node',1),('whether',89,'node',1),('whether',92,'node',0.863659),('which',16,'node',1.8408),('which',18,'node',1.80262),('which',19,'node',1.8661),('which',24,'node',8.28958),('which',45,'node',2.94583),('which',47,'node',1),('which',52,'node',1),('which',57,'node',1),('which',60,'node',1),('which',61,'node',2),('which',72,'node',2),('which',74,'node',1),('which',79,'node',1),('which',85,'node',1),('which',86,'node',0.976851),('which',92,'node',2),('which',94,'node',1),('while',39,'node',1),('while',44,'node',1.93838),('while',48,'node',1),('while',52,'node',0.916736),('while',59,'node',1),('while',72,'node',1),('while',78,'node',1),('while',88,'node',1),('while',89,'node',0.976851),('while',92,'node',0.997306),('white',45,'node',44.965),('white',61,'node',51.6844),('white',63,'node',53),('white',66,'node',54.1533),('white',93,'node',2),('white',110,'node',11),('white',115,'node',11),('white',117,'node',11),('whiteheads',38,'node',1),('whitened',84,'node',1),('who',24,'node',0.794901),('who',26,'node',0.993146),('who',32,'node',1),('who',45,'node',0.822065),('who',67,'node',1),('whole',59,'node',1),('whom',24,'node',0.544759),('why',88,'node',0.98493),('wide',27,'node',1),('wide',31,'node',1),('wide',63,'node',1),('wide',64,'node',1),('wide',71,'node',2.46724),('wide',86,'node',5),('wide',88,'node',1),('wide',92,'node',0.931053),('wideiphone',44,'node',0.792123),('wider',44,'node',0.993146),('wider',89,'node',1),('widest',89,'node',0.949597),('wideview',51,'node',1),('width',52,'node',1),('width',56,'node',1),('wifi',44,'node',0.76431),('wifi',46,'node',2.71968),('wifi',47,'node',0.96498),('wifi',49,'node',51.3981),('wifi',52,'node',49.4465),('wifi',76,'node',0.882818),('wifi',80,'node',54.8117),('wifi',88,'node',1),('wifi',92,'node',1),('wifi',94,'node',53),('wifi',133,'node',11),('wild',31,'node',1),('wildlife',86,'node',1),('wildness',65,'node',1),('wildness',66,'node',1),('will',16,'node',5.67132),('will',18,'node',5.59203),('will',19,'node',5.71805),('will',24,'node',10.6116),('will',26,'node',2.79114),('will',27,'node',2.84832),('will',31,'node',3.71921),('will',32,'node',1.9496),('will',36,'node',1),('will',44,'node',1),('will',45,'node',0.873132),('will',47,'node',0.916736),('will',51,'node',1),('will',52,'node',1),('will',54,'node',0.949597),('will',59,'node',1),('will',61,'node',1),('will',65,'node',1),('will',66,'node',1),('will',71,'node',1),('will',72,'node',1),('will',73,'node',5),('will',74,'node',1),('will',76,'node',1),('will',79,'node',1),('will',80,'node',1),('will',81,'node',1),('will',83,'node',1),('will',86,'node',1.81281),('will',88,'node',1),('will',89,'node',2.91674),('will',96,'node',1),('wind',63,'node',1),('wind',64,'node',1),('window',54,'node',1.87313),('windows',46,'node',12.5405),('windows',51,'node',2),('windows',77,'node',3),('windshield',55,'node',1),('windshield',56,'node',1),('wink',88,'node',6),('wipe',41,'node',1),('wire',16,'node',1),('wire',18,'node',1),('wire',19,'node',1),('wired',81,'node',1),('wireless',7,'node',37),('wireless',44,'node',0.797402),('wireless',46,'node',49.4548),('wireless',52,'node',1.82776),('wireless',58,'node',3),('wireless',75,'node',1),('wireless',76,'node',1.74947),('wireless',80,'node',1),('wireless',81,'node',57.7829),('wireless',92,'node',48.6718),('wireless',94,'node',5),('wireless',124,'node',11),('wireless',126,'node',11),('wireless',132,'node',11),('wirelessly',76,'node',3),('wirelessly',94,'node',1),('wish',24,'node',0.371011),('with',16,'node',3.81949),('with',18,'node',2.77879),('with',19,'node',3.84055),('with',22,'node',1),('with',24,'node',16.9339),('with',26,'node',3),('with',27,'node',2.85746),('with',30,'node',3),('with',31,'node',3.77919),('with',32,'node',4),('with',33,'node',3),('with',36,'node',3),('with',38,'node',4),('with',40,'node',2),('with',41,'node',1),('with',42,'node',1),('with',43,'node',4),('with',44,'node',9.56674),('with',45,'node',4.45926),('with',46,'node',8.75674),('with',47,'node',4.91155),('with',48,'node',5.9689),('with',49,'node',4.88421),('with',50,'node',2),('with',51,'node',12),('with',52,'node',6.36468),('with',53,'node',2.91838),('with',54,'node',5.83087),('with',55,'node',57),('with',56,'node',6),('with',57,'node',54),('with',58,'node',2),('with',59,'node',3),('with',60,'node',1.94583),('with',61,'node',2),('with',62,'node',1),('with',63,'node',4),('with',64,'node',3),('with',65,'node',4),('with',66,'node',4),('with',67,'node',1.93838),('with',69,'node',2),('with',71,'node',10.4293),('with',72,'node',2),('with',74,'node',4.98902),('with',75,'node',1),('with',76,'node',3),('with',77,'node',3),('with',78,'node',56),('with',79,'node',52.1064),('with',80,'node',4),('with',81,'node',1),('with',82,'node',1),('with',83,'node',7),('with',84,'node',3),('with',85,'node',3),('with',86,'node',7),('with',88,'node',6.84995),('with',89,'node',5.9347),('with',92,'node',9.84232),('with',93,'node',1),('with',94,'node',54),('with',95,'node',1),('with',96,'node',2),('with',111,'node',37),('with',125,'node',11),('with',133,'node',11),('with',138,'node',1),('with',139,'node',1),('withdraw',24,'node',1.30516),('withdrawal',24,'node',9.21416),('within',24,'node',1.62593),('within',27,'node',0.886095),('within',32,'node',1),('within',138,'node',4),('without',24,'node',1.3892),('without',31,'node',1),('without',33,'node',2),('without',38,'node',2),('without',43,'node',1),('without',44,'node',0.718502),('without',54,'node',1),('without',60,'node',2),('without',65,'node',1),('without',66,'node',1),('without',112,'node',37),('withstand',31,'node',0.839384),('withstand',80,'node',1),('women',63,'node',53),('women',115,'node',37),('won',45,'node',0.810915),('won',74,'node',1),('wooden',36,'node',1),('woofer',74,'node',0.913226),('work',32,'node',0.916736),('work',39,'node',1),('work',44,'node',0.683725),('work',59,'node',1),('work',78,'node',1),('work',88,'node',1.87127),('work',96,'node',1),('workflow',82,'node',1),('working',27,'node',1.99731),('works',26,'node',19),('world',32,'node',1),('world',44,'node',0.7017),('world',46,'node',1),('world',71,'node',1),('world',86,'node',1),('worldclass',32,'node',1),('worry',59,'node',1),('worryfree',26,'node',1),('worship',95,'node',1),('worth',30,'node',1),('worth',73,'node',1),('worthy',56,'node',1),('would',24,'node',0.929069),('would',45,'node',1.66921),('would',60,'node',1),('would',63,'node',1),('would',78,'node',1),('wow',32,'node',0.920273),('wrinkles',38,'node',1),('wrist',70,'node',1),('wrist',75,'node',51.7145),('wrist',122,'node',11),('wristband',70,'node',2),('writing',96,'node',54),('writing',99,'node',11),('wwwskinblossomcommy',40,'node',11),('x130cm',65,'node',0.920273),('x180cm',66,'node',0.927431),('x51',77,'node',3),('x5177822g',77,'node',53),('xpress',48,'node',0.968904),('year',24,'node',0.532778),('year',39,'node',1),('years',24,'node',0.923412),('yeast',138,'node',1),('yellow',65,'node',1.96498),('yellow',94,'node',52),('yellow',95,'node',52),('yellow',98,'node',11),('yellow',133,'node',11),('yemen',28,'node',0.542319),('yet',30,'node',0.916736),('yet',31,'node',0.774192),('yet',32,'node',0.882818),('yet',33,'node',1),('yet',34,'node',1),('yet',35,'node',1),('yet',36,'node',1),('yet',37,'node',0.934703),('yet',38,'node',0.96498),('yet',39,'node',1),('yet',40,'node',1),('yet',41,'node',1),('yet',42,'node',1),('yet',43,'node',1),('yet',44,'node',1.66299),('yet',45,'node',1.61003),('yet',46,'node',0.827757),('yet',47,'node',4.80441),('yet',48,'node',0.909743),('yet',49,'node',1.97286),('yet',50,'node',1),('yet',51,'node',0.938382),('yet',52,'node',1.86679),('yet',53,'node',1),('yet',54,'node',0.899454),('yet',55,'node',1),('yet',56,'node',1),('yet',57,'node',1),('yet',58,'node',1),('yet',59,'node',0.968904),('yet',60,'node',0.980874),('yet',61,'node',0.949597),('yet',62,'node',1),('yet',63,'node',1),('yet',64,'node',1),('yet',65,'node',0.961087),('yet',66,'node',0.96498),('yet',67,'node',0.972861),('yet',68,'node',1),('yet',69,'node',1),('yet',70,'node',1),('yet',71,'node',0.754681),('yet',72,'node',1),('yet',73,'node',1),('yet',74,'node',0.896076),('yet',75,'node',0.980874),('yet',76,'node',0.923838),('yet',77,'node',1),('yet',78,'node',1),('yet',79,'node',0.923838),('yet',80,'node',1.9496),('yet',81,'node',0.98493),('yet',82,'node',1),('yet',83,'node',0.989021),('yet',84,'node',0.899454),('yet',85,'node',0.945829),('yet',86,'node',0.851346),('yet',88,'node',0.766757),('yet',89,'node',0.879565),('yet',90,'node',1),('yet',91,'node',1),('yet',92,'node',0.830633),('yet',93,'node',1),('yet',94,'node',1),('yet',95,'node',1),('yet',96,'node',1),('yet',97,'node',1),('yet',138,'node',0.957226),('yet',139,'node',1),('you',16,'node',2),('you',18,'node',5),('you',19,'node',4),('you',22,'node',4),('you',24,'node',52.9412),('you',26,'node',16.9572),('you',27,'node',5.75843),('you',29,'node',2),('you',30,'node',6.99315),('you',31,'node',1),('you',32,'node',2.82292),('you',38,'node',1),('you',43,'node',1),('you',44,'node',5.73397),('you',45,'node',1),('you',46,'node',1),('you',47,'node',3.88564),('you',48,'node',4.92702),('you',49,'node',1),('you',50,'node',1),('you',51,'node',4.99731),('you',52,'node',5.82297),('you',54,'node',2.93453),('you',55,'node',1),('you',56,'node',1),('you',57,'node',3),('you',58,'node',4),('you',59,'node',5),('you',60,'node',4),('you',61,'node',1),('you',63,'node',2),('you',64,'node',1),('you',65,'node',8),('you',66,'node',8),('you',71,'node',6.55687),('you',72,'node',2),('you',73,'node',5),('you',74,'node',7),('you',75,'node',4),('you',76,'node',6),('you',77,'node',3),('you',79,'node',1),('you',80,'node',5),('you',82,'node',7),('you',83,'node',1),('you',84,'node',11.923),('you',86,'node',3.8775),('you',88,'node',3.84132),('you',89,'node',2.92743),('you',92,'node',9.60848),('you',94,'node',2),('you',96,'node',2),('you',97,'node',2),('you',139,'node',1),('young',95,'node',1),('your',16,'node',9.49454),('your',18,'node',11.3744),('your',19,'node',10.5625),('your',22,'node',4),('your',24,'node',73.7916),('your',26,'node',30.8235),('your',27,'node',10.9452),('your',30,'node',3),('your',31,'node',9.8533),('your',32,'node',1),('your',33,'node',1),('your',38,'node',5),('your',39,'node',6),('your',41,'node',1),('your',43,'node',2),('your',44,'node',3.95745),('your',47,'node',2.87957),('your',48,'node',3),('your',51,'node',4),('your',52,'node',4.68463),('your',53,'node',2),('your',54,'node',5.97286),('your',55,'node',4),('your',56,'node',1),('your',58,'node',4),('your',59,'node',7),('your',60,'node',4),('your',62,'node',1),('your',63,'node',4),('your',64,'node',1),('your',65,'node',6),('your',66,'node',6),('your',67,'node',1),('your',71,'node',9.38529),('your',72,'node',1),('your',73,'node',5),('your',74,'node',11),('your',75,'node',2),('your',76,'node',20),('your',77,'node',1),('your',78,'node',3),('your',79,'node',1),('your',81,'node',1),('your',82,'node',3),('your',83,'node',6),('your',84,'node',2.90336),('your',85,'node',1),('your',86,'node',1),('your',88,'node',7.74472),('your',89,'node',1.91674),('your',92,'node',4.89608),('your',94,'node',5),('your',95,'node',1),('your',138,'node',5),('your',139,'node',2),('yours',47,'node',0.876337),('yourself',26,'node',1),('yourself',56,'node',4),('yourself',59,'node',1),('yourself',63,'node',1),('yourself',64,'node',1),('yourself',73,'node',1),('youthful',63,'node',1),('youthful',64,'node',1),('youtube',76,'node',4),('z121l',91,'node',52),('z121l',130,'node',11),('z121l',140,'node',11),('z123l',91,'node',52),('z123l',130,'node',11),('z123l',140,'node',11),('z125l',91,'node',52),('z125l',130,'node',11),('z125l',140,'node',11),('z3740',51,'node',0.899454),('zalora',27,'node',0.754681),('zambia',28,'node',0.541108),('zealand',28,'node',0.725015),('zebra',66,'node',53.1915),('zebra',117,'node',11),('zero',83,'node',0.942091),('zimbabwe',28,'node',0.539902),('zipdown',33,'node',1),('zipped',31,'node',1),('zippered',30,'node',1),('zippered',34,'node',2),('zoom',71,'node',0.927431),('zoom',85,'node',0.909743),('zoom',86,'node',0.827757),('zoom',92,'node',4.78994),('zoom1',84,'node',0.863659),('zoom4x',84,'node',0.866793),('zoomed',86,'node',1),('zooming',88,'node',0.797402),('zpro',91,'node',1);
/*!40000 ALTER TABLE `search_index` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_node_links`
--

DROP TABLE IF EXISTS `search_node_links`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_node_links` (
  `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The search_dataset.sid of the searchable item containing the link to the node.',
  `type` varchar(16) NOT NULL DEFAULT '' COMMENT 'The search_dataset.type of the searchable item containing the link to the node.',
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid that this item links to.',
  `caption` longtext COMMENT 'The text used to link to the node.nid.',
  PRIMARY KEY (`sid`,`type`,`nid`),
  KEY `nid` (`nid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores items (like nodes) that link to other nodes, used...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_node_links`
--

LOCK TABLES `search_node_links` WRITE;
/*!40000 ALTER TABLE `search_node_links` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `search_node_links` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_total`
--

DROP TABLE IF EXISTS `search_total`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_total` (
  `word` varchar(50) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique word in the search index.',
  `count` float DEFAULT NULL COMMENT 'The count of the word in the index using Zipf’s law to equalize the probability distribution.',
  PRIMARY KEY (`word`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores search totals for words.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_total`
--

LOCK TABLES `search_total` WRITE;
/*!40000 ALTER TABLE `search_total` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `search_total` VALUES ('0187kg',0.30103),('01kg',0.30103),('033inches',0.30103),('03h',0.176091),('08mm',0.30103),('1',0.00646583),('10',0.00654667),('100',0.0490443),('1000',0.100548),('10000',0.176091),('100000',0.131617),('101001000mbps',0.176091),('10100baset',0.30103),('10400mah',0.00659669),('105',0.00663058),('107',0.187253),('10700',0.30103),('1075',0.30103),('1080',0.197965),('1080p',0.0725746),('10gbe',0.00704888),('10secs',0.30103),('10x',0.134511),('10x10x10',0.30103),('11',0.100108),('110l',0.176091),('114060',0.00567713),('1143',0.30103),('114x114x125',0.30103),('115',0.30103),('11500',0.30103),('119',0.30103),('11900',0.176091),('119900',0.30103),('12',0.081013),('12000',0.30103),('12092014',0.30103),('121l',0.30103),('1224',0.176091),('123l',0.30103),('12500',0.30103),('125l',0.30103),('1276',0.30103),('12800',0.30103),('1280x800',0.09691),('128bit',0.30103),('128gb',0.30103),('12900',0.30103),('129900',0.0813328),('12x12x12',0.30103),('13',0.0680824),('13000',0.30103),('130cm',0.30103),('132',0.30103),('133',0.30103),('133in',0.0377886),('135',0.176091),('13900',0.30103),('13cm',0.30103),('13ghz',0.190715),('13mp',0.30103),('13x10x45',0.30103),('14',0.127485),('142',0.30103),('1422',0.30103),('1440',0.30103),('145',0.30103),('14500',0.30103),('14900',0.179531),('149900',0.196086),('15',0.126931),('15000',0.30103),('153',0.30103),('1535',0.199379),('15422',0.00791331),('1546',0.30103),('155',0.30103),('15500',0.30103),('156in',0.00768683),('158g',0.30103),('15900',0.30103),('159900',0.30103),('15cm',0.30103),('15g',0.30103),('15ml',0.00683942),('15x15x15',0.30103),('16',0.00877519),('16001800',0.30103),('160x120',0.30103),('161',0.30103),('161mp',0.0068821),('161mp125x',0.30103),('163kg',0.30103),('165',0.30103),('168',0.30103),('1695',0.30103),('16gb',0.00465739),('16ohm',0.30103),('17',0.0978324),('17000',0.30103),('1705cm',0.30103),('176',0.176091),('17900',0.197147),('17cm',0.30103),('17x15x10',0.30103),('18',0.0555732),('180',0.178078),('1800',0.124939),('1800w',0.00673338),('180degree',0.30103),('180megapixel',0.09691),('180mp',0.30103),('18200mm',0.00683942),('1837',0.30103),('184',0.00734908),('184inch',0.17689),('1855mm',0.00727306),('186ghz',0.30103),('18900',0.30103),('18g',0.00812912),('18k',0.30103),('18megapixel',0.176091),('18mp',0.00727306),('19',0.30103),('1920',0.135381),('1953',0.30103),('196x1086x674',0.30103),('197',0.30103),('1970',0.30103),('1990',0.30103),('19900',0.13092),('1click',0.30103),('1group',0.30103),('1pc',0.09691),('1piece',0.30103),('1xpower',0.30103),('2',0.00250557),('20',0.00603964),('200',0.132487),('2000',0.177189),('20000mah',0.00801778),('2000mah',0.181785),('2012',0.30103),('2014',0.30103),('203500',0.30103),('205',0.30103),('205mp',0.00914344),('206',0.00786548),('20cm',0.30103),('20g',0.0791812),('20m',0.30103),('20x20x20',0.30103),('21',0.131398),('210',0.00673338),('211365mm',0.30103),('215',0.30103),('216',0.30103),('216mbps',0.30103),('21900',0.30103),('21a',0.30103),('22',0.177189),('220v',0.30103),('223',0.30103),('225',0.30103),('225mm',0.30103),('228',0.30103),('22cm',0.30103),('23',0.0529752),('2300',0.30103),('2330',0.30103),('236',0.30103),('23800',0.30103),('23inch',0.30103),('24',0.00618984),('240',0.30103),('2400',0.30103),('2448',0.177392),('24ghz',0.068865),('24leds',0.30103),('24piece',0.00811789),('24x',0.184111),('25',0.10046),('25000',0.30103),('250mah',0.30103),('2560',0.30103),('25900',0.30103),('25x23x19',0.30103),('26',0.0791812),('26010337991385',0.30103),('2603',0.30103),('260500059912717',0.30103),('26400',0.30103),('264ppi',0.30103),('265mb',0.30103),('27',0.18123),('2700',0.30103),('27cm',0.30103),('28',0.30103),('285',0.30103),('28l',0.00715561),('29',0.30103),('2900',0.176091),('29900',0.101844),('299900',0.30103),('2gb',0.140855),('2ml',0.30103),('2mp',0.189764),('2mpcamera',0.30103),('2tb',0.30103),('3',0.0036231),('30',0.00623391),('300',0.0856389),('3000',0.30103),('300dpi',0.30103),('300mbps',0.124939),('30day',0.30103),('30fps',0.30103),('30inch',0.30103),('30m',0.00796893),('30ml',0.176091),('31',0.20089),('315',0.30103),('31800',0.30103),('32',0.189764),('3200',0.30103),('320x240',0.30103),('32gb',0.00758517),('330',0.30103),('33000',0.30103),('33x15x40',0.30103),('34',0.30103),('34900',0.130698),('35',0.0981008),('3500',0.179818),('3556',0.00683942),('35mm',0.30103),('360',0.00673338),('365',0.30103),('367',0.30103),('36700',0.30103),('36900',0.30103),('36mm',0.176091),('37',0.30103),('3746',0.30103),('37700',0.30103),('38',0.129075),('3800',0.186253),('381',0.30103),('386',0.30103),('388',0.30103),('39',0.30103),('3900',0.12826),('396',0.0069061),('39900',0.127794),('3999',0.30103),('39ghz',0.30103),('3gb',0.30103),('3group',0.30103),('3inch',0.0669468),('3ohm',0.30103),('3rd',0.30103),('3x14x15',0.30103),('4',0.00145988),('40',0.0836313),('400',0.0427638),('4000',0.30103),('404page',0.0163904),('40cm',0.30103),('40gbps',0.30103),('40x45x30',0.30103),('4100',0.30103),('41800',0.30103),('42',0.30103),('43',0.179244),('4300',0.178372),('432cm',0.30103),('43800',0.30103),('43cm',0.30103),('440',0.30103),('444',0.30103),('45',0.0865086),('450',0.30103),('45000',0.30103),('450mbps',0.0979327),('456',0.30103),('45cm',0.30103),('46',0.30103),('48',0.00624895),('4800',0.182512),('48000',0.30103),('4800dpi',0.179531),('48x',0.183467),('4900',0.30103),('49900',0.188034),('49999',0.30103),('4gb',0.0377886),('4port',0.30103),('5',0.00792211),('50',0.130443),('500',0.0158401),('5000',0.00625515),('50ml',0.0082864),('50mm',0.00797975),('51',0.133222),('510',0.30103),('512mb',0.190241),('514',0.30103),('515',0.30103),('52',0.18288),('52x18x33',0.30103),('533',0.30103),('54',0.30103),('54800',0.30103),('5500',0.124939),('5524p',0.00694272),('56',0.30103),('57inches',0.199379),('58mm',0.30103),('59',0.30103),('5900',0.176091),('59399848',0.00689816),('59900',0.105348),('5ghz',0.0685781),('5megapixel',0.30103),('5mp',0.30103),('5pcs',0.00683942),('5piece',0.00643411),('5x35x25',0.30103),('5x5x5',0.30103),('6',0.00788879),('60',0.189282),('600',0.0607458),('60000',0.30103),('600d',0.00694056),('60p',0.30103),('61',0.30103),('615',0.30103),('63g',0.30103),('640x480',0.30103),('64bit',0.192432),('64gb',0.00810866),('65x',0.30103),('67',0.176091),('68',0.187555),('68800',0.30103),('6900',0.30103),('6990',0.30103),('69900',0.30103),('6kg',0.30103),('6mm',0.124939),('6pm',0.194849),('6x2x6',0.30103),('7',0.00514688),('70',0.00756075),('700',0.124939),('7000',0.30103),('70000',0.30103),('710',0.30103),('711',0.30103),('720p',0.30103),('74900',0.30103),('75',0.185787),('7500',0.30103),('75000',0.30103),('768',0.30103),('77',0.133337),('78',0.30103),('780',0.30103),('786',0.199379),('7900',0.187541),('795',0.139924),('79900',0.130026),('7cm',0.30103),('7inch',0.30103),('7x2x12',0.30103),('8',0.00495962),('800',0.30103),('800mbps',0.30103),('801366',0.30103),('80211',0.30103),('80211a',0.142689),('80211n',0.30103),('8023az',0.30103),('805',0.30103),('81',0.30103),('816',0.30103),('85',0.103489),('8500',0.176091),('850tvl',0.00811789),('88',0.30103),('89',0.30103),('8900',0.140084),('89900',0.176091),('8am',0.193188),('8gb',0.00687332),('8x4x3',0.30103),('9',0.0597562),('90',0.30103),('90cm',0.30103),('91',0.00796893),('910',0.30103),('91x905x562',0.30103),('926',0.30103),('92mm',0.30103),('9400',0.30103),('9500',0.30103),('955',0.00796893),('9600',0.30103),('97inch',0.192583),('98',0.185791),('9900',0.0832657),('99900',0.136881),('9am',0.19452),('9mm',0.00934009),('9pm',0.193524),('a316',0.00663328),('a5x',0.180669),('aaa',0.30103),('aaaa',0.30103),('aaaaincluded',0.30103),('aberrations',0.30103),('ability',0.30103),('able',0.0607528),('about',0.00549144),('above',0.0841806),('abovementioned',0.257628),('abs',0.176091),('absorb',0.30103),('absorption',0.125929),('acai',0.30103),('accent',0.30103),('accept',0.134099),('accepts',0.124939),('access',0.0219627),('accessing',0.0405256),('accessories',0.00616031),('accessory',0.0579919),('accommodate',0.30103),('accompanying',0.30103),('accordance',0.040922),('accorded',0.30103),('according',0.176091),('account',0.030066),('accountmlbtv',0.30103),('accumsan',0.0601682),('accurate',0.137611),('accurately',0.30103),('achieve',0.30103),('acid',0.30103),('acknowledge',0.30103),('across',0.176091),('act',0.30103),('action',0.196814),('actions',0.30103),('activated',0.30103),('active',0.178954),('activity',0.30103),('actually',0.30103),('acuspheres',0.30103),('adapter',0.30103),('adapters',0.30103),('adapting',0.30103),('adaptors',0.00683942),('add',0.0631108),('added',0.178664),('addition',0.176091),('additional',0.176091),('address',0.0161903),('addresses',0.0669468),('adipiscing',0.0172183),('adjust',0.09691),('adjustable',0.0989888),('adjustment',0.30103),('admin',0.0470359),('administer',0.253407),('administrative',0.30103),('adorn',0.176091),('adrenaline',0.30103),('adults',0.30103),('advance',0.30103),('advanced',0.0272143),('advancements',0.30103),('adventure',0.30103),('adventures',0.30103),('adventurous',0.126074),('advertise',0.0248236),('advertised',0.30103),('advertiser',0.30103),('advertising',0.0299632),('ae217faapmf5anmy727141',0.30103),('aenean',0.0384513),('aeroline',0.00694329),('affiliates',0.151596),('affordable',0.127348),('afghanistan',0.30103),('africa',0.30103),('african',0.30103),('afs',0.00812912),('after',0.0430685),('afﬁliate',0.0163904),('again',0.0791812),('against',0.30103),('agc',0.124939),('age',0.124939),('agent',0.194136),('ages',0.30103),('agree',0.30103),('aiball',0.00560388),('aiballing',0.30103),('aid',0.30103),('aiming',0.30103),('aio',0.00699402),('air',0.00735489),('airgesture',0.30103),('airplay',0.0669468),('aland',0.30103),('albania',0.30103),('algeria',0.30103),('algorithm',0.191757),('alienware',0.00782534),('aliquam',0.0232827),('aliquet',0.048325),('all',0.0106307),('allinone',0.0689609),('allnatural',0.0677815),('allocate',0.30103),('allow',0.132031),('allowed',0.30103),('allowing',0.176091),('allows',0.0347621),('almost',0.178372),('along',0.176091),('along3',0.30103),('also',0.0165916),('alternative',0.176091),('alternatively',0.30103),('although',0.30103),('altimeter',0.176091),('altitude',0.176091),('aluminium',0.176091),('always',0.0421469),('amazing',0.0460926),('amazingly',0.09691),('amazon',0.30103),('amazoncom',0.182452),('american',0.30103),('amet',0.00848367),('amoled',0.199379),('amount',0.30103),('analog',0.0800286),('analogue',0.00827253),('analyse',0.30103),('analysis',0.30103),('and',0.000641526),('andorra',0.30103),('android',0.00560428),('angel',0.00683942),('angle',0.067882),('angles',0.059081),('angola',0.30103),('anguilla',0.30103),('anonymous',0.30103),('another',0.124939),('answer',0.127758),('antarctica',0.30103),('ante',0.0288487),('antennas',0.30103),('antiageing',0.30103),('antigua',0.30103),('antilles',0.30103),('antioxidant',0.30103),('antique',0.30103),('antiscratch',0.30103),('any',0.00807963),('anyone',0.147637),('anything',0.176091),('anytime',0.143762),('anyway',0.30103),('anywhere',0.0327188),('ap564elalljmanmy575572',0.30103),('ap564elalvswanmy592956',0.30103),('ap564elapeznanmy715186',0.30103),('ap564elapuhianmy741814',0.30103),('ap564elat12eanmy913520',0.30103),('apart',0.30103),('aperture',0.0981841),('app',0.083717),('appear',0.176091),('appearance',0.30103),('apple',0.00126428),('appliances',0.30103),('applicable',0.0294186),('applications',0.0669468),('applicator',0.30103),('applicatorwell',0.30103),('apply',0.182335),('applying',0.30103),('appreciate',0.30103),('appreciates',0.30103),('approach',0.30103),('approval',0.30103),('approvals',0.30103),('approve',0.30103),('approximated',0.30103),('apps',0.0797486),('apscsized',0.30103),('arab',0.30103),('arabia',0.30103),('architecture',0.133318),('archived',0.30103),('arcu',0.03019),('are',0.0079827),('area',0.080246),('areas',0.18206),('arena',0.30103),('argentina',0.30103),('arm',0.30103),('armenia',0.30103),('around',0.0669468),('arrange',0.30103),('arrangements',0.30103),('array',0.124939),('art',0.0805616),('artistic',0.30103),('arts',0.30103),('aruba',0.30103),('as575elat5hfanmy920560',0.30103),('asha',0.00847532),('asian',0.213862),('ask',0.30103),('aspects',0.176091),('aspherical',0.178078),('assist',0.30103),('association',0.30103),('assume',0.232796),('assurance',0.30103),('assured',0.30103),('asus',0.0016349),('atm',0.181508),('atom',0.183687),('attach',0.30103),('attached',0.30103),('attention',0.176091),('attractive',0.30103),('auctor',0.0332224),('audience',0.176091),('audio',0.00782534),('audit',0.30103),('augue',0.0271212),('aura',0.30103),('aus',0.00673338),('australia',0.30103),('austria',0.30103),('author',0.30103),('authorities',0.30103),('authorize',0.30103),('authorized',0.228998),('auto',0.0431864),('autofocus',0.0692817),('automatic',0.00560388),('automatically',0.0555195),('availability',0.30103),('available',0.0398779),('avoid',0.30103),('away',0.0836232),('awesome',0.30103),('azerbaijan',0.30103),('b0008',0.30103),('b00773',0.30103),('babies',0.30103),('baby',0.30103),('babylike',0.30103),('back',0.0178982),('background',0.0579919),('backlight',0.30103),('backpack',0.00163661),('backpackers',0.30103),('backpacking',0.30103),('backpacks',0.011281),('backside',0.30103),('backwards',0.30103),('bag',0.00176867),('bags',0.00568279),('bahamas',0.30103),('bahrain',0.30103),('balances',0.30103),('bamboo',0.176091),('band',0.00600512),('bands',0.30103),('bandwidthintensive',0.30103),('bangladesh',0.30103),('bank',0.00692352),('banner',0.0163904),('barbados',0.30103),('barbuda',0.30103),('barometer',0.128161),('barthélemy',0.30103),('based',0.176091),('basic',0.0115819),('basis',0.30103),('bass',0.124939),('batteries',0.0107239),('battery',0.0228016),('bdvn9200w',0.00782534),('beacons',0.30103),('beads',0.30103),('beats',0.30103),('beautiful',0.0321847),('beautifully',0.176091),('beauty',0.00935463),('because',0.124939),('becomes',0.30103),('beefed',0.30103),('been',0.0387546),('before',0.0884876),('beginning',0.184484),('behalf',0.30103),('behavior',0.30103),('being',0.201713),('bejeweled',0.30103),('belarus',0.30103),('belgium',0.30103),('believe',0.178843),('belize',0.30103),('belongings',0.30103),('beloved',0.30103),('below',0.0439606),('belt',0.00357446),('belts',0.0109954),('beneficial',0.30103),('benefit',0.30103),('benefits',0.30103),('benin',0.30103),('bermuda',0.30103),('bernie',0.0511525),('berry',0.30103),('besides',0.30103),('best',0.0382152),('better',0.0255399),('between',0.0539867),('beyond',0.30103),('bezels',0.30103),('bhutan',0.30103),('bibendum',0.0351572),('big',0.00653174),('bigger',0.0704517),('biggeriphone',0.30103),('biggest',0.203107),('bigscreen',0.30103),('bigtime',0.09691),('binding',0.30103),('bird',0.30103),('birth',0.30103),('biskeles',0.176091),('bit',0.176091),('black',0.000545087),('blackberry',0.176589),('blackhead',0.00838523),('blackheads',0.176091),('blandit',0.0529313),('blanket',0.30103),('blast',0.30103),('blazing',0.30103),('blend',0.30103),('blends',0.181508),('blockbuster',0.30103),('blocker',0.30103),('blocking',0.176091),('blogger',0.30103),('blood',0.124939),('blossom',0.0377886),('blue',0.00367203),('blueant',0.0115819),('bluebackpack',0.30103),('bluetooth',0.0025694),('blur',0.0579919),('bluray',0.00796893),('blusher',0.185692),('bo242tbapso5anmy738496',0.30103),('board',0.00683942),('boasting',0.30103),('body',0.0347621),('bokeh',0.176091),('bolivia',0.30103),('boogie',0.00582954),('books',0.011281),('boosting',0.30103),('boosts',0.30103),('boring',0.30103),('bos04088shb03',0.00827253),('bosnia',0.30103),('both',0.09691),('botswana',0.30103),('bottom',0.30103),('boundaries',0.30103),('bouvet',0.30103),('box',0.047652),('bracelet',0.00646144),('bracket',0.30103),('bracketing',0.09691),('braided',0.00811789),('braids',0.30103),('brand',0.0511525),('brands',0.30103),('bravia',0.00683942),('brazil',0.30103),('brazzaville',0.30103),('breached',0.30103),('break',0.30103),('breaking',0.30103),('breakouts',0.30103),('breakthrough',0.30103),('breathable',0.124939),('breathtaking',0.176091),('breeze',0.30103),('briefcase',0.176091),('bright',0.103489),('brightens',0.30103),('brightroom',0.30103),('brilliance',0.0579919),('brilliant',0.30103),('bring',0.0511525),('brings',0.30103),('british',0.176091),('broadband',0.30103),('broadcasting',0.30103),('broadcasts',0.30103),('broaden',0.30103),('bronzetone',0.30103),('brown',0.178664),('browse',0.176091),('browser',0.0949037),('browsers',0.30103),('browsing',0.0673516),('brunei',0.176091),('brush',0.00755314),('brushes',0.30103),('bsi',0.30103),('buckle',0.176091),('buckwheat',0.30103),('bud',0.30103),('build',0.176091),('buildup',0.30103),('built',0.30103),('builtin',0.0427249),('bulgaria',0.30103),('bulky',0.30103),('bumper',0.176091),('bumps',0.30103),('bumpy',0.30103),('bundled',0.30103),('burkina',0.30103),('burn',0.30103),('burner',0.00768683),('burundi',0.30103),('business',0.0104476),('businesses',0.30103),('busy',0.124939),('but',0.0236341),('button',0.080613),('buttons',0.0800286),('buy',0.01524),('buyers',0.208856),('buying',0.30103),('ca065hbas3ukanmy866687',0.30103),('ca673elalorhanmy581181',0.30103),('ca673elam9xuanmy618219',0.30103),('ca673elarxo5anmy857455',0.30103),('ca673elatex3anmy936277',0.30103),('ca680elapvlxanmy743566',0.30103),('cable',0.0845298),('cables',0.097149),('caicos',0.30103),('calculated',0.30103),('caledonia',0.30103),('california',0.0701967),('call',0.00539503),('caller',0.176091),('calling',0.124939),('calls',0.0598439),('calm',0.30103),('calories',0.30103),('cambodia',0.30103),('came',0.30103),('cameleon',0.00601358),('camera',0.00138605),('cameras',0.00292455),('cameroon',0.30103),('camping',0.30103),('campus',0.30103),('campusfocused',0.30103),('cắn',0.00426852),('canada',0.30103),('candlelight',0.30103),('cannot',0.30103),('canon',0.00131905),('canopy',0.30103),('capabilities',0.0716034),('capability',0.0465332),('capable',0.0472052),('capacitive',0.30103),('capacity',0.0865864),('cape',0.30103),('capture',0.0333101),('captured',0.30103),('captures',0.30103),('capturing',0.184484),('car',0.0030534),('carbohydrate',0.30103),('card',0.00816633),('cards',0.00638364),('care',0.0034252),('carefully',0.30103),('cares',0.30103),('caribbean',0.30103),('carmudi',0.30103),('carrie',0.176091),('carrier',0.0188344),('carry',0.00648668),('carrycot',0.30103),('carrying',0.176091),('cartilage',0.30103),('cartoon',0.30103),('case',0.00226755),('cases',0.00582954),('cash',0.0125891),('cashier',0.124939),('casing',0.124939),('casio',0.00612506),('casting',0.30103),('casual',0.00812897),('catalog',0.30103),('categories',0.30103),('cater',0.30103),('caught',0.30103),('cavernous',0.30103),('cayman',0.30103),('ccd',0.0377886),('cctv',0.00415596),('cdquality',0.30103),('cdr',0.30103),('cdrw',0.30103),('cell',0.30103),('cellphone',0.30103),('cells',0.124939),('center',0.30103),('central',0.30103),('certain',0.186555),('certification',0.30103),('certified',0.178954),('ch299tbas06zanmy861162',0.30103),('chad',0.30103),('chain',0.00795587),('change',0.0522274),('changed',0.30103),('changes',0.04813),('changing',0.178664),('channel',0.130563),('characteristic',0.176091),('characters',0.30103),('charge',0.0627682),('charged',0.0997335),('charger',0.0075991),('chargers',0.0115819),('charging',0.0806126),('charlotte',0.176091),('chats',0.30103),('check',0.100801),('checking',0.30103),('checkout',0.0700574),('checks',0.124939),('cheese',0.30103),('chiasso',0.30103),('chicco',0.0321847),('chicken',0.30103),('child',0.0413927),('children',0.228305),('chile',0.30103),('china',0.137792),('chip',0.0699658),('chipsets',0.30103),('chipsystem',0.30103),('choice',0.0669468),('choose',0.0422121),('chosing',0.30103),('christmas',0.30103),('cinema',0.00827253),('cinematic',0.30103),('circle',0.30103),('circles',0.176091),('circuit',0.30103),('circular',0.30103),('circulation',0.176091),('circumstances',0.294584),('cis',0.30103),('citing',0.30103),('city',0.30103),('clarity',0.0678933),('clasp',0.176091),('class',0.124939),('classic',0.00402564),('classy',0.30103),('clean',0.124939),('cleaner',0.00838523),('cleaning',0.176091),('cleans',0.176091),('cleanser',0.0669468),('cleanses',0.176091),('cleansing',0.09691),('clear',0.0283386),('clearer',0.176091),('clears',0.30103),('click',0.0834781),('climbers',0.30103),('climbs',0.30103),('clip',0.124939),('clipon',0.176091),('clock',0.09691),('close',0.148612),('closed',0.30103),('closeness',0.30103),('closeup',0.30103),('closure',0.30103),('cloth',0.176286),('clothes',0.0669468),('cloudcam',0.00733973),('cloudy',0.30103),('cmos',0.0354112),('co716elapowbanmy731726',0.30103),('coast',0.30103),('coating',0.30103),('cobblestone',0.30103),('cocos',0.30103),('code',0.00673338),('coenzyme',0.30103),('cokin',0.0050208),('cold',0.30103),('collect',0.069309),('collected',0.0486578),('collection',0.0166059),('collisionthe',0.30103),('colombia',0.30103),('color',0.00632808),('colors',0.0700144),('colour',0.0473921),('colourfast',0.30103),('colours',0.033907),('coma',0.30103),('combination',0.0791812),('combines',0.176091),('combining',0.124939),('come',0.30103),('comes',0.0300195),('comfort',0.0546641),('comfortable',0.128027),('comfortably',0.176091),('commentators',0.30103),('comments',0.13783),('commision',0.30103),('commodo',0.0429712),('commonly',0.30103),('communicate',0.273809),('communication',0.30103),('communications',0.30103),('comoros',0.30103),('compact',0.0677815),('companies',0.224141),('companion',0.30103),('company',0.0207521),('comparable',0.21206),('compare',0.30103),('compared',0.176091),('comparison',0.30103),('comparments',0.30103),('compartment',0.0413927),('compass',0.176091),('compatible',0.0531723),('compensates',0.30103),('competitive',0.30103),('complaints',0.30103),('complementary',0.30103),('complete',0.179446),('completed',0.236711),('completely',0.176091),('completing',0.30103),('complex',0.30103),('complexion',0.09691),('complicated',0.30103),('compliment',0.30103),('components',0.176091),('composed',0.30103),('composition',0.30103),('comprehensive',0.0265017),('compressed',0.30103),('compromised',0.30103),('computer',0.0365669),('computers',0.176091),('concentrated',0.30103),('concerns',0.30103),('concurrent',0.09691),('condimentum',0.0515494),('conditioned',0.30103),('conditions',0.01524),('conferences',0.30103),('confidence',0.30103),('confidentially',0.30103),('configuration',0.30103),('congo',0.176091),('congue',0.0904683),('connect',0.18123),('connected',0.0694489),('connecting',0.30103),('connection',0.0983491),('connections',0.0990666),('connectivity',0.124939),('connectors',0.30103),('connectshare',0.30103),('consectetur',0.0127284),('consent',0.0354016),('consequat',0.0434511),('consequences',0.30103),('considered',0.30103),('consistence',0.30103),('consistency',0.30103),('constantlyit',0.30103),('construction',0.176091),('consumers',0.195229),('consumption',0.176091),('contact',0.0052912),('contacted',0.30103),('contacting',0.0576073),('contain',0.30103),('containing',0.30103),('contains',0.176091),('content',0.0463138),('continual',0.30103),('continue',0.30103),('continuous',0.124939),('contour',0.30103),('contract',0.30103),('contrast',0.176091),('control',0.00654886),('controls',0.176091),('convallis',0.0395646),('convenience',0.0321847),('conveniences',0.30103),('convenient',0.0631605),('conveniently',0.09691),('conversion',0.30103),('converted',0.30103),('cook',0.30103),('cookierelated',0.30103),('cookies',0.30103),('cool',0.30103),('cooperating',0.30103),('coordinated',0.30103),('cope',0.30103),('copper',0.30103),('coprocessor',0.30103),('copy',0.176091),('coq10',0.30103),('cord',0.124939),('core',0.0299632),('cornered',0.30103),('correct',0.176091),('correction',0.30103),('cost',0.30103),('costa',0.30103),('costeffective',0.30103),('costly',0.30103),('cot',0.00673338),('cotton',0.098512),('could',0.0485152),('count',0.30103),('countries',0.30103),('country',0.196086),('coupling',0.30103),('coupons',0.0186208),('courageous',0.30103),('courier',0.30103),('course',0.30103),('cover',0.00640086),('coverage',0.0669468),('covers',0.0115819),('cpu',0.30103),('cr39',0.30103),('cradle',0.00616031),('crafted',0.30103),('craftsmanship',0.30103),('cras',0.0352616),('cream',0.00643411),('create',0.0791812),('created',0.124939),('creates',0.125036),('creating',0.0998191),('creation',0.30103),('creative',0.0978732),('creativity',0.30103),('credit',0.0119534),('crisp',0.128688),('critical',0.30103),('croatia',0.30103),('cross',0.00654949),('crown',0.176091),('crystal',0.0413927),('ct941tbam1qdanmy602711',0.30103),('cuba',0.30103),('culture',0.30103),('cum',0.30103),('cup',0.176091),('curabitur',0.067551),('curaçao',0.30103),('current',0.30103),('cursus',0.0588093),('cushion',0.30103),('cushiony',0.101496),('custom',0.188059),('customer',0.106202),('customers',0.012809),('customerservices',0.0279915),('customisable',0.0800286),('customisation',0.30103),('customization',0.30103),('customize',0.30103),('customized',0.30103),('cut',0.30103),('cutting',0.30103),('cyber',0.30103),('cyprus',0.30103),('czech',0.30103),('da883faal9qsanmy556860',0.30103),('da883faal9r7anmy556875',0.30103),('daily',0.30103),('damage',0.124939),('damaged',0.30103),('dandelion',0.00300551),('dapibus',0.0532999),('dark',0.0079796),('dashboard',0.30103),('data',0.0266957),('date',0.130795),('dates',0.30103),('day',0.0539849),('days',0.102894),('daytoday',0.176091),('dcs5222l',0.00669045),('ddr3',0.30103),('de759elap5i7anmy696915',0.30103),('de759elat5r5anmy920910',0.30103),('dead',0.124939),('dealership',0.30103),('dealings',0.30103),('deals',0.30103),('debit',0.012965),('decade',0.30103),('dedicated',0.176091),('deemed',0.30103),('deep',0.124939),('deeper',0.30103),('deepest',0.30103),('defect',0.30103),('defined',0.132732),('definitely',0.124939),('definition',0.124939),('definitive',0.176091),('degree',0.00663058),('dehydration',0.30103),('dekstop',0.00734908),('delicious',0.30103),('deliver',0.133687),('delivered',0.09691),('delivering',0.30103),('delivers',0.0591079),('delivery',0.00601517),('dell',0.00315368),('demanding',0.125337),('demographics',0.30103),('denmark',0.30103),('denote',0.30103),('departure',0.30103),('depending',0.214703),('deployment',0.30103),('deposits',0.30103),('depth',0.176091),('described',0.30103),('description',0.00648196),('design',0.00452749),('designdurable',0.30103),('designed',0.0195903),('designers',0.30103),('designs',0.176091),('desire',0.30103),('desktop',0.00490928),('desktopclass',0.30103),('desktops',0.0266343),('destination',0.30103),('destroying',0.30103),('detach',0.17689),('detachable',0.09691),('detail',0.0352713),('detailed',0.30103),('details',0.041592),('detection',0.191649),('detects',0.124939),('developed',0.30103),('device',0.0283544),('devices',0.0238262),('di503faap8lhanmy703741',0.30103),('diacut',0.30103),('dial',0.00546764),('diam',0.023171),('diameter',0.30103),('diapers',0.30103),('dictum',0.0307804),('did',0.30103),('didn',0.30103),('difference',0.177783),('different',0.0809526),('difficult',0.30103),('dig',0.30103),('digging',0.30103),('digic',0.0987526),('digital',0.00342755),('dignissim',0.0304865),('dimension',0.30103),('diniwell',0.00582954),('direction',0.18315),('directly',0.124939),('dis',0.30103),('disappearance',0.30103),('disappointing',0.30103),('disc',0.00811956),('disclose',0.17332),('disclosed',0.30103),('disclosing',0.30103),('disclosure',0.0255087),('disconnected',0.30103),('discover',0.0791812),('discrete',0.30103),('dispatched',0.30103),('disperse',0.30103),('display',0.00757622),('displayit',0.30103),('displays',0.30103),('displayunlike',0.30103),('distance',0.30103),('distortion',0.30103),('dive',0.30103),('diver',0.00821026),('diverse',0.30103),('diving',0.176091),('division',0.30103),('djibouti',0.30103),('dl746elaozrfanmy689095',0.30103),('dlink',0.00635497),('doas',0.30103),('dock',0.00796893),('document',0.30103),('documentation',0.30103),('documents',0.09691),('does',0.18301),('doesn',0.20228),('doing',0.30103),('dolor',0.010378),('dome',0.00796893),('dominica',0.30103),('dominican',0.30103),('don',0.0974153),('done',0.30103),('donec',0.0230777),('doodle',0.30103),('doors',0.30103),('doorstep',0.30103),('dose',0.30103),('dots',0.30103),('double',0.0511525),('down',0.09691),('download',0.200902),('downloading',0.30103),('downloads',0.30103),('downpours',0.30103),('dpi',0.30103),('draining',0.176091),('dramatic',0.30103),('dramatically',0.30103),('drastically',0.30103),('draw',0.176091),('draws',0.30103),('dre',0.30103),('drenches',0.30103),('dress',0.30103),('drink',0.00769881),('drive',0.19211),('driven',0.30103),('driver',0.0112913),('drives',0.30103),('driving',0.30103),('drool',0.30103),('drop',0.176091),('dropdead',0.30103),('drops',0.30103),('dryer',0.00634018),('dryness',0.30103),('dslr',0.011281),('dual',0.00241381),('dualband',0.00724012),('dualcore',0.134456),('dualport',0.00831775),('duffle',0.30103),('dui',0.0439179),('duis',0.0466665),('dull',0.30103),('duo',0.30103),('duplex',0.30103),('durability',0.30103),('durable',0.0688388),('during',0.0387442),('dvb',0.0791812),('dvbt2',0.30103),('dvd',0.00672224),('dvdvideo',0.30103),('dvr',0.30103),('dynamic',0.097822),('each',0.128027),('ear',0.176589),('earbuds',0.30103),('earbudstyle',0.30103),('early',0.30103),('earn',0.0234811),('earnings',0.30103),('earphone',0.00827253),('earpod',0.00827253),('earpods',0.124939),('ease',0.124939),('easier',0.0584738),('easiest',0.30103),('easily',0.0419369),('easy',0.01739),('easytouse',0.30103),('ebuddy',0.30103),('eclectic',0.176091),('ecommerce',0.30103),('ecuador',0.30103),('edge',0.176091),('edges',0.30103),('edit',0.176091),('edr',0.30103),('educating',0.30103),('educational',0.0115819),('effect',0.137654),('effective',0.30103),('effectively',0.30103),('effects',0.0836431),('efficiency',0.124939),('efficient',0.0978479),('efficiently',0.30103),('efficitur',0.0369799),('effort',0.30103),('effortless',0.30103),('effortlessly',0.30103),('efs',0.00683942),('egestas',0.0430968),('eget',0.020784),('egypt',0.30103),('eight',0.30103),('either',0.30103),('elastic',0.30103),('electronic',0.084321),('electronics',0.30103),('elegance',0.09691),('elegant',0.176091),('elegantly',0.30103),('eleifend',0.0533931),('element',0.00675841),('elements',0.133083),('elementum',0.0673516),('eliminates',0.30103),('elit',0.010964),('else',0.0791812),('email',0.0627511),('embarrassing',0.30103),('embedded',0.176091),('emirates',0.30103),('employs',0.30103),('enables',0.09691),('enabling',0.30103),('enclosure',0.30103),('encounter',0.0800286),('encryption',0.30103),('end',0.124939),('endeavor',0.30103),('endless',0.176091),('endlessly',0.30103),('energy',0.124939),('enforcement',0.295982),('engage',0.30103),('engaging',0.30103),('engineered',0.30103),('enhance',0.09691),('enhancement',0.30103),('enhancer',0.104481),('enhances',0.176091),('enhancing',0.178078),('enim',0.0681104),('enjoy',0.0207248),('enjoyable',0.30103),('enormously',0.30103),('enough',0.124939),('ensemble',0.30103),('ensure',0.0673497),('ensures',0.30103),('ensuring',0.30103),('enter',0.199578),('entertainment',0.0379298),('entire',0.0670605),('entirely',0.30103),('entryclass',0.30103),('environmental',0.30103),('environments',0.176091),('eos',0.00694056),('ep840elaltf7anmy589363',0.30103),('epson',0.00627183),('equatorial',0.30103),('equipment',0.30103),('equipped',0.0810545),('equivalent',0.30103),('era',0.30103),('erases',0.30103),('erat',0.0316385),('ergonomic',0.124939),('ergonomically',0.0669468),('eritrea',0.30103),('eros',0.0388661),('error',0.30103),('especially',0.102663),('essence',0.00634018),('essential',0.30103),('essentials',0.30103),('est',0.0302716),('estimate',0.0701506),('estonia',0.30103),('etc',0.30103),('eternity',0.30103),('ethernet',0.0466458),('ethiopia',0.30103),('etiam',0.0380067),('euismod',0.042318),('evaluate',0.30103),('evaluation',0.30103),('even',0.0177242),('evening',0.30103),('evenly',0.30103),('event',0.119963),('eventually',0.30103),('ever',0.0680748),('everios',0.30103),('everlasting',0.00655519),('every',0.0271936),('everyday',0.0669468),('everyone',0.30103),('everything',0.0348708),('evolution',0.30103),('exactly',0.177487),('example',0.195229),('excellent',0.124939),('except',0.0870617),('exceptional',0.138548),('exceptionally',0.30103),('excercise',0.30103),('excitement',0.080138),('exclusive',0.30103),('exclusively',0.176091),('executed',0.30103),('exemplifies',0.30103),('exercise',0.30103),('exfoliation',0.30103),('exilim',0.00712274),('exist',0.30103),('expected',0.30103),('expeditions',0.30103),('expensive',0.30103),('experience',0.0187949),('experienceget',0.30103),('explicit',0.30103),('exposure',0.127622),('express',0.30103),('expression',0.30103),('expressly',0.30103),('extender',0.30103),('extent',0.30103),('exterior',0.30103),('external',0.0935441),('extra',0.0976765),('extract',0.30103),('extreme',0.30103),('exudes',0.30103),('exzr1500',0.00690565),('eye',0.00423705),('eyebright',0.30103),('eyecatching',0.30103),('eyelash',0.30103),('eyelid',0.00663058),('eyelidline',0.30103),('eyelids',0.30103),('eyelids2',0.30103),('eyeopening',0.176091),('eyes',0.30103),('eyeshadow',0.18379),('eﬃcientbuilt',0.30103),('f28',0.30103),('f9asurtn56u',0.30103),('fabric',0.09691),('face',0.00418421),('facebook',0.30103),('faces',0.176091),('faceted',0.30103),('facetime',0.30103),('facial',0.00588529),('facilisis',0.020986),('facilitate',0.30103),('facilitates',0.30103),('facility',0.00582954),('fact',0.30103),('factor',0.30103),('fail',0.30103),('fair',0.30103),('falkland',0.30103),('fames',0.09691),('familiar',0.199379),('family',0.125487),('fanfare',0.30103),('far',0.192339),('faroe',0.30103),('fashion',0.00591497),('fashionable',0.130563),('faso',0.30103),('fast',0.0593508),('faster',0.0532175),('fastest',0.176091),('fastgrowing',0.30103),('fat',0.00768683),('faucibus',0.13092),('favorite',0.30103),('favorites',0.30103),('favourite',0.0992971),('fcc',0.30103),('feature',0.00999923),('features',0.0101656),('featuring',0.0791812),('fee',0.15034),('feed',0.30103),('feedback',0.30103),('feeding',0.30103),('feeds',0.30103),('feel',0.0677548),('feeling',0.30103),('feels',0.0795178),('fees',0.0191163),('feet',0.09691),('felis',0.0440619),('fermented',0.30103),('fermentum',0.0791812),('ferrule',0.176091),('feugiat',0.0471142),('few',0.30103),('fhd',0.30103),('fibres',0.124939),('field',0.30103),('fields',0.30103),('fighting',0.176091),('figure',0.124939),('fiji',0.30103),('file',0.30103),('files',0.232),('filter',0.00555659),('filters',0.00575233),('final',0.0618689),('finally',0.30103),('financial',0.259407),('find',0.0391356),('fine',0.183419),('finer',0.176091),('finest',0.30103),('finetextured',0.30103),('fingerprint',0.30103),('fingertipthe',0.30103),('finibus',0.30103),('finish',0.128817),('finished',0.30103),('finishing',0.176589),('finland',0.30103),('firetv',0.0115819),('first',0.09691),('fisheye',0.30103),('fit',0.0347621),('fits',0.30103),('fitsyourlaptop',0.30103),('fitted',0.176091),('fitting',0.30103),('five',0.30103),('fivefinger',0.09691),('fixed',0.30103),('fixedport',0.30103),('flagship',0.30103),('flame',0.30103),('flare',0.30103),('flash',0.30103),('flatbed',0.30103),('flaunt',0.176091),('fleeting',0.30103),('flexibility',0.124939),('flexible',0.30103),('flip',0.30103),('flipped',0.30103),('flipup',0.197139),('flowy',0.176091),('fluid',0.30103),('fluidity',0.30103),('foam',0.30103),('focal',0.30103),('focus',0.0703736),('focuses',0.30103),('focusing',0.30103),('following',0.30103),('food',0.0109954),('footage',0.30103),('football',0.30103),('for',0.00106911),('force',0.30103),('forefront',0.30103),('forest',0.30103),('forget',0.176091),('form',0.0312615),('formal',0.30103),('format',0.0791812),('formed',0.30103),('forms',0.124939),('formula',0.30103),('formulation',0.30103),('found',0.176091),('founded',0.30103),('founder',0.0511525),('four',0.124939),('fps',0.20606),('frame',0.0985426),('frameworthy',0.30103),('france',0.30103),('free',0.089566),('freely',0.30103),('french',0.106801),('frequency',0.30103),('fresher',0.30103),('fret',0.30103),('friday',0.0108422),('friendly',0.30103),('friends',0.099373),('fringilla',0.0698023),('from',0.00607973),('front',0.126931),('frontfiring',0.30103),('frustrating',0.30103),('fs0005',0.30103),('ftp',0.30103),('fu022faal7jtanmy553296',0.30103),('fu022faalch2anmy561503',0.30103),('fulfilling',0.30103),('fulfillment',0.206583),('full',0.00314868),('fullwirespeed',0.30103),('fully',0.124939),('fun',0.176091),('function',0.00730356),('functional',0.30103),('functionality',0.0580451),('functions',0.0801921),('funky',0.176091),('fur',0.00289427),('furnyce',0.30103),('further',0.0830121),('furthermore',0.30103),('fusce',0.058836),('fusion',0.30103),('futuna',0.30103),('gabon',0.30103),('gadget',0.30103),('gadgets',0.0104654),('gain',0.124939),('galaxy',0.00229261),('gallery',0.129955),('gambia',0.30103),('gamecenter',0.30103),('games',0.100597),('gaming',0.00782534),('gamma',0.176091),('gathers',0.30103),('gbe',0.00704888),('gbps',0.30103),('gddr5',0.30103),('gears',0.30103),('gem',0.176091),('gender',0.176091),('general',0.09691),('generation',0.0579919),('generations',0.30103),('gentle',0.0511525),('genuine',0.00852015),('geometry',0.30103),('georgia',0.214572),('germany',0.30103),('gesture',0.09691),('get',0.00516897),('getaway',0.30103),('gets',0.30103),('ghana',0.30103),('ghz',0.30103),('gibraltar',0.30103),('gift',0.0177552),('gigabit',0.00334619),('girlfriends',0.30103),('give',0.106628),('given',0.219916),('gives',0.0815987),('giving',0.30103),('gladly',0.30103),('glam',0.176091),('glass',0.124939),('glides',0.30103),('global',0.124939),('globally',0.30103),('globe',0.30103),('glow',0.176091),('glowing',0.176091),('glud',0.30103),('glue',0.00663058),('going',0.176091),('gold',0.00256268),('good',0.0361602),('gorgeous',0.176091),('governmental',0.30103),('gps',0.18123),('gpu',0.30103),('grab',0.176091),('grad',0.00553249),('grade',0.09691),('grades',0.176091),('graduated',0.30103),('grams',0.30103),('grand',0.30103),('grants',0.30103),('graphic',0.30103),('graphics',0.0982668),('grass',0.30103),('gravida',0.0334592),('grease',0.30103),('great',0.0249863),('greater',0.0791812),('greatlooking',0.30103),('greece',0.30103),('green',0.00416607),('greenery',0.30103),('greenland',0.30103),('grenada',0.30103),('grenadines',0.30103),('grey',0.0086656),('grins',0.30103),('grip',0.30103),('grounds',0.223249),('grown',0.30103),('gsm',0.30103),('gtx',0.30103),('guadeloupe',0.30103),('guam',0.30103),('guardian',0.30103),('guatemala',0.30103),('guernsey',0.30103),('guessing',0.30103),('guiana',0.30103),('guinea',0.141035),('guineabissau',0.30103),('guyana',0.30103),('gym',0.30103),('ha181hbasx9janmy908363',0.30103),('habitant',0.09691),('hair',0.00616031),('hairdryer',0.176091),('hairscape',0.00553249),('haiti',0.30103),('halloween',0.0377886),('hand',0.04585),('handbag',0.30103),('handcrafted',0.176091),('handle',0.0458237),('handles',0.30103),('handling',0.30103),('handpicked',0.30103),('hands',0.0579919),('handset',0.30103),('handsfree',0.180387),('handy',0.30103),('happiness',0.30103),('hard',0.125635),('harddisk',0.30103),('hardware',0.0807149),('harshest',0.30103),('has',0.0169267),('hasn',0.30103),('hassle',0.176286),('have',0.00949237),('having',0.0835127),('hdd',0.30103),('hdmi',0.00686869),('hdmi13b',0.30103),('hdtv',0.09691),('hdtv1',0.30103),('headphone',0.30103),('headphones',0.00568031),('heads',0.176091),('headset',0.00628054),('health',0.00570359),('healthful',0.30103),('healthier',0.30103),('healthy',0.09691),('hear',0.12721),('heard',0.30103),('heart',0.0669468),('heat',0.30103),('heavy',0.30103),('helena',0.30103),('help',0.0120242),('helping',0.176091),('helps',0.0579919),('hence',0.30103),('hendrerit',0.0474498),('her',0.30103),('here',0.0722654),('herzegovina',0.30103),('hidden',0.188552),('high',0.0107991),('highavailability',0.30103),('highend',0.30103),('higher',0.176091),('highest',0.30103),('highlights',0.0791812),('highly',0.30103),('highperformance',0.30103),('highpolymercoated',0.30103),('highpowered',0.30103),('highquality',0.176091),('highresolution',0.176091),('highspeed',0.100108),('hike',0.30103),('hiking',0.00357089),('hinge',0.30103),('hippieinspired',0.176091),('his',0.30103),('hit',0.30103),('hold',0.0791812),('holder',0.00311324),('holding',0.182608),('holds',0.176091),('holes',0.30103),('holiday',0.13448),('home',0.00235361),('honduras',0.30103),('hong',0.30103),('honor',0.30103),('hoped',0.30103),('hopefully',0.30103),('hot',0.30103),('hotspot',0.181785),('hottest',0.30103),('hour',0.124939),('hours',0.060518),('house',0.124939),('housing',0.176091),('how',0.00363428),('however',0.176091),('hspa',0.185126),('htc',0.176589),('hte350k',0.0070218),('huge',0.30103),('hugely',0.30103),('human',0.30103),('hungary',0.30103),('hunt',0.30103),('hurdle',0.30103),('hurting',0.30103),('hyaluronic',0.30103),('hybrid',0.00673338),('hydrate',0.30103),('hydrated',0.176091),('hydrolysed',0.30103),('i74770',0.30103),('iaculis',0.0530329),('ibooks',0.30103),('icc',0.30103),('iceland',0.30103),('icloud',0.0669468),('iconic',0.30103),('ideal',0.0669468),('identify',0.199776),('identity',0.176091),('idle',0.30103),('illuminated',0.30103),('illumination',0.30103),('image',0.0218997),('images',0.0301236),('imagine',0.176091),('imaging',0.30103),('immediately',0.30103),('immersion',0.30103),('immersive',0.30103),('immortal',0.30103),('imovie',0.176091),('impact',0.30103),('impeccable',0.30103),('impedance',0.30103),('imperdiet',0.0551681),('important',0.0516462),('impress',0.30103),('impressive',0.09691),('impressively',0.30103),('improper',0.30103),('improve',0.1662),('improved',0.176091),('improvement',0.30103),('improves',0.188034),('impurities',0.30103),('in656faas6g7anmy870227',0.30103),('inactive',0.30103),('incar',0.00811789),('inch',0.00645522),('inches',0.176091),('include',0.0765913),('included',0.0888694),('includes',0.0290188),('including',0.0435963),('incoming',0.30103),('incomplete',0.30103),('increase',0.30103),('increased',0.30103),('increases',0.30103),('incredible',0.0604867),('incredibly',0.176091),('indepth',0.30103),('india',0.30103),('indian',0.30103),('indicated',0.30103),('indicator',0.176091),('indicators',0.30103),('indispensable',0.30103),('individuality',0.30103),('individually',0.30103),('individuals',0.124939),('indonesia',0.30103),('indoors',0.30103),('indulge',0.30103),('industry',0.30103),('ineligible',0.0457575),('inexpensive',0.176091),('infinity',0.30103),('inform',0.30103),('information',0.00424262),('informattion',0.0222764),('infused',0.30103),('ingredients',0.0586169),('initiate',0.30103),('injuring',0.30103),('ink',0.132513),('inner',0.176091),('innovation',0.30103),('innovations',0.126931),('innovative',0.0978479),('inplane',0.30103),('input',0.176091),('inputs',0.30103),('inquire',0.30103),('insert',0.177189),('inside',0.176091),('inspiration',0.30103),('inspired',0.30103),('install',0.30103),('installation',0.176091),('installed',0.30103),('installments',0.30103),('instant',0.124939),('instantaneously',0.30103),('instantly',0.00653087),('instead',0.30103),('instrument',0.30103),('intalian',0.30103),('integer',0.0427307),('integrate',0.30103),('integrated',0.0518079),('intel',0.0824642),('intelligent',0.0603901),('intended',0.30103),('intentionally',0.30103),('interacting',0.30103),('interactive',0.30103),('interchangeable',0.176091),('interdum',0.0836587),('interests',0.30103),('interface',0.176091),('interference',0.30103),('interior',0.176091),('interlaced',0.30103),('internal',0.0686599),('internet',0.0993986),('intervals',0.30103),('intheroom',0.30103),('into',0.0284694),('intricate',0.30103),('introduced',0.30103),('introducing',0.30103),('investigation',0.30103),('invicta',0.00589735),('invincible',0.30103),('invisible',0.176091),('invoice',0.0719034),('involvement',0.30103),('ios',0.00632999),('ipad',0.00254797),('iphone',0.0024353),('iphone6',0.244299),('iphones',0.30103),('ipod',0.00796893),('ips',0.0679666),('ipsum',0.0127251),('iran',0.30103),('iraq',0.30103),('ire',0.30103),('ireland',0.30103),('ishop',0.0791812),('isight',0.0596499),('islamic',0.176091),('island',0.0443525),('islands',0.0339891),('isle',0.30103),('isn',0.176091),('iso',0.30103),('israel',0.30103),('issue',0.30103),('italian',0.30103),('italy',0.30103),('item',0.00491672),('items',0.0440623),('its',0.0106172),('itself',0.30103),('itunes',0.198373),('ivory',0.187562),('jack',0.30103),('jacks',0.30103),('jamaica',0.30103),('jan',0.30103),('japan',0.133721),('jersey',0.30103),('jewelleries',0.124939),('jewellery',0.00954762),('jewelries',0.176091),('jewelry',0.30103),('job',0.30103),('join',0.0147233),('joined',0.176091),('jordan',0.30103),('jot',0.176091),('journey',0.30103),('joy',0.30103),('jpeg',0.30103),('jump',0.30103),('jungle',0.176091),('jurisdiction',0.30103),('just',0.012828),('justo',0.0277637),('karaoke',0.131606),('kazakhstan',0.30103),('kdl48r470b',0.00683942),('keeling',0.30103),('keep',0.0713504),('keeps',0.30103),('kenya',0.30103),('key',0.113677),('keys',0.124939),('ki236hbap7fzanmy699829',0.30103),('kids',0.00653087),('kill',0.30103),('kinds',0.30103),('kingdom',0.30103),('kinohimitsu',0.00677961),('kinshasa',0.30103),('kiribati',0.30103),('kit',0.00312698),('kitkat',0.30103),('kits',0.30103),('kitts',0.30103),('knots',0.30103),('know',0.09691),('known',0.176091),('kong',0.30103),('korea',0.246043),('krait',0.30103),('kuwait',0.30103),('kyrgyzstan',0.30103),('l12s',0.00676332),('label',0.30103),('lacinia',0.0472552),('lack',0.30103),('lacus',0.0300725),('lagfree',0.30103),('lamido',0.30103),('lamudi',0.30103),('lan',0.30103),('landscape',0.30103),('landscapes',0.30103),('language',0.30103),('lanka',0.30103),('laoreet',0.0307076),('laos',0.30103),('laptop',0.00360297),('laptops',0.011281),('large',0.0512925),('larger',0.085088),('largest',0.176091),('last',0.0579919),('lasting',0.0791812),('latencysensitive',0.30103),('later',0.30103),('latest',0.0795178),('lather',0.30103),('latvia',0.30103),('law',0.0383387),('lay',0.30103),('layer',0.0558838),('layers',0.30103),('layout',0.30103),('lazada',0.190003),('lcarnitine',0.30103),('lcd',0.00526094),('le106elasxt7anmy909117',0.30103),('le106elat4hkanmy918581',0.30103),('leading',0.0616103),('learn',0.0248236),('lease',0.124939),('least',0.30103),('leather',0.176091),('leaves',0.30103),('lebanon',0.30103),('lecithin',0.30103),('lectus',0.0288525),('led',0.00361829),('left',0.30103),('legal',0.13734),('legally',0.30103),('legendary',0.176091),('legs',0.30103),('lend',0.30103),('lends',0.30103),('length',0.182335),('lenovo',0.00295765),('lens',0.00190982),('lenses',0.0115819),('leo',0.0358068),('leone',0.30103),('lesotho',0.30103),('less',0.0791812),('let',0.176091),('lets',0.018981),('letters',0.30103),('letting',0.30103),('level',0.176091),('levels',0.09691),('liability',0.30103),('liberia',0.30103),('libero',0.039137),('libya',0.30103),('licensed',0.30103),('lide',0.00673338),('liechtenstein',0.30103),('life',0.0548432),('lifeless',0.30103),('lifelike',0.124939),('lifestyle',0.126506),('lifetime',0.101645),('light',0.0234811),('lightcapturing',0.30103),('lighting',0.30103),('lightningfast',0.30103),('lights',0.30103),('lightweigh',0.30103),('lightweight',0.046128),('ligula',0.0715516),('liion',0.30103),('like',0.0243705),('likely',0.30103),('limitations',0.30103),('limited',0.0691675),('line',0.30103),('lines',0.30103),('linger',0.30103),('lining',0.30103),('link',0.0182343),('linking',0.0347621),('lion',0.00541265),('lip',0.129049),('list',0.0633474),('listed',0.0699799),('listen',0.182335),('listening',0.176091),('listing',0.198576),('listings',0.0321847),('lists',0.176091),('lite',0.30103),('literally',0.30103),('liters',0.30103),('lithuania',0.30103),('little',0.09691),('live',0.104556),('lively',0.30103),('living',0.0134564),('lo024faaksj4anmy530660',0.30103),('load',0.178078),('loaded',0.30103),('lobortis',0.0518894),('lobster',0.30103),('local',0.00443345),('locate',0.30103),('located',0.141319),('log',0.0934362),('logging',0.30103),('login',0.30103),('long',0.03933),('longer',0.112299),('longevity',0.30103),('look',0.0265814),('looking',0.0538789),('looks',0.0511525),('loops',0.30103),('loose',0.30103),('lorem',0.0108013),('lose',0.30103),('loss',0.124939),('lost',0.30103),('lotion',0.124939),('love',0.00647512),('loved',0.30103),('low',0.09691),('lowend',0.30103),('lower',0.30103),('lowlight',0.176091),('lte',0.00748366),('lu757faat3kbanmy916954',0.30103),('luccacal',0.00673338),('lucia',0.30103),('luctus',0.0807654),('luggage',0.176091),('luminescent',0.176091),('luminous',0.30103),('lush',0.30103),('lux',0.176091),('luxembourg',0.30103),('luxury',0.30103),('m5250',0.00770211),('maarten',0.30103),('mac',0.176091),('macao',0.30103),('macbook',0.0377886),('macedonia',0.30103),('machine',0.30103),('machines',0.30103),('mad',0.30103),('madagascar',0.30103),('made',0.0229658),('maecenas',0.0359685),('magic',0.178954),('magna',0.0267336),('magnificent',0.176091),('magnis',0.30103),('mah',0.198778),('mail',0.30103),('mailing',0.30103),('main',0.0818507),('maintain',0.234422),('maintaining',0.222221),('maintains',0.30103),('make',0.0188013),('maker',0.30103),('makes',0.0357154),('makeup',0.00269939),('making',0.09691),('malawi',0.30103),('malaysia',0.133268),('maldives',0.30103),('malesuada',0.0302891),('mali',0.30103),('mali400',0.30103),('mall',0.30103),('malta',0.30103),('màn',0.186808),('manage',0.188552),('managed',0.00673241),('management',0.178372),('manager',0.30103),('managing',0.30103),('mandatory',0.30103),('manila',0.30103),('manner',0.166889),('manual',0.30103),('manually',0.30103),('manufacturing',0.30103),('many',0.0804352),('mariana',0.30103),('marino',0.30103),('marked',0.30103),('marker',0.176091),('markers',0.176091),('market',0.30103),('marketing',0.139636),('marketplace',0.00199946),('marketplacecom',0.0152289),('marshall',0.30103),('martin',0.30103),('martinique',0.30103),('mask',0.0791812),('massa',0.0543003),('massage',0.30103),('massager',0.00694886),('massagers',0.30103),('massive',0.176091),('masterpiece',0.30103),('masterpieces',0.30103),('match',0.0549873),('matches',0.30103),('material',0.0280585),('materials',0.104498),('matrix',0.0377886),('matte',0.30103),('matter',0.09691),('matters',0.30103),('mattis',0.0472819),('mauris',0.0246621),('mauritania',0.30103),('mauritius',0.30103),('mavens',0.30103),('maximize',0.176091),('maximum',0.09691),('maximus',0.0472394),('máy',0.0222513),('mayen',0.30103),('mayotte',0.30103),('mcdonald',0.30103),('md368',0.00821133),('md785zpa',0.00868591),('me223hbat7xuanmy924008',0.30103),('me864',0.0377886),('mean',0.30103),('means',0.30103),('meant',0.190003),('measure',0.30103),('measurement',0.176091),('measures',0.136131),('medal',0.30103),('media',0.0640407),('medicine',0.30103),('medium',0.30103),('meet',0.135092),('meeting',0.30103),('meets',0.30103),('mega',0.00782534),('megapixel',0.19672),('megapixels',0.194136),('mejikaliner',0.00575233),('memo',0.0511525),('memopad',0.00582954),('memorize',0.30103),('memory',0.00798429),('men',0.00414019),('mens',0.00575233),('menu',0.176286),('message',0.232534),('messages',0.207981),('metal',0.00663058),('metallic',0.30103),('metallized',0.176091),('meters',0.176091),('method',0.0511525),('methods',0.0579919),('metro',0.30103),('metus',0.0332916),('mexico',0.30103),('mic',0.00769148),('micro',0.30103),('micronesia',0.30103),('microsd',0.143737),('midsection',0.30103),('might',0.30103),('miix',0.0067903),('mild',0.176091),('millimeters',0.30103),('million',0.176091),('millions',0.30103),('mimo',0.30103),('mind',0.09691),('mindblowing',0.09691),('mini',0.00372974),('miniature',0.30103),('minimal',0.176091),('minimize',0.30103),('minitablet',0.30103),('minor',0.0528318),('minute',0.124939),('minutes',0.30103),('miquelon',0.30103),('miracle',0.30103),('mirror',0.30103),('misleading',0.30103),('miss',0.127071),('missed',0.30103),('mist',0.176091),('misuse',0.30103),('mix',0.176091),('mlb',0.0971446),('mobile',0.00326543),('mobility',0.30103),('mode',0.0224993),('model',0.00409277),('modern',0.176091),('modify',0.30103),('module',0.179818),('moisture',0.30103),('moisturising',0.30103),('moisturizer',0.30103),('moldova',0.30103),('molestie',0.0981841),('mollis',0.0443704),('moment',0.176091),('moments',0.0839675),('monaco',0.30103),('monday',0.143252),('monetize',0.30103),('money',0.124939),('mongolia',0.30103),('monitor',0.0512681),('monitoring',0.100413),('montenegro',0.30103),('montes',0.30103),('month',0.102129),('monthlong',0.30103),('monthly',0.30103),('months',0.176091),('montserrat',0.30103),('morbi',0.0419005),('more',0.00704932),('morning',0.30103),('morocco',0.30103),('most',0.0220976),('motion',0.135114),('motionsensing',0.30103),('motor',0.127348),('motorized',0.30103),('mount',0.30103),('mountain',0.00634342),('mouse',0.30103),('move',0.124939),('moved',0.30103),('movement',0.0519286),('movie',0.132293),('movies',0.0376432),('moving',0.176091),('mozambique',0.30103),('mp3',0.30103),('mp4',0.176091),('mtk6572',0.190715),('mu553faarfdmanmy830725',0.30103),('much',0.0611141),('multi',0.00796893),('multiangle',0.30103),('multicolour',0.30103),('multimedia',0.30103),('multipage',0.30103),('multiple',0.0288022),('multisurround',0.30103),('multitouch',0.0524228),('mums',0.30103),('mus',0.30103),('muscles',0.30103),('music',0.0306023),('muslim',0.30103),('must',0.177189),('mute',0.30103),('muwo',0.00537662),('myanmar',0.30103),('mydlink',0.0669468),('n600',0.00734908),('n750',0.00685867),('n900',0.00845157),('n910',0.0075929),('nam',0.0592267),('name',0.0624574),('names',0.30103),('namibia',0.30103),('nắp',0.30103),('nappies',0.30103),('narrower',0.30103),('nascetur',0.30103),('nat',0.30103),('nationwide',0.30103),('natoque',0.30103),('natural',0.0579919),('nature',0.127266),('nauru',0.30103),('navigation',0.176091),('nd2',0.30103),('near',0.30103),('nearby',0.30103),('nearly',0.30103),('nec',0.0183454),('necessary',0.0765171),('necessities',0.30103),('neck',0.176091),('necklace',0.0078366),('need',0.0288192),('needed',0.30103),('needs',0.0669468),('negative',0.30103),('neo',0.00673338),('neoprene',0.30103),('nepal',0.30103),('neque',0.0336345),('nest',0.30103),('nét',0.30103),('netherlands',0.147973),('netus',0.09691),('network',0.00648117),('networking',0.30103),('networkitunes',0.30103),('networks',0.186044),('never',0.0460204),('nevis',0.30103),('new',0.0151545),('newborns',0.30103),('newest',0.30103),('newly',0.0413927),('news',0.30103),('newsletter',0.30103),('newsletters',0.30103),('next',0.0166658),('nfc',0.30103),('nhl',0.30103),('ni220elao90eanmy649565',0.30103),('nibh',0.0250054),('nicaragua',0.30103),('niger',0.30103),('nigeria',0.30103),('night',0.00645192),('nighttime',0.30103),('nightvision',0.30103),('nikkor',0.0975029),('nikon',0.00710821),('nisi',0.0636729),('nisl',0.0417606),('niue',0.30103),('no1',0.30103),('no225elak8ttanmy497673',0.30103),('noise',0.09691),('nokia',0.00645984),('nominal',0.30103),('non',0.0246413),('none',0.193469),('norfolk',0.30103),('normal',0.176091),('north',0.30103),('northern',0.30103),('norway',0.30103),('not',0.0163905),('note',0.00217853),('note4',0.30103),('notes',0.0791812),('notice',0.09691),('noticeable',0.30103),('notifications',0.0180515),('notifies',0.176091),('nourish',0.30103),('now',0.0118212),('nozzles',0.30103),('ntsc',0.30103),('nulla',0.0177501),('nullam',0.0427771),('number',0.0791812),('numbers',0.30103),('nunc',0.0235686),('nurtured',0.30103),('nutrients',0.30103),('nutrition',0.0377886),('nvidia',0.178372),('nxf1',0.30103),('nyce',0.00289427),('nylon',0.196298),('objected',0.30103),('objection',0.201092),('obligations',0.30103),('obtained',0.30103),('occasion',0.0998879),('occasions',0.30103),('occured',0.30103),('ocean',0.176091),('odio',0.0353919),('oe702el51smmanmy130613',0.30103),('oe702elak0u8anmy486129',0.30103),('oe702elakqt4anmy527371',0.30103),('oe702elamnj0anmy642088',0.30103),('oe702elas5khanmy868993',0.30103),('oe702elass8banmy900509',0.30103),('oe702faashknanmy885439',0.30103),('oe702hbamqybanmy647350',0.30103),('oe702hbast9qanmy901982',0.30103),('oe702hbat78lanmy922903',0.30103),('oem',0.00439995),('off',0.00631371),('offbeat',0.176091),('offer',0.0698881),('offered',0.19211),('offers',0.0457575),('officer',0.23863),('offset',0.30103),('often',0.176091),('oil',0.30103),('old',0.30103),('oled',0.00676863),('oman',0.30103),('once',0.09691),('one',0.0138083),('ones',0.126931),('onesizefitsall',0.30103),('onetouch',0.0669468),('online',0.00844003),('only',0.0172597),('only2014',0.30103),('onthego',0.125635),('oomph',0.30103),('open',0.219534),('opening',0.176091),('opens',0.30103),('operate',0.0807149),('operated',0.176091),('operating',0.104006),('operation',0.0791812),('operations',0.30103),('optical',0.10186),('optimal',0.30103),('optimized',0.30103),('option',0.09691),('optional',0.09691),('options',0.0160499),('orange',0.00334207),('orci',0.083053),('order',0.00986726),('orders',0.0443074),('ordinary',0.30103),('organic',0.00653087),('organizer',0.00683942),('ori',0.00858093),('oriented',0.30103),('origin',0.30103),('original',0.00811789),('ornare',0.0798377),('ot343elam59danmy609257',0.30103),('other',0.0162673),('others',0.0335037),('otherwise',0.170672),('our',0.0139),('out',0.0184216),('outcome',0.30103),('outdoor',0.00675171),('outdoors',0.30103),('outfit',0.0791812),('outlined',0.30103),('outlying',0.30103),('output',0.0987526),('outputs',0.176091),('outstanding',0.176091),('over',0.0366824),('overall',0.176091),('oversaturated',0.199379),('overseas',0.30103),('own',0.0975029),('owner',0.30103),('owners',0.30103),('oyster',0.30103),('p1801b041k',0.00724544),('p338',0.00673338),('pack',0.124939),('packed',0.30103),('packs',0.00655598),('pad',0.0669468),('padded',0.18315),('paddings',0.30103),('pads',0.176091),('page',0.0137819),('pages',0.126102),('paint',0.30103),('painting',0.30103),('pair',0.180387),('pairing',0.30103),('pakistan',0.30103),('pal',0.30103),('palau',0.30103),('palestinian',0.30103),('palm',0.30103),('pan',0.00380609),('panama',0.30103),('panel',0.176091),('paper',0.124939),('paperless',0.176091),('papua',0.30103),('paraguay',0.30103),('parallel',0.30103),('parent',0.30103),('parents',0.30103),('part',0.0246656),('participant',0.30103),('particular',0.30103),('particularly',0.30103),('parties',0.0734104),('partner',0.30103),('parturient',0.30103),('party',0.0439092),('pass',0.30103),('password',0.0529369),('past',0.30103),('pastel',0.176091),('patent',0.30103),('pattern',0.0036297),('payment',0.00553249),('payments',0.0289335),('paypal',0.30103),('pcs',0.176091),('pcworld',0.30103),('pdf',0.124939),('peaceloving',0.176091),('pedometer',0.30103),('pellentesque',0.0266539),('pen',0.30103),('penatibus',0.30103),('penetrates',0.30103),('penetrating',0.30103),('people',0.0530824),('per',0.124939),('perfect',0.00582665),('perfection',0.0083007),('perfectly',0.0579919),('perform',0.30103),('performance',0.0263289),('performanceoptimised',0.30103),('performing',0.30103),('perhaps',0.30103),('period',0.0989888),('peritem',0.30103),('permalink',0.0467397),('permissible',0.30103),('person',0.124939),('personal',0.00351005),('personalities',0.176091),('personality',0.124939),('personalize',0.30103),('personalized',0.230726),('perspective',0.30103),('peru',0.30103),('pharetra',0.069381),('phasellus',0.0338964),('philippine',0.30103),('philippines',0.228097),('philosophy',0.09691),('phone',0.00306115),('phones',0.0102198),('photo',0.129075),('photographic',0.30103),('photographs',0.30103),('photography',0.30103),('photos',0.0243099),('physical',0.30103),('pick',0.0981841),('picked',0.0486359),('pickup',0.00796893),('pictelligent',0.30103),('picture',0.0691143),('pictures',0.09691),('piece',0.0669468),('pieces',0.124939),('pierre',0.30103),('pimples',0.30103),('pinch',0.30103),('pink',0.0034475),('pioneering',0.30103),('pir',0.184747),('pitcairn',0.30103),('pitch',0.30103),('pitera',0.176091),('pixels',0.0814858),('place',0.0855509),('placed',0.30103),('placerat',0.0428301),('places',0.09691),('plain',0.0795178),('planning',0.30103),('plastic',0.09691),('plasticlined',0.30103),('plated',0.00687359),('platform',0.022687),('plating',0.176286),('play',0.0511525),('playback',0.0792806),('player',0.0810616),('players',0.30103),('playful',0.30103),('playing',0.176091),('please',0.0507667),('pleasure',0.30103),('plug',0.132513),('plugable',0.0511525),('plugs',0.30103),('plus',0.00331379),('pocket',0.18123),('pockets',0.176091),('poe',0.00693797),('point',0.010745),('poland',0.30103),('pole',0.30103),('policies',0.0193572),('policy',0.00693167),('polishing',0.176091),('polycarbonate',0.124939),('polyester',0.30103),('polynesia',0.30103),('pony',0.176091),('poor',0.30103),('pop',0.179818),('pore',0.00726363),('pores',0.30103),('port',0.00372425),('porta',0.0530926),('portability',0.30103),('portable',0.00591411),('portrait',0.30103),('portraits',0.182335),('ports',0.0516179),('porttitor',0.0486385),('portugal',0.30103),('poses',0.30103),('position',0.143154),('possible',0.0585028),('post',0.194136),('posted',0.30103),('postpurchase',0.30103),('posuere',0.0386443),('potent',0.30103),('potential',0.30103),('pouch',0.00634018),('powder',0.129509),('power',0.00311642),('powerbank',0.00640522),('powerbanks',0.30103),('powerconnect',0.00704888),('powered',0.30103),('powerful',0.0236528),('powering',0.30103),('powershot',0.00636905),('ppi',0.176091),('practical',0.30103),('praesent',0.0842363),('prayers',0.176091),('precious',0.30103),('precise',0.124939),('predecessor',0.199379),('predefined',0.30103),('predicament',0.30103),('prefer',0.234754),('preference',0.111956),('preferences',0.234588),('preferred',0.30103),('premium',0.0795761),('prepare',0.176091),('prepolishing',0.30103),('presenting',0.30103),('preserved',0.30103),('preserves',0.30103),('preset',0.30103),('pressed',0.185064),('pressure',0.30103),('pretium',0.0711705),('pretty',0.0742887),('prevent',0.0938567),('preview',0.30103),('previous',0.124939),('previously',0.30103),('price',0.0474661),('pricing',0.0086298),('principe',0.30103),('print',0.00365628),('printers',0.30103),('priority',0.176091),('privacy',0.0105075),('pro',0.00317241),('probably',0.30103),('procedures',0.30103),('process',0.0823345),('processed',0.209187),('processes',0.176091),('processing',0.30103),('processor',0.0238459),('processora',0.30103),('produce',0.30103),('producing',0.30103),('product',0.0628831),('productivity',0.0791812),('products',0.00989774),('professional',0.00653431),('professionals',0.30103),('profile',0.176091),('program',0.0157943),('programmes',0.176091),('programs',0.30103),('proin',0.0387142),('projection',0.176091),('projects',0.30103),('promote',0.30103),('promotes',0.30103),('promotional',0.30103),('promotions',0.0178551),('properly',0.30103),('properties',0.30103),('proprietary',0.30103),('protect',0.109177),('protection',0.0362012),('protective',0.30103),('protects',0.30103),('proves',0.30103),('provide',0.036669),('provided',0.0879633),('provider',0.201802),('providers',0.25467),('provides',0.0457575),('providing',0.185787),('provincial',0.30103),('published',0.30103),('puerto',0.30103),('puff',0.30103),('puffiness',0.30103),('pulling',0.30103),('pulvinar',0.0422089),('pump',0.0115819),('punches',0.30103),('purchase',0.148824),('purchased',0.269304),('purchases',0.0372359),('purchasing',0.30103),('pure',0.30103),('purest',0.30103),('purpose',0.186059),('purposes',0.0596707),('purse',0.176091),('pursuit',0.09691),('purus',0.0329497),('push',0.30103),('pushing',0.176091),('put',0.0512436),('q10',0.30103),('qatar',0.30103),('qhd',0.30103),('qqvga',0.30103),('quad',0.30103),('quadband',0.30103),('quadcore',0.0982668),('qualcomm',0.30103),('qualify',0.124939),('qualifying',0.30103),('qualities',0.176091),('quality',0.0121602),('quam',0.0402014),('quantity',0.00652844),('quarter',0.30103),('quartz',0.176091),('queries',0.30103),('question',0.30103),('questions',0.177189),('quick',0.00609818),('quickie',0.30103),('quickly',0.0745313),('quiet',0.30103),('quis',0.0188909),('quisque',0.0687428),('quite',0.30103),('quran',0.00634018),('qvga',0.30103),('radiance',0.0791812),('radiant',0.30103),('radio',0.30103),('raincover',0.30103),('rainy',0.30103),('ram',0.0847331),('range',0.124939),('ranked',0.30103),('rapidly',0.30103),('rate',0.0437337),('rates',0.30103),('rating',0.30103),('razorsharp',0.30103),('reach',0.124939),('read',0.176091),('reader',0.30103),('readily',0.30103),('reading',0.30103),('ready',0.0580772),('realestate',0.30103),('realism',0.176091),('reality',0.0791812),('really',0.30103),('rear',0.30103),('reason',0.30103),('reasonable',0.30103),('reasons',0.30103),('rebates',0.0150902),('receive',0.30103),('receives',0.30103),('receiving',0.25252),('recent',0.176091),('rechargeable',0.205438),('recognition',0.09691),('recognize',0.30103),('recognizes',0.18123),('recommended',0.18422),('reconnect',0.30103),('record',0.0735038),('recorder',0.30103),('recording',0.0361312),('recordings',0.18422),('records',0.30103),('red',0.00815456),('reduce',0.09691),('reduced',0.177189),('reduces',0.30103),('reducing',0.30103),('reduction',0.176091),('referral',0.30103),('refinements',0.30103),('reflect',0.061771),('reflex',0.30103),('refunded',0.30103),('refunds',0.00695291),('regardless',0.176091),('register',0.0291692),('registered',0.177487),('regular',0.124939),('regularly',0.30103),('regulatory',0.206759),('reimagined',0.30103),('reject',0.176091),('rejuvenate',0.30103),('related',0.146965),('relates',0.30103),('relation',0.30103),('relationship',0.30103),('relaxing',0.30103),('release',0.30103),('relevant',0.115912),('reliability',0.0594964),('remain',0.30103),('remains',0.141519),('remarkably',0.30103),('remedies',0.30103),('reminded',0.30103),('remote',0.00250859),('remotely',0.30103),('removable',0.176091),('removal',0.30103),('remove',0.09691),('removes',0.30103),('renders',0.30103),('rendezvous',0.30103),('renews',0.30103),('report',0.30103),('reporting',0.0377886),('representatives',0.187906),('represents',0.176091),('reproduced',0.30103),('republic',0.124939),('request',0.199989),('requested',0.30103),('requests',0.254459),('require',0.30103),('required',0.0738791),('requirements',0.145098),('requires',0.1863),('research',0.199973),('resembles',0.30103),('reserve',0.184579),('reserved',0.30103),('residual',0.30103),('resin',0.30103),('resistance',0.30103),('resistant',0.00538689),('resolution',0.0164145),('resonate',0.30103),('respective',0.30103),('responsible',0.30103),('responsive',0.30103),('resting',0.30103),('restore',0.176091),('restricting',0.30103),('result',0.237214),('resulting',0.130078),('results',0.176091),('resurfaced',0.30103),('retain',0.30103),('retains',0.30103),('retina',0.0387494),('retrieving',0.30103),('retro',0.30103),('return',0.0105104),('returns',0.00464227),('reunion',0.30103),('review',0.30103),('revive',0.30103),('revolution',0.00531141),('revolutionary',0.176091),('revolutions',0.30103),('rhinestones',0.30103),('rhode',0.0702731),('rhoncus',0.0584396),('rica',0.30103),('rich',0.080613),('richer',0.176091),('rico',0.30103),('ride',0.30103),('rides',0.30103),('ridiculus',0.30103),('right',0.0255198),('rights',0.30103),('ring',0.30103),('ripping',0.30103),('ripstop',0.30103),('risks',0.30103),('risus',0.0432297),('ritual',0.176091),('ro180faasx6ranmy908233',0.30103),('road',0.176091),('roaming',0.30103),('robust',0.176091),('robustness',0.30103),('rohs',0.30103),('rolex',0.00337974),('rollup',0.30103),('romania',0.30103),('room',0.0134575),('rope',0.30103),('rose',0.30103),('rosy',0.176091),('rotatable',0.30103),('rotate',0.30103),('rotates',0.30103),('rotating',0.30103),('rotational',0.30103),('rough',0.30103),('round',0.0675901),('rounder',0.30103),('roundtheclock',0.176091),('router',0.00350581),('routers',0.0115819),('routine',0.30103),('routing',0.30103),('rtn56u',0.00734908),('rubber',0.176091),('rugged',0.30103),('run',0.09691),('running',0.0791812),('runs',0.176091),('rushing',0.30103),('russia',0.30103),('rutrum',0.0422865),('rwanda',0.30103),('sa356elaol1vanmy666683',0.30103),('sa356elaovyaanmy683458',0.30103),('sa356elaqrcjanmy794737',0.30103),('sa356elarow3anmy844449',0.30103),('sa356elat7ymanmy924036',0.30103),('sacrifice',0.30103),('safe',0.0107239),('safely',0.0871165),('safer',0.30103),('safety',0.0115819),('sagittis',0.0809641),('sahara',0.30103),('saint',0.0855578),('sake',0.30103),('sale',0.30103),('sales',0.0278201),('salon',0.176091),('salvador',0.30103),('same',0.0453077),('samoa',0.206583),('samsung',0.000950295),('sản',0.30103),('sandwich',0.30103),('sao',0.30103),('sapien',0.0481875),('sapphire',0.176091),('sar',0.202679),('satisfaction',0.0594964),('satisfies',0.09691),('satisfying',0.30103),('saturday',0.195177),('saudi',0.30103),('say',0.30103),('sbh20',0.00663058),('sc910elaptxianmy740946',0.30103),('scalability',0.30103),('scale',0.176091),('scan',0.0382257),('scanner',0.0034662),('scanners',0.0115819),('scanning',0.0511525),('scans',0.30103),('scantoemail',0.30103),('scantopdf',0.30103),('scantrack',0.0377886),('scarf',0.00359833),('scarves',0.0109954),('scelerisque',0.0433153),('scene',0.0602646),('scenes',0.30103),('scent',0.30103),('schedule',0.30103),('scheduler',0.176091),('school',0.30103),('scoring',0.30103),('scratch',0.124939),('scratches',0.30103),('scratching',0.30103),('screen',0.016281),('screw',0.176091),('scuba',0.30103),('sdhc',0.30103),('sdxc',0.30103),('seamless',0.0987526),('seamlessly',0.106308),('searchable',0.30103),('searched',0.30103),('season',0.30103),('second',0.176091),('seconds',0.30103),('secret',0.30103),('sections',0.30103),('secure',0.00996078),('securely',0.134926),('security',0.0383784),('sed',0.0101253),('see',0.0166029),('seeking',0.30103),('seems',0.188497),('seen',0.0688696),('segmentation',0.30103),('select',0.176091),('selected',0.30103),('selection',0.30103),('selfies',0.176091),('selfportraits',0.046604),('sell',0.0150363),('seller',0.0317008),('sellers',0.0987609),('selling',0.0180391),('sem',0.0543101),('semper',0.0531292),('send',0.120466),('sends',0.30103),('senectus',0.09691),('senegal',0.30103),('sense',0.176091),('senses',0.30103),('sensitive',0.176091),('sensitivity',0.128027),('sensor',0.0327478),('sensors',0.30103),('sent',0.30103),('separate',0.30103),('separately',0.30103),('serbia',0.30103),('series',0.00832267),('seriously',0.30103),('servers',0.230155),('service',0.0208905),('services',0.080529),('set',0.00226608),('setting',0.30103),('settings',0.0791812),('settle',0.30103),('setup',0.09691),('several',0.09691),('seychelles',0.30103),('sfp',0.30103),('shall',0.157057),('shape',0.124939),('shapes',0.176091),('share',0.0668678),('shared',0.189967),('sharing',0.0476746),('sharp',0.0697655),('sharper',0.176091),('sharply',0.30103),('sheen',0.30103),('shift',0.176091),('ship',0.0222764),('shipping',0.00477063),('shock',0.178078),('shoe',0.0048525),('shoes',0.00663058),('shoot',0.00998422),('shooting',0.0514584),('shoots',0.30103),('shop',0.013364),('shopping',0.081974),('shoppinge',0.0222764),('short',0.30103),('shortly',0.30103),('shot',0.0267559),('shots',0.0978479),('should',0.133366),('shoulder',0.0988318),('show',0.30103),('shown',0.176091),('shutter',0.30103),('sic',0.30103),('side',0.128817),('sierra',0.30103),('sign',0.30103),('signal',0.30103),('signature',0.176091),('significantly',0.30103),('silent',0.18095),('silver',0.00700554),('sim',0.00699367),('similar',0.131021),('simple',0.030179),('simplest',0.30103),('simplicity',0.30103),('simplifies',0.30103),('simplify',0.30103),('simply',0.0698684),('simultaneously',0.30103),('since',0.30103),('sing',0.09691),('singapore',0.208593),('single',0.0328794),('singlecore',0.30103),('sint',0.30103),('sit',0.00847076),('site',0.124939),('situation',0.30103),('situations',0.124939),('six',0.30103),('size',0.00587318),('sizes',0.176091),('sk159hbasxk7anmy908752',0.30103),('sk2',0.00683942),('sk222hbaqyn8anmy807324',0.30103),('sketch',0.30103),('skii',0.00320514),('skills',0.30103),('skin',0.00940097),('skincare',0.00643411),('skipping',0.30103),('skmei',0.00811789),('sku',0.00649075),('sky',0.176091),('slam',0.124939),('slap',0.30103),('slash',0.30103),('sleek',0.13207),('sleeves',0.30103),('sliding',0.30103),('slightly',0.30103),('slim',0.0791812),('slimming',0.00811789),('slip',0.30103),('slipper',0.30103),('slomo',0.30103),('slot',0.30103),('slots',0.30103),('slovakia',0.30103),('slovenia',0.30103),('slr',0.0115819),('small',0.0688292),('smart',0.00238956),('smarter',0.0115819),('smartphone',0.0525359),('smartphones',0.0109954),('smile',0.30103),('smooth',0.0995235),('smoother',0.183954),('smoothes',0.30103),('smoothly',0.18422),('smoothness',0.176091),('smudges',0.30103),('snap',0.0687766),('snapdragon',0.30103),('snapshot',0.30103),('snapshots',0.30103),('snugged',0.30103),('so406elakprjanmy525732',0.30103),('so406elama8aanmy618653',0.30103),('so406elao9yxanmy651058',0.30103),('soccer',0.0791812),('social',0.0640106),('sociis',0.30103),('sockets',0.30103),('sodales',0.0328783),('soft',0.081577),('softness',0.30103),('software',0.0354573),('soil',0.30103),('sold',0.0815337),('solid',0.124939),('sollicitudin',0.067994),('solomon',0.30103),('solution',0.0669468),('solutions',0.30103),('solve',0.30103),('somalia',0.30103),('some',0.028438),('something',0.30103),('sometimes',0.30103),('song',0.176091),('songs',0.30103),('sony',0.00202469),('sophisticated',0.079634),('sound',0.0267152),('source',0.0791812),('sourced',0.30103),('south',0.123546),('southeast',0.30103),('southern',0.30103),('sp889elasu66anmy903500',0.30103),('space',0.00760356),('spacious',0.30103),('spain',0.30103),('spam',0.0565969),('sparkling',0.176091),('speaker',0.0824017),('speakers',0.125036),('special',0.0403178),('specialist',0.124939),('specially',0.187709),('specific',0.30103),('specifically',0.207766),('specification',0.0511525),('specifications',0.0457575),('speed',0.0809181),('speeds',0.0863883),('spent',0.30103),('spigen',0.00582954),('spine',0.30103),('spins',0.30103),('spirit',0.176091),('sponge',0.30103),('sport',0.30103),('sports',0.00459648),('sporty',0.30103),('spread',0.30103),('spreadsheets',0.30103),('spring',0.0413927),('sprinkle',0.30103),('spyware',0.0566739),('square',0.00811695),('squeezing',0.176091),('sri',0.30103),('ssl',0.30103),('stabilisation',0.30103),('stack',0.30103),('stacking',0.00682931),('stadium',0.178664),('stages',0.30103),('stainless',0.00337091),('stand',0.09691),('standard',0.0362666),('standards',0.176286),('stands',0.30103),('staple',0.176091),('start',0.124939),('stash',0.30103),('state',0.0301155),('stated',0.163935),('statement',0.124939),('states',0.277871),('station',0.102802),('stationery',0.0115819),('statistics',0.30103),('status',0.0143213),('stay',0.30103),('staytrue',0.30103),('std403',0.30103),('steel',0.00337091),('steering',0.30103),('steps',0.272934),('stereo',0.00663058),('stick',0.00673338),('sticky',0.176091),('still',0.107957),('stills',0.176091),('stimulate',0.30103),('stitch',0.00663058),('stitching',0.30103),('stock',0.30103),('stocks',0.30103),('stolen',0.30103),('storage',0.0527065),('store',0.00436578),('stored',0.146135),('stores',0.30103),('storing',0.149319),('straightforward',0.30103),('strap',0.00792003),('straps',0.18288),('stream',0.09691),('streaming',0.129831),('streamlined',0.30103),('streamlining',0.30103),('strength',0.30103),('strict',0.30103),('striking',0.30103),('strips',0.30103),('stroller',0.30103),('struggle',0.30103),('studio',0.00827253),('stunner',0.30103),('stunning',0.0511525),('style',0.0170333),('styled',0.30103),('styles',0.0972384),('styling',0.30103),('stylish',0.09691),('stylishly',0.176091),('stylus',0.0608647),('su433faasxlfanmy908796',0.30103),('sub',0.30103),('subject',0.231858),('submariner',0.0054629),('submit',0.104585),('submitted',0.164274),('subscribed',0.30103),('subscription',0.105934),('subscriptions',0.30103),('subsequently',0.30103),('substantial',0.30103),('subtle',0.125187),('subwoofer',0.30103),('successful',0.30103),('such',0.0478629),('suck',0.30103),('suction',0.09691),('sudan',0.262181),('sufficiency',0.30103),('sufficient',0.30103),('suggestions',0.30103),('suit',0.0791812),('suitable',0.0672286),('sun',0.30103),('sunday',0.195503),('sunglasses',0.176091),('sunlight',0.30103),('sunny',0.30103),('sunshine',0.176091),('super',0.0649824),('superb',0.176091),('superduper',0.30103),('superior',0.0792203),('supplements',0.0115819),('supplied',0.30103),('supplier',0.10249),('supply',0.30103),('support',0.00629757),('supported',0.30103),('supports',0.0830259),('supreme',0.30103),('surahs',0.30103),('sure',0.0985927),('surface',0.09691),('suriname',0.30103),('surprised',0.176091),('surround',0.30103),('surveillance',0.30103),('survey',0.176091),('suscipit',0.0809149),('suspendisse',0.0543467),('suspicious',0.30103),('suss010600610',0.00673338),('suunto',0.0054629),('svalbard',0.30103),('swarovski',0.00687432),('swaziland',0.30103),('sweat',0.176091),('sweden',0.30103),('swipe',0.103752),('swiss',0.30103),('switch',0.00354763),('switcher',0.30103),('switches',0.00978269),('switching',0.0669468),('switzerland',0.211756),('swivelled',0.30103),('swm',0.18095),('sx60',0.00628017),('symbol',0.176091),('synthetic',0.176091),('syntheticblend',0.30103),('syria',0.30103),('system',0.00360175),('systems',0.178954),('t02297lap01',0.00591385),('ta073faaqqfqanmy793372',0.30103),('ta452faal25aanmy544771',0.30103),('tab',0.00782534),('table',0.30103),('tablet',0.00206156),('tablets',0.30103),('tack',0.30103),('tactile',0.176091),('taiwan',0.30103),('tajikistan',0.30103),('take',0.0210096),('taken',0.189608),('takes',0.176091),('taking',0.124939),('talented',0.30103),('tan',0.30103),('tanzania',0.30103),('tập',0.176091),('tarantula',0.00683942),('targus',0.00643411),('targustsb166ap50bk',0.30103),('tasks',0.30103),('tax',0.0071591),('taxed',0.0486359),('taxes',0.0726977),('taxi',0.228597),('te960faakjc3anmy515575',0.30103),('tea',0.30103),('teachings',0.30103),('teams',0.30103),('tear',0.30103),('tech',0.30103),('technical',0.116057),('techniques',0.30103),('technologies',0.0437379),('technology',0.0188422),('tee',0.30103),('telephone',0.217457),('televisions',0.0115819),('tell',0.30103),('tellus',0.0313077),('temperature',0.176091),('tempor',0.0360214),('tempus',0.0461455),('tens',0.30103),('terminus',0.00476156),('terms',0.0150805),('territories',0.30103),('territory',0.201523),('text',0.0170473),('texture',0.183687),('textured',0.30103),('tft',0.30103),('thailand',0.30103),('thân',0.0271805),('thanks',0.0469421),('that',0.00525794),('thế',0.00059602),('theater',0.00679812),('theatre',0.00811789),('their',0.0399111),('them',0.0492173),('then',0.128688),('there',0.03945),('thereafter',0.30103),('therefore',0.22698),('these',0.151554),('they',0.0561147),('thickness',0.30103),('thin',0.0579919),('thing',0.176091),('think',0.206546),('thinner',0.176091),('thinnest',0.30103),('thinnestdeveloping',0.30103),('third',0.0290445),('thirdparty',0.30103),('thirty',0.30103),('this',0.00732128),('thompson',0.0511525),('those',0.0546099),('though',0.176091),('thousands',0.30103),('threat',0.30103),('three',0.124939),('threeport',0.30103),('thrilled',0.30103),('through',0.0271319),('throughout',0.30103),('thumb',0.30103),('thumping',0.30103),('thus',0.124939),('till',0.30103),('tilt',0.00699164),('tilts',0.081756),('time',0.00546234),('timelapse',0.30103),('timeless',0.30103),('timepiece',0.176091),('times',0.111359),('timorleste',0.30103),('tincidunt',0.018113),('tk512spala1fanmy557274',0.30103),('tko',0.00683942),('tlm5250',0.30103),('tlwdr4300',0.00626501),('tobacco',0.176091),('tobago',0.30103),('today',0.0997459),('together',0.30103),('togo',0.30103),('tokelau',0.30103),('tome',0.30103),('tone',0.0791812),('tones',0.124939),('tonga',0.30103),('tonific',0.00694886),('too',0.101392),('took',0.30103),('tool',0.30103),('tools',0.00683942),('top',0.00639638),('topic',0.124939),('toprated',0.30103),('tops',0.30103),('tortor',0.0358679),('total',0.0542187),('touch',0.0428005),('touchrejection',0.30103),('touchwiz',0.0847899),('tough',0.0791812),('toughness',0.30103),('towel',0.30103),('town',0.130078),('toys',0.00877392),('tp481elajqboanmy468439',0.30103),('tp481elakvc0anmy535125',0.30103),('tplink',0.00361283),('tpu',0.0791812),('tr626elampm1anmy645445',0.30103),('track',0.176091),('tracking',0.30103),('tracks',0.30103),('tradition',0.30103),('traditional',0.124939),('trail',0.30103),('transaction',0.208099),('transactions',0.30103),('transfer',0.100615),('transferring',0.30103),('transfers',0.0263289),('transform',0.30103),('transformer',0.00699402),('transforms',0.176091),('transition',0.30103),('transmission',0.128294),('transporter',0.00673338),('travel',0.00217692),('traveling',0.30103),('travellers',0.30103),('travelling',0.17689),('travels',0.30103),('treat',0.30103),('treatment',0.0263289),('trek',0.00582954),('trend',0.0792806),('trendiest',0.176091),('trendy',0.193676),('trendz',0.00537662),('trial',0.30103),('tribal',0.00811789),('trigger',0.30103),('trillion',0.30103),('trinidad',0.30103),('tristique',0.0423572),('trolley',0.30103),('truck',0.09691),('truly',0.124939),('trust',0.176091),('trusted',0.30103),('try',0.30103),('trying',0.30103),('tsb166ap',0.00827253),('tue',0.30103),('tunewiki',0.30103),('tunisia',0.30103),('turbo',0.30103),('turkey',0.30103),('turkmenistan',0.30103),('turks',0.30103),('turn',0.130801),('turpis',0.032925),('tuvalu',0.30103),('tvs',0.176091),('twice',0.30103),('twist',0.30103),('twitter',0.30103),('two',0.0511525),('twohanded',0.30103),('type',0.0341218),('types',0.0583256),('typically',0.30103),('u961',0.30103),('u961a',0.00582954),('ua40h5008arxxm',0.00925137),('uganda',0.30103),('ukraine',0.30103),('ullamcorper',0.0366455),('ultimate',0.183954),('ultra',0.30103),('ultrafast',0.30103),('ultrafresh',0.30103),('ultramodern',0.30103),('ultraportable',0.176091),('ultrices',0.0518281),('ultricies',0.0330642),('unauthorized',0.209098),('unbelievably',0.30103),('unbundled',0.0705506),('uncovers',0.30103),('under',0.129186),('underbelly',0.30103),('undergo',0.30103),('undergoes',0.176091),('understand',0.30103),('undertake',0.30103),('unexpected',0.0800286),('unibody',0.30103),('unique',0.0728618),('unison',0.30103),('united',0.160323),('universal',0.00373703),('unleash',0.09691),('unless',0.09691),('unlike',0.176091),('unmatched',0.30103),('unsatisfied',0.30103),('unsubscribe',0.241488),('unsurpassed',0.09691),('until',0.30103),('update',0.0647138),('updated',0.184484),('updates',0.30103),('updating',0.046767),('upgrade',0.30103),('uplinks',0.30103),('upload',0.0235105),('upon',0.30103),('upright',0.0791812),('upto8mp',0.30103),('urna',0.0306553),('uruguay',0.30103),('usa',0.30103),('usage',0.176091),('usb',0.0252917),('usd',0.0511525),('use',0.00371818),('used',0.0552674),('useful',0.0776911),('user',0.112198),('username',0.297495),('users',0.0405508),('uses',0.0873299),('using',0.0186515),('usual',0.30103),('usually',0.176091),('utilise',0.30103),('utilizing',0.30103),('utmost',0.30103),('uvcoated',0.30103),('uzbekistan',0.30103),('v30',0.30103),('v33',0.00814502),('v39',0.0791812),('value',0.0969685),('vanuatu',0.30103),('variangle',0.30103),('variety',0.060317),('various',0.176091),('varius',0.0330448),('vast',0.30103),('vatican',0.30103),('vcd',0.30103),('vector',0.00634018),('vegan',0.30103),('vehicle',0.00782534),('vehicula',0.0599985),('vel',0.0154857),('velit',0.0358122),('velvety',0.30103),('venenatis',0.0480209),('venezuela',0.30103),('ventures',0.219124),('ver',0.00683942),('verde',0.30103),('veriface',0.09691),('verify',0.148644),('versa',0.30103),('versatile',0.176091),('versatility',0.0791812),('version',0.30103),('vertical',0.176091),('very',0.0413927),('vessels',0.30103),('vestibulum',0.0189008),('vga',0.30103),('via',0.0645723),('vibrant',0.0866049),('vibration',0.30103),('vice',0.30103),('video',0.0174292),('videomore',0.30103),('videos',0.0415158),('vietnam',0.30103),('view',0.00601701),('viewed',0.233833),('viewing',0.0304779),('vigilant',0.30103),('vignetting',0.30103),('vigorous',0.30103),('vimeo',0.09691),('vincent',0.30103),('viral',0.30103),('virgin',0.214417),('virtual',0.0791812),('virtually',0.0795761),('virus',0.0567508),('viscose',0.18123),('vision',0.19095),('visit',0.104018),('visiting',0.30103),('visitors',0.30103),('visual',0.30103),('visuals',0.09691),('vitae',0.0220894),('vital',0.30103),('vitamins',0.30103),('vivamus',0.0428716),('viverra',0.0329431),('vivid',0.10032),('vividly',0.30103),('voice',0.0999338),('voiceactivated',0.30103),('volume',0.0671451),('voluntarily',0.191867),('voluntary',0.30103),('volutpat',0.02756),('votes',0.00657249),('vulputate',0.0548864),('waist',0.30103),('waiting',0.30103),('waive',0.30103),('walk',0.176091),('walks',0.30103),('wall',0.30103),('wallet',0.176091),('wallis',0.30103),('wan',0.30103),('want',0.0579919),('wants',0.30103),('wardrobe',0.124939),('warmth',0.176091),('warmup',0.30103),('warranties',0.30103),('warranty',0.0418071),('was',0.0669468),('washing',0.30103),('watch',0.00134182),('watches',0.124939),('watching',0.176091),('water',0.00538689),('waterproof',0.00469512),('waterresistant',0.00673338),('watts',0.30103),('wave',0.127348),('way',0.09691),('ways',0.21759),('wcdma',0.178954),('wear',0.124939),('wearable',0.30103),('weather',0.100502),('web',0.0685921),('webcam',0.0791812),('webpage',0.30103),('webpatterned',0.30103),('website',0.250218),('weebpal',0.0224854),('weekend',0.176091),('weight',0.0107772),('well',0.0397872),('wellspaced',0.30103),('were',0.0949798),('western',0.30103),('wet',0.30103),('what',0.011532),('wheel',0.30103),('when',0.0139657),('whenever',0.30103),('where',0.024216),('wherever',0.09691),('whether',0.0298372),('which',0.0134794),('while',0.0383587),('white',0.00181484),('whiteheads',0.30103),('whitened',0.30103),('who',0.08526),('whole',0.30103),('whom',0.30103),('why',0.30103),('wide',0.0312615),('wideiphone',0.30103),('wider',0.176589),('widest',0.30103),('wideview',0.30103),('width',0.176091),('wifi',0.00190909),('wild',0.30103),('wildlife',0.30103),('wildness',0.176091),('will',0.00621584),('wind',0.176091),('window',0.185787),('windows',0.0240794),('windshield',0.176091),('wink',0.0669468),('wipe',0.30103),('wire',0.124939),('wired',0.30103),('wireless',0.00180367),('wirelessly',0.09691),('wish',0.30103),('with',0.000752407),('withdraw',0.247038),('withdrawal',0.0447469),('within',0.0542758),('without',0.00858187),('withstand',0.188552),('women',0.00479888),('won',0.19095),('wooden',0.30103),('woofer',0.30103),('work',0.054551),('workflow',0.30103),('working',0.176286),('works',0.0222764),('world',0.0837495),('worldclass',0.30103),('worry',0.30103),('worryfree',0.30103),('worship',0.30103),('worth',0.176091),('worthy',0.30103),('would',0.0713762),('wow',0.30103),('wrinkles',0.30103),('wrist',0.00676332),('wristband',0.176091),('writing',0.00663058),('wwwskinblossomcommy',0.0377886),('x130cm',0.30103),('x180cm',0.30103),('x51',0.124939),('x5177822g',0.00811789),('xpress',0.30103),('year',0.218118),('years',0.30103),('yeast',0.30103),('yellow',0.00338066),('yemen',0.30103),('yet',0.00580633),('you',0.00165126),('young',0.30103),('your',0.00127104),('yours',0.30103),('yourself',0.0457575),('youthful',0.176091),('youtube',0.09691),('z121l',0.00582954),('z123l',0.00582954),('z125l',0.00582954),('z3740',0.30103),('zalora',0.30103),('zambia',0.30103),('zealand',0.30103),('zebra',0.00671345),('zero',0.30103),('zimbabwe',0.30103),('zipdown',0.30103),('zipped',0.30103),('zippered',0.124939),('zoom',0.0546669),('zoom1',0.30103),('zoom4x',0.30103),('zoomed',0.30103),('zooming',0.30103),('zpro',0.30103);
/*!40000 ALTER TABLE `search_total` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `semaphore`
--

DROP TABLE IF EXISTS `semaphore`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `semaphore` (
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique name.',
  `value` varchar(255) NOT NULL DEFAULT '' COMMENT 'A value for the semaphore.',
  `expire` double NOT NULL COMMENT 'A Unix timestamp with microseconds indicating when the semaphore should expire.',
  PRIMARY KEY (`name`),
  KEY `value` (`value`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Table for holding semaphores, locks, flags, etc. that...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `semaphore`
--

LOCK TABLES `semaphore` WRITE;
/*!40000 ALTER TABLE `semaphore` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `semaphore` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `sequences`
--

DROP TABLE IF EXISTS `sequences`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sequences` (
  `value` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The value of the sequence.',
  PRIMARY KEY (`value`)
) ENGINE=InnoDB AUTO_INCREMENT=30 DEFAULT CHARSET=utf8 COMMENT='Stores IDs.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequences`
--

LOCK TABLES `sequences` WRITE;
/*!40000 ALTER TABLE `sequences` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `sequences` VALUES (29);
/*!40000 ALTER TABLE `sequences` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `session_api`
--

DROP TABLE IF EXISTS `session_api`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `session_api` (
  `sid` int(11) NOT NULL AUTO_INCREMENT,
  `session_id` varchar(128) NOT NULL,
  `timestamp` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`sid`),
  UNIQUE KEY `session_id` (`session_id`),
  KEY `timestamp` (`timestamp`)
) ENGINE=InnoDB AUTO_INCREMENT=124 DEFAULT CHARSET=utf8 COMMENT='Map Session API IDs to the sessions sid field.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `session_api`
--

LOCK TABLES `session_api` WRITE;
/*!40000 ALTER TABLE `session_api` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `session_api` VALUES (122,'c_FPU6te6fIQ3QJgCv34Ap1svTf-0DYT-eiJnfPWFbQ',1499933862),(123,'0jhUgwo4jzkj9Ob2omaqxE2Z0oFrVe9V6menie844CE',1500361298);
/*!40000 ALTER TABLE `session_api` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `sessions`
--

DROP TABLE IF EXISTS `sessions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sessions` (
  `uid` int(10) unsigned NOT NULL COMMENT 'The users.uid corresponding to a session, or 0 for anonymous user.',
  `sid` varchar(128) NOT NULL COMMENT 'A session ID. The value is generated by Drupal’s session handlers.',
  `ssid` varchar(128) NOT NULL DEFAULT '' COMMENT 'Secure session ID. The value is generated by Drupal’s session handlers.',
  `hostname` varchar(128) NOT NULL DEFAULT '' COMMENT 'The IP address that last used this session ID (sid).',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when this session last requested a page. Old records are purged by PHP automatically.',
  `cache` int(11) NOT NULL DEFAULT '0' COMMENT 'The time of this user’s last post. This is used when the site has specified a minimum_cache_lifetime. See cache_get().',
  `session` longblob COMMENT 'The serialized contents of $_SESSION, an array of name/value pairs that persists across page requests by this session ID. Drupal loads $_SESSION from here at the start of each request and saves it at the end.',
  PRIMARY KEY (`sid`,`ssid`),
  KEY `timestamp` (`timestamp`),
  KEY `uid` (`uid`),
  KEY `ssid` (`ssid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Drupal’s session handlers read and write into the...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sessions`
--

LOCK TABLES `sessions` WRITE;
/*!40000 ALTER TABLE `sessions` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `sessions` VALUES (1,'w6MFeD-8Akqottg2Yd5gcdX3wzJi89XqHfbKlkZHHdc','','192.168.1.49',1500361131,0,'session_api_session|s:0:\"\";commerce_cart_orders|a:1:{i:0;s:3:\"256\";}');
/*!40000 ALTER TABLE `sessions` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `shortcut_set`
--

DROP TABLE IF EXISTS `shortcut_set`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shortcut_set` (
  `set_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'Primary Key: The menu_links.menu_name under which the set’s links are stored.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title of the set.',
  PRIMARY KEY (`set_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores information about sets of shortcuts links.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shortcut_set`
--

LOCK TABLES `shortcut_set` WRITE;
/*!40000 ALTER TABLE `shortcut_set` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `shortcut_set` VALUES ('shortcut-set-1','Default');
/*!40000 ALTER TABLE `shortcut_set` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `shortcut_set_users`
--

DROP TABLE IF EXISTS `shortcut_set_users`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shortcut_set_users` (
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The users.uid for this set.',
  `set_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'The shortcut_set.set_name that will be displayed for this user.',
  PRIMARY KEY (`uid`),
  KEY `set_name` (`set_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Maps users to shortcut sets.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shortcut_set_users`
--

LOCK TABLES `shortcut_set_users` WRITE;
/*!40000 ALTER TABLE `shortcut_set_users` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `shortcut_set_users` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `simplenews_category`
--

DROP TABLE IF EXISTS `simplenews_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `simplenews_category` (
  `tid` int(11) NOT NULL DEFAULT '0' COMMENT 'taxonomy_term_data.tid used as newsletter category.',
  `format` varchar(8) NOT NULL DEFAULT '' COMMENT 'Format of the newsletter email (plain, html).',
  `priority` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Email priority according to RFC 2156 and RFC 5231 (0 = none; 1 = highest; 2 = high; 3 = normal; 4 = low; 5 = lowest).',
  `receipt` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Boolean indicating request for email receipt confirmation according to RFC 2822.',
  `from_name` varchar(128) NOT NULL DEFAULT '' COMMENT 'Sender name for newsletter emails.',
  `email_subject` varchar(255) NOT NULL DEFAULT '' COMMENT 'Subject of newsletter email. May contain tokens.',
  `from_address` varchar(64) NOT NULL DEFAULT '' COMMENT 'Sender address for newsletter emails',
  `hyperlinks` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Flag indicating type of hyperlink conversion (1 = hyperlinks are in-line; 0 = hyperlinks are placed at email bottom).',
  `new_account` varchar(12) NOT NULL DEFAULT '' COMMENT 'How to treat subscription at account creation (none = None; on = Default on; off = Default off; silent = Invisible subscription).',
  `opt_inout` varchar(12) NOT NULL DEFAULT '' COMMENT 'How to treat subscription confirmation (hidden = Newsletter is hidden from the user; single = Single opt-in; double = Double opt-in).',
  `block` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'For this category a subscription block is available.',
  PRIMARY KEY (`tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Simplenews newsletter categories.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `simplenews_category`
--

LOCK TABLES `simplenews_category` WRITE;
/*!40000 ALTER TABLE `simplenews_category` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `simplenews_category` VALUES (1,'plain',0,0,'Azastore','[[simplenews-category:name]] [node:title]','azastore@weebpal.com',1,'none','double',1);
/*!40000 ALTER TABLE `simplenews_category` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `simplenews_mail_spool`
--

DROP TABLE IF EXISTS `simplenews_mail_spool`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `simplenews_mail_spool` (
  `msid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a mail spool record.',
  `mail` varchar(255) NOT NULL DEFAULT '' COMMENT 'The formatted email address of mail message recipient.',
  `nid` int(11) NOT NULL DEFAULT '0' COMMENT 'The node.nid of this newsletter.',
  `tid` int(11) NOT NULL DEFAULT '0' COMMENT 'The simplenews_category.tid this newsletter belongs to.',
  `status` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'The sent status of the email (0 = hold, 1 = pending, 2 = done).',
  `error` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether an error occured while sending the email.',
  `timestamp` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The time status was set or changed.',
  `data` longtext COMMENT 'A serialized array of name value pairs that are related to the email address.',
  `snid` int(11) NOT NULL DEFAULT '0' COMMENT 'Foreign key for subscriber table (simplenews_subscriptions.snid)',
  PRIMARY KEY (`msid`),
  KEY `tid` (`tid`),
  KEY `status` (`status`),
  KEY `snid_tid` (`snid`,`tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Spool for temporary storage of newsletter emails.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `simplenews_mail_spool`
--

LOCK TABLES `simplenews_mail_spool` WRITE;
/*!40000 ALTER TABLE `simplenews_mail_spool` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `simplenews_mail_spool` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `simplenews_newsletter`
--

DROP TABLE IF EXISTS `simplenews_newsletter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `simplenews_newsletter` (
  `nid` int(11) NOT NULL DEFAULT '0' COMMENT 'node that is used as newsletter.',
  `tid` int(11) NOT NULL DEFAULT '0' COMMENT 'The newsletter category simplenews_category.tid this newsletter belongs to.',
  `status` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'sent status of the newsletter issue (0 = not sent; 1 = pending; 2 = sent, 3 = send on publish).',
  `sent_subscriber_count` int(11) NOT NULL DEFAULT '0' COMMENT 'The count of subscribers to the newsletter when it was sent.',
  PRIMARY KEY (`nid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Simplenews newsletter data.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `simplenews_newsletter`
--

LOCK TABLES `simplenews_newsletter` WRITE;
/*!40000 ALTER TABLE `simplenews_newsletter` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `simplenews_newsletter` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `simplenews_subscriber`
--

DROP TABLE IF EXISTS `simplenews_subscriber`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `simplenews_subscriber` (
  `snid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary key: Unique subscriber ID.',
  `activated` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating the status of the subscription.',
  `mail` varchar(64) NOT NULL DEFAULT '' COMMENT 'The subscriber’s email address.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that has the same email address.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'Subscriber preferred language.',
  `timestamp` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'UNIX timestamp of when the user is (un)subscribed.',
  `changes` text COMMENT 'Contains the requested subscription changes',
  `created` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'UNIX timestamp of when the subscription record was added.',
  PRIMARY KEY (`snid`),
  KEY `mail` (`mail`),
  KEY `uid` (`uid`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COMMENT='Subscribers to simplenews_category. Many-to-many relation...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `simplenews_subscriber`
--

LOCK TABLES `simplenews_subscriber` WRITE;
/*!40000 ALTER TABLE `simplenews_subscriber` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `simplenews_subscriber` VALUES (1,1,'you@yourdomain.com',1,'',0,'a:0:{}',1416479559);
/*!40000 ALTER TABLE `simplenews_subscriber` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `simplenews_subscription`
--

DROP TABLE IF EXISTS `simplenews_subscription`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `simplenews_subscription` (
  `snid` int(11) NOT NULL DEFAULT '0' COMMENT 'The simplenews_subscriber.snid who is subscribed.',
  `tid` int(11) NOT NULL DEFAULT '0' COMMENT 'The category (simplenews_category.tid) the subscriber is subscribed to.',
  `status` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'A flag indicating whether the user is subscribed (1) or unsubscribed (0).',
  `timestamp` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'UNIX timestamp of when the user is (un)subscribed.',
  `source` varchar(24) NOT NULL DEFAULT '' COMMENT 'The source via which the user is (un)subscription.',
  PRIMARY KEY (`snid`,`tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Newsletter subscription data. Which subscriber is...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `simplenews_subscription`
--

LOCK TABLES `simplenews_subscription` WRITE;
/*!40000 ALTER TABLE `simplenews_subscription` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `simplenews_subscription` VALUES (1,1,1,1416479559,'website');
/*!40000 ALTER TABLE `simplenews_subscription` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `system`
--

DROP TABLE IF EXISTS `system`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `system` (
  `filename` varchar(255) NOT NULL DEFAULT '' COMMENT 'The path of the primary file for this item, relative to the Drupal root; e.g. modules/node/node.module.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the item; e.g. node.',
  `type` varchar(12) NOT NULL DEFAULT '' COMMENT 'The type of the item, either module, theme, or theme_engine.',
  `owner` varchar(255) NOT NULL DEFAULT '' COMMENT 'A theme’s ’parent’ . Can be either a theme or an engine.',
  `status` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether or not this item is enabled.',
  `bootstrap` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether this module is loaded during Drupal’s early bootstrapping phase (e.g. even before the page cache is consulted).',
  `schema_version` smallint(6) NOT NULL DEFAULT '-1' COMMENT 'The module’s database schema version number. -1 if the module is not installed (its tables do not exist); 0 or the largest N of the module’s hook_update_N() function that has either been run or existed when the module was first installed.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The order in which this module’s hooks should be invoked relative to other modules. Equal-weighted modules are ordered by name.',
  `info` blob COMMENT 'A serialized array containing information from the module’s .info file; keys can include name, description, package, version, core, dependencies, and php.',
  PRIMARY KEY (`filename`),
  KEY `system_list` (`status`,`bootstrap`,`type`,`weight`,`name`),
  KEY `type_name` (`type`,`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='A list of all modules, themes, and theme engines that are...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `system`
--

LOCK TABLES `system` WRITE;
/*!40000 ALTER TABLE `system` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `system` VALUES ('modules/aggregator/aggregator.module','aggregator','module','',0,0,-1,0,'a:14:{s:4:\"name\";s:10:\"Aggregator\";s:11:\"description\";s:57:\"Aggregates syndicated content (RSS, RDF, and Atom feeds).\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:15:\"aggregator.test\";}s:9:\"configure\";s:41:\"admin/config/services/aggregator/settings\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:14:\"aggregator.css\";s:33:\"modules/aggregator/aggregator.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/aggregator/tests/aggregator_test.module','aggregator_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:23:\"Aggregator module tests\";s:11:\"description\";s:46:\"Support module for aggregator related testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/block/block.module','block','module','',1,0,7009,-5,'a:13:{s:4:\"name\";s:5:\"Block\";s:11:\"description\";s:140:\"Controls the visual building blocks a page is constructed with. Blocks are boxes of content rendered into an area, or region, of a web page.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"block.test\";}s:9:\"configure\";s:21:\"admin/structure/block\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/block/tests/block_test.module','block_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:10:\"Block test\";s:11:\"description\";s:21:\"Provides test blocks.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/blog/blog.module','blog','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:4:\"Blog\";s:11:\"description\";s:25:\"Enables multi-user blogs.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"blog.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/book/book.module','book','module','',0,0,-1,0,'a:14:{s:4:\"name\";s:4:\"Book\";s:11:\"description\";s:66:\"Allows users to create and organize related content in an outline.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"book.test\";}s:9:\"configure\";s:27:\"admin/content/book/settings\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"book.css\";s:21:\"modules/book/book.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/color/color.module','color','module','',1,0,7001,0,'a:12:{s:4:\"name\";s:5:\"Color\";s:11:\"description\";s:70:\"Allows administrators to change the color scheme of compatible themes.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"color.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/comment/comment.module','comment','module','',1,0,7009,0,'a:14:{s:4:\"name\";s:7:\"Comment\";s:11:\"description\";s:57:\"Allows users to comment on and discuss published content.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:4:\"text\";}s:5:\"files\";a:2:{i:0;s:14:\"comment.module\";i:1;s:12:\"comment.test\";}s:9:\"configure\";s:21:\"admin/content/comment\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:11:\"comment.css\";s:27:\"modules/comment/comment.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/contact/contact.module','contact','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:7:\"Contact\";s:11:\"description\";s:61:\"Enables the use of both personal and site-wide contact forms.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:12:\"contact.test\";}s:9:\"configure\";s:23:\"admin/structure/contact\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/contextual/contextual.module','contextual','module','',1,0,0,0,'a:12:{s:4:\"name\";s:16:\"Contextual links\";s:11:\"description\";s:75:\"Provides contextual links to perform actions related to elements on a page.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:15:\"contextual.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/dashboard/dashboard.module','dashboard','module','',1,0,0,0,'a:13:{s:4:\"name\";s:9:\"Dashboard\";s:11:\"description\";s:136:\"Provides a dashboard page in the administrative interface for organizing administrative tasks and tracking information within your site.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:5:\"files\";a:1:{i:0;s:14:\"dashboard.test\";}s:12:\"dependencies\";a:1:{i:0;s:5:\"block\";}s:9:\"configure\";s:25:\"admin/dashboard/customize\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/dblog/dblog.module','dblog','module','',1,1,7003,0,'a:12:{s:4:\"name\";s:16:\"Database logging\";s:11:\"description\";s:47:\"Logs and records system events to the database.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"dblog.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/field/field.module','field','module','',1,0,7004,0,'a:14:{s:4:\"name\";s:5:\"Field\";s:11:\"description\";s:57:\"Field API to add fields to entities like nodes and users.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:4:{i:0;s:12:\"field.module\";i:1;s:16:\"field.attach.inc\";i:2;s:20:\"field.info.class.inc\";i:3;s:16:\"tests/field.test\";}s:12:\"dependencies\";a:1:{i:0;s:17:\"field_sql_storage\";}s:8:\"required\";b:1;s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:15:\"theme/field.css\";s:29:\"modules/field/theme/field.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/field/modules/field_sql_storage/field_sql_storage.module','field_sql_storage','module','',1,0,7002,0,'a:13:{s:4:\"name\";s:17:\"Field SQL storage\";s:11:\"description\";s:37:\"Stores field data in an SQL database.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:22:\"field_sql_storage.test\";}s:8:\"required\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/field/modules/list/list.module','list','module','',1,0,7002,0,'a:14:{s:4:\"name\";s:4:\"List\";s:11:\"description\";s:69:\"Defines list field types. Use with Options to create selection lists.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:5:\"field\";i:1;s:7:\"options\";}s:5:\"files\";a:1:{i:0;s:15:\"tests/list.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}'),('modules/field/modules/list/tests/list_test.module','list_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:9:\"List test\";s:11:\"description\";s:41:\"Support module for the List module tests.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/field/modules/number/number.module','number','module','',1,0,0,0,'a:14:{s:4:\"name\";s:6:\"Number\";s:11:\"description\";s:28:\"Defines numeric field types.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:11:\"number.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}'),('modules/field/modules/options/options.module','options','module','',1,0,0,0,'a:12:{s:4:\"name\";s:7:\"Options\";s:11:\"description\";s:82:\"Defines selection, check box and radio button widgets for text and numeric fields.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:12:\"options.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/field/modules/text/text.module','text','module','',1,0,7000,0,'a:14:{s:4:\"name\";s:4:\"Text\";s:11:\"description\";s:32:\"Defines simple text field types.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:9:\"text.test\";}s:8:\"required\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}'),('modules/field/tests/field_test.module','field_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:14:\"Field API Test\";s:11:\"description\";s:39:\"Support module for the Field API tests.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:5:\"files\";a:1:{i:0;s:21:\"field_test.entity.inc\";}s:7:\"version\";s:4:\"7.56\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/field_ui/field_ui.module','field_ui','module','',1,0,0,0,'a:12:{s:4:\"name\";s:8:\"Field UI\";s:11:\"description\";s:33:\"User interface for the Field API.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:13:\"field_ui.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/file/file.module','file','module','',1,0,0,0,'a:12:{s:4:\"name\";s:4:\"File\";s:11:\"description\";s:26:\"Defines a file field type.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:15:\"tests/file.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/file/tests/file_module_test.module','file_module_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:9:\"File test\";s:11:\"description\";s:53:\"Provides hooks for testing File module functionality.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/filter/filter.module','filter','module','',1,0,7010,0,'a:14:{s:4:\"name\";s:6:\"Filter\";s:11:\"description\";s:43:\"Filters content in preparation for display.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"filter.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:28:\"admin/config/content/formats\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/forum/forum.module','forum','module','',0,0,-1,0,'a:14:{s:4:\"name\";s:5:\"Forum\";s:11:\"description\";s:27:\"Provides discussion forums.\";s:12:\"dependencies\";a:2:{i:0;s:8:\"taxonomy\";i:1;s:7:\"comment\";}s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"forum.test\";}s:9:\"configure\";s:21:\"admin/structure/forum\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:9:\"forum.css\";s:23:\"modules/forum/forum.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/help/help.module','help','module','',1,0,0,0,'a:12:{s:4:\"name\";s:4:\"Help\";s:11:\"description\";s:35:\"Manages the display of online help.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"help.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/image/image.module','image','module','',1,0,7005,0,'a:15:{s:4:\"name\";s:5:\"Image\";s:11:\"description\";s:34:\"Provides image manipulation tools.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:4:\"file\";}s:5:\"files\";a:1:{i:0;s:10:\"image.test\";}s:9:\"configure\";s:31:\"admin/config/media/image-styles\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}'),('modules/image/tests/image_module_test.module','image_module_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:10:\"Image test\";s:11:\"description\";s:69:\"Provides hook implementations for testing Image module functionality.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:24:\"image_module_test.module\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/locale/locale.module','locale','module','',1,0,7005,0,'a:13:{s:4:\"name\";s:6:\"Locale\";s:11:\"description\";s:119:\"Adds language handling functionality and enables the translation of the user interface to languages other than English.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"locale.test\";}s:9:\"configure\";s:30:\"admin/config/regional/language\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/locale/tests/locale_test.module','locale_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:11:\"Locale Test\";s:11:\"description\";s:42:\"Support module for the locale layer tests.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/menu/menu.module','menu','module','',1,0,7003,0,'a:13:{s:4:\"name\";s:4:\"Menu\";s:11:\"description\";s:60:\"Allows administrators to customize the site navigation menu.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"menu.test\";}s:9:\"configure\";s:20:\"admin/structure/menu\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/node/node.module','node','module','',1,0,7016,0,'a:15:{s:4:\"name\";s:4:\"Node\";s:11:\"description\";s:66:\"Allows content to be submitted to the site and displayed on pages.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:11:\"node.module\";i:1;s:9:\"node.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:21:\"admin/structure/types\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"node.css\";s:21:\"modules/node/node.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/node/tests/node_access_test.module','node_access_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:24:\"Node module access tests\";s:11:\"description\";s:43:\"Support module for node permission testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/node/tests/node_test.module','node_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:17:\"Node module tests\";s:11:\"description\";s:40:\"Support module for node related testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/node/tests/node_test_exception.module','node_test_exception','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:27:\"Node module exception tests\";s:11:\"description\";s:50:\"Support module for node related exception testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/openid/openid.module','openid','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:6:\"OpenID\";s:11:\"description\";s:48:\"Allows users to log into your site using OpenID.\";s:7:\"version\";s:4:\"7.56\";s:7:\"package\";s:4:\"Core\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"openid.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/openid/tests/openid_test.module','openid_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:21:\"OpenID dummy provider\";s:11:\"description\";s:33:\"OpenID provider used for testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"openid\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/overlay/overlay.module','overlay','module','',1,1,0,0,'a:12:{s:4:\"name\";s:7:\"Overlay\";s:11:\"description\";s:59:\"Displays the Drupal administration interface in an overlay.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/path/path.module','path','module','',1,0,0,0,'a:13:{s:4:\"name\";s:4:\"Path\";s:11:\"description\";s:28:\"Allows users to rename URLs.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"path.test\";}s:9:\"configure\";s:24:\"admin/config/search/path\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/php/php.module','php','module','',1,0,0,0,'a:12:{s:4:\"name\";s:10:\"PHP filter\";s:11:\"description\";s:50:\"Allows embedded PHP code/snippets to be evaluated.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:8:\"php.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/poll/poll.module','poll','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:4:\"Poll\";s:11:\"description\";s:95:\"Allows your site to capture votes on different topics in the form of multiple choice questions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"poll.test\";}s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"poll.css\";s:21:\"modules/poll/poll.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/profile/profile.module','profile','module','',0,0,-1,0,'a:14:{s:4:\"name\";s:7:\"Profile\";s:11:\"description\";s:36:\"Supports configurable user profiles.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:12:\"profile.test\";}s:9:\"configure\";s:27:\"admin/config/people/profile\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/rdf/rdf.module','rdf','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:3:\"RDF\";s:11:\"description\";s:148:\"Enriches your content with metadata to let other applications (e.g. search engines, aggregators) better understand its relationships and attributes.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:8:\"rdf.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/rdf/tests/rdf_test.module','rdf_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:16:\"RDF module tests\";s:11:\"description\";s:38:\"Support module for RDF module testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:1:{i:0;s:4:\"blog\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/search/search.module','search','module','',1,0,7000,0,'a:14:{s:4:\"name\";s:6:\"Search\";s:11:\"description\";s:36:\"Enables site-wide keyword searching.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:19:\"search.extender.inc\";i:1;s:11:\"search.test\";}s:9:\"configure\";s:28:\"admin/config/search/settings\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"search.css\";s:25:\"modules/search/search.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/search/tests/search_embedded_form.module','search_embedded_form','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:20:\"Search embedded form\";s:11:\"description\";s:59:\"Support module for search module testing of embedded forms.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/search/tests/search_extra_type.module','search_extra_type','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:16:\"Test search type\";s:11:\"description\";s:41:\"Support module for search module testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/search/tests/search_node_tags.module','search_node_tags','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:21:\"Test search node tags\";s:11:\"description\";s:44:\"Support module for Node search tags testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/shortcut/shortcut.module','shortcut','module','',1,0,0,0,'a:13:{s:4:\"name\";s:8:\"Shortcut\";s:11:\"description\";s:60:\"Allows users to manage customizable lists of shortcut links.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:13:\"shortcut.test\";}s:9:\"configure\";s:36:\"admin/config/user-interface/shortcut\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/simpletest/simpletest.module','simpletest','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:7:\"Testing\";s:11:\"description\";s:53:\"Provides a framework for unit and functional testing.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:50:{i:0;s:15:\"simpletest.test\";i:1;s:24:\"drupal_web_test_case.php\";i:2;s:18:\"tests/actions.test\";i:3;s:15:\"tests/ajax.test\";i:4;s:16:\"tests/batch.test\";i:5;s:15:\"tests/boot.test\";i:6;s:20:\"tests/bootstrap.test\";i:7;s:16:\"tests/cache.test\";i:8;s:17:\"tests/common.test\";i:9;s:24:\"tests/database_test.test\";i:10;s:22:\"tests/entity_crud.test\";i:11;s:32:\"tests/entity_crud_hook_test.test\";i:12;s:23:\"tests/entity_query.test\";i:13;s:16:\"tests/error.test\";i:14;s:15:\"tests/file.test\";i:15;s:23:\"tests/filetransfer.test\";i:16;s:15:\"tests/form.test\";i:17;s:16:\"tests/graph.test\";i:18;s:16:\"tests/image.test\";i:19;s:15:\"tests/lock.test\";i:20;s:15:\"tests/mail.test\";i:21;s:15:\"tests/menu.test\";i:22;s:17:\"tests/module.test\";i:23;s:16:\"tests/pager.test\";i:24;s:19:\"tests/password.test\";i:25;s:15:\"tests/path.test\";i:26;s:19:\"tests/registry.test\";i:27;s:17:\"tests/schema.test\";i:28;s:18:\"tests/session.test\";i:29;s:20:\"tests/tablesort.test\";i:30;s:16:\"tests/theme.test\";i:31;s:18:\"tests/unicode.test\";i:32;s:17:\"tests/update.test\";i:33;s:17:\"tests/xmlrpc.test\";i:34;s:26:\"tests/upgrade/upgrade.test\";i:35;s:34:\"tests/upgrade/upgrade.comment.test\";i:36;s:33:\"tests/upgrade/upgrade.filter.test\";i:37;s:32:\"tests/upgrade/upgrade.forum.test\";i:38;s:33:\"tests/upgrade/upgrade.locale.test\";i:39;s:31:\"tests/upgrade/upgrade.menu.test\";i:40;s:31:\"tests/upgrade/upgrade.node.test\";i:41;s:35:\"tests/upgrade/upgrade.taxonomy.test\";i:42;s:34:\"tests/upgrade/upgrade.trigger.test\";i:43;s:39:\"tests/upgrade/upgrade.translatable.test\";i:44;s:33:\"tests/upgrade/upgrade.upload.test\";i:45;s:31:\"tests/upgrade/upgrade.user.test\";i:46;s:36:\"tests/upgrade/update.aggregator.test\";i:47;s:33:\"tests/upgrade/update.trigger.test\";i:48;s:31:\"tests/upgrade/update.field.test\";i:49;s:30:\"tests/upgrade/update.user.test\";}s:9:\"configure\";s:41:\"admin/config/development/testing/settings\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/actions_loop_test.module','actions_loop_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:17:\"Actions loop test\";s:11:\"description\";s:39:\"Support module for action loop testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/ajax_forms_test.module','ajax_forms_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:26:\"AJAX form test mock module\";s:11:\"description\";s:25:\"Test for AJAX form calls.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/ajax_test.module','ajax_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:9:\"AJAX Test\";s:11:\"description\";s:40:\"Support module for AJAX framework tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/batch_test.module','batch_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:14:\"Batch API test\";s:11:\"description\";s:35:\"Support module for Batch API tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/boot_test_1.module','boot_test_1','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:21:\"Early bootstrap tests\";s:11:\"description\";s:39:\"A support module for hook_boot testing.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/boot_test_2.module','boot_test_2','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:21:\"Early bootstrap tests\";s:11:\"description\";s:44:\"A support module for hook_boot hook testing.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/common_test.module','common_test','module','',0,0,-1,0,'a:14:{s:4:\"name\";s:11:\"Common Test\";s:11:\"description\";s:32:\"Support module for Common tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:15:\"common_test.css\";s:40:\"modules/simpletest/tests/common_test.css\";}s:5:\"print\";a:1:{s:21:\"common_test.print.css\";s:46:\"modules/simpletest/tests/common_test.print.css\";}}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/common_test_cron_helper.module','common_test_cron_helper','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:23:\"Common Test Cron Helper\";s:11:\"description\";s:56:\"Helper module for CronRunTestCase::testCronExceptions().\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/database_test.module','database_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:13:\"Database Test\";s:11:\"description\";s:40:\"Support module for Database layer tests.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/drupal_autoload_test/drupal_autoload_test.module','drupal_autoload_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:25:\"Drupal code registry test\";s:11:\"description\";s:45:\"Support module for testing the code registry.\";s:5:\"files\";a:2:{i:0;s:34:\"drupal_autoload_test_interface.inc\";i:1;s:30:\"drupal_autoload_test_class.inc\";}s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/drupal_system_listing_compatible_test/drupal_system_listing_compatible_test.module','drupal_system_listing_compatible_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:37:\"Drupal system listing compatible test\";s:11:\"description\";s:62:\"Support module for testing the drupal_system_listing function.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/drupal_system_listing_incompatible_test/drupal_system_listing_incompatible_test.module','drupal_system_listing_incompatible_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:39:\"Drupal system listing incompatible test\";s:11:\"description\";s:62:\"Support module for testing the drupal_system_listing function.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/entity_cache_test.module','entity_cache_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:17:\"Entity cache test\";s:11:\"description\";s:40:\"Support module for testing entity cache.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:28:\"entity_cache_test_dependency\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/entity_cache_test_dependency.module','entity_cache_test_dependency','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:28:\"Entity cache test dependency\";s:11:\"description\";s:51:\"Support dependency module for testing entity cache.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/entity_crud_hook_test.module','entity_crud_hook_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:22:\"Entity CRUD Hooks Test\";s:11:\"description\";s:35:\"Support module for CRUD hook tests.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/entity_query_access_test.module','entity_query_access_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:24:\"Entity query access test\";s:11:\"description\";s:49:\"Support module for checking entity query results.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/error_test.module','error_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:10:\"Error test\";s:11:\"description\";s:47:\"Support module for error and exception testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/file_test.module','file_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:9:\"File test\";s:11:\"description\";s:39:\"Support module for file handling tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:16:\"file_test.module\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/filter_test.module','filter_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:18:\"Filter test module\";s:11:\"description\";s:33:\"Tests filter hooks and functions.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/form_test.module','form_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:12:\"FormAPI Test\";s:11:\"description\";s:34:\"Support module for Form API tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/image_test.module','image_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:10:\"Image test\";s:11:\"description\";s:39:\"Support module for image toolkit tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/menu_test.module','menu_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:15:\"Hook menu tests\";s:11:\"description\";s:37:\"Support module for menu hook testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/module_test.module','module_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:11:\"Module test\";s:11:\"description\";s:41:\"Support module for module system testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/path_test.module','path_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:15:\"Hook path tests\";s:11:\"description\";s:37:\"Support module for path hook testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/psr_0_test/psr_0_test.module','psr_0_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:16:\"PSR-0 Test cases\";s:11:\"description\";s:44:\"Test classes to be discovered by simpletest.\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/psr_4_test/psr_4_test.module','psr_4_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:16:\"PSR-4 Test cases\";s:11:\"description\";s:44:\"Test classes to be discovered by simpletest.\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/requirements1_test.module','requirements1_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:19:\"Requirements 1 Test\";s:11:\"description\";s:80:\"Tests that a module is not installed when it fails hook_requirements(\'install\').\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/requirements2_test.module','requirements2_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:19:\"Requirements 2 Test\";s:11:\"description\";s:98:\"Tests that a module is not installed when the one it depends on fails hook_requirements(\'install).\";s:12:\"dependencies\";a:2:{i:0;s:18:\"requirements1_test\";i:1;s:7:\"comment\";}s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/session_test.module','session_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:12:\"Session test\";s:11:\"description\";s:40:\"Support module for session data testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_dependencies_test.module','system_dependencies_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:22:\"System dependency test\";s:11:\"description\";s:47:\"Support module for testing system dependencies.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:1:{i:0;s:19:\"_missing_dependency\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_incompatible_core_version_dependencies_test.module','system_incompatible_core_version_dependencies_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:50:\"System incompatible core version dependencies test\";s:11:\"description\";s:47:\"Support module for testing system dependencies.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:1:{i:0;s:37:\"system_incompatible_core_version_test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_incompatible_core_version_test.module','system_incompatible_core_version_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:37:\"System incompatible core version test\";s:11:\"description\";s:47:\"Support module for testing system dependencies.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"5.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_incompatible_module_version_dependencies_test.module','system_incompatible_module_version_dependencies_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:52:\"System incompatible module version dependencies test\";s:11:\"description\";s:47:\"Support module for testing system dependencies.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:1:{i:0;s:46:\"system_incompatible_module_version_test (>2.0)\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_incompatible_module_version_test.module','system_incompatible_module_version_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:39:\"System incompatible module version test\";s:11:\"description\";s:47:\"Support module for testing system dependencies.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_project_namespace_test.module','system_project_namespace_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:29:\"System project namespace test\";s:11:\"description\";s:58:\"Support module for testing project namespace dependencies.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:1:{i:0;s:13:\"drupal:filter\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_test.module','system_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:11:\"System test\";s:11:\"description\";s:34:\"Support module for system testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:18:\"system_test.module\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/taxonomy_test.module','taxonomy_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:20:\"Taxonomy test module\";s:11:\"description\";s:45:\"\"Tests functions and hooks not used in core\".\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:1:{i:0;s:8:\"taxonomy\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/theme_test.module','theme_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:10:\"Theme test\";s:11:\"description\";s:40:\"Support module for theme system testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/update_script_test.module','update_script_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:18:\"Update script test\";s:11:\"description\";s:41:\"Support module for update script testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/update_test_1.module','update_test_1','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:11:\"Update test\";s:11:\"description\";s:34:\"Support module for update testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/update_test_2.module','update_test_2','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:11:\"Update test\";s:11:\"description\";s:34:\"Support module for update testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/update_test_3.module','update_test_3','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:11:\"Update test\";s:11:\"description\";s:34:\"Support module for update testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/url_alter_test.module','url_alter_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:15:\"Url_alter tests\";s:11:\"description\";s:45:\"A support modules for url_alter hook testing.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/xmlrpc_test.module','xmlrpc_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:12:\"XML-RPC Test\";s:11:\"description\";s:75:\"Support module for XML-RPC tests according to the validator1 specification.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/statistics/statistics.module','statistics','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:10:\"Statistics\";s:11:\"description\";s:37:\"Logs access statistics for your site.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:15:\"statistics.test\";}s:9:\"configure\";s:30:\"admin/config/system/statistics\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/syslog/syslog.module','syslog','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:6:\"Syslog\";s:11:\"description\";s:41:\"Logs and records system events to syslog.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"syslog.test\";}s:9:\"configure\";s:32:\"admin/config/development/logging\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/system/system.module','system','module','',1,1,7081,0,'a:14:{s:4:\"name\";s:6:\"System\";s:11:\"description\";s:54:\"Handles general site configuration for administrators.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:6:{i:0;s:19:\"system.archiver.inc\";i:1;s:15:\"system.mail.inc\";i:2;s:16:\"system.queue.inc\";i:3;s:14:\"system.tar.inc\";i:4;s:18:\"system.updater.inc\";i:5;s:11:\"system.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:19:\"admin/config/system\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/system/tests/cron_queue_test.module','cron_queue_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:15:\"Cron Queue test\";s:11:\"description\";s:41:\"Support module for the cron queue runner.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/system/tests/system_cron_test.module','system_cron_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:16:\"System Cron Test\";s:11:\"description\";s:45:\"Support module for testing the system_cron().\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/taxonomy/taxonomy.module','taxonomy','module','',1,0,7011,0,'a:15:{s:4:\"name\";s:8:\"Taxonomy\";s:11:\"description\";s:38:\"Enables the categorization of content.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:7:\"options\";}s:5:\"files\";a:2:{i:0;s:15:\"taxonomy.module\";i:1;s:13:\"taxonomy.test\";}s:9:\"configure\";s:24:\"admin/structure/taxonomy\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}'),('modules/toolbar/toolbar.module','toolbar','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:7:\"Toolbar\";s:11:\"description\";s:99:\"Provides a toolbar that shows the top-level administration menu items and links from other modules.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/tracker/tracker.module','tracker','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:7:\"Tracker\";s:11:\"description\";s:45:\"Enables tracking of recent content for users.\";s:12:\"dependencies\";a:1:{i:0;s:7:\"comment\";}s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:12:\"tracker.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/translation/tests/translation_test.module','translation_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:24:\"Content Translation Test\";s:11:\"description\";s:49:\"Support module for the content translation tests.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/translation/translation.module','translation','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:19:\"Content translation\";s:11:\"description\";s:57:\"Allows content to be translated into different languages.\";s:12:\"dependencies\";a:1:{i:0;s:6:\"locale\";}s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:16:\"translation.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/trigger/tests/trigger_test.module','trigger_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:12:\"Trigger Test\";s:11:\"description\";s:33:\"Support module for Trigger tests.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:4:\"7.56\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/trigger/trigger.module','trigger','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:7:\"Trigger\";s:11:\"description\";s:90:\"Enables actions to be fired on certain system events, such as when new content is created.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:12:\"trigger.test\";}s:9:\"configure\";s:23:\"admin/structure/trigger\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/update/tests/aaa_update_test.module','aaa_update_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:15:\"AAA Update test\";s:11:\"description\";s:41:\"Support module for update module testing.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:4:\"7.56\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/update/tests/bbb_update_test.module','bbb_update_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:15:\"BBB Update test\";s:11:\"description\";s:41:\"Support module for update module testing.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:4:\"7.56\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/update/tests/ccc_update_test.module','ccc_update_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:15:\"CCC Update test\";s:11:\"description\";s:41:\"Support module for update module testing.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:4:\"7.56\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/update/tests/update_test.module','update_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:11:\"Update test\";s:11:\"description\";s:41:\"Support module for update module testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/update/update.module','update','module','',1,0,7001,0,'a:13:{s:4:\"name\";s:14:\"Update manager\";s:11:\"description\";s:104:\"Checks for available updates, and can securely install or update modules and themes via a web interface.\";s:7:\"version\";s:4:\"7.56\";s:7:\"package\";s:4:\"Core\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"update.test\";}s:9:\"configure\";s:30:\"admin/reports/updates/settings\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/user/tests/user_form_test.module','user_form_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:22:\"User module form tests\";s:11:\"description\";s:37:\"Support module for user form testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/user/user.module','user','module','',1,0,7019,0,'a:15:{s:4:\"name\";s:4:\"User\";s:11:\"description\";s:47:\"Manages the user registration and login system.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:11:\"user.module\";i:1;s:9:\"user.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:19:\"admin/config/people\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"user.css\";s:21:\"modules/user/user.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('profiles/standard/standard.profile','standard','module','',1,0,0,1000,'a:15:{s:4:\"name\";s:8:\"Standard\";s:11:\"description\";s:51:\"Install with commonly used features pre-configured.\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:21:{i:0;s:5:\"block\";i:1;s:5:\"color\";i:2;s:7:\"comment\";i:3;s:10:\"contextual\";i:4;s:9:\"dashboard\";i:5;s:4:\"help\";i:6;s:5:\"image\";i:7;s:4:\"list\";i:8;s:4:\"menu\";i:9;s:6:\"number\";i:10;s:7:\"options\";i:11;s:4:\"path\";i:12;s:8:\"taxonomy\";i:13;s:5:\"dblog\";i:14;s:6:\"search\";i:15;s:8:\"shortcut\";i:16;s:7:\"toolbar\";i:17;s:7:\"overlay\";i:18;s:8:\"field_ui\";i:19;s:4:\"file\";i:20;s:3:\"rdf\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;s:6:\"hidden\";b:1;s:8:\"required\";b:1;s:17:\"distribution_name\";s:6:\"Drupal\";}'),('sites/all/modules/addressfield/addressfield.module','addressfield','module','',1,0,7001,0,'a:14:{s:4:\"name\";s:13:\"Address Field\";s:11:\"description\";s:64:\"Manage a flexible address field, implementing the xNAL standard.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Fields\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:5:\"files\";a:3:{i:0;s:24:\"addressfield.migrate.inc\";i:1;s:50:\"views/addressfield_views_handler_field_country.inc\";i:2;s:51:\"views/addressfield_views_handler_filter_country.inc\";}s:7:\"version\";s:7:\"7.x-1.0\";s:7:\"project\";s:12:\"addressfield\";s:9:\"datestamp\";s:10:\"1421426885\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}'),('sites/all/modules/addressfield/example/addressfield_example.module','addressfield_example','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:21:\"Address Field Example\";s:11:\"description\";s:67:\"Example module for how to implement an addressfield format handler.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Fields\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:2:{i:0;s:6:\"ctools\";i:1;s:12:\"addressfield\";}s:7:\"version\";s:7:\"7.x-1.0\";s:7:\"project\";s:12:\"addressfield\";s:9:\"datestamp\";s:10:\"1421426885\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/admin_menu/admin_devel/admin_devel.module','admin_devel','module','',1,0,0,0,'a:13:{s:4:\"name\";s:32:\"Administration Development tools\";s:11:\"description\";s:76:\"Administration and debugging functionality for developers and site builders.\";s:7:\"package\";s:14:\"Administration\";s:4:\"core\";s:3:\"7.x\";s:7:\"scripts\";a:1:{s:14:\"admin_devel.js\";s:55:\"sites/all/modules/admin_menu/admin_devel/admin_devel.js\";}s:7:\"version\";s:11:\"7.x-3.0-rc5\";s:7:\"project\";s:10:\"admin_menu\";s:9:\"datestamp\";s:10:\"1419029284\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/admin_menu/admin_menu.module','admin_menu','module','',1,0,7304,100,'a:13:{s:4:\"name\";s:19:\"Administration menu\";s:11:\"description\";s:123:\"Provides a dropdown menu to most administrative tasks and other common destinations (to users with the proper permissions).\";s:7:\"package\";s:14:\"Administration\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:38:\"admin/config/administration/admin_menu\";s:12:\"dependencies\";a:1:{i:0;s:14:\"system (>7.10)\";}s:5:\"files\";a:1:{i:0;s:21:\"tests/admin_menu.test\";}s:7:\"version\";s:11:\"7.x-3.0-rc5\";s:7:\"project\";s:10:\"admin_menu\";s:9:\"datestamp\";s:10:\"1419029284\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/admin_menu/admin_menu_toolbar/admin_menu_toolbar.module','admin_menu_toolbar','module','',1,0,6300,101,'a:12:{s:4:\"name\";s:33:\"Administration menu Toolbar style\";s:11:\"description\";s:17:\"A better Toolbar.\";s:7:\"package\";s:14:\"Administration\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:10:\"admin_menu\";}s:7:\"version\";s:11:\"7.x-3.0-rc5\";s:7:\"project\";s:10:\"admin_menu\";s:9:\"datestamp\";s:10:\"1419029284\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/backup_migrate/backup_migrate.module','backup_migrate','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:18:\"Backup and Migrate\";s:11:\"description\";s:76:\"Backup the Drupal database and files or migrate them to another environment.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:25:\"includes/destinations.inc\";i:1;s:21:\"includes/profiles.inc\";i:2;s:22:\"includes/schedules.inc\";}s:9:\"configure\";s:34:\"admin/config/system/backup_migrate\";s:7:\"version\";s:7:\"7.x-3.0\";s:7:\"project\";s:14:\"backup_migrate\";s:9:\"datestamp\";s:10:\"1401209057\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/bean/bean.module','bean','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:4:\"Bean\";s:11:\"description\";s:28:\"Create Bean (Block Entities)\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:12:{i:0;s:22:\"includes/bean.core.inc\";i:1;s:22:\"includes/bean.info.inc\";i:2;s:28:\"plugins/BeanPlugin.class.php\";i:3;s:29:\"plugins/BeanDefault.class.php\";i:4;s:37:\"includes/translation.handler.bean.inc\";i:5;s:36:\"includes/bean.inline_entity_form.inc\";i:6;s:40:\"views/views_handler_filter_bean_type.inc\";i:7;s:39:\"views/views_handler_field_bean_type.inc\";i:8;s:44:\"views/views_handler_field_bean_edit_link.inc\";i:9;s:46:\"views/views_handler_field_bean_delete_link.inc\";i:10;s:45:\"views/views_handler_field_bean_operations.inc\";i:11;s:9:\"bean.test\";}s:12:\"dependencies\";a:2:{i:0;s:18:\"entity (>=7.x-1.0)\";i:1;s:6:\"ctools\";}s:7:\"package\";s:4:\"Bean\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:4:\"bean\";s:9:\"datestamp\";s:10:\"1425439382\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/bean/bean_admin_ui/bean_admin_ui.module','bean_admin_ui','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:13:\"Bean Admin UI\";s:11:\"description\";s:47:\"Add the ability to create Block Types in the UI\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:20:\"bean_admin_ui.module\";i:1;s:28:\"plugins/BeanCustom.class.php\";}s:12:\"dependencies\";a:1:{i:0;s:4:\"bean\";}s:9:\"configure\";s:27:\"admin/structure/block-types\";s:7:\"package\";s:4:\"Bean\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:4:\"bean\";s:9:\"datestamp\";s:10:\"1425439382\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/bean/bean_all/bean_all.module','bean_all','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:8:\"Bean All\";s:11:\"description\";s:32:\"Integrate all blocks with beans.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:15:\"plugins/all.inc\";}s:12:\"dependencies\";a:3:{i:0;s:4:\"bean\";i:1;s:5:\"block\";i:2;s:4:\"menu\";}s:7:\"package\";s:4:\"Bean\";s:7:\"version\";s:7:\"7.x-1.8\";s:7:\"project\";s:4:\"bean\";s:9:\"datestamp\";s:10:\"1412260740\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/bean/bean_entitycache/bean_entitycache.module','bean_entitycache','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:18:\"Bean - Entitycache\";s:11:\"description\";s:54:\"Integrates the Bean module with the Entitycache module\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:27:\"Performance and scalability\";s:5:\"files\";a:1:{i:0;s:34:\"includes/bean_entitycache.core.inc\";}s:12:\"dependencies\";a:2:{i:0;s:4:\"bean\";i:1;s:11:\"entitycache\";}s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:4:\"bean\";s:9:\"datestamp\";s:10:\"1425439382\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/bean/bean_usage/bean_usage.module','bean_usage','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:10:\"Bean Usage\";s:11:\"description\";s:32:\"View Bean (Block Entities) Usage\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:4:\"bean\";i:1;s:14:\"blockreference\";}s:7:\"package\";s:4:\"Bean\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:4:\"bean\";s:9:\"datestamp\";s:10:\"1425439382\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/bean/bean_uuid/bean_uuid.module','bean_uuid','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:9:\"Bean UUID\";s:11:\"description\";s:60:\"Allow deploying bean blocks through Deploy and UUID modules.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:4:\"bean\";i:1;s:4:\"uuid\";}s:7:\"package\";s:4:\"Bean\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:4:\"bean\";s:9:\"datestamp\";s:10:\"1425439382\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/bean/tests/bean_test.module','bean_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:9:\"Bean Test\";s:11:\"description\";s:29:\"Creates test plugins for bean\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:4:\"bean\";}s:5:\"files\";a:1:{i:0;s:16:\"bean_test.module\";}s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:4:\"bean\";s:9:\"datestamp\";s:10:\"1425439382\";s:5:\"mtime\";i:1499933463;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/better_exposed_filters/better_exposed_filters.module','better_exposed_filters','module','',1,0,7000,0,'a:12:{s:4:\"name\";s:22:\"Better Exposed Filters\";s:11:\"description\";s:70:\"Allow the use of checkboxes or radio buttons for exposed Views filters\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Views\";s:12:\"dependencies\";a:1:{i:0;s:5:\"views\";}s:5:\"files\";a:2:{i:0;s:46:\"better_exposed_filters_exposed_form_plugin.inc\";i:1;s:33:\"tests/better_exposed_filters.test\";}s:7:\"version\";s:7:\"7.x-3.4\";s:7:\"project\";s:22:\"better_exposed_filters\";s:9:\"datestamp\";s:10:\"1485926287\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/better_exposed_filters/tests/bef_test_content/bef_test_content.module','bef_test_content','module','',0,0,-1,0,'a:15:{s:4:\"name\";s:16:\"BEF Test Content\";s:11:\"description\";s:53:\"Content and Views for testing Better Exposed Filters.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:9:\"BEF Tests\";s:12:\"dependencies\";a:9:{i:0;s:22:\"better_exposed_filters\";i:1;s:4:\"date\";i:2;s:8:\"features\";i:3;s:4:\"list\";i:4;s:6:\"number\";i:5;s:8:\"taxonomy\";i:6;s:4:\"text\";i:7;s:5:\"views\";i:8;s:13:\"views_content\";}s:8:\"features\";a:7:{s:6:\"ctools\";a:1:{i:0;s:23:\"views:views_default:3.0\";}s:12:\"features_api\";a:1:{i:0;s:5:\"api:2\";}s:10:\"field_base\";a:7:{i:0;s:19:\"field_bef_test_body\";i:1;s:19:\"field_bef_test_date\";i:2;s:22:\"field_bef_test_integer\";i:3;s:22:\"field_bef_test_letters\";i:4;s:23:\"field_bef_test_location\";i:5;s:22:\"field_bef_test_numbers\";i:6;s:20:\"field_bef_test_price\";}s:14:\"field_instance\";a:7:{i:0;s:33:\"node-bef_test-field_bef_test_body\";i:1;s:33:\"node-bef_test-field_bef_test_date\";i:2;s:36:\"node-bef_test-field_bef_test_integer\";i:3;s:36:\"node-bef_test-field_bef_test_letters\";i:4;s:37:\"node-bef_test-field_bef_test_location\";i:5;s:36:\"node-bef_test-field_bef_test_numbers\";i:6;s:34:\"node-bef_test-field_bef_test_price\";}s:4:\"node\";a:1:{i:0;s:8:\"bef_test\";}s:8:\"taxonomy\";a:1:{i:0;s:26:\"taxonomy-bef_test-location\";}s:10:\"views_view\";a:1:{i:0;s:13:\"bef_test_view\";}}s:16:\"features_exclude\";a:2:{s:12:\"dependencies\";a:2:{s:6:\"ctools\";s:6:\"ctools\";s:7:\"options\";s:7:\"options\";}s:5:\"field\";a:7:{s:18:\"node-bef_test-body\";s:18:\"node-bef_test-body\";s:27:\"node-bef_test-field_letters\";s:27:\"node-bef_test-field_letters\";s:27:\"node-bef_test-field_numbers\";s:27:\"node-bef_test-field_numbers\";s:28:\"node-bef_test-field_location\";s:28:\"node-bef_test-field_location\";s:27:\"node-bef_test-field_integer\";s:27:\"node-bef_test-field_integer\";s:25:\"node-bef_test-field_price\";s:25:\"node-bef_test-field_price\";s:24:\"node-bef_test-field_date\";s:24:\"node-bef_test-field_date\";}}s:6:\"hidden\";s:1:\"1\";s:7:\"version\";s:7:\"7.x-3.4\";s:7:\"project\";s:22:\"better_exposed_filters\";s:9:\"datestamp\";s:10:\"1485926287\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/block_class/block_class.module','block_class','module','',1,0,7103,0,'a:13:{s:4:\"name\";s:11:\"Block Class\";s:11:\"description\";s:39:\"Allows assigning CSS classes to blocks.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"block\";}s:5:\"files\";a:1:{i:0;s:16:\"block_class.test\";}s:17:\"test_dependencies\";a:3:{i:0;s:7:\"context\";i:1;s:14:\"features (2.x)\";i:2;s:14:\"features_extra\";}s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:11:\"block_class\";s:9:\"datestamp\";s:10:\"1450415951\";s:5:\"mtime\";i:1499933463;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/block_class/tests/block_class_fe_block_test.module','block_class_fe_block_test','module','',0,0,-1,0,'a:14:{s:4:\"name\";s:44:\"Block Class FE Block Integration Test Helper\";s:11:\"description\";s:99:\"Helper module for testing the integration of Block Class with Features through the FE Block module.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:8:\"Features\";s:12:\"dependencies\";a:1:{i:0;s:8:\"fe_block\";}s:8:\"features\";a:2:{s:17:\"fe_block_settings\";a:1:{i:0;s:11:\"user-online\";}s:12:\"features_api\";a:1:{i:0;s:5:\"api:2\";}}s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:11:\"block_class\";s:9:\"datestamp\";s:10:\"1450415951\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/chosen/chosen.module','chosen','module','',1,0,7203,0,'a:13:{s:4:\"name\";s:6:\"Chosen\";s:11:\"description\";s:104:\"Makes select elements more user-friendly using <a href=\"http://harvesthq.github.com/chosen/\">Chosen</a>.\";s:7:\"package\";s:14:\"User interface\";s:9:\"configure\";s:34:\"admin/config/user-interface/chosen\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:13:\"7.x-2.0-beta4\";s:7:\"project\";s:6:\"chosen\";s:9:\"datestamp\";s:10:\"1394256505\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ckeditor/ckeditor.module','ckeditor','module','',1,0,7005,0,'a:13:{s:4:\"name\";s:8:\"CKEditor\";s:11:\"description\";s:76:\"Enables CKEditor (WYSIWYG HTML editor) for use instead of plain text fields.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:14:\"User interface\";s:9:\"configure\";s:29:\"admin/config/content/ckeditor\";s:7:\"version\";s:8:\"7.x-1.16\";s:7:\"project\";s:8:\"ckeditor\";s:9:\"datestamp\";s:10:\"1413311935\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/cloud_zoom/cloud_zoom.module','cloud_zoom','module','',1,0,0,0,'a:12:{s:4:\"name\";s:10:\"Cloud Zoom\";s:11:\"description\";s:40:\"Cloud Zoom (Professor Cloud) integration\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:10:\"Cloud Zoom\";s:12:\"dependencies\";a:1:{i:0;s:5:\"image\";}s:5:\"files\";a:1:{i:0;s:17:\"cloud_zoom.module\";}s:7:\"version\";s:13:\"7.x-1.1+1-dev\";s:7:\"project\";s:10:\"cloud_zoom\";s:9:\"datestamp\";s:10:\"1380559092\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce/commerce.module','commerce','module','',1,0,7102,1,'a:12:{s:4:\"name\";s:8:\"Commerce\";s:11:\"description\";s:115:\"Defines features and functions common to the Commerce modules. Must be enabled to uninstall other Commerce modules.\";s:7:\"package\";s:8:\"Commerce\";s:12:\"dependencies\";a:3:{i:0;s:6:\"system\";i:1;s:6:\"entity\";i:2;s:5:\"rules\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:24:\"tests/commerce_base.test\";i:1;s:32:\"includes/commerce.controller.inc\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce/commerce_ui.module','commerce_ui','module','',1,0,0,0,'a:12:{s:4:\"name\";s:11:\"Commerce UI\";s:11:\"description\";s:68:\"Defines menu items common to the various Drupal Commerce UI modules.\";s:7:\"package\";s:8:\"Commerce\";s:12:\"dependencies\";a:1:{i:0;s:8:\"commerce\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce/modules/cart/commerce_cart.module','commerce_cart','module','',1,0,7102,0,'a:12:{s:4:\"name\";s:4:\"Cart\";s:11:\"description\";s:61:\"Implements the shopping cart system and add to cart features.\";s:7:\"package\";s:8:\"Commerce\";s:12:\"dependencies\";a:10:{i:0;s:8:\"commerce\";i:1;s:17:\"commerce_checkout\";i:2;s:18:\"commerce_line_item\";i:3;s:14:\"commerce_order\";i:4;s:16:\"commerce_product\";i:5;s:24:\"commerce_product_pricing\";i:6;s:26:\"commerce_product_reference\";i:7;s:6:\"entity\";i:8;s:5:\"rules\";i:9;s:5:\"views\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:5:{i:0;s:72:\"includes/views/handlers/commerce_cart_handler_field_add_to_cart_form.inc\";i:1;s:71:\"includes/views/handlers/commerce_cart_handler_field_edit_attributes.inc\";i:2;s:87:\"includes/views/handlers/commerce_cart_plugin_argument_default_current_cart_order_id.inc\";i:3;s:65:\"includes/views/handlers/commerce_cart_handler_area_empty_text.inc\";i:4;s:24:\"tests/commerce_cart.test\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce/modules/checkout/commerce_checkout.module','commerce_checkout','module','',1,0,7103,0,'a:13:{s:4:\"name\";s:8:\"Checkout\";s:11:\"description\";s:70:\"Enable checkout as a multi-step form with customizable checkout pages.\";s:7:\"package\";s:8:\"Commerce\";s:12:\"dependencies\";a:5:{i:0;s:8:\"commerce\";i:1;s:11:\"commerce_ui\";i:2;s:14:\"commerce_order\";i:3;s:6:\"entity\";i:4;s:5:\"rules\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:30:\"admin/commerce/config/checkout\";s:5:\"files\";a:1:{i:0;s:28:\"tests/commerce_checkout.test\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce/modules/customer/commerce_customer.module','commerce_customer','module','',1,0,7102,0,'a:12:{s:4:\"name\";s:8:\"Customer\";s:11:\"description\";s:59:\"Defines the Customer entity with Address Field integration.\";s:7:\"package\";s:8:\"Commerce\";s:12:\"dependencies\";a:3:{i:0;s:12:\"addressfield\";i:1;s:8:\"commerce\";i:2;s:6:\"entity\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:8:{i:0;s:49:\"includes/commerce_customer_profile.controller.inc\";i:1;s:69:\"includes/views/handlers/commerce_customer_handler_area_empty_text.inc\";i:2;s:76:\"includes/views/handlers/commerce_customer_handler_field_customer_profile.inc\";i:3;s:81:\"includes/views/handlers/commerce_customer_handler_field_customer_profile_link.inc\";i:4;s:88:\"includes/views/handlers/commerce_customer_handler_field_customer_profile_link_delete.inc\";i:5;s:86:\"includes/views/handlers/commerce_customer_handler_field_customer_profile_link_edit.inc\";i:6;s:81:\"includes/views/handlers/commerce_customer_handler_field_customer_profile_type.inc\";i:7;s:82:\"includes/views/handlers/commerce_customer_handler_filter_customer_profile_type.inc\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce/modules/customer/commerce_customer_ui.module','commerce_customer_ui','module','',1,0,0,0,'a:13:{s:4:\"name\";s:11:\"Customer UI\";s:11:\"description\";s:80:\"Exposes a default UI for Customers through profile edit forms and default Views.\";s:7:\"package\";s:8:\"Commerce\";s:12:\"dependencies\";a:5:{i:0;s:8:\"field_ui\";i:1;s:8:\"commerce\";i:2;s:11:\"commerce_ui\";i:3;s:17:\"commerce_customer\";i:4;s:5:\"views\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:38:\"admin/commerce/customer-profiles/types\";s:5:\"files\";a:1:{i:0;s:31:\"tests/commerce_customer_ui.test\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce/modules/customer/tests/commerce_customer_profile_dummy_type.module','commerce_customer_profile_dummy_type','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:31:\"Commerce Customer Dummy Profile\";s:11:\"description\";s:79:\"Defines a dummy customer profile type for use in certain Customer module tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:8:\"7.x-1.13\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce/modules/line_item/commerce_line_item.module','commerce_line_item','module','',1,0,7101,0,'a:12:{s:4:\"name\";s:9:\"Line Item\";s:11:\"description\";s:53:\"Defines the Line Item entity and associated features.\";s:7:\"package\";s:8:\"Commerce\";s:12:\"dependencies\";a:4:{i:0;s:8:\"commerce\";i:1;s:14:\"commerce_price\";i:2;s:6:\"entity\";i:3;s:5:\"rules\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:9:{i:0;s:42:\"includes/commerce_line_item.controller.inc\";i:1;s:77:\"includes/views/handlers/commerce_line_item_handler_area_line_item_summary.inc\";i:2;s:86:\"includes/views/handlers/commerce_line_item_handler_argument_line_item_line_item_id.inc\";i:3;s:76:\"includes/views/handlers/commerce_line_item_handler_field_line_item_title.inc\";i:4;s:75:\"includes/views/handlers/commerce_line_item_handler_field_line_item_type.inc\";i:5;s:85:\"includes/views/handlers/commerce_line_item_handler_filter_line_item_is_referenced.inc\";i:6;s:76:\"includes/views/handlers/commerce_line_item_handler_filter_line_item_type.inc\";i:7;s:74:\"includes/views/handlers/commerce_line_item_handler_field_edit_quantity.inc\";i:8;s:72:\"includes/views/handlers/commerce_line_item_handler_field_edit_delete.inc\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce/modules/line_item/commerce_line_item_ui.module','commerce_line_item_ui','module','',1,0,0,0,'a:13:{s:4:\"name\";s:12:\"Line Item UI\";s:11:\"description\";s:83:\"Exposes a default UI for Line Items through line item type forms and default Views.\";s:7:\"package\";s:8:\"Commerce\";s:12:\"dependencies\";a:5:{i:0;s:8:\"field_ui\";i:1;s:8:\"commerce\";i:2;s:11:\"commerce_ui\";i:3;s:18:\"commerce_line_item\";i:4;s:5:\"views\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:32:\"admin/commerce/config/line-items\";s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce/modules/order/commerce_order.module','commerce_order','module','',1,0,7109,0,'a:12:{s:4:\"name\";s:5:\"Order\";s:11:\"description\";s:49:\"Defines the Order entity and associated features.\";s:7:\"package\";s:8:\"Commerce\";s:12:\"dependencies\";a:6:{i:0;s:8:\"commerce\";i:1;s:17:\"commerce_customer\";i:2;s:18:\"commerce_line_item\";i:3;s:14:\"commerce_price\";i:4;s:6:\"entity\";i:5;s:5:\"rules\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:19:{i:0;s:38:\"includes/commerce_order.controller.inc\";i:1;s:66:\"includes/views/handlers/commerce_order_handler_area_empty_text.inc\";i:2;s:67:\"includes/views/handlers/commerce_order_handler_area_order_total.inc\";i:3;s:74:\"includes/views/handlers/commerce_order_handler_argument_order_order_id.inc\";i:4;s:62:\"includes/views/handlers/commerce_order_handler_field_order.inc\";i:5;s:69:\"includes/views/handlers/commerce_order_handler_field_order_status.inc\";i:6;s:68:\"includes/views/handlers/commerce_order_handler_field_order_state.inc\";i:7;s:67:\"includes/views/handlers/commerce_order_handler_field_order_type.inc\";i:8;s:67:\"includes/views/handlers/commerce_order_handler_field_order_link.inc\";i:9;s:74:\"includes/views/handlers/commerce_order_handler_field_order_link_delete.inc\";i:10;s:72:\"includes/views/handlers/commerce_order_handler_field_order_link_edit.inc\";i:11;s:67:\"includes/views/handlers/commerce_order_handler_field_order_mail.inc\";i:12;s:73:\"includes/views/handlers/commerce_order_handler_field_order_operations.inc\";i:13;s:70:\"includes/views/handlers/commerce_order_handler_filter_order_status.inc\";i:14;s:69:\"includes/views/handlers/commerce_order_handler_filter_order_state.inc\";i:15;s:68:\"includes/views/handlers/commerce_order_handler_filter_order_type.inc\";i:16;s:72:\"includes/views/handlers/commerce_order_plugin_argument_validate_user.inc\";i:17;s:31:\"tests/commerce_order.rules.test\";i:18;s:25:\"tests/commerce_order.test\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce/modules/order/commerce_order_ui.module','commerce_order_ui','module','',1,0,0,0,'a:13:{s:4:\"name\";s:8:\"Order UI\";s:11:\"description\";s:75:\"Exposes a default UI for Orders through order edit forms and default Views.\";s:7:\"package\";s:8:\"Commerce\";s:12:\"dependencies\";a:6:{i:0;s:8:\"field_ui\";i:1;s:8:\"commerce\";i:2;s:11:\"commerce_ui\";i:3;s:18:\"commerce_line_item\";i:4;s:14:\"commerce_order\";i:5;s:5:\"views\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:27:\"admin/commerce/config/order\";s:5:\"files\";a:2:{i:0;s:74:\"includes/views/handlers/commerce_order_ui_handler_area_view_order_form.inc\";i:1;s:28:\"tests/commerce_order_ui.test\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce/modules/payment/commerce_payment.module','commerce_payment','module','',1,0,7103,0,'a:12:{s:4:\"name\";s:7:\"Payment\";s:11:\"description\";s:52:\"Implement core payment features for Drupal commerce.\";s:7:\"package\";s:8:\"Commerce\";s:12:\"dependencies\";a:4:{i:0;s:8:\"commerce\";i:1;s:14:\"commerce_order\";i:2;s:6:\"entity\";i:3;s:5:\"rules\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:16:{i:0;s:26:\"commerce_payment.rules.inc\";i:1;s:52:\"includes/commerce_payment_transaction.controller.inc\";i:2;s:64:\"includes/views/handlers/commerce_payment_handler_area_totals.inc\";i:3;s:65:\"includes/views/handlers/commerce_payment_handler_field_amount.inc\";i:4;s:72:\"includes/views/handlers/commerce_payment_handler_field_currency_code.inc\";i:5;s:66:\"includes/views/handlers/commerce_payment_handler_field_message.inc\";i:6;s:73:\"includes/views/handlers/commerce_payment_handler_field_payment_method.inc\";i:7;s:83:\"includes/views/handlers/commerce_payment_handler_field_payment_transaction_link.inc\";i:8;s:90:\"includes/views/handlers/commerce_payment_handler_field_payment_transaction_link_delete.inc\";i:9;s:89:\"includes/views/handlers/commerce_payment_handler_field_payment_transaction_operations.inc\";i:10;s:65:\"includes/views/handlers/commerce_payment_handler_field_status.inc\";i:11;s:74:\"includes/views/handlers/commerce_payment_handler_filter_payment_method.inc\";i:12;s:86:\"includes/views/handlers/commerce_payment_handler_filter_payment_transaction_status.inc\";i:13;s:73:\"includes/views/handlers/commerce_payment_handler_filter_currency_code.inc\";i:14;s:66:\"includes/views/handlers/commerce_payment_handler_field_balance.inc\";i:15;s:33:\"tests/commerce_payment.rules.test\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce/modules/payment/commerce_payment_ui.module','commerce_payment_ui','module','',1,0,0,0,'a:13:{s:4:\"name\";s:10:\"Payment UI\";s:11:\"description\";s:93:\"Exposes a default UI for payment method configuration and payment transaction administration.\";s:7:\"package\";s:8:\"Commerce\";s:12:\"dependencies\";a:5:{i:0;s:11:\"rules_admin\";i:1;s:8:\"commerce\";i:2;s:14:\"commerce_order\";i:3;s:17:\"commerce_order_ui\";i:4;s:16:\"commerce_payment\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:37:\"admin/commerce/config/payment-methods\";s:5:\"files\";a:1:{i:0;s:30:\"tests/commerce_payment_ui.test\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce/modules/payment/modules/commerce_payment_example.module','commerce_payment_example','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:22:\"Payment Method Example\";s:11:\"description\";s:63:\"Provides an example payment method for testing and development.\";s:7:\"package\";s:8:\"Commerce\";s:12:\"dependencies\";a:2:{i:0;s:8:\"commerce\";i:1;s:16:\"commerce_payment\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce/modules/payment/tests/commerce_payment_dummy_offsite.module','commerce_payment_dummy_offsite','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:29:\"Commerce payment offsite test\";s:11:\"description\";s:52:\"Support module for customer payment related testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:8:\"7.x-1.13\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce/modules/price/commerce_price.module','commerce_price','module','',1,0,7100,0,'a:12:{s:4:\"name\";s:5:\"Price\";s:11:\"description\";s:54:\"Defines the price field and a price alteration system.\";s:7:\"package\";s:8:\"Commerce\";s:12:\"dependencies\";a:1:{i:0;s:8:\"commerce\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:24:\"commerce_price.rules.inc\";i:1;s:71:\"includes/views/handlers/commerce_price_handler_field_commerce_price.inc\";i:2;s:79:\"includes/views/handlers/commerce_price_handler_filter_commerce_price_amount.inc\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce/modules/product/commerce_product.module','commerce_product','module','',1,0,7104,0,'a:12:{s:4:\"name\";s:7:\"Product\";s:11:\"description\";s:51:\"Defines the Product entity and associated features.\";s:7:\"package\";s:8:\"Commerce\";s:12:\"dependencies\";a:2:{i:0;s:8:\"commerce\";i:1;s:14:\"commerce_price\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:12:{i:0;s:40:\"includes/commerce_product.controller.inc\";i:1;s:68:\"includes/views/handlers/commerce_product_handler_area_empty_text.inc\";i:2;s:72:\"includes/views/handlers/commerce_product_handler_argument_product_id.inc\";i:3;s:66:\"includes/views/handlers/commerce_product_handler_field_product.inc\";i:4;s:71:\"includes/views/handlers/commerce_product_handler_field_product_type.inc\";i:5;s:71:\"includes/views/handlers/commerce_product_handler_field_product_link.inc\";i:6;s:78:\"includes/views/handlers/commerce_product_handler_field_product_link_delete.inc\";i:7;s:76:\"includes/views/handlers/commerce_product_handler_field_product_link_edit.inc\";i:8;s:77:\"includes/views/handlers/commerce_product_handler_field_product_operations.inc\";i:9;s:72:\"includes/views/handlers/commerce_product_handler_filter_product_type.inc\";i:10;s:49:\"includes/commerce_product.translation_handler.inc\";i:11;s:27:\"tests/commerce_product.test\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce/modules/product/commerce_product_ui.module','commerce_product_ui','module','',1,0,7100,0,'a:13:{s:4:\"name\";s:10:\"Product UI\";s:11:\"description\";s:79:\"Exposes a default UI for Products through product edit forms and default Views.\";s:7:\"package\";s:8:\"Commerce\";s:12:\"dependencies\";a:5:{i:0;s:8:\"field_ui\";i:1;s:8:\"commerce\";i:2;s:11:\"commerce_ui\";i:3;s:16:\"commerce_product\";i:4;s:5:\"views\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:29:\"admin/commerce/products/types\";s:5:\"files\";a:1:{i:0;s:30:\"tests/commerce_product_ui.test\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce/modules/product/tests/commerce_product_crud_test.module','commerce_product_crud_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:26:\"Commerce product crud test\";s:11:\"description\";s:43:\"Support module for product related testing.\";s:7:\"package\";s:7:\"Testing\";s:12:\"dependencies\";a:1:{i:0;s:5:\"rules\";}s:7:\"version\";s:8:\"7.x-1.13\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce/modules/product_pricing/commerce_product_pricing.module','commerce_product_pricing','module','',1,0,7100,0,'a:12:{s:4:\"name\";s:15:\"Product Pricing\";s:11:\"description\";s:79:\"Enables Rules based product sell price calculation for dynamic product pricing.\";s:7:\"package\";s:8:\"Commerce\";s:12:\"dependencies\";a:5:{i:0;s:8:\"commerce\";i:1;s:14:\"commerce_price\";i:2;s:26:\"commerce_product_reference\";i:3;s:6:\"entity\";i:4;s:5:\"rules\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce/modules/product_pricing/commerce_product_pricing_ui.module','commerce_product_pricing_ui','module','',1,0,0,0,'a:13:{s:4:\"name\";s:18:\"Product Pricing UI\";s:11:\"description\";s:77:\"Exposes a UI for managing product pricing rules and pre-calculation settings.\";s:7:\"package\";s:8:\"Commerce\";s:12:\"dependencies\";a:6:{i:0;s:11:\"rules_admin\";i:1;s:8:\"commerce\";i:2;s:11:\"commerce_ui\";i:3;s:14:\"commerce_price\";i:4;s:24:\"commerce_product_pricing\";i:5;s:26:\"commerce_product_reference\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:37:\"admin/commerce/config/product-pricing\";s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce/modules/product_reference/commerce_product_reference.module','commerce_product_reference','module','',1,0,0,0,'a:12:{s:4:\"name\";s:17:\"Product Reference\";s:11:\"description\";s:65:\"Defines a product reference field and default display formatters.\";s:7:\"package\";s:8:\"Commerce\";s:12:\"dependencies\";a:6:{i:0;s:8:\"commerce\";i:1;s:18:\"commerce_line_item\";i:2;s:14:\"commerce_price\";i:3;s:16:\"commerce_product\";i:4;s:6:\"entity\";i:5;s:7:\"options\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:4:{i:0;s:93:\"includes/views/handlers/commerce_product_reference_handler_filter_node_is_product_display.inc\";i:1;s:79:\"includes/views/handlers/commerce_product_reference_handler_filter_node_type.inc\";i:2;s:92:\"includes/views/handlers/commerce_product_reference_handler_filter_product_line_item_type.inc\";i:3;s:37:\"tests/commerce_product_reference.test\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce/modules/tax/commerce_tax.module','commerce_tax','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:3:\"Tax\";s:11:\"description\";s:71:\"Define tax rates and configure tax rules for applicability and display.\";s:7:\"package\";s:8:\"Commerce\";s:12:\"dependencies\";a:6:{i:0;s:8:\"commerce\";i:1;s:18:\"commerce_line_item\";i:2;s:14:\"commerce_price\";i:3;s:24:\"commerce_product_pricing\";i:4;s:6:\"entity\";i:5;s:5:\"rules\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce/modules/tax/commerce_tax_ui.module','commerce_tax_ui','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:6:\"Tax UI\";s:11:\"description\";s:54:\"Provides a UI for creating simple tax types and rates.\";s:7:\"package\";s:8:\"Commerce\";s:12:\"dependencies\";a:3:{i:0;s:8:\"commerce\";i:1;s:11:\"commerce_ui\";i:2;s:12:\"commerce_tax\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:27:\"admin/commerce/config/taxes\";s:5:\"files\";a:1:{i:0;s:26:\"tests/commerce_tax_ui.test\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:8:\"commerce\";s:9:\"datestamp\";s:10:\"1459956613\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_cop/commerce_cop.module','commerce_cop','module','',1,0,7001,0,'a:13:{s:4:\"name\";s:32:\"Commerce Custom Offline Payments\";s:11:\"description\";s:38:\"Manage custom offline payment methods.\";s:7:\"package\";s:18:\"Commerce (contrib)\";s:12:\"dependencies\";a:2:{i:0;s:8:\"commerce\";i:1;s:16:\"commerce_payment\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:45:\"admin/commerce/config/custom-offline-payments\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:7:\"project\";s:12:\"commerce_cop\";s:9:\"datestamp\";s:10:\"1409840629\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_cop/payments/commerce_cop_bank_transfer/commerce_cop_bank_transfer.module','commerce_cop_bank_transfer','module','',1,0,0,0,'a:13:{s:4:\"name\";s:21:\"Bank Transfer payment\";s:11:\"description\";s:29:\"Bank Transfer offline payment\";s:7:\"package\";s:27:\"Commerce (offline payments)\";s:12:\"dependencies\";a:2:{i:0;s:12:\"commerce_cop\";i:1;s:8:\"features\";}s:4:\"core\";s:3:\"7.x\";s:8:\"features\";a:2:{s:31:\"commerce_custom_offline_payment\";a:1:{i:0;s:13:\"bank_transfer\";}s:12:\"features_api\";a:1:{i:0;s:5:\"api:2\";}}s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:7:\"project\";s:12:\"commerce_cop\";s:9:\"datestamp\";s:10:\"1409840629\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_cop/payments/commerce_cop_ccod/commerce_cop_ccod.module','commerce_cop_ccod','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:31:\"Credit card on Delivery payment\";s:11:\"description\";s:39:\"Credit card on Delivery offline payment\";s:7:\"package\";s:27:\"Commerce (offline payments)\";s:12:\"dependencies\";a:2:{i:0;s:12:\"commerce_cop\";i:1;s:8:\"features\";}s:4:\"core\";s:3:\"7.x\";s:8:\"features\";a:2:{s:31:\"commerce_custom_offline_payment\";a:1:{i:0;s:13:\"commerce_ccod\";}s:12:\"features_api\";a:1:{i:0;s:5:\"api:2\";}}s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:7:\"project\";s:12:\"commerce_cop\";s:9:\"datestamp\";s:10:\"1409840629\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_cop/payments/commerce_cop_cheque/commerce_cop_cheque.module','commerce_cop_cheque','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:21:\"Pay by Cheque payment\";s:11:\"description\";s:29:\"Pay by Cheque offline payment\";s:7:\"package\";s:27:\"Commerce (offline payments)\";s:12:\"dependencies\";a:2:{i:0;s:12:\"commerce_cop\";i:1;s:8:\"features\";}s:4:\"core\";s:3:\"7.x\";s:8:\"features\";a:2:{s:31:\"commerce_custom_offline_payment\";a:1:{i:0;s:15:\"commerce_cheque\";}s:12:\"features_api\";a:1:{i:0;s:5:\"api:2\";}}s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:7:\"project\";s:12:\"commerce_cop\";s:9:\"datestamp\";s:10:\"1409840629\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_cop/payments/commerce_cop_cod/commerce_cop_cod.module','commerce_cop_cod','module','',1,0,0,0,'a:13:{s:4:\"name\";s:24:\"Cash on Delivery payment\";s:11:\"description\";s:32:\"Cash on Delivery offline payment\";s:7:\"package\";s:27:\"Commerce (offline payments)\";s:12:\"dependencies\";a:2:{i:0;s:12:\"commerce_cop\";i:1;s:8:\"features\";}s:4:\"core\";s:3:\"7.x\";s:8:\"features\";a:2:{s:31:\"commerce_custom_offline_payment\";a:1:{i:0;s:12:\"commerce_cod\";}s:12:\"features_api\";a:1:{i:0;s:5:\"api:2\";}}s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:7:\"project\";s:12:\"commerce_cop\";s:9:\"datestamp\";s:10:\"1409840629\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_cop/payments/commerce_cop_pay_in_person/commerce_cop_pay_in_person.module','commerce_cop_pay_in_person','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:21:\"Pay in person payment\";s:11:\"description\";s:29:\"Pay in person offline payment\";s:7:\"package\";s:27:\"Commerce (offline payments)\";s:12:\"dependencies\";a:2:{i:0;s:12:\"commerce_cop\";i:1;s:8:\"features\";}s:4:\"core\";s:3:\"7.x\";s:8:\"features\";a:2:{s:31:\"commerce_custom_offline_payment\";a:1:{i:0;s:9:\"in_person\";}s:12:\"features_api\";a:1:{i:0;s:5:\"api:2\";}}s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:7:\"project\";s:12:\"commerce_cop\";s:9:\"datestamp\";s:10:\"1409840629\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_fancy_attributes/commerce_fancy_attributes.module','commerce_fancy_attributes','module','',1,0,0,1,'a:12:{s:4:\"name\";s:25:\"Commerce fancy attributes\";s:4:\"core\";s:3:\"7.x\";s:11:\"description\";s:69:\"Provides better-looking attribute selectors for the add to cart form.\";s:7:\"package\";s:18:\"Commerce (contrib)\";s:12:\"dependencies\";a:2:{i:0;s:8:\"taxonomy\";i:1;s:13:\"commerce_cart\";}s:7:\"version\";s:7:\"7.x-1.0\";s:7:\"project\";s:25:\"commerce_fancy_attributes\";s:9:\"datestamp\";s:10:\"1343752308\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_flat_rate/commerce_flat_rate.module','commerce_flat_rate','module','',1,0,0,0,'a:12:{s:4:\"name\";s:9:\"Flat Rate\";s:11:\"description\";s:103:\"Allows you to define any number of flat rate shipping services for customers to choose during checkout.\";s:7:\"package\";s:19:\"Commerce (shipping)\";s:12:\"dependencies\";a:3:{i:0;s:8:\"commerce\";i:1;s:17:\"commerce_shipping\";i:2;s:20:\"commerce_shipping_ui\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:7:\"project\";s:18:\"commerce_flat_rate\";s:9:\"datestamp\";s:10:\"1353122757\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_marketplace/commerce_marketplace.module','commerce_marketplace','module','',1,0,0,0,'a:13:{s:4:\"name\";s:20:\"Commerce Marketplace\";s:11:\"description\";s:51:\"Marketplace functionality on top of Drupal Commerce\";s:7:\"package\";s:20:\"Commerce Marketplace\";s:12:\"dependencies\";a:10:{i:0;s:8:\"commerce\";i:1;s:14:\"commerce_price\";i:2;s:13:\"commerce_cart\";i:3;s:14:\"commerce_order\";i:4;s:14:\"commerce_store\";i:5;s:21:\"commerce_store_access\";i:6;s:26:\"commerce_marketplace_order\";i:7;s:26:\"commerce_product_reference\";i:8;s:3:\"eck\";i:9;s:15:\"entityreference\";}s:9:\"configure\";s:26:\"admin/commerce/marketplace\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:7:\"project\";s:20:\"commerce_marketplace\";s:9:\"datestamp\";s:10:\"1408538840\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/commerce_marketplace_funds.module','commerce_marketplace_funds','module','',1,0,0,0,'a:12:{s:4:\"name\";s:26:\"Commerce Marketplace Funds\";s:11:\"description\";s:58:\"Provides funds management system for Commerce Marketplace.\";s:7:\"package\";s:20:\"Commerce Marketplace\";s:12:\"dependencies\";a:8:{i:0;s:8:\"commerce\";i:1;s:11:\"commerce_ui\";i:2;s:16:\"commerce_payment\";i:3;s:14:\"commerce_price\";i:4;s:14:\"commerce_order\";i:5;s:14:\"commerce_store\";i:6;s:21:\"commerce_store_access\";i:7;s:15:\"entityreference\";}s:5:\"files\";a:7:{i:0;s:53:\"lib/commerce_marketplace_funds.account.controller.inc\";i:1;s:49:\"lib/commerce_marketplace_funds.account.entity.inc\";i:2;s:51:\"lib/commerce_marketplace_funds.account.metadata.inc\";i:3;s:57:\"lib/commerce_marketplace_funds.transaction.controller.inc\";i:4;s:53:\"lib/commerce_marketplace_funds.transaction.entity.inc\";i:5;s:55:\"lib/commerce_marketplace_funds.transaction.metadata.inc\";i:6;s:54:\"lib/commerce_marketplace_funds.processor.interface.inc\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:7:\"project\";s:20:\"commerce_marketplace\";s:9:\"datestamp\";s:10:\"1408538840\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_marketplace/modules/commerce_marketplace_funds/modules/withdraw/commerce_marketplace_funds_withdraw.module','commerce_marketplace_funds_withdraw','module','',1,0,0,0,'a:12:{s:4:\"name\";s:45:\"Commerce Marketplace Funds Withdrawal methods\";s:11:\"description\";s:88:\"Provides funds withdrawal capabilities for Commerce Marketplace Funds Management module.\";s:7:\"package\";s:20:\"Commerce Marketplace\";s:12:\"dependencies\";a:6:{i:0;s:8:\"commerce\";i:1;s:11:\"commerce_ui\";i:2;s:16:\"commerce_payment\";i:3;s:14:\"commerce_order\";i:4;s:26:\"commerce_marketplace_funds\";i:5;s:15:\"entityreference\";}s:5:\"files\";a:7:{i:0;s:61:\"includes/commerce_marketplace_funds_withdraw.method.admin.inc\";i:1;s:66:\"includes/commerce_marketplace_funds_withdraw.method_type.admin.inc\";i:2;s:57:\"lib/commerce_marketplace_funds_withdraw.method.entity.inc\";i:3;s:61:\"lib/commerce_marketplace_funds_withdraw.method.controller.inc\";i:4;s:59:\"lib/commerce_marketplace_funds_withdraw.method.metadata.inc\";i:5;s:62:\"lib/commerce_marketplace_funds_withdraw.method_type.entity.inc\";i:6;s:66:\"lib/commerce_marketplace_funds_withdraw.method_type.controller.inc\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:7:\"project\";s:20:\"commerce_marketplace\";s:9:\"datestamp\";s:10:\"1408538840\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_marketplace/modules/commerce_marketplace_order/commerce_marketplace_order.module','commerce_marketplace_order','module','',1,0,0,0,'a:13:{s:4:\"name\";s:26:\"Commerce Marketplace Order\";s:11:\"description\";s:96:\"Creates Store Order order type and splits standard orders into Store orders on checkout complete\";s:7:\"package\";s:20:\"Commerce Marketplace\";s:12:\"dependencies\";a:6:{i:0;s:14:\"commerce_order\";i:1;s:18:\"commerce_line_item\";i:2;s:16:\"commerce_product\";i:3;s:14:\"commerce_store\";i:4;s:14:\"commerce_order\";i:5;s:17:\"commerce_shipping\";}s:9:\"configure\";s:26:\"admin/commerce/marketplace\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:7:\"project\";s:20:\"commerce_marketplace\";s:9:\"datestamp\";s:10:\"1408538840\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_marketplace/modules/commerce_marketplace_shipping/commerce_marketplace_shipping.module','commerce_marketplace_shipping','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:36:\"Commerce marketplace shipping method\";s:11:\"description\";s:55:\"Calculates store shipping rates for marketplace orders.\";s:7:\"package\";s:20:\"Commerce marketplace\";s:12:\"dependencies\";a:3:{i:0;s:17:\"commerce_shipping\";i:1;s:14:\"commerce_store\";i:2;s:26:\"commerce_marketplace_order\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:7:\"project\";s:20:\"commerce_marketplace\";s:9:\"datestamp\";s:10:\"1408538840\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_marketplace/modules/commerce_store/commerce_store.module','commerce_store','module','',1,0,0,0,'a:13:{s:4:\"name\";s:14:\"Commerce Store\";s:11:\"description\";s:67:\"Creates the commerce_store entity type used in Commerce Marketplace\";s:7:\"package\";s:20:\"Commerce Marketplace\";s:12:\"dependencies\";a:5:{i:0;s:3:\"eck\";i:1;s:15:\"entityreference\";i:2;s:14:\"commerce_order\";i:3;s:16:\"commerce_product\";i:4;s:17:\"commerce_shipping\";}s:9:\"configure\";s:26:\"admin/commerce/marketplace\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:7:\"project\";s:20:\"commerce_marketplace\";s:9:\"datestamp\";s:10:\"1408538840\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_marketplace/modules/commerce_store_access/commerce_store_access.module','commerce_store_access','module','',1,0,0,0,'a:13:{s:4:\"name\";s:26:\"Commerce Store Permissions\";s:11:\"description\";s:73:\"Allows store-level permissions and roles to be assigned to store members.\";s:7:\"package\";s:20:\"Commerce Marketplace\";s:12:\"dependencies\";a:3:{i:0;s:3:\"eck\";i:1;s:15:\"entityreference\";i:2;s:14:\"commerce_store\";}s:9:\"configure\";s:26:\"admin/commerce/marketplace\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:7:\"project\";s:20:\"commerce_marketplace\";s:9:\"datestamp\";s:10:\"1408538840\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_paypal/commerce_paypal.module','commerce_paypal','module','',1,0,0,0,'a:12:{s:4:\"name\";s:6:\"PayPal\";s:11:\"description\";s:64:\"Implements PayPal payment services for use with Drupal Commerce.\";s:7:\"package\";s:17:\"Commerce (PayPal)\";s:12:\"dependencies\";a:4:{i:0;s:8:\"commerce\";i:1;s:11:\"commerce_ui\";i:2;s:16:\"commerce_payment\";i:3;s:14:\"commerce_order\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:15:\"commerce_paypal\";s:9:\"datestamp\";s:10:\"1389740908\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_paypal/modules/ec/commerce_paypal_ec.module','commerce_paypal_ec','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:23:\"PayPal Express Checkout\";s:11:\"description\";s:63:\"Implements PayPal Express Checkout in Drupal Commerce checkout.\";s:7:\"package\";s:17:\"Commerce (PayPal)\";s:12:\"dependencies\";a:5:{i:0;s:8:\"commerce\";i:1;s:11:\"commerce_ui\";i:2;s:16:\"commerce_payment\";i:3;s:14:\"commerce_order\";i:4;s:15:\"commerce_paypal\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:15:\"commerce_paypal\";s:9:\"datestamp\";s:10:\"1389740908\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_paypal/modules/payflow/commerce_payflow.module','commerce_payflow','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:41:\"PayPal Payments Advanced and Payflow Link\";s:11:\"description\";s:112:\"Implements PayPal Payments Advanced (U.S. only) and Payflow Link Hosted Checkout pages and Transparent Redirect.\";s:7:\"package\";s:17:\"Commerce (PayPal)\";s:12:\"dependencies\";a:5:{i:0;s:8:\"commerce\";i:1;s:11:\"commerce_ui\";i:2;s:16:\"commerce_payment\";i:3;s:14:\"commerce_order\";i:4;s:15:\"commerce_paypal\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:15:\"commerce_paypal\";s:9:\"datestamp\";s:10:\"1389740908\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_paypal/modules/wpp/commerce_paypal_wpp.module','commerce_paypal_wpp','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:10:\"PayPal WPP\";s:11:\"description\";s:67:\"Implements PayPal Website Payments Pro in Drupal Commerce checkout.\";s:7:\"package\";s:17:\"Commerce (PayPal)\";s:12:\"dependencies\";a:5:{i:0;s:8:\"commerce\";i:1;s:11:\"commerce_ui\";i:2;s:16:\"commerce_payment\";i:3;s:14:\"commerce_order\";i:4;s:15:\"commerce_paypal\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:15:\"commerce_paypal\";s:9:\"datestamp\";s:10:\"1389740908\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_paypal/modules/wps/commerce_paypal_wps.module','commerce_paypal_wps','module','',1,0,0,0,'a:12:{s:4:\"name\";s:10:\"PayPal WPS\";s:11:\"description\";s:72:\"Implements PayPal Website Payments Standard in Drupal Commerce checkout.\";s:7:\"package\";s:17:\"Commerce (PayPal)\";s:12:\"dependencies\";a:5:{i:0;s:8:\"commerce\";i:1;s:11:\"commerce_ui\";i:2;s:16:\"commerce_payment\";i:3;s:14:\"commerce_order\";i:4;s:15:\"commerce_paypal\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:15:\"commerce_paypal\";s:9:\"datestamp\";s:10:\"1389740908\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_saleprice/commerce_saleprice.module','commerce_saleprice','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:19:\"Commerce Sale Price\";s:11:\"description\";s:90:\"Allows a product to be configured with a sale price that can be manually enabled/disabled.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:18:\"Commerce (contrib)\";s:3:\"php\";s:5:\"5.2.4\";s:12:\"dependencies\";a:8:{i:0;s:18:\"commerce_line_item\";i:1;s:14:\"commerce_price\";i:2;s:26:\"commerce_product_reference\";i:3;s:6:\"entity\";i:4;s:8:\"features\";i:5;s:4:\"list\";i:6;s:7:\"options\";i:7;s:5:\"rules\";}s:8:\"features\";a:3:{s:12:\"features_api\";a:1:{i:0;s:5:\"api:1\";}s:5:\"field\";a:2:{i:0;s:57:\"commerce_product-product-field_commerce_saleprice_on_sale\";i:1;s:49:\"commerce_product-product-field_commerce_saleprice\";}s:12:\"rules_config\";a:2:{i:0;s:34:\"rules_commerce_saleprice_component\";i:1;s:29:\"rules_commerce_saleprice_rule\";}}s:7:\"version\";s:13:\"7.x-1.0-beta4\";s:7:\"project\";s:18:\"commerce_saleprice\";s:9:\"datestamp\";s:10:\"1344702410\";s:5:\"mtime\";i:1499933463;s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_search_api/commerce_search_api.module','commerce_search_api','module','',1,0,0,0,'a:13:{s:4:\"name\";s:19:\"Commerce Search API\";s:11:\"description\";s:50:\"Provides Search API commerce related enhancements.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:18:\"Commerce (contrib)\";s:9:\"configure\";s:41:\"admin/commerce/config/commerce_search_api\";s:3:\"php\";s:5:\"5.2.4\";s:12:\"dependencies\";a:2:{i:0;s:26:\"commerce_product_reference\";i:1;s:10:\"search_api\";}s:5:\"files\";a:5:{i:0;s:40:\"includes/facetapi/filter_same_search.inc\";i:1;s:41:\"includes/facetapi/filter_search_start.inc\";i:2;s:45:\"includes/facetapi/widget_fancy_attributes.inc\";i:3;s:55:\"includes/commerce_search_api_product_display_filter.inc\";i:4;s:36:\"includes/callback_product_status.inc\";}s:7:\"version\";s:7:\"7.x-1.4\";s:7:\"project\";s:19:\"commerce_search_api\";s:9:\"datestamp\";s:10:\"1436974444\";s:5:\"mtime\";i:1499933463;s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_shipping/commerce_shipping.module','commerce_shipping','module','',1,0,7100,0,'a:12:{s:4:\"name\";s:8:\"Shipping\";s:11:\"description\";s:53:\"Implement core shipping features for Drupal commerce.\";s:7:\"package\";s:19:\"Commerce (shipping)\";s:12:\"dependencies\";a:5:{i:0;s:8:\"commerce\";i:1;s:18:\"commerce_line_item\";i:2;s:16:\"commerce_payment\";i:3;s:4:\"list\";i:4;s:5:\"rules\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:100:\"includes/views/handlers/commerce_shipping_handler_relationship_shipping_line_item_representative.inc\";}s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:17:\"commerce_shipping\";s:9:\"datestamp\";s:10:\"1428479882\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_shipping/commerce_shipping_ui.module','commerce_shipping_ui','module','',1,0,0,0,'a:13:{s:4:\"name\";s:11:\"Shipping UI\";s:11:\"description\";s:77:\"Provides an interface for viewing and managing shipping methods and services.\";s:7:\"package\";s:19:\"Commerce (shipping)\";s:12:\"dependencies\";a:3:{i:0;s:5:\"rules\";i:1;s:8:\"commerce\";i:2;s:17:\"commerce_shipping\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:30:\"admin/commerce/config/shipping\";s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:17:\"commerce_shipping\";s:9:\"datestamp\";s:10:\"1428479882\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_shipping/modules/commerce_shipping_example.module','commerce_shipping_example','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:23:\"Shipping Method Example\";s:11:\"description\";s:64:\"Provides an example shipping method for testing and development.\";s:7:\"package\";s:19:\"Commerce (shipping)\";s:12:\"dependencies\";a:2:{i:0;s:8:\"commerce\";i:1;s:17:\"commerce_shipping\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:17:\"commerce_shipping\";s:9:\"datestamp\";s:10:\"1428479882\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_stock/commerce_stock.module','commerce_stock','module','',1,0,0,0,'a:13:{s:4:\"name\";s:18:\"Commerce Stock API\";s:11:\"description\";s:97:\"Provides a stock management framework based on rules to manage stock levels of commerce products.\";s:7:\"package\";s:16:\"Commerce (stock)\";s:12:\"dependencies\";a:4:{i:0;s:6:\"number\";i:1;s:16:\"commerce_product\";i:2;s:14:\"commerce_order\";i:3;s:5:\"rules\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:27:\"admin/commerce/config/stock\";s:7:\"version\";s:7:\"7.x-2.1\";s:7:\"project\";s:14:\"commerce_stock\";s:9:\"datestamp\";s:10:\"1418323685\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_stock/commerce_stock_ui.module','commerce_stock_ui','module','',1,0,0,0,'a:13:{s:4:\"name\";s:17:\"Commerce stock UI\";s:11:\"description\";s:59:\"Provides an interface for viewing and managing stock rules.\";s:7:\"package\";s:16:\"Commerce (stock)\";s:12:\"dependencies\";a:3:{i:0;s:5:\"rules\";i:1;s:8:\"commerce\";i:2;s:14:\"commerce_stock\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:27:\"admin/commerce/config/stock\";s:7:\"version\";s:7:\"7.x-2.1\";s:7:\"project\";s:14:\"commerce_stock\";s:9:\"datestamp\";s:10:\"1418323685\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_stock/modules/commerce_sdf/commerce_sdf.module','commerce_sdf','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:32:\"Commerce Stock Decimal formatter\";s:11:\"description\";s:74:\"Provide a Decimal formater for converting stock levels into text messages.\";s:7:\"package\";s:16:\"Commerce (stock)\";s:12:\"dependencies\";a:1:{i:0;s:6:\"number\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-2.1\";s:7:\"project\";s:14:\"commerce_stock\";s:9:\"datestamp\";s:10:\"1418323685\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_stock/modules/commerce_ss/commerce_ss.module','commerce_ss','module','',1,0,0,0,'a:13:{s:4:\"name\";s:21:\"Commerce Simple Stock\";s:11:\"description\";s:78:\"Manage stock levels of Commerce products using a decimal level field and rules\";s:7:\"package\";s:16:\"Commerce (stock)\";s:12:\"dependencies\";a:6:{i:0;s:6:\"number\";i:1;s:16:\"commerce_product\";i:2;s:14:\"commerce_order\";i:3;s:14:\"commerce_stock\";i:4;s:17:\"commerce_checkout\";i:5;s:5:\"rules\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:30:\"admin/commerce/config/stock/ss\";s:7:\"version\";s:7:\"7.x-2.1\";s:7:\"project\";s:14:\"commerce_stock\";s:9:\"datestamp\";s:10:\"1418323685\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/commerce_stock/modules/commerce_ssr/commerce_ssr.module','commerce_ssr','module','',1,0,0,0,'a:12:{s:4:\"name\";s:27:\"Commerce Simple Stock Rules\";s:11:\"description\";s:34:\"Validation rules for simple stock.\";s:7:\"package\";s:16:\"Commerce (stock)\";s:12:\"dependencies\";a:6:{i:0;s:6:\"number\";i:1;s:16:\"commerce_product\";i:2;s:14:\"commerce_order\";i:3;s:14:\"commerce_stock\";i:4;s:11:\"commerce_ss\";i:5;s:5:\"rules\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-2.1\";s:7:\"project\";s:14:\"commerce_stock\";s:9:\"datestamp\";s:10:\"1418323685\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/context/context.module','context','module','',1,0,7000,0,'a:12:{s:4:\"name\";s:7:\"Context\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:11:\"description\";s:66:\"Provide modules with a cache that lasts for a single page request.\";s:7:\"package\";s:7:\"Context\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:18:\"tests/context.test\";i:1;s:29:\"tests/context.conditions.test\";i:2;s:28:\"tests/context.reactions.test\";}s:7:\"version\";s:7:\"7.x-3.6\";s:7:\"project\";s:7:\"context\";s:9:\"datestamp\";s:10:\"1420573188\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/context/context_layouts/context_layouts.module','context_layouts','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:15:\"Context layouts\";s:11:\"description\";s:80:\"Allow theme layer to provide multiple region layouts and integrate with context.\";s:12:\"dependencies\";a:1:{i:0;s:7:\"context\";}s:7:\"package\";s:7:\"Context\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:42:\"plugins/context_layouts_reaction_block.inc\";}s:7:\"version\";s:7:\"7.x-3.6\";s:7:\"project\";s:7:\"context\";s:9:\"datestamp\";s:10:\"1420573188\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/context/context_ui/context_ui.module','context_ui','module','',1,0,6004,0,'a:13:{s:4:\"name\";s:10:\"Context UI\";s:11:\"description\";s:68:\"Provides a simple UI for settings up a site structure using Context.\";s:12:\"dependencies\";a:1:{i:0;s:7:\"context\";}s:7:\"package\";s:7:\"Context\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:23:\"admin/structure/context\";s:5:\"files\";a:2:{i:0;s:14:\"context.module\";i:1;s:21:\"tests/context_ui.test\";}s:7:\"version\";s:7:\"7.x-3.6\";s:7:\"project\";s:7:\"context\";s:9:\"datestamp\";s:10:\"1420573188\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/context_mobile_detect/context_mobile_detect.module','context_mobile_detect','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:21:\"Context Mobile Detect\";s:11:\"description\";s:55:\"Context condition detecting if user uses mobile device.\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"package\";s:7:\"Context\";s:12:\"dependencies\";a:1:{i:0;s:7:\"context\";}s:7:\"project\";s:21:\"context_mobile_detect\";s:9:\"datestamp\";s:10:\"1352148656\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/countries/countries.module','countries','module','',1,0,7205,0,'a:14:{s:4:\"name\";s:9:\"Countries\";s:11:\"description\";s:113:\"A module that provides a FAPI / Field country element and a simple wrapper module to store / update country data.\";s:7:\"package\";s:6:\"Fields\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:6:{i:0;s:50:\"views/views_handler_argument_countries_country.inc\";i:1;s:49:\"views/views_handler_field_countries_continent.inc\";i:2;s:56:\"views/views_handler_filter_countries_continents_list.inc\";i:3;s:45:\"views/views_handler_filter_countries_list.inc\";i:4;s:21:\"countries.migrate.inc\";i:5;s:20:\"tests/countries.test\";}s:9:\"configure\";s:31:\"admin/config/regional/countries\";s:12:\"dependencies\";a:1:{i:0;s:6:\"entity\";}s:10:\"recommends\";a:1:{i:0;s:12:\"countryicons\";}s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:9:\"countries\";s:9:\"datestamp\";s:10:\"1409450929\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/countries/modules/countries_configuration/countries_configuration.module','countries_configuration','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:23:\"Countries configuration\";s:11:\"description\";s:71:\"A configuration utility module to assist storing country specific data.\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-2.3\";s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:9:\"countries\";s:9:\"datestamp\";s:10:\"1409450929\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/countries/modules/countries_example/countries_example.module','countries_example','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:17:\"Countries Example\";s:11:\"description\";s:24:\"Countries example module\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:15:\"Example modules\";s:12:\"dependencies\";a:1:{i:0;s:9:\"countries\";}s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:9:\"countries\";s:9:\"datestamp\";s:10:\"1409450929\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/countries/modules/countries_i18n/countries_i18n.module','countries_i18n','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:21:\"Countries translation\";s:11:\"description\";s:25:\"Translation of countries.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:12:\"dependencies\";a:2:{i:0;s:9:\"countries\";i:1;s:11:\"i18n_string\";}s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:9:\"countries\";s:9:\"datestamp\";s:10:\"1409450929\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/bulk_export/bulk_export.module','bulk_export','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:11:\"Bulk Export\";s:11:\"description\";s:67:\"Performs bulk exporting of data objects known about by Chaos tools.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/ctools.module','ctools','module','',1,0,7001,0,'a:12:{s:4:\"name\";s:11:\"Chaos tools\";s:11:\"description\";s:46:\"A library of helpful tools by Merlin of Chaos.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:5:\"files\";a:5:{i:0;s:20:\"includes/context.inc\";i:1;s:22:\"includes/css-cache.inc\";i:2;s:22:\"includes/math-expr.inc\";i:3;s:21:\"includes/stylizer.inc\";i:4;s:20:\"tests/css_cache.test\";}s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/ctools_access_ruleset/ctools_access_ruleset.module','ctools_access_ruleset','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:15:\"Custom rulesets\";s:11:\"description\";s:81:\"Create custom, exportable, reusable access rulesets for applications like Panels.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/ctools_ajax_sample/ctools_ajax_sample.module','ctools_ajax_sample','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:33:\"Chaos Tools (CTools) AJAX Example\";s:11:\"description\";s:41:\"Shows how to use the power of Chaos AJAX.\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/ctools_custom_content/ctools_custom_content.module','ctools_custom_content','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:20:\"Custom content panes\";s:11:\"description\";s:79:\"Create custom, exportable, reusable content panes for applications like Panels.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/ctools_plugin_example/ctools_plugin_example.module','ctools_plugin_example','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:35:\"Chaos Tools (CTools) Plugin Example\";s:11:\"description\";s:75:\"Shows how an external module can provide ctools plugins (for Panels, etc.).\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:12:\"dependencies\";a:4:{i:0;s:6:\"ctools\";i:1;s:6:\"panels\";i:2;s:12:\"page_manager\";i:3;s:13:\"advanced_help\";}s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/page_manager/page_manager.module','page_manager','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:12:\"Page manager\";s:11:\"description\";s:54:\"Provides a UI and API to manage pages within the site.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/stylizer/stylizer.module','stylizer','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:8:\"Stylizer\";s:11:\"description\";s:53:\"Create custom styles for applications such as Panels.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:12:\"dependencies\";a:2:{i:0;s:6:\"ctools\";i:1;s:5:\"color\";}s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/term_depth/term_depth.module','term_depth','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:17:\"Term Depth access\";s:11:\"description\";s:48:\"Controls access to context based upon term depth\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/tests/ctools_export_test/ctools_export_test.module','ctools_export_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:18:\"CTools export test\";s:11:\"description\";s:25:\"CTools export test module\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:6:\"hidden\";b:1;s:5:\"files\";a:1:{i:0;s:18:\"ctools_export.test\";}s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/tests/ctools_plugin_test.module','ctools_plugin_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:24:\"Chaos tools plugins test\";s:11:\"description\";s:42:\"Provides hooks for testing ctools plugins.\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:5:\"files\";a:6:{i:0;s:19:\"ctools.plugins.test\";i:1;s:17:\"object_cache.test\";i:2;s:8:\"css.test\";i:3;s:12:\"context.test\";i:4;s:20:\"math_expression.test\";i:5;s:26:\"math_expression_stack.test\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/views_content/views_content.module','views_content','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:19:\"Views content panes\";s:11:\"description\";s:104:\"Allows Views content to be used in Panels, Dashboard and other modules which use the CTools Content API.\";s:7:\"package\";s:16:\"Chaos tool suite\";s:12:\"dependencies\";a:2:{i:0;s:6:\"ctools\";i:1;s:5:\"views\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-1.9\";s:5:\"files\";a:3:{i:0;s:61:\"plugins/views/views_content_plugin_display_ctools_context.inc\";i:1;s:57:\"plugins/views/views_content_plugin_display_panel_pane.inc\";i:2;s:59:\"plugins/views/views_content_plugin_style_ctools_context.inc\";}s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/custom_breadcrumbs/custom_breadcrumbs.module','custom_breadcrumbs','module','',1,0,7001,0,'a:13:{s:4:\"name\";s:18:\"Custom breadcrumbs\";s:7:\"package\";s:18:\"Custom breadcrumbs\";s:11:\"description\";s:72:\"Allows administrators to define custom breadcrumb trails for node types.\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:46:\"admin/config/user-interface/custom-breadcrumbs\";s:5:\"files\";a:4:{i:0;s:28:\"custom_breadcrumbs.admin.inc\";i:1;s:26:\"custom_breadcrumbs.install\";i:2;s:25:\"custom_breadcrumbs.module\";i:3;s:29:\"custom_breadcrumbs_common.inc\";}s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:7:\"project\";s:18:\"custom_breadcrumbs\";s:9:\"datestamp\";s:10:\"1410287363\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/custom_breadcrumbs/custom_breadcrumbsapi/custom_breadcrumbsapi.module','custom_breadcrumbsapi','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:22:\"Custom breadcrumbs API\";s:7:\"package\";s:18:\"Custom breadcrumbs\";s:12:\"dependencies\";a:1:{i:0;s:18:\"custom_breadcrumbs\";}s:11:\"description\";s:107:\"Provides a simple API to set breadcrumbs on module pages not served by other custom breadcrumbs submodules.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:29:\"custom_breadcrumbsapi.install\";i:1;s:28:\"custom_breadcrumbsapi.module\";}s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:7:\"project\";s:18:\"custom_breadcrumbs\";s:9:\"datestamp\";s:10:\"1410287363\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/custom_breadcrumbs/custom_breadcrumbs_identifiers/custom_breadcrumbs_identifiers.module','custom_breadcrumbs_identifiers','module','',1,0,0,0,'a:13:{s:4:\"name\";s:30:\"Custom breadcrumbs identifiers\";s:7:\"package\";s:18:\"Custom breadcrumbs\";s:11:\"description\";s:52:\"Provides special identifiers for custom breadcrumbs.\";s:12:\"dependencies\";a:1:{i:0;s:18:\"custom_breadcrumbs\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:46:\"admin/config/user-interface/custom-breadcrumbs\";s:5:\"files\";a:1:{i:0;s:37:\"custom_breadcrumbs_identifiers.module\";}s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:7:\"project\";s:18:\"custom_breadcrumbs\";s:9:\"datestamp\";s:10:\"1410287363\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/custom_breadcrumbs/custom_breadcrumbs_panels/custom_breadcrumbs_panels.module','custom_breadcrumbs_panels','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:29:\"Custom breadcrumbs for panels\";s:7:\"package\";s:18:\"Custom breadcrumbs\";s:12:\"dependencies\";a:4:{i:0;s:18:\"custom_breadcrumbs\";i:1;s:6:\"panels\";i:2;s:6:\"ctools\";i:3;s:12:\"page_manager\";}s:11:\"description\";s:45:\"Provides custom breadcrumbs for panels pages.\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:46:\"admin/config/user-interface/custom-breadcrumbs\";s:5:\"files\";a:2:{i:0;s:33:\"custom_breadcrumbs_panels.install\";i:1;s:32:\"custom_breadcrumbs_panels.module\";}s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:7:\"project\";s:18:\"custom_breadcrumbs\";s:9:\"datestamp\";s:10:\"1410287363\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/custom_breadcrumbs/custom_breadcrumbs_paths/custom_breadcrumbs_paths.module','custom_breadcrumbs_paths','module','',1,0,6200,2,'a:13:{s:4:\"name\";s:28:\"Custom breadcrumbs for paths\";s:7:\"package\";s:18:\"Custom breadcrumbs\";s:12:\"dependencies\";a:1:{i:0;s:18:\"custom_breadcrumbs\";}s:11:\"description\";s:47:\"Provides custom breadcrumbs for specific paths.\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:46:\"admin/config/user-interface/custom-breadcrumbs\";s:5:\"files\";a:2:{i:0;s:32:\"custom_breadcrumbs_paths.install\";i:1;s:31:\"custom_breadcrumbs_paths.module\";}s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:7:\"project\";s:18:\"custom_breadcrumbs\";s:9:\"datestamp\";s:10:\"1410287363\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/custom_breadcrumbs/custom_breadcrumbs_taxonomy/custom_breadcrumbs_taxonomy.module','custom_breadcrumbs_taxonomy','module','',1,1,6200,11,'a:13:{s:4:\"name\";s:31:\"Custom breadcrumbs for taxonomy\";s:11:\"description\";s:89:\"Enables taxonomy based breadcrumbs and allows for node assosciations with taxonomy terms.\";s:7:\"package\";s:18:\"Custom breadcrumbs\";s:12:\"dependencies\";a:2:{i:0;s:18:\"custom_breadcrumbs\";i:1;s:8:\"taxonomy\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:46:\"admin/config/user-interface/custom-breadcrumbs\";s:5:\"files\";a:4:{i:0;s:37:\"custom_breadcrumbs_taxonomy.admin.inc\";i:1;s:31:\"custom_breadcrumbs_taxonomy.inc\";i:2;s:35:\"custom_breadcrumbs_taxonomy.install\";i:3;s:34:\"custom_breadcrumbs_taxonomy.module\";}s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:7:\"project\";s:18:\"custom_breadcrumbs\";s:9:\"datestamp\";s:10:\"1410287363\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/custom_breadcrumbs/custom_breadcrumbs_views/custom_breadcrumbs_views.module','custom_breadcrumbs_views','module','',1,0,6200,1,'a:13:{s:4:\"name\";s:28:\"Custom breadcrumbs for views\";s:7:\"package\";s:18:\"Custom breadcrumbs\";s:12:\"dependencies\";a:2:{i:0;s:18:\"custom_breadcrumbs\";i:1;s:5:\"views\";}s:11:\"description\";s:44:\"Provides custom breadcrumbs for views pages.\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:46:\"admin/config/user-interface/custom-breadcrumbs\";s:5:\"files\";a:2:{i:0;s:32:\"custom_breadcrumbs_views.install\";i:1;s:31:\"custom_breadcrumbs_views.module\";}s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:7:\"project\";s:18:\"custom_breadcrumbs\";s:9:\"datestamp\";s:10:\"1410287363\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/devel/devel.module','devel','module','',1,1,7006,88,'a:14:{s:4:\"name\";s:5:\"Devel\";s:11:\"description\";s:52:\"Various blocks, pages, and functions for developers.\";s:7:\"package\";s:11:\"Development\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:30:\"admin/config/development/devel\";s:4:\"tags\";a:1:{i:0;s:9:\"developer\";}s:5:\"files\";a:2:{i:0;s:10:\"devel.test\";i:1;s:14:\"devel.mail.inc\";}s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:5:\"devel\";s:9:\"datestamp\";s:10:\"1398963366\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/devel/devel_generate/devel_generate.module','devel_generate','module','',0,0,-1,0,'a:14:{s:4:\"name\";s:14:\"Devel generate\";s:11:\"description\";s:48:\"Generate dummy users, nodes, and taxonomy terms.\";s:7:\"package\";s:11:\"Development\";s:4:\"core\";s:3:\"7.x\";s:4:\"tags\";a:1:{i:0;s:9:\"developer\";}s:9:\"configure\";s:33:\"admin/config/development/generate\";s:5:\"files\";a:1:{i:0;s:19:\"devel_generate.test\";}s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:5:\"devel\";s:9:\"datestamp\";s:10:\"1398963366\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/devel/devel_node_access.module','devel_node_access','module','',0,0,-1,0,'a:14:{s:4:\"name\";s:17:\"Devel node access\";s:11:\"description\";s:68:\"Developer blocks and page illustrating relevant node_access records.\";s:7:\"package\";s:11:\"Development\";s:12:\"dependencies\";a:1:{i:0;s:4:\"menu\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:30:\"admin/config/development/devel\";s:4:\"tags\";a:1:{i:0;s:9:\"developer\";}s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:5:\"devel\";s:9:\"datestamp\";s:10:\"1398963366\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/eck/eck.module','eck','module','',1,0,7011,0,'a:15:{s:4:\"name\";s:23:\"Entity Construction Kit\";s:11:\"description\";s:126:\"ECK (Entity Construction Kit) Allows users to create and administer entity types, bundles, and entities from an easy to use UI\";s:7:\"package\";s:3:\"ECK\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:27:\"admin/structure/entity-type\";s:12:\"dependencies\";a:2:{i:0;s:6:\"entity\";i:1;s:6:\"ctools\";}s:5:\"files\";a:4:{i:0;s:47:\"views/handlers/eck_views_handler_field_link.inc\";i:1;s:52:\"views/handlers/eck_views_handler_field_link_edit.inc\";i:2;s:54:\"views/handlers/eck_views_handler_field_link_delete.inc\";i:3;s:35:\"includes/eck.inline_entity_form.inc\";}s:7:\"version\";s:11:\"7.x-2.0-rc7\";s:7:\"project\";s:3:\"eck\";s:9:\"datestamp\";s:10:\"1422241382\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:60:\"Entity types created by ECK are still present in the system.\";}'),('sites/all/modules/eck/examples/eck_example.module','eck_example','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:11:\"ECK Example\";s:11:\"description\";s:67:\"A module demonstrating the kind of things that ECK can do from code\";s:7:\"package\";s:3:\"ECK\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:3:\"eck\";}s:7:\"version\";s:11:\"7.x-2.0-rc7\";s:7:\"project\";s:3:\"eck\";s:9:\"datestamp\";s:10:\"1422241382\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/eck/modules/eck_entitycache/eck_entitycache.module','eck_entitycache','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:17:\"ECK - Entitycache\";s:11:\"description\";s:53:\"Integrates the ECK module with the Entitycache module\";s:7:\"package\";s:27:\"Performance and scalability\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:3:\"eck\";i:1;s:11:\"entitycache\";}s:7:\"version\";s:11:\"7.x-2.0-rc7\";s:7:\"project\";s:3:\"eck\";s:9:\"datestamp\";s:10:\"1422241382\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/eck/modules/eck_services/eck_services.module','eck_services','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:12:\"ECK Services\";s:11:\"description\";s:25:\"Service resources for ECK\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:3:\"ECK\";s:12:\"dependencies\";a:2:{i:0;s:3:\"eck\";i:1;s:8:\"services\";}s:7:\"version\";s:11:\"7.x-2.0-rc7\";s:7:\"project\";s:3:\"eck\";s:9:\"datestamp\";s:10:\"1422241382\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/entity/entity.module','entity','module','',1,0,7003,0,'a:12:{s:4:\"name\";s:10:\"Entity API\";s:11:\"description\";s:69:\"Enables modules to work with any entity type and to provide entities.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:24:{i:0;s:19:\"entity.features.inc\";i:1;s:15:\"entity.i18n.inc\";i:2;s:15:\"entity.info.inc\";i:3;s:16:\"entity.rules.inc\";i:4;s:11:\"entity.test\";i:5;s:19:\"includes/entity.inc\";i:6;s:30:\"includes/entity.controller.inc\";i:7;s:22:\"includes/entity.ui.inc\";i:8;s:27:\"includes/entity.wrapper.inc\";i:9;s:22:\"views/entity.views.inc\";i:10;s:52:\"views/handlers/entity_views_field_handler_helper.inc\";i:11;s:51:\"views/handlers/entity_views_handler_area_entity.inc\";i:12;s:53:\"views/handlers/entity_views_handler_field_boolean.inc\";i:13;s:50:\"views/handlers/entity_views_handler_field_date.inc\";i:14;s:54:\"views/handlers/entity_views_handler_field_duration.inc\";i:15;s:52:\"views/handlers/entity_views_handler_field_entity.inc\";i:16;s:51:\"views/handlers/entity_views_handler_field_field.inc\";i:17;s:53:\"views/handlers/entity_views_handler_field_numeric.inc\";i:18;s:53:\"views/handlers/entity_views_handler_field_options.inc\";i:19;s:50:\"views/handlers/entity_views_handler_field_text.inc\";i:20;s:49:\"views/handlers/entity_views_handler_field_uri.inc\";i:21;s:62:\"views/handlers/entity_views_handler_relationship_by_bundle.inc\";i:22;s:52:\"views/handlers/entity_views_handler_relationship.inc\";i:23;s:53:\"views/plugins/entity_views_plugin_row_entity_view.inc\";}s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";s:10:\"1424876582\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/entity/entity_token.module','entity_token','module','',1,0,0,0,'a:12:{s:4:\"name\";s:13:\"Entity tokens\";s:11:\"description\";s:99:\"Provides token replacements for all properties that have no tokens and are known to the entity API.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:23:\"entity_token.tokens.inc\";i:1;s:19:\"entity_token.module\";}s:12:\"dependencies\";a:1:{i:0;s:6:\"entity\";}s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";s:10:\"1424876582\";s:5:\"mtime\";i:1499933463;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/entity/tests/entity_feature.module','entity_feature','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:21:\"Entity feature module\";s:11:\"description\";s:31:\"Provides some entities in code.\";s:7:\"version\";s:7:\"7.x-1.6\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:21:\"entity_feature.module\";}s:12:\"dependencies\";a:1:{i:0;s:11:\"entity_test\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";s:10:\"1424876582\";s:5:\"mtime\";i:1499933463;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/entity/tests/entity_test.module','entity_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:23:\"Entity CRUD test module\";s:11:\"description\";s:46:\"Provides entity types based upon the CRUD API.\";s:7:\"version\";s:7:\"7.x-1.6\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:18:\"entity_test.module\";i:1;s:19:\"entity_test.install\";}s:12:\"dependencies\";a:1:{i:0;s:6:\"entity\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";s:10:\"1424876582\";s:5:\"mtime\";i:1499933463;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/entity/tests/entity_test_i18n.module','entity_test_i18n','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:28:\"Entity-test type translation\";s:11:\"description\";s:37:\"Allows translating entity-test types.\";s:12:\"dependencies\";a:2:{i:0;s:11:\"entity_test\";i:1;s:11:\"i18n_string\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";s:10:\"1424876582\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/entityreference/entityreference.module','entityreference','module','',1,0,7002,0,'a:14:{s:4:\"name\";s:16:\"Entity Reference\";s:11:\"description\";s:51:\"Provides a field that can reference other entities.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Fields\";s:12:\"dependencies\";a:2:{i:0;s:6:\"entity\";i:1;s:6:\"ctools\";}s:5:\"files\";a:11:{i:0;s:27:\"entityreference.migrate.inc\";i:1;s:30:\"plugins/selection/abstract.inc\";i:2;s:27:\"plugins/selection/views.inc\";i:3;s:29:\"plugins/behavior/abstract.inc\";i:4;s:40:\"views/entityreference_plugin_display.inc\";i:5;s:38:\"views/entityreference_plugin_style.inc\";i:6;s:43:\"views/entityreference_plugin_row_fields.inc\";i:7;s:35:\"tests/entityreference.handlers.test\";i:8;s:35:\"tests/entityreference.taxonomy.test\";i:9;s:32:\"tests/entityreference.admin.test\";i:10;s:32:\"tests/entityreference.feeds.test\";}s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:15:\"entityreference\";s:9:\"datestamp\";s:10:\"1384973110\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}'),('sites/all/modules/entityreference/examples/entityreference_behavior_example/entityreference_behavior_example.module','entityreference_behavior_example','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:33:\"Entity Reference Behavior Example\";s:11:\"description\";s:71:\"Provides some example code for implementing Entity Reference behaviors.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Fields\";s:12:\"dependencies\";a:1:{i:0;s:15:\"entityreference\";}s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:15:\"entityreference\";s:9:\"datestamp\";s:10:\"1384973110\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/entityreference/tests/modules/entityreference_feeds_test/entityreference_feeds_test.module','entityreference_feeds_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:41:\"Entityreference - Feeds integration tests\";s:11:\"description\";s:65:\"Support module for the Entityreference - Feeds integration tests.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:3:{i:0;s:5:\"feeds\";i:1;s:8:\"feeds_ui\";i:2;s:15:\"entityreference\";}s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:15:\"entityreference\";s:9:\"datestamp\";s:10:\"1384973110\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/exclude_node_title/exclude_node_title.module','exclude_node_title','module','',1,0,7100,0,'a:13:{s:4:\"name\";s:18:\"Exclude node title\";s:11:\"description\";s:153:\"Excludes a node title from display. It provides a checkbox on node-edit pages for easier exclusion. You can also exclude title display from teaser pages.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Other\";s:9:\"configure\";s:39:\"admin/config/content/exclude_node_title\";s:5:\"files\";a:3:{i:0;s:23:\"exclude_node_title.info\";i:1;s:25:\"exclude_node_title.module\";i:2;s:28:\"exclude_node_title.admin.inc\";}s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:18:\"exclude_node_title\";s:9:\"datestamp\";s:10:\"1435338184\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/facetapi/contrib/current_search/current_search.module','current_search','module','',1,0,7101,0,'a:13:{s:4:\"name\";s:21:\"Current Search Blocks\";s:11:\"description\";s:90:\"Provides an interface for creating blocks containing information about the current search.\";s:12:\"dependencies\";a:1:{i:0;s:8:\"facetapi\";}s:7:\"package\";s:14:\"Search Toolkit\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:5:{i:0;s:31:\"plugins/current_search/item.inc\";i:1;s:38:\"plugins/current_search/item_active.inc\";i:2;s:37:\"plugins/current_search/item_group.inc\";i:3;s:36:\"plugins/current_search/item_text.inc\";i:4;s:25:\"tests/current_search.test\";}s:9:\"configure\";s:34:\"admin/config/search/current_search\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:8:\"facetapi\";s:9:\"datestamp\";s:10:\"1405685332\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/facetapi/facetapi.module','facetapi','module','',1,0,7103,0,'a:12:{s:4:\"name\";s:9:\"Facet API\";s:11:\"description\";s:68:\"An abstracted facet API that can be used by various search backends.\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"package\";s:14:\"Search Toolkit\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:14:{i:0;s:28:\"plugins/facetapi/adapter.inc\";i:1;s:31:\"plugins/facetapi/dependency.inc\";i:2;s:38:\"plugins/facetapi/dependency_bundle.inc\";i:3;s:36:\"plugins/facetapi/dependency_role.inc\";i:4;s:35:\"plugins/facetapi/empty_behavior.inc\";i:5;s:40:\"plugins/facetapi/empty_behavior_text.inc\";i:6;s:27:\"plugins/facetapi/filter.inc\";i:7;s:31:\"plugins/facetapi/query_type.inc\";i:8;s:34:\"plugins/facetapi/url_processor.inc\";i:9;s:43:\"plugins/facetapi/url_processor_standard.inc\";i:10;s:27:\"plugins/facetapi/widget.inc\";i:11;s:33:\"plugins/facetapi/widget_links.inc\";i:12;s:31:\"tests/facetapi_test.plugins.inc\";i:13;s:19:\"tests/facetapi.test\";}s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:8:\"facetapi\";s:9:\"datestamp\";s:10:\"1405685332\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/facetapi/tests/facetapi_test.module','facetapi_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:14:\"Facet API Test\";s:11:\"description\";s:36:\"Provides a test adapter and plugins.\";s:12:\"dependencies\";a:1:{i:0;s:8:\"facetapi\";}s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:8:\"facetapi\";s:9:\"datestamp\";s:10:\"1405685332\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/faq/faq.module','faq','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:26:\"Frequently Asked Questions\";s:11:\"description\";s:50:\"Manages configuration of questions for a FAQ page.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:18:{i:0;s:13:\"faq.admin.inc\";i:1;s:11:\"faq.install\";i:2;s:10:\"faq.module\";i:3;s:8:\"faq.test\";i:4;s:41:\"includes/faq-category-hide-answer.tpl.php\";i:5;s:38:\"includes/faq-category-new-page.tpl.php\";i:6;s:46:\"includes/faq-category-questions-inline.tpl.php\";i:7;s:51:\"includes/faq-category-questions-top-answers.tpl.php\";i:8;s:43:\"includes/faq-category-questions-top.tpl.php\";i:9;s:32:\"includes/faq-hide-answer.tpl.php\";i:10;s:29:\"includes/faq-new-page.tpl.php\";i:11;s:37:\"includes/faq-questions-inline.tpl.php\";i:12;s:34:\"includes/faq-questions-top.tpl.php\";i:13;s:28:\"includes/faq.hide_answer.inc\";i:14;s:25:\"includes/faq.new_page.inc\";i:15;s:33:\"includes/faq.questions_inline.inc\";i:16;s:30:\"includes/faq.questions_top.inc\";i:17;s:19:\"views/faq.views.inc\";}s:9:\"configure\";s:24:\"admin/config/content/faq\";s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:7:\"project\";s:3:\"faq\";s:9:\"datestamp\";s:10:\"1415528891\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/features/features.module','features','module','',1,0,7200,20,'a:14:{s:4:\"name\";s:8:\"Features\";s:11:\"description\";s:39:\"Provides feature management for Drupal.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:8:\"Features\";s:5:\"files\";a:1:{i:0;s:19:\"tests/features.test\";}s:17:\"test_dependencies\";a:4:{i:0;s:5:\"image\";i:1;s:9:\"strongarm\";i:2;s:8:\"taxonomy\";i:3;s:5:\"views\";}s:9:\"configure\";s:33:\"admin/structure/features/settings\";s:7:\"version\";s:8:\"7.x-2.10\";s:7:\"project\";s:8:\"features\";s:9:\"datestamp\";s:10:\"1461011641\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/features/tests/features_test/features_test.module','features_test','module','',0,0,-1,0,'a:14:{s:4:\"name\";s:14:\"Features Tests\";s:11:\"description\";s:33:\"Test module for Features testing.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:3:\"php\";s:5:\"5.2.0\";s:12:\"dependencies\";a:5:{i:0;s:8:\"features\";i:1;s:5:\"image\";i:2;s:9:\"strongarm\";i:3;s:8:\"taxonomy\";i:4;s:5:\"views\";}s:8:\"features\";a:10:{s:6:\"ctools\";a:2:{i:0;s:21:\"strongarm:strongarm:1\";i:1;s:23:\"views:views_default:3.0\";}s:12:\"features_api\";a:1:{i:0;s:5:\"api:2\";}s:10:\"field_base\";a:1:{i:0;s:19:\"field_features_test\";}s:14:\"field_instance\";a:1:{i:0;s:38:\"node-features_test-field_features_test\";}s:6:\"filter\";a:1:{i:0;s:13:\"features_test\";}s:5:\"image\";a:1:{i:0;s:13:\"features_test\";}s:4:\"node\";a:1:{i:0;s:13:\"features_test\";}s:8:\"taxonomy\";a:1:{i:0;s:22:\"taxonomy_features_test\";}s:15:\"user_permission\";a:1:{i:0;s:28:\"create features_test content\";}s:10:\"views_view\";a:1:{i:0;s:13:\"features_test\";}}s:6:\"hidden\";s:1:\"1\";s:7:\"version\";s:8:\"7.x-2.10\";s:7:\"project\";s:8:\"features\";s:9:\"datestamp\";s:10:\"1461011641\";s:5:\"mtime\";i:1499933463;s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/field_collection/field_collection.module','field_collection','module','',1,0,7006,0,'a:15:{s:4:\"name\";s:16:\"Field collection\";s:11:\"description\";s:81:\"Provides a field collection field, to which any number of fields can be attached.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"entity\";}s:5:\"files\";a:4:{i:0;s:21:\"field_collection.test\";i:1;s:25:\"field_collection.info.inc\";i:2;s:47:\"views/field_collection_handler_relationship.inc\";i:3;s:28:\"field_collection.migrate.inc\";}s:9:\"configure\";s:33:\"admin/structure/field-collections\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:13:\"7.x-1.0-beta8\";s:7:\"project\";s:16:\"field_collection\";s:9:\"datestamp\";s:10:\"1415122384\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}'),('sites/all/modules/field_collection_table/field_collection_table.module','field_collection_table','module','',1,0,0,0,'a:12:{s:4:\"name\";s:22:\"Field Collection Table\";s:11:\"description\";s:44:\"Provides a field-collection table formatter.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:16:\"field_collection\";}s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:7:\"project\";s:22:\"field_collection_table\";s:9:\"datestamp\";s:10:\"1426689182\";s:5:\"mtime\";i:1499933463;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/field_formatter_class/field_formatter_class.module','field_formatter_class','module','',1,0,0,0,'a:12:{s:4:\"name\";s:21:\"Field Formatter Class\";s:11:\"description\";s:48:\"Allows custom HTML classes for field formatters.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Fields\";s:12:\"dependencies\";a:2:{i:0;s:5:\"field\";i:1;s:24:\"field_formatter_settings\";}s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:21:\"field_formatter_class\";s:9:\"datestamp\";s:10:\"1361374877\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/field_formatter_settings/field_formatter_settings.module','field_formatter_settings','module','',1,0,0,0,'a:13:{s:4:\"name\";s:28:\"Field formatter settings API\";s:11:\"description\";s:71:\"Provides missing alter hooks for field formatter settings and summaries\";s:4:\"core\";s:3:\"7.x\";s:8:\"enhances\";a:2:{i:0;s:8:\"field_ui\";i:1;s:8:\"views_ui\";}s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:24:\"field_formatter_settings\";s:9:\"datestamp\";s:10:\"1378741903\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/field_group/field_group.module','field_group','module','',1,0,7008,1,'a:12:{s:4:\"name\";s:11:\"Field Group\";s:11:\"description\";s:67:\"Provides the ability to group your fields on both form and display.\";s:7:\"package\";s:6:\"Fields\";s:12:\"dependencies\";a:2:{i:0;s:5:\"field\";i:1;s:6:\"ctools\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:25:\"tests/field_group.ui.test\";i:1;s:30:\"tests/field_group.display.test\";}s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:11:\"field_group\";s:9:\"datestamp\";s:10:\"1452033709\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/field_group/tests/field_group_test.module','field_group_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:16:\"Field Group Test\";s:11:\"description\";s:27:\"Test module for Field Group\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Fields\";s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:11:\"field_group\";s:9:\"datestamp\";s:10:\"1452033709\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/field_slideshow/field_slideshow.module','field_slideshow','module','',1,0,7001,0,'a:12:{s:4:\"name\";s:15:\"Field Slideshow\";s:11:\"description\";s:65:\"Provides a Slideshow format for displaying Image or Media fields.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Fields\";s:12:\"dependencies\";a:2:{i:0;s:5:\"image\";i:1;s:9:\"libraries\";}s:5:\"files\";a:1:{i:0;s:22:\"field_slideshow.module\";}s:7:\"version\";s:8:\"7.x-1.82\";s:7:\"project\";s:15:\"field_slideshow\";s:9:\"datestamp\";s:10:\"1363270823\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/fivestar/fivestar.module','fivestar','module','',1,0,7208,0,'a:15:{s:4:\"name\";s:8:\"Fivestar\";s:11:\"description\";s:48:\"Enables fivestar ratings on content, users, etc.\";s:7:\"package\";s:6:\"Voting\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:9:\"votingapi\";}s:9:\"configure\";s:29:\"admin/config/content/fivestar\";s:5:\"files\";a:2:{i:0;s:23:\"test/fivestar.base.test\";i:1;s:24:\"test/fivestar.field.test\";}s:7:\"version\";s:7:\"7.x-2.1\";s:7:\"project\";s:8:\"fivestar\";s:9:\"datestamp\";s:10:\"1395087839\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}'),('sites/all/modules/flexslider/flexslider.module','flexslider','module','',1,0,7202,0,'a:13:{s:4:\"name\";s:10:\"FlexSlider\";s:11:\"description\";s:46:\"Integrate the FlexSlider 2 library with Drupal\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:10:\"FlexSlider\";s:12:\"dependencies\";a:3:{i:0;s:17:\"libraries (>=2.x)\";i:1;s:6:\"ctools\";i:2;s:5:\"image\";}s:5:\"files\";a:2:{i:0;s:26:\"theme/flexslider.theme.inc\";i:1;s:15:\"flexslider.test\";}s:9:\"configure\";s:29:\"admin/config/media/flexslider\";s:7:\"version\";s:11:\"7.x-2.0-rc1\";s:7:\"project\";s:10:\"flexslider\";s:9:\"datestamp\";s:10:\"1438285141\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/flexslider/flexslider_example/flexslider_example.module','flexslider_example','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:18:\"FlexSlider Example\";s:11:\"description\";s:35:\"Sample implementation of FlexSlider\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:10:\"FlexSlider\";s:3:\"php\";s:5:\"5.2.4\";s:12:\"dependencies\";a:9:{i:0;s:7:\"context\";i:1;s:8:\"features\";i:2;s:10:\"flexslider\";i:3;s:17:\"flexslider_fields\";i:4;s:16:\"flexslider_views\";i:5;s:5:\"image\";i:6;s:4:\"menu\";i:7;s:9:\"strongarm\";i:8;s:5:\"views\";}s:8:\"features\";a:9:{s:7:\"context\";a:1:{i:0;s:28:\"flexslider_example_thumbnail\";}s:6:\"ctools\";a:4:{i:0;s:17:\"context:context:3\";i:1;s:38:\"flexslider:flexslider_default_preset:1\";i:2;s:21:\"strongarm:strongarm:1\";i:3;s:23:\"views:views_default:3.0\";}s:12:\"features_api\";a:1:{i:0;s:5:\"api:1\";}s:5:\"field\";a:2:{i:0;s:54:\"node-flexslider_example-field_flexslider_example_image\";i:1;s:56:\"node-flexslider_example-field_flexslider_example_slidesh\";}s:20:\"flexslider_optionset\";a:6:{i:0;s:43:\"flexslider_carousel_with_min_and_max_ranges\";i:1;s:33:\"flexslider_default_basic_carousel\";i:2;s:46:\"flexslider_default_slider_thumbnail_controlnav\";i:3;s:44:\"flexslider_default_slider_w_thumbnail_slider\";i:4;s:37:\"flexslider_default_thumbnail_captions\";i:5;s:35:\"flexslider_default_thumbnail_slider\";}s:11:\"menu_custom\";a:1:{i:0;s:23:\"menu-flexslider-example\";}s:4:\"node\";a:1:{i:0;s:18:\"flexslider_example\";}s:8:\"variable\";a:1:{i:0;s:46:\"field_bundle_settings_node__flexslider_example\";}s:10:\"views_view\";a:1:{i:0;s:24:\"flexslider_views_example\";}}s:7:\"version\";s:11:\"7.x-2.0-rc1\";s:7:\"project\";s:10:\"flexslider\";s:9:\"datestamp\";s:10:\"1438285141\";s:5:\"mtime\";i:1499933463;s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/flexslider/flexslider_fields/flexslider_fields.module','flexslider_fields','module','',1,0,0,0,'a:12:{s:4:\"name\";s:17:\"FlexSlider Fields\";s:11:\"description\";s:44:\"Adds a display mode in Fields for FlexSlider\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:10:\"FlexSlider\";s:12:\"dependencies\";a:1:{i:0;s:10:\"flexslider\";}s:7:\"version\";s:11:\"7.x-2.0-rc1\";s:7:\"project\";s:10:\"flexslider\";s:9:\"datestamp\";s:10:\"1438285141\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/flexslider/flexslider_views/flexslider_views.module','flexslider_views','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:22:\"FlexSlider Views Style\";s:11:\"description\";s:40:\"Adds a Views style plugin for FlexSlider\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:10:\"FlexSlider\";s:12:\"dependencies\";a:2:{i:0;s:5:\"views\";i:1;s:10:\"flexslider\";}s:5:\"files\";a:3:{i:0;s:23:\"flexslider_views.module\";i:1;s:26:\"flexslider_views.views.inc\";i:2;s:44:\"flexslider_views_plugin_style_flexslider.inc\";}s:7:\"version\";s:11:\"7.x-2.0-rc1\";s:7:\"project\";s:10:\"flexslider\";s:9:\"datestamp\";s:10:\"1438285141\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/icon/icon.module','icon','module','',1,0,0,0,'a:13:{s:4:\"name\";s:8:\"Icon API\";s:11:\"description\";s:105:\"Implements an API for icon providers and an administrative UI for integrating icons through out the site.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:8:\"Icon API\";s:9:\"configure\";s:23:\"admin/config/media/icon\";s:5:\"files\";a:2:{i:0;s:12:\"icon.install\";i:1;s:11:\"icon.module\";}s:7:\"version\";s:13:\"7.x-1.0-beta6\";s:7:\"project\";s:4:\"icon\";s:9:\"datestamp\";s:10:\"1438832040\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/icon/modules/icon_block/icon_block.module','icon_block','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:15:\"Icon API: Block\";s:11:\"description\";s:38:\"Provides icon integration with blocks.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:8:\"Icon API\";s:5:\"files\";a:2:{i:0;s:18:\"icon_block.install\";i:1;s:17:\"icon_block.module\";}s:12:\"dependencies\";a:2:{i:0;s:5:\"block\";i:1;s:4:\"icon\";}s:7:\"version\";s:13:\"7.x-1.0-beta6\";s:7:\"project\";s:4:\"icon\";s:9:\"datestamp\";s:10:\"1438832040\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/icon/modules/icon_field/icon_field.module','icon_field','module','',1,0,0,0,'a:14:{s:4:\"name\";s:15:\"Icon API: Field\";s:11:\"description\";s:61:\"Provides a field for attaching an icon to a fieldable entity.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:8:\"Icon API\";s:12:\"dependencies\";a:2:{i:0;s:5:\"field\";i:1;s:4:\"icon\";}s:7:\"version\";s:13:\"7.x-1.0-beta6\";s:7:\"project\";s:4:\"icon\";s:9:\"datestamp\";s:10:\"1438832040\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}'),('sites/all/modules/icon/modules/icon_filter/icon_filter.module','icon_filter','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:16:\"Icon API: Filter\";s:11:\"description\";s:76:\"Provides a filter for text fields to replace an icon token with icon markup.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:8:\"Icon API\";s:12:\"dependencies\";a:2:{i:0;s:6:\"filter\";i:1;s:4:\"icon\";}s:7:\"version\";s:13:\"7.x-1.0-beta6\";s:7:\"project\";s:4:\"icon\";s:9:\"datestamp\";s:10:\"1438832040\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/icon/modules/icon_menu/icon_menu.module','icon_menu','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:14:\"Icon API: Menu\";s:11:\"description\";s:42:\"Provides icon integration with menu items.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:8:\"Icon API\";s:5:\"files\";a:2:{i:0;s:17:\"icon_menu.install\";i:1;s:16:\"icon_menu.module\";}s:12:\"dependencies\";a:2:{i:0;s:4:\"icon\";i:1;s:4:\"menu\";}s:7:\"version\";s:13:\"7.x-1.0-beta6\";s:7:\"project\";s:4:\"icon\";s:9:\"datestamp\";s:10:\"1438832040\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/image_delta_formatter/image_delta_formatter.module','image_delta_formatter','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:21:\"Image Delta Formatter\";s:11:\"description\";s:79:\"Provides a formatter that displays a specific delta of a multivalue imagefield.\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:7:\"project\";s:21:\"image_delta_formatter\";s:9:\"datestamp\";s:10:\"1355927255\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/image_link_formatter/image_link_formatter.module','image_link_formatter','module','',1,0,0,0,'a:12:{s:4:\"name\";s:20:\"Image Link Formatter\";s:11:\"description\";s:181:\"Provides an additional formatter for image core field, to be combined with contributed Link field module, to allow display of custom links with custom properties on the image field.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:4:\"link\";i:1;s:5:\"image\";}s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-1.0\";s:7:\"project\";s:20:\"image_link_formatter\";s:9:\"datestamp\";s:10:\"1355914053\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/imce/imce.module','imce','module','',1,0,7002,0,'a:13:{s:4:\"name\";s:4:\"IMCE\";s:11:\"description\";s:82:\"An image/file uploader and browser supporting personal directories and user quota.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Media\";s:9:\"configure\";s:23:\"admin/config/media/imce\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:4:\"imce\";s:9:\"datestamp\";s:10:\"1400275428\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/inline_entity_form/inline_entity_form.module','inline_entity_form','module','',1,0,0,0,'a:12:{s:4:\"name\";s:18:\"Inline Entity Form\";s:11:\"description\";s:98:\"Provides a widget for inline management (creation, modification, removal) of referenced entities. \";s:7:\"package\";s:6:\"Fields\";s:12:\"dependencies\";a:2:{i:0;s:6:\"entity\";i:1;s:14:\"system (>7.14)\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:5:{i:0;s:38:\"includes/entity.inline_entity_form.inc\";i:1;s:36:\"includes/node.inline_entity_form.inc\";i:2;s:45:\"includes/taxonomy_term.inline_entity_form.inc\";i:3;s:48:\"includes/commerce_product.inline_entity_form.inc\";i:4;s:50:\"includes/commerce_line_item.inline_entity_form.inc\";}s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:18:\"inline_entity_form\";s:9:\"datestamp\";s:10:\"1434553381\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/jcarousel/jcarousel.module','jcarousel','module','',1,0,0,0,'a:12:{s:4:\"name\";s:9:\"jCarousel\";s:11:\"description\";s:38:\"Create jQuery-based carousel rotators.\";s:7:\"package\";s:14:\"User interface\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:16:\"jcarousel.module\";i:1;s:28:\"includes/jcarousel.views.inc\";i:2;s:35:\"includes/jcarousel_style_plugin.inc\";}s:7:\"version\";s:7:\"7.x-2.7\";s:7:\"project\";s:9:\"jcarousel\";s:9:\"datestamp\";s:10:\"1420460282\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/jquery_update/jquery_update.module','jquery_update','module','',1,0,7000,0,'a:13:{s:4:\"name\";s:13:\"jQuery Update\";s:11:\"description\";s:53:\"Update jQuery and jQuery UI to a more recent version.\";s:7:\"package\";s:14:\"User interface\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:20:\"jquery_update.module\";i:1;s:21:\"jquery_update.install\";}s:9:\"configure\";s:38:\"admin/config/development/jquery_update\";s:7:\"version\";s:7:\"7.x-2.7\";s:7:\"project\";s:13:\"jquery_update\";s:9:\"datestamp\";s:10:\"1445379855\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/languageicons/languageicons.module','languageicons','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:14:\"Language Icons\";s:11:\"description\";s:29:\"Adds icons to language links.\";s:12:\"dependencies\";a:1:{i:0;s:6:\"locale\";}s:7:\"package\";s:12:\"Multilingual\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:36:\"admin/config/regional/language/icons\";s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:13:\"languageicons\";s:9:\"datestamp\";s:10:\"1399825730\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/lang_dropdown/lang_dropdown.module','lang_dropdown','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:26:\"Language Switcher Dropdown\";s:7:\"package\";s:12:\"Multilingual\";s:11:\"description\";s:65:\"Provides a dropdown select to switch between available languages.\";s:12:\"dependencies\";a:1:{i:0;s:6:\"locale\";}s:9:\"configure\";s:21:\"admin/structure/block\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:20:\"lang_dropdown.module\";i:1;s:21:\"lang_dropdown.install\";}s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:13:\"lang_dropdown\";s:9:\"datestamp\";s:10:\"1387127905\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/lang_dropdown/lang_dropdown_hideout/lang_dropdown_hideout.module','lang_dropdown_hideout','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:34:\"Language Switcher Dropdown Hideout\";s:7:\"package\";s:12:\"Multilingual\";s:11:\"description\";s:69:\"Allow to hide specific languages from the switcher for certain roles.\";s:12:\"dependencies\";a:1:{i:0;s:6:\"locale\";}s:9:\"configure\";s:21:\"admin/structure/block\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:28:\"lang_dropdown_hideout.module\";i:1;s:29:\"lang_dropdown_hideout.install\";}s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:13:\"lang_dropdown\";s:9:\"datestamp\";s:10:\"1387127905\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/libraries/libraries.module','libraries','module','',1,0,7200,0,'a:12:{s:4:\"name\";s:9:\"Libraries\";s:11:\"description\";s:64:\"Allows version-dependent and shared usage of external libraries.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:15:\"system (>=7.11)\";}s:5:\"files\";a:1:{i:0;s:20:\"tests/libraries.test\";}s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:9:\"libraries\";s:9:\"datestamp\";s:10:\"1391965716\";s:5:\"mtime\";i:1499933463;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/libraries/tests/libraries_test.module','libraries_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:21:\"Libraries test module\";s:11:\"description\";s:36:\"Tests library detection and loading.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:9:\"libraries\";}s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-2.1\";s:7:\"project\";s:9:\"libraries\";s:9:\"datestamp\";s:10:\"1362848412\";s:5:\"mtime\";i:1499933463;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/libraries/tests/modules/libraries_test_module/libraries_test_module.module','libraries_test_module','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:21:\"Libraries test module\";s:11:\"description\";s:36:\"Tests library detection and loading.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:12:\"dependencies\";a:1:{i:0;s:9:\"libraries\";}s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:9:\"libraries\";s:9:\"datestamp\";s:10:\"1391965716\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/link/link.module','link','module','',1,0,7001,0,'a:14:{s:4:\"name\";s:4:\"Link\";s:11:\"description\";s:32:\"Defines simple link field types.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Fields\";s:5:\"files\";a:10:{i:0;s:11:\"link.module\";i:1;s:16:\"link.migrate.inc\";i:2;s:15:\"tests/link.test\";i:3;s:25:\"tests/link.attribute.test\";i:4;s:20:\"tests/link.crud.test\";i:5;s:28:\"tests/link.crud_browser.test\";i:6;s:21:\"tests/link.token.test\";i:7;s:24:\"tests/link.validate.test\";i:8;s:44:\"views/link_views_handler_argument_target.inc\";i:9;s:44:\"views/link_views_handler_filter_protocol.inc\";}s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:4:\"link\";s:9:\"datestamp\";s:10:\"1413924830\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}'),('sites/all/modules/megamenus/megamenus.module','megamenus','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:9:\"Megamenus\";s:11:\"description\";s:25:\"Menu solutions for Drupal\";s:7:\"package\";s:9:\"megamenus\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:5:{i:0;s:13:\"megamenus.inc\";i:1;s:20:\"megamenus.themes.inc\";i:2;s:18:\"megamenus.ajax.inc\";i:3;s:19:\"megamenus.admin.inc\";i:4;s:16:\"megamenus.module\";}s:9:\"configure\";s:25:\"admin/structure/megamenus\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/memcache/memcache.module','memcache','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:8:\"Memcache\";s:11:\"description\";s:43:\"High performance integration with memcache.\";s:7:\"package\";s:27:\"Performance and scalability\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:4:{i:0;s:12:\"memcache.inc\";i:1;s:19:\"tests/memcache.test\";i:2;s:27:\"tests/memcache-session.test\";i:3;s:24:\"tests/memcache-lock.test\";}s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:8:\"memcache\";s:9:\"datestamp\";s:10:\"1422088394\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/memcache/memcache_admin/memcache_admin.module','memcache_admin','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:14:\"Memcache Admin\";s:11:\"description\";s:60:\"Adds a User Interface to monitor the Memcache for this site.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:27:\"Performance and scalability\";s:9:\"configure\";s:28:\"admin/config/system/memcache\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:8:\"memcache\";s:9:\"datestamp\";s:10:\"1422088394\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/memcache/tests/memcache_test.module','memcache_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:13:\"Memcache test\";s:11:\"description\";s:36:\"Support module for memcache testing.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:8:\"memcache\";s:9:\"datestamp\";s:10:\"1422088394\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/menu_attributes/menu_attributes.module','menu_attributes','module','',0,0,-1,10,'a:13:{s:4:\"name\";s:15:\"Menu attributes\";s:11:\"description\";s:66:\"Allows administrators to specify custom attributes for menu items.\";s:12:\"dependencies\";a:1:{i:0;s:4:\"menu\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:29:\"admin/structure/menu/settings\";s:5:\"files\";a:1:{i:0;s:20:\"menu_attributes.test\";}s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:7:\"project\";s:15:\"menu_attributes\";s:9:\"datestamp\";s:10:\"1413756231\";s:5:\"mtime\";i:1499933463;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/menu_descriptions/menu_descriptions.module','menu_descriptions','module','',1,0,0,0,'a:12:{s:4:\"name\";s:17:\"Menu Descriptions\";s:11:\"description\";s:78:\"Permit longer descriptions for menu items, and display blocks for those menus.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:4:\"menu\";}s:7:\"package\";s:14:\"User interface\";s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:17:\"menu_descriptions\";s:9:\"datestamp\";s:10:\"1415818689\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/menu_token/menu_token.module','menu_token','module','',1,0,7004,0,'a:13:{s:4:\"name\";s:10:\"Menu Token\";s:11:\"description\";s:38:\"Provides tokens in menu items (links).\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:4:{i:0;s:4:\"menu\";i:1;s:6:\"entity\";i:2;s:5:\"token\";i:3;s:6:\"ctools\";}s:5:\"files\";a:1:{i:0;s:15:\"menu_token.test\";}s:9:\"configure\";s:23:\"admin/config/menu_token\";s:7:\"version\";s:13:\"7.x-1.0-beta5\";s:7:\"project\";s:10:\"menu_token\";s:9:\"datestamp\";s:10:\"1371232255\";s:5:\"mtime\";i:1499933463;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/module_filter/module_filter.module','module_filter','module','',1,0,7201,0,'a:13:{s:4:\"name\";s:13:\"Module filter\";s:11:\"description\";s:24:\"Filter the modules list.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:14:\"Administration\";s:5:\"files\";a:9:{i:0;s:21:\"module_filter.install\";i:1;s:16:\"module_filter.js\";i:2;s:20:\"module_filter.module\";i:3;s:23:\"module_filter.admin.inc\";i:4;s:23:\"module_filter.theme.inc\";i:5;s:21:\"css/module_filter.css\";i:6;s:25:\"css/module_filter_tab.css\";i:7;s:19:\"js/module_filter.js\";i:8;s:23:\"js/module_filter_tab.js\";}s:9:\"configure\";s:40:\"admin/config/user-interface/modulefilter\";s:7:\"version\";s:7:\"7.x-2.0\";s:7:\"project\";s:13:\"module_filter\";s:9:\"datestamp\";s:10:\"1424631189\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/node_class/node_class.module','node_class','module','',1,0,0,0,'a:12:{s:4:\"name\";s:10:\"Node Class\";s:11:\"description\";s:38:\"Allows assigning CSS classes to nodes.\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:10:\"node_class\";s:9:\"datestamp\";s:10:\"1388997876\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/page_title/page_title.module','page_title','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:10:\"Page Title\";s:11:\"description\";s:60:\"Enhanced control over the page title (in the &lt;head> tag).\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:3:\"SEO\";s:12:\"dependencies\";a:1:{i:0;s:5:\"token\";}s:5:\"files\";a:6:{i:0;s:17:\"page_title.module\";i:1;s:20:\"page_title.admin.inc\";i:2;s:21:\"page_title.tokens.inc\";i:3;s:15:\"page_title.test\";i:4;s:64:\"views/plugins/page_title_plugin_display_page_with_page_title.inc\";i:5;s:39:\"views_handler_field_node_page_title.inc\";}s:9:\"configure\";s:30:\"admin/config/search/page-title\";s:7:\"version\";s:7:\"7.x-2.7\";s:7:\"project\";s:10:\"page_title\";s:9:\"datestamp\";s:10:\"1336556786\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/panels/i18n_panels/i18n_panels.module','i18n_panels','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:18:\"Panels translation\";s:11:\"description\";s:35:\"Supports translatable panels items.\";s:12:\"dependencies\";a:4:{i:0;s:4:\"i18n\";i:1;s:6:\"panels\";i:2;s:11:\"i18n_string\";i:3;s:16:\"i18n_translation\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-3.9\";s:7:\"project\";s:6:\"panels\";s:9:\"datestamp\";s:10:\"1486394388\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/panels/panels.module','panels','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:6:\"Panels\";s:11:\"description\";s:107:\"Core Panels display functions; provides no external UI, at least one other Panels module should be enabled.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Panels\";s:9:\"configure\";s:22:\"admin/structure/panels\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:5:\"files\";a:9:{i:0;s:13:\"panels.module\";i:1;s:19:\"includes/common.inc\";i:2;s:19:\"includes/legacy.inc\";i:3;s:20:\"includes/plugins.inc\";i:4;s:48:\"plugins/views/panels_views_plugin_row_fields.inc\";i:5;s:38:\"tests/PanelsEntityViewWebTestCase.test\";i:6;s:36:\"tests/PanelsNodeViewWebTestCase.test\";i:7;s:36:\"tests/PanelsTermViewWebTestCase.test\";i:8;s:36:\"tests/PanelsUserViewWebTestCase.test\";}s:7:\"version\";s:7:\"7.x-3.9\";s:7:\"project\";s:6:\"panels\";s:9:\"datestamp\";s:10:\"1486394388\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/panels/panels_ipe/panels_ipe.module','panels_ipe','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:22:\"Panels In-Place Editor\";s:11:\"description\";s:101:\"Provide a UI for managing some Panels directly on the frontend, instead of having to use the backend.\";s:7:\"package\";s:6:\"Panels\";s:12:\"dependencies\";a:1:{i:0;s:6:\"panels\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:22:\"admin/structure/panels\";s:5:\"files\";a:1:{i:0;s:17:\"panels_ipe.module\";}s:7:\"version\";s:7:\"7.x-3.9\";s:7:\"project\";s:6:\"panels\";s:9:\"datestamp\";s:10:\"1486394388\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/panels/panels_mini/panels_mini.module','panels_mini','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:11:\"Mini panels\";s:11:\"description\";s:89:\"Create mini panels that can be used as blocks by Drupal and panes by other panel modules.\";s:7:\"package\";s:6:\"Panels\";s:12:\"dependencies\";a:1:{i:0;s:6:\"panels\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:42:\"plugins/export_ui/panels_mini_ui.class.php\";}s:7:\"version\";s:7:\"7.x-3.9\";s:7:\"project\";s:6:\"panels\";s:9:\"datestamp\";s:10:\"1486394388\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/panels/panels_node/panels_node.module','panels_node','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:11:\"Panel nodes\";s:11:\"description\";s:65:\"Create nodes that are divided into areas with selectable content.\";s:7:\"package\";s:6:\"Panels\";s:12:\"dependencies\";a:1:{i:0;s:6:\"panels\";}s:9:\"configure\";s:22:\"admin/structure/panels\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:18:\"panels_node.module\";}s:7:\"version\";s:7:\"7.x-3.9\";s:7:\"project\";s:6:\"panels\";s:9:\"datestamp\";s:10:\"1486394388\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/pathauto/pathauto.module','pathauto','module','',1,0,7005,1,'a:14:{s:4:\"name\";s:8:\"Pathauto\";s:11:\"description\";s:95:\"Provides a mechanism for modules to automatically generate aliases for the content they manage.\";s:12:\"dependencies\";a:2:{i:0;s:4:\"path\";i:1;s:5:\"token\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:13:\"pathauto.test\";}s:9:\"configure\";s:33:\"admin/config/search/path/patterns\";s:10:\"recommends\";a:1:{i:0;s:8:\"redirect\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:8:\"pathauto\";s:9:\"datestamp\";s:10:\"1344525185\";s:5:\"mtime\";i:1499933463;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/quicktabs/quicktabs.module','quicktabs','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:9:\"Quicktabs\";s:11:\"description\";s:49:\"Render content with tabs and other display styles\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:4:{i:0;s:16:\"quicktabs.module\";i:1;s:21:\"quicktabs.classes.inc\";i:2;s:35:\"includes/quicktabs_style_plugin.inc\";i:3;s:20:\"tests/quicktabs.test\";}s:9:\"configure\";s:25:\"admin/structure/quicktabs\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"version\";s:7:\"7.x-3.6\";s:7:\"project\";s:9:\"quicktabs\";s:9:\"datestamp\";s:10:\"1380731929\";s:5:\"mtime\";i:1499933463;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/quicktabs/quicktabs_tabstyles/quicktabs_tabstyles.module','quicktabs_tabstyles','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:16:\"Quicktabs Styles\";s:11:\"description\";s:65:\"Adds predefined tab styles to choose from per Quicktabs instance.\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:32:\"admin/structure/quicktabs/styles\";s:12:\"dependencies\";a:1:{i:0;s:9:\"quicktabs\";}s:7:\"version\";s:7:\"7.x-3.6\";s:7:\"project\";s:9:\"quicktabs\";s:9:\"datestamp\";s:10:\"1380731929\";s:5:\"mtime\";i:1499933463;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/recently_read/recently_read.module','recently_read','module','',1,0,0,0,'a:13:{s:4:\"name\";s:13:\"Recently read\";s:11:\"description\";s:57:\"Tracks the history of recently read content by each user.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Other\";s:9:\"configure\";s:33:\"admin/config/system/recently-read\";s:12:\"dependencies\";a:3:{i:0;s:5:\"views\";i:1;s:6:\"entity\";i:2;s:11:\"session_api\";}s:5:\"files\";a:3:{i:0;s:32:\"includes/recently_read.views.inc\";i:1;s:49:\"includes/recently_read_handler_filter_current.inc\";i:2;s:53:\"includes/recently_read_handler_filter_entity_type.inc\";}s:7:\"version\";s:7:\"7.x-3.1\";s:7:\"project\";s:13:\"recently_read\";s:9:\"datestamp\";s:10:\"1409150634\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/rules/rules.module','rules','module','',1,1,7214,20,'a:13:{s:4:\"name\";s:5:\"Rules\";s:11:\"description\";s:51:\"React on events and conditionally evaluate actions.\";s:7:\"package\";s:5:\"Rules\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:17:{i:0;s:18:\"rules.features.inc\";i:1;s:16:\"tests/rules.test\";i:2;s:18:\"includes/faces.inc\";i:3;s:23:\"includes/rules.core.inc\";i:4;s:24:\"includes/rules.event.inc\";i:5;s:28:\"includes/rules.processor.inc\";i:6;s:26:\"includes/rules.plugins.inc\";i:7;s:24:\"includes/rules.state.inc\";i:8;s:29:\"includes/rules.dispatcher.inc\";i:9;s:21:\"modules/node.eval.inc\";i:10;s:20:\"modules/php.eval.inc\";i:11;s:27:\"modules/rules_core.eval.inc\";i:12;s:23:\"modules/system.eval.inc\";i:13;s:20:\"ui/ui.controller.inc\";i:14;s:14:\"ui/ui.core.inc\";i:15;s:14:\"ui/ui.data.inc\";i:16;s:17:\"ui/ui.plugins.inc\";}s:12:\"dependencies\";a:2:{i:0;s:12:\"entity_token\";i:1;s:6:\"entity\";}s:7:\"version\";s:7:\"7.x-2.9\";s:7:\"project\";s:5:\"rules\";s:9:\"datestamp\";s:10:\"1426527210\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:9:\"configure\";s:27:\"admin/config/workflow/rules\";}'),('sites/all/modules/rules/rules_admin/rules_admin.module','rules_admin','module','',1,0,0,0,'a:12:{s:4:\"name\";s:8:\"Rules UI\";s:11:\"description\";s:44:\"Administrative interface for managing rules.\";s:7:\"package\";s:5:\"Rules\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:18:\"rules_admin.module\";i:1;s:15:\"rules_admin.inc\";}s:12:\"dependencies\";a:1:{i:0;s:5:\"rules\";}s:7:\"version\";s:7:\"7.x-2.9\";s:7:\"project\";s:5:\"rules\";s:9:\"datestamp\";s:10:\"1426527210\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/rules/rules_i18n/rules_i18n.module','rules_i18n','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:17:\"Rules translation\";s:11:\"description\";s:25:\"Allows translating rules.\";s:12:\"dependencies\";a:2:{i:0;s:5:\"rules\";i:1;s:11:\"i18n_string\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:19:\"rules_i18n.i18n.inc\";i:1;s:20:\"rules_i18n.rules.inc\";i:2;s:15:\"rules_i18n.test\";}s:7:\"version\";s:7:\"7.x-2.9\";s:7:\"project\";s:5:\"rules\";s:9:\"datestamp\";s:10:\"1426527210\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/rules/rules_scheduler/rules_scheduler.module','rules_scheduler','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:15:\"Rules Scheduler\";s:11:\"description\";s:57:\"Schedule the execution of Rules components using actions.\";s:12:\"dependencies\";a:1:{i:0;s:5:\"rules\";}s:7:\"package\";s:5:\"Rules\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:9:{i:0;s:25:\"rules_scheduler.admin.inc\";i:1;s:22:\"rules_scheduler.module\";i:2;s:23:\"rules_scheduler.install\";i:3;s:25:\"rules_scheduler.rules.inc\";i:4;s:20:\"rules_scheduler.test\";i:5;s:36:\"includes/rules_scheduler.handler.inc\";i:6;s:42:\"includes/rules_scheduler.views_default.inc\";i:7;s:34:\"includes/rules_scheduler.views.inc\";i:8;s:41:\"includes/rules_scheduler_views_filter.inc\";}s:7:\"version\";s:7:\"7.x-2.9\";s:7:\"project\";s:5:\"rules\";s:9:\"datestamp\";s:10:\"1426527210\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:9:\"configure\";s:36:\"admin/config/workflow/rules/schedule\";}'),('sites/all/modules/rules/rules_scheduler/tests/rules_scheduler_test.module','rules_scheduler_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:21:\"Rules Scheduler Tests\";s:11:\"description\";s:45:\"Support module for the Rules Scheduler tests.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:24:\"rules_scheduler_test.inc\";}s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-2.9\";s:7:\"project\";s:5:\"rules\";s:9:\"datestamp\";s:10:\"1426527210\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/rules/tests/rules_test.module','rules_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:11:\"Rules Tests\";s:11:\"description\";s:35:\"Support module for the Rules tests.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:20:\"rules_test.rules.inc\";i:1;s:29:\"rules_test.rules_defaults.inc\";}s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-2.9\";s:7:\"project\";s:5:\"rules\";s:9:\"datestamp\";s:10:\"1426527210\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/rules/tests/rules_test_invocation.module','rules_test_invocation','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:21:\"Rules Test invocation\";s:11:\"description\";s:40:\"Helper module to test Rules invocations.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-2.9\";s:7:\"project\";s:5:\"rules\";s:9:\"datestamp\";s:10:\"1426527210\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/search_api/contrib/search_api_facetapi/search_api_facetapi.module','search_api_facetapi','module','',1,0,7101,0,'a:12:{s:4:\"name\";s:13:\"Search facets\";s:11:\"description\";s:73:\"Integrate the Search API with the Facet API to provide facetted searches.\";s:12:\"dependencies\";a:2:{i:0;s:10:\"search_api\";i:1;s:8:\"facetapi\";}s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Search\";s:5:\"files\";a:3:{i:0;s:28:\"plugins/facetapi/adapter.inc\";i:1;s:36:\"plugins/facetapi/query_type_term.inc\";i:2;s:36:\"plugins/facetapi/query_type_date.inc\";}s:7:\"version\";s:8:\"7.x-1.21\";s:7:\"project\";s:10:\"search_api\";s:9:\"datestamp\";s:10:\"1487844493\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/search_api/contrib/search_api_views/search_api_views.module','search_api_views','module','',1,0,7102,0,'a:12:{s:4:\"name\";s:12:\"Search views\";s:11:\"description\";s:107:\"Integrates the Search API with Views, enabling users to create views with searches as filters or arguments.\";s:12:\"dependencies\";a:2:{i:0;s:10:\"search_api\";i:1;s:5:\"views\";}s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Search\";s:5:\"files\";a:20:{i:0;s:32:\"includes/display_facet_block.inc\";i:1;s:29:\"includes/handler_argument.inc\";i:2;s:38:\"includes/handler_argument_fulltext.inc\";i:3;s:44:\"includes/handler_argument_more_like_this.inc\";i:4;s:36:\"includes/handler_argument_string.inc\";i:5;s:34:\"includes/handler_argument_date.inc\";i:6;s:43:\"includes/handler_argument_taxonomy_term.inc\";i:7;s:27:\"includes/handler_filter.inc\";i:8;s:35:\"includes/handler_filter_boolean.inc\";i:9;s:32:\"includes/handler_filter_date.inc\";i:10;s:34:\"includes/handler_filter_entity.inc\";i:11;s:36:\"includes/handler_filter_fulltext.inc\";i:12;s:36:\"includes/handler_filter_language.inc\";i:13;s:35:\"includes/handler_filter_options.inc\";i:14;s:41:\"includes/handler_filter_taxonomy_term.inc\";i:15;s:32:\"includes/handler_filter_text.inc\";i:16;s:32:\"includes/handler_filter_user.inc\";i:17;s:25:\"includes/handler_sort.inc\";i:18;s:25:\"includes/plugin_cache.inc\";i:19;s:18:\"includes/query.inc\";}s:7:\"version\";s:8:\"7.x-1.21\";s:7:\"project\";s:10:\"search_api\";s:9:\"datestamp\";s:10:\"1487844493\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/search_api/search_api.module','search_api','module','',1,0,7118,0,'a:13:{s:4:\"name\";s:10:\"Search API\";s:11:\"description\";s:64:\"Provides a generic API for modules offering search capabilities.\";s:12:\"dependencies\";a:1:{i:0;s:6:\"entity\";}s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Search\";s:5:\"files\";a:30:{i:0;s:15:\"search_api.test\";i:1;s:21:\"includes/callback.inc\";i:2;s:37:\"includes/callback_add_aggregation.inc\";i:3;s:35:\"includes/callback_add_hierarchy.inc\";i:4;s:29:\"includes/callback_add_url.inc\";i:5;s:39:\"includes/callback_add_viewed_entity.inc\";i:6;s:35:\"includes/callback_bundle_filter.inc\";i:7;s:36:\"includes/callback_comment_access.inc\";i:8;s:38:\"includes/callback_language_control.inc\";i:9;s:33:\"includes/callback_node_access.inc\";i:10;s:33:\"includes/callback_node_status.inc\";i:11;s:33:\"includes/callback_role_filter.inc\";i:12;s:33:\"includes/callback_user_status.inc\";i:13;s:23:\"includes/datasource.inc\";i:14;s:30:\"includes/datasource_entity.inc\";i:15;s:32:\"includes/datasource_external.inc\";i:16;s:32:\"includes/datasource_multiple.inc\";i:17;s:22:\"includes/exception.inc\";i:18;s:25:\"includes/index_entity.inc\";i:19;s:22:\"includes/processor.inc\";i:20;s:32:\"includes/processor_highlight.inc\";i:21;s:34:\"includes/processor_html_filter.inc\";i:22;s:34:\"includes/processor_ignore_case.inc\";i:23;s:30:\"includes/processor_stemmer.inc\";i:24;s:32:\"includes/processor_stopwords.inc\";i:25;s:32:\"includes/processor_tokenizer.inc\";i:26;s:38:\"includes/processor_transliteration.inc\";i:27;s:18:\"includes/query.inc\";i:28;s:26:\"includes/server_entity.inc\";i:29;s:20:\"includes/service.inc\";}s:9:\"configure\";s:30:\"admin/config/search/search_api\";s:7:\"version\";s:8:\"7.x-1.21\";s:7:\"project\";s:10:\"search_api\";s:9:\"datestamp\";s:10:\"1487844493\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/search_api/tests/search_api_test.module','search_api_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:15:\"Search API test\";s:11:\"description\";s:54:\"Some dummy implementations for testing the Search API.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Search\";s:12:\"dependencies\";a:1:{i:0;s:10:\"search_api\";}s:5:\"files\";a:1:{i:0;s:22:\"search_api_test.module\";}s:6:\"hidden\";b:1;s:7:\"version\";s:8:\"7.x-1.21\";s:7:\"project\";s:10:\"search_api\";s:9:\"datestamp\";s:10:\"1487844493\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/search_api_db/search_api_db.module','search_api_db','module','',1,0,7106,0,'a:14:{s:4:\"name\";s:15:\"Database search\";s:11:\"description\";s:90:\"Offers an implementation of the Search API that uses database tables for indexing content.\";s:12:\"dependencies\";a:1:{i:0;s:10:\"search_api\";}s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Search\";s:5:\"files\";a:2:{i:0;s:18:\"search_api_db.test\";i:1;s:11:\"service.inc\";}s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:13:\"search_api_db\";s:9:\"datestamp\";s:10:\"1440962643\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:121:\"Service class in use by the following server: <a href=\"/en/admin/config/search/search_api/server/frontend\">Db server</a>.\";}'),('sites/all/modules/search_api_ranges/search_api_ranges.module','search_api_ranges','module','',1,0,0,0,'a:12:{s:4:\"name\";s:13:\"Search ranges\";s:11:\"description\";s:59:\"Provides range widgets and a min/max slider for Search API.\";s:12:\"dependencies\";a:3:{i:0;s:8:\"facetapi\";i:1;s:10:\"search_api\";i:2;s:19:\"search_api_facetapi\";}s:5:\"files\";a:4:{i:0;s:39:\"includes/callback_search_api_ranges.inc\";i:1;s:33:\"plugins/facetapi/widget_links.inc\";i:2;s:34:\"plugins/facetapi/widget_slider.inc\";i:3;s:34:\"plugins/facetapi/widget_select.inc\";}s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Search\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:17:\"search_api_ranges\";s:9:\"datestamp\";s:10:\"1392554914\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/search_api_solr/search_api_solr.module','search_api_solr','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:11:\"Solr search\";s:11:\"description\";s:96:\"Offers an implementation of the Search API that uses an Apache Solr server for indexing content.\";s:12:\"dependencies\";a:1:{i:0;s:10:\"search_api\";}s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Search\";s:5:\"files\";a:6:{i:0;s:21:\"includes/document.inc\";i:1;s:20:\"includes/service.inc\";i:2;s:28:\"includes/solr_connection.inc\";i:3;s:38:\"includes/solr_connection.interface.inc\";i:4;s:23:\"includes/solr_field.inc\";i:5;s:23:\"includes/spellcheck.inc\";}s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:15:\"search_api_solr\";s:9:\"datestamp\";s:10:\"1410186051\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/search_api_sorts/search_api_sorts.module','search_api_sorts','module','',1,0,7204,0,'a:13:{s:4:\"name\";s:16:\"Search API sorts\";s:11:\"description\";s:67:\"Create sort options for search queries executed via the Search API.\";s:12:\"dependencies\";a:1:{i:0;s:10:\"search_api\";}s:17:\"test_dependencies\";a:1:{i:0;s:13:\"search_api_db\";}s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Search\";s:5:\"files\";a:2:{i:0;s:27:\"search_api_sorts.entity.inc\";i:1;s:21:\"search_api_sorts.test\";}s:7:\"version\";s:7:\"7.x-1.7\";s:7:\"project\";s:16:\"search_api_sorts\";s:9:\"datestamp\";s:10:\"1487095386\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/search_facetapi/search_facetapi.module','search_facetapi','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:29:\"Faceted Navigation for Search\";s:11:\"description\";s:61:\"Integrates the core Search module with the Facet API project.\";s:12:\"dependencies\";a:1:{i:0;s:8:\"facetapi\";}s:7:\"package\";s:14:\"Search Toolkit\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:4:{i:0;s:28:\"plugins/facetapi/adapter.inc\";i:1;s:36:\"plugins/facetapi/query_type_term.inc\";i:2;s:36:\"plugins/facetapi/query_type_date.inc\";i:3;s:28:\"search_facetapi.extender.inc\";}s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:7:\"project\";s:15:\"search_facetapi\";s:9:\"datestamp\";s:10:\"1338413501\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/select_or_other/select_or_other.module','select_or_other','module','',1,0,7201,1,'a:12:{s:4:\"name\";s:17:\"Select (or other)\";s:11:\"description\";s:86:\"Provides a select box form element with additional option \'Other\' to give a textfield.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Fields\";s:5:\"files\";a:2:{i:0;s:33:\"tests/select_or_other_number.test\";i:1;s:31:\"tests/select_or_other_text.test\";}s:7:\"version\";s:8:\"7.x-2.22\";s:7:\"project\";s:15:\"select_or_other\";s:9:\"datestamp\";s:10:\"1432142587\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/session_api/session_api.module','session_api','module','',1,0,7102,0,'a:13:{s:4:\"name\";s:11:\"Session API\";s:11:\"description\";s:54:\"Provides an interface for storing session information.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:4:{i:0;s:18:\"session_api.module\";i:1;s:21:\"session_api.admin.inc\";i:2;s:19:\"session_api.install\";i:3;s:16:\"session_api.test\";}s:9:\"configure\";s:36:\"admin/config/development/session-api\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:7:\"project\";s:11:\"session_api\";s:9:\"datestamp\";s:10:\"1354234727\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/session_api/tests/session_api_test.module','session_api_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:16:\"Session API test\";s:11:\"description\";s:38:\"Helper module for Session API testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:12:\"dependencies\";a:1:{i:0;s:11:\"session_api\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:23:\"session_api_test.module\";}s:6:\"hidden\";b:1;s:7:\"project\";s:11:\"session_api\";s:9:\"datestamp\";s:10:\"1354234727\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/sharethis/sharethis.module','sharethis','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:9:\"ShareThis\";s:11:\"description\";s:87:\"Add the <a href=\"http://www.sharethis.com/\">ShareThis</a> widget to nodes on your site.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Sharing\";s:9:\"configure\";s:31:\"admin/config/services/sharethis\";s:5:\"files\";a:1:{i:0;s:38:\"views/sharethis_handler_field_link.inc\";}s:7:\"version\";s:8:\"7.x-2.10\";s:7:\"project\";s:9:\"sharethis\";s:9:\"datestamp\";s:10:\"1422441977\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/shortcode/shortcode.module','shortcode','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:9:\"Shortcode\";s:11:\"description\";s:65:\"Provides shortcodes filter framework and API (like WP shortcodes)\";s:7:\"package\";s:9:\"Shortcode\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"filter\";}s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:9:\"shortcode\";s:9:\"datestamp\";s:10:\"1423035812\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/shortcode/shortcode_basic_tags/shortcode_basic_tags.module','shortcode_basic_tags','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:20:\"Shortcode Basic Tags\";s:11:\"description\";s:59:\"Provides basic shortcode tags like highlight, dropcap, etc.\";s:7:\"package\";s:9:\"Shortcode\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:9:\"shortcode\";}s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:9:\"shortcode\";s:9:\"datestamp\";s:10:\"1423035812\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/shortcode/shortcode_embed_content/shortcode_embed_content.module','shortcode_embed_content','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:27:\"Shortcode Embed Content Tag\";s:11:\"description\";s:64:\"Provides a shortcode tag for embedding a node content into text.\";s:7:\"package\";s:9:\"Shortcode\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:6:\"filter\";i:1;s:9:\"shortcode\";}s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:9:\"shortcode\";s:9:\"datestamp\";s:10:\"1423035812\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/shortcode/shortcode_video/shortcode_video.module','shortcode_video','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:21:\"Shortcode Video Macro\";s:11:\"description\";s:68:\"Provides easy video embedding to contents. Supports YouTube sharing.\";s:7:\"package\";s:9:\"Shortcode\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:6:\"filter\";i:1;s:9:\"shortcode\";}s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:9:\"shortcode\";s:9:\"datestamp\";s:10:\"1423035812\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/simplenews/simplenews.module','simplenews','module','',1,0,7010,0,'a:14:{s:4:\"name\";s:10:\"Simplenews\";s:11:\"description\";s:47:\"Send newsletters to subscribed email addresses.\";s:7:\"package\";s:4:\"Mail\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:32:\"admin/config/services/simplenews\";s:12:\"dependencies\";a:1:{i:0;s:8:\"taxonomy\";}s:17:\"test_dependencies\";a:1:{i:0;s:13:\"i18n_taxonomy\";}s:5:\"files\";a:13:{i:0;s:21:\"tests/simplenews.test\";i:1;s:30:\"includes/simplenews.source.inc\";i:2;s:70:\"includes/views/handlers/simplenews_handler_field_newsletter_status.inc\";i:3;s:72:\"includes/views/handlers/simplenews_handler_field_newsletter_priority.inc\";i:4;s:72:\"includes/views/handlers/simplenews_handler_field_category_hyperlinks.inc\";i:5;s:73:\"includes/views/handlers/simplenews_handler_field_category_new_account.inc\";i:6;s:71:\"includes/views/handlers/simplenews_handler_field_category_opt_inout.inc\";i:7;s:68:\"includes/views/handlers/simplenews_handler_field_newsletter_send.inc\";i:8;s:71:\"includes/views/handlers/simplenews_handler_filter_newsletter_status.inc\";i:9;s:73:\"includes/views/handlers/simplenews_handler_filter_newsletter_priority.inc\";i:10;s:73:\"includes/views/handlers/simplenews_handler_filter_category_hyperlinks.inc\";i:11;s:74:\"includes/views/handlers/simplenews_handler_filter_category_new_account.inc\";i:12;s:72:\"includes/views/handlers/simplenews_handler_filter_category_opt_inout.inc\";}s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:10:\"simplenews\";s:9:\"datestamp\";s:10:\"1381947969\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/simplenews/simplenews_rules/simplenews_rules.module','simplenews_rules','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:16:\"Simplenews rules\";s:11:\"description\";s:54:\"Provides integration with Rules module for Simplenews.\";s:12:\"dependencies\";a:2:{i:0;s:10:\"simplenews\";i:1;s:5:\"rules\";}s:7:\"package\";s:4:\"Mail\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:10:\"simplenews\";s:9:\"datestamp\";s:10:\"1381947969\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/tagclouds/tagclouds.module','tagclouds','module','',1,0,0,0,'a:13:{s:4:\"name\";s:9:\"TagClouds\";s:11:\"description\";s:61:\"TagClouds makes weighted tag clouds from your taxonomy terms.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:8:\"taxonomy\";}s:7:\"package\";s:8:\"Taxonomy\";s:9:\"configure\";s:30:\"admin/config/content/tagclouds\";s:7:\"version\";s:8:\"7.x-1.10\";s:7:\"project\";s:9:\"tagclouds\";s:9:\"datestamp\";s:10:\"1404152332\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/taxonomy_menu/taxonomy_menu.module','taxonomy_menu','module','',1,0,7000,0,'a:12:{s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:8:\"taxonomy\";i:1;s:4:\"menu\";}s:11:\"description\";s:39:\"Adds links to taxonomy terms to a menu.\";s:4:\"name\";s:13:\"Taxonomy menu\";s:7:\"package\";s:13:\"Taxonomy menu\";s:5:\"files\";a:5:{i:0;s:23:\"taxonomy_menu.batch.inc\";i:1;s:26:\"taxonomy_menu.database.inc\";i:2;s:20:\"taxonomy_menu.module\";i:3;s:18:\"taxonomy_menu.test\";i:4;s:21:\"taxonomy_menu.install\";}s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:13:\"taxonomy_menu\";s:9:\"datestamp\";s:10:\"1396359247\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/tb_megamenu/tb_megamenu.module','tb_megamenu','module','',1,0,7101,0,'a:13:{s:4:\"name\";s:12:\"TB Mega Menu\";s:11:\"description\";s:29:\"Megamenu solutions for Drupal\";s:7:\"package\";s:4:\"Menu\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:9:\"libraries\";i:1;s:13:\"jquery_update\";}s:9:\"configure\";s:27:\"admin/structure/tb-megamenu\";s:7:\"project\";s:11:\"tb_megamenu\";s:9:\"datestamp\";s:10:\"1440756596\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/title/tests/title_test.module','title_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:10:\"Title Test\";s:11:\"description\";s:61:\"Testing module for Title module functionality. Do not enable.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:3:{i:0;s:5:\"title\";i:1;s:6:\"entity\";i:2;s:18:\"entity_translation\";}s:7:\"version\";s:14:\"7.x-1.0-alpha9\";s:7:\"project\";s:5:\"title\";s:9:\"datestamp\";s:10:\"1484302985\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/title/title.module','title','module','',1,0,7002,100,'a:13:{s:4:\"name\";s:5:\"Title\";s:11:\"description\";s:50:\"Replaces entity legacy fields with regular fields.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Fields\";s:9:\"configure\";s:26:\"admin/config/content/title\";s:12:\"dependencies\";a:1:{i:0;s:14:\"system (>7.14)\";}s:5:\"files\";a:3:{i:0;s:12:\"title.module\";i:1;s:35:\"views/views_handler_title_field.inc\";i:2;s:16:\"tests/title.test\";}s:7:\"version\";s:14:\"7.x-1.0-alpha9\";s:7:\"project\";s:5:\"title\";s:9:\"datestamp\";s:10:\"1484302985\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/token/tests/token_test.module','token_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:10:\"Token Test\";s:11:\"description\";s:39:\"Testing module for token functionality.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:17:\"token_test.module\";}s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:5:\"token\";s:9:\"datestamp\";s:10:\"1425149060\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/token/token.module','token','module','',1,0,7001,0,'a:12:{s:4:\"name\";s:5:\"Token\";s:11:\"description\";s:73:\"Provides a user interface for the Token API and some missing core tokens.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"token.test\";}s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:5:\"token\";s:9:\"datestamp\";s:10:\"1425149060\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/variable/variable.module','variable','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:8:\"Variable\";s:11:\"description\";s:43:\"Variable Information and basic variable API\";s:7:\"package\";s:8:\"Variable\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:9:{i:0;s:27:\"includes/forum.variable.inc\";i:1;s:28:\"includes/locale.variable.inc\";i:2;s:26:\"includes/menu.variable.inc\";i:3;s:26:\"includes/node.variable.inc\";i:4;s:28:\"includes/system.variable.inc\";i:5;s:30:\"includes/taxonomy.variable.inc\";i:6;s:33:\"includes/translation.variable.inc\";i:7;s:26:\"includes/user.variable.inc\";i:8;s:13:\"variable.test\";}s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:8:\"variable\";s:9:\"datestamp\";s:10:\"1398250128\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/variable/variable_admin/variable_admin.module','variable_admin','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:14:\"Variable admin\";s:11:\"description\";s:26:\"Variable Administration UI\";s:12:\"dependencies\";a:1:{i:0;s:8:\"variable\";}s:7:\"package\";s:8:\"Variable\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:8:\"variable\";s:9:\"datestamp\";s:10:\"1398250128\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/variable/variable_example/variable_example.module','variable_example','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:16:\"Variable example\";s:11:\"description\";s:83:\"An example module showing how to use the Variable API and providing some variables.\";s:12:\"dependencies\";a:2:{i:0;s:8:\"variable\";i:1;s:14:\"variable_store\";}s:7:\"package\";s:15:\"Example modules\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:29:\"variable_example.variable.inc\";}s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:8:\"variable\";s:9:\"datestamp\";s:10:\"1398250128\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/variable/variable_realm/variable_realm.module','variable_realm','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:14:\"Variable realm\";s:11:\"description\";s:49:\"API to use variable realms from different modules\";s:12:\"dependencies\";a:1:{i:0;s:8:\"variable\";}s:7:\"package\";s:8:\"Variable\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-2.5\";s:5:\"files\";a:2:{i:0;s:24:\"variable_realm.class.inc\";i:1;s:30:\"variable_realm_union.class.inc\";}s:7:\"project\";s:8:\"variable\";s:9:\"datestamp\";s:10:\"1398250128\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/variable/variable_store/variable_store.module','variable_store','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:14:\"Variable store\";s:11:\"description\";s:60:\"Database storage for variable realms. This is an API module.\";s:12:\"dependencies\";a:1:{i:0;s:8:\"variable\";}s:7:\"package\";s:8:\"Variable\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-2.5\";s:5:\"files\";a:2:{i:0;s:24:\"variable_store.class.inc\";i:1;s:19:\"variable_store.test\";}s:7:\"project\";s:8:\"variable\";s:9:\"datestamp\";s:10:\"1398250128\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/variable/variable_views/variable_views.module','variable_views','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:14:\"Variable views\";s:11:\"description\";s:78:\"Provides views integration for variable, included a default variable argument.\";s:12:\"dependencies\";a:2:{i:0;s:8:\"variable\";i:1;s:5:\"views\";}s:7:\"package\";s:8:\"Variable\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:51:\"includes/views_plugin_argument_default_variable.inc\";i:1;s:47:\"includes/views_handler_field_variable_title.inc\";i:2;s:47:\"includes/views_handler_field_variable_value.inc\";}s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:8:\"variable\";s:9:\"datestamp\";s:10:\"1398250128\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/video_embed_field/video_embed_brightcove/video_embed_brightcove.module','video_embed_brightcove','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:22:\"Video Embed Brightcove\";s:11:\"description\";s:51:\"Provides Brightcove handler for Video Embed Fields.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Media\";s:9:\"configure\";s:35:\"admin/config/media/vef_video_styles\";s:12:\"dependencies\";a:1:{i:0;s:17:\"video_embed_field\";}s:7:\"version\";s:13:\"7.x-2.0-beta8\";s:7:\"project\";s:17:\"video_embed_field\";s:9:\"datestamp\";s:10:\"1408177433\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/video_embed_field/video_embed_facebook/video_embed_facebook.module','video_embed_facebook','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:20:\"Video Embed Facebook\";s:11:\"description\";s:133:\"Provides Facebook handler for Video Embed Fields.  This module also serves as an example of how to add handlers to video embed field.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Media\";s:9:\"configure\";s:35:\"admin/config/media/vef_video_styles\";s:12:\"dependencies\";a:1:{i:0;s:17:\"video_embed_field\";}s:7:\"version\";s:13:\"7.x-2.0-beta8\";s:7:\"project\";s:17:\"video_embed_field\";s:9:\"datestamp\";s:10:\"1408177433\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/video_embed_field/video_embed_field.module','video_embed_field','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:17:\"Video Embed Field\";s:11:\"description\";s:63:\"Expose a field type for embedding videos from youtube or vimeo.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Media\";s:9:\"configure\";s:35:\"admin/config/media/vef_video_styles\";s:5:\"files\";a:2:{i:0;s:29:\"video_embed_field.migrate.inc\";i:1;s:71:\"views/handlers/views_embed_field_views_handler_field_thumbnail_path.inc\";}s:12:\"dependencies\";a:2:{i:0;s:6:\"ctools\";i:1;s:5:\"image\";}s:7:\"version\";s:13:\"7.x-2.0-beta8\";s:7:\"project\";s:17:\"video_embed_field\";s:9:\"datestamp\";s:10:\"1408177433\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/views/tests/views_test.module','views_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:10:\"Views Test\";s:11:\"description\";s:22:\"Test module for Views.\";s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"views\";}s:6:\"hidden\";b:1;s:7:\"version\";s:8:\"7.x-3.16\";s:7:\"project\";s:5:\"views\";s:9:\"datestamp\";s:10:\"1491158591\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/views/views.module','views','module','',1,0,7302,10,'a:13:{s:4:\"name\";s:5:\"Views\";s:11:\"description\";s:55:\"Create customized lists and queries from your database.\";s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:13:\"css/views.css\";s:37:\"sites/all/modules/views/css/views.css\";}}s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:5:\"files\";a:313:{i:0;s:31:\"handlers/views_handler_area.inc\";i:1;s:40:\"handlers/views_handler_area_messages.inc\";i:2;s:38:\"handlers/views_handler_area_result.inc\";i:3;s:36:\"handlers/views_handler_area_text.inc\";i:4;s:43:\"handlers/views_handler_area_text_custom.inc\";i:5;s:36:\"handlers/views_handler_area_view.inc\";i:6;s:35:\"handlers/views_handler_argument.inc\";i:7;s:40:\"handlers/views_handler_argument_date.inc\";i:8;s:43:\"handlers/views_handler_argument_formula.inc\";i:9;s:47:\"handlers/views_handler_argument_many_to_one.inc\";i:10;s:40:\"handlers/views_handler_argument_null.inc\";i:11;s:43:\"handlers/views_handler_argument_numeric.inc\";i:12;s:42:\"handlers/views_handler_argument_string.inc\";i:13;s:52:\"handlers/views_handler_argument_group_by_numeric.inc\";i:14;s:32:\"handlers/views_handler_field.inc\";i:15;s:40:\"handlers/views_handler_field_counter.inc\";i:16;s:40:\"handlers/views_handler_field_boolean.inc\";i:17;s:49:\"handlers/views_handler_field_contextual_links.inc\";i:18;s:48:\"handlers/views_handler_field_ctools_dropdown.inc\";i:19;s:39:\"handlers/views_handler_field_custom.inc\";i:20;s:37:\"handlers/views_handler_field_date.inc\";i:21;s:39:\"handlers/views_handler_field_entity.inc\";i:22;s:38:\"handlers/views_handler_field_links.inc\";i:23;s:39:\"handlers/views_handler_field_markup.inc\";i:24;s:37:\"handlers/views_handler_field_math.inc\";i:25;s:40:\"handlers/views_handler_field_numeric.inc\";i:26;s:47:\"handlers/views_handler_field_prerender_list.inc\";i:27;s:46:\"handlers/views_handler_field_time_interval.inc\";i:28;s:43:\"handlers/views_handler_field_serialized.inc\";i:29;s:45:\"handlers/views_handler_field_machine_name.inc\";i:30;s:36:\"handlers/views_handler_field_url.inc\";i:31;s:33:\"handlers/views_handler_filter.inc\";i:32;s:50:\"handlers/views_handler_filter_boolean_operator.inc\";i:33;s:57:\"handlers/views_handler_filter_boolean_operator_string.inc\";i:34;s:41:\"handlers/views_handler_filter_combine.inc\";i:35;s:38:\"handlers/views_handler_filter_date.inc\";i:36;s:42:\"handlers/views_handler_filter_equality.inc\";i:37;s:47:\"handlers/views_handler_filter_entity_bundle.inc\";i:38;s:50:\"handlers/views_handler_filter_group_by_numeric.inc\";i:39;s:45:\"handlers/views_handler_filter_in_operator.inc\";i:40;s:45:\"handlers/views_handler_filter_many_to_one.inc\";i:41;s:41:\"handlers/views_handler_filter_numeric.inc\";i:42;s:40:\"handlers/views_handler_filter_string.inc\";i:43;s:48:\"handlers/views_handler_filter_fields_compare.inc\";i:44;s:39:\"handlers/views_handler_relationship.inc\";i:45;s:53:\"handlers/views_handler_relationship_groupwise_max.inc\";i:46;s:31:\"handlers/views_handler_sort.inc\";i:47;s:36:\"handlers/views_handler_sort_date.inc\";i:48;s:39:\"handlers/views_handler_sort_formula.inc\";i:49;s:48:\"handlers/views_handler_sort_group_by_numeric.inc\";i:50;s:46:\"handlers/views_handler_sort_menu_hierarchy.inc\";i:51;s:38:\"handlers/views_handler_sort_random.inc\";i:52;s:17:\"includes/base.inc\";i:53;s:21:\"includes/handlers.inc\";i:54;s:20:\"includes/plugins.inc\";i:55;s:17:\"includes/view.inc\";i:56;s:60:\"modules/aggregator/views_handler_argument_aggregator_fid.inc\";i:57;s:60:\"modules/aggregator/views_handler_argument_aggregator_iid.inc\";i:58;s:69:\"modules/aggregator/views_handler_argument_aggregator_category_cid.inc\";i:59;s:64:\"modules/aggregator/views_handler_field_aggregator_title_link.inc\";i:60;s:62:\"modules/aggregator/views_handler_field_aggregator_category.inc\";i:61;s:70:\"modules/aggregator/views_handler_field_aggregator_item_description.inc\";i:62;s:57:\"modules/aggregator/views_handler_field_aggregator_xss.inc\";i:63;s:67:\"modules/aggregator/views_handler_filter_aggregator_category_cid.inc\";i:64;s:54:\"modules/aggregator/views_plugin_row_aggregator_rss.inc\";i:65;s:56:\"modules/book/views_plugin_argument_default_book_root.inc\";i:66;s:59:\"modules/comment/views_handler_argument_comment_user_uid.inc\";i:67;s:47:\"modules/comment/views_handler_field_comment.inc\";i:68;s:53:\"modules/comment/views_handler_field_comment_depth.inc\";i:69;s:52:\"modules/comment/views_handler_field_comment_link.inc\";i:70;s:60:\"modules/comment/views_handler_field_comment_link_approve.inc\";i:71;s:59:\"modules/comment/views_handler_field_comment_link_delete.inc\";i:72;s:57:\"modules/comment/views_handler_field_comment_link_edit.inc\";i:73;s:58:\"modules/comment/views_handler_field_comment_link_reply.inc\";i:74;s:57:\"modules/comment/views_handler_field_comment_node_link.inc\";i:75;s:56:\"modules/comment/views_handler_field_comment_username.inc\";i:76;s:61:\"modules/comment/views_handler_field_ncs_last_comment_name.inc\";i:77;s:56:\"modules/comment/views_handler_field_ncs_last_updated.inc\";i:78;s:52:\"modules/comment/views_handler_field_node_comment.inc\";i:79;s:57:\"modules/comment/views_handler_field_node_new_comments.inc\";i:80;s:62:\"modules/comment/views_handler_field_last_comment_timestamp.inc\";i:81;s:57:\"modules/comment/views_handler_filter_comment_user_uid.inc\";i:82;s:57:\"modules/comment/views_handler_filter_ncs_last_updated.inc\";i:83;s:53:\"modules/comment/views_handler_filter_node_comment.inc\";i:84;s:53:\"modules/comment/views_handler_sort_comment_thread.inc\";i:85;s:60:\"modules/comment/views_handler_sort_ncs_last_comment_name.inc\";i:86;s:55:\"modules/comment/views_handler_sort_ncs_last_updated.inc\";i:87;s:48:\"modules/comment/views_plugin_row_comment_rss.inc\";i:88;s:49:\"modules/comment/views_plugin_row_comment_view.inc\";i:89;s:52:\"modules/contact/views_handler_field_contact_link.inc\";i:90;s:43:\"modules/field/views_handler_field_field.inc\";i:91;s:59:\"modules/field/views_handler_relationship_entity_reverse.inc\";i:92;s:51:\"modules/field/views_handler_argument_field_list.inc\";i:93;s:57:\"modules/field/views_handler_filter_field_list_boolean.inc\";i:94;s:58:\"modules/field/views_handler_argument_field_list_string.inc\";i:95;s:49:\"modules/field/views_handler_filter_field_list.inc\";i:96;s:57:\"modules/filter/views_handler_field_filter_format_name.inc\";i:97;s:52:\"modules/locale/views_handler_field_node_language.inc\";i:98;s:53:\"modules/locale/views_handler_filter_node_language.inc\";i:99;s:54:\"modules/locale/views_handler_argument_locale_group.inc\";i:100;s:57:\"modules/locale/views_handler_argument_locale_language.inc\";i:101;s:51:\"modules/locale/views_handler_field_locale_group.inc\";i:102;s:54:\"modules/locale/views_handler_field_locale_language.inc\";i:103;s:55:\"modules/locale/views_handler_field_locale_link_edit.inc\";i:104;s:52:\"modules/locale/views_handler_filter_locale_group.inc\";i:105;s:55:\"modules/locale/views_handler_filter_locale_language.inc\";i:106;s:54:\"modules/locale/views_handler_filter_locale_version.inc\";i:107;s:51:\"modules/locale/views_handler_sort_node_language.inc\";i:108;s:53:\"modules/node/views_handler_argument_dates_various.inc\";i:109;s:53:\"modules/node/views_handler_argument_node_language.inc\";i:110;s:48:\"modules/node/views_handler_argument_node_nid.inc\";i:111;s:49:\"modules/node/views_handler_argument_node_type.inc\";i:112;s:48:\"modules/node/views_handler_argument_node_vid.inc\";i:113;s:57:\"modules/node/views_handler_argument_node_uid_revision.inc\";i:114;s:59:\"modules/node/views_handler_field_history_user_timestamp.inc\";i:115;s:41:\"modules/node/views_handler_field_node.inc\";i:116;s:46:\"modules/node/views_handler_field_node_link.inc\";i:117;s:53:\"modules/node/views_handler_field_node_link_delete.inc\";i:118;s:51:\"modules/node/views_handler_field_node_link_edit.inc\";i:119;s:50:\"modules/node/views_handler_field_node_revision.inc\";i:120;s:55:\"modules/node/views_handler_field_node_revision_link.inc\";i:121;s:62:\"modules/node/views_handler_field_node_revision_link_delete.inc\";i:122;s:62:\"modules/node/views_handler_field_node_revision_link_revert.inc\";i:123;s:46:\"modules/node/views_handler_field_node_path.inc\";i:124;s:46:\"modules/node/views_handler_field_node_type.inc\";i:125;s:55:\"modules/node/views_handler_field_node_version_count.inc\";i:126;s:60:\"modules/node/views_handler_filter_history_user_timestamp.inc\";i:127;s:49:\"modules/node/views_handler_filter_node_access.inc\";i:128;s:49:\"modules/node/views_handler_filter_node_status.inc\";i:129;s:47:\"modules/node/views_handler_filter_node_type.inc\";i:130;s:55:\"modules/node/views_handler_filter_node_uid_revision.inc\";i:131;s:56:\"modules/node/views_handler_filter_node_version_count.inc\";i:132;s:54:\"modules/node/views_handler_sort_node_version_count.inc\";i:133;s:51:\"modules/node/views_plugin_argument_default_node.inc\";i:134;s:52:\"modules/node/views_plugin_argument_validate_node.inc\";i:135;s:42:\"modules/node/views_plugin_row_node_rss.inc\";i:136;s:43:\"modules/node/views_plugin_row_node_view.inc\";i:137;s:52:\"modules/profile/views_handler_field_profile_date.inc\";i:138;s:52:\"modules/profile/views_handler_field_profile_list.inc\";i:139;s:58:\"modules/profile/views_handler_filter_profile_selection.inc\";i:140;s:48:\"modules/search/views_handler_argument_search.inc\";i:141;s:51:\"modules/search/views_handler_field_search_score.inc\";i:142;s:46:\"modules/search/views_handler_filter_search.inc\";i:143;s:50:\"modules/search/views_handler_sort_search_score.inc\";i:144;s:47:\"modules/search/views_plugin_row_search_view.inc\";i:145;s:57:\"modules/statistics/views_handler_field_accesslog_path.inc\";i:146;s:65:\"modules/statistics/views_handler_field_node_counter_timestamp.inc\";i:147;s:61:\"modules/statistics/views_handler_field_statistics_numeric.inc\";i:148;s:50:\"modules/system/views_handler_argument_file_fid.inc\";i:149;s:43:\"modules/system/views_handler_field_file.inc\";i:150;s:53:\"modules/system/views_handler_field_file_extension.inc\";i:151;s:52:\"modules/system/views_handler_field_file_filemime.inc\";i:152;s:47:\"modules/system/views_handler_field_file_uri.inc\";i:153;s:50:\"modules/system/views_handler_field_file_status.inc\";i:154;s:51:\"modules/system/views_handler_filter_file_status.inc\";i:155;s:52:\"modules/taxonomy/views_handler_argument_taxonomy.inc\";i:156;s:57:\"modules/taxonomy/views_handler_argument_term_node_tid.inc\";i:157;s:63:\"modules/taxonomy/views_handler_argument_term_node_tid_depth.inc\";i:158;s:68:\"modules/taxonomy/views_handler_argument_term_node_tid_depth_join.inc\";i:159;s:72:\"modules/taxonomy/views_handler_argument_term_node_tid_depth_modifier.inc\";i:160;s:58:\"modules/taxonomy/views_handler_argument_vocabulary_vid.inc\";i:161;s:67:\"modules/taxonomy/views_handler_argument_vocabulary_machine_name.inc\";i:162;s:49:\"modules/taxonomy/views_handler_field_taxonomy.inc\";i:163;s:54:\"modules/taxonomy/views_handler_field_term_node_tid.inc\";i:164;s:55:\"modules/taxonomy/views_handler_field_term_link_edit.inc\";i:165;s:55:\"modules/taxonomy/views_handler_filter_term_node_tid.inc\";i:166;s:61:\"modules/taxonomy/views_handler_filter_term_node_tid_depth.inc\";i:167;s:66:\"modules/taxonomy/views_handler_filter_term_node_tid_depth_join.inc\";i:168;s:56:\"modules/taxonomy/views_handler_filter_vocabulary_vid.inc\";i:169;s:65:\"modules/taxonomy/views_handler_filter_vocabulary_machine_name.inc\";i:170;s:62:\"modules/taxonomy/views_handler_relationship_node_term_data.inc\";i:171;s:65:\"modules/taxonomy/views_plugin_argument_validate_taxonomy_term.inc\";i:172;s:63:\"modules/taxonomy/views_plugin_argument_default_taxonomy_tid.inc\";i:173;s:67:\"modules/tracker/views_handler_argument_tracker_comment_user_uid.inc\";i:174;s:65:\"modules/tracker/views_handler_filter_tracker_comment_user_uid.inc\";i:175;s:65:\"modules/tracker/views_handler_filter_tracker_boolean_operator.inc\";i:176;s:51:\"modules/system/views_handler_filter_system_type.inc\";i:177;s:56:\"modules/translation/views_handler_argument_node_tnid.inc\";i:178;s:63:\"modules/translation/views_handler_field_node_link_translate.inc\";i:179;s:65:\"modules/translation/views_handler_field_node_translation_link.inc\";i:180;s:54:\"modules/translation/views_handler_filter_node_tnid.inc\";i:181;s:60:\"modules/translation/views_handler_filter_node_tnid_child.inc\";i:182;s:62:\"modules/translation/views_handler_relationship_translation.inc\";i:183;s:48:\"modules/user/views_handler_argument_user_uid.inc\";i:184;s:55:\"modules/user/views_handler_argument_users_roles_rid.inc\";i:185;s:41:\"modules/user/views_handler_field_user.inc\";i:186;s:50:\"modules/user/views_handler_field_user_language.inc\";i:187;s:46:\"modules/user/views_handler_field_user_link.inc\";i:188;s:53:\"modules/user/views_handler_field_user_link_cancel.inc\";i:189;s:51:\"modules/user/views_handler_field_user_link_edit.inc\";i:190;s:46:\"modules/user/views_handler_field_user_mail.inc\";i:191;s:46:\"modules/user/views_handler_field_user_name.inc\";i:192;s:53:\"modules/user/views_handler_field_user_permissions.inc\";i:193;s:49:\"modules/user/views_handler_field_user_picture.inc\";i:194;s:47:\"modules/user/views_handler_field_user_roles.inc\";i:195;s:50:\"modules/user/views_handler_filter_user_current.inc\";i:196;s:47:\"modules/user/views_handler_filter_user_name.inc\";i:197;s:54:\"modules/user/views_handler_filter_user_permissions.inc\";i:198;s:48:\"modules/user/views_handler_filter_user_roles.inc\";i:199;s:59:\"modules/user/views_plugin_argument_default_current_user.inc\";i:200;s:51:\"modules/user/views_plugin_argument_default_user.inc\";i:201;s:52:\"modules/user/views_plugin_argument_validate_user.inc\";i:202;s:43:\"modules/user/views_plugin_row_user_view.inc\";i:203;s:31:\"plugins/views_plugin_access.inc\";i:204;s:36:\"plugins/views_plugin_access_none.inc\";i:205;s:36:\"plugins/views_plugin_access_perm.inc\";i:206;s:36:\"plugins/views_plugin_access_role.inc\";i:207;s:41:\"plugins/views_plugin_argument_default.inc\";i:208;s:45:\"plugins/views_plugin_argument_default_php.inc\";i:209;s:47:\"plugins/views_plugin_argument_default_fixed.inc\";i:210;s:45:\"plugins/views_plugin_argument_default_raw.inc\";i:211;s:42:\"plugins/views_plugin_argument_validate.inc\";i:212;s:50:\"plugins/views_plugin_argument_validate_numeric.inc\";i:213;s:46:\"plugins/views_plugin_argument_validate_php.inc\";i:214;s:30:\"plugins/views_plugin_cache.inc\";i:215;s:35:\"plugins/views_plugin_cache_none.inc\";i:216;s:35:\"plugins/views_plugin_cache_time.inc\";i:217;s:32:\"plugins/views_plugin_display.inc\";i:218;s:43:\"plugins/views_plugin_display_attachment.inc\";i:219;s:38:\"plugins/views_plugin_display_block.inc\";i:220;s:40:\"plugins/views_plugin_display_default.inc\";i:221;s:38:\"plugins/views_plugin_display_embed.inc\";i:222;s:41:\"plugins/views_plugin_display_extender.inc\";i:223;s:37:\"plugins/views_plugin_display_feed.inc\";i:224;s:37:\"plugins/views_plugin_display_page.inc\";i:225;s:43:\"plugins/views_plugin_exposed_form_basic.inc\";i:226;s:37:\"plugins/views_plugin_exposed_form.inc\";i:227;s:52:\"plugins/views_plugin_exposed_form_input_required.inc\";i:228;s:42:\"plugins/views_plugin_localization_core.inc\";i:229;s:37:\"plugins/views_plugin_localization.inc\";i:230;s:42:\"plugins/views_plugin_localization_none.inc\";i:231;s:30:\"plugins/views_plugin_pager.inc\";i:232;s:35:\"plugins/views_plugin_pager_full.inc\";i:233;s:35:\"plugins/views_plugin_pager_mini.inc\";i:234;s:35:\"plugins/views_plugin_pager_none.inc\";i:235;s:35:\"plugins/views_plugin_pager_some.inc\";i:236;s:30:\"plugins/views_plugin_query.inc\";i:237;s:38:\"plugins/views_plugin_query_default.inc\";i:238;s:28:\"plugins/views_plugin_row.inc\";i:239;s:35:\"plugins/views_plugin_row_fields.inc\";i:240;s:39:\"plugins/views_plugin_row_rss_fields.inc\";i:241;s:30:\"plugins/views_plugin_style.inc\";i:242;s:38:\"plugins/views_plugin_style_default.inc\";i:243;s:35:\"plugins/views_plugin_style_grid.inc\";i:244;s:35:\"plugins/views_plugin_style_list.inc\";i:245;s:40:\"plugins/views_plugin_style_jump_menu.inc\";i:246;s:38:\"plugins/views_plugin_style_mapping.inc\";i:247;s:34:\"plugins/views_plugin_style_rss.inc\";i:248;s:38:\"plugins/views_plugin_style_summary.inc\";i:249;s:48:\"plugins/views_plugin_style_summary_jump_menu.inc\";i:250;s:50:\"plugins/views_plugin_style_summary_unformatted.inc\";i:251;s:36:\"plugins/views_plugin_style_table.inc\";i:252;s:34:\"tests/handlers/views_handlers.test\";i:253;s:43:\"tests/handlers/views_handler_area_text.test\";i:254;s:47:\"tests/handlers/views_handler_argument_null.test\";i:255;s:49:\"tests/handlers/views_handler_argument_string.test\";i:256;s:39:\"tests/handlers/views_handler_field.test\";i:257;s:47:\"tests/handlers/views_handler_field_boolean.test\";i:258;s:46:\"tests/handlers/views_handler_field_custom.test\";i:259;s:47:\"tests/handlers/views_handler_field_counter.test\";i:260;s:44:\"tests/handlers/views_handler_field_date.test\";i:261;s:54:\"tests/handlers/views_handler_field_file_extension.test\";i:262;s:49:\"tests/handlers/views_handler_field_file_size.test\";i:263;s:44:\"tests/handlers/views_handler_field_math.test\";i:264;s:43:\"tests/handlers/views_handler_field_url.test\";i:265;s:43:\"tests/handlers/views_handler_field_xss.test\";i:266;s:48:\"tests/handlers/views_handler_filter_combine.test\";i:267;s:45:\"tests/handlers/views_handler_filter_date.test\";i:268;s:49:\"tests/handlers/views_handler_filter_equality.test\";i:269;s:52:\"tests/handlers/views_handler_filter_in_operator.test\";i:270;s:48:\"tests/handlers/views_handler_filter_numeric.test\";i:271;s:47:\"tests/handlers/views_handler_filter_string.test\";i:272;s:45:\"tests/handlers/views_handler_sort_random.test\";i:273;s:43:\"tests/handlers/views_handler_sort_date.test\";i:274;s:38:\"tests/handlers/views_handler_sort.test\";i:275;s:46:\"tests/test_handlers/views_test_area_access.inc\";i:276;s:60:\"tests/test_plugins/views_test_plugin_access_test_dynamic.inc\";i:277;s:59:\"tests/test_plugins/views_test_plugin_access_test_static.inc\";i:278;s:59:\"tests/test_plugins/views_test_plugin_style_test_mapping.inc\";i:279;s:39:\"tests/plugins/views_plugin_display.test\";i:280;s:46:\"tests/styles/views_plugin_style_jump_menu.test\";i:281;s:36:\"tests/styles/views_plugin_style.test\";i:282;s:41:\"tests/styles/views_plugin_style_base.test\";i:283;s:44:\"tests/styles/views_plugin_style_mapping.test\";i:284;s:48:\"tests/styles/views_plugin_style_unformatted.test\";i:285;s:23:\"tests/views_access.test\";i:286;s:24:\"tests/views_analyze.test\";i:287;s:22:\"tests/views_basic.test\";i:288;s:33:\"tests/views_argument_default.test\";i:289;s:35:\"tests/views_argument_validator.test\";i:290;s:29:\"tests/views_exposed_form.test\";i:291;s:31:\"tests/field/views_fieldapi.test\";i:292;s:25:\"tests/views_glossary.test\";i:293;s:24:\"tests/views_groupby.test\";i:294;s:25:\"tests/views_handlers.test\";i:295;s:23:\"tests/views_module.test\";i:296;s:22:\"tests/views_pager.test\";i:297;s:40:\"tests/views_plugin_localization_test.inc\";i:298;s:29:\"tests/views_translatable.test\";i:299;s:22:\"tests/views_query.test\";i:300;s:24:\"tests/views_upgrade.test\";i:301;s:34:\"tests/views_test.views_default.inc\";i:302;s:58:\"tests/comment/views_handler_argument_comment_user_uid.test\";i:303;s:56:\"tests/comment/views_handler_filter_comment_user_uid.test\";i:304;s:45:\"tests/node/views_node_revision_relations.test\";i:305;s:61:\"tests/taxonomy/views_handler_relationship_node_term_data.test\";i:306;s:45:\"tests/user/views_handler_field_user_name.test\";i:307;s:43:\"tests/user/views_user_argument_default.test\";i:308;s:44:\"tests/user/views_user_argument_validate.test\";i:309;s:26:\"tests/user/views_user.test\";i:310;s:22:\"tests/views_cache.test\";i:311;s:21:\"tests/views_view.test\";i:312;s:19:\"tests/views_ui.test\";}s:7:\"version\";s:8:\"7.x-3.16\";s:7:\"project\";s:5:\"views\";s:9:\"datestamp\";s:10:\"1491158591\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/views/views_ui.module','views_ui','module','',1,0,0,0,'a:13:{s:4:\"name\";s:8:\"Views UI\";s:11:\"description\";s:93:\"Administrative interface to views. Without this module, you cannot create or edit your views.\";s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:21:\"admin/structure/views\";s:12:\"dependencies\";a:1:{i:0;s:5:\"views\";}s:5:\"files\";a:2:{i:0;s:15:\"views_ui.module\";i:1;s:57:\"plugins/views_wizard/views_ui_base_views_wizard.class.php\";}s:7:\"version\";s:8:\"7.x-3.16\";s:7:\"project\";s:5:\"views\";s:9:\"datestamp\";s:10:\"1491158591\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/views_bootstrap/views_bootstrap.module','views_bootstrap','module','',1,0,0,0,'a:12:{s:4:\"name\";s:15:\"Views Bootstrap\";s:7:\"package\";s:5:\"Views\";s:11:\"description\";s:20:\"Bootstrap Components\";s:12:\"dependencies\";a:1:{i:0;s:5:\"views\";}s:5:\"files\";a:9:{i:0;s:58:\"plugins/carousel/views_bootstrap_carousel_plugin_style.inc\";i:1;s:57:\"plugins/carousel/views_bootstrap_carousel_plugin_rows.inc\";i:2;s:60:\"plugins/thumbnail/views_bootstrap_thumbnail_plugin_style.inc\";i:3;s:59:\"plugins/thumbnail/views_bootstrap_thumbnail_plugin_rows.inc\";i:4;s:50:\"plugins/grid/views_bootstrap_grid_plugin_style.inc\";i:5;s:60:\"plugins/accordion/views_bootstrap_accordion_plugin_style.inc\";i:6;s:48:\"plugins/tab/views_bootstrap_tab_plugin_style.inc\";i:7;s:52:\"plugins/media/views_bootstrap_media_plugin_style.inc\";i:8;s:52:\"plugins/table/views_bootstrap_table_plugin_style.inc\";}s:7:\"version\";s:7:\"7.x-3.1\";s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:15:\"views_bootstrap\";s:9:\"datestamp\";s:10:\"1398607429\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/views_bulk_operations/actions_permissions.module','actions_permissions','module','',1,0,0,0,'a:12:{s:4:\"name\";s:25:\"Actions permissions (VBO)\";s:11:\"description\";s:84:\"Provides permission-based access control for actions. Used by Views Bulk Operations.\";s:7:\"package\";s:14:\"Administration\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-3.3\";s:7:\"project\";s:21:\"views_bulk_operations\";s:9:\"datestamp\";s:10:\"1435764542\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/views_bulk_operations/views_bulk_operations.module','views_bulk_operations','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:21:\"Views Bulk Operations\";s:11:\"description\";s:74:\"Provides a way of selecting multiple rows and applying operations to them.\";s:12:\"dependencies\";a:2:{i:0;s:6:\"entity\";i:1;s:5:\"views\";}s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:3:\"php\";s:5:\"5.2.9\";s:5:\"files\";a:2:{i:0;s:38:\"plugins/operation_types/base.class.php\";i:1;s:56:\"views/views_bulk_operations_handler_field_operations.inc\";}s:7:\"version\";s:7:\"7.x-3.3\";s:7:\"project\";s:21:\"views_bulk_operations\";s:9:\"datestamp\";s:10:\"1435764542\";s:5:\"mtime\";i:1499933463;s:9:\"bootstrap\";i:0;}'),('sites/all/modules/views_fieldsets/views_fieldsets.module','views_fieldsets','module','',1,0,0,0,'a:12:{s:4:\"name\";s:15:\"Views fieldsets\";s:11:\"description\";s:44:\"Output several Views fields into a fieldset.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Views\";s:12:\"dependencies\";a:1:{i:0;s:5:\"views\";}s:5:\"files\";a:1:{i:0;s:48:\"views/views_fieldsets_fieldset_field_handler.inc\";}s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:15:\"views_fieldsets\";s:9:\"datestamp\";s:10:\"1425515886\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/views_field_view/views_field_view.module','views_field_view','module','',1,0,0,0,'a:12:{s:4:\"name\";s:16:\"Views Field View\";s:11:\"description\";s:36:\"Embeds a view inside a view as field\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Views\";s:12:\"dependencies\";a:1:{i:0;s:5:\"views\";}s:5:\"files\";a:2:{i:0;s:39:\"views_field_view_handler_field_view.inc\";i:1;s:27:\"tests/views_field_view.test\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:16:\"views_field_view\";s:9:\"datestamp\";s:10:\"1442561052\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/views_slideshow/contrib/views_slideshow_cycle/views_slideshow_cycle.module','views_slideshow_cycle','module','',1,0,0,0,'a:12:{s:4:\"name\";s:22:\"Views Slideshow: Cycle\";s:11:\"description\";s:50:\"Adds a Rotating slideshow mode to Views Slideshow.\";s:12:\"dependencies\";a:2:{i:0;s:15:\"views_slideshow\";i:1;s:9:\"libraries\";}s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:28:\"views_slideshow_cycle.module\";i:1;s:41:\"views_slideshow_cycle.views_slideshow.inc\";i:2;s:37:\"theme/views_slideshow_cycle.theme.inc\";}s:7:\"version\";s:7:\"7.x-3.1\";s:7:\"project\";s:15:\"views_slideshow\";s:9:\"datestamp\";s:10:\"1382584826\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/views_slideshow/views_slideshow.module','views_slideshow','module','',1,0,0,0,'a:12:{s:4:\"name\";s:15:\"Views Slideshow\";s:11:\"description\";s:155:\"Provides a View style that displays rows as a jQuery slideshow.  This is an API and requires Views Slideshow Cycle or another module that supports the API.\";s:12:\"dependencies\";a:1:{i:0;s:13:\"views (>=3.0)\";}s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:4:{i:0;s:22:\"views_slideshow.module\";i:1;s:31:\"theme/views_slideshow.theme.inc\";i:2;s:25:\"views_slideshow.views.inc\";i:3;s:42:\"views_slideshow_plugin_style_slideshow.inc\";}s:7:\"version\";s:7:\"7.x-3.1\";s:7:\"project\";s:15:\"views_slideshow\";s:9:\"datestamp\";s:10:\"1382584826\";s:5:\"mtime\";i:1499933463;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/votingapi/votingapi.module','votingapi','module','',1,0,7203,0,'a:13:{s:4:\"name\";s:10:\"Voting API\";s:11:\"description\";s:47:\"Provides a shared voting API for other modules.\";s:7:\"package\";s:6:\"Voting\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:29:\"admin/config/search/votingapi\";s:5:\"files\";a:4:{i:0;s:20:\"tests/votingapi.test\";i:1;s:45:\"views/votingapi_views_handler_field_value.inc\";i:2;s:47:\"views/votingapi_views_handler_sort_nullable.inc\";i:3;s:46:\"views/votingapi_views_handler_relationship.inc\";}s:7:\"version\";s:8:\"7.x-2.12\";s:7:\"project\";s:9:\"votingapi\";s:9:\"datestamp\";s:10:\"1407995929\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/webform/webform.module','webform','module','',1,0,7430,-1,'a:14:{s:4:\"name\";s:7:\"Webform\";s:11:\"description\";s:49:\"Enables the creation of forms and questionnaires.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Webform\";s:9:\"configure\";s:28:\"admin/config/content/webform\";s:3:\"php\";s:3:\"5.3\";s:12:\"dependencies\";a:2:{i:0;s:6:\"ctools\";i:1;s:5:\"views\";}s:17:\"test_dependencies\";a:1:{i:0;s:5:\"token\";}s:5:\"files\";a:26:{i:0;s:40:\"includes/webform.webformconditionals.inc\";i:1;s:49:\"includes/exporters/webform_exporter_delimited.inc\";i:2;s:55:\"includes/exporters/webform_exporter_excel_delimited.inc\";i:3;s:50:\"includes/exporters/webform_exporter_excel_xlsx.inc\";i:4;s:39:\"includes/exporters/webform_exporter.inc\";i:5;s:43:\"views/webform_handler_area_result_pager.inc\";i:6;s:41:\"views/webform_handler_field_form_body.inc\";i:7;s:40:\"views/webform_handler_field_is_draft.inc\";i:8;s:46:\"views/webform_handler_field_node_link_edit.inc\";i:9;s:49:\"views/webform_handler_field_node_link_results.inc\";i:10;s:48:\"views/webform_handler_field_submission_count.inc\";i:11;s:47:\"views/webform_handler_field_submission_data.inc\";i:12;s:47:\"views/webform_handler_field_submission_link.inc\";i:13;s:46:\"views/webform_handler_field_webform_status.inc\";i:14;s:41:\"views/webform_handler_filter_is_draft.inc\";i:15;s:48:\"views/webform_handler_filter_submission_data.inc\";i:16;s:47:\"views/webform_handler_filter_webform_status.inc\";i:17;s:38:\"views/webform_handler_numeric_data.inc\";i:18;s:54:\"views/webform_handler_relationship_submission_data.inc\";i:19;s:44:\"views/webform_plugin_row_submission_view.inc\";i:20;s:23:\"views/webform.views.inc\";i:21;s:21:\"tests/components.test\";i:22;s:23:\"tests/conditionals.test\";i:23;s:22:\"tests/permissions.test\";i:24;s:21:\"tests/submission.test\";i:25;s:18:\"tests/webform.test\";}s:7:\"version\";s:8:\"7.x-4.11\";s:7:\"project\";s:7:\"webform\";s:9:\"datestamp\";s:10:\"1442953145\";s:5:\"mtime\";i:1499933463;s:9:\"bootstrap\";i:0;}'),('sites/all/modules/weebpal_custom/weebpal_modules/weebpal_modules.module','weebpal_modules','module','',0,0,-1,0,'a:10:{s:4:\"name\";s:22:\"WeebPal Modules Custom\";s:11:\"description\";s:22:\"WeebPal Modules Custom\";s:7:\"package\";s:14:\"WeebPal Custom\";s:4:\"core\";s:3:\"7.x\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:7:\"version\";N;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/weight/weight.module','weight','module','',1,0,7212,0,'a:12:{s:4:\"name\";s:6:\"Weight\";s:11:\"description\";s:28:\"Add a weight field to nodes.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:37:\"views/weight_handler_field_weight.inc\";i:1;s:46:\"views/weight_handler_filter_weight_enabled.inc\";i:2;s:18:\"weight.migrate.inc\";}s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:6:\"weight\";s:9:\"datestamp\";s:10:\"1430342647\";s:5:\"mtime\";i:1499933463;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/we_content_migration/we_content_migration.module','we_content_migration','module','',1,0,0,0,'a:12:{s:4:\"name\";s:17:\"Content Migration\";s:11:\"description\";s:29:\"Migrate Content for Drupal 7.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:17:\"Content Migration\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:7:\"project\";s:20:\"we_content_migration\";s:9:\"datestamp\";s:10:\"1499677744\";s:5:\"mtime\";i:1499652544;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/themes/marketplace/marketplace.info','marketplace','theme','themes/engines/phptemplate/phptemplate.engine',1,0,-1,0,'a:19:{s:4:\"name\";s:12:\"Market Place\";s:11:\"description\";s:23:\"Theme for Market Place.\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"engine\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:5:{s:3:\"all\";a:11:{s:34:\"vendor/bootstrap/css/bootstrap.css\";s:63:\"sites/all/themes/marketplace/vendor/bootstrap/css/bootstrap.css\";s:40:\"vendor/bootstrap/css/bootstrap-theme.css\";s:69:\"sites/all/themes/marketplace/vendor/bootstrap/css/bootstrap-theme.css\";s:20:\"fonts/stylesheet.css\";s:49:\"sites/all/themes/marketplace/fonts/stylesheet.css\";s:15:\"css/animate.css\";s:44:\"sites/all/themes/marketplace/css/animate.css\";s:12:\"css/html.css\";s:41:\"sites/all/themes/marketplace/css/html.css\";s:12:\"css/base.css\";s:41:\"sites/all/themes/marketplace/css/base.css\";s:12:\"css/page.css\";s:41:\"sites/all/themes/marketplace/css/page.css\";s:13:\"css/block.css\";s:42:\"sites/all/themes/marketplace/css/block.css\";s:12:\"css/view.css\";s:41:\"sites/all/themes/marketplace/css/view.css\";s:12:\"css/menu.css\";s:41:\"sites/all/themes/marketplace/css/menu.css\";s:14:\"css/screen.css\";s:43:\"sites/all/themes/marketplace/css/screen.css\";}s:56:\"only screen and (min-width:992px) and (max-width:1199px)\";a:1:{s:22:\"css/screens/tablet.css\";s:51:\"sites/all/themes/marketplace/css/screens/tablet.css\";}s:55:\"only screen and (min-width:768px) and (max-width:991px)\";a:1:{s:31:\"css/screens/vertical_tablet.css\";s:60:\"sites/all/themes/marketplace/css/screens/vertical_tablet.css\";}s:33:\"only screen and (max-width:991px)\";a:1:{s:22:\"css/screens/common.css\";s:51:\"sites/all/themes/marketplace/css/screens/common.css\";}s:33:\"only screen and (max-width:767px)\";a:1:{s:22:\"css/screens/mobile.css\";s:51:\"sites/all/themes/marketplace/css/screens/mobile.css\";}}s:7:\"scripts\";a:6:{s:36:\"vendor/bootstrap/js/bootstrap.min.js\";s:65:\"sites/all/themes/marketplace/vendor/bootstrap/js/bootstrap.min.js\";s:23:\"vendor/jquery.cookie.js\";s:52:\"sites/all/themes/marketplace/vendor/jquery.cookie.js\";s:30:\"vendor/jquery.smooth-scroll.js\";s:59:\"sites/all/themes/marketplace/vendor/jquery.smooth-scroll.js\";s:28:\"vendor/uikit/js/uikit.min.js\";s:57:\"sites/all/themes/marketplace/vendor/uikit/js/uikit.min.js\";s:13:\"js/weebpal.js\";s:42:\"sites/all/themes/marketplace/js/weebpal.js\";s:17:\"js/marketplace.js\";s:46:\"sites/all/themes/marketplace/js/marketplace.js\";}s:8:\"features\";a:7:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:25:\"comment_user_verification\";i:6;s:7:\"favicon\";}s:7:\"regions\";a:25:{s:8:\"headline\";s:8:\"Headline\";s:6:\"header\";s:6:\"Header\";s:9:\"main_menu\";s:9:\"Main Menu\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"panel_menu_top\";s:8:\"Menu Top\";s:17:\"panel_mobile_menu\";s:17:\"Panel Mobile Menu\";s:11:\"panel_first\";s:11:\"Panel First\";s:12:\"panel_second\";s:12:\"Panel Second\";s:11:\"panel_third\";s:11:\"Panel Third\";s:19:\"panel_highlighted_1\";s:16:\"Highlighted Left\";s:19:\"panel_highlighted_2\";s:11:\"Highlighted\";s:19:\"panel_highlighted_3\";s:17:\"Highlighted Right\";s:14:\"panel_footer_1\";s:14:\"Panel Footer 1\";s:14:\"panel_footer_2\";s:14:\"Panel Footer 2\";s:14:\"panel_footer_3\";s:14:\"Panel Footer 3\";s:14:\"panel_footer_4\";s:14:\"Panel Footer 4\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:9:{s:19:\"sidebar_first_width\";s:1:\"3\";s:20:\"sidebar_second_width\";s:1:\"3\";s:20:\"panel_footer_1_width\";s:1:\"3\";s:20:\"panel_footer_2_width\";s:1:\"3\";s:20:\"panel_footer_3_width\";s:1:\"3\";s:20:\"panel_footer_4_width\";s:1:\"3\";s:25:\"panel_highlighted_1_width\";s:1:\"4\";s:25:\"panel_highlighted_3_width\";s:1:\"4\";s:20:\"layout_width_default\";s:4:\"1200\";}s:5:\"skins\";a:5:{s:3:\"red\";s:3:\"Red\";s:9:\"dark_blue\";s:9:\"Dark Blue\";s:6:\"yellow\";s:6:\"Yellow\";s:5:\"green\";s:5:\"Green\";s:4:\"cyan\";s:4:\"Cyan\";}s:11:\"backgrounds\";a:7:{s:4:\"bg-1\";s:12:\"Background 1\";s:4:\"bg-2\";s:12:\"Background 2\";s:4:\"bg-3\";s:12:\"Background 3\";s:4:\"bg-4\";s:12:\"Background 4\";s:4:\"bg-5\";s:12:\"Background 5\";s:4:\"bg-6\";s:12:\"Background 6\";s:4:\"bg-7\";s:12:\"Background 7\";}s:6:\"layout\";a:1:{s:12:\"layout-boxed\";s:12:\"Boxed Layout\";}s:10:\"screenshot\";s:43:\"sites/all/themes/marketplace/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"mtime\";i:1499933463;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}'),('sites/all/themes/we_backend/we_backend.info','we_backend','theme','themes/engines/phptemplate/phptemplate.engine',1,0,-1,0,'a:15:{s:4:\"name\";s:21:\"WeebPal Backend theme\";s:11:\"description\";s:26:\"Backend theme from WeebPal\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"engine\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:20:\"assets/css/style.css\";s:48:\"sites/all/themes/we_backend/assets/css/style.css\";}}s:7:\"scripts\";a:1:{s:20:\"assets/js/scripts.js\";s:48:\"sites/all/themes/we_backend/assets/js/scripts.js\";}s:8:\"features\";a:7:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:25:\"comment_user_verification\";i:6;s:7:\"favicon\";}s:7:\"regions\";a:10:{s:6:\"header\";s:6:\"Header\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:10:\"screenshot\";s:42:\"sites/all/themes/we_backend/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"mtime\";i:1499933463;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}'),('themes/bartik/bartik.info','bartik','theme','themes/engines/phptemplate/phptemplate.engine',1,0,-1,0,'a:19:{s:4:\"name\";s:6:\"Bartik\";s:11:\"description\";s:48:\"A flexible, recolorable theme with many regions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:7:\"regions\";a:20:{s:6:\"header\";s:6:\"Header\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"triptych_first\";s:14:\"Triptych first\";s:15:\"triptych_middle\";s:15:\"Triptych middle\";s:13:\"triptych_last\";s:13:\"Triptych last\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"0\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:28:\"themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}'),('themes/garland/garland.info','garland','theme','themes/engines/phptemplate/phptemplate.engine',0,0,-1,0,'a:19:{s:4:\"name\";s:7:\"Garland\";s:11:\"description\";s:111:\"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:8:\"settings\";a:1:{s:13:\"garland_width\";s:5:\"fluid\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:29:\"themes/garland/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}'),('themes/seven/seven.info','seven','theme','themes/engines/phptemplate/phptemplate.engine',1,0,-1,0,'a:19:{s:4:\"name\";s:5:\"Seven\";s:11:\"description\";s:65:\"A simple one-column, tableless, fluid width administration theme.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"1\";}s:7:\"regions\";a:8:{s:7:\"content\";s:7:\"Content\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}'),('themes/stark/stark.info','stark','theme','themes/engines/phptemplate/phptemplate.engine',0,0,-1,0,'a:18:{s:4:\"name\";s:5:\"Stark\";s:11:\"description\";s:208:\"This theme demonstrates Drupal\'s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal\'s default code, see the <a href=\"http://drupal.org/theme-guide\">Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/stark/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}');
/*!40000 ALTER TABLE `system` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `taxonomy_index`
--

DROP TABLE IF EXISTS `taxonomy_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxonomy_index` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid this record tracks.',
  `tid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The term ID.',
  `sticky` tinyint(4) DEFAULT '0' COMMENT 'Boolean indicating whether the node is sticky.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the node was created.',
  KEY `term_node` (`tid`,`sticky`,`created`),
  KEY `nid` (`nid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Maintains denormalized information about node/term...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxonomy_index`
--

LOCK TABLES `taxonomy_index` WRITE;
/*!40000 ALTER TABLE `taxonomy_index` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `taxonomy_index` VALUES (2,34,0,1412914951),(2,10,0,1412914951),(1,2,0,1412914723),(1,10,0,1412914723),(76,64,0,1417589262),(76,10,0,1417589262),(75,64,0,1417588949),(75,82,0,1417588949),(74,63,0,1417588401),(74,11,0,1417588401),(38,71,0,1417508779),(38,82,0,1417508779),(67,51,0,1417581463),(67,97,0,1417581463),(64,48,0,1417579912),(64,94,0,1417579912),(62,53,0,1417578986),(62,93,0,1417578986),(41,70,0,1417511293),(41,86,0,1417511293),(85,17,0,1417600163),(85,102,0,1417600163),(49,31,0,1417518185),(49,10,0,1417518185),(52,32,0,1417530153),(52,10,0,1417530153),(58,39,0,1417576765),(58,91,0,1417576765),(48,29,0,1417517324),(48,14,0,1417517324),(43,72,0,1417512093),(43,82,0,1417512093),(86,18,0,1417600767),(86,102,0,1417600767),(84,17,0,1417599720),(84,98,0,1417599720),(83,42,0,1417599162),(83,101,0,1417599162),(82,42,0,1417598912),(82,102,0,1417598912),(36,68,0,1417504200),(36,82,0,1417504200),(37,68,0,1417504583),(37,83,0,1417504583),(40,70,0,1417510355),(40,85,0,1417510355),(42,72,0,1417511809),(42,87,0,1417511809),(44,28,0,1417513096),(44,10,0,1417513096),(47,29,0,1417515888),(47,88,0,1417515888),(50,31,0,1417518819),(50,13,0,1417518819),(53,34,0,1417530854),(53,89,0,1417530854),(54,34,0,1417531758),(54,11,0,1417531758),(55,35,0,1417532298),(55,82,0,1417532298),(56,35,0,1417533303),(56,90,0,1417533303),(57,39,0,1417573407),(57,10,0,1417573407),(59,38,0,1417577778),(59,82,0,1417577778),(60,38,0,1417578198),(60,82,0,1417578198),(61,53,0,1417578593),(61,92,0,1417578593),(63,48,0,1417579652),(63,94,0,1417579652),(65,49,0,1417580590),(65,95,0,1417580590),(66,49,0,1417580757),(66,95,0,1417580757),(68,51,0,1417581629),(68,96,0,1417581629),(69,52,0,1417582273),(69,99,0,1417582273),(70,52,0,1417582520),(70,82,0,1417582520),(73,63,0,1417588138),(73,91,0,1417588138),(77,41,0,1417590261),(77,12,0,1417590261),(78,44,0,1417591448),(78,82,0,1417591448),(79,44,0,1417591728),(79,12,0,1417591728),(80,45,0,1417592574),(80,100,0,1417592574),(81,45,0,1417592796),(81,100,0,1417592796),(32,66,0,1417446223),(32,76,0,1417446223),(33,66,0,1417447402),(33,78,0,1417447402),(35,67,0,1417481146),(35,81,0,1417481146),(31,77,0,1417445005),(31,75,0,1417445005),(34,67,0,1417478826),(34,79,0,1417478826),(88,18,0,1418365242),(88,11,0,1418365242),(89,25,0,1418365650),(89,103,0,1418365650),(90,25,0,1418366198),(90,102,0,1418366198),(91,26,0,1418366731),(91,111,0,1418366731),(94,23,0,1418369205),(94,114,0,1418369205),(93,22,0,1418368416),(93,113,0,1418368416),(95,58,0,1418370240),(95,115,0,1418370240),(92,22,0,1418367347),(92,112,0,1418367347),(96,59,0,1418370758),(96,116,0,1418370758),(97,57,0,1418371223),(97,117,0,1418371223),(99,59,0,1418375179),(100,57,0,1418375406),(98,58,0,1418374047),(101,77,0,1418376994),(102,67,0,1418377770),(103,68,0,1418378499),(104,70,0,1418378630),(105,72,0,1418378759),(106,73,0,1418379045),(108,35,0,1418379782),(107,29,0,1418379647),(111,31,0,1418380893),(112,32,0,1418381108),(114,38,0,1418381604),(116,48,0,1418632181),(115,53,0,1418632088),(117,49,0,1418632414),(118,51,0,1418632547),(119,52,0,1418632627),(120,61,0,1418638559),(121,63,0,1418638692),(3,6,0,1412915086),(3,10,0,1412915086),(122,64,0,1418639070),(123,40,0,1418640832),(124,41,0,1418641175),(125,44,0,1418641282),(126,45,0,1418641404),(127,42,0,1418641523),(128,17,0,1418701080),(129,18,0,1418701197),(130,26,0,1418701300),(131,25,0,1418701389),(132,22,0,1418701500),(133,23,0,1418701663),(134,66,0,1418704961),(45,28,0,1417513689),(45,11,0,1417513689),(87,71,0,1417666125),(109,34,0,1418379877),(113,39,0,1418381515),(110,28,0,1418380566),(135,13,0,1418789083),(136,96,0,1418789989),(10,40,0,1416304113),(10,10,0,1416304113),(9,40,0,1416303464),(9,10,0,1416303464),(138,73,0,1418884808),(138,118,0,1418884808),(140,26,0,1418895744),(137,102,0,1418790897),(139,73,0,1418885579),(139,119,0,1418885579),(39,71,0,1417509360),(39,84,0,1417509360),(30,77,0,1417426925),(30,74,0,1417426925),(72,61,0,1417587699),(72,11,0,1417587699),(71,61,0,1417587476),(71,11,0,1417587476),(46,41,0,1417515301),(46,13,0,1417515301),(51,32,0,1417528583),(51,88,0,1417528583);
/*!40000 ALTER TABLE `taxonomy_index` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `taxonomy_menu`
--

DROP TABLE IF EXISTS `taxonomy_menu`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxonomy_menu` (
  `mlid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The taxonomy terms menu_link.mlid.',
  `tid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Tid that is linked to the mlid.',
  `vid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Vid for the tid.',
  PRIMARY KEY (`mlid`,`tid`),
  KEY `vid` (`vid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Links a taxonomy term to a menu item.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxonomy_menu`
--

LOCK TABLES `taxonomy_menu` WRITE;
/*!40000 ALTER TABLE `taxonomy_menu` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `taxonomy_menu` VALUES (611,8,3),(612,2,3),(613,7,3),(614,6,3),(615,3,3),(616,4,3),(617,9,3),(618,5,3),(1064,17,3),(1065,18,3),(1068,21,3),(1069,22,3),(1070,23,3),(1071,24,3),(1072,25,3),(1073,26,3),(1074,27,3),(1075,28,3),(1076,29,3),(1077,30,3),(1078,31,3),(1079,32,3),(1080,33,3),(1081,34,3),(1082,35,3),(1083,36,3),(1085,38,3),(1086,39,3),(1087,40,3),(1088,41,3),(1089,42,3),(1090,43,3),(1091,44,3),(1092,45,3),(1094,47,3),(1095,48,3),(1096,49,3),(1097,50,3),(1098,51,3),(1099,52,3),(1100,53,3),(1101,54,3),(1102,55,3),(1103,56,3),(1104,57,3),(1105,58,3),(1106,59,3),(1107,60,3),(1108,61,3),(1109,62,3),(1110,63,3),(1111,64,3),(1112,65,3),(1113,66,3),(1114,67,3),(1115,68,3),(1116,69,3),(1117,70,3),(1118,71,3),(1119,72,3),(1120,73,3),(1121,77,3);
/*!40000 ALTER TABLE `taxonomy_menu` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `taxonomy_term_data`
--

DROP TABLE IF EXISTS `taxonomy_term_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxonomy_term_data` (
  `tid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique term ID.',
  `vid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The taxonomy_vocabulary.vid of the vocabulary to which the term is assigned.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The term name.',
  `description` longtext COMMENT 'A description of the term.',
  `format` varchar(255) DEFAULT NULL COMMENT 'The filter_format.format of the description.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The weight of this term in relation to other terms.',
  PRIMARY KEY (`tid`),
  KEY `taxonomy_tree` (`vid`,`weight`,`name`),
  KEY `vid_name` (`vid`,`name`),
  KEY `name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=120 DEFAULT CHARSET=utf8 COMMENT='Stores term information.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxonomy_term_data`
--

LOCK TABLES `taxonomy_term_data` WRITE;
/*!40000 ALTER TABLE `taxonomy_term_data` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `taxonomy_term_data` VALUES (1,2,'Azastore newsletter','Azastore newsletter categories.',NULL,0),(2,3,'Clothes Shoes & Bags','','filtered_html',56),(3,3,'Health & Beauty','','filtered_html',57),(4,3,'Mobiles & Tablets','','filtered_html',58),(5,3,'Watches & Accessories','','filtered_html',59),(6,3,'Consumer Electronics','','filtered_html',60),(7,3,'Computers & Laptops','','filtered_html',61),(8,3,'Cameras','','filtered_html',62),(9,3,'Toys, Kids & Babies','','filtered_html',63),(10,4,'Apple','','filtered_html',0),(11,4,'Samsung','','filtered_html',0),(12,4,'Dell','','filtered_html',0),(13,4,'Asus','','filtered_html',0),(14,4,'Nokia','','filtered_html',0),(15,5,'In Stock','','filtered_html',0),(16,5,'Out Of Stock','','filtered_html',0),(17,3,'Point & Shoot Cameras','','filtered_html',0),(18,3,'DSLR/SLR Cameras','','filtered_html',1),(21,3,'Other Cameras','','filtered_html',5),(22,3,'IP Cameras','','filtered_html',0),(23,3,'Car Cameras','','filtered_html',1),(24,3,'Camera Accessories','','filtered_html',4),(25,3,'Lenses','','filtered_html',1),(26,3,'Filters','','filtered_html',0),(27,3,'Mobiles','','filtered_html',0),(28,3,'Smartphones','','filtered_html',0),(29,3,'Basic Phones','','filtered_html',1),(30,3,'Tablets','','filtered_html',1),(31,3,'With call facility','','filtered_html',0),(32,3,'Without call facility','','filtered_html',1),(33,3,'Mobile Accessories','','filtered_html',2),(34,3,'Cases & Covers','','filtered_html',0),(35,3,'Car Accessories','','filtered_html',1),(36,3,'Tablet Accessories','','filtered_html',3),(38,3,'Batteries & Chargers','','filtered_html',1),(39,3,'Headphones','','filtered_html',0),(40,3,'Laptops','','filtered_html',0),(41,3,'Desktops','','filtered_html',1),(42,3,'Scanners','','filtered_html',3),(43,3,'Network Components','','filtered_html',2),(44,3,'Switches','','filtered_html',0),(45,3,'Routers','','filtered_html',1),(47,3,'Women\'s Accessories','','filtered_html',1),(48,3,'Belts','','filtered_html',0),(49,3,'Scarves','','filtered_html',1),(50,3,'Men\'s Watches','','filtered_html',2),(51,3,'Business','','filtered_html',0),(52,3,'Sports','','filtered_html',1),(53,3,'Women\'s Jewellery','','filtered_html',0),(54,3,'Babies','','filtered_html',2),(55,3,'Toys','','filtered_html',0),(56,3,'Kids','','filtered_html',1),(57,3,'Health & Safety','','filtered_html',0),(58,3,'Educational Toys','','filtered_html',0),(59,3,'Books & Stationery','','filtered_html',0),(60,3,'TV & Video','','filtered_html',0),(61,3,'Televisions','','filtered_html',0),(62,3,'Audio','','filtered_html',1),(63,3,'Home Audio','','filtered_html',0),(64,3,'Gadgets','','filtered_html',2),(65,3,'Bags & Backpacks','','filtered_html',0),(66,3,'Laptop Bags & Cases','','filtered_html',1),(67,3,'Shoe Bags','','filtered_html',1),(68,3,'Makeup','','filtered_html',0),(69,3,'Face','','filtered_html',1),(70,3,'Eye Care','','filtered_html',1),(71,3,'Face Care','','filtered_html',0),(72,3,'Health & Beauty Tools','','filtered_html',2),(73,3,'Food Supplements','','filtered_html',3),(74,4,'Aeroline','','filtered_html',0),(75,4,'Local Lion','','filtered_html',0),(76,4,'Terminus','','filtered_html',0),(77,3,'Backpacks','','filtered_html',0),(78,4,'Targus','','filtered_html',0),(79,4,'Tarantula','','filtered_html',0),(80,4,'Wellhouse','','filtered_html',0),(81,4,'Diniwell','','filtered_html',0),(82,4,'OEM','','filtered_html',0),(83,4,'Cameleon','','filtered_html',0),(84,4,'SK II','','filtered_html',0),(85,4,'Skin Blossom','','filtered_html',0),(86,4,'Mejikaliner','','filtered_html',0),(87,4,'Hairscape','','filtered_html',0),(88,4,'Lenovo','','filtered_html',0),(89,4,'Spigen','','filtered_html',0),(90,4,'Others','','filtered_html',0),(91,4,'Sony','','filtered_html',0),(92,4,'MuWo Trendz','','filtered_html',0),(93,4,'Luccacal','','filtered_html',0),(94,4,'Dandelion','','filtered_html',0),(95,4,'Fur Nyce','','filtered_html',0),(96,4,'Rolex','','filtered_html',0),(97,4,'Invicta','','filtered_html',0),(98,4,'Casio','','filtered_html',0),(99,4,'Suunto','','filtered_html',0),(100,4,'TP Link','','filtered_html',0),(101,4,'Epson','','filtered_html',0),(102,4,'Canon','','filtered_html',0),(103,4,'Nikon','','filtered_html',0),(104,6,'Black','','filtered_html',0),(105,6,'White','','filtered_html',0),(106,6,'Blue','','filtered_html',0),(107,6,'Red','','filtered_html',0),(108,6,'Orange','','filtered_html',0),(109,6,'Pink','','filtered_html',0),(110,6,'Green','','filtered_html',0),(111,4,'Cokin','','filtered_html',0),(112,4,'D-Link','','filtered_html',0),(113,4,'ScanTrack','','filtered_html',0),(114,4,'Trek','','filtered_html',0),(115,4,'CT Toys','','filtered_html',0),(116,4,'Boogie','','filtered_html',0),(117,4,'Chicco','','filtered_html',0),(118,4,'Kinohimitsu','','filtered_html',0),(119,4,'TKO Nutrition','','filtered_html',0);
/*!40000 ALTER TABLE `taxonomy_term_data` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `taxonomy_term_hierarchy`
--

DROP TABLE IF EXISTS `taxonomy_term_hierarchy`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxonomy_term_hierarchy` (
  `tid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: The taxonomy_term_data.tid of the term.',
  `parent` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: The taxonomy_term_data.tid of the term’s parent. 0 indicates no parent.',
  PRIMARY KEY (`tid`,`parent`),
  KEY `parent` (`parent`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores the hierarchical relationship between terms.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxonomy_term_hierarchy`
--

LOCK TABLES `taxonomy_term_hierarchy` WRITE;
/*!40000 ALTER TABLE `taxonomy_term_hierarchy` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `taxonomy_term_hierarchy` VALUES (1,0),(2,0),(3,0),(4,0),(5,0),(6,0),(7,0),(8,0),(9,0),(10,0),(11,0),(12,0),(13,0),(14,0),(15,0),(16,0),(74,0),(75,0),(76,0),(78,0),(79,0),(80,0),(81,0),(82,0),(83,0),(84,0),(85,0),(86,0),(87,0),(88,0),(89,0),(90,0),(91,0),(92,0),(93,0),(94,0),(95,0),(96,0),(97,0),(98,0),(99,0),(100,0),(101,0),(102,0),(103,0),(104,0),(105,0),(106,0),(107,0),(108,0),(109,0),(110,0),(111,0),(112,0),(113,0),(114,0),(115,0),(116,0),(117,0),(118,0),(119,0),(65,2),(67,2),(68,3),(69,3),(72,3),(73,3),(27,4),(30,4),(33,4),(36,4),(47,5),(50,5),(53,5),(60,6),(62,6),(64,6),(40,7),(41,7),(42,7),(43,7),(17,8),(18,8),(21,8),(24,8),(54,9),(55,9),(56,9),(22,21),(23,21),(25,24),(26,24),(28,27),(29,27),(31,30),(32,30),(34,33),(35,33),(38,36),(39,36),(44,43),(45,43),(48,47),(49,47),(51,50),(52,50),(57,54),(58,55),(59,56),(61,60),(63,62),(66,65),(77,65),(70,69),(71,69);
/*!40000 ALTER TABLE `taxonomy_term_hierarchy` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `taxonomy_vocabulary`
--

DROP TABLE IF EXISTS `taxonomy_vocabulary`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxonomy_vocabulary` (
  `vid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique vocabulary ID.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'Name of the vocabulary.',
  `machine_name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The vocabulary machine name.',
  `description` longtext COMMENT 'Description of the vocabulary.',
  `hierarchy` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'The type of hierarchy allowed within the vocabulary. (0 = disabled, 1 = single, 2 = multiple)',
  `module` varchar(255) NOT NULL DEFAULT '' COMMENT 'The module which created the vocabulary.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The weight of this vocabulary in relation to other vocabularies.',
  PRIMARY KEY (`vid`),
  UNIQUE KEY `machine_name` (`machine_name`),
  KEY `list` (`weight`,`name`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8 COMMENT='Stores vocabulary information.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxonomy_vocabulary`
--

LOCK TABLES `taxonomy_vocabulary` WRITE;
/*!40000 ALTER TABLE `taxonomy_vocabulary` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `taxonomy_vocabulary` VALUES (1,'Tags','tags','Use tags to group articles on similar topics into categories.',0,'taxonomy',0),(2,'Newsletter','newsletter','Simplenews newsletter categories.',0,'simplenews',0),(3,'Categories','categories','',0,'taxonomy',0),(4,'Brands','brands','',0,'taxonomy',0),(5,'Availability','availability','',0,'taxonomy',0),(6,'Color','color','',0,'taxonomy',0);
/*!40000 ALTER TABLE `taxonomy_vocabulary` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `tb_megamenus`
--

DROP TABLE IF EXISTS `tb_megamenus`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tb_megamenus` (
  `menu_name` varchar(255) NOT NULL,
  `block_config` text,
  `menu_config` text,
  `language` varchar(12) NOT NULL DEFAULT '',
  PRIMARY KEY (`menu_name`,`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tb_megamenus`
--

LOCK TABLES `tb_megamenus` WRITE;
/*!40000 ALTER TABLE `tb_megamenus` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `tb_megamenus` VALUES ('main-menu','{\"animation\":\"none\",\"duration\":400,\"delay\":200,\"style\":\"\",\"auto-arrow\":\"1\",\"always-show-submenu\":\"1\"}','{\"611\":{\"rows_content\":[[{\"col_content\":[{\"mlid\":\"1064\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"6\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}},{\"col_content\":[{\"mlid\":\"1071\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"6\",\"class\":\"\",\"hidewcol\":\"\",\"showblocktitle\":\"1\"}}],[{\"col_content\":[{\"block_key\":\"block--18\",\"type\":\"block\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"\",\"class\":\"\",\"hidewcol\":\"\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"571\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"612\":{\"rows_content\":[[{\"col_content\":[{\"mlid\":\"1112\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"6\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}},{\"col_content\":[{\"mlid\":\"1114\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"6\",\"class\":\"\",\"hidewcol\":\"\",\"showblocktitle\":\"1\"}}],[{\"col_content\":[{\"block_key\":\"block--13\",\"type\":\"block\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"\",\"class\":\"\",\"hidewcol\":\"\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"571\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"613\":{\"rows_content\":[[{\"col_content\":[{\"mlid\":\"1087\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"6\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}},{\"col_content\":[{\"mlid\":\"1090\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"6\",\"class\":\"\",\"hidewcol\":\"\",\"showblocktitle\":\"1\"}}],[{\"col_content\":[{\"block_key\":\"block--16\",\"type\":\"block\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"\",\"class\":\"\",\"hidewcol\":\"\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"571\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"614\":{\"rows_content\":[[{\"col_content\":[{\"mlid\":\"1107\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"6\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}},{\"col_content\":[{\"mlid\":\"1111\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"6\",\"class\":\"\",\"hidewcol\":\"\",\"showblocktitle\":\"1\"}}],[{\"col_content\":[{\"block_key\":\"block--19\",\"type\":\"block\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"\",\"class\":\"\",\"hidewcol\":\"\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"571\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"615\":{\"rows_content\":[[{\"col_content\":[{\"mlid\":\"1115\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"6\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}},{\"col_content\":[{\"mlid\":\"1119\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"6\",\"class\":\"\",\"hidewcol\":\"\",\"showblocktitle\":\"1\"}}],[{\"col_content\":[{\"block_key\":\"block--15\",\"type\":\"block\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"\",\"class\":\"\",\"hidewcol\":\"\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"571\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"616\":{\"rows_content\":[[{\"col_content\":[{\"mlid\":\"1074\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"6\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}},{\"col_content\":[{\"mlid\":\"1080\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"6\",\"class\":\"\",\"hidewcol\":\"\",\"showblocktitle\":\"1\"}}],[{\"col_content\":[{\"block_key\":\"block--14\",\"type\":\"block\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"\",\"class\":\"\",\"hidewcol\":\"\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"571\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"617\":{\"rows_content\":[[{\"col_content\":[{\"mlid\":\"1102\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"6\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}},{\"col_content\":[{\"mlid\":\"1101\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"6\",\"class\":\"\",\"hidewcol\":\"\",\"showblocktitle\":\"1\"}}],[{\"col_content\":[{\"block_key\":\"block--17\",\"type\":\"block\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"\",\"class\":\"\",\"hidewcol\":\"\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"571\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"618\":{\"rows_content\":[[{\"col_content\":[{\"mlid\":\"1100\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"6\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}},{\"col_content\":[{\"mlid\":\"1097\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"6\",\"class\":\"\",\"hidewcol\":\"\",\"showblocktitle\":\"1\"}}],[{\"col_content\":[{\"block_key\":\"block--12\",\"type\":\"block\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"\",\"class\":\"\",\"hidewcol\":\"\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"571\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"644\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1112\":{\"rows_content\":[[{\"col_content\":[{\"mlid\":\"1121\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"12\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1121\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1113\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1114\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1115\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1116\":{\"rows_content\":[[{\"col_content\":[{\"mlid\":\"1118\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"12\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1118\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1117\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1119\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1120\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1074\":{\"rows_content\":[[{\"col_content\":[{\"mlid\":\"1075\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"12\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1075\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1076\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1077\":{\"rows_content\":[[{\"col_content\":[{\"mlid\":\"1078\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"12\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1078\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1079\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1080\":{\"rows_content\":[[{\"col_content\":[{\"mlid\":\"1081\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"12\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1081\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1082\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1083\":{\"rows_content\":[[{\"col_content\":[{\"mlid\":\"1086\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"12\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1086\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1085\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1100\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1094\":{\"rows_content\":[[{\"col_content\":[{\"mlid\":\"1095\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"12\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1095\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1096\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1097\":{\"rows_content\":[[{\"col_content\":[{\"mlid\":\"1098\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"12\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1098\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1099\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1107\":{\"rows_content\":[[{\"col_content\":[{\"mlid\":\"1108\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"12\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1108\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1109\":{\"rows_content\":[[{\"col_content\":[{\"mlid\":\"1110\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"12\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1110\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1111\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1087\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1088\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1090\":{\"rows_content\":[[{\"col_content\":[{\"mlid\":\"1091\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"12\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1091\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1092\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1089\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1064\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1065\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1071\":{\"rows_content\":[[{\"col_content\":[{\"mlid\":\"1073\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"12\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1073\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1072\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1068\":{\"rows_content\":[[{\"col_content\":[{\"mlid\":\"1069\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"12\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1069\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1070\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1102\":{\"rows_content\":[[{\"col_content\":[{\"mlid\":\"1105\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"12\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1105\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1103\":{\"rows_content\":[[{\"col_content\":[{\"mlid\":\"1106\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"12\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1106\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1101\":{\"rows_content\":[[{\"col_content\":[{\"mlid\":\"1104\",\"type\":\"menu_item\",\"tb_item_config\":{}}],\"col_config\":{\"width\":\"12\",\"class\":\"\",\"hidewcol\":\"0\",\"showblocktitle\":\"1\"}}]],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}},\"1104\":{\"rows_content\":[],\"submenu_config\":{\"width\":\"\",\"class\":\"\",\"group\":\"0\"},\"item_config\":{\"class\":\"\",\"xicon\":\"\",\"caption\":\"\",\"alignsub\":\"\",\"group\":\"0\",\"hidewcol\":\"0\",\"hidesub\":\"0\"}}}','en');
/*!40000 ALTER TABLE `tb_megamenus` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `url_alias`
--

DROP TABLE IF EXISTS `url_alias`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `url_alias` (
  `pid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'A unique path alias identifier.',
  `source` varchar(255) NOT NULL DEFAULT '' COMMENT 'The Drupal path this alias is for; e.g. node/12.',
  `alias` varchar(255) NOT NULL DEFAULT '' COMMENT 'The alias for this path; e.g. title-of-the-story.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'The language this alias is for; if ’und’, the alias will be used for unknown languages. Each Drupal path can have an alias for each supported language.',
  PRIMARY KEY (`pid`),
  KEY `alias_language_pid` (`alias`,`language`,`pid`),
  KEY `source_language_pid` (`source`,`language`,`pid`)
) ENGINE=InnoDB AUTO_INCREMENT=307 DEFAULT CHARSET=utf8 COMMENT='A list of URL aliases for Drupal paths; a user may visit...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `url_alias`
--

LOCK TABLES `url_alias` WRITE;
/*!40000 ALTER TABLE `url_alias` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `url_alias` VALUES (39,'node/7','blueant-pump-hd-wireless-bluetooth-waterproof-headphones','und'),(40,'taxonomy/term/1','newsletter/azastore-newsletter','und'),(41,'taxonomy/term/2','categories/clothes-shoes-bags','und'),(42,'taxonomy/term/3','categories/health-beauty','und'),(43,'taxonomy/term/4','categories/mobiles-tablets','und'),(44,'taxonomy/term/5','categories/watches-accessories','und'),(45,'taxonomy/term/6','categories/consumer-electronics','und'),(46,'taxonomy/term/7','categories/computers-laptops','und'),(47,'taxonomy/term/8','categories/cameras','und'),(48,'taxonomy/term/9','categories/toys-kids-babies','und'),(49,'taxonomy/term/10','brands/apple','und'),(50,'taxonomy/term/11','brands/samsung','und'),(51,'taxonomy/term/12','brands/dell','und'),(52,'taxonomy/term/13','brands/asus','und'),(53,'taxonomy/term/14','brands/nokia','und'),(54,'user/1','users/admin','und'),(55,'node/8','banner-2','und'),(57,'user/7','users/amazon','und'),(58,'user/8','users/alibaba','und'),(61,'taxonomy/term/15','availability/stock','und'),(62,'taxonomy/term/16','availability/out-stock','und'),(63,'node/11','feature-firetv','und'),(64,'node/12','driver-smarter','und'),(65,'node/13','living-room','und'),(66,'node/14','get-20-instantly','und'),(68,'node/16','payment-pricing','und'),(69,'node/17','how-buy','und'),(70,'node/18','shipping-pickup','und'),(71,'node/19','returns-refunds','und'),(72,'node/20','order-status','und'),(73,'node/21','about-marketplace','und'),(74,'node/22','afﬁliate-program','und'),(75,'node/23','terms-conditions','und'),(76,'node/24','privacy-policy','und'),(78,'node/26','sell-marketplace','und'),(79,'node/27','about-us','und'),(80,'node/28','contact-us','und'),(81,'node/29','how-can-we-help','und'),(82,'taxonomy/term/17','categories/point-shoot-cameras','und'),(83,'taxonomy/term/18','categories/dslrslr-cameras','und'),(86,'taxonomy/term/21','categories/other-cameras','und'),(87,'taxonomy/term/22','categories/ip-cameras','und'),(88,'taxonomy/term/23','categories/car-cameras','und'),(89,'taxonomy/term/24','categories/camera-accessories','und'),(90,'taxonomy/term/25','categories/lenses','und'),(91,'taxonomy/term/26','categories/filters','und'),(92,'taxonomy/term/27','categories/mobiles','und'),(93,'taxonomy/term/28','categories/smartphones','und'),(94,'taxonomy/term/29','categories/basic-phones','und'),(95,'taxonomy/term/30','categories/tablets','und'),(96,'taxonomy/term/31','categories/call-facility','und'),(97,'taxonomy/term/32','categories/without-call-facility','und'),(98,'taxonomy/term/33','categories/mobile-accessories','und'),(99,'taxonomy/term/34','categories/cases-covers','und'),(100,'taxonomy/term/35','categories/car-accessories','und'),(101,'taxonomy/term/36','categories/tablet-accessories','und'),(103,'taxonomy/term/38','categories/batteries-chargers','und'),(104,'taxonomy/term/39','categories/headphones','und'),(105,'taxonomy/term/40','categories/laptops','und'),(106,'taxonomy/term/41','categories/desktops','und'),(107,'taxonomy/term/42','categories/scanners','und'),(108,'taxonomy/term/43','categories/network-components','und'),(109,'taxonomy/term/44','categories/switches','und'),(110,'taxonomy/term/45','categories/routers','und'),(112,'taxonomy/term/47','categories/womens-accessories','und'),(113,'taxonomy/term/48','categories/belts','und'),(114,'taxonomy/term/49','categories/scarves','und'),(115,'taxonomy/term/50','categories/mens-watches','und'),(116,'taxonomy/term/51','categories/business','und'),(117,'taxonomy/term/52','categories/sports','und'),(118,'taxonomy/term/53','categories/womens-jewellery','und'),(119,'taxonomy/term/54','categories/babies','und'),(120,'taxonomy/term/55','categories/toys','und'),(121,'taxonomy/term/56','categories/kids','und'),(122,'taxonomy/term/57','categories/health-safety','und'),(123,'taxonomy/term/58','categories/educational-toys','und'),(124,'taxonomy/term/59','categories/books-stationery','und'),(125,'taxonomy/term/60','categories/tv-video','und'),(126,'taxonomy/term/61','categories/televisions','und'),(127,'taxonomy/term/62','categories/audio','und'),(128,'taxonomy/term/63','categories/home-audio','und'),(129,'taxonomy/term/64','categories/gadgets','und'),(130,'taxonomy/term/65','categories/bags-backpacks','und'),(131,'taxonomy/term/66','categories/laptop-bags-cases','und'),(132,'taxonomy/term/67','categories/shoe-bags','und'),(133,'taxonomy/term/68','categories/makeup','und'),(134,'taxonomy/term/69','categories/face','und'),(135,'taxonomy/term/70','categories/eye-care','und'),(136,'taxonomy/term/71','categories/face-care','und'),(137,'taxonomy/term/72','categories/health-beauty-tools','und'),(138,'taxonomy/term/73','categories/food-supplements','und'),(139,'node/30','product/aeroline-casual-hiking-backpack-dark-blue-30','und'),(140,'taxonomy/term/74','brands/aeroline','und'),(141,'taxonomy/term/75','brands/local-lion','und'),(142,'node/31','product/local-lion-water-resistant-hiking-backpack-bag-28l-blue-31','und'),(143,'taxonomy/term/76','brands/terminus','und'),(144,'node/32','product/terminus-t02-297lap-01-laptop-backpack-plus-32','und'),(145,'taxonomy/term/77','categories/backpacks','und'),(146,'taxonomy/term/78','brands/targus','und'),(147,'node/33','product/targus-tsb166ap-156in-revolution-backpack-xl-33','und'),(148,'taxonomy/term/79','brands/tarantula','und'),(149,'node/34','product/tarantula-shoe-bag-bos04-088shb-03-red-34','und'),(150,'taxonomy/term/80','brands/wellhouse','und'),(151,'taxonomy/term/81','brands/diniwell','und'),(152,'node/35','product/diniwell-water-resistant-travel-shoes-bag-pouch-organizer-bag-ver-2-orange-35','und'),(153,'taxonomy/term/82','brands/oem','und'),(154,'node/36','product/24-piece-makeup-brush-set-36','und'),(155,'taxonomy/term/83','brands/cameleon','und'),(156,'node/37','product/cameleon-makeup-kit-396-37','und'),(157,'node/38','product/4-1-function-power-perfect-pore-facial-face-care-blackhead-cleaner-38','und'),(158,'taxonomy/term/84','brands/sk-ii','und'),(159,'node/39','product/sk-ii-5-piece-skincare-travel-set-5pcs-travel-packs-skii-sk2-39','und'),(160,'node/40','product/organic-eye-cream-15ml-40','und'),(161,'taxonomy/term/85','brands/skin-blossom','und'),(162,'taxonomy/term/86','brands/mejikaliner','und'),(163,'node/41','product/mejikaliner-quick-eyelid-essence-stick-glue-night-use-41','und'),(164,'taxonomy/term/87','brands/hairscape','und'),(165,'node/42','product/hairscape-1800w-aus-5000-professional-hair-dryer-42','und'),(166,'node/43','product/tonific-slimming-massager-43','und'),(167,'node/44','product/apple-iphone-6-16gb-gold-44','und'),(168,'node/45','product/samsung-n910-note-4-lte-32gb-white-45','und'),(169,'node/46','product/asus-transformer-p1801-b041k-aio-184-pc-dekstop-asus-rt-n56u-wireless-n-n600-dual-band','und'),(170,'taxonomy/term/88','brands/lenovo','und'),(171,'node/47','product/lenovo-a316-47','und'),(172,'node/2','product/nike-mens-diamond-arm-band-iphone-55s-2','und'),(173,'node/48','product/nokia-asha-206-dual-sim-black-48','und'),(174,'node/49','product/apple-ipad-3-wi-fi4g-md368-64gb-black-49','und'),(175,'node/1','product/beats-dr-dre-studio-wireless-ear-headphones-1','und'),(176,'node/50','product/asus-memopad-7-tablet-50','und'),(177,'node/51','product/lenovo-tablet-miix-2-59399848-8-silver-51','und'),(178,'node/52','product/apple-ipad-air-16gb-wifi-space-grey-md785zpa-52','und'),(179,'taxonomy/term/89','brands/spigen','und'),(180,'node/53','product/galaxy-note-4-spigen-case-neo-hybrid-metal-gold-53','und'),(181,'node/54','product/genuine-samsung-galaxy-note-4-s-view-classic-cover-case-black-54','und'),(182,'node/55','product/samsung-galaxy-tab-70-plus-vehicle-dock-car-charger-55','und'),(183,'taxonomy/term/90','brands/others','und'),(184,'node/56','product/angel-universal-mobile-phone-car-phone-holder-360-degree-item-code-p338-56','und'),(185,'node/57','product/original-apple-earpod-earphone-remote-mic-iphone-ipad-ipod-57','und'),(186,'taxonomy/term/91','brands/sony','und'),(187,'node/58','product/sony-stereo-bluetooth-headset-sbh20-black-58','und'),(188,'node/59','product/top-mi-10400mah-powerbank-black-59','und'),(189,'node/60','product/universal-dual-port-power-bank-20000mah-black-60','und'),(190,'taxonomy/term/92','brands/muwo-trendz','und'),(191,'node/61','product/muwo-trendz-swarovski-element-white-gold-plated-everlasting-love-set-61','und'),(192,'taxonomy/term/93','brands/luccacal','und'),(193,'node/62','product/luccacal-multi-color-tribal-necklace-62','und'),(194,'taxonomy/term/94','brands/dandelion','und'),(195,'node/63','product/dandelion-women-braided-belt-white-63','und'),(196,'node/64','product/dandelion-cross-stitch-belt-orange-64','und'),(197,'taxonomy/term/95','brands/fur-nyce','und'),(198,'node/65','product/fur-nyce-big-square-classic-chain-pattern-print-scarf-65','und'),(199,'node/66','product/fur-nyce-fashion-zebra-pattern-print-scarf-white-66','und'),(200,'taxonomy/term/96','brands/rolex','und'),(201,'taxonomy/term/97','brands/invicta','und'),(202,'node/67','product/invicta-pro-diver-men-black-stainless-steel-strap-watch-15422-67','und'),(203,'node/68','product/rolex-submariner-black-dial-stainless-steel-automatic-mens-watch-114060-68','und'),(204,'taxonomy/term/98','brands/casio','und'),(205,'taxonomy/term/99','brands/suunto','und'),(206,'node/69','product/suunto-vector-black-suss010600610-mountain-outdoor-watch-69','und'),(207,'node/70','product/skmei-0955-30m-waterproof-analogue-digital-dual-time-mens-sports-watch-black-green-70','und'),(208,'node/71','product/samsung-4-full-hd-led-tv-ua40h5008arxxm-series-5-71','und'),(209,'node/72','product/sony-48-full-hd-led-tv-bravia-model-kdl-48r470b-72','und'),(210,'node/73','product/sony-bdv-n9200w-91-cinema-studio-3d-blu-ray-disc-home-theatre-system-73','und'),(211,'node/74','product/samsung-ht-e350k-dvd-home-theater-system-74','und'),(212,'node/75','product/l12s-oled-smart-watch-bluetooth-30-bracelet-wrist-design-ios-android-iphone-samsung-smart','und'),(213,'node/76','product/ori-apple-tv-76','und'),(214,'node/77','product/dell-alienware-x51-77822g-gaming-desktop-77','und'),(215,'node/78','product/3-port-hdmi-switch-remote-control-78','und'),(216,'node/79','product/dell-powerconnect-5524p-24-gbe-port-managed-l2-switch-poe-support-10gbe-and-stacking-capable','und'),(217,'taxonomy/term/100','brands/tp-link','und'),(218,'node/80','product/tp-link-m5250-n900-3g-mobile-wifi-black-80','und'),(219,'node/81','product/tp-link-n750-wireless-dual-band-gigabit-router-tl-wdr4300-black-81','und'),(220,'taxonomy/term/101','brands/epson','und'),(221,'taxonomy/term/102','brands/canon','und'),(222,'node/82','product/canon-lide-210-scanner-82','und'),(223,'node/83','product/epson-perfection-v33-scanner-83','und'),(224,'node/84','product/casio-exilim-ex-zr1500-digital-camera-pink-84','und'),(225,'node/85','product/canon-powershot-sx60-hs-161mp-black-8gb-case-85','und'),(226,'taxonomy/term/103','brands/nikon','und'),(227,'node/86','product/canon-eos-600d-18mp-18-55mm-lens-86','und'),(228,'taxonomy/term/104','color/black','und'),(229,'taxonomy/term/105','color/white','und'),(230,'taxonomy/term/106','color/blue','und'),(231,'taxonomy/term/107','color/red','und'),(232,'taxonomy/term/108','color/orange','und'),(233,'node/87','face-care','und'),(234,'taxonomy/term/109','color/pink','und'),(235,'user/15','users/1','und'),(236,'user/16','users/weebpal','und'),(237,'taxonomy/term/110','color/green','und'),(238,'node/88','product/samsung-smart-camera-nx-mini-205mp-green-9mm-lens-16-gb-memory-card-88','und'),(239,'node/89','product/nikon-af-s-50mm-lens-f18g-89','und'),(240,'node/90','product/canon-ef-s-lens-18-200mm-f35-56-90','und'),(241,'node/91','product/cokin-u961a-z-pro-grad-kit-z-filter-holder-z121l-z123l-z125l-91','und'),(242,'taxonomy/term/111','brands/cokin','und'),(243,'node/92','product/d-link-dcs-5222l-cloudcam-hd-wireless-n-pantilt-network-camera-92','und'),(244,'taxonomy/term/112','brands/d-link','und'),(245,'taxonomy/term/113','brands/scantrack','und'),(246,'node/93','product/cctv-850tvl-ir-dome-cctv-camera-93','und'),(247,'node/94','product/trek-ai-ball-portable-wi-fi-remote-camera-cradle-adaptors-yellow-94','und'),(248,'taxonomy/term/114','brands/trek','und'),(249,'taxonomy/term/115','brands/ct-toys','und'),(250,'node/95','product/mini-quran-kids-yellow-95','und'),(251,'taxonomy/term/116','brands/boogie','und'),(252,'node/96','product/boogie-board-105-inch-lcd-writing-tablet-pink-96','und'),(253,'taxonomy/term/117','brands/chicco','und'),(254,'node/97','product/transporter-carry-cot-97','und'),(255,'node/98','educational-toys','und'),(256,'node/99','books-stationery','und'),(257,'user/17','users/test','und'),(258,'node/100','health-safety','und'),(259,'node/101','backpacks','und'),(260,'node/102','shoe-bags','und'),(261,'node/103','makeup','und'),(262,'node/104','eye-care','und'),(263,'node/105','health-beauty-tools','und'),(264,'node/106','food-supplements','und'),(265,'node/107','basic-phones','und'),(266,'node/108','car-accessories','und'),(267,'node/109','cases-covers','und'),(268,'node/110','smartphones','und'),(269,'node/111','call-facility','und'),(270,'node/112','without-call-facility','und'),(271,'node/113','headphones','und'),(272,'node/114','batteries-chargers','und'),(273,'node/115','womens-jewellery','und'),(274,'node/116','belts','und'),(275,'node/117','scarves','und'),(276,'node/118','business','und'),(277,'node/119','sports','und'),(278,'node/120','televisions','und'),(279,'node/121','home-audio','und'),(280,'node/3','product/withings-pulse-o2-activity-tracker-3','und'),(281,'node/122','gadgets','und'),(282,'node/123','laptops','und'),(283,'node/124','desktop','und'),(284,'node/125','switches','und'),(285,'node/126','routers','und'),(286,'node/127','scanners','und'),(287,'node/128','point-shoot-cameras','und'),(288,'node/129','dslrslr-cameras','und'),(289,'node/130','filters','und'),(290,'node/131','lenses','und'),(291,'node/132','ip-cameras','und'),(292,'node/133','car-cameras','und'),(293,'node/134','laptop-bags-cases','und'),(294,'node/135','asus','und'),(295,'node/136','rolex','und'),(296,'node/137','canon','und'),(297,'taxonomy/term/118','brands/kinohimitsu','und'),(298,'node/10','product/apple-macbook-pro-me864-zpa-core-i5-133in-4gb-10','und'),(299,'node/9','product/apple-macbook-air-md760b-core-i5-133-4gb-9','und'),(300,'node/138','product/kinohimitsu-jpan-bb-drink-50ml-x-10-138','und'),(301,'taxonomy/term/119','brands/tko-nutrition','und'),(302,'node/139','product/tko-fat-burner-mega-139','und'),(303,'node/140','filters-0','und'),(304,'node/141','404-page','und'),(305,'node/142','black-friday','und'),(306,'node/143','get-20-instantly-0','en');
/*!40000 ALTER TABLE `url_alias` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `users`
--

DROP TABLE IF EXISTS `users`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `users` (
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: Unique user ID.',
  `name` varchar(60) NOT NULL DEFAULT '' COMMENT 'Unique user name.',
  `pass` varchar(128) NOT NULL DEFAULT '' COMMENT 'User’s password (hashed).',
  `mail` varchar(254) DEFAULT '' COMMENT 'User’s e-mail address.',
  `theme` varchar(255) NOT NULL DEFAULT '' COMMENT 'User’s default theme.',
  `signature` varchar(255) NOT NULL DEFAULT '' COMMENT 'User’s signature.',
  `signature_format` varchar(255) DEFAULT NULL COMMENT 'The filter_format.format of the signature.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp for when user was created.',
  `access` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp for previous time user accessed the site.',
  `login` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp for user’s last login.',
  `status` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Whether the user is active(1) or blocked(0).',
  `timezone` varchar(32) DEFAULT NULL COMMENT 'User’s time zone.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'User’s default language.',
  `picture` int(11) NOT NULL DEFAULT '0' COMMENT 'Foreign key: file_managed.fid of user’s picture.',
  `init` varchar(254) DEFAULT '' COMMENT 'E-mail address used for initial account creation.',
  `data` longblob COMMENT 'A serialized array of name value pairs that are related to the user. Any form values posted during user edit are stored and are loaded into the $user object during user_load(). Use of this field is discouraged and it will likely disappear in a future...',
  PRIMARY KEY (`uid`),
  UNIQUE KEY `name` (`name`),
  KEY `access` (`access`),
  KEY `created` (`created`),
  KEY `mail` (`mail`),
  KEY `picture` (`picture`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores user data.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `users`
--

LOCK TABLES `users` WRITE;
/*!40000 ALTER TABLE `users` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `users` VALUES (0,'','','','','',NULL,0,0,0,0,NULL,'',0,'',NULL),(1,'admin','$S$DpISI8KTOVPTYv94rYwViyW.98wbGxmzMaheK77gqJ9.JeGQpSbU','you@yourdomain.com','','',NULL,1412842259,1500361131,1500347121,1,'Asia/Ho_Chi_Minh','',0,'you@yourdomain.com','b:0;'),(7,'amazon','$S$DNh8XXWpbXJKDPEqAqCTqvAxLQ1kPg.61MWdndiQUA4pnyGoVH0g','amazon@mail.com','','','filtered_html',1416299280,0,0,1,'Asia/Bangkok','',0,'amazon@mail.com','a:5:{s:16:\"ckeditor_default\";s:1:\"t\";s:20:\"ckeditor_show_toggle\";s:1:\"t\";s:14:\"ckeditor_width\";s:4:\"100%\";s:13:\"ckeditor_lang\";s:2:\"en\";s:18:\"ckeditor_auto_lang\";s:1:\"t\";}'),(8,'alibaba','$S$DfrRpQM1D7iavZ0WxkOzkLJSV/P330zCNUoHxNUYxsOSJejpbDgz','alibaba@mail.com','','','filtered_html',1416299349,0,0,1,'Asia/Bangkok','',0,'alibaba@mail.com','a:5:{s:16:\"ckeditor_default\";s:1:\"t\";s:20:\"ckeditor_show_toggle\";s:1:\"t\";s:14:\"ckeditor_width\";s:4:\"100%\";s:13:\"ckeditor_lang\";s:2:\"en\";s:18:\"ckeditor_auto_lang\";s:1:\"t\";}'),(15,'1','$S$D/8mOOszb/HdOmLnssviG1I.83vQTypCqZK6n1pPRwq8ttkytftj','1@abc.com','','','filtered_html',1418032873,1418093628,1418032895,1,'Asia/Bangkok','',0,'1@abc.com','a:5:{s:16:\"ckeditor_default\";s:1:\"t\";s:20:\"ckeditor_show_toggle\";s:1:\"t\";s:14:\"ckeditor_width\";s:4:\"100%\";s:13:\"ckeditor_lang\";s:2:\"en\";s:18:\"ckeditor_auto_lang\";s:1:\"t\";}'),(16,'weebpal','$S$DXL3GggF8pvfNU/s02NVqHwcNMsdvAjvdKqTXTAh2swS3b.nfXSL','weebpal@mail.com','','','filtered_html',1418356739,1420442286,1420441457,1,'Asia/Bangkok','',0,'weebpal@mail.com','a:5:{s:16:\"ckeditor_default\";s:1:\"t\";s:20:\"ckeditor_show_toggle\";s:1:\"t\";s:14:\"ckeditor_width\";s:4:\"100%\";s:13:\"ckeditor_lang\";s:2:\"en\";s:18:\"ckeditor_auto_lang\";s:1:\"t\";}'),(17,'test','$S$Di8RO5./kiEm.2z/BBaJbEwHXOCdzAonzKqLrek2zMCeR9DjwLZB','test@mail.vn','','','filtered_html',1418375370,1418375395,1418375395,1,'Asia/Bangkok','',0,'test@mail.vn','a:5:{s:16:\"ckeditor_default\";s:1:\"t\";s:20:\"ckeditor_show_toggle\";s:1:\"t\";s:14:\"ckeditor_width\";s:4:\"100%\";s:13:\"ckeditor_lang\";s:2:\"en\";s:18:\"ckeditor_auto_lang\";s:1:\"t\";}');
/*!40000 ALTER TABLE `users` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `users_roles`
--

DROP TABLE IF EXISTS `users_roles`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `users_roles` (
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: users.uid for user.',
  `rid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: role.rid for role.',
  PRIMARY KEY (`uid`,`rid`),
  KEY `rid` (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Maps users to roles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `users_roles`
--

LOCK TABLES `users_roles` WRITE;
/*!40000 ALTER TABLE `users_roles` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `users_roles` VALUES (1,3),(7,4),(8,4),(16,4);
/*!40000 ALTER TABLE `users_roles` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `variable`
--

DROP TABLE IF EXISTS `variable`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `variable` (
  `name` varchar(128) NOT NULL DEFAULT '' COMMENT 'The name of the variable.',
  `value` longblob NOT NULL COMMENT 'The value of the variable.',
  PRIMARY KEY (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Named variable/value pairs created by Drupal core or any...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `variable`
--

LOCK TABLES `variable` WRITE;
/*!40000 ALTER TABLE `variable` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `variable` VALUES ('additional_settings__active_tab_banner','s:20:\"edit-weight-settings\";'),('additional_settings__active_tab_product','s:15:\"edit-submission\";'),('additional_settings__active_tab_webform','s:12:\"edit-display\";'),('admin_theme','s:10:\"we_backend\";'),('cache_class_cache_ctools_css','s:14:\"CToolsCssCache\";'),('chosen_disable_search','i:1;'),('chosen_disable_search_threshold','s:1:\"0\";'),('chosen_jquery_selector','s:151:\"select#edit-field-category, select#edit-submitted-country, .container select.country, select[name=\"product_id\"], select#edit-field-category-parents-all\";'),('chosen_minimum_multiple','s:2:\"10\";'),('chosen_minimum_single','s:1:\"0\";'),('chosen_minimum_width','s:3:\"200\";'),('chosen_no_results_text','s:16:\"No results match\";'),('chosen_placeholder_text_multiple','s:19:\"Choose some options\";'),('chosen_placeholder_text_single','s:16:\"Choose an option\";'),('chosen_search_contains','i:0;'),('chosen_use_theme','i:1;'),('clean_url','s:1:\"1\";'),('clear_all_banner','i:0;'),('clear_all_webform','i:0;'),('comment_anonymous_banner','i:0;'),('comment_anonymous_product','i:0;'),('comment_anonymous_webform','i:0;'),('comment_banner','s:1:\"1\";'),('comment_default_mode_banner','i:1;'),('comment_default_mode_product','i:1;'),('comment_default_mode_webform','i:1;'),('comment_default_per_page_banner','s:2:\"50\";'),('comment_default_per_page_product','s:2:\"50\";'),('comment_default_per_page_webform','s:2:\"50\";'),('comment_form_location_banner','i:1;'),('comment_form_location_product','i:1;'),('comment_form_location_webform','i:1;'),('comment_page','i:0;'),('comment_preview_banner','s:1:\"1\";'),('comment_preview_product','s:1:\"1\";'),('comment_preview_webform','s:1:\"1\";'),('comment_product','s:1:\"1\";'),('comment_subject_field_banner','i:1;'),('comment_subject_field_product','i:1;'),('comment_subject_field_webform','i:1;'),('comment_webform','s:1:\"0\";'),('commerce_customer_profile_billing_field','s:25:\"commerce_customer_billing\";'),('commerce_customer_profile_shipping_field','s:26:\"commerce_customer_shipping\";'),('context_block_rebuild_needed','b:1;'),('cron_key','s:43:\"nIB27vAacpuWhw1T4e2fmNBGz2hupqQvGuay0muIEZs\";'),('cron_last','i:1500360922;'),('cron_safe_threshold','s:1:\"0\";'),('css_js_query_string','s:6:\"ot9y86\";'),('ctools_last_cron','i:1500360922;'),('custom_breadcrumbs_append_bid_class','i:0;'),('custom_breadcrumbs_append_page_title','i:0;'),('custom_breadcrumbs_append_page_title_no_link','i:0;'),('custom_breadcrumbs_even_odd_class','i:0;'),('custom_breadcrumbs_exclude_list','s:20:\"admin/user/user,user\";'),('custom_breadcrumbs_force_active_trail','i:0;'),('custom_breadcrumbs_home_id','i:0;'),('custom_breadcrumbs_menu_list','a:0:{}'),('custom_breadcrumbs_none_span','i:0;'),('custom_breadcrumbs_parts_class','i:0;'),('custom_breadcrumbs_paths_allow_wildcards','i:0;'),('custom_breadcrumbs_set_global_home_breadcrumb','i:0;'),('custom_breadcrumbs_set_menu_breadcrumb','i:0;'),('custom_breadcrumbs_sort','a:2:{s:9:\"direction\";a:3:{s:4:\"name\";s:3:\"asc\";s:15:\"breadcrumb_type\";s:3:\"asc\";s:8:\"language\";s:3:\"asc\";}s:6:\"column\";s:4:\"name\";}'),('custom_breadcrumbs_taxonomy_append_breadcrumb','i:1;'),('custom_breadcrumbs_taxonomy_excluded_vocabs','a:6:{i:5;i:0;i:4;i:0;i:3;i:0;i:6;i:0;i:2;i:0;i:1;i:0;}'),('custom_breadcrumbs_taxonomy_include_nodes','s:1:\"1\";'),('custom_breadcrumbs_taxonomy_include_node_title','i:1;'),('custom_breadcrumbs_taxonomy_node_types','a:6:{s:7:\"product\";s:7:\"product\";s:7:\"article\";i:0;s:6:\"banner\";i:0;s:4:\"page\";i:0;s:10:\"simplenews\";i:0;s:7:\"webform\";i:0;}'),('custom_breadcrumbs_taxonomy_no_anon_sessions','b:0;'),('custom_breadcrumbs_taxonomy_result_nodes','i:0;'),('custom_breadcrumbs_taxonomy_session','i:0;'),('custom_breadcrumbs_taxonomy_show_current_term','i:1;'),('custom_breadcrumbs_taxonomy_show_current_term_term','i:1;'),('custom_breadcrumbs_taxonomy_show_vocabulary','i:0;'),('custom_breadcrumbs_taxonomy_uncache','b:0;'),('custom_breadcrumbs_taxonomy_use_hierarchy','i:1;'),('custom_breadcrumbs_taxonomy_views','i:0;'),('custom_breadcrumbs_type_class','i:0;'),('custom_breadcrumbs_use_exclude_list','i:0;'),('custom_breadcrumbs_use_php_in_titles','i:0;'),('custom_breadcrumb_home','s:4:\"Home\";'),('date_default_timezone','s:12:\"Asia/Bangkok\";'),('date_format_search_api_facetapi_DAY','s:6:\"F j, Y\";'),('date_format_search_api_facetapi_HOUR','s:4:\"H:__\";'),('date_format_search_api_facetapi_MINUTE','s:3:\"H:i\";'),('date_format_search_api_facetapi_MONTH','s:3:\"F Y\";'),('date_format_search_api_facetapi_SECOND','s:5:\"H:i:S\";'),('date_format_search_api_facetapi_YEAR','s:1:\"Y\";'),('default_field_group','a:9:{s:28:\"group_info|node|product|form\";b:0;s:38:\"group_product_detail|node|product|form\";b:0;s:43:\"group_product_information|node|product|form\";b:0;s:31:\"group_info|node|product|default\";b:0;s:36:\"group_more_info|node|product|default\";b:0;s:41:\"group_product_detail|node|product|default\";b:0;s:38:\"group_information|node|product|default\";b:0;s:34:\"group_summary|node|product|default\";b:0;s:32:\"group_price|node|product|default\";b:0;}'),('default_nodes_main','s:2:\"10\";'),('drupal_http_request_fails','b:0;'),('drupal_private_key','s:43:\"cOZ2vx7Nj0f-m2AirEGYkQwDCaXtjFz2d6iH4ub5KWs\";'),('eck_clear_caches','b:0;'),('entityreference:base-tables','a:22:{s:4:\"node\";a:2:{i:0;s:4:\"node\";i:1;s:3:\"nid\";}s:13:\"taxonomy_term\";a:2:{i:0;s:18:\"taxonomy_term_data\";i:1;s:3:\"tid\";}s:7:\"comment\";a:2:{i:0;s:7:\"comment\";i:1;s:3:\"cid\";}s:25:\"commerce_customer_profile\";a:2:{i:0;s:25:\"commerce_customer_profile\";i:1;s:10:\"profile_id\";}s:18:\"commerce_line_item\";a:2:{i:0;s:18:\"commerce_line_item\";i:1;s:12:\"line_item_id\";}s:17:\"cmp_funds_account\";a:2:{i:0;s:34:\"commerce_marketplace_funds_account\";i:1;s:10:\"account_id\";}s:21:\"cmp_funds_transaction\";a:2:{i:0;s:38:\"commerce_marketplace_funds_transaction\";i:1;s:14:\"transaction_id\";}s:25:\"cmp_funds_withdraw_method\";a:2:{i:0;s:42:\"commerce_marketplace_funds_withdraw_method\";i:1;s:2:\"id\";}s:30:\"cmp_funds_withdraw_method_type\";a:2:{i:0;s:47:\"commerce_marketplace_funds_withdraw_method_type\";i:1;s:2:\"id\";}s:14:\"commerce_order\";a:2:{i:0;s:14:\"commerce_order\";i:1;s:8:\"order_id\";}s:28:\"commerce_payment_transaction\";a:2:{i:0;s:28:\"commerce_payment_transaction\";i:1;s:14:\"transaction_id\";}s:16:\"commerce_product\";a:2:{i:0;s:16:\"commerce_product\";i:1;s:10:\"product_id\";}s:7:\"country\";a:2:{i:0;s:17:\"countries_country\";i:1;s:3:\"cid\";}s:14:\"commerce_store\";a:2:{i:0;s:18:\"eck_commerce_store\";i:1;s:2:\"id\";}s:21:\"field_collection_item\";a:2:{i:0;s:21:\"field_collection_item\";i:1;s:7:\"item_id\";}s:17:\"search_api_server\";a:2:{i:0;s:17:\"search_api_server\";i:1;s:2:\"id\";}s:16:\"search_api_index\";a:2:{i:0;s:16:\"search_api_index\";i:1;s:2:\"id\";}s:15:\"search_api_sort\";a:2:{i:0;s:15:\"search_api_sort\";i:1;s:2:\"id\";}s:4:\"file\";a:2:{i:0;s:12:\"file_managed\";i:1;s:3:\"fid\";}s:19:\"taxonomy_vocabulary\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:3:\"vid\";}s:4:\"user\";a:2:{i:0;s:5:\"users\";i:1;s:3:\"uid\";}s:12:\"rules_config\";a:2:{i:0;s:12:\"rules_config\";i:1;s:2:\"id\";}}'),('entity_cache_tables_created','N;'),('exclude_node_title_content_type_modes_article','a:10:{s:4:\"full\";i:0;s:6:\"teaser\";i:0;s:3:\"rss\";i:0;s:12:\"search_index\";i:0;s:13:\"search_result\";i:0;s:11:\"email_plain\";i:0;s:10:\"email_html\";i:0;s:13:\"email_textalt\";i:0;s:5:\"token\";i:0;s:8:\"nodeform\";i:0;}'),('exclude_node_title_content_type_modes_banner','a:10:{s:4:\"full\";i:0;s:6:\"teaser\";i:0;s:3:\"rss\";i:0;s:12:\"search_index\";i:0;s:13:\"search_result\";i:0;s:11:\"email_plain\";i:0;s:10:\"email_html\";i:0;s:13:\"email_textalt\";i:0;s:5:\"token\";i:0;s:8:\"nodeform\";i:0;}'),('exclude_node_title_content_type_modes_page','a:10:{s:4:\"full\";i:0;s:6:\"teaser\";i:0;s:3:\"rss\";i:0;s:12:\"search_index\";i:0;s:13:\"search_result\";i:0;s:11:\"email_plain\";i:0;s:10:\"email_html\";i:0;s:13:\"email_textalt\";i:0;s:5:\"token\";i:0;s:8:\"nodeform\";i:0;}'),('exclude_node_title_content_type_modes_product','a:10:{s:4:\"full\";s:4:\"full\";s:6:\"teaser\";i:0;s:3:\"rss\";i:0;s:12:\"search_index\";i:0;s:13:\"search_result\";i:0;s:11:\"email_plain\";i:0;s:10:\"email_html\";i:0;s:13:\"email_textalt\";i:0;s:5:\"token\";i:0;s:8:\"nodeform\";i:0;}'),('exclude_node_title_content_type_modes_simplenews','a:10:{s:4:\"full\";i:0;s:6:\"teaser\";i:0;s:3:\"rss\";i:0;s:12:\"search_index\";i:0;s:13:\"search_result\";i:0;s:11:\"email_plain\";i:0;s:10:\"email_html\";i:0;s:13:\"email_textalt\";i:0;s:5:\"token\";i:0;s:8:\"nodeform\";i:0;}'),('exclude_node_title_content_type_modes_webform','a:10:{s:4:\"full\";i:0;s:6:\"teaser\";i:0;s:3:\"rss\";i:0;s:12:\"search_index\";i:0;s:13:\"search_result\";i:0;s:11:\"email_plain\";i:0;s:10:\"email_html\";i:0;s:13:\"email_textalt\";i:0;s:5:\"token\";i:0;s:8:\"nodeform\";i:0;}'),('exclude_node_title_content_type_value_article','s:4:\"none\";'),('exclude_node_title_content_type_value_banner','s:4:\"none\";'),('exclude_node_title_content_type_value_page','s:4:\"none\";'),('exclude_node_title_content_type_value_product','s:3:\"all\";'),('exclude_node_title_content_type_value_simplenews','s:4:\"none\";'),('exclude_node_title_content_type_value_webform','s:4:\"none\";'),('exclude_node_title_search','i:0;'),('exclude_node_title_translation_sync','b:1;'),('features_codecache','a:2:{s:26:\"commerce_cop_bank_transfer\";a:2:{s:31:\"commerce_custom_offline_payment\";s:32:\"29547449bbf81dc19ba1c410683d8f5e\";s:12:\"dependencies\";s:32:\"3abd2fa9d2a31ca86ffdd074133b81a3\";}s:16:\"commerce_cop_cod\";a:2:{s:31:\"commerce_custom_offline_payment\";s:32:\"b4b0405535f891eee98ee06195b9ac68\";s:12:\"dependencies\";s:32:\"3abd2fa9d2a31ca86ffdd074133b81a3\";}}'),('features_ignored_orphans','a:0:{}'),('features_modules_changed','b:0;'),('features_semaphore','a:0:{}'),('field_bundle_settings_bean__about','a:2:{s:10:\"view_modes\";a:2:{s:7:\"default\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"token\";a:1:{s:15:\"custom_settings\";b:0;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:4:{s:5:\"label\";a:1:{s:6:\"weight\";s:1:\"0\";}s:5:\"title\";a:1:{s:6:\"weight\";s:1:\"1\";}s:8:\"revision\";a:1:{s:6:\"weight\";s:1:\"6\";}s:9:\"view_mode\";a:1:{s:6:\"weight\";s:1:\"5\";}}s:7:\"display\";a:1:{s:5:\"title\";a:1:{s:7:\"default\";a:2:{s:6:\"weight\";s:1:\"0\";s:7:\"visible\";b:1;}}}}}'),('field_bundle_settings_bean__image_category','a:2:{s:10:\"view_modes\";a:2:{s:7:\"default\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"token\";a:1:{s:15:\"custom_settings\";b:0;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:4:{s:5:\"label\";a:1:{s:6:\"weight\";s:3:\"-10\";}s:5:\"title\";a:1:{s:6:\"weight\";s:2:\"-9\";}s:8:\"revision\";a:1:{s:6:\"weight\";s:2:\"10\";}s:9:\"view_mode\";a:1:{s:6:\"weight\";s:2:\"10\";}}s:7:\"display\";a:1:{s:5:\"title\";a:1:{s:7:\"default\";a:2:{s:6:\"weight\";s:1:\"0\";s:7:\"visible\";b:1;}}}}}'),('field_bundle_settings_cmp_funds_withdraw_method__paypal','a:2:{s:10:\"view_modes\";a:0:{}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:0:{}s:7:\"display\";a:0:{}}}'),('field_bundle_settings_comment__comment_node_product','a:2:{s:10:\"view_modes\";a:2:{s:4:\"full\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"token\";a:1:{s:15:\"custom_settings\";b:0;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:2:{s:6:\"author\";a:1:{s:6:\"weight\";s:1:\"0\";}s:7:\"subject\";a:1:{s:6:\"weight\";s:1:\"1\";}}s:7:\"display\";a:0:{}}}'),('field_bundle_settings_commerce_product__product','a:2:{s:10:\"view_modes\";a:14:{s:9:\"line_item\";a:1:{s:15:\"custom_settings\";b:1;}s:11:\"node_teaser\";a:1:{s:15:\"custom_settings\";b:1;}s:4:\"full\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"token\";a:1:{s:15:\"custom_settings\";b:0;}s:26:\"commerce_line_item_display\";a:1:{s:15:\"custom_settings\";b:0;}s:24:\"commerce_line_item_token\";a:1:{s:15:\"custom_settings\";b:0;}s:9:\"node_full\";a:1:{s:15:\"custom_settings\";b:0;}s:8:\"node_rss\";a:1:{s:15:\"custom_settings\";b:0;}s:17:\"node_search_index\";a:1:{s:15:\"custom_settings\";b:0;}s:18:\"node_search_result\";a:1:{s:15:\"custom_settings\";b:0;}s:16:\"node_email_plain\";a:1:{s:15:\"custom_settings\";b:0;}s:15:\"node_email_html\";a:1:{s:15:\"custom_settings\";b:0;}s:18:\"node_email_textalt\";a:1:{s:15:\"custom_settings\";b:0;}s:10:\"node_token\";a:1:{s:15:\"custom_settings\";b:0;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:3:{s:3:\"sku\";a:1:{s:6:\"weight\";s:1:\"0\";}s:5:\"title\";a:1:{s:6:\"weight\";s:1:\"1\";}s:6:\"status\";a:1:{s:6:\"weight\";s:1:\"7\";}}s:7:\"display\";a:3:{s:3:\"sku\";a:1:{s:7:\"default\";a:2:{s:6:\"weight\";s:1:\"1\";s:7:\"visible\";b:1;}}s:6:\"status\";a:1:{s:7:\"default\";a:2:{s:6:\"weight\";s:1:\"6\";s:7:\"visible\";b:1;}}s:5:\"title\";a:1:{s:7:\"default\";a:2:{s:6:\"weight\";s:1:\"0\";s:7:\"visible\";b:1;}}}}}'),('field_bundle_settings_commerce_store__store','a:2:{s:10:\"view_modes\";a:2:{s:6:\"teaser\";a:1:{s:15:\"custom_settings\";b:1;}s:5:\"token\";a:1:{s:15:\"custom_settings\";b:0;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:0:{}s:7:\"display\";a:0:{}}}'),('field_bundle_settings_field_collection_item__field_specifications','a:2:{s:10:\"view_modes\";a:2:{s:4:\"full\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"token\";a:1:{s:15:\"custom_settings\";b:0;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:0:{}s:7:\"display\";a:0:{}}}'),('field_bundle_settings_node__banner','a:2:{s:10:\"view_modes\";a:9:{s:6:\"teaser\";a:1:{s:15:\"custom_settings\";b:1;}s:4:\"full\";a:1:{s:15:\"custom_settings\";b:0;}s:3:\"rss\";a:1:{s:15:\"custom_settings\";b:0;}s:12:\"search_index\";a:1:{s:15:\"custom_settings\";b:0;}s:13:\"search_result\";a:1:{s:15:\"custom_settings\";b:0;}s:11:\"email_plain\";a:1:{s:15:\"custom_settings\";b:0;}s:10:\"email_html\";a:1:{s:15:\"custom_settings\";b:0;}s:13:\"email_textalt\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"token\";a:1:{s:15:\"custom_settings\";b:0;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:2:{s:5:\"title\";a:1:{s:6:\"weight\";s:1:\"0\";}s:4:\"path\";a:1:{s:6:\"weight\";s:1:\"7\";}}s:7:\"display\";a:0:{}}}'),('field_bundle_settings_node__product','a:2:{s:10:\"view_modes\";a:9:{s:6:\"teaser\";a:1:{s:15:\"custom_settings\";b:1;}s:4:\"full\";a:1:{s:15:\"custom_settings\";b:0;}s:3:\"rss\";a:1:{s:15:\"custom_settings\";b:0;}s:12:\"search_index\";a:1:{s:15:\"custom_settings\";b:0;}s:13:\"search_result\";a:1:{s:15:\"custom_settings\";b:0;}s:11:\"email_plain\";a:1:{s:15:\"custom_settings\";b:0;}s:10:\"email_html\";a:1:{s:15:\"custom_settings\";b:0;}s:13:\"email_textalt\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"token\";a:1:{s:15:\"custom_settings\";b:0;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:2:{s:5:\"title\";a:1:{s:6:\"weight\";s:1:\"0\";}s:4:\"path\";a:1:{s:6:\"weight\";s:1:\"5\";}}s:7:\"display\";a:11:{s:11:\"product:sku\";a:1:{s:7:\"default\";a:2:{s:6:\"weight\";s:1:\"6\";s:7:\"visible\";b:0;}}s:13:\"product:title\";a:1:{s:7:\"default\";a:2:{s:6:\"weight\";s:1:\"3\";s:7:\"visible\";b:0;}}s:14:\"product:status\";a:1:{s:7:\"default\";a:2:{s:6:\"weight\";s:1:\"7\";s:7:\"visible\";b:0;}}s:22:\"product:commerce_price\";a:1:{s:7:\"default\";a:2:{s:6:\"weight\";s:2:\"30\";s:7:\"visible\";b:1;}}s:17:\"product:cmp_store\";a:1:{s:7:\"default\";a:2:{s:6:\"weight\";s:2:\"32\";s:7:\"visible\";b:1;}}s:27:\"product:field_product_image\";a:1:{s:7:\"default\";a:2:{s:6:\"weight\";s:1:\"3\";s:7:\"visible\";b:1;}}s:19:\"product:title_field\";a:1:{s:7:\"default\";a:2:{s:6:\"weight\";s:2:\"-5\";s:7:\"visible\";b:1;}}s:22:\"product:commerce_stock\";a:1:{s:7:\"default\";a:2:{s:6:\"weight\";s:2:\"31\";s:7:\"visible\";b:1;}}s:23:\"product:field_old_price\";a:1:{s:7:\"default\";a:2:{s:6:\"weight\";s:2:\"28\";s:7:\"visible\";b:1;}}s:27:\"product:field_product_color\";a:1:{s:7:\"default\";a:2:{s:6:\"weight\";s:1:\"2\";s:7:\"visible\";b:0;}}s:33:\"product:field_discount_percentage\";a:1:{s:7:\"default\";a:2:{s:6:\"weight\";s:2:\"29\";s:7:\"visible\";b:1;}}}}}'),('field_bundle_settings_node__webform','a:2:{s:10:\"view_modes\";a:9:{s:6:\"teaser\";a:1:{s:15:\"custom_settings\";b:1;}s:4:\"full\";a:1:{s:15:\"custom_settings\";b:0;}s:3:\"rss\";a:1:{s:15:\"custom_settings\";b:0;}s:12:\"search_index\";a:1:{s:15:\"custom_settings\";b:0;}s:13:\"search_result\";a:1:{s:15:\"custom_settings\";b:0;}s:11:\"email_plain\";a:1:{s:15:\"custom_settings\";b:0;}s:10:\"email_html\";a:1:{s:15:\"custom_settings\";b:0;}s:13:\"email_textalt\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"token\";a:1:{s:15:\"custom_settings\";b:0;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:2:{s:5:\"title\";a:1:{s:6:\"weight\";s:1:\"0\";}s:4:\"path\";a:1:{s:6:\"weight\";s:1:\"3\";}}s:7:\"display\";a:1:{s:7:\"webform\";a:1:{s:7:\"default\";a:2:{s:6:\"weight\";s:1:\"1\";s:7:\"visible\";b:1;}}}}}'),('field_bundle_settings_taxonomy_term__brands','a:2:{s:10:\"view_modes\";a:0:{}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:3:{s:4:\"path\";a:1:{s:6:\"weight\";s:1:\"3\";}s:4:\"name\";a:1:{s:6:\"weight\";s:1:\"0\";}s:11:\"description\";a:1:{s:6:\"weight\";s:1:\"2\";}}s:7:\"display\";a:0:{}}}'),('field_bundle_settings_taxonomy_term__color','a:2:{s:10:\"view_modes\";a:0:{}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:3:{s:4:\"path\";a:1:{s:6:\"weight\";s:1:\"3\";}s:4:\"name\";a:1:{s:6:\"weight\";s:1:\"0\";}s:11:\"description\";a:1:{s:6:\"weight\";s:1:\"2\";}}s:7:\"display\";a:1:{s:11:\"description\";a:1:{s:16:\"add_to_cart_form\";a:2:{s:6:\"weight\";s:1:\"1\";s:7:\"visible\";b:0;}}}}}'),('file_default_scheme','s:6:\"public\";'),('file_private_path','s:0:\"\";'),('file_public_path','s:19:\"sites/default/files\";'),('file_temporary_path','s:4:\"/tmp\";'),('filter_fallback_format','s:10:\"plain_text\";'),('flexslider_version','s:3:\"2.2\";'),('icon_api_view_path_alias','s:5:\"icons\";'),('image_jpeg_quality','s:3:\"100\";'),('image_toolkit','s:2:\"gd\";'),('imce_profiles','a:2:{i:1;a:10:{s:4:\"name\";s:6:\"User-1\";s:7:\"usertab\";i:1;s:8:\"filesize\";i:0;s:5:\"quota\";i:0;s:7:\"tuquota\";i:0;s:10:\"extensions\";s:1:\"*\";s:10:\"dimensions\";s:9:\"1200x1200\";s:7:\"filenum\";i:0;s:11:\"directories\";a:1:{i:0;a:7:{s:4:\"name\";s:1:\".\";s:6:\"subnav\";i:1;s:6:\"browse\";i:1;s:6:\"upload\";i:1;s:5:\"thumb\";i:1;s:6:\"delete\";i:1;s:6:\"resize\";i:1;}}s:10:\"thumbnails\";a:3:{i:0;a:4:{s:4:\"name\";s:5:\"Small\";s:10:\"dimensions\";s:5:\"90x90\";s:6:\"prefix\";s:6:\"small_\";s:6:\"suffix\";s:0:\"\";}i:1;a:4:{s:4:\"name\";s:6:\"Medium\";s:10:\"dimensions\";s:7:\"120x120\";s:6:\"prefix\";s:7:\"medium_\";s:6:\"suffix\";s:0:\"\";}i:2;a:4:{s:4:\"name\";s:5:\"Large\";s:10:\"dimensions\";s:7:\"180x180\";s:6:\"prefix\";s:6:\"large_\";s:6:\"suffix\";s:0:\"\";}}}i:2;a:10:{s:4:\"name\";s:14:\"Sample profile\";s:7:\"usertab\";i:1;s:8:\"filesize\";i:1;s:5:\"quota\";i:2;s:7:\"tuquota\";i:0;s:10:\"extensions\";s:16:\"gif png jpg jpeg\";s:10:\"dimensions\";s:7:\"800x600\";s:7:\"filenum\";i:1;s:11:\"directories\";a:1:{i:0;a:7:{s:4:\"name\";s:5:\"u%uid\";s:6:\"subnav\";i:0;s:6:\"browse\";i:1;s:6:\"upload\";i:1;s:5:\"thumb\";i:1;s:6:\"delete\";i:0;s:6:\"resize\";i:0;}}s:10:\"thumbnails\";a:1:{i:0;a:4:{s:4:\"name\";s:5:\"Thumb\";s:10:\"dimensions\";s:5:\"90x90\";s:6:\"prefix\";s:6:\"thumb_\";s:6:\"suffix\";s:0:\"\";}}}}'),('install_profile','s:8:\"standard\";'),('install_task','s:4:\"done\";'),('install_time','i:1414469826;'),('jquery_update_compression_type','s:3:\"min\";'),('jquery_update_jquery_admin_version','s:0:\"\";'),('jquery_update_jquery_cdn','s:4:\"none\";'),('jquery_update_jquery_version','s:3:\"1.7\";'),('language_count','i:2;'),('language_default','O:8:\"stdClass\":11:{s:8:\"language\";s:2:\"en\";s:4:\"name\";s:7:\"English\";s:6:\"native\";s:7:\"English\";s:9:\"direction\";s:1:\"0\";s:7:\"enabled\";i:1;s:7:\"plurals\";s:1:\"0\";s:7:\"formula\";s:0:\"\";s:6:\"domain\";s:0:\"\";s:6:\"prefix\";s:2:\"en\";s:6:\"weight\";s:1:\"0\";s:10:\"javascript\";s:0:\"\";}'),('language_negotiation_language','a:2:{s:10:\"locale-url\";a:2:{s:9:\"callbacks\";a:3:{s:8:\"language\";s:24:\"locale_language_from_url\";s:8:\"switcher\";s:28:\"locale_language_switcher_url\";s:11:\"url_rewrite\";s:31:\"locale_language_url_rewrite_url\";}s:4:\"file\";s:19:\"includes/locale.inc\";}s:16:\"language-default\";a:1:{s:9:\"callbacks\";a:1:{s:8:\"language\";s:21:\"language_from_default\";}}}'),('language_negotiation_language_content','a:1:{s:16:\"locale-interface\";a:2:{s:9:\"callbacks\";a:1:{s:8:\"language\";s:30:\"locale_language_from_interface\";}s:4:\"file\";s:19:\"includes/locale.inc\";}}'),('language_negotiation_language_url','a:2:{s:10:\"locale-url\";a:2:{s:9:\"callbacks\";a:3:{s:8:\"language\";s:24:\"locale_language_from_url\";s:8:\"switcher\";s:28:\"locale_language_switcher_url\";s:11:\"url_rewrite\";s:31:\"locale_language_url_rewrite_url\";}s:4:\"file\";s:19:\"includes/locale.inc\";}s:19:\"locale-url-fallback\";a:2:{s:9:\"callbacks\";a:1:{s:8:\"language\";s:28:\"locale_language_url_fallback\";}s:4:\"file\";s:19:\"includes/locale.inc\";}}'),('language_types','a:3:{s:8:\"language\";b:1;s:16:\"language_content\";b:0;s:12:\"language_url\";b:0;}'),('locale_language_providers_weight_language','a:5:{s:10:\"locale-url\";s:2:\"-8\";s:14:\"locale-session\";s:2:\"-6\";s:11:\"locale-user\";s:2:\"-4\";s:14:\"locale-browser\";s:2:\"-2\";s:16:\"language-default\";s:2:\"10\";}'),('maintenance_mode','b:0;'),('menu_breadcrumb_append_node_title','i:1;'),('menu_breadcrumb_append_node_url','i:0;'),('menu_breadcrumb_determine_menu','i:1;'),('menu_breadcrumb_hide_on_single_item','i:1;'),('menu_breadcrumb_menus','a:9:{s:9:\"main-menu\";a:5:{s:7:\"enabled\";i:1;s:6:\"weight\";s:1:\"0\";s:4:\"type\";s:4:\"menu\";s:5:\"title\";s:9:\"Main menu\";s:4:\"name\";s:9:\"main-menu\";}s:10:\"management\";a:5:{s:7:\"enabled\";i:1;s:6:\"weight\";s:1:\"0\";s:4:\"type\";s:4:\"menu\";s:5:\"title\";s:10:\"Management\";s:4:\"name\";s:10:\"management\";}s:13:\"menu-about-us\";a:5:{s:7:\"enabled\";i:1;s:6:\"weight\";s:1:\"0\";s:4:\"type\";s:4:\"menu\";s:5:\"title\";s:8:\"About us\";s:4:\"name\";s:13:\"menu-about-us\";}s:18:\"menu-customer-help\";a:5:{s:7:\"enabled\";i:1;s:6:\"weight\";s:1:\"0\";s:4:\"type\";s:4:\"menu\";s:5:\"title\";s:13:\"Customer help\";s:4:\"name\";s:18:\"menu-customer-help\";}s:28:\"menu_breadcrumb_default_menu\";a:5:{s:7:\"enabled\";i:1;s:6:\"weight\";s:1:\"0\";s:4:\"type\";s:28:\"menu_breadcrumb_default_menu\";s:5:\"title\";s:28:\"menu_breadcrumb_default_menu\";s:4:\"name\";s:28:\"menu_breadcrumb_default_menu\";}s:10:\"navigation\";a:5:{s:7:\"enabled\";i:1;s:6:\"weight\";s:1:\"0\";s:4:\"type\";s:4:\"menu\";s:5:\"title\";s:10:\"Navigation\";s:4:\"name\";s:10:\"navigation\";}s:14:\"shortcut-set-1\";a:5:{s:7:\"enabled\";i:1;s:6:\"weight\";s:1:\"0\";s:4:\"type\";s:4:\"menu\";s:5:\"title\";s:14:\"shortcut-set-1\";s:4:\"name\";s:14:\"shortcut-set-1\";}s:9:\"user-menu\";a:5:{s:7:\"enabled\";i:1;s:6:\"weight\";s:1:\"0\";s:4:\"type\";s:4:\"menu\";s:5:\"title\";s:9:\"User menu\";s:4:\"name\";s:9:\"user-menu\";}s:5:\"devel\";a:5:{s:7:\"enabled\";i:0;s:6:\"weight\";s:1:\"1\";s:4:\"type\";s:4:\"menu\";s:5:\"title\";s:11:\"Development\";s:4:\"name\";s:5:\"devel\";}}'),('menu_breadcrumb_menu_patterns','s:22:\"/^book-toc-\\d+$/Books/\";'),('menu_breadcrumb_pattern_matches_rebuild','b:0;'),('menu_default_active_menus','a:9:{i:0;s:13:\"menu-about-us\";i:1;s:18:\"menu-customer-help\";i:2;s:5:\"devel\";i:3;s:9:\"main-menu\";i:4;s:10:\"management\";i:5;s:10:\"navigation\";i:6;s:9:\"user-menu\";i:8;s:14:\"menu-help-menu\";i:9;s:18:\"menu-headline-menu\";}'),('menu_descriptions_headline-menu','i:0;'),('menu_descriptions_help-menu','i:0;'),('menu_descriptions_menu-headline-menu','i:0;'),('menu_descriptions_menu-help-menu','i:0;'),('menu_descriptions_menu-your-account','i:1;'),('menu_descriptions_user-menu','i:1;'),('menu_descriptions_your-account','i:1;'),('menu_expanded','a:1:{i:0;s:9:\"main-menu\";}'),('menu_masks','a:62:{i:0;i:509;i:1;i:507;i:2;i:506;i:3;i:501;i:4;i:494;i:5;i:493;i:6;i:255;i:7;i:254;i:8;i:253;i:9;i:252;i:10;i:251;i:11;i:250;i:12;i:247;i:13;i:246;i:14;i:245;i:15;i:241;i:16;i:127;i:17;i:126;i:18;i:125;i:19;i:124;i:20;i:123;i:21;i:122;i:22;i:121;i:23;i:118;i:24;i:117;i:25;i:111;i:26;i:109;i:27;i:63;i:28;i:62;i:29;i:61;i:30;i:60;i:31;i:59;i:32;i:58;i:33;i:56;i:34;i:55;i:35;i:54;i:36;i:53;i:37;i:47;i:38;i:45;i:39;i:44;i:40;i:43;i:41;i:31;i:42;i:30;i:43;i:29;i:44;i:28;i:45;i:27;i:46;i:26;i:47;i:24;i:48;i:22;i:49;i:21;i:50;i:15;i:51;i:14;i:52;i:13;i:53;i:11;i:54;i:10;i:55;i:7;i:56;i:6;i:57;i:5;i:58;i:4;i:59;i:3;i:60;i:2;i:61;i:1;}'),('menu_options_banner','a:0:{}'),('menu_options_product','a:1:{i:0;s:9:\"main-menu\";}'),('menu_options_webform','a:1:{i:0;s:9:\"main-menu\";}'),('menu_parent_banner','s:11:\"main-menu:0\";'),('menu_parent_product','s:11:\"main-menu:0\";'),('menu_parent_webform','s:11:\"main-menu:0\";'),('minimum_word_size','s:1:\"3\";'),('module_filter_recent_modules','a:1:{s:20:\"we_content_migration\";i:1499933751;}'),('node_admin_theme','i:1;'),('node_cron_last','s:10:\"1419633533\";'),('node_options_banner','a:1:{i:0;s:6:\"status\";}'),('node_options_page','a:1:{i:0;s:6:\"status\";}'),('node_options_product','a:2:{i:0;s:6:\"status\";i:1;s:7:\"promote\";}'),('node_options_webform','a:2:{i:0;s:6:\"status\";i:1;s:7:\"promote\";}'),('node_preview_banner','s:1:\"1\";'),('node_preview_product','s:1:\"1\";'),('node_preview_webform','s:1:\"1\";'),('node_rank_comments','s:1:\"0\";'),('node_rank_promote','s:1:\"0\";'),('node_rank_recent','s:1:\"0\";'),('node_rank_relevance','s:1:\"0\";'),('node_rank_sticky','s:1:\"0\";'),('node_recent_block_count','s:1:\"4\";'),('node_submitted_banner','i:0;'),('node_submitted_page','b:0;'),('node_submitted_product','i:0;'),('node_submitted_webform','i:0;'),('overlap_cjk','i:1;'),('pathauto_blog_pattern','s:17:\"blogs/[user:name]\";'),('pathauto_forum_pattern','s:29:\"[term:vocabulary]/[term:name]\";'),('pathauto_node_article_pattern','s:12:\"[node:title]\";'),('pathauto_node_banner_pattern','s:12:\"[node:title]\";'),('pathauto_node_page_pattern','s:12:\"[node:title]\";'),('pathauto_node_pattern','s:20:\"content/[node:title]\";'),('pathauto_node_product_pattern','s:31:\"product/[node:title]-[node:nid]\";'),('pathauto_node_simplenews_pattern','s:0:\"\";'),('pathauto_node_webform_pattern','s:12:\"[node:title]\";'),('pathauto_punctuation_hyphen','i:1;'),('pathauto_taxonomy_term_brands_pattern','s:0:\"\";'),('pathauto_taxonomy_term_categories_pattern','s:0:\"\";'),('pathauto_taxonomy_term_newsletter_pattern','s:0:\"\";'),('pathauto_taxonomy_term_pattern','s:29:\"[term:vocabulary]/[term:name]\";'),('pathauto_taxonomy_term_tags_pattern','s:0:\"\";'),('pathauto_user_pattern','s:17:\"users/[user:name]\";'),('path_alias_whitelist','a:3:{s:4:\"node\";b:1;s:8:\"taxonomy\";b:1;s:4:\"user\";b:1;}'),('rr_config','a:1:{s:4:\"node\";a:3:{s:6:\"enable\";i:1;s:10:\"max_record\";i:10;s:9:\"view_mode\";a:1:{s:4:\"full\";s:4:\"full\";}}}'),('save_continue_banner','s:19:\"Save and add fields\";'),('save_continue_products','s:19:\"Save and add fields\";'),('search_active_modules','a:2:{s:4:\"node\";s:4:\"node\";s:4:\"user\";s:4:\"user\";}'),('search_api_facets_search_ids','a:1:{s:15:\"product_display\";a:3:{s:28:\"search_api_views:search:page\";s:28:\"search_api_views:search:page\";s:30:\"search_api_views:category:page\";s:30:\"search_api_views:category:page\";s:32:\"search_api_views:category:page_1\";s:32:\"search_api_views:category:page_1\";}}'),('search_cron_limit','s:3:\"500\";'),('search_default_module','s:4:\"node\";'),('simplenews_block_f_1','s:1:\"1\";'),('simplenews_block_i_1','s:1:\"5\";'),('simplenews_block_i_status_1','i:0;'),('simplenews_block_l_1','i:0;'),('simplenews_block_m_1','s:32:\"Subscribe and Get 20% Instantly!\";'),('simplenews_block_r_1','i:0;'),('simplenews_content_type_banner','i:0;'),('simplenews_content_type_product','i:0;'),('simplenews_content_type_simplenews','b:1;'),('simplenews_content_type_webform','i:0;'),('simplenews_vid','s:1:\"2\";'),('site_403','s:0:\"\";'),('site_404','s:8:\"node/141\";'),('site_default_country','s:2:\"VN\";'),('site_frontpage','s:9:\"frontpage\";'),('site_mail','s:13:\"admin@lvh.com\";'),('site_name','s:12:\"Market Place\";'),('site_slogan','s:0:\"\";'),('sync_translations_banner','s:1:\"0\";'),('sync_translations_webform','s:1:\"0\";'),('table','a:4:{i:0;a:1:{s:6:\"weight\";s:1:\"0\";}i:1;a:1:{s:6:\"weight\";s:1:\"1\";}i:2;a:1:{s:6:\"weight\";s:1:\"2\";}i:3;a:1:{s:6:\"weight\";s:2:\"11\";}}'),('taxonomy_menu_display_descendants_apple','i:0;'),('taxonomy_menu_display_descendants_availability','i:0;'),('taxonomy_menu_display_descendants_brands','i:0;'),('taxonomy_menu_display_descendants_categories','i:0;'),('taxonomy_menu_display_descendants_color','i:0;'),('taxonomy_menu_display_descendants_manufacture','i:0;'),('taxonomy_menu_display_num_apple','i:0;'),('taxonomy_menu_display_num_availability','i:0;'),('taxonomy_menu_display_num_brands','i:0;'),('taxonomy_menu_display_num_categories','i:0;'),('taxonomy_menu_display_num_color','i:0;'),('taxonomy_menu_display_num_manufacture','i:0;'),('taxonomy_menu_end_all_apple','b:0;'),('taxonomy_menu_end_all_availability','b:0;'),('taxonomy_menu_end_all_brands','b:0;'),('taxonomy_menu_end_all_categories','b:0;'),('taxonomy_menu_end_all_color','b:0;'),('taxonomy_menu_end_all_manufacture','b:0;'),('taxonomy_menu_expanded_apple','i:1;'),('taxonomy_menu_expanded_availability','i:1;'),('taxonomy_menu_expanded_brands','i:1;'),('taxonomy_menu_expanded_categories','i:1;'),('taxonomy_menu_expanded_color','i:1;'),('taxonomy_menu_expanded_manufacture','i:1;'),('taxonomy_menu_flat_apple','i:0;'),('taxonomy_menu_flat_availability','i:0;'),('taxonomy_menu_flat_brands','i:0;'),('taxonomy_menu_flat_categories','i:0;'),('taxonomy_menu_flat_color','i:0;'),('taxonomy_menu_flat_manufacture','i:0;'),('taxonomy_menu_hide_empty_terms_apple','i:0;'),('taxonomy_menu_hide_empty_terms_availability','i:0;'),('taxonomy_menu_hide_empty_terms_brands','i:0;'),('taxonomy_menu_hide_empty_terms_categories','i:0;'),('taxonomy_menu_hide_empty_terms_color','i:0;'),('taxonomy_menu_hide_empty_terms_manufacture','i:0;'),('taxonomy_menu_path_apple','s:26:\"taxonomy_menu_path_default\";'),('taxonomy_menu_path_availability','s:26:\"taxonomy_menu_path_default\";'),('taxonomy_menu_path_brands','s:26:\"taxonomy_menu_path_default\";'),('taxonomy_menu_path_categories','s:26:\"taxonomy_menu_path_default\";'),('taxonomy_menu_path_color','s:26:\"taxonomy_menu_path_default\";'),('taxonomy_menu_path_manufacture','s:26:\"taxonomy_menu_path_default\";'),('taxonomy_menu_rebuild_apple','i:0;'),('taxonomy_menu_rebuild_availability','i:0;'),('taxonomy_menu_rebuild_brands','i:0;'),('taxonomy_menu_rebuild_categories','i:0;'),('taxonomy_menu_rebuild_color','i:0;'),('taxonomy_menu_rebuild_manufacture','i:0;'),('taxonomy_menu_sync_apple','i:1;'),('taxonomy_menu_sync_availability','i:1;'),('taxonomy_menu_sync_brands','i:1;'),('taxonomy_menu_sync_categories','i:1;'),('taxonomy_menu_sync_color','i:1;'),('taxonomy_menu_sync_manufacture','i:1;'),('taxonomy_menu_term_item_description_apple','i:0;'),('taxonomy_menu_term_item_description_availability','i:0;'),('taxonomy_menu_term_item_description_brands','i:0;'),('taxonomy_menu_term_item_description_categories','i:0;'),('taxonomy_menu_term_item_description_color','i:0;'),('taxonomy_menu_term_item_description_manufacture','i:0;'),('taxonomy_menu_vocab_menu_apple','s:1:\"0\";'),('taxonomy_menu_vocab_menu_availability','s:1:\"0\";'),('taxonomy_menu_vocab_menu_brands','s:1:\"0\";'),('taxonomy_menu_vocab_menu_categories','s:9:\"main-menu\";'),('taxonomy_menu_vocab_menu_color','s:1:\"0\";'),('taxonomy_menu_vocab_menu_manufacture','s:1:\"0\";'),('taxonomy_menu_vocab_parent_apple','s:1:\"0\";'),('taxonomy_menu_vocab_parent_availability','s:1:\"0\";'),('taxonomy_menu_vocab_parent_brands','s:1:\"0\";'),('taxonomy_menu_vocab_parent_categories','s:1:\"0\";'),('taxonomy_menu_vocab_parent_color','s:1:\"0\";'),('taxonomy_menu_vocab_parent_manufacture','s:1:\"0\";'),('taxonomy_menu_voc_item_apple','b:0;'),('taxonomy_menu_voc_item_availability','b:0;'),('taxonomy_menu_voc_item_brands','b:0;'),('taxonomy_menu_voc_item_categories','b:0;'),('taxonomy_menu_voc_item_color','b:0;'),('taxonomy_menu_voc_item_description_apple','i:0;'),('taxonomy_menu_voc_item_description_availability','i:0;'),('taxonomy_menu_voc_item_description_brands','i:0;'),('taxonomy_menu_voc_item_description_categories','i:0;'),('taxonomy_menu_voc_item_description_color','i:0;'),('taxonomy_menu_voc_item_description_manufacture','i:0;'),('taxonomy_menu_voc_item_manufacture','b:0;'),('taxonomy_menu_voc_name_apple','b:0;'),('taxonomy_menu_voc_name_availability','b:0;'),('taxonomy_menu_voc_name_brands','b:0;'),('taxonomy_menu_voc_name_categories','b:0;'),('taxonomy_menu_voc_name_color','b:0;'),('taxonomy_menu_voc_name_manufacture','b:0;'),('theme_azastore_settings','a:21:{s:16:\"azastore_version\";s:0:\"\";s:4:\"skin\";s:0:\"\";s:10:\"background\";s:10:\"bg-default\";s:6:\"layout\";s:14:\"layout-default\";s:12:\"layout_width\";s:4:\"1400\";s:11:\"toggle_logo\";i:1;s:11:\"toggle_name\";i:0;s:13:\"toggle_slogan\";i:0;s:24:\"toggle_node_user_picture\";i:1;s:27:\"toggle_comment_user_picture\";i:1;s:32:\"toggle_comment_user_verification\";i:1;s:14:\"toggle_favicon\";i:1;s:15:\"show_skins_menu\";i:0;s:12:\"loading_page\";i:0;s:12:\"default_logo\";i:1;s:9:\"logo_path\";s:0:\"\";s:11:\"logo_upload\";s:0:\"\";s:15:\"default_favicon\";i:1;s:12:\"favicon_path\";s:0:\"\";s:14:\"favicon_upload\";s:0:\"\";s:29:\"azastore_use_default_settings\";s:1:\"0\";}'),('theme_default','s:11:\"marketplace\";'),('theme_marketplace_settings','a:21:{s:19:\"marketplace_version\";s:0:\"\";s:4:\"skin\";s:0:\"\";s:10:\"background\";s:10:\"bg-default\";s:6:\"layout\";s:14:\"layout-default\";s:12:\"layout_width\";s:4:\"1200\";s:11:\"toggle_logo\";i:1;s:11:\"toggle_name\";i:0;s:13:\"toggle_slogan\";i:0;s:24:\"toggle_node_user_picture\";i:1;s:27:\"toggle_comment_user_picture\";i:1;s:32:\"toggle_comment_user_verification\";i:1;s:14:\"toggle_favicon\";i:1;s:15:\"show_skins_menu\";i:1;s:12:\"loading_page\";i:0;s:12:\"default_logo\";i:1;s:9:\"logo_path\";s:0:\"\";s:11:\"logo_upload\";s:0:\"\";s:15:\"default_favicon\";i:1;s:12:\"favicon_path\";s:0:\"\";s:14:\"favicon_upload\";s:0:\"\";s:32:\"marketplace_use_default_settings\";s:1:\"0\";}'),('update_check_disabled','i:0;'),('update_check_frequency','s:1:\"1\";'),('update_last_check','i:1500361175;'),('update_last_email_notification','i:1500360922;'),('update_notification_threshold','s:3:\"all\";'),('update_notify_emails','a:1:{i:0;s:19:\"admin@localhost.com\";}'),('user_admin_role','s:1:\"3\";'),('user_pictures','s:1:\"1\";'),('user_picture_dimensions','s:9:\"1024x1024\";'),('user_picture_file_size','s:3:\"800\";'),('user_picture_style','s:9:\"thumbnail\";'),('user_register','i:2;'),('views_defaults','a:2:{s:9:\"frontpage\";b:0;s:13:\"taxonomy_term\";b:1;}'),('views_exposed_filter_any_label','s:7:\"new_any\";'),('views_show_additional_queries','i:0;'),('views_ui_always_live_preview','i:1;'),('views_ui_custom_theme','s:8:\"_default\";'),('views_ui_display_embed','i:0;'),('views_ui_show_advanced_column','i:1;'),('views_ui_show_advanced_help_warning','i:1;'),('views_ui_show_listing_filters','i:0;'),('views_ui_show_master_display','i:0;'),('views_ui_show_performance_statistics','i:0;'),('views_ui_show_preview_information','i:1;'),('views_ui_show_sql_query','i:1;'),('views_ui_show_sql_query_where','s:5:\"above\";'),('webform_email_address_individual','i:1;'),('webform_email_html_capable','b:0;'),('webform_node_banner','i:0;'),('webform_node_product','i:0;'),('webform_node_webform','i:1;'),('weight_default_banner','s:1:\"0\";'),('weight_default_webform','s:1:\"0\";'),('weight_enabled_banner','s:1:\"1\";'),('weight_enabled_webform','s:1:\"0\";'),('weight_frontpage','i:1;'),('weight_menu_banner','s:1:\"0\";'),('weight_menu_webform','s:1:\"0\";'),('weight_range_banner','s:2:\"50\";'),('weight_range_webform','s:2:\"20\";');
/*!40000 ALTER TABLE `variable` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `views_display`
--

DROP TABLE IF EXISTS `views_display`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `views_display` (
  `vid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The view this display is attached to.',
  `id` varchar(64) NOT NULL DEFAULT '' COMMENT 'An identifier for this display; usually generated from the display_plugin, so should be something like page or page_1 or block_2, etc.',
  `display_title` varchar(64) NOT NULL DEFAULT '' COMMENT 'The title of the display, viewable by the administrator.',
  `display_plugin` varchar(64) NOT NULL DEFAULT '' COMMENT 'The type of the display. Usually page, block or embed, but is pluggable so may be other things.',
  `position` int(11) DEFAULT '0' COMMENT 'The order in which this display is loaded.',
  `display_options` longtext COMMENT 'A serialized array of options for this display; it contains options that are generally only pertinent to that display plugin type.',
  PRIMARY KEY (`vid`,`id`),
  KEY `vid` (`vid`,`position`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores information about each display attached to a view.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `views_display`
--

LOCK TABLES `views_display` WRITE;
/*!40000 ALTER TABLE `views_display` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `views_display` VALUES (1,'default','Master','default',1,'a:14:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:6:{s:19:\"disable_sql_rewrite\";i:1;s:8:\"distinct\";i:0;s:13:\"pure_distinct\";i:0;s:5:\"slave\";i:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"4\";s:6:\"offset\";s:1:\"0\";}}s:12:\"style_plugin\";s:4:\"grid\";s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:4:{s:22:\"default_field_elements\";i:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";i:0;}s:5:\"sorts\";a:2:{s:6:\"sticky\";a:4:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"sticky\";s:5:\"order\";s:4:\"DESC\";}s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:7:\"filters\";a:3:{s:7:\"promote\";a:6:{s:2:\"id\";s:7:\"promote\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"promote\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:0;s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}s:6:\"status\";a:6:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:0;s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}s:4:\"type\";a:13:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:7:\"product\";s:7:\"product\";}s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:12:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}}s:13:\"style_options\";a:9:{s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";i:1;s:17:\"row_class_special\";i:1;s:11:\"uses_fields\";i:0;s:7:\"columns\";s:1:\"4\";s:9:\"alignment\";s:10:\"horizontal\";s:16:\"fill_single_line\";i:1;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";}s:9:\"css_class\";s:13:\"products-grid\";s:6:\"fields\";a:5:{s:4:\"path\";a:22:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"path\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:8:\"absolute\";i:0;}s:19:\"field_product_image\";a:34:{s:2:\"id\";s:19:\"field_product_image\";s:5:\"table\";s:30:\"field_data_field_product_image\";s:5:\"field\";s:19:\"field_product_image\";s:12:\"relationship\";s:24:\"field_product_product_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:78:\"<a href=\"[path]\" title=\"[field_product_image-title]\">[field_product_image]</a>\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:3:{s:11:\"image_style\";s:22:\"thumbnail_product_grid\";s:10:\"image_link\";s:0:\"\";s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";i:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";s:1:\"0\";s:14:\"delta_reversed\";i:0;s:16:\"delta_first_last\";i:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:5:\"title\";a:22:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:1;}s:12:\"field_review\";a:34:{s:2:\"id\";s:12:\"field_review\";s:5:\"table\";s:23:\"field_data_field_review\";s:5:\"field\";s:12:\"field_review\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:6:\"rating\";s:4:\"type\";s:26:\"fivestar_formatter_default\";s:8:\"settings\";a:5:{s:6:\"widget\";a:1:{s:15:\"fivestar_widget\";s:7:\"default\";}s:6:\"expose\";i:0;s:5:\"style\";s:7:\"average\";s:4:\"text\";s:7:\"average\";s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:14:\"commerce_price\";a:34:{s:2:\"id\";s:14:\"commerce_price\";s:5:\"table\";s:25:\"field_data_commerce_price\";s:5:\"field\";s:14:\"commerce_price\";s:12:\"relationship\";s:24:\"field_product_product_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:6:\"amount\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:1:\"0\";s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}}s:13:\"relationships\";a:1:{s:24:\"field_product_product_id\";a:8:{s:2:\"id\";s:24:\"field_product_product_id\";s:5:\"table\";s:24:\"field_data_field_product\";s:5:\"field\";s:24:\"field_product_product_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:36:\"Products referenced by field_product\";s:8:\"required\";i:1;}}}'),(1,'feed','Feed','feed',3,'a:9:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:8:\"defaults\";a:1:{s:5:\"title\";b:0;}s:5:\"title\";s:15:\"Front page feed\";s:5:\"pager\";a:1:{s:4:\"type\";s:4:\"some\";}s:12:\"style_plugin\";s:3:\"rss\";s:10:\"row_plugin\";s:8:\"node_rss\";s:4:\"path\";s:7:\"rss.xml\";s:8:\"displays\";a:2:{s:7:\"default\";s:7:\"default\";s:4:\"page\";s:4:\"page\";}s:14:\"sitename_title\";s:1:\"1\";}'),(1,'page','Page','page',2,'a:9:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:9:\"frontpage\";s:6:\"header\";a:0:{}s:8:\"defaults\";a:6:{s:6:\"header\";b:0;s:5:\"title\";b:0;s:6:\"fields\";b:0;s:8:\"group_by\";b:0;s:5:\"pager\";b:0;s:13:\"pager_options\";b:0;}s:5:\"title\";s:16:\"Related Products\";s:6:\"fields\";a:3:{s:3:\"nid\";a:22:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:0;}s:11:\"title_field\";a:35:{s:2:\"id\";s:11:\"title_field\";s:5:\"table\";s:22:\"field_data_title_field\";s:5:\"field\";s:11:\"title_field\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:3:\"min\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:9:\"entity_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;s:14:\"link_to_entity\";i:0;}s:4:\"view\";a:25:{s:2:\"id\";s:4:\"view\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"view\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:3:\"div\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:4:\"view\";s:15:\"product_display\";s:7:\"display\";s:5:\"block\";s:9:\"arguments\";s:6:\"[!nid]\";s:17:\"query_aggregation\";i:0;}}s:8:\"group_by\";i:1;s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"8\";s:6:\"offset\";s:1:\"0\";}}s:13:\"pager_options\";N;}'),(2,'block','Block','block',2,'a:3:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"fields\";a:2:{s:11:\"field_image\";a:34:{s:2:\"id\";s:11:\"field_image\";s:5:\"table\";s:22:\"field_data_field_image\";s:5:\"field\";s:11:\"field_image\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:1;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:20:\"image_link_formatter\";s:8:\"settings\";a:3:{s:11:\"image_style\";s:19:\"thumbnail_slideshow\";s:10:\"image_link\";s:0:\"\";s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:10:\"field_link\";a:34:{s:2:\"id\";s:10:\"field_link\";s:5:\"table\";s:21:\"field_data_field_link\";s:5:\"field\";s:10:\"field_link\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:13:\"[field_image]\";s:9:\"make_link\";i:1;s:4:\"path\";s:16:\"[field_link-url]\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:6:\"_blank\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"url\";s:4:\"type\";s:12:\"link_default\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}}s:8:\"defaults\";a:1:{s:6:\"fields\";b:0;}}'),(2,'default','Master','default',1,'a:14:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:6:{s:19:\"disable_sql_rewrite\";i:1;s:8:\"distinct\";i:0;s:13:\"pure_distinct\";i:0;s:5:\"slave\";i:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:1:{s:14:\"items_per_page\";s:1:\"5\";}}s:12:\"style_plugin\";s:37:\"views_bootstrap_carousel_plugin_style\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:1:{s:5:\"title\";a:8:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:4:\"trim\";i:0;s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:0;s:10:\"strip_tags\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:1;}}s:7:\"filters\";a:4:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:13:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:6:\"banner\";s:6:\"banner\";}s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:12:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}s:7:\"promote\";a:13:{s:2:\"id\";s:7:\"promote\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"promote\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}s:17:\"field_slide_value\";a:14:{s:2:\"id\";s:17:\"field_slide_value\";s:5:\"table\";s:22:\"field_data_field_slide\";s:5:\"field\";s:17:\"field_slide_value\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:2:\"or\";s:5:\"value\";a:1:{i:1;s:1:\"1\";}s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:12:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:17:\"reduce_duplicates\";i:0;}}s:5:\"sorts\";a:2:{s:6:\"weight\";a:9:{s:2:\"id\";s:6:\"weight\";s:5:\"table\";s:14:\"weight_weights\";s:5:\"field\";s:6:\"weight\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"order\";s:3:\"ASC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}}s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:5:\"title\";s:9:\"Slideshow\";s:13:\"relationships\";a:0:{}s:9:\"css_class\";s:9:\"slideshow\";s:13:\"style_options\";a:4:{s:8:\"interval\";s:4:\"7000\";s:10:\"navigation\";i:0;s:10:\"indicators\";i:1;s:5:\"pause\";i:0;}}'),(4,'default','Defaults','default',1,'a:16:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:5:\"title\";s:13:\"Shopping cart\";s:15:\"use_more_always\";b:0;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"style_plugin\";s:5:\"table\";s:13:\"style_options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";i:1;s:17:\"row_class_special\";i:1;s:8:\"override\";i:1;s:6:\"sticky\";i:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:7:\"columns\";a:9:{s:21:\"commerce_display_path\";s:21:\"commerce_display_path\";s:19:\"field_product_image\";s:19:\"field_product_image\";s:15:\"line_item_title\";s:15:\"line_item_title\";s:11:\"field_brand\";s:15:\"line_item_title\";s:19:\"commerce_unit_price\";s:19:\"commerce_unit_price\";s:13:\"edit_quantity\";s:13:\"edit_quantity\";s:11:\"edit_delete\";s:15:\"line_item_title\";s:14:\"commerce_total\";s:14:\"commerce_total\";s:14:\"commerce_stock\";s:13:\"edit_quantity\";}s:4:\"info\";a:9:{s:21:\"commerce_display_path\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:19:\"field_product_image\";a:3:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:15:\"line_item_title\";a:3:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:11:\"field_brand\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:19:\"commerce_unit_price\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:13:\"edit_quantity\";a:3:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:11:\"edit_delete\";a:3:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:14:\"commerce_total\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:14:\"commerce_stock\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}}s:7:\"default\";s:2:\"-1\";s:11:\"empty_table\";i:0;}s:6:\"footer\";a:2:{s:17:\"line_item_summary\";a:5:{s:2:\"id\";s:17:\"line_item_summary\";s:5:\"table\";s:18:\"commerce_line_item\";s:5:\"field\";s:17:\"line_item_summary\";s:5:\"label\";s:12:\"Cart summary\";s:4:\"info\";a:2:{s:8:\"quantity\";i:0;s:5:\"total\";s:5:\"total\";}}s:4:\"area\";a:11:{s:2:\"id\";s:4:\"area\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:5:\"empty\";i:0;s:7:\"content\";s:110:\"<a class=\"continue-shopping\" href=\"<?php echo base_path(); ?>\" title=\"Continue Shopping\">Continue Shopping</a>\";s:6:\"format\";s:8:\"php_code\";s:8:\"tokenize\";i:0;}}s:13:\"relationships\";a:3:{s:32:\"commerce_line_items_line_item_id\";a:4:{s:2:\"id\";s:32:\"commerce_line_items_line_item_id\";s:5:\"table\";s:30:\"field_data_commerce_line_items\";s:5:\"field\";s:32:\"commerce_line_items_line_item_id\";s:8:\"required\";b:1;}s:27:\"commerce_product_product_id\";a:8:{s:2:\"id\";s:27:\"commerce_product_product_id\";s:5:\"table\";s:27:\"field_data_commerce_product\";s:5:\"field\";s:27:\"commerce_product_product_id\";s:12:\"relationship\";s:32:\"commerce_line_items_line_item_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:39:\"Products referenced by commerce_product\";s:8:\"required\";i:0;}s:13:\"field_product\";a:8:{s:2:\"id\";s:13:\"field_product\";s:5:\"table\";s:16:\"commerce_product\";s:5:\"field\";s:13:\"field_product\";s:12:\"relationship\";s:27:\"commerce_product_product_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:44:\"Node referencing products from field_product\";s:8:\"required\";i:0;}}s:6:\"fields\";a:9:{s:21:\"commerce_display_path\";a:6:{s:2:\"id\";s:21:\"commerce_display_path\";s:5:\"table\";s:32:\"field_data_commerce_display_path\";s:5:\"field\";s:21:\"commerce_display_path\";s:12:\"relationship\";s:32:\"commerce_line_items_line_item_id\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;}s:19:\"field_product_image\";a:34:{s:2:\"id\";s:19:\"field_product_image\";s:5:\"table\";s:30:\"field_data_field_product_image\";s:5:\"field\";s:19:\"field_product_image\";s:12:\"relationship\";s:27:\"commerce_product_product_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:5:\"Image\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:3:{s:11:\"image_style\";s:15:\"thumbnail_60x80\";s:10:\"image_link\";s:0:\"\";s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";i:1;s:11:\"delta_limit\";s:1:\"1\";s:12:\"delta_offset\";s:1:\"0\";s:14:\"delta_reversed\";i:0;s:16:\"delta_first_last\";i:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:15:\"line_item_title\";a:21:{s:2:\"id\";s:15:\"line_item_title\";s:5:\"table\";s:18:\"commerce_line_item\";s:5:\"field\";s:15:\"line_item_title\";s:12:\"relationship\";s:32:\"commerce_line_items_line_item_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:7:\"Product\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:1;s:4:\"path\";s:23:\"[commerce_display_path]\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:18:\"cart-product-title\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:2:\"80\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;}s:11:\"field_brand\";a:34:{s:2:\"id\";s:11:\"field_brand\";s:5:\"table\";s:22:\"field_data_field_brand\";s:5:\"field\";s:11:\"field_brand\";s:12:\"relationship\";s:13:\"field_product\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"tid\";s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:18:\"cart-product-brand\";}s:12:\"group_column\";s:3:\"tid\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:19:\"commerce_unit_price\";a:8:{s:2:\"id\";s:19:\"commerce_unit_price\";s:5:\"table\";s:30:\"field_data_commerce_unit_price\";s:5:\"field\";s:19:\"commerce_unit_price\";s:12:\"relationship\";s:32:\"commerce_line_items_line_item_id\";s:5:\"label\";s:5:\"Price\";s:13:\"element_class\";s:5:\"price\";s:17:\"click_sort_column\";s:6:\"amount\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";}s:13:\"edit_quantity\";a:7:{s:2:\"id\";s:13:\"edit_quantity\";s:5:\"table\";s:18:\"commerce_line_item\";s:5:\"field\";s:13:\"edit_quantity\";s:12:\"relationship\";s:32:\"commerce_line_items_line_item_id\";s:5:\"label\";s:8:\"Quantity\";s:5:\"alter\";a:2:{s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;}s:19:\"element_label_colon\";b:0;}s:11:\"edit_delete\";a:5:{s:2:\"id\";s:11:\"edit_delete\";s:5:\"table\";s:18:\"commerce_line_item\";s:5:\"field\";s:11:\"edit_delete\";s:12:\"relationship\";s:32:\"commerce_line_items_line_item_id\";s:5:\"label\";s:6:\"Remove\";}s:14:\"commerce_total\";a:7:{s:2:\"id\";s:14:\"commerce_total\";s:5:\"table\";s:25:\"field_data_commerce_total\";s:5:\"field\";s:14:\"commerce_total\";s:12:\"relationship\";s:32:\"commerce_line_items_line_item_id\";s:13:\"element_class\";s:5:\"price\";s:17:\"click_sort_column\";s:6:\"amount\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";}s:14:\"commerce_stock\";a:34:{s:2:\"id\";s:14:\"commerce_stock\";s:5:\"table\";s:25:\"field_data_commerce_stock\";s:5:\"field\";s:14:\"commerce_stock\";s:12:\"relationship\";s:27:\"commerce_product_product_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:4:\"span\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:5:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";s:1:\"0\";s:13:\"prefix_suffix\";i:1;s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}}s:5:\"sorts\";a:1:{s:12:\"line_item_id\";a:4:{s:2:\"id\";s:12:\"line_item_id\";s:5:\"table\";s:18:\"commerce_line_item\";s:5:\"field\";s:12:\"line_item_id\";s:12:\"relationship\";s:32:\"commerce_line_items_line_item_id\";}}s:9:\"arguments\";a:1:{s:8:\"order_id\";a:7:{s:2:\"id\";s:8:\"order_id\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:8:\"order_id\";s:14:\"default_action\";s:5:\"empty\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:2:{s:17:\"number_of_records\";s:1:\"0\";s:6:\"format\";s:15:\"default_summary\";}s:15:\"summary_options\";a:1:{s:14:\"items_per_page\";s:2:\"25\";}}}s:7:\"filters\";a:1:{s:22:\"product_line_item_type\";a:6:{s:2:\"id\";s:22:\"product_line_item_type\";s:5:\"table\";s:18:\"commerce_line_item\";s:5:\"field\";s:22:\"product_line_item_type\";s:12:\"relationship\";s:32:\"commerce_line_items_line_item_id\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:0;}}s:9:\"css_class\";s:13:\"shopping-cart\";}'),(5,'block','Banner block with 3 item','block',2,'a:6:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"field\";a:1:{s:5:\"title\";a:1:{s:12:\"link_to_node\";i:1;}}s:9:\"css_class\";s:14:\"advertise-list\";s:8:\"defaults\";a:2:{s:9:\"css_class\";b:0;s:5:\"title\";b:0;}s:5:\"title\";s:24:\"Banner block with 3 item\";s:19:\"display_description\";s:0:\"\";}'),(5,'block_1','Banner block with 1 item','block',3,'a:11:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"field\";a:1:{s:5:\"title\";a:1:{s:12:\"link_to_node\";i:1;}}s:7:\"filters\";a:5:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:6:\"banner\";s:6:\"banner\";}}s:7:\"promote\";a:13:{s:2:\"id\";s:7:\"promote\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"promote\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}s:6:\"sticky\";a:13:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"sticky\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"0\";s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}s:17:\"field_slide_value\";a:14:{s:2:\"id\";s:17:\"field_slide_value\";s:5:\"table\";s:22:\"field_data_field_slide\";s:5:\"field\";s:17:\"field_slide_value\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:3:\"not\";s:5:\"value\";a:1:{i:1;s:1:\"1\";}s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:12:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:17:\"reduce_duplicates\";i:0;}}s:8:\"defaults\";a:7:{s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;s:5:\"pager\";b:0;s:13:\"pager_options\";b:0;s:5:\"sorts\";b:0;s:9:\"css_class\";b:0;s:5:\"title\";b:0;}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"1\";s:6:\"offset\";s:0:\"\";}}s:13:\"pager_options\";N;s:5:\"sorts\";a:1:{s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:9:\"css_class\";s:14:\"advertise-list\";s:19:\"display_description\";s:0:\"\";s:5:\"title\";s:24:\"Banner block with 2 item\";}'),(5,'block_2','Banner block with 2 item','block',4,'a:8:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"field\";a:1:{s:5:\"title\";a:1:{s:12:\"link_to_node\";i:1;}}s:9:\"css_class\";s:14:\"advertise-list\";s:8:\"defaults\";a:4:{s:9:\"css_class\";b:0;s:5:\"pager\";b:0;s:13:\"pager_options\";b:0;s:5:\"title\";b:0;}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"2\";s:6:\"offset\";s:0:\"\";}}s:13:\"pager_options\";N;s:5:\"title\";s:24:\"Banner block with 2 item\";s:19:\"display_description\";s:0:\"\";}'),(5,'block_3','Banner block with slideshow','block',5,'a:16:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"field\";a:1:{s:5:\"title\";a:1:{s:12:\"link_to_node\";i:1;}}s:9:\"css_class\";s:29:\"advertise-list slideshow-cate\";s:8:\"defaults\";a:12:{s:9:\"css_class\";b:0;s:5:\"pager\";b:0;s:13:\"pager_options\";b:0;s:5:\"title\";b:0;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;s:6:\"fields\";b:0;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:9:\"arguments\";b:0;}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"7\";s:6:\"offset\";s:0:\"\";}}s:13:\"pager_options\";N;s:5:\"title\";s:27:\"Banner block with slideshow\";s:19:\"display_description\";s:0:\"\";s:7:\"filters\";a:3:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:6:\"banner\";s:6:\"banner\";}}s:17:\"field_slide_value\";a:14:{s:2:\"id\";s:17:\"field_slide_value\";s:5:\"table\";s:22:\"field_data_field_slide\";s:5:\"field\";s:17:\"field_slide_value\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:2:\"or\";s:5:\"value\";a:1:{i:1;s:1:\"1\";}s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:12:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:17:\"reduce_duplicates\";i:0;}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:6:\"fields\";a:2:{s:11:\"field_image\";a:34:{s:2:\"id\";s:11:\"field_image\";s:5:\"table\";s:22:\"field_data_field_image\";s:5:\"field\";s:11:\"field_image\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:3:{s:11:\"image_style\";s:17:\"thumbnail_555x308\";s:10:\"image_link\";s:0:\"\";s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:10:\"field_link\";a:34:{s:2:\"id\";s:10:\"field_link\";s:5:\"table\";s:21:\"field_data_field_link\";s:5:\"field\";s:10:\"field_link\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:13:\"[field_image]\";s:9:\"make_link\";i:1;s:4:\"path\";s:16:\"[field_link-url]\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:6:\"_blank\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"url\";s:4:\"type\";s:12:\"link_default\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}}s:12:\"style_plugin\";s:37:\"views_bootstrap_carousel_plugin_style\";s:13:\"style_options\";a:4:{s:8:\"interval\";s:4:\"7000\";s:10:\"navigation\";i:0;s:10:\"indicators\";i:1;s:5:\"pause\";i:0;}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:9:\"arguments\";a:2:{s:19:\"term_node_tid_depth\";a:24:{s:2:\"id\";s:19:\"term_node_tid_depth\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:19:\"term_node_tid_depth\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";i:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";i:0;s:5:\"title\";s:0:\"\";s:17:\"breadcrumb_enable\";i:0;s:10:\"breadcrumb\";s:0:\"\";s:21:\"default_argument_type\";s:12:\"taxonomy_tid\";s:24:\"default_argument_options\";a:5:{s:9:\"term_page\";s:1:\"1\";s:4:\"node\";s:1:\"1\";s:12:\"vocabularies\";a:1:{s:10:\"categories\";s:10:\"categories\";}s:6:\"anyall\";s:1:\",\";s:5:\"limit\";i:0;}s:25:\"default_argument_skip_url\";i:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";s:1:\"1\";s:14:\"items_per_page\";s:2:\"25\";s:8:\"override\";i:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";s:1:\"0\";s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";i:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:5:\"depth\";s:1:\"9\";s:12:\"break_phrase\";i:0;s:14:\"set_breadcrumb\";i:0;s:22:\"use_taxonomy_term_path\";i:0;}s:28:\"term_node_tid_depth_modifier\";a:20:{s:2:\"id\";s:28:\"term_node_tid_depth_modifier\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:28:\"term_node_tid_depth_modifier\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:14:\"default_action\";s:6:\"ignore\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:0;s:5:\"title\";s:0:\"\";s:17:\"breadcrumb_enable\";b:0;s:10:\"breadcrumb\";s:0:\"\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";N;s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";N;s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}}}}'),(5,'block_4','Banner block with slideshow for brand','block',6,'a:16:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"field\";a:1:{s:5:\"title\";a:1:{s:12:\"link_to_node\";i:1;}}s:9:\"css_class\";s:29:\"advertise-list slideshow-cate\";s:8:\"defaults\";a:12:{s:9:\"css_class\";b:0;s:5:\"pager\";b:0;s:13:\"pager_options\";b:0;s:5:\"title\";b:0;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;s:6:\"fields\";b:0;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:9:\"arguments\";b:0;}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"7\";s:6:\"offset\";s:0:\"\";}}s:13:\"pager_options\";N;s:5:\"title\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:7:\"filters\";a:4:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:6:\"banner\";s:6:\"banner\";}}s:17:\"field_slide_value\";a:14:{s:2:\"id\";s:17:\"field_slide_value\";s:5:\"table\";s:22:\"field_data_field_slide\";s:5:\"field\";s:17:\"field_slide_value\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:2:\"or\";s:5:\"value\";a:1:{i:1;s:1:\"1\";}s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:12:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:17:\"reduce_duplicates\";i:0;}s:3:\"tid\";a:19:{s:2:\"id\";s:3:\"tid\";s:5:\"table\";s:14:\"taxonomy_index\";s:5:\"field\";s:3:\"tid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:2:\"or\";s:5:\"value\";a:41:{i:74;s:2:\"74\";i:10;s:2:\"10\";i:13;s:2:\"13\";i:116;s:3:\"116\";i:83;s:2:\"83\";i:102;s:3:\"102\";i:98;s:2:\"98\";i:117;s:3:\"117\";i:111;s:3:\"111\";i:115;s:3:\"115\";i:112;s:3:\"112\";i:94;s:2:\"94\";i:12;s:2:\"12\";i:81;s:2:\"81\";i:101;s:3:\"101\";i:95;s:2:\"95\";i:87;s:2:\"87\";i:97;s:2:\"97\";i:88;s:2:\"88\";i:75;s:2:\"75\";i:93;s:2:\"93\";i:86;s:2:\"86\";i:92;s:2:\"92\";i:103;s:3:\"103\";i:14;s:2:\"14\";i:82;s:2:\"82\";i:90;s:2:\"90\";i:96;s:2:\"96\";i:11;s:2:\"11\";i:113;s:3:\"113\";i:84;s:2:\"84\";i:85;s:2:\"85\";i:91;s:2:\"91\";i:89;s:2:\"89\";i:99;s:2:\"99\";i:79;s:2:\"79\";i:78;s:2:\"78\";i:76;s:2:\"76\";i:100;s:3:\"100\";i:114;s:3:\"114\";i:80;s:2:\"80\";}s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:12:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:17:\"reduce_duplicates\";i:0;s:4:\"type\";s:6:\"select\";s:5:\"limit\";b:1;s:10:\"vocabulary\";s:6:\"brands\";s:9:\"hierarchy\";i:0;s:13:\"error_message\";b:1;}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:6:\"fields\";a:2:{s:11:\"field_image\";a:34:{s:2:\"id\";s:11:\"field_image\";s:5:\"table\";s:22:\"field_data_field_image\";s:5:\"field\";s:11:\"field_image\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:3:{s:11:\"image_style\";s:17:\"thumbnail_555x308\";s:10:\"image_link\";s:0:\"\";s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:10:\"field_link\";a:34:{s:2:\"id\";s:10:\"field_link\";s:5:\"table\";s:21:\"field_data_field_link\";s:5:\"field\";s:10:\"field_link\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:13:\"[field_image]\";s:9:\"make_link\";i:1;s:4:\"path\";s:16:\"[field_link-url]\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:6:\"_blank\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"url\";s:4:\"type\";s:12:\"link_default\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}}s:12:\"style_plugin\";s:37:\"views_bootstrap_carousel_plugin_style\";s:13:\"style_options\";a:4:{s:8:\"interval\";s:4:\"7000\";s:10:\"navigation\";i:0;s:10:\"indicators\";i:1;s:5:\"pause\";i:0;}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:9:\"arguments\";a:0:{}}'),(5,'block_5','Banner block with slideshow for all categories','block',7,'a:16:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"field\";a:1:{s:5:\"title\";a:1:{s:12:\"link_to_node\";i:1;}}s:9:\"css_class\";s:29:\"advertise-list slideshow-cate\";s:8:\"defaults\";a:12:{s:9:\"css_class\";b:0;s:5:\"pager\";b:0;s:13:\"pager_options\";b:0;s:5:\"title\";b:0;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;s:6:\"fields\";b:0;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:9:\"arguments\";b:0;}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"5\";s:6:\"offset\";s:0:\"\";}}s:13:\"pager_options\";N;s:5:\"title\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:7:\"filters\";a:3:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:6:\"banner\";s:6:\"banner\";}}s:17:\"field_slide_value\";a:14:{s:2:\"id\";s:17:\"field_slide_value\";s:5:\"table\";s:22:\"field_data_field_slide\";s:5:\"field\";s:17:\"field_slide_value\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:2:\"or\";s:5:\"value\";a:1:{i:1;s:1:\"1\";}s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:12:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:17:\"reduce_duplicates\";i:0;}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:6:\"fields\";a:2:{s:11:\"field_image\";a:34:{s:2:\"id\";s:11:\"field_image\";s:5:\"table\";s:22:\"field_data_field_image\";s:5:\"field\";s:11:\"field_image\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:3:{s:11:\"image_style\";s:17:\"thumbnail_555x308\";s:10:\"image_link\";s:0:\"\";s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:10:\"field_link\";a:34:{s:2:\"id\";s:10:\"field_link\";s:5:\"table\";s:21:\"field_data_field_link\";s:5:\"field\";s:10:\"field_link\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:13:\"[field_image]\";s:9:\"make_link\";i:1;s:4:\"path\";s:16:\"[field_link-url]\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:6:\"_blank\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"url\";s:4:\"type\";s:12:\"link_default\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}}s:12:\"style_plugin\";s:37:\"views_bootstrap_carousel_plugin_style\";s:13:\"style_options\";a:4:{s:8:\"interval\";s:4:\"7000\";s:10:\"navigation\";i:0;s:10:\"indicators\";i:1;s:5:\"pause\";i:0;}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:9:\"arguments\";a:0:{}}'),(5,'default','Master','default',1,'a:12:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"3\";s:6:\"offset\";s:0:\"\";}}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:2:{s:11:\"field_image\";a:34:{s:2:\"id\";s:11:\"field_image\";s:5:\"table\";s:22:\"field_data_field_image\";s:5:\"field\";s:11:\"field_image\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:3:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:10:\"field_link\";a:34:{s:2:\"id\";s:10:\"field_link\";s:5:\"table\";s:21:\"field_data_field_link\";s:5:\"field\";s:10:\"field_link\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:13:\"[field_image]\";s:9:\"make_link\";i:1;s:4:\"path\";s:16:\"[field_link-url]\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:6:\"_blank\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"url\";s:4:\"type\";s:12:\"link_default\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}}s:7:\"filters\";a:5:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:6:\"banner\";s:6:\"banner\";}}s:7:\"promote\";a:13:{s:2:\"id\";s:7:\"promote\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"promote\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}s:6:\"sticky\";a:13:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"sticky\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}s:17:\"field_slide_value\";a:14:{s:2:\"id\";s:17:\"field_slide_value\";s:5:\"table\";s:22:\"field_data_field_slide\";s:5:\"field\";s:17:\"field_slide_value\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:3:\"not\";s:5:\"value\";a:1:{i:1;s:1:\"1\";}s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:12:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:17:\"reduce_duplicates\";i:0;}}s:5:\"sorts\";a:2:{s:6:\"weight\";a:9:{s:2:\"id\";s:6:\"weight\";s:5:\"table\";s:14:\"weight_weights\";s:5:\"field\";s:6:\"weight\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"order\";s:3:\"ASC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}}s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:5:\"title\";s:14:\"Banner block 1\";s:9:\"arguments\";a:0:{}}'),(6,'default','Defaults','default',1,'a:16:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:5:\"title\";s:13:\"Shopping cart\";s:15:\"use_more_always\";b:0;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:4:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";i:1;s:17:\"row_class_special\";i:1;}s:6:\"footer\";a:1:{s:17:\"line_item_summary\";a:10:{s:2:\"id\";s:17:\"line_item_summary\";s:5:\"table\";s:18:\"commerce_line_item\";s:5:\"field\";s:17:\"line_item_summary\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:5:\"empty\";i:0;s:5:\"links\";a:2:{s:9:\"view_cart\";s:9:\"view_cart\";s:8:\"checkout\";s:8:\"checkout\";}s:4:\"info\";a:2:{s:8:\"quantity\";i:0;s:5:\"total\";i:0;}}}s:13:\"relationships\";a:2:{s:32:\"commerce_line_items_line_item_id\";a:4:{s:2:\"id\";s:32:\"commerce_line_items_line_item_id\";s:5:\"table\";s:30:\"field_data_commerce_line_items\";s:5:\"field\";s:32:\"commerce_line_items_line_item_id\";s:8:\"required\";b:1;}s:27:\"commerce_product_product_id\";a:8:{s:2:\"id\";s:27:\"commerce_product_product_id\";s:5:\"table\";s:27:\"field_data_commerce_product\";s:5:\"field\";s:27:\"commerce_product_product_id\";s:12:\"relationship\";s:32:\"commerce_line_items_line_item_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:39:\"Products referenced by commerce_product\";s:8:\"required\";i:0;}}s:6:\"fields\";a:3:{s:21:\"commerce_display_path\";a:6:{s:2:\"id\";s:21:\"commerce_display_path\";s:5:\"table\";s:32:\"field_data_commerce_display_path\";s:5:\"field\";s:21:\"commerce_display_path\";s:12:\"relationship\";s:32:\"commerce_line_items_line_item_id\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;}s:19:\"field_product_image\";a:34:{s:2:\"id\";s:19:\"field_product_image\";s:5:\"table\";s:30:\"field_data_field_product_image\";s:5:\"field\";s:19:\"field_product_image\";s:12:\"relationship\";s:27:\"commerce_product_product_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:1;s:4:\"path\";s:23:\"[commerce_display_path]\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:3:{s:11:\"image_style\";s:9:\"thumbnail\";s:10:\"image_link\";s:0:\"\";s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";i:1;s:11:\"delta_limit\";s:1:\"1\";s:12:\"delta_offset\";s:1:\"0\";s:14:\"delta_reversed\";i:0;s:16:\"delta_first_last\";i:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:15:\"line_item_title\";a:6:{s:2:\"id\";s:15:\"line_item_title\";s:5:\"table\";s:18:\"commerce_line_item\";s:5:\"field\";s:15:\"line_item_title\";s:12:\"relationship\";s:32:\"commerce_line_items_line_item_id\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:2:{s:9:\"make_link\";b:1;s:4:\"path\";s:23:\"[commerce_display_path]\";}}}s:5:\"sorts\";a:1:{s:12:\"line_item_id\";a:4:{s:2:\"id\";s:12:\"line_item_id\";s:5:\"table\";s:18:\"commerce_line_item\";s:5:\"field\";s:12:\"line_item_id\";s:12:\"relationship\";s:32:\"commerce_line_items_line_item_id\";}}s:9:\"arguments\";a:1:{s:8:\"order_id\";a:6:{s:2:\"id\";s:8:\"order_id\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:8:\"order_id\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:2:{s:17:\"number_of_records\";s:1:\"0\";s:6:\"format\";s:15:\"default_summary\";}s:15:\"summary_options\";a:1:{s:14:\"items_per_page\";s:2:\"25\";}}}s:7:\"filters\";a:1:{s:22:\"product_line_item_type\";a:5:{s:2:\"id\";s:22:\"product_line_item_type\";s:5:\"table\";s:18:\"commerce_line_item\";s:5:\"field\";s:22:\"product_line_item_type\";s:12:\"relationship\";s:32:\"commerce_line_items_line_item_id\";s:5:\"value\";s:1:\"1\";}}s:6:\"header\";a:1:{s:17:\"line_item_summary\";a:10:{s:2:\"id\";s:17:\"line_item_summary\";s:5:\"table\";s:18:\"commerce_line_item\";s:5:\"field\";s:17:\"line_item_summary\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:5:\"empty\";i:0;s:5:\"links\";a:2:{s:9:\"view_cart\";i:0;s:8:\"checkout\";i:0;}s:4:\"info\";a:2:{s:8:\"quantity\";s:8:\"quantity\";s:5:\"total\";i:0;}}}}'),(7,'block','Product Teaser','block',2,'a:7:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"field\";a:1:{s:5:\"title\";a:1:{s:12:\"link_to_node\";i:1;}}s:19:\"display_description\";s:0:\"\";s:9:\"arguments\";a:1:{s:3:\"nid\";a:22:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:14:\"default_action\";s:6:\"ignore\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";i:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";i:0;s:5:\"title\";s:0:\"\";s:17:\"breadcrumb_enable\";i:0;s:10:\"breadcrumb\";s:0:\"\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";i:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";s:1:\"1\";s:14:\"items_per_page\";s:2:\"25\";s:8:\"override\";i:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";s:1:\"0\";s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";i:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";i:0;s:3:\"not\";i:0;}}s:8:\"defaults\";a:3:{s:9:\"arguments\";b:0;s:6:\"fields\";b:0;s:9:\"css_class\";b:0;}s:6:\"fields\";a:10:{s:4:\"path\";a:22:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"path\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:8:\"absolute\";i:0;}s:19:\"field_product_image\";a:34:{s:2:\"id\";s:19:\"field_product_image\";s:5:\"table\";s:30:\"field_data_field_product_image\";s:5:\"field\";s:19:\"field_product_image\";s:12:\"relationship\";s:24:\"field_product_product_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:78:\"<a href=\"[path]\" title=\"[field_product_image-title]\">[field_product_image]</a>\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:3:{s:11:\"image_style\";s:22:\"thumbnail_product_grid\";s:10:\"image_link\";s:0:\"\";s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";i:1;s:11:\"delta_limit\";s:1:\"1\";s:12:\"delta_offset\";s:1:\"0\";s:14:\"delta_reversed\";i:0;s:16:\"delta_first_last\";i:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:8:\"fieldset\";a:23:{s:2:\"id\";s:8:\"fieldset\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:8:\"fieldset\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:8:\"Fieldset\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"children\";a:3:{i:0;s:5:\"title\";i:1;s:11:\"field_brand\";i:2;s:12:\"field_review\";}s:8:\"fieldset\";a:5:{s:4:\"type\";s:3:\"div\";s:7:\"classes\";s:0:\"\";s:2:\"id\";s:0:\"\";s:11:\"collapsible\";i:0;s:9:\"collapsed\";i:0;}}s:5:\"title\";a:22:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:2:\"38\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:1;}s:11:\"field_brand\";a:34:{s:2:\"id\";s:11:\"field_brand\";s:5:\"table\";s:22:\"field_data_field_brand\";s:5:\"field\";s:11:\"field_brand\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:29:\"<span>by </span>[field_brand]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"tid\";s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:3:\"tid\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:12:\"field_review\";a:34:{s:2:\"id\";s:12:\"field_review\";s:5:\"table\";s:23:\"field_data_field_review\";s:5:\"field\";s:12:\"field_review\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:6:\"rating\";s:4:\"type\";s:26:\"fivestar_formatter_default\";s:8:\"settings\";a:5:{s:6:\"widget\";a:1:{s:15:\"fivestar_widget\";s:7:\"default\";}s:6:\"expose\";i:0;s:5:\"style\";s:7:\"average\";s:4:\"text\";s:7:\"average\";s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:10:\"fieldset_1\";a:23:{s:2:\"id\";s:10:\"fieldset_1\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:8:\"fieldset\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:8:\"Fieldset\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"children\";a:3:{i:0;s:15:\"field_old_price\";i:1;s:25:\"field_discount_percentage\";i:2;s:14:\"commerce_price\";}s:8:\"fieldset\";a:5:{s:4:\"type\";s:3:\"div\";s:7:\"classes\";s:6:\"prices\";s:2:\"id\";s:0:\"\";s:11:\"collapsible\";i:0;s:9:\"collapsed\";i:0;}}s:15:\"field_old_price\";a:34:{s:2:\"id\";s:15:\"field_old_price\";s:5:\"table\";s:26:\"field_data_field_old_price\";s:5:\"field\";s:15:\"field_old_price\";s:12:\"relationship\";s:24:\"field_product_product_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:6:\"amount\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:25:\"field_discount_percentage\";a:34:{s:2:\"id\";s:25:\"field_discount_percentage\";s:5:\"table\";s:36:\"field_data_field_discount_percentage\";s:5:\"field\";s:25:\"field_discount_percentage\";s:12:\"relationship\";s:24:\"field_product_product_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:5:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";s:1:\"0\";s:13:\"prefix_suffix\";i:1;s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:14:\"commerce_price\";a:34:{s:2:\"id\";s:14:\"commerce_price\";s:5:\"table\";s:25:\"field_data_commerce_price\";s:5:\"field\";s:14:\"commerce_price\";s:12:\"relationship\";s:24:\"field_product_product_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:6:\"amount\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:1:\"0\";s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}}s:9:\"css_class\";s:21:\"products-display-list\";}'),(7,'block_1','Recommended for you','block',5,'a:17:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:19:\"display_description\";s:0:\"\";s:5:\"title\";s:19:\"Recommended for you\";s:8:\"defaults\";a:14:{s:5:\"title\";b:0;s:5:\"pager\";b:0;s:13:\"pager_options\";b:0;s:6:\"fields\";b:0;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;s:5:\"sorts\";b:0;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:9:\"css_class\";b:0;s:13:\"relationships\";b:0;s:8:\"group_by\";b:0;}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"8\";s:6:\"offset\";s:1:\"0\";}}s:13:\"pager_options\";N;s:6:\"fields\";a:2:{s:3:\"nid\";a:22:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:0;}s:4:\"view\";a:25:{s:2:\"id\";s:4:\"view\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"view\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:3:\"div\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:4:\"view\";s:15:\"product_display\";s:7:\"display\";s:5:\"block\";s:9:\"arguments\";s:6:\"[!nid]\";s:17:\"query_aggregation\";i:0;}}s:7:\"filters\";a:2:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:5:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:7:\"product\";s:7:\"product\";}s:5:\"group\";i:1;}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:12:\"style_plugin\";s:9:\"jcarousel\";s:13:\"style_options\";a:12:{s:4:\"wrap\";s:1:\"0\";s:4:\"skin\";s:7:\"default\";s:7:\"visible\";s:0:\"\";s:6:\"scroll\";s:1:\"1\";s:4:\"auto\";s:1:\"0\";s:10:\"navigation\";s:0:\"\";s:4:\"ajax\";i:0;s:9:\"animation\";s:0:\"\";s:6:\"easing\";s:0:\"\";s:5:\"start\";s:1:\"1\";s:9:\"autoPause\";i:1;s:8:\"vertical\";i:0;}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:9:\"css_class\";s:32:\"products-grid products-recommend\";s:13:\"relationships\";a:1:{s:24:\"field_product_product_id\";a:8:{s:2:\"id\";s:24:\"field_product_product_id\";s:5:\"table\";s:24:\"field_data_field_product\";s:5:\"field\";s:24:\"field_product_product_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:36:\"Products referenced by field_product\";s:8:\"required\";i:0;}}s:8:\"group_by\";i:1;}'),(7,'block_2','Recently Viewed','block',3,'a:17:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:19:\"display_description\";s:0:\"\";s:5:\"title\";s:26:\"Your Recently Viewed Items\";s:8:\"defaults\";a:14:{s:5:\"title\";b:0;s:5:\"pager\";b:0;s:13:\"pager_options\";b:0;s:6:\"fields\";b:0;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;s:5:\"sorts\";b:0;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:9:\"css_class\";b:0;s:13:\"relationships\";b:0;s:8:\"group_by\";b:0;}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:2:\"18\";s:6:\"offset\";s:1:\"0\";}}s:13:\"pager_options\";N;s:6:\"fields\";a:2:{s:4:\"path\";a:22:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"path\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:8:\"absolute\";i:0;}s:19:\"field_product_image\";a:34:{s:2:\"id\";s:19:\"field_product_image\";s:5:\"table\";s:30:\"field_data_field_product_image\";s:5:\"field\";s:19:\"field_product_image\";s:12:\"relationship\";s:24:\"field_product_product_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:78:\"<a href=\"[path]\" title=\"[field_product_image-title]\">[field_product_image]</a>\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:3:{s:11:\"image_style\";s:9:\"thumbnail\";s:10:\"image_link\";s:0:\"\";s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:9:\"entity_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";i:1;s:11:\"delta_limit\";s:1:\"1\";s:12:\"delta_offset\";s:1:\"0\";s:14:\"delta_reversed\";i:0;s:16:\"delta_first_last\";i:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}}s:7:\"filters\";a:4:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:5:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:7:\"product\";s:7:\"product\";}s:5:\"group\";i:1;}s:6:\"type_1\";a:13:{s:2:\"id\";s:6:\"type_1\";s:5:\"table\";s:13:\"recently_read\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:11:\"node_rr_nid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:4:\"node\";s:4:\"node\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:12:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}s:7:\"current\";a:13:{s:2:\"id\";s:7:\"current\";s:5:\"table\";s:13:\"recently_read\";s:5:\"field\";s:7:\"current\";s:12:\"relationship\";s:11:\"node_rr_nid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:5:\"sorts\";a:2:{s:9:\"timestamp\";a:10:{s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:13:\"recently_read\";s:5:\"field\";s:9:\"timestamp\";s:12:\"relationship\";s:11:\"node_rr_nid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";}s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:12:\"style_plugin\";s:4:\"list\";s:13:\"style_options\";a:7:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";i:1;s:17:\"row_class_special\";i:1;s:4:\"type\";s:2:\"ul\";s:13:\"wrapper_class\";s:9:\"item-list\";s:5:\"class\";s:0:\"\";}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:9:\"css_class\";s:13:\"recently-view\";s:13:\"relationships\";a:2:{s:24:\"field_product_product_id\";a:8:{s:2:\"id\";s:24:\"field_product_product_id\";s:5:\"table\";s:24:\"field_data_field_product\";s:5:\"field\";s:24:\"field_product_product_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:36:\"Products referenced by field_product\";s:8:\"required\";i:0;}s:11:\"node_rr_nid\";a:8:{s:2:\"id\";s:11:\"node_rr_nid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:11:\"node_rr_nid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:13:\"Recently Read\";s:8:\"required\";i:0;}}s:8:\"group_by\";i:1;}'),(7,'block_3','Best sellers','block',4,'a:8:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:19:\"display_description\";s:0:\"\";s:5:\"title\";s:12:\"Best sellers\";s:8:\"defaults\";a:5:{s:5:\"title\";b:0;s:6:\"fields\";b:0;s:5:\"pager\";b:0;s:13:\"pager_options\";b:0;s:9:\"css_class\";b:0;}s:6:\"fields\";a:6:{s:4:\"path\";a:22:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"path\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:8:\"absolute\";i:0;}s:19:\"field_product_image\";a:34:{s:2:\"id\";s:19:\"field_product_image\";s:5:\"table\";s:30:\"field_data_field_product_image\";s:5:\"field\";s:19:\"field_product_image\";s:12:\"relationship\";s:24:\"field_product_product_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:78:\"<a href=\"[path]\" title=\"[field_product_image-title]\">[field_product_image]</a>\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:3:{s:11:\"image_style\";s:6:\"medium\";s:10:\"image_link\";s:0:\"\";s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";i:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";s:1:\"0\";s:14:\"delta_reversed\";i:0;s:16:\"delta_first_last\";i:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:8:\"fieldset\";a:23:{s:2:\"id\";s:8:\"fieldset\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:8:\"fieldset\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:8:\"Fieldset\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"children\";a:4:{i:0;s:5:\"title\";i:1;s:11:\"field_brand\";i:2;s:12:\"field_review\";i:3;s:14:\"commerce_price\";}s:8:\"fieldset\";a:5:{s:4:\"type\";s:3:\"div\";s:7:\"classes\";s:0:\"\";s:2:\"id\";s:0:\"\";s:11:\"collapsible\";i:0;s:9:\"collapsed\";i:0;}}s:5:\"title\";a:22:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:2:\"30\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:1;}s:11:\"field_brand\";a:34:{s:2:\"id\";s:11:\"field_brand\";s:5:\"table\";s:22:\"field_data_field_brand\";s:5:\"field\";s:11:\"field_brand\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"tid\";s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:3:\"tid\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:14:\"commerce_price\";a:34:{s:2:\"id\";s:14:\"commerce_price\";s:5:\"table\";s:25:\"field_data_commerce_price\";s:5:\"field\";s:14:\"commerce_price\";s:12:\"relationship\";s:24:\"field_product_product_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:6:\"amount\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:1:\"0\";s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"4\";s:6:\"offset\";s:1:\"0\";}}s:13:\"pager_options\";N;s:9:\"css_class\";s:13:\"products-list\";}'),(7,'default','Master','default',1,'a:12:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:1:{s:14:\"items_per_page\";s:1:\"1\";}}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:6:{s:4:\"path\";a:22:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"path\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:8:\"absolute\";i:0;}s:19:\"field_product_image\";a:34:{s:2:\"id\";s:19:\"field_product_image\";s:5:\"table\";s:30:\"field_data_field_product_image\";s:5:\"field\";s:19:\"field_product_image\";s:12:\"relationship\";s:24:\"field_product_product_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:78:\"<a href=\"[path]\" title=\"[field_product_image-title]\">[field_product_image]</a>\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:3:{s:11:\"image_style\";s:22:\"thumbnail_product_grid\";s:10:\"image_link\";s:0:\"\";s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";i:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";s:1:\"0\";s:14:\"delta_reversed\";i:0;s:16:\"delta_first_last\";i:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:5:\"title\";a:22:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:2:\"40\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:1;}s:11:\"field_brand\";a:34:{s:2:\"id\";s:11:\"field_brand\";s:5:\"table\";s:22:\"field_data_field_brand\";s:5:\"field\";s:11:\"field_brand\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"tid\";s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:3:\"tid\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:12:\"field_review\";a:34:{s:2:\"id\";s:12:\"field_review\";s:5:\"table\";s:23:\"field_data_field_review\";s:5:\"field\";s:12:\"field_review\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:6:\"rating\";s:4:\"type\";s:26:\"fivestar_formatter_default\";s:8:\"settings\";a:5:{s:6:\"widget\";a:1:{s:15:\"fivestar_widget\";s:7:\"default\";}s:6:\"expose\";i:0;s:5:\"style\";s:7:\"average\";s:4:\"text\";s:7:\"average\";s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:14:\"commerce_price\";a:34:{s:2:\"id\";s:14:\"commerce_price\";s:5:\"table\";s:25:\"field_data_commerce_price\";s:5:\"field\";s:14:\"commerce_price\";s:12:\"relationship\";s:24:\"field_product_product_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:6:\"amount\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:1:\"0\";s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}}s:7:\"filters\";a:2:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:7:\"product\";s:7:\"product\";}}}s:5:\"sorts\";a:1:{s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:5:\"title\";s:14:\"Product Teaser\";s:13:\"relationships\";a:1:{s:24:\"field_product_product_id\";a:8:{s:2:\"id\";s:24:\"field_product_product_id\";s:5:\"table\";s:24:\"field_data_field_product\";s:5:\"field\";s:24:\"field_product_product_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:36:\"Products referenced by field_product\";s:8:\"required\";i:0;}}}'),(8,'block_1','Today\'s Deal','block',3,'a:11:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"4\";s:6:\"offset\";s:1:\"0\";}}s:8:\"defaults\";a:8:{s:5:\"pager\";b:0;s:13:\"pager_options\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";b:0;s:9:\"css_class\";b:0;s:6:\"fields\";b:0;s:5:\"sorts\";b:0;}s:13:\"pager_options\";N;s:8:\"use_more\";i:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:9:\"View more\";s:19:\"display_description\";s:0:\"\";s:9:\"css_class\";s:13:\"products-grid\";s:6:\"fields\";a:3:{s:3:\"nid\";a:22:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:0;}s:4:\"view\";a:25:{s:2:\"id\";s:4:\"view\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"view\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:3:\"div\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:4:\"view\";s:15:\"product_display\";s:7:\"display\";s:5:\"block\";s:9:\"arguments\";s:6:\"[!nid]\";s:17:\"query_aggregation\";i:0;}s:11:\"title_field\";a:35:{s:2:\"id\";s:11:\"title_field\";s:5:\"table\";s:22:\"field_data_title_field\";s:5:\"field\";s:11:\"title_field\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:3:\"min\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:9:\"entity_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;s:14:\"link_to_entity\";i:0;}}s:5:\"sorts\";a:4:{s:7:\"promote\";a:9:{s:2:\"id\";s:7:\"promote\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"promote\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}}s:6:\"sticky\";a:9:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"sticky\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}}s:7:\"changed\";a:10:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";}s:7:\"created\";a:10:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";}}}'),(8,'default','Master','default',1,'a:13:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";s:2:\"12\";}}s:12:\"style_plugin\";s:4:\"grid\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:2:{s:3:\"nid\";a:22:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:0;}s:4:\"view\";a:25:{s:2:\"id\";s:4:\"view\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"view\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:4:\"view\";s:15:\"product_display\";s:7:\"display\";s:5:\"block\";s:9:\"arguments\";s:6:\"[!nid]\";s:17:\"query_aggregation\";i:0;}}s:7:\"filters\";a:3:{s:19:\"field_boolean_value\";a:14:{s:2:\"id\";s:19:\"field_boolean_value\";s:5:\"table\";s:24:\"field_data_field_boolean\";s:5:\"field\";s:19:\"field_boolean_value\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:2:\"or\";s:5:\"value\";a:1:{i:1;s:1:\"1\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:12:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:17:\"reduce_duplicates\";i:0;}s:6:\"status\";a:13:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";i:1;s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";b:0;s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}s:4:\"type\";a:13:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:4:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:5:\"value\";s:0:\"\";s:7:\"product\";s:7:\"product\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:12:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}}s:5:\"sorts\";a:3:{s:7:\"created\";a:10:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:10:\"stddev_pop\";s:7:\"ui_name\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";}s:7:\"promote\";a:9:{s:2:\"id\";s:7:\"promote\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"promote\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:10:\"stddev_pop\";s:7:\"ui_name\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}}s:6:\"sticky\";a:9:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"sticky\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:10:\"stddev_pop\";s:7:\"ui_name\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}}}s:5:\"title\";s:12:\"Today\'s Deal\";s:8:\"group_by\";i:1;s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}}'),(8,'page','Page','page',2,'a:6:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:10:\"today-deal\";s:5:\"field\";a:1:{s:5:\"title\";a:1:{s:12:\"link_to_node\";i:0;}}s:9:\"css_class\";s:13:\"products-grid\";s:8:\"defaults\";a:2:{s:9:\"css_class\";b:0;s:8:\"group_by\";b:0;}s:8:\"group_by\";i:0;}'),(9,'block','Block','block',2,'a:3:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:9:\"css_class\";s:11:\"brands-grid\";s:8:\"defaults\";a:1:{s:9:\"css_class\";b:0;}}'),(9,'block_1','Block','block',3,'a:13:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:9:\"css_class\";s:0:\"\";s:8:\"defaults\";a:11:{s:9:\"css_class\";b:0;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;s:6:\"fields\";b:0;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:5:\"pager\";b:0;s:13:\"pager_options\";b:0;s:5:\"title\";b:0;}s:7:\"filters\";a:1:{s:12:\"machine_name\";a:4:{s:2:\"id\";s:12:\"machine_name\";s:5:\"table\";s:19:\"taxonomy_vocabulary\";s:5:\"field\";s:12:\"machine_name\";s:5:\"value\";a:1:{s:6:\"brands\";s:6:\"brands\";}}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:6:\"fields\";a:1:{s:4:\"name\";a:23:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:18:\"taxonomy_term_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:16:\"link_to_taxonomy\";i:1;s:14:\"convert_spaces\";i:0;}}s:12:\"style_plugin\";s:4:\"list\";s:13:\"style_options\";a:7:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";i:1;s:17:\"row_class_special\";i:1;s:4:\"type\";s:2:\"ul\";s:13:\"wrapper_class\";s:9:\"item-list\";s:5:\"class\";s:0:\"\";}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"5\";s:6:\"offset\";s:1:\"0\";}}s:13:\"pager_options\";N;s:5:\"title\";s:16:\"Popular Searches\";}'),(9,'default','Master','default',1,'a:12:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:1:{s:14:\"items_per_page\";s:1:\"3\";}}s:12:\"style_plugin\";s:4:\"grid\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:1:{s:11:\"field_image\";a:34:{s:2:\"id\";s:11:\"field_image\";s:5:\"table\";s:22:\"field_data_field_image\";s:5:\"field\";s:11:\"field_image\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:3:{s:11:\"image_style\";s:16:\"thumbnail_180x85\";s:10:\"image_link\";s:7:\"content\";s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}}s:7:\"filters\";a:2:{s:12:\"machine_name\";a:4:{s:2:\"id\";s:12:\"machine_name\";s:5:\"table\";s:19:\"taxonomy_vocabulary\";s:5:\"field\";s:12:\"machine_name\";s:5:\"value\";a:1:{s:6:\"brands\";s:6:\"brands\";}}s:15:\"field_image_fid\";a:13:{s:2:\"id\";s:15:\"field_image_fid\";s:5:\"table\";s:22:\"field_data_field_image\";s:5:\"field\";s:15:\"field_image_fid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:9:\"not empty\";s:5:\"value\";a:3:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:5:\"value\";s:0:\"\";}s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:0:\"\";s:13:\"style_options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";i:1;s:17:\"row_class_special\";i:1;s:7:\"columns\";s:1:\"3\";s:9:\"alignment\";s:10:\"horizontal\";s:16:\"fill_single_line\";i:1;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";}}'),(10,'block_1','Block','block',2,'a:4:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"5\";s:6:\"offset\";s:1:\"0\";}}s:8:\"defaults\";a:2:{s:5:\"pager\";b:0;s:13:\"pager_options\";b:0;}s:13:\"pager_options\";N;}'),(10,'default','Master','default',1,'a:15:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:6:{s:19:\"disable_sql_rewrite\";i:1;s:8:\"distinct\";i:0;s:13:\"pure_distinct\";i:0;s:5:\"slave\";i:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:5:\"title\";s:12:\"Best sellers\";s:9:\"css_class\";s:13:\"products-list\";s:15:\"use_more_always\";b:0;s:8:\"group_by\";b:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"6\";s:6:\"offset\";s:1:\"0\";}}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:6:\"fields\";s:13:\"relationships\";a:3:{s:32:\"commerce_line_items_line_item_id\";a:4:{s:2:\"id\";s:32:\"commerce_line_items_line_item_id\";s:5:\"table\";s:30:\"field_data_commerce_line_items\";s:5:\"field\";s:32:\"commerce_line_items_line_item_id\";s:8:\"required\";b:1;}s:27:\"commerce_product_product_id\";a:5:{s:2:\"id\";s:27:\"commerce_product_product_id\";s:5:\"table\";s:27:\"field_data_commerce_product\";s:5:\"field\";s:27:\"commerce_product_product_id\";s:12:\"relationship\";s:32:\"commerce_line_items_line_item_id\";s:8:\"required\";b:1;}s:13:\"field_product\";a:5:{s:2:\"id\";s:13:\"field_product\";s:5:\"table\";s:16:\"commerce_product\";s:5:\"field\";s:13:\"field_product\";s:12:\"relationship\";s:27:\"commerce_product_product_id\";s:5:\"label\";s:4:\"Node\";}}s:6:\"fields\";a:8:{s:4:\"path\";a:7:{s:2:\"id\";s:4:\"path\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"path\";s:12:\"relationship\";s:13:\"field_product\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:19:\"element_label_colon\";b:0;}s:19:\"field_product_image\";a:34:{s:2:\"id\";s:19:\"field_product_image\";s:5:\"table\";s:30:\"field_data_field_product_image\";s:5:\"field\";s:19:\"field_product_image\";s:12:\"relationship\";s:27:\"commerce_product_product_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:78:\"<a href=\"[path]\" title=\"[field_product_image-title]\">[field_product_image]</a>\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:3:{s:11:\"image_style\";s:6:\"medium\";s:10:\"image_link\";s:0:\"\";s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:9:\"entity_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";i:1;s:11:\"delta_limit\";s:1:\"1\";s:12:\"delta_offset\";s:1:\"0\";s:14:\"delta_reversed\";i:0;s:16:\"delta_first_last\";i:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:1:\",\";s:17:\"field_api_classes\";i:0;}s:8:\"fieldset\";a:5:{s:2:\"id\";s:8:\"fieldset\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:8:\"fieldset\";s:8:\"children\";a:5:{i:0;s:5:\"title\";i:1;s:11:\"field_brand\";i:2;s:15:\"field_old_price\";i:3;s:25:\"field_discount_percentage\";i:4;s:14:\"commerce_price\";}s:8:\"fieldset\";a:1:{s:4:\"type\";s:3:\"div\";}}s:5:\"title\";a:7:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:13:\"field_product\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:2:{s:10:\"max_length\";s:2:\"40\";s:4:\"trim\";b:1;}s:19:\"element_label_colon\";b:0;}s:11:\"field_brand\";a:34:{s:2:\"id\";s:11:\"field_brand\";s:5:\"table\";s:22:\"field_data_field_brand\";s:5:\"field\";s:11:\"field_brand\";s:12:\"relationship\";s:13:\"field_product\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:29:\"<span>by </span>[field_brand]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"tid\";s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:8:\"settings\";a:1:{s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:3:\"tid\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:15:\"field_old_price\";a:34:{s:2:\"id\";s:15:\"field_old_price\";s:5:\"table\";s:26:\"field_data_field_old_price\";s:5:\"field\";s:15:\"field_old_price\";s:12:\"relationship\";s:27:\"commerce_product_product_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:6:\"amount\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";b:0;s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:9:\"entity_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:25:\"field_discount_percentage\";a:34:{s:2:\"id\";s:25:\"field_discount_percentage\";s:5:\"table\";s:36:\"field_data_field_discount_percentage\";s:5:\"field\";s:25:\"field_discount_percentage\";s:12:\"relationship\";s:27:\"commerce_product_product_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:5:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";s:1:\"0\";s:13:\"prefix_suffix\";i:1;s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:14:\"commerce_price\";a:9:{s:2:\"id\";s:14:\"commerce_price\";s:5:\"table\";s:25:\"field_data_commerce_price\";s:5:\"field\";s:14:\"commerce_price\";s:12:\"relationship\";s:27:\"commerce_product_product_id\";s:5:\"label\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:17:\"click_sort_column\";s:6:\"amount\";s:8:\"settings\";a:2:{s:11:\"calculation\";s:1:\"0\";s:21:\"field_formatter_class\";s:0:\"\";}s:12:\"group_column\";s:9:\"entity_id\";}}s:5:\"sorts\";a:1:{s:5:\"title\";a:6:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:16:\"commerce_product\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:27:\"commerce_product_product_id\";s:10:\"group_type\";s:5:\"count\";s:5:\"order\";s:4:\"DESC\";}}s:7:\"filters\";a:4:{s:4:\"type\";a:5:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:18:\"commerce_line_item\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:32:\"commerce_line_items_line_item_id\";s:5:\"value\";a:1:{s:7:\"product\";s:7:\"product\";}}s:6:\"type_1\";a:5:{s:2:\"id\";s:6:\"type_1\";s:5:\"table\";s:16:\"commerce_product\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:27:\"commerce_product_product_id\";s:5:\"value\";a:1:{s:7:\"product\";s:7:\"product\";}}s:6:\"status\";a:5:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:13:\"field_product\";s:5:\"value\";s:1:\"1\";}s:8:\"status_1\";a:5:{s:2:\"id\";s:8:\"status_1\";s:5:\"table\";s:16:\"commerce_product\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:27:\"commerce_product_product_id\";s:5:\"value\";s:1:\"1\";}}}'),(11,'default','Master','default',1,'a:14:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:22:\"better_exposed_filters\";s:7:\"options\";a:13:{s:13:\"submit_button\";s:2:\"Go\";s:12:\"reset_button\";i:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";i:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";s:10:\"autosubmit\";i:0;s:15:\"autosubmit_hide\";i:1;s:14:\"input_required\";i:0;s:3:\"bef\";a:3:{s:7:\"general\";a:2:{s:15:\"allow_secondary\";i:0;s:15:\"secondary_label\";s:16:\"Advanced options\";}s:14:\"field_category\";a:2:{s:10:\"bef_format\";s:7:\"default\";s:12:\"more_options\";a:7:{s:19:\"bef_select_all_none\";b:0;s:15:\"bef_collapsible\";i:0;s:12:\"is_secondary\";i:0;s:9:\"any_label\";s:3:\"All\";s:22:\"bef_filter_description\";s:0:\"\";s:6:\"tokens\";a:1:{s:9:\"available\";a:1:{i:0;s:12:\"global_types\";}}s:7:\"rewrite\";a:1:{s:21:\"filter_rewrite_values\";s:0:\"\";}}}s:24:\"search_api_aggregation_1\";a:2:{s:10:\"bef_format\";s:7:\"default\";s:12:\"more_options\";a:5:{s:12:\"is_secondary\";i:0;s:9:\"any_label\";s:3:\"All\";s:22:\"bef_filter_description\";s:0:\"\";s:6:\"tokens\";a:1:{s:9:\"available\";a:1:{i:0;s:12:\"global_types\";}}s:7:\"rewrite\";a:1:{s:21:\"filter_rewrite_values\";s:0:\"\";}}}}s:26:\"text_input_required_format\";s:13:\"filtered_html\";s:19:\"text_input_required\";s:51:\"Select any filter and click on Apply to see results\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";s:2:\"12\";}}s:12:\"style_plugin\";s:4:\"grid\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:2:{s:3:\"nid\";a:31:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:32:\"search_api_index_product_display\";s:5:\"field\";s:3:\"nid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:7:\"Node ID\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:14:\"link_to_entity\";i:0;}s:4:\"view\";a:25:{s:2:\"id\";s:4:\"view\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"view\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:4:\"view\";s:15:\"product_display\";s:7:\"display\";s:5:\"block\";s:9:\"arguments\";s:6:\"[!nid]\";s:17:\"query_aggregation\";i:0;}}s:7:\"filters\";a:3:{s:4:\"type\";a:13:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:32:\"search_api_index_product_display\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";a:1:{s:7:\"product\";s:7:\"product\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:12:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}s:26:\"field_category_parents_all\";a:16:{s:2:\"id\";s:26:\"field_category_parents_all\";s:5:\"table\";s:32:\"search_api_index_product_display\";s:5:\"field\";s:26:\"field_category_parents_all\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:29:\"field_category_parents_all_op\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";i:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:29:\"field_category_parents_all_op\";s:10:\"identifier\";s:26:\"field_category_parents_all\";s:8:\"required\";i:0;s:8:\"remember\";i:0;s:8:\"multiple\";i:0;s:14:\"remember_roles\";a:4:{i:2;s:1:\"2\";i:1;i:0;i:4;i:0;i:3;i:0;}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:4:\"type\";s:6:\"select\";s:9:\"hierarchy\";i:1;s:13:\"error_message\";i:1;}s:25:\"search_api_views_fulltext\";a:16:{s:2:\"id\";s:25:\"search_api_views_fulltext\";s:5:\"table\";s:32:\"search_api_index_product_display\";s:5:\"field\";s:25:\"search_api_views_fulltext\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:2:\"OR\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:28:\"search_api_views_fulltext_op\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";i:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:28:\"search_api_views_fulltext_op\";s:10:\"identifier\";s:25:\"search_api_views_fulltext\";s:8:\"required\";i:0;s:8:\"remember\";i:0;s:8:\"multiple\";i:0;s:14:\"remember_roles\";a:4:{i:2;s:1:\"2\";i:1;i:0;i:4;i:0;i:3;i:0;}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:4:\"mode\";s:4:\"keys\";s:10:\"min_length\";s:1:\"3\";s:6:\"fields\";a:4:{s:24:\"search_api_aggregation_1\";s:24:\"search_api_aggregation_1\";s:24:\"search_api_aggregation_4\";s:24:\"search_api_aggregation_4\";s:24:\"search_api_aggregation_5\";s:24:\"search_api_aggregation_5\";s:24:\"search_api_aggregation_6\";s:24:\"search_api_aggregation_6\";}}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:0:\"\";s:13:\"relationships\";a:0:{}s:9:\"css_class\";s:13:\"products-grid\";s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}}'),(11,'page','Search Page','page',2,'a:4:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:11:\"search-page\";s:13:\"exposed_block\";b:1;s:19:\"display_description\";s:0:\"\";}'),(12,'default','Master','default',1,'a:16:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";s:2:\"12\";}}s:12:\"style_plugin\";s:4:\"grid\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:2:{s:3:\"nid\";a:31:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:32:\"search_api_index_product_display\";s:5:\"field\";s:3:\"nid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:14:\"link_to_entity\";i:0;}s:4:\"view\";a:25:{s:2:\"id\";s:4:\"view\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"view\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:4:\"view\";s:15:\"product_display\";s:7:\"display\";s:5:\"block\";s:9:\"arguments\";s:6:\"[!nid]\";s:17:\"query_aggregation\";i:0;}}s:7:\"filters\";a:1:{s:4:\"type\";a:13:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:32:\"search_api_index_product_display\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";a:1:{s:7:\"product\";s:7:\"product\";}s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:12:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}}s:5:\"sorts\";a:1:{s:7:\"created\";a:9:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:32:\"search_api_index_product_display\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}}}s:5:\"title\";s:0:\"\";s:9:\"arguments\";a:1:{s:30:\"search_api_views_taxonomy_term\";a:22:{s:2:\"id\";s:30:\"search_api_views_taxonomy_term\";s:5:\"table\";s:32:\"search_api_index_product_display\";s:5:\"field\";s:30:\"search_api_views_taxonomy_term\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:14:\"default_action\";s:9:\"not found\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";i:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";i:1;s:5:\"title\";s:2:\"%1\";s:17:\"breadcrumb_enable\";i:0;s:10:\"breadcrumb\";s:0:\"\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";i:0;s:15:\"summary_options\";N;s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";i:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";i:0;s:3:\"not\";i:0;}}s:9:\"css_class\";s:27:\"products-grid views-product\";s:13:\"relationships\";a:0:{}s:5:\"empty\";a:1:{s:4:\"area\";a:11:{s:2:\"id\";s:4:\"area\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:5:\"empty\";b:1;s:7:\"content\";s:23:\"Sorry! No results found\";s:6:\"format\";s:13:\"filtered_html\";s:8:\"tokenize\";i:0;}}s:6:\"header\";a:1:{s:4:\"area\";a:11:{s:2:\"id\";s:4:\"area\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:5:\"empty\";i:0;s:7:\"content\";s:202:\"<a href=\"#\" class=\"product-display-type active\" data-type=\"products-grid\" ><i class=\"fa fa-th\"></i></a>\n<a href=\"#\" class=\"product-display-type\" data-type=\"products-list\" ><i class=\"fa fa-list\"></i></a>\";s:6:\"format\";s:8:\"php_code\";s:8:\"tokenize\";i:0;}}}'),(12,'page','Page','page',2,'a:4:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:15:\"taxonomy/term/%\";s:6:\"fields\";a:2:{s:3:\"nid\";a:31:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:32:\"search_api_index_product_display\";s:5:\"field\";s:3:\"nid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:14:\"link_to_entity\";i:0;}s:4:\"view\";a:25:{s:2:\"id\";s:4:\"view\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"view\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:3:\"div\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:4:\"view\";s:15:\"product_display\";s:7:\"display\";s:5:\"block\";s:9:\"arguments\";s:6:\"[!nid]\";s:17:\"query_aggregation\";i:0;}}s:8:\"defaults\";a:1:{s:6:\"fields\";b:0;}}'),(12,'page_1','Page','page',3,'a:5:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:8:\"products\";s:9:\"arguments\";a:0:{}s:8:\"defaults\";a:2:{s:9:\"arguments\";b:0;s:5:\"title\";b:0;}s:5:\"title\";s:8:\"Products\";}'),(13,'default','Defaults','default',1,'a:16:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:5:\"title\";s:13:\"Shopping cart\";s:15:\"use_more_always\";b:0;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"style_plugin\";s:5:\"table\";s:13:\"style_options\";a:3:{s:7:\"columns\";a:4:{s:15:\"line_item_title\";s:15:\"line_item_title\";s:19:\"commerce_unit_price\";s:19:\"commerce_unit_price\";s:8:\"quantity\";s:8:\"quantity\";s:14:\"commerce_total\";s:14:\"commerce_total\";}s:7:\"default\";s:2:\"-1\";s:4:\"info\";a:4:{s:15:\"line_item_title\";a:2:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:19:\"commerce_unit_price\";a:4:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:8:\"quantity\";a:4:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:14:\"commerce_total\";a:4:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:17:\"views-align-right\";s:9:\"separator\";s:0:\"\";}}}s:6:\"footer\";a:1:{s:11:\"order_total\";a:3:{s:2:\"id\";s:11:\"order_total\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:11:\"order_total\";}}s:13:\"relationships\";a:1:{s:32:\"commerce_line_items_line_item_id\";a:4:{s:2:\"id\";s:32:\"commerce_line_items_line_item_id\";s:5:\"table\";s:30:\"field_data_commerce_line_items\";s:5:\"field\";s:32:\"commerce_line_items_line_item_id\";s:8:\"required\";b:1;}}s:6:\"fields\";a:4:{s:15:\"line_item_title\";a:5:{s:2:\"id\";s:15:\"line_item_title\";s:5:\"table\";s:18:\"commerce_line_item\";s:5:\"field\";s:15:\"line_item_title\";s:12:\"relationship\";s:32:\"commerce_line_items_line_item_id\";s:5:\"label\";s:7:\"Product\";}s:19:\"commerce_unit_price\";a:9:{s:2:\"id\";s:19:\"commerce_unit_price\";s:5:\"table\";s:30:\"field_data_commerce_unit_price\";s:5:\"field\";s:19:\"commerce_unit_price\";s:12:\"relationship\";s:32:\"commerce_line_items_line_item_id\";s:5:\"label\";s:5:\"Price\";s:13:\"element_class\";s:5:\"price\";s:17:\"click_sort_column\";s:6:\"amount\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:1:{s:11:\"calculation\";b:0;}}s:8:\"quantity\";a:5:{s:2:\"id\";s:8:\"quantity\";s:5:\"table\";s:18:\"commerce_line_item\";s:5:\"field\";s:8:\"quantity\";s:12:\"relationship\";s:32:\"commerce_line_items_line_item_id\";s:9:\"precision\";s:1:\"0\";}s:14:\"commerce_total\";a:9:{s:2:\"id\";s:14:\"commerce_total\";s:5:\"table\";s:25:\"field_data_commerce_total\";s:5:\"field\";s:14:\"commerce_total\";s:12:\"relationship\";s:32:\"commerce_line_items_line_item_id\";s:13:\"element_class\";s:5:\"price\";s:16:\"hide_alter_empty\";b:0;s:17:\"click_sort_column\";s:6:\"amount\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:1:{s:11:\"calculation\";b:0;}}}s:5:\"sorts\";a:1:{s:12:\"line_item_id\";a:4:{s:2:\"id\";s:12:\"line_item_id\";s:5:\"table\";s:18:\"commerce_line_item\";s:5:\"field\";s:12:\"line_item_id\";s:12:\"relationship\";s:32:\"commerce_line_items_line_item_id\";}}s:9:\"arguments\";a:1:{s:8:\"order_id\";a:7:{s:2:\"id\";s:8:\"order_id\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:8:\"order_id\";s:14:\"default_action\";s:9:\"not found\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:2:{s:17:\"number_of_records\";s:1:\"0\";s:6:\"format\";s:15:\"default_summary\";}s:15:\"summary_options\";a:1:{s:14:\"items_per_page\";s:2:\"25\";}}}s:7:\"filters\";a:1:{s:22:\"product_line_item_type\";a:6:{s:2:\"id\";s:22:\"product_line_item_type\";s:5:\"table\";s:18:\"commerce_line_item\";s:5:\"field\";s:22:\"product_line_item_type\";s:12:\"relationship\";s:32:\"commerce_line_items_line_item_id\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:0;}}s:9:\"css_class\";s:13:\"shopping-cart\";}'),(14,'default','Defaults','default',1,'a:14:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:15:\"use_more_always\";b:0;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"style_plugin\";s:5:\"table\";s:13:\"style_options\";a:3:{s:7:\"columns\";a:7:{s:12:\"line_item_id\";s:12:\"line_item_id\";s:4:\"type\";s:4:\"type\";s:15:\"line_item_title\";s:15:\"line_item_title\";s:15:\"line_item_label\";s:15:\"line_item_title\";s:19:\"commerce_unit_price\";s:19:\"commerce_unit_price\";s:8:\"quantity\";s:8:\"quantity\";s:14:\"commerce_total\";s:14:\"commerce_total\";}s:7:\"default\";s:2:\"-1\";s:4:\"info\";a:7:{s:12:\"line_item_id\";a:4:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:4:\"type\";a:4:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:15:\"line_item_title\";a:2:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:1:\" \";}s:15:\"line_item_label\";a:4:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:19:\"commerce_unit_price\";a:4:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:8:\"quantity\";a:4:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:14:\"commerce_total\";a:4:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:17:\"views-align-right\";s:9:\"separator\";s:0:\"\";}}}s:5:\"empty\";a:1:{s:4:\"area\";a:6:{s:2:\"id\";s:4:\"area\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:5:\"label\";s:21:\"Empty line item text.\";s:7:\"content\";s:20:\"No line items found.\";s:6:\"format\";s:10:\"plain_text\";}}s:6:\"fields\";a:7:{s:12:\"line_item_id\";a:5:{s:2:\"id\";s:12:\"line_item_id\";s:5:\"table\";s:18:\"commerce_line_item\";s:5:\"field\";s:12:\"line_item_id\";s:5:\"label\";s:2:\"ID\";s:7:\"exclude\";b:1;}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:18:\"commerce_line_item\";s:5:\"field\";s:4:\"type\";s:7:\"exclude\";b:1;}s:15:\"line_item_title\";a:3:{s:2:\"id\";s:15:\"line_item_title\";s:5:\"table\";s:18:\"commerce_line_item\";s:5:\"field\";s:15:\"line_item_title\";}s:15:\"line_item_label\";a:4:{s:2:\"id\";s:15:\"line_item_label\";s:5:\"table\";s:18:\"commerce_line_item\";s:5:\"field\";s:15:\"line_item_label\";s:5:\"alter\";a:2:{s:10:\"alter_text\";b:1;s:4:\"text\";s:19:\"([line_item_label])\";}}s:19:\"commerce_unit_price\";a:5:{s:2:\"id\";s:19:\"commerce_unit_price\";s:5:\"table\";s:30:\"field_data_commerce_unit_price\";s:5:\"field\";s:19:\"commerce_unit_price\";s:17:\"click_sort_column\";s:6:\"amount\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";}s:8:\"quantity\";a:4:{s:2:\"id\";s:8:\"quantity\";s:5:\"table\";s:18:\"commerce_line_item\";s:5:\"field\";s:8:\"quantity\";s:9:\"precision\";s:1:\"0\";}s:14:\"commerce_total\";a:5:{s:2:\"id\";s:14:\"commerce_total\";s:5:\"table\";s:25:\"field_data_commerce_total\";s:5:\"field\";s:14:\"commerce_total\";s:17:\"click_sort_column\";s:6:\"amount\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";}}s:5:\"sorts\";a:1:{s:12:\"line_item_id\";a:3:{s:2:\"id\";s:12:\"line_item_id\";s:5:\"table\";s:18:\"commerce_line_item\";s:5:\"field\";s:12:\"line_item_id\";}}s:9:\"arguments\";a:1:{s:12:\"line_item_id\";a:8:{s:2:\"id\";s:12:\"line_item_id\";s:5:\"table\";s:18:\"commerce_line_item\";s:5:\"field\";s:12:\"line_item_id\";s:14:\"default_action\";s:5:\"empty\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:2:{s:17:\"number_of_records\";s:1:\"0\";s:6:\"format\";s:15:\"default_summary\";}s:15:\"summary_options\";a:1:{s:14:\"items_per_page\";s:2:\"25\";}s:12:\"break_phrase\";b:1;}}s:7:\"filters\";a:1:{s:22:\"product_line_item_type\";a:4:{s:2:\"id\";s:22:\"product_line_item_type\";s:5:\"table\";s:18:\"commerce_line_item\";s:5:\"field\";s:22:\"product_line_item_type\";s:5:\"value\";s:1:\"1\";}}s:9:\"css_class\";s:13:\"shopping-cart\";}'),(15,'default','Master','default',1,'a:13:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:15:\"use_more_always\";b:0;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:1:{s:4:\"type\";s:4:\"full\";}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:6:\"entity\";s:11:\"row_options\";a:1:{s:9:\"view_mode\";s:13:\"administrator\";}s:6:\"fields\";a:1:{s:8:\"order_id\";a:3:{s:2:\"id\";s:8:\"order_id\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:8:\"order_id\";}}s:9:\"arguments\";a:1:{s:8:\"order_id\";a:7:{s:2:\"id\";s:8:\"order_id\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:8:\"order_id\";s:14:\"default_action\";s:13:\"access denied\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:2:{s:17:\"number_of_records\";s:1:\"0\";s:6:\"format\";s:15:\"default_summary\";}s:15:\"summary_options\";a:1:{s:14:\"items_per_page\";s:2:\"25\";}}}s:7:\"filters\";a:1:{s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:20:\"commerce_store_order\";s:20:\"commerce_store_order\";}}}s:9:\"css_class\";s:13:\"shopping-cart\";}'),(16,'default','Defaults','default',1,'a:14:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:5:\"title\";s:6:\"Orders\";s:15:\"use_more_always\";b:0;s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:4:\"perm\";s:32:\"view own commerce_order entities\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";i:25;}}s:12:\"style_plugin\";s:5:\"table\";s:13:\"style_options\";a:3:{s:7:\"columns\";a:5:{s:12:\"order_number\";s:12:\"order_number\";s:7:\"created\";s:7:\"created\";s:7:\"changed\";s:7:\"changed\";s:20:\"commerce_order_total\";s:20:\"commerce_order_total\";s:6:\"status\";s:6:\"status\";}s:7:\"default\";s:12:\"order_number\";s:4:\"info\";a:5:{s:12:\"order_number\";a:5:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:7:\"created\";a:5:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:7:\"changed\";a:5:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:20:\"commerce_order_total\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:6:\"status\";a:5:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}}}s:5:\"empty\";a:1:{s:4:\"text\";a:5:{s:2:\"id\";s:4:\"text\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:7:\"content\";s:43:\"You have not placed any orders with us yet.\";s:6:\"format\";s:10:\"plain_text\";}}s:6:\"fields\";a:5:{s:12:\"order_number\";a:4:{s:2:\"id\";s:12:\"order_number\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:12:\"order_number\";s:13:\"link_to_order\";s:8:\"customer\";}s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:7:\"created\";s:5:\"label\";s:7:\"Created\";}s:7:\"changed\";a:3:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:7:\"changed\";}s:20:\"commerce_order_total\";a:7:{s:2:\"id\";s:20:\"commerce_order_total\";s:5:\"table\";s:31:\"field_data_commerce_order_total\";s:5:\"field\";s:20:\"commerce_order_total\";s:5:\"label\";s:5:\"Total\";s:17:\"click_sort_column\";s:6:\"amount\";s:4:\"type\";s:31:\"commerce_price_formatted_amount\";s:8:\"settings\";a:1:{s:11:\"calculation\";b:0;}}s:6:\"status\";a:3:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:6:\"status\";}}s:9:\"arguments\";a:1:{s:5:\"uid_1\";a:10:{s:2:\"id\";s:5:\"uid_1\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:3:\"uid\";s:14:\"default_action\";s:9:\"not found\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:2:{s:17:\"number_of_records\";s:1:\"0\";s:6:\"format\";s:15:\"default_summary\";}s:15:\"summary_options\";a:1:{s:14:\"items_per_page\";s:2:\"25\";}s:18:\"specify_validation\";b:1;s:8:\"validate\";a:1:{s:4:\"type\";s:20:\"current_user_or_role\";}s:16:\"validate_options\";a:2:{s:14:\"restrict_roles\";b:1;s:5:\"roles\";a:1:{i:3;s:1:\"3\";}}}}s:7:\"filters\";a:1:{s:5:\"state\";a:5:{s:2:\"id\";s:5:\"state\";s:5:\"table\";s:14:\"commerce_order\";s:5:\"field\";s:5:\"state\";s:8:\"operator\";s:6:\"not in\";s:5:\"value\";a:2:{s:4:\"cart\";s:4:\"cart\";s:8:\"checkout\";s:8:\"checkout\";}}}s:6:\"header\";a:1:{s:15:\"view_order_form\";a:9:{s:2:\"id\";s:15:\"view_order_form\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:15:\"view_order_form\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:10:\"identifier\";s:12:\"order_number\";s:13:\"redirect_page\";s:8:\"customer\";}}}'),(16,'order_page','User Orders','page',2,'a:4:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:13:\"user/%/orders\";s:4:\"menu\";a:3:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:6:\"Orders\";s:6:\"weight\";s:2:\"15\";}s:11:\"tab_options\";a:5:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:6:\"Orders\";s:11:\"description\";s:25:\"User orders in the store.\";s:6:\"weight\";s:0:\"\";s:4:\"name\";s:9:\"user-menu\";}}');
/*!40000 ALTER TABLE `views_display` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `views_view`
--

DROP TABLE IF EXISTS `views_view`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `views_view` (
  `vid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The view ID of the field, defined by the database.',
  `name` varchar(128) NOT NULL DEFAULT '' COMMENT 'The unique name of the view. This is the primary field views are loaded from, and is used so that views may be internal and not necessarily in the database. May only be alphanumeric characters plus underscores.',
  `description` varchar(255) DEFAULT '' COMMENT 'A description of the view for the admin interface.',
  `tag` varchar(255) DEFAULT '' COMMENT 'A tag used to group/sort views in the admin interface',
  `base_table` varchar(64) NOT NULL DEFAULT '' COMMENT 'What table this view is based on, such as node, user, comment, or term.',
  `human_name` varchar(255) DEFAULT '' COMMENT 'A human readable name used to be displayed in the admin interface',
  `core` int(11) DEFAULT '0' COMMENT 'Stores the drupal core version of the view.',
  PRIMARY KEY (`vid`),
  UNIQUE KEY `name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=17 DEFAULT CHARSET=utf8 COMMENT='Stores the general data for a view.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `views_view`
--

LOCK TABLES `views_view` WRITE;
/*!40000 ALTER TABLE `views_view` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `views_view` VALUES (1,'frontpage','Emulates the default Drupal front page; you may set the default home page path to this view to make it your front page.','default','node','Front page',0),(2,'slideshow','','default','node','Slideshow',7),(4,'commerce_cart_form','Display a shopping cart update form.','commerce','commerce_order','Shopping cart form',0),(5,'banner','','default','node','Banner',7),(6,'commerce_cart_block','Display a list of line items added to cart.','commerce','commerce_order','Shopping cart block',0),(7,'product_display','','default','node','Product Display',7),(8,'today_s_deal','','default','node','Today\'s Deal',7),(9,'brand','','default','taxonomy_term_data','Brand',7),(10,'bestsellers','','default','commerce_order','Bestsellers',7),(11,'search','','default','search_api_index_product_display','Search',7),(12,'category','','default','search_api_index_product_display','Category',7),(13,'commerce_cart_summary','Cart line item summary displayed during checkout.','commerce','commerce_order','Shopping cart summary',0),(14,'commerce_line_item_table','Display a set of line items in a table.','commerce','commerce_line_item','Line items',0),(15,'store_order_view','','default','commerce_order','Store order view',7),(16,'commerce_user_orders','Display a list of completed orders for a user.','commerce','commerce_order','User orders',7);
/*!40000 ALTER TABLE `views_view` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `votingapi_cache`
--

DROP TABLE IF EXISTS `votingapi_cache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `votingapi_cache` (
  `vote_cache_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `entity_type` varchar(64) NOT NULL DEFAULT 'node',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0',
  `value` float NOT NULL DEFAULT '0',
  `value_type` varchar(64) NOT NULL DEFAULT 'percent',
  `tag` varchar(64) NOT NULL DEFAULT 'vote',
  `function` varchar(64) NOT NULL DEFAULT '',
  `timestamp` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`vote_cache_id`),
  KEY `content` (`entity_type`,`entity_id`),
  KEY `content_function` (`entity_type`,`entity_id`,`function`),
  KEY `content_tag_func` (`entity_type`,`entity_id`,`tag`,`function`),
  KEY `content_vtype_tag` (`entity_type`,`entity_id`,`value_type`,`tag`),
  KEY `content_vtype_tag_func` (`entity_type`,`entity_id`,`value_type`,`tag`,`function`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `votingapi_cache`
--

LOCK TABLES `votingapi_cache` WRITE;
/*!40000 ALTER TABLE `votingapi_cache` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `votingapi_cache` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `votingapi_vote`
--

DROP TABLE IF EXISTS `votingapi_vote`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `votingapi_vote` (
  `vote_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `entity_type` varchar(64) NOT NULL DEFAULT 'node',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0',
  `value` float NOT NULL DEFAULT '0',
  `value_type` varchar(64) NOT NULL DEFAULT 'percent',
  `tag` varchar(64) NOT NULL DEFAULT 'vote',
  `uid` int(10) unsigned NOT NULL DEFAULT '0',
  `timestamp` int(10) unsigned NOT NULL DEFAULT '0',
  `vote_source` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`vote_id`),
  KEY `content_uid` (`entity_type`,`entity_id`,`uid`),
  KEY `content_uid_2` (`entity_type`,`uid`),
  KEY `content_source` (`entity_type`,`entity_id`,`vote_source`),
  KEY `content_value_tag` (`entity_type`,`entity_id`,`value_type`,`tag`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `votingapi_vote`
--

LOCK TABLES `votingapi_vote` WRITE;
/*!40000 ALTER TABLE `votingapi_vote` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `votingapi_vote` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `watchdog`
--

DROP TABLE IF EXISTS `watchdog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `watchdog` (
  `wid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique watchdog event ID.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid of the user who triggered the event.',
  `type` varchar(64) NOT NULL DEFAULT '' COMMENT 'Type of log message, for example "user" or "page not found."',
  `message` longtext NOT NULL COMMENT 'Text of log message to be passed into the t() function.',
  `variables` longblob NOT NULL COMMENT 'Serialized array of variables that match the message string and that is passed into the t() function.',
  `severity` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'The severity level of the event; ranges from 0 (Emergency) to 7 (Debug)',
  `link` varchar(255) DEFAULT '' COMMENT 'Link to view the result of the event.',
  `location` text NOT NULL COMMENT 'URL of the origin of the event.',
  `referer` text COMMENT 'URL of referring page.',
  `hostname` varchar(128) NOT NULL DEFAULT '' COMMENT 'Hostname of the user who triggered the event.',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'Unix timestamp of when event occurred.',
  PRIMARY KEY (`wid`),
  KEY `type` (`type`),
  KEY `uid` (`uid`),
  KEY `severity` (`severity`)
) ENGINE=InnoDB AUTO_INCREMENT=88 DEFAULT CHARSET=utf8 COMMENT='Table that contains logs of all system events.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `watchdog`
--

LOCK TABLES `watchdog` WRITE;
/*!40000 ALTER TABLE `watchdog` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `watchdog` VALUES (1,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/','http://local2.weebpal.com/drupal7/marketplace/install.php?profile=standard&locale=en','192.168.1.49',1499933577),(2,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/thumbnail_180x85/public/field/brand/brand-1.png?itok=c3pFos1E','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933578),(3,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/thumbnail_180x85/public/field/brand/brand-2.png?itok=XUr1UNY8','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933578),(4,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/thumbnail_180x85/public/field/brand/brand-3.png?itok=b6fSwvED','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933578),(5,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/thumbnail_product_grid/public/products/samsung-40-full-hd-led-tv.jpg?itok=ndXboxFf','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933578),(6,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/thumbnail_product_grid/public/products/samsung-n910-note-4-lte-32gb-white.jpg?itok=WwNErR3h','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933578),(7,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/medium/public/products/canon-ef-s-lens-18.jpg?itok=9yR6OPDe','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933578),(8,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/medium/public/products/samsung-n910-note-4-lte-32gb-white.jpg?itok=N426JyY9','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933578),(9,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/thumbnail_slideshow/public/banner/slide2.jpg?itok=7UEt5D05','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933578),(10,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/thumbnail_product_grid/public/products/apple-iphone-6-16gb-gold.jpg?itok=5qm4cmi4','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933578),(11,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/thumbnail_product_grid/public/products/asus-transformer-p1801-b041k.jpg?itok=McDDwOZO','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933578),(12,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/thumbnail_slideshow/public/banner/slide1_0.jpg?itok=-zqXlDak','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933578),(13,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/thumbnail_product_grid/public/products/canon-ef-s-lens-18.jpg?itok=R7oVarj7','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933578),(14,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/thumbnail_product_grid/public/products/sony-48-full-hd-led-tv.jpg?itok=WaSYEd_t','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933578),(15,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/thumbnail_product_grid/public/products/dell-alienware-x51.jpg?itok=HTX8wlL7','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933579),(16,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/thumbnail_product_grid/public/products/rolex-submariner-black-dial-stainless.jpg?itok=63GEnCF2','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933579),(17,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/thumbnail_slideshow/public/banner/slideshow-1.png?itok=pFI1Sxaa','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933579),(18,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/thumbnail_product_grid/public/products/apple-ipad-air-16gb-wifi-space-grey.jpg?itok=_2RRNbFL','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933579),(19,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/thumbnail_product_grid/public/products/lenovo-tablet-miix_0.jpg?itok=rkGNBbgF','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933579),(20,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/medium/public/products/aeroline-casual-hiking-orange_0.jpg?itok=2HRCQo1Z','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933579),(21,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/medium/public/products/asus-transformer-p1801-b041k.jpg?itok=v0gpHjJK','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933579),(22,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/medium/public/products/apple-ipad-air-16gb-wifi-space-grey.jpg?itok=jGVufm26','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933579),(23,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/thumbnail_product_grid/public/products/transporter-carry-cot.jpg?itok=QSvp3P7I','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933579),(24,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/thumbnail_product_grid/public/products/tko-fat-burner-mega.jpg?itok=ZStQPJ86','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933579),(25,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/thumbnail_product_grid/public/products/boogie-board-105.jpg?itok=Ydedkkbs','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933579),(26,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/thumbnail_product_grid/public/products/kinohimitsu-jpan-bb-drink.jpg?itok=rYhFIo3J','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933579),(27,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/thumbnail_product_grid/public/products/mini-quran-for-kids-yellow.jpg?itok=NXPExtgh','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933579),(28,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/thumbnail_product_grid/public/products/trek-0043.jpg?itok=tI1XR1L4','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933579),(29,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/thumbnail_product_grid/public/products/cctv-850tvl-ir-dome-cctv-camera.jpg?itok=g4eZFeDI','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933579),(30,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/default/files/styles/thumbnail_product_grid/public/products/d-link-dcs-5222l-cloudcam.jpg?itok=wsqGdM9Q','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933579),(31,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/en','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1499933588),(32,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/user','','192.168.1.49',1499933592),(33,1,'user','Session opened for %name.','a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://local2.weebpal.com/drupal7/marketplace/user','http://local2.weebpal.com/drupal7/marketplace/user','192.168.1.49',1499933597),(34,1,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/user','http://local2.weebpal.com/drupal7/marketplace/user','192.168.1.49',1499933597),(35,1,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/en/users/admin','http://local2.weebpal.com/drupal7/marketplace/user','192.168.1.49',1499933598),(36,1,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/en','http://local2.weebpal.com/drupal7/marketplace/en/users/admin','192.168.1.49',1499933601),(37,1,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/en/js/admin_menu/cache/f5cb32cffc6c36d1b053dbdc4bfe3ad2','http://local2.weebpal.com/drupal7/marketplace/en','192.168.1.49',1499933601),(38,1,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:215:\"The following theme is missing from the file system: <em class=\"placeholder\">weebpal_backend</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/en/admin_menu/flush-cache?token=X0wGVS0bcNCjrs8IL8Sqr49TxHh2KCldkYvYxPJSuD0&destination=frontpage','http://local2.weebpal.com/drupal7/marketplace/en','192.168.1.49',1499933610),(39,1,'system','%module module installed.','a:1:{s:7:\"%module\";s:20:\"we_content_migration\";}',6,'','http://local2.weebpal.com/drupal7/marketplace/en/admin/modules/list/confirm','http://local2.weebpal.com/drupal7/marketplace/en/admin/modules','192.168.1.49',1499933752),(40,1,'system','%module module enabled.','a:1:{s:7:\"%module\";s:20:\"we_content_migration\";}',6,'','http://local2.weebpal.com/drupal7/marketplace/en/admin/modules/list/confirm','http://local2.weebpal.com/drupal7/marketplace/en/admin/modules','192.168.1.49',1499933752),(41,1,'page not found','sites/all/themes/we_backend/images/pay2.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay2.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/appearance','192.168.1.49',1499933784),(42,1,'page not found','sites/all/themes/we_backend/images/pay3.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay3.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/appearance','192.168.1.49',1499933784),(43,1,'page not found','sites/all/themes/we_backend/images/apple-store.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/apple-store.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/appearance','192.168.1.49',1499933784),(44,1,'page not found','sites/all/themes/we_backend/images/pay1.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay1.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/appearance','192.168.1.49',1499933784),(45,1,'page not found','sites/all/themes/we_backend/images/android-store.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/android-store.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/appearance','192.168.1.49',1499933784),(46,1,'page not found','sites/all/themes/we_backend/images/pay4.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay4.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/appearance','192.168.1.49',1499933784),(47,1,'page not found','sites/all/themes/we_backend/images/apple-store.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/apple-store.png','http://local2.weebpal.com/drupal7/marketplace/admin/dashboard','192.168.1.49',1499933842),(48,1,'page not found','sites/all/themes/we_backend/images/pay2.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay2.png','http://local2.weebpal.com/drupal7/marketplace/admin/dashboard','192.168.1.49',1499933842),(49,1,'page not found','sites/all/themes/we_backend/images/pay1.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay1.png','http://local2.weebpal.com/drupal7/marketplace/admin/dashboard','192.168.1.49',1499933842),(50,1,'page not found','sites/all/themes/we_backend/images/android-store.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/android-store.png','http://local2.weebpal.com/drupal7/marketplace/admin/dashboard','192.168.1.49',1499933842),(51,1,'page not found','sites/all/themes/we_backend/images/pay3.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay3.png','http://local2.weebpal.com/drupal7/marketplace/admin/dashboard','192.168.1.49',1499933842),(52,1,'page not found','sites/all/themes/we_backend/images/pay4.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay4.png','http://local2.weebpal.com/drupal7/marketplace/admin/dashboard','192.168.1.49',1499933842),(53,1,'page not found','sites/all/themes/we_backend/images/android-store.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/android-store.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/structure','192.168.1.49',1499933846),(54,1,'page not found','sites/all/themes/we_backend/images/pay4.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay4.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/structure','192.168.1.49',1499933846),(55,1,'page not found','sites/all/themes/we_backend/images/apple-store.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/apple-store.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/structure','192.168.1.49',1499933846),(56,1,'page not found','sites/all/themes/we_backend/images/pay1.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay1.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/structure','192.168.1.49',1499933846),(57,1,'page not found','sites/all/themes/we_backend/images/pay2.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay2.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/structure','192.168.1.49',1499933846),(58,1,'page not found','sites/all/themes/we_backend/images/pay3.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay3.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/structure','192.168.1.49',1499933846),(59,1,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:216:\"The following module is missing from the file system: <em class=\"placeholder\">menu_breadcrumb</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/en/admin/config','http://local2.weebpal.com/drupal7/marketplace/en/admin/structure','192.168.1.49',1499933849),(60,1,'page not found','sites/all/themes/we_backend/images/android-store.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/android-store.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/config','192.168.1.49',1499933849),(61,1,'page not found','sites/all/themes/we_backend/images/pay2.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay2.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/config','192.168.1.49',1499933849),(62,1,'page not found','sites/all/themes/we_backend/images/apple-store.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/apple-store.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/config','192.168.1.49',1499933849),(63,1,'page not found','sites/all/themes/we_backend/images/pay1.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay1.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/config','192.168.1.49',1499933849),(64,1,'page not found','sites/all/themes/we_backend/images/pay3.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay3.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/config','192.168.1.49',1499933849),(65,1,'page not found','sites/all/themes/we_backend/images/pay4.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay4.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/config','192.168.1.49',1499933849),(66,1,'page not found','sites/all/themes/we_backend/images/pay1.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay1.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/people','192.168.1.49',1499933853),(67,1,'page not found','sites/all/themes/we_backend/images/pay2.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay2.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/people','192.168.1.49',1499933853),(68,1,'page not found','sites/all/themes/we_backend/images/apple-store.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/apple-store.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/people','192.168.1.49',1499933853),(69,1,'page not found','sites/all/themes/we_backend/images/android-store.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/android-store.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/people','192.168.1.49',1499933853),(70,1,'page not found','sites/all/themes/we_backend/images/pay4.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay4.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/people','192.168.1.49',1499933853),(71,1,'page not found','sites/all/themes/we_backend/images/pay3.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay3.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/people','192.168.1.49',1499933853),(72,1,'page not found','sites/all/themes/we_backend/images/pay1.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay1.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/appearance','192.168.1.49',1499933856),(73,1,'page not found','sites/all/themes/we_backend/images/android-store.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/android-store.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/appearance','192.168.1.49',1499933856),(74,1,'page not found','sites/all/themes/we_backend/images/apple-store.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/apple-store.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/appearance','192.168.1.49',1499933856),(75,1,'page not found','sites/all/themes/we_backend/images/pay4.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay4.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/appearance','192.168.1.49',1499933856),(76,1,'page not found','sites/all/themes/we_backend/images/pay3.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay3.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/appearance','192.168.1.49',1499933856),(77,1,'page not found','sites/all/themes/we_backend/images/pay2.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay2.png','http://local2.weebpal.com/drupal7/marketplace/en/admin/appearance','192.168.1.49',1499933856),(78,1,'user','Session opened for %name.','a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://local2.weebpal.com/drupal7/marketplace/user','http://local2.weebpal.com/drupal7/marketplace/user','192.168.1.49',1500347121),(79,1,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:216:\"The following module is missing from the file system: <em class=\"placeholder\">menu_breadcrumb</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/en/admin/reports/status?render=overlay','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1500360891),(80,1,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"!message\";s:216:\"The following module is missing from the file system: <em class=\"placeholder\">menu_breadcrumb</em>. For information about how to fix this, see <a href=\"https://www.drupal.org/node/2487215\">the documentation page</a>.\";s:9:\"%function\";s:44:\"_drupal_trigger_error_with_delayed_logging()\";s:5:\"%file\";s:52:\"/data/dev/drupal7/marketplace/includes/bootstrap.inc\";s:5:\"%line\";i:1138;s:14:\"severity_level\";i:4;}',4,'','http://local2.weebpal.com/drupal7/marketplace/en/admin/reports/status?render=overlay','http://local2.weebpal.com/drupal7/marketplace/','192.168.1.49',1500360915),(81,0,'cron','Cron run completed.','a:0:{}',5,'','http://local2.weebpal.com/drupal7/marketplace/cron.php?cron_key=nIB27vAacpuWhw1T4e2fmNBGz2hupqQvGuay0muIEZs','http://local2.weebpal.com/drupal7/marketplace/en/admin/reports/status?render=overlay','192.168.1.49',1500360936),(82,1,'page not found','sites/all/themes/we_backend/images/android-store.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/android-store.png','http://local2.weebpal.com/drupal7/marketplace/admin/modules','192.168.1.49',1500361299),(83,1,'page not found','sites/all/themes/we_backend/images/pay1.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay1.png','http://local2.weebpal.com/drupal7/marketplace/admin/modules','192.168.1.49',1500361299),(84,1,'page not found','sites/all/themes/we_backend/images/pay2.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay2.png','http://local2.weebpal.com/drupal7/marketplace/admin/modules','192.168.1.49',1500361299),(85,1,'page not found','sites/all/themes/we_backend/images/apple-store.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/apple-store.png','http://local2.weebpal.com/drupal7/marketplace/admin/modules','192.168.1.49',1500361299),(86,1,'page not found','sites/all/themes/we_backend/images/pay3.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay3.png','http://local2.weebpal.com/drupal7/marketplace/admin/modules','192.168.1.49',1500361299),(87,1,'page not found','sites/all/themes/we_backend/images/pay4.png','N;',4,'','http://local2.weebpal.com/drupal7/marketplace/sites/all/themes/we_backend/images/pay4.png','http://local2.weebpal.com/drupal7/marketplace/admin/modules','192.168.1.49',1500361299);
/*!40000 ALTER TABLE `watchdog` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `we_content_migration_mapping`
--

DROP TABLE IF EXISTS `we_content_migration_mapping`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `we_content_migration_mapping` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier',
  `old_entity_type` varchar(128) DEFAULT NULL COMMENT 'The machine name of the old entity',
  `old_bundle` varchar(128) DEFAULT NULL COMMENT 'The old bundle’s name',
  `old_entity_id` int(11) DEFAULT NULL COMMENT 'The old entity id',
  `new_entity_type` varchar(128) NOT NULL COMMENT 'The machine name of the new entity',
  `new_bundle` varchar(128) NOT NULL COMMENT 'The new bundle’s name',
  `new_entity_id` int(11) NOT NULL COMMENT 'The new entity id',
  PRIMARY KEY (`id`),
  KEY `mapping` (`old_entity_type`,`old_bundle`,`old_entity_id`,`new_entity_type`,`new_bundle`,`new_entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='The table to save the mapping.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `we_content_migration_mapping`
--

LOCK TABLES `we_content_migration_mapping` WRITE;
/*!40000 ALTER TABLE `we_content_migration_mapping` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `we_content_migration_mapping` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `we_content_migration_mapping_reference`
--

DROP TABLE IF EXISTS `we_content_migration_mapping_reference`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `we_content_migration_mapping_reference` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier',
  `entity_type` varchar(128) NOT NULL COMMENT 'The machine name of the entity',
  `bundle` varchar(128) NOT NULL COMMENT 'The bundle’s name',
  `eid` int(11) NOT NULL COMMENT 'The entity id',
  `field_name` varchar(32) NOT NULL COMMENT 'The field name',
  `field_value` text NOT NULL COMMENT 'The field value string',
  `language` varchar(12) NOT NULL DEFAULT '',
  `status` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `mapping_reference` (`entity_type`,`bundle`,`eid`,`field_name`,`status`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='The table to save all reference field data.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `we_content_migration_mapping_reference`
--

LOCK TABLES `we_content_migration_mapping_reference` WRITE;
/*!40000 ALTER TABLE `we_content_migration_mapping_reference` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `we_content_migration_mapping_reference` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `webform`
--

DROP TABLE IF EXISTS `webform`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webform` (
  `nid` int(10) unsigned NOT NULL COMMENT 'The node identifier of a webform.',
  `next_serial` int(10) unsigned NOT NULL DEFAULT '1' COMMENT 'The serial number to give to the next submission to this webform.',
  `confirmation` text NOT NULL COMMENT 'The confirmation message or URL displayed to the user after submitting a form.',
  `confirmation_format` varchar(255) DEFAULT NULL COMMENT 'The filter_format.format of the confirmation message.',
  `redirect_url` varchar(2048) DEFAULT '<confirmation>' COMMENT 'The URL a user is redirected to after submitting a form.',
  `status` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'Boolean value of a webform for open (1) or closed (0).',
  `block` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean value for whether this form be available as a block.',
  `allow_draft` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean value for whether submissions to this form be saved as a draft.',
  `auto_save` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean value for whether submissions to this form should be auto-saved between pages.',
  `submit_notice` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'Boolean value for whether to show or hide the previous submissions notification.',
  `submit_text` varchar(255) DEFAULT NULL COMMENT 'The title of the submit button on the form.',
  `submit_limit` tinyint(4) NOT NULL DEFAULT '-1' COMMENT 'The number of submissions a single user is allowed to submit within an interval. -1 is unlimited.',
  `submit_interval` int(11) NOT NULL DEFAULT '-1' COMMENT 'The amount of time in seconds that must pass before a user can submit another submission within the set limit.',
  `total_submit_limit` int(11) NOT NULL DEFAULT '-1' COMMENT 'The total number of submissions allowed within an interval. -1 is unlimited.',
  `total_submit_interval` int(11) NOT NULL DEFAULT '-1' COMMENT 'The amount of time in seconds that must pass before another submission can be submitted within the set limit.',
  `progressbar_bar` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean value indicating if the bar should be shown as part of the progress bar.',
  `progressbar_page_number` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean value indicating if the page number should be shown as part of the progress bar.',
  `progressbar_percent` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean value indicating if the percentage complete should be shown as part of the progress bar.',
  `progressbar_pagebreak_labels` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean value indicating if the pagebreak labels should be included as part of the progress bar.',
  `progressbar_include_confirmation` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean value indicating if the confirmation page should count as a page in the progress bar.',
  `progressbar_label_first` varchar(255) DEFAULT NULL COMMENT 'Label for the first page of the progress bar.',
  `progressbar_label_confirmation` varchar(255) DEFAULT NULL COMMENT 'Label for the last page of the progress bar.',
  `preview` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean value indicating if this form includes a page for previewing the submission.',
  `preview_next_button_label` varchar(255) DEFAULT NULL COMMENT 'The text for the button that will proceed to the preview page.',
  `preview_prev_button_label` varchar(255) DEFAULT NULL COMMENT 'The text for the button to go backwards from the preview page.',
  `preview_title` varchar(255) DEFAULT NULL COMMENT 'The title of the preview page, as used by the progress bar.',
  `preview_message` text NOT NULL COMMENT 'Text shown on the preview page of the form.',
  `preview_message_format` varchar(255) DEFAULT NULL COMMENT 'The filter_format.format of the preview page message.',
  `preview_excluded_components` text NOT NULL COMMENT 'Comma-separated list of component IDs that should not be included in this form’s confirmation page.',
  `confidential` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean value for whether to anonymize submissions.',
  PRIMARY KEY (`nid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Table for storing additional properties for webform nodes.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `webform`
--

LOCK TABLES `webform` WRITE;
/*!40000 ALTER TABLE `webform` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `webform` VALUES (28,1,'',NULL,'<confirmation>',1,0,0,0,1,'',-1,-1,-1,-1,1,0,0,1,1,'Start','Complete',0,'','','','',NULL,'',0);
/*!40000 ALTER TABLE `webform` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `webform_component`
--

DROP TABLE IF EXISTS `webform_component`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webform_component` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node identifier of a webform.',
  `cid` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'The identifier for this component within this node, starts at 0 for each node.',
  `pid` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'If this component has a parent fieldset, the cid of that component.',
  `form_key` varchar(128) DEFAULT NULL COMMENT 'When the form is displayed and processed, this key can be used to reference the results.',
  `name` text NOT NULL COMMENT 'The label for this component.',
  `type` varchar(16) DEFAULT NULL COMMENT 'The field type of this component (textfield, select, hidden, etc.).',
  `value` text NOT NULL COMMENT 'The default value of the component when displayed to the end-user.',
  `extra` text NOT NULL COMMENT 'Additional information unique to the display or processing of this component.',
  `required` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean flag for if this component is required.',
  `weight` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Determines the position of this component in the form.',
  PRIMARY KEY (`nid`,`cid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores information about components for webform nodes.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `webform_component`
--

LOCK TABLES `webform_component` WRITE;
/*!40000 ALTER TABLE `webform_component` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `webform_component` VALUES (28,1,0,'first_name','First Name','textfield','','a:5:{s:13:\"title_display\";s:6:\"before\";s:7:\"private\";i:0;s:15:\"wrapper_classes\";s:0:\"\";s:11:\"css_classes\";s:0:\"\";s:5:\"width\";s:2:\"60\";}',1,0),(28,2,0,'last_name','Last Name','textfield','','a:5:{s:13:\"title_display\";s:6:\"before\";s:7:\"private\";i:0;s:15:\"wrapper_classes\";s:0:\"\";s:11:\"css_classes\";s:0:\"\";s:5:\"width\";s:2:\"60\";}',1,1),(28,3,0,'email','Email','textfield','','a:14:{s:13:\"title_display\";s:6:\"before\";s:7:\"private\";i:0;s:15:\"wrapper_classes\";s:0:\"\";s:11:\"css_classes\";s:0:\"\";s:5:\"width\";s:2:\"60\";s:9:\"maxlength\";s:0:\"\";s:12:\"field_prefix\";s:0:\"\";s:12:\"field_suffix\";s:0:\"\";s:8:\"disabled\";i:0;s:6:\"unique\";i:0;s:11:\"description\";s:0:\"\";s:11:\"placeholder\";s:0:\"\";s:10:\"attributes\";a:0:{}s:8:\"analysis\";b:0;}',1,5),(28,4,0,'telephone','Telephone','textfield','','a:14:{s:13:\"title_display\";s:6:\"before\";s:7:\"private\";i:0;s:15:\"wrapper_classes\";s:0:\"\";s:11:\"css_classes\";s:0:\"\";s:5:\"width\";s:2:\"60\";s:9:\"maxlength\";s:0:\"\";s:12:\"field_prefix\";s:0:\"\";s:12:\"field_suffix\";s:0:\"\";s:8:\"disabled\";i:0;s:6:\"unique\";i:0;s:11:\"description\";s:0:\"\";s:11:\"placeholder\";s:0:\"\";s:10:\"attributes\";a:0:{}s:8:\"analysis\";b:0;}',0,4),(28,5,0,'company_name','Company Name','textfield','','a:14:{s:13:\"title_display\";s:6:\"before\";s:7:\"private\";i:0;s:15:\"wrapper_classes\";s:0:\"\";s:11:\"css_classes\";s:0:\"\";s:5:\"width\";s:2:\"60\";s:9:\"maxlength\";s:0:\"\";s:12:\"field_prefix\";s:0:\"\";s:12:\"field_suffix\";s:0:\"\";s:8:\"disabled\";i:0;s:6:\"unique\";i:0;s:11:\"description\";s:0:\"\";s:11:\"placeholder\";s:0:\"\";s:10:\"attributes\";a:0:{}s:8:\"analysis\";b:0;}',0,2),(28,6,0,'comments_and_or_details','Comments and/or details','textarea','','a:12:{s:13:\"title_display\";s:6:\"before\";s:7:\"private\";i:0;s:15:\"wrapper_classes\";s:0:\"\";s:11:\"css_classes\";s:0:\"\";s:4:\"cols\";s:0:\"\";s:4:\"rows\";s:0:\"\";s:9:\"resizable\";i:1;s:8:\"disabled\";i:0;s:11:\"description\";s:0:\"\";s:11:\"placeholder\";s:0:\"\";s:10:\"attributes\";a:0:{}s:8:\"analysis\";b:0;}',1,6),(28,7,0,'country','Country','select','','a:9:{s:5:\"items\";s:3753:\"AF|Afghanistan\r\nAX|Aland Islands\r\nAL|Albania\r\nDZ|Algeria\r\nAS|American Samoa\r\nAD|Andorra\r\nAO|Angola\r\nAI|Anguilla\r\nAQ|Antarctica\r\nAG|Antigua and Barbuda\r\nAR|Argentina\r\nAM|Armenia\r\nAW|Aruba\r\nAU|Australia\r\nAT|Austria\r\nAZ|Azerbaijan\r\nBS|Bahamas\r\nBH|Bahrain\r\nBD|Bangladesh\r\nBB|Barbados\r\nBY|Belarus\r\nBE|Belgium\r\nBZ|Belize\r\nBJ|Benin\r\nBM|Bermuda\r\nBT|Bhutan\r\nBO|Bolivia\r\nBA|Bosnia and Herzegovina\r\nBW|Botswana\r\nBV|Bouvet Island\r\nBR|Brazil\r\nIO|British Indian Ocean Territory\r\nVG|British Virgin Islands\r\nBN|Brunei\r\nBG|Bulgaria\r\nBF|Burkina Faso\r\nBI|Burundi\r\nKH|Cambodia\r\nCM|Cameroon\r\nCA|Canada\r\nCV|Cape Verde\r\nBQ|Caribbean Netherlands\r\nKY|Cayman Islands\r\nCF|Central African Republic\r\nTD|Chad\r\nCL|Chile\r\nCN|China\r\nCX|Christmas Island\r\nCC|Cocos (Keeling) Islands\r\nCO|Colombia\r\nKM|Comoros\r\nCG|Congo (Brazzaville)\r\nCD|Congo (Kinshasa)\r\nCK|Cook Islands\r\nCR|Costa Rica\r\nHR|Croatia\r\nCU|Cuba\r\nCW|Curaçao\r\nCY|Cyprus\r\nCZ|Czech Republic\r\nDK|Denmark\r\nDJ|Djibouti\r\nDM|Dominica\r\nDO|Dominican Republic\r\nEC|Ecuador\r\nEG|Egypt\r\nSV|El Salvador\r\nGQ|Equatorial Guinea\r\nER|Eritrea\r\nEE|Estonia\r\nET|Ethiopia\r\nFK|Falkland Islands\r\nFO|Faroe Islands\r\nFJ|Fiji\r\nFI|Finland\r\nFR|France\r\nGF|French Guiana\r\nPF|French Polynesia\r\nTF|French Southern Territories\r\nGA|Gabon\r\nGM|Gambia\r\nGE|Georgia\r\nDE|Germany\r\nGH|Ghana\r\nGI|Gibraltar\r\nGR|Greece\r\nGL|Greenland\r\nGD|Grenada\r\nGP|Guadeloupe\r\nGU|Guam\r\nGT|Guatemala\r\nGG|Guernsey\r\nGN|Guinea\r\nGW|Guinea-Bissau\r\nGY|Guyana\r\nHT|Haiti\r\nHM|Heard Island and McDonald Islands\r\nHN|Honduras\r\nHK|Hong Kong S.A.R., China\r\nHU|Hungary\r\nIS|Iceland\r\nIN|India\r\nID|Indonesia\r\nIR|Iran\r\nIQ|Iraq\r\nIE|Ireland\r\nIM|Isle of Man\r\nIL|Israel\r\nIT|Italy\r\nCI|Ivory Coast\r\nJM|Jamaica\r\nJP|Japan\r\nJE|Jersey\r\nJO|Jordan\r\nKZ|Kazakhstan\r\nKE|Kenya\r\nKI|Kiribati\r\nKW|Kuwait\r\nKG|Kyrgyzstan\r\nLA|Laos\r\nLV|Latvia\r\nLB|Lebanon\r\nLS|Lesotho\r\nLR|Liberia\r\nLY|Libya\r\nLI|Liechtenstein\r\nLT|Lithuania\r\nLU|Luxembourg\r\nMO|Macao S.A.R., China\r\nMK|Macedonia\r\nMG|Madagascar\r\nMW|Malawi\r\nMY|Malaysia\r\nMV|Maldives\r\nML|Mali\r\nMT|Malta\r\nMH|Marshall Islands\r\nMQ|Martinique\r\nMR|Mauritania\r\nMU|Mauritius\r\nYT|Mayotte\r\nMX|Mexico\r\nFM|Micronesia\r\nMD|Moldova\r\nMC|Monaco\r\nMN|Mongolia\r\nME|Montenegro\r\nMS|Montserrat\r\nMA|Morocco\r\nMZ|Mozambique\r\nMM|Myanmar\r\nNA|Namibia\r\nNR|Nauru\r\nNP|Nepal\r\nNL|Netherlands\r\nAN|Netherlands Antilles\r\nNC|New Caledonia\r\nNZ|New Zealand\r\nNI|Nicaragua\r\nNE|Niger\r\nNG|Nigeria\r\nNU|Niue\r\nNF|Norfolk Island\r\nMP|Northern Mariana Islands\r\nKP|North Korea\r\nNO|Norway\r\nOM|Oman\r\nPK|Pakistan\r\nPW|Palau\r\nPS|Palestinian Territory\r\nPA|Panama\r\nPG|Papua New Guinea\r\nPY|Paraguay\r\nPE|Peru\r\nPH|Philippines\r\nPN|Pitcairn\r\nPL|Poland\r\nPT|Portugal\r\nPR|Puerto Rico\r\nQA|Qatar\r\nRE|Reunion\r\nRO|Romania\r\nRU|Russia\r\nRW|Rwanda\r\nBL|Saint Barthélemy\r\nSH|Saint Helena\r\nKN|Saint Kitts and Nevis\r\nLC|Saint Lucia\r\nMF|Saint Martin (French part)\r\nPM|Saint Pierre and Miquelon\r\nVC|Saint Vincent and the Grenadines\r\nWS|Samoa\r\nSM|San Marino\r\nST|Sao Tome and Principe\r\nSA|Saudi Arabia\r\nSN|Senegal\r\nRS|Serbia\r\nSC|Seychelles\r\nSL|Sierra Leone\r\nSG|Singapore\r\nSX|Sint Maarten\r\nSK|Slovakia\r\nSI|Slovenia\r\nSB|Solomon Islands\r\nSO|Somalia\r\nZA|South Africa\r\nGS|South Georgia and the South Sandwich Islands\r\nKR|South Korea\r\nSS|South Sudan\r\nES|Spain\r\nLK|Sri Lanka\r\nSD|Sudan\r\nSR|Suriname\r\nSJ|Svalbard and Jan Mayen\r\nSZ|Swaziland\r\nSE|Sweden\r\nCH|Switzerland\r\nSY|Syria\r\nTW|Taiwan\r\nTJ|Tajikistan\r\nTZ|Tanzania\r\nTH|Thailand\r\nTL|Timor-Leste\r\nTG|Togo\r\nTK|Tokelau\r\nTO|Tonga\r\nTT|Trinidad and Tobago\r\nTN|Tunisia\r\nTR|Turkey\r\nTM|Turkmenistan\r\nTC|Turks and Caicos Islands\r\nTV|Tuvalu\r\nVI|U.S. Virgin Islands\r\nUG|Uganda\r\nUA|Ukraine\r\nAE|United Arab Emirates\r\nGB|United Kingdom\r\nUS|United States\r\nUM|United States Minor Outlying Islands\r\nUY|Uruguay\r\nUZ|Uzbekistan\r\nVU|Vanuatu\r\nVA|Vatican\r\nVE|Venezuela\r\nVN|Vietnam\r\nWF|Wallis and Futuna\r\nEH|Western Sahara\r\nYE|Yemen\r\nZM|Zambia\r\nZW|Zimbabwe\r\n\";s:14:\"options_source\";s:9:\"countries\";s:12:\"other_option\";i:0;s:8:\"multiple\";i:0;s:13:\"title_display\";s:6:\"inline\";s:7:\"private\";i:0;s:15:\"wrapper_classes\";s:0:\"\";s:11:\"css_classes\";s:0:\"\";s:6:\"aslist\";i:1;}',0,3);
/*!40000 ALTER TABLE `webform_component` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `webform_conditional`
--

DROP TABLE IF EXISTS `webform_conditional`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webform_conditional` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node identifier of a webform.',
  `rgid` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'The rule group identifier for this group of rules.',
  `andor` varchar(128) DEFAULT NULL COMMENT 'Whether to AND or OR the actions in this group. All actions within the same crid should have the same andor value.',
  `weight` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Determines the position of this conditional compared to others.',
  PRIMARY KEY (`nid`,`rgid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Holds information about conditional logic.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `webform_conditional`
--

LOCK TABLES `webform_conditional` WRITE;
/*!40000 ALTER TABLE `webform_conditional` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `webform_conditional` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `webform_conditional_actions`
--

DROP TABLE IF EXISTS `webform_conditional_actions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webform_conditional_actions` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node identifier of a webform.',
  `rgid` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'The rule group identifier for this group of rules.',
  `aid` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'The rule identifier for this conditional action.',
  `target_type` varchar(128) DEFAULT NULL COMMENT 'The type of target to be affected. Currently always "component". Indicates what type of ID the "target" column contains.',
  `target` varchar(128) DEFAULT NULL COMMENT 'The ID of the target to be affected. Typically a component ID.',
  `invert` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'If inverted, execute when rule(s) are false.',
  `action` varchar(128) DEFAULT NULL COMMENT 'The action to be performed on the target.',
  `argument` text COMMENT 'Optional argument for action.',
  PRIMARY KEY (`nid`,`rgid`,`aid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Holds information about conditional actions.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `webform_conditional_actions`
--

LOCK TABLES `webform_conditional_actions` WRITE;
/*!40000 ALTER TABLE `webform_conditional_actions` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `webform_conditional_actions` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `webform_conditional_rules`
--

DROP TABLE IF EXISTS `webform_conditional_rules`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webform_conditional_rules` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node identifier of a webform.',
  `rgid` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'The rule group identifier for this group of rules.',
  `rid` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'The rule identifier for this conditional rule.',
  `source_type` varchar(128) DEFAULT NULL COMMENT 'The type of source on which the conditional is based. Currently always "component". Indicates what type of ID the "source" column contains.',
  `source` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'The component ID being used in this condition.',
  `operator` varchar(128) DEFAULT NULL COMMENT 'Which operator (equal, contains, starts with, etc.) should be used for this comparison between the source and value?',
  `value` text COMMENT 'The value to be compared with source.',
  PRIMARY KEY (`nid`,`rgid`,`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Holds information about conditional logic.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `webform_conditional_rules`
--

LOCK TABLES `webform_conditional_rules` WRITE;
/*!40000 ALTER TABLE `webform_conditional_rules` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `webform_conditional_rules` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `webform_emails`
--

DROP TABLE IF EXISTS `webform_emails`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webform_emails` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node identifier of a webform.',
  `eid` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'The e-mail identifier for this row’s settings.',
  `email` text COMMENT 'The e-mail address that will be sent to upon submission. This may be an e-mail address, the special key "default" or a numeric value. If a numeric value is used, the value of a component will be substituted on submission.',
  `subject` text COMMENT 'The e-mail subject that will be used. This may be a string, the special key "default" or a numeric value. If a numeric value is used, the value of a component will be substituted on submission.',
  `from_name` text COMMENT 'The e-mail "from" name that will be used. This may be a string, the special key "default" or a numeric value. If a numeric value is used, the value of a component will be substituted on submission.',
  `from_address` text COMMENT 'The e-mail "from" e-mail address that will be used. This may be a string, the special key "default" or a numeric value. If a numeric value is used, the value of a component will be substituted on submission.',
  `template` text COMMENT 'A template that will be used for the sent e-mail. This may be a string or the special key "default", which will use the template provided by the theming layer.',
  `excluded_components` text NOT NULL COMMENT 'A list of components that will not be included in the [submission:values] token. A list of CIDs separated by commas.',
  `html` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Determines if the e-mail will be sent in an HTML format. Requires Mime Mail module.',
  `attachments` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Determines if the e-mail will include file attachments. Requires Mime Mail module.',
  `extra` text NOT NULL COMMENT 'A serialized array of additional options for the e-mail configuration, including excluded components and value mapping for the TO and FROM addresses for select lists.',
  `exclude_empty` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Determines if the e-mail will include component with an empty value.',
  `status` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT 'Whether this email is enabled.',
  PRIMARY KEY (`nid`,`eid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Holds information regarding e-mails that should be sent...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `webform_emails`
--

LOCK TABLES `webform_emails` WRITE;
/*!40000 ALTER TABLE `webform_emails` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `webform_emails` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `webform_last_download`
--

DROP TABLE IF EXISTS `webform_last_download`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webform_last_download` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node identifier of a webform.',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The user identifier.',
  `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The last downloaded submission number.',
  `requested` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Timestamp of last download request.',
  PRIMARY KEY (`nid`,`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores last submission number per user download.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `webform_last_download`
--

LOCK TABLES `webform_last_download` WRITE;
/*!40000 ALTER TABLE `webform_last_download` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `webform_last_download` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `webform_roles`
--

DROP TABLE IF EXISTS `webform_roles`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webform_roles` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node identifier of a webform.',
  `rid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The role identifier.',
  PRIMARY KEY (`nid`,`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Holds access information regarding which roles are...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `webform_roles`
--

LOCK TABLES `webform_roles` WRITE;
/*!40000 ALTER TABLE `webform_roles` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `webform_roles` VALUES (28,1),(28,2);
/*!40000 ALTER TABLE `webform_roles` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `webform_submissions`
--

DROP TABLE IF EXISTS `webform_submissions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webform_submissions` (
  `sid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The unique identifier for this submission.',
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node identifier of a webform.',
  `serial` int(10) unsigned NOT NULL COMMENT 'The serial number of this submission.',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The id of the user that completed this submission.',
  `is_draft` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Is this a draft of the submission?',
  `submitted` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp of when the form was submitted.',
  `remote_addr` varchar(128) DEFAULT NULL COMMENT 'The IP address of the user that submitted the form.',
  `completed` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp when the form was submitted as complete (not draft).',
  `modified` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp when the form was last saved (complete or draft).',
  `highest_valid_page` smallint(6) NOT NULL DEFAULT '0' COMMENT 'For drafts, the highest validated page number.',
  PRIMARY KEY (`sid`),
  UNIQUE KEY `sid_nid` (`sid`,`nid`),
  UNIQUE KEY `nid_serial` (`nid`,`serial`),
  KEY `nid_uid_sid` (`nid`,`uid`,`sid`),
  KEY `nid_sid` (`nid`,`sid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Holds general information about submissions outside of...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `webform_submissions`
--

LOCK TABLES `webform_submissions` WRITE;
/*!40000 ALTER TABLE `webform_submissions` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `webform_submissions` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `webform_submitted_data`
--

DROP TABLE IF EXISTS `webform_submitted_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webform_submitted_data` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node identifier of a webform.',
  `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The unique identifier for this submission.',
  `cid` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'The identifier for this component within this node, starts at 0 for each node.',
  `no` varchar(128) NOT NULL DEFAULT '0' COMMENT 'Usually this value is 0, but if a field has multiple values (such as a time or date), it may require multiple rows in the database.',
  `data` mediumtext NOT NULL COMMENT 'The submitted value of this field, may be serialized for some components.',
  PRIMARY KEY (`nid`,`sid`,`cid`,`no`),
  KEY `nid` (`nid`),
  KEY `sid_nid` (`sid`,`nid`),
  KEY `data` (`data`(64))
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores all submitted field data for webform submissions.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `webform_submitted_data`
--

LOCK TABLES `webform_submitted_data` WRITE;
/*!40000 ALTER TABLE `webform_submitted_data` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `webform_submitted_data` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `weight_settings`
--

DROP TABLE IF EXISTS `weight_settings`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `weight_settings` (
  `type` varchar(32) NOT NULL DEFAULT '',
  `weight_enabled` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `weight_range` tinyint(3) unsigned NOT NULL DEFAULT '20',
  `menu_weight` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `weight_default` tinyint(4) NOT NULL DEFAULT '0',
  `sync_translations` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Table for storing Weight configuration';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `weight_settings`
--

LOCK TABLES `weight_settings` WRITE;
/*!40000 ALTER TABLE `weight_settings` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `weight_settings` VALUES ('article',0,20,0,0,0),('banner',1,50,0,0,0),('page',0,20,0,0,0),('product',0,20,0,0,0),('simplenews',0,20,0,0,0),('webform',0,20,0,0,0);
/*!40000 ALTER TABLE `weight_settings` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `weight_weights`
--

DROP TABLE IF EXISTS `weight_weights`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `weight_weights` (
  `entity_id` int(10) unsigned NOT NULL,
  `entity_type` varchar(32) NOT NULL,
  `weight` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `weight_weights`
--

LOCK TABLES `weight_weights` WRITE;
/*!40000 ALTER TABLE `weight_weights` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `weight_weights` VALUES (7,'node',-1),(8,'node',0),(11,'node',-1),(12,'node',0),(13,'node',1),(14,'node',0),(28,'node',0),(87,'node',0),(98,'node',0),(99,'node',0),(100,'node',0),(101,'node',0),(102,'node',0),(103,'node',0),(104,'node',0),(105,'node',0),(106,'node',0),(107,'node',0),(108,'node',0),(109,'node',0),(110,'node',0),(111,'node',0),(112,'node',0),(113,'node',0),(114,'node',0),(115,'node',0),(116,'node',0),(117,'node',0),(118,'node',0),(119,'node',0),(120,'node',0),(121,'node',0),(122,'node',0),(123,'node',0),(124,'node',0),(125,'node',0),(126,'node',0),(127,'node',0),(128,'node',0),(129,'node',0),(130,'node',0),(131,'node',0),(132,'node',0),(133,'node',0),(134,'node',0),(135,'node',0),(136,'node',0),(137,'node',0),(140,'node',0),(142,'node',0);
/*!40000 ALTER TABLE `weight_weights` ENABLE KEYS */;
UNLOCK TABLES;
commit;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2017-07-18 14:02:47
